/*===========================================================================*/
/*   (Llib/music.scm)                                                        */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi alsa -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/music.scm -o objs/music.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <alsa/asoundlib.h>
#include <bglalsa.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;


BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__alsa_musicz00 = BUNSPEC;
extern obj_t BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
static obj_t BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__alsa_musicz00();
static obj_t BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__alsa_musicz00();
extern obj_t BGl_alsazd2sndzd2pcmzd2dropzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__alsa_musicz00();
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_alsamusicz00zz__alsa_musicz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_musicbufz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00;
static obj_t BGl_methodzd2initzd2zz__alsa_musicz00();
static obj_t BGl_z62zc3z04anonymousza31138ze3ze5zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31158ze3ze5zz__alsa_musicz00(obj_t);
static BgL_alsamusicz00_bglt BGl_z62lambda1131z62zz__alsa_musicz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_alsamusicz00_bglt BGl_z62lambda1135z62zz__alsa_musicz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static BgL_alsazd2sndzd2pcmz00_bglt BGl_z62lambda1156z62zz__alsa_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1157z62zz__alsa_musicz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__alsa_musicz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern long BGl_alsazd2sndzd2pcmzd2writezd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, char *, long);
static obj_t BGl_cnstzd2initzd2zz__alsa_musicz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__alsa_musicz00();
static obj_t BGl_gczd2rootszd2initz00zz__alsa_musicz00();
extern obj_t BGl_alsazd2sndzd2pcmzd2openzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicstatusz00zz__multimediazd2musiczd2;
extern obj_t BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
extern obj_t BGl_alsazd2sndzd2pcmzd2closezd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
static obj_t __cnst[ 8 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1221z00zz__alsa_musicz00, BgL_bgl_za762musicza7d2close1239z00, BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1223z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2in1240z00, BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1230z00zz__alsa_musicz00, BgL_bgl_string1230za700za7za7_1241za7, "disconnected (running prepared) not-open default playback __alsa_music alsamusic pcm ", 85 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1225z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2re1242z00, BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1227z00zz__alsa_musicz00, BgL_bgl_za762musicbufza7d2wr1243z00, BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00, 0L, BUNSPEC, 3 );
BGL_IMPORT obj_t BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
BGL_IMPORT obj_t BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1210z00zz__alsa_musicz00, BgL_bgl_string1210za700za7za7_1244za7, "Llib/music.scm", 14 );
DEFINE_STRING( BGl_string1217z00zz__alsa_musicz00, BgL_bgl_string1217za700za7za7_1245za7, "", 0 );
DEFINE_STRING( BGl_string1218z00zz__alsa_musicz00, BgL_bgl_string1218za700za7za7_1246za7, "default", 7 );
BGL_IMPORT obj_t BGl_musicbufzd2initz12zd2envz12zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1211z00zz__alsa_musicz00, BgL_bgl_za762za7c3za704anonymo1247za7, BGl_z62zc3z04anonymousza31158ze3ze5zz__alsa_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1212z00zz__alsa_musicz00, BgL_bgl_za762lambda1157za7621248z00, BGl_z62lambda1157z62zz__alsa_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1213z00zz__alsa_musicz00, BgL_bgl_za762lambda1156za7621249z00, BGl_z62lambda1156z62zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1220z00zz__alsa_musicz00, BgL_bgl_string1220za700za7za7_1250za7, "music-close", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1214z00zz__alsa_musicz00, BgL_bgl_za762za7c3za704anonymo1251za7, BGl_z62zc3z04anonymousza31138ze3ze5zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1215z00zz__alsa_musicz00, BgL_bgl_za762lambda1135za7621252z00, BGl_z62lambda1135z62zz__alsa_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1222z00zz__alsa_musicz00, BgL_bgl_string1222za700za7za7_1253za7, "music-closed?", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1216z00zz__alsa_musicz00, BgL_bgl_za762lambda1131za7621254z00, BGl_z62lambda1131z62zz__alsa_musicz00, 0L, BUNSPEC, 19 );
DEFINE_STRING( BGl_string1224z00zz__alsa_musicz00, BgL_bgl_string1224za700za7za7_1255za7, "musicbuf-init!", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1219z00zz__alsa_musicz00, BgL_bgl_za762musicza7d2close1256z00, BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1226z00zz__alsa_musicz00, BgL_bgl_string1226za700za7za7_1257za7, "musicbuf-reset!", 15 );
DEFINE_STRING( BGl_string1228z00zz__alsa_musicz00, BgL_bgl_string1228za700za7za7_1258za7, "musicbuf-write", 14 );
DEFINE_STRING( BGl_string1229z00zz__alsa_musicz00, BgL_bgl_string1229za700za7za7_1259za7, "__alsa_music", 12 );
BGL_IMPORT obj_t BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__alsa_musicz00) );
ADD_ROOT( (void *)(&BGl_alsamusicz00zz__alsa_musicz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__alsa_musicz00(long BgL_checksumz00_277, char * BgL_fromz00_278)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__alsa_musicz00))
{ 
BGl_requirezd2initializa7ationz75zz__alsa_musicz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__alsa_musicz00(); 
BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00(); 
BGl_cnstzd2initzd2zz__alsa_musicz00(); 
BGl_importedzd2moduleszd2initz00zz__alsa_musicz00(); 
BGl_objectzd2initzd2zz__alsa_musicz00(); 
BGl_methodzd2initzd2zz__alsa_musicz00(); 
return 
BGl_toplevelzd2initzd2zz__alsa_musicz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__alsa_music"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__alsa_music"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_cportz00_217;
{ /* Llib/music.scm 15 */
obj_t BgL_stringz00_225;
BgL_stringz00_225 = BGl_string1230z00zz__alsa_musicz00; 
{ /* Llib/music.scm 15 */
obj_t BgL_startz00_226;
BgL_startz00_226 = 
BINT(((long)0)); 
{ /* Llib/music.scm 15 */
obj_t BgL_endz00_227;
BgL_endz00_227 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_225))); 
{ /* Llib/music.scm 15 */

BgL_cportz00_217 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_225, BgL_startz00_226, BgL_endz00_227); } } } } 
{ 
long BgL_iz00_218;
BgL_iz00_218 = ((long)7); 
BgL_loopz00_219:
if(
(BgL_iz00_218==((long)-1)))
{ /* Llib/music.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_arg1238z00_221;
{ /* Llib/music.scm 15 */

{ /* Llib/music.scm 15 */
obj_t BgL_locationz00_223;
BgL_locationz00_223 = 
BBOOL(((bool_t)0)); 
{ /* Llib/music.scm 15 */

BgL_arg1238z00_221 = 
BGl_readz00zz__readerz00(BgL_cportz00_217, BgL_locationz00_223); } } } 
{ /* Llib/music.scm 15 */
int BgL_tmpz00_307;
BgL_tmpz00_307 = 
(int)(BgL_iz00_218); 
CNST_TABLE_SET(BgL_tmpz00_307, BgL_arg1238z00_221); } } 
{ /* Llib/music.scm 15 */
int BgL_auxz00_224;
BgL_auxz00_224 = 
(int)(
(BgL_iz00_218-((long)1))); 
{ 
long BgL_iz00_312;
BgL_iz00_312 = 
(long)(BgL_auxz00_224); 
BgL_iz00_218 = BgL_iz00_312; 
goto BgL_loopz00_219;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1210z00zz__alsa_musicz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 22 */
obj_t BgL_arg1127z00_21;obj_t BgL_arg1130z00_22;
{ /* Llib/music.scm 22 */
obj_t BgL_v1107z00_52;
BgL_v1107z00_52 = 
create_vector(((long)1)); 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1140z00_53;
BgL_arg1140z00_53 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1213z00zz__alsa_musicz00, BGl_proc1212z00zz__alsa_musicz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1211z00zz__alsa_musicz00, BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
VECTOR_SET(BgL_v1107z00_52,((long)0),BgL_arg1140z00_53); } 
BgL_arg1127z00_21 = BgL_v1107z00_52; } 
{ /* Llib/music.scm 22 */
obj_t BgL_v1108z00_72;
BgL_v1108z00_72 = 
create_vector(((long)0)); 
BgL_arg1130z00_22 = BgL_v1108z00_72; } 
return ( 
BGl_alsamusicz00zz__alsa_musicz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)1)), 
CNST_TABLE_REF(((long)2)), BGl_musicbufz00zz__multimediazd2musicbufzd2, ((long)11039), BGl_proc1216z00zz__alsa_musicz00, BGl_proc1215z00zz__alsa_musicz00, BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2, BGl_proc1214z00zz__alsa_musicz00, BFALSE, BgL_arg1127z00_21, BgL_arg1130z00_22), BUNSPEC) ;} } 

}



/* &<@anonymous:1138> */
obj_t BGl_z62zc3z04anonymousza31138ze3ze5zz__alsa_musicz00(obj_t BgL_envz00_157, obj_t BgL_new1096z00_158)
{
{ /* Llib/music.scm 22 */
{ 
BgL_alsamusicz00_bglt BgL_auxz00_325;
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_onstatez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_onvolumez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_onerrorz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_oneventz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
{ 
BgL_musicstatusz00_bglt BgL_auxz00_342;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_230;
BgL_classz00_230 = BGl_musicstatusz00zz__multimediazd2musiczd2; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1111z00_231;
BgL__ortest_1111z00_231 = 
BGL_CLASS_NIL(BgL_classz00_230); 
if(
CBOOL(BgL__ortest_1111z00_231))
{ /* Llib/music.scm 22 */
BgL_auxz00_342 = 
((BgL_musicstatusz00_bglt)BgL__ortest_1111z00_231)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_342 = 
((BgL_musicstatusz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_230))
; } } } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)BgL_auxz00_342),BUNSPEC); } 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_inbufz00)=((obj_t)BGl_string1217z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_decodersz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_mkthreadz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_timeoutz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52nextbufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52playlistz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52areadyz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52amutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52z12pidz40)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_new1096z00_158))))->BgL_z52acondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
{ 
BgL_alsazd2sndzd2pcmz00_bglt BgL_auxz00_391;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_232;
BgL_classz00_232 = BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1111z00_233;
BgL__ortest_1111z00_233 = 
BGL_CLASS_NIL(BgL_classz00_232); 
if(
CBOOL(BgL__ortest_1111z00_233))
{ /* Llib/music.scm 22 */
BgL_auxz00_391 = 
((BgL_alsazd2sndzd2pcmz00_bglt)BgL__ortest_1111z00_233)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_391 = 
((BgL_alsazd2sndzd2pcmz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_232))
; } } } 
((((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_new1096z00_158)))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)BgL_auxz00_391),BUNSPEC); } 
BgL_auxz00_325 = 
((BgL_alsamusicz00_bglt)BgL_new1096z00_158); 
return 
((obj_t)BgL_auxz00_325);} } 

}



/* &lambda1135 */
BgL_alsamusicz00_bglt BGl_z62lambda1135z62zz__alsa_musicz00(obj_t BgL_envz00_159)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1095z00_234;
BgL_new1095z00_234 = 
((BgL_alsamusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsamusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1137z00_235;
BgL_arg1137z00_235 = 
BGL_CLASS_INDEX(BGl_alsamusicz00zz__alsa_musicz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_234), BgL_arg1137z00_235); } 
return BgL_new1095z00_234;} } 

}



/* &lambda1131 */
BgL_alsamusicz00_bglt BGl_z62lambda1131z62zz__alsa_musicz00(obj_t BgL_envz00_160, obj_t BgL_onstate1076z00_161, obj_t BgL_onvolume1077z00_162, obj_t BgL_onerror1078z00_163, obj_t BgL_onevent1079z00_164, obj_t BgL_z52mutex1080z52_165, obj_t BgL_z52status1081z52_166, obj_t BgL_inbuf1082z00_167, obj_t BgL_decoders1083z00_168, obj_t BgL_mkthread1084z00_169, obj_t BgL_timeout1085z00_170, obj_t BgL_z52decoder1086z52_171, obj_t BgL_z52buffer1087z52_172, obj_t BgL_z52nextbuffer1088z52_173, obj_t BgL_z52playlist1089z52_174, obj_t BgL_z52aready1090z52_175, obj_t BgL_z52amutex1091z52_176, obj_t BgL_z52z12pid1092z40_177, obj_t BgL_z52acondv1093z52_178, obj_t BgL_pcm1094z00_179)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
bool_t BgL_z52aready1090z52_246;int BgL_z52z12pid1092z40_248;
BgL_z52aready1090z52_246 = 
CBOOL(BgL_z52aready1090z52_175); 
BgL_z52z12pid1092z40_248 = 
CINT(BgL_z52z12pid1092z40_177); 
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1103z00_251;
{ /* Llib/music.scm 22 */
BgL_alsamusicz00_bglt BgL_new1102z00_252;
BgL_new1102z00_252 = 
((BgL_alsamusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsamusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1134z00_253;
BgL_arg1134z00_253 = 
BGL_CLASS_INDEX(BGl_alsamusicz00zz__alsa_musicz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_252), BgL_arg1134z00_253); } 
BgL_new1103z00_251 = BgL_new1102z00_252; } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_onstatez00)=((obj_t)
((obj_t)BgL_onstate1076z00_161)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_onvolumez00)=((obj_t)
((obj_t)BgL_onvolume1077z00_162)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_onerrorz00)=((obj_t)
((obj_t)BgL_onerror1078z00_163)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_oneventz00)=((obj_t)
((obj_t)BgL_onevent1079z00_164)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1080z52_165)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1103z00_251)))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)
((BgL_musicstatusz00_bglt)BgL_z52status1081z52_166)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_inbufz00)=((obj_t)
((obj_t)BgL_inbuf1082z00_167)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_decodersz00)=((obj_t)
((obj_t)BgL_decoders1083z00_168)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_mkthreadz00)=((obj_t)
((obj_t)BgL_mkthread1084z00_169)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_timeoutz00)=((obj_t)BgL_timeout1085z00_170),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1086z52_171),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1087z52_172),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52nextbufferz52)=((obj_t)BgL_z52nextbuffer1088z52_173),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52playlistz52)=((obj_t)
((obj_t)BgL_z52playlist1089z52_174)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52areadyz52)=((bool_t)BgL_z52aready1090z52_246),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52amutexz52)=((obj_t)
((obj_t)BgL_z52amutex1091z52_176)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52z12pidz40)=((int)BgL_z52z12pid1092z40_248),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1103z00_251)))->BgL_z52acondvz52)=((obj_t)
((obj_t)BgL_z52acondv1093z52_178)),BUNSPEC); 
((((BgL_alsamusicz00_bglt)COBJECT(BgL_new1103z00_251))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)
((BgL_alsazd2sndzd2pcmz00_bglt)BgL_pcm1094z00_179)),BUNSPEC); 
{ /* Llib/music.scm 22 */
obj_t BgL_fun1132z00_254;
BgL_fun1132z00_254 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_alsamusicz00zz__alsa_musicz00); 
PROCEDURE_ENTRY(BgL_fun1132z00_254)(BgL_fun1132z00_254, 
((obj_t)BgL_new1103z00_251), BEOA); } 
return BgL_new1103z00_251;} } } 

}



/* &<@anonymous:1158> */
obj_t BGl_z62zc3z04anonymousza31158ze3ze5zz__alsa_musicz00(obj_t BgL_envz00_180)
{
{ /* Llib/music.scm 22 */
{ 
BgL_alsazd2sndzd2pcmz00_bglt BgL_auxz00_468;
{ /* Llib/music.scm 23 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_new1106z00_255;
{ /* Llib/music.scm 23 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_new1105z00_256;
BgL_new1105z00_256 = 
((BgL_alsazd2sndzd2pcmz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_alsazd2sndzd2pcmz00_bgl) ))); 
{ /* Llib/music.scm 23 */
long BgL_arg1165z00_257;
BgL_arg1165z00_257 = 
BGL_CLASS_INDEX(BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_256), BgL_arg1165z00_257); } 
BgL_new1106z00_255 = BgL_new1105z00_256; } 
{ 
void * BgL_auxz00_473;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1159z00_258;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1160z00_259;
{ /* Llib/music.scm 23 */
obj_t BgL_classz00_260;
BgL_classz00_260 = BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00; 
BgL_arg1160z00_259 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_260); } 
BgL_arg1159z00_258 = 
VECTOR_REF(BgL_arg1160z00_259,((long)0)); } 
BgL_auxz00_473 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1159z00_258)); } 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_z42builtinz42)=((snd_pcm_t *)BgL_auxz00_473),BUNSPEC); } 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_namez00)=((obj_t)BGl_string1217z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_devicez00)=((obj_t)BGl_string1218z00zz__alsa_musicz00),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_streamz00)=((obj_t)
CNST_TABLE_REF(((long)3))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_modez00)=((obj_t)
CNST_TABLE_REF(((long)4))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_hwbpsz00)=((int)
(int)(((long)32))),BUNSPEC); 
((((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_new1106z00_255))->BgL_hwsratez00)=((int)
(int)(((long)384000))),BUNSPEC); 
{ /* Llib/music.scm 23 */
obj_t BgL_fun1161z00_261;
BgL_fun1161z00_261 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_alsazd2sndzd2pcmz00zz__alsa_pcmz00); 
PROCEDURE_ENTRY(BgL_fun1161z00_261)(BgL_fun1161z00_261, 
((obj_t)BgL_new1106z00_255), BEOA); } 
BgL_auxz00_468 = BgL_new1106z00_255; } 
return 
((obj_t)BgL_auxz00_468);} } 

}



/* &lambda1157 */
obj_t BGl_z62lambda1157z62zz__alsa_musicz00(obj_t BgL_envz00_181, obj_t BgL_oz00_182, obj_t BgL_vz00_183)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_182)))->BgL_pcmz00)=((BgL_alsazd2sndzd2pcmz00_bglt)
((BgL_alsazd2sndzd2pcmz00_bglt)BgL_vz00_183)),BUNSPEC);} 

}



/* &lambda1156 */
BgL_alsazd2sndzd2pcmz00_bglt BGl_z62lambda1156z62zz__alsa_musicz00(obj_t BgL_envz00_184, obj_t BgL_oz00_185)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_185)))->BgL_pcmz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1219z00zz__alsa_musicz00, BGl_string1220z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1221z00zz__alsa_musicz00, BGl_string1222z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2initz12zd2envz12zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1223z00zz__alsa_musicz00, BGl_string1224z00zz__alsa_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1225z00zz__alsa_musicz00, BGl_string1226z00zz__alsa_musicz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2, BGl_alsamusicz00zz__alsa_musicz00, BGl_proc1227z00zz__alsa_musicz00, BGl_string1228z00zz__alsa_musicz00);} 

}



/* &musicbuf-write-alsam1118 */
obj_t BGl_z62musicbufzd2writezd2alsam1118z62zz__alsa_musicz00(obj_t BgL_envz00_193, obj_t BgL_oz00_194, obj_t BgL_outbufz00_195, obj_t BgL_siza7eza7_196)
{
{ /* Llib/music.scm 64 */
{ /* Llib/music.scm 66 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1195z00_266;
BgL_arg1195z00_266 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_194)))->BgL_pcmz00); 
return 
BINT(
BGl_alsazd2sndzd2pcmzd2writezd2zz__alsa_pcmz00(BgL_arg1195z00_266, 
BSTRING_TO_STRING(BgL_outbufz00_195), 
(long)CINT(BgL_siza7eza7_196)));} } 

}



/* &musicbuf-reset!-alsa1116 */
obj_t BGl_z62musicbufzd2resetz12zd2alsa1116z70zz__alsa_musicz00(obj_t BgL_envz00_197, obj_t BgL_oz00_198)
{
{ /* Llib/music.scm 53 */
{ /* Llib/music.scm 55 */
obj_t BgL_pcmzd2statezd2_268;
BgL_pcmzd2statezd2_268 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_198)))->BgL_pcmz00)); 
if(
(BgL_pcmzd2statezd2_268==
CNST_TABLE_REF(((long)5))))
{ /* Llib/music.scm 56 */
return BFALSE;}  else 
{ /* Llib/music.scm 56 */
if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_pcmzd2statezd2_268, 
CNST_TABLE_REF(((long)6)))))
{ /* Llib/music.scm 57 */
BGl_alsazd2sndzd2pcmzd2dropzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_198)))->BgL_pcmz00)); }  else 
{ /* Llib/music.scm 57 */BFALSE; } 
return 
BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_198)))->BgL_pcmz00));} } } 

}



/* &musicbuf-init!-alsam1114 */
obj_t BGl_z62musicbufzd2initz12zd2alsam1114z70zz__alsa_musicz00(obj_t BgL_envz00_199, obj_t BgL_oz00_200)
{
{ /* Llib/music.scm 45 */
{ /* Llib/music.scm 47 */
bool_t BgL_test1267z00_528;
{ /* Llib/music.scm 47 */
obj_t BgL_arg1184z00_270;
BgL_arg1184z00_270 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_200)))->BgL_pcmz00)); 
BgL_test1267z00_528 = 
(BgL_arg1184z00_270==
CNST_TABLE_REF(((long)5))); } 
if(BgL_test1267z00_528)
{ /* Llib/music.scm 47 */
return 
BGl_alsazd2sndzd2pcmzd2openzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_200)))->BgL_pcmz00));}  else 
{ /* Llib/music.scm 47 */
return BFALSE;} } } 

}



/* &music-closed?-alsamu1112 */
obj_t BGl_z62musiczd2closedzf3zd2alsamu1112z91zz__alsa_musicz00(obj_t BgL_envz00_201, obj_t BgL_oz00_202)
{
{ /* Llib/music.scm 37 */
{ /* Llib/music.scm 38 */
bool_t BgL_tmpz00_537;
{ /* Llib/music.scm 39 */
obj_t BgL_mutex1176z00_272;
BgL_mutex1176z00_272 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_oz00_202))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 39 */
obj_t BgL_top1269z00_542;
BgL_top1269z00_542 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1176z00_272); 
BGL_EXITD_PUSH_PROTECT(BgL_top1269z00_542, BgL_mutex1176z00_272); BUNSPEC; 
{ /* Llib/music.scm 39 */
bool_t BgL_tmp1268z00_541;
{ /* Llib/music.scm 40 */
obj_t BgL_arg1178z00_273;
BgL_arg1178z00_273 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_202)))->BgL_pcmz00)); 
BgL_tmp1268z00_541 = 
(BgL_arg1178z00_273==
CNST_TABLE_REF(((long)7))); } 
BGL_EXITD_POP_PROTECT(BgL_top1269z00_542); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1176z00_272); 
BgL_tmpz00_537 = BgL_tmp1268z00_541; } } } 
return 
BBOOL(BgL_tmpz00_537);} } 

}



/* &music-close-alsamusi1110 */
obj_t BGl_z62musiczd2closezd2alsamusi1110z62zz__alsa_musicz00(obj_t BgL_envz00_203, obj_t BgL_oz00_204)
{
{ /* Llib/music.scm 28 */
{ /* Llib/music.scm 30 */
obj_t BgL_mutex1166z00_275;
BgL_mutex1166z00_275 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_alsamusicz00_bglt)BgL_oz00_204))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 30 */
obj_t BgL_top1271z00_558;
BgL_top1271z00_558 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1166z00_275); 
BGL_EXITD_PUSH_PROTECT(BgL_top1271z00_558, BgL_mutex1166z00_275); BUNSPEC; 
{ /* Llib/music.scm 30 */
obj_t BgL_tmp1270z00_557;
{ /* Llib/music.scm 31 */
bool_t BgL_test1272z00_562;
{ /* Llib/music.scm 31 */
obj_t BgL_arg1173z00_276;
BgL_arg1173z00_276 = 
BGl_alsazd2sndzd2pcmzd2getzd2statez00zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_204)))->BgL_pcmz00)); 
BgL_test1272z00_562 = 
(BgL_arg1173z00_276==
CNST_TABLE_REF(((long)7))); } 
if(BgL_test1272z00_562)
{ /* Llib/music.scm 31 */
BgL_tmp1270z00_557 = BFALSE; }  else 
{ /* Llib/music.scm 31 */
BgL_tmp1270z00_557 = 
BGl_alsazd2sndzd2pcmzd2closezd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)BgL_oz00_204)))->BgL_pcmz00)); } } 
BGL_EXITD_POP_PROTECT(BgL_top1271z00_558); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1166z00_275); 
return BgL_tmp1270z00_557;} } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__alsa_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)265821328), 
BSTRING_TO_STRING(BGl_string1229z00zz__alsa_musicz00)); 
return 
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)493378103), 
BSTRING_TO_STRING(BGl_string1229z00zz__alsa_musicz00));} 

}

#ifdef __cplusplus
}
#endif
