/*===========================================================================*/
/*   (Llib/flac_alsadec.scm)                                                 */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi flac -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/flac_alsadec.scm -o objs/flac_alsadec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>
#include <alsa/asoundlib.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;

typedef struct BgL_flacalsadecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacalsadecz00_bglt;

typedef struct BgL_flaczd2alsadecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flaczd2alsadecoderzd2_bglt;


static obj_t BGl_requirezd2initializa7ationz75zz__flac_alsadecz00 = BUNSPEC;
static obj_t BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__flac_alsadecz00();
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
static obj_t BGl_flacalsadecz00zz__flac_alsadecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_alsadecz00();
static obj_t BGl_objectzd2initzd2zz__flac_alsadecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_alsadecz00();
static obj_t BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_alsadecz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31182ze3ze5zz__flac_alsadecz00(obj_t, obj_t);
extern obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_alsadecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
static BgL_flacalsadecz00_bglt BGl_z62lambda1177z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flacalsadecz00_bglt BGl_z62lambda1180z62zz__flac_alsadecz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_alsadecz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_alsadecz00();
static BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1188z62zz__flac_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00();
static obj_t BGl_gczd2rootszd2initz00zz__flac_alsadecz00();
static BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1191z62zz__flac_alsadecz00(obj_t);
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t bgl_custom_nil();
BGL_EXPORTED_DEF obj_t BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00 = BUNSPEC;
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_flacdecz00zz__flac_decoderz00;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt);
extern obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
extern obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00;
static obj_t __cnst[ 22 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00;
DEFINE_STRING( BGl_string1714z00zz__flac_alsadecz00, BgL_bgl_string1714za700za7za7_1735za7, "Llib/flac_alsadec.scm", 21 );
DEFINE_STRING( BGl_string1721z00zz__flac_alsadecz00, BgL_bgl_string1721za700za7za7_1736za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1715z00zz__flac_alsadecz00, BgL_bgl_za762za7c3za704anonymo1737za7, BGl_z62zc3z04anonymousza31182ze3ze5zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1716z00zz__flac_alsadecz00, BgL_bgl_za762lambda1180za7621738z00, BGl_z62lambda1180z62zz__flac_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1723z00zz__flac_alsadecz00, BgL_bgl_string1723za700za7za7_1739za7, "musicdecoder-init", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1717z00zz__flac_alsadecz00, BgL_bgl_za762lambda1177za7621740z00, BGl_z62lambda1177z62zz__flac_alsadecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1718z00zz__flac_alsadecz00, BgL_bgl_za762za7c3za704anonymo1741za7, BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1725z00zz__flac_alsadecz00, BgL_bgl_string1725za700za7za7_1742za7, "musicdecoder-decode", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1719z00zz__flac_alsadecz00, BgL_bgl_za762lambda1191za7621743z00, BGl_z62lambda1191z62zz__flac_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1727z00zz__flac_alsadecz00, BgL_bgl_string1727za700za7za7_1744za7, "flac-decoder-metadata", 21 );
DEFINE_STRING( BGl_string1729z00zz__flac_alsadecz00, BgL_bgl_string1729za700za7za7_1745za7, "flac-decoder-read", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1720z00zz__flac_alsadecz00, BgL_bgl_za762lambda1188za7621746z00, BGl_z62lambda1188z62zz__flac_alsadecz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1722z00zz__flac_alsadecz00, BgL_bgl_za762musicdecoderza71747z00, BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1730z00zz__flac_alsadecz00, BgL_bgl_string1730za700za7za7_1748za7, "__flac_alsadec", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1724z00zz__flac_alsadecz00, BgL_bgl_za762musicdecoderza71749z00, BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1731z00zz__flac_alsadecz00, BgL_bgl_string1731za700za7za7_1750za7, "stop ended :start-threshold :avail-min :rate-resample :access rw-interleaved :format :channels :rate-near :buffer-time-near :buffer-size-near :period-size-near s32 s24-3le s16 buffering play pause flac-alsadecoder __flac_alsadec flacalsadec ", 241 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1726z00zz__flac_alsadecz00, BgL_bgl_za762flacza7d2decode1751z00, BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1728z00zz__flac_alsadecz00, BgL_bgl_za762flacza7d2decode1752z00, BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
extern obj_t BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_alsadecz00) );
ADD_ROOT( (void *)(&BGl_flacalsadecz00zz__flac_alsadecz00) );
ADD_ROOT( (void *)(&BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_alsadecz00(long BgL_checksumz00_632, char * BgL_fromz00_633)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_alsadecz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_alsadecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_alsadecz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00(); 
BGl_cnstzd2initzd2zz__flac_alsadecz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00(); 
BGl_objectzd2initzd2zz__flac_alsadecz00(); 
BGl_methodzd2initzd2zz__flac_alsadecz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_alsadecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_alsadec"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_alsadec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_cportz00_481;
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_stringz00_489;
BgL_stringz00_489 = BGl_string1731z00zz__flac_alsadecz00; 
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_startz00_490;
BgL_startz00_490 = 
BINT(((long)0)); 
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_endz00_491;
BgL_endz00_491 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_489))); 
{ /* Llib/flac_alsadec.scm 15 */

BgL_cportz00_481 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_489, BgL_startz00_490, BgL_endz00_491); } } } } 
{ 
long BgL_iz00_482;
BgL_iz00_482 = ((long)21); 
BgL_loopz00_483:
if(
(BgL_iz00_482==((long)-1)))
{ /* Llib/flac_alsadec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_arg1734z00_485;
{ /* Llib/flac_alsadec.scm 15 */

{ /* Llib/flac_alsadec.scm 15 */
obj_t BgL_locationz00_487;
BgL_locationz00_487 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_alsadec.scm 15 */

BgL_arg1734z00_485 = 
BGl_readz00zz__readerz00(BgL_cportz00_481, BgL_locationz00_487); } } } 
{ /* Llib/flac_alsadec.scm 15 */
int BgL_tmpz00_666;
BgL_tmpz00_666 = 
(int)(BgL_iz00_482); 
CNST_TABLE_SET(BgL_tmpz00_666, BgL_arg1734z00_485); } } 
{ /* Llib/flac_alsadec.scm 15 */
int BgL_auxz00_488;
BgL_auxz00_488 = 
(int)(
(BgL_iz00_482-((long)1))); 
{ 
long BgL_iz00_671;
BgL_iz00_671 = 
(long)(BgL_auxz00_488); 
BgL_iz00_482 = BgL_iz00_671; 
goto BgL_loopz00_483;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), 
BSTRING_TO_STRING(BGl_string1714z00zz__flac_alsadecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1714z00zz__flac_alsadecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_arg1175z00_25;obj_t BgL_arg1176z00_26;
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_v1149z00_53;
BgL_v1149z00_53 = 
create_vector(((long)0)); 
BgL_arg1175z00_25 = BgL_v1149z00_53; } 
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_v1150z00_54;
BgL_v1150z00_54 = 
create_vector(((long)0)); 
BgL_arg1176z00_26 = BgL_v1150z00_54; } 
BGl_flacalsadecz00zz__flac_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_flacdecz00zz__flac_decoderz00, ((long)31914), BGl_proc1717z00zz__flac_alsadecz00, BGl_proc1716z00zz__flac_alsadecz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1715z00zz__flac_alsadecz00, BFALSE, BgL_arg1175z00_25, BgL_arg1176z00_26); } 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_arg1186z00_61;obj_t BgL_arg1187z00_62;
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_v1151z00_85;
BgL_v1151z00_85 = 
create_vector(((long)0)); 
BgL_arg1186z00_61 = BgL_v1151z00_85; } 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_v1152z00_86;
BgL_v1152z00_86 = 
create_vector(((long)0)); 
BgL_arg1187z00_62 = BgL_v1152z00_86; } 
return ( 
BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)2)), 
CNST_TABLE_REF(((long)1)), BGl_flacmusicdecoderz00zz__flac_decoderz00, ((long)10516), BGl_proc1720z00zz__flac_alsadecz00, BGl_proc1719z00zz__flac_alsadecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1718z00zz__flac_alsadecz00, BFALSE, BgL_arg1186z00_61, BgL_arg1187z00_62), BUNSPEC) ;} } 

}



/* &<@anonymous:1196> */
obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_404, obj_t BgL_new1120z00_405)
{
{ /* Llib/flac_alsadec.scm 30 */
{ 
BgL_flaczd2alsadecoderzd2_bglt BgL_auxz00_688;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405))))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_688 = 
((BgL_flaczd2alsadecoderzd2_bglt)BgL_new1120z00_405); 
return 
((obj_t)BgL_auxz00_688);} } 

}



/* &lambda1191 */
BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1191z62zz__flac_alsadecz00(obj_t BgL_envz00_406)
{
{ /* Llib/flac_alsadec.scm 30 */
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1119z00_494;
BgL_new1119z00_494 = 
((BgL_flaczd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2alsadecoderzd2_bgl) ))); 
{ /* Llib/flac_alsadec.scm 30 */
long BgL_arg1195z00_495;
BgL_arg1195z00_495 = 
BGL_CLASS_INDEX(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_494), BgL_arg1195z00_495); } 
return BgL_new1119z00_494;} } 

}



/* &lambda1188 */
BgL_flaczd2alsadecoderzd2_bglt BGl_z62lambda1188z62zz__flac_alsadecz00(obj_t BgL_envz00_407, obj_t BgL_mimetypes1107z00_408, obj_t BgL_bufferzd2timezd2near1108z00_409, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1109z75_410, obj_t BgL_periodzd2siza7ezd2nearzd2rat1110z75_411, obj_t BgL_z52z12dpause1111z40_412, obj_t BgL_z52z12dabort1112z40_413, obj_t BgL_z52z12stop1113z40_414, obj_t BgL_z52dmutex1114z52_415, obj_t BgL_z52dcondv1115z52_416, obj_t BgL_z52doutcondv1116z52_417, obj_t BgL_z52flac1117z52_418, obj_t BgL_z52inseek1118z52_419)
{
{ /* Llib/flac_alsadec.scm 30 */
{ /* Llib/flac_alsadec.scm 30 */
int BgL_bufferzd2timezd2near1108z00_497;int BgL_bufferzd2siza7ezd2nearzd2rat1109z75_498;int BgL_periodzd2siza7ezd2nearzd2rat1110z75_499;bool_t BgL_z52z12dpause1111z40_500;bool_t BgL_z52z12dabort1112z40_501;bool_t BgL_z52z12stop1113z40_502;
BgL_bufferzd2timezd2near1108z00_497 = 
CINT(BgL_bufferzd2timezd2near1108z00_409); 
BgL_bufferzd2siza7ezd2nearzd2rat1109z75_498 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1109z75_410); 
BgL_periodzd2siza7ezd2nearzd2rat1110z75_499 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1110z75_411); 
BgL_z52z12dpause1111z40_500 = 
CBOOL(BgL_z52z12dpause1111z40_412); 
BgL_z52z12dabort1112z40_501 = 
CBOOL(BgL_z52z12dabort1112z40_413); 
BgL_z52z12stop1113z40_502 = 
CBOOL(BgL_z52z12stop1113z40_414); 
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1148z00_506;
{ /* Llib/flac_alsadec.scm 30 */
BgL_flaczd2alsadecoderzd2_bglt BgL_new1147z00_507;
BgL_new1147z00_507 = 
((BgL_flaczd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2alsadecoderzd2_bgl) ))); 
{ /* Llib/flac_alsadec.scm 30 */
long BgL_arg1190z00_508;
BgL_arg1190z00_508 = 
BGL_CLASS_INDEX(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_507), BgL_arg1190z00_508); } 
BgL_new1148z00_506 = BgL_new1147z00_507; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1107z00_408)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1108z00_497),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1109z75_498),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1110z75_499),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1111z40_500),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1112z40_501),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1113z40_502),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1114z52_415)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1115z52_416)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1116z52_417)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52flacz52)=((obj_t)BgL_z52flac1117z52_418),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1148z00_506)))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1118z52_419),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 30 */
obj_t BgL_fun1189z00_509;
BgL_fun1189z00_509 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1189z00_509)(BgL_fun1189z00_509, 
((obj_t)BgL_new1148z00_506), BEOA); } 
return BgL_new1148z00_506;} } } 

}



/* &<@anonymous:1182> */
obj_t BGl_z62zc3z04anonymousza31182ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_420, obj_t BgL_new1105z00_421)
{
{ /* Llib/flac_alsadec.scm 26 */
{ 
BgL_flacalsadecz00_bglt BgL_auxz00_781;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52flacbufz52)=((obj_t)
bgl_custom_nil()),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_outbufz00)=((obj_t)BGl_string1721z00zz__flac_alsadecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421))))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_781 = 
((BgL_flacalsadecz00_bglt)BgL_new1105z00_421); 
return 
((obj_t)BgL_auxz00_781);} } 

}



/* &lambda1180 */
BgL_flacalsadecz00_bglt BGl_z62lambda1180z62zz__flac_alsadecz00(obj_t BgL_envz00_422)
{
{ /* Llib/flac_alsadec.scm 26 */
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1103z00_511;
BgL_new1103z00_511 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 26 */
long BgL_arg1181z00_512;
BgL_arg1181z00_512 = 
BGL_CLASS_INDEX(BGl_flacalsadecz00zz__flac_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1103z00_511), BgL_arg1181z00_512); } 
return BgL_new1103z00_511;} } 

}



/* &lambda1177 */
BgL_flacalsadecz00_bglt BGl_z62lambda1177z62zz__flac_alsadecz00(obj_t BgL_envz00_423, obj_t BgL_z42builtin1087z42_424, obj_t BgL_z52flacbuf1088z52_425, obj_t BgL_outbuf1089z00_426, obj_t BgL_z52eof1090z52_427, obj_t BgL_z52sample1091z52_428, obj_t BgL_z52volume1092z52_429, obj_t BgL_md5check1093z00_430, obj_t BgL_z52bchecksum1094z52_431, obj_t BgL_z52rchecksum1095z52_432, obj_t BgL_z52music1096z52_433, obj_t BgL_z52buffer1097z52_434, obj_t BgL_z52decoder1098z52_435, obj_t BgL_z52rate1099z52_436, obj_t BgL_z52ratezd2max1100z80_437, obj_t BgL_z52ratezd2min1101z80_438, obj_t BgL_z52lastzd2percentage1102z80_439)
{
{ /* Llib/flac_alsadec.scm 26 */
{ /* Llib/flac_alsadec.scm 26 */
FLAC__StreamDecoder * BgL_z42builtin1087z42_513;bool_t BgL_z52eof1090z52_516;long BgL_z52sample1091z52_517;double BgL_z52volume1092z52_518;bool_t BgL_md5check1093z00_519;int BgL_z52bchecksum1094z52_520;int BgL_z52rchecksum1095z52_521;int BgL_z52rate1099z52_522;int BgL_z52ratezd2max1100z80_523;int BgL_z52ratezd2min1101z80_524;int BgL_z52lastzd2percentage1102z80_525;
BgL_z42builtin1087z42_513 = 
FOREIGN_TO_COBJ(BgL_z42builtin1087z42_424); 
BgL_z52eof1090z52_516 = 
CBOOL(BgL_z52eof1090z52_427); 
BgL_z52sample1091z52_517 = 
(long)CINT(BgL_z52sample1091z52_428); 
BgL_z52volume1092z52_518 = 
REAL_TO_DOUBLE(BgL_z52volume1092z52_429); 
BgL_md5check1093z00_519 = 
CBOOL(BgL_md5check1093z00_430); 
BgL_z52bchecksum1094z52_520 = 
CINT(BgL_z52bchecksum1094z52_431); 
BgL_z52rchecksum1095z52_521 = 
CINT(BgL_z52rchecksum1095z52_432); 
BgL_z52rate1099z52_522 = 
CINT(BgL_z52rate1099z52_436); 
BgL_z52ratezd2max1100z80_523 = 
CINT(BgL_z52ratezd2max1100z80_437); 
BgL_z52ratezd2min1101z80_524 = 
CINT(BgL_z52ratezd2min1101z80_438); 
BgL_z52lastzd2percentage1102z80_525 = 
CINT(BgL_z52lastzd2percentage1102z80_439); 
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1146z00_526;
{ /* Llib/flac_alsadec.scm 26 */
BgL_flacalsadecz00_bglt BgL_new1145z00_527;
BgL_new1145z00_527 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 26 */
long BgL_arg1179z00_528;
BgL_arg1179z00_528 = 
BGL_CLASS_INDEX(BGl_flacalsadecz00zz__flac_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1145z00_527), BgL_arg1179z00_528); } 
BgL_new1146z00_526 = BgL_new1145z00_527; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_z42builtin1087z42_513),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52flacbufz52)=((obj_t)
((obj_t)BgL_z52flacbuf1088z52_425)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1089z00_426)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52eofz52)=((bool_t)BgL_z52eof1090z52_516),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52samplez52)=((long)BgL_z52sample1091z52_517),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52volumez52)=((double)BgL_z52volume1092z52_518),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_md5checkz00)=((bool_t)BgL_md5check1093z00_519),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52bchecksumz52)=((int)BgL_z52bchecksum1094z52_520),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1146z00_526)))->BgL_z52rchecksumz52)=((int)BgL_z52rchecksum1095z52_521),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52musicz52)=((obj_t)BgL_z52music1096z52_433),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1097z52_434),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1098z52_435),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52ratez52)=((int)BgL_z52rate1099z52_522),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52ratezd2maxz80)=((int)BgL_z52ratezd2max1100z80_523),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52ratezd2minz80)=((int)BgL_z52ratezd2min1101z80_524),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1146z00_526)))->BgL_z52lastzd2percentagez80)=((int)BgL_z52lastzd2percentage1102z80_525),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 26 */
obj_t BgL_fun1178z00_529;
BgL_fun1178z00_529 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacalsadecz00zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1178z00_529)(BgL_fun1178z00_529, 
((obj_t)BgL_new1146z00_526), BEOA); } 
return BgL_new1146z00_526;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00, BGl_proc1722z00zz__flac_alsadecz00, BGl_string1723z00zz__flac_alsadecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00, BGl_proc1724z00zz__flac_alsadecz00, BGl_string1725z00zz__flac_alsadecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BGl_flacalsadecz00zz__flac_alsadecz00, BGl_proc1726z00zz__flac_alsadecz00, BGl_string1727z00zz__flac_alsadecz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BGl_flacalsadecz00zz__flac_alsadecz00, BGl_proc1728z00zz__flac_alsadecz00, BGl_string1729z00zz__flac_alsadecz00);} 

}



/* &flac-decoder-read-fl1160 */
obj_t BGl_z62flaczd2decoderzd2readzd2fl1160zb0zz__flac_alsadecz00(obj_t BgL_envz00_449, obj_t BgL_oz00_450, obj_t BgL_siza7eza7_451)
{
{ /* Llib/flac_alsadec.scm 97 */
{ /* Llib/flac_alsadec.scm 98 */
long BgL_siza7eza7_531;
BgL_siza7eza7_531 = 
(long)CINT(BgL_siza7eza7_451); 
{ /* Llib/flac_alsadec.scm 100 */
BgL_musicdecoderz00_bglt BgL_i1138z00_532;
BgL_i1138z00_532 = 
((BgL_musicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52decoderz52)); 
{ /* Llib/flac_alsadec.scm 101 */
BgL_musicbufferz00_bglt BgL_i1139z00_533;
BgL_i1139z00_533 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52bufferz52)); 
{ /* Llib/flac_alsadec.scm 101 */
long BgL_inlenz00_534;
BgL_inlenz00_534 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52inlenz52); 
{ /* Llib/flac_alsadec.scm 109 */
char * BgL_flacbufz00_535;
{ /* Llib/flac_alsadec.scm 109 */
obj_t BgL_arg1701z00_536;
BgL_arg1701z00_536 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450)))))->BgL_z52flacbufz52); 
BgL_flacbufz00_535 = 
CUSTOM_IDENTIFIER(BgL_arg1701z00_536); } 
{ 

{ 

{ 
long BgL_siza7eza7_549;
{ 
long BgL_siza7eza7_556;long BgL_iz00_557;
BgL_siza7eza7_556 = BgL_siza7eza7_531; 
BgL_iz00_557 = ((long)0); 
BgL_loopz00_555:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52z12dpausez40))
{ /* Llib/flac_alsadec.scm 156 */
{ /* Llib/flac_alsadec.scm 157 */
obj_t BgL_arg1330z00_558;
BgL_arg1330z00_558 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1330z00_558), 
CNST_TABLE_REF(((long)3))); } 
{ /* Llib/flac_alsadec.scm 159 */
BgL_alsamusicz00_bglt BgL_i1141z00_559;
BgL_i1141z00_559 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 160 */
BgL_musicstatusz00_bglt BgL_i1142z00_560;
BgL_i1142z00_560 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_i1141z00_559)))->BgL_z52statusz52); 
{ 
obj_t BgL_auxz00_932;
{ /* Llib/flac_alsadec.scm 162 */
obj_t BgL_arg1333z00_561;obj_t BgL_arg1334z00_562;
BgL_arg1333z00_561 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52decoderz52); 
BgL_arg1334z00_562 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52bufferz52); 
BgL_auxz00_932 = 
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_arg1333z00_561), 
((BgL_musicbufferz00_bglt)BgL_arg1334z00_562))); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1142z00_560))->BgL_songposz00)=((obj_t)BgL_auxz00_932),BUNSPEC); } } } 
{ /* Llib/flac_alsadec.scm 163 */
obj_t BgL_mutex1335z00_563;
BgL_mutex1335z00_563 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1335z00_563); 
{ /* Llib/flac_alsadec.scm 163 */
bool_t BgL_tmp1756z00_945;
{ 

BgL_liipz00_564:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52z12dpausez40))
{ /* Llib/flac_alsadec.scm 165 */
{ /* Llib/flac_alsadec.scm 166 */
obj_t BgL_arg1338z00_565;obj_t BgL_arg1339z00_566;
BgL_arg1338z00_565 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52dcondvz52); 
BgL_arg1339z00_566 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52dmutexz52); 
{ /* Llib/flac_alsadec.scm 166 */

BGL_CONDVAR_WAIT(BgL_arg1338z00_565, BgL_arg1339z00_566); } } 
goto BgL_liipz00_564;}  else 
{ /* Llib/flac_alsadec.scm 165 */
BgL_tmp1756z00_945 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1335z00_563); BgL_tmp1756z00_945; } } 
{ /* Llib/flac_alsadec.scm 168 */
obj_t BgL_arg1341z00_567;
BgL_arg1341z00_567 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1341z00_567), 
CNST_TABLE_REF(((long)4))); } 
{ 

goto BgL_loopz00_555;} }  else 
{ /* Llib/flac_alsadec.scm 156 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52z12dabortz40))
{ /* Llib/flac_alsadec.scm 170 */
return 
BINT(((long)-1));}  else 
{ /* Llib/flac_alsadec.scm 170 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 173 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 175 */
return BEOF;}  else 
{ /* Llib/flac_alsadec.scm 175 */
{ /* Llib/flac_alsadec.scm 178 */
BgL_alsamusicz00_bglt BgL_i1143z00_568;
BgL_i1143z00_568 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 179 */
BgL_musicstatusz00_bglt BgL_i1144z00_569;
BgL_i1144z00_569 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_i1143z00_568)))->BgL_z52statusz52); 
{ 
int BgL_auxz00_972;
{ /* Llib/flac_alsadec.scm 181 */
long BgL_tmpz00_973;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1684z00_538;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1696z00_539;BGL_LONGLONG_T BgL_arg1697z00_540;
{ /* Llib/flac_alsadec.scm 114 */
BGL_LONGLONG_T BgL_arg1698z00_541;
{ /* Llib/flac_alsadec.scm 114 */
long BgL_arg1699z00_542;
{ /* Llib/flac_alsadec.scm 114 */
obj_t BgL_arg1700z00_543;
BgL_arg1700z00_543 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52bufferz52); 
BgL_arg1699z00_542 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1700z00_543)); } 
BgL_arg1698z00_541 = 
LONG_TO_LLONG(BgL_arg1699z00_542); } 
BgL_arg1696z00_539 = 
(((BGL_LONGLONG_T)100)*BgL_arg1698z00_541); } 
BgL_arg1697z00_540 = 
LONG_TO_LLONG(BgL_inlenz00_534); 
BgL_arg1684z00_538 = 
(BgL_arg1696z00_539/BgL_arg1697z00_540); } 
BgL_tmpz00_973 = 
LLONG_TO_LONG(BgL_arg1684z00_538); } 
BgL_auxz00_972 = 
(int)(BgL_tmpz00_973); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1144z00_569))->BgL_bufferingz00)=((int)BgL_auxz00_972),BUNSPEC); } } } 
{ /* Llib/flac_alsadec.scm 182 */
obj_t BgL_arg1356z00_570;
BgL_arg1356z00_570 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1356z00_570), 
CNST_TABLE_REF(((long)5))); } 
{ /* Llib/flac_alsadec.scm 183 */
obj_t BgL_mutex1357z00_571;
BgL_mutex1357z00_571 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52bmutexz52); 
{ /* Llib/flac_alsadec.scm 183 */
obj_t BgL_top1764z00_994;
BgL_top1764z00_994 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1357z00_571); 
BGL_EXITD_PUSH_PROTECT(BgL_top1764z00_994, BgL_mutex1357z00_571); BUNSPEC; 
{ /* Llib/flac_alsadec.scm 183 */
bool_t BgL_tmp1763z00_993;
{ /* Llib/flac_alsadec.scm 185 */
bool_t BgL_test1765z00_998;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1765z00_998 = ((bool_t)1)
; }  else 
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1138z00_532))->BgL_z52z12dabortz40))
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1765z00_998 = ((bool_t)1)
; }  else 
{ /* Llib/flac_alsadec.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52emptyz52))
{ /* Llib/flac_alsadec.scm 119 */
BgL_test1765z00_998 = ((bool_t)0)
; }  else 
{ /* Llib/flac_alsadec.scm 120 */
long BgL_arg1677z00_545;
{ /* Llib/flac_alsadec.scm 120 */
long BgL_arg1678z00_546;
{ /* Llib/flac_alsadec.scm 120 */
obj_t BgL_arg1681z00_547;
BgL_arg1681z00_547 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52bufferz52); 
BgL_arg1678z00_546 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1681z00_547)); } 
BgL_arg1677z00_545 = 
(((long)4)*BgL_arg1678z00_546); } 
BgL_test1765z00_998 = 
(BgL_arg1677z00_545>BgL_inlenz00_534); } } } }  else 
{ /* Llib/flac_alsadec.scm 185 */
BgL_test1765z00_998 = ((bool_t)1)
; } 
if(BgL_test1765z00_998)
{ /* Llib/flac_alsadec.scm 185 */
BgL_tmp1763z00_993 = ((bool_t)0); }  else 
{ /* Llib/flac_alsadec.scm 189 */
obj_t BgL_arg1389z00_572;obj_t BgL_arg1390z00_573;
BgL_arg1389z00_572 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52bcondvz52); 
BgL_arg1390z00_573 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52bmutexz52); 
{ /* Llib/flac_alsadec.scm 189 */

BgL_tmp1763z00_993 = 
BGL_CONDVAR_WAIT(BgL_arg1389z00_572, BgL_arg1390z00_573); } } } 
BGL_EXITD_POP_PROTECT(BgL_top1764z00_994); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1357z00_571); BgL_tmp1763z00_993; } } } 
{ /* Llib/flac_alsadec.scm 190 */
obj_t BgL_arg1431z00_574;
BgL_arg1431z00_574 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1431z00_574), 
CNST_TABLE_REF(((long)4))); } 
{ 

goto BgL_loopz00_555;} } }  else 
{ /* Llib/flac_alsadec.scm 193 */
long BgL_sz00_575;
{ /* Llib/flac_alsadec.scm 193 */
long BgL_bz00_576;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52)))
{ /* Llib/flac_alsadec.scm 194 */
BgL_bz00_576 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52)); }  else 
{ /* Llib/flac_alsadec.scm 194 */
BgL_bz00_576 = 
(BgL_inlenz00_534-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52)); } 
if(
(BgL_siza7eza7_556<BgL_bz00_576))
{ /* Llib/flac_alsadec.scm 194 */
BgL_sz00_575 = BgL_siza7eza7_556; }  else 
{ /* Llib/flac_alsadec.scm 194 */
BgL_sz00_575 = BgL_bz00_576; } } 
if(
(BgL_sz00_575>((long)0)))
{ /* Llib/flac_alsadec.scm 197 */
{ /* Llib/flac_alsadec.scm 198 */
char * BgL_arg1506z00_577;long BgL_arg1507z00_578;
BgL_arg1506z00_577 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52inbufpz52); 
BgL_arg1507z00_578 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52); 
BGL_FLAC_BLIT_STRING(BgL_arg1506z00_577, BgL_arg1507z00_578, BgL_flacbufz00_535, BgL_iz00_557, BgL_sz00_575); BUNSPEC; } 
BgL_siza7eza7_549 = BgL_sz00_575; 
{ /* Llib/flac_alsadec.scm 128 */
long BgL_ntailz00_550;
BgL_ntailz00_550 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52)+BgL_siza7eza7_549); 
if(
(BgL_ntailz00_550==BgL_inlenz00_534))
{ /* Llib/flac_alsadec.scm 129 */
BgL_ntailz00_550 = ((long)0); }  else 
{ /* Llib/flac_alsadec.scm 129 */BFALSE; } 
if(
(BgL_ntailz00_550==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52headz52)))
{ /* Llib/flac_alsadec.scm 132 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))<((long)80)))
{ /* Llib/flac_alsadec.scm 133 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 133 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 132 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52tailz52)=((long)BgL_ntailz00_550),BUNSPEC); } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 137 */BFALSE; }  else 
{ /* Llib/flac_alsadec.scm 140 */
long BgL_availz00_551;
{ /* Llib/flac_alsadec.scm 140 */
obj_t BgL_arg1671z00_552;
BgL_arg1671z00_552 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52bufferz52); 
BgL_availz00_551 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1671z00_552)); } 
{ /* Llib/flac_alsadec.scm 140 */
long BgL_pz00_553;
BgL_pz00_553 = 
(
(BgL_availz00_551*((long)100))/BgL_inlenz00_534); 
{ /* Llib/flac_alsadec.scm 141 */

if(
(BgL_pz00_553<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))))
{ /* Llib/flac_alsadec.scm 143 */
{ /* Llib/flac_alsadec.scm 123 */
obj_t BgL_mutex1673z00_554;
BgL_mutex1673z00_554 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1673z00_554); 
{ /* Llib/flac_alsadec.scm 123 */
bool_t BgL_tmp1781z00_1076;
{ /* Llib/flac_alsadec.scm 124 */
obj_t BgL_tmpz00_1078;
BgL_tmpz00_1078 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1139z00_533))->BgL_z52bcondvz52); 
BgL_tmp1781z00_1076 = 
BGL_CONDVAR_BROADCAST(BgL_tmpz00_1078); } 
BGL_MUTEX_UNLOCK(BgL_mutex1673z00_554); BgL_tmp1781z00_1076; } } 
{ /* Llib/flac_alsadec.scm 145 */
bool_t BgL_test1782z00_1082;
if(
(BgL_pz00_553<=
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52lastzd2percentagez80))))
{ /* Llib/flac_alsadec.scm 145 */
BgL_test1782z00_1082 = 
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratezd2maxz80)))
; }  else 
{ /* Llib/flac_alsadec.scm 145 */
BgL_test1782z00_1082 = ((bool_t)0)
; } 
if(BgL_test1782z00_1082)
{ /* Llib/flac_alsadec.scm 145 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))+((long)10)))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 145 */BFALSE; } } }  else 
{ /* Llib/flac_alsadec.scm 143 */
if(
(BgL_pz00_553>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_alsadec.scm 147 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_alsadec.scm 148 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52ratez52))-((long)1)))),BUNSPEC); }  else 
{ /* Llib/flac_alsadec.scm 148 */BFALSE; } }  else 
{ /* Llib/flac_alsadec.scm 147 */BFALSE; } } 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_450))))->BgL_z52lastzd2percentagez80)=((int)
(int)(BgL_pz00_553)),BUNSPEC); BUNSPEC; } } } }  else 
{ /* Llib/flac_alsadec.scm 197 */BFALSE; } 
if(
(BgL_sz00_575<BgL_siza7eza7_556))
{ 
long BgL_iz00_1140;long BgL_siza7eza7_1138;
BgL_siza7eza7_1138 = 
(BgL_siza7eza7_556-BgL_sz00_575); 
BgL_iz00_1140 = 
(BgL_iz00_557+BgL_sz00_575); 
BgL_iz00_557 = BgL_iz00_1140; 
BgL_siza7eza7_556 = BgL_siza7eza7_1138; 
goto BgL_loopz00_555;}  else 
{ /* Llib/flac_alsadec.scm 200 */
return 
BINT(
(BgL_iz00_557+BgL_sz00_575));} } } } } } } } } } } } } } 

}



/* &flac-decoder-metadat1158 */
obj_t BGl_z62flaczd2decoderzd2metadat1158z62zz__flac_alsadecz00(obj_t BgL_envz00_452, obj_t BgL_oz00_453, obj_t BgL_totalz00_454, obj_t BgL_ratez00_455, obj_t BgL_channelsz00_456, obj_t BgL_bpsz00_457)
{
{ /* Llib/flac_alsadec.scm 72 */
{ /* Llib/flac_alsadec.scm 74 */
BgL_alsamusicz00_bglt BgL_i1134z00_580;
BgL_i1134z00_580 = 
((BgL_alsamusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacalsadecz00_bglt)BgL_oz00_453))))->BgL_z52musicz52)); 
{ /* Llib/flac_alsadec.scm 75 */
obj_t BgL_encodingz00_581;
if(
INTEGERP(BgL_bpsz00_457))
{ /* Llib/flac_alsadec.scm 75 */
switch( 
(long)CINT(BgL_bpsz00_457)) { case ((long)8) : 

BgL_encodingz00_581 = 
CNST_TABLE_REF(((long)6)); break;case ((long)16) : 

BgL_encodingz00_581 = 
CNST_TABLE_REF(((long)6)); break;case ((long)24) : 

BgL_encodingz00_581 = 
CNST_TABLE_REF(((long)7)); break;case ((long)32) : 

BgL_encodingz00_581 = 
CNST_TABLE_REF(((long)8)); break;
default: 
BgL_encodingz00_581 = BUNSPEC; } }  else 
{ /* Llib/flac_alsadec.scm 75 */
BgL_encodingz00_581 = BUNSPEC; } 
BGl_alsazd2sndzd2pcmzd2reopenzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_580))->BgL_pcmz00)); 
{ /* Llib/flac_alsadec.scm 81 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1239z00_582;long BgL_arg1240z00_583;long BgL_arg1241z00_584;
BgL_arg1239z00_582 = 
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_580))->BgL_pcmz00); 
BgL_arg1240z00_583 = 
(
(long)CINT(BgL_ratez00_455)/((long)2)); 
BgL_arg1241z00_584 = 
(
(long)CINT(BgL_ratez00_455)/((long)8)); 
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_list1242z00_585;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1244z00_586;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1245z00_587;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1246z00_588;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1247z00_589;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1248z00_590;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1249z00_591;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1252z00_592;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1253z00_593;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1254z00_594;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1258z00_595;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1277z00_596;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1279z00_597;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1280z00_598;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1281z00_599;
{ /* Llib/flac_alsadec.scm 81 */
obj_t BgL_arg1318z00_600;
BgL_arg1318z00_600 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1241z00_584), BNIL); 
BgL_arg1281z00_599 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BgL_arg1318z00_600); } 
BgL_arg1280z00_598 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1240z00_583), BgL_arg1281z00_599); } 
BgL_arg1279z00_597 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BgL_arg1280z00_598); } 
BgL_arg1277z00_596 = 
MAKE_YOUNG_PAIR(
BINT(((long)500000)), BgL_arg1279z00_597); } 
BgL_arg1258z00_595 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BgL_arg1277z00_596); } 
BgL_arg1254z00_594 = 
MAKE_YOUNG_PAIR(BgL_ratez00_455, BgL_arg1258z00_595); } 
BgL_arg1253z00_593 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BgL_arg1254z00_594); } 
BgL_arg1252z00_592 = 
MAKE_YOUNG_PAIR(BgL_channelsz00_456, BgL_arg1253z00_593); } 
BgL_arg1249z00_591 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BgL_arg1252z00_592); } 
BgL_arg1248z00_590 = 
MAKE_YOUNG_PAIR(BgL_encodingz00_581, BgL_arg1249z00_591); } 
BgL_arg1247z00_589 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BgL_arg1248z00_590); } 
BgL_arg1246z00_588 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BgL_arg1247z00_589); } 
BgL_arg1245z00_587 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BgL_arg1246z00_588); } 
BgL_arg1244z00_586 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1245z00_587); } 
BgL_list1242z00_585 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BgL_arg1244z00_586); } 
BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1239z00_582, BgL_list1242z00_585); } } 
{ /* Llib/flac_alsadec.scm 90 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1319z00_601;
BgL_arg1319z00_601 = 
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1134z00_580))->BgL_pcmz00); 
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_list1320z00_602;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1321z00_603;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1323z00_604;
{ /* Llib/flac_alsadec.scm 90 */
obj_t BgL_arg1324z00_605;
BgL_arg1324z00_605 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BNIL); 
BgL_arg1323z00_604 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BgL_arg1324z00_605); } 
BgL_arg1321z00_603 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1323z00_604); } 
BgL_list1320z00_602 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BgL_arg1321z00_603); } 
return 
BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1319z00_601, BgL_list1320z00_602);} } } } } 

}



/* &musicdecoder-decode-1156 */
obj_t BGl_z62musicdecoderzd2decodezd21156z62zz__flac_alsadecz00(obj_t BgL_envz00_458, obj_t BgL_decz00_459, obj_t BgL_amz00_460, obj_t BgL_bufferz00_461)
{
{ /* Llib/flac_alsadec.scm 50 */
{ /* Llib/flac_alsadec.scm 54 */
BgL_flacdecz00_bglt BgL_i1125z00_609;
BgL_i1125z00_609 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_459))))->BgL_z52flacz52)); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_609))->BgL_z52bufferz52)=((obj_t)
((obj_t)
((BgL_musicbufferz00_bglt)BgL_bufferz00_461))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_609))->BgL_z52musicz52)=((obj_t)
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_460))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_609))->BgL_z52decoderz52)=((obj_t)
((obj_t)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_459))),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 60 */
obj_t BgL_exitd1128z00_610;
BgL_exitd1128z00_610 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac_alsadec.scm 65 */
obj_t BgL_zc3z04anonymousza31228ze3z87_611;
BgL_zc3z04anonymousza31228ze3z87_611 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_alsadecz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_611, 
(int)(((long)0)), 
((obj_t)BgL_i1125z00_609)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_611, 
(int)(((long)1)), 
((obj_t)
((BgL_alsamusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_460)))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_611, 
(int)(((long)2)), 
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_460))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1128z00_610, BgL_zc3z04anonymousza31228ze3z87_611); 
{ /* Llib/flac_alsadec.scm 61 */
obj_t BgL_tmp1130z00_612;
{ /* Llib/flac_alsadec.scm 61 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_i1132z00_613;
BgL_i1132z00_613 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_460))))->BgL_pcmz00); 
if(
(
(long)(
(((BgL_alsazd2sndzd2pcmz00_bglt)COBJECT(BgL_i1132z00_613))->BgL_hwbpsz00))<=((long)16)))
{ /* Llib/flac_alsadec.scm 63 */
obj_t BgL_arg1221z00_614;
BgL_arg1221z00_614 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_459))))->BgL_z52flacz52); 
BgL_tmp1130z00_612 = 
BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1221z00_614)); }  else 
{ /* Llib/flac_alsadec.scm 64 */
obj_t BgL_arg1222z00_615;
BgL_arg1222z00_615 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_459))))->BgL_z52flacz52); 
BgL_tmp1130z00_612 = 
BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1222z00_615)); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1128z00_610); 
BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_alsadecz00(BgL_zc3z04anonymousza31228ze3z87_611); 
return BgL_tmp1130z00_612;} } } } } 

}



/* &<@anonymous:1228> */
obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_alsadecz00(obj_t BgL_envz00_462)
{
{ /* Llib/flac_alsadec.scm 60 */
{ /* Llib/flac_alsadec.scm 65 */
BgL_flacdecz00_bglt BgL_i1125z00_463;BgL_alsamusicz00_bglt BgL_i1126z00_464;BgL_musicbufz00_bglt BgL_amz00_465;
BgL_i1125z00_463 = 
((BgL_flacdecz00_bglt)
PROCEDURE_REF(BgL_envz00_462, 
(int)(((long)0)))); 
BgL_i1126z00_464 = 
((BgL_alsamusicz00_bglt)
PROCEDURE_REF(BgL_envz00_462, 
(int)(((long)1)))); 
BgL_amz00_465 = 
((BgL_musicbufz00_bglt)
PROCEDURE_REF(BgL_envz00_462, 
(int)(((long)2)))); 
{ /* Llib/flac_alsadec.scm 65 */
BgL_musicbufferz00_bglt BgL_i1131z00_616;
BgL_i1131z00_616 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1125z00_463))->BgL_z52bufferz52)); 
BGl_alsazd2sndzd2pcmzd2cleanupzd2zz__alsa_pcmz00(
(((BgL_alsamusicz00_bglt)COBJECT(BgL_i1126z00_464))->BgL_pcmz00)); 
{ /* Llib/flac_alsadec.scm 67 */
obj_t BgL_arg1230z00_617;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1131z00_616))->BgL_z52eofz52))
{ /* Llib/flac_alsadec.scm 67 */
BgL_arg1230z00_617 = 
CNST_TABLE_REF(((long)20)); }  else 
{ /* Llib/flac_alsadec.scm 67 */
BgL_arg1230z00_617 = 
CNST_TABLE_REF(((long)21)); } 
return 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_465), BgL_arg1230z00_617);} } } } 

}



/* &musicdecoder-init-fl1154 */
obj_t BGl_z62musicdecoderzd2initzd2fl1154z62zz__flac_alsadecz00(obj_t BgL_envz00_466, obj_t BgL_decz00_467)
{
{ /* Llib/flac_alsadec.scm 42 */
{ 

{ /* Llib/flac_alsadec.scm 42 */
obj_t BgL_nextzd2method1153zd2_620;
BgL_nextzd2method1153zd2_620 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_467)), BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2alsadecoderzd2zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_nextzd2method1153zd2_620)(BgL_nextzd2method1153zd2_620, 
((obj_t)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_467)), BEOA); } 
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_467))))->BgL_z52flacz52)))
{ /* Llib/flac_alsadec.scm 45 */
return BFALSE;}  else 
{ 
obj_t BgL_auxz00_1285;
{ /* Llib/flac_alsadec.scm 45 */
BgL_flacalsadecz00_bglt BgL_new1123z00_621;
{ /* Llib/flac_alsadec.scm 45 */
BgL_flacalsadecz00_bglt BgL_new1122z00_622;
BgL_new1122z00_622 = 
((BgL_flacalsadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacalsadecz00_bgl) ))); 
{ /* Llib/flac_alsadec.scm 45 */
long BgL_arg1217z00_623;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_624;
BgL_classz00_624 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_arg1217z00_623 = 
BGL_CLASS_INDEX(BgL_classz00_624); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_622), BgL_arg1217z00_623); } 
BgL_new1123z00_621 = BgL_new1122z00_622; } 
{ 
void * BgL_auxz00_1292;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1201z00_625;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1206z00_626;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_627;
BgL_classz00_627 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_arg1206z00_626 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_627); } 
BgL_arg1201z00_625 = 
VECTOR_REF(BgL_arg1206z00_626,((long)0)); } 
BgL_auxz00_1292 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1201z00_625)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_1292),BUNSPEC); } 
{ 
obj_t BgL_auxz00_1299;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1209z00_628;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_arg1212z00_629;
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_classz00_630;
BgL_classz00_630 = BGl_flacalsadecz00zz__flac_alsadecz00; 
BgL_arg1212z00_629 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_630); } 
BgL_arg1209z00_628 = 
VECTOR_REF(BgL_arg1212z00_629,((long)1)); } 
BgL_auxz00_1299 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1209z00_628); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_1299),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_outbufz00)=((obj_t)BGl_string1721z00zz__flac_alsadecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1123z00_621)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1123z00_621)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_alsadec.scm 45 */
obj_t BgL_fun1213z00_631;
BgL_fun1213z00_631 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacalsadecz00zz__flac_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1213z00_631)(BgL_fun1213z00_631, 
((obj_t)BgL_new1123z00_621), BEOA); } 
BgL_auxz00_1285 = 
((obj_t)BgL_new1123z00_621); } 
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2alsadecoderzd2_bglt)BgL_decz00_467))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_1285),BUNSPEC);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_alsadecz00()
{
{ /* Llib/flac_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1730z00zz__flac_alsadecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__flac_decoderz00(((long)630617), 
BSTRING_TO_STRING(BGl_string1730z00zz__flac_alsadecz00));} 

}

#ifdef __cplusplus
}
#endif
