/*===========================================================================*/
/*   (Llib/flac_decoder.scm)                                                 */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi flac -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/flac_decoder.scm -o objs/flac_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;


BGL_EXPORTED_DECL int BGl_flaczd2debugzd2zz__flac_decoderz00();
static obj_t BGl_requirezd2initializa7ationz75zz__flac_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_musicbufferzd2tellzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
static obj_t BGl_z62flaczd2debugzb0zz__flac_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2seekzd2fl1145z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2lengthzd21153zb0zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__flac_decoderz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62flaczd2decoderzd2seekzd2fl1151zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_decoderz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__flac_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31215ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2positio1139zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2readzd2fl1147zb0zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_decoderz00(obj_t);
extern long BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicbufferzd2lengthzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicbufferz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2initzd2fl1131z62zz__flac_decoderz00(obj_t, obj_t);
extern obj_t BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2tellzd2fl1149zb0zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1213z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1214z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2resetz12zd21137z70zz__flac_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static obj_t BGl_z62lambda1222z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1223z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_decoderz00(obj_t);
extern obj_t BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31509ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1239z62zz__flac_decoderz00(obj_t, obj_t);
extern long BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_z62flaczd2decoderzd2resetz12zd21133za2zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1240z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1322z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1323z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1247z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1248z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2infozd2fl1141z62zz__flac_decoderz00(obj_t, obj_t);
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1259z62zz__flac_decoderz00(obj_t, obj_t);
static BgL_flacmusicdecoderz00_bglt BGl_z62lambda1340z62zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1260z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1507z62zz__flac_decoderz00(obj_t, obj_t);
static BgL_flacmusicdecoderz00_bglt BGl_z62lambda1345z62zz__flac_decoderz00(obj_t);
static obj_t BGl_z62lambda1508z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_decoderz00();
extern obj_t BGl_flaczd2decoderzd2zz__flac_flacz00;
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_decoderz00();
static obj_t BGl_gczd2rootszd2initz00zz__flac_decoderz00();
static BgL_flacdecz00_bglt BGl_z62lambda1191z62zz__flac_decoderz00(obj_t);
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t bgl_custom_nil();
BGL_IMPORT obj_t BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, obj_t);
static obj_t BGl_z62lambda1360z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1361z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1282z62zz__flac_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1283z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2volumezd21143z62zz__flac_decoderz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_flacdecz00zz__flac_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2writezd2f1135zb0zz__flac_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_za2debugzd2portza2zd2zz__flac_decoderz00;
BGL_EXPORTED_DECL int BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(long, char *, long, long);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00 = BUNSPEC;
static obj_t __cnst[ 18 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_flaczd2checksumzd2debugzd2envzd2zz__flac_decoderz00, BgL_bgl_za762flacza7d2checks2000z00, BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00, 0L, BUNSPEC, 4 );
extern obj_t BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_flaczd2debugzd2envz00zz__flac_decoderz00, BgL_bgl_za762flacza7d2debugza72001za7, BGl_z62flaczd2debugzb0zz__flac_decoderz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00;
DEFINE_STRING( BGl_string1934z00zz__flac_decoderz00, BgL_bgl_string1934za700za7za7_2002za7, "Llib/flac_decoder.scm", 21 );
DEFINE_STRING( BGl_string1935z00zz__flac_decoderz00, BgL_bgl_string1935za700za7za7_2003za7, "/builddir/build/BUILD/bigloo-4.4b/api/flac/src/Llib/flac_decoder.scm", 68 );
DEFINE_STRING( BGl_string1936z00zz__flac_decoderz00, BgL_bgl_string1936za700za7za7_2004za7, "&flac-checksum-debug", 20 );
DEFINE_STRING( BGl_string1937z00zz__flac_decoderz00, BgL_bgl_string1937za700za7za7_2005za7, "bint", 4 );
DEFINE_STRING( BGl_string1938z00zz__flac_decoderz00, BgL_bgl_string1938za700za7za7_2006za7, "bstring", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2007za7, BGl_z62zc3z04anonymousza31215ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1940z00zz__flac_decoderz00, BgL_bgl_za762lambda1214za7622008z00, BGl_z62lambda1214z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1941z00zz__flac_decoderz00, BgL_bgl_za762lambda1213za7622009z00, BGl_z62lambda1213z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1942z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2010za7, BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1943z00zz__flac_decoderz00, BgL_bgl_za762lambda1223za7622011z00, BGl_z62lambda1223z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1944z00zz__flac_decoderz00, BgL_bgl_za762lambda1222za7622012z00, BGl_z62lambda1222z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1945z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2013za7, BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1946z00zz__flac_decoderz00, BgL_bgl_za762lambda1240za7622014z00, BGl_z62lambda1240z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1947z00zz__flac_decoderz00, BgL_bgl_za762lambda1239za7622015z00, BGl_z62lambda1239z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1948z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2016za7, BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1949z00zz__flac_decoderz00, BgL_bgl_za762lambda1248za7622017z00, BGl_z62lambda1248z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1950z00zz__flac_decoderz00, BgL_bgl_za762lambda1247za7622018z00, BGl_z62lambda1247z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1951z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2019za7, BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1952z00zz__flac_decoderz00, BgL_bgl_za762lambda1260za7622020z00, BGl_z62lambda1260z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1953z00zz__flac_decoderz00, BgL_bgl_za762lambda1259za7622021z00, BGl_z62lambda1259z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1954z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2022za7, BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1955z00zz__flac_decoderz00, BgL_bgl_za762lambda1283za7622023z00, BGl_z62lambda1283z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1956z00zz__flac_decoderz00, BgL_bgl_za762lambda1282za7622024z00, BGl_z62lambda1282z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1957z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2025za7, BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1958z00zz__flac_decoderz00, BgL_bgl_za762lambda1323za7622026z00, BGl_z62lambda1323z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1959z00zz__flac_decoderz00, BgL_bgl_za762lambda1322za7622027z00, BGl_z62lambda1322z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1960z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2028za7, BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1961z00zz__flac_decoderz00, BgL_bgl_za762lambda1191za7622029z00, BGl_z62lambda1191z62zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1962z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2030za7, BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1963z00zz__flac_decoderz00, BgL_bgl_za762lambda1361za7622031z00, BGl_z62lambda1361z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1964z00zz__flac_decoderz00, BgL_bgl_za762lambda1360za7622032z00, BGl_z62lambda1360z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1971z00zz__flac_decoderz00, BgL_bgl_string1971za700za7za7_2033za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1965z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2034za7, BGl_z62zc3z04anonymousza31509ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1966z00zz__flac_decoderz00, BgL_bgl_za762lambda1508za7622035z00, BGl_z62lambda1508z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1973z00zz__flac_decoderz00, BgL_bgl_string1973za700za7za7_2036za7, "musicdecoder-init", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1967z00zz__flac_decoderz00, BgL_bgl_za762lambda1507za7622037z00, BGl_z62lambda1507z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1968z00zz__flac_decoderz00, BgL_bgl_za762za7c3za704anonymo2038za7, BGl_z62zc3z04anonymousza31347ze3ze5zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1975z00zz__flac_decoderz00, BgL_bgl_string1975za700za7za7_2039za7, "flac-decoder-reset!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1969z00zz__flac_decoderz00, BgL_bgl_za762lambda1345za7622040z00, BGl_z62lambda1345z62zz__flac_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1977z00zz__flac_decoderz00, BgL_bgl_string1977za700za7za7_2041za7, "flac-decoder-write", 18 );
DEFINE_STRING( BGl_string1979z00zz__flac_decoderz00, BgL_bgl_string1979za700za7za7_2042za7, "musicdecoder-reset!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1970z00zz__flac_decoderz00, BgL_bgl_za762lambda1340za7622043z00, BGl_z62lambda1340z62zz__flac_decoderz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1972z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72044z00, BGl_z62musicdecoderzd2initzd2fl1131z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1974z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2045z00, BGl_z62flaczd2decoderzd2resetz12zd21133za2zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1981z00zz__flac_decoderz00, BgL_bgl_string1981za700za7za7_2046za7, "musicdecoder-position", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1976z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2047z00, BGl_z62flaczd2decoderzd2writezd2f1135zb0zz__flac_decoderz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string1983z00zz__flac_decoderz00, BgL_bgl_string1983za700za7za7_2048za7, "musicdecoder-info", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1978z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72049z00, BGl_z62musicdecoderzd2resetz12zd21137z70zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1985z00zz__flac_decoderz00, BgL_bgl_string1985za700za7za7_2050za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string1987z00zz__flac_decoderz00, BgL_bgl_string1987za700za7za7_2051za7, "musicdecoder-seek", 17 );
DEFINE_STRING( BGl_string1989z00zz__flac_decoderz00, BgL_bgl_string1989za700za7za7_2052za7, "flac-decoder-read", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1980z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72053z00, BGl_z62musicdecoderzd2positio1139zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1982z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72054z00, BGl_z62musicdecoderzd2infozd2fl1141z62zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1984z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72055z00, BGl_z62musicdecoderzd2volumezd21143z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1991z00zz__flac_decoderz00, BgL_bgl_string1991za700za7za7_2056za7, "flac-decoder-tell", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1986z00zz__flac_decoderz00, BgL_bgl_za762musicdecoderza72057z00, BGl_z62musicdecoderzd2seekzd2fl1145z62zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1993z00zz__flac_decoderz00, BgL_bgl_string1993za700za7za7_2058za7, "flac-decoder-seek", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1988z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2059z00, BGl_z62flaczd2decoderzd2readzd2fl1147zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1995z00zz__flac_decoderz00, BgL_bgl_string1995za700za7za7_2060za7, "flac-decoder-length", 19 );
DEFINE_STRING( BGl_string1996z00zz__flac_decoderz00, BgL_bgl_string1996za700za7za7_2061za7, "__flac_decoder", 14 );
DEFINE_STRING( BGl_string1997z00zz__flac_decoderz00, BgL_bgl_string1997za700za7za7_2062za7, "(\"audio/flac\" \"application/x-flac\" \"audio/x-flac\") buffering play pause flacmusicdecoder %inseek %flac __flac_decoder flacdec %last-percentage %rate-min %rate-max int %rate %decoder %buffer obj %music ", 201 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1990z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2063z00, BGl_z62flaczd2decoderzd2tellzd2fl1149zb0zz__flac_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1992z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2064z00, BGl_z62flaczd2decoderzd2seekzd2fl1151zb0zz__flac_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1994z00zz__flac_decoderz00, BgL_bgl_za762flacza7d2decode2065z00, BGl_z62flaczd2decoderzd2lengthzd21153zb0zz__flac_decoderz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
extern obj_t BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_decoderz00) );
ADD_ROOT( (void *)(&BGl_flacdecz00zz__flac_decoderz00) );
ADD_ROOT( (void *)(&BGl_flacmusicdecoderz00zz__flac_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long BgL_checksumz00_945, char * BgL_fromz00_946)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00(); 
BGl_cnstzd2initzd2zz__flac_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_decoderz00(); 
BGl_objectzd2initzd2zz__flac_decoderz00(); 
BGl_methodzd2initzd2zz__flac_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_decoderz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__flac_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_decoder"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_cportz00_803;
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_stringz00_811;
BgL_stringz00_811 = BGl_string1997z00zz__flac_decoderz00; 
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_startz00_812;
BgL_startz00_812 = 
BINT(((long)0)); 
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_endz00_813;
BgL_endz00_813 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_811))); 
{ /* Llib/flac_decoder.scm 15 */

BgL_cportz00_803 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_811, BgL_startz00_812, BgL_endz00_813); } } } } 
{ 
long BgL_iz00_804;
BgL_iz00_804 = ((long)17); 
BgL_loopz00_805:
if(
(BgL_iz00_804==((long)-1)))
{ /* Llib/flac_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_arg1999z00_807;
{ /* Llib/flac_decoder.scm 15 */

{ /* Llib/flac_decoder.scm 15 */
obj_t BgL_locationz00_809;
BgL_locationz00_809 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_decoder.scm 15 */

BgL_arg1999z00_807 = 
BGl_readz00zz__readerz00(BgL_cportz00_803, BgL_locationz00_809); } } } 
{ /* Llib/flac_decoder.scm 15 */
int BgL_tmpz00_980;
BgL_tmpz00_980 = 
(int)(BgL_iz00_804); 
CNST_TABLE_SET(BgL_tmpz00_980, BgL_arg1999z00_807); } } 
{ /* Llib/flac_decoder.scm 15 */
int BgL_auxz00_810;
BgL_auxz00_810 = 
(int)(
(BgL_iz00_804-((long)1))); 
{ 
long BgL_iz00_985;
BgL_iz00_985 = 
(long)(BgL_auxz00_810); 
BgL_iz00_804 = BgL_iz00_985; 
goto BgL_loopz00_805;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1934z00zz__flac_decoderz00)); 
return ( 
BGl_za2debugzd2portza2zd2zz__flac_decoderz00 = ((bool_t)0), BUNSPEC) ;} 

}



/* flac-debug */
BGL_EXPORTED_DEF int BGl_flaczd2debugzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 53 */
if(
(((long)0)>((long)0)))
{ /* Llib/flac_decoder.scm 55 */
(long)(
bgl_debug()); }  else 
{ /* Llib/flac_decoder.scm 55 */((long)0); } 
return 
(int)(((long)1));} 

}



/* &flac-debug */
obj_t BGl_z62flaczd2debugzb0zz__flac_decoderz00(obj_t BgL_envz00_604)
{
{ /* Llib/flac_decoder.scm 53 */
return 
BINT(
BGl_flaczd2debugzd2zz__flac_decoderz00());} 

}



/* flac-checksum-debug */
BGL_EXPORTED_DEF int BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(long BgL_cz00_3, char * BgL_bufferz00_4, long BgL_iz00_5, long BgL_sz00_6)
{
{ /* Llib/flac_decoder.scm 63 */
{ 
long BgL_nz00_480;long BgL_cz00_481;
{ /* Llib/flac_decoder.scm 64 */
long BgL_tmpz00_997;
BgL_nz00_480 = ((long)0); 
BgL_cz00_481 = BgL_cz00_3; 
BgL_loopz00_479:
if(
(BgL_nz00_480==BgL_sz00_6))
{ /* Llib/flac_decoder.scm 66 */
BgL_tmpz00_997 = BgL_cz00_481
; }  else 
{ /* Llib/flac_decoder.scm 68 */
long BgL_arg1160z00_485;long BgL_arg1161z00_486;
BgL_arg1160z00_485 = 
(BgL_nz00_480+((long)1)); 
{ /* Llib/flac_decoder.scm 68 */
char BgL_arg1165z00_488;
{ /* Llib/flac_decoder.scm 68 */
long BgL_tmpz00_1001;
BgL_tmpz00_1001 = 
(BgL_iz00_5+BgL_nz00_480); 
BgL_arg1165z00_488 = 
BGL_FLAC_STRING_REF(BgL_bufferz00_4, BgL_tmpz00_1001); } 
BgL_arg1161z00_486 = 
(BgL_cz00_481 ^ 
(long)(BgL_arg1165z00_488)); } 
{ 
long BgL_cz00_1007;long BgL_nz00_1006;
BgL_nz00_1006 = BgL_arg1160z00_485; 
BgL_cz00_1007 = BgL_arg1161z00_486; 
BgL_cz00_481 = BgL_cz00_1007; 
BgL_nz00_480 = BgL_nz00_1006; 
goto BgL_loopz00_479;} } 
return 
(int)(BgL_tmpz00_997);} } } 

}



/* &flac-checksum-debug */
obj_t BGl_z62flaczd2checksumzd2debugz62zz__flac_decoderz00(obj_t BgL_envz00_605, obj_t BgL_cz00_606, obj_t BgL_bufferz00_607, obj_t BgL_iz00_608, obj_t BgL_sz00_609)
{
{ /* Llib/flac_decoder.scm 63 */
{ /* Llib/flac_decoder.scm 64 */
int BgL_tmpz00_1009;
{ /* Llib/flac_decoder.scm 64 */
long BgL_auxz00_1037;long BgL_auxz00_1028;char * BgL_auxz00_1019;long BgL_auxz00_1010;
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1038;
if(
INTEGERP(BgL_sz00_609))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1038 = BgL_sz00_609
; }  else 
{ 
obj_t BgL_auxz00_1041;
BgL_auxz00_1041 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1936z00zz__flac_decoderz00, BGl_string1937z00zz__flac_decoderz00, BgL_sz00_609); 
FAILURE(BgL_auxz00_1041,BFALSE,BFALSE);} 
BgL_auxz00_1037 = 
(long)CINT(BgL_tmpz00_1038); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1029;
if(
INTEGERP(BgL_iz00_608))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1029 = BgL_iz00_608
; }  else 
{ 
obj_t BgL_auxz00_1032;
BgL_auxz00_1032 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1936z00zz__flac_decoderz00, BGl_string1937z00zz__flac_decoderz00, BgL_iz00_608); 
FAILURE(BgL_auxz00_1032,BFALSE,BFALSE);} 
BgL_auxz00_1028 = 
(long)CINT(BgL_tmpz00_1029); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1020;
if(
STRINGP(BgL_bufferz00_607))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1020 = BgL_bufferz00_607
; }  else 
{ 
obj_t BgL_auxz00_1023;
BgL_auxz00_1023 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1936z00zz__flac_decoderz00, BGl_string1938z00zz__flac_decoderz00, BgL_bufferz00_607); 
FAILURE(BgL_auxz00_1023,BFALSE,BFALSE);} 
BgL_auxz00_1019 = 
BSTRING_TO_STRING(BgL_tmpz00_1020); } 
{ /* Llib/flac_decoder.scm 64 */
obj_t BgL_tmpz00_1011;
if(
INTEGERP(BgL_cz00_606))
{ /* Llib/flac_decoder.scm 64 */
BgL_tmpz00_1011 = BgL_cz00_606
; }  else 
{ 
obj_t BgL_auxz00_1014;
BgL_auxz00_1014 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__flac_decoderz00, 
BINT(((long)2760)), BGl_string1936z00zz__flac_decoderz00, BGl_string1937z00zz__flac_decoderz00, BgL_cz00_606); 
FAILURE(BgL_auxz00_1014,BFALSE,BFALSE);} 
BgL_auxz00_1010 = 
(long)CINT(BgL_tmpz00_1011); } 
BgL_tmpz00_1009 = 
BGl_flaczd2checksumzd2debugz00zz__flac_decoderz00(BgL_auxz00_1010, BgL_auxz00_1019, BgL_auxz00_1028, BgL_auxz00_1037); } 
return 
BINT(BgL_tmpz00_1009);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1189z00_73;obj_t BgL_arg1190z00_74;
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_v1126z00_80;
BgL_v1126z00_80 = 
create_vector(((long)7)); 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1201z00_81;
BgL_arg1201z00_81 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1941z00zz__flac_decoderz00, BGl_proc1940z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1939z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_80,((long)0),BgL_arg1201z00_81); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1217z00_94;
BgL_arg1217z00_94 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1944z00zz__flac_decoderz00, BGl_proc1943z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1942z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_80,((long)1),BgL_arg1217z00_94); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1227z00_107;
BgL_arg1227z00_107 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)3)), BGl_proc1947z00zz__flac_decoderz00, BGl_proc1946z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1945z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_80,((long)2),BgL_arg1227z00_107); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1242z00_120;
BgL_arg1242z00_120 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1950z00zz__flac_decoderz00, BGl_proc1949z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1948z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_80,((long)3),BgL_arg1242z00_120); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1252z00_133;
BgL_arg1252z00_133 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1953z00zz__flac_decoderz00, BGl_proc1952z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1951z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_80,((long)4),BgL_arg1252z00_133); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1277z00_146;
BgL_arg1277z00_146 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc1956z00zz__flac_decoderz00, BGl_proc1955z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1954z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_80,((long)5),BgL_arg1277z00_146); } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_arg1318z00_159;
BgL_arg1318z00_159 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1959z00zz__flac_decoderz00, BGl_proc1958z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1957z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_80,((long)6),BgL_arg1318z00_159); } 
BgL_arg1189z00_73 = BgL_v1126z00_80; } 
{ /* Llib/flac_decoder.scm 28 */
obj_t BgL_v1127z00_172;
BgL_v1127z00_172 = 
create_vector(((long)0)); 
BgL_arg1190z00_74 = BgL_v1127z00_172; } 
BGl_flacdecz00zz__flac_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)10)), BGl_flaczd2decoderzd2zz__flac_flacz00, ((long)58322), BFALSE, BGl_proc1961z00zz__flac_decoderz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1960z00zz__flac_decoderz00, BFALSE, BgL_arg1189z00_73, BgL_arg1190z00_74); } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1338z00_178;obj_t BgL_arg1339z00_179;
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_v1128z00_202;
BgL_v1128z00_202 = 
create_vector(((long)2)); 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1356z00_203;
BgL_arg1356z00_203 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc1964z00zz__flac_decoderz00, BGl_proc1963z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1962z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1128z00_202,((long)0),BgL_arg1356z00_203); } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_arg1389z00_216;
BgL_arg1389z00_216 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc1967z00zz__flac_decoderz00, BGl_proc1966z00zz__flac_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1965z00zz__flac_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1128z00_202,((long)1),BgL_arg1389z00_216); } 
BgL_arg1338z00_178 = BgL_v1128z00_202; } 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_v1129z00_229;
BgL_v1129z00_229 = 
create_vector(((long)0)); 
BgL_arg1339z00_179 = BgL_v1129z00_229; } 
return ( 
BGl_flacmusicdecoderz00zz__flac_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)13)), 
CNST_TABLE_REF(((long)10)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)48433), BGl_proc1970z00zz__flac_decoderz00, BGl_proc1969z00zz__flac_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1968z00zz__flac_decoderz00, BFALSE, BgL_arg1338z00_178, BgL_arg1339z00_179), BUNSPEC) ;} } 

}



/* &<@anonymous:1347> */
obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_642, obj_t BgL_new1091z00_643)
{
{ /* Llib/flac_decoder.scm 37 */
{ 
BgL_flacmusicdecoderz00_bglt BgL_auxz00_1094;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643)))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643)))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1094 = 
((BgL_flacmusicdecoderz00_bglt)BgL_new1091z00_643); 
return 
((obj_t)BgL_auxz00_1094);} } 

}



/* &lambda1345 */
BgL_flacmusicdecoderz00_bglt BGl_z62lambda1345z62zz__flac_decoderz00(obj_t BgL_envz00_644)
{
{ /* Llib/flac_decoder.scm 37 */
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1090z00_816;
BgL_new1090z00_816 = 
((BgL_flacmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacmusicdecoderz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 37 */
long BgL_arg1346z00_817;
BgL_arg1346z00_817 = 
BGL_CLASS_INDEX(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_816), BgL_arg1346z00_817); } 
return BgL_new1090z00_816;} } 

}



/* &lambda1340 */
BgL_flacmusicdecoderz00_bglt BGl_z62lambda1340z62zz__flac_decoderz00(obj_t BgL_envz00_645, obj_t BgL_mimetypes1078z00_646, obj_t BgL_bufferzd2timezd2near1079z00_647, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1080z75_648, obj_t BgL_periodzd2siza7ezd2nearzd2rat1081z75_649, obj_t BgL_z52z12dpause1082z40_650, obj_t BgL_z52z12dabort1083z40_651, obj_t BgL_z52z12stop1084z40_652, obj_t BgL_z52dmutex1085z52_653, obj_t BgL_z52dcondv1086z52_654, obj_t BgL_z52doutcondv1087z52_655, obj_t BgL_z52flac1088z52_656, obj_t BgL_z52inseek1089z52_657)
{
{ /* Llib/flac_decoder.scm 37 */
{ /* Llib/flac_decoder.scm 37 */
int BgL_bufferzd2timezd2near1079z00_819;int BgL_bufferzd2siza7ezd2nearzd2rat1080z75_820;int BgL_periodzd2siza7ezd2nearzd2rat1081z75_821;bool_t BgL_z52z12dpause1082z40_822;bool_t BgL_z52z12dabort1083z40_823;bool_t BgL_z52z12stop1084z40_824;
BgL_bufferzd2timezd2near1079z00_819 = 
CINT(BgL_bufferzd2timezd2near1079z00_647); 
BgL_bufferzd2siza7ezd2nearzd2rat1080z75_820 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1080z75_648); 
BgL_periodzd2siza7ezd2nearzd2rat1081z75_821 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1081z75_649); 
BgL_z52z12dpause1082z40_822 = 
CBOOL(BgL_z52z12dpause1082z40_650); 
BgL_z52z12dabort1083z40_823 = 
CBOOL(BgL_z52z12dabort1083z40_651); 
BgL_z52z12stop1084z40_824 = 
CBOOL(BgL_z52z12stop1084z40_652); 
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1123z00_828;
{ /* Llib/flac_decoder.scm 37 */
BgL_flacmusicdecoderz00_bglt BgL_new1122z00_829;
BgL_new1122z00_829 = 
((BgL_flacmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacmusicdecoderz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 37 */
long BgL_arg1344z00_830;
BgL_arg1344z00_830 = 
BGL_CLASS_INDEX(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_829), BgL_arg1344z00_830); } 
BgL_new1123z00_828 = BgL_new1122z00_829; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1078z00_646)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1079z00_819),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1080z75_820),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1081z75_821),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1082z40_822),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1083z40_823),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1084z40_824),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1085z52_653)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1086z52_654)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1123z00_828)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1087z52_655)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_828))->BgL_z52flacz52)=((obj_t)BgL_z52flac1088z52_656),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_new1123z00_828))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1089z52_657),BUNSPEC); 
{ /* Llib/flac_decoder.scm 37 */
obj_t BgL_fun1341z00_831;
BgL_fun1341z00_831 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacmusicdecoderz00zz__flac_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1341z00_831)(BgL_fun1341z00_831, 
((obj_t)BgL_new1123z00_828), BEOA); } 
return BgL_new1123z00_828;} } } 

}



/* &<@anonymous:1509> */
obj_t BGl_z62zc3z04anonymousza31509ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_658)
{
{ /* Llib/flac_decoder.scm 37 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1508 */
obj_t BGl_z62lambda1508z62zz__flac_decoderz00(obj_t BgL_envz00_659, obj_t BgL_oz00_660, obj_t BgL_vz00_661)
{
{ /* Llib/flac_decoder.scm 37 */
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_660)))->BgL_z52inseekz52)=((obj_t)BgL_vz00_661),BUNSPEC);} 

}



/* &lambda1507 */
obj_t BGl_z62lambda1507z62zz__flac_decoderz00(obj_t BgL_envz00_662, obj_t BgL_oz00_663)
{
{ /* Llib/flac_decoder.scm 37 */
return 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_663)))->BgL_z52inseekz52);} 

}



/* &<@anonymous:1362> */
obj_t BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_664)
{
{ /* Llib/flac_decoder.scm 37 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1361 */
obj_t BGl_z62lambda1361z62zz__flac_decoderz00(obj_t BgL_envz00_665, obj_t BgL_oz00_666, obj_t BgL_vz00_667)
{
{ /* Llib/flac_decoder.scm 37 */
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_666)))->BgL_z52flacz52)=((obj_t)BgL_vz00_667),BUNSPEC);} 

}



/* &lambda1360 */
obj_t BGl_z62lambda1360z62zz__flac_decoderz00(obj_t BgL_envz00_668, obj_t BgL_oz00_669)
{
{ /* Llib/flac_decoder.scm 37 */
return 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_669)))->BgL_z52flacz52);} 

}



/* &<@anonymous:1196> */
obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_670, obj_t BgL_new1076z00_671)
{
{ /* Llib/flac_decoder.scm 28 */
{ 
BgL_flacdecz00_bglt BgL_auxz00_1193;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52flacbufz52)=((obj_t)
bgl_custom_nil()),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_outbufz00)=((obj_t)BGl_string1971z00zz__flac_decoderz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_new1076z00_671))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1076z00_671)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1193 = 
((BgL_flacdecz00_bglt)BgL_new1076z00_671); 
return 
((obj_t)BgL_auxz00_1193);} } 

}



/* &lambda1191 */
BgL_flacdecz00_bglt BGl_z62lambda1191z62zz__flac_decoderz00(obj_t BgL_envz00_672)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
BgL_flacdecz00_bglt BgL_new1075z00_837;
BgL_new1075z00_837 = 
((BgL_flacdecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacdecz00_bgl) ))); 
{ /* Llib/flac_decoder.scm 28 */
long BgL_arg1195z00_838;
BgL_arg1195z00_838 = 
BGL_CLASS_INDEX(BGl_flacdecz00zz__flac_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1075z00_837), BgL_arg1195z00_838); } 
return BgL_new1075z00_837;} } 

}



/* &<@anonymous:1324> */
obj_t BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_673)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)0));} 

}



/* &lambda1323 */
obj_t BGl_z62lambda1323z62zz__flac_decoderz00(obj_t BgL_envz00_674, obj_t BgL_oz00_675, obj_t BgL_vz00_676)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_840;
BgL_vz00_840 = 
CINT(BgL_vz00_676); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_675)))->BgL_z52lastzd2percentagez80)=((int)BgL_vz00_840),BUNSPEC);} } 

}



/* &lambda1322 */
obj_t BGl_z62lambda1322z62zz__flac_decoderz00(obj_t BgL_envz00_677, obj_t BgL_oz00_678)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_678)))->BgL_z52lastzd2percentagez80));} 

}



/* &<@anonymous:1284> */
obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_679)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)50));} 

}



/* &lambda1283 */
obj_t BGl_z62lambda1283z62zz__flac_decoderz00(obj_t BgL_envz00_680, obj_t BgL_oz00_681, obj_t BgL_vz00_682)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_843;
BgL_vz00_843 = 
CINT(BgL_vz00_682); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_681)))->BgL_z52ratezd2minz80)=((int)BgL_vz00_843),BUNSPEC);} } 

}



/* &lambda1282 */
obj_t BGl_z62lambda1282z62zz__flac_decoderz00(obj_t BgL_envz00_683, obj_t BgL_oz00_684)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_684)))->BgL_z52ratezd2minz80));} 

}



/* &<@anonymous:1261> */
obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_685)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)80));} 

}



/* &lambda1260 */
obj_t BGl_z62lambda1260z62zz__flac_decoderz00(obj_t BgL_envz00_686, obj_t BgL_oz00_687, obj_t BgL_vz00_688)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_846;
BgL_vz00_846 = 
CINT(BgL_vz00_688); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_687)))->BgL_z52ratezd2maxz80)=((int)BgL_vz00_846),BUNSPEC);} } 

}



/* &lambda1259 */
obj_t BGl_z62lambda1259z62zz__flac_decoderz00(obj_t BgL_envz00_689, obj_t BgL_oz00_690)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_690)))->BgL_z52ratezd2maxz80));} 

}



/* &<@anonymous:1249> */
obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_691)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(((long)80));} 

}



/* &lambda1248 */
obj_t BGl_z62lambda1248z62zz__flac_decoderz00(obj_t BgL_envz00_692, obj_t BgL_oz00_693, obj_t BgL_vz00_694)
{
{ /* Llib/flac_decoder.scm 28 */
{ /* Llib/flac_decoder.scm 28 */
int BgL_vz00_849;
BgL_vz00_849 = 
CINT(BgL_vz00_694); 
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_693)))->BgL_z52ratez52)=((int)BgL_vz00_849),BUNSPEC);} } 

}



/* &lambda1247 */
obj_t BGl_z62lambda1247z62zz__flac_decoderz00(obj_t BgL_envz00_695, obj_t BgL_oz00_696)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BINT(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_696)))->BgL_z52ratez52));} 

}



/* &<@anonymous:1241> */
obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_697)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1240 */
obj_t BGl_z62lambda1240z62zz__flac_decoderz00(obj_t BgL_envz00_698, obj_t BgL_oz00_699, obj_t BgL_vz00_700)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_699)))->BgL_z52decoderz52)=((obj_t)BgL_vz00_700),BUNSPEC);} 

}



/* &lambda1239 */
obj_t BGl_z62lambda1239z62zz__flac_decoderz00(obj_t BgL_envz00_701, obj_t BgL_oz00_702)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_702)))->BgL_z52decoderz52);} 

}



/* &<@anonymous:1224> */
obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_703)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1223 */
obj_t BGl_z62lambda1223z62zz__flac_decoderz00(obj_t BgL_envz00_704, obj_t BgL_oz00_705, obj_t BgL_vz00_706)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_705)))->BgL_z52bufferz52)=((obj_t)BgL_vz00_706),BUNSPEC);} 

}



/* &lambda1222 */
obj_t BGl_z62lambda1222z62zz__flac_decoderz00(obj_t BgL_envz00_707, obj_t BgL_oz00_708)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_708)))->BgL_z52bufferz52);} 

}



/* &<@anonymous:1215> */
obj_t BGl_z62zc3z04anonymousza31215ze3ze5zz__flac_decoderz00(obj_t BgL_envz00_709)
{
{ /* Llib/flac_decoder.scm 28 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1214 */
obj_t BGl_z62lambda1214z62zz__flac_decoderz00(obj_t BgL_envz00_710, obj_t BgL_oz00_711, obj_t BgL_vz00_712)
{
{ /* Llib/flac_decoder.scm 28 */
return 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_711)))->BgL_z52musicz52)=((obj_t)BgL_vz00_712),BUNSPEC);} 

}



/* &lambda1213 */
obj_t BGl_z62lambda1213z62zz__flac_decoderz00(obj_t BgL_envz00_713, obj_t BgL_oz00_714)
{
{ /* Llib/flac_decoder.scm 28 */
return 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_714)))->BgL_z52musicz52);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1972z00zz__flac_decoderz00, BGl_string1973z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1974z00zz__flac_decoderz00, BGl_string1975z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1976z00zz__flac_decoderz00, BGl_string1977z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1978z00zz__flac_decoderz00, BGl_string1979z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1980z00zz__flac_decoderz00, BGl_string1981z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1982z00zz__flac_decoderz00, BGl_string1983z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1984z00zz__flac_decoderz00, BGl_string1985z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00, BGl_proc1986z00zz__flac_decoderz00, BGl_string1987z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1988z00zz__flac_decoderz00, BGl_string1989z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1990z00zz__flac_decoderz00, BGl_string1991z00zz__flac_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1992z00zz__flac_decoderz00, BGl_string1993z00zz__flac_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00, BGl_proc1994z00zz__flac_decoderz00, BGl_string1995z00zz__flac_decoderz00);} 

}



/* &flac-decoder-length-1153 */
obj_t BGl_z62flaczd2decoderzd2lengthzd21153zb0zz__flac_decoderz00(obj_t BgL_envz00_735, obj_t BgL_oz00_736)
{
{ /* Llib/flac_decoder.scm 274 */
{ /* Llib/flac_decoder.scm 276 */
BgL_flacmusicdecoderz00_bglt BgL_i1120z00_858;
BgL_i1120z00_858 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_736)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 277 */
BgL_flacdecz00_bglt BgL_i1121z00_859;
BgL_i1121z00_859 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1120z00_858))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 278 */
obj_t BgL_arg1796z00_860;
BgL_arg1796z00_860 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1121z00_859))->BgL_z52bufferz52); 
return 
BGl_musicbufferzd2lengthzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1796z00_860));} } } } 

}



/* &flac-decoder-seek-fl1151 */
obj_t BGl_z62flaczd2decoderzd2seekzd2fl1151zb0zz__flac_decoderz00(obj_t BgL_envz00_737, obj_t BgL_oz00_738, obj_t BgL_offz00_739)
{
{ /* Llib/flac_decoder.scm 263 */
{ /* Llib/flac_decoder.scm 265 */
BgL_flacmusicdecoderz00_bglt BgL_i1118z00_862;
BgL_i1118z00_862 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_738)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 266 */
bool_t BgL_test2074z00_1315;
{ /* Llib/flac_decoder.scm 266 */
obj_t BgL_arg1795z00_863;
BgL_arg1795z00_863 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_738)))->BgL_z52bufferz52); 
BgL_test2074z00_1315 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1795z00_863, BGl_musicbufferz00zz__multimediazd2musicbufzd2); } 
if(BgL_test2074z00_1315)
{ /* Llib/flac_decoder.scm 266 */
{ /* Llib/flac_decoder.scm 267 */
obj_t BgL_arg1794z00_864;
BgL_arg1794z00_864 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_738)))->BgL_z52bufferz52); 
BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1794z00_864), BgL_offz00_739); } 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1118z00_862))->BgL_z52inseekz52)=((obj_t)BFALSE),BUNSPEC); 
return BTRUE;}  else 
{ /* Llib/flac_decoder.scm 266 */
return BFALSE;} } } } 

}



/* &flac-decoder-tell-fl1149 */
obj_t BGl_z62flaczd2decoderzd2tellzd2fl1149zb0zz__flac_decoderz00(obj_t BgL_envz00_740, obj_t BgL_oz00_741)
{
{ /* Llib/flac_decoder.scm 253 */
{ /* Llib/flac_decoder.scm 255 */
BgL_flacmusicdecoderz00_bglt BgL_i1115z00_866;
BgL_i1115z00_866 = 
((BgL_flacmusicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_741)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 256 */
BgL_flacdecz00_bglt BgL_i1116z00_867;
BgL_i1116z00_867 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(BgL_i1115z00_866))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 257 */
bool_t BgL_test2075z00_1329;
{ /* Llib/flac_decoder.scm 257 */
obj_t BgL_arg1791z00_868;
BgL_arg1791z00_868 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1116z00_867))->BgL_z52bufferz52); 
BgL_test2075z00_1329 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1791z00_868, BGl_musicbufferz00zz__multimediazd2musicbufzd2); } 
if(BgL_test2075z00_1329)
{ /* Llib/flac_decoder.scm 258 */
obj_t BgL_arg1790z00_869;
BgL_arg1790z00_869 = 
(((BgL_flacdecz00_bglt)COBJECT(BgL_i1116z00_867))->BgL_z52bufferz52); 
return 
BGl_musicbufferzd2tellzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1790z00_869));}  else 
{ /* Llib/flac_decoder.scm 257 */
return BFALSE;} } } } } 

}



/* &flac-decoder-read-fl1147 */
obj_t BGl_z62flaczd2decoderzd2readzd2fl1147zb0zz__flac_decoderz00(obj_t BgL_envz00_742, obj_t BgL_oz00_743, obj_t BgL_siza7eza7_744)
{
{ /* Llib/flac_decoder.scm 143 */
{ /* Llib/flac_decoder.scm 144 */
long BgL_siza7eza7_871;
BgL_siza7eza7_871 = 
(long)CINT(BgL_siza7eza7_744); 
{ /* Llib/flac_decoder.scm 146 */
BgL_musicdecoderz00_bglt BgL_i1105z00_872;
BgL_i1105z00_872 = 
((BgL_musicdecoderz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52decoderz52)); 
{ /* Llib/flac_decoder.scm 147 */
BgL_musicbufferz00_bglt BgL_i1106z00_873;
BgL_i1106z00_873 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52bufferz52)); 
{ /* Llib/flac_decoder.scm 147 */
long BgL_inlenz00_874;
BgL_inlenz00_874 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52inlenz52); 
{ /* Llib/flac_decoder.scm 155 */
char * BgL_flacbufz00_875;
{ /* Llib/flac_decoder.scm 155 */
obj_t BgL_arg1787z00_876;
BgL_arg1787z00_876 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_743))))->BgL_z52flacbufz52); 
BgL_flacbufz00_875 = 
CUSTOM_IDENTIFIER(BgL_arg1787z00_876); } 
{ 

{ 

{ 
long BgL_siza7eza7_889;
{ 
long BgL_siza7eza7_896;long BgL_iz00_897;
BgL_siza7eza7_896 = BgL_siza7eza7_871; 
BgL_iz00_897 = ((long)0); 
BgL_loopz00_895:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52z12dpausez40))
{ /* Llib/flac_decoder.scm 202 */
{ /* Llib/flac_decoder.scm 203 */
obj_t BgL_arg1580z00_898;
BgL_arg1580z00_898 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1580z00_898), 
CNST_TABLE_REF(((long)14))); } 
{ /* Llib/flac_decoder.scm 205 */
BgL_musicz00_bglt BgL_i1110z00_899;
BgL_i1110z00_899 = 
((BgL_musicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52)); 
{ /* Llib/flac_decoder.scm 206 */
BgL_musicstatusz00_bglt BgL_i1111z00_900;
BgL_i1111z00_900 = 
(((BgL_musicz00_bglt)COBJECT(BgL_i1110z00_899))->BgL_z52statusz52); 
{ 
obj_t BgL_auxz00_1358;
{ /* Llib/flac_decoder.scm 208 */
obj_t BgL_arg1581z00_901;obj_t BgL_arg1582z00_902;
BgL_arg1581z00_901 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52decoderz52); 
BgL_arg1582z00_902 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52bufferz52); 
BgL_auxz00_1358 = 
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_arg1581z00_901), 
((BgL_musicbufferz00_bglt)BgL_arg1582z00_902))); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1111z00_900))->BgL_songposz00)=((obj_t)BgL_auxz00_1358),BUNSPEC); } } } 
{ /* Llib/flac_decoder.scm 209 */
obj_t BgL_mutex1583z00_903;
BgL_mutex1583z00_903 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1583z00_903); 
{ /* Llib/flac_decoder.scm 209 */
bool_t BgL_tmp2077z00_1369;
{ 

BgL_liipz00_904:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52z12dpausez40))
{ /* Llib/flac_decoder.scm 211 */
{ /* Llib/flac_decoder.scm 212 */
obj_t BgL_arg1591z00_905;obj_t BgL_arg1593z00_906;
BgL_arg1591z00_905 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52dcondvz52); 
BgL_arg1593z00_906 = 
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52dmutexz52); 
{ /* Llib/flac_decoder.scm 212 */

BGL_CONDVAR_WAIT(BgL_arg1591z00_905, BgL_arg1593z00_906); } } 
goto BgL_liipz00_904;}  else 
{ /* Llib/flac_decoder.scm 211 */
BgL_tmp2077z00_1369 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1583z00_903); BgL_tmp2077z00_1369; } } 
{ /* Llib/flac_decoder.scm 214 */
obj_t BgL_arg1615z00_907;
BgL_arg1615z00_907 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1615z00_907), 
CNST_TABLE_REF(((long)15))); } 
{ 

goto BgL_loopz00_895;} }  else 
{ /* Llib/flac_decoder.scm 202 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52z12dabortz40))
{ /* Llib/flac_decoder.scm 216 */
return 
BINT(((long)-1));}  else 
{ /* Llib/flac_decoder.scm 216 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 219 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 221 */
return BEOF;}  else 
{ /* Llib/flac_decoder.scm 221 */
{ /* Llib/flac_decoder.scm 224 */
BgL_musicz00_bglt BgL_i1112z00_908;
BgL_i1112z00_908 = 
((BgL_musicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52)); 
{ 
int BgL_auxz00_1392;
{ /* Llib/flac_decoder.scm 227 */
long BgL_tmpz00_1394;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1781z00_878;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1782z00_879;BGL_LONGLONG_T BgL_arg1783z00_880;
{ /* Llib/flac_decoder.scm 160 */
BGL_LONGLONG_T BgL_arg1784z00_881;
{ /* Llib/flac_decoder.scm 160 */
long BgL_arg1785z00_882;
{ /* Llib/flac_decoder.scm 160 */
obj_t BgL_arg1786z00_883;
BgL_arg1786z00_883 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52bufferz52); 
BgL_arg1785z00_882 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1786z00_883)); } 
BgL_arg1784z00_881 = 
LONG_TO_LLONG(BgL_arg1785z00_882); } 
BgL_arg1782z00_879 = 
(((BGL_LONGLONG_T)100)*BgL_arg1784z00_881); } 
BgL_arg1783z00_880 = 
LONG_TO_LLONG(BgL_inlenz00_874); 
BgL_arg1781z00_878 = 
(BgL_arg1782z00_879/BgL_arg1783z00_880); } 
BgL_tmpz00_1394 = 
LLONG_TO_LONG(BgL_arg1781z00_878); } 
BgL_auxz00_1392 = 
(int)(BgL_tmpz00_1394); } 
((((BgL_musicstatusz00_bglt)COBJECT(
(((BgL_musicz00_bglt)COBJECT(BgL_i1112z00_908))->BgL_z52statusz52)))->BgL_bufferingz00)=((int)BgL_auxz00_1392),BUNSPEC); } } 
{ /* Llib/flac_decoder.scm 228 */
obj_t BgL_arg1624z00_909;
BgL_arg1624z00_909 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1624z00_909), 
CNST_TABLE_REF(((long)16))); } 
{ /* Llib/flac_decoder.scm 229 */
obj_t BgL_mutex1625z00_910;
BgL_mutex1625z00_910 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52bmutexz52); 
{ /* Llib/flac_decoder.scm 229 */
obj_t BgL_top2083z00_1413;
BgL_top2083z00_1413 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1625z00_910); 
BGL_EXITD_PUSH_PROTECT(BgL_top2083z00_1413, BgL_mutex1625z00_910); BUNSPEC; 
{ /* Llib/flac_decoder.scm 229 */
bool_t BgL_tmp2082z00_1412;
{ /* Llib/flac_decoder.scm 231 */
bool_t BgL_test2084z00_1417;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 231 */
BgL_test2084z00_1417 = ((bool_t)1)
; }  else 
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(BgL_i1105z00_872))->BgL_z52z12dabortz40))
{ /* Llib/flac_decoder.scm 231 */
BgL_test2084z00_1417 = ((bool_t)1)
; }  else 
{ /* Llib/flac_decoder.scm 231 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52emptyz52))
{ /* Llib/flac_decoder.scm 165 */
BgL_test2084z00_1417 = ((bool_t)0)
; }  else 
{ /* Llib/flac_decoder.scm 166 */
long BgL_arg1777z00_885;
{ /* Llib/flac_decoder.scm 166 */
long BgL_arg1778z00_886;
{ /* Llib/flac_decoder.scm 166 */
obj_t BgL_arg1779z00_887;
BgL_arg1779z00_887 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52bufferz52); 
BgL_arg1778z00_886 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1779z00_887)); } 
BgL_arg1777z00_885 = 
(((long)4)*BgL_arg1778z00_886); } 
BgL_test2084z00_1417 = 
(BgL_arg1777z00_885>BgL_inlenz00_874); } } } }  else 
{ /* Llib/flac_decoder.scm 231 */
BgL_test2084z00_1417 = ((bool_t)1)
; } 
if(BgL_test2084z00_1417)
{ /* Llib/flac_decoder.scm 231 */
BgL_tmp2082z00_1412 = ((bool_t)0); }  else 
{ /* Llib/flac_decoder.scm 235 */
obj_t BgL_arg1636z00_911;obj_t BgL_arg1643z00_912;
BgL_arg1636z00_911 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52bcondvz52); 
BgL_arg1643z00_912 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52bmutexz52); 
{ /* Llib/flac_decoder.scm 235 */

BgL_tmp2082z00_1412 = 
BGL_CONDVAR_WAIT(BgL_arg1636z00_911, BgL_arg1643z00_912); } } } 
BGL_EXITD_POP_PROTECT(BgL_top2083z00_1413); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1625z00_910); BgL_tmp2082z00_1412; } } } 
{ /* Llib/flac_decoder.scm 236 */
obj_t BgL_arg1644z00_913;
BgL_arg1644z00_913 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52musicz52); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_arg1644z00_913), 
CNST_TABLE_REF(((long)15))); } 
{ 

goto BgL_loopz00_895;} } }  else 
{ /* Llib/flac_decoder.scm 239 */
long BgL_sz00_914;
{ /* Llib/flac_decoder.scm 239 */
long BgL_bz00_915;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52)))
{ /* Llib/flac_decoder.scm 240 */
BgL_bz00_915 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52)); }  else 
{ /* Llib/flac_decoder.scm 240 */
BgL_bz00_915 = 
(BgL_inlenz00_874-
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52)); } 
if(
(BgL_siza7eza7_896<BgL_bz00_915))
{ /* Llib/flac_decoder.scm 240 */
BgL_sz00_914 = BgL_siza7eza7_896; }  else 
{ /* Llib/flac_decoder.scm 240 */
BgL_sz00_914 = BgL_bz00_915; } } 
if(
(BgL_sz00_914>((long)0)))
{ /* Llib/flac_decoder.scm 243 */
{ /* Llib/flac_decoder.scm 244 */
char * BgL_arg1647z00_916;long BgL_arg1648z00_917;
BgL_arg1647z00_916 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52inbufpz52); 
BgL_arg1648z00_917 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52); 
BGL_FLAC_BLIT_STRING(BgL_arg1647z00_916, BgL_arg1648z00_917, BgL_flacbufz00_875, BgL_iz00_897, BgL_sz00_914); BUNSPEC; } 
BgL_siza7eza7_889 = BgL_sz00_914; 
{ /* Llib/flac_decoder.scm 174 */
long BgL_ntailz00_890;
BgL_ntailz00_890 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52)+BgL_siza7eza7_889); 
if(
(BgL_ntailz00_890==BgL_inlenz00_874))
{ /* Llib/flac_decoder.scm 175 */
BgL_ntailz00_890 = ((long)0); }  else 
{ /* Llib/flac_decoder.scm 175 */BFALSE; } 
if(
(BgL_ntailz00_890==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52headz52)))
{ /* Llib/flac_decoder.scm 178 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))<((long)80)))
{ /* Llib/flac_decoder.scm 179 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 179 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 178 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52tailz52)=((long)BgL_ntailz00_890),BUNSPEC); } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52eofz52))
{ /* Llib/flac_decoder.scm 183 */BFALSE; }  else 
{ /* Llib/flac_decoder.scm 186 */
long BgL_availz00_891;
{ /* Llib/flac_decoder.scm 186 */
obj_t BgL_arg1772z00_892;
BgL_arg1772z00_892 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52bufferz52); 
BgL_availz00_891 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_arg1772z00_892)); } 
{ /* Llib/flac_decoder.scm 186 */
long BgL_pz00_893;
BgL_pz00_893 = 
(
(BgL_availz00_891*((long)100))/BgL_inlenz00_874); 
{ /* Llib/flac_decoder.scm 187 */

if(
(BgL_pz00_893<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))))
{ /* Llib/flac_decoder.scm 189 */
{ /* Llib/flac_decoder.scm 169 */
obj_t BgL_mutex1774z00_894;
BgL_mutex1774z00_894 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1774z00_894); 
{ /* Llib/flac_decoder.scm 169 */
bool_t BgL_tmp2097z00_1489;
{ /* Llib/flac_decoder.scm 170 */
obj_t BgL_tmpz00_1491;
BgL_tmpz00_1491 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1106z00_873))->BgL_z52bcondvz52); 
BgL_tmp2097z00_1489 = 
BGL_CONDVAR_BROADCAST(BgL_tmpz00_1491); } 
BGL_MUTEX_UNLOCK(BgL_mutex1774z00_894); BgL_tmp2097z00_1489; } } 
{ /* Llib/flac_decoder.scm 191 */
bool_t BgL_test2098z00_1495;
if(
(BgL_pz00_893<=
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52lastzd2percentagez80))))
{ /* Llib/flac_decoder.scm 191 */
BgL_test2098z00_1495 = 
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))<
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratezd2maxz80)))
; }  else 
{ /* Llib/flac_decoder.scm 191 */
BgL_test2098z00_1495 = ((bool_t)0)
; } 
if(BgL_test2098z00_1495)
{ /* Llib/flac_decoder.scm 191 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))+((long)10)))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 191 */BFALSE; } } }  else 
{ /* Llib/flac_decoder.scm 189 */
if(
(BgL_pz00_893>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_decoder.scm 193 */
if(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))>
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratezd2minz80))))
{ /* Llib/flac_decoder.scm 194 */
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52)=((int)
(int)(
(
(long)(
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52ratez52))-((long)1)))),BUNSPEC); }  else 
{ /* Llib/flac_decoder.scm 194 */BFALSE; } }  else 
{ /* Llib/flac_decoder.scm 193 */BFALSE; } } 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_743)))->BgL_z52lastzd2percentagez80)=((int)
(int)(BgL_pz00_893)),BUNSPEC); BUNSPEC; } } } }  else 
{ /* Llib/flac_decoder.scm 243 */BFALSE; } 
if(
(BgL_sz00_914<BgL_siza7eza7_896))
{ 
long BgL_iz00_1542;long BgL_siza7eza7_1540;
BgL_siza7eza7_1540 = 
(BgL_siza7eza7_896-BgL_sz00_914); 
BgL_iz00_1542 = 
(BgL_iz00_897+BgL_sz00_914); 
BgL_iz00_897 = BgL_iz00_1542; 
BgL_siza7eza7_896 = BgL_siza7eza7_1540; 
goto BgL_loopz00_895;}  else 
{ /* Llib/flac_decoder.scm 246 */
return 
BINT(
(BgL_iz00_897+BgL_sz00_914));} } } } } } } } } } } } } } 

}



/* &musicdecoder-seek-fl1145 */
obj_t BGl_z62musicdecoderzd2seekzd2fl1145z62zz__flac_decoderz00(obj_t BgL_envz00_745, obj_t BgL_oz00_746, obj_t BgL_secz00_747)
{
{ /* Llib/flac_decoder.scm 130 */
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_746)))->BgL_z52inseekz52)))
{ /* Llib/flac_decoder.scm 132 */
return BFALSE;}  else 
{ /* Llib/flac_decoder.scm 132 */
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_746)))->BgL_z52inseekz52)=((obj_t)BTRUE),BUNSPEC); 
{ /* Llib/flac_decoder.scm 134 */
BgL_flacdecz00_bglt BgL_i1103z00_919;
BgL_i1103z00_919 = 
((BgL_flacdecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_746)))->BgL_z52flacz52)); 
{ /* Llib/flac_decoder.scm 135 */
unsigned long BgL_bpsz00_920;
{ /* Llib/flac_decoder.scm 135 */
FLAC__StreamDecoder * BgL_arg1564z00_921;
BgL_arg1564z00_921 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_919)))->BgL_z42builtinz42); 
BgL_bpsz00_920 = 
FLAC__stream_decoder_get_bits_per_sample(BgL_arg1564z00_921); } 
{ /* Llib/flac_decoder.scm 135 */
unsigned long BgL_sratez00_922;
{ /* Llib/flac_decoder.scm 136 */
FLAC__StreamDecoder * BgL_arg1563z00_923;
BgL_arg1563z00_923 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_919)))->BgL_z42builtinz42); 
BgL_sratez00_922 = 
FLAC__stream_decoder_get_sample_rate(BgL_arg1563z00_923); } 
{ /* Llib/flac_decoder.scm 136 */
BGL_LONGLONG_T BgL_offz00_924;
{ /* Llib/flac_decoder.scm 137 */
BGL_LONGLONG_T BgL_arg1544z00_925;BGL_LONGLONG_T BgL_arg1562z00_926;
{ /* Llib/flac_decoder.scm 137 */
long BgL_tmpz00_1561;
BgL_tmpz00_1561 = 
(long)(BgL_sratez00_922); 
BgL_arg1544z00_925 = 
LONG_TO_LLONG(BgL_tmpz00_1561); } 
{ /* Llib/flac_decoder.scm 137 */
long BgL_tmpz00_1564;
BgL_tmpz00_1564 = 
(long)CINT(BgL_secz00_747); 
BgL_arg1562z00_926 = 
LONG_TO_LLONG(BgL_tmpz00_1564); } 
BgL_offz00_924 = 
(BgL_arg1544z00_925*BgL_arg1562z00_926); } 
{ /* Llib/flac_decoder.scm 137 */

{ /* Llib/flac_decoder.scm 138 */
FLAC__StreamDecoder * BgL_arg1543z00_927;
BgL_arg1543z00_927 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_i1103z00_919)))->BgL_z42builtinz42); 
{ /* Llib/flac_decoder.scm 138 */
long BgL_tmpz00_1570;
{ /* Llib/flac_decoder.scm 138 */
unsigned BGL_LONGLONG_T BgL_tmpz00_1571;
BgL_tmpz00_1571 = 
(unsigned BGL_LONGLONG_T)(BgL_offz00_924); 
BgL_tmpz00_1570 = 
FLAC__stream_decoder_seek_absolute(BgL_arg1543z00_927, BgL_tmpz00_1571); } 
return 
BINT(BgL_tmpz00_1570);} } } } } } } } } 

}



/* &musicdecoder-volume-1143 */
obj_t BGl_z62musicdecoderzd2volumezd21143z62zz__flac_decoderz00(obj_t BgL_envz00_748, obj_t BgL_oz00_749, obj_t BgL_volz00_750)
{
{ /* Llib/flac_decoder.scm 123 */
{ /* Llib/flac_decoder.scm 125 */
obj_t BgL_arg1540z00_929;
BgL_arg1540z00_929 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_749)))->BgL_z52flacz52); 
return 
BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1540z00_929), BgL_volz00_750);} } 

}



/* &musicdecoder-info-fl1141 */
obj_t BGl_z62musicdecoderzd2infozd2fl1141z62zz__flac_decoderz00(obj_t BgL_envz00_751, obj_t BgL_oz00_752)
{
{ /* Llib/flac_decoder.scm 116 */
{ /* Llib/flac_decoder.scm 117 */
long BgL_tmpz00_1579;
{ /* Llib/flac_decoder.scm 118 */
obj_t BgL_arg1539z00_931;
BgL_arg1539z00_931 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_752)))->BgL_z52flacz52); 
BgL_tmpz00_1579 = 
BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1539z00_931)); } 
return 
BINT(BgL_tmpz00_1579);} } 

}



/* &musicdecoder-positio1139 */
obj_t BGl_z62musicdecoderzd2positio1139zb0zz__flac_decoderz00(obj_t BgL_envz00_753, obj_t BgL_oz00_754, obj_t BgL_abufz00_755)
{
{ /* Llib/flac_decoder.scm 109 */
{ /* Llib/flac_decoder.scm 110 */
long BgL_tmpz00_1585;
{ /* Llib/flac_decoder.scm 111 */
obj_t BgL_arg1538z00_933;
BgL_arg1538z00_933 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_754)))->BgL_z52flacz52); 
BgL_tmpz00_1585 = 
BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1538z00_933)); } 
return 
BINT(BgL_tmpz00_1585);} } 

}



/* &musicdecoder-reset!-1137 */
obj_t BGl_z62musicdecoderzd2resetz12zd21137z70zz__flac_decoderz00(obj_t BgL_envz00_756, obj_t BgL_oz00_757)
{
{ /* Llib/flac_decoder.scm 101 */
{ 

{ /* Llib/flac_decoder.scm 103 */
obj_t BgL_arg1531z00_937;
BgL_arg1531z00_937 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_757)))->BgL_z52flacz52); 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1531z00_937)); } 
{ /* Llib/flac_decoder.scm 101 */
obj_t BgL_nextzd2method1136zd2_936;
BgL_nextzd2method1136zd2_936 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_757)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_flacmusicdecoderz00zz__flac_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1136zd2_936)(BgL_nextzd2method1136zd2_936, 
((obj_t)
((BgL_flacmusicdecoderz00_bglt)BgL_oz00_757)), BEOA);} } } 

}



/* &flac-decoder-write-f1135 */
obj_t BGl_z62flaczd2decoderzd2writezd2f1135zb0zz__flac_decoderz00(obj_t BgL_envz00_758, obj_t BgL_oz00_759, obj_t BgL_siza7eza7_760, obj_t BgL_ratez00_761, obj_t BgL_channelsz00_762, obj_t BgL_bpsz00_763)
{
{ /* Llib/flac_decoder.scm 92 */
if(
(
(long)CINT(BgL_siza7eza7_760)>((long)0)))
{ /* Llib/flac_decoder.scm 94 */
{ /* Llib/flac_decoder.scm 95 */
obj_t BgL_arg1524z00_939;obj_t BgL_arg1530z00_940;
BgL_arg1524z00_939 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_759)))->BgL_z52musicz52); 
BgL_arg1530z00_940 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_759))))->BgL_outbufz00); 
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_arg1524z00_939), BgL_arg1530z00_940, 
(long)CINT(BgL_siza7eza7_760)); } 
return BTRUE;}  else 
{ /* Llib/flac_decoder.scm 94 */
return BFALSE;} } 

}



/* &flac-decoder-reset!-1133 */
obj_t BGl_z62flaczd2decoderzd2resetz12zd21133za2zz__flac_decoderz00(obj_t BgL_envz00_764, obj_t BgL_oz00_765)
{
{ /* Llib/flac_decoder.scm 81 */
{ 

((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_765)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_oz00_765)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_765))))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_765))))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
{ /* Llib/flac_decoder.scm 81 */
obj_t BgL_nextzd2method1132zd2_943;
BgL_nextzd2method1132zd2_943 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flacdecz00_bglt)BgL_oz00_765)), BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BGl_flacdecz00zz__flac_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1132zd2_943)(BgL_nextzd2method1132zd2_943, 
((obj_t)
((BgL_flacdecz00_bglt)BgL_oz00_765)), BEOA);} } } 

}



/* &musicdecoder-init-fl1131 */
obj_t BGl_z62musicdecoderzd2initzd2fl1131z62zz__flac_decoderz00(obj_t BgL_envz00_766, obj_t BgL_decz00_767)
{
{ /* Llib/flac_decoder.scm 73 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_decz00_767))))->BgL_mimetypesz00)))
{ /* Llib/flac_decoder.scm 75 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flacmusicdecoderz00_bglt)BgL_decz00_767))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC);}  else 
{ /* Llib/flac_decoder.scm 75 */
return BFALSE;} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_decoderz00()
{
{ /* Llib/flac_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1996z00zz__flac_decoderz00));} 

}

#ifdef __cplusplus
}
#endif
