/*===========================================================================*/
/*   (Llib/flac_padec.scm)                                                   */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi flac -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/flac_padec.scm -o objs/flac_padec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <pulse/error.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>
#include <pulse/simple.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_flacdecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacdecz00_bglt;

typedef struct BgL_flacmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flacmusicdecoderz00_bglt;

typedef struct BgL_flacpadecz00_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
   obj_t BgL_z52musicz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52decoderz52;
   int BgL_z52ratez52;
   int BgL_z52ratezd2maxz80;
   int BgL_z52ratezd2minz80;
   int BgL_z52lastzd2percentagez80;
} *BgL_flacpadecz00_bglt;

typedef struct BgL_flaczd2pulseaudiodecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_z52flacz52;
   obj_t BgL_z52inseekz52;
} *BgL_flaczd2pulseaudiodecoderzd2_bglt;


BGL_IMPORT obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__flac_padecz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__flac_padecz00();
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_padecz00();
static obj_t BGl_objectzd2initzd2zz__flac_padecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_padecz00();
static obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_padecz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00(obj_t, obj_t);
extern obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DEF obj_t BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_padecz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31169ze3ze5zz__flac_padecz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_padecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
static BgL_flacpadecz00_bglt BGl_z62lambda1160z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flacpadecz00_bglt BGl_z62lambda1166z62zz__flac_padecz00(obj_t);
static BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1179z62zz__flac_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1182z62zz__flac_padecz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_padecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_padecz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__flac_padecz00();
static obj_t BGl_gczd2rootszd2initz00zz__flac_padecz00();
BGL_IMPORT obj_t bgl_custom_nil();
BGL_IMPORT int bgl_pulseaudio_error(char *, char *, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_flacpadecz00zz__flac_padecz00 = BUNSPEC;
extern obj_t BGl_flacdecz00zz__flac_decoderz00;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
extern obj_t BGl_flacmusicdecoderz00zz__flac_decoderz00;
static obj_t __cnst[ 6 ] ;


DEFINE_STRING( BGl_string1255z00zz__flac_padecz00, BgL_bgl_string1255za700za7za7_1278za7, "Llib/flac_padec.scm", 19 );
DEFINE_STRING( BGl_string1262z00zz__flac_padecz00, BgL_bgl_string1262za700za7za7_1279za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1256z00zz__flac_padecz00, BgL_bgl_za762za7c3za704anonymo1280za7, BGl_z62zc3z04anonymousza31169ze3ze5zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1257z00zz__flac_padecz00, BgL_bgl_za762lambda1166za7621281z00, BGl_z62lambda1166z62zz__flac_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1264z00zz__flac_padecz00, BgL_bgl_string1264za700za7za7_1282za7, "musicdecoder-init", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1258z00zz__flac_padecz00, BgL_bgl_za762lambda1160za7621283z00, BGl_z62lambda1160z62zz__flac_padecz00, 0L, BUNSPEC, 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1259z00zz__flac_padecz00, BgL_bgl_za762za7c3za704anonymo1284za7, BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1266z00zz__flac_padecz00, BgL_bgl_string1266za700za7za7_1285za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string1268z00zz__flac_padecz00, BgL_bgl_string1268za700za7za7_1286za7, "flac-decoder-metadata", 21 );
DEFINE_STRING( BGl_string1269z00zz__flac_padecz00, BgL_bgl_string1269za700za7za7_1287za7, "pulseaudio-simple-flush", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1260z00zz__flac_padecz00, BgL_bgl_za762lambda1182za7621288z00, BGl_z62lambda1182z62zz__flac_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1261z00zz__flac_padecz00, BgL_bgl_za762lambda1179za7621289z00, BGl_z62lambda1179z62zz__flac_padecz00, 0L, BUNSPEC, 12 );
BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1263z00zz__flac_padecz00, BgL_bgl_za762musicdecoderza71290z00, BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1270z00zz__flac_padecz00, BgL_bgl_string1270za700za7za7_1291za7, "__flac_padec", 12 );
DEFINE_STRING( BGl_string1271z00zz__flac_padecz00, BgL_bgl_string1271za700za7za7_1292za7, "stop ended s16 flac-pulseaudiodecoder __flac_padec flacpadec ", 61 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1265z00zz__flac_padecz00, BgL_bgl_za762musicdecoderza71293z00, BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1267z00zz__flac_padecz00, BgL_bgl_za762flacza7d2decode1294z00, BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00, 0L, BUNSPEC, 5 );
extern obj_t BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00;
extern obj_t BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_padecz00) );
ADD_ROOT( (void *)(&BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00) );
ADD_ROOT( (void *)(&BGl_flacpadecz00zz__flac_padecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_padecz00(long BgL_checksumz00_380, char * BgL_fromz00_381)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_padecz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_padecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__flac_padecz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_padecz00(); 
BGl_cnstzd2initzd2zz__flac_padecz00(); 
BGl_importedzd2moduleszd2initz00zz__flac_padecz00(); 
BGl_objectzd2initzd2zz__flac_padecz00(); 
BGl_methodzd2initzd2zz__flac_padecz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_padecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_padec"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_padec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_cportz00_278;
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_stringz00_286;
BgL_stringz00_286 = BGl_string1271z00zz__flac_padecz00; 
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_startz00_287;
BgL_startz00_287 = 
BINT(((long)0)); 
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_endz00_288;
BgL_endz00_288 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_286))); 
{ /* Llib/flac_padec.scm 15 */

BgL_cportz00_278 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_286, BgL_startz00_287, BgL_endz00_288); } } } } 
{ 
long BgL_iz00_279;
BgL_iz00_279 = ((long)5); 
BgL_loopz00_280:
if(
(BgL_iz00_279==((long)-1)))
{ /* Llib/flac_padec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 15 */
obj_t BgL_arg1277z00_282;
{ /* Llib/flac_padec.scm 15 */

{ /* Llib/flac_padec.scm 15 */
obj_t BgL_locationz00_284;
BgL_locationz00_284 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac_padec.scm 15 */

BgL_arg1277z00_282 = 
BGl_readz00zz__readerz00(BgL_cportz00_278, BgL_locationz00_284); } } } 
{ /* Llib/flac_padec.scm 15 */
int BgL_tmpz00_415;
BgL_tmpz00_415 = 
(int)(BgL_iz00_279); 
CNST_TABLE_SET(BgL_tmpz00_415, BgL_arg1277z00_282); } } 
{ /* Llib/flac_padec.scm 15 */
int BgL_auxz00_285;
BgL_auxz00_285 = 
(int)(
(BgL_iz00_279-((long)1))); 
{ 
long BgL_iz00_420;
BgL_iz00_420 = 
(long)(BgL_auxz00_285); 
BgL_iz00_279 = BgL_iz00_420; 
goto BgL_loopz00_280;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), 
BSTRING_TO_STRING(BGl_string1255z00zz__flac_padecz00)); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1255z00zz__flac_padecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_arg1158z00_23;obj_t BgL_arg1159z00_24;
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_v1136z00_51;
BgL_v1136z00_51 = 
create_vector(((long)0)); 
BgL_arg1158z00_23 = BgL_v1136z00_51; } 
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_v1137z00_52;
BgL_v1137z00_52 = 
create_vector(((long)0)); 
BgL_arg1159z00_24 = BgL_v1137z00_52; } 
BGl_flacpadecz00zz__flac_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_flacdecz00zz__flac_decoderz00, ((long)11770), BGl_proc1258z00zz__flac_padecz00, BGl_proc1257z00zz__flac_padecz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1256z00zz__flac_padecz00, BFALSE, BgL_arg1158z00_23, BgL_arg1159z00_24); } 
{ /* Llib/flac_padec.scm 35 */
obj_t BgL_arg1176z00_59;obj_t BgL_arg1178z00_60;
{ /* Llib/flac_padec.scm 35 */
obj_t BgL_v1138z00_83;
BgL_v1138z00_83 = 
create_vector(((long)0)); 
BgL_arg1176z00_59 = BgL_v1138z00_83; } 
{ /* Llib/flac_padec.scm 35 */
obj_t BgL_v1139z00_84;
BgL_v1139z00_84 = 
create_vector(((long)0)); 
BgL_arg1178z00_60 = BgL_v1139z00_84; } 
return ( 
BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)2)), 
CNST_TABLE_REF(((long)1)), BGl_flacmusicdecoderz00zz__flac_decoderz00, ((long)38574), BGl_proc1261z00zz__flac_padecz00, BGl_proc1260z00zz__flac_padecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1259z00zz__flac_padecz00, BFALSE, BgL_arg1176z00_59, BgL_arg1178z00_60), BUNSPEC) ;} } 

}



/* &<@anonymous:1184> */
obj_t BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_padecz00(obj_t BgL_envz00_208, obj_t BgL_new1113z00_209)
{
{ /* Llib/flac_padec.scm 35 */
{ 
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_auxz00_437;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52flacz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209))))->BgL_z52inseekz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_437 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_new1113z00_209); 
return 
((obj_t)BgL_auxz00_437);} } 

}



/* &lambda1182 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1182z62zz__flac_padecz00(obj_t BgL_envz00_210)
{
{ /* Llib/flac_padec.scm 35 */
{ /* Llib/flac_padec.scm 35 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1112z00_291;
BgL_new1112z00_291 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/flac_padec.scm 35 */
long BgL_arg1183z00_292;
BgL_arg1183z00_292 = 
BGL_CLASS_INDEX(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1112z00_291), BgL_arg1183z00_292); } 
return BgL_new1112z00_291;} } 

}



/* &lambda1179 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BGl_z62lambda1179z62zz__flac_padecz00(obj_t BgL_envz00_211, obj_t BgL_mimetypes1100z00_212, obj_t BgL_bufferzd2timezd2near1101z00_213, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1102z75_214, obj_t BgL_periodzd2siza7ezd2nearzd2rat1103z75_215, obj_t BgL_z52z12dpause1104z40_216, obj_t BgL_z52z12dabort1105z40_217, obj_t BgL_z52z12stop1106z40_218, obj_t BgL_z52dmutex1107z52_219, obj_t BgL_z52dcondv1108z52_220, obj_t BgL_z52doutcondv1109z52_221, obj_t BgL_z52flac1110z52_222, obj_t BgL_z52inseek1111z52_223)
{
{ /* Llib/flac_padec.scm 35 */
{ /* Llib/flac_padec.scm 35 */
int BgL_bufferzd2timezd2near1101z00_294;int BgL_bufferzd2siza7ezd2nearzd2rat1102z75_295;int BgL_periodzd2siza7ezd2nearzd2rat1103z75_296;bool_t BgL_z52z12dpause1104z40_297;bool_t BgL_z52z12dabort1105z40_298;bool_t BgL_z52z12stop1106z40_299;
BgL_bufferzd2timezd2near1101z00_294 = 
CINT(BgL_bufferzd2timezd2near1101z00_213); 
BgL_bufferzd2siza7ezd2nearzd2rat1102z75_295 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1102z75_214); 
BgL_periodzd2siza7ezd2nearzd2rat1103z75_296 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1103z75_215); 
BgL_z52z12dpause1104z40_297 = 
CBOOL(BgL_z52z12dpause1104z40_216); 
BgL_z52z12dabort1105z40_298 = 
CBOOL(BgL_z52z12dabort1105z40_217); 
BgL_z52z12stop1106z40_299 = 
CBOOL(BgL_z52z12stop1106z40_218); 
{ /* Llib/flac_padec.scm 35 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1135z00_303;
{ /* Llib/flac_padec.scm 35 */
BgL_flaczd2pulseaudiodecoderzd2_bglt BgL_new1134z00_304;
BgL_new1134z00_304 = 
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/flac_padec.scm 35 */
long BgL_arg1181z00_305;
BgL_arg1181z00_305 = 
BGL_CLASS_INDEX(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_304), BgL_arg1181z00_305); } 
BgL_new1135z00_303 = BgL_new1134z00_304; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1100z00_212)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1101z00_294),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1102z75_295),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1103z75_296),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1104z40_297),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1105z40_298),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1106z40_299),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1107z52_219)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1108z52_220)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1109z52_221)),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52flacz52)=((obj_t)BgL_z52flac1110z52_222),BUNSPEC); 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)BgL_new1135z00_303)))->BgL_z52inseekz52)=((obj_t)BgL_z52inseek1111z52_223),BUNSPEC); 
{ /* Llib/flac_padec.scm 35 */
obj_t BgL_fun1180z00_306;
BgL_fun1180z00_306 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1180z00_306)(BgL_fun1180z00_306, 
((obj_t)BgL_new1135z00_303), BEOA); } 
return BgL_new1135z00_303;} } } 

}



/* &<@anonymous:1169> */
obj_t BGl_z62zc3z04anonymousza31169ze3ze5zz__flac_padecz00(obj_t BgL_envz00_224, obj_t BgL_new1098z00_225)
{
{ /* Llib/flac_padec.scm 26 */
{ 
BgL_flacpadecz00_bglt BgL_auxz00_530;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52flacbufz52)=((obj_t)
bgl_custom_nil()),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_outbufz00)=((obj_t)BGl_string1262z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52musicz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52ratezd2minz80)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_new1098z00_225))))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_530 = 
((BgL_flacpadecz00_bglt)BgL_new1098z00_225); 
return 
((obj_t)BgL_auxz00_530);} } 

}



/* &lambda1166 */
BgL_flacpadecz00_bglt BGl_z62lambda1166z62zz__flac_padecz00(obj_t BgL_envz00_226)
{
{ /* Llib/flac_padec.scm 26 */
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1097z00_308;
BgL_new1097z00_308 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 26 */
long BgL_arg1168z00_309;
BgL_arg1168z00_309 = 
BGL_CLASS_INDEX(BGl_flacpadecz00zz__flac_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_308), BgL_arg1168z00_309); } 
return BgL_new1097z00_308;} } 

}



/* &lambda1160 */
BgL_flacpadecz00_bglt BGl_z62lambda1160z62zz__flac_padecz00(obj_t BgL_envz00_227, obj_t BgL_z42builtin1081z42_228, obj_t BgL_z52flacbuf1082z52_229, obj_t BgL_outbuf1083z00_230, obj_t BgL_z52eof1084z52_231, obj_t BgL_z52sample1085z52_232, obj_t BgL_z52volume1086z52_233, obj_t BgL_md5check1087z00_234, obj_t BgL_z52bchecksum1088z52_235, obj_t BgL_z52rchecksum1089z52_236, obj_t BgL_z52music1090z52_237, obj_t BgL_z52buffer1091z52_238, obj_t BgL_z52decoder1092z52_239, obj_t BgL_z52rate1093z52_240, obj_t BgL_z52ratezd2max1094z80_241, obj_t BgL_z52ratezd2min1095z80_242, obj_t BgL_z52lastzd2percentage1096z80_243)
{
{ /* Llib/flac_padec.scm 26 */
{ /* Llib/flac_padec.scm 26 */
FLAC__StreamDecoder * BgL_z42builtin1081z42_310;bool_t BgL_z52eof1084z52_313;long BgL_z52sample1085z52_314;double BgL_z52volume1086z52_315;bool_t BgL_md5check1087z00_316;int BgL_z52bchecksum1088z52_317;int BgL_z52rchecksum1089z52_318;int BgL_z52rate1093z52_319;int BgL_z52ratezd2max1094z80_320;int BgL_z52ratezd2min1095z80_321;int BgL_z52lastzd2percentage1096z80_322;
BgL_z42builtin1081z42_310 = 
FOREIGN_TO_COBJ(BgL_z42builtin1081z42_228); 
BgL_z52eof1084z52_313 = 
CBOOL(BgL_z52eof1084z52_231); 
BgL_z52sample1085z52_314 = 
(long)CINT(BgL_z52sample1085z52_232); 
BgL_z52volume1086z52_315 = 
REAL_TO_DOUBLE(BgL_z52volume1086z52_233); 
BgL_md5check1087z00_316 = 
CBOOL(BgL_md5check1087z00_234); 
BgL_z52bchecksum1088z52_317 = 
CINT(BgL_z52bchecksum1088z52_235); 
BgL_z52rchecksum1089z52_318 = 
CINT(BgL_z52rchecksum1089z52_236); 
BgL_z52rate1093z52_319 = 
CINT(BgL_z52rate1093z52_240); 
BgL_z52ratezd2max1094z80_320 = 
CINT(BgL_z52ratezd2max1094z80_241); 
BgL_z52ratezd2min1095z80_321 = 
CINT(BgL_z52ratezd2min1095z80_242); 
BgL_z52lastzd2percentage1096z80_322 = 
CINT(BgL_z52lastzd2percentage1096z80_243); 
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1133z00_323;
{ /* Llib/flac_padec.scm 26 */
BgL_flacpadecz00_bglt BgL_new1132z00_324;
BgL_new1132z00_324 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 26 */
long BgL_arg1165z00_325;
BgL_arg1165z00_325 = 
BGL_CLASS_INDEX(BGl_flacpadecz00zz__flac_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1132z00_324), BgL_arg1165z00_325); } 
BgL_new1133z00_323 = BgL_new1132z00_324; } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_z42builtin1081z42_310),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52flacbufz52)=((obj_t)
((obj_t)BgL_z52flacbuf1082z52_229)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1083z00_230)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52eofz52)=((bool_t)BgL_z52eof1084z52_313),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52samplez52)=((long)BgL_z52sample1085z52_314),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52volumez52)=((double)BgL_z52volume1086z52_315),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_md5checkz00)=((bool_t)BgL_md5check1087z00_316),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52bchecksumz52)=((int)BgL_z52bchecksum1088z52_317),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1133z00_323)))->BgL_z52rchecksumz52)=((int)BgL_z52rchecksum1089z52_318),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52musicz52)=((obj_t)BgL_z52music1090z52_237),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1091z52_238),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1092z52_239),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52ratez52)=((int)BgL_z52rate1093z52_319),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52ratezd2maxz80)=((int)BgL_z52ratezd2max1094z80_320),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52ratezd2minz80)=((int)BgL_z52ratezd2min1095z80_321),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1133z00_323)))->BgL_z52lastzd2percentagez80)=((int)BgL_z52lastzd2percentage1096z80_322),BUNSPEC); 
{ /* Llib/flac_padec.scm 26 */
obj_t BgL_fun1161z00_326;
BgL_fun1161z00_326 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1161z00_326)(BgL_fun1161z00_326, 
((obj_t)BgL_new1133z00_323), BEOA); } 
return BgL_new1133z00_323;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00, BGl_proc1263z00zz__flac_padecz00, BGl_string1264z00zz__flac_padecz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00, BGl_proc1265z00zz__flac_padecz00, BGl_string1266z00zz__flac_padecz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BGl_flacpadecz00zz__flac_padecz00, BGl_proc1267z00zz__flac_padecz00, BGl_string1268z00zz__flac_padecz00);} 

}



/* &flac-decoder-metadat1145 */
obj_t BGl_z62flaczd2decoderzd2metadat1145z62zz__flac_padecz00(obj_t BgL_envz00_252, obj_t BgL_oz00_253, obj_t BgL_totalz00_254, obj_t BgL_ratez00_255, obj_t BgL_channelsz00_256, obj_t BgL_bpsz00_257)
{
{ /* Llib/flac_padec.scm 78 */
{ /* Llib/flac_padec.scm 80 */
BgL_pulseaudiomusicz00_bglt BgL_i1129z00_328;
BgL_i1129z00_328 = 
((BgL_pulseaudiomusicz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_oz00_253))))->BgL_z52musicz52)); 
{ /* Llib/flac_padec.scm 81 */
obj_t BgL_arg1238z00_329;BgL_pulseaudiozd2simplezd2_bglt BgL_arg1239z00_330;
BgL_arg1238z00_329 = 
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)
((BgL_flacpadecz00_bglt)BgL_oz00_253))))->BgL_z52musicz52); 
{ /* Llib/flac_padec.scm 82 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1131z00_331;
{ /* Llib/flac_padec.scm 82 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1130z00_332;
BgL_new1130z00_332 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/flac_padec.scm 82 */
long BgL_arg1244z00_333;
BgL_arg1244z00_333 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1130z00_332), BgL_arg1244z00_333); } 
BgL_new1131z00_331 = BgL_new1130z00_332; } 
{ 
void * BgL_auxz00_662;
{ /* Llib/flac_padec.scm 82 */
obj_t BgL_arg1240z00_334;
{ /* Llib/flac_padec.scm 82 */
obj_t BgL_arg1241z00_335;
{ /* Llib/flac_padec.scm 82 */
obj_t BgL_classz00_336;
BgL_classz00_336 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_arg1241z00_335 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_336); } 
BgL_arg1240z00_334 = 
VECTOR_REF(BgL_arg1241z00_335,((long)0)); } 
BgL_auxz00_662 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1240z00_334)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_662),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_namez00)=((obj_t)
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_i1129z00_328))->BgL_namez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_ratez00)=((long)
(long)CINT(BgL_ratez00_255)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_channelsz00)=((long)
(long)CINT(BgL_channelsz00_256)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_bpsz00)=((int)
CINT(BgL_bpsz00_257)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1131z00_331))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)3))),BUNSPEC); 
{ /* Llib/flac_padec.scm 82 */
obj_t BgL_fun1242z00_337;
BgL_fun1242z00_337 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1242z00_337)(BgL_fun1242z00_337, 
((obj_t)BgL_new1131z00_331), BEOA); } 
BgL_arg1239z00_330 = BgL_new1131z00_331; } 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(
((BgL_pulseaudiomusicz00_bglt)BgL_arg1238z00_329), BgL_arg1239z00_330);} } } 

}



/* &musicdecoder-decode-1143 */
obj_t BGl_z62musicdecoderzd2decodezd21143z62zz__flac_padecz00(obj_t BgL_envz00_258, obj_t BgL_decz00_259, obj_t BgL_amz00_260, obj_t BgL_bufferz00_261)
{
{ /* Llib/flac_padec.scm 55 */
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))))->BgL_z52flacz52)))
{ /* Llib/flac_padec.scm 59 */BFALSE; }  else 
{ 
obj_t BgL_auxz00_693;
{ /* Llib/flac_padec.scm 59 */
BgL_flacpadecz00_bglt BgL_new1119z00_341;
{ /* Llib/flac_padec.scm 59 */
BgL_flacpadecz00_bglt BgL_new1118z00_342;
BgL_new1118z00_342 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 59 */
long BgL_arg1217z00_343;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_classz00_344;
BgL_classz00_344 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1217z00_343 = 
BGL_CLASS_INDEX(BgL_classz00_344); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_342), BgL_arg1217z00_343); } 
BgL_new1119z00_341 = BgL_new1118z00_342; } 
{ 
void * BgL_auxz00_700;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_arg1201z00_345;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_arg1206z00_346;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_classz00_347;
BgL_classz00_347 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1206z00_346 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_347); } 
BgL_arg1201z00_345 = 
VECTOR_REF(BgL_arg1206z00_346,((long)0)); } 
BgL_auxz00_700 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1201z00_345)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_700),BUNSPEC); } 
{ 
obj_t BgL_auxz00_707;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_arg1209z00_348;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_arg1212z00_349;
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_classz00_350;
BgL_classz00_350 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1212z00_349 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_350); } 
BgL_arg1209z00_348 = 
VECTOR_REF(BgL_arg1212z00_349,((long)1)); } 
BgL_auxz00_707 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1209z00_348); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_707),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_outbufz00)=((obj_t)BGl_string1262z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1119z00_341)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1119z00_341)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_padec.scm 59 */
obj_t BgL_fun1213z00_351;
BgL_fun1213z00_351 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1213z00_351)(BgL_fun1213z00_351, 
((obj_t)BgL_new1119z00_341), BEOA); } 
BgL_auxz00_693 = 
((obj_t)BgL_new1119z00_341); } 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_693),BUNSPEC); } 
{ /* Llib/flac_padec.scm 60 */
BgL_flacpadecz00_bglt BgL_i1120z00_352;
BgL_i1120z00_352 = 
((BgL_flacpadecz00_bglt)
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))))->BgL_z52flacz52)); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_352)))->BgL_z52bufferz52)=((obj_t)
((obj_t)
((BgL_musicbufferz00_bglt)BgL_bufferz00_261))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_352)))->BgL_z52musicz52)=((obj_t)
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_260))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_352)))->BgL_z52decoderz52)=((obj_t)
((obj_t)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))),BUNSPEC); 
{ /* Llib/flac_padec.scm 66 */
obj_t BgL_exitd1123z00_353;
BgL_exitd1123z00_353 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac_padec.scm 71 */
obj_t BgL_zc3z04anonymousza31228ze3z87_354;
BgL_zc3z04anonymousza31228ze3z87_354 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_padecz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_354, 
(int)(((long)0)), 
((obj_t)BgL_i1120z00_352)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_354, 
(int)(((long)1)), 
((obj_t)
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_260)))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_354, 
(int)(((long)2)), 
((obj_t)
((BgL_musicbufz00_bglt)BgL_amz00_260))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_353, BgL_zc3z04anonymousza31228ze3z87_354); 
{ /* Llib/flac_padec.scm 67 */
obj_t BgL_tmp1125z00_355;
{ /* Llib/flac_padec.scm 67 */
BgL_pulseaudiozd2simplezd2_bglt BgL_i1127z00_356;
BgL_i1127z00_356 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_260))))->BgL_simplez00); 
if(
(
(long)(
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_i1127z00_356))->BgL_bpsz00))<=((long)16)))
{ /* Llib/flac_padec.scm 69 */
obj_t BgL_arg1221z00_357;
BgL_arg1221z00_357 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))))->BgL_z52flacz52); 
BgL_tmp1125z00_355 = 
BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1221z00_357)); }  else 
{ /* Llib/flac_padec.scm 70 */
obj_t BgL_arg1222z00_358;
BgL_arg1222z00_358 = 
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_259))))->BgL_z52flacz52); 
BgL_tmp1125z00_355 = 
BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_arg1222z00_358)); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1123z00_353); 
BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_padecz00(BgL_zc3z04anonymousza31228ze3z87_354); 
return BgL_tmp1125z00_355;} } } } } 

}



/* &<@anonymous:1228> */
obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__flac_padecz00(obj_t BgL_envz00_262)
{
{ /* Llib/flac_padec.scm 66 */
{ /* Llib/flac_padec.scm 71 */
BgL_flacpadecz00_bglt BgL_i1120z00_263;BgL_pulseaudiomusicz00_bglt BgL_i1121z00_264;BgL_musicbufz00_bglt BgL_amz00_265;
BgL_i1120z00_263 = 
((BgL_flacpadecz00_bglt)
PROCEDURE_REF(BgL_envz00_262, 
(int)(((long)0)))); 
BgL_i1121z00_264 = 
((BgL_pulseaudiomusicz00_bglt)
PROCEDURE_REF(BgL_envz00_262, 
(int)(((long)1)))); 
BgL_amz00_265 = 
((BgL_musicbufz00_bglt)
PROCEDURE_REF(BgL_envz00_262, 
(int)(((long)2)))); 
{ /* Llib/flac_padec.scm 71 */
BgL_musicbufferz00_bglt BgL_i1126z00_359;
BgL_i1126z00_359 = 
((BgL_musicbufferz00_bglt)
(((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_i1120z00_263)))->BgL_z52bufferz52)); 
{ /* Llib/flac_padec.scm 72 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1229z00_360;
BgL_arg1229z00_360 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_i1121z00_264))->BgL_simplez00); 
{ /* Llib/flac_padec.scm 72 */
int BgL_errz00_361;
BgL_errz00_361 = 
(int)(((long)0)); 
{ /* Llib/flac_padec.scm 72 */
pa_simple * BgL_arg1086z00_362;int * BgL_arg1087z00_363;
BgL_arg1086z00_362 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1229z00_360))->BgL_z42builtinz42); 
BgL_arg1087z00_363 = 
&(BgL_errz00_361); 
pa_simple_flush(BgL_arg1086z00_362, BgL_arg1087z00_363); } 
if(
(
(long)(BgL_errz00_361)<((long)0)))
{ /* Llib/flac_padec.scm 72 */
char * BgL_arg1089z00_364;
{ /* Llib/flac_padec.scm 72 */
int BgL_tmpz00_827;
BgL_tmpz00_827 = 
(int)(((long)0)); 
BgL_arg1089z00_364 = 
pa_strerror(BgL_tmpz00_827); } 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1269z00zz__flac_padecz00), BgL_arg1089z00_364, 
BINT(((long)0)))); }  else 
{ /* Llib/flac_padec.scm 72 */BFALSE; } } } 
{ /* Llib/flac_padec.scm 73 */
obj_t BgL_arg1230z00_365;
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1126z00_359))->BgL_z52eofz52))
{ /* Llib/flac_padec.scm 73 */
BgL_arg1230z00_365 = 
CNST_TABLE_REF(((long)4)); }  else 
{ /* Llib/flac_padec.scm 73 */
BgL_arg1230z00_365 = 
CNST_TABLE_REF(((long)5)); } 
return 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_265), BgL_arg1230z00_365);} } } } 

}



/* &musicdecoder-init-fl1141 */
obj_t BGl_z62musicdecoderzd2initzd2fl1141z62zz__flac_padecz00(obj_t BgL_envz00_266, obj_t BgL_decz00_267)
{
{ /* Llib/flac_padec.scm 47 */
{ 

{ /* Llib/flac_padec.scm 47 */
obj_t BgL_nextzd2method1140zd2_368;
BgL_nextzd2method1140zd2_368 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_267)), BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_flaczd2pulseaudiodecoderzd2zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_nextzd2method1140zd2_368)(BgL_nextzd2method1140zd2_368, 
((obj_t)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_267)), BEOA); } 
if(
CBOOL(
(((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_267))))->BgL_z52flacz52)))
{ /* Llib/flac_padec.scm 50 */
return BFALSE;}  else 
{ 
obj_t BgL_auxz00_854;
{ /* Llib/flac_padec.scm 50 */
BgL_flacpadecz00_bglt BgL_new1116z00_369;
{ /* Llib/flac_padec.scm 50 */
BgL_flacpadecz00_bglt BgL_new1115z00_370;
BgL_new1115z00_370 = 
((BgL_flacpadecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flacpadecz00_bgl) ))); 
{ /* Llib/flac_padec.scm 50 */
long BgL_arg1195z00_371;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_classz00_372;
BgL_classz00_372 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1195z00_371 = 
BGL_CLASS_INDEX(BgL_classz00_372); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_370), BgL_arg1195z00_371); } 
BgL_new1116z00_369 = BgL_new1115z00_370; } 
{ 
void * BgL_auxz00_861;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_arg1186z00_373;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_arg1187z00_374;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_classz00_375;
BgL_classz00_375 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1187z00_374 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_375); } 
BgL_arg1186z00_373 = 
VECTOR_REF(BgL_arg1187z00_374,((long)0)); } 
BgL_auxz00_861 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1186z00_373)); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_auxz00_861),BUNSPEC); } 
{ 
obj_t BgL_auxz00_868;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_arg1188z00_376;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_arg1189z00_377;
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_classz00_378;
BgL_classz00_378 = BGl_flacpadecz00zz__flac_padecz00; 
BgL_arg1189z00_377 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_378); } 
BgL_arg1188z00_376 = 
VECTOR_REF(BgL_arg1189z00_377,((long)1)); } 
BgL_auxz00_868 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1188z00_376); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52flacbufz52)=((obj_t)BgL_auxz00_868),BUNSPEC); } 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_outbufz00)=((obj_t)BGl_string1262z00zz__flac_padecz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52volumez52)=((double)((double)1.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52bchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1116z00_369)))->BgL_z52rchecksumz52)=((int)
(int)(((long)128))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52musicz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52bufferz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52decoderz52)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52ratez52)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52ratezd2maxz80)=((int)
(int)(((long)80))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52ratezd2minz80)=((int)
(int)(((long)50))),BUNSPEC); 
((((BgL_flacdecz00_bglt)COBJECT(
((BgL_flacdecz00_bglt)BgL_new1116z00_369)))->BgL_z52lastzd2percentagez80)=((int)
(int)(((long)0))),BUNSPEC); 
{ /* Llib/flac_padec.scm 50 */
obj_t BgL_fun1190z00_379;
BgL_fun1190z00_379 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_flacpadecz00zz__flac_padecz00); 
PROCEDURE_ENTRY(BgL_fun1190z00_379)(BgL_fun1190z00_379, 
((obj_t)BgL_new1116z00_369), BEOA); } 
BgL_auxz00_854 = 
((obj_t)BgL_new1116z00_369); } 
return 
((((BgL_flacmusicdecoderz00_bglt)COBJECT(
((BgL_flacmusicdecoderz00_bglt)
((BgL_flaczd2pulseaudiodecoderzd2_bglt)BgL_decz00_267))))->BgL_z52flacz52)=((obj_t)BgL_auxz00_854),BUNSPEC);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__flac_padecz00()
{
{ /* Llib/flac_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__flac_flacz00(((long)107017853), 
BSTRING_TO_STRING(BGl_string1270z00zz__flac_padecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__flac_decoderz00(((long)630617), 
BSTRING_TO_STRING(BGl_string1270z00zz__flac_padecz00));} 

}

#ifdef __cplusplus
}
#endif
