/*===========================================================================*/
/*   (Llib/_pthread.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/_pthread.scm -o objs/_pthread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_uncaughtzd2exceptionzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_reasonz00;
} *BgL_uncaughtzd2exceptionzd2_bglt;

typedef struct BgL_pthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
} *BgL_pthreadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52sigjoinz52_bgl {
   header_t header;
   obj_t widening;
   struct BgL_fthreadz00_bgl * BgL_threadz00;
} *BgL_z52sigjoinz52_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52(obj_t);
static obj_t BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62terminatez62zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52pthreadz52();
BGL_IMPORT void * BGl_z42pthreadzd2nilz90zz__pth_threadz00();
static obj_t BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_z52pthreadz52();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__ft_z52pthreadz52();
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_pthreadz00zz__pth_threadz00;
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
static obj_t BGl_z62zc3z04anonymousza31135ze3ze5zz__ft_z52pthreadz52(obj_t);
static obj_t BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52(obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static obj_t BGl_methodzd2initzd2zz__ft_z52pthreadz52();
BGL_IMPORT obj_t BGl_objectzd2writezd2zz__objectz00(BgL_objectz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52sigjoinz52zz__ft_typesz00;
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt);
static obj_t BGl_zc3z04exitza31162ze3ze70z60zz__ft_z52pthreadz52(BgL_fthreadz00_bglt, BgL_fthreadz00_bglt);
static obj_t BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31342ze3ze5zz__ft_z52pthreadz52(obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
BGL_IMPORT obj_t BGl_uncaughtzd2exceptionzd2zz__pth_threadz00;
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52(obj_t, obj_t);
extern obj_t BGl_z52pthreadz52zz__ft_z52typesz52;
static obj_t BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__ft_z52pthreadz52(obj_t);
static obj_t BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31169ze3ze5zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52();
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_z52pthreadz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52();
extern obj_t BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52();
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52();
static obj_t BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = BUNSPEC;
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52(obj_t, obj_t);
extern obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52(obj_t, obj_t);
BGL_IMPORT obj_t bgl_find_runtime_type(obj_t);
static obj_t BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
extern obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52(obj_t, obj_t);
static obj_t __cnst[ 2 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2enterzd2schedulerzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21616za7, BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2switchzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21617za7, BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1600z00zz__ft_z52pthreadz52, BgL_bgl_string1600za700za7za7_1618za7, "%user-thread-yield!", 19 );
DEFINE_STRING( BGl_string1602z00zz__ft_z52pthreadz52, BgL_bgl_string1602za700za7za7_1619za7, "%user-thread-sleep!", 19 );
DEFINE_STRING( BGl_string1606z00zz__ft_z52pthreadz52, BgL_bgl_string1606za700za7za7_1620za7, "*self*", 6 );
DEFINE_STRING( BGl_string1607z00zz__ft_z52pthreadz52, BgL_bgl_string1607za700za7za7_1621za7, ">", 1 );
DEFINE_STRING( BGl_string1608z00zz__ft_z52pthreadz52, BgL_bgl_string1608za700za7za7_1622za7, " parent:", 8 );
DEFINE_STRING( BGl_string1609z00zz__ft_z52pthreadz52, BgL_bgl_string1609za700za7za7_1623za7, "#<%pthread:", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1601z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1624za7, BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1603z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2cur1625za7, BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1610z00zz__ft_z52pthreadz52, BgL_bgl_string1610za700za7za7_1626za7, "__ft_%pthread", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1604z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1627za7, BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1611z00zz__ft_z52pthreadz52, BgL_bgl_string1611za700za7za7_1628za7, "async %pthread-enter-scheduler ", 31 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1605z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1629za7, BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2spawnzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sp1630za7, BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1572z00zz__ft_z52pthreadz52, BgL_bgl_string1572za700za7za7_1631za7, "Llib/_pthread.scm", 17 );
DEFINE_STRING( BGl_string1574z00zz__ft_z52pthreadz52, BgL_bgl_string1574za700za7za7_1632za7, "/builddir/build/BUILD/bigloo-4.4b/api/fthread/src/Llib/_pthread.scm", 67 );
DEFINE_STRING( BGl_string1575z00zz__ft_z52pthreadz52, BgL_bgl_string1575za700za7za7_1633za7, "&%fscheduler-new", 16 );
DEFINE_STRING( BGl_string1576z00zz__ft_z52pthreadz52, BgL_bgl_string1576za700za7za7_1634za7, "%scheduler", 10 );
DEFINE_STRING( BGl_string1577z00zz__ft_z52pthreadz52, BgL_bgl_string1577za700za7za7_1635za7, "&%pthread-new", 13 );
DEFINE_STRING( BGl_string1578z00zz__ft_z52pthreadz52, BgL_bgl_string1578za700za7za7_1636za7, "fthread", 7 );
DEFINE_STRING( BGl_string1579z00zz__ft_z52pthreadz52, BgL_bgl_string1579za700za7za7_1637za7, "Illegal cleanup function", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1573z00zz__ft_z52pthreadz52, BgL_bgl_za762za7c3za704anonymo1638za7, BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1580z00zz__ft_z52pthreadz52, BgL_bgl_string1580za700za7za7_1639za7, "&%pthread-wait", 14 );
DEFINE_STRING( BGl_string1581z00zz__ft_z52pthreadz52, BgL_bgl_string1581za700za7za7_1640za7, "%pthread", 8 );
DEFINE_STRING( BGl_string1582z00zz__ft_z52pthreadz52, BgL_bgl_string1582za700za7za7_1641za7, "&%pthread-switch", 16 );
DEFINE_STRING( BGl_string1583z00zz__ft_z52pthreadz52, BgL_bgl_string1583za700za7za7_1642za7, "Bogus (current-thread) procedure", 32 );
DEFINE_STRING( BGl_string1584z00zz__ft_z52pthreadz52, BgL_bgl_string1584za700za7za7_1643za7, "Undefined current-thread", 24 );
DEFINE_STRING( BGl_string1585z00zz__ft_z52pthreadz52, BgL_bgl_string1585za700za7za7_1644za7, "&%pthread-enter-scheduler", 25 );
DEFINE_STRING( BGl_string1586z00zz__ft_z52pthreadz52, BgL_bgl_string1586za700za7za7_1645za7, "&%pthread-leave-scheduler", 25 );
DEFINE_STRING( BGl_string1587z00zz__ft_z52pthreadz52, BgL_bgl_string1587za700za7za7_1646za7, "&%async-spawn", 13 );
DEFINE_STRING( BGl_string1588z00zz__ft_z52pthreadz52, BgL_bgl_string1588za700za7za7_1647za7, "procedure", 9 );
DEFINE_STRING( BGl_string1589z00zz__ft_z52pthreadz52, BgL_bgl_string1589za700za7za7_1648za7, "&%async-synchronize", 19 );
DEFINE_STRING( BGl_string1590z00zz__ft_z52pthreadz52, BgL_bgl_string1590za700za7za7_1649za7, "&%async-asynchronize", 20 );
DEFINE_STRING( BGl_string1591z00zz__ft_z52pthreadz52, BgL_bgl_string1591za700za7za7_1650za7, "&%async-scheduler-wait", 22 );
DEFINE_STRING( BGl_string1592z00zz__ft_z52pthreadz52, BgL_bgl_string1592za700za7za7_1651za7, "&%async-scheduler-notify", 24 );
DEFINE_STRING( BGl_string1594z00zz__ft_z52pthreadz52, BgL_bgl_string1594za700za7za7_1652za7, "object-write", 12 );
DEFINE_STRING( BGl_string1596z00zz__ft_z52pthreadz52, BgL_bgl_string1596za700za7za7_1653za7, "object-display", 14 );
DEFINE_STRING( BGl_string1598z00zz__ft_z52pthreadz52, BgL_bgl_string1598za700za7za7_1654za7, "%user-current-thread", 20 );
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1593z00zz__ft_z52pthreadz52, BgL_bgl_za762objectza7d2writ1655z00, va_generic_entry, BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1595z00zz__ft_z52pthreadz52, BgL_bgl_za762objectza7d2disp1656z00, va_generic_entry, BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1597z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2cur1657za7, BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2schedulerzd2notifyzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sc1658za7, BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1599z00zz__ft_z52pthreadz52, BgL_bgl_za762za752userza7d2thr1659za7, BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2schedulerzd2waitzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sc1660za7, BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2synchroniza7ezd2envzf5zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2sy1661za7, BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2waitzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21662za7, BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52asynczd2asynchroniza7ezd2envzf5zz__ft_z52pthreadz52, BgL_bgl_za762za752asyncza7d2as1663za7, BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2newzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21664za7, BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52fschedulerzd2newzd2envz52zz__ft_z52pthreadz52, BgL_bgl_za762za752fscheduler1665z00, BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52pthreadzd2leavezd2schedulerzd2envz80zz__ft_z52pthreadz52, BgL_bgl_za762za752pthreadza7d21666za7, BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52) );
ADD_ROOT( (void *)(&BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long BgL_checksumz00_576, char * BgL_fromz00_577)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52pthreadz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52(); 
BGl_cnstzd2initzd2zz__ft_z52pthreadz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52(); 
BGl_methodzd2initzd2zz__ft_z52pthreadz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52pthreadz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_%pthread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_%pthread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
{ /* Llib/_pthread.scm 6 */
obj_t BgL_cportz00_517;
{ /* Llib/_pthread.scm 6 */
obj_t BgL_stringz00_525;
BgL_stringz00_525 = BGl_string1611z00zz__ft_z52pthreadz52; 
{ /* Llib/_pthread.scm 6 */
obj_t BgL_startz00_526;
BgL_startz00_526 = 
BINT(((long)0)); 
{ /* Llib/_pthread.scm 6 */
obj_t BgL_endz00_527;
BgL_endz00_527 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_525))); 
{ /* Llib/_pthread.scm 6 */

BgL_cportz00_517 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_525, BgL_startz00_526, BgL_endz00_527); } } } } 
{ 
long BgL_iz00_518;
BgL_iz00_518 = ((long)1); 
BgL_loopz00_519:
if(
(BgL_iz00_518==((long)-1)))
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;}  else 
{ /* Llib/_pthread.scm 6 */
{ /* Llib/_pthread.scm 6 */
obj_t BgL_arg1615z00_521;
{ /* Llib/_pthread.scm 6 */

{ /* Llib/_pthread.scm 6 */
obj_t BgL_locationz00_523;
BgL_locationz00_523 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_pthread.scm 6 */

BgL_arg1615z00_521 = 
BGl_readz00zz__readerz00(BgL_cportz00_517, BgL_locationz00_523); } } } 
{ /* Llib/_pthread.scm 6 */
int BgL_tmpz00_611;
BgL_tmpz00_611 = 
(int)(BgL_iz00_518); 
CNST_TABLE_SET(BgL_tmpz00_611, BgL_arg1615z00_521); } } 
{ /* Llib/_pthread.scm 6 */
int BgL_auxz00_524;
BgL_auxz00_524 = 
(int)(
(BgL_iz00_518-((long)1))); 
{ 
long BgL_iz00_616;
BgL_iz00_616 = 
(long)(BgL_auxz00_524); 
BgL_iz00_518 = BgL_iz00_616; 
goto BgL_loopz00_519;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1572z00zz__ft_z52pthreadz52)); 
BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = BFALSE; 
return BUNSPEC;} 

}



/* %get-scheduler-token */
obj_t BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 36 */
{ /* Llib/_pthread.scm 37 */
obj_t BgL_scdlz00_39;
BgL_scdlz00_39 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_39, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 38 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_39)))->BgL_currentzd2tokenzd2);}  else 
{ /* Llib/_pthread.scm 38 */
return BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52;} } } 

}



/* %set-scheduler-token! */
obj_t BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_tokenz00_3)
{
{ /* Llib/_pthread.scm 43 */
{ /* Llib/_pthread.scm 44 */
obj_t BgL_scdlz00_42;
BgL_scdlz00_42 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_42, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 45 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_42)))->BgL_currentzd2tokenzd2)=((obj_t)
((obj_t)BgL_tokenz00_3)),BUNSPEC);}  else 
{ /* Llib/_pthread.scm 45 */
return ( 
BGl_za2schedulerzd2currentzd2tokenza2z00zz__ft_z52pthreadz52 = 
((obj_t)BgL_tokenz00_3), BUNSPEC) ;} } } 

}



/* %fscheduler-new */
BGL_EXPORTED_DEF obj_t BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_z52schedulerz52_bglt BgL_scdlz00_4)
{
{ /* Llib/_pthread.scm 53 */
{ /* Llib/_pthread.scm 56 */
BgL_z52pthreadz52_bglt BgL_z52pthz52_46;
{ /* Llib/_pthread.scm 56 */
BgL_z52pthreadz52_bglt BgL_new1064z00_47;
{ /* Llib/_pthread.scm 58 */
BgL_z52pthreadz52_bglt BgL_new1063z00_56;
BgL_new1063z00_56 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 58 */
long BgL_arg1134z00_57;
BgL_arg1134z00_57 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1063z00_56), BgL_arg1134z00_57); } 
BgL_new1064z00_47 = BgL_new1063z00_56; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1064z00_47)))->BgL_namez00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_scdlz00_4)))->BgL_namez00)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_bodyz00)=((obj_t)BGl_proc1573z00zz__ft_z52pthreadz52),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1064z00_47)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_fthreadz00)=((obj_t)
((obj_t)BgL_scdlz00_4)),BUNSPEC); 
{ 
obj_t BgL_auxz00_654;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1122z00_49;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1123z00_50;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_278;
BgL_classz00_278 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1123z00_50 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_278); } 
BgL_arg1122z00_49 = 
VECTOR_REF(BgL_arg1123z00_50,((long)9)); } 
BgL_auxz00_654 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1122z00_49); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_mutexz00)=((obj_t)BgL_auxz00_654),BUNSPEC); } 
{ 
obj_t BgL_auxz00_659;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1125z00_51;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1127z00_52;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_280;
BgL_classz00_280 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1127z00_52 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_280); } 
BgL_arg1125z00_51 = 
VECTOR_REF(BgL_arg1127z00_52,((long)10)); } 
BgL_auxz00_659 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1125z00_51); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_condvarz00)=((obj_t)BgL_auxz00_659),BUNSPEC); } 
{ 
obj_t BgL_auxz00_664;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1130z00_53;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_arg1132z00_54;
{ /* Llib/_pthread.scm 59 */
obj_t BgL_classz00_282;
BgL_classz00_282 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1132z00_54 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_282); } 
BgL_arg1130z00_53 = 
VECTOR_REF(BgL_arg1132z00_54,((long)11)); } 
BgL_auxz00_664 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1130z00_53); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_idz00)=((obj_t)BgL_auxz00_664),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1064z00_47))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 56 */
obj_t BgL_fun1133z00_55;
BgL_fun1133z00_55 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1133z00_55)(BgL_fun1133z00_55, 
((obj_t)BgL_new1064z00_47), BEOA); } 
BgL_z52pthz52_46 = BgL_new1064z00_47; } 
return 
((obj_t)BgL_z52pthz52_46);} } 

}



/* &%fscheduler-new */
obj_t BGl_z62z52fschedulerzd2newze2zz__ft_z52pthreadz52(obj_t BgL_envz00_379, obj_t BgL_scdlz00_380)
{
{ /* Llib/_pthread.scm 53 */
{ /* Llib/_pthread.scm 55 */
BgL_z52schedulerz52_bglt BgL_auxz00_677;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_380, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 55 */
BgL_auxz00_677 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_380)
; }  else 
{ 
obj_t BgL_auxz00_681;
BgL_auxz00_681 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)1881)), BGl_string1575z00zz__ft_z52pthreadz52, BGl_string1576z00zz__ft_z52pthreadz52, BgL_scdlz00_380); 
FAILURE(BgL_auxz00_681,BFALSE,BFALSE);} 
return 
BGl_z52fschedulerzd2newz80zz__ft_z52pthreadz52(BgL_auxz00_677);} } 

}



/* &<@anonymous:1121> */
obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_381)
{
{ /* Llib/_pthread.scm 57 */
return BUNSPEC;} 

}



/* %pthread-new */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt BgL_ftz00_5)
{
{ /* Llib/_pthread.scm 66 */
{ /* Llib/_pthread.scm 95 */
obj_t BgL_z52pthz52_401;
BgL_z52pthz52_401 = 
MAKE_CELL(BUNSPEC); 
{ /* Llib/_pthread.scm 95 */
BgL_z52pthreadz52_bglt BgL_g1160z00_74;
{ /* Llib/_pthread.scm 96 */
BgL_z52pthreadz52_bglt BgL_new1078z00_61;
{ /* Llib/_pthread.scm 102 */
BgL_z52pthreadz52_bglt BgL_new1077z00_72;
BgL_new1077z00_72 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 102 */
long BgL_arg1159z00_73;
BgL_arg1159z00_73 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_72), BgL_arg1159z00_73); } 
BgL_new1078z00_61 = BgL_new1077z00_72; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1078z00_61)))->BgL_namez00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_ftz00_5)))->BgL_namez00)),BUNSPEC); 
{ 
obj_t BgL_auxz00_694;
{ /* Llib/_pthread.scm 98 */
obj_t BgL_zc3z04anonymousza31135ze3z87_385;
BgL_zc3z04anonymousza31135ze3z87_385 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31135ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31135ze3z87_385, 
(int)(((long)0)), 
((obj_t)BgL_ftz00_5)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31135ze3z87_385, 
(int)(((long)1)), 
((obj_t)BgL_z52pthz52_401)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31135ze3z87_385, 
(int)(((long)2)), 
((obj_t)BgL_ftz00_5)); 
BgL_auxz00_694 = BgL_zc3z04anonymousza31135ze3z87_385; } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_bodyz00)=((obj_t)BgL_auxz00_694),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1078z00_61)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_fthreadz00)=((obj_t)
((obj_t)BgL_ftz00_5)),BUNSPEC); 
{ 
obj_t BgL_auxz00_720;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1140z00_65;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1152z00_66;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_295;
BgL_classz00_295 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1152z00_66 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_295); } 
BgL_arg1140z00_65 = 
VECTOR_REF(BgL_arg1152z00_66,((long)9)); } 
BgL_auxz00_720 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1140z00_65); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_mutexz00)=((obj_t)BgL_auxz00_720),BUNSPEC); } 
{ 
obj_t BgL_auxz00_725;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1153z00_67;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1155z00_68;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_297;
BgL_classz00_297 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1155z00_68 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_297); } 
BgL_arg1153z00_67 = 
VECTOR_REF(BgL_arg1155z00_68,((long)10)); } 
BgL_auxz00_725 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1153z00_67); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_condvarz00)=((obj_t)BgL_auxz00_725),BUNSPEC); } 
{ 
obj_t BgL_auxz00_730;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1156z00_69;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_arg1157z00_70;
{ /* Llib/_pthread.scm 97 */
obj_t BgL_classz00_299;
BgL_classz00_299 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1157z00_70 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_299); } 
BgL_arg1156z00_69 = 
VECTOR_REF(BgL_arg1157z00_70,((long)11)); } 
BgL_auxz00_730 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1156z00_69); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_idz00)=((obj_t)BgL_auxz00_730),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1078z00_61))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 96 */
obj_t BgL_fun1158z00_71;
BgL_fun1158z00_71 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1158z00_71)(BgL_fun1158z00_71, 
((obj_t)BgL_new1078z00_61), BEOA); } 
BgL_g1160z00_74 = BgL_new1078z00_61; } 
CELL_SET(BgL_z52pthz52_401, 
((obj_t)BgL_g1160z00_74)); 
return 
CELL_REF(BgL_z52pthz52_401);} } } 

}



/* &%pthread-new */
obj_t BGl_z62z52pthreadzd2newze2zz__ft_z52pthreadz52(obj_t BgL_envz00_386, obj_t BgL_ftz00_387)
{
{ /* Llib/_pthread.scm 66 */
{ /* Llib/_pthread.scm 68 */
BgL_fthreadz00_bglt BgL_auxz00_743;
if(
BGl_isazf3zf3zz__objectz00(BgL_ftz00_387, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 68 */
BgL_auxz00_743 = 
((BgL_fthreadz00_bglt)BgL_ftz00_387)
; }  else 
{ 
obj_t BgL_auxz00_747;
BgL_auxz00_747 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)2397)), BGl_string1577z00zz__ft_z52pthreadz52, BGl_string1578z00zz__ft_z52pthreadz52, BgL_ftz00_387); 
FAILURE(BgL_auxz00_747,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_auxz00_743);} } 

}



/* &<@anonymous:1135> */
obj_t BGl_z62zc3z04anonymousza31135ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_388)
{
{ /* Llib/_pthread.scm 98 */
{ /* Llib/_pthread.scm 99 */
BgL_fthreadz00_bglt BgL_i1076z00_389;obj_t BgL_z52pthz52_390;BgL_fthreadz00_bglt BgL_ftz00_391;
BgL_i1076z00_389 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_388, 
(int)(((long)0)))); 
BgL_z52pthz52_390 = 
PROCEDURE_REF(BgL_envz00_388, 
(int)(((long)1))); 
BgL_ftz00_391 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_388, 
(int)(((long)2)))); 
{ 
BgL_fthreadz00_bglt BgL_tz00_530;
{ /* Llib/_pthread.scm 99 */
obj_t BgL_arg1137z00_539;
BgL_arg1137z00_539 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_i1076z00_389))->BgL_schedulerz00); 
{ /* Llib/_pthread.scm 99 */
obj_t BgL_list1138z00_540;
BgL_list1138z00_540 = 
MAKE_YOUNG_PAIR(BgL_arg1137z00_539, BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1138z00_540); } } 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)
((BgL_z52pthreadz52_bglt)
CELL_REF(BgL_z52pthz52_390)))); 
BgL_tz00_530 = BgL_ftz00_391; 
BGl_zc3z04exitza31162ze3ze70z60zz__ft_z52pthreadz52(BgL_tz00_530, BgL_tz00_530); 
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_arg1178z00_531;obj_t BgL_arg1179z00_532;
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_new1075z00_533;
{ /* Llib/_pthread.scm 85 */
BgL_z52sigjoinz52_bglt BgL_new1074z00_534;
BgL_new1074z00_534 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/_pthread.scm 85 */
long BgL_arg1181z00_535;
BgL_arg1181z00_535 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1074z00_534), BgL_arg1181z00_535); } 
BgL_new1075z00_533 = BgL_new1074z00_534; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1075z00_533))->BgL_threadz00)=((BgL_fthreadz00_bglt)BgL_tz00_530),BUNSPEC); 
BgL_arg1178z00_531 = BgL_new1075z00_533; } 
BgL_arg1179z00_532 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_530))->BgL_z52resultz52); 
{ /* Llib/_pthread.scm 85 */
obj_t BgL_list1180z00_536;
BgL_list1180z00_536 = 
MAKE_YOUNG_PAIR(BgL_arg1179z00_532, BNIL); 
BGl_broadcastz12z12zz__ft_schedulerz00(
((obj_t)BgL_arg1178z00_531), BgL_list1180z00_536); } } 
{ /* Llib/_pthread.scm 87 */
bool_t BgL_test1673z00_776;
{ /* Llib/_pthread.scm 87 */
obj_t BgL_tmpz00_777;
BgL_tmpz00_777 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_530))->BgL_z52cleanupz52); 
BgL_test1673z00_776 = 
PROCEDUREP(BgL_tmpz00_777); } 
if(BgL_test1673z00_776)
{ /* Llib/_pthread.scm 87 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_530))->BgL_z52cleanupz52), 
(int)(((long)1))))
{ /* Llib/_pthread.scm 89 */
obj_t BgL_fun1186z00_537;
BgL_fun1186z00_537 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_530))->BgL_z52cleanupz52); 
PROCEDURE_ENTRY(BgL_fun1186z00_537)(BgL_fun1186z00_537, 
((obj_t)BgL_tz00_530), BEOA); }  else 
{ /* Llib/_pthread.scm 90 */
obj_t BgL_arg1187z00_538;
BgL_arg1187z00_538 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_530))->BgL_z52cleanupz52); 
BGl_errorz00zz__errorz00(
((obj_t)BgL_tz00_530), BGl_string1579z00zz__ft_z52pthreadz52, BgL_arg1187z00_538); } }  else 
{ /* Llib/_pthread.scm 87 */BFALSE; } } 
return 
BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_tz00_530);} } } 

}



/* <@exit:1162>~0 */
obj_t BGl_zc3z04exitza31162ze3ze70z60zz__ft_z52pthreadz52(BgL_fthreadz00_bglt BgL_i1065z00_470, BgL_fthreadz00_bglt BgL_tz00_469)
{
{ /* Llib/_pthread.scm 70 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1070z00_79;
if( SET_EXIT(BgL_an_exit1070z00_79 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1070z00_79 = 
(void *)jmpbuf; 
{ /* Llib/_pthread.scm 70 */

PUSH_EXIT(BgL_an_exit1070z00_79, ((long)1)); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_an_exitd1071z00_80;
BgL_an_exitd1071z00_80 = 
((obj_t)(&exitd)); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_terminatez00_382;
BgL_terminatez00_382 = 
MAKE_FX_PROCEDURE(BGl_z62terminatez62zz__ft_z52pthreadz52, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_terminatez00_382, 
(int)(((long)0)), BgL_an_exitd1071z00_80); 
{ /* Llib/_pthread.scm 70 */
obj_t BgL_res1073z00_83;
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_469))->BgL_z52terminatez52)=((obj_t)BgL_terminatez00_382),BUNSPEC); 
{ /* Llib/_pthread.scm 75 */
obj_t BgL_zc3z04anonymousza31176ze3z87_384;obj_t BgL_zc3z04anonymousza31169ze3z87_383;
BgL_zc3z04anonymousza31176ze3z87_384 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31176ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)1))); 
BgL_zc3z04anonymousza31169ze3z87_383 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31169ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31176ze3z87_384, 
(int)(((long)0)), 
((obj_t)BgL_i1065z00_470)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31169ze3z87_383, 
(int)(((long)0)), 
((obj_t)BgL_tz00_469)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31169ze3z87_383, 
(int)(((long)1)), BgL_an_exitd1071z00_80); 
BgL_res1073z00_83 = 
BGl_withzd2exceptionzd2handlerz00zz__errorz00(BgL_zc3z04anonymousza31169ze3z87_383, BgL_zc3z04anonymousza31176ze3z87_384); } 
POP_EXIT(); 
return BgL_res1073z00_83;} } } } 
}} 

}



/* &<@anonymous:1176> */
obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_392)
{
{ /* Llib/_pthread.scm 81 */
{ /* Llib/_pthread.scm 81 */
BgL_fthreadz00_bglt BgL_i1065z00_393;
BgL_i1065z00_393 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_392, 
(int)(((long)0)))); 
{ 
obj_t BgL_auxz00_822;
{ /* Llib/_pthread.scm 83 */
obj_t BgL_fun1177z00_541;
BgL_fun1177z00_541 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_i1065z00_393))->BgL_bodyz00); 
BgL_auxz00_822 = 
PROCEDURE_ENTRY(BgL_fun1177z00_541)(BgL_fun1177z00_541, BEOA); } 
return 
((((BgL_fthreadz00_bglt)COBJECT(BgL_i1065z00_393))->BgL_z52resultz52)=((obj_t)BgL_auxz00_822),BUNSPEC);} } } 

}



/* &<@anonymous:1169> */
obj_t BGl_z62zc3z04anonymousza31169ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_394, obj_t BgL_ez00_397)
{
{ /* Llib/_pthread.scm 74 */
{ /* Llib/_pthread.scm 75 */
BgL_fthreadz00_bglt BgL_tz00_395;obj_t BgL_an_exitd1071z00_396;
BgL_tz00_395 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_394, 
(int)(((long)0)))); 
BgL_an_exitd1071z00_396 = 
PROCEDURE_REF(BgL_envz00_394, 
(int)(((long)1))); 
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_uz00_542;
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1068z00_543;
{ /* Llib/_pthread.scm 75 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1067z00_544;
BgL_new1067z00_544 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uncaughtzd2exceptionzd2_bgl) ))); 
{ /* Llib/_pthread.scm 75 */
long BgL_arg1175z00_545;
BgL_arg1175z00_545 = 
BGL_CLASS_INDEX(BGl_uncaughtzd2exceptionzd2zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1067z00_544), BgL_arg1175z00_545); } 
BgL_new1068z00_543 = BgL_new1067z00_544; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_543)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_543)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_841;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_arg1172z00_546;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_arg1173z00_547;
{ /* Llib/_pthread.scm 75 */
obj_t BgL_classz00_548;
BgL_classz00_548 = BGl_uncaughtzd2exceptionzd2zz__pth_threadz00; 
BgL_arg1173z00_547 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_548); } 
BgL_arg1172z00_546 = 
VECTOR_REF(BgL_arg1173z00_547,((long)2)); } 
BgL_auxz00_841 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1172z00_546); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1068z00_543)))->BgL_stackz00)=((obj_t)BgL_auxz00_841),BUNSPEC); } 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(BgL_new1068z00_543))->BgL_reasonz00)=((obj_t)BgL_ez00_397),BUNSPEC); 
BgL_uz00_542 = BgL_new1068z00_543; } 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_395))->BgL_z52exczd2resultz80)=((obj_t)
((obj_t)BgL_uz00_542)),BUNSPEC); 
BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_397); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1071z00_396, BFALSE);} } } 

}



/* &terminate */
obj_t BGl_z62terminatez62zz__ft_z52pthreadz52(obj_t BgL_envz00_398, obj_t BgL_val1072z00_400)
{
{ /* Llib/_pthread.scm 70 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_398, 
(int)(((long)0))), BgL_val1072z00_400);} 

}



/* %pthread-wait */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_ftz00_6)
{
{ /* Llib/_pthread.scm 109 */
{ /* Llib/_pthread.scm 116 */
obj_t BgL_mutex1190z00_116;
BgL_mutex1190z00_116 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 116 */
obj_t BgL_top1676z00_857;
BgL_top1676z00_857 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1190z00_116); 
BGL_EXITD_PUSH_PROTECT(BgL_top1676z00_857, BgL_mutex1190z00_116); BUNSPEC; 
{ /* Llib/_pthread.scm 116 */
obj_t BgL_tmp1675z00_856;
{ 

{ /* Llib/_pthread.scm 117 */
bool_t BgL_tmpz00_861;
BgL_zc3z04anonymousza31191ze3z87_118:
{ /* Llib/_pthread.scm 118 */
bool_t BgL_test1677z00_862;
{ /* Llib/_pthread.scm 118 */
obj_t BgL_arg1209z00_126;
BgL_arg1209z00_126 = 
BGl_z52getzd2schedulerzd2tokenz52zz__ft_z52pthreadz52(); 
BgL_test1677z00_862 = 
(BgL_arg1209z00_126==
((obj_t)BgL_ftz00_6)); } 
if(BgL_test1677z00_862)
{ /* Llib/_pthread.scm 118 */
BgL_tmpz00_861 = ((bool_t)0)
; }  else 
{ /* Llib/_pthread.scm 118 */
{ /* Llib/_pthread.scm 119 */
obj_t BgL_arg1201z00_121;obj_t BgL_arg1206z00_122;
BgL_arg1201z00_121 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_condvarz00); 
BgL_arg1206z00_122 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ftz00_6))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 119 */

BGL_CONDVAR_WAIT(BgL_arg1201z00_121, BgL_arg1206z00_122); } } 
goto BgL_zc3z04anonymousza31191ze3z87_118;} } 
BgL_tmp1675z00_856 = 
BBOOL(BgL_tmpz00_861); } } 
BGL_EXITD_POP_PROTECT(BgL_top1676z00_857); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1190z00_116); 
return BgL_tmp1675z00_856;} } } } 

}



/* &%pthread-wait */
obj_t BGl_z62z52pthreadzd2waitze2zz__ft_z52pthreadz52(obj_t BgL_envz00_404, obj_t BgL_ftz00_405)
{
{ /* Llib/_pthread.scm 109 */
{ /* Llib/_pthread.scm 111 */
BgL_z52pthreadz52_bglt BgL_auxz00_872;
if(
BGl_isazf3zf3zz__objectz00(BgL_ftz00_405, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 111 */
BgL_auxz00_872 = 
((BgL_z52pthreadz52_bglt)BgL_ftz00_405)
; }  else 
{ 
obj_t BgL_auxz00_876;
BgL_auxz00_876 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)3945)), BGl_string1580z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_ftz00_405); 
FAILURE(BgL_auxz00_876,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_auxz00_872);} } 

}



/* %pthread-switch */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t BgL_ftz00_7, BgL_z52pthreadz52_bglt BgL_ntz00_8)
{
{ /* Llib/_pthread.scm 125 */
{ /* Llib/_pthread.scm 131 */
obj_t BgL_mutex1210z00_307;
BgL_mutex1210z00_307 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ntz00_8))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 131 */
obj_t BgL_top1681z00_883;
BgL_top1681z00_883 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1210z00_307); 
BGL_EXITD_PUSH_PROTECT(BgL_top1681z00_883, BgL_mutex1210z00_307); BUNSPEC; 
{ /* Llib/_pthread.scm 131 */
obj_t BgL_tmp1680z00_882;
BGl_z52setzd2schedulerzd2tokenz12z40zz__ft_z52pthreadz52(BgL_ntz00_8); 
{ /* Llib/_pthread.scm 134 */
obj_t BgL_arg1212z00_308;
BgL_arg1212z00_308 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_ntz00_8))->BgL_condvarz00); 
BgL_tmp1680z00_882 = 
BBOOL(
BGL_CONDVAR_SIGNAL(BgL_arg1212z00_308)); } 
BGL_EXITD_POP_PROTECT(BgL_top1681z00_883); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1210z00_307); 
return BgL_tmp1680z00_882;} } } } 

}



/* &%pthread-switch */
obj_t BGl_z62z52pthreadzd2switchze2zz__ft_z52pthreadz52(obj_t BgL_envz00_406, obj_t BgL_ftz00_407, obj_t BgL_ntz00_408)
{
{ /* Llib/_pthread.scm 125 */
{ /* Llib/_pthread.scm 130 */
BgL_z52pthreadz52_bglt BgL_auxz00_893;
if(
BGl_isazf3zf3zz__objectz00(BgL_ntz00_408, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 130 */
BgL_auxz00_893 = 
((BgL_z52pthreadz52_bglt)BgL_ntz00_408)
; }  else 
{ 
obj_t BgL_auxz00_897;
BgL_auxz00_897 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)4678)), BGl_string1582z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_ntz00_408); 
FAILURE(BgL_auxz00_897,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_ftz00_407, BgL_auxz00_893);} } 

}



/* %pthread-enter-scheduler */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_9)
{
{ /* Llib/_pthread.scm 139 */
if(
CBOOL(
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)))
{ /* Llib/_pthread.scm 145 */BFALSE; }  else 
{ /* Llib/_pthread.scm 145 */
{ /* Llib/_pthread.scm 146 */
obj_t BgL_thz00_133;
BgL_thz00_133 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 149 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string1583z00zz__ft_z52pthreadz52, BgL_thz00_133); }  else 
{ /* Llib/_pthread.scm 149 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 154 */BUNSPEC; }  else 
{ /* Llib/_pthread.scm 154 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)))
{ /* Llib/_pthread.scm 157 */BUNSPEC; }  else 
{ /* Llib/_pthread.scm 157 */
if(
BGl_isazf3zf3zz__objectz00(BgL_thz00_133, BGl_pthreadz00zz__pth_threadz00))
{ /* Llib/_pthread.scm 160 */
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)=((obj_t)BgL_thz00_133),BUNSPEC); }  else 
{ /* Llib/_pthread.scm 163 */
bool_t BgL_test1690z00_918;
if(
BOOLEANP(BgL_thz00_133))
{ /* Llib/_pthread.scm 163 */
if(
CBOOL(BgL_thz00_133))
{ /* Llib/_pthread.scm 163 */
BgL_test1690z00_918 = ((bool_t)0)
; }  else 
{ /* Llib/_pthread.scm 163 */
BgL_test1690z00_918 = ((bool_t)1)
; } }  else 
{ /* Llib/_pthread.scm 163 */
BgL_test1690z00_918 = ((bool_t)0)
; } 
if(BgL_test1690z00_918)
{ /* Llib/_pthread.scm 163 */
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); }  else 
{ /* Llib/_pthread.scm 169 */
obj_t BgL_arg1227z00_141;
BgL_arg1227z00_141 = 
bgl_find_runtime_type(BgL_thz00_133); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string1584z00zz__ft_z52pthreadz52, BgL_arg1227z00_141); } } } } } } BUNSPEC; } 
{ /* Llib/_pthread.scm 173 */
bool_t BgL_test1693z00_927;
{ /* Llib/_pthread.scm 173 */
obj_t BgL_arg1239z00_147;
BgL_arg1239z00_147 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
BgL_test1693z00_927 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1239z00_147, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1693z00_927)
{ /* Llib/_pthread.scm 173 */BFALSE; }  else 
{ /* Llib/_pthread.scm 173 */
BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)); } } 
{ /* Llib/_pthread.scm 177 */
BgL_schedulerz00_bglt BgL_i1082z00_148;
BgL_i1082z00_148 = 
((BgL_schedulerz00_bglt)
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_fthreadz00)); 
{ /* Llib/_pthread.scm 178 */
obj_t BgL_fun1240z00_149;
BgL_fun1240z00_149 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_i1082z00_148)))->BgL_bodyz00); 
return 
PROCEDURE_ENTRY(BgL_fun1240z00_149)(BgL_fun1240z00_149, BEOA);} } } 

}



/* &%pthread-enter-scheduler */
obj_t BGl_z62z52pthreadzd2enterzd2schedulerz30zz__ft_z52pthreadz52(obj_t BgL_envz00_409, obj_t BgL_scdlz00_410)
{
{ /* Llib/_pthread.scm 139 */
{ /* Llib/_pthread.scm 143 */
BgL_z52pthreadz52_bglt BgL_auxz00_939;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_410, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 143 */
BgL_auxz00_939 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_410)
; }  else 
{ 
obj_t BgL_auxz00_943;
BgL_auxz00_943 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)5251)), BGl_string1585z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_410); 
FAILURE(BgL_auxz00_943,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2enterzd2schedulerz52zz__ft_z52pthreadz52(BgL_auxz00_939);} } 

}



/* %pthread-leave-scheduler */
BGL_EXPORTED_DEF obj_t BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_10)
{
{ /* Llib/_pthread.scm 183 */
{ /* Llib/_pthread.scm 187 */
bool_t BgL_test1695z00_948;
{ /* Llib/_pthread.scm 187 */
obj_t BgL_arg1244z00_153;
BgL_arg1244z00_153 = 
BGl_currentzd2threadzd2zz__threadz00(); 
BgL_test1695z00_948 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1244z00_153, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1695z00_948)
{ /* Llib/_pthread.scm 187 */BFALSE; }  else 
{ /* Llib/_pthread.scm 187 */
BGl_currentzd2schedulerzd2setz12z12zz__ft_schedulerz00(BFALSE); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_10))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); } } 
return BFALSE;} 

}



/* &%pthread-leave-scheduler */
obj_t BGl_z62z52pthreadzd2leavezd2schedulerz30zz__ft_z52pthreadz52(obj_t BgL_envz00_411, obj_t BgL_scdlz00_412)
{
{ /* Llib/_pthread.scm 183 */
{ /* Llib/_pthread.scm 187 */
BgL_z52pthreadz52_bglt BgL_auxz00_953;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_412, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 187 */
BgL_auxz00_953 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_412)
; }  else 
{ 
obj_t BgL_auxz00_957;
BgL_auxz00_957 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)6787)), BGl_string1586z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_412); 
FAILURE(BgL_auxz00_957,BFALSE,BFALSE);} 
return 
BGl_z52pthreadzd2leavezd2schedulerz52zz__ft_z52pthreadz52(BgL_auxz00_953);} } 

}



/* %async-spawn */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_11, obj_t BgL_bodyz00_12, obj_t BgL_oz00_13)
{
{ /* Llib/_pthread.scm 196 */
{ /* Llib/_pthread.scm 201 */
BgL_z52pthreadz52_bglt BgL_z52pthz52_154;
{ /* Llib/_pthread.scm 201 */
BgL_z52pthreadz52_bglt BgL_new1085z00_156;
{ /* Llib/_pthread.scm 204 */
BgL_z52pthreadz52_bglt BgL_new1084z00_166;
BgL_new1084z00_166 = 
((BgL_z52pthreadz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52pthreadz52_bgl) ))); 
{ /* Llib/_pthread.scm 204 */
long BgL_arg1277z00_167;
BgL_arg1277z00_167 = 
BGL_CLASS_INDEX(BGl_z52pthreadz52zz__ft_z52typesz52); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1084z00_166), BgL_arg1277z00_167); } 
BgL_new1085z00_156 = BgL_new1084z00_166; } 
{ 
obj_t BgL_auxz00_966;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1246z00_157;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1247z00_158;obj_t BgL_arg1248z00_159;
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1249z00_160;
BgL_arg1249z00_160 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1434z00_314;
BgL_arg1434z00_314 = 
SYMBOL_TO_STRING(BgL_arg1249z00_160); 
BgL_arg1247z00_158 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_314); } } 
{ /* Llib/_pthread.scm 204 */
obj_t BgL_arg1434z00_316;
BgL_arg1434z00_316 = 
SYMBOL_TO_STRING(
((obj_t)BgL_oz00_13)); 
BgL_arg1248z00_159 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_316); } 
BgL_arg1246z00_157 = 
string_append(BgL_arg1247z00_158, BgL_arg1248z00_159); } 
BgL_auxz00_966 = 
bstring_to_symbol(BgL_arg1246z00_157); } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1085z00_156)))->BgL_namez00)=((obj_t)BgL_auxz00_966),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_bodyz00)=((obj_t)BgL_bodyz00_12),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1085z00_156)))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_fthreadz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_990;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1252z00_161;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1253z00_162;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_classz00_318;
BgL_classz00_318 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1253z00_162 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_318); } 
BgL_arg1252z00_161 = 
VECTOR_REF(BgL_arg1253z00_162,((long)9)); } 
BgL_auxz00_990 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1252z00_161); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_mutexz00)=((obj_t)BgL_auxz00_990),BUNSPEC); } 
{ 
obj_t BgL_auxz00_995;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1254z00_163;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_arg1258z00_164;
{ /* Llib/_pthread.scm 203 */
obj_t BgL_classz00_320;
BgL_classz00_320 = BGl_z52pthreadz52zz__ft_z52typesz52; 
BgL_arg1258z00_164 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_320); } 
BgL_arg1254z00_163 = 
VECTOR_REF(BgL_arg1258z00_164,((long)10)); } 
BgL_auxz00_995 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1254z00_163); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_condvarz00)=((obj_t)BgL_auxz00_995),BUNSPEC); } 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_idz00)=((obj_t)BgL_oz00_13),BUNSPEC); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_new1085z00_156))->BgL_parentz00)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/_pthread.scm 201 */
obj_t BgL_fun1259z00_165;
BgL_fun1259z00_165 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_z52pthreadz52zz__ft_z52typesz52); 
PROCEDURE_ENTRY(BgL_fun1259z00_165)(BgL_fun1259z00_165, 
((obj_t)BgL_new1085z00_156), BEOA); } 
BgL_z52pthz52_154 = BgL_new1085z00_156; } 
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_z52pthz52_154), BNIL); 
return 
((obj_t)BgL_z52pthz52_154);} } 

}



/* &%async-spawn */
obj_t BGl_z62z52asynczd2spawnze2zz__ft_z52pthreadz52(obj_t BgL_envz00_413, obj_t BgL_scdlz00_414, obj_t BgL_bodyz00_415, obj_t BgL_oz00_416)
{
{ /* Llib/_pthread.scm 196 */
{ /* Llib/_pthread.scm 201 */
obj_t BgL_auxz00_1019;BgL_z52pthreadz52_bglt BgL_auxz00_1011;
if(
PROCEDUREP(BgL_bodyz00_415))
{ /* Llib/_pthread.scm 201 */
BgL_auxz00_1019 = BgL_bodyz00_415
; }  else 
{ 
obj_t BgL_auxz00_1022;
BgL_auxz00_1022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)7392)), BGl_string1587z00zz__ft_z52pthreadz52, BGl_string1588z00zz__ft_z52pthreadz52, BgL_bodyz00_415); 
FAILURE(BgL_auxz00_1022,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_414, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 201 */
BgL_auxz00_1011 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_414)
; }  else 
{ 
obj_t BgL_auxz00_1015;
BgL_auxz00_1015 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)7392)), BGl_string1587z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_414); 
FAILURE(BgL_auxz00_1015,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_auxz00_1011, BgL_auxz00_1019, BgL_oz00_416);} } 

}



/* %async-synchronize */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_14)
{
{ /* Llib/_pthread.scm 211 */
{ /* Llib/_pthread.scm 215 */
obj_t BgL_arg1279z00_323;
BgL_arg1279z00_323 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_14))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 215 */

{ /* Llib/_pthread.scm 215 */
int BgL_arg1649z00_329;
BgL_arg1649z00_329 = 
BGL_MUTEX_LOCK(BgL_arg1279z00_323); 
return 
BBOOL(
(
(long)(BgL_arg1649z00_329)==((long)0)));} } } } 

}



/* &%async-synchronize */
obj_t BGl_z62z52asynczd2synchroniza7ez45zz__ft_z52pthreadz52(obj_t BgL_envz00_417, obj_t BgL_scdlz00_418)
{
{ /* Llib/_pthread.scm 211 */
{ /* Llib/_pthread.scm 214 */
BgL_z52pthreadz52_bglt BgL_auxz00_1032;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_418, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 214 */
BgL_auxz00_1032 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_418)
; }  else 
{ 
obj_t BgL_auxz00_1036;
BgL_auxz00_1036 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)7893)), BGl_string1589z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_418); 
FAILURE(BgL_auxz00_1036,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_auxz00_1032);} } 

}



/* %async-asynchronize */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_15)
{
{ /* Llib/_pthread.scm 220 */
{ /* Llib/_pthread.scm 224 */
obj_t BgL_arg1280z00_335;
BgL_arg1280z00_335 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_15))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 224 */
int BgL_arg1646z00_337;
BgL_arg1646z00_337 = 
BGL_MUTEX_UNLOCK(BgL_arg1280z00_335); 
return 
BBOOL(
(
(long)(BgL_arg1646z00_337)==((long)0)));} } } 

}



/* &%async-asynchronize */
obj_t BGl_z62z52asynczd2asynchroniza7ez45zz__ft_z52pthreadz52(obj_t BgL_envz00_419, obj_t BgL_scdlz00_420)
{
{ /* Llib/_pthread.scm 220 */
{ /* Llib/_pthread.scm 223 */
BgL_z52pthreadz52_bglt BgL_auxz00_1046;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_420, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 223 */
BgL_auxz00_1046 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_420)
; }  else 
{ 
obj_t BgL_auxz00_1050;
BgL_auxz00_1050 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)8317)), BGl_string1590z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_420); 
FAILURE(BgL_auxz00_1050,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_auxz00_1046);} } 

}



/* %async-scheduler-wait */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_16)
{
{ /* Llib/_pthread.scm 229 */
{ /* Llib/_pthread.scm 233 */
obj_t BgL_arg1281z00_175;obj_t BgL_arg1318z00_176;
BgL_arg1281z00_175 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_16))->BgL_condvarz00); 
BgL_arg1318z00_176 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_16))->BgL_mutexz00); 
{ /* Llib/_pthread.scm 233 */

return 
BBOOL(
BGL_CONDVAR_WAIT(BgL_arg1281z00_175, BgL_arg1318z00_176));} } } 

}



/* &%async-scheduler-wait */
obj_t BGl_z62z52asynczd2schedulerzd2waitz30zz__ft_z52pthreadz52(obj_t BgL_envz00_421, obj_t BgL_scdlz00_422)
{
{ /* Llib/_pthread.scm 229 */
{ /* Llib/_pthread.scm 232 */
BgL_z52pthreadz52_bglt BgL_auxz00_1059;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_422, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 232 */
BgL_auxz00_1059 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_422)
; }  else 
{ 
obj_t BgL_auxz00_1063;
BgL_auxz00_1063 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)8744)), BGl_string1591z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_422); 
FAILURE(BgL_auxz00_1063,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2schedulerzd2waitz52zz__ft_z52pthreadz52(BgL_auxz00_1059);} } 

}



/* %async-scheduler-notify */
BGL_EXPORTED_DEF obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt BgL_scdlz00_17)
{
{ /* Llib/_pthread.scm 238 */
{ /* Llib/_pthread.scm 242 */
obj_t BgL_arg1319z00_345;
BgL_arg1319z00_345 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_scdlz00_17))->BgL_condvarz00); 
return 
BBOOL(
BGL_CONDVAR_SIGNAL(BgL_arg1319z00_345));} } 

}



/* &%async-scheduler-notify */
obj_t BGl_z62z52asynczd2schedulerzd2notifyz30zz__ft_z52pthreadz52(obj_t BgL_envz00_423, obj_t BgL_scdlz00_424)
{
{ /* Llib/_pthread.scm 238 */
{ /* Llib/_pthread.scm 241 */
BgL_z52pthreadz52_bglt BgL_auxz00_1071;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_424, BGl_z52pthreadz52zz__ft_z52typesz52))
{ /* Llib/_pthread.scm 241 */
BgL_auxz00_1071 = 
((BgL_z52pthreadz52_bglt)BgL_scdlz00_424)
; }  else 
{ 
obj_t BgL_auxz00_1075;
BgL_auxz00_1075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1574z00zz__ft_z52pthreadz52, 
BINT(((long)9202)), BGl_string1592z00zz__ft_z52pthreadz52, BGl_string1581z00zz__ft_z52pthreadz52, BgL_scdlz00_424); 
FAILURE(BgL_auxz00_1075,BFALSE,BFALSE);} 
return 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_auxz00_1071);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1593z00zz__ft_z52pthreadz52, BGl_string1594z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1595z00zz__ft_z52pthreadz52, BGl_string1596z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1597z00zz__ft_z52pthreadz52, BGl_string1598z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1599z00zz__ft_z52pthreadz52, BGl_string1600z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00, BGl_z52pthreadz52zz__ft_z52typesz52, BGl_proc1601z00zz__ft_z52pthreadz52, BGl_string1602z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2currentzd2threadzd2envz80zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1603z00zz__ft_z52pthreadz52, BGl_string1598z00zz__ft_z52pthreadz52); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1604z00zz__ft_z52pthreadz52, BGl_string1600z00zz__ft_z52pthreadz52); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2sleepz12zd2envz92zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1605z00zz__ft_z52pthreadz52, BGl_string1602z00zz__ft_z52pthreadz52);} 

}



/* &%user-thread-sleep!-1115 */
obj_t BGl_z62z52userzd2threadzd2sleepz12zd21115zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_434, obj_t BgL_oz00_435, obj_t BgL_timeoutz00_436)
{
{ /* Llib/_pthread.scm 317 */
if(
(
(long)CINT(BgL_timeoutz00_436)>((long)0)))
{ /* Llib/_pthread.scm 318 */
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_oz00_435), 
CINT(BgL_timeoutz00_436));}  else 
{ /* Llib/_pthread.scm 318 */
return BFALSE;} } 

}



/* &%user-thread-yield!-1113 */
obj_t BGl_z62z52userzd2threadzd2yieldz12zd21113zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_437, obj_t BgL_oz00_438)
{
{ /* Llib/_pthread.scm 311 */
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_oz00_438));} 

}



/* &%user-current-thread1111 */
obj_t BGl_z62z52userzd2currentzd2thread1111z30zz__ft_z52pthreadz52(obj_t BgL_envz00_439, obj_t BgL_oz00_440)
{
{ /* Llib/_pthread.scm 305 */
return 
((obj_t)
((BgL_fthreadz00_bglt)BgL_oz00_440));} 

}



/* &%user-thread-sleep!-1109 */
obj_t BGl_z62z52userzd2threadzd2sleepz12zd21109zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_441, obj_t BgL_oz00_442, obj_t BgL_timeoutz00_443)
{
{ /* Llib/_pthread.scm 297 */
{ /* Llib/_pthread.scm 299 */
bool_t BgL_test1707z00_1098;
{ /* Llib/_pthread.scm 299 */
bool_t BgL_test1708z00_1099;
{ /* Llib/_pthread.scm 299 */
obj_t BgL_arg1531z00_553;
BgL_arg1531z00_553 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_442)))->BgL_fthreadz00); 
BgL_test1708z00_1099 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1531z00_553, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1708z00_1099)
{ /* Llib/_pthread.scm 299 */
BgL_test1707z00_1098 = 
(
(long)CINT(BgL_timeoutz00_443)>((long)0))
; }  else 
{ /* Llib/_pthread.scm 299 */
BgL_test1707z00_1098 = ((bool_t)0)
; } } 
if(BgL_test1707z00_1098)
{ /* Llib/_pthread.scm 300 */
obj_t BgL_arg1530z00_554;
BgL_arg1530z00_554 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_442)))->BgL_fthreadz00); 
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_arg1530z00_554), 
CINT(BgL_timeoutz00_443));}  else 
{ /* Llib/_pthread.scm 299 */
return BFALSE;} } } 

}



/* &%user-thread-yield!-1107 */
obj_t BGl_z62z52userzd2threadzd2yieldz12zd21107zf0zz__ft_z52pthreadz52(obj_t BgL_envz00_444, obj_t BgL_oz00_445)
{
{ /* Llib/_pthread.scm 289 */
if(
CBOOL(
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_445)))->BgL_fthreadz00)))
{ /* Llib/_pthread.scm 292 */
obj_t BgL_arg1512z00_556;
BgL_arg1512z00_556 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_445)))->BgL_fthreadz00); 
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_arg1512z00_556));}  else 
{ /* Llib/_pthread.scm 291 */
return BFALSE;} } 

}



/* &%user-current-thread1105 */
obj_t BGl_z62z52userzd2currentzd2thread1105z30zz__ft_z52pthreadz52(obj_t BgL_envz00_446, obj_t BgL_oz00_447)
{
{ /* Llib/_pthread.scm 280 */
{ /* Llib/_pthread.scm 282 */
bool_t BgL_test1710z00_1118;
{ /* Llib/_pthread.scm 282 */
obj_t BgL_arg1506z00_558;
BgL_arg1506z00_558 = 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_447)))->BgL_fthreadz00); 
BgL_test1710z00_1118 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1506z00_558, BGl_fthreadz00zz__ft_typesz00); } 
if(BgL_test1710z00_1118)
{ /* Llib/_pthread.scm 282 */
return 
(((BgL_z52pthreadz52_bglt)COBJECT(
((BgL_z52pthreadz52_bglt)BgL_oz00_447)))->BgL_fthreadz00);}  else 
{ /* Llib/_pthread.scm 268 */
obj_t BgL_csz00_559;
BgL_csz00_559 = 
BGl_currentzd2schedulerzd2zz__ft_schedulerz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_csz00_559, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 269 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)
((BgL_schedulerz00_bglt)BgL_csz00_559))))->BgL_currentzd2threadzd2);}  else 
{ /* Llib/_pthread.scm 272 */
obj_t BgL_dsz00_560;
BgL_dsz00_560 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
if(
BGl_isazf3zf3zz__objectz00(BgL_dsz00_560, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_pthread.scm 273 */
return 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)
((BgL_schedulerz00_bglt)BgL_dsz00_560))))->BgL_currentzd2threadzd2);}  else 
{ /* Llib/_pthread.scm 273 */
return BFALSE;} } } } } 

}



/* &object-display-%pthr1103 */
obj_t BGl_z62objectzd2displayzd2z52pthr1103z30zz__ft_z52pthreadz52(obj_t BgL_envz00_448, obj_t BgL_oz00_449, obj_t BgL_portz00_450)
{
{ /* Llib/_pthread.scm 260 */
{ /* Llib/_pthread.scm 261 */
obj_t BgL_runner1393z00_562;
{ /* Llib/_pthread.scm 261 */
obj_t BgL_list1391z00_563;
BgL_list1391z00_563 = 
MAKE_YOUNG_PAIR(BgL_portz00_450, BNIL); 
BgL_runner1393z00_562 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)
((BgL_z52pthreadz52_bglt)BgL_oz00_449)), BgL_list1391z00_563); } 
{ /* Llib/_pthread.scm 261 */
BgL_objectz00_bglt BgL_aux1392z00_564;
{ /* Llib/_pthread.scm 261 */
obj_t BgL_pairz00_565;
BgL_pairz00_565 = BgL_runner1393z00_562; 
BgL_aux1392z00_564 = 
((BgL_objectz00_bglt)
CAR(BgL_pairz00_565)); } 
BgL_runner1393z00_562 = 
CDR(BgL_runner1393z00_562); 
return 
BGl_objectzd2writezd2zz__objectz00(BgL_aux1392z00_564, BgL_runner1393z00_562);} } } 

}



/* &object-write-%pthrea1101 */
obj_t BGl_z62objectzd2writezd2z52pthrea1101z30zz__ft_z52pthreadz52(obj_t BgL_envz00_451, obj_t BgL_oz00_452, obj_t BgL_portz00_453)
{
{ /* Llib/_pthread.scm 247 */
{ /* Llib/_pthread.scm 248 */
obj_t BgL_arg1330z00_567;
{ /* Llib/_pthread.scm 248 */
bool_t BgL_test1714z00_1144;
if(
PAIRP(BgL_portz00_453))
{ /* Llib/_pthread.scm 248 */
obj_t BgL_tmpz00_1147;
BgL_tmpz00_1147 = 
CAR(BgL_portz00_453); 
BgL_test1714z00_1144 = 
OUTPUT_PORTP(BgL_tmpz00_1147); }  else 
{ /* Llib/_pthread.scm 248 */
BgL_test1714z00_1144 = ((bool_t)0)
; } 
if(BgL_test1714z00_1144)
{ /* Llib/_pthread.scm 248 */
BgL_arg1330z00_567 = 
CAR(BgL_portz00_453); }  else 
{ /* Llib/_pthread.scm 250 */
obj_t BgL_tmpz00_1151;
BgL_tmpz00_1151 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1330z00_567 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1151); } } 
{ /* Llib/_pthread.scm 252 */
obj_t BgL_zc3z04anonymousza31342ze3z87_568;
BgL_zc3z04anonymousza31342ze3z87_568 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31342ze3ze5zz__ft_z52pthreadz52, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31342ze3z87_568, 
(int)(((long)0)), 
((obj_t)
((BgL_z52pthreadz52_bglt)BgL_oz00_452))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1330z00_567, BgL_zc3z04anonymousza31342ze3z87_568);} } } 

}



/* &<@anonymous:1342> */
obj_t BGl_z62zc3z04anonymousza31342ze3ze5zz__ft_z52pthreadz52(obj_t BgL_envz00_454)
{
{ /* Llib/_pthread.scm 251 */
{ /* Llib/_pthread.scm 252 */
BgL_z52pthreadz52_bglt BgL_oz00_455;
BgL_oz00_455 = 
((BgL_z52pthreadz52_bglt)
PROCEDURE_REF(BgL_envz00_454, 
(int)(((long)0)))); 
{ /* Llib/_pthread.scm 254 */
obj_t BgL_thezd2parentzd2_569;
if(
(
((obj_t)BgL_oz00_455)==
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_oz00_455))->BgL_parentz00)))
{ /* Llib/_pthread.scm 254 */
BgL_thezd2parentzd2_569 = BGl_string1606z00zz__ft_z52pthreadz52; }  else 
{ /* Llib/_pthread.scm 254 */
BgL_thezd2parentzd2_569 = 
(((BgL_z52pthreadz52_bglt)COBJECT(BgL_oz00_455))->BgL_parentz00); } 
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1344z00_570;
BgL_arg1344z00_570 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_oz00_455)))->BgL_namez00); 
{ /* Llib/_pthread.scm 255 */
obj_t BgL_list1345z00_571;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1346z00_572;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1356z00_573;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1357z00_574;
{ /* Llib/_pthread.scm 255 */
obj_t BgL_arg1358z00_575;
BgL_arg1358z00_575 = 
MAKE_YOUNG_PAIR(BGl_string1607z00zz__ft_z52pthreadz52, BNIL); 
BgL_arg1357z00_574 = 
MAKE_YOUNG_PAIR(BgL_thezd2parentzd2_569, BgL_arg1358z00_575); } 
BgL_arg1356z00_573 = 
MAKE_YOUNG_PAIR(BGl_string1608z00zz__ft_z52pthreadz52, BgL_arg1357z00_574); } 
BgL_arg1346z00_572 = 
MAKE_YOUNG_PAIR(BgL_arg1344z00_570, BgL_arg1356z00_573); } 
BgL_list1345z00_571 = 
MAKE_YOUNG_PAIR(BGl_string1609z00zz__ft_z52pthreadz52, BgL_arg1346z00_572); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1345z00_571);} } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52pthreadz52()
{
{ /* Llib/_pthread.scm 6 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1610z00zz__ft_z52pthreadz52));} 

}

#ifdef __cplusplus
}
#endif
