/*===========================================================================*/
/*   (Llib/_scheduler.scm)                                                   */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/_scheduler.scm -o objs/_scheduler.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


static obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = BUNSPEC;
static obj_t BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52schedulerz52();
static obj_t BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_genericzd2initzd2zz__ft_z52schedulerz52();
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_objectzd2initzd2zz__ft_z52schedulerz52();
extern obj_t BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt, obj_t, obj_t);
static obj_t BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_fthreadz00_bglt);
static obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52();
static BgL_schedulerz00_bglt BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31340ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31325ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31334ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(obj_t);
extern obj_t BGl_ftenvzd2threadszd2zz__ft_envz00(BgL_ftenvz00_bglt);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
extern BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_signalzd2emitzd2zz__ft_signalz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
static obj_t BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
extern obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
extern obj_t BGl_schedulerz00zz__ft_typesz00;
static obj_t BGl_z62zc3z04anonymousza31188ze3ze5zz__ft_z52schedulerz52(obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52();
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52();
extern obj_t BGl_instantzd2envz12zc0zz__ft_envz00(BgL_ftenvz00_bglt);
static bool_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
BGL_IMPORT obj_t BGl_filterz12z12zz__r4_control_features_6_9z00(obj_t, obj_t);
static obj_t BGl_z62ntz62zz__ft_z52schedulerz52(obj_t);
static obj_t BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(obj_t, BgL_threadz00_bglt);
static obj_t BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
extern obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t __cnst[ 1 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752broadcastza71702za7, BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2spawnzd2asynczd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71703za7, BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52getzd2optionalzd2schedulerzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752getza7d2opti1704za7, BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1672z00zz__ft_z52schedulerz52, BgL_bgl_string1672za700za7za7_1705za7, "Llib/_scheduler.scm", 19 );
DEFINE_STRING( BGl_string1673z00zz__ft_z52schedulerz52, BgL_bgl_string1673za700za7za7_1706za7, "Illegal scheduler", 17 );
DEFINE_STRING( BGl_string1674z00zz__ft_z52schedulerz52, BgL_bgl_string1674za700za7za7_1707za7, "/builddir/build/BUILD/bigloo-4.4b/api/fthread/src/Llib/_scheduler.scm", 69 );
DEFINE_STRING( BGl_string1675z00zz__ft_z52schedulerz52, BgL_bgl_string1675za700za7za7_1708za7, "&%get-optional-scheduler", 24 );
DEFINE_STRING( BGl_string1676z00zz__ft_z52schedulerz52, BgL_bgl_string1676za700za7za7_1709za7, "symbol", 6 );
DEFINE_STRING( BGl_string1677z00zz__ft_z52schedulerz52, BgL_bgl_string1677za700za7za7_1710za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string1678z00zz__ft_z52schedulerz52, BgL_bgl_string1678za700za7za7_1711za7, "&%scheduler-add-async-runnable!", 31 );
DEFINE_STRING( BGl_string1679z00zz__ft_z52schedulerz52, BgL_bgl_string1679za700za7za7_1712za7, "%scheduler", 10 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulezd2instantzd2envz52zz__ft_z52schedulerz52, BgL_bgl_za762za752scheduleza7d1713za7, BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1680z00zz__ft_z52schedulerz52, BgL_bgl_string1680za700za7za7_1714za7, "fthread", 7 );
DEFINE_STRING( BGl_string1681z00zz__ft_z52schedulerz52, BgL_bgl_string1681za700za7za7_1715za7, "&%scheduler-add-async!", 22 );
DEFINE_STRING( BGl_string1682z00zz__ft_z52schedulerz52, BgL_bgl_string1682za700za7za7_1716za7, "%sigasync", 9 );
DEFINE_STRING( BGl_string1684z00zz__ft_z52schedulerz52, BgL_bgl_string1684za700za7za7_1717za7, "&%scheduler-next-thread", 23 );
DEFINE_STRING( BGl_string1685z00zz__ft_z52schedulerz52, BgL_bgl_string1685za700za7za7_1718za7, "scheduler", 9 );
DEFINE_STRING( BGl_string1686z00zz__ft_z52schedulerz52, BgL_bgl_string1686za700za7za7_1719za7, "&%scheduler-switch-to-next-thread", 33 );
DEFINE_STRING( BGl_string1687z00zz__ft_z52schedulerz52, BgL_bgl_string1687za700za7za7_1720za7, "&%schedule-instant", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1683z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1721za7, BGl_z62zc3z04anonymousza31188ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1693z00zz__ft_z52schedulerz52, BgL_bgl_string1693za700za7za7_1722za7, "&%scheduler-spawn-async", 23 );
DEFINE_STRING( BGl_string1694z00zz__ft_z52schedulerz52, BgL_bgl_string1694za700za7za7_1723za7, "&%broadcast!", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1688z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1724za7, BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1695z00zz__ft_z52schedulerz52, BgL_bgl_string1695za700za7za7_1725za7, "&%scheduler-add-broadcast!", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1689z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1726za7, BGl_z62zc3z04anonymousza31347ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1696z00zz__ft_z52schedulerz52, BgL_bgl_string1696za700za7za7_1727za7, "&%scheduler-time", 16 );
DEFINE_STRING( BGl_string1697z00zz__ft_z52schedulerz52, BgL_bgl_string1697za700za7za7_1728za7, "&%scheduler-waiting-threads", 27 );
DEFINE_STRING( BGl_string1698z00zz__ft_z52schedulerz52, BgL_bgl_string1698za700za7za7_1729za7, "__ft_%scheduler", 15 );
DEFINE_STRING( BGl_string1699z00zz__ft_z52schedulerz52, BgL_bgl_string1699za700za7za7_1730za7, "dead ", 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2asynczd2runnablez12zd2envz40zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71731za7, BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1690z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1732za7, BGl_z62zc3z04anonymousza31325ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1691z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1733za7, BGl_z62zc3z04anonymousza31334ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1692z00zz__ft_z52schedulerz52, BgL_bgl_za762za7c3za704anonymo1734za7, BGl_z62zc3z04anonymousza31340ze3ze5zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2asyncz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71735za7, BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2timezd2envz52zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71736za7, BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71737za7, BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2addzd2broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71738za7, BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2switchzd2tozd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71739za7, BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52schedulerzd2waitingzd2threadszd2envz80zz__ft_z52schedulerz52, BgL_bgl_za762za752schedulerza71740za7, BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long BgL_checksumz00_549, char * BgL_fromz00_550)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
BGl_cnstzd2initzd2zz__ft_z52schedulerz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52schedulerz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%scheduler"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_cportz00_526;
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_stringz00_534;
BgL_stringz00_534 = BGl_string1699z00zz__ft_z52schedulerz52; 
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_startz00_535;
BgL_startz00_535 = 
BINT(((long)0)); 
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_endz00_536;
BgL_endz00_536 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_534))); 
{ /* Llib/_scheduler.scm 15 */

BgL_cportz00_526 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_534, BgL_startz00_535, BgL_endz00_536); } } } } 
{ 
long BgL_iz00_527;
BgL_iz00_527 = ((long)0); 
BgL_loopz00_528:
if(
(BgL_iz00_527==((long)-1)))
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/_scheduler.scm 15 */
{ /* Llib/_scheduler.scm 15 */
obj_t BgL_arg1701z00_530;
{ /* Llib/_scheduler.scm 15 */

{ /* Llib/_scheduler.scm 15 */
obj_t BgL_locationz00_532;
BgL_locationz00_532 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_scheduler.scm 15 */

BgL_arg1701z00_530 = 
BGl_readz00zz__readerz00(BgL_cportz00_526, BgL_locationz00_532); } } } 
{ /* Llib/_scheduler.scm 15 */
int BgL_tmpz00_578;
BgL_tmpz00_578 = 
(int)(BgL_iz00_527); 
CNST_TABLE_SET(BgL_tmpz00_578, BgL_arg1701z00_530); } } 
{ /* Llib/_scheduler.scm 15 */
int BgL_auxz00_533;
BgL_auxz00_533 = 
(int)(
(BgL_iz00_527-((long)1))); 
{ 
long BgL_iz00_583;
BgL_iz00_583 = 
(long)(BgL_auxz00_533); 
BgL_iz00_527 = BgL_iz00_583; 
goto BgL_loopz00_528;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1672z00zz__ft_z52schedulerz52)); 
return BFALSE;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__ft_z52schedulerz52(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_40;
BgL_headz00_40 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_41;obj_t BgL_tailz00_42;
BgL_prevz00_41 = BgL_headz00_40; 
BgL_tailz00_42 = BgL_l1z00_1; 
BgL_loopz00_43:
if(
PAIRP(BgL_tailz00_42))
{ 
obj_t BgL_newzd2prevzd2_45;
BgL_newzd2prevzd2_45 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_42), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_41, BgL_newzd2prevzd2_45); 
{ 
obj_t BgL_tailz00_595;obj_t BgL_prevz00_594;
BgL_prevz00_594 = BgL_newzd2prevzd2_45; 
BgL_tailz00_595 = 
CDR(BgL_tailz00_42); 
BgL_tailz00_42 = BgL_tailz00_595; 
BgL_prevz00_41 = BgL_prevz00_594; 
goto BgL_loopz00_43;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_40);} } } 

}



/* %get-optional-scheduler */
BGL_EXPORTED_DEF BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t BgL_whoz00_3, obj_t BgL_oz00_4)
{
{ /* Llib/_scheduler.scm 54 */
if(
NULLP(BgL_oz00_4))
{ /* Llib/_scheduler.scm 57 */
obj_t BgL_sz00_49;
BgL_sz00_49 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_49, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 58 */
return 
((BgL_schedulerz00_bglt)BgL_sz00_49);}  else 
{ /* Llib/_scheduler.scm 60 */
BgL_schedulerz00_bglt BgL_arg1134z00_51;
BgL_arg1134z00_51 = 
BGl_makezd2schedulerzd2zz__ft_schedulerz00(BNIL); 
{ /* Llib/_scheduler.scm 60 */
obj_t BgL_list1135z00_52;
BgL_list1135z00_52 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1134z00_51), BNIL); 
return 
((BgL_schedulerz00_bglt)
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1135z00_52));} } }  else 
{ /* Llib/_scheduler.scm 61 */
bool_t BgL_test1746z00_609;
{ /* Llib/_scheduler.scm 61 */
obj_t BgL_arg1152z00_58;
BgL_arg1152z00_58 = 
CAR(BgL_oz00_4); 
BgL_test1746z00_609 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1152z00_58, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_test1746z00_609)
{ /* Llib/_scheduler.scm 61 */
return 
((BgL_schedulerz00_bglt)
CAR(BgL_oz00_4));}  else 
{ /* Llib/_scheduler.scm 64 */
obj_t BgL_arg1140z00_57;
BgL_arg1140z00_57 = 
CAR(BgL_oz00_4); 
return 
((BgL_schedulerz00_bglt)
BGl_errorz00zz__errorz00(BgL_whoz00_3, BGl_string1673z00zz__ft_z52schedulerz52, BgL_arg1140z00_57));} } } 

}



/* &%get-optional-scheduler */
BgL_schedulerz00_bglt BGl_z62z52getzd2optionalzd2schedulerz30zz__ft_z52schedulerz52(obj_t BgL_envz00_399, obj_t BgL_whoz00_400, obj_t BgL_oz00_401)
{
{ /* Llib/_scheduler.scm 54 */
{ /* Llib/_scheduler.scm 56 */
obj_t BgL_auxz00_624;obj_t BgL_auxz00_617;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_oz00_401))
{ /* Llib/_scheduler.scm 56 */
BgL_auxz00_624 = BgL_oz00_401
; }  else 
{ 
obj_t BgL_auxz00_627;
BgL_auxz00_627 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)2487)), BGl_string1675z00zz__ft_z52schedulerz52, BGl_string1677z00zz__ft_z52schedulerz52, BgL_oz00_401); 
FAILURE(BgL_auxz00_627,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_whoz00_400))
{ /* Llib/_scheduler.scm 56 */
BgL_auxz00_617 = BgL_whoz00_400
; }  else 
{ 
obj_t BgL_auxz00_620;
BgL_auxz00_620 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)2487)), BGl_string1675z00zz__ft_z52schedulerz52, BGl_string1676z00zz__ft_z52schedulerz52, BgL_whoz00_400); 
FAILURE(BgL_auxz00_620,BFALSE,BFALSE);} 
return 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(BgL_auxz00_617, BgL_auxz00_624);} } 

}



/* %scheduler-get-async-runnable */
obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_5, obj_t BgL_nvz00_6)
{
{ /* Llib/_scheduler.scm 73 */
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_arg1153z00_60;
BgL_arg1153z00_60 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_5)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1153z00_60)); } 
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_g1066z00_61;
{ /* Llib/_scheduler.scm 76 */
obj_t BgL_vz00_63;
BgL_vz00_63 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_5))->BgL_asynczd2runnablezd2); 
if(
PAIRP(BgL_nvz00_6))
{ /* Llib/_scheduler.scm 77 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_5))->BgL_asynczd2runnablezd2)=((obj_t)
CAR(BgL_nvz00_6)),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 77 */BFALSE; } 
BgL_g1066z00_61 = BgL_vz00_63; } 
{ /* Llib/_scheduler.scm 74 */
obj_t BgL_arg1155z00_62;
BgL_arg1155z00_62 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_5)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1155z00_62)); } 
return BgL_g1066z00_61;} } 

}



/* %scheduler-add-async-runnable! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_7, BgL_fthreadz00_bglt BgL_tz00_8)
{
{ /* Llib/_scheduler.scm 88 */
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_arg1157z00_68;
BgL_arg1157z00_68 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1157z00_68)); } 
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_g1069z00_69;
{ 
obj_t BgL_auxz00_649;
{ /* Llib/_scheduler.scm 94 */
obj_t BgL_arg1159z00_72;
BgL_arg1159z00_72 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_7))->BgL_asynczd2runnablezd2); 
BgL_auxz00_649 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_8), BgL_arg1159z00_72); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_7))->BgL_asynczd2runnablezd2)=((obj_t)BgL_auxz00_649),BUNSPEC); } 
{ /* Llib/_scheduler.scm 95 */
obj_t BgL_arg1160z00_73;
BgL_arg1160z00_73 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1160z00_73)); } 
BgL_g1069z00_69 = BUNSPEC; 
{ /* Llib/_scheduler.scm 91 */
obj_t BgL_arg1158z00_70;
BgL_arg1158z00_70 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_7)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1158z00_70)); } 
return BgL_g1069z00_69;} } 

}



/* &%scheduler-add-async-runnable! */
obj_t BGl_z62z52schedulerzd2addzd2asynczd2runnablez12zf0zz__ft_z52schedulerz52(obj_t BgL_envz00_402, obj_t BgL_scdlz00_403, obj_t BgL_tz00_404)
{
{ /* Llib/_scheduler.scm 88 */
{ /* Llib/_scheduler.scm 91 */
BgL_fthreadz00_bglt BgL_auxz00_670;BgL_z52schedulerz52_bglt BgL_auxz00_662;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_404, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 91 */
BgL_auxz00_670 = 
((BgL_fthreadz00_bglt)BgL_tz00_404)
; }  else 
{ 
obj_t BgL_auxz00_674;
BgL_auxz00_674 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)4155)), BGl_string1678z00zz__ft_z52schedulerz52, BGl_string1680z00zz__ft_z52schedulerz52, BgL_tz00_404); 
FAILURE(BgL_auxz00_674,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_403, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 91 */
BgL_auxz00_662 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_403)
; }  else 
{ 
obj_t BgL_auxz00_666;
BgL_auxz00_666 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)4155)), BGl_string1678z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_403); 
FAILURE(BgL_auxz00_666,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_auxz00_662, BgL_auxz00_670);} } 

}



/* %scheduler-add-async! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_9, BgL_z52sigasyncz52_bglt BgL_sigz00_10)
{
{ /* Llib/_scheduler.scm 101 */
{ 
obj_t BgL_auxz00_679;
{ /* Llib/_scheduler.scm 103 */
obj_t BgL_arg1161z00_322;
BgL_arg1161z00_322 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_tospawnz00); 
BgL_auxz00_679 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_sigz00_10), BgL_arg1161z00_322); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_9))->BgL_tospawnz00)=((obj_t)BgL_auxz00_679),BUNSPEC);} } 

}



/* &%scheduler-add-async! */
obj_t BGl_z62z52schedulerzd2addzd2asyncz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_405, obj_t BgL_scdlz00_406, obj_t BgL_sigz00_407)
{
{ /* Llib/_scheduler.scm 101 */
{ /* Llib/_scheduler.scm 102 */
BgL_z52sigasyncz52_bglt BgL_auxz00_692;BgL_z52schedulerz52_bglt BgL_auxz00_684;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_407, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 102 */
BgL_auxz00_692 = 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_407)
; }  else 
{ 
obj_t BgL_auxz00_696;
BgL_auxz00_696 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)4674)), BGl_string1681z00zz__ft_z52schedulerz52, BGl_string1682z00zz__ft_z52schedulerz52, BgL_sigz00_407); 
FAILURE(BgL_auxz00_696,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_406, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 102 */
BgL_auxz00_684 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_406)
; }  else 
{ 
obj_t BgL_auxz00_688;
BgL_auxz00_688 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)4674)), BGl_string1681z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_406); 
FAILURE(BgL_auxz00_688,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_auxz00_684, BgL_auxz00_692);} } 

}



/* %scheduler-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt BgL_tz00_11, BgL_schedulerz00_bglt BgL_scdlz00_12)
{
{ /* Llib/_scheduler.scm 108 */
{ /* Llib/_scheduler.scm 152 */
obj_t BgL_arg1186z00_323;
{ /* Llib/_scheduler.scm 152 */
obj_t BgL_tmpz00_701;
BgL_tmpz00_701 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1186z00_323 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_701); } 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1186z00_323, BGl_proc1683z00zz__ft_z52schedulerz52); } 
{ 
obj_t BgL_runnablez00_79;
{ /* Llib/_scheduler.scm 115 */
obj_t BgL_arg1165z00_78;
BgL_arg1165z00_78 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2); 
BgL_runnablez00_79 = BgL_arg1165z00_78; 
BgL_zc3z04anonymousza31166ze3z87_80:
if(
PAIRP(BgL_runnablez00_79))
{ /* Llib/_scheduler.scm 118 */
obj_t BgL_ntz00_82;
BgL_ntz00_82 = 
CAR(BgL_runnablez00_79); 
if(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_82)))->BgL_z52iszd2suspendz80))
{ /* Llib/_scheduler.scm 120 */
{ 
obj_t BgL_auxz00_713;
{ /* Llib/_scheduler.scm 122 */
obj_t BgL_arg1169z00_85;
BgL_arg1169z00_85 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2yieldzd2); 
BgL_auxz00_713 = 
MAKE_YOUNG_PAIR(BgL_ntz00_82, BgL_arg1169z00_85); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2yieldzd2)=((obj_t)BgL_auxz00_713),BUNSPEC); } 
{ 
obj_t BgL_runnablez00_719;
BgL_runnablez00_719 = 
CDR(BgL_runnablez00_79); 
BgL_runnablez00_79 = BgL_runnablez00_719; 
goto BgL_zc3z04anonymousza31166ze3z87_80;} }  else 
{ /* Llib/_scheduler.scm 120 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_ntz00_82), BNIL))
{ 
obj_t BgL_runnablez00_724;
BgL_runnablez00_724 = 
CDR(BgL_runnablez00_79); 
BgL_runnablez00_79 = BgL_runnablez00_724; 
goto BgL_zc3z04anonymousza31166ze3z87_80;}  else 
{ /* Llib/_scheduler.scm 124 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)=((obj_t)
CDR(BgL_runnablez00_79)),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 128 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 128 */BFALSE; } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_currentzd2threadzd2)=((obj_t)BgL_ntz00_82),BUNSPEC); 
return BgL_ntz00_82;} } }  else 
{ /* Llib/_scheduler.scm 133 */
obj_t BgL_asyncz00_96;
{ /* Llib/_scheduler.scm 133 */
obj_t BgL_list1185z00_104;
BgL_list1185z00_104 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_asyncz00_96 = 
BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12), BgL_list1185z00_104); } 
if(
NULLP(BgL_asyncz00_96))
{ /* Llib/_scheduler.scm 134 */
return 
((obj_t)BgL_scdlz00_12);}  else 
{ /* Llib/_scheduler.scm 135 */
obj_t BgL_ntz00_98;
BgL_ntz00_98 = 
CAR(BgL_asyncz00_96); 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)=((obj_t)
CDR(BgL_asyncz00_96)),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 137 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 137 */
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_threadszd2runnablezd2))),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_12)))->BgL_currentzd2threadzd2)=((obj_t)BgL_ntz00_98),BUNSPEC); 
return BgL_ntz00_98;} } } } } 

}



/* &%scheduler-next-thread */
obj_t BGl_z62z52schedulerzd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t BgL_envz00_409, obj_t BgL_tz00_410, obj_t BgL_scdlz00_411)
{
{ /* Llib/_scheduler.scm 108 */
{ /* Llib/_scheduler.scm 109 */
BgL_schedulerz00_bglt BgL_auxz00_768;BgL_fthreadz00_bglt BgL_auxz00_760;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_411, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 109 */
BgL_auxz00_768 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_411)
; }  else 
{ 
obj_t BgL_auxz00_772;
BgL_auxz00_772 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)5042)), BGl_string1684z00zz__ft_z52schedulerz52, BGl_string1685z00zz__ft_z52schedulerz52, BgL_scdlz00_411); 
FAILURE(BgL_auxz00_772,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_410, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 109 */
BgL_auxz00_760 = 
((BgL_fthreadz00_bglt)BgL_tz00_410)
; }  else 
{ 
obj_t BgL_auxz00_764;
BgL_auxz00_764 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)5042)), BGl_string1684z00zz__ft_z52schedulerz52, BGl_string1680z00zz__ft_z52schedulerz52, BgL_tz00_410); 
FAILURE(BgL_auxz00_764,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_760, BgL_auxz00_768);} } 

}



/* &<@anonymous:1188> */
obj_t BGl_z62zc3z04anonymousza31188ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_412)
{
{ /* Llib/_scheduler.scm 153 */
return BUNSPEC;} 

}



/* %scheduler-switch-to-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt BgL_tz00_15, BgL_schedulerz00_bglt BgL_scdlz00_16)
{
{ /* Llib/_scheduler.scm 171 */
{ /* Llib/_scheduler.scm 174 */
obj_t BgL_ntz00_112;
BgL_ntz00_112 = 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_15, BgL_scdlz00_16); 
{ /* Llib/_scheduler.scm 177 */
obj_t BgL_arg1189z00_114;obj_t BgL_arg1190z00_115;
BgL_arg1189z00_114 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52builtinz52); 
BgL_arg1190z00_115 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_112)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_arg1189z00_114, 
((BgL_z52pthreadz52_bglt)BgL_arg1190z00_115)); } 
if(
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52statez52)==
CNST_TABLE_REF(((long)0))))
{ /* Llib/_scheduler.scm 178 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 178 */
{ /* Llib/_scheduler.scm 179 */
obj_t BgL_arg1201z00_118;
BgL_arg1201z00_118 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_15))->BgL_z52builtinz52); 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1201z00_118)); } 
return BUNSPEC;} } } 

}



/* &%scheduler-switch-to-next-thread */
obj_t BGl_z62z52schedulerzd2switchzd2tozd2nextzd2threadz30zz__ft_z52schedulerz52(obj_t BgL_envz00_413, obj_t BgL_tz00_414, obj_t BgL_scdlz00_415)
{
{ /* Llib/_scheduler.scm 171 */
{ /* Llib/_scheduler.scm 172 */
BgL_schedulerz00_bglt BgL_auxz00_798;BgL_fthreadz00_bglt BgL_auxz00_790;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_415, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 172 */
BgL_auxz00_798 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_415)
; }  else 
{ 
obj_t BgL_auxz00_802;
BgL_auxz00_802 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)7677)), BGl_string1686z00zz__ft_z52schedulerz52, BGl_string1685z00zz__ft_z52schedulerz52, BgL_scdlz00_415); 
FAILURE(BgL_auxz00_802,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_414, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 172 */
BgL_auxz00_790 = 
((BgL_fthreadz00_bglt)BgL_tz00_414)
; }  else 
{ 
obj_t BgL_auxz00_794;
BgL_auxz00_794 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)7677)), BGl_string1686z00zz__ft_z52schedulerz52, BGl_string1680z00zz__ft_z52schedulerz52, BgL_tz00_414); 
FAILURE(BgL_auxz00_794,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_790, BgL_auxz00_798);} } 

}



/* %schedule-instant */
BGL_EXPORTED_DEF obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_20)
{
{ /* Llib/_scheduler.scm 195 */
BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(
((BgL_schedulerz00_bglt)BgL_scdlz00_20)); 
BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_scdlz00_20); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
((BgL_fthreadz00_bglt)BgL_scdlz00_20), 
((BgL_schedulerz00_bglt)BgL_scdlz00_20)); 
return 
BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_scdlz00_20);} 

}



/* &%schedule-instant */
obj_t BGl_z62z52schedulezd2instantze2zz__ft_z52schedulerz52(obj_t BgL_envz00_416, obj_t BgL_scdlz00_417)
{
{ /* Llib/_scheduler.scm 195 */
{ /* Llib/_scheduler.scm 211 */
BgL_z52schedulerz52_bglt BgL_auxz00_818;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_417, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 211 */
BgL_auxz00_818 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_417)
; }  else 
{ 
obj_t BgL_auxz00_822;
BgL_auxz00_822 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)9510)), BGl_string1687z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_417); 
FAILURE(BgL_auxz00_822,BFALSE,BFALSE);} 
return 
BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_auxz00_818);} } 

}



/* %env-init-instant */
bool_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_21)
{
{ /* Llib/_scheduler.scm 220 */
{ /* Llib/_scheduler.scm 222 */
obj_t BgL_g1110z00_121;
BgL_g1110z00_121 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)
((BgL_z52schedulerz52_bglt)BgL_scdlz00_21))))->BgL_envzb2zb2); 
{ 
obj_t BgL_l1108z00_123;
BgL_l1108z00_123 = BgL_g1110z00_121; 
BgL_zc3z04anonymousza31207ze3z87_124:
if(
PAIRP(BgL_l1108z00_123))
{ /* Llib/_scheduler.scm 222 */
{ /* Llib/_scheduler.scm 222 */
obj_t BgL_arg1209z00_126;
BgL_arg1209z00_126 = 
CAR(BgL_l1108z00_123); 
BGl_instantzd2envz12zc0zz__ft_envz00(
((BgL_ftenvz00_bglt)BgL_arg1209z00_126)); } 
{ 
obj_t BgL_l1108z00_835;
BgL_l1108z00_835 = 
CDR(BgL_l1108z00_123); 
BgL_l1108z00_123 = BgL_l1108z00_835; 
goto BgL_zc3z04anonymousza31207ze3z87_124;} }  else 
{ /* Llib/_scheduler.scm 222 */
return ((bool_t)1);} } } } 

}



/* %sort-threads */
obj_t BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(obj_t BgL_threadsz00_22)
{
{ /* Llib/_scheduler.scm 227 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_threadsz00_22, BGl_proc1688z00zz__ft_z52schedulerz52);} 

}



/* &<@anonymous:1218> */
obj_t BGl_z62zc3z04anonymousza31218ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_419, obj_t BgL_t1z00_420, obj_t BgL_t2z00_421)
{
{ /* Llib/_scheduler.scm 229 */
return 
BBOOL(
(
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_t1z00_420)))->BgL_z52identz52))<
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_t2z00_421)))->BgL_z52identz52))));} 

}



/* %select-threads! */
obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_23)
{
{ /* Llib/_scheduler.scm 240 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/_scheduler.scm 264 */
obj_t BgL_runnablez00_428;
{ /* Llib/_scheduler.scm 264 */
obj_t BgL_cellvalz00_847;
BgL_cellvalz00_847 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2yieldzd2); 
BgL_runnablez00_428 = 
MAKE_CELL(BgL_cellvalz00_847); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2yieldzd2)=((obj_t)BNIL),BUNSPEC); 
{ 
obj_t BgL_auxz00_850;
{ /* Llib/_scheduler.scm 267 */
obj_t BgL_arg1227z00_147;
BgL_arg1227z00_147 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2timeoutzd2); 
{ /* Llib/_scheduler.scm 268 */
obj_t BgL_zc3z04anonymousza31228ze3z87_422;
BgL_zc3z04anonymousza31228ze3z87_422 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31228ze3ze5zz__ft_z52schedulerz52, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_422, 
(int)(((long)0)), 
((obj_t)BgL_scdlz00_23)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31228ze3z87_422, 
(int)(((long)1)), 
((obj_t)BgL_runnablez00_428)); 
BgL_auxz00_850 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BgL_zc3z04anonymousza31228ze3z87_422, BgL_arg1227z00_147); } } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_auxz00_850),BUNSPEC); } 
if(
CBOOL(
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_23)))->BgL_strictzd2orderzf3z21)))
{ /* Llib/_scheduler.scm 285 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)=((obj_t)
BGl_z52sortzd2threadsz80zz__ft_z52schedulerz52(
CELL_REF(BgL_runnablez00_428))),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 285 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)=((obj_t)
CELL_REF(BgL_runnablez00_428)),BUNSPEC); } 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2)))
{ /* Llib/_scheduler.scm 288 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC);}  else 
{ /* Llib/_scheduler.scm 288 */
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_23))->BgL_threadszd2runnablezd2))),BUNSPEC);} } } 

}



/* &<@anonymous:1228> */
obj_t BGl_z62zc3z04anonymousza31228ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_423, obj_t BgL_tz00_426)
{
{ /* Llib/_scheduler.scm 267 */
{ /* Llib/_scheduler.scm 268 */
BgL_z52schedulerz52_bglt BgL_i1081z00_424;obj_t BgL_runnablez00_425;
BgL_i1081z00_424 = 
((BgL_z52schedulerz52_bglt)
PROCEDURE_REF(BgL_envz00_423, 
(int)(((long)0)))); 
BgL_runnablez00_425 = 
PROCEDURE_REF(BgL_envz00_423, 
(int)(((long)1))); 
{ /* Llib/_scheduler.scm 268 */
bool_t BgL_tmpz00_882;
{ 

{ /* Llib/_scheduler.scm 269 */
int BgL_aux1085z00_539;
BgL_aux1085z00_539 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_426)))->BgL_z52timeoutz52); 
{ /* Llib/_scheduler.scm 269 */
obj_t BgL_aux1087z00_540;
BgL_aux1087z00_540 = 
BINT(BgL_aux1085z00_539); 
switch( 
(long)CINT(BgL_aux1087z00_540)) { case ((long)0) : 

BgL_tmpz00_882 = ((bool_t)0); break;case ((long)1) : 

{ /* Llib/_scheduler.scm 276 */
obj_t BgL_g1124z00_541;
BgL_g1124z00_541 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_426)))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1122z00_543;
BgL_l1122z00_543 = BgL_g1124z00_541; 
BgL_zc3z04anonymousza31632ze3z87_542:
if(
PAIRP(BgL_l1122z00_543))
{ /* Llib/_scheduler.scm 276 */
{ /* Llib/_scheduler.scm 276 */
obj_t BgL_sz00_544;
BgL_sz00_544 = 
CAR(BgL_l1122z00_543); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_544, 
((BgL_threadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_426))); } 
{ 
obj_t BgL_l1122z00_894;
BgL_l1122z00_894 = 
CDR(BgL_l1122z00_543); 
BgL_l1122z00_543 = BgL_l1122z00_894; 
goto BgL_zc3z04anonymousza31632ze3z87_542;} }  else 
{ /* Llib/_scheduler.scm 276 */((bool_t)1); } } } 
{ /* Llib/_scheduler.scm 277 */
obj_t BgL_auxz00_545;
BgL_auxz00_545 = 
MAKE_YOUNG_PAIR(BgL_tz00_426, 
CELL_REF(BgL_runnablez00_425)); 
CELL_SET(BgL_runnablez00_425, BgL_auxz00_545); } 
BgL_tmpz00_882 = ((bool_t)0); break;
default: 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_426)))->BgL_z52timeoutz52)=((int)
(int)(
(
(long)(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_426)))->BgL_z52timeoutz52))-((long)1)))),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1081z00_424))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
BgL_tmpz00_882 = ((bool_t)1); } } } } 
return 
BBOOL(BgL_tmpz00_882);} } } 

}



/* %start-new-threads */
obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_sz00_24)
{
{ /* Llib/_scheduler.scm 297 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00)))
{ /* Llib/_scheduler.scm 301 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 301 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)))
{ /* Llib/_scheduler.scm 303 */
{ 
obj_t BgL_auxz00_914;
{ /* Llib/_scheduler.scm 309 */
obj_t BgL_arg1277z00_173;obj_t BgL_arg1279z00_174;
BgL_arg1277z00_173 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2); 
{ /* Llib/_scheduler.scm 309 */
obj_t BgL_arg1280z00_175;
BgL_arg1280z00_175 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00); 
BgL_arg1279z00_174 = 
bgl_reverse_bang(BgL_arg1280z00_175); } 
BgL_auxz00_914 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BgL_arg1277z00_173, BgL_arg1279z00_174); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_914),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2))),BUNSPEC); }  else 
{ /* Llib/_scheduler.scm 303 */
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2), 
bgl_reverse_bang(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00))); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_threadszd2runnablezd2lastzd2pairzd2))),BUNSPEC); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_sz00_24))->BgL_tostartz00)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %terminate-threads */
obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_25)
{
{ /* Llib/_scheduler.scm 319 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)))
{ /* Llib/_scheduler.scm 324 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 329 */
obj_t BgL_thdsz00_182;
BgL_thdsz00_182 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1689z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_toterminatez00)=((obj_t)BNIL),BUNSPEC); 
{ /* Llib/_scheduler.scm 340 */
obj_t BgL_runnablez00_183;obj_t BgL_yieldz00_184;obj_t BgL_timeoutz00_185;
BgL_runnablez00_183 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1690z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)); 
BgL_yieldz00_184 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1691z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2yieldzd2)); 
BgL_timeoutz00_185 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc1692z00zz__ft_z52schedulerz52, 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2timeoutzd2)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)=((obj_t)BgL_thdsz00_182),BUNSPEC); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
((BgL_fthreadz00_bglt)BgL_scdlz00_25), 
((BgL_schedulerz00_bglt)BgL_scdlz00_25)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2runnablezd2)=((obj_t)BgL_runnablez00_183),BUNSPEC); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2yieldzd2)=((obj_t)BgL_yieldz00_184),BUNSPEC); 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_25))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_timeoutz00_185),BUNSPEC);} } } 

}



/* &<@anonymous:1340> */
obj_t BGl_z62zc3z04anonymousza31340ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_434, obj_t BgL_tz00_435)
{
{ /* Llib/_scheduler.scm 346 */
{ /* Llib/_scheduler.scm 347 */
bool_t BgL_tmpz00_950;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_435), BNIL))
{ /* Llib/_scheduler.scm 347 */
BgL_tmpz00_950 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 347 */
BgL_tmpz00_950 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_950);} } 

}



/* &<@anonymous:1334> */
obj_t BGl_z62zc3z04anonymousza31334ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_436, obj_t BgL_tz00_437)
{
{ /* Llib/_scheduler.scm 343 */
{ /* Llib/_scheduler.scm 344 */
bool_t BgL_tmpz00_955;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_437), BNIL))
{ /* Llib/_scheduler.scm 344 */
BgL_tmpz00_955 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 344 */
BgL_tmpz00_955 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_955);} } 

}



/* &<@anonymous:1325> */
obj_t BGl_z62zc3z04anonymousza31325ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_438, obj_t BgL_tz00_439)
{
{ /* Llib/_scheduler.scm 340 */
{ /* Llib/_scheduler.scm 341 */
bool_t BgL_tmpz00_960;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_439), BNIL))
{ /* Llib/_scheduler.scm 341 */
BgL_tmpz00_960 = ((bool_t)0)
; }  else 
{ /* Llib/_scheduler.scm 341 */
BgL_tmpz00_960 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_960);} } 

}



/* &<@anonymous:1347> */
obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__ft_z52schedulerz52(obj_t BgL_envz00_440, obj_t BgL_tz00_441)
{
{ /* Llib/_scheduler.scm 329 */
{ /* Llib/_scheduler.scm 330 */
bool_t BgL_tmpz00_965;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_441), BNIL))
{ /* Llib/_scheduler.scm 330 */
{ /* Llib/_scheduler.scm 332 */
obj_t BgL_list1348z00_546;
BgL_list1348z00_546 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_441), BgL_list1348z00_546); } 
BgL_tmpz00_965 = ((bool_t)1); }  else 
{ /* Llib/_scheduler.scm 330 */
BgL_tmpz00_965 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_965);} } 

}



/* %suspend/resume-threads */
obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_26)
{
{ /* Llib/_scheduler.scm 364 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)))
{ /* Llib/_scheduler.scm 366 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 366 */
{ /* Llib/_scheduler.scm 368 */
obj_t BgL_g1113z00_222;
BgL_g1113z00_222 = 
bgl_reverse_bang(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)); 
{ 
obj_t BgL_l1111z00_224;
BgL_l1111z00_224 = BgL_g1113z00_222; 
BgL_zc3z04anonymousza31364ze3z87_225:
if(
PAIRP(BgL_l1111z00_224))
{ /* Llib/_scheduler.scm 371 */
{ /* Llib/_scheduler.scm 369 */
obj_t BgL_vz00_227;
BgL_vz00_227 = 
CAR(BgL_l1111z00_224); 
{ /* Llib/_scheduler.scm 369 */
BgL_fthreadz00_bglt BgL_i1092z00_228;
BgL_i1092z00_228 = 
((BgL_fthreadz00_bglt)
CAR(
((obj_t)BgL_vz00_227))); 
((((BgL_fthreadz00_bglt)COBJECT(BgL_i1092z00_228))->BgL_z52iszd2suspendz80)=((bool_t)
CBOOL(
CDR(
((obj_t)BgL_vz00_227)))),BUNSPEC); } } 
{ 
obj_t BgL_l1111z00_988;
BgL_l1111z00_988 = 
CDR(BgL_l1111z00_224); 
BgL_l1111z00_224 = BgL_l1111z00_988; 
goto BgL_zc3z04anonymousza31364ze3z87_225;} }  else 
{ /* Llib/_scheduler.scm 371 */((bool_t)1); } } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_26))->BgL_tosuspendzf2resumezf2)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %scheduler-spawn-async */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_27, BgL_z52sigasyncz52_bglt BgL_sigz00_28)
{
{ /* Llib/_scheduler.scm 377 */
if(
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_spawnedz00))
{ /* Llib/_scheduler.scm 379 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_ntz00_442;
BgL_ntz00_442 = 
MAKE_FX_PROCEDURE(BGl_z62ntz62zz__ft_z52schedulerz52, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_ntz00_442, 
(int)(((long)0)), 
((obj_t)BgL_sigz00_28)); 
PROCEDURE_SET(BgL_ntz00_442, 
(int)(((long)1)), 
((obj_t)BgL_scdlz00_27)); 
PROCEDURE_SET(BgL_ntz00_442, 
(int)(((long)2)), 
((obj_t)BgL_sigz00_28)); 
((((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_spawnedz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/_scheduler.scm 385 */
obj_t BgL_arg1506z00_237;obj_t BgL_arg1507z00_238;
BgL_arg1506z00_237 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_27)))->BgL_z52builtinz52); 
BgL_arg1507z00_238 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_sigz00_28))->BgL_idz00); 
BGl_z52asynczd2spawnz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1506z00_237), BgL_ntz00_442, BgL_arg1507z00_238); } 
return BUNSPEC;} } 

}



/* &%scheduler-spawn-async */
obj_t BGl_z62z52schedulerzd2spawnzd2asyncz30zz__ft_z52schedulerz52(obj_t BgL_envz00_443, obj_t BgL_scdlz00_444, obj_t BgL_sigz00_445)
{
{ /* Llib/_scheduler.scm 377 */
{ /* Llib/_scheduler.scm 378 */
BgL_z52sigasyncz52_bglt BgL_auxz00_1019;BgL_z52schedulerz52_bglt BgL_auxz00_1011;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_445, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 378 */
BgL_auxz00_1019 = 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_445)
; }  else 
{ 
obj_t BgL_auxz00_1023;
BgL_auxz00_1023 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)16633)), BGl_string1693z00zz__ft_z52schedulerz52, BGl_string1682z00zz__ft_z52schedulerz52, BgL_sigz00_445); 
FAILURE(BgL_auxz00_1023,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_444, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 378 */
BgL_auxz00_1011 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_444)
; }  else 
{ 
obj_t BgL_auxz00_1015;
BgL_auxz00_1015 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)16633)), BGl_string1693z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_444); 
FAILURE(BgL_auxz00_1015,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_auxz00_1011, BgL_auxz00_1019);} } 

}



/* &nt */
obj_t BGl_z62ntz62zz__ft_z52schedulerz52(obj_t BgL_envz00_446)
{
{ /* Llib/_scheduler.scm 380 */
{ /* Llib/_scheduler.scm 381 */
BgL_z52sigasyncz52_bglt BgL_i1093z00_447;BgL_z52schedulerz52_bglt BgL_scdlz00_448;BgL_z52sigasyncz52_bglt BgL_sigz00_449;
BgL_i1093z00_447 = 
((BgL_z52sigasyncz52_bglt)
PROCEDURE_REF(BgL_envz00_446, 
(int)(((long)0)))); 
BgL_scdlz00_448 = 
((BgL_z52schedulerz52_bglt)
PROCEDURE_REF(BgL_envz00_446, 
(int)(((long)1)))); 
BgL_sigz00_449 = 
((BgL_z52sigasyncz52_bglt)
PROCEDURE_REF(BgL_envz00_446, 
(int)(((long)2)))); 
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_arg1512z00_547;
{ /* Llib/_scheduler.scm 381 */
obj_t BgL_fun1513z00_548;
BgL_fun1513z00_548 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(BgL_i1093z00_447))->BgL_thunkz00); 
BgL_arg1512z00_547 = 
PROCEDURE_ENTRY(BgL_fun1513z00_548)(BgL_fun1513z00_548, BEOA); } 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_scdlz00_448, 
((obj_t)BgL_sigz00_449), BgL_arg1512z00_547); } 
return BUNSPEC;} } 

}



/* %spawn-async */
obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_29)
{
{ /* Llib/_scheduler.scm 395 */
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00)))
{ /* Llib/_scheduler.scm 397 */
return BFALSE;}  else 
{ /* Llib/_scheduler.scm 397 */
{ /* Llib/_scheduler.scm 398 */
obj_t BgL_g1116z00_246;
BgL_g1116z00_246 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00); 
{ 
obj_t BgL_l1114z00_248;
BgL_l1114z00_248 = BgL_g1116z00_246; 
BgL_zc3z04anonymousza31519ze3z87_249:
if(
PAIRP(BgL_l1114z00_248))
{ /* Llib/_scheduler.scm 398 */
{ /* Llib/_scheduler.scm 398 */
obj_t BgL_sz00_251;
BgL_sz00_251 = 
CAR(BgL_l1114z00_248); 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_scdlz00_29, 
((BgL_z52sigasyncz52_bglt)BgL_sz00_251)); } 
{ 
obj_t BgL_l1114z00_1052;
BgL_l1114z00_1052 = 
CDR(BgL_l1114z00_248); 
BgL_l1114z00_248 = BgL_l1114z00_1052; 
goto BgL_zc3z04anonymousza31519ze3z87_249;} }  else 
{ /* Llib/_scheduler.scm 398 */((bool_t)1); } } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_29))->BgL_tospawnz00)=((obj_t)BNIL),BUNSPEC);} } 

}



/* %broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_30, obj_t BgL_sigz00_31, obj_t BgL_valz00_32)
{
{ /* Llib/_scheduler.scm 404 */
{ /* Llib/_scheduler.scm 408 */
obj_t BgL_arg1531z00_367;
BgL_arg1531z00_367 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_30)))->BgL_envzb2zb2); 
return 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_sigz00_31, BgL_valz00_32, BgL_arg1531z00_367);} } 

}



/* &%broadcast! */
obj_t BGl_z62z52broadcastz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_450, obj_t BgL_scdlz00_451, obj_t BgL_sigz00_452, obj_t BgL_valz00_453)
{
{ /* Llib/_scheduler.scm 404 */
{ /* Llib/_scheduler.scm 407 */
BgL_z52schedulerz52_bglt BgL_auxz00_1058;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_451, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 407 */
BgL_auxz00_1058 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_451)
; }  else 
{ 
obj_t BgL_auxz00_1062;
BgL_auxz00_1062 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)17989)), BGl_string1694z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_451); 
FAILURE(BgL_auxz00_1062,BFALSE,BFALSE);} 
return 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_1058, BgL_sigz00_452, BgL_valz00_453);} } 

}



/* %scheduler-broadcast*! */
obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_33)
{
{ /* Llib/_scheduler.scm 413 */
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_arg1538z00_259;
BgL_arg1538z00_259 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_33)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1538z00_259)); } 
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_g1099z00_260;
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00)))
{ /* Llib/_scheduler.scm 421 */
BgL_g1099z00_260 = BFALSE; }  else 
{ /* Llib/_scheduler.scm 421 */
{ /* Llib/_scheduler.scm 423 */
obj_t BgL_g1121z00_265;
BgL_g1121z00_265 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00); 
{ 
obj_t BgL_l1117z00_267;
BgL_l1117z00_267 = BgL_g1121z00_265; 
BgL_zc3z04anonymousza31542ze3z87_268:
if(
PAIRP(BgL_l1117z00_267))
{ /* Llib/_scheduler.scm 423 */
{ /* Llib/_scheduler.scm 423 */
obj_t BgL_arg1544z00_270;
BgL_arg1544z00_270 = 
CAR(BgL_l1117z00_267); 
{ /* Llib/_scheduler.scm 415 */
obj_t BgL_arg1580z00_376;obj_t BgL_arg1581z00_377;
BgL_arg1580z00_376 = 
CAR(
((obj_t)BgL_arg1544z00_270)); 
BgL_arg1581z00_377 = 
CDR(
((obj_t)BgL_arg1544z00_270)); 
{ /* Llib/_scheduler.scm 408 */
obj_t BgL_arg1531z00_382;
BgL_arg1531z00_382 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_33)))->BgL_envzb2zb2); 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_arg1580z00_376, BgL_arg1581z00_377, BgL_arg1531z00_382); } } } 
{ 
obj_t BgL_l1117z00_1085;
BgL_l1117z00_1085 = 
CDR(BgL_l1117z00_267); 
BgL_l1117z00_267 = BgL_l1117z00_1085; 
goto BgL_zc3z04anonymousza31542ze3z87_268;} }  else 
{ /* Llib/_scheduler.scm 423 */((bool_t)1); } } } 
BgL_g1099z00_260 = 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_33))->BgL_tobroadcastz00)=((obj_t)BNIL),BUNSPEC); } 
{ /* Llib/_scheduler.scm 416 */
obj_t BgL_arg1539z00_261;
BgL_arg1539z00_261 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_33)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1539z00_261)); } 
return BgL_g1099z00_260;} } 

}



/* %scheduler-add-broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_34, obj_t BgL_sigz00_35, obj_t BgL_valz00_36)
{
{ /* Llib/_scheduler.scm 433 */
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_arg1582z00_280;
BgL_arg1582z00_280 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2synchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1582z00_280)); } 
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_g1102z00_281;
{ /* Llib/_scheduler.scm 437 */
obj_t BgL_svz00_284;
BgL_svz00_284 = 
MAKE_YOUNG_PAIR(BgL_sigz00_35, BgL_valz00_36); 
{ 
obj_t BgL_auxz00_1097;
{ /* Llib/_scheduler.scm 438 */
obj_t BgL_arg1593z00_285;
BgL_arg1593z00_285 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_34))->BgL_tobroadcastz00); 
BgL_auxz00_1097 = 
MAKE_YOUNG_PAIR(BgL_svz00_284, BgL_arg1593z00_285); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_scdlz00_34))->BgL_tobroadcastz00)=((obj_t)BgL_auxz00_1097),BUNSPEC); } } 
{ /* Llib/_scheduler.scm 439 */
obj_t BgL_arg1615z00_286;
BgL_arg1615z00_286 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2schedulerzd2notifyz52zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1615z00_286)); } 
BgL_g1102z00_281 = BUNSPEC; 
{ /* Llib/_scheduler.scm 434 */
obj_t BgL_arg1591z00_282;
BgL_arg1591z00_282 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_scdlz00_34)))->BgL_z52builtinz52); 
BGl_z52asynczd2asynchroniza7ez27zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1591z00_282)); } 
return BgL_g1102z00_281;} } 

}



/* &%scheduler-add-broadcast! */
obj_t BGl_z62z52schedulerzd2addzd2broadcastz12z22zz__ft_z52schedulerz52(obj_t BgL_envz00_454, obj_t BgL_scdlz00_455, obj_t BgL_sigz00_456, obj_t BgL_valz00_457)
{
{ /* Llib/_scheduler.scm 433 */
{ /* Llib/_scheduler.scm 434 */
BgL_z52schedulerz52_bglt BgL_auxz00_1109;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_455, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 434 */
BgL_auxz00_1109 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_455)
; }  else 
{ 
obj_t BgL_auxz00_1113;
BgL_auxz00_1113 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)19122)), BGl_string1695z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_455); 
FAILURE(BgL_auxz00_1113,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_1109, BgL_sigz00_456, BgL_valz00_457);} } 

}



/* %scheduler-time */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_37)
{
{ /* Llib/_scheduler.scm 445 */
return 
BINT(
(((BgL_ftenvz00_bglt)COBJECT(
((BgL_ftenvz00_bglt)
CAR(
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_37))->BgL_envzb2zb2)))))->BgL_instantz00));} 

}



/* &%scheduler-time */
obj_t BGl_z62z52schedulerzd2timeze2zz__ft_z52schedulerz52(obj_t BgL_envz00_458, obj_t BgL_scdlz00_459)
{
{ /* Llib/_scheduler.scm 445 */
{ /* Llib/_scheduler.scm 447 */
BgL_schedulerz00_bglt BgL_auxz00_1123;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_459, BGl_schedulerz00zz__ft_typesz00))
{ /* Llib/_scheduler.scm 447 */
BgL_auxz00_1123 = 
((BgL_schedulerz00_bglt)BgL_scdlz00_459)
; }  else 
{ 
obj_t BgL_auxz00_1127;
BgL_auxz00_1127 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)19672)), BGl_string1696z00zz__ft_z52schedulerz52, BGl_string1685z00zz__ft_z52schedulerz52, BgL_scdlz00_459); 
FAILURE(BgL_auxz00_1127,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_auxz00_1123);} } 

}



/* %scheduler-waiting-threads */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_38)
{
{ /* Llib/_scheduler.scm 453 */
{ 
obj_t BgL_envsz00_294;obj_t BgL_thsz00_295;
{ /* Llib/_scheduler.scm 455 */
obj_t BgL_arg1619z00_293;
BgL_arg1619z00_293 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_38)))->BgL_envzb2zb2); 
BgL_envsz00_294 = BgL_arg1619z00_293; 
BgL_thsz00_295 = BNIL; 
BgL_zc3z04anonymousza31620ze3z87_296:
if(
PAIRP(BgL_envsz00_294))
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1624z00_298;obj_t BgL_arg1626z00_299;
BgL_arg1624z00_298 = 
CDR(BgL_envsz00_294); 
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1627z00_300;
{ /* Llib/_scheduler.scm 458 */
obj_t BgL_arg1628z00_301;
BgL_arg1628z00_301 = 
CAR(
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_scdlz00_38)))->BgL_envzb2zb2)); 
BgL_arg1627z00_300 = 
BGl_ftenvzd2threadszd2zz__ft_envz00(
((BgL_ftenvz00_bglt)BgL_arg1628z00_301)); } 
BgL_arg1626z00_299 = 
BGl_appendzd221010zd2zz__ft_z52schedulerz52(BgL_arg1627z00_300, BgL_thsz00_295); } 
{ 
obj_t BgL_thsz00_1144;obj_t BgL_envsz00_1143;
BgL_envsz00_1143 = BgL_arg1624z00_298; 
BgL_thsz00_1144 = BgL_arg1626z00_299; 
BgL_thsz00_295 = BgL_thsz00_1144; 
BgL_envsz00_294 = BgL_envsz00_1143; 
goto BgL_zc3z04anonymousza31620ze3z87_296;} }  else 
{ /* Llib/_scheduler.scm 457 */
return BgL_thsz00_295;} } } } 

}



/* &%scheduler-waiting-threads */
obj_t BGl_z62z52schedulerzd2waitingzd2threadsz30zz__ft_z52schedulerz52(obj_t BgL_envz00_460, obj_t BgL_scdlz00_461)
{
{ /* Llib/_scheduler.scm 453 */
{ /* Llib/_scheduler.scm 454 */
BgL_z52schedulerz52_bglt BgL_auxz00_1145;
if(
BGl_isazf3zf3zz__objectz00(BgL_scdlz00_461, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* Llib/_scheduler.scm 454 */
BgL_auxz00_1145 = 
((BgL_z52schedulerz52_bglt)BgL_scdlz00_461)
; }  else 
{ 
obj_t BgL_auxz00_1149;
BgL_auxz00_1149 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1674z00zz__ft_z52schedulerz52, 
BINT(((long)19994)), BGl_string1697z00zz__ft_z52schedulerz52, BGl_string1679z00zz__ft_z52schedulerz52, BgL_scdlz00_461); 
FAILURE(BgL_auxz00_1149,BFALSE,BFALSE);} 
return 
BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_auxz00_1145);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52()
{
{ /* Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)360853603), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565054), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1698z00zz__ft_z52schedulerz52));} 

}

#ifdef __cplusplus
}
#endif
