/*===========================================================================*/
/*   (Llib/_thread.scm)                                                      */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/_thread.scm -o objs/_thread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52pthreadz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
   obj_t BgL_fthreadz00;
   obj_t BgL_mutexz00;
   obj_t BgL_condvarz00;
   obj_t BgL_idz00;
   obj_t BgL_parentz00;
} *BgL_z52pthreadz52_bglt;


static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52threadz52 = BUNSPEC;
static obj_t BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_z52threadz52();
static obj_t BGl_genericzd2initzd2zz__ft_z52threadz52();
extern obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_objectzd2initzd2zz__ft_z52threadz52();
extern obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52(obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static obj_t BGl_methodzd2initzd2zz__ft_z52threadz52();
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_EXPORTED_DECL bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t bgl_remq_bang(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
extern obj_t BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(obj_t, BgL_z52pthreadz52_bglt);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
static obj_t BGl_cnstzd2initzd2zz__ft_z52threadz52();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52();
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52();
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_gczd2rootszd2initz00zz__ft_z52threadz52();
static obj_t BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52(obj_t, obj_t);
extern obj_t BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(obj_t, BgL_threadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t);
BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(BgL_z52pthreadz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52(obj_t, obj_t);
static obj_t BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52(obj_t, obj_t, obj_t);
extern obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_fthreadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52(obj_t, obj_t, obj_t);
static obj_t __cnst[ 3 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2timeoutz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2t1202za7, BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1180z00zz__ft_z52threadz52, BgL_bgl_string1180za700za7za7_1203za7, "Llib/_thread.scm", 16 );
DEFINE_STRING( BGl_string1181z00zz__ft_z52threadz52, BgL_bgl_string1181za700za7za7_1204za7, "/builddir/build/BUILD/bigloo-4.4b/api/fthread/src/Llib/_thread.scm", 66 );
DEFINE_STRING( BGl_string1182z00zz__ft_z52threadz52, BgL_bgl_string1182za700za7za7_1205za7, "&%thread-awake!", 15 );
DEFINE_STRING( BGl_string1183z00zz__ft_z52threadz52, BgL_bgl_string1183za700za7za7_1206za7, "fthread", 7 );
DEFINE_STRING( BGl_string1184z00zz__ft_z52threadz52, BgL_bgl_string1184za700za7za7_1207za7, "&%thread-cooperate", 18 );
DEFINE_STRING( BGl_string1185z00zz__ft_z52threadz52, BgL_bgl_string1185za700za7za7_1208za7, "&%thread-yield!", 15 );
DEFINE_STRING( BGl_string1186z00zz__ft_z52threadz52, BgL_bgl_string1186za700za7za7_1209za7, "&%thread-timeout!", 17 );
DEFINE_STRING( BGl_string1187z00zz__ft_z52threadz52, BgL_bgl_string1187za700za7za7_1210za7, "bint", 4 );
DEFINE_STRING( BGl_string1188z00zz__ft_z52threadz52, BgL_bgl_string1188za700za7za7_1211za7, "&%thread-kill!", 14 );
DEFINE_STRING( BGl_string1189z00zz__ft_z52threadz52, BgL_bgl_string1189za700za7za7_1212za7, "&%thread-unregister-signals!", 28 );
DEFINE_STRING( BGl_string1190z00zz__ft_z52threadz52, BgL_bgl_string1190za700za7za7_1213za7, "&%thread-attached?", 18 );
DEFINE_STRING( BGl_string1191z00zz__ft_z52threadz52, BgL_bgl_string1191za700za7za7_1214za7, "&%thread-is-dead", 16 );
DEFINE_STRING( BGl_string1192z00zz__ft_z52threadz52, BgL_bgl_string1192za700za7za7_1215za7, "&%thread-is-toterminate", 23 );
DEFINE_STRING( BGl_string1193z00zz__ft_z52threadz52, BgL_bgl_string1193za700za7za7_1216za7, "&%thread-is-terminated", 22 );
DEFINE_STRING( BGl_string1194z00zz__ft_z52threadz52, BgL_bgl_string1194za700za7za7_1217za7, "&%thread-asynchronize!", 22 );
DEFINE_STRING( BGl_string1195z00zz__ft_z52threadz52, BgL_bgl_string1195za700za7za7_1218za7, "symbol", 6 );
DEFINE_STRING( BGl_string1196z00zz__ft_z52threadz52, BgL_bgl_string1196za700za7za7_1219za7, "__ft_%thread", 12 );
DEFINE_STRING( BGl_string1197z00zz__ft_z52threadz52, BgL_bgl_string1197za700za7za7_1220za7, "terminated toterminate dead ", 28 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2yieldz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2y1221za7, BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2cooperatezd2envz52zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2c1222za7, BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2killz12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2k1223za7, BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2deadzd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1224za7, va_generic_entry, BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2attachedzf3zd2envza1zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1225za7, BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2toterminatezd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1226za7, va_generic_entry, BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2unregisterzd2signalsz12zd2envz92zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2u1227za7, BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2iszd2terminatedzd2envz80zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2i1228za7, va_generic_entry, BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2synchroniza7ez12zd2envze7zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2s1229za7, BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2asynchroniza7ez12zd2envze7zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1230za7, BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52threadzd2awakez12zd2envz40zz__ft_z52threadz52, BgL_bgl_za762za752threadza7d2a1231za7, BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_z52threadz52) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long BgL_checksumz00_219, char * BgL_fromz00_220)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52threadz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52threadz52 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__ft_z52threadz52(); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52(); 
BGl_cnstzd2initzd2zz__ft_z52threadz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52(); 
return 
BGl_toplevelzd2initzd2zz__ft_z52threadz52();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_%thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_%thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
{ /* Llib/_thread.scm 15 */
obj_t BgL_cportz00_203;
{ /* Llib/_thread.scm 15 */
obj_t BgL_stringz00_211;
BgL_stringz00_211 = BGl_string1197z00zz__ft_z52threadz52; 
{ /* Llib/_thread.scm 15 */
obj_t BgL_startz00_212;
BgL_startz00_212 = 
BINT(((long)0)); 
{ /* Llib/_thread.scm 15 */
obj_t BgL_endz00_213;
BgL_endz00_213 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_211))); 
{ /* Llib/_thread.scm 15 */

BgL_cportz00_203 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_211, BgL_startz00_212, BgL_endz00_213); } } } } 
{ 
long BgL_iz00_204;
BgL_iz00_204 = ((long)2); 
BgL_loopz00_205:
if(
(BgL_iz00_204==((long)-1)))
{ /* Llib/_thread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/_thread.scm 15 */
{ /* Llib/_thread.scm 15 */
obj_t BgL_arg1201z00_207;
{ /* Llib/_thread.scm 15 */

{ /* Llib/_thread.scm 15 */
obj_t BgL_locationz00_209;
BgL_locationz00_209 = 
BBOOL(((bool_t)0)); 
{ /* Llib/_thread.scm 15 */

BgL_arg1201z00_207 = 
BGl_readz00zz__readerz00(BgL_cportz00_203, BgL_locationz00_209); } } } 
{ /* Llib/_thread.scm 15 */
int BgL_tmpz00_246;
BgL_tmpz00_246 = 
(int)(BgL_iz00_204); 
CNST_TABLE_SET(BgL_tmpz00_246, BgL_arg1201z00_207); } } 
{ /* Llib/_thread.scm 15 */
int BgL_auxz00_210;
BgL_auxz00_210 = 
(int)(
(BgL_iz00_204-((long)1))); 
{ 
long BgL_iz00_251;
BgL_iz00_251 = 
(long)(BgL_auxz00_210); 
BgL_iz00_204 = BgL_iz00_251; 
goto BgL_loopz00_205;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1180z00zz__ft_z52threadz52)); 
return BFALSE;} 

}



/* %thread-awake! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_3)
{
{ /* Llib/_thread.scm 42 */
{ /* Llib/_thread.scm 44 */
BgL_z52schedulerz52_bglt BgL_i1061z00_30;
BgL_i1061z00_30 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_3))->BgL_schedulerz00)); 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_3))->BgL_z52timeoutz52)=((int)
(int)(((long)1))),BUNSPEC); 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)))
{ /* Llib/_thread.scm 47 */
{ 
obj_t BgL_auxz00_263;
{ /* Llib/_thread.scm 52 */
obj_t BgL_list1095z00_35;
BgL_list1095z00_35 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_3), BNIL); 
BgL_auxz00_263 = BgL_list1095z00_35; } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_263),BUNSPEC); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2)),BUNSPEC);}  else 
{ /* Llib/_thread.scm 48 */
obj_t BgL_pz00_33;
BgL_pz00_33 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_3), BNIL); 
{ /* Llib/_thread.scm 49 */
obj_t BgL_arg1094z00_34;
BgL_arg1094z00_34 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2); 
{ /* Llib/_thread.scm 49 */
obj_t BgL_tmpz00_272;
BgL_tmpz00_272 = 
((obj_t)BgL_arg1094z00_34); 
SET_CDR(BgL_tmpz00_272, BgL_pz00_33); } } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1061z00_30))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BgL_pz00_33),BUNSPEC);} } } 

}



/* &%thread-awake! */
obj_t BGl_z62z52threadzd2awakez12zf0zz__ft_z52threadz52(obj_t BgL_envz00_123, obj_t BgL_tz00_124)
{
{ /* Llib/_thread.scm 42 */
{ /* Llib/_thread.scm 43 */
BgL_fthreadz00_bglt BgL_auxz00_276;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_124, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 43 */
BgL_auxz00_276 = 
((BgL_fthreadz00_bglt)BgL_tz00_124)
; }  else 
{ 
obj_t BgL_auxz00_280;
BgL_auxz00_280 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)1915)), BGl_string1182z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_124); 
FAILURE(BgL_auxz00_280,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2awakez12z92zz__ft_z52threadz52(BgL_auxz00_276);} } 

}



/* %thread-cooperate */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_4)
{
{ /* Llib/_thread.scm 58 */
{ /* Llib/_thread.scm 64 */
obj_t BgL_arg1099z00_38;
BgL_arg1099z00_38 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_4))->BgL_schedulerz00); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_4, 
((BgL_schedulerz00_bglt)BgL_arg1099z00_38)); } 
if(
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_tz00_4, BNIL))
{ /* Llib/_thread.scm 66 */
obj_t BgL_fun1102z00_41;
BgL_fun1102z00_41 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_4))->BgL_z52terminatez52); 
return 
PROCEDURE_ENTRY(BgL_fun1102z00_41)(BgL_fun1102z00_41, 
((obj_t)BgL_tz00_4), BEOA);}  else 
{ /* Llib/_thread.scm 65 */
return BFALSE;} } 

}



/* &%thread-cooperate */
obj_t BGl_z62z52threadzd2cooperateze2zz__ft_z52threadz52(obj_t BgL_envz00_125, obj_t BgL_tz00_126)
{
{ /* Llib/_thread.scm 58 */
{ /* Llib/_thread.scm 59 */
BgL_fthreadz00_bglt BgL_auxz00_296;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_126, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 59 */
BgL_auxz00_296 = 
((BgL_fthreadz00_bglt)BgL_tz00_126)
; }  else 
{ 
obj_t BgL_auxz00_300;
BgL_auxz00_300 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)2597)), BGl_string1184z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_126); 
FAILURE(BgL_auxz00_300,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_auxz00_296);} } 

}



/* %thread-yield! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_5)
{
{ /* Llib/_thread.scm 71 */
{ /* Llib/_thread.scm 73 */
BgL_z52schedulerz52_bglt BgL_i1064z00_44;
BgL_i1064z00_44 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_5))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_307;
{ /* Llib/_thread.scm 74 */
obj_t BgL_arg1108z00_45;
BgL_arg1108z00_45 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_threadszd2yieldzd2); 
BgL_auxz00_307 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_5), BgL_arg1108z00_45); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_threadszd2yieldzd2)=((obj_t)BgL_auxz00_307),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1064z00_44))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_tz00_5);} } 

}



/* &%thread-yield! */
obj_t BGl_z62z52threadzd2yieldz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_127, obj_t BgL_tz00_128)
{
{ /* Llib/_thread.scm 71 */
{ /* Llib/_thread.scm 72 */
BgL_fthreadz00_bglt BgL_auxz00_314;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_128, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 72 */
BgL_auxz00_314 = 
((BgL_fthreadz00_bglt)BgL_tz00_128)
; }  else 
{ 
obj_t BgL_auxz00_318;
BgL_auxz00_318 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3208)), BGl_string1185z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_128); 
FAILURE(BgL_auxz00_318,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_auxz00_314);} } 

}



/* %thread-timeout! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_6, int BgL_tmtz00_7)
{
{ /* Llib/_thread.scm 81 */
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_6))->BgL_z52timeoutz52)=((int)BgL_tmtz00_7),BUNSPEC); 
{ /* Llib/_thread.scm 84 */
BgL_z52schedulerz52_bglt BgL_i1066z00_47;
BgL_i1066z00_47 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_6))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_326;
{ /* Llib/_thread.scm 85 */
obj_t BgL_arg1109z00_48;
BgL_arg1109z00_48 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_threadszd2timeoutzd2); 
BgL_auxz00_326 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_6), BgL_arg1109z00_48); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_threadszd2timeoutzd2)=((obj_t)BgL_auxz00_326),BUNSPEC); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1066z00_47))->BgL_z52threadszd2readyz80)=((bool_t)((bool_t)1)),BUNSPEC); 
return 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_tz00_6);} } 

}



/* &%thread-timeout! */
obj_t BGl_z62z52threadzd2timeoutz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_129, obj_t BgL_tz00_130, obj_t BgL_tmtz00_131)
{
{ /* Llib/_thread.scm 81 */
{ /* Llib/_thread.scm 82 */
int BgL_auxz00_341;BgL_fthreadz00_bglt BgL_auxz00_333;
{ /* Llib/_thread.scm 82 */
obj_t BgL_tmpz00_342;
if(
INTEGERP(BgL_tmtz00_131))
{ /* Llib/_thread.scm 82 */
BgL_tmpz00_342 = BgL_tmtz00_131
; }  else 
{ 
obj_t BgL_auxz00_345;
BgL_auxz00_345 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3689)), BGl_string1186z00zz__ft_z52threadz52, BGl_string1187z00zz__ft_z52threadz52, BgL_tmtz00_131); 
FAILURE(BgL_auxz00_345,BFALSE,BFALSE);} 
BgL_auxz00_341 = 
CINT(BgL_tmpz00_342); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_130, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 82 */
BgL_auxz00_333 = 
((BgL_fthreadz00_bglt)BgL_tz00_130)
; }  else 
{ 
obj_t BgL_auxz00_337;
BgL_auxz00_337 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)3689)), BGl_string1186z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_130); 
FAILURE(BgL_auxz00_337,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_auxz00_333, BgL_auxz00_341);} } 

}



/* %thread-kill! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_8)
{
{ /* Llib/_thread.scm 92 */
{ /* Llib/_thread.scm 96 */
obj_t BgL_list1110z00_50;
BgL_list1110z00_50 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_tz00_8, BgL_list1110z00_50); } 
{ /* Llib/_thread.scm 97 */
BgL_z52schedulerz52_bglt BgL_i1068z00_51;
BgL_i1068z00_51 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_schedulerz00)); 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(
(
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_z52livezd2threadzd2numberz52))-((long)1)))),BUNSPEC); 
{ 
obj_t BgL_auxz00_360;
{ /* Llib/_thread.scm 101 */
obj_t BgL_arg1112z00_53;
BgL_arg1112z00_53 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2); 
BgL_auxz00_360 = 
bgl_remq_bang(
((obj_t)BgL_tz00_8), BgL_arg1112z00_53); } 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2)=((obj_t)BgL_auxz00_360),BUNSPEC); } 
if(
NULLP(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2)))
{ /* Llib/_thread.scm 102 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)BNIL),BUNSPEC); }  else 
{ /* Llib/_thread.scm 102 */
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2lastzd2pairzd2)=((obj_t)
BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1068z00_51))->BgL_threadszd2runnablezd2))),BUNSPEC); } 
{ /* Llib/_thread.scm 122 */
obj_t BgL_g1085z00_101;
BgL_g1085z00_101 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1079z00_103;
BgL_l1079z00_103 = BgL_g1085z00_101; 
BgL_zc3z04anonymousza31118ze3z87_102:
if(
PAIRP(BgL_l1079z00_103))
{ /* Llib/_thread.scm 122 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_sz00_105;
BgL_sz00_105 = 
CAR(BgL_l1079z00_103); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_105, 
((BgL_threadz00_bglt)BgL_tz00_8)); } 
{ 
obj_t BgL_l1079z00_378;
BgL_l1079z00_378 = 
CDR(BgL_l1079z00_103); 
BgL_l1079z00_103 = BgL_l1079z00_378; 
goto BgL_zc3z04anonymousza31118ze3z87_102;} }  else 
{ /* Llib/_thread.scm 122 */((bool_t)1); } } } 
{ /* Llib/_thread.scm 106 */
obj_t BgL_arg1117z00_58;
BgL_arg1117z00_58 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_8))->BgL_schedulerz00); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_8, 
((BgL_schedulerz00_bglt)BgL_arg1117z00_58)); } 
return BUNSPEC;} } 

}



/* &%thread-kill! */
obj_t BGl_z62z52threadzd2killz12zf0zz__ft_z52threadz52(obj_t BgL_envz00_132, obj_t BgL_tz00_133)
{
{ /* Llib/_thread.scm 92 */
{ /* Llib/_thread.scm 93 */
BgL_fthreadz00_bglt BgL_auxz00_383;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_133, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 93 */
BgL_auxz00_383 = 
((BgL_fthreadz00_bglt)BgL_tz00_133)
; }  else 
{ 
obj_t BgL_auxz00_387;
BgL_auxz00_387 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)4201)), BGl_string1188z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_133); 
FAILURE(BgL_auxz00_387,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2killz12z92zz__ft_z52threadz52(BgL_auxz00_383);} } 

}



/* %thread-unregister-signals! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_10)
{
{ /* Llib/_thread.scm 120 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_g1085z00_215;
BgL_g1085z00_215 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_10))->BgL_z52signalsz52); 
{ 
obj_t BgL_l1079z00_217;
{ /* Llib/_thread.scm 122 */
bool_t BgL_tmpz00_393;
BgL_l1079z00_217 = BgL_g1085z00_215; 
BgL_zc3z04anonymousza31118ze3z87_216:
if(
PAIRP(BgL_l1079z00_217))
{ /* Llib/_thread.scm 122 */
{ /* Llib/_thread.scm 122 */
obj_t BgL_sz00_218;
BgL_sz00_218 = 
CAR(BgL_l1079z00_217); 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_218, 
((BgL_threadz00_bglt)BgL_tz00_10)); } 
{ 
obj_t BgL_l1079z00_399;
BgL_l1079z00_399 = 
CDR(BgL_l1079z00_217); 
BgL_l1079z00_217 = BgL_l1079z00_399; 
goto BgL_zc3z04anonymousza31118ze3z87_216;} }  else 
{ /* Llib/_thread.scm 122 */
BgL_tmpz00_393 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_393);} } } } 

}



/* &%thread-unregister-signals! */
obj_t BGl_z62z52threadzd2unregisterzd2signalsz12z22zz__ft_z52threadz52(obj_t BgL_envz00_134, obj_t BgL_tz00_135)
{
{ /* Llib/_thread.scm 120 */
{ /* Llib/_thread.scm 121 */
BgL_fthreadz00_bglt BgL_auxz00_402;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_135, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 121 */
BgL_auxz00_402 = 
((BgL_fthreadz00_bglt)BgL_tz00_135)
; }  else 
{ 
obj_t BgL_auxz00_406;
BgL_auxz00_406 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)5556)), BGl_string1189z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_135); 
FAILURE(BgL_auxz00_406,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2unregisterzd2signalsz12z40zz__ft_z52threadz52(BgL_auxz00_402);} } 

}



/* %thread-attached? */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_11)
{
{ /* Llib/_thread.scm 127 */
{ /* Llib/_thread.scm 129 */
obj_t BgL_arg1121z00_119;
BgL_arg1121z00_119 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_11))->BgL_schedulerz00); 
return 
BGl_isazf3zf3zz__objectz00(BgL_arg1121z00_119, BGl_schedulerz00zz__ft_typesz00);} } 

}



/* &%thread-attached? */
obj_t BGl_z62z52threadzd2attachedzf3z11zz__ft_z52threadz52(obj_t BgL_envz00_136, obj_t BgL_tz00_137)
{
{ /* Llib/_thread.scm 127 */
{ /* Llib/_thread.scm 128 */
bool_t BgL_tmpz00_413;
{ /* Llib/_thread.scm 128 */
BgL_fthreadz00_bglt BgL_auxz00_414;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_137, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 128 */
BgL_auxz00_414 = 
((BgL_fthreadz00_bglt)BgL_tz00_137)
; }  else 
{ 
obj_t BgL_auxz00_418;
BgL_auxz00_418 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)5925)), BGl_string1190z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_137); 
FAILURE(BgL_auxz00_418,BFALSE,BFALSE);} 
BgL_tmpz00_413 = 
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_auxz00_414); } 
return 
BBOOL(BgL_tmpz00_413);} } 

}



/* %thread-is-dead */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_12, obj_t BgL_vz00_13)
{
{ /* Llib/_thread.scm 134 */
{ /* Llib/_thread.scm 136 */
bool_t BgL_test1249z00_424;
if(
PAIRP(BgL_vz00_13))
{ /* Llib/_thread.scm 136 */
BgL_test1249z00_424 = 
CBOOL(
CAR(BgL_vz00_13))
; }  else 
{ /* Llib/_thread.scm 136 */
BgL_test1249z00_424 = ((bool_t)0)
; } 
if(BgL_test1249z00_424)
{ /* Llib/_thread.scm 137 */
obj_t BgL_xz00_182;
BgL_xz00_182 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_12))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)0))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 136 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_12))->BgL_z52statez52)==
CNST_TABLE_REF(((long)0)));} } } 

}



/* &%thread-is-dead */
obj_t BGl_z62z52threadzd2iszd2deadz30zz__ft_z52threadz52(obj_t BgL_envz00_138, obj_t BgL_tz00_139, obj_t BgL_vz00_140)
{
{ /* Llib/_thread.scm 134 */
{ /* Llib/_thread.scm 135 */
bool_t BgL_tmpz00_434;
{ /* Llib/_thread.scm 135 */
BgL_fthreadz00_bglt BgL_auxz00_435;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_139, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 135 */
BgL_auxz00_435 = 
((BgL_fthreadz00_bglt)BgL_tz00_139)
; }  else 
{ 
obj_t BgL_auxz00_439;
BgL_auxz00_439 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)6265)), BGl_string1191z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_139); 
FAILURE(BgL_auxz00_439,BFALSE,BFALSE);} 
BgL_tmpz00_434 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_auxz00_435, BgL_vz00_140); } 
return 
BBOOL(BgL_tmpz00_434);} } 

}



/* %thread-is-toterminate */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_14, obj_t BgL_vz00_15)
{
{ /* Llib/_thread.scm 143 */
{ /* Llib/_thread.scm 145 */
bool_t BgL_test1252z00_445;
if(
PAIRP(BgL_vz00_15))
{ /* Llib/_thread.scm 145 */
BgL_test1252z00_445 = 
CBOOL(
CAR(BgL_vz00_15))
; }  else 
{ /* Llib/_thread.scm 145 */
BgL_test1252z00_445 = ((bool_t)0)
; } 
if(BgL_test1252z00_445)
{ /* Llib/_thread.scm 146 */
obj_t BgL_xz00_187;
BgL_xz00_187 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_14))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)1))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 145 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_14))->BgL_z52statez52)==
CNST_TABLE_REF(((long)1)));} } } 

}



/* &%thread-is-toterminate */
obj_t BGl_z62z52threadzd2iszd2toterminatez30zz__ft_z52threadz52(obj_t BgL_envz00_141, obj_t BgL_tz00_142, obj_t BgL_vz00_143)
{
{ /* Llib/_thread.scm 143 */
{ /* Llib/_thread.scm 144 */
bool_t BgL_tmpz00_455;
{ /* Llib/_thread.scm 144 */
BgL_fthreadz00_bglt BgL_auxz00_456;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_142, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 144 */
BgL_auxz00_456 = 
((BgL_fthreadz00_bglt)BgL_tz00_142)
; }  else 
{ 
obj_t BgL_auxz00_460;
BgL_auxz00_460 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)6654)), BGl_string1192z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_142); 
FAILURE(BgL_auxz00_460,BFALSE,BFALSE);} 
BgL_tmpz00_455 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_456, BgL_vz00_143); } 
return 
BBOOL(BgL_tmpz00_455);} } 

}



/* %thread-is-terminated */
BGL_EXPORTED_DEF bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_16, obj_t BgL_vz00_17)
{
{ /* Llib/_thread.scm 152 */
{ /* Llib/_thread.scm 154 */
bool_t BgL_test1261z00_466;
if(
PAIRP(BgL_vz00_17))
{ /* Llib/_thread.scm 154 */
BgL_test1261z00_466 = 
CBOOL(
CAR(BgL_vz00_17))
; }  else 
{ /* Llib/_thread.scm 154 */
BgL_test1261z00_466 = ((bool_t)0)
; } 
if(BgL_test1261z00_466)
{ /* Llib/_thread.scm 155 */
obj_t BgL_xz00_192;
BgL_xz00_192 = 
((((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_16))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)2))),BUNSPEC); 
return ((bool_t)1);}  else 
{ /* Llib/_thread.scm 154 */
return 
(
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_16))->BgL_z52statez52)==
CNST_TABLE_REF(((long)2)));} } } 

}



/* &%thread-is-terminated */
obj_t BGl_z62z52threadzd2iszd2terminatedz30zz__ft_z52threadz52(obj_t BgL_envz00_144, obj_t BgL_tz00_145, obj_t BgL_vz00_146)
{
{ /* Llib/_thread.scm 152 */
{ /* Llib/_thread.scm 153 */
bool_t BgL_tmpz00_476;
{ /* Llib/_thread.scm 153 */
BgL_fthreadz00_bglt BgL_auxz00_477;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_145, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 153 */
BgL_auxz00_477 = 
((BgL_fthreadz00_bglt)BgL_tz00_145)
; }  else 
{ 
obj_t BgL_auxz00_481;
BgL_auxz00_481 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7056)), BGl_string1193z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_145); 
FAILURE(BgL_auxz00_481,BFALSE,BFALSE);} 
BgL_tmpz00_476 = 
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_auxz00_477, BgL_vz00_146); } 
return 
BBOOL(BgL_tmpz00_476);} } 

}



/* %thread-asynchronize! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt BgL_tz00_18, obj_t BgL_idz00_19)
{
{ /* Llib/_thread.scm 161 */
{ /* Llib/_thread.scm 166 */
BgL_z52pthreadz52_bglt BgL_i1075z00_86;
BgL_i1075z00_86 = 
((BgL_z52pthreadz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_z52builtinz52)); 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_i1075z00_86))->BgL_idz00)=((obj_t)BgL_idz00_19),BUNSPEC); } 
{ /* Llib/_thread.scm 168 */
obj_t BgL_ntz00_87;
{ /* Llib/_thread.scm 168 */
obj_t BgL_arg1138z00_91;
BgL_arg1138z00_91 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_schedulerz00); 
BgL_ntz00_87 = 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_18, 
((BgL_schedulerz00_bglt)BgL_arg1138z00_91)); } 
{ /* Llib/_thread.scm 170 */
obj_t BgL_arg1135z00_89;obj_t BgL_arg1137z00_90;
BgL_arg1135z00_89 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_18))->BgL_z52builtinz52); 
BgL_arg1137z00_90 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_ntz00_87)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2switchz80zz__ft_z52pthreadz52(BgL_arg1135z00_89, 
((BgL_z52pthreadz52_bglt)BgL_arg1137z00_90)); } } 
return BUNSPEC;} 

}



/* &%thread-asynchronize! */
obj_t BGl_z62z52threadzd2asynchroniza7ez12z57zz__ft_z52threadz52(obj_t BgL_envz00_147, obj_t BgL_tz00_148, obj_t BgL_idz00_149)
{
{ /* Llib/_thread.scm 161 */
{ /* Llib/_thread.scm 165 */
obj_t BgL_auxz00_506;BgL_fthreadz00_bglt BgL_auxz00_498;
if(
SYMBOLP(BgL_idz00_149))
{ /* Llib/_thread.scm 165 */
BgL_auxz00_506 = BgL_idz00_149
; }  else 
{ 
obj_t BgL_auxz00_509;
BgL_auxz00_509 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7578)), BGl_string1194z00zz__ft_z52threadz52, BGl_string1195z00zz__ft_z52threadz52, BgL_idz00_149); 
FAILURE(BgL_auxz00_509,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_148, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/_thread.scm 165 */
BgL_auxz00_498 = 
((BgL_fthreadz00_bglt)BgL_tz00_148)
; }  else 
{ 
obj_t BgL_auxz00_502;
BgL_auxz00_502 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1181z00zz__ft_z52threadz52, 
BINT(((long)7578)), BGl_string1194z00zz__ft_z52threadz52, BGl_string1183z00zz__ft_z52threadz52, BgL_tz00_148); 
FAILURE(BgL_auxz00_502,BFALSE,BFALSE);} 
return 
BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_auxz00_498, BgL_auxz00_506);} } 

}



/* %thread-synchronize! */
BGL_EXPORTED_DEF obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t BgL_tz00_20)
{
{ /* Llib/_thread.scm 176 */
{ /* Llib/_thread.scm 182 */
obj_t BgL_arg1140z00_93;
BgL_arg1140z00_93 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_schedulerz00); 
BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_arg1140z00_93), 
((BgL_fthreadz00_bglt)BgL_tz00_20)); } 
{ /* Llib/_thread.scm 184 */
obj_t BgL_arg1152z00_94;
BgL_arg1152z00_94 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_z52builtinz52); 
BGl_z52pthreadzd2waitz80zz__ft_z52pthreadz52(
((BgL_z52pthreadz52_bglt)BgL_arg1152z00_94)); } 
{ /* Llib/_thread.scm 185 */
BgL_z52pthreadz52_bglt BgL_i1078z00_95;
BgL_i1078z00_95 = 
((BgL_z52pthreadz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_20)))->BgL_z52builtinz52)); 
return 
((((BgL_z52pthreadz52_bglt)COBJECT(BgL_i1078z00_95))->BgL_idz00)=((obj_t)
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_20))))->BgL_namez00)),BUNSPEC);} } 

}



/* &%thread-synchronize! */
obj_t BGl_z62z52threadzd2synchroniza7ez12z57zz__ft_z52threadz52(obj_t BgL_envz00_150, obj_t BgL_tz00_151)
{
{ /* Llib/_thread.scm 176 */
return 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(BgL_tz00_151);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52threadz52()
{
{ /* Llib/_thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1196z00zz__ft_z52threadz52));} 

}

#ifdef __cplusplus
}
#endif
