/*===========================================================================*/
/*   (Llib/thread.scm)                                                       */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/thread.scm -o objs/thread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_terminatedzd2threadzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_terminatedzd2threadzd2exceptionz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52sigjoinz52_bgl {
   header_t header;
   obj_t widening;
   struct BgL_fthreadz00_bgl * BgL_threadz00;
} *BgL_z52sigjoinz52_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_joinzd2timeoutzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_joinzd2timeoutzd2exceptionz00_bglt;


BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_threadz00();
static obj_t BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_threadz00();
static obj_t BGl_objectzd2initzd2zz__ft_threadz00();
BGL_IMPORT obj_t BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(bool_t);
static obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62exceptionz62zz__objectz00;
BGL_EXPORTED_DECL obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
static obj_t BGl_methodzd2initzd2zz__ft_threadz00();
extern obj_t BGl_z52sigjoinz52zz__ft_typesz00;
extern obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = BUNSPEC;
extern obj_t BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(obj_t, obj_t, BgL_threadz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00(obj_t);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31531ze3ze5zz__ft_threadz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
BGL_IMPORT obj_t BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__libraryz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00(obj_t, obj_t);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_threadz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00();
extern obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00();
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1517z62zz__ft_threadz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31708ze3ze5zz__ft_threadz00(obj_t);
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1525z62zz__ft_threadz00(obj_t);
static obj_t BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_signalzd2lookupzd2zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt, obj_t, bool_t);
extern obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_signalzd2valuezd2zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t);
extern obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_IMPORT bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
extern obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
extern obj_t BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(obj_t, obj_t);
static obj_t __cnst[ 11 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2resumez12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2resu1977z00, BGl_z62threadzd2resumez12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2envz00zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1978z00, va_generic_entry, BGl_z62threadzd2awaitz12za2zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2startz12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_threadzd2joinz12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2specificzd2envz00zz__threadz00;
DEFINE_STRING( BGl_string1929z00zz__ft_threadz00, BgL_bgl_string1929za700za7za7_1979za7, "Llib/thread.scm", 15 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1980z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1930z00zz__ft_threadz00, BgL_bgl_string1930za700za7za7_1981za7, "thread-await", 12 );
DEFINE_STRING( BGl_string1931z00zz__ft_threadz00, BgL_bgl_string1931za700za7za7_1982za7, "Illegal timeout", 15 );
DEFINE_STRING( BGl_string1932z00zz__ft_threadz00, BgL_bgl_string1932za700za7za7_1983za7, "unattached thread", 17 );
DEFINE_STRING( BGl_string1933z00zz__ft_threadz00, BgL_bgl_string1933za700za7za7_1984za7, "no such thread", 14 );
DEFINE_STRING( BGl_string1934z00zz__ft_threadz00, BgL_bgl_string1934za700za7za7_1985za7, "thread-await*", 13 );
DEFINE_STRING( BGl_string1935z00zz__ft_threadz00, BgL_bgl_string1935za700za7za7_1986za7, "/builddir/build/BUILD/bigloo-4.4b/api/fthread/src/Llib/thread.scm", 65 );
DEFINE_STRING( BGl_string1936z00zz__ft_threadz00, BgL_bgl_string1936za700za7za7_1987za7, "&thread-await*!", 15 );
DEFINE_STRING( BGl_string1937z00zz__ft_threadz00, BgL_bgl_string1937za700za7za7_1988za7, "pair", 4 );
DEFINE_STRING( BGl_string1938z00zz__ft_threadz00, BgL_bgl_string1938za700za7za7_1989za7, "&thread-get-values*!", 20 );
DEFINE_STRING( BGl_string1939z00zz__ft_threadz00, BgL_bgl_string1939za700za7za7_1990za7, "&thread-await-values*!", 22 );
DEFINE_STRING( BGl_string1940z00zz__ft_threadz00, BgL_bgl_string1940za700za7za7_1991za7, "Unattached thread", 17 );
DEFINE_STRING( BGl_string1941z00zz__ft_threadz00, BgL_bgl_string1941za700za7za7_1992za7, "&thread-suspend!", 16 );
DEFINE_STRING( BGl_string1942z00zz__ft_threadz00, BgL_bgl_string1942za700za7za7_1993za7, "fthread", 7 );
DEFINE_STRING( BGl_string1943z00zz__ft_threadz00, BgL_bgl_string1943za700za7za7_1994za7, "&thread-resume!", 15 );
DEFINE_STRING( BGl_string1948z00zz__ft_threadz00, BgL_bgl_string1948za700za7za7_1995za7, "object-equal?", 13 );
DEFINE_STRING( BGl_string1950z00zz__ft_threadz00, BgL_bgl_string1950za700za7za7_1996za7, "thread-join!", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1944z00zz__ft_threadz00, BgL_bgl_za762za7c3za704anonymo1997za7, BGl_z62zc3z04anonymousza31531ze3ze5zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1945z00zz__ft_threadz00, BgL_bgl_za762lambda1525za7621998z00, BGl_z62lambda1525z62zz__ft_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1952z00zz__ft_threadz00, BgL_bgl_string1952za700za7za7_1999za7, "object-write", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1946z00zz__ft_threadz00, BgL_bgl_za762lambda1517za7622000z00, BGl_z62lambda1517z62zz__ft_threadz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1947z00zz__ft_threadz00, BgL_bgl_za762objectza7d2equa2001z00, BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1954z00zz__ft_threadz00, BgL_bgl_string1954za700za7za7_2002za7, "thread-start!", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1949z00zz__ft_threadz00, BgL_bgl_za762threadza7d2join2003z00, va_generic_entry, BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1956z00zz__ft_threadz00, BgL_bgl_string1956za700za7za7_2004za7, "thread-terminate!", 17 );
DEFINE_STRING( BGl_string1958z00zz__ft_threadz00, BgL_bgl_string1958za700za7za7_2005za7, "thread-specific", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1951z00zz__ft_threadz00, BgL_bgl_za762objectza7d2writ2006z00, va_generic_entry, BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1953z00zz__ft_threadz00, BgL_bgl_za762threadza7d2star2007z00, va_generic_entry, BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1960z00zz__ft_threadz00, BgL_bgl_string1960za700za7za7_2008za7, "thread-specific-set!", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1955z00zz__ft_threadz00, BgL_bgl_za762threadza7d2term2009z00, BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1962z00zz__ft_threadz00, BgL_bgl_string1962za700za7za7_2010za7, "thread-cleanup", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1957z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec2011z00, BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1964z00zz__ft_threadz00, BgL_bgl_string1964za700za7za7_2012za7, "thread-cleanup-set!", 19 );
DEFINE_STRING( BGl_string1965z00zz__ft_threadz00, BgL_bgl_string1965za700za7za7_2013za7, "thread already running", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1959z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec2014z00, BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1966z00zz__ft_threadz00, BgL_bgl_string1966za700za7za7_2015za7, ">", 1 );
DEFINE_STRING( BGl_string1967z00zz__ft_threadz00, BgL_bgl_string1967za700za7za7_2016za7, " signals=", 9 );
DEFINE_STRING( BGl_string1968z00zz__ft_threadz00, BgL_bgl_string1968za700za7za7_2017za7, " timeout=", 9 );
DEFINE_STRING( BGl_string1969z00zz__ft_threadz00, BgL_bgl_string1969za700za7za7_2018za7, " state=", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1961z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea2019z00, BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1963z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea2020z00, BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1970z00zz__ft_threadz00, BgL_bgl_string1970za700za7za7_2021za7, "#<fthread:", 10 );
DEFINE_STRING( BGl_string1971z00zz__ft_threadz00, BgL_bgl_string1971za700za7za7_2022za7, "thread-join", 11 );
DEFINE_STRING( BGl_string1972z00zz__ft_threadz00, BgL_bgl_string1972za700za7za7_2023za7, "integer", 7 );
DEFINE_STRING( BGl_string1973z00zz__ft_threadz00, BgL_bgl_string1973za700za7za7_2024za7, "__ft_thread", 11 );
DEFINE_STRING( BGl_string1974z00zz__ft_threadz00, BgL_bgl_string1974za700za7za7_2025za7, "dead terminated started thread-start! thread-terminate! __ft_thread join-timeout-exception thread-resume! thread-suspend! end init ", 131 );
BGL_IMPORT obj_t BGl_objectzd2equalzf3zd2envzf3zz__objectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2getza72026za7, BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2suspendz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2susp2027z00, BGl_z62threadzd2suspendz12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitza2z12zd2envzb0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2028z00, va_generic_entry, BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2terminatez12zd2envz12zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2getza72029za7, BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2030z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00, BUNSPEC, -2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_threadz00) );
ADD_ROOT( (void *)(&BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long BgL_checksumz00_704, char * BgL_fromz00_705)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_threadz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_threadz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__ft_threadz00(); 
BGl_libraryzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_cnstzd2initzd2zz__ft_threadz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_objectzd2initzd2zz__ft_threadz00(); 
BGl_methodzd2initzd2zz__ft_threadz00(); 
return 
BGl_toplevelzd2initzd2zz__ft_threadz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__libraryz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_cportz00_615;
{ /* Llib/thread.scm 15 */
obj_t BgL_stringz00_623;
BgL_stringz00_623 = BGl_string1974z00zz__ft_threadz00; 
{ /* Llib/thread.scm 15 */
obj_t BgL_startz00_624;
BgL_startz00_624 = 
BINT(((long)0)); 
{ /* Llib/thread.scm 15 */
obj_t BgL_endz00_625;
BgL_endz00_625 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_623))); 
{ /* Llib/thread.scm 15 */

BgL_cportz00_615 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_623, BgL_startz00_624, BgL_endz00_625); } } } } 
{ 
long BgL_iz00_616;
BgL_iz00_616 = ((long)10); 
BgL_loopz00_617:
if(
(BgL_iz00_616==((long)-1)))
{ /* Llib/thread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_arg1976z00_619;
{ /* Llib/thread.scm 15 */

{ /* Llib/thread.scm 15 */
obj_t BgL_locationz00_621;
BgL_locationz00_621 = 
BBOOL(((bool_t)0)); 
{ /* Llib/thread.scm 15 */

BgL_arg1976z00_619 = 
BGl_readz00zz__readerz00(BgL_cportz00_615, BgL_locationz00_621); } } } 
{ /* Llib/thread.scm 15 */
int BgL_tmpz00_741;
BgL_tmpz00_741 = 
(int)(BgL_iz00_616); 
CNST_TABLE_SET(BgL_tmpz00_741, BgL_arg1976z00_619); } } 
{ /* Llib/thread.scm 15 */
int BgL_auxz00_622;
BgL_auxz00_622 = 
(int)(
(BgL_iz00_616-((long)1))); 
{ 
long BgL_iz00_746;
BgL_iz00_746 = 
(long)(BgL_auxz00_622); 
BgL_iz00_616 = BgL_iz00_746; 
goto BgL_loopz00_617;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1929z00zz__ft_threadz00)); 
BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(((bool_t)1)); 
return BUNSPEC;} 

}



/* thread-await! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t BgL_sigz00_7, obj_t BgL_argz00_8)
{
{ /* Llib/thread.scm 107 */
{ /* Llib/thread.scm 108 */
obj_t BgL_tz00_42;
BgL_tz00_42 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 108 */

{ 
BgL_schedulerz00_bglt BgL_scdlz00_79;obj_t BgL_sigz00_80;obj_t BgL_timeoutz00_81;BgL_schedulerz00_bglt BgL_scdlz00_53;obj_t BgL_sigz00_54;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_42, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 159 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))
{ /* Llib/thread.scm 161 */
if(
PAIRP(BgL_argz00_8))
{ /* Llib/thread.scm 165 */
obj_t BgL_arg1165z00_49;obj_t BgL_arg1168z00_50;
BgL_arg1165z00_49 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_arg1168z00_50 = 
CAR(BgL_argz00_8); 
BgL_scdlz00_79 = 
((BgL_schedulerz00_bglt)BgL_arg1165z00_49); 
BgL_sigz00_80 = BgL_sigz00_7; 
BgL_timeoutz00_81 = BgL_arg1168z00_50; 
{ /* Llib/thread.scm 137 */
bool_t BgL_test2036z00_765;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_81))
{ /* Llib/thread.scm 137 */
if(
INTEGERP(BgL_timeoutz00_81))
{ /* Llib/thread.scm 137 */
BgL_test2036z00_765 = 
(
(long)CINT(BgL_timeoutz00_81)>((long)0))
; }  else 
{ /* Llib/thread.scm 137 */
BgL_test2036z00_765 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_timeoutz00_81, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 137 */
BgL_test2036z00_765 = ((bool_t)0)
; } 
if(BgL_test2036z00_765)
{ /* Llib/thread.scm 140 */
bool_t BgL_test2039z00_774;
{ /* Llib/thread.scm 140 */
obj_t BgL_arg1217z00_96;
BgL_arg1217z00_96 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2039z00_774 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1217z00_96)); } 
if(BgL_test2039z00_774)
{ /* Llib/thread.scm 140 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 140 */
{ /* Llib/thread.scm 144 */
obj_t BgL_arg1201z00_90;
BgL_arg1201z00_90 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_80, BgL_arg1201z00_90, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_80, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 147 */
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_79), 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_80)); }  else 
{ /* Llib/thread.scm 147 */BFALSE; } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), 
CINT(BgL_timeoutz00_81)); 
{ /* Llib/thread.scm 152 */
bool_t BgL_test2041z00_791;
{ /* Llib/thread.scm 152 */
obj_t BgL_arg1212z00_95;
BgL_arg1212z00_95 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2041z00_791 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1212z00_95)); } 
if(BgL_test2041z00_791)
{ /* Llib/thread.scm 152 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 152 */
return BFALSE;} } } }  else 
{ /* Llib/thread.scm 137 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1931z00zz__ft_threadz00, BgL_timeoutz00_81);} } }  else 
{ /* Llib/thread.scm 168 */
obj_t BgL_arg1169z00_52;
BgL_arg1169z00_52 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_scdlz00_53 = 
((BgL_schedulerz00_bglt)BgL_arg1169z00_52); 
BgL_sigz00_54 = BgL_sigz00_7; 
{ /* Llib/thread.scm 113 */
bool_t BgL_test2042z00_802;
{ /* Llib/thread.scm 113 */
obj_t BgL_arg1184z00_78;
BgL_arg1184z00_78 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BgL_test2042z00_802 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_54, BgL_arg1184z00_78)); } 
if(BgL_test2042z00_802)
{ /* Llib/thread.scm 113 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 116 */
bool_t BgL_test2043z00_808;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_54, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 116 */
if(
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00))
{ /* Llib/thread.scm 118 */
BgL_test2043z00_808 = ((bool_t)0)
; }  else 
{ /* Llib/thread.scm 118 */
BgL_test2043z00_808 = ((bool_t)1)
; } }  else 
{ /* Llib/thread.scm 116 */
BgL_test2043z00_808 = ((bool_t)0)
; } 
if(BgL_test2043z00_808)
{ /* Llib/thread.scm 116 */
((((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/thread.scm 123 */
obj_t BgL_arg1179z00_65;
BgL_arg1179z00_65 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_idz00); 
BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), BgL_arg1179z00_65); } 
{ /* Llib/thread.scm 124 */
obj_t BgL_resz00_66;
{ /* Llib/thread.scm 124 */
obj_t BgL_exitd1084z00_67;
BgL_exitd1084z00_67 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/thread.scm 126 */
obj_t BgL_zc3z04anonymousza31181ze3z87_508;
BgL_zc3z04anonymousza31181ze3z87_508 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31181ze3z87_508, 
(int)(((long)0)), BgL_tz00_42); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1084z00_67, BgL_zc3z04anonymousza31181ze3z87_508); 
{ /* Llib/thread.scm 125 */
obj_t BgL_tmp1086z00_69;
{ /* Llib/thread.scm 125 */
obj_t BgL_fun1180z00_70;
BgL_fun1180z00_70 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_thunkz00); 
BgL_tmp1086z00_69 = 
PROCEDURE_ENTRY(BgL_fun1180z00_70)(BgL_fun1180z00_70, BEOA); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1084z00_67); 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(BgL_tz00_42); 
BgL_resz00_66 = BgL_tmp1086z00_69; } } } 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_53), BgL_sigz00_54, BgL_resz00_66); 
return BgL_resz00_66;} }  else 
{ /* Llib/thread.scm 116 */
{ /* Llib/thread.scm 131 */
obj_t BgL_arg1182z00_73;
BgL_arg1182z00_73 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_54, BgL_arg1182z00_73, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42)); 
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));} } } } }  else 
{ /* Llib/thread.scm 161 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1932z00zz__ft_threadz00, BgL_tz00_42);} }  else 
{ /* Llib/thread.scm 159 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1933z00zz__ft_threadz00, BgL_tz00_42);} } } } } 

}



/* &thread-await! */
obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t BgL_envz00_509, obj_t BgL_sigz00_510, obj_t BgL_argz00_511)
{
{ /* Llib/thread.scm 107 */
return 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_sigz00_510, BgL_argz00_511);} 

}



/* &<@anonymous:1181> */
obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__ft_threadz00(obj_t BgL_envz00_512)
{
{ /* Llib/thread.scm 124 */
return 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(
PROCEDURE_REF(BgL_envz00_512, 
(int)(((long)0))));} 

}



/* thread-await*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t BgL_sza2za2_9, obj_t BgL_argz00_10)
{
{ /* Llib/thread.scm 173 */
{ /* Llib/thread.scm 174 */
obj_t BgL_tz00_101;
BgL_tz00_101 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 174 */

{ 
obj_t BgL_eza2za2_143;obj_t BgL_sz00_144;obj_t BgL_timeoutz00_145;obj_t BgL_eza2za2_112;obj_t BgL_sz00_113;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_101, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 215 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))
{ /* Llib/thread.scm 217 */
if(
PAIRP(BgL_argz00_10))
{ /* Llib/thread.scm 221 */
obj_t BgL_arg1221z00_108;obj_t BgL_arg1222z00_109;
BgL_arg1221z00_108 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_arg1222z00_109 = 
CAR(BgL_argz00_10); 
BgL_eza2za2_143 = BgL_sza2za2_9; 
BgL_sz00_144 = BgL_arg1221z00_108; 
BgL_timeoutz00_145 = BgL_arg1222z00_109; 
{ /* Llib/thread.scm 194 */
bool_t BgL_test2049z00_863;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_145))
{ /* Llib/thread.scm 194 */
if(
INTEGERP(BgL_timeoutz00_145))
{ /* Llib/thread.scm 194 */
BgL_test2049z00_863 = 
(
(long)CINT(BgL_timeoutz00_145)>=((long)0))
; }  else 
{ /* Llib/thread.scm 194 */
BgL_test2049z00_863 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_timeoutz00_145, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 194 */
BgL_test2049z00_863 = ((bool_t)0)
; } 
if(BgL_test2049z00_863)
{ /* Llib/thread.scm 196 */
obj_t BgL_g1094z00_151;
BgL_g1094z00_151 = 
CNST_TABLE_REF(((long)0)); 
{ 
obj_t BgL_esz00_153;obj_t BgL_stagez00_154;
BgL_esz00_153 = BgL_eza2za2_143; 
BgL_stagez00_154 = BgL_g1094z00_151; 
BgL_zc3z04anonymousza31253ze3z87_155:
if(
NULLP(BgL_esz00_153))
{ /* Llib/thread.scm 199 */
if(
(BgL_stagez00_154==
CNST_TABLE_REF(((long)0))))
{ /* Llib/thread.scm 200 */
{ /* Llib/thread.scm 202 */
BgL_schedulerz00_bglt BgL_i1096z00_159;
BgL_i1096z00_159 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_schedulerz00)); 
{ 
obj_t BgL_l1125z00_161;
BgL_l1125z00_161 = BgL_eza2za2_143; 
BgL_zc3z04anonymousza31262ze3z87_162:
if(
PAIRP(BgL_l1125z00_161))
{ /* Llib/thread.scm 203 */
{ /* Llib/thread.scm 204 */
obj_t BgL_ez00_164;
BgL_ez00_164 = 
CAR(BgL_l1125z00_161); 
{ /* Llib/thread.scm 204 */
obj_t BgL_arg1277z00_165;
BgL_arg1277z00_165 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1096z00_159))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_164, BgL_arg1277z00_165, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1125z00_887;
BgL_l1125z00_887 = 
CDR(BgL_l1125z00_161); 
BgL_l1125z00_161 = BgL_l1125z00_887; 
goto BgL_zc3z04anonymousza31262ze3z87_162;} }  else 
{ /* Llib/thread.scm 203 */((bool_t)1); } } } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101), 
CINT(BgL_timeoutz00_145)); 
{ 
obj_t BgL_stagez00_893;obj_t BgL_esz00_892;
BgL_esz00_892 = BgL_eza2za2_143; 
BgL_stagez00_893 = 
CNST_TABLE_REF(((long)1)); 
BgL_stagez00_154 = BgL_stagez00_893; 
BgL_esz00_153 = BgL_esz00_892; 
goto BgL_zc3z04anonymousza31253ze3z87_155;} }  else 
{ /* Llib/thread.scm 200 */
{ /* Llib/thread.scm 208 */
int BgL_tmpz00_895;
BgL_tmpz00_895 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_895); } 
{ /* Llib/thread.scm 208 */
int BgL_tmpz00_898;
BgL_tmpz00_898 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_898, BFALSE); } 
return BFALSE;} }  else 
{ /* Llib/thread.scm 209 */
bool_t BgL_test2055z00_901;
{ /* Llib/thread.scm 209 */
obj_t BgL_arg1321z00_178;obj_t BgL_arg1323z00_179;
BgL_arg1321z00_178 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1323z00_179 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_test2055z00_901 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1321z00_178, BgL_arg1323z00_179)); } 
if(BgL_test2055z00_901)
{ /* Llib/thread.scm 210 */
obj_t BgL_val0_1129z00_173;obj_t BgL_val1_1130z00_174;
{ /* Llib/thread.scm 210 */
obj_t BgL_arg1318z00_175;obj_t BgL_arg1319z00_176;
BgL_arg1318z00_175 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1319z00_176 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_val0_1129z00_173 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1318z00_175, BgL_arg1319z00_176); } 
BgL_val1_1130z00_174 = 
CAR(
((obj_t)BgL_esz00_153)); 
{ /* Llib/thread.scm 210 */
int BgL_tmpz00_915;
BgL_tmpz00_915 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_915); } 
{ /* Llib/thread.scm 210 */
int BgL_tmpz00_918;
BgL_tmpz00_918 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_918, BgL_val1_1130z00_174); } 
return BgL_val0_1129z00_173;}  else 
{ /* Llib/thread.scm 212 */
obj_t BgL_arg1320z00_177;
BgL_arg1320z00_177 = 
CDR(
((obj_t)BgL_esz00_153)); 
{ 
obj_t BgL_esz00_923;
BgL_esz00_923 = BgL_arg1320z00_177; 
BgL_esz00_153 = BgL_esz00_923; 
goto BgL_zc3z04anonymousza31253ze3z87_155;} } } } }  else 
{ /* Llib/thread.scm 194 */
return 
BGl_errorz00zz__errorz00(BGl_string1934z00zz__ft_threadz00, BGl_string1931z00zz__ft_threadz00, BgL_timeoutz00_145);} } }  else 
{ /* Llib/thread.scm 224 */
obj_t BgL_arg1227z00_111;
BgL_arg1227z00_111 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_eza2za2_112 = BgL_sza2za2_9; 
BgL_sz00_113 = BgL_arg1227z00_111; 
{ 
obj_t BgL_esz00_117;
BgL_esz00_117 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31229ze3z87_118:
if(
NULLP(BgL_esz00_117))
{ /* Llib/thread.scm 180 */
{ 
obj_t BgL_l1119z00_122;
BgL_l1119z00_122 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31231ze3z87_123:
if(
PAIRP(BgL_l1119z00_122))
{ /* Llib/thread.scm 182 */
{ /* Llib/thread.scm 183 */
obj_t BgL_ez00_125;
BgL_ez00_125 = 
CAR(BgL_l1119z00_122); 
{ /* Llib/thread.scm 183 */
obj_t BgL_arg1238z00_126;
BgL_arg1238z00_126 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_125, BgL_arg1238z00_126, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1119z00_937;
BgL_l1119z00_937 = 
CDR(BgL_l1119z00_122); 
BgL_l1119z00_122 = BgL_l1119z00_937; 
goto BgL_zc3z04anonymousza31231ze3z87_123;} }  else 
{ /* Llib/thread.scm 182 */((bool_t)1); } } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101)); 
{ /* Llib/thread.scm 187 */
obj_t BgL_val0_1121z00_130;obj_t BgL_val1_1122z00_131;
BgL_val0_1121z00_130 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2valuez80); 
BgL_val1_1122z00_131 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2signalz80); 
{ /* Llib/thread.scm 187 */
int BgL_tmpz00_945;
BgL_tmpz00_945 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_945); } 
{ /* Llib/thread.scm 187 */
int BgL_tmpz00_948;
BgL_tmpz00_948 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_948, BgL_val1_1122z00_131); } 
return BgL_val0_1121z00_130;} }  else 
{ /* Llib/thread.scm 188 */
bool_t BgL_test2058z00_951;
{ /* Llib/thread.scm 188 */
obj_t BgL_arg1247z00_140;obj_t BgL_arg1248z00_141;
BgL_arg1247z00_140 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1248z00_141 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_test2058z00_951 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1247z00_140, BgL_arg1248z00_141)); } 
if(BgL_test2058z00_951)
{ /* Llib/thread.scm 189 */
obj_t BgL_val0_1123z00_135;obj_t BgL_val1_1124z00_136;
{ /* Llib/thread.scm 189 */
obj_t BgL_arg1244z00_137;obj_t BgL_arg1245z00_138;
BgL_arg1244z00_137 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1245z00_138 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_val0_1123z00_135 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1244z00_137, BgL_arg1245z00_138); } 
BgL_val1_1124z00_136 = 
CAR(
((obj_t)BgL_esz00_117)); 
{ /* Llib/thread.scm 189 */
int BgL_tmpz00_965;
BgL_tmpz00_965 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_965); } 
{ /* Llib/thread.scm 189 */
int BgL_tmpz00_968;
BgL_tmpz00_968 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_968, BgL_val1_1124z00_136); } 
return BgL_val0_1123z00_135;}  else 
{ /* Llib/thread.scm 191 */
obj_t BgL_arg1246z00_139;
BgL_arg1246z00_139 = 
CDR(
((obj_t)BgL_esz00_117)); 
{ 
obj_t BgL_esz00_973;
BgL_esz00_973 = BgL_arg1246z00_139; 
BgL_esz00_117 = BgL_esz00_973; 
goto BgL_zc3z04anonymousza31229ze3z87_118;} } } } } }  else 
{ /* Llib/thread.scm 217 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1932z00zz__ft_threadz00, BgL_tz00_101);} }  else 
{ /* Llib/thread.scm 215 */
return 
BGl_errorz00zz__errorz00(BGl_string1930z00zz__ft_threadz00, BGl_string1933z00zz__ft_threadz00, BgL_tz00_101);} } } } } 

}



/* &thread-await*! */
obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t BgL_envz00_514, obj_t BgL_sza2za2_515, obj_t BgL_argz00_516)
{
{ /* Llib/thread.scm 173 */
{ /* Llib/thread.scm 174 */
obj_t BgL_auxz00_976;
if(
PAIRP(BgL_sza2za2_515))
{ /* Llib/thread.scm 174 */
BgL_auxz00_976 = BgL_sza2za2_515
; }  else 
{ 
obj_t BgL_auxz00_979;
BgL_auxz00_979 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__ft_threadz00, 
BINT(((long)6510)), BGl_string1936z00zz__ft_threadz00, BGl_string1937z00zz__ft_threadz00, BgL_sza2za2_515); 
FAILURE(BgL_auxz00_979,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_auxz00_976, BgL_argz00_516);} } 

}



/* thread-get-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_11)
{
{ /* Llib/thread.scm 229 */
{ /* Llib/thread.scm 230 */
obj_t BgL_tz00_185;
BgL_tz00_185 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_185, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 231 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))); 
{ /* Llib/thread.scm 234 */
BgL_schedulerz00_bglt BgL_i1100z00_188;
BgL_i1100z00_188 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))))->BgL_schedulerz00)); 
return 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_11, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1100z00_188))->BgL_envzb2zb2));} }  else 
{ /* Llib/thread.scm 231 */
return BFALSE;} } } 

}



/* &thread-get-values! */
obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_517, obj_t BgL_sz00_518)
{
{ /* Llib/thread.scm 229 */
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_518);} 

}



/* thread-get-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_12)
{
{ /* Llib/thread.scm 240 */
{ /* Llib/thread.scm 241 */
obj_t BgL_tz00_190;
BgL_tz00_190 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_190, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 242 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_190))); 
{ /* Llib/thread.scm 244 */
obj_t BgL_head1133z00_194;
BgL_head1133z00_194 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1131z00_196;obj_t BgL_tail1134z00_197;
BgL_l1131z00_196 = BgL_sza2za2_12; 
BgL_tail1134z00_197 = BgL_head1133z00_194; 
BgL_zc3z04anonymousza31334ze3z87_198:
if(
NULLP(BgL_l1131z00_196))
{ /* Llib/thread.scm 244 */
return 
CDR(BgL_head1133z00_194);}  else 
{ /* Llib/thread.scm 244 */
obj_t BgL_newtail1135z00_200;
{ /* Llib/thread.scm 244 */
obj_t BgL_arg1339z00_202;
{ /* Llib/thread.scm 244 */
obj_t BgL_sz00_203;
BgL_sz00_203 = 
CAR(
((obj_t)BgL_l1131z00_196)); 
{ /* Llib/thread.scm 246 */
BgL_schedulerz00_bglt BgL_i1102z00_205;
BgL_i1102z00_205 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_190)))->BgL_schedulerz00)); 
BgL_arg1339z00_202 = 
MAKE_YOUNG_PAIR(BgL_sz00_203, 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_203, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1102z00_205))->BgL_envzb2zb2))); } } 
BgL_newtail1135z00_200 = 
MAKE_YOUNG_PAIR(BgL_arg1339z00_202, BNIL); } 
SET_CDR(BgL_tail1134z00_197, BgL_newtail1135z00_200); 
{ /* Llib/thread.scm 244 */
obj_t BgL_arg1338z00_201;
BgL_arg1338z00_201 = 
CDR(
((obj_t)BgL_l1131z00_196)); 
{ 
obj_t BgL_tail1134z00_1020;obj_t BgL_l1131z00_1019;
BgL_l1131z00_1019 = BgL_arg1338z00_201; 
BgL_tail1134z00_1020 = BgL_newtail1135z00_200; 
BgL_tail1134z00_197 = BgL_tail1134z00_1020; 
BgL_l1131z00_196 = BgL_l1131z00_1019; 
goto BgL_zc3z04anonymousza31334ze3z87_198;} } } } } }  else 
{ /* Llib/thread.scm 242 */
return BFALSE;} } } 

}



/* &thread-get-values*! */
obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_519, obj_t BgL_sza2za2_520)
{
{ /* Llib/thread.scm 240 */
{ /* Llib/thread.scm 241 */
obj_t BgL_auxz00_1021;
if(
PAIRP(BgL_sza2za2_520))
{ /* Llib/thread.scm 241 */
BgL_auxz00_1021 = BgL_sza2za2_520
; }  else 
{ 
obj_t BgL_auxz00_1024;
BgL_auxz00_1024 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__ft_threadz00, 
BINT(((long)8929)), BGl_string1938z00zz__ft_threadz00, BGl_string1937z00zz__ft_threadz00, BgL_sza2za2_520); 
FAILURE(BgL_auxz00_1024,BFALSE,BFALSE);} 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1021);} } 

}



/* thread-await-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_13, obj_t BgL_tmtz00_14)
{
{ /* Llib/thread.scm 253 */
{ /* Llib/thread.scm 254 */
obj_t BgL_runner1347z00_452;
{ /* Llib/thread.scm 254 */
obj_t BgL_list1345z00_453;
BgL_list1345z00_453 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_14, BNIL); 
BgL_runner1347z00_452 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sz00_13, BgL_list1345z00_453); } 
{ /* Llib/thread.scm 254 */
obj_t BgL_aux1346z00_454;
BgL_aux1346z00_454 = 
CAR(BgL_runner1347z00_452); 
BgL_runner1347z00_452 = 
CDR(BgL_runner1347z00_452); 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_aux1346z00_454, BgL_runner1347z00_452); } } 
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_13);} 

}



/* &thread-await-values! */
obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_521, obj_t BgL_sz00_522, obj_t BgL_tmtz00_523)
{
{ /* Llib/thread.scm 253 */
return 
BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(BgL_sz00_522, BgL_tmtz00_523);} 

}



/* thread-await-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_15, obj_t BgL_tmtz00_16)
{
{ /* Llib/thread.scm 260 */
{ /* Llib/thread.scm 261 */
obj_t BgL_runner1350z00_457;
{ /* Llib/thread.scm 261 */
obj_t BgL_list1348z00_458;
BgL_list1348z00_458 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_16, BNIL); 
BgL_runner1350z00_457 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sza2za2_15, BgL_list1348z00_458); } 
{ /* Llib/thread.scm 261 */
obj_t BgL_aux1349z00_459;
BgL_aux1349z00_459 = 
CAR(BgL_runner1350z00_457); 
BgL_runner1350z00_457 = 
CDR(BgL_runner1350z00_457); 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_aux1349z00_459, BgL_runner1350z00_457); } } 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_sza2za2_15);} 

}



/* &thread-await-values*! */
obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_524, obj_t BgL_sza2za2_525, obj_t BgL_tmtz00_526)
{
{ /* Llib/thread.scm 260 */
{ /* Llib/thread.scm 261 */
obj_t BgL_auxz00_1042;
if(
PAIRP(BgL_sza2za2_525))
{ /* Llib/thread.scm 261 */
BgL_auxz00_1042 = BgL_sza2za2_525
; }  else 
{ 
obj_t BgL_auxz00_1045;
BgL_auxz00_1045 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__ft_threadz00, 
BINT(((long)9790)), BGl_string1939z00zz__ft_threadz00, BGl_string1937z00zz__ft_threadz00, BgL_sza2za2_525); 
FAILURE(BgL_auxz00_1045,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1042, BgL_tmtz00_526);} } 

}



/* thread-suspend/resume! */
obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_22, obj_t BgL_whoz00_23, bool_t BgL_valz00_24)
{
{ /* Llib/thread.scm 341 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_tz00_22))
{ /* Llib/thread.scm 346 */
bool_t BgL_test2066z00_1052;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 346 */
BgL_test2066z00_1052 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 346 */
if(
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 347 */
BgL_test2066z00_1052 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 347 */
BgL_test2066z00_1052 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_tz00_22, BNIL)
; } } 
if(BgL_test2066z00_1052)
{ /* Llib/thread.scm 346 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 355 */
BgL_z52schedulerz52_bglt BgL_i1111z00_225;
BgL_i1111z00_225 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_22))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1060;
{ /* Llib/thread.scm 356 */
obj_t BgL_arg1389z00_226;obj_t BgL_arg1390z00_227;
BgL_arg1389z00_226 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_22), 
BBOOL(BgL_valz00_24)); 
BgL_arg1390z00_227 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1111z00_225))->BgL_tosuspendzf2resumezf2); 
BgL_auxz00_1060 = 
MAKE_YOUNG_PAIR(BgL_arg1389z00_226, BgL_arg1390z00_227); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1111z00_225))->BgL_tosuspendzf2resumezf2)=((obj_t)BgL_auxz00_1060),BUNSPEC);} } }  else 
{ /* Llib/thread.scm 343 */
return 
BGl_errorz00zz__errorz00(BgL_whoz00_23, BGl_string1940z00zz__ft_threadz00, 
((obj_t)BgL_tz00_22));} } 

}



/* thread-suspend! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_25)
{
{ /* Llib/thread.scm 361 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_25, 
CNST_TABLE_REF(((long)2)), ((bool_t)1));} 

}



/* &thread-suspend! */
obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t BgL_envz00_527, obj_t BgL_tz00_528)
{
{ /* Llib/thread.scm 361 */
{ /* Llib/thread.scm 362 */
BgL_fthreadz00_bglt BgL_auxz00_1071;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_528, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 362 */
BgL_auxz00_1071 = 
((BgL_fthreadz00_bglt)BgL_tz00_528)
; }  else 
{ 
obj_t BgL_auxz00_1075;
BgL_auxz00_1075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__ft_threadz00, 
BINT(((long)14254)), BGl_string1941z00zz__ft_threadz00, BGl_string1942z00zz__ft_threadz00, BgL_tz00_528); 
FAILURE(BgL_auxz00_1075,BFALSE,BFALSE);} 
return 
BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_auxz00_1071);} } 

}



/* thread-resume! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_26)
{
{ /* Llib/thread.scm 367 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_26, 
CNST_TABLE_REF(((long)3)), ((bool_t)0));} 

}



/* &thread-resume! */
obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t BgL_envz00_529, obj_t BgL_tz00_530)
{
{ /* Llib/thread.scm 367 */
{ /* Llib/thread.scm 368 */
BgL_fthreadz00_bglt BgL_auxz00_1082;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_530, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 368 */
BgL_auxz00_1082 = 
((BgL_fthreadz00_bglt)BgL_tz00_530)
; }  else 
{ 
obj_t BgL_auxz00_1086;
BgL_auxz00_1086 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1935z00zz__ft_threadz00, 
BINT(((long)14555)), BGl_string1943z00zz__ft_threadz00, BGl_string1942z00zz__ft_threadz00, BgL_tz00_530); 
FAILURE(BgL_auxz00_1086,BFALSE,BFALSE);} 
return 
BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_auxz00_1082);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 31 */
obj_t BgL_arg1512z00_236;obj_t BgL_arg1516z00_237;
{ /* Llib/thread.scm 31 */
obj_t BgL_v1136z00_250;
BgL_v1136z00_250 = 
create_vector(((long)0)); 
BgL_arg1512z00_236 = BgL_v1136z00_250; } 
{ /* Llib/thread.scm 31 */
obj_t BgL_v1137z00_251;
BgL_v1137z00_251 = 
create_vector(((long)0)); 
BgL_arg1516z00_237 = BgL_v1137z00_251; } 
return ( 
BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)4)), 
CNST_TABLE_REF(((long)5)), BGl_z62exceptionz62zz__objectz00, ((long)60410), BGl_proc1946z00zz__ft_threadz00, BGl_proc1945z00zz__ft_threadz00, BFALSE, BGl_proc1944z00zz__ft_threadz00, BFALSE, BgL_arg1512z00_236, BgL_arg1516z00_237), BUNSPEC) ;} } 

}



/* &<@anonymous:1531> */
obj_t BGl_z62zc3z04anonymousza31531ze3ze5zz__ft_threadz00(obj_t BgL_envz00_534, obj_t BgL_new1066z00_535)
{
{ /* Llib/thread.scm 31 */
{ 
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_auxz00_1096;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_535))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_535))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_535))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1096 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1066z00_535); 
return 
((obj_t)BgL_auxz00_1096);} } 

}



/* &lambda1525 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1525z62zz__ft_threadz00(obj_t BgL_envz00_536)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1065z00_628;
BgL_new1065z00_628 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1530z00_629;
BgL_arg1530z00_629 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_628), BgL_arg1530z00_629); } 
return BgL_new1065z00_628;} } 

}



/* &lambda1517 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1517z62zz__ft_threadz00(obj_t BgL_envz00_537, obj_t BgL_fname1062z00_538, obj_t BgL_location1063z00_539, obj_t BgL_stack1064z00_540)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1117z00_630;
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1116z00_631;
BgL_new1116z00_631 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1524z00_632;
BgL_arg1524z00_632 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1116z00_631), BgL_arg1524z00_632); } 
BgL_new1117z00_630 = BgL_new1116z00_631; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_630)))->BgL_fnamez00)=((obj_t)BgL_fname1062z00_538),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_630)))->BgL_locationz00)=((obj_t)BgL_location1063z00_539),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_630)))->BgL_stackz00)=((obj_t)BgL_stack1064z00_540),BUNSPEC); 
return BgL_new1117z00_630;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2equalzf3zd2envzf3zz__objectz00, BGl_z52sigjoinz52zz__ft_typesz00, BGl_proc1947z00zz__ft_threadz00, BGl_string1948z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2joinz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1949z00zz__ft_threadz00, BGl_string1950z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1951z00zz__ft_threadz00, BGl_string1952z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2startz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1953z00zz__ft_threadz00, BGl_string1954z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2terminatez12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1955z00zz__ft_threadz00, BGl_string1956z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1957z00zz__ft_threadz00, BGl_string1958z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1959z00zz__ft_threadz00, BGl_string1960z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1961z00zz__ft_threadz00, BGl_string1962z00zz__ft_threadz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1963z00zz__ft_threadz00, BGl_string1964z00zz__ft_threadz00);} 

}



/* &thread-cleanup-set!-1158 */
obj_t BGl_z62threadzd2cleanupzd2setz12zd21158za2zz__ft_threadz00(obj_t BgL_envz00_551, obj_t BgL_thz00_552, obj_t BgL_vz00_553)
{
{ /* Llib/thread.scm 394 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_552)))->BgL_z52cleanupz52)=((obj_t)BgL_vz00_553),BUNSPEC);} 

}



/* &thread-cleanup-fthre1156 */
obj_t BGl_z62threadzd2cleanupzd2fthre1156z62zz__ft_threadz00(obj_t BgL_envz00_554, obj_t BgL_thz00_555)
{
{ /* Llib/thread.scm 387 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_555)))->BgL_z52cleanupz52);} 

}



/* &thread-specific-set!1154 */
obj_t BGl_z62threadzd2specificzd2setz121154z70zz__ft_threadz00(obj_t BgL_envz00_556, obj_t BgL_thz00_557, obj_t BgL_vz00_558)
{
{ /* Llib/thread.scm 380 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_557)))->BgL_z52specificz52)=((obj_t)BgL_vz00_558),BUNSPEC);} 

}



/* &thread-specific-fthr1152 */
obj_t BGl_z62threadzd2specificzd2fthr1152z62zz__ft_threadz00(obj_t BgL_envz00_559, obj_t BgL_thz00_560)
{
{ /* Llib/thread.scm 373 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_560)))->BgL_z52specificz52);} 

}



/* &thread-terminate!-ft1150 */
obj_t BGl_z62threadzd2terminatez12zd2ft1150z70zz__ft_threadz00(obj_t BgL_envz00_561, obj_t BgL_tz00_562)
{
{ /* Llib/thread.scm 309 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_562)))
{ /* Llib/thread.scm 318 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_562), BNIL))
{ /* Llib/thread.scm 321 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 321 */
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_562), BNIL))
{ /* Llib/thread.scm 324 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 324 */
{ /* Llib/thread.scm 329 */
obj_t BgL_list1755z00_638;
BgL_list1755z00_638 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_562), BgL_list1755z00_638); } 
{ 
obj_t BgL_auxz00_1151;
{ /* Llib/thread.scm 331 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1108z00_639;
{ /* Llib/thread.scm 331 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1107z00_640;
BgL_new1107z00_640 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 331 */
long BgL_arg1772z00_641;
{ /* Llib/thread.scm 331 */
obj_t BgL_classz00_642;
BgL_classz00_642 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_arg1772z00_641 = 
BGL_CLASS_INDEX(BgL_classz00_642); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_640), BgL_arg1772z00_641); } 
BgL_new1108z00_639 = BgL_new1107z00_640; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_639)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_639)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1161;
{ /* Llib/thread.scm 331 */
obj_t BgL_arg1760z00_643;
{ /* Llib/thread.scm 331 */
obj_t BgL_arg1763z00_644;
{ /* Llib/thread.scm 331 */
obj_t BgL_classz00_645;
BgL_classz00_645 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_arg1763z00_644 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_645); } 
BgL_arg1760z00_643 = 
VECTOR_REF(BgL_arg1763z00_644,((long)2)); } 
BgL_auxz00_1161 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1760z00_643); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1108z00_639)))->BgL_stackz00)=((obj_t)BgL_auxz00_1161),BUNSPEC); } 
BgL_auxz00_1151 = 
((obj_t)BgL_new1108z00_639); } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_562)))->BgL_z52exczd2resultz80)=((obj_t)BgL_auxz00_1151),BUNSPEC); } 
{ /* Llib/thread.scm 334 */
BgL_z52schedulerz52_bglt BgL_i1109z00_646;
BgL_i1109z00_646 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_562)))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1172;
{ /* Llib/thread.scm 336 */
obj_t BgL_arg1773z00_647;
BgL_arg1773z00_647 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1109z00_646))->BgL_toterminatez00); 
BgL_auxz00_1172 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_562)), BgL_arg1773z00_647); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1109z00_646))->BgL_toterminatez00)=((obj_t)BgL_auxz00_1172),BUNSPEC);} } } } }  else 
{ /* Llib/thread.scm 318 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string1940z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_562)));} } 

}



/* &thread-start!-fthrea1148 */
obj_t BGl_z62threadzd2startz12zd2fthrea1148z70zz__ft_threadz00(obj_t BgL_envz00_563, obj_t BgL_tz00_564, obj_t BgL_oz00_565)
{
{ /* Llib/thread.scm 280 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_564)))
{ /* Llib/thread.scm 286 */
return 
BGl_errorz00zz__errorz00(BGl_string1954z00zz__ft_threadz00, BGl_string1965z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_564)));}  else 
{ /* Llib/thread.scm 288 */
BgL_schedulerz00_bglt BgL_scdlz00_649;
BgL_scdlz00_649 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)7)), BgL_oz00_565); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_564)))->BgL_schedulerz00)=((obj_t)
((obj_t)BgL_scdlz00_649)),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_564)))->BgL_z52builtinz52)=((obj_t)
BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(
((BgL_fthreadz00_bglt)BgL_tz00_564))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_564)))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)8))),BUNSPEC); 
{ /* Llib/thread.scm 295 */
obj_t BgL_arg1737z00_650;
BgL_arg1737z00_650 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_564)))->BgL_z52builtinz52); 
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1737z00_650), BNIL); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_649)))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(
(((long)1)+
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_649)))->BgL_z52livezd2threadzd2numberz52))))),BUNSPEC); 
{ 
obj_t BgL_auxz00_1211;
{ /* Llib/thread.scm 302 */
obj_t BgL_arg1748z00_651;
BgL_arg1748z00_651 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_649)))->BgL_tostartz00); 
BgL_auxz00_1211 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_564)), BgL_arg1748z00_651); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_649)))->BgL_tostartz00)=((obj_t)BgL_auxz00_1211),BUNSPEC); } 
return 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_564));} } 

}



/* &object-write-fthread1146 */
obj_t BGl_z62objectzd2writezd2fthread1146z62zz__ft_threadz00(obj_t BgL_envz00_566, obj_t BgL_oz00_567, obj_t BgL_portz00_568)
{
{ /* Llib/thread.scm 267 */
{ /* Llib/thread.scm 268 */
obj_t BgL_arg1705z00_653;
if(
PAIRP(BgL_portz00_568))
{ /* Llib/thread.scm 268 */
BgL_arg1705z00_653 = 
CAR(BgL_portz00_568); }  else 
{ /* Llib/thread.scm 268 */
obj_t BgL_tmpz00_1224;
BgL_tmpz00_1224 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1705z00_653 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1224); } 
{ /* Llib/thread.scm 270 */
obj_t BgL_zc3z04anonymousza31708ze3z87_654;
BgL_zc3z04anonymousza31708ze3z87_654 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31708ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31708ze3z87_654, 
(int)(((long)0)), 
((obj_t)
((BgL_fthreadz00_bglt)BgL_oz00_567))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1705z00_653, BgL_zc3z04anonymousza31708ze3z87_654);} } } 

}



/* &<@anonymous:1708> */
obj_t BGl_z62zc3z04anonymousza31708ze3ze5zz__ft_threadz00(obj_t BgL_envz00_569)
{
{ /* Llib/thread.scm 269 */
{ /* Llib/thread.scm 270 */
BgL_fthreadz00_bglt BgL_oz00_570;
BgL_oz00_570 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_569, 
(int)(((long)0)))); 
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1712z00_655;obj_t BgL_arg1713z00_656;int BgL_arg1714z00_657;obj_t BgL_arg1715z00_658;
BgL_arg1712z00_655 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_oz00_570)))->BgL_namez00); 
BgL_arg1713z00_656 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_570))->BgL_z52statez52); 
BgL_arg1714z00_657 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_570))->BgL_z52timeoutz52); 
BgL_arg1715z00_658 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_570))->BgL_z52signalsz52); 
{ /* Llib/thread.scm 271 */
obj_t BgL_list1716z00_659;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1717z00_660;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1718z00_661;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1719z00_662;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1720z00_663;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1726z00_664;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1727z00_665;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1730z00_666;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1734z00_667;
BgL_arg1734z00_667 = 
MAKE_YOUNG_PAIR(BGl_string1966z00zz__ft_threadz00, BNIL); 
BgL_arg1730z00_666 = 
MAKE_YOUNG_PAIR(BgL_arg1715z00_658, BgL_arg1734z00_667); } 
BgL_arg1727z00_665 = 
MAKE_YOUNG_PAIR(BGl_string1967z00zz__ft_threadz00, BgL_arg1730z00_666); } 
BgL_arg1726z00_664 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1714z00_657), BgL_arg1727z00_665); } 
BgL_arg1720z00_663 = 
MAKE_YOUNG_PAIR(BGl_string1968z00zz__ft_threadz00, BgL_arg1726z00_664); } 
BgL_arg1719z00_662 = 
MAKE_YOUNG_PAIR(BgL_arg1713z00_656, BgL_arg1720z00_663); } 
BgL_arg1718z00_661 = 
MAKE_YOUNG_PAIR(BGl_string1969z00zz__ft_threadz00, BgL_arg1719z00_662); } 
BgL_arg1717z00_660 = 
MAKE_YOUNG_PAIR(BgL_arg1712z00_655, BgL_arg1718z00_661); } 
BgL_list1716z00_659 = 
MAKE_YOUNG_PAIR(BGl_string1970z00zz__ft_threadz00, BgL_arg1717z00_660); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1716z00_659);} } } } 

}



/* &thread-join!-fthread1144 */
obj_t BGl_z62threadzd2joinz12zd2fthread1144z70zz__ft_threadz00(obj_t BgL_envz00_571, obj_t BgL_tz00_572, obj_t BgL_argsz00_573)
{
{ /* Llib/thread.scm 59 */
{ /* Llib/thread.scm 61 */
bool_t BgL_test2076z00_1254;
if(
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)9))))
{ /* Llib/thread.scm 61 */
BgL_test2076z00_1254 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 61 */
BgL_test2076z00_1254 = 
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)10)))
; } 
if(BgL_test2076z00_1254)
{ /* Llib/thread.scm 61 */
if(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2raisedz80))
{ /* Llib/thread.scm 62 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 62 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52resultz52);} }  else 
{ 
obj_t BgL_toz00_693;obj_t BgL_tozd2valzd2_694;obj_t BgL_toz00_678;
if(
PAIRP(BgL_argsz00_573))
{ /* Llib/thread.scm 65 */
obj_t BgL_cdrzd2110zd2_702;
BgL_cdrzd2110zd2_702 = 
CDR(BgL_argsz00_573); 
if(
PAIRP(BgL_cdrzd2110zd2_702))
{ /* Llib/thread.scm 65 */
if(
NULLP(
CDR(BgL_cdrzd2110zd2_702)))
{ /* Llib/thread.scm 65 */
BgL_toz00_693 = 
CAR(BgL_argsz00_573); 
BgL_tozd2valzd2_694 = 
CAR(BgL_cdrzd2110zd2_702); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_693))
{ /* Llib/thread.scm 69 */
obj_t BgL_vz00_695;
{ /* Llib/thread.scm 69 */
BgL_z52sigjoinz52_bglt BgL_arg1643z00_696;
{ /* Llib/thread.scm 69 */
BgL_z52sigjoinz52_bglt BgL_new1071z00_697;
{ /* Llib/thread.scm 70 */
BgL_z52sigjoinz52_bglt BgL_new1070z00_698;
BgL_new1070z00_698 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 70 */
long BgL_arg1645z00_699;
BgL_arg1645z00_699 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_698), BgL_arg1645z00_699); } 
BgL_new1071z00_697 = BgL_new1070z00_698; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1071z00_697))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_572)),BUNSPEC); 
BgL_arg1643z00_696 = BgL_new1071z00_697; } 
{ /* Llib/thread.scm 69 */
obj_t BgL_list1644z00_700;
BgL_list1644z00_700 = 
MAKE_YOUNG_PAIR(BgL_toz00_693, BNIL); 
BgL_vz00_695 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1643z00_696), BgL_list1644z00_700); } } 
{ /* Llib/thread.scm 74 */
bool_t BgL_test2083z00_1291;
{ /* Llib/thread.scm 74 */
obj_t BgL_arg1636z00_701;
BgL_arg1636z00_701 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80); 
BgL_test2083z00_1291 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1636z00_701, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2083z00_1291)
{ /* Llib/thread.scm 74 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 74 */
if(
CBOOL(BgL_vz00_695))
{ /* Llib/thread.scm 76 */
return BgL_vz00_695;}  else 
{ /* Llib/thread.scm 76 */
return BgL_tozd2valzd2_694;} } } }  else 
{ /* Llib/thread.scm 67 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1971z00zz__ft_threadz00, BGl_string1972z00zz__ft_threadz00, BgL_toz00_693);} }  else 
{ /* Llib/thread.scm 65 */
BgL_tagzd2103zd2_669:
{ /* Llib/thread.scm 95 */
obj_t BgL_vz00_672;
{ /* Llib/thread.scm 95 */
BgL_z52sigjoinz52_bglt BgL_arg1698z00_673;
{ /* Llib/thread.scm 95 */
BgL_z52sigjoinz52_bglt BgL_new1079z00_674;
{ /* Llib/thread.scm 96 */
BgL_z52sigjoinz52_bglt BgL_new1078z00_675;
BgL_new1078z00_675 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 96 */
long BgL_arg1700z00_676;
BgL_arg1700z00_676 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_675), BgL_arg1700z00_676); } 
BgL_new1079z00_674 = BgL_new1078z00_675; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1079z00_674))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_572)),BUNSPEC); 
BgL_arg1698z00_673 = BgL_new1079z00_674; } 
BgL_vz00_672 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1698z00_673), BNIL); } 
{ /* Llib/thread.scm 99 */
bool_t BgL_test2085z00_1311;
{ /* Llib/thread.scm 99 */
obj_t BgL_arg1697z00_677;
BgL_arg1697z00_677 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80); 
BgL_test2085z00_1311 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1697z00_677, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2085z00_1311)
{ /* Llib/thread.scm 99 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 99 */
return BgL_vz00_672;} } } } }  else 
{ /* Llib/thread.scm 65 */
if(
NULLP(BgL_cdrzd2110zd2_702))
{ /* Llib/thread.scm 65 */
BgL_toz00_678 = 
CAR(BgL_argsz00_573); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_678))
{ /* Llib/thread.scm 83 */
obj_t BgL_vz00_679;
{ /* Llib/thread.scm 83 */
BgL_z52sigjoinz52_bglt BgL_arg1677z00_680;
{ /* Llib/thread.scm 83 */
BgL_z52sigjoinz52_bglt BgL_new1074z00_681;
{ /* Llib/thread.scm 84 */
BgL_z52sigjoinz52_bglt BgL_new1073z00_682;
BgL_new1073z00_682 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 84 */
long BgL_arg1681z00_683;
BgL_arg1681z00_683 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_682), BgL_arg1681z00_683); } 
BgL_new1074z00_681 = BgL_new1073z00_682; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1074z00_681))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_572)),BUNSPEC); 
BgL_arg1677z00_680 = BgL_new1074z00_681; } 
{ /* Llib/thread.scm 83 */
obj_t BgL_list1678z00_684;
BgL_list1678z00_684 = 
MAKE_YOUNG_PAIR(BgL_toz00_678, BNIL); 
BgL_vz00_679 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1677z00_680), BgL_list1678z00_684); } } 
{ /* Llib/thread.scm 88 */
bool_t BgL_test2088z00_1331;
{ /* Llib/thread.scm 88 */
obj_t BgL_arg1674z00_685;
BgL_arg1674z00_685 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80); 
BgL_test2088z00_1331 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1674z00_685, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2088z00_1331)
{ /* Llib/thread.scm 88 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_572)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 88 */
if(
CBOOL(BgL_vz00_679))
{ /* Llib/thread.scm 90 */
return BgL_vz00_679;}  else 
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_arg1656z00_686;
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1077z00_687;
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1076z00_688;
BgL_new1076z00_688 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 93 */
long BgL_arg1671z00_689;
BgL_arg1671z00_689 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1076z00_688), BgL_arg1671z00_689); } 
BgL_new1077z00_687 = BgL_new1076z00_688; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_687)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_687)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1348;
{ /* Llib/thread.scm 93 */
obj_t BgL_arg1661z00_690;
{ /* Llib/thread.scm 93 */
obj_t BgL_arg1662z00_691;
{ /* Llib/thread.scm 93 */
obj_t BgL_classz00_692;
BgL_classz00_692 = BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00; 
BgL_arg1662z00_691 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_692); } 
BgL_arg1661z00_690 = 
VECTOR_REF(BgL_arg1662z00_691,((long)2)); } 
BgL_auxz00_1348 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1661z00_690); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1077z00_687)))->BgL_stackz00)=((obj_t)BgL_auxz00_1348),BUNSPEC); } 
BgL_arg1656z00_686 = BgL_new1077z00_687; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1656z00_686));} } } }  else 
{ /* Llib/thread.scm 81 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1971z00zz__ft_threadz00, BGl_string1972z00zz__ft_threadz00, BgL_toz00_678);} }  else 
{ /* Llib/thread.scm 65 */
goto BgL_tagzd2103zd2_669;} } }  else 
{ /* Llib/thread.scm 65 */
goto BgL_tagzd2103zd2_669;} } } } 

}



/* &object-equal?-%sigjo1142 */
obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1142zc3zz__ft_threadz00(obj_t BgL_envz00_574, obj_t BgL_o1z00_575, obj_t BgL_o2z00_576)
{
{ /* Llib/thread.scm 50 */
{ /* Llib/thread.scm 51 */
bool_t BgL_tmpz00_1358;
if(
BGl_isazf3zf3zz__objectz00(BgL_o2z00_576, BGl_z52sigjoinz52zz__ft_typesz00))
{ /* Llib/thread.scm 51 */
BgL_tmpz00_1358 = 
(
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o1z00_575)))->BgL_threadz00))==
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o2z00_576)))->BgL_threadz00)))
; }  else 
{ /* Llib/thread.scm 51 */
BgL_tmpz00_1358 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_1358);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892275), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536507091), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827911), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966270), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)360853603), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565054), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295111899), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486293435), 
BSTRING_TO_STRING(BGl_string1973z00zz__ft_threadz00));} 

}

#ifdef __cplusplus
}
#endif
