/*===========================================================================*/
/*   (Llib/mpg123_decoder.scm)                                               */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi mpg123 -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/mpg123_decoder.scm -o objs/mpg123_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <mpg123.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_mpg123zd2handlezd2_bgl {
   header_t header;
   obj_t widening;
   mpg123_handle * BgL_z42builtinz42;
   obj_t BgL_decoderz00;
   long BgL_siza7eza7;
} *BgL_mpg123zd2handlezd2_bglt;

typedef struct BgL_mpg123zd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52mpg123z52;
   long BgL_z52z12dseekz40;
   int BgL_z52ratez52;
   int BgL_z52channelsz52;
   obj_t BgL_z52encodingz52;
} *BgL_mpg123zd2decoderzd2_bglt;


static obj_t BGl_z62musicdecoderzd2closezd2m1133z62zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2streamzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00 = BUNSPEC;
static obj_t BGl_z62musicdecoderzd2decodezd21145z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2initzd2mp1131z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
extern obj_t BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static int BGl_mpg123zd2debugzd2zz__mpg123_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31220ze3ze5zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31204ze3ze5zz__mpg123_decoderz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__mpg123_decoderz00();
extern obj_t BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00;
extern long BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_genericzd2initzd2zz__mpg123_decoderz00();
static obj_t BGl_z62musicdecoderzd2infozd2mp1139z62zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__mpg123_decoderz00();
static obj_t BGl_z62musicdecoderzd2positio1137zb0zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
extern obj_t BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_debugz00zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31250ze3ze5zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31242ze3ze5zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__mpg123_decoderz00();
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
extern obj_t BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
static obj_t BGl_z62lambda1202z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1203z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static long BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(long, BgL_musicbufferz00_bglt);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
extern int bgl_mpg123_decode(obj_t, char *, long, long, char *, long);
static obj_t BGl_z62lambda1218z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1219z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2resetz12zd21135z70zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mp3zd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_z62lambda1240z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1241z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1248z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1249z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62lambda1259z62zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62lambda1260z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1183z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31188ze3ze5zz__mpg123_decoderz00(obj_t, obj_t);
BGL_IMPORT long BGl_mp3zd2indexzd2zz__multimediazd2mp3zd2(obj_t, long);
static BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1186z62zz__mpg123_decoderz00(obj_t);
static obj_t BGl_z62objectzd2printzd2mpg123zd21129zb0zz__mpg123_decoderz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__mpg123_decoderz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00();
static obj_t BGl_z62musicdecoderzd2seekzd2mp1141z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2initz12zc0zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00();
static obj_t BGl_gczd2rootszd2initz00zz__mpg123_decoderz00();
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, obj_t);
BGL_IMPORT long BGl_musicdecoderzd2infozd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt);
static obj_t BGl_z62lambda1282z62zz__mpg123_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1283z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2volumezd21143z62zz__mpg123_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
extern long BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(BgL_mpg123zd2handlezd2_bglt);
static obj_t BGl_newzd2formatzd2zz__mpg123_decoderz00(BgL_mpg123zd2decoderzd2_bglt, BgL_musicbufz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = BUNSPEC;
extern obj_t BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(int);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2drainzd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt);
static obj_t __cnst[ 21 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1920z00zz__mpg123_decoderz00, BgL_bgl_string1920za700za7za7_1995za7, "Llib/mpg123_decoder.scm", 23 );
DEFINE_STRING( BGl_string1921z00zz__mpg123_decoderz00, BgL_bgl_string1921za700za7za7_1996za7, "/tmp/MPG123.log", 15 );
DEFINE_STRING( BGl_string1922z00zz__mpg123_decoderz00, BgL_bgl_string1922za700za7za7_1997za7, "\n", 1 );
DEFINE_STRING( BGl_string1923z00zz__mpg123_decoderz00, BgL_bgl_string1923za700za7za7_1998za7, " ", 1 );
DEFINE_STRING( BGl_string1924z00zz__mpg123_decoderz00, BgL_bgl_string1924za700za7za7_1999za7, ">>> MPG123_DECODER init ", 24 );
DEFINE_STRING( BGl_string1925z00zz__mpg123_decoderz00, BgL_bgl_string1925za700za7za7_2000za7, ">>> MPG123_DECODER stop ", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1926z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2001za7, BGl_z62zc3z04anonymousza31204ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1927z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1203za7622002z00, BGl_z62lambda1203z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1928z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1202za7622003z00, BGl_z62lambda1202z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1929z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2004za7, BGl_z62zc3z04anonymousza31220ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_musicdecoderzd2closezd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1930z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1219za7622005z00, BGl_z62lambda1219z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1931z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1218za7622006z00, BGl_z62lambda1218z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1932z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2007za7, BGl_z62zc3z04anonymousza31242ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1933z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1241za7622008z00, BGl_z62lambda1241z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1934z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1240za7622009z00, BGl_z62lambda1240z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1935z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2010za7, BGl_z62zc3z04anonymousza31250ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1936z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1249za7622011z00, BGl_z62lambda1249z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1937z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1248za7622012z00, BGl_z62lambda1248z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1938z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2013za7, BGl_z62zc3z04anonymousza31261ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1260za7622014z00, BGl_z62lambda1260z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1947z00zz__mpg123_decoderz00, BgL_bgl_string1947za700za7za7_2015za7, "", 0 );
DEFINE_STRING( BGl_string1949z00zz__mpg123_decoderz00, BgL_bgl_string1949za700za7za7_2016za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1940z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1259za7622017z00, BGl_z62lambda1259z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1941z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2018za7, BGl_z62zc3z04anonymousza31284ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1942z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1283za7622019z00, BGl_z62lambda1283z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1943z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1282za7622020z00, BGl_z62lambda1282z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1944z00zz__mpg123_decoderz00, BgL_bgl_za762za7c3za704anonymo2021za7, BGl_z62zc3z04anonymousza31188ze3ze5zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1951z00zz__mpg123_decoderz00, BgL_bgl_string1951za700za7za7_2022za7, "musicdecoder-init", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1945z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1186za7622023z00, BGl_z62lambda1186z62zz__mpg123_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1946z00zz__mpg123_decoderz00, BgL_bgl_za762lambda1183za7622024z00, BGl_z62lambda1183z62zz__mpg123_decoderz00, 0L, BUNSPEC, 16 );
DEFINE_STRING( BGl_string1953z00zz__mpg123_decoderz00, BgL_bgl_string1953za700za7za7_2025za7, "musicdecoder-close", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1948z00zz__mpg123_decoderz00, BgL_bgl_za762objectza7d2prin2026z00, BGl_z62objectzd2printzd2mpg123zd21129zb0zz__mpg123_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1955z00zz__mpg123_decoderz00, BgL_bgl_string1955za700za7za7_2027za7, "musicdecoder-reset!", 19 );
DEFINE_STRING( BGl_string1957z00zz__mpg123_decoderz00, BgL_bgl_string1957za700za7za7_2028za7, "musicdecoder-position", 21 );
DEFINE_STRING( BGl_string1959z00zz__mpg123_decoderz00, BgL_bgl_string1959za700za7za7_2029za7, "musicdecoder-info", 17 );
BGL_IMPORT obj_t BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1950z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72030z00, BGl_z62musicdecoderzd2initzd2mp1131z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1952z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72031z00, BGl_z62musicdecoderzd2closezd2m1133z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1954z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72032z00, BGl_z62musicdecoderzd2resetz12zd21135z70zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1961z00zz__mpg123_decoderz00, BgL_bgl_string1961za700za7za7_2033za7, "musicdecoder-seek", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1956z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72034z00, BGl_z62musicdecoderzd2positio1137zb0zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1963z00zz__mpg123_decoderz00, BgL_bgl_string1963za700za7za7_2035za7, "musicdecoder-volume-set!", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1958z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72036z00, BGl_z62musicdecoderzd2infozd2mp1139z62zz__mpg123_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1965z00zz__mpg123_decoderz00, BgL_bgl_string1965za700za7za7_2037za7, "musicdecoder-decode", 19 );
DEFINE_STRING( BGl_string1966z00zz__mpg123_decoderz00, BgL_bgl_string1966za700za7za7_2038za7, "\033[0m\033[1;33m", 11 );
DEFINE_STRING( BGl_string1967z00zz__mpg123_decoderz00, BgL_bgl_string1967za700za7za7_2039za7, "\033[0m\033[1;32m", 11 );
DEFINE_STRING( BGl_string1968z00zz__mpg123_decoderz00, BgL_bgl_string1968za700za7za7_2040za7, " EOF", 4 );
DEFINE_STRING( BGl_string1969z00zz__mpg123_decoderz00, BgL_bgl_string1969za700za7za7_2041za7, " url=", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1960z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72042z00, BGl_z62musicdecoderzd2seekzd2mp1141z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1962z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72043z00, BGl_z62musicdecoderzd2volumezd21143z62zz__mpg123_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1970z00zz__mpg123_decoderz00, BgL_bgl_string1970za700za7za7_2044za7, "%\033[0m", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1964z00zz__mpg123_decoderz00, BgL_bgl_za762musicdecoderza72045z00, BGl_z62musicdecoderzd2decodezd21145z62zz__mpg123_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1971z00zz__mpg123_decoderz00, BgL_bgl_string1971za700za7za7_2046za7, "--- MPG123_DECODER, buffer fill: ", 33 );
DEFINE_STRING( BGl_string1972z00zz__mpg123_decoderz00, BgL_bgl_string1972za700za7za7_2047za7, "...", 3 );
DEFINE_STRING( BGl_string1973z00zz__mpg123_decoderz00, BgL_bgl_string1973za700za7za7_2048za7, "--> MPG123_DECODER, broadcast not-full ", 39 );
DEFINE_STRING( BGl_string1974z00zz__mpg123_decoderz00, BgL_bgl_string1974za700za7za7_2049za7, "~~~ MPG123_DECODER, EOF ", 24 );
DEFINE_STRING( BGl_string1975z00zz__mpg123_decoderz00, BgL_bgl_string1975za700za7za7_2050za7, "<-- MPG123_DECODER, wait not-empty ", 35 );
DEFINE_STRING( BGl_string1976z00zz__mpg123_decoderz00, BgL_bgl_string1976za700za7za7_2051za7, " -> status=", 11 );
DEFINE_STRING( BGl_string1977z00zz__mpg123_decoderz00, BgL_bgl_string1977za700za7za7_2052za7, " hd=", 4 );
DEFINE_STRING( BGl_string1978z00zz__mpg123_decoderz00, BgL_bgl_string1978za700za7za7_2053za7, " tl=", 4 );
DEFINE_STRING( BGl_string1979z00zz__mpg123_decoderz00, BgL_bgl_string1979za700za7za7_2054za7, "~~~ MPG123_DECODER, s=", 22 );
DEFINE_STRING( BGl_string1980z00zz__mpg123_decoderz00, BgL_bgl_string1980za700za7za7_2055za7, "offset=", 7 );
DEFINE_STRING( BGl_string1981z00zz__mpg123_decoderz00, BgL_bgl_string1981za700za7za7_2056za7, ":", 1 );
DEFINE_STRING( BGl_string1982z00zz__mpg123_decoderz00, BgL_bgl_string1982za700za7za7_2057za7, ",", 1 );
DEFINE_STRING( BGl_string1983z00zz__mpg123_decoderz00, BgL_bgl_string1983za700za7za7_2058za7, " size=", 6 );
DEFINE_STRING( BGl_string1984z00zz__mpg123_decoderz00, BgL_bgl_string1984za700za7za7_2059za7, "~~~ MPG123_DECODER, OK s=", 25 );
DEFINE_STRING( BGl_string1985z00zz__mpg123_decoderz00, BgL_bgl_string1985za700za7za7_2060za7, " tail=", 6 );
DEFINE_STRING( BGl_string1986z00zz__mpg123_decoderz00, BgL_bgl_string1986za700za7za7_2061za7, " %empty=", 8 );
DEFINE_STRING( BGl_string1987z00zz__mpg123_decoderz00, BgL_bgl_string1987za700za7za7_2062za7, "~~~ MPG123_DECODER, NEED-MORE s=", 32 );
DEFINE_STRING( BGl_string1988z00zz__mpg123_decoderz00, BgL_bgl_string1988za700za7za7_2063za7, "mp3 decoding error", 18 );
DEFINE_STRING( BGl_string1989z00zz__mpg123_decoderz00, BgL_bgl_string1989za700za7za7_2064za7, "~~~ MPG123_SEEK, seek=", 22 );
DEFINE_STRING( BGl_string1990z00zz__mpg123_decoderz00, BgL_bgl_string1990za700za7za7_2065za7, "#|mpg123-decoder|", 17 );
DEFINE_STRING( BGl_string1991z00zz__mpg123_decoderz00, BgL_bgl_string1991za700za7za7_2066za7, "__mpg123_decoder", 16 );
DEFINE_STRING( BGl_string1992z00zz__mpg123_decoderz00, BgL_bgl_string1992za700za7za7_2067za7, "(\"audio/mpeg\") buffering ended stop play pause unknown _ __mpg123_decoder mpg123-decoder symbol %encoding %channels int %rate long %!dseek obj %mpg123 bstring outbuf ", 166 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00) );
ADD_ROOT( (void *)(&BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mpg123_decoderz00(long BgL_checksumz00_1000, char * BgL_fromz00_1001)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__mpg123_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mpg123_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00(); 
BGl_cnstzd2initzd2zz__mpg123_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00(); 
BGl_objectzd2initzd2zz__mpg123_decoderz00(); 
BGl_methodzd2initzd2zz__mpg123_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__mpg123_decoderz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2mp3zd2(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__mpg123_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__mpg123_decoder"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_cportz00_793;
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_stringz00_801;
BgL_stringz00_801 = BGl_string1992z00zz__mpg123_decoderz00; 
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_startz00_802;
BgL_startz00_802 = 
BINT(((long)0)); 
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_endz00_803;
BgL_endz00_803 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_801))); 
{ /* Llib/mpg123_decoder.scm 15 */

BgL_cportz00_793 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_801, BgL_startz00_802, BgL_endz00_803); } } } } 
{ 
long BgL_iz00_794;
BgL_iz00_794 = ((long)20); 
BgL_loopz00_795:
if(
(BgL_iz00_794==((long)-1)))
{ /* Llib/mpg123_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_arg1994z00_797;
{ /* Llib/mpg123_decoder.scm 15 */

{ /* Llib/mpg123_decoder.scm 15 */
obj_t BgL_locationz00_799;
BgL_locationz00_799 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpg123_decoder.scm 15 */

BgL_arg1994z00_797 = 
BGl_readz00zz__readerz00(BgL_cportz00_793, BgL_locationz00_799); } } } 
{ /* Llib/mpg123_decoder.scm 15 */
int BgL_tmpz00_1036;
BgL_tmpz00_1036 = 
(int)(BgL_iz00_794); 
CNST_TABLE_SET(BgL_tmpz00_1036, BgL_arg1994z00_797); } } 
{ /* Llib/mpg123_decoder.scm 15 */
int BgL_auxz00_800;
BgL_auxz00_800 = 
(int)(
(BgL_iz00_794-((long)1))); 
{ 
long BgL_iz00_1041;
BgL_iz00_1041 = 
(long)(BgL_auxz00_800); 
BgL_iz00_794 = BgL_iz00_1041; 
goto BgL_loopz00_795;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1920z00zz__mpg123_decoderz00)); 
return ( 
BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = BFALSE, BUNSPEC) ;} 

}



/* mpg123-debug */
int BGl_mpg123zd2debugzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 38 */
if(
(((long)0)>((long)0)))
{ /* Llib/mpg123_decoder.scm 39 */
return 
bgl_debug();}  else 
{ /* Llib/mpg123_decoder.scm 39 */
return 
(int)(((long)0));} } 

}



/* new-format */
obj_t BGl_newzd2formatzd2zz__mpg123_decoderz00(BgL_mpg123zd2decoderzd2_bglt BgL_decz00_19, BgL_musicbufz00_bglt BgL_amz00_20, BgL_musicbufferz00_bglt BgL_bufferz00_21)
{
{ /* Llib/mpg123_decoder.scm 303 */
{ /* Llib/mpg123_decoder.scm 305 */
obj_t BgL_ratez00_35;
{ /* Llib/mpg123_decoder.scm 306 */
obj_t BgL_arg1155z00_38;
BgL_arg1155z00_38 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52mpg123z52); 
BgL_ratez00_35 = 
BGl_mpg123zd2getzd2formatz00zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1155z00_38)); } 
{ /* Llib/mpg123_decoder.scm 306 */
obj_t BgL_channelsz00_36;obj_t BgL_encodingz00_37;
{ /* Llib/mpg123_decoder.scm 307 */
int BgL_tmpz00_1053;
BgL_tmpz00_1053 = 
(int)(((long)1)); 
BgL_channelsz00_36 = 
BGL_MVALUES_VAL(BgL_tmpz00_1053); } 
{ /* Llib/mpg123_decoder.scm 307 */
int BgL_tmpz00_1056;
BgL_tmpz00_1056 = 
(int)(((long)2)); 
BgL_encodingz00_37 = 
BGL_MVALUES_VAL(BgL_tmpz00_1056); } 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52ratez52)=((int)
CINT(BgL_ratez00_35)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52channelsz52)=((int)
CINT(BgL_channelsz00_36)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_decz00_19))->BgL_z52encodingz52)=((obj_t)BgL_encodingz00_37),BUNSPEC); 
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19), 
((BgL_musicz00_bglt)BgL_amz00_20), BgL_bufferz00_21); } } 
{ /* Llib/mpg123_decoder.scm 312 */
BgL_musicstatusz00_bglt BgL_i1119z00_40;
BgL_i1119z00_40 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_amz00_20)))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1119z00_40))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19), BgL_bufferz00_21))),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 314 */
long BgL_bratez00_41;
BgL_bratez00_41 = 
BGl_musicdecoderzd2infozd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)BgL_decz00_19)); 
{ /* Llib/mpg123_decoder.scm 315 */
obj_t BgL_ratez00_42;
{ /* Llib/mpg123_decoder.scm 316 */
int BgL_tmpz00_1075;
BgL_tmpz00_1075 = 
(int)(((long)1)); 
BgL_ratez00_42 = 
BGL_MVALUES_VAL(BgL_tmpz00_1075); } 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1119z00_40))->BgL_bitratez00)=((int)
(int)(BgL_bratez00_41)),BUNSPEC); 
return 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1119z00_40))->BgL_khza7za7)=((int)
CINT(BgL_ratez00_42)),BUNSPEC);} } } } 

}



/* debug-init! */
obj_t BGl_debugzd2initz12zc0zz__mpg123_decoderz00(obj_t BgL_urlz00_22)
{
{ /* Llib/mpg123_decoder.scm 327 */
{ /* Llib/mpg123_decoder.scm 328 */

BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00 = 
BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(BGl_string1921z00zz__mpg123_decoderz00, BTRUE); } 
{ /* Llib/mpg123_decoder.scm 329 */
BGL_LONGLONG_T BgL_arg1156z00_45;
BgL_arg1156z00_45 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_list1157z00_46;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1158z00_47;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1159z00_48;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1160z00_49;
{ /* Llib/mpg123_decoder.scm 329 */
obj_t BgL_arg1161z00_50;
BgL_arg1161z00_50 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1160z00_49 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1156z00_45), BgL_arg1161z00_50); } 
BgL_arg1159z00_48 = 
MAKE_YOUNG_PAIR(BGl_string1923z00zz__mpg123_decoderz00, BgL_arg1160z00_49); } 
BgL_arg1158z00_47 = 
MAKE_YOUNG_PAIR(BgL_urlz00_22, BgL_arg1159z00_48); } 
BgL_list1157z00_46 = 
MAKE_YOUNG_PAIR(BGl_string1924z00zz__mpg123_decoderz00, BgL_arg1158z00_47); } 
return 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1157z00_46);} } } 

}



/* debug-stop! */
obj_t BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(obj_t BgL_urlz00_23)
{
{ /* Llib/mpg123_decoder.scm 334 */
{ /* Llib/mpg123_decoder.scm 335 */
BGL_LONGLONG_T BgL_arg1165z00_51;
BgL_arg1165z00_51 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_list1166z00_52;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1168z00_53;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1169z00_54;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1172z00_55;
{ /* Llib/mpg123_decoder.scm 335 */
obj_t BgL_arg1173z00_56;
BgL_arg1173z00_56 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1172z00_55 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1165z00_51), BgL_arg1173z00_56); } 
BgL_arg1169z00_54 = 
MAKE_YOUNG_PAIR(BGl_string1923z00zz__mpg123_decoderz00, BgL_arg1172z00_55); } 
BgL_arg1168z00_53 = 
MAKE_YOUNG_PAIR(BgL_urlz00_23, BgL_arg1169z00_54); } 
BgL_list1166z00_52 = 
MAKE_YOUNG_PAIR(BGl_string1925z00zz__mpg123_decoderz00, BgL_arg1168z00_53); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1166z00_52); } } 
return 
bgl_close_output_port(BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00);} 

}



/* debug */
obj_t BGl_debugz00zz__mpg123_decoderz00(obj_t BgL_argsz00_24)
{
{ /* Llib/mpg123_decoder.scm 341 */
{ 
obj_t BgL_l1124z00_58;
BgL_l1124z00_58 = BgL_argsz00_24; 
BgL_zc3z04anonymousza31174ze3z87_59:
if(
PAIRP(BgL_l1124z00_58))
{ /* Llib/mpg123_decoder.scm 342 */
{ /* Llib/mpg123_decoder.scm 342 */
obj_t BgL_az00_61;
BgL_az00_61 = 
CAR(BgL_l1124z00_58); 
bgl_display_obj(BgL_az00_61, BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00); } 
{ 
obj_t BgL_l1124z00_1104;
BgL_l1124z00_1104 = 
CDR(BgL_l1124z00_58); 
BgL_l1124z00_58 = BgL_l1124z00_1104; 
goto BgL_zc3z04anonymousza31174ze3z87_59;} }  else 
{ /* Llib/mpg123_decoder.scm 342 */((bool_t)1); } } 
return 
bgl_flush_output_port(BGl_za2debugzd2portza2zd2zz__mpg123_decoderz00);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1181z00_67;obj_t BgL_arg1182z00_68;
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_v1126z00_95;
BgL_v1126z00_95 = 
create_vector(((long)6)); 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1189z00_96;
BgL_arg1189z00_96 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1928z00zz__mpg123_decoderz00, BGl_proc1927z00zz__mpg123_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1926z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1126z00_95,((long)0),BgL_arg1189z00_96); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1206z00_111;
BgL_arg1206z00_111 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1931z00zz__mpg123_decoderz00, BGl_proc1930z00zz__mpg123_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1929z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)3))); 
VECTOR_SET(BgL_v1126z00_95,((long)1),BgL_arg1206z00_111); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1229z00_130;
BgL_arg1229z00_130 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1934z00zz__mpg123_decoderz00, BGl_proc1933z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1932z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_95,((long)2),BgL_arg1229z00_130); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1244z00_143;
BgL_arg1244z00_143 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1937z00zz__mpg123_decoderz00, BGl_proc1936z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1935z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1126z00_95,((long)3),BgL_arg1244z00_143); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1252z00_156;
BgL_arg1252z00_156 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1940z00zz__mpg123_decoderz00, BGl_proc1939z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1938z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1126z00_95,((long)4),BgL_arg1252z00_156); } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_arg1277z00_169;
BgL_arg1277z00_169 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc1943z00zz__mpg123_decoderz00, BGl_proc1942z00zz__mpg123_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1941z00zz__mpg123_decoderz00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1126z00_95,((long)5),BgL_arg1277z00_169); } 
BgL_arg1181z00_67 = BgL_v1126z00_95; } 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_v1127z00_182;
BgL_v1127z00_182 = 
create_vector(((long)0)); 
BgL_arg1182z00_68 = BgL_v1127z00_182; } 
return ( 
BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)50873), BGl_proc1946z00zz__mpg123_decoderz00, BGl_proc1945z00zz__mpg123_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1944z00zz__mpg123_decoderz00, BFALSE, BgL_arg1181z00_67, BgL_arg1182z00_68), BUNSPEC) ;} } 

}



/* &<@anonymous:1188> */
obj_t BGl_z62zc3z04anonymousza31188ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_676, obj_t BgL_new1092z00_677)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ 
BgL_mpg123zd2decoderzd2_bglt BgL_auxz00_1136;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_outbufz00)=((obj_t)BGl_string1947z00zz__mpg123_decoderz00),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_z52mpg123z52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_z52z12dseekz40)=((long)((long)0)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_z52ratez52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_z52channelsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677)))->BgL_z52encodingz52)=((obj_t)
CNST_TABLE_REF(((long)13))),BUNSPEC); 
BgL_auxz00_1136 = 
((BgL_mpg123zd2decoderzd2_bglt)BgL_new1092z00_677); 
return 
((obj_t)BgL_auxz00_1136);} } 

}



/* &lambda1186 */
BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1186z62zz__mpg123_decoderz00(obj_t BgL_envz00_678)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1091z00_806;
BgL_new1091z00_806 = 
((BgL_mpg123zd2decoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2decoderzd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_arg1187z00_807;
BgL_arg1187z00_807 = 
BGL_CLASS_INDEX(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_806), BgL_arg1187z00_807); } 
return BgL_new1091z00_806;} } 

}



/* &lambda1183 */
BgL_mpg123zd2decoderzd2_bglt BGl_z62lambda1183z62zz__mpg123_decoderz00(obj_t BgL_envz00_679, obj_t BgL_mimetypes1075z00_680, obj_t BgL_bufferzd2timezd2near1076z00_681, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1077z75_682, obj_t BgL_periodzd2siza7ezd2nearzd2rat1078z75_683, obj_t BgL_z52z12dpause1079z40_684, obj_t BgL_z52z12dabort1080z40_685, obj_t BgL_z52z12stop1081z40_686, obj_t BgL_z52dmutex1082z52_687, obj_t BgL_z52dcondv1083z52_688, obj_t BgL_z52doutcondv1084z52_689, obj_t BgL_outbuf1085z00_690, obj_t BgL_z52mpg1231086z52_691, obj_t BgL_z52z12dseek1087z40_692, obj_t BgL_z52rate1088z52_693, obj_t BgL_z52channels1089z52_694, obj_t BgL_z52encoding1090z52_695)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_bufferzd2timezd2near1076z00_809;int BgL_bufferzd2siza7ezd2nearzd2rat1077z75_810;int BgL_periodzd2siza7ezd2nearzd2rat1078z75_811;bool_t BgL_z52z12dpause1079z40_812;bool_t BgL_z52z12dabort1080z40_813;bool_t BgL_z52z12stop1081z40_814;long BgL_z52z12dseek1087z40_819;int BgL_z52rate1088z52_820;int BgL_z52channels1089z52_821;
BgL_bufferzd2timezd2near1076z00_809 = 
CINT(BgL_bufferzd2timezd2near1076z00_681); 
BgL_bufferzd2siza7ezd2nearzd2rat1077z75_810 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1077z75_682); 
BgL_periodzd2siza7ezd2nearzd2rat1078z75_811 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1078z75_683); 
BgL_z52z12dpause1079z40_812 = 
CBOOL(BgL_z52z12dpause1079z40_684); 
BgL_z52z12dabort1080z40_813 = 
CBOOL(BgL_z52z12dabort1080z40_685); 
BgL_z52z12stop1081z40_814 = 
CBOOL(BgL_z52z12stop1081z40_686); 
BgL_z52z12dseek1087z40_819 = 
(long)CINT(BgL_z52z12dseek1087z40_692); 
BgL_z52rate1088z52_820 = 
CINT(BgL_z52rate1088z52_693); 
BgL_z52channels1089z52_821 = 
CINT(BgL_z52channels1089z52_694); 
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1121z00_823;
{ /* Llib/mpg123_decoder.scm 21 */
BgL_mpg123zd2decoderzd2_bglt BgL_new1120z00_824;
BgL_new1120z00_824 = 
((BgL_mpg123zd2decoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2decoderzd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_arg1185z00_825;
BgL_arg1185z00_825 = 
BGL_CLASS_INDEX(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_824), BgL_arg1185z00_825); } 
BgL_new1121z00_823 = BgL_new1120z00_824; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1075z00_680)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1076z00_809),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1077z75_810),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1078z75_811),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1079z40_812),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1080z40_813),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1081z40_814),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1082z52_687)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1083z52_688)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1121z00_823)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1084z52_689)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1085z00_690)),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_z52mpg123z52)=((obj_t)BgL_z52mpg1231086z52_691),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_z52z12dseekz40)=((long)BgL_z52z12dseek1087z40_819),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_z52ratez52)=((int)BgL_z52rate1088z52_820),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_z52channelsz52)=((int)BgL_z52channels1089z52_821),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(BgL_new1121z00_823))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_z52encoding1090z52_695)),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 21 */
obj_t BgL_fun1184z00_826;
BgL_fun1184z00_826 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1184z00_826)(BgL_fun1184z00_826, 
((obj_t)BgL_new1121z00_823), BEOA); } 
return BgL_new1121z00_823;} } } 

}



/* &<@anonymous:1284> */
obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_696)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
CNST_TABLE_REF(((long)14));} 

}



/* &lambda1283 */
obj_t BGl_z62lambda1283z62zz__mpg123_decoderz00(obj_t BgL_envz00_697, obj_t BgL_oz00_698, obj_t BgL_vz00_699)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_698)))->BgL_z52encodingz52)=((obj_t)
((obj_t)BgL_vz00_699)),BUNSPEC);} 

}



/* &lambda1282 */
obj_t BGl_z62lambda1282z62zz__mpg123_decoderz00(obj_t BgL_envz00_700, obj_t BgL_oz00_701)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_701)))->BgL_z52encodingz52);} 

}



/* &<@anonymous:1261> */
obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_702)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1260 */
obj_t BGl_z62lambda1260z62zz__mpg123_decoderz00(obj_t BgL_envz00_703, obj_t BgL_oz00_704, obj_t BgL_vz00_705)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_vz00_831;
BgL_vz00_831 = 
CINT(BgL_vz00_705); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_704)))->BgL_z52channelsz52)=((int)BgL_vz00_831),BUNSPEC);} } 

}



/* &lambda1259 */
obj_t BGl_z62lambda1259z62zz__mpg123_decoderz00(obj_t BgL_envz00_706, obj_t BgL_oz00_707)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_707)))->BgL_z52channelsz52));} 

}



/* &<@anonymous:1250> */
obj_t BGl_z62zc3z04anonymousza31250ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_708)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1249 */
obj_t BGl_z62lambda1249z62zz__mpg123_decoderz00(obj_t BgL_envz00_709, obj_t BgL_oz00_710, obj_t BgL_vz00_711)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
int BgL_vz00_834;
BgL_vz00_834 = 
CINT(BgL_vz00_711); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_710)))->BgL_z52ratez52)=((int)BgL_vz00_834),BUNSPEC);} } 

}



/* &lambda1248 */
obj_t BGl_z62lambda1248z62zz__mpg123_decoderz00(obj_t BgL_envz00_712, obj_t BgL_oz00_713)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_713)))->BgL_z52ratez52));} 

}



/* &<@anonymous:1242> */
obj_t BGl_z62zc3z04anonymousza31242ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_714)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(((long)-1));} 

}



/* &lambda1241 */
obj_t BGl_z62lambda1241z62zz__mpg123_decoderz00(obj_t BgL_envz00_715, obj_t BgL_oz00_716, obj_t BgL_vz00_717)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 21 */
long BgL_vz00_837;
BgL_vz00_837 = 
(long)CINT(BgL_vz00_717); 
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_716)))->BgL_z52z12dseekz40)=((long)BgL_vz00_837),BUNSPEC);} } 

}



/* &lambda1240 */
obj_t BGl_z62lambda1240z62zz__mpg123_decoderz00(obj_t BgL_envz00_718, obj_t BgL_oz00_719)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_719)))->BgL_z52z12dseekz40));} 

}



/* &<@anonymous:1220> */
obj_t BGl_z62zc3z04anonymousza31220ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_720)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ 
BgL_mpg123zd2handlezd2_bglt BgL_auxz00_1272;
{ /* Llib/mpg123_decoder.scm 23 */
BgL_mpg123zd2handlezd2_bglt BgL_new1123z00_839;
{ /* Llib/mpg123_decoder.scm 23 */
BgL_mpg123zd2handlezd2_bglt BgL_new1122z00_840;
BgL_new1122z00_840 = 
((BgL_mpg123zd2handlezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpg123zd2handlezd2_bgl) ))); 
{ /* Llib/mpg123_decoder.scm 23 */
long BgL_arg1227z00_841;
BgL_arg1227z00_841 = 
BGL_CLASS_INDEX(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_840), BgL_arg1227z00_841); } 
BgL_new1123z00_839 = BgL_new1122z00_840; } 
{ 
void * BgL_auxz00_1277;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_arg1221z00_842;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_arg1222z00_843;
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_classz00_844;
BgL_classz00_844 = BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00; 
BgL_arg1222z00_843 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_844); } 
BgL_arg1221z00_842 = 
VECTOR_REF(BgL_arg1222z00_843,((long)0)); } 
BgL_auxz00_1277 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1221z00_842)); } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1123z00_839))->BgL_z42builtinz42)=((mpg123_handle *)BgL_auxz00_1277),BUNSPEC); } 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1123z00_839))->BgL_decoderz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_new1123z00_839))->BgL_siza7eza7)=((long)((long)0)),BUNSPEC); 
{ /* Llib/mpg123_decoder.scm 23 */
obj_t BgL_fun1223z00_845;
BgL_fun1223z00_845 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpg123zd2handlezd2zz__mpg123_mpg123z00); 
PROCEDURE_ENTRY(BgL_fun1223z00_845)(BgL_fun1223z00_845, 
((obj_t)BgL_new1123z00_839), BEOA); } 
BgL_auxz00_1272 = BgL_new1123z00_839; } 
return 
((obj_t)BgL_auxz00_1272);} } 

}



/* &lambda1219 */
obj_t BGl_z62lambda1219z62zz__mpg123_decoderz00(obj_t BgL_envz00_721, obj_t BgL_oz00_722, obj_t BgL_vz00_723)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_722)))->BgL_z52mpg123z52)=((obj_t)BgL_vz00_723),BUNSPEC);} 

}



/* &lambda1218 */
obj_t BGl_z62lambda1218z62zz__mpg123_decoderz00(obj_t BgL_envz00_724, obj_t BgL_oz00_725)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_725)))->BgL_z52mpg123z52);} 

}



/* &<@anonymous:1204> */
obj_t BGl_z62zc3z04anonymousza31204ze3ze5zz__mpg123_decoderz00(obj_t BgL_envz00_726)
{
{ /* Llib/mpg123_decoder.scm 21 */
{ /* Llib/mpg123_decoder.scm 22 */

return 
make_string(((long)5120), ((unsigned char)' '));} } 

}



/* &lambda1203 */
obj_t BGl_z62lambda1203z62zz__mpg123_decoderz00(obj_t BgL_envz00_727, obj_t BgL_oz00_728, obj_t BgL_vz00_729)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_728)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_vz00_729)),BUNSPEC);} 

}



/* &lambda1202 */
obj_t BGl_z62lambda1202z62zz__mpg123_decoderz00(obj_t BgL_envz00_730, obj_t BgL_oz00_731)
{
{ /* Llib/mpg123_decoder.scm 21 */
return 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_oz00_731)))->BgL_outbufz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1948z00zz__mpg123_decoderz00, BGl_string1949z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1950z00zz__mpg123_decoderz00, BGl_string1951z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2closezd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1952z00zz__mpg123_decoderz00, BGl_string1953z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1954z00zz__mpg123_decoderz00, BGl_string1955z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1956z00zz__mpg123_decoderz00, BGl_string1957z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2infozd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1958z00zz__mpg123_decoderz00, BGl_string1959z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2seekzd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1960z00zz__mpg123_decoderz00, BGl_string1961z00zz__mpg123_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1962z00zz__mpg123_decoderz00, BGl_string1963z00zz__mpg123_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00, BGl_proc1964z00zz__mpg123_decoderz00, BGl_string1965z00zz__mpg123_decoderz00);} 

}



/* &musicdecoder-decode-1145 */
obj_t BGl_z62musicdecoderzd2decodezd21145z62zz__mpg123_decoderz00(obj_t BgL_envz00_745, obj_t BgL_decz00_746, obj_t BgL_amz00_747, obj_t BgL_bufferz00_748)
{
{ /* Llib/mpg123_decoder.scm 106 */
{ /* Llib/mpg123_decoder.scm 111 */
bool_t BgL_haszd2beenzd2emptyzd2oncezd2_854;
BgL_haszd2beenzd2emptyzd2oncezd2_854 = ((bool_t)0); 
{ /* Llib/mpg123_decoder.scm 111 */
long BgL_inlenz00_855;
BgL_inlenz00_855 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52inlenz52); 
{ /* Llib/mpg123_decoder.scm 119 */
long BgL_outlenz00_856;
BgL_outlenz00_856 = 
STRING_LENGTH(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00)); 
{ /* Llib/mpg123_decoder.scm 121 */
long BgL_decsza7za7_857;
{ /* Llib/mpg123_decoder.scm 121 */
long BgL_az00_858;
BgL_az00_858 = 
(((long)2)*BgL_outlenz00_856); 
if(
(BgL_az00_858<BgL_inlenz00_855))
{ /* Llib/mpg123_decoder.scm 121 */
BgL_decsza7za7_857 = BgL_az00_858; }  else 
{ /* Llib/mpg123_decoder.scm 121 */
BgL_decsza7za7_857 = BgL_inlenz00_855; } } 
{ 

{ 

{ 

{ 
long BgL_siza7eza7_878;
{ /* Llib/mpg123_decoder.scm 179 */
bool_t BgL_test2073z00_1319;
{ /* Llib/mpg123_decoder.scm 179 */
int BgL_arg1507z00_893;
BgL_arg1507z00_893 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2073z00_1319 = 
(
(long)(BgL_arg1507z00_893)>((long)0)); } 
if(BgL_test2073z00_1319)
{ /* Llib/mpg123_decoder.scm 179 */
BGl_debugzd2initz12zc0zz__mpg123_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00)); }  else 
{ /* Llib/mpg123_decoder.scm 179 */BFALSE; } } 
if(
(
(long)(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52ratez52))>((long)0)))
{ /* Llib/mpg123_decoder.scm 183 */
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)), 
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)); }  else 
{ /* Llib/mpg123_decoder.scm 183 */BFALSE; } 
{ 

BgL_loopz00_894:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52z12dpausez40))
{ /* Llib/mpg123_decoder.scm 188 */
{ /* Llib/mpg123_decoder.scm 190 */
BgL_musicstatusz00_bglt BgL_i1108z00_895;
BgL_i1108z00_895 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1108z00_895))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)15))); 
{ /* Llib/mpg123_decoder.scm 193 */
obj_t BgL_mutex1519z00_896;
BgL_mutex1519z00_896 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1519z00_896); 
{ /* Llib/mpg123_decoder.scm 193 */
bool_t BgL_tmp2076z00_1357;
{ 

BgL_liipz00_897:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52z12dpausez40))
{ /* Llib/mpg123_decoder.scm 195 */
{ /* Llib/mpg123_decoder.scm 196 */
obj_t BgL_arg1524z00_898;obj_t BgL_arg1530z00_899;
BgL_arg1524z00_898 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52dcondvz52); 
BgL_arg1530z00_899 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52dmutexz52); 
{ /* Llib/mpg123_decoder.scm 196 */

BGL_CONDVAR_WAIT(BgL_arg1524z00_898, BgL_arg1530z00_899); } } 
goto BgL_liipz00_897;}  else 
{ /* Llib/mpg123_decoder.scm 195 */
BgL_tmp2076z00_1357 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1519z00_896); BgL_tmp2076z00_1357; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)16))); 
goto BgL_loopz00_894;}  else 
{ /* Llib/mpg123_decoder.scm 188 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52z12dabortz40))
{ /* Llib/mpg123_decoder.scm 200 */
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)17))); }  else 
{ /* Llib/mpg123_decoder.scm 200 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52emptyz52))
{ /* Llib/mpg123_decoder.scm 203 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 205 */
{ /* Llib/mpg123_decoder.scm 207 */
bool_t BgL_test2081z00_1389;
{ /* Llib/mpg123_decoder.scm 207 */
int BgL_arg1562z00_900;
BgL_arg1562z00_900 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2081z00_1389 = 
(
(long)(BgL_arg1562z00_900)>=((long)2)); } 
if(BgL_test2081z00_1389)
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1540z00_901;
BgL_arg1540z00_901 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00); 
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_list1541z00_902;
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1543z00_903;
{ /* Llib/mpg123_decoder.scm 208 */
obj_t BgL_arg1544z00_904;
BgL_arg1544z00_904 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1543z00_903 = 
MAKE_YOUNG_PAIR(BgL_arg1540z00_901, BgL_arg1544z00_904); } 
BgL_list1541z00_902 = 
MAKE_YOUNG_PAIR(BGl_string1974z00zz__mpg123_decoderz00, BgL_arg1543z00_903); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1541z00_902); } }  else 
{ /* Llib/mpg123_decoder.scm 207 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/mpg123_decoder.scm 205 */
{ /* Llib/mpg123_decoder.scm 211 */
bool_t BgL_test2082z00_1403;
{ /* Llib/mpg123_decoder.scm 211 */
int BgL_arg1619z00_905;
BgL_arg1619z00_905 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2082z00_1403 = 
(
(long)(BgL_arg1619z00_905)>=((long)1)); } 
if(BgL_test2082z00_1403)
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1580z00_906;BGL_LONGLONG_T BgL_arg1581z00_907;
BgL_arg1580z00_906 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00); 
BgL_arg1581z00_907 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_list1582z00_908;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1591z00_909;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1593z00_910;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1615z00_911;
{ /* Llib/mpg123_decoder.scm 212 */
obj_t BgL_arg1616z00_912;
BgL_arg1616z00_912 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1615z00_911 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1581z00_907), BgL_arg1616z00_912); } 
BgL_arg1593z00_910 = 
MAKE_YOUNG_PAIR(BGl_string1923z00zz__mpg123_decoderz00, BgL_arg1615z00_911); } 
BgL_arg1591z00_909 = 
MAKE_YOUNG_PAIR(BgL_arg1580z00_906, BgL_arg1593z00_910); } 
BgL_list1582z00_908 = 
MAKE_YOUNG_PAIR(BGl_string1975z00zz__mpg123_decoderz00, BgL_arg1591z00_909); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1582z00_908); } }  else 
{ /* Llib/mpg123_decoder.scm 211 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 215 */
BgL_musicstatusz00_bglt BgL_i1110z00_913;
BgL_i1110z00_913 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1110z00_913))->BgL_bufferingz00)=((int)
(int)(
BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(BgL_inlenz00_855, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)19))); 
{ /* Llib/mpg123_decoder.scm 219 */
obj_t BgL_mutex1620z00_914;
BgL_mutex1620z00_914 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52bmutexz52); 
{ /* Llib/mpg123_decoder.scm 219 */
obj_t BgL_top2084z00_1431;
BgL_top2084z00_1431 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1620z00_914); 
BGL_EXITD_PUSH_PROTECT(BgL_top2084z00_1431, BgL_mutex1620z00_914); BUNSPEC; 
{ /* Llib/mpg123_decoder.scm 219 */
bool_t BgL_tmp2083z00_1430;
{ /* Llib/mpg123_decoder.scm 221 */
bool_t BgL_test2085z00_1435;
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52emptyz52))
{ /* Llib/mpg123_decoder.scm 221 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 221 */
BgL_test2085z00_1435 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 221 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746))))->BgL_z52z12dabortz40))
{ /* Llib/mpg123_decoder.scm 221 */
BgL_test2085z00_1435 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 221 */
BgL_test2085z00_1435 = 
(
(((long)8)*
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))>BgL_inlenz00_855)
; } } }  else 
{ /* Llib/mpg123_decoder.scm 221 */
BgL_test2085z00_1435 = ((bool_t)1)
; } 
if(BgL_test2085z00_1435)
{ /* Llib/mpg123_decoder.scm 221 */
BgL_tmp2083z00_1430 = ((bool_t)0); }  else 
{ /* Llib/mpg123_decoder.scm 225 */
obj_t BgL_arg1626z00_915;obj_t BgL_arg1627z00_916;
BgL_arg1626z00_915 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52bcondvz52); 
BgL_arg1627z00_916 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52bmutexz52); 
{ /* Llib/mpg123_decoder.scm 225 */

BgL_tmp2083z00_1430 = 
BGL_CONDVAR_WAIT(BgL_arg1626z00_915, BgL_arg1627z00_916); } } } 
BGL_EXITD_POP_PROTECT(BgL_top2084z00_1431); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1620z00_914); BgL_tmp2083z00_1430; } } } 
{ /* Llib/mpg123_decoder.scm 226 */
bool_t BgL_test2089z00_1457;
{ /* Llib/mpg123_decoder.scm 226 */
int BgL_arg1643z00_917;
BgL_arg1643z00_917 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2089z00_1457 = 
(
(long)(BgL_arg1643z00_917)>=((long)1)); } 
if(BgL_test2089z00_1457)
{ /* Llib/mpg123_decoder.scm 227 */
BGL_LONGLONG_T BgL_arg1631z00_918;
BgL_arg1631z00_918 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 227 */
obj_t BgL_list1632z00_919;
{ /* Llib/mpg123_decoder.scm 227 */
obj_t BgL_arg1636z00_920;
BgL_arg1636z00_920 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_list1632z00_919 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1631z00_918), BgL_arg1636z00_920); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1632z00_919); } }  else 
{ /* Llib/mpg123_decoder.scm 226 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)16))); 
goto BgL_loopz00_894;} }  else 
{ /* Llib/mpg123_decoder.scm 232 */
long BgL_g1111z00_921;
{ /* Llib/mpg123_decoder.scm 232 */
long BgL_bz00_922;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52)))
{ /* Llib/mpg123_decoder.scm 233 */
BgL_bz00_922 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52)); }  else 
{ /* Llib/mpg123_decoder.scm 233 */
BgL_bz00_922 = 
(BgL_inlenz00_855-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52)); } 
if(
(BgL_decsza7za7_857<BgL_bz00_922))
{ /* Llib/mpg123_decoder.scm 233 */
BgL_g1111z00_921 = BgL_decsza7za7_857; }  else 
{ /* Llib/mpg123_decoder.scm 233 */
BgL_g1111z00_921 = BgL_bz00_922; } } 
{ 
long BgL_sz00_924;
BgL_sz00_924 = BgL_g1111z00_921; 
BgL_flushz00_923:
{ /* Llib/mpg123_decoder.scm 236 */
int BgL_statusz00_925;
{ /* Llib/mpg123_decoder.scm 236 */
obj_t BgL_arg1805z00_926;char * BgL_arg1806z00_927;long BgL_arg1807z00_928;obj_t BgL_arg1809z00_929;
BgL_arg1805z00_926 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52); 
BgL_arg1806z00_927 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52inbufpz52); 
BgL_arg1807z00_928 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52); 
BgL_arg1809z00_929 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00); 
BgL_statusz00_925 = 
bgl_mpg123_decode(BgL_arg1805z00_926, BgL_arg1806z00_927, BgL_arg1807z00_928, BgL_sz00_924, 
BSTRING_TO_STRING(BgL_arg1809z00_929), BgL_outlenz00_856); } 
{ /* Llib/mpg123_decoder.scm 238 */
bool_t BgL_test2092z00_1496;
{ /* Llib/mpg123_decoder.scm 238 */
int BgL_arg1684z00_930;
BgL_arg1684z00_930 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2092z00_1496 = 
(
(long)(BgL_arg1684z00_930)>=((long)4)); } 
if(BgL_test2092z00_1496)
{ /* Llib/mpg123_decoder.scm 239 */
long BgL_arg1647z00_931;long BgL_arg1648z00_932;obj_t BgL_arg1652z00_933;
BgL_arg1647z00_931 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52); 
BgL_arg1648z00_932 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52headz52); 
BgL_arg1652z00_933 = 
BGl_mpg123zd2decodezd2statuszd2ze3symbolz31zz__mpg123_mpg123z00(BgL_statusz00_925); 
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_list1653z00_934;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1656z00_935;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1661z00_936;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1662z00_937;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1671z00_938;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1674z00_939;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1677z00_940;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1678z00_941;
{ /* Llib/mpg123_decoder.scm 239 */
obj_t BgL_arg1681z00_942;
BgL_arg1681z00_942 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1678z00_941 = 
MAKE_YOUNG_PAIR(BgL_arg1652z00_933, BgL_arg1681z00_942); } 
BgL_arg1677z00_940 = 
MAKE_YOUNG_PAIR(BGl_string1976z00zz__mpg123_decoderz00, BgL_arg1678z00_941); } 
BgL_arg1674z00_939 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1648z00_932), BgL_arg1677z00_940); } 
BgL_arg1671z00_938 = 
MAKE_YOUNG_PAIR(BGl_string1977z00zz__mpg123_decoderz00, BgL_arg1674z00_939); } 
BgL_arg1662z00_937 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1647z00_931), BgL_arg1671z00_938); } 
BgL_arg1661z00_936 = 
MAKE_YOUNG_PAIR(BGl_string1978z00zz__mpg123_decoderz00, BgL_arg1662z00_937); } 
BgL_arg1656z00_935 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_924), BgL_arg1661z00_936); } 
BgL_list1653z00_934 = 
MAKE_YOUNG_PAIR(BGl_string1979z00zz__mpg123_decoderz00, BgL_arg1656z00_935); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1653z00_934); } }  else 
{ /* Llib/mpg123_decoder.scm 238 */BFALSE; } } 
if(
(BgL_sz00_924>((long)0)))
{ /* Llib/mpg123_decoder.scm 244 */
BgL_siza7eza7_878 = BgL_sz00_924; 
{ /* Llib/mpg123_decoder.scm 159 */
long BgL_ntailz00_879;
BgL_ntailz00_879 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52)+BgL_siza7eza7_878); 
if(
(BgL_ntailz00_879==BgL_inlenz00_855))
{ /* Llib/mpg123_decoder.scm 160 */
BgL_ntailz00_879 = ((long)0); }  else 
{ /* Llib/mpg123_decoder.scm 160 */BFALSE; } 
if(
(BgL_ntailz00_879==
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52headz52)))
{ /* Llib/mpg123_decoder.scm 163 */
BgL_haszd2beenzd2emptyzd2oncezd2_854 = ((bool_t)1); 
((((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/mpg123_decoder.scm 163 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52)=((long)BgL_ntailz00_879),BUNSPEC); } 
{ /* Llib/mpg123_decoder.scm 142 */
bool_t BgL_test2096z00_1533;
{ /* Llib/mpg123_decoder.scm 142 */
int BgL_arg1878z00_863;
BgL_arg1878z00_863 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2096z00_1533 = 
(
(long)(BgL_arg1878z00_863)>=((long)3)); } 
if(BgL_test2096z00_1533)
{ /* Llib/mpg123_decoder.scm 143 */
long BgL_pz00_864;
BgL_pz00_864 = 
BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(BgL_inlenz00_855, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)); 
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_test2097z00_1539;
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_test2098z00_1540;
{ /* Llib/mpg123_decoder.scm 144 */
bool_t BgL_test2099z00_1541;
if(
(BgL_pz00_864<((long)75)))
{ /* Llib/mpg123_decoder.scm 144 */
BgL_test2099z00_1541 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 144 */
BgL_test2099z00_1541 = BgL_haszd2beenzd2emptyzd2oncezd2_854
; } 
if(BgL_test2099z00_1541)
{ /* Llib/mpg123_decoder.scm 144 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 145 */
BgL_test2098z00_1540 = ((bool_t)0)
; }  else 
{ /* Llib/mpg123_decoder.scm 145 */
BgL_test2098z00_1540 = ((bool_t)1)
; } }  else 
{ /* Llib/mpg123_decoder.scm 144 */
BgL_test2098z00_1540 = ((bool_t)0)
; } } 
if(BgL_test2098z00_1540)
{ /* Llib/mpg123_decoder.scm 144 */
BgL_test2097z00_1539 = ((bool_t)1)
; }  else 
{ /* Llib/mpg123_decoder.scm 146 */
int BgL_arg1877z00_865;
BgL_arg1877z00_865 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2097z00_1539 = 
(
(long)(BgL_arg1877z00_865)>=((long)4)); } } 
if(BgL_test2097z00_1539)
{ /* Llib/mpg123_decoder.scm 149 */
obj_t BgL_arg1861z00_866;obj_t BgL_arg1862z00_867;obj_t BgL_arg1863z00_868;
if(
(BgL_pz00_864>=((long)80)))
{ /* Llib/mpg123_decoder.scm 149 */
BgL_arg1861z00_866 = BGl_string1947z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 149 */
if(
(BgL_pz00_864>((long)25)))
{ /* Llib/mpg123_decoder.scm 150 */
BgL_arg1861z00_866 = BGl_string1966z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 150 */
BgL_arg1861z00_866 = BGl_string1967z00zz__mpg123_decoderz00; } } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 154 */
BgL_arg1862z00_867 = BGl_string1968z00zz__mpg123_decoderz00; }  else 
{ /* Llib/mpg123_decoder.scm 154 */
BgL_arg1862z00_867 = BGl_string1947z00zz__mpg123_decoderz00; } 
BgL_arg1863z00_868 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00); 
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_list1864z00_869;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1865z00_870;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1866z00_871;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1867z00_872;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1868z00_873;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1869z00_874;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1870z00_875;
{ /* Llib/mpg123_decoder.scm 147 */
obj_t BgL_arg1871z00_876;
BgL_arg1871z00_876 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1870z00_875 = 
MAKE_YOUNG_PAIR(BgL_arg1863z00_868, BgL_arg1871z00_876); } 
BgL_arg1869z00_874 = 
MAKE_YOUNG_PAIR(BGl_string1969z00zz__mpg123_decoderz00, BgL_arg1870z00_875); } 
BgL_arg1868z00_873 = 
MAKE_YOUNG_PAIR(BgL_arg1862z00_867, BgL_arg1869z00_874); } 
BgL_arg1867z00_872 = 
MAKE_YOUNG_PAIR(BGl_string1970z00zz__mpg123_decoderz00, BgL_arg1868z00_873); } 
BgL_arg1866z00_871 = 
MAKE_YOUNG_PAIR(
BINT(BgL_pz00_864), BgL_arg1867z00_872); } 
BgL_arg1865z00_870 = 
MAKE_YOUNG_PAIR(BgL_arg1861z00_866, BgL_arg1866z00_871); } 
BgL_list1864z00_869 = 
MAKE_YOUNG_PAIR(BGl_string1971z00zz__mpg123_decoderz00, BgL_arg1865z00_870); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1864z00_869); } }  else 
{ /* Llib/mpg123_decoder.scm 144 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 142 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 170 */
bool_t BgL_test2105z00_1569;
{ /* Llib/mpg123_decoder.scm 170 */
bool_t BgL_test2106z00_1570;
{ /* Llib/mpg123_decoder.scm 137 */
bool_t BgL__ortest_1106z00_861;
BgL__ortest_1106z00_861 = BgL_haszd2beenzd2emptyzd2oncezd2_854; 
if(BgL__ortest_1106z00_861)
{ /* Llib/mpg123_decoder.scm 137 */
BgL_test2106z00_1570 = BgL__ortest_1106z00_861
; }  else 
{ /* Llib/mpg123_decoder.scm 137 */
BgL_test2106z00_1570 = 
(
(((long)4)*
(BgL_inlenz00_855-
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748))))>BgL_inlenz00_855)
; } } 
if(BgL_test2106z00_1570)
{ /* Llib/mpg123_decoder.scm 170 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52eofz52))
{ /* Llib/mpg123_decoder.scm 170 */
BgL_test2105z00_1569 = ((bool_t)0)
; }  else 
{ /* Llib/mpg123_decoder.scm 170 */
BgL_test2105z00_1569 = ((bool_t)1)
; } }  else 
{ /* Llib/mpg123_decoder.scm 170 */
BgL_test2105z00_1569 = ((bool_t)0)
; } } 
if(BgL_test2105z00_1569)
{ /* Llib/mpg123_decoder.scm 170 */
{ /* Llib/mpg123_decoder.scm 171 */
bool_t BgL_test2109z00_1580;
{ /* Llib/mpg123_decoder.scm 171 */
int BgL_arg1841z00_880;
BgL_arg1841z00_880 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2109z00_1580 = 
(
(long)(BgL_arg1841z00_880)>=((long)2)); } 
if(BgL_test2109z00_1580)
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1834z00_881;BGL_LONGLONG_T BgL_arg1835z00_882;
BgL_arg1834z00_881 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00); 
BgL_arg1835z00_882 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_list1836z00_883;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1837z00_884;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1838z00_885;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1839z00_886;
{ /* Llib/mpg123_decoder.scm 172 */
obj_t BgL_arg1840z00_887;
BgL_arg1840z00_887 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1839z00_886 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1835z00_882), BgL_arg1840z00_887); } 
BgL_arg1838z00_885 = 
MAKE_YOUNG_PAIR(BGl_string1923z00zz__mpg123_decoderz00, BgL_arg1839z00_886); } 
BgL_arg1837z00_884 = 
MAKE_YOUNG_PAIR(BgL_arg1834z00_881, BgL_arg1838z00_885); } 
BgL_list1836z00_883 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__mpg123_decoderz00, BgL_arg1837z00_884); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1836z00_883); } }  else 
{ /* Llib/mpg123_decoder.scm 171 */BFALSE; } } 
{ /* Llib/mpg123_decoder.scm 174 */
obj_t BgL_mutex1842z00_888;
BgL_mutex1842z00_888 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1842z00_888); 
{ /* Llib/mpg123_decoder.scm 174 */
bool_t BgL_tmp2110z00_1596;
{ /* Llib/mpg123_decoder.scm 175 */
obj_t BgL_tmpz00_1598;
BgL_tmpz00_1598 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52bcondvz52); 
BgL_tmp2110z00_1596 = 
BGL_CONDVAR_BROADCAST(BgL_tmpz00_1598); } 
BGL_MUTEX_UNLOCK(BgL_mutex1842z00_888); BgL_tmp2110z00_1596; } } 
{ /* Llib/mpg123_decoder.scm 176 */
bool_t BgL_test2111z00_1603;
{ /* Llib/mpg123_decoder.scm 176 */
int BgL_arg1849z00_889;
BgL_arg1849z00_889 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2111z00_1603 = 
(
(long)(BgL_arg1849z00_889)>=((long)2)); } 
if(BgL_test2111z00_1603)
{ /* Llib/mpg123_decoder.scm 177 */
BGL_LONGLONG_T BgL_arg1846z00_890;
BgL_arg1846z00_890 = 
bgl_current_microseconds(); 
{ /* Llib/mpg123_decoder.scm 177 */
obj_t BgL_list1847z00_891;
{ /* Llib/mpg123_decoder.scm 177 */
obj_t BgL_arg1848z00_892;
BgL_arg1848z00_892 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_list1847z00_891 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1846z00_890), BgL_arg1848z00_892); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1847z00_891); } }  else 
{ /* Llib/mpg123_decoder.scm 176 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 170 */BFALSE; } } }  else 
{ /* Llib/mpg123_decoder.scm 244 */BFALSE; } 
if(
(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52z12dseekz40)>((long)0)))
{ /* Llib/mpg123_decoder.scm 248 */
long BgL_offsetz00_943;
{ /* Llib/mpg123_decoder.scm 248 */
obj_t BgL_arg1713z00_944;long BgL_arg1714z00_945;
BgL_arg1713z00_944 = 
BGl_musicbufferzd2streamzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)); 
BgL_arg1714z00_945 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52z12dseekz40); 
BgL_offsetz00_943 = 
BGl_mp3zd2indexzd2zz__multimediazd2mp3zd2(BgL_arg1713z00_944, 
(long)(BgL_arg1714z00_945)); } 
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1698z00_946;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_tmpz00_1622;
BgL_tmpz00_1622 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1698z00_946 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_1622); } 
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_list1699z00_947;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1700z00_948;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1701z00_949;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1703z00_950;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1705z00_951;
{ /* Llib/mpg123_decoder.scm 249 */
obj_t BgL_arg1706z00_952;
BgL_arg1706z00_952 = 
MAKE_YOUNG_PAIR(
make_belong(BgL_offsetz00_943), BNIL); 
BgL_arg1705z00_951 = 
MAKE_YOUNG_PAIR(BGl_string1980z00zz__mpg123_decoderz00, BgL_arg1706z00_952); } 
BgL_arg1703z00_950 = 
MAKE_YOUNG_PAIR(BGl_string1981z00zz__mpg123_decoderz00, BgL_arg1705z00_951); } 
BgL_arg1701z00_949 = 
MAKE_YOUNG_PAIR(
BINT(((long)249)), BgL_arg1703z00_950); } 
BgL_arg1700z00_948 = 
MAKE_YOUNG_PAIR(BGl_string1982z00zz__mpg123_decoderz00, BgL_arg1701z00_949); } 
BgL_list1699z00_947 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__mpg123_decoderz00, BgL_arg1700z00_948); } 
BGl_tprintz00zz__r4_output_6_10_3z00(BgL_arg1698z00_946, BgL_list1699z00_947); } } 
BGl_musicbufferzd2seekzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748), 
make_belong(BgL_offsetz00_943)); 
{ /* Llib/mpg123_decoder.scm 251 */
obj_t BgL_arg1712z00_953;
BgL_arg1712z00_953 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52); 
BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1712z00_953)); } 
{ /* Llib/mpg123_decoder.scm 252 */
BgL_musicstatusz00_bglt BgL_i1112z00_954;
BgL_i1112z00_954 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1112z00_954))->BgL_songposz00)=((obj_t)
BINT(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52z12dseekz40))),BUNSPEC); 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52z12dseekz40)=((long)((long)-1)),BUNSPEC); } 
goto BgL_loopz00_894;}  else 
{ /* Llib/mpg123_decoder.scm 247 */
if(
(
(long)(BgL_statusz00_925)==
(long)(MPG123_OK)))
{ /* Llib/mpg123_decoder.scm 258 */
BgL_mpg123zd2handlezd2_bglt BgL_i1113z00_955;
BgL_i1113z00_955 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52)); 
{ /* Llib/mpg123_decoder.scm 259 */
bool_t BgL_test2114z00_1657;
{ /* Llib/mpg123_decoder.scm 259 */
int BgL_arg1737z00_956;
BgL_arg1737z00_956 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2114z00_1657 = 
(
(long)(BgL_arg1737z00_956)>=((long)5)); } 
if(BgL_test2114z00_1657)
{ /* Llib/mpg123_decoder.scm 260 */
long BgL_arg1719z00_957;
BgL_arg1719z00_957 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1113z00_955))->BgL_siza7eza7); 
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_list1720z00_958;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1726z00_959;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1727z00_960;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1730z00_961;
{ /* Llib/mpg123_decoder.scm 260 */
obj_t BgL_arg1734z00_962;
BgL_arg1734z00_962 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1730z00_961 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1719z00_957), BgL_arg1734z00_962); } 
BgL_arg1727z00_960 = 
MAKE_YOUNG_PAIR(BGl_string1983z00zz__mpg123_decoderz00, BgL_arg1730z00_961); } 
BgL_arg1726z00_959 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_924), BgL_arg1727z00_960); } 
BgL_list1720z00_958 = 
MAKE_YOUNG_PAIR(BGl_string1984z00zz__mpg123_decoderz00, BgL_arg1726z00_959); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1720z00_958); } }  else 
{ /* Llib/mpg123_decoder.scm 259 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1113z00_955))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 262 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_747), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1113z00_955))->BgL_siza7eza7)); 
{ 
long BgL_sz00_1678;
BgL_sz00_1678 = ((long)0); 
BgL_sz00_924 = BgL_sz00_1678; 
goto BgL_flushz00_923;} }  else 
{ /* Llib/mpg123_decoder.scm 262 */BFALSE; } }  else 
{ /* Llib/mpg123_decoder.scm 256 */
if(
(
(long)(BgL_statusz00_925)==
(long)(MPG123_NEED_MORE)))
{ /* Llib/mpg123_decoder.scm 266 */
{ /* Llib/mpg123_decoder.scm 268 */
BgL_mpg123zd2handlezd2_bglt BgL_i1114z00_963;
BgL_i1114z00_963 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52)); 
{ /* Llib/mpg123_decoder.scm 269 */
bool_t BgL_test2117z00_1686;
{ /* Llib/mpg123_decoder.scm 269 */
int BgL_arg1785z00_964;
BgL_arg1785z00_964 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2117z00_1686 = 
(
(long)(BgL_arg1785z00_964)>=((long)5)); } 
if(BgL_test2117z00_1686)
{ /* Llib/mpg123_decoder.scm 270 */
long BgL_arg1772z00_965;bool_t BgL_arg1773z00_966;long BgL_arg1775z00_967;
BgL_arg1772z00_965 = 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_963))->BgL_siza7eza7); 
BgL_arg1773z00_966 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52emptyz52); 
BgL_arg1775z00_967 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_z52tailz52); 
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_list1776z00_968;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1777z00_969;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1778z00_970;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1779z00_971;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1780z00_972;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1781z00_973;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1782z00_974;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1783z00_975;
{ /* Llib/mpg123_decoder.scm 270 */
obj_t BgL_arg1784z00_976;
BgL_arg1784z00_976 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1783z00_975 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1775z00_967), BgL_arg1784z00_976); } 
BgL_arg1782z00_974 = 
MAKE_YOUNG_PAIR(BGl_string1985z00zz__mpg123_decoderz00, BgL_arg1783z00_975); } 
BgL_arg1781z00_973 = 
MAKE_YOUNG_PAIR(
BBOOL(BgL_arg1773z00_966), BgL_arg1782z00_974); } 
BgL_arg1780z00_972 = 
MAKE_YOUNG_PAIR(BGl_string1986z00zz__mpg123_decoderz00, BgL_arg1781z00_973); } 
BgL_arg1779z00_971 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1772z00_965), BgL_arg1780z00_972); } 
BgL_arg1778z00_970 = 
MAKE_YOUNG_PAIR(BGl_string1983z00zz__mpg123_decoderz00, BgL_arg1779z00_971); } 
BgL_arg1777z00_969 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_924), BgL_arg1778z00_970); } 
BgL_list1776z00_968 = 
MAKE_YOUNG_PAIR(BGl_string1987z00zz__mpg123_decoderz00, BgL_arg1777z00_969); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1776z00_968); } }  else 
{ /* Llib/mpg123_decoder.scm 269 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_963))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 273 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_747), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1114z00_963))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 273 */BFALSE; } } 
goto BgL_loopz00_894;}  else 
{ /* Llib/mpg123_decoder.scm 266 */
if(
(
(long)(BgL_statusz00_925)==
(long)(MPG123_NEW_FORMAT)))
{ /* Llib/mpg123_decoder.scm 277 */
BGl_newzd2formatzd2zz__mpg123_decoderz00(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746), 
((BgL_musicbufz00_bglt)BgL_amz00_747), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)); 
{ /* Llib/mpg123_decoder.scm 280 */
BgL_mpg123zd2handlezd2_bglt BgL_i1115z00_977;
BgL_i1115z00_977 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52)); 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1115z00_977))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 281 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_747), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1115z00_977))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 281 */BFALSE; } } 
{ 
long BgL_sz00_1736;
BgL_sz00_1736 = ((long)0); 
BgL_sz00_924 = BgL_sz00_1736; 
goto BgL_flushz00_923;} }  else 
{ /* Llib/mpg123_decoder.scm 277 */
if(
(
(long)(BgL_statusz00_925)==
(long)(MPG123_DONE)))
{ /* Llib/mpg123_decoder.scm 285 */
{ /* Llib/mpg123_decoder.scm 287 */
BgL_mpg123zd2handlezd2_bglt BgL_i1116z00_978;
BgL_i1116z00_978 = 
((BgL_mpg123zd2handlezd2_bglt)
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_z52mpg123z52)); 
if(
(
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1116z00_978))->BgL_siza7eza7)>((long)0)))
{ /* Llib/mpg123_decoder.scm 288 */
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_747), 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_746)))->BgL_outbufz00), 
(((BgL_mpg123zd2handlezd2_bglt)COBJECT(BgL_i1116z00_978))->BgL_siza7eza7)); }  else 
{ /* Llib/mpg123_decoder.scm 288 */BFALSE; } } 
BGl_musicbufzd2drainzd2zz__multimediazd2musicbufzd2(
((BgL_musicbufz00_bglt)BgL_amz00_747)); 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/mpg123_decoder.scm 285 */
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_747)), BGl_string1988z00zz__mpg123_decoderz00); } } } } } } } } } } } 
{ /* Llib/mpg123_decoder.scm 297 */
bool_t BgL_test2123z00_1761;
{ /* Llib/mpg123_decoder.scm 297 */
int BgL_arg1822z00_979;
BgL_arg1822z00_979 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2123z00_1761 = 
(
(long)(BgL_arg1822z00_979)>((long)0)); } 
if(BgL_test2123z00_1761)
{ /* Llib/mpg123_decoder.scm 297 */
return 
BGl_debugzd2stopz12zc0zz__mpg123_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_748)))->BgL_urlz00));}  else 
{ /* Llib/mpg123_decoder.scm 297 */
return BFALSE;} } } } } } } } } } } 

}



/* buffer-percentage-filled~0 */
long BGl_bufferzd2percentagezd2filledze70ze7zz__mpg123_decoderz00(long BgL_inlenz00_792, BgL_musicbufferz00_bglt BgL_bufferz00_791)
{
{ /* Llib/mpg123_decoder.scm 129 */
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1887z00_524;
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1888z00_525;BGL_LONGLONG_T BgL_arg1889z00_526;
{ /* Llib/mpg123_decoder.scm 128 */
BGL_LONGLONG_T BgL_arg1890z00_527;
{ /* Llib/mpg123_decoder.scm 128 */
long BgL_tmpz00_1768;
BgL_tmpz00_1768 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_791); 
BgL_arg1890z00_527 = 
LONG_TO_LLONG(BgL_tmpz00_1768); } 
BgL_arg1888z00_525 = 
(((BGL_LONGLONG_T)100)*BgL_arg1890z00_527); } 
BgL_arg1889z00_526 = 
LONG_TO_LLONG(BgL_inlenz00_792); 
BgL_arg1887z00_524 = 
(BgL_arg1888z00_525/BgL_arg1889z00_526); } 
return 
LLONG_TO_LONG(BgL_arg1887z00_524);} } 

}



/* &musicdecoder-volume-1143 */
obj_t BGl_z62musicdecoderzd2volumezd21143z62zz__mpg123_decoderz00(obj_t BgL_envz00_749, obj_t BgL_decz00_750, obj_t BgL_volz00_751)
{
{ /* Llib/mpg123_decoder.scm 99 */
{ /* Llib/mpg123_decoder.scm 101 */
obj_t BgL_arg1390z00_981;
BgL_arg1390z00_981 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_750)))->BgL_z52mpg123z52); 
return 
BGl_mpg123zd2volumezd2setz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1390z00_981), BgL_volz00_751);} } 

}



/* &musicdecoder-seek-mp1141 */
obj_t BGl_z62musicdecoderzd2seekzd2mp1141z62zz__mpg123_decoderz00(obj_t BgL_envz00_752, obj_t BgL_decz00_753, obj_t BgL_secz00_754)
{
{ /* Llib/mpg123_decoder.scm 89 */
{ /* Llib/mpg123_decoder.scm 91 */
bool_t BgL_test2124z00_1779;
{ /* Llib/mpg123_decoder.scm 91 */
int BgL_arg1346z00_983;
BgL_arg1346z00_983 = 
BGl_mpg123zd2debugzd2zz__mpg123_decoderz00(); 
BgL_test2124z00_1779 = 
(
(long)(BgL_arg1346z00_983)>=((long)2)); } 
if(BgL_test2124z00_1779)
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_list1341z00_984;
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_arg1344z00_985;
{ /* Llib/mpg123_decoder.scm 92 */
obj_t BgL_arg1345z00_986;
BgL_arg1345z00_986 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__mpg123_decoderz00, BNIL); 
BgL_arg1344z00_985 = 
MAKE_YOUNG_PAIR(BgL_secz00_754, BgL_arg1345z00_986); } 
BgL_list1341z00_984 = 
MAKE_YOUNG_PAIR(BGl_string1989z00zz__mpg123_decoderz00, BgL_arg1344z00_985); } 
BGl_debugz00zz__mpg123_decoderz00(BgL_list1341z00_984); }  else 
{ /* Llib/mpg123_decoder.scm 91 */BFALSE; } } 
if(
(
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_753)))->BgL_z52z12dseekz40)<((long)0)))
{ /* Llib/mpg123_decoder.scm 93 */
return 
((((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_753)))->BgL_z52z12dseekz40)=((long)
(long)CINT(BgL_secz00_754)),BUNSPEC);}  else 
{ /* Llib/mpg123_decoder.scm 93 */
return BFALSE;} } 

}



/* &musicdecoder-info-mp1139 */
obj_t BGl_z62musicdecoderzd2infozd2mp1139z62zz__mpg123_decoderz00(obj_t BgL_envz00_755, obj_t BgL_decz00_756)
{
{ /* Llib/mpg123_decoder.scm 82 */
{ /* Llib/mpg123_decoder.scm 83 */
long BgL_tmpz00_1794;
{ /* Llib/mpg123_decoder.scm 84 */
obj_t BgL_arg1338z00_988;
BgL_arg1338z00_988 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_756)))->BgL_z52mpg123z52); 
BgL_tmpz00_1794 = 
BGl_mpg123zd2infozd2zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1338z00_988)); } 
return 
BINT(BgL_tmpz00_1794);} } 

}



/* &musicdecoder-positio1137 */
obj_t BGl_z62musicdecoderzd2positio1137zb0zz__mpg123_decoderz00(obj_t BgL_envz00_757, obj_t BgL_decz00_758, obj_t BgL_bz00_759)
{
{ /* Llib/mpg123_decoder.scm 75 */
{ /* Llib/mpg123_decoder.scm 76 */
long BgL_tmpz00_1800;
{ /* Llib/mpg123_decoder.scm 77 */
long BgL_arg1333z00_990;
{ /* Llib/mpg123_decoder.scm 77 */
obj_t BgL_arg1334z00_991;
BgL_arg1334z00_991 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_758)))->BgL_z52mpg123z52); 
BgL_arg1333z00_990 = 
BGl_mpg123zd2positionzd2zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1334z00_991)); } 
BgL_tmpz00_1800 = 
(BgL_arg1333z00_990/((long)1000)); } 
return 
BINT(BgL_tmpz00_1800);} } 

}



/* &musicdecoder-reset!-1135 */
obj_t BGl_z62musicdecoderzd2resetz12zd21135z70zz__mpg123_decoderz00(obj_t BgL_envz00_760, obj_t BgL_decz00_761)
{
{ /* Llib/mpg123_decoder.scm 67 */
{ 

{ /* Llib/mpg123_decoder.scm 69 */
obj_t BgL_arg1330z00_995;
BgL_arg1330z00_995 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_761)))->BgL_z52mpg123z52); 
BGl_mpg123zd2handlezd2resetz12z12zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1330z00_995)); } 
{ /* Llib/mpg123_decoder.scm 67 */
obj_t BgL_nextzd2method1134zd2_994;
BgL_nextzd2method1134zd2_994 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_761)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_mpg123zd2decoderzd2zz__mpg123_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1134zd2_994)(BgL_nextzd2method1134zd2_994, 
((obj_t)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_761)), BEOA);} } } 

}



/* &musicdecoder-close-m1133 */
obj_t BGl_z62musicdecoderzd2closezd2m1133z62zz__mpg123_decoderz00(obj_t BgL_envz00_762, obj_t BgL_decz00_763)
{
{ /* Llib/mpg123_decoder.scm 60 */
{ /* Llib/mpg123_decoder.scm 62 */
obj_t BgL_arg1324z00_997;
BgL_arg1324z00_997 = 
(((BgL_mpg123zd2decoderzd2_bglt)COBJECT(
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_763)))->BgL_z52mpg123z52); 
return 
BGl_mpg123zd2handlezd2closez00zz__mpg123_mpg123z00(
((BgL_mpg123zd2handlezd2_bglt)BgL_arg1324z00_997));} } 

}



/* &musicdecoder-init-mp1131 */
obj_t BGl_z62musicdecoderzd2initzd2mp1131z62zz__mpg123_decoderz00(obj_t BgL_envz00_764, obj_t BgL_decz00_765)
{
{ /* Llib/mpg123_decoder.scm 52 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_765))))->BgL_mimetypesz00)))
{ /* Llib/mpg123_decoder.scm 54 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_mpg123zd2decoderzd2_bglt)BgL_decz00_765))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)20))),BUNSPEC);}  else 
{ /* Llib/mpg123_decoder.scm 54 */
return BFALSE;} } 

}



/* &object-print-mpg123-1129 */
obj_t BGl_z62objectzd2printzd2mpg123zd21129zb0zz__mpg123_decoderz00(obj_t BgL_envz00_766, obj_t BgL_oz00_767, obj_t BgL_portz00_768, obj_t BgL_printzd2slotzd2_769)
{
{ /* Llib/mpg123_decoder.scm 46 */
{ /* Llib/mpg123_decoder.scm 47 */
obj_t BgL_tmpz00_1833;
BgL_tmpz00_1833 = 
((obj_t)BgL_portz00_768); 
return 
bgl_display_string(BGl_string1990z00zz__mpg123_decoderz00, BgL_tmpz00_1833);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mpg123_decoderz00()
{
{ /* Llib/mpg123_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__mpg123_mpg123z00(((long)388603996), 
BSTRING_TO_STRING(BGl_string1991z00zz__mpg123_decoderz00));} 

}

#ifdef __cplusplus
}
#endif
