/*===========================================================================*/
/*   (Llib/pthread.scm)                                                      */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/pthread.scm -o objs/objs_u/pthread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <bglpthread.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_pthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
} *BgL_pthreadz00_bglt;

typedef struct BgL_z62threadzd2errorzb0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62threadzd2errorzb0_bglt;

typedef struct BgL_uncaughtzd2exceptionzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_reasonz00;
} *BgL_uncaughtzd2exceptionzd2_bglt;

typedef struct BgL_terminatedzd2threadzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_terminatedzd2threadzd2exceptionz00_bglt;


extern void * bglpth_thread_new(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__pth_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
extern obj_t BGl_pthreadzd2setupzd2backendz12z12zz__pth_backendz00();
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
extern bool_t bglpth_thread_terminate(void *);
static obj_t BGl_zc3z04exitza31546ze3ze70z60zz__pth_threadz00(BgL_pthreadz00_bglt);
static obj_t BGl_toplevelzd2initzd2zz__pth_threadz00();
BGL_EXPORTED_DECL void * BGl_z42pthreadzd2nilz90zz__pth_threadz00();
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62threadzd2terminatez12zd2pt1147z70zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectzd2displayzd2zz__objectz00(BgL_objectz00_bglt, obj_t);
static obj_t BGl_genericzd2initzd2zz__pth_threadz00();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31222ze3ze5zz__pth_threadz00(obj_t);
static obj_t BGl_z62threadzd2specificzd2pthr1149z62zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__pth_threadz00();
BGL_IMPORT obj_t BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(bool_t);
BGL_EXPORTED_DEF obj_t BGl_pthreadz00zz__pth_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_z62exceptionz62zz__objectz00;
static obj_t BGl_z62zc3z04anonymousza31321ze3ze5zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2joinz12zd2pthread1145z70zz__pth_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__pth_threadz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31209ze3ze5zz__pth_threadz00(obj_t);
BGL_IMPORT obj_t BGl_objectzd2printzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__pth_threadz00();
BGL_IMPORT obj_t BGl_objectzd2writezd2zz__objectz00(BgL_objectz00_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62threadzd2errorzb0zz__pth_threadz00 = BUNSPEC;
BGL_IMPORT obj_t bgl_typeof(obj_t);
extern void bglpth_thread_start(void *, obj_t, bool_t);
static obj_t BGl_z62zc3z04anonymousza31253ze3ze5zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62objectzd2printzd2uncaugh1135z62zz__pth_threadz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31513ze3ze5zz__pth_threadz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_uncaughtzd2exceptionzd2zz__pth_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_signalz00zz__osz00(int, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1207z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62lambda1208z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62threadzd2initializa7ez12zd2p1139zd7zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda1220z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62lambda1221z62zz__pth_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
extern int sched_yield();
static obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__pth_threadz00(obj_t, obj_t);
static BgL_uncaughtzd2exceptionzd2_bglt BGl_z62lambda1319z62zz__pth_threadz00(obj_t);
static obj_t BGl_z62lambda1239z62zz__pth_threadz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__pth_backendz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__libraryz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static obj_t BGl_z62z42pthreadzd2nilzf2zz__pth_threadz00(obj_t);
static obj_t BGl_z62lambda1240z62zz__pth_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
static BgL_z62threadzd2errorzb0_bglt BGl_z62lambda1248z62zz__pth_threadz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pthreadz00_bglt BGl_z62lambda1169z62zz__pth_threadz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_z62threadzd2errorzb0_bglt BGl_z62lambda1250z62zz__pth_threadz00(obj_t);
static obj_t BGl_z62lambda1331z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62lambda1332z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static BgL_pthreadz00_bglt BGl_z62lambda1173z62zz__pth_threadz00(obj_t);
extern void bglpth_thread_join(void *, obj_t);
static BgL_terminatedzd2threadzd2exceptionz00_bglt BGl_z62lambda1342z62zz__pth_threadz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1181z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62lambda1182z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static BgL_terminatedzd2threadzd2exceptionz00_bglt BGl_z62lambda1345z62zz__pth_threadz00(obj_t);
static obj_t BGl_z62lambda1187z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__pth_threadz00();
static obj_t BGl_z62lambda1188z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__pth_threadz00();
BGL_IMPORT bool_t BGl_bigloozd2initializa7edzf3z86zz__paramz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__pth_threadz00();
static obj_t BGl_gczd2rootszd2initz00zz__pth_threadz00();
static obj_t BGl_z62zc3z04anonymousza31545ze3ze5zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2startz12zd2pthrea1141z70zz__pth_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31189ze3ze5zz__pth_threadz00(obj_t);
static obj_t BGl_z62objectzd2writezd2uncaugh1131z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62threadzd2specificzd2setz121151z70zz__pth_threadz00(obj_t, obj_t, obj_t);
static BgL_uncaughtzd2exceptionzd2_bglt BGl_z62lambda1281z62zz__pth_threadz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31563ze3ze5zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62threadzd2cleanupzd2setz12zd21155za2zz__pth_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31565ze3ze5zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31543ze3ze70z60zz__pth_threadz00(obj_t, BgL_pthreadz00_bglt);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62bz62zz__pth_threadz00(obj_t);
static obj_t BGl_z62threadzd2cleanupzd2pthre1153z62zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62objectzd2displayzd2uncau1133z62zz__pth_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31567ze3ze5zz__pth_threadz00(obj_t);
static obj_t BGl_z62z52userzd2threadzd2yieldz12zd21137zf0zz__pth_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2startzd2joinabl1143z62zz__pth_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
static obj_t __cnst[ 18 ] ;


BGL_IMPORT obj_t BGl_threadzd2cleanupzd2envz00zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2startz12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
BGL_IMPORT obj_t BGl_threadzd2joinz12zd2envz12zz__threadz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1721z00zz__pth_threadz00, BgL_bgl_za762lambda1182za7621786z00, BGl_z62lambda1182z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1722z00zz__pth_threadz00, BgL_bgl_za762lambda1181za7621787z00, BGl_z62lambda1181z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1723z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1788za7, BGl_z62zc3z04anonymousza31189ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1724z00zz__pth_threadz00, BgL_bgl_za762lambda1188za7621789z00, BGl_z62lambda1188z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1725z00zz__pth_threadz00, BgL_bgl_za762lambda1187za7621790z00, BGl_z62lambda1187z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1726z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1791za7, BGl_z62zc3z04anonymousza31209ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1727z00zz__pth_threadz00, BgL_bgl_za762lambda1208za7621792z00, BGl_z62lambda1208z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1728z00zz__pth_threadz00, BgL_bgl_za762lambda1207za7621793z00, BGl_z62lambda1207z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1729z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1794za7, BGl_z62zc3z04anonymousza31222ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1730z00zz__pth_threadz00, BgL_bgl_za762lambda1221za7621795z00, BGl_z62lambda1221z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1731z00zz__pth_threadz00, BgL_bgl_za762lambda1220za7621796z00, BGl_z62lambda1220z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1732z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1797za7, BGl_z62zc3z04anonymousza31241ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1733z00zz__pth_threadz00, BgL_bgl_za762lambda1240za7621798z00, BGl_z62lambda1240z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1734z00zz__pth_threadz00, BgL_bgl_za762lambda1239za7621799z00, BGl_z62lambda1239z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1735z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1800za7, BGl_z62zc3z04anonymousza31176ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1736z00zz__pth_threadz00, BgL_bgl_za762lambda1173za7621801z00, BGl_z62lambda1173z62zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1737z00zz__pth_threadz00, BgL_bgl_za762lambda1169za7621802z00, BGl_z62lambda1169z62zz__pth_threadz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1738z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1803za7, BGl_z62zc3z04anonymousza31253ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1739z00zz__pth_threadz00, BgL_bgl_za762lambda1250za7621804z00, BGl_z62lambda1250z62zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1740z00zz__pth_threadz00, BgL_bgl_za762lambda1248za7621805z00, BGl_z62lambda1248z62zz__pth_threadz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1741z00zz__pth_threadz00, BgL_bgl_za762lambda1332za7621806z00, BGl_z62lambda1332z62zz__pth_threadz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_threadzd2specificzd2envz00zz__threadz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1742z00zz__pth_threadz00, BgL_bgl_za762lambda1331za7621807z00, BGl_z62lambda1331z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1743z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1808za7, BGl_z62zc3z04anonymousza31321ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1750z00zz__pth_threadz00, BgL_bgl_string1750za700za7za7_1809za7, "object-write", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1744z00zz__pth_threadz00, BgL_bgl_za762lambda1319za7621810z00, BGl_z62lambda1319z62zz__pth_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1745z00zz__pth_threadz00, BgL_bgl_za762lambda1281za7621811z00, BGl_z62lambda1281z62zz__pth_threadz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string1752z00zz__pth_threadz00, BgL_bgl_string1752za700za7za7_1812za7, "object-display", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1746z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1813za7, BGl_z62zc3z04anonymousza31347ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1747z00zz__pth_threadz00, BgL_bgl_za762lambda1345za7621814z00, BGl_z62lambda1345z62zz__pth_threadz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STRING( BGl_string1754z00zz__pth_threadz00, BgL_bgl_string1754za700za7za7_1815za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1748z00zz__pth_threadz00, BgL_bgl_za762lambda1342za7621816z00, BGl_z62lambda1342z62zz__pth_threadz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1749z00zz__pth_threadz00, BgL_bgl_za762objectza7d2writ1817z00, va_generic_entry, BGl_z62objectzd2writezd2uncaugh1131z62zz__pth_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1756z00zz__pth_threadz00, BgL_bgl_string1756za700za7za7_1818za7, "%user-thread-yield!", 19 );
DEFINE_STRING( BGl_string1758z00zz__pth_threadz00, BgL_bgl_string1758za700za7za7_1819za7, "thread-initialize!", 18 );
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_threadzd2startzd2joinablez12zd2envzc0zz__threadz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1751z00zz__pth_threadz00, BgL_bgl_za762objectza7d2disp1820z00, va_generic_entry, BGl_z62objectzd2displayzd2uncau1133z62zz__pth_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1753z00zz__pth_threadz00, BgL_bgl_za762objectza7d2prin1821z00, BGl_z62objectzd2printzd2uncaugh1135z62zz__pth_threadz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1760z00zz__pth_threadz00, BgL_bgl_string1760za700za7za7_1822za7, "thread-start!", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1755z00zz__pth_threadz00, BgL_bgl_za762za752userza7d2thr1823za7, BGl_z62z52userzd2threadzd2yieldz12zd21137zf0zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1762z00zz__pth_threadz00, BgL_bgl_string1762za700za7za7_1824za7, "thread-start-joinable!", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1757z00zz__pth_threadz00, BgL_bgl_za762threadza7d2init1825z00, BGl_z62threadzd2initializa7ez12zd2p1139zd7zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1764z00zz__pth_threadz00, BgL_bgl_string1764za700za7za7_1826za7, "thread-join!", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1759z00zz__pth_threadz00, BgL_bgl_za762threadza7d2star1827z00, va_generic_entry, BGl_z62threadzd2startz12zd2pthrea1141z70zz__pth_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1766z00zz__pth_threadz00, BgL_bgl_string1766za700za7za7_1828za7, "thread-terminate!", 17 );
DEFINE_STRING( BGl_string1768z00zz__pth_threadz00, BgL_bgl_string1768za700za7za7_1829za7, "thread-specific", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1761z00zz__pth_threadz00, BgL_bgl_za762threadza7d2star1830z00, BGl_z62threadzd2startzd2joinabl1143z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1763z00zz__pth_threadz00, BgL_bgl_za762threadza7d2join1831z00, va_generic_entry, BGl_z62threadzd2joinz12zd2pthread1145z70zz__pth_threadz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1770z00zz__pth_threadz00, BgL_bgl_string1770za700za7za7_1832za7, "thread-specific-set!", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1765z00zz__pth_threadz00, BgL_bgl_za762threadza7d2term1833z00, BGl_z62threadzd2terminatez12zd2pt1147z70zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1772z00zz__pth_threadz00, BgL_bgl_string1772za700za7za7_1834za7, "thread-cleanup", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1767z00zz__pth_threadz00, BgL_bgl_za762threadza7d2spec1835z00, BGl_z62threadzd2specificzd2pthr1149z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1774z00zz__pth_threadz00, BgL_bgl_string1774za700za7za7_1836za7, "thread-cleanup-set!", 19 );
DEFINE_STRING( BGl_string1775z00zz__pth_threadz00, BgL_bgl_string1775za700za7za7_1837za7, "Illegal procedure arity", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1769z00zz__pth_threadz00, BgL_bgl_za762threadza7d2spec1838z00, BGl_z62threadzd2specificzd2setz121151z70zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1776z00zz__pth_threadz00, BgL_bgl_string1776za700za7za7_1839za7, "detached thread", 15 );
DEFINE_STRING( BGl_string1777z00zz__pth_threadz00, BgL_bgl_string1777za700za7za7_1840za7, "Thread created before module initialization completed -- ", 57 );
DEFINE_STRING( BGl_string1778z00zz__pth_threadz00, BgL_bgl_string1778za700za7za7_1841za7, "make-thread", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1771z00zz__pth_threadz00, BgL_bgl_za762threadza7d2clea1842z00, BGl_z62threadzd2cleanupzd2pthre1153z62zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1773z00zz__pth_threadz00, BgL_bgl_za762threadza7d2clea1843z00, BGl_z62threadzd2cleanupzd2setz12zd21155za2zz__pth_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1780z00zz__pth_threadz00, BgL_bgl_string1780za700za7za7_1844za7, "unwind-until!, ~a", 17 );
DEFINE_STRING( BGl_string1781z00zz__pth_threadz00, BgL_bgl_string1781za700za7za7_1845za7, "exit out of thread dynamic scope", 32 );
DEFINE_STRING( BGl_string1782z00zz__pth_threadz00, BgL_bgl_string1782za700za7za7_1846za7, "__pth_thread", 12 );
DEFINE_STRING( BGl_string1783z00zz__pth_threadz00, BgL_bgl_string1783za700za7za7_1847za7, "&pthread- & thread-join! terminated-thread-exception uncaught-exception reason &thread-error __pth_thread pthread $pthread $builtin end-exception obj end-result bool detachedp procedure body ", 191 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1779z00zz__pth_threadz00, BgL_bgl_za762za7c3za704anonymo1848za7, BGl_z62zc3z04anonymousza31565ze3ze5zz__pth_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z42pthreadzd2nilzd2envz42zz__pth_threadz00, BgL_bgl_za762za742pthreadza7d21849za7, BGl_z62z42pthreadzd2nilzf2zz__pth_threadz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_threadzd2initializa7ez12zd2envzb5zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2terminatez12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__pth_threadz00) );
ADD_ROOT( (void *)(&BGl_pthreadz00zz__pth_threadz00) );
ADD_ROOT( (void *)(&BGl_z62threadzd2errorzb0zz__pth_threadz00) );
ADD_ROOT( (void *)(&BGl_uncaughtzd2exceptionzd2zz__pth_threadz00) );
ADD_ROOT( (void *)(&BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long BgL_checksumz00_834, char * BgL_fromz00_835)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__pth_threadz00))
{ 
BGl_requirezd2initializa7ationz75zz__pth_threadz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__pth_threadz00(); 
BGl_libraryzd2moduleszd2initz00zz__pth_threadz00(); 
BGl_cnstzd2initzd2zz__pth_threadz00(); 
BGl_importedzd2moduleszd2initz00zz__pth_threadz00(); 
BGl_objectzd2initzd2zz__pth_threadz00(); 
BGl_methodzd2initzd2zz__pth_threadz00(); 
return 
BGl_toplevelzd2initzd2zz__pth_threadz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__libraryz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__pth_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__pth_thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
{ /* Llib/pthread.scm 15 */
obj_t BgL_cportz00_707;
{ /* Llib/pthread.scm 15 */
obj_t BgL_stringz00_715;
BgL_stringz00_715 = BGl_string1783z00zz__pth_threadz00; 
{ /* Llib/pthread.scm 15 */
obj_t BgL_startz00_716;
BgL_startz00_716 = 
BINT(((long)0)); 
{ /* Llib/pthread.scm 15 */
obj_t BgL_endz00_717;
BgL_endz00_717 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_715))); 
{ /* Llib/pthread.scm 15 */

BgL_cportz00_707 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_715, BgL_startz00_716, BgL_endz00_717); } } } } 
{ 
long BgL_iz00_708;
BgL_iz00_708 = ((long)17); 
BgL_loopz00_709:
if(
(BgL_iz00_708==((long)-1)))
{ /* Llib/pthread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/pthread.scm 15 */
{ /* Llib/pthread.scm 15 */
obj_t BgL_arg1785z00_711;
{ /* Llib/pthread.scm 15 */

{ /* Llib/pthread.scm 15 */
obj_t BgL_locationz00_713;
BgL_locationz00_713 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pthread.scm 15 */

BgL_arg1785z00_711 = 
BGl_readz00zz__readerz00(BgL_cportz00_707, BgL_locationz00_713); } } } 
{ /* Llib/pthread.scm 15 */
int BgL_tmpz00_870;
BgL_tmpz00_870 = 
(int)(BgL_iz00_708); 
CNST_TABLE_SET(BgL_tmpz00_870, BgL_arg1785z00_711); } } 
{ /* Llib/pthread.scm 15 */
int BgL_auxz00_714;
BgL_auxz00_714 = 
(int)(
(BgL_iz00_708-((long)1))); 
{ 
long BgL_iz00_875;
BgL_iz00_875 = 
(long)(BgL_auxz00_714); 
BgL_iz00_708 = BgL_iz00_875; 
goto BgL_loopz00_709;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(((bool_t)1)); 
return 
BGl_pthreadzd2setupzd2backendz12z12zz__pth_backendz00();} 

}



/* $pthread-nil */
BGL_EXPORTED_DEF void * BGl_z42pthreadzd2nilz90zz__pth_threadz00()
{
{ /* Llib/pthread.scm 205 */
return 
(0L);} 

}



/* &$pthread-nil */
obj_t BGl_z62z42pthreadzd2nilzf2zz__pth_threadz00(obj_t BgL_envz00_495)
{
{ /* Llib/pthread.scm 205 */
return 
void_star_to_obj(
BGl_z42pthreadzd2nilz90zz__pth_threadz00());} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1165z00_35;obj_t BgL_arg1168z00_36;
{ /* Llib/pthread.scm 25 */
obj_t BgL_v1122z00_53;
BgL_v1122z00_53 = 
create_vector(((long)5)); 
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1178z00_54;
BgL_arg1178z00_54 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1722z00zz__pth_threadz00, BGl_proc1721z00zz__pth_threadz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)1))); 
VECTOR_SET(BgL_v1122z00_53,((long)0),BgL_arg1178z00_54); } 
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1183z00_64;
BgL_arg1183z00_64 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc1725z00zz__pth_threadz00, BGl_proc1724z00zz__pth_threadz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1723z00zz__pth_threadz00, 
CNST_TABLE_REF(((long)3))); 
VECTOR_SET(BgL_v1122z00_53,((long)1),BgL_arg1183z00_64); } 
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1190z00_77;
BgL_arg1190z00_77 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)4)), BGl_proc1728z00zz__pth_threadz00, BGl_proc1727z00zz__pth_threadz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1726z00zz__pth_threadz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1122z00_53,((long)2),BgL_arg1190z00_77); } 
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1212z00_90;
BgL_arg1212z00_90 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1731z00zz__pth_threadz00, BGl_proc1730z00zz__pth_threadz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1729z00zz__pth_threadz00, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1122z00_53,((long)3),BgL_arg1212z00_90); } 
{ /* Llib/pthread.scm 25 */
obj_t BgL_arg1227z00_103;
BgL_arg1227z00_103 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc1734z00zz__pth_threadz00, BGl_proc1733z00zz__pth_threadz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1732z00zz__pth_threadz00, 
CNST_TABLE_REF(((long)8))); 
VECTOR_SET(BgL_v1122z00_53,((long)4),BgL_arg1227z00_103); } 
BgL_arg1165z00_35 = BgL_v1122z00_53; } 
{ /* Llib/pthread.scm 25 */
obj_t BgL_v1123z00_116;
BgL_v1123z00_116 = 
create_vector(((long)0)); 
BgL_arg1168z00_36 = BgL_v1123z00_116; } 
BGl_pthreadz00zz__pth_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)10)), BGl_threadz00zz__threadz00, ((long)35369), BGl_proc1737z00zz__pth_threadz00, BGl_proc1736z00zz__pth_threadz00, BGl_threadzd2initializa7ez12zd2envzb5zz__threadz00, BGl_proc1735z00zz__pth_threadz00, BFALSE, BgL_arg1165z00_35, BgL_arg1168z00_36); } 
{ /* Llib/pthread.scm 37 */
obj_t BgL_arg1246z00_123;obj_t BgL_arg1247z00_124;
{ /* Llib/pthread.scm 37 */
obj_t BgL_v1124z00_140;
BgL_v1124z00_140 = 
create_vector(((long)0)); 
BgL_arg1246z00_123 = BgL_v1124z00_140; } 
{ /* Llib/pthread.scm 37 */
obj_t BgL_v1125z00_141;
BgL_v1125z00_141 = 
create_vector(((long)0)); 
BgL_arg1247z00_124 = BgL_v1125z00_141; } 
BGl_z62threadzd2errorzb0zz__pth_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)10)), BGl_z62errorz62zz__objectz00, ((long)52138), BGl_proc1740z00zz__pth_threadz00, BGl_proc1739z00zz__pth_threadz00, BFALSE, BGl_proc1738z00zz__pth_threadz00, BFALSE, BgL_arg1246z00_123, BgL_arg1247z00_124); } 
{ /* Llib/pthread.scm 39 */
obj_t BgL_arg1279z00_148;obj_t BgL_arg1280z00_149;
{ /* Llib/pthread.scm 39 */
obj_t BgL_v1126z00_163;
BgL_v1126z00_163 = 
create_vector(((long)1)); 
{ /* Llib/pthread.scm 39 */
obj_t BgL_arg1323z00_164;
BgL_arg1323z00_164 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc1742z00zz__pth_threadz00, BGl_proc1741z00zz__pth_threadz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)5))); 
VECTOR_SET(BgL_v1126z00_163,((long)0),BgL_arg1323z00_164); } 
BgL_arg1279z00_148 = BgL_v1126z00_163; } 
{ /* Llib/pthread.scm 39 */
obj_t BgL_v1127z00_174;
BgL_v1127z00_174 = 
create_vector(((long)0)); 
BgL_arg1280z00_149 = BgL_v1127z00_174; } 
BGl_uncaughtzd2exceptionzd2zz__pth_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)13)), 
CNST_TABLE_REF(((long)10)), BGl_z62exceptionz62zz__objectz00, ((long)30717), BGl_proc1745z00zz__pth_threadz00, BGl_proc1744z00zz__pth_threadz00, BFALSE, BGl_proc1743z00zz__pth_threadz00, BFALSE, BgL_arg1279z00_148, BgL_arg1280z00_149); } 
{ /* Llib/pthread.scm 42 */
obj_t BgL_arg1339z00_181;obj_t BgL_arg1341z00_182;
{ /* Llib/pthread.scm 42 */
obj_t BgL_v1128z00_195;
BgL_v1128z00_195 = 
create_vector(((long)0)); 
BgL_arg1339z00_181 = BgL_v1128z00_195; } 
{ /* Llib/pthread.scm 42 */
obj_t BgL_v1129z00_196;
BgL_v1129z00_196 = 
create_vector(((long)0)); 
BgL_arg1341z00_182 = BgL_v1129z00_196; } 
return ( 
BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)14)), 
CNST_TABLE_REF(((long)10)), BGl_z62exceptionz62zz__objectz00, ((long)35176), BGl_proc1748z00zz__pth_threadz00, BGl_proc1747z00zz__pth_threadz00, BFALSE, BGl_proc1746z00zz__pth_threadz00, BFALSE, BgL_arg1339z00_181, BgL_arg1341z00_182), BUNSPEC) ;} } 

}



/* &<@anonymous:1347> */
obj_t BGl_z62zc3z04anonymousza31347ze3ze5zz__pth_threadz00(obj_t BgL_envz00_527, obj_t BgL_new1078z00_528)
{
{ /* Llib/pthread.scm 42 */
{ 
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_auxz00_927;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BgL_new1078z00_528))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BgL_new1078z00_528))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BgL_new1078z00_528))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_927 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BgL_new1078z00_528); 
return 
((obj_t)BgL_auxz00_927);} } 

}



/* &lambda1345 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BGl_z62lambda1345z62zz__pth_threadz00(obj_t BgL_envz00_529)
{
{ /* Llib/pthread.scm 42 */
{ /* Llib/pthread.scm 42 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1077z00_720;
BgL_new1077z00_720 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/pthread.scm 42 */
long BgL_arg1346z00_721;
BgL_arg1346z00_721 = 
BGL_CLASS_INDEX(BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_720), BgL_arg1346z00_721); } 
return BgL_new1077z00_720;} } 

}



/* &lambda1342 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BGl_z62lambda1342z62zz__pth_threadz00(obj_t BgL_envz00_530, obj_t BgL_fname1074z00_531, obj_t BgL_location1075z00_532, obj_t BgL_stack1076z00_533)
{
{ /* Llib/pthread.scm 42 */
{ /* Llib/pthread.scm 42 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1121z00_722;
{ /* Llib/pthread.scm 42 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1120z00_723;
BgL_new1120z00_723 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/pthread.scm 42 */
long BgL_arg1344z00_724;
BgL_arg1344z00_724 = 
BGL_CLASS_INDEX(BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_723), BgL_arg1344z00_724); } 
BgL_new1121z00_722 = BgL_new1120z00_723; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1121z00_722)))->BgL_fnamez00)=((obj_t)BgL_fname1074z00_531),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1121z00_722)))->BgL_locationz00)=((obj_t)BgL_location1075z00_532),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1121z00_722)))->BgL_stackz00)=((obj_t)BgL_stack1076z00_533),BUNSPEC); 
return BgL_new1121z00_722;} } 

}



/* &<@anonymous:1321> */
obj_t BGl_z62zc3z04anonymousza31321ze3ze5zz__pth_threadz00(obj_t BgL_envz00_534, obj_t BgL_new1072z00_535)
{
{ /* Llib/pthread.scm 39 */
{ 
BgL_uncaughtzd2exceptionzd2_bglt BgL_auxz00_953;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_new1072z00_535))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_new1072z00_535))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_new1072z00_535))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_new1072z00_535)))->BgL_reasonz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_953 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_new1072z00_535); 
return 
((obj_t)BgL_auxz00_953);} } 

}



/* &lambda1319 */
BgL_uncaughtzd2exceptionzd2_bglt BGl_z62lambda1319z62zz__pth_threadz00(obj_t BgL_envz00_536)
{
{ /* Llib/pthread.scm 39 */
{ /* Llib/pthread.scm 39 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1071z00_726;
BgL_new1071z00_726 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uncaughtzd2exceptionzd2_bgl) ))); 
{ /* Llib/pthread.scm 39 */
long BgL_arg1320z00_727;
BgL_arg1320z00_727 = 
BGL_CLASS_INDEX(BGl_uncaughtzd2exceptionzd2zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1071z00_726), BgL_arg1320z00_727); } 
return BgL_new1071z00_726;} } 

}



/* &lambda1281 */
BgL_uncaughtzd2exceptionzd2_bglt BGl_z62lambda1281z62zz__pth_threadz00(obj_t BgL_envz00_537, obj_t BgL_fname1067z00_538, obj_t BgL_location1068z00_539, obj_t BgL_stack1069z00_540, obj_t BgL_reason1070z00_541)
{
{ /* Llib/pthread.scm 39 */
{ /* Llib/pthread.scm 39 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1119z00_728;
{ /* Llib/pthread.scm 39 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1118z00_729;
BgL_new1118z00_729 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uncaughtzd2exceptionzd2_bgl) ))); 
{ /* Llib/pthread.scm 39 */
long BgL_arg1318z00_730;
BgL_arg1318z00_730 = 
BGL_CLASS_INDEX(BGl_uncaughtzd2exceptionzd2zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_729), BgL_arg1318z00_730); } 
BgL_new1119z00_728 = BgL_new1118z00_729; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1119z00_728)))->BgL_fnamez00)=((obj_t)BgL_fname1067z00_538),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1119z00_728)))->BgL_locationz00)=((obj_t)BgL_location1068z00_539),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1119z00_728)))->BgL_stackz00)=((obj_t)BgL_stack1069z00_540),BUNSPEC); 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(BgL_new1119z00_728))->BgL_reasonz00)=((obj_t)BgL_reason1070z00_541),BUNSPEC); 
return BgL_new1119z00_728;} } 

}



/* &lambda1332 */
obj_t BGl_z62lambda1332z62zz__pth_threadz00(obj_t BgL_envz00_542, obj_t BgL_oz00_543, obj_t BgL_vz00_544)
{
{ /* Llib/pthread.scm 39 */
return 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_oz00_543)))->BgL_reasonz00)=((obj_t)BgL_vz00_544),BUNSPEC);} 

}



/* &lambda1331 */
obj_t BGl_z62lambda1331z62zz__pth_threadz00(obj_t BgL_envz00_545, obj_t BgL_oz00_546)
{
{ /* Llib/pthread.scm 39 */
return 
(((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_oz00_546)))->BgL_reasonz00);} 

}



/* &<@anonymous:1253> */
obj_t BGl_z62zc3z04anonymousza31253ze3ze5zz__pth_threadz00(obj_t BgL_envz00_547, obj_t BgL_new1065z00_548)
{
{ /* Llib/pthread.scm 37 */
{ 
BgL_z62threadzd2errorzb0_bglt BgL_auxz00_986;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_986 = 
((BgL_z62threadzd2errorzb0_bglt)BgL_new1065z00_548); 
return 
((obj_t)BgL_auxz00_986);} } 

}



/* &lambda1250 */
BgL_z62threadzd2errorzb0_bglt BGl_z62lambda1250z62zz__pth_threadz00(obj_t BgL_envz00_549)
{
{ /* Llib/pthread.scm 37 */
{ /* Llib/pthread.scm 37 */
BgL_z62threadzd2errorzb0_bglt BgL_new1064z00_734;
BgL_new1064z00_734 = 
((BgL_z62threadzd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62threadzd2errorzb0_bgl) ))); 
{ /* Llib/pthread.scm 37 */
long BgL_arg1252z00_735;
BgL_arg1252z00_735 = 
BGL_CLASS_INDEX(BGl_z62threadzd2errorzb0zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_734), BgL_arg1252z00_735); } 
return BgL_new1064z00_734;} } 

}



/* &lambda1248 */
BgL_z62threadzd2errorzb0_bglt BGl_z62lambda1248z62zz__pth_threadz00(obj_t BgL_envz00_550, obj_t BgL_fname1058z00_551, obj_t BgL_location1059z00_552, obj_t BgL_stack1060z00_553, obj_t BgL_proc1061z00_554, obj_t BgL_msg1062z00_555, obj_t BgL_obj1063z00_556)
{
{ /* Llib/pthread.scm 37 */
{ /* Llib/pthread.scm 37 */
BgL_z62threadzd2errorzb0_bglt BgL_new1117z00_736;
{ /* Llib/pthread.scm 37 */
BgL_z62threadzd2errorzb0_bglt BgL_new1116z00_737;
BgL_new1116z00_737 = 
((BgL_z62threadzd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62threadzd2errorzb0_bgl) ))); 
{ /* Llib/pthread.scm 37 */
long BgL_arg1249z00_738;
BgL_arg1249z00_738 = 
BGL_CLASS_INDEX(BGl_z62threadzd2errorzb0zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1116z00_737), BgL_arg1249z00_738); } 
BgL_new1117z00_736 = BgL_new1116z00_737; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_736)))->BgL_fnamez00)=((obj_t)BgL_fname1058z00_551),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_736)))->BgL_locationz00)=((obj_t)BgL_location1059z00_552),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1117z00_736)))->BgL_stackz00)=((obj_t)BgL_stack1060z00_553),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1117z00_736)))->BgL_procz00)=((obj_t)BgL_proc1061z00_554),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1117z00_736)))->BgL_msgz00)=((obj_t)BgL_msg1062z00_555),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1117z00_736)))->BgL_objz00)=((obj_t)BgL_obj1063z00_556),BUNSPEC); 
return BgL_new1117z00_736;} } 

}



/* &<@anonymous:1176> */
obj_t BGl_z62zc3z04anonymousza31176ze3ze5zz__pth_threadz00(obj_t BgL_envz00_557, obj_t BgL_new1056z00_558)
{
{ /* Llib/pthread.scm 25 */
{ 
BgL_pthreadz00_bglt BgL_auxz00_1027;
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)
((BgL_pthreadz00_bglt)BgL_new1056z00_558))))->BgL_namez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1056z00_558)))->BgL_bodyz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1056z00_558)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1056z00_558)))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1056z00_558)))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_new1056z00_558)))->BgL_z42builtinz42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_1027 = 
((BgL_pthreadz00_bglt)BgL_new1056z00_558); 
return 
((obj_t)BgL_auxz00_1027);} } 

}



/* &lambda1173 */
BgL_pthreadz00_bglt BGl_z62lambda1173z62zz__pth_threadz00(obj_t BgL_envz00_559)
{
{ /* Llib/pthread.scm 25 */
{ /* Llib/pthread.scm 25 */
BgL_pthreadz00_bglt BgL_new1055z00_740;
BgL_new1055z00_740 = 
((BgL_pthreadz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pthreadz00_bgl) ))); 
{ /* Llib/pthread.scm 25 */
long BgL_arg1175z00_741;
BgL_arg1175z00_741 = 
BGL_CLASS_INDEX(BGl_pthreadz00zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_740), BgL_arg1175z00_741); } 
return BgL_new1055z00_740;} } 

}



/* &lambda1169 */
BgL_pthreadz00_bglt BGl_z62lambda1169z62zz__pth_threadz00(obj_t BgL_envz00_560, obj_t BgL_name1049z00_561, obj_t BgL_body1050z00_562, obj_t BgL_detachedp1051z00_563, obj_t BgL_endzd2result1052zd2_564, obj_t BgL_endzd2exception1053zd2_565, obj_t BgL_z42builtin1054z42_566)
{
{ /* Llib/pthread.scm 25 */
{ /* Llib/pthread.scm 25 */
bool_t BgL_detachedp1051z00_743;void * BgL_z42builtin1054z42_744;
BgL_detachedp1051z00_743 = 
CBOOL(BgL_detachedp1051z00_563); 
BgL_z42builtin1054z42_744 = 
FOREIGN_TO_COBJ(BgL_z42builtin1054z42_566); 
{ /* Llib/pthread.scm 25 */
BgL_pthreadz00_bglt BgL_new1115z00_745;
{ /* Llib/pthread.scm 25 */
BgL_pthreadz00_bglt BgL_new1114z00_746;
BgL_new1114z00_746 = 
((BgL_pthreadz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pthreadz00_bgl) ))); 
{ /* Llib/pthread.scm 25 */
long BgL_arg1172z00_747;
BgL_arg1172z00_747 = 
BGL_CLASS_INDEX(BGl_pthreadz00zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_746), BgL_arg1172z00_747); } 
BgL_new1115z00_745 = BgL_new1114z00_746; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1115z00_745)))->BgL_namez00)=((obj_t)BgL_name1049z00_561),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1115z00_745))->BgL_bodyz00)=((obj_t)
((obj_t)BgL_body1050z00_562)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1115z00_745))->BgL_detachedpz00)=((bool_t)BgL_detachedp1051z00_743),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1115z00_745))->BgL_endzd2resultzd2)=((obj_t)BgL_endzd2result1052zd2_564),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1115z00_745))->BgL_endzd2exceptionzd2)=((obj_t)BgL_endzd2exception1053zd2_565),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1115z00_745))->BgL_z42builtinz42)=((void *)BgL_z42builtin1054z42_744),BUNSPEC); 
{ /* Llib/pthread.scm 25 */
obj_t BgL_fun1170z00_748;
BgL_fun1170z00_748 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pthreadz00zz__pth_threadz00); 
PROCEDURE_ENTRY(BgL_fun1170z00_748)(BgL_fun1170z00_748, 
((obj_t)BgL_new1115z00_745), BEOA); } 
return BgL_new1115z00_745;} } } 

}



/* &<@anonymous:1241> */
obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__pth_threadz00(obj_t BgL_envz00_567)
{
{ /* Llib/pthread.scm 25 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda1240 */
obj_t BGl_z62lambda1240z62zz__pth_threadz00(obj_t BgL_envz00_568, obj_t BgL_oz00_569, obj_t BgL_vz00_570)
{
{ /* Llib/pthread.scm 25 */
{ /* Llib/pthread.scm 25 */
void * BgL_vz00_750;
BgL_vz00_750 = 
FOREIGN_TO_COBJ(BgL_vz00_570); 
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_569)))->BgL_z42builtinz42)=((void *)BgL_vz00_750),BUNSPEC);} } 

}



/* &lambda1239 */
obj_t BGl_z62lambda1239z62zz__pth_threadz00(obj_t BgL_envz00_571, obj_t BgL_oz00_572)
{
{ /* Llib/pthread.scm 25 */
return 
void_star_to_obj(
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_572)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1222> */
obj_t BGl_z62zc3z04anonymousza31222ze3ze5zz__pth_threadz00(obj_t BgL_envz00_573)
{
{ /* Llib/pthread.scm 25 */
return BUNSPEC;} 

}



/* &lambda1221 */
obj_t BGl_z62lambda1221z62zz__pth_threadz00(obj_t BgL_envz00_574, obj_t BgL_oz00_575, obj_t BgL_vz00_576)
{
{ /* Llib/pthread.scm 25 */
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_575)))->BgL_endzd2exceptionzd2)=((obj_t)BgL_vz00_576),BUNSPEC);} 

}



/* &lambda1220 */
obj_t BGl_z62lambda1220z62zz__pth_threadz00(obj_t BgL_envz00_577, obj_t BgL_oz00_578)
{
{ /* Llib/pthread.scm 25 */
return 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_578)))->BgL_endzd2exceptionzd2);} 

}



/* &<@anonymous:1209> */
obj_t BGl_z62zc3z04anonymousza31209ze3ze5zz__pth_threadz00(obj_t BgL_envz00_579)
{
{ /* Llib/pthread.scm 25 */
return BUNSPEC;} 

}



/* &lambda1208 */
obj_t BGl_z62lambda1208z62zz__pth_threadz00(obj_t BgL_envz00_580, obj_t BgL_oz00_581, obj_t BgL_vz00_582)
{
{ /* Llib/pthread.scm 25 */
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_581)))->BgL_endzd2resultzd2)=((obj_t)BgL_vz00_582),BUNSPEC);} 

}



/* &lambda1207 */
obj_t BGl_z62lambda1207z62zz__pth_threadz00(obj_t BgL_envz00_583, obj_t BgL_oz00_584)
{
{ /* Llib/pthread.scm 25 */
return 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_584)))->BgL_endzd2resultzd2);} 

}



/* &<@anonymous:1189> */
obj_t BGl_z62zc3z04anonymousza31189ze3ze5zz__pth_threadz00(obj_t BgL_envz00_585)
{
{ /* Llib/pthread.scm 25 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1188 */
obj_t BGl_z62lambda1188z62zz__pth_threadz00(obj_t BgL_envz00_586, obj_t BgL_oz00_587, obj_t BgL_vz00_588)
{
{ /* Llib/pthread.scm 25 */
{ /* Llib/pthread.scm 25 */
bool_t BgL_vz00_757;
BgL_vz00_757 = 
CBOOL(BgL_vz00_588); 
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_587)))->BgL_detachedpz00)=((bool_t)BgL_vz00_757),BUNSPEC);} } 

}



/* &lambda1187 */
obj_t BGl_z62lambda1187z62zz__pth_threadz00(obj_t BgL_envz00_589, obj_t BgL_oz00_590)
{
{ /* Llib/pthread.scm 25 */
return 
BBOOL(
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_590)))->BgL_detachedpz00));} 

}



/* &lambda1182 */
obj_t BGl_z62lambda1182z62zz__pth_threadz00(obj_t BgL_envz00_591, obj_t BgL_oz00_592, obj_t BgL_vz00_593)
{
{ /* Llib/pthread.scm 25 */
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_592)))->BgL_bodyz00)=((obj_t)
((obj_t)BgL_vz00_593)),BUNSPEC);} 

}



/* &lambda1181 */
obj_t BGl_z62lambda1181z62zz__pth_threadz00(obj_t BgL_envz00_594, obj_t BgL_oz00_595)
{
{ /* Llib/pthread.scm 25 */
return 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_595)))->BgL_bodyz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_uncaughtzd2exceptionzd2zz__pth_threadz00, BGl_proc1749z00zz__pth_threadz00, BGl_string1750z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_uncaughtzd2exceptionzd2zz__pth_threadz00, BGl_proc1751z00zz__pth_threadz00, BGl_string1752z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_uncaughtzd2exceptionzd2zz__pth_threadz00, BGl_proc1753z00zz__pth_threadz00, BGl_string1754z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_z52userzd2threadzd2yieldz12zd2envz92zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1755z00zz__pth_threadz00, BGl_string1756z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2initializa7ez12zd2envzb5zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1757z00zz__pth_threadz00, BGl_string1758z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2startz12zd2envz12zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1759z00zz__pth_threadz00, BGl_string1760z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2startzd2joinablez12zd2envzc0zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1761z00zz__pth_threadz00, BGl_string1762z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2joinz12zd2envz12zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1763z00zz__pth_threadz00, BGl_string1764z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2terminatez12zd2envz12zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1765z00zz__pth_threadz00, BGl_string1766z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2envz00zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1767z00zz__pth_threadz00, BGl_string1768z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1769z00zz__pth_threadz00, BGl_string1770z00zz__pth_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2envz00zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1771z00zz__pth_threadz00, BGl_string1772z00zz__pth_threadz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00, BGl_pthreadz00zz__pth_threadz00, BGl_proc1773z00zz__pth_threadz00, BGl_string1774z00zz__pth_threadz00);} 

}



/* &thread-cleanup-set!-1155 */
obj_t BGl_z62threadzd2cleanupzd2setz12zd21155za2zz__pth_threadz00(obj_t BgL_envz00_617, obj_t BgL_tz00_618, obj_t BgL_pz00_619)
{
{ /* Llib/pthread.scm 194 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_pz00_619, 
(int)(((long)1))))
{ /* Llib/pthread.scm 196 */
{ /* Llib/pthread.scm 198 */
void * BgL_arg1699z00_763;
BgL_arg1699z00_763 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_618)))->BgL_z42builtinz42); 
BGLPTH_THREAD_CLEANUP_SET(BgL_arg1699z00_763, BgL_pz00_619); BUNSPEC; } 
return BgL_pz00_619;}  else 
{ /* Llib/pthread.scm 196 */
return 
BGl_errorz00zz__errorz00(BGl_string1774z00zz__pth_threadz00, BGl_string1775z00zz__pth_threadz00, BgL_pz00_619);} } 

}



/* &thread-cleanup-pthre1153 */
obj_t BGl_z62threadzd2cleanupzd2pthre1153z62zz__pth_threadz00(obj_t BgL_envz00_620, obj_t BgL_tz00_621)
{
{ /* Llib/pthread.scm 187 */
{ /* Llib/pthread.scm 189 */
void * BgL_tmpz00_1116;
BgL_tmpz00_1116 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_621)))->BgL_z42builtinz42); 
return 
BGLPTH_THREAD_CLEANUP(BgL_tmpz00_1116);} } 

}



/* &thread-specific-set!1151 */
obj_t BGl_z62threadzd2specificzd2setz121151z70zz__pth_threadz00(obj_t BgL_envz00_622, obj_t BgL_tz00_623, obj_t BgL_vz00_624)
{
{ /* Llib/pthread.scm 179 */
{ /* Llib/pthread.scm 181 */
void * BgL_arg1696z00_766;
BgL_arg1696z00_766 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_623)))->BgL_z42builtinz42); 
BGLPTH_THREAD_SPECIFIC_SET(BgL_arg1696z00_766, BgL_vz00_624); BUNSPEC; } 
return BgL_vz00_624;} 

}



/* &thread-specific-pthr1149 */
obj_t BGl_z62threadzd2specificzd2pthr1149z62zz__pth_threadz00(obj_t BgL_envz00_625, obj_t BgL_tz00_626)
{
{ /* Llib/pthread.scm 172 */
{ /* Llib/pthread.scm 174 */
void * BgL_tmpz00_1123;
BgL_tmpz00_1123 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_626)))->BgL_z42builtinz42); 
return 
BGLPTH_THREAD_SPECIFIC(BgL_tmpz00_1123);} } 

}



/* &thread-terminate!-pt1147 */
obj_t BGl_z62threadzd2terminatez12zd2pt1147z70zz__pth_threadz00(obj_t BgL_envz00_627, obj_t BgL_tz00_628)
{
{ /* Llib/pthread.scm 163 */
if(
bglpth_thread_terminate(
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_628)))->BgL_z42builtinz42)))
{ 
obj_t BgL_auxz00_1131;
{ /* Llib/pthread.scm 166 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1109z00_769;
{ /* Llib/pthread.scm 166 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1108z00_770;
BgL_new1108z00_770 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/pthread.scm 166 */
long BgL_arg1678z00_771;
{ /* Llib/pthread.scm 166 */
obj_t BgL_classz00_772;
BgL_classz00_772 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_arg1678z00_771 = 
BGL_CLASS_INDEX(BgL_classz00_772); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1108z00_770), BgL_arg1678z00_771); } 
BgL_new1109z00_769 = BgL_new1108z00_770; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1109z00_769)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1109z00_769)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1141;
{ /* Llib/pthread.scm 166 */
obj_t BgL_arg1674z00_773;
{ /* Llib/pthread.scm 166 */
obj_t BgL_arg1677z00_774;
{ /* Llib/pthread.scm 166 */
obj_t BgL_classz00_775;
BgL_classz00_775 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_arg1677z00_774 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_775); } 
BgL_arg1674z00_773 = 
VECTOR_REF(BgL_arg1677z00_774,((long)2)); } 
BgL_auxz00_1141 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1674z00_773); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1109z00_769)))->BgL_stackz00)=((obj_t)BgL_auxz00_1141),BUNSPEC); } 
BgL_auxz00_1131 = 
((obj_t)BgL_new1109z00_769); } 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_628)))->BgL_endzd2exceptionzd2)=((obj_t)BgL_auxz00_1131),BUNSPEC); }  else 
{ /* Llib/pthread.scm 165 */BFALSE; } 
return 
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_628));} 

}



/* &thread-join!-pthread1145 */
obj_t BGl_z62threadzd2joinz12zd2pthread1145z70zz__pth_threadz00(obj_t BgL_envz00_629, obj_t BgL_tz00_630, obj_t BgL_timeoutz00_631)
{
{ /* Llib/pthread.scm 146 */
if(
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_630)))->BgL_detachedpz00))
{ /* Llib/pthread.scm 150 */
BgL_z62threadzd2errorzb0_bglt BgL_arg1631z00_777;
{ /* Llib/pthread.scm 150 */
BgL_z62threadzd2errorzb0_bglt BgL_new1106z00_778;
{ /* Llib/pthread.scm 150 */
BgL_z62threadzd2errorzb0_bglt BgL_new1105z00_779;
BgL_new1105z00_779 = 
((BgL_z62threadzd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62threadzd2errorzb0_bgl) ))); 
{ /* Llib/pthread.scm 150 */
long BgL_arg1644z00_780;
BgL_arg1644z00_780 = 
BGL_CLASS_INDEX(BGl_z62threadzd2errorzb0zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_779), BgL_arg1644z00_780); } 
BgL_new1106z00_778 = BgL_new1105z00_779; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1106z00_778)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1106z00_778)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1162;
{ /* Llib/pthread.scm 150 */
obj_t BgL_arg1636z00_781;
{ /* Llib/pthread.scm 150 */
obj_t BgL_arg1643z00_782;
{ /* Llib/pthread.scm 150 */
obj_t BgL_classz00_783;
BgL_classz00_783 = BGl_z62threadzd2errorzb0zz__pth_threadz00; 
BgL_arg1643z00_782 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_783); } 
BgL_arg1636z00_781 = 
VECTOR_REF(BgL_arg1643z00_782,((long)2)); } 
BgL_auxz00_1162 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1636z00_781); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1106z00_778)))->BgL_stackz00)=((obj_t)BgL_auxz00_1162),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1106z00_778)))->BgL_procz00)=((obj_t)
CNST_TABLE_REF(((long)15))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1106z00_778)))->BgL_msgz00)=((obj_t)BGl_string1776z00zz__pth_threadz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1106z00_778)))->BgL_objz00)=((obj_t)
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_630))),BUNSPEC); 
BgL_arg1631z00_777 = BgL_new1106z00_778; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1631z00_777));}  else 
{ /* Llib/pthread.scm 148 */
{ /* Llib/pthread.scm 155 */
void * BgL_arg1645z00_784;obj_t BgL_arg1647z00_785;
BgL_arg1645z00_784 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_630)))->BgL_z42builtinz42); 
if(
PAIRP(BgL_timeoutz00_631))
{ /* Llib/pthread.scm 155 */
BgL_arg1647z00_785 = 
CAR(BgL_timeoutz00_631); }  else 
{ /* Llib/pthread.scm 155 */
BgL_arg1647z00_785 = BFALSE; } 
bglpth_thread_join(BgL_arg1645z00_784, BgL_arg1647z00_785); BUNSPEC; } 
{ /* Llib/pthread.scm 156 */
bool_t BgL_test1856z00_1185;
{ /* Llib/pthread.scm 156 */
obj_t BgL_arg1661z00_786;
BgL_arg1661z00_786 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_630)))->BgL_endzd2exceptionzd2); 
BgL_test1856z00_1185 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1661z00_786, BGl_z62exceptionz62zz__objectz00); } 
if(BgL_test1856z00_1185)
{ /* Llib/pthread.scm 156 */
return 
BGl_raisez00zz__errorz00(
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_630)))->BgL_endzd2exceptionzd2));}  else 
{ /* Llib/pthread.scm 156 */
return 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_630)))->BgL_endzd2resultzd2);} } } } 

}



/* &thread-start-joinabl1143 */
obj_t BGl_z62threadzd2startzd2joinabl1143z62zz__pth_threadz00(obj_t BgL_envz00_632, obj_t BgL_tz00_633)
{
{ /* Llib/pthread.scm 137 */
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_633)))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/pthread.scm 140 */
void * BgL_arg1628z00_788;
BgL_arg1628z00_788 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_633)))->BgL_z42builtinz42); 
bglpth_thread_start(BgL_arg1628z00_788, 
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_633)), ((bool_t)0)); BUNSPEC; } 
return 
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_633));} 

}



/* &thread-start!-pthrea1141 */
obj_t BGl_z62threadzd2startz12zd2pthrea1141z70zz__pth_threadz00(obj_t BgL_envz00_634, obj_t BgL_tz00_635, obj_t BgL_scdz00_636)
{
{ /* Llib/pthread.scm 128 */
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_635)))->BgL_detachedpz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/pthread.scm 131 */
void * BgL_arg1626z00_790;
BgL_arg1626z00_790 = 
(((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_tz00_635)))->BgL_z42builtinz42); 
bglpth_thread_start(BgL_arg1626z00_790, 
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_635)), ((bool_t)1)); BUNSPEC; } 
return 
((obj_t)
((BgL_pthreadz00_bglt)BgL_tz00_635));} 

}



/* &thread-initialize!-p1139 */
obj_t BGl_z62threadzd2initializa7ez12zd2p1139zd7zz__pth_threadz00(obj_t BgL_envz00_637, obj_t BgL_oz00_638)
{
{ /* Llib/pthread.scm 88 */
if(
BGl_bigloozd2initializa7edzf3z86zz__paramz00())
{ /* Llib/pthread.scm 89 */BFALSE; }  else 
{ /* Llib/pthread.scm 92 */
obj_t BgL_arg1431z00_792;
BgL_arg1431z00_792 = 
bgl_typeof(
((obj_t)
((BgL_pthreadz00_bglt)BgL_oz00_638))); 
{ /* Llib/pthread.scm 90 */
obj_t BgL_list1432z00_793;
{ /* Llib/pthread.scm 90 */
obj_t BgL_arg1506z00_794;
{ /* Llib/pthread.scm 90 */
obj_t BgL_arg1507z00_795;
BgL_arg1507z00_795 = 
MAKE_YOUNG_PAIR(BgL_arg1431z00_792, BNIL); 
BgL_arg1506z00_794 = 
MAKE_YOUNG_PAIR(BGl_string1777z00zz__pth_threadz00, BgL_arg1507z00_795); } 
BgL_list1432z00_793 = 
MAKE_YOUNG_PAIR(BGl_string1778z00zz__pth_threadz00, BgL_arg1506z00_794); } 
BGl_warningz00zz__errorz00(BgL_list1432z00_793); } } 
{ /* Llib/pthread.scm 95 */
obj_t BgL_bz00_796;
BgL_bz00_796 = 
MAKE_FX_PROCEDURE(BGl_z62bz62zz__pth_threadz00, 
(int)(((long)0)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_bz00_796, 
(int)(((long)0)), 
((obj_t)
((BgL_pthreadz00_bglt)BgL_oz00_638))); 
PROCEDURE_SET(BgL_bz00_796, 
(int)(((long)1)), 
((obj_t)
((BgL_pthreadz00_bglt)BgL_oz00_638))); 
return 
((((BgL_pthreadz00_bglt)COBJECT(
((BgL_pthreadz00_bglt)BgL_oz00_638)))->BgL_z42builtinz42)=((void *)
bglpth_thread_new(BgL_bz00_796)),BUNSPEC);} } 

}



/* &b */
obj_t BGl_z62bz62zz__pth_threadz00(obj_t BgL_envz00_639)
{
{ /* Llib/pthread.scm 94 */
{ /* Llib/pthread.scm 95 */
BgL_pthreadz00_bglt BgL_i1082z00_640;BgL_pthreadz00_bglt BgL_oz00_641;
BgL_i1082z00_640 = 
((BgL_pthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_639, 
(int)(((long)0)))); 
BgL_oz00_641 = 
((BgL_pthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_639, 
(int)(((long)1)))); 
{ /* Llib/pthread.scm 95 */
obj_t BgL_idz00_797;
{ /* Llib/pthread.scm 95 */
bool_t BgL_test1858z00_1241;
{ /* Llib/pthread.scm 95 */
obj_t BgL_tmpz00_1242;
BgL_tmpz00_1242 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_i1082z00_640)))->BgL_namez00); 
BgL_test1858z00_1241 = 
SYMBOLP(BgL_tmpz00_1242); } 
if(BgL_test1858z00_1241)
{ /* Llib/pthread.scm 96 */
obj_t BgL_arg1593z00_798;
{ /* Llib/pthread.scm 96 */
obj_t BgL_arg1615z00_799;obj_t BgL_arg1616z00_800;
{ /* Llib/pthread.scm 96 */
obj_t BgL_symbolz00_801;
BgL_symbolz00_801 = 
CNST_TABLE_REF(((long)16)); 
{ /* Llib/pthread.scm 96 */
obj_t BgL_arg1434z00_802;
BgL_arg1434z00_802 = 
SYMBOL_TO_STRING(BgL_symbolz00_801); 
BgL_arg1615z00_799 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_802); } } 
{ /* Llib/pthread.scm 96 */
obj_t BgL_arg1619z00_803;
BgL_arg1619z00_803 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_i1082z00_640)))->BgL_namez00); 
{ /* Llib/pthread.scm 96 */
obj_t BgL_arg1434z00_804;
BgL_arg1434z00_804 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg1619z00_803)); 
BgL_arg1616z00_800 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_804); } } 
BgL_arg1593z00_798 = 
string_append(BgL_arg1615z00_799, BgL_arg1616z00_800); } 
BgL_idz00_797 = 
bstring_to_symbol(BgL_arg1593z00_798); }  else 
{ /* Llib/pthread.scm 95 */
BgL_idz00_797 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)17))); } } 
{ /* Llib/pthread.scm 98 */

BGL_PUSH_TRACE(BgL_idz00_797, BUNSPEC); 
{ /* Llib/pthread.scm 102 */
obj_t BgL_zc3z04anonymousza31513ze3z87_805;
BgL_zc3z04anonymousza31513ze3z87_805 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31513ze3ze5zz__pth_threadz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31513ze3z87_805, 
(int)(((long)0)), 
((obj_t)BgL_oz00_641)); 
BGL_UNCAUGHT_EXCEPTION_HANDLER_SET(BgL_zc3z04anonymousza31513ze3z87_805); BUNSPEC; } 
{ /* Llib/pthread.scm 105 */
obj_t BgL_res1085z00_806;
BgL_res1085z00_806 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_808;
if(
CBOOL(
BGl_zc3z04exitza31543ze3ze70z60zz__pth_threadz00(BgL_res1085z00_806, BgL_i1082z00_640)))
{ /* Llib/pthread.scm 105 */
{ /* Llib/pthread.scm 105 */
int BgL_tmpz00_1269;
BgL_tmpz00_1269 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_1269); } 
{ /* Llib/pthread.scm 105 */
bool_t BgL_tmpz00_1272;
BgL_ez00_808 = 
CELL_REF(BgL_res1085z00_806); 
{ /* Llib/pthread.scm 107 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_uz00_809;
{ /* Llib/pthread.scm 107 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1089z00_810;
{ /* Llib/pthread.scm 107 */
BgL_uncaughtzd2exceptionzd2_bglt BgL_new1088z00_811;
BgL_new1088z00_811 = 
((BgL_uncaughtzd2exceptionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uncaughtzd2exceptionzd2_bgl) ))); 
{ /* Llib/pthread.scm 107 */
long BgL_arg1582z00_812;
BgL_arg1582z00_812 = 
BGL_CLASS_INDEX(BGl_uncaughtzd2exceptionzd2zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1088z00_811), BgL_arg1582z00_812); } 
BgL_new1089z00_810 = BgL_new1088z00_811; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1089z00_810)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1089z00_810)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1281;
{ /* Llib/pthread.scm 107 */
obj_t BgL_arg1580z00_813;
{ /* Llib/pthread.scm 107 */
obj_t BgL_arg1581z00_814;
{ /* Llib/pthread.scm 107 */
obj_t BgL_classz00_815;
BgL_classz00_815 = BGl_uncaughtzd2exceptionzd2zz__pth_threadz00; 
BgL_arg1581z00_814 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_815); } 
BgL_arg1580z00_813 = 
VECTOR_REF(BgL_arg1581z00_814,((long)2)); } 
BgL_auxz00_1281 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1580z00_813); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1089z00_810)))->BgL_stackz00)=((obj_t)BgL_auxz00_1281),BUNSPEC); } 
((((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(BgL_new1089z00_810))->BgL_reasonz00)=((obj_t)BgL_ez00_808),BUNSPEC); 
BgL_uz00_809 = BgL_new1089z00_810; } 
((((BgL_pthreadz00_bglt)COBJECT(BgL_i1082z00_640))->BgL_endzd2exceptionzd2)=((obj_t)
((obj_t)BgL_uz00_809)),BUNSPEC); 
BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_808); 
BgL_tmpz00_1272 = ((bool_t)0); } 
return 
BBOOL(BgL_tmpz00_1272);} }  else 
{ /* Llib/pthread.scm 105 */
return 
CELL_REF(BgL_res1085z00_806);} } } } } } } 

}



/* <@exit:1546>~0 */
obj_t BGl_zc3z04exitza31546ze3ze70z60zz__pth_threadz00(BgL_pthreadz00_bglt BgL_i1082z00_704)
{
{ /* Llib/pthread.scm 114 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1093z00_301;
if( SET_EXIT(BgL_an_exit1093z00_301 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1093z00_301 = 
(void *)jmpbuf; 
{ /* Llib/pthread.scm 114 */

PUSH_EXIT(BgL_an_exit1093z00_301, ((long)1)); 
{ /* Llib/pthread.scm 114 */
obj_t BgL_an_exitd1094z00_302;
BgL_an_exitd1094z00_302 = 
((obj_t)(&exitd)); 
{ /* Llib/pthread.scm 115 */
obj_t BgL_res1096z00_305;
{ /* Llib/pthread.scm 117 */
obj_t BgL_zc3z04anonymousza31563ze3z87_610;
BgL_zc3z04anonymousza31563ze3z87_610 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31563ze3ze5zz__pth_threadz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31563ze3z87_610, 
(int)(((long)0)), BgL_an_exitd1094z00_302); 
BGl_signalz00zz__osz00(BGL_PTHREAD_TERM_SIG, BgL_zc3z04anonymousza31563ze3z87_610); } 
{ 
obj_t BgL_auxz00_1301;
{ /* Llib/pthread.scm 120 */
obj_t BgL_fun1566z00_314;
BgL_fun1566z00_314 = 
(((BgL_pthreadz00_bglt)COBJECT(BgL_i1082z00_704))->BgL_bodyz00); 
BgL_auxz00_1301 = 
PROCEDURE_ENTRY(BgL_fun1566z00_314)(BgL_fun1566z00_314, BEOA); } 
BgL_res1096z00_305 = 
((((BgL_pthreadz00_bglt)COBJECT(BgL_i1082z00_704))->BgL_endzd2resultzd2)=((obj_t)BgL_auxz00_1301),BUNSPEC); } 
POP_EXIT(); 
return BgL_res1096z00_305;} } } 
}} 

}



/* <@exit:1543>~0 */
obj_t BGl_zc3z04exitza31543ze3ze70z60zz__pth_threadz00(obj_t BgL_res1085z00_706, BgL_pthreadz00_bglt BgL_i1082z00_705)
{
{ /* Llib/pthread.scm 105 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1097z00_287;
if( SET_EXIT(BgL_an_exit1097z00_287 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1097z00_287 = 
(void *)jmpbuf; 
{ /* Llib/pthread.scm 105 */

PUSH_EXIT(BgL_an_exit1097z00_287, ((long)1)); 
{ /* Llib/pthread.scm 105 */
obj_t BgL_an_exitd1098z00_288;
BgL_an_exitd1098z00_288 = 
((obj_t)(&exitd)); 
{ /* Llib/pthread.scm 105 */
bool_t BgL_res1100z00_291;
{ /* Llib/pthread.scm 105 */
obj_t BgL_ohs1083z00_292;
BgL_ohs1083z00_292 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/pthread.scm 105 */
obj_t BgL_exitd1090z00_293;
BgL_exitd1090z00_293 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31567ze3z87_607;
BgL_zc3z04anonymousza31567ze3z87_607 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31567ze3ze5zz__pth_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31567ze3z87_607, 
(int)(((long)0)), BgL_ohs1083z00_292); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1090z00_293, BgL_zc3z04anonymousza31567ze3z87_607); 
{ /* Llib/pthread.scm 105 */
bool_t BgL_tmp1092z00_295;
{ /* Llib/pthread.scm 105 */
obj_t BgL_zc3z04anonymousza31545ze3z87_608;
BgL_zc3z04anonymousza31545ze3z87_608 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31545ze3ze5zz__pth_threadz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31545ze3z87_608, 
(int)(((long)0)), 
((obj_t)BgL_res1085z00_706)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31545ze3z87_608, 
(int)(((long)1)), BgL_an_exitd1098z00_288); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31545ze3z87_608, BgL_ohs1083z00_292); BUNSPEC; } 
{ /* Llib/pthread.scm 105 */
obj_t BgL_auxz00_643;
BgL_auxz00_643 = 
BGl_zc3z04exitza31546ze3ze70z60zz__pth_threadz00(BgL_i1082z00_705); 
CELL_SET(BgL_res1085z00_706, BgL_auxz00_643); } 
BgL_tmp1092z00_295 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1090z00_293); 
BGL_ERROR_HANDLER_SET(BgL_ohs1083z00_292); BUNSPEC; 
BgL_res1100z00_291 = BgL_tmp1092z00_295; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1100z00_291);} } } 
}} 

}



/* &<@anonymous:1563> */
obj_t BGl_z62zc3z04anonymousza31563ze3ze5zz__pth_threadz00(obj_t BgL_envz00_645, obj_t BgL_sz00_647)
{
{ /* Llib/pthread.scm 116 */
{ /* Llib/pthread.scm 117 */
obj_t BgL_an_exitd1094z00_646;
BgL_an_exitd1094z00_646 = 
PROCEDURE_REF(BgL_envz00_645, 
(int)(((long)0))); 
BGL_UNCAUGHT_EXCEPTION_HANDLER_SET(BGl_proc1779z00zz__pth_threadz00); BUNSPEC; 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1094z00_646, BFALSE);} } 

}



/* &<@anonymous:1565> */
obj_t BGl_z62zc3z04anonymousza31565ze3ze5zz__pth_threadz00(obj_t BgL_envz00_648, obj_t BgL_valz00_649)
{
{ /* Llib/pthread.scm 118 */
return BgL_valz00_649;} 

}



/* &<@anonymous:1545> */
obj_t BGl_z62zc3z04anonymousza31545ze3ze5zz__pth_threadz00(obj_t BgL_envz00_650, obj_t BgL_ez00_653)
{
{ /* Llib/pthread.scm 105 */
{ /* Llib/pthread.scm 105 */
obj_t BgL_res1085z00_651;obj_t BgL_an_exitd1098z00_652;
BgL_res1085z00_651 = 
PROCEDURE_REF(BgL_envz00_650, 
(int)(((long)0))); 
BgL_an_exitd1098z00_652 = 
PROCEDURE_REF(BgL_envz00_650, 
(int)(((long)1))); 
CELL_SET(BgL_res1085z00_651, BgL_ez00_653); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1098z00_652, BTRUE);} } 

}



/* &<@anonymous:1567> */
obj_t BGl_z62zc3z04anonymousza31567ze3ze5zz__pth_threadz00(obj_t BgL_envz00_655)
{
{ /* Llib/pthread.scm 105 */
{ 
obj_t BgL_ohs1083z00_656;
BgL_ohs1083z00_656 = 
PROCEDURE_REF(BgL_envz00_655, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1083z00_656); 
return BUNSPEC;} } 

}



/* &<@anonymous:1513> */
obj_t BGl_z62zc3z04anonymousza31513ze3ze5zz__pth_threadz00(obj_t BgL_envz00_657, obj_t BgL_valz00_659)
{
{ /* Llib/pthread.scm 101 */
{ /* Llib/pthread.scm 102 */
BgL_pthreadz00_bglt BgL_oz00_658;
BgL_oz00_658 = 
((BgL_pthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_657, 
(int)(((long)0)))); 
{ /* Llib/pthread.scm 102 */
obj_t BgL_arg1516z00_817;
{ /* Llib/pthread.scm 102 */
obj_t BgL_list1517z00_818;
BgL_list1517z00_818 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_oz00_658), BNIL); 
BgL_arg1516z00_817 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string1780z00zz__pth_threadz00, BgL_list1517z00_818); } 
return 
BGl_errorz00zz__errorz00(BgL_arg1516z00_817, BGl_string1781z00zz__pth_threadz00, BgL_valz00_659);} } } 

}



/* &%user-thread-yield!-1137 */
obj_t BGl_z62z52userzd2threadzd2yieldz12zd21137zf0zz__pth_threadz00(obj_t BgL_envz00_660, obj_t BgL_oz00_661)
{
{ /* Llib/pthread.scm 82 */
return 
BINT(
sched_yield());} 

}



/* &object-print-uncaugh1135 */
obj_t BGl_z62objectzd2printzd2uncaugh1135z62zz__pth_threadz00(obj_t BgL_envz00_662, obj_t BgL_oz00_663, obj_t BgL_portz00_664, obj_t BgL_printzd2slotzd2_665)
{
{ /* Llib/pthread.scm 75 */
{ /* Llib/pthread.scm 77 */
obj_t BgL_arg1389z00_821;
BgL_arg1389z00_821 = 
(((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_oz00_663)))->BgL_reasonz00); 
return 
BGl_objectzd2printzd2zz__objectz00(
((BgL_objectz00_bglt)BgL_arg1389z00_821), BgL_portz00_664, BgL_printzd2slotzd2_665);} } 

}



/* &object-display-uncau1133 */
obj_t BGl_z62objectzd2displayzd2uncau1133z62zz__pth_threadz00(obj_t BgL_envz00_666, obj_t BgL_oz00_667, obj_t BgL_portz00_668)
{
{ /* Llib/pthread.scm 68 */
{ /* Llib/pthread.scm 70 */
obj_t BgL_runner1364z00_823;
{ /* Llib/pthread.scm 70 */
obj_t BgL_arg1361z00_824;
BgL_arg1361z00_824 = 
(((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_oz00_667)))->BgL_reasonz00); 
{ /* Llib/pthread.scm 70 */
obj_t BgL_list1362z00_825;
BgL_list1362z00_825 = 
MAKE_YOUNG_PAIR(BgL_portz00_668, BNIL); 
BgL_runner1364z00_823 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg1361z00_824, BgL_list1362z00_825); } } 
{ /* Llib/pthread.scm 70 */
BgL_objectz00_bglt BgL_aux1363z00_826;
{ /* Llib/pthread.scm 70 */
obj_t BgL_pairz00_827;
BgL_pairz00_827 = BgL_runner1364z00_823; 
BgL_aux1363z00_826 = 
((BgL_objectz00_bglt)
CAR(BgL_pairz00_827)); } 
BgL_runner1364z00_823 = 
CDR(BgL_runner1364z00_823); 
return 
BGl_objectzd2displayzd2zz__objectz00(BgL_aux1363z00_826, BgL_runner1364z00_823);} } } 

}



/* &object-write-uncaugh1131 */
obj_t BGl_z62objectzd2writezd2uncaugh1131z62zz__pth_threadz00(obj_t BgL_envz00_669, obj_t BgL_oz00_670, obj_t BgL_portz00_671)
{
{ /* Llib/pthread.scm 61 */
{ /* Llib/pthread.scm 63 */
obj_t BgL_runner1359z00_829;
{ /* Llib/pthread.scm 63 */
obj_t BgL_arg1356z00_830;
BgL_arg1356z00_830 = 
(((BgL_uncaughtzd2exceptionzd2_bglt)COBJECT(
((BgL_uncaughtzd2exceptionzd2_bglt)BgL_oz00_670)))->BgL_reasonz00); 
{ /* Llib/pthread.scm 63 */
obj_t BgL_list1357z00_831;
BgL_list1357z00_831 = 
MAKE_YOUNG_PAIR(BgL_portz00_671, BNIL); 
BgL_runner1359z00_829 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg1356z00_830, BgL_list1357z00_831); } } 
{ /* Llib/pthread.scm 63 */
BgL_objectz00_bglt BgL_aux1358z00_832;
{ /* Llib/pthread.scm 63 */
obj_t BgL_pairz00_833;
BgL_pairz00_833 = BgL_runner1359z00_829; 
BgL_aux1358z00_832 = 
((BgL_objectz00_bglt)
CAR(BgL_pairz00_833)); } 
BgL_runner1359z00_829 = 
CDR(BgL_runner1359z00_829); 
return 
BGl_objectzd2writezd2zz__objectz00(BgL_aux1358z00_832, BgL_runner1359z00_829);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__pth_threadz00()
{
{ /* Llib/pthread.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__pth_backendz00(((long)354908835), 
BSTRING_TO_STRING(BGl_string1782z00zz__pth_threadz00));} 

}

#ifdef __cplusplus
}
#endif
