/*===========================================================================*/
/*   (Llib/music.scm)                                                        */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi pulseaudio -copt -D_REENTRANT -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/music.scm -o objs/music.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <pulse/simple.h>
#include <pulse/version.h>
#include <pulse/sample.h>
#include <pulse/error.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;


static obj_t BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00(obj_t, obj_t);
extern obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_genericzd2initzd2zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_musicbufz00zz__multimediazd2musicbufzd2;
static obj_t BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_EXPORTED_DECL obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31158ze3ze5zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31183ze3ze5zz__pulseaudio_musicz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31168ze3ze5zz__pulseaudio_musicz00(obj_t);
static BgL_pulseaudiomusicz00_bglt BGl_z62lambda1153z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
static BgL_pulseaudiomusicz00_bglt BGl_z62lambda1156z62zz__pulseaudio_musicz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static BgL_pulseaudiozd2simplezd2_bglt BGl_z62lambda1166z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1167z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1181z62zz__pulseaudio_musicz00(obj_t, obj_t);
static obj_t BGl_z62lambda1182z62zz__pulseaudio_musicz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__pulseaudio_musicz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00();
static obj_t BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00();
extern int bgl_pulseaudio_error(char *, char *, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_pulseaudiomusicz00zz__pulseaudio_musicz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_pulseaudiozd2simplezd2statez00zz__pulseaudio_simplez00(BgL_pulseaudiozd2simplezd2_bglt);
BGL_IMPORT obj_t BGl_musicstatusz00zz__multimediazd2musiczd2;
extern obj_t BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(BgL_pulseaudiozd2simplezd2_bglt);
static obj_t __cnst[ 7 ] ;


DEFINE_STRING( BGl_string1245z00zz__pulseaudio_musicz00, BgL_bgl_string1245za700za7za7_1278za7, "Llib/music.scm", 14 );
DEFINE_STRING( BGl_string1246z00zz__pulseaudio_musicz00, BgL_bgl_string1246za700za7za7_1279za7, "/builddir/build/BUILD/bigloo-4.4b/api/pulseaudio/src/Llib/music.scm", 67 );
DEFINE_STRING( BGl_string1247z00zz__pulseaudio_musicz00, BgL_bgl_string1247za700za7za7_1280za7, "&pulseaudiomusic-simple-set!", 28 );
DEFINE_STRING( BGl_string1248z00zz__pulseaudio_musicz00, BgL_bgl_string1248za700za7za7_1281za7, "pulseaudiomusic", 15 );
DEFINE_STRING( BGl_string1249z00zz__pulseaudio_musicz00, BgL_bgl_string1249za700za7za7_1282za7, "pulseaudio-simple", 17 );
BGL_IMPORT obj_t BGl_musicbufzd2drainzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2;
DEFINE_STRING( BGl_string1259z00zz__pulseaudio_musicz00, BgL_bgl_string1259za700za7za7_1283za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1250z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1284za7, BGl_z62zc3z04anonymousza31168ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1251z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1167za7621285z00, BGl_z62lambda1167z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1252z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1166za7621286z00, BGl_z62lambda1166z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1253z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1287za7, BGl_z62zc3z04anonymousza31183ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1260z00zz__pulseaudio_musicz00, BgL_bgl_string1260za700za7za7_1288za7, "bigloo", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1254z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1182za7621289z00, BGl_z62lambda1182z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1255z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1181za7621290z00, BGl_z62lambda1181z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1262z00zz__pulseaudio_musicz00, BgL_bgl_string1262za700za7za7_1291za7, "music-close", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1256z00zz__pulseaudio_musicz00, BgL_bgl_za762za7c3za704anonymo1292za7, BGl_z62zc3z04anonymousza31158ze3ze5zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1257z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1156za7621293z00, BGl_z62lambda1156z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1264z00zz__pulseaudio_musicz00, BgL_bgl_string1264za700za7za7_1294za7, "music-closed?", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1258z00zz__pulseaudio_musicz00, BgL_bgl_za762lambda1153za7621295z00, BGl_z62lambda1153z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 20 );
DEFINE_STRING( BGl_string1266z00zz__pulseaudio_musicz00, BgL_bgl_string1266za700za7za7_1296za7, "musicbuf-write", 14 );
DEFINE_STRING( BGl_string1268z00zz__pulseaudio_musicz00, BgL_bgl_string1268za700za7za7_1297za7, "musicbuf-drain", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1261z00zz__pulseaudio_musicz00, BgL_bgl_za762musicza7d2close1298z00, BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1263z00zz__pulseaudio_musicz00, BgL_bgl_za762musicza7d2close1299z00, BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1270z00zz__pulseaudio_musicz00, BgL_bgl_string1270za700za7za7_1300za7, "musicbuf-reset!", 15 );
DEFINE_STRING( BGl_string1271z00zz__pulseaudio_musicz00, BgL_bgl_string1271za700za7za7_1301za7, "pulseaudio-simple-flush", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1265z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2wr1302z00, BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1272z00zz__pulseaudio_musicz00, BgL_bgl_string1272za700za7za7_1303za7, "pulseaudio-simple-drain", 23 );
DEFINE_STRING( BGl_string1273z00zz__pulseaudio_musicz00, BgL_bgl_string1273za700za7za7_1304za7, "pulseaudio-simple-write", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1267z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2dr1305z00, BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1274z00zz__pulseaudio_musicz00, BgL_bgl_string1274za700za7za7_1306za7, "__pulseaudio_music", 18 );
DEFINE_STRING( BGl_string1275z00zz__pulseaudio_musicz00, BgL_bgl_string1275za700za7za7_1307za7, "closed s16 __pulseaudio_music pulseaudiomusic bstring name simple ", 66 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1269z00zz__pulseaudio_musicz00, BgL_bgl_za762musicbufza7d2re1308z00, BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
BGL_IMPORT obj_t BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2;
BGL_IMPORT obj_t BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_pulseaudiomusiczd2simplezd2setz12zd2envzc0zz__pulseaudio_musicz00, BgL_bgl_za762pulseaudiomus1309za7, BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00) );
ADD_ROOT( (void *)(&BGl_pulseaudiomusicz00zz__pulseaudio_musicz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long BgL_checksumz00_403, char * BgL_fromz00_404)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00))
{ 
BGl_requirezd2initializa7ationz75zz__pulseaudio_musicz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00(); 
BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00(); 
BGl_cnstzd2initzd2zz__pulseaudio_musicz00(); 
BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00(); 
BGl_objectzd2initzd2zz__pulseaudio_musicz00(); 
BGl_methodzd2initzd2zz__pulseaudio_musicz00(); 
return 
BGl_toplevelzd2initzd2zz__pulseaudio_musicz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__pulseaudio_music"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__pulseaudio_music"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_cportz00_327;
{ /* Llib/music.scm 15 */
obj_t BgL_stringz00_335;
BgL_stringz00_335 = BGl_string1275z00zz__pulseaudio_musicz00; 
{ /* Llib/music.scm 15 */
obj_t BgL_startz00_336;
BgL_startz00_336 = 
BINT(((long)0)); 
{ /* Llib/music.scm 15 */
obj_t BgL_endz00_337;
BgL_endz00_337 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_335))); 
{ /* Llib/music.scm 15 */

BgL_cportz00_327 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_335, BgL_startz00_336, BgL_endz00_337); } } } } 
{ 
long BgL_iz00_328;
BgL_iz00_328 = ((long)6); 
BgL_loopz00_329:
if(
(BgL_iz00_328==((long)-1)))
{ /* Llib/music.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 15 */
obj_t BgL_arg1277z00_331;
{ /* Llib/music.scm 15 */

{ /* Llib/music.scm 15 */
obj_t BgL_locationz00_333;
BgL_locationz00_333 = 
BBOOL(((bool_t)0)); 
{ /* Llib/music.scm 15 */

BgL_arg1277z00_331 = 
BGl_readz00zz__readerz00(BgL_cportz00_327, BgL_locationz00_333); } } } 
{ /* Llib/music.scm 15 */
int BgL_tmpz00_435;
BgL_tmpz00_435 = 
(int)(BgL_iz00_328); 
CNST_TABLE_SET(BgL_tmpz00_435, BgL_arg1277z00_331); } } 
{ /* Llib/music.scm 15 */
int BgL_auxz00_334;
BgL_auxz00_334 = 
(int)(
(BgL_iz00_328-((long)1))); 
{ 
long BgL_iz00_440;
BgL_iz00_440 = 
(long)(BgL_auxz00_334); 
BgL_iz00_328 = BgL_iz00_440; 
goto BgL_loopz00_329;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1245z00zz__pulseaudio_musicz00)); 
return BUNSPEC;} 

}



/* pulseaudiomusic-simple-set! */
BGL_EXPORTED_DEF obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt BgL_oz00_10, BgL_pulseaudiozd2simplezd2_bglt BgL_sz00_11)
{
{ /* Llib/music.scm 69 */
BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_oz00_10))->BgL_simplez00)); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_oz00_10))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)BgL_sz00_11),BUNSPEC); 
return 
((obj_t)BgL_sz00_11);} 

}



/* &pulseaudiomusic-simple-set! */
obj_t BGl_z62pulseaudiomusiczd2simplezd2setz12z70zz__pulseaudio_musicz00(obj_t BgL_envz00_237, obj_t BgL_oz00_238, obj_t BgL_sz00_239)
{
{ /* Llib/music.scm 69 */
{ /* Llib/music.scm 70 */
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_457;BgL_pulseaudiomusicz00_bglt BgL_auxz00_449;
if(
BGl_isazf3zf3zz__objectz00(BgL_sz00_239, BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00))
{ /* Llib/music.scm 70 */
BgL_auxz00_457 = 
((BgL_pulseaudiozd2simplezd2_bglt)BgL_sz00_239)
; }  else 
{ 
obj_t BgL_auxz00_461;
BgL_auxz00_461 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1246z00zz__pulseaudio_musicz00, 
BINT(((long)3551)), BGl_string1247z00zz__pulseaudio_musicz00, BGl_string1249z00zz__pulseaudio_musicz00, BgL_sz00_239); 
FAILURE(BgL_auxz00_461,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_238, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00))
{ /* Llib/music.scm 70 */
BgL_auxz00_449 = 
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_238)
; }  else 
{ 
obj_t BgL_auxz00_453;
BgL_auxz00_453 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1246z00zz__pulseaudio_musicz00, 
BINT(((long)3551)), BGl_string1247z00zz__pulseaudio_musicz00, BGl_string1248z00zz__pulseaudio_musicz00, BgL_oz00_238); 
FAILURE(BgL_auxz00_453,BFALSE,BFALSE);} 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_auxz00_449, BgL_auxz00_457);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
{ /* Llib/music.scm 22 */
obj_t BgL_arg1140z00_33;obj_t BgL_arg1152z00_34;
{ /* Llib/music.scm 22 */
obj_t BgL_v1112z00_65;
BgL_v1112z00_65 = 
create_vector(((long)2)); 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1159z00_66;
BgL_arg1159z00_66 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)0)), BGl_proc1252z00zz__pulseaudio_musicz00, BGl_proc1251z00zz__pulseaudio_musicz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1250z00zz__pulseaudio_musicz00, BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
VECTOR_SET(BgL_v1112z00_65,((long)0),BgL_arg1159z00_66); } 
{ /* Llib/music.scm 22 */
obj_t BgL_arg1176z00_85;
BgL_arg1176z00_85 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)1)), BGl_proc1255z00zz__pulseaudio_musicz00, BGl_proc1254z00zz__pulseaudio_musicz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1253z00zz__pulseaudio_musicz00, 
CNST_TABLE_REF(((long)2))); 
VECTOR_SET(BgL_v1112z00_65,((long)1),BgL_arg1176z00_85); } 
BgL_arg1140z00_33 = BgL_v1112z00_65; } 
{ /* Llib/music.scm 22 */
obj_t BgL_v1113z00_98;
BgL_v1113z00_98 = 
create_vector(((long)0)); 
BgL_arg1152z00_34 = BgL_v1113z00_98; } 
return ( 
BGl_pulseaudiomusicz00zz__pulseaudio_musicz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)3)), 
CNST_TABLE_REF(((long)4)), BGl_musicbufz00zz__multimediazd2musicbufzd2, ((long)62652), BGl_proc1258z00zz__pulseaudio_musicz00, BGl_proc1257z00zz__pulseaudio_musicz00, BGl_musiczd2initzd2envz00zz__multimediazd2musiczd2, BGl_proc1256z00zz__pulseaudio_musicz00, BFALSE, BgL_arg1140z00_33, BgL_arg1152z00_34), BUNSPEC) ;} } 

}



/* &<@anonymous:1158> */
obj_t BGl_z62zc3z04anonymousza31158ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_252, obj_t BgL_new1097z00_253)
{
{ /* Llib/music.scm 22 */
{ 
BgL_pulseaudiomusicz00_bglt BgL_auxz00_478;
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_onstatez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_onvolumez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_onerrorz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_oneventz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
{ 
BgL_musicstatusz00_bglt BgL_auxz00_495;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_340;
BgL_classz00_340 = BGl_musicstatusz00zz__multimediazd2musiczd2; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1111z00_341;
BgL__ortest_1111z00_341 = 
BGL_CLASS_NIL(BgL_classz00_340); 
if(
CBOOL(BgL__ortest_1111z00_341))
{ /* Llib/music.scm 22 */
BgL_auxz00_495 = 
((BgL_musicstatusz00_bglt)BgL__ortest_1111z00_341)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_495 = 
((BgL_musicstatusz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_340))
; } } } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)BgL_auxz00_495),BUNSPEC); } 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_inbufz00)=((obj_t)BGl_string1259z00zz__pulseaudio_musicz00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_decodersz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_mkthreadz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_timeoutz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52decoderz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52bufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52nextbufferz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52playlistz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52areadyz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52amutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52z12pidz40)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253))))->BgL_z52acondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
{ 
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_544;
{ /* Llib/music.scm 22 */
obj_t BgL_classz00_342;
BgL_classz00_342 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
{ /* Llib/music.scm 22 */
obj_t BgL__ortest_1111z00_343;
BgL__ortest_1111z00_343 = 
BGL_CLASS_NIL(BgL_classz00_342); 
if(
CBOOL(BgL__ortest_1111z00_343))
{ /* Llib/music.scm 22 */
BgL_auxz00_544 = 
((BgL_pulseaudiozd2simplezd2_bglt)BgL__ortest_1111z00_343)
; }  else 
{ /* Llib/music.scm 22 */
BgL_auxz00_544 = 
((BgL_pulseaudiozd2simplezd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_342))
; } } } 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253)))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)BgL_auxz00_544),BUNSPEC); } 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253)))->BgL_namez00)=((obj_t)BGl_string1259z00zz__pulseaudio_musicz00),BUNSPEC); 
BgL_auxz00_478 = 
((BgL_pulseaudiomusicz00_bglt)BgL_new1097z00_253); 
return 
((obj_t)BgL_auxz00_478);} } 

}



/* &lambda1156 */
BgL_pulseaudiomusicz00_bglt BGl_z62lambda1156z62zz__pulseaudio_musicz00(obj_t BgL_envz00_254)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1096z00_344;
BgL_new1096z00_344 = 
((BgL_pulseaudiomusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiomusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1157z00_345;
BgL_arg1157z00_345 = 
BGL_CLASS_INDEX(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1096z00_344), BgL_arg1157z00_345); } 
return BgL_new1096z00_344;} } 

}



/* &lambda1153 */
BgL_pulseaudiomusicz00_bglt BGl_z62lambda1153z62zz__pulseaudio_musicz00(obj_t BgL_envz00_255, obj_t BgL_onstate1076z00_256, obj_t BgL_onvolume1077z00_257, obj_t BgL_onerror1078z00_258, obj_t BgL_onevent1079z00_259, obj_t BgL_z52mutex1080z52_260, obj_t BgL_z52status1081z52_261, obj_t BgL_inbuf1082z00_262, obj_t BgL_decoders1083z00_263, obj_t BgL_mkthread1084z00_264, obj_t BgL_timeout1085z00_265, obj_t BgL_z52decoder1086z52_266, obj_t BgL_z52buffer1087z52_267, obj_t BgL_z52nextbuffer1088z52_268, obj_t BgL_z52playlist1089z52_269, obj_t BgL_z52aready1090z52_270, obj_t BgL_z52amutex1091z52_271, obj_t BgL_z52z12pid1092z40_272, obj_t BgL_z52acondv1093z52_273, obj_t BgL_simple1094z00_274, obj_t BgL_name1095z00_275)
{
{ /* Llib/music.scm 22 */
{ /* Llib/music.scm 22 */
bool_t BgL_z52aready1090z52_356;int BgL_z52z12pid1092z40_358;
BgL_z52aready1090z52_356 = 
CBOOL(BgL_z52aready1090z52_270); 
BgL_z52z12pid1092z40_358 = 
CINT(BgL_z52z12pid1092z40_272); 
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1106z00_362;
{ /* Llib/music.scm 22 */
BgL_pulseaudiomusicz00_bglt BgL_new1105z00_363;
BgL_new1105z00_363 = 
((BgL_pulseaudiomusicz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiomusicz00_bgl) ))); 
{ /* Llib/music.scm 22 */
long BgL_arg1155z00_364;
BgL_arg1155z00_364 = 
BGL_CLASS_INDEX(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_363), BgL_arg1155z00_364); } 
BgL_new1106z00_362 = BgL_new1105z00_363; } 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_onstatez00)=((obj_t)
((obj_t)BgL_onstate1076z00_256)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_onvolumez00)=((obj_t)
((obj_t)BgL_onvolume1077z00_257)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_onerrorz00)=((obj_t)
((obj_t)BgL_onerror1078z00_258)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_oneventz00)=((obj_t)
((obj_t)BgL_onevent1079z00_259)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1080z52_260)),BUNSPEC); 
((((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)BgL_new1106z00_362)))->BgL_z52statusz52)=((BgL_musicstatusz00_bglt)
((BgL_musicstatusz00_bglt)BgL_z52status1081z52_261)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_inbufz00)=((obj_t)
((obj_t)BgL_inbuf1082z00_262)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_decodersz00)=((obj_t)
((obj_t)BgL_decoders1083z00_263)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_mkthreadz00)=((obj_t)
((obj_t)BgL_mkthread1084z00_264)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_timeoutz00)=((obj_t)BgL_timeout1085z00_265),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52decoderz52)=((obj_t)BgL_z52decoder1086z52_266),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52bufferz52)=((obj_t)BgL_z52buffer1087z52_267),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52nextbufferz52)=((obj_t)BgL_z52nextbuffer1088z52_268),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52playlistz52)=((obj_t)
((obj_t)BgL_z52playlist1089z52_269)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52areadyz52)=((bool_t)BgL_z52aready1090z52_356),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52amutexz52)=((obj_t)
((obj_t)BgL_z52amutex1091z52_271)),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52z12pidz40)=((int)BgL_z52z12pid1092z40_358),BUNSPEC); 
((((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)BgL_new1106z00_362)))->BgL_z52acondvz52)=((obj_t)
((obj_t)BgL_z52acondv1093z52_273)),BUNSPEC); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_new1106z00_362))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)
((BgL_pulseaudiozd2simplezd2_bglt)BgL_simple1094z00_274)),BUNSPEC); 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(BgL_new1106z00_362))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1095z00_275)),BUNSPEC); 
{ /* Llib/music.scm 22 */
obj_t BgL_fun1154z00_365;
BgL_fun1154z00_365 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiomusicz00zz__pulseaudio_musicz00); 
PROCEDURE_ENTRY(BgL_fun1154z00_365)(BgL_fun1154z00_365, 
((obj_t)BgL_new1106z00_362), BEOA); } 
return BgL_new1106z00_362;} } } 

}



/* &<@anonymous:1183> */
obj_t BGl_z62zc3z04anonymousza31183ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_276)
{
{ /* Llib/music.scm 22 */
return BGl_string1260z00zz__pulseaudio_musicz00;} 

}



/* &lambda1182 */
obj_t BGl_z62lambda1182z62zz__pulseaudio_musicz00(obj_t BgL_envz00_277, obj_t BgL_oz00_278, obj_t BgL_vz00_279)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_278)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_279)),BUNSPEC);} 

}



/* &lambda1181 */
obj_t BGl_z62lambda1181z62zz__pulseaudio_musicz00(obj_t BgL_envz00_280, obj_t BgL_oz00_281)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_281)))->BgL_namez00);} 

}



/* &<@anonymous:1168> */
obj_t BGl_z62zc3z04anonymousza31168ze3ze5zz__pulseaudio_musicz00(obj_t BgL_envz00_282)
{
{ /* Llib/music.scm 22 */
{ 
BgL_pulseaudiozd2simplezd2_bglt BgL_auxz00_630;
{ /* Llib/music.scm 23 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1108z00_369;
{ /* Llib/music.scm 23 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1107z00_370;
BgL_new1107z00_370 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/music.scm 23 */
long BgL_arg1175z00_371;
BgL_arg1175z00_371 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_370), BgL_arg1175z00_371); } 
BgL_new1108z00_369 = BgL_new1107z00_370; } 
{ 
void * BgL_auxz00_635;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1169z00_372;
{ /* Llib/music.scm 23 */
obj_t BgL_arg1172z00_373;
{ /* Llib/music.scm 23 */
obj_t BgL_classz00_374;
BgL_classz00_374 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_arg1172z00_373 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_374); } 
BgL_arg1169z00_372 = 
VECTOR_REF(BgL_arg1172z00_373,((long)0)); } 
BgL_auxz00_635 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1169z00_372)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_635),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_namez00)=((obj_t)BGl_string1260z00zz__pulseaudio_musicz00),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_ratez00)=((long)((long)44000)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_channelsz00)=((long)((long)2)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_bpsz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1108z00_369))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)5))),BUNSPEC); 
{ /* Llib/music.scm 23 */
obj_t BgL_fun1173z00_375;
BgL_fun1173z00_375 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1173z00_375)(BgL_fun1173z00_375, 
((obj_t)BgL_new1108z00_369), BEOA); } 
BgL_auxz00_630 = BgL_new1108z00_369; } 
return 
((obj_t)BgL_auxz00_630);} } 

}



/* &lambda1167 */
obj_t BGl_z62lambda1167z62zz__pulseaudio_musicz00(obj_t BgL_envz00_283, obj_t BgL_oz00_284, obj_t BgL_vz00_285)
{
{ /* Llib/music.scm 22 */
return 
((((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_284)))->BgL_simplez00)=((BgL_pulseaudiozd2simplezd2_bglt)
((BgL_pulseaudiozd2simplezd2_bglt)BgL_vz00_285)),BUNSPEC);} 

}



/* &lambda1166 */
BgL_pulseaudiozd2simplezd2_bglt BGl_z62lambda1166z62zz__pulseaudio_musicz00(obj_t BgL_envz00_286, obj_t BgL_oz00_287)
{
{ /* Llib/music.scm 22 */
return 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_287)))->BgL_simplez00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closezd2envz00zz__multimediazd2musiczd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1261z00zz__pulseaudio_musicz00, BGl_string1262z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musiczd2closedzf3zd2envzf3zz__multimediazd2musiczd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1263z00zz__pulseaudio_musicz00, BGl_string1264z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2writezd2envz00zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1265z00zz__pulseaudio_musicz00, BGl_string1266z00zz__pulseaudio_musicz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2drainzd2envz00zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1267z00zz__pulseaudio_musicz00, BGl_string1268z00zz__pulseaudio_musicz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicbufzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_pulseaudiomusicz00zz__pulseaudio_musicz00, BGl_proc1269z00zz__pulseaudio_musicz00, BGl_string1270z00zz__pulseaudio_musicz00);} 

}



/* &musicbuf-reset!-puls1123 */
obj_t BGl_z62musicbufzd2resetz12zd2puls1123z70zz__pulseaudio_musicz00(obj_t BgL_envz00_295, obj_t BgL_oz00_296)
{
{ /* Llib/music.scm 61 */
{ /* Llib/music.scm 64 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1201z00_380;
BgL_arg1201z00_380 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_296)))->BgL_simplez00); 
{ /* Llib/music.scm 64 */
int BgL_errz00_381;
BgL_errz00_381 = 
(int)(((long)0)); 
{ /* Llib/music.scm 64 */
pa_simple * BgL_arg1209z00_382;int * BgL_arg1212z00_383;
BgL_arg1209z00_382 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1201z00_380))->BgL_z42builtinz42); 
BgL_arg1212z00_383 = 
&(BgL_errz00_381); 
pa_simple_flush(BgL_arg1209z00_382, BgL_arg1212z00_383); } 
if(
(
(long)(BgL_errz00_381)<((long)0)))
{ /* Llib/music.scm 64 */
char * BgL_arg1217z00_384;
{ /* Llib/music.scm 64 */
int BgL_tmpz00_676;
BgL_tmpz00_676 = 
(int)(((long)0)); 
BgL_arg1217z00_384 = 
pa_strerror(BgL_tmpz00_676); } 
return 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1271z00zz__pulseaudio_musicz00), BgL_arg1217z00_384, 
BINT(((long)0))));}  else 
{ /* Llib/music.scm 64 */
return BFALSE;} } } } 

}



/* &musicbuf-drain-pulse1121 */
obj_t BGl_z62musicbufzd2drainzd2pulse1121z62zz__pulseaudio_musicz00(obj_t BgL_envz00_297, obj_t BgL_oz00_298)
{
{ /* Llib/music.scm 54 */
{ /* Llib/music.scm 56 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1190z00_386;
BgL_arg1190z00_386 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_298)))->BgL_simplez00); 
{ /* Llib/music.scm 56 */
int BgL_errz00_387;
BgL_errz00_387 = 
(int)(((long)0)); 
{ /* Llib/music.scm 56 */
pa_simple * BgL_arg1218z00_388;int * BgL_arg1219z00_389;
BgL_arg1218z00_388 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1190z00_386))->BgL_z42builtinz42); 
BgL_arg1219z00_389 = 
&(BgL_errz00_387); 
pa_simple_drain(BgL_arg1218z00_388, BgL_arg1219z00_389); } 
if(
(
(long)(BgL_errz00_387)<((long)0)))
{ /* Llib/music.scm 56 */
char * BgL_arg1221z00_390;
{ /* Llib/music.scm 56 */
int BgL_tmpz00_692;
BgL_tmpz00_692 = 
(int)(((long)0)); 
BgL_arg1221z00_390 = 
pa_strerror(BgL_tmpz00_692); } 
return 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1272z00zz__pulseaudio_musicz00), BgL_arg1221z00_390, 
BINT(((long)0))));}  else 
{ /* Llib/music.scm 56 */
return BFALSE;} } } } 

}



/* &musicbuf-write-pulse1119 */
obj_t BGl_z62musicbufzd2writezd2pulse1119z62zz__pulseaudio_musicz00(obj_t BgL_envz00_299, obj_t BgL_oz00_300, obj_t BgL_outbufz00_301, obj_t BgL_siza7eza7_302)
{
{ /* Llib/music.scm 47 */
{ /* Llib/music.scm 49 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1189z00_392;
BgL_arg1189z00_392 = 
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_300)))->BgL_simplez00); 
{ /* Llib/music.scm 49 */
long BgL_siza7eza7_393;
BgL_siza7eza7_393 = 
(long)CINT(BgL_siza7eza7_302); 
{ /* Llib/music.scm 49 */
int BgL_errz00_394;
BgL_errz00_394 = 
(int)(((long)0)); 
{ /* Llib/music.scm 49 */
pa_simple * BgL_arg1222z00_395;int * BgL_arg1227z00_396;
BgL_arg1222z00_395 = 
(((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_arg1189z00_392))->BgL_z42builtinz42); 
BgL_arg1227z00_396 = 
&(BgL_errz00_394); 
{ /* Llib/music.scm 49 */
char * BgL_tmpz00_705;
BgL_tmpz00_705 = 
BSTRING_TO_STRING(
((obj_t)BgL_outbufz00_301)); 
pa_simple_write(BgL_arg1222z00_395, BgL_tmpz00_705, BgL_siza7eza7_393, BgL_arg1227z00_396); } } 
if(
(
(long)(BgL_errz00_394)<((long)0)))
{ /* Llib/music.scm 49 */
char * BgL_arg1230z00_397;
{ /* Llib/music.scm 49 */
int BgL_tmpz00_712;
BgL_tmpz00_712 = 
(int)(((long)0)); 
BgL_arg1230z00_397 = 
pa_strerror(BgL_tmpz00_712); } 
BINT(
bgl_pulseaudio_error(
BSTRING_TO_STRING(BGl_string1273z00zz__pulseaudio_musicz00), BgL_arg1230z00_397, 
BINT(((long)0)))); }  else 
{ /* Llib/music.scm 49 */BFALSE; } 
return 
BINT(BgL_siza7eza7_393);} } } } 

}



/* &music-closed?-pulsea1117 */
obj_t BGl_z62musiczd2closedzf3zd2pulsea1117z91zz__pulseaudio_musicz00(obj_t BgL_envz00_303, obj_t BgL_oz00_304)
{
{ /* Llib/music.scm 39 */
{ /* Llib/music.scm 40 */
bool_t BgL_tmpz00_720;
{ /* Llib/music.scm 41 */
obj_t BgL_mutex1186z00_399;
BgL_mutex1186z00_399 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_304))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 41 */
obj_t BgL_top1327z00_725;
BgL_top1327z00_725 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1186z00_399); 
BGL_EXITD_PUSH_PROTECT(BgL_top1327z00_725, BgL_mutex1186z00_399); BUNSPEC; 
{ /* Llib/music.scm 41 */
bool_t BgL_tmp1326z00_724;
{ /* Llib/music.scm 42 */
obj_t BgL_arg1187z00_400;
BgL_arg1187z00_400 = 
BGl_pulseaudiozd2simplezd2statez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_304)))->BgL_simplez00)); 
BgL_tmp1326z00_724 = 
(BgL_arg1187z00_400==
CNST_TABLE_REF(((long)6))); } 
BGL_EXITD_POP_PROTECT(BgL_top1327z00_725); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1186z00_399); 
BgL_tmpz00_720 = BgL_tmp1326z00_724; } } } 
return 
BBOOL(BgL_tmpz00_720);} } 

}



/* &music-close-pulseaud1115 */
obj_t BGl_z62musiczd2closezd2pulseaud1115z62zz__pulseaudio_musicz00(obj_t BgL_envz00_305, obj_t BgL_oz00_306)
{
{ /* Llib/music.scm 31 */
{ /* Llib/music.scm 33 */
obj_t BgL_mutex1184z00_402;
BgL_mutex1184z00_402 = 
(((BgL_musicbufz00_bglt)COBJECT(
((BgL_musicbufz00_bglt)
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_306))))->BgL_z52amutexz52); 
{ /* Llib/music.scm 33 */
obj_t BgL_top1329z00_741;
BgL_top1329z00_741 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1184z00_402); 
BGL_EXITD_PUSH_PROTECT(BgL_top1329z00_741, BgL_mutex1184z00_402); BUNSPEC; 
{ /* Llib/music.scm 33 */
obj_t BgL_tmp1328z00_740;
BgL_tmp1328z00_740 = 
BGl_pulseaudiozd2simplezd2closez00zz__pulseaudio_simplez00(
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)BgL_oz00_306)))->BgL_simplez00)); 
BGL_EXITD_POP_PROTECT(BgL_top1329z00_741); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1184z00_402); 
return BgL_tmp1328z00_740;} } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__pulseaudio_musicz00()
{
{ /* Llib/music.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)117276091), 
BSTRING_TO_STRING(BGl_string1274z00zz__pulseaudio_musicz00)); 
return 
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)129098468), 
BSTRING_TO_STRING(BGl_string1274z00zz__pulseaudio_musicz00));} 

}

#ifdef __cplusplus
}
#endif
