/*===========================================================================*/
/*   (Llib/wav_alsadec.scm)                                                  */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -safee -unsafe -srfi wav -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/wav_alsadec.scm -o objs/wav_alsadec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <alsa/asoundlib.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_alsamusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_alsazd2sndzd2pcmz00_bgl * BgL_pcmz00;
} *BgL_alsamusicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_alsazd2sndzd2pcmz00_bgl {
   header_t header;
   obj_t widening;
   snd_pcm_t * BgL_z42builtinz42;
   obj_t BgL_namez00;
   obj_t BgL_devicez00;
   obj_t BgL_streamz00;
   obj_t BgL_modez00;
   int BgL_hwbpsz00;
   int BgL_hwsratez00;
} *BgL_alsazd2sndzd2pcmz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;

typedef struct BgL_wavzd2alsadecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavzd2alsadecoderzd2_bglt;


static obj_t BGl_requirezd2initializa7ationz75zz__wav_alsadecz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__wav_alsadecz00();
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
static obj_t BGl_genericzd2initzd2zz__wav_alsadecz00();
static obj_t BGl_objectzd2initzd2zz__wav_alsadecz00();
static obj_t BGl_z62zc3z04anonymousza31128ze3ze5zz__wav_alsadecz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__wav_alsadecz00();
static BgL_wavzd2alsadecoderzd2_bglt BGl_z62lambda1123z62zz__wav_alsadecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_wavzd2alsadecoderzd2_bglt BGl_z62lambda1126z62zz__wav_alsadecz00(obj_t);
static obj_t BGl_z62musicdecoderzd2hwparam1113zb0zz__wav_alsadecz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_alsadecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_alsazd2sndzd2pcmz00_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00 = BUNSPEC;
static obj_t BGl_cnstzd2initzd2zz__wav_alsadecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_alsadecz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_alsadecz00();
static obj_t BGl_gczd2rootszd2initz00zz__wav_alsadecz00();
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00;
static obj_t __cnst[ 15 ] ;


DEFINE_STRING( BGl_string1182z00zz__wav_alsadecz00, BgL_bgl_string1182za700za7za7_1196za7, "Llib/wav_alsadec.scm", 20 );
DEFINE_STRING( BGl_string1186z00zz__wav_alsadecz00, BgL_bgl_string1186za700za7za7_1197za7, "", 0 );
DEFINE_STRING( BGl_string1188z00zz__wav_alsadecz00, BgL_bgl_string1188za700za7za7_1198za7, "musicdecoder-hwparams-set!", 26 );
DEFINE_STRING( BGl_string1189z00zz__wav_alsadecz00, BgL_bgl_string1189za700za7za7_1199za7, "__wav_alsadec", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1183z00zz__wav_alsadecz00, BgL_bgl_za762za7c3za704anonymo1200za7, BGl_z62zc3z04anonymousza31128ze3ze5zz__wav_alsadecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1190z00zz__wav_alsadecz00, BgL_bgl_string1190za700za7za7_1201za7, ":start-threshold :avail-min :access rw-interleaved :format :channels :rate-near :buffer-size-near-ratio :period-size-near-ratio s32 s24-3le s16 u8 __wav_alsadec wav-alsadecoder ", 177 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1184z00zz__wav_alsadecz00, BgL_bgl_za762lambda1126za7621202z00, BGl_z62lambda1126z62zz__wav_alsadecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1185z00zz__wav_alsadecz00, BgL_bgl_za762lambda1123za7621203z00, BGl_z62lambda1123z62zz__wav_alsadecz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1187z00zz__wav_alsadecz00, BgL_bgl_za762musicdecoderza71204z00, BGl_z62musicdecoderzd2hwparam1113zb0zz__wav_alsadecz00, 0L, BUNSPEC, 3 );
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_alsadecz00) );
ADD_ROOT( (void *)(&BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_alsadecz00(long BgL_checksumz00_187, char * BgL_fromz00_188)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_alsadecz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_alsadecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_alsadecz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_alsadecz00(); 
BGl_cnstzd2initzd2zz__wav_alsadecz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_alsadecz00(); 
BGl_objectzd2initzd2zz__wav_alsadecz00(); 
BGl_methodzd2initzd2zz__wav_alsadecz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_alsadecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__alsa_pcmz00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_alsadec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_alsadec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_cportz00_127;
{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_stringz00_135;
BgL_stringz00_135 = BGl_string1190z00zz__wav_alsadecz00; 
{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_startz00_136;
BgL_startz00_136 = 
BINT(((long)0)); 
{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_endz00_137;
BgL_endz00_137 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_135))); 
{ /* Llib/wav_alsadec.scm 15 */

BgL_cportz00_127 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_135, BgL_startz00_136, BgL_endz00_137); } } } } 
{ 
long BgL_iz00_128;
BgL_iz00_128 = ((long)14); 
BgL_loopz00_129:
if(
(BgL_iz00_128==((long)-1)))
{ /* Llib/wav_alsadec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_alsadec.scm 15 */
{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_arg1195z00_131;
{ /* Llib/wav_alsadec.scm 15 */

{ /* Llib/wav_alsadec.scm 15 */
obj_t BgL_locationz00_133;
BgL_locationz00_133 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_alsadec.scm 15 */

BgL_arg1195z00_131 = 
BGl_readz00zz__readerz00(BgL_cportz00_127, BgL_locationz00_133); } } } 
{ /* Llib/wav_alsadec.scm 15 */
int BgL_tmpz00_217;
BgL_tmpz00_217 = 
(int)(BgL_iz00_128); 
CNST_TABLE_SET(BgL_tmpz00_217, BgL_arg1195z00_131); } } 
{ /* Llib/wav_alsadec.scm 15 */
int BgL_auxz00_134;
BgL_auxz00_134 = 
(int)(
(BgL_iz00_128-((long)1))); 
{ 
long BgL_iz00_222;
BgL_iz00_222 = 
(long)(BgL_auxz00_134); 
BgL_iz00_128 = BgL_iz00_222; 
goto BgL_loopz00_129;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1182z00zz__wav_alsadecz00)); 
BGl_modulezd2initializa7ationz75zz__alsa_alsaz00(((long)0), 
BSTRING_TO_STRING(BGl_string1182z00zz__wav_alsadecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
{ /* Llib/wav_alsadec.scm 28 */
obj_t BgL_arg1121z00_17;obj_t BgL_arg1122z00_18;
{ /* Llib/wav_alsadec.scm 28 */
obj_t BgL_v1110z00_44;
BgL_v1110z00_44 = 
create_vector(((long)0)); 
BgL_arg1121z00_17 = BgL_v1110z00_44; } 
{ /* Llib/wav_alsadec.scm 28 */
obj_t BgL_v1111z00_45;
BgL_v1111z00_45 = 
create_vector(((long)0)); 
BgL_arg1122z00_18 = BgL_v1111z00_45; } 
return ( 
BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_wavmusicdecoderz00zz__wav_decoderz00, ((long)30116), BGl_proc1185z00zz__wav_alsadecz00, BGl_proc1184z00zz__wav_alsadecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1183z00zz__wav_alsadecz00, BFALSE, BgL_arg1121z00_17, BgL_arg1122z00_18), BUNSPEC) ;} } 

}



/* &<@anonymous:1128> */
obj_t BGl_z62zc3z04anonymousza31128ze3ze5zz__wav_alsadecz00(obj_t BgL_envz00_97, obj_t BgL_new1102z00_98)
{
{ /* Llib/wav_alsadec.scm 28 */
{ 
BgL_wavzd2alsadecoderzd2_bglt BgL_auxz00_234;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_outbufz00)=((obj_t)BGl_string1186z00zz__wav_alsadecz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98))))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_234 = 
((BgL_wavzd2alsadecoderzd2_bglt)BgL_new1102z00_98); 
return 
((obj_t)BgL_auxz00_234);} } 

}



/* &lambda1126 */
BgL_wavzd2alsadecoderzd2_bglt BGl_z62lambda1126z62zz__wav_alsadecz00(obj_t BgL_envz00_99)
{
{ /* Llib/wav_alsadec.scm 28 */
{ /* Llib/wav_alsadec.scm 28 */
BgL_wavzd2alsadecoderzd2_bglt BgL_new1101z00_140;
BgL_new1101z00_140 = 
((BgL_wavzd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2alsadecoderzd2_bgl) ))); 
{ /* Llib/wav_alsadec.scm 28 */
long BgL_arg1127z00_141;
BgL_arg1127z00_141 = 
BGL_CLASS_INDEX(BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1101z00_140), BgL_arg1127z00_141); } 
return BgL_new1101z00_140;} } 

}



/* &lambda1123 */
BgL_wavzd2alsadecoderzd2_bglt BGl_z62lambda1123z62zz__wav_alsadecz00(obj_t BgL_envz00_100, obj_t BgL_mimetypes1086z00_101, obj_t BgL_bufferzd2timezd2near1087z00_102, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1088z75_103, obj_t BgL_periodzd2siza7ezd2nearzd2rat1089z75_104, obj_t BgL_z52z12dpause1090z40_105, obj_t BgL_z52z12dabort1091z40_106, obj_t BgL_z52z12stop1092z40_107, obj_t BgL_z52dmutex1093z52_108, obj_t BgL_z52dcondv1094z52_109, obj_t BgL_z52doutcondv1095z52_110, obj_t BgL_outbuf1096z00_111, obj_t BgL_z52header1097z52_112, obj_t BgL_z52cursor1098z52_113, obj_t BgL_z52siza7e1099zf5_114, obj_t BgL_z52position1100z52_115)
{
{ /* Llib/wav_alsadec.scm 28 */
{ /* Llib/wav_alsadec.scm 28 */
int BgL_bufferzd2timezd2near1087z00_143;int BgL_bufferzd2siza7ezd2nearzd2rat1088z75_144;int BgL_periodzd2siza7ezd2nearzd2rat1089z75_145;bool_t BgL_z52z12dpause1090z40_146;bool_t BgL_z52z12dabort1091z40_147;bool_t BgL_z52z12stop1092z40_148;int BgL_z52cursor1098z52_153;int BgL_z52siza7e1099zf5_154;int BgL_z52position1100z52_155;
BgL_bufferzd2timezd2near1087z00_143 = 
CINT(BgL_bufferzd2timezd2near1087z00_102); 
BgL_bufferzd2siza7ezd2nearzd2rat1088z75_144 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1088z75_103); 
BgL_periodzd2siza7ezd2nearzd2rat1089z75_145 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1089z75_104); 
BgL_z52z12dpause1090z40_146 = 
CBOOL(BgL_z52z12dpause1090z40_105); 
BgL_z52z12dabort1091z40_147 = 
CBOOL(BgL_z52z12dabort1091z40_106); 
BgL_z52z12stop1092z40_148 = 
CBOOL(BgL_z52z12stop1092z40_107); 
BgL_z52cursor1098z52_153 = 
CINT(BgL_z52cursor1098z52_113); 
BgL_z52siza7e1099zf5_154 = 
CINT(BgL_z52siza7e1099zf5_114); 
BgL_z52position1100z52_155 = 
CINT(BgL_z52position1100z52_115); 
{ /* Llib/wav_alsadec.scm 28 */
BgL_wavzd2alsadecoderzd2_bglt BgL_new1109z00_156;
{ /* Llib/wav_alsadec.scm 28 */
BgL_wavzd2alsadecoderzd2_bglt BgL_new1108z00_157;
BgL_new1108z00_157 = 
((BgL_wavzd2alsadecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2alsadecoderzd2_bgl) ))); 
{ /* Llib/wav_alsadec.scm 28 */
long BgL_arg1125z00_158;
BgL_arg1125z00_158 = 
BGL_CLASS_INDEX(BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1108z00_157), BgL_arg1125z00_158); } 
BgL_new1109z00_156 = BgL_new1108z00_157; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1086z00_101)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1087z00_143),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1088z75_144),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1089z75_145),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1090z40_146),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1091z40_147),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1092z40_148),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1093z52_108)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1094z52_109)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1095z52_110)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1096z00_111)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52headerz52)=((obj_t)BgL_z52header1097z52_112),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52cursorz52)=((int)BgL_z52cursor1098z52_153),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1099zf5_154),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1109z00_156)))->BgL_z52positionz52)=((int)BgL_z52position1100z52_155),BUNSPEC); 
{ /* Llib/wav_alsadec.scm 28 */
obj_t BgL_fun1124z00_159;
BgL_fun1124z00_159 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00); 
PROCEDURE_ENTRY(BgL_fun1124z00_159)(BgL_fun1124z00_159, 
((obj_t)BgL_new1109z00_156), BEOA); } 
return BgL_new1109z00_156;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavzd2alsadecoderzd2zz__wav_alsadecz00, BGl_proc1187z00zz__wav_alsadecz00, BGl_string1188z00zz__wav_alsadecz00);} 

}



/* &musicdecoder-hwparam1113 */
obj_t BGl_z62musicdecoderzd2hwparam1113zb0zz__wav_alsadecz00(obj_t BgL_envz00_119, obj_t BgL_decz00_120, obj_t BgL_amz00_121, obj_t BgL_bufferz00_122)
{
{ /* Llib/wav_alsadec.scm 40 */
{ /* Llib/wav_alsadec.scm 46 */
BgL_wavinfoz00_bglt BgL_i1105z00_163;
BgL_i1105z00_163 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_decz00_120))))->BgL_z52headerz52)); 
{ /* Llib/wav_alsadec.scm 47 */
obj_t BgL_encodingz00_164;
switch( 
(long)(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1105z00_163)))->BgL_bpsz00))) { case ((long)8) : 

BgL_encodingz00_164 = 
CNST_TABLE_REF(((long)2)); break;case ((long)16) : 

BgL_encodingz00_164 = 
CNST_TABLE_REF(((long)3)); break;case ((long)24) : 

BgL_encodingz00_164 = 
CNST_TABLE_REF(((long)4)); break;case ((long)32) : 

BgL_encodingz00_164 = 
CNST_TABLE_REF(((long)5)); break;
default: 
BgL_encodingz00_164 = BUNSPEC; } 
{ /* Llib/wav_alsadec.scm 52 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1130z00_165;int BgL_arg1132z00_166;long BgL_arg1134z00_167;int BgL_arg1135z00_168;int BgL_arg1137z00_169;
BgL_arg1130z00_165 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)
((BgL_musicz00_bglt)BgL_amz00_121))))->BgL_pcmz00); 
BgL_arg1132z00_166 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1105z00_163)))->BgL_channelsz00); 
BgL_arg1134z00_167 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1105z00_163)))->BgL_sampleratez00); 
BgL_arg1135z00_168 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_decz00_120))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75); 
BgL_arg1137z00_169 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2alsadecoderzd2_bglt)BgL_decz00_120))))->BgL_periodzd2siza7ezd2nearzd2ratioz75); 
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_list1138z00_170;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1140z00_171;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1152z00_172;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1153z00_173;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1155z00_174;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1156z00_175;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1157z00_176;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1158z00_177;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1159z00_178;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1160z00_179;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1161z00_180;
{ /* Llib/wav_alsadec.scm 52 */
obj_t BgL_arg1165z00_181;
BgL_arg1165z00_181 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1137z00_169), BNIL); 
BgL_arg1161z00_180 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BgL_arg1165z00_181); } 
BgL_arg1160z00_179 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1135z00_168), BgL_arg1161z00_180); } 
BgL_arg1159z00_178 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BgL_arg1160z00_179); } 
BgL_arg1158z00_177 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1134z00_167), BgL_arg1159z00_178); } 
BgL_arg1157z00_176 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BgL_arg1158z00_177); } 
BgL_arg1156z00_175 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1132z00_166), BgL_arg1157z00_176); } 
BgL_arg1155z00_174 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BgL_arg1156z00_175); } 
BgL_arg1153z00_173 = 
MAKE_YOUNG_PAIR(BgL_encodingz00_164, BgL_arg1155z00_174); } 
BgL_arg1152z00_172 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BgL_arg1153z00_173); } 
BgL_arg1140z00_171 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BgL_arg1152z00_172); } 
BgL_list1138z00_170 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BgL_arg1140z00_171); } 
BGl_alsazd2sndzd2pcmzd2hwzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1130z00_165, BgL_list1138z00_170); } } 
{ /* Llib/wav_alsadec.scm 59 */
BgL_alsazd2sndzd2pcmz00_bglt BgL_arg1168z00_182;
BgL_arg1168z00_182 = 
(((BgL_alsamusicz00_bglt)COBJECT(
((BgL_alsamusicz00_bglt)
((BgL_musicz00_bglt)BgL_amz00_121))))->BgL_pcmz00); 
{ /* Llib/wav_alsadec.scm 59 */
obj_t BgL_list1169z00_183;
{ /* Llib/wav_alsadec.scm 59 */
obj_t BgL_arg1172z00_184;
{ /* Llib/wav_alsadec.scm 59 */
obj_t BgL_arg1173z00_185;
{ /* Llib/wav_alsadec.scm 59 */
obj_t BgL_arg1175z00_186;
BgL_arg1175z00_186 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BNIL); 
BgL_arg1173z00_185 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BgL_arg1175z00_186); } 
BgL_arg1172z00_184 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1173z00_185); } 
BgL_list1169z00_183 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BgL_arg1172z00_184); } 
return 
BGl_alsazd2sndzd2pcmzd2swzd2setzd2paramsz12zc0zz__alsa_pcmz00(BgL_arg1168z00_182, BgL_list1169z00_183);} } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_alsadecz00()
{
{ /* Llib/wav_alsadec.scm 15 */
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string1189z00zz__wav_alsadecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__wav_decoderz00(((long)0), 
BSTRING_TO_STRING(BGl_string1189z00zz__wav_alsadecz00));} 

}

#ifdef __cplusplus
}
#endif
