/*===========================================================================*/
/*   (Llib/wav_decoder.scm)                                                  */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -safee -unsafe -srfi wav -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/wav_decoder.scm -o objs/wav_decoder.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musicbufferz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_urlz00;
   bool_t BgL_z52eofz52;
   obj_t BgL_z52bcondvz52;
   obj_t BgL_z52bmutexz52;
   long BgL_z52inlenz52;
   char * BgL_z52inbufpz52;
   long BgL_z52headz52;
   long BgL_z52tailz52;
   bool_t BgL_z52emptyz52;
} *BgL_musicbufferz00_bglt;

typedef struct BgL_musicbufz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
} *BgL_musicbufz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;


static obj_t BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
static long BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00;
static obj_t BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = BUNSPEC;
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00();
BGL_IMPORT obj_t BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, obj_t, int, int);
BGL_IMPORT obj_t BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__wav_decoderz00();
static obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_musicbufz00_bglt, obj_t, long);
static obj_t BGl_objectzd2initzd2zz__wav_decoderz00();
static obj_t BGl_z62zc3z04anonymousza31223ze3ze5zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31240ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_debugz00zz__wav_decoderz00(obj_t);
static long BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31331ze3ze5zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt, BgL_musicbufz00_bglt, BgL_musicbufferz00_bglt, int, int);
static obj_t BGl_methodzd2initzd2zz__wav_decoderz00();
BGL_IMPORT obj_t BGl_musicdecoderz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t);
static int BGl_wavzd2debugzd2zz__wav_decoderz00();
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_z62zc3z04anonymousza31342ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt, long, BgL_musicbufferz00_bglt, obj_t, long);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long, BgL_musicbufferz00_bglt);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62zc3z04anonymousza31515ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_IMPORT obj_t BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31533ze3ze5zz__wav_decoderz00(obj_t);
static long BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1320z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static BgL_wavmusicdecoderz00_bglt BGl_z62lambda1324z62zz__wav_decoderz00(obj_t);
BGL_IMPORT int bgl_debug();
static obj_t BGl_z62lambda1340z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1341z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__wav_decoderz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00();
static obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00();
static obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00();
static obj_t BGl_z62lambda1513z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1514z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31359ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_z62lambda1357z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1358z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicbufferz00_bglt);
static obj_t BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31392ze3ze5zz__wav_decoderz00(obj_t);
static obj_t BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt);
static obj_t BGl_z62lambda1531z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1532z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
static obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t);
static obj_t BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00(obj_t, obj_t, obj_t, obj_t);
extern long BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00();
static long BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00;
static obj_t BGl_z62lambda1390z62zz__wav_decoderz00(obj_t, obj_t);
static obj_t BGl_z62lambda1391z62zz__wav_decoderz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(BgL_musicdecoderz00_bglt, BgL_musicz00_bglt, BgL_musicbufferz00_bglt);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_wavzd2parsezd2headerz00zz__wav_wavz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00 = BUNSPEC;
static obj_t BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BUNSPEC;
static bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt, BgL_wavmusicdecoderz00_bglt, int);
BGL_IMPORT obj_t BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31221ze3ze70z60zz__wav_decoderz00(int, BgL_wavmusicdecoderz00_bglt, BgL_musicbufferz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_musicbufferz00_bglt, int, int);
static obj_t __cnst[ 23 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STRING( BGl_string1916z00zz__wav_decoderz00, BgL_bgl_string1916za700za7za7_1980za7, "Llib/wav_decoder.scm", 20 );
DEFINE_STRING( BGl_string1917z00zz__wav_decoderz00, BgL_bgl_string1917za700za7za7_1981za7, "wav-decode", 10 );
DEFINE_STRING( BGl_string1918z00zz__wav_decoderz00, BgL_bgl_string1918za700za7za7_1982za7, "Cannot play none PCM wav format", 31 );
DEFINE_STRING( BGl_string1919z00zz__wav_decoderz00, BgL_bgl_string1919za700za7za7_1983za7, "/tmp/WAV.log", 12 );
BGL_IMPORT obj_t BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1920z00zz__wav_decoderz00, BgL_bgl_string1920za700za7za7_1984za7, "\n", 1 );
DEFINE_STRING( BGl_string1921z00zz__wav_decoderz00, BgL_bgl_string1921za700za7za7_1985za7, " ", 1 );
DEFINE_STRING( BGl_string1922z00zz__wav_decoderz00, BgL_bgl_string1922za700za7za7_1986za7, ">>> WAV_DECODER init ", 21 );
DEFINE_STRING( BGl_string1923z00zz__wav_decoderz00, BgL_bgl_string1923za700za7za7_1987za7, ">>> WAV_DECODER stop ", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1924z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo1988za7, BGl_z62zc3z04anonymousza31342ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1925z00zz__wav_decoderz00, BgL_bgl_za762lambda1341za7621989z00, BGl_z62lambda1341z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1926z00zz__wav_decoderz00, BgL_bgl_za762lambda1340za7621990z00, BGl_z62lambda1340z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1927z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo1991za7, BGl_z62zc3z04anonymousza31359ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1928z00zz__wav_decoderz00, BgL_bgl_za762lambda1358za7621992z00, BGl_z62lambda1358z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1929z00zz__wav_decoderz00, BgL_bgl_za762lambda1357za7621993z00, BGl_z62lambda1357z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1930z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo1994za7, BGl_z62zc3z04anonymousza31392ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1931z00zz__wav_decoderz00, BgL_bgl_za762lambda1391za7621995z00, BGl_z62lambda1391z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1932z00zz__wav_decoderz00, BgL_bgl_za762lambda1390za7621996z00, BGl_z62lambda1390z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1933z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo1997za7, BGl_z62zc3z04anonymousza31515ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1934z00zz__wav_decoderz00, BgL_bgl_za762lambda1514za7621998z00, BGl_z62lambda1514z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1935z00zz__wav_decoderz00, BgL_bgl_za762lambda1513za7621999z00, BGl_z62lambda1513z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1942z00zz__wav_decoderz00, BgL_bgl_string1942za700za7za7_2000za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1936z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2001za7, BGl_z62zc3z04anonymousza31533ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1937z00zz__wav_decoderz00, BgL_bgl_za762lambda1532za7622002z00, BGl_z62lambda1532z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1944z00zz__wav_decoderz00, BgL_bgl_string1944za700za7za7_2003za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1938z00zz__wav_decoderz00, BgL_bgl_za762lambda1531za7622004z00, BGl_z62lambda1531z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__wav_decoderz00, BgL_bgl_za762za7c3za704anonymo2005za7, BGl_z62zc3z04anonymousza31331ze3ze5zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1946z00zz__wav_decoderz00, BgL_bgl_string1946za700za7za7_2006za7, "musicdecoder-init", 17 );
DEFINE_STRING( BGl_string1948z00zz__wav_decoderz00, BgL_bgl_string1948za700za7za7_2007za7, "musicdecoder-reset!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1940z00zz__wav_decoderz00, BgL_bgl_za762lambda1324za7622008z00, BGl_z62lambda1324z62zz__wav_decoderz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1941z00zz__wav_decoderz00, BgL_bgl_za762lambda1320za7622009z00, BGl_z62lambda1320z62zz__wav_decoderz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1943z00zz__wav_decoderz00, BgL_bgl_za762objectza7d2prin2010z00, BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1950z00zz__wav_decoderz00, BgL_bgl_string1950za700za7za7_2011za7, "musicdecoder-position", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1945z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72012z00, BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1952z00zz__wav_decoderz00, BgL_bgl_string1952za700za7za7_2013za7, "musicdecoder-decode", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1947z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72014z00, BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1954z00zz__wav_decoderz00, BgL_bgl_string1954za700za7za7_2015za7, "musicdecoder-volume-set!", 24 );
DEFINE_STRING( BGl_string1955z00zz__wav_decoderz00, BgL_bgl_string1955za700za7za7_2016za7, "~~~ WAV_DECODER, EOF ", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1949z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72017z00, BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1956z00zz__wav_decoderz00, BgL_bgl_string1956za700za7za7_2018za7, "...", 3 );
DEFINE_STRING( BGl_string1957z00zz__wav_decoderz00, BgL_bgl_string1957za700za7za7_2019za7, "<-- WAV_DECODER, wait not-empty ", 32 );
DEFINE_STRING( BGl_string1958z00zz__wav_decoderz00, BgL_bgl_string1958za700za7za7_2020za7, " -> status=", 11 );
DEFINE_STRING( BGl_string1959z00zz__wav_decoderz00, BgL_bgl_string1959za700za7za7_2021za7, " hd=", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1951z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72022z00, BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1953z00zz__wav_decoderz00, BgL_bgl_za762musicdecoderza72023z00, BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1960z00zz__wav_decoderz00, BgL_bgl_string1960za700za7za7_2024za7, " tl=", 4 );
DEFINE_STRING( BGl_string1961z00zz__wav_decoderz00, BgL_bgl_string1961za700za7za7_2025za7, "~~~ WAV_DECODER, s=", 19 );
DEFINE_STRING( BGl_string1962z00zz__wav_decoderz00, BgL_bgl_string1962za700za7za7_2026za7, " size=", 6 );
DEFINE_STRING( BGl_string1963z00zz__wav_decoderz00, BgL_bgl_string1963za700za7za7_2027za7, "~~~ WAV_DECODER, OK s=", 22 );
DEFINE_STRING( BGl_string1964z00zz__wav_decoderz00, BgL_bgl_string1964za700za7za7_2028za7, " tail=", 6 );
DEFINE_STRING( BGl_string1965z00zz__wav_decoderz00, BgL_bgl_string1965za700za7za7_2029za7, " %empty=", 8 );
DEFINE_STRING( BGl_string1966z00zz__wav_decoderz00, BgL_bgl_string1966za700za7za7_2030za7, "~~~ WAV_DECODER, NEED-MORE s=", 29 );
DEFINE_STRING( BGl_string1967z00zz__wav_decoderz00, BgL_bgl_string1967za700za7za7_2031za7, "wav decoding error", 18 );
DEFINE_STRING( BGl_string1968z00zz__wav_decoderz00, BgL_bgl_string1968za700za7za7_2032za7, "\033[0m\033[1;33m", 11 );
DEFINE_STRING( BGl_string1969z00zz__wav_decoderz00, BgL_bgl_string1969za700za7za7_2033za7, "\033[0m\033[1;32m", 11 );
DEFINE_STRING( BGl_string1970z00zz__wav_decoderz00, BgL_bgl_string1970za700za7za7_2034za7, " EOF", 4 );
DEFINE_STRING( BGl_string1971z00zz__wav_decoderz00, BgL_bgl_string1971za700za7za7_2035za7, " url=", 5 );
DEFINE_STRING( BGl_string1972z00zz__wav_decoderz00, BgL_bgl_string1972za700za7za7_2036za7, "%\033[0m", 5 );
DEFINE_STRING( BGl_string1973z00zz__wav_decoderz00, BgL_bgl_string1973za700za7za7_2037za7, "--- WAV_DECODER, buffer fill: ", 30 );
DEFINE_STRING( BGl_string1974z00zz__wav_decoderz00, BgL_bgl_string1974za700za7za7_2038za7, "--> WAV_DECODER, broadcast not-full ", 36 );
DEFINE_STRING( BGl_string1975z00zz__wav_decoderz00, BgL_bgl_string1975za700za7za7_2039za7, "#|wavmusicdecoder|", 18 );
DEFINE_STRING( BGl_string1976z00zz__wav_decoderz00, BgL_bgl_string1976za700za7za7_2040za7, "__wav_decoder", 13 );
DEFINE_STRING( BGl_string1977z00zz__wav_decoderz00, BgL_bgl_string1977za700za7za7_2041za7, "(\"audio/wav\" \"audio/x-wav\" \"audio/x-pn-windows-acm\") error buffering ended stop play pause __wav_decoder wavmusicdecoder %position %size int %cursor obj %header bstring outbuf pcm unknown-status ok need-more done new-format ", 224 );
BGL_IMPORT obj_t BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_wavmusicdecoderz00zz__wav_decoderz00) );
ADD_ROOT( (void *)(&BGl_za2debugzd2portza2zd2zz__wav_decoderz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long BgL_checksumz00_901, char * BgL_fromz00_902)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_decoderz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_decoderz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_decoderz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_cnstzd2initzd2zz__wav_decoderz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_decoderz00(); 
BGl_objectzd2initzd2zz__wav_decoderz00(); 
BGl_methodzd2initzd2zz__wav_decoderz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_decoderz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__wav_decoder"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__wav_decoder"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_cportz00_772;
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_stringz00_780;
BgL_stringz00_780 = BGl_string1977z00zz__wav_decoderz00; 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_startz00_781;
BgL_startz00_781 = 
BINT(((long)0)); 
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_endz00_782;
BgL_endz00_782 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_780))); 
{ /* Llib/wav_decoder.scm 15 */

BgL_cportz00_772 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_780, BgL_startz00_781, BgL_endz00_782); } } } } 
{ 
long BgL_iz00_773;
BgL_iz00_773 = ((long)22); 
BgL_loopz00_774:
if(
(BgL_iz00_773==((long)-1)))
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_arg1979z00_776;
{ /* Llib/wav_decoder.scm 15 */

{ /* Llib/wav_decoder.scm 15 */
obj_t BgL_locationz00_778;
BgL_locationz00_778 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_decoder.scm 15 */

BgL_arg1979z00_776 = 
BGl_readz00zz__readerz00(BgL_cportz00_772, BgL_locationz00_778); } } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_tmpz00_938;
BgL_tmpz00_938 = 
(int)(BgL_iz00_773); 
CNST_TABLE_SET(BgL_tmpz00_938, BgL_arg1979z00_776); } } 
{ /* Llib/wav_decoder.scm 15 */
int BgL_auxz00_779;
BgL_auxz00_779 = 
(int)(
(BgL_iz00_773-((long)1))); 
{ 
long BgL_iz00_943;
BgL_iz00_943 = 
(long)(BgL_auxz00_779); 
BgL_iz00_773 = BgL_iz00_943; 
goto BgL_loopz00_774;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1916z00zz__wav_decoderz00)); 
BGl_z42wavzd2statuszd2newzd2formatz90zz__wav_decoderz00 = ((long)1); 
BGl_z42wavzd2statuszd2donez42zz__wav_decoderz00 = ((long)2); 
BGl_z42wavzd2statuszd2needzd2morez90zz__wav_decoderz00 = ((long)3); 
BGl_z42wavzd2statuszd2okz42zz__wav_decoderz00 = ((long)4); 
return ( 
BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = BFALSE, BUNSPEC) ;} 

}



/* wav-debug */
int BGl_wavzd2debugzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 37 */
if(
(((long)0)>((long)0)))
{ /* Llib/wav_decoder.scm 38 */
return 
bgl_debug();}  else 
{ /* Llib/wav_decoder.scm 38 */
return 
(int)(((long)0));} } 

}



/* wav-decode-status->symbol */
obj_t BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(obj_t BgL_statusz00_10)
{
{ /* Llib/wav_decoder.scm 82 */
if(
(((long)1)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 84 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/wav_decoder.scm 84 */
if(
(((long)2)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 85 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/wav_decoder.scm 85 */
if(
(((long)3)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 86 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/wav_decoder.scm 86 */
if(
(((long)4)==
(long)CINT(BgL_statusz00_10)))
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/wav_decoder.scm 87 */
return 
CNST_TABLE_REF(((long)4));} } } } } 

}



/* wav-decode */
obj_t BGl_wavzd2decodezd2zz__wav_decoderz00(BgL_wavmusicdecoderz00_bglt BgL_decz00_14, BgL_musicbufz00_bglt BgL_amz00_15, BgL_musicbufferz00_bglt BgL_bufferz00_16, int BgL_tailz00_17, int BgL_sz00_18)
{
{ /* Llib/wav_decoder.scm 267 */
if(
CBOOL(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52)))
{ /* Llib/wav_decoder.scm 288 */
BgL_wavinfoz00_bglt BgL_i1120z00_40;
BgL_i1120z00_40 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52headerz52)); 
if(
(
(long)(BgL_sz00_18)<
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_blockalignz00))))
{ /* Llib/wav_decoder.scm 290 */
{ /* Llib/wav_decoder.scm 291 */
long BgL_arg1161z00_43;obj_t BgL_arg1165z00_44;int BgL_arg1168z00_45;
BgL_arg1161z00_43 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1165z00_44 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1168z00_45 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1161z00_43), BgL_arg1165z00_44, BgL_arg1168z00_45, BgL_sz00_18); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52))+
(long)(BgL_sz00_18)))),BUNSPEC); 
return 
BINT(((long)3));}  else 
{ /* Llib/wav_decoder.scm 294 */
bool_t BgL_test2051z00_991;
{ /* Llib/wav_decoder.scm 294 */
long BgL_n1z00_529;long BgL_n2z00_530;
BgL_n1z00_529 = 
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)); 
{ /* Llib/wav_decoder.scm 294 */
long BgL_tmpz00_994;
BgL_tmpz00_994 = 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_chunksiza7eza7); 
BgL_n2z00_530 = 
(long)(BgL_tmpz00_994); } 
BgL_test2051z00_991 = 
(BgL_n1z00_529>=BgL_n2z00_530); } 
if(BgL_test2051z00_991)
{ /* Llib/wav_decoder.scm 294 */
return 
BINT(((long)2));}  else 
{ /* Llib/wav_decoder.scm 294 */
{ 
int BgL_auxz00_999;
{ /* Llib/wav_decoder.scm 297 */
long BgL_za71za7_533;
BgL_za71za7_533 = 
(long)(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1120z00_40))->BgL_blockalignz00)); 
BgL_auxz00_999 = 
(int)(
(BgL_za71za7_533*
(
(long)(BgL_sz00_18)/BgL_za71za7_533))); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5)=((int)BgL_auxz00_999),BUNSPEC); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52)=((int)
(int)(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52positionz52))+
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5))))),BUNSPEC); 
{ /* Llib/wav_decoder.scm 299 */
long BgL_arg1181z00_55;obj_t BgL_arg1182z00_56;int BgL_arg1183z00_57;int BgL_arg1184z00_58;
BgL_arg1181z00_55 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_bufferz00_16))->BgL_z52tailz52); 
BgL_arg1182z00_56 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_outbufz00); 
BgL_arg1183z00_57 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52); 
BgL_arg1184z00_58 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52siza7ezf5); 
BGl_musicbufferzd2blitzd2stringz12z12zz__multimediazd2musicbufzd2(BgL_bufferz00_16, 
(int)(BgL_arg1181z00_55), BgL_arg1182z00_56, BgL_arg1183z00_57, BgL_arg1184z00_58); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_decz00_14))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
return 
BINT(((long)4));} } }  else 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1108z00_645;
BgL_res1108z00_645 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31221ze3ze70z60zz__wav_decoderz00(BgL_sz00_18, BgL_decz00_14, BgL_bufferz00_16, BgL_res1108z00_645)))
{ /* Llib/wav_decoder.scm 271 */
{ /* Llib/wav_decoder.scm 271 */
int BgL_tmpz00_1026;
BgL_tmpz00_1026 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_1026); } 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ez00_540;
BgL_ez00_540 = 
CELL_REF(BgL_res1108z00_645); 
return 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_amz00_15), BgL_ez00_540);} }  else 
{ /* Llib/wav_decoder.scm 271 */
return 
CELL_REF(BgL_res1108z00_645);} } } 

}



/* <@exit:1221>~0 */
obj_t BGl_zc3z04exitza31221ze3ze70z60zz__wav_decoderz00(int BgL_sz00_771, BgL_wavmusicdecoderz00_bglt BgL_i1105z00_770, BgL_musicbufferz00_bglt BgL_bufferz00_769, obj_t BgL_res1108z00_768)
{
{ /* Llib/wav_decoder.scm 271 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1115z00_93;
if( SET_EXIT(BgL_an_exit1115z00_93 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1115z00_93 = 
(void *)jmpbuf; 
{ /* Llib/wav_decoder.scm 271 */

PUSH_EXIT(BgL_an_exit1115z00_93, ((long)1)); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_an_exitd1116z00_94;
BgL_an_exitd1116z00_94 = 
((obj_t)(&exitd)); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_res1118z00_97;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_ohs1106z00_98;
BgL_ohs1106z00_98 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_exitd1111z00_99;
BgL_exitd1111z00_99 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31240ze3z87_637;
BgL_zc3z04anonymousza31240ze3z87_637 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31240ze3ze5zz__wav_decoderz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31240ze3z87_637, 
(int)(((long)0)), BgL_ohs1106z00_98); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1111z00_99, BgL_zc3z04anonymousza31240ze3z87_637); 
{ /* Llib/wav_decoder.scm 271 */
bool_t BgL_tmp1113z00_101;
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_zc3z04anonymousza31223ze3z87_636;
BgL_zc3z04anonymousza31223ze3z87_636 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31223ze3ze5zz__wav_decoderz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31223ze3z87_636, 
(int)(((long)0)), 
((obj_t)BgL_res1108z00_768)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31223ze3z87_636, 
(int)(((long)1)), BgL_an_exitd1116z00_94); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31223ze3z87_636, BgL_ohs1106z00_98); BUNSPEC; } 
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_auxz00_646;
{ /* Llib/wav_decoder.scm 274 */
bool_t BgL_test2053z00_1050;
{ /* Llib/wav_decoder.scm 274 */
long BgL_arg1239z00_114;
BgL_arg1239z00_114 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
{ /* Llib/wav_decoder.scm 274 */
long BgL_n1z00_537;long BgL_n2z00_538;
BgL_n1z00_537 = 
(long)(BgL_sz00_771); 
BgL_n2z00_538 = 
(long)(BgL_arg1239z00_114); 
BgL_test2053z00_1050 = 
(BgL_n1z00_537<BgL_n2z00_538); } } 
if(BgL_test2053z00_1050)
{ /* Llib/wav_decoder.scm 274 */
BgL_auxz00_646 = 
BINT(((long)3)); }  else 
{ /* Llib/wav_decoder.scm 276 */
obj_t BgL_strz00_107;
{ /* Llib/wav_decoder.scm 277 */
long BgL_arg1230z00_112;
{ /* Llib/wav_decoder.scm 277 */
long BgL_tmpz00_1056;
BgL_tmpz00_1056 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
BgL_arg1230z00_112 = 
(long)(BgL_tmpz00_1056); } 
BgL_strz00_107 = 
BGl_musicbufferzd2substringzd2zz__multimediazd2musicbufzd2(BgL_bufferz00_769, 
(int)(((long)0)), 
(int)(BgL_arg1230z00_112)); } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_770))->BgL_z52headerz52)=((obj_t)
BGl_wavzd2parsezd2headerz00zz__wav_wavz00(BgL_strz00_107)),BUNSPEC); 
{ /* Llib/wav_decoder.scm 279 */
BgL_wavinfoz00_bglt BgL_i1114z00_108;
BgL_i1114z00_108 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_770))->BgL_z52headerz52)); 
if(
(
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1114z00_108))->BgL_audiofmtz00)==
CNST_TABLE_REF(((long)5))))
{ /* Llib/wav_decoder.scm 280 */BFALSE; }  else 
{ /* Llib/wav_decoder.scm 280 */
BGl_errorz00zz__errorz00(BGl_string1917z00zz__wav_decoderz00, BGl_string1918z00zz__wav_decoderz00, 
(((BgL_wavinfoz00_bglt)COBJECT(BgL_i1114z00_108))->BgL_audiofmtz00)); } } 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_770))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_770))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1105z00_770))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_646 = 
BINT(((long)1)); } } 
CELL_SET(BgL_res1108z00_768, BgL_auxz00_646); } 
BgL_tmp1113z00_101 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1111z00_99); 
BGL_ERROR_HANDLER_SET(BgL_ohs1106z00_98); BUNSPEC; 
BgL_res1118z00_97 = BgL_tmp1113z00_101; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1118z00_97);} } } 
}} 

}



/* &<@anonymous:1223> */
obj_t BGl_z62zc3z04anonymousza31223ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_638, obj_t BgL_ez00_641)
{
{ /* Llib/wav_decoder.scm 271 */
{ /* Llib/wav_decoder.scm 271 */
obj_t BgL_res1108z00_639;obj_t BgL_an_exitd1116z00_640;
BgL_res1108z00_639 = 
PROCEDURE_REF(BgL_envz00_638, 
(int)(((long)0))); 
BgL_an_exitd1116z00_640 = 
PROCEDURE_REF(BgL_envz00_638, 
(int)(((long)1))); 
CELL_SET(BgL_res1108z00_639, BgL_ez00_641); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1116z00_640, BTRUE);} } 

}



/* &<@anonymous:1240> */
obj_t BGl_z62zc3z04anonymousza31240ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_643)
{
{ /* Llib/wav_decoder.scm 271 */
{ 
obj_t BgL_ohs1106z00_644;
BgL_ohs1106z00_644 = 
PROCEDURE_REF(BgL_envz00_643, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1106z00_644); 
return BUNSPEC;} } 

}



/* debug-init! */
obj_t BGl_debugzd2initz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_21)
{
{ /* Llib/wav_decoder.scm 317 */
{ /* Llib/wav_decoder.scm 318 */

BGl_za2debugzd2portza2zd2zz__wav_decoderz00 = 
BGl_openzd2outputzd2filez00zz__r4_ports_6_10_1z00(BGl_string1919z00zz__wav_decoderz00, BTRUE); } 
{ /* Llib/wav_decoder.scm 319 */
BGL_LONGLONG_T BgL_arg1242z00_122;
BgL_arg1242z00_122 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_list1243z00_123;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1244z00_124;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1245z00_125;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1246z00_126;
{ /* Llib/wav_decoder.scm 319 */
obj_t BgL_arg1247z00_127;
BgL_arg1247z00_127 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1246z00_126 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1242z00_122), BgL_arg1247z00_127); } 
BgL_arg1245z00_125 = 
MAKE_YOUNG_PAIR(BGl_string1921z00zz__wav_decoderz00, BgL_arg1246z00_126); } 
BgL_arg1244z00_124 = 
MAKE_YOUNG_PAIR(BgL_urlz00_21, BgL_arg1245z00_125); } 
BgL_list1243z00_123 = 
MAKE_YOUNG_PAIR(BGl_string1922z00zz__wav_decoderz00, BgL_arg1244z00_124); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1243z00_123);} } } 

}



/* debug-stop! */
obj_t BGl_debugzd2stopz12zc0zz__wav_decoderz00(obj_t BgL_urlz00_22)
{
{ /* Llib/wav_decoder.scm 324 */
{ /* Llib/wav_decoder.scm 325 */
BGL_LONGLONG_T BgL_arg1248z00_128;
BgL_arg1248z00_128 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_list1249z00_129;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1252z00_130;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1253z00_131;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1254z00_132;
{ /* Llib/wav_decoder.scm 325 */
obj_t BgL_arg1258z00_133;
BgL_arg1258z00_133 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1254z00_132 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1248z00_128), BgL_arg1258z00_133); } 
BgL_arg1253z00_131 = 
MAKE_YOUNG_PAIR(BGl_string1921z00zz__wav_decoderz00, BgL_arg1254z00_132); } 
BgL_arg1252z00_130 = 
MAKE_YOUNG_PAIR(BgL_urlz00_22, BgL_arg1253z00_131); } 
BgL_list1249z00_129 = 
MAKE_YOUNG_PAIR(BGl_string1923z00zz__wav_decoderz00, BgL_arg1252z00_130); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1249z00_129); } } 
return 
bgl_close_output_port(BGl_za2debugzd2portza2zd2zz__wav_decoderz00);} 

}



/* debug */
obj_t BGl_debugz00zz__wav_decoderz00(obj_t BgL_argsz00_23)
{
{ /* Llib/wav_decoder.scm 331 */
{ 
obj_t BgL_l1123z00_135;
BgL_l1123z00_135 = BgL_argsz00_23; 
BgL_zc3z04anonymousza31259ze3z87_136:
if(
PAIRP(BgL_l1123z00_135))
{ /* Llib/wav_decoder.scm 332 */
{ /* Llib/wav_decoder.scm 332 */
obj_t BgL_az00_138;
BgL_az00_138 = 
CAR(BgL_l1123z00_135); 
bgl_display_obj(BgL_az00_138, BGl_za2debugzd2portza2zd2zz__wav_decoderz00); } 
{ 
obj_t BgL_l1123z00_1113;
BgL_l1123z00_1113 = 
CDR(BgL_l1123z00_135); 
BgL_l1123z00_135 = BgL_l1123z00_1113; 
goto BgL_zc3z04anonymousza31259ze3z87_136;} }  else 
{ /* Llib/wav_decoder.scm 332 */((bool_t)1); } } 
return 
bgl_flush_output_port(BGl_za2debugzd2portza2zd2zz__wav_decoderz00);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1318z00_144;obj_t BgL_arg1319z00_145;
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1125z00_171;
BgL_v1125z00_171 = 
create_vector(((long)5)); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1333z00_172;
BgL_arg1333z00_172 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc1926z00zz__wav_decoderz00, BGl_proc1925z00zz__wav_decoderz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1924z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1125z00_171,((long)0),BgL_arg1333z00_172); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1344z00_187;
BgL_arg1344z00_187 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc1929z00zz__wav_decoderz00, BGl_proc1928z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1927z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)9))); 
VECTOR_SET(BgL_v1125z00_171,((long)1),BgL_arg1344z00_187); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1360z00_200;
BgL_arg1360z00_200 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)10)), BGl_proc1932z00zz__wav_decoderz00, BGl_proc1931z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1930z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_171,((long)2),BgL_arg1360z00_200); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1431z00_213;
BgL_arg1431z00_213 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)12)), BGl_proc1935z00zz__wav_decoderz00, BGl_proc1934z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1933z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_171,((long)3),BgL_arg1431z00_213); } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_arg1516z00_226;
BgL_arg1516z00_226 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc1938z00zz__wav_decoderz00, BGl_proc1937z00zz__wav_decoderz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1936z00zz__wav_decoderz00, 
CNST_TABLE_REF(((long)11))); 
VECTOR_SET(BgL_v1125z00_171,((long)4),BgL_arg1516z00_226); } 
BgL_arg1318z00_144 = BgL_v1125z00_171; } 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_v1126z00_239;
BgL_v1126z00_239 = 
create_vector(((long)0)); 
BgL_arg1319z00_145 = BgL_v1126z00_239; } 
return ( 
BGl_wavmusicdecoderz00zz__wav_decoderz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)14)), 
CNST_TABLE_REF(((long)15)), BGl_musicdecoderz00zz__multimediazd2musicbufzd2, ((long)3767), BGl_proc1941z00zz__wav_decoderz00, BGl_proc1940z00zz__wav_decoderz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1939z00zz__wav_decoderz00, BFALSE, BgL_arg1318z00_144, BgL_arg1319z00_145), BUNSPEC) ;} } 

}



/* &<@anonymous:1331> */
obj_t BGl_z62zc3z04anonymousza31331ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_666, obj_t BgL_new1091z00_667)
{
{ /* Llib/wav_decoder.scm 21 */
{ 
BgL_wavmusicdecoderz00_bglt BgL_auxz00_1141;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667)))->BgL_outbufz00)=((obj_t)BGl_string1942z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667)))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667)))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667)))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667)))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1141 = 
((BgL_wavmusicdecoderz00_bglt)BgL_new1091z00_667); 
return 
((obj_t)BgL_auxz00_1141);} } 

}



/* &lambda1324 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1324z62zz__wav_decoderz00(obj_t BgL_envz00_668)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1090z00_785;
BgL_new1090z00_785 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1330z00_786;
BgL_arg1330z00_786 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_785), BgL_arg1330z00_786); } 
return BgL_new1090z00_785;} } 

}



/* &lambda1320 */
BgL_wavmusicdecoderz00_bglt BGl_z62lambda1320z62zz__wav_decoderz00(obj_t BgL_envz00_669, obj_t BgL_mimetypes1075z00_670, obj_t BgL_bufferzd2timezd2near1076z00_671, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1077z75_672, obj_t BgL_periodzd2siza7ezd2nearzd2rat1078z75_673, obj_t BgL_z52z12dpause1079z40_674, obj_t BgL_z52z12dabort1080z40_675, obj_t BgL_z52z12stop1081z40_676, obj_t BgL_z52dmutex1082z52_677, obj_t BgL_z52dcondv1083z52_678, obj_t BgL_z52doutcondv1084z52_679, obj_t BgL_outbuf1085z00_680, obj_t BgL_z52header1086z52_681, obj_t BgL_z52cursor1087z52_682, obj_t BgL_z52siza7e1088zf5_683, obj_t BgL_z52position1089z52_684)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_bufferzd2timezd2near1076z00_788;int BgL_bufferzd2siza7ezd2nearzd2rat1077z75_789;int BgL_periodzd2siza7ezd2nearzd2rat1078z75_790;bool_t BgL_z52z12dpause1079z40_791;bool_t BgL_z52z12dabort1080z40_792;bool_t BgL_z52z12stop1081z40_793;int BgL_z52cursor1087z52_798;int BgL_z52siza7e1088zf5_799;int BgL_z52position1089z52_800;
BgL_bufferzd2timezd2near1076z00_788 = 
CINT(BgL_bufferzd2timezd2near1076z00_671); 
BgL_bufferzd2siza7ezd2nearzd2rat1077z75_789 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1077z75_672); 
BgL_periodzd2siza7ezd2nearzd2rat1078z75_790 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1078z75_673); 
BgL_z52z12dpause1079z40_791 = 
CBOOL(BgL_z52z12dpause1079z40_674); 
BgL_z52z12dabort1080z40_792 = 
CBOOL(BgL_z52z12dabort1080z40_675); 
BgL_z52z12stop1081z40_793 = 
CBOOL(BgL_z52z12stop1081z40_676); 
BgL_z52cursor1087z52_798 = 
CINT(BgL_z52cursor1087z52_682); 
BgL_z52siza7e1088zf5_799 = 
CINT(BgL_z52siza7e1088zf5_683); 
BgL_z52position1089z52_800 = 
CINT(BgL_z52position1089z52_684); 
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1122z00_801;
{ /* Llib/wav_decoder.scm 21 */
BgL_wavmusicdecoderz00_bglt BgL_new1121z00_802;
BgL_new1121z00_802 = 
((BgL_wavmusicdecoderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavmusicdecoderz00_bgl) ))); 
{ /* Llib/wav_decoder.scm 21 */
long BgL_arg1323z00_803;
BgL_arg1323z00_803 = 
BGL_CLASS_INDEX(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_802), BgL_arg1323z00_803); } 
BgL_new1122z00_801 = BgL_new1121z00_802; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1075z00_670)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1076z00_788),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1077z75_789),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1078z75_790),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1079z40_791),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1080z40_792),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1081z40_793),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1082z52_677)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1083z52_678)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1122z00_801)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1084z52_679)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_801))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1085z00_680)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_801))->BgL_z52headerz52)=((obj_t)BgL_z52header1086z52_681),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_801))->BgL_z52cursorz52)=((int)BgL_z52cursor1087z52_798),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_801))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1088zf5_799),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_new1122z00_801))->BgL_z52positionz52)=((int)BgL_z52position1089z52_800),BUNSPEC); 
{ /* Llib/wav_decoder.scm 21 */
obj_t BgL_fun1321z00_804;
BgL_fun1321z00_804 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavmusicdecoderz00zz__wav_decoderz00); 
PROCEDURE_ENTRY(BgL_fun1321z00_804)(BgL_fun1321z00_804, 
((obj_t)BgL_new1122z00_801), BEOA); } 
return BgL_new1122z00_801;} } } 

}



/* &<@anonymous:1533> */
obj_t BGl_z62zc3z04anonymousza31533ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_685)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1532 */
obj_t BGl_z62lambda1532z62zz__wav_decoderz00(obj_t BgL_envz00_686, obj_t BgL_oz00_687, obj_t BgL_vz00_688)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_806;
BgL_vz00_806 = 
CINT(BgL_vz00_688); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_687)))->BgL_z52positionz52)=((int)BgL_vz00_806),BUNSPEC);} } 

}



/* &lambda1531 */
obj_t BGl_z62lambda1531z62zz__wav_decoderz00(obj_t BgL_envz00_689, obj_t BgL_oz00_690)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_690)))->BgL_z52positionz52));} 

}



/* &<@anonymous:1515> */
obj_t BGl_z62zc3z04anonymousza31515ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_691)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1514 */
obj_t BGl_z62lambda1514z62zz__wav_decoderz00(obj_t BgL_envz00_692, obj_t BgL_oz00_693, obj_t BgL_vz00_694)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_809;
BgL_vz00_809 = 
CINT(BgL_vz00_694); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_693)))->BgL_z52siza7ezf5)=((int)BgL_vz00_809),BUNSPEC);} } 

}



/* &lambda1513 */
obj_t BGl_z62lambda1513z62zz__wav_decoderz00(obj_t BgL_envz00_695, obj_t BgL_oz00_696)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_696)))->BgL_z52siza7ezf5));} 

}



/* &<@anonymous:1392> */
obj_t BGl_z62zc3z04anonymousza31392ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_697)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(((long)0));} 

}



/* &lambda1391 */
obj_t BGl_z62lambda1391z62zz__wav_decoderz00(obj_t BgL_envz00_698, obj_t BgL_oz00_699, obj_t BgL_vz00_700)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 21 */
int BgL_vz00_812;
BgL_vz00_812 = 
CINT(BgL_vz00_700); 
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_699)))->BgL_z52cursorz52)=((int)BgL_vz00_812),BUNSPEC);} } 

}



/* &lambda1390 */
obj_t BGl_z62lambda1390z62zz__wav_decoderz00(obj_t BgL_envz00_701, obj_t BgL_oz00_702)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_702)))->BgL_z52cursorz52));} 

}



/* &<@anonymous:1359> */
obj_t BGl_z62zc3z04anonymousza31359ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_703)
{
{ /* Llib/wav_decoder.scm 21 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1358 */
obj_t BGl_z62lambda1358z62zz__wav_decoderz00(obj_t BgL_envz00_704, obj_t BgL_oz00_705, obj_t BgL_vz00_706)
{
{ /* Llib/wav_decoder.scm 21 */
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_705)))->BgL_z52headerz52)=((obj_t)BgL_vz00_706),BUNSPEC);} 

}



/* &lambda1357 */
obj_t BGl_z62lambda1357z62zz__wav_decoderz00(obj_t BgL_envz00_707, obj_t BgL_oz00_708)
{
{ /* Llib/wav_decoder.scm 21 */
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_708)))->BgL_z52headerz52);} 

}



/* &<@anonymous:1342> */
obj_t BGl_z62zc3z04anonymousza31342ze3ze5zz__wav_decoderz00(obj_t BgL_envz00_709)
{
{ /* Llib/wav_decoder.scm 21 */
{ /* Llib/wav_decoder.scm 22 */

return 
make_string(((long)2048), ((unsigned char)' '));} } 

}



/* &lambda1341 */
obj_t BGl_z62lambda1341z62zz__wav_decoderz00(obj_t BgL_envz00_710, obj_t BgL_oz00_711, obj_t BgL_vz00_712)
{
{ /* Llib/wav_decoder.scm 21 */
return 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_711)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_vz00_712)),BUNSPEC);} 

}



/* &lambda1340 */
obj_t BGl_z62lambda1340z62zz__wav_decoderz00(obj_t BgL_envz00_713, obj_t BgL_oz00_714)
{
{ /* Llib/wav_decoder.scm 21 */
return 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_oz00_714)))->BgL_outbufz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1943z00zz__wav_decoderz00, BGl_string1944z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1945z00zz__wav_decoderz00, BGl_string1946z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1947z00zz__wav_decoderz00, BGl_string1948z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2positionzd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1949z00zz__wav_decoderz00, BGl_string1950z00zz__wav_decoderz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2decodezd2envz00zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1951z00zz__wav_decoderz00, BGl_string1952z00zz__wav_decoderz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2volumezd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00, BGl_proc1953z00zz__wav_decoderz00, BGl_string1954z00zz__wav_decoderz00);} 

}



/* &musicdecoder-volume-1138 */
obj_t BGl_z62musicdecoderzd2volumezd21138z62zz__wav_decoderz00(obj_t BgL_envz00_725, obj_t BgL_decz00_726, obj_t BgL_volz00_727)
{
{ /* Llib/wav_decoder.scm 306 */
return BFALSE;} 

}



/* &musicdecoder-decode-1136 */
obj_t BGl_z62musicdecoderzd2decodezd21136z62zz__wav_decoderz00(obj_t BgL_envz00_728, obj_t BgL_decz00_729, obj_t BgL_amz00_730, obj_t BgL_bufferz00_731)
{
{ /* Llib/wav_decoder.scm 93 */
{ /* Llib/wav_decoder.scm 99 */
struct bgl_cell BgL_box2056_823z00; 
obj_t BgL_haszd2beenzd2emptyzd2oncezd2_823;
BgL_haszd2beenzd2emptyzd2oncezd2_823 = 
MAKE_CELL_STACK(BFALSE,BgL_box2056_823z00); 
{ /* Llib/wav_decoder.scm 99 */
long BgL_inlenz00_824;
BgL_inlenz00_824 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52inlenz52); 
{ /* Llib/wav_decoder.scm 107 */
long BgL_outlenz00_825;
BgL_outlenz00_825 = 
STRING_LENGTH(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)))->BgL_outbufz00)); 
{ 

{ /* Llib/wav_decoder.scm 169 */
bool_t BgL_test2057z00_1289;
{ /* Llib/wav_decoder.scm 169 */
int BgL_arg1563z00_827;
BgL_arg1563z00_827 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2057z00_1289 = 
(
(long)(BgL_arg1563z00_827)>((long)0)); } 
if(BgL_test2057z00_1289)
{ /* Llib/wav_decoder.scm 169 */
BGl_debugzd2initz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_urlz00)); }  else 
{ /* Llib/wav_decoder.scm 169 */BFALSE; } } 
{ 

BgL_loopz00_828:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 173 */
{ /* Llib/wav_decoder.scm 175 */
BgL_musicstatusz00_bglt BgL_i1101z00_829;
BgL_i1101z00_829 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1101z00_829))->BgL_songposz00)=((obj_t)
BINT(
BGl_musicdecoderzd2positionzd2zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)16))); 
{ /* Llib/wav_decoder.scm 178 */
obj_t BgL_mutex1566z00_830;
BgL_mutex1566z00_830 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52dmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1566z00_830); 
{ /* Llib/wav_decoder.scm 178 */
bool_t BgL_tmp2059z00_1316;
{ 

BgL_liipz00_831:
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52z12dpausez40))
{ /* Llib/wav_decoder.scm 180 */
{ /* Llib/wav_decoder.scm 181 */
obj_t BgL_arg1580z00_832;obj_t BgL_arg1581z00_833;
BgL_arg1580z00_832 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52dcondvz52); 
BgL_arg1581z00_833 = 
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52dmutexz52); 
{ /* Llib/wav_decoder.scm 181 */

BGL_CONDVAR_WAIT(BgL_arg1580z00_832, BgL_arg1581z00_833); } } 
goto BgL_liipz00_831;}  else 
{ /* Llib/wav_decoder.scm 180 */
BgL_tmp2059z00_1316 = ((bool_t)0); } } 
BGL_MUTEX_UNLOCK(BgL_mutex1566z00_830); BgL_tmp2059z00_1316; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)17))); 
goto BgL_loopz00_828;}  else 
{ /* Llib/wav_decoder.scm 173 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 185 */
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)18))); }  else 
{ /* Llib/wav_decoder.scm 185 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 188 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 192 */
bool_t BgL_test2064z00_1348;
{ /* Llib/wav_decoder.scm 192 */
int BgL_arg1619z00_834;
BgL_arg1619z00_834 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2064z00_1348 = 
(
(long)(BgL_arg1619z00_834)>=((long)2)); } 
if(BgL_test2064z00_1348)
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1593z00_835;
BgL_arg1593z00_835 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_list1594z00_836;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1615z00_837;
{ /* Llib/wav_decoder.scm 193 */
obj_t BgL_arg1616z00_838;
BgL_arg1616z00_838 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1615z00_837 = 
MAKE_YOUNG_PAIR(BgL_arg1593z00_835, BgL_arg1616z00_838); } 
BgL_list1594z00_836 = 
MAKE_YOUNG_PAIR(BGl_string1955z00zz__wav_decoderz00, BgL_arg1615z00_837); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1594z00_836); } }  else 
{ /* Llib/wav_decoder.scm 192 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)19))); }  else 
{ /* Llib/wav_decoder.scm 190 */
{ /* Llib/wav_decoder.scm 196 */
bool_t BgL_test2065z00_1362;
{ /* Llib/wav_decoder.scm 196 */
int BgL_arg1645z00_839;
BgL_arg1645z00_839 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2065z00_1362 = 
(
(long)(BgL_arg1645z00_839)>=((long)1)); } 
if(BgL_test2065z00_1362)
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1626z00_840;BGL_LONGLONG_T BgL_arg1627z00_841;
BgL_arg1626z00_840 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_urlz00); 
BgL_arg1627z00_841 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_list1628z00_842;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1631z00_843;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1636z00_844;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1643z00_845;
{ /* Llib/wav_decoder.scm 197 */
obj_t BgL_arg1644z00_846;
BgL_arg1644z00_846 = 
MAKE_YOUNG_PAIR(BGl_string1956z00zz__wav_decoderz00, BNIL); 
BgL_arg1643z00_845 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1627z00_841), BgL_arg1644z00_846); } 
BgL_arg1636z00_844 = 
MAKE_YOUNG_PAIR(BGl_string1921z00zz__wav_decoderz00, BgL_arg1643z00_845); } 
BgL_arg1631z00_843 = 
MAKE_YOUNG_PAIR(BgL_arg1626z00_840, BgL_arg1636z00_844); } 
BgL_list1628z00_842 = 
MAKE_YOUNG_PAIR(BGl_string1957z00zz__wav_decoderz00, BgL_arg1631z00_843); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1628z00_842); } }  else 
{ /* Llib/wav_decoder.scm 196 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 200 */
BgL_musicstatusz00_bglt BgL_i1103z00_847;
BgL_i1103z00_847 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1103z00_847))->BgL_bufferingz00)=((int)
(int)(
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_824, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))),BUNSPEC); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)20))); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_mutex1646z00_848;
BgL_mutex1646z00_848 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 204 */
obj_t BgL_top2067z00_1390;
BgL_top2067z00_1390 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mutex1646z00_848); 
BGL_EXITD_PUSH_PROTECT(BgL_top2067z00_1390, BgL_mutex1646z00_848); BUNSPEC; 
{ /* Llib/wav_decoder.scm 204 */
bool_t BgL_tmp2066z00_1389;
{ /* Llib/wav_decoder.scm 206 */
bool_t BgL_test2068z00_1394;
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52emptyz52))
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 206 */
BgL_test2068z00_1394 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
if(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729))))->BgL_z52z12dabortz40))
{ /* Llib/wav_decoder.scm 206 */
BgL_test2068z00_1394 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_test2068z00_1394 = 
(
(((long)8)*
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))>BgL_inlenz00_824)
; } } }  else 
{ /* Llib/wav_decoder.scm 206 */
BgL_test2068z00_1394 = ((bool_t)1)
; } 
if(BgL_test2068z00_1394)
{ /* Llib/wav_decoder.scm 206 */
BgL_tmp2066z00_1389 = ((bool_t)0); }  else 
{ /* Llib/wav_decoder.scm 210 */
obj_t BgL_arg1652z00_849;obj_t BgL_arg1656z00_850;
BgL_arg1652z00_849 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52bcondvz52); 
BgL_arg1656z00_850 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52bmutexz52); 
{ /* Llib/wav_decoder.scm 210 */

BgL_tmp2066z00_1389 = 
BGL_CONDVAR_WAIT(BgL_arg1652z00_849, BgL_arg1656z00_850); } } } 
BGL_EXITD_POP_PROTECT(BgL_top2067z00_1390); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mutex1646z00_848); BgL_tmp2066z00_1389; } } } 
{ /* Llib/wav_decoder.scm 211 */
bool_t BgL_test2072z00_1416;
{ /* Llib/wav_decoder.scm 211 */
int BgL_arg1677z00_851;
BgL_arg1677z00_851 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2072z00_1416 = 
(
(long)(BgL_arg1677z00_851)>=((long)1)); } 
if(BgL_test2072z00_1416)
{ /* Llib/wav_decoder.scm 212 */
BGL_LONGLONG_T BgL_arg1671z00_852;
BgL_arg1671z00_852 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_list1672z00_853;
{ /* Llib/wav_decoder.scm 212 */
obj_t BgL_arg1674z00_854;
BgL_arg1674z00_854 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_list1672z00_853 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1671z00_852), BgL_arg1674z00_854); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1672z00_853); } }  else 
{ /* Llib/wav_decoder.scm 211 */BFALSE; } } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)17))); 
goto BgL_loopz00_828;} }  else 
{ /* Llib/wav_decoder.scm 217 */
long BgL_sz00_855;
{ /* Llib/wav_decoder.scm 217 */
long BgL_bz00_856;
if(
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52headz52)>
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52)))
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_856 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52headz52)-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52)); }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_bz00_856 = 
(BgL_inlenz00_824-
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52)); } 
if(
(BgL_outlenz00_825<BgL_bz00_856))
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_855 = BgL_outlenz00_825; }  else 
{ /* Llib/wav_decoder.scm 218 */
BgL_sz00_855 = BgL_bz00_856; } } 
if(
(BgL_sz00_855==((long)0)))
{ /* Llib/wav_decoder.scm 221 */
goto BgL_loopz00_828;}  else 
{ /* Llib/wav_decoder.scm 223 */
obj_t BgL_statusz00_857;
{ /* Llib/wav_decoder.scm 223 */
long BgL_arg1790z00_858;
BgL_arg1790z00_858 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52); 
BgL_statusz00_857 = 
BGl_wavzd2decodezd2zz__wav_decoderz00(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729), 
((BgL_musicbufz00_bglt)BgL_amz00_730), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731), 
(int)(BgL_arg1790z00_858), 
(int)(BgL_sz00_855)); } 
{ /* Llib/wav_decoder.scm 224 */
bool_t BgL_test2076z00_1455;
{ /* Llib/wav_decoder.scm 224 */
int BgL_arg1714z00_859;
BgL_arg1714z00_859 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2076z00_1455 = 
(
(long)(BgL_arg1714z00_859)>=((long)4)); } 
if(BgL_test2076z00_1455)
{ /* Llib/wav_decoder.scm 225 */
long BgL_arg1684z00_860;long BgL_arg1696z00_861;obj_t BgL_arg1697z00_862;
BgL_arg1684z00_860 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52); 
BgL_arg1696z00_861 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52headz52); 
BgL_arg1697z00_862 = 
BGl_wavzd2decodezd2statuszd2ze3symbolz31zz__wav_decoderz00(BgL_statusz00_857); 
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_list1698z00_863;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1699z00_864;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1700z00_865;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1701z00_866;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1703z00_867;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1705z00_868;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1706z00_869;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1712z00_870;
{ /* Llib/wav_decoder.scm 225 */
obj_t BgL_arg1713z00_871;
BgL_arg1713z00_871 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1712z00_870 = 
MAKE_YOUNG_PAIR(BgL_arg1697z00_862, BgL_arg1713z00_871); } 
BgL_arg1706z00_869 = 
MAKE_YOUNG_PAIR(BGl_string1958z00zz__wav_decoderz00, BgL_arg1712z00_870); } 
BgL_arg1705z00_868 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1696z00_861), BgL_arg1706z00_869); } 
BgL_arg1703z00_867 = 
MAKE_YOUNG_PAIR(BGl_string1959z00zz__wav_decoderz00, BgL_arg1705z00_868); } 
BgL_arg1701z00_866 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1684z00_860), BgL_arg1703z00_867); } 
BgL_arg1700z00_865 = 
MAKE_YOUNG_PAIR(BGl_string1960z00zz__wav_decoderz00, BgL_arg1701z00_866); } 
BgL_arg1699z00_864 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_855), BgL_arg1700z00_865); } 
BgL_list1698z00_863 = 
MAKE_YOUNG_PAIR(BGl_string1961z00zz__wav_decoderz00, BgL_arg1699z00_864); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1698z00_863); } }  else 
{ /* Llib/wav_decoder.scm 224 */BFALSE; } } 
if(
(
(long)CINT(BgL_statusz00_857)==((long)4)))
{ /* Llib/wav_decoder.scm 231 */
{ /* Llib/wav_decoder.scm 233 */
bool_t BgL_test2078z00_1480;
{ /* Llib/wav_decoder.scm 233 */
int BgL_arg1737z00_872;
BgL_arg1737z00_872 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2078z00_1480 = 
(
(long)(BgL_arg1737z00_872)>=((long)5)); } 
if(BgL_test2078z00_1480)
{ /* Llib/wav_decoder.scm 234 */
int BgL_arg1719z00_873;
BgL_arg1719z00_873 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)))->BgL_z52siza7ezf5); 
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_list1720z00_874;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1726z00_875;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1727z00_876;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1730z00_877;
{ /* Llib/wav_decoder.scm 234 */
obj_t BgL_arg1734z00_878;
BgL_arg1734z00_878 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1730z00_877 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1719z00_873), BgL_arg1734z00_878); } 
BgL_arg1727z00_876 = 
MAKE_YOUNG_PAIR(BGl_string1962z00zz__wav_decoderz00, BgL_arg1730z00_877); } 
BgL_arg1726z00_875 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_855), BgL_arg1727z00_876); } 
BgL_list1720z00_874 = 
MAKE_YOUNG_PAIR(BGl_string1963z00zz__wav_decoderz00, BgL_arg1726z00_875); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1720z00_874); } }  else 
{ /* Llib/wav_decoder.scm 233 */BFALSE; } } 
BGl_flushze70ze7zz__wav_decoderz00(
((BgL_musicbufz00_bglt)BgL_amz00_730), 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729), 
(int)(BgL_sz00_855)); 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731), BgL_inlenz00_824, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731), BgL_haszd2beenzd2emptyzd2oncezd2_823, BgL_sz00_855); 
goto BgL_loopz00_828;}  else 
{ /* Llib/wav_decoder.scm 231 */
if(
(
(long)CINT(BgL_statusz00_857)==((long)3)))
{ /* Llib/wav_decoder.scm 239 */
{ /* Llib/wav_decoder.scm 241 */
bool_t BgL_test2080z00_1504;
{ /* Llib/wav_decoder.scm 241 */
int BgL_arg1781z00_879;
BgL_arg1781z00_879 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2080z00_1504 = 
(
(long)(BgL_arg1781z00_879)>=((long)5)); } 
if(BgL_test2080z00_1504)
{ /* Llib/wav_decoder.scm 242 */
int BgL_arg1748z00_880;bool_t BgL_arg1760z00_881;long BgL_arg1763z00_882;
BgL_arg1748z00_880 = 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)))->BgL_z52siza7ezf5); 
BgL_arg1760z00_881 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52emptyz52); 
BgL_arg1763z00_882 = 
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_z52tailz52); 
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_list1764z00_883;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1772z00_884;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1773z00_885;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1775z00_886;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1776z00_887;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1777z00_888;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1778z00_889;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1779z00_890;
{ /* Llib/wav_decoder.scm 242 */
obj_t BgL_arg1780z00_891;
BgL_arg1780z00_891 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1779z00_890 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1763z00_882), BgL_arg1780z00_891); } 
BgL_arg1778z00_889 = 
MAKE_YOUNG_PAIR(BGl_string1964z00zz__wav_decoderz00, BgL_arg1779z00_890); } 
BgL_arg1777z00_888 = 
MAKE_YOUNG_PAIR(
BBOOL(BgL_arg1760z00_881), BgL_arg1778z00_889); } 
BgL_arg1776z00_887 = 
MAKE_YOUNG_PAIR(BGl_string1965z00zz__wav_decoderz00, BgL_arg1777z00_888); } 
BgL_arg1775z00_886 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1748z00_880), BgL_arg1776z00_887); } 
BgL_arg1773z00_885 = 
MAKE_YOUNG_PAIR(BGl_string1962z00zz__wav_decoderz00, BgL_arg1775z00_886); } 
BgL_arg1772z00_884 = 
MAKE_YOUNG_PAIR(
BINT(BgL_sz00_855), BgL_arg1773z00_885); } 
BgL_list1764z00_883 = 
MAKE_YOUNG_PAIR(BGl_string1966z00zz__wav_decoderz00, BgL_arg1772z00_884); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1764z00_883); } }  else 
{ /* Llib/wav_decoder.scm 241 */BFALSE; } } 
goto BgL_loopz00_828;}  else 
{ /* Llib/wav_decoder.scm 239 */
if(
(
(long)CINT(BgL_statusz00_857)==((long)1)))
{ /* Llib/wav_decoder.scm 246 */
BGl_musicdecoderzd2hwparamszd2setz12z12zz__multimediazd2musicbufzd2(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)), 
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)); 
{ /* Llib/wav_decoder.scm 249 */
long BgL_arg1783z00_892;
{ /* Llib/wav_decoder.scm 249 */
long BgL_tmpz00_1537;
BgL_tmpz00_1537 = 
BGl_wavzd2headerzd2siza7eza7zz__wav_wavz00(); 
BgL_arg1783z00_892 = 
(long)(BgL_tmpz00_1537); } 
BGl_inczd2tailz12ze70z27zz__wav_decoderz00(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731), BgL_inlenz00_824, 
((BgL_musicbufferz00_bglt)BgL_bufferz00_731), BgL_haszd2beenzd2emptyzd2oncezd2_823, BgL_arg1783z00_892); } 
goto BgL_loopz00_828;}  else 
{ /* Llib/wav_decoder.scm 246 */
if(
(
(long)CINT(BgL_statusz00_857)==((long)2)))
{ /* Llib/wav_decoder.scm 251 */
if(
(
(long)(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)))->BgL_z52siza7ezf5))>((long)0)))
{ /* Llib/wav_decoder.scm 253 */
BGl_flushze70ze7zz__wav_decoderz00(
((BgL_musicbufz00_bglt)BgL_amz00_730), 
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729), 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_729)))->BgL_z52siza7ezf5)); }  else 
{ /* Llib/wav_decoder.scm 253 */((bool_t)0); } 
BGl_musiczd2statezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), 
CNST_TABLE_REF(((long)19))); }  else 
{ /* Llib/wav_decoder.scm 251 */
{ /* Llib/wav_decoder.scm 257 */
BgL_musicstatusz00_bglt BgL_i1104z00_893;
BgL_i1104z00_893 = 
(((BgL_musicz00_bglt)COBJECT(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730))))->BgL_z52statusz52); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1104z00_893))->BgL_errz00)=((obj_t)BGl_string1967z00zz__wav_decoderz00),BUNSPEC); 
((((BgL_musicstatusz00_bglt)COBJECT(BgL_i1104z00_893))->BgL_statez00)=((obj_t)
CNST_TABLE_REF(((long)21))),BUNSPEC); } 
BGl_musiczd2errorzd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)
((BgL_musicbufz00_bglt)BgL_amz00_730)), BGl_string1967z00zz__wav_decoderz00); } } } } } } } } } 
{ /* Llib/wav_decoder.scm 261 */
bool_t BgL_test2084z00_1569;
{ /* Llib/wav_decoder.scm 261 */
int BgL_arg1804z00_894;
BgL_arg1804z00_894 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2084z00_1569 = 
(
(long)(BgL_arg1804z00_894)>((long)0)); } 
if(BgL_test2084z00_1569)
{ /* Llib/wav_decoder.scm 261 */
return 
BGl_debugzd2stopz12zc0zz__wav_decoderz00(
(((BgL_musicbufferz00_bglt)COBJECT(
((BgL_musicbufferz00_bglt)BgL_bufferz00_731)))->BgL_urlz00));}  else 
{ /* Llib/wav_decoder.scm 261 */
return BFALSE;} } } } } } } 

}



/* flush~0 */
bool_t BGl_flushze70ze7zz__wav_decoderz00(BgL_musicbufz00_bglt BgL_amz00_758, BgL_wavmusicdecoderz00_bglt BgL_i1099z00_757, int BgL_sza7za7_502)
{
{ /* Llib/wav_decoder.scm 167 */
BGl_flushze70ze7zz__wav_decoderz00:
if(
(
(long)(BgL_sza7za7_502)>((long)0)))
{ /* Llib/wav_decoder.scm 167 */
long BgL_arg1879z00_505;
{ /* Llib/wav_decoder.scm 167 */
obj_t BgL_arg1880z00_506;
BgL_arg1880z00_506 = 
BGl_musicbufzd2writezd2zz__multimediazd2musicbufzd2(BgL_amz00_758, 
(((BgL_wavmusicdecoderz00_bglt)COBJECT(BgL_i1099z00_757))->BgL_outbufz00), 
(long)(BgL_sza7za7_502)); 
BgL_arg1879z00_505 = 
(
(long)(BgL_sza7za7_502)-
(long)CINT(BgL_arg1880z00_506)); } 
{ 
int BgL_sza7za7_1585;
BgL_sza7za7_1585 = 
(int)(BgL_arg1879z00_505); 
BgL_sza7za7_502 = BgL_sza7za7_1585; 
goto BGl_flushze70ze7zz__wav_decoderz00;} }  else 
{ /* Llib/wav_decoder.scm 166 */
return ((bool_t)0);} } 

}



/* inc-tail!~0 */
obj_t BGl_inczd2tailz12ze70z27zz__wav_decoderz00(BgL_musicbufferz00_bglt BgL_i1100z00_762, long BgL_inlenz00_761, BgL_musicbufferz00_bglt BgL_bufferz00_760, obj_t BgL_haszd2beenzd2emptyzd2oncezd2_759, long BgL_siza7eza7_471)
{
{ /* Llib/wav_decoder.scm 152 */
{ 

{ /* Llib/wav_decoder.scm 145 */
long BgL_ntailz00_473;
BgL_ntailz00_473 = 
(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52tailz52)+BgL_siza7eza7_471); 
if(
(BgL_ntailz00_473==BgL_inlenz00_761))
{ /* Llib/wav_decoder.scm 146 */
BgL_ntailz00_473 = ((long)0); }  else 
{ /* Llib/wav_decoder.scm 146 */BFALSE; } 
if(
(BgL_ntailz00_473==
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52headz52)))
{ /* Llib/wav_decoder.scm 149 */
{ /* Llib/wav_decoder.scm 150 */
obj_t BgL_auxz00_763;
BgL_auxz00_763 = BTRUE; 
CELL_SET(BgL_haszd2beenzd2emptyzd2oncezd2_759, BgL_auxz00_763); } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52emptyz52)=((bool_t)((bool_t)1)),BUNSPEC); }  else 
{ /* Llib/wav_decoder.scm 149 */BFALSE; } 
((((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52tailz52)=((long)BgL_ntailz00_473),BUNSPEC); } 
{ /* Llib/wav_decoder.scm 128 */
bool_t BgL_test2088z00_1596;
{ /* Llib/wav_decoder.scm 128 */
int BgL_arg1847z00_470;
BgL_arg1847z00_470 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2088z00_1596 = 
(
(long)(BgL_arg1847z00_470)>=((long)3)); } 
if(BgL_test2088z00_1596)
{ /* Llib/wav_decoder.scm 129 */
long BgL_pz00_431;
BgL_pz00_431 = 
BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(BgL_inlenz00_761, BgL_bufferz00_760); 
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2089z00_1601;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2090z00_1602;
{ /* Llib/wav_decoder.scm 130 */
bool_t BgL_test2091z00_1603;
if(
(BgL_pz00_431<((long)75)))
{ /* Llib/wav_decoder.scm 130 */
BgL_test2091z00_1603 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_test2091z00_1603 = 
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_759))
; } 
if(BgL_test2091z00_1603)
{ /* Llib/wav_decoder.scm 130 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 131 */
BgL_test2090z00_1602 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 131 */
BgL_test2090z00_1602 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 130 */
BgL_test2090z00_1602 = ((bool_t)0)
; } } 
if(BgL_test2090z00_1602)
{ /* Llib/wav_decoder.scm 130 */
BgL_test2089z00_1601 = ((bool_t)1)
; }  else 
{ /* Llib/wav_decoder.scm 132 */
int BgL_arg1846z00_465;
BgL_arg1846z00_465 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2089z00_1601 = 
(
(long)(BgL_arg1846z00_465)>=((long)4)); } } 
if(BgL_test2089z00_1601)
{ /* Llib/wav_decoder.scm 135 */
obj_t BgL_arg1830z00_446;obj_t BgL_arg1831z00_447;obj_t BgL_arg1832z00_448;
if(
(BgL_pz00_431>=((long)80)))
{ /* Llib/wav_decoder.scm 135 */
BgL_arg1830z00_446 = BGl_string1942z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 135 */
if(
(BgL_pz00_431>((long)25)))
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1830z00_446 = BGl_string1968z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 136 */
BgL_arg1830z00_446 = BGl_string1969z00zz__wav_decoderz00; } } 
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1831z00_447 = BGl_string1970z00zz__wav_decoderz00; }  else 
{ /* Llib/wav_decoder.scm 140 */
BgL_arg1831z00_447 = BGl_string1942z00zz__wav_decoderz00; } 
BgL_arg1832z00_448 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_urlz00); 
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_list1833z00_449;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1834z00_450;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1835z00_451;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1836z00_452;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1837z00_453;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1838z00_454;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1839z00_455;
{ /* Llib/wav_decoder.scm 133 */
obj_t BgL_arg1840z00_456;
BgL_arg1840z00_456 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_arg1839z00_455 = 
MAKE_YOUNG_PAIR(BgL_arg1832z00_448, BgL_arg1840z00_456); } 
BgL_arg1838z00_454 = 
MAKE_YOUNG_PAIR(BGl_string1971z00zz__wav_decoderz00, BgL_arg1839z00_455); } 
BgL_arg1837z00_453 = 
MAKE_YOUNG_PAIR(BgL_arg1831z00_447, BgL_arg1838z00_454); } 
BgL_arg1836z00_452 = 
MAKE_YOUNG_PAIR(BGl_string1972z00zz__wav_decoderz00, BgL_arg1837z00_453); } 
BgL_arg1835z00_451 = 
MAKE_YOUNG_PAIR(
BINT(BgL_pz00_431), BgL_arg1836z00_452); } 
BgL_arg1834z00_450 = 
MAKE_YOUNG_PAIR(BgL_arg1830z00_446, BgL_arg1835z00_451); } 
BgL_list1833z00_449 = 
MAKE_YOUNG_PAIR(BGl_string1973z00zz__wav_decoderz00, BgL_arg1834z00_450); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1833z00_449); } }  else 
{ /* Llib/wav_decoder.scm 130 */BFALSE; } } }  else 
{ /* Llib/wav_decoder.scm 128 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_test2097z00_1629;
{ /* Llib/wav_decoder.scm 156 */
bool_t BgL_test2098z00_1630;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1816z00_424;
{ /* Llib/wav_decoder.scm 123 */
long BgL_arg1817z00_425;long BgL_arg1818z00_426;
if(
CBOOL(
CELL_REF(BgL_haszd2beenzd2emptyzd2oncezd2_759)))
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1817z00_425 = ((long)2); }  else 
{ /* Llib/wav_decoder.scm 123 */
BgL_arg1817z00_425 = ((long)4); } 
BgL_arg1818z00_426 = 
(BgL_inlenz00_761-
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_760)); 
BgL_arg1816z00_424 = 
(BgL_arg1817z00_425*BgL_arg1818z00_426); } 
BgL_test2098z00_1630 = 
(BgL_arg1816z00_424>BgL_inlenz00_761); } 
if(BgL_test2098z00_1630)
{ /* Llib/wav_decoder.scm 156 */
if(
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52eofz52))
{ /* Llib/wav_decoder.scm 156 */
BgL_test2097z00_1629 = ((bool_t)0)
; }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_test2097z00_1629 = ((bool_t)1)
; } }  else 
{ /* Llib/wav_decoder.scm 156 */
BgL_test2097z00_1629 = ((bool_t)0)
; } } 
if(BgL_test2097z00_1629)
{ /* Llib/wav_decoder.scm 156 */
{ /* Llib/wav_decoder.scm 157 */
bool_t BgL_test2101z00_1639;
{ /* Llib/wav_decoder.scm 157 */
int BgL_arg1868z00_491;
BgL_arg1868z00_491 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2101z00_1639 = 
(
(long)(BgL_arg1868z00_491)>=((long)2)); } 
if(BgL_test2101z00_1639)
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1861z00_484;BGL_LONGLONG_T BgL_arg1862z00_485;
BgL_arg1861z00_484 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_urlz00); 
BgL_arg1862z00_485 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_list1863z00_486;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1864z00_487;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1865z00_488;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1866z00_489;
{ /* Llib/wav_decoder.scm 158 */
obj_t BgL_arg1867z00_490;
BgL_arg1867z00_490 = 
MAKE_YOUNG_PAIR(BGl_string1956z00zz__wav_decoderz00, BNIL); 
BgL_arg1866z00_489 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1862z00_485), BgL_arg1867z00_490); } 
BgL_arg1865z00_488 = 
MAKE_YOUNG_PAIR(BGl_string1921z00zz__wav_decoderz00, BgL_arg1866z00_489); } 
BgL_arg1864z00_487 = 
MAKE_YOUNG_PAIR(BgL_arg1861z00_484, BgL_arg1865z00_488); } 
BgL_list1863z00_486 = 
MAKE_YOUNG_PAIR(BGl_string1974z00zz__wav_decoderz00, BgL_arg1864z00_487); } 
BGl_debugz00zz__wav_decoderz00(BgL_list1863z00_486); } }  else 
{ /* Llib/wav_decoder.scm 157 */BFALSE; } } 
{ /* Llib/wav_decoder.scm 160 */
obj_t BgL_mutex1869z00_492;
BgL_mutex1869z00_492 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52bmutexz52); 
BGL_MUTEX_LOCK(BgL_mutex1869z00_492); 
{ /* Llib/wav_decoder.scm 160 */
bool_t BgL_tmp2102z00_1653;
{ /* Llib/wav_decoder.scm 161 */
obj_t BgL_tmpz00_1655;
BgL_tmpz00_1655 = 
(((BgL_musicbufferz00_bglt)COBJECT(BgL_i1100z00_762))->BgL_z52bcondvz52); 
BgL_tmp2102z00_1653 = 
BGL_CONDVAR_BROADCAST(BgL_tmpz00_1655); } 
BGL_MUTEX_UNLOCK(BgL_mutex1869z00_492); BgL_tmp2102z00_1653; } } 
{ /* Llib/wav_decoder.scm 162 */
bool_t BgL_test2103z00_1659;
{ /* Llib/wav_decoder.scm 162 */
int BgL_arg1876z00_499;
BgL_arg1876z00_499 = 
BGl_wavzd2debugzd2zz__wav_decoderz00(); 
BgL_test2103z00_1659 = 
(
(long)(BgL_arg1876z00_499)>=((long)2)); } 
if(BgL_test2103z00_1659)
{ /* Llib/wav_decoder.scm 163 */
BGL_LONGLONG_T BgL_arg1873z00_496;
BgL_arg1873z00_496 = 
bgl_current_microseconds(); 
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_list1874z00_497;
{ /* Llib/wav_decoder.scm 163 */
obj_t BgL_arg1875z00_498;
BgL_arg1875z00_498 = 
MAKE_YOUNG_PAIR(BGl_string1920z00zz__wav_decoderz00, BNIL); 
BgL_list1874z00_497 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1873z00_496), BgL_arg1875z00_498); } 
return 
BGl_debugz00zz__wav_decoderz00(BgL_list1874z00_497);} }  else 
{ /* Llib/wav_decoder.scm 162 */
return BFALSE;} } }  else 
{ /* Llib/wav_decoder.scm 156 */
return BFALSE;} } } } 

}



/* buffer-percentage-filled~0 */
long BGl_bufferzd2percentagezd2filledze70ze7zz__wav_decoderz00(long BgL_inlenz00_765, BgL_musicbufferz00_bglt BgL_bufferz00_764)
{
{ /* Llib/wav_decoder.scm 115 */
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1806z00_415;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1807z00_416;BGL_LONGLONG_T BgL_arg1809z00_417;
{ /* Llib/wav_decoder.scm 114 */
BGL_LONGLONG_T BgL_arg1810z00_418;
{ /* Llib/wav_decoder.scm 114 */
long BgL_tmpz00_1668;
BgL_tmpz00_1668 = 
BGl_musicbufferzd2availablezd2zz__multimediazd2musicbufzd2(BgL_bufferz00_764); 
BgL_arg1810z00_418 = 
LONG_TO_LLONG(BgL_tmpz00_1668); } 
BgL_arg1807z00_416 = 
(((BGL_LONGLONG_T)100)*BgL_arg1810z00_418); } 
BgL_arg1809z00_417 = 
LONG_TO_LLONG(BgL_inlenz00_765); 
BgL_arg1806z00_415 = 
(BgL_arg1807z00_416/BgL_arg1809z00_417); } 
return 
LLONG_TO_LONG(BgL_arg1806z00_415);} } 

}



/* &musicdecoder-positio1134 */
obj_t BGl_z62musicdecoderzd2positio1134zb0zz__wav_decoderz00(obj_t BgL_envz00_732, obj_t BgL_decz00_733, obj_t BgL_bz00_734)
{
{ /* Llib/wav_decoder.scm 67 */
return 
BINT(
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_733)))->BgL_z52positionz52));} 

}



/* &musicdecoder-reset!-1132 */
obj_t BGl_z62musicdecoderzd2resetz12zd21132z70zz__wav_decoderz00(obj_t BgL_envz00_735, obj_t BgL_decz00_736)
{
{ /* Llib/wav_decoder.scm 59 */
{ 

((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_736)))->BgL_z52headerz52)=((obj_t)BFALSE),BUNSPEC); 
{ /* Llib/wav_decoder.scm 59 */
obj_t BgL_nextzd2method1131zd2_898;
BgL_nextzd2method1131zd2_898 = 
BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_736)), BGl_musicdecoderzd2resetz12zd2envz12zz__multimediazd2musicbufzd2, BGl_wavmusicdecoderz00zz__wav_decoderz00); 
return 
PROCEDURE_ENTRY(BgL_nextzd2method1131zd2_898)(BgL_nextzd2method1131zd2_898, 
((obj_t)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_736)), BEOA);} } } 

}



/* &musicdecoder-init-wa1130 */
obj_t BGl_z62musicdecoderzd2initzd2wa1130z62zz__wav_decoderz00(obj_t BgL_envz00_737, obj_t BgL_decz00_738)
{
{ /* Llib/wav_decoder.scm 51 */
if(
NULLP(
(((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_738))))->BgL_mimetypesz00)))
{ /* Llib/wav_decoder.scm 53 */
return 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavmusicdecoderz00_bglt)BgL_decz00_738))))->BgL_mimetypesz00)=((obj_t)
CNST_TABLE_REF(((long)22))),BUNSPEC);}  else 
{ /* Llib/wav_decoder.scm 53 */
return BFALSE;} } 

}



/* &object-print-wavmusi1128 */
obj_t BGl_z62objectzd2printzd2wavmusi1128z62zz__wav_decoderz00(obj_t BgL_envz00_739, obj_t BgL_oz00_740, obj_t BgL_portz00_741, obj_t BgL_printzd2slotzd2_742)
{
{ /* Llib/wav_decoder.scm 45 */
{ /* Llib/wav_decoder.scm 46 */
obj_t BgL_tmpz00_1698;
BgL_tmpz00_1698 = 
((obj_t)BgL_portz00_741); 
return 
bgl_display_string(BGl_string1975z00zz__wav_decoderz00, BgL_tmpz00_1698);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_decoderz00()
{
{ /* Llib/wav_decoder.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string1976z00zz__wav_decoderz00));} 

}

#ifdef __cplusplus
}
#endif
