/*===========================================================================*/
/*   (Llib/wav_padec.scm)                                                    */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -safee -unsafe -srfi wav -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/wav_padec.scm -o objs/wav_padec.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <pulse/simple.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_pulseaudiozd2simplezd2_bgl {
   header_t header;
   obj_t widening;
   pa_simple * BgL_z42builtinz42;
   obj_t BgL_srvnamez00;
   obj_t BgL_namez00;
   obj_t BgL_streamz00;
   long BgL_ratez00;
   long BgL_channelsz00;
   int BgL_bpsz00;
   obj_t BgL_formatz00;
} *BgL_pulseaudiozd2simplezd2_bglt;

typedef struct BgL_pulseaudiomusicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
   obj_t BgL_inbufz00;
   obj_t BgL_decodersz00;
   obj_t BgL_mkthreadz00;
   obj_t BgL_timeoutz00;
   obj_t BgL_z52decoderz52;
   obj_t BgL_z52bufferz52;
   obj_t BgL_z52nextbufferz52;
   obj_t BgL_z52playlistz52;
   bool_t BgL_z52areadyz52;
   obj_t BgL_z52amutexz52;
   int BgL_z52z12pidz40;
   obj_t BgL_z52acondvz52;
   struct BgL_pulseaudiozd2simplezd2_bgl * BgL_simplez00;
   obj_t BgL_namez00;
} *BgL_pulseaudiomusicz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_musicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
} *BgL_musicdecoderz00_bglt;

typedef struct BgL_wavinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
   obj_t BgL_audiofmtz00;
   int BgL_byteratez00;
   int BgL_blockalignz00;
   long BgL_chunksiza7eza7;
} *BgL_wavinfoz00_bglt;

typedef struct BgL_wavmusicdecoderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavmusicdecoderz00_bglt;

typedef struct BgL_wavzd2pulseaudiodecoderzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_mimetypesz00;
   int BgL_bufferzd2timezd2nearz00;
   int BgL_bufferzd2siza7ezd2nearzd2ratioz75;
   int BgL_periodzd2siza7ezd2nearzd2ratioz75;
   bool_t BgL_z52z12dpausez40;
   bool_t BgL_z52z12dabortz40;
   bool_t BgL_z52z12stopz40;
   obj_t BgL_z52dmutexz52;
   obj_t BgL_z52dcondvz52;
   obj_t BgL_z52doutcondvz52;
   obj_t BgL_outbufz00;
   obj_t BgL_z52headerz52;
   int BgL_z52cursorz52;
   int BgL_z52siza7ezf5;
   int BgL_z52positionz52;
} *BgL_wavzd2pulseaudiodecoderzd2_bglt;


BGL_IMPORT obj_t BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00;
static obj_t BGl_requirezd2initializa7ationz75zz__wav_padecz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__wav_padecz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__wav_padecz00();
static obj_t BGl_genericzd2initzd2zz__wav_padecz00();
static obj_t BGl_objectzd2initzd2zz__wav_padecz00();
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_IMPORT obj_t BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(BgL_pulseaudiomusicz00_bglt, BgL_pulseaudiozd2simplezd2_bglt);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__wav_padecz00();
static BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1116z62zz__wav_padecz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1119z62zz__wav_padecz00(obj_t);
static obj_t BGl_z62musicdecoderzd2hwparam1107zb0zz__wav_padecz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_conditionzd2variablezd2nilz00zz__threadz00();
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__wav_padecz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_decoderz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__wav_wavz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
static obj_t BGl_cnstzd2initzd2zz__wav_padecz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__wav_padecz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__wav_padecz00();
static obj_t BGl_gczd2rootszd2initz00zz__wav_padecz00();
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_wavmusicdecoderz00zz__wav_decoderz00;
BGL_EXPORTED_DEF obj_t BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00 = BUNSPEC;
static obj_t __cnst[ 3 ] ;


BGL_IMPORT obj_t BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2;
BGL_IMPORT obj_t BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2;
DEFINE_STRING( BGl_string1132z00zz__wav_padecz00, BgL_bgl_string1132za700za7za7_1153za7, "Llib/wav_padec.scm", 18 );
DEFINE_STRING( BGl_string1136z00zz__wav_padecz00, BgL_bgl_string1136za700za7za7_1154za7, "", 0 );
DEFINE_STRING( BGl_string1138z00zz__wav_padecz00, BgL_bgl_string1138za700za7za7_1155za7, "musicdecoder-hwparams-set!", 26 );
DEFINE_STRING( BGl_string1139z00zz__wav_padecz00, BgL_bgl_string1139za700za7za7_1156za7, "__wav_padec", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1133z00zz__wav_padecz00, BgL_bgl_za762za7c3za704anonymo1157za7, BGl_z62zc3z04anonymousza31121ze3ze5zz__wav_padecz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1140z00zz__wav_padecz00, BgL_bgl_string1140za700za7za7_1158za7, "s16 __wav_padec wav-pulseaudiodecoder ", 38 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1134z00zz__wav_padecz00, BgL_bgl_za762lambda1119za7621159z00, BGl_z62lambda1119z62zz__wav_padecz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1135z00zz__wav_padecz00, BgL_bgl_za762lambda1116za7621160z00, BGl_z62lambda1116z62zz__wav_padecz00, 0L, BUNSPEC, 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1137z00zz__wav_padecz00, BgL_bgl_za762musicdecoderza71161z00, BGl_z62musicdecoderzd2hwparam1107zb0zz__wav_padecz00, 0L, BUNSPEC, 3 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__wav_padecz00) );
ADD_ROOT( (void *)(&BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__wav_padecz00(long BgL_checksumz00_158, char * BgL_fromz00_159)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__wav_padecz00))
{ 
BGl_requirezd2initializa7ationz75zz__wav_padecz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__wav_padecz00(); 
BGl_libraryzd2moduleszd2initz00zz__wav_padecz00(); 
BGl_cnstzd2initzd2zz__wav_padecz00(); 
BGl_importedzd2moduleszd2initz00zz__wav_padecz00(); 
BGl_objectzd2initzd2zz__wav_padecz00(); 
BGl_methodzd2initzd2zz__wav_padecz00(); 
return 
BGl_toplevelzd2initzd2zz__wav_padecz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__pulseaudio_simplez00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_musicz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musicbufzd2(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__wav_padec"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__wav_padec"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_cportz00_113;
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_stringz00_121;
BgL_stringz00_121 = BGl_string1140z00zz__wav_padecz00; 
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_startz00_122;
BgL_startz00_122 = 
BINT(((long)0)); 
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_endz00_123;
BgL_endz00_123 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_121))); 
{ /* Llib/wav_padec.scm 15 */

BgL_cportz00_113 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_121, BgL_startz00_122, BgL_endz00_123); } } } } 
{ 
long BgL_iz00_114;
BgL_iz00_114 = ((long)2); 
BgL_loopz00_115:
if(
(BgL_iz00_114==((long)-1)))
{ /* Llib/wav_padec.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 15 */
obj_t BgL_arg1152z00_117;
{ /* Llib/wav_padec.scm 15 */

{ /* Llib/wav_padec.scm 15 */
obj_t BgL_locationz00_119;
BgL_locationz00_119 = 
BBOOL(((bool_t)0)); 
{ /* Llib/wav_padec.scm 15 */

BgL_arg1152z00_117 = 
BGl_readz00zz__readerz00(BgL_cportz00_113, BgL_locationz00_119); } } } 
{ /* Llib/wav_padec.scm 15 */
int BgL_tmpz00_190;
BgL_tmpz00_190 = 
(int)(BgL_iz00_114); 
CNST_TABLE_SET(BgL_tmpz00_190, BgL_arg1152z00_117); } } 
{ /* Llib/wav_padec.scm 15 */
int BgL_auxz00_120;
BgL_auxz00_120 = 
(int)(
(BgL_iz00_114-((long)1))); 
{ 
long BgL_iz00_195;
BgL_iz00_195 = 
(long)(BgL_auxz00_120); 
BgL_iz00_114 = BgL_iz00_195; 
goto BgL_loopz00_115;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1132z00zz__wav_padecz00)); 
BGl_modulezd2initializa7ationz75zz__pulseaudio_pulseaudioz00(((long)0), 
BSTRING_TO_STRING(BGl_string1132z00zz__wav_padecz00)); 
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_arg1114z00_17;obj_t BgL_arg1115z00_18;
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_v1104z00_44;
BgL_v1104z00_44 = 
create_vector(((long)0)); 
BgL_arg1114z00_17 = BgL_v1104z00_44; } 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_v1105z00_45;
BgL_v1105z00_45 = 
create_vector(((long)0)); 
BgL_arg1115z00_18 = BgL_v1105z00_45; } 
return ( 
BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)0)), 
CNST_TABLE_REF(((long)1)), BGl_wavmusicdecoderz00zz__wav_decoderz00, ((long)3710), BGl_proc1135z00zz__wav_padecz00, BGl_proc1134z00zz__wav_padecz00, BGl_musicdecoderzd2initzd2envz00zz__multimediazd2musicbufzd2, BGl_proc1133z00zz__wav_padecz00, BFALSE, BgL_arg1114z00_17, BgL_arg1115z00_18), BUNSPEC) ;} } 

}



/* &<@anonymous:1121> */
obj_t BGl_z62zc3z04anonymousza31121ze3ze5zz__wav_padecz00(obj_t BgL_envz00_83, obj_t BgL_new1096z00_84)
{
{ /* Llib/wav_padec.scm 28 */
{ 
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_auxz00_207;
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_mimetypesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_bufferzd2timezd2nearz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52z12dpausez40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52z12dabortz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52z12stopz40)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52dmutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52dcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52doutcondvz52)=((obj_t)
BGl_conditionzd2variablezd2nilz00zz__threadz00()),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_outbufz00)=((obj_t)BGl_string1136z00zz__wav_padecz00),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52headerz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52cursorz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52siza7ezf5)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84))))->BgL_z52positionz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_207 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_new1096z00_84); 
return 
((obj_t)BgL_auxz00_207);} } 

}



/* &lambda1119 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1119z62zz__wav_padecz00(obj_t BgL_envz00_85)
{
{ /* Llib/wav_padec.scm 28 */
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1095z00_126;
BgL_new1095z00_126 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/wav_padec.scm 28 */
long BgL_arg1120z00_127;
BgL_arg1120z00_127 = 
BGL_CLASS_INDEX(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_126), BgL_arg1120z00_127); } 
return BgL_new1095z00_126;} } 

}



/* &lambda1116 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BGl_z62lambda1116z62zz__wav_padecz00(obj_t BgL_envz00_86, obj_t BgL_mimetypes1080z00_87, obj_t BgL_bufferzd2timezd2near1081z00_88, obj_t BgL_bufferzd2siza7ezd2nearzd2rat1082z75_89, obj_t BgL_periodzd2siza7ezd2nearzd2rat1083z75_90, obj_t BgL_z52z12dpause1084z40_91, obj_t BgL_z52z12dabort1085z40_92, obj_t BgL_z52z12stop1086z40_93, obj_t BgL_z52dmutex1087z52_94, obj_t BgL_z52dcondv1088z52_95, obj_t BgL_z52doutcondv1089z52_96, obj_t BgL_outbuf1090z00_97, obj_t BgL_z52header1091z52_98, obj_t BgL_z52cursor1092z52_99, obj_t BgL_z52siza7e1093zf5_100, obj_t BgL_z52position1094z52_101)
{
{ /* Llib/wav_padec.scm 28 */
{ /* Llib/wav_padec.scm 28 */
int BgL_bufferzd2timezd2near1081z00_129;int BgL_bufferzd2siza7ezd2nearzd2rat1082z75_130;int BgL_periodzd2siza7ezd2nearzd2rat1083z75_131;bool_t BgL_z52z12dpause1084z40_132;bool_t BgL_z52z12dabort1085z40_133;bool_t BgL_z52z12stop1086z40_134;int BgL_z52cursor1092z52_139;int BgL_z52siza7e1093zf5_140;int BgL_z52position1094z52_141;
BgL_bufferzd2timezd2near1081z00_129 = 
CINT(BgL_bufferzd2timezd2near1081z00_88); 
BgL_bufferzd2siza7ezd2nearzd2rat1082z75_130 = 
CINT(BgL_bufferzd2siza7ezd2nearzd2rat1082z75_89); 
BgL_periodzd2siza7ezd2nearzd2rat1083z75_131 = 
CINT(BgL_periodzd2siza7ezd2nearzd2rat1083z75_90); 
BgL_z52z12dpause1084z40_132 = 
CBOOL(BgL_z52z12dpause1084z40_91); 
BgL_z52z12dabort1085z40_133 = 
CBOOL(BgL_z52z12dabort1085z40_92); 
BgL_z52z12stop1086z40_134 = 
CBOOL(BgL_z52z12stop1086z40_93); 
BgL_z52cursor1092z52_139 = 
CINT(BgL_z52cursor1092z52_99); 
BgL_z52siza7e1093zf5_140 = 
CINT(BgL_z52siza7e1093zf5_100); 
BgL_z52position1094z52_141 = 
CINT(BgL_z52position1094z52_101); 
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1103z00_142;
{ /* Llib/wav_padec.scm 28 */
BgL_wavzd2pulseaudiodecoderzd2_bglt BgL_new1102z00_143;
BgL_new1102z00_143 = 
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_wavzd2pulseaudiodecoderzd2_bgl) ))); 
{ /* Llib/wav_padec.scm 28 */
long BgL_arg1118z00_144;
BgL_arg1118z00_144 = 
BGL_CLASS_INDEX(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_143), BgL_arg1118z00_144); } 
BgL_new1103z00_142 = BgL_new1102z00_143; } 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_mimetypesz00)=((obj_t)
((obj_t)BgL_mimetypes1080z00_87)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_bufferzd2timezd2nearz00)=((int)BgL_bufferzd2timezd2near1081z00_129),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_bufferzd2siza7ezd2nearzd2ratioz75)=((int)BgL_bufferzd2siza7ezd2nearzd2rat1082z75_130),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_periodzd2siza7ezd2nearzd2ratioz75)=((int)BgL_periodzd2siza7ezd2nearzd2rat1083z75_131),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52z12dpausez40)=((bool_t)BgL_z52z12dpause1084z40_132),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52z12dabortz40)=((bool_t)BgL_z52z12dabort1085z40_133),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52z12stopz40)=((bool_t)BgL_z52z12stop1086z40_134),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52dmutexz52)=((obj_t)
((obj_t)BgL_z52dmutex1087z52_94)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52dcondvz52)=((obj_t)
((obj_t)BgL_z52dcondv1088z52_95)),BUNSPEC); 
((((BgL_musicdecoderz00_bglt)COBJECT(
((BgL_musicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52doutcondvz52)=((obj_t)
((obj_t)BgL_z52doutcondv1089z52_96)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_outbuf1090z00_97)),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52headerz52)=((obj_t)BgL_z52header1091z52_98),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52cursorz52)=((int)BgL_z52cursor1092z52_139),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52siza7ezf5)=((int)BgL_z52siza7e1093zf5_140),BUNSPEC); 
((((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)BgL_new1103z00_142)))->BgL_z52positionz52)=((int)BgL_z52position1094z52_141),BUNSPEC); 
{ /* Llib/wav_padec.scm 28 */
obj_t BgL_fun1117z00_145;
BgL_fun1117z00_145 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00); 
PROCEDURE_ENTRY(BgL_fun1117z00_145)(BgL_fun1117z00_145, 
((obj_t)BgL_new1103z00_142), BEOA); } 
return BgL_new1103z00_142;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_musicdecoderzd2hwparamszd2setz12zd2envzc0zz__multimediazd2musicbufzd2, BGl_wavzd2pulseaudiodecoderzd2zz__wav_padecz00, BGl_proc1137z00zz__wav_padecz00, BGl_string1138z00zz__wav_padecz00);} 

}



/* &musicdecoder-hwparam1107 */
obj_t BGl_z62musicdecoderzd2hwparam1107zb0zz__wav_padecz00(obj_t BgL_envz00_105, obj_t BgL_decz00_106, obj_t BgL_amz00_107, obj_t BgL_bufferz00_108)
{
{ /* Llib/wav_padec.scm 40 */
{ /* Llib/wav_padec.scm 43 */
BgL_wavinfoz00_bglt BgL_i1099z00_149;
BgL_i1099z00_149 = 
((BgL_wavinfoz00_bglt)
(((BgL_wavmusicdecoderz00_bglt)COBJECT(
((BgL_wavmusicdecoderz00_bglt)
((BgL_wavzd2pulseaudiodecoderzd2_bglt)BgL_decz00_106))))->BgL_z52headerz52)); 
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_arg1122z00_150;
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1101z00_151;
{ /* Llib/wav_padec.scm 45 */
BgL_pulseaudiozd2simplezd2_bglt BgL_new1100z00_152;
BgL_new1100z00_152 = 
((BgL_pulseaudiozd2simplezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pulseaudiozd2simplezd2_bgl) ))); 
{ /* Llib/wav_padec.scm 45 */
long BgL_arg1127z00_153;
BgL_arg1127z00_153 = 
BGL_CLASS_INDEX(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1100z00_152), BgL_arg1127z00_153); } 
BgL_new1101z00_151 = BgL_new1100z00_152; } 
{ 
void * BgL_auxz00_331;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_arg1123z00_154;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_arg1125z00_155;
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_classz00_156;
BgL_classz00_156 = BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00; 
BgL_arg1125z00_155 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_156); } 
BgL_arg1123z00_154 = 
VECTOR_REF(BgL_arg1125z00_155,((long)0)); } 
BgL_auxz00_331 = 
FOREIGN_TO_COBJ(
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1123z00_154)); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_z42builtinz42)=((pa_simple *)BgL_auxz00_331),BUNSPEC); } 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_srvnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_namez00)=((obj_t)
(((BgL_pulseaudiomusicz00_bglt)COBJECT(
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicz00_bglt)BgL_amz00_107))))->BgL_namez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_ratez00)=((long)
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1099z00_149)))->BgL_sampleratez00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_channelsz00)=((long)
(long)(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1099z00_149)))->BgL_channelsz00))),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_bpsz00)=((int)
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_i1099z00_149)))->BgL_bpsz00)),BUNSPEC); 
((((BgL_pulseaudiozd2simplezd2_bglt)COBJECT(BgL_new1101z00_151))->BgL_formatz00)=((obj_t)
CNST_TABLE_REF(((long)2))),BUNSPEC); 
{ /* Llib/wav_padec.scm 45 */
obj_t BgL_fun1126z00_157;
BgL_fun1126z00_157 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pulseaudiozd2simplezd2zz__pulseaudio_simplez00); 
PROCEDURE_ENTRY(BgL_fun1126z00_157)(BgL_fun1126z00_157, 
((obj_t)BgL_new1101z00_151), BEOA); } 
BgL_arg1122z00_150 = BgL_new1101z00_151; } 
return 
BGl_pulseaudiomusiczd2simplezd2setz12z12zz__pulseaudio_musicz00(
((BgL_pulseaudiomusicz00_bglt)
((BgL_musicz00_bglt)BgL_amz00_107)), BgL_arg1122z00_150);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__wav_padecz00()
{
{ /* Llib/wav_padec.scm 15 */
BGl_modulezd2initializa7ationz75zz__wav_wavz00(((long)21080121), 
BSTRING_TO_STRING(BGl_string1139z00zz__wav_padecz00)); 
return 
BGl_modulezd2initializa7ationz75zz__wav_decoderz00(((long)0), 
BSTRING_TO_STRING(BGl_string1139z00zz__wav_padecz00));} 

}

#ifdef __cplusplus
}
#endif
