/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2fun1285za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	static obj_t BGl_z62shrinkzd2nodez121247za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2appzd2ly1262za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2extern1266z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2switch1277z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2kwote1254z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21289z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2cast1268z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2funcall1264z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2conditi1273z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2setq1270z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2sync1258z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2var1287za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2set1283za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2fail1275z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1281za2zzast_shrinkifyz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2variablez121245za2zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2sequenc1256z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2var1252z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2makezd2bo1279za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_gczd2rootszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2app1260z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	extern obj_t BGl_switchz00zzast_nodez00;
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1291za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2atom1250z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[1];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl_za762shrinkifyza712za71802za7,
		BGl_z62shrinkifyz12z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1803z00,
		BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1772z00zzast_shrinkifyz00,
		BgL_bgl_string1772za700za7za7a1804za7, "shrink-variable!1245", 20);
	      DEFINE_STRING(BGl_string1774z00zzast_shrinkifyz00,
		BgL_bgl_string1774za700za7za7a1805za7, "shrink-node!1247", 16);
	      DEFINE_STRING(BGl_string1775z00zzast_shrinkifyz00,
		BgL_bgl_string1775za700za7za7a1806za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1777z00zzast_shrinkifyz00,
		BgL_bgl_string1777za700za7za7a1807za7, "shrink-node!", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1771z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1808z00,
		BGl_z62shrinkzd2variablez121245za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1773z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1809z00,
		BGl_z62shrinkzd2nodez121247za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1776z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1810z00,
		BGl_z62shrinkzd2nodez12zd2atom1250z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1778z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1811z00,
		BGl_z62shrinkzd2nodez12zd2var1252z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1779z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1812z00,
		BGl_z62shrinkzd2nodez12zd2kwote1254z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1780z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1813z00,
		BGl_z62shrinkzd2nodez12zd2sequenc1256z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1781z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1814z00,
		BGl_z62shrinkzd2nodez12zd2sync1258z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1782z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1815z00,
		BGl_z62shrinkzd2nodez12zd2app1260z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1783z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1816z00,
		BGl_z62shrinkzd2nodez12zd2appzd2ly1262za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1784z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1817z00,
		BGl_z62shrinkzd2nodez12zd2funcall1264z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1785z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1818z00,
		BGl_z62shrinkzd2nodez12zd2extern1266z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1786z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1819z00,
		BGl_z62shrinkzd2nodez12zd2cast1268z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1787z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1820z00,
		BGl_z62shrinkzd2nodez12zd2setq1270z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1788z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1821z00,
		BGl_z62shrinkzd2nodez12zd2conditi1273z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1789z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1822z00,
		BGl_z62shrinkzd2nodez12zd2fail1275z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1798z00zzast_shrinkifyz00,
		BgL_bgl_string1798za700za7za7a1823za7, "ast_shrinkify", 13);
	      DEFINE_STRING(BGl_string1799z00zzast_shrinkifyz00,
		BgL_bgl_string1799za700za7za7a1824za7, "shrink-node!1247 ", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1790z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1825z00,
		BGl_z62shrinkzd2nodez12zd2switch1277z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1791z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1826z00,
		BGl_z62shrinkzd2nodez12zd2makezd2bo1279za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1792z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1827z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1281za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1793z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1828z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2set1283za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1794z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1829z00,
		BGl_z62shrinkzd2nodez12zd2letzd2fun1285za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1795z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1830z00,
		BGl_z62shrinkzd2nodez12zd2letzd2var1287za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1796z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1831z00,
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21289z70zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1797z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1832z00,
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1291za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1833z00,
		BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzast_shrinkifyz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_2197, char *BgL_fromz00_2198)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_shrinkifyz00();
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BGl_toplevelzd2initzd2zzast_shrinkifyz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_2090;

				{	/* Ast/shrinkify.scm 15 */
					obj_t BgL_stringz00_2098;

					BgL_stringz00_2098 = BGl_string1799z00zzast_shrinkifyz00;
					{	/* Ast/shrinkify.scm 15 */
						obj_t BgL_startz00_2099;

						BgL_startz00_2099 = BINT(((long) 0));
						{	/* Ast/shrinkify.scm 15 */
							obj_t BgL_endz00_2100;

							BgL_endz00_2100 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2098)));
							{	/* Ast/shrinkify.scm 15 */

								BgL_cportz00_2090 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2098, BgL_startz00_2099, BgL_endz00_2100);
				}}}}
				{
					long BgL_iz00_2091;

					BgL_iz00_2091 = ((long) 0);
				BgL_loopz00_2092:
					if ((BgL_iz00_2091 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg1801z00_2094;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_2096;

										BgL_locationz00_2096 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg1801z00_2094 =
												BGl_readz00zz__readerz00(BgL_cportz00_2090,
												BgL_locationz00_2096);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_tmpz00_2227;

									BgL_tmpz00_2227 = (int) (BgL_iz00_2091);
									CNST_TABLE_SET(BgL_tmpz00_2227, BgL_arg1801z00_2094);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_2097;

								BgL_auxz00_2097 = (int) ((BgL_iz00_2091 - ((long) 1)));
								{
									long BgL_iz00_2232;

									BgL_iz00_2232 = (long) (BgL_auxz00_2097);
									BgL_iz00_2091 = BgL_iz00_2232;
									goto BgL_loopz00_2092;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}

	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_3)
	{
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l1229z00_1367;

				BgL_l1229z00_1367 = BgL_globalsz00_3;
			BgL_zc3z04anonymousza31300ze3z87_1368:
				if (PAIRP(BgL_l1229z00_1367))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_1370;

							BgL_globalz00_1370 = CAR(BgL_l1229z00_1367);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_1371;

								BgL_sfunz00_1371 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_globalz00_1370))))->
									BgL_valuez00);
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g1228z00_1372;

									BgL_g1228z00_1372 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_sfunz00_1371)))->BgL_argsz00);
									{
										obj_t BgL_l1226z00_1374;

										BgL_l1226z00_1374 = BgL_g1228z00_1372;
									BgL_zc3z04anonymousza31302ze3z87_1375:
										if (PAIRP(BgL_l1226z00_1374))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg1304z00_1377;

													BgL_arg1304z00_1377 = CAR(BgL_l1226z00_1374);
													BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
														((BgL_variablez00_bglt) BgL_arg1304z00_1377));
												}
												{
													obj_t BgL_l1226z00_2249;

													BgL_l1226z00_2249 = CDR(BgL_l1226z00_1374);
													BgL_l1226z00_1374 = BgL_l1226z00_2249;
													goto BgL_zc3z04anonymousza31302ze3z87_1375;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg1307z00_1380;

									BgL_arg1307z00_1380 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt)
																	((BgL_globalz00_bglt) BgL_globalz00_1370))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(((BgL_nodez00_bglt)
											BgL_arg1307z00_1380));
								}
							}
						}
						{
							obj_t BgL_l1229z00_2258;

							BgL_l1229z00_2258 = CDR(BgL_l1229z00_1367);
							BgL_l1229z00_1367 = BgL_l1229z00_2258;
							goto BgL_zc3z04anonymousza31300ze3z87_1368;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}

	}



/* &shrinkify! */
	obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t BgL_envz00_2014,
		obj_t BgL_globalsz00_2015)
	{
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2015);
		}

	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_27)
	{
		{	/* Ast/shrinkify.scm 230 */
			{
				obj_t BgL_l1243z00_1385;

				BgL_l1243z00_1385 = BgL_nodeza2za2_27;
			BgL_zc3z04anonymousza31310ze3z87_1386:
				if (PAIRP(BgL_l1243z00_1385))
					{	/* Ast/shrinkify.scm 231 */
						{	/* Ast/shrinkify.scm 231 */
							obj_t BgL_arg1313z00_1388;

							BgL_arg1313z00_1388 = CAR(BgL_l1243z00_1385);
							BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
								((BgL_nodez00_bglt) BgL_arg1313z00_1388));
						}
						{
							obj_t BgL_l1243z00_2266;

							BgL_l1243z00_2266 = CDR(BgL_l1243z00_1385);
							BgL_l1243z00_1385 = BgL_l1243z00_2266;
							goto BgL_zc3z04anonymousza31310ze3z87_1386;
						}
					}
				else
					{	/* Ast/shrinkify.scm 231 */
						return ((bool_t) 1);
					}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1771z00zzast_shrinkifyz00, BGl_variablez00zzast_varz00,
				BGl_string1772z00zzast_shrinkifyz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1773z00zzast_shrinkifyz00, BGl_nodez00zzast_nodez00,
				BGl_string1774z00zzast_shrinkifyz00);
		}

	}



/* &shrink-node!1247 */
	obj_t BGl_z62shrinkzd2nodez121247za2zzast_shrinkifyz00(obj_t BgL_envz00_2020,
		obj_t BgL_nodez00_2021)
	{
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
				BGl_string1775z00zzast_shrinkifyz00,
				((obj_t) ((BgL_nodez00_bglt) BgL_nodez00_2021)));
		}

	}



/* &shrink-variable!1245 */
	obj_t BGl_z62shrinkzd2variablez121245za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2022, obj_t BgL_variablez00_2023)
	{
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 38 */
				bool_t BgL_test1839z00_2274;

				{	/* Ast/shrinkify.scm 38 */
					obj_t BgL_tmpz00_2275;

					{	/* Ast/shrinkify.scm 38 */
						BgL_objectz00_bglt BgL_tmpz00_2276;

						BgL_tmpz00_2276 =
							((BgL_objectz00_bglt)
							((BgL_variablez00_bglt) BgL_variablez00_2023));
						BgL_tmpz00_2275 = BGL_OBJECT_WIDENING(BgL_tmpz00_2276);
					}
					BgL_test1839z00_2274 = CBOOL(BgL_tmpz00_2275);
				}
				if (BgL_test1839z00_2274)
					{	/* Ast/shrinkify.scm 38 */
						{	/* Ast/shrinkify.scm 39 */
							long BgL_arg1329z00_2104;

							{	/* Ast/shrinkify.scm 39 */
								obj_t BgL_arg1331z00_2105;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg1332z00_2106;

									{	/* Ast/shrinkify.scm 39 */
										long BgL_arg1794z00_2107;

										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg1795z00_2108;

											BgL_arg1795z00_2108 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_variablez00_bglt) BgL_variablez00_2023)));
											BgL_arg1794z00_2107 = (BgL_arg1795z00_2108 - OBJECT_TYPE);
										}
										BgL_arg1332z00_2106 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2107);
									}
									BgL_arg1331z00_2105 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1332z00_2106);
								}
								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_tmpz00_2287;

									BgL_tmpz00_2287 = ((obj_t) BgL_arg1331z00_2105);
									BgL_arg1329z00_2104 = BGL_CLASS_INDEX(BgL_tmpz00_2287);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_variablez00_bglt) BgL_variablez00_2023)),
								BgL_arg1329z00_2104);
						}
						{	/* Ast/shrinkify.scm 39 */
							BgL_objectz00_bglt BgL_tmpz00_2293;

							BgL_tmpz00_2293 =
								((BgL_objectz00_bglt)
								((BgL_variablez00_bglt) BgL_variablez00_2023));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2293, BFALSE);
						}
						((BgL_objectz00_bglt)
							((BgL_variablez00_bglt) BgL_variablez00_2023));
						((obj_t) ((BgL_variablez00_bglt) BgL_variablez00_2023));
					}
				else
					{	/* Ast/shrinkify.scm 38 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 40 */
				bool_t BgL_test1840z00_2301;

				{	/* Ast/shrinkify.scm 40 */
					BgL_objectz00_bglt BgL_oz00_2109;

					BgL_oz00_2109 =
						((BgL_objectz00_bglt)
						(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_variablez00_2023)))->
							BgL_valuez00));
					BgL_test1840z00_2301 = CBOOL(BGL_OBJECT_WIDENING(BgL_oz00_2109));
				}
				if (BgL_test1840z00_2301)
					{	/* Ast/shrinkify.scm 41 */
						BgL_valuez00_bglt BgL_o1101z00_2110;

						BgL_o1101z00_2110 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_variablez00_2023)))->
							BgL_valuez00);
						{	/* Ast/shrinkify.scm 41 */
							long BgL_arg1338z00_2111;

							{	/* Ast/shrinkify.scm 41 */
								obj_t BgL_arg1340z00_2112;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg1343z00_2113;

									{	/* Ast/shrinkify.scm 41 */
										long BgL_arg1794z00_2114;

										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg1795z00_2115;

											BgL_arg1795z00_2115 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt) BgL_o1101z00_2110));
											BgL_arg1794z00_2114 = (BgL_arg1795z00_2115 - OBJECT_TYPE);
										}
										BgL_arg1343z00_2113 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2114);
									}
									BgL_arg1340z00_2112 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1343z00_2113);
								}
								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_tmpz00_2314;

									BgL_tmpz00_2314 = ((obj_t) BgL_arg1340z00_2112);
									BgL_arg1338z00_2111 = BGL_CLASS_INDEX(BgL_tmpz00_2314);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_o1101z00_2110), BgL_arg1338z00_2111);
						}
						{	/* Ast/shrinkify.scm 41 */
							BgL_objectz00_bglt BgL_tmpz00_2319;

							BgL_tmpz00_2319 = ((BgL_objectz00_bglt) BgL_o1101z00_2110);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2319, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_o1101z00_2110);
						return ((obj_t) BgL_o1101z00_2110);
					}
				else
					{	/* Ast/shrinkify.scm 40 */
						return BFALSE;
					}
			}
		}

	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_4)
	{
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method1246z00_1411;

				{	/* Ast/shrinkify.scm 37 */
					obj_t BgL_res1765z00_1833;

					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1804;

						BgL_objzd2classzd2numz00_1804 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_variablez00_4));
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg1791z00_1805;

							BgL_arg1791z00_1805 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								int BgL_offsetz00_1808;

								BgL_offsetz00_1808 = (int) (BgL_objzd2classzd2numz00_1804);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1809;

									BgL_offsetz00_1809 =
										((long) (BgL_offsetz00_1808) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1810;

										BgL_modz00_1810 =
											(BgL_offsetz00_1809 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1812;

											BgL_restz00_1812 =
												(BgL_offsetz00_1809 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/shrinkify.scm 37 */

												{	/* Ast/shrinkify.scm 37 */
													obj_t BgL_bucketz00_1814;

													BgL_bucketz00_1814 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_1805), BgL_modz00_1810);
													BgL_res1765z00_1833 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1814), BgL_restz00_1812);
					}}}}}}}}
					BgL_method1246z00_1411 = BgL_res1765z00_1833;
				}
				return
					PROCEDURE_ENTRY(BgL_method1246z00_1411) (BgL_method1246z00_1411,
					((obj_t) BgL_variablez00_4), BEOA);
			}
		}

	}



/* &shrink-variable! */
	obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t BgL_envz00_2016,
		obj_t BgL_variablez00_2017)
	{
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				((BgL_variablez00_bglt) BgL_variablez00_2017));
		}

	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method1248z00_1412;

				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_res1770z00_1864;

					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1835;

						BgL_objzd2classzd2numz00_1835 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg1791z00_1836;

							BgL_arg1791z00_1836 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								int BgL_offsetz00_1839;

								BgL_offsetz00_1839 = (int) (BgL_objzd2classzd2numz00_1835);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1840;

									BgL_offsetz00_1840 =
										((long) (BgL_offsetz00_1839) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1841;

										BgL_modz00_1841 =
											(BgL_offsetz00_1840 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1843;

											BgL_restz00_1843 =
												(BgL_offsetz00_1840 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/shrinkify.scm 46 */

												{	/* Ast/shrinkify.scm 46 */
													obj_t BgL_bucketz00_1845;

													BgL_bucketz00_1845 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_1836), BgL_modz00_1841);
													BgL_res1770z00_1864 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_1845), BgL_restz00_1843);
					}}}}}}}}
					BgL_method1248z00_1412 = BgL_res1770z00_1864;
				}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_2089;

					BgL_xz00_2089 =
						PROCEDURE_ENTRY(BgL_method1248z00_1412) (BgL_method1248z00_1412,
						((obj_t) BgL_nodez00_5), BEOA);
					return BUNSPEC;
				}
			}
		}

	}



/* &shrink-node! */
	obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t BgL_envz00_2024,
		obj_t BgL_nodez00_2025)
	{
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				((BgL_nodez00_bglt) BgL_nodez00_2025));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc1776z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc1778z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc1779z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc1780z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_syncz00zzast_nodez00, BGl_proc1781z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc1782z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1783z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc1784z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc1785z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc1786z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc1787z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1788z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc1789z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_switchz00zzast_nodez00, BGl_proc1790z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1791z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1792z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1793z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1794z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1795z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1796z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1797z00zzast_shrinkifyz00,
				BGl_string1777z00zzast_shrinkifyz00);
		}

	}



/* &shrink-node!-jump-ex1291 */
	obj_t BGl_z62shrinkzd2nodez12zd2jumpzd2ex1291za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2047, obj_t BgL_nodez00_2048)
	{
		{	/* Ast/shrinkify.scm 222 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2048)))->BgL_exitz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2048)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-set-ex-1289 */
	obj_t BGl_z62shrinkzd2nodez12zd2setzd2exzd21289z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2049, obj_t BgL_nodez00_2050)
	{
		{	/* Ast/shrinkify.scm 213 */
			{	/* Ast/shrinkify.scm 215 */
				BgL_varz00_bglt BgL_arg1615z00_2118;

				BgL_arg1615z00_2118 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2050)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1615z00_2118));
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2050)))->BgL_bodyz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-let-var1287 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2var1287za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2051, obj_t BgL_nodez00_2052)
	{
		{	/* Ast/shrinkify.scm 201 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2052)))->BgL_bodyz00));
			{	/* Ast/shrinkify.scm 204 */
				obj_t BgL_g1242z00_2120;

				BgL_g1242z00_2120 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_2052)))->BgL_bindingsz00);
				{
					obj_t BgL_l1240z00_2122;

					BgL_l1240z00_2122 = BgL_g1242z00_2120;
				BgL_zc3z04anonymousza31604ze3z87_2121:
					if (PAIRP(BgL_l1240z00_2122))
						{	/* Ast/shrinkify.scm 204 */
							{	/* Ast/shrinkify.scm 205 */
								obj_t BgL_bindingz00_2123;

								BgL_bindingz00_2123 = CAR(BgL_l1240z00_2122);
								{	/* Ast/shrinkify.scm 205 */
									obj_t BgL_arg1612z00_2124;

									BgL_arg1612z00_2124 = CAR(((obj_t) BgL_bindingz00_2123));
									BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
										((BgL_variablez00_bglt) BgL_arg1612z00_2124));
								}
								{	/* Ast/shrinkify.scm 206 */
									obj_t BgL_arg1613z00_2125;

									BgL_arg1613z00_2125 = CDR(((obj_t) BgL_bindingz00_2123));
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
										((BgL_nodez00_bglt) BgL_arg1613z00_2125));
								}
							}
							{
								obj_t BgL_l1240z00_2438;

								BgL_l1240z00_2438 = CDR(BgL_l1240z00_2122);
								BgL_l1240z00_2122 = BgL_l1240z00_2438;
								goto BgL_zc3z04anonymousza31604ze3z87_2121;
							}
						}
					else
						{	/* Ast/shrinkify.scm 204 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-let-fun1285 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2fun1285za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2053, obj_t BgL_nodez00_2054)
	{
		{	/* Ast/shrinkify.scm 187 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2054)))->BgL_bodyz00));
			{	/* Ast/shrinkify.scm 190 */
				obj_t BgL_g1239z00_2127;

				BgL_g1239z00_2127 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_2054)))->BgL_localsz00);
				{
					obj_t BgL_l1237z00_2129;

					BgL_l1237z00_2129 = BgL_g1239z00_2127;
				BgL_zc3z04anonymousza31585ze3z87_2128:
					if (PAIRP(BgL_l1237z00_2129))
						{	/* Ast/shrinkify.scm 190 */
							{	/* Ast/shrinkify.scm 191 */
								obj_t BgL_localz00_2130;

								BgL_localz00_2130 = CAR(BgL_l1237z00_2129);
								{	/* Ast/shrinkify.scm 191 */
									BgL_valuez00_bglt BgL_sfunz00_2131;

									BgL_sfunz00_2131 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_localz00_2130))))->
										BgL_valuez00);
									BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00((
											(BgL_variablez00_bglt) BgL_localz00_2130));
									{	/* Ast/shrinkify.scm 193 */
										obj_t BgL_g1236z00_2132;

										BgL_g1236z00_2132 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_sfunz00_2131)))->BgL_argsz00);
										{
											obj_t BgL_l1234z00_2134;

											BgL_l1234z00_2134 = BgL_g1236z00_2132;
										BgL_zc3z04anonymousza31587ze3z87_2133:
											if (PAIRP(BgL_l1234z00_2134))
												{	/* Ast/shrinkify.scm 193 */
													{	/* Ast/shrinkify.scm 193 */
														obj_t BgL_arg1597z00_2135;

														BgL_arg1597z00_2135 = CAR(BgL_l1234z00_2134);
														BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
															((BgL_variablez00_bglt) BgL_arg1597z00_2135));
													}
													{
														obj_t BgL_l1234z00_2460;

														BgL_l1234z00_2460 = CDR(BgL_l1234z00_2134);
														BgL_l1234z00_2134 = BgL_l1234z00_2460;
														goto BgL_zc3z04anonymousza31587ze3z87_2133;
													}
												}
											else
												{	/* Ast/shrinkify.scm 193 */
													((bool_t) 1);
												}
										}
									}
									{	/* Ast/shrinkify.scm 194 */
										obj_t BgL_arg1599z00_2136;

										BgL_arg1599z00_2136 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_sfunz00_2131)))->BgL_bodyz00);
										BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
											((BgL_nodez00_bglt) BgL_arg1599z00_2136));
									}
								}
							}
							{
								obj_t BgL_l1237z00_2466;

								BgL_l1237z00_2466 = CDR(BgL_l1237z00_2129);
								BgL_l1237z00_2129 = BgL_l1237z00_2466;
								goto BgL_zc3z04anonymousza31585ze3z87_2128;
							}
						}
					else
						{	/* Ast/shrinkify.scm 190 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-box-set1283 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2set1283za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2055, obj_t BgL_nodez00_2056)
	{
		{	/* Ast/shrinkify.scm 178 */
			{	/* Ast/shrinkify.scm 179 */
				bool_t BgL_test1844z00_2468;

				{	/* Ast/shrinkify.scm 179 */
					obj_t BgL_tmpz00_2469;

					{	/* Ast/shrinkify.scm 179 */
						BgL_objectz00_bglt BgL_tmpz00_2470;

						BgL_tmpz00_2470 =
							((BgL_objectz00_bglt)
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056));
						BgL_tmpz00_2469 = BGL_OBJECT_WIDENING(BgL_tmpz00_2470);
					}
					BgL_test1844z00_2468 = CBOOL(BgL_tmpz00_2469);
				}
				if (BgL_test1844z00_2468)
					{	/* Ast/shrinkify.scm 179 */
						{	/* Ast/shrinkify.scm 179 */
							long BgL_arg1573z00_2138;

							{	/* Ast/shrinkify.scm 179 */
								obj_t BgL_arg1579z00_2139;

								{	/* Ast/shrinkify.scm 179 */
									obj_t BgL_arg1580z00_2140;

									{	/* Ast/shrinkify.scm 179 */
										long BgL_arg1794z00_2141;

										{	/* Ast/shrinkify.scm 179 */
											long BgL_arg1795z00_2142;

											BgL_arg1795z00_2142 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056)));
											BgL_arg1794z00_2141 = (BgL_arg1795z00_2142 - OBJECT_TYPE);
										}
										BgL_arg1580z00_2140 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2141);
									}
									BgL_arg1579z00_2139 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1580z00_2140);
								}
								{	/* Ast/shrinkify.scm 179 */
									obj_t BgL_tmpz00_2481;

									BgL_tmpz00_2481 = ((obj_t) BgL_arg1579z00_2139);
									BgL_arg1573z00_2138 = BGL_CLASS_INDEX(BgL_tmpz00_2481);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056)),
								BgL_arg1573z00_2138);
						}
						{	/* Ast/shrinkify.scm 179 */
							BgL_objectz00_bglt BgL_tmpz00_2487;

							BgL_tmpz00_2487 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2487, BFALSE);
						}
						((BgL_objectz00_bglt)
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056));
						((obj_t) ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056));
					}
				else
					{	/* Ast/shrinkify.scm 179 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 180 */
				BgL_varz00_bglt BgL_arg1582z00_2143;

				BgL_arg1582z00_2143 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1582z00_2143));
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2056)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-box-ref1281 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2ref1281za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2057, obj_t BgL_nodez00_2058)
	{
		{	/* Ast/shrinkify.scm 170 */
			{	/* Ast/shrinkify.scm 171 */
				bool_t BgL_test1845z00_2502;

				{	/* Ast/shrinkify.scm 171 */
					obj_t BgL_tmpz00_2503;

					{	/* Ast/shrinkify.scm 171 */
						BgL_objectz00_bglt BgL_tmpz00_2504;

						BgL_tmpz00_2504 =
							((BgL_objectz00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058));
						BgL_tmpz00_2503 = BGL_OBJECT_WIDENING(BgL_tmpz00_2504);
					}
					BgL_test1845z00_2502 = CBOOL(BgL_tmpz00_2503);
				}
				if (BgL_test1845z00_2502)
					{	/* Ast/shrinkify.scm 171 */
						{	/* Ast/shrinkify.scm 171 */
							long BgL_arg1563z00_2145;

							{	/* Ast/shrinkify.scm 171 */
								obj_t BgL_arg1568z00_2146;

								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_arg1569z00_2147;

									{	/* Ast/shrinkify.scm 171 */
										long BgL_arg1794z00_2148;

										{	/* Ast/shrinkify.scm 171 */
											long BgL_arg1795z00_2149;

											BgL_arg1795z00_2149 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058)));
											BgL_arg1794z00_2148 = (BgL_arg1795z00_2149 - OBJECT_TYPE);
										}
										BgL_arg1569z00_2147 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2148);
									}
									BgL_arg1568z00_2146 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1569z00_2147);
								}
								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_tmpz00_2515;

									BgL_tmpz00_2515 = ((obj_t) BgL_arg1568z00_2146);
									BgL_arg1563z00_2145 = BGL_CLASS_INDEX(BgL_tmpz00_2515);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058)),
								BgL_arg1563z00_2145);
						}
						{	/* Ast/shrinkify.scm 171 */
							BgL_objectz00_bglt BgL_tmpz00_2521;

							BgL_tmpz00_2521 =
								((BgL_objectz00_bglt)
								((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2521, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058));
						((obj_t) ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058));
					}
				else
					{	/* Ast/shrinkify.scm 171 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 172 */
				BgL_varz00_bglt BgL_arg1571z00_2150;

				BgL_arg1571z00_2150 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_2058)))->BgL_varz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1571z00_2150));
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-make-bo1279 */
	obj_t BGl_z62shrinkzd2nodez12zd2makezd2bo1279za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2059, obj_t BgL_nodez00_2060)
	{
		{	/* Ast/shrinkify.scm 162 */
			{	/* Ast/shrinkify.scm 163 */
				bool_t BgL_test1846z00_2533;

				{	/* Ast/shrinkify.scm 163 */
					obj_t BgL_tmpz00_2534;

					{	/* Ast/shrinkify.scm 163 */
						BgL_objectz00_bglt BgL_tmpz00_2535;

						BgL_tmpz00_2535 =
							((BgL_objectz00_bglt)
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060));
						BgL_tmpz00_2534 = BGL_OBJECT_WIDENING(BgL_tmpz00_2535);
					}
					BgL_test1846z00_2533 = CBOOL(BgL_tmpz00_2534);
				}
				if (BgL_test1846z00_2533)
					{	/* Ast/shrinkify.scm 163 */
						{	/* Ast/shrinkify.scm 163 */
							long BgL_arg1557z00_2152;

							{	/* Ast/shrinkify.scm 163 */
								obj_t BgL_arg1558z00_2153;

								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_arg1559z00_2154;

									{	/* Ast/shrinkify.scm 163 */
										long BgL_arg1794z00_2155;

										{	/* Ast/shrinkify.scm 163 */
											long BgL_arg1795z00_2156;

											BgL_arg1795z00_2156 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060)));
											BgL_arg1794z00_2155 = (BgL_arg1795z00_2156 - OBJECT_TYPE);
										}
										BgL_arg1559z00_2154 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2155);
									}
									BgL_arg1558z00_2153 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1559z00_2154);
								}
								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_tmpz00_2546;

									BgL_tmpz00_2546 = ((obj_t) BgL_arg1558z00_2153);
									BgL_arg1557z00_2152 = BGL_CLASS_INDEX(BgL_tmpz00_2546);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060)),
								BgL_arg1557z00_2152);
						}
						{	/* Ast/shrinkify.scm 163 */
							BgL_objectz00_bglt BgL_tmpz00_2552;

							BgL_tmpz00_2552 =
								((BgL_objectz00_bglt)
								((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2552, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060));
						((obj_t) ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060));
					}
				else
					{	/* Ast/shrinkify.scm 163 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_2060)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-switch1277 */
	obj_t BGl_z62shrinkzd2nodez12zd2switch1277z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2061, obj_t BgL_nodez00_2062)
	{
		{	/* Ast/shrinkify.scm 152 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2062)))->BgL_testz00));
			{	/* Ast/shrinkify.scm 154 */
				obj_t BgL_g1233z00_2158;

				BgL_g1233z00_2158 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nodez00_2062)))->BgL_clausesz00);
				{
					obj_t BgL_l1231z00_2160;

					BgL_l1231z00_2160 = BgL_g1233z00_2158;
				BgL_zc3z04anonymousza31548ze3z87_2159:
					if (PAIRP(BgL_l1231z00_2160))
						{	/* Ast/shrinkify.scm 156 */
							{	/* Ast/shrinkify.scm 155 */
								obj_t BgL_clausez00_2161;

								BgL_clausez00_2161 = CAR(BgL_l1231z00_2160);
								{	/* Ast/shrinkify.scm 155 */
									obj_t BgL_arg1551z00_2162;

									BgL_arg1551z00_2162 = CDR(((obj_t) BgL_clausez00_2161));
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
										((BgL_nodez00_bglt) BgL_arg1551z00_2162));
								}
							}
							{
								obj_t BgL_l1231z00_2575;

								BgL_l1231z00_2575 = CDR(BgL_l1231z00_2160);
								BgL_l1231z00_2160 = BgL_l1231z00_2575;
								goto BgL_zc3z04anonymousza31548ze3z87_2159;
							}
						}
					else
						{	/* Ast/shrinkify.scm 156 */
							((bool_t) 1);
						}
				}
			}
			return BUNSPEC;
		}

	}



/* &shrink-node!-fail1275 */
	obj_t BGl_z62shrinkzd2nodez12zd2fail1275z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2063, obj_t BgL_nodez00_2064)
	{
		{	/* Ast/shrinkify.scm 143 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2064)))->BgL_procz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2064)))->BgL_msgz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_2064)))->BgL_objz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-conditi1273 */
	obj_t BGl_z62shrinkzd2nodez12zd2conditi1273z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2065, obj_t BgL_nodez00_2066)
	{
		{	/* Ast/shrinkify.scm 134 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2066)))->BgL_testz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2066)))->BgL_truez00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_2066)))->BgL_falsez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-setq1270 */
	obj_t BGl_z62shrinkzd2nodez12zd2setq1270z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2067, obj_t BgL_nodez00_2068)
	{
		{	/* Ast/shrinkify.scm 127 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_2068)))->BgL_valuez00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-cast1268 */
	obj_t BGl_z62shrinkzd2nodez12zd2cast1268z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2069, obj_t BgL_nodez00_2070)
	{
		{	/* Ast/shrinkify.scm 120 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nodez00_2070)))->BgL_argz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-extern1266 */
	obj_t BGl_z62shrinkzd2nodez12zd2extern1266z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2071, obj_t BgL_nodez00_2072)
	{
		{	/* Ast/shrinkify.scm 112 */
			{	/* Ast/shrinkify.scm 113 */
				bool_t BgL_test1848z00_2601;

				{	/* Ast/shrinkify.scm 113 */
					obj_t BgL_tmpz00_2602;

					{	/* Ast/shrinkify.scm 113 */
						BgL_objectz00_bglt BgL_tmpz00_2603;

						BgL_tmpz00_2603 =
							((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2072));
						BgL_tmpz00_2602 = BGL_OBJECT_WIDENING(BgL_tmpz00_2603);
					}
					BgL_test1848z00_2601 = CBOOL(BgL_tmpz00_2602);
				}
				if (BgL_test1848z00_2601)
					{	/* Ast/shrinkify.scm 113 */
						{	/* Ast/shrinkify.scm 113 */
							long BgL_arg1502z00_2168;

							{	/* Ast/shrinkify.scm 113 */
								obj_t BgL_arg1520z00_2169;

								{	/* Ast/shrinkify.scm 113 */
									obj_t BgL_arg1521z00_2170;

									{	/* Ast/shrinkify.scm 113 */
										long BgL_arg1794z00_2171;

										{	/* Ast/shrinkify.scm 113 */
											long BgL_arg1795z00_2172;

											BgL_arg1795z00_2172 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_externz00_bglt) BgL_nodez00_2072)));
											BgL_arg1794z00_2171 = (BgL_arg1795z00_2172 - OBJECT_TYPE);
										}
										BgL_arg1521z00_2170 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2171);
									}
									BgL_arg1520z00_2169 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1521z00_2170);
								}
								{	/* Ast/shrinkify.scm 113 */
									obj_t BgL_tmpz00_2614;

									BgL_tmpz00_2614 = ((obj_t) BgL_arg1520z00_2169);
									BgL_arg1502z00_2168 = BGL_CLASS_INDEX(BgL_tmpz00_2614);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_externz00_bglt) BgL_nodez00_2072)),
								BgL_arg1502z00_2168);
						}
						{	/* Ast/shrinkify.scm 113 */
							BgL_objectz00_bglt BgL_tmpz00_2620;

							BgL_tmpz00_2620 =
								((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2072));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2620, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_externz00_bglt) BgL_nodez00_2072));
						((obj_t) ((BgL_externz00_bglt) BgL_nodez00_2072));
					}
				else
					{	/* Ast/shrinkify.scm 113 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nodez00_2072)))->BgL_exprza2za2));
			return BUNSPEC;
		}

	}



/* &shrink-node!-funcall1264 */
	obj_t BGl_z62shrinkzd2nodez12zd2funcall1264z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2073, obj_t BgL_nodez00_2074)
	{
		{	/* Ast/shrinkify.scm 103 */
			{	/* Ast/shrinkify.scm 104 */
				bool_t BgL_test1849z00_2631;

				{	/* Ast/shrinkify.scm 104 */
					obj_t BgL_tmpz00_2632;

					{	/* Ast/shrinkify.scm 104 */
						BgL_objectz00_bglt BgL_tmpz00_2633;

						BgL_tmpz00_2633 =
							((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2074));
						BgL_tmpz00_2632 = BGL_OBJECT_WIDENING(BgL_tmpz00_2633);
					}
					BgL_test1849z00_2631 = CBOOL(BgL_tmpz00_2632);
				}
				if (BgL_test1849z00_2631)
					{	/* Ast/shrinkify.scm 104 */
						{	/* Ast/shrinkify.scm 104 */
							long BgL_arg1445z00_2174;

							{	/* Ast/shrinkify.scm 104 */
								obj_t BgL_arg1446z00_2175;

								{	/* Ast/shrinkify.scm 104 */
									obj_t BgL_arg1451z00_2176;

									{	/* Ast/shrinkify.scm 104 */
										long BgL_arg1794z00_2177;

										{	/* Ast/shrinkify.scm 104 */
											long BgL_arg1795z00_2178;

											BgL_arg1795z00_2178 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_funcallz00_bglt) BgL_nodez00_2074)));
											BgL_arg1794z00_2177 = (BgL_arg1795z00_2178 - OBJECT_TYPE);
										}
										BgL_arg1451z00_2176 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2177);
									}
									BgL_arg1446z00_2175 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1451z00_2176);
								}
								{	/* Ast/shrinkify.scm 104 */
									obj_t BgL_tmpz00_2644;

									BgL_tmpz00_2644 = ((obj_t) BgL_arg1446z00_2175);
									BgL_arg1445z00_2174 = BGL_CLASS_INDEX(BgL_tmpz00_2644);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_funcallz00_bglt) BgL_nodez00_2074)),
								BgL_arg1445z00_2174);
						}
						{	/* Ast/shrinkify.scm 104 */
							BgL_objectz00_bglt BgL_tmpz00_2650;

							BgL_tmpz00_2650 =
								((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2074));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2650, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_funcallz00_bglt) BgL_nodez00_2074));
						((obj_t) ((BgL_funcallz00_bglt) BgL_nodez00_2074));
					}
				else
					{	/* Ast/shrinkify.scm 104 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2074)))->BgL_funz00));
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nodez00_2074)))->BgL_argsz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-app-ly1262 */
	obj_t BGl_z62shrinkzd2nodez12zd2appzd2ly1262za2zzast_shrinkifyz00(obj_t
		BgL_envz00_2075, obj_t BgL_nodez00_2076)
	{
		{	/* Ast/shrinkify.scm 94 */
			{	/* Ast/shrinkify.scm 95 */
				bool_t BgL_test1850z00_2664;

				{	/* Ast/shrinkify.scm 95 */
					obj_t BgL_tmpz00_2665;

					{	/* Ast/shrinkify.scm 95 */
						BgL_objectz00_bglt BgL_tmpz00_2666;

						BgL_tmpz00_2666 =
							((BgL_objectz00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076));
						BgL_tmpz00_2665 = BGL_OBJECT_WIDENING(BgL_tmpz00_2666);
					}
					BgL_test1850z00_2664 = CBOOL(BgL_tmpz00_2665);
				}
				if (BgL_test1850z00_2664)
					{	/* Ast/shrinkify.scm 95 */
						{	/* Ast/shrinkify.scm 95 */
							long BgL_arg1396z00_2180;

							{	/* Ast/shrinkify.scm 95 */
								obj_t BgL_arg1404z00_2181;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg1409z00_2182;

									{	/* Ast/shrinkify.scm 95 */
										long BgL_arg1794z00_2183;

										{	/* Ast/shrinkify.scm 95 */
											long BgL_arg1795z00_2184;

											BgL_arg1795z00_2184 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076)));
											BgL_arg1794z00_2183 = (BgL_arg1795z00_2184 - OBJECT_TYPE);
										}
										BgL_arg1409z00_2182 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2183);
									}
									BgL_arg1404z00_2181 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1409z00_2182);
								}
								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_tmpz00_2677;

									BgL_tmpz00_2677 = ((obj_t) BgL_arg1404z00_2181);
									BgL_arg1396z00_2180 = BGL_CLASS_INDEX(BgL_tmpz00_2677);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076)),
								BgL_arg1396z00_2180);
						}
						{	/* Ast/shrinkify.scm 95 */
							BgL_objectz00_bglt BgL_tmpz00_2683;

							BgL_tmpz00_2683 =
								((BgL_objectz00_bglt)
								((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2683, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076));
						((obj_t) ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076));
					}
				else
					{	/* Ast/shrinkify.scm 95 */
						BFALSE;
					}
			}
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076)))->BgL_funz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_2076)))->BgL_argz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-app1260 */
	obj_t BGl_z62shrinkzd2nodez12zd2app1260z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2077, obj_t BgL_nodez00_2078)
	{
		{	/* Ast/shrinkify.scm 85 */
			{	/* Ast/shrinkify.scm 86 */
				bool_t BgL_test1851z00_2697;

				{	/* Ast/shrinkify.scm 86 */
					obj_t BgL_tmpz00_2698;

					{	/* Ast/shrinkify.scm 86 */
						BgL_objectz00_bglt BgL_tmpz00_2699;

						BgL_tmpz00_2699 =
							((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2078));
						BgL_tmpz00_2698 = BGL_OBJECT_WIDENING(BgL_tmpz00_2699);
					}
					BgL_test1851z00_2697 = CBOOL(BgL_tmpz00_2698);
				}
				if (BgL_test1851z00_2697)
					{	/* Ast/shrinkify.scm 86 */
						{	/* Ast/shrinkify.scm 86 */
							long BgL_arg1356z00_2186;

							{	/* Ast/shrinkify.scm 86 */
								obj_t BgL_arg1357z00_2187;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg1358z00_2188;

									{	/* Ast/shrinkify.scm 86 */
										long BgL_arg1794z00_2189;

										{	/* Ast/shrinkify.scm 86 */
											long BgL_arg1795z00_2190;

											BgL_arg1795z00_2190 =
												BGL_OBJECT_CLASS_NUM(
												((BgL_objectz00_bglt)
													((BgL_appz00_bglt) BgL_nodez00_2078)));
											BgL_arg1794z00_2189 = (BgL_arg1795z00_2190 - OBJECT_TYPE);
										}
										BgL_arg1358z00_2188 =
											VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
											BgL_arg1794z00_2189);
									}
									BgL_arg1357z00_2187 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg1358z00_2188);
								}
								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_tmpz00_2710;

									BgL_tmpz00_2710 = ((obj_t) BgL_arg1357z00_2187);
									BgL_arg1356z00_2186 = BGL_CLASS_INDEX(BgL_tmpz00_2710);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_appz00_bglt) BgL_nodez00_2078)), BgL_arg1356z00_2186);
						}
						{	/* Ast/shrinkify.scm 86 */
							BgL_objectz00_bglt BgL_tmpz00_2716;

							BgL_tmpz00_2716 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2078));
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2716, BFALSE);
						}
						((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2078));
						((obj_t) ((BgL_appz00_bglt) BgL_nodez00_2078));
					}
				else
					{	/* Ast/shrinkify.scm 86 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 87 */
				BgL_varz00_bglt BgL_arg1367z00_2191;

				BgL_arg1367z00_2191 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2078)))->BgL_funz00);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					((BgL_nodez00_bglt) BgL_arg1367z00_2191));
			}
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nodez00_2078)))->BgL_argsz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-sync1258 */
	obj_t BGl_z62shrinkzd2nodez12zd2sync1258z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2079, obj_t BgL_nodez00_2080)
	{
		{	/* Ast/shrinkify.scm 76 */
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2080)))->BgL_mutexz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2080)))->BgL_prelockz00));
			BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_2080)))->BgL_bodyz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-sequenc1256 */
	obj_t BGl_z62shrinkzd2nodez12zd2sequenc1256z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2081, obj_t BgL_nodez00_2082)
	{
		{	/* Ast/shrinkify.scm 69 */
			BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
				(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nodez00_2082)))->BgL_nodesz00));
			return BUNSPEC;
		}

	}



/* &shrink-node!-kwote1254 */
	obj_t BGl_z62shrinkzd2nodez12zd2kwote1254z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2083, obj_t BgL_nodez00_2084)
	{
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}

	}



/* &shrink-node!-var1252 */
	obj_t BGl_z62shrinkzd2nodez12zd2var1252z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2085, obj_t BgL_nodez00_2086)
	{
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}

	}



/* &shrink-node!-atom1250 */
	obj_t BGl_z62shrinkzd2nodez12zd2atom1250z70zzast_shrinkifyz00(obj_t
		BgL_envz00_2087, obj_t BgL_nodez00_2088)
	{
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1798z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1798z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string1798z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1798z00zzast_shrinkifyz00));
		}

	}

#ifdef __cplusplus
}
#endif
