/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
		bool_t BgL_tailrecz00;
	}               *BgL_isfunz00_bglt;


	static obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	extern obj_t BGl_funz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t, BgL_valuez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	static obj_t BGl_objectzd2initzd2zzast_envz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31314ze3ze5zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	static obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt,
		obj_t);
	static obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	static obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	static obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	static obj_t BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	static obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	static BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	static obj_t BGl_gczd2rootszd2initz00zzast_envz00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_valuez00zzast_varz00;
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31727ze3ze5zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t
		BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	static obj_t __cnst[8];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762addza7d2genvza7121933za7, BGl_z62addzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762findza7d2global1934z00,
		BGl_z62findzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl_za762setza7d2genvza7121935za7, BGl_z62setzd2genvz12za2zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl_za762findza7d2global1936z00, va_generic_entry,
		BGl_z62findzd2globalzb0zzast_envz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl_za762initializa7a7eza71937za7,
		BGl_z62initializa7ezd2Genvz12z05zzast_envz00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762unbindza7d2glob1938z00,
		BGl_z62unbindzd2globalz12za2zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1909z00zzast_envz00,
		BgL_bgl_string1909za700za7za7a1939za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string1910z00zzast_envz00,
		BgL_bgl_string1910za700za7za7a1940za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string1911z00zzast_envz00,
		BgL_bgl_string1911za700za7za7a1941za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string1912z00zzast_envz00,
		BgL_bgl_string1912za700za7za7a1942za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string1913z00zzast_envz00,
		BgL_bgl_string1913za700za7za7a1943za7, "eval", 4);
	      DEFINE_STRING(BGl_string1914z00zzast_envz00,
		BgL_bgl_string1914za700za7za7a1944za7, "unbind-global!", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1908z00zzast_envz00,
		BgL_bgl_za762za7c3za704anonymo1945za7,
		BGl_z62zc3z04anonymousza31314ze3ze5zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1915z00zzast_envz00,
		BgL_bgl_string1915za700za7za7a1946za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string1917z00zzast_envz00,
		BgL_bgl_string1917za700za7za7a1947za7, "restore-value-types!1298", 24);
	      DEFINE_STRING(BGl_string1919z00zzast_envz00,
		BgL_bgl_string1919za700za7za7a1948za7, "restore-value-types!", 20);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl_za762globalza7d2buck1949z00,
		BGl_z62globalzd2bucketzd2positionz62zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1916z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1950z00,
		BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1923z00zzast_envz00,
		BgL_bgl_string1923za700za7za7a1951za7, "head-restore", 12);
	      DEFINE_STRING(BGl_string1924z00zzast_envz00,
		BgL_bgl_string1924za700za7za7a1952za7,
		"Illegal restored type for foreign function", 42);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1918z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1953z00,
		BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1925z00zzast_envz00,
		BgL_bgl_string1925za700za7za7a1954za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string1926z00zzast_envz00,
		BgL_bgl_string1926za700za7za7a1955za7, "Illegal argument", 16);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl_za762getza7d2globalza71956za7,
		BGl_z62getzd2globalzf2modulez42zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1927z00zzast_envz00,
		BgL_bgl_string1927za700za7za7a1957za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string1928z00zzast_envz00,
		BgL_bgl_string1928za700za7za7a1958za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string1929z00zzast_envz00,
		BgL_bgl_string1929za700za7za7a1959za7, "ast_env", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1920z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1960z00,
		BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1921z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1961z00,
		BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1922z00zzast_envz00,
		BgL_bgl_za762restoreza7d2val1962z00,
		BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1930z00zzast_envz00,
		BgL_bgl_string1930za700za7za7a1963za7,
		"_ eval now read @ get-global/module foreign the-global-environment ", 67);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl_za762getza7d2genvza7b01964za7, BGl_z62getzd2genvzb0zzast_envz00, 0L,
		BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl_za762restoreza7d2val1965z00,
		BGl_z62restorezd2valuezd2typesz12z70zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl_za762forza7d2eachza7d21966za7, va_generic_entry,
		BGl_z62forzd2eachzd2globalz12z70zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762bindza7d2global1967z00, BGl_z62bindzd2globalz12za2zzast_envz00,
		0L, BUNSPEC, 6);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl_za762restoreza7d2glo1968z00,
		BGl_z62restorezd2globalz12za2zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl_za762alreadyza7d2res1969z00,
		BGl_z62alreadyzd2restoredzf3z43zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl_za762additionalza7d21970z00,
		BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00, 0L, BUNSPEC,
		0);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_envz00));
		     ADD_ROOT((void *) (&BGl_za2Genvza2z00zzast_envz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00));
		     ADD_ROOT((void *) (&BGl_za2restoredza2z00zzast_envz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_2373, char *BgL_fromz00_2374)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_envz00();
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					return BGl_toplevelzd2initzd2zzast_envz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_2314;

				{	/* Ast/venv.scm 14 */
					obj_t BgL_stringz00_2322;

					BgL_stringz00_2322 = BGl_string1930z00zzast_envz00;
					{	/* Ast/venv.scm 14 */
						obj_t BgL_startz00_2323;

						BgL_startz00_2323 = BINT(((long) 0));
						{	/* Ast/venv.scm 14 */
							obj_t BgL_endz00_2324;

							BgL_endz00_2324 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2322)));
							{	/* Ast/venv.scm 14 */

								BgL_cportz00_2314 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2322, BgL_startz00_2323, BgL_endz00_2324);
				}}}}
				{
					long BgL_iz00_2315;

					BgL_iz00_2315 = ((long) 7);
				BgL_loopz00_2316:
					if ((BgL_iz00_2315 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg1932z00_2318;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_2320;

										BgL_locationz00_2320 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg1932z00_2318 =
												BGl_readz00zz__readerz00(BgL_cportz00_2314,
												BgL_locationz00_2320);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_tmpz00_2406;

									BgL_tmpz00_2406 = (int) (BgL_iz00_2315);
									CNST_TABLE_SET(BgL_tmpz00_2406, BgL_arg1932z00_2318);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_2321;

								BgL_auxz00_2321 = (int) ((BgL_iz00_2315 - ((long) 1)));
								{
									long BgL_iz00_2411;

									BgL_iz00_2411 = (long) (BgL_auxz00_2321);
									BgL_iz00_2315 = BgL_iz00_2411;
									goto BgL_loopz00_2316;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}

	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_3)
	{
		{	/* Ast/venv.scm 55 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_3, BUNSPEC);
		}

	}



/* &set-genv! */
	obj_t BGl_z62setzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2246,
		obj_t BgL_genvz00_2247)
	{
		{	/* Ast/venv.scm 55 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_2247);
		}

	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_4)
	{
		{	/* Ast/venv.scm 64 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_4,
				BGl_proc1908z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}

	}



/* &add-genv! */
	obj_t BGl_z62addzd2genvz12za2zzast_envz00(obj_t BgL_envz00_2249,
		obj_t BgL_genvz00_2250)
	{
		{	/* Ast/venv.scm 64 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_2250);
		}

	}



/* &<@anonymous:1314> */
	obj_t BGl_z62zc3z04anonymousza31314ze3ze5zzast_envz00(obj_t BgL_envz00_2251,
		obj_t BgL_kz00_2252, obj_t BgL_bucketz00_2253)
	{
		{	/* Ast/venv.scm 67 */
			{	/* Ast/venv.scm 68 */
				bool_t BgL_tmpz00_2418;

				{	/* Ast/venv.scm 68 */
					obj_t BgL_g1292z00_2326;

					BgL_g1292z00_2326 = CDR(((obj_t) BgL_bucketz00_2253));
					{
						obj_t BgL_l1290z00_2328;

						BgL_l1290z00_2328 = BgL_g1292z00_2326;
					BgL_zc3z04anonymousza31315ze3z87_2327:
						if (PAIRP(BgL_l1290z00_2328))
							{	/* Ast/venv.scm 88 */
								{	/* Ast/venv.scm 69 */
									obj_t BgL_newz00_2329;

									BgL_newz00_2329 = CAR(BgL_l1290z00_2328);
									BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
										MAKE_YOUNG_PAIR(BgL_newz00_2329,
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
									{	/* Ast/venv.scm 70 */
										obj_t BgL_modulez00_2330;

										BgL_modulez00_2330 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_2329)))->
											BgL_modulez00);
										{	/* Ast/venv.scm 70 */
											obj_t BgL_idz00_2331;

											BgL_idz00_2331 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_globalz00_bglt) BgL_newz00_2329))))->
												BgL_idz00);
											{	/* Ast/venv.scm 71 */
												obj_t BgL_bucketz00_2332;

												BgL_bucketz00_2332 =
													BGl_hashtablezd2getzd2zz__hashz00
													(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_2331);
												{	/* Ast/venv.scm 72 */

													if (PAIRP(BgL_bucketz00_2332))
														{	/* Ast/venv.scm 76 */
															bool_t BgL_test1975z00_2433;

															if (
																(BgL_modulez00_2330 ==
																	BGl_za2moduleza2z00zzmodule_modulez00))
																{	/* Ast/venv.scm 76 */
																	BgL_test1975z00_2433 = ((bool_t) 1);
																}
															else
																{	/* Ast/venv.scm 77 */
																	bool_t BgL_test1977z00_2436;

																	{	/* Ast/venv.scm 78 */
																		obj_t BgL_arg1346z00_2333;

																		{
																			BgL_globalz00_bglt BgL_auxz00_2437;

																			{	/* Ast/venv.scm 78 */
																				obj_t BgL_pairz00_2334;

																				BgL_pairz00_2334 =
																					CDR(BgL_bucketz00_2332);
																				BgL_auxz00_2437 =
																					((BgL_globalz00_bglt)
																					CAR(BgL_pairz00_2334));
																			}
																			BgL_arg1346z00_2333 =
																				(((BgL_globalz00_bglt)
																					COBJECT(BgL_auxz00_2437))->
																				BgL_modulez00);
																		}
																		BgL_test1977z00_2436 =
																			(BGl_za2moduleza2z00zzmodule_modulez00 ==
																			BgL_arg1346z00_2333);
																	}
																	if (BgL_test1977z00_2436)
																		{	/* Ast/venv.scm 77 */
																			BgL_test1975z00_2433 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 77 */
																			BgL_test1975z00_2433 = ((bool_t) 1);
																		}
																}
															if (BgL_test1975z00_2433)
																{	/* Ast/venv.scm 84 */
																	obj_t BgL_newzd2bucketzd2_2335;

																	BgL_newzd2bucketzd2_2335 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2329,
																		CDR(BgL_bucketz00_2332));
																	SET_CDR(BgL_bucketz00_2332,
																		BgL_newzd2bucketzd2_2335);
																}
															else
																{	/* Ast/venv.scm 87 */
																	obj_t BgL_arg1340z00_2336;
																	obj_t BgL_arg1343z00_2337;

																	BgL_arg1340z00_2336 = CDR(BgL_bucketz00_2332);
																	BgL_arg1343z00_2337 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2329,
																		CDR(CDR(BgL_bucketz00_2332)));
																	{	/* Ast/venv.scm 87 */
																		obj_t BgL_tmpz00_2450;

																		BgL_tmpz00_2450 =
																			((obj_t) BgL_arg1340z00_2336);
																		SET_CDR(BgL_tmpz00_2450,
																			BgL_arg1343z00_2337);
																	}
																}
														}
													else
														{	/* Ast/venv.scm 75 */
															obj_t BgL_arg1350z00_2338;

															{	/* Ast/venv.scm 75 */
																obj_t BgL_list1351z00_2339;

																{	/* Ast/venv.scm 75 */
																	obj_t BgL_arg1353z00_2340;

																	BgL_arg1353z00_2340 =
																		MAKE_YOUNG_PAIR(BgL_newz00_2329, BNIL);
																	BgL_list1351z00_2339 =
																		MAKE_YOUNG_PAIR(BgL_idz00_2331,
																		BgL_arg1353z00_2340);
																}
																BgL_arg1350z00_2338 = BgL_list1351z00_2339;
															}
															BGl_hashtablezd2putz12zc0zz__hashz00
																(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_2331,
																BgL_arg1350z00_2338);
														}
												}
											}
										}
									}
								}
								{
									obj_t BgL_l1290z00_2456;

									BgL_l1290z00_2456 = CDR(BgL_l1290z00_2328);
									BgL_l1290z00_2328 = BgL_l1290z00_2456;
									goto BgL_zc3z04anonymousza31315ze3z87_2327;
								}
							}
						else
							{	/* Ast/venv.scm 88 */
								BgL_tmpz00_2418 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_2418);
			}
		}

	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		{	/* Ast/venv.scm 105 */
			{
				obj_t BgL_l1293z00_1594;

				BgL_l1293z00_1594 =
					BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_zc3z04anonymousza31355ze3z87_1595:
				if (PAIRP(BgL_l1293z00_1594))
					{	/* Ast/venv.scm 106 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l1293z00_1594));
						{
							obj_t BgL_l1293z00_2463;

							BgL_l1293z00_2463 = CDR(BgL_l1293z00_1594);
							BgL_l1293z00_1594 = BgL_l1293z00_2463;
							goto BgL_zc3z04anonymousza31355ze3z87_1595;
						}
					}
				else
					{	/* Ast/venv.scm 106 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}

	}



/* &additional-heap-restore-globals! */
	obj_t BGl_z62additionalzd2heapzd2restorezd2globalsz12za2zzast_envz00(obj_t
		BgL_envz00_2254)
	{
		{	/* Ast/venv.scm 105 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}

	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_6)
	{
		{	/* Ast/venv.scm 112 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_YOUNG_PAIR(BgL_newz00_6, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 115 */
				obj_t BgL_idz00_1600;

				BgL_idz00_1600 =
					(((BgL_variablez00_bglt) COBJECT(
							((BgL_variablez00_bglt)
								((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_idz00);
				{	/* Ast/venv.scm 115 */
					BgL_typez00_bglt BgL_typez00_1601;

					BgL_typez00_1601 =
						(((BgL_variablez00_bglt) COBJECT(
								((BgL_variablez00_bglt)
									((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_typez00);
					{	/* Ast/venv.scm 116 */
						BgL_valuez00_bglt BgL_valuez00_1602;

						BgL_valuez00_1602 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt)
										((BgL_globalz00_bglt) BgL_newz00_6))))->BgL_valuez00);
						{	/* Ast/venv.scm 117 */
							obj_t BgL_typeidz00_1603;

							BgL_typeidz00_1603 =
								(((BgL_typez00_bglt) COBJECT(BgL_typez00_1601))->BgL_idz00);
							{	/* Ast/venv.scm 118 */

								{	/* Ast/venv.scm 120 */
									BgL_typez00_bglt BgL_arg1369z00_1604;

									BgL_arg1369z00_1604 =
										BGl_findzd2typezd2zztype_envz00(BgL_typeidz00_1603);
									((((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt)
														((BgL_globalz00_bglt) BgL_newz00_6))))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_arg1369z00_1604), BUNSPEC);
								}
								BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_1602,
									BgL_idz00_1600);
								{	/* Ast/venv.scm 124 */
									bool_t BgL_test1979z00_2482;

									{	/* Ast/venv.scm 124 */
										bool_t BgL_test1980z00_2483;

										{	/* Ast/venv.scm 124 */
											obj_t BgL_arg1484z00_1619;

											BgL_arg1484z00_1619 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_test1980z00_2483 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg1484z00_1619)))->
												BgL_qualifiedzd2typeszd2);
										}
										if (BgL_test1980z00_2483)
											{	/* Ast/venv.scm 124 */
												if (
													((((BgL_globalz00_bglt) COBJECT(
																	((BgL_globalz00_bglt) BgL_newz00_6)))->
															BgL_modulez00) == CNST_TABLE_REF(((long) 1))))
													{	/* Ast/venv.scm 125 */
														BgL_test1979z00_2482 = ((bool_t) 0);
													}
												else
													{	/* Ast/venv.scm 125 */
														BgL_test1979z00_2482 = ((bool_t) 1);
													}
											}
										else
											{	/* Ast/venv.scm 124 */
												BgL_test1979z00_2482 = ((bool_t) 0);
											}
									}
									if (BgL_test1979z00_2482)
										{	/* Ast/venv.scm 126 */
											obj_t BgL_arg1435z00_1612;
											obj_t BgL_arg1436z00_1613;
											obj_t BgL_arg1445z00_1614;

											BgL_arg1435z00_1612 =
												(((BgL_globalz00_bglt) COBJECT(
														((BgL_globalz00_bglt) BgL_newz00_6)))->
												BgL_modulez00);
											BgL_arg1436z00_1613 =
												(((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt)
															BgL_newz00_6)))->BgL_jvmzd2typezd2namez00);
											BgL_arg1445z00_1614 =
												BGl_shapez00zztools_shapez00(BgL_newz00_6);
											{	/* Ast/venv.scm 126 */
												obj_t BgL_list1446z00_1615;

												BgL_list1446z00_1615 =
													MAKE_YOUNG_PAIR(BgL_arg1445z00_1614, BNIL);
												return
													BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
													(BgL_arg1435z00_1612, BgL_arg1436z00_1613,
													BgL_list1446z00_1615);
											}
										}
									else
										{	/* Ast/venv.scm 124 */
											return BFALSE;
										}
								}
							}
						}
					}
				}
			}
		}

	}



/* &restore-global! */
	obj_t BGl_z62restorezd2globalz12za2zzast_envz00(obj_t BgL_envz00_2255,
		obj_t BgL_newz00_2256)
	{
		{	/* Ast/venv.scm 112 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_2256);
		}

	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_8)
	{
		{	/* Ast/venv.scm 147 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_8,
				BGl_za2restoredza2z00zzast_envz00);
		}

	}



/* &already-restored? */
	obj_t BGl_z62alreadyzd2restoredzf3z43zzast_envz00(obj_t BgL_envz00_2257,
		obj_t BgL_funz00_2258)
	{
		{	/* Ast/venv.scm 147 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_2258);
		}

	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 226 */
			return BGl_za2Genvza2z00zzast_envz00;
		}

	}



/* &get-genv */
	obj_t BGl_z62getzd2genvzb0zzast_envz00(obj_t BgL_envz00_2259)
	{
		{	/* Ast/venv.scm 226 */
			return BGl_getzd2genvzd2zzast_envz00();
		}

	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		{	/* Ast/venv.scm 232 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}

	}



/* &initialize-Genv! */
	obj_t BGl_z62initializa7ezd2Genvz12z05zzast_envz00(obj_t BgL_envz00_2260)
	{
		{	/* Ast/venv.scm 232 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}

	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_19,
		obj_t BgL_modulez00_20)
	{
		{	/* Ast/venv.scm 238 */
			{	/* Ast/venv.scm 240 */
				obj_t BgL_bucketz00_1621;
				obj_t BgL_modulez00_1622;

				BgL_bucketz00_1621 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_19);
				if (NULLP(BgL_modulez00_20))
					{	/* Ast/venv.scm 241 */
						BgL_modulez00_1622 = BNIL;
					}
				else
					{	/* Ast/venv.scm 241 */
						BgL_modulez00_1622 = CAR(((obj_t) BgL_modulez00_20));
					}
				if (PAIRP(BgL_bucketz00_1621))
					{	/* Ast/venv.scm 243 */
						if (NULLP(CDR(BgL_bucketz00_1621)))
							{	/* Ast/venv.scm 245 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 245 */
								if (NULLP(BgL_modulez00_1622))
									{	/* Ast/venv.scm 247 */
										return CAR(CDR(BgL_bucketz00_1621));
									}
								else
									{	/* Ast/venv.scm 250 */
										obj_t BgL_g1106z00_1627;

										BgL_g1106z00_1627 = CDR(BgL_bucketz00_1621);
										{
											obj_t BgL_globalsz00_1629;

											BgL_globalsz00_1629 = BgL_g1106z00_1627;
										BgL_zc3z04anonymousza31503ze3z87_1630:
											if (NULLP(BgL_globalsz00_1629))
												{	/* Ast/venv.scm 252 */
													return BFALSE;
												}
											else
												{	/* Ast/venv.scm 252 */
													if (
														((((BgL_globalz00_bglt) COBJECT(
																		((BgL_globalz00_bglt)
																			CAR(
																				((obj_t) BgL_globalsz00_1629)))))->
																BgL_modulez00) == BgL_modulez00_1622))
														{	/* Ast/venv.scm 254 */
															return CAR(((obj_t) BgL_globalsz00_1629));
														}
													else
														{	/* Ast/venv.scm 257 */
															obj_t BgL_arg1526z00_1635;

															BgL_arg1526z00_1635 =
																CDR(((obj_t) BgL_globalsz00_1629));
															{
																obj_t BgL_globalsz00_2532;

																BgL_globalsz00_2532 = BgL_arg1526z00_1635;
																BgL_globalsz00_1629 = BgL_globalsz00_2532;
																goto BgL_zc3z04anonymousza31503ze3z87_1630;
															}
														}
												}
										}
									}
							}
					}
				else
					{	/* Ast/venv.scm 243 */
						return BFALSE;
					}
			}
		}

	}



/* &find-global */
	obj_t BGl_z62findzd2globalzb0zzast_envz00(obj_t BgL_envz00_2261,
		obj_t BgL_idz00_2262, obj_t BgL_modulez00_2263)
	{
		{	/* Ast/venv.scm 238 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_2262, BgL_modulez00_2263);
		}

	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_21, obj_t BgL_modulez00_22)
	{
		{	/* Ast/venv.scm 262 */
			{	/* Ast/venv.scm 263 */
				obj_t BgL_bucketz00_1641;

				BgL_bucketz00_1641 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_21);
				if (PAIRP(BgL_bucketz00_1641))
					{	/* Ast/venv.scm 265 */
						if (NULLP(CDR(BgL_bucketz00_1641)))
							{	/* Ast/venv.scm 267 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 272 */
								obj_t BgL_g1107z00_1646;

								BgL_g1107z00_1646 = CDR(BgL_bucketz00_1641);
								{
									obj_t BgL_globalsz00_1648;

									BgL_globalsz00_1648 = BgL_g1107z00_1646;
								BgL_zc3z04anonymousza31543ze3z87_1649:
									if (NULLP(BgL_globalsz00_1648))
										{	/* Ast/venv.scm 274 */
											return BFALSE;
										}
									else
										{	/* Ast/venv.scm 274 */
											if (
												((((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt)
																	CAR(
																		((obj_t) BgL_globalsz00_1648)))))->
														BgL_modulez00) == BgL_modulez00_22))
												{	/* Ast/venv.scm 276 */
													return CAR(((obj_t) BgL_globalsz00_1648));
												}
											else
												{	/* Ast/venv.scm 279 */
													obj_t BgL_arg1551z00_1654;

													BgL_arg1551z00_1654 =
														CDR(((obj_t) BgL_globalsz00_1648));
													{
														obj_t BgL_globalsz00_2553;

														BgL_globalsz00_2553 = BgL_arg1551z00_1654;
														BgL_globalsz00_1648 = BgL_globalsz00_2553;
														goto BgL_zc3z04anonymousza31543ze3z87_1649;
													}
												}
										}
								}
							}
					}
				else
					{	/* Ast/venv.scm 265 */
						return BFALSE;
					}
			}
		}

	}



/* &find-global/module */
	obj_t BGl_z62findzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2264,
		obj_t BgL_idz00_2265, obj_t BgL_modulez00_2266)
	{
		{	/* Ast/venv.scm 262 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_2265,
				BgL_modulez00_2266);
		}

	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_23, obj_t BgL_modulez00_24)
	{
		{	/* Ast/venv.scm 284 */
			{	/* Ast/venv.scm 285 */
				obj_t BgL_globalz00_1659;

				BgL_globalz00_1659 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_23,
					BgL_modulez00_24);
				{	/* Ast/venv.scm 286 */
					bool_t BgL_test1992z00_2556;

					if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1659,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 286 */
							BgL_test1992z00_2556 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 286 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 286 */
									BgL_test1992z00_2556 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 286 */
									BgL_test1992z00_2556 = ((bool_t) 1);
								}
						}
					if (BgL_test1992z00_2556)
						{	/* Ast/venv.scm 289 */
							obj_t BgL_arg1563z00_1662;

							{	/* Ast/venv.scm 289 */
								obj_t BgL_list1564z00_1663;

								{	/* Ast/venv.scm 289 */
									obj_t BgL_arg1568z00_1664;

									BgL_arg1568z00_1664 = MAKE_YOUNG_PAIR(BgL_modulez00_24, BNIL);
									BgL_list1564z00_1663 =
										MAKE_YOUNG_PAIR(BgL_idz00_23, BgL_arg1568z00_1664);
								}
								BgL_arg1563z00_1662 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string1909z00zzast_envz00, BgL_list1564z00_1663);
							}
							BGl_internalzd2errorzd2zztools_errorz00(CNST_TABLE_REF(((long)
										2)), BGl_string1910z00zzast_envz00, BgL_arg1563z00_1662);
						}
					else
						{	/* Ast/venv.scm 286 */
							BFALSE;
						}
				}
				return BgL_globalz00_1659;
			}
		}

	}



/* &get-global/module */
	obj_t BGl_z62getzd2globalzf2modulez42zzast_envz00(obj_t BgL_envz00_2267,
		obj_t BgL_idz00_2268, obj_t BgL_modulez00_2269)
	{
		{	/* Ast/venv.scm 284 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_2268,
				BgL_modulez00_2269);
		}

	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_25,
		obj_t BgL_oz00_26, obj_t BgL_srcez00_27)
	{
		{	/* Ast/venv.scm 295 */
			{	/* Ast/venv.scm 296 */
				bool_t BgL_test1995z00_2567;

				{	/* Ast/venv.scm 296 */
					bool_t BgL_test1996z00_2568;

					{	/* Ast/venv.scm 296 */
						int BgL_arg1599z00_1686;

						BgL_arg1599z00_1686 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_test1996z00_2568 = ((long) (BgL_arg1599z00_1686) > ((long) 0));
					}
					if (BgL_test1996z00_2568)
						{	/* Ast/venv.scm 296 */
							BgL_test1995z00_2567 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 296 */
							BgL_test1995z00_2567 = ((bool_t) 0);
						}
				}
				if (BgL_test1995z00_2567)
					{	/* Ast/venv.scm 298 */
						obj_t BgL_locz00_1671;
						obj_t BgL_oldz00_1672;
						obj_t BgL_newz00_1673;

						{	/* Ast/venv.scm 298 */
							obj_t BgL__ortest_1109z00_1675;

							{	/* Ast/venv.scm 298 */
								obj_t BgL_arg1573z00_1676;

								BgL_arg1573z00_1676 =
									(((BgL_globalz00_bglt) COBJECT(
											((BgL_globalz00_bglt) BgL_oz00_26)))->BgL_srcz00);
								BgL__ortest_1109z00_1675 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1573z00_1676);
							}
							if (CBOOL(BgL__ortest_1109z00_1675))
								{	/* Ast/venv.scm 298 */
									BgL_locz00_1671 = BgL__ortest_1109z00_1675;
								}
							else
								{	/* Ast/venv.scm 298 */
									BgL_locz00_1671 =
										BGl_findzd2locationzd2zztools_locationz00(BgL_srcez00_27);
								}
						}
						{	/* Ast/venv.scm 299 */
							obj_t BgL_arg1579z00_1677;

							{	/* Ast/venv.scm 299 */
								obj_t BgL_arg1580z00_1678;
								obj_t BgL_arg1582z00_1679;

								BgL_arg1580z00_1678 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_oz00_26))))->BgL_idz00);
								{	/* Ast/venv.scm 299 */
									obj_t BgL_arg1583z00_1680;

									BgL_arg1583z00_1680 =
										(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_oz00_26)))->BgL_modulez00);
									BgL_arg1582z00_1679 =
										MAKE_YOUNG_PAIR(BgL_arg1583z00_1680, BNIL);
								}
								BgL_arg1579z00_1677 =
									MAKE_YOUNG_PAIR(BgL_arg1580z00_1678, BgL_arg1582z00_1679);
							}
							BgL_oldz00_1672 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1579z00_1677);
						}
						{	/* Ast/venv.scm 300 */
							obj_t BgL_arg1584z00_1681;

							{	/* Ast/venv.scm 300 */
								obj_t BgL_arg1585z00_1682;
								obj_t BgL_arg1597z00_1683;

								BgL_arg1585z00_1682 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_nz00_25))))->BgL_idz00);
								{	/* Ast/venv.scm 300 */
									obj_t BgL_arg1598z00_1684;

									BgL_arg1598z00_1684 =
										(((BgL_globalz00_bglt) COBJECT(
												((BgL_globalz00_bglt) BgL_nz00_25)))->BgL_modulez00);
									BgL_arg1597z00_1683 =
										MAKE_YOUNG_PAIR(BgL_arg1598z00_1684, BNIL);
								}
								BgL_arg1584z00_1681 =
									MAKE_YOUNG_PAIR(BgL_arg1585z00_1682, BgL_arg1597z00_1683);
							}
							BgL_newz00_1673 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1584z00_1681);
						}
						if (CBOOL(BgL_locz00_1671))
							{	/* Ast/venv.scm 302 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_1671, BgL_oldz00_1672,
									BGl_string1911z00zzast_envz00, BgL_newz00_1673);
							}
						else
							{	/* Ast/venv.scm 302 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_1672,
									BGl_string1911z00zzast_envz00, BgL_newz00_1673);
							}
					}
				else
					{	/* Ast/venv.scm 296 */
						return BFALSE;
					}
			}
		}

	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_28, obj_t BgL_srcz00_29)
	{
		{	/* Ast/venv.scm 309 */
			{	/* Ast/venv.scm 311 */
				obj_t BgL_locz00_1688;

				BgL_locz00_1688 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_29);
				if (CBOOL(BgL_locz00_1688))
					{	/* Ast/venv.scm 314 */
						obj_t BgL_arg1600z00_1690;
						obj_t BgL_arg1603z00_1691;

						BgL_arg1600z00_1690 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_28))->BgL_modulez00);
						BgL_arg1603z00_1691 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_28));
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_1688,
							BgL_arg1600z00_1690, BGl_string1912z00zzast_envz00,
							BgL_arg1603z00_1691, BNIL);
					}
				else
					{	/* Ast/venv.scm 315 */
						obj_t BgL_arg1605z00_1693;
						obj_t BgL_arg1612z00_1694;

						BgL_arg1605z00_1693 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_28))->BgL_modulez00);
						BgL_arg1612z00_1694 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_28));
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg1605z00_1693,
							BGl_string1912z00zzast_envz00, BgL_arg1612z00_1694, BNIL);
					}
			}
		}

	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(BgL_globalz00_bglt
		BgL_oz00_30, obj_t BgL_srcz00_31)
	{
		{	/* Ast/venv.scm 320 */
			{	/* Ast/venv.scm 322 */
				obj_t BgL_locz00_1697;

				BgL_locz00_1697 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_31);
				if (CBOOL(BgL_locz00_1697))
					{	/* Ast/venv.scm 325 */
						obj_t BgL_arg1614z00_1699;
						obj_t BgL_arg1615z00_1700;

						BgL_arg1614z00_1699 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_30))->BgL_modulez00);
						BgL_arg1615z00_1700 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_30));
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_1697,
							BgL_arg1614z00_1699, BGl_string1912z00zzast_envz00,
							BgL_arg1615z00_1700);
					}
				else
					{	/* Ast/venv.scm 326 */
						obj_t BgL_arg1616z00_1701;
						obj_t BgL_arg1633z00_1702;

						BgL_arg1616z00_1701 =
							(((BgL_globalz00_bglt) COBJECT(BgL_oz00_30))->BgL_modulez00);
						BgL_arg1633z00_1702 =
							BGl_shapez00zztools_shapez00(((obj_t) BgL_oz00_30));
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg1616z00_1701,
							BGl_string1912z00zzast_envz00, BgL_arg1633z00_1702);
					}
			}
		}

	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_32, obj_t BgL_aliasz00_33, obj_t BgL_modulez00_34,
		BgL_valuez00_bglt BgL_valuez00_35, obj_t BgL_importz00_36,
		obj_t BgL_srcz00_37)
	{
		{	/* Ast/venv.scm 343 */
			{	/* Ast/venv.scm 346 */
				obj_t BgL_identz00_1703;

				if (CBOOL(BgL_aliasz00_33))
					{	/* Ast/venv.scm 346 */
						BgL_identz00_1703 = BgL_aliasz00_33;
					}
				else
					{	/* Ast/venv.scm 346 */
						BgL_identz00_1703 = BgL_idz00_32;
					}
				{	/* Ast/venv.scm 346 */
					obj_t BgL_oldz00_1704;

					{	/* Ast/venv.scm 347 */
						obj_t BgL_list1696z00_1744;

						BgL_list1696z00_1744 = MAKE_YOUNG_PAIR(BgL_modulez00_34, BNIL);
						BgL_oldz00_1704 =
							BGl_findzd2globalzd2zzast_envz00(BgL_identz00_1703,
							BgL_list1696z00_1744);
					}
					{	/* Ast/venv.scm 347 */

						if (BGl_isazf3zf3zz__objectz00(BgL_oldz00_1704,
								BGl_globalz00zzast_varz00))
							{	/* Ast/venv.scm 348 */
								if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
									{	/* Ast/venv.scm 350 */
										return ((BgL_globalz00_bglt) BgL_oldz00_1704);
									}
								else
									{	/* Ast/venv.scm 350 */
										if (
											(BgL_modulez00_34 ==
												(((BgL_globalz00_bglt) COBJECT(
															((BgL_globalz00_bglt) BgL_oldz00_1704)))->
													BgL_modulez00)))
											{	/* Ast/venv.scm 352 */
												BGl_warningzd2rebindzd2globalz12z12zzast_envz00(
													((BgL_globalz00_bglt) BgL_oldz00_1704),
													BgL_srcz00_37);
												return ((BgL_globalz00_bglt) BgL_oldz00_1704);
											}
										else
											{	/* Ast/venv.scm 352 */
												return
													((BgL_globalz00_bglt)
													BGl_errorzd2rebindzd2globalz12z12zzast_envz00(
														((BgL_globalz00_bglt) BgL_oldz00_1704),
														BgL_srcz00_37));
											}
									}
							}
						else
							{	/* Ast/venv.scm 357 */
								obj_t BgL_bucketz00_1709;
								BgL_globalz00_bglt BgL_newz00_1710;

								BgL_bucketz00_1709 =
									BGl_hashtablezd2getzd2zz__hashz00
									(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1703);
								{	/* Ast/venv.scm 358 */
									BgL_globalz00_bglt BgL_new1114z00_1740;

									{	/* Ast/venv.scm 364 */
										BgL_globalz00_bglt BgL_new1113z00_1742;

										BgL_new1113z00_1742 =
											((BgL_globalz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
														BgL_globalz00_bgl))));
										{	/* Ast/venv.scm 364 */
											long BgL_arg1695z00_1743;

											BgL_arg1695z00_1743 =
												BGL_CLASS_INDEX(BGl_globalz00zzast_varz00);
											BGL_OBJECT_CLASS_NUM_SET(
												((BgL_objectz00_bglt) BgL_new1113z00_1742),
												BgL_arg1695z00_1743);
										}
										{	/* Ast/venv.scm 364 */
											BgL_objectz00_bglt BgL_tmpz00_2647;

											BgL_tmpz00_2647 =
												((BgL_objectz00_bglt) BgL_new1113z00_1742);
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2647, BFALSE);
										}
										((BgL_objectz00_bglt) BgL_new1113z00_1742);
										BgL_new1114z00_1740 = BgL_new1113z00_1742;
									}
									((((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_new1114z00_1740)))->
											BgL_idz00) = ((obj_t) BgL_identz00_1703), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_namez00) =
										((obj_t) BFALSE), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_typez00) =
										((BgL_typez00_bglt) ((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_valuez00_35), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_accessz00) =
										((obj_t) CNST_TABLE_REF(((long) 4))), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_fastzd2alphazd2) =
										((obj_t) BUNSPEC), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_removablez00) =
										((obj_t) CNST_TABLE_REF(((long) 5))), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_occurrencez00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_occurrencewz00) =
										((long) ((long) 0)), BUNSPEC);
									((((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt)
														BgL_new1114z00_1740)))->BgL_userzf3zf3) =
										((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_modulez00) = ((obj_t) BgL_modulez00_34), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_importz00) = ((obj_t) BgL_importz00_36), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_evaluablezf3zf3) = ((bool_t) ((bool_t) 1)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_evalzf3zf3) = ((bool_t) ((bool_t) 0)), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_libraryz00) = ((obj_t) BFALSE), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_pragmaz00) = ((obj_t) BNIL), BUNSPEC);
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_srcz00) = ((obj_t) BgL_srcz00_37), BUNSPEC);
									{
										obj_t BgL_auxz00_2681;

										if ((BgL_importz00_36 == CNST_TABLE_REF(((long) 6))))
											{	/* Ast/venv.scm 361 */
												BgL_auxz00_2681 = BGl_string1913z00zzast_envz00;
											}
										else
											{	/* Ast/venv.scm 361 */
												BgL_auxz00_2681 =
													BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
													(BgL_modulez00_34);
											}
										((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
												BgL_jvmzd2typezd2namez00) =
											((obj_t) BgL_auxz00_2681), BUNSPEC);
									}
									((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
											BgL_initz00) = ((obj_t) BUNSPEC), BUNSPEC);
									{
										obj_t BgL_auxz00_2688;

										if (CBOOL(BgL_aliasz00_33))
											{	/* Ast/venv.scm 365 */
												BgL_auxz00_2688 = BgL_idz00_32;
											}
										else
											{	/* Ast/venv.scm 365 */
												BgL_auxz00_2688 = BFALSE;
											}
										((((BgL_globalz00_bglt) COBJECT(BgL_new1114z00_1740))->
												BgL_aliasz00) = ((obj_t) BgL_auxz00_2688), BUNSPEC);
									}
									BgL_newz00_1710 = BgL_new1114z00_1740;
								}
								{	/* Ast/venv.scm 371 */
									bool_t BgL_test2007z00_2692;

									if (PAIRP(BgL_bucketz00_1709))
										{	/* Ast/venv.scm 371 */
											BgL_test2007z00_2692 = NULLP(CDR(BgL_bucketz00_1709));
										}
									else
										{	/* Ast/venv.scm 371 */
											BgL_test2007z00_2692 = ((bool_t) 1);
										}
									if (BgL_test2007z00_2692)
										{	/* Ast/venv.scm 371 */
											{	/* Ast/venv.scm 373 */
												obj_t BgL_arg1649z00_1714;

												{	/* Ast/venv.scm 373 */
													obj_t BgL_list1650z00_1715;

													{	/* Ast/venv.scm 373 */
														obj_t BgL_arg1655z00_1716;

														BgL_arg1655z00_1716 =
															MAKE_YOUNG_PAIR(((obj_t) BgL_newz00_1710), BNIL);
														BgL_list1650z00_1715 =
															MAKE_YOUNG_PAIR(BgL_identz00_1703,
															BgL_arg1655z00_1716);
													}
													BgL_arg1649z00_1714 = BgL_list1650z00_1715;
												}
												BGl_hashtablezd2putz12zc0zz__hashz00
													(BGl_za2Genvza2z00zzast_envz00, BgL_identz00_1703,
													BgL_arg1649z00_1714);
											}
											return BgL_newz00_1710;
										}
									else
										{	/* Ast/venv.scm 376 */
											obj_t BgL_oldza2za2_1717;

											BgL_oldza2za2_1717 = CDR(((obj_t) BgL_bucketz00_1709));
											{	/* Ast/venv.scm 376 */
												obj_t BgL_midz00_1718;

												{	/* Ast/venv.scm 378 */
													obj_t BgL_arg1686z00_1736;

													BgL_arg1686z00_1736 =
														(((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt)
																	CAR(
																		((obj_t) BgL_oldza2za2_1717)))))->
														BgL_modulez00);
													BgL_midz00_1718 =
														BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
														(BgL_arg1686z00_1736);
												}
												{	/* Ast/venv.scm 377 */

													{	/* Ast/venv.scm 380 */
														bool_t BgL_test2009z00_2708;

														{	/* Ast/venv.scm 380 */
															obj_t BgL_arg1682z00_1734;

															BgL_arg1682z00_1734 =
																(((BgL_globalz00_bglt) COBJECT(
																		((BgL_globalz00_bglt)
																			CAR(
																				((obj_t) BgL_oldza2za2_1717)))))->
																BgL_modulez00);
															BgL_test2009z00_2708 =
																(BgL_arg1682z00_1734 ==
																BGl_za2moduleza2z00zzmodule_modulez00);
														}
														if (BgL_test2009z00_2708)
															{	/* Ast/venv.scm 380 */
																{	/* Ast/venv.scm 382 */
																	bool_t BgL_test2010z00_2714;

																	if ((BgL_identz00_1703 == BgL_midz00_1718))
																		{	/* Ast/venv.scm 382 */
																			BgL_test2010z00_2714 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 382 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 382 */
																					BgL_test2010z00_2714 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 382 */
																					BgL_test2010z00_2714 = ((bool_t) 1);
																				}
																		}
																	if (BgL_test2010z00_2714)
																		{	/* Ast/venv.scm 383 */
																			obj_t BgL_arg1672z00_1724;

																			BgL_arg1672z00_1724 =
																				CAR(((obj_t) BgL_oldza2za2_1717));
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(BgL_arg1672z00_1724,
																				((obj_t) BgL_newz00_1710),
																				BgL_srcz00_37);
																		}
																	else
																		{	/* Ast/venv.scm 382 */
																			BFALSE;
																		}
																}
																{	/* Ast/venv.scm 384 */
																	obj_t BgL_arg1673z00_1726;
																	obj_t BgL_arg1675z00_1727;

																	BgL_arg1673z00_1726 =
																		CDR(((obj_t) BgL_bucketz00_1709));
																	{	/* Ast/venv.scm 384 */
																		obj_t BgL_arg1676z00_1728;

																		{	/* Ast/venv.scm 384 */
																			obj_t BgL_pairz00_2170;

																			BgL_pairz00_2170 =
																				CDR(((obj_t) BgL_bucketz00_1709));
																			BgL_arg1676z00_1728 =
																				CDR(BgL_pairz00_2170);
																		}
																		BgL_arg1675z00_1727 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_newz00_1710),
																			BgL_arg1676z00_1728);
																	}
																	{	/* Ast/venv.scm 384 */
																		obj_t BgL_tmpz00_2730;

																		BgL_tmpz00_2730 =
																			((obj_t) BgL_arg1673z00_1726);
																		SET_CDR(BgL_tmpz00_2730,
																			BgL_arg1675z00_1727);
																	}
																}
																return BgL_newz00_1710;
															}
														else
															{	/* Ast/venv.scm 387 */
																obj_t BgL_newza2za2_1729;

																BgL_newza2za2_1729 =
																	MAKE_YOUNG_PAIR(
																	((obj_t) BgL_newz00_1710),
																	BgL_oldza2za2_1717);
																{	/* Ast/venv.scm 388 */
																	bool_t BgL_test2013z00_2735;

																	if ((BgL_identz00_1703 == BgL_midz00_1718))
																		{	/* Ast/venv.scm 388 */
																			BgL_test2013z00_2735 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 388 */
																			if (CBOOL
																				(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																				{	/* Ast/venv.scm 388 */
																					BgL_test2013z00_2735 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/venv.scm 388 */
																					BgL_test2013z00_2735 = ((bool_t) 1);
																				}
																		}
																	if (BgL_test2013z00_2735)
																		{	/* Ast/venv.scm 389 */
																			obj_t BgL_arg1679z00_1732;

																			BgL_arg1679z00_1732 =
																				CAR(((obj_t) BgL_oldza2za2_1717));
																			BGl_warningzd2overridezd2globalz12z12zzast_envz00
																				(((obj_t) BgL_newz00_1710),
																				BgL_arg1679z00_1732, BgL_srcz00_37);
																		}
																	else
																		{	/* Ast/venv.scm 388 */
																			BFALSE;
																		}
																}
																{	/* Ast/venv.scm 390 */
																	obj_t BgL_tmpz00_2744;

																	BgL_tmpz00_2744 =
																		((obj_t) BgL_bucketz00_1709);
																	SET_CDR(BgL_tmpz00_2744, BgL_newza2za2_1729);
																}
																return BgL_newz00_1710;
															}
													}
												}
											}
										}
								}
							}
					}
				}
			}
		}

	}



/* &bind-global! */
	BgL_globalz00_bglt BGl_z62bindzd2globalz12za2zzast_envz00(obj_t
		BgL_envz00_2270, obj_t BgL_idz00_2271, obj_t BgL_aliasz00_2272,
		obj_t BgL_modulez00_2273, obj_t BgL_valuez00_2274, obj_t BgL_importz00_2275,
		obj_t BgL_srcz00_2276)
	{
		{	/* Ast/venv.scm 343 */
			return
				BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_2271, BgL_aliasz00_2272,
				BgL_modulez00_2273, ((BgL_valuez00_bglt) BgL_valuez00_2274),
				BgL_importz00_2275, BgL_srcz00_2276);
		}

	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_38, obj_t BgL_modulez00_39)
	{
		{	/* Ast/venv.scm 396 */
			{	/* Ast/venv.scm 397 */
				obj_t BgL_globalz00_1746;

				{	/* Ast/venv.scm 397 */
					obj_t BgL_list1722z00_1765;

					BgL_list1722z00_1765 = MAKE_YOUNG_PAIR(BgL_modulez00_39, BNIL);
					BgL_globalz00_1746 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_38,
						BgL_list1722z00_1765);
				}
				if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_1746,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 400 */
						obj_t BgL_bucketz00_1748;

						BgL_bucketz00_1748 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_38);
						{	/* Ast/venv.scm 401 */
							obj_t BgL_g1115z00_1749;

							BgL_g1115z00_1749 = CDR(((obj_t) BgL_bucketz00_1748));
							{
								obj_t BgL_curz00_1751;
								obj_t BgL_prevz00_1752;

								BgL_curz00_1751 = BgL_g1115z00_1749;
								BgL_prevz00_1752 = BgL_bucketz00_1748;
							BgL_zc3z04anonymousza31698ze3z87_1753:
								if ((CAR(((obj_t) BgL_curz00_1751)) == BgL_globalz00_1746))
									{	/* Ast/venv.scm 404 */
										obj_t BgL_arg1702z00_1756;

										BgL_arg1702z00_1756 = CDR(((obj_t) BgL_curz00_1751));
										{	/* Ast/venv.scm 404 */
											obj_t BgL_tmpz00_2762;

											BgL_tmpz00_2762 = ((obj_t) BgL_prevz00_1752);
											return SET_CDR(BgL_tmpz00_2762, BgL_arg1702z00_1756);
										}
									}
								else
									{	/* Ast/venv.scm 405 */
										obj_t BgL_arg1704z00_1757;
										obj_t BgL_arg1710z00_1758;

										BgL_arg1704z00_1757 = CDR(((obj_t) BgL_curz00_1751));
										BgL_arg1710z00_1758 = CDR(((obj_t) BgL_prevz00_1752));
										{
											obj_t BgL_prevz00_2770;
											obj_t BgL_curz00_2769;

											BgL_curz00_2769 = BgL_arg1704z00_1757;
											BgL_prevz00_2770 = BgL_arg1710z00_1758;
											BgL_prevz00_1752 = BgL_prevz00_2770;
											BgL_curz00_1751 = BgL_curz00_2769;
											goto BgL_zc3z04anonymousza31698ze3z87_1753;
										}
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 399 */
						obj_t BgL_arg1718z00_1761;

						{	/* Ast/venv.scm 399 */
							obj_t BgL_arg1720z00_1763;

							{	/* Ast/venv.scm 399 */
								obj_t BgL_arg1721z00_1764;

								BgL_arg1721z00_1764 = MAKE_YOUNG_PAIR(BgL_modulez00_39, BNIL);
								BgL_arg1720z00_1763 =
									MAKE_YOUNG_PAIR(BgL_idz00_38, BgL_arg1721z00_1764);
							}
							BgL_arg1718z00_1761 =
								MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
								BgL_arg1720z00_1763);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string1914z00zzast_envz00,
							BGl_string1915z00zzast_envz00, BgL_arg1718z00_1761, BNIL);
					}
			}
		}

	}



/* &unbind-global! */
	obj_t BGl_z62unbindzd2globalz12za2zzast_envz00(obj_t BgL_envz00_2277,
		obj_t BgL_idz00_2278, obj_t BgL_modulez00_2279)
	{
		{	/* Ast/venv.scm 396 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_2278,
				BgL_modulez00_2279);
		}

	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_40, obj_t BgL_envz00_41)
	{
		{	/* Ast/venv.scm 410 */
			{	/* Ast/venv.scm 411 */
				obj_t BgL_arg1724z00_1766;

				if (NULLP(BgL_envz00_41))
					{	/* Ast/venv.scm 411 */
						BgL_arg1724z00_1766 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 411 */
						BgL_arg1724z00_1766 = CAR(((obj_t) BgL_envz00_41));
					}
				{	/* Ast/venv.scm 412 */
					obj_t BgL_zc3z04anonymousza31727ze3z87_2280;

					BgL_zc3z04anonymousza31727ze3z87_2280 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31727ze3ze5zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza31727ze3z87_2280,
						(int) (((long) 0)), BgL_procz00_40);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg1724z00_1766,
						BgL_zc3z04anonymousza31727ze3z87_2280);
				}
			}
		}

	}



/* &for-each-global! */
	obj_t BGl_z62forzd2eachzd2globalz12z70zzast_envz00(obj_t BgL_envz00_2281,
		obj_t BgL_procz00_2282, obj_t BgL_envz00_2283)
	{
		{	/* Ast/venv.scm 410 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_2282,
				BgL_envz00_2283);
		}

	}



/* &<@anonymous:1727> */
	obj_t BGl_z62zc3z04anonymousza31727ze3ze5zzast_envz00(obj_t BgL_envz00_2284,
		obj_t BgL_kz00_2286, obj_t BgL_bucketz00_2287)
	{
		{	/* Ast/venv.scm 412 */
			{	/* Ast/venv.scm 412 */
				obj_t BgL_procz00_2285;

				BgL_procz00_2285 =
					((obj_t) PROCEDURE_REF(BgL_envz00_2284, (int) (((long) 0))));
				{	/* Ast/venv.scm 412 */
					bool_t BgL_tmpz00_2791;

					{	/* Ast/venv.scm 412 */
						obj_t BgL_g1297z00_2341;

						BgL_g1297z00_2341 = CDR(((obj_t) BgL_bucketz00_2287));
						{
							obj_t BgL_l1295z00_2343;

							BgL_l1295z00_2343 = BgL_g1297z00_2341;
						BgL_zc3z04anonymousza31728ze3z87_2342:
							if (PAIRP(BgL_l1295z00_2343))
								{	/* Ast/venv.scm 412 */
									{	/* Ast/venv.scm 412 */
										obj_t BgL_arg1732z00_2344;

										BgL_arg1732z00_2344 = CAR(BgL_l1295z00_2343);
										PROCEDURE_ENTRY(BgL_procz00_2285) (BgL_procz00_2285,
											BgL_arg1732z00_2344, BEOA);
									}
									{
										obj_t BgL_l1295z00_2801;

										BgL_l1295z00_2801 = CDR(BgL_l1295z00_2343);
										BgL_l1295z00_2343 = BgL_l1295z00_2801;
										goto BgL_zc3z04anonymousza31728ze3z87_2342;
									}
								}
							else
								{	/* Ast/venv.scm 412 */
									BgL_tmpz00_2791 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_tmpz00_2791);
				}
			}
		}

	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_42, obj_t BgL_modulez00_43)
	{
		{	/* Ast/venv.scm 417 */
			{	/* Ast/venv.scm 418 */
				obj_t BgL_bucketz00_1781;

				BgL_bucketz00_1781 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_42);
				if (PAIRP(BgL_bucketz00_1781))
					{	/* Ast/venv.scm 421 */
						obj_t BgL_g1116z00_1783;

						BgL_g1116z00_1783 = CDR(BgL_bucketz00_1781);
						{
							obj_t BgL_globalsz00_1785;
							long BgL_posz00_1786;

							{	/* Ast/venv.scm 421 */
								long BgL_tmpz00_2808;

								BgL_globalsz00_1785 = BgL_g1116z00_1783;
								BgL_posz00_1786 = ((long) 0);
							BgL_zc3z04anonymousza31735ze3z87_1787:
								if (NULLP(BgL_globalsz00_1785))
									{	/* Ast/venv.scm 424 */
										BgL_tmpz00_2808 = ((long) -1);
									}
								else
									{	/* Ast/venv.scm 424 */
										if (
											((((BgL_globalz00_bglt) COBJECT(
															((BgL_globalz00_bglt)
																CAR(
																	((obj_t) BgL_globalsz00_1785)))))->
													BgL_modulez00) == BgL_modulez00_43))
											{	/* Ast/venv.scm 426 */
												BgL_tmpz00_2808 = BgL_posz00_1786;
											}
										else
											{	/* Ast/venv.scm 429 */
												obj_t BgL_arg1744z00_1792;
												long BgL_arg1746z00_1793;

												BgL_arg1744z00_1792 =
													CDR(((obj_t) BgL_globalsz00_1785));
												BgL_arg1746z00_1793 = (BgL_posz00_1786 + ((long) 1));
												{
													long BgL_posz00_2821;
													obj_t BgL_globalsz00_2820;

													BgL_globalsz00_2820 = BgL_arg1744z00_1792;
													BgL_posz00_2821 = BgL_arg1746z00_1793;
													BgL_posz00_1786 = BgL_posz00_2821;
													BgL_globalsz00_1785 = BgL_globalsz00_2820;
													goto BgL_zc3z04anonymousza31735ze3z87_1787;
												}
											}
									}
								return BINT(BgL_tmpz00_2808);
							}
						}
					}
				else
					{	/* Ast/venv.scm 419 */
						return BINT(((long) -1));
		}}}

	}



/* &global-bucket-position */
	obj_t BGl_z62globalzd2bucketzd2positionz62zzast_envz00(obj_t BgL_envz00_2288,
		obj_t BgL_idz00_2289, obj_t BgL_modulez00_2290)
	{
		{	/* Ast/venv.scm 417 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_2289,
				BgL_modulez00_2290);
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_proc1916z00zzast_envz00, BGl_valuez00zzast_varz00,
				BGl_string1917z00zzast_envz00);
		}

	}



/* &restore-value-types!1298 */
	obj_t BGl_z62restorezd2valuezd2typesz121298z70zzast_envz00(obj_t
		BgL_envz00_2292, obj_t BgL_valuez00_2293, obj_t BgL_idz00_2294)
	{
		{	/* Ast/venv.scm 153 */
			return BUNSPEC;
		}

	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_9, obj_t BgL_idz00_10)
	{
		{	/* Ast/venv.scm 153 */
			{	/* Ast/venv.scm 153 */
				obj_t BgL_method1299z00_1802;

				{	/* Ast/venv.scm 153 */
					obj_t BgL_res1907z00_2219;

					{	/* Ast/venv.scm 153 */
						long BgL_objzd2classzd2numz00_2190;

						BgL_objzd2classzd2numz00_2190 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_valuez00_9));
						{	/* Ast/venv.scm 153 */
							obj_t BgL_arg1791z00_2191;

							BgL_arg1791z00_2191 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 153 */
								int BgL_offsetz00_2194;

								BgL_offsetz00_2194 = (int) (BgL_objzd2classzd2numz00_2190);
								{	/* Ast/venv.scm 153 */
									long BgL_offsetz00_2195;

									BgL_offsetz00_2195 =
										((long) (BgL_offsetz00_2194) - OBJECT_TYPE);
									{	/* Ast/venv.scm 153 */
										long BgL_modz00_2196;

										BgL_modz00_2196 =
											(BgL_offsetz00_2195 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/venv.scm 153 */
											long BgL_restz00_2198;

											BgL_restz00_2198 =
												(BgL_offsetz00_2195 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/venv.scm 153 */

												{	/* Ast/venv.scm 153 */
													obj_t BgL_bucketz00_2200;

													BgL_bucketz00_2200 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2191), BgL_modz00_2196);
													BgL_res1907z00_2219 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2200), BgL_restz00_2198);
					}}}}}}}}
					BgL_method1299z00_1802 = BgL_res1907z00_2219;
				}
				return
					PROCEDURE_ENTRY(BgL_method1299z00_1802) (BgL_method1299z00_1802,
					((obj_t) BgL_valuez00_9), BgL_idz00_10, BEOA);
			}
		}

	}



/* &restore-value-types! */
	obj_t BGl_z62restorezd2valuezd2typesz12z70zzast_envz00(obj_t BgL_envz00_2295,
		obj_t BgL_valuez00_2296, obj_t BgL_idz00_2297)
	{
		{	/* Ast/venv.scm 153 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				((BgL_valuez00_bglt) BgL_valuez00_2296), BgL_idz00_2297);
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc1918z00zzast_envz00,
				BGl_string1919z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc1920z00zzast_envz00,
				BGl_string1919z00zzast_envz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc1921z00zzast_envz00,
				BGl_string1919z00zzast_envz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc1922z00zzast_envz00,
				BGl_string1919z00zzast_envz00);
		}

	}



/* &restore-value-types!1307 */
	obj_t BGl_z62restorezd2valuezd2typesz121307z70zzast_envz00(obj_t
		BgL_envz00_2302, obj_t BgL_valuez00_2303, obj_t BgL_idz00_2304)
	{
		{	/* Ast/venv.scm 208 */
			{	/* Ast/venv.scm 208 */
				bool_t BgL_tmpz00_2863;

				{

					{	/* Ast/venv.scm 208 */
						obj_t BgL_nextzd2method1306zd2_2348;

						BgL_nextzd2method1306zd2_2348 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							((BgL_objectz00_bglt)
								((BgL_cfunz00_bglt) BgL_valuez00_2303)),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_cfunz00zzast_varz00);
						PROCEDURE_ENTRY(BgL_nextzd2method1306zd2_2348)
							(BgL_nextzd2method1306zd2_2348,
							((obj_t) ((BgL_cfunz00_bglt) BgL_valuez00_2303)), BgL_idz00_2304,
							BEOA);
					}
					{
						obj_t BgL_argsz00_2350;

						BgL_argsz00_2350 =
							(((BgL_cfunz00_bglt) COBJECT(
									((BgL_cfunz00_bglt) BgL_valuez00_2303)))->BgL_argszd2typezd2);
					BgL_loopz00_2349:
						if (PAIRP(BgL_argsz00_2350))
							{	/* Ast/venv.scm 212 */
								if (
									((((BgL_typez00_bglt) COBJECT(
													((BgL_typez00_bglt)
														CAR(BgL_argsz00_2350))))->BgL_idz00) ==
										CNST_TABLE_REF(((long) 7))))
									{	/* Ast/venv.scm 214 */
										BGl_userzd2warningzd2zztools_errorz00
											(BGl_string1923z00zzast_envz00,
											BGl_string1924z00zzast_envz00, BgL_idz00_2304);
										SET_CAR(BgL_argsz00_2350, BGl_za2objza2z00zztype_cachez00);
									}
								else
									{	/* Ast/venv.scm 220 */
										BgL_typez00_bglt BgL_arg1818z00_2351;

										{	/* Ast/venv.scm 220 */
											obj_t BgL_arg1819z00_2352;

											BgL_arg1819z00_2352 =
												(((BgL_typez00_bglt) COBJECT(
														((BgL_typez00_bglt)
															CAR(BgL_argsz00_2350))))->BgL_idz00);
											BgL_arg1818z00_2351 =
												BGl_findzd2typezd2zztype_envz00(BgL_arg1819z00_2352);
										}
										{	/* Ast/venv.scm 220 */
											obj_t BgL_tmpz00_2888;

											BgL_tmpz00_2888 = ((obj_t) BgL_arg1818z00_2351);
											SET_CAR(BgL_argsz00_2350, BgL_tmpz00_2888);
										}
									}
								{
									obj_t BgL_argsz00_2891;

									BgL_argsz00_2891 = CDR(BgL_argsz00_2350);
									BgL_argsz00_2350 = BgL_argsz00_2891;
									goto BgL_loopz00_2349;
								}
							}
						else
							{	/* Ast/venv.scm 212 */
								BgL_tmpz00_2863 = ((bool_t) 0);
							}
					}
				}
				return BBOOL(BgL_tmpz00_2863);
			}
		}

	}



/* &restore-value-types!1305 */
	obj_t BGl_z62restorezd2valuezd2typesz121305z70zzast_envz00(obj_t
		BgL_envz00_2305, obj_t BgL_valuez00_2306, obj_t BgL_idz00_2307)
	{
		{	/* Ast/venv.scm 201 */
			{

				{	/* Ast/venv.scm 201 */
					obj_t BgL_nextzd2method1304zd2_2355;

					BgL_nextzd2method1304zd2_2355 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_sfunz00_bglt) BgL_valuez00_2306)),
						BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
						BGl_isfunz00zzinline_inlinez00);
					PROCEDURE_ENTRY(BgL_nextzd2method1304zd2_2355)
						(BgL_nextzd2method1304zd2_2355,
						((obj_t) ((BgL_sfunz00_bglt) BgL_valuez00_2306)), BgL_idz00_2307,
						BEOA);
				}
				{	/* Ast/venv.scm 203 */
					BgL_nodez00_bglt BgL_arg1810z00_2356;

					{
						BgL_isfunz00_bglt BgL_auxz00_2906;

						{
							obj_t BgL_auxz00_2907;

							{	/* Ast/venv.scm 203 */
								BgL_objectz00_bglt BgL_tmpz00_2908;

								BgL_tmpz00_2908 =
									((BgL_objectz00_bglt) ((BgL_sfunz00_bglt) BgL_valuez00_2306));
								BgL_auxz00_2907 = BGL_OBJECT_WIDENING(BgL_tmpz00_2908);
							}
							BgL_auxz00_2906 = ((BgL_isfunz00_bglt) BgL_auxz00_2907);
						}
						BgL_arg1810z00_2356 =
							(((BgL_isfunz00_bglt) COBJECT(BgL_auxz00_2906))->
							BgL_originalzd2bodyzd2);
					}
					return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg1810z00_2356);
				}
			}
		}

	}



/* &restore-value-types!1303 */
	obj_t BGl_z62restorezd2valuezd2typesz121303z70zzast_envz00(obj_t
		BgL_envz00_2308, obj_t BgL_valuez00_2309, obj_t BgL_idz00_2310)
	{
		{	/* Ast/venv.scm 167 */
			{

				{	/* Ast/venv.scm 167 */
					obj_t BgL_nextzd2method1302zd2_2359;

					BgL_nextzd2method1302zd2_2359 =
						BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
						((BgL_objectz00_bglt)
							((BgL_sfunz00_bglt) BgL_valuez00_2309)),
						BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
						BGl_sfunz00zzast_varz00);
					PROCEDURE_ENTRY(BgL_nextzd2method1302zd2_2359)
						(BgL_nextzd2method1302zd2_2359,
						((obj_t) ((BgL_sfunz00_bglt) BgL_valuez00_2309)), BgL_idz00_2310,
						BEOA);
				}
				{
					obj_t BgL_argsz00_2361;

					BgL_argsz00_2361 =
						(((BgL_sfunz00_bglt) COBJECT(
								((BgL_sfunz00_bglt) BgL_valuez00_2309)))->BgL_argsz00);
				BgL_loopz00_2360:
					if (PAIRP(BgL_argsz00_2361))
						{	/* Ast/venv.scm 173 */
							obj_t BgL_argz00_2362;

							BgL_argz00_2362 = CAR(BgL_argsz00_2361);
							if (BGl_isazf3zf3zz__objectz00(BgL_argz00_2362,
									BGl_typez00zztype_typez00))
								{	/* Ast/venv.scm 176 */
									BgL_typez00_bglt BgL_arg1786z00_2363;

									{	/* Ast/venv.scm 176 */
										obj_t BgL_arg1787z00_2364;

										BgL_arg1787z00_2364 =
											(((BgL_typez00_bglt) COBJECT(
													((BgL_typez00_bglt) BgL_argz00_2362)))->BgL_idz00);
										BgL_arg1786z00_2363 =
											BGl_findzd2typezd2zztype_envz00(BgL_arg1787z00_2364);
									}
									{	/* Ast/venv.scm 176 */
										obj_t BgL_tmpz00_2933;

										BgL_tmpz00_2933 = ((obj_t) BgL_arg1786z00_2363);
										SET_CAR(BgL_argsz00_2361, BgL_tmpz00_2933);
									}
								}
							else
								{	/* Ast/venv.scm 175 */
									if (BGl_isazf3zf3zz__objectz00(BgL_argz00_2362,
											BGl_localz00zzast_varz00))
										{	/* Ast/venv.scm 178 */
											BgL_typez00_bglt BgL_newzd2typezd2_2365;

											{	/* Ast/venv.scm 178 */
												obj_t BgL_arg1789z00_2366;

												BgL_arg1789z00_2366 =
													(((BgL_typez00_bglt) COBJECT(
															(((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			((BgL_localz00_bglt) BgL_argz00_2362))))->
																BgL_typez00)))->BgL_idz00);
												BgL_newzd2typezd2_2365 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg1789z00_2366);
											}
											((((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_localz00_bglt) BgL_argz00_2362))))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_newzd2typezd2_2365), BUNSPEC);
										}
									else
										{	/* Ast/venv.scm 177 */
											BGl_errorz00zz__errorz00(BGl_string1925z00zzast_envz00,
												BGl_string1926z00zzast_envz00,
												BGl_shapez00zztools_shapez00(BgL_argz00_2362));
										}
								}
							{
								obj_t BgL_argsz00_2948;

								BgL_argsz00_2948 = CDR(BgL_argsz00_2361);
								BgL_argsz00_2361 = BgL_argsz00_2948;
								goto BgL_loopz00_2360;
							}
						}
					else
						{	/* Ast/venv.scm 172 */
							if (NULLP(BgL_argsz00_2361))
								{	/* Ast/venv.scm 186 */
									obj_t BgL_bodyz00_2367;

									BgL_bodyz00_2367 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_valuez00_2309)))->BgL_bodyz00);
									if (BGl_isazf3zf3zz__objectz00(BgL_bodyz00_2367,
											BGl_nodez00zzast_nodez00))
										{	/* Ast/venv.scm 189 */
											BgL_typez00_bglt BgL_tresz00_2368;

											BgL_tresz00_2368 =
												(((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt) BgL_bodyz00_2367)))->
												BgL_typez00);
											BGl_hrtypezd2nodez12zc0zzast_hrtypez00(((BgL_nodez00_bglt)
													BgL_bodyz00_2367));
											{	/* Ast/venv.scm 192 */
												BgL_typez00_bglt BgL_arg1806z00_2369;

												BgL_arg1806z00_2369 =
													BGl_findzd2typezd2zztype_envz00(
													(((BgL_typez00_bglt) COBJECT(BgL_tresz00_2368))->
														BgL_idz00));
												return ((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																	BgL_bodyz00_2367)))->BgL_typez00) =
													((BgL_typez00_bglt) BgL_arg1806z00_2369), BUNSPEC);
											}
										}
									else
										{	/* Ast/venv.scm 188 */
											return BFALSE;
										}
								}
							else
								{	/* Ast/venv.scm 185 */
									return
										BGl_errorz00zz__errorz00(BGl_string1927z00zzast_envz00,
										BGl_string1928z00zzast_envz00,
										BGl_shapez00zztools_shapez00(BgL_argsz00_2361));
								}
						}
				}
			}
		}

	}



/* &restore-value-types!1301 */
	obj_t BGl_z62restorezd2valuezd2typesz121301z70zzast_envz00(obj_t
		BgL_envz00_2311, obj_t BgL_valuez00_2312, obj_t BgL_idz00_2313)
	{
		{	/* Ast/venv.scm 159 */
			{	/* Ast/venv.scm 161 */
				bool_t BgL_test2030z00_2968;

				{	/* Ast/venv.scm 161 */
					obj_t BgL_arg1764z00_2371;

					BgL_arg1764z00_2371 =
						(((BgL_funz00_bglt) COBJECT(
								((BgL_funz00_bglt) BgL_valuez00_2312)))->BgL_predicatezd2ofzd2);
					BgL_test2030z00_2968 =
						BGl_isazf3zf3zz__objectz00(BgL_arg1764z00_2371,
						BGl_typez00zztype_typez00);
				}
				if (BgL_test2030z00_2968)
					{
						obj_t BgL_auxz00_2972;

						{	/* Ast/venv.scm 162 */
							obj_t BgL_arg1759z00_2372;

							BgL_arg1759z00_2372 =
								(((BgL_typez00_bglt) COBJECT(
										((BgL_typez00_bglt)
											(((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt) BgL_valuez00_2312)))->
												BgL_predicatezd2ofzd2))))->BgL_idz00);
							BgL_auxz00_2972 =
								((obj_t) BGl_findzd2typezd2zztype_envz00(BgL_arg1759z00_2372));
						}
						return
							((((BgL_funz00_bglt) COBJECT(
										((BgL_funz00_bglt) BgL_valuez00_2312)))->
								BgL_predicatezd2ofzd2) = ((obj_t) BgL_auxz00_2972), BUNSPEC);
					}
				else
					{	/* Ast/venv.scm 161 */
						return BFALSE;
					}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 156957722),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 20504962),
				BSTRING_TO_STRING(BGl_string1929z00zzast_envz00));
		}

	}

#ifdef __cplusplus
}
#endif
