/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2funcal1581z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00(obj_t);
	static obj_t BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00(obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2switch1562z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2makezd2b1573za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	static obj_t
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1571za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_z62cleanupzd2nodez121549za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzcfa_arithmeticz00();
	static obj_t BGl_z62cleanupzd2nodez12zd2setq1556z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2va1566za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2fu1564za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2setzd2ex1569za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62nodezd2setupz12zd2prezd2arit1585za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2appzd2ly1579za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2condit1558z70zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	extern obj_t BGl_typez00zztype_typez00;
	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2re1575za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62cleanupzd2nodez12zd2app1583z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2se1577za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2sequen1552z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	static obj_t BGl_z62cleanupzd2nodez12zd2fail1560z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_z62cleanupzd2nodez12zd2sync1554z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t, obj_t);
	static BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1587z70zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[3];


	   
		 
		DEFINE_STRING(BGl_string2125z00zzcfa_arithmeticz00,
		BgL_bgl_string2125za700za7za7c2152za7, "cleanup-node!1549", 17);
	      DEFINE_STRING(BGl_string2127z00zzcfa_arithmeticz00,
		BgL_bgl_string2127za700za7za7c2153za7, "cleanup-node!", 13);
	      DEFINE_STRING(BGl_string2144z00zzcfa_arithmeticz00,
		BgL_bgl_string2144za700za7za7c2154za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string2146z00zzcfa_arithmeticz00,
		BgL_bgl_string2146za700za7za7c2155za7, "cfa!::approx", 12);
	      DEFINE_STRING(BGl_string2147z00zzcfa_arithmeticz00,
		BgL_bgl_string2147za700za7za7c2156za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string2148z00zzcfa_arithmeticz00,
		BgL_bgl_string2148za700za7za7c2157za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string2149z00zzcfa_arithmeticz00,
		BgL_bgl_string2149za700za7za7c2158za7, "all c-eq? arithmetic-app ", 25);
	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2124z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2159z00,
		BGl_z62cleanupzd2nodez121549za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2126z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2160z00,
		BGl_z62cleanupzd2nodez12zd2sequen1552z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2128z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2161z00,
		BGl_z62cleanupzd2nodez12zd2sync1554z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2129z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2162z00,
		BGl_z62cleanupzd2nodez12zd2setq1556z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2130z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2163z00,
		BGl_z62cleanupzd2nodez12zd2condit1558z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2131z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2164z00,
		BGl_z62cleanupzd2nodez12zd2fail1560z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2165z00,
		BGl_z62cleanupzd2nodez12zd2switch1562z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2133z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2166z00,
		BGl_z62cleanupzd2nodez12zd2letzd2fu1564za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2167z00,
		BGl_z62cleanupzd2nodez12zd2letzd2va1566za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2135z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2168z00,
		BGl_z62cleanupzd2nodez12zd2setzd2ex1569za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2169z00,
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1571za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2137z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2170z00,
		BGl_z62cleanupzd2nodez12zd2makezd2b1573za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2138z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2171z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2re1575za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2139z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2172z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2se1577za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2173z00,
		BGl_z62cleanupzd2nodez12zd2appzd2ly1579za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2141z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2174z00,
		BGl_z62cleanupzd2nodez12zd2funcal1581z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2175z00,
		BGl_z62cleanupzd2nodez12zd2app1583z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zzcfa_arithmeticz00,
		BgL_bgl_za762nodeza7d2setupza72176za7,
		BGl_z62nodezd2setupz12zd2prezd2arit1585za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zzcfa_arithmeticz00,
		BgL_bgl_za762cfaza712za7d2arit2177za7,
		BGl_z62cfaz12zd2arithmeticzd2app1587z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2ari2178z00,
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2179z00,
		BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00));
		     ADD_ROOT((void
				*) (&BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_4095, char *BgL_fromz00_4096)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcfa_arithmeticz00();
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_genericzd2initzd2zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					return BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_3945;

				{	/* Cfa/arithmetic.scm 28 */
					obj_t BgL_stringz00_3953;

					BgL_stringz00_3953 = BGl_string2149z00zzcfa_arithmeticz00;
					{	/* Cfa/arithmetic.scm 28 */
						obj_t BgL_startz00_3954;

						BgL_startz00_3954 = BINT(((long) 0));
						{	/* Cfa/arithmetic.scm 28 */
							obj_t BgL_endz00_3955;

							BgL_endz00_3955 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_3953)));
							{	/* Cfa/arithmetic.scm 28 */

								BgL_cportz00_3945 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_3953, BgL_startz00_3954, BgL_endz00_3955);
				}}}}
				{
					long BgL_iz00_3946;

					BgL_iz00_3946 = ((long) 2);
				BgL_loopz00_3947:
					if ((BgL_iz00_3946 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg2151z00_3949;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_3951;

										BgL_locationz00_3951 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg2151z00_3949 =
												BGl_readz00zz__readerz00(BgL_cportz00_3945,
												BgL_locationz00_3951);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_tmpz00_4125;

									BgL_tmpz00_4125 = (int) (BgL_iz00_3946);
									CNST_TABLE_SET(BgL_tmpz00_4125, BgL_arg2151z00_3949);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_3952;

								BgL_auxz00_3952 = (int) ((BgL_iz00_3946 - ((long) 1)));
								{
									long BgL_iz00_4130;

									BgL_iz00_4130 = (long) (BgL_auxz00_3952);
									BgL_iz00_3946 = BgL_iz00_4130;
									goto BgL_loopz00_3947;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}

	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_globalsz00_3)
	{
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l1513z00_2823;

				BgL_l1513z00_2823 = BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
			BgL_zc3z04anonymousza31599ze3z87_2824:
				if (PAIRP(BgL_l1513z00_2823))
					{	/* Cfa/arithmetic.scm 63 */
						{	/* Cfa/arithmetic.scm 64 */
							obj_t BgL_nodez00_2826;

							BgL_nodez00_2826 = CAR(BgL_l1513z00_2823);
							{	/* Cfa/arithmetic.scm 65 */
								BgL_variablez00_bglt BgL_fz00_2828;

								BgL_fz00_2828 =
									(((BgL_varz00_bglt) COBJECT(
											(((BgL_appz00_bglt) COBJECT(
														((BgL_appz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_2826))))->
												BgL_funz00)))->BgL_variablez00);
								{	/* Cfa/arithmetic.scm 65 */
									BgL_valuez00_bglt BgL_valz00_2829;

									BgL_valz00_2829 =
										(((BgL_variablez00_bglt) COBJECT(BgL_fz00_2828))->
										BgL_valuez00);
									{	/* Cfa/arithmetic.scm 66 */

										{	/* Cfa/arithmetic.scm 68 */
											bool_t BgL_test2183z00_4141;

											{	/* Cfa/arithmetic.scm 68 */
												BgL_typez00_bglt BgL_arg1605z00_2832;

												BgL_arg1605z00_2832 =
													(((BgL_variablez00_bglt) COBJECT(BgL_fz00_2828))->
													BgL_typez00);
												BgL_test2183z00_4141 =
													(((obj_t) BgL_arg1605z00_2832) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_test2183z00_4141)
												{	/* Cfa/arithmetic.scm 69 */
													BgL_typez00_bglt BgL_vz00_3723;

													BgL_vz00_3723 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_variablez00_bglt) COBJECT(BgL_fz00_2828))->
															BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3723), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 68 */
													BFALSE;
												}
										}
										{	/* Cfa/arithmetic.scm 70 */
											bool_t BgL_test2184z00_4147;

											{	/* Cfa/arithmetic.scm 70 */
												BgL_typez00_bglt BgL_arg1614z00_2835;

												BgL_arg1614z00_2835 =
													(((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt) BgL_nodez00_2826)))->
													BgL_typez00);
												BgL_test2184z00_4147 =
													(((obj_t) BgL_arg1614z00_2835) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_test2184z00_4147)
												{	/* Cfa/arithmetic.scm 71 */
													BgL_typez00_bglt BgL_vz00_3726;

													BgL_vz00_3726 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																		BgL_nodez00_2826)))->BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3726), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 70 */
													BFALSE;
												}
										}
										if (BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_valz00_2829), BGl_sfunz00zzast_varz00))
											{	/* Cfa/arithmetic.scm 74 */
												obj_t BgL_arg1616z00_2837;

												{	/* Cfa/arithmetic.scm 74 */
													obj_t BgL_l1507z00_2838;

													BgL_l1507z00_2838 =
														(((BgL_sfunz00_bglt) COBJECT(
																((BgL_sfunz00_bglt) BgL_valz00_2829)))->
														BgL_argsz00);
													if (NULLP(BgL_l1507z00_2838))
														{	/* Cfa/arithmetic.scm 74 */
															BgL_arg1616z00_2837 = BNIL;
														}
													else
														{	/* Cfa/arithmetic.scm 74 */
															obj_t BgL_head1509z00_2840;

															{	/* Cfa/arithmetic.scm 74 */
																obj_t BgL_arg1643z00_2852;

																{	/* Cfa/arithmetic.scm 74 */
																	obj_t BgL_arg1645z00_2853;

																	BgL_arg1645z00_2853 =
																		CAR(((obj_t) BgL_l1507z00_2838));
																	BgL_arg1643z00_2852 =
																		BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																		(BgL_arg1645z00_2853);
																}
																BgL_head1509z00_2840 =
																	MAKE_YOUNG_PAIR(BgL_arg1643z00_2852, BNIL);
															}
															{	/* Cfa/arithmetic.scm 74 */
																obj_t BgL_g1512z00_2841;

																BgL_g1512z00_2841 =
																	CDR(((obj_t) BgL_l1507z00_2838));
																{
																	obj_t BgL_l1507z00_2843;
																	obj_t BgL_tail1510z00_2844;

																	BgL_l1507z00_2843 = BgL_g1512z00_2841;
																	BgL_tail1510z00_2844 = BgL_head1509z00_2840;
																BgL_zc3z04anonymousza31618ze3z87_2845:
																	if (NULLP(BgL_l1507z00_2843))
																		{	/* Cfa/arithmetic.scm 74 */
																			BgL_arg1616z00_2837 =
																				BgL_head1509z00_2840;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 74 */
																			obj_t BgL_newtail1511z00_2847;

																			{	/* Cfa/arithmetic.scm 74 */
																				obj_t BgL_arg1634z00_2849;

																				{	/* Cfa/arithmetic.scm 74 */
																					obj_t BgL_arg1638z00_2850;

																					BgL_arg1638z00_2850 =
																						CAR(((obj_t) BgL_l1507z00_2843));
																					BgL_arg1634z00_2849 =
																						BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																						(BgL_arg1638z00_2850);
																				}
																				BgL_newtail1511z00_2847 =
																					MAKE_YOUNG_PAIR(BgL_arg1634z00_2849,
																					BNIL);
																			}
																			SET_CDR(BgL_tail1510z00_2844,
																				BgL_newtail1511z00_2847);
																			{	/* Cfa/arithmetic.scm 74 */
																				obj_t BgL_arg1633z00_2848;

																				BgL_arg1633z00_2848 =
																					CDR(((obj_t) BgL_l1507z00_2843));
																				{
																					obj_t BgL_tail1510z00_4178;
																					obj_t BgL_l1507z00_4177;

																					BgL_l1507z00_4177 =
																						BgL_arg1633z00_2848;
																					BgL_tail1510z00_4178 =
																						BgL_newtail1511z00_2847;
																					BgL_tail1510z00_2844 =
																						BgL_tail1510z00_4178;
																					BgL_l1507z00_2843 = BgL_l1507z00_4177;
																					goto
																						BgL_zc3z04anonymousza31618ze3z87_2845;
																				}
																			}
																		}
																}
															}
														}
												}
												((((BgL_sfunz00_bglt) COBJECT(
																((BgL_sfunz00_bglt) BgL_valz00_2829)))->
														BgL_argsz00) =
													((obj_t) BgL_arg1616z00_2837), BUNSPEC);
											}
										else
											{	/* Cfa/arithmetic.scm 73 */
												if (BGl_isazf3zf3zz__objectz00(
														((obj_t) BgL_valz00_2829), BGl_cfunz00zzast_varz00))
													{	/* Cfa/arithmetic.scm 76 */
														obj_t BgL_g1162z00_2855;

														BgL_g1162z00_2855 =
															(((BgL_cfunz00_bglt) COBJECT(
																	((BgL_cfunz00_bglt) BgL_valz00_2829)))->
															BgL_argszd2typezd2);
														{
															obj_t BgL_lz00_2857;

															{	/* Cfa/arithmetic.scm 76 */
																bool_t BgL_tmpz00_4186;

																BgL_lz00_2857 = BgL_g1162z00_2855;
															BgL_zc3z04anonymousza31648ze3z87_2858:
																if (PAIRP(BgL_lz00_2857))
																	{	/* Cfa/arithmetic.scm 77 */
																		{	/* Cfa/arithmetic.scm 79 */
																			obj_t BgL_tmpz00_4189;

																			BgL_tmpz00_4189 =
																				BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00
																				(CAR(BgL_lz00_2857));
																			SET_CAR(BgL_lz00_2857, BgL_tmpz00_4189);
																		}
																		{
																			obj_t BgL_lz00_4193;

																			BgL_lz00_4193 = CDR(BgL_lz00_2857);
																			BgL_lz00_2857 = BgL_lz00_4193;
																			goto
																				BgL_zc3z04anonymousza31648ze3z87_2858;
																		}
																	}
																else
																	{	/* Cfa/arithmetic.scm 77 */
																		BgL_tmpz00_4186 = ((bool_t) 0);
																	}
																BBOOL(BgL_tmpz00_4186);
															}
														}
													}
												else
													{	/* Cfa/arithmetic.scm 75 */
														BFALSE;
													}
											}
									}
								}
							}
						}
						{
							obj_t BgL_l1513z00_4196;

							BgL_l1513z00_4196 = CDR(BgL_l1513z00_2823);
							BgL_l1513z00_2823 = BgL_l1513z00_4196;
							goto BgL_zc3z04anonymousza31599ze3z87_2824;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 63 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l1515z00_2868;

				BgL_l1515z00_2868 = BgL_globalsz00_3;
			BgL_zc3z04anonymousza31665ze3z87_2869:
				if (PAIRP(BgL_l1515z00_2868))
					{	/* Cfa/arithmetic.scm 83 */
						{	/* Cfa/arithmetic.scm 83 */
							obj_t BgL_arg1672z00_2871;

							BgL_arg1672z00_2871 = CAR(BgL_l1515z00_2868);
							{	/* Cfa/arithmetic.scm 90 */
								BgL_valuez00_bglt BgL_funz00_3740;

								BgL_funz00_3740 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_arg1672z00_2871)))->
									BgL_valuez00);
								{	/* Cfa/arithmetic.scm 90 */
									obj_t BgL_bodyz00_3741;

									BgL_bodyz00_3741 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_funz00_3740)))->BgL_bodyz00);
									{	/* Cfa/arithmetic.scm 91 */

										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_bodyz00_3741));
									}
								}
							}
						}
						{
							obj_t BgL_l1515z00_4207;

							BgL_l1515z00_4207 = CDR(BgL_l1515z00_2868);
							BgL_l1515z00_2868 = BgL_l1515z00_4207;
							goto BgL_zc3z04anonymousza31665ze3z87_2869;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 83 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}

	}



/* cleanup-type~0 */
	obj_t BGl_cleanupzd2typeze70z35zzcfa_arithmeticz00(obj_t BgL_tz00_2874)
	{
		{	/* Cfa/arithmetic.scm 62 */
			if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2874, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_2874 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_2874;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2874,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 57 */
							{	/* Cfa/arithmetic.scm 58 */
								bool_t BgL_test2194z00_4215;

								{	/* Cfa/arithmetic.scm 58 */
									BgL_typez00_bglt BgL_arg1682z00_2881;

									BgL_arg1682z00_2881 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_tz00_2874))))->BgL_typez00);
									BgL_test2194z00_4215 =
										(
										((obj_t) BgL_arg1682z00_2881) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_test2194z00_4215)
									{	/* Cfa/arithmetic.scm 59 */
										BgL_typez00_bglt BgL_vz00_3717;

										BgL_vz00_3717 =
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00);
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_tz00_2874))))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_3717), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 58 */
										BFALSE;
									}
							}
							return BgL_tz00_2874;
						}
					else
						{	/* Cfa/arithmetic.scm 57 */
							return BgL_tz00_2874;
						}
				}
		}

	}



/* &cleanup-arithmetic-nodes! */
	obj_t BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3879, obj_t BgL_globalsz00_3880)
	{
		{	/* Cfa/arithmetic.scm 52 */
			return
				BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00
				(BgL_globalsz00_3880);
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_proc2124z00zzcfa_arithmeticz00, BGl_nodez00zzast_nodez00,
				BGl_string2125z00zzcfa_arithmeticz00);
		}

	}



/* &cleanup-node!1549 */
	obj_t BGl_z62cleanupzd2nodez121549za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3882, obj_t BgL_nodez00_3883)
	{
		{	/* Cfa/arithmetic.scm 97 */
			return BUNSPEC;
		}

	}



/* cleanup-node! */
	obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		{	/* Cfa/arithmetic.scm 97 */
			{	/* Cfa/arithmetic.scm 97 */
				obj_t BgL_method1550z00_2889;

				{	/* Cfa/arithmetic.scm 97 */
					obj_t BgL_res2121z00_3779;

					{	/* Cfa/arithmetic.scm 97 */
						long BgL_objzd2classzd2numz00_3750;

						BgL_objzd2classzd2numz00_3750 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
						{	/* Cfa/arithmetic.scm 97 */
							obj_t BgL_arg1791z00_3751;

							BgL_arg1791z00_3751 =
								PROCEDURE_REF(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
								(int) (((long) 1)));
							{	/* Cfa/arithmetic.scm 97 */
								int BgL_offsetz00_3754;

								BgL_offsetz00_3754 = (int) (BgL_objzd2classzd2numz00_3750);
								{	/* Cfa/arithmetic.scm 97 */
									long BgL_offsetz00_3755;

									BgL_offsetz00_3755 =
										((long) (BgL_offsetz00_3754) - OBJECT_TYPE);
									{	/* Cfa/arithmetic.scm 97 */
										long BgL_modz00_3756;

										BgL_modz00_3756 =
											(BgL_offsetz00_3755 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Cfa/arithmetic.scm 97 */
											long BgL_restz00_3758;

											BgL_restz00_3758 =
												(BgL_offsetz00_3755 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Cfa/arithmetic.scm 97 */

												{	/* Cfa/arithmetic.scm 97 */
													obj_t BgL_bucketz00_3760;

													BgL_bucketz00_3760 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_3751), BgL_modz00_3756);
													BgL_res2121z00_3779 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_3760), BgL_restz00_3758);
					}}}}}}}}
					BgL_method1550z00_2889 = BgL_res2121z00_3779;
				}
				return
					PROCEDURE_ENTRY(BgL_method1550z00_2889) (BgL_method1550z00_2889,
					((obj_t) BgL_nodez00_5), BEOA);
			}
		}

	}



/* &cleanup-node! */
	obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t BgL_envz00_3884,
		obj_t BgL_nodez00_3885)
	{
		{	/* Cfa/arithmetic.scm 97 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				((BgL_nodez00_bglt) BgL_nodez00_3885));
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2126z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_syncz00zzast_nodez00, BGl_proc2128z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setqz00zzast_nodez00, BGl_proc2129z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2130z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_failz00zzast_nodez00, BGl_proc2131z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_switchz00zzast_nodez00, BGl_proc2132z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2133z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2134z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2135z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2136z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2137z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2138z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2139z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2140z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2141z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appz00zzast_nodez00, BGl_proc2142z00zzcfa_arithmeticz00,
				BGl_string2127z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc2143z00zzcfa_arithmeticz00,
				BGl_string2144z00zzcfa_arithmeticz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cfaz12zd2envzc0zzcfa_cfaz00, BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc2145z00zzcfa_arithmeticz00,
				BGl_string2146z00zzcfa_arithmeticz00);
		}

	}



/* &cfa!-arithmetic-app1587 */
	BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1587z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3904, obj_t BgL_nodez00_3905)
	{
		{	/* Cfa/arithmetic.scm 287 */
			{
				obj_t BgL_argszd2approxzd2_3979;
				obj_t BgL_argszd2approxzd2_3969;
				obj_t BgL_typez00_3970;
				obj_t BgL_speczd2typeszd2_3971;
				obj_t BgL_argszd2approxzd2_3962;
				obj_t BgL_speczd2typeszd2_3963;

				{	/* Cfa/arithmetic.scm 328 */
					obj_t BgL_argszd2approxzd2_3985;

					{	/* Cfa/arithmetic.scm 328 */
						obj_t BgL_l1541z00_3986;

						BgL_l1541z00_3986 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt)
										((BgL_appz00_bglt) BgL_nodez00_3905))))->BgL_argsz00);
						if (NULLP(BgL_l1541z00_3986))
							{	/* Cfa/arithmetic.scm 328 */
								BgL_argszd2approxzd2_3985 = BNIL;
							}
						else
							{	/* Cfa/arithmetic.scm 328 */
								obj_t BgL_head1543z00_3987;

								{	/* Cfa/arithmetic.scm 328 */
									BgL_approxz00_bglt BgL_arg1910z00_3988;

									{	/* Cfa/arithmetic.scm 328 */
										obj_t BgL_arg1911z00_3989;

										BgL_arg1911z00_3989 = CAR(((obj_t) BgL_l1541z00_3986));
										BgL_arg1910z00_3988 =
											BGl_cfaz12z12zzcfa_cfaz00(
											((BgL_nodez00_bglt) BgL_arg1911z00_3989));
									}
									BgL_head1543z00_3987 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg1910z00_3988), BNIL);
								}
								{	/* Cfa/arithmetic.scm 328 */
									obj_t BgL_g1546z00_3990;

									BgL_g1546z00_3990 = CDR(((obj_t) BgL_l1541z00_3986));
									{
										obj_t BgL_l1541z00_3992;
										obj_t BgL_tail1544z00_3993;

										BgL_l1541z00_3992 = BgL_g1546z00_3990;
										BgL_tail1544z00_3993 = BgL_head1543z00_3987;
									BgL_zc3z04anonymousza31905ze3z87_3991:
										if (NULLP(BgL_l1541z00_3992))
											{	/* Cfa/arithmetic.scm 328 */
												BgL_argszd2approxzd2_3985 = BgL_head1543z00_3987;
											}
										else
											{	/* Cfa/arithmetic.scm 328 */
												obj_t BgL_newtail1545z00_3994;

												{	/* Cfa/arithmetic.scm 328 */
													BgL_approxz00_bglt BgL_arg1908z00_3995;

													{	/* Cfa/arithmetic.scm 328 */
														obj_t BgL_arg1909z00_3996;

														BgL_arg1909z00_3996 =
															CAR(((obj_t) BgL_l1541z00_3992));
														BgL_arg1908z00_3995 =
															BGl_cfaz12z12zzcfa_cfaz00(
															((BgL_nodez00_bglt) BgL_arg1909z00_3996));
													}
													BgL_newtail1545z00_3994 =
														MAKE_YOUNG_PAIR(
														((obj_t) BgL_arg1908z00_3995), BNIL);
												}
												SET_CDR(BgL_tail1544z00_3993, BgL_newtail1545z00_3994);
												{	/* Cfa/arithmetic.scm 328 */
													obj_t BgL_arg1907z00_3997;

													BgL_arg1907z00_3997 =
														CDR(((obj_t) BgL_l1541z00_3992));
													{
														obj_t BgL_tail1544z00_4302;
														obj_t BgL_l1541z00_4301;

														BgL_l1541z00_4301 = BgL_arg1907z00_3997;
														BgL_tail1544z00_4302 = BgL_newtail1545z00_3994;
														BgL_tail1544z00_3993 = BgL_tail1544z00_4302;
														BgL_l1541z00_3992 = BgL_l1541z00_4301;
														goto BgL_zc3z04anonymousza31905ze3z87_3991;
													}
												}
											}
									}
								}
							}
					}
					{	/* Cfa/arithmetic.scm 330 */
						obj_t BgL_tyz00_3998;

						BgL_argszd2approxzd2_3979 = BgL_argszd2approxzd2_3985;
						{
							obj_t BgL_argsz00_3981;

							BgL_argsz00_3981 = BgL_argszd2approxzd2_3979;
						BgL_loopz00_3980:
							if (NULLP(BgL_argsz00_3981))
								{	/* Cfa/arithmetic.scm 296 */
									BgL_tyz00_3998 = BFALSE;
								}
							else
								{	/* Cfa/arithmetic.scm 298 */
									obj_t BgL_tz00_3982;

									{	/* Cfa/arithmetic.scm 298 */
										BgL_typez00_bglt BgL_arg1919z00_3983;

										BgL_arg1919z00_3983 =
											(((BgL_approxz00_bglt) COBJECT(
													((BgL_approxz00_bglt)
														CAR(((obj_t) BgL_argsz00_3981)))))->BgL_typez00);
										if (
											(((obj_t) BgL_arg1919z00_3983) ==
												BGl_za2intza2z00zztype_cachez00))
											{	/* Cfa/arithmetic.scm 290 */
												BgL_tz00_3982 = BGl_za2longza2z00zztype_cachez00;
											}
										else
											{	/* Cfa/arithmetic.scm 290 */
												BgL_tz00_3982 = ((obj_t) BgL_arg1919z00_3983);
											}
									}
									if ((BgL_tz00_3982 == BGl_za2_za2z00zztype_cachez00))
										{	/* Cfa/arithmetic.scm 300 */
											obj_t BgL_arg1918z00_3984;

											BgL_arg1918z00_3984 = CDR(((obj_t) BgL_argsz00_3981));
											{
												obj_t BgL_argsz00_4317;

												BgL_argsz00_4317 = BgL_arg1918z00_3984;
												BgL_argsz00_3981 = BgL_argsz00_4317;
												goto BgL_loopz00_3980;
											}
										}
									else
										{	/* Cfa/arithmetic.scm 299 */
											BgL_tyz00_3998 = BgL_tz00_3982;
										}
								}
						}
						{	/* Cfa/arithmetic.scm 336 */
							bool_t BgL_test2200z00_4318;

							{	/* Cfa/arithmetic.scm 336 */
								obj_t BgL_arg1903z00_3999;

								{
									BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4319;

									{
										obj_t BgL_auxz00_4320;

										{	/* Cfa/arithmetic.scm 336 */
											BgL_objectz00_bglt BgL_tmpz00_4321;

											BgL_tmpz00_4321 =
												((BgL_objectz00_bglt)
												((BgL_appz00_bglt) BgL_nodez00_3905));
											BgL_auxz00_4320 = BGL_OBJECT_WIDENING(BgL_tmpz00_4321);
										}
										BgL_auxz00_4319 =
											((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4320);
									}
									BgL_arg1903z00_3999 =
										(((BgL_arithmeticzd2appzd2_bglt) COBJECT(BgL_auxz00_4319))->
										BgL_speczd2typeszd2);
								}
								BgL_argszd2approxzd2_3969 = BgL_argszd2approxzd2_3985;
								BgL_typez00_3970 = BgL_tyz00_3998;
								BgL_speczd2typeszd2_3971 = BgL_arg1903z00_3999;
								{	/* Cfa/arithmetic.scm 305 */
									bool_t BgL__ortest_1186z00_3972;

									if (CBOOL(BgL_typez00_3970))
										{	/* Cfa/arithmetic.scm 305 */
											BgL__ortest_1186z00_3972 = ((bool_t) 0);
										}
									else
										{	/* Cfa/arithmetic.scm 305 */
											BgL__ortest_1186z00_3972 = ((bool_t) 1);
										}
									if (BgL__ortest_1186z00_3972)
										{	/* Cfa/arithmetic.scm 305 */
											BgL_test2200z00_4318 = BgL__ortest_1186z00_3972;
										}
									else
										{	/* Cfa/arithmetic.scm 306 */
											obj_t BgL__andtest_1187z00_3973;

											BgL__andtest_1187z00_3973 =
												BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_typez00_3970, BgL_speczd2typeszd2_3971);
											if (CBOOL(BgL__andtest_1187z00_3973))
												{
													obj_t BgL_argsz00_3975;

													BgL_argsz00_3975 = BgL_argszd2approxzd2_3969;
												BgL_loopz00_3974:
													if (NULLP(BgL_argsz00_3975))
														{	/* Cfa/arithmetic.scm 308 */
															BgL_test2200z00_4318 = ((bool_t) 1);
														}
													else
														{	/* Cfa/arithmetic.scm 310 */
															obj_t BgL_tz00_3976;

															{	/* Cfa/arithmetic.scm 310 */
																BgL_typez00_bglt BgL_arg1927z00_3977;

																BgL_arg1927z00_3977 =
																	(((BgL_approxz00_bglt) COBJECT(
																			((BgL_approxz00_bglt)
																				CAR(
																					((obj_t) BgL_argsz00_3975)))))->
																	BgL_typez00);
																if ((((obj_t) BgL_arg1927z00_3977) ==
																		BGl_za2intza2z00zztype_cachez00))
																	{	/* Cfa/arithmetic.scm 290 */
																		BgL_tz00_3976 =
																			BGl_za2longza2z00zztype_cachez00;
																	}
																else
																	{	/* Cfa/arithmetic.scm 290 */
																		BgL_tz00_3976 =
																			((obj_t) BgL_arg1927z00_3977);
																	}
															}
															{	/* Cfa/arithmetic.scm 311 */
																bool_t BgL_test2206z00_4343;

																if ((BgL_tz00_3976 == BgL_typez00_3970))
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_test2206z00_4343 = ((bool_t) 1);
																	}
																else
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_test2206z00_4343 =
																			(BgL_tz00_3976 ==
																			BGl_za2_za2z00zztype_cachez00);
																	}
																if (BgL_test2206z00_4343)
																	{	/* Cfa/arithmetic.scm 312 */
																		obj_t BgL_arg1926z00_3978;

																		BgL_arg1926z00_3978 =
																			CDR(((obj_t) BgL_argsz00_3975));
																		{
																			obj_t BgL_argsz00_4349;

																			BgL_argsz00_4349 = BgL_arg1926z00_3978;
																			BgL_argsz00_3975 = BgL_argsz00_4349;
																			goto BgL_loopz00_3974;
																		}
																	}
																else
																	{	/* Cfa/arithmetic.scm 311 */
																		BgL_test2200z00_4318 = ((bool_t) 0);
																	}
															}
														}
												}
											else
												{	/* Cfa/arithmetic.scm 306 */
													BgL_test2200z00_4318 = ((bool_t) 0);
												}
										}
								}
							}
							if (BgL_test2200z00_4318)
								{	/* Cfa/arithmetic.scm 336 */
									{	/* Cfa/arithmetic.scm 339 */
										bool_t BgL_test2208z00_4350;

										{	/* Cfa/arithmetic.scm 339 */
											bool_t BgL_test2209z00_4351;

											{	/* Cfa/arithmetic.scm 339 */
												obj_t BgL_arg1885z00_4000;

												{
													BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4352;

													{
														obj_t BgL_auxz00_4353;

														{	/* Cfa/arithmetic.scm 339 */
															BgL_objectz00_bglt BgL_tmpz00_4354;

															BgL_tmpz00_4354 =
																((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_3905));
															BgL_auxz00_4353 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_4354);
														}
														BgL_auxz00_4352 =
															((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4353);
													}
													BgL_arg1885z00_4000 =
														(((BgL_arithmeticzd2appzd2_bglt)
															COBJECT(BgL_auxz00_4352))->BgL_speczd2typeszd2);
												}
												BgL_argszd2approxzd2_3962 = BgL_argszd2approxzd2_3985;
												BgL_speczd2typeszd2_3963 = BgL_arg1885z00_4000;
												{
													obj_t BgL_argsz00_3965;

													BgL_argsz00_3965 = BgL_argszd2approxzd2_3962;
												BgL_loopz00_3964:
													if (NULLP(BgL_argsz00_3965))
														{	/* Cfa/arithmetic.scm 318 */
															BgL_test2209z00_4351 = ((bool_t) 1);
														}
													else
														{	/* Cfa/arithmetic.scm 320 */
															bool_t BgL_test2211z00_4362;

															{	/* Cfa/arithmetic.scm 320 */
																obj_t BgL_arg1937z00_3966;

																{	/* Cfa/arithmetic.scm 320 */
																	BgL_typez00_bglt BgL_arg1938z00_3967;

																	BgL_arg1938z00_3967 =
																		(((BgL_approxz00_bglt) COBJECT(
																				((BgL_approxz00_bglt)
																					CAR(
																						((obj_t) BgL_argsz00_3965)))))->
																		BgL_typez00);
																	if ((((obj_t) BgL_arg1938z00_3967) ==
																			BGl_za2intza2z00zztype_cachez00))
																		{	/* Cfa/arithmetic.scm 290 */
																			BgL_arg1937z00_3966 =
																				BGl_za2longza2z00zztype_cachez00;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 290 */
																			BgL_arg1937z00_3966 =
																				((obj_t) BgL_arg1938z00_3967);
																		}
																}
																BgL_test2211z00_4362 =
																	CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg1937z00_3966,
																		BgL_speczd2typeszd2_3963));
															}
															if (BgL_test2211z00_4362)
																{	/* Cfa/arithmetic.scm 321 */
																	obj_t BgL_arg1936z00_3968;

																	BgL_arg1936z00_3968 =
																		CDR(((obj_t) BgL_argsz00_3965));
																	{
																		obj_t BgL_argsz00_4375;

																		BgL_argsz00_4375 = BgL_arg1936z00_3968;
																		BgL_argsz00_3965 = BgL_argsz00_4375;
																		goto BgL_loopz00_3964;
																	}
																}
															else
																{	/* Cfa/arithmetic.scm 320 */
																	BgL_test2209z00_4351 = ((bool_t) 0);
																}
														}
												}
											}
											if (BgL_test2209z00_4351)
												{	/* Cfa/arithmetic.scm 340 */
													BgL_typez00_bglt BgL_arg1880z00_4001;

													{	/* Cfa/arithmetic.scm 340 */
														BgL_approxz00_bglt BgL_arg1883z00_4002;

														{
															BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4376;

															{
																obj_t BgL_auxz00_4377;

																{	/* Cfa/arithmetic.scm 340 */
																	BgL_objectz00_bglt BgL_tmpz00_4378;

																	BgL_tmpz00_4378 =
																		((BgL_objectz00_bglt)
																		((BgL_appz00_bglt) BgL_nodez00_3905));
																	BgL_auxz00_4377 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_4378);
																}
																BgL_auxz00_4376 =
																	((BgL_arithmeticzd2appzd2_bglt)
																	BgL_auxz00_4377);
															}
															BgL_arg1883z00_4002 =
																(((BgL_arithmeticzd2appzd2_bglt)
																	COBJECT(BgL_auxz00_4376))->BgL_approxz00);
														}
														BgL_arg1880z00_4001 =
															(((BgL_approxz00_bglt)
																COBJECT(BgL_arg1883z00_4002))->BgL_typez00);
													}
													BgL_test2208z00_4350 =
														(
														((obj_t) BgL_arg1880z00_4001) ==
														BGl_za2_za2z00zztype_cachez00);
												}
											else
												{	/* Cfa/arithmetic.scm 339 */
													BgL_test2208z00_4350 = ((bool_t) 0);
												}
										}
										if (BgL_test2208z00_4350)
											{	/* Cfa/arithmetic.scm 339 */
												{	/* Cfa/arithmetic.scm 343 */
													BgL_approxz00_bglt BgL_arg1879z00_4003;

													{
														BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4387;

														{
															obj_t BgL_auxz00_4388;

															{	/* Cfa/arithmetic.scm 343 */
																BgL_objectz00_bglt BgL_tmpz00_4389;

																BgL_tmpz00_4389 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_nodez00_3905));
																BgL_auxz00_4388 =
																	BGL_OBJECT_WIDENING(BgL_tmpz00_4389);
															}
															BgL_auxz00_4387 =
																((BgL_arithmeticzd2appzd2_bglt)
																BgL_auxz00_4388);
														}
														BgL_arg1879z00_4003 =
															(((BgL_arithmeticzd2appzd2_bglt)
																COBJECT(BgL_auxz00_4387))->BgL_approxz00);
													}
													BGl_approxzd2setzd2typez12z12zzcfa_approxz00
														(BgL_arg1879z00_4003,
														((BgL_typez00_bglt) BgL_tyz00_3998));
												}
												BGl_continuezd2cfaz12zc0zzcfa_iteratez00(CNST_TABLE_REF(
														((long) 0)));
											}
										else
											{	/* Cfa/arithmetic.scm 339 */
												BFALSE;
											}
									}
								}
							else
								{	/* Cfa/arithmetic.scm 345 */
									bool_t BgL_test2213z00_4399;

									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_globalz00_bglt)
																(((BgL_varz00_bglt) COBJECT(
																			(((BgL_appz00_bglt) COBJECT(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_nodez00_3905))))->
																				BgL_funz00)))->BgL_variablez00)))))->
												BgL_idz00) == CNST_TABLE_REF(((long) 1))))
										{	/* Cfa/arithmetic.scm 345 */
											BgL_test2213z00_4399 = ((bool_t) 0);
										}
									else
										{	/* Cfa/arithmetic.scm 345 */
											BgL_test2213z00_4399 = ((bool_t) 1);
										}
									if (BgL_test2213z00_4399)
										{	/* Cfa/arithmetic.scm 345 */
											{
												obj_t BgL_l1547z00_4005;

												BgL_l1547z00_4005 = BgL_argszd2approxzd2_3985;
											BgL_zc3z04anonymousza31894ze3z87_4004:
												if (PAIRP(BgL_l1547z00_4005))
													{	/* Cfa/arithmetic.scm 346 */
														{	/* Cfa/arithmetic.scm 346 */
															obj_t BgL_az00_4006;

															BgL_az00_4006 = CAR(BgL_l1547z00_4005);
															BGl_loosez12z12zzcfa_loosez00(
																((BgL_approxz00_bglt) BgL_az00_4006),
																CNST_TABLE_REF(((long) 2)));
														}
														{
															obj_t BgL_l1547z00_4416;

															BgL_l1547z00_4416 = CDR(BgL_l1547z00_4005);
															BgL_l1547z00_4005 = BgL_l1547z00_4416;
															goto BgL_zc3z04anonymousza31894ze3z87_4004;
														}
													}
												else
													{	/* Cfa/arithmetic.scm 346 */
														((bool_t) 1);
													}
											}
											{	/* Cfa/arithmetic.scm 347 */
												BgL_approxz00_bglt BgL_arg1899z00_4007;

												{
													BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4418;

													{
														obj_t BgL_auxz00_4419;

														{	/* Cfa/arithmetic.scm 347 */
															BgL_objectz00_bglt BgL_tmpz00_4420;

															BgL_tmpz00_4420 =
																((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_3905));
															BgL_auxz00_4419 =
																BGL_OBJECT_WIDENING(BgL_tmpz00_4420);
														}
														BgL_auxz00_4418 =
															((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4419);
													}
													BgL_arg1899z00_4007 =
														(((BgL_arithmeticzd2appzd2_bglt)
															COBJECT(BgL_auxz00_4418))->BgL_approxz00);
												}
												BGl_approxzd2setzd2typez12z12zzcfa_approxz00
													(BgL_arg1899z00_4007,
													((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
											}
										}
									else
										{	/* Cfa/arithmetic.scm 345 */
											BFALSE;
										}
								}
						}
					}
				}
				{
					BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4428;

					{
						obj_t BgL_auxz00_4429;

						{	/* Cfa/arithmetic.scm 350 */
							BgL_objectz00_bglt BgL_tmpz00_4430;

							BgL_tmpz00_4430 =
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3905));
							BgL_auxz00_4429 = BGL_OBJECT_WIDENING(BgL_tmpz00_4430);
						}
						BgL_auxz00_4428 = ((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4429);
					}
					return
						(((BgL_arithmeticzd2appzd2_bglt) COBJECT(BgL_auxz00_4428))->
						BgL_approxz00);
				}
			}
		}

	}



/* &node-setup!-pre-arit1585 */
	obj_t BGl_z62nodezd2setupz12zd2prezd2arit1585za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3906, obj_t BgL_nodez00_3907)
	{
		{	/* Cfa/arithmetic.scm 244 */
			{	/* Cfa/arithmetic.scm 255 */
				BgL_variablez00_bglt BgL_fz00_4009;

				BgL_fz00_4009 =
					(((BgL_varz00_bglt) COBJECT(
							(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3907))))->BgL_funz00)))->
					BgL_variablez00);
				{	/* Cfa/arithmetic.scm 255 */
					BgL_valuez00_bglt BgL_valz00_4010;

					BgL_valz00_4010 =
						(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->BgL_valuez00);
					{	/* Cfa/arithmetic.scm 256 */

						{	/* Cfa/arithmetic.scm 258 */
							bool_t BgL_test2216z00_4441;

							{	/* Cfa/arithmetic.scm 258 */
								BgL_typez00_bglt BgL_arg1830z00_4011;

								BgL_arg1830z00_4011 =
									(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
									BgL_typez00);
								BgL_test2216z00_4441 =
									(((obj_t) BgL_arg1830z00_4011) ==
									BGl_za2objza2z00zztype_cachez00);
							}
							if (BgL_test2216z00_4441)
								{	/* Cfa/arithmetic.scm 258 */
									{	/* Cfa/arithmetic.scm 261 */
										BgL_typez00_bglt BgL_vz00_4012;

										BgL_vz00_4012 =
											((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
										((((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_4012), BUNSPEC);
									}
									{	/* Cfa/arithmetic.scm 262 */
										BgL_typez00_bglt BgL_vz00_4013;

										BgL_vz00_4013 =
											((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
										((((BgL_nodez00_bglt) COBJECT(
														((BgL_nodez00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_3907))))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_4013), BUNSPEC);
									}
								}
							else
								{	/* Cfa/arithmetic.scm 258 */
									BFALSE;
								}
						}
						if (BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_4010), BGl_sfunz00zzast_varz00))
							{	/* Cfa/arithmetic.scm 265 */
								obj_t BgL_arg1832z00_4014;

								{	/* Cfa/arithmetic.scm 265 */
									obj_t BgL_l1535z00_4015;

									BgL_l1535z00_4015 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_valz00_4010)))->BgL_argsz00);
									if (NULLP(BgL_l1535z00_4015))
										{	/* Cfa/arithmetic.scm 265 */
											BgL_arg1832z00_4014 = BNIL;
										}
									else
										{	/* Cfa/arithmetic.scm 265 */
											obj_t BgL_head1537z00_4016;

											{	/* Cfa/arithmetic.scm 265 */
												obj_t BgL_arg1841z00_4017;

												{	/* Cfa/arithmetic.scm 265 */
													obj_t BgL_arg1843z00_4018;

													BgL_arg1843z00_4018 =
														CAR(((obj_t) BgL_l1535z00_4015));
													BgL_arg1841z00_4017 =
														BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00
														(BgL_arg1843z00_4018);
												}
												BgL_head1537z00_4016 =
													MAKE_YOUNG_PAIR(BgL_arg1841z00_4017, BNIL);
											}
											{	/* Cfa/arithmetic.scm 265 */
												obj_t BgL_g1540z00_4019;

												BgL_g1540z00_4019 = CDR(((obj_t) BgL_l1535z00_4015));
												{
													obj_t BgL_l1535z00_4021;
													obj_t BgL_tail1538z00_4022;

													BgL_l1535z00_4021 = BgL_g1540z00_4019;
													BgL_tail1538z00_4022 = BgL_head1537z00_4016;
												BgL_zc3z04anonymousza31834ze3z87_4020:
													if (NULLP(BgL_l1535z00_4021))
														{	/* Cfa/arithmetic.scm 265 */
															BgL_arg1832z00_4014 = BgL_head1537z00_4016;
														}
													else
														{	/* Cfa/arithmetic.scm 265 */
															obj_t BgL_newtail1539z00_4023;

															{	/* Cfa/arithmetic.scm 265 */
																obj_t BgL_arg1838z00_4024;

																{	/* Cfa/arithmetic.scm 265 */
																	obj_t BgL_arg1839z00_4025;

																	BgL_arg1839z00_4025 =
																		CAR(((obj_t) BgL_l1535z00_4021));
																	BgL_arg1838z00_4024 =
																		BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00
																		(BgL_arg1839z00_4025);
																}
																BgL_newtail1539z00_4023 =
																	MAKE_YOUNG_PAIR(BgL_arg1838z00_4024, BNIL);
															}
															SET_CDR(BgL_tail1538z00_4022,
																BgL_newtail1539z00_4023);
															{	/* Cfa/arithmetic.scm 265 */
																obj_t BgL_arg1837z00_4026;

																BgL_arg1837z00_4026 =
																	CDR(((obj_t) BgL_l1535z00_4021));
																{
																	obj_t BgL_tail1538z00_4474;
																	obj_t BgL_l1535z00_4473;

																	BgL_l1535z00_4473 = BgL_arg1837z00_4026;
																	BgL_tail1538z00_4474 =
																		BgL_newtail1539z00_4023;
																	BgL_tail1538z00_4022 = BgL_tail1538z00_4474;
																	BgL_l1535z00_4021 = BgL_l1535z00_4473;
																	goto BgL_zc3z04anonymousza31834ze3z87_4020;
																}
															}
														}
												}
											}
										}
								}
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_valz00_4010)))->BgL_argsz00) =
									((obj_t) BgL_arg1832z00_4014), BUNSPEC);
							}
						else
							{	/* Cfa/arithmetic.scm 264 */
								if (BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_valz00_4010), BGl_cfunz00zzast_varz00))
									{	/* Cfa/arithmetic.scm 267 */
										obj_t BgL_g1180z00_4027;

										BgL_g1180z00_4027 =
											(((BgL_cfunz00_bglt) COBJECT(
													((BgL_cfunz00_bglt) BgL_valz00_4010)))->
											BgL_argszd2typezd2);
										{
											obj_t BgL_lz00_4029;

											BgL_lz00_4029 = BgL_g1180z00_4027;
										BgL_loopz00_4028:
											if (PAIRP(BgL_lz00_4029))
												{	/* Cfa/arithmetic.scm 269 */
													obj_t BgL_tmpz00_4484;

													BgL_tmpz00_4484 =
														BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00(CAR
														(BgL_lz00_4029));
													SET_CAR(BgL_lz00_4029, BgL_tmpz00_4484);
												}
											else
												{	/* Cfa/arithmetic.scm 270 */
													obj_t BgL_arg1851z00_4030;

													BgL_arg1851z00_4030 = CDR(((obj_t) BgL_lz00_4029));
													{
														obj_t BgL_lz00_4490;

														BgL_lz00_4490 = BgL_arg1851z00_4030;
														BgL_lz00_4029 = BgL_lz00_4490;
														goto BgL_loopz00_4028;
													}
												}
										}
									}
								else
									{	/* Cfa/arithmetic.scm 266 */
										BGl_errorz00zz__errorz00
											(BGl_string2144z00zzcfa_arithmeticz00,
											BGl_string2147z00zzcfa_arithmeticz00,
											((obj_t) ((BgL_appz00_bglt) BgL_nodez00_3907)));
									}
							}
						BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
							MAKE_YOUNG_PAIR(
							((obj_t)
								((BgL_appz00_bglt) BgL_nodez00_3907)),
							BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
						{	/* Cfa/arithmetic.scm 275 */
							obj_t BgL_arg1854z00_4031;

							BgL_arg1854z00_4031 =
								(((BgL_appz00_bglt) COBJECT(
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3907))))->BgL_argsz00);
							BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg1854z00_4031);
						}
						{	/* Cfa/arithmetic.scm 276 */
							obj_t BgL_speczd2typeszd2_4032;

							{
								BgL_prezd2arithmeticzd2appz00_bglt BgL_auxz00_4501;

								{
									obj_t BgL_auxz00_4502;

									{	/* Cfa/arithmetic.scm 276 */
										BgL_objectz00_bglt BgL_tmpz00_4503;

										BgL_tmpz00_4503 =
											((BgL_objectz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3907));
										BgL_auxz00_4502 = BGL_OBJECT_WIDENING(BgL_tmpz00_4503);
									}
									BgL_auxz00_4501 =
										((BgL_prezd2arithmeticzd2appz00_bglt) BgL_auxz00_4502);
								}
								BgL_speczd2typeszd2_4032 =
									(((BgL_prezd2arithmeticzd2appz00_bglt)
										COBJECT(BgL_auxz00_4501))->BgL_speczd2typeszd2);
							}
							{	/* Cfa/arithmetic.scm 276 */
								BgL_appz00_bglt BgL_nodez00_4033;

								{	/* Cfa/arithmetic.scm 277 */
									long BgL_arg1860z00_4034;

									{	/* Cfa/arithmetic.scm 277 */
										obj_t BgL_arg1861z00_4035;

										{	/* Cfa/arithmetic.scm 277 */
											obj_t BgL_arg1862z00_4036;

											{	/* Cfa/arithmetic.scm 277 */
												long BgL_arg1794z00_4037;

												{	/* Cfa/arithmetic.scm 277 */
													long BgL_arg1795z00_4038;

													BgL_arg1795z00_4038 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_3907)));
													BgL_arg1794z00_4037 =
														(BgL_arg1795z00_4038 - OBJECT_TYPE);
												}
												BgL_arg1862z00_4036 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													BgL_arg1794z00_4037);
											}
											BgL_arg1861z00_4035 =
												BGl_classzd2superzd2zz__objectz00(BgL_arg1862z00_4036);
										}
										{	/* Cfa/arithmetic.scm 277 */
											obj_t BgL_tmpz00_4515;

											BgL_tmpz00_4515 = ((obj_t) BgL_arg1861z00_4035);
											BgL_arg1860z00_4034 = BGL_CLASS_INDEX(BgL_tmpz00_4515);
									}}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt)
											((BgL_appz00_bglt) BgL_nodez00_3907)),
										BgL_arg1860z00_4034);
								}
								{	/* Cfa/arithmetic.scm 277 */
									BgL_objectz00_bglt BgL_tmpz00_4521;

									BgL_tmpz00_4521 =
										((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3907));
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4521, BFALSE);
								}
								((BgL_objectz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_3907));
								BgL_nodez00_4033 = ((BgL_appz00_bglt) BgL_nodez00_3907);
								{	/* Cfa/arithmetic.scm 277 */

									{	/* Cfa/arithmetic.scm 278 */
										BgL_arithmeticzd2appzd2_bglt BgL_wide1184z00_4039;

										BgL_wide1184z00_4039 =
											((BgL_arithmeticzd2appzd2_bglt)
											BOBJECT(GC_MALLOC(sizeof(struct
														BgL_arithmeticzd2appzd2_bgl))));
										{	/* Cfa/arithmetic.scm 278 */
											obj_t BgL_auxz00_4533;
											BgL_objectz00_bglt BgL_tmpz00_4529;

											BgL_auxz00_4533 = ((obj_t) BgL_wide1184z00_4039);
											BgL_tmpz00_4529 =
												((BgL_objectz00_bglt)
												((BgL_appz00_bglt)
													((BgL_appz00_bglt) BgL_nodez00_4033)));
											BGL_OBJECT_WIDENING_SET(BgL_tmpz00_4529, BgL_auxz00_4533);
										}
										((BgL_objectz00_bglt)
											((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_4033)));
										{	/* Cfa/arithmetic.scm 278 */
											long BgL_arg1855z00_4040;

											BgL_arg1855z00_4040 =
												BGL_CLASS_INDEX(BGl_arithmeticzd2appzd2zzcfa_info2z00);
											BGL_OBJECT_CLASS_NUM_SET(
												((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4033))),
												BgL_arg1855z00_4040);
										}
										((BgL_appz00_bglt)
											((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_4033)));
									}
									{
										BgL_approxz00_bglt BgL_auxz00_4555;
										BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4547;

										{	/* Cfa/arithmetic.scm 280 */
											bool_t BgL_test2222z00_4556;

											{	/* Cfa/arithmetic.scm 280 */
												BgL_typez00_bglt BgL_arg1859z00_4041;

												BgL_arg1859z00_4041 =
													(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
													BgL_typez00);
												BgL_test2222z00_4556 =
													(((obj_t) BgL_arg1859z00_4041) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_test2222z00_4556)
												{	/* Cfa/arithmetic.scm 280 */
													BgL_auxz00_4555 =
														BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
												}
											else
												{	/* Cfa/arithmetic.scm 282 */
													BgL_typez00_bglt BgL_arg1858z00_4042;

													BgL_arg1858z00_4042 =
														(((BgL_variablez00_bglt) COBJECT(BgL_fz00_4009))->
														BgL_typez00);
													BgL_auxz00_4555 =
														BGl_makezd2typezd2approxz00zzcfa_approxz00
														(BgL_arg1858z00_4042);
												}
										}
										{
											obj_t BgL_auxz00_4548;

											{	/* Cfa/arithmetic.scm 280 */
												BgL_objectz00_bglt BgL_tmpz00_4549;

												BgL_tmpz00_4549 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4033)));
												BgL_auxz00_4548 = BGL_OBJECT_WIDENING(BgL_tmpz00_4549);
											}
											BgL_auxz00_4547 =
												((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4548);
										}
										((((BgL_arithmeticzd2appzd2_bglt)
													COBJECT(BgL_auxz00_4547))->BgL_approxz00) =
											((BgL_approxz00_bglt) BgL_auxz00_4555), BUNSPEC);
									}
									{
										BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4564;

										{
											obj_t BgL_auxz00_4565;

											{	/* Cfa/arithmetic.scm 279 */
												BgL_objectz00_bglt BgL_tmpz00_4566;

												BgL_tmpz00_4566 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_4033)));
												BgL_auxz00_4565 = BGL_OBJECT_WIDENING(BgL_tmpz00_4566);
											}
											BgL_auxz00_4564 =
												((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4565);
										}
										((((BgL_arithmeticzd2appzd2_bglt)
													COBJECT(BgL_auxz00_4564))->BgL_speczd2typeszd2) =
											((obj_t) BgL_speczd2typeszd2_4032), BUNSPEC);
									}
									return
										((obj_t)
										((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_4033)));
								}
							}
						}
					}
				}
			}
		}

	}



/* unspecified-type~0 */
	obj_t BGl_unspecifiedzd2typeze70z35zzcfa_arithmeticz00(obj_t BgL_lz00_3121)
	{
		{	/* Cfa/arithmetic.scm 253 */
			if (BGl_isazf3zf3zz__objectz00(BgL_lz00_3121, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 247 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 247 */
					if (BGl_isazf3zf3zz__objectz00(BgL_lz00_3121,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 249 */
							{	/* Cfa/arithmetic.scm 250 */
								BgL_typez00_bglt BgL_vz00_3810;

								BgL_vz00_3810 =
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
								((((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_lz00_3121))))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_vz00_3810), BUNSPEC);
							}
							return BgL_lz00_3121;
						}
					else
						{	/* Cfa/arithmetic.scm 249 */
							return BgL_lz00_3121;
						}
				}
		}

	}



/* &cleanup-node!-app1583 */
	obj_t BGl_z62cleanupzd2nodez12zd2app1583z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3908, obj_t BgL_nodez00_3909)
	{
		{	/* Cfa/arithmetic.scm 231 */
			{	/* Cfa/arithmetic.scm 232 */
				bool_t BgL_tmpz00_4584;

				{	/* Cfa/arithmetic.scm 233 */
					BgL_varz00_bglt BgL_arg1823z00_4044;

					BgL_arg1823z00_4044 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3909)))->BgL_funz00);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						((BgL_nodez00_bglt) BgL_arg1823z00_4044));
				}
				{	/* Cfa/arithmetic.scm 234 */
					obj_t BgL_g1534z00_4045;

					BgL_g1534z00_4045 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nodez00_3909)))->BgL_argsz00);
					{
						obj_t BgL_l1532z00_4047;

						BgL_l1532z00_4047 = BgL_g1534z00_4045;
					BgL_zc3z04anonymousza31824ze3z87_4046:
						if (PAIRP(BgL_l1532z00_4047))
							{	/* Cfa/arithmetic.scm 234 */
								{	/* Cfa/arithmetic.scm 234 */
									obj_t BgL_arg1826z00_4048;

									BgL_arg1826z00_4048 = CAR(BgL_l1532z00_4047);
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1826z00_4048));
								}
								{
									obj_t BgL_l1532z00_4596;

									BgL_l1532z00_4596 = CDR(BgL_l1532z00_4047);
									BgL_l1532z00_4047 = BgL_l1532z00_4596;
									goto BgL_zc3z04anonymousza31824ze3z87_4046;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 234 */
								BgL_tmpz00_4584 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4584);
			}
		}

	}



/* &cleanup-node!-funcal1581 */
	obj_t BGl_z62cleanupzd2nodez12zd2funcal1581z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3910, obj_t BgL_nodez00_3911)
	{
		{	/* Cfa/arithmetic.scm 223 */
			{	/* Cfa/arithmetic.scm 224 */
				bool_t BgL_tmpz00_4599;

				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3911)))->BgL_funz00));
				{	/* Cfa/arithmetic.scm 226 */
					obj_t BgL_g1531z00_4050;

					BgL_g1531z00_4050 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nodez00_3911)))->BgL_argsz00);
					{
						obj_t BgL_l1529z00_4052;

						BgL_l1529z00_4052 = BgL_g1531z00_4050;
					BgL_zc3z04anonymousza31818ze3z87_4051:
						if (PAIRP(BgL_l1529z00_4052))
							{	/* Cfa/arithmetic.scm 226 */
								{	/* Cfa/arithmetic.scm 226 */
									obj_t BgL_arg1821z00_4053;

									BgL_arg1821z00_4053 = CAR(BgL_l1529z00_4052);
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1821z00_4053));
								}
								{
									obj_t BgL_l1529z00_4610;

									BgL_l1529z00_4610 = CDR(BgL_l1529z00_4052);
									BgL_l1529z00_4052 = BgL_l1529z00_4610;
									goto BgL_zc3z04anonymousza31818ze3z87_4051;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 226 */
								BgL_tmpz00_4599 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4599);
			}
		}

	}



/* &cleanup-node!-app-ly1579 */
	obj_t BGl_z62cleanupzd2nodez12zd2appzd2ly1579za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3912, obj_t BgL_nodez00_3913)
	{
		{	/* Cfa/arithmetic.scm 215 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3913)))->BgL_funz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nodez00_3913)))->BgL_argz00));
		}

	}



/* &cleanup-node!-box-se1577 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2se1577za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3914, obj_t BgL_nodez00_3915)
	{
		{	/* Cfa/arithmetic.scm 207 */
			{	/* Cfa/arithmetic.scm 209 */
				BgL_varz00_bglt BgL_arg1812z00_4056;

				BgL_arg1812z00_4056 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3915)))->BgL_varz00);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1812z00_4056));
			}
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3915)))->BgL_valuez00));
		}

	}



/* &cleanup-node!-box-re1575 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2re1575za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3916, obj_t BgL_nodez00_3917)
	{
		{	/* Cfa/arithmetic.scm 200 */
			{	/* Cfa/arithmetic.scm 202 */
				BgL_varz00_bglt BgL_arg1811z00_4058;

				BgL_arg1811z00_4058 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nodez00_3917)))->BgL_varz00);
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1811z00_4058));
			}
		}

	}



/* &cleanup-node!-make-b1573 */
	obj_t BGl_z62cleanupzd2nodez12zd2makezd2b1573za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3918, obj_t BgL_nodez00_3919)
	{
		{	/* Cfa/arithmetic.scm 193 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nodez00_3919)))->BgL_valuez00));
		}

	}



/* &cleanup-node!-jump-e1571 */
	obj_t BGl_z62cleanupzd2nodez12zd2jumpzd2e1571za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3920, obj_t BgL_nodez00_3921)
	{
		{	/* Cfa/arithmetic.scm 185 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3921)))->BgL_exitz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3921)))->BgL_valuez00));
		}

	}



/* &cleanup-node!-set-ex1569 */
	obj_t BGl_z62cleanupzd2nodez12zd2setzd2ex1569za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3922, obj_t BgL_nodez00_3923)
	{
		{	/* Cfa/arithmetic.scm 177 */
			{	/* Cfa/arithmetic.scm 179 */
				BgL_varz00_bglt BgL_arg1804z00_4062;

				BgL_arg1804z00_4062 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3923)))->BgL_varz00);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					((BgL_nodez00_bglt) BgL_arg1804z00_4062));
			}
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3923)))->BgL_bodyz00));
		}

	}



/* &cleanup-node!-let-va1566 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2va1566za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3924, obj_t BgL_nodez00_3925)
	{
		{	/* Cfa/arithmetic.scm 167 */
			{	/* Cfa/arithmetic.scm 169 */
				obj_t BgL_g1528z00_4064;

				BgL_g1528z00_4064 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3925)))->BgL_bindingsz00);
				{
					obj_t BgL_l1526z00_4066;

					BgL_l1526z00_4066 = BgL_g1528z00_4064;
				BgL_zc3z04anonymousza31775ze3z87_4065:
					if (PAIRP(BgL_l1526z00_4066))
						{	/* Cfa/arithmetic.scm 169 */
							{	/* Cfa/arithmetic.scm 169 */
								obj_t BgL_bz00_4067;

								BgL_bz00_4067 = CAR(BgL_l1526z00_4066);
								{	/* Cfa/arithmetic.scm 169 */
									obj_t BgL_arg1786z00_4068;

									BgL_arg1786z00_4068 = CDR(((obj_t) BgL_bz00_4067));
									BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
										((BgL_nodez00_bglt) BgL_arg1786z00_4068));
								}
							}
							{
								obj_t BgL_l1526z00_4655;

								BgL_l1526z00_4655 = CDR(BgL_l1526z00_4066);
								BgL_l1526z00_4066 = BgL_l1526z00_4655;
								goto BgL_zc3z04anonymousza31775ze3z87_4065;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 169 */
							((bool_t) 1);
						}
				}
			}
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nodez00_3925)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 171 */
				bool_t BgL_test2228z00_4660;

				{	/* Cfa/arithmetic.scm 171 */
					BgL_typez00_bglt BgL_arg1802z00_4069;

					BgL_arg1802z00_4069 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2varzd2_bglt) BgL_nodez00_3925))))->BgL_typez00);
					BgL_test2228z00_4660 =
						(((obj_t) BgL_arg1802z00_4069) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test2228z00_4660)
					{	/* Cfa/arithmetic.scm 171 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2varzd2_bglt) BgL_nodez00_3925))))->
								BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_letzd2varzd2_bglt)
													COBJECT(((BgL_letzd2varzd2_bglt) BgL_nodez00_3925)))->
												BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 171 */
						return BFALSE;
					}
			}
		}

	}



/* &cleanup-node!-let-fu1564 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2fu1564za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3926, obj_t BgL_nodez00_3927)
	{
		{	/* Cfa/arithmetic.scm 157 */
			{	/* Cfa/arithmetic.scm 159 */
				obj_t BgL_g1525z00_4071;

				BgL_g1525z00_4071 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3927)))->BgL_localsz00);
				{
					obj_t BgL_l1523z00_4073;

					BgL_l1523z00_4073 = BgL_g1525z00_4071;
				BgL_zc3z04anonymousza31747ze3z87_4072:
					if (PAIRP(BgL_l1523z00_4073))
						{	/* Cfa/arithmetic.scm 159 */
							{	/* Cfa/arithmetic.scm 159 */
								obj_t BgL_arg1751z00_4074;

								BgL_arg1751z00_4074 = CAR(BgL_l1523z00_4073);
								{	/* Cfa/arithmetic.scm 90 */
									BgL_valuez00_bglt BgL_funz00_4075;

									BgL_funz00_4075 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt) BgL_arg1751z00_4074)))->
										BgL_valuez00);
									{	/* Cfa/arithmetic.scm 90 */
										obj_t BgL_bodyz00_4076;

										BgL_bodyz00_4076 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_funz00_4075)))->BgL_bodyz00);
										{	/* Cfa/arithmetic.scm 91 */

											BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
												((BgL_nodez00_bglt) BgL_bodyz00_4076));
										}
									}
								}
							}
							{
								obj_t BgL_l1523z00_4683;

								BgL_l1523z00_4683 = CDR(BgL_l1523z00_4073);
								BgL_l1523z00_4073 = BgL_l1523z00_4683;
								goto BgL_zc3z04anonymousza31747ze3z87_4072;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 159 */
							((bool_t) 1);
						}
				}
			}
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nodez00_3927)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 161 */
				bool_t BgL_test2230z00_4688;

				{	/* Cfa/arithmetic.scm 161 */
					BgL_typez00_bglt BgL_arg1774z00_4077;

					BgL_arg1774z00_4077 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_letzd2funzd2_bglt) BgL_nodez00_3927))))->BgL_typez00);
					BgL_test2230z00_4688 =
						(((obj_t) BgL_arg1774z00_4077) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test2230z00_4688)
					{	/* Cfa/arithmetic.scm 161 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_letzd2funzd2_bglt) BgL_nodez00_3927))))->
								BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_letzd2funzd2_bglt)
													COBJECT(((BgL_letzd2funzd2_bglt) BgL_nodez00_3927)))->
												BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 161 */
						return BFALSE;
					}
			}
		}

	}



/* &cleanup-node!-switch1562 */
	obj_t BGl_z62cleanupzd2nodez12zd2switch1562z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3928, obj_t BgL_nodez00_3929)
	{
		{	/* Cfa/arithmetic.scm 149 */
			{	/* Cfa/arithmetic.scm 150 */
				bool_t BgL_tmpz00_4700;

				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_3929)))->BgL_testz00));
				{	/* Cfa/arithmetic.scm 152 */
					obj_t BgL_g1522z00_4079;

					BgL_g1522z00_4079 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nodez00_3929)))->BgL_clausesz00);
					{
						obj_t BgL_l1520z00_4081;

						BgL_l1520z00_4081 = BgL_g1522z00_4079;
					BgL_zc3z04anonymousza31740ze3z87_4080:
						if (PAIRP(BgL_l1520z00_4081))
							{	/* Cfa/arithmetic.scm 152 */
								{	/* Cfa/arithmetic.scm 152 */
									obj_t BgL_clausez00_4082;

									BgL_clausez00_4082 = CAR(BgL_l1520z00_4081);
									{	/* Cfa/arithmetic.scm 152 */
										obj_t BgL_arg1744z00_4083;

										BgL_arg1744z00_4083 = CDR(((obj_t) BgL_clausez00_4082));
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1744z00_4083));
									}
								}
								{
									obj_t BgL_l1520z00_4713;

									BgL_l1520z00_4713 = CDR(BgL_l1520z00_4081);
									BgL_l1520z00_4081 = BgL_l1520z00_4713;
									goto BgL_zc3z04anonymousza31740ze3z87_4080;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 152 */
								BgL_tmpz00_4700 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_4700);
			}
		}

	}



/* &cleanup-node!-fail1560 */
	obj_t BGl_z62cleanupzd2nodez12zd2fail1560z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3930, obj_t BgL_nodez00_3931)
	{
		{	/* Cfa/arithmetic.scm 140 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3931)))->BgL_procz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3931)))->BgL_msgz00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nodez00_3931)))->BgL_objz00));
		}

	}



/* &cleanup-node!-condit1558 */
	obj_t BGl_z62cleanupzd2nodez12zd2condit1558z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3932, obj_t BgL_nodez00_3933)
	{
		{	/* Cfa/arithmetic.scm 131 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3933)))->BgL_testz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3933)))->BgL_truez00));
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nodez00_3933)))->BgL_falsez00));
		}

	}



/* &cleanup-node!-setq1556 */
	obj_t BGl_z62cleanupzd2nodez12zd2setq1556z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3934, obj_t BgL_nodez00_3935)
	{
		{	/* Cfa/arithmetic.scm 124 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nodez00_3935)))->BgL_valuez00));
		}

	}



/* &cleanup-node!-sync1554 */
	obj_t BGl_z62cleanupzd2nodez12zd2sync1554z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3936, obj_t BgL_nodez00_3937)
	{
		{	/* Cfa/arithmetic.scm 113 */
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3937)))->BgL_mutexz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3937)))->BgL_prelockz00));
			BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nodez00_3937)))->BgL_bodyz00));
			{	/* Cfa/arithmetic.scm 118 */
				bool_t BgL_test2232z00_4746;

				{	/* Cfa/arithmetic.scm 118 */
					BgL_typez00_bglt BgL_arg1724z00_4088;

					BgL_arg1724z00_4088 =
						(((BgL_nodez00_bglt) COBJECT(
								((BgL_nodez00_bglt)
									((BgL_syncz00_bglt) BgL_nodez00_3937))))->BgL_typez00);
					BgL_test2232z00_4746 =
						(((obj_t) BgL_arg1724z00_4088) == BGl_za2_za2z00zztype_cachez00);
				}
				if (BgL_test2232z00_4746)
					{	/* Cfa/arithmetic.scm 118 */
						return
							((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_syncz00_bglt) BgL_nodez00_3937))))->BgL_typez00) =
							((BgL_typez00_bglt) (((BgL_nodez00_bglt)
										COBJECT((((BgL_syncz00_bglt) COBJECT(((BgL_syncz00_bglt)
															BgL_nodez00_3937)))->BgL_bodyz00)))->
									BgL_typez00)), BUNSPEC);
					}
				else
					{	/* Cfa/arithmetic.scm 118 */
						return BFALSE;
					}
			}
		}

	}



/* &cleanup-node!-sequen1552 */
	obj_t BGl_z62cleanupzd2nodez12zd2sequen1552z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3938, obj_t BgL_nodez00_3939)
	{
		{	/* Cfa/arithmetic.scm 103 */
			if (NULLP(
					(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nodez00_3939)))->BgL_nodesz00)))
				{	/* Cfa/arithmetic.scm 105 */
					return BFALSE;
				}
			else
				{	/* Cfa/arithmetic.scm 105 */
					{	/* Cfa/arithmetic.scm 106 */
						obj_t BgL_g1519z00_4090;

						BgL_g1519z00_4090 =
							(((BgL_sequencez00_bglt) COBJECT(
									((BgL_sequencez00_bglt) BgL_nodez00_3939)))->BgL_nodesz00);
						{
							obj_t BgL_l1517z00_4092;

							BgL_l1517z00_4092 = BgL_g1519z00_4090;
						BgL_zc3z04anonymousza31688ze3z87_4091:
							if (PAIRP(BgL_l1517z00_4092))
								{	/* Cfa/arithmetic.scm 106 */
									{	/* Cfa/arithmetic.scm 106 */
										obj_t BgL_arg1690z00_4093;

										BgL_arg1690z00_4093 = CAR(BgL_l1517z00_4092);
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1690z00_4093));
									}
									{
										obj_t BgL_l1517z00_4769;

										BgL_l1517z00_4769 = CDR(BgL_l1517z00_4092);
										BgL_l1517z00_4092 = BgL_l1517z00_4769;
										goto BgL_zc3z04anonymousza31688ze3z87_4091;
									}
								}
							else
								{	/* Cfa/arithmetic.scm 106 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/arithmetic.scm 107 */
						bool_t BgL_test2235z00_4771;

						{	/* Cfa/arithmetic.scm 107 */
							BgL_typez00_bglt BgL_arg1704z00_4094;

							BgL_arg1704z00_4094 =
								(((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt)
											((BgL_sequencez00_bglt) BgL_nodez00_3939))))->
								BgL_typez00);
							BgL_test2235z00_4771 =
								(((obj_t) BgL_arg1704z00_4094) ==
								BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_test2235z00_4771)
							{	/* Cfa/arithmetic.scm 107 */
								return
									((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt)
													((BgL_sequencez00_bglt) BgL_nodez00_3939))))->
										BgL_typez00) =
									((BgL_typez00_bglt) (((BgL_nodez00_bglt)
												COBJECT(((BgL_nodez00_bglt)
														CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
																(((BgL_sequencez00_bglt)
																		COBJECT(((BgL_sequencez00_bglt)
																				BgL_nodez00_3939)))->
																	BgL_nodesz00))))))->BgL_typez00)), BUNSPEC);
							}
						else
							{	/* Cfa/arithmetic.scm 107 */
								return BFALSE;
							}
					}
				}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 3788352),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 471177480),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 131412063),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 168272122),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 324810626),
				BSTRING_TO_STRING(BGl_string2148z00zzcfa_arithmeticz00));
		}

	}

#ifdef __cplusplus
}
#endif
