/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/convert.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
		obj_t BgL_subclassesz00;
	}                *BgL_tclassz00_bglt;


	extern obj_t BGl_za2uint32za2z00zztype_cachez00;
	extern obj_t BGl_za2uint16za2z00zztype_cachez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	static BgL_nodez00_bglt BGl_dozd2convertzd2zzcoerce_convertz00(obj_t,
		BgL_nodez00_bglt, BgL_typez00_bglt);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2stackzd2checkz00zzcoerce_convertz00();
	static obj_t BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00(obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_notifyzd2typezd2testz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	static long BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzcoerce_convertz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_objectzd2initzd2zzcoerce_convertz00();
	static BgL_nodez00_bglt
		BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t, obj_t, obj_t,
		obj_t, BgL_nodez00_bglt, bool_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	extern obj_t BGl_castz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t, BgL_nodez00_bglt);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static long BGl_za2checkza2z00zzcoerce_convertz00;
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2uint64za2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_warningzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_notifiedzd2locationszd2zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_za2stringza2z00zztype_cachez00;
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2typesza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt,
		BgL_typez00_bglt, obj_t, BgL_nodez00_bglt);
	static obj_t BGl_methodzd2initzd2zzcoerce_convertz00();
	static BgL_nodez00_bglt
		BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(BgL_typez00_bglt,
		obj_t, obj_t, obj_t, BgL_nodez00_bglt);
	static obj_t BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2realza2z00zztype_cachez00;
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2int32za2z00zztype_cachez00;
	extern obj_t BGl_za2int16za2z00zztype_cachez00;
	extern obj_t BGl_za2uint8za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_findzd2coercerzd2zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2scharza2z00zztype_cachez00;
	BGL_EXPORTED_DEF obj_t BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 =
		BUNSPEC;
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	static BgL_nodez00_bglt BGl_z62convertz12z70zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2elongza2z00zztype_cachez00;
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2int8za2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_tprintz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzcoerce_convertz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
	static obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
	static obj_t BGl_gczd2rootszd2initz00zzcoerce_convertz00();
	extern obj_t BGl_za2llongza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_za2int64za2z00zztype_cachez00;
	static BgL_nodez00_bglt
		BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT int BGl_bigloozd2tracezd2stackzd2depthzd2zz__paramz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt, BgL_typez00_bglt,
		BgL_typez00_bglt, bool_t);
	extern bool_t
		BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nodez00_bglt);
	extern BgL_typez00_bglt
		BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t
		BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00(int);
	BGL_IMPORT obj_t BGl_memberz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2typezd2errorza2z00zzengine_paramz00;
	extern obj_t BGl_za2charza2z00zztype_cachez00;
	static obj_t __cnst[11];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_runtimezd2typezd2errorzd2envzd2zzcoerce_convertz00,
		BgL_bgl_za762runtimeza7d2typ2020z00,
		BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_convertz12zd2envzc0zzcoerce_convertz00,
		BgL_bgl_za762convertza712za7702021za7,
		BGl_z62convertz12z70zzcoerce_convertz00, 0L, BUNSPEC, 4);
	      DEFINE_REAL(BGl_real2010z00zzcoerce_convertz00,
		BgL_bgl_real2010za700za7za7coe2022za7, 0.0);
	      DEFINE_STRING(BGl_string2007z00zzcoerce_convertz00,
		BgL_bgl_string2007za700za7za7c2023za7,
		" ~a. Type test inserted \"~a\" -> \"~a\"", 36);
	      DEFINE_STRING(BGl_string2008z00zzcoerce_convertz00,
		BgL_bgl_string2008za700za7za7c2024za7, "", 0);
	      DEFINE_STRING(BGl_string2009z00zzcoerce_convertz00,
		BgL_bgl_string2009za700za7za7c2025za7, "Type error", 10);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2stackzd2checkzd2envzd2zzcoerce_convertz00,
		BgL_bgl_za762getza7d2stackza7d2026za7,
		BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2011z00zzcoerce_convertz00,
		BgL_bgl_string2011za700za7za7c2027za7, "e.1 ", 4);
	      DEFINE_STRING(BGl_string2012z00zzcoerce_convertz00,
		BgL_bgl_string2012za700za7za7c2028za7, ":", 1);
	      DEFINE_STRING(BGl_string2013z00zzcoerce_convertz00,
		BgL_bgl_string2013za700za7za7c2029za7, ",", 1);
	      DEFINE_STRING(BGl_string2014z00zzcoerce_convertz00,
		BgL_bgl_string2014za700za7za7c2030za7, "Coerce/convert.scm", 18);
	      DEFINE_STRING(BGl_string2015z00zzcoerce_convertz00,
		BgL_bgl_string2015za700za7za7c2031za7, "Illegal conversion", 18);
	      DEFINE_STRING(BGl_string2016z00zzcoerce_convertz00,
		BgL_bgl_string2016za700za7za7c2032za7, "coerce_convert", 14);
	      DEFINE_STRING(BGl_string2017z00zzcoerce_convertz00,
		BgL_bgl_string2017za700za7za7c2033za7,
		"aux2 if coercer let ::obj aux failure @ type-error __error location ", 68);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzcoerce_convertz00));
		     ADD_ROOT((void *) (&BGl_notifiedzd2locationszd2zzcoerce_convertz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long
		BgL_checksumz00_2579, char *BgL_fromz00_2580)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_convertz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_convertz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzcoerce_convertz00();
					BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
					BGl_cnstzd2initzd2zzcoerce_convertz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
					return BGl_toplevelzd2initzd2zzcoerce_convertz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0),
				"coerce_convert");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			{	/* Coerce/convert.scm 16 */
				obj_t BgL_cportz00_2567;

				{	/* Coerce/convert.scm 16 */
					obj_t BgL_stringz00_2575;

					BgL_stringz00_2575 = BGl_string2017z00zzcoerce_convertz00;
					{	/* Coerce/convert.scm 16 */
						obj_t BgL_startz00_2576;

						BgL_startz00_2576 = BINT(((long) 0));
						{	/* Coerce/convert.scm 16 */
							obj_t BgL_endz00_2577;

							BgL_endz00_2577 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2575)));
							{	/* Coerce/convert.scm 16 */

								BgL_cportz00_2567 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2575, BgL_startz00_2576, BgL_endz00_2577);
				}}}}
				{
					long BgL_iz00_2568;

					BgL_iz00_2568 = ((long) 10);
				BgL_loopz00_2569:
					if ((BgL_iz00_2568 == ((long) -1)))
						{	/* Coerce/convert.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/convert.scm 16 */
							{	/* Coerce/convert.scm 16 */
								obj_t BgL_arg2019z00_2571;

								{	/* Coerce/convert.scm 16 */

									{	/* Coerce/convert.scm 16 */
										obj_t BgL_locationz00_2573;

										BgL_locationz00_2573 = BBOOL(((bool_t) 0));
										{	/* Coerce/convert.scm 16 */

											BgL_arg2019z00_2571 =
												BGl_readz00zz__readerz00(BgL_cportz00_2567,
												BgL_locationz00_2573);
										}
									}
								}
								{	/* Coerce/convert.scm 16 */
									int BgL_tmpz00_2610;

									BgL_tmpz00_2610 = (int) (BgL_iz00_2568);
									CNST_TABLE_SET(BgL_tmpz00_2610, BgL_arg2019z00_2571);
							}}
							{	/* Coerce/convert.scm 16 */
								int BgL_auxz00_2574;

								BgL_auxz00_2574 = (int) ((BgL_iz00_2568 - ((long) 1)));
								{
									long BgL_iz00_2615;

									BgL_iz00_2615 = (long) (BgL_auxz00_2574);
									BgL_iz00_2568 = BgL_iz00_2615;
									goto BgL_loopz00_2569;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_za2checkza2z00zzcoerce_convertz00 = ((long) 0);
			BGl_notifiedzd2locationszd2zzcoerce_convertz00 = BNIL;
			BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00 = BTRUE;
			return (BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
				((long) 0), BUNSPEC);
		}

	}



/* notify-type-test */
	obj_t BGl_notifyzd2typezd2testz00zzcoerce_convertz00(obj_t BgL_fromz00_35,
		obj_t BgL_toz00_36, obj_t BgL_locz00_37)
	{
		{	/* Coerce/convert.scm 59 */
			if (CBOOL(BGl_za2notifyzd2typezd2testza2z00zzcoerce_convertz00))
				{	/* Coerce/convert.scm 61 */
					int BgL_stz00_1758;

					BgL_stz00_1758 = BGl_bigloozd2tracezd2stackzd2depthzd2zz__paramz00();
					BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00(
						(int) (((long) 0)));
					if (CBOOL(BgL_locz00_37))
						{	/* Coerce/convert.scm 64 */
							if (CBOOL(BGl_memberz00zz__r4_pairs_and_lists_6_3z00
									(BgL_locz00_37,
										BGl_notifiedzd2locationszd2zzcoerce_convertz00)))
								{	/* Coerce/convert.scm 69 */
									BFALSE;
								}
							else
								{	/* Coerce/convert.scm 69 */
									BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
										(((long) 1) +
										BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00);
									BGl_notifiedzd2locationszd2zzcoerce_convertz00 =
										MAKE_YOUNG_PAIR(BgL_locz00_37,
										BGl_notifiedzd2locationszd2zzcoerce_convertz00);
									{	/* Coerce/convert.scm 72 */
										obj_t BgL_arg1404z00_1760;
										obj_t BgL_arg1409z00_1761;
										obj_t BgL_arg1435z00_1762;

										BgL_arg1404z00_1760 =
											BGl_locationzd2fullzd2fnamez00zztools_locationz00
											(BgL_locz00_37);
										BgL_arg1409z00_1761 =
											STRUCT_REF(((obj_t) BgL_locz00_37), (int) (((long) 1)));
										{	/* Coerce/convert.scm 75 */
											obj_t BgL_arg1445z00_1764;
											obj_t BgL_arg1446z00_1765;

											BgL_arg1445z00_1764 =
												BGl_shapez00zztools_shapez00(BgL_fromz00_35);
											BgL_arg1446z00_1765 =
												BGl_shapez00zztools_shapez00(BgL_toz00_36);
											{	/* Coerce/convert.scm 74 */
												obj_t BgL_list1447z00_1766;

												{	/* Coerce/convert.scm 74 */
													obj_t BgL_arg1451z00_1767;

													{	/* Coerce/convert.scm 74 */
														obj_t BgL_arg1484z00_1768;

														BgL_arg1484z00_1768 =
															MAKE_YOUNG_PAIR(BgL_arg1446z00_1765, BNIL);
														BgL_arg1451z00_1767 =
															MAKE_YOUNG_PAIR(BgL_arg1445z00_1764,
															BgL_arg1484z00_1768);
													}
													BgL_list1447z00_1766 =
														MAKE_YOUNG_PAIR(BINT
														(BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00),
														BgL_arg1451z00_1767);
												}
												BgL_arg1435z00_1762 =
													BGl_formatz00zz__r4_output_6_10_3z00
													(BGl_string2007z00zzcoerce_convertz00,
													BgL_list1447z00_1766);
										}}
										{	/* Coerce/convert.scm 72 */
											obj_t BgL_list1436z00_1763;

											BgL_list1436z00_1763 =
												MAKE_YOUNG_PAIR(BgL_arg1435z00_1762, BNIL);
											BGl_warningzf2locationzf2zz__errorz00(BgL_arg1404z00_1760,
												BgL_arg1409z00_1761, BgL_list1436z00_1763);
						}}}}
					else
						{	/* Coerce/convert.scm 64 */
							BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00 =
								(((long) 1) + BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00);
							{	/* Coerce/convert.scm 68 */
								obj_t BgL_arg1500z00_1769;

								{	/* Coerce/convert.scm 68 */
									obj_t BgL_arg1502z00_1771;
									obj_t BgL_arg1520z00_1772;

									BgL_arg1502z00_1771 =
										BGl_shapez00zztools_shapez00(BgL_fromz00_35);
									BgL_arg1520z00_1772 =
										BGl_shapez00zztools_shapez00(BgL_toz00_36);
									{	/* Coerce/convert.scm 67 */
										obj_t BgL_list1522z00_1773;

										{	/* Coerce/convert.scm 67 */
											obj_t BgL_arg1526z00_1774;

											{	/* Coerce/convert.scm 67 */
												obj_t BgL_arg1527z00_1775;

												BgL_arg1527z00_1775 =
													MAKE_YOUNG_PAIR(BgL_arg1520z00_1772, BNIL);
												BgL_arg1526z00_1774 =
													MAKE_YOUNG_PAIR(BgL_arg1502z00_1771,
													BgL_arg1527z00_1775);
											}
											BgL_list1522z00_1773 =
												MAKE_YOUNG_PAIR(BINT
												(BGl_za2notifyzd2counterza2zd2zzcoerce_convertz00),
												BgL_arg1526z00_1774);
										}
										BgL_arg1500z00_1769 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string2007z00zzcoerce_convertz00,
											BgL_list1522z00_1773);
								}}
								{	/* Coerce/convert.scm 66 */
									obj_t BgL_list1501z00_1770;

									BgL_list1501z00_1770 =
										MAKE_YOUNG_PAIR(BgL_arg1500z00_1769, BNIL);
									BGl_warningz00zz__errorz00(BgL_list1501z00_1770);
						}}}
					return
						BGl_bigloozd2tracezd2stackzd2depthzd2setz12z12zz__paramz00
						(BgL_stz00_1758);
				}
			else
				{	/* Coerce/convert.scm 60 */
					return BFALSE;
				}
		}

	}



/* get-stack-check */
	BGL_EXPORTED_DEF obj_t BGl_getzd2stackzd2checkz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 88 */
			return BINT(BGl_za2checkza2z00zzcoerce_convertz00);
		}

	}



/* &get-stack-check */
	obj_t BGl_z62getzd2stackzd2checkz62zzcoerce_convertz00(obj_t BgL_envz00_2555)
	{
		{	/* Coerce/convert.scm 88 */
			return BGl_getzd2stackzd2checkz00zzcoerce_convertz00();
		}

	}



/* runtime-type-error/id */
	obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t
		BgL_locz00_49, obj_t BgL_tiz00_50, obj_t BgL_idz00_51)
	{
		{	/* Coerce/convert.scm 114 */
			{	/* Coerce/convert.scm 116 */
				obj_t BgL_fnamez00_1783;
				obj_t BgL_posz00_1784;

				{	/* Coerce/convert.scm 116 */
					bool_t BgL_test2039z00_2656;

					if (STRUCTP(BgL_locz00_49))
						{	/* Coerce/convert.scm 116 */
							BgL_test2039z00_2656 =
								(STRUCT_KEY(BgL_locz00_49) == CNST_TABLE_REF(((long) 0)));
						}
					else
						{	/* Coerce/convert.scm 116 */
							BgL_test2039z00_2656 = ((bool_t) 0);
						}
					if (BgL_test2039z00_2656)
						{	/* Coerce/convert.scm 116 */
							BgL_fnamez00_1783 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_49);
						}
					else
						{	/* Coerce/convert.scm 116 */
							BgL_fnamez00_1783 = BFALSE;
						}
				}
				{	/* Coerce/convert.scm 117 */
					bool_t BgL_test2041z00_2663;

					if (STRUCTP(BgL_locz00_49))
						{	/* Coerce/convert.scm 117 */
							BgL_test2041z00_2663 =
								(STRUCT_KEY(BgL_locz00_49) == CNST_TABLE_REF(((long) 0)));
						}
					else
						{	/* Coerce/convert.scm 117 */
							BgL_test2041z00_2663 = ((bool_t) 0);
						}
					if (BgL_test2041z00_2663)
						{	/* Coerce/convert.scm 117 */
							BgL_posz00_1784 = STRUCT_REF(BgL_locz00_49, (int) (((long) 1)));
						}
					else
						{	/* Coerce/convert.scm 117 */
							BgL_posz00_1784 = BFALSE;
						}
				}
				{	/* Coerce/convert.scm 119 */
					obj_t BgL_arg1546z00_1785;

					{	/* Coerce/convert.scm 119 */
						obj_t BgL_arg1547z00_1786;
						obj_t BgL_arg1551z00_1787;

						{	/* Coerce/convert.scm 119 */
							obj_t BgL_arg1555z00_1788;
							obj_t BgL_arg1557z00_1789;

							{	/* Coerce/convert.scm 119 */
								obj_t BgL_arg1558z00_1790;

								{	/* Coerce/convert.scm 119 */
									obj_t BgL_arg1559z00_1791;

									BgL_arg1559z00_1791 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 1)), BNIL);
									BgL_arg1558z00_1790 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 2)),
										BgL_arg1559z00_1791);
								}
								BgL_arg1555z00_1788 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 3)),
									BgL_arg1558z00_1790);
							}
							{	/* Coerce/convert.scm 120 */
								obj_t BgL_arg1560z00_1792;

								{	/* Coerce/convert.scm 120 */
									obj_t BgL_arg1561z00_1793;

									{	/* Coerce/convert.scm 120 */
										obj_t BgL_arg1563z00_1794;
										obj_t BgL_arg1568z00_1795;

										{	/* Coerce/convert.scm 120 */
											obj_t BgL_arg1569z00_1796;

											BgL_arg1569z00_1796 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 120 */
												obj_t BgL_arg1447z00_2356;

												BgL_arg1447z00_2356 =
													SYMBOL_TO_STRING(((obj_t) BgL_arg1569z00_1796));
												BgL_arg1563z00_1794 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1447z00_2356);
										}}
										{	/* Coerce/convert.scm 121 */
											obj_t BgL_arg1571z00_1797;
											obj_t BgL_arg1573z00_1798;

											{	/* Coerce/convert.scm 121 */
												obj_t BgL_arg1447z00_2358;

												BgL_arg1447z00_2358 =
													SYMBOL_TO_STRING(((obj_t) BgL_tiz00_50));
												BgL_arg1571z00_1797 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1447z00_2358);
											}
											BgL_arg1573z00_1798 = MAKE_YOUNG_PAIR(BgL_idz00_51, BNIL);
											BgL_arg1568z00_1795 =
												MAKE_YOUNG_PAIR(BgL_arg1571z00_1797,
												BgL_arg1573z00_1798);
										}
										BgL_arg1561z00_1793 =
											MAKE_YOUNG_PAIR(BgL_arg1563z00_1794, BgL_arg1568z00_1795);
									}
									BgL_arg1560z00_1792 =
										MAKE_YOUNG_PAIR(BgL_posz00_1784, BgL_arg1561z00_1793);
								}
								BgL_arg1557z00_1789 =
									MAKE_YOUNG_PAIR(BgL_fnamez00_1783, BgL_arg1560z00_1792);
							}
							BgL_arg1547z00_1786 =
								MAKE_YOUNG_PAIR(BgL_arg1555z00_1788, BgL_arg1557z00_1789);
						}
						{	/* Coerce/convert.scm 118 */
							obj_t BgL_arg1579z00_1799;

							BgL_arg1579z00_1799 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1551z00_1787 =
								MAKE_YOUNG_PAIR(BFALSE, BgL_arg1579z00_1799);
						}
						BgL_arg1546z00_1785 =
							MAKE_YOUNG_PAIR(BgL_arg1547z00_1786, BgL_arg1551z00_1787);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 4)), BgL_arg1546z00_1785);
		}}}

	}



/* runtime-type-error */
	BGL_EXPORTED_DEF obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t
		BgL_locz00_52, obj_t BgL_tiz00_53, BgL_nodez00_bglt BgL_valuez00_54)
	{
		{	/* Coerce/convert.scm 128 */
			{	/* Coerce/convert.scm 130 */
				obj_t BgL_auxz00_1802;

				BgL_auxz00_1802 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5)));
				{	/* Coerce/convert.scm 130 */
					BgL_nodez00_bglt BgL_uvaluez00_1803;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_valuez00_54), BGl_varz00zzast_nodez00))
						{	/* Coerce/convert.scm 132 */
							BgL_nodez00_bglt BgL_duplicated1110z00_1820;
							BgL_varz00_bglt BgL_new1108z00_1821;

							BgL_duplicated1110z00_1820 = BgL_valuez00_54;
							{	/* Coerce/convert.scm 132 */
								BgL_varz00_bglt BgL_new1112z00_1823;

								BgL_new1112z00_1823 =
									((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_varz00_bgl))));
								{	/* Coerce/convert.scm 132 */
									long BgL_arg1616z00_1824;

									BgL_arg1616z00_1824 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1112z00_1823),
										BgL_arg1616z00_1824);
								}
								BgL_new1108z00_1821 = BgL_new1112z00_1823;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1108z00_1821)))->BgL_locz00) =
								((obj_t) (((BgL_nodez00_bglt)
											COBJECT(BgL_duplicated1110z00_1820))->BgL_locz00)),
								BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1108z00_1821)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2objza2z00zztype_cachez00)), BUNSPEC);
							((((BgL_varz00_bglt) COBJECT(BgL_new1108z00_1821))->
									BgL_variablez00) =
								((BgL_variablez00_bglt) (((BgL_varz00_bglt)
											COBJECT(((BgL_varz00_bglt) BgL_duplicated1110z00_1820)))->
										BgL_variablez00)), BUNSPEC);
							BgL_uvaluez00_1803 = ((BgL_nodez00_bglt) BgL_new1108z00_1821);
						}
					else
						{	/* Coerce/convert.scm 131 */
							BgL_uvaluez00_1803 = BgL_valuez00_54;
						}
					{	/* Coerce/convert.scm 131 */
						BgL_nodez00_bglt BgL_resz00_1804;

						{	/* Coerce/convert.scm 136 */
							obj_t BgL_arg1584z00_1807;

							{	/* Coerce/convert.scm 136 */
								obj_t BgL_arg1585z00_1808;

								{	/* Coerce/convert.scm 136 */
									obj_t BgL_arg1597z00_1809;
									obj_t BgL_arg1598z00_1810;

									{	/* Coerce/convert.scm 136 */
										obj_t BgL_arg1599z00_1811;

										{	/* Coerce/convert.scm 136 */
											obj_t BgL_arg1600z00_1812;
											obj_t BgL_arg1603z00_1813;

											{	/* Coerce/convert.scm 136 */
												obj_t BgL_arg1604z00_1814;

												{	/* Coerce/convert.scm 136 */
													obj_t BgL_arg1605z00_1815;

													{	/* Coerce/convert.scm 136 */
														obj_t BgL_arg1612z00_1816;
														obj_t BgL_arg1613z00_1817;

														{	/* Coerce/convert.scm 136 */
															obj_t BgL_arg1447z00_2363;

															BgL_arg1447z00_2363 =
																SYMBOL_TO_STRING(BgL_auxz00_1802);
															BgL_arg1612z00_1816 =
																BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																(BgL_arg1447z00_2363);
														}
														{	/* Coerce/convert.scm 136 */
															obj_t BgL_symbolz00_2364;

															BgL_symbolz00_2364 = CNST_TABLE_REF(((long) 6));
															{	/* Coerce/convert.scm 136 */
																obj_t BgL_arg1447z00_2365;

																BgL_arg1447z00_2365 =
																	SYMBOL_TO_STRING(BgL_symbolz00_2364);
																BgL_arg1613z00_1817 =
																	BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																	(BgL_arg1447z00_2365);
														}}
														BgL_arg1605z00_1815 =
															string_append(BgL_arg1612z00_1816,
															BgL_arg1613z00_1817);
													}
													BgL_arg1604z00_1814 =
														bstring_to_symbol(BgL_arg1605z00_1815);
												}
												BgL_arg1600z00_1812 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg1604z00_1814);
											}
											BgL_arg1603z00_1813 = MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
											BgL_arg1599z00_1811 =
												MAKE_YOUNG_PAIR(BgL_arg1600z00_1812,
												BgL_arg1603z00_1813);
										}
										BgL_arg1597z00_1809 =
											MAKE_YOUNG_PAIR(BgL_arg1599z00_1811, BNIL);
									}
									BgL_arg1598z00_1810 =
										MAKE_YOUNG_PAIR
										(BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
										(BgL_locz00_52, BgL_tiz00_53, BgL_auxz00_1802), BNIL);
									BgL_arg1585z00_1808 =
										MAKE_YOUNG_PAIR(BgL_arg1597z00_1809, BgL_arg1598z00_1810);
								}
								BgL_arg1584z00_1807 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
									BgL_arg1585z00_1808);
							}
							BgL_resz00_1804 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg1584z00_1807, BgL_locz00_52);
						}
						{	/* Coerce/convert.scm 135 */

							{	/* Coerce/convert.scm 140 */
								obj_t BgL_arg1582z00_1805;

								{	/* Coerce/convert.scm 140 */
									obj_t BgL_pairz00_2368;

									BgL_pairz00_2368 =
										(((BgL_letzd2varzd2_bglt) COBJECT(
												((BgL_letzd2varzd2_bglt) BgL_resz00_1804)))->
										BgL_bindingsz00);
									BgL_arg1582z00_1805 = CAR(BgL_pairz00_2368);
								}
								{	/* Coerce/convert.scm 140 */
									obj_t BgL_auxz00_2736;
									obj_t BgL_tmpz00_2734;

									BgL_auxz00_2736 = ((obj_t) BgL_uvaluez00_1803);
									BgL_tmpz00_2734 = ((obj_t) BgL_arg1582z00_1805);
									SET_CDR(BgL_tmpz00_2734, BgL_auxz00_2736);
							}}
							return ((obj_t) BgL_resz00_1804);
						}
					}
				}
			}
		}

	}



/* &runtime-type-error */
	obj_t BGl_z62runtimezd2typezd2errorz62zzcoerce_convertz00(obj_t
		BgL_envz00_2556, obj_t BgL_locz00_2557, obj_t BgL_tiz00_2558,
		obj_t BgL_valuez00_2559)
	{
		{	/* Coerce/convert.scm 128 */
			return
				BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_2557,
				BgL_tiz00_2558, ((BgL_nodez00_bglt) BgL_valuez00_2559));
		}

	}



/* convert-error */
	obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_55, BgL_typez00_bglt BgL_toz00_56, obj_t BgL_locz00_57,
		BgL_nodez00_bglt BgL_nodez00_58)
	{
		{	/* Coerce/convert.scm 150 */
			{	/* Coerce/convert.scm 154 */
				bool_t BgL_test2044z00_2742;

				if ((((obj_t) BgL_toz00_56) == BGl_za2objza2z00zztype_cachez00))
					{	/* Coerce/convert.scm 154 */
						BgL_test2044z00_2742 = ((bool_t) 0);
					}
				else
					{	/* Coerce/convert.scm 154 */
						BgL_test2044z00_2742 =
							BGl_subzd2typezf3z21zztype_envz00(BgL_toz00_56,
							((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00));
					}
				if (BgL_test2044z00_2742)
					{	/* Coerce/convert.scm 155 */
						obj_t BgL_nodez00_1827;

						BgL_nodez00_1827 =
							BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_57,
							(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->BgL_idz00),
							BgL_nodez00_58);
						{	/* Coerce/convert.scm 156 */
							obj_t BgL_arg1633z00_1828;

							BgL_arg1633z00_1828 = BGl_currentzd2functionzd2zztools_errorz00();
							{	/* Coerce/convert.scm 108 */
								obj_t BgL_arg1540z00_2371;

								{	/* Coerce/convert.scm 108 */
									obj_t BgL_arg1542z00_2372;
									obj_t BgL_arg1543z00_2373;

									BgL_arg1542z00_2372 =
										BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
									BgL_arg1543z00_2373 =
										BGl_shapez00zztools_shapez00(((obj_t) BgL_fromz00_55));
									BgL_arg1540z00_2371 =
										BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
										(BGl_string2008z00zzcoerce_convertz00, BgL_arg1542z00_2372,
										BgL_arg1543z00_2373);
								}
								BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_57,
									BgL_arg1633z00_1828, BGl_string2009z00zzcoerce_convertz00,
									BgL_arg1540z00_2371);
							}
						}
						BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
							((BgL_nodez00_bglt) BgL_nodez00_1827));
						return
							((obj_t)
							BGl_coercez12z12zzcoerce_coercez00(
								((BgL_nodez00_bglt) BgL_nodez00_1827), BUNSPEC, BgL_fromz00_55,
								((bool_t) 0)));
					}
				else
					{	/* Coerce/convert.scm 154 */
						if (BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_toz00_56), BGl_tclassz00zzobject_classz00))
							{	/* Coerce/convert.scm 160 */
								obj_t BgL_nodez00_1831;

								BgL_nodez00_1831 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_locz00_57,
									(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->BgL_idz00),
									BgL_nodez00_58);
								{	/* Coerce/convert.scm 161 */
									obj_t BgL_arg1638z00_1832;

									BgL_arg1638z00_1832 =
										BGl_currentzd2functionzd2zztools_errorz00();
									{	/* Coerce/convert.scm 108 */
										obj_t BgL_arg1540z00_2375;

										{	/* Coerce/convert.scm 108 */
											obj_t BgL_arg1542z00_2376;
											obj_t BgL_arg1543z00_2377;

											BgL_arg1542z00_2376 =
												BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
											BgL_arg1543z00_2377 =
												BGl_shapez00zztools_shapez00(((obj_t) BgL_fromz00_55));
											BgL_arg1540z00_2375 =
												BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
												(BGl_string2008z00zzcoerce_convertz00,
												BgL_arg1542z00_2376, BgL_arg1543z00_2377);
										}
										BGl_userzd2warningzf2locationz20zztools_errorz00
											(BgL_locz00_57, BgL_arg1638z00_1832,
											BGl_string2009z00zzcoerce_convertz00,
											BgL_arg1540z00_2375);
									}
								}
								BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
									((BgL_nodez00_bglt) BgL_nodez00_1831));
								return
									((obj_t)
									BGl_coercez12z12zzcoerce_coercez00(
										((BgL_nodez00_bglt) BgL_nodez00_1831), BUNSPEC,
										BgL_fromz00_55, ((bool_t) 0)));
							}
						else
							{	/* Coerce/convert.scm 159 */
								if (CBOOL(BGl_za2warningzd2typezd2errorza2z00zzengine_paramz00))
									{	/* Coerce/convert.scm 234 */
										obj_t BgL_arg1645z00_1834;

										BgL_arg1645z00_1834 =
											BGl_currentzd2functionzd2zztools_errorz00();
										{	/* Coerce/convert.scm 97 */
											obj_t BgL_arg1529z00_2378;

											{	/* Coerce/convert.scm 97 */
												obj_t BgL_arg1532z00_2379;
												obj_t BgL_arg1533z00_2380;

												BgL_arg1532z00_2379 =
													BGl_shapez00zztools_shapez00(((obj_t) BgL_toz00_56));
												BgL_arg1533z00_2380 =
													BGl_shapez00zztools_shapez00(
													((obj_t) BgL_fromz00_55));
												BgL_arg1529z00_2378 =
													BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
													(BGl_string2008z00zzcoerce_convertz00,
													BgL_arg1532z00_2379, BgL_arg1533z00_2380);
											}
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_57, BgL_arg1645z00_1834,
												BGl_string2009z00zzcoerce_convertz00,
												BgL_arg1529z00_2378, BNIL);
										}
									}
								else
									{	/* Coerce/convert.scm 166 */
										bool_t BgL_test2048z00_2788;

										if (
											(((obj_t) BgL_toz00_56) ==
												BGl_za2intza2z00zztype_cachez00))
											{	/* Coerce/convert.scm 166 */
												BgL_test2048z00_2788 = ((bool_t) 1);
											}
										else
											{	/* Coerce/convert.scm 166 */
												if (
													(((obj_t) BgL_toz00_56) ==
														BGl_za2longza2z00zztype_cachez00))
													{	/* Coerce/convert.scm 166 */
														BgL_test2048z00_2788 = ((bool_t) 1);
													}
												else
													{	/* Coerce/convert.scm 166 */
														if (
															(((obj_t) BgL_toz00_56) ==
																BGl_za2elongza2z00zztype_cachez00))
															{	/* Coerce/convert.scm 167 */
																BgL_test2048z00_2788 = ((bool_t) 1);
															}
														else
															{	/* Coerce/convert.scm 167 */
																if (
																	(((obj_t) BgL_toz00_56) ==
																		BGl_za2llongza2z00zztype_cachez00))
																	{	/* Coerce/convert.scm 168 */
																		BgL_test2048z00_2788 = ((bool_t) 1);
																	}
																else
																	{	/* Coerce/convert.scm 168 */
																		if (
																			(((obj_t) BgL_toz00_56) ==
																				BGl_za2int8za2z00zztype_cachez00))
																			{	/* Coerce/convert.scm 169 */
																				BgL_test2048z00_2788 = ((bool_t) 1);
																			}
																		else
																			{	/* Coerce/convert.scm 169 */
																				if (
																					(((obj_t) BgL_toz00_56) ==
																						BGl_za2uint8za2z00zztype_cachez00))
																					{	/* Coerce/convert.scm 170 */
																						BgL_test2048z00_2788 = ((bool_t) 1);
																					}
																				else
																					{	/* Coerce/convert.scm 170 */
																						if (
																							(((obj_t) BgL_toz00_56) ==
																								BGl_za2int16za2z00zztype_cachez00))
																							{	/* Coerce/convert.scm 171 */
																								BgL_test2048z00_2788 =
																									((bool_t) 1);
																							}
																						else
																							{	/* Coerce/convert.scm 171 */
																								if (
																									(((obj_t) BgL_toz00_56) ==
																										BGl_za2uint16za2z00zztype_cachez00))
																									{	/* Coerce/convert.scm 172 */
																										BgL_test2048z00_2788 =
																											((bool_t) 1);
																									}
																								else
																									{	/* Coerce/convert.scm 172 */
																										if (
																											(((obj_t) BgL_toz00_56) ==
																												BGl_za2int32za2z00zztype_cachez00))
																											{	/* Coerce/convert.scm 173 */
																												BgL_test2048z00_2788 =
																													((bool_t) 1);
																											}
																										else
																											{	/* Coerce/convert.scm 173 */
																												if (
																													(((obj_t)
																															BgL_toz00_56) ==
																														BGl_za2uint32za2z00zztype_cachez00))
																													{	/* Coerce/convert.scm 174 */
																														BgL_test2048z00_2788
																															= ((bool_t) 1);
																													}
																												else
																													{	/* Coerce/convert.scm 174 */
																														if (
																															(((obj_t)
																																	BgL_toz00_56)
																																==
																																BGl_za2int64za2z00zztype_cachez00))
																															{	/* Coerce/convert.scm 175 */
																																BgL_test2048z00_2788
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Coerce/convert.scm 175 */
																																BgL_test2048z00_2788
																																	=
																																	(((obj_t)
																																		BgL_toz00_56)
																																	==
																																	BGl_za2uint64za2z00zztype_cachez00);
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
										if (BgL_test2048z00_2788)
											{	/* Coerce/convert.scm 177 */
												obj_t BgL_nodez00_1847;

												BgL_nodez00_1847 =
													BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
													(BgL_locz00_57,
													(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
														BgL_idz00), BgL_nodez00_58);
												{	/* Coerce/convert.scm 178 */
													obj_t BgL_arg1659z00_1848;

													BgL_arg1659z00_1848 =
														BGl_currentzd2functionzd2zztools_errorz00();
													{	/* Coerce/convert.scm 108 */
														obj_t BgL_arg1540z00_2383;

														{	/* Coerce/convert.scm 108 */
															obj_t BgL_arg1542z00_2384;
															obj_t BgL_arg1543z00_2385;

															BgL_arg1542z00_2384 =
																BGl_shapez00zztools_shapez00(
																((obj_t) BgL_toz00_56));
															BgL_arg1543z00_2385 =
																BGl_shapez00zztools_shapez00(
																((obj_t) BgL_fromz00_55));
															BgL_arg1540z00_2383 =
																BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																(BGl_string2008z00zzcoerce_convertz00,
																BgL_arg1542z00_2384, BgL_arg1543z00_2385);
														}
														BGl_userzd2warningzf2locationz20zztools_errorz00
															(BgL_locz00_57, BgL_arg1659z00_1848,
															BGl_string2009z00zzcoerce_convertz00,
															BgL_arg1540z00_2383);
													}
												}
												BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
													((BgL_nodez00_bglt) BgL_nodez00_1847));
												{	/* Coerce/convert.scm 180 */
													BgL_sequencez00_bglt BgL_new1114z00_1849;

													{	/* Coerce/convert.scm 180 */
														BgL_sequencez00_bglt BgL_new1113z00_1857;

														BgL_new1113z00_1857 =
															((BgL_sequencez00_bglt)
															BOBJECT(GC_MALLOC(sizeof(struct
																		BgL_sequencez00_bgl))));
														{	/* Coerce/convert.scm 180 */
															long BgL_arg1673z00_1858;

															BgL_arg1673z00_1858 =
																BGL_CLASS_INDEX(BGl_sequencez00zzast_nodez00);
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1113z00_1857),
																BgL_arg1673z00_1858);
														}
														{	/* Coerce/convert.scm 180 */
															BgL_objectz00_bglt BgL_tmpz00_2839;

															BgL_tmpz00_2839 =
																((BgL_objectz00_bglt) BgL_new1113z00_1857);
															BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2839, BFALSE);
														}
														((BgL_objectz00_bglt) BgL_new1113z00_1857);
														BgL_new1114z00_1849 = BgL_new1113z00_1857;
													}
													((((BgL_nodez00_bglt) COBJECT(
																	((BgL_nodez00_bglt) BgL_new1114z00_1849)))->
															BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
													((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																		BgL_new1114z00_1849)))->BgL_typez00) =
														((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1114z00_1849)))->
															BgL_sidezd2effectzd2) =
														((obj_t) BUNSPEC), BUNSPEC);
													((((BgL_nodezf2effectzf2_bglt)
																COBJECT(((BgL_nodezf2effectzf2_bglt)
																		BgL_new1114z00_1849)))->BgL_keyz00) =
														((obj_t) BINT(((long) -1))), BUNSPEC);
													{
														obj_t BgL_auxz00_2852;

														{	/* Coerce/convert.scm 183 */
															BgL_nodez00_bglt BgL_arg1662z00_1850;
															BgL_literalz00_bglt BgL_arg1663z00_1851;

															BgL_arg1662z00_1850 =
																BGl_coercez12z12zzcoerce_coercez00(
																((BgL_nodez00_bglt) BgL_nodez00_1847), BUNSPEC,
																BgL_fromz00_55, ((bool_t) 0));
															{	/* Coerce/convert.scm 184 */
																BgL_literalz00_bglt BgL_new1117z00_1854;

																{	/* Coerce/convert.scm 184 */
																	BgL_literalz00_bglt BgL_new1116z00_1855;

																	BgL_new1116z00_1855 =
																		((BgL_literalz00_bglt)
																		BOBJECT(GC_MALLOC(sizeof(struct
																					BgL_literalz00_bgl))));
																	{	/* Coerce/convert.scm 184 */
																		long BgL_arg1672z00_1856;

																		{	/* Coerce/convert.scm 184 */
																			obj_t BgL_classz00_2390;

																			BgL_classz00_2390 =
																				BGl_literalz00zzast_nodez00;
																			BgL_arg1672z00_1856 =
																				BGL_CLASS_INDEX(BgL_classz00_2390);
																		}
																		BGL_OBJECT_CLASS_NUM_SET(
																			((BgL_objectz00_bglt)
																				BgL_new1116z00_1855),
																			BgL_arg1672z00_1856);
																	}
																	{	/* Coerce/convert.scm 184 */
																		BgL_objectz00_bglt BgL_tmpz00_2859;

																		BgL_tmpz00_2859 =
																			((BgL_objectz00_bglt)
																			BgL_new1116z00_1855);
																		BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2859,
																			BFALSE);
																	}
																	((BgL_objectz00_bglt) BgL_new1116z00_1855);
																	BgL_new1117z00_1854 = BgL_new1116z00_1855;
																}
																((((BgL_nodez00_bglt) COBJECT(
																				((BgL_nodez00_bglt)
																					BgL_new1117z00_1854)))->BgL_locz00) =
																	((obj_t) BFALSE), BUNSPEC);
																((((BgL_nodez00_bglt)
																			COBJECT(((BgL_nodez00_bglt)
																					BgL_new1117z00_1854)))->BgL_typez00) =
																	((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
																((((BgL_atomz00_bglt)
																			COBJECT(((BgL_atomz00_bglt)
																					BgL_new1117z00_1854)))->
																		BgL_valuez00) =
																	((obj_t) BINT(((long) 0))), BUNSPEC);
																BgL_arg1663z00_1851 = BgL_new1117z00_1854;
															}
															{	/* Coerce/convert.scm 182 */
																obj_t BgL_list1664z00_1852;

																{	/* Coerce/convert.scm 182 */
																	obj_t BgL_arg1666z00_1853;

																	BgL_arg1666z00_1853 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg1663z00_1851), BNIL);
																	BgL_list1664z00_1852 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg1662z00_1850),
																		BgL_arg1666z00_1853);
																}
																BgL_auxz00_2852 = BgL_list1664z00_1852;
														}}
														((((BgL_sequencez00_bglt)
																	COBJECT(BgL_new1114z00_1849))->BgL_nodesz00) =
															((obj_t) BgL_auxz00_2852), BUNSPEC);
													}
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1114z00_1849))->BgL_unsafez00) =
														((bool_t) ((bool_t) 0)), BUNSPEC);
													((((BgL_sequencez00_bglt)
																COBJECT(BgL_new1114z00_1849))->BgL_metaz00) =
														((obj_t) BNIL), BUNSPEC);
													return ((obj_t) BgL_new1114z00_1849);
												}
											}
										else
											{	/* Coerce/convert.scm 166 */
												if (
													(((obj_t) BgL_toz00_56) ==
														BGl_za2boolza2z00zztype_cachez00))
													{	/* Coerce/convert.scm 186 */
														obj_t BgL_nodez00_1861;

														BgL_nodez00_1861 =
															BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
															(BgL_locz00_57,
															(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
																BgL_idz00), BgL_nodez00_58);
														{	/* Coerce/convert.scm 187 */
															obj_t BgL_arg1679z00_1862;

															BgL_arg1679z00_1862 =
																BGl_currentzd2functionzd2zztools_errorz00();
															{	/* Coerce/convert.scm 108 */
																obj_t BgL_arg1540z00_2396;

																{	/* Coerce/convert.scm 108 */
																	obj_t BgL_arg1542z00_2397;
																	obj_t BgL_arg1543z00_2398;

																	BgL_arg1542z00_2397 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_56));
																	BgL_arg1543z00_2398 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_55));
																	BgL_arg1540z00_2396 =
																		BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																		(BGl_string2008z00zzcoerce_convertz00,
																		BgL_arg1542z00_2397, BgL_arg1543z00_2398);
																}
																BGl_userzd2warningzf2locationz20zztools_errorz00
																	(BgL_locz00_57, BgL_arg1679z00_1862,
																	BGl_string2009z00zzcoerce_convertz00,
																	BgL_arg1540z00_2396);
															}
														}
														BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
															((BgL_nodez00_bglt) BgL_nodez00_1861));
														{	/* Coerce/convert.scm 189 */
															BgL_sequencez00_bglt BgL_new1119z00_1863;

															{	/* Coerce/convert.scm 189 */
																BgL_sequencez00_bglt BgL_new1118z00_1871;

																BgL_new1118z00_1871 =
																	((BgL_sequencez00_bglt)
																	BOBJECT(GC_MALLOC(sizeof(struct
																				BgL_sequencez00_bgl))));
																{	/* Coerce/convert.scm 189 */
																	long BgL_arg1695z00_1872;

																	BgL_arg1695z00_1872 =
																		BGL_CLASS_INDEX
																		(BGl_sequencez00zzast_nodez00);
																	BGL_OBJECT_CLASS_NUM_SET(((BgL_objectz00_bglt)
																			BgL_new1118z00_1871),
																		BgL_arg1695z00_1872);
																}
																{	/* Coerce/convert.scm 189 */
																	BgL_objectz00_bglt BgL_tmpz00_2896;

																	BgL_tmpz00_2896 =
																		((BgL_objectz00_bglt) BgL_new1118z00_1871);
																	BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2896,
																		BFALSE);
																}
																((BgL_objectz00_bglt) BgL_new1118z00_1871);
																BgL_new1119z00_1863 = BgL_new1118z00_1871;
															}
															((((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				BgL_new1119z00_1863)))->BgL_locz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																				BgL_new1119z00_1863)))->BgL_typez00) =
																((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1119z00_1863)))->
																	BgL_sidezd2effectzd2) =
																((obj_t) BUNSPEC), BUNSPEC);
															((((BgL_nodezf2effectzf2_bglt)
																		COBJECT(((BgL_nodezf2effectzf2_bglt)
																				BgL_new1119z00_1863)))->BgL_keyz00) =
																((obj_t) BINT(((long) -1))), BUNSPEC);
															{
																obj_t BgL_auxz00_2909;

																{	/* Coerce/convert.scm 192 */
																	BgL_nodez00_bglt BgL_arg1682z00_1864;
																	BgL_literalz00_bglt BgL_arg1685z00_1865;

																	BgL_arg1682z00_1864 =
																		BGl_coercez12z12zzcoerce_coercez00(
																		((BgL_nodez00_bglt) BgL_nodez00_1861),
																		BUNSPEC, BgL_fromz00_55, ((bool_t) 0));
																	{	/* Coerce/convert.scm 193 */
																		BgL_literalz00_bglt BgL_new1122z00_1868;

																		{	/* Coerce/convert.scm 193 */
																			BgL_literalz00_bglt BgL_new1120z00_1869;

																			BgL_new1120z00_1869 =
																				((BgL_literalz00_bglt)
																				BOBJECT(GC_MALLOC(sizeof(struct
																							BgL_literalz00_bgl))));
																			{	/* Coerce/convert.scm 193 */
																				long BgL_arg1691z00_1870;

																				{	/* Coerce/convert.scm 193 */
																					obj_t BgL_classz00_2403;

																					BgL_classz00_2403 =
																						BGl_literalz00zzast_nodez00;
																					BgL_arg1691z00_1870 =
																						BGL_CLASS_INDEX(BgL_classz00_2403);
																				}
																				BGL_OBJECT_CLASS_NUM_SET(
																					((BgL_objectz00_bglt)
																						BgL_new1120z00_1869),
																					BgL_arg1691z00_1870);
																			}
																			{	/* Coerce/convert.scm 193 */
																				BgL_objectz00_bglt BgL_tmpz00_2916;

																				BgL_tmpz00_2916 =
																					((BgL_objectz00_bglt)
																					BgL_new1120z00_1869);
																				BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2916,
																					BFALSE);
																			}
																			((BgL_objectz00_bglt)
																				BgL_new1120z00_1869);
																			BgL_new1122z00_1868 = BgL_new1120z00_1869;
																		}
																		((((BgL_nodez00_bglt) COBJECT(
																						((BgL_nodez00_bglt)
																							BgL_new1122z00_1868)))->
																				BgL_locz00) =
																			((obj_t) BFALSE), BUNSPEC);
																		((((BgL_nodez00_bglt)
																					COBJECT(((BgL_nodez00_bglt)
																							BgL_new1122z00_1868)))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) BgL_toz00_56),
																			BUNSPEC);
																		((((BgL_atomz00_bglt)
																					COBJECT(((BgL_atomz00_bglt)
																							BgL_new1122z00_1868)))->
																				BgL_valuez00) =
																			((obj_t) BINT(((long) 0))), BUNSPEC);
																		BgL_arg1685z00_1865 = BgL_new1122z00_1868;
																	}
																	{	/* Coerce/convert.scm 191 */
																		obj_t BgL_list1686z00_1866;

																		{	/* Coerce/convert.scm 191 */
																			obj_t BgL_arg1690z00_1867;

																			BgL_arg1690z00_1867 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_arg1685z00_1865), BNIL);
																			BgL_list1686z00_1866 =
																				MAKE_YOUNG_PAIR(
																				((obj_t) BgL_arg1682z00_1864),
																				BgL_arg1690z00_1867);
																		}
																		BgL_auxz00_2909 = BgL_list1686z00_1866;
																}}
																((((BgL_sequencez00_bglt)
																			COBJECT(BgL_new1119z00_1863))->
																		BgL_nodesz00) =
																	((obj_t) BgL_auxz00_2909), BUNSPEC);
															}
															((((BgL_sequencez00_bglt)
																		COBJECT(BgL_new1119z00_1863))->
																	BgL_unsafez00) =
																((bool_t) ((bool_t) 0)), BUNSPEC);
															((((BgL_sequencez00_bglt)
																		COBJECT(BgL_new1119z00_1863))->
																	BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
															return ((obj_t) BgL_new1119z00_1863);
														}
													}
												else
													{	/* Coerce/convert.scm 185 */
														if (
															(((obj_t) BgL_toz00_56) ==
																BGl_za2realza2z00zztype_cachez00))
															{	/* Coerce/convert.scm 195 */
																obj_t BgL_nodez00_1875;

																BgL_nodez00_1875 =
																	BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																	(BgL_locz00_57,
																	(((BgL_typez00_bglt) COBJECT(BgL_toz00_56))->
																		BgL_idz00), BgL_nodez00_58);
																{	/* Coerce/convert.scm 196 */
																	obj_t BgL_arg1699z00_1876;

																	BgL_arg1699z00_1876 =
																		BGl_currentzd2functionzd2zztools_errorz00();
																	{	/* Coerce/convert.scm 108 */
																		obj_t BgL_arg1540z00_2409;

																		{	/* Coerce/convert.scm 108 */
																			obj_t BgL_arg1542z00_2410;
																			obj_t BgL_arg1543z00_2411;

																			BgL_arg1542z00_2410 =
																				BGl_shapez00zztools_shapez00(
																				((obj_t) BgL_toz00_56));
																			BgL_arg1543z00_2411 =
																				BGl_shapez00zztools_shapez00(
																				((obj_t) BgL_fromz00_55));
																			BgL_arg1540z00_2409 =
																				BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																				(BGl_string2008z00zzcoerce_convertz00,
																				BgL_arg1542z00_2410,
																				BgL_arg1543z00_2411);
																		}
																		BGl_userzd2warningzf2locationz20zztools_errorz00
																			(BgL_locz00_57, BgL_arg1699z00_1876,
																			BGl_string2009z00zzcoerce_convertz00,
																			BgL_arg1540z00_2409);
																	}
																}
																BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																	((BgL_nodez00_bglt) BgL_nodez00_1875));
																{	/* Coerce/convert.scm 198 */
																	BgL_sequencez00_bglt BgL_new1124z00_1877;

																	{	/* Coerce/convert.scm 198 */
																		BgL_sequencez00_bglt BgL_new1123z00_1885;

																		BgL_new1123z00_1885 =
																			((BgL_sequencez00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_sequencez00_bgl))));
																		{	/* Coerce/convert.scm 198 */
																			long BgL_arg1718z00_1886;

																			BgL_arg1718z00_1886 =
																				BGL_CLASS_INDEX
																				(BGl_sequencez00zzast_nodez00);
																			BGL_OBJECT_CLASS_NUM_SET((
																					(BgL_objectz00_bglt)
																					BgL_new1123z00_1885),
																				BgL_arg1718z00_1886);
																		}
																		{	/* Coerce/convert.scm 198 */
																			BgL_objectz00_bglt BgL_tmpz00_2953;

																			BgL_tmpz00_2953 =
																				((BgL_objectz00_bglt)
																				BgL_new1123z00_1885);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2953,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1123z00_1885);
																		BgL_new1124z00_1877 = BgL_new1123z00_1885;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1124z00_1877)))->
																			BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1124z00_1877)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) BgL_toz00_56), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1124z00_1877)))->
																			BgL_sidezd2effectzd2) =
																		((obj_t) BUNSPEC), BUNSPEC);
																	((((BgL_nodezf2effectzf2_bglt)
																				COBJECT(((BgL_nodezf2effectzf2_bglt)
																						BgL_new1124z00_1877)))->
																			BgL_keyz00) =
																		((obj_t) BINT(((long) -1))), BUNSPEC);
																	{
																		obj_t BgL_auxz00_2966;

																		{	/* Coerce/convert.scm 201 */
																			BgL_nodez00_bglt BgL_arg1702z00_1878;
																			BgL_literalz00_bglt BgL_arg1704z00_1879;

																			BgL_arg1702z00_1878 =
																				BGl_coercez12z12zzcoerce_coercez00(
																				((BgL_nodez00_bglt) BgL_nodez00_1875),
																				BUNSPEC, BgL_fromz00_55, ((bool_t) 0));
																			{	/* Coerce/convert.scm 202 */
																				BgL_literalz00_bglt BgL_new1128z00_1882;

																				{	/* Coerce/convert.scm 202 */
																					BgL_literalz00_bglt
																						BgL_new1125z00_1883;
																					BgL_new1125z00_1883 =
																						((BgL_literalz00_bglt)
																						BOBJECT(GC_MALLOC(sizeof(struct
																									BgL_literalz00_bgl))));
																					{	/* Coerce/convert.scm 202 */
																						long BgL_arg1717z00_1884;

																						{	/* Coerce/convert.scm 202 */
																							obj_t BgL_classz00_2416;

																							BgL_classz00_2416 =
																								BGl_literalz00zzast_nodez00;
																							BgL_arg1717z00_1884 =
																								BGL_CLASS_INDEX
																								(BgL_classz00_2416);
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1125z00_1883),
																							BgL_arg1717z00_1884);
																					}
																					{	/* Coerce/convert.scm 202 */
																						BgL_objectz00_bglt BgL_tmpz00_2973;

																						BgL_tmpz00_2973 =
																							((BgL_objectz00_bglt)
																							BgL_new1125z00_1883);
																						BGL_OBJECT_WIDENING_SET
																							(BgL_tmpz00_2973, BFALSE);
																					}
																					((BgL_objectz00_bglt)
																						BgL_new1125z00_1883);
																					BgL_new1128z00_1882 =
																						BgL_new1125z00_1883;
																				}
																				((((BgL_nodez00_bglt) COBJECT(
																								((BgL_nodez00_bglt)
																									BgL_new1128z00_1882)))->
																						BgL_locz00) =
																					((obj_t) BFALSE), BUNSPEC);
																				((((BgL_nodez00_bglt)
																							COBJECT(((BgL_nodez00_bglt)
																									BgL_new1128z00_1882)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_toz00_56),
																					BUNSPEC);
																				((((BgL_atomz00_bglt)
																							COBJECT(((BgL_atomz00_bglt)
																									BgL_new1128z00_1882)))->
																						BgL_valuez00) =
																					((obj_t)
																						BGL_REAL_CNST
																						(BGl_real2010z00zzcoerce_convertz00)),
																					BUNSPEC);
																				BgL_arg1704z00_1879 =
																					BgL_new1128z00_1882;
																			}
																			{	/* Coerce/convert.scm 200 */
																				obj_t BgL_list1705z00_1880;

																				{	/* Coerce/convert.scm 200 */
																					obj_t BgL_arg1710z00_1881;

																					BgL_arg1710z00_1881 =
																						MAKE_YOUNG_PAIR(
																						((obj_t) BgL_arg1704z00_1879),
																						BNIL);
																					BgL_list1705z00_1880 =
																						MAKE_YOUNG_PAIR(((obj_t)
																							BgL_arg1702z00_1878),
																						BgL_arg1710z00_1881);
																				}
																				BgL_auxz00_2966 = BgL_list1705z00_1880;
																		}}
																		((((BgL_sequencez00_bglt)
																					COBJECT(BgL_new1124z00_1877))->
																				BgL_nodesz00) =
																			((obj_t) BgL_auxz00_2966), BUNSPEC);
																	}
																	((((BgL_sequencez00_bglt)
																				COBJECT(BgL_new1124z00_1877))->
																			BgL_unsafez00) =
																		((bool_t) ((bool_t) 0)), BUNSPEC);
																	((((BgL_sequencez00_bglt)
																				COBJECT(BgL_new1124z00_1877))->
																			BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																	return ((obj_t) BgL_new1124z00_1877);
																}
															}
														else
															{	/* Coerce/convert.scm 194 */
																if (
																	(((obj_t) BgL_toz00_56) ==
																		BGl_za2charza2z00zztype_cachez00))
																	{	/* Coerce/convert.scm 204 */
																		obj_t BgL_nodez00_1889;

																		BgL_nodez00_1889 =
																			BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																			(BgL_locz00_57,
																			(((BgL_typez00_bglt)
																					COBJECT(BgL_toz00_56))->BgL_idz00),
																			BgL_nodez00_58);
																		{	/* Coerce/convert.scm 205 */
																			obj_t BgL_arg1722z00_1890;

																			BgL_arg1722z00_1890 =
																				BGl_currentzd2functionzd2zztools_errorz00
																				();
																			{	/* Coerce/convert.scm 108 */
																				obj_t BgL_arg1540z00_2422;

																				{	/* Coerce/convert.scm 108 */
																					obj_t BgL_arg1542z00_2423;
																					obj_t BgL_arg1543z00_2424;

																					BgL_arg1542z00_2423 =
																						BGl_shapez00zztools_shapez00(
																						((obj_t) BgL_toz00_56));
																					BgL_arg1543z00_2424 =
																						BGl_shapez00zztools_shapez00(
																						((obj_t) BgL_fromz00_55));
																					BgL_arg1540z00_2422 =
																						BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																						(BGl_string2008z00zzcoerce_convertz00,
																						BgL_arg1542z00_2423,
																						BgL_arg1543z00_2424);
																				}
																				BGl_userzd2warningzf2locationz20zztools_errorz00
																					(BgL_locz00_57, BgL_arg1722z00_1890,
																					BGl_string2009z00zzcoerce_convertz00,
																					BgL_arg1540z00_2422);
																			}
																		}
																		BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																			((BgL_nodez00_bglt) BgL_nodez00_1889));
																		{	/* Coerce/convert.scm 207 */
																			BgL_sequencez00_bglt BgL_new1130z00_1891;

																			{	/* Coerce/convert.scm 207 */
																				BgL_sequencez00_bglt
																					BgL_new1129z00_1899;
																				BgL_new1129z00_1899 =
																					((BgL_sequencez00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_sequencez00_bgl))));
																				{	/* Coerce/convert.scm 207 */
																					long BgL_arg1734z00_1900;

																					BgL_arg1734z00_1900 =
																						BGL_CLASS_INDEX
																						(BGl_sequencez00zzast_nodez00);
																					BGL_OBJECT_CLASS_NUM_SET((
																							(BgL_objectz00_bglt)
																							BgL_new1129z00_1899),
																						BgL_arg1734z00_1900);
																				}
																				{	/* Coerce/convert.scm 207 */
																					BgL_objectz00_bglt BgL_tmpz00_3009;

																					BgL_tmpz00_3009 =
																						((BgL_objectz00_bglt)
																						BgL_new1129z00_1899);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_tmpz00_3009, BFALSE);
																				}
																				((BgL_objectz00_bglt)
																					BgL_new1129z00_1899);
																				BgL_new1130z00_1891 =
																					BgL_new1129z00_1899;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1130z00_1891)))->
																					BgL_locz00) =
																				((obj_t) BFALSE), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1130z00_1891)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) BgL_toz00_56),
																				BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1130z00_1891)))->
																					BgL_sidezd2effectzd2) =
																				((obj_t) BUNSPEC), BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1130z00_1891)))->
																					BgL_keyz00) =
																				((obj_t) BINT(((long) -1))), BUNSPEC);
																			{
																				obj_t BgL_auxz00_3022;

																				{	/* Coerce/convert.scm 210 */
																					BgL_nodez00_bglt BgL_arg1724z00_1892;
																					BgL_literalz00_bglt
																						BgL_arg1725z00_1893;
																					BgL_arg1724z00_1892 =
																						BGl_coercez12z12zzcoerce_coercez00((
																							(BgL_nodez00_bglt)
																							BgL_nodez00_1889), BUNSPEC,
																						BgL_fromz00_55, ((bool_t) 0));
																					{	/* Coerce/convert.scm 211 */
																						BgL_literalz00_bglt
																							BgL_new1133z00_1896;
																						{	/* Coerce/convert.scm 211 */
																							BgL_literalz00_bglt
																								BgL_new1131z00_1897;
																							BgL_new1131z00_1897 =
																								((BgL_literalz00_bglt)
																								BOBJECT(GC_MALLOC(sizeof(struct
																											BgL_literalz00_bgl))));
																							{	/* Coerce/convert.scm 211 */
																								long BgL_arg1733z00_1898;

																								{	/* Coerce/convert.scm 211 */
																									obj_t BgL_classz00_2429;

																									BgL_classz00_2429 =
																										BGl_literalz00zzast_nodez00;
																									BgL_arg1733z00_1898 =
																										BGL_CLASS_INDEX
																										(BgL_classz00_2429);
																								}
																								BGL_OBJECT_CLASS_NUM_SET(
																									((BgL_objectz00_bglt)
																										BgL_new1131z00_1897),
																									BgL_arg1733z00_1898);
																							}
																							{	/* Coerce/convert.scm 211 */
																								BgL_objectz00_bglt
																									BgL_tmpz00_3029;
																								BgL_tmpz00_3029 =
																									((BgL_objectz00_bglt)
																									BgL_new1131z00_1897);
																								BGL_OBJECT_WIDENING_SET
																									(BgL_tmpz00_3029, BFALSE);
																							}
																							((BgL_objectz00_bglt)
																								BgL_new1131z00_1897);
																							BgL_new1133z00_1896 =
																								BgL_new1131z00_1897;
																						}
																						((((BgL_nodez00_bglt) COBJECT(
																										((BgL_nodez00_bglt)
																											BgL_new1133z00_1896)))->
																								BgL_locz00) =
																							((obj_t) BFALSE), BUNSPEC);
																						((((BgL_nodez00_bglt)
																									COBJECT(((BgL_nodez00_bglt)
																											BgL_new1133z00_1896)))->
																								BgL_typez00) =
																							((BgL_typez00_bglt) BgL_toz00_56),
																							BUNSPEC);
																						((((BgL_atomz00_bglt)
																									COBJECT(((BgL_atomz00_bglt)
																											BgL_new1133z00_1896)))->
																								BgL_valuez00) =
																							((obj_t) BCHAR(((unsigned char)
																										'\000'))), BUNSPEC);
																						BgL_arg1725z00_1893 =
																							BgL_new1133z00_1896;
																					}
																					{	/* Coerce/convert.scm 209 */
																						obj_t BgL_list1726z00_1894;

																						{	/* Coerce/convert.scm 209 */
																							obj_t BgL_arg1732z00_1895;

																							BgL_arg1732z00_1895 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg1725z00_1893),
																								BNIL);
																							BgL_list1726z00_1894 =
																								MAKE_YOUNG_PAIR(((obj_t)
																									BgL_arg1724z00_1892),
																								BgL_arg1732z00_1895);
																						}
																						BgL_auxz00_3022 =
																							BgL_list1726z00_1894;
																				}}
																				((((BgL_sequencez00_bglt)
																							COBJECT(BgL_new1130z00_1891))->
																						BgL_nodesz00) =
																					((obj_t) BgL_auxz00_3022), BUNSPEC);
																			}
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1130z00_1891))->
																					BgL_unsafez00) =
																				((bool_t) ((bool_t) 0)), BUNSPEC);
																			((((BgL_sequencez00_bglt)
																						COBJECT(BgL_new1130z00_1891))->
																					BgL_metaz00) =
																				((obj_t) BNIL), BUNSPEC);
																			return ((obj_t) BgL_new1130z00_1891);
																		}
																	}
																else
																	{	/* Coerce/convert.scm 203 */
																		if (
																			(((obj_t) BgL_toz00_56) ==
																				BGl_za2scharza2z00zztype_cachez00))
																			{	/* Coerce/convert.scm 213 */
																				obj_t BgL_nodez00_1903;

																				BgL_nodez00_1903 =
																					BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																					(BgL_locz00_57,
																					(((BgL_typez00_bglt)
																							COBJECT(BgL_toz00_56))->
																						BgL_idz00), BgL_nodez00_58);
																				{	/* Coerce/convert.scm 214 */
																					obj_t BgL_arg1737z00_1904;

																					BgL_arg1737z00_1904 =
																						BGl_currentzd2functionzd2zztools_errorz00
																						();
																					{	/* Coerce/convert.scm 108 */
																						obj_t BgL_arg1540z00_2435;

																						{	/* Coerce/convert.scm 108 */
																							obj_t BgL_arg1542z00_2436;
																							obj_t BgL_arg1543z00_2437;

																							BgL_arg1542z00_2436 =
																								BGl_shapez00zztools_shapez00(
																								((obj_t) BgL_toz00_56));
																							BgL_arg1543z00_2437 =
																								BGl_shapez00zztools_shapez00(
																								((obj_t) BgL_fromz00_55));
																							BgL_arg1540z00_2435 =
																								BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																								(BGl_string2008z00zzcoerce_convertz00,
																								BgL_arg1542z00_2436,
																								BgL_arg1543z00_2437);
																						}
																						BGl_userzd2warningzf2locationz20zztools_errorz00
																							(BgL_locz00_57,
																							BgL_arg1737z00_1904,
																							BGl_string2009z00zzcoerce_convertz00,
																							BgL_arg1540z00_2435);
																					}
																				}
																				BGl_lvtypezd2nodez12zc0zzast_lvtypez00(
																					((BgL_nodez00_bglt)
																						BgL_nodez00_1903));
																				{	/* Coerce/convert.scm 216 */
																					BgL_sequencez00_bglt
																						BgL_new1135z00_1905;
																					{	/* Coerce/convert.scm 216 */
																						BgL_sequencez00_bglt
																							BgL_new1134z00_1913;
																						BgL_new1134z00_1913 =
																							((BgL_sequencez00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_sequencez00_bgl))));
																						{	/* Coerce/convert.scm 216 */
																							long BgL_arg1747z00_1914;

																							BgL_arg1747z00_1914 =
																								BGL_CLASS_INDEX
																								(BGl_sequencez00zzast_nodez00);
																							BGL_OBJECT_CLASS_NUM_SET((
																									(BgL_objectz00_bglt)
																									BgL_new1134z00_1913),
																								BgL_arg1747z00_1914);
																						}
																						{	/* Coerce/convert.scm 216 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_3066;
																							BgL_tmpz00_3066 =
																								((BgL_objectz00_bglt)
																								BgL_new1134z00_1913);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_tmpz00_3066, BFALSE);
																						}
																						((BgL_objectz00_bglt)
																							BgL_new1134z00_1913);
																						BgL_new1135z00_1905 =
																							BgL_new1134z00_1913;
																					}
																					((((BgL_nodez00_bglt) COBJECT(
																									((BgL_nodez00_bglt)
																										BgL_new1135z00_1905)))->
																							BgL_locz00) =
																						((obj_t) BFALSE), BUNSPEC);
																					((((BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_new1135z00_1905)))->
																							BgL_typez00) =
																						((BgL_typez00_bglt) (
																								(BgL_typez00_bglt)
																								BGl_za2charza2z00zztype_cachez00)),
																						BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1135z00_1905)))->
																							BgL_sidezd2effectzd2) =
																						((obj_t) BUNSPEC), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1135z00_1905)))->
																							BgL_keyz00) =
																						((obj_t) BINT(((long) -1))),
																						BUNSPEC);
																					{
																						obj_t BgL_auxz00_3080;

																						{	/* Coerce/convert.scm 219 */
																							BgL_nodez00_bglt
																								BgL_arg1739z00_1906;
																							BgL_literalz00_bglt
																								BgL_arg1740z00_1907;
																							BgL_arg1739z00_1906 =
																								BGl_coercez12z12zzcoerce_coercez00
																								(((BgL_nodez00_bglt)
																									BgL_nodez00_1903), BUNSPEC,
																								BgL_fromz00_55, ((bool_t) 0));
																							{	/* Coerce/convert.scm 220 */
																								BgL_literalz00_bglt
																									BgL_new1137z00_1910;
																								{	/* Coerce/convert.scm 220 */
																									BgL_literalz00_bglt
																										BgL_new1136z00_1911;
																									BgL_new1136z00_1911 =
																										((BgL_literalz00_bglt)
																										BOBJECT(GC_MALLOC(sizeof
																												(struct
																													BgL_literalz00_bgl))));
																									{	/* Coerce/convert.scm 220 */
																										long BgL_arg1746z00_1912;

																										{	/* Coerce/convert.scm 220 */
																											obj_t BgL_classz00_2442;

																											BgL_classz00_2442 =
																												BGl_literalz00zzast_nodez00;
																											BgL_arg1746z00_1912 =
																												BGL_CLASS_INDEX
																												(BgL_classz00_2442);
																										}
																										BGL_OBJECT_CLASS_NUM_SET(
																											((BgL_objectz00_bglt)
																												BgL_new1136z00_1911),
																											BgL_arg1746z00_1912);
																									}
																									{	/* Coerce/convert.scm 220 */
																										BgL_objectz00_bglt
																											BgL_tmpz00_3087;
																										BgL_tmpz00_3087 =
																											((BgL_objectz00_bglt)
																											BgL_new1136z00_1911);
																										BGL_OBJECT_WIDENING_SET
																											(BgL_tmpz00_3087, BFALSE);
																									}
																									((BgL_objectz00_bglt)
																										BgL_new1136z00_1911);
																									BgL_new1137z00_1910 =
																										BgL_new1136z00_1911;
																								}
																								((((BgL_nodez00_bglt) COBJECT(
																												((BgL_nodez00_bglt)
																													BgL_new1137z00_1910)))->
																										BgL_locz00) =
																									((obj_t) BFALSE), BUNSPEC);
																								((((BgL_nodez00_bglt)
																											COBJECT((
																													(BgL_nodez00_bglt)
																													BgL_new1137z00_1910)))->
																										BgL_typez00) =
																									((BgL_typez00_bglt) (
																											(BgL_typez00_bglt)
																											BGl_za2charza2z00zztype_cachez00)),
																									BUNSPEC);
																								((((BgL_atomz00_bglt)
																											COBJECT((
																													(BgL_atomz00_bglt)
																													BgL_new1137z00_1910)))->
																										BgL_valuez00) =
																									((obj_t) BCHAR(((unsigned
																													char) '\000'))),
																									BUNSPEC);
																								BgL_arg1740z00_1907 =
																									BgL_new1137z00_1910;
																							}
																							{	/* Coerce/convert.scm 218 */
																								obj_t BgL_list1741z00_1908;

																								{	/* Coerce/convert.scm 218 */
																									obj_t BgL_arg1744z00_1909;

																									BgL_arg1744z00_1909 =
																										MAKE_YOUNG_PAIR(
																										((obj_t)
																											BgL_arg1740z00_1907),
																										BNIL);
																									BgL_list1741z00_1908 =
																										MAKE_YOUNG_PAIR(((obj_t)
																											BgL_arg1739z00_1906),
																										BgL_arg1744z00_1909);
																								}
																								BgL_auxz00_3080 =
																									BgL_list1741z00_1908;
																						}}
																						((((BgL_sequencez00_bglt)
																									COBJECT
																									(BgL_new1135z00_1905))->
																								BgL_nodesz00) =
																							((obj_t) BgL_auxz00_3080),
																							BUNSPEC);
																					}
																					((((BgL_sequencez00_bglt)
																								COBJECT(BgL_new1135z00_1905))->
																							BgL_unsafez00) =
																						((bool_t) ((bool_t) 0)), BUNSPEC);
																					((((BgL_sequencez00_bglt)
																								COBJECT(BgL_new1135z00_1905))->
																							BgL_metaz00) =
																						((obj_t) BNIL), BUNSPEC);
																					return ((obj_t) BgL_new1135z00_1905);
																				}
																			}
																		else
																			{	/* Coerce/convert.scm 212 */
																				if (
																					(((obj_t) BgL_toz00_56) ==
																						BGl_za2stringza2z00zztype_cachez00))
																					{	/* Coerce/convert.scm 222 */
																						obj_t BgL_nodez00_1917;

																						BgL_nodez00_1917 =
																							BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																							(BgL_locz00_57,
																							(((BgL_typez00_bglt)
																									COBJECT(BgL_toz00_56))->
																								BgL_idz00), BgL_nodez00_58);
																						{	/* Coerce/convert.scm 223 */
																							obj_t BgL_arg1753z00_1918;

																							BgL_arg1753z00_1918 =
																								BGl_currentzd2functionzd2zztools_errorz00
																								();
																							{	/* Coerce/convert.scm 108 */
																								obj_t BgL_arg1540z00_2448;

																								{	/* Coerce/convert.scm 108 */
																									obj_t BgL_arg1542z00_2449;
																									obj_t BgL_arg1543z00_2450;

																									BgL_arg1542z00_2449 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_toz00_56));
																									BgL_arg1543z00_2450 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_fromz00_55));
																									BgL_arg1540z00_2448 =
																										BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																										(BGl_string2008z00zzcoerce_convertz00,
																										BgL_arg1542z00_2449,
																										BgL_arg1543z00_2450);
																								}
																								BGl_userzd2warningzf2locationz20zztools_errorz00
																									(BgL_locz00_57,
																									BgL_arg1753z00_1918,
																									BGl_string2009z00zzcoerce_convertz00,
																									BgL_arg1540z00_2448);
																							}
																						}
																						BGl_lvtypezd2nodez12zc0zzast_lvtypez00
																							(((BgL_nodez00_bglt)
																								BgL_nodez00_1917));
																						{	/* Coerce/convert.scm 225 */
																							BgL_sequencez00_bglt
																								BgL_new1139z00_1919;
																							{	/* Coerce/convert.scm 225 */
																								BgL_sequencez00_bglt
																									BgL_new1138z00_1927;
																								BgL_new1138z00_1927 =
																									((BgL_sequencez00_bglt)
																									BOBJECT(GC_MALLOC(sizeof
																											(struct
																												BgL_sequencez00_bgl))));
																								{	/* Coerce/convert.scm 225 */
																									long BgL_arg1786z00_1928;

																									BgL_arg1786z00_1928 =
																										BGL_CLASS_INDEX
																										(BGl_sequencez00zzast_nodez00);
																									BGL_OBJECT_CLASS_NUM_SET((
																											(BgL_objectz00_bglt)
																											BgL_new1138z00_1927),
																										BgL_arg1786z00_1928);
																								}
																								{	/* Coerce/convert.scm 225 */
																									BgL_objectz00_bglt
																										BgL_tmpz00_3125;
																									BgL_tmpz00_3125 =
																										((BgL_objectz00_bglt)
																										BgL_new1138z00_1927);
																									BGL_OBJECT_WIDENING_SET
																										(BgL_tmpz00_3125, BFALSE);
																								}
																								((BgL_objectz00_bglt)
																									BgL_new1138z00_1927);
																								BgL_new1139z00_1919 =
																									BgL_new1138z00_1927;
																							}
																							((((BgL_nodez00_bglt) COBJECT(
																											((BgL_nodez00_bglt)
																												BgL_new1139z00_1919)))->
																									BgL_locz00) =
																								((obj_t) BFALSE), BUNSPEC);
																							((((BgL_nodez00_bglt)
																										COBJECT(((BgL_nodez00_bglt)
																												BgL_new1139z00_1919)))->
																									BgL_typez00) =
																								((BgL_typez00_bglt)
																									BgL_toz00_56), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										COBJECT((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1139z00_1919)))->
																									BgL_sidezd2effectzd2) =
																								((obj_t) BUNSPEC), BUNSPEC);
																							((((BgL_nodezf2effectzf2_bglt)
																										COBJECT((
																												(BgL_nodezf2effectzf2_bglt)
																												BgL_new1139z00_1919)))->
																									BgL_keyz00) =
																								((obj_t) BINT(((long) -1))),
																								BUNSPEC);
																							{
																								obj_t BgL_auxz00_3138;

																								{	/* Coerce/convert.scm 228 */
																									BgL_nodez00_bglt
																										BgL_arg1755z00_1920;
																									BgL_literalz00_bglt
																										BgL_arg1759z00_1921;
																									BgL_arg1755z00_1920 =
																										BGl_coercez12z12zzcoerce_coercez00
																										(((BgL_nodez00_bglt)
																											BgL_nodez00_1917),
																										BUNSPEC, BgL_fromz00_55,
																										((bool_t) 0));
																									{	/* Coerce/convert.scm 229 */
																										BgL_literalz00_bglt
																											BgL_new1141z00_1924;
																										{	/* Coerce/convert.scm 229 */
																											BgL_literalz00_bglt
																												BgL_new1140z00_1925;
																											BgL_new1140z00_1925 =
																												((BgL_literalz00_bglt)
																												BOBJECT(GC_MALLOC(sizeof
																														(struct
																															BgL_literalz00_bgl))));
																											{	/* Coerce/convert.scm 229 */
																												long
																													BgL_arg1774z00_1926;
																												{	/* Coerce/convert.scm 229 */
																													obj_t
																														BgL_classz00_2455;
																													BgL_classz00_2455 =
																														BGl_literalz00zzast_nodez00;
																													BgL_arg1774z00_1926 =
																														BGL_CLASS_INDEX
																														(BgL_classz00_2455);
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1140z00_1925),
																													BgL_arg1774z00_1926);
																											}
																											{	/* Coerce/convert.scm 229 */
																												BgL_objectz00_bglt
																													BgL_tmpz00_3145;
																												BgL_tmpz00_3145 =
																													((BgL_objectz00_bglt)
																													BgL_new1140z00_1925);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_tmpz00_3145,
																													BFALSE);
																											}
																											((BgL_objectz00_bglt)
																												BgL_new1140z00_1925);
																											BgL_new1141z00_1924 =
																												BgL_new1140z00_1925;
																										}
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1141z00_1924)))->
																												BgL_locz00) =
																											((obj_t) BFALSE),
																											BUNSPEC);
																										((((BgL_nodez00_bglt)
																													COBJECT((
																															(BgL_nodez00_bglt)
																															BgL_new1141z00_1924)))->
																												BgL_typez00) =
																											((BgL_typez00_bglt)
																												BgL_toz00_56), BUNSPEC);
																										((((BgL_atomz00_bglt)
																													COBJECT((
																															(BgL_atomz00_bglt)
																															BgL_new1141z00_1924)))->
																												BgL_valuez00) =
																											((obj_t)
																												BGl_string2008z00zzcoerce_convertz00),
																											BUNSPEC);
																										BgL_arg1759z00_1921 =
																											BgL_new1141z00_1924;
																									}
																									{	/* Coerce/convert.scm 227 */
																										obj_t BgL_list1760z00_1922;

																										{	/* Coerce/convert.scm 227 */
																											obj_t BgL_arg1764z00_1923;

																											BgL_arg1764z00_1923 =
																												MAKE_YOUNG_PAIR(
																												((obj_t)
																													BgL_arg1759z00_1921),
																												BNIL);
																											BgL_list1760z00_1922 =
																												MAKE_YOUNG_PAIR(((obj_t)
																													BgL_arg1755z00_1920),
																												BgL_arg1764z00_1923);
																										}
																										BgL_auxz00_3138 =
																											BgL_list1760z00_1922;
																								}}
																								((((BgL_sequencez00_bglt)
																											COBJECT
																											(BgL_new1139z00_1919))->
																										BgL_nodesz00) =
																									((obj_t) BgL_auxz00_3138),
																									BUNSPEC);
																							}
																							((((BgL_sequencez00_bglt)
																										COBJECT
																										(BgL_new1139z00_1919))->
																									BgL_unsafez00) =
																								((bool_t) ((bool_t) 0)),
																								BUNSPEC);
																							((((BgL_sequencez00_bglt)
																										COBJECT
																										(BgL_new1139z00_1919))->
																									BgL_metaz00) =
																								((obj_t) BNIL), BUNSPEC);
																							return ((obj_t)
																								BgL_new1139z00_1919);
																						}
																					}
																				else
																					{	/* Coerce/convert.scm 221 */
																						{	/* Coerce/convert.scm 231 */
																							obj_t BgL_arg1789z00_1930;
																							obj_t BgL_arg1798z00_1931;

																							{	/* Coerce/convert.scm 231 */
																								obj_t BgL_tmpz00_3163;

																								BgL_tmpz00_3163 =
																									BGL_CURRENT_DYNAMIC_ENV();
																								BgL_arg1789z00_1930 =
																									BGL_ENV_CURRENT_ERROR_PORT
																									(BgL_tmpz00_3163);
																							}
																							BgL_arg1798z00_1931 =
																								BGl_shapez00zztools_shapez00(
																								((obj_t) BgL_nodez00_58));
																							{	/* Coerce/convert.scm 231 */
																								obj_t BgL_list1799z00_1932;

																								{	/* Coerce/convert.scm 231 */
																									obj_t BgL_arg1801z00_1933;

																									{	/* Coerce/convert.scm 231 */
																										obj_t BgL_arg1802z00_1934;

																										{	/* Coerce/convert.scm 231 */
																											obj_t BgL_arg1804z00_1935;

																											{	/* Coerce/convert.scm 231 */
																												obj_t
																													BgL_arg1806z00_1936;
																												{	/* Coerce/convert.scm 231 */
																													obj_t
																														BgL_arg1808z00_1937;
																													BgL_arg1808z00_1937 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg1798z00_1931,
																														BNIL);
																													BgL_arg1806z00_1936 =
																														MAKE_YOUNG_PAIR
																														(BGl_string2011z00zzcoerce_convertz00,
																														BgL_arg1808z00_1937);
																												}
																												BgL_arg1804z00_1935 =
																													MAKE_YOUNG_PAIR
																													(BGl_string2012z00zzcoerce_convertz00,
																													BgL_arg1806z00_1936);
																											}
																											BgL_arg1802z00_1934 =
																												MAKE_YOUNG_PAIR(BINT((
																														(long) 231)),
																												BgL_arg1804z00_1935);
																										}
																										BgL_arg1801z00_1933 =
																											MAKE_YOUNG_PAIR
																											(BGl_string2013z00zzcoerce_convertz00,
																											BgL_arg1802z00_1934);
																									}
																									BgL_list1799z00_1932 =
																										MAKE_YOUNG_PAIR
																										(BGl_string2014z00zzcoerce_convertz00,
																										BgL_arg1801z00_1933);
																								}
																								BGl_tprintz00zz__r4_output_6_10_3z00
																									(BgL_arg1789z00_1930,
																									BgL_list1799z00_1932);
																						}}
																						{	/* Coerce/convert.scm 232 */
																							obj_t BgL_arg1809z00_1938;

																							BgL_arg1809z00_1938 =
																								BGl_currentzd2functionzd2zztools_errorz00
																								();
																							{	/* Coerce/convert.scm 97 */
																								obj_t BgL_arg1529z00_2461;

																								{	/* Coerce/convert.scm 97 */
																									obj_t BgL_arg1532z00_2462;
																									obj_t BgL_arg1533z00_2463;

																									BgL_arg1532z00_2462 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_toz00_56));
																									BgL_arg1533z00_2463 =
																										BGl_shapez00zztools_shapez00
																										(((obj_t) BgL_fromz00_55));
																									BgL_arg1529z00_2461 =
																										BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
																										(BGl_string2008z00zzcoerce_convertz00,
																										BgL_arg1532z00_2462,
																										BgL_arg1533z00_2463);
																								}
																								return
																									BGl_userzd2errorzf2locationz20zztools_errorz00
																									(BgL_locz00_57,
																									BgL_arg1809z00_1938,
																									BGl_string2009z00zzcoerce_convertz00,
																									BgL_arg1529z00_2461, BNIL);
																							}
																						}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* convert! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt BgL_nodez00_59,
		BgL_typez00_bglt BgL_fromz00_60, BgL_typez00_bglt BgL_toz00_61,
		bool_t BgL_safez00_62)
	{
		{	/* Coerce/convert.scm 242 */
			if ((((obj_t) BgL_fromz00_60) == ((obj_t) BgL_toz00_61)))
				{	/* Coerce/convert.scm 246 */
					return BgL_nodez00_59;
				}
			else
				{	/* Coerce/convert.scm 248 */
					BgL_typez00_bglt BgL_toz00_1952;
					BgL_typez00_bglt BgL_froz00_1953;

					BgL_toz00_1952 =
						BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_toz00_61);
					BgL_froz00_1953 =
						BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_fromz00_60);
					{	/* Coerce/convert.scm 250 */
						bool_t BgL_test2066z00_3189;

						if ((((obj_t) BgL_froz00_1953) == ((obj_t) BgL_toz00_1952)))
							{	/* Coerce/convert.scm 250 */
								BgL_test2066z00_3189 = ((bool_t) 1);
							}
						else
							{	/* Coerce/convert.scm 250 */
								BgL_test2066z00_3189 =
									(((BgL_typez00_bglt) COBJECT(BgL_froz00_1953))->
									BgL_magiczf3zf3);
							}
						if (BgL_test2066z00_3189)
							{	/* Coerce/convert.scm 250 */
								return BgL_nodez00_59;
							}
						else
							{	/* Coerce/convert.scm 252 */
								obj_t BgL_coercerz00_1956;
								obj_t BgL_locz00_1957;

								BgL_coercerz00_1956 =
									BGl_findzd2coercerzd2zztype_coercionz00(BgL_froz00_1953,
									BgL_toz00_1952);
								BgL_locz00_1957 =
									(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_59))->BgL_locz00);
								{	/* Coerce/convert.scm 254 */
									bool_t BgL_test2068z00_3197;

									if (STRUCTP(BgL_coercerz00_1956))
										{	/* Coerce/convert.scm 254 */
											BgL_test2068z00_3197 =
												(STRUCT_KEY(BgL_coercerz00_1956) ==
												CNST_TABLE_REF(((long) 8)));
										}
									else
										{	/* Coerce/convert.scm 254 */
											BgL_test2068z00_3197 = ((bool_t) 0);
										}
									if (BgL_test2068z00_3197)
										{	/* Coerce/convert.scm 258 */
											obj_t BgL_g1143z00_1959;
											obj_t BgL_g1144z00_1960;

											BgL_g1143z00_1959 =
												STRUCT_REF(BgL_coercerz00_1956, (int) (((long) 2)));
											BgL_g1144z00_1960 =
												STRUCT_REF(BgL_coercerz00_1956, (int) (((long) 3)));
											{
												obj_t BgL_checksz00_1962;
												obj_t BgL_coercesz00_1963;
												BgL_nodez00_bglt BgL_nodez00_1964;

												{
													obj_t BgL_auxz00_3207;

													BgL_checksz00_1962 = BgL_g1143z00_1959;
													BgL_coercesz00_1963 = BgL_g1144z00_1960;
													BgL_nodez00_1964 = BgL_nodez00_59;
												BgL_zc3z04anonymousza31814ze3z87_1965:
													if (NULLP(BgL_checksz00_1962))
														{	/* Coerce/convert.scm 262 */
															if (NULLP(BgL_coercesz00_1963))
																{	/* Coerce/convert.scm 263 */
																	BgL_auxz00_3207 = ((obj_t) BgL_nodez00_1964);
																}
															else
																{	/* Coerce/convert.scm 266 */
																	obj_t BgL_arg1817z00_1968;
																	obj_t BgL_arg1818z00_1969;

																	BgL_arg1817z00_1968 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_60));
																	BgL_arg1818z00_1969 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_1952));
																	BgL_auxz00_3207 =
																		BGl_internalzd2errorzd2zztools_errorz00
																		(BGl_string2015z00zzcoerce_convertz00,
																		BgL_arg1817z00_1968, BgL_arg1818z00_1969);
																}
														}
													else
														{	/* Coerce/convert.scm 262 */
															if (NULLP(BgL_coercesz00_1963))
																{	/* Coerce/convert.scm 270 */
																	obj_t BgL_arg1821z00_1971;
																	obj_t BgL_arg1822z00_1972;

																	BgL_arg1821z00_1971 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_fromz00_60));
																	BgL_arg1822z00_1972 =
																		BGl_shapez00zztools_shapez00(
																		((obj_t) BgL_toz00_1952));
																	BgL_auxz00_3207 =
																		BGl_internalzd2errorzd2zztools_errorz00
																		(BGl_string2015z00zzcoerce_convertz00,
																		BgL_arg1821z00_1971, BgL_arg1822z00_1972);
																}
															else
																{	/* Coerce/convert.scm 273 */
																	obj_t BgL_arg1823z00_1973;
																	obj_t BgL_arg1824z00_1974;
																	BgL_nodez00_bglt BgL_arg1825z00_1975;

																	BgL_arg1823z00_1973 =
																		CDR(((obj_t) BgL_checksz00_1962));
																	BgL_arg1824z00_1974 =
																		CDR(((obj_t) BgL_coercesz00_1963));
																	{	/* Coerce/convert.scm 275 */
																		obj_t BgL_arg1826z00_1976;
																		obj_t BgL_arg1827z00_1977;
																		obj_t BgL_arg1828z00_1978;
																		obj_t BgL_arg1829z00_1979;

																		{	/* Coerce/convert.scm 275 */
																			obj_t BgL_pairz00_2478;

																			BgL_pairz00_2478 =
																				CAR(((obj_t) BgL_checksz00_1962));
																			BgL_arg1826z00_1976 =
																				CDR(BgL_pairz00_2478);
																		}
																		{	/* Coerce/convert.scm 276 */
																			obj_t BgL_pairz00_2482;

																			BgL_pairz00_2482 =
																				CAR(((obj_t) BgL_coercesz00_1963));
																			BgL_arg1827z00_1977 =
																				CDR(BgL_pairz00_2482);
																		}
																		{	/* Coerce/convert.scm 277 */
																			obj_t BgL_pairz00_2486;

																			BgL_pairz00_2486 =
																				CAR(((obj_t) BgL_checksz00_1962));
																			BgL_arg1828z00_1978 =
																				CAR(BgL_pairz00_2486);
																		}
																		{	/* Coerce/convert.scm 278 */
																			obj_t BgL_pairz00_2490;

																			BgL_pairz00_2490 =
																				CAR(((obj_t) BgL_coercesz00_1963));
																			BgL_arg1829z00_1979 =
																				CAR(BgL_pairz00_2490);
																		}
																		BgL_arg1825z00_1975 =
																			BGl_makezd2onezd2conversionz00zzcoerce_convertz00
																			(BgL_arg1826z00_1976, BgL_arg1827z00_1977,
																			BgL_arg1828z00_1978, BgL_arg1829z00_1979,
																			BgL_nodez00_1964, BgL_safez00_62);
																	}
																	{
																		BgL_nodez00_bglt BgL_nodez00_3244;
																		obj_t BgL_coercesz00_3243;
																		obj_t BgL_checksz00_3242;

																		BgL_checksz00_3242 = BgL_arg1823z00_1973;
																		BgL_coercesz00_3243 = BgL_arg1824z00_1974;
																		BgL_nodez00_3244 = BgL_arg1825z00_1975;
																		BgL_nodez00_1964 = BgL_nodez00_3244;
																		BgL_coercesz00_1963 = BgL_coercesz00_3243;
																		BgL_checksz00_1962 = BgL_checksz00_3242;
																		goto BgL_zc3z04anonymousza31814ze3z87_1965;
																	}
																}
														}
													return ((BgL_nodez00_bglt) BgL_auxz00_3207);
												}
											}
										}
									else
										{	/* Coerce/convert.scm 254 */
											return
												((BgL_nodez00_bglt)
												BGl_convertzd2errorzd2zzcoerce_convertz00
												(BgL_froz00_1953, BgL_toz00_1952, BgL_locz00_1957,
													BgL_nodez00_59));
										}
								}
							}
					}
				}
		}

	}



/* &convert! */
	BgL_nodez00_bglt BGl_z62convertz12z70zzcoerce_convertz00(obj_t
		BgL_envz00_2560, obj_t BgL_nodez00_2561, obj_t BgL_fromz00_2562,
		obj_t BgL_toz00_2563, obj_t BgL_safez00_2564)
	{
		{	/* Coerce/convert.scm 242 */
			return
				BGl_convertz12z12zzcoerce_convertz00(
				((BgL_nodez00_bglt) BgL_nodez00_2561),
				((BgL_typez00_bglt) BgL_fromz00_2562),
				((BgL_typez00_bglt) BgL_toz00_2563), CBOOL(BgL_safez00_2564));
		}

	}



/* make-one-conversion */
	BgL_nodez00_bglt BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t
		BgL_fromz00_63, obj_t BgL_toz00_64, obj_t BgL_checkopz00_65,
		obj_t BgL_coerceopz00_66, BgL_nodez00_bglt BgL_nodez00_67,
		bool_t BgL_safez00_68)
	{
		{	/* Coerce/convert.scm 291 */
			{	/* Coerce/convert.scm 292 */
				bool_t BgL_test2073z00_3253;

				if ((BgL_checkopz00_65 == BTRUE))
					{	/* Coerce/convert.scm 292 */
						BgL_test2073z00_3253 = ((bool_t) 1);
					}
				else
					{	/* Coerce/convert.scm 292 */
						if (BgL_safez00_68)
							{	/* Coerce/convert.scm 292 */
								BgL_test2073z00_3253 = ((bool_t) 0);
							}
						else
							{	/* Coerce/convert.scm 292 */
								BgL_test2073z00_3253 = ((bool_t) 1);
							}
					}
				if (BgL_test2073z00_3253)
					{	/* Coerce/convert.scm 292 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coerceopz00_66,
							BgL_nodez00_67, ((BgL_typez00_bglt) BgL_fromz00_63));
					}
				else
					{	/* Coerce/convert.scm 292 */
						if (BGl_isazf3zf3zz__objectz00(BgL_fromz00_63,
								BGl_tclassz00zzobject_classz00))
							{	/* Coerce/convert.scm 294 */
								return
									BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(
									((BgL_typez00_bglt) BgL_fromz00_63), BgL_toz00_64,
									BgL_checkopz00_65, BgL_coerceopz00_66, BgL_nodez00_67);
							}
						else
							{	/* Coerce/convert.scm 294 */
								return
									BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00
									(BgL_fromz00_63, BgL_toz00_64, BgL_checkopz00_65,
									BgL_coerceopz00_66, BgL_nodez00_67);
							}
					}
			}
		}

	}



/* skip-let-var */
	BgL_nodez00_bglt BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt
		BgL_nodez00_69)
	{
		{	/* Coerce/convert.scm 301 */
		BGl_skipzd2letzd2varz00zzcoerce_convertz00:
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_nodez00_69), BGl_letzd2varzd2zzast_nodez00))
				{	/* Coerce/convert.scm 303 */
					BgL_nodez00_bglt BgL_arg1834z00_1987;

					BgL_arg1834z00_1987 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nodez00_69)))->BgL_bodyz00);
					{
						BgL_nodez00_bglt BgL_nodez00_3269;

						BgL_nodez00_3269 = BgL_arg1834z00_1987;
						BgL_nodez00_69 = BgL_nodez00_3269;
						goto BGl_skipzd2letzd2varz00zzcoerce_convertz00;
					}
				}
			else
				{	/* Coerce/convert.scm 302 */
					return BgL_nodez00_69;
				}
		}

	}



/* make-one-type-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_fromz00_70, obj_t BgL_toz00_71, obj_t BgL_checkzd2opzd2_72,
		obj_t BgL_coercezd2opzd2_73, BgL_nodez00_bglt BgL_nodez00_74)
	{
		{	/* Coerce/convert.scm 309 */
			{	/* Coerce/convert.scm 312 */
				obj_t BgL_auxz00_1988;

				BgL_auxz00_1988 =
					BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
					(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5))));
				{	/* Coerce/convert.scm 312 */
					obj_t BgL_locz00_1989;

					BgL_locz00_1989 =
						(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_74))->BgL_locz00);
					{	/* Coerce/convert.scm 313 */
						BgL_nodez00_bglt BgL_lnodez00_1990;

						{	/* Coerce/convert.scm 321 */
							obj_t BgL_arg1850z00_2004;

							{	/* Coerce/convert.scm 321 */
								obj_t BgL_arg1851z00_2005;

								{	/* Coerce/convert.scm 321 */
									obj_t BgL_arg1854z00_2006;
									obj_t BgL_arg1855z00_2007;

									{	/* Coerce/convert.scm 321 */
										obj_t BgL_arg1856z00_2008;

										{	/* Coerce/convert.scm 321 */
											obj_t BgL_arg1857z00_2009;
											obj_t BgL_arg1858z00_2010;

											{	/* Coerce/convert.scm 321 */
												obj_t BgL_arg1859z00_2011;

												{	/* Coerce/convert.scm 321 */
													obj_t BgL_arg1860z00_2012;

													BgL_arg1860z00_2012 =
														(((BgL_typez00_bglt) COBJECT(
																((BgL_typez00_bglt) BgL_fromz00_70)))->
														BgL_idz00);
													BgL_arg1859z00_2011 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_auxz00_1988, BgL_arg1860z00_2012);
												}
												BgL_arg1857z00_2009 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg1859z00_2011);
											}
											BgL_arg1858z00_2010 = MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
											BgL_arg1856z00_2008 =
												MAKE_YOUNG_PAIR(BgL_arg1857z00_2009,
												BgL_arg1858z00_2010);
										}
										BgL_arg1854z00_2006 =
											MAKE_YOUNG_PAIR(BgL_arg1856z00_2008, BNIL);
									}
									{	/* Coerce/convert.scm 323 */
										obj_t BgL_arg1861z00_2013;

										{	/* Coerce/convert.scm 323 */
											obj_t BgL_arg1862z00_2014;

											{	/* Coerce/convert.scm 323 */
												obj_t BgL_arg1863z00_2015;
												obj_t BgL_arg1864z00_2016;

												{	/* Coerce/convert.scm 323 */
													obj_t BgL_arg1867z00_2017;

													BgL_arg1867z00_2017 =
														MAKE_YOUNG_PAIR(BgL_auxz00_1988, BNIL);
													BgL_arg1863z00_2015 =
														MAKE_YOUNG_PAIR(BgL_checkzd2opzd2_72,
														BgL_arg1867z00_2017);
												}
												{	/* Coerce/convert.scm 325 */
													obj_t BgL_arg1868z00_2018;

													{	/* Coerce/convert.scm 325 */
														obj_t BgL_arg1871z00_2019;

														{	/* Coerce/convert.scm 325 */
															obj_t BgL_arg1872z00_2020;

															BgL_arg1872z00_2020 =
																(((BgL_typez00_bglt) COBJECT(
																		((BgL_typez00_bglt) BgL_toz00_71)))->
																BgL_idz00);
															BgL_arg1871z00_2019 =
																BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
																(BgL_locz00_1989, BgL_arg1872z00_2020,
																BgL_auxz00_1988);
														}
														BgL_arg1868z00_2018 =
															MAKE_YOUNG_PAIR(BgL_arg1871z00_2019, BNIL);
													}
													BgL_arg1864z00_2016 =
														MAKE_YOUNG_PAIR(BgL_auxz00_1988,
														BgL_arg1868z00_2018);
												}
												BgL_arg1862z00_2014 =
													MAKE_YOUNG_PAIR(BgL_arg1863z00_2015,
													BgL_arg1864z00_2016);
											}
											BgL_arg1861z00_2013 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 9)),
												BgL_arg1862z00_2014);
										}
										BgL_arg1855z00_2007 =
											MAKE_YOUNG_PAIR(BgL_arg1861z00_2013, BNIL);
									}
									BgL_arg1851z00_2005 =
										MAKE_YOUNG_PAIR(BgL_arg1854z00_2006, BgL_arg1855z00_2007);
								}
								BgL_arg1850z00_2004 =
									MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
									BgL_arg1851z00_2005);
							}
							BgL_lnodez00_1990 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg1850z00_2004, BgL_locz00_1989);
						}
						{	/* Coerce/convert.scm 314 */

							BGl_za2checkza2z00zzcoerce_convertz00 =
								(((long) 1) + BGl_za2checkza2z00zzcoerce_convertz00);
							if (CBOOL(BGl_za2warningzd2typesza2zd2zzengine_paramz00))
								{	/* Coerce/convert.scm 83 */
									BGl_notifyzd2typezd2testz00zzcoerce_convertz00(BgL_fromz00_70,
										BgL_toz00_71, BgL_locz00_1989);
								}
							else
								{	/* Coerce/convert.scm 83 */
									BFALSE;
								}
							BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
								(BgL_lnodez00_1990);
							{	/* Coerce/convert.scm 329 */
								obj_t BgL_varz00_1991;

								{	/* Coerce/convert.scm 329 */
									obj_t BgL_pairz00_2498;

									{	/* Coerce/convert.scm 329 */
										obj_t BgL_pairz00_2497;

										BgL_pairz00_2497 =
											(((BgL_letzd2varzd2_bglt) COBJECT(
													((BgL_letzd2varzd2_bglt) BgL_lnodez00_1990)))->
											BgL_bindingsz00);
										BgL_pairz00_2498 = CAR(BgL_pairz00_2497);
									}
									BgL_varz00_1991 = CAR(BgL_pairz00_2498);
								}
								{	/* Coerce/convert.scm 329 */
									BgL_nodez00_bglt BgL_coercezd2appzd2_1992;

									{	/* Coerce/convert.scm 331 */
										BgL_varz00_bglt BgL_arg1841z00_1998;

										{	/* Coerce/convert.scm 331 */
											BgL_varz00_bglt BgL_new1146z00_1999;

											{	/* Coerce/convert.scm 332 */
												BgL_varz00_bglt BgL_new1145z00_2000;

												BgL_new1145z00_2000 =
													((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
																BgL_varz00_bgl))));
												{	/* Coerce/convert.scm 332 */
													long BgL_arg1843z00_2001;

													BgL_arg1843z00_2001 =
														BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
													BGL_OBJECT_CLASS_NUM_SET(
														((BgL_objectz00_bglt) BgL_new1145z00_2000),
														BgL_arg1843z00_2001);
												}
												BgL_new1146z00_1999 = BgL_new1145z00_2000;
											}
											((((BgL_nodez00_bglt) COBJECT(
															((BgL_nodez00_bglt) BgL_new1146z00_1999)))->
													BgL_locz00) = ((obj_t) BgL_locz00_1989), BUNSPEC);
											((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																BgL_new1146z00_1999)))->BgL_typez00) =
												((BgL_typez00_bglt)
													BGl_strictzd2nodezd2typez00zzast_nodez00((
															(BgL_typez00_bglt) BgL_toz00_71),
														((BgL_typez00_bglt) BgL_fromz00_70))), BUNSPEC);
											((((BgL_varz00_bglt) COBJECT(BgL_new1146z00_1999))->
													BgL_variablez00) =
												((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
														BgL_varz00_1991)), BUNSPEC);
											BgL_arg1841z00_1998 = BgL_new1146z00_1999;
										}
										BgL_coercezd2appzd2_1992 =
											BGl_dozd2convertzd2zzcoerce_convertz00
											(BgL_coercezd2opzd2_73,
											((BgL_nodez00_bglt) BgL_arg1841z00_1998),
											((BgL_typez00_bglt) BgL_fromz00_70));
									}
									{	/* Coerce/convert.scm 330 */
										BgL_nodez00_bglt BgL_condnz00_1993;

										BgL_condnz00_1993 =
											BGl_skipzd2letzd2varz00zzcoerce_convertz00
											(BgL_lnodez00_1990);
										{	/* Coerce/convert.scm 336 */

											((((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																((BgL_localz00_bglt) BgL_varz00_1991))))->
													BgL_typez00) =
												((BgL_typez00_bglt) ((BgL_typez00_bglt)
														BgL_fromz00_70)), BUNSPEC);
											{	/* Coerce/convert.scm 340 */
												obj_t BgL_arg1835z00_1994;

												{	/* Coerce/convert.scm 340 */
													obj_t BgL_pairz00_2505;

													BgL_pairz00_2505 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_lnodez00_1990)))->
														BgL_bindingsz00);
													BgL_arg1835z00_1994 = CAR(BgL_pairz00_2505);
												}
												{	/* Coerce/convert.scm 340 */
													obj_t BgL_auxz00_3331;
													obj_t BgL_tmpz00_3329;

													BgL_auxz00_3331 = ((obj_t) BgL_nodez00_74);
													BgL_tmpz00_3329 = ((obj_t) BgL_arg1835z00_1994);
													SET_CDR(BgL_tmpz00_3329, BgL_auxz00_3331);
											}}
											((((BgL_nodez00_bglt) COBJECT(BgL_nodez00_74))->
													BgL_typez00) =
												((BgL_typez00_bglt) ((BgL_typez00_bglt)
														BgL_fromz00_70)), BUNSPEC);
											((((BgL_conditionalz00_bglt)
														COBJECT(((BgL_conditionalz00_bglt)
																BgL_condnz00_1993)))->BgL_truez00) =
												((BgL_nodez00_bglt) BgL_coercezd2appzd2_1992), BUNSPEC);
											{	/* Coerce/convert.scm 344 */
												BgL_nodez00_bglt BgL_arg1838z00_1996;

												{	/* Coerce/convert.scm 344 */
													BgL_nodez00_bglt BgL_arg1839z00_1997;

													BgL_arg1839z00_1997 =
														(((BgL_conditionalz00_bglt) COBJECT(
																((BgL_conditionalz00_bglt)
																	BgL_condnz00_1993)))->BgL_falsez00);
													BgL_arg1838z00_1996 =
														BGl_coercez12z12zzcoerce_coercez00
														(BgL_arg1839z00_1997, BUNSPEC,
														((BgL_typez00_bglt) BgL_fromz00_70), ((bool_t) 0));
												}
												((((BgL_conditionalz00_bglt) COBJECT(
																((BgL_conditionalz00_bglt)
																	BgL_condnz00_1993)))->BgL_falsez00) =
													((BgL_nodez00_bglt) BgL_arg1838z00_1996), BUNSPEC);
											}
											BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1990);
											return BgL_lnodez00_1990;
										}
									}
								}
							}
						}
					}
				}
			}
		}

	}



/* make-one-class-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_75, obj_t BgL_toz00_76, obj_t BgL_checkzd2opzd2_77,
		obj_t BgL_coercezd2opzd2_78, BgL_nodez00_bglt BgL_nodez00_79)
	{
		{	/* Coerce/convert.scm 354 */
			{	/* Coerce/convert.scm 355 */
				bool_t BgL_test2079z00_3345;

				if (BGl_isazf3zf3zz__objectz00(BgL_toz00_76,
						BGl_tclassz00zzobject_classz00))
					{	/* Coerce/convert.scm 355 */
						BgL_test2079z00_3345 =
							BGl_typezd2subclasszf3z21zzobject_classz00(
							((BgL_typez00_bglt) BgL_fromz00_75),
							((BgL_typez00_bglt) ((BgL_typez00_bglt) BgL_toz00_76)));
					}
				else
					{	/* Coerce/convert.scm 355 */
						BgL_test2079z00_3345 = ((bool_t) 0);
					}
				if (BgL_test2079z00_3345)
					{	/* Coerce/convert.scm 355 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coercezd2opzd2_78,
							BgL_nodez00_79, ((BgL_typez00_bglt) BgL_fromz00_75));
					}
				else
					{	/* Coerce/convert.scm 357 */
						obj_t BgL_auxz00_2024;

						BgL_auxz00_2024 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 5)));
						{	/* Coerce/convert.scm 357 */
							obj_t BgL_aux2z00_2025;

							BgL_aux2z00_2025 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 10)));
							{	/* Coerce/convert.scm 358 */
								obj_t BgL_locz00_2026;

								BgL_locz00_2026 =
									(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_79))->BgL_locz00);
								{	/* Coerce/convert.scm 359 */
									BgL_nodez00_bglt BgL_lnodez00_2027;

									{	/* Coerce/convert.scm 362 */
										obj_t BgL_arg1892z00_2051;

										{	/* Coerce/convert.scm 362 */
											obj_t BgL_arg1893z00_2052;

											{	/* Coerce/convert.scm 362 */
												obj_t BgL_arg1894z00_2053;
												obj_t BgL_arg1895z00_2054;

												{	/* Coerce/convert.scm 362 */
													obj_t BgL_arg1896z00_2055;

													{	/* Coerce/convert.scm 362 */
														obj_t BgL_arg1899z00_2056;
														obj_t BgL_arg1900z00_2057;

														{	/* Coerce/convert.scm 362 */
															obj_t BgL_arg1901z00_2058;

															{	/* Coerce/convert.scm 362 */
																obj_t BgL_arg1902z00_2059;

																{	/* Coerce/convert.scm 362 */
																	obj_t BgL_arg1903z00_2060;
																	obj_t BgL_arg1904z00_2061;

																	{	/* Coerce/convert.scm 362 */
																		obj_t BgL_arg1447z00_2516;

																		BgL_arg1447z00_2516 =
																			SYMBOL_TO_STRING(BgL_auxz00_2024);
																		BgL_arg1903z00_2060 =
																			BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																			(BgL_arg1447z00_2516);
																	}
																	{	/* Coerce/convert.scm 362 */
																		obj_t BgL_symbolz00_2517;

																		BgL_symbolz00_2517 =
																			CNST_TABLE_REF(((long) 6));
																		{	/* Coerce/convert.scm 362 */
																			obj_t BgL_arg1447z00_2518;

																			BgL_arg1447z00_2518 =
																				SYMBOL_TO_STRING(BgL_symbolz00_2517);
																			BgL_arg1904z00_2061 =
																				BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																				(BgL_arg1447z00_2518);
																	}}
																	BgL_arg1902z00_2059 =
																		string_append(BgL_arg1903z00_2060,
																		BgL_arg1904z00_2061);
																}
																BgL_arg1901z00_2058 =
																	bstring_to_symbol(BgL_arg1902z00_2059);
															}
															BgL_arg1899z00_2056 =
																BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																(BgL_arg1901z00_2058);
														}
														BgL_arg1900z00_2057 =
															MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
														BgL_arg1896z00_2055 =
															MAKE_YOUNG_PAIR(BgL_arg1899z00_2056,
															BgL_arg1900z00_2057);
													}
													BgL_arg1894z00_2053 =
														MAKE_YOUNG_PAIR(BgL_arg1896z00_2055, BNIL);
												}
												{	/* Coerce/convert.scm 364 */
													obj_t BgL_arg1905z00_2062;

													{	/* Coerce/convert.scm 364 */
														obj_t BgL_arg1907z00_2063;

														{	/* Coerce/convert.scm 364 */
															obj_t BgL_arg1908z00_2064;
															obj_t BgL_arg1909z00_2065;

															{	/* Coerce/convert.scm 364 */
																obj_t BgL_arg1910z00_2066;

																{	/* Coerce/convert.scm 364 */
																	obj_t BgL_arg1911z00_2067;
																	obj_t BgL_arg1912z00_2068;

																	{	/* Coerce/convert.scm 364 */
																		obj_t BgL_arg1913z00_2069;

																		{	/* Coerce/convert.scm 364 */
																			obj_t BgL_arg1914z00_2070;

																			{	/* Coerce/convert.scm 364 */
																				obj_t BgL_arg1915z00_2071;
																				obj_t BgL_arg1917z00_2072;

																				{	/* Coerce/convert.scm 364 */
																					obj_t BgL_arg1447z00_2521;

																					BgL_arg1447z00_2521 =
																						SYMBOL_TO_STRING(BgL_aux2z00_2025);
																					BgL_arg1915z00_2071 =
																						BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																						(BgL_arg1447z00_2521);
																				}
																				{	/* Coerce/convert.scm 364 */
																					obj_t BgL_symbolz00_2522;

																					BgL_symbolz00_2522 =
																						CNST_TABLE_REF(((long) 6));
																					{	/* Coerce/convert.scm 364 */
																						obj_t BgL_arg1447z00_2523;

																						BgL_arg1447z00_2523 =
																							SYMBOL_TO_STRING
																							(BgL_symbolz00_2522);
																						BgL_arg1917z00_2072 =
																							BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																							(BgL_arg1447z00_2523);
																				}}
																				BgL_arg1914z00_2070 =
																					string_append(BgL_arg1915z00_2071,
																					BgL_arg1917z00_2072);
																			}
																			BgL_arg1913z00_2069 =
																				bstring_to_symbol(BgL_arg1914z00_2070);
																		}
																		BgL_arg1911z00_2067 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BgL_arg1913z00_2069);
																	}
																	BgL_arg1912z00_2068 =
																		MAKE_YOUNG_PAIR(BUNSPEC, BNIL);
																	BgL_arg1910z00_2066 =
																		MAKE_YOUNG_PAIR(BgL_arg1911z00_2067,
																		BgL_arg1912z00_2068);
																}
																BgL_arg1908z00_2064 =
																	MAKE_YOUNG_PAIR(BgL_arg1910z00_2066, BNIL);
															}
															{	/* Coerce/convert.scm 365 */
																obj_t BgL_arg1918z00_2073;

																{	/* Coerce/convert.scm 365 */
																	obj_t BgL_arg1919z00_2074;

																	{	/* Coerce/convert.scm 365 */
																		obj_t BgL_arg1920z00_2075;
																		obj_t BgL_arg1921z00_2076;

																		{	/* Coerce/convert.scm 365 */
																			obj_t BgL_arg1922z00_2077;

																			BgL_arg1922z00_2077 =
																				MAKE_YOUNG_PAIR(BgL_aux2z00_2025, BNIL);
																			BgL_arg1920z00_2075 =
																				MAKE_YOUNG_PAIR(BgL_checkzd2opzd2_77,
																				BgL_arg1922z00_2077);
																		}
																		{	/* Coerce/convert.scm 367 */
																			obj_t BgL_arg1923z00_2078;

																			{	/* Coerce/convert.scm 367 */
																				obj_t BgL_arg1926z00_2079;

																				{	/* Coerce/convert.scm 367 */
																					obj_t BgL_arg1927z00_2080;

																					BgL_arg1927z00_2080 =
																						(((BgL_typez00_bglt) COBJECT(
																								((BgL_typez00_bglt)
																									BgL_toz00_76)))->BgL_idz00);
																					BgL_arg1926z00_2079 =
																						BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
																						(BgL_locz00_2026,
																						BgL_arg1927z00_2080,
																						BgL_auxz00_2024);
																				}
																				BgL_arg1923z00_2078 =
																					MAKE_YOUNG_PAIR(BgL_arg1926z00_2079,
																					BNIL);
																			}
																			BgL_arg1921z00_2076 =
																				MAKE_YOUNG_PAIR(BgL_auxz00_2024,
																				BgL_arg1923z00_2078);
																		}
																		BgL_arg1919z00_2074 =
																			MAKE_YOUNG_PAIR(BgL_arg1920z00_2075,
																			BgL_arg1921z00_2076);
																	}
																	BgL_arg1918z00_2073 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 9)),
																		BgL_arg1919z00_2074);
																}
																BgL_arg1909z00_2065 =
																	MAKE_YOUNG_PAIR(BgL_arg1918z00_2073, BNIL);
															}
															BgL_arg1907z00_2063 =
																MAKE_YOUNG_PAIR(BgL_arg1908z00_2064,
																BgL_arg1909z00_2065);
														}
														BgL_arg1905z00_2062 =
															MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
															BgL_arg1907z00_2063);
													}
													BgL_arg1895z00_2054 =
														MAKE_YOUNG_PAIR(BgL_arg1905z00_2062, BNIL);
												}
												BgL_arg1893z00_2052 =
													MAKE_YOUNG_PAIR(BgL_arg1894z00_2053,
													BgL_arg1895z00_2054);
											}
											BgL_arg1892z00_2051 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 7)),
												BgL_arg1893z00_2052);
										}
										BgL_lnodez00_2027 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg1892z00_2051, BgL_locz00_2026);
									}
									{	/* Coerce/convert.scm 360 */

										BGl_za2checkza2z00zzcoerce_convertz00 =
											(((long) 1) + BGl_za2checkza2z00zzcoerce_convertz00);
										if (CBOOL(BGl_za2warningzd2typesza2zd2zzengine_paramz00))
											{	/* Coerce/convert.scm 83 */
												BGl_notifyzd2typezd2testz00zzcoerce_convertz00(
													((obj_t) BgL_fromz00_75), BgL_toz00_76,
													BgL_locz00_2026);
											}
										else
											{	/* Coerce/convert.scm 83 */
												BFALSE;
											}
										BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
											(BgL_lnodez00_2027);
										{	/* Coerce/convert.scm 371 */
											obj_t BgL_varz00_2028;

											{	/* Coerce/convert.scm 371 */
												obj_t BgL_pairz00_2529;

												{	/* Coerce/convert.scm 371 */
													obj_t BgL_pairz00_2528;

													BgL_pairz00_2528 =
														(((BgL_letzd2varzd2_bglt) COBJECT(
																((BgL_letzd2varzd2_bglt) BgL_lnodez00_2027)))->
														BgL_bindingsz00);
													BgL_pairz00_2529 = CAR(BgL_pairz00_2528);
												}
												BgL_varz00_2028 = CAR(BgL_pairz00_2529);
											}
											{	/* Coerce/convert.scm 371 */
												BgL_nodez00_bglt BgL_coercezd2appzd2_2029;

												{	/* Coerce/convert.scm 373 */
													BgL_varz00_bglt BgL_arg1888z00_2045;

													{	/* Coerce/convert.scm 373 */
														BgL_varz00_bglt BgL_new1148z00_2046;

														{	/* Coerce/convert.scm 374 */
															BgL_varz00_bglt BgL_new1147z00_2047;

															BgL_new1147z00_2047 =
																((BgL_varz00_bglt)
																BOBJECT(GC_MALLOC(sizeof(struct
																			BgL_varz00_bgl))));
															{	/* Coerce/convert.scm 374 */
																long BgL_arg1889z00_2048;

																BgL_arg1889z00_2048 =
																	BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
																BGL_OBJECT_CLASS_NUM_SET(
																	((BgL_objectz00_bglt) BgL_new1147z00_2047),
																	BgL_arg1889z00_2048);
															}
															BgL_new1148z00_2046 = BgL_new1147z00_2047;
														}
														((((BgL_nodez00_bglt) COBJECT(
																		((BgL_nodez00_bglt) BgL_new1148z00_2046)))->
																BgL_locz00) =
															((obj_t) BgL_locz00_2026), BUNSPEC);
														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
																			BgL_new1148z00_2046)))->BgL_typez00) =
															((BgL_typez00_bglt) ((BgL_typez00_bglt)
																	BgL_fromz00_75)), BUNSPEC);
														((((BgL_varz00_bglt) COBJECT(BgL_new1148z00_2046))->
																BgL_variablez00) =
															((BgL_variablez00_bglt) ((BgL_variablez00_bglt)
																	BgL_varz00_2028)), BUNSPEC);
														BgL_arg1888z00_2045 = BgL_new1148z00_2046;
													}
													BgL_coercezd2appzd2_2029 =
														BGl_dozd2convertzd2zzcoerce_convertz00
														(BgL_coercezd2opzd2_78,
														((BgL_nodez00_bglt) BgL_arg1888z00_2045),
														((BgL_typez00_bglt) BgL_fromz00_75));
												}
												{	/* Coerce/convert.scm 372 */
													BgL_nodez00_bglt BgL_condnz00_2030;

													BgL_condnz00_2030 =
														BGl_skipzd2letzd2varz00zzcoerce_convertz00
														(BgL_lnodez00_2027);
													{	/* Coerce/convert.scm 378 */

														((((BgL_variablez00_bglt) COBJECT(
																		((BgL_variablez00_bglt)
																			((BgL_localz00_bglt) BgL_varz00_2028))))->
																BgL_typez00) =
															((BgL_typez00_bglt) ((BgL_typez00_bglt)
																	BgL_fromz00_75)), BUNSPEC);
														{	/* Coerce/convert.scm 382 */
															obj_t BgL_arg1876z00_2031;

															{	/* Coerce/convert.scm 382 */
																obj_t BgL_pairz00_2536;

																BgL_pairz00_2536 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				BgL_lnodez00_2027)))->BgL_bindingsz00);
																BgL_arg1876z00_2031 = CAR(BgL_pairz00_2536);
															}
															{	/* Coerce/convert.scm 382 */
																obj_t BgL_auxz00_3434;
																obj_t BgL_tmpz00_3432;

																BgL_auxz00_3434 = ((obj_t) BgL_nodez00_79);
																BgL_tmpz00_3432 = ((obj_t) BgL_arg1876z00_2031);
																SET_CDR(BgL_tmpz00_3432, BgL_auxz00_3434);
														}}
														{	/* Coerce/convert.scm 383 */
															obj_t BgL_binding2z00_2033;

															{	/* Coerce/convert.scm 383 */
																obj_t BgL_pairz00_2540;

																BgL_pairz00_2540 =
																	(((BgL_letzd2varzd2_bglt) COBJECT(
																			((BgL_letzd2varzd2_bglt)
																				(((BgL_letzd2varzd2_bglt) COBJECT(
																							((BgL_letzd2varzd2_bglt)
																								BgL_lnodez00_2027)))->
																					BgL_bodyz00))))->BgL_bindingsz00);
																BgL_binding2z00_2033 = CAR(BgL_pairz00_2540);
															}
															{	/* Coerce/convert.scm 384 */
																BgL_castz00_bglt BgL_arg1878z00_2034;

																{	/* Coerce/convert.scm 384 */
																	BgL_castz00_bglt BgL_new1150z00_2035;

																	{	/* Coerce/convert.scm 385 */
																		BgL_castz00_bglt BgL_new1149z00_2039;

																		BgL_new1149z00_2039 =
																			((BgL_castz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_castz00_bgl))));
																		{	/* Coerce/convert.scm 385 */
																			long BgL_arg1880z00_2040;

																			BgL_arg1880z00_2040 =
																				BGL_CLASS_INDEX
																				(BGl_castz00zzast_nodez00);
																			BGL_OBJECT_CLASS_NUM_SET((
																					(BgL_objectz00_bglt)
																					BgL_new1149z00_2039),
																				BgL_arg1880z00_2040);
																		}
																		{	/* Coerce/convert.scm 385 */
																			BgL_objectz00_bglt BgL_tmpz00_3446;

																			BgL_tmpz00_3446 =
																				((BgL_objectz00_bglt)
																				BgL_new1149z00_2039);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3446,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1149z00_2039);
																		BgL_new1150z00_2035 = BgL_new1149z00_2039;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1150z00_2035)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_2026), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1150z00_2035)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt) ((BgL_typez00_bglt)
																				BGl_za2objza2z00zztype_cachez00)),
																		BUNSPEC);
																	{
																		BgL_nodez00_bglt BgL_auxz00_3455;

																		{	/* Coerce/convert.scm 387 */
																			BgL_varz00_bglt BgL_new1152z00_2036;

																			{	/* Coerce/convert.scm 388 */
																				BgL_varz00_bglt BgL_new1151z00_2037;

																				BgL_new1151z00_2037 =
																					((BgL_varz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Coerce/convert.scm 388 */
																					long BgL_arg1879z00_2038;

																					{	/* Coerce/convert.scm 388 */
																						obj_t BgL_classz00_2545;

																						BgL_classz00_2545 =
																							BGl_varz00zzast_nodez00;
																						BgL_arg1879z00_2038 =
																							BGL_CLASS_INDEX
																							(BgL_classz00_2545);
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1151z00_2037),
																						BgL_arg1879z00_2038);
																				}
																				BgL_new1152z00_2036 =
																					BgL_new1151z00_2037;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1152z00_2036)))->
																					BgL_locz00) =
																				((obj_t) BgL_locz00_2026), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1152z00_2036)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) ((BgL_typez00_bglt)
																						BgL_fromz00_75)), BUNSPEC);
																			((((BgL_varz00_bglt)
																						COBJECT(BgL_new1152z00_2036))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) (
																						(BgL_variablez00_bglt)
																						BgL_varz00_2028)), BUNSPEC);
																			BgL_auxz00_3455 =
																				((BgL_nodez00_bglt)
																				BgL_new1152z00_2036);
																		}
																		((((BgL_castz00_bglt)
																					COBJECT(BgL_new1150z00_2035))->
																				BgL_argz00) =
																			((BgL_nodez00_bglt) BgL_auxz00_3455),
																			BUNSPEC);
																	}
																	BgL_arg1878z00_2034 = BgL_new1150z00_2035;
																}
																{	/* Coerce/convert.scm 384 */
																	obj_t BgL_auxz00_3471;
																	obj_t BgL_tmpz00_3469;

																	BgL_auxz00_3471 =
																		((obj_t) BgL_arg1878z00_2034);
																	BgL_tmpz00_3469 =
																		((obj_t) BgL_binding2z00_2033);
																	SET_CDR(BgL_tmpz00_3469, BgL_auxz00_3471);
														}}}
														((((BgL_conditionalz00_bglt) COBJECT(
																		((BgL_conditionalz00_bglt)
																			BgL_condnz00_2030)))->BgL_truez00) =
															((BgL_nodez00_bglt) BgL_coercezd2appzd2_2029),
															BUNSPEC);
														{	/* Coerce/convert.scm 393 */
															BgL_nodez00_bglt BgL_arg1886z00_2043;

															{	/* Coerce/convert.scm 393 */
																BgL_nodez00_bglt BgL_arg1887z00_2044;

																BgL_arg1887z00_2044 =
																	(((BgL_conditionalz00_bglt) COBJECT(
																			((BgL_conditionalz00_bglt)
																				BgL_condnz00_2030)))->BgL_falsez00);
																BgL_arg1886z00_2043 =
																	BGl_coercez12z12zzcoerce_coercez00
																	(BgL_arg1887z00_2044, BUNSPEC,
																	((BgL_typez00_bglt) BgL_fromz00_75),
																	((bool_t) 0));
															}
															((((BgL_conditionalz00_bglt) COBJECT(
																			((BgL_conditionalz00_bglt)
																				BgL_condnz00_2030)))->BgL_falsez00) =
																((BgL_nodez00_bglt) BgL_arg1886z00_2043),
																BUNSPEC);
														}
														BGl_lvtypezd2nodez12zc0zzast_lvtypez00
															(BgL_lnodez00_2027);
														return BgL_lnodez00_2027;
													}
												}
											}
										}
									}
								}
							}
						}
					}
			}
		}

	}



/* do-convert */
	BgL_nodez00_bglt BGl_dozd2convertzd2zzcoerce_convertz00(obj_t
		BgL_coercezd2opzd2_80, BgL_nodez00_bglt BgL_nodez00_81,
		BgL_typez00_bglt BgL_fromz00_82)
	{
		{	/* Coerce/convert.scm 403 */
			if ((BgL_coercezd2opzd2_80 == BTRUE))
				{	/* Coerce/convert.scm 406 */
					return BgL_nodez00_81;
				}
			else
				{	/* Coerce/convert.scm 408 */
					BgL_nodez00_bglt BgL_nnodez00_2083;

					{	/* Coerce/convert.scm 408 */
						obj_t BgL_arg1929z00_2084;
						obj_t BgL_arg1930z00_2085;

						{	/* Coerce/convert.scm 408 */
							obj_t BgL_arg1931z00_2086;

							BgL_arg1931z00_2086 =
								MAKE_YOUNG_PAIR(((obj_t) BgL_nodez00_81), BNIL);
							BgL_arg1929z00_2084 =
								MAKE_YOUNG_PAIR(BgL_coercezd2opzd2_80, BgL_arg1931z00_2086);
						}
						BgL_arg1930z00_2085 =
							(((BgL_nodez00_bglt) COBJECT(BgL_nodez00_81))->BgL_locz00);
						BgL_nnodez00_2083 =
							BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
							(BgL_arg1929z00_2084, BgL_arg1930z00_2085);
					}
					BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nnodez00_2083);
					BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nnodez00_2083);
					return BgL_nnodez00_2083;
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00()
	{
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 116865673),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 163122759),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 189769752),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 361167184),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 348216764),
				BSTRING_TO_STRING(BGl_string2016z00zzcoerce_convertz00));
		}

	}

#ifdef __cplusplus
}
#endif
