/*===========================================================================*/
/*   (Engine/heap.scm)                                                       */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Engine/heap.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
		obj_t BgL_subclassesz00;
	}                *BgL_tclassz00_bglt;


	extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzengine_heapz00 = BUNSPEC;
	static obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_setzd2backendz12zc0zzbackend_backendz00(obj_t);
	static obj_t BGl_z62dumpzd2heapszb0zzengine_heapz00(obj_t, obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31302ze3ze5zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	static obj_t BGl_genericzd2initzd2zzengine_heapz00();
	static obj_t BGl_objectzd2initzd2zzengine_heapz00();
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzengine_heapz00();
	extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_z62zc3z04anonymousza31309ze3ze5zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31270ze3ze5zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31258ze3ze5zzengine_heapz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT bool_t fexists(char *);
	static obj_t BGl_z62zc3z04anonymousza31284ze3ze5zzengine_heapz00(obj_t);
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	static obj_t BGl_z62zc3z04anonymousza31722ze3ze5zzengine_heapz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zzengine_heapz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00();
	static obj_t BGl_gczd2rootszd2initz00zzengine_heapz00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STRING(BGl_string1820z00zzengine_heapz00,
		BgL_bgl_string1820za700za7za7e1844za7, "dump-heap", 9);
	      DEFINE_STRING(BGl_string1821z00zzengine_heapz00,
		BgL_bgl_string1821za700za7za7e1845za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string1824z00zzengine_heapz00,
		BgL_bgl_string1824za700za7za7e1846za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string1825z00zzengine_heapz00,
		BgL_bgl_string1825za700za7za7e1847za7, "(heap \"", 7);
	      DEFINE_STRING(BGl_string1826z00zzengine_heapz00,
		BgL_bgl_string1826za700za7za7e1848za7, "\"", 1);
	      DEFINE_STRING(BGl_string1827z00zzengine_heapz00,
		BgL_bgl_string1827za700za7za7e1849za7, " (variables", 11);
	      DEFINE_STRING(BGl_string1828z00zzengine_heapz00,
		BgL_bgl_string1828za700za7za7e1850za7, " )\n", 3);
	      DEFINE_STRING(BGl_string1829z00zzengine_heapz00,
		BgL_bgl_string1829za700za7za7e1851za7, " (types", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1822z00zzengine_heapz00,
		BgL_bgl_za762za7c3za704anonymo1852za7,
		BGl_z62zc3z04anonymousza31258ze3ze5zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1823z00zzengine_heapz00,
		BgL_bgl_za762za7c3za704anonymo1853za7,
		BGl_z62zc3z04anonymousza31270ze3ze5zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1830z00zzengine_heapz00,
		BgL_bgl_string1830za700za7za7e1854za7, " )", 2);
	      DEFINE_STRING(BGl_string1831z00zzengine_heapz00,
		BgL_bgl_string1831za700za7za7e1855za7, " (includes", 10);
	      DEFINE_STRING(BGl_string1832z00zzengine_heapz00,
		BgL_bgl_string1832za700za7za7e1856za7, ")\n", 2);
	      DEFINE_STRING(BGl_string1834z00zzengine_heapz00,
		BgL_bgl_string1834za700za7za7e1857za7, "   ", 3);
	      DEFINE_STRING(BGl_string1835z00zzengine_heapz00,
		BgL_bgl_string1835za700za7za7e1858za7, "~s", 2);
	      DEFINE_STRING(BGl_string1836z00zzengine_heapz00,
		BgL_bgl_string1836za700za7za7e1859za7, "", 0);
	      DEFINE_STRING(BGl_string1837z00zzengine_heapz00,
		BgL_bgl_string1837za700za7za7e1860za7, "\n   ", 4);
	      DEFINE_STRING(BGl_string1838z00zzengine_heapz00,
		BgL_bgl_string1838za700za7za7e1861za7, "\n    ", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1833z00zzengine_heapz00,
		BgL_bgl_za762za7c3za704anonymo1862za7,
		BGl_z62zc3z04anonymousza31309ze3ze5zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1840z00zzengine_heapz00,
		BgL_bgl_string1840za700za7za7e1863za7, "engine_heap", 11);
	      DEFINE_STRING(BGl_string1841z00zzengine_heapz00,
		BgL_bgl_string1841za700za7za7e1864za7,
		"type super variable class native function args jvm-type-name inline sifun qualified-type name module id ",
		104);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1839z00zzengine_heapz00,
		BgL_bgl_za762za7c3za704anonymo1865za7,
		BGl_z62zc3z04anonymousza31722ze3ze5zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_dumpzd2heapszd2envz00zzengine_heapz00,
		BgL_bgl_za762dumpza7d2heapsza71866za7,
		BGl_z62dumpzd2heapszb0zzengine_heapz00, 0L, BUNSPEC, 1);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzengine_heapz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long
		BgL_checksumz00_1517, char *BgL_fromz00_1518)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzengine_heapz00))
				{
					BGl_requirezd2initializa7ationz75zzengine_heapz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzengine_heapz00();
					BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
					BGl_cnstzd2initzd2zzengine_heapz00();
					BGl_importedzd2moduleszd2initz00zzengine_heapz00();
					return BGl_methodzd2initzd2zzengine_heapz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"engine_heap");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			{	/* Engine/heap.scm 15 */
				obj_t BgL_cportz00_1325;

				{	/* Engine/heap.scm 15 */
					obj_t BgL_stringz00_1333;

					BgL_stringz00_1333 = BGl_string1841z00zzengine_heapz00;
					{	/* Engine/heap.scm 15 */
						obj_t BgL_startz00_1334;

						BgL_startz00_1334 = BINT(((long) 0));
						{	/* Engine/heap.scm 15 */
							obj_t BgL_endz00_1335;

							BgL_endz00_1335 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_1333)));
							{	/* Engine/heap.scm 15 */

								BgL_cportz00_1325 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_1333, BgL_startz00_1334, BgL_endz00_1335);
				}}}}
				{
					long BgL_iz00_1326;

					BgL_iz00_1326 = ((long) 13);
				BgL_loopz00_1327:
					if ((BgL_iz00_1326 == ((long) -1)))
						{	/* Engine/heap.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Engine/heap.scm 15 */
							{	/* Engine/heap.scm 15 */
								obj_t BgL_arg1843z00_1329;

								{	/* Engine/heap.scm 15 */

									{	/* Engine/heap.scm 15 */
										obj_t BgL_locationz00_1331;

										BgL_locationz00_1331 = BBOOL(((bool_t) 0));
										{	/* Engine/heap.scm 15 */

											BgL_arg1843z00_1329 =
												BGl_readz00zz__readerz00(BgL_cportz00_1325,
												BgL_locationz00_1331);
										}
									}
								}
								{	/* Engine/heap.scm 15 */
									int BgL_tmpz00_1549;

									BgL_tmpz00_1549 = (int) (BgL_iz00_1326);
									CNST_TABLE_SET(BgL_tmpz00_1549, BgL_arg1843z00_1329);
							}}
							{	/* Engine/heap.scm 15 */
								int BgL_auxz00_1332;

								BgL_auxz00_1332 = (int) ((BgL_iz00_1326 - ((long) 1)));
								{
									long BgL_iz00_1554;

									BgL_iz00_1554 = (long) (BgL_auxz00_1332);
									BgL_iz00_1326 = BgL_iz00_1554;
									goto BgL_loopz00_1327;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* dump-heaps */
	BGL_EXPORTED_DEF obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t
		BgL_namesz00_3)
	{
		{	/* Engine/heap.scm 33 */
			BGl_setzd2backendz12zc0zzbackend_backendz00
				(BGl_za2targetzd2languageza2zd2zzengine_paramz00);
			BGl_initializa7ezd2Genvz12z67zzast_envz00();
			BGl_initializa7ezd2Tenvz12z67zztype_envz00();
			{
				obj_t BgL_l1182z00_769;

				{	/* Engine/heap.scm 40 */
					bool_t BgL_tmpz00_1560;

					BgL_l1182z00_769 = BgL_namesz00_3;
				BgL_zc3z04anonymousza31227ze3z87_770:
					if (PAIRP(BgL_l1182z00_769))
						{	/* Engine/heap.scm 40 */
							BGl_dumpzd2heapzd2zzengine_heapz00(CAR(BgL_l1182z00_769));
							{
								obj_t BgL_l1182z00_1565;

								BgL_l1182z00_1565 = CDR(BgL_l1182z00_769);
								BgL_l1182z00_769 = BgL_l1182z00_1565;
								goto BgL_zc3z04anonymousza31227ze3z87_770;
							}
						}
					else
						{	/* Engine/heap.scm 40 */
							BgL_tmpz00_1560 = ((bool_t) 1);
						}
					return BBOOL(BgL_tmpz00_1560);
				}
			}
		}

	}



/* &dump-heaps */
	obj_t BGl_z62dumpzd2heapszb0zzengine_heapz00(obj_t BgL_envz00_1298,
		obj_t BgL_namesz00_1299)
	{
		{	/* Engine/heap.scm 33 */
			return BGl_dumpzd2heapszd2zzengine_heapz00(BgL_namesz00_1299);
		}

	}



/* dump-heap */
	obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t BgL_heapz00_4)
	{
		{	/* Engine/heap.scm 45 */
			{	/* Engine/heap.scm 46 */
				obj_t BgL_fnamez00_775;

				if (fexists(BSTRING_TO_STRING(BgL_heapz00_4)))
					{	/* Engine/heap.scm 46 */
						BgL_fnamez00_775 = BgL_heapz00_4;
					}
				else
					{	/* Engine/heap.scm 46 */
						BgL_fnamez00_775 =
							BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_4,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
					}
				if (STRINGP(BgL_fnamez00_775))
					{	/* Engine/heap.scm 50 */
						obj_t BgL_portz00_777;

						BgL_portz00_777 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_775);
						if (BINARY_PORTP(BgL_portz00_777))
							{	/* Engine/heap.scm 55 */
								obj_t BgL_exitd1064z00_779;

								BgL_exitd1064z00_779 = BGL_EXITD_TOP_AS_OBJ();
								{	/* Engine/heap.scm 115 */
									obj_t BgL_zc3z04anonymousza31302ze3z87_1303;

									BgL_zc3z04anonymousza31302ze3z87_1303 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31302ze3ze5zzengine_heapz00,
										(int) (((long) 0)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31302ze3z87_1303,
										(int) (((long) 0)), BgL_portz00_777);
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
										(BgL_exitd1064z00_779,
										BgL_zc3z04anonymousza31302ze3z87_1303);
									{	/* Engine/heap.scm 56 */
										obj_t BgL_tmp1066z00_781;

										{	/* Engine/heap.scm 56 */
											obj_t BgL_envsz00_782;

											BgL_envsz00_782 = input_obj(BgL_portz00_777);
											{	/* Engine/heap.scm 56 */
												obj_t BgL__z00_783;

												{	/* Engine/heap.scm 57 */
													bool_t BgL_test1873z00_1586;

													{	/* Engine/heap.scm 57 */
														obj_t BgL_v1184z00_848;

														BgL_v1184z00_848 = create_vector(((long) 1));
														VECTOR_SET(BgL_v1184z00_848, ((long) 0),
															BgL_envsz00_782);
														((bool_t) 1);
													}
													{	/* Engine/heap.scm 58 */
														bool_t BgL__ortest_1078z00_845;

														BgL__ortest_1078z00_845 =
															(VECTOR_LENGTH(
																((obj_t) BgL_envsz00_782)) == ((long) 5));
														if (BgL__ortest_1078z00_845)
															{	/* Engine/heap.scm 58 */
																BgL_test1873z00_1586 = BgL__ortest_1078z00_845;
															}
														else
															{	/* Engine/heap.scm 58 */
																BgL_test1873z00_1586 =
																	(VECTOR_LENGTH(
																		((obj_t) BgL_envsz00_782)) == ((long) 7));
													}}
													if (BgL_test1873z00_1586)
														{	/* Engine/heap.scm 57 */
															BgL__z00_783 = BFALSE;
														}
													else
														{	/* Engine/heap.scm 57 */
															BgL__z00_783 =
																BGl_errorz00zz__errorz00
																(BGl_string1820z00zzengine_heapz00,
																BGl_string1821z00zzengine_heapz00,
																BgL_heapz00_4);
														}
												}
												{	/* Engine/heap.scm 57 */
													obj_t BgL_targetz00_784;

													BgL_targetz00_784 =
														VECTOR_REF(((obj_t) BgL_envsz00_782), ((long) 0));
													{	/* Engine/heap.scm 61 */
														obj_t BgL_versionz00_785;

														BgL_versionz00_785 =
															VECTOR_REF(((obj_t) BgL_envsz00_782), ((long) 1));
														{	/* Engine/heap.scm 62 */
															obj_t BgL_specificz00_786;

															BgL_specificz00_786 =
																VECTOR_REF(
																((obj_t) BgL_envsz00_782), ((long) 2));
															{	/* Engine/heap.scm 63 */
																obj_t BgL_genvz00_787;

																BgL_genvz00_787 =
																	VECTOR_REF(
																	((obj_t) BgL_envsz00_782), ((long) 3));
																{	/* Engine/heap.scm 64 */
																	obj_t BgL_tenvz00_788;

																	BgL_tenvz00_788 =
																		VECTOR_REF(
																		((obj_t) BgL_envsz00_782), ((long) 4));
																	{	/* Engine/heap.scm 65 */
																		obj_t BgL_includesz00_789;

																		if (
																			(VECTOR_LENGTH(
																					((obj_t) BgL_envsz00_782)) ==
																				((long) 6)))
																			{	/* Engine/heap.scm 66 */
																				BgL_includesz00_789 =
																					VECTOR_REF(
																					((obj_t) BgL_envsz00_782),
																					((long) 5));
																			}
																		else
																			{	/* Engine/heap.scm 66 */
																				BgL_includesz00_789 = BNIL;
																			}
																		{	/* Engine/heap.scm 66 */

																			if (
																				(VECTOR_LENGTH(
																						((obj_t) BgL_envsz00_782)) ==
																					((long) 6)))
																				{	/* Engine/heap.scm 78 */
																					BGl_addzd2genvz12zc0zzast_envz00
																						(BgL_genvz00_787);
																				}
																			else
																				{	/* Engine/heap.scm 78 */
																					BGl_setzd2tenvz12zc0zztype_envz00
																						(BgL_tenvz00_788);
																					BGl_setzd2genvz12zc0zzast_envz00
																						(BgL_genvz00_787);
																				}
																			{	/* Engine/heap.scm 87 */
																				bool_t BgL_test1877z00_1620;

																				{	/* Engine/heap.scm 87 */
																					obj_t BgL_arg1268z00_804;

																					BgL_arg1268z00_804 =
																						BGl_thezd2backendzd2zzbackend_backendz00
																						();
																					BgL_test1877z00_1620 =
																						(((BgL_backendz00_bglt)
																							COBJECT(((BgL_backendz00_bglt)
																									BgL_arg1268z00_804)))->
																						BgL_qualifiedzd2typeszd2);
																				}
																				if (BgL_test1877z00_1620)
																					{	/* Engine/heap.scm 87 */
																						BGl_forzd2eachzd2globalz12z12zzast_envz00
																							(BGl_proc1822z00zzengine_heapz00,
																							BNIL);
																					}
																				else
																					{	/* Engine/heap.scm 87 */
																						BFALSE;
																					}
																			}
																			BGl_hashtablezd2forzd2eachz00zz__hashz00
																				(BgL_genvz00_787,
																				BGl_proc1823z00zzengine_heapz00);
																			{	/* Engine/heap.scm 101 */
																				obj_t BgL_arg1278z00_820;

																				{	/* Engine/heap.scm 101 */
																					obj_t BgL_tmpz00_1626;

																					BgL_tmpz00_1626 =
																						BGL_CURRENT_DYNAMIC_ENV();
																					BgL_arg1278z00_820 =
																						BGL_ENV_CURRENT_ERROR_PORT
																						(BgL_tmpz00_1626);
																				}
																				{	/* Engine/heap.scm 103 */
																					obj_t
																						BgL_zc3z04anonymousza31284ze3z87_1300;
																					BgL_zc3z04anonymousza31284ze3z87_1300
																						=
																						MAKE_FX_PROCEDURE
																						(BGl_z62zc3z04anonymousza31284ze3ze5zzengine_heapz00,
																						(int) (((long) 0)),
																						(int) (((long) 4)));
																					PROCEDURE_SET
																						(BgL_zc3z04anonymousza31284ze3z87_1300,
																						(int) (((long) 0)), BgL_heapz00_4);
																					PROCEDURE_SET
																						(BgL_zc3z04anonymousza31284ze3z87_1300,
																						(int) (((long) 1)),
																						BgL_genvz00_787);
																					PROCEDURE_SET
																						(BgL_zc3z04anonymousza31284ze3z87_1300,
																						(int) (((long) 2)),
																						BgL_tenvz00_788);
																					PROCEDURE_SET
																						(BgL_zc3z04anonymousza31284ze3z87_1300,
																						(int) (((long) 3)),
																						BgL_includesz00_789);
																					BgL_tmp1066z00_781 =
																						BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00
																						(BgL_arg1278z00_820,
																						BgL_zc3z04anonymousza31284ze3z87_1300);
										}}}}}}}}}}}
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00
											(BgL_exitd1064z00_779);
										close_binary_port(BgL_portz00_777);
										return BgL_tmp1066z00_781;
									}
								}
							}
						else
							{	/* Engine/heap.scm 53 */
								obj_t BgL_arg1304z00_851;

								{	/* Engine/heap.scm 53 */
									obj_t BgL_list1305z00_852;

									BgL_list1305z00_852 = MAKE_YOUNG_PAIR(BgL_fnamez00_775, BNIL);
									BgL_arg1304z00_851 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string1824z00zzengine_heapz00, BgL_list1305z00_852);
								}
								return
									BGl_errorz00zz__errorz00(BGl_string1820z00zzengine_heapz00,
									BgL_arg1304z00_851, BGl_za2libzd2dirza2zd2zzengine_paramz00);
							}
					}
				else
					{	/* Engine/heap.scm 116 */
						obj_t BgL_mz00_853;

						{	/* Engine/heap.scm 116 */
							obj_t BgL_list1306z00_854;

							BgL_list1306z00_854 = MAKE_YOUNG_PAIR(BgL_heapz00_4, BNIL);
							BgL_mz00_853 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string1824z00zzengine_heapz00, BgL_list1306z00_854);
						}
						BGl_errorz00zz__errorz00(BGl_string1820z00zzengine_heapz00,
							BgL_mz00_853, BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BFALSE;
					}
			}
		}

	}



/* &<@anonymous:1284> */
	obj_t BGl_z62zc3z04anonymousza31284ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1304)
	{
		{	/* Engine/heap.scm 102 */
			{	/* Engine/heap.scm 103 */
				obj_t BgL_heapz00_1305;
				obj_t BgL_genvz00_1306;
				obj_t BgL_tenvz00_1307;
				obj_t BgL_includesz00_1308;

				BgL_heapz00_1305 = PROCEDURE_REF(BgL_envz00_1304, (int) (((long) 0)));
				BgL_genvz00_1306 = PROCEDURE_REF(BgL_envz00_1304, (int) (((long) 1)));
				BgL_tenvz00_1307 = PROCEDURE_REF(BgL_envz00_1304, (int) (((long) 2)));
				BgL_includesz00_1308 =
					PROCEDURE_REF(BgL_envz00_1304, (int) (((long) 3)));
				{	/* Engine/heap.scm 103 */
					obj_t BgL_port1188z00_1337;

					{	/* Engine/heap.scm 103 */
						obj_t BgL_tmpz00_1657;

						BgL_tmpz00_1657 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1188z00_1337 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1657);
					}
					bgl_display_string(BGl_string1825z00zzengine_heapz00,
						BgL_port1188z00_1337);
					bgl_display_obj(BgL_heapz00_1305, BgL_port1188z00_1337);
					bgl_display_string(BGl_string1826z00zzengine_heapz00,
						BgL_port1188z00_1337);
					bgl_display_char(((unsigned char) 10), BgL_port1188z00_1337);
				}
				{	/* Engine/heap.scm 104 */
					obj_t BgL_port1189z00_1338;

					{	/* Engine/heap.scm 104 */
						obj_t BgL_tmpz00_1664;

						BgL_tmpz00_1664 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1189z00_1338 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1664);
					}
					bgl_display_string(BGl_string1827z00zzengine_heapz00,
						BgL_port1189z00_1338);
					bgl_display_char(((unsigned char) 10), BgL_port1189z00_1338);
				}
				BGl_dumpzd2Genvzd2zzengine_heapz00(BgL_genvz00_1306);
				{	/* Engine/heap.scm 106 */
					obj_t BgL_port1190z00_1339;

					{	/* Engine/heap.scm 106 */
						obj_t BgL_tmpz00_1670;

						BgL_tmpz00_1670 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1190z00_1339 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1670);
					}
					bgl_display_string(BGl_string1828z00zzengine_heapz00,
						BgL_port1190z00_1339);
					bgl_display_char(((unsigned char) 10), BgL_port1190z00_1339);
				}
				{	/* Engine/heap.scm 107 */
					obj_t BgL_port1191z00_1340;

					{	/* Engine/heap.scm 107 */
						obj_t BgL_tmpz00_1675;

						BgL_tmpz00_1675 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1191z00_1340 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1675);
					}
					bgl_display_string(BGl_string1829z00zzengine_heapz00,
						BgL_port1191z00_1340);
					bgl_display_char(((unsigned char) 10), BgL_port1191z00_1340);
				}
				BGl_dumpzd2Tenvzd2zzengine_heapz00(BgL_tenvz00_1307);
				{	/* Engine/heap.scm 109 */
					obj_t BgL_port1192z00_1341;

					{	/* Engine/heap.scm 109 */
						obj_t BgL_tmpz00_1681;

						BgL_tmpz00_1681 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1192z00_1341 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1681);
					}
					bgl_display_string(BGl_string1830z00zzengine_heapz00,
						BgL_port1192z00_1341);
					bgl_display_char(((unsigned char) 10), BgL_port1192z00_1341);
				}
				if (PAIRP(BgL_includesz00_1308))
					{	/* Engine/heap.scm 110 */
						{	/* Engine/heap.scm 111 */
							obj_t BgL_port1193z00_1342;

							{	/* Engine/heap.scm 111 */
								obj_t BgL_tmpz00_1688;

								BgL_tmpz00_1688 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_port1193z00_1342 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1688);
							}
							bgl_display_string(BGl_string1831z00zzengine_heapz00,
								BgL_port1193z00_1342);
							bgl_display_char(((unsigned char) 10), BgL_port1193z00_1342);
						}
						{	/* Engine/heap.scm 112 */
							obj_t BgL_port1194z00_1343;

							{	/* Engine/heap.scm 112 */
								obj_t BgL_tmpz00_1693;

								BgL_tmpz00_1693 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_port1194z00_1343 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1693);
							}
							bgl_display_obj(BgL_includesz00_1308, BgL_port1194z00_1343);
							bgl_display_char(((unsigned char) 10), BgL_port1194z00_1343);
						}
						{	/* Engine/heap.scm 113 */
							obj_t BgL_port1195z00_1344;

							{	/* Engine/heap.scm 113 */
								obj_t BgL_tmpz00_1698;

								BgL_tmpz00_1698 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_port1195z00_1344 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1698);
							}
							bgl_display_string(BGl_string1830z00zzengine_heapz00,
								BgL_port1195z00_1344);
							bgl_display_char(((unsigned char) 10), BgL_port1195z00_1344);
					}}
				else
					{	/* Engine/heap.scm 110 */
						BFALSE;
					}
				{	/* Engine/heap.scm 114 */
					obj_t BgL_port1196z00_1345;

					{	/* Engine/heap.scm 114 */
						obj_t BgL_tmpz00_1703;

						BgL_tmpz00_1703 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_port1196z00_1345 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1703);
					}
					bgl_display_string(BGl_string1832z00zzengine_heapz00,
						BgL_port1196z00_1345);
					return bgl_display_char(((unsigned char) 10), BgL_port1196z00_1345);
		}}}

	}



/* &<@anonymous:1270> */
	obj_t BGl_z62zc3z04anonymousza31270ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1309, obj_t BgL_kz00_1310, obj_t BgL_bucketz00_1311)
	{
		{	/* Engine/heap.scm 97 */
			{	/* Engine/heap.scm 98 */
				bool_t BgL_tmpz00_1708;

				{	/* Engine/heap.scm 98 */
					obj_t BgL_g1187z00_1346;

					BgL_g1187z00_1346 = CDR(((obj_t) BgL_bucketz00_1311));
					{
						obj_t BgL_l1185z00_1348;

						BgL_l1185z00_1348 = BgL_g1187z00_1346;
					BgL_zc3z04anonymousza31271ze3z87_1347:
						if (PAIRP(BgL_l1185z00_1348))
							{	/* Engine/heap.scm 100 */
								{	/* Engine/heap.scm 99 */
									obj_t BgL_newz00_1349;

									BgL_newz00_1349 = CAR(BgL_l1185z00_1348);
									{	/* Engine/heap.scm 99 */
										obj_t BgL_arg1274z00_1350;

										BgL_arg1274z00_1350 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_1349)))->
											BgL_modulez00);
										{	/* Engine/heap.scm 99 */
											obj_t BgL_list1275z00_1351;

											BgL_list1275z00_1351 =
												MAKE_YOUNG_PAIR(BgL_arg1274z00_1350, BNIL);
											BGl_heapzd2modulezd2listz00zzheap_restorez00
												(BgL_list1275z00_1351);
										}
									}
								}
								{
									obj_t BgL_l1185z00_1718;

									BgL_l1185z00_1718 = CDR(BgL_l1185z00_1348);
									BgL_l1185z00_1348 = BgL_l1185z00_1718;
									goto BgL_zc3z04anonymousza31271ze3z87_1347;
								}
							}
						else
							{	/* Engine/heap.scm 100 */
								BgL_tmpz00_1708 = ((bool_t) 1);
							}
					}
				}
				return BBOOL(BgL_tmpz00_1708);
			}
		}

	}



/* &<@anonymous:1258> */
	obj_t BGl_z62zc3z04anonymousza31258ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1312, obj_t BgL_newz00_1313)
	{
		{	/* Engine/heap.scm 89 */
			{	/* Engine/heap.scm 91 */
				obj_t BgL_arg1259z00_1352;
				obj_t BgL_arg1260z00_1353;
				obj_t BgL_arg1264z00_1354;

				BgL_arg1259z00_1352 =
					(((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_newz00_1313)))->BgL_modulez00);
				BgL_arg1260z00_1353 =
					(((BgL_globalz00_bglt) COBJECT(
							((BgL_globalz00_bglt) BgL_newz00_1313)))->
					BgL_jvmzd2typezd2namez00);
				BgL_arg1264z00_1354 = BGl_shapez00zztools_shapez00(BgL_newz00_1313);
				{	/* Engine/heap.scm 90 */
					obj_t BgL_list1265z00_1355;

					BgL_list1265z00_1355 = MAKE_YOUNG_PAIR(BgL_arg1264z00_1354, BNIL);
					return
						BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg1259z00_1352,
						BgL_arg1260z00_1353, BgL_list1265z00_1355);
				}
			}
		}

	}



/* &<@anonymous:1302> */
	obj_t BGl_z62zc3z04anonymousza31302ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1314)
	{
		{	/* Engine/heap.scm 55 */
			{	/* Engine/heap.scm 115 */
				obj_t BgL_portz00_1315;

				BgL_portz00_1315 = PROCEDURE_REF(BgL_envz00_1314, (int) (((long) 0)));
				return close_binary_port(((obj_t) BgL_portz00_1315));
			}
		}

	}



/* dump-Genv */
	obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t BgL_genvz00_5)
	{
		{	/* Engine/heap.scm 123 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_5,
				BGl_proc1833z00zzengine_heapz00);
		}

	}



/* &<@anonymous:1309> */
	obj_t BGl_z62zc3z04anonymousza31309ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1317, obj_t BgL_kz00_1318, obj_t BgL_bucketz00_1319)
	{
		{	/* Engine/heap.scm 178 */
			{	/* Engine/heap.scm 178 */
				bool_t BgL_tmpz00_1733;

				{
					obj_t BgL_newz00_1357;

					{	/* Engine/heap.scm 178 */
						obj_t BgL_g1214z00_1483;

						BgL_g1214z00_1483 = CDR(((obj_t) BgL_bucketz00_1319));
						{
							obj_t BgL_l1212z00_1485;

							BgL_l1212z00_1485 = BgL_g1214z00_1483;
						BgL_zc3z04anonymousza31310ze3z87_1484:
							if (PAIRP(BgL_l1212z00_1485))
								{	/* Engine/heap.scm 178 */
									BgL_newz00_1357 = CAR(BgL_l1212z00_1485);
									{	/* Engine/heap.scm 125 */
										obj_t BgL_modulez00_1358;

										BgL_modulez00_1358 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt) BgL_newz00_1357)))->
											BgL_modulez00);
										{	/* Engine/heap.scm 125 */
											obj_t BgL_idz00_1359;

											BgL_idz00_1359 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_globalz00_bglt) BgL_newz00_1357))))->
												BgL_idz00);
											{	/* Engine/heap.scm 126 */
												obj_t BgL_qtz00_1360;

												BgL_qtz00_1360 =
													BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
													(BgL_modulez00_1358);
												{	/* Engine/heap.scm 127 */
													obj_t BgL_jtz00_1361;

													BgL_jtz00_1361 =
														(((BgL_globalz00_bglt) COBJECT(
																((BgL_globalz00_bglt) BgL_newz00_1357)))->
														BgL_jvmzd2typezd2namez00);
													{	/* Engine/heap.scm 128 */
														BgL_valuez00_bglt BgL_valz00_1362;

														BgL_valz00_1362 =
															(((BgL_variablez00_bglt) COBJECT(
																	((BgL_variablez00_bglt)
																		((BgL_globalz00_bglt) BgL_newz00_1357))))->
															BgL_valuez00);
														{	/* Engine/heap.scm 129 */

															if (BGl_isazf3zf3zz__objectz00(
																	((obj_t) BgL_valz00_1362),
																	BGl_sfunz00zzast_varz00))
																{	/* Engine/heap.scm 132 */
																	obj_t BgL_port1203z00_1363;

																	{	/* Engine/heap.scm 132 */
																		obj_t BgL_tmpz00_1752;

																		BgL_tmpz00_1752 = BGL_CURRENT_DYNAMIC_ENV();
																		BgL_port1203z00_1363 =
																			BGL_ENV_CURRENT_OUTPUT_PORT
																			(BgL_tmpz00_1752);
																	}
																	bgl_display_string
																		(BGl_string1834z00zzengine_heapz00,
																		BgL_port1203z00_1363);
																	{	/* Engine/heap.scm 133 */
																		obj_t BgL_arg1317z00_1364;

																		{	/* Engine/heap.scm 133 */
																			obj_t BgL_arg1329z00_1365;

																			{	/* Engine/heap.scm 133 */
																				obj_t BgL_arg1331z00_1366;
																				obj_t BgL_arg1332z00_1367;

																				BgL_arg1331z00_1366 =
																					BGl_shapez00zztools_shapez00
																					(BgL_newz00_1357);
																				{	/* Engine/heap.scm 135 */
																					obj_t BgL_arg1335z00_1368;

																					{	/* Engine/heap.scm 135 */
																						obj_t BgL_arg1336z00_1369;
																						obj_t BgL_arg1338z00_1370;

																						{	/* Engine/heap.scm 135 */
																							obj_t BgL_arg1340z00_1371;

																							BgL_arg1340z00_1371 =
																								MAKE_YOUNG_PAIR(BgL_idz00_1359,
																								BNIL);
																							BgL_arg1336z00_1369 =
																								MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																										(long) 0)),
																								BgL_arg1340z00_1371);
																						}
																						{	/* Engine/heap.scm 137 */
																							obj_t BgL_arg1343z00_1372;

																							{	/* Engine/heap.scm 137 */
																								obj_t BgL_arg1344z00_1373;
																								obj_t BgL_arg1346z00_1374;

																								{	/* Engine/heap.scm 137 */
																									obj_t BgL_arg1349z00_1375;

																									BgL_arg1349z00_1375 =
																										MAKE_YOUNG_PAIR
																										(BgL_modulez00_1358, BNIL);
																									BgL_arg1344z00_1373 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long) 1)),
																										BgL_arg1349z00_1375);
																								}
																								{	/* Engine/heap.scm 139 */
																									obj_t BgL_arg1350z00_1376;

																									{	/* Engine/heap.scm 139 */
																										obj_t BgL_arg1353z00_1377;
																										obj_t BgL_arg1354z00_1378;

																										{	/* Engine/heap.scm 139 */
																											obj_t BgL_arg1356z00_1379;

																											{	/* Engine/heap.scm 139 */
																												obj_t
																													BgL_arg1357z00_1380;
																												{	/* Engine/heap.scm 139 */
																													obj_t
																														BgL_arg1358z00_1381;
																													BgL_arg1358z00_1381 =
																														(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) BgL_newz00_1357))))->BgL_namez00);
																													{	/* Engine/heap.scm 139 */
																														obj_t
																															BgL_list1359z00_1382;
																														BgL_list1359z00_1382
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1358z00_1381,
																															BNIL);
																														BgL_arg1357z00_1380
																															=
																															BGl_formatz00zz__r4_output_6_10_3z00
																															(BGl_string1835z00zzengine_heapz00,
																															BgL_list1359z00_1382);
																												}}
																												BgL_arg1356z00_1379 =
																													MAKE_YOUNG_PAIR
																													(BgL_arg1357z00_1380,
																													BNIL);
																											}
																											BgL_arg1353z00_1377 =
																												MAKE_YOUNG_PAIR
																												(CNST_TABLE_REF(((long)
																														2)),
																												BgL_arg1356z00_1379);
																										}
																										{	/* Engine/heap.scm 141 */
																											obj_t BgL_arg1367z00_1383;

																											{	/* Engine/heap.scm 141 */
																												obj_t
																													BgL_arg1368z00_1384;
																												obj_t
																													BgL_arg1369z00_1385;
																												{	/* Engine/heap.scm 141 */
																													obj_t
																														BgL_arg1370z00_1386;
																													BgL_arg1370z00_1386 =
																														MAKE_YOUNG_PAIR
																														(BgL_qtz00_1360,
																														BNIL);
																													BgL_arg1368z00_1384 =
																														MAKE_YOUNG_PAIR
																														(CNST_TABLE_REF((
																																(long) 3)),
																														BgL_arg1370z00_1386);
																												}
																												{	/* Engine/heap.scm 142 */
																													obj_t
																														BgL_arg1371z00_1387;
																													obj_t
																														BgL_arg1372z00_1388;
																													if (((((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt) BgL_valz00_1362)))->BgL_classz00) == CNST_TABLE_REF(((long) 4))))
																														{	/* Engine/heap.scm 143 */
																															obj_t
																																BgL_arg1396z00_1389;
																															{	/* Engine/heap.scm 143 */
																																obj_t
																																	BgL_arg1404z00_1390;
																																{	/* Engine/heap.scm 143 */
																																	obj_t
																																		BgL_arg1409z00_1391;
																																	BgL_arg1409z00_1391
																																		=
																																		(((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt) BgL_valz00_1362)))->BgL_bodyz00);
																																	BgL_arg1404z00_1390
																																		=
																																		BGl_shapez00zztools_shapez00
																																		(BgL_arg1409z00_1391);
																																}
																																BgL_arg1396z00_1389
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1404z00_1390,
																																	BNIL);
																															}
																															BgL_arg1371z00_1387
																																=
																																MAKE_YOUNG_PAIR
																																(CNST_TABLE_REF(
																																	((long) 5)),
																																BgL_arg1396z00_1389);
																														}
																													else
																														{	/* Engine/heap.scm 142 */
																															BgL_arg1371z00_1387
																																=
																																BGl_string1836z00zzengine_heapz00;
																														}
																													{	/* Engine/heap.scm 146 */
																														obj_t
																															BgL_arg1436z00_1392;
																														{	/* Engine/heap.scm 146 */
																															obj_t
																																BgL_arg1445z00_1393;
																															obj_t
																																BgL_arg1446z00_1394;
																															{	/* Engine/heap.scm 146 */
																																obj_t
																																	BgL_arg1451z00_1395;
																																BgL_arg1451z00_1395
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_jtz00_1361,
																																	BNIL);
																																BgL_arg1445z00_1393
																																	=
																																	MAKE_YOUNG_PAIR
																																	(CNST_TABLE_REF
																																	(((long) 6)),
																																	BgL_arg1451z00_1395);
																															}
																															{	/* Engine/heap.scm 147 */
																																obj_t
																																	BgL_arg1484z00_1396;
																																{	/* Engine/heap.scm 147 */
																																	obj_t
																																		BgL_arg1500z00_1397;
																																	{	/* Engine/heap.scm 147 */
																																		obj_t
																																			BgL_arg1502z00_1398;
																																		{	/* Engine/heap.scm 147 */
																																			obj_t
																																				BgL_arg1520z00_1399;
																																			{	/* Engine/heap.scm 147 */
																																				obj_t
																																					BgL_l1197z00_1400;
																																				BgL_l1197z00_1400
																																					=
																																					(((BgL_sfunz00_bglt) COBJECT(((BgL_sfunz00_bglt) BgL_valz00_1362)))->BgL_argsz00);
																																				if (NULLP(BgL_l1197z00_1400))
																																					{	/* Engine/heap.scm 147 */
																																						BgL_arg1520z00_1399
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Engine/heap.scm 147 */
																																						obj_t
																																							BgL_head1199z00_1401;
																																						{	/* Engine/heap.scm 147 */
																																							obj_t
																																								BgL_arg1532z00_1402;
																																							{	/* Engine/heap.scm 147 */
																																								obj_t
																																									BgL_arg1533z00_1403;
																																								BgL_arg1533z00_1403
																																									=
																																									CAR
																																									(
																																									((obj_t) BgL_l1197z00_1400));
																																								BgL_arg1532z00_1402
																																									=
																																									BGl_shapez00zztools_shapez00
																																									(BgL_arg1533z00_1403);
																																							}
																																							BgL_head1199z00_1401
																																								=
																																								MAKE_YOUNG_PAIR
																																								(BgL_arg1532z00_1402,
																																								BNIL);
																																						}
																																						{	/* Engine/heap.scm 147 */
																																							obj_t
																																								BgL_g1202z00_1404;
																																							BgL_g1202z00_1404
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_l1197z00_1400));
																																							{
																																								obj_t
																																									BgL_l1197z00_1406;
																																								obj_t
																																									BgL_tail1200z00_1407;
																																								BgL_l1197z00_1406
																																									=
																																									BgL_g1202z00_1404;
																																								BgL_tail1200z00_1407
																																									=
																																									BgL_head1199z00_1401;
																																							BgL_zc3z04anonymousza31522ze3z87_1405:
																																								if (NULLP(BgL_l1197z00_1406))
																																									{	/* Engine/heap.scm 147 */
																																										BgL_arg1520z00_1399
																																											=
																																											BgL_head1199z00_1401;
																																									}
																																								else
																																									{	/* Engine/heap.scm 147 */
																																										obj_t
																																											BgL_newtail1201z00_1408;
																																										{	/* Engine/heap.scm 147 */
																																											obj_t
																																												BgL_arg1527z00_1409;
																																											{	/* Engine/heap.scm 147 */
																																												obj_t
																																													BgL_arg1529z00_1410;
																																												BgL_arg1529z00_1410
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_l1197z00_1406));
																																												BgL_arg1527z00_1409
																																													=
																																													BGl_shapez00zztools_shapez00
																																													(BgL_arg1529z00_1410);
																																											}
																																											BgL_newtail1201z00_1408
																																												=
																																												MAKE_YOUNG_PAIR
																																												(BgL_arg1527z00_1409,
																																												BNIL);
																																										}
																																										SET_CDR
																																											(BgL_tail1200z00_1407,
																																											BgL_newtail1201z00_1408);
																																										{	/* Engine/heap.scm 147 */
																																											obj_t
																																												BgL_arg1526z00_1411;
																																											BgL_arg1526z00_1411
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_l1197z00_1406));
																																											{
																																												obj_t
																																													BgL_tail1200z00_1808;
																																												obj_t
																																													BgL_l1197z00_1807;
																																												BgL_l1197z00_1807
																																													=
																																													BgL_arg1526z00_1411;
																																												BgL_tail1200z00_1808
																																													=
																																													BgL_newtail1201z00_1408;
																																												BgL_tail1200z00_1407
																																													=
																																													BgL_tail1200z00_1808;
																																												BgL_l1197z00_1406
																																													=
																																													BgL_l1197z00_1807;
																																												goto
																																													BgL_zc3z04anonymousza31522ze3z87_1405;
																																											}
																																										}
																																									}
																																							}
																																						}
																																					}
																																			}
																																			BgL_arg1502z00_1398
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BgL_arg1520z00_1399,
																																				BNIL);
																																		}
																																		BgL_arg1500z00_1397
																																			=
																																			MAKE_YOUNG_PAIR
																																			(CNST_TABLE_REF
																																			(((long)
																																					7)),
																																			BgL_arg1502z00_1398);
																																	}
																																	BgL_arg1484z00_1396
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_arg1500z00_1397,
																																		BNIL);
																																}
																																BgL_arg1446z00_1394
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BGl_string1837z00zzengine_heapz00,
																																	BgL_arg1484z00_1396);
																															}
																															BgL_arg1436z00_1392
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg1445z00_1393,
																																BgL_arg1446z00_1394);
																														}
																														BgL_arg1372z00_1388
																															=
																															MAKE_YOUNG_PAIR
																															(BGl_string1838z00zzengine_heapz00,
																															BgL_arg1436z00_1392);
																													}
																													BgL_arg1369z00_1385 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg1371z00_1387,
																														BgL_arg1372z00_1388);
																												}
																												BgL_arg1367z00_1383 =
																													MAKE_YOUNG_PAIR
																													(BgL_arg1368z00_1384,
																													BgL_arg1369z00_1385);
																											}
																											BgL_arg1354z00_1378 =
																												MAKE_YOUNG_PAIR
																												(BGl_string1838z00zzengine_heapz00,
																												BgL_arg1367z00_1383);
																										}
																										BgL_arg1350z00_1376 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1353z00_1377,
																											BgL_arg1354z00_1378);
																									}
																									BgL_arg1346z00_1374 =
																										MAKE_YOUNG_PAIR
																										(BGl_string1838z00zzengine_heapz00,
																										BgL_arg1350z00_1376);
																								}
																								BgL_arg1343z00_1372 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1344z00_1373,
																									BgL_arg1346z00_1374);
																							}
																							BgL_arg1338z00_1370 =
																								MAKE_YOUNG_PAIR
																								(BGl_string1838z00zzengine_heapz00,
																								BgL_arg1343z00_1372);
																						}
																						BgL_arg1335z00_1368 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1336z00_1369,
																							BgL_arg1338z00_1370);
																					}
																					BgL_arg1332z00_1367 =
																						MAKE_YOUNG_PAIR
																						(BGl_string1838z00zzengine_heapz00,
																						BgL_arg1335z00_1368);
																				}
																				BgL_arg1329z00_1365 =
																					MAKE_YOUNG_PAIR(BgL_arg1331z00_1366,
																					BgL_arg1332z00_1367);
																			}
																			BgL_arg1317z00_1364 =
																				MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long)
																						8)), BgL_arg1329z00_1365);
																		}
																		bgl_display_obj(BgL_arg1317z00_1364,
																			BgL_port1203z00_1363);
																	}
																	bgl_display_char(((unsigned char) 10),
																		BgL_port1203z00_1363);
																}
															else
																{	/* Engine/heap.scm 131 */
																	if (BGl_isazf3zf3zz__objectz00(
																			((obj_t) BgL_valz00_1362),
																			BGl_cfunz00zzast_varz00))
																		{	/* Engine/heap.scm 149 */
																			obj_t BgL_port1210z00_1412;

																			{	/* Engine/heap.scm 149 */
																				obj_t BgL_tmpz00_1833;

																				BgL_tmpz00_1833 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_port1210z00_1412 =
																					BGL_ENV_CURRENT_OUTPUT_PORT
																					(BgL_tmpz00_1833);
																			}
																			bgl_display_string
																				(BGl_string1834z00zzengine_heapz00,
																				BgL_port1210z00_1412);
																			{	/* Engine/heap.scm 150 */
																				obj_t BgL_arg1540z00_1413;

																				{	/* Engine/heap.scm 150 */
																					obj_t BgL_arg1542z00_1414;

																					{	/* Engine/heap.scm 150 */
																						obj_t BgL_arg1543z00_1415;
																						obj_t BgL_arg1546z00_1416;

																						BgL_arg1543z00_1415 =
																							BGl_shapez00zztools_shapez00
																							(BgL_newz00_1357);
																						{	/* Engine/heap.scm 152 */
																							obj_t BgL_arg1547z00_1417;

																							{	/* Engine/heap.scm 152 */
																								obj_t BgL_arg1551z00_1418;
																								obj_t BgL_arg1555z00_1419;

																								{	/* Engine/heap.scm 152 */
																									obj_t BgL_arg1557z00_1420;

																									BgL_arg1557z00_1420 =
																										MAKE_YOUNG_PAIR
																										(BgL_idz00_1359, BNIL);
																									BgL_arg1551z00_1418 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long) 0)),
																										BgL_arg1557z00_1420);
																								}
																								{	/* Engine/heap.scm 154 */
																									obj_t BgL_arg1558z00_1421;

																									{	/* Engine/heap.scm 154 */
																										obj_t BgL_arg1559z00_1422;
																										obj_t BgL_arg1560z00_1423;

																										{	/* Engine/heap.scm 154 */
																											obj_t BgL_arg1561z00_1424;

																											BgL_arg1561z00_1424 =
																												MAKE_YOUNG_PAIR
																												(BgL_modulez00_1358,
																												BNIL);
																											BgL_arg1559z00_1422 =
																												MAKE_YOUNG_PAIR
																												(CNST_TABLE_REF(((long)
																														1)),
																												BgL_arg1561z00_1424);
																										}
																										{	/* Engine/heap.scm 156 */
																											obj_t BgL_arg1563z00_1425;

																											{	/* Engine/heap.scm 156 */
																												obj_t
																													BgL_arg1568z00_1426;
																												obj_t
																													BgL_arg1569z00_1427;
																												{	/* Engine/heap.scm 156 */
																													obj_t
																														BgL_arg1571z00_1428;
																													{	/* Engine/heap.scm 156 */
																														obj_t
																															BgL_arg1573z00_1429;
																														{	/* Engine/heap.scm 156 */
																															obj_t
																																BgL_arg1579z00_1430;
																															BgL_arg1579z00_1430
																																=
																																(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) BgL_newz00_1357))))->BgL_namez00);
																															{	/* Engine/heap.scm 156 */
																																obj_t
																																	BgL_list1580z00_1431;
																																BgL_list1580z00_1431
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1579z00_1430,
																																	BNIL);
																																BgL_arg1573z00_1429
																																	=
																																	BGl_formatz00zz__r4_output_6_10_3z00
																																	(BGl_string1835z00zzengine_heapz00,
																																	BgL_list1580z00_1431);
																														}}
																														BgL_arg1571z00_1428
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1573z00_1429,
																															BNIL);
																													}
																													BgL_arg1568z00_1426 =
																														MAKE_YOUNG_PAIR
																														(CNST_TABLE_REF((
																																(long) 2)),
																														BgL_arg1571z00_1428);
																												}
																												{	/* Engine/heap.scm 158 */
																													obj_t
																														BgL_arg1582z00_1432;
																													{	/* Engine/heap.scm 158 */
																														obj_t
																															BgL_arg1583z00_1433;
																														obj_t
																															BgL_arg1584z00_1434;
																														{	/* Engine/heap.scm 158 */
																															obj_t
																																BgL_arg1585z00_1435;
																															BgL_arg1585z00_1435
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_qtz00_1360,
																																BNIL);
																															BgL_arg1583z00_1433
																																=
																																MAKE_YOUNG_PAIR
																																(CNST_TABLE_REF(
																																	((long) 3)),
																																BgL_arg1585z00_1435);
																														}
																														{	/* Engine/heap.scm 160 */
																															obj_t
																																BgL_arg1597z00_1436;
																															{	/* Engine/heap.scm 160 */
																																obj_t
																																	BgL_arg1598z00_1437;
																																obj_t
																																	BgL_arg1599z00_1438;
																																{	/* Engine/heap.scm 160 */
																																	obj_t
																																		BgL_arg1600z00_1439;
																																	BgL_arg1600z00_1439
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_jtz00_1361,
																																		BNIL);
																																	BgL_arg1598z00_1437
																																		=
																																		MAKE_YOUNG_PAIR
																																		(CNST_TABLE_REF
																																		(((long)
																																				6)),
																																		BgL_arg1600z00_1439);
																																}
																																{	/* Engine/heap.scm 161 */
																																	obj_t
																																		BgL_arg1603z00_1440;
																																	{	/* Engine/heap.scm 161 */
																																		obj_t
																																			BgL_arg1604z00_1441;
																																		{	/* Engine/heap.scm 161 */
																																			obj_t
																																				BgL_arg1605z00_1442;
																																			{	/* Engine/heap.scm 161 */
																																				obj_t
																																					BgL_arg1612z00_1443;
																																				{	/* Engine/heap.scm 161 */
																																					obj_t
																																						BgL_l1204z00_1444;
																																					BgL_l1204z00_1444
																																						=
																																						(((BgL_cfunz00_bglt) COBJECT(((BgL_cfunz00_bglt) BgL_valz00_1362)))->BgL_argszd2typezd2);
																																					if (NULLP(BgL_l1204z00_1444))
																																						{	/* Engine/heap.scm 161 */
																																							BgL_arg1612z00_1443
																																								=
																																								BNIL;
																																						}
																																					else
																																						{	/* Engine/heap.scm 161 */
																																							obj_t
																																								BgL_head1206z00_1445;
																																							{	/* Engine/heap.scm 161 */
																																								obj_t
																																									BgL_arg1638z00_1446;
																																								{	/* Engine/heap.scm 161 */
																																									obj_t
																																										BgL_arg1643z00_1447;
																																									BgL_arg1643z00_1447
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_l1204z00_1444));
																																									BgL_arg1638z00_1446
																																										=
																																										BGl_shapez00zztools_shapez00
																																										(BgL_arg1643z00_1447);
																																								}
																																								BgL_head1206z00_1445
																																									=
																																									MAKE_YOUNG_PAIR
																																									(BgL_arg1638z00_1446,
																																									BNIL);
																																							}
																																							{	/* Engine/heap.scm 161 */
																																								obj_t
																																									BgL_g1209z00_1448;
																																								BgL_g1209z00_1448
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_l1204z00_1444));
																																								{
																																									obj_t
																																										BgL_l1204z00_1450;
																																									obj_t
																																										BgL_tail1207z00_1451;
																																									BgL_l1204z00_1450
																																										=
																																										BgL_g1209z00_1448;
																																									BgL_tail1207z00_1451
																																										=
																																										BgL_head1206z00_1445;
																																								BgL_zc3z04anonymousza31614ze3z87_1449:
																																									if (NULLP(BgL_l1204z00_1450))
																																										{	/* Engine/heap.scm 161 */
																																											BgL_arg1612z00_1443
																																												=
																																												BgL_head1206z00_1445;
																																										}
																																									else
																																										{	/* Engine/heap.scm 161 */
																																											obj_t
																																												BgL_newtail1208z00_1452;
																																											{	/* Engine/heap.scm 161 */
																																												obj_t
																																													BgL_arg1633z00_1453;
																																												{	/* Engine/heap.scm 161 */
																																													obj_t
																																														BgL_arg1634z00_1454;
																																													BgL_arg1634z00_1454
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_l1204z00_1450));
																																													BgL_arg1633z00_1453
																																														=
																																														BGl_shapez00zztools_shapez00
																																														(BgL_arg1634z00_1454);
																																												}
																																												BgL_newtail1208z00_1452
																																													=
																																													MAKE_YOUNG_PAIR
																																													(BgL_arg1633z00_1453,
																																													BNIL);
																																											}
																																											SET_CDR
																																												(BgL_tail1207z00_1451,
																																												BgL_newtail1208z00_1452);
																																											{	/* Engine/heap.scm 161 */
																																												obj_t
																																													BgL_arg1616z00_1455;
																																												BgL_arg1616z00_1455
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_l1204z00_1450));
																																												{
																																													obj_t
																																														BgL_tail1207z00_1878;
																																													obj_t
																																														BgL_l1204z00_1877;
																																													BgL_l1204z00_1877
																																														=
																																														BgL_arg1616z00_1455;
																																													BgL_tail1207z00_1878
																																														=
																																														BgL_newtail1208z00_1452;
																																													BgL_tail1207z00_1451
																																														=
																																														BgL_tail1207z00_1878;
																																													BgL_l1204z00_1450
																																														=
																																														BgL_l1204z00_1877;
																																													goto
																																														BgL_zc3z04anonymousza31614ze3z87_1449;
																																												}
																																											}
																																										}
																																								}
																																							}
																																						}
																																				}
																																				BgL_arg1605z00_1442
																																					=
																																					MAKE_YOUNG_PAIR
																																					(BgL_arg1612z00_1443,
																																					BNIL);
																																			}
																																			BgL_arg1604z00_1441
																																				=
																																				MAKE_YOUNG_PAIR
																																				(CNST_TABLE_REF
																																				(((long)
																																						7)),
																																				BgL_arg1605z00_1442);
																																		}
																																		BgL_arg1603z00_1440
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1604z00_1441,
																																			BNIL);
																																	}
																																	BgL_arg1599z00_1438
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_string1837z00zzengine_heapz00,
																																		BgL_arg1603z00_1440);
																																}
																																BgL_arg1597z00_1436
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1598z00_1437,
																																	BgL_arg1599z00_1438);
																															}
																															BgL_arg1584z00_1434
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_string1838z00zzengine_heapz00,
																																BgL_arg1597z00_1436);
																														}
																														BgL_arg1582z00_1432
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1583z00_1433,
																															BgL_arg1584z00_1434);
																													}
																													BgL_arg1569z00_1427 =
																														MAKE_YOUNG_PAIR
																														(BGl_string1838z00zzengine_heapz00,
																														BgL_arg1582z00_1432);
																												}
																												BgL_arg1563z00_1425 =
																													MAKE_YOUNG_PAIR
																													(BgL_arg1568z00_1426,
																													BgL_arg1569z00_1427);
																											}
																											BgL_arg1560z00_1423 =
																												MAKE_YOUNG_PAIR
																												(BGl_string1838z00zzengine_heapz00,
																												BgL_arg1563z00_1425);
																										}
																										BgL_arg1558z00_1421 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1559z00_1422,
																											BgL_arg1560z00_1423);
																									}
																									BgL_arg1555z00_1419 =
																										MAKE_YOUNG_PAIR
																										(BGl_string1838z00zzengine_heapz00,
																										BgL_arg1558z00_1421);
																								}
																								BgL_arg1547z00_1417 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1551z00_1418,
																									BgL_arg1555z00_1419);
																							}
																							BgL_arg1546z00_1416 =
																								MAKE_YOUNG_PAIR
																								(BGl_string1838z00zzengine_heapz00,
																								BgL_arg1547z00_1417);
																						}
																						BgL_arg1542z00_1414 =
																							MAKE_YOUNG_PAIR
																							(BgL_arg1543z00_1415,
																							BgL_arg1546z00_1416);
																					}
																					BgL_arg1540z00_1413 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 9)),
																						BgL_arg1542z00_1414);
																				}
																				bgl_display_obj(BgL_arg1540z00_1413,
																					BgL_port1210z00_1412);
																			}
																			bgl_display_char(((unsigned char) 10),
																				BgL_port1210z00_1412);
																		}
																	else
																		{	/* Engine/heap.scm 148 */
																			if (
																				((((BgL_typez00_bglt) COBJECT(
																								(((BgL_variablez00_bglt)
																										COBJECT((
																												(BgL_variablez00_bglt) (
																													(BgL_globalz00_bglt)
																													BgL_newz00_1357))))->
																									BgL_typez00)))->BgL_idz00) ==
																					CNST_TABLE_REF(((long) 10))))
																				{	/* Engine/heap.scm 163 */
																					BFALSE;
																				}
																			else
																				{	/* Engine/heap.scm 164 */
																					obj_t BgL_port1211z00_1456;

																					{	/* Engine/heap.scm 164 */
																						obj_t BgL_tmpz00_1906;

																						BgL_tmpz00_1906 =
																							BGL_CURRENT_DYNAMIC_ENV();
																						BgL_port1211z00_1456 =
																							BGL_ENV_CURRENT_OUTPUT_PORT
																							(BgL_tmpz00_1906);
																					}
																					bgl_display_string
																						(BGl_string1834z00zzengine_heapz00,
																						BgL_port1211z00_1456);
																					{	/* Engine/heap.scm 165 */
																						obj_t BgL_arg1649z00_1457;

																						{	/* Engine/heap.scm 165 */
																							obj_t BgL_arg1655z00_1458;

																							{	/* Engine/heap.scm 165 */
																								obj_t BgL_arg1659z00_1459;
																								obj_t BgL_arg1662z00_1460;

																								BgL_arg1659z00_1459 =
																									BGl_shapez00zztools_shapez00
																									(BgL_newz00_1357);
																								{	/* Engine/heap.scm 167 */
																									obj_t BgL_arg1663z00_1461;

																									{	/* Engine/heap.scm 167 */
																										obj_t BgL_arg1664z00_1462;
																										obj_t BgL_arg1666z00_1463;

																										{	/* Engine/heap.scm 167 */
																											obj_t BgL_arg1672z00_1464;

																											BgL_arg1672z00_1464 =
																												MAKE_YOUNG_PAIR
																												(BgL_idz00_1359, BNIL);
																											BgL_arg1664z00_1462 =
																												MAKE_YOUNG_PAIR
																												(CNST_TABLE_REF(((long)
																														0)),
																												BgL_arg1672z00_1464);
																										}
																										{	/* Engine/heap.scm 169 */
																											obj_t BgL_arg1673z00_1465;

																											{	/* Engine/heap.scm 169 */
																												obj_t
																													BgL_arg1675z00_1466;
																												obj_t
																													BgL_arg1676z00_1467;
																												{	/* Engine/heap.scm 169 */
																													obj_t
																														BgL_arg1679z00_1468;
																													BgL_arg1679z00_1468 =
																														MAKE_YOUNG_PAIR
																														(BgL_modulez00_1358,
																														BNIL);
																													BgL_arg1675z00_1466 =
																														MAKE_YOUNG_PAIR
																														(CNST_TABLE_REF((
																																(long) 1)),
																														BgL_arg1679z00_1468);
																												}
																												{	/* Engine/heap.scm 171 */
																													obj_t
																														BgL_arg1682z00_1469;
																													{	/* Engine/heap.scm 171 */
																														obj_t
																															BgL_arg1685z00_1470;
																														obj_t
																															BgL_arg1686z00_1471;
																														{	/* Engine/heap.scm 171 */
																															obj_t
																																BgL_arg1690z00_1472;
																															{	/* Engine/heap.scm 171 */
																																obj_t
																																	BgL_arg1691z00_1473;
																																{	/* Engine/heap.scm 171 */
																																	obj_t
																																		BgL_arg1695z00_1474;
																																	BgL_arg1695z00_1474
																																		=
																																		(((BgL_variablez00_bglt) COBJECT(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) BgL_newz00_1357))))->BgL_namez00);
																																	{	/* Engine/heap.scm 171 */
																																		obj_t
																																			BgL_list1696z00_1475;
																																		BgL_list1696z00_1475
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1695z00_1474,
																																			BNIL);
																																		BgL_arg1691z00_1473
																																			=
																																			BGl_formatz00zz__r4_output_6_10_3z00
																																			(BGl_string1835z00zzengine_heapz00,
																																			BgL_list1696z00_1475);
																																}}
																																BgL_arg1690z00_1472
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1691z00_1473,
																																	BNIL);
																															}
																															BgL_arg1685z00_1470
																																=
																																MAKE_YOUNG_PAIR
																																(CNST_TABLE_REF(
																																	((long) 2)),
																																BgL_arg1690z00_1472);
																														}
																														{	/* Engine/heap.scm 173 */
																															obj_t
																																BgL_arg1697z00_1476;
																															{	/* Engine/heap.scm 173 */
																																obj_t
																																	BgL_arg1699z00_1477;
																																obj_t
																																	BgL_arg1702z00_1478;
																																{	/* Engine/heap.scm 173 */
																																	obj_t
																																		BgL_arg1704z00_1479;
																																	BgL_arg1704z00_1479
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_qtz00_1360,
																																		BNIL);
																																	BgL_arg1699z00_1477
																																		=
																																		MAKE_YOUNG_PAIR
																																		(CNST_TABLE_REF
																																		(((long)
																																				3)),
																																		BgL_arg1704z00_1479);
																																}
																																{	/* Engine/heap.scm 175 */
																																	obj_t
																																		BgL_arg1710z00_1480;
																																	{	/* Engine/heap.scm 175 */
																																		obj_t
																																			BgL_arg1717z00_1481;
																																		{	/* Engine/heap.scm 175 */
																																			obj_t
																																				BgL_arg1718z00_1482;
																																			BgL_arg1718z00_1482
																																				=
																																				MAKE_YOUNG_PAIR
																																				(BgL_jtz00_1361,
																																				BNIL);
																																			BgL_arg1717z00_1481
																																				=
																																				MAKE_YOUNG_PAIR
																																				(CNST_TABLE_REF
																																				(((long)
																																						6)),
																																				BgL_arg1718z00_1482);
																																		}
																																		BgL_arg1710z00_1480
																																			=
																																			MAKE_YOUNG_PAIR
																																			(BgL_arg1717z00_1481,
																																			BNIL);
																																	}
																																	BgL_arg1702z00_1478
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_string1838z00zzengine_heapz00,
																																		BgL_arg1710z00_1480);
																																}
																																BgL_arg1697z00_1476
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_arg1699z00_1477,
																																	BgL_arg1702z00_1478);
																															}
																															BgL_arg1686z00_1471
																																=
																																MAKE_YOUNG_PAIR
																																(BGl_string1838z00zzengine_heapz00,
																																BgL_arg1697z00_1476);
																														}
																														BgL_arg1682z00_1469
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg1685z00_1470,
																															BgL_arg1686z00_1471);
																													}
																													BgL_arg1676z00_1467 =
																														MAKE_YOUNG_PAIR
																														(BGl_string1838z00zzengine_heapz00,
																														BgL_arg1682z00_1469);
																												}
																												BgL_arg1673z00_1465 =
																													MAKE_YOUNG_PAIR
																													(BgL_arg1675z00_1466,
																													BgL_arg1676z00_1467);
																											}
																											BgL_arg1666z00_1463 =
																												MAKE_YOUNG_PAIR
																												(BGl_string1838z00zzengine_heapz00,
																												BgL_arg1673z00_1465);
																										}
																										BgL_arg1663z00_1461 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg1664z00_1462,
																											BgL_arg1666z00_1463);
																									}
																									BgL_arg1662z00_1460 =
																										MAKE_YOUNG_PAIR
																										(BGl_string1838z00zzengine_heapz00,
																										BgL_arg1663z00_1461);
																								}
																								BgL_arg1655z00_1458 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg1659z00_1459,
																									BgL_arg1662z00_1460);
																							}
																							BgL_arg1649z00_1457 =
																								MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																										(long) 11)),
																								BgL_arg1655z00_1458);
																						}
																						bgl_display_obj(BgL_arg1649z00_1457,
																							BgL_port1211z00_1456);
																					}
																					bgl_display_char(((unsigned char) 10),
																						BgL_port1211z00_1456);
									}}}}}}}}}
									{
										obj_t BgL_l1212z00_1947;

										BgL_l1212z00_1947 = CDR(BgL_l1212z00_1485);
										BgL_l1212z00_1485 = BgL_l1212z00_1947;
										goto BgL_zc3z04anonymousza31310ze3z87_1484;
									}
								}
							else
								{	/* Engine/heap.scm 178 */
									BgL_tmpz00_1733 = ((bool_t) 1);
								}
						}
					}
				}
				return BBOOL(BgL_tmpz00_1733);
			}
		}

	}



/* dump-Tenv */
	obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t BgL_tenvz00_6)
	{
		{	/* Engine/heap.scm 183 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_6,
				BGl_proc1839z00zzengine_heapz00);
		}

	}



/* &<@anonymous:1722> */
	obj_t BGl_z62zc3z04anonymousza31722ze3ze5zzengine_heapz00(obj_t
		BgL_envz00_1321, obj_t BgL_kz00_1322, obj_t BgL_newz00_1323)
	{
		{	/* Engine/heap.scm 185 */
			{	/* Engine/heap.scm 186 */
				obj_t BgL_idz00_1486;

				BgL_idz00_1486 =
					(((BgL_typez00_bglt) COBJECT(
							((BgL_typez00_bglt) BgL_newz00_1323)))->BgL_idz00);
				{	/* Engine/heap.scm 186 */
					obj_t BgL_namez00_1487;

					BgL_namez00_1487 =
						(((BgL_typez00_bglt) COBJECT(
								((BgL_typez00_bglt) BgL_newz00_1323)))->BgL_namez00);
					{	/* Engine/heap.scm 187 */

						if (BGl_isazf3zf3zz__objectz00(BgL_newz00_1323,
								BGl_tclassz00zzobject_classz00))
							{	/* Engine/heap.scm 190 */
								obj_t BgL_port1221z00_1488;

								{	/* Engine/heap.scm 190 */
									obj_t BgL_tmpz00_1957;

									BgL_tmpz00_1957 = BGL_CURRENT_DYNAMIC_ENV();
									BgL_port1221z00_1488 =
										BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1957);
								}
								bgl_display_string(BGl_string1834z00zzengine_heapz00,
									BgL_port1221z00_1488);
								{	/* Engine/heap.scm 191 */
									obj_t BgL_arg1724z00_1489;

									{	/* Engine/heap.scm 191 */
										obj_t BgL_arg1725z00_1490;

										{	/* Engine/heap.scm 191 */
											obj_t BgL_arg1732z00_1491;
											obj_t BgL_arg1733z00_1492;

											BgL_arg1732z00_1491 =
												BGl_shapez00zztools_shapez00(BgL_newz00_1323);
											{	/* Engine/heap.scm 192 */
												obj_t BgL_arg1734z00_1493;
												obj_t BgL_arg1735z00_1494;

												{	/* Engine/heap.scm 192 */
													obj_t BgL_arg1736z00_1495;

													{	/* Engine/heap.scm 192 */
														obj_t BgL_arg1737z00_1496;

														{	/* Engine/heap.scm 192 */
															obj_t BgL_arg1739z00_1497;

															{
																BgL_tclassz00_bglt BgL_auxz00_1962;

																{
																	obj_t BgL_auxz00_1963;

																	{	/* Engine/heap.scm 192 */
																		BgL_objectz00_bglt BgL_tmpz00_1964;

																		BgL_tmpz00_1964 =
																			((BgL_objectz00_bglt)
																			((BgL_typez00_bglt) BgL_newz00_1323));
																		BgL_auxz00_1963 =
																			BGL_OBJECT_WIDENING(BgL_tmpz00_1964);
																	}
																	BgL_auxz00_1962 =
																		((BgL_tclassz00_bglt) BgL_auxz00_1963);
																}
																BgL_arg1739z00_1497 =
																	(((BgL_tclassz00_bglt)
																		COBJECT(BgL_auxz00_1962))->
																	BgL_itszd2superzd2);
															}
															BgL_arg1737z00_1496 =
																BGl_shapez00zztools_shapez00
																(BgL_arg1739z00_1497);
														}
														BgL_arg1736z00_1495 =
															MAKE_YOUNG_PAIR(BgL_arg1737z00_1496, BNIL);
													}
													BgL_arg1734z00_1493 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
														BgL_arg1736z00_1495);
												}
												{	/* Engine/heap.scm 193 */
													obj_t BgL_arg1740z00_1498;

													{	/* Engine/heap.scm 193 */
														obj_t BgL_l1215z00_1499;

														{
															BgL_tclassz00_bglt BgL_auxz00_1974;

															{
																obj_t BgL_auxz00_1975;

																{	/* Engine/heap.scm 193 */
																	BgL_objectz00_bglt BgL_tmpz00_1976;

																	BgL_tmpz00_1976 =
																		((BgL_objectz00_bglt)
																		((BgL_typez00_bglt) BgL_newz00_1323));
																	BgL_auxz00_1975 =
																		BGL_OBJECT_WIDENING(BgL_tmpz00_1976);
																}
																BgL_auxz00_1974 =
																	((BgL_tclassz00_bglt) BgL_auxz00_1975);
															}
															BgL_l1215z00_1499 =
																(((BgL_tclassz00_bglt)
																	COBJECT(BgL_auxz00_1974))->BgL_slotsz00);
														}
														if (NULLP(BgL_l1215z00_1499))
															{	/* Engine/heap.scm 193 */
																BgL_arg1740z00_1498 = BNIL;
															}
														else
															{	/* Engine/heap.scm 193 */
																obj_t BgL_head1217z00_1500;

																{	/* Engine/heap.scm 193 */
																	obj_t BgL_arg1751z00_1501;

																	{	/* Engine/heap.scm 193 */
																		obj_t BgL_arg1753z00_1502;

																		BgL_arg1753z00_1502 =
																			CAR(((obj_t) BgL_l1215z00_1499));
																		BgL_arg1751z00_1501 =
																			BGl_shapez00zztools_shapez00
																			(BgL_arg1753z00_1502);
																	}
																	BgL_head1217z00_1500 =
																		MAKE_YOUNG_PAIR(BgL_arg1751z00_1501, BNIL);
																}
																{	/* Engine/heap.scm 193 */
																	obj_t BgL_g1220z00_1503;

																	BgL_g1220z00_1503 =
																		CDR(((obj_t) BgL_l1215z00_1499));
																	{
																		obj_t BgL_l1215z00_1505;
																		obj_t BgL_tail1218z00_1506;

																		BgL_l1215z00_1505 = BgL_g1220z00_1503;
																		BgL_tail1218z00_1506 = BgL_head1217z00_1500;
																	BgL_zc3z04anonymousza31742ze3z87_1504:
																		if (NULLP(BgL_l1215z00_1505))
																			{	/* Engine/heap.scm 193 */
																				BgL_arg1740z00_1498 =
																					BgL_head1217z00_1500;
																			}
																		else
																			{	/* Engine/heap.scm 193 */
																				obj_t BgL_newtail1219z00_1507;

																				{	/* Engine/heap.scm 193 */
																					obj_t BgL_arg1746z00_1508;

																					{	/* Engine/heap.scm 193 */
																						obj_t BgL_arg1747z00_1509;

																						BgL_arg1747z00_1509 =
																							CAR(((obj_t) BgL_l1215z00_1505));
																						BgL_arg1746z00_1508 =
																							BGl_shapez00zztools_shapez00
																							(BgL_arg1747z00_1509);
																					}
																					BgL_newtail1219z00_1507 =
																						MAKE_YOUNG_PAIR(BgL_arg1746z00_1508,
																						BNIL);
																				}
																				SET_CDR(BgL_tail1218z00_1506,
																					BgL_newtail1219z00_1507);
																				{	/* Engine/heap.scm 193 */
																					obj_t BgL_arg1744z00_1510;

																					BgL_arg1744z00_1510 =
																						CDR(((obj_t) BgL_l1215z00_1505));
																					{
																						obj_t BgL_tail1218z00_2000;
																						obj_t BgL_l1215z00_1999;

																						BgL_l1215z00_1999 =
																							BgL_arg1744z00_1510;
																						BgL_tail1218z00_2000 =
																							BgL_newtail1219z00_1507;
																						BgL_tail1218z00_1506 =
																							BgL_tail1218z00_2000;
																						BgL_l1215z00_1505 =
																							BgL_l1215z00_1999;
																						goto
																							BgL_zc3z04anonymousza31742ze3z87_1504;
																					}
																				}
																			}
																	}
																}
															}
													}
													BgL_arg1735z00_1494 =
														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg1740z00_1498, BNIL);
												}
												BgL_arg1733z00_1492 =
													MAKE_YOUNG_PAIR(BgL_arg1734z00_1493,
													BgL_arg1735z00_1494);
											}
											BgL_arg1725z00_1490 =
												MAKE_YOUNG_PAIR(BgL_arg1732z00_1491,
												BgL_arg1733z00_1492);
										}
										BgL_arg1724z00_1489 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 10)),
											BgL_arg1725z00_1490);
									}
									bgl_display_obj(BgL_arg1724z00_1489, BgL_port1221z00_1488);
								}
								return
									bgl_display_char(((unsigned char) 10), BgL_port1221z00_1488);
							}
						else
							{	/* Engine/heap.scm 194 */
								obj_t BgL_port1222z00_1511;

								{	/* Engine/heap.scm 194 */
									obj_t BgL_tmpz00_2008;

									BgL_tmpz00_2008 = BGL_CURRENT_DYNAMIC_ENV();
									BgL_port1222z00_1511 =
										BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2008);
								}
								bgl_display_string(BGl_string1834z00zzengine_heapz00,
									BgL_port1222z00_1511);
								{	/* Engine/heap.scm 194 */
									obj_t BgL_arg1755z00_1512;

									{	/* Engine/heap.scm 194 */
										obj_t BgL_arg1759z00_1513;

										{	/* Engine/heap.scm 194 */
											obj_t BgL_arg1760z00_1514;

											{	/* Engine/heap.scm 194 */
												obj_t BgL_arg1764z00_1515;

												{	/* Engine/heap.scm 194 */
													obj_t BgL_arg1774z00_1516;

													BgL_arg1774z00_1516 =
														MAKE_YOUNG_PAIR(BgL_namez00_1487, BNIL);
													BgL_arg1764z00_1515 =
														MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 2)),
														BgL_arg1774z00_1516);
												}
												BgL_arg1760z00_1514 =
													MAKE_YOUNG_PAIR(BgL_arg1764z00_1515, BNIL);
											}
											BgL_arg1759z00_1513 =
												MAKE_YOUNG_PAIR(BgL_idz00_1486, BgL_arg1760z00_1514);
										}
										BgL_arg1755z00_1512 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 13)),
											BgL_arg1759z00_1513);
									}
									bgl_display_obj(BgL_arg1755z00_1512, BgL_port1222z00_1511);
								}
								return
									bgl_display_char(((unsigned char) 10), BgL_port1222z00_1511);
		}}}}}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00()
	{
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzheap_restorez00(((long) 147989063),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(((long) 433305536),
				BSTRING_TO_STRING(BGl_string1840z00zzengine_heapz00));
		}

	}

#ifdef __cplusplus
}
#endif
