/*===========================================================================*/
/*   (Sync/failsafe.scm)                                                     */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Sync/failsafe.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	BGL_EXPORTED_DECL obj_t
		BGl_failsafezd2synczf3z21zzsync_failsafez00(BgL_syncz00_bglt);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzsync_failsafez00 = BUNSPEC;
	extern obj_t BGl_funz00zzast_varz00;
	static obj_t BGl_z62failsafezd2funzf3zd2sfun1295z91zzsync_failsafez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62failsafezf3zd2sequence1287z43zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_failsafezd2funzf3z21zzsync_failsafez00(BgL_funz00_bglt,
		BgL_variablez00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_toplevelzd2initzd2zzsync_failsafez00();
	static obj_t BGl_z62failsafezf3zd2extern1299z43zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzsync_failsafez00();
	static obj_t BGl_objectzd2initzd2zzsync_failsafez00();
	extern obj_t BGl_castz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2pragma1301z43zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzsync_failsafez00();
	static obj_t BGl_z62failsafezf3zd2var1283z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2atom1281z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62failsafezf3zd2letzd2fun1311z91zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	extern obj_t BGl_pragmaz00zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2kwote1285z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62failsafezf3zd2app1291z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	static obj_t BGl_z62failsafezd2funzf3zd2cfun1297z91zzsync_failsafez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzsync_failsafez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_cplibz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	static obj_t BGl_z62failsafezf3zd2boxzd2setz121319z83zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62failsafezf3zd2cast1303z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2makezd2box1315z91zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	static obj_t BGl_z62failsafezf3zd2setq1305z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_za2optimzd2synczd2failsafezf3za2zf3zzengine_paramz00;
	static obj_t BGl_cnstzd2initzd2zzsync_failsafez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzsync_failsafez00();
	static obj_t BGl_z62failsafezf3z91zzsync_failsafez00(obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzsync_failsafez00();
	static obj_t BGl_gczd2rootszd2initz00zzsync_failsafez00();
	static obj_t BGl_z62failsafezd2funzf3z43zzsync_failsafez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62failsafezf3zd2letzd2var1313z91zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_failsafezf3zf3zzsync_failsafez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2conditiona1307z43zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62failsafezd2funzf31292z43zzsync_failsafez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62failsafezd2synczf3z43zzsync_failsafez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62failsafezf3zd2boxzd2ref1317z91zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_z62failsafezf3zd2sync1289z43zzsync_failsafez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62failsafezf3zd2switch1309z43zzsync_failsafez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_z62failsafezf31278z91zzsync_failsafez00(obj_t, obj_t, obj_t);
	static obj_t __cnst[1];


	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_failsafezf3zd2envz21zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za791787za7,
		BGl_z62failsafezf3z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_failsafezd2funzf3zd2envzf3zzsync_failsafez00,
		BgL_bgl_za762failsafeza7d2fu1788z00,
		BGl_z62failsafezd2funzf3z43zzsync_failsafez00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string1757z00zzsync_failsafez00,
		BgL_bgl_string1757za700za7za7s1789za7, "failsafe?1278", 13);
	      DEFINE_STRING(BGl_string1759z00zzsync_failsafez00,
		BgL_bgl_string1759za700za7za7s1790za7, "failsafe-fun?1292", 17);
	      DEFINE_STRING(BGl_string1761z00zzsync_failsafez00,
		BgL_bgl_string1761za700za7za7s1791za7, "failsafe?", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1756z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3121792z00,
		BGl_z62failsafezf31278z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1758z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7d2fu1793z00,
		BGl_z62failsafezd2funzf31292z43zzsync_failsafez00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string1768z00zzsync_failsafez00,
		BgL_bgl_string1768za700za7za7s1794za7, "failsafe-fun?", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1760z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1795za7,
		BGl_z62failsafezf3zd2atom1281z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1762z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1796za7,
		BGl_z62failsafezf3zd2var1283z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1763z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1797za7,
		BGl_z62failsafezf3zd2kwote1285z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1764z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1798za7,
		BGl_z62failsafezf3zd2sequence1287z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1765z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1799za7,
		BGl_z62failsafezf3zd2sync1289z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1766z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1800za7,
		BGl_z62failsafezf3zd2app1291z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1767z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7d2fu1801z00,
		BGl_z62failsafezd2funzf3zd2sfun1295z91zzsync_failsafez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1769z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7d2fu1802z00,
		BGl_z62failsafezd2funzf3zd2cfun1297z91zzsync_failsafez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_failsafezd2synczf3zd2envzf3zzsync_failsafez00,
		BgL_bgl_za762failsafeza7d2sy1803z00,
		BGl_z62failsafezd2synczf3z43zzsync_failsafez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1770z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1804za7,
		BGl_z62failsafezf3zd2extern1299z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1771z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1805za7,
		BGl_z62failsafezf3zd2pragma1301z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1772z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1806za7,
		BGl_z62failsafezf3zd2cast1303z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1773z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1807za7,
		BGl_z62failsafezf3zd2setq1305z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1774z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1808za7,
		BGl_z62failsafezf3zd2conditiona1307z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1781z00zzsync_failsafez00,
		BgL_bgl_string1781za700za7za7s1809za7, "sync_failsafe", 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1775z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1810za7,
		BGl_z62failsafezf3zd2switch1309z43zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1782z00zzsync_failsafez00,
		BgL_bgl_string1782za700za7za7s1811za7, "fail-safe ", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1776z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1812za7,
		BGl_z62failsafezf3zd2letzd2fun1311z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1777z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1813za7,
		BGl_z62failsafezf3zd2letzd2var1313z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1778z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1814za7,
		BGl_z62failsafezf3zd2makezd2box1315z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1779z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1815za7,
		BGl_z62failsafezf3zd2boxzd2ref1317z91zzsync_failsafez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1780z00zzsync_failsafez00,
		BgL_bgl_za762failsafeza7f3za7d1816za7,
		BGl_z62failsafezf3zd2boxzd2setz121319z83zzsync_failsafez00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zzsync_failsafez00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzsync_failsafez00(long
		BgL_checksumz00_2360, char *BgL_fromz00_2361)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzsync_failsafez00))
				{
					BGl_requirezd2initializa7ationz75zzsync_failsafez00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzsync_failsafez00();
					BGl_libraryzd2moduleszd2initz00zzsync_failsafez00();
					BGl_cnstzd2initzd2zzsync_failsafez00();
					BGl_importedzd2moduleszd2initz00zzsync_failsafez00();
					BGl_genericzd2initzd2zzsync_failsafez00();
					BGl_methodzd2initzd2zzsync_failsafez00();
					return BGl_toplevelzd2initzd2zzsync_failsafez00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"sync_failsafe");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0),
				"sync_failsafe");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			{	/* Sync/failsafe.scm 16 */
				obj_t BgL_cportz00_2279;

				{	/* Sync/failsafe.scm 16 */
					obj_t BgL_stringz00_2287;

					BgL_stringz00_2287 = BGl_string1782z00zzsync_failsafez00;
					{	/* Sync/failsafe.scm 16 */
						obj_t BgL_startz00_2288;

						BgL_startz00_2288 = BINT(((long) 0));
						{	/* Sync/failsafe.scm 16 */
							obj_t BgL_endz00_2289;

							BgL_endz00_2289 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_2287)));
							{	/* Sync/failsafe.scm 16 */

								BgL_cportz00_2279 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_2287, BgL_startz00_2288, BgL_endz00_2289);
				}}}}
				{
					long BgL_iz00_2280;

					BgL_iz00_2280 = ((long) 0);
				BgL_loopz00_2281:
					if ((BgL_iz00_2280 == ((long) -1)))
						{	/* Sync/failsafe.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Sync/failsafe.scm 16 */
							{	/* Sync/failsafe.scm 16 */
								obj_t BgL_arg1786z00_2283;

								{	/* Sync/failsafe.scm 16 */

									{	/* Sync/failsafe.scm 16 */
										obj_t BgL_locationz00_2285;

										BgL_locationz00_2285 = BBOOL(((bool_t) 0));
										{	/* Sync/failsafe.scm 16 */

											BgL_arg1786z00_2283 =
												BGl_readz00zz__readerz00(BgL_cportz00_2279,
												BgL_locationz00_2285);
										}
									}
								}
								{	/* Sync/failsafe.scm 16 */
									int BgL_tmpz00_2391;

									BgL_tmpz00_2391 = (int) (BgL_iz00_2280);
									CNST_TABLE_SET(BgL_tmpz00_2391, BgL_arg1786z00_2283);
							}}
							{	/* Sync/failsafe.scm 16 */
								int BgL_auxz00_2286;

								BgL_auxz00_2286 = (int) ((BgL_iz00_2280 - ((long) 1)));
								{
									long BgL_iz00_2396;

									BgL_iz00_2396 = (long) (BgL_auxz00_2286);
									BgL_iz00_2280 = BgL_iz00_2396;
									goto BgL_loopz00_2281;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			return BUNSPEC;
		}

	}



/* failsafe-sync? */
	BGL_EXPORTED_DEF obj_t
		BGl_failsafezd2synczf3z21zzsync_failsafez00(BgL_syncz00_bglt BgL_nz00_17)
	{
		{	/* Sync/failsafe.scm 45 */
			if (CBOOL(BGl_za2optimzd2synczd2failsafezf3za2zf3zzengine_paramz00))
				{	/* Sync/failsafe.scm 46 */
					return
						BGl_failsafezf3zf3zzsync_failsafez00(
						(((BgL_syncz00_bglt) COBJECT(BgL_nz00_17))->BgL_bodyz00), BNIL);
				}
			else
				{	/* Sync/failsafe.scm 46 */
					return BFALSE;
				}
		}

	}



/* &failsafe-sync? */
	obj_t BGl_z62failsafezd2synczf3z43zzsync_failsafez00(obj_t BgL_envz00_2182,
		obj_t BgL_nz00_2183)
	{
		{	/* Sync/failsafe.scm 45 */
			return
				BGl_failsafezd2synczf3z21zzsync_failsafez00(
				((BgL_syncz00_bglt) BgL_nz00_2183));
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_proc1756z00zzsync_failsafez00, BGl_nodez00zzast_nodez00,
				BGl_string1757z00zzsync_failsafez00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_failsafezd2funzf3zd2envzf3zzsync_failsafez00,
				BGl_proc1758z00zzsync_failsafez00, BGl_funz00zzast_varz00,
				BGl_string1759z00zzsync_failsafez00);
		}

	}



/* &failsafe-fun?1292 */
	obj_t BGl_z62failsafezd2funzf31292z43zzsync_failsafez00(obj_t BgL_envz00_2186,
		obj_t BgL_funz00_2187, obj_t BgL_varz00_2188, obj_t BgL_stkz00_2189)
	{
		{	/* Sync/failsafe.scm 102 */
			return BBOOL(((bool_t) 0));
		}

	}



/* &failsafe?1278 */
	obj_t BGl_z62failsafezf31278z91zzsync_failsafez00(obj_t BgL_envz00_2190,
		obj_t BgL_nz00_2191, obj_t BgL_stkz00_2192)
	{
		{	/* Sync/failsafe.scm 53 */
			return BBOOL(((bool_t) 0));
		}

	}



/* failsafe? */
	obj_t BGl_failsafezf3zf3zzsync_failsafez00(BgL_nodez00_bglt BgL_nz00_18,
		obj_t BgL_stkz00_19)
	{
		{	/* Sync/failsafe.scm 53 */
			{	/* Sync/failsafe.scm 53 */
				obj_t BgL_method1279z00_1692;

				{	/* Sync/failsafe.scm 53 */
					obj_t BgL_res1750z00_2124;

					{	/* Sync/failsafe.scm 53 */
						long BgL_objzd2classzd2numz00_2095;

						BgL_objzd2classzd2numz00_2095 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_18));
						{	/* Sync/failsafe.scm 53 */
							obj_t BgL_arg1791z00_2096;

							BgL_arg1791z00_2096 =
								PROCEDURE_REF(BGl_failsafezf3zd2envz21zzsync_failsafez00,
								(int) (((long) 1)));
							{	/* Sync/failsafe.scm 53 */
								int BgL_offsetz00_2099;

								BgL_offsetz00_2099 = (int) (BgL_objzd2classzd2numz00_2095);
								{	/* Sync/failsafe.scm 53 */
									long BgL_offsetz00_2100;

									BgL_offsetz00_2100 =
										((long) (BgL_offsetz00_2099) - OBJECT_TYPE);
									{	/* Sync/failsafe.scm 53 */
										long BgL_modz00_2101;

										BgL_modz00_2101 =
											(BgL_offsetz00_2100 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Sync/failsafe.scm 53 */
											long BgL_restz00_2103;

											BgL_restz00_2103 =
												(BgL_offsetz00_2100 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Sync/failsafe.scm 53 */

												{	/* Sync/failsafe.scm 53 */
													obj_t BgL_bucketz00_2105;

													BgL_bucketz00_2105 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2096), BgL_modz00_2101);
													BgL_res1750z00_2124 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2105), BgL_restz00_2103);
					}}}}}}}}
					BgL_method1279z00_1692 = BgL_res1750z00_2124;
				}
				return
					PROCEDURE_ENTRY(BgL_method1279z00_1692) (BgL_method1279z00_1692,
					((obj_t) BgL_nz00_18), BgL_stkz00_19, BEOA);
			}
		}

	}



/* &failsafe? */
	obj_t BGl_z62failsafezf3z91zzsync_failsafez00(obj_t BgL_envz00_2193,
		obj_t BgL_nz00_2194, obj_t BgL_stkz00_2195)
	{
		{	/* Sync/failsafe.scm 53 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				((BgL_nodez00_bglt) BgL_nz00_2194), BgL_stkz00_2195);
		}

	}



/* failsafe-fun? */
	obj_t BGl_failsafezd2funzf3z21zzsync_failsafez00(BgL_funz00_bglt
		BgL_funz00_32, BgL_variablez00_bglt BgL_varz00_33, obj_t BgL_stkz00_34)
	{
		{	/* Sync/failsafe.scm 102 */
			{	/* Sync/failsafe.scm 102 */
				obj_t BgL_method1293z00_1693;

				{	/* Sync/failsafe.scm 102 */
					obj_t BgL_res1755z00_2155;

					{	/* Sync/failsafe.scm 102 */
						long BgL_objzd2classzd2numz00_2126;

						BgL_objzd2classzd2numz00_2126 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_funz00_32));
						{	/* Sync/failsafe.scm 102 */
							obj_t BgL_arg1791z00_2127;

							BgL_arg1791z00_2127 =
								PROCEDURE_REF(BGl_failsafezd2funzf3zd2envzf3zzsync_failsafez00,
								(int) (((long) 1)));
							{	/* Sync/failsafe.scm 102 */
								int BgL_offsetz00_2130;

								BgL_offsetz00_2130 = (int) (BgL_objzd2classzd2numz00_2126);
								{	/* Sync/failsafe.scm 102 */
									long BgL_offsetz00_2131;

									BgL_offsetz00_2131 =
										((long) (BgL_offsetz00_2130) - OBJECT_TYPE);
									{	/* Sync/failsafe.scm 102 */
										long BgL_modz00_2132;

										BgL_modz00_2132 =
											(BgL_offsetz00_2131 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Sync/failsafe.scm 102 */
											long BgL_restz00_2134;

											BgL_restz00_2134 =
												(BgL_offsetz00_2131 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Sync/failsafe.scm 102 */

												{	/* Sync/failsafe.scm 102 */
													obj_t BgL_bucketz00_2136;

													BgL_bucketz00_2136 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_2127), BgL_modz00_2132);
													BgL_res1755z00_2155 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_2136), BgL_restz00_2134);
					}}}}}}}}
					BgL_method1293z00_1693 = BgL_res1755z00_2155;
				}
				return
					PROCEDURE_ENTRY(BgL_method1293z00_1693) (BgL_method1293z00_1693,
					((obj_t) BgL_funz00_32),
					((obj_t) BgL_varz00_33), BgL_stkz00_34, BEOA);
			}
		}

	}



/* &failsafe-fun? */
	obj_t BGl_z62failsafezd2funzf3z43zzsync_failsafez00(obj_t BgL_envz00_2196,
		obj_t BgL_funz00_2197, obj_t BgL_varz00_2198, obj_t BgL_stkz00_2199)
	{
		{	/* Sync/failsafe.scm 102 */
			return
				BGl_failsafezd2funzf3z21zzsync_failsafez00(
				((BgL_funz00_bglt) BgL_funz00_2197),
				((BgL_variablez00_bglt) BgL_varz00_2198), BgL_stkz00_2199);
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_atomz00zzast_nodez00,
				BGl_proc1760z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_varz00zzast_nodez00,
				BGl_proc1762z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_kwotez00zzast_nodez00,
				BGl_proc1763z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_sequencez00zzast_nodez00, BGl_proc1764z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_syncz00zzast_nodez00,
				BGl_proc1765z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_appz00zzast_nodez00,
				BGl_proc1766z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezd2funzf3zd2envzf3zzsync_failsafez00,
				BGl_sfunz00zzast_varz00, BGl_proc1767z00zzsync_failsafez00,
				BGl_string1768z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezd2funzf3zd2envzf3zzsync_failsafez00,
				BGl_cfunz00zzast_varz00, BGl_proc1769z00zzsync_failsafez00,
				BGl_string1768z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_externz00zzast_nodez00,
				BGl_proc1770z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_pragmaz00zzast_nodez00,
				BGl_proc1771z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_castz00zzast_nodez00,
				BGl_proc1772z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_setqz00zzast_nodez00,
				BGl_proc1773z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1774z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00, BGl_switchz00zzast_nodez00,
				BGl_proc1775z00zzsync_failsafez00, BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1776z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1777z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1778z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1779z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_failsafezf3zd2envz21zzsync_failsafez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1780z00zzsync_failsafez00,
				BGl_string1761z00zzsync_failsafez00);
		}

	}



/* &failsafe?-box-set!1319 */
	obj_t BGl_z62failsafezf3zd2boxzd2setz121319z83zzsync_failsafez00(obj_t
		BgL_envz00_2219, obj_t BgL_nz00_2220, obj_t BgL_stkz00_2221)
	{
		{	/* Sync/failsafe.scm 216 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_2220)))->BgL_valuez00),
				BgL_stkz00_2221);
		}

	}



/* &failsafe?-box-ref1317 */
	obj_t BGl_z62failsafezf3zd2boxzd2ref1317z91zzsync_failsafez00(obj_t
		BgL_envz00_2222, obj_t BgL_nz00_2223, obj_t BgL_stkz00_2224)
	{
		{	/* Sync/failsafe.scm 210 */
			return BBOOL(((bool_t) 1));
		}

	}



/* &failsafe?-make-box1315 */
	obj_t BGl_z62failsafezf3zd2makezd2box1315z91zzsync_failsafez00(obj_t
		BgL_envz00_2225, obj_t BgL_nz00_2226, obj_t BgL_stkz00_2227)
	{
		{	/* Sync/failsafe.scm 203 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nz00_2226)))->BgL_valuez00),
				BgL_stkz00_2227);
		}

	}



/* &failsafe?-let-var1313 */
	obj_t BGl_z62failsafezf3zd2letzd2var1313z91zzsync_failsafez00(obj_t
		BgL_envz00_2228, obj_t BgL_nz00_2229, obj_t BgL_stkz00_2230)
	{
		{	/* Sync/failsafe.scm 195 */
			{	/* Sync/failsafe.scm 196 */
				bool_t BgL_tmpz00_2504;

				{	/* Sync/failsafe.scm 197 */
					bool_t BgL_test1820z00_2505;

					{	/* Sync/failsafe.scm 197 */
						BgL_nodez00_bglt BgL_arg1582z00_2299;

						BgL_arg1582z00_2299 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_2229)))->BgL_bodyz00);
						BgL_test1820z00_2505 =
							CBOOL(BGl_failsafezf3zf3zzsync_failsafez00(BgL_arg1582z00_2299,
								BgL_stkz00_2230));
					}
					if (BgL_test1820z00_2505)
						{	/* Sync/failsafe.scm 198 */
							obj_t BgL_g1276z00_2300;

							BgL_g1276z00_2300 =
								(((BgL_letzd2varzd2_bglt) COBJECT(
										((BgL_letzd2varzd2_bglt) BgL_nz00_2229)))->BgL_bindingsz00);
							{
								obj_t BgL_l1274z00_2302;

								BgL_l1274z00_2302 = BgL_g1276z00_2300;
							BgL_zc3z04anonymousza31575ze3z87_2301:
								if (NULLP(BgL_l1274z00_2302))
									{	/* Sync/failsafe.scm 198 */
										BgL_tmpz00_2504 = ((bool_t) 1);
									}
								else
									{	/* Sync/failsafe.scm 198 */
										obj_t BgL_nvz00_2303;

										{	/* Sync/failsafe.scm 198 */
											obj_t BgL_bz00_2304;

											BgL_bz00_2304 = CAR(((obj_t) BgL_l1274z00_2302));
											{	/* Sync/failsafe.scm 198 */
												obj_t BgL_arg1580z00_2305;

												BgL_arg1580z00_2305 = CDR(((obj_t) BgL_bz00_2304));
												BgL_nvz00_2303 =
													BGl_failsafezf3zf3zzsync_failsafez00(
													((BgL_nodez00_bglt) BgL_arg1580z00_2305),
													BgL_stkz00_2230);
											}
										}
										if (CBOOL(BgL_nvz00_2303))
											{	/* Sync/failsafe.scm 198 */
												obj_t BgL_arg1579z00_2306;

												BgL_arg1579z00_2306 = CDR(((obj_t) BgL_l1274z00_2302));
												{
													obj_t BgL_l1274z00_2524;

													BgL_l1274z00_2524 = BgL_arg1579z00_2306;
													BgL_l1274z00_2302 = BgL_l1274z00_2524;
													goto BgL_zc3z04anonymousza31575ze3z87_2301;
												}
											}
										else
											{	/* Sync/failsafe.scm 198 */
												BgL_tmpz00_2504 = ((bool_t) 0);
											}
									}
							}
						}
					else
						{	/* Sync/failsafe.scm 197 */
							BgL_tmpz00_2504 = ((bool_t) 0);
						}
				}
				return BBOOL(BgL_tmpz00_2504);
			}
		}

	}



/* &failsafe?-let-fun1311 */
	obj_t BGl_z62failsafezf3zd2letzd2fun1311z91zzsync_failsafez00(obj_t
		BgL_envz00_2231, obj_t BgL_nz00_2232, obj_t BgL_stkz00_2233)
	{
		{	/* Sync/failsafe.scm 187 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_2232)))->BgL_bodyz00),
				BgL_stkz00_2233);
		}

	}



/* &failsafe?-switch1309 */
	obj_t BGl_z62failsafezf3zd2switch1309z43zzsync_failsafez00(obj_t
		BgL_envz00_2234, obj_t BgL_nz00_2235, obj_t BgL_stkz00_2236)
	{
		{	/* Sync/failsafe.scm 179 */
			{	/* Sync/failsafe.scm 180 */
				bool_t BgL_tmpz00_2529;

				{	/* Sync/failsafe.scm 181 */
					bool_t BgL_test1823z00_2530;

					{	/* Sync/failsafe.scm 181 */
						BgL_nodez00_bglt BgL_arg1569z00_2309;

						BgL_arg1569z00_2309 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_2235)))->BgL_testz00);
						BgL_test1823z00_2530 =
							CBOOL(BGl_failsafezf3zf3zzsync_failsafez00(BgL_arg1569z00_2309,
								BgL_stkz00_2236));
					}
					if (BgL_test1823z00_2530)
						{	/* Sync/failsafe.scm 182 */
							obj_t BgL_g1272z00_2310;

							BgL_g1272z00_2310 =
								(((BgL_switchz00_bglt) COBJECT(
										((BgL_switchz00_bglt) BgL_nz00_2235)))->BgL_clausesz00);
							{
								obj_t BgL_l1270z00_2312;

								BgL_l1270z00_2312 = BgL_g1272z00_2310;
							BgL_zc3z04anonymousza31561ze3z87_2311:
								if (NULLP(BgL_l1270z00_2312))
									{	/* Sync/failsafe.scm 182 */
										BgL_tmpz00_2529 = ((bool_t) 1);
									}
								else
									{	/* Sync/failsafe.scm 182 */
										obj_t BgL_nvz00_2313;

										{	/* Sync/failsafe.scm 182 */
											obj_t BgL_cz00_2314;

											BgL_cz00_2314 = CAR(((obj_t) BgL_l1270z00_2312));
											{	/* Sync/failsafe.scm 182 */
												obj_t BgL_arg1568z00_2315;

												BgL_arg1568z00_2315 = CDR(((obj_t) BgL_cz00_2314));
												BgL_nvz00_2313 =
													BGl_failsafezf3zf3zzsync_failsafez00(
													((BgL_nodez00_bglt) BgL_arg1568z00_2315),
													BgL_stkz00_2236);
											}
										}
										if (CBOOL(BgL_nvz00_2313))
											{	/* Sync/failsafe.scm 182 */
												obj_t BgL_arg1563z00_2316;

												BgL_arg1563z00_2316 = CDR(((obj_t) BgL_l1270z00_2312));
												{
													obj_t BgL_l1270z00_2549;

													BgL_l1270z00_2549 = BgL_arg1563z00_2316;
													BgL_l1270z00_2312 = BgL_l1270z00_2549;
													goto BgL_zc3z04anonymousza31561ze3z87_2311;
												}
											}
										else
											{	/* Sync/failsafe.scm 182 */
												BgL_tmpz00_2529 = ((bool_t) 0);
											}
									}
							}
						}
					else
						{	/* Sync/failsafe.scm 181 */
							BgL_tmpz00_2529 = ((bool_t) 0);
						}
				}
				return BBOOL(BgL_tmpz00_2529);
			}
		}

	}



/* &failsafe?-conditiona1307 */
	obj_t BGl_z62failsafezf3zd2conditiona1307z43zzsync_failsafez00(obj_t
		BgL_envz00_2237, obj_t BgL_nz00_2238, obj_t BgL_stkz00_2239)
	{
		{	/* Sync/failsafe.scm 172 */
			{	/* Sync/failsafe.scm 174 */
				obj_t BgL__andtest_1124z00_2318;

				BgL__andtest_1124z00_2318 =
					BGl_failsafezf3zf3zzsync_failsafez00(
					(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_2238)))->BgL_testz00),
					BgL_stkz00_2239);
				if (CBOOL(BgL__andtest_1124z00_2318))
					{	/* Sync/failsafe.scm 174 */
						obj_t BgL__andtest_1125z00_2319;

						BgL__andtest_1125z00_2319 =
							BGl_failsafezf3zf3zzsync_failsafez00(
							(((BgL_conditionalz00_bglt) COBJECT(
										((BgL_conditionalz00_bglt) BgL_nz00_2238)))->BgL_truez00),
							BgL_stkz00_2239);
						if (CBOOL(BgL__andtest_1125z00_2319))
							{	/* Sync/failsafe.scm 174 */
								return
									BGl_failsafezf3zf3zzsync_failsafez00(
									(((BgL_conditionalz00_bglt) COBJECT(
												((BgL_conditionalz00_bglt) BgL_nz00_2238)))->
										BgL_falsez00), BgL_stkz00_2239);
							}
						else
							{	/* Sync/failsafe.scm 174 */
								return BFALSE;
							}
					}
				else
					{	/* Sync/failsafe.scm 174 */
						return BFALSE;
					}
			}
		}

	}



/* &failsafe?-setq1305 */
	obj_t BGl_z62failsafezf3zd2setq1305z43zzsync_failsafez00(obj_t
		BgL_envz00_2240, obj_t BgL_nz00_2241, obj_t BgL_stkz00_2242)
	{
		{	/* Sync/failsafe.scm 165 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_2241)))->BgL_valuez00),
				BgL_stkz00_2242);
		}

	}



/* &failsafe?-cast1303 */
	obj_t BGl_z62failsafezf3zd2cast1303z43zzsync_failsafez00(obj_t
		BgL_envz00_2243, obj_t BgL_nz00_2244, obj_t BgL_stkz00_2245)
	{
		{	/* Sync/failsafe.scm 158 */
			return
				BGl_failsafezf3zf3zzsync_failsafez00(
				(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nz00_2244)))->BgL_argz00),
				BgL_stkz00_2245);
		}

	}



/* &failsafe?-pragma1301 */
	obj_t BGl_z62failsafezf3zd2pragma1301z43zzsync_failsafez00(obj_t
		BgL_envz00_2246, obj_t BgL_nz00_2247, obj_t BgL_stkz00_2248)
	{
		{	/* Sync/failsafe.scm 152 */
			return BBOOL(((bool_t) 0));
		}

	}



/* &failsafe?-extern1299 */
	obj_t BGl_z62failsafezf3zd2extern1299z43zzsync_failsafez00(obj_t
		BgL_envz00_2249, obj_t BgL_nz00_2250, obj_t BgL_stkz00_2251)
	{
		{	/* Sync/failsafe.scm 145 */
			{	/* Sync/failsafe.scm 146 */
				bool_t BgL_tmpz00_2571;

				{	/* Sync/failsafe.scm 147 */
					obj_t BgL_g1268z00_2324;

					BgL_g1268z00_2324 =
						(((BgL_externz00_bglt) COBJECT(
								((BgL_externz00_bglt) BgL_nz00_2250)))->BgL_exprza2za2);
					{
						obj_t BgL_l1266z00_2326;

						BgL_l1266z00_2326 = BgL_g1268z00_2324;
					BgL_zc3z04anonymousza31541ze3z87_2325:
						if (NULLP(BgL_l1266z00_2326))
							{	/* Sync/failsafe.scm 147 */
								BgL_tmpz00_2571 = ((bool_t) 1);
							}
						else
							{	/* Sync/failsafe.scm 147 */
								obj_t BgL_nvz00_2327;

								{	/* Sync/failsafe.scm 147 */
									obj_t BgL_nz00_2328;

									BgL_nz00_2328 = CAR(((obj_t) BgL_l1266z00_2326));
									BgL_nvz00_2327 =
										BGl_failsafezf3zf3zzsync_failsafez00(
										((BgL_nodez00_bglt) BgL_nz00_2328), BgL_stkz00_2251);
								}
								if (CBOOL(BgL_nvz00_2327))
									{	/* Sync/failsafe.scm 147 */
										obj_t BgL_arg1543z00_2329;

										BgL_arg1543z00_2329 = CDR(((obj_t) BgL_l1266z00_2326));
										{
											obj_t BgL_l1266z00_2584;

											BgL_l1266z00_2584 = BgL_arg1543z00_2329;
											BgL_l1266z00_2326 = BgL_l1266z00_2584;
											goto BgL_zc3z04anonymousza31541ze3z87_2325;
										}
									}
								else
									{	/* Sync/failsafe.scm 147 */
										BgL_tmpz00_2571 = ((bool_t) 0);
									}
							}
					}
				}
				return BBOOL(BgL_tmpz00_2571);
			}
		}

	}



/* &failsafe-fun?-cfun1297 */
	obj_t BGl_z62failsafezd2funzf3zd2cfun1297z91zzsync_failsafez00(obj_t
		BgL_envz00_2252, obj_t BgL_funz00_2253, obj_t BgL_varz00_2254,
		obj_t BgL_stkz00_2255)
	{
		{	/* Sync/failsafe.scm 130 */
			{	/* Sync/failsafe.scm 133 */
				bool_t BgL_test1830z00_2586;

				{	/* Sync/failsafe.scm 133 */
					obj_t BgL_tmpz00_2587;

					BgL_tmpz00_2587 =
						(((BgL_funz00_bglt) COBJECT(
								((BgL_funz00_bglt)
									((BgL_cfunz00_bglt) BgL_funz00_2253))))->BgL_failsafez00);
					BgL_test1830z00_2586 = BOOLEANP(BgL_tmpz00_2587);
				}
				if (BgL_test1830z00_2586)
					{	/* Sync/failsafe.scm 133 */
						return
							(((BgL_funz00_bglt) COBJECT(
									((BgL_funz00_bglt)
										((BgL_cfunz00_bglt) BgL_funz00_2253))))->BgL_failsafez00);
					}
				else
					{	/* Sync/failsafe.scm 133 */
						if (BGl_isazf3zf3zz__objectz00(
								((obj_t)
									((BgL_variablez00_bglt) BgL_varz00_2254)),
								BGl_globalz00zzast_varz00))
							{	/* Sync/failsafe.scm 135 */
								{
									obj_t BgL_auxz00_2599;

									{	/* Sync/failsafe.scm 137 */
										bool_t BgL_tmpz00_2602;

										{	/* Sync/failsafe.scm 137 */
											obj_t BgL_tmpz00_2603;

											BgL_tmpz00_2603 =
												BGl_memqz00zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF(
													((long) 0)),
												(((BgL_globalz00_bglt)
														COBJECT(((BgL_globalz00_bglt) (
																	(BgL_variablez00_bglt) BgL_varz00_2254))))->
													BgL_pragmaz00));
											BgL_tmpz00_2602 = PAIRP(BgL_tmpz00_2603);
										}
										BgL_auxz00_2599 = BBOOL(BgL_tmpz00_2602);
									}
									((((BgL_funz00_bglt) COBJECT(
													((BgL_funz00_bglt)
														((BgL_cfunz00_bglt) BgL_funz00_2253))))->
											BgL_failsafez00) = ((obj_t) BgL_auxz00_2599), BUNSPEC);
								}
								return
									(((BgL_funz00_bglt) COBJECT(
											((BgL_funz00_bglt)
												((BgL_cfunz00_bglt) BgL_funz00_2253))))->
									BgL_failsafez00);
							}
						else
							{	/* Sync/failsafe.scm 135 */
								return BFALSE;
							}
					}
			}
		}

	}



/* &failsafe-fun?-sfun1295 */
	obj_t BGl_z62failsafezd2funzf3zd2sfun1295z91zzsync_failsafez00(obj_t
		BgL_envz00_2256, obj_t BgL_funz00_2257, obj_t BgL_varz00_2258,
		obj_t BgL_stkz00_2259)
	{
		{	/* Sync/failsafe.scm 108 */
			if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
						((obj_t)
							((BgL_variablez00_bglt) BgL_varz00_2258)), BgL_stkz00_2259)))
				{	/* Sync/failsafe.scm 111 */
					return BTRUE;
				}
			else
				{	/* Sync/failsafe.scm 113 */
					bool_t BgL_test1833z00_2620;

					{	/* Sync/failsafe.scm 113 */
						obj_t BgL_tmpz00_2621;

						BgL_tmpz00_2621 =
							(((BgL_funz00_bglt) COBJECT(
									((BgL_funz00_bglt)
										((BgL_sfunz00_bglt) BgL_funz00_2257))))->BgL_failsafez00);
						BgL_test1833z00_2620 = BOOLEANP(BgL_tmpz00_2621);
					}
					if (BgL_test1833z00_2620)
						{	/* Sync/failsafe.scm 113 */
							return
								(((BgL_funz00_bglt) COBJECT(
										((BgL_funz00_bglt)
											((BgL_sfunz00_bglt) BgL_funz00_2257))))->BgL_failsafez00);
						}
					else
						{	/* Sync/failsafe.scm 115 */
							bool_t BgL_test1834z00_2629;

							if (BGl_isazf3zf3zz__objectz00(
									((obj_t)
										((BgL_variablez00_bglt) BgL_varz00_2258)),
									BGl_globalz00zzast_varz00))
								{	/* Sync/failsafe.scm 115 */
									bool_t BgL_test1836z00_2634;

									{	/* Sync/failsafe.scm 115 */
										obj_t BgL_arg1521z00_2334;

										BgL_arg1521z00_2334 =
											(((BgL_globalz00_bglt) COBJECT(
													((BgL_globalz00_bglt)
														((BgL_variablez00_bglt) BgL_varz00_2258))))->
											BgL_modulez00);
										BgL_test1836z00_2634 =
											(BgL_arg1521z00_2334 ==
											BGl_za2moduleza2z00zzmodule_modulez00);
									}
									if (BgL_test1836z00_2634)
										{	/* Sync/failsafe.scm 115 */
											BgL_test1834z00_2629 = ((bool_t) 0);
										}
									else
										{	/* Sync/failsafe.scm 115 */
											BgL_test1834z00_2629 = ((bool_t) 1);
										}
								}
							else
								{	/* Sync/failsafe.scm 115 */
									BgL_test1834z00_2629 = ((bool_t) 0);
								}
							if (BgL_test1834z00_2629)
								{	/* Sync/failsafe.scm 115 */
									{
										obj_t BgL_auxz00_2639;

										{	/* Sync/failsafe.scm 118 */
											bool_t BgL_tmpz00_2642;

											{	/* Sync/failsafe.scm 118 */
												obj_t BgL_tmpz00_2643;

												BgL_tmpz00_2643 =
													BGl_memqz00zz__r4_pairs_and_lists_6_3z00
													(CNST_TABLE_REF(((long) 0)),
													(((BgL_globalz00_bglt)
															COBJECT(((BgL_globalz00_bglt) (
																		(BgL_variablez00_bglt) BgL_varz00_2258))))->
														BgL_pragmaz00));
												BgL_tmpz00_2642 = PAIRP(BgL_tmpz00_2643);
											}
											BgL_auxz00_2639 = BBOOL(BgL_tmpz00_2642);
										}
										((((BgL_funz00_bglt) COBJECT(
														((BgL_funz00_bglt)
															((BgL_sfunz00_bglt) BgL_funz00_2257))))->
												BgL_failsafez00) = ((obj_t) BgL_auxz00_2639), BUNSPEC);
									}
									return
										(((BgL_funz00_bglt) COBJECT(
												((BgL_funz00_bglt)
													((BgL_sfunz00_bglt) BgL_funz00_2257))))->
										BgL_failsafez00);
								}
							else
								{	/* Sync/failsafe.scm 122 */
									obj_t BgL_fsafez00_2335;

									{	/* Sync/failsafe.scm 122 */
										obj_t BgL_arg1502z00_2336;
										obj_t BgL_arg1520z00_2337;

										BgL_arg1502z00_2336 =
											(((BgL_sfunz00_bglt) COBJECT(
													((BgL_sfunz00_bglt) BgL_funz00_2257)))->BgL_bodyz00);
										BgL_arg1520z00_2337 =
											MAKE_YOUNG_PAIR(
											((obj_t)
												((BgL_variablez00_bglt) BgL_varz00_2258)),
											BgL_stkz00_2259);
										BgL_fsafez00_2335 =
											BGl_failsafezf3zf3zzsync_failsafez00(((BgL_nodez00_bglt)
												BgL_arg1502z00_2336), BgL_arg1520z00_2337);
									}
									if (NULLP(BgL_stkz00_2259))
										{	/* Sync/failsafe.scm 124 */
											((((BgL_funz00_bglt) COBJECT(
															((BgL_funz00_bglt)
																((BgL_sfunz00_bglt) BgL_funz00_2257))))->
													BgL_failsafez00) =
												((obj_t) BgL_fsafez00_2335), BUNSPEC);
										}
									else
										{	/* Sync/failsafe.scm 124 */
											BFALSE;
										}
									return BgL_fsafez00_2335;
								}
						}
				}
		}

	}



/* &failsafe?-app1291 */
	obj_t BGl_z62failsafezf3zd2app1291z43zzsync_failsafez00(obj_t BgL_envz00_2260,
		obj_t BgL_nz00_2261, obj_t BgL_stkz00_2262)
	{
		{	/* Sync/failsafe.scm 93 */
			{	/* Sync/failsafe.scm 94 */
				bool_t BgL_tmpz00_2667;

				{	/* Sync/failsafe.scm 95 */
					BgL_variablez00_bglt BgL_vz00_2339;

					BgL_vz00_2339 =
						(((BgL_varz00_bglt) COBJECT(
								(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nz00_2261)))->BgL_funz00)))->
						BgL_variablez00);
					{	/* Sync/failsafe.scm 96 */
						bool_t BgL_test1838z00_2671;

						{	/* Sync/failsafe.scm 96 */
							BgL_valuez00_bglt BgL_arg1404z00_2340;

							BgL_arg1404z00_2340 =
								(((BgL_variablez00_bglt) COBJECT(BgL_vz00_2339))->BgL_valuez00);
							BgL_test1838z00_2671 =
								CBOOL(BGl_failsafezd2funzf3z21zzsync_failsafez00(
									((BgL_funz00_bglt) BgL_arg1404z00_2340), BgL_vz00_2339,
									BgL_stkz00_2262));
						}
						if (BgL_test1838z00_2671)
							{	/* Sync/failsafe.scm 97 */
								obj_t BgL_g1264z00_2341;

								BgL_g1264z00_2341 =
									(((BgL_appz00_bglt) COBJECT(
											((BgL_appz00_bglt) BgL_nz00_2261)))->BgL_argsz00);
								{
									obj_t BgL_l1262z00_2343;

									BgL_l1262z00_2343 = BgL_g1264z00_2341;
								BgL_zc3z04anonymousza31376ze3z87_2342:
									if (NULLP(BgL_l1262z00_2343))
										{	/* Sync/failsafe.scm 97 */
											BgL_tmpz00_2667 = ((bool_t) 1);
										}
									else
										{	/* Sync/failsafe.scm 97 */
											obj_t BgL_nvz00_2344;

											{	/* Sync/failsafe.scm 97 */
												obj_t BgL_nz00_2345;

												BgL_nz00_2345 = CAR(((obj_t) BgL_l1262z00_2343));
												BgL_nvz00_2344 =
													BGl_failsafezf3zf3zzsync_failsafez00(
													((BgL_nodez00_bglt) BgL_nz00_2345), BgL_stkz00_2262);
											}
											if (CBOOL(BgL_nvz00_2344))
												{	/* Sync/failsafe.scm 97 */
													obj_t BgL_arg1396z00_2346;

													BgL_arg1396z00_2346 =
														CDR(((obj_t) BgL_l1262z00_2343));
													{
														obj_t BgL_l1262z00_2688;

														BgL_l1262z00_2688 = BgL_arg1396z00_2346;
														BgL_l1262z00_2343 = BgL_l1262z00_2688;
														goto BgL_zc3z04anonymousza31376ze3z87_2342;
													}
												}
											else
												{	/* Sync/failsafe.scm 97 */
													BgL_tmpz00_2667 = ((bool_t) 0);
												}
										}
								}
							}
						else
							{	/* Sync/failsafe.scm 96 */
								BgL_tmpz00_2667 = ((bool_t) 0);
							}
					}
				}
				return BBOOL(BgL_tmpz00_2667);
			}
		}

	}



/* &failsafe?-sync1289 */
	obj_t BGl_z62failsafezf3zd2sync1289z43zzsync_failsafez00(obj_t
		BgL_envz00_2263, obj_t BgL_nz00_2264, obj_t BgL_stkz00_2265)
	{
		{	/* Sync/failsafe.scm 84 */
			{	/* Sync/failsafe.scm 86 */
				obj_t BgL__andtest_1112z00_2348;

				BgL__andtest_1112z00_2348 =
					BGl_failsafezf3zf3zzsync_failsafez00(
					(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_2264)))->BgL_mutexz00),
					BgL_stkz00_2265);
				if (CBOOL(BgL__andtest_1112z00_2348))
					{	/* Sync/failsafe.scm 87 */
						obj_t BgL__andtest_1113z00_2349;

						BgL__andtest_1113z00_2349 =
							BGl_failsafezf3zf3zzsync_failsafez00(
							(((BgL_syncz00_bglt) COBJECT(
										((BgL_syncz00_bglt) BgL_nz00_2264)))->BgL_prelockz00),
							BgL_stkz00_2265);
						if (CBOOL(BgL__andtest_1113z00_2349))
							{	/* Sync/failsafe.scm 87 */
								return
									BGl_failsafezf3zf3zzsync_failsafez00(
									(((BgL_syncz00_bglt) COBJECT(
												((BgL_syncz00_bglt) BgL_nz00_2264)))->BgL_bodyz00),
									BgL_stkz00_2265);
							}
						else
							{	/* Sync/failsafe.scm 87 */
								return BFALSE;
							}
					}
				else
					{	/* Sync/failsafe.scm 86 */
						return BFALSE;
					}
			}
		}

	}



/* &failsafe?-sequence1287 */
	obj_t BGl_z62failsafezf3zd2sequence1287z43zzsync_failsafez00(obj_t
		BgL_envz00_2266, obj_t BgL_nz00_2267, obj_t BgL_stkz00_2268)
	{
		{	/* Sync/failsafe.scm 77 */
			{	/* Sync/failsafe.scm 78 */
				bool_t BgL_tmpz00_2703;

				{	/* Sync/failsafe.scm 79 */
					obj_t BgL_g1260z00_2351;

					BgL_g1260z00_2351 =
						(((BgL_sequencez00_bglt) COBJECT(
								((BgL_sequencez00_bglt) BgL_nz00_2267)))->BgL_nodesz00);
					{
						obj_t BgL_l1258z00_2353;

						BgL_l1258z00_2353 = BgL_g1260z00_2351;
					BgL_zc3z04anonymousza31354ze3z87_2352:
						if (NULLP(BgL_l1258z00_2353))
							{	/* Sync/failsafe.scm 79 */
								BgL_tmpz00_2703 = ((bool_t) 1);
							}
						else
							{	/* Sync/failsafe.scm 79 */
								obj_t BgL_nvz00_2354;

								{	/* Sync/failsafe.scm 79 */
									obj_t BgL_nz00_2355;

									BgL_nz00_2355 = CAR(((obj_t) BgL_l1258z00_2353));
									BgL_nvz00_2354 =
										BGl_failsafezf3zf3zzsync_failsafez00(
										((BgL_nodez00_bglt) BgL_nz00_2355), BgL_stkz00_2268);
								}
								if (CBOOL(BgL_nvz00_2354))
									{	/* Sync/failsafe.scm 79 */
										obj_t BgL_arg1356z00_2356;

										BgL_arg1356z00_2356 = CDR(((obj_t) BgL_l1258z00_2353));
										{
											obj_t BgL_l1258z00_2716;

											BgL_l1258z00_2716 = BgL_arg1356z00_2356;
											BgL_l1258z00_2353 = BgL_l1258z00_2716;
											goto BgL_zc3z04anonymousza31354ze3z87_2352;
										}
									}
								else
									{	/* Sync/failsafe.scm 79 */
										BgL_tmpz00_2703 = ((bool_t) 0);
									}
							}
					}
				}
				return BBOOL(BgL_tmpz00_2703);
			}
		}

	}



/* &failsafe?-kwote1285 */
	obj_t BGl_z62failsafezf3zd2kwote1285z43zzsync_failsafez00(obj_t
		BgL_envz00_2269, obj_t BgL_nz00_2270, obj_t BgL_stkz00_2271)
	{
		{	/* Sync/failsafe.scm 71 */
			return BBOOL(((bool_t) 1));
		}

	}



/* &failsafe?-var1283 */
	obj_t BGl_z62failsafezf3zd2var1283z43zzsync_failsafez00(obj_t BgL_envz00_2272,
		obj_t BgL_nz00_2273, obj_t BgL_stkz00_2274)
	{
		{	/* Sync/failsafe.scm 65 */
			return BBOOL(((bool_t) 1));
		}

	}



/* &failsafe?-atom1281 */
	obj_t BGl_z62failsafezf3zd2atom1281z43zzsync_failsafez00(obj_t
		BgL_envz00_2275, obj_t BgL_nz00_2276, obj_t BgL_stkz00_2277)
	{
		{	/* Sync/failsafe.scm 59 */
			return BBOOL(((bool_t) 1));
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzsync_failsafez00()
	{
		{	/* Sync/failsafe.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 453414928),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 151271251),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 315247917),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 163122759),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 460136018),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
			return
				BGl_modulezd2initializa7ationz75zzbackend_cplibz00(((long) 395792377),
				BSTRING_TO_STRING(BGl_string1781z00zzsync_failsafez00));
		}

	}

#ifdef __cplusplus
}
#endif
