/*===========================================================================*/
/*   (Llib/avahi.scm)                                                        */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi avahi -copt -D_REENTRANT -copt -fPIC -copt -IClib Llib/avahi.scm -o objs/avahi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <avahi-client/client.h>
#include <avahi-client/lookup.h>
#include <avahi-client/publish.h>
#include <avahi-common/simple-watch.h>
#include <avahi-common/thread-watch.h>
#include <avahi-common/error.h>
#include <avahi-common/alternative.h>
#include <bavahi.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_pthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_bodyz00;
   bool_t BgL_detachedpz00;
   obj_t BgL_endzd2resultzd2;
   obj_t BgL_endzd2exceptionzd2;
   void * BgL_z42builtinz42;
} *BgL_pthreadz00_bglt;

typedef struct BgL_z62avahizd2errorzb0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
   int BgL_errnoz00;
} *BgL_z62avahizd2errorzb0_bglt;

typedef struct BgL_z62avahizd2collisionzd2errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
   int BgL_errnoz00;
} *BgL_z62avahizd2collisionzd2errorz62_bglt;

typedef struct BgL_avahizd2objectzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_avahizd2objectzd2_bglt;

typedef struct BgL_avahizd2pollzd2_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
} *BgL_avahizd2pollzd2_bglt;

typedef struct BgL_avahizd2simplezd2pollz00_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
   AvahiSimplePoll * BgL_z42builtinz42;
} *BgL_avahizd2simplezd2pollz00_bglt;

typedef struct BgL_avahizd2threadedzd2pollz00_bgl {
   header_t header;
   obj_t widening;
   int BgL_z42ctypez42;
   obj_t BgL_z52procsz52;
   AvahiThreadedPoll * BgL_z42builtinz42;
} *BgL_avahizd2threadedzd2pollz00_bglt;

typedef struct BgL_avahizd2clientzd2_bgl {
   header_t header;
   obj_t widening;
   AvahiClient * BgL_z42builtinz42;
   struct BgL_avahizd2pollzd2_bgl * BgL_pollz00;
   obj_t BgL_flagsz00;
   obj_t BgL_procz00;
   obj_t BgL_z52groupsz52;
   obj_t BgL_z52browsersz52;
   obj_t BgL_resolversz00;
} *BgL_avahizd2clientzd2_bglt;

typedef struct BgL_avahizd2entryzd2groupz00_bgl {
   header_t header;
   obj_t widening;
   AvahiEntryGroup * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
} *BgL_avahizd2entryzd2groupz00_bglt;

typedef struct BgL_avahizd2servicezd2browserz00_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_typez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2browserz00_bglt;

typedef struct BgL_avahizd2servicezd2typezd2browserzd2_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceTypeBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2typezd2browserzd2_bglt;

typedef struct BgL_avahizd2domainzd2browserz00_bgl {
   header_t header;
   obj_t widening;
   AvahiDomainBrowser * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   obj_t BgL_btypez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2domainzd2browserz00_bglt;

typedef struct BgL_avahizd2servicezd2resolverz00_bgl {
   header_t header;
   obj_t widening;
   AvahiServiceResolver * BgL_z42builtinz42;
   struct BgL_avahizd2clientzd2_bgl * BgL_clientz00;
   obj_t BgL_procz00;
   AvahiIfIndex BgL_interfacez00;
   obj_t BgL_protocolz00;
   obj_t BgL_namez00;
   obj_t BgL_typez00;
   obj_t BgL_domainz00;
} *BgL_avahizd2servicezd2resolverz00_bglt;


static obj_t BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
extern AvahiStringList * bgl_avahi_list_to_string_list(obj_t);
static obj_t BGl_z62zc3z04anonymousza31951ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1930z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1850z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1931z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1851z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31838ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1937z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1938z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1859z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31960ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31871ze3ze5zz__avahi_avahiz00(obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1862z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda1944z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1945z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1869z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2resolverz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00();
static obj_t BGl_z62zc3z04anonymousza31864ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1870z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1877z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__avahi_avahiz00(obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__avahi_avahiz00(obj_t);
static BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1880z62zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_resolver_event_to_symbol(AvahiResolverEvent);
static obj_t BGl_z62lambda1887z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62lambda1888z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32103ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__avahi_avahiz00();
BGL_EXPORTED_DEF obj_t BGl_avahizd2pollzd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_avahizd2objectzd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31971ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31882ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31939ze3ze5zz__avahi_avahiz00(obj_t);
BGL_IMPORT void * BGl_z42pthreadzd2nilz90zz__pth_threadz00();
static BgL_avahizd2clientzd2_bglt BGl_z62lambda1895z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda1898z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_lookup_result_flags_to_symbol(AvahiLookupResultFlags);
static obj_t BGl_z62zc3z04anonymousza31956ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__avahi_avahiz00();
BGL_EXPORTED_DECL obj_t bgl_avahi_error(char *, char *, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__avahi_avahiz00();
static obj_t BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_pthreadz00zz__pth_threadz00;
static obj_t BGl_z62avahizd2initzd2avahizd2thr1260zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_browser_event_to_symbol(AvahiBrowserEvent);
static obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32018ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31975ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_protocol_to_symbol(AvahiProtocol);
BGL_EXPORTED_DECL obj_t bgl_avahi_lookup_flags_to_symbol(AvahiLookupFlags);
static obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_client_state_to_symbol(AvahiClientState);
BGL_EXPORTED_DECL obj_t BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31323ze3ze5zz__avahi_avahiz00(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__avahi_avahiz00();
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00 = BUNSPEC;
BGL_EXPORTED_DECL AvahiProtocol bgl_avahi_symbol_to_protocol(obj_t);
static obj_t BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2initzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32063ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__avahi_avahiz00(obj_t);
extern void bgl_avahi_invoke_callbacks();
BGL_EXPORTED_DEF obj_t BGl_z62avahizd2errorzb0zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32145ze3ze5zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
BGL_IMPORT bool_t BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32162ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_entry_group_state_to_symbol(AvahiEntryGroupState);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2101z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2error2261zb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2108z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2109z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2cli1262zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_lock();
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2sim1258zb0zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2030z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2033z62zz__avahi_avahiz00(obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2114z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2115z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2119z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_remq_bang(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62z52avahizd2signalze2zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2120z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1267zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2040z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2202z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2041z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2203z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1269zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2125z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2126z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2207z62zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2046z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2047z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__avahi_avahiz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62avahizd2init1255zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2domainzd2browserz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2initzd2avahizd2ent1264zb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static obj_t BGl_z62avahizd2initzd2avahizd2ser1273zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2212z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2051z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2213z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2052z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2133z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
static BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2136z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2217z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2218z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2058z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(obj_t);
static BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2061z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2223z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2143z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2224z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2144z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2068z62zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2149z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2069z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31900ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2150z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza31544ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2154z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(obj_t, obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2074z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2155z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
static obj_t BGl_z62lambda2075z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_cnstzd2initzd2zz__avahi_avahiz00();
static obj_t BGl_z62lambda2079z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00();
BGL_EXPORTED_DECL obj_t BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt);
static obj_t BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__avahi_avahiz00();
static obj_t BGl_z62lambda2160z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2080z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2161z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2084z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2085z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2167z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2168z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62avahizd2initzd2avahizd2dom1271zb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2090z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2091z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2175z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2098z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2179z62zz__avahi_avahiz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2browserz00_bglt);
static obj_t BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt);
static obj_t BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31814ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31806ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2zz__avahi_avahiz00 = BUNSPEC;
static obj_t BGl_z62lambda2186z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2187z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static BgL_avahizd2clientzd2_bglt BGl_z62lambda2192z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda2193z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2197z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda2198z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31824ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1802z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1804z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt, int);
BGL_EXPORTED_DECL obj_t bgl_avahi_unlock();
BGL_EXPORTED_DECL obj_t bgl_avahi_if_index_to_symbol(AvahiIfIndex);
static obj_t BGl_z62lambda1812z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1813z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_deletez12z12zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt);
static BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1820z62zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__avahi_avahiz00(obj_t);
static BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1822z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31908ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1906z62zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt, obj_t);
static obj_t BGl_z62lambda1907z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_avahi_signal();
static BgL_avahizd2objectzd2_bglt BGl_z62lambda1829z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31852ze3ze5zz__avahi_avahiz00(obj_t);
static BgL_avahizd2pollzd2_bglt BGl_z62lambda1912z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1913z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
static BgL_avahizd2pollzd2_bglt BGl_z62lambda1836z62zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda1918z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1919z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31950ze3ze5zz__avahi_avahiz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31845ze3ze5zz__avahi_avahiz00(obj_t);
static obj_t BGl_z62lambda1843z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1924z62zz__avahi_avahiz00(obj_t, obj_t);
static obj_t BGl_z62lambda1844z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1925z62zz__avahi_avahiz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 101 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2lookupzd2resultzd2flagszd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2looku2573z00, BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2signalzd2envz52zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2si2574za7, BGl_z62z52avahizd2signalze2zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2loopzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2575z00, BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2resolverzd2eventzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2resol2576z00, BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2servicezd2browserzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2servi2577z00, BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2lockz12zd2envz40zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2lo2578za7, BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2400z00zz__avahi_avahiz00, BgL_bgl_string2400za700za7za7_2579za7, "symbol", 6 );
DEFINE_STRING( BGl_string2401z00zz__avahi_avahiz00, BgL_bgl_string2401za700za7za7_2580za7, "avahi-lookup-flags->symbol", 26 );
DEFINE_STRING( BGl_string2402z00zz__avahi_avahiz00, BgL_bgl_string2402za700za7za7_2581za7, "Unknown lookup-flag", 19 );
DEFINE_STRING( BGl_string2403z00zz__avahi_avahiz00, BgL_bgl_string2403za700za7za7_2582za7, "&avahi-lookup-flags->symbol", 27 );
DEFINE_STRING( BGl_string2404z00zz__avahi_avahiz00, BgL_bgl_string2404za700za7za7_2583za7, "avahi-lookup-result-flags->symbol", 33 );
DEFINE_STRING( BGl_string2405z00zz__avahi_avahiz00, BgL_bgl_string2405za700za7za7_2584za7, "Unknown lookup-result-flag", 26 );
DEFINE_STRING( BGl_string2406z00zz__avahi_avahiz00, BgL_bgl_string2406za700za7za7_2585za7, "&avahi-lookup-result-flags->symbol", 34 );
DEFINE_STRING( BGl_string2407z00zz__avahi_avahiz00, BgL_bgl_string2407za700za7za7_2586za7, "avahi-symbol->domain-browser-type", 33 );
DEFINE_STRING( BGl_string2408z00zz__avahi_avahiz00, BgL_bgl_string2408za700za7za7_2587za7, "Unknown btype", 13 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2errorzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2error2588z00, BGl_z62avahizd2error2261zb0zz__avahi_avahiz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2servicezd2resolverzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2servi2589z00, BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2590za7, BGl_z62zc3z04anonymousza31814ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__avahi_avahiz00, BgL_bgl_za762lambda1813za7622591z00, BGl_z62lambda1813z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2411z00zz__avahi_avahiz00, BgL_bgl_za762lambda1812za7622592z00, BGl_z62lambda1812z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2412z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2593za7, BGl_z62zc3z04anonymousza31806ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__avahi_avahiz00, BgL_bgl_za762lambda1804za7622594z00, BGl_z62lambda1804z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__avahi_avahiz00, BgL_bgl_za762lambda1802za7622595z00, BGl_z62lambda1802z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2596za7, BGl_z62zc3z04anonymousza31824ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2416z00zz__avahi_avahiz00, BgL_bgl_za762lambda1822za7622597z00, BGl_z62lambda1822z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2417z00zz__avahi_avahiz00, BgL_bgl_za762lambda1820za7622598z00, BGl_z62lambda1820z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STRING( BGl_string2342z00zz__avahi_avahiz00, BgL_bgl_string2342za700za7za7_2599za7, "Llib/avahi.scm", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2600za7, BGl_z62zc3z04anonymousza31831ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2343z00zz__avahi_avahiz00, BgL_bgl_string2343za700za7za7_2601za7, "/builddir/build/BUILD/bigloo-4.4b/api/avahi/src/Llib/avahi.scm", 62 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__avahi_avahiz00, BgL_bgl_za762lambda1829za7622602z00, BGl_z62lambda1829z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2344z00zz__avahi_avahiz00, BgL_bgl_string2344za700za7za7_2603za7, "&avahi-error2261", 16 );
DEFINE_STRING( BGl_string2345z00zz__avahi_avahiz00, BgL_bgl_string2345za700za7za7_2604za7, "bstring", 7 );
DEFINE_STRING( BGl_string2346z00zz__avahi_avahiz00, BgL_bgl_string2346za700za7za7_2605za7, "bint", 4 );
DEFINE_STRING( BGl_string2347z00zz__avahi_avahiz00, BgL_bgl_string2347za700za7za7_2606za7, "avahi", 5 );
DEFINE_STRING( BGl_string2348z00zz__avahi_avahiz00, BgL_bgl_string2348za700za7za7_2607za7, "&avahi-simple-poll-close", 24 );
DEFINE_STRING( BGl_string2349z00zz__avahi_avahiz00, BgL_bgl_string2349za700za7za7_2608za7, "avahi-simple-poll", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2500z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2609za7, BGl_z62zc3z04anonymousza32063ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2501z00zz__avahi_avahiz00, BgL_bgl_za762lambda2061za7622610z00, BGl_z62lambda2061z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2420z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2611za7, BGl_z62zc3z04anonymousza31845ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2502z00zz__avahi_avahiz00, BgL_bgl_za762lambda2058za7622612z00, BGl_z62lambda2058z62zz__avahi_avahiz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2421z00zz__avahi_avahiz00, BgL_bgl_za762lambda1844za7622613z00, BGl_z62lambda1844z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2503z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2614za7, BGl_z62zc3z04anonymousza32110ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__avahi_avahiz00, BgL_bgl_za762lambda1843za7622615z00, BGl_z62lambda1843z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2504z00zz__avahi_avahiz00, BgL_bgl_za762lambda2109za7622616z00, BGl_z62lambda2109z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2617za7, BGl_z62zc3z04anonymousza31852ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2505z00zz__avahi_avahiz00, BgL_bgl_za762lambda2108za7622618z00, BGl_z62lambda2108z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__avahi_avahiz00, BgL_bgl_za762lambda1851za7622619z00, BGl_z62lambda1851z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2506z00zz__avahi_avahiz00, BgL_bgl_za762lambda2115za7622620z00, BGl_z62lambda2115z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2425z00zz__avahi_avahiz00, BgL_bgl_za762lambda1850za7622621z00, BGl_z62lambda1850z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2350z00zz__avahi_avahiz00, BgL_bgl_string2350za700za7za7_2622za7, "&avahi-simple-poll-loop", 23 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2ifzd2indexzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2ifza7d22623za7, BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2507z00zz__avahi_avahiz00, BgL_bgl_za762lambda2114za7622624z00, BGl_z62lambda2114z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2426z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2625za7, BGl_z62zc3z04anonymousza31838ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2351z00zz__avahi_avahiz00, BgL_bgl_string2351za700za7za7_2626za7, "avahi-simple-poll-timeout", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2508z00zz__avahi_avahiz00, BgL_bgl_za762lambda2120za7622627z00, BGl_z62lambda2120z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__avahi_avahiz00, BgL_bgl_za762lambda1836za7622628z00, BGl_z62lambda1836z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2352z00zz__avahi_avahiz00, BgL_bgl_string2352za700za7za7_2629za7, "Illegal callback", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2509z00zz__avahi_avahiz00, BgL_bgl_za762lambda2119za7622630z00, BGl_z62lambda2119z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2631za7, BGl_z62zc3z04anonymousza31871ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2353z00zz__avahi_avahiz00, BgL_bgl_string2353za700za7za7_2632za7, "&avahi-simple-poll-timeout", 26 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2429z00zz__avahi_avahiz00, BgL_bgl_za762lambda1870za7622633z00, BGl_z62lambda1870z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2354z00zz__avahi_avahiz00, BgL_bgl_string2354za700za7za7_2634za7, "procedure", 9 );
DEFINE_STRING( BGl_string2355z00zz__avahi_avahiz00, BgL_bgl_string2355za700za7za7_2635za7, "&avahi-simple-poll-quit", 23 );
DEFINE_STRING( BGl_string2356z00zz__avahi_avahiz00, BgL_bgl_string2356za700za7za7_2636za7, "&avahi-threaded-poll-close", 26 );
DEFINE_STRING( BGl_string2357z00zz__avahi_avahiz00, BgL_bgl_string2357za700za7za7_2637za7, "avahi-threaded-poll", 19 );
DEFINE_STRING( BGl_string2358z00zz__avahi_avahiz00, BgL_bgl_string2358za700za7za7_2638za7, "&avahi-threaded-poll-loop", 25 );
DEFINE_STRING( BGl_string2359z00zz__avahi_avahiz00, BgL_bgl_string2359za700za7za7_2639za7, "&avahi-threaded-poll-lock!", 26 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2closezd2envzd2zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2640z00, BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2510z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2641za7, BGl_z62zc3z04anonymousza32127ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2511z00zz__avahi_avahiz00, BgL_bgl_za762lambda2126za7622642z00, BGl_z62lambda2126z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2430z00zz__avahi_avahiz00, BgL_bgl_za762lambda1869za7622643z00, BGl_z62lambda1869z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2512z00zz__avahi_avahiz00, BgL_bgl_za762lambda2125za7622644z00, BGl_z62lambda2125z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2645za7, BGl_z62zc3z04anonymousza31864ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2646za7, BGl_z62zc3z04anonymousza32103ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__avahi_avahiz00, BgL_bgl_za762lambda1862za7622647z00, BGl_z62lambda1862z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2514z00zz__avahi_avahiz00, BgL_bgl_za762lambda2101za7622648z00, BGl_z62lambda2101z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2433z00zz__avahi_avahiz00, BgL_bgl_za762lambda1859za7622649z00, BGl_z62lambda1859z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2515z00zz__avahi_avahiz00, BgL_bgl_za762lambda2098za7622650z00, BGl_z62lambda2098z62zz__avahi_avahiz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2434z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2651za7, BGl_z62zc3z04anonymousza31889ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2516z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2652za7, BGl_z62zc3z04anonymousza32145ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__avahi_avahiz00, BgL_bgl_za762lambda1888za7622653z00, BGl_z62lambda1888z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2360z00zz__avahi_avahiz00, BgL_bgl_string2360za700za7za7_2654za7, "&avahi-threaded-poll-unlock!", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2517z00zz__avahi_avahiz00, BgL_bgl_za762lambda2144za7622655z00, BGl_z62lambda2144z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__avahi_avahiz00, BgL_bgl_za762lambda1887za7622656z00, BGl_z62lambda1887z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2361z00zz__avahi_avahiz00, BgL_bgl_string2361za700za7za7_2657za7, "avahi-threaded-poll-timeout", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2518z00zz__avahi_avahiz00, BgL_bgl_za762lambda2143za7622658z00, BGl_z62lambda2143z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2437z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2659za7, BGl_z62zc3z04anonymousza31882ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2362z00zz__avahi_avahiz00, BgL_bgl_string2362za700za7za7_2660za7, "&avahi-threaded-poll-timeout", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2519z00zz__avahi_avahiz00, BgL_bgl_za762lambda2150za7622661z00, BGl_z62lambda2150z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__avahi_avahiz00, BgL_bgl_za762lambda1880za7622662z00, BGl_z62lambda1880z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2363z00zz__avahi_avahiz00, BgL_bgl_string2363za700za7za7_2663za7, "&avahi-threaded-poll-quit", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__avahi_avahiz00, BgL_bgl_za762lambda1877za7622664z00, BGl_z62lambda1877z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2364z00zz__avahi_avahiz00, BgL_bgl_string2364za700za7za7_2665za7, "&avahi-client-close", 19 );
DEFINE_STRING( BGl_string2365z00zz__avahi_avahiz00, BgL_bgl_string2365za700za7za7_2666za7, "avahi-client", 12 );
DEFINE_STRING( BGl_string2366z00zz__avahi_avahiz00, BgL_bgl_string2366za700za7za7_2667za7, "&avahi-client-error-message", 27 );
DEFINE_STRING( BGl_string2367z00zz__avahi_avahiz00, BgL_bgl_string2367za700za7za7_2668za7, "avahi-client-state->symbol", 26 );
DEFINE_STRING( BGl_string2368z00zz__avahi_avahiz00, BgL_bgl_string2368za700za7za7_2669za7, "Unknown state", 13 );
DEFINE_STRING( BGl_string2369z00zz__avahi_avahiz00, BgL_bgl_string2369za700za7za7_2670za7, "&avahi-client-state->symbol", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2520z00zz__avahi_avahiz00, BgL_bgl_za762lambda2149za7622671z00, BGl_z62lambda2149z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2521z00zz__avahi_avahiz00, BgL_bgl_za762lambda2155za7622672z00, BGl_z62lambda2155z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2673za7, BGl_z62zc3z04anonymousza31908ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__avahi_avahiz00, BgL_bgl_za762lambda2154za7622674z00, BGl_z62lambda2154z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__avahi_avahiz00, BgL_bgl_za762lambda1907za7622675z00, BGl_z62lambda1907z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2523z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2676za7, BGl_z62zc3z04anonymousza32162ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2442z00zz__avahi_avahiz00, BgL_bgl_za762lambda1906za7622677z00, BGl_z62lambda1906z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2524z00zz__avahi_avahiz00, BgL_bgl_za762lambda2161za7622678z00, BGl_z62lambda2161z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__avahi_avahiz00, BgL_bgl_za762lambda1913za7622679z00, BGl_z62lambda1913z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2525z00zz__avahi_avahiz00, BgL_bgl_za762lambda2160za7622680z00, BGl_z62lambda2160z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__avahi_avahiz00, BgL_bgl_za762lambda1912za7622681z00, BGl_z62lambda1912z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2682za7, BGl_z62zc3z04anonymousza32169ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2683za7, BGl_z62zc3z04anonymousza31920ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2370z00zz__avahi_avahiz00, BgL_bgl_string2370za700za7za7_2684za7, "&avahi-entry-group-close", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__avahi_avahiz00, BgL_bgl_za762lambda2168za7622685z00, BGl_z62lambda2168z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__avahi_avahiz00, BgL_bgl_za762lambda1919za7622686z00, BGl_z62lambda1919z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2371z00zz__avahi_avahiz00, BgL_bgl_string2371za700za7za7_2687za7, "avahi-entry-group", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__avahi_avahiz00, BgL_bgl_za762lambda2167za7622688z00, BGl_z62lambda2167z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__avahi_avahiz00, BgL_bgl_za762lambda1918za7622689z00, BGl_z62lambda1918z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2372z00zz__avahi_avahiz00, BgL_bgl_string2372za700za7za7_2690za7, "&avahi-entry-group-empty?", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2529z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2691za7, BGl_z62zc3z04anonymousza32138ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__avahi_avahiz00, BgL_bgl_za762lambda1925za7622692z00, BGl_z62lambda1925z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2373z00zz__avahi_avahiz00, BgL_bgl_string2373za700za7za7_2693za7, "&avahi-entry-group-commit", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__avahi_avahiz00, BgL_bgl_za762lambda1924za7622694z00, BGl_z62lambda1924z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2374z00zz__avahi_avahiz00, BgL_bgl_string2374za700za7za7_2695za7, "&avahi-entry-group-reset!", 25 );
DEFINE_STRING( BGl_string2375z00zz__avahi_avahiz00, BgL_bgl_string2375za700za7za7_2696za7, "avahi-entry-group-add-service", 29 );
DEFINE_STRING( BGl_string2376z00zz__avahi_avahiz00, BgL_bgl_string2376za700za7za7_2697za7, "&avahi-entry-group-add-service!", 31 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string2377z00zz__avahi_avahiz00, BgL_bgl_string2377za700za7za7_2698za7, "avahi-entry-group-state->symbol", 31 );
DEFINE_STRING( BGl_string2378z00zz__avahi_avahiz00, BgL_bgl_string2378za700za7za7_2699za7, "&avahi-entry-group-state->symbol", 32 );
DEFINE_STRING( BGl_string2379z00zz__avahi_avahiz00, BgL_bgl_string2379za700za7za7_2700za7, "&avahi-alternative-host-name", 28 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2timeoutzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2701z00, BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2530z00zz__avahi_avahiz00, BgL_bgl_za762lambda2136za7622702z00, BGl_z62lambda2136z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__avahi_avahiz00, BgL_bgl_za762lambda2133za7622703z00, BGl_z62lambda2133z62zz__avahi_avahiz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2704za7, BGl_z62zc3z04anonymousza31932ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2705za7, BGl_z62zc3z04anonymousza32188ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2451z00zz__avahi_avahiz00, BgL_bgl_za762lambda1931za7622706z00, BGl_z62lambda1931z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__avahi_avahiz00, BgL_bgl_za762lambda2187za7622707z00, BGl_z62lambda2187z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__avahi_avahiz00, BgL_bgl_za762lambda1930za7622708z00, BGl_z62lambda1930z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2534z00zz__avahi_avahiz00, BgL_bgl_za762lambda2186za7622709z00, BGl_z62lambda2186z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2453z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2710za7, BGl_z62zc3z04anonymousza31939ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2535z00zz__avahi_avahiz00, BgL_bgl_za762lambda2193za7622711z00, BGl_z62lambda2193z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2454z00zz__avahi_avahiz00, BgL_bgl_za762lambda1938za7622712z00, BGl_z62lambda1938z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__avahi_avahiz00, BgL_bgl_za762lambda2192za7622713z00, BGl_z62lambda2192z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__avahi_avahiz00, BgL_bgl_za762lambda1937za7622714z00, BGl_z62lambda1937z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2380z00zz__avahi_avahiz00, BgL_bgl_string2380za700za7za7_2715za7, "&avahi-alternative-service-name", 31 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__avahi_avahiz00, BgL_bgl_za762lambda2198za7622716z00, BGl_z62lambda2198z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2456z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2717za7, BGl_z62zc3z04anonymousza31946ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2381z00zz__avahi_avahiz00, BgL_bgl_string2381za700za7za7_2718za7, "&avahi-service-browser-close", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2538z00zz__avahi_avahiz00, BgL_bgl_za762lambda2197za7622719z00, BGl_z62lambda2197z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2457z00zz__avahi_avahiz00, BgL_bgl_za762lambda1945za7622720z00, BGl_z62lambda1945z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2382z00zz__avahi_avahiz00, BgL_bgl_string2382za700za7za7_2721za7, "avahi-service-browser", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2539z00zz__avahi_avahiz00, BgL_bgl_za762lambda2203za7622722z00, BGl_z62lambda2203z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__avahi_avahiz00, BgL_bgl_za762lambda1944za7622723z00, BGl_z62lambda1944z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2383z00zz__avahi_avahiz00, BgL_bgl_string2383za700za7za7_2724za7, "&avahi-domain-browser-close", 27 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2725za7, BGl_z62zc3z04anonymousza31951ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2384z00zz__avahi_avahiz00, BgL_bgl_string2384za700za7za7_2726za7, "avahi-domain-browser", 20 );
DEFINE_STRING( BGl_string2385z00zz__avahi_avahiz00, BgL_bgl_string2385za700za7za7_2727za7, "&avahi-service-resolver-close", 29 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2resetz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2728z00, BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2386z00zz__avahi_avahiz00, BgL_bgl_string2386za700za7za7_2729za7, "avahi-service-resolver", 22 );
DEFINE_STRING( BGl_string2387z00zz__avahi_avahiz00, BgL_bgl_string2387za700za7za7_2730za7, "avahi-browser-event->symbol", 27 );
DEFINE_STRING( BGl_string2388z00zz__avahi_avahiz00, BgL_bgl_string2388za700za7za7_2731za7, "Unknown event", 13 );
DEFINE_STRING( BGl_string2389z00zz__avahi_avahiz00, BgL_bgl_string2389za700za7za7_2732za7, "&avahi-browser-event->symbol", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2540z00zz__avahi_avahiz00, BgL_bgl_za762lambda2202za7622733z00, BGl_z62lambda2202z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__avahi_avahiz00, BgL_bgl_za762lambda2208za7622734z00, BGl_z62lambda2208z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2735za7, BGl_z62zc3z04anonymousza31950ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__avahi_avahiz00, BgL_bgl_za762lambda2207za7622736z00, BGl_z62lambda2207z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2461z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2737za7, BGl_z62zc3z04anonymousza31956ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2543z00zz__avahi_avahiz00, BgL_bgl_za762lambda2213za7622738z00, BGl_z62lambda2213z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2462z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2739za7, BGl_z62zc3z04anonymousza31955ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2544z00zz__avahi_avahiz00, BgL_bgl_za762lambda2212za7622740z00, BGl_z62lambda2212z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2463z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2741za7, BGl_z62zc3z04anonymousza31961ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__avahi_avahiz00, BgL_bgl_za762lambda2218za7622742z00, BGl_z62lambda2218z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2464z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2743za7, BGl_z62zc3z04anonymousza31960ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2alternativezd2hostzd2namezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2alter2744z00, BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__avahi_avahiz00, BgL_bgl_za762lambda2217za7622745z00, BGl_z62lambda2217z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2465z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2746za7, BGl_z62zc3z04anonymousza31966ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2390z00zz__avahi_avahiz00, BgL_bgl_string2390za700za7za7_2747za7, "avahi-resolver-event->symbol", 28 );
DEFINE_STRING( BGl_string2553z00zz__avahi_avahiz00, BgL_bgl_string2553za700za7za7_2748za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2547z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2749za7, BGl_z62zc3z04anonymousza32225ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2466z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2750za7, BGl_z62zc3z04anonymousza31965ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2391z00zz__avahi_avahiz00, BgL_bgl_string2391za700za7za7_2751za7, "&avahi-resolver-event->symbol", 29 );
DEFINE_STRING( BGl_string2554z00zz__avahi_avahiz00, BgL_bgl_string2554za700za7za7_2752za7, "nil", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2548z00zz__avahi_avahiz00, BgL_bgl_za762lambda2224za7622753z00, BGl_z62lambda2224z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2467z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2754za7, BGl_z62zc3z04anonymousza31971ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2392z00zz__avahi_avahiz00, BgL_bgl_string2392za700za7za7_2755za7, "avahi-if-index->symbol", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__avahi_avahiz00, BgL_bgl_za762lambda2223za7622756z00, BGl_z62lambda2223z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2468z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2757za7, BGl_z62zc3z04anonymousza31970ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2393z00zz__avahi_avahiz00, BgL_bgl_string2393za700za7za7_2758za7, "Unknown index", 13 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2lockz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2759z00, BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2556z00zz__avahi_avahiz00, BgL_bgl_string2556za700za7za7_2760za7, "avahi-init1255", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2469z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2761za7, BGl_z62zc3z04anonymousza31975ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2394z00zz__avahi_avahiz00, BgL_bgl_string2394za700za7za7_2762za7, "&avahi-if-index->symbol", 23 );
DEFINE_STRING( BGl_string2557z00zz__avahi_avahiz00, BgL_bgl_string2557za700za7za7_2763za7, "&avahi-init", 11 );
DEFINE_STRING( BGl_string2395z00zz__avahi_avahiz00, BgL_bgl_string2395za700za7za7_2764za7, "avahi-protocol->symbol", 22 );
DEFINE_STRING( BGl_string2558z00zz__avahi_avahiz00, BgL_bgl_string2558za700za7za7_2765za7, "avahi-object", 12 );
DEFINE_STRING( BGl_string2396z00zz__avahi_avahiz00, BgL_bgl_string2396za700za7za7_2766za7, "Unknown protocol", 16 );
DEFINE_STRING( BGl_string2397z00zz__avahi_avahiz00, BgL_bgl_string2397za700za7za7_2767za7, "&avahi-protocol->symbol", 23 );
DEFINE_STRING( BGl_string2398z00zz__avahi_avahiz00, BgL_bgl_string2398za700za7za7_2768za7, "avahi-symbol->protocol", 22 );
DEFINE_STRING( BGl_string2399z00zz__avahi_avahiz00, BgL_bgl_string2399za700za7za7_2769za7, "&avahi-symbol->protocol", 23 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2protocolzd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2proto2770z00, BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2550z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2771za7, BGl_z62zc3z04anonymousza32181ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__avahi_avahiz00, BgL_bgl_za762lambda2179za7622772z00, BGl_z62lambda2179z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2470z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2773za7, BGl_z62zc3z04anonymousza31985ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2552z00zz__avahi_avahiz00, BgL_bgl_za762lambda2175za7622774z00, BGl_z62lambda2175z62zz__avahi_avahiz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2471z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2775za7, BGl_z62zc3z04anonymousza31991ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2776za7, BGl_z62zc3z04anonymousza32000ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2560z00zz__avahi_avahiz00, BgL_bgl_string2560za700za7za7_2777za7, "avahi-init", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2778za7, BGl_z62zc3z04anonymousza32009ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2555z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2init12779z00, BGl_z62avahizd2init1255zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2474z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2780za7, BGl_z62zc3z04anonymousza32018ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2475z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2781za7, BGl_z62zc3z04anonymousza31900ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__avahi_avahiz00, BgL_bgl_za762lambda1898za7622782z00, BGl_z62lambda1898z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__avahi_avahiz00, BgL_bgl_za762lambda1895za7622783z00, BGl_z62lambda1895z62zz__avahi_avahiz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2559z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72784za7, BGl_z62avahizd2initzd2avahizd2sim1258zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2785za7, BGl_z62zc3z04anonymousza32042ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2479z00zz__avahi_avahiz00, BgL_bgl_za762lambda2041za7622786z00, BGl_z62lambda2041z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2568z00zz__avahi_avahiz00, BgL_bgl_string2568za700za7za7_2787za7, "avahi-service-type-browser", 26 );
DEFINE_STRING( BGl_string2569z00zz__avahi_avahiz00, BgL_bgl_string2569za700za7za7_2788za7, "avahi-client-init", 17 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2emptyzf3zd2envzf3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2789z00, BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2errorzd2messagezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2790z00, BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2561z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72791za7, BGl_z62avahizd2initzd2avahizd2thr1260zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2480z00zz__avahi_avahiz00, BgL_bgl_za762lambda2040za7622792z00, BGl_z62lambda2040z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2562z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72793za7, BGl_z62avahizd2initzd2avahizd2cli1262zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2481z00zz__avahi_avahiz00, BgL_bgl_za762lambda2047za7622794z00, BGl_z62lambda2047z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72795za7, BGl_z62avahizd2initzd2avahizd2ent1264zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2482z00zz__avahi_avahiz00, BgL_bgl_za762lambda2046za7622796z00, BGl_z62lambda2046z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2570z00zz__avahi_avahiz00, BgL_bgl_string2570za700za7za7_2797za7, "none nil avahi-domain-browser-browse _ avahi-service-resolver name protocol $avahi-if-index interface $avahi-service-resolver avahi-domain-browser $avahi-domain-browser avahi-service-type-browser $avahi-service-type-browser avahi-service-browser domain type $avahi-service-browser avahi-entry-group client $avahi-entry-group avahi-client state hostname-fqdn domainname hostname bstring version resolvers %browsers %groups procedure proc symbol flags poll $avahi-client avahi-threaded-poll $avahi-threaded-poll avahi-simple-poll $avahi-simple-poll $builtin avahi-poll pair-nil %procs $ctype avahi-object &avahi-collision-error __avahi_avahi &avahi-error int errno (quote avahi-domain-browser-max) (quote avahi-domain-browser-browse-legacy) (quote avahi-domain-browser-register-default) (quote avahi-domain-browser-register) (quote avahi-domain-browser-browse-default) (quote avahi-domain-browser-browse) btype eq? avahi-lookup-result-default avahi-lookup-result-static avahi-lookup-result-our-own avahi-lookup-result-local av"
"ahi-lookup-result-multicast avahi-lookup-result-wide-area avahi-lookup-result-cached avahi-lookup-default avahi-lookup-no-address avahi-lookup-no-txt avahi-proto-unspec avahi-proto-inet6 avahi-proto-inet avahi-if-unspec avahi-resolver-failure avahi-resolver-found avahi-browser-failure avahi-browser-all-for-now avahi-browser-cache-exhausted avahi-browser-remove avahi-browser-new avahi-entry-group-failure avahi-entry-group-collision avahi-entry-group-established avahi-entry-group-registering avahi-entry-group-uncommited (:subtype :port :host :domain :type :name) :subtype :port :host :domain :type :name avahi-client-connecting avahi-client-failure avahi-client-collision avahi-client-running avahi-client-registering condition-variable mutex avahi ", 1777 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72798za7, BGl_z62avahizd2initzd2avahizd2ser1267zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2483z00zz__avahi_avahiz00, BgL_bgl_za762lambda2052za7622799z00, BGl_z62lambda2052z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2565z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72800za7, BGl_z62avahizd2initzd2avahizd2ser1269zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2484z00zz__avahi_avahiz00, BgL_bgl_za762lambda2051za7622801z00, BGl_z62lambda2051z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2566z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72802za7, BGl_z62avahizd2initzd2avahizd2dom1271zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2485z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2803za7, BGl_z62zc3z04anonymousza32035ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72804za7, BGl_z62avahizd2initzd2avahizd2ser1273zb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2486z00zz__avahi_avahiz00, BgL_bgl_za762lambda2033za7622805z00, BGl_z62lambda2033z62zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2487z00zz__avahi_avahiz00, BgL_bgl_za762lambda2030za7622806z00, BGl_z62lambda2030z62zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2488z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2807za7, BGl_z62zc3z04anonymousza32070ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2489z00zz__avahi_avahiz00, BgL_bgl_za762lambda2069za7622808z00, BGl_z62lambda2069z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2symbolzd2ze3protocolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2symbo2809z00, BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2browserzd2eventzd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2brows2810z00, BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2490z00zz__avahi_avahiz00, BgL_bgl_za762lambda2068za7622811z00, BGl_z62lambda2068z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2491z00zz__avahi_avahiz00, BgL_bgl_za762lambda2075za7622812z00, BGl_z62lambda2075z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2492z00zz__avahi_avahiz00, BgL_bgl_za762lambda2074za7622813z00, BGl_z62lambda2074z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2493z00zz__avahi_avahiz00, BgL_bgl_za762lambda2080za7622814z00, BGl_z62lambda2080z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2494z00zz__avahi_avahiz00, BgL_bgl_za762lambda2079za7622815z00, BGl_z62lambda2079z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2495z00zz__avahi_avahiz00, BgL_bgl_za762lambda2085za7622816z00, BGl_z62lambda2085z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2496z00zz__avahi_avahiz00, BgL_bgl_za762lambda2084za7622817z00, BGl_z62lambda2084z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2497z00zz__avahi_avahiz00, BgL_bgl_za762za7c3za704anonymo2818za7, BGl_z62zc3z04anonymousza32092ze3ze5zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2498z00zz__avahi_avahiz00, BgL_bgl_za762lambda2091za7622819z00, BGl_z62lambda2091z62zz__avahi_avahiz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2499z00zz__avahi_avahiz00, BgL_bgl_za762lambda2090za7622820z00, BGl_z62lambda2090z62zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2timeoutzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2821z00, BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2commitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2822z00, BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2823z00, BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2initza72824za7, BGl_z62avahizd2initzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2statezd2ze3symbolzd2envz31zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2825z00, BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2lookupzd2flagszd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2looku2826z00, BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2threadzd2initz12zd2envz92zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2th2827za7, BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2alternativezd2servicezd2namezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2alter2828z00, BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2829z00, BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2quitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2830z00, BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2addzd2servicez12zd2envzc0zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2831z00, va_generic_entry, BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2clientzd2statezd2ze3symbolzd2envze3zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2clien2832z00, BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2entryzd2groupzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2entry2833z00, BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2domainzd2browserzd2closezd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2domai2834z00, BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2quitzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2835z00, BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52avahizd2unlockz12zd2envz40zz__avahi_avahiz00, BgL_bgl_za762za752avahiza7d2un2836za7, BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2threadedzd2pollzd2unlockz12zd2envz12zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2threa2837z00, BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_equalzf3zd2envz21zz__r4_equivalence_6_2z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_avahizd2simplezd2pollzd2loopzd2envz00zz__avahi_avahiz00, BgL_bgl_za762avahiza7d2simpl2838z00, BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2pollzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2objectzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_z62avahizd2errorzb0zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00) );
ADD_ROOT( (void *)(&BGl_avahizd2clientzd2zz__avahi_avahiz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__avahi_avahiz00(long BgL_checksumz00_2811, char * BgL_fromz00_2812)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__avahi_avahiz00))
{ 
BGl_requirezd2initializa7ationz75zz__avahi_avahiz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__avahi_avahiz00(); 
BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00(); 
BGl_cnstzd2initzd2zz__avahi_avahiz00(); 
BGl_objectzd2initzd2zz__avahi_avahiz00(); 
BGl_genericzd2initzd2zz__avahi_avahiz00(); 
BGl_methodzd2initzd2zz__avahi_avahiz00(); 
return 
BGl_toplevelzd2initzd2zz__avahi_avahiz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__avahi_avahi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__avahi_avahi"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 15 */
obj_t BgL_cportz00_2470;
{ /* Llib/avahi.scm 15 */
obj_t BgL_stringz00_2478;
BgL_stringz00_2478 = BGl_string2570z00zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 15 */
obj_t BgL_startz00_2479;
BgL_startz00_2479 = 
BINT(((long)0)); 
{ /* Llib/avahi.scm 15 */
obj_t BgL_endz00_2480;
BgL_endz00_2480 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2478))); 
{ /* Llib/avahi.scm 15 */

BgL_cportz00_2470 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2478, BgL_startz00_2479, BgL_endz00_2480); } } } } 
{ 
long BgL_iz00_2471;
BgL_iz00_2471 = ((long)100); 
BgL_loopz00_2472:
if(
(BgL_iz00_2471==((long)-1)))
{ /* Llib/avahi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 15 */
obj_t BgL_arg2572z00_2474;
{ /* Llib/avahi.scm 15 */

{ /* Llib/avahi.scm 15 */
obj_t BgL_locationz00_2476;
BgL_locationz00_2476 = 
BBOOL(((bool_t)0)); 
{ /* Llib/avahi.scm 15 */

BgL_arg2572z00_2474 = 
BGl_readz00zz__readerz00(BgL_cportz00_2470, BgL_locationz00_2476); } } } 
{ /* Llib/avahi.scm 15 */
int BgL_tmpz00_2848;
BgL_tmpz00_2848 = 
(int)(BgL_iz00_2471); 
CNST_TABLE_SET(BgL_tmpz00_2848, BgL_arg2572z00_2474); } } 
{ /* Llib/avahi.scm 15 */
int BgL_auxz00_2477;
BgL_auxz00_2477 = 
(int)(
(BgL_iz00_2471-((long)1))); 
{ 
long BgL_iz00_2853;
BgL_iz00_2853 = 
(long)(BgL_auxz00_2477); 
BgL_iz00_2471 = BgL_iz00_2853; 
goto BgL_loopz00_2472;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string2342z00zz__avahi_avahiz00)); 
{ /* Llib/avahi.scm 201 */
obj_t BgL_namez00_1231;
BgL_namez00_1231 = 
CNST_TABLE_REF(((long)0)); 
BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00 = 
bgl_make_mutex(BgL_namez00_1231); } 
{ /* Llib/avahi.scm 202 */
obj_t BgL_namez00_1232;
BgL_namez00_1232 = 
CNST_TABLE_REF(((long)0)); 
BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00 = 
bgl_make_condvar(BgL_namez00_1232); } 
BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = BUNSPEC; 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = BNIL; 
{ /* Llib/avahi.scm 245 */

{ /* Llib/avahi.scm 245 */
obj_t BgL_namez00_56;
BgL_namez00_56 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/avahi.scm 245 */

BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00 = 
bgl_make_mutex(BgL_namez00_56); } } } 
return BUNSPEC;} 

}



/* avahi-error */
BGL_EXPORTED_DEF obj_t bgl_avahi_error(char * BgL_procz00_3, char * BgL_msgz00_4, obj_t BgL_objz00_5, int BgL_errnoz00_6)
{
{ /* Llib/avahi.scm 212 */
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_65;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_66;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_69;
BgL_new1141z00_69 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_70;
BgL_arg1319z00_70 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_69), BgL_arg1319z00_70); } 
BgL_new1142z00_66 = BgL_new1141z00_69; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_66)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_66)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_2873;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_67;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_68;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1236;
BgL_classz00_1236 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_68 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1236); } 
BgL_arg1281z00_67 = 
VECTOR_REF(BgL_arg1318z00_68,((long)2)); } 
BgL_auxz00_2873 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_67); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_66)))->BgL_stackz00)=((obj_t)BgL_auxz00_2873),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_66)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_3)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_66)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_4)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_66)))->BgL_objz00)=((obj_t)BgL_objz00_5),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_66))->BgL_errnoz00)=((int)BgL_errnoz00_6),BUNSPEC); 
BgL_arg1280z00_65 = BgL_new1142z00_66; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_65));} } 

}



/* &avahi-error2261 */
obj_t BGl_z62avahizd2error2261zb0zz__avahi_avahiz00(obj_t BgL_envz00_1745, obj_t BgL_procz00_1746, obj_t BgL_msgz00_1747, obj_t BgL_objz00_1748, obj_t BgL_errnoz00_1749)
{
{ /* Llib/avahi.scm 212 */
{ /* Llib/avahi.scm 214 */
int BgL_auxz00_2908;char * BgL_auxz00_2899;char * BgL_auxz00_2890;
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_2909;
if(
INTEGERP(BgL_errnoz00_1749))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_2909 = BgL_errnoz00_1749
; }  else 
{ 
obj_t BgL_auxz00_2912;
BgL_auxz00_2912 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2344z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_errnoz00_1749); 
FAILURE(BgL_auxz00_2912,BFALSE,BFALSE);} 
BgL_auxz00_2908 = 
CINT(BgL_tmpz00_2909); } 
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_2900;
if(
STRINGP(BgL_msgz00_1747))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_2900 = BgL_msgz00_1747
; }  else 
{ 
obj_t BgL_auxz00_2903;
BgL_auxz00_2903 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2344z00zz__avahi_avahiz00, BGl_string2345z00zz__avahi_avahiz00, BgL_msgz00_1747); 
FAILURE(BgL_auxz00_2903,BFALSE,BFALSE);} 
BgL_auxz00_2899 = 
BSTRING_TO_STRING(BgL_tmpz00_2900); } 
{ /* Llib/avahi.scm 214 */
obj_t BgL_tmpz00_2891;
if(
STRINGP(BgL_procz00_1746))
{ /* Llib/avahi.scm 214 */
BgL_tmpz00_2891 = BgL_procz00_1746
; }  else 
{ 
obj_t BgL_auxz00_2894;
BgL_auxz00_2894 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)8538)), BGl_string2344z00zz__avahi_avahiz00, BGl_string2345z00zz__avahi_avahiz00, BgL_procz00_1746); 
FAILURE(BgL_auxz00_2894,BFALSE,BFALSE);} 
BgL_auxz00_2890 = 
BSTRING_TO_STRING(BgL_tmpz00_2891); } 
return 
bgl_avahi_error(BgL_auxz00_2890, BgL_auxz00_2899, BgL_objz00_1748, BgL_auxz00_2908);} } 

}



/* %avahi-lock! */
BGL_EXPORTED_DEF obj_t bgl_avahi_lock()
{
{ /* Llib/avahi.scm 223 */
{ /* Llib/avahi.scm 224 */
obj_t BgL_g1177z00_1238;
BgL_g1177z00_1238 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 224 */

{ /* Llib/avahi.scm 224 */
int BgL_arg1649z00_1243;
BgL_arg1649z00_1243 = 
BGL_MUTEX_LOCK(BgL_g1177z00_1238); 
return 
BBOOL(
(
(long)(BgL_arg1649z00_1243)==((long)0)));} } } } 

}



/* &%avahi-lock! */
obj_t BGl_z62z52avahizd2lockz12zf0zz__avahi_avahiz00(obj_t BgL_envz00_1750)
{
{ /* Llib/avahi.scm 223 */
return 
bgl_avahi_lock();} 

}



/* %avahi-unlock! */
BGL_EXPORTED_DEF obj_t bgl_avahi_unlock()
{
{ /* Llib/avahi.scm 229 */
{ /* Llib/avahi.scm 230 */
obj_t BgL_mz00_1248;
BgL_mz00_1248 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 230 */
int BgL_arg1646z00_1249;
BgL_arg1646z00_1249 = 
BGL_MUTEX_UNLOCK(BgL_mz00_1248); 
return 
BBOOL(
(
(long)(BgL_arg1646z00_1249)==((long)0)));} } } 

}



/* &%avahi-unlock! */
obj_t BGl_z62z52avahizd2unlockz12zf0zz__avahi_avahiz00(obj_t BgL_envz00_1751)
{
{ /* Llib/avahi.scm 229 */
return 
bgl_avahi_unlock();} 

}



/* %avahi-signal */
BGL_EXPORTED_DEF obj_t bgl_avahi_signal()
{
{ /* Llib/avahi.scm 235 */
{ /* Llib/avahi.scm 236 */
obj_t BgL_cz00_1251;
BgL_cz00_1251 = BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00; 
return 
BBOOL(
BGL_CONDVAR_SIGNAL(BgL_cz00_1251));} } 

}



/* &%avahi-signal */
obj_t BGl_z62z52avahizd2signalze2zz__avahi_avahiz00(obj_t BgL_envz00_1752)
{
{ /* Llib/avahi.scm 235 */
return 
bgl_avahi_signal();} 

}



/* avahi-gc-unmark! */
obj_t BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt BgL_oz00_8)
{
{ /* Llib/avahi.scm 257 */
{ /* Llib/avahi.scm 258 */
obj_t BgL_top2845z00_2932;
BgL_top2845z00_2932 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
BGL_EXITD_PUSH_PROTECT(BgL_top2845z00_2932, BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BUNSPEC; 
{ /* Llib/avahi.scm 258 */
obj_t BgL_tmp2844z00_2931;
{ /* Llib/avahi.scm 259 */
obj_t BgL_g1888z00_74;
BgL_g1888z00_74 = BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 259 */

BgL_tmp2844z00_2931 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
BGl_deletez12z12zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_oz00_8), BgL_g1888z00_74, BGl_equalzf3zd2envz21zz__r4_equivalence_6_2z00), BUNSPEC) ; } } 
BGL_EXITD_POP_PROTECT(BgL_top2845z00_2932); BUNSPEC; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
return BgL_tmp2844z00_2931;} } } 

}



/* %avahi-thread-init! */
BGL_EXPORTED_DEF obj_t BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 264 */
if(
BGl_isazf3zf3zz__objectz00(BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00, BGl_threadz00zz__threadz00))
{ /* Llib/avahi.scm 265 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 267 */
obj_t BgL_lkz00_77;obj_t BgL_cvz00_78;
{ /* Llib/avahi.scm 267 */

{ /* Llib/avahi.scm 267 */
obj_t BgL_namez00_94;
BgL_namez00_94 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)1))); 
{ /* Llib/avahi.scm 267 */

BgL_lkz00_77 = 
bgl_make_mutex(BgL_namez00_94); } } } 
{ /* Llib/avahi.scm 268 */

{ /* Llib/avahi.scm 268 */
obj_t BgL_namez00_95;
BgL_namez00_95 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)2))); 
{ /* Llib/avahi.scm 268 */

BgL_cvz00_78 = 
bgl_make_condvar(BgL_namez00_95); } } } 
{ /* Llib/avahi.scm 270 */
BgL_pthreadz00_bglt BgL_new1144z00_79;
{ /* Llib/avahi.scm 271 */
BgL_pthreadz00_bglt BgL_new1143z00_88;
BgL_new1143z00_88 = 
((BgL_pthreadz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pthreadz00_bgl) ))); 
{ /* Llib/avahi.scm 271 */
long BgL_arg1330z00_89;
BgL_arg1330z00_89 = 
BGL_CLASS_INDEX(BGl_pthreadz00zz__pth_threadz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1143z00_88), BgL_arg1330z00_89); } 
BgL_new1144z00_79 = BgL_new1143z00_88; } 
((((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_new1144z00_79)))->BgL_namez00)=((obj_t)BGl_string2347z00zz__avahi_avahiz00),BUNSPEC); 
{ 
obj_t BgL_auxz00_2954;
{ /* Llib/avahi.scm 272 */
obj_t BgL_zc3z04anonymousza31323ze3z87_1756;
BgL_zc3z04anonymousza31323ze3z87_1756 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31323ze3ze5zz__avahi_avahiz00, 
(int)(((long)0)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31323ze3z87_1756, 
(int)(((long)0)), BgL_lkz00_77); 
PROCEDURE_SET(BgL_zc3z04anonymousza31323ze3z87_1756, 
(int)(((long)1)), BgL_cvz00_78); 
BgL_auxz00_2954 = BgL_zc3z04anonymousza31323ze3z87_1756; } 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1144z00_79))->BgL_bodyz00)=((obj_t)BgL_auxz00_2954),BUNSPEC); } 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1144z00_79))->BgL_detachedpz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1144z00_79))->BgL_endzd2resultzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1144z00_79))->BgL_endzd2exceptionzd2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pthreadz00_bglt)COBJECT(BgL_new1144z00_79))->BgL_z42builtinz42)=((void *)
BGl_z42pthreadzd2nilz90zz__pth_threadz00()),BUNSPEC); 
{ /* Llib/avahi.scm 270 */
obj_t BgL_fun1325z00_87;
BgL_fun1325z00_87 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_pthreadz00zz__pth_threadz00); 
PROCEDURE_ENTRY(BgL_fun1325z00_87)(BgL_fun1325z00_87, 
((obj_t)BgL_new1144z00_79), BEOA); } 
BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00 = 
((obj_t)BgL_new1144z00_79); } 
{ /* Llib/avahi.scm 281 */
obj_t BgL_top2848z00_2976;
BgL_top2848z00_2976 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_lkz00_77); 
BGL_EXITD_PUSH_PROTECT(BgL_top2848z00_2976, BgL_lkz00_77); BUNSPEC; 
{ /* Llib/avahi.scm 281 */
obj_t BgL_tmp2847z00_2975;
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BGl_za2avahizd2threadza2zd2zz__avahi_avahiz00), BNIL); 
{ /* Llib/avahi.scm 283 */

BgL_tmp2847z00_2975 = 
BBOOL(
BGL_CONDVAR_WAIT(BgL_cvz00_78, BgL_lkz00_77)); } 
BGL_EXITD_POP_PROTECT(BgL_top2848z00_2976); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_lkz00_77); 
return BgL_tmp2847z00_2975;} } } } 

}



/* &%avahi-thread-init! */
obj_t BGl_z62z52avahizd2threadzd2initz12z22zz__avahi_avahiz00(obj_t BgL_envz00_1757)
{
{ /* Llib/avahi.scm 264 */
return 
BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00();} 

}



/* &<@anonymous:1323> */
obj_t BGl_z62zc3z04anonymousza31323ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_1758)
{
{ /* Llib/avahi.scm 272 */
{ /* Llib/avahi.scm 273 */
obj_t BgL_lkz00_1759;obj_t BgL_cvz00_1760;
BgL_lkz00_1759 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1758, 
(int)(((long)0)))); 
BgL_cvz00_1760 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1758, 
(int)(((long)1)))); 
BGL_MUTEX_LOCK(BgL_lkz00_1759); 
{ /* Llib/avahi.scm 273 */
bool_t BgL_tmp2849z00_2993;
BgL_tmp2849z00_2993 = 
BGL_CONDVAR_SIGNAL(BgL_cvz00_1760); 
BGL_MUTEX_UNLOCK(BgL_lkz00_1759); BgL_tmp2849z00_2993; } 
{ 

BgL_loopz00_2482:
BGL_MUTEX_LOCK(BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 276 */
bool_t BgL_tmp2850z00_2997;
{ /* Llib/avahi.scm 278 */
obj_t BgL_g1167z00_2483;obj_t BgL_g1168z00_2484;
BgL_g1167z00_2483 = BGl_za2avahizd2condvza2zd2zz__avahi_avahiz00; 
BgL_g1168z00_2484 = BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 277 */

BgL_tmp2850z00_2997 = 
BGL_CONDVAR_WAIT(BgL_g1167z00_2483, BgL_g1168z00_2484); } } 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2mutexza2zd2zz__avahi_avahiz00); BgL_tmp2850z00_2997; } 
bgl_avahi_invoke_callbacks(); BUNSPEC; 
goto BgL_loopz00_2482;} } } 

}



/* avahi-simple-poll-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_11)
{
{ /* Llib/avahi.scm 304 */
bgl_avahi_simple_poll_close(BgL_oz00_11); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_11)); 
return BUNSPEC;} 

}



/* &avahi-simple-poll-close */
obj_t BGl_z62avahizd2simplezd2pollzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1761, obj_t BgL_oz00_1762)
{
{ /* Llib/avahi.scm 304 */
{ /* Llib/avahi.scm 305 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3005;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1762, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 305 */
BgL_auxz00_3005 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1762)
; }  else 
{ 
obj_t BgL_auxz00_3009;
BgL_auxz00_3009 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)12511)), BGl_string2348z00zz__avahi_avahiz00, BGl_string2349z00zz__avahi_avahiz00, BgL_oz00_1762); 
FAILURE(BgL_auxz00_3009,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3005);} } 

}



/* avahi-simple-poll-loop */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_12)
{
{ /* Llib/avahi.scm 312 */
{ /* Llib/avahi.scm 314 */
AvahiSimplePoll * BgL_arg1333z00_1267;
BgL_arg1333z00_1267 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_12))->BgL_z42builtinz42); 
avahi_simple_poll_loop(BgL_arg1333z00_1267); BUNSPEC; } 
return 
((obj_t)BgL_oz00_12);} 

}



/* &avahi-simple-poll-loop */
obj_t BGl_z62avahizd2simplezd2pollzd2loopzb0zz__avahi_avahiz00(obj_t BgL_envz00_1763, obj_t BgL_oz00_1764)
{
{ /* Llib/avahi.scm 312 */
{ /* Llib/avahi.scm 313 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3017;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1764, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 313 */
BgL_auxz00_3017 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1764)
; }  else 
{ 
obj_t BgL_auxz00_3021;
BgL_auxz00_3021 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)12834)), BGl_string2350z00zz__avahi_avahiz00, BGl_string2349z00zz__avahi_avahiz00, BgL_oz00_1764); 
FAILURE(BgL_auxz00_3021,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2loopzd2zz__avahi_avahiz00(BgL_auxz00_3017);} } 

}



/* avahi-simple-poll-timeout */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_13, long BgL_tz00_14, obj_t BgL_procz00_15)
{
{ /* Llib/avahi.scm 320 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_procz00_15, 
(int)(((long)0))))
{ /* Llib/avahi.scm 321 */
{ 
obj_t BgL_auxz00_3029;
{ /* Llib/avahi.scm 323 */
obj_t BgL_arg1338z00_100;
BgL_arg1338z00_100 = 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_13)))->BgL_z52procsz52); 
BgL_auxz00_3029 = 
MAKE_YOUNG_PAIR(BgL_procz00_15, BgL_arg1338z00_100); } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_13)))->BgL_z52procsz52)=((obj_t)BgL_auxz00_3029),BUNSPEC); } 
{ /* Llib/avahi.scm 324 */
AvahiSimplePoll * BgL_arg1339z00_101;
BgL_arg1339z00_101 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_13))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 324 */
long BgL_tmpz00_3036;
BgL_tmpz00_3036 = 
(long)(BgL_tz00_14); 
bgl_avahi_simple_poll_timeout(BgL_arg1339z00_101, BgL_tmpz00_3036, BgL_procz00_15); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 325 */
char * BgL_procz00_1268;char * BgL_msgz00_1269;
BgL_procz00_1268 = 
BSTRING_TO_STRING(BGl_string2351z00zz__avahi_avahiz00); 
BgL_msgz00_1269 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_1271;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_1272;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1273;
BgL_new1141z00_1273 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_1274;
BgL_arg1319z00_1274 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_1273), BgL_arg1319z00_1274); } 
BgL_new1142z00_1272 = BgL_new1141z00_1273; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1272)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1272)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3049;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_1278;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_1279;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1280;
BgL_classz00_1280 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_1279 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1280); } 
BgL_arg1281z00_1278 = 
VECTOR_REF(BgL_arg1318z00_1279,((long)2)); } 
BgL_auxz00_3049 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_1278); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1272)))->BgL_stackz00)=((obj_t)BgL_auxz00_3049),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1272)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1268)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1272)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1269)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1272)))->BgL_objz00)=((obj_t)BgL_procz00_15),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_1272))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_1271 = BgL_new1142z00_1272; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_1271));} } } 

}



/* &avahi-simple-poll-timeout */
obj_t BGl_z62avahizd2simplezd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t BgL_envz00_1765, obj_t BgL_oz00_1766, obj_t BgL_tz00_1767, obj_t BgL_procz00_1768)
{
{ /* Llib/avahi.scm 320 */
{ /* Llib/avahi.scm 321 */
obj_t BgL_auxz00_3083;long BgL_auxz00_3074;BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3066;
if(
PROCEDUREP(BgL_procz00_1768))
{ /* Llib/avahi.scm 321 */
BgL_auxz00_3083 = BgL_procz00_1768
; }  else 
{ 
obj_t BgL_auxz00_3086;
BgL_auxz00_3086 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2353z00zz__avahi_avahiz00, BGl_string2354z00zz__avahi_avahiz00, BgL_procz00_1768); 
FAILURE(BgL_auxz00_3086,BFALSE,BFALSE);} 
{ /* Llib/avahi.scm 321 */
obj_t BgL_tmpz00_3075;
if(
INTEGERP(BgL_tz00_1767))
{ /* Llib/avahi.scm 321 */
BgL_tmpz00_3075 = BgL_tz00_1767
; }  else 
{ 
obj_t BgL_auxz00_3078;
BgL_auxz00_3078 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2353z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_tz00_1767); 
FAILURE(BgL_auxz00_3078,BFALSE,BFALSE);} 
BgL_auxz00_3074 = 
(long)CINT(BgL_tmpz00_3075); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1766, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 321 */
BgL_auxz00_3066 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1766)
; }  else 
{ 
obj_t BgL_auxz00_3070;
BgL_auxz00_3070 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)13237)), BGl_string2353z00zz__avahi_avahiz00, BGl_string2349z00zz__avahi_avahiz00, BgL_oz00_1766); 
FAILURE(BgL_auxz00_3070,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_auxz00_3066, BgL_auxz00_3074, BgL_auxz00_3083);} } 

}



/* avahi-simple-poll-quit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2simplezd2pollz00_bglt BgL_oz00_16)
{
{ /* Llib/avahi.scm 331 */
{ /* Llib/avahi.scm 333 */
AvahiSimplePoll * BgL_arg1341z00_1283;
BgL_arg1341z00_1283 = 
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_oz00_16))->BgL_z42builtinz42); 
avahi_simple_poll_quit(BgL_arg1341z00_1283); BUNSPEC; } 
return 
((obj_t)BgL_oz00_16);} 

}



/* &avahi-simple-poll-quit */
obj_t BGl_z62avahizd2simplezd2pollzd2quitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1769, obj_t BgL_oz00_1770)
{
{ /* Llib/avahi.scm 331 */
{ /* Llib/avahi.scm 332 */
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_3094;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1770, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 332 */
BgL_auxz00_3094 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_1770)
; }  else 
{ 
obj_t BgL_auxz00_3098;
BgL_auxz00_3098 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)13797)), BGl_string2355z00zz__avahi_avahiz00, BGl_string2349z00zz__avahi_avahiz00, BgL_oz00_1770); 
FAILURE(BgL_auxz00_3098,BFALSE,BFALSE);} 
return 
BGl_avahizd2simplezd2pollzd2quitzd2zz__avahi_avahiz00(BgL_auxz00_3094);} } 

}



/* avahi-threaded-poll-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_18)
{
{ /* Llib/avahi.scm 350 */
bgl_avahi_threaded_poll_close(BgL_oz00_18); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_18)); 
return BUNSPEC;} 

}



/* &avahi-threaded-poll-close */
obj_t BGl_z62avahizd2threadedzd2pollzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1771, obj_t BgL_oz00_1772)
{
{ /* Llib/avahi.scm 350 */
{ /* Llib/avahi.scm 351 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3106;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1772, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 351 */
BgL_auxz00_3106 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1772)
; }  else 
{ 
obj_t BgL_auxz00_3110;
BgL_auxz00_3110 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)14645)), BGl_string2356z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1772); 
FAILURE(BgL_auxz00_3110,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3106);} } 

}



/* avahi-threaded-poll-loop */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_19)
{
{ /* Llib/avahi.scm 358 */
{ /* Llib/avahi.scm 360 */
AvahiThreadedPoll * BgL_arg1344z00_1285;
BgL_arg1344z00_1285 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_19))->BgL_z42builtinz42); 
avahi_threaded_poll_start(BgL_arg1344z00_1285); BUNSPEC; } 
return 
((obj_t)BgL_oz00_19);} 

}



/* &avahi-threaded-poll-loop */
obj_t BGl_z62avahizd2threadedzd2pollzd2loopzb0zz__avahi_avahiz00(obj_t BgL_envz00_1773, obj_t BgL_oz00_1774)
{
{ /* Llib/avahi.scm 358 */
{ /* Llib/avahi.scm 359 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3118;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1774, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 359 */
BgL_auxz00_3118 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1774)
; }  else 
{ 
obj_t BgL_auxz00_3122;
BgL_auxz00_3122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)14972)), BGl_string2358z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1774); 
FAILURE(BgL_auxz00_3122,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2loopzd2zz__avahi_avahiz00(BgL_auxz00_3118);} } 

}



/* avahi-threaded-poll-lock! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_20)
{
{ /* Llib/avahi.scm 366 */
{ /* Llib/avahi.scm 368 */
AvahiThreadedPoll * BgL_arg1345z00_1287;
BgL_arg1345z00_1287 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_20))->BgL_z42builtinz42); 
avahi_threaded_poll_lock(BgL_arg1345z00_1287); BUNSPEC; } 
return 
((obj_t)BgL_oz00_20);} 

}



/* &avahi-threaded-poll-lock! */
obj_t BGl_z62avahizd2threadedzd2pollzd2lockz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1775, obj_t BgL_oz00_1776)
{
{ /* Llib/avahi.scm 366 */
{ /* Llib/avahi.scm 367 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3130;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1776, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 367 */
BgL_auxz00_3130 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1776)
; }  else 
{ 
obj_t BgL_auxz00_3134;
BgL_auxz00_3134 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)15357)), BGl_string2359z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1776); 
FAILURE(BgL_auxz00_3134,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2lockz12zc0zz__avahi_avahiz00(BgL_auxz00_3130);} } 

}



/* avahi-threaded-poll-unlock! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_21)
{
{ /* Llib/avahi.scm 374 */
{ /* Llib/avahi.scm 376 */
AvahiThreadedPoll * BgL_arg1346z00_1289;
BgL_arg1346z00_1289 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_21))->BgL_z42builtinz42); 
avahi_threaded_poll_unlock(BgL_arg1346z00_1289); BUNSPEC; } 
return 
((obj_t)BgL_oz00_21);} 

}



/* &avahi-threaded-poll-unlock! */
obj_t BGl_z62avahizd2threadedzd2pollzd2unlockz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1777, obj_t BgL_oz00_1778)
{
{ /* Llib/avahi.scm 374 */
{ /* Llib/avahi.scm 375 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3142;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1778, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 375 */
BgL_auxz00_3142 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1778)
; }  else 
{ 
obj_t BgL_auxz00_3146;
BgL_auxz00_3146 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)15744)), BGl_string2360z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1778); 
FAILURE(BgL_auxz00_3146,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2unlockz12zc0zz__avahi_avahiz00(BgL_auxz00_3142);} } 

}



/* avahi-threaded-poll-timeout */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_22, long BgL_tz00_23, obj_t BgL_procz00_24)
{
{ /* Llib/avahi.scm 382 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_procz00_24, 
(int)(((long)0))))
{ /* Llib/avahi.scm 383 */
{ 
obj_t BgL_auxz00_3154;
{ /* Llib/avahi.scm 385 */
obj_t BgL_arg1356z00_112;
BgL_arg1356z00_112 = 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_22)))->BgL_z52procsz52); 
BgL_auxz00_3154 = 
MAKE_YOUNG_PAIR(BgL_procz00_24, BgL_arg1356z00_112); } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_22)))->BgL_z52procsz52)=((obj_t)BgL_auxz00_3154),BUNSPEC); } 
{ /* Llib/avahi.scm 386 */
AvahiThreadedPoll * BgL_arg1357z00_113;
BgL_arg1357z00_113 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_22))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 386 */
long BgL_tmpz00_3161;
BgL_tmpz00_3161 = 
(long)(BgL_tz00_23); 
bgl_avahi_threaded_poll_timeout(BgL_arg1357z00_113, BgL_tmpz00_3161, BgL_procz00_24); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 387 */
char * BgL_procz00_1290;char * BgL_msgz00_1291;
BgL_procz00_1290 = 
BSTRING_TO_STRING(BGl_string2361z00zz__avahi_avahiz00); 
BgL_msgz00_1291 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_1293;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_1294;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1295;
BgL_new1141z00_1295 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_1296;
BgL_arg1319z00_1296 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_1295), BgL_arg1319z00_1296); } 
BgL_new1142z00_1294 = BgL_new1141z00_1295; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1294)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1294)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3174;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_1300;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_1301;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1302;
BgL_classz00_1302 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_1301 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1302); } 
BgL_arg1281z00_1300 = 
VECTOR_REF(BgL_arg1318z00_1301,((long)2)); } 
BgL_auxz00_3174 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_1300); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1294)))->BgL_stackz00)=((obj_t)BgL_auxz00_3174),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1294)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1290)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1294)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1291)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1294)))->BgL_objz00)=((obj_t)BgL_procz00_24),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_1294))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_1293 = BgL_new1142z00_1294; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_1293));} } } 

}



/* &avahi-threaded-poll-timeout */
obj_t BGl_z62avahizd2threadedzd2pollzd2timeoutzb0zz__avahi_avahiz00(obj_t BgL_envz00_1779, obj_t BgL_oz00_1780, obj_t BgL_tz00_1781, obj_t BgL_procz00_1782)
{
{ /* Llib/avahi.scm 382 */
{ /* Llib/avahi.scm 383 */
obj_t BgL_auxz00_3208;long BgL_auxz00_3199;BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3191;
if(
PROCEDUREP(BgL_procz00_1782))
{ /* Llib/avahi.scm 383 */
BgL_auxz00_3208 = BgL_procz00_1782
; }  else 
{ 
obj_t BgL_auxz00_3211;
BgL_auxz00_3211 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2362z00zz__avahi_avahiz00, BGl_string2354z00zz__avahi_avahiz00, BgL_procz00_1782); 
FAILURE(BgL_auxz00_3211,BFALSE,BFALSE);} 
{ /* Llib/avahi.scm 383 */
obj_t BgL_tmpz00_3200;
if(
INTEGERP(BgL_tz00_1781))
{ /* Llib/avahi.scm 383 */
BgL_tmpz00_3200 = BgL_tz00_1781
; }  else 
{ 
obj_t BgL_auxz00_3203;
BgL_auxz00_3203 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2362z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_tz00_1781); 
FAILURE(BgL_auxz00_3203,BFALSE,BFALSE);} 
BgL_auxz00_3199 = 
(long)CINT(BgL_tmpz00_3200); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1780, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 383 */
BgL_auxz00_3191 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1780)
; }  else 
{ 
obj_t BgL_auxz00_3195;
BgL_auxz00_3195 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)16157)), BGl_string2362z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1780); 
FAILURE(BgL_auxz00_3195,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2timeoutzd2zz__avahi_avahiz00(BgL_auxz00_3191, BgL_auxz00_3199, BgL_auxz00_3208);} } 

}



/* avahi-threaded-poll-quit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_avahizd2threadedzd2pollz00_bglt BgL_oz00_25)
{
{ /* Llib/avahi.scm 393 */
{ /* Llib/avahi.scm 395 */
AvahiThreadedPoll * BgL_arg1358z00_1305;
BgL_arg1358z00_1305 = 
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_oz00_25))->BgL_z42builtinz42); 
avahi_threaded_poll_stop(BgL_arg1358z00_1305); BUNSPEC; } 
return 
((obj_t)BgL_oz00_25);} 

}



/* &avahi-threaded-poll-quit */
obj_t BGl_z62avahizd2threadedzd2pollzd2quitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1783, obj_t BgL_oz00_1784)
{
{ /* Llib/avahi.scm 393 */
{ /* Llib/avahi.scm 394 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_3219;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1784, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 394 */
BgL_auxz00_3219 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_1784)
; }  else 
{ 
obj_t BgL_auxz00_3223;
BgL_auxz00_3223 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)16727)), BGl_string2363z00zz__avahi_avahiz00, BGl_string2357z00zz__avahi_avahiz00, BgL_oz00_1784); 
FAILURE(BgL_auxz00_3223,BFALSE,BFALSE);} 
return 
BGl_avahizd2threadedzd2pollzd2quitzd2zz__avahi_avahiz00(BgL_auxz00_3219);} } 

}



/* avahi-client-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt BgL_oz00_27)
{
{ /* Llib/avahi.scm 413 */
bgl_avahi_client_close(BgL_oz00_27); BUNSPEC; 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_z52groupsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_z52browsersz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_27))->BgL_resolversz00)=((obj_t)BNIL),BUNSPEC); 
return 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_27));} 

}



/* &avahi-client-close */
obj_t BGl_z62avahizd2clientzd2closez62zz__avahi_avahiz00(obj_t BgL_envz00_1785, obj_t BgL_oz00_1786)
{
{ /* Llib/avahi.scm 413 */
{ /* Llib/avahi.scm 414 */
BgL_avahizd2clientzd2_bglt BgL_auxz00_3234;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1786, BGl_avahizd2clientzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 414 */
BgL_auxz00_3234 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_1786)
; }  else 
{ 
obj_t BgL_auxz00_3238;
BgL_auxz00_3238 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)17628)), BGl_string2364z00zz__avahi_avahiz00, BGl_string2365z00zz__avahi_avahiz00, BgL_oz00_1786); 
FAILURE(BgL_auxz00_3238,BFALSE,BFALSE);} 
return 
BGl_avahizd2clientzd2closez00zz__avahi_avahiz00(BgL_auxz00_3234);} } 

}



/* avahi-client-error-message */
BGL_EXPORTED_DEF obj_t BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_avahizd2clientzd2_bglt BgL_oz00_28)
{
{ /* Llib/avahi.scm 424 */
{ /* Llib/avahi.scm 426 */
int BgL_arg1359z00_1307;
{ /* Llib/avahi.scm 426 */
AvahiClient * BgL_tmpz00_3243;
BgL_tmpz00_3243 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_oz00_28))->BgL_z42builtinz42); 
BgL_arg1359z00_1307 = 
avahi_client_errno(BgL_tmpz00_3243); } 
return 
string_to_bstring(
(char *)avahi_strerror(BgL_arg1359z00_1307));} } 

}



/* &avahi-client-error-message */
obj_t BGl_z62avahizd2clientzd2errorzd2messagezb0zz__avahi_avahiz00(obj_t BgL_envz00_1787, obj_t BgL_oz00_1788)
{
{ /* Llib/avahi.scm 424 */
{ /* Llib/avahi.scm 425 */
BgL_avahizd2clientzd2_bglt BgL_auxz00_3248;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1788, BGl_avahizd2clientzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 425 */
BgL_auxz00_3248 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_1788)
; }  else 
{ 
obj_t BgL_auxz00_3252;
BgL_auxz00_3252 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)18076)), BGl_string2366z00zz__avahi_avahiz00, BGl_string2365z00zz__avahi_avahiz00, BgL_oz00_1788); 
FAILURE(BgL_auxz00_3252,BFALSE,BFALSE);} 
return 
BGl_avahizd2clientzd2errorzd2messagezd2zz__avahi_avahiz00(BgL_auxz00_3248);} } 

}



/* avahi-client-state->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_client_state_to_symbol(AvahiClientState BgL_statez00_29)
{
{ /* Llib/avahi.scm 431 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_REGISTERING))
{ /* Llib/avahi.scm 433 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/avahi.scm 433 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_RUNNING))
{ /* Llib/avahi.scm 435 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/avahi.scm 435 */
if(
(BgL_statez00_29==AVAHI_CLIENT_S_COLLISION))
{ /* Llib/avahi.scm 437 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/avahi.scm 437 */
if(
(BgL_statez00_29==AVAHI_CLIENT_FAILURE))
{ /* Llib/avahi.scm 439 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/avahi.scm 439 */
if(
(BgL_statez00_29==AVAHI_CLIENT_CONNECTING))
{ /* Llib/avahi.scm 441 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Llib/avahi.scm 444 */
char * BgL_procz00_1319;char * BgL_msgz00_1320;
BgL_procz00_1319 = 
BSTRING_TO_STRING(BGl_string2367z00zz__avahi_avahiz00); 
BgL_msgz00_1320 = 
BSTRING_TO_STRING(BGl_string2368z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_1322;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_1323;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_1324;
BgL_new1141z00_1324 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_1325;
BgL_arg1319z00_1325 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_1324), BgL_arg1319z00_1325); } 
BgL_new1142z00_1323 = BgL_new1141z00_1324; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1323)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1323)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3282;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_1329;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_1330;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_1331;
BgL_classz00_1331 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_1330 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1331); } 
BgL_arg1281z00_1329 = 
VECTOR_REF(BgL_arg1318z00_1330,((long)2)); } 
BgL_auxz00_3282 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_1329); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_1323)))->BgL_stackz00)=((obj_t)BgL_auxz00_3282),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1323)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_1319)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1323)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_1320)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_1323)))->BgL_objz00)=((obj_t)
BINT(BgL_statez00_29)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_1323))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_1322 = BgL_new1142z00_1323; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_1322));} } } } } } } 

}



/* &avahi-client-state->symbol */
obj_t BGl_z62avahizd2clientzd2statezd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1789, obj_t BgL_statez00_1790)
{
{ /* Llib/avahi.scm 431 */
{ /* Llib/avahi.scm 433 */
AvahiClientState BgL_auxz00_3300;
{ /* Llib/avahi.scm 433 */
obj_t BgL_tmpz00_3301;
if(
INTEGERP(BgL_statez00_1790))
{ /* Llib/avahi.scm 433 */
BgL_tmpz00_3301 = BgL_statez00_1790
; }  else 
{ 
obj_t BgL_auxz00_3304;
BgL_auxz00_3304 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)18475)), BGl_string2369z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_statez00_1790); 
FAILURE(BgL_auxz00_3304,BFALSE,BFALSE);} 
BgL_auxz00_3300 = 
(long)CINT(BgL_tmpz00_3301); } 
return 
bgl_avahi_client_state_to_symbol(BgL_auxz00_3300);} } 

}



/* avahi-entry-group-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_31)
{
{ /* Llib/avahi.scm 463 */
bgl_avahi_entry_group_close(BgL_oz00_31); BUNSPEC; 
{ /* Llib/avahi.scm 466 */
BgL_avahizd2clientzd2_bglt BgL_i1161z00_126;
BgL_i1161z00_126 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_31))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3312;
{ /* Llib/avahi.scm 467 */
obj_t BgL_arg1389z00_127;
BgL_arg1389z00_127 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1161z00_126))->BgL_z52groupsz52); 
BgL_auxz00_3312 = 
bgl_remq_bang(
((obj_t)BgL_oz00_31), BgL_arg1389z00_127); } 
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1161z00_126))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_3312),BUNSPEC);} } } 

}



/* &avahi-entry-group-close */
obj_t BGl_z62avahizd2entryzd2groupzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1791, obj_t BgL_oz00_1792)
{
{ /* Llib/avahi.scm 463 */
{ /* Llib/avahi.scm 464 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3317;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1792, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 464 */
BgL_auxz00_3317 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1792)
; }  else 
{ 
obj_t BgL_auxz00_3321;
BgL_auxz00_3321 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)19887)), BGl_string2370z00zz__avahi_avahiz00, BGl_string2371z00zz__avahi_avahiz00, BgL_oz00_1792); 
FAILURE(BgL_auxz00_3321,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3317);} } 

}



/* avahi-entry-group-empty? */
BGL_EXPORTED_DEF bool_t BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_32)
{
{ /* Llib/avahi.scm 472 */
{ /* Llib/avahi.scm 474 */
AvahiEntryGroup * BgL_arg1390z00_1334;
BgL_arg1390z00_1334 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_32))->BgL_z42builtinz42); 
avahi_entry_group_is_empty(BgL_arg1390z00_1334); 
return ((bool_t)1);} } 

}



/* &avahi-entry-group-empty? */
obj_t BGl_z62avahizd2entryzd2groupzd2emptyzf3z43zz__avahi_avahiz00(obj_t BgL_envz00_1793, obj_t BgL_oz00_1794)
{
{ /* Llib/avahi.scm 472 */
{ /* Llib/avahi.scm 473 */
bool_t BgL_tmpz00_3328;
{ /* Llib/avahi.scm 473 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3329;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1794, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 473 */
BgL_auxz00_3329 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1794)
; }  else 
{ 
obj_t BgL_auxz00_3333;
BgL_auxz00_3333 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)20314)), BGl_string2372z00zz__avahi_avahiz00, BGl_string2371z00zz__avahi_avahiz00, BgL_oz00_1794); 
FAILURE(BgL_auxz00_3333,BFALSE,BFALSE);} 
BgL_tmpz00_3328 = 
BGl_avahizd2entryzd2groupzd2emptyzf3z21zz__avahi_avahiz00(BgL_auxz00_3329); } 
return 
BBOOL(BgL_tmpz00_3328);} } 

}



/* avahi-entry-group-commit */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_33)
{
{ /* Llib/avahi.scm 479 */
{ /* Llib/avahi.scm 481 */
int BgL_nz00_131;
{ /* Llib/avahi.scm 481 */
AvahiEntryGroup * BgL_tmpz00_3339;
BgL_tmpz00_3339 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_33))->BgL_z42builtinz42); 
BgL_nz00_131 = 
avahi_entry_group_commit(BgL_tmpz00_3339); } 
if(
(
(long)(BgL_nz00_131)>=((long)0)))
{ /* Llib/avahi.scm 482 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 483 */
char * BgL_arg1431z00_133;
BgL_arg1431z00_133 = 
(char *)avahi_strerror(BgL_nz00_131); 
return 
bgl_avahi_error(
BSTRING_TO_STRING(BGl_string2371z00zz__avahi_avahiz00), BgL_arg1431z00_133, 
((obj_t)BgL_oz00_33), BgL_nz00_131);} } } 

}



/* &avahi-entry-group-commit */
obj_t BGl_z62avahizd2entryzd2groupzd2commitzb0zz__avahi_avahiz00(obj_t BgL_envz00_1795, obj_t BgL_oz00_1796)
{
{ /* Llib/avahi.scm 479 */
{ /* Llib/avahi.scm 480 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3349;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1796, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 480 */
BgL_auxz00_3349 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1796)
; }  else 
{ 
obj_t BgL_auxz00_3353;
BgL_auxz00_3353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)20686)), BGl_string2373z00zz__avahi_avahiz00, BGl_string2371z00zz__avahi_avahiz00, BgL_oz00_1796); 
FAILURE(BgL_auxz00_3353,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2commitzd2zz__avahi_avahiz00(BgL_auxz00_3349);} } 

}



/* avahi-entry-group-reset! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_34)
{
{ /* Llib/avahi.scm 488 */
{ /* Llib/avahi.scm 490 */
BgL_avahizd2clientzd2_bglt BgL_i1165z00_136;
BgL_i1165z00_136 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_34))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3359;
{ /* Llib/avahi.scm 491 */
obj_t BgL_arg1507z00_137;
BgL_arg1507z00_137 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1165z00_136))->BgL_z52groupsz52); 
BgL_auxz00_3359 = 
bgl_remq_bang(
((obj_t)BgL_oz00_34), BgL_arg1507z00_137); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1165z00_136))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_3359),BUNSPEC); } } 
{ /* Llib/avahi.scm 492 */
int BgL_nz00_138;
{ /* Llib/avahi.scm 492 */
AvahiEntryGroup * BgL_tmpz00_3364;
BgL_tmpz00_3364 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_34))->BgL_z42builtinz42); 
BgL_nz00_138 = 
avahi_entry_group_reset(BgL_tmpz00_3364); } 
if(
(
(long)(BgL_nz00_138)>=((long)0)))
{ /* Llib/avahi.scm 493 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 494 */
char * BgL_arg1512z00_140;
BgL_arg1512z00_140 = 
(char *)avahi_strerror(BgL_nz00_138); 
return 
bgl_avahi_error(
BSTRING_TO_STRING(BGl_string2371z00zz__avahi_avahiz00), BgL_arg1512z00_140, 
((obj_t)BgL_oz00_34), BgL_nz00_138);} } } 

}



/* &avahi-entry-group-reset! */
obj_t BGl_z62avahizd2entryzd2groupzd2resetz12za2zz__avahi_avahiz00(obj_t BgL_envz00_1797, obj_t BgL_oz00_1798)
{
{ /* Llib/avahi.scm 488 */
{ /* Llib/avahi.scm 489 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3374;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1798, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 489 */
BgL_auxz00_3374 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1798)
; }  else 
{ 
obj_t BgL_auxz00_3378;
BgL_auxz00_3378 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)21155)), BGl_string2374z00zz__avahi_avahiz00, BGl_string2371z00zz__avahi_avahiz00, BgL_oz00_1798); 
FAILURE(BgL_auxz00_3378,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2resetz12zc0zz__avahi_avahiz00(BgL_auxz00_3374);} } 

}



/* avahi-entry-group-add-service! */
BGL_EXPORTED_DEF obj_t BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_35, obj_t BgL_namez00_36)
{
{ /* Llib/avahi.scm 499 */
{ /* Llib/avahi.scm 186 */
obj_t BgL_namez00_143;
BgL_namez00_143 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)8)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_typez00_144;
BgL_typez00_144 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)9)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_domainz00_145;
BgL_domainz00_145 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)10)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_hostz00_146;
BgL_hostz00_146 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)11)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_portz00_147;
BgL_portz00_147 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)12)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_subtypez00_148;
BgL_subtypez00_148 = 
BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)13)), BFALSE); 
{ /* Llib/avahi.scm 186 */
obj_t BgL_txtz00_149;
BgL_txtz00_149 = 
BGl_dssslzd2getzd2keyzd2restzd2argz00zz__dssslz00(BgL_namez00_36, 
CNST_TABLE_REF(((long)14))); 
if(
CBOOL(BgL_subtypez00_148))
{ /* Llib/avahi.scm 523 */
int BgL_arg1517z00_152;
{ /* Llib/avahi.scm 523 */
AvahiEntryGroup * BgL_arg1524z00_153;obj_t BgL_arg1530z00_154;
BgL_arg1524z00_153 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 529 */
BgL_arg1530z00_154 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 529 */
BgL_arg1530z00_154 = 
string_to_bstring(
((char *)0L)); } 
{ /* Llib/avahi.scm 523 */
char * BgL_auxz00_3410;char * BgL_auxz00_3408;char * BgL_auxz00_3406;char * BgL_tmpz00_3404;
BgL_auxz00_3410 = 
BSTRING_TO_STRING(BgL_subtypez00_148); 
BgL_auxz00_3408 = 
BSTRING_TO_STRING(BgL_arg1530z00_154); 
BgL_auxz00_3406 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3404 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1517z00_152 = 
avahi_entry_group_add_service_subtype(BgL_arg1524z00_153, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3404, BgL_auxz00_3406, BgL_auxz00_3408, BgL_auxz00_3410); } } 
return 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1517z00_152);}  else 
{ /* Llib/avahi.scm 520 */
if(
PAIRP(BgL_txtz00_149))
{ /* Llib/avahi.scm 533 */
AvahiStringList * BgL_lz00_157;
BgL_lz00_157 = 
bgl_avahi_list_to_string_list(BgL_txtz00_149); 
{ /* Llib/avahi.scm 534 */
obj_t BgL_exitd1174z00_158;
BgL_exitd1174z00_158 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ 
obj_t BgL_zc3z04anonymousza31544ze3z87_1799;
BgL_zc3z04anonymousza31544ze3z87_1799 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31544ze3ze5zz__avahi_avahiz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31544ze3z87_1799, 
(int)(((long)0)), 
void_star_to_obj(BgL_lz00_157)); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1174z00_158, BgL_zc3z04anonymousza31544ze3z87_1799); 
{ /* Llib/avahi.scm 536 */
obj_t BgL_tmp1176z00_160;
{ /* Llib/avahi.scm 536 */
int BgL_arg1538z00_161;
{ /* Llib/avahi.scm 536 */
AvahiEntryGroup * BgL_arg1539z00_162;obj_t BgL_arg1540z00_163;obj_t BgL_arg1543z00_164;
BgL_arg1539z00_162 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 542 */
BgL_arg1540z00_163 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 542 */
BgL_arg1540z00_163 = 
string_to_bstring(
((char *)0L)); } 
if(
CBOOL(BgL_hostz00_146))
{ /* Llib/avahi.scm 543 */
BgL_arg1543z00_164 = BgL_hostz00_146; }  else 
{ /* Llib/avahi.scm 543 */
BgL_arg1543z00_164 = 
string_to_bstring(
((char *)0L)); } 
{ /* Llib/avahi.scm 536 */
int BgL_auxz00_3442;char * BgL_auxz00_3440;char * BgL_auxz00_3438;char * BgL_auxz00_3436;char * BgL_tmpz00_3434;
BgL_auxz00_3442 = 
CINT(BgL_portz00_147); 
BgL_auxz00_3440 = 
BSTRING_TO_STRING(BgL_arg1543z00_164); 
BgL_auxz00_3438 = 
BSTRING_TO_STRING(BgL_arg1540z00_163); 
BgL_auxz00_3436 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3434 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1538z00_161 = 
avahi_entry_group_add_service_strlst(BgL_arg1539z00_162, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3434, BgL_auxz00_3436, BgL_auxz00_3438, BgL_auxz00_3440, BgL_auxz00_3442, BgL_lz00_157); } } 
BgL_tmp1176z00_160 = 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1538z00_161); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1174z00_158); 
avahi_string_list_free(BgL_lz00_157); BUNSPEC; 
return BgL_tmp1176z00_160;} } } }  else 
{ /* Llib/avahi.scm 549 */
int BgL_arg1562z00_169;
{ /* Llib/avahi.scm 549 */
AvahiEntryGroup * BgL_arg1563z00_170;obj_t BgL_arg1564z00_171;obj_t BgL_arg1580z00_172;char * BgL_arg1581z00_173;
BgL_arg1563z00_170 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_oz00_35))->BgL_z42builtinz42); 
if(
CBOOL(BgL_domainz00_145))
{ /* Llib/avahi.scm 555 */
BgL_arg1564z00_171 = BgL_domainz00_145; }  else 
{ /* Llib/avahi.scm 555 */
BgL_arg1564z00_171 = 
string_to_bstring(
((char *)0L)); } 
if(
CBOOL(BgL_hostz00_146))
{ /* Llib/avahi.scm 556 */
BgL_arg1580z00_172 = BgL_hostz00_146; }  else 
{ /* Llib/avahi.scm 556 */
BgL_arg1580z00_172 = 
string_to_bstring(
((char *)0L)); } 
BgL_arg1581z00_173 = 
((char *)0L); 
{ /* Llib/avahi.scm 549 */
int BgL_auxz00_3466;char * BgL_auxz00_3464;char * BgL_auxz00_3462;char * BgL_auxz00_3460;char * BgL_tmpz00_3458;
BgL_auxz00_3466 = 
CINT(BgL_portz00_147); 
BgL_auxz00_3464 = 
BSTRING_TO_STRING(BgL_arg1580z00_172); 
BgL_auxz00_3462 = 
BSTRING_TO_STRING(BgL_arg1564z00_171); 
BgL_auxz00_3460 = 
BSTRING_TO_STRING(BgL_typez00_144); 
BgL_tmpz00_3458 = 
BSTRING_TO_STRING(BgL_namez00_143); 
BgL_arg1562z00_169 = 
avahi_entry_group_add_service(BgL_arg1563z00_170, AVAHI_IF_UNSPEC, AVAHI_PROTO_UNSPEC, 0L, BgL_tmpz00_3458, BgL_auxz00_3460, BgL_auxz00_3462, BgL_auxz00_3464, BgL_auxz00_3466, BgL_arg1581z00_173); } } 
return 
BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_oz00_35, BgL_arg1562z00_169);} } } } } } } } } } 

}



/* check-error~0 */
obj_t BGl_checkzd2errorze70z35zz__avahi_avahiz00(BgL_avahizd2entryzd2groupz00_bglt BgL_oz00_2348, int BgL_nz00_176)
{
{ /* Llib/avahi.scm 516 */
if(
(
(long)(BgL_nz00_176)<((long)0)))
{ /* Llib/avahi.scm 506 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1591z00_179;
if(
(
(long)(BgL_nz00_176)==
(long)(AVAHI_ERR_COLLISION)))
{ /* Llib/avahi.scm 507 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1169z00_181;
{ /* Llib/avahi.scm 507 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1168z00_184;
BgL_new1168z00_184 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 507 */
long BgL_arg1616z00_185;
BgL_arg1616z00_185 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1168z00_184), BgL_arg1616z00_185); } 
BgL_new1169z00_181 = BgL_new1168z00_184; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1169z00_181)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1169z00_181)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3485;
{ /* Llib/avahi.scm 507 */
obj_t BgL_arg1593z00_182;
{ /* Llib/avahi.scm 507 */
obj_t BgL_arg1615z00_183;
{ /* Llib/avahi.scm 507 */
obj_t BgL_classz00_1343;
BgL_classz00_1343 = BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00; 
BgL_arg1615z00_183 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1343); } 
BgL_arg1593z00_182 = 
VECTOR_REF(BgL_arg1615z00_183,((long)2)); } 
BgL_auxz00_3485 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1593z00_182); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1169z00_181)))->BgL_stackz00)=((obj_t)BgL_auxz00_3485),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1169z00_181)))->BgL_procz00)=((obj_t)BGl_string2375z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1169z00_181)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)avahi_strerror(BgL_nz00_176))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1169z00_181)))->BgL_objz00)=((obj_t)
((obj_t)BgL_oz00_2348)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1169z00_181)))->BgL_errnoz00)=((int)BgL_nz00_176),BUNSPEC); 
BgL_arg1591z00_179 = 
((BgL_z62avahizd2errorzb0_bglt)BgL_new1169z00_181); }  else 
{ /* Llib/avahi.scm 512 */
BgL_z62avahizd2errorzb0_bglt BgL_new1171z00_186;
{ /* Llib/avahi.scm 512 */
BgL_z62avahizd2errorzb0_bglt BgL_new1170z00_189;
BgL_new1170z00_189 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 512 */
long BgL_arg1626z00_190;
BgL_arg1626z00_190 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1170z00_189), BgL_arg1626z00_190); } 
BgL_new1171z00_186 = BgL_new1170z00_189; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1171z00_186)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1171z00_186)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3511;
{ /* Llib/avahi.scm 512 */
obj_t BgL_arg1619z00_187;
{ /* Llib/avahi.scm 512 */
obj_t BgL_arg1624z00_188;
{ /* Llib/avahi.scm 512 */
obj_t BgL_classz00_1348;
BgL_classz00_1348 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1624z00_188 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1348); } 
BgL_arg1619z00_187 = 
VECTOR_REF(BgL_arg1624z00_188,((long)2)); } 
BgL_auxz00_3511 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1619z00_187); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1171z00_186)))->BgL_stackz00)=((obj_t)BgL_auxz00_3511),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1171z00_186)))->BgL_procz00)=((obj_t)BGl_string2375z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1171z00_186)))->BgL_msgz00)=((obj_t)
string_to_bstring(
(char *)avahi_strerror(BgL_nz00_176))),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1171z00_186)))->BgL_objz00)=((obj_t)
((obj_t)BgL_oz00_2348)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1171z00_186))->BgL_errnoz00)=((int)BgL_nz00_176),BUNSPEC); 
BgL_arg1591z00_179 = BgL_new1171z00_186; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1591z00_179));}  else 
{ /* Llib/avahi.scm 504 */
return BFALSE;} } 

}



/* &avahi-entry-group-add-service! */
obj_t BGl_z62avahizd2entryzd2groupzd2addzd2servicez12z70zz__avahi_avahiz00(obj_t BgL_envz00_1800, obj_t BgL_oz00_1801, obj_t BgL_namez00_1802)
{
{ /* Llib/avahi.scm 499 */
{ /* Llib/avahi.scm 186 */
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_3529;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1801, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 186 */
BgL_auxz00_3529 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_1801)
; }  else 
{ 
obj_t BgL_auxz00_3533;
BgL_auxz00_3533 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)7339)), BGl_string2376z00zz__avahi_avahiz00, BGl_string2371z00zz__avahi_avahiz00, BgL_oz00_1801); 
FAILURE(BgL_auxz00_3533,BFALSE,BFALSE);} 
return 
BGl_avahizd2entryzd2groupzd2addzd2servicez12z12zz__avahi_avahiz00(BgL_auxz00_3529, BgL_namez00_1802);} } 

}



/* &<@anonymous:1544> */
obj_t BGl_z62zc3z04anonymousza31544ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_1803)
{
{ /* Llib/avahi.scm 534 */
{ 
AvahiStringList * BgL_lz00_1804;
BgL_lz00_1804 = 
FOREIGN_TO_COBJ(
PROCEDURE_REF(BgL_envz00_1803, 
(int)(((long)0)))); 
avahi_string_list_free(BgL_lz00_1804); 
return BUNSPEC;} } 

}



/* avahi-entry-group-state->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_entry_group_state_to_symbol(AvahiEntryGroupState BgL_statez00_37)
{
{ /* Llib/avahi.scm 563 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_UNCOMMITED))
{ /* Llib/avahi.scm 565 */
return 
CNST_TABLE_REF(((long)15));}  else 
{ /* Llib/avahi.scm 565 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_REGISTERING))
{ /* Llib/avahi.scm 567 */
return 
CNST_TABLE_REF(((long)16));}  else 
{ /* Llib/avahi.scm 567 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_ESTABLISHED))
{ /* Llib/avahi.scm 569 */
return 
CNST_TABLE_REF(((long)17));}  else 
{ /* Llib/avahi.scm 569 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_COLLISION))
{ /* Llib/avahi.scm 571 */
return 
CNST_TABLE_REF(((long)18));}  else 
{ /* Llib/avahi.scm 571 */
if(
(BgL_statez00_37==AVAHI_ENTRY_GROUP_FAILURE))
{ /* Llib/avahi.scm 573 */
return 
CNST_TABLE_REF(((long)19));}  else 
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1636z00_197;
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_new1182z00_198;
{ /* Llib/avahi.scm 577 */
BgL_z62avahizd2errorzb0_bglt BgL_new1181z00_201;
BgL_new1181z00_201 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 577 */
long BgL_arg1645z00_202;
BgL_arg1645z00_202 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1181z00_201), BgL_arg1645z00_202); } 
BgL_new1182z00_198 = BgL_new1181z00_201; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1182z00_198)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1182z00_198)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3565;
{ /* Llib/avahi.scm 577 */
obj_t BgL_arg1643z00_199;
{ /* Llib/avahi.scm 577 */
obj_t BgL_arg1644z00_200;
{ /* Llib/avahi.scm 577 */
obj_t BgL_classz00_1363;
BgL_classz00_1363 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1644z00_200 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1363); } 
BgL_arg1643z00_199 = 
VECTOR_REF(BgL_arg1644z00_200,((long)2)); } 
BgL_auxz00_3565 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1643z00_199); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1182z00_198)))->BgL_stackz00)=((obj_t)BgL_auxz00_3565),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1182z00_198)))->BgL_procz00)=((obj_t)BGl_string2377z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1182z00_198)))->BgL_msgz00)=((obj_t)BGl_string2368z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1182z00_198)))->BgL_objz00)=((obj_t)
BINT(BgL_statez00_37)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1182z00_198))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1636z00_197 = BgL_new1182z00_198; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1636z00_197));} } } } } } 

}



/* &avahi-entry-group-state->symbol */
obj_t BGl_z62avahizd2entryzd2groupzd2statezd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1805, obj_t BgL_statez00_1806)
{
{ /* Llib/avahi.scm 563 */
{ /* Llib/avahi.scm 565 */
AvahiEntryGroupState BgL_auxz00_3581;
{ /* Llib/avahi.scm 565 */
obj_t BgL_tmpz00_3582;
if(
INTEGERP(BgL_statez00_1806))
{ /* Llib/avahi.scm 565 */
BgL_tmpz00_3582 = BgL_statez00_1806
; }  else 
{ 
obj_t BgL_auxz00_3585;
BgL_auxz00_3585 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)23435)), BGl_string2378z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_statez00_1806); 
FAILURE(BgL_auxz00_3585,BFALSE,BFALSE);} 
BgL_auxz00_3581 = 
(long)CINT(BgL_tmpz00_3582); } 
return 
bgl_avahi_entry_group_state_to_symbol(BgL_auxz00_3581);} } 

}



/* avahi-alternative-host-name */
BGL_EXPORTED_DEF obj_t BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(obj_t BgL_namez00_38)
{
{ /* Llib/avahi.scm 586 */
{ /* Llib/avahi.scm 587 */
char * BgL_tmpz00_3591;
{ /* Llib/avahi.scm 587 */
char * BgL_tmpz00_3592;
BgL_tmpz00_3592 = 
BSTRING_TO_STRING(BgL_namez00_38); 
BgL_tmpz00_3591 = 
avahi_alternative_host_name(BgL_tmpz00_3592); } 
return 
string_to_bstring(BgL_tmpz00_3591);} } 

}



/* &avahi-alternative-host-name */
obj_t BGl_z62avahizd2alternativezd2hostzd2namezb0zz__avahi_avahiz00(obj_t BgL_envz00_1807, obj_t BgL_namez00_1808)
{
{ /* Llib/avahi.scm 586 */
{ /* Llib/avahi.scm 587 */
obj_t BgL_auxz00_3596;
if(
STRINGP(BgL_namez00_1808))
{ /* Llib/avahi.scm 587 */
BgL_auxz00_3596 = BgL_namez00_1808
; }  else 
{ 
obj_t BgL_auxz00_3599;
BgL_auxz00_3599 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)24353)), BGl_string2379z00zz__avahi_avahiz00, BGl_string2345z00zz__avahi_avahiz00, BgL_namez00_1808); 
FAILURE(BgL_auxz00_3599,BFALSE,BFALSE);} 
return 
BGl_avahizd2alternativezd2hostzd2namezd2zz__avahi_avahiz00(BgL_auxz00_3596);} } 

}



/* avahi-alternative-service-name */
BGL_EXPORTED_DEF obj_t BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(obj_t BgL_namez00_39)
{
{ /* Llib/avahi.scm 592 */
{ /* Llib/avahi.scm 593 */
char * BgL_tmpz00_3604;
{ /* Llib/avahi.scm 593 */
char * BgL_tmpz00_3605;
BgL_tmpz00_3605 = 
BSTRING_TO_STRING(BgL_namez00_39); 
BgL_tmpz00_3604 = 
avahi_alternative_service_name(BgL_tmpz00_3605); } 
return 
string_to_bstring(BgL_tmpz00_3604);} } 

}



/* &avahi-alternative-service-name */
obj_t BGl_z62avahizd2alternativezd2servicezd2namezb0zz__avahi_avahiz00(obj_t BgL_envz00_1809, obj_t BgL_namez00_1810)
{
{ /* Llib/avahi.scm 592 */
{ /* Llib/avahi.scm 593 */
obj_t BgL_auxz00_3609;
if(
STRINGP(BgL_namez00_1810))
{ /* Llib/avahi.scm 593 */
BgL_auxz00_3609 = BgL_namez00_1810
; }  else 
{ 
obj_t BgL_auxz00_3612;
BgL_auxz00_3612 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)24662)), BGl_string2380z00zz__avahi_avahiz00, BGl_string2345z00zz__avahi_avahiz00, BgL_namez00_1810); 
FAILURE(BgL_auxz00_3612,BFALSE,BFALSE);} 
return 
BGl_avahizd2alternativezd2servicezd2namezd2zz__avahi_avahiz00(BgL_auxz00_3609);} } 

}



/* avahi-service-browser-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2browserz00_bglt BgL_oz00_41)
{
{ /* Llib/avahi.scm 611 */
bgl_avahi_service_browser_close(BgL_oz00_41); BUNSPEC; 
{ /* Llib/avahi.scm 614 */
BgL_avahizd2clientzd2_bglt BgL_i1186z00_204;
BgL_i1186z00_204 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_oz00_41))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3619;
{ /* Llib/avahi.scm 615 */
obj_t BgL_arg1647z00_205;
BgL_arg1647z00_205 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1186z00_204))->BgL_z52browsersz52); 
BgL_auxz00_3619 = 
bgl_remq_bang(
((obj_t)BgL_oz00_41), BgL_arg1647z00_205); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1186z00_204))->BgL_z52browsersz52)=((obj_t)BgL_auxz00_3619),BUNSPEC); } } 
return BUNSPEC;} 

}



/* &avahi-service-browser-close */
obj_t BGl_z62avahizd2servicezd2browserzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1811, obj_t BgL_oz00_1812)
{
{ /* Llib/avahi.scm 611 */
{ /* Llib/avahi.scm 612 */
BgL_avahizd2servicezd2browserz00_bglt BgL_auxz00_3624;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1812, BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 612 */
BgL_auxz00_3624 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_1812)
; }  else 
{ 
obj_t BgL_auxz00_3628;
BgL_auxz00_3628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)25634)), BGl_string2381z00zz__avahi_avahiz00, BGl_string2382z00zz__avahi_avahiz00, BgL_oz00_1812); 
FAILURE(BgL_auxz00_3628,BFALSE,BFALSE);} 
return 
BGl_avahizd2servicezd2browserzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3624);} } 

}



/* avahi-domain-browser-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_avahizd2domainzd2browserz00_bglt BgL_oz00_45)
{
{ /* Llib/avahi.scm 653 */
bgl_avahi_domain_browser_close(BgL_oz00_45); BUNSPEC; 
BGl_avahizd2gczd2unmarkz12z12zz__avahi_avahiz00(
((BgL_avahizd2objectzd2_bglt)BgL_oz00_45)); 
return BUNSPEC;} 

}



/* &avahi-domain-browser-close */
obj_t BGl_z62avahizd2domainzd2browserzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1813, obj_t BgL_oz00_1814)
{
{ /* Llib/avahi.scm 653 */
{ /* Llib/avahi.scm 654 */
BgL_avahizd2domainzd2browserz00_bglt BgL_auxz00_3636;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1814, BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 654 */
BgL_auxz00_3636 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_1814)
; }  else 
{ 
obj_t BgL_auxz00_3640;
BgL_auxz00_3640 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)27636)), BGl_string2383z00zz__avahi_avahiz00, BGl_string2384z00zz__avahi_avahiz00, BgL_oz00_1814); 
FAILURE(BgL_auxz00_3640,BFALSE,BFALSE);} 
return 
BGl_avahizd2domainzd2browserzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3636);} } 

}



/* avahi-service-resolver-close */
BGL_EXPORTED_DEF obj_t BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_avahizd2servicezd2resolverz00_bglt BgL_oz00_47)
{
{ /* Llib/avahi.scm 674 */
bgl_avahi_service_resolver_close(BgL_oz00_47); BUNSPEC; 
{ /* Llib/avahi.scm 677 */
BgL_avahizd2clientzd2_bglt BgL_i1192z00_207;
BgL_i1192z00_207 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_oz00_47))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_3647;
{ /* Llib/avahi.scm 678 */
obj_t BgL_arg1648z00_208;
BgL_arg1648z00_208 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1192z00_207))->BgL_resolversz00); 
BgL_auxz00_3647 = 
bgl_remq_bang(
((obj_t)BgL_oz00_47), BgL_arg1648z00_208); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1192z00_207))->BgL_resolversz00)=((obj_t)BgL_auxz00_3647),BUNSPEC); } } 
return BUNSPEC;} 

}



/* &avahi-service-resolver-close */
obj_t BGl_z62avahizd2servicezd2resolverzd2closezb0zz__avahi_avahiz00(obj_t BgL_envz00_1815, obj_t BgL_oz00_1816)
{
{ /* Llib/avahi.scm 674 */
{ /* Llib/avahi.scm 675 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_auxz00_3652;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1816, BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00))
{ /* Llib/avahi.scm 675 */
BgL_auxz00_3652 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_1816)
; }  else 
{ 
obj_t BgL_auxz00_3656;
BgL_auxz00_3656 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)28622)), BGl_string2385z00zz__avahi_avahiz00, BGl_string2386z00zz__avahi_avahiz00, BgL_oz00_1816); 
FAILURE(BgL_auxz00_3656,BFALSE,BFALSE);} 
return 
BGl_avahizd2servicezd2resolverzd2closezd2zz__avahi_avahiz00(BgL_auxz00_3652);} } 

}



/* avahi-browser-event->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_browser_event_to_symbol(AvahiBrowserEvent BgL_eventz00_48)
{
{ /* Llib/avahi.scm 684 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_NEW))
{ /* Llib/avahi.scm 686 */
return 
CNST_TABLE_REF(((long)20));}  else 
{ /* Llib/avahi.scm 686 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_REMOVE))
{ /* Llib/avahi.scm 688 */
return 
CNST_TABLE_REF(((long)21));}  else 
{ /* Llib/avahi.scm 688 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_CACHE_EXHAUSTED))
{ /* Llib/avahi.scm 690 */
return 
CNST_TABLE_REF(((long)22));}  else 
{ /* Llib/avahi.scm 690 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_ALL_FOR_NOW))
{ /* Llib/avahi.scm 692 */
return 
CNST_TABLE_REF(((long)23));}  else 
{ /* Llib/avahi.scm 692 */
if(
(BgL_eventz00_48==AVAHI_BROWSER_FAILURE))
{ /* Llib/avahi.scm 694 */
return 
CNST_TABLE_REF(((long)24));}  else 
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1656z00_214;
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_new1194z00_215;
{ /* Llib/avahi.scm 698 */
BgL_z62avahizd2errorzb0_bglt BgL_new1193z00_218;
BgL_new1193z00_218 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 698 */
long BgL_arg1671z00_219;
BgL_arg1671z00_219 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1193z00_218), BgL_arg1671z00_219); } 
BgL_new1194z00_215 = BgL_new1193z00_218; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1194z00_215)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1194z00_215)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3684;
{ /* Llib/avahi.scm 698 */
obj_t BgL_arg1661z00_216;
{ /* Llib/avahi.scm 698 */
obj_t BgL_arg1662z00_217;
{ /* Llib/avahi.scm 698 */
obj_t BgL_classz00_1378;
BgL_classz00_1378 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1662z00_217 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1378); } 
BgL_arg1661z00_216 = 
VECTOR_REF(BgL_arg1662z00_217,((long)2)); } 
BgL_auxz00_3684 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1661z00_216); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1194z00_215)))->BgL_stackz00)=((obj_t)BgL_auxz00_3684),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1194z00_215)))->BgL_procz00)=((obj_t)BGl_string2387z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1194z00_215)))->BgL_msgz00)=((obj_t)BGl_string2388z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1194z00_215)))->BgL_objz00)=((obj_t)
BINT(BgL_eventz00_48)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1194z00_215))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1656z00_214 = BgL_new1194z00_215; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1656z00_214));} } } } } } 

}



/* &avahi-browser-event->symbol */
obj_t BGl_z62avahizd2browserzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1817, obj_t BgL_eventz00_1818)
{
{ /* Llib/avahi.scm 684 */
{ /* Llib/avahi.scm 686 */
AvahiBrowserEvent BgL_auxz00_3700;
{ /* Llib/avahi.scm 686 */
obj_t BgL_tmpz00_3701;
if(
INTEGERP(BgL_eventz00_1818))
{ /* Llib/avahi.scm 686 */
BgL_tmpz00_3701 = BgL_eventz00_1818
; }  else 
{ 
obj_t BgL_auxz00_3704;
BgL_auxz00_3704 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)29092)), BGl_string2389z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_eventz00_1818); 
FAILURE(BgL_auxz00_3704,BFALSE,BFALSE);} 
BgL_auxz00_3700 = 
(long)CINT(BgL_tmpz00_3701); } 
return 
bgl_avahi_browser_event_to_symbol(BgL_auxz00_3700);} } 

}



/* avahi-resolver-event->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_resolver_event_to_symbol(AvahiResolverEvent BgL_eventz00_49)
{
{ /* Llib/avahi.scm 707 */
if(
(BgL_eventz00_49==AVAHI_RESOLVER_FOUND))
{ /* Llib/avahi.scm 709 */
return 
CNST_TABLE_REF(((long)25));}  else 
{ /* Llib/avahi.scm 709 */
if(
(BgL_eventz00_49==AVAHI_RESOLVER_FAILURE))
{ /* Llib/avahi.scm 711 */
return 
CNST_TABLE_REF(((long)26));}  else 
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1674z00_222;
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_new1196z00_223;
{ /* Llib/avahi.scm 715 */
BgL_z62avahizd2errorzb0_bglt BgL_new1195z00_226;
BgL_new1195z00_226 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 715 */
long BgL_arg1681z00_227;
BgL_arg1681z00_227 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1195z00_226), BgL_arg1681z00_227); } 
BgL_new1196z00_223 = BgL_new1195z00_226; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1196z00_223)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1196z00_223)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3724;
{ /* Llib/avahi.scm 715 */
obj_t BgL_arg1677z00_224;
{ /* Llib/avahi.scm 715 */
obj_t BgL_arg1678z00_225;
{ /* Llib/avahi.scm 715 */
obj_t BgL_classz00_1387;
BgL_classz00_1387 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1678z00_225 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1387); } 
BgL_arg1677z00_224 = 
VECTOR_REF(BgL_arg1678z00_225,((long)2)); } 
BgL_auxz00_3724 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1677z00_224); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1196z00_223)))->BgL_stackz00)=((obj_t)BgL_auxz00_3724),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1196z00_223)))->BgL_procz00)=((obj_t)BGl_string2390z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1196z00_223)))->BgL_msgz00)=((obj_t)BGl_string2388z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1196z00_223)))->BgL_objz00)=((obj_t)
BINT(BgL_eventz00_49)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1196z00_223))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1674z00_222 = BgL_new1196z00_223; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1674z00_222));} } } 

}



/* &avahi-resolver-event->symbol */
obj_t BGl_z62avahizd2resolverzd2eventzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1819, obj_t BgL_eventz00_1820)
{
{ /* Llib/avahi.scm 707 */
{ /* Llib/avahi.scm 709 */
AvahiResolverEvent BgL_auxz00_3740;
{ /* Llib/avahi.scm 709 */
obj_t BgL_tmpz00_3741;
if(
INTEGERP(BgL_eventz00_1820))
{ /* Llib/avahi.scm 709 */
BgL_tmpz00_3741 = BgL_eventz00_1820
; }  else 
{ 
obj_t BgL_auxz00_3744;
BgL_auxz00_3744 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)29961)), BGl_string2391z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_eventz00_1820); 
FAILURE(BgL_auxz00_3744,BFALSE,BFALSE);} 
BgL_auxz00_3740 = 
(long)CINT(BgL_tmpz00_3741); } 
return 
bgl_avahi_resolver_event_to_symbol(BgL_auxz00_3740);} } 

}



/* avahi-if-index->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_if_index_to_symbol(AvahiIfIndex BgL_indexz00_50)
{
{ /* Llib/avahi.scm 724 */
if(
(BgL_indexz00_50==AVAHI_IF_UNSPEC))
{ /* Llib/avahi.scm 726 */
return 
CNST_TABLE_REF(((long)27));}  else 
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1684z00_229;
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_new1198z00_230;
{ /* Llib/avahi.scm 729 */
BgL_z62avahizd2errorzb0_bglt BgL_new1197z00_233;
BgL_new1197z00_233 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 729 */
long BgL_arg1698z00_234;
BgL_arg1698z00_234 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1197z00_233), BgL_arg1698z00_234); } 
BgL_new1198z00_230 = BgL_new1197z00_233; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1198z00_230)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1198z00_230)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3761;
{ /* Llib/avahi.scm 729 */
obj_t BgL_arg1696z00_231;
{ /* Llib/avahi.scm 729 */
obj_t BgL_arg1697z00_232;
{ /* Llib/avahi.scm 729 */
obj_t BgL_classz00_1394;
BgL_classz00_1394 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1697z00_232 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1394); } 
BgL_arg1696z00_231 = 
VECTOR_REF(BgL_arg1697z00_232,((long)2)); } 
BgL_auxz00_3761 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1696z00_231); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1198z00_230)))->BgL_stackz00)=((obj_t)BgL_auxz00_3761),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1198z00_230)))->BgL_procz00)=((obj_t)BGl_string2392z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1198z00_230)))->BgL_msgz00)=((obj_t)BGl_string2393z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1198z00_230)))->BgL_objz00)=((obj_t)
BINT(BgL_indexz00_50)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1198z00_230))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1684z00_229 = BgL_new1198z00_230; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1684z00_229));} } 

}



/* &avahi-if-index->symbol */
obj_t BGl_z62avahizd2ifzd2indexzd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1821, obj_t BgL_indexz00_1822)
{
{ /* Llib/avahi.scm 724 */
{ /* Llib/avahi.scm 726 */
AvahiIfIndex BgL_auxz00_3777;
{ /* Llib/avahi.scm 726 */
obj_t BgL_tmpz00_3778;
if(
INTEGERP(BgL_indexz00_1822))
{ /* Llib/avahi.scm 726 */
BgL_tmpz00_3778 = BgL_indexz00_1822
; }  else 
{ 
obj_t BgL_auxz00_3781;
BgL_auxz00_3781 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)30586)), BGl_string2394z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_indexz00_1822); 
FAILURE(BgL_auxz00_3781,BFALSE,BFALSE);} 
BgL_auxz00_3777 = 
(long)CINT(BgL_tmpz00_3778); } 
return 
bgl_avahi_if_index_to_symbol(BgL_auxz00_3777);} } 

}



/* avahi-protocol->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_protocol_to_symbol(AvahiProtocol BgL_protoz00_51)
{
{ /* Llib/avahi.scm 738 */
if(
(BgL_protoz00_51==AVAHI_PROTO_INET))
{ /* Llib/avahi.scm 740 */
return 
CNST_TABLE_REF(((long)28));}  else 
{ /* Llib/avahi.scm 740 */
if(
(BgL_protoz00_51==AVAHI_PROTO_INET6))
{ /* Llib/avahi.scm 742 */
return 
CNST_TABLE_REF(((long)29));}  else 
{ /* Llib/avahi.scm 742 */
if(
(BgL_protoz00_51==AVAHI_PROTO_UNSPEC))
{ /* Llib/avahi.scm 744 */
return 
CNST_TABLE_REF(((long)30));}  else 
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1703z00_238;
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_new1200z00_239;
{ /* Llib/avahi.scm 748 */
BgL_z62avahizd2errorzb0_bglt BgL_new1199z00_242;
BgL_new1199z00_242 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 748 */
long BgL_arg1712z00_243;
BgL_arg1712z00_243 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_242), BgL_arg1712z00_243); } 
BgL_new1200z00_239 = BgL_new1199z00_242; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1200z00_239)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1200z00_239)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3804;
{ /* Llib/avahi.scm 748 */
obj_t BgL_arg1705z00_240;
{ /* Llib/avahi.scm 748 */
obj_t BgL_arg1706z00_241;
{ /* Llib/avahi.scm 748 */
obj_t BgL_classz00_1405;
BgL_classz00_1405 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1706z00_241 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1405); } 
BgL_arg1705z00_240 = 
VECTOR_REF(BgL_arg1706z00_241,((long)2)); } 
BgL_auxz00_3804 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1705z00_240); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1200z00_239)))->BgL_stackz00)=((obj_t)BgL_auxz00_3804),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1200z00_239)))->BgL_procz00)=((obj_t)BGl_string2395z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1200z00_239)))->BgL_msgz00)=((obj_t)BGl_string2396z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1200z00_239)))->BgL_objz00)=((obj_t)
BINT(BgL_protoz00_51)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1200z00_239))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1703z00_238 = BgL_new1200z00_239; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1703z00_238));} } } } 

}



/* &avahi-protocol->symbol */
obj_t BGl_z62avahizd2protocolzd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1823, obj_t BgL_protoz00_1824)
{
{ /* Llib/avahi.scm 738 */
{ /* Llib/avahi.scm 740 */
AvahiProtocol BgL_auxz00_3820;
{ /* Llib/avahi.scm 740 */
obj_t BgL_tmpz00_3821;
if(
INTEGERP(BgL_protoz00_1824))
{ /* Llib/avahi.scm 740 */
BgL_tmpz00_3821 = BgL_protoz00_1824
; }  else 
{ 
obj_t BgL_auxz00_3824;
BgL_auxz00_3824 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)31113)), BGl_string2397z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_protoz00_1824); 
FAILURE(BgL_auxz00_3824,BFALSE,BFALSE);} 
BgL_auxz00_3820 = 
(long)CINT(BgL_tmpz00_3821); } 
return 
bgl_avahi_protocol_to_symbol(BgL_auxz00_3820);} } 

}



/* avahi-symbol->protocol */
BGL_EXPORTED_DEF AvahiProtocol bgl_avahi_symbol_to_protocol(obj_t BgL_protoz00_52)
{
{ /* Llib/avahi.scm 757 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)28))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_INET;}  else 
{ /* Llib/avahi.scm 758 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)29))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_INET6;}  else 
{ /* Llib/avahi.scm 758 */
if(
(BgL_protoz00_52==
CNST_TABLE_REF(((long)30))))
{ /* Llib/avahi.scm 758 */
return AVAHI_PROTO_UNSPEC;}  else 
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1717z00_248;
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_new1202z00_249;
{ /* Llib/avahi.scm 767 */
BgL_z62avahizd2errorzb0_bglt BgL_new1201z00_252;
BgL_new1201z00_252 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 767 */
long BgL_arg1720z00_253;
BgL_arg1720z00_253 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1201z00_252), BgL_arg1720z00_253); } 
BgL_new1202z00_249 = BgL_new1201z00_252; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1202z00_249)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1202z00_249)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3847;
{ /* Llib/avahi.scm 767 */
obj_t BgL_arg1718z00_250;
{ /* Llib/avahi.scm 767 */
obj_t BgL_arg1719z00_251;
{ /* Llib/avahi.scm 767 */
obj_t BgL_classz00_1413;
BgL_classz00_1413 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1719z00_251 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1413); } 
BgL_arg1718z00_250 = 
VECTOR_REF(BgL_arg1719z00_251,((long)2)); } 
BgL_auxz00_3847 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1718z00_250); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1202z00_249)))->BgL_stackz00)=((obj_t)BgL_auxz00_3847),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1202z00_249)))->BgL_procz00)=((obj_t)BGl_string2398z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1202z00_249)))->BgL_msgz00)=((obj_t)BGl_string2396z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1202z00_249)))->BgL_objz00)=((obj_t)BgL_protoz00_52),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1202z00_249))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1717z00_248 = BgL_new1202z00_249; } 
return 
(long)CINT(
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1717z00_248)));} } } } 

}



/* &avahi-symbol->protocol */
obj_t BGl_z62avahizd2symbolzd2ze3protocolz81zz__avahi_avahiz00(obj_t BgL_envz00_1825, obj_t BgL_protoz00_1826)
{
{ /* Llib/avahi.scm 757 */
{ /* Llib/avahi.scm 758 */
long BgL_tmpz00_3863;
{ /* Llib/avahi.scm 758 */
obj_t BgL_auxz00_3864;
if(
SYMBOLP(BgL_protoz00_1826))
{ /* Llib/avahi.scm 758 */
BgL_auxz00_3864 = BgL_protoz00_1826
; }  else 
{ 
obj_t BgL_auxz00_3867;
BgL_auxz00_3867 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)31763)), BGl_string2399z00zz__avahi_avahiz00, BGl_string2400z00zz__avahi_avahiz00, BgL_protoz00_1826); 
FAILURE(BgL_auxz00_3867,BFALSE,BFALSE);} 
BgL_tmpz00_3863 = 
bgl_avahi_symbol_to_protocol(BgL_auxz00_3864); } 
return 
BINT(BgL_tmpz00_3863);} } 

}



/* avahi-lookup-flags->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_lookup_flags_to_symbol(AvahiLookupFlags BgL_flagz00_53)
{
{ /* Llib/avahi.scm 776 */
if(
(BgL_flagz00_53==AVAHI_LOOKUP_NO_TXT))
{ /* Llib/avahi.scm 778 */
return 
CNST_TABLE_REF(((long)31));}  else 
{ /* Llib/avahi.scm 778 */
if(
(BgL_flagz00_53==AVAHI_LOOKUP_NO_ADDRESS))
{ /* Llib/avahi.scm 780 */
return 
CNST_TABLE_REF(((long)32));}  else 
{ /* Llib/avahi.scm 780 */
if(
(BgL_flagz00_53==((long)0)))
{ /* Llib/avahi.scm 782 */
return 
CNST_TABLE_REF(((long)33));}  else 
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1726z00_257;
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_new1204z00_258;
{ /* Llib/avahi.scm 786 */
BgL_z62avahizd2errorzb0_bglt BgL_new1203z00_261;
BgL_new1203z00_261 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 786 */
long BgL_arg1734z00_262;
BgL_arg1734z00_262 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1203z00_261), BgL_arg1734z00_262); } 
BgL_new1204z00_258 = BgL_new1203z00_261; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1204z00_258)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1204z00_258)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3890;
{ /* Llib/avahi.scm 786 */
obj_t BgL_arg1727z00_259;
{ /* Llib/avahi.scm 786 */
obj_t BgL_arg1730z00_260;
{ /* Llib/avahi.scm 786 */
obj_t BgL_classz00_1423;
BgL_classz00_1423 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1730z00_260 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1423); } 
BgL_arg1727z00_259 = 
VECTOR_REF(BgL_arg1730z00_260,((long)2)); } 
BgL_auxz00_3890 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1727z00_259); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1204z00_258)))->BgL_stackz00)=((obj_t)BgL_auxz00_3890),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1204z00_258)))->BgL_procz00)=((obj_t)BGl_string2401z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1204z00_258)))->BgL_msgz00)=((obj_t)BGl_string2402z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1204z00_258)))->BgL_objz00)=((obj_t)
BINT(BgL_flagz00_53)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1204z00_258))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1726z00_257 = BgL_new1204z00_258; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1726z00_257));} } } } 

}



/* &avahi-lookup-flags->symbol */
obj_t BGl_z62avahizd2lookupzd2flagszd2ze3symbolz53zz__avahi_avahiz00(obj_t BgL_envz00_1827, obj_t BgL_flagz00_1828)
{
{ /* Llib/avahi.scm 776 */
{ /* Llib/avahi.scm 778 */
AvahiLookupFlags BgL_auxz00_3906;
{ /* Llib/avahi.scm 778 */
obj_t BgL_tmpz00_3907;
if(
INTEGERP(BgL_flagz00_1828))
{ /* Llib/avahi.scm 778 */
BgL_tmpz00_3907 = BgL_flagz00_1828
; }  else 
{ 
obj_t BgL_auxz00_3910;
BgL_auxz00_3910 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)32426)), BGl_string2403z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_flagz00_1828); 
FAILURE(BgL_auxz00_3910,BFALSE,BFALSE);} 
BgL_auxz00_3906 = 
(long)CINT(BgL_tmpz00_3907); } 
return 
bgl_avahi_lookup_flags_to_symbol(BgL_auxz00_3906);} } 

}



/* avahi-lookup-result-flags->symbol */
BGL_EXPORTED_DEF obj_t bgl_avahi_lookup_result_flags_to_symbol(AvahiLookupResultFlags BgL_flagz00_54)
{
{ /* Llib/avahi.scm 795 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_CACHED))
{ /* Llib/avahi.scm 797 */
return 
CNST_TABLE_REF(((long)34));}  else 
{ /* Llib/avahi.scm 797 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_WIDE_AREA))
{ /* Llib/avahi.scm 799 */
return 
CNST_TABLE_REF(((long)35));}  else 
{ /* Llib/avahi.scm 799 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_MULTICAST))
{ /* Llib/avahi.scm 801 */
return 
CNST_TABLE_REF(((long)36));}  else 
{ /* Llib/avahi.scm 801 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_LOCAL))
{ /* Llib/avahi.scm 803 */
return 
CNST_TABLE_REF(((long)37));}  else 
{ /* Llib/avahi.scm 803 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_OUR_OWN))
{ /* Llib/avahi.scm 805 */
return 
CNST_TABLE_REF(((long)38));}  else 
{ /* Llib/avahi.scm 805 */
if(
(BgL_flagz00_54==AVAHI_LOOKUP_RESULT_STATIC))
{ /* Llib/avahi.scm 807 */
return 
CNST_TABLE_REF(((long)39));}  else 
{ /* Llib/avahi.scm 807 */
if(
(BgL_flagz00_54==((long)0)))
{ /* Llib/avahi.scm 809 */
return 
CNST_TABLE_REF(((long)40));}  else 
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1748z00_270;
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_new1206z00_271;
{ /* Llib/avahi.scm 813 */
BgL_z62avahizd2errorzb0_bglt BgL_new1205z00_274;
BgL_new1205z00_274 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 813 */
long BgL_arg1772z00_275;
BgL_arg1772z00_275 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1205z00_274), BgL_arg1772z00_275); } 
BgL_new1206z00_271 = BgL_new1205z00_274; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1206z00_271)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1206z00_271)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_3945;
{ /* Llib/avahi.scm 813 */
obj_t BgL_arg1760z00_272;
{ /* Llib/avahi.scm 813 */
obj_t BgL_arg1763z00_273;
{ /* Llib/avahi.scm 813 */
obj_t BgL_classz00_1441;
BgL_classz00_1441 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1763z00_273 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1441); } 
BgL_arg1760z00_272 = 
VECTOR_REF(BgL_arg1763z00_273,((long)2)); } 
BgL_auxz00_3945 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1760z00_272); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1206z00_271)))->BgL_stackz00)=((obj_t)BgL_auxz00_3945),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1206z00_271)))->BgL_procz00)=((obj_t)BGl_string2404z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1206z00_271)))->BgL_msgz00)=((obj_t)BGl_string2405z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1206z00_271)))->BgL_objz00)=((obj_t)
BINT(BgL_flagz00_54)),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1206z00_271))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1748z00_270 = BgL_new1206z00_271; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1748z00_270));} } } } } } } } 

}



/* &avahi-lookup-result-flags->symbol */
obj_t BGl_z62avahizd2lookupzd2resultzd2flagszd2ze3symbolz81zz__avahi_avahiz00(obj_t BgL_envz00_1829, obj_t BgL_flagz00_1830)
{
{ /* Llib/avahi.scm 795 */
{ /* Llib/avahi.scm 797 */
AvahiLookupResultFlags BgL_auxz00_3961;
{ /* Llib/avahi.scm 797 */
obj_t BgL_tmpz00_3962;
if(
INTEGERP(BgL_flagz00_1830))
{ /* Llib/avahi.scm 797 */
BgL_tmpz00_3962 = BgL_flagz00_1830
; }  else 
{ 
obj_t BgL_auxz00_3965;
BgL_auxz00_3965 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)33123)), BGl_string2406z00zz__avahi_avahiz00, BGl_string2346z00zz__avahi_avahiz00, BgL_flagz00_1830); 
FAILURE(BgL_auxz00_3965,BFALSE,BFALSE);} 
BgL_auxz00_3961 = 
(long)CINT(BgL_tmpz00_3962); } 
return 
bgl_avahi_lookup_result_flags_to_symbol(BgL_auxz00_3961);} } 

}



/* avahi-symbol->domain-browser-type */
obj_t BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(obj_t BgL_btypez00_55)
{
{ /* Llib/avahi.scm 822 */
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2933z00_3971;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2933z00_3971 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2933z00_3971 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2933z00_3971 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)43)))
; } } 
if(BgL_test2933z00_3971)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2936z00_3981;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2936z00_3981 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2936z00_3981 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2936z00_3981 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)44)))
; } } 
if(BgL_test2936z00_3981)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE_DEFAULT);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2939z00_3991;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2939z00_3991 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2939z00_3991 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2939z00_3991 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)45)))
; } } 
if(BgL_test2939z00_3991)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_REGISTER);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2942z00_4001;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2942z00_4001 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2942z00_4001 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2942z00_4001 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)46)))
; } } 
if(BgL_test2942z00_4001)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_REGISTER_DEFAULT);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2945z00_4011;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2945z00_4011 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2945z00_4011 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2945z00_4011 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)47)))
; } } 
if(BgL_test2945z00_4011)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_BROWSE_LEGACY);}  else 
{ /* Llib/avahi.scm 823 */
bool_t BgL_test2948z00_4021;
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)41))))
{ /* Llib/avahi.scm 823 */
BgL_test2948z00_4021 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
if(
(BgL_btypez00_55==
CNST_TABLE_REF(((long)42))))
{ /* Llib/avahi.scm 823 */
BgL_test2948z00_4021 = ((bool_t)1)
; }  else 
{ /* Llib/avahi.scm 823 */
BgL_test2948z00_4021 = 
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_btypez00_55, 
CNST_TABLE_REF(((long)48)))
; } } 
if(BgL_test2948z00_4021)
{ /* Llib/avahi.scm 823 */
return 
BINT(AVAHI_DOMAIN_BROWSER_MAX);}  else 
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1793z00_295;
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_new1208z00_296;
{ /* Llib/avahi.scm 838 */
BgL_z62avahizd2errorzb0_bglt BgL_new1207z00_299;
BgL_new1207z00_299 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 838 */
long BgL_arg1796z00_300;
BgL_arg1796z00_300 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1207z00_299), BgL_arg1796z00_300); } 
BgL_new1208z00_296 = BgL_new1207z00_299; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1208z00_296)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1208z00_296)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4039;
{ /* Llib/avahi.scm 838 */
obj_t BgL_arg1794z00_297;
{ /* Llib/avahi.scm 838 */
obj_t BgL_arg1795z00_298;
{ /* Llib/avahi.scm 838 */
obj_t BgL_classz00_1458;
BgL_classz00_1458 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1795z00_298 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1458); } 
BgL_arg1794z00_297 = 
VECTOR_REF(BgL_arg1795z00_298,((long)2)); } 
BgL_auxz00_4039 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1794z00_297); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1208z00_296)))->BgL_stackz00)=((obj_t)BgL_auxz00_4039),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1208z00_296)))->BgL_procz00)=((obj_t)BGl_string2407z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1208z00_296)))->BgL_msgz00)=((obj_t)BGl_string2408z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1208z00_296)))->BgL_objz00)=((obj_t)BgL_btypez00_55),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1208z00_296))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1793z00_295 = BgL_new1208z00_296; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1793z00_295));} } } } } } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
{ /* Llib/avahi.scm 50 */
obj_t BgL_arg1800z00_316;obj_t BgL_arg1801z00_317;
{ /* Llib/avahi.scm 50 */
obj_t BgL_v1231z00_334;
BgL_v1231z00_334 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 50 */
obj_t BgL_arg1807z00_335;
BgL_arg1807z00_335 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc2411z00zz__avahi_avahiz00, BGl_proc2410z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2409z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1231z00_334,((long)0),BgL_arg1807z00_335); } 
BgL_arg1800z00_316 = BgL_v1231z00_334; } 
{ /* Llib/avahi.scm 50 */
obj_t BgL_v1232z00_348;
BgL_v1232z00_348 = 
create_vector(((long)0)); 
BgL_arg1801z00_317 = BgL_v1232z00_348; } 
BGl_z62avahizd2errorzb0zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)52)), BGl_z62errorz62zz__objectz00, ((long)37908), BGl_proc2414z00zz__avahi_avahiz00, BGl_proc2413z00zz__avahi_avahiz00, BFALSE, BGl_proc2412z00zz__avahi_avahiz00, BFALSE, BgL_arg1800z00_316, BgL_arg1801z00_317); } 
{ /* Llib/avahi.scm 52 */
obj_t BgL_arg1818z00_355;obj_t BgL_arg1819z00_356;
{ /* Llib/avahi.scm 52 */
obj_t BgL_v1233z00_373;
BgL_v1233z00_373 = 
create_vector(((long)0)); 
BgL_arg1818z00_355 = BgL_v1233z00_373; } 
{ /* Llib/avahi.scm 52 */
obj_t BgL_v1234z00_374;
BgL_v1234z00_374 = 
create_vector(((long)0)); 
BgL_arg1819z00_356 = BgL_v1234z00_374; } 
BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)52)), BGl_z62avahizd2errorzb0zz__avahi_avahiz00, ((long)15882), BGl_proc2417z00zz__avahi_avahiz00, BGl_proc2416z00zz__avahi_avahiz00, BFALSE, BGl_proc2415z00zz__avahi_avahiz00, BFALSE, BgL_arg1818z00_355, BgL_arg1819z00_356); } 
{ /* Llib/avahi.scm 54 */
obj_t BgL_arg1827z00_380;obj_t BgL_arg1828z00_381;
{ /* Llib/avahi.scm 54 */
obj_t BgL_v1235z00_387;
BgL_v1235z00_387 = 
create_vector(((long)0)); 
BgL_arg1827z00_380 = BgL_v1235z00_387; } 
{ /* Llib/avahi.scm 54 */
obj_t BgL_v1236z00_388;
BgL_v1236z00_388 = 
create_vector(((long)0)); 
BgL_arg1828z00_381 = BgL_v1236z00_388; } 
BGl_avahizd2objectzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)54)), 
CNST_TABLE_REF(((long)52)), BGl_objectz00zz__objectz00, ((long)39383), BFALSE, BGl_proc2419z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2418z00zz__avahi_avahiz00, BFALSE, BgL_arg1827z00_380, BgL_arg1828z00_381); } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1834z00_393;obj_t BgL_arg1835z00_394;
{ /* Llib/avahi.scm 57 */
obj_t BgL_v1237z00_400;
BgL_v1237z00_400 = 
create_vector(((long)2)); 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1839z00_401;
BgL_arg1839z00_401 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2422z00zz__avahi_avahiz00, BGl_proc2421z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2420z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)50))); 
VECTOR_SET(BgL_v1237z00_400,((long)0),BgL_arg1839z00_401); } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_arg1846z00_414;
BgL_arg1846z00_414 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc2425z00zz__avahi_avahiz00, BGl_proc2424z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2423z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1237z00_400,((long)1),BgL_arg1846z00_414); } 
BgL_arg1834z00_393 = BgL_v1237z00_400; } 
{ /* Llib/avahi.scm 57 */
obj_t BgL_v1238z00_427;
BgL_v1238z00_427 = 
create_vector(((long)0)); 
BgL_arg1835z00_394 = BgL_v1238z00_427; } 
BGl_avahizd2pollzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)58)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)43719), BFALSE, BGl_proc2427z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2426z00zz__avahi_avahiz00, BFALSE, BgL_arg1834z00_393, BgL_arg1835z00_394); } 
{ /* Llib/avahi.scm 61 */
obj_t BgL_arg1856z00_433;obj_t BgL_arg1858z00_434;
{ /* Llib/avahi.scm 61 */
obj_t BgL_v1239z00_448;
BgL_v1239z00_448 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 61 */
obj_t BgL_arg1865z00_449;
BgL_arg1865z00_449 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2430z00zz__avahi_avahiz00, BGl_proc2429z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2428z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)60))); 
VECTOR_SET(BgL_v1239z00_448,((long)0),BgL_arg1865z00_449); } 
BgL_arg1856z00_433 = BgL_v1239z00_448; } 
{ /* Llib/avahi.scm 61 */
obj_t BgL_v1240z00_462;
BgL_v1240z00_462 = 
create_vector(((long)0)); 
BgL_arg1858z00_434 = BgL_v1240z00_462; } 
BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2pollzd2zz__avahi_avahiz00, ((long)59689), BGl_proc2433z00zz__avahi_avahiz00, BGl_proc2432z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2431z00zz__avahi_avahiz00, BFALSE, BgL_arg1856z00_433, BgL_arg1858z00_434); } 
{ /* Llib/avahi.scm 64 */
obj_t BgL_arg1875z00_469;obj_t BgL_arg1876z00_470;
{ /* Llib/avahi.scm 64 */
obj_t BgL_v1241z00_484;
BgL_v1241z00_484 = 
create_vector(((long)1)); 
{ /* Llib/avahi.scm 64 */
obj_t BgL_arg1883z00_485;
BgL_arg1883z00_485 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2436z00zz__avahi_avahiz00, BGl_proc2435z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2434z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)62))); 
VECTOR_SET(BgL_v1241z00_484,((long)0),BgL_arg1883z00_485); } 
BgL_arg1875z00_469 = BgL_v1241z00_484; } 
{ /* Llib/avahi.scm 64 */
obj_t BgL_v1242z00_498;
BgL_v1242z00_498 = 
create_vector(((long)0)); 
BgL_arg1876z00_470 = BgL_v1242z00_498; } 
BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)63)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2pollzd2zz__avahi_avahiz00, ((long)39682), BGl_proc2439z00zz__avahi_avahiz00, BGl_proc2438z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2437z00zz__avahi_avahiz00, BFALSE, BgL_arg1875z00_469, BgL_arg1876z00_470); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1893z00_505;obj_t BgL_arg1894z00_506;
{ /* Llib/avahi.scm 67 */
obj_t BgL_v1243z00_524;
BgL_v1243z00_524 = 
create_vector(((long)12)); 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1902z00_525;
BgL_arg1902z00_525 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2442z00zz__avahi_avahiz00, BGl_proc2441z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2440z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)64))); 
VECTOR_SET(BgL_v1243z00_524,((long)0),BgL_arg1902z00_525); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1909z00_538;
BgL_arg1909z00_538 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc2444z00zz__avahi_avahiz00, BGl_proc2443z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2pollzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1243z00_524,((long)1),BgL_arg1909z00_538); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1914z00_548;
BgL_arg1914z00_548 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc2447z00zz__avahi_avahiz00, BGl_proc2446z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2445z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1243z00_524,((long)2),BgL_arg1914z00_548); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1921z00_561;
BgL_arg1921z00_561 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2449z00zz__avahi_avahiz00, BGl_proc2448z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1243z00_524,((long)3),BgL_arg1921z00_561); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1926z00_571;
BgL_arg1926z00_571 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc2452z00zz__avahi_avahiz00, BGl_proc2451z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2450z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1243z00_524,((long)4),BgL_arg1926z00_571); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1933z00_584;
BgL_arg1933z00_584 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc2455z00zz__avahi_avahiz00, BGl_proc2454z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2453z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1243z00_524,((long)5),BgL_arg1933z00_584); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1940z00_597;
BgL_arg1940z00_597 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc2458z00zz__avahi_avahiz00, BGl_proc2457z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2456z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1243z00_524,((long)6),BgL_arg1940z00_597); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1947z00_610;
BgL_arg1947z00_610 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc2460z00zz__avahi_avahiz00, BGl_proc2459z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1243z00_524,((long)7),BgL_arg1947z00_610); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1952z00_620;
BgL_arg1952z00_620 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc2462z00zz__avahi_avahiz00, BGl_proc2461z00zz__avahi_avahiz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1243z00_524,((long)8),BgL_arg1952z00_620); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1957z00_630;
BgL_arg1957z00_630 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)76)), BGl_proc2464z00zz__avahi_avahiz00, BGl_proc2463z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1243z00_524,((long)9),BgL_arg1957z00_630); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1962z00_640;
BgL_arg1962z00_640 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc2466z00zz__avahi_avahiz00, BGl_proc2465z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1243z00_524,((long)10),BgL_arg1962z00_640); } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_arg1967z00_650;
BgL_arg1967z00_650 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)78)), BGl_proc2468z00zz__avahi_avahiz00, BGl_proc2467z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1243z00_524,((long)11),BgL_arg1967z00_650); } 
BgL_arg1893z00_505 = BgL_v1243z00_524; } 
{ /* Llib/avahi.scm 67 */
obj_t BgL_v1244z00_660;
BgL_v1244z00_660 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 78 */
obj_t BgL_arg1972z00_661;
{ /* Llib/avahi.scm 78 */
obj_t BgL_arg1973z00_662;
BgL_arg1973z00_662 = 
MAKE_YOUNG_PAIR(BGl_proc2469z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1972z00_661 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg1973z00_662); } 
VECTOR_SET(BgL_v1244z00_660,((long)0),BgL_arg1972z00_661); } 
{ /* Llib/avahi.scm 83 */
obj_t BgL_arg1981z00_675;
{ /* Llib/avahi.scm 83 */
obj_t BgL_arg1982z00_676;
BgL_arg1982z00_676 = 
MAKE_YOUNG_PAIR(BGl_proc2470z00zz__avahi_avahiz00, BGl_proc2471z00zz__avahi_avahiz00); 
BgL_arg1981z00_675 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg1982z00_676); } 
VECTOR_SET(BgL_v1244z00_660,((long)1),BgL_arg1981z00_675); } 
{ /* Llib/avahi.scm 92 */
obj_t BgL_arg1997z00_703;
{ /* Llib/avahi.scm 92 */
obj_t BgL_arg1998z00_704;
BgL_arg1998z00_704 = 
MAKE_YOUNG_PAIR(BGl_proc2472z00zz__avahi_avahiz00, BFALSE); 
BgL_arg1997z00_703 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg1998z00_704); } 
VECTOR_SET(BgL_v1244z00_660,((long)2),BgL_arg1997z00_703); } 
{ /* Llib/avahi.scm 98 */
obj_t BgL_arg2006z00_717;
{ /* Llib/avahi.scm 98 */
obj_t BgL_arg2007z00_718;
BgL_arg2007z00_718 = 
MAKE_YOUNG_PAIR(BGl_proc2473z00zz__avahi_avahiz00, BFALSE); 
BgL_arg2006z00_717 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2007z00_718); } 
VECTOR_SET(BgL_v1244z00_660,((long)3),BgL_arg2006z00_717); } 
{ /* Llib/avahi.scm 104 */
obj_t BgL_arg2015z00_731;
{ /* Llib/avahi.scm 104 */
obj_t BgL_arg2016z00_732;
BgL_arg2016z00_732 = 
MAKE_YOUNG_PAIR(BGl_proc2474z00zz__avahi_avahiz00, BFALSE); 
BgL_arg2015z00_731 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2016z00_732); } 
VECTOR_SET(BgL_v1244z00_660,((long)4),BgL_arg2015z00_731); } 
BgL_arg1894z00_506 = BgL_v1244z00_660; } 
BGl_avahizd2clientzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)79)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)28649), BGl_proc2477z00zz__avahi_avahiz00, BGl_proc2476z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2475z00zz__avahi_avahiz00, BFALSE, BgL_arg1893z00_505, BgL_arg1894z00_506); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2028z00_752;obj_t BgL_arg2029z00_753;
{ /* Llib/avahi.scm 110 */
obj_t BgL_v1245z00_767;
BgL_v1245z00_767 = 
create_vector(((long)3)); 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2036z00_768;
BgL_arg2036z00_768 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2480z00zz__avahi_avahiz00, BGl_proc2479z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2478z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)80))); 
VECTOR_SET(BgL_v1245z00_767,((long)0),BgL_arg2036z00_768); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2043z00_781;
BgL_arg2043z00_781 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2482z00zz__avahi_avahiz00, BGl_proc2481z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1245z00_767,((long)1),BgL_arg2043z00_781); } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_arg2048z00_791;
BgL_arg2048z00_791 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2484z00zz__avahi_avahiz00, BGl_proc2483z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1245z00_767,((long)2),BgL_arg2048z00_791); } 
BgL_arg2028z00_752 = BgL_v1245z00_767; } 
{ /* Llib/avahi.scm 110 */
obj_t BgL_v1246z00_801;
BgL_v1246z00_801 = 
create_vector(((long)0)); 
BgL_arg2029z00_753 = BgL_v1246z00_801; } 
BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)82)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)3478), BGl_proc2487z00zz__avahi_avahiz00, BGl_proc2486z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2485z00zz__avahi_avahiz00, BFALSE, BgL_arg2028z00_752, BgL_arg2029z00_753); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2056z00_808;obj_t BgL_arg2057z00_809;
{ /* Llib/avahi.scm 115 */
obj_t BgL_v1247z00_825;
BgL_v1247z00_825 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2064z00_826;
BgL_arg2064z00_826 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2490z00zz__avahi_avahiz00, BGl_proc2489z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2488z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)83))); 
VECTOR_SET(BgL_v1247z00_825,((long)0),BgL_arg2064z00_826); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2071z00_839;
BgL_arg2071z00_839 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2492z00zz__avahi_avahiz00, BGl_proc2491z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1247z00_825,((long)1),BgL_arg2071z00_839); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2076z00_849;
BgL_arg2076z00_849 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2494z00zz__avahi_avahiz00, BGl_proc2493z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1247z00_825,((long)2),BgL_arg2076z00_849); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2081z00_859;
BgL_arg2081z00_859 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc2496z00zz__avahi_avahiz00, BGl_proc2495z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1247z00_825,((long)3),BgL_arg2081z00_859); } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_arg2086z00_869;
BgL_arg2086z00_869 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2499z00zz__avahi_avahiz00, BGl_proc2498z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2497z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1247z00_825,((long)4),BgL_arg2086z00_869); } 
BgL_arg2056z00_808 = BgL_v1247z00_825; } 
{ /* Llib/avahi.scm 115 */
obj_t BgL_v1248z00_882;
BgL_v1248z00_882 = 
create_vector(((long)0)); 
BgL_arg2057z00_809 = BgL_v1248z00_882; } 
BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)86)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)44122), BGl_proc2502z00zz__avahi_avahiz00, BGl_proc2501z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2500z00zz__avahi_avahiz00, BFALSE, BgL_arg2056z00_808, BgL_arg2057z00_809); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2096z00_889;obj_t BgL_arg2097z00_890;
{ /* Llib/avahi.scm 122 */
obj_t BgL_v1249z00_905;
BgL_v1249z00_905 = 
create_vector(((long)4)); 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2104z00_906;
BgL_arg2104z00_906 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2505z00zz__avahi_avahiz00, BGl_proc2504z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2503z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1249z00_905,((long)0),BgL_arg2104z00_906); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2111z00_919;
BgL_arg2111z00_919 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2507z00zz__avahi_avahiz00, BGl_proc2506z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1249z00_905,((long)1),BgL_arg2111z00_919); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2116z00_929;
BgL_arg2116z00_929 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2509z00zz__avahi_avahiz00, BGl_proc2508z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1249z00_905,((long)2),BgL_arg2116z00_929); } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_arg2121z00_939;
BgL_arg2121z00_939 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2512z00zz__avahi_avahiz00, BGl_proc2511z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2510z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1249z00_905,((long)3),BgL_arg2121z00_939); } 
BgL_arg2096z00_889 = BgL_v1249z00_905; } 
{ /* Llib/avahi.scm 122 */
obj_t BgL_v1250z00_952;
BgL_v1250z00_952 = 
create_vector(((long)0)); 
BgL_arg2097z00_890 = BgL_v1250z00_952; } 
BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)88)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)22928), BGl_proc2515z00zz__avahi_avahiz00, BGl_proc2514z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2513z00zz__avahi_avahiz00, BFALSE, BgL_arg2096z00_889, BgL_arg2097z00_890); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2131z00_959;obj_t BgL_arg2132z00_960;
{ /* Llib/avahi.scm 128 */
obj_t BgL_v1251z00_976;
BgL_v1251z00_976 = 
create_vector(((long)5)); 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2139z00_977;
BgL_arg2139z00_977 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2518z00zz__avahi_avahiz00, BGl_proc2517z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2516z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)89))); 
VECTOR_SET(BgL_v1251z00_976,((long)0),BgL_arg2139z00_977); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2146z00_990;
BgL_arg2146z00_990 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2520z00zz__avahi_avahiz00, BGl_proc2519z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1251z00_976,((long)1),BgL_arg2146z00_990); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2151z00_1000;
BgL_arg2151z00_1000 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2522z00zz__avahi_avahiz00, BGl_proc2521z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1251z00_976,((long)2),BgL_arg2151z00_1000); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2156z00_1010;
BgL_arg2156z00_1010 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc2525z00zz__avahi_avahiz00, BGl_proc2524z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2523z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1251z00_976,((long)3),BgL_arg2156z00_1010); } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_arg2163z00_1023;
BgL_arg2163z00_1023 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2528z00zz__avahi_avahiz00, BGl_proc2527z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2526z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1251z00_976,((long)4),BgL_arg2163z00_1023); } 
BgL_arg2131z00_959 = BgL_v1251z00_976; } 
{ /* Llib/avahi.scm 128 */
obj_t BgL_v1252z00_1036;
BgL_v1252z00_1036 = 
create_vector(((long)0)); 
BgL_arg2132z00_960 = BgL_v1252z00_1036; } 
BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)90)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)49790), BGl_proc2531z00zz__avahi_avahiz00, BGl_proc2530z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2529z00zz__avahi_avahiz00, BFALSE, BgL_arg2131z00_959, BgL_arg2132z00_960); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2173z00_1043;obj_t BgL_arg2174z00_1044;
{ /* Llib/avahi.scm 135 */
obj_t BgL_v1253z00_1063;
BgL_v1253z00_1063 = 
create_vector(((long)8)); 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2182z00_1064;
BgL_arg2182z00_1064 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2534z00zz__avahi_avahiz00, BGl_proc2533z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2532z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)91))); 
VECTOR_SET(BgL_v1253z00_1063,((long)0),BgL_arg2182z00_1064); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2189z00_1077;
BgL_arg2189z00_1077 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)81)), BGl_proc2536z00zz__avahi_avahiz00, BGl_proc2535z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_avahizd2clientzd2zz__avahi_avahiz00); 
VECTOR_SET(BgL_v1253z00_1063,((long)1),BgL_arg2189z00_1077); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2194z00_1087;
BgL_arg2194z00_1087 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2538z00zz__avahi_avahiz00, BGl_proc2537z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)69))); 
VECTOR_SET(BgL_v1253z00_1063,((long)2),BgL_arg2194z00_1087); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2199z00_1097;
BgL_arg2199z00_1097 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)92)), BGl_proc2540z00zz__avahi_avahiz00, BGl_proc2539z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)93))); 
VECTOR_SET(BgL_v1253z00_1063,((long)3),BgL_arg2199z00_1097); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2204z00_1107;
BgL_arg2204z00_1107 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)94)), BGl_proc2542z00zz__avahi_avahiz00, BGl_proc2541z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)67))); 
VECTOR_SET(BgL_v1253z00_1063,((long)4),BgL_arg2204z00_1107); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2209z00_1117;
BgL_arg2209z00_1117 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)95)), BGl_proc2544z00zz__avahi_avahiz00, BGl_proc2543z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1253z00_1063,((long)5),BgL_arg2209z00_1117); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2214z00_1127;
BgL_arg2214z00_1127 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)84)), BGl_proc2546z00zz__avahi_avahiz00, BGl_proc2545z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1253z00_1063,((long)6),BgL_arg2214z00_1127); } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_arg2219z00_1137;
BgL_arg2219z00_1137 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)85)), BGl_proc2549z00zz__avahi_avahiz00, BGl_proc2548z00zz__avahi_avahiz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2547z00zz__avahi_avahiz00, 
CNST_TABLE_REF(((long)74))); 
VECTOR_SET(BgL_v1253z00_1063,((long)7),BgL_arg2219z00_1137); } 
BgL_arg2173z00_1043 = BgL_v1253z00_1063; } 
{ /* Llib/avahi.scm 135 */
obj_t BgL_v1254z00_1150;
BgL_v1254z00_1150 = 
create_vector(((long)0)); 
BgL_arg2174z00_1044 = BgL_v1254z00_1150; } 
return ( 
BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)96)), 
CNST_TABLE_REF(((long)52)), BGl_avahizd2objectzd2zz__avahi_avahiz00, ((long)20996), BGl_proc2552z00zz__avahi_avahiz00, BGl_proc2551z00zz__avahi_avahiz00, BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2550z00zz__avahi_avahiz00, BFALSE, BgL_arg2173z00_1043, BgL_arg2174z00_1044), BUNSPEC) ;} } 

}



/* &<@anonymous:2181> */
obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_1978, obj_t BgL_new1140z00_1979)
{
{ /* Llib/avahi.scm 135 */
{ 
BgL_avahizd2servicezd2resolverz00_bglt BgL_auxz00_4296;
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_z42builtinz42)=((AvahiServiceResolver *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4300;
{ /* Llib/avahi.scm 135 */
obj_t BgL_classz00_2486;
BgL_classz00_2486 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 135 */
obj_t BgL__ortest_1111z00_2487;
BgL__ortest_1111z00_2487 = 
BGL_CLASS_NIL(BgL_classz00_2486); 
if(
CBOOL(BgL__ortest_1111z00_2487))
{ /* Llib/avahi.scm 135 */
BgL_auxz00_4300 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1111z00_2487)
; }  else 
{ /* Llib/avahi.scm 135 */
BgL_auxz00_4300 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2486))
; } } } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4300),BUNSPEC); } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_interfacez00)=((AvahiIfIndex)
0L),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_protocolz00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_namez00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_typez00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979)))->BgL_domainz00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4296 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_new1140z00_1979); 
return 
((obj_t)BgL_auxz00_4296);} } 

}



/* &lambda2179 */
BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2179z62zz__avahi_avahiz00(obj_t BgL_envz00_1980)
{
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1139z00_2488;
BgL_new1139z00_2488 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2resolverz00_bgl) ))); 
{ /* Llib/avahi.scm 135 */
long BgL_arg2180z00_2489;
BgL_arg2180z00_2489 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1139z00_2488), BgL_arg2180z00_2489); } 
return BgL_new1139z00_2488;} } 

}



/* &lambda2175 */
BgL_avahizd2servicezd2resolverz00_bglt BGl_z62lambda2175z62zz__avahi_avahiz00(obj_t BgL_envz00_1981, obj_t BgL_z42builtin1131z42_1982, obj_t BgL_client1132z00_1983, obj_t BgL_proc1133z00_1984, obj_t BgL_interface1134z00_1985, obj_t BgL_protocol1135z00_1986, obj_t BgL_name1136z00_1987, obj_t BgL_type1137z00_1988, obj_t BgL_domain1138z00_1989)
{
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiServiceResolver * BgL_z42builtin1131z42_2490;AvahiIfIndex BgL_interface1134z00_2493;
BgL_z42builtin1131z42_2490 = 
FOREIGN_TO_COBJ(BgL_z42builtin1131z42_1982); 
BgL_interface1134z00_2493 = 
(long)CINT(BgL_interface1134z00_1985); 
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1228z00_2498;
{ /* Llib/avahi.scm 135 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_new1227z00_2499;
BgL_new1227z00_2499 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2resolverz00_bgl) ))); 
{ /* Llib/avahi.scm 135 */
long BgL_arg2178z00_2500;
BgL_arg2178z00_2500 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1227z00_2499), BgL_arg2178z00_2500); } 
BgL_new1228z00_2498 = BgL_new1227z00_2499; } 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_z42builtinz42)=((AvahiServiceResolver *)BgL_z42builtin1131z42_2490),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1132z00_1983)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1133z00_1984)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_interfacez00)=((AvahiIfIndex)BgL_interface1134z00_2493),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_protocolz00)=((obj_t)
((obj_t)BgL_protocol1135z00_1986)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1136z00_1987)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1137z00_1988)),BUNSPEC); 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(BgL_new1228z00_2498))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1138z00_1989)),BUNSPEC); 
{ /* Llib/avahi.scm 135 */
obj_t BgL_fun2176z00_2501;
BgL_fun2176z00_2501 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2176z00_2501)(BgL_fun2176z00_2501, 
((obj_t)BgL_new1228z00_2498), BEOA); } 
return BgL_new1228z00_2498;} } } 

}



/* &<@anonymous:2225> */
obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_1990)
{
{ /* Llib/avahi.scm 135 */
return BGl_string2553z00zz__avahi_avahiz00;} 

}



/* &lambda2224 */
obj_t BGl_z62lambda2224z62zz__avahi_avahiz00(obj_t BgL_envz00_1991, obj_t BgL_oz00_1992, obj_t BgL_vz00_1993)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_1992)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_1993)),BUNSPEC);} 

}



/* &lambda2223 */
obj_t BGl_z62lambda2223z62zz__avahi_avahiz00(obj_t BgL_envz00_1994, obj_t BgL_oz00_1995)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_1995)))->BgL_domainz00);} 

}



/* &lambda2218 */
obj_t BGl_z62lambda2218z62zz__avahi_avahiz00(obj_t BgL_envz00_1996, obj_t BgL_oz00_1997, obj_t BgL_vz00_1998)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_1997)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_1998)),BUNSPEC);} 

}



/* &lambda2217 */
obj_t BGl_z62lambda2217z62zz__avahi_avahiz00(obj_t BgL_envz00_1999, obj_t BgL_oz00_2000)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2000)))->BgL_typez00);} 

}



/* &lambda2213 */
obj_t BGl_z62lambda2213z62zz__avahi_avahiz00(obj_t BgL_envz00_2001, obj_t BgL_oz00_2002, obj_t BgL_vz00_2003)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2002)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_2003)),BUNSPEC);} 

}



/* &lambda2212 */
obj_t BGl_z62lambda2212z62zz__avahi_avahiz00(obj_t BgL_envz00_2004, obj_t BgL_oz00_2005)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2005)))->BgL_namez00);} 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__avahi_avahiz00(obj_t BgL_envz00_2006, obj_t BgL_oz00_2007, obj_t BgL_vz00_2008)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2007)))->BgL_protocolz00)=((obj_t)
((obj_t)BgL_vz00_2008)),BUNSPEC);} 

}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__avahi_avahiz00(obj_t BgL_envz00_2009, obj_t BgL_oz00_2010)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2010)))->BgL_protocolz00);} 

}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__avahi_avahiz00(obj_t BgL_envz00_2011, obj_t BgL_oz00_2012, obj_t BgL_vz00_2013)
{
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiIfIndex BgL_vz00_2515;
BgL_vz00_2515 = 
(long)CINT(BgL_vz00_2013); 
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2012)))->BgL_interfacez00)=((AvahiIfIndex)BgL_vz00_2515),BUNSPEC);} } 

}



/* &lambda2202 */
obj_t BGl_z62lambda2202z62zz__avahi_avahiz00(obj_t BgL_envz00_2014, obj_t BgL_oz00_2015)
{
{ /* Llib/avahi.scm 135 */
return 
BINT(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2015)))->BgL_interfacez00));} 

}



/* &lambda2198 */
obj_t BGl_z62lambda2198z62zz__avahi_avahiz00(obj_t BgL_envz00_2016, obj_t BgL_oz00_2017, obj_t BgL_vz00_2018)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2017)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2018)),BUNSPEC);} 

}



/* &lambda2197 */
obj_t BGl_z62lambda2197z62zz__avahi_avahiz00(obj_t BgL_envz00_2019, obj_t BgL_oz00_2020)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2020)))->BgL_procz00);} 

}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__avahi_avahiz00(obj_t BgL_envz00_2021, obj_t BgL_oz00_2022, obj_t BgL_vz00_2023)
{
{ /* Llib/avahi.scm 135 */
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2022)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2023)),BUNSPEC);} 

}



/* &lambda2192 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2192z62zz__avahi_avahiz00(obj_t BgL_envz00_2024, obj_t BgL_oz00_2025)
{
{ /* Llib/avahi.scm 135 */
return 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2025)))->BgL_clientz00);} 

}



/* &<@anonymous:2188> */
obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2026)
{
{ /* Llib/avahi.scm 135 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__avahi_avahiz00(obj_t BgL_envz00_2027, obj_t BgL_oz00_2028, obj_t BgL_vz00_2029)
{
{ /* Llib/avahi.scm 135 */
{ /* Llib/avahi.scm 135 */
AvahiServiceResolver * BgL_vz00_2524;
BgL_vz00_2524 = 
FOREIGN_TO_COBJ(BgL_vz00_2029); 
return 
((((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2028)))->BgL_z42builtinz42)=((AvahiServiceResolver *)BgL_vz00_2524),BUNSPEC);} } 

}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__avahi_avahiz00(obj_t BgL_envz00_2030, obj_t BgL_oz00_2031)
{
{ /* Llib/avahi.scm 135 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2031)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2138> */
obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2032, obj_t BgL_new1129z00_2033)
{
{ /* Llib/avahi.scm 128 */
{ 
BgL_avahizd2domainzd2browserz00_bglt BgL_auxz00_4399;
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033)))->BgL_z42builtinz42)=((AvahiDomainBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4403;
{ /* Llib/avahi.scm 128 */
obj_t BgL_classz00_2527;
BgL_classz00_2527 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 128 */
obj_t BgL__ortest_1111z00_2528;
BgL__ortest_1111z00_2528 = 
BGL_CLASS_NIL(BgL_classz00_2527); 
if(
CBOOL(BgL__ortest_1111z00_2528))
{ /* Llib/avahi.scm 128 */
BgL_auxz00_4403 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1111z00_2528)
; }  else 
{ /* Llib/avahi.scm 128 */
BgL_auxz00_4403 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2527))
; } } } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4403),BUNSPEC); } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033)))->BgL_btypez00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033)))->BgL_domainz00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4399 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_new1129z00_2033); 
return 
((obj_t)BgL_auxz00_4399);} } 

}



/* &lambda2136 */
BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2136z62zz__avahi_avahiz00(obj_t BgL_envz00_2034)
{
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1128z00_2529;
BgL_new1128z00_2529 = 
((BgL_avahizd2domainzd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2domainzd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 128 */
long BgL_arg2137z00_2530;
BgL_arg2137z00_2530 = 
BGL_CLASS_INDEX(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1128z00_2529), BgL_arg2137z00_2530); } 
return BgL_new1128z00_2529;} } 

}



/* &lambda2133 */
BgL_avahizd2domainzd2browserz00_bglt BGl_z62lambda2133z62zz__avahi_avahiz00(obj_t BgL_envz00_2035, obj_t BgL_z42builtin1123z42_2036, obj_t BgL_client1124z00_2037, obj_t BgL_proc1125z00_2038, obj_t BgL_btype1126z00_2039, obj_t BgL_domain1127z00_2040)
{
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
AvahiDomainBrowser * BgL_z42builtin1123z42_2531;
BgL_z42builtin1123z42_2531 = 
FOREIGN_TO_COBJ(BgL_z42builtin1123z42_2036); 
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1226z00_2536;
{ /* Llib/avahi.scm 128 */
BgL_avahizd2domainzd2browserz00_bglt BgL_new1225z00_2537;
BgL_new1225z00_2537 = 
((BgL_avahizd2domainzd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2domainzd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 128 */
long BgL_arg2135z00_2538;
BgL_arg2135z00_2538 = 
BGL_CLASS_INDEX(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1225z00_2537), BgL_arg2135z00_2538); } 
BgL_new1226z00_2536 = BgL_new1225z00_2537; } 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1226z00_2536))->BgL_z42builtinz42)=((AvahiDomainBrowser *)BgL_z42builtin1123z42_2531),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1226z00_2536))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1124z00_2037)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1226z00_2536))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1125z00_2038)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1226z00_2536))->BgL_btypez00)=((obj_t)
((obj_t)BgL_btype1126z00_2039)),BUNSPEC); 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(BgL_new1226z00_2536))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1127z00_2040)),BUNSPEC); 
{ /* Llib/avahi.scm 128 */
obj_t BgL_fun2134z00_2539;
BgL_fun2134z00_2539 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2134z00_2539)(BgL_fun2134z00_2539, 
((obj_t)BgL_new1226z00_2536), BEOA); } 
return BgL_new1226z00_2536;} } } 

}



/* &<@anonymous:2169> */
obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2041)
{
{ /* Llib/avahi.scm 128 */
return BGl_string2553z00zz__avahi_avahiz00;} 

}



/* &lambda2168 */
obj_t BGl_z62lambda2168z62zz__avahi_avahiz00(obj_t BgL_envz00_2042, obj_t BgL_oz00_2043, obj_t BgL_vz00_2044)
{
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2043)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2044)),BUNSPEC);} 

}



/* &lambda2167 */
obj_t BGl_z62lambda2167z62zz__avahi_avahiz00(obj_t BgL_envz00_2045, obj_t BgL_oz00_2046)
{
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2046)))->BgL_domainz00);} 

}



/* &<@anonymous:2162> */
obj_t BGl_z62zc3z04anonymousza32162ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2047)
{
{ /* Llib/avahi.scm 128 */
return 
CNST_TABLE_REF(((long)98));} 

}



/* &lambda2161 */
obj_t BGl_z62lambda2161z62zz__avahi_avahiz00(obj_t BgL_envz00_2048, obj_t BgL_oz00_2049, obj_t BgL_vz00_2050)
{
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2049)))->BgL_btypez00)=((obj_t)
((obj_t)BgL_vz00_2050)),BUNSPEC);} 

}



/* &lambda2160 */
obj_t BGl_z62lambda2160z62zz__avahi_avahiz00(obj_t BgL_envz00_2051, obj_t BgL_oz00_2052)
{
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2052)))->BgL_btypez00);} 

}



/* &lambda2155 */
obj_t BGl_z62lambda2155z62zz__avahi_avahiz00(obj_t BgL_envz00_2053, obj_t BgL_oz00_2054, obj_t BgL_vz00_2055)
{
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2054)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2055)),BUNSPEC);} 

}



/* &lambda2154 */
obj_t BGl_z62lambda2154z62zz__avahi_avahiz00(obj_t BgL_envz00_2056, obj_t BgL_oz00_2057)
{
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2057)))->BgL_procz00);} 

}



/* &lambda2150 */
obj_t BGl_z62lambda2150z62zz__avahi_avahiz00(obj_t BgL_envz00_2058, obj_t BgL_oz00_2059, obj_t BgL_vz00_2060)
{
{ /* Llib/avahi.scm 128 */
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2059)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2060)),BUNSPEC);} 

}



/* &lambda2149 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2149z62zz__avahi_avahiz00(obj_t BgL_envz00_2061, obj_t BgL_oz00_2062)
{
{ /* Llib/avahi.scm 128 */
return 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2062)))->BgL_clientz00);} 

}



/* &<@anonymous:2145> */
obj_t BGl_z62zc3z04anonymousza32145ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2063)
{
{ /* Llib/avahi.scm 128 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda2144 */
obj_t BGl_z62lambda2144z62zz__avahi_avahiz00(obj_t BgL_envz00_2064, obj_t BgL_oz00_2065, obj_t BgL_vz00_2066)
{
{ /* Llib/avahi.scm 128 */
{ /* Llib/avahi.scm 128 */
AvahiDomainBrowser * BgL_vz00_2553;
BgL_vz00_2553 = 
FOREIGN_TO_COBJ(BgL_vz00_2066); 
return 
((((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2065)))->BgL_z42builtinz42)=((AvahiDomainBrowser *)BgL_vz00_2553),BUNSPEC);} } 

}



/* &lambda2143 */
obj_t BGl_z62lambda2143z62zz__avahi_avahiz00(obj_t BgL_envz00_2067, obj_t BgL_oz00_2068)
{
{ /* Llib/avahi.scm 128 */
return 
void_star_to_obj(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2068)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2103> */
obj_t BGl_z62zc3z04anonymousza32103ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2069, obj_t BgL_new1121z00_2070)
{
{ /* Llib/avahi.scm 122 */
{ 
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_auxz00_4474;
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1121z00_2070)))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4478;
{ /* Llib/avahi.scm 122 */
obj_t BgL_classz00_2556;
BgL_classz00_2556 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 122 */
obj_t BgL__ortest_1111z00_2557;
BgL__ortest_1111z00_2557 = 
BGL_CLASS_NIL(BgL_classz00_2556); 
if(
CBOOL(BgL__ortest_1111z00_2557))
{ /* Llib/avahi.scm 122 */
BgL_auxz00_4478 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1111z00_2557)
; }  else 
{ /* Llib/avahi.scm 122 */
BgL_auxz00_4478 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2556))
; } } } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1121z00_2070)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4478),BUNSPEC); } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1121z00_2070)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1121z00_2070)))->BgL_domainz00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4474 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_new1121z00_2070); 
return 
((obj_t)BgL_auxz00_4474);} } 

}



/* &lambda2101 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2101z62zz__avahi_avahiz00(obj_t BgL_envz00_2071)
{
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1120z00_2558;
BgL_new1120z00_2558 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2typezd2browserzd2_bgl) ))); 
{ /* Llib/avahi.scm 122 */
long BgL_arg2102z00_2559;
BgL_arg2102z00_2559 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_2558), BgL_arg2102z00_2559); } 
return BgL_new1120z00_2558;} } 

}



/* &lambda2098 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BGl_z62lambda2098z62zz__avahi_avahiz00(obj_t BgL_envz00_2072, obj_t BgL_z42builtin1116z42_2073, obj_t BgL_client1117z00_2074, obj_t BgL_proc1118z00_2075, obj_t BgL_domain1119z00_2076)
{
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
AvahiServiceTypeBrowser * BgL_z42builtin1116z42_2560;
BgL_z42builtin1116z42_2560 = 
FOREIGN_TO_COBJ(BgL_z42builtin1116z42_2073); 
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1224z00_2564;
{ /* Llib/avahi.scm 122 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_new1223z00_2565;
BgL_new1223z00_2565 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2typezd2browserzd2_bgl) ))); 
{ /* Llib/avahi.scm 122 */
long BgL_arg2100z00_2566;
BgL_arg2100z00_2566 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_2565), BgL_arg2100z00_2566); } 
BgL_new1224z00_2564 = BgL_new1223z00_2565; } 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1224z00_2564))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)BgL_z42builtin1116z42_2560),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1224z00_2564))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1117z00_2074)),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1224z00_2564))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1118z00_2075)),BUNSPEC); 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(BgL_new1224z00_2564))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1119z00_2076)),BUNSPEC); 
{ /* Llib/avahi.scm 122 */
obj_t BgL_fun2099z00_2567;
BgL_fun2099z00_2567 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2099z00_2567)(BgL_fun2099z00_2567, 
((obj_t)BgL_new1224z00_2564), BEOA); } 
return BgL_new1224z00_2564;} } } 

}



/* &<@anonymous:2127> */
obj_t BGl_z62zc3z04anonymousza32127ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2077)
{
{ /* Llib/avahi.scm 122 */
return BGl_string2553z00zz__avahi_avahiz00;} 

}



/* &lambda2126 */
obj_t BGl_z62lambda2126z62zz__avahi_avahiz00(obj_t BgL_envz00_2078, obj_t BgL_oz00_2079, obj_t BgL_vz00_2080)
{
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2079)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2080)),BUNSPEC);} 

}



/* &lambda2125 */
obj_t BGl_z62lambda2125z62zz__avahi_avahiz00(obj_t BgL_envz00_2081, obj_t BgL_oz00_2082)
{
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2082)))->BgL_domainz00);} 

}



/* &lambda2120 */
obj_t BGl_z62lambda2120z62zz__avahi_avahiz00(obj_t BgL_envz00_2083, obj_t BgL_oz00_2084, obj_t BgL_vz00_2085)
{
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2084)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2085)),BUNSPEC);} 

}



/* &lambda2119 */
obj_t BGl_z62lambda2119z62zz__avahi_avahiz00(obj_t BgL_envz00_2086, obj_t BgL_oz00_2087)
{
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2087)))->BgL_procz00);} 

}



/* &lambda2115 */
obj_t BGl_z62lambda2115z62zz__avahi_avahiz00(obj_t BgL_envz00_2088, obj_t BgL_oz00_2089, obj_t BgL_vz00_2090)
{
{ /* Llib/avahi.scm 122 */
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2089)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2090)),BUNSPEC);} 

}



/* &lambda2114 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2114z62zz__avahi_avahiz00(obj_t BgL_envz00_2091, obj_t BgL_oz00_2092)
{
{ /* Llib/avahi.scm 122 */
return 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2092)))->BgL_clientz00);} 

}



/* &<@anonymous:2110> */
obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2093)
{
{ /* Llib/avahi.scm 122 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda2109 */
obj_t BGl_z62lambda2109z62zz__avahi_avahiz00(obj_t BgL_envz00_2094, obj_t BgL_oz00_2095, obj_t BgL_vz00_2096)
{
{ /* Llib/avahi.scm 122 */
{ /* Llib/avahi.scm 122 */
AvahiServiceTypeBrowser * BgL_vz00_2578;
BgL_vz00_2578 = 
FOREIGN_TO_COBJ(BgL_vz00_2096); 
return 
((((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2095)))->BgL_z42builtinz42)=((AvahiServiceTypeBrowser *)BgL_vz00_2578),BUNSPEC);} } 

}



/* &lambda2108 */
obj_t BGl_z62lambda2108z62zz__avahi_avahiz00(obj_t BgL_envz00_2097, obj_t BgL_oz00_2098)
{
{ /* Llib/avahi.scm 122 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2098)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2063> */
obj_t BGl_z62zc3z04anonymousza32063ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2099, obj_t BgL_new1114z00_2100)
{
{ /* Llib/avahi.scm 115 */
{ 
BgL_avahizd2servicezd2browserz00_bglt BgL_auxz00_4538;
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100)))->BgL_z42builtinz42)=((AvahiServiceBrowser *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4542;
{ /* Llib/avahi.scm 115 */
obj_t BgL_classz00_2581;
BgL_classz00_2581 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 115 */
obj_t BgL__ortest_1111z00_2582;
BgL__ortest_1111z00_2582 = 
BGL_CLASS_NIL(BgL_classz00_2581); 
if(
CBOOL(BgL__ortest_1111z00_2582))
{ /* Llib/avahi.scm 115 */
BgL_auxz00_4542 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1111z00_2582)
; }  else 
{ /* Llib/avahi.scm 115 */
BgL_auxz00_4542 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2581))
; } } } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4542),BUNSPEC); } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100)))->BgL_typez00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100)))->BgL_domainz00)=((obj_t)BGl_string2553z00zz__avahi_avahiz00),BUNSPEC); 
BgL_auxz00_4538 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_new1114z00_2100); 
return 
((obj_t)BgL_auxz00_4538);} } 

}



/* &lambda2061 */
BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2061z62zz__avahi_avahiz00(obj_t BgL_envz00_2101)
{
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1113z00_2583;
BgL_new1113z00_2583 = 
((BgL_avahizd2servicezd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 115 */
long BgL_arg2062z00_2584;
BgL_arg2062z00_2584 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1113z00_2583), BgL_arg2062z00_2584); } 
return BgL_new1113z00_2583;} } 

}



/* &lambda2058 */
BgL_avahizd2servicezd2browserz00_bglt BGl_z62lambda2058z62zz__avahi_avahiz00(obj_t BgL_envz00_2102, obj_t BgL_z42builtin1108z42_2103, obj_t BgL_client1109z00_2104, obj_t BgL_proc1110z00_2105, obj_t BgL_type1111z00_2106, obj_t BgL_domain1112z00_2107)
{
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
AvahiServiceBrowser * BgL_z42builtin1108z42_2585;
BgL_z42builtin1108z42_2585 = 
FOREIGN_TO_COBJ(BgL_z42builtin1108z42_2103); 
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1222z00_2590;
{ /* Llib/avahi.scm 115 */
BgL_avahizd2servicezd2browserz00_bglt BgL_new1221z00_2591;
BgL_new1221z00_2591 = 
((BgL_avahizd2servicezd2browserz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2servicezd2browserz00_bgl) ))); 
{ /* Llib/avahi.scm 115 */
long BgL_arg2060z00_2592;
BgL_arg2060z00_2592 = 
BGL_CLASS_INDEX(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1221z00_2591), BgL_arg2060z00_2592); } 
BgL_new1222z00_2590 = BgL_new1221z00_2591; } 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1222z00_2590))->BgL_z42builtinz42)=((AvahiServiceBrowser *)BgL_z42builtin1108z42_2585),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1222z00_2590))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1109z00_2104)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1222z00_2590))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1110z00_2105)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1222z00_2590))->BgL_typez00)=((obj_t)
((obj_t)BgL_type1111z00_2106)),BUNSPEC); 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(BgL_new1222z00_2590))->BgL_domainz00)=((obj_t)
((obj_t)BgL_domain1112z00_2107)),BUNSPEC); 
{ /* Llib/avahi.scm 115 */
obj_t BgL_fun2059z00_2593;
BgL_fun2059z00_2593 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2059z00_2593)(BgL_fun2059z00_2593, 
((obj_t)BgL_new1222z00_2590), BEOA); } 
return BgL_new1222z00_2590;} } } 

}



/* &<@anonymous:2092> */
obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2108)
{
{ /* Llib/avahi.scm 115 */
return BGl_string2553z00zz__avahi_avahiz00;} 

}



/* &lambda2091 */
obj_t BGl_z62lambda2091z62zz__avahi_avahiz00(obj_t BgL_envz00_2109, obj_t BgL_oz00_2110, obj_t BgL_vz00_2111)
{
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2110)))->BgL_domainz00)=((obj_t)
((obj_t)BgL_vz00_2111)),BUNSPEC);} 

}



/* &lambda2090 */
obj_t BGl_z62lambda2090z62zz__avahi_avahiz00(obj_t BgL_envz00_2112, obj_t BgL_oz00_2113)
{
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2113)))->BgL_domainz00);} 

}



/* &lambda2085 */
obj_t BGl_z62lambda2085z62zz__avahi_avahiz00(obj_t BgL_envz00_2114, obj_t BgL_oz00_2115, obj_t BgL_vz00_2116)
{
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2115)))->BgL_typez00)=((obj_t)
((obj_t)BgL_vz00_2116)),BUNSPEC);} 

}



/* &lambda2084 */
obj_t BGl_z62lambda2084z62zz__avahi_avahiz00(obj_t BgL_envz00_2117, obj_t BgL_oz00_2118)
{
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2118)))->BgL_typez00);} 

}



/* &lambda2080 */
obj_t BGl_z62lambda2080z62zz__avahi_avahiz00(obj_t BgL_envz00_2119, obj_t BgL_oz00_2120, obj_t BgL_vz00_2121)
{
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2120)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2121)),BUNSPEC);} 

}



/* &lambda2079 */
obj_t BGl_z62lambda2079z62zz__avahi_avahiz00(obj_t BgL_envz00_2122, obj_t BgL_oz00_2123)
{
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2123)))->BgL_procz00);} 

}



/* &lambda2075 */
obj_t BGl_z62lambda2075z62zz__avahi_avahiz00(obj_t BgL_envz00_2124, obj_t BgL_oz00_2125, obj_t BgL_vz00_2126)
{
{ /* Llib/avahi.scm 115 */
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2125)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2126)),BUNSPEC);} 

}



/* &lambda2074 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2074z62zz__avahi_avahiz00(obj_t BgL_envz00_2127, obj_t BgL_oz00_2128)
{
{ /* Llib/avahi.scm 115 */
return 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2128)))->BgL_clientz00);} 

}



/* &<@anonymous:2070> */
obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2129)
{
{ /* Llib/avahi.scm 115 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda2069 */
obj_t BGl_z62lambda2069z62zz__avahi_avahiz00(obj_t BgL_envz00_2130, obj_t BgL_oz00_2131, obj_t BgL_vz00_2132)
{
{ /* Llib/avahi.scm 115 */
{ /* Llib/avahi.scm 115 */
AvahiServiceBrowser * BgL_vz00_2607;
BgL_vz00_2607 = 
FOREIGN_TO_COBJ(BgL_vz00_2132); 
return 
((((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2131)))->BgL_z42builtinz42)=((AvahiServiceBrowser *)BgL_vz00_2607),BUNSPEC);} } 

}



/* &lambda2068 */
obj_t BGl_z62lambda2068z62zz__avahi_avahiz00(obj_t BgL_envz00_2133, obj_t BgL_oz00_2134)
{
{ /* Llib/avahi.scm 115 */
return 
void_star_to_obj(
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2134)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2035> */
obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2135, obj_t BgL_new1106z00_2136)
{
{ /* Llib/avahi.scm 110 */
{ 
BgL_avahizd2entryzd2groupz00_bglt BgL_auxz00_4611;
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1106z00_2136)))->BgL_z42builtinz42)=((AvahiEntryGroup *)
0L),BUNSPEC); 
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4615;
{ /* Llib/avahi.scm 110 */
obj_t BgL_classz00_2610;
BgL_classz00_2610 = BGl_avahizd2clientzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 110 */
obj_t BgL__ortest_1111z00_2611;
BgL__ortest_1111z00_2611 = 
BGL_CLASS_NIL(BgL_classz00_2610); 
if(
CBOOL(BgL__ortest_1111z00_2611))
{ /* Llib/avahi.scm 110 */
BgL_auxz00_4615 = 
((BgL_avahizd2clientzd2_bglt)BgL__ortest_1111z00_2611)
; }  else 
{ /* Llib/avahi.scm 110 */
BgL_auxz00_4615 = 
((BgL_avahizd2clientzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2610))
; } } } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1106z00_2136)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)BgL_auxz00_4615),BUNSPEC); } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1106z00_2136)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_4611 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_new1106z00_2136); 
return 
((obj_t)BgL_auxz00_4611);} } 

}



/* &lambda2033 */
BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2033z62zz__avahi_avahiz00(obj_t BgL_envz00_2137)
{
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1105z00_2612;
BgL_new1105z00_2612 = 
((BgL_avahizd2entryzd2groupz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2entryzd2groupz00_bgl) ))); 
{ /* Llib/avahi.scm 110 */
long BgL_arg2034z00_2613;
BgL_arg2034z00_2613 = 
BGL_CLASS_INDEX(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_2612), BgL_arg2034z00_2613); } 
return BgL_new1105z00_2612;} } 

}



/* &lambda2030 */
BgL_avahizd2entryzd2groupz00_bglt BGl_z62lambda2030z62zz__avahi_avahiz00(obj_t BgL_envz00_2138, obj_t BgL_z42builtin1102z42_2139, obj_t BgL_client1103z00_2140, obj_t BgL_proc1104z00_2141)
{
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
AvahiEntryGroup * BgL_z42builtin1102z42_2614;
BgL_z42builtin1102z42_2614 = 
FOREIGN_TO_COBJ(BgL_z42builtin1102z42_2139); 
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1220z00_2617;
{ /* Llib/avahi.scm 110 */
BgL_avahizd2entryzd2groupz00_bglt BgL_new1219z00_2618;
BgL_new1219z00_2618 = 
((BgL_avahizd2entryzd2groupz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2entryzd2groupz00_bgl) ))); 
{ /* Llib/avahi.scm 110 */
long BgL_arg2032z00_2619;
BgL_arg2032z00_2619 = 
BGL_CLASS_INDEX(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_2618), BgL_arg2032z00_2619); } 
BgL_new1220z00_2617 = BgL_new1219z00_2618; } 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1220z00_2617))->BgL_z42builtinz42)=((AvahiEntryGroup *)BgL_z42builtin1102z42_2614),BUNSPEC); 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1220z00_2617))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_client1103z00_2140)),BUNSPEC); 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(BgL_new1220z00_2617))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1104z00_2141)),BUNSPEC); 
{ /* Llib/avahi.scm 110 */
obj_t BgL_fun2031z00_2620;
BgL_fun2031z00_2620 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun2031z00_2620)(BgL_fun2031z00_2620, 
((obj_t)BgL_new1220z00_2617), BEOA); } 
return BgL_new1220z00_2617;} } } 

}



/* &lambda2052 */
obj_t BGl_z62lambda2052z62zz__avahi_avahiz00(obj_t BgL_envz00_2142, obj_t BgL_oz00_2143, obj_t BgL_vz00_2144)
{
{ /* Llib/avahi.scm 110 */
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2143)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2144)),BUNSPEC);} 

}



/* &lambda2051 */
obj_t BGl_z62lambda2051z62zz__avahi_avahiz00(obj_t BgL_envz00_2145, obj_t BgL_oz00_2146)
{
{ /* Llib/avahi.scm 110 */
return 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2146)))->BgL_procz00);} 

}



/* &lambda2047 */
obj_t BGl_z62lambda2047z62zz__avahi_avahiz00(obj_t BgL_envz00_2147, obj_t BgL_oz00_2148, obj_t BgL_vz00_2149)
{
{ /* Llib/avahi.scm 110 */
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2148)))->BgL_clientz00)=((BgL_avahizd2clientzd2_bglt)
((BgL_avahizd2clientzd2_bglt)BgL_vz00_2149)),BUNSPEC);} 

}



/* &lambda2046 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda2046z62zz__avahi_avahiz00(obj_t BgL_envz00_2150, obj_t BgL_oz00_2151)
{
{ /* Llib/avahi.scm 110 */
return 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2151)))->BgL_clientz00);} 

}



/* &<@anonymous:2042> */
obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2152)
{
{ /* Llib/avahi.scm 110 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda2041 */
obj_t BGl_z62lambda2041z62zz__avahi_avahiz00(obj_t BgL_envz00_2153, obj_t BgL_oz00_2154, obj_t BgL_vz00_2155)
{
{ /* Llib/avahi.scm 110 */
{ /* Llib/avahi.scm 110 */
AvahiEntryGroup * BgL_vz00_2628;
BgL_vz00_2628 = 
FOREIGN_TO_COBJ(BgL_vz00_2155); 
return 
((((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2154)))->BgL_z42builtinz42)=((AvahiEntryGroup *)BgL_vz00_2628),BUNSPEC);} } 

}



/* &lambda2040 */
obj_t BGl_z62lambda2040z62zz__avahi_avahiz00(obj_t BgL_envz00_2156, obj_t BgL_oz00_2157)
{
{ /* Llib/avahi.scm 110 */
return 
void_star_to_obj(
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2157)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1900> */
obj_t BGl_z62zc3z04anonymousza31900ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2158, obj_t BgL_new1100z00_2159)
{
{ /* Llib/avahi.scm 67 */
{ 
BgL_avahizd2clientzd2_bglt BgL_auxz00_4666;
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_z42builtinz42)=((AvahiClient *)
0L),BUNSPEC); 
{ 
BgL_avahizd2pollzd2_bglt BgL_auxz00_4670;
{ /* Llib/avahi.scm 67 */
obj_t BgL_classz00_2631;
BgL_classz00_2631 = BGl_avahizd2pollzd2zz__avahi_avahiz00; 
{ /* Llib/avahi.scm 67 */
obj_t BgL__ortest_1111z00_2632;
BgL__ortest_1111z00_2632 = 
BGL_CLASS_NIL(BgL_classz00_2631); 
if(
CBOOL(BgL__ortest_1111z00_2632))
{ /* Llib/avahi.scm 67 */
BgL_auxz00_4670 = 
((BgL_avahizd2pollzd2_bglt)BgL__ortest_1111z00_2632)
; }  else 
{ /* Llib/avahi.scm 67 */
BgL_auxz00_4670 = 
((BgL_avahizd2pollzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2631))
; } } } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)BgL_auxz00_4670),BUNSPEC); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_flagsz00)=((obj_t)
CNST_TABLE_REF(((long)97))),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_procz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_z52groupsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_z52browsersz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159)))->BgL_resolversz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4666 = 
((BgL_avahizd2clientzd2_bglt)BgL_new1100z00_2159); 
return 
((obj_t)BgL_auxz00_4666);} } 

}



/* &lambda1898 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda1898z62zz__avahi_avahiz00(obj_t BgL_envz00_2160)
{
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1099z00_2633;
BgL_new1099z00_2633 = 
((BgL_avahizd2clientzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2clientzd2_bgl) ))); 
{ /* Llib/avahi.scm 67 */
long BgL_arg1899z00_2634;
BgL_arg1899z00_2634 = 
BGL_CLASS_INDEX(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1099z00_2633), BgL_arg1899z00_2634); } 
return BgL_new1099z00_2633;} } 

}



/* &lambda1895 */
BgL_avahizd2clientzd2_bglt BGl_z62lambda1895z62zz__avahi_avahiz00(obj_t BgL_envz00_2161, obj_t BgL_z42builtin1092z42_2162, obj_t BgL_poll1093z00_2163, obj_t BgL_flags1094z00_2164, obj_t BgL_proc1095z00_2165, obj_t BgL_z52groups1096z52_2166, obj_t BgL_z52browsers1097z52_2167, obj_t BgL_resolvers1098z00_2168)
{
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
AvahiClient * BgL_z42builtin1092z42_2635;
BgL_z42builtin1092z42_2635 = 
FOREIGN_TO_COBJ(BgL_z42builtin1092z42_2162); 
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1218z00_2642;
{ /* Llib/avahi.scm 67 */
BgL_avahizd2clientzd2_bglt BgL_new1217z00_2643;
BgL_new1217z00_2643 = 
((BgL_avahizd2clientzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2clientzd2_bgl) ))); 
{ /* Llib/avahi.scm 67 */
long BgL_arg1897z00_2644;
BgL_arg1897z00_2644 = 
BGL_CLASS_INDEX(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1217z00_2643), BgL_arg1897z00_2644); } 
BgL_new1218z00_2642 = BgL_new1217z00_2643; } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_z42builtinz42)=((AvahiClient *)BgL_z42builtin1092z42_2635),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2pollzd2_bglt)BgL_poll1093z00_2163)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_flags1094z00_2164)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_procz00)=((obj_t)
((obj_t)BgL_proc1095z00_2165)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_z52groupsz52)=((obj_t)
((obj_t)BgL_z52groups1096z52_2166)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_z52browsersz52)=((obj_t)
((obj_t)BgL_z52browsers1097z52_2167)),BUNSPEC); 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_new1218z00_2642))->BgL_resolversz00)=((obj_t)
((obj_t)BgL_resolvers1098z00_2168)),BUNSPEC); 
{ /* Llib/avahi.scm 67 */
obj_t BgL_fun1896z00_2645;
BgL_fun1896z00_2645 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2clientzd2zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1896z00_2645)(BgL_fun1896z00_2645, 
((obj_t)BgL_new1218z00_2642), BEOA); } 
return BgL_new1218z00_2642;} } } 

}



/* &<@anonymous:2018> */
obj_t BGl_z62zc3z04anonymousza32018ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2169, obj_t BgL_oz00_2170)
{
{ /* Llib/avahi.scm 101 */
{ /* Llib/avahi.scm 104 */
bool_t BgL_test2957z00_4720;
{ /* Llib/avahi.scm 104 */
AvahiClient * BgL_arg2023z00_2646;
BgL_arg2023z00_2646 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2170)))->BgL_z42builtinz42); 
BgL_test2957z00_4720 = 
(BgL_arg2023z00_2646 == 0L); } 
if(BgL_test2957z00_4720)
{ /* Llib/avahi.scm 104 */
return 
CNST_TABLE_REF(((long)99));}  else 
{ /* Llib/avahi.scm 107 */
AvahiClientState BgL_arg2021z00_2647;
{ /* Llib/avahi.scm 107 */
AvahiClient * BgL_arg2022z00_2648;
BgL_arg2022z00_2648 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2170)))->BgL_z42builtinz42); 
BgL_arg2021z00_2647 = 
avahi_client_get_state(BgL_arg2022z00_2648); } 
return 
bgl_avahi_client_state_to_symbol(BgL_arg2021z00_2647);} } } 

}



/* &<@anonymous:2009> */
obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2171, obj_t BgL_oz00_2172)
{
{ /* Llib/avahi.scm 95 */
{ /* Llib/avahi.scm 98 */
bool_t BgL_test2958z00_4729;
{ /* Llib/avahi.scm 98 */
AvahiClient * BgL_arg2013z00_2649;
BgL_arg2013z00_2649 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2172)))->BgL_z42builtinz42); 
BgL_test2958z00_4729 = 
(BgL_arg2013z00_2649 == 0L); } 
if(BgL_test2958z00_4729)
{ /* Llib/avahi.scm 98 */
return BGl_string2554z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 100 */
AvahiClient * BgL_arg2012z00_2650;
BgL_arg2012z00_2650 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2172)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_host_name_fqdn(BgL_arg2012z00_2650));} } } 

}



/* &<@anonymous:2000> */
obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2173, obj_t BgL_oz00_2174)
{
{ /* Llib/avahi.scm 89 */
{ /* Llib/avahi.scm 92 */
bool_t BgL_test2959z00_4737;
{ /* Llib/avahi.scm 92 */
AvahiClient * BgL_arg2004z00_2651;
BgL_arg2004z00_2651 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2174)))->BgL_z42builtinz42); 
BgL_test2959z00_4737 = 
(BgL_arg2004z00_2651 == 0L); } 
if(BgL_test2959z00_4737)
{ /* Llib/avahi.scm 92 */
return BGl_string2554z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 94 */
AvahiClient * BgL_arg2003z00_2652;
BgL_arg2003z00_2652 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2174)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_domain_name(BgL_arg2003z00_2652));} } } 

}



/* &<@anonymous:1991> */
obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2175, obj_t BgL_oz00_2176, obj_t BgL_vz00_2177)
{
{ /* Llib/avahi.scm 81 */
{ /* Llib/avahi.scm 87 */
bool_t BgL_test2960z00_4745;
{ /* Llib/avahi.scm 87 */
AvahiClient * BgL_arg1995z00_2653;
BgL_arg1995z00_2653 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2176)))->BgL_z42builtinz42); 
BgL_test2960z00_4745 = 
(BgL_arg1995z00_2653 == 0L); } 
if(BgL_test2960z00_4745)
{ /* Llib/avahi.scm 87 */
return BFALSE;}  else 
{ /* Llib/avahi.scm 88 */
AvahiClient * BgL_arg1994z00_2654;
BgL_arg1994z00_2654 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2176)))->BgL_z42builtinz42); 
{ /* Llib/avahi.scm 88 */
char * BgL_tmpz00_4751;
{ /* Llib/avahi.scm 88 */
char * BgL_tmpz00_4752;
BgL_tmpz00_4752 = 
BSTRING_TO_STRING(
((obj_t)BgL_vz00_2177)); 
BgL_tmpz00_4751 = 
avahi_client_set_host_name(BgL_arg1994z00_2654, BgL_tmpz00_4752); } 
return 
string_to_bstring(BgL_tmpz00_4751);} } } } 

}



/* &<@anonymous:1985> */
obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2178, obj_t BgL_oz00_2179)
{
{ /* Llib/avahi.scm 81 */
{ /* Llib/avahi.scm 83 */
bool_t BgL_test2961z00_4757;
{ /* Llib/avahi.scm 83 */
AvahiClient * BgL_arg1989z00_2655;
BgL_arg1989z00_2655 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2179)))->BgL_z42builtinz42); 
BgL_test2961z00_4757 = 
(BgL_arg1989z00_2655 == 0L); } 
if(BgL_test2961z00_4757)
{ /* Llib/avahi.scm 83 */
return BGl_string2554z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 85 */
AvahiClient * BgL_arg1988z00_2656;
BgL_arg1988z00_2656 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2179)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_host_name(BgL_arg1988z00_2656));} } } 

}



/* &<@anonymous:1975> */
obj_t BGl_z62zc3z04anonymousza31975ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2180, obj_t BgL_oz00_2181)
{
{ /* Llib/avahi.scm 75 */
{ /* Llib/avahi.scm 78 */
bool_t BgL_test2962z00_4765;
{ /* Llib/avahi.scm 78 */
AvahiClient * BgL_arg1979z00_2657;
BgL_arg1979z00_2657 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2181)))->BgL_z42builtinz42); 
BgL_test2962z00_4765 = 
(BgL_arg1979z00_2657 == 0L); } 
if(BgL_test2962z00_4765)
{ /* Llib/avahi.scm 78 */
return BGl_string2554z00zz__avahi_avahiz00;}  else 
{ /* Llib/avahi.scm 80 */
AvahiClient * BgL_arg1978z00_2658;
BgL_arg1978z00_2658 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2181)))->BgL_z42builtinz42); 
return 
string_to_bstring(
avahi_client_get_version_string(BgL_arg1978z00_2658));} } } 

}



/* &<@anonymous:1971> */
obj_t BGl_z62zc3z04anonymousza31971ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2182, obj_t BgL_oz00_2183, obj_t BgL_vz00_2184)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2183), 
(int)(((long)4)), BgL_vz00_2184);} 

}



/* &<@anonymous:1970> */
obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2185, obj_t BgL_oz00_2186)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2186), 
(int)(((long)4)));} 

}



/* &<@anonymous:1966> */
obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2187, obj_t BgL_oz00_2188, obj_t BgL_vz00_2189)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2188), 
(int)(((long)3)), BgL_vz00_2189);} 

}



/* &<@anonymous:1965> */
obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2190, obj_t BgL_oz00_2191)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2191), 
(int)(((long)3)));} 

}



/* &<@anonymous:1961> */
obj_t BGl_z62zc3z04anonymousza31961ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2192, obj_t BgL_oz00_2193, obj_t BgL_vz00_2194)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2193), 
(int)(((long)2)), BgL_vz00_2194);} 

}



/* &<@anonymous:1960> */
obj_t BGl_z62zc3z04anonymousza31960ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2195, obj_t BgL_oz00_2196)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2196), 
(int)(((long)2)));} 

}



/* &<@anonymous:1956> */
obj_t BGl_z62zc3z04anonymousza31956ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2197, obj_t BgL_oz00_2198, obj_t BgL_vz00_2199)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2198), 
(int)(((long)1)), BgL_vz00_2199);} 

}



/* &<@anonymous:1955> */
obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2200, obj_t BgL_oz00_2201)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2201), 
(int)(((long)1)));} 

}



/* &<@anonymous:1951> */
obj_t BGl_z62zc3z04anonymousza31951ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2202, obj_t BgL_oz00_2203, obj_t BgL_vz00_2204)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2203), 
(int)(((long)0)), BgL_vz00_2204);} 

}



/* &<@anonymous:1950> */
obj_t BGl_z62zc3z04anonymousza31950ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2205, obj_t BgL_oz00_2206)
{
{ /* Llib/avahi.scm 67 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2206), 
(int)(((long)0)));} 

}



/* &<@anonymous:1946> */
obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2207)
{
{ /* Llib/avahi.scm 67 */
return BNIL;} 

}



/* &lambda1945 */
obj_t BGl_z62lambda1945z62zz__avahi_avahiz00(obj_t BgL_envz00_2208, obj_t BgL_oz00_2209, obj_t BgL_vz00_2210)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2209)))->BgL_resolversz00)=((obj_t)
((obj_t)BgL_vz00_2210)),BUNSPEC);} 

}



/* &lambda1944 */
obj_t BGl_z62lambda1944z62zz__avahi_avahiz00(obj_t BgL_envz00_2211, obj_t BgL_oz00_2212)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2212)))->BgL_resolversz00);} 

}



/* &<@anonymous:1939> */
obj_t BGl_z62zc3z04anonymousza31939ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2213)
{
{ /* Llib/avahi.scm 67 */
return BNIL;} 

}



/* &lambda1938 */
obj_t BGl_z62lambda1938z62zz__avahi_avahiz00(obj_t BgL_envz00_2214, obj_t BgL_oz00_2215, obj_t BgL_vz00_2216)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2215)))->BgL_z52browsersz52)=((obj_t)
((obj_t)BgL_vz00_2216)),BUNSPEC);} 

}



/* &lambda1937 */
obj_t BGl_z62lambda1937z62zz__avahi_avahiz00(obj_t BgL_envz00_2217, obj_t BgL_oz00_2218)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2218)))->BgL_z52browsersz52);} 

}



/* &<@anonymous:1932> */
obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2219)
{
{ /* Llib/avahi.scm 67 */
return BNIL;} 

}



/* &lambda1931 */
obj_t BGl_z62lambda1931z62zz__avahi_avahiz00(obj_t BgL_envz00_2220, obj_t BgL_oz00_2221, obj_t BgL_vz00_2222)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2221)))->BgL_z52groupsz52)=((obj_t)
((obj_t)BgL_vz00_2222)),BUNSPEC);} 

}



/* &lambda1930 */
obj_t BGl_z62lambda1930z62zz__avahi_avahiz00(obj_t BgL_envz00_2223, obj_t BgL_oz00_2224)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2224)))->BgL_z52groupsz52);} 

}



/* &lambda1925 */
obj_t BGl_z62lambda1925z62zz__avahi_avahiz00(obj_t BgL_envz00_2225, obj_t BgL_oz00_2226, obj_t BgL_vz00_2227)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2226)))->BgL_procz00)=((obj_t)
((obj_t)BgL_vz00_2227)),BUNSPEC);} 

}



/* &lambda1924 */
obj_t BGl_z62lambda1924z62zz__avahi_avahiz00(obj_t BgL_envz00_2228, obj_t BgL_oz00_2229)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2229)))->BgL_procz00);} 

}



/* &<@anonymous:1920> */
obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2230)
{
{ /* Llib/avahi.scm 67 */
return 
CNST_TABLE_REF(((long)100));} 

}



/* &lambda1919 */
obj_t BGl_z62lambda1919z62zz__avahi_avahiz00(obj_t BgL_envz00_2231, obj_t BgL_oz00_2232, obj_t BgL_vz00_2233)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2232)))->BgL_flagsz00)=((obj_t)
((obj_t)BgL_vz00_2233)),BUNSPEC);} 

}



/* &lambda1918 */
obj_t BGl_z62lambda1918z62zz__avahi_avahiz00(obj_t BgL_envz00_2234, obj_t BgL_oz00_2235)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2235)))->BgL_flagsz00);} 

}



/* &lambda1913 */
obj_t BGl_z62lambda1913z62zz__avahi_avahiz00(obj_t BgL_envz00_2236, obj_t BgL_oz00_2237, obj_t BgL_vz00_2238)
{
{ /* Llib/avahi.scm 67 */
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2237)))->BgL_pollz00)=((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2pollzd2_bglt)BgL_vz00_2238)),BUNSPEC);} 

}



/* &lambda1912 */
BgL_avahizd2pollzd2_bglt BGl_z62lambda1912z62zz__avahi_avahiz00(obj_t BgL_envz00_2239, obj_t BgL_oz00_2240)
{
{ /* Llib/avahi.scm 67 */
return 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2240)))->BgL_pollz00);} 

}



/* &<@anonymous:1908> */
obj_t BGl_z62zc3z04anonymousza31908ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2241)
{
{ /* Llib/avahi.scm 67 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda1907 */
obj_t BGl_z62lambda1907z62zz__avahi_avahiz00(obj_t BgL_envz00_2242, obj_t BgL_oz00_2243, obj_t BgL_vz00_2244)
{
{ /* Llib/avahi.scm 67 */
{ /* Llib/avahi.scm 67 */
AvahiClient * BgL_vz00_2678;
BgL_vz00_2678 = 
FOREIGN_TO_COBJ(BgL_vz00_2244); 
return 
((((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2243)))->BgL_z42builtinz42)=((AvahiClient *)BgL_vz00_2678),BUNSPEC);} } 

}



/* &lambda1906 */
obj_t BGl_z62lambda1906z62zz__avahi_avahiz00(obj_t BgL_envz00_2245, obj_t BgL_oz00_2246)
{
{ /* Llib/avahi.scm 67 */
return 
void_star_to_obj(
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2246)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1882> */
obj_t BGl_z62zc3z04anonymousza31882ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2247, obj_t BgL_new1090z00_2248)
{
{ /* Llib/avahi.scm 64 */
{ 
BgL_avahizd2threadedzd2pollz00_bglt BgL_auxz00_4842;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1090z00_2248))))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1090z00_2248))))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1090z00_2248)))->BgL_z42builtinz42)=((AvahiThreadedPoll *)
0L),BUNSPEC); 
BgL_auxz00_4842 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_new1090z00_2248); 
return 
((obj_t)BgL_auxz00_4842);} } 

}



/* &lambda1880 */
BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1880z62zz__avahi_avahiz00(obj_t BgL_envz00_2249)
{
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1089z00_2681;
BgL_new1089z00_2681 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2threadedzd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 64 */
long BgL_arg1881z00_2682;
BgL_arg1881z00_2682 = 
BGL_CLASS_INDEX(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_2681), BgL_arg1881z00_2682); } 
return BgL_new1089z00_2681;} } 

}



/* &lambda1877 */
BgL_avahizd2threadedzd2pollz00_bglt BGl_z62lambda1877z62zz__avahi_avahiz00(obj_t BgL_envz00_2250, obj_t BgL_z42ctype1086z42_2251, obj_t BgL_z52procs1087z52_2252, obj_t BgL_z42builtin1088z42_2253)
{
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
int BgL_z42ctype1086z42_2683;AvahiThreadedPoll * BgL_z42builtin1088z42_2685;
BgL_z42ctype1086z42_2683 = 
CINT(BgL_z42ctype1086z42_2251); 
BgL_z42builtin1088z42_2685 = 
FOREIGN_TO_COBJ(BgL_z42builtin1088z42_2253); 
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1216z00_2686;
{ /* Llib/avahi.scm 64 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_new1215z00_2687;
BgL_new1215z00_2687 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2threadedzd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 64 */
long BgL_arg1879z00_2688;
BgL_arg1879z00_2688 = 
BGL_CLASS_INDEX(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_2687), BgL_arg1879z00_2688); } 
BgL_new1216z00_2686 = BgL_new1215z00_2687; } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1216z00_2686)))->BgL_z42ctypez42)=((int)BgL_z42ctype1086z42_2683),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1216z00_2686)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_z52procs1087z52_2252)),BUNSPEC); 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(BgL_new1216z00_2686))->BgL_z42builtinz42)=((AvahiThreadedPoll *)BgL_z42builtin1088z42_2685),BUNSPEC); 
{ /* Llib/avahi.scm 64 */
obj_t BgL_fun1878z00_2689;
BgL_fun1878z00_2689 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1878z00_2689)(BgL_fun1878z00_2689, 
((obj_t)BgL_new1216z00_2686), BEOA); } 
return BgL_new1216z00_2686;} } } 

}



/* &<@anonymous:1889> */
obj_t BGl_z62zc3z04anonymousza31889ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2254)
{
{ /* Llib/avahi.scm 64 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda1888 */
obj_t BGl_z62lambda1888z62zz__avahi_avahiz00(obj_t BgL_envz00_2255, obj_t BgL_oz00_2256, obj_t BgL_vz00_2257)
{
{ /* Llib/avahi.scm 64 */
{ /* Llib/avahi.scm 64 */
AvahiThreadedPoll * BgL_vz00_2691;
BgL_vz00_2691 = 
FOREIGN_TO_COBJ(BgL_vz00_2257); 
return 
((((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2256)))->BgL_z42builtinz42)=((AvahiThreadedPoll *)BgL_vz00_2691),BUNSPEC);} } 

}



/* &lambda1887 */
obj_t BGl_z62lambda1887z62zz__avahi_avahiz00(obj_t BgL_envz00_2258, obj_t BgL_oz00_2259)
{
{ /* Llib/avahi.scm 64 */
return 
void_star_to_obj(
(((BgL_avahizd2threadedzd2pollz00_bglt)COBJECT(
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2259)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1864> */
obj_t BGl_z62zc3z04anonymousza31864ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2260, obj_t BgL_new1084z00_2261)
{
{ /* Llib/avahi.scm 61 */
{ 
BgL_avahizd2simplezd2pollz00_bglt BgL_auxz00_4885;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1084z00_2261))))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1084z00_2261))))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1084z00_2261)))->BgL_z42builtinz42)=((AvahiSimplePoll *)
0L),BUNSPEC); 
BgL_auxz00_4885 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_new1084z00_2261); 
return 
((obj_t)BgL_auxz00_4885);} } 

}



/* &lambda1862 */
BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1862z62zz__avahi_avahiz00(obj_t BgL_envz00_2262)
{
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1083z00_2694;
BgL_new1083z00_2694 = 
((BgL_avahizd2simplezd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2simplezd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 61 */
long BgL_arg1863z00_2695;
BgL_arg1863z00_2695 = 
BGL_CLASS_INDEX(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1083z00_2694), BgL_arg1863z00_2695); } 
return BgL_new1083z00_2694;} } 

}



/* &lambda1859 */
BgL_avahizd2simplezd2pollz00_bglt BGl_z62lambda1859z62zz__avahi_avahiz00(obj_t BgL_envz00_2263, obj_t BgL_z42ctype1080z42_2264, obj_t BgL_z52procs1081z52_2265, obj_t BgL_z42builtin1082z42_2266)
{
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
int BgL_z42ctype1080z42_2696;AvahiSimplePoll * BgL_z42builtin1082z42_2698;
BgL_z42ctype1080z42_2696 = 
CINT(BgL_z42ctype1080z42_2264); 
BgL_z42builtin1082z42_2698 = 
FOREIGN_TO_COBJ(BgL_z42builtin1082z42_2266); 
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1214z00_2699;
{ /* Llib/avahi.scm 61 */
BgL_avahizd2simplezd2pollz00_bglt BgL_new1213z00_2700;
BgL_new1213z00_2700 = 
((BgL_avahizd2simplezd2pollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2simplezd2pollz00_bgl) ))); 
{ /* Llib/avahi.scm 61 */
long BgL_arg1861z00_2701;
BgL_arg1861z00_2701 = 
BGL_CLASS_INDEX(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_2700), BgL_arg1861z00_2701); } 
BgL_new1214z00_2699 = BgL_new1213z00_2700; } 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1214z00_2699)))->BgL_z42ctypez42)=((int)BgL_z42ctype1080z42_2696),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1214z00_2699)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_z52procs1081z52_2265)),BUNSPEC); 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(BgL_new1214z00_2699))->BgL_z42builtinz42)=((AvahiSimplePoll *)BgL_z42builtin1082z42_2698),BUNSPEC); 
{ /* Llib/avahi.scm 61 */
obj_t BgL_fun1860z00_2702;
BgL_fun1860z00_2702 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00); 
PROCEDURE_ENTRY(BgL_fun1860z00_2702)(BgL_fun1860z00_2702, 
((obj_t)BgL_new1214z00_2699), BEOA); } 
return BgL_new1214z00_2699;} } } 

}



/* &<@anonymous:1871> */
obj_t BGl_z62zc3z04anonymousza31871ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2267)
{
{ /* Llib/avahi.scm 61 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda1870 */
obj_t BGl_z62lambda1870z62zz__avahi_avahiz00(obj_t BgL_envz00_2268, obj_t BgL_oz00_2269, obj_t BgL_vz00_2270)
{
{ /* Llib/avahi.scm 61 */
{ /* Llib/avahi.scm 61 */
AvahiSimplePoll * BgL_vz00_2704;
BgL_vz00_2704 = 
FOREIGN_TO_COBJ(BgL_vz00_2270); 
return 
((((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2269)))->BgL_z42builtinz42)=((AvahiSimplePoll *)BgL_vz00_2704),BUNSPEC);} } 

}



/* &lambda1869 */
obj_t BGl_z62lambda1869z62zz__avahi_avahiz00(obj_t BgL_envz00_2271, obj_t BgL_oz00_2272)
{
{ /* Llib/avahi.scm 61 */
return 
void_star_to_obj(
(((BgL_avahizd2simplezd2pollz00_bglt)COBJECT(
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2272)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1838> */
obj_t BGl_z62zc3z04anonymousza31838ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2273, obj_t BgL_new1078z00_2274)
{
{ /* Llib/avahi.scm 57 */
{ 
BgL_avahizd2pollzd2_bglt BgL_auxz00_4928;
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1078z00_2274)))->BgL_z42ctypez42)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_new1078z00_2274)))->BgL_z52procsz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4928 = 
((BgL_avahizd2pollzd2_bglt)BgL_new1078z00_2274); 
return 
((obj_t)BgL_auxz00_4928);} } 

}



/* &lambda1836 */
BgL_avahizd2pollzd2_bglt BGl_z62lambda1836z62zz__avahi_avahiz00(obj_t BgL_envz00_2275)
{
{ /* Llib/avahi.scm 57 */
{ /* Llib/avahi.scm 57 */
BgL_avahizd2pollzd2_bglt BgL_new1077z00_2707;
BgL_new1077z00_2707 = 
((BgL_avahizd2pollzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2pollzd2_bgl) ))); 
{ /* Llib/avahi.scm 57 */
long BgL_arg1837z00_2708;
BgL_arg1837z00_2708 = 
BGL_CLASS_INDEX(BGl_avahizd2pollzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_2707), BgL_arg1837z00_2708); } 
return BgL_new1077z00_2707;} } 

}



/* &<@anonymous:1852> */
obj_t BGl_z62zc3z04anonymousza31852ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2276)
{
{ /* Llib/avahi.scm 57 */
return BNIL;} 

}



/* &lambda1851 */
obj_t BGl_z62lambda1851z62zz__avahi_avahiz00(obj_t BgL_envz00_2277, obj_t BgL_oz00_2278, obj_t BgL_vz00_2279)
{
{ /* Llib/avahi.scm 57 */
return 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2278)))->BgL_z52procsz52)=((obj_t)
((obj_t)BgL_vz00_2279)),BUNSPEC);} 

}



/* &lambda1850 */
obj_t BGl_z62lambda1850z62zz__avahi_avahiz00(obj_t BgL_envz00_2280, obj_t BgL_oz00_2281)
{
{ /* Llib/avahi.scm 57 */
return 
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2281)))->BgL_z52procsz52);} 

}



/* &<@anonymous:1845> */
obj_t BGl_z62zc3z04anonymousza31845ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2282)
{
{ /* Llib/avahi.scm 57 */
return 
BINT(((long)-1));} 

}



/* &lambda1844 */
obj_t BGl_z62lambda1844z62zz__avahi_avahiz00(obj_t BgL_envz00_2283, obj_t BgL_oz00_2284, obj_t BgL_vz00_2285)
{
{ /* Llib/avahi.scm 57 */
{ /* Llib/avahi.scm 57 */
int BgL_vz00_2713;
BgL_vz00_2713 = 
CINT(BgL_vz00_2285); 
return 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2284)))->BgL_z42ctypez42)=((int)BgL_vz00_2713),BUNSPEC);} } 

}



/* &lambda1843 */
obj_t BGl_z62lambda1843z62zz__avahi_avahiz00(obj_t BgL_envz00_2286, obj_t BgL_oz00_2287)
{
{ /* Llib/avahi.scm 57 */
return 
BINT(
(((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)BgL_oz00_2287)))->BgL_z42ctypez42));} 

}



/* &<@anonymous:1831> */
obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2288, obj_t BgL_new1075z00_2289)
{
{ /* Llib/avahi.scm 54 */
return 
((obj_t)
((BgL_avahizd2objectzd2_bglt)BgL_new1075z00_2289));} 

}



/* &lambda1829 */
BgL_avahizd2objectzd2_bglt BGl_z62lambda1829z62zz__avahi_avahiz00(obj_t BgL_envz00_2290)
{
{ /* Llib/avahi.scm 54 */
{ /* Llib/avahi.scm 54 */
BgL_avahizd2objectzd2_bglt BgL_new1074z00_2716;
BgL_new1074z00_2716 = 
((BgL_avahizd2objectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_avahizd2objectzd2_bgl) ))); 
{ /* Llib/avahi.scm 54 */
long BgL_arg1830z00_2717;
BgL_arg1830z00_2717 = 
BGL_CLASS_INDEX(BGl_avahizd2objectzd2zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1074z00_2716), BgL_arg1830z00_2717); } 
return BgL_new1074z00_2716;} } 

}



/* &<@anonymous:1824> */
obj_t BGl_z62zc3z04anonymousza31824ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2291, obj_t BgL_new1072z00_2292)
{
{ /* Llib/avahi.scm 52 */
{ 
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_auxz00_4958;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292))))->BgL_errnoz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_4958 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BgL_new1072z00_2292); 
return 
((obj_t)BgL_auxz00_4958);} } 

}



/* &lambda1822 */
BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1822z62zz__avahi_avahiz00(obj_t BgL_envz00_2293)
{
{ /* Llib/avahi.scm 52 */
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1071z00_2719;
BgL_new1071z00_2719 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 52 */
long BgL_arg1823z00_2720;
BgL_arg1823z00_2720 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1071z00_2719), BgL_arg1823z00_2720); } 
return BgL_new1071z00_2719;} } 

}



/* &lambda1820 */
BgL_z62avahizd2collisionzd2errorz62_bglt BGl_z62lambda1820z62zz__avahi_avahiz00(obj_t BgL_envz00_2294, obj_t BgL_fname1064z00_2295, obj_t BgL_location1065z00_2296, obj_t BgL_stack1066z00_2297, obj_t BgL_proc1067z00_2298, obj_t BgL_msg1068z00_2299, obj_t BgL_obj1069z00_2300, obj_t BgL_errno1070z00_2301)
{
{ /* Llib/avahi.scm 52 */
{ /* Llib/avahi.scm 52 */
int BgL_errno1070z00_2721;
BgL_errno1070z00_2721 = 
CINT(BgL_errno1070z00_2301); 
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1212z00_2722;
{ /* Llib/avahi.scm 52 */
BgL_z62avahizd2collisionzd2errorz62_bglt BgL_new1211z00_2723;
BgL_new1211z00_2723 = 
((BgL_z62avahizd2collisionzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2collisionzd2errorz62_bgl) ))); 
{ /* Llib/avahi.scm 52 */
long BgL_arg1821z00_2724;
BgL_arg1821z00_2724 = 
BGL_CLASS_INDEX(BGl_z62avahizd2collisionzd2errorz62zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_2723), BgL_arg1821z00_2724); } 
BgL_new1212z00_2722 = BgL_new1211z00_2723; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1212z00_2722)))->BgL_fnamez00)=((obj_t)BgL_fname1064z00_2295),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1212z00_2722)))->BgL_locationz00)=((obj_t)BgL_location1065z00_2296),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1212z00_2722)))->BgL_stackz00)=((obj_t)BgL_stack1066z00_2297),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1212z00_2722)))->BgL_procz00)=((obj_t)BgL_proc1067z00_2298),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1212z00_2722)))->BgL_msgz00)=((obj_t)BgL_msg1068z00_2299),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1212z00_2722)))->BgL_objz00)=((obj_t)BgL_obj1069z00_2300),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1212z00_2722)))->BgL_errnoz00)=((int)BgL_errno1070z00_2721),BUNSPEC); 
return BgL_new1212z00_2722;} } } 

}



/* &<@anonymous:1806> */
obj_t BGl_z62zc3z04anonymousza31806ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2302, obj_t BgL_new1062z00_2303)
{
{ /* Llib/avahi.scm 50 */
{ 
BgL_z62avahizd2errorzb0_bglt BgL_auxz00_5006;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303)))->BgL_errnoz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_5006 = 
((BgL_z62avahizd2errorzb0_bglt)BgL_new1062z00_2303); 
return 
((obj_t)BgL_auxz00_5006);} } 

}



/* &lambda1804 */
BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1804z62zz__avahi_avahiz00(obj_t BgL_envz00_2304)
{
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1061z00_2726;
BgL_new1061z00_2726 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 50 */
long BgL_arg1805z00_2727;
BgL_arg1805z00_2727 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1061z00_2726), BgL_arg1805z00_2727); } 
return BgL_new1061z00_2726;} } 

}



/* &lambda1802 */
BgL_z62avahizd2errorzb0_bglt BGl_z62lambda1802z62zz__avahi_avahiz00(obj_t BgL_envz00_2305, obj_t BgL_fname1053z00_2306, obj_t BgL_location1054z00_2307, obj_t BgL_stack1055z00_2308, obj_t BgL_proc1056z00_2309, obj_t BgL_msg1057z00_2310, obj_t BgL_obj1058z00_2311, obj_t BgL_errno1059z00_2312)
{
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
int BgL_errno1059z00_2728;
BgL_errno1059z00_2728 = 
CINT(BgL_errno1059z00_2312); 
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1210z00_2729;
{ /* Llib/avahi.scm 50 */
BgL_z62avahizd2errorzb0_bglt BgL_new1209z00_2730;
BgL_new1209z00_2730 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 50 */
long BgL_arg1803z00_2731;
BgL_arg1803z00_2731 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1209z00_2730), BgL_arg1803z00_2731); } 
BgL_new1210z00_2729 = BgL_new1209z00_2730; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1210z00_2729)))->BgL_fnamez00)=((obj_t)BgL_fname1053z00_2306),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1210z00_2729)))->BgL_locationz00)=((obj_t)BgL_location1054z00_2307),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1210z00_2729)))->BgL_stackz00)=((obj_t)BgL_stack1055z00_2308),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1210z00_2729)))->BgL_procz00)=((obj_t)BgL_proc1056z00_2309),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1210z00_2729)))->BgL_msgz00)=((obj_t)BgL_msg1057z00_2310),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1210z00_2729)))->BgL_objz00)=((obj_t)BgL_obj1058z00_2311),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1210z00_2729))->BgL_errnoz00)=((int)BgL_errno1059z00_2728),BUNSPEC); 
return BgL_new1210z00_2729;} } } 

}



/* &<@anonymous:1814> */
obj_t BGl_z62zc3z04anonymousza31814ze3ze5zz__avahi_avahiz00(obj_t BgL_envz00_2313)
{
{ /* Llib/avahi.scm 50 */
return 
BINT(((long)0));} 

}



/* &lambda1813 */
obj_t BGl_z62lambda1813z62zz__avahi_avahiz00(obj_t BgL_envz00_2314, obj_t BgL_oz00_2315, obj_t BgL_vz00_2316)
{
{ /* Llib/avahi.scm 50 */
{ /* Llib/avahi.scm 50 */
int BgL_vz00_2733;
BgL_vz00_2733 = 
CINT(BgL_vz00_2316); 
return 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_oz00_2315)))->BgL_errnoz00)=((int)BgL_vz00_2733),BUNSPEC);} } 

}



/* &lambda1812 */
obj_t BGl_z62lambda1812z62zz__avahi_avahiz00(obj_t BgL_envz00_2317, obj_t BgL_oz00_2318)
{
{ /* Llib/avahi.scm 50 */
return 
BINT(
(((BgL_z62avahizd2errorzb0_bglt)COBJECT(
((BgL_z62avahizd2errorzb0_bglt)BgL_oz00_2318)))->BgL_errnoz00));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_proc2555z00zz__avahi_avahiz00, BGl_avahizd2objectzd2zz__avahi_avahiz00, BGl_string2556z00zz__avahi_avahiz00);} 

}



/* &avahi-init1255 */
obj_t BGl_z62avahizd2init1255zb0zz__avahi_avahiz00(obj_t BgL_envz00_2322, obj_t BgL_oz00_2323)
{
{ /* Llib/avahi.scm 288 */
return 
((obj_t)
((BgL_avahizd2objectzd2_bglt)BgL_oz00_2323));} 

}



/* avahi-init */
BGL_EXPORTED_DEF obj_t BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_avahizd2objectzd2_bglt BgL_oz00_9)
{
{ /* Llib/avahi.scm 288 */
{ /* Llib/avahi.scm 288 */
obj_t BgL_method1256z00_1158;
{ /* Llib/avahi.scm 288 */
obj_t BgL_res2260z00_1658;
{ /* Llib/avahi.scm 288 */
long BgL_objzd2classzd2numz00_1629;
BgL_objzd2classzd2numz00_1629 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_9)); 
{ /* Llib/avahi.scm 288 */
obj_t BgL_arg1765z00_1630;
BgL_arg1765z00_1630 = 
PROCEDURE_REF(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, 
(int)(((long)1))); 
{ /* Llib/avahi.scm 288 */
int BgL_offsetz00_1633;
BgL_offsetz00_1633 = 
(int)(BgL_objzd2classzd2numz00_1629); 
{ /* Llib/avahi.scm 288 */
long BgL_offsetz00_1634;
BgL_offsetz00_1634 = 
(
(long)(BgL_offsetz00_1633)-OBJECT_TYPE); 
{ /* Llib/avahi.scm 288 */
long BgL_modz00_1635;
BgL_modz00_1635 = 
(BgL_offsetz00_1634 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/avahi.scm 288 */
long BgL_restz00_1637;
BgL_restz00_1637 = 
(BgL_offsetz00_1634 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/avahi.scm 288 */

{ /* Llib/avahi.scm 288 */
obj_t BgL_bucketz00_1639;
BgL_bucketz00_1639 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1630),BgL_modz00_1635); 
BgL_res2260z00_1658 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1639),BgL_restz00_1637); } } } } } } } } 
BgL_method1256z00_1158 = BgL_res2260z00_1658; } 
return 
PROCEDURE_ENTRY(BgL_method1256z00_1158)(BgL_method1256z00_1158, 
((obj_t)BgL_oz00_9), BEOA);} } 

}



/* &avahi-init */
obj_t BGl_z62avahizd2initzb0zz__avahi_avahiz00(obj_t BgL_envz00_2319, obj_t BgL_oz00_2320)
{
{ /* Llib/avahi.scm 288 */
{ /* Llib/avahi.scm 288 */
BgL_avahizd2objectzd2_bglt BgL_auxz00_5092;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_2320, BGl_avahizd2objectzd2zz__avahi_avahiz00))
{ /* Llib/avahi.scm 288 */
BgL_auxz00_5092 = 
((BgL_avahizd2objectzd2_bglt)BgL_oz00_2320)
; }  else 
{ 
obj_t BgL_auxz00_5096;
BgL_auxz00_5096 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2343z00zz__avahi_avahiz00, 
BINT(((long)11745)), BGl_string2557z00zz__avahi_avahiz00, BGl_string2558z00zz__avahi_avahiz00, BgL_oz00_2320); 
FAILURE(BgL_auxz00_5096,BFALSE,BFALSE);} 
return 
BGl_avahizd2initzd2zz__avahi_avahiz00(BgL_auxz00_5092);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__avahi_avahiz00()
{
{ /* Llib/avahi.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2simplezd2pollz00zz__avahi_avahiz00, BGl_proc2559z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2threadedzd2pollz00zz__avahi_avahiz00, BGl_proc2561z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2clientzd2zz__avahi_avahiz00, BGl_proc2562z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2entryzd2groupz00zz__avahi_avahiz00, BGl_proc2563z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2browserz00zz__avahi_avahiz00, BGl_proc2564z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2typezd2browserzd2zz__avahi_avahiz00, BGl_proc2565z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2domainzd2browserz00zz__avahi_avahiz00, BGl_proc2566z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_avahizd2initzd2envz00zz__avahi_avahiz00, BGl_avahizd2servicezd2resolverz00zz__avahi_avahiz00, BGl_proc2567z00zz__avahi_avahiz00, BGl_string2560z00zz__avahi_avahiz00);} 

}



/* &avahi-init-avahi-ser1273 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1273zb0zz__avahi_avahiz00(obj_t BgL_envz00_2332, obj_t BgL_oz00_2333)
{
{ /* Llib/avahi.scm 661 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2333)))->BgL_procz00), 
(int)(((long)12))))
{ /* Llib/avahi.scm 663 */
{ /* Llib/avahi.scm 665 */
BgL_avahizd2clientzd2_bglt BgL_i1190z00_2737;
BgL_i1190z00_2737 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2333)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5116;
{ /* Llib/avahi.scm 666 */
obj_t BgL_arg2253z00_2738;
BgL_arg2253z00_2738 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1190z00_2737))->BgL_resolversz00); 
BgL_auxz00_5116 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2333)), BgL_arg2253z00_2738); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1190z00_2737))->BgL_resolversz00)=((obj_t)BgL_auxz00_5116),BUNSPEC); } } 
{ /* Llib/avahi.scm 667 */
BgL_avahizd2servicezd2resolverz00_bglt BgL_tmpz00_5122;
BgL_tmpz00_5122 = 
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2333); 
bgl_avahi_service_resolver_new(BgL_tmpz00_5122); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 668 */
obj_t BgL_arg2254z00_2739;
BgL_arg2254z00_2739 = 
(((BgL_avahizd2servicezd2resolverz00_bglt)COBJECT(
((BgL_avahizd2servicezd2resolverz00_bglt)BgL_oz00_2333)))->BgL_procz00); 
{ /* Llib/avahi.scm 668 */
char * BgL_procz00_2740;char * BgL_msgz00_2741;
BgL_procz00_2740 = 
BSTRING_TO_STRING(BGl_string2386z00zz__avahi_avahiz00); 
BgL_msgz00_2741 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2742;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2743;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2744;
BgL_new1141z00_2744 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2745;
BgL_arg1319z00_2745 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2744), BgL_arg1319z00_2745); } 
BgL_new1142z00_2743 = BgL_new1141z00_2744; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2743)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2743)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5137;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2746;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2747;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2748;
BgL_classz00_2748 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2747 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2748); } 
BgL_arg1281z00_2746 = 
VECTOR_REF(BgL_arg1318z00_2747,((long)2)); } 
BgL_auxz00_5137 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2746); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2743)))->BgL_stackz00)=((obj_t)BgL_auxz00_5137),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2743)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2740)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2743)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2741)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2743)))->BgL_objz00)=((obj_t)BgL_arg2254z00_2739),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2743))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2742 = BgL_new1142z00_2743; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2742));} } } } 

}



/* &avahi-init-avahi-dom1271 */
obj_t BGl_z62avahizd2initzd2avahizd2dom1271zb0zz__avahi_avahiz00(obj_t BgL_envz00_2334, obj_t BgL_oz00_2335)
{
{ /* Llib/avahi.scm 641 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2335)))->BgL_procz00), 
(int)(((long)5))))
{ /* Llib/avahi.scm 643 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2966z00_5159;
BgL_tmp2966z00_5159 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2335)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2966z00_5159; } 
{ /* Llib/avahi.scm 646 */
obj_t BgL_arg2247z00_2750;
BgL_arg2247z00_2750 = 
BGl_avahizd2symbolzd2ze3domainzd2browserzd2typeze3zz__avahi_avahiz00(
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2335)))->BgL_btypez00)); 
{ /* Llib/avahi.scm 646 */
AvahiDomainBrowserType BgL_auxz00_5170;BgL_avahizd2domainzd2browserz00_bglt BgL_tmpz00_5168;
BgL_auxz00_5170 = 
(long)CINT(BgL_arg2247z00_2750); 
BgL_tmpz00_5168 = 
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2335); 
bgl_avahi_domain_browser_new(BgL_tmpz00_5168, BgL_auxz00_5170); } 
return BUNSPEC;} }  else 
{ /* Llib/avahi.scm 647 */
obj_t BgL_arg2249z00_2751;
BgL_arg2249z00_2751 = 
(((BgL_avahizd2domainzd2browserz00_bglt)COBJECT(
((BgL_avahizd2domainzd2browserz00_bglt)BgL_oz00_2335)))->BgL_procz00); 
{ /* Llib/avahi.scm 647 */
char * BgL_procz00_2752;char * BgL_msgz00_2753;
BgL_procz00_2752 = 
BSTRING_TO_STRING(BGl_string2384z00zz__avahi_avahiz00); 
BgL_msgz00_2753 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2754;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2755;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2756;
BgL_new1141z00_2756 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2757;
BgL_arg1319z00_2757 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2756), BgL_arg1319z00_2757); } 
BgL_new1142z00_2755 = BgL_new1141z00_2756; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2755)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2755)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5185;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2758;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2759;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2760;
BgL_classz00_2760 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2759 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2760); } 
BgL_arg1281z00_2758 = 
VECTOR_REF(BgL_arg1318z00_2759,((long)2)); } 
BgL_auxz00_5185 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2758); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2755)))->BgL_stackz00)=((obj_t)BgL_auxz00_5185),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2755)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2752)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2755)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2753)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2755)))->BgL_objz00)=((obj_t)BgL_arg2249z00_2751),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2755))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2754 = BgL_new1142z00_2755; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2754));} } } } 

}



/* &avahi-init-avahi-ser1269 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1269zb0zz__avahi_avahiz00(obj_t BgL_envz00_2336, obj_t BgL_oz00_2337)
{
{ /* Llib/avahi.scm 621 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2337)))->BgL_procz00), 
(int)(((long)7))))
{ /* Llib/avahi.scm 623 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2968z00_5207;
BgL_tmp2968z00_5207 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2337)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2968z00_5207; } 
{ /* Llib/avahi.scm 626 */
BgL_avahizd2servicezd2typezd2browserzd2_bglt BgL_tmpz00_5213;
BgL_tmpz00_5213 = 
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2337); 
bgl_avahi_service_type_browser_new(BgL_tmpz00_5213); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 627 */
obj_t BgL_arg2243z00_2762;
BgL_arg2243z00_2762 = 
(((BgL_avahizd2servicezd2typezd2browserzd2_bglt)COBJECT(
((BgL_avahizd2servicezd2typezd2browserzd2_bglt)BgL_oz00_2337)))->BgL_procz00); 
{ /* Llib/avahi.scm 627 */
char * BgL_procz00_2763;char * BgL_msgz00_2764;
BgL_procz00_2763 = 
BSTRING_TO_STRING(BGl_string2568z00zz__avahi_avahiz00); 
BgL_msgz00_2764 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2765;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2766;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2767;
BgL_new1141z00_2767 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2768;
BgL_arg1319z00_2768 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2767), BgL_arg1319z00_2768); } 
BgL_new1142z00_2766 = BgL_new1141z00_2767; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2766)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2766)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5228;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2769;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2770;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2771;
BgL_classz00_2771 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2770 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2771); } 
BgL_arg1281z00_2769 = 
VECTOR_REF(BgL_arg1318z00_2770,((long)2)); } 
BgL_auxz00_5228 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2769); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2766)))->BgL_stackz00)=((obj_t)BgL_auxz00_5228),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2766)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2763)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2766)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2764)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2766)))->BgL_objz00)=((obj_t)BgL_arg2243z00_2762),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2766))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2765 = BgL_new1142z00_2766; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2765));} } } } 

}



/* &avahi-init-avahi-ser1267 */
obj_t BGl_z62avahizd2initzd2avahizd2ser1267zb0zz__avahi_avahiz00(obj_t BgL_envz00_2338, obj_t BgL_oz00_2339)
{
{ /* Llib/avahi.scm 598 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2339)))->BgL_procz00), 
(int)(((long)8))))
{ /* Llib/avahi.scm 600 */
{ /* Llib/avahi.scm 602 */
BgL_avahizd2clientzd2_bglt BgL_i1184z00_2773;
BgL_i1184z00_2773 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2339)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5252;
{ /* Llib/avahi.scm 603 */
obj_t BgL_arg2238z00_2774;
BgL_arg2238z00_2774 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1184z00_2773))->BgL_z52browsersz52); 
BgL_auxz00_5252 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2339)), BgL_arg2238z00_2774); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1184z00_2773))->BgL_z52browsersz52)=((obj_t)BgL_auxz00_5252),BUNSPEC); } } 
{ /* Llib/avahi.scm 604 */
BgL_avahizd2servicezd2browserz00_bglt BgL_tmpz00_5258;
BgL_tmpz00_5258 = 
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2339); 
bgl_avahi_service_browser_new(BgL_tmpz00_5258); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 605 */
obj_t BgL_arg2239z00_2775;
BgL_arg2239z00_2775 = 
(((BgL_avahizd2servicezd2browserz00_bglt)COBJECT(
((BgL_avahizd2servicezd2browserz00_bglt)BgL_oz00_2339)))->BgL_procz00); 
{ /* Llib/avahi.scm 605 */
char * BgL_procz00_2776;char * BgL_msgz00_2777;
BgL_procz00_2776 = 
BSTRING_TO_STRING(BGl_string2382z00zz__avahi_avahiz00); 
BgL_msgz00_2777 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2778;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2779;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2780;
BgL_new1141z00_2780 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2781;
BgL_arg1319z00_2781 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2780), BgL_arg1319z00_2781); } 
BgL_new1142z00_2779 = BgL_new1141z00_2780; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2779)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2779)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5273;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2782;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2783;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2784;
BgL_classz00_2784 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2783 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2784); } 
BgL_arg1281z00_2782 = 
VECTOR_REF(BgL_arg1318z00_2783,((long)2)); } 
BgL_auxz00_5273 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2782); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2779)))->BgL_stackz00)=((obj_t)BgL_auxz00_5273),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2779)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2776)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2779)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2777)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2779)))->BgL_objz00)=((obj_t)BgL_arg2239z00_2775),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2779))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2778 = BgL_new1142z00_2779; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2778));} } } } 

}



/* &avahi-init-avahi-ent1264 */
obj_t BGl_z62avahizd2initzd2avahizd2ent1264zb0zz__avahi_avahiz00(obj_t BgL_envz00_2340, obj_t BgL_oz00_2341)
{
{ /* Llib/avahi.scm 450 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2341)))->BgL_procz00), 
(int)(((long)2))))
{ /* Llib/avahi.scm 452 */
{ /* Llib/avahi.scm 454 */
BgL_avahizd2clientzd2_bglt BgL_i1159z00_2786;
BgL_i1159z00_2786 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2341)))->BgL_clientz00); 
{ 
obj_t BgL_auxz00_5297;
{ /* Llib/avahi.scm 455 */
obj_t BgL_arg2233z00_2787;
BgL_arg2233z00_2787 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1159z00_2786))->BgL_z52groupsz52); 
BgL_auxz00_5297 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2341)), BgL_arg2233z00_2787); } 
((((BgL_avahizd2clientzd2_bglt)COBJECT(BgL_i1159z00_2786))->BgL_z52groupsz52)=((obj_t)BgL_auxz00_5297),BUNSPEC); } } 
{ /* Llib/avahi.scm 456 */
BgL_avahizd2entryzd2groupz00_bglt BgL_tmpz00_5303;
BgL_tmpz00_5303 = 
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2341); 
bgl_avahi_entry_group_new(BgL_tmpz00_5303); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 457 */
obj_t BgL_arg2234z00_2788;
BgL_arg2234z00_2788 = 
(((BgL_avahizd2entryzd2groupz00_bglt)COBJECT(
((BgL_avahizd2entryzd2groupz00_bglt)BgL_oz00_2341)))->BgL_procz00); 
{ /* Llib/avahi.scm 457 */
char * BgL_procz00_2789;char * BgL_msgz00_2790;
BgL_procz00_2789 = 
BSTRING_TO_STRING(BGl_string2371z00zz__avahi_avahiz00); 
BgL_msgz00_2790 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2791;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2792;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2793;
BgL_new1141z00_2793 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2794;
BgL_arg1319z00_2794 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2793), BgL_arg1319z00_2794); } 
BgL_new1142z00_2792 = BgL_new1141z00_2793; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2792)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2792)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5318;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2795;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2796;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2797;
BgL_classz00_2797 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2796 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2797); } 
BgL_arg1281z00_2795 = 
VECTOR_REF(BgL_arg1318z00_2796,((long)2)); } 
BgL_auxz00_5318 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2795); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2792)))->BgL_stackz00)=((obj_t)BgL_auxz00_5318),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2792)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2789)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2792)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2790)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2792)))->BgL_objz00)=((obj_t)BgL_arg2234z00_2788),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2792))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2791 = BgL_new1142z00_2792; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2791));} } } } 

}



/* &avahi-init-avahi-cli1262 */
obj_t BGl_z62avahizd2initzd2avahizd2cli1262zb0zz__avahi_avahiz00(obj_t BgL_envz00_2342, obj_t BgL_oz00_2343)
{
{ /* Llib/avahi.scm 401 */
if(
PROCEDURE_CORRECT_ARITYP(
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2343)))->BgL_procz00), 
(int)(((long)2))))
{ /* Llib/avahi.scm 403 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2972z00_5340;
BgL_tmp2972z00_5340 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2343)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2972z00_5340; } 
{ /* Llib/avahi.scm 406 */
BgL_avahizd2clientzd2_bglt BgL_tmpz00_5346;
BgL_tmpz00_5346 = 
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2343); 
bgl_avahi_client_new(BgL_tmpz00_5346); } 
return BUNSPEC;}  else 
{ /* Llib/avahi.scm 407 */
obj_t BgL_arg2229z00_2799;
BgL_arg2229z00_2799 = 
(((BgL_avahizd2clientzd2_bglt)COBJECT(
((BgL_avahizd2clientzd2_bglt)BgL_oz00_2343)))->BgL_procz00); 
{ /* Llib/avahi.scm 407 */
char * BgL_procz00_2800;char * BgL_msgz00_2801;
BgL_procz00_2800 = 
BSTRING_TO_STRING(BGl_string2569z00zz__avahi_avahiz00); 
BgL_msgz00_2801 = 
BSTRING_TO_STRING(BGl_string2352z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_arg1280z00_2802;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1142z00_2803;
{ /* Llib/avahi.scm 214 */
BgL_z62avahizd2errorzb0_bglt BgL_new1141z00_2804;
BgL_new1141z00_2804 = 
((BgL_z62avahizd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62avahizd2errorzb0_bgl) ))); 
{ /* Llib/avahi.scm 214 */
long BgL_arg1319z00_2805;
BgL_arg1319z00_2805 = 
BGL_CLASS_INDEX(BGl_z62avahizd2errorzb0zz__avahi_avahiz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2804), BgL_arg1319z00_2805); } 
BgL_new1142z00_2803 = BgL_new1141z00_2804; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2803)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2803)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5361;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1281z00_2806;
{ /* Llib/avahi.scm 214 */
obj_t BgL_arg1318z00_2807;
{ /* Llib/avahi.scm 214 */
obj_t BgL_classz00_2808;
BgL_classz00_2808 = BGl_z62avahizd2errorzb0zz__avahi_avahiz00; 
BgL_arg1318z00_2807 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2808); } 
BgL_arg1281z00_2806 = 
VECTOR_REF(BgL_arg1318z00_2807,((long)2)); } 
BgL_auxz00_5361 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_2806); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1142z00_2803)))->BgL_stackz00)=((obj_t)BgL_auxz00_5361),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2803)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_2800)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2803)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_2801)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1142z00_2803)))->BgL_objz00)=((obj_t)BgL_arg2229z00_2799),BUNSPEC); 
((((BgL_z62avahizd2errorzb0_bglt)COBJECT(BgL_new1142z00_2803))->BgL_errnoz00)=((int)AVAHI_ERR_INVALID_OBJECT),BUNSPEC); 
BgL_arg1280z00_2802 = BgL_new1142z00_2803; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1280z00_2802));} } } } 

}



/* &avahi-init-avahi-thr1260 */
obj_t BGl_z62avahizd2initzd2avahizd2thr1260zb0zz__avahi_avahiz00(obj_t BgL_envz00_2344, obj_t BgL_oz00_2345)
{
{ /* Llib/avahi.scm 339 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2973z00_5378;
BgL_tmp2973z00_5378 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2345)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2973z00_5378; } 
{ /* Llib/avahi.scm 341 */
BgL_avahizd2threadedzd2pollz00_bglt BgL_tmpz00_5384;
BgL_tmpz00_5384 = 
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2345); 
bgl_avahi_threaded_poll_new(BgL_tmpz00_5384); } BUNSPEC; 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2345))))->BgL_z42ctypez42)=((int)
(int)(((long)2))),BUNSPEC); 
BGl_z52avahizd2threadzd2initz12z40zz__avahi_avahiz00(); 
return 
((obj_t)
((BgL_avahizd2threadedzd2pollz00_bglt)BgL_oz00_2345));} 

}



/* &avahi-init-avahi-sim1258 */
obj_t BGl_z62avahizd2initzd2avahizd2sim1258zb0zz__avahi_avahiz00(obj_t BgL_envz00_2346, obj_t BgL_oz00_2347)
{
{ /* Llib/avahi.scm 294 */
BGL_MUTEX_LOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); 
{ /* Llib/avahi.scm 251 */
obj_t BgL_tmp2974z00_5394;
BgL_tmp2974z00_5394 = ( 
BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2347)), BGl_za2avahizd2gczd2rootsza2z00zz__avahi_avahiz00), BUNSPEC) ; 
BGL_MUTEX_UNLOCK(BGl_za2avahizd2gczd2mutexza2z00zz__avahi_avahiz00); BgL_tmp2974z00_5394; } 
{ /* Llib/avahi.scm 296 */
BgL_avahizd2simplezd2pollz00_bglt BgL_tmpz00_5400;
BgL_tmpz00_5400 = 
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2347); 
bgl_avahi_simple_poll_new(BgL_tmpz00_5400); } BUNSPEC; 
((((BgL_avahizd2pollzd2_bglt)COBJECT(
((BgL_avahizd2pollzd2_bglt)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2347))))->BgL_z42ctypez42)=((int)
(int)(((long)1))),BUNSPEC); 
return 
((obj_t)
((BgL_avahizd2simplezd2pollz00_bglt)BgL_oz00_2347));} 

}

#ifdef __cplusplus
}
#endif
