/*===========================================================================*/
/*   (Llib/block_ciphers.scm)                                                */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IPosix Llib/block_ciphers.scm -o objs/block_ciphers.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_blockzd2cipherzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   long BgL_blockzd2siza7ez75;
   long BgL_preferredzd2keyzd2lengthz00;
   obj_t BgL_encryptz12z12;
   obj_t BgL_decryptz12z12;
   obj_t BgL_keyzd2ze3encryptzd2paramze3;
   obj_t BgL_keyzd2ze3decryptzd2paramze3;
} *BgL_blockzd2cipherzd2_bglt;

typedef struct BgL_cipherzd2statezd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_cipherzd2statezd2_bglt;

typedef struct BgL_ecbzd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_ecbzd2encryptzd2_bglt;

typedef struct BgL_ecbzd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_ecbzd2decryptzd2_bglt;

typedef struct BgL_cbczd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cbczd2encryptzd2_bglt;

typedef struct BgL_cbczd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cbczd2decryptzd2_bglt;

typedef struct BgL_pcbczd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_pcbczd2encryptzd2_bglt;

typedef struct BgL_pcbczd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_pcbczd2decryptzd2_bglt;

typedef struct BgL_streamzd2cipherzd2statez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
} *BgL_streamzd2cipherzd2statez00_bglt;

typedef struct BgL_cfbzd2encryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_chainz00;
} *BgL_cfbzd2encryptzd2_bglt;

typedef struct BgL_cfbzd2decryptzd2_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_bufferz00;
   obj_t BgL_chainz00;
} *BgL_cfbzd2decryptzd2_bglt;

typedef struct BgL_ofbz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_chainz00;
} *BgL_ofbz00_bglt;

typedef struct BgL_ctrz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_blockzd2siza7ez75;
   obj_t BgL_cipherz00;
   obj_t BgL_paramz00;
   obj_t BgL_noncez00;
   obj_t BgL_noncezd2strzd2;
   long BgL_blockzd2counterzd2;
   obj_t BgL_noncezd2initz12zc0;
   obj_t BgL_noncezd2updatez12zc0;
} *BgL_ctrz00_bglt;

typedef struct BgL_cipherzd2modezd2statez00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_encryptzf3zf3;
   long BgL_blockzd2siza7ez75;
   struct BgL_cipherzd2statezd2_bgl * BgL_cipherzd2statezd2;
   obj_t BgL_ivzd2actionzd2;
   obj_t BgL_ivz00;
   obj_t BgL_padzf2unpadzf2;
   obj_t BgL_loopzd2bufferzd2;
   long BgL_posz00;
} *BgL_cipherzd2modezd2statez00_bglt;


static obj_t BGl_z62lambda2497z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2498z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1351zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1357zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1319z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_OFBz00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
extern obj_t BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(obj_t, long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1323z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1329za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1333za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1335z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1337za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1341z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1343za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1353z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static BgL_pcbczd2encryptzd2_bglt BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static long BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt, obj_t, long, obj_t, obj_t, long, obj_t);
static obj_t BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static BgL_cipherzd2statezd2_bglt BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, bool_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cfbzd2decryptzd2_bglt BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62dozd2cipherzd2IVzd2initz121308za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(obj_t, BgL_blockzd2cipherzd2_bglt);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32043ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz121310z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00();
BGL_EXPORTED_DECL obj_t BGl_encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32043ze32744ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_ofbz00_bglt BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32305ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static long BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt, obj_t, long, obj_t, obj_t, long, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CTR1355za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_IMPORT obj_t make_string(long, unsigned char);
BGL_IMPORT obj_t bgl_close_input_port(obj_t);
static BgL_blockzd2cipherzd2_bglt BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2OFB1349za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32218ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_ctrz00_bglt BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, long);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32184ze32745ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_cbczd2decryptzd2_bglt BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32260ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32325ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, BgL_cipherzd2modezd2statez00_bglt, long, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32407ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1321za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1325za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2string2keyzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2cipherzd2paddingz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__mmapz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_blockzd2cipherzd2_bglt BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_blockzd2cipherzd2_bglt BGl_z62lambda2216z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static BgL_cbczd2encryptzd2_bglt BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2222z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_cbczd2encryptzd2_bglt BGl_z62lambda2303z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32442ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32523ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(long, obj_t);
static obj_t BGl_z62zc3z04anonymousza32345ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_cfbzd2encryptzd2_bglt BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2227z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2228z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2309z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2O1347z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2310z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t rgc_buffer_eof_p(obj_t);
static obj_t BGl_z62lambda2232z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62lambda2233z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2315z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32184ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2237z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2238z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00();
static obj_t BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00();
static BgL_cbczd2decryptzd2_bglt BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00();
static BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2242z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_cbczd2decryptzd2_bglt BGl_z62lambda2323z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2243z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2405z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2247z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2248z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2329z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1327z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_rgc_blit_string(obj_t, char *, long, long);
BGL_EXPORTED_DECL BgL_blockzd2cipherzd2_bglt BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2330z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2412z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2253z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1331z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2335z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2416z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static BgL_cipherzd2statezd2_bglt BGl_z62lambda2258z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_CTRz00zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ofbz00_bglt BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2504z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2343z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32365ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2505z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_ofbz00_bglt BGl_z62lambda2425z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t, long, obj_t, long);
static obj_t BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_pcbczd2decryptzd2_bglt BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static obj_t BGl_z62lambda2265z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long, obj_t, long, long);
static obj_t BGl_z62lambda2349z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2269z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2510z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2511z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2350z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2431z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2270z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32382ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32285ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2515z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2354z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2516z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2355z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2275z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_ctrz00_bglt BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ctrz00_bglt BGl_z62lambda2440z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2521z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2522z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2363z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2283z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2447z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2369z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2370z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2451z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
BGL_IMPORT obj_t blit_string(obj_t, long, obj_t, long, long);
static obj_t BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2291z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32295ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2293z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2375z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2456z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1312zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_streamzd2cipherzd2statez00_bglt BGl_z62lambda2380z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static obj_t BGl_z62lambda2461z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static obj_t BGl_z62lambda2466z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2467z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cbczd2encryptzd2_bglt BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, long);
static BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2390z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2473z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00(obj_t);
static BgL_cipherzd2modezd2statez00_bglt BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2397z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = BUNSPEC;
static obj_t BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1339zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt, obj_t, long, obj_t, long, long, long);
static obj_t BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1315za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1317za2zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62dozd2cipherzd2partialzd2bl1345zb0zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(long, obj_t, obj_t, long);
static BgL_cipherzd2statezd2_bglt BGl_z62lambda2491z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32477ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t);
static obj_t BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 84 ] ;


extern obj_t BGl_bytezd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
extern obj_t BGl_za7erozd2padzd2envza7zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3392z00, BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza700za7za7__c3393za7, opt_generic_entry, BGl__decryptz00zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STRING( BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3200za700za7za7_3394za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3201za700za7za7_3395za7, "_encrypt", 8 );
DEFINE_STRING( BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3202za700za7za7_3396za7, "bint", 4 );
DEFINE_STRING( BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3203za700za7za7_3397za7, "symbol", 6 );
DEFINE_STRING( BGl_string3204z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3204za700za7za7_3398za7, "procedure", 9 );
DEFINE_STRING( BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3205za700za7za7_3399za7, "wrong number of arguments: [3..9] expected, provided", 52 );
DEFINE_STRING( BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3206za700za7za7_3400za7, "_encrypt-string", 15 );
DEFINE_STRING( BGl_string3207z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3207za700za7za7_3401za7, "&encrypt-fast-string", 20 );
DEFINE_STRING( BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3208za700za7za7_3402za7, "_encrypt-mmap", 13 );
DEFINE_STRING( BGl_string3209z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3209za700za7za7_3403za7, "mmap", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3404z00, BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
extern obj_t BGl_ansizd2xze2923zd2padzd2envz30zz__cryptozd2cipherzd2paddingz00;
DEFINE_STRING( BGl_string3210z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3210za700za7za7_3405za7, "&encrypt-fast-mmap", 18 );
DEFINE_STRING( BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3211za700za7za7_3406za7, "_encrypt-port", 13 );
DEFINE_STRING( BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3212za700za7za7_3407za7, "input-port", 10 );
DEFINE_STRING( BGl_string3213z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3213za700za7za7_3408za7, "&encrypt-fast-port", 18 );
DEFINE_STRING( BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3214za700za7za7_3409za7, "_encrypt-file", 13 );
DEFINE_STRING( BGl_string3215z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3215za700za7za7_3410za7, "encrypt-file", 12 );
DEFINE_STRING( BGl_string3216z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3216za700za7za7_3411za7, "Could not open file", 19 );
DEFINE_STRING( BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3217za700za7za7_3412za7, "_encrypt-sendchars", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas3413z00, BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string3218z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3218za700za7za7_3414za7, "output-port", 11 );
DEFINE_STRING( BGl_string3219z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3219za700za7za7_3415za7, "wrong number of arguments: [4..10] expected, provided", 53 );
DEFINE_STRING( BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3220za700za7za7_3416za7, "_decrypt", 8 );
DEFINE_STRING( BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3221za700za7za7_3417za7, "_decrypt-string", 15 );
DEFINE_STRING( BGl_string3222z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3222za700za7za7_3418za7, "&decrypt-fast-string", 20 );
DEFINE_STRING( BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3223za700za7za7_3419za7, "_decrypt-mmap", 13 );
DEFINE_STRING( BGl_string3224z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3224za700za7za7_3420za7, "&decrypt-fast-mmap", 18 );
DEFINE_STRING( BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3225za700za7za7_3421za7, "_decrypt-port", 13 );
DEFINE_STRING( BGl_string3226z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3226za700za7za7_3422za7, "&decrypt-fast-port", 18 );
DEFINE_STRING( BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3227za700za7za7_3423za7, "_decrypt-file", 13 );
DEFINE_STRING( BGl_string3228z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3228za700za7za7_3424za7, "decrypt-file", 12 );
DEFINE_STRING( BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3229za700za7za7_3425za7, "_decrypt-sendchars", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3300z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2388za7623426z00, BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_blockzd2cipherzd2descriptionzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762blockza7d2ciphe3427z00, BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3301z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2412za7623428z00, BGl_z62lambda2412z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3302z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2411za7623429z00, BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3303z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2417za7623430z00, BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3304z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2416za7623431z00, BGl_z62lambda2416z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3305z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3432za7, BGl_z62zc3z04anonymousza32407ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3230z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3230za700za7za7_3433za7, "&register-cipher!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3306z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2405za7623434z00, BGl_z62lambda2405z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3231z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3231za700za7za7_3435za7, "Block-Cipher", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3307z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2403za7623436z00, BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3232z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3232za700za7za7_3437za7, "block-cipher-description", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3308z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2432za7623438z00, BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3233z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3233za700za7za7_3439za7, "Could not find cipher", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3309z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2431za7623440z00, BGl_z62lambda2431z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3234z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3234za700za7za7_3441za7, "&block-cipher-description", 25 );
extern obj_t BGl_bitzd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3310z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3442za7, BGl_z62zc3z04anonymousza32427ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3311z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2425za7623443z00, BGl_z62lambda2425z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3312z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2423za7623444z00, BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3313z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2447za7623445z00, BGl_z62lambda2447z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3314z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2446za7623446z00, BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3315z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2452za7623447z00, BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3316z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2451za7623448z00, BGl_z62lambda2451z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3235z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2223za7623449z00, BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3317z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2457za7623450z00, BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3236z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2222za7623451z00, BGl_z62lambda2222z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3318z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2456za7623452z00, BGl_z62lambda2456z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3237z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2228za7623453z00, BGl_z62lambda2228z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3319z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2462za7623454z00, BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3238z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2227za7623455z00, BGl_z62lambda2227z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3239z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2233za7623456z00, BGl_z62lambda2233z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_BGL_L_PROCEDURE(BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2portza7d3457za7, BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2mmapzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2mmapza73458z00, opt_generic_entry, BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3459za7, BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3320z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2461za7623460z00, BGl_z62lambda2461z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3321z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2467za7623461z00, BGl_z62lambda2467z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3240z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2232za7623462z00, BGl_z62lambda2232z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3322z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2466za7623463z00, BGl_z62lambda2466z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3241z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2238za7623464z00, BGl_z62lambda2238z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3323z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3465za7, BGl_z62zc3z04anonymousza32442ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3242z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2237za7623466z00, BGl_z62lambda2237z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3324z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2440za7623467z00, BGl_z62lambda2440z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3243z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2243za7623468z00, BGl_z62lambda2243z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3325z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2438za7623469z00, BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3244z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2242za7623470z00, BGl_z62lambda2242z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3326z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2482za7623471z00, BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3245z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2248za7623472z00, BGl_z62lambda2248z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3327z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2481za7623473z00, BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3246z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2247za7623474z00, BGl_z62lambda2247z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3328z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2487za7623475z00, BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3247z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2253za7623476z00, BGl_z62lambda2253z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3329z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2486za7623477z00, BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3248z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2252za7623478z00, BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3249z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3479za7, BGl_z62zc3z04anonymousza32218ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3330z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2492za7623480z00, BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3331z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2491za7623481z00, BGl_z62lambda2491z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3250z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2216za7623482z00, BGl_z62lambda2216z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2filezd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2fileza73483z00, opt_generic_entry, BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3332z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3484za7, BGl_z62zc3z04anonymousza32499ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3251z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2214za7623485z00, BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3333z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2498za7623486z00, BGl_z62lambda2498z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3252z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2265za7623487z00, BGl_z62lambda2265z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3334z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2497za7623488z00, BGl_z62lambda2497z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3253z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2264za7623489z00, BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3335z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3490za7, BGl_z62zc3z04anonymousza32506ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3254z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2270za7623491z00, BGl_z62lambda2270z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3336z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2505za7623492z00, BGl_z62lambda2505z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3255z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2269za7623493z00, BGl_z62lambda2269z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3337z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2504za7623494z00, BGl_z62lambda2504z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3256z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2275za7623495z00, BGl_z62lambda2275z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3338z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2511za7623496z00, BGl_z62lambda2511z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3257z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2274za7623497z00, BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3339z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2510za7623498z00, BGl_z62lambda2510z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3258z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3499za7, BGl_z62zc3z04anonymousza32260ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3259z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2258za7623500z00, BGl_z62lambda2258z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3184za700za7za7_3501za7, "/builddir/build/BUILD/bigloo-4.4b/api/crypto/src/Llib/block_ciphers.scm", 71 );
DEFINE_STRING( BGl_string3185z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3185za700za7za7_3502za7, "&default-nonce-init!", 20 );
DEFINE_STRING( BGl_string3348z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3348za700za7za7_3503za7, "", 0 );
DEFINE_STRING( BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3186za700za7za7_3504za7, "bstring", 7 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string3187z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3187za700za7za7_3505za7, "&default-nonce-update!", 22 );
DEFINE_STRING( BGl_string3188z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3188za700za7za7_3506za7, "encrypt-input!", 14 );
DEFINE_STRING( BGl_string3189z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3189za700za7za7_3507za7, "Internal Error. Unexpected IV-action", 36 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3340z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2516za7623508z00, BGl_z62lambda2516z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3341z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2515za7623509z00, BGl_z62lambda2515z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3260z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3510za7, BGl_z62zc3z04anonymousza32285ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3342z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3511za7, BGl_z62zc3z04anonymousza32523ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3261z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2283za7623512z00, BGl_z62lambda2283z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3343z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2522za7623513z00, BGl_z62lambda2522z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3262z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2281za7623514z00, BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3350z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3350za700za7za7_3515za7, "do-cipher-IV-init!1308", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3344z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2521za7623516z00, BGl_z62lambda2521z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3263z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3517za7, BGl_z62zc3z04anonymousza32295ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3345z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3518za7, BGl_z62zc3z04anonymousza32477ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3264z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2293za7623519z00, BGl_z62lambda2293z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3352z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3352za700za7za7_3520za7, "do-cipher-block!1310", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3346z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2475za7623521z00, BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3265z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2291za7623522z00, BGl_z62lambda2291z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3190z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3190za700za7za7_3523za7, "IV", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3347z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2473za7623524z00, BGl_z62lambda2473z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3266z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2310za7623525z00, BGl_z62lambda2310z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3191z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3191za700za7za7_3526za7, "Could not read IV", 17 );
DEFINE_STRING( BGl_string3354z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3354za700za7za7_3527za7, "do-cipher-partial-bl1312", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3267z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2309za7623528z00, BGl_z62lambda2309z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3192z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3192za700za7za7_3529za7, "decrypt-input!", 14 );
DEFINE_STRING( BGl_string3355z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3355za700za7za7_3530za7, "en/decrypt-partial-block", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3349z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3531za7, BGl_z62dozd2cipherzd2IVzd2initz121308za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3268z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2315za7623532z00, BGl_z62lambda2315z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3193z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3193za700za7za7_3533za7, "decrypt", 7 );
DEFINE_STRING( BGl_string3356z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3356za700za7za7_3534za7, "Internal Error: Could not find method for state", 47 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3269z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2314za7623535z00, BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3194z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3194za700za7za7_3536za7, "Message size must be a multiple of block-size", 45 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762encryptza7d2fas3537z00, BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string3357z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3357za700za7za7_3538za7, "en/decrypt-block", 16 );
DEFINE_STRING( BGl_string3195z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3195za700za7za7_3539za7, "encrypt", 7 );
DEFINE_STRING( BGl_string3358z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3358za700za7za7_3540za7, "cipher-IV-init", 14 );
DEFINE_STRING( BGl_string3196z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3196za700za7za7_3541za7, "Unknown cipher mode", 19 );
DEFINE_STRING( BGl_string3359z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3359za700za7za7_3542za7, "&do-cipher-IV-init!", 19 );
DEFINE_STRING( BGl_string3197z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3197za700za7za7_3543za7, "Invalid padding mode", 20 );
DEFINE_STRING( BGl_string3198z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3198za700za7za7_3544za7, "encryption", 10 );
DEFINE_STRING( BGl_string3199z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3199za700za7za7_3545za7, "IV vector is too small", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762writeza7d2portza73546za7, BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas3547z00, BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3351z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3548za7, BGl_z62dozd2cipherzd2blockz121310z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3270z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3549za7, BGl_z62zc3z04anonymousza32305ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3271z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2303za7623550z00, BGl_z62lambda2303z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3353z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3551za7, BGl_z62dozd2cipherzd2partialzd2bl1312zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3272z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2301za7623552z00, BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3360z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3360za700za7za7_3553za7, "Cipher-State", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3273z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2330za7623554z00, BGl_z62lambda2330z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3361za700za7za7_3555za7, "&do-cipher-block!", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3274z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2329za7623556z00, BGl_z62lambda2329z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3362za700za7za7_3557za7, "&do-cipher-partial-block!", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3275z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2335za7623558z00, BGl_z62lambda2335z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3276z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2334za7623559z00, BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3364z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3364za700za7za7_3560za7, "do-cipher-block!", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3277z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3561za7, BGl_z62zc3z04anonymousza32325ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3278z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2323za7623562z00, BGl_z62lambda2323z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3279z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2321za7623563z00, BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3367z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3367za700za7za7_3564za7, "do-cipher-IV-init!", 18 );
extern obj_t BGl_nozd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3280z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2350za7623565z00, BGl_z62lambda2350z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3281z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2349za7623566z00, BGl_z62lambda2349z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3363z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3567za7, BGl_z62dozd2cipherzd2blockz12zd2ECB1315za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3282z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2355za7623568z00, BGl_z62lambda2355z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3283z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2354za7623569z00, BGl_z62lambda2354z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3365z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3570za7, BGl_z62dozd2cipherzd2blockz12zd2ECB1317za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3284z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3571za7, BGl_z62zc3z04anonymousza32345ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3366z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3572za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1319z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3285z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2343za7623573z00, BGl_z62lambda2343z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3286z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2341za7623574z00, BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3368z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3575za7, BGl_z62dozd2cipherzd2blockz12zd2CBC1321za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3287z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2370za7623576z00, BGl_z62lambda2370z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3369z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3577za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1323z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3288z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2369za7623578z00, BGl_z62lambda2369z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3289z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2375za7623579z00, BGl_z62lambda2375z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3378z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3378za700za7za7_3580za7, "do-cipher-partial-block!", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3370z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3581za7, BGl_z62dozd2cipherzd2blockz12zd2CBC1325za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3371z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3582za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2P1327z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3290z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2374za7623583z00, BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3372z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3584za7, BGl_z62dozd2cipherzd2blockz12zd2PCB1329za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3291z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3585za7, BGl_z62zc3z04anonymousza32365ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3373z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3586za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2P1331z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3292z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2363za7623587z00, BGl_z62lambda2363z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3374z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3588za7, BGl_z62dozd2cipherzd2blockz12zd2PCB1333za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3293z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2361za7623589z00, BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3375z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3590za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1335z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3294z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3591za7, BGl_z62zc3z04anonymousza32382ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3376z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3592za7, BGl_z62dozd2cipherzd2blockz12zd2CFB1337za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3295z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2380za7623593z00, BGl_z62lambda2380z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3377z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3594za7, BGl_z62dozd2cipherzd2partialzd2bl1339zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3296z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2397za7623595z00, BGl_z62lambda2397z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3297z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2396za7623596z00, BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3379z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3597za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1341z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3298z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762za7c3za704anonymo3598za7, BGl_z62zc3z04anonymousza32392ze3ze5zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3299z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762lambda2390za7623599z00, BGl_z62lambda2390z62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3388z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3388za700za7za7_3600za7, "__crypto-block-ciphers", 22 );
DEFINE_STRING( BGl_string3389z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_string3389za700za7za7_3601za7, "unspecified _ Cipher-Mode-State pos loop-buffer pad/unpad IV symbol IV-action cipher-state bool encrypt? CTR nonce-update! nonce-init! block-counter nonce-str nonce OFB CFB-Decrypt CFB-Encrypt Stream-Cipher-State PCBC-Decrypt PCBC-Encrypt CBC-Decrypt CBC-Encrypt chain buffer ECB-Decrypt ECB-Encrypt Cipher-State obj param cipher __crypto-block-ciphers Block-Cipher key->decrypt-param key->encrypt-param decrypt! procedure encrypt! preferred-key-length long block-size bstring name decrypt-sendchars decrypt-file::bstring decrypt-port::bstring decrypt-mmap::bstring decrypt-string::bstring decrypt decrypt::bstring encrypt-sendchars encrypt-file::bstring encrypt-port::bstring encrypt-mmap::bstring encrypt-string::bstring encrypt :string->key :pad :nonce-update! :nonce-init! :mode :IV encrypt::bstring (:IV :mode :nonce-init! :nonce-update! :pad :string->key) zero pkcs7 iso-10126 ansi-x.923 bit none ctr ofb pcbc cbc cfb ecb read do-nothing done write init ", 960 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3380z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3602za7, BGl_z62dozd2cipherzd2blockz12zd2CFB1343za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3381z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3603za7, BGl_z62dozd2cipherzd2partialzd2bl1345zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2portzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2portza73604z00, opt_generic_entry, BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3382z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3605za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2O1347z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3383z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3606za7, BGl_z62dozd2cipherzd2blockz12zd2OFB1349za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3384z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3607za7, BGl_z62dozd2cipherzd2partialzd2bl1351zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3385z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3608za7, BGl_z62dozd2cipherzd2IVzd2initz12zd2C1353z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3386z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3609za7, BGl_z62dozd2cipherzd2blockz12zd2CTR1355za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3387z00zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3610za7, BGl_z62dozd2cipherzd2partialzd2bl1357zb0zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762decryptza7d2fas3611z00, BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 9 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2sendcharszd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2sendc3612za7, opt_generic_entry, BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2sendcharszd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2sendc3613za7, opt_generic_entry, BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762defaultza7d2non3614z00, BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_bitzd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2mmapzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2mmapza73615z00, opt_generic_entry, BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
BGL_IMPORT obj_t BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00;
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3616za7, BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2filezd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2fileza73617z00, opt_generic_entry, BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
extern obj_t BGl_isozd210126zd2padzd2envzd2zz__cryptozd2cipherzd2paddingz00;
extern obj_t BGl_za7erozd2unpadzd2envza7zz__cryptozd2cipherzd2paddingz00;
extern obj_t BGl_pkcs7zd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_BGL_L_PROCEDURE(BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2mmapza7d3618za7, BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_STATIC_BGL_GENERIC( BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762doza7d2cipherza7d3619za7, BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2portzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2portza73620z00, opt_generic_entry, BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decryptzd2stringzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__decryptza7d2strin3621za7, opt_generic_entry, BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
extern obj_t BGl_nozd2padzd2envz00zz__cryptozd2cipherzd2paddingz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2stringzd2envz00zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza7d2strin3622za7, opt_generic_entry, BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762defaultza7d2non3623z00, BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encryptzd2envzd2zz__cryptozd2blockzd2ciphersz00, BgL_bgl__encryptza700za7za7__c3624za7, opt_generic_entry, BGl__encryptz00zz__cryptozd2blockzd2ciphersz00, BFALSE, -1 );
DEFINE_BGL_L_PROCEDURE(BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762readza7d2string3625z00, BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_registerzd2cipherz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BgL_bgl_za762registerza7d2ci3626z00, BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_OFBz00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_CTRz00zz__cryptozd2blockzd2ciphersz00) );
ADD_ROOT( (void *)(&BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00(long BgL_checksumz00_6092, char * BgL_fromz00_6093)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00))
{ 
BGl_requirezd2initializa7ationz75zz__cryptozd2blockzd2ciphersz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00(); 
BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00(); 
return 
BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__mmapz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__crypto-block-ciphers"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__crypto-block-ciphers"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_cportz00_5548;
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_stringz00_5556;
BgL_stringz00_5556 = BGl_string3389z00zz__cryptozd2blockzd2ciphersz00; 
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_startz00_5557;
BgL_startz00_5557 = 
BINT(((long)0)); 
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_endz00_5558;
BgL_endz00_5558 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5556))); 
{ /* Llib/block_ciphers.scm 1 */

BgL_cportz00_5548 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5556, BgL_startz00_5557, BgL_endz00_5558); } } } } 
{ 
long BgL_iz00_5549;
BgL_iz00_5549 = ((long)83); 
BgL_loopz00_5550:
if(
(BgL_iz00_5549==((long)-1)))
{ /* Llib/block_ciphers.scm 1 */
return BUNSPEC;}  else 
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_arg3391z00_5552;
{ /* Llib/block_ciphers.scm 1 */

{ /* Llib/block_ciphers.scm 1 */
obj_t BgL_locationz00_5554;
BgL_locationz00_5554 = 
BBOOL(((bool_t)0)); 
{ /* Llib/block_ciphers.scm 1 */

BgL_arg3391z00_5552 = 
BGl_readz00zz__readerz00(BgL_cportz00_5548, BgL_locationz00_5554); } } } 
{ /* Llib/block_ciphers.scm 1 */
int BgL_tmpz00_6130;
BgL_tmpz00_6130 = 
(int)(BgL_iz00_5549); 
CNST_TABLE_SET(BgL_tmpz00_6130, BgL_arg3391z00_5552); } } 
{ /* Llib/block_ciphers.scm 1 */
int BgL_auxz00_5555;
BgL_auxz00_5555 = 
(int)(
(BgL_iz00_5549-((long)1))); 
{ 
long BgL_iz00_6135;
BgL_iz00_6135 = 
(long)(BgL_auxz00_5555); 
BgL_iz00_5549 = BgL_iz00_6135; 
goto BgL_loopz00_5550;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
return ( 
BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = BNIL, BUNSPEC) ;} 

}



/* &read-string-at! */
obj_t BGl_z62readzd2stringzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4347, obj_t BgL_strz00_4348, long BgL_strzd2poszd2_4349, obj_t BgL_tozd2strzd2_4350, long BgL_tozd2poszd2_4351, long BgL_lenz00_4352)
{
{ /* Llib/block_ciphers.scm 142 */
{ /* Llib/block_ciphers.scm 143 */
long BgL_tmpz00_6138;
{ /* Llib/block_ciphers.scm 143 */
long BgL_strzd2lenzd2_5566;
BgL_strzd2lenzd2_5566 = 
STRING_LENGTH(
((obj_t)BgL_strz00_4348)); 
{ /* Llib/block_ciphers.scm 143 */

if(
(
(BgL_strzd2poszd2_4349+BgL_lenz00_4352)<=BgL_strzd2lenzd2_5566))
{ /* Llib/block_ciphers.scm 144 */
blit_string(
((obj_t)BgL_strz00_4348), BgL_strzd2poszd2_4349, BgL_tozd2strzd2_4350, BgL_tozd2poszd2_4351, BgL_lenz00_4352); 
BgL_tmpz00_6138 = BgL_lenz00_4352; }  else 
{ /* Llib/block_ciphers.scm 148 */
long BgL_remainingzd2lenzd2_5569;
BgL_remainingzd2lenzd2_5569 = 
(BgL_strzd2lenzd2_5566-BgL_strzd2poszd2_4349); 
blit_string(
((obj_t)BgL_strz00_4348), BgL_strzd2poszd2_4349, BgL_tozd2strzd2_4350, BgL_tozd2poszd2_4351, BgL_remainingzd2lenzd2_5569); 
BgL_tmpz00_6138 = BgL_remainingzd2lenzd2_5569; } } } 
return 
BINT(BgL_tmpz00_6138);} } 

}



/* &read-mmap-at! */
obj_t BGl_z62readzd2mmapzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4353, obj_t BgL_mmapz00_4354, long BgL_mmapzd2poszd2_4355, obj_t BgL_tozd2strzd2_4356, long BgL_tozd2poszd2_4357, long BgL_lenz00_4358)
{
{ /* Llib/block_ciphers.scm 151 */
{ /* Llib/block_ciphers.scm 152 */
long BgL_tmpz00_6150;
{ 
long BgL_lenz00_5571;
BgL_lenz00_5571 = BgL_lenz00_4358; 
BgL_readzd2mmapzd2atz12z12_5570:
{ /* Llib/block_ciphers.scm 152 */
long BgL_mmapzd2lenzd2_5572;
{ /* Llib/block_ciphers.scm 152 */
obj_t BgL_tmpz00_6151;
BgL_tmpz00_6151 = 
((obj_t)BgL_mmapz00_4354); 
BgL_mmapzd2lenzd2_5572 = 
BGL_MMAP_LENGTH(BgL_tmpz00_6151); } 
if(
(BgL_lenz00_5571==((long)0)))
{ /* Llib/block_ciphers.scm 154 */
BgL_tmpz00_6150 = ((long)0)
; }  else 
{ /* Llib/block_ciphers.scm 155 */
bool_t BgL_test3631z00_6156;
{ /* Llib/block_ciphers.scm 155 */
long BgL_n2z00_5573;
BgL_n2z00_5573 = 
(long)(BgL_mmapzd2lenzd2_5572); 
BgL_test3631z00_6156 = 
(
(BgL_mmapzd2poszd2_4355+BgL_lenz00_5571)>BgL_n2z00_5573); } 
if(BgL_test3631z00_6156)
{ /* Llib/block_ciphers.scm 156 */
long BgL_arg1580z00_5574;
{ /* Llib/block_ciphers.scm 156 */
long BgL_za71za7_5575;
BgL_za71za7_5575 = 
(long)(BgL_mmapzd2lenzd2_5572); 
BgL_arg1580z00_5574 = 
(BgL_za71za7_5575-BgL_mmapzd2poszd2_4355); } 
{ 
long BgL_lenz00_6162;
BgL_lenz00_6162 = BgL_arg1580z00_5574; 
BgL_lenz00_5571 = BgL_lenz00_6162; 
goto BgL_readzd2mmapzd2atz12z12_5570;} }  else 
{ 
long BgL_iz00_5577;
BgL_iz00_5577 = ((long)0); 
BgL_loopz00_5576:
if(
(BgL_iz00_5577==BgL_lenz00_5571))
{ /* Llib/block_ciphers.scm 159 */
BgL_tmpz00_6150 = BgL_lenz00_5571
; }  else 
{ /* Llib/block_ciphers.scm 159 */
{ /* Llib/block_ciphers.scm 162 */
long BgL_arg1591z00_5578;unsigned char BgL_arg1593z00_5579;
BgL_arg1591z00_5578 = 
(BgL_tozd2poszd2_4357+BgL_iz00_5577); 
{ /* Llib/block_ciphers.scm 163 */
long BgL_arg1615z00_5580;
BgL_arg1615z00_5580 = 
(BgL_mmapzd2poszd2_4355+BgL_iz00_5577); 
{ /* Llib/block_ciphers.scm 163 */
unsigned char BgL_res2681z00_5581;
{ /* Llib/block_ciphers.scm 163 */
long BgL_iz00_5582;
BgL_iz00_5582 = 
(long)(BgL_arg1615z00_5580); 
{ /* Llib/block_ciphers.scm 163 */
unsigned char BgL_cz00_5583;
{ /* Llib/block_ciphers.scm 163 */
obj_t BgL_tmpz00_6168;
BgL_tmpz00_6168 = 
((obj_t)BgL_mmapz00_4354); 
BgL_cz00_5583 = 
BGL_MMAP_REF(BgL_tmpz00_6168, BgL_iz00_5582); } 
{ /* Llib/block_ciphers.scm 163 */
long BgL_arg1640z00_5584;
BgL_arg1640z00_5584 = 
(BgL_iz00_5582+((long)1)); 
{ /* Llib/block_ciphers.scm 163 */
obj_t BgL_tmpz00_6172;
BgL_tmpz00_6172 = 
((obj_t)BgL_mmapz00_4354); 
BGL_MMAP_RP_SET(BgL_tmpz00_6172, BgL_arg1640z00_5584); } BUNSPEC; BgL_arg1640z00_5584; } 
BgL_res2681z00_5581 = BgL_cz00_5583; } } 
BgL_arg1593z00_5579 = BgL_res2681z00_5581; } } 
STRING_SET(BgL_tozd2strzd2_4356, BgL_arg1591z00_5578, BgL_arg1593z00_5579); } 
{ 
long BgL_iz00_6176;
BgL_iz00_6176 = 
(BgL_iz00_5577+((long)1)); 
BgL_iz00_5577 = BgL_iz00_6176; 
goto BgL_loopz00_5576;} } } } } } 
return 
BINT(BgL_tmpz00_6150);} } 

}



/* &read-port-at! */
obj_t BGl_z62readzd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4359, obj_t BgL_pz00_4360, long BgL_pzd2poszd2_4361, obj_t BgL_tozd2strzd2_4362, long BgL_tozd2poszd2_4363, long BgL_lenz00_4364)
{
{ /* Llib/block_ciphers.scm 165 */
{ /* Llib/block_ciphers.scm 166 */
obj_t BgL_nz00_5589;
{ /* Llib/block_ciphers.scm 166 */
long BgL_nz00_5590;
BgL_nz00_5590 = 
bgl_rgc_blit_string(BgL_pz00_4360, 
BSTRING_TO_STRING(BgL_tozd2strzd2_4362), BgL_tozd2poszd2_4363, BgL_lenz00_4364); 
{ /* Llib/block_ciphers.scm 166 */
bool_t BgL_test3633z00_6181;
if(
(BgL_nz00_5590==((long)0)))
{ /* Llib/block_ciphers.scm 166 */
BgL_test3633z00_6181 = 
rgc_buffer_eof_p(BgL_pz00_4360)
; }  else 
{ /* Llib/block_ciphers.scm 166 */
BgL_test3633z00_6181 = ((bool_t)0)
; } 
if(BgL_test3633z00_6181)
{ /* Llib/block_ciphers.scm 166 */
BgL_nz00_5589 = BEOF; }  else 
{ /* Llib/block_ciphers.scm 166 */
BgL_nz00_5589 = 
BINT(BgL_nz00_5590); } } } 
if(
EOF_OBJECTP(BgL_nz00_5589))
{ /* Llib/block_ciphers.scm 167 */
return 
BINT(((long)0));}  else 
{ /* Llib/block_ciphers.scm 167 */
return BgL_nz00_5589;} } } 

}



/* &write-port-at! */
obj_t BGl_z62writezd2portzd2atz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4365, obj_t BgL_fromz00_4366, obj_t BgL_fromzd2poszd2_4367, obj_t BgL_pz00_4368, obj_t BgL_pzd2poszd2_4369, obj_t BgL_lenz00_4370)
{
{ /* Llib/block_ciphers.scm 171 */
{ /* Llib/block_ciphers.scm 173 */
bool_t BgL_tmpz00_6189;
{ /* Llib/block_ciphers.scm 173 */
long BgL_fromzd2poszd2_5591;
BgL_fromzd2poszd2_5591 = 
(long)CINT(BgL_fromzd2poszd2_4367); 
{ 
long BgL_iz00_5594;
BgL_iz00_5594 = ((long)0); 
BgL_loopz00_5593:
if(
(BgL_iz00_5594==
(long)CINT(BgL_lenz00_4370)))
{ /* Llib/block_ciphers.scm 173 */
BgL_tmpz00_6189 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 173 */
{ /* Llib/block_ciphers.scm 174 */
unsigned char BgL_arg1624z00_5595;
BgL_arg1624z00_5595 = 
STRING_REF(
((obj_t)BgL_fromz00_4366), 
(BgL_fromzd2poszd2_5591+BgL_iz00_5594)); 
{ /* Llib/block_ciphers.scm 174 */
obj_t BgL_tmpz00_6197;
BgL_tmpz00_6197 = 
((obj_t)BgL_pz00_4368); 
bgl_display_char(BgL_arg1624z00_5595, BgL_tmpz00_6197); } } 
{ 
long BgL_iz00_6200;
BgL_iz00_6200 = 
(BgL_iz00_5594+((long)1)); 
BgL_iz00_5594 = BgL_iz00_6200; 
goto BgL_loopz00_5593;} } } } 
return 
BBOOL(BgL_tmpz00_6189);} } 

}



/* &default-nonce-init! */
obj_t BGl_z62defaultzd2noncezd2initz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4371, obj_t BgL_strz00_4372, obj_t BgL_noncez00_4373)
{
{ /* Llib/block_ciphers.scm 189 */
{ /* Llib/block_ciphers.scm 190 */
obj_t BgL_strz00_5596;
if(
STRINGP(BgL_strz00_4372))
{ /* Llib/block_ciphers.scm 190 */
BgL_strz00_5596 = BgL_strz00_4372; }  else 
{ 
obj_t BgL_auxz00_6205;
BgL_auxz00_6205 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)6773)), BGl_string3185z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_strz00_4372); 
FAILURE(BgL_auxz00_6205,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 190 */
long BgL_arg1647z00_5597;
{ /* Llib/block_ciphers.scm 190 */
long BgL_az00_5598;long BgL_bz00_5599;
BgL_az00_5598 = 
STRING_LENGTH(BgL_strz00_5596); 
BgL_bz00_5599 = 
STRING_LENGTH(
((obj_t)BgL_noncez00_4373)); 
if(
(BgL_az00_5598<BgL_bz00_5599))
{ /* Llib/block_ciphers.scm 191 */
BgL_arg1647z00_5597 = BgL_az00_5598; }  else 
{ /* Llib/block_ciphers.scm 191 */
BgL_arg1647z00_5597 = BgL_bz00_5599; } } 
return 
blit_string(
((obj_t)BgL_noncez00_4373), ((long)0), BgL_strz00_5596, ((long)0), BgL_arg1647z00_5597);} } } 

}



/* &default-nonce-update! */
obj_t BGl_z62defaultzd2noncezd2updatez12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4374, obj_t BgL_strz00_4375, obj_t BgL_noncez00_4376, obj_t BgL_iz00_4377)
{
{ /* Llib/block_ciphers.scm 192 */
{ /* Llib/block_ciphers.scm 193 */
obj_t BgL_strz00_5600;
if(
STRINGP(BgL_strz00_4375))
{ /* Llib/block_ciphers.scm 193 */
BgL_strz00_5600 = BgL_strz00_4375; }  else 
{ 
obj_t BgL_auxz00_6218;
BgL_auxz00_6218 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)6889)), BGl_string3187z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_strz00_4375); 
FAILURE(BgL_auxz00_6218,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 193 */
long BgL_g1160z00_5601;
BgL_g1160z00_5601 = 
(
STRING_LENGTH(BgL_strz00_5600)-((long)1)); 
{ 
long BgL_iz00_5603;
BgL_iz00_5603 = BgL_g1160z00_5601; 
BgL_loopz00_5602:
if(
(BgL_iz00_5603>=((long)0)))
{ /* Llib/block_ciphers.scm 195 */
long BgL_cz00_5604;
BgL_cz00_5604 = 
(
STRING_REF(BgL_strz00_5600, BgL_iz00_5603)); 
if(
(BgL_cz00_5604==((long)255)))
{ /* Llib/block_ciphers.scm 196 */
STRING_SET(BgL_strz00_5600, BgL_iz00_5603, ((unsigned char)'\000')); 
{ 
long BgL_iz00_6231;
BgL_iz00_6231 = 
(BgL_iz00_5603-((long)1)); 
BgL_iz00_5603 = BgL_iz00_6231; 
goto BgL_loopz00_5602;} }  else 
{ /* Llib/block_ciphers.scm 200 */
unsigned char BgL_tmpz00_6233;
BgL_tmpz00_6233 = 
(
(BgL_cz00_5604+((long)1))); 
return 
STRING_SET(BgL_strz00_5600, BgL_iz00_5603, BgL_tmpz00_6233);} }  else 
{ /* Llib/block_ciphers.scm 194 */
return BFALSE;} } } } } 

}



/* create-ECB-state */
BgL_cipherzd2statezd2_bglt BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_enzf2decryptzf2_50, obj_t BgL_paramz00_51, long BgL_blockzd2siza7ez75_52, bool_t BgL_encryptzf3zf3_53)
{
{ /* Llib/block_ciphers.scm 223 */
if(BgL_encryptzf3zf3_53)
{ /* Llib/block_ciphers.scm 225 */
BgL_ecbzd2encryptzd2_bglt BgL_new1162z00_496;
{ /* Llib/block_ciphers.scm 228 */
BgL_ecbzd2encryptzd2_bglt BgL_new1161z00_497;
BgL_new1161z00_497 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 228 */
long BgL_arg1677z00_498;
BgL_arg1677z00_498 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1161z00_497), BgL_arg1677z00_498); } 
{ /* Llib/block_ciphers.scm 228 */
BgL_objectz00_bglt BgL_tmpz00_6242;
BgL_tmpz00_6242 = 
((BgL_objectz00_bglt)BgL_new1161z00_497); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6242, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1161z00_497); 
BgL_new1162z00_496 = BgL_new1161z00_497; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1162z00_496)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_52),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1162z00_496)))->BgL_cipherz00)=((obj_t)BgL_enzf2decryptzf2_50),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1162z00_496)))->BgL_paramz00)=((obj_t)BgL_paramz00_51),BUNSPEC); 
return 
((BgL_cipherzd2statezd2_bglt)BgL_new1162z00_496);}  else 
{ /* Llib/block_ciphers.scm 229 */
BgL_ecbzd2decryptzd2_bglt BgL_new1164z00_499;
{ /* Llib/block_ciphers.scm 232 */
BgL_ecbzd2decryptzd2_bglt BgL_new1163z00_500;
BgL_new1163z00_500 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 232 */
long BgL_arg1678z00_501;
BgL_arg1678z00_501 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1163z00_500), BgL_arg1678z00_501); } 
{ /* Llib/block_ciphers.scm 232 */
BgL_objectz00_bglt BgL_tmpz00_6257;
BgL_tmpz00_6257 = 
((BgL_objectz00_bglt)BgL_new1163z00_500); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6257, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1163z00_500); 
BgL_new1164z00_499 = BgL_new1163z00_500; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1164z00_499)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_52),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1164z00_499)))->BgL_cipherz00)=((obj_t)BgL_enzf2decryptzf2_50),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1164z00_499)))->BgL_paramz00)=((obj_t)BgL_paramz00_51),BUNSPEC); 
return 
((BgL_cipherzd2statezd2_bglt)BgL_new1164z00_499);} } 

}



/* create-CBC-encryption-state */
BgL_cbczd2encryptzd2_bglt BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_64, obj_t BgL_paramz00_65, long BgL_blockzd2siza7ez75_66)
{
{ /* Llib/block_ciphers.scm 242 */
{ /* Llib/block_ciphers.scm 243 */
BgL_cbczd2encryptzd2_bglt BgL_new1168z00_502;
{ /* Llib/block_ciphers.scm 246 */
BgL_cbczd2encryptzd2_bglt BgL_new1167z00_507;
BgL_new1167z00_507 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 246 */
long BgL_arg1681z00_508;
BgL_arg1681z00_508 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1167z00_507), BgL_arg1681z00_508); } 
{ /* Llib/block_ciphers.scm 246 */
BgL_objectz00_bglt BgL_tmpz00_6272;
BgL_tmpz00_6272 = 
((BgL_objectz00_bglt)BgL_new1167z00_507); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6272, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1167z00_507); 
BgL_new1168z00_502 = BgL_new1167z00_507; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1168z00_502)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_66),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1168z00_502)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_64),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1168z00_502)))->BgL_paramz00)=((obj_t)BgL_paramz00_65),BUNSPEC); 
{ 
obj_t BgL_auxz00_6282;
{ /* Llib/block_ciphers.scm 247 */

BgL_auxz00_6282 = 
make_string(BgL_blockzd2siza7ez75_66, ((unsigned char)' ')); } 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1168z00_502))->BgL_bufferz00)=((obj_t)BgL_auxz00_6282),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6285;
{ /* Llib/block_ciphers.scm 248 */

BgL_auxz00_6285 = 
make_string(BgL_blockzd2siza7ez75_66, ((unsigned char)' ')); } 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1168z00_502))->BgL_chainz00)=((obj_t)BgL_auxz00_6285),BUNSPEC); } 
return BgL_new1168z00_502;} } 

}



/* create-CBC-decryption-state */
BgL_cbczd2decryptzd2_bglt BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_decryptz00_74, obj_t BgL_paramz00_75, long BgL_blockzd2siza7ez75_76)
{
{ /* Llib/block_ciphers.scm 259 */
{ /* Llib/block_ciphers.scm 260 */
BgL_cbczd2decryptzd2_bglt BgL_new1172z00_509;
{ /* Llib/block_ciphers.scm 263 */
BgL_cbczd2decryptzd2_bglt BgL_new1171z00_514;
BgL_new1171z00_514 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 263 */
long BgL_arg1684z00_515;
BgL_arg1684z00_515 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1171z00_514), BgL_arg1684z00_515); } 
{ /* Llib/block_ciphers.scm 263 */
BgL_objectz00_bglt BgL_tmpz00_6292;
BgL_tmpz00_6292 = 
((BgL_objectz00_bglt)BgL_new1171z00_514); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6292, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1171z00_514); 
BgL_new1172z00_509 = BgL_new1171z00_514; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1172z00_509)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_76),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1172z00_509)))->BgL_cipherz00)=((obj_t)BgL_decryptz00_74),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1172z00_509)))->BgL_paramz00)=((obj_t)BgL_paramz00_75),BUNSPEC); 
{ 
obj_t BgL_auxz00_6302;
{ /* Llib/block_ciphers.scm 264 */

BgL_auxz00_6302 = 
make_string(BgL_blockzd2siza7ez75_76, ((unsigned char)' ')); } 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1172z00_509))->BgL_bufferz00)=((obj_t)BgL_auxz00_6302),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6305;
{ /* Llib/block_ciphers.scm 265 */

BgL_auxz00_6305 = 
make_string(BgL_blockzd2siza7ez75_76, ((unsigned char)' ')); } 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1172z00_509))->BgL_chainz00)=((obj_t)BgL_auxz00_6305),BUNSPEC); } 
return BgL_new1172z00_509;} } 

}



/* create-PCBC-encryption-state */
BgL_pcbczd2encryptzd2_bglt BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_84, obj_t BgL_paramz00_85, long BgL_blockzd2siza7ez75_86)
{
{ /* Llib/block_ciphers.scm 280 */
{ /* Llib/block_ciphers.scm 281 */
BgL_pcbczd2encryptzd2_bglt BgL_new1176z00_516;
{ /* Llib/block_ciphers.scm 285 */
BgL_pcbczd2encryptzd2_bglt BgL_new1175z00_521;
BgL_new1175z00_521 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 285 */
long BgL_arg1696z00_522;
BgL_arg1696z00_522 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_521), BgL_arg1696z00_522); } 
{ /* Llib/block_ciphers.scm 285 */
BgL_objectz00_bglt BgL_tmpz00_6312;
BgL_tmpz00_6312 = 
((BgL_objectz00_bglt)BgL_new1175z00_521); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6312, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1175z00_521); 
BgL_new1176z00_516 = BgL_new1175z00_521; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1176z00_516)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_86),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1176z00_516)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_84),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1176z00_516)))->BgL_paramz00)=((obj_t)BgL_paramz00_85),BUNSPEC); 
{ 
obj_t BgL_auxz00_6322;
{ /* Llib/block_ciphers.scm 282 */

BgL_auxz00_6322 = 
make_string(BgL_blockzd2siza7ez75_86, ((unsigned char)' ')); } 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1176z00_516))->BgL_bufferz00)=((obj_t)BgL_auxz00_6322),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6325;
{ /* Llib/block_ciphers.scm 286 */

BgL_auxz00_6325 = 
make_string(BgL_blockzd2siza7ez75_86, ((unsigned char)' ')); } 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1176z00_516))->BgL_chainz00)=((obj_t)BgL_auxz00_6325),BUNSPEC); } 
return BgL_new1176z00_516;} } 

}



/* create-PCBC-decryption-state */
BgL_pcbczd2decryptzd2_bglt BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_decryptz00_94, obj_t BgL_paramz00_95, long BgL_blockzd2siza7ez75_96)
{
{ /* Llib/block_ciphers.scm 298 */
{ /* Llib/block_ciphers.scm 299 */
BgL_pcbczd2decryptzd2_bglt BgL_new1180z00_523;
{ /* Llib/block_ciphers.scm 303 */
BgL_pcbczd2decryptzd2_bglt BgL_new1179z00_528;
BgL_new1179z00_528 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 303 */
long BgL_arg1697z00_529;
BgL_arg1697z00_529 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_528), BgL_arg1697z00_529); } 
{ /* Llib/block_ciphers.scm 303 */
BgL_objectz00_bglt BgL_tmpz00_6332;
BgL_tmpz00_6332 = 
((BgL_objectz00_bglt)BgL_new1179z00_528); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6332, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1179z00_528); 
BgL_new1180z00_523 = BgL_new1179z00_528; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1180z00_523)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_96),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1180z00_523)))->BgL_cipherz00)=((obj_t)BgL_decryptz00_94),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1180z00_523)))->BgL_paramz00)=((obj_t)BgL_paramz00_95),BUNSPEC); 
{ 
obj_t BgL_auxz00_6342;
{ /* Llib/block_ciphers.scm 300 */

BgL_auxz00_6342 = 
make_string(BgL_blockzd2siza7ez75_96, ((unsigned char)' ')); } 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1180z00_523))->BgL_bufferz00)=((obj_t)BgL_auxz00_6342),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6345;
{ /* Llib/block_ciphers.scm 304 */

BgL_auxz00_6345 = 
make_string(BgL_blockzd2siza7ez75_96, ((unsigned char)' ')); } 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1180z00_523))->BgL_chainz00)=((obj_t)BgL_auxz00_6345),BUNSPEC); } 
return BgL_new1180z00_523;} } 

}



/* create-CFB-encryption-state */
BgL_cfbzd2encryptzd2_bglt BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_104, obj_t BgL_paramz00_105, long BgL_blockzd2siza7ez75_106)
{
{ /* Llib/block_ciphers.scm 318 */
{ /* Llib/block_ciphers.scm 319 */
BgL_cfbzd2encryptzd2_bglt BgL_new1184z00_530;
{ /* Llib/block_ciphers.scm 322 */
BgL_cfbzd2encryptzd2_bglt BgL_new1183z00_533;
BgL_new1183z00_533 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 322 */
long BgL_arg1698z00_534;
BgL_arg1698z00_534 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1183z00_533), BgL_arg1698z00_534); } 
{ /* Llib/block_ciphers.scm 322 */
BgL_objectz00_bglt BgL_tmpz00_6352;
BgL_tmpz00_6352 = 
((BgL_objectz00_bglt)BgL_new1183z00_533); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6352, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1183z00_533); 
BgL_new1184z00_530 = BgL_new1183z00_533; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1184z00_530)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_106),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1184z00_530)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_104),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1184z00_530)))->BgL_paramz00)=((obj_t)BgL_paramz00_105),BUNSPEC); 
{ 
obj_t BgL_auxz00_6362;
{ /* Llib/block_ciphers.scm 323 */

BgL_auxz00_6362 = 
make_string(BgL_blockzd2siza7ez75_106, ((unsigned char)' ')); } 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(BgL_new1184z00_530))->BgL_chainz00)=((obj_t)BgL_auxz00_6362),BUNSPEC); } 
return BgL_new1184z00_530;} } 

}



/* create-CFB-decryption-state */
BgL_cfbzd2decryptzd2_bglt BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_121, obj_t BgL_paramz00_122, long BgL_blockzd2siza7ez75_123)
{
{ /* Llib/block_ciphers.scm 341 */
{ /* Llib/block_ciphers.scm 342 */
BgL_cfbzd2decryptzd2_bglt BgL_new1189z00_535;
{ /* Llib/block_ciphers.scm 346 */
BgL_cfbzd2decryptzd2_bglt BgL_new1188z00_540;
BgL_new1188z00_540 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 346 */
long BgL_arg1699z00_541;
BgL_arg1699z00_541 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1188z00_540), BgL_arg1699z00_541); } 
{ /* Llib/block_ciphers.scm 346 */
BgL_objectz00_bglt BgL_tmpz00_6369;
BgL_tmpz00_6369 = 
((BgL_objectz00_bglt)BgL_new1188z00_540); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6369, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1188z00_540); 
BgL_new1189z00_535 = BgL_new1188z00_540; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1189z00_535)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_123),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1189z00_535)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_121),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1189z00_535)))->BgL_paramz00)=((obj_t)BgL_paramz00_122),BUNSPEC); 
{ 
obj_t BgL_auxz00_6379;
{ /* Llib/block_ciphers.scm 343 */

BgL_auxz00_6379 = 
make_string(BgL_blockzd2siza7ez75_123, ((unsigned char)' ')); } 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1189z00_535))->BgL_bufferz00)=((obj_t)BgL_auxz00_6379),BUNSPEC); } 
{ 
obj_t BgL_auxz00_6382;
{ /* Llib/block_ciphers.scm 347 */

BgL_auxz00_6382 = 
make_string(BgL_blockzd2siza7ez75_123, ((unsigned char)' ')); } 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1189z00_535))->BgL_chainz00)=((obj_t)BgL_auxz00_6382),BUNSPEC); } 
return BgL_new1189z00_535;} } 

}



/* create-OFB-state */
BgL_ofbz00_bglt BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_138, obj_t BgL_paramz00_139, long BgL_blockzd2siza7ez75_140)
{
{ /* Llib/block_ciphers.scm 369 */
{ /* Llib/block_ciphers.scm 370 */
BgL_ofbz00_bglt BgL_new1194z00_542;
{ /* Llib/block_ciphers.scm 373 */
BgL_ofbz00_bglt BgL_new1193z00_545;
BgL_new1193z00_545 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 373 */
long BgL_arg1700z00_546;
BgL_arg1700z00_546 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1193z00_545), BgL_arg1700z00_546); } 
{ /* Llib/block_ciphers.scm 373 */
BgL_objectz00_bglt BgL_tmpz00_6389;
BgL_tmpz00_6389 = 
((BgL_objectz00_bglt)BgL_new1193z00_545); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6389, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1193z00_545); 
BgL_new1194z00_542 = BgL_new1193z00_545; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1194z00_542)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_140),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1194z00_542)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_138),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1194z00_542)))->BgL_paramz00)=((obj_t)BgL_paramz00_139),BUNSPEC); 
{ 
obj_t BgL_auxz00_6399;
{ /* Llib/block_ciphers.scm 374 */

BgL_auxz00_6399 = 
make_string(BgL_blockzd2siza7ez75_140, ((unsigned char)' ')); } 
((((BgL_ofbz00_bglt)COBJECT(BgL_new1194z00_542))->BgL_chainz00)=((obj_t)BgL_auxz00_6399),BUNSPEC); } 
return BgL_new1194z00_542;} } 

}



/* create-CTR-state */
BgL_ctrz00_bglt BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_encryptz00_155, obj_t BgL_paramz00_156, obj_t BgL_noncezd2initz12zc0_157, obj_t BgL_noncezd2updatez12zc0_158, long BgL_blockzd2siza7ez75_159)
{
{ /* Llib/block_ciphers.scm 394 */
{ /* Llib/block_ciphers.scm 397 */
BgL_ctrz00_bglt BgL_new1199z00_547;
{ /* Llib/block_ciphers.scm 405 */
BgL_ctrz00_bglt BgL_new1198z00_550;
BgL_new1198z00_550 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 405 */
long BgL_arg1701z00_551;
BgL_arg1701z00_551 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1198z00_550), BgL_arg1701z00_551); } 
{ /* Llib/block_ciphers.scm 405 */
BgL_objectz00_bglt BgL_tmpz00_6406;
BgL_tmpz00_6406 = 
((BgL_objectz00_bglt)BgL_new1198z00_550); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6406, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1198z00_550); 
BgL_new1199z00_547 = BgL_new1198z00_550; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1199z00_547)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7ez75_159),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1199z00_547)))->BgL_cipherz00)=((obj_t)BgL_encryptz00_155),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1199z00_547)))->BgL_paramz00)=((obj_t)BgL_paramz00_156),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1199z00_547))->BgL_noncez00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
obj_t BgL_auxz00_6417;
{ /* Llib/block_ciphers.scm 401 */

BgL_auxz00_6417 = 
make_string(BgL_blockzd2siza7ez75_159, ((unsigned char)' ')); } 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1199z00_547))->BgL_noncezd2strzd2)=((obj_t)BgL_auxz00_6417),BUNSPEC); } 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1199z00_547))->BgL_blockzd2counterzd2)=((long)((long)0)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1199z00_547))->BgL_noncezd2initz12zc0)=((obj_t)BgL_noncezd2initz12zc0_157),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1199z00_547))->BgL_noncezd2updatez12zc0)=((obj_t)BgL_noncezd2updatez12zc0_158),BUNSPEC); 
return BgL_new1199z00_547;} } 

}



/* encrypt-input! */
long BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt BgL_modezd2statezd2_174, obj_t BgL_fromz00_175, long BgL_fromzd2poszd2_176, obj_t BgL_readzd2atz12zc0_177, obj_t BgL_toz00_178, long BgL_tozd2poszd2_179, obj_t BgL_writezd2atz12zc0_180)
{
{ /* Llib/block_ciphers.scm 433 */
{ /* Llib/block_ciphers.scm 439 */
obj_t BgL_casezd2valuezd2_553;
BgL_casezd2valuezd2_553 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivzd2actionzd2); 
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)0))))
{ /* Llib/block_ciphers.scm 439 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00)); }  else 
{ /* Llib/block_ciphers.scm 439 */
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)1))))
{ /* Llib/block_ciphers.scm 439 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00)); 
{ /* Llib/block_ciphers.scm 443 */
obj_t BgL_arg1714z00_560;long BgL_arg1715z00_561;
BgL_arg1714z00_560 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivz00); 
BgL_arg1715z00_561 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_arg1714z00_560, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_tozd2poszd2_179), 
BINT(BgL_arg1715z00_561), BEOA); } 
BgL_tozd2poszd2_179 = 
(BgL_tozd2poszd2_179+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)); }  else 
{ /* Llib/block_ciphers.scm 439 */
if(
(BgL_casezd2valuezd2_553==
CNST_TABLE_REF(((long)2))))
{ /* Llib/block_ciphers.scm 439 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 439 */
BGl_errorz00zz__errorz00(BGl_string3188z00zz__cryptozd2blockzd2ciphersz00, BGl_string3189z00zz__cryptozd2blockzd2ciphersz00, 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_ivzd2actionzd2)); } } } } 
{ /* Llib/block_ciphers.scm 450 */
obj_t BgL_bufferz00_565;obj_t BgL_padz00_566;
BgL_bufferz00_565 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_loopzd2bufferzd2); 
BgL_padz00_566 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_padzf2unpadzf2); 
{ 
long BgL_iz00_568;
BgL_iz00_568 = ((long)0); 
BgL_zc3z04anonymousza31719ze3z87_569:
{ /* Llib/block_ciphers.scm 453 */
obj_t BgL_nbzd2copiedzd2_570;
{ /* Llib/block_ciphers.scm 453 */
long BgL_arg1781z00_595;long BgL_arg1782z00_596;
BgL_arg1781z00_595 = 
(BgL_fromzd2poszd2_176+BgL_iz00_568); 
BgL_arg1782z00_596 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
BgL_nbzd2copiedzd2_570 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_177)(BgL_readzd2atz12zc0_177, BgL_fromz00_175, BgL_arg1781z00_595, BgL_bufferz00_565, ((long)0), BgL_arg1782z00_596); } 
{ /* Llib/block_ciphers.scm 457 */
bool_t BgL_test3646z00_6469;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 457 */
if(
CBOOL(BgL_padz00_566))
{ /* Llib/block_ciphers.scm 457 */
BgL_test3646z00_6469 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 457 */
BgL_test3646z00_6469 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 457 */
BgL_test3646z00_6469 = ((bool_t)0)
; } 
if(BgL_test3646z00_6469)
{ /* Llib/block_ciphers.scm 457 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)==((long)0)))
{ /* Llib/block_ciphers.scm 458 */
return 
(BgL_iz00_568+BgL_tozd2poszd2_179);}  else 
{ /* Llib/block_ciphers.scm 458 */
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0), ((long)0), 
(long)CINT(BgL_nbzd2copiedzd2_570)); 
{ /* Llib/block_ciphers.scm 464 */
long BgL_arg1734z00_577;
BgL_arg1734z00_577 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1734z00_577), BgL_nbzd2copiedzd2_570, BEOA); } 
return 
(BgL_iz00_568+
(BgL_tozd2poszd2_179+
(long)CINT(BgL_nbzd2copiedzd2_570)));} }  else 
{ /* Llib/block_ciphers.scm 457 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_570)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 466 */
if(
CBOOL(
PROCEDURE_ENTRY(BgL_padz00_566)(BgL_padz00_566, BgL_bufferz00_565, BgL_nbzd2copiedzd2_570, BEOA)))
{ /* Llib/block_ciphers.scm 467 */
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0)); 
{ /* Llib/block_ciphers.scm 470 */
long BgL_arg1748z00_583;long BgL_arg1760z00_584;
BgL_arg1748z00_583 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
BgL_arg1760z00_584 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1748z00_583), 
BINT(BgL_arg1760z00_584), BEOA); } 
return 
(BgL_iz00_568+
(BgL_tozd2poszd2_179+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)));}  else 
{ /* Llib/block_ciphers.scm 467 */
return 
(BgL_iz00_568+BgL_tozd2poszd2_179);} }  else 
{ /* Llib/block_ciphers.scm 466 */
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_cipherzd2statezd2), BgL_bufferz00_565, ((long)0), BgL_bufferz00_565, ((long)0)); 
{ /* Llib/block_ciphers.scm 475 */
long BgL_arg1775z00_588;long BgL_arg1776z00_589;
BgL_arg1775z00_588 = 
(BgL_tozd2poszd2_179+BgL_iz00_568); 
BgL_arg1776z00_589 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_180)(BgL_writezd2atz12zc0_180, BgL_bufferz00_565, 
BINT(((long)0)), BgL_toz00_178, 
BINT(BgL_arg1775z00_588), 
BINT(BgL_arg1776z00_589), BEOA); } 
{ 
long BgL_iz00_6542;
BgL_iz00_6542 = 
(BgL_iz00_568+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_174))->BgL_blockzd2siza7ez75)); 
BgL_iz00_568 = BgL_iz00_6542; 
goto BgL_zc3z04anonymousza31719ze3z87_569;} } } } } } } } 

}



/* decrypt-input! */
long BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2modezd2statez00_bglt BgL_modezd2statezd2_181, obj_t BgL_fromz00_182, long BgL_fromzd2poszd2_183, obj_t BgL_readzd2atz12zc0_184, obj_t BgL_toz00_185, long BgL_tozd2poszd2_186, obj_t BgL_writezd2atz12zc0_187)
{
{ /* Llib/block_ciphers.scm 479 */
{ /* Llib/block_ciphers.scm 485 */
obj_t BgL_casezd2valuezd2_600;
BgL_casezd2valuezd2_600 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivzd2actionzd2); 
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)0))))
{ /* Llib/block_ciphers.scm 485 */
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivz00)); }  else 
{ /* Llib/block_ciphers.scm 485 */
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)4))))
{ /* Llib/block_ciphers.scm 488 */
obj_t BgL_nbzd2readzd2_605;
{ /* Llib/block_ciphers.scm 488 */
obj_t BgL_arg1793z00_612;long BgL_arg1794z00_613;
BgL_arg1793z00_612 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2); 
BgL_arg1794z00_613 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
BgL_nbzd2readzd2_605 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_184)(BgL_readzd2atz12zc0_184, BgL_fromz00_182, BgL_fromzd2poszd2_183, BgL_arg1793z00_612, ((long)0), BgL_arg1794z00_613); } 
if(
(
(long)CINT(BgL_nbzd2readzd2_605)==
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 489 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 489 */
BGl_errorz00zz__errorz00(BGl_string3190z00zz__cryptozd2blockzd2ciphersz00, BGl_string3191z00zz__cryptozd2blockzd2ciphersz00, BgL_nbzd2readzd2_605); } 
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2)); 
BgL_fromzd2poszd2_183 = 
(BgL_fromzd2poszd2_183+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)); }  else 
{ /* Llib/block_ciphers.scm 485 */
if(
(BgL_casezd2valuezd2_600==
CNST_TABLE_REF(((long)2))))
{ /* Llib/block_ciphers.scm 485 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 485 */
BGl_errorz00zz__errorz00(BGl_string3192z00zz__cryptozd2blockzd2ciphersz00, BGl_string3189z00zz__cryptozd2blockzd2ciphersz00, 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_ivzd2actionzd2)); } } } } 
{ /* Llib/block_ciphers.scm 504 */
obj_t BgL_bufferz00_616;obj_t BgL_unpadz00_617;obj_t BgL_lastzd2decryptedzd2_618;
BgL_bufferz00_616 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_loopzd2bufferzd2); 
BgL_unpadz00_617 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_padzf2unpadzf2); 
{ /* Llib/block_ciphers.scm 507 */
long BgL_arg1830z00_657;
BgL_arg1830z00_657 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 507 */

BgL_lastzd2decryptedzd2_618 = 
make_string(BgL_arg1830z00_657, ((unsigned char)' ')); } } 
{ 
long BgL_iz00_620;
{ /* Llib/block_ciphers.scm 508 */
obj_t BgL_tmpz00_6585;
BgL_iz00_620 = ((long)0); 
BgL_zc3z04anonymousza31797ze3z87_621:
{ /* Llib/block_ciphers.scm 509 */
obj_t BgL_nbzd2copiedzd2_622;
{ /* Llib/block_ciphers.scm 509 */
long BgL_arg1828z00_654;long BgL_arg1829z00_655;
BgL_arg1828z00_654 = 
(BgL_fromzd2poszd2_183+BgL_iz00_620); 
BgL_arg1829z00_655 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75); 
BgL_nbzd2copiedzd2_622 = 
PROCEDURE_L_ENTRY(BgL_readzd2atz12zc0_184)(BgL_readzd2atz12zc0_184, BgL_fromz00_182, BgL_arg1828z00_654, BgL_bufferz00_616, ((long)0), BgL_arg1829z00_655); } 
{ /* Llib/block_ciphers.scm 513 */
bool_t BgL_test3656z00_6596;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 513 */
if(
CBOOL(BgL_unpadz00_617))
{ /* Llib/block_ciphers.scm 513 */
BgL_test3656z00_6596 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 513 */
BgL_test3656z00_6596 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 513 */
BgL_test3656z00_6596 = ((bool_t)0)
; } 
if(BgL_test3656z00_6596)
{ /* Llib/block_ciphers.scm 513 */
BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(BgL_toz00_185, BgL_writezd2atz12zc0_187, BgL_modezd2statezd2_181, BgL_tozd2poszd2_186, BgL_lastzd2decryptedzd2_618, 
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 515 */
BgL_tmpz00_6585 = 
BINT(
(BgL_iz00_620+BgL_tozd2poszd2_186))
; }  else 
{ /* Llib/block_ciphers.scm 515 */
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), BgL_bufferz00_616, ((long)0), BgL_bufferz00_616, ((long)0), ((long)0), 
(long)CINT(BgL_nbzd2copiedzd2_622)); 
{ /* Llib/block_ciphers.scm 521 */
long BgL_arg1807z00_631;
BgL_arg1807z00_631 = 
(BgL_tozd2poszd2_186+BgL_iz00_620); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_187)(BgL_writezd2atz12zc0_187, BgL_bufferz00_616, 
BINT(((long)0)), BgL_toz00_185, 
BINT(BgL_arg1807z00_631), BgL_nbzd2copiedzd2_622, BEOA); } 
BgL_tmpz00_6585 = 
BINT(
(BgL_iz00_620+
(BgL_tozd2poszd2_186+
(long)CINT(BgL_nbzd2copiedzd2_622)))); } }  else 
{ /* Llib/block_ciphers.scm 513 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)<
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 525 */
bool_t BgL_test3661z00_6633;
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 525 */
BgL_test3661z00_6633 = 
(BgL_iz00_620==((long)0))
; }  else 
{ /* Llib/block_ciphers.scm 525 */
BgL_test3661z00_6633 = ((bool_t)0)
; } 
if(BgL_test3661z00_6633)
{ /* Llib/block_ciphers.scm 525 */
BgL_tmpz00_6585 = 
BINT(BgL_tozd2poszd2_186)
; }  else 
{ /* Llib/block_ciphers.scm 525 */
if(
(
(long)CINT(BgL_nbzd2copiedzd2_622)==((long)0)))
{ /* Llib/block_ciphers.scm 528 */
obj_t BgL_plainzd2charszd2_638;
BgL_plainzd2charszd2_638 = 
PROCEDURE_ENTRY(BgL_unpadz00_617)(BgL_unpadz00_617, BgL_lastzd2decryptedzd2_618, BEOA); 
{ /* Llib/block_ciphers.scm 530 */
long BgL_arg1815z00_639;
BgL_arg1815z00_639 = 
(BgL_tozd2poszd2_186+
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_187)(BgL_writezd2atz12zc0_187, BgL_lastzd2decryptedzd2_618, 
BINT(((long)0)), BgL_toz00_185, 
BINT(BgL_arg1815z00_639), BgL_plainzd2charszd2_638, BEOA); } 
BgL_tmpz00_6585 = 
BINT(
(
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))+
(BgL_tozd2poszd2_186+
(long)CINT(BgL_plainzd2charszd2_638)))); }  else 
{ /* Llib/block_ciphers.scm 527 */
BgL_tmpz00_6585 = 
BGl_errorz00zz__errorz00(BGl_string3193z00zz__cryptozd2blockzd2ciphersz00, BGl_string3194z00zz__cryptozd2blockzd2ciphersz00, BgL_nbzd2copiedzd2_622)
; } } }  else 
{ /* Llib/block_ciphers.scm 523 */
BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(BgL_toz00_185, BgL_writezd2atz12zc0_187, BgL_modezd2statezd2_181, BgL_tozd2poszd2_186, BgL_lastzd2decryptedzd2_618, 
(BgL_iz00_620-
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75))); 
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_cipherzd2statezd2), BgL_bufferz00_616, ((long)0), BgL_lastzd2decryptedzd2_618, ((long)0)); 
{ 
long BgL_iz00_6671;
BgL_iz00_6671 = 
(BgL_iz00_620+
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_modezd2statezd2_181))->BgL_blockzd2siza7ez75)); 
BgL_iz00_620 = BgL_iz00_6671; 
goto BgL_zc3z04anonymousza31797ze3z87_621;} } } } } 
return 
(long)CINT(BgL_tmpz00_6585);} } } } 

}



/* write-last-decrypted!~0 */
obj_t BGl_writezd2lastzd2decryptedz12ze70zf5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_toz00_5101, obj_t BgL_writezd2atz12zc0_5100, BgL_cipherzd2modezd2statez00_bglt BgL_i1204z00_5099, long BgL_tozd2poszd2_5098, obj_t BgL_lastzd2decryptedzd2_660, long BgL_iz00_661)
{
{ /* Llib/block_ciphers.scm 502 */
if(
(BgL_iz00_661<((long)0)))
{ /* Llib/block_ciphers.scm 501 */
return BFALSE;}  else 
{ /* Llib/block_ciphers.scm 502 */
long BgL_arg1833z00_664;long BgL_arg1834z00_665;
BgL_arg1833z00_664 = 
(BgL_tozd2poszd2_5098+BgL_iz00_661); 
BgL_arg1834z00_665 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_i1204z00_5099))->BgL_blockzd2siza7ez75); 
return 
PROCEDURE_ENTRY(BgL_writezd2atz12zc0_5100)(BgL_writezd2atz12zc0_5100, BgL_lastzd2decryptedzd2_660, 
BINT(((long)0)), BgL_toz00_5101, 
BINT(BgL_arg1833z00_664), 
BINT(BgL_arg1834z00_665), BEOA);} } 

}



/* create-encryption-state */
BgL_cipherzd2modezd2statez00_bglt BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_188, obj_t BgL_passwordz00_189, obj_t BgL_ivz00_190, obj_t BgL_modez00_191, obj_t BgL_padz00_192, obj_t BgL_noncezd2initz12zc0_193, obj_t BgL_noncezd2updatez12zc0_194, obj_t BgL_stringzd2ze3keyz31_195)
{
{ /* Llib/block_ciphers.scm 594 */
{ /* Llib/block_ciphers.scm 597 */
BgL_blockzd2cipherzd2_bglt BgL_i1205z00_667;
BgL_i1205z00_667 = 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_188); 
{ 
obj_t BgL_modez00_719;obj_t BgL_paramz00_720;long BgL_bsz00_721;
{ /* Llib/block_ciphers.scm 615 */
obj_t BgL_keyz00_669;
if(
CBOOL(BgL_stringzd2ze3keyz31_195))
{ /* Llib/block_ciphers.scm 615 */
BgL_keyz00_669 = 
PROCEDURE_ENTRY(BgL_stringzd2ze3keyz31_195)(BgL_stringzd2ze3keyz31_195, BgL_passwordz00_189, BEOA); }  else 
{ /* Llib/block_ciphers.scm 615 */
BgL_keyz00_669 = 
BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(BgL_passwordz00_189, 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_preferredzd2keyzd2lengthz00), BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2); } 
{ /* Llib/block_ciphers.scm 615 */
obj_t BgL_padzd2proczd2_670;
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL_test3666z00_6699;
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL__ortest_1208z00_716;
BgL__ortest_1208z00_716 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)5))); 
if(BgL__ortest_1208z00_716)
{ /* Llib/block_ciphers.scm 619 */
BgL_test3666z00_6699 = BgL__ortest_1208z00_716
; }  else 
{ /* Llib/block_ciphers.scm 619 */
bool_t BgL__ortest_1209z00_717;
BgL__ortest_1209z00_717 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)7))); 
if(BgL__ortest_1209z00_717)
{ /* Llib/block_ciphers.scm 619 */
BgL_test3666z00_6699 = BgL__ortest_1209z00_717
; }  else 
{ /* Llib/block_ciphers.scm 619 */
BgL_test3666z00_6699 = 
(BgL_modez00_191==
CNST_TABLE_REF(((long)8)))
; } } } 
if(BgL_test3666z00_6699)
{ /* Llib/block_ciphers.scm 619 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)11))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_nozd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)12))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_bitzd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)13))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_ansizd2xze2923zd2padzd2envz30zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)14))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_isozd210126zd2padzd2envzd2zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)15))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_pkcs7zd2padzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
(BgL_padz00_192==
CNST_TABLE_REF(((long)16))))
{ /* Llib/block_ciphers.scm 621 */
BgL_padzd2proczd2_670 = BGl_za7erozd2padzd2envza7zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 621 */
if(
PROCEDUREP(BgL_padz00_192))
{ /* Llib/block_ciphers.scm 628 */
BgL_padzd2proczd2_670 = BgL_padz00_192; }  else 
{ /* Llib/block_ciphers.scm 628 */
BgL_padzd2proczd2_670 = 
BGl_errorz00zz__errorz00(BGl_string3195z00zz__cryptozd2blockzd2ciphersz00, BGl_string3197z00zz__cryptozd2blockzd2ciphersz00, BgL_padz00_192); } } } } } } } }  else 
{ /* Llib/block_ciphers.scm 619 */
BgL_padzd2proczd2_670 = BFALSE; } } 
{ /* Llib/block_ciphers.scm 619 */
obj_t BgL_encryptionzd2ivzd2_671;
if(
CBOOL(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 634 */
BgL_encryptionzd2ivzd2_671 = BgL_ivz00_190; }  else 
{ /* Llib/block_ciphers.scm 634 */
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 635 */
BgL_encryptionzd2ivzd2_671 = BFALSE; }  else 
{ /* Llib/block_ciphers.scm 635 */
BgL_encryptionzd2ivzd2_671 = 
BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_blockzd2siza7ez75), BFALSE); } } 
{ /* Llib/block_ciphers.scm 634 */
obj_t BgL_paramz00_672;
{ /* Llib/block_ciphers.scm 639 */
obj_t BgL_fun1853z00_698;
BgL_fun1853z00_698 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_keyzd2ze3encryptzd2paramze3); 
BgL_paramz00_672 = 
PROCEDURE_ENTRY(BgL_fun1853z00_698)(BgL_fun1853z00_698, BgL_keyz00_669, BEOA); } 
{ /* Llib/block_ciphers.scm 639 */
obj_t BgL_statez00_673;
BgL_modez00_719 = BgL_modez00_191; 
BgL_paramz00_720 = BgL_paramz00_672; 
BgL_bsz00_721 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_blockzd2siza7ez75); 
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 602 */
obj_t BgL_arg1867z00_725;
BgL_arg1867z00_725 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1867z00_725, BgL_paramz00_720, BgL_bsz00_721, ((bool_t)1))); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)6))))
{ /* Llib/block_ciphers.scm 603 */
obj_t BgL_arg1869z00_727;
BgL_arg1869z00_727 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CFBzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1869z00_727, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)7))))
{ /* Llib/block_ciphers.scm 604 */
obj_t BgL_arg1871z00_729;
BgL_arg1871z00_729 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1871z00_729, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)8))))
{ /* Llib/block_ciphers.scm 605 */
obj_t BgL_arg1873z00_731;
BgL_arg1873z00_731 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2PCBCzd2encryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1873z00_731, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 606 */
obj_t BgL_arg1875z00_733;
BgL_arg1875z00_733 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1875z00_733, BgL_paramz00_720, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
if(
(BgL_modez00_719==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 607 */
obj_t BgL_arg1877z00_735;obj_t BgL_arg1878z00_736;obj_t BgL_arg1879z00_737;
BgL_arg1877z00_735 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_encryptz12z12); 
if(
CBOOL(BgL_noncezd2initz12zc0_193))
{ /* Llib/block_ciphers.scm 608 */
BgL_arg1878z00_736 = BgL_noncezd2initz12zc0_193; }  else 
{ /* Llib/block_ciphers.scm 608 */
BgL_arg1878z00_736 = BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
if(
CBOOL(BgL_noncezd2updatez12zc0_194))
{ /* Llib/block_ciphers.scm 609 */
BgL_arg1879z00_737 = BgL_noncezd2updatez12zc0_194; }  else 
{ /* Llib/block_ciphers.scm 609 */
BgL_arg1879z00_737 = BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
BgL_statez00_673 = 
((obj_t)
BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1877z00_735, BgL_paramz00_720, BgL_arg1878z00_736, BgL_arg1879z00_737, BgL_bsz00_721)); }  else 
{ /* Llib/block_ciphers.scm 601 */
BgL_statez00_673 = 
BGl_errorz00zz__errorz00(BGl_string3195z00zz__cryptozd2blockzd2ciphersz00, BGl_string3196z00zz__cryptozd2blockzd2ciphersz00, BgL_modez00_719); } } } } } } 
{ /* Llib/block_ciphers.scm 640 */

if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 642 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 642 */
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 643 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 645 */
bool_t BgL_test3688z00_6791;
if(
STRINGP(BgL_encryptionzd2ivzd2_671))
{ /* Llib/block_ciphers.scm 645 */
if(
(
STRING_LENGTH(BgL_encryptionzd2ivzd2_671)>=
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 646 */
BgL_test3688z00_6791 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 646 */
BgL_test3688z00_6791 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 645 */
BgL_test3688z00_6791 = ((bool_t)1)
; } 
if(BgL_test3688z00_6791)
{ /* Llib/block_ciphers.scm 649 */
obj_t BgL_arg1844z00_683;
if(
STRINGP(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 649 */
BgL_arg1844z00_683 = 
BINT(
STRING_LENGTH(BgL_ivz00_190)); }  else 
{ /* Llib/block_ciphers.scm 649 */
BgL_arg1844z00_683 = BgL_ivz00_190; } 
BGl_errorz00zz__errorz00(BGl_string3198z00zz__cryptozd2blockzd2ciphersz00, BGl_string3199z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1844z00_683); }  else 
{ /* Llib/block_ciphers.scm 645 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 652 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1212z00_689;
{ /* Llib/block_ciphers.scm 653 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1211z00_695;
BgL_new1211z00_695 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 653 */
long BgL_arg1851z00_696;
BgL_arg1851z00_696 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_695), BgL_arg1851z00_696); } 
{ /* Llib/block_ciphers.scm 653 */
BgL_objectz00_bglt BgL_tmpz00_6807;
BgL_tmpz00_6807 = 
((BgL_objectz00_bglt)BgL_new1211z00_695); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6807, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1211z00_695); 
BgL_new1212z00_689 = BgL_new1211z00_695; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_encryptzf3zf3)=((bool_t)((bool_t)1)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_blockzd2siza7ez75)=((long)
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_blockzd2siza7ez75)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_673)),BUNSPEC); 
{ 
obj_t BgL_auxz00_6816;
if(
(BgL_modez00_191==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 657 */
BgL_auxz00_6816 = 
CNST_TABLE_REF(((long)2))
; }  else 
{ /* Llib/block_ciphers.scm 658 */
bool_t BgL_test3693z00_6821;
if(
CBOOL(BgL_ivz00_190))
{ /* Llib/block_ciphers.scm 658 */
BgL_test3693z00_6821 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 658 */
BgL_test3693z00_6821 = 
CBOOL(BgL_encryptionzd2ivzd2_671)
; } 
if(BgL_test3693z00_6821)
{ /* Llib/block_ciphers.scm 658 */
BgL_auxz00_6816 = 
CNST_TABLE_REF(((long)1))
; }  else 
{ /* Llib/block_ciphers.scm 658 */
BgL_auxz00_6816 = 
CNST_TABLE_REF(((long)0))
; } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_ivzd2actionzd2)=((obj_t)BgL_auxz00_6816),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_ivz00)=((obj_t)BgL_encryptionzd2ivzd2_671),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_padzf2unpadzf2)=((obj_t)BgL_padzd2proczd2_670),BUNSPEC); 
{ 
obj_t BgL_auxz00_6830;
{ /* Llib/block_ciphers.scm 662 */
long BgL_arg1850z00_692;
BgL_arg1850z00_692 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1205z00_667))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 662 */

BgL_auxz00_6830 = 
make_string(BgL_arg1850z00_692, ((unsigned char)' ')); } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_loopzd2bufferzd2)=((obj_t)BgL_auxz00_6830),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1212z00_689))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
return BgL_new1212z00_689;} } } } } } } } } } 

}



/* create-decryption-state */
BgL_cipherzd2modezd2statez00_bglt BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_196, obj_t BgL_passwordz00_197, obj_t BgL_ivz00_198, obj_t BgL_modez00_199, obj_t BgL_padz00_200, obj_t BgL_noncezd2initz12zc0_201, obj_t BgL_noncezd2updatez12zc0_202, obj_t BgL_stringzd2ze3keyz31_203)
{
{ /* Llib/block_ciphers.scm 664 */
{ /* Llib/block_ciphers.scm 667 */
BgL_blockzd2cipherzd2_bglt BgL_i1213z00_741;
BgL_i1213z00_741 = 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_196); 
{ 
obj_t BgL_modez00_795;obj_t BgL_paramz00_796;long BgL_bsz00_797;
{ /* Llib/block_ciphers.scm 686 */
obj_t BgL_keyz00_743;
if(
CBOOL(BgL_stringzd2ze3keyz31_203))
{ /* Llib/block_ciphers.scm 686 */
BgL_keyz00_743 = 
PROCEDURE_ENTRY(BgL_stringzd2ze3keyz31_203)(BgL_stringzd2ze3keyz31_203, BgL_passwordz00_197, BEOA); }  else 
{ /* Llib/block_ciphers.scm 686 */
BgL_keyz00_743 = 
BGl_stringzd2ze3keyzd2hashze3zz__cryptozd2string2keyzd2(BgL_passwordz00_197, 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_preferredzd2keyzd2lengthz00), BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2); } 
{ /* Llib/block_ciphers.scm 686 */
obj_t BgL_unpadzd2proczd2_744;
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL_test3696z00_6844;
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL__ortest_1216z00_792;
BgL__ortest_1216z00_792 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)5))); 
if(BgL__ortest_1216z00_792)
{ /* Llib/block_ciphers.scm 690 */
BgL_test3696z00_6844 = BgL__ortest_1216z00_792
; }  else 
{ /* Llib/block_ciphers.scm 690 */
bool_t BgL__ortest_1217z00_793;
BgL__ortest_1217z00_793 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)7))); 
if(BgL__ortest_1217z00_793)
{ /* Llib/block_ciphers.scm 690 */
BgL_test3696z00_6844 = BgL__ortest_1217z00_793
; }  else 
{ /* Llib/block_ciphers.scm 690 */
BgL_test3696z00_6844 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)8)))
; } } } 
if(BgL_test3696z00_6844)
{ /* Llib/block_ciphers.scm 690 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)11))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_nozd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)12))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_bitzd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL_test3701z00_6859;
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL__ortest_1218z00_790;
BgL__ortest_1218z00_790 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)13))); 
if(BgL__ortest_1218z00_790)
{ /* Llib/block_ciphers.scm 692 */
BgL_test3701z00_6859 = BgL__ortest_1218z00_790
; }  else 
{ /* Llib/block_ciphers.scm 692 */
bool_t BgL__ortest_1219z00_791;
BgL__ortest_1219z00_791 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)14))); 
if(BgL__ortest_1219z00_791)
{ /* Llib/block_ciphers.scm 692 */
BgL_test3701z00_6859 = BgL__ortest_1219z00_791
; }  else 
{ /* Llib/block_ciphers.scm 692 */
BgL_test3701z00_6859 = 
(BgL_padz00_200==
CNST_TABLE_REF(((long)15)))
; } } } 
if(BgL_test3701z00_6859)
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_bytezd2unpadzd2envz00zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
(BgL_padz00_200==
CNST_TABLE_REF(((long)16))))
{ /* Llib/block_ciphers.scm 692 */
BgL_unpadzd2proczd2_744 = BGl_za7erozd2unpadzd2envza7zz__cryptozd2cipherzd2paddingz00; }  else 
{ /* Llib/block_ciphers.scm 692 */
if(
PROCEDUREP(BgL_padz00_200))
{ /* Llib/block_ciphers.scm 698 */
BgL_unpadzd2proczd2_744 = BgL_padz00_200; }  else 
{ /* Llib/block_ciphers.scm 698 */
BgL_unpadzd2proczd2_744 = 
BGl_errorz00zz__errorz00(BGl_string3193z00zz__cryptozd2blockzd2ciphersz00, BGl_string3197z00zz__cryptozd2blockzd2ciphersz00, BgL_padz00_200); } } } } } }  else 
{ /* Llib/block_ciphers.scm 690 */
BgL_unpadzd2proczd2_744 = BFALSE; } } 
{ /* Llib/block_ciphers.scm 690 */
obj_t BgL_paramz00_745;
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL_test3706z00_6874;
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL__ortest_1220z00_776;
BgL__ortest_1220z00_776 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)5))); 
if(BgL__ortest_1220z00_776)
{ /* Llib/block_ciphers.scm 704 */
BgL_test3706z00_6874 = BgL__ortest_1220z00_776
; }  else 
{ /* Llib/block_ciphers.scm 704 */
bool_t BgL__ortest_1221z00_777;
BgL__ortest_1221z00_777 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)7))); 
if(BgL__ortest_1221z00_777)
{ /* Llib/block_ciphers.scm 704 */
BgL_test3706z00_6874 = BgL__ortest_1221z00_777
; }  else 
{ /* Llib/block_ciphers.scm 704 */
BgL_test3706z00_6874 = 
(BgL_modez00_199==
CNST_TABLE_REF(((long)8)))
; } } } 
if(BgL_test3706z00_6874)
{ /* Llib/block_ciphers.scm 705 */
obj_t BgL_fun1898z00_774;
BgL_fun1898z00_774 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_keyzd2ze3decryptzd2paramze3); 
BgL_paramz00_745 = 
PROCEDURE_ENTRY(BgL_fun1898z00_774)(BgL_fun1898z00_774, BgL_keyz00_743, BEOA); }  else 
{ /* Llib/block_ciphers.scm 706 */
obj_t BgL_fun1899z00_775;
BgL_fun1899z00_775 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_keyzd2ze3encryptzd2paramze3); 
BgL_paramz00_745 = 
PROCEDURE_ENTRY(BgL_fun1899z00_775)(BgL_fun1899z00_775, BgL_keyz00_743, BEOA); } } 
{ /* Llib/block_ciphers.scm 704 */
obj_t BgL_statez00_746;
BgL_modez00_795 = BgL_modez00_199; 
BgL_paramz00_796 = BgL_paramz00_745; 
BgL_bsz00_797 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_blockzd2siza7ez75); 
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 673 */
obj_t BgL_arg1909z00_801;
BgL_arg1909z00_801 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2ECBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1909z00_801, BgL_paramz00_796, BgL_bsz00_797, ((bool_t)0))); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)7))))
{ /* Llib/block_ciphers.scm 674 */
obj_t BgL_arg1911z00_803;
BgL_arg1911z00_803 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1911z00_803, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)8))))
{ /* Llib/block_ciphers.scm 675 */
obj_t BgL_arg1913z00_805;
BgL_arg1913z00_805 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_decryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2PCBCzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1913z00_805, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)6))))
{ /* Llib/block_ciphers.scm 676 */
obj_t BgL_arg1915z00_807;
BgL_arg1915z00_807 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_encryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CFBzd2decryptionzd2statezd2zz__cryptozd2blockzd2ciphersz00(BgL_arg1915z00_807, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)9))))
{ /* Llib/block_ciphers.scm 677 */
obj_t BgL_arg1917z00_809;
BgL_arg1917z00_809 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_encryptz12z12); 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2OFBzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1917z00_809, BgL_paramz00_796, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
if(
(BgL_modez00_795==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 678 */
obj_t BgL_arg1919z00_811;obj_t BgL_arg1920z00_812;obj_t BgL_arg1921z00_813;
BgL_arg1919z00_811 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_encryptz12z12); 
if(
CBOOL(BgL_noncezd2initz12zc0_201))
{ /* Llib/block_ciphers.scm 679 */
BgL_arg1920z00_812 = BgL_noncezd2initz12zc0_201; }  else 
{ /* Llib/block_ciphers.scm 679 */
BgL_arg1920z00_812 = BGl_defaultzd2noncezd2initz12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
if(
CBOOL(BgL_noncezd2updatez12zc0_202))
{ /* Llib/block_ciphers.scm 680 */
BgL_arg1921z00_813 = BgL_noncezd2updatez12zc0_202; }  else 
{ /* Llib/block_ciphers.scm 680 */
BgL_arg1921z00_813 = BGl_defaultzd2noncezd2updatez12zd2envzc0zz__cryptozd2blockzd2ciphersz00; } 
BgL_statez00_746 = 
((obj_t)
BGl_createzd2CTRzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_arg1919z00_811, BgL_paramz00_796, BgL_arg1920z00_812, BgL_arg1921z00_813, BgL_bsz00_797)); }  else 
{ /* Llib/block_ciphers.scm 672 */
BgL_statez00_746 = 
BGl_errorz00zz__errorz00(BGl_string3193z00zz__cryptozd2blockzd2ciphersz00, BGl_string3196z00zz__cryptozd2blockzd2ciphersz00, BgL_modez00_795); } } } } } } 
{ /* Llib/block_ciphers.scm 707 */

if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 709 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 709 */
if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)10))))
{ /* Llib/block_ciphers.scm 710 */
CNST_TABLE_REF(((long)3)); }  else 
{ /* Llib/block_ciphers.scm 710 */
if(
CBOOL(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 713 */
bool_t BgL_test3720z00_6945;
if(
STRINGP(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 713 */
if(
(
STRING_LENGTH(BgL_ivz00_198)>=
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_blockzd2siza7ez75)))
{ /* Llib/block_ciphers.scm 714 */
BgL_test3720z00_6945 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 714 */
BgL_test3720z00_6945 = ((bool_t)1)
; } }  else 
{ /* Llib/block_ciphers.scm 713 */
BgL_test3720z00_6945 = ((bool_t)1)
; } 
if(BgL_test3720z00_6945)
{ /* Llib/block_ciphers.scm 717 */
obj_t BgL_arg1889z00_756;
if(
STRINGP(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 717 */
BgL_arg1889z00_756 = 
BINT(
STRING_LENGTH(BgL_ivz00_198)); }  else 
{ /* Llib/block_ciphers.scm 717 */
BgL_arg1889z00_756 = BgL_ivz00_198; } 
BGl_errorz00zz__errorz00(BGl_string3198z00zz__cryptozd2blockzd2ciphersz00, BGl_string3199z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1889z00_756); }  else 
{ /* Llib/block_ciphers.scm 713 */BFALSE; } }  else 
{ /* Llib/block_ciphers.scm 711 */
CNST_TABLE_REF(((long)3)); } } } 
{ /* Llib/block_ciphers.scm 720 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1223z00_762;
{ /* Llib/block_ciphers.scm 721 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1222z00_767;
BgL_new1222z00_767 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 721 */
long BgL_arg1895z00_768;
BgL_arg1895z00_768 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1222z00_767), BgL_arg1895z00_768); } 
{ /* Llib/block_ciphers.scm 721 */
BgL_objectz00_bglt BgL_tmpz00_6962;
BgL_tmpz00_6962 = 
((BgL_objectz00_bglt)BgL_new1222z00_767); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_6962, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1222z00_767); 
BgL_new1223z00_762 = BgL_new1222z00_767; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_encryptzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_blockzd2siza7ez75)=((long)
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_blockzd2siza7ez75)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_746)),BUNSPEC); 
{ 
obj_t BgL_auxz00_6971;
if(
(BgL_modez00_199==
CNST_TABLE_REF(((long)5))))
{ /* Llib/block_ciphers.scm 725 */
BgL_auxz00_6971 = 
CNST_TABLE_REF(((long)2))
; }  else 
{ /* Llib/block_ciphers.scm 725 */
if(
CBOOL(BgL_ivz00_198))
{ /* Llib/block_ciphers.scm 726 */
BgL_auxz00_6971 = 
CNST_TABLE_REF(((long)0))
; }  else 
{ /* Llib/block_ciphers.scm 726 */
BgL_auxz00_6971 = 
CNST_TABLE_REF(((long)4))
; } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_ivzd2actionzd2)=((obj_t)BgL_auxz00_6971),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_ivz00)=((obj_t)BgL_ivz00_198),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_padzf2unpadzf2)=((obj_t)BgL_unpadzd2proczd2_744),BUNSPEC); 
{ 
obj_t BgL_auxz00_6983;
{ /* Llib/block_ciphers.scm 730 */
long BgL_arg1894z00_764;
BgL_arg1894z00_764 = 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_i1213z00_741))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 730 */

BgL_auxz00_6983 = 
make_string(BgL_arg1894z00_764, ((unsigned char)' ')); } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_loopzd2bufferzd2)=((obj_t)BgL_auxz00_6983),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1223z00_762))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
return BgL_new1223z00_762;} } } } } } } } } 

}



/* _encrypt */
obj_t BGl__encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1359z00_214, obj_t BgL_opt1358z00_213)
{
{ /* Llib/block_ciphers.scm 736 */
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_cipherz00_821;obj_t BgL_plainz00_822;obj_t BgL_passwordz00_823;
BgL_cipherz00_821 = 
VECTOR_REF(BgL_opt1358z00_213,((long)0)); 
BgL_plainz00_822 = 
VECTOR_REF(BgL_opt1358z00_213,((long)1)); 
BgL_passwordz00_823 = 
VECTOR_REF(BgL_opt1358z00_213,((long)2)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_ivz00_824;
BgL_ivz00_824 = BFALSE; 
{ /* Llib/block_ciphers.scm 737 */
obj_t BgL_modez00_825;
BgL_modez00_825 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2initz12zc0_826;
BgL_noncezd2initz12zc0_826 = BFALSE; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2updatez12zc0_827;
BgL_noncezd2updatez12zc0_827 = BFALSE; 
{ /* Llib/block_ciphers.scm 737 */
obj_t BgL_padz00_828;
BgL_padz00_828 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_stringzd2ze3keyz31_829;
BgL_stringzd2ze3keyz31_829 = BFALSE; 
{ /* Llib/block_ciphers.scm 736 */

{ 
long BgL_iz00_830;
BgL_iz00_830 = ((long)3); 
BgL_check1362z00_831:
if(
(BgL_iz00_830==
VECTOR_LENGTH(BgL_opt1358z00_213)))
{ /* Llib/block_ciphers.scm 736 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3727z00_6996;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1927z00_837;
BgL_arg1927z00_837 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_iz00_830); 
BgL_test3727z00_6996 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1927z00_837, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3727z00_6996)
{ 
long BgL_iz00_7001;
BgL_iz00_7001 = 
(BgL_iz00_830+((long)2)); 
BgL_iz00_830 = BgL_iz00_7001; 
goto BgL_check1362z00_831;}  else 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1926z00_836;
BgL_arg1926z00_836 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_iz00_830); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1926z00_836); } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1364z00_838;
BgL_index1364z00_838 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3728z00_7009;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2856;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7010;
if(
INTEGERP(BgL_index1364z00_838))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7010 = BgL_index1364z00_838
; }  else 
{ 
obj_t BgL_auxz00_7013;
BgL_auxz00_7013 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1364z00_838); 
FAILURE(BgL_auxz00_7013,BFALSE,BFALSE);} 
BgL_n1z00_2856 = 
(long)CINT(BgL_tmpz00_7010); } 
BgL_test3728z00_7009 = 
(BgL_n1z00_2856>=((long)0)); } 
if(BgL_test3728z00_7009)
{ 
long BgL_auxz00_7019;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7020;
if(
INTEGERP(BgL_index1364z00_838))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7020 = BgL_index1364z00_838
; }  else 
{ 
obj_t BgL_auxz00_7023;
BgL_auxz00_7023 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1364z00_838); 
FAILURE(BgL_auxz00_7023,BFALSE,BFALSE);} 
BgL_auxz00_7019 = 
(long)CINT(BgL_tmpz00_7020); } 
BgL_ivz00_824 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7019); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1365z00_840;
BgL_index1365z00_840 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3731z00_7032;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2857;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7033;
if(
INTEGERP(BgL_index1365z00_840))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7033 = BgL_index1365z00_840
; }  else 
{ 
obj_t BgL_auxz00_7036;
BgL_auxz00_7036 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1365z00_840); 
FAILURE(BgL_auxz00_7036,BFALSE,BFALSE);} 
BgL_n1z00_2857 = 
(long)CINT(BgL_tmpz00_7033); } 
BgL_test3731z00_7032 = 
(BgL_n1z00_2857>=((long)0)); } 
if(BgL_test3731z00_7032)
{ 
long BgL_auxz00_7042;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7043;
if(
INTEGERP(BgL_index1365z00_840))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7043 = BgL_index1365z00_840
; }  else 
{ 
obj_t BgL_auxz00_7046;
BgL_auxz00_7046 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1365z00_840); 
FAILURE(BgL_auxz00_7046,BFALSE,BFALSE);} 
BgL_auxz00_7042 = 
(long)CINT(BgL_tmpz00_7043); } 
BgL_modez00_825 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7042); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1366z00_842;
BgL_index1366z00_842 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3734z00_7055;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2858;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7056;
if(
INTEGERP(BgL_index1366z00_842))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7056 = BgL_index1366z00_842
; }  else 
{ 
obj_t BgL_auxz00_7059;
BgL_auxz00_7059 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1366z00_842); 
FAILURE(BgL_auxz00_7059,BFALSE,BFALSE);} 
BgL_n1z00_2858 = 
(long)CINT(BgL_tmpz00_7056); } 
BgL_test3734z00_7055 = 
(BgL_n1z00_2858>=((long)0)); } 
if(BgL_test3734z00_7055)
{ 
long BgL_auxz00_7065;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7066;
if(
INTEGERP(BgL_index1366z00_842))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7066 = BgL_index1366z00_842
; }  else 
{ 
obj_t BgL_auxz00_7069;
BgL_auxz00_7069 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1366z00_842); 
FAILURE(BgL_auxz00_7069,BFALSE,BFALSE);} 
BgL_auxz00_7065 = 
(long)CINT(BgL_tmpz00_7066); } 
BgL_noncezd2initz12zc0_826 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7065); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1367z00_844;
BgL_index1367z00_844 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3737z00_7078;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2859;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7079;
if(
INTEGERP(BgL_index1367z00_844))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7079 = BgL_index1367z00_844
; }  else 
{ 
obj_t BgL_auxz00_7082;
BgL_auxz00_7082 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1367z00_844); 
FAILURE(BgL_auxz00_7082,BFALSE,BFALSE);} 
BgL_n1z00_2859 = 
(long)CINT(BgL_tmpz00_7079); } 
BgL_test3737z00_7078 = 
(BgL_n1z00_2859>=((long)0)); } 
if(BgL_test3737z00_7078)
{ 
long BgL_auxz00_7088;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7089;
if(
INTEGERP(BgL_index1367z00_844))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7089 = BgL_index1367z00_844
; }  else 
{ 
obj_t BgL_auxz00_7092;
BgL_auxz00_7092 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1367z00_844); 
FAILURE(BgL_auxz00_7092,BFALSE,BFALSE);} 
BgL_auxz00_7088 = 
(long)CINT(BgL_tmpz00_7089); } 
BgL_noncezd2updatez12zc0_827 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7088); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1368z00_846;
BgL_index1368z00_846 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3740z00_7101;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2860;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7102;
if(
INTEGERP(BgL_index1368z00_846))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7102 = BgL_index1368z00_846
; }  else 
{ 
obj_t BgL_auxz00_7105;
BgL_auxz00_7105 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1368z00_846); 
FAILURE(BgL_auxz00_7105,BFALSE,BFALSE);} 
BgL_n1z00_2860 = 
(long)CINT(BgL_tmpz00_7102); } 
BgL_test3740z00_7101 = 
(BgL_n1z00_2860>=((long)0)); } 
if(BgL_test3740z00_7101)
{ 
long BgL_auxz00_7111;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7112;
if(
INTEGERP(BgL_index1368z00_846))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7112 = BgL_index1368z00_846
; }  else 
{ 
obj_t BgL_auxz00_7115;
BgL_auxz00_7115 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1368z00_846); 
FAILURE(BgL_auxz00_7115,BFALSE,BFALSE);} 
BgL_auxz00_7111 = 
(long)CINT(BgL_tmpz00_7112); } 
BgL_padz00_828 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7111); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_index1369z00_848;
BgL_index1369z00_848 = 
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1358z00_213), BgL_opt1358z00_213, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 736 */
bool_t BgL_test3743z00_7124;
{ /* Llib/block_ciphers.scm 736 */
long BgL_n1z00_2861;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7125;
if(
INTEGERP(BgL_index1369z00_848))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7125 = BgL_index1369z00_848
; }  else 
{ 
obj_t BgL_auxz00_7128;
BgL_auxz00_7128 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1369z00_848); 
FAILURE(BgL_auxz00_7128,BFALSE,BFALSE);} 
BgL_n1z00_2861 = 
(long)CINT(BgL_tmpz00_7125); } 
BgL_test3743z00_7124 = 
(BgL_n1z00_2861>=((long)0)); } 
if(BgL_test3743z00_7124)
{ 
long BgL_auxz00_7134;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_tmpz00_7135;
if(
INTEGERP(BgL_index1369z00_848))
{ /* Llib/block_ciphers.scm 736 */
BgL_tmpz00_7135 = BgL_index1369z00_848
; }  else 
{ 
obj_t BgL_auxz00_7138;
BgL_auxz00_7138 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1369z00_848); 
FAILURE(BgL_auxz00_7138,BFALSE,BFALSE);} 
BgL_auxz00_7134 = 
(long)CINT(BgL_tmpz00_7135); } 
BgL_stringzd2ze3keyz31_829 = 
VECTOR_REF(BgL_opt1358z00_213,BgL_auxz00_7134); }  else 
{ /* Llib/block_ciphers.scm 736 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_arg1934z00_850;obj_t BgL_arg1935z00_851;obj_t BgL_arg1936z00_852;
BgL_arg1934z00_850 = 
VECTOR_REF(BgL_opt1358z00_213,((long)0)); 
BgL_arg1935z00_851 = 
VECTOR_REF(BgL_opt1358z00_213,((long)1)); 
BgL_arg1936z00_852 = 
VECTOR_REF(BgL_opt1358z00_213,((long)2)); 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_ivz00_853;
BgL_ivz00_853 = BgL_ivz00_824; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_modez00_854;
BgL_modez00_854 = BgL_modez00_825; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2initz12zc0_855;
BgL_noncezd2initz12zc0_855 = BgL_noncezd2initz12zc0_826; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_noncezd2updatez12zc0_856;
BgL_noncezd2updatez12zc0_856 = BgL_noncezd2updatez12zc0_827; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_padz00_857;
BgL_padz00_857 = BgL_padz00_828; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_stringzd2ze3keyz31_858;
BgL_stringzd2ze3keyz31_858 = BgL_stringzd2ze3keyz31_829; 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_res2683z00_2870;
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_cipherz00_2862;obj_t BgL_passwordz00_2863;
if(
SYMBOLP(BgL_arg1934z00_850))
{ /* Llib/block_ciphers.scm 736 */
BgL_cipherz00_2862 = BgL_arg1934z00_850; }  else 
{ 
obj_t BgL_auxz00_7149;
BgL_auxz00_7149 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1934z00_850); 
FAILURE(BgL_auxz00_7149,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1936z00_852))
{ /* Llib/block_ciphers.scm 736 */
BgL_passwordz00_2863 = BgL_arg1936z00_852; }  else 
{ 
obj_t BgL_auxz00_7155;
BgL_auxz00_7155 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)26758)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1936z00_852); 
FAILURE(BgL_auxz00_7155,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 740 */
obj_t BgL_redirectz00_2864;
if(
STRINGP(BgL_arg1935z00_851))
{ /* Llib/block_ciphers.scm 741 */
BgL_redirectz00_2864 = BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 741 */
if(
BGL_MMAPP(BgL_arg1935z00_851))
{ /* Llib/block_ciphers.scm 742 */
BgL_redirectz00_2864 = BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL_test3750z00_7163;
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL__ortest_1057z00_2868;
BgL__ortest_1057z00_2868 = 
OUTPUT_PORTP(BgL_arg1935z00_851); 
if(BgL__ortest_1057z00_2868)
{ /* Llib/block_ciphers.scm 743 */
BgL_test3750z00_7163 = BgL__ortest_1057z00_2868
; }  else 
{ /* Llib/block_ciphers.scm 743 */
BgL_test3750z00_7163 = 
INPUT_PORTP(BgL_arg1935z00_851)
; } } 
if(BgL_test3750z00_7163)
{ /* Llib/block_ciphers.scm 743 */
BgL_redirectz00_2864 = BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
CNST_TABLE_REF(((long)25)); 
BgL_redirectz00_2864 = BgL_arg1935z00_851; } } } 
{ /* Llib/block_ciphers.scm 747 */
obj_t BgL_aux2780z00_5136;
{ /* Llib/block_ciphers.scm 747 */
obj_t BgL_tmpfunz00_7179;
{ /* Llib/block_ciphers.scm 747 */
bool_t BgL_test2779z00_5135;
BgL_test2779z00_5135 = 
PROCEDUREP(BgL_redirectz00_2864); 
if(BgL_test2779z00_5135)
{ /* Llib/block_ciphers.scm 747 */
BgL_tmpfunz00_7179 = BgL_redirectz00_2864
; }  else 
{ 
obj_t BgL_auxz00_7182;
BgL_auxz00_7182 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27169)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3204z00zz__cryptozd2blockzd2ciphersz00, BgL_redirectz00_2864); 
FAILURE(BgL_auxz00_7182,BFALSE,BFALSE);} } 
BgL_aux2780z00_5136 = 
PROCEDURE_ENTRY(BgL_tmpfunz00_7179)(BgL_redirectz00_2864, BgL_cipherz00_2862, BgL_arg1935z00_851, BgL_passwordz00_2863, BgL_ivz00_853, BgL_modez00_854, BgL_padz00_857, BgL_noncezd2initz12zc0_855, BgL_noncezd2updatez12zc0_856, BgL_stringzd2ze3keyz31_858, BEOA); } 
if(
STRINGP(BgL_aux2780z00_5136))
{ /* Llib/block_ciphers.scm 747 */
BgL_res2683z00_2870 = BgL_aux2780z00_5136; }  else 
{ 
obj_t BgL_auxz00_7188;
BgL_auxz00_7188 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27169)), BGl_string3201z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_aux2780z00_5136); 
FAILURE(BgL_auxz00_7188,BFALSE,BFALSE);} } } } 
return BgL_res2683z00_2870;} } } } } } } } } } } } } } } } } 

}



/* search1361~0 */
obj_t BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1360z00_5097, obj_t BgL_opt1358z00_5096, obj_t BgL_k1z00_818, long BgL_iz00_819)
{
{ /* Llib/block_ciphers.scm 736 */
BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_819==BgL_l1360z00_5097))
{ /* Llib/block_ciphers.scm 736 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 736 */
if(
(BgL_iz00_819==
(BgL_l1360z00_5097-((long)1))))
{ /* Llib/block_ciphers.scm 736 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1358z00_5096)));}  else 
{ /* Llib/block_ciphers.scm 736 */
obj_t BgL_vz00_863;
BgL_vz00_863 = 
VECTOR_REF(BgL_opt1358z00_5096,BgL_iz00_819); 
if(
(BgL_vz00_863==BgL_k1z00_818))
{ /* Llib/block_ciphers.scm 736 */
return 
BINT(
(BgL_iz00_819+((long)1)));}  else 
{ 
long BgL_iz00_7207;
BgL_iz00_7207 = 
(BgL_iz00_819+((long)2)); 
BgL_iz00_819 = BgL_iz00_7207; 
goto BGl_search1361ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* encrypt */
BGL_EXPORTED_DEF obj_t BGl_encryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_204, obj_t BgL_plaintextz00_205, obj_t BgL_passwordz00_206, obj_t BgL_ivz00_207, obj_t BgL_modez00_208, obj_t BgL_noncezd2initz12zc0_209, obj_t BgL_noncezd2updatez12zc0_210, obj_t BgL_padz00_211, obj_t BgL_stringzd2ze3keyz31_212)
{
{ /* Llib/block_ciphers.scm 736 */
{ /* Llib/block_ciphers.scm 740 */
obj_t BgL_redirectz00_2871;
if(
STRINGP(BgL_plaintextz00_205))
{ /* Llib/block_ciphers.scm 741 */
BgL_redirectz00_2871 = BGl_encryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 741 */
if(
BGL_MMAPP(BgL_plaintextz00_205))
{ /* Llib/block_ciphers.scm 742 */
BgL_redirectz00_2871 = BGl_encryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL_test3759z00_7213;
{ /* Llib/block_ciphers.scm 743 */
bool_t BgL__ortest_1057z00_2875;
BgL__ortest_1057z00_2875 = 
OUTPUT_PORTP(BgL_plaintextz00_205); 
if(BgL__ortest_1057z00_2875)
{ /* Llib/block_ciphers.scm 743 */
BgL_test3759z00_7213 = BgL__ortest_1057z00_2875
; }  else 
{ /* Llib/block_ciphers.scm 743 */
BgL_test3759z00_7213 = 
INPUT_PORTP(BgL_plaintextz00_205)
; } } 
if(BgL_test3759z00_7213)
{ /* Llib/block_ciphers.scm 743 */
BgL_redirectz00_2871 = BGl_encryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 743 */
CNST_TABLE_REF(((long)25)); 
BgL_redirectz00_2871 = BgL_plaintextz00_205; } } } 
return 
PROCEDURE_ENTRY(BgL_redirectz00_2871)(BgL_redirectz00_2871, BgL_cipherz00_204, BgL_plaintextz00_205, BgL_passwordz00_206, BgL_ivz00_207, BgL_modez00_208, BgL_padz00_211, BgL_noncezd2initz12zc0_209, BgL_noncezd2updatez12zc0_210, BgL_stringzd2ze3keyz31_212, BEOA);} } 

}



/* _encrypt-string */
obj_t BGl__encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1371z00_225, obj_t BgL_opt1370z00_224)
{
{ /* Llib/block_ciphers.scm 750 */
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_cipherz00_875;obj_t BgL_plaintextz00_876;obj_t BgL_passwordz00_877;
BgL_cipherz00_875 = 
VECTOR_REF(BgL_opt1370z00_224,((long)0)); 
BgL_plaintextz00_876 = 
VECTOR_REF(BgL_opt1370z00_224,((long)1)); 
BgL_passwordz00_877 = 
VECTOR_REF(BgL_opt1370z00_224,((long)2)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_ivz00_878;
BgL_ivz00_878 = BFALSE; 
{ /* Llib/block_ciphers.scm 751 */
obj_t BgL_modez00_879;
BgL_modez00_879 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2initz12zc0_880;
BgL_noncezd2initz12zc0_880 = BFALSE; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2updatez12zc0_881;
BgL_noncezd2updatez12zc0_881 = BFALSE; 
{ /* Llib/block_ciphers.scm 752 */
obj_t BgL_padz00_882;
BgL_padz00_882 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_stringzd2ze3keyz31_883;
BgL_stringzd2ze3keyz31_883 = BFALSE; 
{ /* Llib/block_ciphers.scm 750 */

{ 
long BgL_iz00_884;
BgL_iz00_884 = ((long)3); 
BgL_check1374z00_885:
if(
(BgL_iz00_884==
VECTOR_LENGTH(BgL_opt1370z00_224)))
{ /* Llib/block_ciphers.scm 750 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3762z00_7238;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1952z00_891;
BgL_arg1952z00_891 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_iz00_884); 
BgL_test3762z00_7238 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1952z00_891, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3762z00_7238)
{ 
long BgL_iz00_7243;
BgL_iz00_7243 = 
(BgL_iz00_884+((long)2)); 
BgL_iz00_884 = BgL_iz00_7243; 
goto BgL_check1374z00_885;}  else 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1951z00_890;
BgL_arg1951z00_890 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_iz00_884); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1951z00_890); } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1376z00_892;
BgL_index1376z00_892 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3763z00_7251;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2892;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7252;
if(
INTEGERP(BgL_index1376z00_892))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7252 = BgL_index1376z00_892
; }  else 
{ 
obj_t BgL_auxz00_7255;
BgL_auxz00_7255 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1376z00_892); 
FAILURE(BgL_auxz00_7255,BFALSE,BFALSE);} 
BgL_n1z00_2892 = 
(long)CINT(BgL_tmpz00_7252); } 
BgL_test3763z00_7251 = 
(BgL_n1z00_2892>=((long)0)); } 
if(BgL_test3763z00_7251)
{ 
long BgL_auxz00_7261;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7262;
if(
INTEGERP(BgL_index1376z00_892))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7262 = BgL_index1376z00_892
; }  else 
{ 
obj_t BgL_auxz00_7265;
BgL_auxz00_7265 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1376z00_892); 
FAILURE(BgL_auxz00_7265,BFALSE,BFALSE);} 
BgL_auxz00_7261 = 
(long)CINT(BgL_tmpz00_7262); } 
BgL_ivz00_878 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7261); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1377z00_894;
BgL_index1377z00_894 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3766z00_7274;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2893;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7275;
if(
INTEGERP(BgL_index1377z00_894))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7275 = BgL_index1377z00_894
; }  else 
{ 
obj_t BgL_auxz00_7278;
BgL_auxz00_7278 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1377z00_894); 
FAILURE(BgL_auxz00_7278,BFALSE,BFALSE);} 
BgL_n1z00_2893 = 
(long)CINT(BgL_tmpz00_7275); } 
BgL_test3766z00_7274 = 
(BgL_n1z00_2893>=((long)0)); } 
if(BgL_test3766z00_7274)
{ 
long BgL_auxz00_7284;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7285;
if(
INTEGERP(BgL_index1377z00_894))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7285 = BgL_index1377z00_894
; }  else 
{ 
obj_t BgL_auxz00_7288;
BgL_auxz00_7288 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1377z00_894); 
FAILURE(BgL_auxz00_7288,BFALSE,BFALSE);} 
BgL_auxz00_7284 = 
(long)CINT(BgL_tmpz00_7285); } 
BgL_modez00_879 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7284); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1378z00_896;
BgL_index1378z00_896 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3769z00_7297;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2894;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7298;
if(
INTEGERP(BgL_index1378z00_896))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7298 = BgL_index1378z00_896
; }  else 
{ 
obj_t BgL_auxz00_7301;
BgL_auxz00_7301 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1378z00_896); 
FAILURE(BgL_auxz00_7301,BFALSE,BFALSE);} 
BgL_n1z00_2894 = 
(long)CINT(BgL_tmpz00_7298); } 
BgL_test3769z00_7297 = 
(BgL_n1z00_2894>=((long)0)); } 
if(BgL_test3769z00_7297)
{ 
long BgL_auxz00_7307;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7308;
if(
INTEGERP(BgL_index1378z00_896))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7308 = BgL_index1378z00_896
; }  else 
{ 
obj_t BgL_auxz00_7311;
BgL_auxz00_7311 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1378z00_896); 
FAILURE(BgL_auxz00_7311,BFALSE,BFALSE);} 
BgL_auxz00_7307 = 
(long)CINT(BgL_tmpz00_7308); } 
BgL_noncezd2initz12zc0_880 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7307); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1379z00_898;
BgL_index1379z00_898 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3772z00_7320;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2895;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7321;
if(
INTEGERP(BgL_index1379z00_898))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7321 = BgL_index1379z00_898
; }  else 
{ 
obj_t BgL_auxz00_7324;
BgL_auxz00_7324 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1379z00_898); 
FAILURE(BgL_auxz00_7324,BFALSE,BFALSE);} 
BgL_n1z00_2895 = 
(long)CINT(BgL_tmpz00_7321); } 
BgL_test3772z00_7320 = 
(BgL_n1z00_2895>=((long)0)); } 
if(BgL_test3772z00_7320)
{ 
long BgL_auxz00_7330;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7331;
if(
INTEGERP(BgL_index1379z00_898))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7331 = BgL_index1379z00_898
; }  else 
{ 
obj_t BgL_auxz00_7334;
BgL_auxz00_7334 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1379z00_898); 
FAILURE(BgL_auxz00_7334,BFALSE,BFALSE);} 
BgL_auxz00_7330 = 
(long)CINT(BgL_tmpz00_7331); } 
BgL_noncezd2updatez12zc0_881 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7330); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1380z00_900;
BgL_index1380z00_900 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3775z00_7343;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2896;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7344;
if(
INTEGERP(BgL_index1380z00_900))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7344 = BgL_index1380z00_900
; }  else 
{ 
obj_t BgL_auxz00_7347;
BgL_auxz00_7347 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1380z00_900); 
FAILURE(BgL_auxz00_7347,BFALSE,BFALSE);} 
BgL_n1z00_2896 = 
(long)CINT(BgL_tmpz00_7344); } 
BgL_test3775z00_7343 = 
(BgL_n1z00_2896>=((long)0)); } 
if(BgL_test3775z00_7343)
{ 
long BgL_auxz00_7353;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7354;
if(
INTEGERP(BgL_index1380z00_900))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7354 = BgL_index1380z00_900
; }  else 
{ 
obj_t BgL_auxz00_7357;
BgL_auxz00_7357 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1380z00_900); 
FAILURE(BgL_auxz00_7357,BFALSE,BFALSE);} 
BgL_auxz00_7353 = 
(long)CINT(BgL_tmpz00_7354); } 
BgL_padz00_882 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7353); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_index1381z00_902;
BgL_index1381z00_902 = 
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1370z00_224), BgL_opt1370z00_224, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 750 */
bool_t BgL_test3778z00_7366;
{ /* Llib/block_ciphers.scm 750 */
long BgL_n1z00_2897;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7367;
if(
INTEGERP(BgL_index1381z00_902))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7367 = BgL_index1381z00_902
; }  else 
{ 
obj_t BgL_auxz00_7370;
BgL_auxz00_7370 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1381z00_902); 
FAILURE(BgL_auxz00_7370,BFALSE,BFALSE);} 
BgL_n1z00_2897 = 
(long)CINT(BgL_tmpz00_7367); } 
BgL_test3778z00_7366 = 
(BgL_n1z00_2897>=((long)0)); } 
if(BgL_test3778z00_7366)
{ 
long BgL_auxz00_7376;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_tmpz00_7377;
if(
INTEGERP(BgL_index1381z00_902))
{ /* Llib/block_ciphers.scm 750 */
BgL_tmpz00_7377 = BgL_index1381z00_902
; }  else 
{ 
obj_t BgL_auxz00_7380;
BgL_auxz00_7380 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1381z00_902); 
FAILURE(BgL_auxz00_7380,BFALSE,BFALSE);} 
BgL_auxz00_7376 = 
(long)CINT(BgL_tmpz00_7377); } 
BgL_stringzd2ze3keyz31_883 = 
VECTOR_REF(BgL_opt1370z00_224,BgL_auxz00_7376); }  else 
{ /* Llib/block_ciphers.scm 750 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_arg1959z00_904;obj_t BgL_arg1960z00_905;obj_t BgL_arg1961z00_906;
BgL_arg1959z00_904 = 
VECTOR_REF(BgL_opt1370z00_224,((long)0)); 
BgL_arg1960z00_905 = 
VECTOR_REF(BgL_opt1370z00_224,((long)1)); 
BgL_arg1961z00_906 = 
VECTOR_REF(BgL_opt1370z00_224,((long)2)); 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_ivz00_907;
BgL_ivz00_907 = BgL_ivz00_878; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_modez00_908;
BgL_modez00_908 = BgL_modez00_879; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2initz12zc0_909;
BgL_noncezd2initz12zc0_909 = BgL_noncezd2initz12zc0_880; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_noncezd2updatez12zc0_910;
BgL_noncezd2updatez12zc0_910 = BgL_noncezd2updatez12zc0_881; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_padz00_911;
BgL_padz00_911 = BgL_padz00_882; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_stringzd2ze3keyz31_912;
BgL_stringzd2ze3keyz31_912 = BgL_stringzd2ze3keyz31_883; 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_res2685z00_2901;
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_cipherz00_2898;obj_t BgL_plaintextz00_2899;obj_t BgL_passwordz00_2900;
if(
SYMBOLP(BgL_arg1959z00_904))
{ /* Llib/block_ciphers.scm 750 */
BgL_cipherz00_2898 = BgL_arg1959z00_904; }  else 
{ 
obj_t BgL_auxz00_7391;
BgL_auxz00_7391 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1959z00_904); 
FAILURE(BgL_auxz00_7391,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1960z00_905))
{ /* Llib/block_ciphers.scm 750 */
BgL_plaintextz00_2899 = BgL_arg1960z00_905; }  else 
{ 
obj_t BgL_auxz00_7397;
BgL_auxz00_7397 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1960z00_905); 
FAILURE(BgL_auxz00_7397,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1961z00_906))
{ /* Llib/block_ciphers.scm 750 */
BgL_passwordz00_2900 = BgL_arg1961z00_906; }  else 
{ 
obj_t BgL_auxz00_7403;
BgL_auxz00_7403 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27261)), BGl_string3206z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1961z00_906); 
FAILURE(BgL_auxz00_7403,BFALSE,BFALSE);} 
BgL_res2685z00_2901 = 
BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_2898, BgL_plaintextz00_2899, BgL_passwordz00_2900, BgL_ivz00_907, BgL_modez00_908, BgL_padz00_911, BgL_noncezd2initz12zc0_909, BgL_noncezd2updatez12zc0_910, BgL_stringzd2ze3keyz31_912); } 
return BgL_res2685z00_2901;} } } } } } } } } } } } } } } } } 

}



/* search1373~0 */
obj_t BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1372z00_5095, obj_t BgL_opt1370z00_5094, obj_t BgL_k1z00_872, long BgL_iz00_873)
{
{ /* Llib/block_ciphers.scm 750 */
BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_873==BgL_l1372z00_5095))
{ /* Llib/block_ciphers.scm 750 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 750 */
if(
(BgL_iz00_873==
(BgL_l1372z00_5095-((long)1))))
{ /* Llib/block_ciphers.scm 750 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1370z00_5094)));}  else 
{ /* Llib/block_ciphers.scm 750 */
obj_t BgL_vz00_917;
BgL_vz00_917 = 
VECTOR_REF(BgL_opt1370z00_5094,BgL_iz00_873); 
if(
(BgL_vz00_917==BgL_k1z00_872))
{ /* Llib/block_ciphers.scm 750 */
return 
BINT(
(BgL_iz00_873+((long)1)));}  else 
{ 
long BgL_iz00_7423;
BgL_iz00_7423 = 
(BgL_iz00_873+((long)2)); 
BgL_iz00_873 = BgL_iz00_7423; 
goto BGl_search1373ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* encrypt-string */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_215, obj_t BgL_plaintextz00_216, obj_t BgL_passwordz00_217, obj_t BgL_ivz00_218, obj_t BgL_modez00_219, obj_t BgL_noncezd2initz12zc0_220, obj_t BgL_noncezd2updatez12zc0_221, obj_t BgL_padz00_222, obj_t BgL_stringzd2ze3keyz31_223)
{
{ /* Llib/block_ciphers.scm 750 */
{ /* Llib/block_ciphers.scm 765 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_2903;
BgL_statez00_2903 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_215, BgL_passwordz00_217, BgL_ivz00_218, BgL_modez00_219, BgL_padz00_222, BgL_noncezd2initz12zc0_220, BgL_noncezd2updatez12zc0_221, BgL_stringzd2ze3keyz31_223); 
{ /* Llib/block_ciphers.scm 765 */
long BgL_blockzd2siza7ez75_2904;
BgL_blockzd2siza7ez75_2904 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_2903))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 768 */
obj_t BgL_strz00_2906;
{ /* Llib/block_ciphers.scm 770 */
long BgL_arg1970z00_2907;
BgL_arg1970z00_2907 = 
(
(((long)2)*BgL_blockzd2siza7ez75_2904)+
STRING_LENGTH(BgL_plaintextz00_216)); 
{ /* Llib/block_ciphers.scm 770 */

BgL_strz00_2906 = 
make_string(BgL_arg1970z00_2907, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 770 */

{ /* Llib/block_ciphers.scm 771 */
long BgL_tmpz00_7431;
BgL_tmpz00_7431 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_2903, BgL_plaintextz00_216, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_2906, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_2906, BgL_tmpz00_7431);} } } } } } 

}



/* encrypt-fast-string */
obj_t BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_226, obj_t BgL_plaintextz00_227, obj_t BgL_passwordz00_228, obj_t BgL_ivz00_229, obj_t BgL_modez00_230, obj_t BgL_padz00_231, obj_t BgL_noncezd2initz12zc0_232, obj_t BgL_noncezd2updatez12zc0_233, obj_t BgL_stringzd2ze3keyz31_234)
{
{ /* Llib/block_ciphers.scm 759 */
{ /* Llib/block_ciphers.scm 765 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_2920;
BgL_statez00_2920 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_226, BgL_passwordz00_228, BgL_ivz00_229, BgL_modez00_230, BgL_padz00_231, BgL_noncezd2initz12zc0_232, BgL_noncezd2updatez12zc0_233, BgL_stringzd2ze3keyz31_234); 
{ /* Llib/block_ciphers.scm 765 */
long BgL_blockzd2siza7ez75_2921;
BgL_blockzd2siza7ez75_2921 = 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_2920))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 768 */
obj_t BgL_strz00_2923;
{ /* Llib/block_ciphers.scm 770 */
long BgL_arg1970z00_2924;
BgL_arg1970z00_2924 = 
(
(((long)2)*BgL_blockzd2siza7ez75_2921)+
STRING_LENGTH(BgL_plaintextz00_227)); 
{ /* Llib/block_ciphers.scm 770 */

BgL_strz00_2923 = 
make_string(BgL_arg1970z00_2924, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 770 */

{ /* Llib/block_ciphers.scm 771 */
long BgL_tmpz00_7440;
BgL_tmpz00_7440 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_2920, BgL_plaintextz00_227, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_2923, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_2923, BgL_tmpz00_7440);} } } } } } 

}



/* &encrypt-fast-string */
obj_t BGl_z62encryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4406, obj_t BgL_cipherz00_4407, obj_t BgL_plaintextz00_4408, obj_t BgL_passwordz00_4409, obj_t BgL_ivz00_4410, obj_t BgL_modez00_4411, obj_t BgL_padz00_4412, obj_t BgL_noncezd2initz12zc0_4413, obj_t BgL_noncezd2updatez12zc0_4414, obj_t BgL_stringzd2ze3keyz31_4415)
{
{ /* Llib/block_ciphers.scm 759 */
{ /* Llib/block_ciphers.scm 765 */
obj_t BgL_auxz00_7443;
if(
STRINGP(BgL_plaintextz00_4408))
{ /* Llib/block_ciphers.scm 765 */
BgL_auxz00_7443 = BgL_plaintextz00_4408
; }  else 
{ 
obj_t BgL_auxz00_7446;
BgL_auxz00_7446 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)27779)), BGl_string3207z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4408); 
FAILURE(BgL_auxz00_7446,BFALSE,BFALSE);} 
return 
BGl_encryptzd2fastzd2stringz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4407, BgL_auxz00_7443, BgL_passwordz00_4409, BgL_ivz00_4410, BgL_modez00_4411, BgL_padz00_4412, BgL_noncezd2initz12zc0_4413, BgL_noncezd2updatez12zc0_4414, BgL_stringzd2ze3keyz31_4415);} } 

}



/* _encrypt-mmap */
obj_t BGl__encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1383z00_245, obj_t BgL_opt1382z00_244)
{
{ /* Llib/block_ciphers.scm 776 */
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_cipherz00_935;obj_t BgL_plaintextz00_936;obj_t BgL_passwordz00_937;
BgL_cipherz00_935 = 
VECTOR_REF(BgL_opt1382z00_244,((long)0)); 
BgL_plaintextz00_936 = 
VECTOR_REF(BgL_opt1382z00_244,((long)1)); 
BgL_passwordz00_937 = 
VECTOR_REF(BgL_opt1382z00_244,((long)2)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_ivz00_938;
BgL_ivz00_938 = BFALSE; 
{ /* Llib/block_ciphers.scm 777 */
obj_t BgL_modez00_939;
BgL_modez00_939 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2initz12zc0_940;
BgL_noncezd2initz12zc0_940 = BFALSE; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2updatez12zc0_941;
BgL_noncezd2updatez12zc0_941 = BFALSE; 
{ /* Llib/block_ciphers.scm 777 */
obj_t BgL_padz00_942;
BgL_padz00_942 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_stringzd2ze3keyz31_943;
BgL_stringzd2ze3keyz31_943 = BFALSE; 
{ /* Llib/block_ciphers.scm 776 */

{ 
long BgL_iz00_944;
BgL_iz00_944 = ((long)3); 
BgL_check1386z00_945:
if(
(BgL_iz00_944==
VECTOR_LENGTH(BgL_opt1382z00_244)))
{ /* Llib/block_ciphers.scm 776 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3789z00_7459;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1978z00_951;
BgL_arg1978z00_951 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_iz00_944); 
BgL_test3789z00_7459 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1978z00_951, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3789z00_7459)
{ 
long BgL_iz00_7464;
BgL_iz00_7464 = 
(BgL_iz00_944+((long)2)); 
BgL_iz00_944 = BgL_iz00_7464; 
goto BgL_check1386z00_945;}  else 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1977z00_950;
BgL_arg1977z00_950 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_iz00_944); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1977z00_950); } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1388z00_952;
BgL_index1388z00_952 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3790z00_7472;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2952;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7473;
if(
INTEGERP(BgL_index1388z00_952))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7473 = BgL_index1388z00_952
; }  else 
{ 
obj_t BgL_auxz00_7476;
BgL_auxz00_7476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1388z00_952); 
FAILURE(BgL_auxz00_7476,BFALSE,BFALSE);} 
BgL_n1z00_2952 = 
(long)CINT(BgL_tmpz00_7473); } 
BgL_test3790z00_7472 = 
(BgL_n1z00_2952>=((long)0)); } 
if(BgL_test3790z00_7472)
{ 
long BgL_auxz00_7482;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7483;
if(
INTEGERP(BgL_index1388z00_952))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7483 = BgL_index1388z00_952
; }  else 
{ 
obj_t BgL_auxz00_7486;
BgL_auxz00_7486 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1388z00_952); 
FAILURE(BgL_auxz00_7486,BFALSE,BFALSE);} 
BgL_auxz00_7482 = 
(long)CINT(BgL_tmpz00_7483); } 
BgL_ivz00_938 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7482); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1389z00_954;
BgL_index1389z00_954 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3793z00_7495;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2953;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7496;
if(
INTEGERP(BgL_index1389z00_954))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7496 = BgL_index1389z00_954
; }  else 
{ 
obj_t BgL_auxz00_7499;
BgL_auxz00_7499 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1389z00_954); 
FAILURE(BgL_auxz00_7499,BFALSE,BFALSE);} 
BgL_n1z00_2953 = 
(long)CINT(BgL_tmpz00_7496); } 
BgL_test3793z00_7495 = 
(BgL_n1z00_2953>=((long)0)); } 
if(BgL_test3793z00_7495)
{ 
long BgL_auxz00_7505;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7506;
if(
INTEGERP(BgL_index1389z00_954))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7506 = BgL_index1389z00_954
; }  else 
{ 
obj_t BgL_auxz00_7509;
BgL_auxz00_7509 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1389z00_954); 
FAILURE(BgL_auxz00_7509,BFALSE,BFALSE);} 
BgL_auxz00_7505 = 
(long)CINT(BgL_tmpz00_7506); } 
BgL_modez00_939 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7505); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1390z00_956;
BgL_index1390z00_956 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3796z00_7518;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2954;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7519;
if(
INTEGERP(BgL_index1390z00_956))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7519 = BgL_index1390z00_956
; }  else 
{ 
obj_t BgL_auxz00_7522;
BgL_auxz00_7522 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1390z00_956); 
FAILURE(BgL_auxz00_7522,BFALSE,BFALSE);} 
BgL_n1z00_2954 = 
(long)CINT(BgL_tmpz00_7519); } 
BgL_test3796z00_7518 = 
(BgL_n1z00_2954>=((long)0)); } 
if(BgL_test3796z00_7518)
{ 
long BgL_auxz00_7528;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7529;
if(
INTEGERP(BgL_index1390z00_956))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7529 = BgL_index1390z00_956
; }  else 
{ 
obj_t BgL_auxz00_7532;
BgL_auxz00_7532 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1390z00_956); 
FAILURE(BgL_auxz00_7532,BFALSE,BFALSE);} 
BgL_auxz00_7528 = 
(long)CINT(BgL_tmpz00_7529); } 
BgL_noncezd2initz12zc0_940 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7528); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1391z00_958;
BgL_index1391z00_958 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3799z00_7541;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2955;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7542;
if(
INTEGERP(BgL_index1391z00_958))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7542 = BgL_index1391z00_958
; }  else 
{ 
obj_t BgL_auxz00_7545;
BgL_auxz00_7545 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1391z00_958); 
FAILURE(BgL_auxz00_7545,BFALSE,BFALSE);} 
BgL_n1z00_2955 = 
(long)CINT(BgL_tmpz00_7542); } 
BgL_test3799z00_7541 = 
(BgL_n1z00_2955>=((long)0)); } 
if(BgL_test3799z00_7541)
{ 
long BgL_auxz00_7551;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7552;
if(
INTEGERP(BgL_index1391z00_958))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7552 = BgL_index1391z00_958
; }  else 
{ 
obj_t BgL_auxz00_7555;
BgL_auxz00_7555 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1391z00_958); 
FAILURE(BgL_auxz00_7555,BFALSE,BFALSE);} 
BgL_auxz00_7551 = 
(long)CINT(BgL_tmpz00_7552); } 
BgL_noncezd2updatez12zc0_941 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7551); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1392z00_960;
BgL_index1392z00_960 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3802z00_7564;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2956;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7565;
if(
INTEGERP(BgL_index1392z00_960))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7565 = BgL_index1392z00_960
; }  else 
{ 
obj_t BgL_auxz00_7568;
BgL_auxz00_7568 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1392z00_960); 
FAILURE(BgL_auxz00_7568,BFALSE,BFALSE);} 
BgL_n1z00_2956 = 
(long)CINT(BgL_tmpz00_7565); } 
BgL_test3802z00_7564 = 
(BgL_n1z00_2956>=((long)0)); } 
if(BgL_test3802z00_7564)
{ 
long BgL_auxz00_7574;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7575;
if(
INTEGERP(BgL_index1392z00_960))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7575 = BgL_index1392z00_960
; }  else 
{ 
obj_t BgL_auxz00_7578;
BgL_auxz00_7578 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1392z00_960); 
FAILURE(BgL_auxz00_7578,BFALSE,BFALSE);} 
BgL_auxz00_7574 = 
(long)CINT(BgL_tmpz00_7575); } 
BgL_padz00_942 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7574); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_index1393z00_962;
BgL_index1393z00_962 = 
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1382z00_244), BgL_opt1382z00_244, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 776 */
bool_t BgL_test3805z00_7587;
{ /* Llib/block_ciphers.scm 776 */
long BgL_n1z00_2957;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7588;
if(
INTEGERP(BgL_index1393z00_962))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7588 = BgL_index1393z00_962
; }  else 
{ 
obj_t BgL_auxz00_7591;
BgL_auxz00_7591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1393z00_962); 
FAILURE(BgL_auxz00_7591,BFALSE,BFALSE);} 
BgL_n1z00_2957 = 
(long)CINT(BgL_tmpz00_7588); } 
BgL_test3805z00_7587 = 
(BgL_n1z00_2957>=((long)0)); } 
if(BgL_test3805z00_7587)
{ 
long BgL_auxz00_7597;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_tmpz00_7598;
if(
INTEGERP(BgL_index1393z00_962))
{ /* Llib/block_ciphers.scm 776 */
BgL_tmpz00_7598 = BgL_index1393z00_962
; }  else 
{ 
obj_t BgL_auxz00_7601;
BgL_auxz00_7601 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1393z00_962); 
FAILURE(BgL_auxz00_7601,BFALSE,BFALSE);} 
BgL_auxz00_7597 = 
(long)CINT(BgL_tmpz00_7598); } 
BgL_stringzd2ze3keyz31_943 = 
VECTOR_REF(BgL_opt1382z00_244,BgL_auxz00_7597); }  else 
{ /* Llib/block_ciphers.scm 776 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_arg1985z00_964;obj_t BgL_arg1986z00_965;obj_t BgL_arg1987z00_966;
BgL_arg1985z00_964 = 
VECTOR_REF(BgL_opt1382z00_244,((long)0)); 
BgL_arg1986z00_965 = 
VECTOR_REF(BgL_opt1382z00_244,((long)1)); 
BgL_arg1987z00_966 = 
VECTOR_REF(BgL_opt1382z00_244,((long)2)); 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_ivz00_967;
BgL_ivz00_967 = BgL_ivz00_938; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_modez00_968;
BgL_modez00_968 = BgL_modez00_939; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2initz12zc0_969;
BgL_noncezd2initz12zc0_969 = BgL_noncezd2initz12zc0_940; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_noncezd2updatez12zc0_970;
BgL_noncezd2updatez12zc0_970 = BgL_noncezd2updatez12zc0_941; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_padz00_971;
BgL_padz00_971 = BgL_padz00_942; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_stringzd2ze3keyz31_972;
BgL_stringzd2ze3keyz31_972 = BgL_stringzd2ze3keyz31_943; 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_res2686z00_2961;
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_cipherz00_2958;obj_t BgL_plaintextz00_2959;obj_t BgL_passwordz00_2960;
if(
SYMBOLP(BgL_arg1985z00_964))
{ /* Llib/block_ciphers.scm 776 */
BgL_cipherz00_2958 = BgL_arg1985z00_964; }  else 
{ 
obj_t BgL_auxz00_7612;
BgL_auxz00_7612 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1985z00_964); 
FAILURE(BgL_auxz00_7612,BFALSE,BFALSE);} 
if(
BGL_MMAPP(BgL_arg1986z00_965))
{ /* Llib/block_ciphers.scm 776 */
BgL_plaintextz00_2959 = BgL_arg1986z00_965; }  else 
{ 
obj_t BgL_auxz00_7618;
BgL_auxz00_7618 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3209z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1986z00_965); 
FAILURE(BgL_auxz00_7618,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg1987z00_966))
{ /* Llib/block_ciphers.scm 776 */
BgL_passwordz00_2960 = BgL_arg1987z00_966; }  else 
{ 
obj_t BgL_auxz00_7624;
BgL_auxz00_7624 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28189)), BGl_string3208z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg1987z00_966); 
FAILURE(BgL_auxz00_7624,BFALSE,BFALSE);} 
BgL_res2686z00_2961 = 
BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_2958, BgL_plaintextz00_2959, BgL_passwordz00_2960, BgL_ivz00_967, BgL_modez00_968, BgL_padz00_971, BgL_noncezd2initz12zc0_969, BgL_noncezd2updatez12zc0_970, BgL_stringzd2ze3keyz31_972); } 
return BgL_res2686z00_2961;} } } } } } } } } } } } } } } } } 

}



/* search1385~0 */
obj_t BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1384z00_5093, obj_t BgL_opt1382z00_5092, obj_t BgL_k1z00_932, long BgL_iz00_933)
{
{ /* Llib/block_ciphers.scm 776 */
BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_933==BgL_l1384z00_5093))
{ /* Llib/block_ciphers.scm 776 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 776 */
if(
(BgL_iz00_933==
(BgL_l1384z00_5093-((long)1))))
{ /* Llib/block_ciphers.scm 776 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1382z00_5092)));}  else 
{ /* Llib/block_ciphers.scm 776 */
obj_t BgL_vz00_977;
BgL_vz00_977 = 
VECTOR_REF(BgL_opt1382z00_5092,BgL_iz00_933); 
if(
(BgL_vz00_977==BgL_k1z00_932))
{ /* Llib/block_ciphers.scm 776 */
return 
BINT(
(BgL_iz00_933+((long)1)));}  else 
{ 
long BgL_iz00_7644;
BgL_iz00_7644 = 
(BgL_iz00_933+((long)2)); 
BgL_iz00_933 = BgL_iz00_7644; 
goto BGl_search1385ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* encrypt-mmap */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_235, obj_t BgL_plaintextz00_236, obj_t BgL_passwordz00_237, obj_t BgL_ivz00_238, obj_t BgL_modez00_239, obj_t BgL_noncezd2initz12zc0_240, obj_t BgL_noncezd2updatez12zc0_241, obj_t BgL_padz00_242, obj_t BgL_stringzd2ze3keyz31_243)
{
{ /* Llib/block_ciphers.scm 776 */
{ /* Llib/block_ciphers.scm 789 */
long BgL_lenz00_2963;
BgL_lenz00_2963 = 
BGL_MMAP_LENGTH(BgL_plaintextz00_236); 
{ /* Llib/block_ciphers.scm 789 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_2964;
BgL_statez00_2964 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_235, BgL_passwordz00_237, BgL_ivz00_238, BgL_modez00_239, BgL_padz00_242, BgL_noncezd2initz12zc0_240, BgL_noncezd2updatez12zc0_241, BgL_stringzd2ze3keyz31_243); 
{ /* Llib/block_ciphers.scm 790 */
obj_t BgL_strz00_2965;
{ /* Llib/block_ciphers.scm 793 */
long BgL_arg1996z00_2966;
{ /* Llib/block_ciphers.scm 793 */
long BgL_za72za7_2976;
BgL_za72za7_2976 = 
(long)(BgL_lenz00_2963); 
BgL_arg1996z00_2966 = 
(
(((long)2)*
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_2964))->BgL_blockzd2siza7ez75))+BgL_za72za7_2976); } 
{ /* Llib/block_ciphers.scm 793 */

BgL_strz00_2965 = 
make_string(BgL_arg1996z00_2966, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 793 */

{ /* Llib/block_ciphers.scm 796 */
long BgL_tmpz00_7653;
BgL_tmpz00_7653 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_2964, BgL_plaintextz00_236, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_2965, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_2965, BgL_tmpz00_7653);} } } } } } 

}



/* encrypt-fast-mmap */
obj_t BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_246, obj_t BgL_plaintextz00_247, obj_t BgL_passwordz00_248, obj_t BgL_ivz00_249, obj_t BgL_modez00_250, obj_t BgL_padz00_251, obj_t BgL_noncezd2initz12zc0_252, obj_t BgL_noncezd2updatez12zc0_253, obj_t BgL_stringzd2ze3keyz31_254)
{
{ /* Llib/block_ciphers.scm 784 */
{ /* Llib/block_ciphers.scm 789 */
long BgL_lenz00_2980;
BgL_lenz00_2980 = 
BGL_MMAP_LENGTH(BgL_plaintextz00_247); 
{ /* Llib/block_ciphers.scm 789 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_2981;
BgL_statez00_2981 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_246, BgL_passwordz00_248, BgL_ivz00_249, BgL_modez00_250, BgL_padz00_251, BgL_noncezd2initz12zc0_252, BgL_noncezd2updatez12zc0_253, BgL_stringzd2ze3keyz31_254); 
{ /* Llib/block_ciphers.scm 790 */
obj_t BgL_strz00_2982;
{ /* Llib/block_ciphers.scm 793 */
long BgL_arg1996z00_2983;
{ /* Llib/block_ciphers.scm 793 */
long BgL_za72za7_2993;
BgL_za72za7_2993 = 
(long)(BgL_lenz00_2980); 
BgL_arg1996z00_2983 = 
(
(((long)2)*
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_statez00_2981))->BgL_blockzd2siza7ez75))+BgL_za72za7_2993); } 
{ /* Llib/block_ciphers.scm 793 */

BgL_strz00_2982 = 
make_string(BgL_arg1996z00_2983, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 793 */

{ /* Llib/block_ciphers.scm 796 */
long BgL_tmpz00_7663;
BgL_tmpz00_7663 = 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_2981, BgL_plaintextz00_247, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_2982, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_2982, BgL_tmpz00_7663);} } } } } } 

}



/* &encrypt-fast-mmap */
obj_t BGl_z62encryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4416, obj_t BgL_cipherz00_4417, obj_t BgL_plaintextz00_4418, obj_t BgL_passwordz00_4419, obj_t BgL_ivz00_4420, obj_t BgL_modez00_4421, obj_t BgL_padz00_4422, obj_t BgL_noncezd2initz12zc0_4423, obj_t BgL_noncezd2updatez12zc0_4424, obj_t BgL_stringzd2ze3keyz31_4425)
{
{ /* Llib/block_ciphers.scm 784 */
{ /* Llib/block_ciphers.scm 789 */
obj_t BgL_auxz00_7666;
if(
BGL_MMAPP(BgL_plaintextz00_4418))
{ /* Llib/block_ciphers.scm 789 */
BgL_auxz00_7666 = BgL_plaintextz00_4418
; }  else 
{ 
obj_t BgL_auxz00_7669;
BgL_auxz00_7669 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)28710)), BGl_string3210z00zz__cryptozd2blockzd2ciphersz00, BGl_string3209z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4418); 
FAILURE(BgL_auxz00_7669,BFALSE,BFALSE);} 
return 
BGl_encryptzd2fastzd2mmapz00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4417, BgL_auxz00_7666, BgL_passwordz00_4419, BgL_ivz00_4420, BgL_modez00_4421, BgL_padz00_4422, BgL_noncezd2initz12zc0_4423, BgL_noncezd2updatez12zc0_4424, BgL_stringzd2ze3keyz31_4425);} } 

}



/* _encrypt-port */
obj_t BGl__encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1395z00_265, obj_t BgL_opt1394z00_264)
{
{ /* Llib/block_ciphers.scm 801 */
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_cipherz00_995;obj_t BgL_plaintextz00_996;obj_t BgL_passwordz00_997;
BgL_cipherz00_995 = 
VECTOR_REF(BgL_opt1394z00_264,((long)0)); 
BgL_plaintextz00_996 = 
VECTOR_REF(BgL_opt1394z00_264,((long)1)); 
BgL_passwordz00_997 = 
VECTOR_REF(BgL_opt1394z00_264,((long)2)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_ivz00_998;
BgL_ivz00_998 = BFALSE; 
{ /* Llib/block_ciphers.scm 802 */
obj_t BgL_modez00_999;
BgL_modez00_999 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2initz12zc0_1000;
BgL_noncezd2initz12zc0_1000 = BFALSE; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2updatez12zc0_1001;
BgL_noncezd2updatez12zc0_1001 = BFALSE; 
{ /* Llib/block_ciphers.scm 802 */
obj_t BgL_padz00_1002;
BgL_padz00_1002 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_stringzd2ze3keyz31_1003;
BgL_stringzd2ze3keyz31_1003 = BFALSE; 
{ /* Llib/block_ciphers.scm 801 */

{ 
long BgL_iz00_1004;
BgL_iz00_1004 = ((long)3); 
BgL_check1398z00_1005:
if(
(BgL_iz00_1004==
VECTOR_LENGTH(BgL_opt1394z00_264)))
{ /* Llib/block_ciphers.scm 801 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3816z00_7682;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg2004z00_1011;
BgL_arg2004z00_1011 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_iz00_1004); 
BgL_test3816z00_7682 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2004z00_1011, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3816z00_7682)
{ 
long BgL_iz00_7687;
BgL_iz00_7687 = 
(BgL_iz00_1004+((long)2)); 
BgL_iz00_1004 = BgL_iz00_7687; 
goto BgL_check1398z00_1005;}  else 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg2003z00_1010;
BgL_arg2003z00_1010 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_iz00_1004); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2003z00_1010); } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1400z00_1012;
BgL_index1400z00_1012 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3817z00_7695;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3012;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7696;
if(
INTEGERP(BgL_index1400z00_1012))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7696 = BgL_index1400z00_1012
; }  else 
{ 
obj_t BgL_auxz00_7699;
BgL_auxz00_7699 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1400z00_1012); 
FAILURE(BgL_auxz00_7699,BFALSE,BFALSE);} 
BgL_n1z00_3012 = 
(long)CINT(BgL_tmpz00_7696); } 
BgL_test3817z00_7695 = 
(BgL_n1z00_3012>=((long)0)); } 
if(BgL_test3817z00_7695)
{ 
long BgL_auxz00_7705;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7706;
if(
INTEGERP(BgL_index1400z00_1012))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7706 = BgL_index1400z00_1012
; }  else 
{ 
obj_t BgL_auxz00_7709;
BgL_auxz00_7709 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1400z00_1012); 
FAILURE(BgL_auxz00_7709,BFALSE,BFALSE);} 
BgL_auxz00_7705 = 
(long)CINT(BgL_tmpz00_7706); } 
BgL_ivz00_998 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7705); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1401z00_1014;
BgL_index1401z00_1014 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3820z00_7718;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3013;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7719;
if(
INTEGERP(BgL_index1401z00_1014))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7719 = BgL_index1401z00_1014
; }  else 
{ 
obj_t BgL_auxz00_7722;
BgL_auxz00_7722 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1401z00_1014); 
FAILURE(BgL_auxz00_7722,BFALSE,BFALSE);} 
BgL_n1z00_3013 = 
(long)CINT(BgL_tmpz00_7719); } 
BgL_test3820z00_7718 = 
(BgL_n1z00_3013>=((long)0)); } 
if(BgL_test3820z00_7718)
{ 
long BgL_auxz00_7728;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7729;
if(
INTEGERP(BgL_index1401z00_1014))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7729 = BgL_index1401z00_1014
; }  else 
{ 
obj_t BgL_auxz00_7732;
BgL_auxz00_7732 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1401z00_1014); 
FAILURE(BgL_auxz00_7732,BFALSE,BFALSE);} 
BgL_auxz00_7728 = 
(long)CINT(BgL_tmpz00_7729); } 
BgL_modez00_999 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7728); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1402z00_1016;
BgL_index1402z00_1016 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3823z00_7741;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3014;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7742;
if(
INTEGERP(BgL_index1402z00_1016))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7742 = BgL_index1402z00_1016
; }  else 
{ 
obj_t BgL_auxz00_7745;
BgL_auxz00_7745 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1402z00_1016); 
FAILURE(BgL_auxz00_7745,BFALSE,BFALSE);} 
BgL_n1z00_3014 = 
(long)CINT(BgL_tmpz00_7742); } 
BgL_test3823z00_7741 = 
(BgL_n1z00_3014>=((long)0)); } 
if(BgL_test3823z00_7741)
{ 
long BgL_auxz00_7751;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7752;
if(
INTEGERP(BgL_index1402z00_1016))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7752 = BgL_index1402z00_1016
; }  else 
{ 
obj_t BgL_auxz00_7755;
BgL_auxz00_7755 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1402z00_1016); 
FAILURE(BgL_auxz00_7755,BFALSE,BFALSE);} 
BgL_auxz00_7751 = 
(long)CINT(BgL_tmpz00_7752); } 
BgL_noncezd2initz12zc0_1000 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7751); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1403z00_1018;
BgL_index1403z00_1018 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3826z00_7764;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3015;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7765;
if(
INTEGERP(BgL_index1403z00_1018))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7765 = BgL_index1403z00_1018
; }  else 
{ 
obj_t BgL_auxz00_7768;
BgL_auxz00_7768 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1403z00_1018); 
FAILURE(BgL_auxz00_7768,BFALSE,BFALSE);} 
BgL_n1z00_3015 = 
(long)CINT(BgL_tmpz00_7765); } 
BgL_test3826z00_7764 = 
(BgL_n1z00_3015>=((long)0)); } 
if(BgL_test3826z00_7764)
{ 
long BgL_auxz00_7774;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7775;
if(
INTEGERP(BgL_index1403z00_1018))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7775 = BgL_index1403z00_1018
; }  else 
{ 
obj_t BgL_auxz00_7778;
BgL_auxz00_7778 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1403z00_1018); 
FAILURE(BgL_auxz00_7778,BFALSE,BFALSE);} 
BgL_auxz00_7774 = 
(long)CINT(BgL_tmpz00_7775); } 
BgL_noncezd2updatez12zc0_1001 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7774); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1404z00_1020;
BgL_index1404z00_1020 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3829z00_7787;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3016;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7788;
if(
INTEGERP(BgL_index1404z00_1020))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7788 = BgL_index1404z00_1020
; }  else 
{ 
obj_t BgL_auxz00_7791;
BgL_auxz00_7791 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1404z00_1020); 
FAILURE(BgL_auxz00_7791,BFALSE,BFALSE);} 
BgL_n1z00_3016 = 
(long)CINT(BgL_tmpz00_7788); } 
BgL_test3829z00_7787 = 
(BgL_n1z00_3016>=((long)0)); } 
if(BgL_test3829z00_7787)
{ 
long BgL_auxz00_7797;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7798;
if(
INTEGERP(BgL_index1404z00_1020))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7798 = BgL_index1404z00_1020
; }  else 
{ 
obj_t BgL_auxz00_7801;
BgL_auxz00_7801 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1404z00_1020); 
FAILURE(BgL_auxz00_7801,BFALSE,BFALSE);} 
BgL_auxz00_7797 = 
(long)CINT(BgL_tmpz00_7798); } 
BgL_padz00_1002 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7797); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_index1405z00_1022;
BgL_index1405z00_1022 = 
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1394z00_264), BgL_opt1394z00_264, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 801 */
bool_t BgL_test3832z00_7810;
{ /* Llib/block_ciphers.scm 801 */
long BgL_n1z00_3017;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7811;
if(
INTEGERP(BgL_index1405z00_1022))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7811 = BgL_index1405z00_1022
; }  else 
{ 
obj_t BgL_auxz00_7814;
BgL_auxz00_7814 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1405z00_1022); 
FAILURE(BgL_auxz00_7814,BFALSE,BFALSE);} 
BgL_n1z00_3017 = 
(long)CINT(BgL_tmpz00_7811); } 
BgL_test3832z00_7810 = 
(BgL_n1z00_3017>=((long)0)); } 
if(BgL_test3832z00_7810)
{ 
long BgL_auxz00_7820;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_tmpz00_7821;
if(
INTEGERP(BgL_index1405z00_1022))
{ /* Llib/block_ciphers.scm 801 */
BgL_tmpz00_7821 = BgL_index1405z00_1022
; }  else 
{ 
obj_t BgL_auxz00_7824;
BgL_auxz00_7824 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1405z00_1022); 
FAILURE(BgL_auxz00_7824,BFALSE,BFALSE);} 
BgL_auxz00_7820 = 
(long)CINT(BgL_tmpz00_7821); } 
BgL_stringzd2ze3keyz31_1003 = 
VECTOR_REF(BgL_opt1394z00_264,BgL_auxz00_7820); }  else 
{ /* Llib/block_ciphers.scm 801 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_arg2011z00_1024;obj_t BgL_arg2012z00_1025;obj_t BgL_arg2013z00_1026;
BgL_arg2011z00_1024 = 
VECTOR_REF(BgL_opt1394z00_264,((long)0)); 
BgL_arg2012z00_1025 = 
VECTOR_REF(BgL_opt1394z00_264,((long)1)); 
BgL_arg2013z00_1026 = 
VECTOR_REF(BgL_opt1394z00_264,((long)2)); 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_ivz00_1027;
BgL_ivz00_1027 = BgL_ivz00_998; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_modez00_1028;
BgL_modez00_1028 = BgL_modez00_999; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2initz12zc0_1029;
BgL_noncezd2initz12zc0_1029 = BgL_noncezd2initz12zc0_1000; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_noncezd2updatez12zc0_1030;
BgL_noncezd2updatez12zc0_1030 = BgL_noncezd2updatez12zc0_1001; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_padz00_1031;
BgL_padz00_1031 = BgL_padz00_1002; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_stringzd2ze3keyz31_1032;
BgL_stringzd2ze3keyz31_1032 = BgL_stringzd2ze3keyz31_1003; 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_res2687z00_3026;
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_cipherz00_3018;obj_t BgL_plaintextz00_3019;obj_t BgL_passwordz00_3020;
if(
SYMBOLP(BgL_arg2011z00_1024))
{ /* Llib/block_ciphers.scm 801 */
BgL_cipherz00_3018 = BgL_arg2011z00_1024; }  else 
{ 
obj_t BgL_auxz00_7835;
BgL_auxz00_7835 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2011z00_1024); 
FAILURE(BgL_auxz00_7835,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2012z00_1025))
{ /* Llib/block_ciphers.scm 801 */
BgL_plaintextz00_3019 = BgL_arg2012z00_1025; }  else 
{ 
obj_t BgL_auxz00_7841;
BgL_auxz00_7841 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2012z00_1025); 
FAILURE(BgL_auxz00_7841,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2013z00_1026))
{ /* Llib/block_ciphers.scm 801 */
BgL_passwordz00_3020 = BgL_arg2013z00_1026; }  else 
{ 
obj_t BgL_auxz00_7847;
BgL_auxz00_7847 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29107)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2013z00_1026); 
FAILURE(BgL_auxz00_7847,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3022;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3023;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3022 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3023 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3018, BgL_passwordz00_3020, BgL_ivz00_1027, BgL_modez00_1028, BgL_padz00_1031, BgL_noncezd2initz12zc0_1029, BgL_noncezd2updatez12zc0_1030, BgL_stringzd2ze3keyz31_1032); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3023, BgL_plaintextz00_3019, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3022, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 819 */
obj_t BgL_aux2876z00_5232;
BgL_aux2876z00_5232 = 
bgl_close_output_port(BgL_pz00_3022); 
if(
STRINGP(BgL_aux2876z00_5232))
{ /* Llib/block_ciphers.scm 819 */
BgL_res2687z00_3026 = BgL_aux2876z00_5232; }  else 
{ 
obj_t BgL_auxz00_7857;
BgL_auxz00_7857 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29795)), BGl_string3211z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_aux2876z00_5232); 
FAILURE(BgL_auxz00_7857,BFALSE,BFALSE);} } } } 
return BgL_res2687z00_3026;} } } } } } } } } } } } } } } } } 

}



/* search1397~0 */
obj_t BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1396z00_5091, obj_t BgL_opt1394z00_5090, obj_t BgL_k1z00_992, long BgL_iz00_993)
{
{ /* Llib/block_ciphers.scm 801 */
BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_993==BgL_l1396z00_5091))
{ /* Llib/block_ciphers.scm 801 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 801 */
if(
(BgL_iz00_993==
(BgL_l1396z00_5091-((long)1))))
{ /* Llib/block_ciphers.scm 801 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1394z00_5090)));}  else 
{ /* Llib/block_ciphers.scm 801 */
obj_t BgL_vz00_1037;
BgL_vz00_1037 = 
VECTOR_REF(BgL_opt1394z00_5090,BgL_iz00_993); 
if(
(BgL_vz00_1037==BgL_k1z00_992))
{ /* Llib/block_ciphers.scm 801 */
return 
BINT(
(BgL_iz00_993+((long)1)));}  else 
{ 
long BgL_iz00_7876;
BgL_iz00_7876 = 
(BgL_iz00_993+((long)2)); 
BgL_iz00_993 = BgL_iz00_7876; 
goto BGl_search1397ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* encrypt-port */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_255, obj_t BgL_plaintextz00_256, obj_t BgL_passwordz00_257, obj_t BgL_ivz00_258, obj_t BgL_modez00_259, obj_t BgL_noncezd2initz12zc0_260, obj_t BgL_noncezd2updatez12zc0_261, obj_t BgL_padz00_262, obj_t BgL_stringzd2ze3keyz31_263)
{
{ /* Llib/block_ciphers.scm 801 */
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3028;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3029;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3028 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3029 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_255, BgL_passwordz00_257, BgL_ivz00_258, BgL_modez00_259, BgL_padz00_262, BgL_noncezd2initz12zc0_260, BgL_noncezd2updatez12zc0_261, BgL_stringzd2ze3keyz31_263); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3029, BgL_plaintextz00_256, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3028, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_3028);} } 

}



/* &encrypt-fast-port */
obj_t BGl_z62encryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4426, obj_t BgL_cipherz00_4427, obj_t BgL_plaintextz00_4428, obj_t BgL_passwordz00_4429, obj_t BgL_ivz00_4430, obj_t BgL_modez00_4431, obj_t BgL_padz00_4432, obj_t BgL_noncezd2initz12zc0_4433, obj_t BgL_noncezd2updatez12zc0_4434, obj_t BgL_stringzd2ze3keyz31_4435)
{
{ /* Llib/block_ciphers.scm 809 */
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_plaintextz00_5605;
if(
INPUT_PORTP(BgL_plaintextz00_4428))
{ /* Llib/block_ciphers.scm 812 */
BgL_plaintextz00_5605 = BgL_plaintextz00_4428; }  else 
{ 
obj_t BgL_auxz00_7884;
BgL_auxz00_7884 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29553)), BGl_string3213z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_plaintextz00_4428); 
FAILURE(BgL_auxz00_7884,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_5606;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_5607;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_5606 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_5607 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4427, BgL_passwordz00_4429, BgL_ivz00_4430, BgL_modez00_4431, BgL_padz00_4432, BgL_noncezd2initz12zc0_4433, BgL_noncezd2updatez12zc0_4434, BgL_stringzd2ze3keyz31_4435); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_5607, BgL_plaintextz00_5605, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_5606, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_5606);} } } 

}



/* _encrypt-file */
obj_t BGl__encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1407z00_285, obj_t BgL_opt1406z00_284)
{
{ /* Llib/block_ciphers.scm 821 */
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_cipherz00_1048;obj_t BgL_filenamez00_1049;obj_t BgL_passwordz00_1050;
BgL_cipherz00_1048 = 
VECTOR_REF(BgL_opt1406z00_284,((long)0)); 
BgL_filenamez00_1049 = 
VECTOR_REF(BgL_opt1406z00_284,((long)1)); 
BgL_passwordz00_1050 = 
VECTOR_REF(BgL_opt1406z00_284,((long)2)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_ivz00_1051;
BgL_ivz00_1051 = BFALSE; 
{ /* Llib/block_ciphers.scm 822 */
obj_t BgL_modez00_1052;
BgL_modez00_1052 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2initz12zc0_1053;
BgL_noncezd2initz12zc0_1053 = BFALSE; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2updatez12zc0_1054;
BgL_noncezd2updatez12zc0_1054 = BFALSE; 
{ /* Llib/block_ciphers.scm 822 */
obj_t BgL_padz00_1055;
BgL_padz00_1055 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_stringzd2ze3keyz31_1056;
BgL_stringzd2ze3keyz31_1056 = BFALSE; 
{ /* Llib/block_ciphers.scm 821 */

{ 
long BgL_iz00_1057;
BgL_iz00_1057 = ((long)3); 
BgL_check1410z00_1058:
if(
(BgL_iz00_1057==
VECTOR_LENGTH(BgL_opt1406z00_284)))
{ /* Llib/block_ciphers.scm 821 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3844z00_7900;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg2026z00_1064;
BgL_arg2026z00_1064 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_iz00_1057); 
BgL_test3844z00_7900 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2026z00_1064, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3844z00_7900)
{ 
long BgL_iz00_7905;
BgL_iz00_7905 = 
(BgL_iz00_1057+((long)2)); 
BgL_iz00_1057 = BgL_iz00_7905; 
goto BgL_check1410z00_1058;}  else 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg2025z00_1063;
BgL_arg2025z00_1063 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_iz00_1057); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2025z00_1063); } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1412z00_1065;
BgL_index1412z00_1065 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3845z00_7913;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3051;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7914;
if(
INTEGERP(BgL_index1412z00_1065))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7914 = BgL_index1412z00_1065
; }  else 
{ 
obj_t BgL_auxz00_7917;
BgL_auxz00_7917 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1412z00_1065); 
FAILURE(BgL_auxz00_7917,BFALSE,BFALSE);} 
BgL_n1z00_3051 = 
(long)CINT(BgL_tmpz00_7914); } 
BgL_test3845z00_7913 = 
(BgL_n1z00_3051>=((long)0)); } 
if(BgL_test3845z00_7913)
{ 
long BgL_auxz00_7923;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7924;
if(
INTEGERP(BgL_index1412z00_1065))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7924 = BgL_index1412z00_1065
; }  else 
{ 
obj_t BgL_auxz00_7927;
BgL_auxz00_7927 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1412z00_1065); 
FAILURE(BgL_auxz00_7927,BFALSE,BFALSE);} 
BgL_auxz00_7923 = 
(long)CINT(BgL_tmpz00_7924); } 
BgL_ivz00_1051 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_7923); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1413z00_1067;
BgL_index1413z00_1067 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3848z00_7936;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3052;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7937;
if(
INTEGERP(BgL_index1413z00_1067))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7937 = BgL_index1413z00_1067
; }  else 
{ 
obj_t BgL_auxz00_7940;
BgL_auxz00_7940 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1413z00_1067); 
FAILURE(BgL_auxz00_7940,BFALSE,BFALSE);} 
BgL_n1z00_3052 = 
(long)CINT(BgL_tmpz00_7937); } 
BgL_test3848z00_7936 = 
(BgL_n1z00_3052>=((long)0)); } 
if(BgL_test3848z00_7936)
{ 
long BgL_auxz00_7946;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7947;
if(
INTEGERP(BgL_index1413z00_1067))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7947 = BgL_index1413z00_1067
; }  else 
{ 
obj_t BgL_auxz00_7950;
BgL_auxz00_7950 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1413z00_1067); 
FAILURE(BgL_auxz00_7950,BFALSE,BFALSE);} 
BgL_auxz00_7946 = 
(long)CINT(BgL_tmpz00_7947); } 
BgL_modez00_1052 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_7946); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1414z00_1069;
BgL_index1414z00_1069 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3851z00_7959;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3053;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7960;
if(
INTEGERP(BgL_index1414z00_1069))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7960 = BgL_index1414z00_1069
; }  else 
{ 
obj_t BgL_auxz00_7963;
BgL_auxz00_7963 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1414z00_1069); 
FAILURE(BgL_auxz00_7963,BFALSE,BFALSE);} 
BgL_n1z00_3053 = 
(long)CINT(BgL_tmpz00_7960); } 
BgL_test3851z00_7959 = 
(BgL_n1z00_3053>=((long)0)); } 
if(BgL_test3851z00_7959)
{ 
long BgL_auxz00_7969;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7970;
if(
INTEGERP(BgL_index1414z00_1069))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7970 = BgL_index1414z00_1069
; }  else 
{ 
obj_t BgL_auxz00_7973;
BgL_auxz00_7973 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1414z00_1069); 
FAILURE(BgL_auxz00_7973,BFALSE,BFALSE);} 
BgL_auxz00_7969 = 
(long)CINT(BgL_tmpz00_7970); } 
BgL_noncezd2initz12zc0_1053 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_7969); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1415z00_1071;
BgL_index1415z00_1071 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3854z00_7982;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3054;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7983;
if(
INTEGERP(BgL_index1415z00_1071))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7983 = BgL_index1415z00_1071
; }  else 
{ 
obj_t BgL_auxz00_7986;
BgL_auxz00_7986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1415z00_1071); 
FAILURE(BgL_auxz00_7986,BFALSE,BFALSE);} 
BgL_n1z00_3054 = 
(long)CINT(BgL_tmpz00_7983); } 
BgL_test3854z00_7982 = 
(BgL_n1z00_3054>=((long)0)); } 
if(BgL_test3854z00_7982)
{ 
long BgL_auxz00_7992;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_7993;
if(
INTEGERP(BgL_index1415z00_1071))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_7993 = BgL_index1415z00_1071
; }  else 
{ 
obj_t BgL_auxz00_7996;
BgL_auxz00_7996 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1415z00_1071); 
FAILURE(BgL_auxz00_7996,BFALSE,BFALSE);} 
BgL_auxz00_7992 = 
(long)CINT(BgL_tmpz00_7993); } 
BgL_noncezd2updatez12zc0_1054 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_7992); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1416z00_1073;
BgL_index1416z00_1073 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3857z00_8005;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3055;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8006;
if(
INTEGERP(BgL_index1416z00_1073))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8006 = BgL_index1416z00_1073
; }  else 
{ 
obj_t BgL_auxz00_8009;
BgL_auxz00_8009 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1416z00_1073); 
FAILURE(BgL_auxz00_8009,BFALSE,BFALSE);} 
BgL_n1z00_3055 = 
(long)CINT(BgL_tmpz00_8006); } 
BgL_test3857z00_8005 = 
(BgL_n1z00_3055>=((long)0)); } 
if(BgL_test3857z00_8005)
{ 
long BgL_auxz00_8015;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8016;
if(
INTEGERP(BgL_index1416z00_1073))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8016 = BgL_index1416z00_1073
; }  else 
{ 
obj_t BgL_auxz00_8019;
BgL_auxz00_8019 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1416z00_1073); 
FAILURE(BgL_auxz00_8019,BFALSE,BFALSE);} 
BgL_auxz00_8015 = 
(long)CINT(BgL_tmpz00_8016); } 
BgL_padz00_1055 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_8015); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_index1417z00_1075;
BgL_index1417z00_1075 = 
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1406z00_284), BgL_opt1406z00_284, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 821 */
bool_t BgL_test3860z00_8028;
{ /* Llib/block_ciphers.scm 821 */
long BgL_n1z00_3056;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8029;
if(
INTEGERP(BgL_index1417z00_1075))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8029 = BgL_index1417z00_1075
; }  else 
{ 
obj_t BgL_auxz00_8032;
BgL_auxz00_8032 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1417z00_1075); 
FAILURE(BgL_auxz00_8032,BFALSE,BFALSE);} 
BgL_n1z00_3056 = 
(long)CINT(BgL_tmpz00_8029); } 
BgL_test3860z00_8028 = 
(BgL_n1z00_3056>=((long)0)); } 
if(BgL_test3860z00_8028)
{ 
long BgL_auxz00_8038;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_tmpz00_8039;
if(
INTEGERP(BgL_index1417z00_1075))
{ /* Llib/block_ciphers.scm 821 */
BgL_tmpz00_8039 = BgL_index1417z00_1075
; }  else 
{ 
obj_t BgL_auxz00_8042;
BgL_auxz00_8042 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1417z00_1075); 
FAILURE(BgL_auxz00_8042,BFALSE,BFALSE);} 
BgL_auxz00_8038 = 
(long)CINT(BgL_tmpz00_8039); } 
BgL_stringzd2ze3keyz31_1056 = 
VECTOR_REF(BgL_opt1406z00_284,BgL_auxz00_8038); }  else 
{ /* Llib/block_ciphers.scm 821 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_arg2033z00_1077;obj_t BgL_arg2034z00_1078;obj_t BgL_arg2035z00_1079;
BgL_arg2033z00_1077 = 
VECTOR_REF(BgL_opt1406z00_284,((long)0)); 
BgL_arg2034z00_1078 = 
VECTOR_REF(BgL_opt1406z00_284,((long)1)); 
BgL_arg2035z00_1079 = 
VECTOR_REF(BgL_opt1406z00_284,((long)2)); 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_ivz00_1080;
BgL_ivz00_1080 = BgL_ivz00_1051; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_modez00_1081;
BgL_modez00_1081 = BgL_modez00_1052; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2initz12zc0_1082;
BgL_noncezd2initz12zc0_1082 = BgL_noncezd2initz12zc0_1053; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_noncezd2updatez12zc0_1083;
BgL_noncezd2updatez12zc0_1083 = BgL_noncezd2updatez12zc0_1054; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_padz00_1084;
BgL_padz00_1084 = BgL_padz00_1055; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_stringzd2ze3keyz31_1085;
BgL_stringzd2ze3keyz31_1085 = BgL_stringzd2ze3keyz31_1056; 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_res2688z00_3074;
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_cipherz00_3057;obj_t BgL_filenamez00_3058;obj_t BgL_passwordz00_3059;
if(
SYMBOLP(BgL_arg2033z00_1077))
{ /* Llib/block_ciphers.scm 821 */
BgL_cipherz00_3057 = BgL_arg2033z00_1077; }  else 
{ 
obj_t BgL_auxz00_8053;
BgL_auxz00_8053 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2033z00_1077); 
FAILURE(BgL_auxz00_8053,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2034z00_1078))
{ /* Llib/block_ciphers.scm 821 */
BgL_filenamez00_3058 = BgL_arg2034z00_1078; }  else 
{ 
obj_t BgL_auxz00_8059;
BgL_auxz00_8059 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2034z00_1078); 
FAILURE(BgL_auxz00_8059,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2035z00_1079))
{ /* Llib/block_ciphers.scm 821 */
BgL_passwordz00_3059 = BgL_arg2035z00_1079; }  else 
{ 
obj_t BgL_auxz00_8065;
BgL_auxz00_8065 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)29820)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2035z00_1079); 
FAILURE(BgL_auxz00_8065,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 825 */
obj_t BgL_pz00_3060;
{ /* Llib/block_ciphers.scm 825 */

BgL_pz00_3060 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_3058, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3060))
{ /* Llib/block_ciphers.scm 826 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 826 */
BGl_errorz00zz__errorz00(BGl_string3215z00zz__cryptozd2blockzd2ciphersz00, BGl_string3216z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_3058); } 
{ /* Llib/block_ciphers.scm 830 */
obj_t BgL_exitd1231z00_3064;
BgL_exitd1231z00_3064 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_zc3z04anonymousza32043ze3z87_4442;
BgL_zc3z04anonymousza32043ze3z87_4442 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32043ze3ze5zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32043ze3z87_4442, 
(int)(((long)0)), BgL_pz00_3060); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1231z00_3064, BgL_zc3z04anonymousza32043ze3z87_4442); 
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_tmp1233z00_3066;
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_plaintextz00_3068;
if(
INPUT_PORTP(BgL_pz00_3060))
{ /* Llib/block_ciphers.scm 831 */
BgL_plaintextz00_3068 = BgL_pz00_3060; }  else 
{ 
obj_t BgL_auxz00_8083;
BgL_auxz00_8083 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30188)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3060); 
FAILURE(BgL_auxz00_8083,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3069;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3070;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3069 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3070 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3057, BgL_passwordz00_3059, BgL_ivz00_1080, BgL_modez00_1081, BgL_padz00_1084, BgL_noncezd2initz12zc0_1082, BgL_noncezd2updatez12zc0_1083, BgL_stringzd2ze3keyz31_1085); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3070, BgL_plaintextz00_3068, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3069, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_tmp1233z00_3066 = 
bgl_close_output_port(BgL_pz00_3069); } } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1231z00_3064); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_portz00_3073;
if(
INPUT_PORTP(BgL_pz00_3060))
{ /* Llib/block_ciphers.scm 834 */
BgL_portz00_3073 = BgL_pz00_3060; }  else 
{ 
obj_t BgL_auxz00_8094;
BgL_auxz00_8094 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30284)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3060); 
FAILURE(BgL_auxz00_8094,BFALSE,BFALSE);} 
bgl_close_input_port(BgL_portz00_3073); } 
if(
STRINGP(BgL_tmp1233z00_3066))
{ /* Llib/block_ciphers.scm 830 */
BgL_res2688z00_3074 = BgL_tmp1233z00_3066; }  else 
{ 
obj_t BgL_auxz00_8101;
BgL_auxz00_8101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30144)), BGl_string3214z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_tmp1233z00_3066); 
FAILURE(BgL_auxz00_8101,BFALSE,BFALSE);} } } } } } 
return BgL_res2688z00_3074;} } } } } } } } } } } } } } } } } 

}



/* search1409~0 */
obj_t BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1408z00_5089, obj_t BgL_opt1406z00_5088, obj_t BgL_k1z00_1045, long BgL_iz00_1046)
{
{ /* Llib/block_ciphers.scm 821 */
BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1046==BgL_l1408z00_5089))
{ /* Llib/block_ciphers.scm 821 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 821 */
if(
(BgL_iz00_1046==
(BgL_l1408z00_5089-((long)1))))
{ /* Llib/block_ciphers.scm 821 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1406z00_5088)));}  else 
{ /* Llib/block_ciphers.scm 821 */
obj_t BgL_vz00_1090;
BgL_vz00_1090 = 
VECTOR_REF(BgL_opt1406z00_5088,BgL_iz00_1046); 
if(
(BgL_vz00_1090==BgL_k1z00_1045))
{ /* Llib/block_ciphers.scm 821 */
return 
BINT(
(BgL_iz00_1046+((long)1)));}  else 
{ 
long BgL_iz00_8120;
BgL_iz00_8120 = 
(BgL_iz00_1046+((long)2)); 
BgL_iz00_1046 = BgL_iz00_8120; 
goto BGl_search1409ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* &<@anonymous:2043> */
obj_t BGl_z62zc3z04anonymousza32043ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4443)
{
{ /* Llib/block_ciphers.scm 830 */
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_pz00_4444;
BgL_pz00_4444 = 
PROCEDURE_REF(BgL_envz00_4443, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_4444));} } 

}



/* encrypt-file */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_275, obj_t BgL_filenamez00_276, obj_t BgL_passwordz00_277, obj_t BgL_ivz00_278, obj_t BgL_modez00_279, obj_t BgL_noncezd2initz12zc0_280, obj_t BgL_noncezd2updatez12zc0_281, obj_t BgL_padz00_282, obj_t BgL_stringzd2ze3keyz31_283)
{
{ /* Llib/block_ciphers.scm 821 */
{ /* Llib/block_ciphers.scm 825 */
obj_t BgL_pz00_3075;
{ /* Llib/block_ciphers.scm 825 */

BgL_pz00_3075 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_276, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3075))
{ /* Llib/block_ciphers.scm 826 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 826 */
BGl_errorz00zz__errorz00(BGl_string3215z00zz__cryptozd2blockzd2ciphersz00, BGl_string3216z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_276); } 
{ /* Llib/block_ciphers.scm 830 */
obj_t BgL_exitd1231z00_3079;
BgL_exitd1231z00_3079 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_zc3z04anonymousza32043ze3z87_4445;
BgL_zc3z04anonymousza32043ze3z87_4445 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32043ze32744ze5zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32043ze3z87_4445, 
(int)(((long)0)), BgL_pz00_3075); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1231z00_3079, BgL_zc3z04anonymousza32043ze3z87_4445); 
{ /* Llib/block_ciphers.scm 831 */
obj_t BgL_tmp1233z00_3081;
{ /* Llib/block_ciphers.scm 812 */
obj_t BgL_pz00_3084;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3085;
{ /* Llib/block_ciphers.scm 812 */

{ /* Llib/block_ciphers.scm 812 */

BgL_pz00_3084 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3085 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_275, BgL_passwordz00_277, BgL_ivz00_278, BgL_modez00_279, BgL_padz00_282, BgL_noncezd2initz12zc0_280, BgL_noncezd2updatez12zc0_281, BgL_stringzd2ze3keyz31_283); 
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3085, 
((obj_t)BgL_pz00_3075), ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3084, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_tmp1233z00_3081 = 
bgl_close_output_port(BgL_pz00_3084); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1231z00_3079); 
bgl_close_input_port(
((obj_t)BgL_pz00_3075)); 
return BgL_tmp1233z00_3081;} } } } } 

}



/* &<@anonymous:2043>2744 */
obj_t BGl_z62zc3z04anonymousza32043ze32744ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4446)
{
{ /* Llib/block_ciphers.scm 830 */
{ /* Llib/block_ciphers.scm 834 */
obj_t BgL_pz00_4447;
BgL_pz00_4447 = 
PROCEDURE_REF(BgL_envz00_4446, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_4447));} } 

}



/* _encrypt-sendchars */
obj_t BGl__encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1419z00_297, obj_t BgL_opt1418z00_296)
{
{ /* Llib/block_ciphers.scm 836 */
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_cipherz00_1107;obj_t BgL_inz00_1108;obj_t BgL_outz00_1109;obj_t BgL_passwordz00_1110;
BgL_cipherz00_1107 = 
VECTOR_REF(BgL_opt1418z00_296,((long)0)); 
BgL_inz00_1108 = 
VECTOR_REF(BgL_opt1418z00_296,((long)1)); 
BgL_outz00_1109 = 
VECTOR_REF(BgL_opt1418z00_296,((long)2)); 
BgL_passwordz00_1110 = 
VECTOR_REF(BgL_opt1418z00_296,((long)3)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_ivz00_1111;
BgL_ivz00_1111 = BFALSE; 
{ /* Llib/block_ciphers.scm 838 */
obj_t BgL_modez00_1112;
BgL_modez00_1112 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2initz12zc0_1113;
BgL_noncezd2initz12zc0_1113 = BFALSE; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2updatez12zc0_1114;
BgL_noncezd2updatez12zc0_1114 = BFALSE; 
{ /* Llib/block_ciphers.scm 838 */
obj_t BgL_padz00_1115;
BgL_padz00_1115 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_stringzd2ze3keyz31_1116;
BgL_stringzd2ze3keyz31_1116 = BFALSE; 
{ /* Llib/block_ciphers.scm 836 */

{ 
long BgL_iz00_1117;
BgL_iz00_1117 = ((long)4); 
BgL_check1422z00_1118:
if(
(BgL_iz00_1117==
VECTOR_LENGTH(BgL_opt1418z00_296)))
{ /* Llib/block_ciphers.scm 836 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3875z00_8159;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2049z00_1124;
BgL_arg2049z00_1124 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_iz00_1117); 
BgL_test3875z00_8159 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2049z00_1124, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3875z00_8159)
{ 
long BgL_iz00_8164;
BgL_iz00_8164 = 
(BgL_iz00_1117+((long)2)); 
BgL_iz00_1117 = BgL_iz00_8164; 
goto BgL_check1422z00_1118;}  else 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2048z00_1123;
BgL_arg2048z00_1123 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_iz00_1117); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2048z00_1123); } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1424z00_1125;
BgL_index1424z00_1125 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)19)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3876z00_8172;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3104;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8173;
if(
INTEGERP(BgL_index1424z00_1125))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8173 = BgL_index1424z00_1125
; }  else 
{ 
obj_t BgL_auxz00_8176;
BgL_auxz00_8176 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1424z00_1125); 
FAILURE(BgL_auxz00_8176,BFALSE,BFALSE);} 
BgL_n1z00_3104 = 
(long)CINT(BgL_tmpz00_8173); } 
BgL_test3876z00_8172 = 
(BgL_n1z00_3104>=((long)0)); } 
if(BgL_test3876z00_8172)
{ 
long BgL_auxz00_8182;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8183;
if(
INTEGERP(BgL_index1424z00_1125))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8183 = BgL_index1424z00_1125
; }  else 
{ 
obj_t BgL_auxz00_8186;
BgL_auxz00_8186 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1424z00_1125); 
FAILURE(BgL_auxz00_8186,BFALSE,BFALSE);} 
BgL_auxz00_8182 = 
(long)CINT(BgL_tmpz00_8183); } 
BgL_ivz00_1111 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8182); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1425z00_1127;
BgL_index1425z00_1127 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)20)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3879z00_8195;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3105;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8196;
if(
INTEGERP(BgL_index1425z00_1127))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8196 = BgL_index1425z00_1127
; }  else 
{ 
obj_t BgL_auxz00_8199;
BgL_auxz00_8199 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1425z00_1127); 
FAILURE(BgL_auxz00_8199,BFALSE,BFALSE);} 
BgL_n1z00_3105 = 
(long)CINT(BgL_tmpz00_8196); } 
BgL_test3879z00_8195 = 
(BgL_n1z00_3105>=((long)0)); } 
if(BgL_test3879z00_8195)
{ 
long BgL_auxz00_8205;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8206;
if(
INTEGERP(BgL_index1425z00_1127))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8206 = BgL_index1425z00_1127
; }  else 
{ 
obj_t BgL_auxz00_8209;
BgL_auxz00_8209 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1425z00_1127); 
FAILURE(BgL_auxz00_8209,BFALSE,BFALSE);} 
BgL_auxz00_8205 = 
(long)CINT(BgL_tmpz00_8206); } 
BgL_modez00_1112 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8205); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1426z00_1129;
BgL_index1426z00_1129 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)21)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3882z00_8218;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3106;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8219;
if(
INTEGERP(BgL_index1426z00_1129))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8219 = BgL_index1426z00_1129
; }  else 
{ 
obj_t BgL_auxz00_8222;
BgL_auxz00_8222 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1426z00_1129); 
FAILURE(BgL_auxz00_8222,BFALSE,BFALSE);} 
BgL_n1z00_3106 = 
(long)CINT(BgL_tmpz00_8219); } 
BgL_test3882z00_8218 = 
(BgL_n1z00_3106>=((long)0)); } 
if(BgL_test3882z00_8218)
{ 
long BgL_auxz00_8228;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8229;
if(
INTEGERP(BgL_index1426z00_1129))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8229 = BgL_index1426z00_1129
; }  else 
{ 
obj_t BgL_auxz00_8232;
BgL_auxz00_8232 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1426z00_1129); 
FAILURE(BgL_auxz00_8232,BFALSE,BFALSE);} 
BgL_auxz00_8228 = 
(long)CINT(BgL_tmpz00_8229); } 
BgL_noncezd2initz12zc0_1113 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8228); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1427z00_1131;
BgL_index1427z00_1131 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)22)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3885z00_8241;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3107;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8242;
if(
INTEGERP(BgL_index1427z00_1131))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8242 = BgL_index1427z00_1131
; }  else 
{ 
obj_t BgL_auxz00_8245;
BgL_auxz00_8245 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1427z00_1131); 
FAILURE(BgL_auxz00_8245,BFALSE,BFALSE);} 
BgL_n1z00_3107 = 
(long)CINT(BgL_tmpz00_8242); } 
BgL_test3885z00_8241 = 
(BgL_n1z00_3107>=((long)0)); } 
if(BgL_test3885z00_8241)
{ 
long BgL_auxz00_8251;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8252;
if(
INTEGERP(BgL_index1427z00_1131))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8252 = BgL_index1427z00_1131
; }  else 
{ 
obj_t BgL_auxz00_8255;
BgL_auxz00_8255 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1427z00_1131); 
FAILURE(BgL_auxz00_8255,BFALSE,BFALSE);} 
BgL_auxz00_8251 = 
(long)CINT(BgL_tmpz00_8252); } 
BgL_noncezd2updatez12zc0_1114 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8251); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1428z00_1133;
BgL_index1428z00_1133 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)23)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3888z00_8264;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3108;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8265;
if(
INTEGERP(BgL_index1428z00_1133))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8265 = BgL_index1428z00_1133
; }  else 
{ 
obj_t BgL_auxz00_8268;
BgL_auxz00_8268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1428z00_1133); 
FAILURE(BgL_auxz00_8268,BFALSE,BFALSE);} 
BgL_n1z00_3108 = 
(long)CINT(BgL_tmpz00_8265); } 
BgL_test3888z00_8264 = 
(BgL_n1z00_3108>=((long)0)); } 
if(BgL_test3888z00_8264)
{ 
long BgL_auxz00_8274;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8275;
if(
INTEGERP(BgL_index1428z00_1133))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8275 = BgL_index1428z00_1133
; }  else 
{ 
obj_t BgL_auxz00_8278;
BgL_auxz00_8278 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1428z00_1133); 
FAILURE(BgL_auxz00_8278,BFALSE,BFALSE);} 
BgL_auxz00_8274 = 
(long)CINT(BgL_tmpz00_8275); } 
BgL_padz00_1115 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8274); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_index1429z00_1135;
BgL_index1429z00_1135 = 
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1418z00_296), BgL_opt1418z00_296, 
CNST_TABLE_REF(((long)24)), ((long)4)); 
{ /* Llib/block_ciphers.scm 836 */
bool_t BgL_test3891z00_8287;
{ /* Llib/block_ciphers.scm 836 */
long BgL_n1z00_3109;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8288;
if(
INTEGERP(BgL_index1429z00_1135))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8288 = BgL_index1429z00_1135
; }  else 
{ 
obj_t BgL_auxz00_8291;
BgL_auxz00_8291 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1429z00_1135); 
FAILURE(BgL_auxz00_8291,BFALSE,BFALSE);} 
BgL_n1z00_3109 = 
(long)CINT(BgL_tmpz00_8288); } 
BgL_test3891z00_8287 = 
(BgL_n1z00_3109>=((long)0)); } 
if(BgL_test3891z00_8287)
{ 
long BgL_auxz00_8297;
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_tmpz00_8298;
if(
INTEGERP(BgL_index1429z00_1135))
{ /* Llib/block_ciphers.scm 836 */
BgL_tmpz00_8298 = BgL_index1429z00_1135
; }  else 
{ 
obj_t BgL_auxz00_8301;
BgL_auxz00_8301 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1429z00_1135); 
FAILURE(BgL_auxz00_8301,BFALSE,BFALSE);} 
BgL_auxz00_8297 = 
(long)CINT(BgL_tmpz00_8298); } 
BgL_stringzd2ze3keyz31_1116 = 
VECTOR_REF(BgL_opt1418z00_296,BgL_auxz00_8297); }  else 
{ /* Llib/block_ciphers.scm 836 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_arg2056z00_1137;obj_t BgL_arg2057z00_1138;obj_t BgL_arg2058z00_1139;obj_t BgL_arg2059z00_1140;
BgL_arg2056z00_1137 = 
VECTOR_REF(BgL_opt1418z00_296,((long)0)); 
BgL_arg2057z00_1138 = 
VECTOR_REF(BgL_opt1418z00_296,((long)1)); 
BgL_arg2058z00_1139 = 
VECTOR_REF(BgL_opt1418z00_296,((long)2)); 
BgL_arg2059z00_1140 = 
VECTOR_REF(BgL_opt1418z00_296,((long)3)); 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_ivz00_1141;
BgL_ivz00_1141 = BgL_ivz00_1111; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_modez00_1142;
BgL_modez00_1142 = BgL_modez00_1112; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2initz12zc0_1143;
BgL_noncezd2initz12zc0_1143 = BgL_noncezd2initz12zc0_1113; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_noncezd2updatez12zc0_1144;
BgL_noncezd2updatez12zc0_1144 = BgL_noncezd2updatez12zc0_1114; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_padz00_1145;
BgL_padz00_1145 = BgL_padz00_1115; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_stringzd2ze3keyz31_1146;
BgL_stringzd2ze3keyz31_1146 = BgL_stringzd2ze3keyz31_1116; 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_cipherz00_3110;obj_t BgL_inz00_3111;obj_t BgL_outz00_3112;obj_t BgL_passwordz00_3113;
if(
SYMBOLP(BgL_arg2056z00_1137))
{ /* Llib/block_ciphers.scm 836 */
BgL_cipherz00_3110 = BgL_arg2056z00_1137; }  else 
{ 
obj_t BgL_auxz00_8313;
BgL_auxz00_8313 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2056z00_1137); 
FAILURE(BgL_auxz00_8313,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2057z00_1138))
{ /* Llib/block_ciphers.scm 836 */
BgL_inz00_3111 = BgL_arg2057z00_1138; }  else 
{ 
obj_t BgL_auxz00_8319;
BgL_auxz00_8319 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2057z00_1138); 
FAILURE(BgL_auxz00_8319,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg2058z00_1139))
{ /* Llib/block_ciphers.scm 836 */
BgL_outz00_3112 = BgL_arg2058z00_1139; }  else 
{ 
obj_t BgL_auxz00_8325;
BgL_auxz00_8325 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3218z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2058z00_1139); 
FAILURE(BgL_auxz00_8325,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2059z00_1140))
{ /* Llib/block_ciphers.scm 836 */
BgL_passwordz00_3113 = BgL_arg2059z00_1140; }  else 
{ 
obj_t BgL_auxz00_8331;
BgL_auxz00_8331 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30291)), BGl_string3217z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2059z00_1140); 
FAILURE(BgL_auxz00_8331,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 841 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3114;
BgL_statez00_3114 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3110, BgL_passwordz00_3113, BgL_ivz00_1141, BgL_modez00_1142, BgL_padz00_1145, BgL_noncezd2initz12zc0_1143, BgL_noncezd2updatez12zc0_1144, BgL_stringzd2ze3keyz31_1146); 
return 
BINT(
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3114, BgL_inz00_3111, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_3112, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } } } } } } } } } } } } } } } } } 

}



/* search1421~0 */
obj_t BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1420z00_5087, obj_t BgL_opt1418z00_5086, obj_t BgL_k1z00_1104, long BgL_iz00_1105)
{
{ /* Llib/block_ciphers.scm 836 */
BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1105==BgL_l1420z00_5087))
{ /* Llib/block_ciphers.scm 836 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 836 */
if(
(BgL_iz00_1105==
(BgL_l1420z00_5087-((long)1))))
{ /* Llib/block_ciphers.scm 836 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string3219z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1418z00_5086)));}  else 
{ /* Llib/block_ciphers.scm 836 */
obj_t BgL_vz00_1151;
BgL_vz00_1151 = 
VECTOR_REF(BgL_opt1418z00_5086,BgL_iz00_1105); 
if(
(BgL_vz00_1151==BgL_k1z00_1104))
{ /* Llib/block_ciphers.scm 836 */
return 
BINT(
(BgL_iz00_1105+((long)1)));}  else 
{ 
long BgL_iz00_8353;
BgL_iz00_8353 = 
(BgL_iz00_1105+((long)2)); 
BgL_iz00_1105 = BgL_iz00_8353; 
goto BGl_search1421ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* encrypt-sendchars */
BGL_EXPORTED_DEF obj_t BGl_encryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_286, obj_t BgL_inz00_287, obj_t BgL_outz00_288, obj_t BgL_passwordz00_289, obj_t BgL_ivz00_290, obj_t BgL_modez00_291, obj_t BgL_noncezd2initz12zc0_292, obj_t BgL_noncezd2updatez12zc0_293, obj_t BgL_padz00_294, obj_t BgL_stringzd2ze3keyz31_295)
{
{ /* Llib/block_ciphers.scm 836 */
{ /* Llib/block_ciphers.scm 841 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3115;
BgL_statez00_3115 = 
BGl_createzd2encryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_286, BgL_passwordz00_289, BgL_ivz00_290, BgL_modez00_291, BgL_padz00_294, BgL_noncezd2initz12zc0_292, BgL_noncezd2updatez12zc0_293, BgL_stringzd2ze3keyz31_295); 
return 
BINT(
BGl_encryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3115, BgL_inz00_287, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_288, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } 

}



/* _decrypt */
obj_t BGl__decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1431z00_308, obj_t BgL_opt1430z00_307)
{
{ /* Llib/block_ciphers.scm 850 */
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_cipherz00_1160;obj_t BgL_ciphertextz00_1161;obj_t BgL_passwordz00_1162;
BgL_cipherz00_1160 = 
VECTOR_REF(BgL_opt1430z00_307,((long)0)); 
BgL_ciphertextz00_1161 = 
VECTOR_REF(BgL_opt1430z00_307,((long)1)); 
BgL_passwordz00_1162 = 
VECTOR_REF(BgL_opt1430z00_307,((long)2)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_ivz00_1163;
BgL_ivz00_1163 = BFALSE; 
{ /* Llib/block_ciphers.scm 851 */
obj_t BgL_modez00_1164;
BgL_modez00_1164 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2initz12zc0_1165;
BgL_noncezd2initz12zc0_1165 = BFALSE; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2updatez12zc0_1166;
BgL_noncezd2updatez12zc0_1166 = BFALSE; 
{ /* Llib/block_ciphers.scm 851 */
obj_t BgL_padz00_1167;
BgL_padz00_1167 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_stringzd2ze3keyz31_1168;
BgL_stringzd2ze3keyz31_1168 = BFALSE; 
{ /* Llib/block_ciphers.scm 850 */

{ 
long BgL_iz00_1169;
BgL_iz00_1169 = ((long)3); 
BgL_check1434z00_1170:
if(
(BgL_iz00_1169==
VECTOR_LENGTH(BgL_opt1430z00_307)))
{ /* Llib/block_ciphers.scm 850 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3902z00_8366;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2072z00_1176;
BgL_arg2072z00_1176 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_iz00_1169); 
BgL_test3902z00_8366 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2072z00_1176, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3902z00_8366)
{ 
long BgL_iz00_8371;
BgL_iz00_8371 = 
(BgL_iz00_1169+((long)2)); 
BgL_iz00_1169 = BgL_iz00_8371; 
goto BgL_check1434z00_1170;}  else 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2071z00_1175;
BgL_arg2071z00_1175 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_iz00_1169); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2071z00_1175); } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1436z00_1177;
BgL_index1436z00_1177 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3903z00_8379;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3131;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8380;
if(
INTEGERP(BgL_index1436z00_1177))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8380 = BgL_index1436z00_1177
; }  else 
{ 
obj_t BgL_auxz00_8383;
BgL_auxz00_8383 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1436z00_1177); 
FAILURE(BgL_auxz00_8383,BFALSE,BFALSE);} 
BgL_n1z00_3131 = 
(long)CINT(BgL_tmpz00_8380); } 
BgL_test3903z00_8379 = 
(BgL_n1z00_3131>=((long)0)); } 
if(BgL_test3903z00_8379)
{ 
long BgL_auxz00_8389;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8390;
if(
INTEGERP(BgL_index1436z00_1177))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8390 = BgL_index1436z00_1177
; }  else 
{ 
obj_t BgL_auxz00_8393;
BgL_auxz00_8393 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1436z00_1177); 
FAILURE(BgL_auxz00_8393,BFALSE,BFALSE);} 
BgL_auxz00_8389 = 
(long)CINT(BgL_tmpz00_8390); } 
BgL_ivz00_1163 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8389); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1437z00_1179;
BgL_index1437z00_1179 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3906z00_8402;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3132;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8403;
if(
INTEGERP(BgL_index1437z00_1179))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8403 = BgL_index1437z00_1179
; }  else 
{ 
obj_t BgL_auxz00_8406;
BgL_auxz00_8406 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1437z00_1179); 
FAILURE(BgL_auxz00_8406,BFALSE,BFALSE);} 
BgL_n1z00_3132 = 
(long)CINT(BgL_tmpz00_8403); } 
BgL_test3906z00_8402 = 
(BgL_n1z00_3132>=((long)0)); } 
if(BgL_test3906z00_8402)
{ 
long BgL_auxz00_8412;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8413;
if(
INTEGERP(BgL_index1437z00_1179))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8413 = BgL_index1437z00_1179
; }  else 
{ 
obj_t BgL_auxz00_8416;
BgL_auxz00_8416 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1437z00_1179); 
FAILURE(BgL_auxz00_8416,BFALSE,BFALSE);} 
BgL_auxz00_8412 = 
(long)CINT(BgL_tmpz00_8413); } 
BgL_modez00_1164 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8412); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1438z00_1181;
BgL_index1438z00_1181 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3909z00_8425;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3133;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8426;
if(
INTEGERP(BgL_index1438z00_1181))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8426 = BgL_index1438z00_1181
; }  else 
{ 
obj_t BgL_auxz00_8429;
BgL_auxz00_8429 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1438z00_1181); 
FAILURE(BgL_auxz00_8429,BFALSE,BFALSE);} 
BgL_n1z00_3133 = 
(long)CINT(BgL_tmpz00_8426); } 
BgL_test3909z00_8425 = 
(BgL_n1z00_3133>=((long)0)); } 
if(BgL_test3909z00_8425)
{ 
long BgL_auxz00_8435;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8436;
if(
INTEGERP(BgL_index1438z00_1181))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8436 = BgL_index1438z00_1181
; }  else 
{ 
obj_t BgL_auxz00_8439;
BgL_auxz00_8439 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1438z00_1181); 
FAILURE(BgL_auxz00_8439,BFALSE,BFALSE);} 
BgL_auxz00_8435 = 
(long)CINT(BgL_tmpz00_8436); } 
BgL_noncezd2initz12zc0_1165 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8435); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1439z00_1183;
BgL_index1439z00_1183 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3912z00_8448;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3134;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8449;
if(
INTEGERP(BgL_index1439z00_1183))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8449 = BgL_index1439z00_1183
; }  else 
{ 
obj_t BgL_auxz00_8452;
BgL_auxz00_8452 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1439z00_1183); 
FAILURE(BgL_auxz00_8452,BFALSE,BFALSE);} 
BgL_n1z00_3134 = 
(long)CINT(BgL_tmpz00_8449); } 
BgL_test3912z00_8448 = 
(BgL_n1z00_3134>=((long)0)); } 
if(BgL_test3912z00_8448)
{ 
long BgL_auxz00_8458;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8459;
if(
INTEGERP(BgL_index1439z00_1183))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8459 = BgL_index1439z00_1183
; }  else 
{ 
obj_t BgL_auxz00_8462;
BgL_auxz00_8462 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1439z00_1183); 
FAILURE(BgL_auxz00_8462,BFALSE,BFALSE);} 
BgL_auxz00_8458 = 
(long)CINT(BgL_tmpz00_8459); } 
BgL_noncezd2updatez12zc0_1166 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8458); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1440z00_1185;
BgL_index1440z00_1185 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3915z00_8471;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3135;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8472;
if(
INTEGERP(BgL_index1440z00_1185))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8472 = BgL_index1440z00_1185
; }  else 
{ 
obj_t BgL_auxz00_8475;
BgL_auxz00_8475 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1440z00_1185); 
FAILURE(BgL_auxz00_8475,BFALSE,BFALSE);} 
BgL_n1z00_3135 = 
(long)CINT(BgL_tmpz00_8472); } 
BgL_test3915z00_8471 = 
(BgL_n1z00_3135>=((long)0)); } 
if(BgL_test3915z00_8471)
{ 
long BgL_auxz00_8481;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8482;
if(
INTEGERP(BgL_index1440z00_1185))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8482 = BgL_index1440z00_1185
; }  else 
{ 
obj_t BgL_auxz00_8485;
BgL_auxz00_8485 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1440z00_1185); 
FAILURE(BgL_auxz00_8485,BFALSE,BFALSE);} 
BgL_auxz00_8481 = 
(long)CINT(BgL_tmpz00_8482); } 
BgL_padz00_1167 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8481); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_index1441z00_1187;
BgL_index1441z00_1187 = 
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1430z00_307), BgL_opt1430z00_307, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 850 */
bool_t BgL_test3918z00_8494;
{ /* Llib/block_ciphers.scm 850 */
long BgL_n1z00_3136;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8495;
if(
INTEGERP(BgL_index1441z00_1187))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8495 = BgL_index1441z00_1187
; }  else 
{ 
obj_t BgL_auxz00_8498;
BgL_auxz00_8498 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1441z00_1187); 
FAILURE(BgL_auxz00_8498,BFALSE,BFALSE);} 
BgL_n1z00_3136 = 
(long)CINT(BgL_tmpz00_8495); } 
BgL_test3918z00_8494 = 
(BgL_n1z00_3136>=((long)0)); } 
if(BgL_test3918z00_8494)
{ 
long BgL_auxz00_8504;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_tmpz00_8505;
if(
INTEGERP(BgL_index1441z00_1187))
{ /* Llib/block_ciphers.scm 850 */
BgL_tmpz00_8505 = BgL_index1441z00_1187
; }  else 
{ 
obj_t BgL_auxz00_8508;
BgL_auxz00_8508 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1441z00_1187); 
FAILURE(BgL_auxz00_8508,BFALSE,BFALSE);} 
BgL_auxz00_8504 = 
(long)CINT(BgL_tmpz00_8505); } 
BgL_stringzd2ze3keyz31_1168 = 
VECTOR_REF(BgL_opt1430z00_307,BgL_auxz00_8504); }  else 
{ /* Llib/block_ciphers.scm 850 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_arg2079z00_1189;obj_t BgL_arg2080z00_1190;obj_t BgL_arg2081z00_1191;
BgL_arg2079z00_1189 = 
VECTOR_REF(BgL_opt1430z00_307,((long)0)); 
BgL_arg2080z00_1190 = 
VECTOR_REF(BgL_opt1430z00_307,((long)1)); 
BgL_arg2081z00_1191 = 
VECTOR_REF(BgL_opt1430z00_307,((long)2)); 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_ivz00_1192;
BgL_ivz00_1192 = BgL_ivz00_1163; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_modez00_1193;
BgL_modez00_1193 = BgL_modez00_1164; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2initz12zc0_1194;
BgL_noncezd2initz12zc0_1194 = BgL_noncezd2initz12zc0_1165; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_noncezd2updatez12zc0_1195;
BgL_noncezd2updatez12zc0_1195 = BgL_noncezd2updatez12zc0_1166; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_padz00_1196;
BgL_padz00_1196 = BgL_padz00_1167; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_stringzd2ze3keyz31_1197;
BgL_stringzd2ze3keyz31_1197 = BgL_stringzd2ze3keyz31_1168; 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_res2690z00_3145;
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_cipherz00_3137;obj_t BgL_passwordz00_3138;
if(
SYMBOLP(BgL_arg2079z00_1189))
{ /* Llib/block_ciphers.scm 850 */
BgL_cipherz00_3137 = BgL_arg2079z00_1189; }  else 
{ 
obj_t BgL_auxz00_8519;
BgL_auxz00_8519 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2079z00_1189); 
FAILURE(BgL_auxz00_8519,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2081z00_1191))
{ /* Llib/block_ciphers.scm 850 */
BgL_passwordz00_3138 = BgL_arg2081z00_1191; }  else 
{ 
obj_t BgL_auxz00_8525;
BgL_auxz00_8525 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)30777)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2081z00_1191); 
FAILURE(BgL_auxz00_8525,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 854 */
obj_t BgL_redirectz00_3139;
if(
STRINGP(BgL_arg2080z00_1190))
{ /* Llib/block_ciphers.scm 855 */
BgL_redirectz00_3139 = BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 855 */
if(
BGL_MMAPP(BgL_arg2080z00_1190))
{ /* Llib/block_ciphers.scm 856 */
BgL_redirectz00_3139 = BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL_test3925z00_8533;
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL__ortest_1057z00_3143;
BgL__ortest_1057z00_3143 = 
OUTPUT_PORTP(BgL_arg2080z00_1190); 
if(BgL__ortest_1057z00_3143)
{ /* Llib/block_ciphers.scm 857 */
BgL_test3925z00_8533 = BgL__ortest_1057z00_3143
; }  else 
{ /* Llib/block_ciphers.scm 857 */
BgL_test3925z00_8533 = 
INPUT_PORTP(BgL_arg2080z00_1190)
; } } 
if(BgL_test3925z00_8533)
{ /* Llib/block_ciphers.scm 857 */
BgL_redirectz00_3139 = BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
CNST_TABLE_REF(((long)32)); 
BgL_redirectz00_3139 = BgL_arg2080z00_1190; } } } 
{ /* Llib/block_ciphers.scm 861 */
obj_t BgL_aux2978z00_5334;
{ /* Llib/block_ciphers.scm 861 */
obj_t BgL_tmpfunz00_8549;
{ /* Llib/block_ciphers.scm 861 */
bool_t BgL_test2977z00_5333;
BgL_test2977z00_5333 = 
PROCEDUREP(BgL_redirectz00_3139); 
if(BgL_test2977z00_5333)
{ /* Llib/block_ciphers.scm 861 */
BgL_tmpfunz00_8549 = BgL_redirectz00_3139
; }  else 
{ 
obj_t BgL_auxz00_8552;
BgL_auxz00_8552 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31193)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3204z00zz__cryptozd2blockzd2ciphersz00, BgL_redirectz00_3139); 
FAILURE(BgL_auxz00_8552,BFALSE,BFALSE);} } 
BgL_aux2978z00_5334 = 
PROCEDURE_ENTRY(BgL_tmpfunz00_8549)(BgL_redirectz00_3139, BgL_cipherz00_3137, BgL_arg2080z00_1190, BgL_passwordz00_3138, BgL_ivz00_1192, BgL_modez00_1193, BgL_padz00_1196, BgL_noncezd2initz12zc0_1194, BgL_noncezd2updatez12zc0_1195, BgL_stringzd2ze3keyz31_1197, BEOA); } 
if(
STRINGP(BgL_aux2978z00_5334))
{ /* Llib/block_ciphers.scm 861 */
BgL_res2690z00_3145 = BgL_aux2978z00_5334; }  else 
{ 
obj_t BgL_auxz00_8558;
BgL_auxz00_8558 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31193)), BGl_string3220z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_aux2978z00_5334); 
FAILURE(BgL_auxz00_8558,BFALSE,BFALSE);} } } } 
return BgL_res2690z00_3145;} } } } } } } } } } } } } } } } } 

}



/* search1433~0 */
obj_t BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1432z00_5085, obj_t BgL_opt1430z00_5084, obj_t BgL_k1z00_1157, long BgL_iz00_1158)
{
{ /* Llib/block_ciphers.scm 850 */
BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1158==BgL_l1432z00_5085))
{ /* Llib/block_ciphers.scm 850 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 850 */
if(
(BgL_iz00_1158==
(BgL_l1432z00_5085-((long)1))))
{ /* Llib/block_ciphers.scm 850 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1430z00_5084)));}  else 
{ /* Llib/block_ciphers.scm 850 */
obj_t BgL_vz00_1202;
BgL_vz00_1202 = 
VECTOR_REF(BgL_opt1430z00_5084,BgL_iz00_1158); 
if(
(BgL_vz00_1202==BgL_k1z00_1157))
{ /* Llib/block_ciphers.scm 850 */
return 
BINT(
(BgL_iz00_1158+((long)1)));}  else 
{ 
long BgL_iz00_8577;
BgL_iz00_8577 = 
(BgL_iz00_1158+((long)2)); 
BgL_iz00_1158 = BgL_iz00_8577; 
goto BGl_search1433ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* decrypt */
BGL_EXPORTED_DEF obj_t BGl_decryptz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_298, obj_t BgL_ciphertextz00_299, obj_t BgL_passwordz00_300, obj_t BgL_ivz00_301, obj_t BgL_modez00_302, obj_t BgL_noncezd2initz12zc0_303, obj_t BgL_noncezd2updatez12zc0_304, obj_t BgL_padz00_305, obj_t BgL_stringzd2ze3keyz31_306)
{
{ /* Llib/block_ciphers.scm 850 */
{ /* Llib/block_ciphers.scm 854 */
obj_t BgL_redirectz00_3146;
if(
STRINGP(BgL_ciphertextz00_299))
{ /* Llib/block_ciphers.scm 855 */
BgL_redirectz00_3146 = BGl_decryptzd2fastzd2stringzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 855 */
if(
BGL_MMAPP(BgL_ciphertextz00_299))
{ /* Llib/block_ciphers.scm 856 */
BgL_redirectz00_3146 = BGl_decryptzd2fastzd2mmapzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL_test3934z00_8583;
{ /* Llib/block_ciphers.scm 857 */
bool_t BgL__ortest_1057z00_3150;
BgL__ortest_1057z00_3150 = 
OUTPUT_PORTP(BgL_ciphertextz00_299); 
if(BgL__ortest_1057z00_3150)
{ /* Llib/block_ciphers.scm 857 */
BgL_test3934z00_8583 = BgL__ortest_1057z00_3150
; }  else 
{ /* Llib/block_ciphers.scm 857 */
BgL_test3934z00_8583 = 
INPUT_PORTP(BgL_ciphertextz00_299)
; } } 
if(BgL_test3934z00_8583)
{ /* Llib/block_ciphers.scm 857 */
BgL_redirectz00_3146 = BGl_decryptzd2fastzd2portzd2envzd2zz__cryptozd2blockzd2ciphersz00; }  else 
{ /* Llib/block_ciphers.scm 857 */
CNST_TABLE_REF(((long)32)); 
BgL_redirectz00_3146 = BgL_ciphertextz00_299; } } } 
return 
PROCEDURE_ENTRY(BgL_redirectz00_3146)(BgL_redirectz00_3146, BgL_cipherz00_298, BgL_ciphertextz00_299, BgL_passwordz00_300, BgL_ivz00_301, BgL_modez00_302, BgL_padz00_305, BgL_noncezd2initz12zc0_303, BgL_noncezd2updatez12zc0_304, BgL_stringzd2ze3keyz31_306, BEOA);} } 

}



/* _decrypt-string */
obj_t BGl__decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1443z00_319, obj_t BgL_opt1442z00_318)
{
{ /* Llib/block_ciphers.scm 864 */
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_cipherz00_1214;obj_t BgL_ciphertextz00_1215;obj_t BgL_passwordz00_1216;
BgL_cipherz00_1214 = 
VECTOR_REF(BgL_opt1442z00_318,((long)0)); 
BgL_ciphertextz00_1215 = 
VECTOR_REF(BgL_opt1442z00_318,((long)1)); 
BgL_passwordz00_1216 = 
VECTOR_REF(BgL_opt1442z00_318,((long)2)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_ivz00_1217;
BgL_ivz00_1217 = BFALSE; 
{ /* Llib/block_ciphers.scm 865 */
obj_t BgL_modez00_1218;
BgL_modez00_1218 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2initz12zc0_1219;
BgL_noncezd2initz12zc0_1219 = BFALSE; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2updatez12zc0_1220;
BgL_noncezd2updatez12zc0_1220 = BFALSE; 
{ /* Llib/block_ciphers.scm 865 */
obj_t BgL_padz00_1221;
BgL_padz00_1221 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_stringzd2ze3keyz31_1222;
BgL_stringzd2ze3keyz31_1222 = BFALSE; 
{ /* Llib/block_ciphers.scm 864 */

{ 
long BgL_iz00_1223;
BgL_iz00_1223 = ((long)3); 
BgL_check1446z00_1224:
if(
(BgL_iz00_1223==
VECTOR_LENGTH(BgL_opt1442z00_318)))
{ /* Llib/block_ciphers.scm 864 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3937z00_8608;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2097z00_1230;
BgL_arg2097z00_1230 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_iz00_1223); 
BgL_test3937z00_8608 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2097z00_1230, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3937z00_8608)
{ 
long BgL_iz00_8613;
BgL_iz00_8613 = 
(BgL_iz00_1223+((long)2)); 
BgL_iz00_1223 = BgL_iz00_8613; 
goto BgL_check1446z00_1224;}  else 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2096z00_1229;
BgL_arg2096z00_1229 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_iz00_1223); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2096z00_1229); } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1448z00_1231;
BgL_index1448z00_1231 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3938z00_8621;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3167;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8622;
if(
INTEGERP(BgL_index1448z00_1231))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8622 = BgL_index1448z00_1231
; }  else 
{ 
obj_t BgL_auxz00_8625;
BgL_auxz00_8625 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1448z00_1231); 
FAILURE(BgL_auxz00_8625,BFALSE,BFALSE);} 
BgL_n1z00_3167 = 
(long)CINT(BgL_tmpz00_8622); } 
BgL_test3938z00_8621 = 
(BgL_n1z00_3167>=((long)0)); } 
if(BgL_test3938z00_8621)
{ 
long BgL_auxz00_8631;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8632;
if(
INTEGERP(BgL_index1448z00_1231))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8632 = BgL_index1448z00_1231
; }  else 
{ 
obj_t BgL_auxz00_8635;
BgL_auxz00_8635 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1448z00_1231); 
FAILURE(BgL_auxz00_8635,BFALSE,BFALSE);} 
BgL_auxz00_8631 = 
(long)CINT(BgL_tmpz00_8632); } 
BgL_ivz00_1217 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8631); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1449z00_1233;
BgL_index1449z00_1233 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3941z00_8644;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3168;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8645;
if(
INTEGERP(BgL_index1449z00_1233))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8645 = BgL_index1449z00_1233
; }  else 
{ 
obj_t BgL_auxz00_8648;
BgL_auxz00_8648 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1449z00_1233); 
FAILURE(BgL_auxz00_8648,BFALSE,BFALSE);} 
BgL_n1z00_3168 = 
(long)CINT(BgL_tmpz00_8645); } 
BgL_test3941z00_8644 = 
(BgL_n1z00_3168>=((long)0)); } 
if(BgL_test3941z00_8644)
{ 
long BgL_auxz00_8654;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8655;
if(
INTEGERP(BgL_index1449z00_1233))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8655 = BgL_index1449z00_1233
; }  else 
{ 
obj_t BgL_auxz00_8658;
BgL_auxz00_8658 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1449z00_1233); 
FAILURE(BgL_auxz00_8658,BFALSE,BFALSE);} 
BgL_auxz00_8654 = 
(long)CINT(BgL_tmpz00_8655); } 
BgL_modez00_1218 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8654); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1450z00_1235;
BgL_index1450z00_1235 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3944z00_8667;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3169;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8668;
if(
INTEGERP(BgL_index1450z00_1235))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8668 = BgL_index1450z00_1235
; }  else 
{ 
obj_t BgL_auxz00_8671;
BgL_auxz00_8671 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1450z00_1235); 
FAILURE(BgL_auxz00_8671,BFALSE,BFALSE);} 
BgL_n1z00_3169 = 
(long)CINT(BgL_tmpz00_8668); } 
BgL_test3944z00_8667 = 
(BgL_n1z00_3169>=((long)0)); } 
if(BgL_test3944z00_8667)
{ 
long BgL_auxz00_8677;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8678;
if(
INTEGERP(BgL_index1450z00_1235))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8678 = BgL_index1450z00_1235
; }  else 
{ 
obj_t BgL_auxz00_8681;
BgL_auxz00_8681 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1450z00_1235); 
FAILURE(BgL_auxz00_8681,BFALSE,BFALSE);} 
BgL_auxz00_8677 = 
(long)CINT(BgL_tmpz00_8678); } 
BgL_noncezd2initz12zc0_1219 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8677); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1451z00_1237;
BgL_index1451z00_1237 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3947z00_8690;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3170;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8691;
if(
INTEGERP(BgL_index1451z00_1237))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8691 = BgL_index1451z00_1237
; }  else 
{ 
obj_t BgL_auxz00_8694;
BgL_auxz00_8694 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1451z00_1237); 
FAILURE(BgL_auxz00_8694,BFALSE,BFALSE);} 
BgL_n1z00_3170 = 
(long)CINT(BgL_tmpz00_8691); } 
BgL_test3947z00_8690 = 
(BgL_n1z00_3170>=((long)0)); } 
if(BgL_test3947z00_8690)
{ 
long BgL_auxz00_8700;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8701;
if(
INTEGERP(BgL_index1451z00_1237))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8701 = BgL_index1451z00_1237
; }  else 
{ 
obj_t BgL_auxz00_8704;
BgL_auxz00_8704 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1451z00_1237); 
FAILURE(BgL_auxz00_8704,BFALSE,BFALSE);} 
BgL_auxz00_8700 = 
(long)CINT(BgL_tmpz00_8701); } 
BgL_noncezd2updatez12zc0_1220 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8700); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1452z00_1239;
BgL_index1452z00_1239 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3950z00_8713;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3171;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8714;
if(
INTEGERP(BgL_index1452z00_1239))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8714 = BgL_index1452z00_1239
; }  else 
{ 
obj_t BgL_auxz00_8717;
BgL_auxz00_8717 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1452z00_1239); 
FAILURE(BgL_auxz00_8717,BFALSE,BFALSE);} 
BgL_n1z00_3171 = 
(long)CINT(BgL_tmpz00_8714); } 
BgL_test3950z00_8713 = 
(BgL_n1z00_3171>=((long)0)); } 
if(BgL_test3950z00_8713)
{ 
long BgL_auxz00_8723;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8724;
if(
INTEGERP(BgL_index1452z00_1239))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8724 = BgL_index1452z00_1239
; }  else 
{ 
obj_t BgL_auxz00_8727;
BgL_auxz00_8727 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1452z00_1239); 
FAILURE(BgL_auxz00_8727,BFALSE,BFALSE);} 
BgL_auxz00_8723 = 
(long)CINT(BgL_tmpz00_8724); } 
BgL_padz00_1221 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8723); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_index1453z00_1241;
BgL_index1453z00_1241 = 
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1442z00_318), BgL_opt1442z00_318, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 864 */
bool_t BgL_test3953z00_8736;
{ /* Llib/block_ciphers.scm 864 */
long BgL_n1z00_3172;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8737;
if(
INTEGERP(BgL_index1453z00_1241))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8737 = BgL_index1453z00_1241
; }  else 
{ 
obj_t BgL_auxz00_8740;
BgL_auxz00_8740 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1453z00_1241); 
FAILURE(BgL_auxz00_8740,BFALSE,BFALSE);} 
BgL_n1z00_3172 = 
(long)CINT(BgL_tmpz00_8737); } 
BgL_test3953z00_8736 = 
(BgL_n1z00_3172>=((long)0)); } 
if(BgL_test3953z00_8736)
{ 
long BgL_auxz00_8746;
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_tmpz00_8747;
if(
INTEGERP(BgL_index1453z00_1241))
{ /* Llib/block_ciphers.scm 864 */
BgL_tmpz00_8747 = BgL_index1453z00_1241
; }  else 
{ 
obj_t BgL_auxz00_8750;
BgL_auxz00_8750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1453z00_1241); 
FAILURE(BgL_auxz00_8750,BFALSE,BFALSE);} 
BgL_auxz00_8746 = 
(long)CINT(BgL_tmpz00_8747); } 
BgL_stringzd2ze3keyz31_1222 = 
VECTOR_REF(BgL_opt1442z00_318,BgL_auxz00_8746); }  else 
{ /* Llib/block_ciphers.scm 864 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_arg2104z00_1243;obj_t BgL_arg2105z00_1244;obj_t BgL_arg2106z00_1245;
BgL_arg2104z00_1243 = 
VECTOR_REF(BgL_opt1442z00_318,((long)0)); 
BgL_arg2105z00_1244 = 
VECTOR_REF(BgL_opt1442z00_318,((long)1)); 
BgL_arg2106z00_1245 = 
VECTOR_REF(BgL_opt1442z00_318,((long)2)); 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_ivz00_1246;
BgL_ivz00_1246 = BgL_ivz00_1217; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_modez00_1247;
BgL_modez00_1247 = BgL_modez00_1218; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2initz12zc0_1248;
BgL_noncezd2initz12zc0_1248 = BgL_noncezd2initz12zc0_1219; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_noncezd2updatez12zc0_1249;
BgL_noncezd2updatez12zc0_1249 = BgL_noncezd2updatez12zc0_1220; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_padz00_1250;
BgL_padz00_1250 = BgL_padz00_1221; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_stringzd2ze3keyz31_1251;
BgL_stringzd2ze3keyz31_1251 = BgL_stringzd2ze3keyz31_1222; 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_cipherz00_3173;obj_t BgL_ciphertextz00_3174;obj_t BgL_passwordz00_3175;
if(
SYMBOLP(BgL_arg2104z00_1243))
{ /* Llib/block_ciphers.scm 864 */
BgL_cipherz00_3173 = BgL_arg2104z00_1243; }  else 
{ 
obj_t BgL_auxz00_8761;
BgL_auxz00_8761 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2104z00_1243); 
FAILURE(BgL_auxz00_8761,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2105z00_1244))
{ /* Llib/block_ciphers.scm 864 */
BgL_ciphertextz00_3174 = BgL_arg2105z00_1244; }  else 
{ 
obj_t BgL_auxz00_8767;
BgL_auxz00_8767 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2105z00_1244); 
FAILURE(BgL_auxz00_8767,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2106z00_1245))
{ /* Llib/block_ciphers.scm 864 */
BgL_passwordz00_3175 = BgL_arg2106z00_1245; }  else 
{ 
obj_t BgL_auxz00_8773;
BgL_auxz00_8773 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31286)), BGl_string3221z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2106z00_1245); 
FAILURE(BgL_auxz00_8773,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_3178;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3179;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2115z00_3180;
BgL_arg2115z00_3180 = 
STRING_LENGTH(BgL_ciphertextz00_3174); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_3178 = 
make_string(BgL_arg2115z00_3180, ((unsigned char)' ')); } } 
BgL_statez00_3179 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3173, BgL_passwordz00_3175, BgL_ivz00_1246, BgL_modez00_1247, BgL_padz00_1250, BgL_noncezd2initz12zc0_1248, BgL_noncezd2updatez12zc0_1249, BgL_stringzd2ze3keyz31_1251); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_8780;
BgL_tmpz00_8780 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3179, BgL_ciphertextz00_3174, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3178, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3178, BgL_tmpz00_8780);} } } } } } } } } } } } } } } } } } } 

}



/* search1445~0 */
obj_t BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1444z00_5083, obj_t BgL_opt1442z00_5082, obj_t BgL_k1z00_1211, long BgL_iz00_1212)
{
{ /* Llib/block_ciphers.scm 864 */
BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1212==BgL_l1444z00_5083))
{ /* Llib/block_ciphers.scm 864 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 864 */
if(
(BgL_iz00_1212==
(BgL_l1444z00_5083-((long)1))))
{ /* Llib/block_ciphers.scm 864 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1442z00_5082)));}  else 
{ /* Llib/block_ciphers.scm 864 */
obj_t BgL_vz00_1256;
BgL_vz00_1256 = 
VECTOR_REF(BgL_opt1442z00_5082,BgL_iz00_1212); 
if(
(BgL_vz00_1256==BgL_k1z00_1211))
{ /* Llib/block_ciphers.scm 864 */
return 
BINT(
(BgL_iz00_1212+((long)1)));}  else 
{ 
long BgL_iz00_8798;
BgL_iz00_8798 = 
(BgL_iz00_1212+((long)2)); 
BgL_iz00_1212 = BgL_iz00_8798; 
goto BGl_search1445ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* decrypt-string */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2stringzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_309, obj_t BgL_ciphertextz00_310, obj_t BgL_passwordz00_311, obj_t BgL_ivz00_312, obj_t BgL_modez00_313, obj_t BgL_noncezd2initz12zc0_314, obj_t BgL_noncezd2updatez12zc0_315, obj_t BgL_padz00_316, obj_t BgL_stringzd2ze3keyz31_317)
{
{ /* Llib/block_ciphers.scm 864 */
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_3190;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3191;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2115z00_3192;
BgL_arg2115z00_3192 = 
STRING_LENGTH(BgL_ciphertextz00_310); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_3190 = 
make_string(BgL_arg2115z00_3192, ((unsigned char)' ')); } } 
BgL_statez00_3191 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_309, BgL_passwordz00_311, BgL_ivz00_312, BgL_modez00_313, BgL_padz00_316, BgL_noncezd2initz12zc0_314, BgL_noncezd2updatez12zc0_315, BgL_stringzd2ze3keyz31_317); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_8803;
BgL_tmpz00_8803 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3191, BgL_ciphertextz00_310, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3190, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3190, BgL_tmpz00_8803);} } } 

}



/* &decrypt-fast-string */
obj_t BGl_z62decryptzd2fastzd2stringz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4448, obj_t BgL_cipherz00_4449, obj_t BgL_ciphertextz00_4450, obj_t BgL_passwordz00_4451, obj_t BgL_ivz00_4452, obj_t BgL_modez00_4453, obj_t BgL_padz00_4454, obj_t BgL_noncezd2initz12zc0_4455, obj_t BgL_noncezd2updatez12zc0_4456, obj_t BgL_stringzd2ze3keyz31_4457)
{
{ /* Llib/block_ciphers.scm 871 */
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_ciphertextz00_5608;obj_t BgL_passwordz00_5609;
if(
STRINGP(BgL_ciphertextz00_4450))
{ /* Llib/block_ciphers.scm 874 */
BgL_ciphertextz00_5608 = BgL_ciphertextz00_4450; }  else 
{ 
obj_t BgL_auxz00_8808;
BgL_auxz00_8808 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31735)), BGl_string3222z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_4450); 
FAILURE(BgL_auxz00_8808,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_4451))
{ /* Llib/block_ciphers.scm 874 */
BgL_passwordz00_5609 = BgL_passwordz00_4451; }  else 
{ 
obj_t BgL_auxz00_8814;
BgL_auxz00_8814 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)31735)), BGl_string3222z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_4451); 
FAILURE(BgL_auxz00_8814,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 874 */
obj_t BgL_strz00_5610;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_5611;
{ /* Llib/block_ciphers.scm 874 */
long BgL_arg2115z00_5612;
BgL_arg2115z00_5612 = 
STRING_LENGTH(BgL_ciphertextz00_5608); 
{ /* Llib/block_ciphers.scm 874 */

BgL_strz00_5610 = 
make_string(BgL_arg2115z00_5612, ((unsigned char)' ')); } } 
BgL_statez00_5611 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4449, BgL_passwordz00_5609, BgL_ivz00_4452, BgL_modez00_4453, BgL_padz00_4454, BgL_noncezd2initz12zc0_4455, BgL_noncezd2updatez12zc0_4456, BgL_stringzd2ze3keyz31_4457); 
{ /* Llib/block_ciphers.scm 878 */
long BgL_tmpz00_8821;
BgL_tmpz00_8821 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_5611, BgL_ciphertextz00_5608, ((long)0), BGl_readzd2stringzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_5610, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_5610, BgL_tmpz00_8821);} } } } 

}



/* _decrypt-mmap */
obj_t BGl__decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1455z00_339, obj_t BgL_opt1454z00_338)
{
{ /* Llib/block_ciphers.scm 883 */
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_cipherz00_1270;obj_t BgL_ciphertextz00_1271;obj_t BgL_passwordz00_1272;
BgL_cipherz00_1270 = 
VECTOR_REF(BgL_opt1454z00_338,((long)0)); 
BgL_ciphertextz00_1271 = 
VECTOR_REF(BgL_opt1454z00_338,((long)1)); 
BgL_passwordz00_1272 = 
VECTOR_REF(BgL_opt1454z00_338,((long)2)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_ivz00_1273;
BgL_ivz00_1273 = BFALSE; 
{ /* Llib/block_ciphers.scm 884 */
obj_t BgL_modez00_1274;
BgL_modez00_1274 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2initz12zc0_1275;
BgL_noncezd2initz12zc0_1275 = BFALSE; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2updatez12zc0_1276;
BgL_noncezd2updatez12zc0_1276 = BFALSE; 
{ /* Llib/block_ciphers.scm 884 */
obj_t BgL_padz00_1277;
BgL_padz00_1277 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_stringzd2ze3keyz31_1278;
BgL_stringzd2ze3keyz31_1278 = BFALSE; 
{ /* Llib/block_ciphers.scm 883 */

{ 
long BgL_iz00_1279;
BgL_iz00_1279 = ((long)3); 
BgL_check1458z00_1280:
if(
(BgL_iz00_1279==
VECTOR_LENGTH(BgL_opt1454z00_338)))
{ /* Llib/block_ciphers.scm 883 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3965z00_8832;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2121z00_1286;
BgL_arg2121z00_1286 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_iz00_1279); 
BgL_test3965z00_8832 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2121z00_1286, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3965z00_8832)
{ 
long BgL_iz00_8837;
BgL_iz00_8837 = 
(BgL_iz00_1279+((long)2)); 
BgL_iz00_1279 = BgL_iz00_8837; 
goto BgL_check1458z00_1280;}  else 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2120z00_1285;
BgL_arg2120z00_1285 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_iz00_1279); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2120z00_1285); } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1460z00_1287;
BgL_index1460z00_1287 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3966z00_8845;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3225;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8846;
if(
INTEGERP(BgL_index1460z00_1287))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8846 = BgL_index1460z00_1287
; }  else 
{ 
obj_t BgL_auxz00_8849;
BgL_auxz00_8849 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1460z00_1287); 
FAILURE(BgL_auxz00_8849,BFALSE,BFALSE);} 
BgL_n1z00_3225 = 
(long)CINT(BgL_tmpz00_8846); } 
BgL_test3966z00_8845 = 
(BgL_n1z00_3225>=((long)0)); } 
if(BgL_test3966z00_8845)
{ 
long BgL_auxz00_8855;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8856;
if(
INTEGERP(BgL_index1460z00_1287))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8856 = BgL_index1460z00_1287
; }  else 
{ 
obj_t BgL_auxz00_8859;
BgL_auxz00_8859 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1460z00_1287); 
FAILURE(BgL_auxz00_8859,BFALSE,BFALSE);} 
BgL_auxz00_8855 = 
(long)CINT(BgL_tmpz00_8856); } 
BgL_ivz00_1273 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8855); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1461z00_1289;
BgL_index1461z00_1289 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3969z00_8868;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3226;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8869;
if(
INTEGERP(BgL_index1461z00_1289))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8869 = BgL_index1461z00_1289
; }  else 
{ 
obj_t BgL_auxz00_8872;
BgL_auxz00_8872 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1461z00_1289); 
FAILURE(BgL_auxz00_8872,BFALSE,BFALSE);} 
BgL_n1z00_3226 = 
(long)CINT(BgL_tmpz00_8869); } 
BgL_test3969z00_8868 = 
(BgL_n1z00_3226>=((long)0)); } 
if(BgL_test3969z00_8868)
{ 
long BgL_auxz00_8878;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8879;
if(
INTEGERP(BgL_index1461z00_1289))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8879 = BgL_index1461z00_1289
; }  else 
{ 
obj_t BgL_auxz00_8882;
BgL_auxz00_8882 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1461z00_1289); 
FAILURE(BgL_auxz00_8882,BFALSE,BFALSE);} 
BgL_auxz00_8878 = 
(long)CINT(BgL_tmpz00_8879); } 
BgL_modez00_1274 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8878); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1462z00_1291;
BgL_index1462z00_1291 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3972z00_8891;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3227;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8892;
if(
INTEGERP(BgL_index1462z00_1291))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8892 = BgL_index1462z00_1291
; }  else 
{ 
obj_t BgL_auxz00_8895;
BgL_auxz00_8895 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1462z00_1291); 
FAILURE(BgL_auxz00_8895,BFALSE,BFALSE);} 
BgL_n1z00_3227 = 
(long)CINT(BgL_tmpz00_8892); } 
BgL_test3972z00_8891 = 
(BgL_n1z00_3227>=((long)0)); } 
if(BgL_test3972z00_8891)
{ 
long BgL_auxz00_8901;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8902;
if(
INTEGERP(BgL_index1462z00_1291))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8902 = BgL_index1462z00_1291
; }  else 
{ 
obj_t BgL_auxz00_8905;
BgL_auxz00_8905 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1462z00_1291); 
FAILURE(BgL_auxz00_8905,BFALSE,BFALSE);} 
BgL_auxz00_8901 = 
(long)CINT(BgL_tmpz00_8902); } 
BgL_noncezd2initz12zc0_1275 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8901); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1463z00_1293;
BgL_index1463z00_1293 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3975z00_8914;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3228;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8915;
if(
INTEGERP(BgL_index1463z00_1293))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8915 = BgL_index1463z00_1293
; }  else 
{ 
obj_t BgL_auxz00_8918;
BgL_auxz00_8918 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1463z00_1293); 
FAILURE(BgL_auxz00_8918,BFALSE,BFALSE);} 
BgL_n1z00_3228 = 
(long)CINT(BgL_tmpz00_8915); } 
BgL_test3975z00_8914 = 
(BgL_n1z00_3228>=((long)0)); } 
if(BgL_test3975z00_8914)
{ 
long BgL_auxz00_8924;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8925;
if(
INTEGERP(BgL_index1463z00_1293))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8925 = BgL_index1463z00_1293
; }  else 
{ 
obj_t BgL_auxz00_8928;
BgL_auxz00_8928 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1463z00_1293); 
FAILURE(BgL_auxz00_8928,BFALSE,BFALSE);} 
BgL_auxz00_8924 = 
(long)CINT(BgL_tmpz00_8925); } 
BgL_noncezd2updatez12zc0_1276 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8924); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1464z00_1295;
BgL_index1464z00_1295 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3978z00_8937;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3229;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8938;
if(
INTEGERP(BgL_index1464z00_1295))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8938 = BgL_index1464z00_1295
; }  else 
{ 
obj_t BgL_auxz00_8941;
BgL_auxz00_8941 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1464z00_1295); 
FAILURE(BgL_auxz00_8941,BFALSE,BFALSE);} 
BgL_n1z00_3229 = 
(long)CINT(BgL_tmpz00_8938); } 
BgL_test3978z00_8937 = 
(BgL_n1z00_3229>=((long)0)); } 
if(BgL_test3978z00_8937)
{ 
long BgL_auxz00_8947;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8948;
if(
INTEGERP(BgL_index1464z00_1295))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8948 = BgL_index1464z00_1295
; }  else 
{ 
obj_t BgL_auxz00_8951;
BgL_auxz00_8951 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1464z00_1295); 
FAILURE(BgL_auxz00_8951,BFALSE,BFALSE);} 
BgL_auxz00_8947 = 
(long)CINT(BgL_tmpz00_8948); } 
BgL_padz00_1277 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8947); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_index1465z00_1297;
BgL_index1465z00_1297 = 
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1454z00_338), BgL_opt1454z00_338, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 883 */
bool_t BgL_test3981z00_8960;
{ /* Llib/block_ciphers.scm 883 */
long BgL_n1z00_3230;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8961;
if(
INTEGERP(BgL_index1465z00_1297))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8961 = BgL_index1465z00_1297
; }  else 
{ 
obj_t BgL_auxz00_8964;
BgL_auxz00_8964 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1465z00_1297); 
FAILURE(BgL_auxz00_8964,BFALSE,BFALSE);} 
BgL_n1z00_3230 = 
(long)CINT(BgL_tmpz00_8961); } 
BgL_test3981z00_8960 = 
(BgL_n1z00_3230>=((long)0)); } 
if(BgL_test3981z00_8960)
{ 
long BgL_auxz00_8970;
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_tmpz00_8971;
if(
INTEGERP(BgL_index1465z00_1297))
{ /* Llib/block_ciphers.scm 883 */
BgL_tmpz00_8971 = BgL_index1465z00_1297
; }  else 
{ 
obj_t BgL_auxz00_8974;
BgL_auxz00_8974 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1465z00_1297); 
FAILURE(BgL_auxz00_8974,BFALSE,BFALSE);} 
BgL_auxz00_8970 = 
(long)CINT(BgL_tmpz00_8971); } 
BgL_stringzd2ze3keyz31_1278 = 
VECTOR_REF(BgL_opt1454z00_338,BgL_auxz00_8970); }  else 
{ /* Llib/block_ciphers.scm 883 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_arg2128z00_1299;obj_t BgL_arg2129z00_1300;obj_t BgL_arg2130z00_1301;
BgL_arg2128z00_1299 = 
VECTOR_REF(BgL_opt1454z00_338,((long)0)); 
BgL_arg2129z00_1300 = 
VECTOR_REF(BgL_opt1454z00_338,((long)1)); 
BgL_arg2130z00_1301 = 
VECTOR_REF(BgL_opt1454z00_338,((long)2)); 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_ivz00_1302;
BgL_ivz00_1302 = BgL_ivz00_1273; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_modez00_1303;
BgL_modez00_1303 = BgL_modez00_1274; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2initz12zc0_1304;
BgL_noncezd2initz12zc0_1304 = BgL_noncezd2initz12zc0_1275; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_noncezd2updatez12zc0_1305;
BgL_noncezd2updatez12zc0_1305 = BgL_noncezd2updatez12zc0_1276; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_padz00_1306;
BgL_padz00_1306 = BgL_padz00_1277; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_stringzd2ze3keyz31_1307;
BgL_stringzd2ze3keyz31_1307 = BgL_stringzd2ze3keyz31_1278; 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_cipherz00_3231;obj_t BgL_ciphertextz00_3232;obj_t BgL_passwordz00_3233;
if(
SYMBOLP(BgL_arg2128z00_1299))
{ /* Llib/block_ciphers.scm 883 */
BgL_cipherz00_3231 = BgL_arg2128z00_1299; }  else 
{ 
obj_t BgL_auxz00_8985;
BgL_auxz00_8985 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2128z00_1299); 
FAILURE(BgL_auxz00_8985,BFALSE,BFALSE);} 
if(
BGL_MMAPP(BgL_arg2129z00_1300))
{ /* Llib/block_ciphers.scm 883 */
BgL_ciphertextz00_3232 = BgL_arg2129z00_1300; }  else 
{ 
obj_t BgL_auxz00_8991;
BgL_auxz00_8991 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3209z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2129z00_1300); 
FAILURE(BgL_auxz00_8991,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2130z00_1301))
{ /* Llib/block_ciphers.scm 883 */
BgL_passwordz00_3233 = BgL_arg2130z00_1301; }  else 
{ 
obj_t BgL_auxz00_8997;
BgL_auxz00_8997 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32035)), BGl_string3223z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2130z00_1301); 
FAILURE(BgL_auxz00_8997,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_3236;
BgL_lenz00_3236 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_3232); 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_3237;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_3243;
BgL_kz00_3243 = 
(long)(BgL_lenz00_3236); 
BgL_strz00_3237 = 
make_string(BgL_kz00_3243, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3240;
BgL_statez00_3240 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3231, BgL_passwordz00_3233, BgL_ivz00_1302, BgL_modez00_1303, BgL_padz00_1306, BgL_noncezd2initz12zc0_1304, BgL_noncezd2updatez12zc0_1305, BgL_stringzd2ze3keyz31_1307); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9005;
BgL_tmpz00_9005 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3240, BgL_ciphertextz00_3232, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3237, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3237, BgL_tmpz00_9005);} } } } } } } } } } } } } } } } } } } } } } 

}



/* search1457~0 */
obj_t BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1456z00_5081, obj_t BgL_opt1454z00_5080, obj_t BgL_k1z00_1267, long BgL_iz00_1268)
{
{ /* Llib/block_ciphers.scm 883 */
BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1268==BgL_l1456z00_5081))
{ /* Llib/block_ciphers.scm 883 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 883 */
if(
(BgL_iz00_1268==
(BgL_l1456z00_5081-((long)1))))
{ /* Llib/block_ciphers.scm 883 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1454z00_5080)));}  else 
{ /* Llib/block_ciphers.scm 883 */
obj_t BgL_vz00_1312;
BgL_vz00_1312 = 
VECTOR_REF(BgL_opt1454z00_5080,BgL_iz00_1268); 
if(
(BgL_vz00_1312==BgL_k1z00_1267))
{ /* Llib/block_ciphers.scm 883 */
return 
BINT(
(BgL_iz00_1268+((long)1)));}  else 
{ 
long BgL_iz00_9023;
BgL_iz00_9023 = 
(BgL_iz00_1268+((long)2)); 
BgL_iz00_1268 = BgL_iz00_9023; 
goto BGl_search1457ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* decrypt-mmap */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2mmapzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_329, obj_t BgL_ciphertextz00_330, obj_t BgL_passwordz00_331, obj_t BgL_ivz00_332, obj_t BgL_modez00_333, obj_t BgL_noncezd2initz12zc0_334, obj_t BgL_noncezd2updatez12zc0_335, obj_t BgL_padz00_336, obj_t BgL_stringzd2ze3keyz31_337)
{
{ /* Llib/block_ciphers.scm 883 */
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_3248;
BgL_lenz00_3248 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_330); 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_3249;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_3255;
BgL_kz00_3255 = 
(long)(BgL_lenz00_3248); 
BgL_strz00_3249 = 
make_string(BgL_kz00_3255, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3252;
BgL_statez00_3252 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_329, BgL_passwordz00_331, BgL_ivz00_332, BgL_modez00_333, BgL_padz00_336, BgL_noncezd2initz12zc0_334, BgL_noncezd2updatez12zc0_335, BgL_stringzd2ze3keyz31_337); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9029;
BgL_tmpz00_9029 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3252, BgL_ciphertextz00_330, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_3249, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_3249, BgL_tmpz00_9029);} } } } } } 

}



/* &decrypt-fast-mmap */
obj_t BGl_z62decryptzd2fastzd2mmapz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4458, obj_t BgL_cipherz00_4459, obj_t BgL_ciphertextz00_4460, obj_t BgL_passwordz00_4461, obj_t BgL_ivz00_4462, obj_t BgL_modez00_4463, obj_t BgL_padz00_4464, obj_t BgL_noncezd2initz12zc0_4465, obj_t BgL_noncezd2updatez12zc0_4466, obj_t BgL_stringzd2ze3keyz31_4467)
{
{ /* Llib/block_ciphers.scm 890 */
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_ciphertextz00_5613;obj_t BgL_passwordz00_5614;
if(
BGL_MMAPP(BgL_ciphertextz00_4460))
{ /* Llib/block_ciphers.scm 893 */
BgL_ciphertextz00_5613 = BgL_ciphertextz00_4460; }  else 
{ 
obj_t BgL_auxz00_9034;
BgL_auxz00_9034 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32489)), BGl_string3224z00zz__cryptozd2blockzd2ciphersz00, BGl_string3209z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_4460); 
FAILURE(BgL_auxz00_9034,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_4461))
{ /* Llib/block_ciphers.scm 893 */
BgL_passwordz00_5614 = BgL_passwordz00_4461; }  else 
{ 
obj_t BgL_auxz00_9040;
BgL_auxz00_9040 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32489)), BGl_string3224z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_4461); 
FAILURE(BgL_auxz00_9040,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 893 */
long BgL_lenz00_5615;
BgL_lenz00_5615 = 
BGL_MMAP_LENGTH(BgL_ciphertextz00_5613); 
{ /* Llib/block_ciphers.scm 893 */
obj_t BgL_strz00_5616;
{ /* Llib/block_ciphers.scm 894 */

{ /* Llib/block_ciphers.scm 894 */
long BgL_kz00_5617;
BgL_kz00_5617 = 
(long)(BgL_lenz00_5615); 
BgL_strz00_5616 = 
make_string(BgL_kz00_5617, ((unsigned char)' ')); } } 
{ /* Llib/block_ciphers.scm 894 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_5618;
BgL_statez00_5618 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4459, BgL_passwordz00_5614, BgL_ivz00_4462, BgL_modez00_4463, BgL_padz00_4464, BgL_noncezd2initz12zc0_4465, BgL_noncezd2updatez12zc0_4466, BgL_stringzd2ze3keyz31_4467); 
{ /* Llib/block_ciphers.scm 895 */

{ /* Llib/block_ciphers.scm 898 */
long BgL_tmpz00_9048;
BgL_tmpz00_9048 = 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_5618, BgL_ciphertextz00_5613, ((long)0), BGl_readzd2mmapzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_strz00_5616, ((long)0), BGl_blitzd2stringzd2urz12zd2envzc0zz__r4_strings_6_7z00); 
return 
bgl_string_shrink(BgL_strz00_5616, BgL_tmpz00_9048);} } } } } } } 

}



/* _decrypt-port */
obj_t BGl__decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1467z00_359, obj_t BgL_opt1466z00_358)
{
{ /* Llib/block_ciphers.scm 903 */
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_cipherz00_1326;obj_t BgL_ciphertextz00_1327;obj_t BgL_passwordz00_1328;
BgL_cipherz00_1326 = 
VECTOR_REF(BgL_opt1466z00_358,((long)0)); 
BgL_ciphertextz00_1327 = 
VECTOR_REF(BgL_opt1466z00_358,((long)1)); 
BgL_passwordz00_1328 = 
VECTOR_REF(BgL_opt1466z00_358,((long)2)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_ivz00_1329;
BgL_ivz00_1329 = BFALSE; 
{ /* Llib/block_ciphers.scm 904 */
obj_t BgL_modez00_1330;
BgL_modez00_1330 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2initz12zc0_1331;
BgL_noncezd2initz12zc0_1331 = BFALSE; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2updatez12zc0_1332;
BgL_noncezd2updatez12zc0_1332 = BFALSE; 
{ /* Llib/block_ciphers.scm 904 */
obj_t BgL_padz00_1333;
BgL_padz00_1333 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_stringzd2ze3keyz31_1334;
BgL_stringzd2ze3keyz31_1334 = BFALSE; 
{ /* Llib/block_ciphers.scm 903 */

{ 
long BgL_iz00_1335;
BgL_iz00_1335 = ((long)3); 
BgL_check1470z00_1336:
if(
(BgL_iz00_1335==
VECTOR_LENGTH(BgL_opt1466z00_358)))
{ /* Llib/block_ciphers.scm 903 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test3993z00_9059;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2144z00_1342;
BgL_arg2144z00_1342 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_iz00_1335); 
BgL_test3993z00_9059 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2144z00_1342, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test3993z00_9059)
{ 
long BgL_iz00_9064;
BgL_iz00_9064 = 
(BgL_iz00_1335+((long)2)); 
BgL_iz00_1335 = BgL_iz00_9064; 
goto BgL_check1470z00_1336;}  else 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2143z00_1341;
BgL_arg2143z00_1341 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_iz00_1335); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)35)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2143z00_1341); } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1472z00_1343;
BgL_index1472z00_1343 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test3994z00_9072;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3283;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9073;
if(
INTEGERP(BgL_index1472z00_1343))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9073 = BgL_index1472z00_1343
; }  else 
{ 
obj_t BgL_auxz00_9076;
BgL_auxz00_9076 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1472z00_1343); 
FAILURE(BgL_auxz00_9076,BFALSE,BFALSE);} 
BgL_n1z00_3283 = 
(long)CINT(BgL_tmpz00_9073); } 
BgL_test3994z00_9072 = 
(BgL_n1z00_3283>=((long)0)); } 
if(BgL_test3994z00_9072)
{ 
long BgL_auxz00_9082;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9083;
if(
INTEGERP(BgL_index1472z00_1343))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9083 = BgL_index1472z00_1343
; }  else 
{ 
obj_t BgL_auxz00_9086;
BgL_auxz00_9086 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1472z00_1343); 
FAILURE(BgL_auxz00_9086,BFALSE,BFALSE);} 
BgL_auxz00_9082 = 
(long)CINT(BgL_tmpz00_9083); } 
BgL_ivz00_1329 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9082); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1473z00_1345;
BgL_index1473z00_1345 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test3997z00_9095;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3284;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9096;
if(
INTEGERP(BgL_index1473z00_1345))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9096 = BgL_index1473z00_1345
; }  else 
{ 
obj_t BgL_auxz00_9099;
BgL_auxz00_9099 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1473z00_1345); 
FAILURE(BgL_auxz00_9099,BFALSE,BFALSE);} 
BgL_n1z00_3284 = 
(long)CINT(BgL_tmpz00_9096); } 
BgL_test3997z00_9095 = 
(BgL_n1z00_3284>=((long)0)); } 
if(BgL_test3997z00_9095)
{ 
long BgL_auxz00_9105;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9106;
if(
INTEGERP(BgL_index1473z00_1345))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9106 = BgL_index1473z00_1345
; }  else 
{ 
obj_t BgL_auxz00_9109;
BgL_auxz00_9109 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1473z00_1345); 
FAILURE(BgL_auxz00_9109,BFALSE,BFALSE);} 
BgL_auxz00_9105 = 
(long)CINT(BgL_tmpz00_9106); } 
BgL_modez00_1330 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9105); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1474z00_1347;
BgL_index1474z00_1347 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test4000z00_9118;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3285;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9119;
if(
INTEGERP(BgL_index1474z00_1347))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9119 = BgL_index1474z00_1347
; }  else 
{ 
obj_t BgL_auxz00_9122;
BgL_auxz00_9122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1474z00_1347); 
FAILURE(BgL_auxz00_9122,BFALSE,BFALSE);} 
BgL_n1z00_3285 = 
(long)CINT(BgL_tmpz00_9119); } 
BgL_test4000z00_9118 = 
(BgL_n1z00_3285>=((long)0)); } 
if(BgL_test4000z00_9118)
{ 
long BgL_auxz00_9128;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9129;
if(
INTEGERP(BgL_index1474z00_1347))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9129 = BgL_index1474z00_1347
; }  else 
{ 
obj_t BgL_auxz00_9132;
BgL_auxz00_9132 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1474z00_1347); 
FAILURE(BgL_auxz00_9132,BFALSE,BFALSE);} 
BgL_auxz00_9128 = 
(long)CINT(BgL_tmpz00_9129); } 
BgL_noncezd2initz12zc0_1331 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9128); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1475z00_1349;
BgL_index1475z00_1349 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test4003z00_9141;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3286;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9142;
if(
INTEGERP(BgL_index1475z00_1349))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9142 = BgL_index1475z00_1349
; }  else 
{ 
obj_t BgL_auxz00_9145;
BgL_auxz00_9145 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1475z00_1349); 
FAILURE(BgL_auxz00_9145,BFALSE,BFALSE);} 
BgL_n1z00_3286 = 
(long)CINT(BgL_tmpz00_9142); } 
BgL_test4003z00_9141 = 
(BgL_n1z00_3286>=((long)0)); } 
if(BgL_test4003z00_9141)
{ 
long BgL_auxz00_9151;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9152;
if(
INTEGERP(BgL_index1475z00_1349))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9152 = BgL_index1475z00_1349
; }  else 
{ 
obj_t BgL_auxz00_9155;
BgL_auxz00_9155 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1475z00_1349); 
FAILURE(BgL_auxz00_9155,BFALSE,BFALSE);} 
BgL_auxz00_9151 = 
(long)CINT(BgL_tmpz00_9152); } 
BgL_noncezd2updatez12zc0_1332 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9151); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1476z00_1351;
BgL_index1476z00_1351 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test4006z00_9164;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3287;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9165;
if(
INTEGERP(BgL_index1476z00_1351))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9165 = BgL_index1476z00_1351
; }  else 
{ 
obj_t BgL_auxz00_9168;
BgL_auxz00_9168 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1476z00_1351); 
FAILURE(BgL_auxz00_9168,BFALSE,BFALSE);} 
BgL_n1z00_3287 = 
(long)CINT(BgL_tmpz00_9165); } 
BgL_test4006z00_9164 = 
(BgL_n1z00_3287>=((long)0)); } 
if(BgL_test4006z00_9164)
{ 
long BgL_auxz00_9174;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9175;
if(
INTEGERP(BgL_index1476z00_1351))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9175 = BgL_index1476z00_1351
; }  else 
{ 
obj_t BgL_auxz00_9178;
BgL_auxz00_9178 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1476z00_1351); 
FAILURE(BgL_auxz00_9178,BFALSE,BFALSE);} 
BgL_auxz00_9174 = 
(long)CINT(BgL_tmpz00_9175); } 
BgL_padz00_1333 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9174); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_index1477z00_1353;
BgL_index1477z00_1353 = 
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1466z00_358), BgL_opt1466z00_358, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 903 */
bool_t BgL_test4009z00_9187;
{ /* Llib/block_ciphers.scm 903 */
long BgL_n1z00_3288;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9188;
if(
INTEGERP(BgL_index1477z00_1353))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9188 = BgL_index1477z00_1353
; }  else 
{ 
obj_t BgL_auxz00_9191;
BgL_auxz00_9191 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1477z00_1353); 
FAILURE(BgL_auxz00_9191,BFALSE,BFALSE);} 
BgL_n1z00_3288 = 
(long)CINT(BgL_tmpz00_9188); } 
BgL_test4009z00_9187 = 
(BgL_n1z00_3288>=((long)0)); } 
if(BgL_test4009z00_9187)
{ 
long BgL_auxz00_9197;
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_tmpz00_9198;
if(
INTEGERP(BgL_index1477z00_1353))
{ /* Llib/block_ciphers.scm 903 */
BgL_tmpz00_9198 = BgL_index1477z00_1353
; }  else 
{ 
obj_t BgL_auxz00_9201;
BgL_auxz00_9201 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1477z00_1353); 
FAILURE(BgL_auxz00_9201,BFALSE,BFALSE);} 
BgL_auxz00_9197 = 
(long)CINT(BgL_tmpz00_9198); } 
BgL_stringzd2ze3keyz31_1334 = 
VECTOR_REF(BgL_opt1466z00_358,BgL_auxz00_9197); }  else 
{ /* Llib/block_ciphers.scm 903 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_arg2151z00_1355;obj_t BgL_arg2152z00_1356;obj_t BgL_arg2153z00_1357;
BgL_arg2151z00_1355 = 
VECTOR_REF(BgL_opt1466z00_358,((long)0)); 
BgL_arg2152z00_1356 = 
VECTOR_REF(BgL_opt1466z00_358,((long)1)); 
BgL_arg2153z00_1357 = 
VECTOR_REF(BgL_opt1466z00_358,((long)2)); 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_ivz00_1358;
BgL_ivz00_1358 = BgL_ivz00_1329; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_modez00_1359;
BgL_modez00_1359 = BgL_modez00_1330; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2initz12zc0_1360;
BgL_noncezd2initz12zc0_1360 = BgL_noncezd2initz12zc0_1331; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_noncezd2updatez12zc0_1361;
BgL_noncezd2updatez12zc0_1361 = BgL_noncezd2updatez12zc0_1332; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_padz00_1362;
BgL_padz00_1362 = BgL_padz00_1333; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_stringzd2ze3keyz31_1363;
BgL_stringzd2ze3keyz31_1363 = BgL_stringzd2ze3keyz31_1334; 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_cipherz00_3289;obj_t BgL_ciphertextz00_3290;obj_t BgL_passwordz00_3291;
if(
SYMBOLP(BgL_arg2151z00_1355))
{ /* Llib/block_ciphers.scm 903 */
BgL_cipherz00_3289 = BgL_arg2151z00_1355; }  else 
{ 
obj_t BgL_auxz00_9212;
BgL_auxz00_9212 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2151z00_1355); 
FAILURE(BgL_auxz00_9212,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2152z00_1356))
{ /* Llib/block_ciphers.scm 903 */
BgL_ciphertextz00_3290 = BgL_arg2152z00_1356; }  else 
{ 
obj_t BgL_auxz00_9218;
BgL_auxz00_9218 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2152z00_1356); 
FAILURE(BgL_auxz00_9218,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2153z00_1357))
{ /* Llib/block_ciphers.scm 903 */
BgL_passwordz00_3291 = BgL_arg2153z00_1357; }  else 
{ 
obj_t BgL_auxz00_9224;
BgL_auxz00_9224 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)32802)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2153z00_1357); 
FAILURE(BgL_auxz00_9224,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 907 */
obj_t BgL_res2692z00_3298;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3294;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3295;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3294 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3295 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3289, BgL_passwordz00_3291, BgL_ivz00_1358, BgL_modez00_1359, BgL_padz00_1362, BgL_noncezd2initz12zc0_1360, BgL_noncezd2updatez12zc0_1361, BgL_stringzd2ze3keyz31_1363); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3295, BgL_ciphertextz00_3290, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3294, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 920 */
obj_t BgL_aux3078z00_5434;
BgL_aux3078z00_5434 = 
bgl_close_output_port(BgL_pz00_3294); 
if(
STRINGP(BgL_aux3078z00_5434))
{ /* Llib/block_ciphers.scm 920 */
BgL_res2692z00_3298 = BgL_aux3078z00_5434; }  else 
{ 
obj_t BgL_auxz00_9234;
BgL_auxz00_9234 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33510)), BGl_string3225z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3078z00_5434); 
FAILURE(BgL_auxz00_9234,BFALSE,BFALSE);} } } 
return BgL_res2692z00_3298;} } } } } } } } } } } } } } } } } } 

}



/* search1469~0 */
obj_t BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1468z00_5079, obj_t BgL_opt1466z00_5078, obj_t BgL_k1z00_1323, long BgL_iz00_1324)
{
{ /* Llib/block_ciphers.scm 903 */
BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1324==BgL_l1468z00_5079))
{ /* Llib/block_ciphers.scm 903 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 903 */
if(
(BgL_iz00_1324==
(BgL_l1468z00_5079-((long)1))))
{ /* Llib/block_ciphers.scm 903 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)35)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1466z00_5078)));}  else 
{ /* Llib/block_ciphers.scm 903 */
obj_t BgL_vz00_1368;
BgL_vz00_1368 = 
VECTOR_REF(BgL_opt1466z00_5078,BgL_iz00_1324); 
if(
(BgL_vz00_1368==BgL_k1z00_1323))
{ /* Llib/block_ciphers.scm 903 */
return 
BINT(
(BgL_iz00_1324+((long)1)));}  else 
{ 
long BgL_iz00_9253;
BgL_iz00_9253 = 
(BgL_iz00_1324+((long)2)); 
BgL_iz00_1324 = BgL_iz00_9253; 
goto BGl_search1469ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* decrypt-port */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2portzd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_349, obj_t BgL_ciphertextz00_350, obj_t BgL_passwordz00_351, obj_t BgL_ivz00_352, obj_t BgL_modez00_353, obj_t BgL_noncezd2initz12zc0_354, obj_t BgL_noncezd2updatez12zc0_355, obj_t BgL_padz00_356, obj_t BgL_stringzd2ze3keyz31_357)
{
{ /* Llib/block_ciphers.scm 903 */
{ /* Llib/block_ciphers.scm 907 */
obj_t BgL_res2693z00_3305;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3301;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3302;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3301 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3302 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_349, BgL_passwordz00_351, BgL_ivz00_352, BgL_modez00_353, BgL_padz00_356, BgL_noncezd2initz12zc0_354, BgL_noncezd2updatez12zc0_355, BgL_stringzd2ze3keyz31_357); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3302, BgL_ciphertextz00_350, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3301, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_res2693z00_3305 = 
bgl_close_output_port(BgL_pz00_3301); } 
return BgL_res2693z00_3305;} } 

}



/* &decrypt-fast-port */
obj_t BGl_z62decryptzd2fastzd2portz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4468, obj_t BgL_cipherz00_4469, obj_t BgL_ciphertextz00_4470, obj_t BgL_passwordz00_4471, obj_t BgL_ivz00_4472, obj_t BgL_modez00_4473, obj_t BgL_padz00_4474, obj_t BgL_noncezd2initz12zc0_4475, obj_t BgL_noncezd2updatez12zc0_4476, obj_t BgL_stringzd2ze3keyz31_4477)
{
{ /* Llib/block_ciphers.scm 910 */
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_ciphertextz00_5619;obj_t BgL_passwordz00_5620;
if(
INPUT_PORTP(BgL_ciphertextz00_4470))
{ /* Llib/block_ciphers.scm 913 */
BgL_ciphertextz00_5619 = BgL_ciphertextz00_4470; }  else 
{ 
obj_t BgL_auxz00_9261;
BgL_auxz00_9261 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33267)), BGl_string3226z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_ciphertextz00_4470); 
FAILURE(BgL_auxz00_9261,BFALSE,BFALSE);} 
if(
STRINGP(BgL_passwordz00_4471))
{ /* Llib/block_ciphers.scm 913 */
BgL_passwordz00_5620 = BgL_passwordz00_4471; }  else 
{ 
obj_t BgL_auxz00_9267;
BgL_auxz00_9267 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33267)), BGl_string3226z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_passwordz00_4471); 
FAILURE(BgL_auxz00_9267,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_5621;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_5622;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_5621 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_5622 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_4469, BgL_passwordz00_5620, BgL_ivz00_4472, BgL_modez00_4473, BgL_padz00_4474, BgL_noncezd2initz12zc0_4475, BgL_noncezd2updatez12zc0_4476, BgL_stringzd2ze3keyz31_4477); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_5622, BgL_ciphertextz00_5619, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_5621, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
return 
bgl_close_output_port(BgL_pz00_5621);} } } 

}



/* _decrypt-file */
obj_t BGl__decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1479z00_379, obj_t BgL_opt1478z00_378)
{
{ /* Llib/block_ciphers.scm 922 */
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_cipherz00_1379;obj_t BgL_filenamez00_1380;obj_t BgL_passwordz00_1381;
BgL_cipherz00_1379 = 
VECTOR_REF(BgL_opt1478z00_378,((long)0)); 
BgL_filenamez00_1380 = 
VECTOR_REF(BgL_opt1478z00_378,((long)1)); 
BgL_passwordz00_1381 = 
VECTOR_REF(BgL_opt1478z00_378,((long)2)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_ivz00_1382;
BgL_ivz00_1382 = BFALSE; 
{ /* Llib/block_ciphers.scm 923 */
obj_t BgL_modez00_1383;
BgL_modez00_1383 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2initz12zc0_1384;
BgL_noncezd2initz12zc0_1384 = BFALSE; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2updatez12zc0_1385;
BgL_noncezd2updatez12zc0_1385 = BFALSE; 
{ /* Llib/block_ciphers.scm 923 */
obj_t BgL_padz00_1386;
BgL_padz00_1386 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_stringzd2ze3keyz31_1387;
BgL_stringzd2ze3keyz31_1387 = BFALSE; 
{ /* Llib/block_ciphers.scm 922 */

{ 
long BgL_iz00_1388;
BgL_iz00_1388 = ((long)3); 
BgL_check1482z00_1389:
if(
(BgL_iz00_1388==
VECTOR_LENGTH(BgL_opt1478z00_378)))
{ /* Llib/block_ciphers.scm 922 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4022z00_9283;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2166z00_1395;
BgL_arg2166z00_1395 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_iz00_1388); 
BgL_test4022z00_9283 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2166z00_1395, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test4022z00_9283)
{ 
long BgL_iz00_9288;
BgL_iz00_9288 = 
(BgL_iz00_1388+((long)2)); 
BgL_iz00_1388 = BgL_iz00_9288; 
goto BgL_check1482z00_1389;}  else 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2165z00_1394;
BgL_arg2165z00_1394 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_iz00_1388); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2165z00_1394); } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1484z00_1396;
BgL_index1484z00_1396 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)19)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4023z00_9296;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3325;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9297;
if(
INTEGERP(BgL_index1484z00_1396))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9297 = BgL_index1484z00_1396
; }  else 
{ 
obj_t BgL_auxz00_9300;
BgL_auxz00_9300 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1484z00_1396); 
FAILURE(BgL_auxz00_9300,BFALSE,BFALSE);} 
BgL_n1z00_3325 = 
(long)CINT(BgL_tmpz00_9297); } 
BgL_test4023z00_9296 = 
(BgL_n1z00_3325>=((long)0)); } 
if(BgL_test4023z00_9296)
{ 
long BgL_auxz00_9306;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9307;
if(
INTEGERP(BgL_index1484z00_1396))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9307 = BgL_index1484z00_1396
; }  else 
{ 
obj_t BgL_auxz00_9310;
BgL_auxz00_9310 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1484z00_1396); 
FAILURE(BgL_auxz00_9310,BFALSE,BFALSE);} 
BgL_auxz00_9306 = 
(long)CINT(BgL_tmpz00_9307); } 
BgL_ivz00_1382 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9306); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1485z00_1398;
BgL_index1485z00_1398 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)20)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4026z00_9319;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3326;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9320;
if(
INTEGERP(BgL_index1485z00_1398))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9320 = BgL_index1485z00_1398
; }  else 
{ 
obj_t BgL_auxz00_9323;
BgL_auxz00_9323 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1485z00_1398); 
FAILURE(BgL_auxz00_9323,BFALSE,BFALSE);} 
BgL_n1z00_3326 = 
(long)CINT(BgL_tmpz00_9320); } 
BgL_test4026z00_9319 = 
(BgL_n1z00_3326>=((long)0)); } 
if(BgL_test4026z00_9319)
{ 
long BgL_auxz00_9329;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9330;
if(
INTEGERP(BgL_index1485z00_1398))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9330 = BgL_index1485z00_1398
; }  else 
{ 
obj_t BgL_auxz00_9333;
BgL_auxz00_9333 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1485z00_1398); 
FAILURE(BgL_auxz00_9333,BFALSE,BFALSE);} 
BgL_auxz00_9329 = 
(long)CINT(BgL_tmpz00_9330); } 
BgL_modez00_1383 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9329); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1486z00_1400;
BgL_index1486z00_1400 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)21)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4029z00_9342;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3327;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9343;
if(
INTEGERP(BgL_index1486z00_1400))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9343 = BgL_index1486z00_1400
; }  else 
{ 
obj_t BgL_auxz00_9346;
BgL_auxz00_9346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1486z00_1400); 
FAILURE(BgL_auxz00_9346,BFALSE,BFALSE);} 
BgL_n1z00_3327 = 
(long)CINT(BgL_tmpz00_9343); } 
BgL_test4029z00_9342 = 
(BgL_n1z00_3327>=((long)0)); } 
if(BgL_test4029z00_9342)
{ 
long BgL_auxz00_9352;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9353;
if(
INTEGERP(BgL_index1486z00_1400))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9353 = BgL_index1486z00_1400
; }  else 
{ 
obj_t BgL_auxz00_9356;
BgL_auxz00_9356 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1486z00_1400); 
FAILURE(BgL_auxz00_9356,BFALSE,BFALSE);} 
BgL_auxz00_9352 = 
(long)CINT(BgL_tmpz00_9353); } 
BgL_noncezd2initz12zc0_1384 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9352); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1487z00_1402;
BgL_index1487z00_1402 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)22)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4032z00_9365;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3328;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9366;
if(
INTEGERP(BgL_index1487z00_1402))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9366 = BgL_index1487z00_1402
; }  else 
{ 
obj_t BgL_auxz00_9369;
BgL_auxz00_9369 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1487z00_1402); 
FAILURE(BgL_auxz00_9369,BFALSE,BFALSE);} 
BgL_n1z00_3328 = 
(long)CINT(BgL_tmpz00_9366); } 
BgL_test4032z00_9365 = 
(BgL_n1z00_3328>=((long)0)); } 
if(BgL_test4032z00_9365)
{ 
long BgL_auxz00_9375;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9376;
if(
INTEGERP(BgL_index1487z00_1402))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9376 = BgL_index1487z00_1402
; }  else 
{ 
obj_t BgL_auxz00_9379;
BgL_auxz00_9379 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1487z00_1402); 
FAILURE(BgL_auxz00_9379,BFALSE,BFALSE);} 
BgL_auxz00_9375 = 
(long)CINT(BgL_tmpz00_9376); } 
BgL_noncezd2updatez12zc0_1385 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9375); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1488z00_1404;
BgL_index1488z00_1404 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)23)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4035z00_9388;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3329;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9389;
if(
INTEGERP(BgL_index1488z00_1404))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9389 = BgL_index1488z00_1404
; }  else 
{ 
obj_t BgL_auxz00_9392;
BgL_auxz00_9392 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1488z00_1404); 
FAILURE(BgL_auxz00_9392,BFALSE,BFALSE);} 
BgL_n1z00_3329 = 
(long)CINT(BgL_tmpz00_9389); } 
BgL_test4035z00_9388 = 
(BgL_n1z00_3329>=((long)0)); } 
if(BgL_test4035z00_9388)
{ 
long BgL_auxz00_9398;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9399;
if(
INTEGERP(BgL_index1488z00_1404))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9399 = BgL_index1488z00_1404
; }  else 
{ 
obj_t BgL_auxz00_9402;
BgL_auxz00_9402 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1488z00_1404); 
FAILURE(BgL_auxz00_9402,BFALSE,BFALSE);} 
BgL_auxz00_9398 = 
(long)CINT(BgL_tmpz00_9399); } 
BgL_padz00_1386 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9398); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_index1489z00_1406;
BgL_index1489z00_1406 = 
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1478z00_378), BgL_opt1478z00_378, 
CNST_TABLE_REF(((long)24)), ((long)3)); 
{ /* Llib/block_ciphers.scm 922 */
bool_t BgL_test4038z00_9411;
{ /* Llib/block_ciphers.scm 922 */
long BgL_n1z00_3330;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9412;
if(
INTEGERP(BgL_index1489z00_1406))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9412 = BgL_index1489z00_1406
; }  else 
{ 
obj_t BgL_auxz00_9415;
BgL_auxz00_9415 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1489z00_1406); 
FAILURE(BgL_auxz00_9415,BFALSE,BFALSE);} 
BgL_n1z00_3330 = 
(long)CINT(BgL_tmpz00_9412); } 
BgL_test4038z00_9411 = 
(BgL_n1z00_3330>=((long)0)); } 
if(BgL_test4038z00_9411)
{ 
long BgL_auxz00_9421;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_tmpz00_9422;
if(
INTEGERP(BgL_index1489z00_1406))
{ /* Llib/block_ciphers.scm 922 */
BgL_tmpz00_9422 = BgL_index1489z00_1406
; }  else 
{ 
obj_t BgL_auxz00_9425;
BgL_auxz00_9425 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1489z00_1406); 
FAILURE(BgL_auxz00_9425,BFALSE,BFALSE);} 
BgL_auxz00_9421 = 
(long)CINT(BgL_tmpz00_9422); } 
BgL_stringzd2ze3keyz31_1387 = 
VECTOR_REF(BgL_opt1478z00_378,BgL_auxz00_9421); }  else 
{ /* Llib/block_ciphers.scm 922 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_arg2173z00_1408;obj_t BgL_arg2174z00_1409;obj_t BgL_arg2175z00_1410;
BgL_arg2173z00_1408 = 
VECTOR_REF(BgL_opt1478z00_378,((long)0)); 
BgL_arg2174z00_1409 = 
VECTOR_REF(BgL_opt1478z00_378,((long)1)); 
BgL_arg2175z00_1410 = 
VECTOR_REF(BgL_opt1478z00_378,((long)2)); 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_ivz00_1411;
BgL_ivz00_1411 = BgL_ivz00_1382; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_modez00_1412;
BgL_modez00_1412 = BgL_modez00_1383; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2initz12zc0_1413;
BgL_noncezd2initz12zc0_1413 = BgL_noncezd2initz12zc0_1384; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_noncezd2updatez12zc0_1414;
BgL_noncezd2updatez12zc0_1414 = BgL_noncezd2updatez12zc0_1385; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_padz00_1415;
BgL_padz00_1415 = BgL_padz00_1386; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_stringzd2ze3keyz31_1416;
BgL_stringzd2ze3keyz31_1416 = BgL_stringzd2ze3keyz31_1387; 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_res2695z00_3350;
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_cipherz00_3331;obj_t BgL_filenamez00_3332;obj_t BgL_passwordz00_3333;
if(
SYMBOLP(BgL_arg2173z00_1408))
{ /* Llib/block_ciphers.scm 922 */
BgL_cipherz00_3331 = BgL_arg2173z00_1408; }  else 
{ 
obj_t BgL_auxz00_9436;
BgL_auxz00_9436 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2173z00_1408); 
FAILURE(BgL_auxz00_9436,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2174z00_1409))
{ /* Llib/block_ciphers.scm 922 */
BgL_filenamez00_3332 = BgL_arg2174z00_1409; }  else 
{ 
obj_t BgL_auxz00_9442;
BgL_auxz00_9442 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2174z00_1409); 
FAILURE(BgL_auxz00_9442,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2175z00_1410))
{ /* Llib/block_ciphers.scm 922 */
BgL_passwordz00_3333 = BgL_arg2175z00_1410; }  else 
{ 
obj_t BgL_auxz00_9448;
BgL_auxz00_9448 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33535)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2175z00_1410); 
FAILURE(BgL_auxz00_9448,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 926 */
obj_t BgL_pz00_3334;
{ /* Llib/block_ciphers.scm 926 */

BgL_pz00_3334 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_3332, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3334))
{ /* Llib/block_ciphers.scm 927 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 927 */
BGl_errorz00zz__errorz00(BGl_string3228z00zz__cryptozd2blockzd2ciphersz00, BGl_string3216z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_3332); } 
{ /* Llib/block_ciphers.scm 931 */
obj_t BgL_exitd1240z00_3338;
BgL_exitd1240z00_3338 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_zc3z04anonymousza32184ze3z87_4478;
BgL_zc3z04anonymousza32184ze3z87_4478 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32184ze3ze5zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_4478, 
(int)(((long)0)), BgL_pz00_3334); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1240z00_3338, BgL_zc3z04anonymousza32184ze3z87_4478); 
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_tmp1242z00_3340;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_res2694z00_3348;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_ciphertextz00_3342;
if(
INPUT_PORTP(BgL_pz00_3334))
{ /* Llib/block_ciphers.scm 932 */
BgL_ciphertextz00_3342 = BgL_pz00_3334; }  else 
{ 
obj_t BgL_auxz00_9466;
BgL_auxz00_9466 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33903)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3334); 
FAILURE(BgL_auxz00_9466,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3344;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3345;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3344 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3345 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3331, BgL_passwordz00_3333, BgL_ivz00_1411, BgL_modez00_1412, BgL_padz00_1415, BgL_noncezd2initz12zc0_1413, BgL_noncezd2updatez12zc0_1414, BgL_stringzd2ze3keyz31_1416); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3345, BgL_ciphertextz00_3342, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3344, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
{ /* Llib/block_ciphers.scm 920 */
obj_t BgL_aux3116z00_5472;
BgL_aux3116z00_5472 = 
bgl_close_output_port(BgL_pz00_3344); 
if(
STRINGP(BgL_aux3116z00_5472))
{ /* Llib/block_ciphers.scm 920 */
BgL_res2694z00_3348 = BgL_aux3116z00_5472; }  else 
{ 
obj_t BgL_auxz00_9476;
BgL_auxz00_9476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33510)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_aux3116z00_5472); 
FAILURE(BgL_auxz00_9476,BFALSE,BFALSE);} } } } 
BgL_tmp1242z00_3340 = BgL_res2694z00_3348; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1240z00_3338); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_portz00_3349;
if(
INPUT_PORTP(BgL_pz00_3334))
{ /* Llib/block_ciphers.scm 935 */
BgL_portz00_3349 = BgL_pz00_3334; }  else 
{ 
obj_t BgL_auxz00_9483;
BgL_auxz00_9483 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)33999)), BGl_string3227z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3334); 
FAILURE(BgL_auxz00_9483,BFALSE,BFALSE);} 
bgl_close_input_port(BgL_portz00_3349); } 
BgL_res2695z00_3350 = BgL_tmp1242z00_3340; } } } } } 
return BgL_res2695z00_3350;} } } } } } } } } } } } } } } } } 

}



/* search1481~0 */
obj_t BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1480z00_5077, obj_t BgL_opt1478z00_5076, obj_t BgL_k1z00_1376, long BgL_iz00_1377)
{
{ /* Llib/block_ciphers.scm 922 */
BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1377==BgL_l1480z00_5077))
{ /* Llib/block_ciphers.scm 922 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 922 */
if(
(BgL_iz00_1377==
(BgL_l1480z00_5077-((long)1))))
{ /* Llib/block_ciphers.scm 922 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string3205z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1478z00_5076)));}  else 
{ /* Llib/block_ciphers.scm 922 */
obj_t BgL_vz00_1421;
BgL_vz00_1421 = 
VECTOR_REF(BgL_opt1478z00_5076,BgL_iz00_1377); 
if(
(BgL_vz00_1421==BgL_k1z00_1376))
{ /* Llib/block_ciphers.scm 922 */
return 
BINT(
(BgL_iz00_1377+((long)1)));}  else 
{ 
long BgL_iz00_9503;
BgL_iz00_9503 = 
(BgL_iz00_1377+((long)2)); 
BgL_iz00_1377 = BgL_iz00_9503; 
goto BGl_search1481ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* &<@anonymous:2184> */
obj_t BGl_z62zc3z04anonymousza32184ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4479)
{
{ /* Llib/block_ciphers.scm 931 */
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_pz00_4480;
BgL_pz00_4480 = 
PROCEDURE_REF(BgL_envz00_4479, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_4480));} } 

}



/* decrypt-file */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2filezd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_369, obj_t BgL_filenamez00_370, obj_t BgL_passwordz00_371, obj_t BgL_ivz00_372, obj_t BgL_modez00_373, obj_t BgL_noncezd2initz12zc0_374, obj_t BgL_noncezd2updatez12zc0_375, obj_t BgL_padz00_376, obj_t BgL_stringzd2ze3keyz31_377)
{
{ /* Llib/block_ciphers.scm 922 */
{ /* Llib/block_ciphers.scm 926 */
obj_t BgL_pz00_3351;
{ /* Llib/block_ciphers.scm 926 */

BgL_pz00_3351 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_370, BTRUE, 
BINT(((long)5000000))); } 
if(
CBOOL(BgL_pz00_3351))
{ /* Llib/block_ciphers.scm 927 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 927 */
BGl_errorz00zz__errorz00(BGl_string3228z00zz__cryptozd2blockzd2ciphersz00, BGl_string3216z00zz__cryptozd2blockzd2ciphersz00, BgL_filenamez00_370); } 
{ /* Llib/block_ciphers.scm 931 */
obj_t BgL_exitd1240z00_3355;
BgL_exitd1240z00_3355 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_zc3z04anonymousza32184ze3z87_4481;
BgL_zc3z04anonymousza32184ze3z87_4481 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32184ze32745ze5zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_4481, 
(int)(((long)0)), BgL_pz00_3351); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1240z00_3355, BgL_zc3z04anonymousza32184ze3z87_4481); 
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_tmp1242z00_3357;
{ /* Llib/block_ciphers.scm 932 */
obj_t BgL_res2696z00_3365;
{ /* Llib/block_ciphers.scm 913 */
obj_t BgL_pz00_3361;BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3362;
{ /* Llib/block_ciphers.scm 913 */

{ /* Llib/block_ciphers.scm 913 */

BgL_pz00_3361 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_statez00_3362 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_369, BgL_passwordz00_371, BgL_ivz00_372, BgL_modez00_373, BgL_padz00_376, BgL_noncezd2initz12zc0_374, BgL_noncezd2updatez12zc0_375, BgL_stringzd2ze3keyz31_377); 
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3362, 
((obj_t)BgL_pz00_3351), ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_pz00_3361, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00); 
BgL_res2696z00_3365 = 
bgl_close_output_port(BgL_pz00_3361); } 
BgL_tmp1242z00_3357 = BgL_res2696z00_3365; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1240z00_3355); 
bgl_close_input_port(
((obj_t)BgL_pz00_3351)); 
return BgL_tmp1242z00_3357;} } } } } 

}



/* &<@anonymous:2184>2745 */
obj_t BGl_z62zc3z04anonymousza32184ze32745ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4482)
{
{ /* Llib/block_ciphers.scm 931 */
{ /* Llib/block_ciphers.scm 935 */
obj_t BgL_pz00_4483;
BgL_pz00_4483 = 
PROCEDURE_REF(BgL_envz00_4482, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_4483));} } 

}



/* _decrypt-sendchars */
obj_t BGl__decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_env1491z00_391, obj_t BgL_opt1490z00_390)
{
{ /* Llib/block_ciphers.scm 937 */
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_cipherz00_1438;obj_t BgL_inz00_1439;obj_t BgL_outz00_1440;obj_t BgL_passwordz00_1441;
BgL_cipherz00_1438 = 
VECTOR_REF(BgL_opt1490z00_390,((long)0)); 
BgL_inz00_1439 = 
VECTOR_REF(BgL_opt1490z00_390,((long)1)); 
BgL_outz00_1440 = 
VECTOR_REF(BgL_opt1490z00_390,((long)2)); 
BgL_passwordz00_1441 = 
VECTOR_REF(BgL_opt1490z00_390,((long)3)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_ivz00_1442;
BgL_ivz00_1442 = BFALSE; 
{ /* Llib/block_ciphers.scm 939 */
obj_t BgL_modez00_1443;
BgL_modez00_1443 = 
CNST_TABLE_REF(((long)6)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2initz12zc0_1444;
BgL_noncezd2initz12zc0_1444 = BFALSE; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2updatez12zc0_1445;
BgL_noncezd2updatez12zc0_1445 = BFALSE; 
{ /* Llib/block_ciphers.scm 939 */
obj_t BgL_padz00_1446;
BgL_padz00_1446 = 
CNST_TABLE_REF(((long)11)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_stringzd2ze3keyz31_1447;
BgL_stringzd2ze3keyz31_1447 = BFALSE; 
{ /* Llib/block_ciphers.scm 937 */

{ 
long BgL_iz00_1448;
BgL_iz00_1448 = ((long)4); 
BgL_check1494z00_1449:
if(
(BgL_iz00_1448==
VECTOR_LENGTH(BgL_opt1490z00_390)))
{ /* Llib/block_ciphers.scm 937 */BNIL; }  else 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4053z00_9542;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2190z00_1455;
BgL_arg2190z00_1455 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_iz00_1448); 
BgL_test4053z00_9542 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg2190z00_1455, 
CNST_TABLE_REF(((long)17)))); } 
if(BgL_test4053z00_9542)
{ 
long BgL_iz00_9547;
BgL_iz00_9547 = 
(BgL_iz00_1448+((long)2)); 
BgL_iz00_1448 = BgL_iz00_9547; 
goto BgL_check1494z00_1449;}  else 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2189z00_1454;
BgL_arg2189z00_1454 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_iz00_1448); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)37)), BGl_string3200z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2189z00_1454); } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1496z00_1456;
BgL_index1496z00_1456 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)19)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4054z00_9555;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3382;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9556;
if(
INTEGERP(BgL_index1496z00_1456))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9556 = BgL_index1496z00_1456
; }  else 
{ 
obj_t BgL_auxz00_9559;
BgL_auxz00_9559 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1496z00_1456); 
FAILURE(BgL_auxz00_9559,BFALSE,BFALSE);} 
BgL_n1z00_3382 = 
(long)CINT(BgL_tmpz00_9556); } 
BgL_test4054z00_9555 = 
(BgL_n1z00_3382>=((long)0)); } 
if(BgL_test4054z00_9555)
{ 
long BgL_auxz00_9565;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9566;
if(
INTEGERP(BgL_index1496z00_1456))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9566 = BgL_index1496z00_1456
; }  else 
{ 
obj_t BgL_auxz00_9569;
BgL_auxz00_9569 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1496z00_1456); 
FAILURE(BgL_auxz00_9569,BFALSE,BFALSE);} 
BgL_auxz00_9565 = 
(long)CINT(BgL_tmpz00_9566); } 
BgL_ivz00_1442 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9565); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1497z00_1458;
BgL_index1497z00_1458 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)20)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4057z00_9578;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3383;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9579;
if(
INTEGERP(BgL_index1497z00_1458))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9579 = BgL_index1497z00_1458
; }  else 
{ 
obj_t BgL_auxz00_9582;
BgL_auxz00_9582 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1497z00_1458); 
FAILURE(BgL_auxz00_9582,BFALSE,BFALSE);} 
BgL_n1z00_3383 = 
(long)CINT(BgL_tmpz00_9579); } 
BgL_test4057z00_9578 = 
(BgL_n1z00_3383>=((long)0)); } 
if(BgL_test4057z00_9578)
{ 
long BgL_auxz00_9588;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9589;
if(
INTEGERP(BgL_index1497z00_1458))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9589 = BgL_index1497z00_1458
; }  else 
{ 
obj_t BgL_auxz00_9592;
BgL_auxz00_9592 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1497z00_1458); 
FAILURE(BgL_auxz00_9592,BFALSE,BFALSE);} 
BgL_auxz00_9588 = 
(long)CINT(BgL_tmpz00_9589); } 
BgL_modez00_1443 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9588); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1498z00_1460;
BgL_index1498z00_1460 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)21)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4060z00_9601;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3384;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9602;
if(
INTEGERP(BgL_index1498z00_1460))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9602 = BgL_index1498z00_1460
; }  else 
{ 
obj_t BgL_auxz00_9605;
BgL_auxz00_9605 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1498z00_1460); 
FAILURE(BgL_auxz00_9605,BFALSE,BFALSE);} 
BgL_n1z00_3384 = 
(long)CINT(BgL_tmpz00_9602); } 
BgL_test4060z00_9601 = 
(BgL_n1z00_3384>=((long)0)); } 
if(BgL_test4060z00_9601)
{ 
long BgL_auxz00_9611;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9612;
if(
INTEGERP(BgL_index1498z00_1460))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9612 = BgL_index1498z00_1460
; }  else 
{ 
obj_t BgL_auxz00_9615;
BgL_auxz00_9615 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1498z00_1460); 
FAILURE(BgL_auxz00_9615,BFALSE,BFALSE);} 
BgL_auxz00_9611 = 
(long)CINT(BgL_tmpz00_9612); } 
BgL_noncezd2initz12zc0_1444 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9611); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1499z00_1462;
BgL_index1499z00_1462 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)22)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4063z00_9624;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3385;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9625;
if(
INTEGERP(BgL_index1499z00_1462))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9625 = BgL_index1499z00_1462
; }  else 
{ 
obj_t BgL_auxz00_9628;
BgL_auxz00_9628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1499z00_1462); 
FAILURE(BgL_auxz00_9628,BFALSE,BFALSE);} 
BgL_n1z00_3385 = 
(long)CINT(BgL_tmpz00_9625); } 
BgL_test4063z00_9624 = 
(BgL_n1z00_3385>=((long)0)); } 
if(BgL_test4063z00_9624)
{ 
long BgL_auxz00_9634;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9635;
if(
INTEGERP(BgL_index1499z00_1462))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9635 = BgL_index1499z00_1462
; }  else 
{ 
obj_t BgL_auxz00_9638;
BgL_auxz00_9638 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1499z00_1462); 
FAILURE(BgL_auxz00_9638,BFALSE,BFALSE);} 
BgL_auxz00_9634 = 
(long)CINT(BgL_tmpz00_9635); } 
BgL_noncezd2updatez12zc0_1445 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9634); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1500z00_1464;
BgL_index1500z00_1464 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)23)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4066z00_9647;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3386;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9648;
if(
INTEGERP(BgL_index1500z00_1464))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9648 = BgL_index1500z00_1464
; }  else 
{ 
obj_t BgL_auxz00_9651;
BgL_auxz00_9651 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1500z00_1464); 
FAILURE(BgL_auxz00_9651,BFALSE,BFALSE);} 
BgL_n1z00_3386 = 
(long)CINT(BgL_tmpz00_9648); } 
BgL_test4066z00_9647 = 
(BgL_n1z00_3386>=((long)0)); } 
if(BgL_test4066z00_9647)
{ 
long BgL_auxz00_9657;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9658;
if(
INTEGERP(BgL_index1500z00_1464))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9658 = BgL_index1500z00_1464
; }  else 
{ 
obj_t BgL_auxz00_9661;
BgL_auxz00_9661 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1500z00_1464); 
FAILURE(BgL_auxz00_9661,BFALSE,BFALSE);} 
BgL_auxz00_9657 = 
(long)CINT(BgL_tmpz00_9658); } 
BgL_padz00_1446 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9657); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_index1501z00_1466;
BgL_index1501z00_1466 = 
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(
VECTOR_LENGTH(BgL_opt1490z00_390), BgL_opt1490z00_390, 
CNST_TABLE_REF(((long)24)), ((long)4)); 
{ /* Llib/block_ciphers.scm 937 */
bool_t BgL_test4069z00_9670;
{ /* Llib/block_ciphers.scm 937 */
long BgL_n1z00_3387;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9671;
if(
INTEGERP(BgL_index1501z00_1466))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9671 = BgL_index1501z00_1466
; }  else 
{ 
obj_t BgL_auxz00_9674;
BgL_auxz00_9674 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1501z00_1466); 
FAILURE(BgL_auxz00_9674,BFALSE,BFALSE);} 
BgL_n1z00_3387 = 
(long)CINT(BgL_tmpz00_9671); } 
BgL_test4069z00_9670 = 
(BgL_n1z00_3387>=((long)0)); } 
if(BgL_test4069z00_9670)
{ 
long BgL_auxz00_9680;
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_tmpz00_9681;
if(
INTEGERP(BgL_index1501z00_1466))
{ /* Llib/block_ciphers.scm 937 */
BgL_tmpz00_9681 = BgL_index1501z00_1466
; }  else 
{ 
obj_t BgL_auxz00_9684;
BgL_auxz00_9684 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_index1501z00_1466); 
FAILURE(BgL_auxz00_9684,BFALSE,BFALSE);} 
BgL_auxz00_9680 = 
(long)CINT(BgL_tmpz00_9681); } 
BgL_stringzd2ze3keyz31_1447 = 
VECTOR_REF(BgL_opt1490z00_390,BgL_auxz00_9680); }  else 
{ /* Llib/block_ciphers.scm 937 */BFALSE; } } } 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_arg2197z00_1468;obj_t BgL_arg2198z00_1469;obj_t BgL_arg2199z00_1470;obj_t BgL_arg2200z00_1471;
BgL_arg2197z00_1468 = 
VECTOR_REF(BgL_opt1490z00_390,((long)0)); 
BgL_arg2198z00_1469 = 
VECTOR_REF(BgL_opt1490z00_390,((long)1)); 
BgL_arg2199z00_1470 = 
VECTOR_REF(BgL_opt1490z00_390,((long)2)); 
BgL_arg2200z00_1471 = 
VECTOR_REF(BgL_opt1490z00_390,((long)3)); 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_ivz00_1472;
BgL_ivz00_1472 = BgL_ivz00_1442; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_modez00_1473;
BgL_modez00_1473 = BgL_modez00_1443; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2initz12zc0_1474;
BgL_noncezd2initz12zc0_1474 = BgL_noncezd2initz12zc0_1444; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_noncezd2updatez12zc0_1475;
BgL_noncezd2updatez12zc0_1475 = BgL_noncezd2updatez12zc0_1445; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_padz00_1476;
BgL_padz00_1476 = BgL_padz00_1446; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_stringzd2ze3keyz31_1477;
BgL_stringzd2ze3keyz31_1477 = BgL_stringzd2ze3keyz31_1447; 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_cipherz00_3388;obj_t BgL_inz00_3389;obj_t BgL_outz00_3390;obj_t BgL_passwordz00_3391;
if(
SYMBOLP(BgL_arg2197z00_1468))
{ /* Llib/block_ciphers.scm 937 */
BgL_cipherz00_3388 = BgL_arg2197z00_1468; }  else 
{ 
obj_t BgL_auxz00_9696;
BgL_auxz00_9696 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2197z00_1468); 
FAILURE(BgL_auxz00_9696,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg2198z00_1469))
{ /* Llib/block_ciphers.scm 937 */
BgL_inz00_3389 = BgL_arg2198z00_1469; }  else 
{ 
obj_t BgL_auxz00_9702;
BgL_auxz00_9702 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3212z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2198z00_1469); 
FAILURE(BgL_auxz00_9702,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg2199z00_1470))
{ /* Llib/block_ciphers.scm 937 */
BgL_outz00_3390 = BgL_arg2199z00_1470; }  else 
{ 
obj_t BgL_auxz00_9708;
BgL_auxz00_9708 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3218z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2199z00_1470); 
FAILURE(BgL_auxz00_9708,BFALSE,BFALSE);} 
if(
STRINGP(BgL_arg2200z00_1471))
{ /* Llib/block_ciphers.scm 937 */
BgL_passwordz00_3391 = BgL_arg2200z00_1471; }  else 
{ 
obj_t BgL_auxz00_9714;
BgL_auxz00_9714 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34006)), BGl_string3229z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_arg2200z00_1471); 
FAILURE(BgL_auxz00_9714,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 941 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3392;
BgL_statez00_3392 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_3388, BgL_passwordz00_3391, BgL_ivz00_1472, BgL_modez00_1473, BgL_padz00_1476, BgL_noncezd2initz12zc0_1474, BgL_noncezd2updatez12zc0_1475, BgL_stringzd2ze3keyz31_1477); 
return 
BINT(
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3392, BgL_inz00_3389, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_3390, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } } } } } } } } } } } } } } } } } 

}



/* search1493~0 */
obj_t BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00(long BgL_l1492z00_5075, obj_t BgL_opt1490z00_5074, obj_t BgL_k1z00_1435, long BgL_iz00_1436)
{
{ /* Llib/block_ciphers.scm 937 */
BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00:
if(
(BgL_iz00_1436==BgL_l1492z00_5075))
{ /* Llib/block_ciphers.scm 937 */
return 
BINT(((long)-1));}  else 
{ /* Llib/block_ciphers.scm 937 */
if(
(BgL_iz00_1436==
(BgL_l1492z00_5075-((long)1))))
{ /* Llib/block_ciphers.scm 937 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)37)), BGl_string3219z00zz__cryptozd2blockzd2ciphersz00, 
BINT(
VECTOR_LENGTH(BgL_opt1490z00_5074)));}  else 
{ /* Llib/block_ciphers.scm 937 */
obj_t BgL_vz00_1482;
BgL_vz00_1482 = 
VECTOR_REF(BgL_opt1490z00_5074,BgL_iz00_1436); 
if(
(BgL_vz00_1482==BgL_k1z00_1435))
{ /* Llib/block_ciphers.scm 937 */
return 
BINT(
(BgL_iz00_1436+((long)1)));}  else 
{ 
long BgL_iz00_9736;
BgL_iz00_9736 = 
(BgL_iz00_1436+((long)2)); 
BgL_iz00_1436 = BgL_iz00_9736; 
goto BGl_search1493ze70ze7zz__cryptozd2blockzd2ciphersz00;} } } } 

}



/* decrypt-sendchars */
BGL_EXPORTED_DEF obj_t BGl_decryptzd2sendcharszd2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_cipherz00_380, obj_t BgL_inz00_381, obj_t BgL_outz00_382, obj_t BgL_passwordz00_383, obj_t BgL_ivz00_384, obj_t BgL_modez00_385, obj_t BgL_noncezd2initz12zc0_386, obj_t BgL_noncezd2updatez12zc0_387, obj_t BgL_padz00_388, obj_t BgL_stringzd2ze3keyz31_389)
{
{ /* Llib/block_ciphers.scm 937 */
{ /* Llib/block_ciphers.scm 941 */
BgL_cipherzd2modezd2statez00_bglt BgL_statez00_3393;
BgL_statez00_3393 = 
BGl_createzd2decryptionzd2statez00zz__cryptozd2blockzd2ciphersz00(BgL_cipherz00_380, BgL_passwordz00_383, BgL_ivz00_384, BgL_modez00_385, BgL_padz00_388, BgL_noncezd2initz12zc0_386, BgL_noncezd2updatez12zc0_387, BgL_stringzd2ze3keyz31_389); 
return 
BINT(
BGl_decryptzd2inputz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_statez00_3393, BgL_inz00_381, ((long)0), BGl_readzd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BgL_outz00_382, ((long)0), BGl_writezd2portzd2atz12zd2envzc0zz__cryptozd2blockzd2ciphersz00));} } 

}



/* register-cipher! */
BGL_EXPORTED_DEF obj_t BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_lookupzd2namezd2_392, BgL_blockzd2cipherzd2_bglt BgL_descz00_393)
{
{ /* Llib/block_ciphers.scm 952 */
{ /* Llib/block_ciphers.scm 953 */
obj_t BgL_arg2208z00_3394;
BgL_arg2208z00_3394 = 
MAKE_YOUNG_PAIR(BgL_lookupzd2namezd2_392, 
((obj_t)BgL_descz00_393)); 
return ( 
BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00 = 
MAKE_YOUNG_PAIR(BgL_arg2208z00_3394, BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00), BUNSPEC) ;} } 

}



/* &register-cipher! */
obj_t BGl_z62registerzd2cipherz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4484, obj_t BgL_lookupzd2namezd2_4485, obj_t BgL_descz00_4486)
{
{ /* Llib/block_ciphers.scm 952 */
{ /* Llib/block_ciphers.scm 953 */
BgL_blockzd2cipherzd2_bglt BgL_auxz00_9751;obj_t BgL_auxz00_9744;
if(
BGl_isazf3zf3zz__objectz00(BgL_descz00_4486, BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 953 */
BgL_auxz00_9751 = 
((BgL_blockzd2cipherzd2_bglt)BgL_descz00_4486)
; }  else 
{ 
obj_t BgL_auxz00_9755;
BgL_auxz00_9755 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34570)), BGl_string3230z00zz__cryptozd2blockzd2ciphersz00, BGl_string3231z00zz__cryptozd2blockzd2ciphersz00, BgL_descz00_4486); 
FAILURE(BgL_auxz00_9755,BFALSE,BFALSE);} 
if(
SYMBOLP(BgL_lookupzd2namezd2_4485))
{ /* Llib/block_ciphers.scm 953 */
BgL_auxz00_9744 = BgL_lookupzd2namezd2_4485
; }  else 
{ 
obj_t BgL_auxz00_9747;
BgL_auxz00_9747 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34570)), BGl_string3230z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_4485); 
FAILURE(BgL_auxz00_9747,BFALSE,BFALSE);} 
return 
BGl_registerzd2cipherz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_9744, BgL_auxz00_9751);} } 

}



/* block-cipher-description */
BGL_EXPORTED_DEF BgL_blockzd2cipherzd2_bglt BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(obj_t BgL_lookupzd2namezd2_394)
{
{ /* Llib/block_ciphers.scm 955 */
{ /* Llib/block_ciphers.scm 956 */
obj_t BgL_desczd2pzd2_1488;
BgL_desczd2pzd2_1488 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_lookupzd2namezd2_394, BGl_za2ciphersza2z00zz__cryptozd2blockzd2ciphersz00); 
if(
CBOOL(BgL_desczd2pzd2_1488))
{ /* Llib/block_ciphers.scm 957 */BFALSE; }  else 
{ /* Llib/block_ciphers.scm 957 */
BGl_errorz00zz__errorz00(BGl_string3232z00zz__cryptozd2blockzd2ciphersz00, BGl_string3233z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_394); } 
return 
((BgL_blockzd2cipherzd2_bglt)
CDR(
((obj_t)BgL_desczd2pzd2_1488)));} } 

}



/* &block-cipher-description */
BgL_blockzd2cipherzd2_bglt BGl_z62blockzd2cipherzd2descriptionz62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4487, obj_t BgL_lookupzd2namezd2_4488)
{
{ /* Llib/block_ciphers.scm 955 */
{ /* Llib/block_ciphers.scm 956 */
obj_t BgL_auxz00_9767;
if(
SYMBOLP(BgL_lookupzd2namezd2_4488))
{ /* Llib/block_ciphers.scm 956 */
BgL_auxz00_9767 = BgL_lookupzd2namezd2_4488
; }  else 
{ 
obj_t BgL_auxz00_9770;
BgL_auxz00_9770 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)34702)), BGl_string3234z00zz__cryptozd2blockzd2ciphersz00, BGl_string3203z00zz__cryptozd2blockzd2ciphersz00, BgL_lookupzd2namezd2_4488); 
FAILURE(BgL_auxz00_9770,BFALSE,BFALSE);} 
return 
BGl_blockzd2cipherzd2descriptionz00zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_9767);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2212z00_1492;obj_t BgL_arg2213z00_1493;
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_v1280z00_1510;
BgL_v1280z00_1510 = 
create_vector(((long)7)); 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2219z00_1511;
BgL_arg2219z00_1511 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc3236z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3235z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1280z00_1510,((long)0),BgL_arg2219z00_1511); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2224z00_1521;
BgL_arg2224z00_1521 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3238z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3237z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1280z00_1510,((long)1),BgL_arg2224z00_1521); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2229z00_1531;
BgL_arg2229z00_1531 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3240z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3239z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1280z00_1510,((long)2),BgL_arg2229z00_1531); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2234z00_1541;
BgL_arg2234z00_1541 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3242z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3241z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1280z00_1510,((long)3),BgL_arg2234z00_1541); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2239z00_1551;
BgL_arg2239z00_1551 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3244z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3243z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1280z00_1510,((long)4),BgL_arg2239z00_1551); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2244z00_1561;
BgL_arg2244z00_1561 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3246z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3245z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1280z00_1510,((long)5),BgL_arg2244z00_1561); } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_arg2249z00_1571;
BgL_arg2249z00_1571 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3248z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3247z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1280z00_1510,((long)6),BgL_arg2249z00_1571); } 
BgL_arg2212z00_1492 = BgL_v1280z00_1510; } 
{ /* Llib/block_ciphers.scm 6 */
obj_t BgL_v1281z00_1581;
BgL_v1281z00_1581 = 
create_vector(((long)0)); 
BgL_arg2213z00_1493 = BgL_v1281z00_1581; } 
BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)48)), 
CNST_TABLE_REF(((long)49)), BGl_objectz00zz__objectz00, ((long)63399), BGl_proc3251z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3250z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3249z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2212z00_1492, BgL_arg2213z00_1493); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2256z00_1587;obj_t BgL_arg2257z00_1588;
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_v1282z00_1594;
BgL_v1282z00_1594 = 
create_vector(((long)3)); 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2261z00_1595;
BgL_arg2261z00_1595 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3253z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3252z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1282z00_1594,((long)0),BgL_arg2261z00_1595); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2266z00_1605;
BgL_arg2266z00_1605 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3255z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3254z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1282z00_1594,((long)1),BgL_arg2266z00_1605); } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_arg2271z00_1615;
BgL_arg2271z00_1615 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3257z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3256z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)52))); 
VECTOR_SET(BgL_v1282z00_1594,((long)2),BgL_arg2271z00_1615); } 
BgL_arg2256z00_1587 = BgL_v1282z00_1594; } 
{ /* Llib/block_ciphers.scm 77 */
obj_t BgL_v1283z00_1625;
BgL_v1283z00_1625 = 
create_vector(((long)0)); 
BgL_arg2257z00_1588 = BgL_v1283z00_1625; } 
BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)49)), BGl_objectz00zz__objectz00, ((long)46511), BFALSE, BGl_proc3259z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3258z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2256z00_1587, BgL_arg2257z00_1588); } 
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_arg2279z00_1631;obj_t BgL_arg2280z00_1632;
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_v1284z00_1645;
BgL_v1284z00_1645 = 
create_vector(((long)0)); 
BgL_arg2279z00_1631 = BgL_v1284z00_1645; } 
{ /* Llib/block_ciphers.scm 81 */
obj_t BgL_v1285z00_1646;
BgL_v1285z00_1646 = 
create_vector(((long)0)); 
BgL_arg2280z00_1632 = BgL_v1285z00_1646; } 
BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)54)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)15877), BGl_proc3262z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3261z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3260z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2279z00_1631, BgL_arg2280z00_1632); } 
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_arg2289z00_1653;obj_t BgL_arg2290z00_1654;
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_v1286z00_1667;
BgL_v1286z00_1667 = 
create_vector(((long)0)); 
BgL_arg2289z00_1653 = BgL_v1286z00_1667; } 
{ /* Llib/block_ciphers.scm 82 */
obj_t BgL_v1287z00_1668;
BgL_v1287z00_1668 = 
create_vector(((long)0)); 
BgL_arg2290z00_1654 = BgL_v1287z00_1668; } 
BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)55)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)55855), BGl_proc3265z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3264z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3263z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2289z00_1653, BgL_arg2290z00_1654); } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2299z00_1675;obj_t BgL_arg2300z00_1676;
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_v1288z00_1691;
BgL_v1288z00_1691 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2306z00_1692;
BgL_arg2306z00_1692 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3267z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3266z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1288z00_1691,((long)0),BgL_arg2306z00_1692); } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_arg2311z00_1702;
BgL_arg2311z00_1702 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3269z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3268z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1288z00_1691,((long)1),BgL_arg2311z00_1702); } 
BgL_arg2299z00_1675 = BgL_v1288z00_1691; } 
{ /* Llib/block_ciphers.scm 83 */
obj_t BgL_v1289z00_1712;
BgL_v1289z00_1712 = 
create_vector(((long)0)); 
BgL_arg2300z00_1676 = BgL_v1289z00_1712; } 
BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)58)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)16316), BGl_proc3272z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3271z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3270z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2299z00_1675, BgL_arg2300z00_1676); } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2319z00_1719;obj_t BgL_arg2320z00_1720;
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_v1290z00_1735;
BgL_v1290z00_1735 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2326z00_1736;
BgL_arg2326z00_1736 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3274z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3273z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1290z00_1735,((long)0),BgL_arg2326z00_1736); } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_arg2331z00_1746;
BgL_arg2331z00_1746 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3276z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3275z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1290z00_1735,((long)1),BgL_arg2331z00_1746); } 
BgL_arg2319z00_1719 = BgL_v1290z00_1735; } 
{ /* Llib/block_ciphers.scm 86 */
obj_t BgL_v1291z00_1756;
BgL_v1291z00_1756 = 
create_vector(((long)0)); 
BgL_arg2320z00_1720 = BgL_v1291z00_1756; } 
BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)59)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)41938), BGl_proc3279z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3278z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3277z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2319z00_1719, BgL_arg2320z00_1720); } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2339z00_1763;obj_t BgL_arg2340z00_1764;
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_v1292z00_1779;
BgL_v1292z00_1779 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2346z00_1780;
BgL_arg2346z00_1780 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3281z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3280z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1292z00_1779,((long)0),BgL_arg2346z00_1780); } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_arg2351z00_1790;
BgL_arg2351z00_1790 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3283z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3282z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1292z00_1779,((long)1),BgL_arg2351z00_1790); } 
BgL_arg2339z00_1763 = BgL_v1292z00_1779; } 
{ /* Llib/block_ciphers.scm 89 */
obj_t BgL_v1293z00_1800;
BgL_v1293z00_1800 = 
create_vector(((long)0)); 
BgL_arg2340z00_1764 = BgL_v1293z00_1800; } 
BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)60)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)34988), BGl_proc3286z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3285z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3284z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2339z00_1763, BgL_arg2340z00_1764); } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2359z00_1807;obj_t BgL_arg2360z00_1808;
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_v1294z00_1823;
BgL_v1294z00_1823 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2366z00_1824;
BgL_arg2366z00_1824 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3288z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3287z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1294z00_1823,((long)0),BgL_arg2366z00_1824); } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_arg2371z00_1834;
BgL_arg2371z00_1834 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3290z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3289z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1294z00_1823,((long)1),BgL_arg2371z00_1834); } 
BgL_arg2359z00_1807 = BgL_v1294z00_1823; } 
{ /* Llib/block_ciphers.scm 92 */
obj_t BgL_v1295z00_1844;
BgL_v1295z00_1844 = 
create_vector(((long)0)); 
BgL_arg2360z00_1808 = BgL_v1295z00_1844; } 
BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)61)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)11458), BGl_proc3293z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3292z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3291z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2359z00_1807, BgL_arg2360z00_1808); } 
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_arg2378z00_1850;obj_t BgL_arg2379z00_1851;
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_v1296z00_1857;
BgL_v1296z00_1857 = 
create_vector(((long)0)); 
BgL_arg2378z00_1850 = BgL_v1296z00_1857; } 
{ /* Llib/block_ciphers.scm 96 */
obj_t BgL_v1297z00_1858;
BgL_v1297z00_1858 = 
create_vector(((long)0)); 
BgL_arg2379z00_1851 = BgL_v1297z00_1858; } 
BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)62)), 
CNST_TABLE_REF(((long)49)), BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, ((long)43473), BFALSE, BGl_proc3295z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3294z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2378z00_1850, BgL_arg2379z00_1851); } 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_arg2386z00_1864;obj_t BgL_arg2387z00_1865;
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_v1298z00_1879;
BgL_v1298z00_1879 = 
create_vector(((long)1)); 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_arg2393z00_1880;
BgL_arg2393z00_1880 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3297z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3296z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1298z00_1879,((long)0),BgL_arg2393z00_1880); } 
BgL_arg2386z00_1864 = BgL_v1298z00_1879; } 
{ /* Llib/block_ciphers.scm 97 */
obj_t BgL_v1299z00_1890;
BgL_v1299z00_1890 = 
create_vector(((long)0)); 
BgL_arg2387z00_1865 = BgL_v1299z00_1890; } 
BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)63)), 
CNST_TABLE_REF(((long)49)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)46218), BGl_proc3300z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3299z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3298z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2386z00_1864, BgL_arg2387z00_1865); } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2401z00_1897;obj_t BgL_arg2402z00_1898;
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_v1300z00_1913;
BgL_v1300z00_1913 = 
create_vector(((long)2)); 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2408z00_1914;
BgL_arg2408z00_1914 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3302z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3301z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1300z00_1913,((long)0),BgL_arg2408z00_1914); } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_arg2413z00_1924;
BgL_arg2413z00_1924 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3304z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3303z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1300z00_1913,((long)1),BgL_arg2413z00_1924); } 
BgL_arg2401z00_1897 = BgL_v1300z00_1913; } 
{ /* Llib/block_ciphers.scm 99 */
obj_t BgL_v1301z00_1934;
BgL_v1301z00_1934 = 
create_vector(((long)0)); 
BgL_arg2402z00_1898 = BgL_v1301z00_1934; } 
BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)64)), 
CNST_TABLE_REF(((long)49)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)63662), BGl_proc3307z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3306z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3305z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2401z00_1897, BgL_arg2402z00_1898); } 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_arg2421z00_1941;obj_t BgL_arg2422z00_1942;
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_v1302z00_1956;
BgL_v1302z00_1956 = 
create_vector(((long)1)); 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_arg2428z00_1957;
BgL_arg2428z00_1957 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3309z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3308z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1302z00_1956,((long)0),BgL_arg2428z00_1957); } 
BgL_arg2421z00_1941 = BgL_v1302z00_1956; } 
{ /* Llib/block_ciphers.scm 102 */
obj_t BgL_v1303z00_1967;
BgL_v1303z00_1967 = 
create_vector(((long)0)); 
BgL_arg2422z00_1942 = BgL_v1303z00_1967; } 
BGl_OFBz00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)65)), 
CNST_TABLE_REF(((long)49)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)15584), BGl_proc3312z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3311z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3310z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2421z00_1941, BgL_arg2422z00_1942); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2436z00_1974;obj_t BgL_arg2437z00_1975;
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_v1304z00_1993;
BgL_v1304z00_1993 = 
create_vector(((long)5)); 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2443z00_1994;
BgL_arg2443z00_1994 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3314z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3313z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)52))); 
VECTOR_SET(BgL_v1304z00_1993,((long)0),BgL_arg2443z00_1994); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2448z00_2004;
BgL_arg2448z00_2004 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3316z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3315z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1304z00_1993,((long)1),BgL_arg2448z00_2004); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2453z00_2014;
BgL_arg2453z00_2014 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc3318z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3317z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1304z00_1993,((long)2),BgL_arg2453z00_2014); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2458z00_2024;
BgL_arg2458z00_2024 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3320z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3319z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1304z00_1993,((long)3),BgL_arg2458z00_2024); } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_arg2463z00_2034;
BgL_arg2463z00_2034 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3322z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3321z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)44))); 
VECTOR_SET(BgL_v1304z00_1993,((long)4),BgL_arg2463z00_2034); } 
BgL_arg2436z00_1974 = BgL_v1304z00_1993; } 
{ /* Llib/block_ciphers.scm 104 */
obj_t BgL_v1305z00_2044;
BgL_v1305z00_2044 = 
create_vector(((long)0)); 
BgL_arg2437z00_1975 = BgL_v1305z00_2044; } 
BGl_CTRz00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)71)), 
CNST_TABLE_REF(((long)49)), BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00, ((long)15240), BGl_proc3325z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3324z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3323z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2436z00_1974, BgL_arg2437z00_1975); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2471z00_2051;obj_t BgL_arg2472z00_2052;
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_v1306z00_2070;
BgL_v1306z00_2070 = 
create_vector(((long)8)); 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2478z00_2071;
BgL_arg2478z00_2071 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3327z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3326z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)73))); 
VECTOR_SET(BgL_v1306z00_2070,((long)0),BgL_arg2478z00_2071); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2483z00_2081;
BgL_arg2483z00_2081 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3329z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3328z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1306z00_2070,((long)1),BgL_arg2483z00_2081); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2488z00_2091;
BgL_arg2488z00_2091 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)74)), BGl_proc3331z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3330z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00); 
VECTOR_SET(BgL_v1306z00_2070,((long)2),BgL_arg2488z00_2091); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2493z00_2101;
BgL_arg2493z00_2101 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)75)), BGl_proc3334z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3333z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3332z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)76))); 
VECTOR_SET(BgL_v1306z00_2070,((long)3),BgL_arg2493z00_2101); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2500z00_2114;
BgL_arg2500z00_2114 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)77)), BGl_proc3337z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3336z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3335z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)52))); 
VECTOR_SET(BgL_v1306z00_2070,((long)4),BgL_arg2500z00_2114); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2507z00_2127;
BgL_arg2507z00_2127 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)78)), BGl_proc3339z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3338z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)52))); 
VECTOR_SET(BgL_v1306z00_2070,((long)5),BgL_arg2507z00_2127); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2512z00_2137;
BgL_arg2512z00_2137 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)79)), BGl_proc3341z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3340z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)39))); 
VECTOR_SET(BgL_v1306z00_2070,((long)6),BgL_arg2512z00_2137); } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_arg2517z00_2147;
BgL_arg2517z00_2147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)80)), BGl_proc3344z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3343z00zz__cryptozd2blockzd2ciphersz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3342z00zz__cryptozd2blockzd2ciphersz00, 
CNST_TABLE_REF(((long)41))); 
VECTOR_SET(BgL_v1306z00_2070,((long)7),BgL_arg2517z00_2147); } 
BgL_arg2471z00_2051 = BgL_v1306z00_2070; } 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_v1307z00_2160;
BgL_v1307z00_2160 = 
create_vector(((long)0)); 
BgL_arg2472z00_2052 = BgL_v1307z00_2160; } 
return ( 
BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)81)), 
CNST_TABLE_REF(((long)49)), BGl_objectz00zz__objectz00, ((long)41267), BGl_proc3347z00zz__cryptozd2blockzd2ciphersz00, BGl_proc3346z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BGl_proc3345z00zz__cryptozd2blockzd2ciphersz00, BFALSE, BgL_arg2471z00_2051, BgL_arg2472z00_2052), BUNSPEC) ;} } 

}



/* &<@anonymous:2477> */
obj_t BGl_z62zc3z04anonymousza32477ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4605, obj_t BgL_new1150z00_4606)
{
{ /* Llib/block_ciphers.scm 111 */
{ 
BgL_cipherzd2modezd2statez00_bglt BgL_auxz00_9984;
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_encryptzf3zf3)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
{ 
BgL_cipherzd2statezd2_bglt BgL_auxz00_9989;
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL_classz00_5624;
BgL_classz00_5624 = BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00; 
{ /* Llib/block_ciphers.scm 111 */
obj_t BgL__ortest_1111z00_5625;
BgL__ortest_1111z00_5625 = 
BGL_CLASS_NIL(BgL_classz00_5624); 
if(
CBOOL(BgL__ortest_1111z00_5625))
{ /* Llib/block_ciphers.scm 111 */
BgL_auxz00_9989 = 
((BgL_cipherzd2statezd2_bglt)BgL__ortest_1111z00_5625)
; }  else 
{ /* Llib/block_ciphers.scm 111 */
BgL_auxz00_9989 = 
((BgL_cipherzd2statezd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_5624))
; } } } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)BgL_auxz00_9989),BUNSPEC); } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_ivzd2actionzd2)=((obj_t)
CNST_TABLE_REF(((long)82))),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_ivz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_padzf2unpadzf2)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_loopzd2bufferzd2)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606)))->BgL_posz00)=((long)((long)0)),BUNSPEC); 
BgL_auxz00_9984 = 
((BgL_cipherzd2modezd2statez00_bglt)BgL_new1150z00_4606); 
return 
((obj_t)BgL_auxz00_9984);} } 

}



/* &lambda2475 */
BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2475z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4607)
{
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1149z00_5626;
BgL_new1149z00_5626 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 111 */
long BgL_arg2476z00_5627;
BgL_arg2476z00_5627 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1149z00_5626), BgL_arg2476z00_5627); } 
{ /* Llib/block_ciphers.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_10015;
BgL_tmpz00_10015 = 
((BgL_objectz00_bglt)BgL_new1149z00_5626); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10015, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1149z00_5626); 
return BgL_new1149z00_5626;} } 

}



/* &lambda2473 */
BgL_cipherzd2modezd2statez00_bglt BGl_z62lambda2473z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4608, obj_t BgL_encryptzf31141zf3_4609, obj_t BgL_blockzd2siza7e1142z75_4610, obj_t BgL_cipherzd2state1143zd2_4611, obj_t BgL_ivzd2action1144zd2_4612, obj_t BgL_iv1145z00_4613, obj_t BgL_padzf2unpad1146zf2_4614, obj_t BgL_loopzd2buffer1147zd2_4615, obj_t BgL_pos1148z00_4616)
{
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
bool_t BgL_encryptzf31141zf3_5628;long BgL_blockzd2siza7e1142z75_5629;long BgL_pos1148z00_5633;
BgL_encryptzf31141zf3_5628 = 
CBOOL(BgL_encryptzf31141zf3_4609); 
BgL_blockzd2siza7e1142z75_5629 = 
(long)CINT(BgL_blockzd2siza7e1142z75_4610); 
BgL_pos1148z00_5633 = 
(long)CINT(BgL_pos1148z00_4616); 
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1267z00_5634;
{ /* Llib/block_ciphers.scm 111 */
BgL_cipherzd2modezd2statez00_bglt BgL_new1266z00_5635;
BgL_new1266z00_5635 = 
((BgL_cipherzd2modezd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2modezd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 111 */
long BgL_arg2474z00_5636;
BgL_arg2474z00_5636 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Modezd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1266z00_5635), BgL_arg2474z00_5636); } 
{ /* Llib/block_ciphers.scm 111 */
BgL_objectz00_bglt BgL_tmpz00_10026;
BgL_tmpz00_10026 = 
((BgL_objectz00_bglt)BgL_new1266z00_5635); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10026, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1266z00_5635); 
BgL_new1267z00_5634 = BgL_new1266z00_5635; } 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_encryptzf3zf3)=((bool_t)BgL_encryptzf31141zf3_5628),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1142z75_5629),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_cipherzd2state1143zd2_4611)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_ivzd2actionzd2)=((obj_t)
((obj_t)BgL_ivzd2action1144zd2_4612)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_ivz00)=((obj_t)BgL_iv1145z00_4613),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_padzf2unpadzf2)=((obj_t)BgL_padzf2unpad1146zf2_4614),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_loopzd2bufferzd2)=((obj_t)
((obj_t)BgL_loopzd2buffer1147zd2_4615)),BUNSPEC); 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(BgL_new1267z00_5634))->BgL_posz00)=((long)BgL_pos1148z00_5633),BUNSPEC); 
return BgL_new1267z00_5634;} } } 

}



/* &<@anonymous:2523> */
obj_t BGl_z62zc3z04anonymousza32523ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4617)
{
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(((long)0));} 

}



/* &lambda2522 */
obj_t BGl_z62lambda2522z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4618, obj_t BgL_oz00_4619, obj_t BgL_vz00_4620)
{
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
long BgL_vz00_5638;
BgL_vz00_5638 = 
(long)CINT(BgL_vz00_4620); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4619)))->BgL_posz00)=((long)BgL_vz00_5638),BUNSPEC);} } 

}



/* &lambda2521 */
obj_t BGl_z62lambda2521z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4621, obj_t BgL_oz00_4622)
{
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4622)))->BgL_posz00));} 

}



/* &lambda2516 */
obj_t BGl_z62lambda2516z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4623, obj_t BgL_oz00_4624, obj_t BgL_vz00_4625)
{
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4624)))->BgL_loopzd2bufferzd2)=((obj_t)
((obj_t)BgL_vz00_4625)),BUNSPEC);} 

}



/* &lambda2515 */
obj_t BGl_z62lambda2515z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4626, obj_t BgL_oz00_4627)
{
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4627)))->BgL_loopzd2bufferzd2);} 

}



/* &lambda2511 */
obj_t BGl_z62lambda2511z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4628, obj_t BgL_oz00_4629, obj_t BgL_vz00_4630)
{
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4629)))->BgL_padzf2unpadzf2)=((obj_t)BgL_vz00_4630),BUNSPEC);} 

}



/* &lambda2510 */
obj_t BGl_z62lambda2510z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4631, obj_t BgL_oz00_4632)
{
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4632)))->BgL_padzf2unpadzf2);} 

}



/* &<@anonymous:2506> */
obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4633)
{
{ /* Llib/block_ciphers.scm 111 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2505 */
obj_t BGl_z62lambda2505z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4634, obj_t BgL_oz00_4635, obj_t BgL_vz00_4636)
{
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4635)))->BgL_ivz00)=((obj_t)BgL_vz00_4636),BUNSPEC);} 

}



/* &lambda2504 */
obj_t BGl_z62lambda2504z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4637, obj_t BgL_oz00_4638)
{
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4638)))->BgL_ivz00);} 

}



/* &<@anonymous:2499> */
obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4639)
{
{ /* Llib/block_ciphers.scm 111 */
return 
CNST_TABLE_REF(((long)83));} 

}



/* &lambda2498 */
obj_t BGl_z62lambda2498z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4640, obj_t BgL_oz00_4641, obj_t BgL_vz00_4642)
{
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4641)))->BgL_ivzd2actionzd2)=((obj_t)
((obj_t)BgL_vz00_4642)),BUNSPEC);} 

}



/* &lambda2497 */
obj_t BGl_z62lambda2497z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4643, obj_t BgL_oz00_4644)
{
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4644)))->BgL_ivzd2actionzd2);} 

}



/* &lambda2492 */
obj_t BGl_z62lambda2492z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4645, obj_t BgL_oz00_4646, obj_t BgL_vz00_4647)
{
{ /* Llib/block_ciphers.scm 111 */
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4646)))->BgL_cipherzd2statezd2)=((BgL_cipherzd2statezd2_bglt)
((BgL_cipherzd2statezd2_bglt)BgL_vz00_4647)),BUNSPEC);} 

}



/* &lambda2491 */
BgL_cipherzd2statezd2_bglt BGl_z62lambda2491z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4648, obj_t BgL_oz00_4649)
{
{ /* Llib/block_ciphers.scm 111 */
return 
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4649)))->BgL_cipherzd2statezd2);} 

}



/* &lambda2487 */
obj_t BGl_z62lambda2487z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4650, obj_t BgL_oz00_4651, obj_t BgL_vz00_4652)
{
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
long BgL_vz00_5654;
BgL_vz00_5654 = 
(long)CINT(BgL_vz00_4652); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4651)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_5654),BUNSPEC);} } 

}



/* &lambda2486 */
obj_t BGl_z62lambda2486z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4653, obj_t BgL_oz00_4654)
{
{ /* Llib/block_ciphers.scm 111 */
return 
BINT(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4654)))->BgL_blockzd2siza7ez75));} 

}



/* &lambda2482 */
obj_t BGl_z62lambda2482z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4655, obj_t BgL_oz00_4656, obj_t BgL_vz00_4657)
{
{ /* Llib/block_ciphers.scm 111 */
{ /* Llib/block_ciphers.scm 111 */
bool_t BgL_vz00_5657;
BgL_vz00_5657 = 
CBOOL(BgL_vz00_4657); 
return 
((((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4656)))->BgL_encryptzf3zf3)=((bool_t)BgL_vz00_5657),BUNSPEC);} } 

}



/* &lambda2481 */
obj_t BGl_z62lambda2481z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4658, obj_t BgL_oz00_4659)
{
{ /* Llib/block_ciphers.scm 111 */
return 
BBOOL(
(((BgL_cipherzd2modezd2statez00_bglt)COBJECT(
((BgL_cipherzd2modezd2statez00_bglt)BgL_oz00_4659)))->BgL_encryptzf3zf3));} 

}



/* &<@anonymous:2442> */
obj_t BGl_z62zc3z04anonymousza32442ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4660, obj_t BgL_new1139z00_4661)
{
{ /* Llib/block_ciphers.scm 104 */
{ 
BgL_ctrz00_bglt BgL_auxz00_10085;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1139z00_4661))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1139z00_4661))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_new1139z00_4661))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1139z00_4661)))->BgL_noncez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1139z00_4661)))->BgL_noncezd2strzd2)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1139z00_4661)))->BgL_blockzd2counterzd2)=((long)((long)0)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1139z00_4661)))->BgL_noncezd2initz12zc0)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_new1139z00_4661)))->BgL_noncezd2updatez12zc0)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_10085 = 
((BgL_ctrz00_bglt)BgL_new1139z00_4661); 
return 
((obj_t)BgL_auxz00_10085);} } 

}



/* &lambda2440 */
BgL_ctrz00_bglt BGl_z62lambda2440z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4662)
{
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1138z00_5660;
BgL_new1138z00_5660 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 104 */
long BgL_arg2441z00_5661;
BgL_arg2441z00_5661 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1138z00_5660), BgL_arg2441z00_5661); } 
{ /* Llib/block_ciphers.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_10111;
BgL_tmpz00_10111 = 
((BgL_objectz00_bglt)BgL_new1138z00_5660); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10111, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1138z00_5660); 
return BgL_new1138z00_5660;} } 

}



/* &lambda2438 */
BgL_ctrz00_bglt BGl_z62lambda2438z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4663, obj_t BgL_blockzd2siza7e1130z75_4664, obj_t BgL_cipher1131z00_4665, obj_t BgL_param1132z00_4666, obj_t BgL_nonce1133z00_4667, obj_t BgL_noncezd2str1134zd2_4668, obj_t BgL_blockzd2counter1135zd2_4669, obj_t BgL_noncezd2initz121136zc0_4670, obj_t BgL_noncezd2updatez121137zc0_4671)
{
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
long BgL_blockzd2siza7e1130z75_5662;long BgL_blockzd2counter1135zd2_5665;
BgL_blockzd2siza7e1130z75_5662 = 
(long)CINT(BgL_blockzd2siza7e1130z75_4664); 
BgL_blockzd2counter1135zd2_5665 = 
(long)CINT(BgL_blockzd2counter1135zd2_4669); 
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1265z00_5668;
{ /* Llib/block_ciphers.scm 104 */
BgL_ctrz00_bglt BgL_new1264z00_5669;
BgL_new1264z00_5669 = 
((BgL_ctrz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ctrz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 104 */
long BgL_arg2439z00_5670;
BgL_arg2439z00_5670 = 
BGL_CLASS_INDEX(BGl_CTRz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1264z00_5669), BgL_arg2439z00_5670); } 
{ /* Llib/block_ciphers.scm 104 */
BgL_objectz00_bglt BgL_tmpz00_10121;
BgL_tmpz00_10121 = 
((BgL_objectz00_bglt)BgL_new1264z00_5669); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10121, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1264z00_5669); 
BgL_new1265z00_5668 = BgL_new1264z00_5669; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1265z00_5668)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1130z75_5662),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1265z00_5668)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1131z00_4665)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1265z00_5668)))->BgL_paramz00)=((obj_t)BgL_param1132z00_4666),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1265z00_5668))->BgL_noncez00)=((obj_t)BgL_nonce1133z00_4667),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1265z00_5668))->BgL_noncezd2strzd2)=((obj_t)
((obj_t)BgL_noncezd2str1134zd2_4668)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1265z00_5668))->BgL_blockzd2counterzd2)=((long)BgL_blockzd2counter1135zd2_5665),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1265z00_5668))->BgL_noncezd2initz12zc0)=((obj_t)
((obj_t)BgL_noncezd2initz121136zc0_4670)),BUNSPEC); 
((((BgL_ctrz00_bglt)COBJECT(BgL_new1265z00_5668))->BgL_noncezd2updatez12zc0)=((obj_t)
((obj_t)BgL_noncezd2updatez121137zc0_4671)),BUNSPEC); 
return BgL_new1265z00_5668;} } } 

}



/* &lambda2467 */
obj_t BGl_z62lambda2467z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4672, obj_t BgL_oz00_4673, obj_t BgL_vz00_4674)
{
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4673)))->BgL_noncezd2updatez12zc0)=((obj_t)
((obj_t)BgL_vz00_4674)),BUNSPEC);} 

}



/* &lambda2466 */
obj_t BGl_z62lambda2466z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4675, obj_t BgL_oz00_4676)
{
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4676)))->BgL_noncezd2updatez12zc0);} 

}



/* &lambda2462 */
obj_t BGl_z62lambda2462z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4677, obj_t BgL_oz00_4678, obj_t BgL_vz00_4679)
{
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4678)))->BgL_noncezd2initz12zc0)=((obj_t)
((obj_t)BgL_vz00_4679)),BUNSPEC);} 

}



/* &lambda2461 */
obj_t BGl_z62lambda2461z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4680, obj_t BgL_oz00_4681)
{
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4681)))->BgL_noncezd2initz12zc0);} 

}



/* &lambda2457 */
obj_t BGl_z62lambda2457z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4682, obj_t BgL_oz00_4683, obj_t BgL_vz00_4684)
{
{ /* Llib/block_ciphers.scm 104 */
{ /* Llib/block_ciphers.scm 104 */
long BgL_vz00_5678;
BgL_vz00_5678 = 
(long)CINT(BgL_vz00_4684); 
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4683)))->BgL_blockzd2counterzd2)=((long)BgL_vz00_5678),BUNSPEC);} } 

}



/* &lambda2456 */
obj_t BGl_z62lambda2456z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4685, obj_t BgL_oz00_4686)
{
{ /* Llib/block_ciphers.scm 104 */
return 
BINT(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4686)))->BgL_blockzd2counterzd2));} 

}



/* &lambda2452 */
obj_t BGl_z62lambda2452z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4687, obj_t BgL_oz00_4688, obj_t BgL_vz00_4689)
{
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4688)))->BgL_noncezd2strzd2)=((obj_t)
((obj_t)BgL_vz00_4689)),BUNSPEC);} 

}



/* &lambda2451 */
obj_t BGl_z62lambda2451z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4690, obj_t BgL_oz00_4691)
{
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4691)))->BgL_noncezd2strzd2);} 

}



/* &lambda2447 */
obj_t BGl_z62lambda2447z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4692, obj_t BgL_oz00_4693, obj_t BgL_vz00_4694)
{
{ /* Llib/block_ciphers.scm 104 */
return 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4693)))->BgL_noncez00)=((obj_t)BgL_vz00_4694),BUNSPEC);} 

}



/* &lambda2446 */
obj_t BGl_z62lambda2446z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4695, obj_t BgL_oz00_4696)
{
{ /* Llib/block_ciphers.scm 104 */
return 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_oz00_4696)))->BgL_noncez00);} 

}



/* &<@anonymous:2427> */
obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4697, obj_t BgL_new1128z00_4698)
{
{ /* Llib/block_ciphers.scm 102 */
{ 
BgL_ofbz00_bglt BgL_auxz00_10165;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1128z00_4698))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1128z00_4698))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_new1128z00_4698))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_new1128z00_4698)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10165 = 
((BgL_ofbz00_bglt)BgL_new1128z00_4698); 
return 
((obj_t)BgL_auxz00_10165);} } 

}



/* &lambda2425 */
BgL_ofbz00_bglt BGl_z62lambda2425z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4699)
{
{ /* Llib/block_ciphers.scm 102 */
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1127z00_5686;
BgL_new1127z00_5686 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 102 */
long BgL_arg2426z00_5687;
BgL_arg2426z00_5687 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_5686), BgL_arg2426z00_5687); } 
{ /* Llib/block_ciphers.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_10183;
BgL_tmpz00_10183 = 
((BgL_objectz00_bglt)BgL_new1127z00_5686); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10183, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1127z00_5686); 
return BgL_new1127z00_5686;} } 

}



/* &lambda2423 */
BgL_ofbz00_bglt BGl_z62lambda2423z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4700, obj_t BgL_blockzd2siza7e1123z75_4701, obj_t BgL_cipher1124z00_4702, obj_t BgL_param1125z00_4703, obj_t BgL_chain1126z00_4704)
{
{ /* Llib/block_ciphers.scm 102 */
{ /* Llib/block_ciphers.scm 102 */
long BgL_blockzd2siza7e1123z75_5688;
BgL_blockzd2siza7e1123z75_5688 = 
(long)CINT(BgL_blockzd2siza7e1123z75_4701); 
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1263z00_5691;
{ /* Llib/block_ciphers.scm 102 */
BgL_ofbz00_bglt BgL_new1262z00_5692;
BgL_new1262z00_5692 = 
((BgL_ofbz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ofbz00_bgl) ))); 
{ /* Llib/block_ciphers.scm 102 */
long BgL_arg2424z00_5693;
BgL_arg2424z00_5693 = 
BGL_CLASS_INDEX(BGl_OFBz00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1262z00_5692), BgL_arg2424z00_5693); } 
{ /* Llib/block_ciphers.scm 102 */
BgL_objectz00_bglt BgL_tmpz00_10192;
BgL_tmpz00_10192 = 
((BgL_objectz00_bglt)BgL_new1262z00_5692); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10192, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1262z00_5692); 
BgL_new1263z00_5691 = BgL_new1262z00_5692; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1263z00_5691)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1123z75_5688),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1263z00_5691)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1124z00_4702)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1263z00_5691)))->BgL_paramz00)=((obj_t)BgL_param1125z00_4703),BUNSPEC); 
((((BgL_ofbz00_bglt)COBJECT(BgL_new1263z00_5691))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1126z00_4704)),BUNSPEC); 
return BgL_new1263z00_5691;} } } 

}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4705, obj_t BgL_oz00_4706, obj_t BgL_vz00_4707)
{
{ /* Llib/block_ciphers.scm 102 */
return 
((((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_oz00_4706)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4707)),BUNSPEC);} 

}



/* &lambda2431 */
obj_t BGl_z62lambda2431z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4708, obj_t BgL_oz00_4709)
{
{ /* Llib/block_ciphers.scm 102 */
return 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_oz00_4709)))->BgL_chainz00);} 

}



/* &<@anonymous:2407> */
obj_t BGl_z62zc3z04anonymousza32407ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4710, obj_t BgL_new1121z00_4711)
{
{ /* Llib/block_ciphers.scm 99 */
{ 
BgL_cfbzd2decryptzd2_bglt BgL_auxz00_10210;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711)))->BgL_bufferz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10210 = 
((BgL_cfbzd2decryptzd2_bglt)BgL_new1121z00_4711); 
return 
((obj_t)BgL_auxz00_10210);} } 

}



/* &lambda2405 */
BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2405z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4712)
{
{ /* Llib/block_ciphers.scm 99 */
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1120z00_5698;
BgL_new1120z00_5698 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 99 */
long BgL_arg2406z00_5699;
BgL_arg2406z00_5699 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_5698), BgL_arg2406z00_5699); } 
{ /* Llib/block_ciphers.scm 99 */
BgL_objectz00_bglt BgL_tmpz00_10230;
BgL_tmpz00_10230 = 
((BgL_objectz00_bglt)BgL_new1120z00_5698); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10230, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1120z00_5698); 
return BgL_new1120z00_5698;} } 

}



/* &lambda2403 */
BgL_cfbzd2decryptzd2_bglt BGl_z62lambda2403z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4713, obj_t BgL_blockzd2siza7e1115z75_4714, obj_t BgL_cipher1116z00_4715, obj_t BgL_param1117z00_4716, obj_t BgL_buffer1118z00_4717, obj_t BgL_chain1119z00_4718)
{
{ /* Llib/block_ciphers.scm 99 */
{ /* Llib/block_ciphers.scm 99 */
long BgL_blockzd2siza7e1115z75_5700;
BgL_blockzd2siza7e1115z75_5700 = 
(long)CINT(BgL_blockzd2siza7e1115z75_4714); 
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1261z00_5704;
{ /* Llib/block_ciphers.scm 99 */
BgL_cfbzd2decryptzd2_bglt BgL_new1260z00_5705;
BgL_new1260z00_5705 = 
((BgL_cfbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 99 */
long BgL_arg2404z00_5706;
BgL_arg2404z00_5706 = 
BGL_CLASS_INDEX(BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1260z00_5705), BgL_arg2404z00_5706); } 
{ /* Llib/block_ciphers.scm 99 */
BgL_objectz00_bglt BgL_tmpz00_10239;
BgL_tmpz00_10239 = 
((BgL_objectz00_bglt)BgL_new1260z00_5705); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10239, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1260z00_5705); 
BgL_new1261z00_5704 = BgL_new1260z00_5705; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1261z00_5704)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1115z75_5700),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1261z00_5704)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1116z00_4715)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1261z00_5704)))->BgL_paramz00)=((obj_t)BgL_param1117z00_4716),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1261z00_5704))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1118z00_4717)),BUNSPEC); 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(BgL_new1261z00_5704))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1119z00_4718)),BUNSPEC); 
return BgL_new1261z00_5704;} } } 

}



/* &lambda2417 */
obj_t BGl_z62lambda2417z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4719, obj_t BgL_oz00_4720, obj_t BgL_vz00_4721)
{
{ /* Llib/block_ciphers.scm 99 */
return 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_4720)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4721)),BUNSPEC);} 

}



/* &lambda2416 */
obj_t BGl_z62lambda2416z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4722, obj_t BgL_oz00_4723)
{
{ /* Llib/block_ciphers.scm 99 */
return 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_4723)))->BgL_chainz00);} 

}



/* &lambda2412 */
obj_t BGl_z62lambda2412z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4724, obj_t BgL_oz00_4725, obj_t BgL_vz00_4726)
{
{ /* Llib/block_ciphers.scm 99 */
return 
((((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_4725)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_4726)),BUNSPEC);} 

}



/* &lambda2411 */
obj_t BGl_z62lambda2411z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4727, obj_t BgL_oz00_4728)
{
{ /* Llib/block_ciphers.scm 99 */
return 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_oz00_4728)))->BgL_bufferz00);} 

}



/* &<@anonymous:2392> */
obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4729, obj_t BgL_new1113z00_4730)
{
{ /* Llib/block_ciphers.scm 97 */
{ 
BgL_cfbzd2encryptzd2_bglt BgL_auxz00_10264;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1113z00_4730))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1113z00_4730))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_new1113z00_4730))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_new1113z00_4730)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10264 = 
((BgL_cfbzd2encryptzd2_bglt)BgL_new1113z00_4730); 
return 
((obj_t)BgL_auxz00_10264);} } 

}



/* &lambda2390 */
BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2390z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4731)
{
{ /* Llib/block_ciphers.scm 97 */
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1112z00_5714;
BgL_new1112z00_5714 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 97 */
long BgL_arg2391z00_5715;
BgL_arg2391z00_5715 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1112z00_5714), BgL_arg2391z00_5715); } 
{ /* Llib/block_ciphers.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_10282;
BgL_tmpz00_10282 = 
((BgL_objectz00_bglt)BgL_new1112z00_5714); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10282, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1112z00_5714); 
return BgL_new1112z00_5714;} } 

}



/* &lambda2388 */
BgL_cfbzd2encryptzd2_bglt BGl_z62lambda2388z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4732, obj_t BgL_blockzd2siza7e1108z75_4733, obj_t BgL_cipher1109z00_4734, obj_t BgL_param1110z00_4735, obj_t BgL_chain1111z00_4736)
{
{ /* Llib/block_ciphers.scm 97 */
{ /* Llib/block_ciphers.scm 97 */
long BgL_blockzd2siza7e1108z75_5716;
BgL_blockzd2siza7e1108z75_5716 = 
(long)CINT(BgL_blockzd2siza7e1108z75_4733); 
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1259z00_5719;
{ /* Llib/block_ciphers.scm 97 */
BgL_cfbzd2encryptzd2_bglt BgL_new1258z00_5720;
BgL_new1258z00_5720 = 
((BgL_cfbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cfbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 97 */
long BgL_arg2389z00_5721;
BgL_arg2389z00_5721 = 
BGL_CLASS_INDEX(BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1258z00_5720), BgL_arg2389z00_5721); } 
{ /* Llib/block_ciphers.scm 97 */
BgL_objectz00_bglt BgL_tmpz00_10291;
BgL_tmpz00_10291 = 
((BgL_objectz00_bglt)BgL_new1258z00_5720); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10291, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1258z00_5720); 
BgL_new1259z00_5719 = BgL_new1258z00_5720; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1259z00_5719)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1108z75_5716),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1259z00_5719)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1109z00_4734)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1259z00_5719)))->BgL_paramz00)=((obj_t)BgL_param1110z00_4735),BUNSPEC); 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(BgL_new1259z00_5719))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1111z00_4736)),BUNSPEC); 
return BgL_new1259z00_5719;} } } 

}



/* &lambda2397 */
obj_t BGl_z62lambda2397z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4737, obj_t BgL_oz00_4738, obj_t BgL_vz00_4739)
{
{ /* Llib/block_ciphers.scm 97 */
return 
((((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_oz00_4738)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4739)),BUNSPEC);} 

}



/* &lambda2396 */
obj_t BGl_z62lambda2396z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4740, obj_t BgL_oz00_4741)
{
{ /* Llib/block_ciphers.scm 97 */
return 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_oz00_4741)))->BgL_chainz00);} 

}



/* &<@anonymous:2382> */
obj_t BGl_z62zc3z04anonymousza32382ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4742, obj_t BgL_new1106z00_4743)
{
{ /* Llib/block_ciphers.scm 96 */
{ 
BgL_streamzd2cipherzd2statez00_bglt BgL_auxz00_10309;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1106z00_4743))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1106z00_4743))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1106z00_4743))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_10309 = 
((BgL_streamzd2cipherzd2statez00_bglt)BgL_new1106z00_4743); 
return 
((obj_t)BgL_auxz00_10309);} } 

}



/* &lambda2380 */
BgL_streamzd2cipherzd2statez00_bglt BGl_z62lambda2380z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4744)
{
{ /* Llib/block_ciphers.scm 96 */
{ /* Llib/block_ciphers.scm 96 */
BgL_streamzd2cipherzd2statez00_bglt BgL_new1105z00_5726;
BgL_new1105z00_5726 = 
((BgL_streamzd2cipherzd2statez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_streamzd2cipherzd2statez00_bgl) ))); 
{ /* Llib/block_ciphers.scm 96 */
long BgL_arg2381z00_5727;
BgL_arg2381z00_5727 = 
BGL_CLASS_INDEX(BGl_Streamzd2Cipherzd2Statez00zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1105z00_5726), BgL_arg2381z00_5727); } 
return BgL_new1105z00_5726;} } 

}



/* &<@anonymous:2365> */
obj_t BGl_z62zc3z04anonymousza32365ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4745, obj_t BgL_new1103z00_4746)
{
{ /* Llib/block_ciphers.scm 92 */
{ 
BgL_pcbczd2decryptzd2_bglt BgL_auxz00_10325;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746)))->BgL_bufferz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10325 = 
((BgL_pcbczd2decryptzd2_bglt)BgL_new1103z00_4746); 
return 
((obj_t)BgL_auxz00_10325);} } 

}



/* &lambda2363 */
BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2363z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4747)
{
{ /* Llib/block_ciphers.scm 92 */
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1102z00_5729;
BgL_new1102z00_5729 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 92 */
long BgL_arg2364z00_5730;
BgL_arg2364z00_5730 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_5729), BgL_arg2364z00_5730); } 
{ /* Llib/block_ciphers.scm 92 */
BgL_objectz00_bglt BgL_tmpz00_10345;
BgL_tmpz00_10345 = 
((BgL_objectz00_bglt)BgL_new1102z00_5729); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10345, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1102z00_5729); 
return BgL_new1102z00_5729;} } 

}



/* &lambda2361 */
BgL_pcbczd2decryptzd2_bglt BGl_z62lambda2361z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4748, obj_t BgL_blockzd2siza7e1097z75_4749, obj_t BgL_cipher1098z00_4750, obj_t BgL_param1099z00_4751, obj_t BgL_buffer1100z00_4752, obj_t BgL_chain1101z00_4753)
{
{ /* Llib/block_ciphers.scm 92 */
{ /* Llib/block_ciphers.scm 92 */
long BgL_blockzd2siza7e1097z75_5731;
BgL_blockzd2siza7e1097z75_5731 = 
(long)CINT(BgL_blockzd2siza7e1097z75_4749); 
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1257z00_5735;
{ /* Llib/block_ciphers.scm 92 */
BgL_pcbczd2decryptzd2_bglt BgL_new1256z00_5736;
BgL_new1256z00_5736 = 
((BgL_pcbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 92 */
long BgL_arg2362z00_5737;
BgL_arg2362z00_5737 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1256z00_5736), BgL_arg2362z00_5737); } 
{ /* Llib/block_ciphers.scm 92 */
BgL_objectz00_bglt BgL_tmpz00_10354;
BgL_tmpz00_10354 = 
((BgL_objectz00_bglt)BgL_new1256z00_5736); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10354, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1256z00_5736); 
BgL_new1257z00_5735 = BgL_new1256z00_5736; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1257z00_5735)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1097z75_5731),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1257z00_5735)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1098z00_4750)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1257z00_5735)))->BgL_paramz00)=((obj_t)BgL_param1099z00_4751),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1257z00_5735))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1100z00_4752)),BUNSPEC); 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(BgL_new1257z00_5735))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1101z00_4753)),BUNSPEC); 
return BgL_new1257z00_5735;} } } 

}



/* &lambda2375 */
obj_t BGl_z62lambda2375z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4754, obj_t BgL_oz00_4755, obj_t BgL_vz00_4756)
{
{ /* Llib/block_ciphers.scm 92 */
return 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_4755)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4756)),BUNSPEC);} 

}



/* &lambda2374 */
obj_t BGl_z62lambda2374z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4757, obj_t BgL_oz00_4758)
{
{ /* Llib/block_ciphers.scm 92 */
return 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_4758)))->BgL_chainz00);} 

}



/* &lambda2370 */
obj_t BGl_z62lambda2370z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4759, obj_t BgL_oz00_4760, obj_t BgL_vz00_4761)
{
{ /* Llib/block_ciphers.scm 92 */
return 
((((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_4760)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_4761)),BUNSPEC);} 

}



/* &lambda2369 */
obj_t BGl_z62lambda2369z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4762, obj_t BgL_oz00_4763)
{
{ /* Llib/block_ciphers.scm 92 */
return 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_oz00_4763)))->BgL_bufferz00);} 

}



/* &<@anonymous:2345> */
obj_t BGl_z62zc3z04anonymousza32345ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4764, obj_t BgL_new1095z00_4765)
{
{ /* Llib/block_ciphers.scm 89 */
{ 
BgL_pcbczd2encryptzd2_bglt BgL_auxz00_10379;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765)))->BgL_bufferz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10379 = 
((BgL_pcbczd2encryptzd2_bglt)BgL_new1095z00_4765); 
return 
((obj_t)BgL_auxz00_10379);} } 

}



/* &lambda2343 */
BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2343z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4766)
{
{ /* Llib/block_ciphers.scm 89 */
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1094z00_5745;
BgL_new1094z00_5745 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 89 */
long BgL_arg2344z00_5746;
BgL_arg2344z00_5746 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1094z00_5745), BgL_arg2344z00_5746); } 
{ /* Llib/block_ciphers.scm 89 */
BgL_objectz00_bglt BgL_tmpz00_10399;
BgL_tmpz00_10399 = 
((BgL_objectz00_bglt)BgL_new1094z00_5745); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10399, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1094z00_5745); 
return BgL_new1094z00_5745;} } 

}



/* &lambda2341 */
BgL_pcbczd2encryptzd2_bglt BGl_z62lambda2341z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4767, obj_t BgL_blockzd2siza7e1089z75_4768, obj_t BgL_cipher1090z00_4769, obj_t BgL_param1091z00_4770, obj_t BgL_buffer1092z00_4771, obj_t BgL_chain1093z00_4772)
{
{ /* Llib/block_ciphers.scm 89 */
{ /* Llib/block_ciphers.scm 89 */
long BgL_blockzd2siza7e1089z75_5747;
BgL_blockzd2siza7e1089z75_5747 = 
(long)CINT(BgL_blockzd2siza7e1089z75_4768); 
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1255z00_5751;
{ /* Llib/block_ciphers.scm 89 */
BgL_pcbczd2encryptzd2_bglt BgL_new1254z00_5752;
BgL_new1254z00_5752 = 
((BgL_pcbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pcbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 89 */
long BgL_arg2342z00_5753;
BgL_arg2342z00_5753 = 
BGL_CLASS_INDEX(BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1254z00_5752), BgL_arg2342z00_5753); } 
{ /* Llib/block_ciphers.scm 89 */
BgL_objectz00_bglt BgL_tmpz00_10408;
BgL_tmpz00_10408 = 
((BgL_objectz00_bglt)BgL_new1254z00_5752); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10408, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1254z00_5752); 
BgL_new1255z00_5751 = BgL_new1254z00_5752; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1255z00_5751)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1089z75_5747),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1255z00_5751)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1090z00_4769)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1255z00_5751)))->BgL_paramz00)=((obj_t)BgL_param1091z00_4770),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1255z00_5751))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1092z00_4771)),BUNSPEC); 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(BgL_new1255z00_5751))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1093z00_4772)),BUNSPEC); 
return BgL_new1255z00_5751;} } } 

}



/* &lambda2355 */
obj_t BGl_z62lambda2355z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4773, obj_t BgL_oz00_4774, obj_t BgL_vz00_4775)
{
{ /* Llib/block_ciphers.scm 89 */
return 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_4774)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4775)),BUNSPEC);} 

}



/* &lambda2354 */
obj_t BGl_z62lambda2354z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4776, obj_t BgL_oz00_4777)
{
{ /* Llib/block_ciphers.scm 89 */
return 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_4777)))->BgL_chainz00);} 

}



/* &lambda2350 */
obj_t BGl_z62lambda2350z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4778, obj_t BgL_oz00_4779, obj_t BgL_vz00_4780)
{
{ /* Llib/block_ciphers.scm 89 */
return 
((((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_4779)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_4780)),BUNSPEC);} 

}



/* &lambda2349 */
obj_t BGl_z62lambda2349z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4781, obj_t BgL_oz00_4782)
{
{ /* Llib/block_ciphers.scm 89 */
return 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_oz00_4782)))->BgL_bufferz00);} 

}



/* &<@anonymous:2325> */
obj_t BGl_z62zc3z04anonymousza32325ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4783, obj_t BgL_new1087z00_4784)
{
{ /* Llib/block_ciphers.scm 86 */
{ 
BgL_cbczd2decryptzd2_bglt BgL_auxz00_10433;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784)))->BgL_bufferz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10433 = 
((BgL_cbczd2decryptzd2_bglt)BgL_new1087z00_4784); 
return 
((obj_t)BgL_auxz00_10433);} } 

}



/* &lambda2323 */
BgL_cbczd2decryptzd2_bglt BGl_z62lambda2323z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4785)
{
{ /* Llib/block_ciphers.scm 86 */
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1086z00_5761;
BgL_new1086z00_5761 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 86 */
long BgL_arg2324z00_5762;
BgL_arg2324z00_5762 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1086z00_5761), BgL_arg2324z00_5762); } 
{ /* Llib/block_ciphers.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_10453;
BgL_tmpz00_10453 = 
((BgL_objectz00_bglt)BgL_new1086z00_5761); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10453, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1086z00_5761); 
return BgL_new1086z00_5761;} } 

}



/* &lambda2321 */
BgL_cbczd2decryptzd2_bglt BGl_z62lambda2321z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4786, obj_t BgL_blockzd2siza7e1081z75_4787, obj_t BgL_cipher1082z00_4788, obj_t BgL_param1083z00_4789, obj_t BgL_buffer1084z00_4790, obj_t BgL_chain1085z00_4791)
{
{ /* Llib/block_ciphers.scm 86 */
{ /* Llib/block_ciphers.scm 86 */
long BgL_blockzd2siza7e1081z75_5763;
BgL_blockzd2siza7e1081z75_5763 = 
(long)CINT(BgL_blockzd2siza7e1081z75_4787); 
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1253z00_5767;
{ /* Llib/block_ciphers.scm 86 */
BgL_cbczd2decryptzd2_bglt BgL_new1252z00_5768;
BgL_new1252z00_5768 = 
((BgL_cbczd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 86 */
long BgL_arg2322z00_5769;
BgL_arg2322z00_5769 = 
BGL_CLASS_INDEX(BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1252z00_5768), BgL_arg2322z00_5769); } 
{ /* Llib/block_ciphers.scm 86 */
BgL_objectz00_bglt BgL_tmpz00_10462;
BgL_tmpz00_10462 = 
((BgL_objectz00_bglt)BgL_new1252z00_5768); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10462, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1252z00_5768); 
BgL_new1253z00_5767 = BgL_new1252z00_5768; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1253z00_5767)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1081z75_5763),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1253z00_5767)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1082z00_4788)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1253z00_5767)))->BgL_paramz00)=((obj_t)BgL_param1083z00_4789),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1253z00_5767))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1084z00_4790)),BUNSPEC); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(BgL_new1253z00_5767))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1085z00_4791)),BUNSPEC); 
return BgL_new1253z00_5767;} } } 

}



/* &lambda2335 */
obj_t BGl_z62lambda2335z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4792, obj_t BgL_oz00_4793, obj_t BgL_vz00_4794)
{
{ /* Llib/block_ciphers.scm 86 */
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_4793)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4794)),BUNSPEC);} 

}



/* &lambda2334 */
obj_t BGl_z62lambda2334z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4795, obj_t BgL_oz00_4796)
{
{ /* Llib/block_ciphers.scm 86 */
return 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_4796)))->BgL_chainz00);} 

}



/* &lambda2330 */
obj_t BGl_z62lambda2330z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4797, obj_t BgL_oz00_4798, obj_t BgL_vz00_4799)
{
{ /* Llib/block_ciphers.scm 86 */
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_4798)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_4799)),BUNSPEC);} 

}



/* &lambda2329 */
obj_t BGl_z62lambda2329z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4800, obj_t BgL_oz00_4801)
{
{ /* Llib/block_ciphers.scm 86 */
return 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_oz00_4801)))->BgL_bufferz00);} 

}



/* &<@anonymous:2305> */
obj_t BGl_z62zc3z04anonymousza32305ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4802, obj_t BgL_new1079z00_4803)
{
{ /* Llib/block_ciphers.scm 83 */
{ 
BgL_cbczd2encryptzd2_bglt BgL_auxz00_10487;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803)))->BgL_bufferz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803)))->BgL_chainz00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
BgL_auxz00_10487 = 
((BgL_cbczd2encryptzd2_bglt)BgL_new1079z00_4803); 
return 
((obj_t)BgL_auxz00_10487);} } 

}



/* &lambda2303 */
BgL_cbczd2encryptzd2_bglt BGl_z62lambda2303z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4804)
{
{ /* Llib/block_ciphers.scm 83 */
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1078z00_5777;
BgL_new1078z00_5777 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 83 */
long BgL_arg2304z00_5778;
BgL_arg2304z00_5778 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_5777), BgL_arg2304z00_5778); } 
{ /* Llib/block_ciphers.scm 83 */
BgL_objectz00_bglt BgL_tmpz00_10507;
BgL_tmpz00_10507 = 
((BgL_objectz00_bglt)BgL_new1078z00_5777); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10507, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1078z00_5777); 
return BgL_new1078z00_5777;} } 

}



/* &lambda2301 */
BgL_cbczd2encryptzd2_bglt BGl_z62lambda2301z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4805, obj_t BgL_blockzd2siza7e1073z75_4806, obj_t BgL_cipher1074z00_4807, obj_t BgL_param1075z00_4808, obj_t BgL_buffer1076z00_4809, obj_t BgL_chain1077z00_4810)
{
{ /* Llib/block_ciphers.scm 83 */
{ /* Llib/block_ciphers.scm 83 */
long BgL_blockzd2siza7e1073z75_5779;
BgL_blockzd2siza7e1073z75_5779 = 
(long)CINT(BgL_blockzd2siza7e1073z75_4806); 
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1251z00_5783;
{ /* Llib/block_ciphers.scm 83 */
BgL_cbczd2encryptzd2_bglt BgL_new1250z00_5784;
BgL_new1250z00_5784 = 
((BgL_cbczd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cbczd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 83 */
long BgL_arg2302z00_5785;
BgL_arg2302z00_5785 = 
BGL_CLASS_INDEX(BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1250z00_5784), BgL_arg2302z00_5785); } 
{ /* Llib/block_ciphers.scm 83 */
BgL_objectz00_bglt BgL_tmpz00_10516;
BgL_tmpz00_10516 = 
((BgL_objectz00_bglt)BgL_new1250z00_5784); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10516, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1250z00_5784); 
BgL_new1251z00_5783 = BgL_new1250z00_5784; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1251z00_5783)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1073z75_5779),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1251z00_5783)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1074z00_4807)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1251z00_5783)))->BgL_paramz00)=((obj_t)BgL_param1075z00_4808),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1251z00_5783))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_buffer1076z00_4809)),BUNSPEC); 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(BgL_new1251z00_5783))->BgL_chainz00)=((obj_t)
((obj_t)BgL_chain1077z00_4810)),BUNSPEC); 
return BgL_new1251z00_5783;} } } 

}



/* &lambda2315 */
obj_t BGl_z62lambda2315z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4811, obj_t BgL_oz00_4812, obj_t BgL_vz00_4813)
{
{ /* Llib/block_ciphers.scm 83 */
return 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_4812)))->BgL_chainz00)=((obj_t)
((obj_t)BgL_vz00_4813)),BUNSPEC);} 

}



/* &lambda2314 */
obj_t BGl_z62lambda2314z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4814, obj_t BgL_oz00_4815)
{
{ /* Llib/block_ciphers.scm 83 */
return 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_4815)))->BgL_chainz00);} 

}



/* &lambda2310 */
obj_t BGl_z62lambda2310z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4816, obj_t BgL_oz00_4817, obj_t BgL_vz00_4818)
{
{ /* Llib/block_ciphers.scm 83 */
return 
((((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_4817)))->BgL_bufferz00)=((obj_t)
((obj_t)BgL_vz00_4818)),BUNSPEC);} 

}



/* &lambda2309 */
obj_t BGl_z62lambda2309z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4819, obj_t BgL_oz00_4820)
{
{ /* Llib/block_ciphers.scm 83 */
return 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_oz00_4820)))->BgL_bufferz00);} 

}



/* &<@anonymous:2295> */
obj_t BGl_z62zc3z04anonymousza32295ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4821, obj_t BgL_new1071z00_4822)
{
{ /* Llib/block_ciphers.scm 82 */
{ 
BgL_ecbzd2decryptzd2_bglt BgL_auxz00_10541;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1071z00_4822))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1071z00_4822))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_new1071z00_4822))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_10541 = 
((BgL_ecbzd2decryptzd2_bglt)BgL_new1071z00_4822); 
return 
((obj_t)BgL_auxz00_10541);} } 

}



/* &lambda2293 */
BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2293z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4823)
{
{ /* Llib/block_ciphers.scm 82 */
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1070z00_5793;
BgL_new1070z00_5793 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 82 */
long BgL_arg2294z00_5794;
BgL_arg2294z00_5794 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_5793), BgL_arg2294z00_5794); } 
{ /* Llib/block_ciphers.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_10557;
BgL_tmpz00_10557 = 
((BgL_objectz00_bglt)BgL_new1070z00_5793); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10557, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1070z00_5793); 
return BgL_new1070z00_5793;} } 

}



/* &lambda2291 */
BgL_ecbzd2decryptzd2_bglt BGl_z62lambda2291z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4824, obj_t BgL_blockzd2siza7e1067z75_4825, obj_t BgL_cipher1068z00_4826, obj_t BgL_param1069z00_4827)
{
{ /* Llib/block_ciphers.scm 82 */
{ /* Llib/block_ciphers.scm 82 */
long BgL_blockzd2siza7e1067z75_5795;
BgL_blockzd2siza7e1067z75_5795 = 
(long)CINT(BgL_blockzd2siza7e1067z75_4825); 
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1249z00_5797;
{ /* Llib/block_ciphers.scm 82 */
BgL_ecbzd2decryptzd2_bglt BgL_new1248z00_5798;
BgL_new1248z00_5798 = 
((BgL_ecbzd2decryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2decryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 82 */
long BgL_arg2292z00_5799;
BgL_arg2292z00_5799 = 
BGL_CLASS_INDEX(BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1248z00_5798), BgL_arg2292z00_5799); } 
{ /* Llib/block_ciphers.scm 82 */
BgL_objectz00_bglt BgL_tmpz00_10566;
BgL_tmpz00_10566 = 
((BgL_objectz00_bglt)BgL_new1248z00_5798); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10566, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1248z00_5798); 
BgL_new1249z00_5797 = BgL_new1248z00_5798; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1249z00_5797)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1067z75_5795),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1249z00_5797)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1068z00_4826)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1249z00_5797)))->BgL_paramz00)=((obj_t)BgL_param1069z00_4827),BUNSPEC); 
return BgL_new1249z00_5797;} } } 

}



/* &<@anonymous:2285> */
obj_t BGl_z62zc3z04anonymousza32285ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4828, obj_t BgL_new1065z00_4829)
{
{ /* Llib/block_ciphers.scm 81 */
{ 
BgL_ecbzd2encryptzd2_bglt BgL_auxz00_10577;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1065z00_4829))))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1065z00_4829))))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_new1065z00_4829))))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_10577 = 
((BgL_ecbzd2encryptzd2_bglt)BgL_new1065z00_4829); 
return 
((obj_t)BgL_auxz00_10577);} } 

}



/* &lambda2283 */
BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2283z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4830)
{
{ /* Llib/block_ciphers.scm 81 */
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1064z00_5801;
BgL_new1064z00_5801 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 81 */
long BgL_arg2284z00_5802;
BgL_arg2284z00_5802 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_5801), BgL_arg2284z00_5802); } 
{ /* Llib/block_ciphers.scm 81 */
BgL_objectz00_bglt BgL_tmpz00_10593;
BgL_tmpz00_10593 = 
((BgL_objectz00_bglt)BgL_new1064z00_5801); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10593, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1064z00_5801); 
return BgL_new1064z00_5801;} } 

}



/* &lambda2281 */
BgL_ecbzd2encryptzd2_bglt BGl_z62lambda2281z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4831, obj_t BgL_blockzd2siza7e1061z75_4832, obj_t BgL_cipher1062z00_4833, obj_t BgL_param1063z00_4834)
{
{ /* Llib/block_ciphers.scm 81 */
{ /* Llib/block_ciphers.scm 81 */
long BgL_blockzd2siza7e1061z75_5803;
BgL_blockzd2siza7e1061z75_5803 = 
(long)CINT(BgL_blockzd2siza7e1061z75_4832); 
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1247z00_5805;
{ /* Llib/block_ciphers.scm 81 */
BgL_ecbzd2encryptzd2_bglt BgL_new1246z00_5806;
BgL_new1246z00_5806 = 
((BgL_ecbzd2encryptzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ecbzd2encryptzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 81 */
long BgL_arg2282z00_5807;
BgL_arg2282z00_5807 = 
BGL_CLASS_INDEX(BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1246z00_5806), BgL_arg2282z00_5807); } 
{ /* Llib/block_ciphers.scm 81 */
BgL_objectz00_bglt BgL_tmpz00_10602;
BgL_tmpz00_10602 = 
((BgL_objectz00_bglt)BgL_new1246z00_5806); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10602, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1246z00_5806); 
BgL_new1247z00_5805 = BgL_new1246z00_5806; } 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1247z00_5805)))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1061z75_5803),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1247z00_5805)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_cipher1062z00_4833)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1247z00_5805)))->BgL_paramz00)=((obj_t)BgL_param1063z00_4834),BUNSPEC); 
return BgL_new1247z00_5805;} } } 

}



/* &<@anonymous:2260> */
obj_t BGl_z62zc3z04anonymousza32260ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4835, obj_t BgL_new1059z00_4836)
{
{ /* Llib/block_ciphers.scm 77 */
{ 
BgL_cipherzd2statezd2_bglt BgL_auxz00_10613;
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1059z00_4836)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1059z00_4836)))->BgL_cipherz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_new1059z00_4836)))->BgL_paramz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_10613 = 
((BgL_cipherzd2statezd2_bglt)BgL_new1059z00_4836); 
return 
((obj_t)BgL_auxz00_10613);} } 

}



/* &lambda2258 */
BgL_cipherzd2statezd2_bglt BGl_z62lambda2258z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4837)
{
{ /* Llib/block_ciphers.scm 77 */
{ /* Llib/block_ciphers.scm 77 */
BgL_cipherzd2statezd2_bglt BgL_new1058z00_5809;
BgL_new1058z00_5809 = 
((BgL_cipherzd2statezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_cipherzd2statezd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 77 */
long BgL_arg2259z00_5810;
BgL_arg2259z00_5810 = 
BGL_CLASS_INDEX(BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1058z00_5809), BgL_arg2259z00_5810); } 
return BgL_new1058z00_5809;} } 

}



/* &lambda2275 */
obj_t BGl_z62lambda2275z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4838, obj_t BgL_oz00_4839, obj_t BgL_vz00_4840)
{
{ /* Llib/block_ciphers.scm 77 */
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4839)))->BgL_paramz00)=((obj_t)BgL_vz00_4840),BUNSPEC);} 

}



/* &lambda2274 */
obj_t BGl_z62lambda2274z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4841, obj_t BgL_oz00_4842)
{
{ /* Llib/block_ciphers.scm 77 */
return 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4842)))->BgL_paramz00);} 

}



/* &lambda2270 */
obj_t BGl_z62lambda2270z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4843, obj_t BgL_oz00_4844, obj_t BgL_vz00_4845)
{
{ /* Llib/block_ciphers.scm 77 */
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4844)))->BgL_cipherz00)=((obj_t)
((obj_t)BgL_vz00_4845)),BUNSPEC);} 

}



/* &lambda2269 */
obj_t BGl_z62lambda2269z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4846, obj_t BgL_oz00_4847)
{
{ /* Llib/block_ciphers.scm 77 */
return 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4847)))->BgL_cipherz00);} 

}



/* &lambda2265 */
obj_t BGl_z62lambda2265z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4848, obj_t BgL_oz00_4849, obj_t BgL_vz00_4850)
{
{ /* Llib/block_ciphers.scm 77 */
{ /* Llib/block_ciphers.scm 77 */
long BgL_vz00_5817;
BgL_vz00_5817 = 
(long)CINT(BgL_vz00_4850); 
return 
((((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4849)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_5817),BUNSPEC);} } 

}



/* &lambda2264 */
obj_t BGl_z62lambda2264z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4851, obj_t BgL_oz00_4852)
{
{ /* Llib/block_ciphers.scm 77 */
return 
BINT(
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)BgL_oz00_4852)))->BgL_blockzd2siza7ez75));} 

}



/* &<@anonymous:2218> */
obj_t BGl_z62zc3z04anonymousza32218ze3ze5zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4853, obj_t BgL_new1056z00_4854)
{
{ /* Llib/block_ciphers.scm 6 */
{ 
BgL_blockzd2cipherzd2_bglt BgL_auxz00_10641;
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_namez00)=((obj_t)BGl_string3348z00zz__cryptozd2blockzd2ciphersz00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_blockzd2siza7ez75)=((long)((long)0)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_preferredzd2keyzd2lengthz00)=((long)((long)0)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_encryptz12z12)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_decryptz12z12)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854)))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_10641 = 
((BgL_blockzd2cipherzd2_bglt)BgL_new1056z00_4854); 
return 
((obj_t)BgL_auxz00_10641);} } 

}



/* &lambda2216 */
BgL_blockzd2cipherzd2_bglt BGl_z62lambda2216z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4855)
{
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1055z00_5820;
BgL_new1055z00_5820 = 
((BgL_blockzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_blockzd2cipherzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 6 */
long BgL_arg2217z00_5821;
BgL_arg2217z00_5821 = 
BGL_CLASS_INDEX(BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_5820), BgL_arg2217z00_5821); } 
{ /* Llib/block_ciphers.scm 6 */
BgL_objectz00_bglt BgL_tmpz00_10662;
BgL_tmpz00_10662 = 
((BgL_objectz00_bglt)BgL_new1055z00_5820); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10662, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1055z00_5820); 
return BgL_new1055z00_5820;} } 

}



/* &lambda2214 */
BgL_blockzd2cipherzd2_bglt BGl_z62lambda2214z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4856, obj_t BgL_name1048z00_4857, obj_t BgL_blockzd2siza7e1049z75_4858, obj_t BgL_preferredzd2keyzd2length1050z00_4859, obj_t BgL_encryptz121051z12_4860, obj_t BgL_decryptz121052z12_4861, obj_t BgL_keyzd2ze3encryptzd2param1053ze3_4862, obj_t BgL_keyzd2ze3decryptzd2param1054ze3_4863)
{
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_blockzd2siza7e1049z75_5823;long BgL_preferredzd2keyzd2length1050z00_5824;
BgL_blockzd2siza7e1049z75_5823 = 
(long)CINT(BgL_blockzd2siza7e1049z75_4858); 
BgL_preferredzd2keyzd2length1050z00_5824 = 
(long)CINT(BgL_preferredzd2keyzd2length1050z00_4859); 
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1245z00_5829;
{ /* Llib/block_ciphers.scm 6 */
BgL_blockzd2cipherzd2_bglt BgL_new1244z00_5830;
BgL_new1244z00_5830 = 
((BgL_blockzd2cipherzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_blockzd2cipherzd2_bgl) ))); 
{ /* Llib/block_ciphers.scm 6 */
long BgL_arg2215z00_5831;
BgL_arg2215z00_5831 = 
BGL_CLASS_INDEX(BGl_Blockzd2Cipherzd2zz__cryptozd2blockzd2ciphersz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1244z00_5830), BgL_arg2215z00_5831); } 
{ /* Llib/block_ciphers.scm 6 */
BgL_objectz00_bglt BgL_tmpz00_10672;
BgL_tmpz00_10672 = 
((BgL_objectz00_bglt)BgL_new1244z00_5830); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_10672, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1244z00_5830); 
BgL_new1245z00_5829 = BgL_new1244z00_5830; } 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1048z00_4857)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_blockzd2siza7ez75)=((long)BgL_blockzd2siza7e1049z75_5823),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_preferredzd2keyzd2lengthz00)=((long)BgL_preferredzd2keyzd2length1050z00_5824),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_encryptz12z12)=((obj_t)
((obj_t)BgL_encryptz121051z12_4860)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_decryptz12z12)=((obj_t)
((obj_t)BgL_decryptz121052z12_4861)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)
((obj_t)BgL_keyzd2ze3encryptzd2param1053ze3_4862)),BUNSPEC); 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(BgL_new1245z00_5829))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)
((obj_t)BgL_keyzd2ze3decryptzd2param1054ze3_4863)),BUNSPEC); 
return BgL_new1245z00_5829;} } } 

}



/* &lambda2253 */
obj_t BGl_z62lambda2253z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4864, obj_t BgL_oz00_4865, obj_t BgL_vz00_4866)
{
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4865)))->BgL_keyzd2ze3decryptzd2paramze3)=((obj_t)
((obj_t)BgL_vz00_4866)),BUNSPEC);} 

}



/* &lambda2252 */
obj_t BGl_z62lambda2252z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4867, obj_t BgL_oz00_4868)
{
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4868)))->BgL_keyzd2ze3decryptzd2paramze3);} 

}



/* &lambda2248 */
obj_t BGl_z62lambda2248z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4869, obj_t BgL_oz00_4870, obj_t BgL_vz00_4871)
{
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4870)))->BgL_keyzd2ze3encryptzd2paramze3)=((obj_t)
((obj_t)BgL_vz00_4871)),BUNSPEC);} 

}



/* &lambda2247 */
obj_t BGl_z62lambda2247z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4872, obj_t BgL_oz00_4873)
{
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4873)))->BgL_keyzd2ze3encryptzd2paramze3);} 

}



/* &lambda2243 */
obj_t BGl_z62lambda2243z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4874, obj_t BgL_oz00_4875, obj_t BgL_vz00_4876)
{
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4875)))->BgL_decryptz12z12)=((obj_t)
((obj_t)BgL_vz00_4876)),BUNSPEC);} 

}



/* &lambda2242 */
obj_t BGl_z62lambda2242z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4877, obj_t BgL_oz00_4878)
{
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4878)))->BgL_decryptz12z12);} 

}



/* &lambda2238 */
obj_t BGl_z62lambda2238z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4879, obj_t BgL_oz00_4880, obj_t BgL_vz00_4881)
{
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4880)))->BgL_encryptz12z12)=((obj_t)
((obj_t)BgL_vz00_4881)),BUNSPEC);} 

}



/* &lambda2237 */
obj_t BGl_z62lambda2237z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4882, obj_t BgL_oz00_4883)
{
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4883)))->BgL_encryptz12z12);} 

}



/* &lambda2233 */
obj_t BGl_z62lambda2233z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4884, obj_t BgL_oz00_4885, obj_t BgL_vz00_4886)
{
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_vz00_5845;
BgL_vz00_5845 = 
(long)CINT(BgL_vz00_4886); 
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4885)))->BgL_preferredzd2keyzd2lengthz00)=((long)BgL_vz00_5845),BUNSPEC);} } 

}



/* &lambda2232 */
obj_t BGl_z62lambda2232z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4887, obj_t BgL_oz00_4888)
{
{ /* Llib/block_ciphers.scm 6 */
return 
BINT(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4888)))->BgL_preferredzd2keyzd2lengthz00));} 

}



/* &lambda2228 */
obj_t BGl_z62lambda2228z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4889, obj_t BgL_oz00_4890, obj_t BgL_vz00_4891)
{
{ /* Llib/block_ciphers.scm 6 */
{ /* Llib/block_ciphers.scm 6 */
long BgL_vz00_5848;
BgL_vz00_5848 = 
(long)CINT(BgL_vz00_4891); 
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4890)))->BgL_blockzd2siza7ez75)=((long)BgL_vz00_5848),BUNSPEC);} } 

}



/* &lambda2227 */
obj_t BGl_z62lambda2227z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4892, obj_t BgL_oz00_4893)
{
{ /* Llib/block_ciphers.scm 6 */
return 
BINT(
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4893)))->BgL_blockzd2siza7ez75));} 

}



/* &lambda2223 */
obj_t BGl_z62lambda2223z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4894, obj_t BgL_oz00_4895, obj_t BgL_vz00_4896)
{
{ /* Llib/block_ciphers.scm 6 */
return 
((((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4895)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_4896)),BUNSPEC);} 

}



/* &lambda2222 */
obj_t BGl_z62lambda2222z62zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4897, obj_t BgL_oz00_4898)
{
{ /* Llib/block_ciphers.scm 6 */
return 
(((BgL_blockzd2cipherzd2_bglt)COBJECT(
((BgL_blockzd2cipherzd2_bglt)BgL_oz00_4898)))->BgL_namez00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_proc3349z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3350z00zz__cryptozd2blockzd2ciphersz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_proc3351z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3352z00zz__cryptozd2blockzd2ciphersz00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_proc3353z00zz__cryptozd2blockzd2ciphersz00, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00, BGl_string3354z00zz__cryptozd2blockzd2ciphersz00);} 

}



/* &do-cipher-partial-bl1312 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1312zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4902, obj_t BgL_statez00_4903, obj_t BgL_fromz00_4904, obj_t BgL_fromzd2blockzd2posz00_4905, obj_t BgL_toz00_4906, obj_t BgL_tozd2blockzd2posz00_4907, obj_t BgL_atz00_4908, obj_t BgL_lenz00_4909)
{
{ /* Llib/block_ciphers.scm 212 */
return 
BGl_errorz00zz__errorz00(BGl_string3355z00zz__cryptozd2blockzd2ciphersz00, BGl_string3356z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4903)));} 

}



/* &do-cipher-block!1310 */
obj_t BGl_z62dozd2cipherzd2blockz121310z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4910, obj_t BgL_statez00_4911, obj_t BgL_fromz00_4912, obj_t BgL_fromzd2poszd2_4913, obj_t BgL_toz00_4914, obj_t BgL_tozd2poszd2_4915)
{
{ /* Llib/block_ciphers.scm 206 */
return 
BGl_errorz00zz__errorz00(BGl_string3357z00zz__cryptozd2blockzd2ciphersz00, BGl_string3356z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4911)));} 

}



/* &do-cipher-IV-init!1308 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz121308za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4916, obj_t BgL_statez00_4917, obj_t BgL_ivz00_4918)
{
{ /* Llib/block_ciphers.scm 202 */
return 
BGl_errorz00zz__errorz00(BGl_string3358z00zz__cryptozd2blockzd2ciphersz00, BGl_string3356z00zz__cryptozd2blockzd2ciphersz00, 
((obj_t)
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4917)));} 

}



/* do-cipher-IV-init! */
obj_t BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_36, obj_t BgL_ivz00_37)
{
{ /* Llib/block_ciphers.scm 202 */
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_method1309z00_2187;
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_res2701z00_3601;
{ /* Llib/block_ciphers.scm 202 */
long BgL_objzd2classzd2numz00_3572;
BgL_objzd2classzd2numz00_3572 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_36)); 
{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_arg1765z00_3573;
BgL_arg1765z00_3573 = 
PROCEDURE_REF(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 202 */
int BgL_offsetz00_3576;
BgL_offsetz00_3576 = 
(int)(BgL_objzd2classzd2numz00_3572); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_offsetz00_3577;
BgL_offsetz00_3577 = 
(
(long)(BgL_offsetz00_3576)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_modz00_3578;
BgL_modz00_3578 = 
(BgL_offsetz00_3577 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/block_ciphers.scm 202 */
long BgL_restz00_3580;
BgL_restz00_3580 = 
(BgL_offsetz00_3577 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/block_ciphers.scm 202 */

{ /* Llib/block_ciphers.scm 202 */
obj_t BgL_bucketz00_3582;
BgL_bucketz00_3582 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3573),BgL_modz00_3578); 
BgL_res2701z00_3601 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3582),BgL_restz00_3580); } } } } } } } } 
BgL_method1309z00_2187 = BgL_res2701z00_3601; } 
return 
PROCEDURE_ENTRY(BgL_method1309z00_2187)(BgL_method1309z00_2187, 
((obj_t)BgL_statez00_36), BgL_ivz00_37, BEOA);} } 

}



/* &do-cipher-IV-init! */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4919, obj_t BgL_statez00_4920, obj_t BgL_ivz00_4921)
{
{ /* Llib/block_ciphers.scm 202 */
{ /* Llib/block_ciphers.scm 202 */
BgL_cipherzd2statezd2_bglt BgL_auxz00_10768;
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_4920, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 202 */
BgL_auxz00_10768 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4920)
; }  else 
{ 
obj_t BgL_auxz00_10772;
BgL_auxz00_10772 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7145)), BGl_string3359z00zz__cryptozd2blockzd2ciphersz00, BGl_string3360z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_4920); 
FAILURE(BgL_auxz00_10772,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2IVzd2initz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_10768, BgL_ivz00_4921);} } 

}



/* do-cipher-block! */
obj_t BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_38, obj_t BgL_fromz00_39, long BgL_fromzd2poszd2_40, obj_t BgL_toz00_41, long BgL_tozd2poszd2_42)
{
{ /* Llib/block_ciphers.scm 206 */
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_method1311z00_2188;
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_res2706z00_3632;
{ /* Llib/block_ciphers.scm 206 */
long BgL_objzd2classzd2numz00_3603;
BgL_objzd2classzd2numz00_3603 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_38)); 
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_arg1765z00_3604;
BgL_arg1765z00_3604 = 
PROCEDURE_REF(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 206 */
int BgL_offsetz00_3607;
BgL_offsetz00_3607 = 
(int)(BgL_objzd2classzd2numz00_3603); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_offsetz00_3608;
BgL_offsetz00_3608 = 
(
(long)(BgL_offsetz00_3607)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_modz00_3609;
BgL_modz00_3609 = 
(BgL_offsetz00_3608 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/block_ciphers.scm 206 */
long BgL_restz00_3611;
BgL_restz00_3611 = 
(BgL_offsetz00_3608 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/block_ciphers.scm 206 */

{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_bucketz00_3613;
BgL_bucketz00_3613 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3604),BgL_modz00_3609); 
BgL_res2706z00_3632 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3613),BgL_restz00_3611); } } } } } } } } 
BgL_method1311z00_2188 = BgL_res2706z00_3632; } 
return 
PROCEDURE_ENTRY(BgL_method1311z00_2188)(BgL_method1311z00_2188, 
((obj_t)BgL_statez00_38), BgL_fromz00_39, 
BINT(BgL_fromzd2poszd2_40), BgL_toz00_41, 
BINT(BgL_tozd2poszd2_42), BEOA);} } 

}



/* &do-cipher-block! */
obj_t BGl_z62dozd2cipherzd2blockz12z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4922, obj_t BgL_statez00_4923, obj_t BgL_fromz00_4924, obj_t BgL_fromzd2poszd2_4925, obj_t BgL_toz00_4926, obj_t BgL_tozd2poszd2_4927)
{
{ /* Llib/block_ciphers.scm 206 */
{ /* Llib/block_ciphers.scm 206 */
long BgL_auxz00_10844;obj_t BgL_auxz00_10837;long BgL_auxz00_10828;obj_t BgL_auxz00_10821;BgL_cipherzd2statezd2_bglt BgL_auxz00_10813;
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_tmpz00_10845;
if(
INTEGERP(BgL_tozd2poszd2_4927))
{ /* Llib/block_ciphers.scm 206 */
BgL_tmpz00_10845 = BgL_tozd2poszd2_4927
; }  else 
{ 
obj_t BgL_auxz00_10848;
BgL_auxz00_10848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7296)), BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_tozd2poszd2_4927); 
FAILURE(BgL_auxz00_10848,BFALSE,BFALSE);} 
BgL_auxz00_10844 = 
(long)CINT(BgL_tmpz00_10845); } 
if(
STRINGP(BgL_toz00_4926))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_10837 = BgL_toz00_4926
; }  else 
{ 
obj_t BgL_auxz00_10840;
BgL_auxz00_10840 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7296)), BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_toz00_4926); 
FAILURE(BgL_auxz00_10840,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 206 */
obj_t BgL_tmpz00_10829;
if(
INTEGERP(BgL_fromzd2poszd2_4925))
{ /* Llib/block_ciphers.scm 206 */
BgL_tmpz00_10829 = BgL_fromzd2poszd2_4925
; }  else 
{ 
obj_t BgL_auxz00_10832;
BgL_auxz00_10832 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7296)), BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_fromzd2poszd2_4925); 
FAILURE(BgL_auxz00_10832,BFALSE,BFALSE);} 
BgL_auxz00_10828 = 
(long)CINT(BgL_tmpz00_10829); } 
if(
STRINGP(BgL_fromz00_4924))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_10821 = BgL_fromz00_4924
; }  else 
{ 
obj_t BgL_auxz00_10824;
BgL_auxz00_10824 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7296)), BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_fromz00_4924); 
FAILURE(BgL_auxz00_10824,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_4923, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 206 */
BgL_auxz00_10813 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4923)
; }  else 
{ 
obj_t BgL_auxz00_10817;
BgL_auxz00_10817 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7296)), BGl_string3361z00zz__cryptozd2blockzd2ciphersz00, BGl_string3360z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_4923); 
FAILURE(BgL_auxz00_10817,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2blockz12z12zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_10813, BgL_auxz00_10821, BgL_auxz00_10828, BgL_auxz00_10837, BgL_auxz00_10844);} } 

}



/* do-cipher-partial-block! */
obj_t BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_cipherzd2statezd2_bglt BgL_statez00_43, obj_t BgL_fromz00_44, long BgL_fromzd2blockzd2posz00_45, obj_t BgL_toz00_46, long BgL_tozd2blockzd2posz00_47, long BgL_atz00_48, long BgL_lenz00_49)
{
{ /* Llib/block_ciphers.scm 212 */
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_method1313z00_2189;
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_res2711z00_3663;
{ /* Llib/block_ciphers.scm 212 */
long BgL_objzd2classzd2numz00_3634;
BgL_objzd2classzd2numz00_3634 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_statez00_43)); 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_arg1765z00_3635;
BgL_arg1765z00_3635 = 
PROCEDURE_REF(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, 
(int)(((long)1))); 
{ /* Llib/block_ciphers.scm 212 */
int BgL_offsetz00_3638;
BgL_offsetz00_3638 = 
(int)(BgL_objzd2classzd2numz00_3634); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_offsetz00_3639;
BgL_offsetz00_3639 = 
(
(long)(BgL_offsetz00_3638)-OBJECT_TYPE); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_modz00_3640;
BgL_modz00_3640 = 
(BgL_offsetz00_3639 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/block_ciphers.scm 212 */
long BgL_restz00_3642;
BgL_restz00_3642 = 
(BgL_offsetz00_3639 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/block_ciphers.scm 212 */

{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_bucketz00_3644;
BgL_bucketz00_3644 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3635),BgL_modz00_3640); 
BgL_res2711z00_3663 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3644),BgL_restz00_3642); } } } } } } } } 
BgL_method1313z00_2189 = BgL_res2711z00_3663; } 
return 
PROCEDURE_ENTRY(BgL_method1313z00_2189)(BgL_method1313z00_2189, 
((obj_t)BgL_statez00_43), BgL_fromz00_44, 
BINT(BgL_fromzd2blockzd2posz00_45), BgL_toz00_46, 
BINT(BgL_tozd2blockzd2posz00_47), 
BINT(BgL_atz00_48), 
BINT(BgL_lenz00_49), BEOA);} } 

}



/* &do-cipher-partial-block! */
obj_t BGl_z62dozd2cipherzd2partialzd2blockz12za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4928, obj_t BgL_statez00_4929, obj_t BgL_fromz00_4930, obj_t BgL_fromzd2blockzd2posz00_4931, obj_t BgL_toz00_4932, obj_t BgL_tozd2blockzd2posz00_4933, obj_t BgL_atz00_4934, obj_t BgL_lenz00_4935)
{
{ /* Llib/block_ciphers.scm 212 */
{ /* Llib/block_ciphers.scm 212 */
long BgL_auxz00_10943;long BgL_auxz00_10934;long BgL_auxz00_10925;obj_t BgL_auxz00_10918;long BgL_auxz00_10909;obj_t BgL_auxz00_10902;BgL_cipherzd2statezd2_bglt BgL_auxz00_10894;
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_10944;
if(
INTEGERP(BgL_lenz00_4935))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_10944 = BgL_lenz00_4935
; }  else 
{ 
obj_t BgL_auxz00_10947;
BgL_auxz00_10947 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_lenz00_4935); 
FAILURE(BgL_auxz00_10947,BFALSE,BFALSE);} 
BgL_auxz00_10943 = 
(long)CINT(BgL_tmpz00_10944); } 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_10935;
if(
INTEGERP(BgL_atz00_4934))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_10935 = BgL_atz00_4934
; }  else 
{ 
obj_t BgL_auxz00_10938;
BgL_auxz00_10938 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_atz00_4934); 
FAILURE(BgL_auxz00_10938,BFALSE,BFALSE);} 
BgL_auxz00_10934 = 
(long)CINT(BgL_tmpz00_10935); } 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_10926;
if(
INTEGERP(BgL_tozd2blockzd2posz00_4933))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_10926 = BgL_tozd2blockzd2posz00_4933
; }  else 
{ 
obj_t BgL_auxz00_10929;
BgL_auxz00_10929 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_tozd2blockzd2posz00_4933); 
FAILURE(BgL_auxz00_10929,BFALSE,BFALSE);} 
BgL_auxz00_10925 = 
(long)CINT(BgL_tmpz00_10926); } 
if(
STRINGP(BgL_toz00_4932))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_10918 = BgL_toz00_4932
; }  else 
{ 
obj_t BgL_auxz00_10921;
BgL_auxz00_10921 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_toz00_4932); 
FAILURE(BgL_auxz00_10921,BFALSE,BFALSE);} 
{ /* Llib/block_ciphers.scm 212 */
obj_t BgL_tmpz00_10910;
if(
INTEGERP(BgL_fromzd2blockzd2posz00_4931))
{ /* Llib/block_ciphers.scm 212 */
BgL_tmpz00_10910 = BgL_fromzd2blockzd2posz00_4931
; }  else 
{ 
obj_t BgL_auxz00_10913;
BgL_auxz00_10913 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3202z00zz__cryptozd2blockzd2ciphersz00, BgL_fromzd2blockzd2posz00_4931); 
FAILURE(BgL_auxz00_10913,BFALSE,BFALSE);} 
BgL_auxz00_10909 = 
(long)CINT(BgL_tmpz00_10910); } 
if(
STRINGP(BgL_fromz00_4930))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_10902 = BgL_fromz00_4930
; }  else 
{ 
obj_t BgL_auxz00_10905;
BgL_auxz00_10905 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3186z00zz__cryptozd2blockzd2ciphersz00, BgL_fromz00_4930); 
FAILURE(BgL_auxz00_10905,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_statez00_4929, BGl_Cipherzd2Statezd2zz__cryptozd2blockzd2ciphersz00))
{ /* Llib/block_ciphers.scm 212 */
BgL_auxz00_10894 = 
((BgL_cipherzd2statezd2_bglt)BgL_statez00_4929)
; }  else 
{ 
obj_t BgL_auxz00_10898;
BgL_auxz00_10898 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3184z00zz__cryptozd2blockzd2ciphersz00, 
BINT(((long)7510)), BGl_string3362z00zz__cryptozd2blockzd2ciphersz00, BGl_string3360z00zz__cryptozd2blockzd2ciphersz00, BgL_statez00_4929); 
FAILURE(BgL_auxz00_10898,BFALSE,BFALSE);} 
return 
BGl_dozd2cipherzd2partialzd2blockz12zc0zz__cryptozd2blockzd2ciphersz00(BgL_auxz00_10894, BgL_auxz00_10902, BgL_auxz00_10909, BgL_auxz00_10918, BgL_auxz00_10925, BgL_auxz00_10934, BgL_auxz00_10943);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_ECBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3363z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_ECBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3365z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3366z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3368z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3369z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3370z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3371z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3372z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3373z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_PCBCzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3374z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3375z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3376z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Encryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3377z00zz__cryptozd2blockzd2ciphersz00, BGl_string3378z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3379z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3380z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CFBzd2Decryptzd2zz__cryptozd2blockzd2ciphersz00, BGl_proc3381z00zz__cryptozd2blockzd2ciphersz00, BGl_string3378z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3382z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3383z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_OFBz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3384z00zz__cryptozd2blockzd2ciphersz00, BGl_string3378z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2IVzd2initz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3385z00zz__cryptozd2blockzd2ciphersz00, BGl_string3367z00zz__cryptozd2blockzd2ciphersz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2blockz12zd2envzc0zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3386z00zz__cryptozd2blockzd2ciphersz00, BGl_string3364z00zz__cryptozd2blockzd2ciphersz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_dozd2cipherzd2partialzd2blockz12zd2envz12zz__cryptozd2blockzd2ciphersz00, BGl_CTRz00zz__cryptozd2blockzd2ciphersz00, BGl_proc3387z00zz__cryptozd2blockzd2ciphersz00, BGl_string3378z00zz__cryptozd2blockzd2ciphersz00);} 

}



/* &do-cipher-partial-bl1357 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1357zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4958, obj_t BgL_statez00_4959, obj_t BgL_fromz00_4960, obj_t BgL_fromzd2poszd2_4961, obj_t BgL_toz00_4962, obj_t BgL_tozd2poszd2_4963, obj_t BgL_atz00_4964, obj_t BgL_lenz00_4965)
{
{ /* Llib/block_ciphers.scm 417 */
{ /* Llib/block_ciphers.scm 419 */
bool_t BgL_tmpz00_10975;
if(
(
(long)CINT(BgL_atz00_4964)==((long)0)))
{ /* Llib/block_ciphers.scm 421 */
{ /* Llib/block_ciphers.scm 422 */
obj_t BgL_fun2654z00_5867;
BgL_fun2654z00_5867 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncezd2updatez12zc0); 
{ /* Llib/block_ciphers.scm 422 */
obj_t BgL_arg2651z00_5868;obj_t BgL_arg2652z00_5869;long BgL_arg2653z00_5870;
BgL_arg2651z00_5868 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncezd2strzd2); 
BgL_arg2652z00_5869 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncez00); 
BgL_arg2653z00_5870 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_blockzd2counterzd2); 
PROCEDURE_ENTRY(BgL_fun2654z00_5867)(BgL_fun2654z00_5867, BgL_arg2651z00_5868, BgL_arg2652z00_5869, 
BINT(BgL_arg2653z00_5870), BEOA); } } 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_blockzd2counterzd2)=((long)
(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_blockzd2counterzd2)+((long)1))),BUNSPEC); 
{ /* Llib/block_ciphers.scm 424 */
obj_t BgL_fun2659z00_5871;
BgL_fun2659z00_5871 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_4959))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 424 */
obj_t BgL_arg2656z00_5872;obj_t BgL_arg2657z00_5873;obj_t BgL_arg2658z00_5874;
BgL_arg2656z00_5872 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncezd2strzd2); 
BgL_arg2657z00_5873 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncezd2strzd2); 
BgL_arg2658z00_5874 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_4959))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2659z00_5871)(BgL_fun2659z00_5871, BgL_arg2656z00_5872, 
BINT(((long)0)), BgL_arg2657z00_5873, 
BINT(((long)0)), BgL_arg2658z00_5874, BEOA); } } }  else 
{ /* Llib/block_ciphers.scm 421 */BFALSE; } 
{ /* Llib/block_ciphers.scm 425 */
long BgL_arg2660z00_5875;long BgL_arg2661z00_5876;obj_t BgL_arg2662z00_5877;
BgL_arg2660z00_5875 = 
(
(long)CINT(BgL_tozd2poszd2_4963)+
(long)CINT(BgL_atz00_4964)); 
BgL_arg2661z00_5876 = 
(
(long)CINT(BgL_fromzd2poszd2_4961)+
(long)CINT(BgL_atz00_4964)); 
BgL_arg2662z00_5877 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4959)))->BgL_noncezd2strzd2); 
{ 
long BgL_iz00_5879;
BgL_iz00_5879 = ((long)0); 
BgL_loopz00_5878:
if(
(BgL_iz00_5879==
(BgL_arg2660z00_5875+
(long)CINT(BgL_lenz00_4965))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_10975 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1516z00_5880;unsigned char BgL_arg1517z00_5881;
BgL_arg1516z00_5880 = 
(BgL_arg2660z00_5875+BgL_iz00_5879); 
BgL_arg1517z00_5881 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_4960), 
(BgL_arg2661z00_5876+BgL_iz00_5879))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2662z00_5877, 
(
(long)CINT(BgL_atz00_4964)+BgL_iz00_5879)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_5882;
BgL_charz00_5882 = 
(unsigned char)(BgL_arg1517z00_5881); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11048;
BgL_tmpz00_11048 = 
((obj_t)BgL_toz00_4962); 
STRING_SET(BgL_tmpz00_11048, BgL_arg1516z00_5880, BgL_charz00_5882); } } } 
{ 
long BgL_iz00_11051;
BgL_iz00_11051 = 
(BgL_iz00_5879+((long)1)); 
BgL_iz00_5879 = BgL_iz00_11051; 
goto BgL_loopz00_5878;} } } } 
return 
BBOOL(BgL_tmpz00_10975);} } 

}



/* &do-cipher-block!-CTR1355 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CTR1355za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4966, obj_t BgL_statez00_4967, obj_t BgL_fromz00_4968, obj_t BgL_fromzd2poszd2_4969, obj_t BgL_toz00_4970, obj_t BgL_tozd2poszd2_4971)
{
{ /* Llib/block_ciphers.scm 410 */
{ /* Llib/block_ciphers.scm 413 */
obj_t BgL_fun2642z00_5884;
BgL_fun2642z00_5884 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncezd2updatez12zc0); 
{ /* Llib/block_ciphers.scm 413 */
obj_t BgL_arg2639z00_5885;obj_t BgL_arg2640z00_5886;long BgL_arg2641z00_5887;
BgL_arg2639z00_5885 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncezd2strzd2); 
BgL_arg2640z00_5886 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncez00); 
BgL_arg2641z00_5887 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_blockzd2counterzd2); 
PROCEDURE_ENTRY(BgL_fun2642z00_5884)(BgL_fun2642z00_5884, BgL_arg2639z00_5885, BgL_arg2640z00_5886, 
BINT(BgL_arg2641z00_5887), BEOA); } } 
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_blockzd2counterzd2)=((long)
(
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_blockzd2counterzd2)+((long)1))),BUNSPEC); 
{ /* Llib/block_ciphers.scm 415 */
obj_t BgL_fun2647z00_5888;
BgL_fun2647z00_5888 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_4967))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 415 */
obj_t BgL_arg2644z00_5889;obj_t BgL_arg2645z00_5890;obj_t BgL_arg2646z00_5891;
BgL_arg2644z00_5889 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncezd2strzd2); 
BgL_arg2645z00_5890 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncezd2strzd2); 
BgL_arg2646z00_5891 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_4967))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2647z00_5888)(BgL_fun2647z00_5888, BgL_arg2644z00_5889, 
BINT(((long)0)), BgL_arg2645z00_5890, 
BINT(((long)0)), BgL_arg2646z00_5891, BEOA); } } 
{ /* Llib/block_ciphers.scm 416 */
obj_t BgL_arg2648z00_5892;long BgL_arg2649z00_5893;
BgL_arg2648z00_5892 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4967)))->BgL_noncezd2strzd2); 
BgL_arg2649z00_5893 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ctrz00_bglt)BgL_statez00_4967))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_5895;
BgL_iz00_5895 = ((long)0); 
BgL_loopz00_5894:
if(
(BgL_iz00_5895==BgL_arg2649z00_5893))
{ /* Llib/block_ciphers.scm 416 */
return BgL_toz00_4970;}  else 
{ /* Llib/block_ciphers.scm 416 */
{ /* Llib/block_ciphers.scm 416 */
long BgL_arg2665z00_5896;unsigned char BgL_arg2666z00_5897;
BgL_arg2665z00_5896 = 
(
(long)CINT(BgL_tozd2poszd2_4971)+BgL_iz00_5895); 
BgL_arg2666z00_5897 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_4968), 
(
(long)CINT(BgL_fromzd2poszd2_4969)+BgL_iz00_5895))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2648z00_5892, 
(((long)0)+BgL_iz00_5895)))))))); 
{ /* Llib/block_ciphers.scm 416 */
unsigned char BgL_charz00_5898;
BgL_charz00_5898 = 
(unsigned char)(BgL_arg2666z00_5897); 
{ /* Llib/block_ciphers.scm 416 */
obj_t BgL_tmpz00_11119;
BgL_tmpz00_11119 = 
((obj_t)BgL_toz00_4970); 
STRING_SET(BgL_tmpz00_11119, BgL_arg2665z00_5896, BgL_charz00_5898); } } } 
{ 
long BgL_iz00_11122;
BgL_iz00_11122 = 
(BgL_iz00_5895+((long)1)); 
BgL_iz00_5895 = BgL_iz00_11122; 
goto BgL_loopz00_5894;} } } } } 

}



/* &do-cipher-IV-init!-C1353 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1353z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4972, obj_t BgL_statez00_4973, obj_t BgL_ivz00_4974)
{
{ /* Llib/block_ciphers.scm 406 */
((((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4973)))->BgL_noncez00)=((obj_t)BgL_ivz00_4974),BUNSPEC); 
{ /* Llib/block_ciphers.scm 409 */
obj_t BgL_fun2638z00_5900;
BgL_fun2638z00_5900 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4973)))->BgL_noncezd2initz12zc0); 
{ /* Llib/block_ciphers.scm 409 */
obj_t BgL_arg2636z00_5901;obj_t BgL_arg2637z00_5902;
BgL_arg2636z00_5901 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4973)))->BgL_noncezd2strzd2); 
BgL_arg2637z00_5902 = 
(((BgL_ctrz00_bglt)COBJECT(
((BgL_ctrz00_bglt)BgL_statez00_4973)))->BgL_noncez00); 
return 
PROCEDURE_ENTRY(BgL_fun2638z00_5900)(BgL_fun2638z00_5900, BgL_arg2636z00_5901, BgL_arg2637z00_5902, BEOA);} } } 

}



/* &do-cipher-partial-bl1351 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1351zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4975, obj_t BgL_statez00_4976, obj_t BgL_fromz00_4977, obj_t BgL_fromzd2poszd2_4978, obj_t BgL_toz00_4979, obj_t BgL_tozd2poszd2_4980, obj_t BgL_atz00_4981, obj_t BgL_lenz00_4982)
{
{ /* Llib/block_ciphers.scm 382 */
{ /* Llib/block_ciphers.scm 384 */
bool_t BgL_tmpz00_11137;
if(
(
(long)CINT(BgL_atz00_4981)==((long)0)))
{ /* Llib/block_ciphers.scm 386 */
obj_t BgL_fun2632z00_5904;
BgL_fun2632z00_5904 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4976))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 386 */
obj_t BgL_arg2629z00_5905;obj_t BgL_arg2630z00_5906;obj_t BgL_arg2631z00_5907;
BgL_arg2629z00_5905 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4976)))->BgL_chainz00); 
BgL_arg2630z00_5906 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4976)))->BgL_chainz00); 
BgL_arg2631z00_5907 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4976))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2632z00_5904)(BgL_fun2632z00_5904, BgL_arg2629z00_5905, 
BINT(((long)0)), BgL_arg2630z00_5906, 
BINT(((long)0)), BgL_arg2631z00_5907, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 385 */BFALSE; } 
{ /* Llib/block_ciphers.scm 387 */
long BgL_arg2633z00_5908;long BgL_arg2634z00_5909;obj_t BgL_arg2635z00_5910;
BgL_arg2633z00_5908 = 
(
(long)CINT(BgL_tozd2poszd2_4980)+
(long)CINT(BgL_atz00_4981)); 
BgL_arg2634z00_5909 = 
(
(long)CINT(BgL_fromzd2poszd2_4978)+
(long)CINT(BgL_atz00_4981)); 
BgL_arg2635z00_5910 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4976)))->BgL_chainz00); 
{ 
long BgL_iz00_5912;
BgL_iz00_5912 = ((long)0); 
BgL_loopz00_5911:
if(
(BgL_iz00_5912==
(BgL_arg2633z00_5908+
(long)CINT(BgL_lenz00_4982))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_11137 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1516z00_5913;unsigned char BgL_arg1517z00_5914;
BgL_arg1516z00_5913 = 
(BgL_arg2633z00_5908+BgL_iz00_5912); 
BgL_arg1517z00_5914 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_4977), 
(BgL_arg2634z00_5909+BgL_iz00_5912))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2635z00_5910, 
(
(long)CINT(BgL_atz00_4981)+BgL_iz00_5912)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_5915;
BgL_charz00_5915 = 
(unsigned char)(BgL_arg1517z00_5914); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11190;
BgL_tmpz00_11190 = 
((obj_t)BgL_toz00_4979); 
STRING_SET(BgL_tmpz00_11190, BgL_arg1516z00_5913, BgL_charz00_5915); } } } 
{ 
long BgL_iz00_11193;
BgL_iz00_11193 = 
(BgL_iz00_5912+((long)1)); 
BgL_iz00_5912 = BgL_iz00_11193; 
goto BgL_loopz00_5911;} } } } 
return 
BBOOL(BgL_tmpz00_11137);} } 

}



/* &do-cipher-block!-OFB1349 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2OFB1349za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4983, obj_t BgL_statez00_4984, obj_t BgL_fromz00_4985, obj_t BgL_fromzd2poszd2_4986, obj_t BgL_toz00_4987, obj_t BgL_tozd2poszd2_4988)
{
{ /* Llib/block_ciphers.scm 378 */
{ /* Llib/block_ciphers.scm 380 */
obj_t BgL_fun2625z00_5917;
BgL_fun2625z00_5917 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4984))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 380 */
obj_t BgL_arg2622z00_5918;obj_t BgL_arg2623z00_5919;obj_t BgL_arg2624z00_5920;
BgL_arg2622z00_5918 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4984)))->BgL_chainz00); 
BgL_arg2623z00_5919 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4984)))->BgL_chainz00); 
BgL_arg2624z00_5920 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4984))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2625z00_5917)(BgL_fun2625z00_5917, BgL_arg2622z00_5918, 
BINT(((long)0)), BgL_arg2623z00_5919, 
BINT(((long)0)), BgL_arg2624z00_5920, BEOA); } } 
{ /* Llib/block_ciphers.scm 381 */
obj_t BgL_arg2626z00_5921;long BgL_arg2627z00_5922;
BgL_arg2626z00_5921 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4984)))->BgL_chainz00); 
BgL_arg2627z00_5922 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4984))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_5924;
BgL_iz00_5924 = ((long)0); 
BgL_loopz00_5923:
if(
(BgL_iz00_5924==BgL_arg2627z00_5922))
{ /* Llib/block_ciphers.scm 381 */
return BgL_toz00_4987;}  else 
{ /* Llib/block_ciphers.scm 381 */
{ /* Llib/block_ciphers.scm 381 */
long BgL_arg2665z00_5925;unsigned char BgL_arg2666z00_5926;
BgL_arg2665z00_5925 = 
(
(long)CINT(BgL_tozd2poszd2_4988)+BgL_iz00_5924); 
BgL_arg2666z00_5926 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_4985), 
(
(long)CINT(BgL_fromzd2poszd2_4986)+BgL_iz00_5924))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2626z00_5921, 
(((long)0)+BgL_iz00_5924)))))))); 
{ /* Llib/block_ciphers.scm 381 */
unsigned char BgL_charz00_5927;
BgL_charz00_5927 = 
(unsigned char)(BgL_arg2666z00_5926); 
{ /* Llib/block_ciphers.scm 381 */
obj_t BgL_tmpz00_11241;
BgL_tmpz00_11241 = 
((obj_t)BgL_toz00_4987); 
STRING_SET(BgL_tmpz00_11241, BgL_arg2665z00_5925, BgL_charz00_5927); } } } 
{ 
long BgL_iz00_11244;
BgL_iz00_11244 = 
(BgL_iz00_5924+((long)1)); 
BgL_iz00_5924 = BgL_iz00_11244; 
goto BgL_loopz00_5923;} } } } } 

}



/* &do-cipher-IV-init!-O1347 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2O1347z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4989, obj_t BgL_statez00_4990, obj_t BgL_ivz00_4991)
{
{ /* Llib/block_ciphers.scm 375 */
{ /* Llib/block_ciphers.scm 377 */
obj_t BgL_arg2620z00_5929;long BgL_arg2621z00_5930;
BgL_arg2620z00_5929 = 
(((BgL_ofbz00_bglt)COBJECT(
((BgL_ofbz00_bglt)BgL_statez00_4990)))->BgL_chainz00); 
BgL_arg2621z00_5930 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ofbz00_bglt)BgL_statez00_4990))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_4991), ((long)0), BgL_arg2620z00_5929, ((long)0), BgL_arg2621z00_5930);} } 

}



/* &do-cipher-partial-bl1345 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1345zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_4992, obj_t BgL_statez00_4993, obj_t BgL_fromz00_4994, obj_t BgL_fromzd2poszd2_4995, obj_t BgL_toz00_4996, obj_t BgL_tozd2poszd2_4997, obj_t BgL_atz00_4998, obj_t BgL_lenz00_4999)
{
{ /* Llib/block_ciphers.scm 356 */
{ /* Llib/block_ciphers.scm 358 */
bool_t BgL_tmpz00_11253;
if(
(
(long)CINT(BgL_atz00_4998)==((long)0)))
{ /* Llib/block_ciphers.scm 360 */
obj_t BgL_fun2614z00_5932;
BgL_fun2614z00_5932 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 360 */
obj_t BgL_arg2611z00_5933;obj_t BgL_arg2612z00_5934;obj_t BgL_arg2613z00_5935;
BgL_arg2611z00_5933 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993)))->BgL_chainz00); 
BgL_arg2612z00_5934 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993)))->BgL_bufferz00); 
BgL_arg2613z00_5935 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2614z00_5932)(BgL_fun2614z00_5932, BgL_arg2611z00_5933, 
BINT(((long)0)), BgL_arg2612z00_5934, 
BINT(((long)0)), BgL_arg2613z00_5935, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 359 */BFALSE; } 
{ /* Llib/block_ciphers.scm 361 */
long BgL_arg2615z00_5936;obj_t BgL_arg2616z00_5937;
BgL_arg2615z00_5936 = 
(
(long)CINT(BgL_fromzd2poszd2_4995)+
(long)CINT(BgL_atz00_4998)); 
BgL_arg2616z00_5937 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993)))->BgL_chainz00); 
{ /* Llib/block_ciphers.scm 361 */
long BgL_o2z00_5938;long BgL_lz00_5939;
BgL_o2z00_5938 = 
(long)CINT(BgL_atz00_4998); 
BgL_lz00_5939 = 
(long)CINT(BgL_lenz00_4999); 
blit_string(
((obj_t)BgL_fromz00_4994), BgL_arg2615z00_5936, BgL_arg2616z00_5937, BgL_o2z00_5938, BgL_lz00_5939); } } 
{ /* Llib/block_ciphers.scm 362 */
long BgL_arg2617z00_5940;obj_t BgL_arg2618z00_5941;long BgL_arg2619z00_5942;
BgL_arg2617z00_5940 = 
(
(long)CINT(BgL_tozd2poszd2_4997)+
(long)CINT(BgL_atz00_4998)); 
BgL_arg2618z00_5941 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_4993)))->BgL_bufferz00); 
BgL_arg2619z00_5942 = 
(
(long)CINT(BgL_fromzd2poszd2_4995)+
(long)CINT(BgL_atz00_4998)); 
{ 
long BgL_iz00_5944;
BgL_iz00_5944 = ((long)0); 
BgL_loopz00_5943:
if(
(BgL_iz00_5944==
(BgL_arg2617z00_5940+
(long)CINT(BgL_lenz00_4999))))
{ /* Llib/block_ciphers.scm 128 */
BgL_tmpz00_11253 = ((bool_t)0)
; }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1516z00_5945;unsigned char BgL_arg1517z00_5946;
BgL_arg1516z00_5945 = 
(BgL_arg2617z00_5940+BgL_iz00_5944); 
BgL_arg1517z00_5946 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2618z00_5941, 
(((long)0)+BgL_iz00_5944))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_4994), 
(BgL_arg2619z00_5942+BgL_iz00_5944)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_charz00_5947;
BgL_charz00_5947 = 
(unsigned char)(BgL_arg1517z00_5946); 
{ /* Llib/block_ciphers.scm 129 */
obj_t BgL_tmpz00_11314;
BgL_tmpz00_11314 = 
((obj_t)BgL_toz00_4996); 
STRING_SET(BgL_tmpz00_11314, BgL_arg1516z00_5945, BgL_charz00_5947); } } } 
{ 
long BgL_iz00_11317;
BgL_iz00_11317 = 
(BgL_iz00_5944+((long)1)); 
BgL_iz00_5944 = BgL_iz00_11317; 
goto BgL_loopz00_5943;} } } } 
return 
BBOOL(BgL_tmpz00_11253);} } 

}



/* &do-cipher-block!-CFB1343 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1343za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5000, obj_t BgL_statez00_5001, obj_t BgL_fromz00_5002, obj_t BgL_fromzd2poszd2_5003, obj_t BgL_toz00_5004, obj_t BgL_tozd2poszd2_5005)
{
{ /* Llib/block_ciphers.scm 351 */
{ /* Llib/block_ciphers.scm 353 */
obj_t BgL_fun2605z00_5949;
BgL_fun2605z00_5949 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 353 */
obj_t BgL_arg2602z00_5950;obj_t BgL_arg2603z00_5951;obj_t BgL_arg2604z00_5952;
BgL_arg2602z00_5950 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001)))->BgL_chainz00); 
BgL_arg2603z00_5951 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001)))->BgL_bufferz00); 
BgL_arg2604z00_5952 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2605z00_5949)(BgL_fun2605z00_5949, BgL_arg2602z00_5950, 
BINT(((long)0)), BgL_arg2603z00_5951, 
BINT(((long)0)), BgL_arg2604z00_5952, BEOA); } } 
{ /* Llib/block_ciphers.scm 354 */
obj_t BgL_arg2606z00_5953;long BgL_arg2607z00_5954;
BgL_arg2606z00_5953 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001)))->BgL_chainz00); 
BgL_arg2607z00_5954 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 354 */
long BgL_o1z00_5955;
BgL_o1z00_5955 = 
(long)CINT(BgL_fromzd2poszd2_5003); 
blit_string(
((obj_t)BgL_fromz00_5002), BgL_o1z00_5955, BgL_arg2606z00_5953, ((long)0), BgL_arg2607z00_5954); } } 
{ /* Llib/block_ciphers.scm 355 */
obj_t BgL_arg2608z00_5956;long BgL_arg2609z00_5957;
BgL_arg2608z00_5956 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001)))->BgL_bufferz00); 
BgL_arg2609z00_5957 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5001))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_5959;
BgL_iz00_5959 = ((long)0); 
BgL_loopz00_5958:
if(
(BgL_iz00_5959==BgL_arg2609z00_5957))
{ /* Llib/block_ciphers.scm 355 */
return BgL_toz00_5004;}  else 
{ /* Llib/block_ciphers.scm 355 */
{ /* Llib/block_ciphers.scm 355 */
long BgL_arg2665z00_5960;unsigned char BgL_arg2666z00_5961;
BgL_arg2665z00_5960 = 
(
(long)CINT(BgL_tozd2poszd2_5005)+BgL_iz00_5959); 
BgL_arg2666z00_5961 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2608z00_5956, 
(((long)0)+BgL_iz00_5959))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5002), 
(
(long)CINT(BgL_fromzd2poszd2_5003)+BgL_iz00_5959)))))))); 
{ /* Llib/block_ciphers.scm 355 */
unsigned char BgL_charz00_5962;
BgL_charz00_5962 = 
(unsigned char)(BgL_arg2666z00_5961); 
{ /* Llib/block_ciphers.scm 355 */
obj_t BgL_tmpz00_11373;
BgL_tmpz00_11373 = 
((obj_t)BgL_toz00_5004); 
STRING_SET(BgL_tmpz00_11373, BgL_arg2665z00_5960, BgL_charz00_5962); } } } 
{ 
long BgL_iz00_11376;
BgL_iz00_11376 = 
(BgL_iz00_5959+((long)1)); 
BgL_iz00_5959 = BgL_iz00_11376; 
goto BgL_loopz00_5958;} } } } } 

}



/* &do-cipher-IV-init!-C1341 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1341z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5006, obj_t BgL_statez00_5007, obj_t BgL_ivz00_5008)
{
{ /* Llib/block_ciphers.scm 348 */
{ /* Llib/block_ciphers.scm 350 */
obj_t BgL_arg2600z00_5964;long BgL_arg2601z00_5965;
BgL_arg2600z00_5964 = 
(((BgL_cfbzd2decryptzd2_bglt)COBJECT(
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5007)))->BgL_chainz00); 
BgL_arg2601z00_5965 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2decryptzd2_bglt)BgL_statez00_5007))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5008), ((long)0), BgL_arg2600z00_5964, ((long)0), BgL_arg2601z00_5965);} } 

}



/* &do-cipher-partial-bl1339 */
obj_t BGl_z62dozd2cipherzd2partialzd2bl1339zb0zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5009, obj_t BgL_statez00_5010, obj_t BgL_fromz00_5011, obj_t BgL_fromzd2poszd2_5012, obj_t BgL_toz00_5013, obj_t BgL_tozd2poszd2_5014, obj_t BgL_atz00_5015, obj_t BgL_lenz00_5016)
{
{ /* Llib/block_ciphers.scm 332 */
if(
(
(long)CINT(BgL_atz00_5015)==((long)0)))
{ /* Llib/block_ciphers.scm 336 */
obj_t BgL_fun2594z00_5967;
BgL_fun2594z00_5967 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 336 */
obj_t BgL_arg2591z00_5968;obj_t BgL_arg2592z00_5969;obj_t BgL_arg2593z00_5970;
BgL_arg2591z00_5968 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010)))->BgL_chainz00); 
BgL_arg2592z00_5969 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010)))->BgL_chainz00); 
BgL_arg2593z00_5970 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2594z00_5967)(BgL_fun2594z00_5967, BgL_arg2591z00_5968, 
BINT(((long)0)), BgL_arg2592z00_5969, 
BINT(((long)0)), BgL_arg2593z00_5970, BEOA); } }  else 
{ /* Llib/block_ciphers.scm 335 */BFALSE; } 
{ /* Llib/block_ciphers.scm 337 */
obj_t BgL_arg2595z00_5971;obj_t BgL_arg2596z00_5972;long BgL_arg2597z00_5973;
BgL_arg2595z00_5971 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010)))->BgL_chainz00); 
BgL_arg2596z00_5972 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010)))->BgL_chainz00); 
BgL_arg2597z00_5973 = 
(
(long)CINT(BgL_fromzd2poszd2_5012)+
(long)CINT(BgL_atz00_5015)); 
{ 
long BgL_iz00_5975;
BgL_iz00_5975 = ((long)0); 
BgL_loopz00_5974:
if(
(BgL_iz00_5975==
(
(long)CINT(BgL_atz00_5015)+
(long)CINT(BgL_lenz00_5016))))
{ /* Llib/block_ciphers.scm 128 */((bool_t)0); }  else 
{ /* Llib/block_ciphers.scm 128 */
{ /* Llib/block_ciphers.scm 129 */
long BgL_arg1516z00_5976;unsigned char BgL_arg1517z00_5977;
BgL_arg1516z00_5976 = 
(
(long)CINT(BgL_atz00_5015)+BgL_iz00_5975); 
BgL_arg1517z00_5977 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2596z00_5972, 
(
(long)CINT(BgL_atz00_5015)+BgL_iz00_5975))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5011), 
(BgL_arg2597z00_5973+BgL_iz00_5975)))))))); 
{ /* Llib/block_ciphers.scm 129 */
unsigned char BgL_tmpz00_11437;
BgL_tmpz00_11437 = 
(unsigned char)(BgL_arg1517z00_5977); 
STRING_SET(BgL_arg2595z00_5971, BgL_arg1516z00_5976, BgL_tmpz00_11437); } } 
{ 
long BgL_iz00_11440;
BgL_iz00_11440 = 
(BgL_iz00_5975+((long)1)); 
BgL_iz00_5975 = BgL_iz00_11440; 
goto BgL_loopz00_5974;} } } } 
{ /* Llib/block_ciphers.scm 338 */
obj_t BgL_arg2598z00_5978;long BgL_arg2599z00_5979;
BgL_arg2598z00_5978 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5010)))->BgL_chainz00); 
BgL_arg2599z00_5979 = 
(
(long)CINT(BgL_tozd2poszd2_5014)+
(long)CINT(BgL_atz00_5015)); 
{ /* Llib/block_ciphers.scm 338 */
long BgL_o1z00_5980;long BgL_lz00_5981;
BgL_o1z00_5980 = 
(long)CINT(BgL_atz00_5015); 
BgL_lz00_5981 = 
(long)CINT(BgL_lenz00_5016); 
return 
blit_string(BgL_arg2598z00_5978, BgL_o1z00_5980, 
((obj_t)BgL_toz00_5013), BgL_arg2599z00_5979, BgL_lz00_5981);} } } 

}



/* &do-cipher-block!-CFB1337 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CFB1337za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5017, obj_t BgL_statez00_5018, obj_t BgL_fromz00_5019, obj_t BgL_fromzd2poszd2_5020, obj_t BgL_toz00_5021, obj_t BgL_tozd2poszd2_5022)
{
{ /* Llib/block_ciphers.scm 327 */
{ /* Llib/block_ciphers.scm 329 */
obj_t BgL_fun2584z00_5983;
BgL_fun2584z00_5983 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 329 */
obj_t BgL_arg2581z00_5984;obj_t BgL_arg2582z00_5985;obj_t BgL_arg2583z00_5986;
BgL_arg2581z00_5984 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018)))->BgL_chainz00); 
BgL_arg2582z00_5985 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018)))->BgL_chainz00); 
BgL_arg2583z00_5986 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2584z00_5983)(BgL_fun2584z00_5983, BgL_arg2581z00_5984, 
BINT(((long)0)), BgL_arg2582z00_5985, 
BINT(((long)0)), BgL_arg2583z00_5986, BEOA); } } 
{ /* Llib/block_ciphers.scm 330 */
obj_t BgL_arg2585z00_5987;obj_t BgL_arg2586z00_5988;long BgL_arg2587z00_5989;
BgL_arg2585z00_5987 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018)))->BgL_chainz00); 
BgL_arg2586z00_5988 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018)))->BgL_chainz00); 
BgL_arg2587z00_5989 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_5991;
BgL_iz00_5991 = ((long)0); 
BgL_loopz00_5990:
if(
(BgL_iz00_5991==BgL_arg2587z00_5989))
{ /* Llib/block_ciphers.scm 330 */BgL_arg2585z00_5987; }  else 
{ /* Llib/block_ciphers.scm 330 */
{ /* Llib/block_ciphers.scm 330 */
long BgL_arg2665z00_5992;unsigned char BgL_arg2666z00_5993;
BgL_arg2665z00_5992 = 
(((long)0)+BgL_iz00_5991); 
BgL_arg2666z00_5993 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5019), 
(
(long)CINT(BgL_fromzd2poszd2_5020)+BgL_iz00_5991))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2586z00_5988, 
(((long)0)+BgL_iz00_5991)))))))); 
{ /* Llib/block_ciphers.scm 330 */
unsigned char BgL_tmpz00_11496;
BgL_tmpz00_11496 = 
(unsigned char)(BgL_arg2666z00_5993); 
STRING_SET(BgL_arg2585z00_5987, BgL_arg2665z00_5992, BgL_tmpz00_11496); } } 
{ 
long BgL_iz00_11499;
BgL_iz00_11499 = 
(BgL_iz00_5991+((long)1)); 
BgL_iz00_5991 = BgL_iz00_11499; 
goto BgL_loopz00_5990;} } } } 
{ /* Llib/block_ciphers.scm 331 */
obj_t BgL_arg2588z00_5994;long BgL_arg2589z00_5995;
BgL_arg2588z00_5994 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018)))->BgL_chainz00); 
BgL_arg2589z00_5995 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5018))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 331 */
long BgL_o2z00_5996;
BgL_o2z00_5996 = 
(long)CINT(BgL_tozd2poszd2_5022); 
return 
blit_string(BgL_arg2588z00_5994, ((long)0), 
((obj_t)BgL_toz00_5021), BgL_o2z00_5996, BgL_arg2589z00_5995);} } } 

}



/* &do-cipher-IV-init!-C1335 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1335z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5023, obj_t BgL_statez00_5024, obj_t BgL_ivz00_5025)
{
{ /* Llib/block_ciphers.scm 324 */
{ /* Llib/block_ciphers.scm 326 */
obj_t BgL_arg2579z00_5998;long BgL_arg2580z00_5999;
BgL_arg2579z00_5998 = 
(((BgL_cfbzd2encryptzd2_bglt)COBJECT(
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5024)))->BgL_chainz00); 
BgL_arg2580z00_5999 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cfbzd2encryptzd2_bglt)BgL_statez00_5024))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5025), ((long)0), BgL_arg2579z00_5998, ((long)0), BgL_arg2580z00_5999);} } 

}



/* &do-cipher-block!-PCB1333 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1333za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5026, obj_t BgL_statez00_5027, obj_t BgL_fromz00_5028, obj_t BgL_fromzd2poszd2_5029, obj_t BgL_toz00_5030, obj_t BgL_tozd2poszd2_5031)
{
{ /* Llib/block_ciphers.scm 308 */
{ /* Llib/block_ciphers.scm 310 */
obj_t BgL_fun2569z00_6001;
BgL_fun2569z00_6001 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 310 */
obj_t BgL_arg2567z00_6002;obj_t BgL_arg2568z00_6003;
BgL_arg2567z00_6002 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_bufferz00); 
BgL_arg2568z00_6003 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2569z00_6001)(BgL_fun2569z00_6001, BgL_fromz00_5028, BgL_fromzd2poszd2_5029, BgL_arg2567z00_6002, 
BINT(((long)0)), BgL_arg2568z00_6003, BEOA); } } 
{ /* Llib/block_ciphers.scm 311 */
obj_t BgL_arg2570z00_6004;obj_t BgL_arg2571z00_6005;obj_t BgL_arg2572z00_6006;long BgL_arg2573z00_6007;
BgL_arg2570z00_6004 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_bufferz00); 
BgL_arg2571z00_6005 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_bufferz00); 
BgL_arg2572z00_6006 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_chainz00); 
BgL_arg2573z00_6007 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6009;
BgL_iz00_6009 = ((long)0); 
BgL_loopz00_6008:
if(
(BgL_iz00_6009==BgL_arg2573z00_6007))
{ /* Llib/block_ciphers.scm 311 */BgL_arg2570z00_6004; }  else 
{ /* Llib/block_ciphers.scm 311 */
{ /* Llib/block_ciphers.scm 311 */
long BgL_arg2665z00_6010;unsigned char BgL_arg2666z00_6011;
BgL_arg2665z00_6010 = 
(((long)0)+BgL_iz00_6009); 
BgL_arg2666z00_6011 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2571z00_6005, 
(((long)0)+BgL_iz00_6009))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2572z00_6006, 
(((long)0)+BgL_iz00_6009)))))))); 
{ /* Llib/block_ciphers.scm 311 */
unsigned char BgL_tmpz00_11558;
BgL_tmpz00_11558 = 
(unsigned char)(BgL_arg2666z00_6011); 
STRING_SET(BgL_arg2570z00_6004, BgL_arg2665z00_6010, BgL_tmpz00_11558); } } 
{ 
long BgL_iz00_11561;
BgL_iz00_11561 = 
(BgL_iz00_6009+((long)1)); 
BgL_iz00_6009 = BgL_iz00_11561; 
goto BgL_loopz00_6008;} } } } 
{ /* Llib/block_ciphers.scm 312 */
obj_t BgL_arg2574z00_6012;obj_t BgL_arg2575z00_6013;long BgL_arg2576z00_6014;
BgL_arg2574z00_6012 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_chainz00); 
BgL_arg2575z00_6013 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_bufferz00); 
BgL_arg2576z00_6014 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6016;
BgL_iz00_6016 = ((long)0); 
BgL_loopz00_6015:
if(
(BgL_iz00_6016==BgL_arg2576z00_6014))
{ /* Llib/block_ciphers.scm 312 */BgL_arg2574z00_6012; }  else 
{ /* Llib/block_ciphers.scm 312 */
{ /* Llib/block_ciphers.scm 312 */
long BgL_arg2665z00_6017;unsigned char BgL_arg2666z00_6018;
BgL_arg2665z00_6017 = 
(((long)0)+BgL_iz00_6016); 
BgL_arg2666z00_6018 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5028), 
(
(long)CINT(BgL_fromzd2poszd2_5029)+BgL_iz00_6016))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2575z00_6013, 
(((long)0)+BgL_iz00_6016)))))))); 
{ /* Llib/block_ciphers.scm 312 */
unsigned char BgL_tmpz00_11588;
BgL_tmpz00_11588 = 
(unsigned char)(BgL_arg2666z00_6018); 
STRING_SET(BgL_arg2574z00_6012, BgL_arg2665z00_6017, BgL_tmpz00_11588); } } 
{ 
long BgL_iz00_11591;
BgL_iz00_11591 = 
(BgL_iz00_6016+((long)1)); 
BgL_iz00_6016 = BgL_iz00_11591; 
goto BgL_loopz00_6015;} } } } 
{ /* Llib/block_ciphers.scm 313 */
obj_t BgL_arg2577z00_6019;long BgL_arg2578z00_6020;
BgL_arg2577z00_6019 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027)))->BgL_bufferz00); 
BgL_arg2578z00_6020 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5027))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 313 */
long BgL_o2z00_6021;
BgL_o2z00_6021 = 
(long)CINT(BgL_tozd2poszd2_5031); 
return 
blit_string(BgL_arg2577z00_6019, ((long)0), 
((obj_t)BgL_toz00_5030), BgL_o2z00_6021, BgL_arg2578z00_6020);} } } 

}



/* &do-cipher-IV-init!-P1331 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1331z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5032, obj_t BgL_statez00_5033, obj_t BgL_ivz00_5034)
{
{ /* Llib/block_ciphers.scm 305 */
{ /* Llib/block_ciphers.scm 307 */
obj_t BgL_arg2565z00_6023;long BgL_arg2566z00_6024;
BgL_arg2565z00_6023 = 
(((BgL_pcbczd2decryptzd2_bglt)COBJECT(
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5033)))->BgL_chainz00); 
BgL_arg2566z00_6024 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2decryptzd2_bglt)BgL_statez00_5033))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5034), ((long)0), BgL_arg2565z00_6023, ((long)0), BgL_arg2566z00_6024);} } 

}



/* &do-cipher-block!-PCB1329 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2PCB1329za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5035, obj_t BgL_statez00_5036, obj_t BgL_fromz00_5037, obj_t BgL_fromzd2poszd2_5038, obj_t BgL_toz00_5039, obj_t BgL_tozd2poszd2_5040)
{
{ /* Llib/block_ciphers.scm 290 */
{ /* Llib/block_ciphers.scm 292 */
obj_t BgL_arg2553z00_6026;obj_t BgL_arg2554z00_6027;long BgL_arg2555z00_6028;
BgL_arg2553z00_6026 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_bufferz00); 
BgL_arg2554z00_6027 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_chainz00); 
BgL_arg2555z00_6028 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6030;
BgL_iz00_6030 = ((long)0); 
BgL_loopz00_6029:
if(
(BgL_iz00_6030==BgL_arg2555z00_6028))
{ /* Llib/block_ciphers.scm 292 */BgL_arg2553z00_6026; }  else 
{ /* Llib/block_ciphers.scm 292 */
{ /* Llib/block_ciphers.scm 292 */
long BgL_arg2665z00_6031;unsigned char BgL_arg2666z00_6032;
BgL_arg2665z00_6031 = 
(((long)0)+BgL_iz00_6030); 
BgL_arg2666z00_6032 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2554z00_6027, 
(((long)0)+BgL_iz00_6030))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5037), 
(
(long)CINT(BgL_fromzd2poszd2_5038)+BgL_iz00_6030)))))))); 
{ /* Llib/block_ciphers.scm 292 */
unsigned char BgL_tmpz00_11633;
BgL_tmpz00_11633 = 
(unsigned char)(BgL_arg2666z00_6032); 
STRING_SET(BgL_arg2553z00_6026, BgL_arg2665z00_6031, BgL_tmpz00_11633); } } 
{ 
long BgL_iz00_11636;
BgL_iz00_11636 = 
(BgL_iz00_6030+((long)1)); 
BgL_iz00_6030 = BgL_iz00_11636; 
goto BgL_loopz00_6029;} } } } 
{ /* Llib/block_ciphers.scm 293 */
obj_t BgL_fun2559z00_6033;
BgL_fun2559z00_6033 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 293 */
obj_t BgL_arg2556z00_6034;obj_t BgL_arg2557z00_6035;obj_t BgL_arg2558z00_6036;
BgL_arg2556z00_6034 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_bufferz00); 
BgL_arg2557z00_6035 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_bufferz00); 
BgL_arg2558z00_6036 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2559z00_6033)(BgL_fun2559z00_6033, BgL_arg2556z00_6034, 
BINT(((long)0)), BgL_arg2557z00_6035, 
BINT(((long)0)), BgL_arg2558z00_6036, BEOA); } } 
{ /* Llib/block_ciphers.scm 294 */
obj_t BgL_arg2560z00_6037;obj_t BgL_arg2561z00_6038;long BgL_arg2562z00_6039;
BgL_arg2560z00_6037 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_chainz00); 
BgL_arg2561z00_6038 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_bufferz00); 
BgL_arg2562z00_6039 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6041;
BgL_iz00_6041 = ((long)0); 
BgL_loopz00_6040:
if(
(BgL_iz00_6041==BgL_arg2562z00_6039))
{ /* Llib/block_ciphers.scm 294 */BgL_arg2560z00_6037; }  else 
{ /* Llib/block_ciphers.scm 294 */
{ /* Llib/block_ciphers.scm 294 */
long BgL_arg2665z00_6042;unsigned char BgL_arg2666z00_6043;
BgL_arg2665z00_6042 = 
(((long)0)+BgL_iz00_6041); 
BgL_arg2666z00_6043 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5037), 
(
(long)CINT(BgL_fromzd2poszd2_5038)+BgL_iz00_6041))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2561z00_6038, 
(((long)0)+BgL_iz00_6041)))))))); 
{ /* Llib/block_ciphers.scm 294 */
unsigned char BgL_tmpz00_11683;
BgL_tmpz00_11683 = 
(unsigned char)(BgL_arg2666z00_6043); 
STRING_SET(BgL_arg2560z00_6037, BgL_arg2665z00_6042, BgL_tmpz00_11683); } } 
{ 
long BgL_iz00_11686;
BgL_iz00_11686 = 
(BgL_iz00_6041+((long)1)); 
BgL_iz00_6041 = BgL_iz00_11686; 
goto BgL_loopz00_6040;} } } } 
{ /* Llib/block_ciphers.scm 295 */
obj_t BgL_arg2563z00_6044;long BgL_arg2564z00_6045;
BgL_arg2563z00_6044 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036)))->BgL_bufferz00); 
BgL_arg2564z00_6045 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5036))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 295 */
long BgL_o2z00_6046;
BgL_o2z00_6046 = 
(long)CINT(BgL_tozd2poszd2_5040); 
return 
blit_string(BgL_arg2563z00_6044, ((long)0), 
((obj_t)BgL_toz00_5039), BgL_o2z00_6046, BgL_arg2564z00_6045);} } } 

}



/* &do-cipher-IV-init!-P1327 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2P1327z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5041, obj_t BgL_statez00_5042, obj_t BgL_ivz00_5043)
{
{ /* Llib/block_ciphers.scm 287 */
{ /* Llib/block_ciphers.scm 289 */
obj_t BgL_arg2551z00_6048;long BgL_arg2552z00_6049;
BgL_arg2551z00_6048 = 
(((BgL_pcbczd2encryptzd2_bglt)COBJECT(
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5042)))->BgL_chainz00); 
BgL_arg2552z00_6049 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_pcbczd2encryptzd2_bglt)BgL_statez00_5042))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5043), ((long)0), BgL_arg2551z00_6048, ((long)0), BgL_arg2552z00_6049);} } 

}



/* &do-cipher-block!-CBC1325 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1325za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5044, obj_t BgL_statez00_5045, obj_t BgL_fromz00_5046, obj_t BgL_fromzd2poszd2_5047, obj_t BgL_toz00_5048, obj_t BgL_tozd2poszd2_5049)
{
{ /* Llib/block_ciphers.scm 269 */
{ /* Llib/block_ciphers.scm 271 */
obj_t BgL_arg2544z00_6051;long BgL_arg2545z00_6052;
BgL_arg2544z00_6051 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_bufferz00); 
BgL_arg2545z00_6052 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 271 */
long BgL_o1z00_6053;
BgL_o1z00_6053 = 
(long)CINT(BgL_fromzd2poszd2_5047); 
blit_string(
((obj_t)BgL_fromz00_5046), BgL_o1z00_6053, BgL_arg2544z00_6051, ((long)0), BgL_arg2545z00_6052); } } 
{ /* Llib/block_ciphers.scm 272 */
obj_t BgL_fun2548z00_6054;
BgL_fun2548z00_6054 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 272 */
obj_t BgL_arg2546z00_6055;obj_t BgL_arg2547z00_6056;
BgL_arg2546z00_6055 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_bufferz00); 
BgL_arg2547z00_6056 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2548z00_6054)(BgL_fun2548z00_6054, BgL_arg2546z00_6055, 
BINT(((long)0)), BgL_toz00_5048, BgL_tozd2poszd2_5049, BgL_arg2547z00_6056, BEOA); } } 
{ /* Llib/block_ciphers.scm 273 */
obj_t BgL_arg2549z00_6057;long BgL_arg2550z00_6058;
BgL_arg2549z00_6057 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_chainz00); 
BgL_arg2550z00_6058 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6060;
BgL_iz00_6060 = ((long)0); 
BgL_loopz00_6059:
if(
(BgL_iz00_6060==BgL_arg2550z00_6058))
{ /* Llib/block_ciphers.scm 273 */BgL_toz00_5048; }  else 
{ /* Llib/block_ciphers.scm 273 */
{ /* Llib/block_ciphers.scm 273 */
long BgL_arg2665z00_6061;unsigned char BgL_arg2666z00_6062;
BgL_arg2665z00_6061 = 
(
(long)CINT(BgL_tozd2poszd2_5049)+BgL_iz00_6060); 
BgL_arg2666z00_6062 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_toz00_5048), 
(
(long)CINT(BgL_tozd2poszd2_5049)+BgL_iz00_6060))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2549z00_6057, 
(((long)0)+BgL_iz00_6060)))))))); 
{ /* Llib/block_ciphers.scm 273 */
unsigned char BgL_charz00_6063;
BgL_charz00_6063 = 
(unsigned char)(BgL_arg2666z00_6062); 
{ /* Llib/block_ciphers.scm 273 */
obj_t BgL_tmpz00_11753;
BgL_tmpz00_11753 = 
((obj_t)BgL_toz00_5048); 
STRING_SET(BgL_tmpz00_11753, BgL_arg2665z00_6061, BgL_charz00_6063); } } } 
{ 
long BgL_iz00_11756;
BgL_iz00_11756 = 
(BgL_iz00_6060+((long)1)); 
BgL_iz00_6060 = BgL_iz00_11756; 
goto BgL_loopz00_6059;} } } } 
{ /* Llib/block_ciphers.scm 274 */
obj_t BgL_tmpz00_6064;
BgL_tmpz00_6064 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_chainz00); 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_chainz00)=((obj_t)
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_bufferz00)),BUNSPEC); 
return 
((((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5045)))->BgL_bufferz00)=((obj_t)BgL_tmpz00_6064),BUNSPEC);} } 

}



/* &do-cipher-IV-init!-C1323 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1323z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5050, obj_t BgL_statez00_5051, obj_t BgL_ivz00_5052)
{
{ /* Llib/block_ciphers.scm 266 */
{ /* Llib/block_ciphers.scm 268 */
obj_t BgL_arg2542z00_6066;long BgL_arg2543z00_6067;
BgL_arg2542z00_6066 = 
(((BgL_cbczd2decryptzd2_bglt)COBJECT(
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5051)))->BgL_chainz00); 
BgL_arg2543z00_6067 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2decryptzd2_bglt)BgL_statez00_5051))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5052), ((long)0), BgL_arg2542z00_6066, ((long)0), BgL_arg2543z00_6067);} } 

}



/* &do-cipher-block!-CBC1321 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2CBC1321za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5053, obj_t BgL_statez00_5054, obj_t BgL_fromz00_5055, obj_t BgL_fromzd2poszd2_5056, obj_t BgL_toz00_5057, obj_t BgL_tozd2poszd2_5058)
{
{ /* Llib/block_ciphers.scm 252 */
{ /* Llib/block_ciphers.scm 254 */
obj_t BgL_arg2533z00_6069;obj_t BgL_arg2534z00_6070;long BgL_arg2535z00_6071;
BgL_arg2533z00_6069 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054)))->BgL_bufferz00); 
BgL_arg2534z00_6070 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054)))->BgL_chainz00); 
BgL_arg2535z00_6071 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054))))->BgL_blockzd2siza7ez75); 
{ 
long BgL_iz00_6073;
BgL_iz00_6073 = ((long)0); 
BgL_loopz00_6072:
if(
(BgL_iz00_6073==BgL_arg2535z00_6071))
{ /* Llib/block_ciphers.scm 254 */BgL_arg2533z00_6069; }  else 
{ /* Llib/block_ciphers.scm 254 */
{ /* Llib/block_ciphers.scm 254 */
long BgL_arg2665z00_6074;unsigned char BgL_arg2666z00_6075;
BgL_arg2665z00_6074 = 
(((long)0)+BgL_iz00_6073); 
BgL_arg2666z00_6075 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_arg2534z00_6070, 
(((long)0)+BgL_iz00_6073))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_fromz00_5055), 
(
(long)CINT(BgL_fromzd2poszd2_5056)+BgL_iz00_6073)))))))); 
{ /* Llib/block_ciphers.scm 254 */
unsigned char BgL_tmpz00_11798;
BgL_tmpz00_11798 = 
(unsigned char)(BgL_arg2666z00_6075); 
STRING_SET(BgL_arg2533z00_6069, BgL_arg2665z00_6074, BgL_tmpz00_11798); } } 
{ 
long BgL_iz00_11801;
BgL_iz00_11801 = 
(BgL_iz00_6073+((long)1)); 
BgL_iz00_6073 = BgL_iz00_11801; 
goto BgL_loopz00_6072;} } } } 
{ /* Llib/block_ciphers.scm 255 */
obj_t BgL_fun2539z00_6076;
BgL_fun2539z00_6076 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 255 */
obj_t BgL_arg2536z00_6077;obj_t BgL_arg2537z00_6078;obj_t BgL_arg2538z00_6079;
BgL_arg2536z00_6077 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054)))->BgL_bufferz00); 
BgL_arg2537z00_6078 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054)))->BgL_chainz00); 
BgL_arg2538z00_6079 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054))))->BgL_paramz00); 
PROCEDURE_ENTRY(BgL_fun2539z00_6076)(BgL_fun2539z00_6076, BgL_arg2536z00_6077, 
BINT(((long)0)), BgL_arg2537z00_6078, 
BINT(((long)0)), BgL_arg2538z00_6079, BEOA); } } 
{ /* Llib/block_ciphers.scm 256 */
obj_t BgL_arg2540z00_6080;long BgL_arg2541z00_6081;
BgL_arg2540z00_6080 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054)))->BgL_chainz00); 
BgL_arg2541z00_6081 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5054))))->BgL_blockzd2siza7ez75); 
{ /* Llib/block_ciphers.scm 256 */
long BgL_o2z00_6082;
BgL_o2z00_6082 = 
(long)CINT(BgL_tozd2poszd2_5058); 
return 
blit_string(BgL_arg2540z00_6080, ((long)0), 
((obj_t)BgL_toz00_5057), BgL_o2z00_6082, BgL_arg2541z00_6081);} } } 

}



/* &do-cipher-IV-init!-C1319 */
obj_t BGl_z62dozd2cipherzd2IVzd2initz12zd2C1319z70zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5059, obj_t BgL_statez00_5060, obj_t BgL_ivz00_5061)
{
{ /* Llib/block_ciphers.scm 249 */
{ /* Llib/block_ciphers.scm 251 */
obj_t BgL_arg2531z00_6084;long BgL_arg2532z00_6085;
BgL_arg2531z00_6084 = 
(((BgL_cbczd2encryptzd2_bglt)COBJECT(
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5060)))->BgL_chainz00); 
BgL_arg2532z00_6085 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_cbczd2encryptzd2_bglt)BgL_statez00_5060))))->BgL_blockzd2siza7ez75); 
return 
blit_string(
((obj_t)BgL_ivz00_5061), ((long)0), BgL_arg2531z00_6084, ((long)0), BgL_arg2532z00_6085);} } 

}



/* &do-cipher-block!-ECB1317 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1317za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5062, obj_t BgL_statez00_5063, obj_t BgL_fromz00_5064, obj_t BgL_fromzd2poszd2_5065, obj_t BgL_toz00_5066, obj_t BgL_tozd2poszd2_5067)
{
{ /* Llib/block_ciphers.scm 236 */
{ /* Llib/block_ciphers.scm 238 */
obj_t BgL_fun2530z00_6087;
BgL_fun2530z00_6087 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_statez00_5063))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 238 */
obj_t BgL_arg2529z00_6088;
BgL_arg2529z00_6088 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2decryptzd2_bglt)BgL_statez00_5063))))->BgL_paramz00); 
return 
PROCEDURE_ENTRY(BgL_fun2530z00_6087)(BgL_fun2530z00_6087, BgL_fromz00_5064, BgL_fromzd2poszd2_5065, BgL_toz00_5066, BgL_tozd2poszd2_5067, BgL_arg2529z00_6088, BEOA);} } } 

}



/* &do-cipher-block!-ECB1315 */
obj_t BGl_z62dozd2cipherzd2blockz12zd2ECB1315za2zz__cryptozd2blockzd2ciphersz00(obj_t BgL_envz00_5068, obj_t BgL_statez00_5069, obj_t BgL_fromz00_5070, obj_t BgL_fromzd2poszd2_5071, obj_t BgL_toz00_5072, obj_t BgL_tozd2poszd2_5073)
{
{ /* Llib/block_ciphers.scm 233 */
{ /* Llib/block_ciphers.scm 235 */
obj_t BgL_fun2528z00_6090;
BgL_fun2528z00_6090 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_statez00_5069))))->BgL_cipherz00); 
{ /* Llib/block_ciphers.scm 235 */
obj_t BgL_arg2527z00_6091;
BgL_arg2527z00_6091 = 
(((BgL_cipherzd2statezd2_bglt)COBJECT(
((BgL_cipherzd2statezd2_bglt)
((BgL_ecbzd2encryptzd2_bglt)BgL_statez00_5069))))->BgL_paramz00); 
return 
PROCEDURE_ENTRY(BgL_fun2528z00_6090)(BgL_fun2528z00_6090, BgL_fromz00_5070, BgL_fromzd2poszd2_5071, BgL_toz00_5072, BgL_tozd2poszd2_5073, BgL_arg2527z00_6091, BEOA);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__cryptozd2blockzd2ciphersz00()
{
{ /* Llib/block_ciphers.scm 1 */
BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(((long)300158978), 
BSTRING_TO_STRING(BGl_string3388z00zz__cryptozd2blockzd2ciphersz00)); 
BGl_modulezd2initializa7ationz75zz__cryptozd2cipherzd2paddingz00(((long)63410218), 
BSTRING_TO_STRING(BGl_string3388z00zz__cryptozd2blockzd2ciphersz00)); 
return 
BGl_modulezd2initializa7ationz75zz__cryptozd2string2keyzd2(((long)210905795), 
BSTRING_TO_STRING(BGl_string3388z00zz__cryptozd2blockzd2ciphersz00));} 

}

#ifdef __cplusplus
}
#endif
