/*===========================================================================*/
/*   (Llib/flac.scm)                                                         */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -srfi flac -copt  -DBGL_DUMMY -copt -fPIC -copt -IClib Llib/flac.scm -o objs/flac.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <FLAC/stream_decoder.h>
#include <bglflac.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_flaczd2decoderzd2_bgl {
   header_t header;
   obj_t widening;
   FLAC__StreamDecoder * BgL_z42builtinz42;
   obj_t BgL_z52flacbufz52;
   obj_t BgL_outbufz00;
   bool_t BgL_z52eofz52;
   long BgL_z52samplez52;
   double BgL_z52volumez52;
   bool_t BgL_md5checkz00;
   int BgL_z52bchecksumz52;
   int BgL_z52rchecksumz52;
} *BgL_flaczd2decoderzd2_bglt;

typedef struct BgL_z62flaczd2errorzb0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62flaczd2errorzb0_bglt;


BGL_EXPORTED_DECL obj_t bgl_flac_decoder_tell(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_requirezd2initializa7ationz75zz__flac_flacz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2tell1128z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2seekz62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL FLAC__StreamDecoder * BGl_z52z42flaczd2decoderzd2newz10zz__flac_flacz00();
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2error1732zb0zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31212ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__flac_flacz00();
static obj_t BGl_z62flaczd2decoderzd2write1124z62zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62z52z42flaczd2makezd2customz72zz__flac_flacz00(obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__flac_flacz00();
BGL_EXPORTED_DECL int bgl_flac_error(char *, char *, obj_t);
static obj_t BGl_z62flaczd2decoderzd2resetz12z70zz__flac_flacz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__flac_flacz00();
static obj_t BGl_z62flaczd2volumezd2setz121140z70zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_flac_decoder_length(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2resetz121120z70zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2writez62zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_flacz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_z62flaczd2errorzb0zz__flac_flacz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_flacz00(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2positio1136z62zz__flac_flacz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_flac_decoder_metadata(BgL_flaczd2decoderzd2_bglt, BGL_LONGLONG_T, long, long, long);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__flac_flacz00();
static obj_t BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_flacz00(obj_t);
BGL_EXPORTED_DECL long BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2metadat1126z62zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31341ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2tellz62zz__flac_flacz00(obj_t, obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
static obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_flacz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2metadataz62zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_flaczd2decoderzd2initz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DECL obj_t bgl_flac_decoder_read(BgL_flaczd2decoderzd2_bglt, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2decoderzd2closez62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1210z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2decode11118z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1211z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31531ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31191ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_z62lambda1222z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1223z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_flacz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31541ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_z62lambda1239z62zz__flac_flacz00(obj_t, obj_t);
BGL_EXPORTED_DECL long BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__customz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62lambda1240z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1322z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1323z62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
BGL_EXPORTED_DECL obj_t BGl_z52z42flaczd2makezd2customz10zz__flac_flacz00();
static obj_t BGl_z62objectzd2printzd2flaczd2de1111zb0zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1247z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1248z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2decode16z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_flacz00(obj_t);
static obj_t BGl_z62lambda1339z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1259z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2seek1130z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52z42flaczd2decoderzd2newz72zz__flac_flacz00(obj_t);
static obj_t BGl_z62lambda1340z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2decodez62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1260z62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_flac_decoder_write(BgL_flaczd2decoderzd2_bglt, long, long, long, long);
static BgL_flaczd2decoderzd2_bglt BGl_z62lambda1182z62zz__flac_flacz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__flac_flacz00();
static obj_t BGl_z62flaczd2decoderzd2decode1116z62zz__flac_flacz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2zz__flac_flacz00 = BUNSPEC;
static obj_t BGl_z62lambda1189z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__flac_flacz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_flac_decoder_seek(BgL_flaczd2decoderzd2_bglt, BGL_LONGLONG_T);
static obj_t BGl_gczd2rootszd2initz00zz__flac_flacz00();
static obj_t BGl_z62lambda1190z62zz__flac_flacz00(obj_t, obj_t, obj_t);
static BgL_z62flaczd2errorzb0_bglt BGl_z62lambda1358z62zz__flac_flacz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_custom_nil();
static obj_t BGl_z62flaczd2decoderzd2positionz62zz__flac_flacz00(obj_t, obj_t);
static BgL_z62flaczd2errorzb0_bglt BGl_z62lambda1360z62zz__flac_flacz00(obj_t);
static obj_t BGl_z62lambda1282z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62lambda1283z62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62flaczd2decoderzd2infoz62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2volumezd2setz12z70zz__flac_flacz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2close1114z62zz__flac_flacz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62flaczd2decoderzd2length1132z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2volumezd2get1138z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2info1134z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2initz62zz__flac_flacz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2init1112z62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2readz62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62flaczd2decoderzd2read1122z62zz__flac_flacz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
BGL_EXPORTED_DECL obj_t BGl_flaczd2decoderzd2closez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_flaczd2decoderzd2statezd2ze3symbolz31zz__flac_flacz00(FLAC__StreamDecoderState);
BGL_EXPORTED_DECL obj_t BGl_flaczd2volumezd2getz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt);
static obj_t BGl_z62flaczd2volumezd2getz62zz__flac_flacz00(obj_t, obj_t);
static obj_t BGl_z62flaczd2decoderzd2lengthz62zz__flac_flacz00(obj_t, obj_t);
static obj_t __cnst[ 33 ] ;


DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2decodezd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1887z00, BGl_z62flaczd2decoderzd2decodez62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2volumezd2setz12zd2envzc0zz__flac_flacz00, BgL_bgl_za762flacza7d2volume1888z00, BGl_z62flaczd2volumezd2setz12z70zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1889z00, BGl_z62flaczd2decoderzd2metadataz62zz__flac_flacz00, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52z42flaczd2decoderzd2newzd2envzc2zz__flac_flacz00, BgL_bgl_za762za752za742flacza7d21890z00, BGl_z62z52z42flaczd2decoderzd2newz72zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1891z00, BGl_z62flaczd2decoderzd2lengthz62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1800z00zz__flac_flacz00, BgL_bgl_za762lambda1190za7621892z00, BGl_z62lambda1190z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1801z00zz__flac_flacz00, BgL_bgl_za762lambda1189za7621893z00, BGl_z62lambda1189z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1802z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1894za7, BGl_z62zc3z04anonymousza31212ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1803z00zz__flac_flacz00, BgL_bgl_za762lambda1211za7621895z00, BGl_z62lambda1211z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1804z00zz__flac_flacz00, BgL_bgl_za762lambda1210za7621896z00, BGl_z62lambda1210z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1805z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1897za7, BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1806z00zz__flac_flacz00, BgL_bgl_za762lambda1223za7621898z00, BGl_z62lambda1223z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1807z00zz__flac_flacz00, BgL_bgl_za762lambda1222za7621899z00, BGl_z62lambda1222z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1808z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1900za7, BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1809z00zz__flac_flacz00, BgL_bgl_za762lambda1240za7621901z00, BGl_z62lambda1240z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1810z00zz__flac_flacz00, BgL_bgl_za762lambda1239za7621902z00, BGl_z62lambda1239z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1811z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1903za7, BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1812z00zz__flac_flacz00, BgL_bgl_za762lambda1248za7621904z00, BGl_z62lambda1248z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1813z00zz__flac_flacz00, BgL_bgl_za762lambda1247za7621905z00, BGl_z62lambda1247z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1814z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1906za7, BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1815z00zz__flac_flacz00, BgL_bgl_za762lambda1260za7621907z00, BGl_z62lambda1260z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1816z00zz__flac_flacz00, BgL_bgl_za762lambda1259za7621908z00, BGl_z62lambda1259z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1817z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1909za7, BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1818z00zz__flac_flacz00, BgL_bgl_za762lambda1283za7621910z00, BGl_z62lambda1283z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1819z00zz__flac_flacz00, BgL_bgl_za762lambda1282za7621911z00, BGl_z62lambda1282z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1820z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1912za7, BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1821z00zz__flac_flacz00, BgL_bgl_za762lambda1323za7621913z00, BGl_z62lambda1323z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1822z00zz__flac_flacz00, BgL_bgl_za762lambda1322za7621914z00, BGl_z62lambda1322z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1823z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1915za7, BGl_z62zc3z04anonymousza31341ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1824z00zz__flac_flacz00, BgL_bgl_za762lambda1340za7621916z00, BGl_z62lambda1340z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1831z00zz__flac_flacz00, BgL_bgl_string1831za700za7za7_1917za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1825z00zz__flac_flacz00, BgL_bgl_za762lambda1339za7621918z00, BGl_z62lambda1339z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1826z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1919za7, BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1833z00zz__flac_flacz00, BgL_bgl_string1833za700za7za7_1920za7, "flac-decoder-init1112", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1827z00zz__flac_flacz00, BgL_bgl_za762lambda1182za7621921z00, BGl_z62lambda1182z62zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1828z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1922za7, BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STRING( BGl_string1835z00zz__flac_flacz00, BgL_bgl_string1835za700za7za7_1923za7, "flac-decoder-close1114", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1829z00zz__flac_flacz00, BgL_bgl_za762lambda1360za7621924z00, BGl_z62lambda1360z62zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1837z00zz__flac_flacz00, BgL_bgl_string1837za700za7za7_1925za7, "flac-decoder-decode1116", 23 );
DEFINE_STRING( BGl_string1839z00zz__flac_flacz00, BgL_bgl_string1839za700za7za7_1926za7, "flac-decoder-decode11118", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2closezd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1927z00, BGl_z62flaczd2decoderzd2closez62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1830z00zz__flac_flacz00, BgL_bgl_za762lambda1358za7621928z00, BGl_z62lambda1358z62zz__flac_flacz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1832z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1929z00, BGl_z62flaczd2decoderzd2init1112z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1834z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1930z00, BGl_z62flaczd2decoderzd2close1114z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1931z00, BGl_z62flaczd2decoderzd2seekz62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1841z00zz__flac_flacz00, BgL_bgl_string1841za700za7za7_1932za7, "flac-decoder-reset!1120", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1836z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1933z00, BGl_z62flaczd2decoderzd2decode1116z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1843z00zz__flac_flacz00, BgL_bgl_string1843za700za7za7_1934za7, "flac-decoder-read1122", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1838z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1935z00, BGl_z62flaczd2decoderzd2decode11118z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1845z00zz__flac_flacz00, BgL_bgl_string1845za700za7za7_1936za7, "flac-decoder-write1124", 22 );
DEFINE_STRING( BGl_string1847z00zz__flac_flacz00, BgL_bgl_string1847za700za7za7_1937za7, "flac-decoder-metadat1126", 24 );
DEFINE_STRING( BGl_string1849z00zz__flac_flacz00, BgL_bgl_string1849za700za7za7_1938za7, "flac-decoder-tell1128", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1840z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1939z00, BGl_z62flaczd2decoderzd2resetz121120z70zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1842z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1940z00, BGl_z62flaczd2decoderzd2read1122z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1844z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1941z00, BGl_z62flaczd2decoderzd2write1124z62zz__flac_flacz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string1851z00zz__flac_flacz00, BgL_bgl_string1851za700za7za7_1942za7, "flac-decoder-seek1130", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1846z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1943z00, BGl_z62flaczd2decoderzd2metadat1126z62zz__flac_flacz00, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string1853z00zz__flac_flacz00, BgL_bgl_string1853za700za7za7_1944za7, "flac-decoder-length1132", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1848z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1945z00, BGl_z62flaczd2decoderzd2tell1128z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1855z00zz__flac_flacz00, BgL_bgl_string1855za700za7za7_1946za7, "flac-decoder-info1134", 21 );
DEFINE_STRING( BGl_string1857z00zz__flac_flacz00, BgL_bgl_string1857za700za7za7_1947za7, "flac-decoder-positio1136", 24 );
DEFINE_STRING( BGl_string1859z00zz__flac_flacz00, BgL_bgl_string1859za700za7za7_1948za7, "flac-volume-get1138", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1850z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1949z00, BGl_z62flaczd2decoderzd2seek1130z62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1852z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1950z00, BGl_z62flaczd2decoderzd2length1132z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1854z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1951z00, BGl_z62flaczd2decoderzd2info1134z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1861z00zz__flac_flacz00, BgL_bgl_string1861za700za7za7_1952za7, "flac-volume-set!1140", 20 );
DEFINE_STRING( BGl_string1862z00zz__flac_flacz00, BgL_bgl_string1862za700za7za7_1953za7, "No method for this object", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1856z00zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1954z00, BGl_z62flaczd2decoderzd2positio1136z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1863z00zz__flac_flacz00, BgL_bgl_string1863za700za7za7_1955za7, "&flac-decoder-init", 18 );
DEFINE_STRING( BGl_string1864z00zz__flac_flacz00, BgL_bgl_string1864za700za7za7_1956za7, "flac-decoder", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1858z00zz__flac_flacz00, BgL_bgl_za762flacza7d2volume1957z00, BGl_z62flaczd2volumezd2get1138z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1865z00zz__flac_flacz00, BgL_bgl_string1865za700za7za7_1958za7, "&flac-decoder-close", 19 );
DEFINE_STRING( BGl_string1866z00zz__flac_flacz00, BgL_bgl_string1866za700za7za7_1959za7, "&flac-decoder-decode", 20 );
DEFINE_STRING( BGl_string1867z00zz__flac_flacz00, BgL_bgl_string1867za700za7za7_1960za7, "&flac-decoder-decode16", 22 );
DEFINE_STRING( BGl_string1868z00zz__flac_flacz00, BgL_bgl_string1868za700za7za7_1961za7, "&flac-decoder-reset!", 20 );
DEFINE_STRING( BGl_string1869z00zz__flac_flacz00, BgL_bgl_string1869za700za7za7_1962za7, "&flac-decoder-read", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1860z00zz__flac_flacz00, BgL_bgl_za762flacza7d2volume1963z00, BGl_z62flaczd2volumezd2setz121140z70zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string1870z00zz__flac_flacz00, BgL_bgl_string1870za700za7za7_1964za7, "bint", 4 );
DEFINE_STRING( BGl_string1871z00zz__flac_flacz00, BgL_bgl_string1871za700za7za7_1965za7, "&flac-decoder-write", 19 );
DEFINE_STRING( BGl_string1872z00zz__flac_flacz00, BgL_bgl_string1872za700za7za7_1966za7, "&flac-decoder-metadata", 22 );
DEFINE_STRING( BGl_string1873z00zz__flac_flacz00, BgL_bgl_string1873za700za7za7_1967za7, "bllong", 6 );
DEFINE_STRING( BGl_string1874z00zz__flac_flacz00, BgL_bgl_string1874za700za7za7_1968za7, "&flac-decoder-tell", 18 );
DEFINE_STRING( BGl_string1875z00zz__flac_flacz00, BgL_bgl_string1875za700za7za7_1969za7, "&flac-decoder-seek", 18 );
DEFINE_STRING( BGl_string1876z00zz__flac_flacz00, BgL_bgl_string1876za700za7za7_1970za7, "&flac-decoder-length", 20 );
DEFINE_STRING( BGl_string1795z00zz__flac_flacz00, BgL_bgl_string1795za700za7za7_1971za7, "Llib/flac.scm", 13 );
DEFINE_STRING( BGl_string1877z00zz__flac_flacz00, BgL_bgl_string1877za700za7za7_1972za7, "&flac-decoder-info", 18 );
DEFINE_STRING( BGl_string1796z00zz__flac_flacz00, BgL_bgl_string1796za700za7za7_1973za7, "/builddir/build/BUILD/bigloo-4.4b/api/flac/src/Llib/flac.scm", 60 );
DEFINE_STRING( BGl_string1878z00zz__flac_flacz00, BgL_bgl_string1878za700za7za7_1974za7, "&flac-decoder-position", 22 );
DEFINE_STRING( BGl_string1797z00zz__flac_flacz00, BgL_bgl_string1797za700za7za7_1975za7, "&flac-error1732", 15 );
DEFINE_STRING( BGl_string1879z00zz__flac_flacz00, BgL_bgl_string1879za700za7za7_1976za7, "&flac-volume-get", 16 );
DEFINE_STRING( BGl_string1798z00zz__flac_flacz00, BgL_bgl_string1798za700za7za7_1977za7, "bstring", 7 );
DEFINE_STRING( BGl_string1880z00zz__flac_flacz00, BgL_bgl_string1880za700za7za7_1978za7, "&flac-volume-set!", 17 );
DEFINE_STRING( BGl_string1882z00zz__flac_flacz00, BgL_bgl_string1882za700za7za7_1979za7, "object-print", 12 );
DEFINE_STRING( BGl_string1883z00zz__flac_flacz00, BgL_bgl_string1883za700za7za7_1980za7, "#|flac-decoder|", 15 );
DEFINE_STRING( BGl_string1884z00zz__flac_flacz00, BgL_bgl_string1884za700za7za7_1981za7, "flac-decoder-read1122 flac-decoder-write1124 flac-decoder-metadat1126 &flac-error __flac_flac flac-decoder %rchecksum int %bchecksum md5check double %volume long %sample bool %eof bstring outbuf custom %flacbuf $flac-decoder $builtin unknown stream-decoder-uninitialized stream-decoder-memory-allocation-error stream-decoder-aborted stream-decoder-seek-error STREAM-DECODER-OGG-ERROR stream-decoder-end-of-stream stream-decoder-read-frame stream-decoder-search-for-frame-sync stream-decoder-read-metadata decoder-search-for-metata ", 531 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1799z00zz__flac_flacz00, BgL_bgl_za762za7c3za704anonymo1982za7, BGl_z62zc3z04anonymousza31191ze3ze5zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1881z00zz__flac_flacz00, BgL_bgl_za762objectza7d2prin1983z00, BGl_z62objectzd2printzd2flaczd2de1111zb0zz__flac_flacz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2decode16zd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1984z00, BGl_z62flaczd2decoderzd2decode16z62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2infozd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1985z00, BGl_z62flaczd2decoderzd2infoz62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1986z00, BGl_z62flaczd2decoderzd2resetz12z70zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1987z00, BGl_z62flaczd2decoderzd2initz62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1988z00, BGl_z62flaczd2decoderzd2readz62zz__flac_flacz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1989z00, BGl_z62flaczd2decoderzd2writez62zz__flac_flacz00, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_flaczd2errorzd2envz00zz__flac_flacz00, BgL_bgl_za762flacza7d2error11990z00, BGl_z62flaczd2error1732zb0zz__flac_flacz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52z42flaczd2makezd2customzd2envzc2zz__flac_flacz00, BgL_bgl_za762za752za742flacza7d21991z00, BGl_z62z52z42flaczd2makezd2customz72zz__flac_flacz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1992z00, BGl_z62flaczd2decoderzd2tellz62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2decoderzd2positionzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2decode1993z00, BGl_z62flaczd2decoderzd2positionz62zz__flac_flacz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_flaczd2volumezd2getzd2envzd2zz__flac_flacz00, BgL_bgl_za762flacza7d2volume1994z00, BGl_z62flaczd2volumezd2getz62zz__flac_flacz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__flac_flacz00) );
ADD_ROOT( (void *)(&BGl_z62flaczd2errorzb0zz__flac_flacz00) );
ADD_ROOT( (void *)(&BGl_flaczd2decoderzd2zz__flac_flacz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__flac_flacz00(long BgL_checksumz00_1312, char * BgL_fromz00_1313)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__flac_flacz00))
{ 
BGl_requirezd2initializa7ationz75zz__flac_flacz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__flac_flacz00(); 
BGl_libraryzd2moduleszd2initz00zz__flac_flacz00(); 
BGl_cnstzd2initzd2zz__flac_flacz00(); 
BGl_objectzd2initzd2zz__flac_flacz00(); 
BGl_genericzd2initzd2zz__flac_flacz00(); 
BGl_methodzd2initzd2zz__flac_flacz00(); 
return 
BGl_toplevelzd2initzd2zz__flac_flacz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__customz00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__flac_flac"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__flac_flac"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
{ /* Llib/flac.scm 15 */
obj_t BgL_cportz00_1215;
{ /* Llib/flac.scm 15 */
obj_t BgL_stringz00_1223;
BgL_stringz00_1223 = BGl_string1884z00zz__flac_flacz00; 
{ /* Llib/flac.scm 15 */
obj_t BgL_startz00_1224;
BgL_startz00_1224 = 
BINT(((long)0)); 
{ /* Llib/flac.scm 15 */
obj_t BgL_endz00_1225;
BgL_endz00_1225 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1223))); 
{ /* Llib/flac.scm 15 */

BgL_cportz00_1215 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1223, BgL_startz00_1224, BgL_endz00_1225); } } } } 
{ 
long BgL_iz00_1216;
BgL_iz00_1216 = ((long)32); 
BgL_loopz00_1217:
if(
(BgL_iz00_1216==((long)-1)))
{ /* Llib/flac.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/flac.scm 15 */
{ /* Llib/flac.scm 15 */
obj_t BgL_arg1886z00_1219;
{ /* Llib/flac.scm 15 */

{ /* Llib/flac.scm 15 */
obj_t BgL_locationz00_1221;
BgL_locationz00_1221 = 
BBOOL(((bool_t)0)); 
{ /* Llib/flac.scm 15 */

BgL_arg1886z00_1219 = 
BGl_readz00zz__readerz00(BgL_cportz00_1215, BgL_locationz00_1221); } } } 
{ /* Llib/flac.scm 15 */
int BgL_tmpz00_1349;
BgL_tmpz00_1349 = 
(int)(BgL_iz00_1216); 
CNST_TABLE_SET(BgL_tmpz00_1349, BgL_arg1886z00_1219); } } 
{ /* Llib/flac.scm 15 */
int BgL_auxz00_1222;
BgL_auxz00_1222 = 
(int)(
(BgL_iz00_1216-((long)1))); 
{ 
long BgL_iz00_1354;
BgL_iz00_1354 = 
(long)(BgL_auxz00_1222); 
BgL_iz00_1216 = BgL_iz00_1354; 
goto BgL_loopz00_1217;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)0), 
BSTRING_TO_STRING(BGl_string1795z00zz__flac_flacz00)); 
return BUNSPEC;} 

}



/* %$flac-decoder-new */
BGL_EXPORTED_DEF FLAC__StreamDecoder * BGl_z52z42flaczd2decoderzd2newz10zz__flac_flacz00()
{
{ /* Llib/flac.scm 77 */
return 
FLAC__stream_decoder_new();} 

}



/* &%$flac-decoder-new */
obj_t BGl_z62z52z42flaczd2decoderzd2newz72zz__flac_flacz00(obj_t BgL_envz00_914)
{
{ /* Llib/flac.scm 77 */
return 
void_star_to_obj(
BGl_z52z42flaczd2decoderzd2newz10zz__flac_flacz00());} 

}



/* %$flac-make-custom */
BGL_EXPORTED_DEF obj_t BGl_z52z42flaczd2makezd2customz10zz__flac_flacz00()
{
{ /* Llib/flac.scm 83 */
return 
create_custom(((long)0));} 

}



/* &%$flac-make-custom */
obj_t BGl_z62z52z42flaczd2makezd2customz72zz__flac_flacz00(obj_t BgL_envz00_915)
{
{ /* Llib/flac.scm 83 */
return 
BGl_z52z42flaczd2makezd2customz10zz__flac_flacz00();} 

}



/* flac-decoder-state->symbol */
obj_t BGl_flaczd2decoderzd2statezd2ze3symbolz31zz__flac_flacz00(FLAC__StreamDecoderState BgL_sz00_29)
{
{ /* Llib/flac.scm 195 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_SEARCH_FOR_METADATA))
{ /* Llib/flac.scm 197 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/flac.scm 197 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_READ_METADATA))
{ /* Llib/flac.scm 199 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/flac.scm 199 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_SEARCH_FOR_FRAME_SYNC))
{ /* Llib/flac.scm 201 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/flac.scm 201 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_READ_FRAME))
{ /* Llib/flac.scm 203 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/flac.scm 203 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_END_OF_STREAM))
{ /* Llib/flac.scm 205 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/flac.scm 205 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_OGG_ERROR))
{ /* Llib/flac.scm 207 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/flac.scm 207 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_SEEK_ERROR))
{ /* Llib/flac.scm 209 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/flac.scm 209 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_ABORTED))
{ /* Llib/flac.scm 211 */
return 
CNST_TABLE_REF(((long)7));}  else 
{ /* Llib/flac.scm 211 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR))
{ /* Llib/flac.scm 213 */
return 
CNST_TABLE_REF(((long)8));}  else 
{ /* Llib/flac.scm 213 */
if(
(BgL_sz00_29==FLAC__STREAM_DECODER_UNINITIALIZED))
{ /* Llib/flac.scm 215 */
return 
CNST_TABLE_REF(((long)9));}  else 
{ /* Llib/flac.scm 215 */
return 
CNST_TABLE_REF(((long)10));} } } } } } } } } } } 

}



/* flac-error */
BGL_EXPORTED_DEF int bgl_flac_error(char * BgL_procz00_35, char * BgL_msgz00_36, obj_t BgL_objz00_37)
{
{ /* Llib/flac.scm 267 */
{ /* Llib/flac.scm 268 */
BgL_z62flaczd2errorzb0_bglt BgL_arg1172z00_63;
{ /* Llib/flac.scm 268 */
BgL_z62flaczd2errorzb0_bglt BgL_new1101z00_64;
{ /* Llib/flac.scm 268 */
BgL_z62flaczd2errorzb0_bglt BgL_new1100z00_67;
BgL_new1100z00_67 = 
((BgL_z62flaczd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62flaczd2errorzb0_bgl) ))); 
{ /* Llib/flac.scm 268 */
long BgL_arg1176z00_68;
BgL_arg1176z00_68 = 
BGL_CLASS_INDEX(BGl_z62flaczd2errorzb0zz__flac_flacz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1100z00_67), BgL_arg1176z00_68); } 
BgL_new1101z00_64 = BgL_new1100z00_67; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1101z00_64)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1101z00_64)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1403;
{ /* Llib/flac.scm 268 */
obj_t BgL_arg1173z00_65;
{ /* Llib/flac.scm 268 */
obj_t BgL_arg1175z00_66;
{ /* Llib/flac.scm 268 */
obj_t BgL_classz00_397;
BgL_classz00_397 = BGl_z62flaczd2errorzb0zz__flac_flacz00; 
BgL_arg1175z00_66 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_397); } 
BgL_arg1173z00_65 = 
VECTOR_REF(BgL_arg1175z00_66,((long)2)); } 
BgL_auxz00_1403 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1173z00_65); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1101z00_64)))->BgL_stackz00)=((obj_t)BgL_auxz00_1403),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1101z00_64)))->BgL_procz00)=((obj_t)
string_to_bstring(BgL_procz00_35)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1101z00_64)))->BgL_msgz00)=((obj_t)
string_to_bstring(BgL_msgz00_36)),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1101z00_64)))->BgL_objz00)=((obj_t)BgL_objz00_37),BUNSPEC); 
BgL_arg1172z00_63 = BgL_new1101z00_64; } 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1172z00_63)); } 
return 
(int)(((long)0));} 

}



/* &flac-error1732 */
obj_t BGl_z62flaczd2error1732zb0zz__flac_flacz00(obj_t BgL_envz00_916, obj_t BgL_procz00_917, obj_t BgL_msgz00_918, obj_t BgL_objz00_919)
{
{ /* Llib/flac.scm 267 */
{ /* Llib/flac.scm 271 */
int BgL_tmpz00_1420;
{ /* Llib/flac.scm 271 */
char * BgL_auxz00_1430;char * BgL_auxz00_1421;
{ /* Llib/flac.scm 271 */
obj_t BgL_tmpz00_1431;
if(
STRINGP(BgL_msgz00_918))
{ /* Llib/flac.scm 271 */
BgL_tmpz00_1431 = BgL_msgz00_918
; }  else 
{ 
obj_t BgL_auxz00_1434;
BgL_auxz00_1434 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)12279)), BGl_string1797z00zz__flac_flacz00, BGl_string1798z00zz__flac_flacz00, BgL_msgz00_918); 
FAILURE(BgL_auxz00_1434,BFALSE,BFALSE);} 
BgL_auxz00_1430 = 
BSTRING_TO_STRING(BgL_tmpz00_1431); } 
{ /* Llib/flac.scm 271 */
obj_t BgL_tmpz00_1422;
if(
STRINGP(BgL_procz00_917))
{ /* Llib/flac.scm 271 */
BgL_tmpz00_1422 = BgL_procz00_917
; }  else 
{ 
obj_t BgL_auxz00_1425;
BgL_auxz00_1425 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)12279)), BGl_string1797z00zz__flac_flacz00, BGl_string1798z00zz__flac_flacz00, BgL_procz00_917); 
FAILURE(BgL_auxz00_1425,BFALSE,BFALSE);} 
BgL_auxz00_1421 = 
BSTRING_TO_STRING(BgL_tmpz00_1422); } 
BgL_tmpz00_1420 = 
bgl_flac_error(BgL_auxz00_1421, BgL_auxz00_1430, BgL_objz00_919); } 
return 
BINT(BgL_tmpz00_1420);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1180z00_71;obj_t BgL_arg1181z00_72;
{ /* Llib/flac.scm 31 */
obj_t BgL_v1106z00_78;
BgL_v1106z00_78 = 
create_vector(((long)9)); 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1185z00_79;
BgL_arg1185z00_79 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc1801z00zz__flac_flacz00, BGl_proc1800z00zz__flac_flacz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1799z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1106z00_78,((long)0),BgL_arg1185z00_79); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1195z00_92;
BgL_arg1195z00_92 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc1804z00zz__flac_flacz00, BGl_proc1803z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1802z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1106z00_78,((long)1),BgL_arg1195z00_92); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1217z00_105;
BgL_arg1217z00_105 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc1807z00zz__flac_flacz00, BGl_proc1806z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1805z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)16))); 
VECTOR_SET(BgL_v1106z00_78,((long)2),BgL_arg1217z00_105); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1227z00_118;
BgL_arg1227z00_118 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)17)), BGl_proc1810z00zz__flac_flacz00, BGl_proc1809z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1808z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1106z00_78,((long)3),BgL_arg1227z00_118); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1242z00_131;
BgL_arg1242z00_131 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc1813z00zz__flac_flacz00, BGl_proc1812z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1811z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)20))); 
VECTOR_SET(BgL_v1106z00_78,((long)4),BgL_arg1242z00_131); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1252z00_144;
BgL_arg1252z00_144 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)21)), BGl_proc1816z00zz__flac_flacz00, BGl_proc1815z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1814z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)22))); 
VECTOR_SET(BgL_v1106z00_78,((long)5),BgL_arg1252z00_144); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1277z00_157;
BgL_arg1277z00_157 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc1819z00zz__flac_flacz00, BGl_proc1818z00zz__flac_flacz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc1817z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)18))); 
VECTOR_SET(BgL_v1106z00_78,((long)6),BgL_arg1277z00_157); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1318z00_170;
BgL_arg1318z00_170 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)24)), BGl_proc1822z00zz__flac_flacz00, BGl_proc1821z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1820z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)25))); 
VECTOR_SET(BgL_v1106z00_78,((long)7),BgL_arg1318z00_170); } 
{ /* Llib/flac.scm 31 */
obj_t BgL_arg1330z00_183;
BgL_arg1330z00_183 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc1825z00zz__flac_flacz00, BGl_proc1824z00zz__flac_flacz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc1823z00zz__flac_flacz00, 
CNST_TABLE_REF(((long)25))); 
VECTOR_SET(BgL_v1106z00_78,((long)8),BgL_arg1330z00_183); } 
BgL_arg1180z00_71 = BgL_v1106z00_78; } 
{ /* Llib/flac.scm 31 */
obj_t BgL_v1107z00_196;
BgL_v1107z00_196 = 
create_vector(((long)0)); 
BgL_arg1181z00_72 = BgL_v1107z00_196; } 
BGl_flaczd2decoderzd2zz__flac_flacz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)27)), 
CNST_TABLE_REF(((long)28)), BGl_objectz00zz__objectz00, ((long)5831), BFALSE, BGl_proc1827z00zz__flac_flacz00, BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1826z00zz__flac_flacz00, BFALSE, BgL_arg1180z00_71, BgL_arg1181z00_72); } 
{ /* Llib/flac.scm 43 */
obj_t BgL_arg1356z00_202;obj_t BgL_arg1357z00_203;
{ /* Llib/flac.scm 43 */
obj_t BgL_v1108z00_219;
BgL_v1108z00_219 = 
create_vector(((long)0)); 
BgL_arg1356z00_202 = BgL_v1108z00_219; } 
{ /* Llib/flac.scm 43 */
obj_t BgL_v1109z00_220;
BgL_v1109z00_220 = 
create_vector(((long)0)); 
BgL_arg1357z00_203 = BgL_v1109z00_220; } 
return ( 
BGl_z62flaczd2errorzb0zz__flac_flacz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)29)), 
CNST_TABLE_REF(((long)28)), BGl_z62errorz62zz__objectz00, ((long)1288), BGl_proc1830z00zz__flac_flacz00, BGl_proc1829z00zz__flac_flacz00, BFALSE, BGl_proc1828z00zz__flac_flacz00, BFALSE, BgL_arg1356z00_202, BgL_arg1357z00_203), BUNSPEC) ;} } 

}



/* &<@anonymous:1362> */
obj_t BGl_z62zc3z04anonymousza31362ze3ze5zz__flac_flacz00(obj_t BgL_envz00_952, obj_t BgL_new1083z00_953)
{
{ /* Llib/flac.scm 43 */
{ 
BgL_z62flaczd2errorzb0_bglt BgL_auxz00_1487;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_procz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953))))->BgL_objz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1487 = 
((BgL_z62flaczd2errorzb0_bglt)BgL_new1083z00_953); 
return 
((obj_t)BgL_auxz00_1487);} } 

}



/* &lambda1360 */
BgL_z62flaczd2errorzb0_bglt BGl_z62lambda1360z62zz__flac_flacz00(obj_t BgL_envz00_954)
{
{ /* Llib/flac.scm 43 */
{ /* Llib/flac.scm 43 */
BgL_z62flaczd2errorzb0_bglt BgL_new1082z00_1228;
BgL_new1082z00_1228 = 
((BgL_z62flaczd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62flaczd2errorzb0_bgl) ))); 
{ /* Llib/flac.scm 43 */
long BgL_arg1361z00_1229;
BgL_arg1361z00_1229 = 
BGL_CLASS_INDEX(BGl_z62flaczd2errorzb0zz__flac_flacz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_1228), BgL_arg1361z00_1229); } 
return BgL_new1082z00_1228;} } 

}



/* &lambda1358 */
BgL_z62flaczd2errorzb0_bglt BGl_z62lambda1358z62zz__flac_flacz00(obj_t BgL_envz00_955, obj_t BgL_fname1076z00_956, obj_t BgL_location1077z00_957, obj_t BgL_stack1078z00_958, obj_t BgL_proc1079z00_959, obj_t BgL_msg1080z00_960, obj_t BgL_obj1081z00_961)
{
{ /* Llib/flac.scm 43 */
{ /* Llib/flac.scm 43 */
BgL_z62flaczd2errorzb0_bglt BgL_new1103z00_1230;
{ /* Llib/flac.scm 43 */
BgL_z62flaczd2errorzb0_bglt BgL_new1102z00_1231;
BgL_new1102z00_1231 = 
((BgL_z62flaczd2errorzb0_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62flaczd2errorzb0_bgl) ))); 
{ /* Llib/flac.scm 43 */
long BgL_arg1359z00_1232;
BgL_arg1359z00_1232 = 
BGL_CLASS_INDEX(BGl_z62flaczd2errorzb0zz__flac_flacz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_1231), BgL_arg1359z00_1232); } 
BgL_new1103z00_1230 = BgL_new1102z00_1231; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1103z00_1230)))->BgL_fnamez00)=((obj_t)BgL_fname1076z00_956),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1103z00_1230)))->BgL_locationz00)=((obj_t)BgL_location1077z00_957),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1103z00_1230)))->BgL_stackz00)=((obj_t)BgL_stack1078z00_958),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1103z00_1230)))->BgL_procz00)=((obj_t)BgL_proc1079z00_959),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1103z00_1230)))->BgL_msgz00)=((obj_t)BgL_msg1080z00_960),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1103z00_1230)))->BgL_objz00)=((obj_t)BgL_obj1081z00_961),BUNSPEC); 
return BgL_new1103z00_1230;} } 

}



/* &<@anonymous:1184> */
obj_t BGl_z62zc3z04anonymousza31184ze3ze5zz__flac_flacz00(obj_t BgL_envz00_962, obj_t BgL_new1074z00_963)
{
{ /* Llib/flac.scm 31 */
{ 
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1528;
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)
0L),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52flacbufz52)=((obj_t)
bgl_custom_nil()),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_outbufz00)=((obj_t)BGl_string1831z00zz__flac_flacz00),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52volumez52)=((double)((double)0.0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_md5checkz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52bchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963)))->BgL_z52rchecksumz52)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_1528 = 
((BgL_flaczd2decoderzd2_bglt)BgL_new1074z00_963); 
return 
((obj_t)BgL_auxz00_1528);} } 

}



/* &lambda1182 */
BgL_flaczd2decoderzd2_bglt BGl_z62lambda1182z62zz__flac_flacz00(obj_t BgL_envz00_964)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
BgL_flaczd2decoderzd2_bglt BgL_new1073z00_1234;
BgL_new1073z00_1234 = 
((BgL_flaczd2decoderzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_flaczd2decoderzd2_bgl) ))); 
{ /* Llib/flac.scm 31 */
long BgL_arg1183z00_1235;
BgL_arg1183z00_1235 = 
BGL_CLASS_INDEX(BGl_flaczd2decoderzd2zz__flac_flacz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_1234), BgL_arg1183z00_1235); } 
return BgL_new1073z00_1234;} } 

}



/* &<@anonymous:1341> */
obj_t BGl_z62zc3z04anonymousza31341ze3ze5zz__flac_flacz00(obj_t BgL_envz00_965)
{
{ /* Llib/flac.scm 31 */
return 
BINT(((long)128));} 

}



/* &lambda1340 */
obj_t BGl_z62lambda1340z62zz__flac_flacz00(obj_t BgL_envz00_966, obj_t BgL_oz00_967, obj_t BgL_vz00_968)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
int BgL_vz00_1237;
BgL_vz00_1237 = 
CINT(BgL_vz00_968); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_967)))->BgL_z52rchecksumz52)=((int)BgL_vz00_1237),BUNSPEC);} } 

}



/* &lambda1339 */
obj_t BGl_z62lambda1339z62zz__flac_flacz00(obj_t BgL_envz00_969, obj_t BgL_oz00_970)
{
{ /* Llib/flac.scm 31 */
return 
BINT(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_970)))->BgL_z52rchecksumz52));} 

}



/* &<@anonymous:1324> */
obj_t BGl_z62zc3z04anonymousza31324ze3ze5zz__flac_flacz00(obj_t BgL_envz00_971)
{
{ /* Llib/flac.scm 31 */
return 
BINT(((long)128));} 

}



/* &lambda1323 */
obj_t BGl_z62lambda1323z62zz__flac_flacz00(obj_t BgL_envz00_972, obj_t BgL_oz00_973, obj_t BgL_vz00_974)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
int BgL_vz00_1240;
BgL_vz00_1240 = 
CINT(BgL_vz00_974); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_973)))->BgL_z52bchecksumz52)=((int)BgL_vz00_1240),BUNSPEC);} } 

}



/* &lambda1322 */
obj_t BGl_z62lambda1322z62zz__flac_flacz00(obj_t BgL_envz00_975, obj_t BgL_oz00_976)
{
{ /* Llib/flac.scm 31 */
return 
BINT(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_976)))->BgL_z52bchecksumz52));} 

}



/* &<@anonymous:1284> */
obj_t BGl_z62zc3z04anonymousza31284ze3ze5zz__flac_flacz00(obj_t BgL_envz00_977)
{
{ /* Llib/flac.scm 31 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1283 */
obj_t BGl_z62lambda1283z62zz__flac_flacz00(obj_t BgL_envz00_978, obj_t BgL_oz00_979, obj_t BgL_vz00_980)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
bool_t BgL_vz00_1243;
BgL_vz00_1243 = 
CBOOL(BgL_vz00_980); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_979)))->BgL_md5checkz00)=((bool_t)BgL_vz00_1243),BUNSPEC);} } 

}



/* &lambda1282 */
obj_t BGl_z62lambda1282z62zz__flac_flacz00(obj_t BgL_envz00_981, obj_t BgL_oz00_982)
{
{ /* Llib/flac.scm 31 */
return 
BBOOL(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_982)))->BgL_md5checkz00));} 

}



/* &<@anonymous:1261> */
obj_t BGl_z62zc3z04anonymousza31261ze3ze5zz__flac_flacz00(obj_t BgL_envz00_983)
{
{ /* Llib/flac.scm 31 */
return 
DOUBLE_TO_REAL(((double)1.0));} 

}



/* &lambda1260 */
obj_t BGl_z62lambda1260z62zz__flac_flacz00(obj_t BgL_envz00_984, obj_t BgL_oz00_985, obj_t BgL_vz00_986)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
double BgL_vz00_1246;
BgL_vz00_1246 = 
REAL_TO_DOUBLE(BgL_vz00_986); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_985)))->BgL_z52volumez52)=((double)BgL_vz00_1246),BUNSPEC);} } 

}



/* &lambda1259 */
obj_t BGl_z62lambda1259z62zz__flac_flacz00(obj_t BgL_envz00_987, obj_t BgL_oz00_988)
{
{ /* Llib/flac.scm 31 */
return 
DOUBLE_TO_REAL(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_988)))->BgL_z52volumez52));} 

}



/* &<@anonymous:1249> */
obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__flac_flacz00(obj_t BgL_envz00_989)
{
{ /* Llib/flac.scm 31 */
return 
BINT(((long)0));} 

}



/* &lambda1248 */
obj_t BGl_z62lambda1248z62zz__flac_flacz00(obj_t BgL_envz00_990, obj_t BgL_oz00_991, obj_t BgL_vz00_992)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
long BgL_vz00_1249;
BgL_vz00_1249 = 
(long)CINT(BgL_vz00_992); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_991)))->BgL_z52samplez52)=((long)BgL_vz00_1249),BUNSPEC);} } 

}



/* &lambda1247 */
obj_t BGl_z62lambda1247z62zz__flac_flacz00(obj_t BgL_envz00_993, obj_t BgL_oz00_994)
{
{ /* Llib/flac.scm 31 */
return 
BINT(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_994)))->BgL_z52samplez52));} 

}



/* &<@anonymous:1241> */
obj_t BGl_z62zc3z04anonymousza31241ze3ze5zz__flac_flacz00(obj_t BgL_envz00_995)
{
{ /* Llib/flac.scm 31 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1240 */
obj_t BGl_z62lambda1240z62zz__flac_flacz00(obj_t BgL_envz00_996, obj_t BgL_oz00_997, obj_t BgL_vz00_998)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
bool_t BgL_vz00_1252;
BgL_vz00_1252 = 
CBOOL(BgL_vz00_998); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_997)))->BgL_z52eofz52)=((bool_t)BgL_vz00_1252),BUNSPEC);} } 

}



/* &lambda1239 */
obj_t BGl_z62lambda1239z62zz__flac_flacz00(obj_t BgL_envz00_999, obj_t BgL_oz00_1000)
{
{ /* Llib/flac.scm 31 */
return 
BBOOL(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1000)))->BgL_z52eofz52));} 

}



/* &<@anonymous:1224> */
obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__flac_flacz00(obj_t BgL_envz00_1001)
{
{ /* Llib/flac.scm 31 */
return BGl_string1831z00zz__flac_flacz00;} 

}



/* &lambda1223 */
obj_t BGl_z62lambda1223z62zz__flac_flacz00(obj_t BgL_envz00_1002, obj_t BgL_oz00_1003, obj_t BgL_vz00_1004)
{
{ /* Llib/flac.scm 31 */
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1003)))->BgL_outbufz00)=((obj_t)
((obj_t)BgL_vz00_1004)),BUNSPEC);} 

}



/* &lambda1222 */
obj_t BGl_z62lambda1222z62zz__flac_flacz00(obj_t BgL_envz00_1005, obj_t BgL_oz00_1006)
{
{ /* Llib/flac.scm 31 */
return 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1006)))->BgL_outbufz00);} 

}



/* &<@anonymous:1212> */
obj_t BGl_z62zc3z04anonymousza31212ze3ze5zz__flac_flacz00(obj_t BgL_envz00_1007)
{
{ /* Llib/flac.scm 31 */
return 
create_custom(((long)0));} 

}



/* &lambda1211 */
obj_t BGl_z62lambda1211z62zz__flac_flacz00(obj_t BgL_envz00_1008, obj_t BgL_oz00_1009, obj_t BgL_vz00_1010)
{
{ /* Llib/flac.scm 31 */
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1009)))->BgL_z52flacbufz52)=((obj_t)
((obj_t)BgL_vz00_1010)),BUNSPEC);} 

}



/* &lambda1210 */
obj_t BGl_z62lambda1210z62zz__flac_flacz00(obj_t BgL_envz00_1011, obj_t BgL_oz00_1012)
{
{ /* Llib/flac.scm 31 */
return 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1012)))->BgL_z52flacbufz52);} 

}



/* &<@anonymous:1191> */
obj_t BGl_z62zc3z04anonymousza31191ze3ze5zz__flac_flacz00(obj_t BgL_envz00_1013)
{
{ /* Llib/flac.scm 31 */
return 
void_star_to_obj(
FLAC__stream_decoder_new());} 

}



/* &lambda1190 */
obj_t BGl_z62lambda1190z62zz__flac_flacz00(obj_t BgL_envz00_1014, obj_t BgL_oz00_1015, obj_t BgL_vz00_1016)
{
{ /* Llib/flac.scm 31 */
{ /* Llib/flac.scm 31 */
FLAC__StreamDecoder * BgL_vz00_1261;
BgL_vz00_1261 = 
FOREIGN_TO_COBJ(BgL_vz00_1016); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1015)))->BgL_z42builtinz42)=((FLAC__StreamDecoder *)BgL_vz00_1261),BUNSPEC);} } 

}



/* &lambda1189 */
obj_t BGl_z62lambda1189z62zz__flac_flacz00(obj_t BgL_envz00_1017, obj_t BgL_oz00_1018)
{
{ /* Llib/flac.scm 31 */
return 
void_star_to_obj(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1018)))->BgL_z42builtinz42));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, BGl_proc1832z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1833z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2closezd2envzd2zz__flac_flacz00, BGl_proc1834z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1835z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2decodezd2envzd2zz__flac_flacz00, BGl_proc1836z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1837z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2decode16zd2envzd2zz__flac_flacz00, BGl_proc1838z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1839z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, BGl_proc1840z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1841z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, BGl_proc1842z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1843z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00, BGl_proc1844z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1845z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, BGl_proc1846z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1847z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00, BGl_proc1848z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1849z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00, BGl_proc1850z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1851z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00, BGl_proc1852z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1853z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2infozd2envzd2zz__flac_flacz00, BGl_proc1854z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1855z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2decoderzd2positionzd2envzd2zz__flac_flacz00, BGl_proc1856z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1857z00zz__flac_flacz00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2volumezd2getzd2envzd2zz__flac_flacz00, BGl_proc1858z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1859z00zz__flac_flacz00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_flaczd2volumezd2setz12zd2envzc0zz__flac_flacz00, BGl_proc1860z00zz__flac_flacz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_string1861z00zz__flac_flacz00);} 

}



/* &flac-volume-set!1140 */
obj_t BGl_z62flaczd2volumezd2setz121140z70zz__flac_flacz00(obj_t BgL_envz00_1038, obj_t BgL_mz00_1039, obj_t BgL_volz00_1040)
{
{ /* Llib/flac.scm 258 */
{ /* Llib/flac.scm 260 */
bool_t BgL_test2009z00_1633;
if(
(
(long)CINT(BgL_volz00_1040)>=((long)0)))
{ /* Llib/flac.scm 260 */
BgL_test2009z00_1633 = 
(
(long)CINT(BgL_volz00_1040)<=((long)100))
; }  else 
{ /* Llib/flac.scm 260 */
BgL_test2009z00_1633 = ((bool_t)0)
; } 
if(BgL_test2009z00_1633)
{ /* Llib/flac.scm 261 */
double BgL_vz00_1264;
BgL_vz00_1264 = 
(
(double)(
(long)CINT(BgL_volz00_1040))/((double)100.0)); 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1039)))->BgL_z52volumez52)=((double)
(BgL_vz00_1264*BgL_vz00_1264)),BUNSPEC);}  else 
{ /* Llib/flac.scm 260 */
return BFALSE;} } } 

}



/* &flac-volume-get1138 */
obj_t BGl_z62flaczd2volumezd2get1138z62zz__flac_flacz00(obj_t BgL_envz00_1041, obj_t BgL_mz00_1042)
{
{ /* Llib/flac.scm 251 */
return 
BINT(
(long)(
(
sqrt(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1042)))->BgL_z52volumez52))*((double)100.0))));} 

}



/* &flac-decoder-positio1136 */
obj_t BGl_z62flaczd2decoderzd2positio1136z62zz__flac_flacz00(obj_t BgL_envz00_1043, obj_t BgL_mz00_1044)
{
{ /* Llib/flac.scm 239 */
{ /* Llib/flac.scm 240 */
long BgL_tmpz00_1651;
if(
(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1044)))->BgL_z52samplez52)<((long)0)))
{ /* Llib/flac.scm 241 */
BgL_tmpz00_1651 = ((long)0)
; }  else 
{ /* Llib/flac.scm 243 */
unsigned long BgL_sratez00_1267;
{ /* Llib/flac.scm 243 */
FLAC__StreamDecoder * BgL_tmpz00_1656;
BgL_tmpz00_1656 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1044)))->BgL_z42builtinz42); 
BgL_sratez00_1267 = 
FLAC__stream_decoder_get_sample_rate(BgL_tmpz00_1656); } 
if(
(
(long)(BgL_sratez00_1267)==((long)0)))
{ /* Llib/flac.scm 244 */
BgL_tmpz00_1651 = ((long)0)
; }  else 
{ /* Llib/flac.scm 244 */
BgL_tmpz00_1651 = 
(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1044)))->BgL_z52samplez52)/
(long)(BgL_sratez00_1267))
; } } 
return 
BINT(BgL_tmpz00_1651);} } 

}



/* &flac-decoder-info1134 */
obj_t BGl_z62flaczd2decoderzd2info1134z62zz__flac_flacz00(obj_t BgL_envz00_1045, obj_t BgL_oz00_1046)
{
{ /* Llib/flac.scm 187 */
{ /* Llib/flac.scm 188 */
unsigned long BgL_tmpz00_1668;
{ /* Llib/flac.scm 189 */
unsigned long BgL_val0_1104z00_1269;unsigned long BgL_val1_1105z00_1270;
{ /* Llib/flac.scm 189 */
FLAC__StreamDecoder * BgL_tmpz00_1669;
BgL_tmpz00_1669 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1046)))->BgL_z42builtinz42); 
BgL_val0_1104z00_1269 = 
FLAC__stream_decoder_get_bits_per_sample(BgL_tmpz00_1669); } 
{ /* Llib/flac.scm 190 */
FLAC__StreamDecoder * BgL_tmpz00_1673;
BgL_tmpz00_1673 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1046)))->BgL_z42builtinz42); 
BgL_val1_1105z00_1270 = 
FLAC__stream_decoder_get_sample_rate(BgL_tmpz00_1673); } 
{ /* Llib/flac.scm 189 */
int BgL_tmpz00_1677;
BgL_tmpz00_1677 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_1677); } 
{ /* Llib/flac.scm 189 */
obj_t BgL_auxz00_1682;int BgL_tmpz00_1680;
BgL_auxz00_1682 = 
BINT(BgL_val1_1105z00_1270); 
BgL_tmpz00_1680 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_1680, BgL_auxz00_1682); } 
BgL_tmpz00_1668 = BgL_val0_1104z00_1269; } 
return 
BINT(BgL_tmpz00_1668);} } 

}



/* &flac-decoder-length1132 */
obj_t BGl_z62flaczd2decoderzd2length1132z62zz__flac_flacz00(obj_t BgL_envz00_1047, obj_t BgL_oz00_1048)
{
{ /* Llib/flac.scm 181 */
return 
BINT(((long)-1));} 

}



/* &flac-decoder-seek1130 */
obj_t BGl_z62flaczd2decoderzd2seek1130z62zz__flac_flacz00(obj_t BgL_envz00_1049, obj_t BgL_oz00_1050, obj_t BgL_offsetz00_1051)
{
{ /* Llib/flac.scm 175 */
return 
BBOOL(((bool_t)1));} 

}



/* &flac-decoder-tell1128 */
obj_t BGl_z62flaczd2decoderzd2tell1128z62zz__flac_flacz00(obj_t BgL_envz00_1052, obj_t BgL_oz00_1053)
{
{ /* Llib/flac.scm 169 */
return 
BBOOL(((bool_t)0));} 

}



/* &flac-decoder-metadat1126 */
obj_t BGl_z62flaczd2decoderzd2metadat1126z62zz__flac_flacz00(obj_t BgL_envz00_1054, obj_t BgL_oz00_1055, obj_t BgL_totalz00_1056, obj_t BgL_sratez00_1057, obj_t BgL_channelsz00_1058, obj_t BgL_bpsz00_1059)
{
{ /* Llib/flac.scm 160 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string1862z00zz__flac_flacz00, 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1055)));} 

}



/* &flac-decoder-write1124 */
obj_t BGl_z62flaczd2decoderzd2write1124z62zz__flac_flacz00(obj_t BgL_envz00_1060, obj_t BgL_oz00_1061, obj_t BgL_blocksiza7eza7_1062, obj_t BgL_sratez00_1063, obj_t BgL_channelsz00_1064, obj_t BgL_bpsz00_1065)
{
{ /* Llib/flac.scm 151 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string1862z00zz__flac_flacz00, 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1061)));} 

}



/* &flac-decoder-read1122 */
obj_t BGl_z62flaczd2decoderzd2read1122z62zz__flac_flacz00(obj_t BgL_envz00_1066, obj_t BgL_oz00_1067, obj_t BgL_siza7eza7_1068)
{
{ /* Llib/flac.scm 146 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string1862z00zz__flac_flacz00, 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1067)));} 

}



/* &flac-decoder-reset!1120 */
obj_t BGl_z62flaczd2decoderzd2resetz121120z70zz__flac_flacz00(obj_t BgL_envz00_1069, obj_t BgL_oz00_1070)
{
{ /* Llib/flac.scm 129 */
{ /* Llib/flac.scm 130 */
bool_t BgL_test2013z00_1701;
{ /* Llib/flac.scm 130 */
obj_t BgL_arg1563z00_1288;
{ /* Llib/flac.scm 141 */
FLAC__StreamDecoderState BgL_arg1155z00_1289;
{ /* Llib/flac.scm 141 */
FLAC__StreamDecoder * BgL_tmpz00_1702;
BgL_tmpz00_1702 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1070)))->BgL_z42builtinz42); 
BgL_arg1155z00_1289 = 
FLAC__stream_decoder_get_state(BgL_tmpz00_1702); } 
BgL_arg1563z00_1288 = 
BGl_flaczd2decoderzd2statezd2ze3symbolz31zz__flac_flacz00(BgL_arg1155z00_1289); } 
BgL_test2013z00_1701 = 
(BgL_arg1563z00_1288==
CNST_TABLE_REF(((long)9))); } 
if(BgL_test2013z00_1701)
{ /* Llib/flac.scm 130 */
return BFALSE;}  else 
{ /* Llib/flac.scm 130 */
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1070)))->BgL_z52eofz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1070)))->BgL_z52samplez52)=((long)((long)0)),BUNSPEC); 
{ /* Llib/flac.scm 134 */
FLAC__StreamDecoder * BgL_arg1562z00_1290;
BgL_arg1562z00_1290 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1070)))->BgL_z42builtinz42); 
return 
BINT(
FLAC__stream_decoder_reset(BgL_arg1562z00_1290));} } } } 

}



/* &flac-decoder-decode11118 */
obj_t BGl_z62flaczd2decoderzd2decode11118z62zz__flac_flacz00(obj_t BgL_envz00_1071, obj_t BgL_oz00_1072)
{
{ /* Llib/flac.scm 118 */
{ /* Llib/flac.scm 119 */
long BgL_tmpz00_1717;
{ /* Llib/flac.scm 120 */
obj_t BgL_exitd1091z00_1292;
BgL_exitd1091z00_1292 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac.scm 124 */
obj_t BgL_zc3z04anonymousza31541ze3z87_1293;
BgL_zc3z04anonymousza31541ze3z87_1293 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31541ze3ze5zz__flac_flacz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31541ze3z87_1293, 
(int)(((long)0)), 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1072))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1091z00_1292, BgL_zc3z04anonymousza31541ze3z87_1293); 
{ /* Llib/flac.scm 122 */
FLAC__bool BgL_tmp1093z00_1294;
{ /* Llib/flac.scm 122 */
FLAC__StreamDecoder * BgL_arg1539z00_1295;
BgL_arg1539z00_1295 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1072)))->BgL_z42builtinz42); 
{ /* Llib/flac.scm 122 */
obj_t BgL_tmpz00_1729;
BgL_tmpz00_1729 = 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1072)); 
bgl_FLAC__stream_decoder_init_stream16(BgL_arg1539z00_1295, BgL_tmpz00_1729); } } 
{ /* Llib/flac.scm 123 */
FLAC__StreamDecoder * BgL_tmpz00_1733;
BgL_tmpz00_1733 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1072)))->BgL_z42builtinz42); 
BgL_tmp1093z00_1294 = 
FLAC__stream_decoder_process_until_end_of_stream(BgL_tmpz00_1733); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1091z00_1292); 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1072)); 
BgL_tmpz00_1717 = BgL_tmp1093z00_1294; } } } 
return 
BINT(BgL_tmpz00_1717);} } 

}



/* &<@anonymous:1541> */
obj_t BGl_z62zc3z04anonymousza31541ze3ze5zz__flac_flacz00(obj_t BgL_envz00_1073)
{
{ /* Llib/flac.scm 120 */
{ /* Llib/flac.scm 124 */
BgL_flaczd2decoderzd2_bglt BgL_oz00_1074;
BgL_oz00_1074 = 
((BgL_flaczd2decoderzd2_bglt)
PROCEDURE_REF(BgL_envz00_1073, 
(int)(((long)0)))); 
return 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_oz00_1074);} } 

}



/* &flac-decoder-decode1116 */
obj_t BGl_z62flaczd2decoderzd2decode1116z62zz__flac_flacz00(obj_t BgL_envz00_1075, obj_t BgL_oz00_1076)
{
{ /* Llib/flac.scm 107 */
{ /* Llib/flac.scm 108 */
long BgL_tmpz00_1745;
{ /* Llib/flac.scm 109 */
obj_t BgL_exitd1087z00_1297;
BgL_exitd1087z00_1297 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/flac.scm 113 */
obj_t BgL_zc3z04anonymousza31531ze3z87_1298;
BgL_zc3z04anonymousza31531ze3z87_1298 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31531ze3ze5zz__flac_flacz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31531ze3z87_1298, 
(int)(((long)0)), 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1076))); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1087z00_1297, BgL_zc3z04anonymousza31531ze3z87_1298); 
{ /* Llib/flac.scm 111 */
FLAC__bool BgL_tmp1089z00_1299;
{ /* Llib/flac.scm 111 */
FLAC__StreamDecoder * BgL_arg1524z00_1300;
BgL_arg1524z00_1300 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1076)))->BgL_z42builtinz42); 
{ /* Llib/flac.scm 111 */
obj_t BgL_tmpz00_1757;
BgL_tmpz00_1757 = 
((obj_t)
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1076)); 
bgl_FLAC__stream_decoder_init_stream(BgL_arg1524z00_1300, BgL_tmpz00_1757); } } 
{ /* Llib/flac.scm 112 */
FLAC__StreamDecoder * BgL_tmpz00_1761;
BgL_tmpz00_1761 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1076)))->BgL_z42builtinz42); 
BgL_tmp1089z00_1299 = 
FLAC__stream_decoder_process_until_end_of_stream(BgL_tmpz00_1761); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1087z00_1297); 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1076)); 
BgL_tmpz00_1745 = BgL_tmp1089z00_1299; } } } 
return 
BINT(BgL_tmpz00_1745);} } 

}



/* &<@anonymous:1531> */
obj_t BGl_z62zc3z04anonymousza31531ze3ze5zz__flac_flacz00(obj_t BgL_envz00_1077)
{
{ /* Llib/flac.scm 109 */
{ /* Llib/flac.scm 113 */
BgL_flaczd2decoderzd2_bglt BgL_oz00_1078;
BgL_oz00_1078 = 
((BgL_flaczd2decoderzd2_bglt)
PROCEDURE_REF(BgL_envz00_1077, 
(int)(((long)0)))); 
return 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_oz00_1078);} } 

}



/* &flac-decoder-close1114 */
obj_t BGl_z62flaczd2decoderzd2close1114z62zz__flac_flacz00(obj_t BgL_envz00_1079, obj_t BgL_oz00_1080)
{
{ /* Llib/flac.scm 99 */
{ 
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1773;
{ /* Llib/flac.scm 101 */
FLAC__StreamDecoder * BgL_arg1516z00_1302;
BgL_arg1516z00_1302 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1080)))->BgL_z42builtinz42); 
FLAC__stream_decoder_delete(BgL_arg1516z00_1302); BUNSPEC; } 
BgL_auxz00_1773 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1080); 
return 
((obj_t)BgL_auxz00_1773);} } 

}



/* &flac-decoder-init1112 */
obj_t BGl_z62flaczd2decoderzd2init1112z62zz__flac_flacz00(obj_t BgL_envz00_1081, obj_t BgL_oz00_1082)
{
{ /* Llib/flac.scm 89 */
{ /* Llib/flac.scm 91 */
FLAC__StreamDecoder * BgL_arg1390z00_1306;FLAC__bool BgL_arg1431z00_1307;
BgL_arg1390z00_1306 = 
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1082)))->BgL_z42builtinz42); 
if(
(((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1082)))->BgL_md5checkz00))
{ /* Llib/flac.scm 92 */
BgL_arg1431z00_1307 = true; }  else 
{ /* Llib/flac.scm 92 */
BgL_arg1431z00_1307 = false; } 
FLAC__stream_decoder_set_md5_checking(BgL_arg1390z00_1306, BgL_arg1431z00_1307); } 
{ 
obj_t BgL_auxz00_1785;
{ /* Llib/flac.scm 94 */
long BgL_arg1506z00_1308;
BgL_arg1506z00_1308 = 
(FLAC__MAX_BLOCK_SIZE*
(FLAC__MAX_CHANNELS*((long)4))); 
{ /* Llib/flac.scm 94 */

BgL_auxz00_1785 = 
make_string(BgL_arg1506z00_1308, ((unsigned char)' ')); } } 
return 
((((BgL_flaczd2decoderzd2_bglt)COBJECT(
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1082)))->BgL_outbufz00)=((obj_t)BgL_auxz00_1785),BUNSPEC);} } 

}



/* flac-decoder-init */
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2initz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_6)
{
{ /* Llib/flac.scm 89 */
{ /* Llib/flac.scm 89 */
obj_t BgL_method1113z00_350;
{ /* Llib/flac.scm 89 */
obj_t BgL_res1661z00_477;
{ /* Llib/flac.scm 89 */
long BgL_objzd2classzd2numz00_448;
BgL_objzd2classzd2numz00_448 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_6)); 
{ /* Llib/flac.scm 89 */
obj_t BgL_arg1765z00_449;
BgL_arg1765z00_449 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2initzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 89 */
int BgL_offsetz00_452;
BgL_offsetz00_452 = 
(int)(BgL_objzd2classzd2numz00_448); 
{ /* Llib/flac.scm 89 */
long BgL_offsetz00_453;
BgL_offsetz00_453 = 
(
(long)(BgL_offsetz00_452)-OBJECT_TYPE); 
{ /* Llib/flac.scm 89 */
long BgL_modz00_454;
BgL_modz00_454 = 
(BgL_offsetz00_453 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 89 */
long BgL_restz00_456;
BgL_restz00_456 = 
(BgL_offsetz00_453 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 89 */

{ /* Llib/flac.scm 89 */
obj_t BgL_bucketz00_458;
BgL_bucketz00_458 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_449),BgL_modz00_454); 
BgL_res1661z00_477 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_458),BgL_restz00_456); } } } } } } } } 
BgL_method1113z00_350 = BgL_res1661z00_477; } 
return 
PROCEDURE_ENTRY(BgL_method1113z00_350)(BgL_method1113z00_350, 
((obj_t)BgL_oz00_6), BEOA);} } 

}



/* &flac-decoder-init */
obj_t BGl_z62flaczd2decoderzd2initz62zz__flac_flacz00(obj_t BgL_envz00_1019, obj_t BgL_oz00_1020)
{
{ /* Llib/flac.scm 89 */
{ /* Llib/flac.scm 89 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1821;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1020, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 89 */
BgL_auxz00_1821 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1020)
; }  else 
{ 
obj_t BgL_auxz00_1825;
BgL_auxz00_1825 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)4030)), BGl_string1863z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1020); 
FAILURE(BgL_auxz00_1825,BFALSE,BFALSE);} 
return 
BGl_flaczd2decoderzd2initz00zz__flac_flacz00(BgL_auxz00_1821);} } 

}



/* flac-decoder-close */
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2closez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_7)
{
{ /* Llib/flac.scm 99 */
{ /* Llib/flac.scm 99 */
obj_t BgL_method1115z00_351;
{ /* Llib/flac.scm 99 */
obj_t BgL_res1666z00_508;
{ /* Llib/flac.scm 99 */
long BgL_objzd2classzd2numz00_479;
BgL_objzd2classzd2numz00_479 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_7)); 
{ /* Llib/flac.scm 99 */
obj_t BgL_arg1765z00_480;
BgL_arg1765z00_480 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2closezd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 99 */
int BgL_offsetz00_483;
BgL_offsetz00_483 = 
(int)(BgL_objzd2classzd2numz00_479); 
{ /* Llib/flac.scm 99 */
long BgL_offsetz00_484;
BgL_offsetz00_484 = 
(
(long)(BgL_offsetz00_483)-OBJECT_TYPE); 
{ /* Llib/flac.scm 99 */
long BgL_modz00_485;
BgL_modz00_485 = 
(BgL_offsetz00_484 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 99 */
long BgL_restz00_487;
BgL_restz00_487 = 
(BgL_offsetz00_484 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 99 */

{ /* Llib/flac.scm 99 */
obj_t BgL_bucketz00_489;
BgL_bucketz00_489 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_480),BgL_modz00_485); 
BgL_res1666z00_508 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_489),BgL_restz00_487); } } } } } } } } 
BgL_method1115z00_351 = BgL_res1666z00_508; } 
return 
PROCEDURE_ENTRY(BgL_method1115z00_351)(BgL_method1115z00_351, 
((obj_t)BgL_oz00_7), BEOA);} } 

}



/* &flac-decoder-close */
obj_t BGl_z62flaczd2decoderzd2closez62zz__flac_flacz00(obj_t BgL_envz00_1083, obj_t BgL_oz00_1084)
{
{ /* Llib/flac.scm 99 */
{ /* Llib/flac.scm 99 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1860;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1084, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 99 */
BgL_auxz00_1860 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1084)
; }  else 
{ 
obj_t BgL_auxz00_1864;
BgL_auxz00_1864 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)4535)), BGl_string1865z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1084); 
FAILURE(BgL_auxz00_1864,BFALSE,BFALSE);} 
return 
BGl_flaczd2decoderzd2closez00zz__flac_flacz00(BgL_auxz00_1860);} } 

}



/* flac-decoder-decode */
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_8)
{
{ /* Llib/flac.scm 107 */
{ /* Llib/flac.scm 107 */
obj_t BgL_method1117z00_352;
{ /* Llib/flac.scm 107 */
obj_t BgL_res1671z00_539;
{ /* Llib/flac.scm 107 */
long BgL_objzd2classzd2numz00_510;
BgL_objzd2classzd2numz00_510 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_8)); 
{ /* Llib/flac.scm 107 */
obj_t BgL_arg1765z00_511;
BgL_arg1765z00_511 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2decodezd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 107 */
int BgL_offsetz00_514;
BgL_offsetz00_514 = 
(int)(BgL_objzd2classzd2numz00_510); 
{ /* Llib/flac.scm 107 */
long BgL_offsetz00_515;
BgL_offsetz00_515 = 
(
(long)(BgL_offsetz00_514)-OBJECT_TYPE); 
{ /* Llib/flac.scm 107 */
long BgL_modz00_516;
BgL_modz00_516 = 
(BgL_offsetz00_515 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 107 */
long BgL_restz00_518;
BgL_restz00_518 = 
(BgL_offsetz00_515 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 107 */

{ /* Llib/flac.scm 107 */
obj_t BgL_bucketz00_520;
BgL_bucketz00_520 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_511),BgL_modz00_516); 
BgL_res1671z00_539 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_520),BgL_restz00_518); } } } } } } } } 
BgL_method1117z00_352 = BgL_res1671z00_539; } 
return 
PROCEDURE_ENTRY(BgL_method1117z00_352)(BgL_method1117z00_352, 
((obj_t)BgL_oz00_8), BEOA);} } 

}



/* &flac-decoder-decode */
obj_t BGl_z62flaczd2decoderzd2decodez62zz__flac_flacz00(obj_t BgL_envz00_1085, obj_t BgL_oz00_1086)
{
{ /* Llib/flac.scm 107 */
{ /* Llib/flac.scm 107 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1899;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1086, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 107 */
BgL_auxz00_1899 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1086)
; }  else 
{ 
obj_t BgL_auxz00_1903;
BgL_auxz00_1903 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)4902)), BGl_string1866z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1086); 
FAILURE(BgL_auxz00_1903,BFALSE,BFALSE);} 
return 
BGl_flaczd2decoderzd2decodez00zz__flac_flacz00(BgL_auxz00_1899);} } 

}



/* flac-decoder-decode16 */
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_9)
{
{ /* Llib/flac.scm 118 */
{ /* Llib/flac.scm 118 */
obj_t BgL_method1119z00_353;
{ /* Llib/flac.scm 118 */
obj_t BgL_res1676z00_570;
{ /* Llib/flac.scm 118 */
long BgL_objzd2classzd2numz00_541;
BgL_objzd2classzd2numz00_541 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_9)); 
{ /* Llib/flac.scm 118 */
obj_t BgL_arg1765z00_542;
BgL_arg1765z00_542 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2decode16zd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 118 */
int BgL_offsetz00_545;
BgL_offsetz00_545 = 
(int)(BgL_objzd2classzd2numz00_541); 
{ /* Llib/flac.scm 118 */
long BgL_offsetz00_546;
BgL_offsetz00_546 = 
(
(long)(BgL_offsetz00_545)-OBJECT_TYPE); 
{ /* Llib/flac.scm 118 */
long BgL_modz00_547;
BgL_modz00_547 = 
(BgL_offsetz00_546 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 118 */
long BgL_restz00_549;
BgL_restz00_549 = 
(BgL_offsetz00_546 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 118 */

{ /* Llib/flac.scm 118 */
obj_t BgL_bucketz00_551;
BgL_bucketz00_551 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_542),BgL_modz00_547); 
BgL_res1676z00_570 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_551),BgL_restz00_549); } } } } } } } } 
BgL_method1119z00_353 = BgL_res1676z00_570; } 
return 
PROCEDURE_ENTRY(BgL_method1119z00_353)(BgL_method1119z00_353, 
((obj_t)BgL_oz00_9), BEOA);} } 

}



/* &flac-decoder-decode16 */
obj_t BGl_z62flaczd2decoderzd2decode16z62zz__flac_flacz00(obj_t BgL_envz00_1087, obj_t BgL_oz00_1088)
{
{ /* Llib/flac.scm 118 */
{ /* Llib/flac.scm 118 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1938;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1088, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 118 */
BgL_auxz00_1938 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1088)
; }  else 
{ 
obj_t BgL_auxz00_1942;
BgL_auxz00_1942 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)5394)), BGl_string1867z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1088); 
FAILURE(BgL_auxz00_1942,BFALSE,BFALSE);} 
return 
BGl_flaczd2decoderzd2decode16z00zz__flac_flacz00(BgL_auxz00_1938);} } 

}



/* flac-decoder-reset! */
BGL_EXPORTED_DEF obj_t BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_10)
{
{ /* Llib/flac.scm 129 */
{ /* Llib/flac.scm 129 */
obj_t BgL_method1121z00_354;
{ /* Llib/flac.scm 129 */
obj_t BgL_res1681z00_601;
{ /* Llib/flac.scm 129 */
long BgL_objzd2classzd2numz00_572;
BgL_objzd2classzd2numz00_572 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_10)); 
{ /* Llib/flac.scm 129 */
obj_t BgL_arg1765z00_573;
BgL_arg1765z00_573 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2resetz12zd2envzc0zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 129 */
int BgL_offsetz00_576;
BgL_offsetz00_576 = 
(int)(BgL_objzd2classzd2numz00_572); 
{ /* Llib/flac.scm 129 */
long BgL_offsetz00_577;
BgL_offsetz00_577 = 
(
(long)(BgL_offsetz00_576)-OBJECT_TYPE); 
{ /* Llib/flac.scm 129 */
long BgL_modz00_578;
BgL_modz00_578 = 
(BgL_offsetz00_577 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 129 */
long BgL_restz00_580;
BgL_restz00_580 = 
(BgL_offsetz00_577 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 129 */

{ /* Llib/flac.scm 129 */
obj_t BgL_bucketz00_582;
BgL_bucketz00_582 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_573),BgL_modz00_578); 
BgL_res1681z00_601 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_582),BgL_restz00_580); } } } } } } } } 
BgL_method1121z00_354 = BgL_res1681z00_601; } 
return 
PROCEDURE_ENTRY(BgL_method1121z00_354)(BgL_method1121z00_354, 
((obj_t)BgL_oz00_10), BEOA);} } 

}



/* &flac-decoder-reset! */
obj_t BGl_z62flaczd2decoderzd2resetz12z70zz__flac_flacz00(obj_t BgL_envz00_1089, obj_t BgL_oz00_1090)
{
{ /* Llib/flac.scm 129 */
{ /* Llib/flac.scm 129 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_1977;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1090, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 129 */
BgL_auxz00_1977 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1090)
; }  else 
{ 
obj_t BgL_auxz00_1981;
BgL_auxz00_1981 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)5890)), BGl_string1868z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1090); 
FAILURE(BgL_auxz00_1981,BFALSE,BFALSE);} 
return 
BGl_flaczd2decoderzd2resetz12z12zz__flac_flacz00(BgL_auxz00_1977);} } 

}



/* flac-decoder-read */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_read(BgL_flaczd2decoderzd2_bglt BgL_oz00_12, long BgL_siza7eza7_13)
{
{ /* Llib/flac.scm 146 */
{ /* Llib/flac.scm 146 */
obj_t BgL_method1123z00_355;
{ /* Llib/flac.scm 146 */
obj_t BgL_res1686z00_632;
{ /* Llib/flac.scm 146 */
long BgL_objzd2classzd2numz00_603;
BgL_objzd2classzd2numz00_603 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_12)); 
{ /* Llib/flac.scm 146 */
obj_t BgL_arg1765z00_604;
BgL_arg1765z00_604 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2readzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 146 */
int BgL_offsetz00_607;
BgL_offsetz00_607 = 
(int)(BgL_objzd2classzd2numz00_603); 
{ /* Llib/flac.scm 146 */
long BgL_offsetz00_608;
BgL_offsetz00_608 = 
(
(long)(BgL_offsetz00_607)-OBJECT_TYPE); 
{ /* Llib/flac.scm 146 */
long BgL_modz00_609;
BgL_modz00_609 = 
(BgL_offsetz00_608 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 146 */
long BgL_restz00_611;
BgL_restz00_611 = 
(BgL_offsetz00_608 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 146 */

{ /* Llib/flac.scm 146 */
obj_t BgL_bucketz00_613;
BgL_bucketz00_613 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_604),BgL_modz00_609); 
BgL_res1686z00_632 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_613),BgL_restz00_611); } } } } } } } } 
BgL_method1123z00_355 = BgL_res1686z00_632; } 
return 
PROCEDURE_ENTRY(BgL_method1123z00_355)(BgL_method1123z00_355, 
((obj_t)BgL_oz00_12), 
BINT(BgL_siza7eza7_13), BEOA);} } 

}



/* &flac-decoder-read */
obj_t BGl_z62flaczd2decoderzd2readz62zz__flac_flacz00(obj_t BgL_envz00_1091, obj_t BgL_oz00_1092, obj_t BgL_siza7eza7_1093)
{
{ /* Llib/flac.scm 146 */
{ /* Llib/flac.scm 146 */
long BgL_auxz00_2026;BgL_flaczd2decoderzd2_bglt BgL_auxz00_2018;
{ /* Llib/flac.scm 146 */
obj_t BgL_tmpz00_2027;
if(
INTEGERP(BgL_siza7eza7_1093))
{ /* Llib/flac.scm 146 */
BgL_tmpz00_2027 = BgL_siza7eza7_1093
; }  else 
{ 
obj_t BgL_auxz00_2030;
BgL_auxz00_2030 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)6760)), BGl_string1869z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_siza7eza7_1093); 
FAILURE(BgL_auxz00_2030,BFALSE,BFALSE);} 
BgL_auxz00_2026 = 
(long)CINT(BgL_tmpz00_2027); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1092, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 146 */
BgL_auxz00_2018 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1092)
; }  else 
{ 
obj_t BgL_auxz00_2022;
BgL_auxz00_2022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)6760)), BGl_string1869z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1092); 
FAILURE(BgL_auxz00_2022,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_read(BgL_auxz00_2018, BgL_auxz00_2026);} } 

}



/* flac-decoder-write */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_write(BgL_flaczd2decoderzd2_bglt BgL_oz00_14, long BgL_blocksiza7eza7_15, long BgL_sratez00_16, long BgL_channelsz00_17, long BgL_bpsz00_18)
{
{ /* Llib/flac.scm 151 */
{ /* Llib/flac.scm 151 */
obj_t BgL_method1125z00_356;
{ /* Llib/flac.scm 151 */
obj_t BgL_res1691z00_663;
{ /* Llib/flac.scm 151 */
long BgL_objzd2classzd2numz00_634;
BgL_objzd2classzd2numz00_634 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_14)); 
{ /* Llib/flac.scm 151 */
obj_t BgL_arg1765z00_635;
BgL_arg1765z00_635 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2writezd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 151 */
int BgL_offsetz00_638;
BgL_offsetz00_638 = 
(int)(BgL_objzd2classzd2numz00_634); 
{ /* Llib/flac.scm 151 */
long BgL_offsetz00_639;
BgL_offsetz00_639 = 
(
(long)(BgL_offsetz00_638)-OBJECT_TYPE); 
{ /* Llib/flac.scm 151 */
long BgL_modz00_640;
BgL_modz00_640 = 
(BgL_offsetz00_639 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 151 */
long BgL_restz00_642;
BgL_restz00_642 = 
(BgL_offsetz00_639 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 151 */

{ /* Llib/flac.scm 151 */
obj_t BgL_bucketz00_644;
BgL_bucketz00_644 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_635),BgL_modz00_640); 
BgL_res1691z00_663 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_644),BgL_restz00_642); } } } } } } } } 
BgL_method1125z00_356 = BgL_res1691z00_663; } 
return 
PROCEDURE_ENTRY(BgL_method1125z00_356)(BgL_method1125z00_356, 
((obj_t)BgL_oz00_14), 
BINT(BgL_blocksiza7eza7_15), 
BINT(BgL_sratez00_16), 
BINT(BgL_channelsz00_17), 
BINT(BgL_bpsz00_18), BEOA);} } 

}



/* &flac-decoder-write */
obj_t BGl_z62flaczd2decoderzd2writez62zz__flac_flacz00(obj_t BgL_envz00_1094, obj_t BgL_oz00_1095, obj_t BgL_blocksiza7eza7_1096, obj_t BgL_sratez00_1097, obj_t BgL_channelsz00_1098, obj_t BgL_bpsz00_1099)
{
{ /* Llib/flac.scm 151 */
{ /* Llib/flac.scm 151 */
long BgL_auxz00_2109;long BgL_auxz00_2100;long BgL_auxz00_2091;long BgL_auxz00_2082;BgL_flaczd2decoderzd2_bglt BgL_auxz00_2074;
{ /* Llib/flac.scm 151 */
obj_t BgL_tmpz00_2110;
if(
INTEGERP(BgL_bpsz00_1099))
{ /* Llib/flac.scm 151 */
BgL_tmpz00_2110 = BgL_bpsz00_1099
; }  else 
{ 
obj_t BgL_auxz00_2113;
BgL_auxz00_2113 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7047)), BGl_string1871z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_bpsz00_1099); 
FAILURE(BgL_auxz00_2113,BFALSE,BFALSE);} 
BgL_auxz00_2109 = 
(long)CINT(BgL_tmpz00_2110); } 
{ /* Llib/flac.scm 151 */
obj_t BgL_tmpz00_2101;
if(
INTEGERP(BgL_channelsz00_1098))
{ /* Llib/flac.scm 151 */
BgL_tmpz00_2101 = BgL_channelsz00_1098
; }  else 
{ 
obj_t BgL_auxz00_2104;
BgL_auxz00_2104 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7047)), BGl_string1871z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_channelsz00_1098); 
FAILURE(BgL_auxz00_2104,BFALSE,BFALSE);} 
BgL_auxz00_2100 = 
(long)CINT(BgL_tmpz00_2101); } 
{ /* Llib/flac.scm 151 */
obj_t BgL_tmpz00_2092;
if(
INTEGERP(BgL_sratez00_1097))
{ /* Llib/flac.scm 151 */
BgL_tmpz00_2092 = BgL_sratez00_1097
; }  else 
{ 
obj_t BgL_auxz00_2095;
BgL_auxz00_2095 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7047)), BGl_string1871z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_sratez00_1097); 
FAILURE(BgL_auxz00_2095,BFALSE,BFALSE);} 
BgL_auxz00_2091 = 
(long)CINT(BgL_tmpz00_2092); } 
{ /* Llib/flac.scm 151 */
obj_t BgL_tmpz00_2083;
if(
INTEGERP(BgL_blocksiza7eza7_1096))
{ /* Llib/flac.scm 151 */
BgL_tmpz00_2083 = BgL_blocksiza7eza7_1096
; }  else 
{ 
obj_t BgL_auxz00_2086;
BgL_auxz00_2086 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7047)), BGl_string1871z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_blocksiza7eza7_1096); 
FAILURE(BgL_auxz00_2086,BFALSE,BFALSE);} 
BgL_auxz00_2082 = 
(long)CINT(BgL_tmpz00_2083); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1095, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 151 */
BgL_auxz00_2074 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1095)
; }  else 
{ 
obj_t BgL_auxz00_2078;
BgL_auxz00_2078 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7047)), BGl_string1871z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1095); 
FAILURE(BgL_auxz00_2078,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_write(BgL_auxz00_2074, BgL_auxz00_2082, BgL_auxz00_2091, BgL_auxz00_2100, BgL_auxz00_2109);} } 

}



/* flac-decoder-metadata */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_metadata(BgL_flaczd2decoderzd2_bglt BgL_oz00_19, BGL_LONGLONG_T BgL_totalz00_20, long BgL_sratez00_21, long BgL_channelsz00_22, long BgL_bpsz00_23)
{
{ /* Llib/flac.scm 160 */
{ /* Llib/flac.scm 160 */
obj_t BgL_method1127z00_357;
{ /* Llib/flac.scm 160 */
obj_t BgL_res1696z00_694;
{ /* Llib/flac.scm 160 */
long BgL_objzd2classzd2numz00_665;
BgL_objzd2classzd2numz00_665 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_19)); 
{ /* Llib/flac.scm 160 */
obj_t BgL_arg1765z00_666;
BgL_arg1765z00_666 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2metadatazd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 160 */
int BgL_offsetz00_669;
BgL_offsetz00_669 = 
(int)(BgL_objzd2classzd2numz00_665); 
{ /* Llib/flac.scm 160 */
long BgL_offsetz00_670;
BgL_offsetz00_670 = 
(
(long)(BgL_offsetz00_669)-OBJECT_TYPE); 
{ /* Llib/flac.scm 160 */
long BgL_modz00_671;
BgL_modz00_671 = 
(BgL_offsetz00_670 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 160 */
long BgL_restz00_673;
BgL_restz00_673 = 
(BgL_offsetz00_670 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 160 */

{ /* Llib/flac.scm 160 */
obj_t BgL_bucketz00_675;
BgL_bucketz00_675 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_666),BgL_modz00_671); 
BgL_res1696z00_694 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_675),BgL_restz00_673); } } } } } } } } 
BgL_method1127z00_357 = BgL_res1696z00_694; } 
return 
PROCEDURE_ENTRY(BgL_method1127z00_357)(BgL_method1127z00_357, 
((obj_t)BgL_oz00_19), 
make_bllong(BgL_totalz00_20), 
BINT(BgL_sratez00_21), 
BINT(BgL_channelsz00_22), 
BINT(BgL_bpsz00_23), BEOA);} } 

}



/* &flac-decoder-metadata */
obj_t BGl_z62flaczd2decoderzd2metadataz62zz__flac_flacz00(obj_t BgL_envz00_1100, obj_t BgL_oz00_1101, obj_t BgL_totalz00_1102, obj_t BgL_sratez00_1103, obj_t BgL_channelsz00_1104, obj_t BgL_bpsz00_1105)
{
{ /* Llib/flac.scm 160 */
{ /* Llib/flac.scm 160 */
long BgL_auxz00_2192;long BgL_auxz00_2183;long BgL_auxz00_2174;BGL_LONGLONG_T BgL_auxz00_2165;BgL_flaczd2decoderzd2_bglt BgL_auxz00_2157;
{ /* Llib/flac.scm 160 */
obj_t BgL_tmpz00_2193;
if(
INTEGERP(BgL_bpsz00_1105))
{ /* Llib/flac.scm 160 */
BgL_tmpz00_2193 = BgL_bpsz00_1105
; }  else 
{ 
obj_t BgL_auxz00_2196;
BgL_auxz00_2196 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7397)), BGl_string1872z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_bpsz00_1105); 
FAILURE(BgL_auxz00_2196,BFALSE,BFALSE);} 
BgL_auxz00_2192 = 
(long)CINT(BgL_tmpz00_2193); } 
{ /* Llib/flac.scm 160 */
obj_t BgL_tmpz00_2184;
if(
INTEGERP(BgL_channelsz00_1104))
{ /* Llib/flac.scm 160 */
BgL_tmpz00_2184 = BgL_channelsz00_1104
; }  else 
{ 
obj_t BgL_auxz00_2187;
BgL_auxz00_2187 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7397)), BGl_string1872z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_channelsz00_1104); 
FAILURE(BgL_auxz00_2187,BFALSE,BFALSE);} 
BgL_auxz00_2183 = 
(long)CINT(BgL_tmpz00_2184); } 
{ /* Llib/flac.scm 160 */
obj_t BgL_tmpz00_2175;
if(
INTEGERP(BgL_sratez00_1103))
{ /* Llib/flac.scm 160 */
BgL_tmpz00_2175 = BgL_sratez00_1103
; }  else 
{ 
obj_t BgL_auxz00_2178;
BgL_auxz00_2178 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7397)), BGl_string1872z00zz__flac_flacz00, BGl_string1870z00zz__flac_flacz00, BgL_sratez00_1103); 
FAILURE(BgL_auxz00_2178,BFALSE,BFALSE);} 
BgL_auxz00_2174 = 
(long)CINT(BgL_tmpz00_2175); } 
{ /* Llib/flac.scm 160 */
obj_t BgL_tmpz00_2166;
if(
LLONGP(BgL_totalz00_1102))
{ /* Llib/flac.scm 160 */
BgL_tmpz00_2166 = BgL_totalz00_1102
; }  else 
{ 
obj_t BgL_auxz00_2169;
BgL_auxz00_2169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7397)), BGl_string1872z00zz__flac_flacz00, BGl_string1873z00zz__flac_flacz00, BgL_totalz00_1102); 
FAILURE(BgL_auxz00_2169,BFALSE,BFALSE);} 
BgL_auxz00_2165 = 
BLLONG_TO_LLONG(BgL_tmpz00_2166); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1101, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 160 */
BgL_auxz00_2157 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1101)
; }  else 
{ 
obj_t BgL_auxz00_2161;
BgL_auxz00_2161 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7397)), BGl_string1872z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1101); 
FAILURE(BgL_auxz00_2161,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_metadata(BgL_auxz00_2157, BgL_auxz00_2165, BgL_auxz00_2174, BgL_auxz00_2183, BgL_auxz00_2192);} } 

}



/* flac-decoder-tell */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_tell(BgL_flaczd2decoderzd2_bglt BgL_oz00_24)
{
{ /* Llib/flac.scm 169 */
{ /* Llib/flac.scm 169 */
obj_t BgL_method1129z00_358;
{ /* Llib/flac.scm 169 */
obj_t BgL_res1701z00_725;
{ /* Llib/flac.scm 169 */
long BgL_objzd2classzd2numz00_696;
BgL_objzd2classzd2numz00_696 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_24)); 
{ /* Llib/flac.scm 169 */
obj_t BgL_arg1765z00_697;
BgL_arg1765z00_697 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2tellzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 169 */
int BgL_offsetz00_700;
BgL_offsetz00_700 = 
(int)(BgL_objzd2classzd2numz00_696); 
{ /* Llib/flac.scm 169 */
long BgL_offsetz00_701;
BgL_offsetz00_701 = 
(
(long)(BgL_offsetz00_700)-OBJECT_TYPE); 
{ /* Llib/flac.scm 169 */
long BgL_modz00_702;
BgL_modz00_702 = 
(BgL_offsetz00_701 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 169 */
long BgL_restz00_704;
BgL_restz00_704 = 
(BgL_offsetz00_701 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 169 */

{ /* Llib/flac.scm 169 */
obj_t BgL_bucketz00_706;
BgL_bucketz00_706 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_697),BgL_modz00_702); 
BgL_res1701z00_725 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_706),BgL_restz00_704); } } } } } } } } 
BgL_method1129z00_358 = BgL_res1701z00_725; } 
return 
PROCEDURE_ENTRY(BgL_method1129z00_358)(BgL_method1129z00_358, 
((obj_t)BgL_oz00_24), BEOA);} } 

}



/* &flac-decoder-tell */
obj_t BGl_z62flaczd2decoderzd2tellz62zz__flac_flacz00(obj_t BgL_envz00_1106, obj_t BgL_oz00_1107)
{
{ /* Llib/flac.scm 169 */
{ /* Llib/flac.scm 169 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2232;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1107, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 169 */
BgL_auxz00_2232 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1107)
; }  else 
{ 
obj_t BgL_auxz00_2236;
BgL_auxz00_2236 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)7747)), BGl_string1874z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1107); 
FAILURE(BgL_auxz00_2236,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_tell(BgL_auxz00_2232);} } 

}



/* flac-decoder-seek */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_seek(BgL_flaczd2decoderzd2_bglt BgL_oz00_25, BGL_LONGLONG_T BgL_offsetz00_26)
{
{ /* Llib/flac.scm 175 */
{ /* Llib/flac.scm 175 */
obj_t BgL_method1131z00_359;
{ /* Llib/flac.scm 175 */
obj_t BgL_res1706z00_756;
{ /* Llib/flac.scm 175 */
long BgL_objzd2classzd2numz00_727;
BgL_objzd2classzd2numz00_727 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_25)); 
{ /* Llib/flac.scm 175 */
obj_t BgL_arg1765z00_728;
BgL_arg1765z00_728 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2seekzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 175 */
int BgL_offsetz00_731;
BgL_offsetz00_731 = 
(int)(BgL_objzd2classzd2numz00_727); 
{ /* Llib/flac.scm 175 */
long BgL_offsetz00_732;
BgL_offsetz00_732 = 
(
(long)(BgL_offsetz00_731)-OBJECT_TYPE); 
{ /* Llib/flac.scm 175 */
long BgL_modz00_733;
BgL_modz00_733 = 
(BgL_offsetz00_732 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 175 */
long BgL_restz00_735;
BgL_restz00_735 = 
(BgL_offsetz00_732 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 175 */

{ /* Llib/flac.scm 175 */
obj_t BgL_bucketz00_737;
BgL_bucketz00_737 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_728),BgL_modz00_733); 
BgL_res1706z00_756 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_737),BgL_restz00_735); } } } } } } } } 
BgL_method1131z00_359 = BgL_res1706z00_756; } 
return 
PROCEDURE_ENTRY(BgL_method1131z00_359)(BgL_method1131z00_359, 
((obj_t)BgL_oz00_25), 
make_bllong(BgL_offsetz00_26), BEOA);} } 

}



/* &flac-decoder-seek */
obj_t BGl_z62flaczd2decoderzd2seekz62zz__flac_flacz00(obj_t BgL_envz00_1108, obj_t BgL_oz00_1109, obj_t BgL_offsetz00_1110)
{
{ /* Llib/flac.scm 175 */
{ /* Llib/flac.scm 175 */
BGL_LONGLONG_T BgL_auxz00_2281;BgL_flaczd2decoderzd2_bglt BgL_auxz00_2273;
{ /* Llib/flac.scm 175 */
obj_t BgL_tmpz00_2282;
if(
LLONGP(BgL_offsetz00_1110))
{ /* Llib/flac.scm 175 */
BgL_tmpz00_2282 = BgL_offsetz00_1110
; }  else 
{ 
obj_t BgL_auxz00_2285;
BgL_auxz00_2285 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)8029)), BGl_string1875z00zz__flac_flacz00, BGl_string1873z00zz__flac_flacz00, BgL_offsetz00_1110); 
FAILURE(BgL_auxz00_2285,BFALSE,BFALSE);} 
BgL_auxz00_2281 = 
BLLONG_TO_LLONG(BgL_tmpz00_2282); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1109, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 175 */
BgL_auxz00_2273 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1109)
; }  else 
{ 
obj_t BgL_auxz00_2277;
BgL_auxz00_2277 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)8029)), BGl_string1875z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1109); 
FAILURE(BgL_auxz00_2277,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_seek(BgL_auxz00_2273, BgL_auxz00_2281);} } 

}



/* flac-decoder-length */
BGL_EXPORTED_DEF obj_t bgl_flac_decoder_length(BgL_flaczd2decoderzd2_bglt BgL_oz00_27)
{
{ /* Llib/flac.scm 181 */
{ /* Llib/flac.scm 181 */
obj_t BgL_method1133z00_360;
{ /* Llib/flac.scm 181 */
obj_t BgL_res1711z00_787;
{ /* Llib/flac.scm 181 */
long BgL_objzd2classzd2numz00_758;
BgL_objzd2classzd2numz00_758 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_27)); 
{ /* Llib/flac.scm 181 */
obj_t BgL_arg1765z00_759;
BgL_arg1765z00_759 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2lengthzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 181 */
int BgL_offsetz00_762;
BgL_offsetz00_762 = 
(int)(BgL_objzd2classzd2numz00_758); 
{ /* Llib/flac.scm 181 */
long BgL_offsetz00_763;
BgL_offsetz00_763 = 
(
(long)(BgL_offsetz00_762)-OBJECT_TYPE); 
{ /* Llib/flac.scm 181 */
long BgL_modz00_764;
BgL_modz00_764 = 
(BgL_offsetz00_763 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 181 */
long BgL_restz00_766;
BgL_restz00_766 = 
(BgL_offsetz00_763 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 181 */

{ /* Llib/flac.scm 181 */
obj_t BgL_bucketz00_768;
BgL_bucketz00_768 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_759),BgL_modz00_764); 
BgL_res1711z00_787 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_768),BgL_restz00_766); } } } } } } } } 
BgL_method1133z00_360 = BgL_res1711z00_787; } 
return 
PROCEDURE_ENTRY(BgL_method1133z00_360)(BgL_method1133z00_360, 
((obj_t)BgL_oz00_27), BEOA);} } 

}



/* &flac-decoder-length */
obj_t BGl_z62flaczd2decoderzd2lengthz62zz__flac_flacz00(obj_t BgL_envz00_1111, obj_t BgL_oz00_1112)
{
{ /* Llib/flac.scm 181 */
{ /* Llib/flac.scm 181 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2321;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1112, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 181 */
BgL_auxz00_2321 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1112)
; }  else 
{ 
obj_t BgL_auxz00_2325;
BgL_auxz00_2325 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)8318)), BGl_string1876z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1112); 
FAILURE(BgL_auxz00_2325,BFALSE,BFALSE);} 
return 
bgl_flac_decoder_length(BgL_auxz00_2321);} } 

}



/* flac-decoder-info */
BGL_EXPORTED_DEF long BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_oz00_28)
{
{ /* Llib/flac.scm 187 */
{ /* Llib/flac.scm 187 */
obj_t BgL_method1135z00_361;
{ /* Llib/flac.scm 187 */
obj_t BgL_res1716z00_818;
{ /* Llib/flac.scm 187 */
long BgL_objzd2classzd2numz00_789;
BgL_objzd2classzd2numz00_789 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_28)); 
{ /* Llib/flac.scm 187 */
obj_t BgL_arg1765z00_790;
BgL_arg1765z00_790 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2infozd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 187 */
int BgL_offsetz00_793;
BgL_offsetz00_793 = 
(int)(BgL_objzd2classzd2numz00_789); 
{ /* Llib/flac.scm 187 */
long BgL_offsetz00_794;
BgL_offsetz00_794 = 
(
(long)(BgL_offsetz00_793)-OBJECT_TYPE); 
{ /* Llib/flac.scm 187 */
long BgL_modz00_795;
BgL_modz00_795 = 
(BgL_offsetz00_794 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 187 */
long BgL_restz00_797;
BgL_restz00_797 = 
(BgL_offsetz00_794 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 187 */

{ /* Llib/flac.scm 187 */
obj_t BgL_bucketz00_799;
BgL_bucketz00_799 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_790),BgL_modz00_795); 
BgL_res1716z00_818 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_799),BgL_restz00_797); } } } } } } } } 
BgL_method1135z00_361 = BgL_res1716z00_818; } 
return 
(long)CINT(
PROCEDURE_ENTRY(BgL_method1135z00_361)(BgL_method1135z00_361, 
((obj_t)BgL_oz00_28), BEOA));} } 

}



/* &flac-decoder-info */
obj_t BGl_z62flaczd2decoderzd2infoz62zz__flac_flacz00(obj_t BgL_envz00_1113, obj_t BgL_oz00_1114)
{
{ /* Llib/flac.scm 187 */
{ /* Llib/flac.scm 187 */
long BgL_tmpz00_2361;
{ /* Llib/flac.scm 187 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2362;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1114, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 187 */
BgL_auxz00_2362 = 
((BgL_flaczd2decoderzd2_bglt)BgL_oz00_1114)
; }  else 
{ 
obj_t BgL_auxz00_2366;
BgL_auxz00_2366 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)8602)), BGl_string1877z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_oz00_1114); 
FAILURE(BgL_auxz00_2366,BFALSE,BFALSE);} 
BgL_tmpz00_2361 = 
BGl_flaczd2decoderzd2infoz00zz__flac_flacz00(BgL_auxz00_2362); } 
return 
BINT(BgL_tmpz00_2361);} } 

}



/* flac-decoder-position */
BGL_EXPORTED_DEF long BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_mz00_31)
{
{ /* Llib/flac.scm 239 */
{ /* Llib/flac.scm 239 */
obj_t BgL_method1137z00_362;
{ /* Llib/flac.scm 239 */
obj_t BgL_res1721z00_849;
{ /* Llib/flac.scm 239 */
long BgL_objzd2classzd2numz00_820;
BgL_objzd2classzd2numz00_820 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mz00_31)); 
{ /* Llib/flac.scm 239 */
obj_t BgL_arg1765z00_821;
BgL_arg1765z00_821 = 
PROCEDURE_REF(BGl_flaczd2decoderzd2positionzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 239 */
int BgL_offsetz00_824;
BgL_offsetz00_824 = 
(int)(BgL_objzd2classzd2numz00_820); 
{ /* Llib/flac.scm 239 */
long BgL_offsetz00_825;
BgL_offsetz00_825 = 
(
(long)(BgL_offsetz00_824)-OBJECT_TYPE); 
{ /* Llib/flac.scm 239 */
long BgL_modz00_826;
BgL_modz00_826 = 
(BgL_offsetz00_825 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 239 */
long BgL_restz00_828;
BgL_restz00_828 = 
(BgL_offsetz00_825 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 239 */

{ /* Llib/flac.scm 239 */
obj_t BgL_bucketz00_830;
BgL_bucketz00_830 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_821),BgL_modz00_826); 
BgL_res1721z00_849 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_830),BgL_restz00_828); } } } } } } } } 
BgL_method1137z00_362 = BgL_res1721z00_849; } 
return 
(long)CINT(
PROCEDURE_ENTRY(BgL_method1137z00_362)(BgL_method1137z00_362, 
((obj_t)BgL_mz00_31), BEOA));} } 

}



/* &flac-decoder-position */
obj_t BGl_z62flaczd2decoderzd2positionz62zz__flac_flacz00(obj_t BgL_envz00_1115, obj_t BgL_mz00_1116)
{
{ /* Llib/flac.scm 239 */
{ /* Llib/flac.scm 239 */
long BgL_tmpz00_2403;
{ /* Llib/flac.scm 239 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2404;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_1116, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 239 */
BgL_auxz00_2404 = 
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1116)
; }  else 
{ 
obj_t BgL_auxz00_2408;
BgL_auxz00_2408 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)10869)), BGl_string1878z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_mz00_1116); 
FAILURE(BgL_auxz00_2408,BFALSE,BFALSE);} 
BgL_tmpz00_2403 = 
BGl_flaczd2decoderzd2positionz00zz__flac_flacz00(BgL_auxz00_2404); } 
return 
BINT(BgL_tmpz00_2403);} } 

}



/* flac-volume-get */
BGL_EXPORTED_DEF obj_t BGl_flaczd2volumezd2getz00zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_mz00_32)
{
{ /* Llib/flac.scm 251 */
{ /* Llib/flac.scm 251 */
obj_t BgL_method1139z00_363;
{ /* Llib/flac.scm 251 */
obj_t BgL_res1726z00_880;
{ /* Llib/flac.scm 251 */
long BgL_objzd2classzd2numz00_851;
BgL_objzd2classzd2numz00_851 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mz00_32)); 
{ /* Llib/flac.scm 251 */
obj_t BgL_arg1765z00_852;
BgL_arg1765z00_852 = 
PROCEDURE_REF(BGl_flaczd2volumezd2getzd2envzd2zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 251 */
int BgL_offsetz00_855;
BgL_offsetz00_855 = 
(int)(BgL_objzd2classzd2numz00_851); 
{ /* Llib/flac.scm 251 */
long BgL_offsetz00_856;
BgL_offsetz00_856 = 
(
(long)(BgL_offsetz00_855)-OBJECT_TYPE); 
{ /* Llib/flac.scm 251 */
long BgL_modz00_857;
BgL_modz00_857 = 
(BgL_offsetz00_856 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 251 */
long BgL_restz00_859;
BgL_restz00_859 = 
(BgL_offsetz00_856 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 251 */

{ /* Llib/flac.scm 251 */
obj_t BgL_bucketz00_861;
BgL_bucketz00_861 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_852),BgL_modz00_857); 
BgL_res1726z00_880 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_861),BgL_restz00_859); } } } } } } } } 
BgL_method1139z00_363 = BgL_res1726z00_880; } 
return 
PROCEDURE_ENTRY(BgL_method1139z00_363)(BgL_method1139z00_363, 
((obj_t)BgL_mz00_32), BEOA);} } 

}



/* &flac-volume-get */
obj_t BGl_z62flaczd2volumezd2getz62zz__flac_flacz00(obj_t BgL_envz00_1117, obj_t BgL_mz00_1118)
{
{ /* Llib/flac.scm 251 */
{ /* Llib/flac.scm 251 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2444;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_1118, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 251 */
BgL_auxz00_2444 = 
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1118)
; }  else 
{ 
obj_t BgL_auxz00_2448;
BgL_auxz00_2448 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)11346)), BGl_string1879z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_mz00_1118); 
FAILURE(BgL_auxz00_2448,BFALSE,BFALSE);} 
return 
BGl_flaczd2volumezd2getz00zz__flac_flacz00(BgL_auxz00_2444);} } 

}



/* flac-volume-set! */
BGL_EXPORTED_DEF obj_t BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(BgL_flaczd2decoderzd2_bglt BgL_mz00_33, obj_t BgL_volz00_34)
{
{ /* Llib/flac.scm 258 */
{ /* Llib/flac.scm 258 */
obj_t BgL_method1141z00_364;
{ /* Llib/flac.scm 258 */
obj_t BgL_res1731z00_911;
{ /* Llib/flac.scm 258 */
long BgL_objzd2classzd2numz00_882;
BgL_objzd2classzd2numz00_882 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mz00_33)); 
{ /* Llib/flac.scm 258 */
obj_t BgL_arg1765z00_883;
BgL_arg1765z00_883 = 
PROCEDURE_REF(BGl_flaczd2volumezd2setz12zd2envzc0zz__flac_flacz00, 
(int)(((long)1))); 
{ /* Llib/flac.scm 258 */
int BgL_offsetz00_886;
BgL_offsetz00_886 = 
(int)(BgL_objzd2classzd2numz00_882); 
{ /* Llib/flac.scm 258 */
long BgL_offsetz00_887;
BgL_offsetz00_887 = 
(
(long)(BgL_offsetz00_886)-OBJECT_TYPE); 
{ /* Llib/flac.scm 258 */
long BgL_modz00_888;
BgL_modz00_888 = 
(BgL_offsetz00_887 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/flac.scm 258 */
long BgL_restz00_890;
BgL_restz00_890 = 
(BgL_offsetz00_887 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/flac.scm 258 */

{ /* Llib/flac.scm 258 */
obj_t BgL_bucketz00_892;
BgL_bucketz00_892 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_883),BgL_modz00_888); 
BgL_res1731z00_911 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_892),BgL_restz00_890); } } } } } } } } 
BgL_method1141z00_364 = BgL_res1731z00_911; } 
return 
PROCEDURE_ENTRY(BgL_method1141z00_364)(BgL_method1141z00_364, 
((obj_t)BgL_mz00_33), BgL_volz00_34, BEOA);} } 

}



/* &flac-volume-set! */
obj_t BGl_z62flaczd2volumezd2setz12z70zz__flac_flacz00(obj_t BgL_envz00_1119, obj_t BgL_mz00_1120, obj_t BgL_volz00_1121)
{
{ /* Llib/flac.scm 258 */
{ /* Llib/flac.scm 258 */
BgL_flaczd2decoderzd2_bglt BgL_auxz00_2484;
if(
BGl_isazf3zf3zz__objectz00(BgL_mz00_1120, BGl_flaczd2decoderzd2zz__flac_flacz00))
{ /* Llib/flac.scm 258 */
BgL_auxz00_2484 = 
((BgL_flaczd2decoderzd2_bglt)BgL_mz00_1120)
; }  else 
{ 
obj_t BgL_auxz00_2488;
BgL_auxz00_2488 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1796z00zz__flac_flacz00, 
BINT(((long)11714)), BGl_string1880z00zz__flac_flacz00, BGl_string1864z00zz__flac_flacz00, BgL_mz00_1120); 
FAILURE(BgL_auxz00_2488,BFALSE,BFALSE);} 
return 
BGl_flaczd2volumezd2setz12z12zz__flac_flacz00(BgL_auxz00_2484, BgL_volz00_1121);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__flac_flacz00()
{
{ /* Llib/flac.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_flaczd2decoderzd2zz__flac_flacz00, BGl_proc1881z00zz__flac_flacz00, BGl_string1882z00zz__flac_flacz00);} 

}



/* &object-print-flac-de1111 */
obj_t BGl_z62objectzd2printzd2flaczd2de1111zb0zz__flac_flacz00(obj_t BgL_envz00_1123, obj_t BgL_oz00_1124, obj_t BgL_portz00_1125, obj_t BgL_printzd2slotzd2_1126)
{
{ /* Llib/flac.scm 71 */
{ /* Llib/flac.scm 72 */
obj_t BgL_tmpz00_2494;
BgL_tmpz00_2494 = 
((obj_t)BgL_portz00_1125); 
return 
bgl_display_string(BGl_string1883z00zz__flac_flacz00, BgL_tmpz00_2494);} } 

}

#ifdef __cplusplus
}
#endif
