/*===========================================================================*/
/*   (Llib/uvtypes.scm)                                                      */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -srfi libuv -copt  -DBGL_DUMMY -safee -unsafe -copt -fPIC -copt -IClib Llib/uvtypes.scm -o objs/uvtypes.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <uv.h>
#include <buv.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z52uvz52_bgl {
   header_t header;
   obj_t widening;
} *BgL_z52uvz52_bglt;

typedef struct BgL_uvhandlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
} *BgL_uvhandlez00_bglt;

typedef struct BgL_uvloopz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z52mutexz52;
} *BgL_uvloopz00_bglt;

typedef struct BgL_uvwatcherz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvwatcherz00_bglt;

typedef struct BgL_uvstreamz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvstreamz00_bglt;

typedef struct BgL_uvtcpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvtcpz00_bglt;

typedef struct BgL_uvudpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   obj_t BgL_z52procmz52;
} *BgL_uvudpz00_bglt;

typedef struct BgL_uvpipez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   bool_t BgL_ipcz00;
} *BgL_uvpipez00_bglt;

typedef struct BgL_uvttyz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   int BgL_fdz00;
   bool_t BgL_readablez00;
} *BgL_uvttyz00_bglt;

typedef struct BgL_uvtimerz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   uint64_t BgL_repeatz00;
   bool_t BgL_refz00;
} *BgL_uvtimerz00_bglt;

typedef struct BgL_uvidlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvidlez00_bglt;

typedef struct BgL_uvasyncz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvasyncz00_bglt;

typedef struct BgL_uvpollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   int BgL_fdz00;
} *BgL_uvpollz00_bglt;

typedef struct BgL_uvfilez00_bgl {
   header_t header;
   obj_t widening;
   int BgL_fdz00;
   obj_t BgL_pathz00;
} *BgL_uvfilez00_bglt;

typedef struct BgL_uvfseventz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfseventz00_bglt;

typedef struct BgL_uvfspollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfspollz00_bglt;

typedef struct BgL_uvcheckz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvcheckz00_bglt;

typedef struct BgL_uvprocessz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z42onexitz42;
} *BgL_uvprocessz00_bglt;

typedef struct BgL_uvprocessoptionsz00_bgl {
   header_t header;
   obj_t widening;
   uv_process_options_t * BgL_z42builtinz42;
} *BgL_uvprocessoptionsz00_bglt;

typedef struct BgL_uvworkz00_bgl {
   header_t header;
   obj_t widening;
   uv_work_t * BgL_z42builtinz42;
   obj_t BgL_z52workzd2cbz80;
   obj_t BgL_z52afterzd2cbz80;
} *BgL_uvworkz00_bglt;


static BgL_uvtimerz00_bglt BGl_z62lambda1928z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt, obj_t);
static BgL_uvtimerz00_bglt BGl_z62lambda1931z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31684ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1851z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1852z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1773z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1938z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1939z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31790ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1860z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1781z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1782z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1863z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1945z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1946z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL char * BGl_uvzd2versionzd2zz__libuv_typesz00();
static BgL_uvwatcherz00_bglt BGl_z62lambda1788z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_handle_type_symbol(int);
static BgL_uvudpz00_bglt BGl_z62lambda1871z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_guess_handle(int);
static BgL_uvidlez00_bglt BGl_z62lambda1953z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvudpz00_bglt BGl_z62lambda1874z62zz__libuv_typesz00(obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1794z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvidlez00_bglt BGl_z62lambda1956z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1795z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_z62z52uvzd2init1338ze2zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTtyz00zz__libuv_typesz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31865ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1881z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1882z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvasyncz00_bglt BGl_z62lambda1964z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsPollz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvasyncz00_bglt BGl_z62lambda1967z62zz__libuv_typesz00(obj_t);
static BgL_uvpipez00_bglt BGl_z62lambda1889z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsEventz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza31947ze3ze5zz__libuv_typesz00(obj_t);
static BgL_uvpipez00_bglt BGl_z62lambda1892z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DECL bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt);
static BgL_uvpollz00_bglt BGl_z62lambda1975z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvpollz00_bglt BGl_z62lambda1978z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1898z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1899z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31883ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1984z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1985z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza32210ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32121ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32016ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza31876ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62lambda1991z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt, obj_t);
static obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62lambda1993z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1999z62zz__libuv_typesz00(obj_t, obj_t);
extern void bgl_uv_process_options_args_set(uv_process_options_t *, obj_t);
static obj_t BGl_z62zc3z04anonymousza32203ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31958ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvIdlez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32115ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31894ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt);
BGL_EXPORTED_DEF obj_t BGl_UvFilez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32027ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvHandlez00zz__libuv_typesz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_EXPORTED_DEF obj_t BGl_UvAsyncz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31969ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__libuv_typesz00();
BGL_EXPORTED_DEF obj_t BGl_UvLoopz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32061ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2namez00zz__objectz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvPipez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31995ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
static obj_t BGl_z62lambda2000z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2004z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2005z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32056ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfseventz00_bglt BGl_z62lambda2011z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvfseventz00_bglt BGl_z62lambda2014z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvWorkz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
BGL_IMPORT bool_t BGl_nilzf3zf3zz__objectz00(BgL_objectz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_UvProcessz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvfspollz00_bglt BGl_z62lambda2022z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00(obj_t, obj_t);
extern obj_t bgl_uv_process_options_args_get(uv_process_options_t *);
static BgL_uvfspollz00_bglt BGl_z62lambda2025z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvStreamz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_UvWatcherz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
extern obj_t bgl_uv_process_options_env_get(uv_process_options_t *);
static obj_t BGl_z62zc3z04anonymousza31702ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32180ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2033z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2036z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTcpz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_UvProcessOptionsz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvworkz00_bglt BGl_z62lambda2201z62zz__libuv_typesz00(obj_t);
static BgL_uvprocessz00_bglt BGl_z62lambda2044z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvprocessz00_bglt BGl_z62lambda2047z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda2209z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2214z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2215z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2054z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2055z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2219z62zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvPollz00zz__libuv_typesz00 = BUNSPEC;
extern void bgl_uv_process_options_env_set(uv_process_options_t *, obj_t);
static obj_t BGl_z62lambda2220z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31802ze3ze5zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvUdpz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31722ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2074z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32079ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2077z62zz__libuv_typesz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__libuv_typesz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int);
static obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza31715ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2084z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2085z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTimerz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL BgL_uvfilez00_bglt bgl_uv_new_file(int, obj_t);
static obj_t BGl_z62zc3z04anonymousza31813ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
BGL_EXPORTED_DECL obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int);
static obj_t BGl_z62objectzd2printzd2UvHandl1341z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31644ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32187ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2namezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static obj_t BGl_z62lambda1700z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1701z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31912ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvworkz00_bglt BGl_z62lambda2198z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1713z62zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62lambda1714z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_z52uvz52_bglt BGl_z62lambda1637z62zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1800z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1720z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1801z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1721z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00(obj_t);
static BgL_uvstreamz00_bglt BGl_z62lambda1808z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvstreamz00_bglt BGl_z62lambda1811z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31672ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31737ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1735z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1736z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1817z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1818z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1657z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvCheckz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_z52Uvz52zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31940ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1823z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1662z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1824z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvttyz00_bglt BGl_z62lambda1907z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvttyz00_bglt BGl_z62lambda1910z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1830z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1831z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1916z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1917z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1837z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1838z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31853ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1921z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1922z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1682z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1844z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1683z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1764z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1845z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t __cnst[ 71 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2guesszd2handlezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2guessza7d22419za7, BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2strerrorzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2strerror2420z00, BGl_z62uvzd2strerrorzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2300z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2421za7, BGl_z62zc3z04anonymousza31883ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2301z00zz__libuv_typesz00, BgL_bgl_za762lambda1882za7622422z00, BGl_z62lambda1882z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2302z00zz__libuv_typesz00, BgL_bgl_za762lambda1881za7622423z00, BGl_z62lambda1881z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2303z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2424za7, BGl_z62zc3z04anonymousza31876ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2304z00zz__libuv_typesz00, BgL_bgl_za762lambda1874za7622425z00, BGl_z62lambda1874z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2305z00zz__libuv_typesz00, BgL_bgl_za762lambda1871za7622426z00, BGl_z62lambda1871z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2306z00zz__libuv_typesz00, BgL_bgl_za762lambda1899za7622427z00, BGl_z62lambda1899z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2307z00zz__libuv_typesz00, BgL_bgl_za762lambda1898za7622428z00, BGl_z62lambda1898z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2308z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2429za7, BGl_z62zc3z04anonymousza31894ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2309z00zz__libuv_typesz00, BgL_bgl_za762lambda1892za7622430z00, BGl_z62lambda1892z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2310z00zz__libuv_typesz00, BgL_bgl_za762lambda1889za7622431z00, BGl_z62lambda1889z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2311z00zz__libuv_typesz00, BgL_bgl_za762lambda1917za7622432z00, BGl_z62lambda1917z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2312z00zz__libuv_typesz00, BgL_bgl_za762lambda1916za7622433z00, BGl_z62lambda1916z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2313z00zz__libuv_typesz00, BgL_bgl_za762lambda1922za7622434z00, BGl_z62lambda1922z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2314z00zz__libuv_typesz00, BgL_bgl_za762lambda1921za7622435z00, BGl_z62lambda1921z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2315z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2436za7, BGl_z62zc3z04anonymousza31912ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2316z00zz__libuv_typesz00, BgL_bgl_za762lambda1910za7622437z00, BGl_z62lambda1910z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2317z00zz__libuv_typesz00, BgL_bgl_za762lambda1907za7622438z00, BGl_z62lambda1907z62zz__libuv_typesz00, 0L, BUNSPEC, 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2318z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2439za7, BGl_z62zc3z04anonymousza31940ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2243z00zz__libuv_typesz00, BgL_bgl_string2243za700za7za7_2440za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2319z00zz__libuv_typesz00, BgL_bgl_za762lambda1939za7622441z00, BGl_z62lambda1939z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2408z00zz__libuv_typesz00, BgL_bgl_string2408za700za7za7_2442za7, "%uv-init1338", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2400z00zz__libuv_typesz00, BgL_bgl_za762lambda2215za7622443z00, BGl_z62lambda2215z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2401z00zz__libuv_typesz00, BgL_bgl_za762lambda2214za7622444z00, BGl_z62lambda2214z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2320z00zz__libuv_typesz00, BgL_bgl_za762lambda1938za7622445z00, BGl_z62lambda1938z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2402z00zz__libuv_typesz00, BgL_bgl_za762lambda2220za7622446z00, BGl_z62lambda2220z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2321z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2447za7, BGl_z62zc3z04anonymousza31947ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__libuv_typesz00, BgL_bgl_za762lambda2219za7622448z00, BGl_z62lambda2219z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2322z00zz__libuv_typesz00, BgL_bgl_za762lambda1946za7622449z00, BGl_z62lambda1946z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2410z00zz__libuv_typesz00, BgL_bgl_string2410za700za7za7_2450za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2451za7, BGl_z62zc3z04anonymousza32203ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2323z00zz__libuv_typesz00, BgL_bgl_za762lambda1945za7622452z00, BGl_z62lambda1945z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2411z00zz__libuv_typesz00, BgL_bgl_string2411za700za7za7_2453za7, " [", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2405z00zz__libuv_typesz00, BgL_bgl_za762lambda2201za7622454z00, BGl_z62lambda2201z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2324z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2455za7, BGl_z62zc3z04anonymousza31933ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2412z00zz__libuv_typesz00, BgL_bgl_string2412za700za7za7_2456za7, "#|", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2406z00zz__libuv_typesz00, BgL_bgl_za762lambda2198za7622457z00, BGl_z62lambda2198z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2325z00zz__libuv_typesz00, BgL_bgl_za762lambda1931za7622458z00, BGl_z62lambda1931z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2244z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2459za7, BGl_z62zc3z04anonymousza31644ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2413z00zz__libuv_typesz00, BgL_bgl_string2413za700za7za7_2460za7, " (0x", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2407z00zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2init12461za7, BGl_z62z52uvzd2init1338ze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2326z00zz__libuv_typesz00, BgL_bgl_za762lambda1928za7622462z00, BGl_z62lambda1928z62zz__libuv_typesz00, 0L, BUNSPEC, 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2245z00zz__libuv_typesz00, BgL_bgl_za762lambda1637za7622463z00, BGl_z62lambda1637z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2414z00zz__libuv_typesz00, BgL_bgl_string2414za700za7za7_2464za7, ")", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2327z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2465za7, BGl_z62zc3z04anonymousza31958ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2246z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2466za7, BGl_z62zc3z04anonymousza31684ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2415z00zz__libuv_typesz00, BgL_bgl_string2415za700za7za7_2467za7, " nil|", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__libuv_typesz00, BgL_bgl_za762objectza7d2prin2468z00, BGl_z62objectzd2printzd2UvHandl1341z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2328z00zz__libuv_typesz00, BgL_bgl_za762lambda1956za7622469z00, BGl_z62lambda1956z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2247z00zz__libuv_typesz00, BgL_bgl_za762lambda1683za7622470z00, BGl_z62lambda1683z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2416z00zz__libuv_typesz00, BgL_bgl_string2416za700za7za7_2471za7, "(#\\$ #\\%) UvWork %after-cb %work-cb $uv_work_t UvProcessOptions gid uid flags cwd env args file $uv_process_options_t UvProcess pid $onexit UvCheck UvFsPoll UvFsEvent UvFile bstring path UvPoll UvAsync UvIdle UvTimer ref uint64 repeat UvTty readable int fd UvPipe ipc UvUdp %procm UvTcp UvStream %callback %procc %proca %offset %alloc UvWatcher procedure cb loop UvLoop mutex %mutex UvHandle bool closed %gcmarkstail pair-nil %gcmarkshead obj %onclose $uv_handle_t $builtin __libuv_types %Uv UNDEFINED UNKNOWN FILE PIPE UDP TTY TCP ", 532 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2329z00zz__libuv_typesz00, BgL_bgl_za762lambda1953za7622472z00, BGl_z62lambda1953z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2248z00zz__libuv_typesz00, BgL_bgl_za762lambda1682za7622473z00, BGl_z62lambda1682z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2249z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2474za7, BGl_z62zc3z04anonymousza31702ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2330z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2475za7, BGl_z62zc3z04anonymousza31969ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2331z00zz__libuv_typesz00, BgL_bgl_za762lambda1967za7622476z00, BGl_z62lambda1967z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2250z00zz__libuv_typesz00, BgL_bgl_za762lambda1701za7622477z00, BGl_z62lambda1701z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2332z00zz__libuv_typesz00, BgL_bgl_za762lambda1964za7622478z00, BGl_z62lambda1964z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2251z00zz__libuv_typesz00, BgL_bgl_za762lambda1700za7622479z00, BGl_z62lambda1700z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2333z00zz__libuv_typesz00, BgL_bgl_za762lambda1985za7622480z00, BGl_z62lambda1985z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2252z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2481za7, BGl_z62zc3z04anonymousza31715ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2334z00zz__libuv_typesz00, BgL_bgl_za762lambda1984za7622482z00, BGl_z62lambda1984z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2253z00zz__libuv_typesz00, BgL_bgl_za762lambda1714za7622483z00, BGl_z62lambda1714z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2335z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2484za7, BGl_z62zc3z04anonymousza31980ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2254z00zz__libuv_typesz00, BgL_bgl_za762lambda1713za7622485z00, BGl_z62lambda1713z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2336z00zz__libuv_typesz00, BgL_bgl_za762lambda1978za7622486z00, BGl_z62lambda1978z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2255z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2487za7, BGl_z62zc3z04anonymousza31722ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2337z00zz__libuv_typesz00, BgL_bgl_za762lambda1975za7622488z00, BGl_z62lambda1975z62zz__libuv_typesz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2256z00zz__libuv_typesz00, BgL_bgl_za762lambda1721za7622489z00, BGl_z62lambda1721z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2338z00zz__libuv_typesz00, BgL_bgl_za762lambda2000za7622490z00, BGl_z62lambda2000z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2257z00zz__libuv_typesz00, BgL_bgl_za762lambda1720za7622491z00, BGl_z62lambda1720z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2339z00zz__libuv_typesz00, BgL_bgl_za762lambda1999za7622492z00, BGl_z62lambda1999z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2258z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2493za7, BGl_z62zc3z04anonymousza31737ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2259z00zz__libuv_typesz00, BgL_bgl_za762lambda1736za7622494z00, BGl_z62lambda1736z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2340z00zz__libuv_typesz00, BgL_bgl_za762lambda2005za7622495z00, BGl_z62lambda2005z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2341z00zz__libuv_typesz00, BgL_bgl_za762lambda2004za7622496z00, BGl_z62lambda2004z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2260z00zz__libuv_typesz00, BgL_bgl_za762lambda1735za7622497z00, BGl_z62lambda1735z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2342z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2498za7, BGl_z62zc3z04anonymousza31995ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2261z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2499za7, BGl_z62zc3z04anonymousza31672ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2343z00zz__libuv_typesz00, BgL_bgl_za762lambda1993za7622500z00, BGl_z62lambda1993z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2262z00zz__libuv_typesz00, BgL_bgl_za762lambda1662za7622501z00, BGl_z62lambda1662z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2popzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2popza7d2gc2502za7, BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2344z00zz__libuv_typesz00, BgL_bgl_za762lambda1991za7622503z00, BGl_z62lambda1991z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2263z00zz__libuv_typesz00, BgL_bgl_za762lambda1657za7622504z00, BGl_z62lambda1657z62zz__libuv_typesz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2345z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2505za7, BGl_z62zc3z04anonymousza32016ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2264z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2506za7, BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2346z00zz__libuv_typesz00, BgL_bgl_za762lambda2014za7622507z00, BGl_z62lambda2014z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2265z00zz__libuv_typesz00, BgL_bgl_za762lambda1782za7622508z00, BGl_z62lambda1782z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2347z00zz__libuv_typesz00, BgL_bgl_za762lambda2011za7622509z00, BGl_z62lambda2011z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2266z00zz__libuv_typesz00, BgL_bgl_za762lambda1781za7622510z00, BGl_z62lambda1781z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2348z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2511za7, BGl_z62zc3z04anonymousza32027ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2267z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2512za7, BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2349z00zz__libuv_typesz00, BgL_bgl_za762lambda2025za7622513z00, BGl_z62lambda2025z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2268z00zz__libuv_typesz00, BgL_bgl_za762lambda1773za7622514z00, BGl_z62lambda1773z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2269z00zz__libuv_typesz00, BgL_bgl_za762lambda1764za7622515z00, BGl_z62lambda1764z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2350z00zz__libuv_typesz00, BgL_bgl_za762lambda2022za7622516z00, BGl_z62lambda2022z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2351z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2517za7, BGl_z62zc3z04anonymousza32038ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2270z00zz__libuv_typesz00, BgL_bgl_za762lambda1795za7622518z00, BGl_z62lambda1795z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2352z00zz__libuv_typesz00, BgL_bgl_za762lambda2036za7622519z00, BGl_z62lambda2036z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2271z00zz__libuv_typesz00, BgL_bgl_za762lambda1794za7622520z00, BGl_z62lambda1794z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2353z00zz__libuv_typesz00, BgL_bgl_za762lambda2033za7622521z00, BGl_z62lambda2033z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2272z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2522za7, BGl_z62zc3z04anonymousza31802ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2354z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2523za7, BGl_z62zc3z04anonymousza32056ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2273z00zz__libuv_typesz00, BgL_bgl_za762lambda1801za7622524z00, BGl_z62lambda1801z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2355z00zz__libuv_typesz00, BgL_bgl_za762lambda2055za7622525z00, BGl_z62lambda2055z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2274z00zz__libuv_typesz00, BgL_bgl_za762lambda1800za7622526z00, BGl_z62lambda1800z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2356z00zz__libuv_typesz00, BgL_bgl_za762lambda2054za7622527z00, BGl_z62lambda2054z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2275z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2528za7, BGl_z62zc3z04anonymousza31790ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2357z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2529za7, BGl_z62zc3z04anonymousza32061ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2276z00zz__libuv_typesz00, BgL_bgl_za762lambda1788za7622530z00, BGl_z62lambda1788z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2358z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2531za7, BGl_z62zc3z04anonymousza32060ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2277z00zz__libuv_typesz00, BgL_bgl_za762lambda1818za7622532z00, BGl_z62lambda1818z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2359z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2533za7, BGl_z62zc3z04anonymousza32065ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2278z00zz__libuv_typesz00, BgL_bgl_za762lambda1817za7622534z00, BGl_z62lambda1817z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2279z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2535za7, BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2360z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2536za7, BGl_z62zc3z04anonymousza32049ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2361z00zz__libuv_typesz00, BgL_bgl_za762lambda2047za7622537z00, BGl_z62lambda2047z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2280z00zz__libuv_typesz00, BgL_bgl_za762lambda1824za7622538z00, BGl_z62lambda1824z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2362z00zz__libuv_typesz00, BgL_bgl_za762lambda2044za7622539z00, BGl_z62lambda2044z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2281z00zz__libuv_typesz00, BgL_bgl_za762lambda1823za7622540z00, BGl_z62lambda1823z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2363z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2541za7, BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2282z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2542za7, BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2364z00zz__libuv_typesz00, BgL_bgl_za762lambda2085za7622543z00, BGl_z62lambda2085z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2283z00zz__libuv_typesz00, BgL_bgl_za762lambda1831za7622544z00, BGl_z62lambda1831z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2365z00zz__libuv_typesz00, BgL_bgl_za762lambda2084za7622545z00, BGl_z62lambda2084z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2284z00zz__libuv_typesz00, BgL_bgl_za762lambda1830za7622546z00, BGl_z62lambda1830z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2366z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2547za7, BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2285z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2548za7, BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2367z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2549za7, BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2286z00zz__libuv_typesz00, BgL_bgl_za762lambda1838za7622550z00, BGl_z62lambda1838z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2368z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2551za7, BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2287z00zz__libuv_typesz00, BgL_bgl_za762lambda1837za7622552z00, BGl_z62lambda1837z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2369z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2553za7, BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2288z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2554za7, BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2289z00zz__libuv_typesz00, BgL_bgl_za762lambda1845za7622555z00, BGl_z62lambda1845z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2370z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2556za7, BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2371z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2557za7, BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2290z00zz__libuv_typesz00, BgL_bgl_za762lambda1844za7622558z00, BGl_z62lambda1844z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2372z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2559za7, BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2291z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2560za7, BGl_z62zc3z04anonymousza31853ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2373z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2561za7, BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2292z00zz__libuv_typesz00, BgL_bgl_za762lambda1852za7622562z00, BGl_z62lambda1852z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2563za7, BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2293z00zz__libuv_typesz00, BgL_bgl_za762lambda1851za7622564z00, BGl_z62lambda1851z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2565za7, BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2294z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2566za7, BGl_z62zc3z04anonymousza31813ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2376z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2567za7, BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2295z00zz__libuv_typesz00, BgL_bgl_za762lambda1811za7622568z00, BGl_z62lambda1811z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2377z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2569za7, BGl_z62zc3z04anonymousza32115ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2296z00zz__libuv_typesz00, BgL_bgl_za762lambda1808za7622570z00, BGl_z62lambda1808z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2378z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2571za7, BGl_z62zc3z04anonymousza32121ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2297z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2572za7, BGl_z62zc3z04anonymousza31865ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2379z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2573za7, BGl_z62zc3z04anonymousza32120ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2298z00zz__libuv_typesz00, BgL_bgl_za762lambda1863za7622574z00, BGl_z62lambda1863z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2299z00zz__libuv_typesz00, BgL_bgl_za762lambda1860za7622575z00, BGl_z62lambda1860z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2380z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2576za7, BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2381z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2577za7, BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2382z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2578za7, BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2383z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2579za7, BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2384z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2580za7, BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2385z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2581za7, BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2386z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2582za7, BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2387z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2583za7, BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2388z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2584za7, BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2389z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2585za7, BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2390z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2586za7, BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2391z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2587za7, BGl_z62zc3z04anonymousza32180ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2392z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2588za7, BGl_z62zc3z04anonymousza32187ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2393z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2589za7, BGl_z62zc3z04anonymousza32190ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2590za7, BGl_z62zc3z04anonymousza32079ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2395z00zz__libuv_typesz00, BgL_bgl_za762lambda2077za7622591z00, BGl_z62lambda2077z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2396z00zz__libuv_typesz00, BgL_bgl_za762lambda2074za7622592z00, BGl_z62lambda2074z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2397z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2593za7, BGl_z62zc3z04anonymousza32210ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2398z00zz__libuv_typesz00, BgL_bgl_za762lambda2209za7622594z00, BGl_z62lambda2209z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2399z00zz__libuv_typesz00, BgL_bgl_za762lambda2208za7622595z00, BGl_z62lambda2208z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2initza72596z00, BGl_z62z52uvzd2initze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2gcmarkszd2emptyzf3zd2envz21zz__libuv_typesz00, BgL_bgl_za762uvza7d2gcmarksza72597za7, BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2errzd2namezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2errza7d2na2598za7, BGl_z62uvzd2errzd2namez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2pushzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2pushza7d2g2599za7, BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2newzd2filezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2newza7d2fi2600za7, BGl_z62uvzd2newzd2filez62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2versionzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2versionza72601za7, BGl_z62uvzd2versionzb0zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2handlezd2typezd2symbolzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2handleza7d2602za7, BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2idzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2idza7b0za7za7_2603za7, BGl_z62uvzd2idzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTtyz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFsPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFsEventz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvIdlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFilez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvHandlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvAsyncz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvLoopz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPipez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWorkz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvStreamz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWatcherz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTcpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessOptionsz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvUdpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTimerz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvCheckz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_z52Uvz52zz__libuv_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long BgL_checksumz00_2678, char * BgL_fromz00_2679)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__libuv_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__libuv_typesz00(); 
BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00(); 
BGl_cnstzd2initzd2zz__libuv_typesz00(); 
BGl_objectzd2initzd2zz__libuv_typesz00(); 
BGl_genericzd2initzd2zz__libuv_typesz00(); 
BGl_methodzd2initzd2zz__libuv_typesz00(); 
return 
BGl_toplevelzd2initzd2zz__libuv_typesz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__libuv_types"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_cportz00_2299;
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_stringz00_2307;
BgL_stringz00_2307 = BGl_string2416z00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_startz00_2308;
BgL_startz00_2308 = 
BINT(((long)0)); 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_endz00_2309;
BgL_endz00_2309 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2307))); 
{ /* Llib/uvtypes.scm 15 */

BgL_cportz00_2299 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2307, BgL_startz00_2308, BgL_endz00_2309); } } } } 
{ 
long BgL_iz00_2300;
BgL_iz00_2300 = ((long)70); 
BgL_loopz00_2301:
if(
(BgL_iz00_2300==((long)-1)))
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_arg2418z00_2303;
{ /* Llib/uvtypes.scm 15 */

{ /* Llib/uvtypes.scm 15 */
obj_t BgL_locationz00_2305;
BgL_locationz00_2305 = 
BBOOL(((bool_t)0)); 
{ /* Llib/uvtypes.scm 15 */

BgL_arg2418z00_2303 = 
BGl_readz00zz__readerz00(BgL_cportz00_2299, BgL_locationz00_2305); } } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_tmpz00_2710;
BgL_tmpz00_2710 = 
(int)(BgL_iz00_2300); 
CNST_TABLE_SET(BgL_tmpz00_2710, BgL_arg2418z00_2303); } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_auxz00_2306;
BgL_auxz00_2306 = 
(int)(
(BgL_iz00_2300-((long)1))); 
{ 
long BgL_iz00_2715;
BgL_iz00_2715 = 
(long)(BgL_auxz00_2306); 
BgL_iz00_2300 = BgL_iz00_2715; 
goto BgL_loopz00_2301;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;} 

}



/* uv-version */
BGL_EXPORTED_DEF char * BGl_uvzd2versionzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 174 */
return 
(char *)uv_version_string();} 

}



/* &uv-version */
obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t BgL_envz00_1648)
{
{ /* Llib/uvtypes.scm 174 */
return 
string_to_bstring(
BGl_uvzd2versionzd2zz__libuv_typesz00());} 

}



/* uv-id */
BGL_EXPORTED_DEF int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_3)
{
{ /* Llib/uvtypes.scm 180 */
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1346z00_1233;
BgL_arg1346z00_1233 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_3))->BgL_z42builtinz42); 
return 
(int)(
(long)(BgL_arg1346z00_1233));} } 

}



/* &uv-id */
obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t BgL_envz00_1649, obj_t BgL_oz00_1650)
{
{ /* Llib/uvtypes.scm 180 */
return 
BINT(
BGl_uvzd2idzd2zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1650)));} 

}



/* uv-new-file */
BGL_EXPORTED_DEF BgL_uvfilez00_bglt bgl_uv_new_file(int BgL_fdz00_8, obj_t BgL_pathz00_9)
{
{ /* Llib/uvtypes.scm 228 */
{ /* Llib/uvtypes.scm 229 */
BgL_uvfilez00_bglt BgL_new1243z00_1234;
{ /* Llib/uvtypes.scm 230 */
BgL_uvfilez00_bglt BgL_new1242z00_1235;
BgL_new1242z00_1235 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 230 */
long BgL_arg1356z00_1236;
BgL_arg1356z00_1236 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1242z00_1235), BgL_arg1356z00_1236); } 
BgL_new1243z00_1234 = BgL_new1242z00_1235; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1243z00_1234))->BgL_fdz00)=((int)BgL_fdz00_8),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1243z00_1234))->BgL_pathz00)=((obj_t)BgL_pathz00_9),BUNSPEC); 
return BgL_new1243z00_1234;} } 

}



/* &uv-new-file */
BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t BgL_envz00_1651, obj_t BgL_fdz00_1652, obj_t BgL_pathz00_1653)
{
{ /* Llib/uvtypes.scm 228 */
return 
bgl_uv_new_file(
CINT(BgL_fdz00_1652), BgL_pathz00_1653);} 

}



/* uv-strerror */
BGL_EXPORTED_DEF obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int BgL_errnoz00_10)
{
{ /* Llib/uvtypes.scm 236 */
{ /* Llib/uvtypes.scm 237 */
char * BgL_sz00_1240;
BgL_sz00_1240 = 
(char *)uv_strerror(BgL_errnoz00_10); 
if(
((char *)0L) ==(BgL_sz00_1240))
{ /* Llib/uvtypes.scm 238 */
return BGl_string2243z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 238 */
return 
string_to_bstring(BgL_sz00_1240);} } } 

}



/* &uv-strerror */
obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t BgL_envz00_1654, obj_t BgL_errnoz00_1655)
{
{ /* Llib/uvtypes.scm 236 */
return 
BGl_uvzd2strerrorzd2zz__libuv_typesz00(
CINT(BgL_errnoz00_1655));} 

}



/* uv-err-name */
BGL_EXPORTED_DEF obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int BgL_errnoz00_11)
{
{ /* Llib/uvtypes.scm 245 */
{ /* Llib/uvtypes.scm 246 */
char * BgL_sz00_1242;
BgL_sz00_1242 = 
(char *)uv_err_name(BgL_errnoz00_11); 
if(
((char *)0L) ==(BgL_sz00_1242))
{ /* Llib/uvtypes.scm 247 */
return BGl_string2243z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 247 */
return 
string_to_bstring(BgL_sz00_1242);} } } 

}



/* &uv-err-name */
obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t BgL_envz00_1656, obj_t BgL_errnoz00_1657)
{
{ /* Llib/uvtypes.scm 245 */
return 
BGl_uvzd2errzd2namez00zz__libuv_typesz00(
CINT(BgL_errnoz00_1657));} 

}



/* uv-guess-handle */
BGL_EXPORTED_DEF obj_t bgl_uv_guess_handle(int BgL_fdz00_12)
{
{ /* Llib/uvtypes.scm 254 */
{ /* Llib/uvtypes.scm 255 */
int BgL_arg1389z00_1244;
BgL_arg1389z00_1244 = 
uv_guess_handle(BgL_fdz00_12); 
return 
bgl_uv_handle_type_symbol(BgL_arg1389z00_1244);} } 

}



/* &uv-guess-handle */
obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t BgL_envz00_1658, obj_t BgL_fdz00_1659)
{
{ /* Llib/uvtypes.scm 254 */
return 
bgl_uv_guess_handle(
CINT(BgL_fdz00_1659));} 

}



/* uv-handle-type-symbol */
BGL_EXPORTED_DEF obj_t bgl_uv_handle_type_symbol(int BgL_rz00_13)
{
{ /* Llib/uvtypes.scm 260 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TCP)))
{ /* Llib/uvtypes.scm 262 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/uvtypes.scm 262 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TTY)))
{ /* Llib/uvtypes.scm 263 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/uvtypes.scm 263 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UDP)))
{ /* Llib/uvtypes.scm 264 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/uvtypes.scm 264 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_NAMED_PIPE)))
{ /* Llib/uvtypes.scm 265 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/uvtypes.scm 265 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_FILE)))
{ /* Llib/uvtypes.scm 266 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/uvtypes.scm 266 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UNKNOWN_HANDLE)))
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)6));} } } } } } } 

}



/* &uv-handle-type-symbol */
obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t BgL_envz00_1660, obj_t BgL_rz00_1661)
{
{ /* Llib/uvtypes.scm 260 */
return 
bgl_uv_handle_type_symbol(
CINT(BgL_rz00_1661));} 

}



/* uv-push-gcmark! */
BGL_EXPORTED_DEF obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_14, obj_t BgL_valz00_15)
{
{ /* Llib/uvtypes.scm 273 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 275 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)=((obj_t)
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 275 */
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_arg1506z00_2311;obj_t BgL_arg1507z00_2312;
BgL_arg1506z00_2311 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_arg1507z00_2312 = 
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL); 
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_tmpz00_2793;
BgL_tmpz00_2793 = 
((obj_t)BgL_arg1506z00_2311); 
SET_CDR(BgL_tmpz00_2793, BgL_arg1507z00_2312); } } 
{ 
obj_t BgL_auxz00_2796;
{ /* Llib/uvtypes.scm 281 */
obj_t BgL_pairz00_2313;
BgL_pairz00_2313 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_auxz00_2796 = 
CDR(BgL_pairz00_2313); } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)BgL_auxz00_2796),BUNSPEC); } } 
return BUNSPEC;} 

}



/* &uv-push-gcmark! */
obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1662, obj_t BgL_oz00_1663, obj_t BgL_valz00_1664)
{
{ /* Llib/uvtypes.scm 273 */
return 
BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1663), BgL_valz00_1664);} 

}



/* uv-pop-gcmark! */
BGL_EXPORTED_DEF obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt BgL_oz00_16, obj_t BgL_valz00_17)
{
{ /* Llib/uvtypes.scm 287 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)))
{ /* Llib/uvtypes.scm 289 */
return BFALSE;}  else 
{ /* Llib/uvtypes.scm 289 */
if(
(BgL_valz00_17==
CAR(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52))))
{ /* Llib/uvtypes.scm 290 */
if(
(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 291 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC);}  else 
{ 
obj_t BgL_auxz00_2815;
{ /* Llib/uvtypes.scm 295 */
obj_t BgL_pairz00_1266;
BgL_pairz00_1266 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_auxz00_2815 = 
CDR(BgL_pairz00_1266); } 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BgL_auxz00_2815),BUNSPEC);} }  else 
{ 
obj_t BgL_pz00_64;
BgL_pz00_64 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_zc3z04anonymousza31564ze3z87_65:
{ /* Llib/uvtypes.scm 297 */
obj_t BgL_nz00_66;
BgL_nz00_66 = 
CDR(
((obj_t)BgL_pz00_64)); 
if(
PAIRP(BgL_nz00_66))
{ /* Llib/uvtypes.scm 298 */
if(
(
CAR(BgL_nz00_66)==BgL_valz00_17))
{ /* Llib/uvtypes.scm 299 */
if(
(BgL_nz00_66==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 301 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BgL_pz00_64),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 301 */BFALSE; } 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_arg1593z00_73;
BgL_arg1593z00_73 = 
CDR(BgL_nz00_66); 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_tmpz00_2831;
BgL_tmpz00_2831 = 
((obj_t)BgL_pz00_64); 
return 
SET_CDR(BgL_tmpz00_2831, BgL_arg1593z00_73);} } }  else 
{ 
obj_t BgL_pz00_2834;
BgL_pz00_2834 = BgL_nz00_66; 
BgL_pz00_64 = BgL_pz00_2834; 
goto BgL_zc3z04anonymousza31564ze3z87_65;} }  else 
{ /* Llib/uvtypes.scm 298 */
return BFALSE;} } } } } 

}



/* &uv-pop-gcmark! */
obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1665, obj_t BgL_oz00_1666, obj_t BgL_valz00_1667)
{
{ /* Llib/uvtypes.scm 287 */
return 
bgl_uv_pop_gcmark(
((BgL_uvhandlez00_bglt)BgL_oz00_1666), BgL_valz00_1667);} 

}



/* uv-gcmarks-empty? */
BGL_EXPORTED_DEF bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_18)
{
{ /* Llib/uvtypes.scm 309 */
return 
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_18))->BgL_z52gcmarksheadz52));} 

}



/* &uv-gcmarks-empty? */
obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t BgL_envz00_1668, obj_t BgL_oz00_1669)
{
{ /* Llib/uvtypes.scm 309 */
return 
BBOOL(
BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1669)));} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_arg1631z00_83;obj_t BgL_arg1636z00_84;
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1298z00_90;
BgL_v1298z00_90 = 
create_vector(((long)0)); 
BgL_arg1631z00_83 = BgL_v1298z00_90; } 
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1299z00_91;
BgL_v1299z00_91 = 
create_vector(((long)0)); 
BgL_arg1636z00_84 = BgL_v1299z00_91; } 
BGl_z52Uvz52zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)7)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)23285), BFALSE, BGl_proc2245z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2244z00zz__libuv_typesz00, BFALSE, BgL_arg1631z00_83, BgL_arg1636z00_84); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1652z00_97;obj_t BgL_arg1656z00_98;
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1300z00_114;
BgL_v1300z00_114 = 
create_vector(((long)5)); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1674z00_115;
BgL_arg1674z00_115 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2248z00zz__libuv_typesz00, BGl_proc2247z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2246z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1300z00_114,((long)0),BgL_arg1674z00_115); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1696z00_128;
BgL_arg1696z00_128 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc2251z00zz__libuv_typesz00, BGl_proc2250z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2249z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1300z00_114,((long)1),BgL_arg1696z00_128); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1703z00_141;
BgL_arg1703z00_141 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2254z00zz__libuv_typesz00, BGl_proc2253z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2252z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1300z00_114,((long)2),BgL_arg1703z00_141); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1716z00_154;
BgL_arg1716z00_154 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc2257z00zz__libuv_typesz00, BGl_proc2256z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2255z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1300z00_114,((long)3),BgL_arg1716z00_154); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1726z00_167;
BgL_arg1726z00_167 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc2260z00zz__libuv_typesz00, BGl_proc2259z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2258z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1300z00_114,((long)4),BgL_arg1726z00_167); } 
BgL_arg1652z00_97 = BgL_v1300z00_114; } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1301z00_180;
BgL_v1301z00_180 = 
create_vector(((long)0)); 
BgL_arg1656z00_98 = BgL_v1301z00_180; } 
BGl_UvHandlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)18)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)36343), BGl_proc2263z00zz__libuv_typesz00, BGl_proc2262z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2261z00zz__libuv_typesz00, BFALSE, BgL_arg1652z00_97, BgL_arg1656z00_98); } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1760z00_187;obj_t BgL_arg1763z00_188;
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1302z00_205;
BgL_v1302z00_205 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1777z00_206;
BgL_arg1777z00_206 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2266z00zz__libuv_typesz00, BGl_proc2265z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2264z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)20))); 
VECTOR_SET(BgL_v1302z00_205,((long)0),BgL_arg1777z00_206); } 
BgL_arg1760z00_187 = BgL_v1302z00_205; } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1303z00_220;
BgL_v1303z00_220 = 
create_vector(((long)0)); 
BgL_arg1763z00_188 = BgL_v1303z00_220; } 
BGl_UvLoopz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)21)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)33046), BGl_proc2269z00zz__libuv_typesz00, BGl_proc2268z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2267z00zz__libuv_typesz00, BFALSE, BgL_arg1760z00_187, BgL_arg1763z00_188); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1786z00_226;obj_t BgL_arg1787z00_227;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1304z00_233;
BgL_v1304z00_233 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1791z00_234;
BgL_arg1791z00_234 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2271z00zz__libuv_typesz00, BGl_proc2270z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1304z00_233,((long)0),BgL_arg1791z00_234); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1796z00_244;
BgL_arg1796z00_244 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2274z00zz__libuv_typesz00, BGl_proc2273z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2272z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1304z00_233,((long)1),BgL_arg1796z00_244); } 
BgL_arg1786z00_226 = BgL_v1304z00_233; } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1305z00_257;
BgL_v1305z00_257 = 
create_vector(((long)0)); 
BgL_arg1787z00_227 = BgL_v1305z00_257; } 
BGl_UvWatcherz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)25)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)54967), BFALSE, BGl_proc2276z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2275z00zz__libuv_typesz00, BFALSE, BgL_arg1786z00_226, BgL_arg1787z00_227); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1806z00_263;obj_t BgL_arg1807z00_264;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1306z00_286;
BgL_v1306z00_286 = 
create_vector(((long)6)); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1814z00_287;
BgL_arg1814z00_287 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2278z00zz__libuv_typesz00, BGl_proc2277z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1306z00_286,((long)0),BgL_arg1814z00_287); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1819z00_297;
BgL_arg1819z00_297 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc2281z00zz__libuv_typesz00, BGl_proc2280z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2279z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1306z00_286,((long)1),BgL_arg1819z00_297); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1826z00_310;
BgL_arg1826z00_310 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc2284z00zz__libuv_typesz00, BGl_proc2283z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2282z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1306z00_286,((long)2),BgL_arg1826z00_310); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1833z00_323;
BgL_arg1833z00_323 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2287z00zz__libuv_typesz00, BGl_proc2286z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2285z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1306z00_286,((long)3),BgL_arg1833z00_323); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1840z00_336;
BgL_arg1840z00_336 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2290z00zz__libuv_typesz00, BGl_proc2289z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2288z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1306z00_286,((long)4),BgL_arg1840z00_336); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1847z00_349;
BgL_arg1847z00_349 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc2293z00zz__libuv_typesz00, BGl_proc2292z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2291z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1306z00_286,((long)5),BgL_arg1847z00_349); } 
BgL_arg1806z00_263 = BgL_v1306z00_286; } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1307z00_362;
BgL_v1307z00_362 = 
create_vector(((long)0)); 
BgL_arg1807z00_264 = BgL_v1307z00_362; } 
BGl_UvStreamz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11232), BGl_proc2296z00zz__libuv_typesz00, BGl_proc2295z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2294z00zz__libuv_typesz00, BFALSE, BgL_arg1806z00_263, BgL_arg1807z00_264); } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_arg1858z00_369;obj_t BgL_arg1859z00_370;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1308z00_392;
BgL_v1308z00_392 = 
create_vector(((long)0)); 
BgL_arg1858z00_369 = BgL_v1308z00_392; } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1309z00_393;
BgL_v1309z00_393 = 
create_vector(((long)0)); 
BgL_arg1859z00_370 = BgL_v1309z00_393; } 
BGl_UvTcpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)32)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)12982), BGl_proc2299z00zz__libuv_typesz00, BGl_proc2298z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2297z00zz__libuv_typesz00, BFALSE, BgL_arg1858z00_369, BgL_arg1859z00_370); } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1869z00_400;obj_t BgL_arg1870z00_401;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1310z00_424;
BgL_v1310z00_424 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1877z00_425;
BgL_arg1877z00_425 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc2302z00zz__libuv_typesz00, BGl_proc2301z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2300z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1310z00_424,((long)0),BgL_arg1877z00_425); } 
BgL_arg1869z00_400 = BgL_v1310z00_424; } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1311z00_438;
BgL_v1311z00_438 = 
create_vector(((long)0)); 
BgL_arg1870z00_401 = BgL_v1311z00_438; } 
BGl_UvUdpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)34)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)61053), BGl_proc2305z00zz__libuv_typesz00, BGl_proc2304z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2303z00zz__libuv_typesz00, BFALSE, BgL_arg1869z00_400, BgL_arg1870z00_401); } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1887z00_445;obj_t BgL_arg1888z00_446;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1312z00_469;
BgL_v1312z00_469 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1895z00_470;
BgL_arg1895z00_470 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc2307z00zz__libuv_typesz00, BGl_proc2306z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1312z00_469,((long)0),BgL_arg1895z00_470); } 
BgL_arg1887z00_445 = BgL_v1312z00_469; } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1313z00_480;
BgL_v1313z00_480 = 
create_vector(((long)0)); 
BgL_arg1888z00_446 = BgL_v1313z00_480; } 
BGl_UvPipez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)36)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)59138), BGl_proc2310z00zz__libuv_typesz00, BGl_proc2309z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2308z00zz__libuv_typesz00, BFALSE, BgL_arg1887z00_445, BgL_arg1888z00_446); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1905z00_487;obj_t BgL_arg1906z00_488;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1314z00_512;
BgL_v1314z00_512 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1913z00_513;
BgL_arg1913z00_513 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2312z00zz__libuv_typesz00, BGl_proc2311z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1314z00_512,((long)0),BgL_arg1913z00_513); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1918z00_523;
BgL_arg1918z00_523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)39)), BGl_proc2314z00zz__libuv_typesz00, BGl_proc2313z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1314z00_512,((long)1),BgL_arg1918z00_523); } 
BgL_arg1905z00_487 = BgL_v1314z00_512; } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1315z00_533;
BgL_v1315z00_533 = 
create_vector(((long)0)); 
BgL_arg1906z00_488 = BgL_v1315z00_533; } 
BGl_UvTtyz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)40)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)33681), BGl_proc2317z00zz__libuv_typesz00, BGl_proc2316z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2315z00zz__libuv_typesz00, BFALSE, BgL_arg1905z00_487, BgL_arg1906z00_488); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1926z00_540;obj_t BgL_arg1927z00_541;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1316z00_561;
BgL_v1316z00_561 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1934z00_562;
BgL_arg1934z00_562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc2320z00zz__libuv_typesz00, BGl_proc2319z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2318z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)42))); 
VECTOR_SET(BgL_v1316z00_561,((long)0),BgL_arg1934z00_562); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1941z00_575;
BgL_arg1941z00_575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc2323z00zz__libuv_typesz00, BGl_proc2322z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2321z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1316z00_561,((long)1),BgL_arg1941z00_575); } 
BgL_arg1926z00_540 = BgL_v1316z00_561; } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1317z00_588;
BgL_v1317z00_588 = 
create_vector(((long)0)); 
BgL_arg1927z00_541 = BgL_v1317z00_588; } 
BGl_UvTimerz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)44)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)64284), BGl_proc2326z00zz__libuv_typesz00, BGl_proc2325z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2324z00zz__libuv_typesz00, BFALSE, BgL_arg1926z00_540, BgL_arg1927z00_541); } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_arg1951z00_595;obj_t BgL_arg1952z00_596;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1318z00_614;
BgL_v1318z00_614 = 
create_vector(((long)0)); 
BgL_arg1951z00_595 = BgL_v1318z00_614; } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1319z00_615;
BgL_v1319z00_615 = 
create_vector(((long)0)); 
BgL_arg1952z00_596 = BgL_v1319z00_615; } 
BGl_UvIdlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)45)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)3465), BGl_proc2329z00zz__libuv_typesz00, BGl_proc2328z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2327z00zz__libuv_typesz00, BFALSE, BgL_arg1951z00_595, BgL_arg1952z00_596); } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_arg1962z00_622;obj_t BgL_arg1963z00_623;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1320z00_641;
BgL_v1320z00_641 = 
create_vector(((long)0)); 
BgL_arg1962z00_622 = BgL_v1320z00_641; } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1321z00_642;
BgL_v1321z00_642 = 
create_vector(((long)0)); 
BgL_arg1963z00_623 = BgL_v1321z00_642; } 
BGl_UvAsyncz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)46)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)42569), BGl_proc2332z00zz__libuv_typesz00, BGl_proc2331z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2330z00zz__libuv_typesz00, BFALSE, BgL_arg1962z00_622, BgL_arg1963z00_623); } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1973z00_649;obj_t BgL_arg1974z00_650;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1322z00_669;
BgL_v1322z00_669 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1981z00_670;
BgL_arg1981z00_670 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2334z00zz__libuv_typesz00, BGl_proc2333z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1322z00_669,((long)0),BgL_arg1981z00_670); } 
BgL_arg1973z00_649 = BgL_v1322z00_669; } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1323z00_680;
BgL_v1323z00_680 = 
create_vector(((long)0)); 
BgL_arg1974z00_650 = BgL_v1323z00_680; } 
BGl_UvPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)47)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)5968), BGl_proc2337z00zz__libuv_typesz00, BGl_proc2336z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2335z00zz__libuv_typesz00, BFALSE, BgL_arg1973z00_649, BgL_arg1974z00_650); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1989z00_687;obj_t BgL_arg1990z00_688;
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1324z00_700;
BgL_v1324z00_700 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1996z00_701;
BgL_arg1996z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2339z00zz__libuv_typesz00, BGl_proc2338z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1324z00_700,((long)0),BgL_arg1996z00_701); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg2001z00_711;
BgL_arg2001z00_711 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc2341z00zz__libuv_typesz00, BGl_proc2340z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)49))); 
VECTOR_SET(BgL_v1324z00_700,((long)1),BgL_arg2001z00_711); } 
BgL_arg1989z00_687 = BgL_v1324z00_700; } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1325z00_721;
BgL_v1325z00_721 = 
create_vector(((long)0)); 
BgL_arg1990z00_688 = BgL_v1325z00_721; } 
BGl_UvFilez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)50)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)50283), BGl_proc2344z00zz__libuv_typesz00, BGl_proc2343z00zz__libuv_typesz00, BFALSE, BGl_proc2342z00zz__libuv_typesz00, BFALSE, BgL_arg1989z00_687, BgL_arg1990z00_688); } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_arg2009z00_728;obj_t BgL_arg2010z00_729;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1326z00_747;
BgL_v1326z00_747 = 
create_vector(((long)0)); 
BgL_arg2009z00_728 = BgL_v1326z00_747; } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1327z00_748;
BgL_v1327z00_748 = 
create_vector(((long)0)); 
BgL_arg2010z00_729 = BgL_v1327z00_748; } 
BGl_UvFsEventz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)49452), BGl_proc2347z00zz__libuv_typesz00, BGl_proc2346z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2345z00zz__libuv_typesz00, BFALSE, BgL_arg2009z00_728, BgL_arg2010z00_729); } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_arg2020z00_755;obj_t BgL_arg2021z00_756;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1328z00_774;
BgL_v1328z00_774 = 
create_vector(((long)0)); 
BgL_arg2020z00_755 = BgL_v1328z00_774; } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1329z00_775;
BgL_v1329z00_775 = 
create_vector(((long)0)); 
BgL_arg2021z00_756 = BgL_v1329z00_775; } 
BGl_UvFsPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)52)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)33371), BGl_proc2350z00zz__libuv_typesz00, BGl_proc2349z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2348z00zz__libuv_typesz00, BFALSE, BgL_arg2020z00_755, BgL_arg2021z00_756); } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_arg2031z00_782;obj_t BgL_arg2032z00_783;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1330z00_801;
BgL_v1330z00_801 = 
create_vector(((long)0)); 
BgL_arg2031z00_782 = BgL_v1330z00_801; } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1331z00_802;
BgL_v1331z00_802 = 
create_vector(((long)0)); 
BgL_arg2032z00_783 = BgL_v1331z00_802; } 
BGl_UvCheckz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)52457), BGl_proc2353z00zz__libuv_typesz00, BGl_proc2352z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2351z00zz__libuv_typesz00, BFALSE, BgL_arg2031z00_782, BgL_arg2032z00_783); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2042z00_809;obj_t BgL_arg2043z00_810;
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1332z00_827;
BgL_v1332z00_827 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2050z00_828;
BgL_arg2050z00_828 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc2356z00zz__libuv_typesz00, BGl_proc2355z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2354z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1332z00_827,((long)0),BgL_arg2050z00_828); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2057z00_841;
BgL_arg2057z00_841 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2358z00zz__libuv_typesz00, BGl_proc2357z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1332z00_827,((long)1),BgL_arg2057z00_841); } 
BgL_arg2042z00_809 = BgL_v1332z00_827; } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1333z00_851;
BgL_v1333z00_851 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2062z00_852;
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2063z00_853;
BgL_arg2063z00_853 = 
MAKE_YOUNG_PAIR(BGl_proc2359z00zz__libuv_typesz00, BFALSE); 
BgL_arg2062z00_852 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2063z00_853); } 
VECTOR_SET(BgL_v1333z00_851,((long)0),BgL_arg2062z00_852); } 
BgL_arg2043z00_810 = BgL_v1333z00_851; } 
BGl_UvProcessz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)56)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11647), BGl_proc2362z00zz__libuv_typesz00, BGl_proc2361z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2360z00zz__libuv_typesz00, BFALSE, BgL_arg2042z00_809, BgL_arg2043z00_810); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2072z00_871;obj_t BgL_arg2073z00_872;
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1334z00_884;
BgL_v1334z00_884 = 
create_vector(((long)8)); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2080z00_885;
BgL_arg2080z00_885 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2365z00zz__libuv_typesz00, BGl_proc2364z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2363z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1334z00_884,((long)0),BgL_arg2080z00_885); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2087z00_898;
BgL_arg2087z00_898 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc2367z00zz__libuv_typesz00, BGl_proc2366z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)1),BgL_arg2087z00_898); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2092z00_908;
BgL_arg2092z00_908 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2369z00zz__libuv_typesz00, BGl_proc2368z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)2),BgL_arg2092z00_908); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2097z00_918;
BgL_arg2097z00_918 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc2371z00zz__libuv_typesz00, BGl_proc2370z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)3),BgL_arg2097z00_918); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2102z00_928;
BgL_arg2102z00_928 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc2373z00zz__libuv_typesz00, BGl_proc2372z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)4),BgL_arg2102z00_928); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2107z00_938;
BgL_arg2107z00_938 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc2375z00zz__libuv_typesz00, BGl_proc2374z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)5),BgL_arg2107z00_938); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2112z00_948;
BgL_arg2112z00_948 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc2377z00zz__libuv_typesz00, BGl_proc2376z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)6),BgL_arg2112z00_948); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2117z00_958;
BgL_arg2117z00_958 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc2379z00zz__libuv_typesz00, BGl_proc2378z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1334z00_884,((long)7),BgL_arg2117z00_958); } 
BgL_arg2072z00_871 = BgL_v1334z00_884; } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1335z00_968;
BgL_v1335z00_968 = 
create_vector(((long)7)); 
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2122z00_969;
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2123z00_970;
BgL_arg2123z00_970 = 
MAKE_YOUNG_PAIR(BGl_proc2380z00zz__libuv_typesz00, BGl_proc2381z00zz__libuv_typesz00); 
BgL_arg2122z00_969 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2123z00_970); } 
VECTOR_SET(BgL_v1335z00_968,((long)0),BgL_arg2122z00_969); } 
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2132z00_993;
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2133z00_994;
BgL_arg2133z00_994 = 
MAKE_YOUNG_PAIR(BGl_proc2382z00zz__libuv_typesz00, BGl_proc2383z00zz__libuv_typesz00); 
BgL_arg2132z00_993 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg2133z00_994); } 
VECTOR_SET(BgL_v1335z00_968,((long)1),BgL_arg2132z00_993); } 
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2142z00_1017;
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2143z00_1018;
BgL_arg2143z00_1018 = 
MAKE_YOUNG_PAIR(BGl_proc2384z00zz__libuv_typesz00, BGl_proc2385z00zz__libuv_typesz00); 
BgL_arg2142z00_1017 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg2143z00_1018); } 
VECTOR_SET(BgL_v1335z00_968,((long)2),BgL_arg2142z00_1017); } 
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2152z00_1041;
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2153z00_1042;
BgL_arg2153z00_1042 = 
MAKE_YOUNG_PAIR(BGl_proc2386z00zz__libuv_typesz00, BGl_proc2387z00zz__libuv_typesz00); 
BgL_arg2152z00_1041 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2153z00_1042); } 
VECTOR_SET(BgL_v1335z00_968,((long)3),BgL_arg2152z00_1041); } 
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2162z00_1065;
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2163z00_1066;
BgL_arg2163z00_1066 = 
MAKE_YOUNG_PAIR(BGl_proc2388z00zz__libuv_typesz00, BGl_proc2389z00zz__libuv_typesz00); 
BgL_arg2162z00_1065 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2163z00_1066); } 
VECTOR_SET(BgL_v1335z00_968,((long)4),BgL_arg2162z00_1065); } 
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2172z00_1089;
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2173z00_1090;
BgL_arg2173z00_1090 = 
MAKE_YOUNG_PAIR(BGl_proc2390z00zz__libuv_typesz00, BGl_proc2391z00zz__libuv_typesz00); 
BgL_arg2172z00_1089 = 
MAKE_YOUNG_PAIR(
BINT(((long)5)), BgL_arg2173z00_1090); } 
VECTOR_SET(BgL_v1335z00_968,((long)5),BgL_arg2172z00_1089); } 
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2183z00_1113;
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2184z00_1114;
BgL_arg2184z00_1114 = 
MAKE_YOUNG_PAIR(BGl_proc2392z00zz__libuv_typesz00, BGl_proc2393z00zz__libuv_typesz00); 
BgL_arg2183z00_1113 = 
MAKE_YOUNG_PAIR(
BINT(((long)6)), BgL_arg2184z00_1114); } 
VECTOR_SET(BgL_v1335z00_968,((long)6),BgL_arg2183z00_1113); } 
BgL_arg2073z00_872 = BgL_v1335z00_968; } 
BGl_UvProcessOptionsz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)65)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)34792), BGl_proc2396z00zz__libuv_typesz00, BGl_proc2395z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2394z00zz__libuv_typesz00, BFALSE, BgL_arg2072z00_871, BgL_arg2073z00_872); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2196z00_1143;obj_t BgL_arg2197z00_1144;
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1336z00_1158;
BgL_v1336z00_1158 = 
create_vector(((long)3)); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2204z00_1159;
BgL_arg2204z00_1159 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2399z00zz__libuv_typesz00, BGl_proc2398z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2397z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)66))); 
VECTOR_SET(BgL_v1336z00_1158,((long)0),BgL_arg2204z00_1159); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2211z00_1172;
BgL_arg2211z00_1172 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc2401z00zz__libuv_typesz00, BGl_proc2400z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1336z00_1158,((long)1),BgL_arg2211z00_1172); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2216z00_1182;
BgL_arg2216z00_1182 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2403z00zz__libuv_typesz00, BGl_proc2402z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1336z00_1158,((long)2),BgL_arg2216z00_1182); } 
BgL_arg2196z00_1143 = BgL_v1336z00_1158; } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1337z00_1192;
BgL_v1337z00_1192 = 
create_vector(((long)0)); 
BgL_arg2197z00_1144 = BgL_v1337z00_1192; } 
return ( 
BGl_UvWorkz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)69)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)37721), BGl_proc2406z00zz__libuv_typesz00, BGl_proc2405z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2404z00zz__libuv_typesz00, BFALSE, BgL_arg2196z00_1143, BgL_arg2197z00_1144), BUNSPEC) ;} } 

}



/* &<@anonymous:2203> */
obj_t BGl_z62zc3z04anonymousza32203ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1838, obj_t BgL_new1240z00_1839)
{
{ /* Llib/uvtypes.scm 149 */
{ 
BgL_uvworkz00_bglt BgL_auxz00_3117;
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1240z00_1839)))->BgL_z42builtinz42)=((uv_work_t *)
0L),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1240z00_1839)))->BgL_z52workzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1240z00_1839)))->BgL_z52afterzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3117 = 
((BgL_uvworkz00_bglt)BgL_new1240z00_1839); 
return 
((obj_t)BgL_auxz00_3117);} } 

}



/* &lambda2201 */
BgL_uvworkz00_bglt BGl_z62lambda2201z62zz__libuv_typesz00(obj_t BgL_envz00_1840)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1239z00_2315;
BgL_new1239z00_2315 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2202z00_2316;
BgL_arg2202z00_2316 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1239z00_2315), BgL_arg2202z00_2316); } 
return BgL_new1239z00_2315;} } 

}



/* &lambda2198 */
BgL_uvworkz00_bglt BGl_z62lambda2198z62zz__libuv_typesz00(obj_t BgL_envz00_1841, obj_t BgL_z42builtin1236z42_1842, obj_t BgL_z52workzd2cb1237z80_1843, obj_t BgL_z52afterzd2cb1238z80_1844)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_z42builtin1236z42_2317;
BgL_z42builtin1236z42_2317 = 
FOREIGN_TO_COBJ(BgL_z42builtin1236z42_1842); 
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1297z00_2320;
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1296z00_2321;
BgL_new1296z00_2321 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2200z00_2322;
BgL_arg2200z00_2322 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1296z00_2321), BgL_arg2200z00_2322); } 
BgL_new1297z00_2320 = BgL_new1296z00_2321; } 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1297z00_2320))->BgL_z42builtinz42)=((uv_work_t *)BgL_z42builtin1236z42_2317),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1297z00_2320))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_z52workzd2cb1237z80_1843)),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1297z00_2320))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_z52afterzd2cb1238z80_1844)),BUNSPEC); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_fun2199z00_2323;
BgL_fun2199z00_2323 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvWorkz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2199z00_2323)(BgL_fun2199z00_2323, 
((obj_t)BgL_new1297z00_2320), BEOA); } 
return BgL_new1297z00_2320;} } } 

}



/* &lambda2220 */
obj_t BGl_z62lambda2220z62zz__libuv_typesz00(obj_t BgL_envz00_1845, obj_t BgL_oz00_1846, obj_t BgL_vz00_1847)
{
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1846)))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1847)),BUNSPEC);} 

}



/* &lambda2219 */
obj_t BGl_z62lambda2219z62zz__libuv_typesz00(obj_t BgL_envz00_1848, obj_t BgL_oz00_1849)
{
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1849)))->BgL_z52afterzd2cbz80);} 

}



/* &lambda2215 */
obj_t BGl_z62lambda2215z62zz__libuv_typesz00(obj_t BgL_envz00_1850, obj_t BgL_oz00_1851, obj_t BgL_vz00_1852)
{
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1851)))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1852)),BUNSPEC);} 

}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__libuv_typesz00(obj_t BgL_envz00_1853, obj_t BgL_oz00_1854)
{
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1854)))->BgL_z52workzd2cbz80);} 

}



/* &<@anonymous:2210> */
obj_t BGl_z62zc3z04anonymousza32210ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1855)
{
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2209 */
obj_t BGl_z62lambda2209z62zz__libuv_typesz00(obj_t BgL_envz00_1856, obj_t BgL_oz00_1857, obj_t BgL_vz00_1858)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_vz00_2331;
BgL_vz00_2331 = 
FOREIGN_TO_COBJ(BgL_vz00_1858); 
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1857)))->BgL_z42builtinz42)=((uv_work_t *)BgL_vz00_2331),BUNSPEC);} } 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__libuv_typesz00(obj_t BgL_envz00_1859, obj_t BgL_oz00_1860)
{
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1860)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2079> */
obj_t BGl_z62zc3z04anonymousza32079ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1861, obj_t BgL_new1234z00_1862)
{
{ /* Llib/uvtypes.scm 89 */
{ 
BgL_uvprocessoptionsz00_bglt BgL_auxz00_3164;
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_new1234z00_1862)))->BgL_z42builtinz42)=((uv_process_options_t *)
0L),BUNSPEC); 
BgL_auxz00_3164 = 
((BgL_uvprocessoptionsz00_bglt)BgL_new1234z00_1862); 
return 
((obj_t)BgL_auxz00_3164);} } 

}



/* &lambda2077 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2077z62zz__libuv_typesz00(obj_t BgL_envz00_1863)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1233z00_2334;
BgL_new1233z00_2334 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2078z00_2335;
BgL_arg2078z00_2335 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1233z00_2334), BgL_arg2078z00_2335); } 
return BgL_new1233z00_2334;} } 

}



/* &lambda2074 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2074z62zz__libuv_typesz00(obj_t BgL_envz00_1864, obj_t BgL_z42builtin1232z42_1865)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_z42builtin1232z42_2336;
BgL_z42builtin1232z42_2336 = 
FOREIGN_TO_COBJ(BgL_z42builtin1232z42_1865); 
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1281z00_2337;
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1280z00_2338;
BgL_new1280z00_2338 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2076z00_2339;
BgL_arg2076z00_2339 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1280z00_2338), BgL_arg2076z00_2339); } 
BgL_new1281z00_2337 = BgL_new1280z00_2338; } 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(BgL_new1281z00_2337))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_z42builtin1232z42_2336),BUNSPEC); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_fun2075z00_2340;
BgL_fun2075z00_2340 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2075z00_2340)(BgL_fun2075z00_2340, 
((obj_t)BgL_new1281z00_2337), BEOA); } 
return BgL_new1281z00_2337;} } } 

}



/* &<@anonymous:2190> */
obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1866, obj_t BgL_oz00_1867, obj_t BgL_vz00_1868)
{
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 146 */
uv_process_options_t * BgL_arg2191z00_2341;
BgL_arg2191z00_2341 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1867)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 146 */
int BgL_tmpz00_3188;
BgL_tmpz00_3188 = 
CINT(BgL_vz00_1868); 
BGL_UV_PROCESS_OPTIONS_GID_SET(BgL_arg2191z00_2341, BgL_tmpz00_3188); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2187> */
obj_t BGl_z62zc3z04anonymousza32187ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1869, obj_t BgL_oz00_1870)
{
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 142 */
int BgL_tmpz00_3191;
{ /* Llib/uvtypes.scm 143 */
uv_process_options_t * BgL_arg2188z00_2342;
BgL_arg2188z00_2342 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1870)))->BgL_z42builtinz42); 
BgL_tmpz00_3191 = 
BGL_UV_PROCESS_OPTIONS_GID_GET(BgL_arg2188z00_2342); } 
return 
BINT(BgL_tmpz00_3191);} } 

}



/* &<@anonymous:2180> */
obj_t BGl_z62zc3z04anonymousza32180ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1871, obj_t BgL_oz00_1872, obj_t BgL_vz00_1873)
{
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 138 */
uv_process_options_t * BgL_arg2181z00_2343;
BgL_arg2181z00_2343 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1872)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 138 */
int BgL_tmpz00_3198;
BgL_tmpz00_3198 = 
CINT(BgL_vz00_1873); 
BGL_UV_PROCESS_OPTIONS_UID_SET(BgL_arg2181z00_2343, BgL_tmpz00_3198); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2176> */
obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1874, obj_t BgL_oz00_1875)
{
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 134 */
int BgL_tmpz00_3201;
{ /* Llib/uvtypes.scm 135 */
uv_process_options_t * BgL_arg2178z00_2344;
BgL_arg2178z00_2344 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1875)))->BgL_z42builtinz42); 
BgL_tmpz00_3201 = 
BGL_UV_PROCESS_OPTIONS_UID_GET(BgL_arg2178z00_2344); } 
return 
BINT(BgL_tmpz00_3201);} } 

}



/* &<@anonymous:2169> */
obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1876, obj_t BgL_oz00_1877, obj_t BgL_vz00_1878)
{
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 130 */
uv_process_options_t * BgL_arg2170z00_2345;
BgL_arg2170z00_2345 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1877)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 130 */
int BgL_tmpz00_3208;
BgL_tmpz00_3208 = 
CINT(BgL_vz00_1878); 
BGL_UV_PROCESS_OPTIONS_FLAGS_SET(BgL_arg2170z00_2345, BgL_tmpz00_3208); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2166> */
obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1879, obj_t BgL_oz00_1880)
{
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 126 */
int BgL_tmpz00_3211;
{ /* Llib/uvtypes.scm 127 */
uv_process_options_t * BgL_arg2167z00_2346;
BgL_arg2167z00_2346 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1880)))->BgL_z42builtinz42); 
BgL_tmpz00_3211 = 
BGL_UV_PROCESS_OPTIONS_FLAGS_GET(BgL_arg2167z00_2346); } 
return 
BINT(BgL_tmpz00_3211);} } 

}



/* &<@anonymous:2159> */
obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1881, obj_t BgL_oz00_1882, obj_t BgL_vz00_1883)
{
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 122 */
uv_process_options_t * BgL_arg2160z00_2347;
BgL_arg2160z00_2347 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1882)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 122 */
char * BgL_tmpz00_3218;
BgL_tmpz00_3218 = 
BSTRING_TO_STRING(BgL_vz00_1883); 
BGL_UV_PROCESS_OPTIONS_CWD_SET(BgL_arg2160z00_2347, BgL_tmpz00_3218); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2156> */
obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1884, obj_t BgL_oz00_1885)
{
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 118 */
char * BgL_tmpz00_3221;
{ /* Llib/uvtypes.scm 119 */
uv_process_options_t * BgL_arg2157z00_2348;
BgL_arg2157z00_2348 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1885)))->BgL_z42builtinz42); 
BgL_tmpz00_3221 = 
BGL_UV_PROCESS_OPTIONS_CWD_GET(BgL_arg2157z00_2348); } 
return 
string_to_bstring(BgL_tmpz00_3221);} } 

}



/* &<@anonymous:2149> */
obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1886, obj_t BgL_oz00_1887, obj_t BgL_vz00_1888)
{
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 114 */
uv_process_options_t * BgL_arg2150z00_2349;
BgL_arg2150z00_2349 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1887)))->BgL_z42builtinz42); 
bgl_uv_process_options_env_set(BgL_arg2150z00_2349, BgL_vz00_1888); BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2146> */
obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1889, obj_t BgL_oz00_1890)
{
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 111 */
uv_process_options_t * BgL_arg2147z00_2350;
BgL_arg2147z00_2350 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1890)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_env_get(BgL_arg2147z00_2350);} } 

}



/* &<@anonymous:2139> */
obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1891, obj_t BgL_oz00_1892, obj_t BgL_vz00_1893)
{
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 106 */
uv_process_options_t * BgL_arg2140z00_2351;
BgL_arg2140z00_2351 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1892)))->BgL_z42builtinz42); 
bgl_uv_process_options_args_set(BgL_arg2140z00_2351, BgL_vz00_1893); BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2136> */
obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1894, obj_t BgL_oz00_1895)
{
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 103 */
uv_process_options_t * BgL_arg2137z00_2352;
BgL_arg2137z00_2352 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1895)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_args_get(BgL_arg2137z00_2352);} } 

}



/* &<@anonymous:2129> */
obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1896, obj_t BgL_oz00_1897, obj_t BgL_vz00_1898)
{
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 98 */
uv_process_options_t * BgL_arg2130z00_2353;
BgL_arg2130z00_2353 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1897)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 98 */
char * BgL_tmpz00_3240;
BgL_tmpz00_3240 = 
BSTRING_TO_STRING(BgL_vz00_1898); 
BGL_UV_PROCESS_OPTIONS_FILE_SET(BgL_arg2130z00_2353, BgL_tmpz00_3240); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2126> */
obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1899, obj_t BgL_oz00_1900)
{
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 94 */
char * BgL_tmpz00_3243;
{ /* Llib/uvtypes.scm 95 */
uv_process_options_t * BgL_arg2127z00_2354;
BgL_arg2127z00_2354 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1900)))->BgL_z42builtinz42); 
BgL_tmpz00_3243 = 
BGL_UV_PROCESS_OPTIONS_FILE_GET(BgL_arg2127z00_2354); } 
return 
string_to_bstring(BgL_tmpz00_3243);} } 

}



/* &<@anonymous:2121> */
obj_t BGl_z62zc3z04anonymousza32121ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1901, obj_t BgL_oz00_1902, obj_t BgL_vz00_1903)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1902), 
(int)(((long)6)), BgL_vz00_1903);} 

}



/* &<@anonymous:2120> */
obj_t BGl_z62zc3z04anonymousza32120ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1904, obj_t BgL_oz00_1905)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1905), 
(int)(((long)6)));} 

}



/* &<@anonymous:2116> */
obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1906, obj_t BgL_oz00_1907, obj_t BgL_vz00_1908)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1907), 
(int)(((long)5)), BgL_vz00_1908);} 

}



/* &<@anonymous:2115> */
obj_t BGl_z62zc3z04anonymousza32115ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1909, obj_t BgL_oz00_1910)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1910), 
(int)(((long)5)));} 

}



/* &<@anonymous:2111> */
obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1911, obj_t BgL_oz00_1912, obj_t BgL_vz00_1913)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1912), 
(int)(((long)4)), BgL_vz00_1913);} 

}



/* &<@anonymous:2110> */
obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1914, obj_t BgL_oz00_1915)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1915), 
(int)(((long)4)));} 

}



/* &<@anonymous:2106> */
obj_t BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1916, obj_t BgL_oz00_1917, obj_t BgL_vz00_1918)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1917), 
(int)(((long)3)), BgL_vz00_1918);} 

}



/* &<@anonymous:2105> */
obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1919, obj_t BgL_oz00_1920)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1920), 
(int)(((long)3)));} 

}



/* &<@anonymous:2101> */
obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1921, obj_t BgL_oz00_1922, obj_t BgL_vz00_1923)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1922), 
(int)(((long)2)), BgL_vz00_1923);} 

}



/* &<@anonymous:2100> */
obj_t BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1924, obj_t BgL_oz00_1925)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1925), 
(int)(((long)2)));} 

}



/* &<@anonymous:2096> */
obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1926, obj_t BgL_oz00_1927, obj_t BgL_vz00_1928)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1927), 
(int)(((long)1)), BgL_vz00_1928);} 

}



/* &<@anonymous:2095> */
obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1929, obj_t BgL_oz00_1930)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1930), 
(int)(((long)1)));} 

}



/* &<@anonymous:2091> */
obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1931, obj_t BgL_oz00_1932, obj_t BgL_vz00_1933)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1932), 
(int)(((long)0)), BgL_vz00_1933);} 

}



/* &<@anonymous:2090> */
obj_t BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1934, obj_t BgL_oz00_1935)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1935), 
(int)(((long)0)));} 

}



/* &<@anonymous:2086> */
obj_t BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1936)
{
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
((uv_process_options_t *)GC_MALLOC( sizeof( uv_process_options_t ) )));} 

}



/* &lambda2085 */
obj_t BGl_z62lambda2085z62zz__libuv_typesz00(obj_t BgL_envz00_1937, obj_t BgL_oz00_1938, obj_t BgL_vz00_1939)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_vz00_2356;
BgL_vz00_2356 = 
FOREIGN_TO_COBJ(BgL_vz00_1939); 
return 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1938)))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_vz00_2356),BUNSPEC);} } 

}



/* &lambda2084 */
obj_t BGl_z62lambda2084z62zz__libuv_typesz00(obj_t BgL_envz00_1940, obj_t BgL_oz00_1941)
{
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1941)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2049> */
obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1942, obj_t BgL_new1230z00_1943)
{
{ /* Llib/uvtypes.scm 81 */
{ 
BgL_uvprocessz00_bglt BgL_auxz00_3298;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943)))->BgL_z42onexitz42)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_3298 = 
((BgL_uvprocessz00_bglt)BgL_new1230z00_1943); 
return 
((obj_t)BgL_auxz00_3298);} } 

}



/* &lambda2047 */
BgL_uvprocessz00_bglt BGl_z62lambda2047z62zz__libuv_typesz00(obj_t BgL_envz00_1944)
{
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1229z00_2359;
BgL_new1229z00_2359 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2048z00_2360;
BgL_arg2048z00_2360 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1229z00_2359), BgL_arg2048z00_2360); } 
return BgL_new1229z00_2359;} } 

}



/* &lambda2044 */
BgL_uvprocessz00_bglt BGl_z62lambda2044z62zz__libuv_typesz00(obj_t BgL_envz00_1945, obj_t BgL_z42builtin1223z42_1946, obj_t BgL_z52onclose1224z52_1947, obj_t BgL_z52gcmarkshead1225z52_1948, obj_t BgL_z52gcmarkstail1226z52_1949, obj_t BgL_closed1227z00_1950, obj_t BgL_z42onexit1228z42_1951)
{
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
uv_handle_t * BgL_z42builtin1223z42_2361;bool_t BgL_closed1227z00_2364;
BgL_z42builtin1223z42_2361 = 
FOREIGN_TO_COBJ(BgL_z42builtin1223z42_1946); 
BgL_closed1227z00_2364 = 
CBOOL(BgL_closed1227z00_1950); 
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1278z00_2365;
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1277z00_2366;
BgL_new1277z00_2366 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2046z00_2367;
BgL_arg2046z00_2367 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1277z00_2366), BgL_arg2046z00_2367); } 
BgL_new1278z00_2365 = BgL_new1277z00_2366; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1278z00_2365)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1223z42_2361),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1278z00_2365)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1224z52_1947),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1278z00_2365)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1225z52_1948)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1278z00_2365)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1226z52_1949)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1278z00_2365)))->BgL_closedz00)=((bool_t)BgL_closed1227z00_2364),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(BgL_new1278z00_2365))->BgL_z42onexitz42)=((obj_t)BgL_z42onexit1228z42_1951),BUNSPEC); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_fun2045z00_2368;
BgL_fun2045z00_2368 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2045z00_2368)(BgL_fun2045z00_2368, 
((obj_t)BgL_new1278z00_2365), BEOA); } 
return BgL_new1278z00_2365;} } } 

}



/* &<@anonymous:2065> */
obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1952, obj_t BgL_oz00_1953)
{
{ /* Llib/uvtypes.scm 83 */
{ /* Llib/uvtypes.scm 85 */
int BgL_tmpz00_3348;
{ /* Llib/uvtypes.scm 86 */
uv_process_t * BgL_arg2066z00_2369;
{ /* Llib/uvtypes.scm 86 */
uv_handle_t * BgL_arg2067z00_2370;
BgL_arg2067z00_2370 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_oz00_1953))))->BgL_z42builtinz42); 
BgL_arg2066z00_2369 = 
(uv_process_t *)(BgL_arg2067z00_2370); } 
BgL_tmpz00_3348 = 
(BgL_arg2066z00_2369->pid); } 
return 
BINT(BgL_tmpz00_3348);} } 

}



/* &<@anonymous:2061> */
obj_t BGl_z62zc3z04anonymousza32061ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1954, obj_t BgL_oz00_1955, obj_t BgL_vz00_1956)
{
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1955), 
(int)(((long)0)), BgL_vz00_1956);} 

}



/* &<@anonymous:2060> */
obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1957, obj_t BgL_oz00_1958)
{
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1958), 
(int)(((long)0)));} 

}



/* &<@anonymous:2056> */
obj_t BGl_z62zc3z04anonymousza32056ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1959)
{
{ /* Llib/uvtypes.scm 81 */
return BUNSPEC;} 

}



/* &lambda2055 */
obj_t BGl_z62lambda2055z62zz__libuv_typesz00(obj_t BgL_envz00_1960, obj_t BgL_oz00_1961, obj_t BgL_vz00_1962)
{
{ /* Llib/uvtypes.scm 81 */
return 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_1961)))->BgL_z42onexitz42)=((obj_t)BgL_vz00_1962),BUNSPEC);} 

}



/* &lambda2054 */
obj_t BGl_z62lambda2054z62zz__libuv_typesz00(obj_t BgL_envz00_1963, obj_t BgL_oz00_1964)
{
{ /* Llib/uvtypes.scm 81 */
return 
(((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_1964)))->BgL_z42onexitz42);} 

}



/* &<@anonymous:2038> */
obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1965, obj_t BgL_new1221z00_1966)
{
{ /* Llib/uvtypes.scm 79 */
{ 
BgL_uvcheckz00_bglt BgL_auxz00_3365;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3382;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_classz00_2374;
BgL_classz00_2374 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL__ortest_1111z00_2375;
BgL__ortest_1111z00_2375 = 
BGL_CLASS_NIL(BgL_classz00_2374); 
if(
CBOOL(BgL__ortest_1111z00_2375))
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3382 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2375)
; }  else 
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3382 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2374))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3382),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3365 = 
((BgL_uvcheckz00_bglt)BgL_new1221z00_1966); 
return 
((obj_t)BgL_auxz00_3365);} } 

}



/* &lambda2036 */
BgL_uvcheckz00_bglt BGl_z62lambda2036z62zz__libuv_typesz00(obj_t BgL_envz00_1967)
{
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1220z00_2376;
BgL_new1220z00_2376 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2037z00_2377;
BgL_arg2037z00_2377 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1220z00_2376), BgL_arg2037z00_2377); } 
return BgL_new1220z00_2376;} } 

}



/* &lambda2033 */
BgL_uvcheckz00_bglt BGl_z62lambda2033z62zz__libuv_typesz00(obj_t BgL_envz00_1968, obj_t BgL_z42builtin1213z42_1969, obj_t BgL_z52onclose1214z52_1970, obj_t BgL_z52gcmarkshead1215z52_1971, obj_t BgL_z52gcmarkstail1216z52_1972, obj_t BgL_closed1217z00_1973, obj_t BgL_loop1218z00_1974, obj_t BgL_cb1219z00_1975)
{
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
uv_handle_t * BgL_z42builtin1213z42_2378;bool_t BgL_closed1217z00_2381;
BgL_z42builtin1213z42_2378 = 
FOREIGN_TO_COBJ(BgL_z42builtin1213z42_1969); 
BgL_closed1217z00_2381 = 
CBOOL(BgL_closed1217z00_1973); 
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1276z00_2384;
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1275z00_2385;
BgL_new1275z00_2385 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2035z00_2386;
BgL_arg2035z00_2386 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1275z00_2385), BgL_arg2035z00_2386); } 
BgL_new1276z00_2384 = BgL_new1275z00_2385; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1276z00_2384)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1213z42_2378),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1276z00_2384)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1214z52_1970),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1276z00_2384)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1215z52_1971)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1276z00_2384)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1216z52_1972)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1276z00_2384)))->BgL_closedz00)=((bool_t)BgL_closed1217z00_2381),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1276z00_2384)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1218z00_1974)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1276z00_2384)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1219z00_1975)),BUNSPEC); 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_fun2034z00_2387;
BgL_fun2034z00_2387 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvCheckz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2034z00_2387)(BgL_fun2034z00_2387, 
((obj_t)BgL_new1276z00_2384), BEOA); } 
return BgL_new1276z00_2384;} } } 

}



/* &<@anonymous:2027> */
obj_t BGl_z62zc3z04anonymousza32027ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1976, obj_t BgL_new1211z00_1977)
{
{ /* Llib/uvtypes.scm 77 */
{ 
BgL_uvfspollz00_bglt BgL_auxz00_3431;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3448;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_classz00_2389;
BgL_classz00_2389 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL__ortest_1111z00_2390;
BgL__ortest_1111z00_2390 = 
BGL_CLASS_NIL(BgL_classz00_2389); 
if(
CBOOL(BgL__ortest_1111z00_2390))
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3448 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2390)
; }  else 
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3448 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2389))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3448),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3431 = 
((BgL_uvfspollz00_bglt)BgL_new1211z00_1977); 
return 
((obj_t)BgL_auxz00_3431);} } 

}



/* &lambda2025 */
BgL_uvfspollz00_bglt BGl_z62lambda2025z62zz__libuv_typesz00(obj_t BgL_envz00_1978)
{
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1210z00_2391;
BgL_new1210z00_2391 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2026z00_2392;
BgL_arg2026z00_2392 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1210z00_2391), BgL_arg2026z00_2392); } 
return BgL_new1210z00_2391;} } 

}



/* &lambda2022 */
BgL_uvfspollz00_bglt BGl_z62lambda2022z62zz__libuv_typesz00(obj_t BgL_envz00_1979, obj_t BgL_z42builtin1203z42_1980, obj_t BgL_z52onclose1204z52_1981, obj_t BgL_z52gcmarkshead1205z52_1982, obj_t BgL_z52gcmarkstail1206z52_1983, obj_t BgL_closed1207z00_1984, obj_t BgL_loop1208z00_1985, obj_t BgL_cb1209z00_1986)
{
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
uv_handle_t * BgL_z42builtin1203z42_2393;bool_t BgL_closed1207z00_2396;
BgL_z42builtin1203z42_2393 = 
FOREIGN_TO_COBJ(BgL_z42builtin1203z42_1980); 
BgL_closed1207z00_2396 = 
CBOOL(BgL_closed1207z00_1984); 
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1274z00_2399;
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1273z00_2400;
BgL_new1273z00_2400 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2024z00_2401;
BgL_arg2024z00_2401 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1273z00_2400), BgL_arg2024z00_2401); } 
BgL_new1274z00_2399 = BgL_new1273z00_2400; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1274z00_2399)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1203z42_2393),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1274z00_2399)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1204z52_1981),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1274z00_2399)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1205z52_1982)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1274z00_2399)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1206z52_1983)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1274z00_2399)))->BgL_closedz00)=((bool_t)BgL_closed1207z00_2396),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1274z00_2399)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1208z00_1985)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1274z00_2399)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1209z00_1986)),BUNSPEC); 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_fun2023z00_2402;
BgL_fun2023z00_2402 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2023z00_2402)(BgL_fun2023z00_2402, 
((obj_t)BgL_new1274z00_2399), BEOA); } 
return BgL_new1274z00_2399;} } } 

}



/* &<@anonymous:2016> */
obj_t BGl_z62zc3z04anonymousza32016ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1987, obj_t BgL_new1201z00_1988)
{
{ /* Llib/uvtypes.scm 75 */
{ 
BgL_uvfseventz00_bglt BgL_auxz00_3497;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3514;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_classz00_2404;
BgL_classz00_2404 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL__ortest_1111z00_2405;
BgL__ortest_1111z00_2405 = 
BGL_CLASS_NIL(BgL_classz00_2404); 
if(
CBOOL(BgL__ortest_1111z00_2405))
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3514 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2405)
; }  else 
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3514 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2404))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3514),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3497 = 
((BgL_uvfseventz00_bglt)BgL_new1201z00_1988); 
return 
((obj_t)BgL_auxz00_3497);} } 

}



/* &lambda2014 */
BgL_uvfseventz00_bglt BGl_z62lambda2014z62zz__libuv_typesz00(obj_t BgL_envz00_1989)
{
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1200z00_2406;
BgL_new1200z00_2406 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg2015z00_2407;
BgL_arg2015z00_2407 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1200z00_2406), BgL_arg2015z00_2407); } 
return BgL_new1200z00_2406;} } 

}



/* &lambda2011 */
BgL_uvfseventz00_bglt BGl_z62lambda2011z62zz__libuv_typesz00(obj_t BgL_envz00_1990, obj_t BgL_z42builtin1193z42_1991, obj_t BgL_z52onclose1194z52_1992, obj_t BgL_z52gcmarkshead1195z52_1993, obj_t BgL_z52gcmarkstail1196z52_1994, obj_t BgL_closed1197z00_1995, obj_t BgL_loop1198z00_1996, obj_t BgL_cb1199z00_1997)
{
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
uv_handle_t * BgL_z42builtin1193z42_2408;bool_t BgL_closed1197z00_2411;
BgL_z42builtin1193z42_2408 = 
FOREIGN_TO_COBJ(BgL_z42builtin1193z42_1991); 
BgL_closed1197z00_2411 = 
CBOOL(BgL_closed1197z00_1995); 
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1272z00_2414;
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1271z00_2415;
BgL_new1271z00_2415 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg2013z00_2416;
BgL_arg2013z00_2416 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1271z00_2415), BgL_arg2013z00_2416); } 
BgL_new1272z00_2414 = BgL_new1271z00_2415; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1272z00_2414)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1193z42_2408),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1272z00_2414)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1194z52_1992),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1272z00_2414)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1195z52_1993)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1272z00_2414)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1196z52_1994)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1272z00_2414)))->BgL_closedz00)=((bool_t)BgL_closed1197z00_2411),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1272z00_2414)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1198z00_1996)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1272z00_2414)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1199z00_1997)),BUNSPEC); 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_fun2012z00_2417;
BgL_fun2012z00_2417 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsEventz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2012z00_2417)(BgL_fun2012z00_2417, 
((obj_t)BgL_new1272z00_2414), BEOA); } 
return BgL_new1272z00_2414;} } } 

}



/* &<@anonymous:1995> */
obj_t BGl_z62zc3z04anonymousza31995ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1998, obj_t BgL_new1191z00_1999)
{
{ /* Llib/uvtypes.scm 71 */
{ 
BgL_uvfilez00_bglt BgL_auxz00_3563;
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1191z00_1999)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1191z00_1999)))->BgL_pathz00)=((obj_t)BGl_string2243z00zz__libuv_typesz00),BUNSPEC); 
BgL_auxz00_3563 = 
((BgL_uvfilez00_bglt)BgL_new1191z00_1999); 
return 
((obj_t)BgL_auxz00_3563);} } 

}



/* &lambda1993 */
BgL_uvfilez00_bglt BGl_z62lambda1993z62zz__libuv_typesz00(obj_t BgL_envz00_2000)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1190z00_2419;
BgL_new1190z00_2419 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1994z00_2420;
BgL_arg1994z00_2420 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1190z00_2419), BgL_arg1994z00_2420); } 
return BgL_new1190z00_2419;} } 

}



/* &lambda1991 */
BgL_uvfilez00_bglt BGl_z62lambda1991z62zz__libuv_typesz00(obj_t BgL_envz00_2001, obj_t BgL_fd1188z00_2002, obj_t BgL_path1189z00_2003)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_fd1188z00_2421;
BgL_fd1188z00_2421 = 
CINT(BgL_fd1188z00_2002); 
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1270z00_2423;
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1269z00_2424;
BgL_new1269z00_2424 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1992z00_2425;
BgL_arg1992z00_2425 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1269z00_2424), BgL_arg1992z00_2425); } 
BgL_new1270z00_2423 = BgL_new1269z00_2424; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1270z00_2423))->BgL_fdz00)=((int)BgL_fd1188z00_2421),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1270z00_2423))->BgL_pathz00)=((obj_t)
((obj_t)BgL_path1189z00_2003)),BUNSPEC); 
return BgL_new1270z00_2423;} } } 

}



/* &lambda2005 */
obj_t BGl_z62lambda2005z62zz__libuv_typesz00(obj_t BgL_envz00_2004, obj_t BgL_oz00_2005, obj_t BgL_vz00_2006)
{
{ /* Llib/uvtypes.scm 71 */
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2005)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_vz00_2006)),BUNSPEC);} 

}



/* &lambda2004 */
obj_t BGl_z62lambda2004z62zz__libuv_typesz00(obj_t BgL_envz00_2007, obj_t BgL_oz00_2008)
{
{ /* Llib/uvtypes.scm 71 */
return 
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2008)))->BgL_pathz00);} 

}



/* &lambda2000 */
obj_t BGl_z62lambda2000z62zz__libuv_typesz00(obj_t BgL_envz00_2009, obj_t BgL_oz00_2010, obj_t BgL_vz00_2011)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_vz00_2430;
BgL_vz00_2430 = 
CINT(BgL_vz00_2011); 
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2010)))->BgL_fdz00)=((int)BgL_vz00_2430),BUNSPEC);} } 

}



/* &lambda1999 */
obj_t BGl_z62lambda1999z62zz__libuv_typesz00(obj_t BgL_envz00_2012, obj_t BgL_oz00_2013)
{
{ /* Llib/uvtypes.scm 71 */
return 
BINT(
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2013)))->BgL_fdz00));} 

}



/* &<@anonymous:1980> */
obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2014, obj_t BgL_new1186z00_2015)
{
{ /* Llib/uvtypes.scm 68 */
{ 
BgL_uvpollz00_bglt BgL_auxz00_3594;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3611;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_classz00_2433;
BgL_classz00_2433 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL__ortest_1111z00_2434;
BgL__ortest_1111z00_2434 = 
BGL_CLASS_NIL(BgL_classz00_2433); 
if(
CBOOL(BgL__ortest_1111z00_2434))
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3611 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2434)
; }  else 
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3611 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2433))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3611),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1186z00_2015))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_new1186z00_2015)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_3594 = 
((BgL_uvpollz00_bglt)BgL_new1186z00_2015); 
return 
((obj_t)BgL_auxz00_3594);} } 

}



/* &lambda1978 */
BgL_uvpollz00_bglt BGl_z62lambda1978z62zz__libuv_typesz00(obj_t BgL_envz00_2016)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1185z00_2435;
BgL_new1185z00_2435 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1979z00_2436;
BgL_arg1979z00_2436 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1185z00_2435), BgL_arg1979z00_2436); } 
return BgL_new1185z00_2435;} } 

}



/* &lambda1975 */
BgL_uvpollz00_bglt BGl_z62lambda1975z62zz__libuv_typesz00(obj_t BgL_envz00_2017, obj_t BgL_z42builtin1177z42_2018, obj_t BgL_z52onclose1178z52_2019, obj_t BgL_z52gcmarkshead1179z52_2020, obj_t BgL_z52gcmarkstail1180z52_2021, obj_t BgL_closed1181z00_2022, obj_t BgL_loop1182z00_2023, obj_t BgL_cb1183z00_2024, obj_t BgL_fd1184z00_2025)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
uv_handle_t * BgL_z42builtin1177z42_2437;bool_t BgL_closed1181z00_2440;int BgL_fd1184z00_2443;
BgL_z42builtin1177z42_2437 = 
FOREIGN_TO_COBJ(BgL_z42builtin1177z42_2018); 
BgL_closed1181z00_2440 = 
CBOOL(BgL_closed1181z00_2022); 
BgL_fd1184z00_2443 = 
CINT(BgL_fd1184z00_2025); 
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1268z00_2444;
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1267z00_2445;
BgL_new1267z00_2445 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1977z00_2446;
BgL_arg1977z00_2446 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1267z00_2445), BgL_arg1977z00_2446); } 
BgL_new1268z00_2444 = BgL_new1267z00_2445; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1268z00_2444)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1177z42_2437),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1268z00_2444)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1178z52_2019),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1268z00_2444)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1179z52_2020)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1268z00_2444)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1180z52_2021)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1268z00_2444)))->BgL_closedz00)=((bool_t)BgL_closed1181z00_2440),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1268z00_2444)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1182z00_2023)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1268z00_2444)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1183z00_2024)),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(BgL_new1268z00_2444))->BgL_fdz00)=((int)BgL_fd1184z00_2443),BUNSPEC); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_fun1976z00_2447;
BgL_fun1976z00_2447 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1976z00_2447)(BgL_fun1976z00_2447, 
((obj_t)BgL_new1268z00_2444), BEOA); } 
return BgL_new1268z00_2444;} } } 

}



/* &lambda1985 */
obj_t BGl_z62lambda1985z62zz__libuv_typesz00(obj_t BgL_envz00_2026, obj_t BgL_oz00_2027, obj_t BgL_vz00_2028)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
int BgL_vz00_2449;
BgL_vz00_2449 = 
CINT(BgL_vz00_2028); 
return 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2027)))->BgL_fdz00)=((int)BgL_vz00_2449),BUNSPEC);} } 

}



/* &lambda1984 */
obj_t BGl_z62lambda1984z62zz__libuv_typesz00(obj_t BgL_envz00_2029, obj_t BgL_oz00_2030)
{
{ /* Llib/uvtypes.scm 68 */
return 
BINT(
(((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2030)))->BgL_fdz00));} 

}



/* &<@anonymous:1969> */
obj_t BGl_z62zc3z04anonymousza31969ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2031, obj_t BgL_new1175z00_2032)
{
{ /* Llib/uvtypes.scm 66 */
{ 
BgL_uvasyncz00_bglt BgL_auxz00_3671;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3688;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_classz00_2452;
BgL_classz00_2452 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL__ortest_1111z00_2453;
BgL__ortest_1111z00_2453 = 
BGL_CLASS_NIL(BgL_classz00_2452); 
if(
CBOOL(BgL__ortest_1111z00_2453))
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3688 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2453)
; }  else 
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3688 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2452))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3688),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3671 = 
((BgL_uvasyncz00_bglt)BgL_new1175z00_2032); 
return 
((obj_t)BgL_auxz00_3671);} } 

}



/* &lambda1967 */
BgL_uvasyncz00_bglt BGl_z62lambda1967z62zz__libuv_typesz00(obj_t BgL_envz00_2033)
{
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1174z00_2454;
BgL_new1174z00_2454 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1968z00_2455;
BgL_arg1968z00_2455 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1174z00_2454), BgL_arg1968z00_2455); } 
return BgL_new1174z00_2454;} } 

}



/* &lambda1964 */
BgL_uvasyncz00_bglt BGl_z62lambda1964z62zz__libuv_typesz00(obj_t BgL_envz00_2034, obj_t BgL_z42builtin1167z42_2035, obj_t BgL_z52onclose1168z52_2036, obj_t BgL_z52gcmarkshead1169z52_2037, obj_t BgL_z52gcmarkstail1170z52_2038, obj_t BgL_closed1171z00_2039, obj_t BgL_loop1172z00_2040, obj_t BgL_cb1173z00_2041)
{
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
uv_handle_t * BgL_z42builtin1167z42_2456;bool_t BgL_closed1171z00_2459;
BgL_z42builtin1167z42_2456 = 
FOREIGN_TO_COBJ(BgL_z42builtin1167z42_2035); 
BgL_closed1171z00_2459 = 
CBOOL(BgL_closed1171z00_2039); 
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1266z00_2462;
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1265z00_2463;
BgL_new1265z00_2463 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1966z00_2464;
BgL_arg1966z00_2464 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1265z00_2463), BgL_arg1966z00_2464); } 
BgL_new1266z00_2462 = BgL_new1265z00_2463; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1266z00_2462)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1167z42_2456),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1266z00_2462)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1168z52_2036),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1266z00_2462)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1169z52_2037)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1266z00_2462)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1170z52_2038)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1266z00_2462)))->BgL_closedz00)=((bool_t)BgL_closed1171z00_2459),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1266z00_2462)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1172z00_2040)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1266z00_2462)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1173z00_2041)),BUNSPEC); 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_fun1965z00_2465;
BgL_fun1965z00_2465 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvAsyncz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1965z00_2465)(BgL_fun1965z00_2465, 
((obj_t)BgL_new1266z00_2462), BEOA); } 
return BgL_new1266z00_2462;} } } 

}



/* &<@anonymous:1958> */
obj_t BGl_z62zc3z04anonymousza31958ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2042, obj_t BgL_new1165z00_2043)
{
{ /* Llib/uvtypes.scm 64 */
{ 
BgL_uvidlez00_bglt BgL_auxz00_3737;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3754;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_classz00_2467;
BgL_classz00_2467 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL__ortest_1111z00_2468;
BgL__ortest_1111z00_2468 = 
BGL_CLASS_NIL(BgL_classz00_2467); 
if(
CBOOL(BgL__ortest_1111z00_2468))
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3754 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2468)
; }  else 
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3754 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2467))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3754),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1165z00_2043))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3737 = 
((BgL_uvidlez00_bglt)BgL_new1165z00_2043); 
return 
((obj_t)BgL_auxz00_3737);} } 

}



/* &lambda1956 */
BgL_uvidlez00_bglt BGl_z62lambda1956z62zz__libuv_typesz00(obj_t BgL_envz00_2044)
{
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1164z00_2469;
BgL_new1164z00_2469 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1957z00_2470;
BgL_arg1957z00_2470 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1164z00_2469), BgL_arg1957z00_2470); } 
return BgL_new1164z00_2469;} } 

}



/* &lambda1953 */
BgL_uvidlez00_bglt BGl_z62lambda1953z62zz__libuv_typesz00(obj_t BgL_envz00_2045, obj_t BgL_z42builtin1157z42_2046, obj_t BgL_z52onclose1158z52_2047, obj_t BgL_z52gcmarkshead1159z52_2048, obj_t BgL_z52gcmarkstail1160z52_2049, obj_t BgL_closed1161z00_2050, obj_t BgL_loop1162z00_2051, obj_t BgL_cb1163z00_2052)
{
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
uv_handle_t * BgL_z42builtin1157z42_2471;bool_t BgL_closed1161z00_2474;
BgL_z42builtin1157z42_2471 = 
FOREIGN_TO_COBJ(BgL_z42builtin1157z42_2046); 
BgL_closed1161z00_2474 = 
CBOOL(BgL_closed1161z00_2050); 
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1264z00_2477;
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1263z00_2478;
BgL_new1263z00_2478 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1955z00_2479;
BgL_arg1955z00_2479 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1263z00_2478), BgL_arg1955z00_2479); } 
BgL_new1264z00_2477 = BgL_new1263z00_2478; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1264z00_2477)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1157z42_2471),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1264z00_2477)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1158z52_2047),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1264z00_2477)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1159z52_2048)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1264z00_2477)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1160z52_2049)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1264z00_2477)))->BgL_closedz00)=((bool_t)BgL_closed1161z00_2474),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1264z00_2477)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1162z00_2051)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1264z00_2477)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1163z00_2052)),BUNSPEC); 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_fun1954z00_2480;
BgL_fun1954z00_2480 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvIdlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1954z00_2480)(BgL_fun1954z00_2480, 
((obj_t)BgL_new1264z00_2477), BEOA); } 
return BgL_new1264z00_2477;} } } 

}



/* &<@anonymous:1933> */
obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2053, obj_t BgL_new1155z00_2054)
{
{ /* Llib/uvtypes.scm 60 */
{ 
BgL_uvtimerz00_bglt BgL_auxz00_3803;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3820;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_classz00_2482;
BgL_classz00_2482 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL__ortest_1111z00_2483;
BgL__ortest_1111z00_2483 = 
BGL_CLASS_NIL(BgL_classz00_2482); 
if(
CBOOL(BgL__ortest_1111z00_2483))
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3820 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2483)
; }  else 
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3820 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2482))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3820),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054)))->BgL_repeatz00)=((uint64_t)
0L),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054)))->BgL_refz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3803 = 
((BgL_uvtimerz00_bglt)BgL_new1155z00_2054); 
return 
((obj_t)BgL_auxz00_3803);} } 

}



/* &lambda1931 */
BgL_uvtimerz00_bglt BGl_z62lambda1931z62zz__libuv_typesz00(obj_t BgL_envz00_2055)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1154z00_2484;
BgL_new1154z00_2484 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1932z00_2485;
BgL_arg1932z00_2485 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1154z00_2484), BgL_arg1932z00_2485); } 
return BgL_new1154z00_2484;} } 

}



/* &lambda1928 */
BgL_uvtimerz00_bglt BGl_z62lambda1928z62zz__libuv_typesz00(obj_t BgL_envz00_2056, obj_t BgL_z42builtin1145z42_2057, obj_t BgL_z52onclose1146z52_2058, obj_t BgL_z52gcmarkshead1147z52_2059, obj_t BgL_z52gcmarkstail1148z52_2060, obj_t BgL_closed1149z00_2061, obj_t BgL_loop1150z00_2062, obj_t BgL_cb1151z00_2063, obj_t BgL_repeat1152z00_2064, obj_t BgL_ref1153z00_2065)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uv_handle_t * BgL_z42builtin1145z42_2486;bool_t BgL_closed1149z00_2489;uint64_t BgL_repeat1152z00_2492;bool_t BgL_ref1153z00_2493;
BgL_z42builtin1145z42_2486 = 
FOREIGN_TO_COBJ(BgL_z42builtin1145z42_2057); 
BgL_closed1149z00_2489 = 
CBOOL(BgL_closed1149z00_2061); 
BgL_repeat1152z00_2492 = 
BGL_BINT64_TO_INT64(BgL_repeat1152z00_2064); 
BgL_ref1153z00_2493 = 
CBOOL(BgL_ref1153z00_2065); 
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1262z00_2494;
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1261z00_2495;
BgL_new1261z00_2495 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1930z00_2496;
BgL_arg1930z00_2496 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1261z00_2495), BgL_arg1930z00_2496); } 
BgL_new1262z00_2494 = BgL_new1261z00_2495; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1262z00_2494)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1145z42_2486),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1262z00_2494)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1146z52_2058),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1262z00_2494)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1147z52_2059)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1262z00_2494)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1148z52_2060)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1262z00_2494)))->BgL_closedz00)=((bool_t)BgL_closed1149z00_2489),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1262z00_2494)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1150z00_2062)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1262z00_2494)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1151z00_2063)),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1262z00_2494))->BgL_repeatz00)=((uint64_t)BgL_repeat1152z00_2492),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1262z00_2494))->BgL_refz00)=((bool_t)BgL_ref1153z00_2493),BUNSPEC); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_fun1929z00_2497;
BgL_fun1929z00_2497 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTimerz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1929z00_2497)(BgL_fun1929z00_2497, 
((obj_t)BgL_new1262z00_2494), BEOA); } 
return BgL_new1262z00_2494;} } } 

}



/* &<@anonymous:1947> */
obj_t BGl_z62zc3z04anonymousza31947ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2066)
{
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(((bool_t)1));} 

}



/* &lambda1946 */
obj_t BGl_z62lambda1946z62zz__libuv_typesz00(obj_t BgL_envz00_2067, obj_t BgL_oz00_2068, obj_t BgL_vz00_2069)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
bool_t BgL_vz00_2499;
BgL_vz00_2499 = 
CBOOL(BgL_vz00_2069); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2068)))->BgL_refz00)=((bool_t)BgL_vz00_2499),BUNSPEC);} } 

}



/* &lambda1945 */
obj_t BGl_z62lambda1945z62zz__libuv_typesz00(obj_t BgL_envz00_2070, obj_t BgL_oz00_2071)
{
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2071)))->BgL_refz00));} 

}



/* &<@anonymous:1940> */
obj_t BGl_z62zc3z04anonymousza31940ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2072)
{
{ /* Llib/uvtypes.scm 60 */
return 
BGL_UINT64_TO_BUINT64((uint64_t)(0));} 

}



/* &lambda1939 */
obj_t BGl_z62lambda1939z62zz__libuv_typesz00(obj_t BgL_envz00_2073, obj_t BgL_oz00_2074, obj_t BgL_vz00_2075)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_vz00_2502;
BgL_vz00_2502 = 
BGL_BINT64_TO_INT64(BgL_vz00_2075); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2074)))->BgL_repeatz00)=((uint64_t)BgL_vz00_2502),BUNSPEC);} } 

}



/* &lambda1938 */
obj_t BGl_z62lambda1938z62zz__libuv_typesz00(obj_t BgL_envz00_2076, obj_t BgL_oz00_2077)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_tmpz00_3889;
BgL_tmpz00_3889 = 
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2077)))->BgL_repeatz00); 
return 
BGL_UINT64_TO_BUINT64(BgL_tmpz00_3889);} } 

}



/* &<@anonymous:1912> */
obj_t BGl_z62zc3z04anonymousza31912ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2078, obj_t BgL_new1143z00_2079)
{
{ /* Llib/uvtypes.scm 56 */
{ 
BgL_uvttyz00_bglt BgL_auxz00_3893;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3910;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_classz00_2505;
BgL_classz00_2505 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL__ortest_1111z00_2506;
BgL__ortest_1111z00_2506 = 
BGL_CLASS_NIL(BgL_classz00_2505); 
if(
CBOOL(BgL__ortest_1111z00_2506))
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_3910 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2506)
; }  else 
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_3910 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2505))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3910),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1143z00_2079))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1143z00_2079)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1143z00_2079)))->BgL_readablez00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3893 = 
((BgL_uvttyz00_bglt)BgL_new1143z00_2079); 
return 
((obj_t)BgL_auxz00_3893);} } 

}



/* &lambda1910 */
BgL_uvttyz00_bglt BGl_z62lambda1910z62zz__libuv_typesz00(obj_t BgL_envz00_2080)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1142z00_2507;
BgL_new1142z00_2507 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1911z00_2508;
BgL_arg1911z00_2508 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_2507), BgL_arg1911z00_2508); } 
return BgL_new1142z00_2507;} } 

}



/* &lambda1907 */
BgL_uvttyz00_bglt BGl_z62lambda1907z62zz__libuv_typesz00(obj_t BgL_envz00_2081, obj_t BgL_z42builtin1129z42_2082, obj_t BgL_z52onclose1130z52_2083, obj_t BgL_z52gcmarkshead1131z52_2084, obj_t BgL_z52gcmarkstail1132z52_2085, obj_t BgL_closed1133z00_2086, obj_t BgL_loop1134z00_2087, obj_t BgL_z52alloc1135z52_2088, obj_t BgL_z52offset1136z52_2089, obj_t BgL_z52proca1137z52_2090, obj_t BgL_z52procc1138z52_2091, obj_t BgL_z52callback1139z52_2092, obj_t BgL_fd1140z00_2093, obj_t BgL_readable1141z00_2094)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
uv_handle_t * BgL_z42builtin1129z42_2509;bool_t BgL_closed1133z00_2512;int BgL_fd1140z00_2514;bool_t BgL_readable1141z00_2515;
BgL_z42builtin1129z42_2509 = 
FOREIGN_TO_COBJ(BgL_z42builtin1129z42_2082); 
BgL_closed1133z00_2512 = 
CBOOL(BgL_closed1133z00_2086); 
BgL_fd1140z00_2514 = 
CINT(BgL_fd1140z00_2093); 
BgL_readable1141z00_2515 = 
CBOOL(BgL_readable1141z00_2094); 
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1260z00_2516;
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1259z00_2517;
BgL_new1259z00_2517 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1909z00_2518;
BgL_arg1909z00_2518 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1259z00_2517), BgL_arg1909z00_2518); } 
BgL_new1260z00_2516 = BgL_new1259z00_2517; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1260z00_2516)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1129z42_2509),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1260z00_2516)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1130z52_2083),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1260z00_2516)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1131z52_2084)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1260z00_2516)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1132z52_2085)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1260z00_2516)))->BgL_closedz00)=((bool_t)BgL_closed1133z00_2512),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1134z00_2087)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1135z52_2088),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1136z52_2089),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1137z52_2090),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1138z52_2091),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1260z00_2516)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1139z52_2092),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1260z00_2516))->BgL_fdz00)=((int)BgL_fd1140z00_2514),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1260z00_2516))->BgL_readablez00)=((bool_t)BgL_readable1141z00_2515),BUNSPEC); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_fun1908z00_2519;
BgL_fun1908z00_2519 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTtyz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1908z00_2519)(BgL_fun1908z00_2519, 
((obj_t)BgL_new1260z00_2516), BEOA); } 
return BgL_new1260z00_2516;} } } 

}



/* &lambda1922 */
obj_t BGl_z62lambda1922z62zz__libuv_typesz00(obj_t BgL_envz00_2095, obj_t BgL_oz00_2096, obj_t BgL_vz00_2097)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
bool_t BgL_vz00_2521;
BgL_vz00_2521 = 
CBOOL(BgL_vz00_2097); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2096)))->BgL_readablez00)=((bool_t)BgL_vz00_2521),BUNSPEC);} } 

}



/* &lambda1921 */
obj_t BGl_z62lambda1921z62zz__libuv_typesz00(obj_t BgL_envz00_2098, obj_t BgL_oz00_2099)
{
{ /* Llib/uvtypes.scm 56 */
return 
BBOOL(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2099)))->BgL_readablez00));} 

}



/* &lambda1917 */
obj_t BGl_z62lambda1917z62zz__libuv_typesz00(obj_t BgL_envz00_2100, obj_t BgL_oz00_2101, obj_t BgL_vz00_2102)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
int BgL_vz00_2524;
BgL_vz00_2524 = 
CINT(BgL_vz00_2102); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2101)))->BgL_fdz00)=((int)BgL_vz00_2524),BUNSPEC);} } 

}



/* &lambda1916 */
obj_t BGl_z62lambda1916z62zz__libuv_typesz00(obj_t BgL_envz00_2103, obj_t BgL_oz00_2104)
{
{ /* Llib/uvtypes.scm 56 */
return 
BINT(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2104)))->BgL_fdz00));} 

}



/* &<@anonymous:1894> */
obj_t BGl_z62zc3z04anonymousza31894ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2105, obj_t BgL_new1127z00_2106)
{
{ /* Llib/uvtypes.scm 53 */
{ 
BgL_uvpipez00_bglt BgL_auxz00_3999;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4016;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_classz00_2527;
BgL_classz00_2527 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL__ortest_1111z00_2528;
BgL__ortest_1111z00_2528 = 
BGL_CLASS_NIL(BgL_classz00_2527); 
if(
CBOOL(BgL__ortest_1111z00_2528))
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4016 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2528)
; }  else 
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4016 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2527))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4016),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1127z00_2106))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_new1127z00_2106)))->BgL_ipcz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3999 = 
((BgL_uvpipez00_bglt)BgL_new1127z00_2106); 
return 
((obj_t)BgL_auxz00_3999);} } 

}



/* &lambda1892 */
BgL_uvpipez00_bglt BGl_z62lambda1892z62zz__libuv_typesz00(obj_t BgL_envz00_2107)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1126z00_2529;
BgL_new1126z00_2529 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1893z00_2530;
BgL_arg1893z00_2530 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_2529), BgL_arg1893z00_2530); } 
return BgL_new1126z00_2529;} } 

}



/* &lambda1889 */
BgL_uvpipez00_bglt BGl_z62lambda1889z62zz__libuv_typesz00(obj_t BgL_envz00_2108, obj_t BgL_z42builtin1114z42_2109, obj_t BgL_z52onclose1115z52_2110, obj_t BgL_z52gcmarkshead1116z52_2111, obj_t BgL_z52gcmarkstail1117z52_2112, obj_t BgL_closed1118z00_2113, obj_t BgL_loop1119z00_2114, obj_t BgL_z52alloc1120z52_2115, obj_t BgL_z52offset1121z52_2116, obj_t BgL_z52proca1122z52_2117, obj_t BgL_z52procc1123z52_2118, obj_t BgL_z52callback1124z52_2119, obj_t BgL_ipc1125z00_2120)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
uv_handle_t * BgL_z42builtin1114z42_2531;bool_t BgL_closed1118z00_2534;bool_t BgL_ipc1125z00_2536;
BgL_z42builtin1114z42_2531 = 
FOREIGN_TO_COBJ(BgL_z42builtin1114z42_2109); 
BgL_closed1118z00_2534 = 
CBOOL(BgL_closed1118z00_2113); 
BgL_ipc1125z00_2536 = 
CBOOL(BgL_ipc1125z00_2120); 
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1258z00_2537;
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1257z00_2538;
BgL_new1257z00_2538 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1891z00_2539;
BgL_arg1891z00_2539 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1257z00_2538), BgL_arg1891z00_2539); } 
BgL_new1258z00_2537 = BgL_new1257z00_2538; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1258z00_2537)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1114z42_2531),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1258z00_2537)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1115z52_2110),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1258z00_2537)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1116z52_2111)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1258z00_2537)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1117z52_2112)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1258z00_2537)))->BgL_closedz00)=((bool_t)BgL_closed1118z00_2534),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1119z00_2114)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1120z52_2115),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1121z52_2116),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1122z52_2117),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1123z52_2118),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1258z00_2537)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1124z52_2119),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(BgL_new1258z00_2537))->BgL_ipcz00)=((bool_t)BgL_ipc1125z00_2536),BUNSPEC); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_fun1890z00_2540;
BgL_fun1890z00_2540 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPipez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1890z00_2540)(BgL_fun1890z00_2540, 
((obj_t)BgL_new1258z00_2537), BEOA); } 
return BgL_new1258z00_2537;} } } 

}



/* &lambda1899 */
obj_t BGl_z62lambda1899z62zz__libuv_typesz00(obj_t BgL_envz00_2121, obj_t BgL_oz00_2122, obj_t BgL_vz00_2123)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
bool_t BgL_vz00_2542;
BgL_vz00_2542 = 
CBOOL(BgL_vz00_2123); 
return 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2122)))->BgL_ipcz00)=((bool_t)BgL_vz00_2542),BUNSPEC);} } 

}



/* &lambda1898 */
obj_t BGl_z62lambda1898z62zz__libuv_typesz00(obj_t BgL_envz00_2124, obj_t BgL_oz00_2125)
{
{ /* Llib/uvtypes.scm 53 */
return 
BBOOL(
(((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2125)))->BgL_ipcz00));} 

}



/* &<@anonymous:1876> */
obj_t BGl_z62zc3z04anonymousza31876ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2126, obj_t BgL_new1112z00_2127)
{
{ /* Llib/uvtypes.scm 50 */
{ 
BgL_uvudpz00_bglt BgL_auxz00_4094;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4111;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_classz00_2545;
BgL_classz00_2545 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL__ortest_1111z00_2546;
BgL__ortest_1111z00_2546 = 
BGL_CLASS_NIL(BgL_classz00_2545); 
if(
CBOOL(BgL__ortest_1111z00_2546))
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4111 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2546)
; }  else 
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4111 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2545))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4111),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1112z00_2127))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_new1112z00_2127)))->BgL_z52procmz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4094 = 
((BgL_uvudpz00_bglt)BgL_new1112z00_2127); 
return 
((obj_t)BgL_auxz00_4094);} } 

}



/* &lambda1874 */
BgL_uvudpz00_bglt BGl_z62lambda1874z62zz__libuv_typesz00(obj_t BgL_envz00_2128)
{
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1111z00_2547;
BgL_new1111z00_2547 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1875z00_2548;
BgL_arg1875z00_2548 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1111z00_2547), BgL_arg1875z00_2548); } 
return BgL_new1111z00_2547;} } 

}



/* &lambda1871 */
BgL_uvudpz00_bglt BGl_z62lambda1871z62zz__libuv_typesz00(obj_t BgL_envz00_2129, obj_t BgL_z42builtin1099z42_2130, obj_t BgL_z52onclose1100z52_2131, obj_t BgL_z52gcmarkshead1101z52_2132, obj_t BgL_z52gcmarkstail1102z52_2133, obj_t BgL_closed1103z00_2134, obj_t BgL_loop1104z00_2135, obj_t BgL_z52alloc1105z52_2136, obj_t BgL_z52offset1106z52_2137, obj_t BgL_z52proca1107z52_2138, obj_t BgL_z52procc1108z52_2139, obj_t BgL_z52callback1109z52_2140, obj_t BgL_z52procm1110z52_2141)
{
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
uv_handle_t * BgL_z42builtin1099z42_2549;bool_t BgL_closed1103z00_2552;
BgL_z42builtin1099z42_2549 = 
FOREIGN_TO_COBJ(BgL_z42builtin1099z42_2130); 
BgL_closed1103z00_2552 = 
CBOOL(BgL_closed1103z00_2134); 
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1256z00_2555;
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1255z00_2556;
BgL_new1255z00_2556 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1873z00_2557;
BgL_arg1873z00_2557 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1255z00_2556), BgL_arg1873z00_2557); } 
BgL_new1256z00_2555 = BgL_new1255z00_2556; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1256z00_2555)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1099z42_2549),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1256z00_2555)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1100z52_2131),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1256z00_2555)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1101z52_2132)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1256z00_2555)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1102z52_2133)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1256z00_2555)))->BgL_closedz00)=((bool_t)BgL_closed1103z00_2552),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1104z00_2135)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1105z52_2136),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1106z52_2137),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1107z52_2138),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1108z52_2139),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1256z00_2555)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1109z52_2140),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(BgL_new1256z00_2555))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_z52procm1110z52_2141)),BUNSPEC); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_fun1872z00_2558;
BgL_fun1872z00_2558 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvUdpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1872z00_2558)(BgL_fun1872z00_2558, 
((obj_t)BgL_new1256z00_2555), BEOA); } 
return BgL_new1256z00_2555;} } } 

}



/* &<@anonymous:1883> */
obj_t BGl_z62zc3z04anonymousza31883ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2142)
{
{ /* Llib/uvtypes.scm 50 */
return BNIL;} 

}



/* &lambda1882 */
obj_t BGl_z62lambda1882z62zz__libuv_typesz00(obj_t BgL_envz00_2143, obj_t BgL_oz00_2144, obj_t BgL_vz00_2145)
{
{ /* Llib/uvtypes.scm 50 */
return 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2144)))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_vz00_2145)),BUNSPEC);} 

}



/* &lambda1881 */
obj_t BGl_z62lambda1881z62zz__libuv_typesz00(obj_t BgL_envz00_2146, obj_t BgL_oz00_2147)
{
{ /* Llib/uvtypes.scm 50 */
return 
(((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2147)))->BgL_z52procmz52);} 

}



/* &<@anonymous:1865> */
obj_t BGl_z62zc3z04anonymousza31865ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2148, obj_t BgL_new1097z00_2149)
{
{ /* Llib/uvtypes.scm 48 */
{ 
BgL_uvtcpz00_bglt BgL_auxz00_4188;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4205;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_classz00_2563;
BgL_classz00_2563 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL__ortest_1111z00_2564;
BgL__ortest_1111z00_2564 = 
BGL_CLASS_NIL(BgL_classz00_2563); 
if(
CBOOL(BgL__ortest_1111z00_2564))
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4205 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2564)
; }  else 
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4205 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2563))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4205),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4188 = 
((BgL_uvtcpz00_bglt)BgL_new1097z00_2149); 
return 
((obj_t)BgL_auxz00_4188);} } 

}



/* &lambda1863 */
BgL_uvtcpz00_bglt BGl_z62lambda1863z62zz__libuv_typesz00(obj_t BgL_envz00_2150)
{
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1096z00_2565;
BgL_new1096z00_2565 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1864z00_2566;
BgL_arg1864z00_2566 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1096z00_2565), BgL_arg1864z00_2566); } 
return BgL_new1096z00_2565;} } 

}



/* &lambda1860 */
BgL_uvtcpz00_bglt BGl_z62lambda1860z62zz__libuv_typesz00(obj_t BgL_envz00_2151, obj_t BgL_z42builtin1085z42_2152, obj_t BgL_z52onclose1086z52_2153, obj_t BgL_z52gcmarkshead1087z52_2154, obj_t BgL_z52gcmarkstail1088z52_2155, obj_t BgL_closed1089z00_2156, obj_t BgL_loop1090z00_2157, obj_t BgL_z52alloc1091z52_2158, obj_t BgL_z52offset1092z52_2159, obj_t BgL_z52proca1093z52_2160, obj_t BgL_z52procc1094z52_2161, obj_t BgL_z52callback1095z52_2162)
{
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
uv_handle_t * BgL_z42builtin1085z42_2567;bool_t BgL_closed1089z00_2570;
BgL_z42builtin1085z42_2567 = 
FOREIGN_TO_COBJ(BgL_z42builtin1085z42_2152); 
BgL_closed1089z00_2570 = 
CBOOL(BgL_closed1089z00_2156); 
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1254z00_2572;
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1253z00_2573;
BgL_new1253z00_2573 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1862z00_2574;
BgL_arg1862z00_2574 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1253z00_2573), BgL_arg1862z00_2574); } 
BgL_new1254z00_2572 = BgL_new1253z00_2573; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1254z00_2572)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1085z42_2567),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1254z00_2572)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1086z52_2153),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1254z00_2572)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1087z52_2154)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1254z00_2572)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1088z52_2155)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1254z00_2572)))->BgL_closedz00)=((bool_t)BgL_closed1089z00_2570),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1090z00_2157)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1091z52_2158),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1092z52_2159),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1093z52_2160),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1094z52_2161),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1254z00_2572)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1095z52_2162),BUNSPEC); 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_fun1861z00_2575;
BgL_fun1861z00_2575 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTcpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1861z00_2575)(BgL_fun1861z00_2575, 
((obj_t)BgL_new1254z00_2572), BEOA); } 
return BgL_new1254z00_2572;} } } 

}



/* &<@anonymous:1813> */
obj_t BGl_z62zc3z04anonymousza31813ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2163, obj_t BgL_new1083z00_2164)
{
{ /* Llib/uvtypes.scm 40 */
{ 
BgL_uvstreamz00_bglt BgL_auxz00_4273;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4290;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_classz00_2577;
BgL_classz00_2577 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL__ortest_1111z00_2578;
BgL__ortest_1111z00_2578 = 
BGL_CLASS_NIL(BgL_classz00_2577); 
if(
CBOOL(BgL__ortest_1111z00_2578))
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4290 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2578)
; }  else 
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4290 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2577))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4290),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164)))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4273 = 
((BgL_uvstreamz00_bglt)BgL_new1083z00_2164); 
return 
((obj_t)BgL_auxz00_4273);} } 

}



/* &lambda1811 */
BgL_uvstreamz00_bglt BGl_z62lambda1811z62zz__libuv_typesz00(obj_t BgL_envz00_2165)
{
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1082z00_2579;
BgL_new1082z00_2579 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1812z00_2580;
BgL_arg1812z00_2580 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_2579), BgL_arg1812z00_2580); } 
return BgL_new1082z00_2579;} } 

}



/* &lambda1808 */
BgL_uvstreamz00_bglt BGl_z62lambda1808z62zz__libuv_typesz00(obj_t BgL_envz00_2166, obj_t BgL_z42builtin1071z42_2167, obj_t BgL_z52onclose1072z52_2168, obj_t BgL_z52gcmarkshead1073z52_2169, obj_t BgL_z52gcmarkstail1074z52_2170, obj_t BgL_closed1075z00_2171, obj_t BgL_loop1076z00_2172, obj_t BgL_z52alloc1077z52_2173, obj_t BgL_z52offset1078z52_2174, obj_t BgL_z52proca1079z52_2175, obj_t BgL_z52procc1080z52_2176, obj_t BgL_z52callback1081z52_2177)
{
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
uv_handle_t * BgL_z42builtin1071z42_2581;bool_t BgL_closed1075z00_2584;
BgL_z42builtin1071z42_2581 = 
FOREIGN_TO_COBJ(BgL_z42builtin1071z42_2167); 
BgL_closed1075z00_2584 = 
CBOOL(BgL_closed1075z00_2171); 
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1252z00_2586;
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1251z00_2587;
BgL_new1251z00_2587 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1810z00_2588;
BgL_arg1810z00_2588 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1251z00_2587), BgL_arg1810z00_2588); } 
BgL_new1252z00_2586 = BgL_new1251z00_2587; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1252z00_2586)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1071z42_2581),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1252z00_2586)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1072z52_2168),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1252z00_2586)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1073z52_2169)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1252z00_2586)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1074z52_2170)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1252z00_2586)))->BgL_closedz00)=((bool_t)BgL_closed1075z00_2584),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1076z00_2172)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1077z52_2173),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1078z52_2174),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_z52procaz52)=((obj_t)BgL_z52proca1079z52_2175),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_z52proccz52)=((obj_t)BgL_z52procc1080z52_2176),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1252z00_2586))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1081z52_2177),BUNSPEC); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_fun1809z00_2589;
BgL_fun1809z00_2589 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvStreamz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1809z00_2589)(BgL_fun1809z00_2589, 
((obj_t)BgL_new1252z00_2586), BEOA); } 
return BgL_new1252z00_2586;} } } 

}



/* &<@anonymous:1853> */
obj_t BGl_z62zc3z04anonymousza31853ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2178)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1852 */
obj_t BGl_z62lambda1852z62zz__libuv_typesz00(obj_t BgL_envz00_2179, obj_t BgL_oz00_2180, obj_t BgL_vz00_2181)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2180)))->BgL_z52callbackz52)=((obj_t)BgL_vz00_2181),BUNSPEC);} 

}



/* &lambda1851 */
obj_t BGl_z62lambda1851z62zz__libuv_typesz00(obj_t BgL_envz00_2182, obj_t BgL_oz00_2183)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2183)))->BgL_z52callbackz52);} 

}



/* &<@anonymous:1846> */
obj_t BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2184)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1845 */
obj_t BGl_z62lambda1845z62zz__libuv_typesz00(obj_t BgL_envz00_2185, obj_t BgL_oz00_2186, obj_t BgL_vz00_2187)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2186)))->BgL_z52proccz52)=((obj_t)BgL_vz00_2187),BUNSPEC);} 

}



/* &lambda1844 */
obj_t BGl_z62lambda1844z62zz__libuv_typesz00(obj_t BgL_envz00_2188, obj_t BgL_oz00_2189)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2189)))->BgL_z52proccz52);} 

}



/* &<@anonymous:1839> */
obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2190)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1838 */
obj_t BGl_z62lambda1838z62zz__libuv_typesz00(obj_t BgL_envz00_2191, obj_t BgL_oz00_2192, obj_t BgL_vz00_2193)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2192)))->BgL_z52procaz52)=((obj_t)BgL_vz00_2193),BUNSPEC);} 

}



/* &lambda1837 */
obj_t BGl_z62lambda1837z62zz__libuv_typesz00(obj_t BgL_envz00_2194, obj_t BgL_oz00_2195)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2195)))->BgL_z52procaz52);} 

}



/* &<@anonymous:1832> */
obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2196)
{
{ /* Llib/uvtypes.scm 40 */
return 
BINT(((long)0));} 

}



/* &lambda1831 */
obj_t BGl_z62lambda1831z62zz__libuv_typesz00(obj_t BgL_envz00_2197, obj_t BgL_oz00_2198, obj_t BgL_vz00_2199)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2198)))->BgL_z52offsetz52)=((obj_t)BgL_vz00_2199),BUNSPEC);} 

}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__libuv_typesz00(obj_t BgL_envz00_2200, obj_t BgL_oz00_2201)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2201)))->BgL_z52offsetz52);} 

}



/* &<@anonymous:1825> */
obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2202)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1824 */
obj_t BGl_z62lambda1824z62zz__libuv_typesz00(obj_t BgL_envz00_2203, obj_t BgL_oz00_2204, obj_t BgL_vz00_2205)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2204)))->BgL_z52allocz52)=((obj_t)BgL_vz00_2205),BUNSPEC);} 

}



/* &lambda1823 */
obj_t BGl_z62lambda1823z62zz__libuv_typesz00(obj_t BgL_envz00_2206, obj_t BgL_oz00_2207)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2207)))->BgL_z52allocz52);} 

}



/* &lambda1818 */
obj_t BGl_z62lambda1818z62zz__libuv_typesz00(obj_t BgL_envz00_2208, obj_t BgL_oz00_2209, obj_t BgL_vz00_2210)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2209)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2210)),BUNSPEC);} 

}



/* &lambda1817 */
BgL_uvloopz00_bglt BGl_z62lambda1817z62zz__libuv_typesz00(obj_t BgL_envz00_2211, obj_t BgL_oz00_2212)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2212)))->BgL_loopz00);} 

}



/* &<@anonymous:1790> */
obj_t BGl_z62zc3z04anonymousza31790ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2213, obj_t BgL_new1069z00_2214)
{
{ /* Llib/uvtypes.scm 36 */
{ 
BgL_uvwatcherz00_bglt BgL_auxz00_4376;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4393;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_classz00_2604;
BgL_classz00_2604 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL__ortest_1111z00_2605;
BgL__ortest_1111z00_2605 = 
BGL_CLASS_NIL(BgL_classz00_2604); 
if(
CBOOL(BgL__ortest_1111z00_2605))
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4393 = 
((BgL_uvloopz00_bglt)BgL__ortest_1111z00_2605)
; }  else 
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4393 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2604))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4393),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214)))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_4376 = 
((BgL_uvwatcherz00_bglt)BgL_new1069z00_2214); 
return 
((obj_t)BgL_auxz00_4376);} } 

}



/* &lambda1788 */
BgL_uvwatcherz00_bglt BGl_z62lambda1788z62zz__libuv_typesz00(obj_t BgL_envz00_2215)
{
{ /* Llib/uvtypes.scm 36 */
{ /* Llib/uvtypes.scm 36 */
BgL_uvwatcherz00_bglt BgL_new1068z00_2606;
BgL_new1068z00_2606 = 
((BgL_uvwatcherz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvwatcherz00_bgl) ))); 
{ /* Llib/uvtypes.scm 36 */
long BgL_arg1789z00_2607;
BgL_arg1789z00_2607 = 
BGL_CLASS_INDEX(BGl_UvWatcherz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1068z00_2606), BgL_arg1789z00_2607); } 
return BgL_new1068z00_2606;} } 

}



/* &<@anonymous:1802> */
obj_t BGl_z62zc3z04anonymousza31802ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2216)
{
{ /* Llib/uvtypes.scm 36 */
return BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;} 

}



/* &lambda1801 */
obj_t BGl_z62lambda1801z62zz__libuv_typesz00(obj_t BgL_envz00_2217, obj_t BgL_oz00_2218, obj_t BgL_vz00_2219)
{
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2218)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_vz00_2219)),BUNSPEC);} 

}



/* &lambda1800 */
obj_t BGl_z62lambda1800z62zz__libuv_typesz00(obj_t BgL_envz00_2220, obj_t BgL_oz00_2221)
{
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2221)))->BgL_cbz00);} 

}



/* &lambda1795 */
obj_t BGl_z62lambda1795z62zz__libuv_typesz00(obj_t BgL_envz00_2222, obj_t BgL_oz00_2223, obj_t BgL_vz00_2224)
{
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2223)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2224)),BUNSPEC);} 

}



/* &lambda1794 */
BgL_uvloopz00_bglt BGl_z62lambda1794z62zz__libuv_typesz00(obj_t BgL_envz00_2225, obj_t BgL_oz00_2226)
{
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2226)))->BgL_loopz00);} 

}



/* &<@anonymous:1776> */
obj_t BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2227, obj_t BgL_new1066z00_2228)
{
{ /* Llib/uvtypes.scm 33 */
{ 
BgL_uvloopz00_bglt BgL_auxz00_4420;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1066z00_2228))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1066z00_2228))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1066z00_2228))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1066z00_2228))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1066z00_2228))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_new1066z00_2228)))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
BgL_auxz00_4420 = 
((BgL_uvloopz00_bglt)BgL_new1066z00_2228); 
return 
((obj_t)BgL_auxz00_4420);} } 

}



/* &lambda1773 */
BgL_uvloopz00_bglt BGl_z62lambda1773z62zz__libuv_typesz00(obj_t BgL_envz00_2229)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1065z00_2615;
BgL_new1065z00_2615 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1775z00_2616;
BgL_arg1775z00_2616 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_2615), BgL_arg1775z00_2616); } 
return BgL_new1065z00_2615;} } 

}



/* &lambda1764 */
BgL_uvloopz00_bglt BGl_z62lambda1764z62zz__libuv_typesz00(obj_t BgL_envz00_2230, obj_t BgL_z42builtin1059z42_2231, obj_t BgL_z52onclose1060z52_2232, obj_t BgL_z52gcmarkshead1061z52_2233, obj_t BgL_z52gcmarkstail1062z52_2234, obj_t BgL_closed1063z00_2235, obj_t BgL_z52mutex1064z52_2236)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
uv_handle_t * BgL_z42builtin1059z42_2617;bool_t BgL_closed1063z00_2620;
BgL_z42builtin1059z42_2617 = 
FOREIGN_TO_COBJ(BgL_z42builtin1059z42_2231); 
BgL_closed1063z00_2620 = 
CBOOL(BgL_closed1063z00_2235); 
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1250z00_2622;
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1249z00_2623;
BgL_new1249z00_2623 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1772z00_2624;
BgL_arg1772z00_2624 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1249z00_2623), BgL_arg1772z00_2624); } 
BgL_new1250z00_2622 = BgL_new1249z00_2623; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1250z00_2622)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1059z42_2617),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1250z00_2622)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1060z52_2232),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1250z00_2622)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1061z52_2233)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1250z00_2622)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1062z52_2234)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1250z00_2622)))->BgL_closedz00)=((bool_t)BgL_closed1063z00_2620),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(BgL_new1250z00_2622))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1064z52_2236)),BUNSPEC); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_fun1765z00_2625;
BgL_fun1765z00_2625 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvLoopz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1765z00_2625)(BgL_fun1765z00_2625, 
((obj_t)BgL_new1250z00_2622), BEOA); } 
return BgL_new1250z00_2622;} } } 

}



/* &<@anonymous:1783> */
obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2237)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 34 */

{ /* Llib/uvtypes.scm 34 */
obj_t BgL_namez00_2626;
BgL_namez00_2626 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)20))); 
{ /* Llib/uvtypes.scm 34 */

return 
bgl_make_mutex(BgL_namez00_2626);} } } } 

}



/* &lambda1782 */
obj_t BGl_z62lambda1782z62zz__libuv_typesz00(obj_t BgL_envz00_2238, obj_t BgL_oz00_2239, obj_t BgL_vz00_2240)
{
{ /* Llib/uvtypes.scm 33 */
return 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2239)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_vz00_2240)),BUNSPEC);} 

}



/* &lambda1781 */
obj_t BGl_z62lambda1781z62zz__libuv_typesz00(obj_t BgL_envz00_2241, obj_t BgL_oz00_2242)
{
{ /* Llib/uvtypes.scm 33 */
return 
(((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2242)))->BgL_z52mutexz52);} 

}



/* &<@anonymous:1672> */
obj_t BGl_z62zc3z04anonymousza31672ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2243, obj_t BgL_new1057z00_2244)
{
{ /* Llib/uvtypes.scm 26 */
{ 
BgL_uvhandlez00_bglt BgL_auxz00_4480;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244)))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244)))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244)))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244)))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244)))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4480 = 
((BgL_uvhandlez00_bglt)BgL_new1057z00_2244); 
return 
((obj_t)BgL_auxz00_4480);} } 

}



/* &lambda1662 */
BgL_uvhandlez00_bglt BGl_z62lambda1662z62zz__libuv_typesz00(obj_t BgL_envz00_2245)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1056z00_2631;
BgL_new1056z00_2631 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1671z00_2632;
BgL_arg1671z00_2632 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1056z00_2631), BgL_arg1671z00_2632); } 
return BgL_new1056z00_2631;} } 

}



/* &lambda1657 */
BgL_uvhandlez00_bglt BGl_z62lambda1657z62zz__libuv_typesz00(obj_t BgL_envz00_2246, obj_t BgL_z42builtin1051z42_2247, obj_t BgL_z52onclose1052z52_2248, obj_t BgL_z52gcmarkshead1053z52_2249, obj_t BgL_z52gcmarkstail1054z52_2250, obj_t BgL_closed1055z00_2251)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_z42builtin1051z42_2633;bool_t BgL_closed1055z00_2636;
BgL_z42builtin1051z42_2633 = 
FOREIGN_TO_COBJ(BgL_z42builtin1051z42_2247); 
BgL_closed1055z00_2636 = 
CBOOL(BgL_closed1055z00_2251); 
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1248z00_2637;
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1247z00_2638;
BgL_new1247z00_2638 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1661z00_2639;
BgL_arg1661z00_2639 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1247z00_2638), BgL_arg1661z00_2639); } 
BgL_new1248z00_2637 = BgL_new1247z00_2638; } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1248z00_2637))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1051z42_2633),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1248z00_2637))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1052z52_2248),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1248z00_2637))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1053z52_2249)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1248z00_2637))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1054z52_2250)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1248z00_2637))->BgL_closedz00)=((bool_t)BgL_closed1055z00_2636),BUNSPEC); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_fun1658z00_2640;
BgL_fun1658z00_2640 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvHandlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1658z00_2640)(BgL_fun1658z00_2640, 
((obj_t)BgL_new1248z00_2637), BEOA); } 
return BgL_new1248z00_2637;} } } 

}



/* &<@anonymous:1737> */
obj_t BGl_z62zc3z04anonymousza31737ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2252)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1736 */
obj_t BGl_z62lambda1736z62zz__libuv_typesz00(obj_t BgL_envz00_2253, obj_t BgL_oz00_2254, obj_t BgL_vz00_2255)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
bool_t BgL_vz00_2642;
BgL_vz00_2642 = 
CBOOL(BgL_vz00_2255); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2254)))->BgL_closedz00)=((bool_t)BgL_vz00_2642),BUNSPEC);} } 

}



/* &lambda1735 */
obj_t BGl_z62lambda1735z62zz__libuv_typesz00(obj_t BgL_envz00_2256, obj_t BgL_oz00_2257)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2257)))->BgL_closedz00));} 

}



/* &<@anonymous:1722> */
obj_t BGl_z62zc3z04anonymousza31722ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2258)
{
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 

}



/* &lambda1721 */
obj_t BGl_z62lambda1721z62zz__libuv_typesz00(obj_t BgL_envz00_2259, obj_t BgL_oz00_2260, obj_t BgL_vz00_2261)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2260)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_vz00_2261)),BUNSPEC);} 

}



/* &lambda1720 */
obj_t BGl_z62lambda1720z62zz__libuv_typesz00(obj_t BgL_envz00_2262, obj_t BgL_oz00_2263)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2263)))->BgL_z52gcmarkstailz52);} 

}



/* &<@anonymous:1715> */
obj_t BGl_z62zc3z04anonymousza31715ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2264)
{
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 

}



/* &lambda1714 */
obj_t BGl_z62lambda1714z62zz__libuv_typesz00(obj_t BgL_envz00_2265, obj_t BgL_oz00_2266, obj_t BgL_vz00_2267)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2266)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_vz00_2267)),BUNSPEC);} 

}



/* &lambda1713 */
obj_t BGl_z62lambda1713z62zz__libuv_typesz00(obj_t BgL_envz00_2268, obj_t BgL_oz00_2269)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2269)))->BgL_z52gcmarksheadz52);} 

}



/* &<@anonymous:1702> */
obj_t BGl_z62zc3z04anonymousza31702ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2270)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1701 */
obj_t BGl_z62lambda1701z62zz__libuv_typesz00(obj_t BgL_envz00_2271, obj_t BgL_oz00_2272, obj_t BgL_vz00_2273)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2272)))->BgL_z52onclosez52)=((obj_t)BgL_vz00_2273),BUNSPEC);} 

}



/* &lambda1700 */
obj_t BGl_z62lambda1700z62zz__libuv_typesz00(obj_t BgL_envz00_2274, obj_t BgL_oz00_2275)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2275)))->BgL_z52onclosez52);} 

}



/* &<@anonymous:1684> */
obj_t BGl_z62zc3z04anonymousza31684ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2276)
{
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1683 */
obj_t BGl_z62lambda1683z62zz__libuv_typesz00(obj_t BgL_envz00_2277, obj_t BgL_oz00_2278, obj_t BgL_vz00_2279)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_vz00_2653;
BgL_vz00_2653 = 
FOREIGN_TO_COBJ(BgL_vz00_2279); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2278)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_vz00_2653),BUNSPEC);} } 

}



/* &lambda1682 */
obj_t BGl_z62lambda1682z62zz__libuv_typesz00(obj_t BgL_envz00_2280, obj_t BgL_oz00_2281)
{
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2281)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1644> */
obj_t BGl_z62zc3z04anonymousza31644ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2282, obj_t BgL_new1049z00_2283)
{
{ /* Llib/uvtypes.scm 23 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_new1049z00_2283));} 

}



/* &lambda1637 */
BgL_z52uvz52_bglt BGl_z62lambda1637z62zz__libuv_typesz00(obj_t BgL_envz00_2284)
{
{ /* Llib/uvtypes.scm 23 */
{ /* Llib/uvtypes.scm 23 */
BgL_z52uvz52_bglt BgL_new1048z00_2656;
BgL_new1048z00_2656 = 
((BgL_z52uvz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52uvz52_bgl) ))); 
{ /* Llib/uvtypes.scm 23 */
long BgL_arg1643z00_2657;
BgL_arg1643z00_2657 = 
BGL_CLASS_INDEX(BGl_z52Uvz52zz__libuv_typesz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1048z00_2656), BgL_arg1643z00_2657); } 
return BgL_new1048z00_2656;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2407z00zz__libuv_typesz00, BGl_z52Uvz52zz__libuv_typesz00, BGl_string2408z00zz__libuv_typesz00);} 

}



/* &%uv-init1338 */
obj_t BGl_z62z52uvzd2init1338ze2zz__libuv_typesz00(obj_t BgL_envz00_2288, obj_t BgL_oz00_2289)
{
{ /* Llib/uvtypes.scm 187 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_oz00_2289));} 

}



/* %uv-init */
BGL_EXPORTED_DEF obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt BgL_oz00_4)
{
{ /* Llib/uvtypes.scm 187 */
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_method1339z00_1200;
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_res2238z00_1608;
{ /* Llib/uvtypes.scm 187 */
long BgL_objzd2classzd2numz00_1579;
BgL_objzd2classzd2numz00_1579 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_4)); 
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_arg1765z00_1580;
BgL_arg1765z00_1580 = 
PROCEDURE_REF(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, 
(int)(((long)1))); 
{ /* Llib/uvtypes.scm 187 */
int BgL_offsetz00_1583;
BgL_offsetz00_1583 = 
(int)(BgL_objzd2classzd2numz00_1579); 
{ /* Llib/uvtypes.scm 187 */
long BgL_offsetz00_1584;
BgL_offsetz00_1584 = 
(
(long)(BgL_offsetz00_1583)-OBJECT_TYPE); 
{ /* Llib/uvtypes.scm 187 */
long BgL_modz00_1585;
BgL_modz00_1585 = 
(BgL_offsetz00_1584 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/uvtypes.scm 187 */
long BgL_restz00_1587;
BgL_restz00_1587 = 
(BgL_offsetz00_1584 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/uvtypes.scm 187 */

{ /* Llib/uvtypes.scm 187 */
obj_t BgL_bucketz00_1589;
BgL_bucketz00_1589 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1580),BgL_modz00_1585); 
BgL_res2238z00_1608 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1589),BgL_restz00_1587); } } } } } } } } 
BgL_method1339z00_1200 = BgL_res2238z00_1608; } 
return 
PROCEDURE_ENTRY(BgL_method1339z00_1200)(BgL_method1339z00_1200, 
((obj_t)BgL_oz00_4), BEOA);} } 

}



/* &%uv-init */
obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t BgL_envz00_2285, obj_t BgL_oz00_2286)
{
{ /* Llib/uvtypes.scm 187 */
return 
BGl_z52uvzd2initz80zz__libuv_typesz00(
((BgL_z52uvz52_bglt)BgL_oz00_2286));} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_UvHandlez00zz__libuv_typesz00, BGl_proc2409z00zz__libuv_typesz00, BGl_string2410z00zz__libuv_typesz00);} 

}



/* &object-print-UvHandl1341 */
obj_t BGl_z62objectzd2printzd2UvHandl1341z62zz__libuv_typesz00(obj_t BgL_envz00_2291, obj_t BgL_objz00_2292, obj_t BgL_portz00_2293, obj_t BgL_printzd2slotzd2_2294)
{
{ /* Llib/uvtypes.scm 193 */
{ 
obj_t BgL_fieldz00_2662;
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classz00_2667;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1768z00_2668;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1769z00_2669;
BgL_arg1769z00_2669 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2292))); 
BgL_arg1768z00_2668 = 
(BgL_arg1769z00_2669-OBJECT_TYPE); } 
BgL_classz00_2667 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1768z00_2668); } 
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classzd2namezd2_2670;
BgL_classzd2namezd2_2670 = 
BGl_classzd2namezd2zz__objectz00(BgL_classz00_2667); 
{ /* Llib/uvtypes.scm 208 */
obj_t BgL_fieldsz00_2671;
{ /* Llib/uvtypes.scm 209 */
obj_t BgL_tmpz00_4594;
BgL_tmpz00_4594 = 
((obj_t)BgL_classz00_2667); 
BgL_fieldsz00_2671 = 
BGL_CLASS_ALL_FIELDS(BgL_tmpz00_4594); } 
{ /* Llib/uvtypes.scm 210 */

{ /* Llib/uvtypes.scm 211 */
obj_t BgL_tmpz00_4597;
BgL_tmpz00_4597 = 
((obj_t)BgL_portz00_2293); 
bgl_display_string(BGl_string2412z00zz__libuv_typesz00, BgL_tmpz00_4597); } 
bgl_display_obj(BgL_classzd2namezd2_2670, BgL_portz00_2293); 
{ /* Llib/uvtypes.scm 213 */
obj_t BgL_tmpz00_4601;
BgL_tmpz00_4601 = 
((obj_t)BgL_portz00_2293); 
bgl_display_string(BGl_string2413z00zz__libuv_typesz00, BgL_tmpz00_4601); } 
{ /* Llib/uvtypes.scm 214 */
obj_t BgL_arg2222z00_2672;
{ /* Llib/uvtypes.scm 214 */
int BgL_arg2223z00_2673;
{ /* Llib/uvtypes.scm 214 */
int BgL_res2239z00_2674;
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1346z00_2675;
BgL_arg1346z00_2675 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_objz00_2292)))->BgL_z42builtinz42); 
BgL_res2239z00_2674 = 
(int)(
(long)(BgL_arg1346z00_2675)); } 
BgL_arg2223z00_2673 = BgL_res2239z00_2674; } 
BgL_arg2222z00_2672 = 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)(BgL_arg2223z00_2673), ((long)16)); } 
bgl_display_obj(BgL_arg2222z00_2672, BgL_portz00_2293); } 
{ /* Llib/uvtypes.scm 215 */
obj_t BgL_tmpz00_4611;
BgL_tmpz00_4611 = 
((obj_t)BgL_portz00_2293); 
bgl_display_string(BGl_string2414z00zz__libuv_typesz00, BgL_tmpz00_4611); } 
if(
BGl_nilzf3zf3zz__objectz00(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2292))))
{ /* Llib/uvtypes.scm 217 */
obj_t BgL_tmpz00_4618;
BgL_tmpz00_4618 = 
((obj_t)BgL_portz00_2293); 
return 
bgl_display_string(BGl_string2415z00zz__libuv_typesz00, BgL_tmpz00_4618);}  else 
{ 
long BgL_iz00_2677;
BgL_iz00_2677 = ((long)0); 
BgL_loopz00_2676:
if(
(BgL_iz00_2677==
VECTOR_LENGTH(BgL_fieldsz00_2671)))
{ /* Llib/uvtypes.scm 220 */
obj_t BgL_tmpz00_4624;
BgL_tmpz00_4624 = 
((obj_t)BgL_portz00_2293); 
return 
bgl_display_char(((unsigned char)'|'), BgL_tmpz00_4624);}  else 
{ /* Llib/uvtypes.scm 219 */
BgL_fieldz00_2662 = 
VECTOR_REF(BgL_fieldsz00_2671,BgL_iz00_2677); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_namez00_2663;
BgL_namez00_2663 = 
BGl_classzd2fieldzd2namez00zz__objectz00(BgL_fieldz00_2662); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_getzd2valuezd2_2664;
BgL_getzd2valuezd2_2664 = 
BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_2662); 
{ /* Llib/uvtypes.scm 197 */
obj_t BgL_sz00_2665;
BgL_sz00_2665 = 
SYMBOL_TO_STRING(BgL_namez00_2663); 
{ /* Llib/uvtypes.scm 198 */

if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
BCHAR(
STRING_REF(BgL_sz00_2665, ((long)0))), 
CNST_TABLE_REF(((long)70)))))
{ /* Llib/uvtypes.scm 199 */BFALSE; }  else 
{ /* Llib/uvtypes.scm 199 */
{ /* Llib/uvtypes.scm 200 */
obj_t BgL_tmpz00_4636;
BgL_tmpz00_4636 = 
((obj_t)BgL_portz00_2293); 
bgl_display_string(BGl_string2411z00zz__libuv_typesz00, BgL_tmpz00_4636); } 
bgl_display_obj(BgL_namez00_2663, BgL_portz00_2293); 
{ /* Llib/uvtypes.scm 202 */
obj_t BgL_tmpz00_4640;
BgL_tmpz00_4640 = 
((obj_t)BgL_portz00_2293); 
bgl_display_char(((unsigned char)':'), BgL_tmpz00_4640); } 
{ /* Llib/uvtypes.scm 203 */
obj_t BgL_tmpz00_4643;
BgL_tmpz00_4643 = 
((obj_t)BgL_portz00_2293); 
bgl_display_char(((unsigned char)' '), BgL_tmpz00_4643); } 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_arg2232z00_2666;
BgL_arg2232z00_2666 = 
PROCEDURE_ENTRY(BgL_getzd2valuezd2_2664)(BgL_getzd2valuezd2_2664, 
((obj_t)
((BgL_uvhandlez00_bglt)BgL_objz00_2292)), BEOA); 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_tmpfunz00_4657;
BgL_tmpfunz00_4657 = 
((obj_t)BgL_printzd2slotzd2_2294); 
PROCEDURE_ENTRY(BgL_tmpfunz00_4657)(
((obj_t)BgL_printzd2slotzd2_2294), BgL_arg2232z00_2666, BgL_portz00_2293, BEOA); } } 
{ /* Llib/uvtypes.scm 205 */
obj_t BgL_tmpz00_4659;
BgL_tmpz00_4659 = 
((obj_t)BgL_portz00_2293); 
bgl_display_char(((unsigned char)']'), BgL_tmpz00_4659); } } } } } } 
{ 
long BgL_iz00_4663;
BgL_iz00_4663 = 
(BgL_iz00_2677+((long)1)); 
BgL_iz00_2677 = BgL_iz00_4663; 
goto BgL_loopz00_2676;} } } } } } } } } 

}

#ifdef __cplusplus
}
#endif
