/*===========================================================================*/
/*   (Llib/midi.scm)                                                         */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IUnix Llib/midi.scm -o objs/midi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_midiscorez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_formatz00;
   long BgL_tempoz00;
   long BgL_ppqz00;
   obj_t BgL_tracksz00;
} *BgL_midiscorez00_bglt;

typedef struct BgL_miditrackz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52streamz52;
   struct BgL_midireaderz00_bgl * BgL_z52readerz52;
   obj_t BgL_z52closez52;
   bool_t BgL_z52eotz52;
   uint32_t BgL_z52wtickz52;
   long BgL_z52statusz52;
   int32_t BgL_lenz00;
   long BgL_tempoz00;
   obj_t BgL_ipz00;
   long BgL_startz00;
   long BgL_datastartz00;
   uint32_t BgL_wtickz00;
   long BgL_statusz00;
   bool_t BgL_eotz00;
} *BgL_miditrackz00_bglt;

typedef struct BgL_midireaderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_peekzd2bytezd2;
   obj_t BgL_readzd2bytezd2;
   obj_t BgL_readzd2int16zd2;
   obj_t BgL_readzd2int32zd2;
   obj_t BgL_readzd2intzd2;
   obj_t BgL_readzd2vlqzd2;
   obj_t BgL_readzd2charszd2;
} *BgL_midireaderz00_bglt;

typedef struct BgL_midiplayerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_errz00;
   obj_t BgL_cdelayz00;
   obj_t BgL_noteoffz00;
   obj_t BgL_noteonz00;
   obj_t BgL_aftertouchz00;
   obj_t BgL_ctrlchangez00;
   obj_t BgL_prgmchangez00;
   obj_t BgL_afterzd2touchzd2;
   obj_t BgL_pitchz00;
   obj_t BgL_sysexz00;
   obj_t BgL_metazd2seqnumzd2;
   obj_t BgL_metazd2textzd2;
   obj_t BgL_metazd2copyrightzd2;
   obj_t BgL_metazd2trackzd2;
   obj_t BgL_metazd2instrumentzd2;
   obj_t BgL_metazd2lyriczd2;
   obj_t BgL_metazd2markerzd2;
   obj_t BgL_metazd2cuezd2;
   obj_t BgL_metazd2prgmnamezd2;
   obj_t BgL_metazd2devnamezd2;
   obj_t BgL_metazd2channprefzd2;
   obj_t BgL_metazd2midiportzd2;
   obj_t BgL_metazd2eotzd2;
   obj_t BgL_metazd2tempozd2;
   obj_t BgL_metazd2smtpezd2;
   obj_t BgL_metazd2timesigzd2;
   obj_t BgL_metazd2keysigzd2;
   obj_t BgL_metazd2seqspeczd2;
} *BgL_midiplayerz00_bglt;

typedef struct BgL_midisinkz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_streamz00;
   obj_t BgL_usleepz00;
   obj_t BgL_writezd2bytezd2;
   obj_t BgL_writezd2stringzd2;
   obj_t BgL_flushz00;
} *BgL_midisinkz00_bglt;


static obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t);
static long BGl_readzd2intzd2zz__multimediazd2midizd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt);
static BgL_midisinkz00_bglt BGl_midisinkzd2nullzd2zz__multimediazd2midizd2;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, BgL_miditrackz00_bglt, long, long, long);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_writezd2stringzd2zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_IMPORT obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midiscorez00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2();
BGL_EXPORTED_DEF obj_t BGl_midiplayerz00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(obj_t, long);
static obj_t BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long, obj_t);
static obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2();
static int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_midireaderz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32131ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, BGL_LONGLONG_T);
static int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long);
BGL_EXPORTED_DEF obj_t BGl_miditrackz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midireaderzd2init1235zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31250ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2();
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31251ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31252ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32119ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
BGL_EXPORTED_DEF obj_t BGl_midisinkz00zz__multimediazd2midizd2 = BUNSPEC;
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza31520ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31253ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
static obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32145ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31254ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31255ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31247ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt);
static obj_t BGl_z62zc3z04anonymousza31248ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_midiplayerzd2readzd2zz__multimediazd2midizd2;
static obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2init1237zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62midiscorezd2init1231zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2114z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt);
static obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62zc3z04anonymousza31517ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2129z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
static obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2136z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2303z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2143z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t create_struct(obj_t, int);
static obj_t BGl_z62midisinkzd2init1239zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2151z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31390ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2154z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2236z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2161z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31391ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2162z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2167z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2168z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2250z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2257z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62miditrackzd2init1233zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2260z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2505z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2267z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2512z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31653ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2271z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2272z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2277z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2523z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31654ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2282z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2287z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt);
BGL_IMPORT obj_t BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62lambda2530z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2297z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2;
static obj_t BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2468z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2552z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2475z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt);
static obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t __cnst[ 76 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3003z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2544za7623033z00, BGl_z62lambda2544z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3004z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3034za7, BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2f3035z00, BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3005z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2553za7623036z00, BGl_z62lambda2553z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3006z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2552za7623037z00, BGl_z62lambda2552z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3007z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3038za7, BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3008z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2515za7623039z00, BGl_z62lambda2515z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3015z00zz__multimediazd2midizd2, BgL_bgl_string3015za700za7za7_3040za7, "midiscore-init1231", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3009z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2512za7623041z00, BGl_z62lambda2512z62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3017z00zz__multimediazd2midizd2, BgL_bgl_string3017za700za7za7_3042za7, "miditrack-init1233", 18 );
DEFINE_STRING( BGl_string3019z00zz__multimediazd2midizd2, BgL_bgl_string3019za700za7za7_3043za7, "midireader-init1235", 19 );
DEFINE_EXPORT_BGL_GENERIC( BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3044z00, BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23045z00, BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3010z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3046za7, BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3011z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3047za7, BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3012z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3048za7, BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3013z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3049za7, BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3014z00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3050z00, BGl_z62midiscorezd2init1231zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3021z00zz__multimediazd2midizd2, BgL_bgl_string3021za700za7za7_3051za7, "midiplayer-init1237", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3016z00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3052z00, BGl_z62miditrackzd2init1233zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3023z00zz__multimediazd2midizd2, BgL_bgl_string3023za700za7za7_3053za7, "midisink-init1239", 17 );
DEFINE_STRING( BGl_string3024z00zz__multimediazd2midizd2, BgL_bgl_string3024za700za7za7_3054za7, "&midiscore-init", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3018z00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23055z00, BGl_z62midireaderzd2init1235zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3025z00zz__multimediazd2midizd2, BgL_bgl_string3025za700za7za7_3056za7, "&miditrack-init", 15 );
DEFINE_STRING( BGl_string3026z00zz__multimediazd2midizd2, BgL_bgl_string3026za700za7za7_3057za7, "&midireader-init", 16 );
DEFINE_STRING( BGl_string3027z00zz__multimediazd2midizd2, BgL_bgl_string3027za700za7za7_3058za7, "midireader", 10 );
DEFINE_STRING( BGl_string3028z00zz__multimediazd2midizd2, BgL_bgl_string3028za700za7za7_3059za7, "&midiplayer-init", 16 );
DEFINE_STRING( BGl_string3029z00zz__multimediazd2midizd2, BgL_bgl_string3029za700za7za7_3060za7, "&midisink-init", 14 );
BGL_IMPORT obj_t BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3020z00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23061z00, BGl_z62midiplayerzd2init1237zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3022z00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3062z00, BGl_z62midisinkzd2init1239zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3030z00zz__multimediazd2midizd2, BgL_bgl_string3030za700za7za7_3063za7, "#() midisink flush write-string write-byte usleep stream midiplayer meta-seqspec meta-keysig meta-timesig meta-smtpe meta-tempo meta-eot meta-midiport meta-channpref meta-devname meta-prgmname meta-cue meta-marker meta-lyric meta-instrument meta-track meta-copyright meta-text meta-seqnum sysex pitch after-touch prgmchange ctrlchange aftertouch noteon noteoff cdelay err midireader read-chars read-vlq read-int read-int32 read-int16 read-byte peek-byte miditrack eot status wtick datastart start ip int32 len %status uint32 %wtick bool %eot procedure %close %reader obj %stream __multimedia-midi midiscore vector tracks ppq tempo long format string-stream #(\"C\" \"C#\" \"D\" \"D#\" \"E\" \"F\" \"F#\" \"G\" \"G#\" \"A\" \"A#\" \"B\") #(\"\" \"Acoustic Grand Piano\" \"Bright Acoustic Piano\" \"Electric Grand Piano\" \"Honky-tonk Piano\" \"Electric Piano 1\" \"Electric Piano 2\" \"Harpsichord\" \"Clavinet\" \"Celesta\" \"Glockenspiel\" \"Music Box\" \"Vibraphone\" \"Marimba\" \"Xylophone\" \"Tubular Bells\" \"Dulcimer"
"\" \"Drawbar Organ\" \"Percussive Organ\" \"Rock Organ\" \"Church Organ\" \"Reed Organ\" \"Accordion\" \"Harmonica\" \"Tango Accordion\" \"Acoustic Guitar (nylon)\" \"Acoustic Guitar (steel)\" \"Electric Guitar (jazz)\" \"Electric Guitar (clean)\" \"Electric Guitar (muted)\" \"Overdriven Guitar\" \"Distortion Guitar\" \"Guitar harmonics\" \"Acoustic Bass\" \"Electric Bass (finger)\" \"Electric Bass (pick)\" \"Fretless Bass\" \"Slap Bass 1\" \"Slap Bass 2\" \"Synth Bass 1\" \"Synth Bass 2\" \"Violin\" \"Viola\" \"Cello\" \"Contrabass\" \"Tremolo Strings\" \"Pizzicato Strings\" \"Orchestral Harp\" \"Timpani\" \"String Ensemble 1\" \"String Ensemble 2\" \"Synth Strings 1\" \"Synth Strings 2\" \"Choir Aahs\" \"Voice Oohs\" \"Synth Voice\" \"Orchestra Hit\" \"Trumpet\" \"Trombone\" \"Tuba\" \"Muted Trumpet\" \"French Horn\" \"Brass Section\" \"Synth Brass 1\" \"Synth Brass 2\" \"Soprano Sax\" \"Alto Sax\" \"Tenor Sax\" \"Baritone Sax\" \"Oboe\" \"English Horn\" \"Bassoon\" \"Clarinet\" \"Piccolo\" \"Flute\" \"Reco"
"rder\" \"Pan Flute\" \"Blown Bottle\" \"Shakuhachi\" \"Whistle\" \"Ocarina\" \"Lead 1 (square)\" \"Lead 2 (sawtooth)\" \"Lead 3 (calliope)\" \"Lead 4 (chiff)\" \"Lead 5 (charang)\" \"Lead 6 (voice)\" \"Lead 7 (fifths)\" \"Lead 8 (bass + lead)\" \"Pad 1 (new age)\" \"Pad 2 (warm)\" \"Pad 3 (polysynth)\" \"Pad 4 (choir)\" \"Pad 5 (bowed)\" \"Pad 6 (metallic)\" \"Pad 7 (halo)\" \"Pad 8 (sweep)\" \"FX 1 (rain)\" \"FX 2 (soundtrack)\" \"FX 3 (crystal)\" \"FX 4 (atmosphere)\" \"FX 5 (brightness)\" \"FX 6 (goblins)\" \"FX 7 (echoes)\" \"FX 8 (sci-fi)\" \"Sitar\" \"Banjo\" \"Shamisen\" \"Koto\" \"Kalimba\" \"Bag pipe\" \"Fiddle\" \"Shanai\" \"Tinkle Bell\" \"Agogo\" \"Steel Drums\" \"Woodblock\" \"Taiko Drum\" \"Melodic Tom\" \"Synth Drum\" \"Reverse Cymbal\" \"Guitar Fret Noise\" \"Breath Noise\" \"Seashore\" \"Bird Tweet\" \"Telephone Ring\" \"Helicopter\" \"Applause\" \"Gunshot\") #(\"Bank Select\" \"Modulation Wheel or Lever\" \"Breath Controller\" \"Undefined\" \"Foot Controller\" \"Portamento Time\" \"Data Entr"
"y MSB\" \"Channel Volume\" \"Balance\" \"Undefined\" \"Pan\" \"Expression Controller\" \"Effect Control 1\" \"Effect Control 2\" \"Undefined\" \"Undefined\" \"General Purpose Controller 1\" \"General Purpose Controller 2\" \"General Purpose Controller 3\" \"General Purpose Controller 4\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"LSB for Control 0\" \"LSB for Control 1\" \"LSB for Control 2\" \"LSB for Control 3\" \"LSB for Control 4\" \"LSB for Control 5\" \"LSB for Control 6\" \"LSB for Control 7\" \"LSB for Control 8\" \"LSB for Control 9\" \"LSB for Control 10\" \"LSB for Control 11\" \"LSB for Control 12\" \"LSB for Control 13\" \"LSB for Control 14\" \"LSB for Control 15\" \"LSB for Control 16\" \"LSB for Control 17\" \"LSB for Control 18\" \"LSB for Control 19\" \"LSB for Control 20\" \"LSB for Control 21\" \"LSB for Control 22\" \"LSB for Control 23\" \"LSB for Control 24\" \""
"LSB for Control 25\" \"LSB for Control 26\" \"LSB for Control 27\" \"LSB for Control 28\" \"LSB for Control 29\" \"LSB for Control 30\" \"LSB for Control 31\" \"Damper Pedal on/off (Sustain)\" \"Portamento On/Off\" \"Sostenuto On/Off\" \"Soft Pedal On/Off\" \"Legato Footswitch\" \"Hold 2\" \"Sound Controller 1 (default: Sound Variation)\" \"Sound Controller 2 (default: Timbre/Harmonic Intens.)\" \"Sound Controller 3 (default: Release Time)\" \"Sound Controller 4 (default: Attack Time)\" \"Sound Controller 5 (default: Brightness)\" \"Sound Controller 6 (default: Decay Time - see MMA RP-021)\" \"Sound Controller 7 (default: Vibrato Rate - see MMA RP-021)\" \"Sound Controller 8 (default: Vibrato Depth - see MMA RP-021)\" \"Sound Controller 9 (default: Vibrato Delay - see MMA RP-021)\" \"Sound Controller 10 (default undefined - see MMA RP-021)\" \"General Purpose Controller 5\" \"General Purpose Controller 6\" \"General Purpose Controller 7\" \"General Purpose Controller 8\" \"Portamento Control\" \"Undefined\" "
"\"Undefined\" \"Undefined\" \"High Resolution Velocity Prefix\" \"Undefined\" \"Undefined\" \"Effects 1 Depth\" \"Effects 2 Depth\" \"Effects 3 Depth\" \"Effects 4 Depth\" \"Effects 5 Depth\" \"Data Increment\" \"Data Decrement\" \"Non-Registered Parameter Number (NRPN)\" \"Non-Registered Parameter Number (NRPN)\" \"Registered Parameter Number (RPN)\" \"Registered Parameter Number (RPN)\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"[Channel Mode Message] All Sound Off\" \"[Channel Mode Message] Reset All Controllers\" \"[Channel Mode Message] Local Control On/Off\" \"[Channel Mode Message] All Notes Off\" \"[Channel Mode Message] Omni Mode Off (+ all notes off)\" \"[Channel Mode Message] Omni Mode On (+ all notes off)\" \"[Channel Mode Message] Mono Mode On (+ poly off, + all notes off)\" \"[Channel Mod"
"e Message] Poly Mode On (+ mono off, +all notes off)\") #(\"\" \"text\" \"copyright\" \"track\" \"instrument\" \"lyric\" \"marker\" \"cue\") ", 5730 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3064z00, BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23065z00, BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23066z00, BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2controllerzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2contro3067z00, BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3068z00, BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2vlqza7b03069za7, BGl_z62readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23070z00, BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3071z00, BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2playzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2p3072z00, BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int32za73073za7, BGl_z62readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2800z00zz__multimediazd2midizd2, BgL_bgl_string2800za700za7za7_3074za7, "read-midi-mthd", 14 );
DEFINE_STRING( BGl_string2801z00zz__multimediazd2midizd2, BgL_bgl_string2801za700za7za7_3075za7, "invalid number of SMPTE frames per second", 41 );
DEFINE_STRING( BGl_string2802z00zz__multimediazd2midizd2, BgL_bgl_string2802za700za7za7_3076za7, "Bad header", 10 );
DEFINE_STRING( BGl_string2803z00zz__multimediazd2midizd2, BgL_bgl_string2803za700za7za7_3077za7, "MTrk", 4 );
DEFINE_STRING( BGl_string2804z00zz__multimediazd2midizd2, BgL_bgl_string2804za700za7za7_3078za7, "read-midi-mtrk", 14 );
DEFINE_STRING( BGl_string2805z00zz__multimediazd2midizd2, BgL_bgl_string2805za700za7za7_3079za7, "&read-int", 9 );
DEFINE_STRING( BGl_string2806z00zz__multimediazd2midizd2, BgL_bgl_string2806za700za7za7_3080za7, "&string-stream-peek-byte", 24 );
DEFINE_STRING( BGl_string2807z00zz__multimediazd2midizd2, BgL_bgl_string2807za700za7za7_3081za7, "struct", 6 );
DEFINE_STRING( BGl_string2808z00zz__multimediazd2midizd2, BgL_bgl_string2808za700za7za7_3082za7, "&string-stream-read-byte", 24 );
DEFINE_STRING( BGl_string2809z00zz__multimediazd2midizd2, BgL_bgl_string2809za700za7za7_3083za7, "&string-stream-read-int16", 25 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23084z00, BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2stringzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2s3085z00, BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2810z00zz__multimediazd2midizd2, BgL_bgl_string2810za700za7za7_3086za7, "&string-stream-read-int32", 25 );
DEFINE_STRING( BGl_string2811z00zz__multimediazd2midizd2, BgL_bgl_string2811za700za7za7_3087za7, "&string-stream-read-int", 23 );
DEFINE_STRING( BGl_string2812z00zz__multimediazd2midizd2, BgL_bgl_string2812za700za7za7_3088za7, "&string-stream-read-chars", 25 );
DEFINE_STRING( BGl_string2813z00zz__multimediazd2midizd2, BgL_bgl_string2813za700za7za7_3089za7, "&midiplayer-cdelay", 18 );
DEFINE_STRING( BGl_string2814z00zz__multimediazd2midizd2, BgL_bgl_string2814za700za7za7_3090za7, "miditrack", 9 );
DEFINE_STRING( BGl_string2815z00zz__multimediazd2midizd2, BgL_bgl_string2815za700za7za7_3091za7, "&midiplayer-ignore", 18 );
DEFINE_STRING( BGl_string2816z00zz__multimediazd2midizd2, BgL_bgl_string2816za700za7za7_3092za7, "&midiplayer-noteoff", 19 );
DEFINE_STRING( BGl_string2817z00zz__multimediazd2midizd2, BgL_bgl_string2817za700za7za7_3093za7, "&midiplayer-noteon", 18 );
DEFINE_STRING( BGl_string2818z00zz__multimediazd2midizd2, BgL_bgl_string2818za700za7za7_3094za7, "&midiplayer-aftertouch", 22 );
DEFINE_STRING( BGl_string2819z00zz__multimediazd2midizd2, BgL_bgl_string2819za700za7za7_3095za7, "&midiplayer-ctrlchange", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3096z00, BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2820z00zz__multimediazd2midizd2, BgL_bgl_string2820za700za7za7_3097za7, "&midiplayer-prgmchange", 22 );
DEFINE_STRING( BGl_string2821z00zz__multimediazd2midizd2, BgL_bgl_string2821za700za7za7_3098za7, "&midiplayer-after-touch", 23 );
DEFINE_STRING( BGl_string2822z00zz__multimediazd2midizd2, BgL_bgl_string2822za700za7za7_3099za7, "&midiplayer-pitch", 17 );
DEFINE_STRING( BGl_string2823z00zz__multimediazd2midizd2, BgL_bgl_string2823za700za7za7_3100za7, "&midiplayer-sysex", 17 );
DEFINE_STRING( BGl_string2824z00zz__multimediazd2midizd2, BgL_bgl_string2824za700za7za7_3101za7, "~a[~a]", 6 );
DEFINE_STRING( BGl_string2825z00zz__multimediazd2midizd2, BgL_bgl_string2825za700za7za7_3102za7, "&midi-note-name", 15 );
DEFINE_STRING( BGl_string2826z00zz__multimediazd2midizd2, BgL_bgl_string2826za700za7za7_3103za7, "unknown controller", 18 );
DEFINE_STRING( BGl_string2827z00zz__multimediazd2midizd2, BgL_bgl_string2827za700za7za7_3104za7, "&midi-controller-name", 21 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2notezd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2noteza7d3105za7, BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2828z00zz__multimediazd2midizd2, BgL_bgl_string2828za700za7za7_3106za7, "unknown program", 15 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23107z00, BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string2829z00zz__multimediazd2midizd2, BgL_bgl_string2829za700za7za7_3108za7, "&midi-program-name", 18 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2inputzd2portzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3109z00, BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2900z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2297za7623110z00, BGl_z62lambda2297z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2901z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2296za7623111z00, BGl_z62lambda2296z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2902z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3112za7, BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2903z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2260za7623113z00, BGl_z62lambda2260z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2904z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2257za7623114z00, BGl_z62lambda2257z62zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2905z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3115za7, BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2830z00zz__multimediazd2midizd2, BgL_bgl_string2830za700za7za7_3116za7, "&midi-program-index", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2906z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2314za7623117z00, BGl_z62lambda2314z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2907z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2313za7623118z00, BGl_z62lambda2313z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2908z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3119za7, BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2909z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2321za7623120z00, BGl_z62lambda2321z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2intza7b03121za7, BGl_z62readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3122z00, BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2910z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2320za7623123z00, BGl_z62lambda2320z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2911z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3124za7, BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2912z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2328za7623125z00, BGl_z62lambda2328z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2831z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2124za7623126z00, BGl_z62lambda2124z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2913z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2327za7623127z00, BGl_z62lambda2327z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2832z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2123za7623128z00, BGl_z62lambda2123z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2914z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3129za7, BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2833z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3130za7, BGl_z62zc3z04anonymousza32131ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2915z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2335za7623131z00, BGl_z62lambda2335z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2834z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2130za7623132z00, BGl_z62lambda2130z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2916z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2334za7623133z00, BGl_z62lambda2334z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2835z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2129za7623134z00, BGl_z62lambda2129z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2917z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3135za7, BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2836z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3136za7, BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2918z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2342za7623137z00, BGl_z62lambda2342z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2837z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2137za7623138z00, BGl_z62lambda2137z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2919z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2341za7623139z00, BGl_z62lambda2341z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2838z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2136za7623140z00, BGl_z62lambda2136z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2839z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3141za7, BGl_z62zc3z04anonymousza32145ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2920z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3142za7, BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2921z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2349za7623143z00, BGl_z62lambda2349z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2840z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2144za7623144z00, BGl_z62lambda2144z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2922z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2348za7623145z00, BGl_z62lambda2348z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2841z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2143za7623146z00, BGl_z62lambda2143z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2923z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3147za7, BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2842z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3148za7, BGl_z62zc3z04anonymousza32119ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2924z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2356za7623149z00, BGl_z62lambda2356z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2843z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2117za7623150z00, BGl_z62lambda2117z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2762z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3151za7, BGl_z62zc3z04anonymousza31247ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2925z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2355za7623152z00, BGl_z62lambda2355z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2844z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2114za7623153z00, BGl_z62lambda2114z62zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2763z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3154za7, BGl_z62zc3z04anonymousza31248ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23155z00, BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2926z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3156za7, BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2845z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3157za7, BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2764z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3158za7, BGl_z62zc3z04anonymousza31249ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3159z00, BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2927z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2363za7623160z00, BGl_z62lambda2363z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2846z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2162za7623161z00, BGl_z62lambda2162z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2765z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3162za7, BGl_z62zc3z04anonymousza31250ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2928z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2362za7623163z00, BGl_z62lambda2362z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2847z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2161za7623164z00, BGl_z62lambda2161z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2766z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3165za7, BGl_z62zc3z04anonymousza31251ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2929z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3166za7, BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2848z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2168za7623167z00, BGl_z62lambda2168z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2767z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3168za7, BGl_z62zc3z04anonymousza31252ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2849z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2167za7623169z00, BGl_z62lambda2167z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2768z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3170za7, BGl_z62zc3z04anonymousza31253ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2769z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3171za7, BGl_z62zc3z04anonymousza31254ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string2777z00zz__multimediazd2midizd2, BgL_bgl_string2777za700za7za7_3172za7, "midiscore-file", 14 );
DEFINE_STRING( BGl_string2778z00zz__multimediazd2midizd2, BgL_bgl_string2778za700za7za7_3173za7, "format not supported", 20 );
DEFINE_STRING( BGl_string2779z00zz__multimediazd2midizd2, BgL_bgl_string2779za700za7za7_3174za7, "midiplayer-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int16za73175za7, BGl_z62readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2930z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2370za7623176z00, BGl_z62lambda2370z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2931z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2369za7623177z00, BGl_z62lambda2369z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2850z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2173za7623178z00, BGl_z62lambda2173z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2932z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3179za7, BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2851z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2172za7623180z00, BGl_z62lambda2172z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2770z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3181za7, BGl_z62zc3z04anonymousza31255ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2933z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2377za7623182z00, BGl_z62lambda2377z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2852z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3183za7, BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2771z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3184za7, BGl_z62zc3z04anonymousza31390ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2934z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2376za7623185z00, BGl_z62lambda2376z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2853z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2180za7623186z00, BGl_z62lambda2180z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2772z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3187za7, BGl_z62zc3z04anonymousza31391ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2935z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3188za7, BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2854z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2179za7623189z00, BGl_z62lambda2179z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2773z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3190za7, BGl_z62zc3z04anonymousza31517ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2936z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2384za7623191z00, BGl_z62lambda2384z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2855z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3192za7, BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2780z00zz__multimediazd2midizd2, BgL_bgl_string2780za700za7za7_3193za7, "bad midi format", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2774z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3194za7, BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2937z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2383za7623195z00, BGl_z62lambda2383z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2856z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2187za7623196z00, BGl_z62lambda2187z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2781z00zz__multimediazd2midizd2, BgL_bgl_string2781za700za7za7_3197za7, "/builddir/build/BUILD/bigloo-4.4b/api/multimedia/src/Llib/midi.scm", 66 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2775z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3198za7, BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2938z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3199za7, BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2857z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2186za7623200z00, BGl_z62lambda2186z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2782z00zz__multimediazd2midizd2, BgL_bgl_string2782za700za7za7_3201za7, "&midiscore-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2776z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3202za7, BGl_z62zc3z04anonymousza31520ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2939z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2391za7623203z00, BGl_z62lambda2391z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2858z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3204za7, BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2783z00zz__multimediazd2midizd2, BgL_bgl_string2783za700za7za7_3205za7, "bstring", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2859z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2194za7623206z00, BGl_z62lambda2194z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2784z00zz__multimediazd2midizd2, BgL_bgl_string2784za700za7za7_3207za7, "&miditrack-input-port", 21 );
DEFINE_STRING( BGl_string2785z00zz__multimediazd2midizd2, BgL_bgl_string2785za700za7za7_3208za7, "input-port", 10 );
DEFINE_STRING( BGl_string2786z00zz__multimediazd2midizd2, BgL_bgl_string2786za700za7za7_3209za7, "bint", 4 );
DEFINE_STRING( BGl_string2787z00zz__multimediazd2midizd2, BgL_bgl_string2787za700za7za7_3210za7, "&miditrack-file", 15 );
DEFINE_STRING( BGl_string2789z00zz__multimediazd2midizd2, BgL_bgl_string2789za700za7za7_3211za7, "&miditrack-string", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2940z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2390za7623212z00, BGl_z62lambda2390z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2941z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3213za7, BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2860z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2193za7623214z00, BGl_z62lambda2193z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2942z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2398za7623215z00, BGl_z62lambda2398z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2861z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3216za7, BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2943z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2397za7623217z00, BGl_z62lambda2397z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2862z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2201za7623218z00, BGl_z62lambda2201z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2944z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3219za7, BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2863z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2200za7623220z00, BGl_z62lambda2200z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23221z00, BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2945z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2405za7623222z00, BGl_z62lambda2405z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2864z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3223za7, BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2946z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2404za7623224z00, BGl_z62lambda2404z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2865z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2208za7623225z00, BGl_z62lambda2208z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2790z00zz__multimediazd2midizd2, BgL_bgl_string2790za700za7za7_3226za7, "midiscore-play", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2947z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3227za7, BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2866z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2207za7623228z00, BGl_z62lambda2207z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2791z00zz__multimediazd2midizd2, BgL_bgl_string2791za700za7za7_3229za7, "&midiscore-play", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2948z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2412za7623230z00, BGl_z62lambda2412z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2867z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3231za7, BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2792z00zz__multimediazd2midizd2, BgL_bgl_string2792za700za7za7_3232za7, "midiscore", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2949z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2411za7623233z00, BGl_z62lambda2411z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2868z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2215za7623234z00, BGl_z62lambda2215z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2793z00zz__multimediazd2midizd2, BgL_bgl_string2793za700za7za7_3235za7, "midiplayer", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2869z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2214za7623236z00, BGl_z62lambda2214z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2794z00zz__multimediazd2midizd2, BgL_bgl_string2794za700za7za7_3237za7, "midisink", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2788z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3238za7, BGl_z62zc3z04anonymousza31654ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2795z00zz__multimediazd2midizd2, BgL_bgl_string2795za700za7za7_3239za7, "~x:~x", 5 );
DEFINE_STRING( BGl_string2796z00zz__multimediazd2midizd2, BgL_bgl_string2796za700za7za7_3240za7, "midiplay", 8 );
BGL_IMPORT obj_t BGl_sleepzd2envzd2zz__osz00;
DEFINE_STRING( BGl_string2797z00zz__multimediazd2midizd2, BgL_bgl_string2797za700za7za7_3241za7, "illegal meta-event", 18 );
DEFINE_STRING( BGl_string2798z00zz__multimediazd2midizd2, BgL_bgl_string2798za700za7za7_3242za7, "illegal event", 13 );
DEFINE_STRING( BGl_string2799z00zz__multimediazd2midizd2, BgL_bgl_string2799za700za7za7_3243za7, "MThd", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2950z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3244za7, BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2951z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2419za7623245z00, BGl_z62lambda2419z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2870z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3246za7, BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2952z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2418za7623247z00, BGl_z62lambda2418z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2871z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2222za7623248z00, BGl_z62lambda2222z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2953z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3249za7, BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2872z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2221za7623250z00, BGl_z62lambda2221z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2954z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2426za7623251z00, BGl_z62lambda2426z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2873z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3252za7, BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
BGL_IMPORT obj_t BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2955z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2425za7623253z00, BGl_z62lambda2425z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2874z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2229za7623254z00, BGl_z62lambda2229z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2956z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3255za7, BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2875z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2228za7623256z00, BGl_z62lambda2228z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2957z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2433za7623257z00, BGl_z62lambda2433z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2876z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3258za7, BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2958z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2432za7623259z00, BGl_z62lambda2432z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2877z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2236za7623260z00, BGl_z62lambda2236z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2959z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3261za7, BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2878z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2235za7623262z00, BGl_z62lambda2235z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2879z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3263za7, BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2960z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2440za7623264z00, BGl_z62lambda2440z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2961z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2439za7623265z00, BGl_z62lambda2439z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2880z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2243za7623266z00, BGl_z62lambda2243z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2962z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3267za7, BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2881z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2242za7623268z00, BGl_z62lambda2242z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2963z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2447za7623269z00, BGl_z62lambda2447z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2882z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3270za7, BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2964z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2446za7623271z00, BGl_z62lambda2446z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2883z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2250za7623272z00, BGl_z62lambda2250z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2965z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3273za7, BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2884z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2249za7623274z00, BGl_z62lambda2249z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2966z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2454za7623275z00, BGl_z62lambda2454z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2885z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3276za7, BGl_z62zc3z04anonymousza32156ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2967z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2453za7623277z00, BGl_z62lambda2453z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2886z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2154za7623278z00, BGl_z62lambda2154z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2968z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3279za7, BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2887z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2151za7623280z00, BGl_z62lambda2151z62zz__multimediazd2midizd2, 0L, BUNSPEC, 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2969z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2461za7623281z00, BGl_z62lambda2461z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2888z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2267za7623282z00, BGl_z62lambda2267z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2889z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2266za7623283z00, BGl_z62lambda2266z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2970z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2460za7623284z00, BGl_z62lambda2460z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2971z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3285za7, BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2890z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2272za7623286z00, BGl_z62lambda2272z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2972z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2468za7623287z00, BGl_z62lambda2468z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2891z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2271za7623288z00, BGl_z62lambda2271z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2973z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2467za7623289z00, BGl_z62lambda2467z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2892z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2277za7623290z00, BGl_z62lambda2277z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2974z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3291za7, BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2893z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2276za7623292z00, BGl_z62lambda2276z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2975z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2475za7623293z00, BGl_z62lambda2475z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2894z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2282za7623294z00, BGl_z62lambda2282z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2976z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2474za7623295z00, BGl_z62lambda2474z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2895z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2281za7623296z00, BGl_z62lambda2281z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2977z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3297za7, BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2896z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2287za7623298z00, BGl_z62lambda2287z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2978z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2482za7623299z00, BGl_z62lambda2482z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2897z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2286za7623300z00, BGl_z62lambda2286z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2979z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2481za7623301z00, BGl_z62lambda2481z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2898z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2292za7623302z00, BGl_z62lambda2292z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2899z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2291za7623303z00, BGl_z62lambda2291z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2980z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3304za7, BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2981z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2490za7623305z00, BGl_z62lambda2490z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2982z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2489za7623306z00, BGl_z62lambda2489z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2983z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3307za7, BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2984z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2498za7623308z00, BGl_z62lambda2498z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2985z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2497za7623309z00, BGl_z62lambda2497z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2986z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3310za7, BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2987z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2505za7623311z00, BGl_z62lambda2505z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2988z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2504za7623312z00, BGl_z62lambda2504z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2989z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3313za7, BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2990z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2306za7623314z00, BGl_z62lambda2306z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2991z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2303za7623315z00, BGl_z62lambda2303z62zz__multimediazd2midizd2, 0L, BUNSPEC, 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2992z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3316za7, BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2993z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2523za7623317z00, BGl_z62lambda2523z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2994z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2522za7623318z00, BGl_z62lambda2522z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2995z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3319za7, BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2996z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2530za7623320z00, BGl_z62lambda2530z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2997z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2529za7623321z00, BGl_z62lambda2529z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2998z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3322za7, BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2999z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2537za7623323z00, BGl_z62lambda2537z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2f3324z00, BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2indexzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3325z00, BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23326z00, BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3327z00, BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23328z00, BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23329z00, BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3330z00, BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3331z00, BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23332z00, BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3333z00, BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3000z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2536za7623334z00, BGl_z62lambda2536z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3001z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3335za7, BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3002z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2545za7623336z00, BGl_z62lambda2545z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_midisinkzd2nullzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiscorez00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2programzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_miditrackz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerzd2readzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2textzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2notezd2namesz00zz__multimediazd2midizd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long BgL_checksumz00_4198, char * BgL_fromz00_4199)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2midizd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2(); 
BGl_cnstzd2initzd2zz__multimediazd2midizd2(); 
BGl_objectzd2initzd2zz__multimediazd2midizd2(); 
BGl_genericzd2initzd2zz__multimediazd2midizd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2midizd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__multimedia-midi"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_cportz00_3849;
{ /* Llib/midi.scm 15 */
obj_t BgL_stringz00_3857;
BgL_stringz00_3857 = BGl_string3030z00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 15 */
obj_t BgL_startz00_3858;
BgL_startz00_3858 = 
BINT(((long)0)); 
{ /* Llib/midi.scm 15 */
obj_t BgL_endz00_3859;
BgL_endz00_3859 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_3857))); 
{ /* Llib/midi.scm 15 */

BgL_cportz00_3849 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_3857, BgL_startz00_3858, BgL_endz00_3859); } } } } 
{ 
long BgL_iz00_3850;
BgL_iz00_3850 = ((long)75); 
BgL_loopz00_3851:
if(
(BgL_iz00_3850==((long)-1)))
{ /* Llib/midi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_arg3032z00_3853;
{ /* Llib/midi.scm 15 */

{ /* Llib/midi.scm 15 */
obj_t BgL_locationz00_3855;
BgL_locationz00_3855 = 
BBOOL(((bool_t)0)); 
{ /* Llib/midi.scm 15 */

BgL_arg3032z00_3853 = 
BGl_readz00zz__readerz00(BgL_cportz00_3849, BgL_locationz00_3855); } } } 
{ /* Llib/midi.scm 15 */
int BgL_tmpz00_4236;
BgL_tmpz00_4236 = 
(int)(BgL_iz00_3850); 
CNST_TABLE_SET(BgL_tmpz00_4236, BgL_arg3032z00_3853); } } 
{ /* Llib/midi.scm 15 */
int BgL_auxz00_3856;
BgL_auxz00_3856 = 
(int)(
(BgL_iz00_3850-((long)1))); 
{ 
long BgL_iz00_4241;
BgL_iz00_4241 = 
(long)(BgL_auxz00_3856); 
BgL_iz00_3850 = BgL_iz00_4241; 
goto BgL_loopz00_3851;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 133 */
BgL_midireaderz00_bglt BgL_new1121z00_143;
{ /* Llib/midi.scm 134 */
BgL_midireaderz00_bglt BgL_new1120z00_145;
BgL_new1120z00_145 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 134 */
long BgL_arg1242z00_146;
BgL_arg1242z00_146 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1120z00_145), BgL_arg1242z00_146); } 
BgL_new1121z00_143 = BgL_new1120z00_145; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_peekzd2bytezd2)=((obj_t)BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2bytezd2)=((obj_t)BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int16zd2)=((obj_t)BGl_readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2int32zd2)=((obj_t)BGl_readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2intzd2)=((obj_t)BGl_readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2vlqzd2)=((obj_t)BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1121z00_143))->BgL_readzd2charszd2)=((obj_t)BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
{ /* Llib/midi.scm 133 */
obj_t BgL_fun1241z00_144;
BgL_fun1241z00_144 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1241z00_144)(BgL_fun1241z00_144, 
((obj_t)BgL_new1121z00_143), BEOA); } 
BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2 = BgL_new1121z00_143; } 
{ /* Llib/midi.scm 146 */
BgL_midireaderz00_bglt BgL_new1123z00_147;
{ /* Llib/midi.scm 147 */
BgL_midireaderz00_bglt BgL_new1122z00_149;
BgL_new1122z00_149 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 147 */
long BgL_arg1244z00_150;
BgL_arg1244z00_150 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1122z00_149), BgL_arg1244z00_150); } 
BgL_new1123z00_147 = BgL_new1122z00_149; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_peekzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int16zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2int32zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2intzd2)=((obj_t)BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2vlqzd2)=((obj_t)BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1123z00_147))->BgL_readzd2charszd2)=((obj_t)BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 146 */
obj_t BgL_fun1243z00_148;
BgL_fun1243z00_148 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1243z00_148)(BgL_fun1243z00_148, 
((obj_t)BgL_new1123z00_147), BEOA); } 
BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2 = BgL_new1123z00_147; } 
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1125z00_151;
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1124z00_264;
BgL_new1124z00_264 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 159 */
long BgL_arg1516z00_265;
BgL_arg1516z00_265 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1124z00_264), BgL_arg1516z00_265); } 
BgL_new1125z00_151 = BgL_new1124z00_264; } 
{ 
obj_t BgL_auxz00_4282;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1245z00_152;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1246z00_153;
{ /* Llib/midi.scm 159 */
obj_t BgL_classz00_1873;
BgL_classz00_1873 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1246z00_153 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1873); } 
BgL_arg1245z00_152 = 
VECTOR_REF(BgL_arg1246z00_153,((long)0)); } 
BgL_auxz00_4282 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1245z00_152); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_errz00)=((obj_t)BgL_auxz00_4282),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_cdelayz00)=((obj_t)BGl_proc2762z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteoffz00)=((obj_t)BGl_proc2763z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_noteonz00)=((obj_t)BGl_proc2764z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_aftertouchz00)=((obj_t)BGl_proc2765z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_ctrlchangez00)=((obj_t)BGl_proc2766z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_prgmchangez00)=((obj_t)BGl_proc2767z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_afterzd2touchzd2)=((obj_t)BGl_proc2768z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_pitchz00)=((obj_t)BGl_proc2769z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_sysexz00)=((obj_t)BGl_proc2770z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4296;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1258z00_214;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1277z00_215;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1875;
BgL_classz00_1875 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1277z00_215 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1875); } 
BgL_arg1258z00_214 = 
VECTOR_REF(BgL_arg1277z00_215,((long)10)); } 
BgL_auxz00_4296 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1258z00_214); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqnumzd2)=((obj_t)BgL_auxz00_4296),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4301;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1279z00_216;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1280z00_217;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1877;
BgL_classz00_1877 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1280z00_217 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1877); } 
BgL_arg1279z00_216 = 
VECTOR_REF(BgL_arg1280z00_217,((long)11)); } 
BgL_auxz00_4301 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1279z00_216); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2textzd2)=((obj_t)BgL_auxz00_4301),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4306;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1281z00_218;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1318z00_219;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1879;
BgL_classz00_1879 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1318z00_219 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1879); } 
BgL_arg1281z00_218 = 
VECTOR_REF(BgL_arg1318z00_219,((long)12)); } 
BgL_auxz00_4306 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1281z00_218); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2copyrightzd2)=((obj_t)BgL_auxz00_4306),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4311;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1319z00_220;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1320z00_221;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1881;
BgL_classz00_1881 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1320z00_221 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1881); } 
BgL_arg1319z00_220 = 
VECTOR_REF(BgL_arg1320z00_221,((long)13)); } 
BgL_auxz00_4311 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1319z00_220); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2trackzd2)=((obj_t)BgL_auxz00_4311),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4316;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1321z00_222;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1323z00_223;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1883;
BgL_classz00_1883 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1323z00_223 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1883); } 
BgL_arg1321z00_222 = 
VECTOR_REF(BgL_arg1323z00_223,((long)14)); } 
BgL_auxz00_4316 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1321z00_222); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2instrumentzd2)=((obj_t)BgL_auxz00_4316),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4321;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1324z00_224;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1330z00_225;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1885;
BgL_classz00_1885 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1330z00_225 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1885); } 
BgL_arg1324z00_224 = 
VECTOR_REF(BgL_arg1330z00_225,((long)15)); } 
BgL_auxz00_4321 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1324z00_224); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2lyriczd2)=((obj_t)BgL_auxz00_4321),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4326;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1333z00_226;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1334z00_227;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1887;
BgL_classz00_1887 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1334z00_227 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1887); } 
BgL_arg1333z00_226 = 
VECTOR_REF(BgL_arg1334z00_227,((long)16)); } 
BgL_auxz00_4326 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1333z00_226); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2markerzd2)=((obj_t)BgL_auxz00_4326),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4331;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1338z00_228;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1339z00_229;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1889;
BgL_classz00_1889 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1339z00_229 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1889); } 
BgL_arg1338z00_228 = 
VECTOR_REF(BgL_arg1339z00_229,((long)17)); } 
BgL_auxz00_4331 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1338z00_228); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2cuezd2)=((obj_t)BgL_auxz00_4331),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4336;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1341z00_230;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1344z00_231;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1891;
BgL_classz00_1891 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1344z00_231 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1891); } 
BgL_arg1341z00_230 = 
VECTOR_REF(BgL_arg1344z00_231,((long)18)); } 
BgL_auxz00_4336 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1341z00_230); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2prgmnamezd2)=((obj_t)BgL_auxz00_4336),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4341;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1345z00_232;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1346z00_233;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1893;
BgL_classz00_1893 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1346z00_233 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1893); } 
BgL_arg1345z00_232 = 
VECTOR_REF(BgL_arg1346z00_233,((long)19)); } 
BgL_auxz00_4341 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1345z00_232); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2devnamezd2)=((obj_t)BgL_auxz00_4341),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4346;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1356z00_234;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1357z00_235;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1895;
BgL_classz00_1895 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1357z00_235 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1895); } 
BgL_arg1356z00_234 = 
VECTOR_REF(BgL_arg1357z00_235,((long)20)); } 
BgL_auxz00_4346 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1356z00_234); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2channprefzd2)=((obj_t)BgL_auxz00_4346),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4351;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1358z00_236;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1359z00_237;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1897;
BgL_classz00_1897 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1359z00_237 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1897); } 
BgL_arg1358z00_236 = 
VECTOR_REF(BgL_arg1359z00_237,((long)21)); } 
BgL_auxz00_4351 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1358z00_236); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2midiportzd2)=((obj_t)BgL_auxz00_4351),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4356;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1360z00_238;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1361z00_239;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1899;
BgL_classz00_1899 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1361z00_239 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1899); } 
BgL_arg1360z00_238 = 
VECTOR_REF(BgL_arg1361z00_239,((long)22)); } 
BgL_auxz00_4356 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1360z00_238); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2eotzd2)=((obj_t)BgL_auxz00_4356),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4361;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1362z00_240;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1389z00_241;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1901;
BgL_classz00_1901 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1389z00_241 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1901); } 
BgL_arg1362z00_240 = 
VECTOR_REF(BgL_arg1389z00_241,((long)23)); } 
BgL_auxz00_4361 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1362z00_240); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2tempozd2)=((obj_t)BgL_auxz00_4361),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2smtpezd2)=((obj_t)BGl_proc2771z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2timesigzd2)=((obj_t)BGl_proc2772z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4368;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1431z00_259;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1506z00_260;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1903;
BgL_classz00_1903 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1506z00_260 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1903); } 
BgL_arg1431z00_259 = 
VECTOR_REF(BgL_arg1506z00_260,((long)26)); } 
BgL_auxz00_4368 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1431z00_259); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2keysigzd2)=((obj_t)BgL_auxz00_4368),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4373;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1507z00_261;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1512z00_262;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1905;
BgL_classz00_1905 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_arg1512z00_262 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1905); } 
BgL_arg1507z00_261 = 
VECTOR_REF(BgL_arg1512z00_262,((long)27)); } 
BgL_auxz00_4373 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1507z00_261); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1125z00_151))->BgL_metazd2seqspeczd2)=((obj_t)BgL_auxz00_4373),BUNSPEC); } 
{ /* Llib/midi.scm 159 */
obj_t BgL_fun1513z00_263;
BgL_fun1513z00_263 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1513z00_263)(BgL_fun1513z00_263, 
((obj_t)BgL_new1125z00_151), BEOA); } 
BGl_midiplayerzd2readzd2zz__multimediazd2midizd2 = BgL_new1125z00_151; } 
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1127z00_266;
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1126z00_278;
BgL_new1126z00_278 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 174 */
long BgL_arg1524z00_279;
BgL_arg1524z00_279 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1126z00_278), BgL_arg1524z00_279); } 
BgL_new1127z00_266 = BgL_new1126z00_278; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_usleepz00)=((obj_t)BGl_proc2773z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2bytezd2)=((obj_t)BGl_proc2774z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_writezd2stringzd2)=((obj_t)BGl_proc2775z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1127z00_266))->BgL_flushz00)=((obj_t)BGl_proc2776z00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 174 */
obj_t BgL_fun1521z00_277;
BgL_fun1521z00_277 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1521z00_277)(BgL_fun1521z00_277, 
((obj_t)BgL_new1127z00_266), BEOA); } 
BGl_midisinkzd2nullzd2zz__multimediazd2midizd2 = BgL_new1127z00_266; } 
BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)0)); 
BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)1)); 
BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)2)); 
BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)3)); 
return BUNSPEC;} 

}



/* &<@anonymous:1520> */
obj_t BGl_z62zc3z04anonymousza31520ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2746, obj_t BgL_opz00_2747)
{
{ /* Llib/midi.scm 178 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1519> */
obj_t BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2748, obj_t BgL_opz00_2749, obj_t BgL_bz00_2750)
{
{ /* Llib/midi.scm 177 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1518> */
obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2751, obj_t BgL_opz00_2752, obj_t BgL_bz00_2753)
{
{ /* Llib/midi.scm 176 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1517> */
obj_t BGl_z62zc3z04anonymousza31517ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2754, obj_t BgL_sz00_2755)
{
{ /* Llib/midi.scm 175 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1391> */
obj_t BGl_z62zc3z04anonymousza31391ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2756, obj_t BgL_mpz00_2757, obj_t BgL_msz00_2758, obj_t BgL_tickz00_2759, obj_t BgL_nnz00_2760, obj_t BgL_ddz00_2761, obj_t BgL_ccz00_2762, obj_t BgL_bbz00_2763)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1390> */
obj_t BGl_z62zc3z04anonymousza31390ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2764, obj_t BgL_mpz00_2765, obj_t BgL_msz00_2766, obj_t BgL_tickz00_2767, obj_t BgL_hrz00_2768, obj_t BgL_mmz00_2769, obj_t BgL_sez00_2770, obj_t BgL_frz00_2771, obj_t BgL_ffz00_2772)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1255> */
obj_t BGl_z62zc3z04anonymousza31255ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2773, obj_t BgL_mpz00_2774, obj_t BgL_msz00_2775, obj_t BgL_tickz00_2776, obj_t BgL_sz00_2777)
{
{ /* Llib/midi.scm 168 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1254> */
obj_t BGl_z62zc3z04anonymousza31254ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2778, obj_t BgL_mpz00_2779, obj_t BgL_msz00_2780, obj_t BgL_tickz00_2781, obj_t BgL_xz00_2782, obj_t BgL_yz00_2783, obj_t BgL_za7za7_2784)
{
{ /* Llib/midi.scm 167 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1253> */
obj_t BGl_z62zc3z04anonymousza31253ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2785, obj_t BgL_mpz00_2786, obj_t BgL_msz00_2787, obj_t BgL_tickz00_2788, obj_t BgL_xz00_2789, obj_t BgL_yz00_2790)
{
{ /* Llib/midi.scm 166 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1252> */
obj_t BGl_z62zc3z04anonymousza31252ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2791, obj_t BgL_mpz00_2792, obj_t BgL_msz00_2793, obj_t BgL_tickz00_2794, obj_t BgL_xz00_2795, obj_t BgL_yz00_2796)
{
{ /* Llib/midi.scm 165 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1251> */
obj_t BGl_z62zc3z04anonymousza31251ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2797, obj_t BgL_mpz00_2798, obj_t BgL_msz00_2799, obj_t BgL_tickz00_2800, obj_t BgL_xz00_2801, obj_t BgL_yz00_2802, obj_t BgL_za7za7_2803)
{
{ /* Llib/midi.scm 164 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1250> */
obj_t BGl_z62zc3z04anonymousza31250ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2804, obj_t BgL_mpz00_2805, obj_t BgL_msz00_2806, obj_t BgL_tickz00_2807, obj_t BgL_xz00_2808, obj_t BgL_yz00_2809, obj_t BgL_za7za7_2810)
{
{ /* Llib/midi.scm 163 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1249> */
obj_t BGl_z62zc3z04anonymousza31249ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2811, obj_t BgL_mpz00_2812, obj_t BgL_msz00_2813, obj_t BgL_tickz00_2814, obj_t BgL_xz00_2815, obj_t BgL_yz00_2816, obj_t BgL_za7za7_2817)
{
{ /* Llib/midi.scm 162 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1248> */
obj_t BGl_z62zc3z04anonymousza31248ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2818, obj_t BgL_mpz00_2819, obj_t BgL_msz00_2820, obj_t BgL_tickz00_2821, obj_t BgL_xz00_2822, obj_t BgL_yz00_2823, obj_t BgL_za7za7_2824)
{
{ /* Llib/midi.scm 161 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1247> */
obj_t BGl_z62zc3z04anonymousza31247ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2825, obj_t BgL_mpz00_2826, obj_t BgL_msz00_2827, obj_t BgL_tickz00_2828, obj_t BgL_trackz00_2829, obj_t BgL_ppqz00_2830, obj_t BgL_dtz00_2831, obj_t BgL_usz00_2832)
{
{ /* Llib/midi.scm 160 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-file */
BGL_EXPORTED_DEF BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_13)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_ipz00_299;
{ /* Llib/midi.scm 184 */

BgL_ipz00_299 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_13, BTRUE, 
BINT(((long)5000000))); } 
{ /* Llib/midi.scm 185 */
obj_t BgL_sza7za7_300;
BgL_sza7za7_300 = 
BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(BgL_ipz00_299); 
{ /* Llib/midi.scm 186 */
obj_t BgL_fmtz00_301;obj_t BgL_tckz00_302;obj_t BgL_tempoz00_303;obj_t BgL_ppqz00_304;
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4421;
BgL_tmpz00_4421 = 
(int)(((long)1)); 
BgL_fmtz00_301 = 
BGL_MVALUES_VAL(BgL_tmpz00_4421); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4424;
BgL_tmpz00_4424 = 
(int)(((long)2)); 
BgL_tckz00_302 = 
BGL_MVALUES_VAL(BgL_tmpz00_4424); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4427;
BgL_tmpz00_4427 = 
(int)(((long)3)); 
BgL_tempoz00_303 = 
BGL_MVALUES_VAL(BgL_tmpz00_4427); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4430;
BgL_tmpz00_4430 = 
(int)(((long)4)); 
BgL_ppqz00_304 = 
BGL_MVALUES_VAL(BgL_tmpz00_4430); } 
{ /* Llib/midi.scm 187 */
obj_t BgL_tracksz00_305;
if(
INTEGERP(BgL_fmtz00_301))
{ /* Llib/midi.scm 187 */
switch( 
(long)CINT(BgL_fmtz00_301)) { case ((long)0) : 

{ /* Llib/midi.scm 188 */
obj_t BgL_v1187z00_313;
BgL_v1187z00_313 = 
create_vector(((long)1)); 
{ /* Llib/midi.scm 188 */
BgL_miditrackz00_bglt BgL_arg1580z00_314;
BgL_arg1580z00_314 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_299, 
(long)CINT(BgL_tempoz00_303)); 
VECTOR_SET(BgL_v1187z00_313,((long)0),
((obj_t)BgL_arg1580z00_314)); } 
BgL_tracksz00_305 = BgL_v1187z00_313; } break;case ((long)1) : 

BgL_tracksz00_305 = 
BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_299, 
(long)CINT(BgL_tempoz00_303), BgL_tckz00_302); break;case ((long)2) : 

BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string2777z00zz__multimediazd2midizd2, BGl_string2778z00zz__multimediazd2midizd2, BgL_fmtz00_301); break;
default: 
BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string2779z00zz__multimediazd2midizd2, BGl_string2780z00zz__multimediazd2midizd2, BgL_fmtz00_301); } }  else 
{ /* Llib/midi.scm 187 */
BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string2779z00zz__multimediazd2midizd2, BGl_string2780z00zz__multimediazd2midizd2, BgL_fmtz00_301); } 
{ /* Llib/midi.scm 192 */
BgL_midiscorez00_bglt BgL_new1131z00_306;
{ /* Llib/midi.scm 193 */
BgL_midiscorez00_bglt BgL_new1130z00_308;
BgL_new1130z00_308 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 193 */
long BgL_arg1564z00_309;
BgL_arg1564z00_309 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1130z00_308), BgL_arg1564z00_309); } 
BgL_new1131z00_306 = BgL_new1130z00_308; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_306))->BgL_formatz00)=((long)
(long)CINT(BgL_fmtz00_301)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_306))->BgL_tempoz00)=((long)
(long)CINT(BgL_tempoz00_303)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_306))->BgL_ppqz00)=((long)
(long)CINT(BgL_ppqz00_304)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1131z00_306))->BgL_tracksz00)=((obj_t)BgL_tracksz00_305),BUNSPEC); 
{ /* Llib/midi.scm 192 */
obj_t BgL_fun1563z00_307;
BgL_fun1563z00_307 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1563z00_307)(BgL_fun1563z00_307, 
((obj_t)BgL_new1131z00_306), BEOA); } 
return BgL_new1131z00_306;} } } } } } 

}



/* &midiscore-file */
BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2865, obj_t BgL_filenamez00_2866)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_auxz00_4464;
if(
STRINGP(BgL_filenamez00_2866))
{ /* Llib/midi.scm 184 */
BgL_auxz00_4464 = BgL_filenamez00_2866
; }  else 
{ 
obj_t BgL_auxz00_4467;
BgL_auxz00_4467 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)8489)), BGl_string2782z00zz__multimediazd2midizd2, BGl_string2783z00zz__multimediazd2midizd2, BgL_filenamez00_2866); 
FAILURE(BgL_auxz00_4467,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4464);} } 

}



/* miditrack-input-port */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_15, long BgL_tempoz00_16)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
BgL_miditrackz00_bglt BgL_new1135z00_331;
{ /* Llib/midi.scm 213 */
BgL_miditrackz00_bglt BgL_new1134z00_333;
BgL_new1134z00_333 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 213 */
long BgL_arg1615z00_334;
BgL_arg1615z00_334 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_333), BgL_arg1615z00_334); } 
BgL_new1135z00_331 = BgL_new1134z00_333; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52streamz52)=((obj_t)BgL_ipz00_15),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52closez52)=((obj_t)BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4482;
{ /* Llib/midi.scm 216 */
obj_t BgL_tmpz00_4483;
BgL_tmpz00_4483 = 
BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(BgL_ipz00_15); 
BgL_auxz00_4482 = 
BGL_BINT32_TO_INT32(BgL_tmpz00_4483); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_lenz00)=((int32_t)BgL_auxz00_4482),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_tempoz00)=((long)BgL_tempoz00_16),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1135z00_331))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 212 */
obj_t BgL_fun1594z00_332;
BgL_fun1594z00_332 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1594z00_332)(BgL_fun1594z00_332, 
((obj_t)BgL_new1135z00_331), BEOA); } 
return BgL_new1135z00_331;} } 

}



/* &miditrack-input-port */
BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t BgL_envz00_2867, obj_t BgL_ipz00_2868, obj_t BgL_tempoz00_2869)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
long BgL_auxz00_4507;obj_t BgL_auxz00_4500;
{ /* Llib/midi.scm 212 */
obj_t BgL_tmpz00_4508;
if(
INTEGERP(BgL_tempoz00_2869))
{ /* Llib/midi.scm 212 */
BgL_tmpz00_4508 = BgL_tempoz00_2869
; }  else 
{ 
obj_t BgL_auxz00_4511;
BgL_auxz00_4511 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string2784z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tempoz00_2869); 
FAILURE(BgL_auxz00_4511,BFALSE,BFALSE);} 
BgL_auxz00_4507 = 
(long)CINT(BgL_tmpz00_4508); } 
if(
INPUT_PORTP(BgL_ipz00_2868))
{ /* Llib/midi.scm 212 */
BgL_auxz00_4500 = BgL_ipz00_2868
; }  else 
{ 
obj_t BgL_auxz00_4503;
BgL_auxz00_4503 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string2784z00zz__multimediazd2midizd2, BGl_string2785z00zz__multimediazd2midizd2, BgL_ipz00_2868); 
FAILURE(BgL_auxz00_4503,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_auxz00_4500, BgL_auxz00_4507);} } 

}



/* miditracks-input-port */
obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_17, long BgL_tempoz00_18, obj_t BgL_tnumz00_19)
{
{ /* Llib/midi.scm 222 */
{ 
obj_t BgL_ipz00_361;long BgL_tempoz00_362;
{ /* Llib/midi.scm 241 */
BgL_miditrackz00_bglt BgL_t0z00_337;
BgL_ipz00_361 = BgL_ipz00_17; 
BgL_tempoz00_362 = BgL_tempoz00_18; 
{ /* Llib/midi.scm 225 */
BgL_miditrackz00_bglt BgL_trackz00_364;
BgL_trackz00_364 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_361, BgL_tempoz00_362); 
{ /* Llib/midi.scm 227 */
BgL_midireaderz00_bglt BgL_i1137z00_366;
BgL_i1137z00_366 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52readerz52); 
{ 

BgL_zc3z04anonymousza31646ze3z87_368:
{ /* Llib/midi.scm 229 */
obj_t BgL_fun1648z00_369;
BgL_fun1648z00_369 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1137z00_366))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 229 */
obj_t BgL_arg1647z00_370;
BgL_arg1647z00_370 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52streamz52); 
PROCEDURE_ENTRY(BgL_fun1648z00_369)(BgL_fun1648z00_369, BgL_arg1647z00_370, BEOA); } } 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_364, BGl_midiplayerzd2readzd2zz__multimediazd2midizd2, BGl_midisinkzd2nullzd2zz__multimediazd2midizd2, ((long)0), ((long)0), ((long)0), 
LONG_TO_LLONG(((long)0))); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52eotz52))
{ /* Llib/midi.scm 232 */
BgL_t0z00_337 = BgL_trackz00_364; }  else 
{ /* Llib/midi.scm 232 */
goto BgL_zc3z04anonymousza31646ze3z87_368;} } } } 
{ /* Llib/midi.scm 243 */
obj_t BgL_filez00_339;
BgL_filez00_339 = 
INPUT_PORT_NAME(BgL_ipz00_17); 
{ /* Llib/midi.scm 244 */
long BgL_g1139z00_340;
BgL_g1139z00_340 = 
INPUT_PORT_FILEPOS(BgL_ipz00_17); 
{ 
long BgL_iz00_343;long BgL_posz00_344;obj_t BgL_tksz00_345;
BgL_iz00_343 = ((long)1); 
BgL_posz00_344 = BgL_g1139z00_340; 
BgL_tksz00_345 = BNIL; 
BgL_zc3z04anonymousza31616ze3z87_346:
if(
(BgL_iz00_343==
(long)CINT(BgL_tnumz00_19)))
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1619z00_348;
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1624z00_349;
BgL_arg1624z00_349 = 
bgl_reverse_bang(BgL_tksz00_345); 
BgL_arg1619z00_348 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_t0z00_337), BgL_arg1624z00_349); } 
return 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg1619z00_348);}  else 
{ /* Llib/midi.scm 249 */
obj_t BgL_ipz00_350;
{ /* Llib/midi.scm 237 */
obj_t BgL_portz00_1932;
{ /* Llib/midi.scm 237 */

BgL_portz00_1932 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filez00_339, BTRUE, 
BINT(((long)5000000))); } 
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_portz00_1932, BgL_posz00_344); 
BgL_ipz00_350 = BgL_portz00_1932; } 
{ /* Llib/midi.scm 249 */
BgL_miditrackz00_bglt BgL_tz00_351;
BgL_tz00_351 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_350, 
(((BgL_miditrackz00_bglt)COBJECT(BgL_t0z00_337))->BgL_tempoz00)); 
{ /* Llib/midi.scm 250 */

{ /* Llib/midi.scm 252 */
long BgL_arg1626z00_353;long BgL_arg1627z00_354;obj_t BgL_arg1628z00_355;
BgL_arg1626z00_353 = 
(BgL_iz00_343+((long)1)); 
{ /* Llib/midi.scm 253 */
long BgL_arg1631z00_356;long BgL_arg1636z00_357;
{ /* Llib/midi.scm 253 */
obj_t BgL_tmpz00_4544;
BgL_tmpz00_4544 = 
((obj_t)BgL_ipz00_350); 
BgL_arg1631z00_356 = 
INPUT_PORT_FILEPOS(BgL_tmpz00_4544); } 
{ /* Llib/midi.scm 253 */
int32_t BgL_arg1643z00_358;
BgL_arg1643z00_358 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_tz00_351))->BgL_lenz00); 
{ /* Llib/midi.scm 253 */
long BgL_arg1425z00_1939;
BgL_arg1425z00_1939 = 
(long)(BgL_arg1643z00_358); 
BgL_arg1636z00_357 = 
(long)(BgL_arg1425z00_1939); } } 
BgL_arg1627z00_354 = 
(BgL_arg1631z00_356+BgL_arg1636z00_357); } 
BgL_arg1628z00_355 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_351), BgL_tksz00_345); 
{ 
obj_t BgL_tksz00_4555;long BgL_posz00_4554;long BgL_iz00_4553;
BgL_iz00_4553 = BgL_arg1626z00_353; 
BgL_posz00_4554 = BgL_arg1627z00_354; 
BgL_tksz00_4555 = BgL_arg1628z00_355; 
BgL_tksz00_345 = BgL_tksz00_4555; 
BgL_posz00_344 = BgL_posz00_4554; 
BgL_iz00_343 = BgL_iz00_4553; 
goto BgL_zc3z04anonymousza31616ze3z87_346;} } } } } } } } } } } 

}



/* miditrack-file */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_20, long BgL_offsetz00_21, long BgL_tempoz00_22)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
obj_t BgL_zc3z04anonymousza31653ze3z87_2872;
BgL_zc3z04anonymousza31653ze3z87_2872 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31653ze3ze5zz__multimediazd2midizd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31653ze3z87_2872, 
(int)(((long)0)), 
BINT(BgL_offsetz00_21)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31653ze3z87_2872, 
(int)(((long)1)), 
BINT(BgL_tempoz00_22)); 
return 
((BgL_miditrackz00_bglt)
BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(BgL_filenamez00_20, BgL_zc3z04anonymousza31653ze3z87_2872));} } 

}



/* &miditrack-file */
BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2873, obj_t BgL_filenamez00_2874, obj_t BgL_offsetz00_2875, obj_t BgL_tempoz00_2876)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
long BgL_auxz00_4583;long BgL_auxz00_4574;obj_t BgL_auxz00_4567;
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4584;
if(
INTEGERP(BgL_tempoz00_2876))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4584 = BgL_tempoz00_2876
; }  else 
{ 
obj_t BgL_auxz00_4587;
BgL_auxz00_4587 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string2787z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tempoz00_2876); 
FAILURE(BgL_auxz00_4587,BFALSE,BFALSE);} 
BgL_auxz00_4583 = 
(long)CINT(BgL_tmpz00_4584); } 
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4575;
if(
INTEGERP(BgL_offsetz00_2875))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4575 = BgL_offsetz00_2875
; }  else 
{ 
obj_t BgL_auxz00_4578;
BgL_auxz00_4578 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string2787z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_offsetz00_2875); 
FAILURE(BgL_auxz00_4578,BFALSE,BFALSE);} 
BgL_auxz00_4574 = 
(long)CINT(BgL_tmpz00_4575); } 
if(
STRINGP(BgL_filenamez00_2874))
{ /* Llib/midi.scm 262 */
BgL_auxz00_4567 = BgL_filenamez00_2874
; }  else 
{ 
obj_t BgL_auxz00_4570;
BgL_auxz00_4570 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string2787z00zz__multimediazd2midizd2, BGl_string2783z00zz__multimediazd2midizd2, BgL_filenamez00_2874); 
FAILURE(BgL_auxz00_4570,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4567, BgL_auxz00_4574, BgL_auxz00_4583);} } 

}



/* &<@anonymous:1653> */
obj_t BGl_z62zc3z04anonymousza31653ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2877, obj_t BgL_ipz00_2880)
{
{ /* Llib/midi.scm 261 */
{ /* Llib/midi.scm 262 */
long BgL_offsetz00_2878;long BgL_tempoz00_2879;
BgL_offsetz00_2878 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_2877, 
(int)(((long)0)))); 
BgL_tempoz00_2879 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_2877, 
(int)(((long)1)))); 
{ 
BgL_miditrackz00_bglt BgL_auxz00_4599;
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_ipz00_2880, BgL_offsetz00_2878); 
BgL_auxz00_4599 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_2880, BgL_tempoz00_2879); 
return 
((obj_t)BgL_auxz00_4599);} } } 

}



/* miditrack-string */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t BgL_stringz00_23, long BgL_tempoz00_24)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
BgL_miditrackz00_bglt BgL_new1143z00_386;
{ /* Llib/midi.scm 270 */
BgL_miditrackz00_bglt BgL_new1142z00_390;
BgL_new1142z00_390 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 270 */
long BgL_arg1656z00_391;
BgL_arg1656z00_391 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_390), BgL_arg1656z00_391); } 
BgL_new1143z00_386 = BgL_new1142z00_390; } 
{ 
obj_t BgL_auxz00_4607;
{ /* Llib/midi.scm 127 */
obj_t BgL_newz00_1948;
BgL_newz00_1948 = 
create_struct(
CNST_TABLE_REF(((long)4)), 
(int)(((long)2))); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_4613;int BgL_tmpz00_4611;
BgL_auxz00_4613 = 
BINT(((long)0)); 
BgL_tmpz00_4611 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1948, BgL_tmpz00_4611, BgL_auxz00_4613); } 
{ /* Llib/midi.scm 127 */
int BgL_tmpz00_4616;
BgL_tmpz00_4616 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1948, BgL_tmpz00_4616, BgL_stringz00_23); } 
BgL_auxz00_4607 = BgL_newz00_1948; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52streamz52)=((obj_t)BgL_auxz00_4607),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52closez52)=((obj_t)BGl_proc2788z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4625;
{ /* Llib/midi.scm 273 */
long BgL_tmpz00_4626;
BgL_tmpz00_4626 = 
STRING_LENGTH(BgL_stringz00_23); 
BgL_auxz00_4625 = 
(int32_t)(BgL_tmpz00_4626); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_lenz00)=((int32_t)BgL_auxz00_4625),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_tempoz00)=((long)BgL_tempoz00_24),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 269 */
obj_t BgL_fun1655z00_389;
BgL_fun1655z00_389 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1655z00_389)(BgL_fun1655z00_389, 
((obj_t)BgL_new1143z00_386), BEOA); } 
return BgL_new1143z00_386;} } 

}



/* &miditrack-string */
BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2882, obj_t BgL_stringz00_2883, obj_t BgL_tempoz00_2884)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
long BgL_auxz00_4650;obj_t BgL_auxz00_4643;
{ /* Llib/midi.scm 269 */
obj_t BgL_tmpz00_4651;
if(
INTEGERP(BgL_tempoz00_2884))
{ /* Llib/midi.scm 269 */
BgL_tmpz00_4651 = BgL_tempoz00_2884
; }  else 
{ 
obj_t BgL_auxz00_4654;
BgL_auxz00_4654 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string2789z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tempoz00_2884); 
FAILURE(BgL_auxz00_4654,BFALSE,BFALSE);} 
BgL_auxz00_4650 = 
(long)CINT(BgL_tmpz00_4651); } 
if(
STRINGP(BgL_stringz00_2883))
{ /* Llib/midi.scm 269 */
BgL_auxz00_4643 = BgL_stringz00_2883
; }  else 
{ 
obj_t BgL_auxz00_4646;
BgL_auxz00_4646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string2789z00zz__multimediazd2midizd2, BGl_string2783z00zz__multimediazd2midizd2, BgL_stringz00_2883); 
FAILURE(BgL_auxz00_4646,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(BgL_auxz00_4643, BgL_auxz00_4650);} } 

}



/* &<@anonymous:1654> */
obj_t BGl_z62zc3z04anonymousza31654ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_2885, obj_t BgL_sz00_2886)
{
{ /* Llib/midi.scm 272 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-play */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_25, BgL_midiplayerz00_bglt BgL_mplayerz00_26, BgL_midisinkz00_bglt BgL_msinkz00_27)
{
{ /* Llib/midi.scm 279 */
{ 

{ /* Llib/midi.scm 281 */
long BgL_aux1146z00_394;
BgL_aux1146z00_394 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
switch( BgL_aux1146z00_394) { case ((long)0) : 

return 
BBOOL(
BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;case ((long)1) : 

return 
BBOOL(
BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;
default: 
{ /* Llib/midi.scm 284 */
long BgL_arg1661z00_396;
BgL_arg1661z00_396 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
return 
BGl_errorz00zz__errorz00(BGl_string2790z00zz__multimediazd2midizd2, BGl_string2780z00zz__multimediazd2midizd2, 
BINT(BgL_arg1661z00_396));} } } } } 

}



/* &midiscore-play */
obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2887, obj_t BgL_mscorez00_2888, obj_t BgL_mplayerz00_2889, obj_t BgL_msinkz00_2890)
{
{ /* Llib/midi.scm 279 */
{ /* Llib/midi.scm 280 */
BgL_midisinkz00_bglt BgL_auxz00_4686;BgL_midiplayerz00_bglt BgL_auxz00_4678;BgL_midiscorez00_bglt BgL_auxz00_4670;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_2890, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4686 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_2890)
; }  else 
{ 
obj_t BgL_auxz00_4690;
BgL_auxz00_4690 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string2791z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msinkz00_2890); 
FAILURE(BgL_auxz00_4690,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_2889, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4678 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_2889)
; }  else 
{ 
obj_t BgL_auxz00_4682;
BgL_auxz00_4682 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string2791z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mplayerz00_2889); 
FAILURE(BgL_auxz00_4682,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_2888, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4670 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_2888)
; }  else 
{ 
obj_t BgL_auxz00_4674;
BgL_auxz00_4674 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string2791z00zz__multimediazd2midizd2, BGl_string2792z00zz__multimediazd2midizd2, BgL_mscorez00_2888); 
FAILURE(BgL_auxz00_4674,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_auxz00_4670, BgL_auxz00_4678, BgL_auxz00_4686);} } 

}



/* midiscore-play0 */
bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_28, BgL_midiplayerz00_bglt BgL_mplayerz00_29, BgL_midisinkz00_bglt BgL_msinkz00_30)
{
{ /* Llib/midi.scm 289 */
{ /* Llib/midi.scm 291 */
obj_t BgL_trackz00_398;
BgL_trackz00_398 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_tracksz00),((long)0)); 
{ /* Llib/midi.scm 293 */
BgL_midireaderz00_bglt BgL_i1149z00_400;
BgL_i1149z00_400 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52readerz52); 
{ 
uint32_t BgL_tickz00_402;
BgL_tickz00_402 = (uint32_t)(0); 
BgL_zc3z04anonymousza31662ze3z87_403:
{ /* Llib/midi.scm 295 */
BGL_LONGLONG_T BgL_t0z00_404;
BgL_t0z00_404 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 295 */
obj_t BgL_dtz00_405;
{ /* Llib/midi.scm 296 */
obj_t BgL_fun1679z00_410;
BgL_fun1679z00_410 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1149z00_400))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 296 */
obj_t BgL_arg1678z00_411;
BgL_arg1678z00_411 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52streamz52); 
BgL_dtz00_405 = 
PROCEDURE_ENTRY(BgL_fun1679z00_410)(BgL_fun1679z00_410, BgL_arg1678z00_411, BEOA); } } 
{ /* Llib/midi.scm 296 */

{ /* Llib/midi.scm 298 */
long BgL_arg1671z00_406;long BgL_arg1674z00_407;
BgL_arg1671z00_406 = 
(long)(BgL_tickz00_402); 
BgL_arg1674z00_407 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_ppqz00); 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_398), BgL_mplayerz00_29, BgL_msinkz00_30, BgL_arg1671z00_406, BgL_arg1674z00_407, 
(long)CINT(BgL_dtz00_405), BgL_t0z00_404); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52eotz52))
{ /* Llib/midi.scm 299 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 300 */
uint32_t BgL_arg1677z00_409;
BgL_arg1677z00_409 = 
(BgL_tickz00_402+
(uint32_t)(((long)1))); 
{ 
uint32_t BgL_tickz00_4717;
BgL_tickz00_4717 = BgL_arg1677z00_409; 
BgL_tickz00_402 = BgL_tickz00_4717; 
goto BgL_zc3z04anonymousza31662ze3z87_403;} } } } } } } } } 

}



/* midiscore-play1 */
bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_31, BgL_midiplayerz00_bglt BgL_mplayerz00_32, BgL_midisinkz00_bglt BgL_msinkz00_33)
{
{ /* Llib/midi.scm 305 */
{ /* Llib/midi.scm 307 */
obj_t BgL_v1193z00_415;
BgL_v1193z00_415 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
{ /* Llib/midi.scm 307 */

{ 
long BgL_i1192z00_418;
BgL_i1192z00_418 = ((long)0); 
BgL_zc3z04anonymousza31682ze3z87_419:
if(
(BgL_i1192z00_418<
VECTOR_LENGTH(BgL_v1193z00_415)))
{ /* Llib/midi.scm 307 */
{ /* Llib/midi.scm 308 */
obj_t BgL_trackz00_421;
BgL_trackz00_421 = 
VECTOR_REF(BgL_v1193z00_415,BgL_i1192z00_418); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52eotz52))
{ /* Llib/midi.scm 309 */BFALSE; }  else 
{ /* Llib/midi.scm 310 */
BgL_midireaderz00_bglt BgL_i1152z00_424;
BgL_i1152z00_424 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52readerz52); 
{ /* Llib/midi.scm 311 */
obj_t BgL_dtz00_425;
{ /* Llib/midi.scm 311 */
obj_t BgL_fun1697z00_426;
BgL_fun1697z00_426 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1152z00_424))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 311 */
obj_t BgL_arg1696z00_427;
BgL_arg1696z00_427 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52streamz52); 
BgL_dtz00_425 = 
PROCEDURE_ENTRY(BgL_fun1697z00_426)(BgL_fun1697z00_426, BgL_arg1696z00_427, BEOA); } } 
{ 
uint32_t BgL_auxz00_4735;
{ /* Llib/midi.scm 312 */
long BgL_xz00_1961;
BgL_xz00_1961 = 
(long)CINT(BgL_dtz00_425); 
{ /* Llib/midi.scm 312 */
int32_t BgL_tmpz00_4738;
BgL_tmpz00_4738 = 
(int32_t)(BgL_xz00_1961); 
BgL_auxz00_4735 = 
(uint32_t)(BgL_tmpz00_4738); } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_4735),BUNSPEC); } } } } 
{ 
long BgL_i1192z00_4742;
BgL_i1192z00_4742 = 
(BgL_i1192z00_418+((long)1)); 
BgL_i1192z00_418 = BgL_i1192z00_4742; 
goto BgL_zc3z04anonymousza31682ze3z87_419;} }  else 
{ /* Llib/midi.scm 307 */((bool_t)0); } } } } 
{ /* Llib/midi.scm 314 */
long BgL_resz00_430;
{ /* Llib/midi.scm 314 */
BgL_miditrackz00_bglt BgL_i1153z00_459;
{ /* Llib/midi.scm 314 */
obj_t BgL_arg1726z00_462;
BgL_arg1726z00_462 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
BgL_i1153z00_459 = 
((BgL_miditrackz00_bglt)
VECTOR_REF(BgL_arg1726z00_462,((long)0))); } 
BgL_resz00_430 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_i1153z00_459))->BgL_tempoz00)/
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_ppqz00)); } 
{ 
uint32_t BgL_tickz00_432;
BgL_tickz00_432 = (uint32_t)(0); 
BgL_zc3z04anonymousza31699ze3z87_433:
{ /* Llib/midi.scm 317 */
BGL_LONGLONG_T BgL_t0z00_434;
BgL_t0z00_434 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 317 */
bool_t BgL_eosz00_435;
BgL_eosz00_435 = ((bool_t)1); 
{ /* Llib/midi.scm 318 */

{ /* Llib/midi.scm 319 */
long BgL_g1154z00_436;
{ /* Llib/midi.scm 319 */
long BgL_arg1712z00_449;
BgL_arg1712z00_449 = 
VECTOR_LENGTH(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00)); 
BgL_g1154z00_436 = 
(BgL_arg1712z00_449-((long)1)); } 
{ 
long BgL_iz00_438;
BgL_iz00_438 = BgL_g1154z00_436; 
BgL_zc3z04anonymousza31700ze3z87_439:
if(
(BgL_iz00_438>((long)0)))
{ /* Llib/midi.scm 320 */
{ /* Llib/midi.scm 321 */
obj_t BgL_trackz00_441;
BgL_trackz00_441 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00),BgL_iz00_438); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_441)))->BgL_z52eotz52))
{ /* Llib/midi.scm 323 */BFALSE; }  else 
{ /* Llib/midi.scm 323 */
{ /* Llib/midi.scm 325 */
long BgL_arg1703z00_444;
BgL_arg1703z00_444 = 
(long)(BgL_tickz00_432); 
BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_441), BgL_mplayerz00_32, BgL_msinkz00_33, BgL_arg1703z00_444); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_441)))->BgL_z52eotz52))
{ /* Llib/midi.scm 326 */BFALSE; }  else 
{ /* Llib/midi.scm 326 */
BgL_eosz00_435 = ((bool_t)0); } } } 
{ 
long BgL_iz00_4767;
BgL_iz00_4767 = 
(BgL_iz00_438-((long)1)); 
BgL_iz00_438 = BgL_iz00_4767; 
goto BgL_zc3z04anonymousza31700ze3z87_439;} }  else 
{ /* Llib/midi.scm 320 */((bool_t)0); } } } 
if(BgL_eosz00_435)
{ /* Llib/midi.scm 328 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 329 */
long BgL_usz00_451;
{ /* Llib/midi.scm 329 */
BGL_LONGLONG_T BgL_tmpz00_4770;
BgL_tmpz00_4770 = 
(
bgl_current_microseconds()-BgL_t0z00_434); 
BgL_usz00_451 = 
LLONG_TO_LONG(BgL_tmpz00_4770); } 
{ /* Llib/midi.scm 331 */
obj_t BgL_fun1715z00_453;
BgL_fun1715z00_453 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_33))->BgL_usleepz00); 
{ /* Llib/midi.scm 331 */
long BgL_arg1714z00_454;
BgL_arg1714z00_454 = 
(BgL_resz00_430-BgL_usz00_451); 
PROCEDURE_ENTRY(BgL_fun1715z00_453)(BgL_fun1715z00_453, 
BINT(BgL_arg1714z00_454), BEOA); } } 
{ 
uint32_t BgL_tickz00_4781;
BgL_tickz00_4781 = 
(BgL_tickz00_432+(uint32_t)(1)); 
BgL_tickz00_432 = BgL_tickz00_4781; 
goto BgL_zc3z04anonymousza31699ze3z87_433;} } } } } } } } 

}



/* miditrack-wait-event */
obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_34, BgL_midiplayerz00_bglt BgL_mplayerz00_35, BgL_midisinkz00_bglt BgL_msinkz00_36, long BgL_tickz00_37)
{
{ /* Llib/midi.scm 337 */
{ /* Llib/midi.scm 340 */
BgL_midireaderz00_bglt BgL_i1158z00_464;
BgL_i1158z00_464 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52readerz52); 
{ /* Llib/midi.scm 341 */
bool_t BgL_test3360z00_4784;
{ /* Llib/midi.scm 341 */
uint32_t BgL_n2z00_1981;
BgL_n2z00_1981 = 
(uint32_t)(BgL_tickz00_37); 
BgL_test3360z00_4784 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)<=BgL_n2z00_1981); } 
if(BgL_test3360z00_4784)
{ 

BgL_zc3z04anonymousza31729ze3z87_468:
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_34, BgL_mplayerz00_35, BgL_msinkz00_36, BgL_tickz00_37, ((long)0), ((long)0), ((BGL_LONGLONG_T)0)); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52eotz52))
{ /* Llib/midi.scm 344 */
return BFALSE;}  else 
{ /* Llib/midi.scm 345 */
obj_t BgL_dtz00_470;
{ /* Llib/midi.scm 345 */
obj_t BgL_fun1738z00_473;
BgL_fun1738z00_473 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1158z00_464))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 345 */
obj_t BgL_arg1737z00_474;
BgL_arg1737z00_474 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52streamz52); 
BgL_dtz00_470 = 
PROCEDURE_ENTRY(BgL_fun1738z00_473)(BgL_fun1738z00_473, BgL_arg1737z00_474, BEOA); } } 
if(
(
(long)CINT(BgL_dtz00_470)==((long)0)))
{ /* Llib/midi.scm 346 */
goto BgL_zc3z04anonymousza31729ze3z87_468;}  else 
{ 
uint32_t BgL_auxz00_4800;
{ /* Llib/midi.scm 348 */
int32_t BgL_arg1734z00_472;
{ /* Llib/midi.scm 348 */
long BgL_xz00_1983;
BgL_xz00_1983 = 
(long)CINT(BgL_dtz00_470); 
BgL_arg1734z00_472 = 
(int32_t)(BgL_xz00_1983); } 
{ /* Llib/midi.scm 348 */
uint32_t BgL_za71za7_1984;uint32_t BgL_za72za7_1985;
BgL_za71za7_1984 = 
(uint32_t)(BgL_tickz00_37); 
BgL_za72za7_1985 = 
(uint32_t)(BgL_arg1734z00_472); 
BgL_auxz00_4800 = 
(BgL_za71za7_1984+BgL_za72za7_1985); } } 
return 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_4800),BUNSPEC);} } }  else 
{ /* Llib/midi.scm 341 */
return BFALSE;} } } } 

}



/* miditrack-play-event */
obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_38, BgL_midiplayerz00_bglt BgL_mplayerz00_39, BgL_midisinkz00_bglt BgL_msinkz00_40, long BgL_tickz00_41, long BgL_ppqz00_42, long BgL_dtz00_43, BGL_LONGLONG_T BgL_t0z00_44)
{
{ /* Llib/midi.scm 353 */
{ /* Llib/midi.scm 357 */
BgL_midireaderz00_bglt BgL_i1160z00_478;
BgL_i1160z00_478 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52readerz52); 
{ /* Llib/midi.scm 372 */
obj_t BgL_statusz00_480;
{ /* Llib/midi.scm 372 */
bool_t BgL_test3363z00_4808;
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1974z00_714;
{ /* Llib/midi.scm 372 */
obj_t BgL_fun1976z00_715;
BgL_fun1976z00_715 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_peekzd2bytezd2); 
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1975z00_716;
BgL_arg1975z00_716 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1974z00_714 = 
PROCEDURE_ENTRY(BgL_fun1976z00_715)(BgL_fun1976z00_715, BgL_arg1975z00_716, BEOA); } } 
BgL_test3363z00_4808 = 
(
(long)CINT(BgL_arg1974z00_714)<((long)128)); } 
if(BgL_test3363z00_4808)
{ /* Llib/midi.scm 372 */
BgL_statusz00_480 = 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)); }  else 
{ /* Llib/midi.scm 374 */
obj_t BgL_sz00_711;
{ /* Llib/midi.scm 374 */
obj_t BgL_fun1973z00_712;
BgL_fun1973z00_712 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 374 */
obj_t BgL_arg1972z00_713;
BgL_arg1972z00_713 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sz00_711 = 
PROCEDURE_ENTRY(BgL_fun1973z00_712)(BgL_fun1973z00_712, BgL_arg1972z00_713, BEOA); } } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)=((long)
(long)CINT(BgL_sz00_711)),BUNSPEC); 
BgL_statusz00_480 = BgL_sz00_711; } } 
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)8)))
{ /* Llib/midi.scm 380 */
long BgL_kkz00_483;
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1778z00_494;
{ /* Llib/midi.scm 380 */
obj_t BgL_fun1780z00_495;
BgL_fun1780z00_495 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1779z00_496;
BgL_arg1779z00_496 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1778z00_494 = 
PROCEDURE_ENTRY(BgL_fun1780z00_495)(BgL_fun1780z00_495, BgL_arg1779z00_496, BEOA); } } 
BgL_kkz00_483 = 
(((long)127) & 
(long)CINT(BgL_arg1778z00_494)); } 
{ /* Llib/midi.scm 380 */
long BgL_vvz00_484;
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1775z00_491;
{ /* Llib/midi.scm 381 */
obj_t BgL_fun1777z00_492;
BgL_fun1777z00_492 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1776z00_493;
BgL_arg1776z00_493 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1775z00_491 = 
PROCEDURE_ENTRY(BgL_fun1777z00_492)(BgL_fun1777z00_492, BgL_arg1776z00_493, BEOA); } } 
BgL_vvz00_484 = 
(((long)127) & 
(long)CINT(BgL_arg1775z00_491)); } 
{ /* Llib/midi.scm 381 */

{ /* Llib/midi.scm 382 */
obj_t BgL_fun1761z00_485;
BgL_fun1761z00_485 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 383 */
long BgL_arg1760z00_486;
{ /* Llib/midi.scm 383 */
BGL_LONGLONG_T BgL_tmpz00_4849;
BgL_tmpz00_4849 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1760z00_486 = 
LLONG_TO_LONG(BgL_tmpz00_4849); } 
PROCEDURE_ENTRY(BgL_fun1761z00_485)(BgL_fun1761z00_485, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1760z00_486), BEOA); } } 
{ /* Llib/midi.scm 384 */
obj_t BgL_fun1774z00_489;
BgL_fun1774z00_489 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteoffz00); 
{ /* Llib/midi.scm 384 */
long BgL_arg1773z00_490;
BgL_arg1773z00_490 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1774z00_489)(BgL_fun1774z00_489, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1773z00_490), 
BINT(BgL_kkz00_483), 
BINT(BgL_vvz00_484), BEOA); } } } } }  else 
{ /* Llib/midi.scm 378 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)9)))
{ /* Llib/midi.scm 387 */
long BgL_kkz00_499;
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1792z00_510;
{ /* Llib/midi.scm 387 */
obj_t BgL_fun1794z00_511;
BgL_fun1794z00_511 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1793z00_512;
BgL_arg1793z00_512 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1792z00_510 = 
PROCEDURE_ENTRY(BgL_fun1794z00_511)(BgL_fun1794z00_511, BgL_arg1793z00_512, BEOA); } } 
BgL_kkz00_499 = 
(((long)127) & 
(long)CINT(BgL_arg1792z00_510)); } 
{ /* Llib/midi.scm 387 */
long BgL_vvz00_500;
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1789z00_507;
{ /* Llib/midi.scm 388 */
obj_t BgL_fun1791z00_508;
BgL_fun1791z00_508 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1790z00_509;
BgL_arg1790z00_509 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1789z00_507 = 
PROCEDURE_ENTRY(BgL_fun1791z00_508)(BgL_fun1791z00_508, BgL_arg1790z00_509, BEOA); } } 
BgL_vvz00_500 = 
(((long)127) & 
(long)CINT(BgL_arg1789z00_507)); } 
{ /* Llib/midi.scm 388 */

{ /* Llib/midi.scm 389 */
obj_t BgL_fun1784z00_501;
BgL_fun1784z00_501 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 390 */
long BgL_arg1783z00_502;
{ /* Llib/midi.scm 390 */
BGL_LONGLONG_T BgL_tmpz00_4910;
BgL_tmpz00_4910 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1783z00_502 = 
LLONG_TO_LONG(BgL_tmpz00_4910); } 
PROCEDURE_ENTRY(BgL_fun1784z00_501)(BgL_fun1784z00_501, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1783z00_502), BEOA); } } 
{ /* Llib/midi.scm 391 */
obj_t BgL_fun1788z00_505;
BgL_fun1788z00_505 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteonz00); 
{ /* Llib/midi.scm 391 */
long BgL_arg1787z00_506;
BgL_arg1787z00_506 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1788z00_505)(BgL_fun1788z00_505, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1787z00_506), 
BINT(BgL_kkz00_499), 
BINT(BgL_vvz00_500), BEOA); } } } } }  else 
{ /* Llib/midi.scm 385 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)10)))
{ /* Llib/midi.scm 394 */
long BgL_ccz00_515;
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1806z00_526;
{ /* Llib/midi.scm 394 */
obj_t BgL_fun1808z00_527;
BgL_fun1808z00_527 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1807z00_528;
BgL_arg1807z00_528 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1806z00_526 = 
PROCEDURE_ENTRY(BgL_fun1808z00_527)(BgL_fun1808z00_527, BgL_arg1807z00_528, BEOA); } } 
BgL_ccz00_515 = 
(((long)127) & 
(long)CINT(BgL_arg1806z00_526)); } 
{ /* Llib/midi.scm 394 */
long BgL_vvz00_516;
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1803z00_523;
{ /* Llib/midi.scm 395 */
obj_t BgL_fun1805z00_524;
BgL_fun1805z00_524 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1804z00_525;
BgL_arg1804z00_525 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1803z00_523 = 
PROCEDURE_ENTRY(BgL_fun1805z00_524)(BgL_fun1805z00_524, BgL_arg1804z00_525, BEOA); } } 
BgL_vvz00_516 = 
(((long)127) & 
(long)CINT(BgL_arg1803z00_523)); } 
{ /* Llib/midi.scm 395 */

{ /* Llib/midi.scm 396 */
obj_t BgL_fun1798z00_517;
BgL_fun1798z00_517 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 397 */
long BgL_arg1797z00_518;
{ /* Llib/midi.scm 397 */
BGL_LONGLONG_T BgL_tmpz00_4971;
BgL_tmpz00_4971 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1797z00_518 = 
LLONG_TO_LONG(BgL_tmpz00_4971); } 
PROCEDURE_ENTRY(BgL_fun1798z00_517)(BgL_fun1798z00_517, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1797z00_518), BEOA); } } 
{ /* Llib/midi.scm 398 */
obj_t BgL_fun1802z00_521;
BgL_fun1802z00_521 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_aftertouchz00); 
{ /* Llib/midi.scm 398 */
long BgL_arg1801z00_522;
BgL_arg1801z00_522 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1802z00_521)(BgL_fun1802z00_521, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1801z00_522), 
BINT(BgL_ccz00_515), 
BINT(BgL_vvz00_516), BEOA); } } } } }  else 
{ /* Llib/midi.scm 392 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)11)))
{ /* Llib/midi.scm 401 */
long BgL_ccz00_531;
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1820z00_542;
{ /* Llib/midi.scm 401 */
obj_t BgL_fun1822z00_543;
BgL_fun1822z00_543 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1821z00_544;
BgL_arg1821z00_544 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1820z00_542 = 
PROCEDURE_ENTRY(BgL_fun1822z00_543)(BgL_fun1822z00_543, BgL_arg1821z00_544, BEOA); } } 
BgL_ccz00_531 = 
(((long)127) & 
(long)CINT(BgL_arg1820z00_542)); } 
{ /* Llib/midi.scm 401 */
long BgL_nnz00_532;
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1817z00_539;
{ /* Llib/midi.scm 402 */
obj_t BgL_fun1819z00_540;
BgL_fun1819z00_540 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1818z00_541;
BgL_arg1818z00_541 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1817z00_539 = 
PROCEDURE_ENTRY(BgL_fun1819z00_540)(BgL_fun1819z00_540, BgL_arg1818z00_541, BEOA); } } 
BgL_nnz00_532 = 
(((long)127) & 
(long)CINT(BgL_arg1817z00_539)); } 
{ /* Llib/midi.scm 402 */

{ /* Llib/midi.scm 403 */
obj_t BgL_fun1812z00_533;
BgL_fun1812z00_533 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 404 */
long BgL_arg1811z00_534;
{ /* Llib/midi.scm 404 */
BGL_LONGLONG_T BgL_tmpz00_5032;
BgL_tmpz00_5032 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1811z00_534 = 
LLONG_TO_LONG(BgL_tmpz00_5032); } 
PROCEDURE_ENTRY(BgL_fun1812z00_533)(BgL_fun1812z00_533, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1811z00_534), BEOA); } } 
{ /* Llib/midi.scm 405 */
obj_t BgL_fun1816z00_537;
BgL_fun1816z00_537 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_ctrlchangez00); 
{ /* Llib/midi.scm 405 */
long BgL_arg1815z00_538;
BgL_arg1815z00_538 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1816z00_537)(BgL_fun1816z00_537, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1815z00_538), 
BINT(BgL_ccz00_531), 
BINT(BgL_nnz00_532), BEOA); } } } } }  else 
{ /* Llib/midi.scm 399 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)12)))
{ /* Llib/midi.scm 408 */
long BgL_ppz00_547;
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1831z00_554;
{ /* Llib/midi.scm 408 */
obj_t BgL_fun1833z00_555;
BgL_fun1833z00_555 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1832z00_556;
BgL_arg1832z00_556 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1831z00_554 = 
PROCEDURE_ENTRY(BgL_fun1833z00_555)(BgL_fun1833z00_555, BgL_arg1832z00_556, BEOA); } } 
BgL_ppz00_547 = 
(((long)127) & 
(long)CINT(BgL_arg1831z00_554)); } 
{ /* Llib/midi.scm 409 */
obj_t BgL_fun1826z00_548;
BgL_fun1826z00_548 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 410 */
long BgL_arg1825z00_549;
{ /* Llib/midi.scm 410 */
BGL_LONGLONG_T BgL_tmpz00_5085;
BgL_tmpz00_5085 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1825z00_549 = 
LLONG_TO_LONG(BgL_tmpz00_5085); } 
PROCEDURE_ENTRY(BgL_fun1826z00_548)(BgL_fun1826z00_548, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1825z00_549), BEOA); } } 
{ /* Llib/midi.scm 411 */
obj_t BgL_fun1830z00_552;
BgL_fun1830z00_552 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_prgmchangez00); 
{ /* Llib/midi.scm 411 */
long BgL_arg1829z00_553;
BgL_arg1829z00_553 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1830z00_552)(BgL_fun1830z00_552, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1829z00_553), 
BINT(BgL_ppz00_547), BEOA); } } }  else 
{ /* Llib/midi.scm 406 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)13)))
{ /* Llib/midi.scm 414 */
long BgL_ppz00_559;
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1842z00_566;
{ /* Llib/midi.scm 414 */
obj_t BgL_fun1844z00_567;
BgL_fun1844z00_567 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1843z00_568;
BgL_arg1843z00_568 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1842z00_566 = 
PROCEDURE_ENTRY(BgL_fun1844z00_567)(BgL_fun1844z00_567, BgL_arg1843z00_568, BEOA); } } 
BgL_ppz00_559 = 
(((long)127) & 
(long)CINT(BgL_arg1842z00_566)); } 
{ /* Llib/midi.scm 415 */
obj_t BgL_fun1837z00_560;
BgL_fun1837z00_560 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 416 */
long BgL_arg1836z00_561;
{ /* Llib/midi.scm 416 */
BGL_LONGLONG_T BgL_tmpz00_5136;
BgL_tmpz00_5136 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1836z00_561 = 
LLONG_TO_LONG(BgL_tmpz00_5136); } 
PROCEDURE_ENTRY(BgL_fun1837z00_560)(BgL_fun1837z00_560, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1836z00_561), BEOA); } } 
{ /* Llib/midi.scm 417 */
obj_t BgL_fun1841z00_564;
BgL_fun1841z00_564 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_afterzd2touchzd2); 
{ /* Llib/midi.scm 417 */
long BgL_arg1840z00_565;
BgL_arg1840z00_565 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1841z00_564)(BgL_fun1841z00_564, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1840z00_565), 
BINT(BgL_ppz00_559), BEOA); } } }  else 
{ /* Llib/midi.scm 412 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)14)))
{ /* Llib/midi.scm 420 */
long BgL_ccz00_571;
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1856z00_582;
{ /* Llib/midi.scm 420 */
obj_t BgL_fun1859z00_583;
BgL_fun1859z00_583 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1858z00_584;
BgL_arg1858z00_584 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1856z00_582 = 
PROCEDURE_ENTRY(BgL_fun1859z00_583)(BgL_fun1859z00_583, BgL_arg1858z00_584, BEOA); } } 
BgL_ccz00_571 = 
(((long)127) & 
(long)CINT(BgL_arg1856z00_582)); } 
{ /* Llib/midi.scm 420 */
long BgL_vvz00_572;
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1853z00_579;
{ /* Llib/midi.scm 421 */
obj_t BgL_fun1855z00_580;
BgL_fun1855z00_580 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1854z00_581;
BgL_arg1854z00_581 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1853z00_579 = 
PROCEDURE_ENTRY(BgL_fun1855z00_580)(BgL_fun1855z00_580, BgL_arg1854z00_581, BEOA); } } 
BgL_vvz00_572 = 
(((long)127) & 
(long)CINT(BgL_arg1853z00_579)); } 
{ /* Llib/midi.scm 421 */

{ /* Llib/midi.scm 422 */
obj_t BgL_fun1848z00_573;
BgL_fun1848z00_573 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 423 */
long BgL_arg1847z00_574;
{ /* Llib/midi.scm 423 */
BGL_LONGLONG_T BgL_tmpz00_5195;
BgL_tmpz00_5195 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1847z00_574 = 
LLONG_TO_LONG(BgL_tmpz00_5195); } 
PROCEDURE_ENTRY(BgL_fun1848z00_573)(BgL_fun1848z00_573, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1847z00_574), BEOA); } } 
{ /* Llib/midi.scm 424 */
obj_t BgL_fun1852z00_577;
BgL_fun1852z00_577 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_pitchz00); 
{ /* Llib/midi.scm 424 */
long BgL_arg1851z00_578;
BgL_arg1851z00_578 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1852z00_577)(BgL_fun1852z00_577, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1851z00_578), 
BINT(BgL_ccz00_571), 
BINT(BgL_vvz00_572), BEOA); } } } } }  else 
{ /* Llib/midi.scm 418 */
if(
(
(long)CINT(BgL_statusz00_480)==((long)255)))
{ /* Llib/midi.scm 427 */
obj_t BgL_cz00_586;
{ /* Llib/midi.scm 427 */
obj_t BgL_fun1947z00_683;
BgL_fun1947z00_683 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 427 */
obj_t BgL_arg1946z00_684;
BgL_arg1946z00_684 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_cz00_586 = 
PROCEDURE_ENTRY(BgL_fun1947z00_683)(BgL_fun1947z00_683, BgL_arg1946z00_684, BEOA); } } 
{ /* Llib/midi.scm 427 */
obj_t BgL_lz00_587;
{ /* Llib/midi.scm 428 */
obj_t BgL_fun1945z00_681;
BgL_fun1945z00_681 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 428 */
obj_t BgL_arg1944z00_682;
BgL_arg1944z00_682 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_lz00_587 = 
PROCEDURE_ENTRY(BgL_fun1945z00_681)(BgL_fun1945z00_681, BgL_arg1944z00_682, BEOA); } } 
{ /* Llib/midi.scm 428 */

{ 

if(
INTEGERP(BgL_cz00_586))
{ /* Llib/midi.scm 429 */
switch( 
(long)CINT(BgL_cz00_586)) { case ((long)0) : 

{ /* Llib/midi.scm 432 */
obj_t BgL_fun1863z00_591;
BgL_fun1863z00_591 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqnumzd2); 
{ /* Llib/midi.scm 432 */
int32_t BgL_arg1862z00_592;
BgL_arg1862z00_592 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1863z00_591)(BgL_fun1863z00_591, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BGL_INT32_TO_BINT32(BgL_arg1862z00_592), BEOA); } } break;case ((long)1) : 

{ /* Llib/midi.scm 435 */
obj_t BgL_fun1866z00_594;
BgL_fun1866z00_594 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2textzd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1865z00_595;
{ /* Llib/midi.scm 435 */
obj_t BgL_fun1868z00_596;
BgL_fun1868z00_596 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1867z00_597;
BgL_arg1867z00_597 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1865z00_595 = 
PROCEDURE_ENTRY(BgL_fun1868z00_596)(BgL_fun1868z00_596, BgL_lz00_587, BgL_arg1867z00_597, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1866z00_594)(BgL_fun1866z00_594, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1865z00_595, BEOA); } } break;case ((long)2) : 

{ /* Llib/midi.scm 438 */
obj_t BgL_fun1870z00_598;
BgL_fun1870z00_598 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2copyrightzd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1869z00_599;
{ /* Llib/midi.scm 438 */
obj_t BgL_fun1872z00_600;
BgL_fun1872z00_600 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1871z00_601;
BgL_arg1871z00_601 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1869z00_599 = 
PROCEDURE_ENTRY(BgL_fun1872z00_600)(BgL_fun1872z00_600, BgL_lz00_587, BgL_arg1871z00_601, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1870z00_598)(BgL_fun1870z00_598, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1869z00_599, BEOA); } } break;case ((long)3) : 

{ /* Llib/midi.scm 441 */
obj_t BgL_fun1874z00_602;
BgL_fun1874z00_602 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2trackzd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1873z00_603;
{ /* Llib/midi.scm 441 */
obj_t BgL_fun1876z00_604;
BgL_fun1876z00_604 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1875z00_605;
BgL_arg1875z00_605 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1873z00_603 = 
PROCEDURE_ENTRY(BgL_fun1876z00_604)(BgL_fun1876z00_604, BgL_lz00_587, BgL_arg1875z00_605, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1874z00_602)(BgL_fun1874z00_602, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1873z00_603, BEOA); } } break;case ((long)4) : 

{ /* Llib/midi.scm 444 */
obj_t BgL_fun1878z00_606;
BgL_fun1878z00_606 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2instrumentzd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1877z00_607;
{ /* Llib/midi.scm 444 */
obj_t BgL_fun1880z00_608;
BgL_fun1880z00_608 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1879z00_609;
BgL_arg1879z00_609 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1877z00_607 = 
PROCEDURE_ENTRY(BgL_fun1880z00_608)(BgL_fun1880z00_608, BgL_lz00_587, BgL_arg1879z00_609, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1878z00_606)(BgL_fun1878z00_606, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1877z00_607, BEOA); } } break;case ((long)5) : 

{ /* Llib/midi.scm 447 */
obj_t BgL_fun1882z00_610;
BgL_fun1882z00_610 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2lyriczd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1881z00_611;
{ /* Llib/midi.scm 447 */
obj_t BgL_fun1884z00_612;
BgL_fun1884z00_612 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1883z00_613;
BgL_arg1883z00_613 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1881z00_611 = 
PROCEDURE_ENTRY(BgL_fun1884z00_612)(BgL_fun1884z00_612, BgL_lz00_587, BgL_arg1883z00_613, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1882z00_610)(BgL_fun1882z00_610, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1881z00_611, BEOA); } } break;case ((long)6) : 

{ /* Llib/midi.scm 450 */
obj_t BgL_fun1886z00_614;
BgL_fun1886z00_614 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2markerzd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1885z00_615;
{ /* Llib/midi.scm 450 */
obj_t BgL_fun1888z00_616;
BgL_fun1888z00_616 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1887z00_617;
BgL_arg1887z00_617 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1885z00_615 = 
PROCEDURE_ENTRY(BgL_fun1888z00_616)(BgL_fun1888z00_616, BgL_lz00_587, BgL_arg1887z00_617, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1886z00_614)(BgL_fun1886z00_614, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1885z00_615, BEOA); } } break;case ((long)7) : 

{ /* Llib/midi.scm 453 */
obj_t BgL_fun1890z00_618;
BgL_fun1890z00_618 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2cuezd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1889z00_619;
{ /* Llib/midi.scm 453 */
obj_t BgL_fun1892z00_620;
BgL_fun1892z00_620 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1891z00_621;
BgL_arg1891z00_621 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1889z00_619 = 
PROCEDURE_ENTRY(BgL_fun1892z00_620)(BgL_fun1892z00_620, BgL_lz00_587, BgL_arg1891z00_621, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1890z00_618)(BgL_fun1890z00_618, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1889z00_619, BEOA); } } break;case ((long)8) : 

{ /* Llib/midi.scm 456 */
obj_t BgL_fun1894z00_622;
BgL_fun1894z00_622 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2prgmnamezd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1893z00_623;
{ /* Llib/midi.scm 456 */
obj_t BgL_fun1896z00_624;
BgL_fun1896z00_624 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1895z00_625;
BgL_arg1895z00_625 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1893z00_623 = 
PROCEDURE_ENTRY(BgL_fun1896z00_624)(BgL_fun1896z00_624, BgL_lz00_587, BgL_arg1895z00_625, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1894z00_622)(BgL_fun1894z00_622, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1893z00_623, BEOA); } } break;case ((long)9) : 

{ /* Llib/midi.scm 459 */
obj_t BgL_fun1898z00_626;
BgL_fun1898z00_626 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2devnamezd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1897z00_627;
{ /* Llib/midi.scm 459 */
obj_t BgL_fun1900z00_628;
BgL_fun1900z00_628 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1899z00_629;
BgL_arg1899z00_629 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1897z00_627 = 
PROCEDURE_ENTRY(BgL_fun1900z00_628)(BgL_fun1900z00_628, BgL_lz00_587, BgL_arg1899z00_629, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1898z00_626)(BgL_fun1898z00_626, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1897z00_627, BEOA); } } break;case ((long)32) : 

{ /* Llib/midi.scm 462 */
obj_t BgL_fun1903z00_630;
BgL_fun1903z00_630 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1902z00_631;
{ /* Llib/midi.scm 462 */
obj_t BgL_fun1905z00_632;
BgL_fun1905z00_632 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1904z00_633;
BgL_arg1904z00_633 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1902z00_631 = 
PROCEDURE_ENTRY(BgL_fun1905z00_632)(BgL_fun1905z00_632, BgL_arg1904z00_633, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1903z00_630)(BgL_fun1903z00_630, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1902z00_631, BEOA); } } break;case ((long)33) : 

{ /* Llib/midi.scm 465 */
obj_t BgL_fun1907z00_634;
BgL_fun1907z00_634 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 465 */
long BgL_arg1906z00_635;
BgL_arg1906z00_635 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1907z00_634)(BgL_fun1907z00_634, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1906z00_635), BEOA); } } break;case ((long)47) : 

((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52eotz52)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/midi.scm 469 */
obj_t BgL_fun1909z00_637;
BgL_fun1909z00_637 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2eotzd2); 
PROCEDURE_ENTRY(BgL_fun1909z00_637)(BgL_fun1909z00_637, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BUNSPEC, BEOA); } break;case ((long)81) : 

{ 
long BgL_auxz00_5471;
{ /* Llib/midi.scm 472 */
obj_t BgL_arg1910z00_638;
BgL_arg1910z00_638 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_auxz00_5471 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), BgL_arg1910z00_638); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00)=((long)BgL_auxz00_5471),BUNSPEC); } 
{ /* Llib/midi.scm 473 */
obj_t BgL_fun1912z00_639;
BgL_fun1912z00_639 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2tempozd2); 
{ /* Llib/midi.scm 473 */
long BgL_arg1911z00_640;
BgL_arg1911z00_640 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00); 
PROCEDURE_ENTRY(BgL_fun1912z00_639)(BgL_fun1912z00_639, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1911z00_640), BEOA); } } break;case ((long)84) : 

{ /* Llib/midi.scm 476 */
obj_t BgL_hrz00_641;
{ /* Llib/midi.scm 476 */
obj_t BgL_fun1923z00_655;
BgL_fun1923z00_655 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 476 */
obj_t BgL_arg1922z00_656;
BgL_arg1922z00_656 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_hrz00_641 = 
PROCEDURE_ENTRY(BgL_fun1923z00_655)(BgL_fun1923z00_655, BgL_arg1922z00_656, BEOA); } } 
{ /* Llib/midi.scm 476 */
obj_t BgL_mmz00_642;
{ /* Llib/midi.scm 477 */
obj_t BgL_fun1921z00_653;
BgL_fun1921z00_653 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 477 */
obj_t BgL_arg1920z00_654;
BgL_arg1920z00_654 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_mmz00_642 = 
PROCEDURE_ENTRY(BgL_fun1921z00_653)(BgL_fun1921z00_653, BgL_arg1920z00_654, BEOA); } } 
{ /* Llib/midi.scm 477 */
obj_t BgL_sez00_643;
{ /* Llib/midi.scm 478 */
obj_t BgL_fun1919z00_651;
BgL_fun1919z00_651 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 478 */
obj_t BgL_arg1918z00_652;
BgL_arg1918z00_652 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sez00_643 = 
PROCEDURE_ENTRY(BgL_fun1919z00_651)(BgL_fun1919z00_651, BgL_arg1918z00_652, BEOA); } } 
{ /* Llib/midi.scm 478 */
obj_t BgL_frz00_644;
{ /* Llib/midi.scm 479 */
obj_t BgL_fun1917z00_649;
BgL_fun1917z00_649 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 479 */
obj_t BgL_arg1916z00_650;
BgL_arg1916z00_650 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_frz00_644 = 
PROCEDURE_ENTRY(BgL_fun1917z00_649)(BgL_fun1917z00_649, BgL_arg1916z00_650, BEOA); } } 
{ /* Llib/midi.scm 479 */
obj_t BgL_ffz00_645;
{ /* Llib/midi.scm 480 */
obj_t BgL_fun1915z00_647;
BgL_fun1915z00_647 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 480 */
obj_t BgL_arg1914z00_648;
BgL_arg1914z00_648 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ffz00_645 = 
PROCEDURE_ENTRY(BgL_fun1915z00_647)(BgL_fun1915z00_647, BgL_arg1914z00_648, BEOA); } } 
{ /* Llib/midi.scm 480 */

{ /* Llib/midi.scm 481 */
obj_t BgL_fun1913z00_646;
BgL_fun1913z00_646 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2smtpezd2); 
PROCEDURE_ENTRY(BgL_fun1913z00_646)(BgL_fun1913z00_646, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_hrz00_641, BgL_mmz00_642, BgL_sez00_643, BgL_frz00_644, BgL_ffz00_645, BEOA); } } } } } } } break;case ((long)88) : 

{ /* Llib/midi.scm 484 */
obj_t BgL_nnz00_657;
{ /* Llib/midi.scm 484 */
obj_t BgL_fun1932z00_668;
BgL_fun1932z00_668 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 484 */
obj_t BgL_arg1931z00_669;
BgL_arg1931z00_669 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_nnz00_657 = 
PROCEDURE_ENTRY(BgL_fun1932z00_668)(BgL_fun1932z00_668, BgL_arg1931z00_669, BEOA); } } 
{ /* Llib/midi.scm 484 */
obj_t BgL_ddz00_658;
{ /* Llib/midi.scm 485 */
obj_t BgL_fun1930z00_666;
BgL_fun1930z00_666 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 485 */
obj_t BgL_arg1929z00_667;
BgL_arg1929z00_667 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ddz00_658 = 
PROCEDURE_ENTRY(BgL_fun1930z00_666)(BgL_fun1930z00_666, BgL_arg1929z00_667, BEOA); } } 
{ /* Llib/midi.scm 485 */
obj_t BgL_ccz00_659;
{ /* Llib/midi.scm 486 */
obj_t BgL_fun1928z00_664;
BgL_fun1928z00_664 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 486 */
obj_t BgL_arg1927z00_665;
BgL_arg1927z00_665 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ccz00_659 = 
PROCEDURE_ENTRY(BgL_fun1928z00_664)(BgL_fun1928z00_664, BgL_arg1927z00_665, BEOA); } } 
{ /* Llib/midi.scm 486 */
obj_t BgL_bbz00_660;
{ /* Llib/midi.scm 487 */
obj_t BgL_fun1926z00_662;
BgL_fun1926z00_662 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 487 */
obj_t BgL_arg1925z00_663;
BgL_arg1925z00_663 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_bbz00_660 = 
PROCEDURE_ENTRY(BgL_fun1926z00_662)(BgL_fun1926z00_662, BgL_arg1925z00_663, BEOA); } } 
{ /* Llib/midi.scm 487 */

{ /* Llib/midi.scm 488 */
obj_t BgL_fun1924z00_661;
BgL_fun1924z00_661 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2timesigzd2); 
PROCEDURE_ENTRY(BgL_fun1924z00_661)(BgL_fun1924z00_661, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_nnz00_657, BgL_ddz00_658, BgL_ccz00_659, BgL_bbz00_660, BEOA); } } } } } } break;case ((long)89) : 

{ /* Llib/midi.scm 491 */
obj_t BgL_fun1934z00_670;
BgL_fun1934z00_670 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2keysigzd2); 
{ /* Llib/midi.scm 491 */
long BgL_arg1933z00_671;
BgL_arg1933z00_671 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1934z00_670)(BgL_fun1934z00_670, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1933z00_671), BEOA); } } break;case ((long)127) : 

{ /* Llib/midi.scm 494 */
obj_t BgL_fun1937z00_673;
BgL_fun1937z00_673 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqspeczd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1936z00_674;
{ /* Llib/midi.scm 494 */
obj_t BgL_fun1939z00_675;
BgL_fun1939z00_675 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1938z00_676;
BgL_arg1938z00_676 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1936z00_674 = 
PROCEDURE_ENTRY(BgL_fun1939z00_675)(BgL_fun1939z00_675, BgL_lz00_587, BgL_arg1938z00_676, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1937z00_673)(BgL_fun1937z00_673, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1936z00_674, BEOA); } } break;
default: 
BgL_case_else1162z00_588:
{ /* Llib/midi.scm 496 */
obj_t BgL_fun1941z00_677;
BgL_fun1941z00_677 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1940z00_678;
{ /* Llib/midi.scm 497 */
obj_t BgL_list1942z00_679;
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1943z00_680;
BgL_arg1943z00_680 = 
MAKE_YOUNG_PAIR(BgL_cz00_586, BNIL); 
BgL_list1942z00_679 = 
MAKE_YOUNG_PAIR(BgL_statusz00_480, BgL_arg1943z00_680); } 
BgL_arg1940z00_678 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2795z00zz__multimediazd2midizd2, BgL_list1942z00_679); } 
PROCEDURE_ENTRY(BgL_fun1941z00_677)(BgL_fun1941z00_677, BGl_string2796z00zz__multimediazd2midizd2, BGl_string2797z00zz__multimediazd2midizd2, BgL_arg1940z00_678, BEOA); } } } }  else 
{ /* Llib/midi.scm 429 */
goto BgL_case_else1162z00_588;} } } } }  else 
{ /* Llib/midi.scm 498 */
bool_t BgL_test3373z00_5617;
if(
(
(long)CINT(BgL_statusz00_480)==((long)240)))
{ /* Llib/midi.scm 498 */
BgL_test3373z00_5617 = ((bool_t)1)
; }  else 
{ /* Llib/midi.scm 498 */
BgL_test3373z00_5617 = 
(
(long)CINT(BgL_statusz00_480)==((long)247))
; } 
if(BgL_test3373z00_5617)
{ /* Llib/midi.scm 500 */
obj_t BgL_strz00_687;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1957z00_693;
BgL_fun1957z00_693 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1955z00_694;obj_t BgL_arg1956z00_695;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1959z00_696;
BgL_fun1959z00_696 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1958z00_697;
BgL_arg1958z00_697 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1955z00_694 = 
PROCEDURE_ENTRY(BgL_fun1959z00_696)(BgL_fun1959z00_696, BgL_arg1958z00_697, BEOA); } } 
BgL_arg1956z00_695 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_strz00_687 = 
PROCEDURE_ENTRY(BgL_fun1957z00_693)(BgL_fun1957z00_693, BgL_arg1955z00_694, BgL_arg1956z00_695, BEOA); } } 
{ /* Llib/midi.scm 501 */
obj_t BgL_fun1951z00_688;
BgL_fun1951z00_688 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 502 */
long BgL_arg1950z00_689;
{ /* Llib/midi.scm 502 */
BGL_LONGLONG_T BgL_tmpz00_5637;
BgL_tmpz00_5637 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
BgL_arg1950z00_689 = 
LLONG_TO_LONG(BgL_tmpz00_5637); } 
PROCEDURE_ENTRY(BgL_fun1951z00_688)(BgL_fun1951z00_688, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_dtz00_43), 
BINT(BgL_ppqz00_42), 
BINT(BgL_arg1950z00_689), BEOA); } } 
{ /* Llib/midi.scm 503 */
obj_t BgL_fun1954z00_692;
BgL_fun1954z00_692 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_sysexz00); 
PROCEDURE_ENTRY(BgL_fun1954z00_692)(BgL_fun1954z00_692, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_strz00_687, BEOA); } }  else 
{ /* Llib/midi.scm 505 */
obj_t BgL_fun1960z00_698;
BgL_fun1960z00_698 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
PROCEDURE_ENTRY(BgL_fun1960z00_698)(BgL_fun1960z00_698, BGl_string2796z00zz__multimediazd2midizd2, BGl_string2798z00zz__multimediazd2midizd2, BgL_statusz00_480, BEOA); } } } } } } } } } } 
{ /* Llib/midi.scm 507 */
obj_t BgL_fun1978z00_718;
BgL_fun1978z00_718 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_flushz00); 
{ /* Llib/midi.scm 507 */
obj_t BgL_arg1977z00_719;
BgL_arg1977z00_719 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun1978z00_718)(BgL_fun1978z00_718, BgL_arg1977z00_719, BEOA);} } } } 

}



/* midi-read-mthd */
obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t BgL_ipz00_45)
{
{ /* Llib/midi.scm 512 */
{ /* Llib/midi.scm 513 */
obj_t BgL_tyz00_720;
BgL_tyz00_720 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_45); 
{ /* Llib/midi.scm 514 */
bool_t BgL_test3375z00_5684;
{ /* Llib/midi.scm 514 */
long BgL_l1z00_2061;
BgL_l1z00_2061 = 
STRING_LENGTH(
((obj_t)BgL_tyz00_720)); 
if(
(BgL_l1z00_2061==((long)4)))
{ /* Llib/midi.scm 514 */
int BgL_arg1282z00_2064;
{ /* Llib/midi.scm 514 */
char * BgL_auxz00_5692;char * BgL_tmpz00_5689;
BgL_auxz00_5692 = 
BSTRING_TO_STRING(BGl_string2799z00zz__multimediazd2midizd2); 
BgL_tmpz00_5689 = 
BSTRING_TO_STRING(
((obj_t)BgL_tyz00_720)); 
BgL_arg1282z00_2064 = 
memcmp(BgL_tmpz00_5689, BgL_auxz00_5692, BgL_l1z00_2061); } 
BgL_test3375z00_5684 = 
(
(long)(BgL_arg1282z00_2064)==((long)0)); }  else 
{ /* Llib/midi.scm 514 */
BgL_test3375z00_5684 = ((bool_t)0)
; } } 
if(BgL_test3375z00_5684)
{ /* Llib/midi.scm 516 */
int32_t BgL_sza7za7_722;
BgL_sza7za7_722 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 516 */
long BgL_fmtz00_723;
{ /* Llib/midi.scm 517 */
int32_t BgL_arg1995z00_768;
BgL_arg1995z00_768 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 517 */
long BgL_arg1425z00_2071;
BgL_arg1425z00_2071 = 
(long)(BgL_arg1995z00_768); 
BgL_fmtz00_723 = 
(long)(BgL_arg1425z00_2071); } } 
{ /* Llib/midi.scm 517 */
long BgL_tckz00_724;
{ /* Llib/midi.scm 518 */
int32_t BgL_arg1994z00_767;
BgL_arg1994z00_767 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 518 */
long BgL_arg1425z00_2074;
BgL_arg1425z00_2074 = 
(long)(BgL_arg1994z00_767); 
BgL_tckz00_724 = 
(long)(BgL_arg1425z00_2074); } } 
{ /* Llib/midi.scm 518 */
long BgL_divz00_725;
{ /* Llib/midi.scm 519 */
int32_t BgL_arg1993z00_766;
BgL_arg1993z00_766 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 519 */
long BgL_arg1425z00_2077;
BgL_arg1425z00_2077 = 
(long)(BgL_arg1993z00_766); 
BgL_divz00_725 = 
(long)(BgL_arg1425z00_2077); } } 
{ /* Llib/midi.scm 519 */

if(
(
(BgL_divz00_725 >> 
(int)(((long)15)))==((long)0)))
{ /* Llib/midi.scm 521 */
long BgL_val4_1200z00_732;
BgL_val4_1200z00_732 = 
(BgL_divz00_725 & ((long)32767)); 
{ /* Llib/midi.scm 521 */
int BgL_tmpz00_5712;
BgL_tmpz00_5712 = 
(int)(((long)5)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5712); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5717;int BgL_tmpz00_5715;
BgL_auxz00_5717 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_5715 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5715, BgL_auxz00_5717); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5722;int BgL_tmpz00_5720;
BgL_auxz00_5722 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_5720 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5720, BgL_auxz00_5722); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5727;int BgL_tmpz00_5725;
BgL_auxz00_5727 = 
BINT(((long)500000)); 
BgL_tmpz00_5725 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5725, BgL_auxz00_5727); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_5732;int BgL_tmpz00_5730;
BgL_auxz00_5732 = 
BINT(BgL_val4_1200z00_732); 
BgL_tmpz00_5730 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5730, BgL_auxz00_5732); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);}  else 
{ 

{ /* Llib/midi.scm 522 */
long BgL_aux1166z00_734;
BgL_aux1166z00_734 = 
(((long)128)-
(
(BgL_divz00_725 >> 
(int)(((long)8))) & ((long)127))); 
switch( BgL_aux1166z00_734) { case ((long)24) : 

{ /* Llib/midi.scm 524 */
long BgL_val4_1205z00_740;
BgL_val4_1205z00_740 = 
(((long)12)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 524 */
int BgL_tmpz00_5742;
BgL_tmpz00_5742 = 
(int)(((long)5)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5742); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5747;int BgL_tmpz00_5745;
BgL_auxz00_5747 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_5745 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5745, BgL_auxz00_5747); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5752;int BgL_tmpz00_5750;
BgL_auxz00_5752 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_5750 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5750, BgL_auxz00_5752); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5757;int BgL_tmpz00_5755;
BgL_auxz00_5757 = 
BINT(((long)500000)); 
BgL_tmpz00_5755 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5755, BgL_auxz00_5757); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_5762;int BgL_tmpz00_5760;
BgL_auxz00_5762 = 
BINT(BgL_val4_1205z00_740); 
BgL_tmpz00_5760 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5760, BgL_auxz00_5762); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)25) : 

{ /* Llib/midi.scm 526 */
long BgL_val4_1210z00_746;
BgL_val4_1210z00_746 = 
(((long)10)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 526 */
int BgL_tmpz00_5768;
BgL_tmpz00_5768 = 
(int)(((long)5)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5768); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_5773;int BgL_tmpz00_5771;
BgL_auxz00_5773 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_5771 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5771, BgL_auxz00_5773); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_5778;int BgL_tmpz00_5776;
BgL_auxz00_5778 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_5776 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5776, BgL_auxz00_5778); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_5783;int BgL_tmpz00_5781;
BgL_auxz00_5783 = 
BINT(((long)400000)); 
BgL_tmpz00_5781 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5781, BgL_auxz00_5783); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_5788;int BgL_tmpz00_5786;
BgL_auxz00_5788 = 
BINT(BgL_val4_1210z00_746); 
BgL_tmpz00_5786 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5786, BgL_auxz00_5788); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)29) : 

{ /* Llib/midi.scm 528 */
long BgL_val4_1215z00_752;
BgL_val4_1215z00_752 = 
(((long)2997)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 528 */
int BgL_tmpz00_5794;
BgL_tmpz00_5794 = 
(int)(((long)5)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5794); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_5799;int BgL_tmpz00_5797;
BgL_auxz00_5799 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_5797 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5797, BgL_auxz00_5799); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_5804;int BgL_tmpz00_5802;
BgL_auxz00_5804 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_5802 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5802, BgL_auxz00_5804); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_5809;int BgL_tmpz00_5807;
BgL_auxz00_5809 = 
BINT(((long)100000000)); 
BgL_tmpz00_5807 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5807, BgL_auxz00_5809); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_5814;int BgL_tmpz00_5812;
BgL_auxz00_5814 = 
BINT(BgL_val4_1215z00_752); 
BgL_tmpz00_5812 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5812, BgL_auxz00_5814); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)30) : 

{ /* Llib/midi.scm 530 */
long BgL_val4_1220z00_758;
BgL_val4_1220z00_758 = 
(((long)15)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 530 */
int BgL_tmpz00_5820;
BgL_tmpz00_5820 = 
(int)(((long)5)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_5820); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_5825;int BgL_tmpz00_5823;
BgL_auxz00_5825 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_5823 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5823, BgL_auxz00_5825); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_5830;int BgL_tmpz00_5828;
BgL_auxz00_5830 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_5828 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5828, BgL_auxz00_5830); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_5835;int BgL_tmpz00_5833;
BgL_auxz00_5835 = 
BINT(((long)500000)); 
BgL_tmpz00_5833 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5833, BgL_auxz00_5835); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_5840;int BgL_tmpz00_5838;
BgL_auxz00_5840 = 
BINT(BgL_val4_1220z00_758); 
BgL_tmpz00_5838 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_5838, BgL_auxz00_5840); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;
default: 
{ /* Llib/midi.scm 534 */
long BgL_arg1989z00_762;
BgL_arg1989z00_762 = 
(((long)128)-
(
(BgL_divz00_725 >> 
(int)(((long)8))) & ((long)127))); 
return 
BGl_errorz00zz__errorz00(BGl_string2800z00zz__multimediazd2midizd2, BGl_string2801z00zz__multimediazd2midizd2, 
BINT(BgL_arg1989z00_762));} } } } } } } } }  else 
{ /* Llib/midi.scm 514 */
return 
BGl_errorz00zz__errorz00(BGl_string2800z00zz__multimediazd2midizd2, BGl_string2802z00zz__multimediazd2midizd2, BgL_tyz00_720);} } } } 

}



/* midi-read-mtrk */
obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t BgL_ipz00_46)
{
{ /* Llib/midi.scm 539 */
{ /* Llib/midi.scm 540 */
obj_t BgL_tyz00_769;
BgL_tyz00_769 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_46); 
{ /* Llib/midi.scm 541 */
bool_t BgL_test3378z00_5854;
{ /* Llib/midi.scm 541 */
long BgL_l1z00_2098;
BgL_l1z00_2098 = 
STRING_LENGTH(
((obj_t)BgL_tyz00_769)); 
if(
(BgL_l1z00_2098==((long)4)))
{ /* Llib/midi.scm 541 */
int BgL_arg1282z00_2101;
{ /* Llib/midi.scm 541 */
char * BgL_auxz00_5862;char * BgL_tmpz00_5859;
BgL_auxz00_5862 = 
BSTRING_TO_STRING(BGl_string2803z00zz__multimediazd2midizd2); 
BgL_tmpz00_5859 = 
BSTRING_TO_STRING(
((obj_t)BgL_tyz00_769)); 
BgL_arg1282z00_2101 = 
memcmp(BgL_tmpz00_5859, BgL_auxz00_5862, BgL_l1z00_2098); } 
BgL_test3378z00_5854 = 
(
(long)(BgL_arg1282z00_2101)==((long)0)); }  else 
{ /* Llib/midi.scm 541 */
BgL_test3378z00_5854 = ((bool_t)0)
; } } 
if(BgL_test3378z00_5854)
{ /* Llib/midi.scm 543 */
int32_t BgL_tmpz00_5867;
BgL_tmpz00_5867 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_46); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_5867);}  else 
{ /* Llib/midi.scm 541 */
return 
BGl_errorz00zz__errorz00(BGl_string2804z00zz__multimediazd2midizd2, BGl_string2802z00zz__multimediazd2midizd2, BgL_tyz00_769);} } } } 

}



/* read-int16 */
int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_49)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
obj_t BgL_b1z00_772;
BgL_b1z00_772 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 561 */
obj_t BgL_b0z00_773;
BgL_b0z00_773 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 562 */

{ /* Llib/midi.scm 563 */
int32_t BgL_arg1998z00_774;int32_t BgL_arg1999z00_775;
{ /* Llib/midi.scm 563 */
int32_t BgL_arg2000z00_776;
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5873;
BgL_tmpz00_5873 = 
(
CCHAR(BgL_b1z00_772)); 
BgL_arg2000z00_776 = 
(int32_t)(BgL_tmpz00_5873); } 
BgL_arg1998z00_774 = 
(BgL_arg2000z00_776 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5879;
BgL_tmpz00_5879 = 
(
CCHAR(BgL_b0z00_773)); 
BgL_arg1999z00_775 = 
(int32_t)(BgL_tmpz00_5879); } 
return 
(BgL_arg1998z00_774+BgL_arg1999z00_775);} } } } } 

}



/* &read-int16 */
obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_2837, obj_t BgL_ipz00_2838)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
int32_t BgL_tmpz00_5884;
BgL_tmpz00_5884 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_2838); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_5884);} } 

}



/* read-int32 */
int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_50)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
obj_t BgL_b3z00_777;
BgL_b3z00_777 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 570 */
obj_t BgL_b2z00_778;
BgL_b2z00_778 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 571 */
obj_t BgL_b1z00_779;
BgL_b1z00_779 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 572 */
obj_t BgL_b0z00_780;
BgL_b0z00_780 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 573 */

{ /* Llib/midi.scm 574 */
int32_t BgL_arg2001z00_781;int32_t BgL_arg2002z00_782;
{ /* Llib/midi.scm 574 */
int32_t BgL_arg2003z00_783;
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5891;
BgL_tmpz00_5891 = 
(
CCHAR(BgL_b3z00_777)); 
BgL_arg2003z00_783 = 
(int32_t)(BgL_tmpz00_5891); } 
BgL_arg2001z00_781 = 
(BgL_arg2003z00_783 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2004z00_784;int32_t BgL_arg2005z00_785;
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2006z00_786;
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5897;
BgL_tmpz00_5897 = 
(
CCHAR(BgL_b2z00_778)); 
BgL_arg2006z00_786 = 
(int32_t)(BgL_tmpz00_5897); } 
BgL_arg2004z00_784 = 
(BgL_arg2006z00_786 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2007z00_787;int32_t BgL_arg2008z00_788;
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2009z00_789;
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5903;
BgL_tmpz00_5903 = 
(
CCHAR(BgL_b1z00_779)); 
BgL_arg2009z00_789 = 
(int32_t)(BgL_tmpz00_5903); } 
BgL_arg2007z00_787 = 
(BgL_arg2009z00_789 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_tmpz00_5909;
BgL_tmpz00_5909 = 
(
CCHAR(BgL_b0z00_780)); 
BgL_arg2008z00_788 = 
(int32_t)(BgL_tmpz00_5909); } 
BgL_arg2005z00_785 = 
(BgL_arg2007z00_787+BgL_arg2008z00_788); } 
BgL_arg2002z00_782 = 
(BgL_arg2004z00_784+BgL_arg2005z00_785); } 
return 
(BgL_arg2001z00_781+BgL_arg2002z00_782);} } } } } } } 

}



/* &read-int32 */
obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_2839, obj_t BgL_ipz00_2840)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
int32_t BgL_tmpz00_5916;
BgL_tmpz00_5916 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_2840); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_5916);} } 

}



/* read-int */
long BGl_readzd2intzd2zz__multimediazd2midizd2(long BgL_lenz00_51, obj_t BgL_ipz00_52)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_g1169z00_790;
{ /* Llib/midi.scm 583 */
obj_t BgL_arg2017z00_802;
BgL_arg2017z00_802 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_g1169z00_790 = 
(
CCHAR(BgL_arg2017z00_802)); } 
{ 
long BgL_valz00_792;long BgL_lenz00_793;
BgL_valz00_792 = BgL_g1169z00_790; 
BgL_lenz00_793 = BgL_lenz00_51; 
BgL_zc3z04anonymousza32010ze3z87_794:
if(
(BgL_lenz00_793==((long)1)))
{ /* Llib/midi.scm 585 */
return BgL_valz00_792;}  else 
{ /* Llib/midi.scm 587 */
long BgL_arg2012z00_796;long BgL_arg2013z00_797;
{ /* Llib/midi.scm 587 */
long BgL_arg2014z00_798;long BgL_arg2015z00_799;
BgL_arg2014z00_798 = 
(BgL_valz00_792 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 587 */
obj_t BgL_arg2016z00_800;
BgL_arg2016z00_800 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_arg2015z00_799 = 
(
CCHAR(BgL_arg2016z00_800)); } 
BgL_arg2012z00_796 = 
(BgL_arg2014z00_798+BgL_arg2015z00_799); } 
BgL_arg2013z00_797 = 
(BgL_lenz00_793-((long)1)); 
{ 
long BgL_lenz00_5932;long BgL_valz00_5931;
BgL_valz00_5931 = BgL_arg2012z00_796; 
BgL_lenz00_5932 = BgL_arg2013z00_797; 
BgL_lenz00_793 = BgL_lenz00_5932; 
BgL_valz00_792 = BgL_valz00_5931; 
goto BgL_zc3z04anonymousza32010ze3z87_794;} } } } } 

}



/* &read-int */
obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2841, obj_t BgL_lenz00_2842, obj_t BgL_ipz00_2843)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_tmpz00_5933;
{ /* Llib/midi.scm 583 */
obj_t BgL_auxz00_5943;long BgL_auxz00_5934;
if(
INPUT_PORTP(BgL_ipz00_2843))
{ /* Llib/midi.scm 583 */
BgL_auxz00_5943 = BgL_ipz00_2843
; }  else 
{ 
obj_t BgL_auxz00_5946;
BgL_auxz00_5946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string2805z00zz__multimediazd2midizd2, BGl_string2785z00zz__multimediazd2midizd2, BgL_ipz00_2843); 
FAILURE(BgL_auxz00_5946,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 583 */
obj_t BgL_tmpz00_5935;
if(
INTEGERP(BgL_lenz00_2842))
{ /* Llib/midi.scm 583 */
BgL_tmpz00_5935 = BgL_lenz00_2842
; }  else 
{ 
obj_t BgL_auxz00_5938;
BgL_auxz00_5938 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string2805z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_lenz00_2842); 
FAILURE(BgL_auxz00_5938,BFALSE,BFALSE);} 
BgL_auxz00_5934 = 
(long)CINT(BgL_tmpz00_5935); } 
BgL_tmpz00_5933 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(BgL_auxz00_5934, BgL_auxz00_5943); } 
return 
BINT(BgL_tmpz00_5933);} } 

}



/* &read-vlq */
obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2844, obj_t BgL_ipz00_2845)
{
{ /* Llib/midi.scm 593 */
{ /* Llib/midi.scm 595 */
long BgL_tmpz00_5952;
{ 
long BgL_accz00_3862;
BgL_accz00_3862 = ((long)0); 
BgL_loopz00_3861:
{ /* Llib/midi.scm 595 */
long BgL_cz00_3863;
{ /* Llib/midi.scm 595 */
obj_t BgL_arg2023z00_3864;
BgL_arg2023z00_3864 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_2845); 
BgL_cz00_3863 = 
(
CCHAR(BgL_arg2023z00_3864)); } 
if(
(BgL_cz00_3863<=((long)127)))
{ /* Llib/midi.scm 596 */
BgL_tmpz00_5952 = 
(BgL_cz00_3863+BgL_accz00_3862)
; }  else 
{ 
long BgL_accz00_5959;
BgL_accz00_5959 = 
(
(BgL_accz00_3862+
(BgL_cz00_3863 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_3862 = BgL_accz00_5959; 
goto BgL_loopz00_3861;} } } 
return 
BINT(BgL_tmpz00_5952);} } 

}



/* string-stream-peek-byte */
long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t BgL_ipz00_54)
{
{ /* Llib/midi.scm 603 */
return 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)1))))));} 

}



/* &string-stream-peek-byte */
obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2849, obj_t BgL_ipz00_2850)
{
{ /* Llib/midi.scm 603 */
{ /* Llib/midi.scm 605 */
long BgL_tmpz00_5972;
{ /* Llib/midi.scm 605 */
obj_t BgL_auxz00_5973;
if(
STRUCTP(BgL_ipz00_2850))
{ /* Llib/midi.scm 605 */
BgL_auxz00_5973 = BgL_ipz00_2850
; }  else 
{ 
obj_t BgL_auxz00_5976;
BgL_auxz00_5976 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)25285)), BGl_string2806z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2850); 
FAILURE(BgL_auxz00_5976,BFALSE,BFALSE);} 
BgL_tmpz00_5972 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_auxz00_5973); } 
return 
BINT(BgL_tmpz00_5972);} } 

}



/* &string-stream-read-byte */
obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2851, obj_t BgL_ipz00_2852)
{
{ /* Llib/midi.scm 610 */
{ /* Llib/midi.scm 611 */
long BgL_tmpz00_5982;
{ /* Llib/midi.scm 611 */
obj_t BgL_ipz00_3865;
if(
STRUCTP(BgL_ipz00_2852))
{ /* Llib/midi.scm 611 */
BgL_ipz00_3865 = BgL_ipz00_2852; }  else 
{ 
obj_t BgL_auxz00_5985;
BgL_auxz00_5985 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)25610)), BGl_string2808z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2852); 
FAILURE(BgL_auxz00_5985,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 611 */
long BgL_bz00_3866;
BgL_bz00_3866 = 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_3865, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_3865, 
(int)(((long)1)))))); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3867;
BgL_arg2027z00_3867 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3865, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6002;int BgL_tmpz00_6000;
BgL_auxz00_6002 = 
BINT(BgL_arg2027z00_3867); 
BgL_tmpz00_6000 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3865, BgL_tmpz00_6000, BgL_auxz00_6002); } } 
BgL_tmpz00_5982 = BgL_bz00_3866; } } 
return 
BINT(BgL_tmpz00_5982);} } 

}



/* &string-stream-read-int16 */
obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_2853, obj_t BgL_ipz00_2854)
{
{ /* Llib/midi.scm 618 */
{ /* Llib/midi.scm 619 */
int32_t BgL_tmpz00_6006;
{ /* Llib/midi.scm 619 */
obj_t BgL_ipz00_3868;
if(
STRUCTP(BgL_ipz00_2854))
{ /* Llib/midi.scm 619 */
BgL_ipz00_3868 = BgL_ipz00_2854; }  else 
{ 
obj_t BgL_auxz00_6009;
BgL_auxz00_6009 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)26001)), BGl_string2809z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2854); 
FAILURE(BgL_auxz00_6009,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 619 */
long BgL_b1z00_3869;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3870;
BgL_bz00_3870 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3868); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3871;
BgL_arg2027z00_3871 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3868, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6020;int BgL_tmpz00_6018;
BgL_auxz00_6020 = 
BINT(BgL_arg2027z00_3871); 
BgL_tmpz00_6018 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3868, BgL_tmpz00_6018, BgL_auxz00_6020); } } 
BgL_b1z00_3869 = BgL_bz00_3870; } 
{ /* Llib/midi.scm 619 */
long BgL_b0z00_3872;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3873;
BgL_bz00_3873 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3868); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3874;
BgL_arg2027z00_3874 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3868, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6030;int BgL_tmpz00_6028;
BgL_auxz00_6030 = 
BINT(BgL_arg2027z00_3874); 
BgL_tmpz00_6028 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3868, BgL_tmpz00_6028, BgL_auxz00_6030); } } 
BgL_b0z00_3872 = BgL_bz00_3873; } 
{ /* Llib/midi.scm 620 */

{ /* Llib/midi.scm 621 */
int32_t BgL_arg2029z00_3875;int32_t BgL_arg2030z00_3876;
{ /* Llib/midi.scm 621 */
int32_t BgL_arg2031z00_3877;
BgL_arg2031z00_3877 = 
(int32_t)(BgL_b1z00_3869); 
BgL_arg2029z00_3875 = 
(BgL_arg2031z00_3877 << 
(int)(((long)8))); } 
BgL_arg2030z00_3876 = 
(int32_t)(BgL_b0z00_3872); 
BgL_tmpz00_6006 = 
(BgL_arg2029z00_3875+BgL_arg2030z00_3876); } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6006);} } 

}



/* &string-stream-read-int32 */
obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_2855, obj_t BgL_ipz00_2856)
{
{ /* Llib/midi.scm 626 */
{ /* Llib/midi.scm 627 */
int32_t BgL_tmpz00_6039;
{ /* Llib/midi.scm 627 */
obj_t BgL_ipz00_3878;
if(
STRUCTP(BgL_ipz00_2856))
{ /* Llib/midi.scm 627 */
BgL_ipz00_3878 = BgL_ipz00_2856; }  else 
{ 
obj_t BgL_auxz00_6042;
BgL_auxz00_6042 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)26420)), BGl_string2810z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2856); 
FAILURE(BgL_auxz00_6042,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 627 */
long BgL_b3z00_3879;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3880;
BgL_bz00_3880 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3878); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3881;
BgL_arg2027z00_3881 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3878, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6053;int BgL_tmpz00_6051;
BgL_auxz00_6053 = 
BINT(BgL_arg2027z00_3881); 
BgL_tmpz00_6051 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3878, BgL_tmpz00_6051, BgL_auxz00_6053); } } 
BgL_b3z00_3879 = BgL_bz00_3880; } 
{ /* Llib/midi.scm 627 */
long BgL_b2z00_3882;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3883;
BgL_bz00_3883 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3878); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3884;
BgL_arg2027z00_3884 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3878, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6063;int BgL_tmpz00_6061;
BgL_auxz00_6063 = 
BINT(BgL_arg2027z00_3884); 
BgL_tmpz00_6061 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3878, BgL_tmpz00_6061, BgL_auxz00_6063); } } 
BgL_b2z00_3882 = BgL_bz00_3883; } 
{ /* Llib/midi.scm 628 */
long BgL_b1z00_3885;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3886;
BgL_bz00_3886 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3878); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3887;
BgL_arg2027z00_3887 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3878, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6073;int BgL_tmpz00_6071;
BgL_auxz00_6073 = 
BINT(BgL_arg2027z00_3887); 
BgL_tmpz00_6071 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3878, BgL_tmpz00_6071, BgL_auxz00_6073); } } 
BgL_b1z00_3885 = BgL_bz00_3886; } 
{ /* Llib/midi.scm 629 */
long BgL_b0z00_3888;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3889;
BgL_bz00_3889 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3878); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3890;
BgL_arg2027z00_3890 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3878, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6083;int BgL_tmpz00_6081;
BgL_auxz00_6083 = 
BINT(BgL_arg2027z00_3890); 
BgL_tmpz00_6081 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3878, BgL_tmpz00_6081, BgL_auxz00_6083); } } 
BgL_b0z00_3888 = BgL_bz00_3889; } 
{ /* Llib/midi.scm 630 */

{ /* Llib/midi.scm 631 */
int32_t BgL_arg2032z00_3891;int32_t BgL_arg2033z00_3892;
{ /* Llib/midi.scm 631 */
int32_t BgL_arg2034z00_3893;
BgL_arg2034z00_3893 = 
(int32_t)(BgL_b3z00_3879); 
BgL_arg2032z00_3891 = 
(BgL_arg2034z00_3893 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2035z00_3894;int32_t BgL_arg2036z00_3895;
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2037z00_3896;
BgL_arg2037z00_3896 = 
(int32_t)(BgL_b2z00_3882); 
BgL_arg2035z00_3894 = 
(BgL_arg2037z00_3896 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2038z00_3897;int32_t BgL_arg2039z00_3898;
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2040z00_3899;
BgL_arg2040z00_3899 = 
(int32_t)(BgL_b1z00_3885); 
BgL_arg2038z00_3897 = 
(BgL_arg2040z00_3899 << 
(int)(((long)8))); } 
BgL_arg2039z00_3898 = 
(int32_t)(BgL_b0z00_3888); 
BgL_arg2036z00_3895 = 
(BgL_arg2038z00_3897+BgL_arg2039z00_3898); } 
BgL_arg2033z00_3892 = 
(BgL_arg2035z00_3894+BgL_arg2036z00_3895); } 
BgL_tmpz00_6039 = 
(BgL_arg2032z00_3891+BgL_arg2033z00_3892); } } } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6039);} } 

}



/* &string-stream-read-int */
obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2857, obj_t BgL_lenz00_2858, obj_t BgL_ipz00_2859)
{
{ /* Llib/midi.scm 639 */
{ /* Llib/midi.scm 640 */
long BgL_tmpz00_6100;
{ /* Llib/midi.scm 640 */
long BgL_lenz00_3900;obj_t BgL_ipz00_3901;
{ /* Llib/midi.scm 640 */
obj_t BgL_tmpz00_6101;
if(
INTEGERP(BgL_lenz00_2858))
{ /* Llib/midi.scm 640 */
BgL_tmpz00_6101 = BgL_lenz00_2858
; }  else 
{ 
obj_t BgL_auxz00_6104;
BgL_auxz00_6104 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string2811z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_lenz00_2858); 
FAILURE(BgL_auxz00_6104,BFALSE,BFALSE);} 
BgL_lenz00_3900 = 
(long)CINT(BgL_tmpz00_6101); } 
if(
STRUCTP(BgL_ipz00_2859))
{ /* Llib/midi.scm 640 */
BgL_ipz00_3901 = BgL_ipz00_2859; }  else 
{ 
obj_t BgL_auxz00_6111;
BgL_auxz00_6111 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string2811z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2859); 
FAILURE(BgL_auxz00_6111,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 640 */
long BgL_g1170z00_3902;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3903;
BgL_bz00_3903 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3901); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3904;
BgL_arg2027z00_3904 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3901, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6122;int BgL_tmpz00_6120;
BgL_auxz00_6122 = 
BINT(BgL_arg2027z00_3904); 
BgL_tmpz00_6120 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3901, BgL_tmpz00_6120, BgL_auxz00_6122); } } 
BgL_g1170z00_3902 = BgL_bz00_3903; } 
{ 
long BgL_valz00_3906;long BgL_lenz00_3907;
BgL_valz00_3906 = BgL_g1170z00_3902; 
BgL_lenz00_3907 = BgL_lenz00_3900; 
BgL_loopz00_3905:
if(
(BgL_lenz00_3907==((long)1)))
{ /* Llib/midi.scm 642 */
BgL_tmpz00_6100 = BgL_valz00_3906
; }  else 
{ /* Llib/midi.scm 644 */
long BgL_arg2043z00_3908;long BgL_arg2044z00_3909;
{ /* Llib/midi.scm 644 */
long BgL_arg2045z00_3910;long BgL_arg2046z00_3911;
BgL_arg2045z00_3910 = 
(BgL_valz00_3906 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 611 */
long BgL_bz00_3912;
BgL_bz00_3912 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_3901); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3913;
BgL_arg2027z00_3913 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_3901, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6136;int BgL_tmpz00_6134;
BgL_auxz00_6136 = 
BINT(BgL_arg2027z00_3913); 
BgL_tmpz00_6134 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3901, BgL_tmpz00_6134, BgL_auxz00_6136); } } 
BgL_arg2046z00_3911 = BgL_bz00_3912; } 
BgL_arg2043z00_3908 = 
(BgL_arg2045z00_3910+BgL_arg2046z00_3911); } 
BgL_arg2044z00_3909 = 
(BgL_lenz00_3907-((long)1)); 
{ 
long BgL_lenz00_6142;long BgL_valz00_6141;
BgL_valz00_6141 = BgL_arg2043z00_3908; 
BgL_lenz00_6142 = BgL_arg2044z00_3909; 
BgL_lenz00_3907 = BgL_lenz00_6142; 
BgL_valz00_3906 = BgL_valz00_6141; 
goto BgL_loopz00_3905;} } } } } 
return 
BINT(BgL_tmpz00_6100);} } 

}



/* &string-stream-read-vlq */
obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2860, obj_t BgL_ipz00_2861)
{
{ /* Llib/midi.scm 650 */
{ /* Llib/midi.scm 652 */
long BgL_tmpz00_6144;
{ 
long BgL_accz00_3915;
BgL_accz00_3915 = ((long)0); 
BgL_loopz00_3914:
{ /* Llib/midi.scm 652 */
long BgL_cz00_3916;
{ /* Llib/midi.scm 611 */
long BgL_bz00_3917;
BgL_bz00_3917 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(
((obj_t)BgL_ipz00_2861)); 
{ /* Llib/midi.scm 612 */
long BgL_arg2027z00_3918;
BgL_arg2027z00_3918 = 
(
(long)CINT(
STRUCT_REF(
((obj_t)BgL_ipz00_2861), 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6156;int BgL_auxz00_6154;obj_t BgL_tmpz00_6152;
BgL_auxz00_6156 = 
BINT(BgL_arg2027z00_3918); 
BgL_auxz00_6154 = 
(int)(((long)1)); 
BgL_tmpz00_6152 = 
((obj_t)BgL_ipz00_2861); 
STRUCT_SET(BgL_tmpz00_6152, BgL_auxz00_6154, BgL_auxz00_6156); } } 
BgL_cz00_3916 = BgL_bz00_3917; } 
if(
(BgL_cz00_3916<=((long)127)))
{ /* Llib/midi.scm 653 */
BgL_tmpz00_6144 = 
(BgL_cz00_3916+BgL_accz00_3915)
; }  else 
{ 
long BgL_accz00_6162;
BgL_accz00_6162 = 
(
(BgL_accz00_3915+
(BgL_cz00_3916 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_3915 = BgL_accz00_6162; 
goto BgL_loopz00_3914;} } } 
return 
BINT(BgL_tmpz00_6144);} } 

}



/* &string-stream-read-chars */
obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t BgL_envz00_2862, obj_t BgL_lenz00_2863, obj_t BgL_ipz00_2864)
{
{ /* Llib/midi.scm 660 */
{ /* Llib/midi.scm 661 */
obj_t BgL_ipz00_3919;
if(
STRUCTP(BgL_ipz00_2864))
{ /* Llib/midi.scm 661 */
BgL_ipz00_3919 = BgL_ipz00_2864; }  else 
{ 
obj_t BgL_auxz00_6170;
BgL_auxz00_6170 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)27894)), BGl_string2812z00zz__multimediazd2midizd2, BGl_string2807z00zz__multimediazd2midizd2, BgL_ipz00_2864); 
FAILURE(BgL_auxz00_6170,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 661 */
obj_t BgL_sz00_3920;
{ /* Llib/midi.scm 661 */
obj_t BgL_arg2054z00_3921;obj_t BgL_arg2055z00_3922;obj_t BgL_arg2056z00_3923;
BgL_arg2054z00_3921 = 
STRUCT_REF(BgL_ipz00_3919, 
(int)(((long)0))); 
BgL_arg2055z00_3922 = 
STRUCT_REF(BgL_ipz00_3919, 
(int)(((long)1))); 
BgL_arg2056z00_3923 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_3919, 
(int)(((long)1))), BgL_lenz00_2863); 
{ /* Llib/midi.scm 661 */
long BgL_startz00_3924;long BgL_endz00_3925;
BgL_startz00_3924 = 
(long)CINT(BgL_arg2055z00_3922); 
BgL_endz00_3925 = 
(long)CINT(BgL_arg2056z00_3923); 
BgL_sz00_3920 = 
c_substring(
((obj_t)BgL_arg2054z00_3921), BgL_startz00_3924, BgL_endz00_3925); } } 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6187;int BgL_tmpz00_6185;
BgL_auxz00_6187 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_3919, 
(int)(((long)1))), BgL_lenz00_2863); 
BgL_tmpz00_6185 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_3919, BgL_tmpz00_6185, BgL_auxz00_6187); } 
return BgL_sz00_3920;} } } 

}



/* midiplayer-cdelay */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_68, BgL_midisinkz00_bglt BgL_msz00_69, long BgL_tickz00_70, BgL_miditrackz00_bglt BgL_trackz00_71, long BgL_ppqz00_72, long BgL_dtz00_73, long BgL_usz00_74)
{
{ /* Llib/midi.scm 993 */
if(
(BgL_dtz00_73>((long)0)))
{ /* Llib/midi.scm 998 */
obj_t BgL_fun2060z00_2283;
BgL_fun2060z00_2283 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_69))->BgL_usleepz00); 
{ /* Llib/midi.scm 998 */
long BgL_arg2059z00_2284;
BgL_arg2059z00_2284 = 
(
(
(BgL_dtz00_73*
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_71))->BgL_tempoz00))/BgL_ppqz00_72)-BgL_usz00_74); 
return 
PROCEDURE_ENTRY(BgL_fun2060z00_2283)(BgL_fun2060z00_2283, 
BINT(BgL_arg2059z00_2284), BEOA);} }  else 
{ /* Llib/midi.scm 997 */
return BFALSE;} } 

}



/* &midiplayer-cdelay */
obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2891, obj_t BgL_mpz00_2892, obj_t BgL_msz00_2893, obj_t BgL_tickz00_2894, obj_t BgL_trackz00_2895, obj_t BgL_ppqz00_2896, obj_t BgL_dtz00_2897, obj_t BgL_usz00_2898)
{
{ /* Llib/midi.scm 993 */
{ /* Llib/midi.scm 995 */
long BgL_auxz00_6255;long BgL_auxz00_6246;long BgL_auxz00_6237;BgL_miditrackz00_bglt BgL_auxz00_6229;long BgL_auxz00_6220;BgL_midisinkz00_bglt BgL_auxz00_6212;BgL_midiplayerz00_bglt BgL_auxz00_6204;
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6256;
if(
INTEGERP(BgL_usz00_2898))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6256 = BgL_usz00_2898
; }  else 
{ 
obj_t BgL_auxz00_6259;
BgL_auxz00_6259 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_usz00_2898); 
FAILURE(BgL_auxz00_6259,BFALSE,BFALSE);} 
BgL_auxz00_6255 = 
(long)CINT(BgL_tmpz00_6256); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6247;
if(
INTEGERP(BgL_dtz00_2897))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6247 = BgL_dtz00_2897
; }  else 
{ 
obj_t BgL_auxz00_6250;
BgL_auxz00_6250 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_dtz00_2897); 
FAILURE(BgL_auxz00_6250,BFALSE,BFALSE);} 
BgL_auxz00_6246 = 
(long)CINT(BgL_tmpz00_6247); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6238;
if(
INTEGERP(BgL_ppqz00_2896))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6238 = BgL_ppqz00_2896
; }  else 
{ 
obj_t BgL_auxz00_6241;
BgL_auxz00_6241 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ppqz00_2896); 
FAILURE(BgL_auxz00_6241,BFALSE,BFALSE);} 
BgL_auxz00_6237 = 
(long)CINT(BgL_tmpz00_6238); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_trackz00_2895, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6229 = 
((BgL_miditrackz00_bglt)BgL_trackz00_2895)
; }  else 
{ 
obj_t BgL_auxz00_6233;
BgL_auxz00_6233 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2814z00zz__multimediazd2midizd2, BgL_trackz00_2895); 
FAILURE(BgL_auxz00_6233,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6221;
if(
INTEGERP(BgL_tickz00_2894))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6221 = BgL_tickz00_2894
; }  else 
{ 
obj_t BgL_auxz00_6224;
BgL_auxz00_6224 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2894); 
FAILURE(BgL_auxz00_6224,BFALSE,BFALSE);} 
BgL_auxz00_6220 = 
(long)CINT(BgL_tmpz00_6221); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2893, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6212 = 
((BgL_midisinkz00_bglt)BgL_msz00_2893)
; }  else 
{ 
obj_t BgL_auxz00_6216;
BgL_auxz00_6216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2893); 
FAILURE(BgL_auxz00_6216,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2892, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6204 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2892)
; }  else 
{ 
obj_t BgL_auxz00_6208;
BgL_auxz00_6208 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string2813z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2892); 
FAILURE(BgL_auxz00_6208,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_auxz00_6204, BgL_auxz00_6212, BgL_auxz00_6220, BgL_auxz00_6229, BgL_auxz00_6237, BgL_auxz00_6246, BgL_auxz00_6255);} } 

}



/* midiplayer-ignore */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_75, BgL_midisinkz00_bglt BgL_msz00_76, long BgL_tickz00_77, obj_t BgL_objz00_78)
{
{ /* Llib/midi.scm 1003 */
return BUNSPEC;} 

}



/* &midiplayer-ignore */
obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2899, obj_t BgL_mpz00_2900, obj_t BgL_msz00_2901, obj_t BgL_tickz00_2902, obj_t BgL_objz00_2903)
{
{ /* Llib/midi.scm 1003 */
{ /* Llib/midi.scm 1003 */
BgL_midiplayerz00_bglt BgL_mpz00_3926;BgL_midisinkz00_bglt BgL_msz00_3927;long BgL_tickz00_3928;
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2900, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_mpz00_3926 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2900); }  else 
{ 
obj_t BgL_auxz00_6268;
BgL_auxz00_6268 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string2815z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2900); 
FAILURE(BgL_auxz00_6268,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2901, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_msz00_3927 = 
((BgL_midisinkz00_bglt)BgL_msz00_2901); }  else 
{ 
obj_t BgL_auxz00_6275;
BgL_auxz00_6275 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string2815z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2901); 
FAILURE(BgL_auxz00_6275,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1003 */
obj_t BgL_tmpz00_6279;
if(
INTEGERP(BgL_tickz00_2902))
{ /* Llib/midi.scm 1003 */
BgL_tmpz00_6279 = BgL_tickz00_2902
; }  else 
{ 
obj_t BgL_auxz00_6282;
BgL_auxz00_6282 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string2815z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2902); 
FAILURE(BgL_auxz00_6282,BFALSE,BFALSE);} 
BgL_tickz00_3928 = 
(long)CINT(BgL_tmpz00_6279); } 
return BUNSPEC;} } 

}



/* midiplayer-noteoff */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_88, BgL_midisinkz00_bglt BgL_msz00_89, long BgL_tickz00_90, long BgL_nnz00_91, long BgL_kkz00_92, long BgL_vvz00_93)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2070z00_2318;
BgL_fun2070z00_2318 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2068z00_2319;long BgL_arg2069z00_2320;
BgL_arg2068z00_2319 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
BgL_arg2069z00_2320 = 
(((long)128) | BgL_nnz00_91); 
PROCEDURE_ENTRY(BgL_fun2070z00_2318)(BgL_fun2070z00_2318, BgL_arg2068z00_2319, 
BINT(BgL_arg2069z00_2320), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2072z00_2321;
BgL_fun2072z00_2321 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2071z00_2322;
BgL_arg2071z00_2322 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2072z00_2321)(BgL_fun2072z00_2321, BgL_arg2071z00_2322, 
BINT(BgL_kkz00_92), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2074z00_2323;
BgL_fun2074z00_2323 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2073z00_2324;
BgL_arg2073z00_2324 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2074z00_2323)(BgL_fun2074z00_2323, BgL_arg2073z00_2324, 
BINT(BgL_vvz00_93), BEOA);} } } 

}



/* &midiplayer-noteoff */
obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2904, obj_t BgL_mpz00_2905, obj_t BgL_msz00_2906, obj_t BgL_tickz00_2907, obj_t BgL_nnz00_2908, obj_t BgL_kkz00_2909, obj_t BgL_vvz00_2910)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1028 */
long BgL_auxz00_6355;long BgL_auxz00_6346;long BgL_auxz00_6337;long BgL_auxz00_6328;BgL_midisinkz00_bglt BgL_auxz00_6320;BgL_midiplayerz00_bglt BgL_auxz00_6312;
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6356;
if(
INTEGERP(BgL_vvz00_2910))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6356 = BgL_vvz00_2910
; }  else 
{ 
obj_t BgL_auxz00_6359;
BgL_auxz00_6359 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_vvz00_2910); 
FAILURE(BgL_auxz00_6359,BFALSE,BFALSE);} 
BgL_auxz00_6355 = 
(long)CINT(BgL_tmpz00_6356); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6347;
if(
INTEGERP(BgL_kkz00_2909))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6347 = BgL_kkz00_2909
; }  else 
{ 
obj_t BgL_auxz00_6350;
BgL_auxz00_6350 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_kkz00_2909); 
FAILURE(BgL_auxz00_6350,BFALSE,BFALSE);} 
BgL_auxz00_6346 = 
(long)CINT(BgL_tmpz00_6347); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6338;
if(
INTEGERP(BgL_nnz00_2908))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6338 = BgL_nnz00_2908
; }  else 
{ 
obj_t BgL_auxz00_6341;
BgL_auxz00_6341 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2908); 
FAILURE(BgL_auxz00_6341,BFALSE,BFALSE);} 
BgL_auxz00_6337 = 
(long)CINT(BgL_tmpz00_6338); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6329;
if(
INTEGERP(BgL_tickz00_2907))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6329 = BgL_tickz00_2907
; }  else 
{ 
obj_t BgL_auxz00_6332;
BgL_auxz00_6332 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2907); 
FAILURE(BgL_auxz00_6332,BFALSE,BFALSE);} 
BgL_auxz00_6328 = 
(long)CINT(BgL_tmpz00_6329); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2906, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6320 = 
((BgL_midisinkz00_bglt)BgL_msz00_2906)
; }  else 
{ 
obj_t BgL_auxz00_6324;
BgL_auxz00_6324 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2906); 
FAILURE(BgL_auxz00_6324,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2905, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6312 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2905)
; }  else 
{ 
obj_t BgL_auxz00_6316;
BgL_auxz00_6316 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string2816z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2905); 
FAILURE(BgL_auxz00_6316,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_auxz00_6312, BgL_auxz00_6320, BgL_auxz00_6328, BgL_auxz00_6337, BgL_auxz00_6346, BgL_auxz00_6355);} } 

}



/* midiplayer-noteon */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_94, BgL_midisinkz00_bglt BgL_msz00_95, long BgL_tickz00_96, long BgL_nnz00_97, long BgL_kkz00_98, long BgL_vvz00_99)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2070z00_2331;
BgL_fun2070z00_2331 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2068z00_2332;long BgL_arg2069z00_2333;
BgL_arg2068z00_2332 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
BgL_arg2069z00_2333 = 
(((long)144) | BgL_nnz00_97); 
PROCEDURE_ENTRY(BgL_fun2070z00_2331)(BgL_fun2070z00_2331, BgL_arg2068z00_2332, 
BINT(BgL_arg2069z00_2333), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2072z00_2334;
BgL_fun2072z00_2334 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2071z00_2335;
BgL_arg2071z00_2335 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2072z00_2334)(BgL_fun2072z00_2334, BgL_arg2071z00_2335, 
BINT(BgL_kkz00_98), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2074z00_2336;
BgL_fun2074z00_2336 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2073z00_2337;
BgL_arg2073z00_2337 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2074z00_2336)(BgL_fun2074z00_2336, BgL_arg2073z00_2337, 
BINT(BgL_vvz00_99), BEOA);} } } 

}



/* &midiplayer-noteon */
obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2911, obj_t BgL_mpz00_2912, obj_t BgL_msz00_2913, obj_t BgL_tickz00_2914, obj_t BgL_nnz00_2915, obj_t BgL_kkz00_2916, obj_t BgL_vvz00_2917)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1035 */
long BgL_auxz00_6433;long BgL_auxz00_6424;long BgL_auxz00_6415;long BgL_auxz00_6406;BgL_midisinkz00_bglt BgL_auxz00_6398;BgL_midiplayerz00_bglt BgL_auxz00_6390;
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6434;
if(
INTEGERP(BgL_vvz00_2917))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6434 = BgL_vvz00_2917
; }  else 
{ 
obj_t BgL_auxz00_6437;
BgL_auxz00_6437 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_vvz00_2917); 
FAILURE(BgL_auxz00_6437,BFALSE,BFALSE);} 
BgL_auxz00_6433 = 
(long)CINT(BgL_tmpz00_6434); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6425;
if(
INTEGERP(BgL_kkz00_2916))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6425 = BgL_kkz00_2916
; }  else 
{ 
obj_t BgL_auxz00_6428;
BgL_auxz00_6428 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_kkz00_2916); 
FAILURE(BgL_auxz00_6428,BFALSE,BFALSE);} 
BgL_auxz00_6424 = 
(long)CINT(BgL_tmpz00_6425); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6416;
if(
INTEGERP(BgL_nnz00_2915))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6416 = BgL_nnz00_2915
; }  else 
{ 
obj_t BgL_auxz00_6419;
BgL_auxz00_6419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2915); 
FAILURE(BgL_auxz00_6419,BFALSE,BFALSE);} 
BgL_auxz00_6415 = 
(long)CINT(BgL_tmpz00_6416); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6407;
if(
INTEGERP(BgL_tickz00_2914))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6407 = BgL_tickz00_2914
; }  else 
{ 
obj_t BgL_auxz00_6410;
BgL_auxz00_6410 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2914); 
FAILURE(BgL_auxz00_6410,BFALSE,BFALSE);} 
BgL_auxz00_6406 = 
(long)CINT(BgL_tmpz00_6407); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2913, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6398 = 
((BgL_midisinkz00_bglt)BgL_msz00_2913)
; }  else 
{ 
obj_t BgL_auxz00_6402;
BgL_auxz00_6402 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2913); 
FAILURE(BgL_auxz00_6402,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2912, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6390 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2912)
; }  else 
{ 
obj_t BgL_auxz00_6394;
BgL_auxz00_6394 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string2817z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2912); 
FAILURE(BgL_auxz00_6394,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_auxz00_6390, BgL_auxz00_6398, BgL_auxz00_6406, BgL_auxz00_6415, BgL_auxz00_6424, BgL_auxz00_6433);} } 

}



/* midiplayer-aftertouch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_100, BgL_midisinkz00_bglt BgL_msz00_101, long BgL_tickz00_102, long BgL_nnz00_103, long BgL_kkz00_104, long BgL_vvz00_105)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2070z00_2344;
BgL_fun2070z00_2344 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2068z00_2345;long BgL_arg2069z00_2346;
BgL_arg2068z00_2345 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
BgL_arg2069z00_2346 = 
(((long)160) | BgL_nnz00_103); 
PROCEDURE_ENTRY(BgL_fun2070z00_2344)(BgL_fun2070z00_2344, BgL_arg2068z00_2345, 
BINT(BgL_arg2069z00_2346), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2072z00_2347;
BgL_fun2072z00_2347 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2071z00_2348;
BgL_arg2071z00_2348 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2072z00_2347)(BgL_fun2072z00_2347, BgL_arg2071z00_2348, 
BINT(BgL_kkz00_104), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2074z00_2349;
BgL_fun2074z00_2349 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2073z00_2350;
BgL_arg2073z00_2350 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2074z00_2349)(BgL_fun2074z00_2349, BgL_arg2073z00_2350, 
BINT(BgL_vvz00_105), BEOA);} } } 

}



/* &midiplayer-aftertouch */
obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2918, obj_t BgL_mpz00_2919, obj_t BgL_msz00_2920, obj_t BgL_tickz00_2921, obj_t BgL_nnz00_2922, obj_t BgL_kkz00_2923, obj_t BgL_vvz00_2924)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1042 */
long BgL_auxz00_6511;long BgL_auxz00_6502;long BgL_auxz00_6493;long BgL_auxz00_6484;BgL_midisinkz00_bglt BgL_auxz00_6476;BgL_midiplayerz00_bglt BgL_auxz00_6468;
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6512;
if(
INTEGERP(BgL_vvz00_2924))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6512 = BgL_vvz00_2924
; }  else 
{ 
obj_t BgL_auxz00_6515;
BgL_auxz00_6515 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_vvz00_2924); 
FAILURE(BgL_auxz00_6515,BFALSE,BFALSE);} 
BgL_auxz00_6511 = 
(long)CINT(BgL_tmpz00_6512); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6503;
if(
INTEGERP(BgL_kkz00_2923))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6503 = BgL_kkz00_2923
; }  else 
{ 
obj_t BgL_auxz00_6506;
BgL_auxz00_6506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_kkz00_2923); 
FAILURE(BgL_auxz00_6506,BFALSE,BFALSE);} 
BgL_auxz00_6502 = 
(long)CINT(BgL_tmpz00_6503); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6494;
if(
INTEGERP(BgL_nnz00_2922))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6494 = BgL_nnz00_2922
; }  else 
{ 
obj_t BgL_auxz00_6497;
BgL_auxz00_6497 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2922); 
FAILURE(BgL_auxz00_6497,BFALSE,BFALSE);} 
BgL_auxz00_6493 = 
(long)CINT(BgL_tmpz00_6494); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6485;
if(
INTEGERP(BgL_tickz00_2921))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6485 = BgL_tickz00_2921
; }  else 
{ 
obj_t BgL_auxz00_6488;
BgL_auxz00_6488 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2921); 
FAILURE(BgL_auxz00_6488,BFALSE,BFALSE);} 
BgL_auxz00_6484 = 
(long)CINT(BgL_tmpz00_6485); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2920, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6476 = 
((BgL_midisinkz00_bglt)BgL_msz00_2920)
; }  else 
{ 
obj_t BgL_auxz00_6480;
BgL_auxz00_6480 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2920); 
FAILURE(BgL_auxz00_6480,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2919, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6468 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2919)
; }  else 
{ 
obj_t BgL_auxz00_6472;
BgL_auxz00_6472 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string2818z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2919); 
FAILURE(BgL_auxz00_6472,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_auxz00_6468, BgL_auxz00_6476, BgL_auxz00_6484, BgL_auxz00_6493, BgL_auxz00_6502, BgL_auxz00_6511);} } 

}



/* midiplayer-ctrlchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_106, BgL_midisinkz00_bglt BgL_msz00_107, long BgL_tickz00_108, long BgL_nnz00_109, long BgL_kkz00_110, long BgL_vvz00_111)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2070z00_2357;
BgL_fun2070z00_2357 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2068z00_2358;long BgL_arg2069z00_2359;
BgL_arg2068z00_2358 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
BgL_arg2069z00_2359 = 
(((long)176) | BgL_nnz00_109); 
PROCEDURE_ENTRY(BgL_fun2070z00_2357)(BgL_fun2070z00_2357, BgL_arg2068z00_2358, 
BINT(BgL_arg2069z00_2359), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2072z00_2360;
BgL_fun2072z00_2360 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2071z00_2361;
BgL_arg2071z00_2361 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2072z00_2360)(BgL_fun2072z00_2360, BgL_arg2071z00_2361, 
BINT(BgL_kkz00_110), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2074z00_2362;
BgL_fun2074z00_2362 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2073z00_2363;
BgL_arg2073z00_2363 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2074z00_2362)(BgL_fun2074z00_2362, BgL_arg2073z00_2363, 
BINT(BgL_vvz00_111), BEOA);} } } 

}



/* &midiplayer-ctrlchange */
obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2925, obj_t BgL_mpz00_2926, obj_t BgL_msz00_2927, obj_t BgL_tickz00_2928, obj_t BgL_nnz00_2929, obj_t BgL_kkz00_2930, obj_t BgL_vvz00_2931)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1049 */
long BgL_auxz00_6589;long BgL_auxz00_6580;long BgL_auxz00_6571;long BgL_auxz00_6562;BgL_midisinkz00_bglt BgL_auxz00_6554;BgL_midiplayerz00_bglt BgL_auxz00_6546;
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6590;
if(
INTEGERP(BgL_vvz00_2931))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6590 = BgL_vvz00_2931
; }  else 
{ 
obj_t BgL_auxz00_6593;
BgL_auxz00_6593 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_vvz00_2931); 
FAILURE(BgL_auxz00_6593,BFALSE,BFALSE);} 
BgL_auxz00_6589 = 
(long)CINT(BgL_tmpz00_6590); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6581;
if(
INTEGERP(BgL_kkz00_2930))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6581 = BgL_kkz00_2930
; }  else 
{ 
obj_t BgL_auxz00_6584;
BgL_auxz00_6584 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_kkz00_2930); 
FAILURE(BgL_auxz00_6584,BFALSE,BFALSE);} 
BgL_auxz00_6580 = 
(long)CINT(BgL_tmpz00_6581); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6572;
if(
INTEGERP(BgL_nnz00_2929))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6572 = BgL_nnz00_2929
; }  else 
{ 
obj_t BgL_auxz00_6575;
BgL_auxz00_6575 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2929); 
FAILURE(BgL_auxz00_6575,BFALSE,BFALSE);} 
BgL_auxz00_6571 = 
(long)CINT(BgL_tmpz00_6572); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6563;
if(
INTEGERP(BgL_tickz00_2928))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6563 = BgL_tickz00_2928
; }  else 
{ 
obj_t BgL_auxz00_6566;
BgL_auxz00_6566 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2928); 
FAILURE(BgL_auxz00_6566,BFALSE,BFALSE);} 
BgL_auxz00_6562 = 
(long)CINT(BgL_tmpz00_6563); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2927, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6554 = 
((BgL_midisinkz00_bglt)BgL_msz00_2927)
; }  else 
{ 
obj_t BgL_auxz00_6558;
BgL_auxz00_6558 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2927); 
FAILURE(BgL_auxz00_6558,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2926, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6546 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2926)
; }  else 
{ 
obj_t BgL_auxz00_6550;
BgL_auxz00_6550 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string2819z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2926); 
FAILURE(BgL_auxz00_6550,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_auxz00_6546, BgL_auxz00_6554, BgL_auxz00_6562, BgL_auxz00_6571, BgL_auxz00_6580, BgL_auxz00_6589);} } 

}



/* midiplayer-prgmchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_112, BgL_midisinkz00_bglt BgL_msz00_113, long BgL_tickz00_114, long BgL_nnz00_115, long BgL_ppz00_116)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2065z00_2369;
BgL_fun2065z00_2369 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2063z00_2370;long BgL_arg2064z00_2371;
BgL_arg2063z00_2370 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
BgL_arg2064z00_2371 = 
(((long)192) | BgL_nnz00_115); 
PROCEDURE_ENTRY(BgL_fun2065z00_2369)(BgL_fun2065z00_2369, BgL_arg2063z00_2370, 
BINT(BgL_arg2064z00_2371), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2067z00_2372;
BgL_fun2067z00_2372 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2066z00_2373;
BgL_arg2066z00_2373 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2067z00_2372)(BgL_fun2067z00_2372, BgL_arg2066z00_2373, 
BINT(BgL_ppz00_116), BEOA);} } } 

}



/* &midiplayer-prgmchange */
obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_2932, obj_t BgL_mpz00_2933, obj_t BgL_msz00_2934, obj_t BgL_tickz00_2935, obj_t BgL_nnz00_2936, obj_t BgL_ppz00_2937)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1056 */
long BgL_auxz00_6650;long BgL_auxz00_6641;long BgL_auxz00_6632;BgL_midisinkz00_bglt BgL_auxz00_6624;BgL_midiplayerz00_bglt BgL_auxz00_6616;
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6651;
if(
INTEGERP(BgL_ppz00_2937))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6651 = BgL_ppz00_2937
; }  else 
{ 
obj_t BgL_auxz00_6654;
BgL_auxz00_6654 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string2820z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ppz00_2937); 
FAILURE(BgL_auxz00_6654,BFALSE,BFALSE);} 
BgL_auxz00_6650 = 
(long)CINT(BgL_tmpz00_6651); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6642;
if(
INTEGERP(BgL_nnz00_2936))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6642 = BgL_nnz00_2936
; }  else 
{ 
obj_t BgL_auxz00_6645;
BgL_auxz00_6645 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string2820z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2936); 
FAILURE(BgL_auxz00_6645,BFALSE,BFALSE);} 
BgL_auxz00_6641 = 
(long)CINT(BgL_tmpz00_6642); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6633;
if(
INTEGERP(BgL_tickz00_2935))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6633 = BgL_tickz00_2935
; }  else 
{ 
obj_t BgL_auxz00_6636;
BgL_auxz00_6636 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string2820z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2935); 
FAILURE(BgL_auxz00_6636,BFALSE,BFALSE);} 
BgL_auxz00_6632 = 
(long)CINT(BgL_tmpz00_6633); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2934, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6624 = 
((BgL_midisinkz00_bglt)BgL_msz00_2934)
; }  else 
{ 
obj_t BgL_auxz00_6628;
BgL_auxz00_6628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string2820z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2934); 
FAILURE(BgL_auxz00_6628,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2933, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6616 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2933)
; }  else 
{ 
obj_t BgL_auxz00_6620;
BgL_auxz00_6620 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string2820z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2933); 
FAILURE(BgL_auxz00_6620,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_auxz00_6616, BgL_auxz00_6624, BgL_auxz00_6632, BgL_auxz00_6641, BgL_auxz00_6650);} } 

}



/* midiplayer-after-touch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_117, BgL_midisinkz00_bglt BgL_msz00_118, long BgL_tickz00_119, long BgL_nnz00_120, long BgL_ppz00_121)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2065z00_2379;
BgL_fun2065z00_2379 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2063z00_2380;long BgL_arg2064z00_2381;
BgL_arg2063z00_2380 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
BgL_arg2064z00_2381 = 
(((long)208) | BgL_nnz00_120); 
PROCEDURE_ENTRY(BgL_fun2065z00_2379)(BgL_fun2065z00_2379, BgL_arg2063z00_2380, 
BINT(BgL_arg2064z00_2381), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2067z00_2382;
BgL_fun2067z00_2382 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2066z00_2383;
BgL_arg2066z00_2383 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2067z00_2382)(BgL_fun2067z00_2382, BgL_arg2066z00_2383, 
BINT(BgL_ppz00_121), BEOA);} } } 

}



/* &midiplayer-after-touch */
obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t BgL_envz00_2938, obj_t BgL_mpz00_2939, obj_t BgL_msz00_2940, obj_t BgL_tickz00_2941, obj_t BgL_nnz00_2942, obj_t BgL_ppz00_2943)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1063 */
long BgL_auxz00_6711;long BgL_auxz00_6702;long BgL_auxz00_6693;BgL_midisinkz00_bglt BgL_auxz00_6685;BgL_midiplayerz00_bglt BgL_auxz00_6677;
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6712;
if(
INTEGERP(BgL_ppz00_2943))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6712 = BgL_ppz00_2943
; }  else 
{ 
obj_t BgL_auxz00_6715;
BgL_auxz00_6715 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string2821z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ppz00_2943); 
FAILURE(BgL_auxz00_6715,BFALSE,BFALSE);} 
BgL_auxz00_6711 = 
(long)CINT(BgL_tmpz00_6712); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6703;
if(
INTEGERP(BgL_nnz00_2942))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6703 = BgL_nnz00_2942
; }  else 
{ 
obj_t BgL_auxz00_6706;
BgL_auxz00_6706 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string2821z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2942); 
FAILURE(BgL_auxz00_6706,BFALSE,BFALSE);} 
BgL_auxz00_6702 = 
(long)CINT(BgL_tmpz00_6703); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6694;
if(
INTEGERP(BgL_tickz00_2941))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6694 = BgL_tickz00_2941
; }  else 
{ 
obj_t BgL_auxz00_6697;
BgL_auxz00_6697 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string2821z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2941); 
FAILURE(BgL_auxz00_6697,BFALSE,BFALSE);} 
BgL_auxz00_6693 = 
(long)CINT(BgL_tmpz00_6694); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2940, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6685 = 
((BgL_midisinkz00_bglt)BgL_msz00_2940)
; }  else 
{ 
obj_t BgL_auxz00_6689;
BgL_auxz00_6689 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string2821z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2940); 
FAILURE(BgL_auxz00_6689,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2939, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6677 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2939)
; }  else 
{ 
obj_t BgL_auxz00_6681;
BgL_auxz00_6681 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string2821z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2939); 
FAILURE(BgL_auxz00_6681,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_auxz00_6677, BgL_auxz00_6685, BgL_auxz00_6693, BgL_auxz00_6702, BgL_auxz00_6711);} } 

}



/* midiplayer-pitch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_122, BgL_midisinkz00_bglt BgL_msz00_123, long BgL_tickz00_124, long BgL_nnz00_125, long BgL_ccz00_126, long BgL_vvz00_127)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2070z00_2390;
BgL_fun2070z00_2390 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2068z00_2391;long BgL_arg2069z00_2392;
BgL_arg2068z00_2391 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
BgL_arg2069z00_2392 = 
(((long)224) | BgL_nnz00_125); 
PROCEDURE_ENTRY(BgL_fun2070z00_2390)(BgL_fun2070z00_2390, BgL_arg2068z00_2391, 
BINT(BgL_arg2069z00_2392), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2072z00_2393;
BgL_fun2072z00_2393 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2071z00_2394;
BgL_arg2071z00_2394 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2072z00_2393)(BgL_fun2072z00_2393, BgL_arg2071z00_2394, 
BINT(BgL_ccz00_126), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2074z00_2395;
BgL_fun2074z00_2395 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2073z00_2396;
BgL_arg2073z00_2396 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2074z00_2395)(BgL_fun2074z00_2395, BgL_arg2073z00_2396, 
BINT(BgL_vvz00_127), BEOA);} } } 

}



/* &midiplayer-pitch */
obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2944, obj_t BgL_mpz00_2945, obj_t BgL_msz00_2946, obj_t BgL_tickz00_2947, obj_t BgL_nnz00_2948, obj_t BgL_ccz00_2949, obj_t BgL_vvz00_2950)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1070 */
long BgL_auxz00_6789;long BgL_auxz00_6780;long BgL_auxz00_6771;long BgL_auxz00_6762;BgL_midisinkz00_bglt BgL_auxz00_6754;BgL_midiplayerz00_bglt BgL_auxz00_6746;
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_6790;
if(
INTEGERP(BgL_vvz00_2950))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_6790 = BgL_vvz00_2950
; }  else 
{ 
obj_t BgL_auxz00_6793;
BgL_auxz00_6793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_vvz00_2950); 
FAILURE(BgL_auxz00_6793,BFALSE,BFALSE);} 
BgL_auxz00_6789 = 
(long)CINT(BgL_tmpz00_6790); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_6781;
if(
INTEGERP(BgL_ccz00_2949))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_6781 = BgL_ccz00_2949
; }  else 
{ 
obj_t BgL_auxz00_6784;
BgL_auxz00_6784 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ccz00_2949); 
FAILURE(BgL_auxz00_6784,BFALSE,BFALSE);} 
BgL_auxz00_6780 = 
(long)CINT(BgL_tmpz00_6781); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_6772;
if(
INTEGERP(BgL_nnz00_2948))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_6772 = BgL_nnz00_2948
; }  else 
{ 
obj_t BgL_auxz00_6775;
BgL_auxz00_6775 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_nnz00_2948); 
FAILURE(BgL_auxz00_6775,BFALSE,BFALSE);} 
BgL_auxz00_6771 = 
(long)CINT(BgL_tmpz00_6772); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_6763;
if(
INTEGERP(BgL_tickz00_2947))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_6763 = BgL_tickz00_2947
; }  else 
{ 
obj_t BgL_auxz00_6766;
BgL_auxz00_6766 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2947); 
FAILURE(BgL_auxz00_6766,BFALSE,BFALSE);} 
BgL_auxz00_6762 = 
(long)CINT(BgL_tmpz00_6763); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2946, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_6754 = 
((BgL_midisinkz00_bglt)BgL_msz00_2946)
; }  else 
{ 
obj_t BgL_auxz00_6758;
BgL_auxz00_6758 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2946); 
FAILURE(BgL_auxz00_6758,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2945, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_6746 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2945)
; }  else 
{ 
obj_t BgL_auxz00_6750;
BgL_auxz00_6750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string2822z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2945); 
FAILURE(BgL_auxz00_6750,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_auxz00_6746, BgL_auxz00_6754, BgL_auxz00_6762, BgL_auxz00_6771, BgL_auxz00_6780, BgL_auxz00_6789);} } 

}



/* midiplayer-sysex */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_128, BgL_midisinkz00_bglt BgL_msz00_129, long BgL_tickz00_130, obj_t BgL_dataz00_131)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1077 */
obj_t BgL_fun2076z00_2399;
BgL_fun2076z00_2399 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_writezd2stringzd2); 
{ /* Llib/midi.scm 1077 */
obj_t BgL_arg2075z00_2400;
BgL_arg2075z00_2400 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2076z00_2399)(BgL_fun2076z00_2399, BgL_arg2075z00_2400, BEOA);} } } 

}



/* &midiplayer-sysex */
obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t BgL_envz00_2951, obj_t BgL_mpz00_2952, obj_t BgL_msz00_2953, obj_t BgL_tickz00_2954, obj_t BgL_dataz00_2955)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1076 */
obj_t BgL_auxz00_6830;long BgL_auxz00_6821;BgL_midisinkz00_bglt BgL_auxz00_6813;BgL_midiplayerz00_bglt BgL_auxz00_6805;
if(
STRINGP(BgL_dataz00_2955))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_6830 = BgL_dataz00_2955
; }  else 
{ 
obj_t BgL_auxz00_6833;
BgL_auxz00_6833 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string2823z00zz__multimediazd2midizd2, BGl_string2783z00zz__multimediazd2midizd2, BgL_dataz00_2955); 
FAILURE(BgL_auxz00_6833,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1076 */
obj_t BgL_tmpz00_6822;
if(
INTEGERP(BgL_tickz00_2954))
{ /* Llib/midi.scm 1076 */
BgL_tmpz00_6822 = BgL_tickz00_2954
; }  else 
{ 
obj_t BgL_auxz00_6825;
BgL_auxz00_6825 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string2823z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_tickz00_2954); 
FAILURE(BgL_auxz00_6825,BFALSE,BFALSE);} 
BgL_auxz00_6821 = 
(long)CINT(BgL_tmpz00_6822); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_2953, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_6813 = 
((BgL_midisinkz00_bglt)BgL_msz00_2953)
; }  else 
{ 
obj_t BgL_auxz00_6817;
BgL_auxz00_6817 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string2823z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msz00_2953); 
FAILURE(BgL_auxz00_6817,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_2952, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_6805 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_2952)
; }  else 
{ 
obj_t BgL_auxz00_6809;
BgL_auxz00_6809 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string2823z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mpz00_2952); 
FAILURE(BgL_auxz00_6809,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_auxz00_6805, BgL_auxz00_6813, BgL_auxz00_6821, BgL_auxz00_6830);} } 

}



/* midi-note-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long BgL_kkz00_132)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_notez00_888;long BgL_octavez00_889;
{ /* Llib/midi.scm 1083 */
long BgL_arg2080z00_893;
{ /* Llib/midi.scm 1083 */
obj_t BgL_vectorz00_2401;
BgL_vectorz00_2401 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2080z00_893 = 
VECTOR_LENGTH(BgL_vectorz00_2401); } 
{ /* Llib/midi.scm 1083 */
long BgL_n1z00_2402;long BgL_n2z00_2403;
BgL_n1z00_2402 = BgL_kkz00_132; 
BgL_n2z00_2403 = BgL_arg2080z00_893; 
{ /* Llib/midi.scm 1083 */
bool_t BgL_test3448z00_6840;
{ /* Llib/midi.scm 1083 */
long BgL_arg1328z00_2405;
BgL_arg1328z00_2405 = 
(((BgL_n1z00_2402) | (BgL_n2z00_2403)) & -2147483648); 
BgL_test3448z00_6840 = 
(BgL_arg1328z00_2405==((long)0)); } 
if(BgL_test3448z00_6840)
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1325z00_2406;
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1326z00_2407;int32_t BgL_arg1327z00_2408;
BgL_arg1326z00_2407 = 
(int32_t)(BgL_n1z00_2402); 
BgL_arg1327z00_2408 = 
(int32_t)(BgL_n2z00_2403); 
BgL_arg1325z00_2406 = 
(BgL_arg1326z00_2407%BgL_arg1327z00_2408); } 
{ /* Llib/midi.scm 1083 */
long BgL_arg1425z00_2413;
BgL_arg1425z00_2413 = 
(long)(BgL_arg1325z00_2406); 
BgL_notez00_888 = 
(long)(BgL_arg1425z00_2413); } }  else 
{ /* Llib/midi.scm 1083 */
BgL_notez00_888 = 
(BgL_n1z00_2402%BgL_n2z00_2403); } } } } 
{ /* Llib/midi.scm 1084 */
long BgL_arg2081z00_894;
{ /* Llib/midi.scm 1084 */
obj_t BgL_vectorz00_2415;
BgL_vectorz00_2415 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2081z00_894 = 
VECTOR_LENGTH(BgL_vectorz00_2415); } 
BgL_octavez00_889 = 
(BgL_kkz00_132/BgL_arg2081z00_894); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2077z00_890;
{ /* Llib/midi.scm 1085 */
obj_t BgL_vectorz00_2418;
BgL_vectorz00_2418 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2077z00_890 = 
VECTOR_REF(BgL_vectorz00_2418,BgL_notez00_888); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_list2078z00_891;
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2079z00_892;
BgL_arg2079z00_892 = 
MAKE_YOUNG_PAIR(
BINT(BgL_octavez00_889), BNIL); 
BgL_list2078z00_891 = 
MAKE_YOUNG_PAIR(BgL_arg2077z00_890, BgL_arg2079z00_892); } 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2824z00zz__multimediazd2midizd2, BgL_list2078z00_891);} } } } 

}



/* &midi-note-name */
obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_2956, obj_t BgL_kkz00_2957)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_auxz00_6858;
{ /* Llib/midi.scm 1083 */
obj_t BgL_tmpz00_6859;
if(
INTEGERP(BgL_kkz00_2957))
{ /* Llib/midi.scm 1083 */
BgL_tmpz00_6859 = BgL_kkz00_2957
; }  else 
{ 
obj_t BgL_auxz00_6862;
BgL_auxz00_6862 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)42219)), BGl_string2825z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_kkz00_2957); 
FAILURE(BgL_auxz00_6862,BFALSE,BFALSE);} 
BgL_auxz00_6858 = 
(long)CINT(BgL_tmpz00_6859); } 
return 
BGl_midizd2notezd2namez00zz__multimediazd2midizd2(BgL_auxz00_6858);} } 

}



/* midi-controller-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long BgL_ccz00_133)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
bool_t BgL_test3450z00_6868;
{ /* Llib/midi.scm 1091 */
long BgL_arg2084z00_2421;
{ /* Llib/midi.scm 1091 */
obj_t BgL_vectorz00_2422;
BgL_vectorz00_2422 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2084z00_2421 = 
VECTOR_LENGTH(BgL_vectorz00_2422); } 
BgL_test3450z00_6868 = 
(BgL_ccz00_133<BgL_arg2084z00_2421); } 
if(BgL_test3450z00_6868)
{ /* Llib/midi.scm 1092 */
obj_t BgL_vectorz00_2425;
BgL_vectorz00_2425 = 
CNST_TABLE_REF(((long)1)); 
return 
VECTOR_REF(BgL_vectorz00_2425,BgL_ccz00_133);}  else 
{ /* Llib/midi.scm 1091 */
return BGl_string2826z00zz__multimediazd2midizd2;} } } 

}



/* &midi-controller-name */
obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_2958, obj_t BgL_ccz00_2959)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
long BgL_auxz00_6874;
{ /* Llib/midi.scm 1091 */
obj_t BgL_tmpz00_6875;
if(
INTEGERP(BgL_ccz00_2959))
{ /* Llib/midi.scm 1091 */
BgL_tmpz00_6875 = BgL_ccz00_2959
; }  else 
{ 
obj_t BgL_auxz00_6878;
BgL_auxz00_6878 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)42667)), BGl_string2827z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ccz00_2959); 
FAILURE(BgL_auxz00_6878,BFALSE,BFALSE);} 
BgL_auxz00_6874 = 
(long)CINT(BgL_tmpz00_6875); } 
return 
BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(BgL_auxz00_6874);} } 

}



/* midi-program-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long BgL_ppz00_134)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
bool_t BgL_test3452z00_6884;
{ /* Llib/midi.scm 1099 */
long BgL_arg2087z00_2428;
{ /* Llib/midi.scm 1099 */
obj_t BgL_vectorz00_2429;
BgL_vectorz00_2429 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2087z00_2428 = 
VECTOR_LENGTH(BgL_vectorz00_2429); } 
BgL_test3452z00_6884 = 
(BgL_ppz00_134<BgL_arg2087z00_2428); } 
if(BgL_test3452z00_6884)
{ /* Llib/midi.scm 1100 */
obj_t BgL_vectorz00_2432;
BgL_vectorz00_2432 = 
CNST_TABLE_REF(((long)2)); 
return 
VECTOR_REF(BgL_vectorz00_2432,BgL_ppz00_134);}  else 
{ /* Llib/midi.scm 1099 */
return BGl_string2828z00zz__multimediazd2midizd2;} } } 

}



/* &midi-program-name */
obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_2960, obj_t BgL_ppz00_2961)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
long BgL_auxz00_6890;
{ /* Llib/midi.scm 1099 */
obj_t BgL_tmpz00_6891;
if(
INTEGERP(BgL_ppz00_2961))
{ /* Llib/midi.scm 1099 */
BgL_tmpz00_6891 = BgL_ppz00_2961
; }  else 
{ 
obj_t BgL_auxz00_6894;
BgL_auxz00_6894 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)43056)), BGl_string2829z00zz__multimediazd2midizd2, BGl_string2786z00zz__multimediazd2midizd2, BgL_ppz00_2961); 
FAILURE(BgL_auxz00_6894,BFALSE,BFALSE);} 
BgL_auxz00_6890 = 
(long)CINT(BgL_tmpz00_6891); } 
return 
BGl_midizd2programzd2namez00zz__multimediazd2midizd2(BgL_auxz00_6890);} } 

}



/* midi-program-index */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t BgL_prgmz00_135)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
long BgL_g1176z00_901;
{ /* Llib/midi.scm 1107 */
long BgL_arg2094z00_911;
{ /* Llib/midi.scm 1107 */
obj_t BgL_vectorz00_2434;
BgL_vectorz00_2434 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2094z00_911 = 
VECTOR_LENGTH(BgL_vectorz00_2434); } 
BgL_g1176z00_901 = 
(BgL_arg2094z00_911-((long)1)); } 
{ 
long BgL_iz00_903;
BgL_iz00_903 = BgL_g1176z00_901; 
BgL_zc3z04anonymousza32088ze3z87_904:
if(
(BgL_iz00_903>=((long)0)))
{ /* Llib/midi.scm 1109 */
bool_t BgL_test3455z00_6905;
{ /* Llib/midi.scm 1109 */
obj_t BgL_arg2093z00_909;
{ /* Llib/midi.scm 1109 */
obj_t BgL_vectorz00_2437;
BgL_vectorz00_2437 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2093z00_909 = 
VECTOR_REF(BgL_vectorz00_2437,BgL_iz00_903); } 
BgL_test3455z00_6905 = 
bigloo_strcicmp(BgL_arg2093z00_909, BgL_prgmz00_135); } 
if(BgL_test3455z00_6905)
{ /* Llib/midi.scm 1109 */
return 
BINT(BgL_iz00_903);}  else 
{ 
long BgL_iz00_6910;
BgL_iz00_6910 = 
(BgL_iz00_903-((long)1)); 
BgL_iz00_903 = BgL_iz00_6910; 
goto BgL_zc3z04anonymousza32088ze3z87_904;} }  else 
{ /* Llib/midi.scm 1108 */
return BFALSE;} } } } 

}



/* &midi-program-index */
obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t BgL_envz00_2962, obj_t BgL_prgmz00_2963)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
obj_t BgL_auxz00_6912;
if(
STRINGP(BgL_prgmz00_2963))
{ /* Llib/midi.scm 1107 */
BgL_auxz00_6912 = BgL_prgmz00_2963
; }  else 
{ 
obj_t BgL_auxz00_6915;
BgL_auxz00_6915 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)43433)), BGl_string2830z00zz__multimediazd2midizd2, BGl_string2783z00zz__multimediazd2midizd2, BgL_prgmz00_2963); 
FAILURE(BgL_auxz00_6915,BFALSE,BFALSE);} 
return 
BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(BgL_auxz00_6912);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2112z00_936;obj_t BgL_arg2113z00_937;
{ /* Llib/midi.scm 17 */
obj_t BgL_v1221z00_952;
BgL_v1221z00_952 = 
create_vector(((long)4)); 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2120z00_953;
BgL_arg2120z00_953 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc2832z00zz__multimediazd2midizd2, BGl_proc2831z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_952,((long)0),BgL_arg2120z00_953); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2125z00_963;
BgL_arg2125z00_963 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc2835z00zz__multimediazd2midizd2, BGl_proc2834z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2833z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_952,((long)1),BgL_arg2125z00_963); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2132z00_976;
BgL_arg2132z00_976 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc2838z00zz__multimediazd2midizd2, BGl_proc2837z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2836z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_952,((long)2),BgL_arg2132z00_976); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2139z00_989;
BgL_arg2139z00_989 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2841z00zz__multimediazd2midizd2, BGl_proc2840z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2839z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1221z00_952,((long)3),BgL_arg2139z00_989); } 
BgL_arg2112z00_936 = BgL_v1221z00_952; } 
{ /* Llib/midi.scm 17 */
obj_t BgL_v1222z00_1002;
BgL_v1222z00_1002 = 
create_vector(((long)0)); 
BgL_arg2113z00_937 = BgL_v1222z00_1002; } 
BGl_midiscorez00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)54602), BGl_proc2844z00zz__multimediazd2midizd2, BGl_proc2843z00zz__multimediazd2midizd2, BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc2842z00zz__multimediazd2midizd2, BFALSE, BgL_arg2112z00_936, BgL_arg2113z00_937); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2149z00_1009;obj_t BgL_arg2150z00_1010;
{ /* Llib/midi.scm 24 */
obj_t BgL_v1223z00_1035;
BgL_v1223z00_1035 = 
create_vector(((long)14)); 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2157z00_1036;
BgL_arg2157z00_1036 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2847z00zz__multimediazd2midizd2, BGl_proc2846z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2845z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1223z00_1035,((long)0),BgL_arg2157z00_1036); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2164z00_1049;
BgL_arg2164z00_1049 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc2849z00zz__multimediazd2midizd2, BGl_proc2848z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_midireaderz00zz__multimediazd2midizd2); 
VECTOR_SET(BgL_v1223z00_1035,((long)1),BgL_arg2164z00_1049); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2169z00_1059;
BgL_arg2169z00_1059 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc2851z00zz__multimediazd2midizd2, BGl_proc2850z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1035,((long)2),BgL_arg2169z00_1059); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2174z00_1069;
BgL_arg2174z00_1069 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc2854z00zz__multimediazd2midizd2, BGl_proc2853z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2852z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1223z00_1035,((long)3),BgL_arg2174z00_1069); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2182z00_1082;
BgL_arg2182z00_1082 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc2857z00zz__multimediazd2midizd2, BGl_proc2856z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2855z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1223z00_1035,((long)4),BgL_arg2182z00_1082); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2189z00_1095;
BgL_arg2189z00_1095 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2860z00zz__multimediazd2midizd2, BGl_proc2859z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2858z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1223z00_1035,((long)5),BgL_arg2189z00_1095); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2196z00_1108;
BgL_arg2196z00_1108 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2863z00zz__multimediazd2midizd2, BGl_proc2862z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2861z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1223z00_1035,((long)6),BgL_arg2196z00_1108); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2203z00_1121;
BgL_arg2203z00_1121 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc2866z00zz__multimediazd2midizd2, BGl_proc2865z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2864z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1223z00_1035,((long)7),BgL_arg2203z00_1121); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2210z00_1134;
BgL_arg2210z00_1134 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc2869z00zz__multimediazd2midizd2, BGl_proc2868z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2867z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1223z00_1035,((long)8),BgL_arg2210z00_1134); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2217z00_1147;
BgL_arg2217z00_1147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc2872z00zz__multimediazd2midizd2, BGl_proc2871z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2870z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1223z00_1035,((long)9),BgL_arg2217z00_1147); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2224z00_1160;
BgL_arg2224z00_1160 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc2875z00zz__multimediazd2midizd2, BGl_proc2874z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2873z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1223z00_1035,((long)10),BgL_arg2224z00_1160); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2231z00_1173;
BgL_arg2231z00_1173 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2878z00zz__multimediazd2midizd2, BGl_proc2877z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2876z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1223z00_1035,((long)11),BgL_arg2231z00_1173); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2238z00_1186;
BgL_arg2238z00_1186 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2881z00zz__multimediazd2midizd2, BGl_proc2880z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2879z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1223z00_1035,((long)12),BgL_arg2238z00_1186); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2245z00_1199;
BgL_arg2245z00_1199 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc2884z00zz__multimediazd2midizd2, BGl_proc2883z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2882z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1223z00_1035,((long)13),BgL_arg2245z00_1199); } 
BgL_arg2149z00_1009 = BgL_v1223z00_1035; } 
{ /* Llib/midi.scm 24 */
obj_t BgL_v1224z00_1212;
BgL_v1224z00_1212 = 
create_vector(((long)0)); 
BgL_arg2150z00_1010 = BgL_v1224z00_1212; } 
BGl_miditrackz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)26896), BGl_proc2887z00zz__multimediazd2midizd2, BGl_proc2886z00zz__multimediazd2midizd2, BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc2885z00zz__multimediazd2midizd2, BFALSE, BgL_arg2149z00_1009, BgL_arg2150z00_1010); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2255z00_1219;obj_t BgL_arg2256z00_1220;
{ /* Llib/midi.scm 42 */
obj_t BgL_v1225z00_1238;
BgL_v1225z00_1238 = 
create_vector(((long)7)); 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2263z00_1239;
BgL_arg2263z00_1239 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc2889z00zz__multimediazd2midizd2, BGl_proc2888z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)0),BgL_arg2263z00_1239); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2268z00_1249;
BgL_arg2268z00_1249 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc2891z00zz__multimediazd2midizd2, BGl_proc2890z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)1),BgL_arg2268z00_1249); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2273z00_1259;
BgL_arg2273z00_1259 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc2893z00zz__multimediazd2midizd2, BGl_proc2892z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)2),BgL_arg2273z00_1259); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2278z00_1269;
BgL_arg2278z00_1269 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc2895z00zz__multimediazd2midizd2, BGl_proc2894z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)3),BgL_arg2278z00_1269); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2283z00_1279;
BgL_arg2283z00_1279 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc2897z00zz__multimediazd2midizd2, BGl_proc2896z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)4),BgL_arg2283z00_1279); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2288z00_1289;
BgL_arg2288z00_1289 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2899z00zz__multimediazd2midizd2, BGl_proc2898z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)5),BgL_arg2288z00_1289); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2293z00_1299;
BgL_arg2293z00_1299 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc2901z00zz__multimediazd2midizd2, BGl_proc2900z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1238,((long)6),BgL_arg2293z00_1299); } 
BgL_arg2255z00_1219 = BgL_v1225z00_1238; } 
{ /* Llib/midi.scm 42 */
obj_t BgL_v1226z00_1309;
BgL_v1226z00_1309 = 
create_vector(((long)0)); 
BgL_arg2256z00_1220 = BgL_v1226z00_1309; } 
BGl_midireaderz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)53877), BGl_proc2904z00zz__multimediazd2midizd2, BGl_proc2903z00zz__multimediazd2midizd2, BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc2902z00zz__multimediazd2midizd2, BFALSE, BgL_arg2255z00_1219, BgL_arg2256z00_1220); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2301z00_1316;obj_t BgL_arg2302z00_1317;
{ /* Llib/midi.scm 52 */
obj_t BgL_v1227z00_1356;
BgL_v1227z00_1356 = 
create_vector(((long)28)); 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2309z00_1357;
BgL_arg2309z00_1357 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc2907z00zz__multimediazd2midizd2, BGl_proc2906z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2905z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)0),BgL_arg2309z00_1357); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2316z00_1370;
BgL_arg2316z00_1370 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc2910z00zz__multimediazd2midizd2, BGl_proc2909z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2908z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)1),BgL_arg2316z00_1370); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2323z00_1383;
BgL_arg2323z00_1383 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc2913z00zz__multimediazd2midizd2, BGl_proc2912z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2911z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)2),BgL_arg2323z00_1383); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2330z00_1396;
BgL_arg2330z00_1396 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc2916z00zz__multimediazd2midizd2, BGl_proc2915z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2914z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)3),BgL_arg2330z00_1396); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2337z00_1409;
BgL_arg2337z00_1409 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc2919z00zz__multimediazd2midizd2, BGl_proc2918z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2917z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)4),BgL_arg2337z00_1409); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2344z00_1422;
BgL_arg2344z00_1422 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc2922z00zz__multimediazd2midizd2, BGl_proc2921z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2920z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)5),BgL_arg2344z00_1422); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2351z00_1435;
BgL_arg2351z00_1435 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc2925z00zz__multimediazd2midizd2, BGl_proc2924z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2923z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)6),BgL_arg2351z00_1435); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2358z00_1448;
BgL_arg2358z00_1448 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc2928z00zz__multimediazd2midizd2, BGl_proc2927z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2926z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)7),BgL_arg2358z00_1448); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2365z00_1461;
BgL_arg2365z00_1461 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc2931z00zz__multimediazd2midizd2, BGl_proc2930z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2929z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)8),BgL_arg2365z00_1461); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2372z00_1474;
BgL_arg2372z00_1474 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc2934z00zz__multimediazd2midizd2, BGl_proc2933z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2932z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)9),BgL_arg2372z00_1474); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2379z00_1487;
BgL_arg2379z00_1487 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc2937z00zz__multimediazd2midizd2, BGl_proc2936z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2935z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)10),BgL_arg2379z00_1487); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2386z00_1500;
BgL_arg2386z00_1500 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc2940z00zz__multimediazd2midizd2, BGl_proc2939z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2938z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)11),BgL_arg2386z00_1500); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2393z00_1513;
BgL_arg2393z00_1513 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc2943z00zz__multimediazd2midizd2, BGl_proc2942z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2941z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)12),BgL_arg2393z00_1513); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2400z00_1526;
BgL_arg2400z00_1526 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc2946z00zz__multimediazd2midizd2, BGl_proc2945z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2944z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)13),BgL_arg2400z00_1526); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2407z00_1539;
BgL_arg2407z00_1539 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc2949z00zz__multimediazd2midizd2, BGl_proc2948z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2947z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)14),BgL_arg2407z00_1539); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2414z00_1552;
BgL_arg2414z00_1552 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2952z00zz__multimediazd2midizd2, BGl_proc2951z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2950z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)15),BgL_arg2414z00_1552); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2421z00_1565;
BgL_arg2421z00_1565 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc2955z00zz__multimediazd2midizd2, BGl_proc2954z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2953z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)16),BgL_arg2421z00_1565); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2428z00_1578;
BgL_arg2428z00_1578 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc2958z00zz__multimediazd2midizd2, BGl_proc2957z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2956z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)17),BgL_arg2428z00_1578); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2435z00_1591;
BgL_arg2435z00_1591 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc2961z00zz__multimediazd2midizd2, BGl_proc2960z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2959z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)18),BgL_arg2435z00_1591); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2442z00_1604;
BgL_arg2442z00_1604 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2964z00zz__multimediazd2midizd2, BGl_proc2963z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2962z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)19),BgL_arg2442z00_1604); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2449z00_1617;
BgL_arg2449z00_1617 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc2967z00zz__multimediazd2midizd2, BGl_proc2966z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2965z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)20),BgL_arg2449z00_1617); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2456z00_1630;
BgL_arg2456z00_1630 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc2970z00zz__multimediazd2midizd2, BGl_proc2969z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2968z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)21),BgL_arg2456z00_1630); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2463z00_1643;
BgL_arg2463z00_1643 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc2973z00zz__multimediazd2midizd2, BGl_proc2972z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2971z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)22),BgL_arg2463z00_1643); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2470z00_1656;
BgL_arg2470z00_1656 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc2976z00zz__multimediazd2midizd2, BGl_proc2975z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2974z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)23),BgL_arg2470z00_1656); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2477z00_1669;
BgL_arg2477z00_1669 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc2979z00zz__multimediazd2midizd2, BGl_proc2978z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2977z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)24),BgL_arg2477z00_1669); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2485z00_1691;
BgL_arg2485z00_1691 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc2982z00zz__multimediazd2midizd2, BGl_proc2981z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2980z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)25),BgL_arg2485z00_1691); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2493z00_1712;
BgL_arg2493z00_1712 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc2985z00zz__multimediazd2midizd2, BGl_proc2984z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2983z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)26),BgL_arg2493z00_1712); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2500z00_1725;
BgL_arg2500z00_1725 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc2988z00zz__multimediazd2midizd2, BGl_proc2987z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2986z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1356,((long)27),BgL_arg2500z00_1725); } 
BgL_arg2301z00_1316 = BgL_v1227z00_1356; } 
{ /* Llib/midi.scm 52 */
obj_t BgL_v1228z00_1738;
BgL_v1228z00_1738 = 
create_vector(((long)0)); 
BgL_arg2302z00_1317 = BgL_v1228z00_1738; } 
BGl_midiplayerz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)52705), BGl_proc2991z00zz__multimediazd2midizd2, BGl_proc2990z00zz__multimediazd2midizd2, BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc2989z00zz__multimediazd2midizd2, BFALSE, BgL_arg2301z00_1316, BgL_arg2302z00_1317); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2510z00_1745;obj_t BgL_arg2511z00_1746;
{ /* Llib/midi.scm 87 */
obj_t BgL_v1229z00_1762;
BgL_v1229z00_1762 = 
create_vector(((long)5)); 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2518z00_1763;
BgL_arg2518z00_1763 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc2994z00zz__multimediazd2midizd2, BGl_proc2993z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2992z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1229z00_1762,((long)0),BgL_arg2518z00_1763); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2525z00_1776;
BgL_arg2525z00_1776 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc2997z00zz__multimediazd2midizd2, BGl_proc2996z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2995z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1229z00_1762,((long)1),BgL_arg2525z00_1776); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2532z00_1789;
BgL_arg2532z00_1789 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3000z00zz__multimediazd2midizd2, BGl_proc2999z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2998z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1229z00_1762,((long)2),BgL_arg2532z00_1789); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2540z00_1805;
BgL_arg2540z00_1805 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3003z00zz__multimediazd2midizd2, BGl_proc3002z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3001z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1229z00_1762,((long)3),BgL_arg2540z00_1805); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2548z00_1821;
BgL_arg2548z00_1821 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3006z00zz__multimediazd2midizd2, BGl_proc3005z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3004z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1229z00_1762,((long)4),BgL_arg2548z00_1821); } 
BgL_arg2510z00_1745 = BgL_v1229z00_1762; } 
{ /* Llib/midi.scm 87 */
obj_t BgL_v1230z00_1834;
BgL_v1230z00_1834 = 
create_vector(((long)0)); 
BgL_arg2511z00_1746 = BgL_v1230z00_1834; } 
return ( 
BGl_midisinkz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)13783), BGl_proc3009z00zz__multimediazd2midizd2, BGl_proc3008z00zz__multimediazd2midizd2, BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3007z00zz__multimediazd2midizd2, BFALSE, BgL_arg2510z00_1745, BgL_arg2511z00_1746), BUNSPEC) ;} } 

}



/* &<@anonymous:2517> */
obj_t BGl_z62zc3z04anonymousza32517ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3158, obj_t BgL_new1119z00_3159)
{
{ /* Llib/midi.scm 87 */
{ 
BgL_midisinkz00_bglt BgL_auxz00_7176;
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3159)))->BgL_streamz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3159)))->BgL_usleepz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3159)))->BgL_writezd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3159)))->BgL_writezd2stringzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1119z00_3159)))->BgL_flushz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7176 = 
((BgL_midisinkz00_bglt)BgL_new1119z00_3159); 
return 
((obj_t)BgL_auxz00_7176);} } 

}



/* &lambda2515 */
BgL_midisinkz00_bglt BGl_z62lambda2515z62zz__multimediazd2midizd2(obj_t BgL_envz00_3160)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1118z00_3930;
BgL_new1118z00_3930 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2516z00_3931;
BgL_arg2516z00_3931 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1118z00_3930), BgL_arg2516z00_3931); } 
return BgL_new1118z00_3930;} } 

}



/* &lambda2512 */
BgL_midisinkz00_bglt BGl_z62lambda2512z62zz__multimediazd2midizd2(obj_t BgL_envz00_3161, obj_t BgL_stream1113z00_3162, obj_t BgL_usleep1114z00_3163, obj_t BgL_writezd2byte1115zd2_3164, obj_t BgL_writezd2string1116zd2_3165, obj_t BgL_flush1117z00_3166)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1186z00_3936;
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1185z00_3937;
BgL_new1185z00_3937 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2514z00_3938;
BgL_arg2514z00_3938 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1185z00_3937), BgL_arg2514z00_3938); } 
BgL_new1186z00_3936 = BgL_new1185z00_3937; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1186z00_3936))->BgL_streamz00)=((obj_t)BgL_stream1113z00_3162),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1186z00_3936))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_usleep1114z00_3163)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1186z00_3936))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_writezd2byte1115zd2_3164)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1186z00_3936))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_writezd2string1116zd2_3165)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1186z00_3936))->BgL_flushz00)=((obj_t)
((obj_t)BgL_flush1117z00_3166)),BUNSPEC); 
{ /* Llib/midi.scm 87 */
obj_t BgL_fun2513z00_3939;
BgL_fun2513z00_3939 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2513z00_3939)(BgL_fun2513z00_3939, 
((obj_t)BgL_new1186z00_3936), BEOA); } 
return BgL_new1186z00_3936;} } 

}



/* &<@anonymous:2554> */
obj_t BGl_z62zc3z04anonymousza32554ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3167)
{
{ /* Llib/midi.scm 87 */
return BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;} 

}



/* &lambda2553 */
obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t BgL_envz00_3168, obj_t BgL_oz00_3169, obj_t BgL_vz00_3170)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3169)))->BgL_flushz00)=((obj_t)
((obj_t)BgL_vz00_3170)),BUNSPEC);} 

}



/* &lambda2552 */
obj_t BGl_z62lambda2552z62zz__multimediazd2midizd2(obj_t BgL_envz00_3171, obj_t BgL_oz00_3172)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3172)))->BgL_flushz00);} 

}



/* &<@anonymous:2546> */
obj_t BGl_z62zc3z04anonymousza32546ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3173)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3010z00zz__multimediazd2midizd2;} 

}



/* &lambda2545 */
obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t BgL_envz00_3174, obj_t BgL_oz00_3175, obj_t BgL_vz00_3176)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3175)))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_vz00_3176)),BUNSPEC);} 

}



/* &lambda2544 */
obj_t BGl_z62lambda2544z62zz__multimediazd2midizd2(obj_t BgL_envz00_3177, obj_t BgL_oz00_3178)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3178)))->BgL_writezd2stringzd2);} 

}



/* &<@anonymous:2547> */
obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3179, obj_t BgL_opz00_3180, obj_t BgL_sz00_3181)
{
{ /* Llib/midi.scm 92 */
return 
BGl_writezd2stringzd2zz__r4_output_6_10_3z00(BgL_sz00_3181, BgL_opz00_3180);} 

}



/* &<@anonymous:2538> */
obj_t BGl_z62zc3z04anonymousza32538ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3182)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3011z00zz__multimediazd2midizd2;} 

}



/* &lambda2537 */
obj_t BGl_z62lambda2537z62zz__multimediazd2midizd2(obj_t BgL_envz00_3183, obj_t BgL_oz00_3184, obj_t BgL_vz00_3185)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3184)))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3185)),BUNSPEC);} 

}



/* &lambda2536 */
obj_t BGl_z62lambda2536z62zz__multimediazd2midizd2(obj_t BgL_envz00_3186, obj_t BgL_oz00_3187)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3187)))->BgL_writezd2bytezd2);} 

}



/* &<@anonymous:2539> */
obj_t BGl_z62zc3z04anonymousza32539ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3188, obj_t BgL_opz00_3189, obj_t BgL_bz00_3190)
{
{ /* Llib/midi.scm 91 */
{ /* Llib/midi.scm 91 */
unsigned char BgL_bytez00_3949;
BgL_bytez00_3949 = 
(unsigned char)CINT(BgL_bz00_3190); 
{ /* Llib/midi.scm 91 */
obj_t BgL_tmpz00_7229;
BgL_tmpz00_7229 = 
((obj_t)BgL_opz00_3189); 
return 
bgl_display_char(BgL_bytez00_3949, BgL_tmpz00_7229);} } } 

}



/* &<@anonymous:2531> */
obj_t BGl_z62zc3z04anonymousza32531ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3191)
{
{ /* Llib/midi.scm 87 */
return BGl_sleepzd2envzd2zz__osz00;} 

}



/* &lambda2530 */
obj_t BGl_z62lambda2530z62zz__multimediazd2midizd2(obj_t BgL_envz00_3192, obj_t BgL_oz00_3193, obj_t BgL_vz00_3194)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3193)))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_vz00_3194)),BUNSPEC);} 

}



/* &lambda2529 */
obj_t BGl_z62lambda2529z62zz__multimediazd2midizd2(obj_t BgL_envz00_3195, obj_t BgL_oz00_3196)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3196)))->BgL_usleepz00);} 

}



/* &<@anonymous:2524> */
obj_t BGl_z62zc3z04anonymousza32524ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3197)
{
{ /* Llib/midi.scm 87 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2523 */
obj_t BGl_z62lambda2523z62zz__multimediazd2midizd2(obj_t BgL_envz00_3198, obj_t BgL_oz00_3199, obj_t BgL_vz00_3200)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3199)))->BgL_streamz00)=((obj_t)BgL_vz00_3200),BUNSPEC);} 

}



/* &lambda2522 */
obj_t BGl_z62lambda2522z62zz__multimediazd2midizd2(obj_t BgL_envz00_3201, obj_t BgL_oz00_3202)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3202)))->BgL_streamz00);} 

}



/* &<@anonymous:2308> */
obj_t BGl_z62zc3z04anonymousza32308ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3203, obj_t BgL_new1111z00_3204)
{
{ /* Llib/midi.scm 52 */
{ 
BgL_midiplayerz00_bglt BgL_auxz00_7242;
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_errz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_cdelayz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_noteoffz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_noteonz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_aftertouchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_ctrlchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_prgmchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_afterzd2touchzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_pitchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_sysexz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2seqnumzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2textzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2copyrightzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2trackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2instrumentzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2lyriczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2markerzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2cuezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2prgmnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2devnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2channprefzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2midiportzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2eotzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2tempozd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2smtpezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2timesigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2keysigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204)))->BgL_metazd2seqspeczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7242 = 
((BgL_midiplayerz00_bglt)BgL_new1111z00_3204); 
return 
((obj_t)BgL_auxz00_7242);} } 

}



/* &lambda2306 */
BgL_midiplayerz00_bglt BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t BgL_envz00_3205)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1110z00_3956;
BgL_new1110z00_3956 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2307z00_3957;
BgL_arg2307z00_3957 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_3956), BgL_arg2307z00_3957); } 
return BgL_new1110z00_3956;} } 

}



/* &lambda2303 */
BgL_midiplayerz00_bglt BGl_z62lambda2303z62zz__multimediazd2midizd2(obj_t BgL_envz00_3206, obj_t BgL_err1082z00_3207, obj_t BgL_cdelay1083z00_3208, obj_t BgL_noteoff1084z00_3209, obj_t BgL_noteon1085z00_3210, obj_t BgL_aftertouch1086z00_3211, obj_t BgL_ctrlchange1087z00_3212, obj_t BgL_prgmchange1088z00_3213, obj_t BgL_afterzd2touch1089zd2_3214, obj_t BgL_pitch1090z00_3215, obj_t BgL_sysex1091z00_3216, obj_t BgL_metazd2seqnum1092zd2_3217, obj_t BgL_metazd2text1093zd2_3218, obj_t BgL_metazd2copyright1094zd2_3219, obj_t BgL_metazd2track1095zd2_3220, obj_t BgL_metazd2instrument1096zd2_3221, obj_t BgL_metazd2lyric1097zd2_3222, obj_t BgL_metazd2marker1098zd2_3223, obj_t BgL_metazd2cue1099zd2_3224, obj_t BgL_metazd2prgmname1100zd2_3225, obj_t BgL_metazd2devname1101zd2_3226, obj_t BgL_metazd2channpref1102zd2_3227, obj_t BgL_metazd2midiport1103zd2_3228, obj_t BgL_metazd2eot1104zd2_3229, obj_t BgL_metazd2tempo1105zd2_3230, obj_t BgL_metazd2smtpe1106zd2_3231, obj_t BgL_metazd2timesig1107zd2_3232, obj_t BgL_metazd2keysig1108zd2_3233, obj_t BgL_metazd2seqspec1109zd2_3234)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1184z00_3986;
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1183z00_3987;
BgL_new1183z00_3987 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2305z00_3988;
BgL_arg2305z00_3988 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1183z00_3987), BgL_arg2305z00_3988); } 
BgL_new1184z00_3986 = BgL_new1183z00_3987; } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_errz00)=((obj_t)
((obj_t)BgL_err1082z00_3207)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_cdelay1083z00_3208)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_noteoff1084z00_3209)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_noteon1085z00_3210)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_aftertouch1086z00_3211)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_ctrlchange1087z00_3212)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_prgmchange1088z00_3213)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_afterzd2touch1089zd2_3214)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_pitch1090z00_3215)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_sysex1091z00_3216)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_metazd2seqnum1092zd2_3217)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_metazd2text1093zd2_3218)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_metazd2copyright1094zd2_3219)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_metazd2track1095zd2_3220)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_metazd2instrument1096zd2_3221)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_metazd2lyric1097zd2_3222)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_metazd2marker1098zd2_3223)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_metazd2cue1099zd2_3224)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_metazd2prgmname1100zd2_3225)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_metazd2devname1101zd2_3226)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_metazd2channpref1102zd2_3227)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_metazd2midiport1103zd2_3228)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_metazd2eot1104zd2_3229)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_metazd2tempo1105zd2_3230)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_metazd2smtpe1106zd2_3231)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_metazd2timesig1107zd2_3232)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_metazd2keysig1108zd2_3233)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1184z00_3986))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_metazd2seqspec1109zd2_3234)),BUNSPEC); 
{ /* Llib/midi.scm 52 */
obj_t BgL_fun2304z00_3989;
BgL_fun2304z00_3989 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2304z00_3989)(BgL_fun2304z00_3989, 
((obj_t)BgL_new1184z00_3986), BEOA); } 
return BgL_new1184z00_3986;} } 

}



/* &<@anonymous:2506> */
obj_t BGl_z62zc3z04anonymousza32506ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3235)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2505 */
obj_t BGl_z62lambda2505z62zz__multimediazd2midizd2(obj_t BgL_envz00_3236, obj_t BgL_oz00_3237, obj_t BgL_vz00_3238)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3237)))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_vz00_3238)),BUNSPEC);} 

}



/* &lambda2504 */
obj_t BGl_z62lambda2504z62zz__multimediazd2midizd2(obj_t BgL_envz00_3239, obj_t BgL_oz00_3240)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3240)))->BgL_metazd2seqspeczd2);} 

}



/* &<@anonymous:2499> */
obj_t BGl_z62zc3z04anonymousza32499ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3241)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2498 */
obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t BgL_envz00_3242, obj_t BgL_oz00_3243, obj_t BgL_vz00_3244)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3243)))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_vz00_3244)),BUNSPEC);} 

}



/* &lambda2497 */
obj_t BGl_z62lambda2497z62zz__multimediazd2midizd2(obj_t BgL_envz00_3245, obj_t BgL_oz00_3246)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3246)))->BgL_metazd2keysigzd2);} 

}



/* &<@anonymous:2491> */
obj_t BGl_z62zc3z04anonymousza32491ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3247)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3012z00zz__multimediazd2midizd2;} 

}



/* &lambda2490 */
obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t BgL_envz00_3248, obj_t BgL_oz00_3249, obj_t BgL_vz00_3250)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3249)))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_vz00_3250)),BUNSPEC);} 

}



/* &lambda2489 */
obj_t BGl_z62lambda2489z62zz__multimediazd2midizd2(obj_t BgL_envz00_3251, obj_t BgL_oz00_3252)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3252)))->BgL_metazd2timesigzd2);} 

}



/* &<@anonymous:2492> */
obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3253, obj_t BgL_mpz00_3254, obj_t BgL_msz00_3255, obj_t BgL_tickz00_3256, obj_t BgL_nnz00_3257, obj_t BgL_ddz00_3258, obj_t BgL_ccz00_3259, obj_t BgL_bbz00_3260)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2483> */
obj_t BGl_z62zc3z04anonymousza32483ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3261)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3013z00zz__multimediazd2midizd2;} 

}



/* &lambda2482 */
obj_t BGl_z62lambda2482z62zz__multimediazd2midizd2(obj_t BgL_envz00_3262, obj_t BgL_oz00_3263, obj_t BgL_vz00_3264)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3263)))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_vz00_3264)),BUNSPEC);} 

}



/* &lambda2481 */
obj_t BGl_z62lambda2481z62zz__multimediazd2midizd2(obj_t BgL_envz00_3265, obj_t BgL_oz00_3266)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3266)))->BgL_metazd2smtpezd2);} 

}



/* &<@anonymous:2484> */
obj_t BGl_z62zc3z04anonymousza32484ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3267, obj_t BgL_mpz00_3268, obj_t BgL_msz00_3269, obj_t BgL_tickz00_3270, obj_t BgL_hrz00_3271, obj_t BgL_mmz00_3272, obj_t BgL_sez00_3273, obj_t BgL_frz00_3274, obj_t BgL_ffz00_3275)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2476> */
obj_t BGl_z62zc3z04anonymousza32476ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3276)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2475 */
obj_t BGl_z62lambda2475z62zz__multimediazd2midizd2(obj_t BgL_envz00_3277, obj_t BgL_oz00_3278, obj_t BgL_vz00_3279)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3278)))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_vz00_3279)),BUNSPEC);} 

}



/* &lambda2474 */
obj_t BGl_z62lambda2474z62zz__multimediazd2midizd2(obj_t BgL_envz00_3280, obj_t BgL_oz00_3281)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3281)))->BgL_metazd2tempozd2);} 

}



/* &<@anonymous:2469> */
obj_t BGl_z62zc3z04anonymousza32469ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3282)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2468 */
obj_t BGl_z62lambda2468z62zz__multimediazd2midizd2(obj_t BgL_envz00_3283, obj_t BgL_oz00_3284, obj_t BgL_vz00_3285)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3284)))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_vz00_3285)),BUNSPEC);} 

}



/* &lambda2467 */
obj_t BGl_z62lambda2467z62zz__multimediazd2midizd2(obj_t BgL_envz00_3286, obj_t BgL_oz00_3287)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3287)))->BgL_metazd2eotzd2);} 

}



/* &<@anonymous:2462> */
obj_t BGl_z62zc3z04anonymousza32462ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3288)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2461 */
obj_t BGl_z62lambda2461z62zz__multimediazd2midizd2(obj_t BgL_envz00_3289, obj_t BgL_oz00_3290, obj_t BgL_vz00_3291)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3290)))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_vz00_3291)),BUNSPEC);} 

}



/* &lambda2460 */
obj_t BGl_z62lambda2460z62zz__multimediazd2midizd2(obj_t BgL_envz00_3292, obj_t BgL_oz00_3293)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3293)))->BgL_metazd2midiportzd2);} 

}



/* &<@anonymous:2455> */
obj_t BGl_z62zc3z04anonymousza32455ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3294)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2454 */
obj_t BGl_z62lambda2454z62zz__multimediazd2midizd2(obj_t BgL_envz00_3295, obj_t BgL_oz00_3296, obj_t BgL_vz00_3297)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3296)))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_vz00_3297)),BUNSPEC);} 

}



/* &lambda2453 */
obj_t BGl_z62lambda2453z62zz__multimediazd2midizd2(obj_t BgL_envz00_3298, obj_t BgL_oz00_3299)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3299)))->BgL_metazd2channprefzd2);} 

}



/* &<@anonymous:2448> */
obj_t BGl_z62zc3z04anonymousza32448ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3300)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2447 */
obj_t BGl_z62lambda2447z62zz__multimediazd2midizd2(obj_t BgL_envz00_3301, obj_t BgL_oz00_3302, obj_t BgL_vz00_3303)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3302)))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_vz00_3303)),BUNSPEC);} 

}



/* &lambda2446 */
obj_t BGl_z62lambda2446z62zz__multimediazd2midizd2(obj_t BgL_envz00_3304, obj_t BgL_oz00_3305)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3305)))->BgL_metazd2devnamezd2);} 

}



/* &<@anonymous:2441> */
obj_t BGl_z62zc3z04anonymousza32441ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3306)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2440 */
obj_t BGl_z62lambda2440z62zz__multimediazd2midizd2(obj_t BgL_envz00_3307, obj_t BgL_oz00_3308, obj_t BgL_vz00_3309)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3308)))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_vz00_3309)),BUNSPEC);} 

}



/* &lambda2439 */
obj_t BGl_z62lambda2439z62zz__multimediazd2midizd2(obj_t BgL_envz00_3310, obj_t BgL_oz00_3311)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3311)))->BgL_metazd2prgmnamezd2);} 

}



/* &<@anonymous:2434> */
obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3312)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2433 */
obj_t BGl_z62lambda2433z62zz__multimediazd2midizd2(obj_t BgL_envz00_3313, obj_t BgL_oz00_3314, obj_t BgL_vz00_3315)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3314)))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_vz00_3315)),BUNSPEC);} 

}



/* &lambda2432 */
obj_t BGl_z62lambda2432z62zz__multimediazd2midizd2(obj_t BgL_envz00_3316, obj_t BgL_oz00_3317)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3317)))->BgL_metazd2cuezd2);} 

}



/* &<@anonymous:2427> */
obj_t BGl_z62zc3z04anonymousza32427ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3318)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2426 */
obj_t BGl_z62lambda2426z62zz__multimediazd2midizd2(obj_t BgL_envz00_3319, obj_t BgL_oz00_3320, obj_t BgL_vz00_3321)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3320)))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_vz00_3321)),BUNSPEC);} 

}



/* &lambda2425 */
obj_t BGl_z62lambda2425z62zz__multimediazd2midizd2(obj_t BgL_envz00_3322, obj_t BgL_oz00_3323)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3323)))->BgL_metazd2markerzd2);} 

}



/* &<@anonymous:2420> */
obj_t BGl_z62zc3z04anonymousza32420ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3324)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2419 */
obj_t BGl_z62lambda2419z62zz__multimediazd2midizd2(obj_t BgL_envz00_3325, obj_t BgL_oz00_3326, obj_t BgL_vz00_3327)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3326)))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_vz00_3327)),BUNSPEC);} 

}



/* &lambda2418 */
obj_t BGl_z62lambda2418z62zz__multimediazd2midizd2(obj_t BgL_envz00_3328, obj_t BgL_oz00_3329)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3329)))->BgL_metazd2lyriczd2);} 

}



/* &<@anonymous:2413> */
obj_t BGl_z62zc3z04anonymousza32413ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3330)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2412 */
obj_t BGl_z62lambda2412z62zz__multimediazd2midizd2(obj_t BgL_envz00_3331, obj_t BgL_oz00_3332, obj_t BgL_vz00_3333)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3332)))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_vz00_3333)),BUNSPEC);} 

}



/* &lambda2411 */
obj_t BGl_z62lambda2411z62zz__multimediazd2midizd2(obj_t BgL_envz00_3334, obj_t BgL_oz00_3335)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3335)))->BgL_metazd2instrumentzd2);} 

}



/* &<@anonymous:2406> */
obj_t BGl_z62zc3z04anonymousza32406ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3336)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2405 */
obj_t BGl_z62lambda2405z62zz__multimediazd2midizd2(obj_t BgL_envz00_3337, obj_t BgL_oz00_3338, obj_t BgL_vz00_3339)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3338)))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_vz00_3339)),BUNSPEC);} 

}



/* &lambda2404 */
obj_t BGl_z62lambda2404z62zz__multimediazd2midizd2(obj_t BgL_envz00_3340, obj_t BgL_oz00_3341)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3341)))->BgL_metazd2trackzd2);} 

}



/* &<@anonymous:2399> */
obj_t BGl_z62zc3z04anonymousza32399ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3342)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2398 */
obj_t BGl_z62lambda2398z62zz__multimediazd2midizd2(obj_t BgL_envz00_3343, obj_t BgL_oz00_3344, obj_t BgL_vz00_3345)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3344)))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_vz00_3345)),BUNSPEC);} 

}



/* &lambda2397 */
obj_t BGl_z62lambda2397z62zz__multimediazd2midizd2(obj_t BgL_envz00_3346, obj_t BgL_oz00_3347)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3347)))->BgL_metazd2copyrightzd2);} 

}



/* &<@anonymous:2392> */
obj_t BGl_z62zc3z04anonymousza32392ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3348)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2391 */
obj_t BGl_z62lambda2391z62zz__multimediazd2midizd2(obj_t BgL_envz00_3349, obj_t BgL_oz00_3350, obj_t BgL_vz00_3351)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3350)))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_vz00_3351)),BUNSPEC);} 

}



/* &lambda2390 */
obj_t BGl_z62lambda2390z62zz__multimediazd2midizd2(obj_t BgL_envz00_3352, obj_t BgL_oz00_3353)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3353)))->BgL_metazd2textzd2);} 

}



/* &<@anonymous:2385> */
obj_t BGl_z62zc3z04anonymousza32385ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3354)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2384 */
obj_t BGl_z62lambda2384z62zz__multimediazd2midizd2(obj_t BgL_envz00_3355, obj_t BgL_oz00_3356, obj_t BgL_vz00_3357)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3356)))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_vz00_3357)),BUNSPEC);} 

}



/* &lambda2383 */
obj_t BGl_z62lambda2383z62zz__multimediazd2midizd2(obj_t BgL_envz00_3358, obj_t BgL_oz00_3359)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3359)))->BgL_metazd2seqnumzd2);} 

}



/* &<@anonymous:2378> */
obj_t BGl_z62zc3z04anonymousza32378ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3360)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2377 */
obj_t BGl_z62lambda2377z62zz__multimediazd2midizd2(obj_t BgL_envz00_3361, obj_t BgL_oz00_3362, obj_t BgL_vz00_3363)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3362)))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_vz00_3363)),BUNSPEC);} 

}



/* &lambda2376 */
obj_t BGl_z62lambda2376z62zz__multimediazd2midizd2(obj_t BgL_envz00_3364, obj_t BgL_oz00_3365)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3365)))->BgL_sysexz00);} 

}



/* &<@anonymous:2371> */
obj_t BGl_z62zc3z04anonymousza32371ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3366)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2370 */
obj_t BGl_z62lambda2370z62zz__multimediazd2midizd2(obj_t BgL_envz00_3367, obj_t BgL_oz00_3368, obj_t BgL_vz00_3369)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3368)))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_vz00_3369)),BUNSPEC);} 

}



/* &lambda2369 */
obj_t BGl_z62lambda2369z62zz__multimediazd2midizd2(obj_t BgL_envz00_3370, obj_t BgL_oz00_3371)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3371)))->BgL_pitchz00);} 

}



/* &<@anonymous:2364> */
obj_t BGl_z62zc3z04anonymousza32364ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3372)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2;} 

}



/* &lambda2363 */
obj_t BGl_z62lambda2363z62zz__multimediazd2midizd2(obj_t BgL_envz00_3373, obj_t BgL_oz00_3374, obj_t BgL_vz00_3375)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3374)))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_vz00_3375)),BUNSPEC);} 

}



/* &lambda2362 */
obj_t BGl_z62lambda2362z62zz__multimediazd2midizd2(obj_t BgL_envz00_3376, obj_t BgL_oz00_3377)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3377)))->BgL_afterzd2touchzd2);} 

}



/* &<@anonymous:2357> */
obj_t BGl_z62zc3z04anonymousza32357ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3378)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2356 */
obj_t BGl_z62lambda2356z62zz__multimediazd2midizd2(obj_t BgL_envz00_3379, obj_t BgL_oz00_3380, obj_t BgL_vz00_3381)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3380)))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_vz00_3381)),BUNSPEC);} 

}



/* &lambda2355 */
obj_t BGl_z62lambda2355z62zz__multimediazd2midizd2(obj_t BgL_envz00_3382, obj_t BgL_oz00_3383)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3383)))->BgL_prgmchangez00);} 

}



/* &<@anonymous:2350> */
obj_t BGl_z62zc3z04anonymousza32350ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3384)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2349 */
obj_t BGl_z62lambda2349z62zz__multimediazd2midizd2(obj_t BgL_envz00_3385, obj_t BgL_oz00_3386, obj_t BgL_vz00_3387)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3386)))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_vz00_3387)),BUNSPEC);} 

}



/* &lambda2348 */
obj_t BGl_z62lambda2348z62zz__multimediazd2midizd2(obj_t BgL_envz00_3388, obj_t BgL_oz00_3389)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3389)))->BgL_ctrlchangez00);} 

}



/* &<@anonymous:2343> */
obj_t BGl_z62zc3z04anonymousza32343ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3390)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2342 */
obj_t BGl_z62lambda2342z62zz__multimediazd2midizd2(obj_t BgL_envz00_3391, obj_t BgL_oz00_3392, obj_t BgL_vz00_3393)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3392)))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_vz00_3393)),BUNSPEC);} 

}



/* &lambda2341 */
obj_t BGl_z62lambda2341z62zz__multimediazd2midizd2(obj_t BgL_envz00_3394, obj_t BgL_oz00_3395)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3395)))->BgL_aftertouchz00);} 

}



/* &<@anonymous:2336> */
obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3396)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2335 */
obj_t BGl_z62lambda2335z62zz__multimediazd2midizd2(obj_t BgL_envz00_3397, obj_t BgL_oz00_3398, obj_t BgL_vz00_3399)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3398)))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_vz00_3399)),BUNSPEC);} 

}



/* &lambda2334 */
obj_t BGl_z62lambda2334z62zz__multimediazd2midizd2(obj_t BgL_envz00_3400, obj_t BgL_oz00_3401)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3401)))->BgL_noteonz00);} 

}



/* &<@anonymous:2329> */
obj_t BGl_z62zc3z04anonymousza32329ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3402)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2328 */
obj_t BGl_z62lambda2328z62zz__multimediazd2midizd2(obj_t BgL_envz00_3403, obj_t BgL_oz00_3404, obj_t BgL_vz00_3405)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3404)))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_vz00_3405)),BUNSPEC);} 

}



/* &lambda2327 */
obj_t BGl_z62lambda2327z62zz__multimediazd2midizd2(obj_t BgL_envz00_3406, obj_t BgL_oz00_3407)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3407)))->BgL_noteoffz00);} 

}



/* &<@anonymous:2322> */
obj_t BGl_z62zc3z04anonymousza32322ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3408)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2321 */
obj_t BGl_z62lambda2321z62zz__multimediazd2midizd2(obj_t BgL_envz00_3409, obj_t BgL_oz00_3410, obj_t BgL_vz00_3411)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3410)))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_vz00_3411)),BUNSPEC);} 

}



/* &lambda2320 */
obj_t BGl_z62lambda2320z62zz__multimediazd2midizd2(obj_t BgL_envz00_3412, obj_t BgL_oz00_3413)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3413)))->BgL_cdelayz00);} 

}



/* &<@anonymous:2315> */
obj_t BGl_z62zc3z04anonymousza32315ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3414)
{
{ /* Llib/midi.scm 52 */
return BGl_errorzd2envzd2zz__errorz00;} 

}



/* &lambda2314 */
obj_t BGl_z62lambda2314z62zz__multimediazd2midizd2(obj_t BgL_envz00_3415, obj_t BgL_oz00_3416, obj_t BgL_vz00_3417)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3416)))->BgL_errz00)=((obj_t)
((obj_t)BgL_vz00_3417)),BUNSPEC);} 

}



/* &lambda2313 */
obj_t BGl_z62lambda2313z62zz__multimediazd2midizd2(obj_t BgL_envz00_3418, obj_t BgL_oz00_3419)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3419)))->BgL_errz00);} 

}



/* &<@anonymous:2262> */
obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3420, obj_t BgL_new1080z00_3421)
{
{ /* Llib/midi.scm 42 */
{ 
BgL_midireaderz00_bglt BgL_auxz00_7513;
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_peekzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2int16zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2int32zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2intzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2vlqzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1080z00_3421)))->BgL_readzd2charszd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7513 = 
((BgL_midireaderz00_bglt)BgL_new1080z00_3421); 
return 
((obj_t)BgL_auxz00_7513);} } 

}



/* &lambda2260 */
BgL_midireaderz00_bglt BGl_z62lambda2260z62zz__multimediazd2midizd2(obj_t BgL_envz00_3422)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1079z00_4075;
BgL_new1079z00_4075 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2261z00_4076;
BgL_arg2261z00_4076 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1079z00_4075), BgL_arg2261z00_4076); } 
return BgL_new1079z00_4075;} } 

}



/* &lambda2257 */
BgL_midireaderz00_bglt BGl_z62lambda2257z62zz__multimediazd2midizd2(obj_t BgL_envz00_3423, obj_t BgL_peekzd2byte1072zd2_3424, obj_t BgL_readzd2byte1073zd2_3425, obj_t BgL_readzd2int161074zd2_3426, obj_t BgL_readzd2int321075zd2_3427, obj_t BgL_readzd2int1076zd2_3428, obj_t BgL_readzd2vlq1077zd2_3429, obj_t BgL_readzd2chars1078zd2_3430)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1182z00_4084;
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1181z00_4085;
BgL_new1181z00_4085 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2259z00_4086;
BgL_arg2259z00_4086 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1181z00_4085), BgL_arg2259z00_4086); } 
BgL_new1182z00_4084 = BgL_new1181z00_4085; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_peekzd2byte1072zd2_3424)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_readzd2byte1073zd2_3425)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_readzd2int161074zd2_3426)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_readzd2int321075zd2_3427)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_readzd2int1076zd2_3428)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_readzd2vlq1077zd2_3429)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1182z00_4084))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_readzd2chars1078zd2_3430)),BUNSPEC); 
{ /* Llib/midi.scm 42 */
obj_t BgL_fun2258z00_4087;
BgL_fun2258z00_4087 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2258z00_4087)(BgL_fun2258z00_4087, 
((obj_t)BgL_new1182z00_4084), BEOA); } 
return BgL_new1182z00_4084;} } 

}



/* &lambda2297 */
obj_t BGl_z62lambda2297z62zz__multimediazd2midizd2(obj_t BgL_envz00_3431, obj_t BgL_oz00_3432, obj_t BgL_vz00_3433)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3432)))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_vz00_3433)),BUNSPEC);} 

}



/* &lambda2296 */
obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t BgL_envz00_3434, obj_t BgL_oz00_3435)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3435)))->BgL_readzd2charszd2);} 

}



/* &lambda2292 */
obj_t BGl_z62lambda2292z62zz__multimediazd2midizd2(obj_t BgL_envz00_3436, obj_t BgL_oz00_3437, obj_t BgL_vz00_3438)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3437)))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_vz00_3438)),BUNSPEC);} 

}



/* &lambda2291 */
obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t BgL_envz00_3439, obj_t BgL_oz00_3440)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3440)))->BgL_readzd2vlqzd2);} 

}



/* &lambda2287 */
obj_t BGl_z62lambda2287z62zz__multimediazd2midizd2(obj_t BgL_envz00_3441, obj_t BgL_oz00_3442, obj_t BgL_vz00_3443)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3442)))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_vz00_3443)),BUNSPEC);} 

}



/* &lambda2286 */
obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t BgL_envz00_3444, obj_t BgL_oz00_3445)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3445)))->BgL_readzd2intzd2);} 

}



/* &lambda2282 */
obj_t BGl_z62lambda2282z62zz__multimediazd2midizd2(obj_t BgL_envz00_3446, obj_t BgL_oz00_3447, obj_t BgL_vz00_3448)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3447)))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_vz00_3448)),BUNSPEC);} 

}



/* &lambda2281 */
obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t BgL_envz00_3449, obj_t BgL_oz00_3450)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3450)))->BgL_readzd2int32zd2);} 

}



/* &lambda2277 */
obj_t BGl_z62lambda2277z62zz__multimediazd2midizd2(obj_t BgL_envz00_3451, obj_t BgL_oz00_3452, obj_t BgL_vz00_3453)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3452)))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_vz00_3453)),BUNSPEC);} 

}



/* &lambda2276 */
obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t BgL_envz00_3454, obj_t BgL_oz00_3455)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3455)))->BgL_readzd2int16zd2);} 

}



/* &lambda2272 */
obj_t BGl_z62lambda2272z62zz__multimediazd2midizd2(obj_t BgL_envz00_3456, obj_t BgL_oz00_3457, obj_t BgL_vz00_3458)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3457)))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3458)),BUNSPEC);} 

}



/* &lambda2271 */
obj_t BGl_z62lambda2271z62zz__multimediazd2midizd2(obj_t BgL_envz00_3459, obj_t BgL_oz00_3460)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3460)))->BgL_readzd2bytezd2);} 

}



/* &lambda2267 */
obj_t BGl_z62lambda2267z62zz__multimediazd2midizd2(obj_t BgL_envz00_3461, obj_t BgL_oz00_3462, obj_t BgL_vz00_3463)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3462)))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3463)),BUNSPEC);} 

}



/* &lambda2266 */
obj_t BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t BgL_envz00_3464, obj_t BgL_oz00_3465)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3465)))->BgL_peekzd2bytezd2);} 

}



/* &<@anonymous:2156> */
obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3466, obj_t BgL_new1070z00_3467)
{
{ /* Llib/midi.scm 24 */
{ 
BgL_miditrackz00_bglt BgL_auxz00_7593;
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52streamz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_midireaderz00_bglt BgL_auxz00_7596;
{ /* Llib/midi.scm 24 */
obj_t BgL_classz00_4110;
BgL_classz00_4110 = BGl_midireaderz00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 24 */
obj_t BgL__ortest_1111z00_4111;
BgL__ortest_1111z00_4111 = 
BGL_CLASS_NIL(BgL_classz00_4110); 
if(
CBOOL(BgL__ortest_1111z00_4111))
{ /* Llib/midi.scm 24 */
BgL_auxz00_7596 = 
((BgL_midireaderz00_bglt)BgL__ortest_1111z00_4111)
; }  else 
{ /* Llib/midi.scm 24 */
BgL_auxz00_7596 = 
((BgL_midireaderz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4110))
; } } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BgL_auxz00_7596),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52closez52)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52wtickz52)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_lenz00)=((int32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_ipz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_wtickz00)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_statusz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1070z00_3467)))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7593 = 
((BgL_miditrackz00_bglt)BgL_new1070z00_3467); 
return 
((obj_t)BgL_auxz00_7593);} } 

}



/* &lambda2154 */
BgL_miditrackz00_bglt BGl_z62lambda2154z62zz__multimediazd2midizd2(obj_t BgL_envz00_3468)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1069z00_4112;
BgL_new1069z00_4112 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2155z00_4113;
BgL_arg2155z00_4113 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4112), BgL_arg2155z00_4113); } 
return BgL_new1069z00_4112;} } 

}



/* &lambda2151 */
BgL_miditrackz00_bglt BGl_z62lambda2151z62zz__multimediazd2midizd2(obj_t BgL_envz00_3469, obj_t BgL_z52stream1055z52_3470, obj_t BgL_z52reader1056z52_3471, obj_t BgL_z52close1057z52_3472, obj_t BgL_z52eot1058z52_3473, obj_t BgL_z52wtick1059z52_3474, obj_t BgL_z52status1060z52_3475, obj_t BgL_len1061z00_3476, obj_t BgL_tempo1062z00_3477, obj_t BgL_ip1063z00_3478, obj_t BgL_start1064z00_3479, obj_t BgL_datastart1065z00_3480, obj_t BgL_wtick1066z00_3481, obj_t BgL_status1067z00_3482, obj_t BgL_eot1068z00_3483)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_z52eot1058z52_4116;uint32_t BgL_z52wtick1059z52_4117;long BgL_z52status1060z52_4118;int32_t BgL_len1061z00_4119;long BgL_tempo1062z00_4120;long BgL_start1064z00_4121;long BgL_datastart1065z00_4122;uint32_t BgL_wtick1066z00_4123;long BgL_status1067z00_4124;bool_t BgL_eot1068z00_4125;
BgL_z52eot1058z52_4116 = 
CBOOL(BgL_z52eot1058z52_3473); 
BgL_z52wtick1059z52_4117 = 
BGL_BUINT32_TO_UINT32(BgL_z52wtick1059z52_3474); 
BgL_z52status1060z52_4118 = 
(long)CINT(BgL_z52status1060z52_3475); 
BgL_len1061z00_4119 = 
BGL_BINT32_TO_INT32(BgL_len1061z00_3476); 
BgL_tempo1062z00_4120 = 
(long)CINT(BgL_tempo1062z00_3477); 
BgL_start1064z00_4121 = 
(long)CINT(BgL_start1064z00_3479); 
BgL_datastart1065z00_4122 = 
(long)CINT(BgL_datastart1065z00_3480); 
BgL_wtick1066z00_4123 = 
BGL_BUINT32_TO_UINT32(BgL_wtick1066z00_3481); 
BgL_status1067z00_4124 = 
(long)CINT(BgL_status1067z00_3482); 
BgL_eot1068z00_4125 = 
CBOOL(BgL_eot1068z00_3483); 
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1180z00_4126;
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1179z00_4127;
BgL_new1179z00_4127 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2153z00_4128;
BgL_arg2153z00_4128 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_4127), BgL_arg2153z00_4128); } 
BgL_new1180z00_4126 = BgL_new1179z00_4127; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52streamz52)=((obj_t)BgL_z52stream1055z52_3470),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_z52reader1056z52_3471)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_z52close1057z52_3472)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52eotz52)=((bool_t)BgL_z52eot1058z52_4116),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52wtickz52)=((uint32_t)BgL_z52wtick1059z52_4117),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_z52statusz52)=((long)BgL_z52status1060z52_4118),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_lenz00)=((int32_t)BgL_len1061z00_4119),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_tempoz00)=((long)BgL_tempo1062z00_4120),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_ipz00)=((obj_t)BgL_ip1063z00_3478),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_startz00)=((long)BgL_start1064z00_4121),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_datastartz00)=((long)BgL_datastart1065z00_4122),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_wtickz00)=((uint32_t)BgL_wtick1066z00_4123),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_statusz00)=((long)BgL_status1067z00_4124),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1180z00_4126))->BgL_eotz00)=((bool_t)BgL_eot1068z00_4125),BUNSPEC); 
{ /* Llib/midi.scm 24 */
obj_t BgL_fun2152z00_4129;
BgL_fun2152z00_4129 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2152z00_4129)(BgL_fun2152z00_4129, 
((obj_t)BgL_new1180z00_4126), BEOA); } 
return BgL_new1180z00_4126;} } } 

}



/* &<@anonymous:2251> */
obj_t BGl_z62zc3z04anonymousza32251ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3484)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2250 */
obj_t BGl_z62lambda2250z62zz__multimediazd2midizd2(obj_t BgL_envz00_3485, obj_t BgL_oz00_3486, obj_t BgL_vz00_3487)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4131;
BgL_vz00_4131 = 
CBOOL(BgL_vz00_3487); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3486)))->BgL_eotz00)=((bool_t)BgL_vz00_4131),BUNSPEC);} } 

}



/* &lambda2249 */
obj_t BGl_z62lambda2249z62zz__multimediazd2midizd2(obj_t BgL_envz00_3488, obj_t BgL_oz00_3489)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3489)))->BgL_eotz00));} 

}



/* &<@anonymous:2244> */
obj_t BGl_z62zc3z04anonymousza32244ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3490)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)-1));} 

}



/* &lambda2243 */
obj_t BGl_z62lambda2243z62zz__multimediazd2midizd2(obj_t BgL_envz00_3491, obj_t BgL_oz00_3492, obj_t BgL_vz00_3493)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4134;
BgL_vz00_4134 = 
(long)CINT(BgL_vz00_3493); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3492)))->BgL_statusz00)=((long)BgL_vz00_4134),BUNSPEC);} } 

}



/* &lambda2242 */
obj_t BGl_z62lambda2242z62zz__multimediazd2midizd2(obj_t BgL_envz00_3494, obj_t BgL_oz00_3495)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3495)))->BgL_statusz00));} 

}



/* &<@anonymous:2237> */
obj_t BGl_z62zc3z04anonymousza32237ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3496)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2236 */
obj_t BGl_z62lambda2236z62zz__multimediazd2midizd2(obj_t BgL_envz00_3497, obj_t BgL_oz00_3498, obj_t BgL_vz00_3499)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4137;
BgL_vz00_4137 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3499); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3498)))->BgL_wtickz00)=((uint32_t)BgL_vz00_4137),BUNSPEC);} } 

}



/* &lambda2235 */
obj_t BGl_z62lambda2235z62zz__multimediazd2midizd2(obj_t BgL_envz00_3500, obj_t BgL_oz00_3501)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7692;
BgL_tmpz00_7692 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3501)))->BgL_wtickz00); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7692);} } 

}



/* &<@anonymous:2230> */
obj_t BGl_z62zc3z04anonymousza32230ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3502)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2229 */
obj_t BGl_z62lambda2229z62zz__multimediazd2midizd2(obj_t BgL_envz00_3503, obj_t BgL_oz00_3504, obj_t BgL_vz00_3505)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4140;
BgL_vz00_4140 = 
(long)CINT(BgL_vz00_3505); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3504)))->BgL_datastartz00)=((long)BgL_vz00_4140),BUNSPEC);} } 

}



/* &lambda2228 */
obj_t BGl_z62lambda2228z62zz__multimediazd2midizd2(obj_t BgL_envz00_3506, obj_t BgL_oz00_3507)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3507)))->BgL_datastartz00));} 

}



/* &<@anonymous:2223> */
obj_t BGl_z62zc3z04anonymousza32223ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3508)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2222 */
obj_t BGl_z62lambda2222z62zz__multimediazd2midizd2(obj_t BgL_envz00_3509, obj_t BgL_oz00_3510, obj_t BgL_vz00_3511)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4143;
BgL_vz00_4143 = 
(long)CINT(BgL_vz00_3511); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3510)))->BgL_startz00)=((long)BgL_vz00_4143),BUNSPEC);} } 

}



/* &lambda2221 */
obj_t BGl_z62lambda2221z62zz__multimediazd2midizd2(obj_t BgL_envz00_3512, obj_t BgL_oz00_3513)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3513)))->BgL_startz00));} 

}



/* &<@anonymous:2216> */
obj_t BGl_z62zc3z04anonymousza32216ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3514)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2215 */
obj_t BGl_z62lambda2215z62zz__multimediazd2midizd2(obj_t BgL_envz00_3515, obj_t BgL_oz00_3516, obj_t BgL_vz00_3517)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3516)))->BgL_ipz00)=((obj_t)BgL_vz00_3517),BUNSPEC);} 

}



/* &lambda2214 */
obj_t BGl_z62lambda2214z62zz__multimediazd2midizd2(obj_t BgL_envz00_3518, obj_t BgL_oz00_3519)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3519)))->BgL_ipz00);} 

}



/* &<@anonymous:2209> */
obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3520)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)500000));} 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__multimediazd2midizd2(obj_t BgL_envz00_3521, obj_t BgL_oz00_3522, obj_t BgL_vz00_3523)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4148;
BgL_vz00_4148 = 
(long)CINT(BgL_vz00_3523); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3522)))->BgL_tempoz00)=((long)BgL_vz00_4148),BUNSPEC);} } 

}



/* &lambda2207 */
obj_t BGl_z62lambda2207z62zz__multimediazd2midizd2(obj_t BgL_envz00_3524, obj_t BgL_oz00_3525)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3525)))->BgL_tempoz00));} 

}



/* &<@anonymous:2202> */
obj_t BGl_z62zc3z04anonymousza32202ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3526)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2201 */
obj_t BGl_z62lambda2201z62zz__multimediazd2midizd2(obj_t BgL_envz00_3527, obj_t BgL_oz00_3528, obj_t BgL_vz00_3529)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_vz00_4151;
BgL_vz00_4151 = 
BGL_BINT32_TO_INT32(BgL_vz00_3529); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3528)))->BgL_lenz00)=((int32_t)BgL_vz00_4151),BUNSPEC);} } 

}



/* &lambda2200 */
obj_t BGl_z62lambda2200z62zz__multimediazd2midizd2(obj_t BgL_envz00_3530, obj_t BgL_oz00_3531)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_tmpz00_7726;
BgL_tmpz00_7726 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3531)))->BgL_lenz00); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_7726);} } 

}



/* &<@anonymous:2195> */
obj_t BGl_z62zc3z04anonymousza32195ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3532)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2194 */
obj_t BGl_z62lambda2194z62zz__multimediazd2midizd2(obj_t BgL_envz00_3533, obj_t BgL_oz00_3534, obj_t BgL_vz00_3535)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4154;
BgL_vz00_4154 = 
(long)CINT(BgL_vz00_3535); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3534)))->BgL_z52statusz52)=((long)BgL_vz00_4154),BUNSPEC);} } 

}



/* &lambda2193 */
obj_t BGl_z62lambda2193z62zz__multimediazd2midizd2(obj_t BgL_envz00_3536, obj_t BgL_oz00_3537)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3537)))->BgL_z52statusz52));} 

}



/* &<@anonymous:2188> */
obj_t BGl_z62zc3z04anonymousza32188ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3538)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2187 */
obj_t BGl_z62lambda2187z62zz__multimediazd2midizd2(obj_t BgL_envz00_3539, obj_t BgL_oz00_3540, obj_t BgL_vz00_3541)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4157;
BgL_vz00_4157 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3541); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3540)))->BgL_z52wtickz52)=((uint32_t)BgL_vz00_4157),BUNSPEC);} } 

}



/* &lambda2186 */
obj_t BGl_z62lambda2186z62zz__multimediazd2midizd2(obj_t BgL_envz00_3542, obj_t BgL_oz00_3543)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7741;
BgL_tmpz00_7741 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3543)))->BgL_z52wtickz52); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7741);} } 

}



/* &<@anonymous:2181> */
obj_t BGl_z62zc3z04anonymousza32181ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3544)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2180 */
obj_t BGl_z62lambda2180z62zz__multimediazd2midizd2(obj_t BgL_envz00_3545, obj_t BgL_oz00_3546, obj_t BgL_vz00_3547)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4160;
BgL_vz00_4160 = 
CBOOL(BgL_vz00_3547); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3546)))->BgL_z52eotz52)=((bool_t)BgL_vz00_4160),BUNSPEC);} } 

}



/* &lambda2179 */
obj_t BGl_z62lambda2179z62zz__multimediazd2midizd2(obj_t BgL_envz00_3548, obj_t BgL_oz00_3549)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3549)))->BgL_z52eotz52));} 

}



/* &lambda2173 */
obj_t BGl_z62lambda2173z62zz__multimediazd2midizd2(obj_t BgL_envz00_3550, obj_t BgL_oz00_3551, obj_t BgL_vz00_3552)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3551)))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_vz00_3552)),BUNSPEC);} 

}



/* &lambda2172 */
obj_t BGl_z62lambda2172z62zz__multimediazd2midizd2(obj_t BgL_envz00_3553, obj_t BgL_oz00_3554)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3554)))->BgL_z52closez52);} 

}



/* &lambda2168 */
obj_t BGl_z62lambda2168z62zz__multimediazd2midizd2(obj_t BgL_envz00_3555, obj_t BgL_oz00_3556, obj_t BgL_vz00_3557)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3556)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_vz00_3557)),BUNSPEC);} 

}



/* &lambda2167 */
BgL_midireaderz00_bglt BGl_z62lambda2167z62zz__multimediazd2midizd2(obj_t BgL_envz00_3558, obj_t BgL_oz00_3559)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3559)))->BgL_z52readerz52);} 

}



/* &<@anonymous:2163> */
obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3560)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2162 */
obj_t BGl_z62lambda2162z62zz__multimediazd2midizd2(obj_t BgL_envz00_3561, obj_t BgL_oz00_3562, obj_t BgL_vz00_3563)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3562)))->BgL_z52streamz52)=((obj_t)BgL_vz00_3563),BUNSPEC);} 

}



/* &lambda2161 */
obj_t BGl_z62lambda2161z62zz__multimediazd2midizd2(obj_t BgL_envz00_3564, obj_t BgL_oz00_3565)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3565)))->BgL_z52streamz52);} 

}



/* &<@anonymous:2119> */
obj_t BGl_z62zc3z04anonymousza32119ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3566, obj_t BgL_new1053z00_3567)
{
{ /* Llib/midi.scm 17 */
{ 
BgL_midiscorez00_bglt BgL_auxz00_7767;
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3567)))->BgL_formatz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3567)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3567)))->BgL_ppqz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1053z00_3567)))->BgL_tracksz00)=((obj_t)
CNST_TABLE_REF(((long)75))),BUNSPEC); 
BgL_auxz00_7767 = 
((BgL_midiscorez00_bglt)BgL_new1053z00_3567); 
return 
((obj_t)BgL_auxz00_7767);} } 

}



/* &lambda2117 */
BgL_midiscorez00_bglt BGl_z62lambda2117z62zz__multimediazd2midizd2(obj_t BgL_envz00_3568)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1052z00_4171;
BgL_new1052z00_4171 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2118z00_4172;
BgL_arg2118z00_4172 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1052z00_4171), BgL_arg2118z00_4172); } 
return BgL_new1052z00_4171;} } 

}



/* &lambda2114 */
BgL_midiscorez00_bglt BGl_z62lambda2114z62zz__multimediazd2midizd2(obj_t BgL_envz00_3569, obj_t BgL_format1048z00_3570, obj_t BgL_tempo1049z00_3571, obj_t BgL_ppq1050z00_3572, obj_t BgL_tracks1051z00_3573)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_format1048z00_4173;long BgL_tempo1049z00_4174;long BgL_ppq1050z00_4175;
BgL_format1048z00_4173 = 
(long)CINT(BgL_format1048z00_3570); 
BgL_tempo1049z00_4174 = 
(long)CINT(BgL_tempo1049z00_3571); 
BgL_ppq1050z00_4175 = 
(long)CINT(BgL_ppq1050z00_3572); 
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1178z00_4177;
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1177z00_4178;
BgL_new1177z00_4178 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2116z00_4179;
BgL_arg2116z00_4179 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_4178), BgL_arg2116z00_4179); } 
BgL_new1178z00_4177 = BgL_new1177z00_4178; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1178z00_4177))->BgL_formatz00)=((long)BgL_format1048z00_4173),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1178z00_4177))->BgL_tempoz00)=((long)BgL_tempo1049z00_4174),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1178z00_4177))->BgL_ppqz00)=((long)BgL_ppq1050z00_4175),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1178z00_4177))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_tracks1051z00_3573)),BUNSPEC); 
{ /* Llib/midi.scm 17 */
obj_t BgL_fun2115z00_4180;
BgL_fun2115z00_4180 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2115z00_4180)(BgL_fun2115z00_4180, 
((obj_t)BgL_new1178z00_4177), BEOA); } 
return BgL_new1178z00_4177;} } } 

}



/* &<@anonymous:2145> */
obj_t BGl_z62zc3z04anonymousza32145ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3574)
{
{ /* Llib/midi.scm 17 */
return 
CNST_TABLE_REF(((long)75));} 

}



/* &lambda2144 */
obj_t BGl_z62lambda2144z62zz__multimediazd2midizd2(obj_t BgL_envz00_3575, obj_t BgL_oz00_3576, obj_t BgL_vz00_3577)
{
{ /* Llib/midi.scm 17 */
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3576)))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_vz00_3577)),BUNSPEC);} 

}



/* &lambda2143 */
obj_t BGl_z62lambda2143z62zz__multimediazd2midizd2(obj_t BgL_envz00_3578, obj_t BgL_oz00_3579)
{
{ /* Llib/midi.scm 17 */
return 
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3579)))->BgL_tracksz00);} 

}



/* &<@anonymous:2138> */
obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3580)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)96));} 

}



/* &lambda2137 */
obj_t BGl_z62lambda2137z62zz__multimediazd2midizd2(obj_t BgL_envz00_3581, obj_t BgL_oz00_3582, obj_t BgL_vz00_3583)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4185;
BgL_vz00_4185 = 
(long)CINT(BgL_vz00_3583); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3582)))->BgL_ppqz00)=((long)BgL_vz00_4185),BUNSPEC);} } 

}



/* &lambda2136 */
obj_t BGl_z62lambda2136z62zz__multimediazd2midizd2(obj_t BgL_envz00_3584, obj_t BgL_oz00_3585)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3585)))->BgL_ppqz00));} 

}



/* &<@anonymous:2131> */
obj_t BGl_z62zc3z04anonymousza32131ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3586)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)500000));} 

}



/* &lambda2130 */
obj_t BGl_z62lambda2130z62zz__multimediazd2midizd2(obj_t BgL_envz00_3587, obj_t BgL_oz00_3588, obj_t BgL_vz00_3589)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4188;
BgL_vz00_4188 = 
(long)CINT(BgL_vz00_3589); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3588)))->BgL_tempoz00)=((long)BgL_vz00_4188),BUNSPEC);} } 

}



/* &lambda2129 */
obj_t BGl_z62lambda2129z62zz__multimediazd2midizd2(obj_t BgL_envz00_3590, obj_t BgL_oz00_3591)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3591)))->BgL_tempoz00));} 

}



/* &lambda2124 */
obj_t BGl_z62lambda2124z62zz__multimediazd2midizd2(obj_t BgL_envz00_3592, obj_t BgL_oz00_3593, obj_t BgL_vz00_3594)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4191;
BgL_vz00_4191 = 
(long)CINT(BgL_vz00_3594); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3593)))->BgL_formatz00)=((long)BgL_vz00_4191),BUNSPEC);} } 

}



/* &lambda2123 */
obj_t BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t BgL_envz00_3595, obj_t BgL_oz00_3596)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3596)))->BgL_formatz00));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3014z00zz__multimediazd2midizd2, BGl_midiscorez00zz__multimediazd2midizd2, BGl_string3015z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3016z00zz__multimediazd2midizd2, BGl_miditrackz00zz__multimediazd2midizd2, BGl_string3017z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3018z00zz__multimediazd2midizd2, BGl_midireaderz00zz__multimediazd2midizd2, BGl_string3019z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3020z00zz__multimediazd2midizd2, BGl_midiplayerz00zz__multimediazd2midizd2, BGl_string3021z00zz__multimediazd2midizd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3022z00zz__multimediazd2midizd2, BGl_midisinkz00zz__multimediazd2midizd2, BGl_string3023z00zz__multimediazd2midizd2);} 

}



/* &midisink-init1239 */
obj_t BGl_z62midisinkzd2init1239zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3612, obj_t BgL_msinkz00_3613)
{
{ /* Llib/midi.scm 987 */
return 
((obj_t)
((BgL_midisinkz00_bglt)BgL_msinkz00_3613));} 

}



/* &midiplayer-init1237 */
obj_t BGl_z62midiplayerzd2init1237zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3614, obj_t BgL_mplayerz00_3615)
{
{ /* Llib/midi.scm 981 */
return 
((obj_t)
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3615));} 

}



/* &midireader-init1235 */
obj_t BGl_z62midireaderzd2init1235zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3616, obj_t BgL_mreaderz00_3617)
{
{ /* Llib/midi.scm 975 */
return 
((obj_t)
((BgL_midireaderz00_bglt)BgL_mreaderz00_3617));} 

}



/* &miditrack-init1233 */
obj_t BGl_z62miditrackzd2init1233zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3618, obj_t BgL_mtrackz00_3619)
{
{ /* Llib/midi.scm 969 */
return 
((obj_t)
((BgL_miditrackz00_bglt)BgL_mtrackz00_3619));} 

}



/* &midiscore-init1231 */
obj_t BGl_z62midiscorezd2init1231zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3620, obj_t BgL_mscorez00_3621)
{
{ /* Llib/midi.scm 963 */
return 
((obj_t)
((BgL_midiscorez00_bglt)BgL_mscorez00_3621));} 

}



/* midiscore-init */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_63)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
obj_t BgL_method1232z00_1858;
{ /* Llib/midi.scm 963 */
obj_t BgL_res2565z00_2606;
{ /* Llib/midi.scm 963 */
long BgL_objzd2classzd2numz00_2577;
BgL_objzd2classzd2numz00_2577 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mscorez00_63)); 
{ /* Llib/midi.scm 963 */
obj_t BgL_arg1765z00_2578;
BgL_arg1765z00_2578 = 
PROCEDURE_REF(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 963 */
int BgL_offsetz00_2581;
BgL_offsetz00_2581 = 
(int)(BgL_objzd2classzd2numz00_2577); 
{ /* Llib/midi.scm 963 */
long BgL_offsetz00_2582;
BgL_offsetz00_2582 = 
(
(long)(BgL_offsetz00_2581)-OBJECT_TYPE); 
{ /* Llib/midi.scm 963 */
long BgL_modz00_2583;
BgL_modz00_2583 = 
(BgL_offsetz00_2582 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 963 */
long BgL_restz00_2585;
BgL_restz00_2585 = 
(BgL_offsetz00_2582 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 963 */

{ /* Llib/midi.scm 963 */
obj_t BgL_bucketz00_2587;
BgL_bucketz00_2587 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_2578),BgL_modz00_2583); 
BgL_res2565z00_2606 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2587),BgL_restz00_2585); } } } } } } } } 
BgL_method1232z00_1858 = BgL_res2565z00_2606; } 
return 
PROCEDURE_ENTRY(BgL_method1232z00_1858)(BgL_method1232z00_1858, 
((obj_t)BgL_mscorez00_63), BEOA);} } 

}



/* &midiscore-init */
obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3597, obj_t BgL_mscorez00_3598)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
BgL_midiscorez00_bglt BgL_auxz00_7872;
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3598, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 963 */
BgL_auxz00_7872 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3598)
; }  else 
{ 
obj_t BgL_auxz00_7876;
BgL_auxz00_7876 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)36209)), BGl_string3024z00zz__multimediazd2midizd2, BGl_string2792z00zz__multimediazd2midizd2, BgL_mscorez00_3598); 
FAILURE(BgL_auxz00_7876,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_auxz00_7872);} } 

}



/* miditrack-init */
BGL_EXPORTED_DEF obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_mtrackz00_64)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
obj_t BgL_method1234z00_1859;
{ /* Llib/midi.scm 969 */
obj_t BgL_res2570z00_2637;
{ /* Llib/midi.scm 969 */
long BgL_objzd2classzd2numz00_2608;
BgL_objzd2classzd2numz00_2608 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mtrackz00_64)); 
{ /* Llib/midi.scm 969 */
obj_t BgL_arg1765z00_2609;
BgL_arg1765z00_2609 = 
PROCEDURE_REF(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 969 */
int BgL_offsetz00_2612;
BgL_offsetz00_2612 = 
(int)(BgL_objzd2classzd2numz00_2608); 
{ /* Llib/midi.scm 969 */
long BgL_offsetz00_2613;
BgL_offsetz00_2613 = 
(
(long)(BgL_offsetz00_2612)-OBJECT_TYPE); 
{ /* Llib/midi.scm 969 */
long BgL_modz00_2614;
BgL_modz00_2614 = 
(BgL_offsetz00_2613 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 969 */
long BgL_restz00_2616;
BgL_restz00_2616 = 
(BgL_offsetz00_2613 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 969 */

{ /* Llib/midi.scm 969 */
obj_t BgL_bucketz00_2618;
BgL_bucketz00_2618 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_2609),BgL_modz00_2614); 
BgL_res2570z00_2637 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2618),BgL_restz00_2616); } } } } } } } } 
BgL_method1234z00_1859 = BgL_res2570z00_2637; } 
return 
PROCEDURE_ENTRY(BgL_method1234z00_1859)(BgL_method1234z00_1859, 
((obj_t)BgL_mtrackz00_64), BEOA);} } 

}



/* &miditrack-init */
obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3599, obj_t BgL_mtrackz00_3600)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
BgL_miditrackz00_bglt BgL_auxz00_7911;
if(
BGl_isazf3zf3zz__objectz00(BgL_mtrackz00_3600, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 969 */
BgL_auxz00_7911 = 
((BgL_miditrackz00_bglt)BgL_mtrackz00_3600)
; }  else 
{ 
obj_t BgL_auxz00_7915;
BgL_auxz00_7915 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)36494)), BGl_string3025z00zz__multimediazd2midizd2, BGl_string2814z00zz__multimediazd2midizd2, BgL_mtrackz00_3600); 
FAILURE(BgL_auxz00_7915,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_7911);} } 

}



/* midireader-init */
BGL_EXPORTED_DEF obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt BgL_mreaderz00_65)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
obj_t BgL_method1236z00_1860;
{ /* Llib/midi.scm 975 */
obj_t BgL_res2575z00_2668;
{ /* Llib/midi.scm 975 */
long BgL_objzd2classzd2numz00_2639;
BgL_objzd2classzd2numz00_2639 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mreaderz00_65)); 
{ /* Llib/midi.scm 975 */
obj_t BgL_arg1765z00_2640;
BgL_arg1765z00_2640 = 
PROCEDURE_REF(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 975 */
int BgL_offsetz00_2643;
BgL_offsetz00_2643 = 
(int)(BgL_objzd2classzd2numz00_2639); 
{ /* Llib/midi.scm 975 */
long BgL_offsetz00_2644;
BgL_offsetz00_2644 = 
(
(long)(BgL_offsetz00_2643)-OBJECT_TYPE); 
{ /* Llib/midi.scm 975 */
long BgL_modz00_2645;
BgL_modz00_2645 = 
(BgL_offsetz00_2644 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 975 */
long BgL_restz00_2647;
BgL_restz00_2647 = 
(BgL_offsetz00_2644 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 975 */

{ /* Llib/midi.scm 975 */
obj_t BgL_bucketz00_2649;
BgL_bucketz00_2649 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_2640),BgL_modz00_2645); 
BgL_res2575z00_2668 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2649),BgL_restz00_2647); } } } } } } } } 
BgL_method1236z00_1860 = BgL_res2575z00_2668; } 
return 
PROCEDURE_ENTRY(BgL_method1236z00_1860)(BgL_method1236z00_1860, 
((obj_t)BgL_mreaderz00_65), BEOA);} } 

}



/* &midireader-init */
obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3601, obj_t BgL_mreaderz00_3602)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
BgL_midireaderz00_bglt BgL_auxz00_7950;
if(
BGl_isazf3zf3zz__objectz00(BgL_mreaderz00_3602, BGl_midireaderz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 975 */
BgL_auxz00_7950 = 
((BgL_midireaderz00_bglt)BgL_mreaderz00_3602)
; }  else 
{ 
obj_t BgL_auxz00_7954;
BgL_auxz00_7954 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)36779)), BGl_string3026z00zz__multimediazd2midizd2, BGl_string3027z00zz__multimediazd2midizd2, BgL_mreaderz00_3602); 
FAILURE(BgL_auxz00_7954,BFALSE,BFALSE);} 
return 
BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_7950);} } 

}



/* midiplayer-init */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mplayerz00_66)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
obj_t BgL_method1238z00_1861;
{ /* Llib/midi.scm 981 */
obj_t BgL_res2580z00_2699;
{ /* Llib/midi.scm 981 */
long BgL_objzd2classzd2numz00_2670;
BgL_objzd2classzd2numz00_2670 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mplayerz00_66)); 
{ /* Llib/midi.scm 981 */
obj_t BgL_arg1765z00_2671;
BgL_arg1765z00_2671 = 
PROCEDURE_REF(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 981 */
int BgL_offsetz00_2674;
BgL_offsetz00_2674 = 
(int)(BgL_objzd2classzd2numz00_2670); 
{ /* Llib/midi.scm 981 */
long BgL_offsetz00_2675;
BgL_offsetz00_2675 = 
(
(long)(BgL_offsetz00_2674)-OBJECT_TYPE); 
{ /* Llib/midi.scm 981 */
long BgL_modz00_2676;
BgL_modz00_2676 = 
(BgL_offsetz00_2675 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 981 */
long BgL_restz00_2678;
BgL_restz00_2678 = 
(BgL_offsetz00_2675 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 981 */

{ /* Llib/midi.scm 981 */
obj_t BgL_bucketz00_2680;
BgL_bucketz00_2680 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_2671),BgL_modz00_2676); 
BgL_res2580z00_2699 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2680),BgL_restz00_2678); } } } } } } } } 
BgL_method1238z00_1861 = BgL_res2580z00_2699; } 
return 
PROCEDURE_ENTRY(BgL_method1238z00_1861)(BgL_method1238z00_1861, 
((obj_t)BgL_mplayerz00_66), BEOA);} } 

}



/* &midiplayer-init */
obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3603, obj_t BgL_mplayerz00_3604)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
BgL_midiplayerz00_bglt BgL_auxz00_7989;
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3604, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 981 */
BgL_auxz00_7989 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3604)
; }  else 
{ 
obj_t BgL_auxz00_7993;
BgL_auxz00_7993 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37068)), BGl_string3028z00zz__multimediazd2midizd2, BGl_string2793z00zz__multimediazd2midizd2, BgL_mplayerz00_3604); 
FAILURE(BgL_auxz00_7993,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_7989);} } 

}



/* midisink-init */
BGL_EXPORTED_DEF obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt BgL_msinkz00_67)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
obj_t BgL_method1240z00_1862;
{ /* Llib/midi.scm 987 */
obj_t BgL_res2585z00_2730;
{ /* Llib/midi.scm 987 */
long BgL_objzd2classzd2numz00_2701;
BgL_objzd2classzd2numz00_2701 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_msinkz00_67)); 
{ /* Llib/midi.scm 987 */
obj_t BgL_arg1765z00_2702;
BgL_arg1765z00_2702 = 
PROCEDURE_REF(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 987 */
int BgL_offsetz00_2705;
BgL_offsetz00_2705 = 
(int)(BgL_objzd2classzd2numz00_2701); 
{ /* Llib/midi.scm 987 */
long BgL_offsetz00_2706;
BgL_offsetz00_2706 = 
(
(long)(BgL_offsetz00_2705)-OBJECT_TYPE); 
{ /* Llib/midi.scm 987 */
long BgL_modz00_2707;
BgL_modz00_2707 = 
(BgL_offsetz00_2706 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 987 */
long BgL_restz00_2709;
BgL_restz00_2709 = 
(BgL_offsetz00_2706 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 987 */

{ /* Llib/midi.scm 987 */
obj_t BgL_bucketz00_2711;
BgL_bucketz00_2711 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_2702),BgL_modz00_2707); 
BgL_res2585z00_2730 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2711),BgL_restz00_2709); } } } } } } } } 
BgL_method1240z00_1862 = BgL_res2585z00_2730; } 
return 
PROCEDURE_ENTRY(BgL_method1240z00_1862)(BgL_method1240z00_1862, 
((obj_t)BgL_msinkz00_67), BEOA);} } 

}



/* &midisink-init */
obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3605, obj_t BgL_msinkz00_3606)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
BgL_midisinkz00_bglt BgL_auxz00_8028;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3606, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 987 */
BgL_auxz00_8028 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3606)
; }  else 
{ 
obj_t BgL_auxz00_8032;
BgL_auxz00_8032 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2781z00zz__multimediazd2midizd2, 
BINT(((long)37357)), BGl_string3029z00zz__multimediazd2midizd2, BGl_string2794z00zz__multimediazd2midizd2, BgL_msinkz00_3606); 
FAILURE(BgL_auxz00_8032,BFALSE,BFALSE);} 
return 
BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8028);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
