/*===========================================================================*/
/*   (Llib/mpd.scm)                                                          */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -unsafe -safee -copt -fPIC -copt -IUnix Llib/mpd.scm -o objs/mpd.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musictagz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_titlez00;
   obj_t BgL_artistz00;
   obj_t BgL_interpretz00;
   obj_t BgL_albumz00;
   int BgL_trackz00;
   int BgL_yearz00;
   obj_t BgL_genrez00;
   obj_t BgL_commentz00;
   obj_t BgL_ufidz00;
   obj_t BgL_copyrightz00;
   obj_t BgL_picturez00;
} *BgL_musictagz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_mpdzd2databasezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_directoriesz00;
   obj_t BgL_suffixesz00;
   obj_t BgL_z52basez52;
   obj_t BgL_z52artistsz52;
   obj_t BgL_z52albumsz52;
   obj_t BgL_z52genresz52;
   obj_t BgL_z52nartistsz52;
   int BgL_z52nalbumsz52;
   int BgL_z52nsongsz52;
   obj_t BgL_z52uptimez52;
   obj_t BgL_z52dbzd2updatez80;
} *BgL_mpdzd2databasezd2_bglt;


static obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
extern obj_t BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_directory_to_list(char *);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
extern obj_t BGl_musiczd2nextzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, int, obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
BGL_IMPORT obj_t BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
static obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32658ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assocz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz121349z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t bgl_seconds_to_date(long);
static obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1365z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
static obj_t BGl_search1343ze70ze7zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2stopzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_search1335ze70ze7zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2skipzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
BGL_IMPORT obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2mapzd2zz__hashz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
BGL_IMPORT obj_t BGl_dirnamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
BGL_IMPORT obj_t BGl_fprintfz00zz__r4_output_6_10_3z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, bool_t);
static obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_basenamez00zz__osz00(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ti1379zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt, obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32312ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32061ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern obj_t BGl_musiczd2pausezd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1351z53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32402ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getarti1389z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2prevzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT long bgl_current_seconds();
static obj_t BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1387z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, int);
static obj_t BGl_z62mpdzd2databasezd2findzd2ar1373zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
BGL_IMPORT obj_t BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32332ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfo1369z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BUNSPEC;
static bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
static long BGl_cmdnz00zz__multimediazd2mpdzd2;
BGL_IMPORT obj_t BGl_makezd2datezd2zz__datez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32325ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern BgL_musicstatusz00_bglt BGl_musiczd2statuszd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
extern obj_t BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2listalb1357z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_filezd2namezd2ze3listze3zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
static obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
static obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32360ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32182ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t fexists(char *);
static long BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2;
extern obj_t BGl_musicz00zz__multimediazd2musiczd2;
static obj_t BGl_zc3z04exitza32047ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32353ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2alb1395zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32346ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2();
static bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62lambda2400z62zz__multimediazd2mpdzd2(obj_t, obj_t);
extern obj_t BGl_musicinfoz00zz__multimediazd2id3zd2;
static obj_t BGl_z62lambda2401z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2320z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_prefixz00zz__osz00(obj_t);
static bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2();
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2323z62zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32339ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32177ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62iozd2errorzb0zz__objectz00;
static obj_t BGl_z62mpdzd2databasezd2findzd2al1371zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2filezd2pathz00zz__osz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda2330z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2331z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcmp_at(obj_t, obj_t, long);
static obj_t BGl_z62lambda2337z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2338z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
extern obj_t BGl_filezd2musictagzd2zz__multimediazd2id3zd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32381ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern obj_t BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62lambda2344z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2345z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musictagz00zz__multimediazd2id3zd2;
BGL_IMPORT obj_t BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listart1359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t, obj_t);
static bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2stats1353z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2351z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2352z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32374ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2metazd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bgl_directoryp(char *);
static obj_t BGl_z62lambda2358z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ge1381zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
extern int BGl_musiczd2songzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listart1367z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21377zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
static obj_t BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32367ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62lambda2365z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2366z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listall1355z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_zc3z04exitza32058ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2372z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2373z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_last_modification_time(char *);
static obj_t BGl_z62lambda2379z62zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, bool_t, obj_t);
static bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT long bgl_date_to_seconds(obj_t);
static obj_t BGl_z62lambda2380z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
extern obj_t BGl_musiczd2seekzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62lambda2386z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2387z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda2393z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2394z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32581ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32395ze3ze5zz__multimediazd2mpdzd2(obj_t);
static bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT int BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t __cnst[ 104 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3003z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2330za7623114z00, BGl_z62lambda2330z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3004z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3115za7, BGl_z62zc3z04anonymousza32339ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3005z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2338za7623116z00, BGl_z62lambda2338z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3006z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2337za7623117z00, BGl_z62lambda2337z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3007z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3118za7, BGl_z62zc3z04anonymousza32346ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3008z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2345za7623119z00, BGl_z62lambda2345z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3009z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2344za7623120z00, BGl_z62lambda2344z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2lsinfoza73121za7, BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3010z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3122za7, BGl_z62zc3z04anonymousza32353ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3011z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2352za7623123z00, BGl_z62lambda2352z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3012z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2351za7623124z00, BGl_z62lambda2351z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3100z00zz__multimediazd2mpdzd2, BgL_bgl_string3100za700za7za7_3125za7, "&mpd-database-find-artist", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3013z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3126za7, BGl_z62zc3z04anonymousza32360ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3101z00zz__multimediazd2mpdzd2, BgL_bgl_string3101za700za7za7_3127za7, "&mpd-database-search-artist-album", 33 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3014z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2359za7623128z00, BGl_z62lambda2359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3102z00zz__multimediazd2mpdzd2, BgL_bgl_string3102za700za7za7_3129za7, "&mpd-database-search-artist-title", 33 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3015z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2358za7623130z00, BGl_z62lambda2358z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3103z00zz__multimediazd2mpdzd2, BgL_bgl_string3103za700za7za7_3131za7, "&mpd-database-find-title", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3016z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3132za7, BGl_z62zc3z04anonymousza32367ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3104z00zz__multimediazd2mpdzd2, BgL_bgl_string3104za700za7za7_3133za7, "&mpd-database-find-genre", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3017z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2366za7623134z00, BGl_z62lambda2366z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3105z00zz__multimediazd2mpdzd2, BgL_bgl_string3105za700za7za7_3135za7, "&mpd-database-getgenre", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3018z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2365za7623136z00, BGl_z62lambda2365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3106z00zz__multimediazd2mpdzd2, BgL_bgl_string3106za700za7za7_3137za7, "&mpd-database-getartist", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3019z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3138za7, BGl_z62zc3z04anonymousza32374ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3107z00zz__multimediazd2mpdzd2, BgL_bgl_string3107za700za7za7_3139za7, "&mpd-database-getgenreartist", 28 );
DEFINE_STRING( BGl_string3108z00zz__multimediazd2mpdzd2, BgL_bgl_string3108za700za7za7_3140za7, "&mpd-database-getartistalbum", 28 );
DEFINE_STRING( BGl_string3109z00zz__multimediazd2mpdzd2, BgL_bgl_string3109za700za7za7_3141za7, "&mpd-database-get-album", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3020z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2373za7623142z00, BGl_z62lambda2373z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3021z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2372za7623143z00, BGl_z62lambda2372z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3022z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3144za7, BGl_z62zc3z04anonymousza32381ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3110z00zz__multimediazd2mpdzd2, BgL_bgl_string3110za700za7za7_3145za7, "__multimedia-mpd", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3023z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2380za7623146z00, BGl_z62lambda2380z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3111z00zz__multimediazd2mpdzd2, BgL_bgl_string3111za700za7za7_3147za7, "(\"mp3\" \"flac\" \"ogg\" \"wav\") __multimedia-mpd mpd-database %db-update %uptime %nsongs int %nalbums obj %nartists %genres %albums %artists bstring %base suffixes pair-nil directories :Image :Time :Last-Modified :file :Genre :Date :Track :Album :Title :Artist (\"jpg\" \"JPG\" \"png\" \"gif\" \"GIF\") any genre disc album title artist :image :artist :album infofile (:album :artist :image) (\"Artist\" \"Album\" \"Title\" \"Track\" \"Name\" \"Genre\" \"Date\" \"Composer\" \"Performer\" \"Disc\") (\"http://\" \"file://\") :err :command mpd-err (:command :err) command_list_end command_list_ok_begin command_list_begin blank ok :log (:log) mpd outputs update swapid swap shuffle save rm repeat random password moveid move crossfade addid notcommands commands search find kill plconangesposid lsinfo listallinfo list listall stats close clearerror setvol volume previous next pause stop seekid seek playid play currentsong clear deleteid delete add plchanges playlistid playlistinfo playlist status tagtypes urlhandlers "
"ping ", 987 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3024z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2379za7623148z00, BGl_z62lambda2379z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3025z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3149za7, BGl_z62zc3z04anonymousza32388ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3026z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2387za7623150z00, BGl_z62lambda2387z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3027z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2386za7623151z00, BGl_z62lambda2386z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3028z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3152za7, BGl_z62zc3z04anonymousza32395ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3029z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2394za7623153z00, BGl_z62lambda2394z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3038z00zz__multimediazd2mpdzd2, BgL_bgl_string3038za700za7za7_3154za7, "mpd-database-init!1349", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3030z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2393za7623155z00, BGl_z62lambda2393z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3031z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3156za7, BGl_z62zc3z04anonymousza32402ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3032z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2401za7623157z00, BGl_z62lambda2401z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3033z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2400za7623158z00, BGl_z62lambda2400z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3040z00zz__multimediazd2mpdzd2, BgL_bgl_string3040za700za7za7_3159za7, "mpd-database-file->p1351", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3034z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3160za7, BGl_z62zc3z04anonymousza32325ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3035z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2323za7623161z00, BGl_z62lambda2323z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3042z00zz__multimediazd2mpdzd2, BgL_bgl_string3042za700za7za7_3162za7, "mpd-database-stats1353", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3036z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2320za7623163z00, BGl_z62lambda2320z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3037z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3164z00, BGl_z62mpdzd2databasezd2initz121349z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3044z00zz__multimediazd2mpdzd2, BgL_bgl_string3044za700za7za7_3165za7, "mpd-database-listall1355", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3039z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3166z00, BGl_z62mpdzd2databasezd2filezd2ze3p1351z53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3046z00zz__multimediazd2mpdzd2, BgL_bgl_string3046za700za7za7_3167za7, "mpd-database-listalb1357", 24 );
DEFINE_STRING( BGl_string3048z00zz__multimediazd2mpdzd2, BgL_bgl_string3048za700za7za7_3168za7, "mpd-database-listart1359", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3169z00, BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekidza73170za7, BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2searchza73171za7, BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playza7b03172za7, BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3041z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3173z00, BGl_z62mpdzd2databasezd2stats1353z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3043z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3174z00, BGl_z62mpdzd2databasezd2listall1355z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3050z00zz__multimediazd2mpdzd2, BgL_bgl_string3050za700za7za7_3175za7, "mpd-database-listgen1361", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3045z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3176z00, BGl_z62mpdzd2databasezd2listalb1357z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3052z00zz__multimediazd2mpdzd2, BgL_bgl_string3052za700za7za7_3177za7, "mpd-database-listgen1363", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3047z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3178z00, BGl_z62mpdzd2databasezd2listart1359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3054z00zz__multimediazd2mpdzd2, BgL_bgl_string3054za700za7za7_3179za7, "mpd-database-listgen1365", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2rmza7b0za7za73180za7, BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3049z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3181z00, BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3056z00zz__multimediazd2mpdzd2, BgL_bgl_string3056za700za7za7_3182za7, "mpd-database-listart1367", 24 );
DEFINE_STRING( BGl_string3058z00zz__multimediazd2mpdzd2, BgL_bgl_string3058za700za7za7_3183za7, "mpd-database-lsinfo1369", 23 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3184z00, BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deleteza73185za7, BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3186z00, BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3051z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3187z00, BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3053z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3188z00, BGl_z62mpdzd2databasezd2listgen1365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3060z00zz__multimediazd2mpdzd2, BgL_bgl_string3060za700za7za7_3189za7, "mpd-database-find-al1371", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3055z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3190z00, BGl_z62mpdzd2databasezd2listart1367z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3062z00zz__multimediazd2mpdzd2, BgL_bgl_string3062za700za7za7_3191za7, "mpd-database-find-ar1373", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3057z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3192z00, BGl_z62mpdzd2databasezd2lsinfo1369z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3064z00zz__multimediazd2mpdzd2, BgL_bgl_string3064za700za7za7_3193za7, "mpd-database-search-1375", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3059z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3194z00, BGl_z62mpdzd2databasezd2findzd2al1371zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3066z00zz__multimediazd2mpdzd2, BgL_bgl_string3066za700za7za7_3195za7, "mpd-database-search-1377", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2notcomm3196z00, BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3068z00zz__multimediazd2mpdzd2, BgL_bgl_string3068za700za7za7_3197za7, "mpd-database-find-ti1379", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3198z00, BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3061z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3199z00, BGl_z62mpdzd2databasezd2findzd2ar1373zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3063z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3200z00, BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3070z00zz__multimediazd2mpdzd2, BgL_bgl_string3070za700za7za7_3201za7, "mpd-database-find-ge1381", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3065z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3202z00, BGl_z62mpdzd2databasezd2searchzd21377zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3072z00zz__multimediazd2mpdzd2, BgL_bgl_string3072za700za7za7_3203za7, "mpd-database-getgenr1383", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3067z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3204z00, BGl_z62mpdzd2databasezd2findzd2ti1379zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3074z00zz__multimediazd2mpdzd2, BgL_bgl_string3074za700za7za7_3205za7, "mpd-database-getarti1385", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3069z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3206z00, BGl_z62mpdzd2databasezd2findzd2ge1381zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3076z00zz__multimediazd2mpdzd2, BgL_bgl_string3076za700za7za7_3207za7, "mpd-database-getgenr1387", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2updateza73208za7, BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3078z00zz__multimediazd2mpdzd2, BgL_bgl_string3078za700za7za7_3209za7, "mpd-database-getarti1389", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3210z00, BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3071z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3211z00, BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3073z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3212z00, BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3080z00zz__multimediazd2mpdzd2, BgL_bgl_string3080za700za7za7_3213za7, "mpd-database-get-alb1395", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3075z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3214z00, BGl_z62mpdzd2databasezd2getgenr1387z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3082z00zz__multimediazd2mpdzd2, BgL_bgl_string3082za700za7za7_3215za7, "directory: ", 11 );
DEFINE_STRING( BGl_string3083z00zz__multimediazd2mpdzd2, BgL_bgl_string3083za700za7za7_3216za7, "lsinfo", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3077z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3217z00, BGl_z62mpdzd2databasezd2getarti1389z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3084z00zz__multimediazd2mpdzd2, BgL_bgl_string3084za700za7za7_3218za7, "Genre: ", 7 );
DEFINE_STRING( BGl_string3085z00zz__multimediazd2mpdzd2, BgL_bgl_string3085za700za7za7_3219za7, "artists: ~a\nalbums: ~a\nsongs: ~a\nuptime: ~a\nplaytime: ~a\ndb_playtime: 10000000\ndb_update: ~a\n", 93 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3079z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3220z00, BGl_z62mpdzd2databasezd2getzd2alb1395zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3087z00zz__multimediazd2mpdzd2, BgL_bgl_string3087za700za7za7_3221za7, "&mpd-database-init!", 19 );
DEFINE_STRING( BGl_string3088z00zz__multimediazd2mpdzd2, BgL_bgl_string3088za700za7za7_3222za7, "&mpd-database-file->path", 24 );
DEFINE_STRING( BGl_string3089z00zz__multimediazd2mpdzd2, BgL_bgl_string3089za700za7za7_3223za7, "bstring", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearer3224z00, BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3081z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3225za7, BGl_z62zc3z04anonymousza32581ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3090z00zz__multimediazd2mpdzd2, BgL_bgl_string3090za700za7za7_3226za7, "&mpd-database-stats", 19 );
DEFINE_STRING( BGl_string3091z00zz__multimediazd2mpdzd2, BgL_bgl_string3091za700za7za7_3227za7, "&mpd-database-listall", 21 );
DEFINE_STRING( BGl_string3092z00zz__multimediazd2mpdzd2, BgL_bgl_string3092za700za7za7_3228za7, "&mpd-database-listalbum", 23 );
DEFINE_STRING( BGl_string3093z00zz__multimediazd2mpdzd2, BgL_bgl_string3093za700za7za7_3229za7, "&mpd-database-listartistalbum", 29 );
DEFINE_STRING( BGl_string3094z00zz__multimediazd2mpdzd2, BgL_bgl_string3094za700za7za7_3230za7, "&mpd-database-listgenrealbum", 28 );
DEFINE_STRING( BGl_string3095z00zz__multimediazd2mpdzd2, BgL_bgl_string3095za700za7za7_3231za7, "&mpd-database-listgenreartist", 29 );
DEFINE_STRING( BGl_string3096z00zz__multimediazd2mpdzd2, BgL_bgl_string3096za700za7za7_3232za7, "&mpd-database-listgenre", 23 );
DEFINE_STRING( BGl_string3097z00zz__multimediazd2mpdzd2, BgL_bgl_string3097za700za7za7_3233za7, "&mpd-database-listartist", 24 );
DEFINE_STRING( BGl_string3098z00zz__multimediazd2mpdzd2, BgL_bgl_string3098za700za7za7_3234za7, "&mpd-database-lsinfo", 20 );
DEFINE_STRING( BGl_string3099z00zz__multimediazd2mpdzd2, BgL_bgl_string3099za700za7za7_3235za7, "&mpd-database-find-album", 24 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3236z00, BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2current3237z00, BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekza7b03238za7, BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pingza7b03239za7, BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2command3240z00, BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2nextza7b03241za7, BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2stopza7b03242za7, BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2previou3243z00, BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3244z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2crossfa3245z00, BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_LLONG( BGl_llong3086z00zz__multimediazd2mpdzd2, BgL_bgl_llong3086za700za7za7__3246za7, ((BGL_LONGLONG_T)0) );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpdzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl__mpdza700za7za7__multi3247za7, opt_generic_entry, BGl__mpdz00zz__multimediazd2mpdzd2, BFALSE, -1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2setvolza73248za7, BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3249z00, BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3250z00, BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3251z00, BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3252z00, BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statusza73253za7, BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearza7b3254za7, BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3255z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2saveza7b03256za7, BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3257z00, BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3258z00, BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2927z00zz__multimediazd2mpdzd2, BgL_bgl_string2927za700za7za7_3259za7, "", 0 );
DEFINE_STRING( BGl_string2928z00zz__multimediazd2mpdzd2, BgL_bgl_string2928za700za7za7_3260za7, "wrong number of arguments: [4..5] expected, provided", 52 );
DEFINE_STRING( BGl_string2929z00zz__multimediazd2mpdzd2, BgL_bgl_string2929za700za7za7_3261za7, "Illegal keyword argument", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plconan3262z00, BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3263z00, BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addidza7b3264za7, BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3265z00, BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pauseza7b3266za7, BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2930z00zz__multimediazd2mpdzd2, BgL_bgl_string2930za700za7za7_3267za7, "/builddir/build/BUILD/bigloo-4.4b/api/multimedia/src/Llib/mpd.scm", 65 );
DEFINE_STRING( BGl_string2931z00zz__multimediazd2mpdzd2, BgL_bgl_string2931za700za7za7_3268za7, "_mpd", 4 );
DEFINE_STRING( BGl_string2932z00zz__multimediazd2mpdzd2, BgL_bgl_string2932za700za7za7_3269za7, "bint", 4 );
DEFINE_STRING( BGl_string2933z00zz__multimediazd2mpdzd2, BgL_bgl_string2933za700za7za7_3270za7, "music", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveidza73271za7, BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2934z00zz__multimediazd2mpdzd2, BgL_bgl_string2934za700za7za7_3272za7, "input-port", 10 );
DEFINE_STRING( BGl_string2935z00zz__multimediazd2mpdzd2, BgL_bgl_string2935za700za7za7_3273za7, "output-port", 11 );
DEFINE_STRING( BGl_string2936z00zz__multimediazd2mpdzd2, BgL_bgl_string2936za700za7za7_3274za7, "mpd-database", 12 );
DEFINE_STRING( BGl_string2937z00zz__multimediazd2mpdzd2, BgL_bgl_string2937za700za7za7_3275za7, "OK MPD 0.16.0", 13 );
DEFINE_STRING( BGl_string2938z00zz__multimediazd2mpdzd2, BgL_bgl_string2938za700za7za7_3276za7, "OK\n", 3 );
DEFINE_STRING( BGl_string2939z00zz__multimediazd2mpdzd2, BgL_bgl_string2939za700za7za7_3277za7, "ACK [", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2killza7b03278za7, BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2shuffle3279z00, BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2closeza7b3280za7, BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2randomza73281za7, BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2940z00zz__multimediazd2mpdzd2, BgL_bgl_string2940za700za7za7_3282za7, "5@0", 3 );
DEFINE_STRING( BGl_string2941z00zz__multimediazd2mpdzd2, BgL_bgl_string2941za700za7za7_3283za7, "] {", 3 );
DEFINE_STRING( BGl_string2942z00zz__multimediazd2mpdzd2, BgL_bgl_string2942za700za7za7_3284za7, "} ", 2 );
DEFINE_STRING( BGl_string2943z00zz__multimediazd2mpdzd2, BgL_bgl_string2943za700za7za7_3285za7, "\n", 1 );
DEFINE_STRING( BGl_string2944z00zz__multimediazd2mpdzd2, BgL_bgl_string2944za700za7za7_3286za7, "unknown command \"~a\"", 20 );
DEFINE_STRING( BGl_string2945z00zz__multimediazd2mpdzd2, BgL_bgl_string2945za700za7za7_3287za7, "list_OK\n", 8 );
DEFINE_STRING( BGl_string2946z00zz__multimediazd2mpdzd2, BgL_bgl_string2946za700za7za7_3288za7, "wrong number of arguments: [2..4] expected, provided", 52 );
DEFINE_STRING( BGl_string2947z00zz__multimediazd2mpdzd2, BgL_bgl_string2947za700za7za7_3289za7, "handler: ", 9 );
DEFINE_STRING( BGl_string2948z00zz__multimediazd2mpdzd2, BgL_bgl_string2948za700za7za7_3290za7, "tagtype: ", 9 );
DEFINE_STRING( BGl_string2949z00zz__multimediazd2mpdzd2, BgL_bgl_string2949za700za7za7_3291za7, "volume: ", 8 );
DEFINE_STRING( BGl_string2950z00zz__multimediazd2mpdzd2, BgL_bgl_string2950za700za7za7_3292za7, "state: ", 7 );
DEFINE_STRING( BGl_string2951z00zz__multimediazd2mpdzd2, BgL_bgl_string2951za700za7za7_3293za7, "playlist: ", 10 );
DEFINE_STRING( BGl_string2952z00zz__multimediazd2mpdzd2, BgL_bgl_string2952za700za7za7_3294za7, "playlistlength: ", 16 );
DEFINE_STRING( BGl_string2953z00zz__multimediazd2mpdzd2, BgL_bgl_string2953za700za7za7_3295za7, "song: ", 6 );
DEFINE_STRING( BGl_string2954z00zz__multimediazd2mpdzd2, BgL_bgl_string2954za700za7za7_3296za7, "songid: ", 8 );
DEFINE_STRING( BGl_string2955z00zz__multimediazd2mpdzd2, BgL_bgl_string2955za700za7za7_3297za7, "bitrate: ", 9 );
DEFINE_STRING( BGl_string2956z00zz__multimediazd2mpdzd2, BgL_bgl_string2956za700za7za7_3298za7, "audio: ", 7 );
DEFINE_STRING( BGl_string2957z00zz__multimediazd2mpdzd2, BgL_bgl_string2957za700za7za7_3299za7, ":16:2\n", 6 );
DEFINE_STRING( BGl_string2958z00zz__multimediazd2mpdzd2, BgL_bgl_string2958za700za7za7_3300za7, "time: ", 6 );
DEFINE_STRING( BGl_string2959z00zz__multimediazd2mpdzd2, BgL_bgl_string2959za700za7za7_3301za7, ":", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statsza7b3302za7, BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deletei3303z00, BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2960z00zz__multimediazd2mpdzd2, BgL_bgl_string2960za700za7za7_3304za7, "repeat: 1\n", 10 );
DEFINE_STRING( BGl_string2961z00zz__multimediazd2mpdzd2, BgL_bgl_string2961za700za7za7_3305za7, "repeat: 0\n", 10 );
DEFINE_STRING( BGl_string2962z00zz__multimediazd2mpdzd2, BgL_bgl_string2962za700za7za7_3306za7, "random: 1\n", 10 );
DEFINE_STRING( BGl_string2963z00zz__multimediazd2mpdzd2, BgL_bgl_string2963za700za7za7_3307za7, "random: 0\n", 10 );
DEFINE_STRING( BGl_string2964z00zz__multimediazd2mpdzd2, BgL_bgl_string2964za700za7za7_3308za7, "xfade: ", 7 );
DEFINE_STRING( BGl_string2965z00zz__multimediazd2mpdzd2, BgL_bgl_string2965za700za7za7_3309za7, ": ", 2 );
DEFINE_STRING( BGl_string2966z00zz__multimediazd2mpdzd2, BgL_bgl_string2966za700za7za7_3310za7, "wrong number of arguments: [3..6] expected, provided", 52 );
DEFINE_STRING( BGl_string2967z00zz__multimediazd2mpdzd2, BgL_bgl_string2967za700za7za7_3311za7, "http://", 7 );
DEFINE_STRING( BGl_string2968z00zz__multimediazd2mpdzd2, BgL_bgl_string2968za700za7za7_3312za7, "add", 3 );
DEFINE_STRING( BGl_string2969z00zz__multimediazd2mpdzd2, BgL_bgl_string2969za700za7za7_3313za7, "illegal uri \"~a\"", 16 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3314z00, BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plchang3315z00, BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2volumeza73316za7, BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2970z00zz__multimediazd2mpdzd2, BgL_bgl_string2970za700za7za7_3317za7, "file: ", 6 );
DEFINE_STRING( BGl_string2971z00zz__multimediazd2mpdzd2, BgL_bgl_string2971za700za7za7_3318za7, "Pos: ", 5 );
DEFINE_STRING( BGl_string2972z00zz__multimediazd2mpdzd2, BgL_bgl_string2972za700za7za7_3319za7, "Id: ", 4 );
DEFINE_STRING( BGl_string2973z00zz__multimediazd2mpdzd2, BgL_bgl_string2973za700za7za7_3320za7, "Artist: ", 8 );
DEFINE_STRING( BGl_string2974z00zz__multimediazd2mpdzd2, BgL_bgl_string2974za700za7za7_3321za7, "Title: ", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addza7b0za73322z00, BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2975z00zz__multimediazd2mpdzd2, BgL_bgl_string2975za700za7za7_3323za7, "Album: ", 7 );
DEFINE_STRING( BGl_string2976z00zz__multimediazd2mpdzd2, BgL_bgl_string2976za700za7za7_3324za7, "50@0", 4 );
DEFINE_STRING( BGl_string2977z00zz__multimediazd2mpdzd2, BgL_bgl_string2977za700za7za7_3325za7, "next", 4 );
DEFINE_STRING( BGl_string2978z00zz__multimediazd2mpdzd2, BgL_bgl_string2978za700za7za7_3326za7, "No more song", 12 );
DEFINE_STRING( BGl_string2979z00zz__multimediazd2mpdzd2, BgL_bgl_string2979za700za7za7_3327za7, "previous", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2tagtype3328z00, BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2980z00zz__multimediazd2mpdzd2, BgL_bgl_string2980za700za7za7_3329za7, "No previous song", 16 );
DEFINE_STRING( BGl_string2981z00zz__multimediazd2mpdzd2, BgL_bgl_string2981za700za7za7_3330za7, "artist", 6 );
DEFINE_STRING( BGl_string2982z00zz__multimediazd2mpdzd2, BgL_bgl_string2982za700za7za7_3331za7, "genre", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapidza73332za7, BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2983z00zz__multimediazd2mpdzd2, BgL_bgl_string2983za700za7za7_3333za7, "unknown list type \"~a\"", 22 );
DEFINE_STRING( BGl_string2984z00zz__multimediazd2mpdzd2, BgL_bgl_string2984za700za7za7_3334za7, "ACK [2@0] {list} too few arguments for \"list\"", 45 );
DEFINE_STRING( BGl_string2985z00zz__multimediazd2mpdzd2, BgL_bgl_string2985za700za7za7_3335za7, "cpos: ", 6 );
DEFINE_STRING( BGl_string2986z00zz__multimediazd2mpdzd2, BgL_bgl_string2986za700za7za7_3336za7, "unknown find type \"~a\"", 22 );
DEFINE_STRING( BGl_string2987z00zz__multimediazd2mpdzd2, BgL_bgl_string2987za700za7za7_3337za7, "unknown search type \"~a\"", 24 );
DEFINE_STRING( BGl_string2989z00zz__multimediazd2mpdzd2, BgL_bgl_string2989za700za7za7_3338za7, "command: ", 9 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3339z00, BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapza7b03340za7, BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3341z00, BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2urlhand3342z00, BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string2992z00zz__multimediazd2mpdzd2, BgL_bgl_string2992za700za7za7_3343za7, "No such file", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2988z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3344za7, BGl_z62zc3z04anonymousza32101ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2997z00zz__multimediazd2mpdzd2, BgL_bgl_string2997za700za7za7_3345za7, "~a-~2,0d-~2,0dT~2,0d:~2,0d:~2,0dZ", 33 );
DEFINE_STRING( BGl_string2998z00zz__multimediazd2mpdzd2, BgL_bgl_string2998za700za7za7_3346za7, "unknown", 7 );
DEFINE_STRING( BGl_string2999z00zz__multimediazd2mpdzd2, BgL_bgl_string2999za700za7za7_3347za7, "Unknown Disc", 12 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3348z00, BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2findza7b03349za7, BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2990z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3350za7, BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2outputs3351z00, BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2991z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3352za7, BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2993z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3353za7, BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2994z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3354za7, BGl_z62zc3z04anonymousza32177ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2995z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3355za7, BGl_z62zc3z04anonymousza32182ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2996z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3356za7, BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playidza73357za7, BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3358z00, BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveza7b03359za7, BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3360z00, BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3361z00, BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3362z00, BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listza7b03363za7, BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3364z00, BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2repeatza73365za7, BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3366z00, BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2passwor3367z00, BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3368z00, BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3000z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3369za7, BGl_z62zc3z04anonymousza32312ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3001z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3370za7, BGl_z62zc3z04anonymousza32332ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3002z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2331za7623371z00, BGl_z62lambda2331z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long BgL_checksumz00_5525, char * BgL_fromz00_5526)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_cnstzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_objectzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_genericzd2initzd2zz__multimediazd2mpdzd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__multimedia-mpd"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_cportz00_5048;
{ /* Llib/mpd.scm 15 */
obj_t BgL_stringz00_5056;
BgL_stringz00_5056 = BGl_string3111z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 15 */
obj_t BgL_startz00_5057;
BgL_startz00_5057 = 
BINT(((long)0)); 
{ /* Llib/mpd.scm 15 */
obj_t BgL_endz00_5058;
BgL_endz00_5058 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5056))); 
{ /* Llib/mpd.scm 15 */

BgL_cportz00_5048 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5056, BgL_startz00_5057, BgL_endz00_5058); } } } } 
{ 
long BgL_iz00_5049;
BgL_iz00_5049 = ((long)103); 
BgL_loopz00_5050:
if(
(BgL_iz00_5049==((long)-1)))
{ /* Llib/mpd.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_arg3113z00_5052;
{ /* Llib/mpd.scm 15 */

{ /* Llib/mpd.scm 15 */
obj_t BgL_locationz00_5054;
BgL_locationz00_5054 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpd.scm 15 */

BgL_arg3113z00_5052 = 
BGl_readz00zz__readerz00(BgL_cportz00_5048, BgL_locationz00_5054); } } } 
{ /* Llib/mpd.scm 15 */
int BgL_tmpz00_5567;
BgL_tmpz00_5567 = 
(int)(BgL_iz00_5049); 
CNST_TABLE_SET(BgL_tmpz00_5567, BgL_arg3113z00_5052); } } 
{ /* Llib/mpd.scm 15 */
int BgL_auxz00_5055;
BgL_auxz00_5055 = 
(int)(
(BgL_iz00_5049-((long)1))); 
{ 
long BgL_iz00_5572;
BgL_iz00_5572 = 
(long)(BgL_auxz00_5055); 
BgL_iz00_5049 = BgL_iz00_5572; 
goto BgL_loopz00_5050;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_cmdnz00zz__multimediazd2mpdzd2 = ((long)0); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1431z00_419;
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1506z00_420;
BgL_arg1506z00_420 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)0)), BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_list1508z00_421;
BgL_list1508z00_421 = 
MAKE_YOUNG_PAIR(BgL_arg1506z00_420, BNIL); 
BgL_arg1431z00_419 = BgL_list1508z00_421; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1431z00_419); } 
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1512z00_422;
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1516z00_423;
BgL_arg1516z00_423 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 344 */
obj_t BgL_list1517z00_424;
BgL_list1517z00_424 = 
MAKE_YOUNG_PAIR(BgL_arg1516z00_423, BNIL); 
BgL_arg1512z00_422 = BgL_list1517z00_424; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1512z00_422); } 
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1524z00_425;
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1530z00_426;
BgL_arg1530z00_426 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)2)), BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 354 */
obj_t BgL_list1531z00_427;
BgL_list1531z00_427 = 
MAKE_YOUNG_PAIR(BgL_arg1530z00_426, BNIL); 
BgL_arg1524z00_425 = BgL_list1531z00_427; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1524z00_425); } 
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1538z00_428;
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1539z00_429;
BgL_arg1539z00_429 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 371 */
obj_t BgL_list1540z00_430;
BgL_list1540z00_430 = 
MAKE_YOUNG_PAIR(BgL_arg1539z00_429, BNIL); 
BgL_arg1538z00_428 = BgL_list1540z00_430; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1538z00_428); } 
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1543z00_431;
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1544z00_432;
BgL_arg1544z00_432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)4)), BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 406 */
obj_t BgL_list1545z00_433;
BgL_list1545z00_433 = 
MAKE_YOUNG_PAIR(BgL_arg1544z00_432, BNIL); 
BgL_arg1543z00_431 = BgL_list1545z00_433; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1543z00_431); } 
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1562z00_434;
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1563z00_435;
BgL_arg1563z00_435 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)5)), BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 447 */
obj_t BgL_list1564z00_436;
BgL_list1564z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1563z00_435, BNIL); 
BgL_arg1562z00_434 = BgL_list1564z00_436; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1562z00_434); } 
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1580z00_437;
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1581z00_438;
BgL_arg1581z00_438 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 453 */
obj_t BgL_list1582z00_439;
BgL_list1582z00_439 = 
MAKE_YOUNG_PAIR(BgL_arg1581z00_438, BNIL); 
BgL_arg1580z00_437 = BgL_list1582z00_439; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1580z00_437); } 
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1591z00_440;
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1593z00_441;
BgL_arg1593z00_441 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 459 */
obj_t BgL_list1594z00_442;
BgL_list1594z00_442 = 
MAKE_YOUNG_PAIR(BgL_arg1593z00_441, BNIL); 
BgL_arg1591z00_440 = BgL_list1594z00_442; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1591z00_440); } 
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1615z00_443;
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1616z00_444;
BgL_arg1616z00_444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 477 */
obj_t BgL_list1617z00_445;
BgL_list1617z00_445 = 
MAKE_YOUNG_PAIR(BgL_arg1616z00_444, BNIL); 
BgL_arg1615z00_443 = BgL_list1617z00_445; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1615z00_443); } 
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1619z00_446;
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1624z00_447;
BgL_arg1624z00_447 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 493 */
obj_t BgL_list1625z00_448;
BgL_list1625z00_448 = 
MAKE_YOUNG_PAIR(BgL_arg1624z00_447, BNIL); 
BgL_arg1619z00_446 = BgL_list1625z00_448; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1619z00_446); } 
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1626z00_449;
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1627z00_450;
BgL_arg1627z00_450 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 500 */
obj_t BgL_list1628z00_451;
BgL_list1628z00_451 = 
MAKE_YOUNG_PAIR(BgL_arg1627z00_450, BNIL); 
BgL_arg1626z00_449 = BgL_list1628z00_451; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1626z00_449); } 
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1631z00_452;
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1636z00_453;
BgL_arg1636z00_453 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 507 */
obj_t BgL_list1637z00_454;
BgL_list1637z00_454 = 
MAKE_YOUNG_PAIR(BgL_arg1636z00_453, BNIL); 
BgL_arg1631z00_452 = BgL_list1637z00_454; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1631z00_452); } 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BFALSE; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = ((long)-1); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BGl_string2927z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1643z00_455;
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1644z00_456;
BgL_arg1644z00_456 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 579 */
obj_t BgL_list1645z00_457;
BgL_list1645z00_457 = 
MAKE_YOUNG_PAIR(BgL_arg1644z00_456, BNIL); 
BgL_arg1643z00_455 = BgL_list1645z00_457; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1643z00_455); } 
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1647z00_458;
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1648z00_459;
BgL_arg1648z00_459 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 589 */
obj_t BgL_list1649z00_460;
BgL_list1649z00_460 = 
MAKE_YOUNG_PAIR(BgL_arg1648z00_459, BNIL); 
BgL_arg1647z00_458 = BgL_list1649z00_460; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1647z00_458); } 
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1652z00_461;
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1656z00_462;
BgL_arg1656z00_462 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 598 */
obj_t BgL_list1657z00_463;
BgL_list1657z00_463 = 
MAKE_YOUNG_PAIR(BgL_arg1656z00_462, BNIL); 
BgL_arg1652z00_461 = BgL_list1657z00_463; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1652z00_461); } 
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1661z00_464;
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1662z00_465;
BgL_arg1662z00_465 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 607 */
obj_t BgL_list1663z00_466;
BgL_list1663z00_466 = 
MAKE_YOUNG_PAIR(BgL_arg1662z00_465, BNIL); 
BgL_arg1661z00_464 = BgL_list1663z00_466; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1661z00_464); } 
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1671z00_467;
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1674z00_468;
BgL_arg1674z00_468 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 614 */
obj_t BgL_list1675z00_469;
BgL_list1675z00_469 = 
MAKE_YOUNG_PAIR(BgL_arg1674z00_468, BNIL); 
BgL_arg1671z00_467 = BgL_list1675z00_469; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1671z00_467); } 
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1677z00_470;
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1678z00_471;
BgL_arg1678z00_471 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 621 */
obj_t BgL_list1679z00_472;
BgL_list1679z00_472 = 
MAKE_YOUNG_PAIR(BgL_arg1678z00_471, BNIL); 
BgL_arg1677z00_470 = BgL_list1679z00_472; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1677z00_470); } 
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1681z00_473;
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1684z00_474;
BgL_arg1684z00_474 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 628 */
obj_t BgL_list1685z00_475;
BgL_list1685z00_475 = 
MAKE_YOUNG_PAIR(BgL_arg1684z00_474, BNIL); 
BgL_arg1681z00_473 = BgL_list1685z00_475; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1681z00_473); } 
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1696z00_476;
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1697z00_477;
BgL_arg1697z00_477 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 635 */
obj_t BgL_list1698z00_478;
BgL_list1698z00_478 = 
MAKE_YOUNG_PAIR(BgL_arg1697z00_477, BNIL); 
BgL_arg1696z00_476 = BgL_list1698z00_478; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1696z00_476); } 
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1699z00_479;
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1700z00_480;
BgL_arg1700z00_480 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)20)), BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 648 */
obj_t BgL_list1701z00_481;
BgL_list1701z00_481 = 
MAKE_YOUNG_PAIR(BgL_arg1700z00_480, BNIL); 
BgL_arg1699z00_479 = BgL_list1701z00_481; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1699z00_479); } 
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1703z00_482;
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1705z00_483;
BgL_arg1705z00_483 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)21)), BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 661 */
obj_t BgL_list1706z00_484;
BgL_list1706z00_484 = 
MAKE_YOUNG_PAIR(BgL_arg1705z00_483, BNIL); 
BgL_arg1703z00_482 = BgL_list1706z00_484; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1703z00_482); } 
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1712z00_485;
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1713z00_486;
BgL_arg1713z00_486 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)22)), BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 684 */
obj_t BgL_list1714z00_487;
BgL_list1714z00_487 = 
MAKE_YOUNG_PAIR(BgL_arg1713z00_486, BNIL); 
BgL_arg1712z00_485 = BgL_list1714z00_487; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1712z00_485); } 
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1715z00_488;
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1716z00_489;
BgL_arg1716z00_489 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)23)), BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 690 */
obj_t BgL_list1717z00_490;
BgL_list1717z00_490 = 
MAKE_YOUNG_PAIR(BgL_arg1716z00_489, BNIL); 
BgL_arg1715z00_488 = BgL_list1717z00_490; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1715z00_488); } 
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1718z00_491;
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1719z00_492;
BgL_arg1719z00_492 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)24)), BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 696 */
obj_t BgL_list1720z00_493;
BgL_list1720z00_493 = 
MAKE_YOUNG_PAIR(BgL_arg1719z00_492, BNIL); 
BgL_arg1718z00_491 = BgL_list1720z00_493; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1718z00_491); } 
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1726z00_494;
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1727z00_495;
BgL_arg1727z00_495 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)25)), BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 702 */
obj_t BgL_list1728z00_496;
BgL_list1728z00_496 = 
MAKE_YOUNG_PAIR(BgL_arg1727z00_495, BNIL); 
BgL_arg1726z00_494 = BgL_list1728z00_496; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1726z00_494); } 
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1730z00_497;
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1734z00_498;
BgL_arg1734z00_498 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)26)), BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 709 */
obj_t BgL_list1735z00_499;
BgL_list1735z00_499 = 
MAKE_YOUNG_PAIR(BgL_arg1734z00_498, BNIL); 
BgL_arg1730z00_497 = BgL_list1735z00_499; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1730z00_497); } 
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1737z00_500;
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1738z00_501;
BgL_arg1738z00_501 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)27)), BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 716 */
obj_t BgL_list1739z00_502;
BgL_list1739z00_502 = 
MAKE_YOUNG_PAIR(BgL_arg1738z00_501, BNIL); 
BgL_arg1737z00_500 = BgL_list1739z00_502; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1737z00_500); } 
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1741z00_503;
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1748z00_504;
BgL_arg1748z00_504 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)28)), BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 745 */
obj_t BgL_list1749z00_505;
BgL_list1749z00_505 = 
MAKE_YOUNG_PAIR(BgL_arg1748z00_504, BNIL); 
BgL_arg1741z00_503 = BgL_list1749z00_505; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1741z00_503); } 
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1760z00_506;
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1763z00_507;
BgL_arg1763z00_507 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)29)), BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 752 */
obj_t BgL_list1764z00_508;
BgL_list1764z00_508 = 
MAKE_YOUNG_PAIR(BgL_arg1763z00_507, BNIL); 
BgL_arg1760z00_506 = BgL_list1764z00_508; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1760z00_506); } 
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1772z00_509;
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1773z00_510;
BgL_arg1773z00_510 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)30)), BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 759 */
obj_t BgL_list1774z00_511;
BgL_list1774z00_511 = 
MAKE_YOUNG_PAIR(BgL_arg1773z00_510, BNIL); 
BgL_arg1772z00_509 = BgL_list1774z00_511; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1772z00_509); } 
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1775z00_512;
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1776z00_513;
BgL_arg1776z00_513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)31)), BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 771 */
obj_t BgL_list1777z00_514;
BgL_list1777z00_514 = 
MAKE_YOUNG_PAIR(BgL_arg1776z00_513, BNIL); 
BgL_arg1775z00_512 = BgL_list1777z00_514; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1775z00_512); } 
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1778z00_515;
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1779z00_516;
BgL_arg1779z00_516 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)32)), BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 777 */
obj_t BgL_list1780z00_517;
BgL_list1780z00_517 = 
MAKE_YOUNG_PAIR(BgL_arg1779z00_516, BNIL); 
BgL_arg1778z00_515 = BgL_list1780z00_517; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1778z00_515); } 
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1781z00_518;
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1782z00_519;
BgL_arg1782z00_519 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)33)), BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 797 */
obj_t BgL_list1783z00_520;
BgL_list1783z00_520 = 
MAKE_YOUNG_PAIR(BgL_arg1782z00_519, BNIL); 
BgL_arg1781z00_518 = BgL_list1783z00_520; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1781z00_518); } 
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1784z00_521;
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1785z00_522;
BgL_arg1785z00_522 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)34)), BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 825 */
obj_t BgL_list1786z00_523;
BgL_list1786z00_523 = 
MAKE_YOUNG_PAIR(BgL_arg1785z00_522, BNIL); 
BgL_arg1784z00_521 = BgL_list1786z00_523; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1784z00_521); } 
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1787z00_524;
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1788z00_525;
BgL_arg1788z00_525 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)35)), BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 839 */
obj_t BgL_list1789z00_526;
BgL_list1789z00_526 = 
MAKE_YOUNG_PAIR(BgL_arg1788z00_525, BNIL); 
BgL_arg1787z00_524 = BgL_list1789z00_526; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1787z00_524); } 
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1790z00_527;
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1791z00_528;
BgL_arg1791z00_528 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)36)), BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 853 */
obj_t BgL_list1792z00_529;
BgL_list1792z00_529 = 
MAKE_YOUNG_PAIR(BgL_arg1791z00_528, BNIL); 
BgL_arg1790z00_527 = BgL_list1792z00_529; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1790z00_527); } 
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1793z00_530;
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1794z00_531;
BgL_arg1794z00_531 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)37)), BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 858 */
obj_t BgL_list1795z00_532;
BgL_list1795z00_532 = 
MAKE_YOUNG_PAIR(BgL_arg1794z00_531, BNIL); 
BgL_arg1793z00_530 = BgL_list1795z00_532; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1793z00_530); } 
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1796z00_533;
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1797z00_534;
BgL_arg1797z00_534 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)38)), BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 863 */
obj_t BgL_list1798z00_535;
BgL_list1798z00_535 = 
MAKE_YOUNG_PAIR(BgL_arg1797z00_534, BNIL); 
BgL_arg1796z00_533 = BgL_list1798z00_535; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1796z00_533); } 
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1799z00_536;
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1800z00_537;
BgL_arg1800z00_537 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)39)), BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 868 */
obj_t BgL_list1801z00_538;
BgL_list1801z00_538 = 
MAKE_YOUNG_PAIR(BgL_arg1800z00_537, BNIL); 
BgL_arg1799z00_536 = BgL_list1801z00_538; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1799z00_536); } 
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1803z00_539;
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1804z00_540;
BgL_arg1804z00_540 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)40)), BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 873 */
obj_t BgL_list1805z00_541;
BgL_list1805z00_541 = 
MAKE_YOUNG_PAIR(BgL_arg1804z00_540, BNIL); 
BgL_arg1803z00_539 = BgL_list1805z00_541; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1803z00_539); } 
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1806z00_542;
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1807z00_543;
BgL_arg1807z00_543 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)41)), BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 878 */
obj_t BgL_list1808z00_544;
BgL_list1808z00_544 = 
MAKE_YOUNG_PAIR(BgL_arg1807z00_543, BNIL); 
BgL_arg1806z00_542 = BgL_list1808z00_544; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1806z00_542); } 
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1809z00_545;
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1810z00_546;
BgL_arg1810z00_546 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)42)), BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 883 */
obj_t BgL_list1811z00_547;
BgL_list1811z00_547 = 
MAKE_YOUNG_PAIR(BgL_arg1810z00_546, BNIL); 
BgL_arg1809z00_545 = BgL_list1811z00_547; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1809z00_545); } 
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1812z00_548;
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1813z00_549;
BgL_arg1813z00_549 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)43)), BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 888 */
obj_t BgL_list1814z00_550;
BgL_list1814z00_550 = 
MAKE_YOUNG_PAIR(BgL_arg1813z00_549, BNIL); 
BgL_arg1812z00_548 = BgL_list1814z00_550; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1812z00_548); } 
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1815z00_551;
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1816z00_552;
BgL_arg1816z00_552 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)44)), BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 893 */
obj_t BgL_list1817z00_553;
BgL_list1817z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1816z00_552, BNIL); 
BgL_arg1815z00_551 = BgL_list1817z00_553; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1815z00_551); } 
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1818z00_554;
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1819z00_555;
BgL_arg1819z00_555 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)45)), BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 898 */
obj_t BgL_list1820z00_556;
BgL_list1820z00_556 = 
MAKE_YOUNG_PAIR(BgL_arg1819z00_555, BNIL); 
BgL_arg1818z00_554 = BgL_list1820z00_556; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1818z00_554); } 
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1821z00_557;
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1822z00_558;
BgL_arg1822z00_558 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)46)), BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 903 */
obj_t BgL_list1823z00_559;
BgL_list1823z00_559 = 
MAKE_YOUNG_PAIR(BgL_arg1822z00_558, BNIL); 
BgL_arg1821z00_557 = BgL_list1823z00_559; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1821z00_557); } 
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1824z00_560;
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1825z00_561;
BgL_arg1825z00_561 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)47)), BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 908 */
obj_t BgL_list1826z00_562;
BgL_list1826z00_562 = 
MAKE_YOUNG_PAIR(BgL_arg1825z00_561, BNIL); 
BgL_arg1824z00_560 = BgL_list1826z00_562; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1824z00_560); } 
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1827z00_563;
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1828z00_564;
BgL_arg1828z00_564 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)48)), BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 913 */
obj_t BgL_list1829z00_565;
BgL_list1829z00_565 = 
MAKE_YOUNG_PAIR(BgL_arg1828z00_564, BNIL); 
BgL_arg1827z00_563 = BgL_list1829z00_565; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1827z00_563); } 
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1830z00_566;
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1831z00_567;
BgL_arg1831z00_567 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)49)), BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 918 */
obj_t BgL_list1832z00_568;
BgL_list1832z00_568 = 
MAKE_YOUNG_PAIR(BgL_arg1831z00_567, BNIL); 
BgL_arg1830z00_566 = BgL_list1832z00_568; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1830z00_566); } 
return BUNSPEC;} 

}



/* get-line-command */
obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_6)
{
{ /* Llib/mpd.scm 161 */
{ /* Llib/mpd.scm 162 */
obj_t BgL_iz00_579;
BgL_iz00_579 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_6, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_iz00_579))
{ /* Llib/mpd.scm 164 */
obj_t BgL_arg1836z00_580;
{ /* Llib/mpd.scm 164 */
long BgL_endz00_2453;
BgL_endz00_2453 = 
(long)CINT(BgL_iz00_579); 
BgL_arg1836z00_580 = 
c_substring(
((obj_t)BgL_linez00_6), ((long)0), BgL_endz00_2453); } 
return 
bstring_to_symbol(BgL_arg1836z00_580);}  else 
{ /* Llib/mpd.scm 163 */
return 
bstring_to_symbol(
((obj_t)BgL_linez00_6));} } } 

}



/* get-line-arg-string-nth */
obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_7, long BgL_numz00_8)
{
{ /* Llib/mpd.scm 170 */
{ 
obj_t BgL_iz00_594;long BgL_lenz00_595;
{ /* Llib/mpd.scm 182 */
obj_t BgL_i0z00_582;long BgL_lenz00_583;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2477;
BgL_jz00_2477 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2477))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2478;
BgL__ortest_1079z00_2478 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2477); 
if(
CBOOL(BgL__ortest_1079z00_2478))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL__ortest_1079z00_2478; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL_jz00_2477; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BFALSE; } } 
BgL_lenz00_583 = 
STRING_LENGTH(
((obj_t)BgL_linez00_7)); 
if(
CBOOL(BgL_i0z00_582))
{ /* Llib/mpd.scm 185 */
long BgL_g1085z00_584;
BgL_g1085z00_584 = 
(BgL_numz00_8-((long)1)); 
{ 
long BgL_nz00_586;obj_t BgL_iz00_587;
BgL_nz00_586 = BgL_g1085z00_584; 
BgL_iz00_587 = BgL_i0z00_582; 
BgL_zc3z04anonymousza31837ze3z87_588:
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 188 */
if(
(BgL_nz00_586==((long)0)))
{ /* Llib/mpd.scm 190 */
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 191 */
BgL_iz00_594 = BgL_iz00_587; 
BgL_lenz00_595 = BgL_lenz00_583; 
if(
(
(long)CINT(BgL_iz00_594)<BgL_lenz00_595))
{ /* Llib/mpd.scm 172 */
if(
(((unsigned char)'"')==
STRING_REF(
((obj_t)BgL_linez00_7), 
(long)CINT(BgL_iz00_594))))
{ /* Llib/mpd.scm 174 */
obj_t BgL_jz00_600;
{ /* Llib/mpd.scm 174 */
long BgL_arg1848z00_603;
BgL_arg1848z00_603 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
BgL_jz00_600 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)'"')), 
BINT(BgL_arg1848z00_603)); } 
if(
CBOOL(BgL_jz00_600))
{ /* Llib/mpd.scm 176 */
long BgL_arg1846z00_601;
BgL_arg1846z00_601 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 176 */
long BgL_endz00_2466;
BgL_endz00_2466 = 
(long)CINT(BgL_jz00_600); 
return 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1846z00_601, BgL_endz00_2466);} }  else 
{ /* Llib/mpd.scm 177 */
long BgL_arg1847z00_602;
BgL_arg1847z00_602 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
return 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1847z00_602, BgL_lenz00_595);} }  else 
{ /* Llib/mpd.scm 178 */
obj_t BgL_jz00_604;
BgL_jz00_604 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_594); 
if(
CBOOL(BgL_jz00_604))
{ /* Llib/mpd.scm 180 */
long BgL_startz00_2472;long BgL_endz00_2473;
BgL_startz00_2472 = 
(long)CINT(BgL_iz00_594); 
BgL_endz00_2473 = 
(long)CINT(BgL_jz00_604); 
return 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2472, BgL_endz00_2473);}  else 
{ /* Llib/mpd.scm 181 */
long BgL_startz00_2475;
BgL_startz00_2475 = 
(long)CINT(BgL_iz00_594); 
return 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2475, BgL_lenz00_595);} } }  else 
{ /* Llib/mpd.scm 172 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 191 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 190 */
if(
(
(long)CINT(BgL_iz00_587)<BgL_lenz00_583))
{ /* Llib/mpd.scm 193 */
long BgL_arg1840z00_591;obj_t BgL_arg1841z00_592;
BgL_arg1840z00_591 = 
(BgL_nz00_586-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2485;
BgL_jz00_2485 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_587); 
if(
CBOOL(BgL_jz00_2485))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2486;
BgL__ortest_1079z00_2486 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2485); 
if(
CBOOL(BgL__ortest_1079z00_2486))
{ /* Llib/mpd.scm 156 */
BgL_arg1841z00_592 = BgL__ortest_1079z00_2486; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1841z00_592 = BgL_jz00_2485; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1841z00_592 = BFALSE; } } 
{ 
obj_t BgL_iz00_5854;long BgL_nz00_5853;
BgL_nz00_5853 = BgL_arg1840z00_591; 
BgL_iz00_5854 = BgL_arg1841z00_592; 
BgL_iz00_587 = BgL_iz00_5854; 
BgL_nz00_586 = BgL_nz00_5853; 
goto BgL_zc3z04anonymousza31837ze3z87_588;} }  else 
{ /* Llib/mpd.scm 192 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 188 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 184 */
return BFALSE;} } } } 

}



/* get-line-arg-symbol-nth */
obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_9, long BgL_numz00_10)
{
{ /* Llib/mpd.scm 198 */
{ 
obj_t BgL_iz00_620;long BgL_lenz00_621;
{ /* Llib/mpd.scm 205 */
obj_t BgL_i0z00_608;long BgL_lenz00_609;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2497;
BgL_jz00_2497 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2497))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2498;
BgL__ortest_1079z00_2498 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2497); 
if(
CBOOL(BgL__ortest_1079z00_2498))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL__ortest_1079z00_2498; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL_jz00_2497; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BFALSE; } } 
BgL_lenz00_609 = 
STRING_LENGTH(
((obj_t)BgL_linez00_9)); 
if(
CBOOL(BgL_i0z00_608))
{ /* Llib/mpd.scm 208 */
long BgL_g1086z00_610;
BgL_g1086z00_610 = 
(BgL_numz00_10-((long)1)); 
{ 
long BgL_nz00_612;obj_t BgL_iz00_613;
BgL_nz00_612 = BgL_g1086z00_610; 
BgL_iz00_613 = BgL_i0z00_608; 
BgL_zc3z04anonymousza31850ze3z87_614:
if(
CBOOL(BgL_iz00_613))
{ /* Llib/mpd.scm 211 */
if(
(BgL_nz00_612==((long)0)))
{ /* Llib/mpd.scm 213 */
BgL_iz00_620 = BgL_iz00_613; 
BgL_lenz00_621 = BgL_lenz00_609; 
if(
(
(long)CINT(BgL_iz00_620)<BgL_lenz00_621))
{ /* Llib/mpd.scm 201 */
obj_t BgL_jz00_624;
BgL_jz00_624 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_620); 
if(
CBOOL(BgL_jz00_624))
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1858z00_625;
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1859z00_626;
{ /* Llib/mpd.scm 203 */
long BgL_startz00_2490;long BgL_endz00_2491;
BgL_startz00_2490 = 
(long)CINT(BgL_iz00_620); 
BgL_endz00_2491 = 
(long)CINT(BgL_jz00_624); 
BgL_arg1859z00_626 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2490, BgL_endz00_2491); } 
BgL_arg1858z00_625 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1859z00_626); } 
return 
bstring_to_symbol(BgL_arg1858z00_625);}  else 
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1861z00_627;
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1862z00_628;
{ /* Llib/mpd.scm 204 */
long BgL_startz00_2494;
BgL_startz00_2494 = 
(long)CINT(BgL_iz00_620); 
BgL_arg1862z00_628 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2494, BgL_lenz00_621); } 
BgL_arg1861z00_627 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1862z00_628); } 
return 
bstring_to_symbol(BgL_arg1861z00_627);} }  else 
{ /* Llib/mpd.scm 200 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 213 */
if(
(
(long)CINT(BgL_iz00_613)<BgL_lenz00_609))
{ /* Llib/mpd.scm 216 */
long BgL_arg1853z00_617;obj_t BgL_arg1854z00_618;
BgL_arg1853z00_617 = 
(BgL_nz00_612-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2505;
BgL_jz00_2505 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_613); 
if(
CBOOL(BgL_jz00_2505))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1079z00_2506;
BgL__ortest_1079z00_2506 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2505); 
if(
CBOOL(BgL__ortest_1079z00_2506))
{ /* Llib/mpd.scm 156 */
BgL_arg1854z00_618 = BgL__ortest_1079z00_2506; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1854z00_618 = BgL_jz00_2505; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1854z00_618 = BFALSE; } } 
{ 
obj_t BgL_iz00_5904;long BgL_nz00_5903;
BgL_nz00_5903 = BgL_arg1853z00_617; 
BgL_iz00_5904 = BgL_arg1854z00_618; 
BgL_iz00_613 = BgL_iz00_5904; 
BgL_nz00_612 = BgL_nz00_5903; 
goto BgL_zc3z04anonymousza31850ze3z87_614;} }  else 
{ /* Llib/mpd.scm 215 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 211 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 207 */
return BFALSE;} } } } 

}



/* _mpd */
obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t BgL_env1322z00_19, obj_t BgL_opt1321z00_18)
{
{ /* Llib/mpd.scm 230 */
{ 
obj_t BgL_k1z00_633;long BgL_iz00_634;
{ /* Llib/mpd.scm 230 */
obj_t BgL_g1328z00_636;obj_t BgL_g1329z00_637;obj_t BgL_g1330z00_638;obj_t BgL_g1331z00_639;
BgL_g1328z00_636 = 
VECTOR_REF(BgL_opt1321z00_18,((long)0)); 
BgL_g1329z00_637 = 
VECTOR_REF(BgL_opt1321z00_18,((long)1)); 
BgL_g1330z00_638 = 
VECTOR_REF(BgL_opt1321z00_18,((long)2)); 
BgL_g1331z00_639 = 
VECTOR_REF(BgL_opt1321z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_640;
BgL_logz00_640 = BFALSE; 
{ /* Llib/mpd.scm 230 */

{ 
long BgL_iz00_641;
BgL_iz00_641 = ((long)4); 
BgL_check1325z00_642:
if(
(BgL_iz00_641==
VECTOR_LENGTH(BgL_opt1321z00_18)))
{ /* Llib/mpd.scm 230 */BNIL; }  else 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3399z00_5912;
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1869z00_648;
BgL_arg1869z00_648 = 
VECTOR_REF(BgL_opt1321z00_18,BgL_iz00_641); 
BgL_test3399z00_5912 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1869z00_648, 
CNST_TABLE_REF(((long)51)))); } 
if(BgL_test3399z00_5912)
{ 
long BgL_iz00_5917;
BgL_iz00_5917 = 
(BgL_iz00_641+((long)2)); 
BgL_iz00_641 = BgL_iz00_5917; 
goto BgL_check1325z00_642;}  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1868z00_647;
BgL_arg1868z00_647 = 
VECTOR_REF(BgL_opt1321z00_18,BgL_iz00_641); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string2929z00zz__multimediazd2mpdzd2, BgL_arg1868z00_647); } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_index1327z00_649;
BgL_k1z00_633 = 
CNST_TABLE_REF(((long)52)); 
BgL_iz00_634 = ((long)4); 
BgL_search1324z00_635:
if(
(BgL_iz00_634==
VECTOR_LENGTH(BgL_opt1321z00_18)))
{ /* Llib/mpd.scm 230 */
BgL_index1327z00_649 = 
BINT(((long)-1)); }  else 
{ /* Llib/mpd.scm 230 */
if(
(BgL_iz00_634==
(
VECTOR_LENGTH(BgL_opt1321z00_18)-((long)1))))
{ /* Llib/mpd.scm 230 */
BgL_index1327z00_649 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string2928z00zz__multimediazd2mpdzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1321z00_18))); }  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_vz00_660;
BgL_vz00_660 = 
VECTOR_REF(BgL_opt1321z00_18,BgL_iz00_634); 
if(
(BgL_vz00_660==BgL_k1z00_633))
{ /* Llib/mpd.scm 230 */
BgL_index1327z00_649 = 
BINT(
(BgL_iz00_634+((long)1))); }  else 
{ 
long BgL_iz00_5939;
BgL_iz00_5939 = 
(BgL_iz00_634+((long)2)); 
BgL_iz00_634 = BgL_iz00_5939; 
goto BgL_search1324z00_635;} } } 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3403z00_5942;
{ /* Llib/mpd.scm 230 */
long BgL_n1z00_2524;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_5943;
if(
INTEGERP(BgL_index1327z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_5943 = BgL_index1327z00_649
; }  else 
{ 
obj_t BgL_auxz00_5946;
BgL_auxz00_5946 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2932z00zz__multimediazd2mpdzd2, BgL_index1327z00_649); 
FAILURE(BgL_auxz00_5946,BFALSE,BFALSE);} 
BgL_n1z00_2524 = 
(long)CINT(BgL_tmpz00_5943); } 
BgL_test3403z00_5942 = 
(BgL_n1z00_2524>=((long)0)); } 
if(BgL_test3403z00_5942)
{ 
long BgL_auxz00_5952;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_5953;
if(
INTEGERP(BgL_index1327z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_5953 = BgL_index1327z00_649
; }  else 
{ 
obj_t BgL_auxz00_5956;
BgL_auxz00_5956 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2932z00zz__multimediazd2mpdzd2, BgL_index1327z00_649); 
FAILURE(BgL_auxz00_5956,BFALSE,BFALSE);} 
BgL_auxz00_5952 = 
(long)CINT(BgL_tmpz00_5953); } 
BgL_logz00_640 = 
VECTOR_REF(BgL_opt1321z00_18,BgL_auxz00_5952); }  else 
{ /* Llib/mpd.scm 230 */BFALSE; } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1871z00_651;obj_t BgL_arg1872z00_652;obj_t BgL_arg1873z00_653;obj_t BgL_arg1874z00_654;
BgL_arg1871z00_651 = 
VECTOR_REF(BgL_opt1321z00_18,((long)0)); 
BgL_arg1872z00_652 = 
VECTOR_REF(BgL_opt1321z00_18,((long)1)); 
BgL_arg1873z00_653 = 
VECTOR_REF(BgL_opt1321z00_18,((long)2)); 
BgL_arg1874z00_654 = 
VECTOR_REF(BgL_opt1321z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_655;
BgL_logz00_655 = BgL_logz00_640; 
{ /* Llib/mpd.scm 230 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_5988;obj_t BgL_auxz00_5981;obj_t BgL_auxz00_5974;BgL_musicz00_bglt BgL_auxz00_5966;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1874z00_654, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_5988 = 
((BgL_mpdzd2databasezd2_bglt)BgL_arg1874z00_654)
; }  else 
{ 
obj_t BgL_auxz00_5992;
BgL_auxz00_5992 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_arg1874z00_654); 
FAILURE(BgL_auxz00_5992,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg1873z00_653))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_5981 = BgL_arg1873z00_653
; }  else 
{ 
obj_t BgL_auxz00_5984;
BgL_auxz00_5984 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_arg1873z00_653); 
FAILURE(BgL_auxz00_5984,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg1872z00_652))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_5974 = BgL_arg1872z00_652
; }  else 
{ 
obj_t BgL_auxz00_5977;
BgL_auxz00_5977 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2934z00zz__multimediazd2mpdzd2, BgL_arg1872z00_652); 
FAILURE(BgL_auxz00_5977,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1871z00_651, BGl_musicz00zz__multimediazd2musiczd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_5966 = 
((BgL_musicz00_bglt)BgL_arg1871z00_651)
; }  else 
{ 
obj_t BgL_auxz00_5970;
BgL_auxz00_5970 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string2931z00zz__multimediazd2mpdzd2, BGl_string2933z00zz__multimediazd2mpdzd2, BgL_arg1871z00_651); 
FAILURE(BgL_auxz00_5970,BFALSE,BFALSE);} 
return 
BGl_mpdz00zz__multimediazd2mpdzd2(BgL_auxz00_5966, BgL_auxz00_5974, BgL_auxz00_5981, BgL_auxz00_5988, BgL_logz00_655);} } } } } } } } 

}



/* mpd */
BGL_EXPORTED_DEF obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt BgL_backendz00_13, obj_t BgL_ipz00_14, obj_t BgL_opz00_15, BgL_mpdzd2databasezd2_bglt BgL_dbz00_16, obj_t BgL_logz00_17)
{
{ /* Llib/mpd.scm 230 */
bgl_display_obj(BGl_string2937z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_char(((unsigned char)10), BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
{ 

BgL_zc3z04anonymousza31883ze3z87_666:
if(
BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_backendz00_13))
{ /* Llib/mpd.scm 237 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 238 */
obj_t BgL_linez00_668;
BgL_linez00_668 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_14); 
BGl_cmdnz00zz__multimediazd2mpdzd2 = 
(((long)1)+BGl_cmdnz00zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_logz00_17))
{ /* Llib/mpd.scm 240 */
PROCEDURE_ENTRY(BgL_logz00_17)(BgL_logz00_17, BgL_linez00_668, BEOA); }  else 
{ /* Llib/mpd.scm 240 */BFALSE; } 
if(
EOF_OBJECTP(BgL_linez00_668))
{ /* Llib/mpd.scm 241 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 242 */
obj_t BgL_vz00_670;
BgL_vz00_670 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_16, BgL_backendz00_13, BgL_ipz00_14, BgL_opz00_15, BgL_linez00_668); 
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string2938z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
goto BgL_zc3z04anonymousza31883ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bool_t BgL_test3414z00_6019;
{ /* Llib/mpd.scm 243 */
bool_t BgL__ortest_1088z00_678;
BgL__ortest_1088z00_678 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)24))); 
if(BgL__ortest_1088z00_678)
{ /* Llib/mpd.scm 243 */
BgL_test3414z00_6019 = BgL__ortest_1088z00_678
; }  else 
{ /* Llib/mpd.scm 243 */
BgL_test3414z00_6019 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)31)))
; } } 
if(BgL_test3414z00_6019)
{ /* Llib/mpd.scm 243 */
return 
bgl_flush_output_port(BgL_opz00_15);}  else 
{ /* Llib/mpd.scm 243 */
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)54))))
{ /* Llib/mpd.scm 243 */
goto BgL_zc3z04anonymousza31883ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string2939z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string2940z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string2941z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string2927z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string2942z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BgL_vz00_670, BgL_opz00_15); 
bgl_display_string(BGl_string2943z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
CNST_TABLE_REF(((long)54)); 
goto BgL_zc3z04anonymousza31883ze3z87_666;} } } } } } } 

}



/* execute-command */
obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_20, BgL_musicz00_bglt BgL_backendz00_21, obj_t BgL_ipz00_22, obj_t BgL_opz00_23, obj_t BgL_linez00_24)
{
{ /* Llib/mpd.scm 259 */
{ /* Llib/mpd.scm 260 */
obj_t BgL_cmdz00_680;
BgL_cmdz00_680 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_24); 
{ /* Llib/mpd.scm 262 */
bool_t BgL_test3417z00_6039;
if(
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 262 */
BgL_test3417z00_6039 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 262 */
BgL_test3417z00_6039 = 
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)56)))
; } 
if(BgL_test3417z00_6039)
{ /* Llib/mpd.scm 262 */
return 
BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_dbz00_20, BgL_backendz00_21, BgL_ipz00_22, BgL_opz00_23, BgL_cmdz00_680);}  else 
{ /* Llib/mpd.scm 265 */
obj_t BgL_g1090z00_683;
BgL_g1090z00_683 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1090z00_683))
{ /* Llib/mpd.scm 267 */
obj_t BgL_fun1891z00_686;
BgL_fun1891z00_686 = 
CDR(
((obj_t)BgL_g1090z00_683)); 
return 
PROCEDURE_ENTRY(BgL_fun1891z00_686)(BgL_fun1891z00_686, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
obj_t BgL_g1092z00_687;
BgL_g1092z00_687 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1092z00_687))
{ /* Llib/mpd.scm 270 */
obj_t BgL_fun1892z00_690;
BgL_fun1892z00_690 = 
CDR(
((obj_t)BgL_g1092z00_687)); 
return 
PROCEDURE_ENTRY(BgL_fun1892z00_690)(BgL_fun1892z00_690, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
if(
(
STRING_LENGTH(BgL_linez00_24)>((long)0)))
{ /* Llib/mpd.scm 273 */
obj_t BgL_list1895z00_693;
BgL_list1895z00_693 = 
MAKE_YOUNG_PAIR(BgL_linez00_24, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2944z00zz__multimediazd2mpdzd2, BgL_list1895z00_693);}  else 
{ /* Llib/mpd.scm 272 */
return 
CNST_TABLE_REF(((long)54));} } } } } } } 

}



/* mpd-list-begin */
obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_25, BgL_musicz00_bglt BgL_backendz00_26, obj_t BgL_ipz00_27, obj_t BgL_opz00_28, obj_t BgL_cmdz00_29)
{
{ /* Llib/mpd.scm 279 */
{ 
obj_t BgL_linesz00_698;
BgL_linesz00_698 = BNIL; 
BgL_zc3z04anonymousza31897ze3z87_699:
{ /* Llib/mpd.scm 281 */
obj_t BgL_linez00_700;
BgL_linez00_700 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_27); 
if(
EOF_OBJECTP(BgL_linez00_700))
{ /* Llib/mpd.scm 282 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 283 */
obj_t BgL_cz00_702;
BgL_cz00_702 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_700); 
if(
(BgL_cz00_702==
CNST_TABLE_REF(((long)57))))
{ /* Llib/mpd.scm 284 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 287 */
obj_t BgL_g1095z00_705;
BgL_g1095z00_705 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_707;
BgL_lsz00_707 = BgL_g1095z00_705; 
BgL_zc3z04anonymousza31901ze3z87_708:
if(
NULLP(BgL_lsz00_707))
{ /* Llib/mpd.scm 288 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 290 */
obj_t BgL_lz00_710;
BgL_lz00_710 = 
CAR(
((obj_t)BgL_lsz00_707)); 
{ /* Llib/mpd.scm 290 */
obj_t BgL_vz00_711;
BgL_vz00_711 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_710); 
{ /* Llib/mpd.scm 291 */

if(
(BgL_vz00_711==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 293 */
obj_t BgL_arg1904z00_713;
BgL_arg1904z00_713 = 
CDR(
((obj_t)BgL_lsz00_707)); 
{ 
obj_t BgL_lsz00_6104;
BgL_lsz00_6104 = BgL_arg1904z00_713; 
BgL_lsz00_707 = BgL_lsz00_6104; 
goto BgL_zc3z04anonymousza31901ze3z87_708;} }  else 
{ /* Llib/mpd.scm 292 */
return BgL_vz00_711;} } } } } }  else 
{ /* Llib/mpd.scm 286 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)56))))
{ /* Llib/mpd.scm 296 */
obj_t BgL_g1096z00_716;
BgL_g1096z00_716 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_718;
BgL_lsz00_718 = BgL_g1096z00_716; 
BgL_zc3z04anonymousza31906ze3z87_719:
if(
NULLP(BgL_lsz00_718))
{ /* Llib/mpd.scm 297 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 299 */
obj_t BgL_lz00_721;
BgL_lz00_721 = 
CAR(
((obj_t)BgL_lsz00_718)); 
{ /* Llib/mpd.scm 299 */
obj_t BgL_vz00_722;
BgL_vz00_722 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_721); 
{ /* Llib/mpd.scm 300 */

if(
(BgL_vz00_722==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 301 */
bgl_display_string(BGl_string2945z00zz__multimediazd2mpdzd2, BgL_opz00_28); 
{ /* Llib/mpd.scm 304 */
obj_t BgL_arg1909z00_724;
BgL_arg1909z00_724 = 
CDR(
((obj_t)BgL_lsz00_718)); 
{ 
obj_t BgL_lsz00_6121;
BgL_lsz00_6121 = BgL_arg1909z00_724; 
BgL_lsz00_718 = BgL_lsz00_6121; 
goto BgL_zc3z04anonymousza31906ze3z87_719;} } }  else 
{ /* Llib/mpd.scm 301 */
return BgL_vz00_722;} } } } } }  else 
{ /* Llib/mpd.scm 295 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 306 */
obj_t BgL_arg1910z00_726;
BgL_arg1910z00_726 = 
MAKE_YOUNG_PAIR(BgL_linez00_700, BgL_linesz00_698); 
{ 
obj_t BgL_linesz00_6123;
BgL_linesz00_6123 = BgL_arg1910z00_726; 
BgL_linesz00_698 = BgL_linesz00_6123; 
goto BgL_zc3z04anonymousza31897ze3z87_699;} } } } } } 

}



/* search1335~0 */
obj_t BGl_search1335ze70ze7zz__multimediazd2mpdzd2(obj_t BgL_l1334z00_4910, obj_t BgL_opt1332z00_4909, obj_t BgL_k1z00_729, obj_t BgL_iz00_730)
{
{ /* Llib/mpd.scm 324 */
BGl_search1335ze70ze7zz__multimediazd2mpdzd2:
if(
(
(long)CINT(BgL_iz00_730)==
(long)CINT(BgL_l1334z00_4910)))
{ /* Llib/mpd.scm 324 */
return 
BINT(((long)-1));}  else 
{ /* Llib/mpd.scm 324 */
if(
(
(long)CINT(BgL_iz00_730)==
(long)CINT(
SUBFX(BgL_l1334z00_4910, 
BINT(((long)1))))))
{ /* Llib/mpd.scm 324 */
obj_t BgL_arg1924z00_755;
BgL_arg1924z00_755 = 
BINT(
VECTOR_LENGTH(BgL_opt1332z00_4909)); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)59)), BGl_string2946z00zz__multimediazd2mpdzd2, BgL_arg1924z00_755);}  else 
{ /* Llib/mpd.scm 324 */
obj_t BgL_vz00_756;
BgL_vz00_756 = 
VECTOR_REF(BgL_opt1332z00_4909,
(long)CINT(BgL_iz00_730)); 
if(
(BgL_vz00_756==BgL_k1z00_729))
{ /* Llib/mpd.scm 324 */
return 
ADDFX(BgL_iz00_730, 
BINT(((long)1)));}  else 
{ 
obj_t BgL_iz00_6145;
BgL_iz00_6145 = 
ADDFX(BgL_iz00_730, 
BINT(((long)2))); 
BgL_iz00_730 = BgL_iz00_6145; 
goto BGl_search1335ze70ze7zz__multimediazd2mpdzd2;} } } } 

}



/* &mpd-ping */
obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4201, obj_t BgL_dbz00_4202, obj_t BgL_backendz00_4203, obj_t BgL_linez00_4204, obj_t BgL_ipz00_4205, obj_t BgL_opz00_4206)
{
{ /* Llib/mpd.scm 338 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-urlhandlers */
obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4207, obj_t BgL_dbz00_4208, obj_t BgL_backendz00_4209, obj_t BgL_linez00_4210, obj_t BgL_ipz00_4211, obj_t BgL_opz00_4212)
{
{ /* Llib/mpd.scm 344 */
{ /* Llib/mpd.scm 345 */
bool_t BgL_tmpz00_6149;
{ /* Llib/mpd.scm 345 */
obj_t BgL_g1179z00_5060;
BgL_g1179z00_5060 = 
CNST_TABLE_REF(((long)62)); 
{ 
obj_t BgL_l1177z00_5062;
BgL_l1177z00_5062 = BgL_g1179z00_5060; 
BgL_zc3z04anonymousza31928ze3z87_5061:
if(
PAIRP(BgL_l1177z00_5062))
{ /* Llib/mpd.scm 349 */
{ /* Llib/mpd.scm 346 */
obj_t BgL_handlerz00_5063;
BgL_handlerz00_5063 = 
CAR(BgL_l1177z00_5062); 
{ /* Llib/mpd.scm 346 */
obj_t BgL_tmpz00_6154;
BgL_tmpz00_6154 = 
((obj_t)BgL_opz00_4212); 
bgl_display_string(BGl_string2947z00zz__multimediazd2mpdzd2, BgL_tmpz00_6154); } 
bgl_display_obj(BgL_handlerz00_5063, BgL_opz00_4212); 
{ /* Llib/mpd.scm 348 */
obj_t BgL_tmpz00_6158;
BgL_tmpz00_6158 = 
((obj_t)BgL_opz00_4212); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6158); } } 
{ 
obj_t BgL_l1177z00_6161;
BgL_l1177z00_6161 = 
CDR(BgL_l1177z00_5062); 
BgL_l1177z00_5062 = BgL_l1177z00_6161; 
goto BgL_zc3z04anonymousza31928ze3z87_5061;} }  else 
{ /* Llib/mpd.scm 349 */
BgL_tmpz00_6149 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6149);} } 

}



/* &mpd-tagtypes */
obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4213, obj_t BgL_dbz00_4214, obj_t BgL_backendz00_4215, obj_t BgL_linez00_4216, obj_t BgL_ipz00_4217, obj_t BgL_opz00_4218)
{
{ /* Llib/mpd.scm 354 */
{ /* Llib/mpd.scm 355 */
bool_t BgL_tmpz00_6164;
{ /* Llib/mpd.scm 355 */
obj_t BgL_g1182z00_5064;
BgL_g1182z00_5064 = 
CNST_TABLE_REF(((long)63)); 
{ 
obj_t BgL_l1180z00_5066;
BgL_l1180z00_5066 = BgL_g1182z00_5064; 
BgL_zc3z04anonymousza31931ze3z87_5065:
if(
PAIRP(BgL_l1180z00_5066))
{ /* Llib/mpd.scm 359 */
{ /* Llib/mpd.scm 356 */
obj_t BgL_tagz00_5067;
BgL_tagz00_5067 = 
CAR(BgL_l1180z00_5066); 
{ /* Llib/mpd.scm 356 */
obj_t BgL_tmpz00_6169;
BgL_tmpz00_6169 = 
((obj_t)BgL_opz00_4218); 
bgl_display_string(BGl_string2948z00zz__multimediazd2mpdzd2, BgL_tmpz00_6169); } 
bgl_display_obj(BgL_tagz00_5067, BgL_opz00_4218); 
{ /* Llib/mpd.scm 358 */
obj_t BgL_tmpz00_6173;
BgL_tmpz00_6173 = 
((obj_t)BgL_opz00_4218); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6173); } } 
{ 
obj_t BgL_l1180z00_6176;
BgL_l1180z00_6176 = 
CDR(BgL_l1180z00_5066); 
BgL_l1180z00_5066 = BgL_l1180z00_6176; 
goto BgL_zc3z04anonymousza31931ze3z87_5065;} }  else 
{ /* Llib/mpd.scm 359 */
BgL_tmpz00_6164 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6164);} } 

}



/* &mpd-status */
obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4219, obj_t BgL_dbz00_4220, obj_t BgL_backendz00_4221, obj_t BgL_linez00_4222, obj_t BgL_ipz00_4223, obj_t BgL_opz00_4224)
{
{ /* Llib/mpd.scm 371 */
{ /* Llib/mpd.scm 372 */
BgL_musicstatusz00_bglt BgL_statusz00_5068;
BgL_statusz00_5068 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4221)); 
{ /* Llib/mpd.scm 376 */
obj_t BgL_volz00_5069;
{ /* Llib/mpd.scm 376 */
bool_t BgL_test3435z00_6181;
{ /* Llib/mpd.scm 376 */
obj_t BgL_tmpz00_6182;
BgL_tmpz00_6182 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_volumez00); 
BgL_test3435z00_6181 = 
VECTORP(BgL_tmpz00_6182); } 
if(BgL_test3435z00_6181)
{ /* Llib/mpd.scm 376 */
obj_t BgL_arg1936z00_5070;
BgL_arg1936z00_5070 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_volumez00); 
BgL_volz00_5069 = 
VECTOR_REF(
((obj_t)BgL_arg1936z00_5070),((long)0)); }  else 
{ /* Llib/mpd.scm 376 */
BgL_volz00_5069 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_volumez00); } } 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6189;
BgL_tmpz00_6189 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2949z00zz__multimediazd2mpdzd2, BgL_tmpz00_6189); } 
bgl_display_obj(BgL_volz00_5069, BgL_opz00_4224); 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6193;
BgL_tmpz00_6193 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6193); } } 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6196;
BgL_tmpz00_6196 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2950z00zz__multimediazd2mpdzd2, BgL_tmpz00_6196); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_statez00), BgL_opz00_4224); 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6201;
BgL_tmpz00_6201 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6201); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6204;
BgL_tmpz00_6204 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2951z00zz__multimediazd2mpdzd2, BgL_tmpz00_6204); } 
{ /* Llib/mpd.scm 379 */
int BgL_arg1939z00_5071;
BgL_arg1939z00_5071 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_playlistidz00); 
bgl_display_obj(
BINT(BgL_arg1939z00_5071), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6210;
BgL_tmpz00_6210 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6210); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6213;
BgL_tmpz00_6213 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2952z00zz__multimediazd2mpdzd2, BgL_tmpz00_6213); } 
{ /* Llib/mpd.scm 380 */
int BgL_arg1940z00_5072;
BgL_arg1940z00_5072 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_playlistlengthz00); 
bgl_display_obj(
BINT(BgL_arg1940z00_5072), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6219;
BgL_tmpz00_6219 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6219); } 
if(
(
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_songz00))>=((long)0)))
{ /* Llib/mpd.scm 381 */
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6226;
BgL_tmpz00_6226 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2953z00zz__multimediazd2mpdzd2, BgL_tmpz00_6226); } 
{ /* Llib/mpd.scm 382 */
int BgL_arg1943z00_5073;
BgL_arg1943z00_5073 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_songz00); 
bgl_display_obj(
BINT(BgL_arg1943z00_5073), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6232;
BgL_tmpz00_6232 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6232); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6235;
BgL_tmpz00_6235 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2954z00zz__multimediazd2mpdzd2, BgL_tmpz00_6235); } 
{ /* Llib/mpd.scm 383 */
int BgL_arg1944z00_5074;
BgL_arg1944z00_5074 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_songidz00); 
bgl_display_obj(
BINT(BgL_arg1944z00_5074), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6241;
BgL_tmpz00_6241 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6241); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6244;
BgL_tmpz00_6244 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2955z00zz__multimediazd2mpdzd2, BgL_tmpz00_6244); } 
{ /* Llib/mpd.scm 384 */
int BgL_arg1945z00_5075;
BgL_arg1945z00_5075 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_bitratez00); 
bgl_display_obj(
BINT(BgL_arg1945z00_5075), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6250;
BgL_tmpz00_6250 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6250); } 
{ /* Llib/mpd.scm 385 */
obj_t BgL_tmpz00_6253;
BgL_tmpz00_6253 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2956z00zz__multimediazd2mpdzd2, BgL_tmpz00_6253); } 
{ /* Llib/mpd.scm 386 */
int BgL_arg1946z00_5076;
BgL_arg1946z00_5076 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_khza7za7); 
bgl_display_obj(
BINT(BgL_arg1946z00_5076), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 387 */
obj_t BgL_tmpz00_6259;
BgL_tmpz00_6259 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2957z00zz__multimediazd2mpdzd2, BgL_tmpz00_6259); } }  else 
{ /* Llib/mpd.scm 381 */BFALSE; } 
{ /* Llib/mpd.scm 388 */
bool_t BgL_test3437z00_6262;
if(
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_statez00)==
CNST_TABLE_REF(((long)13))))
{ /* Llib/mpd.scm 388 */
BgL_test3437z00_6262 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 388 */
BgL_test3437z00_6262 = 
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_statez00)==
CNST_TABLE_REF(((long)18)))
; } 
if(BgL_test3437z00_6262)
{ /* Llib/mpd.scm 388 */
{ /* Llib/mpd.scm 389 */
obj_t BgL_tmpz00_6270;
BgL_tmpz00_6270 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2958z00zz__multimediazd2mpdzd2, BgL_tmpz00_6270); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_songposz00), BgL_opz00_4224); 
{ /* Llib/mpd.scm 391 */
obj_t BgL_tmpz00_6275;
BgL_tmpz00_6275 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2959z00zz__multimediazd2mpdzd2, BgL_tmpz00_6275); } 
{ /* Llib/mpd.scm 392 */
int BgL_arg1954z00_5077;
BgL_arg1954z00_5077 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_songlengthz00); 
bgl_display_obj(
BINT(BgL_arg1954z00_5077), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 393 */
obj_t BgL_tmpz00_6281;
BgL_tmpz00_6281 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6281); } }  else 
{ /* Llib/mpd.scm 388 */BFALSE; } } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_repeatz00))
{ /* Llib/mpd.scm 395 */
obj_t BgL_tmpz00_6286;
BgL_tmpz00_6286 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2960z00zz__multimediazd2mpdzd2, BgL_tmpz00_6286); }  else 
{ /* Llib/mpd.scm 396 */
obj_t BgL_tmpz00_6289;
BgL_tmpz00_6289 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2961z00zz__multimediazd2mpdzd2, BgL_tmpz00_6289); } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_randomz00))
{ /* Llib/mpd.scm 398 */
obj_t BgL_tmpz00_6294;
BgL_tmpz00_6294 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2962z00zz__multimediazd2mpdzd2, BgL_tmpz00_6294); }  else 
{ /* Llib/mpd.scm 399 */
obj_t BgL_tmpz00_6297;
BgL_tmpz00_6297 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2963z00zz__multimediazd2mpdzd2, BgL_tmpz00_6297); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6300;
BgL_tmpz00_6300 = 
((obj_t)BgL_opz00_4224); 
bgl_display_string(BGl_string2964z00zz__multimediazd2mpdzd2, BgL_tmpz00_6300); } 
{ /* Llib/mpd.scm 400 */
int BgL_arg1959z00_5078;
BgL_arg1959z00_5078 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5068))->BgL_xfadez00); 
bgl_display_obj(
BINT(BgL_arg1959z00_5078), BgL_opz00_4224); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6306;
BgL_tmpz00_6306 = 
((obj_t)BgL_opz00_4224); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6306); } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlist */
obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4225, obj_t BgL_dbz00_4226, obj_t BgL_backendz00_4227, obj_t BgL_linez00_4228, obj_t BgL_ipz00_4229, obj_t BgL_opz00_4230)
{
{ /* Llib/mpd.scm 406 */
{ /* Llib/mpd.scm 407 */
obj_t BgL_g1102z00_5079;
BgL_g1102z00_5079 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4227)); 
{ 
obj_t BgL_plistz00_5081;long BgL_numz00_5082;
BgL_plistz00_5081 = BgL_g1102z00_5079; 
BgL_numz00_5082 = ((long)0); 
BgL_loopz00_5080:
if(
PAIRP(BgL_plistz00_5081))
{ /* Llib/mpd.scm 409 */
bgl_display_obj(
BINT(BgL_numz00_5082), BgL_opz00_4230); 
{ /* Llib/mpd.scm 411 */
obj_t BgL_tmpz00_6316;
BgL_tmpz00_6316 = 
((obj_t)BgL_opz00_4230); 
bgl_display_string(BGl_string2959z00zz__multimediazd2mpdzd2, BgL_tmpz00_6316); } 
bgl_display_obj(
CAR(BgL_plistz00_5081), BgL_opz00_4230); 
{ /* Llib/mpd.scm 413 */
obj_t BgL_tmpz00_6321;
BgL_tmpz00_6321 = 
((obj_t)BgL_opz00_4230); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6321); } 
{ 
long BgL_numz00_6326;obj_t BgL_plistz00_6324;
BgL_plistz00_6324 = 
CDR(BgL_plistz00_5081); 
BgL_numz00_6326 = 
(((long)1)+BgL_numz00_5082); 
BgL_numz00_5082 = BgL_numz00_6326; 
BgL_plistz00_5081 = BgL_plistz00_6324; 
goto BgL_loopz00_5080;} }  else 
{ /* Llib/mpd.scm 409 */((bool_t)0); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* search1343~0 */
obj_t BGl_search1343ze70ze7zz__multimediazd2mpdzd2(obj_t BgL_l1342z00_4908, obj_t BgL_opt1340z00_4907, obj_t BgL_k1z00_817, obj_t BgL_iz00_818)
{
{ /* Llib/mpd.scm 420 */
BGl_search1343ze70ze7zz__multimediazd2mpdzd2:
if(
(
(long)CINT(BgL_iz00_818)==
(long)CINT(BgL_l1342z00_4908)))
{ /* Llib/mpd.scm 420 */
return 
BINT(((long)-1));}  else 
{ /* Llib/mpd.scm 420 */
if(
(
(long)CINT(BgL_iz00_818)==
(long)CINT(
SUBFX(BgL_l1342z00_4908, 
BINT(((long)1))))))
{ /* Llib/mpd.scm 420 */
obj_t BgL_arg1980z00_849;
BgL_arg1980z00_849 = 
BINT(
VECTOR_LENGTH(BgL_opt1340z00_4907)); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)65)), BGl_string2966z00zz__multimediazd2mpdzd2, BgL_arg1980z00_849);}  else 
{ /* Llib/mpd.scm 420 */
obj_t BgL_vz00_850;
BgL_vz00_850 = 
VECTOR_REF(BgL_opt1340z00_4907,
(long)CINT(BgL_iz00_818)); 
if(
(BgL_vz00_850==BgL_k1z00_817))
{ /* Llib/mpd.scm 420 */
return 
ADDFX(BgL_iz00_818, 
BINT(((long)1)));}  else 
{ 
obj_t BgL_iz00_6350;
BgL_iz00_6350 = 
ADDFX(BgL_iz00_818, 
BINT(((long)2))); 
BgL_iz00_818 = BgL_iz00_6350; 
goto BGl_search1343ze70ze7zz__multimediazd2mpdzd2;} } } } 

}



/* playlistinfo */
obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_71, obj_t BgL_backendz00_72, obj_t BgL_linez00_73, obj_t BgL_ipz00_74, obj_t BgL_opz00_75, int BgL_numz00_76)
{
{ /* Llib/mpd.scm 432 */
{ /* Llib/mpd.scm 434 */
obj_t BgL_plistz00_867;
BgL_plistz00_867 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_72)); 
{ /* Llib/mpd.scm 435 */
bool_t BgL_test3445z00_6355;
if(
(
(long)(BgL_numz00_76)>=((long)0)))
{ /* Llib/mpd.scm 435 */
BgL_test3445z00_6355 = 
(
(long)(BgL_numz00_76)<
bgl_list_length(BgL_plistz00_867))
; }  else 
{ /* Llib/mpd.scm 435 */
BgL_test3445z00_6355 = ((bool_t)0)
; } 
if(BgL_test3445z00_6355)
{ /* Llib/mpd.scm 436 */
obj_t BgL_arg1993z00_871;
BgL_arg1993z00_871 = 
bgl_list_ref(BgL_plistz00_867, 
(long)(BgL_numz00_76)); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_2732;
BgL_g1186z00_2732 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1993z00_871, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_2734;
BgL_l1184z00_2734 = BgL_g1186z00_2732; 
BgL_zc3z04anonymousza31984ze3z87_2733:
if(
PAIRP(BgL_l1184z00_2734))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2736;
BgL_kz00_2736 = 
CAR(BgL_l1184z00_2734); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_2737;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_2738;
BgL_arg1987z00_2738 = 
CAR(
((obj_t)BgL_kz00_2736)); 
BgL_arg1986z00_2737 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_2738)); } 
bgl_display_obj(BgL_arg1986z00_2737, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6373;
BgL_tmpz00_6373 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_tmpz00_6373); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_2739;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2749;
BgL_pairz00_2749 = 
CDR(
((obj_t)BgL_kz00_2736)); 
BgL_arg1988z00_2739 = 
CAR(BgL_pairz00_2749); } 
bgl_display_obj(BgL_arg1988z00_2739, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6380;
BgL_tmpz00_6380 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6380); } } 
{ 
obj_t BgL_l1184z00_6383;
BgL_l1184z00_6383 = 
CDR(BgL_l1184z00_2734); 
BgL_l1184z00_2734 = BgL_l1184z00_6383; 
goto BgL_zc3z04anonymousza31984ze3z87_2733;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } }  else 
{ 
obj_t BgL_plistz00_876;long BgL_numz00_877;
BgL_plistz00_876 = BgL_plistz00_867; 
BgL_numz00_877 = ((long)0); 
BgL_zc3z04anonymousza31994ze3z87_878:
if(
PAIRP(BgL_plistz00_876))
{ /* Llib/mpd.scm 439 */
{ /* Llib/mpd.scm 440 */
obj_t BgL_arg1996z00_880;
BgL_arg1996z00_880 = 
CAR(BgL_plistz00_876); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_2753;
BgL_g1186z00_2753 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1996z00_880, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_2755;
BgL_l1184z00_2755 = BgL_g1186z00_2753; 
BgL_zc3z04anonymousza31984ze3z87_2754:
if(
PAIRP(BgL_l1184z00_2755))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2757;
BgL_kz00_2757 = 
CAR(BgL_l1184z00_2755); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_2758;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_2759;
BgL_arg1987z00_2759 = 
CAR(
((obj_t)BgL_kz00_2757)); 
BgL_arg1986z00_2758 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_2759)); } 
bgl_display_obj(BgL_arg1986z00_2758, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6397;
BgL_tmpz00_6397 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_tmpz00_6397); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_2760;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2770;
BgL_pairz00_2770 = 
CDR(
((obj_t)BgL_kz00_2757)); 
BgL_arg1988z00_2760 = 
CAR(BgL_pairz00_2770); } 
bgl_display_obj(BgL_arg1988z00_2760, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6404;
BgL_tmpz00_6404 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6404); } } 
{ 
obj_t BgL_l1184z00_6407;
BgL_l1184z00_6407 = 
CDR(BgL_l1184z00_2755); 
BgL_l1184z00_2755 = BgL_l1184z00_6407; 
goto BgL_zc3z04anonymousza31984ze3z87_2754;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } } 
{ 
long BgL_numz00_6411;obj_t BgL_plistz00_6409;
BgL_plistz00_6409 = 
CDR(BgL_plistz00_876); 
BgL_numz00_6411 = 
(((long)1)+BgL_numz00_877); 
BgL_numz00_877 = BgL_numz00_6411; 
BgL_plistz00_876 = BgL_plistz00_6409; 
goto BgL_zc3z04anonymousza31994ze3z87_878;} }  else 
{ /* Llib/mpd.scm 439 */((bool_t)0); } } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlistinfo */
obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4231, obj_t BgL_dbz00_4232, obj_t BgL_backendz00_4233, obj_t BgL_linez00_4234, obj_t BgL_ipz00_4235, obj_t BgL_opz00_4236)
{
{ /* Llib/mpd.scm 447 */
{ /* Llib/mpd.scm 447 */
obj_t BgL_numz00_5083;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5084;
BgL_strz00_5084 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4234, ((long)1)); 
if(
STRINGP(BgL_strz00_5084))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6417;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6418;
BgL_tmpz00_6418 = 
BSTRING_TO_STRING(BgL_strz00_5084); 
BgL_tmpz00_6417 = 
BGL_STRTOL(BgL_tmpz00_6418, ((long)0), ((long)10)); } 
BgL_numz00_5083 = 
BINT(BgL_tmpz00_6417); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5083 = BFALSE; } } 
{ /* Llib/mpd.scm 448 */
obj_t BgL_arg2000z00_5085;
if(
CBOOL(BgL_numz00_5083))
{ /* Llib/mpd.scm 448 */
BgL_arg2000z00_5085 = BgL_numz00_5083; }  else 
{ /* Llib/mpd.scm 448 */
BgL_arg2000z00_5085 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4232, BgL_backendz00_4233, BgL_linez00_4234, BgL_ipz00_4235, BgL_opz00_4236, 
CINT(BgL_arg2000z00_5085));} } } 

}



/* &mpd-playlistid */
obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4237, obj_t BgL_dbz00_4238, obj_t BgL_backendz00_4239, obj_t BgL_linez00_4240, obj_t BgL_ipz00_4241, obj_t BgL_opz00_4242)
{
{ /* Llib/mpd.scm 453 */
{ /* Llib/mpd.scm 453 */
obj_t BgL_numz00_5086;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5087;
BgL_strz00_5087 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4240, ((long)1)); 
if(
STRINGP(BgL_strz00_5087))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6430;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6431;
BgL_tmpz00_6431 = 
BSTRING_TO_STRING(BgL_strz00_5087); 
BgL_tmpz00_6430 = 
BGL_STRTOL(BgL_tmpz00_6431, ((long)0), ((long)10)); } 
BgL_numz00_5086 = 
BINT(BgL_tmpz00_6430); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5086 = BFALSE; } } 
{ /* Llib/mpd.scm 454 */
obj_t BgL_arg2001z00_5088;
if(
CBOOL(BgL_numz00_5086))
{ /* Llib/mpd.scm 454 */
BgL_arg2001z00_5088 = BgL_numz00_5086; }  else 
{ /* Llib/mpd.scm 454 */
BgL_arg2001z00_5088 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4238, BgL_backendz00_4239, BgL_linez00_4240, BgL_ipz00_4241, BgL_opz00_4242, 
CINT(BgL_arg2001z00_5088));} } } 

}



/* &mpd-plchanges */
obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4243, obj_t BgL_dbz00_4244, obj_t BgL_backendz00_4245, obj_t BgL_linez00_4246, obj_t BgL_ipz00_4247, obj_t BgL_opz00_4248)
{
{ /* Llib/mpd.scm 459 */
{ /* Llib/mpd.scm 459 */
obj_t BgL_numz00_5089;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5090;
BgL_strz00_5090 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4246, ((long)1)); 
if(
STRINGP(BgL_strz00_5090))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6443;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6444;
BgL_tmpz00_6444 = 
BSTRING_TO_STRING(BgL_strz00_5090); 
BgL_tmpz00_6443 = 
BGL_STRTOL(BgL_tmpz00_6444, ((long)0), ((long)10)); } 
BgL_numz00_5089 = 
BINT(BgL_tmpz00_6443); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5089 = BFALSE; } } 
{ /* Llib/mpd.scm 460 */
BgL_musicstatusz00_bglt BgL_statusz00_5091;
BgL_statusz00_5091 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4245)); 
if(
(
(long)CINT(BgL_numz00_5089)<
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5091))->BgL_playlistidz00))))
{ /* Llib/mpd.scm 462 */
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4244, BgL_backendz00_4245, BgL_linez00_4246, BgL_ipz00_4247, BgL_opz00_4248, 
(int)(((long)0)));}  else 
{ /* Llib/mpd.scm 462 */
return 
CNST_TABLE_REF(((long)53));} } } } 

}



/* &mpd-add */
obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4249, obj_t BgL_dbz00_4250, obj_t BgL_backendz00_4251, obj_t BgL_linez00_4252, obj_t BgL_ipz00_4253, obj_t BgL_opz00_4254)
{
{ /* Llib/mpd.scm 477 */
{ /* Llib/mpd.scm 477 */
obj_t BgL_uriz00_5092;
BgL_uriz00_5092 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4252, ((long)1)); 
if(
CBOOL(BgL_uriz00_5092))
{ /* Llib/mpd.scm 479 */
obj_t BgL_pathz00_5093;
if(
bigloo_strcmp_at(BgL_uriz00_5092, BGl_string2967z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5093 = BgL_uriz00_5092; }  else 
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5093 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(BgL_uriz00_5092, BgL_dbz00_4250, BgL_opz00_4254, BGl_string2968z00zz__multimediazd2mpdzd2); } 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5093)))
{ /* Llib/mpd.scm 481 */
obj_t BgL_g1189z00_5094;
BgL_g1189z00_5094 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5093); 
{ 
obj_t BgL_l1187z00_5096;
{ /* Llib/mpd.scm 485 */
bool_t BgL_tmpz00_6468;
BgL_l1187z00_5096 = BgL_g1189z00_5094; 
BgL_zc3z04anonymousza32007ze3z87_5095:
if(
PAIRP(BgL_l1187z00_5096))
{ /* Llib/mpd.scm 485 */
{ /* Llib/mpd.scm 482 */
obj_t BgL_fz00_5097;
BgL_fz00_5097 = 
CAR(BgL_l1187z00_5096); 
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5097, BgL_dbz00_4250))
{ /* Llib/mpd.scm 484 */
obj_t BgL_arg2010z00_5098;
BgL_arg2010z00_5098 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5093, BgL_fz00_5097); 
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4251), BgL_arg2010z00_5098); }  else 
{ /* Llib/mpd.scm 482 */BFALSE; } } 
{ 
obj_t BgL_l1187z00_6477;
BgL_l1187z00_6477 = 
CDR(BgL_l1187z00_5096); 
BgL_l1187z00_5096 = BgL_l1187z00_6477; 
goto BgL_zc3z04anonymousza32007ze3z87_5095;} }  else 
{ /* Llib/mpd.scm 485 */
BgL_tmpz00_6468 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_6468); } } }  else 
{ /* Llib/mpd.scm 480 */
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4251), BgL_pathz00_5093); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 488 */
obj_t BgL_list2012z00_5099;
BgL_list2012z00_5099 = 
MAKE_YOUNG_PAIR(BgL_uriz00_5092, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2969z00zz__multimediazd2mpdzd2, BgL_list2012z00_5099);} } } 

}



/* &mpd-delete */
obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4255, obj_t BgL_dbz00_4256, obj_t BgL_backendz00_4257, obj_t BgL_linez00_4258, obj_t BgL_ipz00_4259, obj_t BgL_opz00_4260)
{
{ /* Llib/mpd.scm 493 */
{ /* Llib/mpd.scm 493 */
obj_t BgL_numz00_5100;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5101;
BgL_strz00_5101 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4258, ((long)1)); 
if(
STRINGP(BgL_strz00_5101))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6488;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6489;
BgL_tmpz00_6489 = 
BSTRING_TO_STRING(BgL_strz00_5101); 
BgL_tmpz00_6488 = 
BGL_STRTOL(BgL_tmpz00_6489, ((long)0), ((long)10)); } 
BgL_numz00_5100 = 
BINT(BgL_tmpz00_6488); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5100 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4257), 
CINT(BgL_numz00_5100)); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-deleteid */
obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4261, obj_t BgL_dbz00_4262, obj_t BgL_backendz00_4263, obj_t BgL_linez00_4264, obj_t BgL_ipz00_4265, obj_t BgL_opz00_4266)
{
{ /* Llib/mpd.scm 500 */
{ /* Llib/mpd.scm 500 */
obj_t BgL_numz00_5102;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5103;
BgL_strz00_5103 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4264, ((long)1)); 
if(
STRINGP(BgL_strz00_5103))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6500;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6501;
BgL_tmpz00_6501 = 
BSTRING_TO_STRING(BgL_strz00_5103); 
BgL_tmpz00_6500 = 
BGL_STRTOL(BgL_tmpz00_6501, ((long)0), ((long)10)); } 
BgL_numz00_5102 = 
BINT(BgL_tmpz00_6500); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5102 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4263), 
CINT(BgL_numz00_5102)); 
{ /* Llib/mpd.scm 312 */
obj_t BgL_tmpz00_6508;
BgL_tmpz00_6508 = 
((obj_t)BgL_opz00_4266); 
bgl_display_string(BGl_string2938z00zz__multimediazd2mpdzd2, BgL_tmpz00_6508); } 
{ /* Llib/mpd.scm 313 */
obj_t BgL_tmpz00_6511;
BgL_tmpz00_6511 = 
((obj_t)BgL_opz00_4266); 
return 
bgl_flush_output_port(BgL_tmpz00_6511);} } } 

}



/* &mpd-clear */
obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4267, obj_t BgL_dbz00_4268, obj_t BgL_backendz00_4269, obj_t BgL_linez00_4270, obj_t BgL_ipz00_4271, obj_t BgL_opz00_4272)
{
{ /* Llib/mpd.scm 507 */
BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4269)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* currentsong-info */
obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t BgL_dbz00_116, obj_t BgL_backendz00_117, obj_t BgL_plistz00_118, int BgL_numz00_119, obj_t BgL_linez00_120, obj_t BgL_ipz00_121)
{
{ /* Llib/mpd.scm 514 */
{ /* Llib/mpd.scm 549 */
obj_t BgL_filez00_919;
BgL_filez00_919 = 
bgl_list_ref(BgL_plistz00_118, 
(long)(BgL_numz00_119)); 
{ /* Llib/mpd.scm 549 */
obj_t BgL_pathz00_920;
if(
bigloo_strcmp_at(BgL_filez00_919, BGl_string2967z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = BgL_filez00_919; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_919, BgL_dbz00_116); } 
{ /* Llib/mpd.scm 550 */

{ /* Llib/mpd.scm 553 */
obj_t BgL_zc3z04anonymousza32014ze3z87_4501;
BgL_zc3z04anonymousza32014ze3z87_4501 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)0)), BgL_backendz00_117); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)1)), BgL_dbz00_116); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)2)), BgL_linez00_120); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)3)), BgL_ipz00_121); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)4)), BgL_filez00_919); 
PROCEDURE_SET(BgL_zc3z04anonymousza32014ze3z87_4501, 
(int)(((long)5)), BgL_pathz00_920); 
return 
BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3z04anonymousza32014ze3z87_4501);} } } } } 

}



/* &<@anonymous:2014> */
obj_t BGl_z62zc3z04anonymousza32014ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4502, obj_t BgL_opz00_4509)
{
{ /* Llib/mpd.scm 552 */
{ /* Llib/mpd.scm 553 */
obj_t BgL_backendz00_4503;obj_t BgL_dbz00_4504;obj_t BgL_linez00_4505;obj_t BgL_ipz00_4506;obj_t BgL_filez00_4507;obj_t BgL_pathz00_4508;
BgL_backendz00_4503 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)0))); 
BgL_dbz00_4504 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)1))); 
BgL_linez00_4505 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)2))); 
BgL_ipz00_4506 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)3))); 
BgL_filez00_4507 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)4))); 
BgL_pathz00_4508 = 
PROCEDURE_REF(BgL_envz00_4502, 
(int)(((long)5))); 
{ 
obj_t BgL_opz00_5105;obj_t BgL_filez00_5106;obj_t BgL_pathz00_5107;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_4507)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_5118;
BgL_g1186z00_5118 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_4504, BgL_filez00_4507, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_5120;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_6554;
BgL_l1184z00_5120 = BgL_g1186z00_5118; 
BgL_zc3z04anonymousza31984ze3z87_5119:
if(
PAIRP(BgL_l1184z00_5120))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5121;
BgL_kz00_5121 = 
CAR(BgL_l1184z00_5120); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_5122;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_5123;
BgL_arg1987z00_5123 = 
CAR(
((obj_t)BgL_kz00_5121)); 
BgL_arg1986z00_5122 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_5123)); } 
bgl_display_obj(BgL_arg1986z00_5122, BgL_opz00_4509); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6563;
BgL_tmpz00_6563 = 
((obj_t)BgL_opz00_4509); 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_tmpz00_6563); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_5124;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5125;
BgL_pairz00_5125 = 
CDR(
((obj_t)BgL_kz00_5121)); 
BgL_arg1988z00_5124 = 
CAR(BgL_pairz00_5125); } 
bgl_display_obj(BgL_arg1988z00_5124, BgL_opz00_4509); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6570;
BgL_tmpz00_6570 = 
((obj_t)BgL_opz00_4509); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6570); } } 
{ 
obj_t BgL_l1184z00_6573;
BgL_l1184z00_6573 = 
CDR(BgL_l1184z00_5120); 
BgL_l1184z00_5120 = BgL_l1184z00_6573; 
goto BgL_zc3z04anonymousza31984ze3z87_5119;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_6554 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_6554);} } }  else 
{ /* Llib/mpd.scm 553 */
BgL_opz00_5105 = BgL_opz00_4509; 
BgL_filez00_5106 = BgL_filez00_4507; 
BgL_pathz00_5107 = BgL_pathz00_4508; 
{ /* Llib/mpd.scm 518 */
obj_t BgL_metaz00_5108;
BgL_metaz00_5108 = 
BGl_musiczd2metazd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4503)); 
if(
NULLP(BgL_metaz00_5108))
{ /* Llib/mpd.scm 520 */
int BgL_arg2018z00_5109;
BgL_arg2018z00_5109 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4503)); 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4504, BgL_backendz00_4503, BgL_linez00_4505, BgL_ipz00_4506, BgL_opz00_5105, BgL_arg2018z00_5109);}  else 
{ /* Llib/mpd.scm 521 */
int BgL_numz00_5110;obj_t BgL_dirz00_5111;
BgL_numz00_5110 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4503)); 
BgL_dirz00_5111 = 
BGl_dirnamez00zz__osz00(BgL_filez00_5106); 
{ /* Llib/mpd.scm 523 */
obj_t BgL_tmpz00_6586;
BgL_tmpz00_6586 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2970z00zz__multimediazd2mpdzd2, BgL_tmpz00_6586); } 
bgl_display_obj(BgL_pathz00_5107, BgL_opz00_5105); 
{ /* Llib/mpd.scm 525 */
obj_t BgL_tmpz00_6590;
BgL_tmpz00_6590 = 
((obj_t)BgL_opz00_5105); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6590); } 
{ /* Llib/mpd.scm 527 */
obj_t BgL_tmpz00_6593;
BgL_tmpz00_6593 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2971z00zz__multimediazd2mpdzd2, BgL_tmpz00_6593); } 
bgl_display_obj(
BINT(BgL_numz00_5110), BgL_opz00_5105); 
{ /* Llib/mpd.scm 529 */
obj_t BgL_tmpz00_6598;
BgL_tmpz00_6598 = 
((obj_t)BgL_opz00_5105); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6598); } 
{ /* Llib/mpd.scm 530 */
obj_t BgL_tmpz00_6601;
BgL_tmpz00_6601 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2972z00zz__multimediazd2mpdzd2, BgL_tmpz00_6601); } 
bgl_display_obj(
BINT(BgL_numz00_5110), BgL_opz00_5105); 
{ /* Llib/mpd.scm 532 */
obj_t BgL_tmpz00_6606;
BgL_tmpz00_6606 = 
((obj_t)BgL_opz00_5105); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6606); } 
{ /* Llib/mpd.scm 533 */
obj_t BgL_caz00_5112;
BgL_caz00_5112 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)69)), BgL_metaz00_5108); 
{ /* Llib/mpd.scm 533 */
obj_t BgL_ctz00_5113;
BgL_ctz00_5113 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)70)), BgL_metaz00_5108); 
{ /* Llib/mpd.scm 534 */
obj_t BgL_cbz00_5114;
BgL_cbz00_5114 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)71)), BgL_metaz00_5108); 
{ /* Llib/mpd.scm 535 */
obj_t BgL_az00_5115;
if(
PAIRP(BgL_caz00_5112))
{ /* Llib/mpd.scm 536 */
BgL_az00_5115 = 
CDR(BgL_caz00_5112); }  else 
{ /* Llib/mpd.scm 536 */
BgL_az00_5115 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5111))); } 
{ /* Llib/mpd.scm 536 */
obj_t BgL_tz00_5116;
if(
PAIRP(BgL_ctz00_5113))
{ /* Llib/mpd.scm 539 */
BgL_tz00_5116 = 
CDR(BgL_ctz00_5113); }  else 
{ /* Llib/mpd.scm 539 */
BgL_tz00_5116 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_filez00_5106)); } 
{ /* Llib/mpd.scm 539 */
obj_t BgL_bz00_5117;
if(
PAIRP(BgL_cbz00_5114))
{ /* Llib/mpd.scm 542 */
BgL_bz00_5117 = 
CDR(BgL_cbz00_5114); }  else 
{ /* Llib/mpd.scm 542 */
BgL_bz00_5117 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_5111)); } 
{ /* Llib/mpd.scm 542 */

{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_6631;
BgL_tmpz00_6631 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2973z00zz__multimediazd2mpdzd2, BgL_tmpz00_6631); } 
bgl_display_obj(BgL_az00_5115, BgL_opz00_5105); 
{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_6635;
BgL_tmpz00_6635 = 
((obj_t)BgL_opz00_5105); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6635); } 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_6638;
BgL_tmpz00_6638 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2974z00zz__multimediazd2mpdzd2, BgL_tmpz00_6638); } 
bgl_display_obj(BgL_tz00_5116, BgL_opz00_5105); 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_6642;
BgL_tmpz00_6642 = 
((obj_t)BgL_opz00_5105); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6642); } 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_6645;
BgL_tmpz00_6645 = 
((obj_t)BgL_opz00_5105); 
bgl_display_string(BGl_string2975z00zz__multimediazd2mpdzd2, BgL_tmpz00_6645); } 
bgl_display_obj(BgL_bz00_5117, BgL_opz00_5105); 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_6649;
BgL_tmpz00_6649 = 
((obj_t)BgL_opz00_5105); 
return 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6649);} } } } } } } } } } } } } } 

}



/* &mpd-currentsong */
obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4273, obj_t BgL_dbz00_4274, obj_t BgL_backendz00_4275, obj_t BgL_linez00_4276, obj_t BgL_ipz00_4277, obj_t BgL_opz00_4278)
{
{ /* Llib/mpd.scm 579 */
{ /* Llib/mpd.scm 580 */
obj_t BgL_plistz00_5126;int BgL_numz00_5127;
BgL_plistz00_5126 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4275)); 
BgL_numz00_5127 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4275)); 
{ /* Llib/mpd.scm 582 */
bool_t BgL_test3470z00_6656;
if(
(
(long)(BgL_numz00_5127)>=((long)0)))
{ /* Llib/mpd.scm 582 */
BgL_test3470z00_6656 = 
(
(long)(BgL_numz00_5127)<
bgl_list_length(BgL_plistz00_5126))
; }  else 
{ /* Llib/mpd.scm 582 */
BgL_test3470z00_6656 = ((bool_t)0)
; } 
if(BgL_test3470z00_6656)
{ /* Llib/mpd.scm 568 */
bool_t BgL_test3472z00_6663;
if(
(BgL_plistz00_5126==BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 568 */
BgL_test3472z00_6663 = 
(BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2==
(long)(BgL_numz00_5127))
; }  else 
{ /* Llib/mpd.scm 568 */
BgL_test3472z00_6663 = ((bool_t)0)
; } 
if(BgL_test3472z00_6663)
{ /* Llib/mpd.scm 568 */
bgl_display_obj(BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2, BgL_opz00_4278); }  else 
{ /* Llib/mpd.scm 570 */
obj_t BgL_infoz00_5128;
BgL_infoz00_5128 = 
BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(BgL_dbz00_4274, BgL_backendz00_4275, BgL_plistz00_5126, BgL_numz00_5127, BgL_linez00_4276, BgL_ipz00_4277); 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BgL_plistz00_5126; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = 
(long)(BgL_numz00_5127); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BgL_infoz00_5128; 
bgl_display_obj(BgL_infoz00_5128, BgL_opz00_4278); } }  else 
{ /* Llib/mpd.scm 582 */BFALSE; } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-play */
obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4279, obj_t BgL_dbz00_4280, obj_t BgL_backendz00_4281, obj_t BgL_linez00_4282, obj_t BgL_ipz00_4283, obj_t BgL_opz00_4284)
{
{ /* Llib/mpd.scm 589 */
{ /* Llib/mpd.scm 589 */
obj_t BgL_numz00_5129;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5130;
BgL_strz00_5130 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4282, ((long)1)); 
if(
STRINGP(BgL_strz00_5130))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6676;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6677;
BgL_tmpz00_6677 = 
BSTRING_TO_STRING(BgL_strz00_5130); 
BgL_tmpz00_6676 = 
BGL_STRTOL(BgL_tmpz00_6677, ((long)0), ((long)10)); } 
BgL_numz00_5129 = 
BINT(BgL_tmpz00_6676); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5129 = BFALSE; } } 
{ /* Llib/mpd.scm 590 */
bool_t BgL_test3475z00_6681;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5129))
{ /* Llib/mpd.scm 590 */
BgL_test3475z00_6681 = 
(
(long)CINT(BgL_numz00_5129)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 590 */
BgL_test3475z00_6681 = ((bool_t)0)
; } 
if(BgL_test3475z00_6681)
{ /* Llib/mpd.scm 591 */
obj_t BgL_list2034z00_5131;
BgL_list2034z00_5131 = 
MAKE_YOUNG_PAIR(BgL_numz00_5129, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4281), BgL_list2034z00_5131); }  else 
{ /* Llib/mpd.scm 590 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4281), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-playid */
obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4285, obj_t BgL_dbz00_4286, obj_t BgL_backendz00_4287, obj_t BgL_linez00_4288, obj_t BgL_ipz00_4289, obj_t BgL_opz00_4290)
{
{ /* Llib/mpd.scm 598 */
{ /* Llib/mpd.scm 598 */
obj_t BgL_numz00_5132;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5133;
BgL_strz00_5133 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4288, ((long)1)); 
if(
STRINGP(BgL_strz00_5133))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6695;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6696;
BgL_tmpz00_6696 = 
BSTRING_TO_STRING(BgL_strz00_5133); 
BgL_tmpz00_6695 = 
BGL_STRTOL(BgL_tmpz00_6696, ((long)0), ((long)10)); } 
BgL_numz00_5132 = 
BINT(BgL_tmpz00_6695); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5132 = BFALSE; } } 
{ /* Llib/mpd.scm 599 */
bool_t BgL_test3478z00_6700;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5132))
{ /* Llib/mpd.scm 599 */
BgL_test3478z00_6700 = 
(
(long)CINT(BgL_numz00_5132)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 599 */
BgL_test3478z00_6700 = ((bool_t)0)
; } 
if(BgL_test3478z00_6700)
{ /* Llib/mpd.scm 600 */
obj_t BgL_list2038z00_5134;
BgL_list2038z00_5134 = 
MAKE_YOUNG_PAIR(BgL_numz00_5132, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4287), BgL_list2038z00_5134); }  else 
{ /* Llib/mpd.scm 599 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4287), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seek */
obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4291, obj_t BgL_dbz00_4292, obj_t BgL_backendz00_4293, obj_t BgL_linez00_4294, obj_t BgL_ipz00_4295, obj_t BgL_opz00_4296)
{
{ /* Llib/mpd.scm 607 */
{ /* Llib/mpd.scm 607 */
obj_t BgL_num1z00_5135;obj_t BgL_num2z00_5136;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5137;
BgL_strz00_5137 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4294, ((long)1)); 
if(
STRINGP(BgL_strz00_5137))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6714;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6715;
BgL_tmpz00_6715 = 
BSTRING_TO_STRING(BgL_strz00_5137); 
BgL_tmpz00_6714 = 
BGL_STRTOL(BgL_tmpz00_6715, ((long)0), ((long)10)); } 
BgL_num1z00_5135 = 
BINT(BgL_tmpz00_6714); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5135 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5138;
BgL_strz00_5138 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4294, ((long)2)); 
if(
STRINGP(BgL_strz00_5138))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6722;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6723;
BgL_tmpz00_6723 = 
BSTRING_TO_STRING(BgL_strz00_5138); 
BgL_tmpz00_6722 = 
BGL_STRTOL(BgL_tmpz00_6723, ((long)0), ((long)10)); } 
BgL_num2z00_5136 = 
BINT(BgL_tmpz00_6722); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5136 = BFALSE; } } 
{ /* Llib/mpd.scm 608 */
obj_t BgL_list2040z00_5139;
BgL_list2040z00_5139 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5135, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4293), BgL_num2z00_5136, BgL_list2040z00_5139); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seekid */
obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4297, obj_t BgL_dbz00_4298, obj_t BgL_backendz00_4299, obj_t BgL_linez00_4300, obj_t BgL_ipz00_4301, obj_t BgL_opz00_4302)
{
{ /* Llib/mpd.scm 614 */
{ /* Llib/mpd.scm 614 */
obj_t BgL_num1z00_5140;obj_t BgL_num2z00_5141;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5142;
BgL_strz00_5142 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4300, ((long)1)); 
if(
STRINGP(BgL_strz00_5142))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6734;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6735;
BgL_tmpz00_6735 = 
BSTRING_TO_STRING(BgL_strz00_5142); 
BgL_tmpz00_6734 = 
BGL_STRTOL(BgL_tmpz00_6735, ((long)0), ((long)10)); } 
BgL_num1z00_5140 = 
BINT(BgL_tmpz00_6734); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5140 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5143;
BgL_strz00_5143 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4300, ((long)2)); 
if(
STRINGP(BgL_strz00_5143))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6742;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6743;
BgL_tmpz00_6743 = 
BSTRING_TO_STRING(BgL_strz00_5143); 
BgL_tmpz00_6742 = 
BGL_STRTOL(BgL_tmpz00_6743, ((long)0), ((long)10)); } 
BgL_num2z00_5141 = 
BINT(BgL_tmpz00_6742); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5141 = BFALSE; } } 
{ /* Llib/mpd.scm 615 */
obj_t BgL_list2041z00_5144;
BgL_list2041z00_5144 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5140, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4299), BgL_num2z00_5141, BgL_list2041z00_5144); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-stop */
obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4303, obj_t BgL_dbz00_4304, obj_t BgL_backendz00_4305, obj_t BgL_linez00_4306, obj_t BgL_ipz00_4307, obj_t BgL_opz00_4308)
{
{ /* Llib/mpd.scm 621 */
BGl_musiczd2stopzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4305)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-pause */
obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4309, obj_t BgL_dbz00_4310, obj_t BgL_backendz00_4311, obj_t BgL_linez00_4312, obj_t BgL_ipz00_4313, obj_t BgL_opz00_4314)
{
{ /* Llib/mpd.scm 628 */
BGl_musiczd2pausezd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4311)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* <@exit:2047>~0 */
obj_t BGl_zc3z04exitza32047ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_4906, obj_t BgL_res1111z00_4905)
{
{ /* Llib/mpd.scm 636 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1117z00_1004;
if( SET_EXIT(BgL_an_exit1117z00_1004 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1117z00_1004 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 636 */

PUSH_EXIT(BgL_an_exit1117z00_1004, ((long)1)); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_an_exitd1118z00_1005;
BgL_an_exitd1118z00_1005 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_res1120z00_1008;
{ /* Llib/mpd.scm 636 */
obj_t BgL_ohs1109z00_1009;
BgL_ohs1109z00_1009 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_exitd1114z00_1010;
BgL_exitd1114z00_1010 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32050ze3z87_4511;
BgL_zc3z04anonymousza32050ze3z87_4511 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32050ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32050ze3z87_4511, 
(int)(((long)0)), BgL_ohs1109z00_1009); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1010, BgL_zc3z04anonymousza32050ze3z87_4511); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_tmp1116z00_1012;
{ /* Llib/mpd.scm 636 */
obj_t BgL_zc3z04anonymousza32049ze3z87_4510;
BgL_zc3z04anonymousza32049ze3z87_4510 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32049ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_4510, 
(int)(((long)0)), 
((obj_t)BgL_res1111z00_4905)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_4510, 
(int)(((long)1)), BgL_an_exitd1118z00_1005); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza32049ze3z87_4510, BgL_ohs1109z00_1009); BUNSPEC; } 
{ /* Llib/mpd.scm 636 */
obj_t BgL_auxz00_4520;
BGl_musiczd2nextzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4906)); 
BgL_auxz00_4520 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1111z00_4905, BgL_auxz00_4520); } 
BgL_tmp1116z00_1012 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1010); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_1009); BUNSPEC; 
BgL_res1120z00_1008 = BgL_tmp1116z00_1012; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1120z00_1008);} } } 
}} 

}



/* &mpd-next */
obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4315, obj_t BgL_dbz00_4316, obj_t BgL_backendz00_4317, obj_t BgL_linez00_4318, obj_t BgL_ipz00_4319, obj_t BgL_opz00_4320)
{
{ /* Llib/mpd.scm 635 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_5145;
BgL_res1111z00_5145 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5147;
if(
CBOOL(
BGl_zc3z04exitza32047ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4317, BgL_res1111z00_5145)))
{ /* Llib/mpd.scm 636 */
{ /* Llib/mpd.scm 636 */
int BgL_tmpz00_6786;
BgL_tmpz00_6786 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_6786); } 
BgL_ez00_5147 = 
CELL_REF(BgL_res1111z00_5145); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5147, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 638 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_6791;
BgL_tmpz00_6791 = 
((obj_t)BgL_opz00_4320); 
bgl_display_string(BGl_string2939z00zz__multimediazd2mpdzd2, BgL_tmpz00_6791); } 
bgl_display_obj(BGl_string2976z00zz__multimediazd2mpdzd2, BgL_opz00_4320); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_6795;
BgL_tmpz00_6795 = 
((obj_t)BgL_opz00_4320); 
bgl_display_string(BGl_string2941z00zz__multimediazd2mpdzd2, BgL_tmpz00_6795); } 
bgl_display_obj(BGl_string2977z00zz__multimediazd2mpdzd2, BgL_opz00_4320); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_6799;
BgL_tmpz00_6799 = 
((obj_t)BgL_opz00_4320); 
bgl_display_string(BGl_string2942z00zz__multimediazd2mpdzd2, BgL_tmpz00_6799); } 
bgl_display_obj(BGl_string2978z00zz__multimediazd2mpdzd2, BgL_opz00_4320); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_6803;
BgL_tmpz00_6803 = 
((obj_t)BgL_opz00_4320); 
bgl_display_string(BGl_string2943z00zz__multimediazd2mpdzd2, BgL_tmpz00_6803); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_6806;
BgL_tmpz00_6806 = 
((obj_t)BgL_opz00_4320); 
bgl_flush_output_port(BgL_tmpz00_6806); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 638 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5147);} }  else 
{ /* Llib/mpd.scm 636 */
return 
CELL_REF(BgL_res1111z00_5145);} } } } 

}



/* &<@anonymous:2049> */
obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4512, obj_t BgL_ez00_4515)
{
{ /* Llib/mpd.scm 636 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_4513;obj_t BgL_an_exitd1118z00_4514;
BgL_res1111z00_4513 = 
PROCEDURE_REF(BgL_envz00_4512, 
(int)(((long)0))); 
BgL_an_exitd1118z00_4514 = 
PROCEDURE_REF(BgL_envz00_4512, 
(int)(((long)1))); 
CELL_SET(BgL_res1111z00_4513, BgL_ez00_4515); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1118z00_4514, BTRUE);} } 

}



/* &<@anonymous:2050> */
obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4517)
{
{ /* Llib/mpd.scm 636 */
{ 
obj_t BgL_ohs1109z00_4518;
BgL_ohs1109z00_4518 = 
PROCEDURE_REF(BgL_envz00_4517, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_4518); 
return BUNSPEC;} } 

}



/* <@exit:2058>~0 */
obj_t BGl_zc3z04exitza32058ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_4904, obj_t BgL_res1123z00_4903)
{
{ /* Llib/mpd.scm 649 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1129z00_1045;
if( SET_EXIT(BgL_an_exit1129z00_1045 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1129z00_1045 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 649 */

PUSH_EXIT(BgL_an_exit1129z00_1045, ((long)1)); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_an_exitd1130z00_1046;
BgL_an_exitd1130z00_1046 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_res1132z00_1049;
{ /* Llib/mpd.scm 649 */
obj_t BgL_ohs1121z00_1050;
BgL_ohs1121z00_1050 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_exitd1126z00_1051;
BgL_exitd1126z00_1051 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32061ze3z87_4523;
BgL_zc3z04anonymousza32061ze3z87_4523 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32061ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32061ze3z87_4523, 
(int)(((long)0)), BgL_ohs1121z00_1050); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1051, BgL_zc3z04anonymousza32061ze3z87_4523); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_tmp1128z00_1053;
{ /* Llib/mpd.scm 649 */
obj_t BgL_zc3z04anonymousza32060ze3z87_4522;
BgL_zc3z04anonymousza32060ze3z87_4522 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32060ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_4522, 
(int)(((long)0)), 
((obj_t)BgL_res1123z00_4903)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32060ze3z87_4522, 
(int)(((long)1)), BgL_an_exitd1130z00_1046); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza32060ze3z87_4522, BgL_ohs1121z00_1050); BUNSPEC; } 
{ /* Llib/mpd.scm 649 */
obj_t BgL_auxz00_4532;
BGl_musiczd2prevzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4904)); 
BgL_auxz00_4532 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1123z00_4903, BgL_auxz00_4532); } 
BgL_tmp1128z00_1053 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1051); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_1050); BUNSPEC; 
BgL_res1132z00_1049 = BgL_tmp1128z00_1053; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1132z00_1049);} } } 
}} 

}



/* &mpd-previous */
obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4321, obj_t BgL_dbz00_4322, obj_t BgL_backendz00_4323, obj_t BgL_linez00_4324, obj_t BgL_ipz00_4325, obj_t BgL_opz00_4326)
{
{ /* Llib/mpd.scm 648 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_5148;
BgL_res1123z00_5148 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5150;
if(
CBOOL(
BGl_zc3z04exitza32058ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4323, BgL_res1123z00_5148)))
{ /* Llib/mpd.scm 649 */
{ /* Llib/mpd.scm 649 */
int BgL_tmpz00_6848;
BgL_tmpz00_6848 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_6848); } 
BgL_ez00_5150 = 
CELL_REF(BgL_res1123z00_5148); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5150, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 651 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_6853;
BgL_tmpz00_6853 = 
((obj_t)BgL_opz00_4326); 
bgl_display_string(BGl_string2939z00zz__multimediazd2mpdzd2, BgL_tmpz00_6853); } 
bgl_display_obj(BGl_string2976z00zz__multimediazd2mpdzd2, BgL_opz00_4326); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_6857;
BgL_tmpz00_6857 = 
((obj_t)BgL_opz00_4326); 
bgl_display_string(BGl_string2941z00zz__multimediazd2mpdzd2, BgL_tmpz00_6857); } 
bgl_display_obj(BGl_string2979z00zz__multimediazd2mpdzd2, BgL_opz00_4326); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_6861;
BgL_tmpz00_6861 = 
((obj_t)BgL_opz00_4326); 
bgl_display_string(BGl_string2942z00zz__multimediazd2mpdzd2, BgL_tmpz00_6861); } 
bgl_display_obj(BGl_string2980z00zz__multimediazd2mpdzd2, BgL_opz00_4326); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_6865;
BgL_tmpz00_6865 = 
((obj_t)BgL_opz00_4326); 
bgl_display_string(BGl_string2943z00zz__multimediazd2mpdzd2, BgL_tmpz00_6865); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_6868;
BgL_tmpz00_6868 = 
((obj_t)BgL_opz00_4326); 
bgl_flush_output_port(BgL_tmpz00_6868); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 651 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5150);} }  else 
{ /* Llib/mpd.scm 649 */
return 
CELL_REF(BgL_res1123z00_5148);} } } } 

}



/* &<@anonymous:2060> */
obj_t BGl_z62zc3z04anonymousza32060ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4524, obj_t BgL_ez00_4527)
{
{ /* Llib/mpd.scm 649 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_4525;obj_t BgL_an_exitd1130z00_4526;
BgL_res1123z00_4525 = 
PROCEDURE_REF(BgL_envz00_4524, 
(int)(((long)0))); 
BgL_an_exitd1130z00_4526 = 
PROCEDURE_REF(BgL_envz00_4524, 
(int)(((long)1))); 
CELL_SET(BgL_res1123z00_4525, BgL_ez00_4527); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1130z00_4526, BTRUE);} } 

}



/* &<@anonymous:2061> */
obj_t BGl_z62zc3z04anonymousza32061ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4529)
{
{ /* Llib/mpd.scm 649 */
{ 
obj_t BgL_ohs1121z00_4530;
BgL_ohs1121z00_4530 = 
PROCEDURE_REF(BgL_envz00_4529, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_4530); 
return BUNSPEC;} } 

}



/* &mpd-volume */
obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4327, obj_t BgL_dbz00_4328, obj_t BgL_backendz00_4329, obj_t BgL_linez00_4330, obj_t BgL_ipz00_4331, obj_t BgL_opz00_4332)
{
{ /* Llib/mpd.scm 661 */
{ /* Llib/mpd.scm 661 */
obj_t BgL_intz00_5151;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5152;
BgL_strz00_5152 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4330, ((long)1)); 
if(
STRINGP(BgL_strz00_5152))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6884;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6885;
BgL_tmpz00_6885 = 
BSTRING_TO_STRING(BgL_strz00_5152); 
BgL_tmpz00_6884 = 
BGL_STRTOL(BgL_tmpz00_6885, ((long)0), ((long)10)); } 
BgL_intz00_5151 = 
BINT(BgL_tmpz00_6884); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5151 = BFALSE; } } 
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_intz00_5151))
{ /* Llib/mpd.scm 662 */
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4329), BgL_intz00_5151); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 662 */
{ /* Llib/mpd.scm 670 */
obj_t BgL_arg2065z00_5153;
BgL_arg2065z00_5153 = 
BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4329)); 
bgl_display_obj(BgL_arg2065z00_5153, BgL_opz00_4332); } 
{ /* Llib/mpd.scm 671 */
obj_t BgL_tmpz00_6897;
BgL_tmpz00_6897 = 
((obj_t)BgL_opz00_4332); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6897); } 
return 
CNST_TABLE_REF(((long)53));} } } 

}



/* &mpd-setvol */
obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4333, obj_t BgL_dbz00_4334, obj_t BgL_backendz00_4335, obj_t BgL_linez00_4336, obj_t BgL_ipz00_4337, obj_t BgL_opz00_4338)
{
{ /* Llib/mpd.scm 684 */
{ /* Llib/mpd.scm 684 */
obj_t BgL_intz00_5154;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5155;
BgL_strz00_5155 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4336, ((long)1)); 
if(
STRINGP(BgL_strz00_5155))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6904;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6905;
BgL_tmpz00_6905 = 
BSTRING_TO_STRING(BgL_strz00_5155); 
BgL_tmpz00_6904 = 
BGL_STRTOL(BgL_tmpz00_6905, ((long)0), ((long)10)); } 
BgL_intz00_5154 = 
BINT(BgL_tmpz00_6904); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5154 = BFALSE; } } 
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4335), BgL_intz00_5154); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-clearerror */
obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4339, obj_t BgL_dbz00_4340, obj_t BgL_backendz00_4341, obj_t BgL_linez00_4342, obj_t BgL_ipz00_4343, obj_t BgL_opz00_4344)
{
{ /* Llib/mpd.scm 690 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-close */
obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4345, obj_t BgL_dbz00_4346, obj_t BgL_backendz00_4347, obj_t BgL_linez00_4348, obj_t BgL_ipz00_4349, obj_t BgL_opz00_4350)
{
{ /* Llib/mpd.scm 696 */
return 
CNST_TABLE_REF(((long)24));} 

}



/* &mpd-stats */
obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4351, obj_t BgL_dbz00_4352, obj_t BgL_backendz00_4353, obj_t BgL_linez00_4354, obj_t BgL_ipz00_4355, obj_t BgL_opz00_4356)
{
{ /* Llib/mpd.scm 702 */
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4352), BgL_backendz00_4353, BgL_opz00_4356); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-listall */
obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4357, obj_t BgL_dbz00_4358, obj_t BgL_backendz00_4359, obj_t BgL_linez00_4360, obj_t BgL_ipz00_4361, obj_t BgL_opz00_4362)
{
{ /* Llib/mpd.scm 709 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4358), BgL_opz00_4362); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-list */
obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4363, obj_t BgL_dbz00_4364, obj_t BgL_backendz00_4365, obj_t BgL_linez00_4366, obj_t BgL_ipz00_4367, obj_t BgL_opz00_4368)
{
{ /* Llib/mpd.scm 716 */
{ /* Llib/mpd.scm 716 */
obj_t BgL_symz00_5156;obj_t BgL_string2z00_5157;obj_t BgL_string3z00_5158;
BgL_symz00_5156 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4366, ((long)1)); 
BgL_string2z00_5157 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4366, ((long)2)); 
BgL_string3z00_5158 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4366, ((long)3)); 
if(
(BgL_symz00_5156==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5157, BGl_string2981z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 720 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368, BgL_string3z00_5158); }  else 
{ /* Llib/mpd.scm 720 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5157, BGl_string2982z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368, BgL_string3z00_5158); }  else 
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368, BgL_string2z00_5157); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5156==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5157, BGl_string2982z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368, BgL_string3z00_5158); }  else 
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5156==
CNST_TABLE_REF(((long)72))))
{ /* Llib/mpd.scm 717 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5156==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 717 */
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4364), BgL_opz00_4368); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
CBOOL(BgL_symz00_5156))
{ /* Llib/mpd.scm 740 */
obj_t BgL_list2073z00_5159;
BgL_list2073z00_5159 = 
MAKE_YOUNG_PAIR(BgL_symz00_5156, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2983z00zz__multimediazd2mpdzd2, BgL_list2073z00_5159);}  else 
{ /* Llib/mpd.scm 738 */
return BGl_string2984z00zz__multimediazd2mpdzd2;} } } } } } } 

}



/* &mpd-listallinfo */
obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4369, obj_t BgL_dbz00_4370, obj_t BgL_backendz00_4371, obj_t BgL_linez00_4372, obj_t BgL_ipz00_4373, obj_t BgL_opz00_4374)
{
{ /* Llib/mpd.scm 745 */
{ /* Llib/mpd.scm 745 */
obj_t BgL_dirz00_5160;
BgL_dirz00_5160 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4372, ((long)1)); 
{ /* Llib/mpd.scm 746 */
obj_t BgL_arg2074z00_5161;
if(
CBOOL(BgL_dirz00_5160))
{ /* Llib/mpd.scm 746 */
BgL_arg2074z00_5161 = BgL_dirz00_5160; }  else 
{ /* Llib/mpd.scm 746 */
obj_t BgL_list2076z00_5162;
BgL_list2076z00_5162 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2074z00_5161 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2076z00_5162); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4370), BgL_opz00_4374, BgL_arg2074z00_5161, ((bool_t)1)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-lsinfo */
obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4375, obj_t BgL_dbz00_4376, obj_t BgL_backendz00_4377, obj_t BgL_linez00_4378, obj_t BgL_ipz00_4379, obj_t BgL_opz00_4380)
{
{ /* Llib/mpd.scm 752 */
{ /* Llib/mpd.scm 752 */
obj_t BgL_dirz00_5163;
BgL_dirz00_5163 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4378, ((long)1)); 
{ /* Llib/mpd.scm 753 */
obj_t BgL_arg2077z00_5164;
if(
CBOOL(BgL_dirz00_5163))
{ /* Llib/mpd.scm 753 */
BgL_arg2077z00_5164 = BgL_dirz00_5163; }  else 
{ /* Llib/mpd.scm 753 */
obj_t BgL_list2079z00_5165;
BgL_list2079z00_5165 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2077z00_5164 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2079z00_5165); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4376), BgL_opz00_4380, BgL_arg2077z00_5164, ((bool_t)0)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-plconangesposid */
obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4381, obj_t BgL_dbz00_4382, obj_t BgL_backendz00_4383, obj_t BgL_linez00_4384, obj_t BgL_ipz00_4385, obj_t BgL_opz00_4386)
{
{ /* Llib/mpd.scm 759 */
{ /* Llib/mpd.scm 759 */
obj_t BgL_intz00_5166;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5167;
BgL_strz00_5167 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4384, ((long)1)); 
if(
STRINGP(BgL_strz00_5167))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6982;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6983;
BgL_tmpz00_6983 = 
BSTRING_TO_STRING(BgL_strz00_5167); 
BgL_tmpz00_6982 = 
BGL_STRTOL(BgL_tmpz00_6983, ((long)0), ((long)10)); } 
BgL_intz00_5166 = 
BINT(BgL_tmpz00_6982); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5166 = BFALSE; } } 
{ /* Llib/mpd.scm 760 */
long BgL_numz00_5168;
BgL_numz00_5168 = ((long)0); 
{ /* Llib/mpd.scm 761 */
obj_t BgL_g1200z00_5169;
BgL_g1200z00_5169 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4383)); 
{ 
obj_t BgL_l1195z00_5171;
BgL_l1195z00_5171 = BgL_g1200z00_5169; 
BgL_zc3z04anonymousza32080ze3z87_5170:
if(
PAIRP(BgL_l1195z00_5171))
{ /* Llib/mpd.scm 765 */
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_6991;
BgL_tmpz00_6991 = 
((obj_t)BgL_opz00_4386); 
bgl_display_string(BGl_string2985z00zz__multimediazd2mpdzd2, BgL_tmpz00_6991); } 
bgl_display_obj(
BINT(BgL_numz00_5168), BgL_opz00_4386); 
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_6996;
BgL_tmpz00_6996 = 
((obj_t)BgL_opz00_4386); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6996); } 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_6999;
BgL_tmpz00_6999 = 
((obj_t)BgL_opz00_4386); 
bgl_display_string(BGl_string2972z00zz__multimediazd2mpdzd2, BgL_tmpz00_6999); } 
bgl_display_obj(
BINT(BgL_numz00_5168), BgL_opz00_4386); 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7004;
BgL_tmpz00_7004 = 
((obj_t)BgL_opz00_4386); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7004); } 
BgL_numz00_5168 = 
(BgL_numz00_5168+((long)1)); 
{ 
obj_t BgL_l1195z00_7008;
BgL_l1195z00_7008 = 
CDR(BgL_l1195z00_5171); 
BgL_l1195z00_5171 = BgL_l1195z00_7008; 
goto BgL_zc3z04anonymousza32080ze3z87_5170;} }  else 
{ /* Llib/mpd.scm 765 */((bool_t)1); } } } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-kill */
obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4387, obj_t BgL_dbz00_4388, obj_t BgL_backendz00_4389, obj_t BgL_linez00_4390, obj_t BgL_ipz00_4391, obj_t BgL_opz00_4392)
{
{ /* Llib/mpd.scm 771 */
return 
CNST_TABLE_REF(((long)31));} 

}



/* &mpd-find */
obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4393, obj_t BgL_dbz00_4394, obj_t BgL_backendz00_4395, obj_t BgL_linez00_4396, obj_t BgL_ipz00_4397, obj_t BgL_opz00_4398)
{
{ /* Llib/mpd.scm 777 */
{ /* Llib/mpd.scm 777 */
obj_t BgL_symbolz00_5172;obj_t BgL_string2z00_5173;
BgL_symbolz00_5172 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4396, ((long)1)); 
BgL_string2z00_5173 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4396, ((long)2)); 
if(
(BgL_symbolz00_5172==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4394), BgL_opz00_4398, BgL_string2z00_5173); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5172==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4394), BgL_opz00_4398, BgL_string2z00_5173); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5172==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4394), BgL_opz00_4398, BgL_string2z00_5173); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5172==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4394), BgL_opz00_4398, BgL_string2z00_5173); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 792 */
obj_t BgL_list2087z00_5174;
BgL_list2087z00_5174 = 
MAKE_YOUNG_PAIR(BgL_symbolz00_5172, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2986z00zz__multimediazd2mpdzd2, BgL_list2087z00_5174);} } } } } } 

}



/* &mpd-search */
obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4399, obj_t BgL_dbz00_4400, obj_t BgL_backendz00_4401, obj_t BgL_linez00_4402, obj_t BgL_ipz00_4403, obj_t BgL_opz00_4404)
{
{ /* Llib/mpd.scm 797 */
{ /* Llib/mpd.scm 797 */
obj_t BgL_symbol1z00_5175;obj_t BgL_string2z00_5176;obj_t BgL_symbol3z00_5177;obj_t BgL_string4z00_5178;
BgL_symbol1z00_5175 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4402, ((long)1)); 
BgL_string2z00_5176 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4402, ((long)2)); 
BgL_symbol3z00_5177 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4402, ((long)3)); 
BgL_string4z00_5178 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4402, ((long)4)); 
if(
(BgL_symbol1z00_5175==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5175==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol3z00_5177==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176, BgL_string4z00_5178); }  else 
{ /* Llib/mpd.scm 803 */
if(
(BgL_symbol3z00_5177==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176, BgL_string4z00_5178); }  else 
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5175==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5175==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404, BgL_string2z00_5176); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5175==
CNST_TABLE_REF(((long)74))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4400), BgL_opz00_4404); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 820 */
obj_t BgL_list2095z00_5179;
BgL_list2095z00_5179 = 
MAKE_YOUNG_PAIR(BgL_symbol1z00_5175, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2987z00zz__multimediazd2mpdzd2, BgL_list2095z00_5179);} } } } } } } 

}



/* &mpd-commands */
obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4405, obj_t BgL_dbz00_4406, obj_t BgL_backendz00_4407, obj_t BgL_linez00_4408, obj_t BgL_ipz00_4409, obj_t BgL_opz00_4410)
{
{ /* Llib/mpd.scm 825 */
{ /* Llib/mpd.scm 826 */
obj_t BgL_g1203z00_5180;
BgL_g1203z00_5180 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2988z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1201z00_5183;
BgL_l1201z00_5183 = BgL_g1203z00_5180; 
BgL_zc3z04anonymousza32096ze3z87_5182:
if(
PAIRP(BgL_l1201z00_5183))
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 827 */
obj_t BgL_cz00_5184;
BgL_cz00_5184 = 
CAR(BgL_l1201z00_5183); 
{ /* Llib/mpd.scm 827 */
obj_t BgL_tmpz00_7090;
BgL_tmpz00_7090 = 
((obj_t)BgL_opz00_4410); 
bgl_display_string(BGl_string2989z00zz__multimediazd2mpdzd2, BgL_tmpz00_7090); } 
{ /* Llib/mpd.scm 828 */
obj_t BgL_arg2098z00_5185;
BgL_arg2098z00_5185 = 
CAR(
((obj_t)BgL_cz00_5184)); 
bgl_display_obj(BgL_arg2098z00_5185, BgL_opz00_4410); } 
{ /* Llib/mpd.scm 829 */
obj_t BgL_tmpz00_7096;
BgL_tmpz00_7096 = 
((obj_t)BgL_opz00_4410); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7096); } } 
{ 
obj_t BgL_l1201z00_7099;
BgL_l1201z00_7099 = 
CDR(BgL_l1201z00_5183); 
BgL_l1201z00_5183 = BgL_l1201z00_7099; 
goto BgL_zc3z04anonymousza32096ze3z87_5182;} }  else 
{ /* Llib/mpd.scm 830 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2101> */
obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4535, obj_t BgL_c1z00_4536, obj_t BgL_c2z00_4537)
{
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 831 */
bool_t BgL_tmpz00_7102;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2102z00_5186;obj_t BgL_arg2103z00_5187;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2104z00_5188;
BgL_arg2104z00_5188 = 
CAR(
((obj_t)BgL_c1z00_4536)); 
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg1434z00_5189;
BgL_arg1434z00_5189 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2104z00_5188)); 
BgL_arg2102z00_5186 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_5189); } } 
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg2105z00_5190;
BgL_arg2105z00_5190 = 
CAR(
((obj_t)BgL_c2z00_4537)); 
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg1434z00_5191;
BgL_arg1434z00_5191 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2105z00_5190)); 
BgL_arg2103z00_5187 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_5191); } } 
BgL_tmpz00_7102 = 
bigloo_string_lt(BgL_arg2102z00_5186, BgL_arg2103z00_5187); } 
return 
BBOOL(BgL_tmpz00_7102);} } 

}



/* &mpd-notcommands */
obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4411, obj_t BgL_dbz00_4412, obj_t BgL_backendz00_4413, obj_t BgL_linez00_4414, obj_t BgL_ipz00_4415, obj_t BgL_opz00_4416)
{
{ /* Llib/mpd.scm 839 */
{ /* Llib/mpd.scm 840 */
obj_t BgL_g1206z00_5192;
BgL_g1206z00_5192 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2990z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1204z00_5195;
BgL_l1204z00_5195 = BgL_g1206z00_5192; 
BgL_zc3z04anonymousza32106ze3z87_5194:
if(
PAIRP(BgL_l1204z00_5195))
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 841 */
obj_t BgL_cz00_5196;
BgL_cz00_5196 = 
CAR(BgL_l1204z00_5195); 
{ /* Llib/mpd.scm 841 */
obj_t BgL_tmpz00_7119;
BgL_tmpz00_7119 = 
((obj_t)BgL_opz00_4416); 
bgl_display_string(BGl_string2989z00zz__multimediazd2mpdzd2, BgL_tmpz00_7119); } 
{ /* Llib/mpd.scm 842 */
obj_t BgL_arg2108z00_5197;
BgL_arg2108z00_5197 = 
CAR(
((obj_t)BgL_cz00_5196)); 
bgl_display_obj(BgL_arg2108z00_5197, BgL_opz00_4416); } 
{ /* Llib/mpd.scm 843 */
obj_t BgL_tmpz00_7125;
BgL_tmpz00_7125 = 
((obj_t)BgL_opz00_4416); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7125); } } 
{ 
obj_t BgL_l1204z00_7128;
BgL_l1204z00_7128 = 
CDR(BgL_l1204z00_5195); 
BgL_l1204z00_5195 = BgL_l1204z00_7128; 
goto BgL_zc3z04anonymousza32106ze3z87_5194;} }  else 
{ /* Llib/mpd.scm 844 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2111> */
obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4539, obj_t BgL_c1z00_4540, obj_t BgL_c2z00_4541)
{
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 845 */
bool_t BgL_tmpz00_7131;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2112z00_5198;obj_t BgL_arg2113z00_5199;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2114z00_5200;
BgL_arg2114z00_5200 = 
CAR(
((obj_t)BgL_c1z00_4540)); 
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg1434z00_5201;
BgL_arg1434z00_5201 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2114z00_5200)); 
BgL_arg2112z00_5198 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_5201); } } 
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg2115z00_5202;
BgL_arg2115z00_5202 = 
CAR(
((obj_t)BgL_c2z00_4541)); 
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg1434z00_5203;
BgL_arg1434z00_5203 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2115z00_5202)); 
BgL_arg2113z00_5199 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_5203); } } 
BgL_tmpz00_7131 = 
bigloo_string_lt(BgL_arg2112z00_5198, BgL_arg2113z00_5199); } 
return 
BBOOL(BgL_tmpz00_7131);} } 

}



/* &mpd-addid */
obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4417, obj_t BgL_dbz00_4418, obj_t BgL_backendz00_4419, obj_t BgL_linez00_4420, obj_t BgL_ipz00_4421, obj_t BgL_opz00_4422)
{
{ /* Llib/mpd.scm 853 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-crossfade */
obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4423, obj_t BgL_dbz00_4424, obj_t BgL_backendz00_4425, obj_t BgL_linez00_4426, obj_t BgL_ipz00_4427, obj_t BgL_opz00_4428)
{
{ /* Llib/mpd.scm 858 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-move */
obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4429, obj_t BgL_dbz00_4430, obj_t BgL_backendz00_4431, obj_t BgL_linez00_4432, obj_t BgL_ipz00_4433, obj_t BgL_opz00_4434)
{
{ /* Llib/mpd.scm 863 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-moveid */
obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4435, obj_t BgL_dbz00_4436, obj_t BgL_backendz00_4437, obj_t BgL_linez00_4438, obj_t BgL_ipz00_4439, obj_t BgL_opz00_4440)
{
{ /* Llib/mpd.scm 868 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-password */
obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4441, obj_t BgL_dbz00_4442, obj_t BgL_backendz00_4443, obj_t BgL_linez00_4444, obj_t BgL_ipz00_4445, obj_t BgL_opz00_4446)
{
{ /* Llib/mpd.scm 873 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-random */
obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4447, obj_t BgL_dbz00_4448, obj_t BgL_backendz00_4449, obj_t BgL_linez00_4450, obj_t BgL_ipz00_4451, obj_t BgL_opz00_4452)
{
{ /* Llib/mpd.scm 878 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-repeat */
obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4453, obj_t BgL_dbz00_4454, obj_t BgL_backendz00_4455, obj_t BgL_linez00_4456, obj_t BgL_ipz00_4457, obj_t BgL_opz00_4458)
{
{ /* Llib/mpd.scm 883 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-rm */
obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4459, obj_t BgL_dbz00_4460, obj_t BgL_backendz00_4461, obj_t BgL_linez00_4462, obj_t BgL_ipz00_4463, obj_t BgL_opz00_4464)
{
{ /* Llib/mpd.scm 888 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-save */
obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4465, obj_t BgL_dbz00_4466, obj_t BgL_backendz00_4467, obj_t BgL_linez00_4468, obj_t BgL_ipz00_4469, obj_t BgL_opz00_4470)
{
{ /* Llib/mpd.scm 893 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-shuffle */
obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4471, obj_t BgL_dbz00_4472, obj_t BgL_backendz00_4473, obj_t BgL_linez00_4474, obj_t BgL_ipz00_4475, obj_t BgL_opz00_4476)
{
{ /* Llib/mpd.scm 898 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swap */
obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4477, obj_t BgL_dbz00_4478, obj_t BgL_backendz00_4479, obj_t BgL_linez00_4480, obj_t BgL_ipz00_4481, obj_t BgL_opz00_4482)
{
{ /* Llib/mpd.scm 903 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swapid */
obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4483, obj_t BgL_dbz00_4484, obj_t BgL_backendz00_4485, obj_t BgL_linez00_4486, obj_t BgL_ipz00_4487, obj_t BgL_opz00_4488)
{
{ /* Llib/mpd.scm 908 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-update */
obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4489, obj_t BgL_dbz00_4490, obj_t BgL_backendz00_4491, obj_t BgL_linez00_4492, obj_t BgL_ipz00_4493, obj_t BgL_opz00_4494)
{
{ /* Llib/mpd.scm 913 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-outputs */
obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4495, obj_t BgL_dbz00_4496, obj_t BgL_backendz00_4497, obj_t BgL_linez00_4498, obj_t BgL_ipz00_4499, obj_t BgL_opz00_4500)
{
{ /* Llib/mpd.scm 918 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* loop~5 */
obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t BgL_l1z00_1163, obj_t BgL_l2z00_1164)
{
{ /* Llib/mpd.scm 924 */
{ /* Llib/mpd.scm 927 */
bool_t BgL_test3516z00_7158;
if(
NULLP(BgL_l1z00_1163))
{ /* Llib/mpd.scm 927 */
BgL_test3516z00_7158 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 927 */
BgL_test3516z00_7158 = 
NULLP(BgL_l2z00_1164)
; } 
if(BgL_test3516z00_7158)
{ /* Llib/mpd.scm 927 */
return BNIL;}  else 
{ /* Llib/mpd.scm 929 */
bool_t BgL_test3518z00_7162;
{ /* Llib/mpd.scm 929 */
obj_t BgL_arg2126z00_1175;obj_t BgL_arg2127z00_1176;
BgL_arg2126z00_1175 = 
CAR(
((obj_t)BgL_l1z00_1163)); 
BgL_arg2127z00_1176 = 
CAR(
((obj_t)BgL_l2z00_1164)); 
{ /* Llib/mpd.scm 929 */
long BgL_l1z00_3004;
BgL_l1z00_3004 = 
STRING_LENGTH(
((obj_t)BgL_arg2126z00_1175)); 
if(
(BgL_l1z00_3004==
STRING_LENGTH(
((obj_t)BgL_arg2127z00_1176))))
{ /* Llib/mpd.scm 929 */
int BgL_arg1282z00_3007;
{ /* Llib/mpd.scm 929 */
char * BgL_auxz00_7176;char * BgL_tmpz00_7173;
BgL_auxz00_7176 = 
BSTRING_TO_STRING(
((obj_t)BgL_arg2127z00_1176)); 
BgL_tmpz00_7173 = 
BSTRING_TO_STRING(
((obj_t)BgL_arg2126z00_1175)); 
BgL_arg1282z00_3007 = 
memcmp(BgL_tmpz00_7173, BgL_auxz00_7176, BgL_l1z00_3004); } 
BgL_test3518z00_7162 = 
(
(long)(BgL_arg1282z00_3007)==((long)0)); }  else 
{ /* Llib/mpd.scm 929 */
BgL_test3518z00_7162 = ((bool_t)0)
; } } } 
if(BgL_test3518z00_7162)
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2122z00_1171;obj_t BgL_arg2123z00_1172;
BgL_arg2122z00_1171 = 
CAR(
((obj_t)BgL_l1z00_1163)); 
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2124z00_1173;obj_t BgL_arg2125z00_1174;
BgL_arg2124z00_1173 = 
CDR(
((obj_t)BgL_l1z00_1163)); 
BgL_arg2125z00_1174 = 
CDR(
((obj_t)BgL_l2z00_1164)); 
BgL_arg2123z00_1172 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_arg2124z00_1173, BgL_arg2125z00_1174); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2122z00_1171, BgL_arg2123z00_1172);}  else 
{ /* Llib/mpd.scm 929 */
return BNIL;} } } } 

}



/* file-system-root? */
bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_330)
{
{ /* Llib/mpd.scm 949 */
if(
(
STRING_LENGTH(BgL_dirz00_330)==((long)1)))
{ /* Llib/mpd.scm 950 */
return 
(
STRING_REF(BgL_dirz00_330, ((long)0))==
(unsigned char)(FILE_SEPARATOR));}  else 
{ /* Llib/mpd.scm 950 */
return ((bool_t)0);} } 

}



/* directory->sort-list */
obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_332)
{
{ /* Llib/mpd.scm 988 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2991z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_332)));} 

}



/* &<@anonymous:2138> */
obj_t BGl_z62zc3z04anonymousza32138ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4543, obj_t BgL_s1z00_4544, obj_t BgL_s2z00_4545)
{
{ /* Llib/mpd.scm 989 */
{ /* Llib/mpd.scm 990 */
bool_t BgL_tmpz00_7199;
{ /* Llib/mpd.scm 990 */
int BgL_arg2139z00_5204;
{ /* Llib/mpd.scm 990 */

BgL_arg2139z00_5204 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4544, BgL_s2z00_4545, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7199 = 
(
(long)(BgL_arg2139z00_5204)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7199);} } 

}



/* mpd->file */
obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t BgL_filez00_333, obj_t BgL_dbz00_334, obj_t BgL_opz00_335, obj_t BgL_cmdz00_336)
{
{ /* Llib/mpd.scm 996 */
{ /* Llib/mpd.scm 998 */
obj_t BgL_fz00_1216;
{ /* Llib/mpd.scm 998 */
obj_t BgL_g1209z00_1220;
BgL_g1209z00_1220 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_334)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1207z00_1222;
BgL_l1207z00_1222 = BgL_g1209z00_1220; 
BgL_zc3z04anonymousza32141ze3z87_1223:
if(
NULLP(BgL_l1207z00_1222))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1216 = BFALSE; }  else 
{ /* Llib/mpd.scm 999 */
obj_t BgL__ortest_1210z00_1225;
{ /* Llib/mpd.scm 999 */
obj_t BgL_dirz00_1227;
BgL_dirz00_1227 = 
CAR(
((obj_t)BgL_l1207z00_1222)); 
{ /* Llib/mpd.scm 999 */
obj_t BgL_pz00_1228;
BgL_pz00_1228 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1227, BgL_filez00_333); 
if(
fexists(
BSTRING_TO_STRING(BgL_pz00_1228)))
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1210z00_1225 = BgL_pz00_1228; }  else 
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1210z00_1225 = BFALSE; } } } 
if(
CBOOL(BgL__ortest_1210z00_1225))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1216 = BgL__ortest_1210z00_1225; }  else 
{ /* Llib/mpd.scm 998 */
obj_t BgL_arg2143z00_1226;
BgL_arg2143z00_1226 = 
CDR(
((obj_t)BgL_l1207z00_1222)); 
{ 
obj_t BgL_l1207z00_7220;
BgL_l1207z00_7220 = BgL_arg2143z00_1226; 
BgL_l1207z00_1222 = BgL_l1207z00_7220; 
goto BgL_zc3z04anonymousza32141ze3z87_1223;} } } } } 
if(
STRINGP(BgL_fz00_1216))
{ /* Llib/mpd.scm 1003 */
return BgL_fz00_1216;}  else 
{ /* Llib/mpd.scm 1003 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7223;
BgL_tmpz00_7223 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string2939z00zz__multimediazd2mpdzd2, BgL_tmpz00_7223); } 
bgl_display_obj(BGl_string2976z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7227;
BgL_tmpz00_7227 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string2941z00zz__multimediazd2mpdzd2, BgL_tmpz00_7227); } 
bgl_display_obj(BgL_cmdz00_336, BgL_opz00_335); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7231;
BgL_tmpz00_7231 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string2942z00zz__multimediazd2mpdzd2, BgL_tmpz00_7231); } 
bgl_display_obj(BGl_string2992z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7235;
BgL_tmpz00_7235 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string2943z00zz__multimediazd2mpdzd2, BgL_tmpz00_7235); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7238;
BgL_tmpz00_7238 = 
((obj_t)BgL_opz00_335); 
bgl_flush_output_port(BgL_tmpz00_7238); } 
return 
CNST_TABLE_REF(((long)54));} } } 

}



/* file->mpd */
obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t BgL_filez00_337, obj_t BgL_dbz00_338)
{
{ /* Llib/mpd.scm 1010 */
{ /* Llib/mpd.scm 1012 */
long BgL_blenz00_1232;
BgL_blenz00_1232 = 
STRING_LENGTH(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_338)))->BgL_z52basez52)); 
if(
(
STRING_LENGTH(
((obj_t)BgL_filez00_337))>BgL_blenz00_1232))
{ /* Llib/mpd.scm 1014 */
long BgL_arg2147z00_1235;
BgL_arg2147z00_1235 = 
(BgL_blenz00_1232+((long)1)); 
{ /* Llib/mpd.scm 1014 */
long BgL_endz00_1238;
BgL_endz00_1238 = 
STRING_LENGTH(
((obj_t)BgL_filez00_337)); 
{ /* Llib/mpd.scm 1014 */

return 
BGl_substringz00zz__r4_strings_6_7z00(BgL_filez00_337, BgL_arg2147z00_1235, BgL_endz00_1238);} } }  else 
{ /* Llib/mpd.scm 1013 */
return BGl_string2927z00zz__multimediazd2mpdzd2;} } } 

}



/* image-file? */
bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_341)
{
{ /* Llib/mpd.scm 1028 */
{ 
obj_t BgL_l1211z00_1244;
BgL_l1211z00_1244 = 
CNST_TABLE_REF(((long)75)); 
BgL_zc3z04anonymousza32151ze3z87_1245:
if(
NULLP(BgL_l1211z00_1244))
{ /* Llib/mpd.scm 1029 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1029 */
bool_t BgL__ortest_1214z00_1247;
{ /* Llib/mpd.scm 1029 */

BgL__ortest_1214z00_1247 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1211z00_1244)), BgL_fz00_341, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1214z00_1247)
{ /* Llib/mpd.scm 1029 */
return BgL__ortest_1214z00_1247;}  else 
{ 
obj_t BgL_l1211z00_7259;
BgL_l1211z00_7259 = 
CDR(
((obj_t)BgL_l1211z00_1244)); 
BgL_l1211z00_1244 = BgL_l1211z00_7259; 
goto BgL_zc3z04anonymousza32151ze3z87_1245;} } } } 

}



/* directory-image */
obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t BgL_dirz00_342)
{
{ /* Llib/mpd.scm 1034 */
{ /* Llib/mpd.scm 1035 */
obj_t BgL_fz00_1257;
{ /* Llib/mpd.scm 1035 */
obj_t BgL_g1217z00_1259;
BgL_g1217z00_1259 = 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_342)); 
{ 
obj_t BgL_list1216z00_1261;
BgL_list1216z00_1261 = BgL_g1217z00_1259; 
BgL_zc3z04anonymousza32155ze3z87_1262:
if(
PAIRP(BgL_list1216z00_1261))
{ /* Llib/mpd.scm 1035 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1216z00_1261)))
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1257 = 
CAR(BgL_list1216z00_1261); }  else 
{ 
obj_t BgL_list1216z00_7271;
BgL_list1216z00_7271 = 
CDR(BgL_list1216z00_1261); 
BgL_list1216z00_1261 = BgL_list1216z00_7271; 
goto BgL_zc3z04anonymousza32155ze3z87_1262;} }  else 
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1257 = BFALSE; } } } 
if(
STRINGP(BgL_fz00_1257))
{ /* Llib/mpd.scm 1036 */
return 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_342, BgL_fz00_1257);}  else 
{ /* Llib/mpd.scm 1036 */
return BFALSE;} } } 

}



/* music-file? */
bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_343, obj_t BgL_dbz00_344)
{
{ /* Llib/mpd.scm 1042 */
{ 
obj_t BgL_l1218z00_1272;
BgL_l1218z00_1272 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_344)))->BgL_suffixesz00); 
BgL_zc3z04anonymousza32161ze3z87_1273:
if(
NULLP(BgL_l1218z00_1272))
{ /* Llib/mpd.scm 1044 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1044 */
bool_t BgL__ortest_1221z00_1275;
{ /* Llib/mpd.scm 1044 */

BgL__ortest_1221z00_1275 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1218z00_1272)), BgL_fz00_343, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1221z00_1275)
{ /* Llib/mpd.scm 1044 */
return BgL__ortest_1221z00_1275;}  else 
{ 
obj_t BgL_l1218z00_7282;
BgL_l1218z00_7282 = 
CDR(
((obj_t)BgL_l1218z00_1272)); 
BgL_l1218z00_1272 = BgL_l1218z00_7282; 
goto BgL_zc3z04anonymousza32161ze3z87_1273;} } } } 

}



/* mpd-database-directories-scan */
obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_347, obj_t BgL_directoriesz00_348)
{
{ /* Llib/mpd.scm 1055 */
{ /* Llib/mpd.scm 1055 */
struct bgl_cell BgL_box3533_4901z00; 
obj_t BgL_nsongsz00_4901;
BgL_nsongsz00_4901 = 
MAKE_CELL_STACK(
BINT(((long)0)),BgL_box3533_4901z00); 
{ /* Llib/mpd.scm 1057 */
obj_t BgL_artistsz00_1291;
BgL_artistsz00_1291 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1058 */
obj_t BgL_albumsz00_1292;
BgL_albumsz00_1292 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1059 */
obj_t BgL_genresz00_1293;
BgL_genresz00_1293 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ 
obj_t BgL_l1225z00_1296;
BgL_l1225z00_1296 = BgL_directoriesz00_348; 
BgL_zc3z04anonymousza32167ze3z87_1297:
if(
PAIRP(BgL_l1225z00_1296))
{ /* Llib/mpd.scm 1082 */
{ /* Llib/mpd.scm 1082 */
obj_t BgL_dz00_1299;
BgL_dz00_1299 = 
CAR(BgL_l1225z00_1296); 
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_347, BgL_genresz00_1293, BgL_albumsz00_1292, BgL_artistsz00_1291, BgL_nsongsz00_4901, BgL_dz00_1299, BgL_dz00_1299); } 
{ 
obj_t BgL_l1225z00_7295;
BgL_l1225z00_7295 = 
CDR(BgL_l1225z00_1296); 
BgL_l1225z00_1296 = BgL_l1225z00_7295; 
goto BgL_zc3z04anonymousza32167ze3z87_1297;} }  else 
{ /* Llib/mpd.scm 1082 */((bool_t)1); } } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_val0_1227z00_1302;obj_t BgL_val1_1228z00_1303;obj_t BgL_val2_1229z00_1304;long BgL_val3_1230z00_1305;
BgL_val0_1227z00_1302 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2993z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_artistsz00_1291, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val1_1228z00_1303 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2994z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_albumsz00_1292, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val2_1229z00_1304 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2995z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_genresz00_1293, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val3_1230z00_1305 = 
(long)CINT(
CELL_REF(BgL_nsongsz00_4901)); 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7304;
BgL_tmpz00_7304 = 
(int)(((long)4)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7304); } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7307;
BgL_tmpz00_7307 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7307, BgL_val1_1228z00_1303); } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7310;
BgL_tmpz00_7310 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7310, BgL_val2_1229z00_1304); } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_auxz00_7315;int BgL_tmpz00_7313;
BgL_auxz00_7315 = 
BINT(BgL_val3_1230z00_1305); 
BgL_tmpz00_7313 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7313, BgL_auxz00_7315); } 
return BgL_val0_1227z00_1302;} } } } } } 

}



/* directory-scan~0 */
bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_4899, obj_t BgL_genresz00_4898, obj_t BgL_albumsz00_4897, obj_t BgL_artistsz00_4896, obj_t BgL_nsongsz00_4895, obj_t BgL_dirz00_1330, obj_t BgL_repoz00_1331)
{
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1063 */
obj_t BgL_albumz00_1333;
BgL_albumz00_1333 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1330); 
{ /* Llib/mpd.scm 1063 */
obj_t BgL_dir2z00_1334;
BgL_dir2z00_1334 = 
BGl_dirnamez00zz__osz00(BgL_dirz00_1330); 
{ /* Llib/mpd.scm 1064 */
obj_t BgL_artistz00_1335;
BgL_artistz00_1335 = 
BGl_basenamez00zz__osz00(BgL_dir2z00_1334); 
{ /* Llib/mpd.scm 1065 */
obj_t BgL_dir3z00_1336;
BgL_dir3z00_1336 = 
BGl_dirnamez00zz__osz00(BgL_dir2z00_1334); 
{ /* Llib/mpd.scm 1066 */
obj_t BgL_genrez00_1337;
BgL_genrez00_1337 = 
BGl_basenamez00zz__osz00(BgL_dir3z00_1336); 
{ /* Llib/mpd.scm 1067 */
bool_t BgL_addz00_1338;
BgL_addz00_1338 = ((bool_t)0); 
{ /* Llib/mpd.scm 1068 */

{ /* Llib/mpd.scm 1069 */
obj_t BgL_g1224z00_1339;
BgL_g1224z00_1339 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_1330); 
{ 
obj_t BgL_l1222z00_1341;
BgL_l1222z00_1341 = BgL_g1224z00_1339; 
BgL_zc3z04anonymousza32186ze3z87_1342:
if(
PAIRP(BgL_l1222z00_1341))
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1071 */
obj_t BgL_pz00_1344;
BgL_pz00_1344 = 
CAR(BgL_l1222z00_1341); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1344)))
{ /* Llib/mpd.scm 1071 */
BBOOL(
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_4899, BgL_genresz00_4898, BgL_albumsz00_4897, BgL_artistsz00_4896, BgL_nsongsz00_4895, BgL_pz00_1344, BgL_repoz00_1331)); }  else 
{ /* Llib/mpd.scm 1071 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1344, 
((obj_t)BgL_dbz00_4899)))
{ /* Llib/mpd.scm 1073 */
{ /* Llib/mpd.scm 1074 */
obj_t BgL_auxz00_4900;
BgL_auxz00_4900 = 
ADDFX(
CELL_REF(BgL_nsongsz00_4895), 
BINT(((long)1))); 
CELL_SET(BgL_nsongsz00_4895, BgL_auxz00_4900); } 
if(BgL_addz00_1338)
{ /* Llib/mpd.scm 1075 */BFALSE; }  else 
{ /* Llib/mpd.scm 1075 */
BgL_addz00_1338 = ((bool_t)1); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_artistsz00_4896, BgL_artistz00_1335, BgL_dir2z00_1334); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_albumsz00_4897, BgL_albumz00_1333, BgL_dirz00_1330); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_genresz00_4898, BgL_genrez00_1337, BgL_dir3z00_1336); } }  else 
{ /* Llib/mpd.scm 1073 */BFALSE; } } } 
{ 
obj_t BgL_l1222z00_7341;
BgL_l1222z00_7341 = 
CDR(BgL_l1222z00_1341); 
BgL_l1222z00_1341 = BgL_l1222z00_7341; 
goto BgL_zc3z04anonymousza32186ze3z87_1342;} }  else 
{ /* Llib/mpd.scm 1080 */
return ((bool_t)1);} } } } } } } } } } } 

}



/* &<@anonymous:2182> */
obj_t BGl_z62zc3z04anonymousza32182ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4549, obj_t BgL_e1z00_4550, obj_t BgL_e2z00_4551)
{
{ /* Llib/mpd.scm 1088 */
{ /* Llib/mpd.scm 1088 */
bool_t BgL_tmpz00_7343;
{ /* Llib/mpd.scm 1088 */
obj_t BgL_string1z00_5205;obj_t BgL_string2z00_5206;
BgL_string1z00_5205 = 
CAR(
((obj_t)BgL_e1z00_4550)); 
BgL_string2z00_5206 = 
CAR(
((obj_t)BgL_e2z00_4551)); 
BgL_tmpz00_7343 = 
bigloo_string_lt(BgL_string1z00_5205, BgL_string2z00_5206); } 
return 
BBOOL(BgL_tmpz00_7343);} } 

}



/* &<@anonymous:2177> */
obj_t BGl_z62zc3z04anonymousza32177ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4552, obj_t BgL_e1z00_4553, obj_t BgL_e2z00_4554)
{
{ /* Llib/mpd.scm 1086 */
{ /* Llib/mpd.scm 1086 */
bool_t BgL_tmpz00_7350;
{ /* Llib/mpd.scm 1086 */
obj_t BgL_string1z00_5207;obj_t BgL_string2z00_5208;
BgL_string1z00_5207 = 
CAR(
((obj_t)BgL_e1z00_4553)); 
BgL_string2z00_5208 = 
CAR(
((obj_t)BgL_e2z00_4554)); 
BgL_tmpz00_7350 = 
bigloo_string_lt(BgL_string1z00_5207, BgL_string2z00_5208); } 
return 
BBOOL(BgL_tmpz00_7350);} } 

}



/* &<@anonymous:2172> */
obj_t BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4555, obj_t BgL_e1z00_4556, obj_t BgL_e2z00_4557)
{
{ /* Llib/mpd.scm 1084 */
{ /* Llib/mpd.scm 1084 */
bool_t BgL_tmpz00_7357;
{ /* Llib/mpd.scm 1084 */
obj_t BgL_string1z00_5209;obj_t BgL_string2z00_5210;
BgL_string1z00_5209 = 
CAR(
((obj_t)BgL_e1z00_4556)); 
BgL_string2z00_5210 = 
CAR(
((obj_t)BgL_e2z00_4557)); 
BgL_tmpz00_7357 = 
bigloo_string_lt(BgL_string1z00_5209, BgL_string2z00_5210); } 
return 
BBOOL(BgL_tmpz00_7357);} } 

}



/* loop~4 */
bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_4894, BgL_mpdzd2databasezd2_bglt BgL_dbz00_4893, obj_t BgL_albumz00_4892, obj_t BgL_artistz00_4891, obj_t BgL_dirz00_1354)
{
{ /* Llib/mpd.scm 1270 */
{ /* Llib/mpd.scm 1271 */
obj_t BgL_artistz00_1356;
if(
CBOOL(BgL_artistz00_4891))
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1356 = BgL_artistz00_4891; }  else 
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1356 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1354)); } 
{ /* Llib/mpd.scm 1271 */
obj_t BgL_albumz00_1357;
if(
CBOOL(BgL_albumz00_4892))
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1357 = BgL_albumz00_4892; }  else 
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1357 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1354); } 
{ /* Llib/mpd.scm 1272 */
obj_t BgL_filesz00_1358;
BgL_filesz00_1358 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc2996z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1354))); 
{ /* Llib/mpd.scm 1273 */
obj_t BgL_imgz00_1359;
{ /* Llib/mpd.scm 1276 */
obj_t BgL_fz00_1373;
{ 
obj_t BgL_list1272z00_1376;
BgL_list1272z00_1376 = BgL_filesz00_1358; 
BgL_zc3z04anonymousza32201ze3z87_1377:
if(
PAIRP(BgL_list1272z00_1376))
{ /* Llib/mpd.scm 1276 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1272z00_1376)))
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1373 = 
CAR(BgL_list1272z00_1376); }  else 
{ 
obj_t BgL_list1272z00_7380;
BgL_list1272z00_7380 = 
CDR(BgL_list1272z00_1376); 
BgL_list1272z00_1376 = BgL_list1272z00_7380; 
goto BgL_zc3z04anonymousza32201ze3z87_1377;} }  else 
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1373 = BFALSE; } } 
if(
STRINGP(BgL_fz00_1373))
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1359 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1354, BgL_fz00_1373); }  else 
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1359 = BFALSE; } } 
{ /* Llib/mpd.scm 1276 */

{ 
obj_t BgL_l1273z00_1361;
BgL_l1273z00_1361 = BgL_filesz00_1358; 
BgL_zc3z04anonymousza32195ze3z87_1362:
if(
PAIRP(BgL_l1273z00_1361))
{ /* Llib/mpd.scm 1279 */
{ /* Llib/mpd.scm 1280 */
obj_t BgL_fz00_1364;
BgL_fz00_1364 = 
CAR(BgL_l1273z00_1361); 
{ /* Llib/mpd.scm 1280 */
obj_t BgL_pz00_1365;
BgL_pz00_1365 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1354, BgL_fz00_1364); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1365)))
{ /* Llib/mpd.scm 1282 */
BGl_loopze74ze7zz__multimediazd2mpdzd2(BgL_opz00_4894, BgL_dbz00_4893, BgL_albumz00_4892, BgL_artistz00_4891, BgL_pz00_1365); }  else 
{ /* Llib/mpd.scm 1282 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1365, 
((obj_t)BgL_dbz00_4893)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3091;
BgL_g1186z00_3091 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_4893), BgL_pz00_1365, BgL_artistz00_1356, BgL_albumz00_1357, BgL_imgz00_1359); 
{ 
obj_t BgL_l1184z00_3093;
BgL_l1184z00_3093 = BgL_g1186z00_3091; 
BgL_zc3z04anonymousza31984ze3z87_3092:
if(
PAIRP(BgL_l1184z00_3093))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3095;
BgL_kz00_3095 = 
CAR(BgL_l1184z00_3093); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_3096;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_3097;
BgL_arg1987z00_3097 = 
CAR(
((obj_t)BgL_kz00_3095)); 
BgL_arg1986z00_3096 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_3097)); } 
bgl_display_obj(BgL_arg1986z00_3096, BgL_opz00_4894); } 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_opz00_4894); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_3098;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3108;
BgL_pairz00_3108 = 
CDR(
((obj_t)BgL_kz00_3095)); 
BgL_arg1988z00_3098 = 
CAR(BgL_pairz00_3108); } 
bgl_display_obj(BgL_arg1988z00_3098, BgL_opz00_4894); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4894); } 
{ 
obj_t BgL_l1184z00_7412;
BgL_l1184z00_7412 = 
CDR(BgL_l1184z00_3093); 
BgL_l1184z00_3093 = BgL_l1184z00_7412; 
goto BgL_zc3z04anonymousza31984ze3z87_3092;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1284 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1273z00_7414;
BgL_l1273z00_7414 = 
CDR(BgL_l1273z00_1361); 
BgL_l1273z00_1361 = BgL_l1273z00_7414; 
goto BgL_zc3z04anonymousza32195ze3z87_1362;} }  else 
{ /* Llib/mpd.scm 1279 */
return ((bool_t)1);} } } } } } } } 

}



/* &<@anonymous:2209> */
obj_t BGl_z62zc3z04anonymousza32209ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4562, obj_t BgL_s1z00_4563, obj_t BgL_s2z00_4564)
{
{ /* Llib/mpd.scm 1273 */
{ /* Llib/mpd.scm 1274 */
bool_t BgL_tmpz00_7416;
{ /* Llib/mpd.scm 1274 */
int BgL_arg2210z00_5211;
{ /* Llib/mpd.scm 1274 */

BgL_arg2210z00_5211 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4563, BgL_s2z00_4564, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7416 = 
(
(long)(BgL_arg2210z00_5211)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7416);} } 

}



/* getinfofile */
obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_406, obj_t BgL_filez00_407, obj_t BgL_artistz00_408, obj_t BgL_albumz00_409, obj_t BgL_imagez00_410)
{
{ /* Llib/mpd.scm 1444 */
{ 
obj_t BgL_filez00_1488;BgL_musictagz00_bglt BgL_tagz00_1489;obj_t BgL_filez00_1468;obj_t BgL_dtz00_1454;
{ /* Llib/mpd.scm 1477 */
bool_t BgL_test3548z00_7423;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_407)))
{ /* Llib/mpd.scm 1477 */
BgL_test3548z00_7423 = 
bgl_directoryp(
BSTRING_TO_STRING(BgL_filez00_407))
; }  else 
{ /* Llib/mpd.scm 1477 */
BgL_test3548z00_7423 = ((bool_t)1)
; } 
if(BgL_test3548z00_7423)
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2215z00_1421;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2216z00_1422;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2217z00_1423;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string2967z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2217z00_1423 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2217z00_1423 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2216z00_1422 = 
MAKE_YOUNG_PAIR(BgL_arg2217z00_1423, BNIL); } 
BgL_arg2215z00_1421 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)82)), BgL_arg2216z00_1422); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2215z00_1421, BNIL);}  else 
{ /* Llib/mpd.scm 1479 */
obj_t BgL_tagz00_1424;obj_t BgL_infoz00_1425;obj_t BgL_dtz00_1426;obj_t BgL_imgz00_1427;
BgL_tagz00_1424 = 
BGl_filezd2musictagzd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_infoz00_1425 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_dtz00_1426 = 
bgl_seconds_to_date(
bgl_last_modification_time(
BSTRING_TO_STRING(BgL_filez00_407))); 
if(
STRINGP(BgL_imagez00_410))
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1427 = 
BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(
BGl_dirnamez00zz__osz00(BgL_filez00_407)); }  else 
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1427 = BFALSE; } 
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2218z00_1428;obj_t BgL_arg2219z00_1429;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2220z00_1430;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2221z00_1431;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string2967z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2221z00_1431 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2221z00_1431 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2220z00_1430 = 
MAKE_YOUNG_PAIR(BgL_arg2221z00_1431, BNIL); } 
BgL_arg2218z00_1428 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)82)), BgL_arg2220z00_1430); } 
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2222z00_1432;obj_t BgL_arg2223z00_1433;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2224z00_1434;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_tmpz00_7451;
BgL_dtz00_1454 = BgL_dtz00_1426; 
{ /* Llib/mpd.scm 1448 */
int BgL_arg2243z00_1456;int BgL_arg2244z00_1457;int BgL_arg2245z00_1458;int BgL_arg2246z00_1459;int BgL_arg2247z00_1460;int BgL_arg2248z00_1461;
BgL_arg2243z00_1456 = 
BGL_DATE_YEAR(BgL_dtz00_1454); 
BgL_arg2244z00_1457 = 
BGL_DATE_MONTH(BgL_dtz00_1454); 
BgL_arg2245z00_1458 = 
BGL_DATE_DAY(BgL_dtz00_1454); 
BgL_arg2246z00_1459 = 
BGL_DATE_HOUR(BgL_dtz00_1454); 
BgL_arg2247z00_1460 = 
BGL_DATE_MINUTE(BgL_dtz00_1454); 
BgL_arg2248z00_1461 = 
BGL_DATE_SECOND(BgL_dtz00_1454); 
{ /* Llib/mpd.scm 1447 */
obj_t BgL_list2249z00_1462;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2250z00_1463;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2251z00_1464;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2252z00_1465;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2253z00_1466;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2254z00_1467;
BgL_arg2254z00_1467 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2248z00_1461), BNIL); 
BgL_arg2253z00_1466 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2247z00_1460), BgL_arg2254z00_1467); } 
BgL_arg2252z00_1465 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2246z00_1459), BgL_arg2253z00_1466); } 
BgL_arg2251z00_1464 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2245z00_1458), BgL_arg2252z00_1465); } 
BgL_arg2250z00_1463 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2244z00_1457), BgL_arg2251z00_1464); } 
BgL_list2249z00_1462 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2243z00_1456), BgL_arg2250z00_1463); } 
BgL_tmpz00_7451 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2997z00zz__multimediazd2mpdzd2, BgL_list2249z00_1462); } } 
BgL_arg2224z00_1434 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_7451, BNIL); } 
BgL_arg2222z00_1432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)83)), BgL_arg2224z00_1434); } 
{ /* Llib/mpd.scm 1485 */
obj_t BgL_arg2226z00_1436;obj_t BgL_arg2227z00_1437;
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_1425, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2229z00_1440;
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2230z00_1441;
{ /* Llib/mpd.scm 1487 */
long BgL_arg2231z00_1442;
BgL_arg2231z00_1442 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_1425)))->BgL_durationz00); 
BgL_arg2230z00_1441 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2231z00_1442), BNIL); } 
BgL_arg2229z00_1440 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)84)), BgL_arg2230z00_1441); } 
BgL_arg2226z00_1436 = 
MAKE_YOUNG_PAIR(BgL_arg2229z00_1440, BNIL); }  else 
{ /* Llib/mpd.scm 1485 */
BgL_arg2226z00_1436 = BNIL; } 
{ /* Llib/mpd.scm 1489 */
obj_t BgL_arg2232z00_1443;obj_t BgL_arg2233z00_1444;
if(
BGl_isazf3zf3zz__objectz00(BgL_tagz00_1424, BGl_musictagz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1488 = BgL_filez00_407; 
BgL_tagz00_1489 = 
((BgL_musictagz00_bglt)BgL_tagz00_1424); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_dirz00_1492;
BgL_dirz00_1492 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1488); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_atz00_1493;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1462 */
BgL_atz00_1493 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1462 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_artistz00), BGl_string2998z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1493 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1492))); }  else 
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1493 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_artistz00); } } 
{ /* Llib/mpd.scm 1462 */
obj_t BgL_alz00_1494;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1466 */
BgL_alz00_1494 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1466 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_albumz00), BGl_string2999z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1494 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1492)); }  else 
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1494 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_albumz00); } } 
{ /* Llib/mpd.scm 1466 */

{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2272z00_1495;obj_t BgL_arg2273z00_1496;
{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2274z00_1497;
BgL_arg2274z00_1497 = 
MAKE_YOUNG_PAIR(BgL_atz00_1493, BNIL); 
BgL_arg2272z00_1495 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2274z00_1497); } 
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2275z00_1498;obj_t BgL_arg2276z00_1499;
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2277z00_1500;
BgL_arg2277z00_1500 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_titlez00), BNIL); 
BgL_arg2275z00_1498 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)77)), BgL_arg2277z00_1500); } 
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2279z00_1502;obj_t BgL_arg2280z00_1503;
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2281z00_1504;
BgL_arg2281z00_1504 = 
MAKE_YOUNG_PAIR(BgL_alz00_1494, BNIL); 
BgL_arg2279z00_1502 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)78)), BgL_arg2281z00_1504); } 
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2282z00_1505;obj_t BgL_arg2283z00_1506;
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2284z00_1507;
{ /* Llib/mpd.scm 1473 */
int BgL_arg2285z00_1508;
BgL_arg2285z00_1508 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_trackz00); 
BgL_arg2284z00_1507 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2285z00_1508), BNIL); } 
BgL_arg2282z00_1505 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)79)), BgL_arg2284z00_1507); } 
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2286z00_1509;obj_t BgL_arg2287z00_1510;
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2288z00_1511;
{ /* Llib/mpd.scm 1474 */
int BgL_arg2289z00_1512;
BgL_arg2289z00_1512 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_yearz00); 
BgL_arg2288z00_1511 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2289z00_1512), BNIL); } 
BgL_arg2286z00_1509 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)80)), BgL_arg2288z00_1511); } 
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2290z00_1513;
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2291z00_1514;
BgL_arg2291z00_1514 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1489))->BgL_genrez00), BNIL); 
BgL_arg2290z00_1513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)81)), BgL_arg2291z00_1514); } 
BgL_arg2287z00_1510 = 
MAKE_YOUNG_PAIR(BgL_arg2290z00_1513, BNIL); } 
BgL_arg2283z00_1506 = 
MAKE_YOUNG_PAIR(BgL_arg2286z00_1509, BgL_arg2287z00_1510); } 
BgL_arg2280z00_1503 = 
MAKE_YOUNG_PAIR(BgL_arg2282z00_1505, BgL_arg2283z00_1506); } 
BgL_arg2276z00_1499 = 
MAKE_YOUNG_PAIR(BgL_arg2279z00_1502, BgL_arg2280z00_1503); } 
BgL_arg2273z00_1496 = 
MAKE_YOUNG_PAIR(BgL_arg2275z00_1498, BgL_arg2276z00_1499); } 
BgL_arg2232z00_1443 = 
MAKE_YOUNG_PAIR(BgL_arg2272z00_1495, BgL_arg2273z00_1496); } } } } } }  else 
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1468 = BgL_filez00_407; 
{ /* Llib/mpd.scm 1452 */
obj_t BgL_dirz00_1470;
BgL_dirz00_1470 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1468); 
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2256z00_1471;obj_t BgL_arg2257z00_1472;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2258z00_1473;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2259z00_1474;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1453 */
BgL_arg2259z00_1474 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1453 */
BgL_arg2259z00_1474 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1470))); } 
BgL_arg2258z00_1473 = 
MAKE_YOUNG_PAIR(BgL_arg2259z00_1474, BNIL); } 
BgL_arg2256z00_1471 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2258z00_1473); } 
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2262z00_1478;obj_t BgL_arg2263z00_1479;
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2264z00_1480;
BgL_arg2264z00_1480 = 
MAKE_YOUNG_PAIR(
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_filez00_1468)), BNIL); 
BgL_arg2262z00_1478 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)77)), BgL_arg2264z00_1480); } 
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2267z00_1483;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2268z00_1484;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2269z00_1485;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1455 */
BgL_arg2269z00_1485 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1455 */
BgL_arg2269z00_1485 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1470)); } 
BgL_arg2268z00_1484 = 
MAKE_YOUNG_PAIR(BgL_arg2269z00_1485, BNIL); } 
BgL_arg2267z00_1483 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)78)), BgL_arg2268z00_1484); } 
BgL_arg2263z00_1479 = 
MAKE_YOUNG_PAIR(BgL_arg2267z00_1483, BNIL); } 
BgL_arg2257z00_1472 = 
MAKE_YOUNG_PAIR(BgL_arg2262z00_1478, BgL_arg2263z00_1479); } 
BgL_arg2232z00_1443 = 
MAKE_YOUNG_PAIR(BgL_arg2256z00_1471, BgL_arg2257z00_1472); } } } 
{ /* Llib/mpd.scm 1492 */
obj_t BgL_arg2235z00_1446;
if(
STRINGP(BgL_imgz00_1427))
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2237z00_1448;
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2238z00_1449;
BgL_arg2238z00_1449 = 
MAKE_YOUNG_PAIR(BgL_imgz00_1427, BNIL); 
BgL_arg2237z00_1448 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)85)), BgL_arg2238z00_1449); } 
BgL_arg2235z00_1446 = 
MAKE_YOUNG_PAIR(BgL_arg2237z00_1448, BNIL); }  else 
{ /* Llib/mpd.scm 1492 */
BgL_arg2235z00_1446 = BNIL; } 
BgL_arg2233z00_1444 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2235z00_1446, BNIL); } 
BgL_arg2227z00_1437 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2232z00_1443, BgL_arg2233z00_1444); } 
BgL_arg2223z00_1433 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2226z00_1436, BgL_arg2227z00_1437); } 
BgL_arg2219z00_1429 = 
MAKE_YOUNG_PAIR(BgL_arg2222z00_1432, BgL_arg2223z00_1433); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2218z00_1428, BgL_arg2219z00_1429);} } } } } 

}



/* loop~3 */
obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_4890, obj_t BgL_albumz00_4889, bool_t BgL_artistz00_4888, obj_t BgL_dirz00_1531)
{
{ /* Llib/mpd.scm 1500 */
{ /* Llib/mpd.scm 1501 */
obj_t BgL_artistz00_1533;obj_t BgL_albumz00_1534;
if(BgL_artistz00_4888)
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1533 = 
BBOOL(BgL_artistz00_4888); }  else 
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1533 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1531)); } 
if(
CBOOL(BgL_albumz00_4889))
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1534 = BgL_albumz00_4889; }  else 
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1534 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1531); } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_l1314z00_1535;
BgL_l1314z00_1535 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3000z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1531))); 
if(
NULLP(BgL_l1314z00_1535))
{ /* Llib/mpd.scm 1503 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_head1316z00_1537;
BgL_head1316z00_1537 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1314z00_1539;obj_t BgL_tail1317z00_1540;
BgL_l1314z00_1539 = BgL_l1314z00_1535; 
BgL_tail1317z00_1540 = BgL_head1316z00_1537; 
BgL_zc3z04anonymousza32304ze3z87_1541:
if(
NULLP(BgL_l1314z00_1539))
{ /* Llib/mpd.scm 1503 */
return 
CDR(BgL_head1316z00_1537);}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_newtail1318z00_1543;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2307z00_1545;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_fz00_1546;
BgL_fz00_1546 = 
CAR(
((obj_t)BgL_l1314z00_1539)); 
{ /* Llib/mpd.scm 1504 */
obj_t BgL_pz00_1547;
BgL_pz00_1547 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1531, BgL_fz00_1546); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1547)))
{ /* Llib/mpd.scm 1506 */
BgL_arg2307z00_1545 = 
BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_dbz00_4890, BgL_albumz00_4889, BgL_artistz00_4888, BgL_pz00_1547); }  else 
{ /* Llib/mpd.scm 1506 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1547, 
((obj_t)BgL_dbz00_4890)))
{ /* Llib/mpd.scm 1509 */

BgL_arg2307z00_1545 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_4890), BgL_pz00_1547, BgL_artistz00_1533, BgL_albumz00_1534, BFALSE); }  else 
{ /* Llib/mpd.scm 1508 */
BgL_arg2307z00_1545 = BFALSE; } } } } 
BgL_newtail1318z00_1543 = 
MAKE_YOUNG_PAIR(BgL_arg2307z00_1545, BNIL); } 
SET_CDR(BgL_tail1317z00_1540, BgL_newtail1318z00_1543); 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2306z00_1544;
BgL_arg2306z00_1544 = 
CDR(
((obj_t)BgL_l1314z00_1539)); 
{ 
obj_t BgL_tail1317z00_7602;obj_t BgL_l1314z00_7601;
BgL_l1314z00_7601 = BgL_arg2306z00_1544; 
BgL_tail1317z00_7602 = BgL_newtail1318z00_1543; 
BgL_tail1317z00_1540 = BgL_tail1317z00_7602; 
BgL_l1314z00_1539 = BgL_l1314z00_7601; 
goto BgL_zc3z04anonymousza32304ze3z87_1541;} } } } } } } } 

}



/* &<@anonymous:2312> */
obj_t BGl_z62zc3z04anonymousza32312ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4566, obj_t BgL_s1z00_4567, obj_t BgL_s2z00_4568)
{
{ /* Llib/mpd.scm 1510 */
{ /* Llib/mpd.scm 1511 */
bool_t BgL_tmpz00_7603;
{ /* Llib/mpd.scm 1511 */
int BgL_arg2313z00_5212;
{ /* Llib/mpd.scm 1511 */

BgL_arg2313z00_5212 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4567, BgL_s2z00_4568, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7603 = 
(
(long)(BgL_arg2313z00_5212)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7603);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2318z00_1574;obj_t BgL_arg2319z00_1575;
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1319z00_1597;
BgL_v1319z00_1597 = 
create_vector(((long)11)); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2326z00_1598;
BgL_arg2326z00_1598 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)86)), BGl_proc3003z00zz__multimediazd2mpdzd2, BGl_proc3002z00zz__multimediazd2mpdzd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3001z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1319z00_1597,((long)0),BgL_arg2326z00_1598); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2333z00_1611;
BgL_arg2333z00_1611 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)88)), BGl_proc3006z00zz__multimediazd2mpdzd2, BGl_proc3005z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3004z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1319z00_1597,((long)1),BgL_arg2333z00_1611); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2340z00_1624;
BgL_arg2340z00_1624 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)89)), BGl_proc3009z00zz__multimediazd2mpdzd2, BGl_proc3008z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3007z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)90))); 
VECTOR_SET(BgL_v1319z00_1597,((long)2),BgL_arg2340z00_1624); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2347z00_1637;
BgL_arg2347z00_1637 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)91)), BGl_proc3012z00zz__multimediazd2mpdzd2, BGl_proc3011z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3010z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1319z00_1597,((long)3),BgL_arg2347z00_1637); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2354z00_1650;
BgL_arg2354z00_1650 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)92)), BGl_proc3015z00zz__multimediazd2mpdzd2, BGl_proc3014z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3013z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1319z00_1597,((long)4),BgL_arg2354z00_1650); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2361z00_1663;
BgL_arg2361z00_1663 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)93)), BGl_proc3018z00zz__multimediazd2mpdzd2, BGl_proc3017z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3016z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1319z00_1597,((long)5),BgL_arg2361z00_1663); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2368z00_1676;
BgL_arg2368z00_1676 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)94)), BGl_proc3021z00zz__multimediazd2mpdzd2, BGl_proc3020z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3019z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1319z00_1597,((long)6),BgL_arg2368z00_1676); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2375z00_1689;
BgL_arg2375z00_1689 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)96)), BGl_proc3024z00zz__multimediazd2mpdzd2, BGl_proc3023z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3022z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)97))); 
VECTOR_SET(BgL_v1319z00_1597,((long)7),BgL_arg2375z00_1689); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2382z00_1702;
BgL_arg2382z00_1702 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)98)), BGl_proc3027z00zz__multimediazd2mpdzd2, BGl_proc3026z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3025z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)97))); 
VECTOR_SET(BgL_v1319z00_1597,((long)8),BgL_arg2382z00_1702); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2389z00_1715;
BgL_arg2389z00_1715 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)99)), BGl_proc3030z00zz__multimediazd2mpdzd2, BGl_proc3029z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3028z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1319z00_1597,((long)9),BgL_arg2389z00_1715); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2396z00_1728;
BgL_arg2396z00_1728 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)100)), BGl_proc3033z00zz__multimediazd2mpdzd2, BGl_proc3032z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3031z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1319z00_1597,((long)10),BgL_arg2396z00_1728); } 
BgL_arg2318z00_1574 = BgL_v1319z00_1597; } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1320z00_1741;
BgL_v1320z00_1741 = 
create_vector(((long)0)); 
BgL_arg2319z00_1575 = BgL_v1320z00_1741; } 
return ( 
BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)101)), 
CNST_TABLE_REF(((long)102)), BGl_objectz00zz__objectz00, ((long)35653), BGl_proc3036z00zz__multimediazd2mpdzd2, BGl_proc3035z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3034z00zz__multimediazd2mpdzd2, BFALSE, BgL_arg2318z00_1574, BgL_arg2319z00_1575), BUNSPEC) ;} } 

}



/* &<@anonymous:2325> */
obj_t BGl_z62zc3z04anonymousza32325ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4605, obj_t BgL_new1066z00_4606)
{
{ /* Llib/mpd.scm 20 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_7659;
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_directoriesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_suffixesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52basez52)=((obj_t)BGl_string2927z00zz__multimediazd2mpdzd2),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52artistsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52albumsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52genresz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52nartistsz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52nalbumsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52nsongsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52uptimez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606)))->BgL_z52dbzd2updatez80)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_7659 = 
((BgL_mpdzd2databasezd2_bglt)BgL_new1066z00_4606); 
return 
((obj_t)BgL_auxz00_7659);} } 

}



/* &lambda2323 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2323z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4607)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1065z00_5214;
BgL_new1065z00_5214 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2324z00_5215;
BgL_arg2324z00_5215 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_5214), BgL_arg2324z00_5215); } 
return BgL_new1065z00_5214;} } 

}



/* &lambda2320 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2320z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4608, obj_t BgL_directories1054z00_4609, obj_t BgL_suffixes1055z00_4610, obj_t BgL_z52base1056z52_4611, obj_t BgL_z52artists1057z52_4612, obj_t BgL_z52albums1058z52_4613, obj_t BgL_z52genres1059z52_4614, obj_t BgL_z52nartists1060z52_4615, obj_t BgL_z52nalbums1061z52_4616, obj_t BgL_z52nsongs1062z52_4617, obj_t BgL_z52uptime1063z52_4618, obj_t BgL_z52dbzd2update1064z80_4619)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_z52nalbums1061z52_5222;int BgL_z52nsongs1062z52_5223;
BgL_z52nalbums1061z52_5222 = 
CINT(BgL_z52nalbums1061z52_4616); 
BgL_z52nsongs1062z52_5223 = 
CINT(BgL_z52nsongs1062z52_4617); 
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1174z00_5224;
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1173z00_5225;
BgL_new1173z00_5225 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2322z00_5226;
BgL_arg2322z00_5226 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_5225), BgL_arg2322z00_5226); } 
BgL_new1174z00_5224 = BgL_new1173z00_5225; } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_directories1054z00_4609)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_suffixes1055z00_4610)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_z52base1056z52_4611)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_z52artists1057z52_4612)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_z52albums1058z52_4613)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_z52genres1059z52_4614)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52nartistsz52)=((obj_t)BgL_z52nartists1060z52_4615),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52nalbumsz52)=((int)BgL_z52nalbums1061z52_5222),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52nsongsz52)=((int)BgL_z52nsongs1062z52_5223),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52uptimez52)=((obj_t)BgL_z52uptime1063z52_4618),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5224))->BgL_z52dbzd2updatez80)=((obj_t)BgL_z52dbzd2update1064z80_4619),BUNSPEC); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_fun2321z00_5227;
BgL_fun2321z00_5227 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
PROCEDURE_ENTRY(BgL_fun2321z00_5227)(BgL_fun2321z00_5227, 
((obj_t)BgL_new1174z00_5224), BEOA); } 
return BgL_new1174z00_5224;} } } 

}



/* &<@anonymous:2402> */
obj_t BGl_z62zc3z04anonymousza32402ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4620)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2401 */
obj_t BGl_z62lambda2401z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4621, obj_t BgL_oz00_4622, obj_t BgL_vz00_4623)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4622)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_vz00_4623),BUNSPEC);} 

}



/* &lambda2400 */
obj_t BGl_z62lambda2400z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4624, obj_t BgL_oz00_4625)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4625)))->BgL_z52dbzd2updatez80);} 

}



/* &<@anonymous:2395> */
obj_t BGl_z62zc3z04anonymousza32395ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4626)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2394 */
obj_t BGl_z62lambda2394z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4627, obj_t BgL_oz00_4628, obj_t BgL_vz00_4629)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4628)))->BgL_z52uptimez52)=((obj_t)BgL_vz00_4629),BUNSPEC);} 

}



/* &lambda2393 */
obj_t BGl_z62lambda2393z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4630, obj_t BgL_oz00_4631)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4631)))->BgL_z52uptimez52);} 

}



/* &<@anonymous:2388> */
obj_t BGl_z62zc3z04anonymousza32388ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4632)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2387 */
obj_t BGl_z62lambda2387z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4633, obj_t BgL_oz00_4634, obj_t BgL_vz00_4635)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5233;
BgL_vz00_5233 = 
CINT(BgL_vz00_4635); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4634)))->BgL_z52nsongsz52)=((int)BgL_vz00_5233),BUNSPEC);} } 

}



/* &lambda2386 */
obj_t BGl_z62lambda2386z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4636, obj_t BgL_oz00_4637)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4637)))->BgL_z52nsongsz52));} 

}



/* &<@anonymous:2381> */
obj_t BGl_z62zc3z04anonymousza32381ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4638)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2380 */
obj_t BGl_z62lambda2380z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4639, obj_t BgL_oz00_4640, obj_t BgL_vz00_4641)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5236;
BgL_vz00_5236 = 
CINT(BgL_vz00_4641); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4640)))->BgL_z52nalbumsz52)=((int)BgL_vz00_5236),BUNSPEC);} } 

}



/* &lambda2379 */
obj_t BGl_z62lambda2379z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4642, obj_t BgL_oz00_4643)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4643)))->BgL_z52nalbumsz52));} 

}



/* &<@anonymous:2374> */
obj_t BGl_z62zc3z04anonymousza32374ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4644)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2373 */
obj_t BGl_z62lambda2373z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4645, obj_t BgL_oz00_4646, obj_t BgL_vz00_4647)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4646)))->BgL_z52nartistsz52)=((obj_t)BgL_vz00_4647),BUNSPEC);} 

}



/* &lambda2372 */
obj_t BGl_z62lambda2372z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4648, obj_t BgL_oz00_4649)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4649)))->BgL_z52nartistsz52);} 

}



/* &<@anonymous:2367> */
obj_t BGl_z62zc3z04anonymousza32367ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4650)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2366 */
obj_t BGl_z62lambda2366z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4651, obj_t BgL_oz00_4652, obj_t BgL_vz00_4653)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4652)))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_vz00_4653)),BUNSPEC);} 

}



/* &lambda2365 */
obj_t BGl_z62lambda2365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4654, obj_t BgL_oz00_4655)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4655)))->BgL_z52genresz52);} 

}



/* &<@anonymous:2360> */
obj_t BGl_z62zc3z04anonymousza32360ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4656)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2359 */
obj_t BGl_z62lambda2359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4657, obj_t BgL_oz00_4658, obj_t BgL_vz00_4659)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4658)))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_vz00_4659)),BUNSPEC);} 

}



/* &lambda2358 */
obj_t BGl_z62lambda2358z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4660, obj_t BgL_oz00_4661)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4661)))->BgL_z52albumsz52);} 

}



/* &<@anonymous:2353> */
obj_t BGl_z62zc3z04anonymousza32353ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4662)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2352 */
obj_t BGl_z62lambda2352z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4663, obj_t BgL_oz00_4664, obj_t BgL_vz00_4665)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4664)))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_vz00_4665)),BUNSPEC);} 

}



/* &lambda2351 */
obj_t BGl_z62lambda2351z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4666, obj_t BgL_oz00_4667)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4667)))->BgL_z52artistsz52);} 

}



/* &<@anonymous:2346> */
obj_t BGl_z62zc3z04anonymousza32346ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4668)
{
{ /* Llib/mpd.scm 20 */
return BGl_string2933z00zz__multimediazd2mpdzd2;} 

}



/* &lambda2345 */
obj_t BGl_z62lambda2345z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4669, obj_t BgL_oz00_4670, obj_t BgL_vz00_4671)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4670)))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_vz00_4671)),BUNSPEC);} 

}



/* &lambda2344 */
obj_t BGl_z62lambda2344z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4672, obj_t BgL_oz00_4673)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4673)))->BgL_z52basez52);} 

}



/* &<@anonymous:2339> */
obj_t BGl_z62zc3z04anonymousza32339ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4674)
{
{ /* Llib/mpd.scm 20 */
return 
CNST_TABLE_REF(((long)103));} 

}



/* &lambda2338 */
obj_t BGl_z62lambda2338z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4675, obj_t BgL_oz00_4676, obj_t BgL_vz00_4677)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4676)))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_vz00_4677)),BUNSPEC);} 

}



/* &lambda2337 */
obj_t BGl_z62lambda2337z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4678, obj_t BgL_oz00_4679)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4679)))->BgL_suffixesz00);} 

}



/* &<@anonymous:2332> */
obj_t BGl_z62zc3z04anonymousza32332ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4680)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2331 */
obj_t BGl_z62lambda2331z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4681, obj_t BgL_oz00_4682, obj_t BgL_vz00_4683)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4682)))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_vz00_4683)),BUNSPEC);} 

}



/* &lambda2330 */
obj_t BGl_z62lambda2330z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4684, obj_t BgL_oz00_4685)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4685)))->BgL_directoriesz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3037z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3038z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BGl_proc3039z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3040z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BGl_proc3041z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3042z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3043z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3044z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3045z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3046z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3047z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3048z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3049z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3050z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3051z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3052z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3053z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3054z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3055z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3056z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BGl_proc3057z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3058z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3059z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3060z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BGl_proc3061z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3062z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3063z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3064z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3065z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3066z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BGl_proc3067z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3068z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BGl_proc3069z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3070z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3071z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3072z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3073z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3074z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3075z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3076z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3077z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3078z00zz__multimediazd2mpdzd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3079z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3080z00zz__multimediazd2mpdzd2);} 

}



/* &mpd-database-get-alb1395 */
obj_t BGl_z62mpdzd2databasezd2getzd2alb1395zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4712, obj_t BgL_oz00_4713, obj_t BgL_albumz00_4714)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1519 */
obj_t BgL_cz00_5262;
BgL_cz00_5262 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_4714, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4713)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5262))
{ /* Llib/mpd.scm 1521 */
obj_t BgL_dirz00_5264;
BgL_dirz00_5264 = 
CDR(BgL_cz00_5262); 
return 
BGl_loopze73ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4713), BgL_albumz00_4714, ((bool_t)0), BgL_dirz00_5264);}  else 
{ /* Llib/mpd.scm 1520 */
return BFALSE;} } } 

}



/* &mpd-database-getarti1389 */
obj_t BGl_z62mpdzd2databasezd2getarti1389z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4715, obj_t BgL_oz00_4716, obj_t BgL_artistz00_4717)
{
{ /* Llib/mpd.scm 1431 */
if(
STRINGP(BgL_artistz00_4717))
{ /* Llib/mpd.scm 1434 */
obj_t BgL_arg2656z00_5267;
BgL_arg2656z00_5267 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4716)))->BgL_z52albumsz52); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_zc3z04anonymousza32658ze3z87_5268;
BgL_zc3z04anonymousza32658ze3z87_5268 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32658ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32658ze3z87_5268, 
(int)(((long)0)), BgL_artistz00_4717); 
{ /* Llib/mpd.scm 1434 */
obj_t BgL_list2657z00_5269;
BgL_list2657z00_5269 = 
MAKE_YOUNG_PAIR(BgL_arg2656z00_5267, BNIL); 
return 
BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(BgL_zc3z04anonymousza32658ze3z87_5268, BgL_list2657z00_5269);} } }  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_l1308z00_5270;
BgL_l1308z00_5270 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4716)))->BgL_z52albumsz52); 
if(
NULLP(BgL_l1308z00_5270))
{ /* Llib/mpd.scm 1439 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_head1310z00_5271;
BgL_head1310z00_5271 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1308z00_5273;obj_t BgL_tail1311z00_5274;
BgL_l1308z00_5273 = BgL_l1308z00_5270; 
BgL_tail1311z00_5274 = BgL_head1310z00_5271; 
BgL_zc3z04anonymousza32667ze3z87_5272:
if(
NULLP(BgL_l1308z00_5273))
{ /* Llib/mpd.scm 1439 */
return 
CDR(BgL_head1310z00_5271);}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_newtail1312z00_5275;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2670z00_5276;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_az00_5277;
BgL_az00_5277 = 
CAR(
((obj_t)BgL_l1308z00_5273)); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2671z00_5278;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2672z00_5279;
BgL_arg2672z00_5279 = 
CAR(
((obj_t)BgL_az00_5277)); 
BgL_arg2671z00_5278 = 
MAKE_YOUNG_PAIR(BgL_arg2672z00_5279, BNIL); } 
BgL_arg2670z00_5276 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)66)), BgL_arg2671z00_5278); } } 
BgL_newtail1312z00_5275 = 
MAKE_YOUNG_PAIR(BgL_arg2670z00_5276, BNIL); } 
SET_CDR(BgL_tail1311z00_5274, BgL_newtail1312z00_5275); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2669z00_5280;
BgL_arg2669z00_5280 = 
CDR(
((obj_t)BgL_l1308z00_5273)); 
{ 
obj_t BgL_tail1311z00_7838;obj_t BgL_l1308z00_7837;
BgL_l1308z00_7837 = BgL_arg2669z00_5280; 
BgL_tail1311z00_7838 = BgL_newtail1312z00_5275; 
BgL_tail1311z00_5274 = BgL_tail1311z00_7838; 
BgL_l1308z00_5273 = BgL_l1308z00_7837; 
goto BgL_zc3z04anonymousza32667ze3z87_5272;} } } } } } } 

}



/* &<@anonymous:2658> */
obj_t BGl_z62zc3z04anonymousza32658ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4718, obj_t BgL_cz00_4720)
{
{ /* Llib/mpd.scm 1434 */
{ /* Llib/mpd.scm 1435 */
obj_t BgL_artistz00_4719;
BgL_artistz00_4719 = 
PROCEDURE_REF(BgL_envz00_4718, 
(int)(((long)0))); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_dirz00_5281;
BgL_dirz00_5281 = 
CDR(
((obj_t)BgL_cz00_4720)); 
{ /* Llib/mpd.scm 1436 */
bool_t BgL_test3572z00_7843;
{ /* Llib/mpd.scm 1436 */
obj_t BgL_arg2664z00_5282;
BgL_arg2664z00_5282 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5281)); 
{ /* Llib/mpd.scm 1436 */
long BgL_l1z00_5283;
BgL_l1z00_5283 = 
STRING_LENGTH(BgL_arg2664z00_5282); 
if(
(BgL_l1z00_5283==
STRING_LENGTH(
((obj_t)BgL_artistz00_4719))))
{ /* Llib/mpd.scm 1436 */
int BgL_arg1282z00_5284;
{ /* Llib/mpd.scm 1436 */
char * BgL_auxz00_7853;char * BgL_tmpz00_7851;
BgL_auxz00_7853 = 
BSTRING_TO_STRING(
((obj_t)BgL_artistz00_4719)); 
BgL_tmpz00_7851 = 
BSTRING_TO_STRING(BgL_arg2664z00_5282); 
BgL_arg1282z00_5284 = 
memcmp(BgL_tmpz00_7851, BgL_auxz00_7853, BgL_l1z00_5283); } 
BgL_test3572z00_7843 = 
(
(long)(BgL_arg1282z00_5284)==((long)0)); }  else 
{ /* Llib/mpd.scm 1436 */
BgL_test3572z00_7843 = ((bool_t)0)
; } } } 
if(BgL_test3572z00_7843)
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2662z00_5285;
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2663z00_5286;
BgL_arg2663z00_5286 = 
CAR(
((obj_t)BgL_cz00_4720)); 
BgL_arg2662z00_5285 = 
MAKE_YOUNG_PAIR(BgL_arg2663z00_5286, BNIL); } 
return 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)66)), BgL_arg2662z00_5285);}  else 
{ /* Llib/mpd.scm 1436 */
return BFALSE;} } } } } 

}



/* &mpd-database-getgenr1387 */
obj_t BGl_z62mpdzd2databasezd2getgenr1387z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4721, obj_t BgL_oz00_4722, obj_t BgL_genrez00_4723)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1423 */
obj_t BgL_hook1306z00_5288;
BgL_hook1306z00_5288 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_g1307z00_5289;
BgL_g1307z00_5289 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4722)))->BgL_z52artistsz52); 
{ 
obj_t BgL_l1303z00_5291;obj_t BgL_h1304z00_5292;
BgL_l1303z00_5291 = BgL_g1307z00_5289; 
BgL_h1304z00_5292 = BgL_hook1306z00_5288; 
BgL_zc3z04anonymousza32643ze3z87_5290:
if(
NULLP(BgL_l1303z00_5291))
{ /* Llib/mpd.scm 1423 */
return 
CDR(BgL_hook1306z00_5288);}  else 
{ /* Llib/mpd.scm 1423 */
bool_t BgL_test3575z00_7870;
{ /* Llib/mpd.scm 1424 */
obj_t BgL_cz00_5293;
BgL_cz00_5293 = 
CAR(
((obj_t)BgL_l1303z00_5291)); 
{ /* Llib/mpd.scm 1424 */
obj_t BgL_dirz00_5294;
BgL_dirz00_5294 = 
CDR(
((obj_t)BgL_cz00_5293)); 
{ /* Llib/mpd.scm 1425 */
obj_t BgL_arg2651z00_5295;
BgL_arg2651z00_5295 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5294)); 
{ /* Llib/mpd.scm 1425 */
long BgL_l1z00_5296;
BgL_l1z00_5296 = 
STRING_LENGTH(BgL_arg2651z00_5295); 
if(
(BgL_l1z00_5296==
STRING_LENGTH(
((obj_t)BgL_genrez00_4723))))
{ /* Llib/mpd.scm 1425 */
int BgL_arg1282z00_5297;
{ /* Llib/mpd.scm 1425 */
char * BgL_auxz00_7884;char * BgL_tmpz00_7882;
BgL_auxz00_7884 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_4723)); 
BgL_tmpz00_7882 = 
BSTRING_TO_STRING(BgL_arg2651z00_5295); 
BgL_arg1282z00_5297 = 
memcmp(BgL_tmpz00_7882, BgL_auxz00_7884, BgL_l1z00_5296); } 
BgL_test3575z00_7870 = 
(
(long)(BgL_arg1282z00_5297)==((long)0)); }  else 
{ /* Llib/mpd.scm 1425 */
BgL_test3575z00_7870 = ((bool_t)0)
; } } } } } 
if(BgL_test3575z00_7870)
{ /* Llib/mpd.scm 1423 */
obj_t BgL_nh1305z00_5298;
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2649z00_5299;
BgL_arg2649z00_5299 = 
CAR(
((obj_t)BgL_l1303z00_5291)); 
BgL_nh1305z00_5298 = 
MAKE_YOUNG_PAIR(BgL_arg2649z00_5299, BNIL); } 
SET_CDR(BgL_h1304z00_5292, BgL_nh1305z00_5298); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2648z00_5300;
BgL_arg2648z00_5300 = 
CDR(
((obj_t)BgL_l1303z00_5291)); 
{ 
obj_t BgL_h1304z00_7897;obj_t BgL_l1303z00_7896;
BgL_l1303z00_7896 = BgL_arg2648z00_5300; 
BgL_h1304z00_7897 = BgL_nh1305z00_5298; 
BgL_h1304z00_5292 = BgL_h1304z00_7897; 
BgL_l1303z00_5291 = BgL_l1303z00_7896; 
goto BgL_zc3z04anonymousza32643ze3z87_5290;} } }  else 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2650z00_5301;
BgL_arg2650z00_5301 = 
CDR(
((obj_t)BgL_l1303z00_5291)); 
{ 
obj_t BgL_l1303z00_7900;
BgL_l1303z00_7900 = BgL_arg2650z00_5301; 
BgL_l1303z00_5291 = BgL_l1303z00_7900; 
goto BgL_zc3z04anonymousza32643ze3z87_5290;} } } } } } } 

}



/* &mpd-database-getarti1385 */
obj_t BGl_z62mpdzd2databasezd2getarti1385z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4724, obj_t BgL_oz00_4725)
{
{ /* Llib/mpd.scm 1414 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4725)))->BgL_z52artistsz52);} 

}



/* &mpd-database-getgenr1383 */
obj_t BGl_z62mpdzd2databasezd2getgenr1383z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4726, obj_t BgL_oz00_4727)
{
{ /* Llib/mpd.scm 1407 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4727)))->BgL_z52genresz52);} 

}



/* &mpd-database-find-ge1381 */
obj_t BGl_z62mpdzd2databasezd2findzd2ge1381zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4728, obj_t BgL_oz00_4729, obj_t BgL_opz00_4730, obj_t BgL_genrez00_4731)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1393 */
bool_t BgL_tmpz00_7905;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_g1300z00_5306;
BgL_g1300z00_5306 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4729)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1298z00_5308;
BgL_l1298z00_5308 = BgL_g1300z00_5306; 
BgL_zc3z04anonymousza32625ze3z87_5307:
if(
NULLP(BgL_l1298z00_5308))
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_7905 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1402 */
bool_t BgL__ortest_1301z00_5309;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2628z00_5310;
BgL_arg2628z00_5310 = 
CAR(
((obj_t)BgL_l1298z00_5308)); 
BgL__ortest_1301z00_5309 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_4731, 
((obj_t)BgL_opz00_4730), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4729), BgL_arg2628z00_5310); } 
if(BgL__ortest_1301z00_5309)
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_7905 = BgL__ortest_1301z00_5309
; }  else 
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2627z00_5311;
BgL_arg2627z00_5311 = 
CDR(
((obj_t)BgL_l1298z00_5308)); 
{ 
obj_t BgL_l1298z00_7918;
BgL_l1298z00_7918 = BgL_arg2627z00_5311; 
BgL_l1298z00_5308 = BgL_l1298z00_7918; 
goto BgL_zc3z04anonymousza32625ze3z87_5307;} } } } } 
return 
BBOOL(BgL_tmpz00_7905);} } 

}



/* find-genre~0 */
bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t BgL_genrez00_4887, obj_t BgL_opz00_4886, BgL_mpdzd2databasezd2_bglt BgL_oz00_4885, obj_t BgL_dirz00_2273)
{
{ /* Llib/mpd.scm 1399 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2273)))
{ /* Llib/mpd.scm 1394 */
obj_t BgL_g1296z00_2276;
BgL_g1296z00_2276 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2273); 
{ 
obj_t BgL_l1294z00_2278;
BgL_l1294z00_2278 = BgL_g1296z00_2276; 
BgL_zc3z04anonymousza32631ze3z87_2279:
if(
NULLP(BgL_l1294z00_2278))
{ /* Llib/mpd.scm 1394 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1394 */
bool_t BgL__ortest_1297z00_2281;
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2634z00_2283;
BgL_arg2634z00_2283 = 
CAR(
((obj_t)BgL_l1294z00_2278)); 
BgL__ortest_1297z00_2281 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_4887, BgL_opz00_4886, BgL_oz00_4885, BgL_arg2634z00_2283); } 
if(BgL__ortest_1297z00_2281)
{ /* Llib/mpd.scm 1394 */
return BgL__ortest_1297z00_2281;}  else 
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2633z00_2282;
BgL_arg2633z00_2282 = 
CDR(
((obj_t)BgL_l1294z00_2278)); 
{ 
obj_t BgL_l1294z00_7932;
BgL_l1294z00_7932 = BgL_arg2633z00_2282; 
BgL_l1294z00_2278 = BgL_l1294z00_7932; 
goto BgL_zc3z04anonymousza32631ze3z87_2279;} } } } }  else 
{ /* Llib/mpd.scm 1395 */
bool_t BgL_test3582z00_7933;
{ /* Llib/mpd.scm 1395 */
obj_t BgL_arg2638z00_2291;
BgL_arg2638z00_2291 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_2273)); 
{ /* Llib/mpd.scm 1395 */
long BgL_l1z00_3449;
BgL_l1z00_3449 = 
STRING_LENGTH(BgL_arg2638z00_2291); 
if(
(BgL_l1z00_3449==
STRING_LENGTH(
((obj_t)BgL_genrez00_4887))))
{ /* Llib/mpd.scm 1395 */
int BgL_arg1282z00_3452;
{ /* Llib/mpd.scm 1395 */
char * BgL_auxz00_7943;char * BgL_tmpz00_7941;
BgL_auxz00_7943 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_4887)); 
BgL_tmpz00_7941 = 
BSTRING_TO_STRING(BgL_arg2638z00_2291); 
BgL_arg1282z00_3452 = 
memcmp(BgL_tmpz00_7941, BgL_auxz00_7943, BgL_l1z00_3449); } 
BgL_test3582z00_7933 = 
(
(long)(BgL_arg1282z00_3452)==((long)0)); }  else 
{ /* Llib/mpd.scm 1395 */
BgL_test3582z00_7933 = ((bool_t)0)
; } } } 
if(BgL_test3582z00_7933)
{ /* Llib/mpd.scm 1395 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3458;
BgL_g1186z00_3458 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_4885), BgL_dirz00_2273, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_3460;
BgL_l1184z00_3460 = BgL_g1186z00_3458; 
BgL_zc3z04anonymousza31984ze3z87_3459:
if(
PAIRP(BgL_l1184z00_3460))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3462;
BgL_kz00_3462 = 
CAR(BgL_l1184z00_3460); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_3463;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_3464;
BgL_arg1987z00_3464 = 
CAR(
((obj_t)BgL_kz00_3462)); 
BgL_arg1986z00_3463 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_3464)); } 
bgl_display_obj(BgL_arg1986z00_3463, BgL_opz00_4886); } 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_opz00_4886); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_3465;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3475;
BgL_pairz00_3475 = 
CDR(
((obj_t)BgL_kz00_3462)); 
BgL_arg1988z00_3465 = 
CAR(BgL_pairz00_3475); } 
bgl_display_obj(BgL_arg1988z00_3465, BgL_opz00_4886); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4886); } 
{ 
obj_t BgL_l1184z00_7965;
BgL_l1184z00_7965 = 
CDR(BgL_l1184z00_3460); 
BgL_l1184z00_3460 = BgL_l1184z00_7965; 
goto BgL_zc3z04anonymousza31984ze3z87_3459;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1395 */
return ((bool_t)0);} } } 

}



/* &mpd-database-find-ti1379 */
obj_t BGl_z62mpdzd2databasezd2findzd2ti1379zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4732, obj_t BgL_oz00_4733, obj_t BgL_opz00_4734, obj_t BgL_titlez00_4735)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1375 */
bool_t BgL_tmpz00_7967;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_g1292z00_5314;
BgL_g1292z00_5314 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4733)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1290z00_5316;
BgL_l1290z00_5316 = BgL_g1292z00_5314; 
BgL_zc3z04anonymousza32609ze3z87_5315:
if(
NULLP(BgL_l1290z00_5316))
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_7967 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1384 */
bool_t BgL__ortest_1293z00_5317;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2612z00_5318;
BgL_arg2612z00_5318 = 
CAR(
((obj_t)BgL_l1290z00_5316)); 
BgL__ortest_1293z00_5317 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_4735, 
((obj_t)BgL_opz00_4734), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4733), BgL_arg2612z00_5318); } 
if(BgL__ortest_1293z00_5317)
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_7967 = BgL__ortest_1293z00_5317
; }  else 
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2611z00_5319;
BgL_arg2611z00_5319 = 
CDR(
((obj_t)BgL_l1290z00_5316)); 
{ 
obj_t BgL_l1290z00_7980;
BgL_l1290z00_7980 = BgL_arg2611z00_5319; 
BgL_l1290z00_5316 = BgL_l1290z00_7980; 
goto BgL_zc3z04anonymousza32609ze3z87_5315;} } } } } 
return 
BBOOL(BgL_tmpz00_7967);} } 

}



/* find-title~0 */
bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t BgL_titlez00_4884, obj_t BgL_opz00_4883, BgL_mpdzd2databasezd2_bglt BgL_oz00_4882, obj_t BgL_dirz00_2235)
{
{ /* Llib/mpd.scm 1381 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2235)))
{ /* Llib/mpd.scm 1376 */
obj_t BgL_g1288z00_2238;
BgL_g1288z00_2238 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2235); 
{ 
obj_t BgL_l1286z00_2240;
BgL_l1286z00_2240 = BgL_g1288z00_2238; 
BgL_zc3z04anonymousza32615ze3z87_2241:
if(
NULLP(BgL_l1286z00_2240))
{ /* Llib/mpd.scm 1376 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1376 */
bool_t BgL__ortest_1289z00_2243;
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2618z00_2245;
BgL_arg2618z00_2245 = 
CAR(
((obj_t)BgL_l1286z00_2240)); 
BgL__ortest_1289z00_2243 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_4884, BgL_opz00_4883, BgL_oz00_4882, BgL_arg2618z00_2245); } 
if(BgL__ortest_1289z00_2243)
{ /* Llib/mpd.scm 1376 */
return BgL__ortest_1289z00_2243;}  else 
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2617z00_2244;
BgL_arg2617z00_2244 = 
CDR(
((obj_t)BgL_l1286z00_2240)); 
{ 
obj_t BgL_l1286z00_7994;
BgL_l1286z00_7994 = BgL_arg2617z00_2244; 
BgL_l1286z00_2240 = BgL_l1286z00_7994; 
goto BgL_zc3z04anonymousza32615ze3z87_2241;} } } } }  else 
{ /* Llib/mpd.scm 1377 */
bool_t BgL_test3590z00_7995;
{ /* Llib/mpd.scm 1377 */
obj_t BgL_arg2622z00_2253;
BgL_arg2622z00_2253 = 
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_dirz00_2235)); 
{ /* Llib/mpd.scm 1377 */
long BgL_l1z00_3413;
BgL_l1z00_3413 = 
STRING_LENGTH(BgL_arg2622z00_2253); 
if(
(BgL_l1z00_3413==
STRING_LENGTH(
((obj_t)BgL_titlez00_4884))))
{ /* Llib/mpd.scm 1377 */
int BgL_arg1282z00_3416;
{ /* Llib/mpd.scm 1377 */
char * BgL_auxz00_8005;char * BgL_tmpz00_8003;
BgL_auxz00_8005 = 
BSTRING_TO_STRING(
((obj_t)BgL_titlez00_4884)); 
BgL_tmpz00_8003 = 
BSTRING_TO_STRING(BgL_arg2622z00_2253); 
BgL_arg1282z00_3416 = 
memcmp(BgL_tmpz00_8003, BgL_auxz00_8005, BgL_l1z00_3413); } 
BgL_test3590z00_7995 = 
(
(long)(BgL_arg1282z00_3416)==((long)0)); }  else 
{ /* Llib/mpd.scm 1377 */
BgL_test3590z00_7995 = ((bool_t)0)
; } } } 
if(BgL_test3590z00_7995)
{ /* Llib/mpd.scm 1377 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3422;
BgL_g1186z00_3422 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_4882), BgL_dirz00_2235, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_3424;
BgL_l1184z00_3424 = BgL_g1186z00_3422; 
BgL_zc3z04anonymousza31984ze3z87_3423:
if(
PAIRP(BgL_l1184z00_3424))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3426;
BgL_kz00_3426 = 
CAR(BgL_l1184z00_3424); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_3427;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_3428;
BgL_arg1987z00_3428 = 
CAR(
((obj_t)BgL_kz00_3426)); 
BgL_arg1986z00_3427 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_3428)); } 
bgl_display_obj(BgL_arg1986z00_3427, BgL_opz00_4883); } 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_opz00_4883); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_3429;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3439;
BgL_pairz00_3439 = 
CDR(
((obj_t)BgL_kz00_3426)); 
BgL_arg1988z00_3429 = 
CAR(BgL_pairz00_3439); } 
bgl_display_obj(BgL_arg1988z00_3429, BgL_opz00_4883); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4883); } 
{ 
obj_t BgL_l1184z00_8027;
BgL_l1184z00_8027 = 
CDR(BgL_l1184z00_3424); 
BgL_l1184z00_3424 = BgL_l1184z00_8027; 
goto BgL_zc3z04anonymousza31984ze3z87_3423;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1377 */
return ((bool_t)0);} } } 

}



/* &mpd-database-search-1377 */
obj_t BGl_z62mpdzd2databasezd2searchzd21377zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4736, obj_t BgL_oz00_4737, obj_t BgL_opz00_4738, obj_t BgL_artistz00_4739, obj_t BgL_titlez00_4740)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1349 */
bool_t BgL_tmpz00_8029;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5323;obj_t BgL_dirz00_5324;obj_t BgL_opz00_5325;
{ /* Llib/mpd.scm 1364 */
obj_t BgL_cz00_5326;
BgL_cz00_5326 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_4739, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4737)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5326))
{ /* Llib/mpd.scm 1365 */
BgL_dbz00_5323 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4737); 
BgL_dirz00_5324 = 
CDR(BgL_cz00_5326); 
BgL_opz00_5325 = 
((obj_t)BgL_opz00_4738); 
BgL_tmpz00_8029 = 
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5325, BgL_dbz00_5323, BgL_artistz00_4739, BgL_titlez00_4740, BgL_dirz00_5324); }  else 
{ /* Llib/mpd.scm 1365 */
BgL_tmpz00_8029 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8029);} } 

}



/* loop~2 */
bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_4881, BgL_mpdzd2databasezd2_bglt BgL_dbz00_4880, obj_t BgL_artistz00_4879, obj_t BgL_titlez00_4878, obj_t BgL_dirz00_2186)
{
{ /* Llib/mpd.scm 1348 */
{ /* Llib/mpd.scm 1349 */
obj_t BgL_filesz00_2188;
BgL_filesz00_2188 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2186); 
{ /* Llib/mpd.scm 1349 */
obj_t BgL_imgz00_2189;
{ 
obj_t BgL_list1283z00_2208;
BgL_list1283z00_2208 = BgL_filesz00_2188; 
BgL_zc3z04anonymousza32602ze3z87_2209:
if(
PAIRP(BgL_list1283z00_2208))
{ /* Llib/mpd.scm 1350 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1283z00_2208)))
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2189 = 
CAR(BgL_list1283z00_2208); }  else 
{ 
obj_t BgL_list1283z00_8047;
BgL_list1283z00_8047 = 
CDR(BgL_list1283z00_2208); 
BgL_list1283z00_2208 = BgL_list1283z00_8047; 
goto BgL_zc3z04anonymousza32602ze3z87_2209;} }  else 
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2189 = BFALSE; } } 
{ /* Llib/mpd.scm 1350 */

{ 
obj_t BgL_l1284z00_2191;
BgL_l1284z00_2191 = BgL_filesz00_2188; 
BgL_zc3z04anonymousza32594ze3z87_2192:
if(
PAIRP(BgL_l1284z00_2191))
{ /* Llib/mpd.scm 1351 */
{ /* Llib/mpd.scm 1352 */
obj_t BgL_fz00_2194;
BgL_fz00_2194 = 
CAR(BgL_l1284z00_2191); 
{ /* Llib/mpd.scm 1352 */
obj_t BgL_pz00_2195;
BgL_pz00_2195 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2186, BgL_fz00_2194); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2195)))
{ /* Llib/mpd.scm 1354 */
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_4881, BgL_dbz00_4880, BgL_artistz00_4879, BgL_titlez00_4878, BgL_pz00_2195); }  else 
{ /* Llib/mpd.scm 1356 */
bool_t BgL_test3598z00_8057;
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2195, 
((obj_t)BgL_dbz00_4880)))
{ /* Llib/mpd.scm 1356 */
obj_t BgL_arg2600z00_2204;
BgL_arg2600z00_2204 = 
BGl_prefixz00zz__osz00(BgL_fz00_2194); 
{ /* Llib/mpd.scm 1356 */
long BgL_l1z00_3377;
BgL_l1z00_3377 = 
STRING_LENGTH(
((obj_t)BgL_titlez00_4878)); 
if(
(BgL_l1z00_3377==
STRING_LENGTH(BgL_arg2600z00_2204)))
{ /* Llib/mpd.scm 1356 */
int BgL_arg1282z00_3380;
{ /* Llib/mpd.scm 1356 */
char * BgL_auxz00_8070;char * BgL_tmpz00_8067;
BgL_auxz00_8070 = 
BSTRING_TO_STRING(BgL_arg2600z00_2204); 
BgL_tmpz00_8067 = 
BSTRING_TO_STRING(
((obj_t)BgL_titlez00_4878)); 
BgL_arg1282z00_3380 = 
memcmp(BgL_tmpz00_8067, BgL_auxz00_8070, BgL_l1z00_3377); } 
BgL_test3598z00_8057 = 
(
(long)(BgL_arg1282z00_3380)==((long)0)); }  else 
{ /* Llib/mpd.scm 1356 */
BgL_test3598z00_8057 = ((bool_t)0)
; } } }  else 
{ /* Llib/mpd.scm 1356 */
BgL_test3598z00_8057 = ((bool_t)0)
; } 
if(BgL_test3598z00_8057)
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3386;
BgL_g1186z00_3386 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_4880), BgL_pz00_2195, BgL_artistz00_4879, BgL_titlez00_4878, BgL_imgz00_2189); 
{ 
obj_t BgL_l1184z00_3388;
BgL_l1184z00_3388 = BgL_g1186z00_3386; 
BgL_zc3z04anonymousza31984ze3z87_3387:
if(
PAIRP(BgL_l1184z00_3388))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3390;
BgL_kz00_3390 = 
CAR(BgL_l1184z00_3388); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_3391;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_3392;
BgL_arg1987z00_3392 = 
CAR(
((obj_t)BgL_kz00_3390)); 
BgL_arg1986z00_3391 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_3392)); } 
bgl_display_obj(BgL_arg1986z00_3391, BgL_opz00_4881); } 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_opz00_4881); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_3393;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3403;
BgL_pairz00_3403 = 
CDR(
((obj_t)BgL_kz00_3390)); 
BgL_arg1988z00_3393 = 
CAR(BgL_pairz00_3403); } 
bgl_display_obj(BgL_arg1988z00_3393, BgL_opz00_4881); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4881); } 
{ 
obj_t BgL_l1184z00_8091;
BgL_l1184z00_8091 = 
CDR(BgL_l1184z00_3388); 
BgL_l1184z00_3388 = BgL_l1184z00_8091; 
goto BgL_zc3z04anonymousza31984ze3z87_3387;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1356 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1284z00_8093;
BgL_l1284z00_8093 = 
CDR(BgL_l1284z00_2191); 
BgL_l1284z00_2191 = BgL_l1284z00_8093; 
goto BgL_zc3z04anonymousza32594ze3z87_2192;} }  else 
{ /* Llib/mpd.scm 1351 */
return ((bool_t)1);} } } } } } 

}



/* &mpd-database-search-1375 */
obj_t BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4741, obj_t BgL_oz00_4742, obj_t BgL_opz00_4743, obj_t BgL_artistz00_4744, obj_t BgL_albumz00_4745)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_tmpz00_8095;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5330;obj_t BgL_dirz00_5331;obj_t BgL_opz00_5332;
{ /* Llib/mpd.scm 1338 */
obj_t BgL_cz00_5333;
BgL_cz00_5333 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_4744, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4742)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5333))
{ /* Llib/mpd.scm 1339 */
BgL_dbz00_5330 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4742); 
BgL_dirz00_5331 = 
CDR(BgL_cz00_5333); 
BgL_opz00_5332 = 
((obj_t)BgL_opz00_4743); 
BgL_tmpz00_8095 = 
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5332, BgL_dbz00_5330, BgL_artistz00_4744, BgL_albumz00_4745, BgL_dirz00_5331); }  else 
{ /* Llib/mpd.scm 1339 */
BgL_tmpz00_8095 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8095);} } 

}



/* loop~1 */
bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_4877, BgL_mpdzd2databasezd2_bglt BgL_dbz00_4876, obj_t BgL_artistz00_4875, obj_t BgL_albumz00_4874, obj_t BgL_dirz00_2115)
{
{ /* Llib/mpd.scm 1314 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_test3603z00_8106;
{ /* Llib/mpd.scm 1315 */
obj_t BgL_arg2587z00_2165;
BgL_arg2587z00_2165 = 
BGl_basenamez00zz__osz00(BgL_dirz00_2115); 
{ /* Llib/mpd.scm 1315 */
long BgL_l1z00_3324;
BgL_l1z00_3324 = 
STRING_LENGTH(BgL_arg2587z00_2165); 
if(
(BgL_l1z00_3324==
STRING_LENGTH(
((obj_t)BgL_albumz00_4874))))
{ /* Llib/mpd.scm 1315 */
int BgL_arg1282z00_3327;
{ /* Llib/mpd.scm 1315 */
char * BgL_auxz00_8115;char * BgL_tmpz00_8113;
BgL_auxz00_8115 = 
BSTRING_TO_STRING(
((obj_t)BgL_albumz00_4874)); 
BgL_tmpz00_8113 = 
BSTRING_TO_STRING(BgL_arg2587z00_2165); 
BgL_arg1282z00_3327 = 
memcmp(BgL_tmpz00_8113, BgL_auxz00_8115, BgL_l1z00_3324); } 
BgL_test3603z00_8106 = 
(
(long)(BgL_arg1282z00_3327)==((long)0)); }  else 
{ /* Llib/mpd.scm 1315 */
BgL_test3603z00_8106 = ((bool_t)0)
; } } } 
if(BgL_test3603z00_8106)
{ /* Llib/mpd.scm 1316 */
obj_t BgL_filesz00_2119;
BgL_filesz00_2119 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3081z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_2115))); 
{ /* Llib/mpd.scm 1316 */
obj_t BgL_imgz00_2120;
{ /* Llib/mpd.scm 1319 */
obj_t BgL_fz00_2134;
{ 
obj_t BgL_list1276z00_2137;
BgL_list1276z00_2137 = BgL_filesz00_2119; 
BgL_zc3z04anonymousza32573ze3z87_2138:
if(
PAIRP(BgL_list1276z00_2137))
{ /* Llib/mpd.scm 1319 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1276z00_2137)))
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2134 = 
CAR(BgL_list1276z00_2137); }  else 
{ 
obj_t BgL_list1276z00_8130;
BgL_list1276z00_8130 = 
CDR(BgL_list1276z00_2137); 
BgL_list1276z00_2137 = BgL_list1276z00_8130; 
goto BgL_zc3z04anonymousza32573ze3z87_2138;} }  else 
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2134 = BFALSE; } } 
if(
STRINGP(BgL_fz00_2134))
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2120 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2115, BgL_fz00_2134); }  else 
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2120 = BFALSE; } } 
{ /* Llib/mpd.scm 1319 */

{ 
obj_t BgL_l1277z00_2122;
BgL_l1277z00_2122 = BgL_filesz00_2119; 
BgL_zc3z04anonymousza32567ze3z87_2123:
if(
PAIRP(BgL_l1277z00_2122))
{ /* Llib/mpd.scm 1322 */
{ /* Llib/mpd.scm 1323 */
obj_t BgL_fz00_2125;
BgL_fz00_2125 = 
CAR(BgL_l1277z00_2122); 
{ /* Llib/mpd.scm 1323 */
obj_t BgL_pz00_2126;
BgL_pz00_2126 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2115, BgL_fz00_2125); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2126)))
{ /* Llib/mpd.scm 1325 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_4877, BgL_dbz00_4876, BgL_artistz00_4875, BgL_albumz00_4874, BgL_pz00_2126); }  else 
{ /* Llib/mpd.scm 1325 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2126, 
((obj_t)BgL_dbz00_4876)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3345;
BgL_g1186z00_3345 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_4876), BgL_pz00_2126, BgL_artistz00_4875, BgL_albumz00_4874, BgL_imgz00_2120); 
{ 
obj_t BgL_l1184z00_3347;
BgL_l1184z00_3347 = BgL_g1186z00_3345; 
BgL_zc3z04anonymousza31984ze3z87_3346:
if(
PAIRP(BgL_l1184z00_3347))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3349;
BgL_kz00_3349 = 
CAR(BgL_l1184z00_3347); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_3350;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_3351;
BgL_arg1987z00_3351 = 
CAR(
((obj_t)BgL_kz00_3349)); 
BgL_arg1986z00_3350 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_3351)); } 
bgl_display_obj(BgL_arg1986z00_3350, BgL_opz00_4877); } 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_opz00_4877); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_3352;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3362;
BgL_pairz00_3362 = 
CDR(
((obj_t)BgL_kz00_3349)); 
BgL_arg1988z00_3352 = 
CAR(BgL_pairz00_3362); } 
bgl_display_obj(BgL_arg1988z00_3352, BgL_opz00_4877); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4877); } 
{ 
obj_t BgL_l1184z00_8162;
BgL_l1184z00_8162 = 
CDR(BgL_l1184z00_3347); 
BgL_l1184z00_3347 = BgL_l1184z00_8162; 
goto BgL_zc3z04anonymousza31984ze3z87_3346;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1327 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1277z00_8164;
BgL_l1277z00_8164 = 
CDR(BgL_l1277z00_2122); 
BgL_l1277z00_2122 = BgL_l1277z00_8164; 
goto BgL_zc3z04anonymousza32567ze3z87_2123;} }  else 
{ /* Llib/mpd.scm 1322 */
return ((bool_t)1);} } } } }  else 
{ /* Llib/mpd.scm 1333 */
obj_t BgL_g1281z00_2156;
BgL_g1281z00_2156 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2115); 
{ 
obj_t BgL_l1279z00_2158;
BgL_l1279z00_2158 = BgL_g1281z00_2156; 
BgL_zc3z04anonymousza32583ze3z87_2159:
if(
PAIRP(BgL_l1279z00_2158))
{ /* Llib/mpd.scm 1336 */
{ /* Llib/mpd.scm 1334 */
obj_t BgL_pz00_2161;
BgL_pz00_2161 = 
CAR(BgL_l1279z00_2158); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2161)))
{ /* Llib/mpd.scm 1334 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_4877, BgL_dbz00_4876, BgL_artistz00_4875, BgL_albumz00_4874, BgL_pz00_2161); }  else 
{ /* Llib/mpd.scm 1334 */((bool_t)0); } } 
{ 
obj_t BgL_l1279z00_8174;
BgL_l1279z00_8174 = 
CDR(BgL_l1279z00_2158); 
BgL_l1279z00_2158 = BgL_l1279z00_8174; 
goto BgL_zc3z04anonymousza32583ze3z87_2159;} }  else 
{ /* Llib/mpd.scm 1336 */
return ((bool_t)1);} } } } } 

}



/* &<@anonymous:2581> */
obj_t BGl_z62zc3z04anonymousza32581ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4746, obj_t BgL_s1z00_4747, obj_t BgL_s2z00_4748)
{
{ /* Llib/mpd.scm 1316 */
{ /* Llib/mpd.scm 1317 */
bool_t BgL_tmpz00_8176;
{ /* Llib/mpd.scm 1317 */
int BgL_arg2582z00_5334;
{ /* Llib/mpd.scm 1317 */

BgL_arg2582z00_5334 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4747, BgL_s2z00_4748, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8176 = 
(
(long)(BgL_arg2582z00_5334)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8176);} } 

}



/* &mpd-database-find-ar1373 */
obj_t BGl_z62mpdzd2databasezd2findzd2ar1373zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4749, obj_t BgL_oz00_4750, obj_t BgL_opz00_4751, obj_t BgL_artistz00_4752)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1304 */
bool_t BgL_tmpz00_8183;
{ /* Llib/mpd.scm 1305 */
obj_t BgL_cz00_5340;
BgL_cz00_5340 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_4752, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4750)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5340))
{ /* Llib/mpd.scm 1307 */
obj_t BgL_dirz00_5342;
BgL_dirz00_5342 = 
CDR(BgL_cz00_5340); 
BgL_tmpz00_8183 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_4751), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4750), BFALSE, BgL_artistz00_4752, BgL_dirz00_5342); }  else 
{ /* Llib/mpd.scm 1306 */
BgL_tmpz00_8183 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8183);} } 

}



/* &mpd-database-find-al1371 */
obj_t BGl_z62mpdzd2databasezd2findzd2al1371zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4753, obj_t BgL_oz00_4754, obj_t BgL_opz00_4755, obj_t BgL_albumz00_4756)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1295 */
bool_t BgL_tmpz00_8194;
{ /* Llib/mpd.scm 1296 */
obj_t BgL_cz00_5349;
BgL_cz00_5349 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_4756, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4754)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5349))
{ /* Llib/mpd.scm 1298 */
obj_t BgL_dirz00_5351;
BgL_dirz00_5351 = 
CDR(BgL_cz00_5349); 
BgL_tmpz00_8194 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_4755), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4754), BgL_albumz00_4756, BFALSE, BgL_dirz00_5351); }  else 
{ /* Llib/mpd.scm 1297 */
BgL_tmpz00_8194 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8194);} } 

}



/* &mpd-database-lsinfo1369 */
obj_t BGl_z62mpdzd2databasezd2lsinfo1369z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4757, obj_t BgL_oz00_4758, obj_t BgL_opz00_4759, obj_t BgL_dirz00_4760, obj_t BgL_recz00_4761)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1234 */
bool_t BgL_tmpz00_8205;
{ /* Llib/mpd.scm 1234 */
bool_t BgL_recz00_5356;
BgL_recz00_5356 = 
CBOOL(BgL_recz00_4761); 
{ /* Llib/mpd.scm 1235 */
bool_t BgL_test3616z00_8207;
if(
BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_4760)))
{ /* Llib/mpd.scm 1235 */
BgL_test3616z00_8207 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 1235 */
obj_t BgL_arg2550z00_5357;
BgL_arg2550z00_5357 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758)))->BgL_z52basez52); 
{ /* Llib/mpd.scm 1235 */
long BgL_l1z00_5358;
BgL_l1z00_5358 = 
STRING_LENGTH(
((obj_t)BgL_dirz00_4760)); 
if(
(BgL_l1z00_5358==
STRING_LENGTH(BgL_arg2550z00_5357)))
{ /* Llib/mpd.scm 1235 */
int BgL_arg1282z00_5359;
{ /* Llib/mpd.scm 1235 */
char * BgL_auxz00_8221;char * BgL_tmpz00_8218;
BgL_auxz00_8221 = 
BSTRING_TO_STRING(BgL_arg2550z00_5357); 
BgL_tmpz00_8218 = 
BSTRING_TO_STRING(
((obj_t)BgL_dirz00_4760)); 
BgL_arg1282z00_5359 = 
memcmp(BgL_tmpz00_8218, BgL_auxz00_8221, BgL_l1z00_5358); } 
BgL_test3616z00_8207 = 
(
(long)(BgL_arg1282z00_5359)==((long)0)); }  else 
{ /* Llib/mpd.scm 1235 */
BgL_test3616z00_8207 = ((bool_t)0)
; } } } 
if(BgL_test3616z00_8207)
{ /* Llib/mpd.scm 1236 */
obj_t BgL_g1266z00_5360;
BgL_g1266z00_5360 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1264z00_5362;
BgL_l1264z00_5362 = BgL_g1266z00_5360; 
BgL_zc3z04anonymousza32531ze3z87_5361:
if(
PAIRP(BgL_l1264z00_5362))
{ /* Llib/mpd.scm 1236 */
{ /* Llib/mpd.scm 1237 */
obj_t BgL_dirz00_5363;
BgL_dirz00_5363 = 
CAR(BgL_l1264z00_5362); 
{ /* Llib/mpd.scm 1237 */
obj_t BgL_g1263z00_5364;
BgL_g1263z00_5364 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_5363); 
{ 
obj_t BgL_l1261z00_5366;
BgL_l1261z00_5366 = BgL_g1263z00_5364; 
BgL_zc3z04anonymousza32533ze3z87_5365:
if(
PAIRP(BgL_l1261z00_5366))
{ /* Llib/mpd.scm 1244 */
{ /* Llib/mpd.scm 1238 */
obj_t BgL_dirz00_5367;
BgL_dirz00_5367 = 
CAR(BgL_l1261z00_5366); 
{ /* Llib/mpd.scm 1238 */
obj_t BgL_mdz00_5368;
BgL_mdz00_5368 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_dirz00_5367, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758))); 
{ /* Llib/mpd.scm 1239 */
obj_t BgL_tmpz00_8238;
BgL_tmpz00_8238 = 
((obj_t)BgL_opz00_4759); 
bgl_display_string(BGl_string3082z00zz__multimediazd2mpdzd2, BgL_tmpz00_8238); } 
bgl_display_obj(BgL_mdz00_5368, 
((obj_t)BgL_opz00_4759)); 
{ /* Llib/mpd.scm 1241 */
obj_t BgL_tmpz00_8243;
BgL_tmpz00_8243 = 
((obj_t)BgL_opz00_4759); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8243); } 
if(BgL_recz00_5356)
{ /* Llib/mpd.scm 1242 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758), 
((obj_t)BgL_opz00_4759), BgL_mdz00_5368, BgL_recz00_5356); }  else 
{ /* Llib/mpd.scm 1242 */BFALSE; } } } 
{ 
obj_t BgL_l1261z00_8250;
BgL_l1261z00_8250 = 
CDR(BgL_l1261z00_5366); 
BgL_l1261z00_5366 = BgL_l1261z00_8250; 
goto BgL_zc3z04anonymousza32533ze3z87_5365;} }  else 
{ /* Llib/mpd.scm 1244 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1264z00_8252;
BgL_l1264z00_8252 = 
CDR(BgL_l1264z00_5362); 
BgL_l1264z00_5362 = BgL_l1264z00_8252; 
goto BgL_zc3z04anonymousza32531ze3z87_5361;} }  else 
{ /* Llib/mpd.scm 1236 */
BgL_tmpz00_8205 = ((bool_t)1)
; } } }  else 
{ /* Llib/mpd.scm 1246 */
obj_t BgL_pathz00_5369;
BgL_pathz00_5369 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_4760), 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758)), 
((obj_t)BgL_opz00_4759), BGl_string3083z00zz__multimediazd2mpdzd2); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5369)))
{ /* Llib/mpd.scm 1248 */
obj_t BgL_filesz00_5370;
BgL_filesz00_5370 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5369); 
{ /* Llib/mpd.scm 1248 */
obj_t BgL_imgz00_5371;
{ /* Llib/mpd.scm 1249 */
obj_t BgL_fz00_5372;
{ 
obj_t BgL_list1268z00_5374;
BgL_list1268z00_5374 = BgL_filesz00_5370; 
BgL_zc3z04anonymousza32544ze3z87_5373:
if(
PAIRP(BgL_list1268z00_5374))
{ /* Llib/mpd.scm 1249 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1268z00_5374)))
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5372 = 
CAR(BgL_list1268z00_5374); }  else 
{ 
obj_t BgL_list1268z00_8269;
BgL_list1268z00_8269 = 
CDR(BgL_list1268z00_5374); 
BgL_list1268z00_5374 = BgL_list1268z00_8269; 
goto BgL_zc3z04anonymousza32544ze3z87_5373;} }  else 
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5372 = BFALSE; } } 
if(
STRINGP(BgL_fz00_5372))
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5371 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5369, BgL_fz00_5372); }  else 
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5371 = BFALSE; } } 
{ /* Llib/mpd.scm 1249 */

{ 
obj_t BgL_l1269z00_5376;
BgL_l1269z00_5376 = BgL_filesz00_5370; 
BgL_zc3z04anonymousza32538ze3z87_5375:
if(
PAIRP(BgL_l1269z00_5376))
{ /* Llib/mpd.scm 1252 */
{ /* Llib/mpd.scm 1253 */
obj_t BgL_fz00_5377;
BgL_fz00_5377 = 
CAR(BgL_l1269z00_5376); 
{ /* Llib/mpd.scm 1253 */
obj_t BgL_pz00_5378;
BgL_pz00_5378 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5369, BgL_fz00_5377); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_5378)))
{ /* Llib/mpd.scm 1256 */
obj_t BgL_mdz00_5379;
BgL_mdz00_5379 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pz00_5378, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758))); 
{ /* Llib/mpd.scm 1257 */
obj_t BgL_tmpz00_8284;
BgL_tmpz00_8284 = 
((obj_t)BgL_opz00_4759); 
bgl_display_string(BGl_string3082z00zz__multimediazd2mpdzd2, BgL_tmpz00_8284); } 
bgl_display_obj(BgL_mdz00_5379, 
((obj_t)BgL_opz00_4759)); 
{ /* Llib/mpd.scm 1259 */
obj_t BgL_tmpz00_8289;
BgL_tmpz00_8289 = 
((obj_t)BgL_opz00_4759); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8289); } 
if(BgL_recz00_5356)
{ /* Llib/mpd.scm 1260 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758), 
((obj_t)BgL_opz00_4759), BgL_mdz00_5379, BgL_recz00_5356); }  else 
{ /* Llib/mpd.scm 1260 */BFALSE; } }  else 
{ /* Llib/mpd.scm 1255 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5377, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758))))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_5380;
BgL_g1186z00_5380 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4758)), BgL_pz00_5378, BFALSE, BFALSE, BgL_imgz00_5371); 
{ 
obj_t BgL_l1184z00_5382;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_8303;
BgL_l1184z00_5382 = BgL_g1186z00_5380; 
BgL_zc3z04anonymousza31984ze3z87_5381:
if(
PAIRP(BgL_l1184z00_5382))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5383;
BgL_kz00_5383 = 
CAR(BgL_l1184z00_5382); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1986z00_5384;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1987z00_5385;
BgL_arg1987z00_5385 = 
CAR(
((obj_t)BgL_kz00_5383)); 
BgL_arg1986z00_5384 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1987z00_5385)); } 
bgl_display_obj(BgL_arg1986z00_5384, 
((obj_t)BgL_opz00_4759)); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_8313;
BgL_tmpz00_8313 = 
((obj_t)BgL_opz00_4759); 
bgl_display_string(BGl_string2965z00zz__multimediazd2mpdzd2, BgL_tmpz00_8313); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1988z00_5386;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5387;
BgL_pairz00_5387 = 
CDR(
((obj_t)BgL_kz00_5383)); 
BgL_arg1988z00_5386 = 
CAR(BgL_pairz00_5387); } 
bgl_display_obj(BgL_arg1988z00_5386, 
((obj_t)BgL_opz00_4759)); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_8321;
BgL_tmpz00_8321 = 
((obj_t)BgL_opz00_4759); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8321); } } 
{ 
obj_t BgL_l1184z00_8324;
BgL_l1184z00_8324 = 
CDR(BgL_l1184z00_5382); 
BgL_l1184z00_5382 = BgL_l1184z00_8324; 
goto BgL_zc3z04anonymousza31984ze3z87_5381;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_8303 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_8303); } } }  else 
{ /* Llib/mpd.scm 1262 */BFALSE; } } } } 
{ 
obj_t BgL_l1269z00_8327;
BgL_l1269z00_8327 = 
CDR(BgL_l1269z00_5376); 
BgL_l1269z00_5376 = BgL_l1269z00_8327; 
goto BgL_zc3z04anonymousza32538ze3z87_5375;} }  else 
{ /* Llib/mpd.scm 1252 */
BgL_tmpz00_8205 = ((bool_t)1)
; } } } } }  else 
{ /* Llib/mpd.scm 1247 */
BgL_tmpz00_8205 = ((bool_t)0)
; } } } } 
return 
BBOOL(BgL_tmpz00_8205);} } 

}



/* &mpd-database-listart1367 */
obj_t BGl_z62mpdzd2databasezd2listart1367z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4762, obj_t BgL_oz00_4763, obj_t BgL_opz00_4764)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1224 */
bool_t BgL_tmpz00_8330;
{ /* Llib/mpd.scm 1224 */
obj_t BgL_g1260z00_5390;
BgL_g1260z00_5390 = 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4763)); 
{ 
obj_t BgL_l1258z00_5392;
BgL_l1258z00_5392 = BgL_g1260z00_5390; 
BgL_zc3z04anonymousza32523ze3z87_5391:
if(
PAIRP(BgL_l1258z00_5392))
{ /* Llib/mpd.scm 1228 */
{ /* Llib/mpd.scm 1225 */
obj_t BgL_az00_5393;
BgL_az00_5393 = 
CAR(BgL_l1258z00_5392); 
{ /* Llib/mpd.scm 1225 */
obj_t BgL_tmpz00_8336;
BgL_tmpz00_8336 = 
((obj_t)BgL_opz00_4764); 
bgl_display_string(BGl_string2973z00zz__multimediazd2mpdzd2, BgL_tmpz00_8336); } 
{ /* Llib/mpd.scm 1226 */
obj_t BgL_arg2525z00_5394;
BgL_arg2525z00_5394 = 
CAR(
((obj_t)BgL_az00_5393)); 
bgl_display_obj(BgL_arg2525z00_5394, 
((obj_t)BgL_opz00_4764)); } 
{ /* Llib/mpd.scm 1227 */
obj_t BgL_tmpz00_8343;
BgL_tmpz00_8343 = 
((obj_t)BgL_opz00_4764); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8343); } } 
{ 
obj_t BgL_l1258z00_8346;
BgL_l1258z00_8346 = 
CDR(BgL_l1258z00_5392); 
BgL_l1258z00_5392 = BgL_l1258z00_8346; 
goto BgL_zc3z04anonymousza32523ze3z87_5391;} }  else 
{ /* Llib/mpd.scm 1228 */
BgL_tmpz00_8330 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8330);} } 

}



/* &mpd-database-listgen1365 */
obj_t BGl_z62mpdzd2databasezd2listgen1365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4765, obj_t BgL_oz00_4766, obj_t BgL_opz00_4767)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1214 */
bool_t BgL_tmpz00_8349;
{ /* Llib/mpd.scm 1214 */
obj_t BgL_g1257z00_5397;
BgL_g1257z00_5397 = 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4766)); 
{ 
obj_t BgL_l1255z00_5399;
BgL_l1255z00_5399 = BgL_g1257z00_5397; 
BgL_zc3z04anonymousza32518ze3z87_5398:
if(
PAIRP(BgL_l1255z00_5399))
{ /* Llib/mpd.scm 1218 */
{ /* Llib/mpd.scm 1215 */
obj_t BgL_az00_5400;
BgL_az00_5400 = 
CAR(BgL_l1255z00_5399); 
{ /* Llib/mpd.scm 1215 */
obj_t BgL_tmpz00_8355;
BgL_tmpz00_8355 = 
((obj_t)BgL_opz00_4767); 
bgl_display_string(BGl_string3084z00zz__multimediazd2mpdzd2, BgL_tmpz00_8355); } 
{ /* Llib/mpd.scm 1216 */
obj_t BgL_arg2520z00_5401;
BgL_arg2520z00_5401 = 
CAR(
((obj_t)BgL_az00_5400)); 
bgl_display_obj(BgL_arg2520z00_5401, 
((obj_t)BgL_opz00_4767)); } 
{ /* Llib/mpd.scm 1217 */
obj_t BgL_tmpz00_8362;
BgL_tmpz00_8362 = 
((obj_t)BgL_opz00_4767); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8362); } } 
{ 
obj_t BgL_l1255z00_8365;
BgL_l1255z00_8365 = 
CDR(BgL_l1255z00_5399); 
BgL_l1255z00_5399 = BgL_l1255z00_8365; 
goto BgL_zc3z04anonymousza32518ze3z87_5398;} }  else 
{ /* Llib/mpd.scm 1218 */
BgL_tmpz00_8349 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8349);} } 

}



/* &mpd-database-listgen1363 */
obj_t BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4768, obj_t BgL_oz00_4769, obj_t BgL_opz00_4770, obj_t BgL_genrez00_4771)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1204 */
bool_t BgL_tmpz00_8368;
{ /* Llib/mpd.scm 1204 */
obj_t BgL_g1254z00_5404;
BgL_g1254z00_5404 = 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4769), BgL_genrez00_4771); 
{ 
obj_t BgL_l1252z00_5406;
BgL_l1252z00_5406 = BgL_g1254z00_5404; 
BgL_zc3z04anonymousza32513ze3z87_5405:
if(
PAIRP(BgL_l1252z00_5406))
{ /* Llib/mpd.scm 1208 */
{ /* Llib/mpd.scm 1205 */
obj_t BgL_az00_5407;
BgL_az00_5407 = 
CAR(BgL_l1252z00_5406); 
{ /* Llib/mpd.scm 1205 */
obj_t BgL_tmpz00_8374;
BgL_tmpz00_8374 = 
((obj_t)BgL_opz00_4770); 
bgl_display_string(BGl_string2973z00zz__multimediazd2mpdzd2, BgL_tmpz00_8374); } 
{ /* Llib/mpd.scm 1206 */
obj_t BgL_arg2515z00_5408;
BgL_arg2515z00_5408 = 
CAR(
((obj_t)BgL_az00_5407)); 
bgl_display_obj(BgL_arg2515z00_5408, 
((obj_t)BgL_opz00_4770)); } 
{ /* Llib/mpd.scm 1207 */
obj_t BgL_tmpz00_8381;
BgL_tmpz00_8381 = 
((obj_t)BgL_opz00_4770); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8381); } } 
{ 
obj_t BgL_l1252z00_8384;
BgL_l1252z00_8384 = 
CDR(BgL_l1252z00_5406); 
BgL_l1252z00_5406 = BgL_l1252z00_8384; 
goto BgL_zc3z04anonymousza32513ze3z87_5405;} }  else 
{ /* Llib/mpd.scm 1208 */
BgL_tmpz00_8368 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8368);} } 

}



/* &mpd-database-listgen1361 */
obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4772, obj_t BgL_oz00_4773, obj_t BgL_opz00_4774, obj_t BgL_genrez00_4775)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1190 */
bool_t BgL_tmpz00_8387;
{ /* Llib/mpd.scm 1190 */
obj_t BgL_g1251z00_5411;
{ /* Llib/mpd.scm 1194 */
obj_t BgL_hook1247z00_5412;
BgL_hook1247z00_5412 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_g1248z00_5413;
BgL_g1248z00_5413 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4773)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1244z00_5415;obj_t BgL_h1245z00_5416;
BgL_l1244z00_5415 = BgL_g1248z00_5413; 
BgL_h1245z00_5416 = BgL_hook1247z00_5412; 
BgL_zc3z04anonymousza32500ze3z87_5414:
if(
NULLP(BgL_l1244z00_5415))
{ /* Llib/mpd.scm 1197 */
BgL_g1251z00_5411 = 
CDR(BgL_hook1247z00_5412); }  else 
{ /* Llib/mpd.scm 1197 */
bool_t BgL_test3635z00_8394;
{ /* Llib/mpd.scm 1195 */
obj_t BgL_cz00_5417;
BgL_cz00_5417 = 
CAR(
((obj_t)BgL_l1244z00_5415)); 
{ /* Llib/mpd.scm 1195 */
obj_t BgL_dirz00_5418;
BgL_dirz00_5418 = 
CDR(
((obj_t)BgL_cz00_5417)); 
{ /* Llib/mpd.scm 1196 */
obj_t BgL_arg2509z00_5419;
BgL_arg2509z00_5419 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5418))); 
{ /* Llib/mpd.scm 1196 */
long BgL_l1z00_5420;
BgL_l1z00_5420 = 
STRING_LENGTH(BgL_arg2509z00_5419); 
if(
(BgL_l1z00_5420==
STRING_LENGTH(
((obj_t)BgL_genrez00_4775))))
{ /* Llib/mpd.scm 1196 */
int BgL_arg1282z00_5421;
{ /* Llib/mpd.scm 1196 */
char * BgL_auxz00_8409;char * BgL_tmpz00_8407;
BgL_auxz00_8409 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_4775)); 
BgL_tmpz00_8407 = 
BSTRING_TO_STRING(BgL_arg2509z00_5419); 
BgL_arg1282z00_5421 = 
memcmp(BgL_tmpz00_8407, BgL_auxz00_8409, BgL_l1z00_5420); } 
BgL_test3635z00_8394 = 
(
(long)(BgL_arg1282z00_5421)==((long)0)); }  else 
{ /* Llib/mpd.scm 1196 */
BgL_test3635z00_8394 = ((bool_t)0)
; } } } } } 
if(BgL_test3635z00_8394)
{ /* Llib/mpd.scm 1197 */
obj_t BgL_nh1246z00_5422;
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2507z00_5423;
BgL_arg2507z00_5423 = 
CAR(
((obj_t)BgL_l1244z00_5415)); 
BgL_nh1246z00_5422 = 
MAKE_YOUNG_PAIR(BgL_arg2507z00_5423, BNIL); } 
SET_CDR(BgL_h1245z00_5416, BgL_nh1246z00_5422); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2506z00_5424;
BgL_arg2506z00_5424 = 
CDR(
((obj_t)BgL_l1244z00_5415)); 
{ 
obj_t BgL_h1245z00_8422;obj_t BgL_l1244z00_8421;
BgL_l1244z00_8421 = BgL_arg2506z00_5424; 
BgL_h1245z00_8422 = BgL_nh1246z00_5422; 
BgL_h1245z00_5416 = BgL_h1245z00_8422; 
BgL_l1244z00_5415 = BgL_l1244z00_8421; 
goto BgL_zc3z04anonymousza32500ze3z87_5414;} } }  else 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2508z00_5425;
BgL_arg2508z00_5425 = 
CDR(
((obj_t)BgL_l1244z00_5415)); 
{ 
obj_t BgL_l1244z00_8425;
BgL_l1244z00_8425 = BgL_arg2508z00_5425; 
BgL_l1244z00_5415 = BgL_l1244z00_8425; 
goto BgL_zc3z04anonymousza32500ze3z87_5414;} } } } } } 
{ 
obj_t BgL_l1249z00_5427;
BgL_l1249z00_5427 = BgL_g1251z00_5411; 
BgL_zc3z04anonymousza32496ze3z87_5426:
if(
PAIRP(BgL_l1249z00_5427))
{ /* Llib/mpd.scm 1194 */
{ /* Llib/mpd.scm 1191 */
obj_t BgL_az00_5428;
BgL_az00_5428 = 
CAR(BgL_l1249z00_5427); 
{ /* Llib/mpd.scm 1191 */
obj_t BgL_tmpz00_8429;
BgL_tmpz00_8429 = 
((obj_t)BgL_opz00_4774); 
bgl_display_string(BGl_string2975z00zz__multimediazd2mpdzd2, BgL_tmpz00_8429); } 
{ /* Llib/mpd.scm 1192 */
obj_t BgL_arg2498z00_5429;
BgL_arg2498z00_5429 = 
CAR(
((obj_t)BgL_az00_5428)); 
bgl_display_obj(BgL_arg2498z00_5429, 
((obj_t)BgL_opz00_4774)); } 
{ /* Llib/mpd.scm 1193 */
obj_t BgL_tmpz00_8436;
BgL_tmpz00_8436 = 
((obj_t)BgL_opz00_4774); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8436); } } 
{ 
obj_t BgL_l1249z00_8439;
BgL_l1249z00_8439 = 
CDR(BgL_l1249z00_5427); 
BgL_l1249z00_5427 = BgL_l1249z00_8439; 
goto BgL_zc3z04anonymousza32496ze3z87_5426;} }  else 
{ /* Llib/mpd.scm 1194 */
BgL_tmpz00_8387 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8387);} } 

}



/* &mpd-database-listart1359 */
obj_t BGl_z62mpdzd2databasezd2listart1359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4776, obj_t BgL_oz00_4777, obj_t BgL_opz00_4778, obj_t BgL_artistz00_4779)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1180 */
bool_t BgL_tmpz00_8442;
{ /* Llib/mpd.scm 1180 */
obj_t BgL_g1242z00_5432;
BgL_g1242z00_5432 = 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4777), BgL_artistz00_4779); 
{ 
obj_t BgL_l1240z00_5434;
BgL_l1240z00_5434 = BgL_g1242z00_5432; 
BgL_zc3z04anonymousza32491ze3z87_5433:
if(
PAIRP(BgL_l1240z00_5434))
{ /* Llib/mpd.scm 1184 */
{ /* Llib/mpd.scm 1181 */
obj_t BgL_az00_5435;
BgL_az00_5435 = 
CAR(BgL_l1240z00_5434); 
{ /* Llib/mpd.scm 1181 */
obj_t BgL_tmpz00_8448;
BgL_tmpz00_8448 = 
((obj_t)BgL_opz00_4778); 
bgl_display_string(BGl_string2975z00zz__multimediazd2mpdzd2, BgL_tmpz00_8448); } 
{ /* Llib/mpd.scm 1182 */
obj_t BgL_arg2493z00_5436;
{ /* Llib/mpd.scm 1182 */
obj_t BgL_pairz00_5437;
BgL_pairz00_5437 = 
CDR(
((obj_t)BgL_az00_5435)); 
BgL_arg2493z00_5436 = 
CAR(BgL_pairz00_5437); } 
bgl_display_obj(BgL_arg2493z00_5436, 
((obj_t)BgL_opz00_4778)); } 
{ /* Llib/mpd.scm 1183 */
obj_t BgL_tmpz00_8456;
BgL_tmpz00_8456 = 
((obj_t)BgL_opz00_4778); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8456); } } 
{ 
obj_t BgL_l1240z00_8459;
BgL_l1240z00_8459 = 
CDR(BgL_l1240z00_5434); 
BgL_l1240z00_5434 = BgL_l1240z00_8459; 
goto BgL_zc3z04anonymousza32491ze3z87_5433;} }  else 
{ /* Llib/mpd.scm 1184 */
BgL_tmpz00_8442 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8442);} } 

}



/* &mpd-database-listalb1357 */
obj_t BGl_z62mpdzd2databasezd2listalb1357z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4780, obj_t BgL_oz00_4781, obj_t BgL_opz00_4782)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1169 */
bool_t BgL_tmpz00_8462;
{ /* Llib/mpd.scm 1169 */
obj_t BgL_g1239z00_5440;
BgL_g1239z00_5440 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4781)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1237z00_5442;
BgL_l1237z00_5442 = BgL_g1239z00_5440; 
BgL_zc3z04anonymousza32486ze3z87_5441:
if(
PAIRP(BgL_l1237z00_5442))
{ /* Llib/mpd.scm 1173 */
{ /* Llib/mpd.scm 1170 */
obj_t BgL_az00_5443;
BgL_az00_5443 = 
CAR(BgL_l1237z00_5442); 
{ /* Llib/mpd.scm 1170 */
obj_t BgL_tmpz00_8468;
BgL_tmpz00_8468 = 
((obj_t)BgL_opz00_4782); 
bgl_display_string(BGl_string2975z00zz__multimediazd2mpdzd2, BgL_tmpz00_8468); } 
{ /* Llib/mpd.scm 1171 */
obj_t BgL_arg2488z00_5444;
BgL_arg2488z00_5444 = 
CAR(
((obj_t)BgL_az00_5443)); 
bgl_display_obj(BgL_arg2488z00_5444, 
((obj_t)BgL_opz00_4782)); } 
{ /* Llib/mpd.scm 1172 */
obj_t BgL_tmpz00_8475;
BgL_tmpz00_8475 = 
((obj_t)BgL_opz00_4782); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8475); } } 
{ 
obj_t BgL_l1237z00_8478;
BgL_l1237z00_8478 = 
CDR(BgL_l1237z00_5442); 
BgL_l1237z00_5442 = BgL_l1237z00_8478; 
goto BgL_zc3z04anonymousza32486ze3z87_5441;} }  else 
{ /* Llib/mpd.scm 1173 */
BgL_tmpz00_8462 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8462);} } 

}



/* &mpd-database-listall1355 */
obj_t BGl_z62mpdzd2databasezd2listall1355z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4783, obj_t BgL_oz00_4784, obj_t BgL_opz00_4785)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1146 */
bool_t BgL_tmpz00_8481;
{ /* Llib/mpd.scm 1160 */
obj_t BgL_tmpz00_8482;
BgL_tmpz00_8482 = 
((obj_t)BgL_opz00_4785); 
bgl_display_string(BGl_string3082z00zz__multimediazd2mpdzd2, BgL_tmpz00_8482); } 
bgl_display_obj(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4784)))->BgL_z52basez52), 
((obj_t)BgL_opz00_4785)); 
{ /* Llib/mpd.scm 1162 */
obj_t BgL_tmpz00_8489;
BgL_tmpz00_8489 = 
((obj_t)BgL_opz00_4785); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8489); } 
{ /* Llib/mpd.scm 1163 */
obj_t BgL_g1236z00_5450;
BgL_g1236z00_5450 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4784)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1234z00_5452;
BgL_l1234z00_5452 = BgL_g1236z00_5450; 
BgL_zc3z04anonymousza32472ze3z87_5451:
if(
PAIRP(BgL_l1234z00_5452))
{ /* Llib/mpd.scm 1163 */
{ /* Llib/mpd.scm 1163 */
obj_t BgL_pathz00_5455;
BgL_pathz00_5455 = 
CAR(BgL_l1234z00_5452); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4784), 
((obj_t)BgL_opz00_4785), BgL_pathz00_5455); } 
{ 
obj_t BgL_l1234z00_8500;
BgL_l1234z00_8500 = 
CDR(BgL_l1234z00_5452); 
BgL_l1234z00_5452 = BgL_l1234z00_8500; 
goto BgL_zc3z04anonymousza32472ze3z87_5451;} }  else 
{ /* Llib/mpd.scm 1163 */
BgL_tmpz00_8481 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8481);} } 

}



/* loop~0 */
obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_4871, obj_t BgL_opz00_4870, obj_t BgL_pathz00_1888)
{
{ /* Llib/mpd.scm 1145 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_1888)))
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3082z00zz__multimediazd2mpdzd2, BgL_opz00_4870); 
{ /* Llib/mpd.scm 1149 */
obj_t BgL_arg2479z00_1891;
BgL_arg2479z00_1891 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1888, 
((obj_t)BgL_oz00_4871)); 
bgl_display_obj(BgL_arg2479z00_1891, BgL_opz00_4870); } 
bgl_display_char(((unsigned char)10), BgL_opz00_4870); 
{ /* Llib/mpd.scm 1151 */
obj_t BgL_g1233z00_1892;
BgL_g1233z00_1892 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_1888); 
{ 
obj_t BgL_l1231z00_1894;
{ /* Llib/mpd.scm 1153 */
bool_t BgL_tmpz00_8512;
BgL_l1231z00_1894 = BgL_g1233z00_1892; 
BgL_zc3z04anonymousza32480ze3z87_1895:
if(
PAIRP(BgL_l1231z00_1894))
{ /* Llib/mpd.scm 1153 */
{ /* Llib/mpd.scm 1152 */
obj_t BgL_fz00_1897;
BgL_fz00_1897 = 
CAR(BgL_l1231z00_1894); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_oz00_4871, BgL_opz00_4870, 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_1888, BgL_fz00_1897)); } 
{ 
obj_t BgL_l1231z00_8518;
BgL_l1231z00_8518 = 
CDR(BgL_l1231z00_1894); 
BgL_l1231z00_1894 = BgL_l1231z00_8518; 
goto BgL_zc3z04anonymousza32480ze3z87_1895;} }  else 
{ /* Llib/mpd.scm 1153 */
BgL_tmpz00_8512 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_8512);} } } }  else 
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string2970z00zz__multimediazd2mpdzd2, BgL_opz00_4870); 
{ /* Llib/mpd.scm 1156 */
obj_t BgL_arg2484z00_1901;
BgL_arg2484z00_1901 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1888, 
((obj_t)BgL_oz00_4871)); 
bgl_display_obj(BgL_arg2484z00_1901, BgL_opz00_4870); } 
return 
bgl_display_char(((unsigned char)10), BgL_opz00_4870);} } 

}



/* &mpd-database-stats1353 */
obj_t BGl_z62mpdzd2databasezd2stats1353z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4786, obj_t BgL_oz00_4787, obj_t BgL_backendz00_4788, obj_t BgL_opz00_4789)
{
{ /* Llib/mpd.scm 1108 */
{ 

{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2445z00_5463;int BgL_arg2446z00_5464;int BgL_arg2447z00_5465;long BgL_arg2448z00_5466;obj_t BgL_arg2449z00_5467;long BgL_arg2450z00_5468;
BgL_arg2445z00_5463 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787)))->BgL_z52nartistsz52); 
BgL_arg2446z00_5464 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787)))->BgL_z52nalbumsz52); 
BgL_arg2447z00_5465 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787)))->BgL_z52nsongsz52); 
{ /* Llib/mpd.scm 1135 */
long BgL_arg2457z00_5469;
{ /* Llib/mpd.scm 1135 */
long BgL_arg2458z00_5470;obj_t BgL_arg2459z00_5471;
BgL_arg2458z00_5470 = 
bgl_current_seconds(); 
BgL_arg2459z00_5471 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787)))->BgL_z52uptimez52); 
{ /* Llib/mpd.scm 1135 */
long BgL_res2727z00_5472;
{ /* Llib/mpd.scm 1135 */
long BgL_za72za7_5473;
BgL_za72za7_5473 = 
BELONG_TO_LONG(BgL_arg2459z00_5471); 
{ /* Llib/mpd.scm 1135 */
long BgL_tmpz00_8536;
BgL_tmpz00_8536 = 
(BgL_arg2458z00_5470-BgL_za72za7_5473); 
BgL_res2727z00_5472 = 
(long)(BgL_tmpz00_8536); } } 
BgL_arg2457z00_5469 = BgL_res2727z00_5472; } } 
BgL_arg2448z00_5466 = 
(long)(BgL_arg2457z00_5469); } 
{ /* Llib/mpd.scm 1111 */
obj_t BgL_plistz00_5458;int BgL_numz00_5459;
BgL_plistz00_5458 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4788)); 
BgL_numz00_5459 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4788)); 
{ /* Llib/mpd.scm 1113 */
bool_t BgL_test3643z00_8544;
if(
(
(long)(BgL_numz00_5459)>=((long)0)))
{ /* Llib/mpd.scm 1113 */
BgL_test3643z00_8544 = 
(
(long)(BgL_numz00_5459)<
bgl_list_length(BgL_plistz00_5458))
; }  else 
{ /* Llib/mpd.scm 1113 */
BgL_test3643z00_8544 = ((bool_t)0)
; } 
if(BgL_test3643z00_8544)
{ /* Llib/mpd.scm 1114 */
obj_t BgL_filez00_5460;
BgL_filez00_5460 = 
bgl_list_ref(BgL_plistz00_5458, 
(long)(BgL_numz00_5459)); 
{ /* Llib/mpd.scm 1114 */
obj_t BgL_pathz00_5461;
if(
bigloo_strcmp_at(BgL_filez00_5460, BGl_string2967z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5461 = BgL_filez00_5460; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5461 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_5460, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787))); } 
{ /* Llib/mpd.scm 1115 */

if(
fexists(
BSTRING_TO_STRING(BgL_filez00_5460)))
{ /* Llib/mpd.scm 1117 */
obj_t BgL_infoz00_5462;
BgL_infoz00_5462 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_5460); 
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_5462, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1118 */
BgL_arg2449z00_5467 = 
BINT(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_5462)))->BgL_durationz00)); }  else 
{ /* Llib/mpd.scm 1118 */
BgL_arg2449z00_5467 = 
BINT(((long)1000000)); } }  else 
{ /* Llib/mpd.scm 1116 */
BgL_arg2449z00_5467 = 
BINT(((long)1000000)); } } } }  else 
{ /* Llib/mpd.scm 1113 */
BgL_arg2449z00_5467 = BFALSE; } } } 
{ /* Llib/mpd.scm 1137 */
long BgL_arg2460z00_5474;
{ /* Llib/mpd.scm 1137 */
long BgL_arg2461z00_5475;obj_t BgL_arg2462z00_5476;
BgL_arg2461z00_5475 = 
bgl_current_seconds(); 
BgL_arg2462z00_5476 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4787)))->BgL_z52dbzd2updatez80); 
{ /* Llib/mpd.scm 1137 */
long BgL_res2728z00_5477;
{ /* Llib/mpd.scm 1137 */
long BgL_za72za7_5478;
BgL_za72za7_5478 = 
BELONG_TO_LONG(BgL_arg2462z00_5476); 
{ /* Llib/mpd.scm 1137 */
long BgL_tmpz00_8573;
BgL_tmpz00_8573 = 
(BgL_arg2461z00_5475-BgL_za72za7_5478); 
BgL_res2728z00_5477 = 
(long)(BgL_tmpz00_8573); } } 
BgL_arg2460z00_5474 = BgL_res2728z00_5477; } } 
BgL_arg2450z00_5468 = 
(long)(BgL_arg2460z00_5474); } 
{ /* Llib/mpd.scm 1125 */
obj_t BgL_list2451z00_5479;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2452z00_5480;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2453z00_5481;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2454z00_5482;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2455z00_5483;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2456z00_5484;
BgL_arg2456z00_5484 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2450z00_5468), BNIL); 
BgL_arg2455z00_5483 = 
MAKE_YOUNG_PAIR(BgL_arg2449z00_5467, BgL_arg2456z00_5484); } 
BgL_arg2454z00_5482 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2448z00_5466), BgL_arg2455z00_5483); } 
BgL_arg2453z00_5481 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2447z00_5465), BgL_arg2454z00_5482); } 
BgL_arg2452z00_5480 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2446z00_5464), BgL_arg2453z00_5481); } 
BgL_list2451z00_5479 = 
MAKE_YOUNG_PAIR(BgL_arg2445z00_5463, BgL_arg2452z00_5480); } 
return 
BGl_fprintfz00zz__r4_output_6_10_3z00(BgL_opz00_4789, BGl_string3085z00zz__multimediazd2mpdzd2, BgL_list2451z00_5479);} } } } 

}



/* &mpd-database-file->p1351 */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1351z53zz__multimediazd2mpdzd2(obj_t BgL_envz00_4790, obj_t BgL_oz00_4791, obj_t BgL_filez00_4792)
{
{ /* Llib/mpd.scm 1095 */
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4791)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 1097 */
return 
((obj_t)BgL_filez00_4792);}  else 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_dirz00_5487;
{ /* Llib/mpd.scm 1099 */
obj_t BgL_arg2442z00_5488;
BgL_arg2442z00_5488 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
((obj_t)BgL_filez00_4792)); 
BgL_dirz00_5487 = 
CAR(
((obj_t)BgL_arg2442z00_5488)); } 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_nz00_5489;
{ /* Llib/mpd.scm 1100 */
obj_t BgL_arg2440z00_5490;
BgL_arg2440z00_5490 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4791)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1100 */

BgL_nz00_5489 = 
BGl_stringzd2containszd2zz__r4_strings_6_7z00(BgL_arg2440z00_5490, BgL_dirz00_5487, 
(int)(((long)0))); } } 
{ /* Llib/mpd.scm 1100 */

if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_nz00_5489))
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2437z00_5491;
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2438z00_5492;
BgL_arg2438z00_5492 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4791)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1102 */
long BgL_endz00_5493;
BgL_endz00_5493 = 
(long)CINT(BgL_nz00_5489); 
BgL_arg2437z00_5491 = 
c_substring(
((obj_t)BgL_arg2438z00_5492), ((long)0), BgL_endz00_5493); } } 
return 
string_append(BgL_arg2437z00_5491, 
((obj_t)BgL_filez00_4792));}  else 
{ /* Llib/mpd.scm 1101 */
return 
((obj_t)BgL_filez00_4792);} } } } } 

}



/* &mpd-database-init!1349 */
obj_t BGl_z62mpdzd2databasezd2initz121349z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_4793, obj_t BgL_oz00_4794)
{
{ /* Llib/mpd.scm 956 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8613;
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 962 */BFALSE; }  else 
{ /* Llib/mpd.scm 962 */
if(
NULLP(
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00))))
{ 
obj_t BgL_auxz00_8623;
{ /* Llib/mpd.scm 964 */
obj_t BgL_pairz00_5497;
BgL_pairz00_5497 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00); 
BgL_auxz00_8623 = 
CAR(BgL_pairz00_5497); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8623),BUNSPEC); }  else 
{ /* Llib/mpd.scm 965 */
obj_t BgL_g1139z00_5498;obj_t BgL_g1140z00_5499;
BgL_g1139z00_5498 = 
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00)); 
BgL_g1140z00_5499 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00))); 
{ 
obj_t BgL_dirsz00_5501;obj_t BgL_lz00_5502;
BgL_dirsz00_5501 = BgL_g1139z00_5498; 
BgL_lz00_5502 = BgL_g1140z00_5499; 
BgL_loopz00_5500:
if(
NULLP(BgL_dirsz00_5501))
{ 
obj_t BgL_auxz00_8638;
{ /* Llib/mpd.scm 968 */
obj_t BgL_runner2414z00_5503;
BgL_runner2414z00_5503 = BgL_lz00_5502; 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2412z00_5504;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5505;
BgL_pairz00_5505 = BgL_runner2414z00_5503; 
BgL_aux2412z00_5504 = 
CAR(BgL_pairz00_5505); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5506;
BgL_pairz00_5506 = BgL_runner2414z00_5503; 
BgL_runner2414z00_5503 = 
CDR(BgL_pairz00_5506); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2413z00_5507;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5508;
BgL_pairz00_5508 = BgL_runner2414z00_5503; 
BgL_aux2413z00_5507 = 
CAR(BgL_pairz00_5508); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5509;
BgL_pairz00_5509 = BgL_runner2414z00_5503; 
BgL_runner2414z00_5503 = 
CDR(BgL_pairz00_5509); } 
BgL_auxz00_8638 = 
BGl_makezd2filezd2pathz00zz__osz00(BgL_aux2412z00_5504, BgL_aux2413z00_5507, BgL_runner2414z00_5503); } } } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52basez52)=((obj_t)BgL_auxz00_8638),BUNSPEC); }  else 
{ /* Llib/mpd.scm 969 */
obj_t BgL_nlz00_5510;
BgL_nlz00_5510 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
BGl_dirnamez00zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00)))); 
{ /* Llib/mpd.scm 970 */
obj_t BgL_arg2415z00_5511;obj_t BgL_arg2416z00_5512;
BgL_arg2415z00_5511 = 
CDR(
((obj_t)BgL_dirsz00_5501)); 
BgL_arg2416z00_5512 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_lz00_5502, BgL_nlz00_5510); 
{ 
obj_t BgL_lz00_8655;obj_t BgL_dirsz00_8654;
BgL_dirsz00_8654 = BgL_arg2415z00_5511; 
BgL_lz00_8655 = BgL_arg2416z00_5512; 
BgL_lz00_5502 = BgL_lz00_8655; 
BgL_dirsz00_5501 = BgL_dirsz00_8654; 
goto BgL_loopz00_5500;} } } } } } 
{ 
obj_t BgL_auxz00_8656;
{ /* Llib/mpd.scm 972 */
long BgL_arg2426z00_5515;long BgL_arg2427z00_5516;
BgL_arg2426z00_5515 = 
bgl_current_seconds(); 
{ /* Llib/mpd.scm 972 */
obj_t BgL_arg2428z00_5517;
BgL_arg2428z00_5517 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3086z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
BgL_arg2427z00_5516 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2428z00_5517)); } 
BgL_auxz00_8656 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2426z00_5515), 
make_belong(BgL_arg2427z00_5516)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_auxz00_8656),BUNSPEC); } 
{ 
obj_t BgL_auxz00_8673;
{ /* Llib/mpd.scm 973 */
long BgL_arg2429z00_5518;long BgL_arg2430z00_5519;
BgL_arg2429z00_5518 = 
bgl_current_seconds(); 
{ /* Llib/mpd.scm 973 */
obj_t BgL_arg2431z00_5520;
BgL_arg2431z00_5520 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3086z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
BgL_arg2430z00_5519 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2431z00_5520)); } 
BgL_auxz00_8673 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2429z00_5518), 
make_belong(BgL_arg2430z00_5519)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52uptimez52)=((obj_t)BgL_auxz00_8673),BUNSPEC); } 
{ /* Llib/mpd.scm 975 */
obj_t BgL_artistsz00_5521;
BgL_artistsz00_5521 = 
BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 976 */
obj_t BgL_albumsz00_5522;obj_t BgL_genresz00_5523;obj_t BgL_nsongz00_5524;
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8694;
BgL_tmpz00_8694 = 
(int)(((long)1)); 
BgL_albumsz00_5522 = 
BGL_MVALUES_VAL(BgL_tmpz00_8694); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8697;
BgL_tmpz00_8697 = 
(int)(((long)2)); 
BgL_genresz00_5523 = 
BGL_MVALUES_VAL(BgL_tmpz00_8697); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_8700;
BgL_tmpz00_8700 = 
(int)(((long)3)); 
BgL_nsongz00_5524 = 
BGL_MVALUES_VAL(BgL_tmpz00_8700); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52artistsz52)=((obj_t)BgL_artistsz00_5521),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52nartistsz52)=((obj_t)
BINT(
bgl_list_length(BgL_artistsz00_5521))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52albumsz52)=((obj_t)BgL_albumsz00_5522),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52genresz52)=((obj_t)BgL_genresz00_5523),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52nalbumsz52)=((int)
(int)(
bgl_list_length(BgL_albumsz00_5522))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794)))->BgL_z52nsongsz52)=((int)
CINT(BgL_nsongz00_5524)),BUNSPEC); } } 
BgL_auxz00_8613 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4794); 
return 
((obj_t)BgL_auxz00_8613);} } 

}



/* mpd-database-init! */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_331)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
obj_t BgL_method1350z00_2378;
{ /* Llib/mpd.scm 956 */
obj_t BgL_res2733z00_3549;
{ /* Llib/mpd.scm 956 */
long BgL_objzd2classzd2numz00_3520;
BgL_objzd2classzd2numz00_3520 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_331)); 
{ /* Llib/mpd.scm 956 */
obj_t BgL_arg1765z00_3521;
BgL_arg1765z00_3521 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 956 */
int BgL_offsetz00_3524;
BgL_offsetz00_3524 = 
(int)(BgL_objzd2classzd2numz00_3520); 
{ /* Llib/mpd.scm 956 */
long BgL_offsetz00_3525;
BgL_offsetz00_3525 = 
(
(long)(BgL_offsetz00_3524)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 956 */
long BgL_modz00_3526;
BgL_modz00_3526 = 
(BgL_offsetz00_3525 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 956 */
long BgL_restz00_3528;
BgL_restz00_3528 = 
(BgL_offsetz00_3525 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 956 */

{ /* Llib/mpd.scm 956 */
obj_t BgL_bucketz00_3530;
BgL_bucketz00_3530 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3521),BgL_modz00_3526); 
BgL_res2733z00_3549 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3530),BgL_restz00_3528); } } } } } } } } 
BgL_method1350z00_2378 = BgL_res2733z00_3549; } 
return 
PROCEDURE_ENTRY(BgL_method1350z00_2378)(BgL_method1350z00_2378, 
((obj_t)BgL_oz00_331), BEOA);} } 

}



/* &mpd-database-init! */
obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_4686, obj_t BgL_oz00_4687)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8752;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4687, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 956 */
BgL_auxz00_8752 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4687)
; }  else 
{ 
obj_t BgL_auxz00_8756;
BgL_auxz00_8756 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)37998)), BGl_string3087z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4687); 
FAILURE(BgL_auxz00_8756,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_auxz00_8752);} } 

}



/* mpd-database-file->path */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_349, obj_t BgL_filez00_350)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_method1352z00_2379;
{ /* Llib/mpd.scm 1095 */
obj_t BgL_res2738z00_3580;
{ /* Llib/mpd.scm 1095 */
long BgL_objzd2classzd2numz00_3551;
BgL_objzd2classzd2numz00_3551 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_349)); 
{ /* Llib/mpd.scm 1095 */
obj_t BgL_arg1765z00_3552;
BgL_arg1765z00_3552 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1095 */
int BgL_offsetz00_3555;
BgL_offsetz00_3555 = 
(int)(BgL_objzd2classzd2numz00_3551); 
{ /* Llib/mpd.scm 1095 */
long BgL_offsetz00_3556;
BgL_offsetz00_3556 = 
(
(long)(BgL_offsetz00_3555)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1095 */
long BgL_modz00_3557;
BgL_modz00_3557 = 
(BgL_offsetz00_3556 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1095 */
long BgL_restz00_3559;
BgL_restz00_3559 = 
(BgL_offsetz00_3556 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1095 */

{ /* Llib/mpd.scm 1095 */
obj_t BgL_bucketz00_3561;
BgL_bucketz00_3561 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3552),BgL_modz00_3557); 
BgL_res2738z00_3580 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3561),BgL_restz00_3559); } } } } } } } } 
BgL_method1352z00_2379 = BgL_res2738z00_3580; } 
return 
PROCEDURE_ENTRY(BgL_method1352z00_2379)(BgL_method1352z00_2379, 
((obj_t)BgL_oz00_349), BgL_filez00_350, BEOA);} } 

}



/* &mpd-database-file->path */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t BgL_envz00_4795, obj_t BgL_oz00_4796, obj_t BgL_filez00_4797)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_auxz00_8800;BgL_mpdzd2databasezd2_bglt BgL_auxz00_8792;
if(
STRINGP(BgL_filez00_4797))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_8800 = BgL_filez00_4797
; }  else 
{ 
obj_t BgL_auxz00_8803;
BgL_auxz00_8803 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3088z00zz__multimediazd2mpdzd2, BGl_string3089z00zz__multimediazd2mpdzd2, BgL_filez00_4797); 
FAILURE(BgL_auxz00_8803,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4796, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_8792 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4796)
; }  else 
{ 
obj_t BgL_auxz00_8796;
BgL_auxz00_8796 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3088z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4796); 
FAILURE(BgL_auxz00_8796,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_auxz00_8792, BgL_auxz00_8800);} } 

}



/* mpd-database-stats */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_351, obj_t BgL_backendz00_352, obj_t BgL_opz00_353)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
obj_t BgL_method1354z00_2380;
{ /* Llib/mpd.scm 1108 */
obj_t BgL_res2743z00_3611;
{ /* Llib/mpd.scm 1108 */
long BgL_objzd2classzd2numz00_3582;
BgL_objzd2classzd2numz00_3582 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_351)); 
{ /* Llib/mpd.scm 1108 */
obj_t BgL_arg1765z00_3583;
BgL_arg1765z00_3583 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1108 */
int BgL_offsetz00_3586;
BgL_offsetz00_3586 = 
(int)(BgL_objzd2classzd2numz00_3582); 
{ /* Llib/mpd.scm 1108 */
long BgL_offsetz00_3587;
BgL_offsetz00_3587 = 
(
(long)(BgL_offsetz00_3586)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1108 */
long BgL_modz00_3588;
BgL_modz00_3588 = 
(BgL_offsetz00_3587 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1108 */
long BgL_restz00_3590;
BgL_restz00_3590 = 
(BgL_offsetz00_3587 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1108 */

{ /* Llib/mpd.scm 1108 */
obj_t BgL_bucketz00_3592;
BgL_bucketz00_3592 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3583),BgL_modz00_3588); 
BgL_res2743z00_3611 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3592),BgL_restz00_3590); } } } } } } } } 
BgL_method1354z00_2380 = BgL_res2743z00_3611; } 
return 
PROCEDURE_ENTRY(BgL_method1354z00_2380)(BgL_method1354z00_2380, 
((obj_t)BgL_oz00_351), BgL_backendz00_352, BgL_opz00_353, BEOA);} } 

}



/* &mpd-database-stats */
obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4798, obj_t BgL_oz00_4799, obj_t BgL_backendz00_4800, obj_t BgL_opz00_4801)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8840;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4799, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1108 */
BgL_auxz00_8840 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4799)
; }  else 
{ 
obj_t BgL_auxz00_8844;
BgL_auxz00_8844 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)44204)), BGl_string3090z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4799); 
FAILURE(BgL_auxz00_8844,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_auxz00_8840, BgL_backendz00_4800, BgL_opz00_4801);} } 

}



/* mpd-database-listall */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_354, obj_t BgL_opz00_355)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_method1356z00_2381;
{ /* Llib/mpd.scm 1142 */
obj_t BgL_res2748z00_3642;
{ /* Llib/mpd.scm 1142 */
long BgL_objzd2classzd2numz00_3613;
BgL_objzd2classzd2numz00_3613 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_354)); 
{ /* Llib/mpd.scm 1142 */
obj_t BgL_arg1765z00_3614;
BgL_arg1765z00_3614 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1142 */
int BgL_offsetz00_3617;
BgL_offsetz00_3617 = 
(int)(BgL_objzd2classzd2numz00_3613); 
{ /* Llib/mpd.scm 1142 */
long BgL_offsetz00_3618;
BgL_offsetz00_3618 = 
(
(long)(BgL_offsetz00_3617)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1142 */
long BgL_modz00_3619;
BgL_modz00_3619 = 
(BgL_offsetz00_3618 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1142 */
long BgL_restz00_3621;
BgL_restz00_3621 = 
(BgL_offsetz00_3618 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1142 */

{ /* Llib/mpd.scm 1142 */
obj_t BgL_bucketz00_3623;
BgL_bucketz00_3623 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3614),BgL_modz00_3619); 
BgL_res2748z00_3642 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3623),BgL_restz00_3621); } } } } } } } } 
BgL_method1356z00_2381 = BgL_res2748z00_3642; } 
return 
PROCEDURE_ENTRY(BgL_method1356z00_2381)(BgL_method1356z00_2381, 
((obj_t)BgL_oz00_354), BgL_opz00_355, BEOA);} } 

}



/* &mpd-database-listall */
obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4802, obj_t BgL_oz00_4803, obj_t BgL_opz00_4804)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_auxz00_8888;BgL_mpdzd2databasezd2_bglt BgL_auxz00_8880;
if(
OUTPUT_PORTP(BgL_opz00_4804))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_8888 = BgL_opz00_4804
; }  else 
{ 
obj_t BgL_auxz00_8891;
BgL_auxz00_8891 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3091z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4804); 
FAILURE(BgL_auxz00_8891,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4803, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_8880 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4803)
; }  else 
{ 
obj_t BgL_auxz00_8884;
BgL_auxz00_8884 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3091z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4803); 
FAILURE(BgL_auxz00_8884,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_auxz00_8880, BgL_auxz00_8888);} } 

}



/* mpd-database-listalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_356, obj_t BgL_opz00_357)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_method1358z00_2382;
{ /* Llib/mpd.scm 1168 */
obj_t BgL_res2753z00_3673;
{ /* Llib/mpd.scm 1168 */
long BgL_objzd2classzd2numz00_3644;
BgL_objzd2classzd2numz00_3644 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_356)); 
{ /* Llib/mpd.scm 1168 */
obj_t BgL_arg1765z00_3645;
BgL_arg1765z00_3645 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1168 */
int BgL_offsetz00_3648;
BgL_offsetz00_3648 = 
(int)(BgL_objzd2classzd2numz00_3644); 
{ /* Llib/mpd.scm 1168 */
long BgL_offsetz00_3649;
BgL_offsetz00_3649 = 
(
(long)(BgL_offsetz00_3648)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1168 */
long BgL_modz00_3650;
BgL_modz00_3650 = 
(BgL_offsetz00_3649 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1168 */
long BgL_restz00_3652;
BgL_restz00_3652 = 
(BgL_offsetz00_3649 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1168 */

{ /* Llib/mpd.scm 1168 */
obj_t BgL_bucketz00_3654;
BgL_bucketz00_3654 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3645),BgL_modz00_3650); 
BgL_res2753z00_3673 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3654),BgL_restz00_3652); } } } } } } } } 
BgL_method1358z00_2382 = BgL_res2753z00_3673; } 
return 
PROCEDURE_ENTRY(BgL_method1358z00_2382)(BgL_method1358z00_2382, 
((obj_t)BgL_oz00_356), BgL_opz00_357, BEOA);} } 

}



/* &mpd-database-listalbum */
obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4805, obj_t BgL_oz00_4806, obj_t BgL_opz00_4807)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_auxz00_8935;BgL_mpdzd2databasezd2_bglt BgL_auxz00_8927;
if(
OUTPUT_PORTP(BgL_opz00_4807))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_8935 = BgL_opz00_4807
; }  else 
{ 
obj_t BgL_auxz00_8938;
BgL_auxz00_8938 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3092z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4807); 
FAILURE(BgL_auxz00_8938,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4806, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_8927 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4806)
; }  else 
{ 
obj_t BgL_auxz00_8931;
BgL_auxz00_8931 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3092z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4806); 
FAILURE(BgL_auxz00_8931,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_8927, BgL_auxz00_8935);} } 

}



/* mpd-database-listartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_358, obj_t BgL_opz00_359, obj_t BgL_artistz00_360)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_method1360z00_2383;
{ /* Llib/mpd.scm 1179 */
obj_t BgL_res2758z00_3704;
{ /* Llib/mpd.scm 1179 */
long BgL_objzd2classzd2numz00_3675;
BgL_objzd2classzd2numz00_3675 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_358)); 
{ /* Llib/mpd.scm 1179 */
obj_t BgL_arg1765z00_3676;
BgL_arg1765z00_3676 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1179 */
int BgL_offsetz00_3679;
BgL_offsetz00_3679 = 
(int)(BgL_objzd2classzd2numz00_3675); 
{ /* Llib/mpd.scm 1179 */
long BgL_offsetz00_3680;
BgL_offsetz00_3680 = 
(
(long)(BgL_offsetz00_3679)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1179 */
long BgL_modz00_3681;
BgL_modz00_3681 = 
(BgL_offsetz00_3680 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1179 */
long BgL_restz00_3683;
BgL_restz00_3683 = 
(BgL_offsetz00_3680 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1179 */

{ /* Llib/mpd.scm 1179 */
obj_t BgL_bucketz00_3685;
BgL_bucketz00_3685 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3676),BgL_modz00_3681); 
BgL_res2758z00_3704 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3685),BgL_restz00_3683); } } } } } } } } 
BgL_method1360z00_2383 = BgL_res2758z00_3704; } 
return 
PROCEDURE_ENTRY(BgL_method1360z00_2383)(BgL_method1360z00_2383, 
((obj_t)BgL_oz00_358), BgL_opz00_359, BgL_artistz00_360, BEOA);} } 

}



/* &mpd-database-listartistalbum */
obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4808, obj_t BgL_oz00_4809, obj_t BgL_opz00_4810, obj_t BgL_artistz00_4811)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_auxz00_8983;BgL_mpdzd2databasezd2_bglt BgL_auxz00_8975;
if(
OUTPUT_PORTP(BgL_opz00_4810))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_8983 = BgL_opz00_4810
; }  else 
{ 
obj_t BgL_auxz00_8986;
BgL_auxz00_8986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3093z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4810); 
FAILURE(BgL_auxz00_8986,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4809, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_8975 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4809)
; }  else 
{ 
obj_t BgL_auxz00_8979;
BgL_auxz00_8979 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3093z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4809); 
FAILURE(BgL_auxz00_8979,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_8975, BgL_auxz00_8983, BgL_artistz00_4811);} } 

}



/* mpd-database-listgenrealbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_361, obj_t BgL_opz00_362, obj_t BgL_genrez00_363)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_method1362z00_2384;
{ /* Llib/mpd.scm 1189 */
obj_t BgL_res2763z00_3735;
{ /* Llib/mpd.scm 1189 */
long BgL_objzd2classzd2numz00_3706;
BgL_objzd2classzd2numz00_3706 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_361)); 
{ /* Llib/mpd.scm 1189 */
obj_t BgL_arg1765z00_3707;
BgL_arg1765z00_3707 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1189 */
int BgL_offsetz00_3710;
BgL_offsetz00_3710 = 
(int)(BgL_objzd2classzd2numz00_3706); 
{ /* Llib/mpd.scm 1189 */
long BgL_offsetz00_3711;
BgL_offsetz00_3711 = 
(
(long)(BgL_offsetz00_3710)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1189 */
long BgL_modz00_3712;
BgL_modz00_3712 = 
(BgL_offsetz00_3711 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1189 */
long BgL_restz00_3714;
BgL_restz00_3714 = 
(BgL_offsetz00_3711 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1189 */

{ /* Llib/mpd.scm 1189 */
obj_t BgL_bucketz00_3716;
BgL_bucketz00_3716 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3707),BgL_modz00_3712); 
BgL_res2763z00_3735 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3716),BgL_restz00_3714); } } } } } } } } 
BgL_method1362z00_2384 = BgL_res2763z00_3735; } 
return 
PROCEDURE_ENTRY(BgL_method1362z00_2384)(BgL_method1362z00_2384, 
((obj_t)BgL_oz00_361), BgL_opz00_362, BgL_genrez00_363, BEOA);} } 

}



/* &mpd-database-listgenrealbum */
obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4812, obj_t BgL_oz00_4813, obj_t BgL_opz00_4814, obj_t BgL_genrez00_4815)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_auxz00_9031;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9023;
if(
OUTPUT_PORTP(BgL_opz00_4814))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9031 = BgL_opz00_4814
; }  else 
{ 
obj_t BgL_auxz00_9034;
BgL_auxz00_9034 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3094z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4814); 
FAILURE(BgL_auxz00_9034,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4813, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9023 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4813)
; }  else 
{ 
obj_t BgL_auxz00_9027;
BgL_auxz00_9027 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3094z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4813); 
FAILURE(BgL_auxz00_9027,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9023, BgL_auxz00_9031, BgL_genrez00_4815);} } 

}



/* mpd-database-listgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_364, obj_t BgL_opz00_365, obj_t BgL_genrez00_366)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_method1364z00_2385;
{ /* Llib/mpd.scm 1203 */
obj_t BgL_res2768z00_3766;
{ /* Llib/mpd.scm 1203 */
long BgL_objzd2classzd2numz00_3737;
BgL_objzd2classzd2numz00_3737 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_364)); 
{ /* Llib/mpd.scm 1203 */
obj_t BgL_arg1765z00_3738;
BgL_arg1765z00_3738 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1203 */
int BgL_offsetz00_3741;
BgL_offsetz00_3741 = 
(int)(BgL_objzd2classzd2numz00_3737); 
{ /* Llib/mpd.scm 1203 */
long BgL_offsetz00_3742;
BgL_offsetz00_3742 = 
(
(long)(BgL_offsetz00_3741)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1203 */
long BgL_modz00_3743;
BgL_modz00_3743 = 
(BgL_offsetz00_3742 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1203 */
long BgL_restz00_3745;
BgL_restz00_3745 = 
(BgL_offsetz00_3742 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1203 */

{ /* Llib/mpd.scm 1203 */
obj_t BgL_bucketz00_3747;
BgL_bucketz00_3747 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3738),BgL_modz00_3743); 
BgL_res2768z00_3766 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3747),BgL_restz00_3745); } } } } } } } } 
BgL_method1364z00_2385 = BgL_res2768z00_3766; } 
return 
PROCEDURE_ENTRY(BgL_method1364z00_2385)(BgL_method1364z00_2385, 
((obj_t)BgL_oz00_364), BgL_opz00_365, BgL_genrez00_366, BEOA);} } 

}



/* &mpd-database-listgenreartist */
obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4816, obj_t BgL_oz00_4817, obj_t BgL_opz00_4818, obj_t BgL_genrez00_4819)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_auxz00_9079;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9071;
if(
OUTPUT_PORTP(BgL_opz00_4818))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9079 = BgL_opz00_4818
; }  else 
{ 
obj_t BgL_auxz00_9082;
BgL_auxz00_9082 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3095z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4818); 
FAILURE(BgL_auxz00_9082,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4817, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9071 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4817)
; }  else 
{ 
obj_t BgL_auxz00_9075;
BgL_auxz00_9075 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3095z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4817); 
FAILURE(BgL_auxz00_9075,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9071, BgL_auxz00_9079, BgL_genrez00_4819);} } 

}



/* mpd-database-listgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_367, obj_t BgL_opz00_368)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_method1366z00_2386;
{ /* Llib/mpd.scm 1213 */
obj_t BgL_res2773z00_3797;
{ /* Llib/mpd.scm 1213 */
long BgL_objzd2classzd2numz00_3768;
BgL_objzd2classzd2numz00_3768 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_367)); 
{ /* Llib/mpd.scm 1213 */
obj_t BgL_arg1765z00_3769;
BgL_arg1765z00_3769 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1213 */
int BgL_offsetz00_3772;
BgL_offsetz00_3772 = 
(int)(BgL_objzd2classzd2numz00_3768); 
{ /* Llib/mpd.scm 1213 */
long BgL_offsetz00_3773;
BgL_offsetz00_3773 = 
(
(long)(BgL_offsetz00_3772)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1213 */
long BgL_modz00_3774;
BgL_modz00_3774 = 
(BgL_offsetz00_3773 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1213 */
long BgL_restz00_3776;
BgL_restz00_3776 = 
(BgL_offsetz00_3773 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1213 */

{ /* Llib/mpd.scm 1213 */
obj_t BgL_bucketz00_3778;
BgL_bucketz00_3778 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3769),BgL_modz00_3774); 
BgL_res2773z00_3797 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3778),BgL_restz00_3776); } } } } } } } } 
BgL_method1366z00_2386 = BgL_res2773z00_3797; } 
return 
PROCEDURE_ENTRY(BgL_method1366z00_2386)(BgL_method1366z00_2386, 
((obj_t)BgL_oz00_367), BgL_opz00_368, BEOA);} } 

}



/* &mpd-database-listgenre */
obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4820, obj_t BgL_oz00_4821, obj_t BgL_opz00_4822)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_auxz00_9126;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9118;
if(
OUTPUT_PORTP(BgL_opz00_4822))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9126 = BgL_opz00_4822
; }  else 
{ 
obj_t BgL_auxz00_9129;
BgL_auxz00_9129 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3096z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4822); 
FAILURE(BgL_auxz00_9129,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4821, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9118 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4821)
; }  else 
{ 
obj_t BgL_auxz00_9122;
BgL_auxz00_9122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3096z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4821); 
FAILURE(BgL_auxz00_9122,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9118, BgL_auxz00_9126);} } 

}



/* mpd-database-listartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_369, obj_t BgL_opz00_370)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_method1368z00_2387;
{ /* Llib/mpd.scm 1223 */
obj_t BgL_res2778z00_3828;
{ /* Llib/mpd.scm 1223 */
long BgL_objzd2classzd2numz00_3799;
BgL_objzd2classzd2numz00_3799 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_369)); 
{ /* Llib/mpd.scm 1223 */
obj_t BgL_arg1765z00_3800;
BgL_arg1765z00_3800 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1223 */
int BgL_offsetz00_3803;
BgL_offsetz00_3803 = 
(int)(BgL_objzd2classzd2numz00_3799); 
{ /* Llib/mpd.scm 1223 */
long BgL_offsetz00_3804;
BgL_offsetz00_3804 = 
(
(long)(BgL_offsetz00_3803)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1223 */
long BgL_modz00_3805;
BgL_modz00_3805 = 
(BgL_offsetz00_3804 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1223 */
long BgL_restz00_3807;
BgL_restz00_3807 = 
(BgL_offsetz00_3804 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1223 */

{ /* Llib/mpd.scm 1223 */
obj_t BgL_bucketz00_3809;
BgL_bucketz00_3809 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3800),BgL_modz00_3805); 
BgL_res2778z00_3828 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3809),BgL_restz00_3807); } } } } } } } } 
BgL_method1368z00_2387 = BgL_res2778z00_3828; } 
return 
PROCEDURE_ENTRY(BgL_method1368z00_2387)(BgL_method1368z00_2387, 
((obj_t)BgL_oz00_369), BgL_opz00_370, BEOA);} } 

}



/* &mpd-database-listartist */
obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4823, obj_t BgL_oz00_4824, obj_t BgL_opz00_4825)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_auxz00_9173;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9165;
if(
OUTPUT_PORTP(BgL_opz00_4825))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9173 = BgL_opz00_4825
; }  else 
{ 
obj_t BgL_auxz00_9176;
BgL_auxz00_9176 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3097z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4825); 
FAILURE(BgL_auxz00_9176,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4824, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9165 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4824)
; }  else 
{ 
obj_t BgL_auxz00_9169;
BgL_auxz00_9169 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3097z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4824); 
FAILURE(BgL_auxz00_9169,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9165, BgL_auxz00_9173);} } 

}



/* mpd-database-lsinfo */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_371, obj_t BgL_opz00_372, obj_t BgL_dirz00_373, bool_t BgL_recz00_374)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_method1370z00_2388;
{ /* Llib/mpd.scm 1233 */
obj_t BgL_res2783z00_3859;
{ /* Llib/mpd.scm 1233 */
long BgL_objzd2classzd2numz00_3830;
BgL_objzd2classzd2numz00_3830 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_371)); 
{ /* Llib/mpd.scm 1233 */
obj_t BgL_arg1765z00_3831;
BgL_arg1765z00_3831 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1233 */
int BgL_offsetz00_3834;
BgL_offsetz00_3834 = 
(int)(BgL_objzd2classzd2numz00_3830); 
{ /* Llib/mpd.scm 1233 */
long BgL_offsetz00_3835;
BgL_offsetz00_3835 = 
(
(long)(BgL_offsetz00_3834)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1233 */
long BgL_modz00_3836;
BgL_modz00_3836 = 
(BgL_offsetz00_3835 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1233 */
long BgL_restz00_3838;
BgL_restz00_3838 = 
(BgL_offsetz00_3835 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1233 */

{ /* Llib/mpd.scm 1233 */
obj_t BgL_bucketz00_3840;
BgL_bucketz00_3840 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3831),BgL_modz00_3836); 
BgL_res2783z00_3859 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3840),BgL_restz00_3838); } } } } } } } } 
BgL_method1370z00_2388 = BgL_res2783z00_3859; } 
return 
PROCEDURE_ENTRY(BgL_method1370z00_2388)(BgL_method1370z00_2388, 
((obj_t)BgL_oz00_371), BgL_opz00_372, BgL_dirz00_373, 
BBOOL(BgL_recz00_374), BEOA);} } 

}



/* &mpd-database-lsinfo */
obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4826, obj_t BgL_oz00_4827, obj_t BgL_opz00_4828, obj_t BgL_dirz00_4829, obj_t BgL_recz00_4830)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_auxz00_9230;obj_t BgL_auxz00_9223;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9215;
if(
STRINGP(BgL_dirz00_4829))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9230 = BgL_dirz00_4829
; }  else 
{ 
obj_t BgL_auxz00_9233;
BgL_auxz00_9233 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3098z00zz__multimediazd2mpdzd2, BGl_string3089z00zz__multimediazd2mpdzd2, BgL_dirz00_4829); 
FAILURE(BgL_auxz00_9233,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_opz00_4828))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9223 = BgL_opz00_4828
; }  else 
{ 
obj_t BgL_auxz00_9226;
BgL_auxz00_9226 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3098z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4828); 
FAILURE(BgL_auxz00_9226,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4827, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9215 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4827)
; }  else 
{ 
obj_t BgL_auxz00_9219;
BgL_auxz00_9219 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3098z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4827); 
FAILURE(BgL_auxz00_9219,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_auxz00_9215, BgL_auxz00_9223, BgL_auxz00_9230, 
CBOOL(BgL_recz00_4830));} } 

}



/* mpd-database-find-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_380, obj_t BgL_opz00_381, obj_t BgL_albumz00_382)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_method1372z00_2389;
{ /* Llib/mpd.scm 1294 */
obj_t BgL_res2788z00_3890;
{ /* Llib/mpd.scm 1294 */
long BgL_objzd2classzd2numz00_3861;
BgL_objzd2classzd2numz00_3861 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_380)); 
{ /* Llib/mpd.scm 1294 */
obj_t BgL_arg1765z00_3862;
BgL_arg1765z00_3862 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1294 */
int BgL_offsetz00_3865;
BgL_offsetz00_3865 = 
(int)(BgL_objzd2classzd2numz00_3861); 
{ /* Llib/mpd.scm 1294 */
long BgL_offsetz00_3866;
BgL_offsetz00_3866 = 
(
(long)(BgL_offsetz00_3865)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1294 */
long BgL_modz00_3867;
BgL_modz00_3867 = 
(BgL_offsetz00_3866 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1294 */
long BgL_restz00_3869;
BgL_restz00_3869 = 
(BgL_offsetz00_3866 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1294 */

{ /* Llib/mpd.scm 1294 */
obj_t BgL_bucketz00_3871;
BgL_bucketz00_3871 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3862),BgL_modz00_3867); 
BgL_res2788z00_3890 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3871),BgL_restz00_3869); } } } } } } } } 
BgL_method1372z00_2389 = BgL_res2788z00_3890; } 
return 
PROCEDURE_ENTRY(BgL_method1372z00_2389)(BgL_method1372z00_2389, 
((obj_t)BgL_oz00_380), BgL_opz00_381, BgL_albumz00_382, BEOA);} } 

}



/* &mpd-database-find-album */
obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4831, obj_t BgL_oz00_4832, obj_t BgL_opz00_4833, obj_t BgL_albumz00_4834)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_auxz00_9279;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9271;
if(
OUTPUT_PORTP(BgL_opz00_4833))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9279 = BgL_opz00_4833
; }  else 
{ 
obj_t BgL_auxz00_9282;
BgL_auxz00_9282 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3099z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4833); 
FAILURE(BgL_auxz00_9282,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4832, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9271 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4832)
; }  else 
{ 
obj_t BgL_auxz00_9275;
BgL_auxz00_9275 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3099z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4832); 
FAILURE(BgL_auxz00_9275,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9271, BgL_auxz00_9279, BgL_albumz00_4834);} } 

}



/* mpd-database-find-artist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_383, obj_t BgL_opz00_384, obj_t BgL_artistz00_385)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_method1374z00_2390;
{ /* Llib/mpd.scm 1303 */
obj_t BgL_res2793z00_3921;
{ /* Llib/mpd.scm 1303 */
long BgL_objzd2classzd2numz00_3892;
BgL_objzd2classzd2numz00_3892 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_383)); 
{ /* Llib/mpd.scm 1303 */
obj_t BgL_arg1765z00_3893;
BgL_arg1765z00_3893 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1303 */
int BgL_offsetz00_3896;
BgL_offsetz00_3896 = 
(int)(BgL_objzd2classzd2numz00_3892); 
{ /* Llib/mpd.scm 1303 */
long BgL_offsetz00_3897;
BgL_offsetz00_3897 = 
(
(long)(BgL_offsetz00_3896)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1303 */
long BgL_modz00_3898;
BgL_modz00_3898 = 
(BgL_offsetz00_3897 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1303 */
long BgL_restz00_3900;
BgL_restz00_3900 = 
(BgL_offsetz00_3897 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1303 */

{ /* Llib/mpd.scm 1303 */
obj_t BgL_bucketz00_3902;
BgL_bucketz00_3902 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3893),BgL_modz00_3898); 
BgL_res2793z00_3921 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3902),BgL_restz00_3900); } } } } } } } } 
BgL_method1374z00_2390 = BgL_res2793z00_3921; } 
return 
PROCEDURE_ENTRY(BgL_method1374z00_2390)(BgL_method1374z00_2390, 
((obj_t)BgL_oz00_383), BgL_opz00_384, BgL_artistz00_385, BEOA);} } 

}



/* &mpd-database-find-artist */
obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4835, obj_t BgL_oz00_4836, obj_t BgL_opz00_4837, obj_t BgL_artistz00_4838)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_auxz00_9327;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9319;
if(
OUTPUT_PORTP(BgL_opz00_4837))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9327 = BgL_opz00_4837
; }  else 
{ 
obj_t BgL_auxz00_9330;
BgL_auxz00_9330 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3100z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4837); 
FAILURE(BgL_auxz00_9330,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4836, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9319 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4836)
; }  else 
{ 
obj_t BgL_auxz00_9323;
BgL_auxz00_9323 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3100z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4836); 
FAILURE(BgL_auxz00_9323,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_auxz00_9319, BgL_auxz00_9327, BgL_artistz00_4838);} } 

}



/* mpd-database-search-artist-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_386, obj_t BgL_opz00_387, obj_t BgL_artistz00_388, obj_t BgL_albumz00_389)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_method1376z00_2391;
{ /* Llib/mpd.scm 1312 */
obj_t BgL_res2798z00_3952;
{ /* Llib/mpd.scm 1312 */
long BgL_objzd2classzd2numz00_3923;
BgL_objzd2classzd2numz00_3923 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_386)); 
{ /* Llib/mpd.scm 1312 */
obj_t BgL_arg1765z00_3924;
BgL_arg1765z00_3924 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1312 */
int BgL_offsetz00_3927;
BgL_offsetz00_3927 = 
(int)(BgL_objzd2classzd2numz00_3923); 
{ /* Llib/mpd.scm 1312 */
long BgL_offsetz00_3928;
BgL_offsetz00_3928 = 
(
(long)(BgL_offsetz00_3927)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1312 */
long BgL_modz00_3929;
BgL_modz00_3929 = 
(BgL_offsetz00_3928 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1312 */
long BgL_restz00_3931;
BgL_restz00_3931 = 
(BgL_offsetz00_3928 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1312 */

{ /* Llib/mpd.scm 1312 */
obj_t BgL_bucketz00_3933;
BgL_bucketz00_3933 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3924),BgL_modz00_3929); 
BgL_res2798z00_3952 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3933),BgL_restz00_3931); } } } } } } } } 
BgL_method1376z00_2391 = BgL_res2798z00_3952; } 
return 
PROCEDURE_ENTRY(BgL_method1376z00_2391)(BgL_method1376z00_2391, 
((obj_t)BgL_oz00_386), BgL_opz00_387, BgL_artistz00_388, BgL_albumz00_389, BEOA);} } 

}



/* &mpd-database-search-artist-album */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4839, obj_t BgL_oz00_4840, obj_t BgL_opz00_4841, obj_t BgL_artistz00_4842, obj_t BgL_albumz00_4843)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_auxz00_9376;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9368;
if(
OUTPUT_PORTP(BgL_opz00_4841))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9376 = BgL_opz00_4841
; }  else 
{ 
obj_t BgL_auxz00_9379;
BgL_auxz00_9379 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3101z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4841); 
FAILURE(BgL_auxz00_9379,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4840, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9368 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4840)
; }  else 
{ 
obj_t BgL_auxz00_9372;
BgL_auxz00_9372 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3101z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4840); 
FAILURE(BgL_auxz00_9372,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_auxz00_9368, BgL_auxz00_9376, BgL_artistz00_4842, BgL_albumz00_4843);} } 

}



/* mpd-database-search-artist-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_390, obj_t BgL_opz00_391, obj_t BgL_artistz00_392, obj_t BgL_titlez00_393)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_method1378z00_2392;
{ /* Llib/mpd.scm 1345 */
obj_t BgL_res2803z00_3983;
{ /* Llib/mpd.scm 1345 */
long BgL_objzd2classzd2numz00_3954;
BgL_objzd2classzd2numz00_3954 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_390)); 
{ /* Llib/mpd.scm 1345 */
obj_t BgL_arg1765z00_3955;
BgL_arg1765z00_3955 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1345 */
int BgL_offsetz00_3958;
BgL_offsetz00_3958 = 
(int)(BgL_objzd2classzd2numz00_3954); 
{ /* Llib/mpd.scm 1345 */
long BgL_offsetz00_3959;
BgL_offsetz00_3959 = 
(
(long)(BgL_offsetz00_3958)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1345 */
long BgL_modz00_3960;
BgL_modz00_3960 = 
(BgL_offsetz00_3959 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1345 */
long BgL_restz00_3962;
BgL_restz00_3962 = 
(BgL_offsetz00_3959 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1345 */

{ /* Llib/mpd.scm 1345 */
obj_t BgL_bucketz00_3964;
BgL_bucketz00_3964 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3955),BgL_modz00_3960); 
BgL_res2803z00_3983 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3964),BgL_restz00_3962); } } } } } } } } 
BgL_method1378z00_2392 = BgL_res2803z00_3983; } 
return 
PROCEDURE_ENTRY(BgL_method1378z00_2392)(BgL_method1378z00_2392, 
((obj_t)BgL_oz00_390), BgL_opz00_391, BgL_artistz00_392, BgL_titlez00_393, BEOA);} } 

}



/* &mpd-database-search-artist-title */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4844, obj_t BgL_oz00_4845, obj_t BgL_opz00_4846, obj_t BgL_artistz00_4847, obj_t BgL_titlez00_4848)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_auxz00_9425;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9417;
if(
OUTPUT_PORTP(BgL_opz00_4846))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9425 = BgL_opz00_4846
; }  else 
{ 
obj_t BgL_auxz00_9428;
BgL_auxz00_9428 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3102z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4846); 
FAILURE(BgL_auxz00_9428,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4845, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9417 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4845)
; }  else 
{ 
obj_t BgL_auxz00_9421;
BgL_auxz00_9421 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3102z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4845); 
FAILURE(BgL_auxz00_9421,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_auxz00_9417, BgL_auxz00_9425, BgL_artistz00_4847, BgL_titlez00_4848);} } 

}



/* mpd-database-find-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_394, obj_t BgL_opz00_395, obj_t BgL_titlez00_396)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_method1380z00_2393;
{ /* Llib/mpd.scm 1371 */
obj_t BgL_res2808z00_4014;
{ /* Llib/mpd.scm 1371 */
long BgL_objzd2classzd2numz00_3985;
BgL_objzd2classzd2numz00_3985 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_394)); 
{ /* Llib/mpd.scm 1371 */
obj_t BgL_arg1765z00_3986;
BgL_arg1765z00_3986 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1371 */
int BgL_offsetz00_3989;
BgL_offsetz00_3989 = 
(int)(BgL_objzd2classzd2numz00_3985); 
{ /* Llib/mpd.scm 1371 */
long BgL_offsetz00_3990;
BgL_offsetz00_3990 = 
(
(long)(BgL_offsetz00_3989)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1371 */
long BgL_modz00_3991;
BgL_modz00_3991 = 
(BgL_offsetz00_3990 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1371 */
long BgL_restz00_3993;
BgL_restz00_3993 = 
(BgL_offsetz00_3990 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1371 */

{ /* Llib/mpd.scm 1371 */
obj_t BgL_bucketz00_3995;
BgL_bucketz00_3995 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_3986),BgL_modz00_3991); 
BgL_res2808z00_4014 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3995),BgL_restz00_3993); } } } } } } } } 
BgL_method1380z00_2393 = BgL_res2808z00_4014; } 
return 
PROCEDURE_ENTRY(BgL_method1380z00_2393)(BgL_method1380z00_2393, 
((obj_t)BgL_oz00_394), BgL_opz00_395, BgL_titlez00_396, BEOA);} } 

}



/* &mpd-database-find-title */
obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4849, obj_t BgL_oz00_4850, obj_t BgL_opz00_4851, obj_t BgL_titlez00_4852)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_auxz00_9473;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9465;
if(
OUTPUT_PORTP(BgL_opz00_4851))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9473 = BgL_opz00_4851
; }  else 
{ 
obj_t BgL_auxz00_9476;
BgL_auxz00_9476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3103z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4851); 
FAILURE(BgL_auxz00_9476,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4850, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9465 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4850)
; }  else 
{ 
obj_t BgL_auxz00_9469;
BgL_auxz00_9469 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3103z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4850); 
FAILURE(BgL_auxz00_9469,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_auxz00_9465, BgL_auxz00_9473, BgL_titlez00_4852);} } 

}



/* mpd-database-find-genre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_397, obj_t BgL_opz00_398, obj_t BgL_genrez00_399)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_method1382z00_2394;
{ /* Llib/mpd.scm 1389 */
obj_t BgL_res2813z00_4045;
{ /* Llib/mpd.scm 1389 */
long BgL_objzd2classzd2numz00_4016;
BgL_objzd2classzd2numz00_4016 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_397)); 
{ /* Llib/mpd.scm 1389 */
obj_t BgL_arg1765z00_4017;
BgL_arg1765z00_4017 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1389 */
int BgL_offsetz00_4020;
BgL_offsetz00_4020 = 
(int)(BgL_objzd2classzd2numz00_4016); 
{ /* Llib/mpd.scm 1389 */
long BgL_offsetz00_4021;
BgL_offsetz00_4021 = 
(
(long)(BgL_offsetz00_4020)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1389 */
long BgL_modz00_4022;
BgL_modz00_4022 = 
(BgL_offsetz00_4021 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1389 */
long BgL_restz00_4024;
BgL_restz00_4024 = 
(BgL_offsetz00_4021 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1389 */

{ /* Llib/mpd.scm 1389 */
obj_t BgL_bucketz00_4026;
BgL_bucketz00_4026 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4017),BgL_modz00_4022); 
BgL_res2813z00_4045 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4026),BgL_restz00_4024); } } } } } } } } 
BgL_method1382z00_2394 = BgL_res2813z00_4045; } 
return 
PROCEDURE_ENTRY(BgL_method1382z00_2394)(BgL_method1382z00_2394, 
((obj_t)BgL_oz00_397), BgL_opz00_398, BgL_genrez00_399, BEOA);} } 

}



/* &mpd-database-find-genre */
obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4853, obj_t BgL_oz00_4854, obj_t BgL_opz00_4855, obj_t BgL_genrez00_4856)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_auxz00_9521;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9513;
if(
OUTPUT_PORTP(BgL_opz00_4855))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9521 = BgL_opz00_4855
; }  else 
{ 
obj_t BgL_auxz00_9524;
BgL_auxz00_9524 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3104z00zz__multimediazd2mpdzd2, BGl_string2935z00zz__multimediazd2mpdzd2, BgL_opz00_4855); 
FAILURE(BgL_auxz00_9524,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4854, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9513 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4854)
; }  else 
{ 
obj_t BgL_auxz00_9517;
BgL_auxz00_9517 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3104z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4854); 
FAILURE(BgL_auxz00_9517,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_auxz00_9513, BgL_auxz00_9521, BgL_genrez00_4856);} } 

}



/* mpd-database-getgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_400)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
obj_t BgL_method1384z00_2395;
{ /* Llib/mpd.scm 1407 */
obj_t BgL_res2818z00_4076;
{ /* Llib/mpd.scm 1407 */
long BgL_objzd2classzd2numz00_4047;
BgL_objzd2classzd2numz00_4047 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_400)); 
{ /* Llib/mpd.scm 1407 */
obj_t BgL_arg1765z00_4048;
BgL_arg1765z00_4048 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1407 */
int BgL_offsetz00_4051;
BgL_offsetz00_4051 = 
(int)(BgL_objzd2classzd2numz00_4047); 
{ /* Llib/mpd.scm 1407 */
long BgL_offsetz00_4052;
BgL_offsetz00_4052 = 
(
(long)(BgL_offsetz00_4051)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1407 */
long BgL_modz00_4053;
BgL_modz00_4053 = 
(BgL_offsetz00_4052 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1407 */
long BgL_restz00_4055;
BgL_restz00_4055 = 
(BgL_offsetz00_4052 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1407 */

{ /* Llib/mpd.scm 1407 */
obj_t BgL_bucketz00_4057;
BgL_bucketz00_4057 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4048),BgL_modz00_4053); 
BgL_res2818z00_4076 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4057),BgL_restz00_4055); } } } } } } } } 
BgL_method1384z00_2395 = BgL_res2818z00_4076; } 
return 
PROCEDURE_ENTRY(BgL_method1384z00_2395)(BgL_method1384z00_2395, 
((obj_t)BgL_oz00_400), BEOA);} } 

}



/* &mpd-database-getgenre */
obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4857, obj_t BgL_oz00_4858)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9559;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4858, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1407 */
BgL_auxz00_9559 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4858)
; }  else 
{ 
obj_t BgL_auxz00_9563;
BgL_auxz00_9563 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)55101)), BGl_string3105z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4858); 
FAILURE(BgL_auxz00_9563,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9559);} } 

}



/* mpd-database-getartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_401)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
obj_t BgL_method1386z00_2396;
{ /* Llib/mpd.scm 1414 */
obj_t BgL_res2823z00_4107;
{ /* Llib/mpd.scm 1414 */
long BgL_objzd2classzd2numz00_4078;
BgL_objzd2classzd2numz00_4078 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_401)); 
{ /* Llib/mpd.scm 1414 */
obj_t BgL_arg1765z00_4079;
BgL_arg1765z00_4079 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1414 */
int BgL_offsetz00_4082;
BgL_offsetz00_4082 = 
(int)(BgL_objzd2classzd2numz00_4078); 
{ /* Llib/mpd.scm 1414 */
long BgL_offsetz00_4083;
BgL_offsetz00_4083 = 
(
(long)(BgL_offsetz00_4082)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1414 */
long BgL_modz00_4084;
BgL_modz00_4084 = 
(BgL_offsetz00_4083 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1414 */
long BgL_restz00_4086;
BgL_restz00_4086 = 
(BgL_offsetz00_4083 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1414 */

{ /* Llib/mpd.scm 1414 */
obj_t BgL_bucketz00_4088;
BgL_bucketz00_4088 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4079),BgL_modz00_4084); 
BgL_res2823z00_4107 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4088),BgL_restz00_4086); } } } } } } } } 
BgL_method1386z00_2396 = BgL_res2823z00_4107; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_2396)(BgL_method1386z00_2396, 
((obj_t)BgL_oz00_401), BEOA);} } 

}



/* &mpd-database-getartist */
obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4859, obj_t BgL_oz00_4860)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9598;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4860, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1414 */
BgL_auxz00_9598 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4860)
; }  else 
{ 
obj_t BgL_auxz00_9602;
BgL_auxz00_9602 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)55438)), BGl_string3106z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4860); 
FAILURE(BgL_auxz00_9602,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9598);} } 

}



/* mpd-database-getgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_402, obj_t BgL_genrez00_403)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
obj_t BgL_method1388z00_2397;
{ /* Llib/mpd.scm 1421 */
obj_t BgL_res2828z00_4138;
{ /* Llib/mpd.scm 1421 */
long BgL_objzd2classzd2numz00_4109;
BgL_objzd2classzd2numz00_4109 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_402)); 
{ /* Llib/mpd.scm 1421 */
obj_t BgL_arg1765z00_4110;
BgL_arg1765z00_4110 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1421 */
int BgL_offsetz00_4113;
BgL_offsetz00_4113 = 
(int)(BgL_objzd2classzd2numz00_4109); 
{ /* Llib/mpd.scm 1421 */
long BgL_offsetz00_4114;
BgL_offsetz00_4114 = 
(
(long)(BgL_offsetz00_4113)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1421 */
long BgL_modz00_4115;
BgL_modz00_4115 = 
(BgL_offsetz00_4114 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1421 */
long BgL_restz00_4117;
BgL_restz00_4117 = 
(BgL_offsetz00_4114 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1421 */

{ /* Llib/mpd.scm 1421 */
obj_t BgL_bucketz00_4119;
BgL_bucketz00_4119 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4110),BgL_modz00_4115); 
BgL_res2828z00_4138 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4119),BgL_restz00_4117); } } } } } } } } 
BgL_method1388z00_2397 = BgL_res2828z00_4138; } 
return 
PROCEDURE_ENTRY(BgL_method1388z00_2397)(BgL_method1388z00_2397, 
((obj_t)BgL_oz00_402), BgL_genrez00_403, BEOA);} } 

}



/* &mpd-database-getgenreartist */
obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4861, obj_t BgL_oz00_4862, obj_t BgL_genrez00_4863)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9638;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4862, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1421 */
BgL_auxz00_9638 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4862)
; }  else 
{ 
obj_t BgL_auxz00_9642;
BgL_auxz00_9642 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)55778)), BGl_string3107z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4862); 
FAILURE(BgL_auxz00_9642,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9638, BgL_genrez00_4863);} } 

}



/* mpd-database-getartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_404, obj_t BgL_artistz00_405)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
obj_t BgL_method1390z00_2398;
{ /* Llib/mpd.scm 1431 */
obj_t BgL_res2833z00_4169;
{ /* Llib/mpd.scm 1431 */
long BgL_objzd2classzd2numz00_4140;
BgL_objzd2classzd2numz00_4140 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_404)); 
{ /* Llib/mpd.scm 1431 */
obj_t BgL_arg1765z00_4141;
BgL_arg1765z00_4141 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1431 */
int BgL_offsetz00_4144;
BgL_offsetz00_4144 = 
(int)(BgL_objzd2classzd2numz00_4140); 
{ /* Llib/mpd.scm 1431 */
long BgL_offsetz00_4145;
BgL_offsetz00_4145 = 
(
(long)(BgL_offsetz00_4144)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1431 */
long BgL_modz00_4146;
BgL_modz00_4146 = 
(BgL_offsetz00_4145 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1431 */
long BgL_restz00_4148;
BgL_restz00_4148 = 
(BgL_offsetz00_4145 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1431 */

{ /* Llib/mpd.scm 1431 */
obj_t BgL_bucketz00_4150;
BgL_bucketz00_4150 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4141),BgL_modz00_4146); 
BgL_res2833z00_4169 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4150),BgL_restz00_4148); } } } } } } } } 
BgL_method1390z00_2398 = BgL_res2833z00_4169; } 
return 
PROCEDURE_ENTRY(BgL_method1390z00_2398)(BgL_method1390z00_2398, 
((obj_t)BgL_oz00_404), BgL_artistz00_405, BEOA);} } 

}



/* &mpd-database-getartistalbum */
obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_4864, obj_t BgL_oz00_4865, obj_t BgL_artistz00_4866)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9678;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4865, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1431 */
BgL_auxz00_9678 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4865)
; }  else 
{ 
obj_t BgL_auxz00_9682;
BgL_auxz00_9682 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)56226)), BGl_string3108z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4865); 
FAILURE(BgL_auxz00_9682,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9678, BgL_artistz00_4866);} } 

}



/* mpd-database-get-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_417, obj_t BgL_albumz00_418)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
obj_t BgL_method1396z00_2399;
{ /* Llib/mpd.scm 1517 */
obj_t BgL_res2838z00_4200;
{ /* Llib/mpd.scm 1517 */
long BgL_objzd2classzd2numz00_4171;
BgL_objzd2classzd2numz00_4171 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_417)); 
{ /* Llib/mpd.scm 1517 */
obj_t BgL_arg1765z00_4172;
BgL_arg1765z00_4172 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1517 */
int BgL_offsetz00_4175;
BgL_offsetz00_4175 = 
(int)(BgL_objzd2classzd2numz00_4171); 
{ /* Llib/mpd.scm 1517 */
long BgL_offsetz00_4176;
BgL_offsetz00_4176 = 
(
(long)(BgL_offsetz00_4175)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1517 */
long BgL_modz00_4177;
BgL_modz00_4177 = 
(BgL_offsetz00_4176 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1517 */
long BgL_restz00_4179;
BgL_restz00_4179 = 
(BgL_offsetz00_4176 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1517 */

{ /* Llib/mpd.scm 1517 */
obj_t BgL_bucketz00_4181;
BgL_bucketz00_4181 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_4172),BgL_modz00_4177); 
BgL_res2838z00_4200 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4181),BgL_restz00_4179); } } } } } } } } 
BgL_method1396z00_2399 = BgL_res2838z00_4200; } 
return 
PROCEDURE_ENTRY(BgL_method1396z00_2399)(BgL_method1396z00_2399, 
((obj_t)BgL_oz00_417), BgL_albumz00_418, BEOA);} } 

}



/* &mpd-database-get-album */
obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4867, obj_t BgL_oz00_4868, obj_t BgL_albumz00_4869)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9718;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_4868, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1517 */
BgL_auxz00_9718 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_4868)
; }  else 
{ 
obj_t BgL_auxz00_9722;
BgL_auxz00_9722 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2930z00zz__multimediazd2mpdzd2, 
BINT(((long)59323)), BGl_string3109z00zz__multimediazd2mpdzd2, BGl_string2936z00zz__multimediazd2mpdzd2, BgL_oz00_4868); 
FAILURE(BgL_auxz00_9722,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9718, BgL_albumz00_4869);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)95358739), 
BSTRING_TO_STRING(BGl_string3110z00zz__multimediazd2mpdzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(((long)299260312), 
BSTRING_TO_STRING(BGl_string3110z00zz__multimediazd2mpdzd2));} 

}

#ifdef __cplusplus
}
#endif
