/*===========================================================================*/
/*   (Llib/pgp_composition.scm)                                              */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -fno-reflection -unsafe -safee -copt -fPIC -copt -IPosix Llib/pgp_composition.scm -o objs/pgp_composition.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_pgpzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2packetzd2_bglt;

typedef struct BgL_pgpzd2sigzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
} *BgL_pgpzd2sigzd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
} *BgL_pgpzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   bool_t BgL_containszd2nestedzd2sigzf3zf3;
} *BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2compressedzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_packetsz00;
} *BgL_pgpzd2compressedzd2packetz00_bglt;

typedef struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt;

typedef struct BgL_pgpzd2literalzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   bool_t BgL_forzd2yourzd2eyeszd2onlyzf3z21;
   obj_t BgL_filezd2namezd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_dataz00;
} *BgL_pgpzd2literalzd2packetz00_bglt;

typedef struct BgL_pgpzd2idzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2idzd2packetz00_bglt;

typedef struct BgL_signedzd2idzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2idzd2packetz00_bgl * BgL_idz00;
   obj_t BgL_sigsz00;
} *BgL_signedzd2idzd2_bglt;

typedef struct BgL_pgpzd2subkeyzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2keyzd2packetz00_bgl * BgL_keyzd2packetzd2;
   obj_t BgL_sigsz00;
   obj_t BgL_revocationzd2sigszd2;
   struct BgL_pgpzd2keyzd2_bgl * BgL_pgpzd2keyzd2;
} *BgL_pgpzd2subkeyzd2_bglt;

typedef struct BgL_pgpzd2compositionzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2compositionzd2_bglt;

typedef struct BgL_pgpzd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_subkeysz00;
   obj_t BgL_userzd2idszd2;
} *BgL_pgpzd2keyzd2_bglt;

typedef struct BgL_pgpzd2messagezd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2messagezd2_bglt;

typedef struct BgL_pgpzd2encryptedzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_sessionzd2keyszd2;
   struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl * BgL_encryptedzd2datazd2;
} *BgL_pgpzd2encryptedzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_msgz00;
   obj_t BgL_sigsz00;
} *BgL_pgpzd2signaturezd2_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_msgz00;
   obj_t BgL_sigsz00;
   obj_t BgL_onezd2passzd2sigsz00;
} *BgL_pgpzd2onezd2passzd2signaturezd2_bglt;

typedef struct BgL_pgpzd2literalzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2literalzd2packetz00_bgl * BgL_literalz00;
} *BgL_pgpzd2literalzd2_bglt;


static BgL_signedzd2idzd2_bglt BGl_z62lambda1927z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_signedzd2idzd2_bglt BGl_z62lambda1929z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31951ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda1935z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1936z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62encodezd2pgp1312zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62lambda1940z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1941z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t);
static obj_t BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1947z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1949z62zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_base64zd2encodezd2zz__base64z00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1955z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1956z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Encry1321zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
static obj_t BGl_z62lambda1960z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1961z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2signaturezd2_bglt BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda1965z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1966z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2();
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1970z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1971z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Key1315zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2compositionzd2_bglt BGl_z62lambda1976z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32015ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse(obj_t);
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1984z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__openpgpzd2compositionzd2();
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1986z62zz__openpgpzd2compositionzd2(obj_t);
extern obj_t BGl_base64zd2decodezd2pipezd2portzd2zz__openpgpzd2portzd2utilz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__openpgpzd2compositionzd2();
static obj_t BGl_z62lambda1992z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1993z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62lambda1997z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1998z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2;
BGL_EXPORTED_DECL obj_t BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
extern obj_t BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_unreadzd2stringz12zc0zz__r4_input_6_10_2z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__openpgpzd2compositionzd2();
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(obj_t);
static bool_t BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31978ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_crczd2stringzd2zz__crcz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_input_port(obj_t);
static obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31988ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2messagezd2_bglt BGl_z62lambda2003z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2011z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2013z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda2019z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda2020z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda2024z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2025z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2031z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2033z62zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2039z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2040z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2044z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2045z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2compositionzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2portzd2utilz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2decodezd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__crcz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__base64z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Signa1319zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2051z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2053z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda2059z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62lambda2060z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2literalzd2_bglt BGl_z62lambda2066z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2literalzd2_bglt BGl_z62lambda2068z62zz__openpgpzd2compositionzd2(obj_t);
static bool_t BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(obj_t);
extern obj_t BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
extern obj_t BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt, obj_t);
static BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2074z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2075z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
extern obj_t BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2();
static obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2();
extern obj_t BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2;
BGL_EXPORTED_DEF obj_t BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
extern obj_t BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(obj_t);
static obj_t BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(obj_t);
static BgL_pgpzd2literalzd2_bglt BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31912ze3ze5zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_readzd2stringzd2zz__r4_input_6_10_2z00(obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_z62zc3z04anonymousza31914ze3ze5zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31931ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1317z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 39 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2200z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1941za7622264z00, BGl_z62lambda1941z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2201z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1940za7622265z00, BGl_z62lambda1940z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2202z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2266za7, BGl_z62zc3z04anonymousza31931ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2203z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1929za7622267z00, BGl_z62lambda1929z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2204z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1927za7622268z00, BGl_z62lambda1927z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2205z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1956za7622269z00, BGl_z62lambda1956z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2206z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1955za7622270z00, BGl_z62lambda1955z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2207z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1961za7622271z00, BGl_z62lambda1961z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2208z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1960za7622272z00, BGl_z62lambda1960z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2209z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1966za7622273z00, BGl_z62lambda1966z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_GENERIC( BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72274za7, BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2210z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1965za7622275z00, BGl_z62lambda1965z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2211z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1971za7622276z00, BGl_z62lambda1971z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2212z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1970za7622277z00, BGl_z62lambda1970z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2213z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2278za7, BGl_z62zc3z04anonymousza31951ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2214z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1949za7622279z00, BGl_z62lambda1949z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2215z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1947za7622280z00, BGl_z62lambda1947z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2216z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2281za7, BGl_z62zc3z04anonymousza31978ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2217z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1976za7622282z00, BGl_z62lambda1976z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2218z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1993za7622283z00, BGl_z62lambda1993z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2219z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1992za7622284z00, BGl_z62lambda1992z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2220z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1998za7622285z00, BGl_z62lambda1998z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2221z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1997za7622286z00, BGl_z62lambda1997z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2222z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2287za7, BGl_z62zc3z04anonymousza31988ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2223z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1986za7622288z00, BGl_z62lambda1986z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2224z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1984za7622289z00, BGl_z62lambda1984z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2225z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2290za7, BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2226z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2003za7622291z00, BGl_z62lambda2003z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2227z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2020za7622292z00, BGl_z62lambda2020z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2228z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2019za7622293z00, BGl_z62lambda2019z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2229z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2025za7622294z00, BGl_z62lambda2025z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2230z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2024za7622295z00, BGl_z62lambda2024z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2231z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2296za7, BGl_z62zc3z04anonymousza32015ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2232z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2013za7622297z00, BGl_z62lambda2013z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2233z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2011za7622298z00, BGl_z62lambda2011z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2234z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2040za7622299z00, BGl_z62lambda2040z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2235z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2039za7622300z00, BGl_z62lambda2039z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2236z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2045za7622301z00, BGl_z62lambda2045z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2237z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2044za7622302z00, BGl_z62lambda2044z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2238z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2303za7, BGl_z62zc3z04anonymousza32035ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2239z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2033za7622304z00, BGl_z62lambda2033z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2166z00zz__openpgpzd2compositionzd2, BgL_bgl_string2166za700za7za7_2305za7, "no packet decoded", 17 );
DEFINE_STRING( BGl_string2167z00zz__openpgpzd2compositionzd2, BgL_bgl_string2167za700za7za7_2306za7, "discarding packets", 18 );
DEFINE_STRING( BGl_string2168z00zz__openpgpzd2compositionzd2, BgL_bgl_string2168za700za7za7_2307za7, "could not parse pgp-message", 27 );
DEFINE_STRING( BGl_string2169z00zz__openpgpzd2compositionzd2, BgL_bgl_string2169za700za7za7_2308za7, "/builddir/build/BUILD/bigloo-4.4b/api/openpgp/src/Llib/pgp_composition.scm", 74 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2240z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2031za7622309z00, BGl_z62lambda2031z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2241z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2060za7622310z00, BGl_z62lambda2060z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2242z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2059za7622311z00, BGl_z62lambda2059z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2243z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2312za7, BGl_z62zc3z04anonymousza32055ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2244z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2053za7622313z00, BGl_z62lambda2053z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2245z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2051za7622314z00, BGl_z62lambda2051z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2170z00zz__openpgpzd2compositionzd2, BgL_bgl_string2170za700za7za7_2315za7, "&parse-packets", 14 );
DEFINE_STRING( BGl_string2252z00zz__openpgpzd2compositionzd2, BgL_bgl_string2252za700za7za7_2316za7, "encode-pgp1312", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2246z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2075za7622317z00, BGl_z62lambda2075z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2171z00zz__openpgpzd2compositionzd2, BgL_bgl_string2171za700za7za7_2318za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string2253z00zz__openpgpzd2compositionzd2, BgL_bgl_string2253za700za7za7_2319za7, "Not yet implemented", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2247z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2074za7622320z00, BGl_z62lambda2074z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2172z00zz__openpgpzd2compositionzd2, BgL_bgl_string2172za700za7za7_2321za7, "Subkey not followed by subkey-binding Signature", 47 );
DEFINE_STRING( BGl_string2254z00zz__openpgpzd2compositionzd2, BgL_bgl_string2254za700za7za7_2322za7, "&encode-pgp", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2248z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2323za7, BGl_z62zc3z04anonymousza32070ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2173z00zz__openpgpzd2compositionzd2, BgL_bgl_string2173za700za7za7_2324za7, "At least one user ID is required", 32 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2249z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2068za7622325z00, BGl_z62lambda2068z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2174z00zz__openpgpzd2compositionzd2, BgL_bgl_string2174za700za7za7_2326za7, "missing encrypted data packet", 29 );
DEFINE_STRING( BGl_string2256z00zz__openpgpzd2compositionzd2, BgL_bgl_string2256za700za7za7_2327za7, "encode-pgp", 10 );
DEFINE_STRING( BGl_string2175z00zz__openpgpzd2compositionzd2, BgL_bgl_string2175za700za7za7_2328za7, "Packet after encrypted data discarded", 37 );
DEFINE_STRING( BGl_string2176z00zz__openpgpzd2compositionzd2, BgL_bgl_string2176za700za7za7_2329za7, "unexpected packet encountered and discarded", 43 );
DEFINE_STRING( BGl_string2177z00zz__openpgpzd2compositionzd2, BgL_bgl_string2177za700za7za7_2330za7, "discarding packets after signature message", 42 );
DEFINE_STRING( BGl_string2178z00zz__openpgpzd2compositionzd2, BgL_bgl_string2178za700za7za7_2331za7, "bad one-pass signature", 22 );
DEFINE_STRING( BGl_string2179z00zz__openpgpzd2compositionzd2, BgL_bgl_string2179za700za7za7_2332za7, "bad one-pass-signature", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2250z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2066za7622333z00, BGl_z62lambda2066z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2251z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgp12334z00, BGl_z62encodezd2pgp1312zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2260z00zz__openpgpzd2compositionzd2, BgL_bgl_string2260za700za7za7_2335za7, "__openpgp-composition", 21 );
DEFINE_STRING( BGl_string2261z00zz__openpgpzd2compositionzd2, BgL_bgl_string2261za700za7za7_2336za7, "encode-pgp PGP-Literal literal PGP-One-Pass-Signature one-pass-sigs PGP-Signature obj msg PGP-Encrypted encrypted-data session-keys PGP-Message PGP-Key user-ids pair subkeys PGP-Composition PGP-Subkey pgp-key revocation-sigs key-packet __openpgp-composition Signed-ID pair-nil sigs id radix-64-24 parse-literal parse-signature parse-encrypted-message subkey-binding key-revocation parse-key positive-certif casual-certif persona-certif generic-certif parse-subkey parse-packets ", 478 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2255z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72337za7, BGl_z62encodezd2pgpzd2PGPzd2Key1315zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2180z00zz__openpgpzd2compositionzd2, BgL_bgl_string2180za700za7za7_2338za7, "bad Literal", 11 );
DEFINE_STRING( BGl_string2181z00zz__openpgpzd2compositionzd2, BgL_bgl_string2181za700za7za7_2339za7, "read-armored", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2257z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72340za7, BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1317z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2182z00zz__openpgpzd2compositionzd2, BgL_bgl_string2182za700za7za7_2341za7, "bad checksum", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2258z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72342za7, BGl_z62encodezd2pgpzd2PGPzd2Signa1319zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2183z00zz__openpgpzd2compositionzd2, BgL_bgl_string2183za700za7za7_2343za7, "-----BEGIN", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2259z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72344za7, BGl_z62encodezd2pgpzd2PGPzd2Encry1321zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2184z00zz__openpgpzd2compositionzd2, BgL_bgl_string2184za700za7za7_2345za7, "-----", 5 );
DEFINE_STRING( BGl_string2185z00zz__openpgpzd2compositionzd2, BgL_bgl_string2185za700za7za7_2346za7, "not an armored file", 19 );
DEFINE_STRING( BGl_string2186z00zz__openpgpzd2compositionzd2, BgL_bgl_string2186za700za7za7_2347za7, "unexpected end of file", 22 );
DEFINE_STRING( BGl_string2187z00zz__openpgpzd2compositionzd2, BgL_bgl_string2187za700za7za7_2348za7, "&decode-pgp", 11 );
DEFINE_STRING( BGl_string2188z00zz__openpgpzd2compositionzd2, BgL_bgl_string2188za700za7za7_2349za7, "input-port", 10 );
DEFINE_STRING( BGl_string2189z00zz__openpgpzd2compositionzd2, BgL_bgl_string2189za700za7za7_2350za7, "&encode-native-pgp", 18 );
DEFINE_STRING( BGl_string2190z00zz__openpgpzd2compositionzd2, BgL_bgl_string2190za700za7za7_2351za7, "PGP-Composition", 15 );
DEFINE_STRING( BGl_string2191z00zz__openpgpzd2compositionzd2, BgL_bgl_string2191za700za7za7_2352za7, "output-port", 11 );
DEFINE_STRING( BGl_string2192z00zz__openpgpzd2compositionzd2, BgL_bgl_string2192za700za7za7_2353za7, "&encode-armored-pgp", 19 );
DEFINE_STRING( BGl_string2193z00zz__openpgpzd2compositionzd2, BgL_bgl_string2193za700za7za7_2354za7, "bstring", 7 );
DEFINE_STRING( BGl_string2194z00zz__openpgpzd2compositionzd2, BgL_bgl_string2194za700za7za7_2355za7, "-----BEGIN ", 11 );
DEFINE_STRING( BGl_string2195z00zz__openpgpzd2compositionzd2, BgL_bgl_string2195za700za7za7_2356za7, ": ", 2 );
DEFINE_STRING( BGl_string2196z00zz__openpgpzd2compositionzd2, BgL_bgl_string2196za700za7za7_2357za7, "=", 1 );
DEFINE_STRING( BGl_string2197z00zz__openpgpzd2compositionzd2, BgL_bgl_string2197za700za7za7_2358za7, "-----END ", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2198z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1936za7622359z00, BGl_z62lambda1936z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2199z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1935za7622360z00, BGl_z62lambda1935z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762decodeza7d2pgpza72361za7, BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2armoredzd2pgpzd2envzd2zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2armo2362z00, BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2nativezd2pgpzd2envzd2zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2nati2363z00, BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_parsezd2packetszd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762parseza7d2packe2364z00, BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2compositionzd2(long BgL_checksumz00_1919, char * BgL_fromz00_1920)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2))
{ 
BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_objectzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_genericzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_methodzd2initzd2zz__openpgpzd2compositionzd2(); 
return 
BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__base64z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__crcz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__openpgp-composition"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_cportz00_1724;
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_stringz00_1732;
BgL_stringz00_1732 = BGl_string2261z00zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_startz00_1733;
BgL_startz00_1733 = 
BINT(((long)0)); 
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_endz00_1734;
BgL_endz00_1734 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1732))); 
{ /* Llib/pgp_composition.scm 15 */

BgL_cportz00_1724 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1732, BgL_startz00_1733, BgL_endz00_1734); } } } } 
{ 
long BgL_iz00_1725;
BgL_iz00_1725 = ((long)38); 
BgL_loopz00_1726:
if(
(BgL_iz00_1725==((long)-1)))
{ /* Llib/pgp_composition.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_arg2263z00_1728;
{ /* Llib/pgp_composition.scm 15 */

{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_locationz00_1730;
BgL_locationz00_1730 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pgp_composition.scm 15 */

BgL_arg2263z00_1728 = 
BGl_readz00zz__readerz00(BgL_cportz00_1724, BgL_locationz00_1730); } } } 
{ /* Llib/pgp_composition.scm 15 */
int BgL_tmpz00_1958;
BgL_tmpz00_1958 = 
(int)(BgL_iz00_1725); 
CNST_TABLE_SET(BgL_tmpz00_1958, BgL_arg2263z00_1728); } } 
{ /* Llib/pgp_composition.scm 15 */
int BgL_auxz00_1731;
BgL_auxz00_1731 = 
(int)(
(BgL_iz00_1725-((long)1))); 
{ 
long BgL_iz00_1963;
BgL_iz00_1963 = 
(long)(BgL_auxz00_1731); 
BgL_iz00_1725 = BgL_iz00_1963; 
goto BgL_loopz00_1726;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return BUNSPEC;} 

}



/* append-21010 */
obj_t BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_56;
BgL_headz00_56 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_57;obj_t BgL_tailz00_58;
BgL_prevz00_57 = BgL_headz00_56; 
BgL_tailz00_58 = BgL_l1z00_1; 
BgL_loopz00_59:
if(
PAIRP(BgL_tailz00_58))
{ 
obj_t BgL_newzd2prevzd2_61;
BgL_newzd2prevzd2_61 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_58), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_57, BgL_newzd2prevzd2_61); 
{ 
obj_t BgL_tailz00_1973;obj_t BgL_prevz00_1972;
BgL_prevz00_1972 = BgL_newzd2prevzd2_61; 
BgL_tailz00_1973 = 
CDR(BgL_tailz00_58); 
BgL_tailz00_58 = BgL_tailz00_1973; 
BgL_prevz00_57 = BgL_prevz00_1972; 
goto BgL_loopz00_59;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_56);} } } 

}



/* parse-packets */
BGL_EXPORTED_DEF obj_t BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_4)
{
{ /* Llib/pgp_composition.scm 71 */
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2:
if(
NULLP(BgL_packetsz00_4))
{ /* Llib/pgp_composition.scm 74 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2166z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 78 */
bool_t BgL_test2369z00_1980;
{ /* Llib/pgp_composition.scm 78 */
bool_t BgL_test2370z00_1981;
{ /* Llib/pgp_composition.scm 78 */
obj_t BgL_arg1543z00_101;
BgL_arg1543z00_101 = 
CAR(BgL_packetsz00_4); 
BgL_test2370z00_1981 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1543z00_101, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2370z00_1981)
{ /* Llib/pgp_composition.scm 78 */
if(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
CAR(BgL_packetsz00_4))))->BgL_subkeyzf3zf3))
{ /* Llib/pgp_composition.scm 80 */
BgL_test2369z00_1980 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 80 */
BgL_test2369z00_1980 = ((bool_t)1)
; } }  else 
{ /* Llib/pgp_composition.scm 78 */
BgL_test2369z00_1980 = ((bool_t)0)
; } } 
if(BgL_test2369z00_1980)
{ /* Llib/pgp_composition.scm 78 */
return 
BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 82 */
bool_t BgL_test2372z00_1989;
{ /* Llib/pgp_composition.scm 82 */
bool_t BgL_test2373z00_1990;
{ /* Llib/pgp_composition.scm 82 */
obj_t BgL_arg1540z00_97;
BgL_arg1540z00_97 = 
CAR(BgL_packetsz00_4); 
BgL_test2373z00_1990 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1540z00_97, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2373z00_1990)
{ /* Llib/pgp_composition.scm 82 */
BgL_test2372z00_1989 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 83 */
obj_t BgL_arg1539z00_96;
BgL_arg1539z00_96 = 
CAR(BgL_packetsz00_4); 
BgL_test2372z00_1989 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1539z00_96, BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); } } 
if(BgL_test2372z00_1989)
{ /* Llib/pgp_composition.scm 82 */
return 
BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 85 */
bool_t BgL_test2374z00_1996;
{ /* Llib/pgp_composition.scm 85 */
obj_t BgL_arg1538z00_94;
BgL_arg1538z00_94 = 
CAR(BgL_packetsz00_4); 
BgL_test2374z00_1996 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1538z00_94, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2374z00_1996)
{ /* Llib/pgp_composition.scm 85 */
return 
((obj_t)
BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4));}  else 
{ /* Llib/pgp_composition.scm 87 */
bool_t BgL_test2375z00_2001;
{ /* Llib/pgp_composition.scm 87 */
obj_t BgL_arg1531z00_93;
BgL_arg1531z00_93 = 
CAR(BgL_packetsz00_4); 
BgL_test2375z00_2001 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1531z00_93, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2375z00_2001)
{ /* Llib/pgp_composition.scm 87 */
return 
BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 89 */
bool_t BgL_test2376z00_2005;
{ /* Llib/pgp_composition.scm 89 */
obj_t BgL_arg1530z00_92;
BgL_arg1530z00_92 = 
CAR(BgL_packetsz00_4); 
BgL_test2376z00_2005 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1530z00_92, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2376z00_2005)
{ /* Llib/pgp_composition.scm 89 */
return 
((obj_t)
BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4));}  else 
{ /* Llib/pgp_composition.scm 91 */
bool_t BgL_test2377z00_2010;
{ /* Llib/pgp_composition.scm 91 */
obj_t BgL_arg1524z00_91;
BgL_arg1524z00_91 = 
CAR(BgL_packetsz00_4); 
BgL_test2377z00_2010 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1524z00_91, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2377z00_2010)
{ /* Llib/pgp_composition.scm 91 */
if(
NULLP(
CDR(BgL_packetsz00_4)))
{ /* Llib/pgp_composition.scm 93 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 94 */
obj_t BgL_list1514z00_87;
BgL_list1514z00_87 = 
MAKE_YOUNG_PAIR(BGl_string2167z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1514z00_87); } 
{ /* Llib/pgp_composition.scm 95 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1138z00_89;
BgL_i1138z00_89 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(BgL_packetsz00_4)); 
{ 
obj_t BgL_packetsz00_2020;
BgL_packetsz00_2020 = 
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1138z00_89))->BgL_packetsz00); 
BgL_packetsz00_4 = BgL_packetsz00_2020; 
goto BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2;} } }  else 
{ /* Llib/pgp_composition.scm 91 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2168z00zz__openpgpzd2compositionzd2, BgL_packetsz00_4);} } } } } } } } 

}



/* &parse-packets */
obj_t BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1481, obj_t BgL_packetsz00_1482)
{
{ /* Llib/pgp_composition.scm 71 */
{ /* Llib/pgp_composition.scm 74 */
obj_t BgL_auxz00_2024;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_packetsz00_1482))
{ /* Llib/pgp_composition.scm 74 */
BgL_auxz00_2024 = BgL_packetsz00_1482
; }  else 
{ 
obj_t BgL_auxz00_2027;
BgL_auxz00_2027 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)3533)), BGl_string2170z00zz__openpgpzd2compositionzd2, BGl_string2171z00zz__openpgpzd2compositionzd2, BgL_packetsz00_1482); 
FAILURE(BgL_auxz00_2027,BFALSE,BFALSE);} 
return 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(BgL_auxz00_2024);} } 

}



/* parse-keys */
obj_t BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_5)
{
{ /* Llib/pgp_composition.scm 107 */
{ 
obj_t BgL_packetsz00_1120;obj_t BgL_keysz00_1121;obj_t BgL_userzd2idszd2_1122;
BgL_packetsz00_1120 = BgL_packetsz00_5; 
BgL_keysz00_1121 = BNIL; 
BgL_userzd2idszd2_1122 = BNIL; 
BgL_loopz00_1119:
if(
NULLP(BgL_packetsz00_1120))
{ /* Llib/pgp_composition.scm 112 */
return BgL_keysz00_1121;}  else 
{ /* Llib/pgp_composition.scm 114 */
obj_t BgL_keyz00_1130;
BgL_keyz00_1130 = 
BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(BgL_packetsz00_1120, BgL_userzd2idszd2_1122); 
{ /* Llib/pgp_composition.scm 116 */
obj_t BgL_remainingzd2packetszd2_1131;obj_t BgL_nuserzd2idszd2_1132;
{ /* Llib/pgp_composition.scm 116 */
int BgL_tmpz00_2035;
BgL_tmpz00_2035 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_1131 = 
BGL_MVALUES_VAL(BgL_tmpz00_2035); } 
{ /* Llib/pgp_composition.scm 116 */
int BgL_tmpz00_2038;
BgL_tmpz00_2038 = 
(int)(((long)2)); 
BgL_nuserzd2idszd2_1132 = 
BGL_MVALUES_VAL(BgL_tmpz00_2038); } 
{ 
obj_t BgL_userzd2idszd2_2044;obj_t BgL_keysz00_2042;obj_t BgL_packetsz00_2041;
BgL_packetsz00_2041 = BgL_remainingzd2packetszd2_1131; 
BgL_keysz00_2042 = 
BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(BgL_keyz00_1130, BgL_keysz00_1121); 
BgL_userzd2idszd2_2044 = 
BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(BgL_nuserzd2idszd2_1132, BgL_userzd2idszd2_1122); 
BgL_userzd2idszd2_1122 = BgL_userzd2idszd2_2044; 
BgL_keysz00_1121 = BgL_keysz00_2042; 
BgL_packetsz00_1120 = BgL_packetsz00_2041; 
goto BgL_loopz00_1119;} } } } } 

}



/* parse-key */
obj_t BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_6, obj_t BgL_userzd2idszd2_7)
{
{ /* Llib/pgp_composition.scm 123 */
{ 
obj_t BgL_packetsz00_162;obj_t BgL_packetsz00_181;obj_t BgL_packetsz00_214;obj_t BgL_packetsz00_238;
{ /* Llib/pgp_composition.scm 220 */
obj_t BgL_mainzd2keyzd2packetz00_121;
BgL_mainzd2keyzd2packetz00_121 = 
CAR(
((obj_t)BgL_packetsz00_6)); 
{ /* Llib/pgp_composition.scm 221 */
obj_t BgL_revocationzd2sigszd2_122;
{ /* Llib/pgp_composition.scm 222 */
obj_t BgL_arg1593z00_156;
BgL_arg1593z00_156 = 
CDR(
((obj_t)BgL_packetsz00_6)); 
BgL_packetsz00_162 = BgL_arg1593z00_156; 
{ 
obj_t BgL_packetsz00_166;obj_t BgL_revocationsz00_167;
BgL_packetsz00_166 = BgL_packetsz00_162; 
BgL_revocationsz00_167 = BNIL; 
BgL_zc3z04anonymousza31617ze3z87_168:
if(
NULLP(BgL_packetsz00_166))
{ /* Llib/pgp_composition.scm 135 */
obj_t BgL_val0_1225z00_170;
BgL_val0_1225z00_170 = 
bgl_reverse_bang(BgL_revocationsz00_167); 
{ /* Llib/pgp_composition.scm 135 */
int BgL_tmpz00_2053;
BgL_tmpz00_2053 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2053); } 
{ /* Llib/pgp_composition.scm 135 */
int BgL_tmpz00_2056;
BgL_tmpz00_2056 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2056, BNIL); } 
BgL_revocationzd2sigszd2_122 = BgL_val0_1225z00_170; }  else 
{ /* Llib/pgp_composition.scm 134 */
if(
BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_packetsz00_166))))
{ /* Llib/pgp_composition.scm 137 */
obj_t BgL_arg1624z00_174;obj_t BgL_arg1626z00_175;
BgL_arg1624z00_174 = 
CDR(
((obj_t)BgL_packetsz00_166)); 
{ /* Llib/pgp_composition.scm 138 */
obj_t BgL_arg1627z00_176;
BgL_arg1627z00_176 = 
CAR(
((obj_t)BgL_packetsz00_166)); 
BgL_arg1626z00_175 = 
MAKE_YOUNG_PAIR(BgL_arg1627z00_176, BgL_revocationsz00_167); } 
{ 
obj_t BgL_revocationsz00_2069;obj_t BgL_packetsz00_2068;
BgL_packetsz00_2068 = BgL_arg1624z00_174; 
BgL_revocationsz00_2069 = BgL_arg1626z00_175; 
BgL_revocationsz00_167 = BgL_revocationsz00_2069; 
BgL_packetsz00_166 = BgL_packetsz00_2068; 
goto BgL_zc3z04anonymousza31617ze3z87_168;} }  else 
{ /* Llib/pgp_composition.scm 140 */
obj_t BgL_val0_1227z00_177;
BgL_val0_1227z00_177 = 
bgl_reverse_bang(BgL_revocationsz00_167); 
{ /* Llib/pgp_composition.scm 140 */
int BgL_tmpz00_2071;
BgL_tmpz00_2071 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2071); } 
{ /* Llib/pgp_composition.scm 140 */
int BgL_tmpz00_2074;
BgL_tmpz00_2074 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2074, BgL_packetsz00_166); } 
BgL_revocationzd2sigszd2_122 = BgL_val0_1227z00_177; } } } } 
{ /* Llib/pgp_composition.scm 223 */
obj_t BgL_remainingzd2packetszd2_123;
{ /* Llib/pgp_composition.scm 223 */
int BgL_tmpz00_2077;
BgL_tmpz00_2077 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_123 = 
BGL_MVALUES_VAL(BgL_tmpz00_2077); } 
{ /* Llib/pgp_composition.scm 223 */
obj_t BgL_nuserzd2idszd2_124;
BgL_packetsz00_214 = BgL_remainingzd2packetszd2_123; 
{ 
obj_t BgL_packetsz00_218;obj_t BgL_userzd2idszd2_219;
BgL_packetsz00_218 = BgL_packetsz00_214; 
BgL_userzd2idszd2_219 = BNIL; 
BgL_zc3z04anonymousza31651ze3z87_220:
if(
NULLP(BgL_packetsz00_218))
{ /* Llib/pgp_composition.scm 167 */
obj_t BgL_val0_1233z00_222;
BgL_val0_1233z00_222 = 
bgl_reverse_bang(BgL_userzd2idszd2_219); 
{ /* Llib/pgp_composition.scm 167 */
int BgL_tmpz00_2083;
BgL_tmpz00_2083 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2083); } 
{ /* Llib/pgp_composition.scm 167 */
int BgL_tmpz00_2086;
BgL_tmpz00_2086 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2086, BNIL); } 
BgL_nuserzd2idszd2_124 = BgL_val0_1233z00_222; }  else 
{ /* Llib/pgp_composition.scm 168 */
bool_t BgL_test2384z00_2089;
{ /* Llib/pgp_composition.scm 168 */
obj_t BgL_arg1677z00_236;
BgL_arg1677z00_236 = 
CAR(
((obj_t)BgL_packetsz00_218)); 
BgL_test2384z00_2089 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1677z00_236, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2384z00_2089)
{ /* Llib/pgp_composition.scm 170 */
obj_t BgL_sigsz00_226;
{ /* Llib/pgp_composition.scm 171 */
obj_t BgL_arg1674z00_233;
BgL_arg1674z00_233 = 
CDR(
((obj_t)BgL_packetsz00_218)); 
BgL_packetsz00_181 = BgL_arg1674z00_233; 
{ 
obj_t BgL_pktz00_201;
{ 
obj_t BgL_packetsz00_186;obj_t BgL_sigsz00_187;
BgL_packetsz00_186 = BgL_packetsz00_181; 
BgL_sigsz00_187 = BNIL; 
BgL_zc3z04anonymousza31630ze3z87_188:
if(
NULLP(BgL_packetsz00_186))
{ /* Llib/pgp_composition.scm 154 */
obj_t BgL_val0_1229z00_190;
BgL_val0_1229z00_190 = 
bgl_reverse_bang(BgL_sigsz00_187); 
{ /* Llib/pgp_composition.scm 154 */
int BgL_tmpz00_2098;
BgL_tmpz00_2098 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2098); } 
{ /* Llib/pgp_composition.scm 154 */
int BgL_tmpz00_2101;
BgL_tmpz00_2101 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2101, BNIL); } 
BgL_sigsz00_226 = BgL_val0_1229z00_190; }  else 
{ /* Llib/pgp_composition.scm 155 */
bool_t BgL_test2386z00_2104;
BgL_pktz00_201 = 
CAR(
((obj_t)BgL_packetsz00_186)); 
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_201, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 146 */
obj_t BgL_casezd2valuezd2_205;
BgL_casezd2valuezd2_205 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_201))))->BgL_signaturezd2typezd2); 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1147z00_210;
BgL__ortest_1147z00_210 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)2))); 
if(BgL__ortest_1147z00_210)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2386z00_2104 = BgL__ortest_1147z00_210
; }  else 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1148z00_211;
BgL__ortest_1148z00_211 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)3))); 
if(BgL__ortest_1148z00_211)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2386z00_2104 = BgL__ortest_1148z00_211
; }  else 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1149z00_212;
BgL__ortest_1149z00_212 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)4))); 
if(BgL__ortest_1149z00_212)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2386z00_2104 = BgL__ortest_1149z00_212
; }  else 
{ /* Llib/pgp_composition.scm 146 */
BgL_test2386z00_2104 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)5)))
; } } } } }  else 
{ /* Llib/pgp_composition.scm 144 */
BgL_test2386z00_2104 = ((bool_t)0)
; } 
if(BgL_test2386z00_2104)
{ /* Llib/pgp_composition.scm 156 */
obj_t BgL_arg1643z00_194;obj_t BgL_arg1644z00_195;
BgL_arg1643z00_194 = 
CDR(
((obj_t)BgL_packetsz00_186)); 
{ /* Llib/pgp_composition.scm 157 */
obj_t BgL_arg1645z00_196;
BgL_arg1645z00_196 = 
CAR(
((obj_t)BgL_packetsz00_186)); 
BgL_arg1644z00_195 = 
MAKE_YOUNG_PAIR(BgL_arg1645z00_196, BgL_sigsz00_187); } 
{ 
obj_t BgL_sigsz00_2129;obj_t BgL_packetsz00_2128;
BgL_packetsz00_2128 = BgL_arg1643z00_194; 
BgL_sigsz00_2129 = BgL_arg1644z00_195; 
BgL_sigsz00_187 = BgL_sigsz00_2129; 
BgL_packetsz00_186 = BgL_packetsz00_2128; 
goto BgL_zc3z04anonymousza31630ze3z87_188;} }  else 
{ /* Llib/pgp_composition.scm 159 */
obj_t BgL_val0_1231z00_197;
BgL_val0_1231z00_197 = 
bgl_reverse_bang(BgL_sigsz00_187); 
{ /* Llib/pgp_composition.scm 159 */
int BgL_tmpz00_2131;
BgL_tmpz00_2131 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2131); } 
{ /* Llib/pgp_composition.scm 159 */
int BgL_tmpz00_2134;
BgL_tmpz00_2134 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2134, BgL_packetsz00_186); } 
BgL_sigsz00_226 = BgL_val0_1231z00_197; } } } } } 
{ /* Llib/pgp_composition.scm 172 */
obj_t BgL_remainingzd2packetszd2_227;
{ /* Llib/pgp_composition.scm 172 */
int BgL_tmpz00_2137;
BgL_tmpz00_2137 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_227 = 
BGL_MVALUES_VAL(BgL_tmpz00_2137); } 
{ /* Llib/pgp_composition.scm 173 */
obj_t BgL_arg1661z00_228;
{ /* Llib/pgp_composition.scm 173 */
BgL_signedzd2idzd2_bglt BgL_arg1662z00_229;
{ /* Llib/pgp_composition.scm 173 */
BgL_signedzd2idzd2_bglt BgL_new1154z00_230;
{ /* Llib/pgp_composition.scm 175 */
BgL_signedzd2idzd2_bglt BgL_new1153z00_231;
BgL_new1153z00_231 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 175 */
long BgL_arg1671z00_232;
BgL_arg1671z00_232 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_231), BgL_arg1671z00_232); } 
{ /* Llib/pgp_composition.scm 175 */
BgL_objectz00_bglt BgL_tmpz00_2144;
BgL_tmpz00_2144 = 
((BgL_objectz00_bglt)BgL_new1153z00_231); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2144, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1153z00_231); 
BgL_new1154z00_230 = BgL_new1153z00_231; } 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1154z00_230))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_218)))),BUNSPEC); 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1154z00_230))->BgL_sigsz00)=((obj_t)BgL_sigsz00_226),BUNSPEC); 
BgL_arg1662z00_229 = BgL_new1154z00_230; } 
BgL_arg1661z00_228 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1662z00_229), BgL_userzd2idszd2_219); } 
{ 
obj_t BgL_userzd2idszd2_2156;obj_t BgL_packetsz00_2155;
BgL_packetsz00_2155 = BgL_remainingzd2packetszd2_227; 
BgL_userzd2idszd2_2156 = BgL_arg1661z00_228; 
BgL_userzd2idszd2_219 = BgL_userzd2idszd2_2156; 
BgL_packetsz00_218 = BgL_packetsz00_2155; 
goto BgL_zc3z04anonymousza31651ze3z87_220;} } } }  else 
{ /* Llib/pgp_composition.scm 178 */
obj_t BgL_val0_1235z00_234;
BgL_val0_1235z00_234 = 
bgl_reverse_bang(BgL_userzd2idszd2_219); 
{ /* Llib/pgp_composition.scm 178 */
int BgL_tmpz00_2158;
BgL_tmpz00_2158 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2158); } 
{ /* Llib/pgp_composition.scm 178 */
int BgL_tmpz00_2161;
BgL_tmpz00_2161 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2161, BgL_packetsz00_218); } 
BgL_nuserzd2idszd2_124 = BgL_val0_1235z00_234; } } } 
{ /* Llib/pgp_composition.scm 228 */
obj_t BgL_remainingzd2packetszd2_125;
{ /* Llib/pgp_composition.scm 228 */
int BgL_tmpz00_2164;
BgL_tmpz00_2164 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_125 = 
BGL_MVALUES_VAL(BgL_tmpz00_2164); } 
{ /* Llib/pgp_composition.scm 225 */
bool_t BgL_test2391z00_2167;
if(
NULLP(BgL_nuserzd2idszd2_124))
{ /* Llib/pgp_composition.scm 225 */
BgL_test2391z00_2167 = 
NULLP(BgL_userzd2idszd2_7)
; }  else 
{ /* Llib/pgp_composition.scm 225 */
BgL_test2391z00_2167 = ((bool_t)0)
; } 
if(BgL_test2391z00_2167)
{ /* Llib/pgp_composition.scm 225 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2173z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 225 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 229 */
obj_t BgL_subkeysz00_129;
BgL_packetsz00_238 = BgL_remainingzd2packetszd2_125; 
{ 
obj_t BgL_packetsz00_243;obj_t BgL_subkeysz00_244;
BgL_packetsz00_243 = BgL_packetsz00_238; 
BgL_subkeysz00_244 = BNIL; 
BgL_zc3z04anonymousza31679ze3z87_245:
{ /* Llib/pgp_composition.scm 188 */
bool_t BgL_test2393z00_2173;
if(
NULLP(BgL_packetsz00_243))
{ /* Llib/pgp_composition.scm 188 */
BgL_test2393z00_2173 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 188 */
BgL_test2393z00_2173 = 
NULLP(
CDR(
((obj_t)BgL_packetsz00_243)))
; } 
if(BgL_test2393z00_2173)
{ /* Llib/pgp_composition.scm 190 */
obj_t BgL_val0_1237z00_249;
BgL_val0_1237z00_249 = 
bgl_reverse_bang(BgL_subkeysz00_244); 
{ /* Llib/pgp_composition.scm 190 */
int BgL_tmpz00_2180;
BgL_tmpz00_2180 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2180); } 
{ /* Llib/pgp_composition.scm 190 */
int BgL_tmpz00_2183;
BgL_tmpz00_2183 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2183, BNIL); } 
BgL_subkeysz00_129 = BgL_val0_1237z00_249; }  else 
{ /* Llib/pgp_composition.scm 191 */
bool_t BgL_test2395z00_2186;
{ /* Llib/pgp_composition.scm 191 */
obj_t BgL_arg1730z00_291;
BgL_arg1730z00_291 = 
CAR(
((obj_t)BgL_packetsz00_243)); 
BgL_test2395z00_2186 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1730z00_291, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2395z00_2186)
{ /* Llib/pgp_composition.scm 192 */
obj_t BgL_g1159z00_253;
BgL_g1159z00_253 = 
CDR(
((obj_t)BgL_packetsz00_243)); 
{ 
obj_t BgL_pktsz00_257;obj_t BgL_subkeyzd2sigszd2_258;obj_t BgL_revoczd2sigszd2_259;
BgL_pktsz00_257 = BgL_g1159z00_253; 
BgL_subkeyzd2sigszd2_258 = BNIL; 
BgL_revoczd2sigszd2_259 = BNIL; 
BgL_zc3z04anonymousza31686ze3z87_260:
{ /* Llib/pgp_composition.scm 196 */
bool_t BgL_test2396z00_2192;
if(
NULLP(BgL_pktsz00_257))
{ /* Llib/pgp_composition.scm 196 */
BgL_test2396z00_2192 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 196 */
if(
BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 197 */
BgL_test2396z00_2192 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 197 */
if(
BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 198 */
BgL_test2396z00_2192 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 198 */
BgL_test2396z00_2192 = ((bool_t)1)
; } } } 
if(BgL_test2396z00_2192)
{ /* Llib/pgp_composition.scm 196 */
if(
NULLP(BgL_subkeyzd2sigszd2_258))
{ /* Llib/pgp_composition.scm 199 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2172z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 199 */BFALSE; } 
{ /* Llib/pgp_composition.scm 204 */
obj_t BgL_arg1703z00_269;
{ /* Llib/pgp_composition.scm 204 */
BgL_pgpzd2subkeyzd2_bglt BgL_arg1705z00_270;
{ /* Llib/pgp_composition.scm 204 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1164z00_271;
{ /* Llib/pgp_composition.scm 208 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1163z00_272;
BgL_new1163z00_272 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 208 */
long BgL_arg1706z00_273;
BgL_arg1706z00_273 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1163z00_272), BgL_arg1706z00_273); } 
{ /* Llib/pgp_composition.scm 208 */
BgL_objectz00_bglt BgL_tmpz00_2211;
BgL_tmpz00_2211 = 
((BgL_objectz00_bglt)BgL_new1163z00_272); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2211, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1163z00_272); 
BgL_new1164z00_271 = BgL_new1163z00_272; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1164z00_271))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_243)))),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1164z00_271))->BgL_sigsz00)=((obj_t)BgL_subkeyzd2sigszd2_258),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1164z00_271))->BgL_revocationzd2sigszd2)=((obj_t)BgL_revoczd2sigszd2_259),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_2221;
{ /* Llib/pgp_composition.scm 208 */
obj_t BgL_classz00_1158;
BgL_classz00_1158 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 208 */
obj_t BgL__ortest_1111z00_1159;
BgL__ortest_1111z00_1159 = 
BGL_CLASS_NIL(BgL_classz00_1158); 
if(
CBOOL(BgL__ortest_1111z00_1159))
{ /* Llib/pgp_composition.scm 208 */
BgL_auxz00_2221 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1111z00_1159)
; }  else 
{ /* Llib/pgp_composition.scm 208 */
BgL_auxz00_2221 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1158))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1164z00_271))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_2221),BUNSPEC); } 
BgL_arg1705z00_270 = BgL_new1164z00_271; } 
BgL_arg1703z00_269 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1705z00_270), BgL_subkeysz00_244); } 
{ 
obj_t BgL_subkeysz00_2232;obj_t BgL_packetsz00_2231;
BgL_packetsz00_2231 = BgL_pktsz00_257; 
BgL_subkeysz00_2232 = BgL_arg1703z00_269; 
BgL_subkeysz00_244 = BgL_subkeysz00_2232; 
BgL_packetsz00_243 = BgL_packetsz00_2231; 
goto BgL_zc3z04anonymousza31679ze3z87_245;} } }  else 
{ /* Llib/pgp_composition.scm 196 */
if(
BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 211 */
obj_t BgL_arg1714z00_276;obj_t BgL_arg1715z00_277;
BgL_arg1714z00_276 = 
CDR(
((obj_t)BgL_pktsz00_257)); 
{ /* Llib/pgp_composition.scm 211 */
obj_t BgL_arg1716z00_278;
BgL_arg1716z00_278 = 
CAR(
((obj_t)BgL_pktsz00_257)); 
BgL_arg1715z00_277 = 
MAKE_YOUNG_PAIR(BgL_arg1716z00_278, BgL_subkeyzd2sigszd2_258); } 
{ 
obj_t BgL_subkeyzd2sigszd2_2243;obj_t BgL_pktsz00_2242;
BgL_pktsz00_2242 = BgL_arg1714z00_276; 
BgL_subkeyzd2sigszd2_2243 = BgL_arg1715z00_277; 
BgL_subkeyzd2sigszd2_258 = BgL_subkeyzd2sigszd2_2243; 
BgL_pktsz00_257 = BgL_pktsz00_2242; 
goto BgL_zc3z04anonymousza31686ze3z87_260;} }  else 
{ /* Llib/pgp_composition.scm 213 */
obj_t BgL_arg1717z00_279;obj_t BgL_arg1718z00_280;
BgL_arg1717z00_279 = 
CDR(
((obj_t)BgL_pktsz00_257)); 
{ /* Llib/pgp_composition.scm 214 */
obj_t BgL_arg1719z00_281;
BgL_arg1719z00_281 = 
CAR(
((obj_t)BgL_pktsz00_257)); 
BgL_arg1718z00_280 = 
MAKE_YOUNG_PAIR(BgL_arg1719z00_281, BgL_revoczd2sigszd2_259); } 
{ 
obj_t BgL_revoczd2sigszd2_2250;obj_t BgL_pktsz00_2249;
BgL_pktsz00_2249 = BgL_arg1717z00_279; 
BgL_revoczd2sigszd2_2250 = BgL_arg1718z00_280; 
BgL_revoczd2sigszd2_259 = BgL_revoczd2sigszd2_2250; 
BgL_pktsz00_257 = BgL_pktsz00_2249; 
goto BgL_zc3z04anonymousza31686ze3z87_260;} } } } } }  else 
{ /* Llib/pgp_composition.scm 216 */
obj_t BgL_val0_1239z00_289;
BgL_val0_1239z00_289 = 
bgl_reverse_bang(BgL_subkeysz00_244); 
{ /* Llib/pgp_composition.scm 216 */
int BgL_tmpz00_2252;
BgL_tmpz00_2252 = 
(int)(((long)2)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2252); } 
{ /* Llib/pgp_composition.scm 216 */
int BgL_tmpz00_2255;
BgL_tmpz00_2255 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2255, BgL_packetsz00_243); } 
BgL_subkeysz00_129 = BgL_val0_1239z00_289; } } } } 
{ /* Llib/pgp_composition.scm 231 */
obj_t BgL_remainingzd2packetszd2_130;
{ /* Llib/pgp_composition.scm 231 */
int BgL_tmpz00_2258;
BgL_tmpz00_2258 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_130 = 
BGL_MVALUES_VAL(BgL_tmpz00_2258); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_mainzd2keyzd2packetz00_121, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 232 */
BgL_pgpzd2subkeyzd2_bglt BgL_mainzd2keyzd2_132;
{ /* Llib/pgp_composition.scm 232 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1166z00_150;
{ /* Llib/pgp_composition.scm 233 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1165z00_151;
BgL_new1165z00_151 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 233 */
long BgL_arg1591z00_152;
BgL_arg1591z00_152 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1165z00_151), BgL_arg1591z00_152); } 
{ /* Llib/pgp_composition.scm 233 */
BgL_objectz00_bglt BgL_tmpz00_2267;
BgL_tmpz00_2267 = 
((BgL_objectz00_bglt)BgL_new1165z00_151); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2267, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1165z00_151); 
BgL_new1166z00_150 = BgL_new1165z00_151; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1166z00_150))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_mainzd2keyzd2packetz00_121)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1166z00_150))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1166z00_150))->BgL_revocationzd2sigszd2)=((obj_t)BgL_revocationzd2sigszd2_122),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_2275;
{ /* Llib/pgp_composition.scm 236 */
obj_t BgL_classz00_1171;
BgL_classz00_1171 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 236 */
obj_t BgL__ortest_1111z00_1172;
BgL__ortest_1111z00_1172 = 
BGL_CLASS_NIL(BgL_classz00_1171); 
if(
CBOOL(BgL__ortest_1111z00_1172))
{ /* Llib/pgp_composition.scm 236 */
BgL_auxz00_2275 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1111z00_1172)
; }  else 
{ /* Llib/pgp_composition.scm 236 */
BgL_auxz00_2275 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1171))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1166z00_150))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_2275),BUNSPEC); } 
BgL_mainzd2keyzd2_132 = BgL_new1166z00_150; } 
{ /* Llib/pgp_composition.scm 232 */
obj_t BgL_allzd2subkeyszd2_133;
BgL_allzd2subkeyszd2_133 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_mainzd2keyzd2_132), BgL_subkeysz00_129); 
{ /* Llib/pgp_composition.scm 237 */
BgL_pgpzd2keyzd2_bglt BgL_reszd2keyzd2_134;
{ /* Llib/pgp_composition.scm 238 */
BgL_pgpzd2keyzd2_bglt BgL_new1168z00_147;
{ /* Llib/pgp_composition.scm 240 */
BgL_pgpzd2keyzd2_bglt BgL_new1167z00_148;
BgL_new1167z00_148 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 240 */
long BgL_arg1582z00_149;
BgL_arg1582z00_149 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1167z00_148), BgL_arg1582z00_149); } 
{ /* Llib/pgp_composition.scm 240 */
BgL_objectz00_bglt BgL_tmpz00_2289;
BgL_tmpz00_2289 = 
((BgL_objectz00_bglt)BgL_new1167z00_148); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2289, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1167z00_148); 
BgL_new1168z00_147 = BgL_new1167z00_148; } 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1168z00_147))->BgL_subkeysz00)=((obj_t)BgL_allzd2subkeyszd2_133),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1168z00_147))->BgL_userzd2idszd2)=((obj_t)
BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(BgL_nuserzd2idszd2_124, BgL_userzd2idszd2_7)),BUNSPEC); 
BgL_reszd2keyzd2_134 = BgL_new1168z00_147; } 
{ /* Llib/pgp_composition.scm 238 */

{ 
obj_t BgL_l1241z00_136;
BgL_l1241z00_136 = BgL_allzd2subkeyszd2_133; 
BgL_zc3z04anonymousza31568ze3z87_137:
if(
PAIRP(BgL_l1241z00_136))
{ /* Llib/pgp_composition.scm 241 */
{ /* Llib/pgp_composition.scm 242 */
obj_t BgL_skeyz00_139;
BgL_skeyz00_139 = 
CAR(BgL_l1241z00_136); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_skeyz00_139)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_reszd2keyzd2_134),BUNSPEC); } 
{ 
obj_t BgL_l1241z00_2301;
BgL_l1241z00_2301 = 
CDR(BgL_l1241z00_136); 
BgL_l1241z00_136 = BgL_l1241z00_2301; 
goto BgL_zc3z04anonymousza31568ze3z87_137;} }  else 
{ /* Llib/pgp_composition.scm 241 */((bool_t)1); } } 
{ /* Llib/pgp_composition.scm 245 */
obj_t BgL_val0_1243z00_143;
{ /* Llib/pgp_composition.scm 245 */
obj_t BgL_list1581z00_146;
BgL_list1581z00_146 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_reszd2keyzd2_134), BNIL); 
BgL_val0_1243z00_143 = BgL_list1581z00_146; } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2305;
BgL_tmpz00_2305 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2305); } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2308;
BgL_tmpz00_2308 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2308, BgL_remainingzd2packetszd2_130); } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2311;
BgL_tmpz00_2311 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2311, BgL_nuserzd2idszd2_124); } 
return BgL_val0_1243z00_143;} } } } }  else 
{ /* Llib/pgp_composition.scm 231 */
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2314;
BgL_tmpz00_2314 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2314); } 
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2317;
BgL_tmpz00_2317 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2317, BgL_remainingzd2packetszd2_130); } 
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2320;
BgL_tmpz00_2320 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2320, BgL_userzd2idszd2_7); } 
return BNIL;} } } } } } } } } } 

}



/* revocation-signature?~0 */
bool_t BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(obj_t BgL_pktz00_157)
{
{ /* Llib/pgp_composition.scm 128 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_157, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 126 */
return 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_157))))->BgL_signaturezd2typezd2)==
CNST_TABLE_REF(((long)7)));}  else 
{ /* Llib/pgp_composition.scm 126 */
return ((bool_t)0);} } 

}



/* subkey-sig?~0 */
bool_t BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(obj_t BgL_pktz00_295)
{
{ /* Llib/pgp_composition.scm 184 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_295, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 182 */
return 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_295))))->BgL_signaturezd2typezd2)==
CNST_TABLE_REF(((long)8)));}  else 
{ /* Llib/pgp_composition.scm 182 */
return ((bool_t)0);} } 

}



/* parse-encrypted-message */
obj_t BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_8)
{
{ /* Llib/pgp_composition.scm 251 */
{ 
obj_t BgL_packetsz00_308;obj_t BgL_sessionzd2keyszd2_309;
BgL_packetsz00_308 = BgL_packetsz00_8; 
BgL_sessionzd2keyszd2_309 = BNIL; 
BgL_zc3z04anonymousza31738ze3z87_310:
if(
NULLP(BgL_packetsz00_308))
{ /* Llib/pgp_composition.scm 256 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2174z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 260 */
bool_t BgL_test2409z00_2341;
{ /* Llib/pgp_composition.scm 260 */
obj_t BgL_arg1791z00_341;
BgL_arg1791z00_341 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2409z00_2341 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1791z00_341, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2409z00_2341)
{ /* Llib/pgp_composition.scm 260 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_308))))
{ /* Llib/pgp_composition.scm 261 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 262 */
obj_t BgL_list1750z00_316;
BgL_list1750z00_316 = 
MAKE_YOUNG_PAIR(BGl_string2175z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1750z00_316); } 
{ /* Llib/pgp_composition.scm 263 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1172z00_318;
{ /* Llib/pgp_composition.scm 264 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1171z00_319;
BgL_new1171z00_319 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 264 */
long BgL_arg1763z00_320;
BgL_arg1763z00_320 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1171z00_319), BgL_arg1763z00_320); } 
{ /* Llib/pgp_composition.scm 264 */
BgL_objectz00_bglt BgL_tmpz00_2355;
BgL_tmpz00_2355 = 
((BgL_objectz00_bglt)BgL_new1171z00_319); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2355, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1171z00_319); 
BgL_new1172z00_318 = BgL_new1171z00_319; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1172z00_318))->BgL_sessionzd2keyszd2)=((obj_t)
bgl_reverse_bang(BgL_sessionzd2keyszd2_309)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1172z00_318))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
CAR(
((obj_t)BgL_packetsz00_308)))),BUNSPEC); 
return 
((obj_t)BgL_new1172z00_318);} }  else 
{ /* Llib/pgp_composition.scm 266 */
bool_t BgL_test2411z00_2366;
{ /* Llib/pgp_composition.scm 266 */
obj_t BgL_arg1790z00_340;
BgL_arg1790z00_340 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2411z00_2366 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1790z00_340, BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2411z00_2366)
{ /* Llib/pgp_composition.scm 266 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_308))))
{ /* Llib/pgp_composition.scm 267 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 268 */
obj_t BgL_list1777z00_325;
BgL_list1777z00_325 = 
MAKE_YOUNG_PAIR(BGl_string2175z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1777z00_325); } 
{ /* Llib/pgp_composition.scm 269 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1174z00_327;
{ /* Llib/pgp_composition.scm 270 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1173z00_328;
BgL_new1173z00_328 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 270 */
long BgL_arg1779z00_329;
BgL_arg1779z00_329 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_328), BgL_arg1779z00_329); } 
{ /* Llib/pgp_composition.scm 270 */
BgL_objectz00_bglt BgL_tmpz00_2380;
BgL_tmpz00_2380 = 
((BgL_objectz00_bglt)BgL_new1173z00_328); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2380, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1173z00_328); 
BgL_new1174z00_327 = BgL_new1173z00_328; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1174z00_327))->BgL_sessionzd2keyszd2)=((obj_t)
bgl_reverse_bang(BgL_sessionzd2keyszd2_309)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1174z00_327))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
CAR(
((obj_t)BgL_packetsz00_308)))),BUNSPEC); 
return 
((obj_t)BgL_new1174z00_327);} }  else 
{ /* Llib/pgp_composition.scm 272 */
bool_t BgL_test2413z00_2391;
{ /* Llib/pgp_composition.scm 272 */
obj_t BgL_arg1789z00_339;
BgL_arg1789z00_339 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2413z00_2391 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1789z00_339, BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2413z00_2391)
{ /* Llib/pgp_composition.scm 273 */
obj_t BgL_arg1782z00_332;obj_t BgL_arg1783z00_333;
BgL_arg1782z00_332 = 
CDR(
((obj_t)BgL_packetsz00_308)); 
{ /* Llib/pgp_composition.scm 274 */
obj_t BgL_arg1784z00_334;
BgL_arg1784z00_334 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_arg1783z00_333 = 
MAKE_YOUNG_PAIR(BgL_arg1784z00_334, BgL_sessionzd2keyszd2_309); } 
{ 
obj_t BgL_sessionzd2keyszd2_2401;obj_t BgL_packetsz00_2400;
BgL_packetsz00_2400 = BgL_arg1782z00_332; 
BgL_sessionzd2keyszd2_2401 = BgL_arg1783z00_333; 
BgL_sessionzd2keyszd2_309 = BgL_sessionzd2keyszd2_2401; 
BgL_packetsz00_308 = BgL_packetsz00_2400; 
goto BgL_zc3z04anonymousza31738ze3z87_310;} }  else 
{ /* Llib/pgp_composition.scm 272 */
{ /* Llib/pgp_composition.scm 277 */
obj_t BgL_arg1785z00_335;
BgL_arg1785z00_335 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
{ /* Llib/pgp_composition.scm 276 */
obj_t BgL_list1786z00_336;
{ /* Llib/pgp_composition.scm 276 */
obj_t BgL_arg1787z00_337;
BgL_arg1787z00_337 = 
MAKE_YOUNG_PAIR(BgL_arg1785z00_335, BNIL); 
BgL_list1786z00_336 = 
MAKE_YOUNG_PAIR(BGl_string2176z00zz__openpgpzd2compositionzd2, BgL_arg1787z00_337); } 
BGl_warningz00zz__errorz00(BgL_list1786z00_336); } } 
{ /* Llib/pgp_composition.scm 278 */
obj_t BgL_arg1788z00_338;
BgL_arg1788z00_338 = 
CDR(
((obj_t)BgL_packetsz00_308)); 
{ 
obj_t BgL_packetsz00_2409;
BgL_packetsz00_2409 = BgL_arg1788z00_338; 
BgL_packetsz00_308 = BgL_packetsz00_2409; 
goto BgL_zc3z04anonymousza31738ze3z87_310;} } } } } } } } 

}



/* parse-signature */
BgL_pgpzd2signaturezd2_bglt BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_9)
{
{ /* Llib/pgp_composition.scm 283 */
{ 
obj_t BgL_packetsz00_345;obj_t BgL_sigsz00_346;
BgL_packetsz00_345 = BgL_packetsz00_9; 
BgL_sigsz00_346 = BNIL; 
BgL_zc3z04anonymousza31792ze3z87_347:
if(
NULLP(BgL_packetsz00_345))
{ /* Llib/pgp_composition.scm 290 */
BgL_pgpzd2signaturezd2_bglt BgL_new1177z00_349;
{ /* Llib/pgp_composition.scm 291 */
BgL_pgpzd2signaturezd2_bglt BgL_new1176z00_350;
BgL_new1176z00_350 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 291 */
long BgL_arg1794z00_351;
BgL_arg1794z00_351 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_350), BgL_arg1794z00_351); } 
BgL_new1177z00_349 = BgL_new1176z00_350; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1177z00_349))->BgL_msgz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1177z00_349))->BgL_sigsz00)=((obj_t)
bgl_reverse_bang(BgL_sigsz00_346)),BUNSPEC); 
return BgL_new1177z00_349;}  else 
{ /* Llib/pgp_composition.scm 293 */
bool_t BgL_test2415z00_2419;
{ /* Llib/pgp_composition.scm 293 */
obj_t BgL_arg1818z00_377;
BgL_arg1818z00_377 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2415z00_2419 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1818z00_377, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2415z00_2419)
{ /* Llib/pgp_composition.scm 294 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1178z00_354;
BgL_i1178z00_354 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_345))); 
{ 
obj_t BgL_packetsz00_2426;
BgL_packetsz00_2426 = 
BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1178z00_354))->BgL_packetsz00), BgL_packetsz00_345); 
BgL_packetsz00_345 = BgL_packetsz00_2426; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} }  else 
{ /* Llib/pgp_composition.scm 296 */
bool_t BgL_test2416z00_2429;
{ /* Llib/pgp_composition.scm 296 */
obj_t BgL_arg1817z00_376;
BgL_arg1817z00_376 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2416z00_2429 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1817z00_376, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2416z00_2429)
{ /* Llib/pgp_composition.scm 297 */
obj_t BgL_arg1801z00_359;obj_t BgL_arg1803z00_360;
BgL_arg1801z00_359 = 
CDR(
((obj_t)BgL_packetsz00_345)); 
{ /* Llib/pgp_composition.scm 297 */
obj_t BgL_arg1804z00_361;
BgL_arg1804z00_361 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_arg1803z00_360 = 
MAKE_YOUNG_PAIR(BgL_arg1804z00_361, BgL_sigsz00_346); } 
{ 
obj_t BgL_sigsz00_2439;obj_t BgL_packetsz00_2438;
BgL_packetsz00_2438 = BgL_arg1801z00_359; 
BgL_sigsz00_2439 = BgL_arg1803z00_360; 
BgL_sigsz00_346 = BgL_sigsz00_2439; 
BgL_packetsz00_345 = BgL_packetsz00_2438; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} }  else 
{ /* Llib/pgp_composition.scm 298 */
bool_t BgL_test2417z00_2440;
{ /* Llib/pgp_composition.scm 298 */
obj_t BgL_arg1816z00_375;
BgL_arg1816z00_375 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2417z00_2440 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1816z00_375, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2417z00_2440)
{ /* Llib/pgp_composition.scm 298 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_345))))
{ /* Llib/pgp_composition.scm 299 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 300 */
obj_t BgL_list1809z00_366;
BgL_list1809z00_366 = 
MAKE_YOUNG_PAIR(BGl_string2177z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1809z00_366); } 
{ /* Llib/pgp_composition.scm 301 */
BgL_pgpzd2signaturezd2_bglt BgL_new1180z00_368;
{ /* Llib/pgp_composition.scm 302 */
BgL_pgpzd2signaturezd2_bglt BgL_new1179z00_369;
BgL_new1179z00_369 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 302 */
long BgL_arg1811z00_370;
BgL_arg1811z00_370 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_369), BgL_arg1811z00_370); } 
BgL_new1180z00_368 = BgL_new1179z00_369; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1180z00_368))->BgL_msgz00)=((obj_t)
CAR(
((obj_t)BgL_packetsz00_345))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1180z00_368))->BgL_sigsz00)=((obj_t)
bgl_reverse_bang(BgL_sigsz00_346)),BUNSPEC); 
return BgL_new1180z00_368;} }  else 
{ /* Llib/pgp_composition.scm 298 */
{ /* Llib/pgp_composition.scm 306 */
obj_t BgL_arg1812z00_371;
BgL_arg1812z00_371 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
{ /* Llib/pgp_composition.scm 305 */
obj_t BgL_list1813z00_372;
{ /* Llib/pgp_composition.scm 305 */
obj_t BgL_arg1814z00_373;
BgL_arg1814z00_373 = 
MAKE_YOUNG_PAIR(BgL_arg1812z00_371, BNIL); 
BgL_list1813z00_372 = 
MAKE_YOUNG_PAIR(BGl_string2176z00zz__openpgpzd2compositionzd2, BgL_arg1814z00_373); } 
BGl_warningz00zz__errorz00(BgL_list1813z00_372); } } 
{ /* Llib/pgp_composition.scm 307 */
obj_t BgL_arg1815z00_374;
BgL_arg1815z00_374 = 
CDR(
((obj_t)BgL_packetsz00_345)); 
{ 
obj_t BgL_packetsz00_2466;
BgL_packetsz00_2466 = BgL_arg1815z00_374; 
BgL_packetsz00_345 = BgL_packetsz00_2466; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} } } } } } } } 

}



/* parse-one-pass-signature */
obj_t BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_10)
{
{ /* Llib/pgp_composition.scm 312 */
{ 
obj_t BgL_opzd2pktzd2_436;obj_t BgL_pktz00_437;
{ 
obj_t BgL_packetsz00_383;bool_t BgL_expectzd2onezd2passzf3zf3_384;obj_t BgL_onezd2passzd2sigsz00_385;obj_t BgL_msgz00_386;obj_t BgL_sigsz00_387;
BgL_packetsz00_383 = BgL_packetsz00_10; 
BgL_expectzd2onezd2passzf3zf3_384 = ((bool_t)1); 
BgL_onezd2passzd2sigsz00_385 = BNIL; 
BgL_msgz00_386 = BFALSE; 
BgL_sigsz00_387 = BNIL; 
BgL_zc3z04anonymousza31819ze3z87_388:
if(
NULLP(BgL_packetsz00_383))
{ /* Llib/pgp_composition.scm 336 */
obj_t BgL_onezd2passzd2sigsz00_390;
BgL_onezd2passzd2sigsz00_390 = 
bgl_reverse_bang(BgL_onezd2passzd2sigsz00_385); 
if(
(
bgl_list_length(BgL_onezd2passzd2sigsz00_390)==
bgl_list_length(BgL_sigsz00_387)))
{ /* Llib/pgp_composition.scm 337 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 337 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2178z00zz__openpgpzd2compositionzd2, BFALSE); } 
{ 
obj_t BgL_ll1249z00_397;obj_t BgL_ll1250z00_398;
BgL_ll1249z00_397 = BgL_onezd2passzd2sigsz00_390; 
BgL_ll1250z00_398 = BgL_sigsz00_387; 
BgL_zc3z04anonymousza31826ze3z87_399:
if(
NULLP(BgL_ll1249z00_397))
{ /* Llib/pgp_composition.scm 342 */((bool_t)1); }  else 
{ /* Llib/pgp_composition.scm 342 */
{ /* Llib/pgp_composition.scm 343 */
obj_t BgL_opzd2pktzd2_401;obj_t BgL_sigzd2pktzd2_402;
BgL_opzd2pktzd2_401 = 
CAR(
((obj_t)BgL_ll1249z00_397)); 
BgL_sigzd2pktzd2_402 = 
CAR(
((obj_t)BgL_ll1250z00_398)); 
{ /* Llib/pgp_composition.scm 343 */
bool_t BgL_test2422z00_2482;
BgL_opzd2pktzd2_436 = BgL_opzd2pktzd2_401; 
BgL_pktz00_437 = BgL_sigzd2pktzd2_402; 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_issuerz00), 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_issuerz00)))
{ /* Llib/pgp_composition.scm 323 */
if(
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_publiczd2keyzd2algoz00)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_publiczd2keyzd2algoz00)))
{ /* Llib/pgp_composition.scm 324 */
if(
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_hashzd2algozd2)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_hashzd2algozd2)))
{ /* Llib/pgp_composition.scm 325 */
BgL_test2422z00_2482 = 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_signaturezd2typezd2)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_signaturezd2typezd2))
; }  else 
{ /* Llib/pgp_composition.scm 325 */
BgL_test2422z00_2482 = ((bool_t)0)
; } }  else 
{ /* Llib/pgp_composition.scm 324 */
BgL_test2422z00_2482 = ((bool_t)0)
; } }  else 
{ /* Llib/pgp_composition.scm 323 */
BgL_test2422z00_2482 = ((bool_t)0)
; } 
if(BgL_test2422z00_2482)
{ /* Llib/pgp_composition.scm 343 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 343 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2179z00zz__openpgpzd2compositionzd2, BFALSE); } } } 
{ /* Llib/pgp_composition.scm 342 */
obj_t BgL_arg1829z00_404;obj_t BgL_arg1830z00_405;
BgL_arg1829z00_404 = 
CDR(
((obj_t)BgL_ll1249z00_397)); 
BgL_arg1830z00_405 = 
CDR(
((obj_t)BgL_ll1250z00_398)); 
{ 
obj_t BgL_ll1250z00_2521;obj_t BgL_ll1249z00_2520;
BgL_ll1249z00_2520 = BgL_arg1829z00_404; 
BgL_ll1250z00_2521 = BgL_arg1830z00_405; 
BgL_ll1250z00_398 = BgL_ll1250z00_2521; 
BgL_ll1249z00_397 = BgL_ll1249z00_2520; 
goto BgL_zc3z04anonymousza31826ze3z87_399;} } } } 
{ /* Llib/pgp_composition.scm 349 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1189z00_407;
{ /* Llib/pgp_composition.scm 351 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1188z00_408;
BgL_new1188z00_408 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 351 */
long BgL_arg1831z00_409;
BgL_arg1831z00_409 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1188z00_408), BgL_arg1831z00_409); } 
{ /* Llib/pgp_composition.scm 351 */
BgL_objectz00_bglt BgL_tmpz00_2526;
BgL_tmpz00_2526 = 
((BgL_objectz00_bglt)BgL_new1188z00_408); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2526, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1188z00_408); 
BgL_new1189z00_407 = BgL_new1188z00_408; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1189z00_407)))->BgL_msgz00)=((obj_t)BgL_msgz00_386),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1189z00_407)))->BgL_sigsz00)=((obj_t)BgL_sigsz00_387),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(BgL_new1189z00_407))->BgL_onezd2passzd2sigsz00)=((obj_t)BgL_onezd2passzd2sigsz00_390),BUNSPEC); 
return 
((obj_t)BgL_new1189z00_407);} }  else 
{ /* Llib/pgp_composition.scm 353 */
bool_t BgL_test2426z00_2536;
{ /* Llib/pgp_composition.scm 353 */
obj_t BgL_arg1854z00_434;
BgL_arg1854z00_434 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2426z00_2536 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1854z00_434, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2426z00_2536)
{ /* Llib/pgp_composition.scm 354 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1190z00_412;
BgL_i1190z00_412 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_383))); 
{ 
obj_t BgL_packetsz00_2543;
BgL_packetsz00_2543 = 
BGl_appendzd221010zd2zz__openpgpzd2compositionzd2(
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1190z00_412))->BgL_packetsz00), BgL_packetsz00_383); 
BgL_packetsz00_383 = BgL_packetsz00_2543; 
goto BgL_zc3z04anonymousza31819ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 357 */
bool_t BgL_test2427z00_2546;
if(BgL_expectzd2onezd2passzf3zf3_384)
{ /* Llib/pgp_composition.scm 358 */
obj_t BgL_arg1853z00_433;
BgL_arg1853z00_433 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2427z00_2546 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1853z00_433, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); }  else 
{ /* Llib/pgp_composition.scm 357 */
BgL_test2427z00_2546 = ((bool_t)0)
; } 
if(BgL_test2427z00_2546)
{ /* Llib/pgp_composition.scm 359 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_i1191z00_417;
BgL_i1191z00_417 = 
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_383))); 
{ /* Llib/pgp_composition.scm 361 */
obj_t BgL_arg1838z00_418;bool_t BgL_arg1839z00_419;obj_t BgL_arg1840z00_420;
BgL_arg1838z00_418 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1839z00_419 = 
(((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(BgL_i1191z00_417))->BgL_containszd2nestedzd2sigzf3zf3); 
{ /* Llib/pgp_composition.scm 363 */
obj_t BgL_arg1841z00_421;
BgL_arg1841z00_421 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1840z00_420 = 
MAKE_YOUNG_PAIR(BgL_arg1841z00_421, BgL_onezd2passzd2sigsz00_385); } 
{ 
obj_t BgL_onezd2passzd2sigsz00_2562;bool_t BgL_expectzd2onezd2passzf3zf3_2561;obj_t BgL_packetsz00_2560;
BgL_packetsz00_2560 = BgL_arg1838z00_418; 
BgL_expectzd2onezd2passzf3zf3_2561 = BgL_arg1839z00_419; 
BgL_onezd2passzd2sigsz00_2562 = BgL_arg1840z00_420; 
BgL_onezd2passzd2sigsz00_385 = BgL_onezd2passzd2sigsz00_2562; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2561; 
BgL_packetsz00_383 = BgL_packetsz00_2560; 
goto BgL_zc3z04anonymousza31819ze3z87_388;} } }  else 
{ /* Llib/pgp_composition.scm 357 */
if(BgL_expectzd2onezd2passzf3zf3_384)
{ /* Llib/pgp_composition.scm 366 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2178z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 370 */
bool_t BgL_test2430z00_2566;
if(
CBOOL(BgL_msgz00_386))
{ /* Llib/pgp_composition.scm 370 */
BgL_test2430z00_2566 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 370 */
obj_t BgL_arg1852z00_432;
BgL_arg1852z00_432 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2430z00_2566 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1852z00_432, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2430z00_2566)
{ /* Llib/pgp_composition.scm 371 */
obj_t BgL_arg1844z00_424;obj_t BgL_arg1845z00_425;
BgL_arg1844z00_424 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1845z00_425 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
{ 
obj_t BgL_msgz00_2578;bool_t BgL_expectzd2onezd2passzf3zf3_2577;obj_t BgL_packetsz00_2576;
BgL_packetsz00_2576 = BgL_arg1844z00_424; 
BgL_expectzd2onezd2passzf3zf3_2577 = ((bool_t)0); 
BgL_msgz00_2578 = BgL_arg1845z00_425; 
BgL_msgz00_386 = BgL_msgz00_2578; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2577; 
BgL_packetsz00_383 = BgL_packetsz00_2576; 
goto BgL_zc3z04anonymousza31819ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 370 */
if(
CBOOL(BgL_msgz00_386))
{ /* Llib/pgp_composition.scm 376 */
bool_t BgL_test2433z00_2581;
{ /* Llib/pgp_composition.scm 376 */
obj_t BgL_arg1851z00_431;
BgL_arg1851z00_431 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2433z00_2581 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1851z00_431, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2433z00_2581)
{ /* Llib/pgp_composition.scm 377 */
obj_t BgL_arg1848z00_428;obj_t BgL_arg1849z00_429;
BgL_arg1848z00_428 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
{ /* Llib/pgp_composition.scm 378 */
obj_t BgL_arg1850z00_430;
BgL_arg1850z00_430 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1849z00_429 = 
MAKE_YOUNG_PAIR(BgL_arg1850z00_430, BgL_sigsz00_387); } 
{ 
obj_t BgL_sigsz00_2592;bool_t BgL_expectzd2onezd2passzf3zf3_2591;obj_t BgL_packetsz00_2590;
BgL_packetsz00_2590 = BgL_arg1848z00_428; 
BgL_expectzd2onezd2passzf3zf3_2591 = ((bool_t)0); 
BgL_sigsz00_2592 = BgL_arg1849z00_429; 
BgL_sigsz00_387 = BgL_sigsz00_2592; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2591; 
BgL_packetsz00_383 = BgL_packetsz00_2590; 
goto BgL_zc3z04anonymousza31819ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 376 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2178z00zz__openpgpzd2compositionzd2, BFALSE);} }  else 
{ /* Llib/pgp_composition.scm 372 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2178z00zz__openpgpzd2compositionzd2, BFALSE);} } } } } } } } } 

}



/* parse-literal */
BgL_pgpzd2literalzd2_bglt BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_11)
{
{ /* Llib/pgp_composition.scm 387 */
if(
NULLP(
CDR(BgL_packetsz00_11)))
{ /* Llib/pgp_composition.scm 388 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 389 */
obj_t BgL_list1868z00_455;
BgL_list1868z00_455 = 
MAKE_YOUNG_PAIR(BGl_string2167z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1868z00_455); } 
{ /* Llib/pgp_composition.scm 390 */
bool_t BgL_test2435z00_2602;
{ /* Llib/pgp_composition.scm 391 */
bool_t BgL_test2436z00_2603;
{ /* Llib/pgp_composition.scm 391 */
obj_t BgL_arg1875z00_464;
BgL_arg1875z00_464 = 
CAR(BgL_packetsz00_11); 
BgL_test2436z00_2603 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1875z00_464, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2436z00_2603)
{ /* Llib/pgp_composition.scm 391 */
BgL_test2435z00_2602 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 391 */
BgL_test2435z00_2602 = ((bool_t)1)
; } } 
if(BgL_test2435z00_2602)
{ /* Llib/pgp_composition.scm 390 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2180z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 390 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 395 */
BgL_pgpzd2literalzd2_bglt BgL_new1193z00_465;
{ /* Llib/pgp_composition.scm 396 */
BgL_pgpzd2literalzd2_bglt BgL_new1192z00_466;
BgL_new1192z00_466 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 396 */
long BgL_arg1876z00_467;
BgL_arg1876z00_467 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1192z00_466), BgL_arg1876z00_467); } 
{ /* Llib/pgp_composition.scm 396 */
BgL_objectz00_bglt BgL_tmpz00_2612;
BgL_tmpz00_2612 = 
((BgL_objectz00_bglt)BgL_new1192z00_466); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2612, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1192z00_466); 
BgL_new1193z00_465 = BgL_new1192z00_466; } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(BgL_new1193z00_465))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)
CAR(BgL_packetsz00_11))),BUNSPEC); 
return BgL_new1193z00_465;} } 

}



/* create-chksum64 */
obj_t BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(obj_t BgL_dataz00_12)
{
{ /* Llib/pgp_composition.scm 401 */
{ /* Llib/pgp_composition.scm 402 */
obj_t BgL_computedzd2chksumzd2_468;
BgL_computedzd2chksumzd2_468 = 
BGl_crczd2stringzd2zz__crcz00(
CNST_TABLE_REF(((long)12)), BgL_dataz00_12, BTRUE, 
BINT(((long)0)), 
BINT(((long)11994318))); 
{ /* Llib/pgp_composition.scm 402 */
long BgL_b1z00_469;
BgL_b1z00_469 = 
(
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)16711680)) >> 
(int)(((long)16))); 
{ /* Llib/pgp_composition.scm 404 */
long BgL_b2z00_470;
BgL_b2z00_470 = 
(
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)65280)) >> 
(int)(((long)8))); 
{ /* Llib/pgp_composition.scm 405 */
long BgL_b3z00_471;
BgL_b3z00_471 = 
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)255)); 
{ /* Llib/pgp_composition.scm 406 */

{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1877z00_472;
{ /* Llib/pgp_composition.scm 407 */
unsigned char BgL_arg1878z00_475;unsigned char BgL_arg1879z00_476;unsigned char BgL_arg1880z00_477;
BgL_arg1878z00_475 = 
(BgL_b1z00_469); 
BgL_arg1879z00_476 = 
(BgL_b2z00_470); 
BgL_arg1880z00_477 = 
(BgL_b3z00_471); 
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_list1881z00_478;
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1882z00_479;
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1883z00_480;
BgL_arg1883z00_480 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1880z00_477), BNIL); 
BgL_arg1882z00_479 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1879z00_476), BgL_arg1883z00_480); } 
BgL_list1881z00_478 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1878z00_475), BgL_arg1882z00_479); } 
BgL_arg1877z00_472 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list1881z00_478); } } 
{ /* Llib/pgp_composition.scm 407 */

return 
BGl_base64zd2encodezd2zz__base64z00(BgL_arg1877z00_472, 
BINT(((long)76)));} } } } } } } } 

}



/* armored-pipe-port */
obj_t BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(obj_t BgL_pz00_13)
{
{ /* Llib/pgp_composition.scm 414 */
{ 
obj_t BgL_lz00_547;obj_t BgL_dataz00_560;obj_t BgL_pz00_561;
{ /* Llib/pgp_composition.scm 460 */
obj_t BgL_lz00_489;
BgL_lz00_489 = 
BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(BgL_pz00_13); 
{ /* Llib/pgp_composition.scm 461 */
bool_t BgL_test2437z00_2646;
{ /* Llib/pgp_composition.scm 461 */
bool_t BgL_test2438z00_2647;
{ /* Llib/pgp_composition.scm 461 */

BgL_test2438z00_2647 = 
BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(BGl_string2183z00zz__openpgpzd2compositionzd2, BgL_lz00_489, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL_test2438z00_2647)
{ /* Llib/pgp_composition.scm 462 */

BgL_test2437z00_2646 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(BGl_string2184z00zz__openpgpzd2compositionzd2, BgL_lz00_489, BFALSE, BFALSE, BFALSE, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 461 */
BgL_test2437z00_2646 = ((bool_t)0)
; } } 
if(BgL_test2437z00_2646)
{ /* Llib/pgp_composition.scm 461 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 461 */
BGl_errorz00zz__errorz00(BGl_string2181z00zz__openpgpzd2compositionzd2, BGl_string2185z00zz__openpgpzd2compositionzd2, BgL_lz00_489); } } 
{ /* Llib/pgp_composition.scm 465 */
obj_t BgL_mainzd2headerzd2infoz00_523;
{ /* Llib/pgp_composition.scm 465 */
long BgL_arg1891z00_541;
BgL_arg1891z00_541 = 
(
STRING_LENGTH(
((obj_t)BgL_lz00_489))-((long)5)); 
BgL_mainzd2headerzd2infoz00_523 = 
c_substring(
((obj_t)BgL_lz00_489), ((long)11), BgL_arg1891z00_541); } 
{ 
obj_t BgL_headersz00_526;
BgL_headersz00_526 = BNIL; 
BgL_zc3z04anonymousza31888ze3z87_527:
{ /* Llib/pgp_composition.scm 467 */
obj_t BgL_lz00_528;
BgL_lz00_528 = 
BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(BgL_pz00_13); 
if(
(
STRING_LENGTH(
((obj_t)BgL_lz00_528))==((long)0)))
{ /* Llib/pgp_composition.scm 469 */
obj_t BgL_val2_1254z00_532;
{ /* Llib/pgp_composition.scm 470 */
obj_t BgL_p64z00_533;
BgL_p64z00_533 = 
BGl_base64zd2decodezd2pipezd2portzd2zz__openpgpzd2portzd2utilz00(BgL_pz00_13); 
{ /* Llib/pgp_composition.scm 470 */
obj_t BgL_dataz00_534;
BgL_dataz00_534 = 
BGl_readzd2stringzd2zz__r4_input_6_10_2z00(BgL_p64z00_533); 
{ /* Llib/pgp_composition.scm 471 */

BgL_dataz00_560 = BgL_dataz00_534; 
BgL_pz00_561 = BgL_pz00_13; 
{ /* Llib/pgp_composition.scm 447 */
obj_t BgL_cz00_564;
BgL_cz00_564 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_pz00_561); 
{ /* Llib/pgp_composition.scm 448 */
bool_t BgL_test2440z00_2664;
if(
CHARP(BgL_cz00_564))
{ /* Llib/pgp_composition.scm 448 */
if(
(
CCHAR(BgL_cz00_564)==((unsigned char)'=')))
{ /* Llib/pgp_composition.scm 449 */
BgL_test2440z00_2664 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 449 */
BgL_test2440z00_2664 = ((bool_t)1)
; } }  else 
{ /* Llib/pgp_composition.scm 448 */
BgL_test2440z00_2664 = ((bool_t)1)
; } 
if(BgL_test2440z00_2664)
{ /* Llib/pgp_composition.scm 448 */
BGl_errorz00zz__errorz00(BGl_string2181z00zz__openpgpzd2compositionzd2, BGl_string2182z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 448 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 451 */
obj_t BgL_linez00_570;obj_t BgL_expectedz00_571;
BgL_linez00_570 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_pz00_561); 
BgL_expectedz00_571 = 
BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(BgL_dataz00_560); 
if(
EOF_OBJECTP(BgL_linez00_570))
{ /* Llib/pgp_composition.scm 455 */
BGl_errorz00zz__errorz00(BGl_string2181z00zz__openpgpzd2compositionzd2, BGl_string2182z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 455 */BFALSE; } 
{ /* Llib/pgp_composition.scm 456 */
bool_t BgL_test2444z00_2676;
{ /* Llib/pgp_composition.scm 456 */
long BgL_l1z00_1264;
BgL_l1z00_1264 = 
STRING_LENGTH(
((obj_t)BgL_linez00_570)); 
if(
(BgL_l1z00_1264==
STRING_LENGTH(BgL_expectedz00_571)))
{ /* Llib/pgp_composition.scm 456 */
int BgL_arg1282z00_1267;
{ /* Llib/pgp_composition.scm 456 */
char * BgL_auxz00_2685;char * BgL_tmpz00_2682;
BgL_auxz00_2685 = 
BSTRING_TO_STRING(BgL_expectedz00_571); 
BgL_tmpz00_2682 = 
BSTRING_TO_STRING(
((obj_t)BgL_linez00_570)); 
BgL_arg1282z00_1267 = 
memcmp(BgL_tmpz00_2682, BgL_auxz00_2685, BgL_l1z00_1264); } 
BgL_test2444z00_2676 = 
(
(long)(BgL_arg1282z00_1267)==((long)0)); }  else 
{ /* Llib/pgp_composition.scm 456 */
BgL_test2444z00_2676 = ((bool_t)0)
; } } 
if(BgL_test2444z00_2676)
{ /* Llib/pgp_composition.scm 456 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 456 */
BGl_errorz00zz__errorz00(BGl_string2181z00zz__openpgpzd2compositionzd2, BGl_string2182z00zz__openpgpzd2compositionzd2, BFALSE); } } } } 
{ /* Llib/pgp_composition.scm 474 */
long BgL_endz00_537;
BgL_endz00_537 = 
STRING_LENGTH(BgL_dataz00_534); 
{ /* Llib/pgp_composition.scm 474 */

BgL_val2_1254z00_532 = 
BGl_openzd2inputzd2stringz00zz__r4_ports_6_10_1z00(BgL_dataz00_534, 
BINT(((long)0)), 
BINT(BgL_endz00_537)); } } } } } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2695;
BgL_tmpz00_2695 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2695); } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2698;
BgL_tmpz00_2698 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2698, BgL_headersz00_526); } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2701;
BgL_tmpz00_2701 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2701, BgL_val2_1254z00_532); } 
return BgL_mainzd2headerzd2infoz00_523;}  else 
{ /* Llib/pgp_composition.scm 475 */
obj_t BgL_headerz00_538;
BgL_lz00_547 = BgL_lz00_528; 
{ /* Llib/pgp_composition.scm 439 */
obj_t BgL_posz00_549;
{ /* Llib/pgp_composition.scm 439 */

BgL_posz00_549 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_lz00_547, 
BCHAR(((unsigned char)':')), 
BINT(((long)0))); } 
if(
CBOOL(BgL_posz00_549))
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_arg1896z00_551;obj_t BgL_arg1897z00_552;
{ /* Llib/pgp_composition.scm 441 */
long BgL_endz00_1253;
BgL_endz00_1253 = 
(long)CINT(BgL_posz00_549); 
BgL_arg1896z00_551 = 
c_substring(
((obj_t)BgL_lz00_547), ((long)0), BgL_endz00_1253); } 
{ /* Llib/pgp_composition.scm 442 */
long BgL_arg1902z00_555;long BgL_arg1903z00_556;
BgL_arg1902z00_555 = 
(
(long)CINT(BgL_posz00_549)+((long)1)); 
BgL_arg1903z00_556 = 
STRING_LENGTH(
((obj_t)BgL_lz00_547)); 
BgL_arg1897z00_552 = 
c_substring(
((obj_t)BgL_lz00_547), BgL_arg1902z00_555, BgL_arg1903z00_556); } 
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_list1898z00_553;
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_arg1899z00_554;
BgL_arg1899z00_554 = 
MAKE_YOUNG_PAIR(BgL_arg1897z00_552, BNIL); 
BgL_list1898z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1896z00_551, BgL_arg1899z00_554); } 
BgL_headerz00_538 = BgL_list1898z00_553; } }  else 
{ /* Llib/pgp_composition.scm 440 */
BgL_headerz00_538 = BFALSE; } } 
if(
CBOOL(BgL_headerz00_538))
{ /* Llib/pgp_composition.scm 477 */
obj_t BgL_arg1890z00_539;
BgL_arg1890z00_539 = 
MAKE_YOUNG_PAIR(BgL_headerz00_538, BgL_headersz00_526); 
{ 
obj_t BgL_headersz00_2723;
BgL_headersz00_2723 = BgL_arg1890z00_539; 
BgL_headersz00_526 = BgL_headersz00_2723; 
goto BgL_zc3z04anonymousza31888ze3z87_527;} }  else 
{ 

goto BgL_zc3z04anonymousza31888ze3z87_527;} } } } } } } } 

}



/* safe-read-line~0 */
obj_t BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(obj_t BgL_pz00_543)
{
{ /* Llib/pgp_composition.scm 436 */
{ /* Llib/pgp_composition.scm 433 */
obj_t BgL_lz00_545;
BgL_lz00_545 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_pz00_543); 
if(
EOF_OBJECTP(BgL_lz00_545))
{ /* Llib/pgp_composition.scm 434 */
BGl_errorz00zz__errorz00(BGl_string2181z00zz__openpgpzd2compositionzd2, BGl_string2186z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 434 */BFALSE; } 
return BgL_lz00_545;} } 

}



/* decode-pgp */
BGL_EXPORTED_DEF obj_t BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(obj_t BgL_pz00_14)
{
{ /* Llib/pgp_composition.scm 483 */
{ /* Llib/pgp_composition.scm 486 */
obj_t BgL_firstzd2charszd2_579;
BgL_firstzd2charszd2_579 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)10)), BgL_pz00_14); 
BGl_unreadzd2stringz12zc0zz__r4_input_6_10_2z00(BgL_firstzd2charszd2_579, BgL_pz00_14); 
{ /* Llib/pgp_composition.scm 489 */
bool_t BgL_test2449z00_2731;
if(
(((long)10)==
STRING_LENGTH(
((obj_t)BgL_firstzd2charszd2_579))))
{ /* Llib/pgp_composition.scm 489 */
int BgL_arg1282z00_1287;
{ /* Llib/pgp_composition.scm 489 */
char * BgL_auxz00_2738;char * BgL_tmpz00_2736;
BgL_auxz00_2738 = 
BSTRING_TO_STRING(
((obj_t)BgL_firstzd2charszd2_579)); 
BgL_tmpz00_2736 = 
BSTRING_TO_STRING(BGl_string2183z00zz__openpgpzd2compositionzd2); 
BgL_arg1282z00_1287 = 
memcmp(BgL_tmpz00_2736, BgL_auxz00_2738, ((long)10)); } 
BgL_test2449z00_2731 = 
(
(long)(BgL_arg1282z00_1287)==((long)0)); }  else 
{ /* Llib/pgp_composition.scm 489 */
BgL_test2449z00_2731 = ((bool_t)0)
; } 
if(BgL_test2449z00_2731)
{ /* Llib/pgp_composition.scm 490 */
obj_t BgL_mainzd2headerzd2infoz00_581;
BgL_mainzd2headerzd2infoz00_581 = 
BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pz00_14); 
{ /* Llib/pgp_composition.scm 490 */
obj_t BgL_headersz00_582;obj_t BgL_compositionz00_583;
{ /* Llib/pgp_composition.scm 490 */
int BgL_tmpz00_2745;
BgL_tmpz00_2745 = 
(int)(((long)1)); 
BgL_headersz00_582 = 
BGL_MVALUES_VAL(BgL_tmpz00_2745); } 
{ /* Llib/pgp_composition.scm 490 */
int BgL_tmpz00_2748;
BgL_tmpz00_2748 = 
(int)(((long)2)); 
BgL_compositionz00_583 = 
BGL_MVALUES_VAL(BgL_tmpz00_2748); } 
return BgL_compositionz00_583;} }  else 
{ /* Llib/pgp_composition.scm 489 */
return 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(
BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(BgL_pz00_14));} } } } 

}



/* &decode-pgp */
obj_t BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1483, obj_t BgL_pz00_1484)
{
{ /* Llib/pgp_composition.scm 483 */
{ /* Llib/pgp_composition.scm 486 */
obj_t BgL_auxz00_2753;
if(
INPUT_PORTP(BgL_pz00_1484))
{ /* Llib/pgp_composition.scm 486 */
BgL_auxz00_2753 = BgL_pz00_1484
; }  else 
{ 
obj_t BgL_auxz00_2756;
BgL_auxz00_2756 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)18048)), BGl_string2187z00zz__openpgpzd2compositionzd2, BGl_string2188z00zz__openpgpzd2compositionzd2, BgL_pz00_1484); 
FAILURE(BgL_auxz00_2756,BFALSE,BFALSE);} 
return 
BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_auxz00_2753);} } 

}



/* decode-armored-pgp */
obj_t BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(obj_t BgL_pz00_15)
{
{ /* Llib/pgp_composition.scm 500 */
{ /* Llib/pgp_composition.scm 502 */
obj_t BgL_mainzd2headerzd2infoz00_584;
BgL_mainzd2headerzd2infoz00_584 = 
BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(BgL_pz00_15); 
{ /* Llib/pgp_composition.scm 504 */
obj_t BgL_headersz00_585;obj_t BgL_ppz00_586;
{ /* Llib/pgp_composition.scm 504 */
int BgL_tmpz00_2762;
BgL_tmpz00_2762 = 
(int)(((long)1)); 
BgL_headersz00_585 = 
BGL_MVALUES_VAL(BgL_tmpz00_2762); } 
{ /* Llib/pgp_composition.scm 504 */
int BgL_tmpz00_2765;
BgL_tmpz00_2765 = 
(int)(((long)2)); 
BgL_ppz00_586 = 
BGL_MVALUES_VAL(BgL_tmpz00_2765); } 
{ /* Llib/pgp_composition.scm 504 */
obj_t BgL_exitd1201z00_587;
BgL_exitd1201z00_587 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/pgp_composition.scm 506 */
obj_t BgL_zc3z04anonymousza31912ze3z87_1485;
BgL_zc3z04anonymousza31912ze3z87_1485 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31912ze3ze5zz__openpgpzd2compositionzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31912ze3z87_1485, 
(int)(((long)0)), BgL_ppz00_586); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1201z00_587, BgL_zc3z04anonymousza31912ze3z87_1485); 
{ /* Llib/pgp_composition.scm 505 */
obj_t BgL_tmp1203z00_589;
{ /* Llib/pgp_composition.scm 505 */
obj_t BgL_val2_1257z00_592;
{ /* Llib/pgp_composition.scm 65 */
obj_t BgL_packetsz00_1298;
BgL_packetsz00_1298 = 
BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(
((obj_t)BgL_ppz00_586)); 
BgL_val2_1257z00_592 = 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(BgL_packetsz00_1298); } 
{ /* Llib/pgp_composition.scm 505 */
int BgL_tmpz00_2778;
BgL_tmpz00_2778 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2778); } 
{ /* Llib/pgp_composition.scm 505 */
int BgL_tmpz00_2781;
BgL_tmpz00_2781 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2781, BgL_headersz00_585); } 
{ /* Llib/pgp_composition.scm 505 */
int BgL_tmpz00_2784;
BgL_tmpz00_2784 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2784, BgL_val2_1257z00_592); } 
BgL_tmp1203z00_589 = BgL_mainzd2headerzd2infoz00_584; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1201z00_587); 
bgl_close_input_port(
((obj_t)BgL_ppz00_586)); 
return BgL_tmp1203z00_589;} } } } } } 

}



/* &<@anonymous:1912> */
obj_t BGl_z62zc3z04anonymousza31912ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1486)
{
{ /* Llib/pgp_composition.scm 504 */
{ /* Llib/pgp_composition.scm 506 */
obj_t BgL_ppz00_1487;
BgL_ppz00_1487 = 
PROCEDURE_REF(BgL_envz00_1486, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_ppz00_1487));} } 

}



/* encode-native-pgp */
BGL_EXPORTED_DEF obj_t BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_pgpzd2compositionzd2_27, obj_t BgL_pz00_28)
{
{ /* Llib/pgp_composition.scm 589 */
return 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_27, BgL_pz00_28);} 

}



/* &encode-native-pgp */
obj_t BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1488, obj_t BgL_pgpzd2compositionzd2_1489, obj_t BgL_pz00_1490)
{
{ /* Llib/pgp_composition.scm 589 */
{ /* Llib/pgp_composition.scm 590 */
obj_t BgL_auxz00_2803;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_2795;
if(
OUTPUT_PORTP(BgL_pz00_1490))
{ /* Llib/pgp_composition.scm 590 */
BgL_auxz00_2803 = BgL_pz00_1490
; }  else 
{ 
obj_t BgL_auxz00_2806;
BgL_auxz00_2806 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)22507)), BGl_string2189z00zz__openpgpzd2compositionzd2, BGl_string2191z00zz__openpgpzd2compositionzd2, BgL_pz00_1490); 
FAILURE(BgL_auxz00_2806,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_pgpzd2compositionzd2_1489, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 590 */
BgL_auxz00_2795 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_pgpzd2compositionzd2_1489)
; }  else 
{ 
obj_t BgL_auxz00_2799;
BgL_auxz00_2799 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)22507)), BGl_string2189z00zz__openpgpzd2compositionzd2, BGl_string2190z00zz__openpgpzd2compositionzd2, BgL_pgpzd2compositionzd2_1489); 
FAILURE(BgL_auxz00_2799,BFALSE,BFALSE);} 
return 
BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_auxz00_2795, BgL_auxz00_2803);} } 

}



/* encode-armored-pgp */
BGL_EXPORTED_DEF obj_t BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_pgpzd2compositionzd2_29, obj_t BgL_mainzd2headerzd2infoz00_30, obj_t BgL_headersz00_31, obj_t BgL_pz00_32)
{
{ /* Llib/pgp_composition.scm 597 */
{ /* Llib/pgp_composition.scm 601 */
obj_t BgL_pstrz00_595;
{ /* Llib/pgp_composition.scm 601 */

{ /* Llib/pgp_composition.scm 601 */

BgL_pstrz00_595 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_29, BgL_pstrz00_595); 
{ /* Llib/pgp_composition.scm 603 */
obj_t BgL_strz00_596;
BgL_strz00_596 = 
bgl_close_output_port(BgL_pstrz00_595); 
{ /* Llib/pgp_composition.scm 603 */
obj_t BgL_b64zd2encodedzd2_597;
{ /* Llib/pgp_composition.scm 604 */

BgL_b64zd2encodedzd2_597 = 
BGl_base64zd2encodezd2zz__base64z00(BgL_strz00_596, 
BINT(((long)76))); } 
{ /* Llib/pgp_composition.scm 604 */
obj_t BgL_crczd2b64zd2_598;
BgL_crczd2b64zd2_598 = 
BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(BgL_strz00_596); 
{ /* Llib/pgp_composition.scm 605 */

{ /* Llib/pgp_composition.scm 608 */
obj_t BgL_zc3z04anonymousza31914ze3z87_1491;
BgL_zc3z04anonymousza31914ze3z87_1491 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31914ze3ze5zz__openpgpzd2compositionzd2, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_1491, 
(int)(((long)0)), BgL_mainzd2headerzd2infoz00_30); 
PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_1491, 
(int)(((long)1)), BgL_headersz00_31); 
PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_1491, 
(int)(((long)2)), BgL_b64zd2encodedzd2_597); 
PROCEDURE_SET(BgL_zc3z04anonymousza31914ze3z87_1491, 
(int)(((long)3)), BgL_crczd2b64zd2_598); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_pz00_32, BgL_zc3z04anonymousza31914ze3z87_1491);} } } } } } } 

}



/* &encode-armored-pgp */
obj_t BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1492, obj_t BgL_pgpzd2compositionzd2_1493, obj_t BgL_mainzd2headerzd2infoz00_1494, obj_t BgL_headersz00_1495, obj_t BgL_pz00_1496)
{
{ /* Llib/pgp_composition.scm 597 */
{ /* Llib/pgp_composition.scm 601 */
obj_t BgL_auxz00_2851;obj_t BgL_auxz00_2844;obj_t BgL_auxz00_2837;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_2829;
if(
OUTPUT_PORTP(BgL_pz00_1496))
{ /* Llib/pgp_composition.scm 601 */
BgL_auxz00_2851 = BgL_pz00_1496
; }  else 
{ 
obj_t BgL_auxz00_2854;
BgL_auxz00_2854 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)23055)), BGl_string2192z00zz__openpgpzd2compositionzd2, BGl_string2191z00zz__openpgpzd2compositionzd2, BgL_pz00_1496); 
FAILURE(BgL_auxz00_2854,BFALSE,BFALSE);} 
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_headersz00_1495))
{ /* Llib/pgp_composition.scm 601 */
BgL_auxz00_2844 = BgL_headersz00_1495
; }  else 
{ 
obj_t BgL_auxz00_2847;
BgL_auxz00_2847 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)23055)), BGl_string2192z00zz__openpgpzd2compositionzd2, BGl_string2171z00zz__openpgpzd2compositionzd2, BgL_headersz00_1495); 
FAILURE(BgL_auxz00_2847,BFALSE,BFALSE);} 
if(
STRINGP(BgL_mainzd2headerzd2infoz00_1494))
{ /* Llib/pgp_composition.scm 601 */
BgL_auxz00_2837 = BgL_mainzd2headerzd2infoz00_1494
; }  else 
{ 
obj_t BgL_auxz00_2840;
BgL_auxz00_2840 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)23055)), BGl_string2192z00zz__openpgpzd2compositionzd2, BGl_string2193z00zz__openpgpzd2compositionzd2, BgL_mainzd2headerzd2infoz00_1494); 
FAILURE(BgL_auxz00_2840,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_pgpzd2compositionzd2_1493, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 601 */
BgL_auxz00_2829 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_pgpzd2compositionzd2_1493)
; }  else 
{ 
obj_t BgL_auxz00_2833;
BgL_auxz00_2833 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)23055)), BGl_string2192z00zz__openpgpzd2compositionzd2, BGl_string2190z00zz__openpgpzd2compositionzd2, BgL_pgpzd2compositionzd2_1493); 
FAILURE(BgL_auxz00_2833,BFALSE,BFALSE);} 
return 
BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_auxz00_2829, BgL_auxz00_2837, BgL_auxz00_2844, BgL_auxz00_2851);} } 

}



/* &<@anonymous:1914> */
obj_t BGl_z62zc3z04anonymousza31914ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1497)
{
{ /* Llib/pgp_composition.scm 607 */
{ /* Llib/pgp_composition.scm 608 */
obj_t BgL_mainzd2headerzd2infoz00_1498;obj_t BgL_headersz00_1499;obj_t BgL_b64zd2encodedzd2_1500;obj_t BgL_crczd2b64zd2_1501;
BgL_mainzd2headerzd2infoz00_1498 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1497, 
(int)(((long)0)))); 
BgL_headersz00_1499 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1497, 
(int)(((long)1)))); 
BgL_b64zd2encodedzd2_1500 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1497, 
(int)(((long)2)))); 
BgL_crczd2b64zd2_1501 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1497, 
(int)(((long)3)))); 
{ /* Llib/pgp_composition.scm 608 */
obj_t BgL_port1287z00_1736;
{ /* Llib/pgp_composition.scm 608 */
obj_t BgL_tmpz00_2871;
BgL_tmpz00_2871 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1287z00_1736 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2871); } 
bgl_display_string(BGl_string2194z00zz__openpgpzd2compositionzd2, BgL_port1287z00_1736); 
bgl_display_obj(BgL_mainzd2headerzd2infoz00_1498, BgL_port1287z00_1736); 
bgl_display_string(BGl_string2184z00zz__openpgpzd2compositionzd2, BgL_port1287z00_1736); 
bgl_display_char(((unsigned char)10), BgL_port1287z00_1736); } 
{ 
obj_t BgL_l1289z00_1738;
BgL_l1289z00_1738 = BgL_headersz00_1499; 
BgL_zc3z04anonymousza31915ze3z87_1737:
if(
PAIRP(BgL_l1289z00_1738))
{ /* Llib/pgp_composition.scm 609 */
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_headerz00_1739;
BgL_headerz00_1739 = 
CAR(BgL_l1289z00_1738); 
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_port1288z00_1740;
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_tmpz00_2881;
BgL_tmpz00_2881 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1288z00_1740 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2881); } 
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_arg1917z00_1741;
BgL_arg1917z00_1741 = 
CAR(
((obj_t)BgL_headerz00_1739)); 
bgl_display_obj(BgL_arg1917z00_1741, BgL_port1288z00_1740); } 
bgl_display_string(BGl_string2195z00zz__openpgpzd2compositionzd2, BgL_port1288z00_1740); 
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_arg1918z00_1742;
{ /* Llib/pgp_composition.scm 610 */
obj_t BgL_pairz00_1743;
BgL_pairz00_1743 = 
CDR(
((obj_t)BgL_headerz00_1739)); 
BgL_arg1918z00_1742 = 
CAR(BgL_pairz00_1743); } 
bgl_display_obj(BgL_arg1918z00_1742, BgL_port1288z00_1740); } 
bgl_display_char(((unsigned char)10), BgL_port1288z00_1740); } } 
{ 
obj_t BgL_l1289z00_2893;
BgL_l1289z00_2893 = 
CDR(BgL_l1289z00_1738); 
BgL_l1289z00_1738 = BgL_l1289z00_2893; 
goto BgL_zc3z04anonymousza31915ze3z87_1737;} }  else 
{ /* Llib/pgp_composition.scm 609 */((bool_t)1); } } 
{ /* Llib/pgp_composition.scm 612 */
obj_t BgL_arg1920z00_1744;
{ /* Llib/pgp_composition.scm 612 */
obj_t BgL_tmpz00_2895;
BgL_tmpz00_2895 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1920z00_1744 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2895); } 
bgl_display_char(((unsigned char)10), BgL_arg1920z00_1744); } 
{ /* Llib/pgp_composition.scm 613 */
obj_t BgL_port1291z00_1745;
{ /* Llib/pgp_composition.scm 613 */
obj_t BgL_tmpz00_2899;
BgL_tmpz00_2899 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1291z00_1745 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2899); } 
bgl_display_obj(BgL_b64zd2encodedzd2_1500, BgL_port1291z00_1745); 
bgl_display_char(((unsigned char)10), BgL_port1291z00_1745); } 
{ /* Llib/pgp_composition.scm 614 */
obj_t BgL_arg1921z00_1746;
{ /* Llib/pgp_composition.scm 614 */
obj_t BgL_tmpz00_2904;
BgL_tmpz00_2904 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1921z00_1746 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2904); } 
bgl_display_string(BGl_string2196z00zz__openpgpzd2compositionzd2, BgL_arg1921z00_1746); } 
{ /* Llib/pgp_composition.scm 615 */
obj_t BgL_port1292z00_1747;
{ /* Llib/pgp_composition.scm 615 */
obj_t BgL_tmpz00_2908;
BgL_tmpz00_2908 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1292z00_1747 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2908); } 
bgl_display_obj(BgL_crczd2b64zd2_1501, BgL_port1292z00_1747); 
bgl_display_char(((unsigned char)10), BgL_port1292z00_1747); } 
{ /* Llib/pgp_composition.scm 616 */
obj_t BgL_port1293z00_1748;
{ /* Llib/pgp_composition.scm 616 */
obj_t BgL_tmpz00_2913;
BgL_tmpz00_2913 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1293z00_1748 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2913); } 
bgl_display_string(BGl_string2197z00zz__openpgpzd2compositionzd2, BgL_port1293z00_1748); 
bgl_display_obj(BgL_mainzd2headerzd2infoz00_1498, BgL_port1293z00_1748); 
bgl_display_string(BGl_string2184z00zz__openpgpzd2compositionzd2, BgL_port1293z00_1748); 
return 
bgl_display_char(((unsigned char)10), BgL_port1293z00_1748);} } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1925z00_624;obj_t BgL_arg1926z00_625;
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_v1294z00_637;
BgL_v1294z00_637 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1932z00_638;
BgL_arg1932z00_638 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2199z00zz__openpgpzd2compositionzd2, BGl_proc2198z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1294z00_637,((long)0),BgL_arg1932z00_638); } 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1937z00_648;
BgL_arg1937z00_648 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2201z00zz__openpgpzd2compositionzd2, BGl_proc2200z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1294z00_637,((long)1),BgL_arg1937z00_648); } 
BgL_arg1925z00_624 = BgL_v1294z00_637; } 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_v1295z00_658;
BgL_v1295z00_658 = 
create_vector(((long)0)); 
BgL_arg1926z00_625 = BgL_v1295z00_658; } 
BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)16)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)38657), BGl_proc2204z00zz__openpgpzd2compositionzd2, BGl_proc2203z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2202z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1925z00_624, BgL_arg1926z00_625); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1945z00_665;obj_t BgL_arg1946z00_666;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_v1296z00_680;
BgL_v1296z00_680 = 
create_vector(((long)4)); 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1952z00_681;
BgL_arg1952z00_681 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc2206z00zz__openpgpzd2compositionzd2, BGl_proc2205z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1296z00_680,((long)0),BgL_arg1952z00_681); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1957z00_691;
BgL_arg1957z00_691 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2208z00zz__openpgpzd2compositionzd2, BGl_proc2207z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1296z00_680,((long)1),BgL_arg1957z00_691); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1962z00_701;
BgL_arg1962z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2210z00zz__openpgpzd2compositionzd2, BGl_proc2209z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1296z00_680,((long)2),BgL_arg1962z00_701); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1967z00_711;
BgL_arg1967z00_711 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc2212z00zz__openpgpzd2compositionzd2, BGl_proc2211z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
VECTOR_SET(BgL_v1296z00_680,((long)3),BgL_arg1967z00_711); } 
BgL_arg1945z00_665 = BgL_v1296z00_680; } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_v1297z00_721;
BgL_v1297z00_721 = 
create_vector(((long)0)); 
BgL_arg1946z00_666 = BgL_v1297z00_721; } 
BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)21)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)25398), BGl_proc2215z00zz__openpgpzd2compositionzd2, BGl_proc2214z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2213z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1945z00_665, BgL_arg1946z00_666); } 
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_arg1974z00_727;obj_t BgL_arg1975z00_728;
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_v1298z00_734;
BgL_v1298z00_734 = 
create_vector(((long)0)); 
BgL_arg1974z00_727 = BgL_v1298z00_734; } 
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_v1299z00_735;
BgL_v1299z00_735 = 
create_vector(((long)0)); 
BgL_arg1975z00_728 = BgL_v1299z00_735; } 
BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)22)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)55354), BFALSE, BGl_proc2217z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2216z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1974z00_727, BgL_arg1975z00_728); } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1982z00_741;obj_t BgL_arg1983z00_742;
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_v1300z00_754;
BgL_v1300z00_754 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1989z00_755;
BgL_arg1989z00_755 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2219z00zz__openpgpzd2compositionzd2, BGl_proc2218z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1300z00_754,((long)0),BgL_arg1989z00_755); } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1994z00_765;
BgL_arg1994z00_765 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc2221z00zz__openpgpzd2compositionzd2, BGl_proc2220z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1300z00_754,((long)1),BgL_arg1994z00_765); } 
BgL_arg1982z00_741 = BgL_v1300z00_754; } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_v1301z00_775;
BgL_v1301z00_775 = 
create_vector(((long)0)); 
BgL_arg1983z00_742 = BgL_v1301z00_775; } 
BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)26)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, ((long)57195), BGl_proc2224z00zz__openpgpzd2compositionzd2, BGl_proc2223z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2222z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1982z00_741, BgL_arg1983z00_742); } 
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_arg2001z00_781;obj_t BgL_arg2002z00_782;
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_v1302z00_788;
BgL_v1302z00_788 = 
create_vector(((long)0)); 
BgL_arg2001z00_781 = BgL_v1302z00_788; } 
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_v1303z00_789;
BgL_v1303z00_789 = 
create_vector(((long)0)); 
BgL_arg2002z00_782 = BgL_v1303z00_789; } 
BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)27)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, ((long)36943), BFALSE, BGl_proc2226z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2225z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2001z00_781, BgL_arg2002z00_782); } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2009z00_795;obj_t BgL_arg2010z00_796;
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_v1304z00_808;
BgL_v1304z00_808 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2016z00_809;
BgL_arg2016z00_809 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2228z00zz__openpgpzd2compositionzd2, BGl_proc2227z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1304z00_808,((long)0),BgL_arg2016z00_809); } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2021z00_819;
BgL_arg2021z00_819 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2230z00zz__openpgpzd2compositionzd2, BGl_proc2229z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1304z00_808,((long)1),BgL_arg2021z00_819); } 
BgL_arg2009z00_795 = BgL_v1304z00_808; } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_v1305z00_829;
BgL_v1305z00_829 = 
create_vector(((long)0)); 
BgL_arg2010z00_796 = BgL_v1305z00_829; } 
BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)30)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)34910), BGl_proc2233z00zz__openpgpzd2compositionzd2, BGl_proc2232z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2231z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2009z00_795, BgL_arg2010z00_796); } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2029z00_836;obj_t BgL_arg2030z00_837;
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_v1306z00_849;
BgL_v1306z00_849 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2036z00_850;
BgL_arg2036z00_850 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)31)), BGl_proc2235z00zz__openpgpzd2compositionzd2, BGl_proc2234z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1306z00_849,((long)0),BgL_arg2036z00_850); } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2041z00_860;
BgL_arg2041z00_860 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2237z00zz__openpgpzd2compositionzd2, BGl_proc2236z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1306z00_849,((long)1),BgL_arg2041z00_860); } 
BgL_arg2029z00_836 = BgL_v1306z00_849; } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_v1307z00_870;
BgL_v1307z00_870 = 
create_vector(((long)0)); 
BgL_arg2030z00_837 = BgL_v1307z00_870; } 
BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)33)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)53773), BGl_proc2240z00zz__openpgpzd2compositionzd2, BGl_proc2239z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2238z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2029z00_836, BgL_arg2030z00_837); } 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_arg2049z00_877;obj_t BgL_arg2050z00_878;
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_v1308z00_891;
BgL_v1308z00_891 = 
create_vector(((long)1)); 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_arg2056z00_892;
BgL_arg2056z00_892 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc2242z00zz__openpgpzd2compositionzd2, BGl_proc2241z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1308z00_891,((long)0),BgL_arg2056z00_892); } 
BgL_arg2049z00_877 = BgL_v1308z00_891; } 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_v1309z00_902;
BgL_v1309z00_902 = 
create_vector(((long)0)); 
BgL_arg2050z00_878 = BgL_v1309z00_902; } 
BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)35)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2, ((long)43858), BGl_proc2245z00zz__openpgpzd2compositionzd2, BGl_proc2244z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2243z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2049z00_877, BgL_arg2050z00_878); } 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_arg2064z00_909;obj_t BgL_arg2065z00_910;
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_v1310z00_921;
BgL_v1310z00_921 = 
create_vector(((long)1)); 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_arg2071z00_922;
BgL_arg2071z00_922 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc2247z00zz__openpgpzd2compositionzd2, BGl_proc2246z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1310z00_921,((long)0),BgL_arg2071z00_922); } 
BgL_arg2064z00_909 = BgL_v1310z00_921; } 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_v1311z00_932;
BgL_v1311z00_932 = 
create_vector(((long)0)); 
BgL_arg2065z00_910 = BgL_v1311z00_932; } 
return ( 
BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)37)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)54317), BGl_proc2250z00zz__openpgpzd2compositionzd2, BGl_proc2249z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2248z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2064z00_909, BgL_arg2065z00_910), BUNSPEC) ;} } 

}



/* &<@anonymous:2070> */
obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1555, obj_t BgL_new1130z00_1556)
{
{ /* Llib/pgp_composition.scm 52 */
{ 
BgL_pgpzd2literalzd2_bglt BgL_auxz00_3016;
{ 
BgL_pgpzd2literalzd2packetz00_bglt BgL_auxz00_3017;
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_classz00_1750;
BgL_classz00_1750 = BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL__ortest_1111z00_1751;
BgL__ortest_1111z00_1751 = 
BGL_CLASS_NIL(BgL_classz00_1750); 
if(
CBOOL(BgL__ortest_1111z00_1751))
{ /* Llib/pgp_composition.scm 52 */
BgL_auxz00_3017 = 
((BgL_pgpzd2literalzd2packetz00_bglt)BgL__ortest_1111z00_1751)
; }  else 
{ /* Llib/pgp_composition.scm 52 */
BgL_auxz00_3017 = 
((BgL_pgpzd2literalzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1750))
; } } } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_new1130z00_1556)))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)BgL_auxz00_3017),BUNSPEC); } 
BgL_auxz00_3016 = 
((BgL_pgpzd2literalzd2_bglt)BgL_new1130z00_1556); 
return 
((obj_t)BgL_auxz00_3016);} } 

}



/* &lambda2068 */
BgL_pgpzd2literalzd2_bglt BGl_z62lambda2068z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1557)
{
{ /* Llib/pgp_composition.scm 52 */
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1129z00_1752;
BgL_new1129z00_1752 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 52 */
long BgL_arg2069z00_1753;
BgL_arg2069z00_1753 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_1752), BgL_arg2069z00_1753); } 
{ /* Llib/pgp_composition.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_3032;
BgL_tmpz00_3032 = 
((BgL_objectz00_bglt)BgL_new1129z00_1752); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3032, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1129z00_1752); 
return BgL_new1129z00_1752;} } 

}



/* &lambda2066 */
BgL_pgpzd2literalzd2_bglt BGl_z62lambda2066z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1558, obj_t BgL_literal1128z00_1559)
{
{ /* Llib/pgp_composition.scm 52 */
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1224z00_1755;
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1223z00_1756;
BgL_new1223z00_1756 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 52 */
long BgL_arg2067z00_1757;
BgL_arg2067z00_1757 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_1756), BgL_arg2067z00_1757); } 
{ /* Llib/pgp_composition.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_3040;
BgL_tmpz00_3040 = 
((BgL_objectz00_bglt)BgL_new1223z00_1756); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3040, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1223z00_1756); 
BgL_new1224z00_1755 = BgL_new1223z00_1756; } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(BgL_new1224z00_1755))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_literal1128z00_1559)),BUNSPEC); 
return BgL_new1224z00_1755;} } 

}



/* &lambda2075 */
obj_t BGl_z62lambda2075z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1560, obj_t BgL_oz00_1561, obj_t BgL_vz00_1562)
{
{ /* Llib/pgp_composition.scm 52 */
return 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_oz00_1561)))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_vz00_1562)),BUNSPEC);} 

}



/* &lambda2074 */
BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2074z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1563, obj_t BgL_oz00_1564)
{
{ /* Llib/pgp_composition.scm 52 */
return 
(((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_oz00_1564)))->BgL_literalz00);} 

}



/* &<@anonymous:2055> */
obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1565, obj_t BgL_new1126z00_1566)
{
{ /* Llib/pgp_composition.scm 50 */
{ 
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_auxz00_3051;
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1566))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1566))))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1566)))->BgL_onezd2passzd2sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3051 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1566); 
return 
((obj_t)BgL_auxz00_3051);} } 

}



/* &lambda2053 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2053z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1567)
{
{ /* Llib/pgp_composition.scm 50 */
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1125z00_1762;
BgL_new1125z00_1762 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 50 */
long BgL_arg2054z00_1763;
BgL_arg2054z00_1763 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_1762), BgL_arg2054z00_1763); } 
{ /* Llib/pgp_composition.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_3066;
BgL_tmpz00_3066 = 
((BgL_objectz00_bglt)BgL_new1125z00_1762); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3066, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1125z00_1762); 
return BgL_new1125z00_1762;} } 

}



/* &lambda2051 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2051z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1568, obj_t BgL_msg1122z00_1569, obj_t BgL_sigs1123z00_1570, obj_t BgL_onezd2passzd2sigs1124z00_1571)
{
{ /* Llib/pgp_composition.scm 50 */
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1222z00_1766;
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1221z00_1767;
BgL_new1221z00_1767 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 50 */
long BgL_arg2052z00_1768;
BgL_arg2052z00_1768 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1221z00_1767), BgL_arg2052z00_1768); } 
{ /* Llib/pgp_composition.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_3074;
BgL_tmpz00_3074 = 
((BgL_objectz00_bglt)BgL_new1221z00_1767); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3074, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1221z00_1767); 
BgL_new1222z00_1766 = BgL_new1221z00_1767; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1222z00_1766)))->BgL_msgz00)=((obj_t)BgL_msg1122z00_1569),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1222z00_1766)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1123z00_1570)),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(BgL_new1222z00_1766))->BgL_onezd2passzd2sigsz00)=((obj_t)
((obj_t)BgL_onezd2passzd2sigs1124z00_1571)),BUNSPEC); 
return BgL_new1222z00_1766;} } 

}



/* &lambda2060 */
obj_t BGl_z62lambda2060z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1572, obj_t BgL_oz00_1573, obj_t BgL_vz00_1574)
{
{ /* Llib/pgp_composition.scm 50 */
return 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_oz00_1573)))->BgL_onezd2passzd2sigsz00)=((obj_t)
((obj_t)BgL_vz00_1574)),BUNSPEC);} 

}



/* &lambda2059 */
obj_t BGl_z62lambda2059z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1575, obj_t BgL_oz00_1576)
{
{ /* Llib/pgp_composition.scm 50 */
return 
(((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_oz00_1576)))->BgL_onezd2passzd2sigsz00);} 

}



/* &<@anonymous:2035> */
obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1577, obj_t BgL_new1120z00_1578)
{
{ /* Llib/pgp_composition.scm 47 */
{ 
BgL_pgpzd2signaturezd2_bglt BgL_auxz00_3090;
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1578)))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1578)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3090 = 
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1578); 
return 
((obj_t)BgL_auxz00_3090);} } 

}



/* &lambda2033 */
BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2033z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1579)
{
{ /* Llib/pgp_composition.scm 47 */
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1119z00_1773;
BgL_new1119z00_1773 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 47 */
long BgL_arg2034z00_1774;
BgL_arg2034z00_1774 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_1773), BgL_arg2034z00_1774); } 
return BgL_new1119z00_1773;} } 

}



/* &lambda2031 */
BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2031z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1580, obj_t BgL_msg1117z00_1581, obj_t BgL_sigs1118z00_1582)
{
{ /* Llib/pgp_composition.scm 47 */
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1220z00_1776;
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1219z00_1777;
BgL_new1219z00_1777 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 47 */
long BgL_arg2032z00_1778;
BgL_arg2032z00_1778 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_1777), BgL_arg2032z00_1778); } 
BgL_new1220z00_1776 = BgL_new1219z00_1777; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1220z00_1776))->BgL_msgz00)=((obj_t)BgL_msg1117z00_1581),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1220z00_1776))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1118z00_1582)),BUNSPEC); 
return BgL_new1220z00_1776;} } 

}



/* &lambda2045 */
obj_t BGl_z62lambda2045z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1583, obj_t BgL_oz00_1584, obj_t BgL_vz00_1585)
{
{ /* Llib/pgp_composition.scm 47 */
return 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1584)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1585)),BUNSPEC);} 

}



/* &lambda2044 */
obj_t BGl_z62lambda2044z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1586, obj_t BgL_oz00_1587)
{
{ /* Llib/pgp_composition.scm 47 */
return 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1587)))->BgL_sigsz00);} 

}



/* &lambda2040 */
obj_t BGl_z62lambda2040z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1588, obj_t BgL_oz00_1589, obj_t BgL_vz00_1590)
{
{ /* Llib/pgp_composition.scm 47 */
return 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1589)))->BgL_msgz00)=((obj_t)BgL_vz00_1590),BUNSPEC);} 

}



/* &lambda2039 */
obj_t BGl_z62lambda2039z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1591, obj_t BgL_oz00_1592)
{
{ /* Llib/pgp_composition.scm 47 */
return 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1592)))->BgL_msgz00);} 

}



/* &<@anonymous:2015> */
obj_t BGl_z62zc3z04anonymousza32015ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1593, obj_t BgL_new1115z00_1594)
{
{ /* Llib/pgp_composition.scm 43 */
{ 
BgL_pgpzd2encryptedzd2_bglt BgL_auxz00_3117;
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1594)))->BgL_sessionzd2keyszd2)=((obj_t)BNIL),BUNSPEC); 
{ 
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_auxz00_3120;
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_classz00_1785;
BgL_classz00_1785 = BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL__ortest_1111z00_1786;
BgL__ortest_1111z00_1786 = 
BGL_CLASS_NIL(BgL_classz00_1785); 
if(
CBOOL(BgL__ortest_1111z00_1786))
{ /* Llib/pgp_composition.scm 43 */
BgL_auxz00_3120 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL__ortest_1111z00_1786)
; }  else 
{ /* Llib/pgp_composition.scm 43 */
BgL_auxz00_3120 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1785))
; } } } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1594)))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_auxz00_3120),BUNSPEC); } 
BgL_auxz00_3117 = 
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1594); 
return 
((obj_t)BgL_auxz00_3117);} } 

}



/* &lambda2013 */
BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2013z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1595)
{
{ /* Llib/pgp_composition.scm 43 */
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1114z00_1787;
BgL_new1114z00_1787 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 43 */
long BgL_arg2014z00_1788;
BgL_arg2014z00_1788 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_1787), BgL_arg2014z00_1788); } 
{ /* Llib/pgp_composition.scm 43 */
BgL_objectz00_bglt BgL_tmpz00_3135;
BgL_tmpz00_3135 = 
((BgL_objectz00_bglt)BgL_new1114z00_1787); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3135, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1114z00_1787); 
return BgL_new1114z00_1787;} } 

}



/* &lambda2011 */
BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2011z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1596, obj_t BgL_sessionzd2keys1112zd2_1597, obj_t BgL_encryptedzd2data1113zd2_1598)
{
{ /* Llib/pgp_composition.scm 43 */
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1218z00_1791;
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1217z00_1792;
BgL_new1217z00_1792 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 43 */
long BgL_arg2012z00_1793;
BgL_arg2012z00_1793 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1217z00_1792), BgL_arg2012z00_1793); } 
{ /* Llib/pgp_composition.scm 43 */
BgL_objectz00_bglt BgL_tmpz00_3143;
BgL_tmpz00_3143 = 
((BgL_objectz00_bglt)BgL_new1217z00_1792); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3143, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1217z00_1792); 
BgL_new1218z00_1791 = BgL_new1217z00_1792; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1218z00_1791))->BgL_sessionzd2keyszd2)=((obj_t)
((obj_t)BgL_sessionzd2keys1112zd2_1597)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1218z00_1791))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_encryptedzd2data1113zd2_1598)),BUNSPEC); 
return BgL_new1218z00_1791;} } 

}



/* &lambda2025 */
obj_t BGl_z62lambda2025z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1599, obj_t BgL_oz00_1600, obj_t BgL_vz00_1601)
{
{ /* Llib/pgp_composition.scm 43 */
return 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1600)))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_vz00_1601)),BUNSPEC);} 

}



/* &lambda2024 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda2024z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1602, obj_t BgL_oz00_1603)
{
{ /* Llib/pgp_composition.scm 43 */
return 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1603)))->BgL_encryptedzd2datazd2);} 

}



/* &lambda2020 */
obj_t BGl_z62lambda2020z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1604, obj_t BgL_oz00_1605, obj_t BgL_vz00_1606)
{
{ /* Llib/pgp_composition.scm 43 */
return 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1605)))->BgL_sessionzd2keyszd2)=((obj_t)
((obj_t)BgL_vz00_1606)),BUNSPEC);} 

}



/* &lambda2019 */
obj_t BGl_z62lambda2019z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1607, obj_t BgL_oz00_1608)
{
{ /* Llib/pgp_composition.scm 43 */
return 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1608)))->BgL_sessionzd2keyszd2);} 

}



/* &<@anonymous:2005> */
obj_t BGl_z62zc3z04anonymousza32005ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1609, obj_t BgL_new1110z00_1610)
{
{ /* Llib/pgp_composition.scm 42 */
return 
((obj_t)
((BgL_pgpzd2messagezd2_bglt)BgL_new1110z00_1610));} 

}



/* &lambda2003 */
BgL_pgpzd2messagezd2_bglt BGl_z62lambda2003z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1611)
{
{ /* Llib/pgp_composition.scm 42 */
{ /* Llib/pgp_composition.scm 42 */
BgL_pgpzd2messagezd2_bglt BgL_new1109z00_1801;
BgL_new1109z00_1801 = 
((BgL_pgpzd2messagezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2messagezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 42 */
long BgL_arg2004z00_1802;
BgL_arg2004z00_1802 = 
BGL_CLASS_INDEX(BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_1801), BgL_arg2004z00_1802); } 
return BgL_new1109z00_1801;} } 

}



/* &<@anonymous:1988> */
obj_t BGl_z62zc3z04anonymousza31988ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1612, obj_t BgL_new1107z00_1613)
{
{ /* Llib/pgp_composition.scm 39 */
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_3167;
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1613)))->BgL_subkeysz00)=((obj_t)
MAKE_YOUNG_PAIR(BFALSE, BFALSE)),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1613)))->BgL_userzd2idszd2)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3167 = 
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1613); 
return 
((obj_t)BgL_auxz00_3167);} } 

}



/* &lambda1986 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1986z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1614)
{
{ /* Llib/pgp_composition.scm 39 */
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1106z00_1804;
BgL_new1106z00_1804 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 39 */
long BgL_arg1987z00_1805;
BgL_arg1987z00_1805 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1106z00_1804), BgL_arg1987z00_1805); } 
{ /* Llib/pgp_composition.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_3179;
BgL_tmpz00_3179 = 
((BgL_objectz00_bglt)BgL_new1106z00_1804); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3179, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1106z00_1804); 
return BgL_new1106z00_1804;} } 

}



/* &lambda1984 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1984z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1615, obj_t BgL_subkeys1104z00_1616, obj_t BgL_userzd2ids1105zd2_1617)
{
{ /* Llib/pgp_composition.scm 39 */
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1216z00_1808;
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1215z00_1809;
BgL_new1215z00_1809 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 39 */
long BgL_arg1985z00_1810;
BgL_arg1985z00_1810 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_1809), BgL_arg1985z00_1810); } 
{ /* Llib/pgp_composition.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_3187;
BgL_tmpz00_3187 = 
((BgL_objectz00_bglt)BgL_new1215z00_1809); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3187, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1215z00_1809); 
BgL_new1216z00_1808 = BgL_new1215z00_1809; } 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1216z00_1808))->BgL_subkeysz00)=((obj_t)
((obj_t)BgL_subkeys1104z00_1616)),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1216z00_1808))->BgL_userzd2idszd2)=((obj_t)
((obj_t)BgL_userzd2ids1105zd2_1617)),BUNSPEC); 
return BgL_new1216z00_1808;} } 

}



/* &lambda1998 */
obj_t BGl_z62lambda1998z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1618, obj_t BgL_oz00_1619, obj_t BgL_vz00_1620)
{
{ /* Llib/pgp_composition.scm 39 */
return 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1619)))->BgL_userzd2idszd2)=((obj_t)
((obj_t)BgL_vz00_1620)),BUNSPEC);} 

}



/* &lambda1997 */
obj_t BGl_z62lambda1997z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1621, obj_t BgL_oz00_1622)
{
{ /* Llib/pgp_composition.scm 39 */
return 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1622)))->BgL_userzd2idszd2);} 

}



/* &lambda1993 */
obj_t BGl_z62lambda1993z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1623, obj_t BgL_oz00_1624, obj_t BgL_vz00_1625)
{
{ /* Llib/pgp_composition.scm 39 */
return 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1624)))->BgL_subkeysz00)=((obj_t)
((obj_t)BgL_vz00_1625)),BUNSPEC);} 

}



/* &lambda1992 */
obj_t BGl_z62lambda1992z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1626, obj_t BgL_oz00_1627)
{
{ /* Llib/pgp_composition.scm 39 */
return 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1627)))->BgL_subkeysz00);} 

}



/* &<@anonymous:1978> */
obj_t BGl_z62zc3z04anonymousza31978ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1628, obj_t BgL_new1102z00_1629)
{
{ /* Llib/pgp_composition.scm 38 */
return 
((obj_t)
((BgL_pgpzd2compositionzd2_bglt)BgL_new1102z00_1629));} 

}



/* &lambda1976 */
BgL_pgpzd2compositionzd2_bglt BGl_z62lambda1976z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1630)
{
{ /* Llib/pgp_composition.scm 38 */
{ /* Llib/pgp_composition.scm 38 */
BgL_pgpzd2compositionzd2_bglt BgL_new1101z00_1818;
BgL_new1101z00_1818 = 
((BgL_pgpzd2compositionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2compositionzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 38 */
long BgL_arg1977z00_1819;
BgL_arg1977z00_1819 = 
BGL_CLASS_INDEX(BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1101z00_1818), BgL_arg1977z00_1819); } 
return BgL_new1101z00_1818;} } 

}



/* &<@anonymous:1951> */
obj_t BGl_z62zc3z04anonymousza31951ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1631, obj_t BgL_new1099z00_1632)
{
{ /* Llib/pgp_composition.scm 33 */
{ 
BgL_pgpzd2subkeyzd2_bglt BgL_auxz00_3211;
{ 
BgL_pgpzd2keyzd2packetz00_bglt BgL_auxz00_3212;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_classz00_1821;
BgL_classz00_1821 = BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL__ortest_1111z00_1822;
BgL__ortest_1111z00_1822 = 
BGL_CLASS_NIL(BgL_classz00_1821); 
if(
CBOOL(BgL__ortest_1111z00_1822))
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3212 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BgL__ortest_1111z00_1822)
; }  else 
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3212 = 
((BgL_pgpzd2keyzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1821))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1099z00_1632)))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)BgL_auxz00_3212),BUNSPEC); } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1099z00_1632)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1099z00_1632)))->BgL_revocationzd2sigszd2)=((obj_t)BNIL),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_3225;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_classz00_1823;
BgL_classz00_1823 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL__ortest_1111z00_1824;
BgL__ortest_1111z00_1824 = 
BGL_CLASS_NIL(BgL_classz00_1823); 
if(
CBOOL(BgL__ortest_1111z00_1824))
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3225 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1111z00_1824)
; }  else 
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3225 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1823))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1099z00_1632)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_3225),BUNSPEC); } 
BgL_auxz00_3211 = 
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1099z00_1632); 
return 
((obj_t)BgL_auxz00_3211);} } 

}



/* &lambda1949 */
BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1949z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1633)
{
{ /* Llib/pgp_composition.scm 33 */
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1098z00_1825;
BgL_new1098z00_1825 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 33 */
long BgL_arg1950z00_1826;
BgL_arg1950z00_1826 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1098z00_1825), BgL_arg1950z00_1826); } 
{ /* Llib/pgp_composition.scm 33 */
BgL_objectz00_bglt BgL_tmpz00_3240;
BgL_tmpz00_3240 = 
((BgL_objectz00_bglt)BgL_new1098z00_1825); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3240, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1098z00_1825); 
return BgL_new1098z00_1825;} } 

}



/* &lambda1947 */
BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1947z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1634, obj_t BgL_keyzd2packet1094zd2_1635, obj_t BgL_sigs1095z00_1636, obj_t BgL_revocationzd2sigs1096zd2_1637, obj_t BgL_pgpzd2key1097zd2_1638)
{
{ /* Llib/pgp_composition.scm 33 */
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1214z00_1831;
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1213z00_1832;
BgL_new1213z00_1832 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 33 */
long BgL_arg1948z00_1833;
BgL_arg1948z00_1833 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_1832), BgL_arg1948z00_1833); } 
{ /* Llib/pgp_composition.scm 33 */
BgL_objectz00_bglt BgL_tmpz00_3248;
BgL_tmpz00_3248 = 
((BgL_objectz00_bglt)BgL_new1213z00_1832); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3248, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1213z00_1832); 
BgL_new1214z00_1831 = BgL_new1213z00_1832; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1831))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_keyzd2packet1094zd2_1635)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1831))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1095z00_1636)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1831))->BgL_revocationzd2sigszd2)=((obj_t)
((obj_t)BgL_revocationzd2sigs1096zd2_1637)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1831))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)
((BgL_pgpzd2keyzd2_bglt)BgL_pgpzd2key1097zd2_1638)),BUNSPEC); 
return BgL_new1214z00_1831;} } 

}



/* &lambda1971 */
obj_t BGl_z62lambda1971z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1639, obj_t BgL_oz00_1640, obj_t BgL_vz00_1641)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1640)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)
((BgL_pgpzd2keyzd2_bglt)BgL_vz00_1641)),BUNSPEC);} 

}



/* &lambda1970 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1970z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1642, obj_t BgL_oz00_1643)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1643)))->BgL_pgpzd2keyzd2);} 

}



/* &lambda1966 */
obj_t BGl_z62lambda1966z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1644, obj_t BgL_oz00_1645, obj_t BgL_vz00_1646)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1645)))->BgL_revocationzd2sigszd2)=((obj_t)
((obj_t)BgL_vz00_1646)),BUNSPEC);} 

}



/* &lambda1965 */
obj_t BGl_z62lambda1965z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1647, obj_t BgL_oz00_1648)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1648)))->BgL_revocationzd2sigszd2);} 

}



/* &lambda1961 */
obj_t BGl_z62lambda1961z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1649, obj_t BgL_oz00_1650, obj_t BgL_vz00_1651)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1650)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1651)),BUNSPEC);} 

}



/* &lambda1960 */
obj_t BGl_z62lambda1960z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1652, obj_t BgL_oz00_1653)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1653)))->BgL_sigsz00);} 

}



/* &lambda1956 */
obj_t BGl_z62lambda1956z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1654, obj_t BgL_oz00_1655, obj_t BgL_vz00_1656)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1655)))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_vz00_1656)),BUNSPEC);} 

}



/* &lambda1955 */
BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1955z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1657, obj_t BgL_oz00_1658)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1658)))->BgL_keyzd2packetzd2);} 

}



/* &<@anonymous:1931> */
obj_t BGl_z62zc3z04anonymousza31931ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1659, obj_t BgL_new1092z00_1660)
{
{ /* Llib/pgp_composition.scm 30 */
{ 
BgL_signedzd2idzd2_bglt BgL_auxz00_3280;
{ 
BgL_pgpzd2idzd2packetz00_bglt BgL_auxz00_3281;
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_classz00_1847;
BgL_classz00_1847 = BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL__ortest_1111z00_1848;
BgL__ortest_1111z00_1848 = 
BGL_CLASS_NIL(BgL_classz00_1847); 
if(
CBOOL(BgL__ortest_1111z00_1848))
{ /* Llib/pgp_composition.scm 30 */
BgL_auxz00_3281 = 
((BgL_pgpzd2idzd2packetz00_bglt)BgL__ortest_1111z00_1848)
; }  else 
{ /* Llib/pgp_composition.scm 30 */
BgL_auxz00_3281 = 
((BgL_pgpzd2idzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1847))
; } } } 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_new1092z00_1660)))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)BgL_auxz00_3281),BUNSPEC); } 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_new1092z00_1660)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3280 = 
((BgL_signedzd2idzd2_bglt)BgL_new1092z00_1660); 
return 
((obj_t)BgL_auxz00_3280);} } 

}



/* &lambda1929 */
BgL_signedzd2idzd2_bglt BGl_z62lambda1929z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1661)
{
{ /* Llib/pgp_composition.scm 30 */
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1091z00_1849;
BgL_new1091z00_1849 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 30 */
long BgL_arg1930z00_1850;
BgL_arg1930z00_1850 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_1849), BgL_arg1930z00_1850); } 
{ /* Llib/pgp_composition.scm 30 */
BgL_objectz00_bglt BgL_tmpz00_3298;
BgL_tmpz00_3298 = 
((BgL_objectz00_bglt)BgL_new1091z00_1849); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3298, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1091z00_1849); 
return BgL_new1091z00_1849;} } 

}



/* &lambda1927 */
BgL_signedzd2idzd2_bglt BGl_z62lambda1927z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1662, obj_t BgL_id1089z00_1663, obj_t BgL_sigs1090z00_1664)
{
{ /* Llib/pgp_composition.scm 30 */
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1212z00_1853;
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1211z00_1854;
BgL_new1211z00_1854 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 30 */
long BgL_arg1928z00_1855;
BgL_arg1928z00_1855 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_1854), BgL_arg1928z00_1855); } 
{ /* Llib/pgp_composition.scm 30 */
BgL_objectz00_bglt BgL_tmpz00_3306;
BgL_tmpz00_3306 = 
((BgL_objectz00_bglt)BgL_new1211z00_1854); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3306, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1211z00_1854); 
BgL_new1212z00_1853 = BgL_new1211z00_1854; } 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1212z00_1853))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)BgL_id1089z00_1663)),BUNSPEC); 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1212z00_1853))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1090z00_1664)),BUNSPEC); 
return BgL_new1212z00_1853;} } 

}



/* &lambda1941 */
obj_t BGl_z62lambda1941z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1665, obj_t BgL_oz00_1666, obj_t BgL_vz00_1667)
{
{ /* Llib/pgp_composition.scm 30 */
return 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1666)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1667)),BUNSPEC);} 

}



/* &lambda1940 */
obj_t BGl_z62lambda1940z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1668, obj_t BgL_oz00_1669)
{
{ /* Llib/pgp_composition.scm 30 */
return 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1669)))->BgL_sigsz00);} 

}



/* &lambda1936 */
obj_t BGl_z62lambda1936z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1670, obj_t BgL_oz00_1671, obj_t BgL_vz00_1672)
{
{ /* Llib/pgp_composition.scm 30 */
return 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1671)))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)BgL_vz00_1672)),BUNSPEC);} 

}



/* &lambda1935 */
BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda1935z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1673, obj_t BgL_oz00_1674)
{
{ /* Llib/pgp_composition.scm 30 */
return 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1674)))->BgL_idz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_proc2251z00zz__openpgpzd2compositionzd2, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, BGl_string2252z00zz__openpgpzd2compositionzd2);} 

}



/* &encode-pgp1312 */
obj_t BGl_z62encodezd2pgp1312zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1676, obj_t BgL_thisz00_1677, obj_t BgL_pz00_1678)
{
{ /* Llib/pgp_composition.scm 518 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string2253z00zz__openpgpzd2compositionzd2, 
((obj_t)
((BgL_pgpzd2compositionzd2_bglt)BgL_thisz00_1677)));} 

}



/* encode-pgp */
obj_t BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_thisz00_17, obj_t BgL_pz00_18)
{
{ /* Llib/pgp_composition.scm 518 */
{ /* Llib/pgp_composition.scm 518 */
obj_t BgL_method1313z00_941;
{ /* Llib/pgp_composition.scm 518 */
obj_t BgL_res2145z00_1458;
{ /* Llib/pgp_composition.scm 518 */
long BgL_objzd2classzd2numz00_1429;
BgL_objzd2classzd2numz00_1429 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_thisz00_17)); 
{ /* Llib/pgp_composition.scm 518 */
obj_t BgL_arg1765z00_1430;
BgL_arg1765z00_1430 = 
PROCEDURE_REF(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, 
(int)(((long)1))); 
{ /* Llib/pgp_composition.scm 518 */
int BgL_offsetz00_1433;
BgL_offsetz00_1433 = 
(int)(BgL_objzd2classzd2numz00_1429); 
{ /* Llib/pgp_composition.scm 518 */
long BgL_offsetz00_1434;
BgL_offsetz00_1434 = 
(
(long)(BgL_offsetz00_1433)-OBJECT_TYPE); 
{ /* Llib/pgp_composition.scm 518 */
long BgL_modz00_1435;
BgL_modz00_1435 = 
(BgL_offsetz00_1434 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/pgp_composition.scm 518 */
long BgL_restz00_1437;
BgL_restz00_1437 = 
(BgL_offsetz00_1434 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/pgp_composition.scm 518 */

{ /* Llib/pgp_composition.scm 518 */
obj_t BgL_bucketz00_1439;
BgL_bucketz00_1439 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1430),BgL_modz00_1435); 
BgL_res2145z00_1458 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1439),BgL_restz00_1437); } } } } } } } } 
BgL_method1313z00_941 = BgL_res2145z00_1458; } 
return 
PROCEDURE_ENTRY(BgL_method1313z00_941)(BgL_method1313z00_941, 
((obj_t)BgL_thisz00_17), BgL_pz00_18, BEOA);} } 

}



/* &encode-pgp */
obj_t BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1679, obj_t BgL_thisz00_1680, obj_t BgL_pz00_1681)
{
{ /* Llib/pgp_composition.scm 518 */
{ /* Llib/pgp_composition.scm 518 */
obj_t BgL_auxz00_3368;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_3360;
if(
OUTPUT_PORTP(BgL_pz00_1681))
{ /* Llib/pgp_composition.scm 518 */
BgL_auxz00_3368 = BgL_pz00_1681
; }  else 
{ 
obj_t BgL_auxz00_3371;
BgL_auxz00_3371 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)19466)), BGl_string2254z00zz__openpgpzd2compositionzd2, BGl_string2191z00zz__openpgpzd2compositionzd2, BgL_pz00_1681); 
FAILURE(BgL_auxz00_3371,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_thisz00_1680, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 518 */
BgL_auxz00_3360 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_thisz00_1680)
; }  else 
{ 
obj_t BgL_auxz00_3364;
BgL_auxz00_3364 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2169z00zz__openpgpzd2compositionzd2, 
BINT(((long)19466)), BGl_string2254z00zz__openpgpzd2compositionzd2, BGl_string2190z00zz__openpgpzd2compositionzd2, BgL_thisz00_1680); 
FAILURE(BgL_auxz00_3364,BFALSE,BFALSE);} 
return 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_auxz00_3360, BgL_auxz00_3368);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2, BGl_proc2255z00zz__openpgpzd2compositionzd2, BGl_string2256z00zz__openpgpzd2compositionzd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2, BGl_proc2257z00zz__openpgpzd2compositionzd2, BGl_string2256z00zz__openpgpzd2compositionzd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2, BGl_proc2258z00zz__openpgpzd2compositionzd2, BGl_string2256z00zz__openpgpzd2compositionzd2); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2, BGl_proc2259z00zz__openpgpzd2compositionzd2, BGl_string2256z00zz__openpgpzd2compositionzd2);} 

}



/* &encode-pgp-PGP-Encry1321 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Encry1321zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1686, obj_t BgL_thisz00_1687, obj_t BgL_pz00_1688)
{
{ /* Llib/pgp_composition.scm 579 */
{ /* Llib/pgp_composition.scm 581 */
obj_t BgL_g1286z00_1866;
BgL_g1286z00_1866 = 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_thisz00_1687)))->BgL_sessionzd2keyszd2); 
{ 
obj_t BgL_l1284z00_1868;
BgL_l1284z00_1868 = BgL_g1286z00_1866; 
BgL_zc3z04anonymousza32113ze3z87_1867:
if(
PAIRP(BgL_l1284z00_1868))
{ /* Llib/pgp_composition.scm 581 */
{ /* Llib/pgp_composition.scm 582 */
obj_t BgL_sessionzd2keyzd2_1869;
BgL_sessionzd2keyzd2_1869 = 
CAR(BgL_l1284z00_1868); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sessionzd2keyzd2_1869), 
((obj_t)BgL_pz00_1688)); } 
{ 
obj_t BgL_l1284z00_3388;
BgL_l1284z00_3388 = 
CDR(BgL_l1284z00_1868); 
BgL_l1284z00_1868 = BgL_l1284z00_3388; 
goto BgL_zc3z04anonymousza32113ze3z87_1867;} }  else 
{ /* Llib/pgp_composition.scm 581 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 584 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_arg2116z00_1870;
BgL_arg2116z00_1870 = 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_thisz00_1687)))->BgL_encryptedzd2datazd2); 
return 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2116z00_1870), 
((obj_t)BgL_pz00_1688));} } 

}



/* &encode-pgp-PGP-Signa1319 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Signa1319zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1689, obj_t BgL_thisz00_1690, obj_t BgL_pz00_1691)
{
{ /* Llib/pgp_composition.scm 569 */
{ /* Llib/pgp_composition.scm 571 */
obj_t BgL_g1283z00_1873;
BgL_g1283z00_1873 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1690)))->BgL_sigsz00); 
{ 
obj_t BgL_l1281z00_1875;
BgL_l1281z00_1875 = BgL_g1283z00_1873; 
BgL_zc3z04anonymousza32108ze3z87_1874:
if(
PAIRP(BgL_l1281z00_1875))
{ /* Llib/pgp_composition.scm 571 */
{ /* Llib/pgp_composition.scm 572 */
obj_t BgL_sigz00_1876;
BgL_sigz00_1876 = 
CAR(BgL_l1281z00_1875); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_1876), 
((obj_t)BgL_pz00_1691)); } 
{ 
obj_t BgL_l1281z00_3403;
BgL_l1281z00_3403 = 
CDR(BgL_l1281z00_1875); 
BgL_l1281z00_1875 = BgL_l1281z00_3403; 
goto BgL_zc3z04anonymousza32108ze3z87_1874;} }  else 
{ /* Llib/pgp_composition.scm 571 */((bool_t)1); } } } 
if(
CBOOL(
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1690)))->BgL_msgz00)))
{ /* Llib/pgp_composition.scm 574 */
obj_t BgL_arg2112z00_1877;
BgL_arg2112z00_1877 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1690)))->BgL_msgz00); 
return 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2112z00_1877), 
((obj_t)BgL_pz00_1691));}  else 
{ /* Llib/pgp_composition.scm 574 */
return BFALSE;} } 

}



/* &encode-pgp-PGP-One-P1317 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1317z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1692, obj_t BgL_thisz00_1693, obj_t BgL_pz00_1694)
{
{ /* Llib/pgp_composition.scm 556 */
{ /* Llib/pgp_composition.scm 557 */
bool_t BgL_tmpz00_3414;
{ /* Llib/pgp_composition.scm 558 */
obj_t BgL_g1277z00_1880;
BgL_g1277z00_1880 = 
bgl_reverse(
(((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1693)))->BgL_onezd2passzd2sigsz00)); 
{ 
obj_t BgL_l1275z00_1882;
BgL_l1275z00_1882 = BgL_g1277z00_1880; 
BgL_zc3z04anonymousza32100ze3z87_1881:
if(
PAIRP(BgL_l1275z00_1882))
{ /* Llib/pgp_composition.scm 560 */
{ /* Llib/pgp_composition.scm 559 */
obj_t BgL_opsz00_1883;
BgL_opsz00_1883 = 
CAR(BgL_l1275z00_1882); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_opsz00_1883), 
((obj_t)BgL_pz00_1694)); } 
{ 
obj_t BgL_l1275z00_3424;
BgL_l1275z00_3424 = 
CDR(BgL_l1275z00_1882); 
BgL_l1275z00_1882 = BgL_l1275z00_3424; 
goto BgL_zc3z04anonymousza32100ze3z87_1881;} }  else 
{ /* Llib/pgp_composition.scm 560 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 561 */
obj_t BgL_arg2104z00_1884;
BgL_arg2104z00_1884 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1693))))->BgL_msgz00); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2104z00_1884), 
((obj_t)BgL_pz00_1694)); } 
{ /* Llib/pgp_composition.scm 562 */
obj_t BgL_g1280z00_1885;
BgL_g1280z00_1885 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1693))))->BgL_sigsz00); 
{ 
obj_t BgL_l1278z00_1887;
BgL_l1278z00_1887 = BgL_g1280z00_1885; 
BgL_zc3z04anonymousza32105ze3z87_1886:
if(
PAIRP(BgL_l1278z00_1887))
{ /* Llib/pgp_composition.scm 562 */
{ /* Llib/pgp_composition.scm 563 */
obj_t BgL_sigz00_1888;
BgL_sigz00_1888 = 
CAR(BgL_l1278z00_1887); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_1888), 
((obj_t)BgL_pz00_1694)); } 
{ 
obj_t BgL_l1278z00_3441;
BgL_l1278z00_3441 = 
CDR(BgL_l1278z00_1887); 
BgL_l1278z00_1887 = BgL_l1278z00_3441; 
goto BgL_zc3z04anonymousza32105ze3z87_1886;} }  else 
{ /* Llib/pgp_composition.scm 562 */
BgL_tmpz00_3414 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_3414);} } 

}



/* &encode-pgp-PGP-Key1315 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Key1315zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1695, obj_t BgL_thisz00_1696, obj_t BgL_pz00_1697)
{
{ /* Llib/pgp_composition.scm 526 */
{ /* Llib/pgp_composition.scm 527 */
bool_t BgL_tmpz00_3444;
{ /* Llib/pgp_composition.scm 528 */
obj_t BgL_mainzd2keyzd2_1891;
BgL_mainzd2keyzd2_1891 = 
CAR(
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1696)))->BgL_subkeysz00)); 
{ /* Llib/pgp_composition.scm 528 */
obj_t BgL_otherzd2subkeyszd2_1892;
BgL_otherzd2subkeyszd2_1892 = 
CDR(
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1696)))->BgL_subkeysz00)); 
{ /* Llib/pgp_composition.scm 529 */

{ /* Llib/pgp_composition.scm 531 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_arg2077z00_1893;
BgL_arg2077z00_1893 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_mainzd2keyzd2_1891)))->BgL_keyzd2packetzd2); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2077z00_1893), 
((obj_t)BgL_pz00_1697)); } 
{ /* Llib/pgp_composition.scm 532 */
obj_t BgL_g1260z00_1894;
BgL_g1260z00_1894 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_mainzd2keyzd2_1891)))->BgL_revocationzd2sigszd2); 
{ 
obj_t BgL_l1258z00_1896;
BgL_l1258z00_1896 = BgL_g1260z00_1894; 
BgL_zc3z04anonymousza32078ze3z87_1895:
if(
PAIRP(BgL_l1258z00_1896))
{ /* Llib/pgp_composition.scm 532 */
{ /* Llib/pgp_composition.scm 532 */
obj_t BgL_revoczd2sigzd2_1897;
BgL_revoczd2sigzd2_1897 = 
CAR(BgL_l1258z00_1896); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_revoczd2sigzd2_1897), 
((obj_t)BgL_pz00_1697)); } 
{ 
obj_t BgL_l1258z00_3464;
BgL_l1258z00_3464 = 
CDR(BgL_l1258z00_1896); 
BgL_l1258z00_1896 = BgL_l1258z00_3464; 
goto BgL_zc3z04anonymousza32078ze3z87_1895;} }  else 
{ /* Llib/pgp_composition.scm 532 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 534 */
obj_t BgL_g1266z00_1898;
BgL_g1266z00_1898 = 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1696)))->BgL_userzd2idszd2); 
{ 
obj_t BgL_l1264z00_1900;
BgL_l1264z00_1900 = BgL_g1266z00_1898; 
BgL_zc3z04anonymousza32081ze3z87_1899:
if(
PAIRP(BgL_l1264z00_1900))
{ /* Llib/pgp_composition.scm 534 */
{ /* Llib/pgp_composition.scm 535 */
obj_t BgL_userzd2idzd2_1901;
BgL_userzd2idzd2_1901 = 
CAR(BgL_l1264z00_1900); 
{ /* Llib/pgp_composition.scm 536 */
BgL_pgpzd2idzd2packetz00_bglt BgL_arg2083z00_1902;
BgL_arg2083z00_1902 = 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_userzd2idzd2_1901)))->BgL_idz00); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2083z00_1902), 
((obj_t)BgL_pz00_1697)); } 
{ /* Llib/pgp_composition.scm 537 */
obj_t BgL_g1263z00_1903;
BgL_g1263z00_1903 = 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_userzd2idzd2_1901)))->BgL_sigsz00); 
{ 
obj_t BgL_l1261z00_1905;
BgL_l1261z00_1905 = BgL_g1263z00_1903; 
BgL_zc3z04anonymousza32084ze3z87_1904:
if(
PAIRP(BgL_l1261z00_1905))
{ /* Llib/pgp_composition.scm 537 */
{ /* Llib/pgp_composition.scm 538 */
obj_t BgL_sigz00_1906;
BgL_sigz00_1906 = 
CAR(BgL_l1261z00_1905); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_1906), 
((obj_t)BgL_pz00_1697)); } 
{ 
obj_t BgL_l1261z00_3484;
BgL_l1261z00_3484 = 
CDR(BgL_l1261z00_1905); 
BgL_l1261z00_1905 = BgL_l1261z00_3484; 
goto BgL_zc3z04anonymousza32084ze3z87_1904;} }  else 
{ /* Llib/pgp_composition.scm 537 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1264z00_3486;
BgL_l1264z00_3486 = 
CDR(BgL_l1264z00_1900); 
BgL_l1264z00_1900 = BgL_l1264z00_3486; 
goto BgL_zc3z04anonymousza32081ze3z87_1899;} }  else 
{ /* Llib/pgp_composition.scm 534 */((bool_t)1); } } } 
{ 
obj_t BgL_l1273z00_1908;
BgL_l1273z00_1908 = BgL_otherzd2subkeyszd2_1892; 
BgL_zc3z04anonymousza32088ze3z87_1907:
if(
PAIRP(BgL_l1273z00_1908))
{ /* Llib/pgp_composition.scm 541 */
{ /* Llib/pgp_composition.scm 542 */
obj_t BgL_subkeyz00_1909;
BgL_subkeyz00_1909 = 
CAR(BgL_l1273z00_1908); 
{ /* Llib/pgp_composition.scm 544 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_arg2090z00_1910;
BgL_arg2090z00_1910 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_1909)))->BgL_keyzd2packetzd2); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2090z00_1910), 
((obj_t)BgL_pz00_1697)); } 
{ /* Llib/pgp_composition.scm 545 */
obj_t BgL_g1269z00_1911;
BgL_g1269z00_1911 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_1909)))->BgL_sigsz00); 
{ 
obj_t BgL_l1267z00_1913;
BgL_l1267z00_1913 = BgL_g1269z00_1911; 
BgL_zc3z04anonymousza32091ze3z87_1912:
if(
PAIRP(BgL_l1267z00_1913))
{ /* Llib/pgp_composition.scm 545 */
{ /* Llib/pgp_composition.scm 546 */
obj_t BgL_sigz00_1914;
BgL_sigz00_1914 = 
CAR(BgL_l1267z00_1913); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_1914), 
((obj_t)BgL_pz00_1697)); } 
{ 
obj_t BgL_l1267z00_3504;
BgL_l1267z00_3504 = 
CDR(BgL_l1267z00_1913); 
BgL_l1267z00_1913 = BgL_l1267z00_3504; 
goto BgL_zc3z04anonymousza32091ze3z87_1912;} }  else 
{ /* Llib/pgp_composition.scm 545 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 548 */
obj_t BgL_g1272z00_1915;
BgL_g1272z00_1915 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_1909)))->BgL_revocationzd2sigszd2); 
{ 
obj_t BgL_l1270z00_1917;
BgL_l1270z00_1917 = BgL_g1272z00_1915; 
BgL_zc3z04anonymousza32094ze3z87_1916:
if(
PAIRP(BgL_l1270z00_1917))
{ /* Llib/pgp_composition.scm 548 */
{ /* Llib/pgp_composition.scm 549 */
obj_t BgL_revoczd2sigzd2_1918;
BgL_revoczd2sigzd2_1918 = 
CAR(BgL_l1270z00_1917); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_revoczd2sigzd2_1918), 
((obj_t)BgL_pz00_1697)); } 
{ 
obj_t BgL_l1270z00_3514;
BgL_l1270z00_3514 = 
CDR(BgL_l1270z00_1917); 
BgL_l1270z00_1917 = BgL_l1270z00_3514; 
goto BgL_zc3z04anonymousza32094ze3z87_1916;} }  else 
{ /* Llib/pgp_composition.scm 548 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1273z00_3516;
BgL_l1273z00_3516 = 
CDR(BgL_l1273z00_1908); 
BgL_l1273z00_1908 = BgL_l1273z00_3516; 
goto BgL_zc3z04anonymousza32088ze3z87_1907;} }  else 
{ /* Llib/pgp_composition.scm 541 */
BgL_tmpz00_3444 = ((bool_t)1)
; } } } } } 
return 
BBOOL(BgL_tmpz00_3444);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(((long)486475050), 
BSTRING_TO_STRING(BGl_string2260z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(((long)485669724), 
BSTRING_TO_STRING(BGl_string2260z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2decodezd2(((long)216390694), 
BSTRING_TO_STRING(BGl_string2260z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(((long)466864889), 
BSTRING_TO_STRING(BGl_string2260z00zz__openpgpzd2compositionzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__openpgpzd2portzd2utilz00(((long)98035382), 
BSTRING_TO_STRING(BGl_string2260z00zz__openpgpzd2compositionzd2));} 

}

#ifdef __cplusplus
}
#endif
