/*===========================================================================*/
/*   (Llib/sqlite.scm)                                                       */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -srfi sqlite -unsafe -safee -copt -fPIC -copt -IPosix Llib/sqlite.scm -o objs/sqlite.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <sqlite3.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z42sqltinyz42_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z42versionz42;
   obj_t BgL_pathz00;
   obj_t BgL_syncz00;
   obj_t BgL_tablesz00;
   obj_t BgL_mutexz00;
   bool_t BgL_transactionz00;
} *BgL_z42sqltinyz42_bglt;

typedef struct BgL_sqlitez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_pathz00;
   void * BgL_z42builtinz42;
} *BgL_sqlitez00_bglt;

typedef struct BgL_z52sqlitez52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_pathz00;
} *BgL_z52sqlitez52_bglt;

typedef struct BgL_sqltinyz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_pathz00;
   obj_t BgL_syncz00;
   struct BgL_z42sqltinyz42_bgl * BgL_z42builtinz42;
} *BgL_sqltinyz00_bglt;


static obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32002ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31943ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31935ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2dumpzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2execzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32011ze3ze5zz__sqlite_sqlitez00(obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62sqlitezd2evalzb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__sqlite_sqlitez00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31944ze3ze5zz__sqlite_sqlitez00(obj_t);
extern void * bgl_sqlite_open(char *);
static BgL_z52sqlitez52_bglt BGl_z62lambda1784z62zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(obj_t, obj_t, long);
static obj_t BGl_zc3z04exitza31930ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2tablezd2numberzd2ofzd2rowsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t);
static obj_t BGl_z62lambda1791z62zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1792z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static BgL_sqltinyz00_bglt BGl_z62lambda1799z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32021ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2dumpzd2table1248z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2close1232zb0zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_displayzd2sqlitezd2quotezd2listze70z35zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32022ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__sqlite_sqlitez00();
static obj_t BGl_z62sqlitezd2map1244zb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31793ze3ze5zz__sqlite_sqlitez00(obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t BGl_z42sqltinyzd2dumpzd2tablez42zz__sqlite_sqltinyz00(obj_t, BgL_z42sqltinyz42_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2closezd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt);
static obj_t BGl_z62sqlitezd2evalzd2sqlite1243z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31786ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__sqlite_sqlitez00();
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2tablezd2namezd2ofzd2columnsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32032ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52setupzd2sqltinyz12z92zz__sqlite_sqlitez00(BgL_sqltinyz00_bglt);
static obj_t BGl_objectzd2initzd2zz__sqlite_sqlitez00();
static obj_t BGl_z62zc3z04anonymousza31957ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62z52setupzd2sqltinyz12zf0zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_zc3z04exitza32008ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32033ze3ze5zz__sqlite_sqlitez00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_sqlitez00zz__sqlite_sqlitez00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31321ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
extern obj_t BGl_z42sqltinyzd2evalz90zz__sqlite_sqltinyz00(BgL_z42sqltinyz42_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31986ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31878ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62sqlitezd2dumpzb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2printzd2sqlite1231z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z42sqlitezd2nilz90zz__sqlite_sqlitez00();
static obj_t BGl_z62sqlitezd2execzb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31941ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2mapzd2sqlite1247z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31887ze3ze5zz__sqlite_sqlitez00(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_writez00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62sqlitezd2tablezd2informationsz62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2tablezd2numberzd2ofzd2rowsz62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31325ze32069ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__sqlite_sqlitez00();
extern obj_t bgl_sqlite_eval(void *, obj_t, char *, obj_t);
static obj_t BGl_z62sqlitezd2formatzb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectzd2writezd2zz__objectz00(BgL_objectz00_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_z52sqlitez52zz__sqlite_sqlitez00 = BUNSPEC;
static obj_t BGl_z62sqlitezd2execzd2sqlite1239z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31978ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31325ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62z52setupzd2sqlitez12zf0zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31988ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
static obj_t BGl_zc3z04exitza32019ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2lastzd2insertzd2rowidzb0zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2tablezd2informationsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__sqlite_sqlitez00(obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31997ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z42sqltinyzd2execz90zz__sqlite_sqltinyz00(BgL_z42sqltinyz42_bglt, obj_t, obj_t);
static obj_t BGl_zc3z04exitza31952ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62sqlitezd2closezd2sqlite1235z62zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62z42sqlitezd2nilzf2zz__sqlite_sqlitez00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2dumpzd2tablez00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52setupzd2sqlitez12z92zz__sqlite_sqlitez00(BgL_sqlitez00_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__sqlite_sqlitez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__sqlite_sqltinyz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62sqlitezd2mapzb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t bgl_sqlite_exec(void *, char *, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31283ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2closezb0zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62objectzd2writezd2sqlite1229z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
static obj_t BGl_z62sqlitezd2tablezd2namezd2ofzd2columnsz62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2namezd2ofzd2tableszd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt);
static obj_t BGl_zc3z04exitza31919ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2exec1236zb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__sqlite_sqlitez00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__sqlite_sqlitez00();
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__sqlite_sqlitez00();
static obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__sqlite_sqlitez00();
static obj_t BGl_z62zc3z04anonymousza31804ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_sqltinyz00zz__sqlite_sqlitez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_zc3z04exitza31963ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2lastzd2insertzd2rowidzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt);
static obj_t BGl_z62zc3z04anonymousza31911ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31830ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
extern obj_t BGl_z42sqltinyz42zz__sqlite_sqltinyz00;
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
BGL_EXPORTED_DECL obj_t BGl_sqlitezd2evalzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2namezd2ofzd2tableszb0zz__sqlite_sqlitez00(obj_t, obj_t);
extern obj_t BGl_z42sqltinyzd2mapz90zz__sqlite_sqltinyz00(BgL_z42sqltinyz42_bglt, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza31921ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31913ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62sqlitezd2eval1240zb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z42sqltinyzd2closez90zz__sqlite_sqltinyz00(BgL_z42sqltinyz42_bglt, obj_t);
static obj_t BGl_zc3z04exitza32030ze3ze70z60zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31922ze3ze5zz__sqlite_sqlitez00(obj_t);
static BgL_sqltinyz00_bglt BGl_z62lambda1802z62zz__sqlite_sqlitez00(obj_t);
extern void bgl_sqlite_close(void *, obj_t);
BGL_IMPORT long bgl_date_to_seconds(obj_t);
static obj_t BGl_z62lambda1810z62zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62lambda1811z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static BgL_z42sqltinyz42_bglt BGl_z62lambda1817z62zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62lambda1818z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2displayzd2sqlit1227z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62sqlitezd2dumpzd2tablezd2sq1251zb0zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31819ze3ze5zz__sqlite_sqlitez00(obj_t);
static BgL_sqlitez00_bglt BGl_z62lambda1825z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static BgL_sqlitez00_bglt BGl_z62lambda1828z62zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31283ze32068ze5zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t BGl_z62sqlitezd2dumpzd2tablez62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__sqlite_sqlitez00(obj_t);
extern BgL_z42sqltinyz42_bglt BGl_z42sqltinyzd2openz90zz__sqlite_sqltinyz00(obj_t, obj_t);
static obj_t BGl_z62lambda1835z62zz__sqlite_sqlitez00(obj_t, obj_t);
static obj_t BGl_z62lambda1836z62zz__sqlite_sqlitez00(obj_t, obj_t, obj_t);
extern obj_t bgl_sqlite_map(void *, obj_t, char *, obj_t);
static obj_t BGl_z62zc3z04anonymousza31837ze3ze5zz__sqlite_sqlitez00(obj_t);
static obj_t __cnst[ 14 ] ;


DEFINE_STRING( BGl_string2200z00zz__sqlite_sqlitez00, BgL_bgl_string2200za700za7za7_2228za7, "&sqlite-exec", 12 );
DEFINE_STRING( BGl_string2201z00zz__sqlite_sqlitez00, BgL_bgl_string2201za700za7za7_2229za7, "&sqlite-eval", 12 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z42sqlitezd2nilzd2envz42zz__sqlite_sqlitez00, BgL_bgl_za762za742sqliteza7d2n2230za7, BGl_z62z42sqlitezd2nilzf2zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2202z00zz__sqlite_sqlitez00, BgL_bgl_string2202za700za7za7_2231za7, "procedure", 9 );
DEFINE_STRING( BGl_string2203z00zz__sqlite_sqlitez00, BgL_bgl_string2203za700za7za7_2232za7, "&sqlite-map", 11 );
DEFINE_STRING( BGl_string2204z00zz__sqlite_sqlitez00, BgL_bgl_string2204za700za7za7_2233za7, "&sqlite-dump-table", 18 );
DEFINE_STRING( BGl_string2206z00zz__sqlite_sqlitez00, BgL_bgl_string2206za700za7za7_2234za7, "object-display", 14 );
DEFINE_STRING( BGl_string2208z00zz__sqlite_sqlitez00, BgL_bgl_string2208za700za7za7_2235za7, "object-write", 12 );
DEFINE_STRING( BGl_string2127z00zz__sqlite_sqlitez00, BgL_bgl_string2127za700za7za7_2236za7, "/builddir/build/BUILD/bigloo-4.4b/api/sqlite/src/Llib/sqlite.scm", 64 );
DEFINE_STRING( BGl_string2128z00zz__sqlite_sqlitez00, BgL_bgl_string2128za700za7za7_2237za7, "&%setup-sqlite!", 15 );
DEFINE_STRING( BGl_string2129z00zz__sqlite_sqlitez00, BgL_bgl_string2129za700za7za7_2238za7, "sqlite", 6 );
DEFINE_STRING( BGl_string2210z00zz__sqlite_sqlitez00, BgL_bgl_string2210za700za7za7_2239za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2205z00zz__sqlite_sqlitez00, BgL_bgl_za762objectza7d2disp2240z00, va_generic_entry, BGl_z62objectzd2displayzd2sqlit1227z62zz__sqlite_sqlitez00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string2130z00zz__sqlite_sqlitez00, BgL_bgl_string2130za700za7za7_2241za7, "&%setup-sqltiny!", 16 );
DEFINE_STRING( BGl_string2212z00zz__sqlite_sqlitez00, BgL_bgl_string2212za700za7za7_2242za7, "sqlite-close", 12 );
DEFINE_STRING( BGl_string2131z00zz__sqlite_sqlitez00, BgL_bgl_string2131za700za7za7_2243za7, "sqltiny", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2207z00zz__sqlite_sqlitez00, BgL_bgl_za762objectza7d2writ2244z00, va_generic_entry, BGl_z62objectzd2writezd2sqlite1229z62zz__sqlite_sqlitez00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string2132z00zz__sqlite_sqlitez00, BgL_bgl_string2132za700za7za7_2245za7, "PRAGMA table_info(~a)", 21 );
DEFINE_STRING( BGl_string2214z00zz__sqlite_sqlitez00, BgL_bgl_string2214za700za7za7_2246za7, "sqlite-exec", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2209z00zz__sqlite_sqlitez00, BgL_bgl_za762objectza7d2prin2247z00, BGl_z62objectzd2printzd2sqlite1231z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2134z00zz__sqlite_sqlitez00, BgL_bgl_string2134za700za7za7_2248za7, "&sqlite-table-informations", 26 );
DEFINE_STRING( BGl_string2216z00zz__sqlite_sqlitez00, BgL_bgl_string2216za700za7za7_2249za7, "sqlite-eval", 11 );
DEFINE_STRING( BGl_string2135z00zz__sqlite_sqlitez00, BgL_bgl_string2135za700za7za7_2250za7, "%sqlite", 7 );
DEFINE_STRING( BGl_string2136z00zz__sqlite_sqlitez00, BgL_bgl_string2136za700za7za7_2251za7, "bstring", 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2tablezd2informationszd2envzd2zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2tabl2252z00, BGl_z62sqlitezd2tablezd2informationsz62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2218z00zz__sqlite_sqlitez00, BgL_bgl_string2218za700za7za7_2253za7, "sqlite-map", 10 );
DEFINE_STRING( BGl_string2137z00zz__sqlite_sqlitez00, BgL_bgl_string2137za700za7za7_2254za7, "SELECT MAX(rowid) FROM ~A", 25 );
DEFINE_STRING( BGl_string2139z00zz__sqlite_sqlitez00, BgL_bgl_string2139za700za7za7_2255za7, "&sqlite-table-number-of-rows", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2211z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2clos2256z00, BGl_z62sqlitezd2closezd2sqlite1235z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2213z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2exec2257z00, va_generic_entry, BGl_z62sqlitezd2execzd2sqlite1239z62zz__sqlite_sqlitez00, BUNSPEC, -3 );
DEFINE_STRING( BGl_string2220z00zz__sqlite_sqlitez00, BgL_bgl_string2220za700za7za7_2258za7, "sqlite-dump-table", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2133z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2259za7, BGl_z62zc3z04anonymousza31283ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2221z00zz__sqlite_sqlitez00, BgL_bgl_string2221za700za7za7_2260za7, ".dump ", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2215z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2eval2261z00, va_generic_entry, BGl_z62sqlitezd2evalzd2sqlite1243z62zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_STRING( BGl_string2222z00zz__sqlite_sqlitez00, BgL_bgl_string2222za700za7za7_2262za7, ">", 1 );
DEFINE_STRING( BGl_string2141z00zz__sqlite_sqlitez00, BgL_bgl_string2141za700za7za7_2263za7, "&sqlite-table-name-of-columns", 29 );
DEFINE_STRING( BGl_string2223z00zz__sqlite_sqlitez00, BgL_bgl_string2223za700za7za7_2264za7, "#<sqlite:", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2217z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2mapza72265za7, va_generic_entry, BGl_z62sqlitezd2mapzd2sqlite1247z62zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_STRING( BGl_string2224z00zz__sqlite_sqlitez00, BgL_bgl_string2224za700za7za7_2266za7, "__sqlite_sqlite", 15 );
DEFINE_STRING( BGl_string2143z00zz__sqlite_sqlitez00, BgL_bgl_string2143za700za7za7_2267za7, "SELECT name FROM sqlite_master WHERE type='table'", 49 );
DEFINE_STRING( BGl_string2225z00zz__sqlite_sqlitez00, BgL_bgl_string2225za700za7za7_2268za7, "automatic _ sqlite $sqlite sqltiny $builtin symbol sync __sqlite_sqlite %sqlite bstring path sqlite-format sqlite-form ", 119 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2219z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2dump2269z00, BGl_z62sqlitezd2dumpzd2tablezd2sq1251zb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2144z00zz__sqlite_sqlitez00, BgL_bgl_string2144za700za7za7_2270za7, "&sqlite-name-of-tables", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2138z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2271za7, BGl_z62zc3z04anonymousza31321ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2146z00zz__sqlite_sqlitez00, BgL_bgl_string2146za700za7za7_2272za7, "&sqlite-dump", 12 );
DEFINE_STRING( BGl_string2147z00zz__sqlite_sqlitez00, BgL_bgl_string2147za700za7za7_2273za7, "output-port", 11 );
DEFINE_STRING( BGl_string2148z00zz__sqlite_sqlitez00, BgL_bgl_string2148za700za7za7_2274za7, ",", 1 );
DEFINE_STRING( BGl_string2149z00zz__sqlite_sqlitez00, BgL_bgl_string2149za700za7za7_2275za7, "Illegal list", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2140z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2276za7, BGl_z62zc3z04anonymousza31283ze32068ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2142z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2277za7, BGl_z62zc3z04anonymousza31325ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2150z00zz__sqlite_sqlitez00, BgL_bgl_string2150za700za7za7_2278za7, "Tag not allowd here", 19 );
DEFINE_STRING( BGl_string2151z00zz__sqlite_sqlitez00, BgL_bgl_string2151za700za7za7_2279za7, "Insufficient number of arguments", 32 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2145z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2280za7, BGl_z62zc3z04anonymousza31325ze32069ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2152z00zz__sqlite_sqlitez00, BgL_bgl_string2152za700za7za7_2281za7, "Illegal char", 12 );
DEFINE_STRING( BGl_string2153z00zz__sqlite_sqlitez00, BgL_bgl_string2153za700za7za7_2282za7, "Illegal number", 14 );
DEFINE_STRING( BGl_string2154z00zz__sqlite_sqlitez00, BgL_bgl_string2154za700za7za7_2283za7, "Illegal tag", 11 );
DEFINE_STRING( BGl_string2155z00zz__sqlite_sqlitez00, BgL_bgl_string2155za700za7za7_2284za7, "#{", 2 );
DEFINE_STRING( BGl_string2156z00zz__sqlite_sqlitez00, BgL_bgl_string2156za700za7za7_2285za7, "}", 1 );
DEFINE_STRING( BGl_string2157z00zz__sqlite_sqlitez00, BgL_bgl_string2157za700za7za7_2286za7, " ", 1 );
DEFINE_STRING( BGl_string2158z00zz__sqlite_sqlitez00, BgL_bgl_string2158za700za7za7_2287za7, "#(", 2 );
DEFINE_STRING( BGl_string2159z00zz__sqlite_sqlitez00, BgL_bgl_string2159za700za7za7_2288za7, ")", 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sqlitezd2mapzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2mapza72289za7, va_generic_entry, BGl_z62sqlitezd2mapzb0zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_STRING( BGl_string2160z00zz__sqlite_sqlitez00, BgL_bgl_string2160za700za7za7_2290za7, "(", 1 );
DEFINE_STRING( BGl_string2161z00zz__sqlite_sqlitez00, BgL_bgl_string2161za700za7za7_2291za7, " . ", 3 );
DEFINE_STRING( BGl_string2162z00zz__sqlite_sqlitez00, BgL_bgl_string2162za700za7za7_2292za7, "\"\"", 2 );
DEFINE_STRING( BGl_string2163z00zz__sqlite_sqlitez00, BgL_bgl_string2163za700za7za7_2293za7, "NULL", 4 );
DEFINE_STRING( BGl_string2164z00zz__sqlite_sqlitez00, BgL_bgl_string2164za700za7za7_2294za7, "&sqlite-format", 14 );
DEFINE_STRING( BGl_string2165z00zz__sqlite_sqlitez00, BgL_bgl_string2165za700za7za7_2295za7, "SELECT last_insert_rowid()", 26 );
DEFINE_STRING( BGl_string2166z00zz__sqlite_sqlitez00, BgL_bgl_string2166za700za7za7_2296za7, "&sqlite-last-insert-rowid", 25 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2167z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2297za7, BGl_z62zc3z04anonymousza31793ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2168z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1792za7622298z00, BGl_z62lambda1792z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2169z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1791za7622299z00, BGl_z62lambda1791z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52setupzd2sqltinyz12zd2envz40zz__sqlite_sqlitez00, BgL_bgl_za762za752setupza7d2sq2300za7, BGl_z62z52setupzd2sqltinyz12zf0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2170z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2301za7, BGl_z62zc3z04anonymousza31786ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2171z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1784za7622302z00, BGl_z62lambda1784z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2172z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2303za7, BGl_z62zc3z04anonymousza31812ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2173z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1811za7622304z00, BGl_z62lambda1811z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2174z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1810za7622305z00, BGl_z62lambda1810z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2175z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2306za7, BGl_z62zc3z04anonymousza31819ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2176z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1818za7622307z00, BGl_z62lambda1818z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2177z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1817za7622308z00, BGl_z62lambda1817z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2178z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2309za7, BGl_z62zc3z04anonymousza31804ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2179z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1802za7622310z00, BGl_z62lambda1802z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2187z00zz__sqlite_sqlitez00, BgL_bgl_string2187za700za7za7_2311za7, "", 0 );
DEFINE_STRING( BGl_string2188z00zz__sqlite_sqlitez00, BgL_bgl_string2188za700za7za7_2312za7, ":memory:", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2180z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1799za7622313z00, BGl_z62lambda1799z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2181z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2314za7, BGl_z62zc3z04anonymousza31837ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2182z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1836za7622315z00, BGl_z62lambda1836z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2183z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1835za7622316z00, BGl_z62lambda1835z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2190z00zz__sqlite_sqlitez00, BgL_bgl_string2190za700za7za7_2317za7, "sqlite-close1232", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2184z00zz__sqlite_sqlitez00, BgL_bgl_za762za7c3za704anonymo2318za7, BGl_z62zc3z04anonymousza31830ze3ze5zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2185z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1828za7622319z00, BGl_z62lambda1828z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2192z00zz__sqlite_sqlitez00, BgL_bgl_string2192za700za7za7_2320za7, "sqlite-exec1236", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2186z00zz__sqlite_sqlitez00, BgL_bgl_za762lambda1825za7622321z00, BGl_z62lambda1825z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2194z00zz__sqlite_sqlitez00, BgL_bgl_string2194za700za7za7_2322za7, "sqlite-eval1240", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2189z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2clos2323z00, BGl_z62sqlitezd2close1232zb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2196z00zz__sqlite_sqlitez00, BgL_bgl_string2196za700za7za7_2324za7, "sqlite-map1244", 14 );
DEFINE_STRING( BGl_string2198z00zz__sqlite_sqlitez00, BgL_bgl_string2198za700za7za7_2325za7, "sqlite-dump-table1248", 21 );
DEFINE_STRING( BGl_string2199z00zz__sqlite_sqlitez00, BgL_bgl_string2199za700za7za7_2326za7, "&sqlite-close", 13 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2191z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2exec2327z00, va_generic_entry, BGl_z62sqlitezd2exec1236zb0zz__sqlite_sqlitez00, BUNSPEC, -3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2193z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2eval2328z00, va_generic_entry, BGl_z62sqlitezd2eval1240zb0zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2195z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2map12329z00, va_generic_entry, BGl_z62sqlitezd2map1244zb0zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2197z00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2dump2330z00, BGl_z62sqlitezd2dumpzd2table1248z62zz__sqlite_sqlitez00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z52setupzd2sqlitez12zd2envz40zz__sqlite_sqlitez00, BgL_bgl_za762za752setupza7d2sq2331za7, BGl_z62z52setupzd2sqlitez12zf0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
DEFINE_EXPORT_BGL_GENERIC( BGl_sqlitezd2execzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2exec2332z00, va_generic_entry, BGl_z62sqlitezd2execzb0zz__sqlite_sqlitez00, BUNSPEC, -3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2lastzd2insertzd2rowidzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2last2333z00, BGl_z62sqlitezd2lastzd2insertzd2rowidzb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2dumpzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2dump2334z00, BGl_z62sqlitezd2dumpzb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sqlitezd2evalzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2eval2335z00, va_generic_entry, BGl_z62sqlitezd2evalzb0zz__sqlite_sqlitez00, BUNSPEC, -4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2formatzd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2form2336z00, va_generic_entry, BGl_z62sqlitezd2formatzb0zz__sqlite_sqlitez00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sqlitezd2closezd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2clos2337z00, BGl_z62sqlitezd2closezb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2tablezd2namezd2ofzd2columnszd2envzd2zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2tabl2338z00, BGl_z62sqlitezd2tablezd2namezd2ofzd2columnsz62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_sqlitezd2dumpzd2tablezd2envzd2zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2dump2339z00, BGl_z62sqlitezd2dumpzd2tablez62zz__sqlite_sqlitez00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2namezd2ofzd2tableszd2envz00zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2name2340z00, BGl_z62sqlitezd2namezd2ofzd2tableszb0zz__sqlite_sqlitez00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sqlitezd2tablezd2numberzd2ofzd2rowszd2envzd2zz__sqlite_sqlitez00, BgL_bgl_za762sqliteza7d2tabl2341z00, BGl_z62sqlitezd2tablezd2numberzd2ofzd2rowsz62zz__sqlite_sqlitez00, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__sqlite_sqlitez00) );
ADD_ROOT( (void *)(&BGl_sqlitez00zz__sqlite_sqlitez00) );
ADD_ROOT( (void *)(&BGl_z52sqlitez52zz__sqlite_sqlitez00) );
ADD_ROOT( (void *)(&BGl_sqltinyz00zz__sqlite_sqlitez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__sqlite_sqlitez00(long BgL_checksumz00_2121, char * BgL_fromz00_2122)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__sqlite_sqlitez00))
{ 
BGl_requirezd2initializa7ationz75zz__sqlite_sqlitez00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__sqlite_sqlitez00(); 
BGl_libraryzd2moduleszd2initz00zz__sqlite_sqlitez00(); 
BGl_cnstzd2initzd2zz__sqlite_sqlitez00(); 
BGl_importedzd2moduleszd2initz00zz__sqlite_sqlitez00(); 
BGl_objectzd2initzd2zz__sqlite_sqlitez00(); 
BGl_genericzd2initzd2zz__sqlite_sqlitez00(); 
BGl_methodzd2initzd2zz__sqlite_sqlitez00(); 
return 
BGl_toplevelzd2initzd2zz__sqlite_sqlitez00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__sqlite_sqlite"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__sqlite_sqlite"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
{ /* Llib/sqlite.scm 15 */
obj_t BgL_cportz00_1945;
{ /* Llib/sqlite.scm 15 */
obj_t BgL_stringz00_1953;
BgL_stringz00_1953 = BGl_string2225z00zz__sqlite_sqlitez00; 
{ /* Llib/sqlite.scm 15 */
obj_t BgL_startz00_1954;
BgL_startz00_1954 = 
BINT(((long)0)); 
{ /* Llib/sqlite.scm 15 */
obj_t BgL_endz00_1955;
BgL_endz00_1955 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1953))); 
{ /* Llib/sqlite.scm 15 */

BgL_cportz00_1945 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1953, BgL_startz00_1954, BgL_endz00_1955); } } } } 
{ 
long BgL_iz00_1946;
BgL_iz00_1946 = ((long)13); 
BgL_loopz00_1947:
if(
(BgL_iz00_1946==((long)-1)))
{ /* Llib/sqlite.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/sqlite.scm 15 */
{ /* Llib/sqlite.scm 15 */
obj_t BgL_arg2227z00_1949;
{ /* Llib/sqlite.scm 15 */

{ /* Llib/sqlite.scm 15 */
obj_t BgL_locationz00_1951;
BgL_locationz00_1951 = 
BBOOL(((bool_t)0)); 
{ /* Llib/sqlite.scm 15 */

BgL_arg2227z00_1949 = 
BGl_readz00zz__readerz00(BgL_cportz00_1945, BgL_locationz00_1951); } } } 
{ /* Llib/sqlite.scm 15 */
int BgL_tmpz00_2161;
BgL_tmpz00_2161 = 
(int)(BgL_iz00_1946); 
CNST_TABLE_SET(BgL_tmpz00_2161, BgL_arg2227z00_1949); } } 
{ /* Llib/sqlite.scm 15 */
int BgL_auxz00_1952;
BgL_auxz00_1952 = 
(int)(
(BgL_iz00_1946-((long)1))); 
{ 
long BgL_iz00_2166;
BgL_iz00_2166 = 
(long)(BgL_auxz00_1952); 
BgL_iz00_1946 = BgL_iz00_2166; 
goto BgL_loopz00_1947;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
return BUNSPEC;} 

}



/* $sqlite-nil */
BGL_EXPORTED_DEF obj_t BGl_z42sqlitezd2nilz90zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 67 */
return 
void_star_to_obj(
(0L));} 

}



/* &$sqlite-nil */
obj_t BGl_z62z42sqlitezd2nilzf2zz__sqlite_sqlitez00(obj_t BgL_envz00_1425)
{
{ /* Llib/sqlite.scm 67 */
return 
BGl_z42sqlitezd2nilz90zz__sqlite_sqlitez00();} 

}



/* %setup-sqlite! */
BGL_EXPORTED_DEF obj_t BGl_z52setupzd2sqlitez12z92zz__sqlite_sqlitez00(BgL_sqlitez00_bglt BgL_oz00_10)
{
{ /* Llib/sqlite.scm 97 */
{ 
void * BgL_auxz00_2172;
{ /* Llib/sqlite.scm 101 */
obj_t BgL_arg1258z00_1009;
BgL_arg1258z00_1009 = 
(((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_10)))->BgL_pathz00); 
BgL_auxz00_2172 = 
bgl_sqlite_open(
BSTRING_TO_STRING(BgL_arg1258z00_1009)); } 
return 
((((BgL_sqlitez00_bglt)COBJECT(BgL_oz00_10))->BgL_z42builtinz42)=((void *)BgL_auxz00_2172),BUNSPEC);} } 

}



/* &%setup-sqlite! */
obj_t BGl_z62z52setupzd2sqlitez12zf0zz__sqlite_sqlitez00(obj_t BgL_envz00_1426, obj_t BgL_oz00_1427)
{
{ /* Llib/sqlite.scm 97 */
{ /* Llib/sqlite.scm 100 */
BgL_sqlitez00_bglt BgL_auxz00_2178;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1427, BGl_sqlitez00zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 100 */
BgL_auxz00_2178 = 
((BgL_sqlitez00_bglt)BgL_oz00_1427)
; }  else 
{ 
obj_t BgL_auxz00_2182;
BgL_auxz00_2182 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)4214)), BGl_string2128z00zz__sqlite_sqlitez00, BGl_string2129z00zz__sqlite_sqlitez00, BgL_oz00_1427); 
FAILURE(BgL_auxz00_2182,BFALSE,BFALSE);} 
return 
BGl_z52setupzd2sqlitez12z92zz__sqlite_sqlitez00(BgL_auxz00_2178);} } 

}



/* %setup-sqltiny! */
BGL_EXPORTED_DEF obj_t BGl_z52setupzd2sqltinyz12z92zz__sqlite_sqlitez00(BgL_sqltinyz00_bglt BgL_oz00_11)
{
{ /* Llib/sqlite.scm 109 */
{ 
BgL_z42sqltinyz42_bglt BgL_auxz00_2187;
{ /* Llib/sqlite.scm 111 */
obj_t BgL_arg1277z00_1011;obj_t BgL_arg1279z00_1012;
BgL_arg1277z00_1011 = 
(((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_11)))->BgL_pathz00); 
BgL_arg1279z00_1012 = 
(((BgL_sqltinyz00_bglt)COBJECT(BgL_oz00_11))->BgL_syncz00); 
BgL_auxz00_2187 = 
BGl_z42sqltinyzd2openz90zz__sqlite_sqltinyz00(BgL_arg1277z00_1011, BgL_arg1279z00_1012); } 
return 
((((BgL_sqltinyz00_bglt)COBJECT(BgL_oz00_11))->BgL_z42builtinz42)=((BgL_z42sqltinyz42_bglt)BgL_auxz00_2187),BUNSPEC);} } 

}



/* &%setup-sqltiny! */
obj_t BGl_z62z52setupzd2sqltinyz12zf0zz__sqlite_sqlitez00(obj_t BgL_envz00_1428, obj_t BgL_oz00_1429)
{
{ /* Llib/sqlite.scm 109 */
{ /* Llib/sqlite.scm 110 */
BgL_sqltinyz00_bglt BgL_auxz00_2193;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1429, BGl_sqltinyz00zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 110 */
BgL_auxz00_2193 = 
((BgL_sqltinyz00_bglt)BgL_oz00_1429)
; }  else 
{ 
obj_t BgL_auxz00_2197;
BgL_auxz00_2197 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)4669)), BGl_string2130z00zz__sqlite_sqlitez00, BGl_string2131z00zz__sqlite_sqlitez00, BgL_oz00_1429); 
FAILURE(BgL_auxz00_2197,BFALSE,BFALSE);} 
return 
BGl_z52setupzd2sqltinyz12z92zz__sqlite_sqlitez00(BgL_auxz00_2193);} } 

}



/* sqlite-table-informations */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2tablezd2informationsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_36, obj_t BgL_namez00_37)
{
{ /* Llib/sqlite.scm 210 */
{ /* Llib/sqlite.scm 212 */
obj_t BgL_arg1281z00_1013;
{ /* Llib/sqlite.scm 213 */
obj_t BgL_list1284z00_1014;
BgL_list1284z00_1014 = 
MAKE_YOUNG_PAIR(BgL_namez00_37, BNIL); 
BgL_arg1281z00_1013 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2132z00zz__sqlite_sqlitez00, BgL_list1284z00_1014); } 
return 
BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_dbz00_36, BGl_proc2133z00zz__sqlite_sqlitez00, BgL_arg1281z00_1013, BNIL);} } 

}



/* &sqlite-table-informations */
obj_t BGl_z62sqlitezd2tablezd2informationsz62zz__sqlite_sqlitez00(obj_t BgL_envz00_1431, obj_t BgL_dbz00_1432, obj_t BgL_namez00_1433)
{
{ /* Llib/sqlite.scm 210 */
{ /* Llib/sqlite.scm 212 */
obj_t BgL_auxz00_2213;BgL_z52sqlitez52_bglt BgL_auxz00_2205;
if(
STRINGP(BgL_namez00_1433))
{ /* Llib/sqlite.scm 212 */
BgL_auxz00_2213 = BgL_namez00_1433
; }  else 
{ 
obj_t BgL_auxz00_2216;
BgL_auxz00_2216 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)8786)), BGl_string2134z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_namez00_1433); 
FAILURE(BgL_auxz00_2216,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1432, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 212 */
BgL_auxz00_2205 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1432)
; }  else 
{ 
obj_t BgL_auxz00_2209;
BgL_auxz00_2209 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)8786)), BGl_string2134z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1432); 
FAILURE(BgL_auxz00_2209,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2tablezd2informationsz00zz__sqlite_sqlitez00(BgL_auxz00_2205, BgL_auxz00_2213);} } 

}



/* &<@anonymous:1283> */
obj_t BGl_z62zc3z04anonymousza31283ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1434, obj_t BgL_xz00_1435, obj_t BgL_yz00_1436)
{
{ /* Llib/sqlite.scm 212 */
return BgL_yz00_1436;} 

}



/* sqlite-table-number-of-rows */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2tablezd2numberzd2ofzd2rowsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_38, obj_t BgL_namez00_39)
{
{ /* Llib/sqlite.scm 218 */
{ /* Llib/sqlite.scm 220 */
obj_t BgL_arg1319z00_76;
{ /* Llib/sqlite.scm 221 */
obj_t BgL_list1322z00_80;
BgL_list1322z00_80 = 
MAKE_YOUNG_PAIR(BgL_namez00_39, BNIL); 
BgL_arg1319z00_76 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2137z00zz__sqlite_sqlitez00, BgL_list1322z00_80); } 
return 
BGl_sqlitezd2evalzd2zz__sqlite_sqlitez00(BgL_dbz00_38, BGl_proc2138z00zz__sqlite_sqlitez00, BgL_arg1319z00_76, BNIL);} } 

}



/* &sqlite-table-number-of-rows */
obj_t BGl_z62sqlitezd2tablezd2numberzd2ofzd2rowsz62zz__sqlite_sqlitez00(obj_t BgL_envz00_1438, obj_t BgL_dbz00_1439, obj_t BgL_namez00_1440)
{
{ /* Llib/sqlite.scm 218 */
{ /* Llib/sqlite.scm 220 */
obj_t BgL_auxz00_2232;BgL_z52sqlitez52_bglt BgL_auxz00_2224;
if(
STRINGP(BgL_namez00_1440))
{ /* Llib/sqlite.scm 220 */
BgL_auxz00_2232 = BgL_namez00_1440
; }  else 
{ 
obj_t BgL_auxz00_2235;
BgL_auxz00_2235 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)9143)), BGl_string2139z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_namez00_1440); 
FAILURE(BgL_auxz00_2235,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1439, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 220 */
BgL_auxz00_2224 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1439)
; }  else 
{ 
obj_t BgL_auxz00_2228;
BgL_auxz00_2228 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)9143)), BGl_string2139z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1439); 
FAILURE(BgL_auxz00_2228,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2tablezd2numberzd2ofzd2rowsz00zz__sqlite_sqlitez00(BgL_auxz00_2224, BgL_auxz00_2232);} } 

}



/* &<@anonymous:1321> */
obj_t BGl_z62zc3z04anonymousza31321ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1441, obj_t BgL_xz00_1442)
{
{ /* Llib/sqlite.scm 220 */
{ /* Llib/sqlite.scm 220 */
long BgL_tmpz00_2240;
{ /* Llib/sqlite.scm 220 */
char * BgL_tmpz00_2241;
BgL_tmpz00_2241 = 
BSTRING_TO_STRING(BgL_xz00_1442); 
BgL_tmpz00_2240 = 
BGL_STRTOL(BgL_tmpz00_2241, ((long)0), ((long)10)); } 
return 
BINT(BgL_tmpz00_2240);} } 

}



/* sqlite-table-name-of-columns */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2tablezd2namezd2ofzd2columnsz00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_40, obj_t BgL_namez00_41)
{
{ /* Llib/sqlite.scm 226 */
{ /* Llib/sqlite.scm 212 */
obj_t BgL_arg1281z00_1021;
{ /* Llib/sqlite.scm 213 */
obj_t BgL_list1284z00_1022;
BgL_list1284z00_1022 = 
MAKE_YOUNG_PAIR(BgL_namez00_41, BNIL); 
BgL_arg1281z00_1021 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2132z00zz__sqlite_sqlitez00, BgL_list1284z00_1022); } 
return 
BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_dbz00_40, BGl_proc2140z00zz__sqlite_sqlitez00, BgL_arg1281z00_1021, BNIL);} } 

}



/* &sqlite-table-name-of-columns */
obj_t BGl_z62sqlitezd2tablezd2namezd2ofzd2columnsz62zz__sqlite_sqlitez00(obj_t BgL_envz00_1444, obj_t BgL_dbz00_1445, obj_t BgL_namez00_1446)
{
{ /* Llib/sqlite.scm 226 */
{ /* Llib/sqlite.scm 227 */
obj_t BgL_auxz00_2256;BgL_z52sqlitez52_bglt BgL_auxz00_2248;
if(
STRINGP(BgL_namez00_1446))
{ /* Llib/sqlite.scm 227 */
BgL_auxz00_2256 = BgL_namez00_1446
; }  else 
{ 
obj_t BgL_auxz00_2259;
BgL_auxz00_2259 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)9499)), BGl_string2141z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_namez00_1446); 
FAILURE(BgL_auxz00_2259,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1445, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 227 */
BgL_auxz00_2248 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1445)
; }  else 
{ 
obj_t BgL_auxz00_2252;
BgL_auxz00_2252 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)9499)), BGl_string2141z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1445); 
FAILURE(BgL_auxz00_2252,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2tablezd2namezd2ofzd2columnsz00zz__sqlite_sqlitez00(BgL_auxz00_2248, BgL_auxz00_2256);} } 

}



/* &<@anonymous:1283>2068 */
obj_t BGl_z62zc3z04anonymousza31283ze32068ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1447, obj_t BgL_xz00_1448, obj_t BgL_yz00_1449)
{
{ /* Llib/sqlite.scm 212 */
return BgL_yz00_1449;} 

}



/* sqlite-name-of-tables */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2namezd2ofzd2tableszd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_42)
{
{ /* Llib/sqlite.scm 232 */
return 
BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_dbz00_42, BGl_proc2142z00zz__sqlite_sqlitez00, BGl_string2143z00zz__sqlite_sqlitez00, BNIL);} 

}



/* &sqlite-name-of-tables */
obj_t BGl_z62sqlitezd2namezd2ofzd2tableszb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1451, obj_t BgL_dbz00_1452)
{
{ /* Llib/sqlite.scm 232 */
{ /* Llib/sqlite.scm 234 */
BgL_z52sqlitez52_bglt BgL_auxz00_2265;
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1452, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 234 */
BgL_auxz00_2265 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1452)
; }  else 
{ 
obj_t BgL_auxz00_2269;
BgL_auxz00_2269 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)9818)), BGl_string2144z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1452); 
FAILURE(BgL_auxz00_2269,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2namezd2ofzd2tableszd2zz__sqlite_sqlitez00(BgL_auxz00_2265);} } 

}



/* &<@anonymous:1325> */
obj_t BGl_z62zc3z04anonymousza31325ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1453, obj_t BgL_xz00_1454)
{
{ /* Llib/sqlite.scm 234 */
return BgL_xz00_1454;} 

}



/* sqlite-dump */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2dumpzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_43, obj_t BgL_outz00_44)
{
{ /* Llib/sqlite.scm 240 */
{ /* Llib/sqlite.scm 241 */
obj_t BgL_g1219z00_87;
BgL_g1219z00_87 = 
BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_dbz00_43, BGl_proc2145z00zz__sqlite_sqlitez00, BGl_string2143z00zz__sqlite_sqlitez00, BNIL); 
{ 
obj_t BgL_l1217z00_89;
{ /* Llib/sqlite.scm 243 */
bool_t BgL_tmpz00_2275;
BgL_l1217z00_89 = BgL_g1219z00_87; 
BgL_zc3z04anonymousza31326ze3z87_90:
if(
PAIRP(BgL_l1217z00_89))
{ /* Llib/sqlite.scm 243 */
BGl_sqlitezd2dumpzd2tablez00zz__sqlite_sqlitez00(BgL_dbz00_43, 
CAR(BgL_l1217z00_89), BgL_outz00_44); 
{ 
obj_t BgL_l1217z00_2280;
BgL_l1217z00_2280 = 
CDR(BgL_l1217z00_89); 
BgL_l1217z00_89 = BgL_l1217z00_2280; 
goto BgL_zc3z04anonymousza31326ze3z87_90;} }  else 
{ /* Llib/sqlite.scm 243 */
BgL_tmpz00_2275 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_2275);} } } } 

}



/* &sqlite-dump */
obj_t BGl_z62sqlitezd2dumpzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1456, obj_t BgL_dbz00_1457, obj_t BgL_outz00_1458)
{
{ /* Llib/sqlite.scm 240 */
{ /* Llib/sqlite.scm 241 */
obj_t BgL_auxz00_2291;BgL_z52sqlitez52_bglt BgL_auxz00_2283;
if(
OUTPUT_PORTP(BgL_outz00_1458))
{ /* Llib/sqlite.scm 241 */
BgL_auxz00_2291 = BgL_outz00_1458
; }  else 
{ 
obj_t BgL_auxz00_2294;
BgL_auxz00_2294 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)10170)), BGl_string2146z00zz__sqlite_sqlitez00, BGl_string2147z00zz__sqlite_sqlitez00, BgL_outz00_1458); 
FAILURE(BgL_auxz00_2294,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1457, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 241 */
BgL_auxz00_2283 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1457)
; }  else 
{ 
obj_t BgL_auxz00_2287;
BgL_auxz00_2287 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)10170)), BGl_string2146z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1457); 
FAILURE(BgL_auxz00_2287,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2dumpzd2zz__sqlite_sqlitez00(BgL_auxz00_2283, BgL_auxz00_2291);} } 

}



/* &<@anonymous:1325>2069 */
obj_t BGl_z62zc3z04anonymousza31325ze32069ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1459, obj_t BgL_xz00_1460)
{
{ /* Llib/sqlite.scm 234 */
return BgL_xz00_1460;} 

}



/* sqlite-format */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(obj_t BgL_fmtz00_51, obj_t BgL_objsz00_52)
{
{ /* Llib/sqlite.scm 261 */
{ /* Llib/sqlite.scm 262 */
obj_t BgL_pz00_95;long BgL_lenz00_96;
{ /* Llib/sqlite.scm 262 */

{ /* Llib/sqlite.scm 262 */

BgL_pz00_95 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BgL_lenz00_96 = 
STRING_LENGTH(BgL_fmtz00_51); 
{ 
long BgL_iz00_98;obj_t BgL_osz00_99;
BgL_iz00_98 = ((long)0); 
BgL_osz00_99 = BgL_objsz00_52; 
BgL_zc3z04anonymousza31331ze3z87_100:
{ 
obj_t BgL_objz00_233;obj_t BgL_pz00_234;
if(
(BgL_iz00_98<BgL_lenz00_96))
{ /* Llib/sqlite.scm 377 */
unsigned char BgL_cz00_110;
BgL_cz00_110 = 
STRING_REF(BgL_fmtz00_51, BgL_iz00_98); 
if(
(BgL_cz00_110==((unsigned char)'~')))
{ /* Llib/sqlite.scm 378 */
if(
(BgL_iz00_98==
(BgL_lenz00_96-((long)1))))
{ /* Llib/sqlite.scm 382 */
obj_t BgL_arg1338z00_114;
BgL_arg1338z00_114 = 
c_substring(BgL_fmtz00_51, BgL_iz00_98, BgL_lenz00_96); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2150z00zz__sqlite_sqlitez00, BgL_arg1338z00_114);}  else 
{ /* Llib/sqlite.scm 383 */
unsigned char BgL_fz00_115;
BgL_fz00_115 = 
STRING_REF(BgL_fmtz00_51, 
(BgL_iz00_98+((long)1))); 
switch( BgL_fz00_115) { case ((unsigned char)'a') : 
case ((unsigned char)'A') : 

{ /* Llib/sqlite.scm 386 */
obj_t BgL_arg1341z00_119;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1341z00_119 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1341z00_119 = 
CAR(
((obj_t)BgL_osz00_99)); } 
bgl_display_obj(BgL_arg1341z00_119, BgL_pz00_95); } 
{ /* Llib/sqlite.scm 387 */
long BgL_arg1344z00_120;obj_t BgL_arg1345z00_121;
BgL_arg1344z00_120 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1345z00_121 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2326;long BgL_iz00_2325;
BgL_iz00_2325 = BgL_arg1344z00_120; 
BgL_osz00_2326 = BgL_arg1345z00_121; 
BgL_osz00_99 = BgL_osz00_2326; 
BgL_iz00_98 = BgL_iz00_2325; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'q') : 
case ((unsigned char)'Q') : 

{ /* Llib/sqlite.scm 389 */
obj_t BgL_arg1346z00_122;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1346z00_122 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1346z00_122 = 
CAR(
((obj_t)BgL_osz00_99)); } 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(BgL_arg1346z00_122, BgL_pz00_95, ((long)0)); } 
{ /* Llib/sqlite.scm 390 */
long BgL_arg1356z00_123;obj_t BgL_arg1357z00_124;
BgL_arg1356z00_123 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1357z00_124 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2339;long BgL_iz00_2338;
BgL_iz00_2338 = BgL_arg1356z00_123; 
BgL_osz00_2339 = BgL_arg1357z00_124; 
BgL_osz00_99 = BgL_osz00_2339; 
BgL_iz00_98 = BgL_iz00_2338; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'l') : 
case ((unsigned char)'L') : 

{ /* Llib/sqlite.scm 392 */
obj_t BgL_arg1358z00_125;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1358z00_125 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1358z00_125 = 
CAR(
((obj_t)BgL_osz00_99)); } 
BgL_objz00_233 = BgL_arg1358z00_125; 
BgL_pz00_234 = BgL_pz00_95; 
if(
NULLP(BgL_objz00_233))
{ /* Llib/sqlite.scm 340 */BUNSPEC; }  else 
{ /* Llib/sqlite.scm 340 */
if(
PAIRP(BgL_objz00_233))
{ /* Llib/sqlite.scm 342 */
if(
NULLP(
CDR(BgL_objz00_233)))
{ /* Llib/sqlite.scm 344 */
bgl_display_obj(
CAR(BgL_objz00_233), BgL_pz00_234); }  else 
{ 
obj_t BgL_oz00_242;
BgL_oz00_242 = BgL_objz00_233; 
BgL_zc3z04anonymousza31715ze3z87_243:
{ /* Llib/sqlite.scm 349 */
bool_t BgL_test2365z00_2356;
{ /* Llib/sqlite.scm 349 */
obj_t BgL_tmpz00_2357;
BgL_tmpz00_2357 = 
CDR(
((obj_t)BgL_oz00_242)); 
BgL_test2365z00_2356 = 
PAIRP(BgL_tmpz00_2357); } 
if(BgL_test2365z00_2356)
{ /* Llib/sqlite.scm 349 */
{ /* Llib/sqlite.scm 350 */
obj_t BgL_arg1718z00_246;
BgL_arg1718z00_246 = 
CAR(
((obj_t)BgL_oz00_242)); 
bgl_display_obj(BgL_arg1718z00_246, BgL_pz00_234); } 
bgl_display_string(BGl_string2148z00zz__sqlite_sqlitez00, BgL_pz00_234); 
{ /* Llib/sqlite.scm 352 */
obj_t BgL_arg1719z00_247;
BgL_arg1719z00_247 = 
CDR(
((obj_t)BgL_oz00_242)); 
{ 
obj_t BgL_oz00_2367;
BgL_oz00_2367 = BgL_arg1719z00_247; 
BgL_oz00_242 = BgL_oz00_2367; 
goto BgL_zc3z04anonymousza31715ze3z87_243;} } }  else 
{ /* Llib/sqlite.scm 349 */
if(
NULLP(
CDR(
((obj_t)BgL_oz00_242))))
{ /* Llib/sqlite.scm 354 */
obj_t BgL_arg1726z00_250;
BgL_arg1726z00_250 = 
CAR(
((obj_t)BgL_oz00_242)); 
bgl_display_obj(BgL_arg1726z00_250, BgL_pz00_234); }  else 
{ /* Llib/sqlite.scm 353 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2149z00zz__sqlite_sqlitez00, BgL_objz00_233); } } } } }  else 
{ /* Llib/sqlite.scm 342 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2149z00zz__sqlite_sqlitez00, BgL_objz00_233); } } } 
{ /* Llib/sqlite.scm 393 */
long BgL_arg1359z00_126;obj_t BgL_arg1360z00_127;
BgL_arg1359z00_126 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1360z00_127 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2383;long BgL_iz00_2382;
BgL_iz00_2382 = BgL_arg1359z00_126; 
BgL_osz00_2383 = BgL_arg1360z00_127; 
BgL_osz00_99 = BgL_osz00_2383; 
BgL_iz00_98 = BgL_iz00_2382; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'k') : 
case ((unsigned char)'K') : 

{ /* Llib/sqlite.scm 395 */
obj_t BgL_arg1361z00_128;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1361z00_128 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1361z00_128 = 
CAR(
((obj_t)BgL_osz00_99)); } 
BGl_displayzd2sqlitezd2quotezd2listze70z35zz__sqlite_sqlitez00(BgL_arg1361z00_128, BgL_pz00_95); } 
{ /* Llib/sqlite.scm 396 */
long BgL_arg1362z00_129;obj_t BgL_arg1389z00_130;
BgL_arg1362z00_129 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1389z00_130 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2396;long BgL_iz00_2395;
BgL_iz00_2395 = BgL_arg1362z00_129; 
BgL_osz00_2396 = BgL_arg1389z00_130; 
BgL_osz00_99 = BgL_osz00_2396; 
BgL_iz00_98 = BgL_iz00_2395; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'s') : 
case ((unsigned char)'S') : 

{ /* Llib/sqlite.scm 398 */
obj_t BgL_arg1390z00_131;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1390z00_131 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1390z00_131 = 
CAR(
((obj_t)BgL_osz00_99)); } 
{ /* Llib/sqlite.scm 398 */
obj_t BgL_list1391z00_132;
BgL_list1391z00_132 = 
MAKE_YOUNG_PAIR(BgL_pz00_95, BNIL); 
BGl_writez00zz__r4_output_6_10_3z00(BgL_arg1390z00_131, BgL_list1391z00_132); } } 
{ /* Llib/sqlite.scm 399 */
long BgL_arg1431z00_133;obj_t BgL_arg1506z00_134;
BgL_arg1431z00_133 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1506z00_134 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2410;long BgL_iz00_2409;
BgL_iz00_2409 = BgL_arg1431z00_133; 
BgL_osz00_2410 = BgL_arg1506z00_134; 
BgL_osz00_99 = BgL_osz00_2410; 
BgL_iz00_98 = BgL_iz00_2409; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'v') : 
case ((unsigned char)'V') : 

{ /* Llib/sqlite.scm 401 */
obj_t BgL_arg1507z00_135;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1507z00_135 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1507z00_135 = 
CAR(
((obj_t)BgL_osz00_99)); } 
bgl_display_obj(BgL_arg1507z00_135, BgL_pz00_95); } 
bgl_display_char(((unsigned char)10), BgL_pz00_95); 
{ /* Llib/sqlite.scm 403 */
long BgL_arg1512z00_136;obj_t BgL_arg1516z00_137;
BgL_arg1512z00_136 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1516z00_137 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2424;long BgL_iz00_2423;
BgL_iz00_2423 = BgL_arg1512z00_136; 
BgL_osz00_2424 = BgL_arg1516z00_137; 
BgL_osz00_99 = BgL_osz00_2424; 
BgL_iz00_98 = BgL_iz00_2423; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'c') : 
case ((unsigned char)'C') : 

{ /* Llib/sqlite.scm 405 */
obj_t BgL_oz00_138;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_oz00_138 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_oz00_138 = 
CAR(
((obj_t)BgL_osz00_99)); } 
if(
CHARP(BgL_oz00_138))
{ /* Llib/sqlite.scm 406 */
{ /* Llib/sqlite.scm 409 */
unsigned char BgL_tmpz00_2434;
BgL_tmpz00_2434 = 
CCHAR(BgL_oz00_138); 
bgl_display_char(BgL_tmpz00_2434, BgL_pz00_95); } 
{ /* Llib/sqlite.scm 410 */
long BgL_arg1524z00_140;obj_t BgL_arg1530z00_141;
BgL_arg1524z00_140 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1530z00_141 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2441;long BgL_iz00_2440;
BgL_iz00_2440 = BgL_arg1524z00_140; 
BgL_osz00_2441 = BgL_arg1530z00_141; 
BgL_osz00_99 = BgL_osz00_2441; 
BgL_iz00_98 = BgL_iz00_2440; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } }  else 
{ /* Llib/sqlite.scm 406 */
return 
BGl_errorz00zz__errorz00(BGl_sqlitezd2formatzd2envz00zz__sqlite_sqlitez00, BGl_string2152z00zz__sqlite_sqlitez00, BgL_oz00_138);} } break;case ((unsigned char)'x') : 
case ((unsigned char)'X') : 

{ /* Llib/sqlite.scm 412 */
obj_t BgL_arg1531z00_142;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1531z00_142 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1531z00_142 = 
CAR(
((obj_t)BgL_osz00_99)); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_arg1531z00_142))
{ /* Llib/sqlite.scm 271 */
bgl_display_obj(
BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(BgL_arg1531z00_142, 
BINT(((long)16))), BgL_pz00_95); }  else 
{ /* Llib/sqlite.scm 271 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2153z00zz__sqlite_sqlitez00, BgL_arg1531z00_142); } } 
{ /* Llib/sqlite.scm 413 */
long BgL_arg1538z00_143;obj_t BgL_arg1539z00_144;
BgL_arg1538z00_143 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1539z00_144 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2461;long BgL_iz00_2460;
BgL_iz00_2460 = BgL_arg1538z00_143; 
BgL_osz00_2461 = BgL_arg1539z00_144; 
BgL_osz00_99 = BgL_osz00_2461; 
BgL_iz00_98 = BgL_iz00_2460; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'o') : 
case ((unsigned char)'O') : 

{ /* Llib/sqlite.scm 415 */
obj_t BgL_arg1540z00_145;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1540z00_145 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1540z00_145 = 
CAR(
((obj_t)BgL_osz00_99)); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_arg1540z00_145))
{ /* Llib/sqlite.scm 271 */
bgl_display_obj(
BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(BgL_arg1540z00_145, 
BINT(((long)8))), BgL_pz00_95); }  else 
{ /* Llib/sqlite.scm 271 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2153z00zz__sqlite_sqlitez00, BgL_arg1540z00_145); } } 
{ /* Llib/sqlite.scm 416 */
long BgL_arg1543z00_146;obj_t BgL_arg1544z00_147;
BgL_arg1543z00_146 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1544z00_147 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2480;long BgL_iz00_2479;
BgL_iz00_2479 = BgL_arg1543z00_146; 
BgL_osz00_2480 = BgL_arg1544z00_147; 
BgL_osz00_99 = BgL_osz00_2480; 
BgL_iz00_98 = BgL_iz00_2479; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'b') : 
case ((unsigned char)'B') : 

{ /* Llib/sqlite.scm 418 */
obj_t BgL_arg1562z00_148;
if(
NULLP(BgL_osz00_99))
{ /* Llib/sqlite.scm 267 */
BgL_arg1562z00_148 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2151z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115)); }  else 
{ /* Llib/sqlite.scm 267 */
BgL_arg1562z00_148 = 
CAR(
((obj_t)BgL_osz00_99)); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_arg1562z00_148))
{ /* Llib/sqlite.scm 271 */
bgl_display_obj(
BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(BgL_arg1562z00_148, 
BINT(((long)2))), BgL_pz00_95); }  else 
{ /* Llib/sqlite.scm 271 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2153z00zz__sqlite_sqlitez00, BgL_arg1562z00_148); } } 
{ /* Llib/sqlite.scm 419 */
long BgL_arg1563z00_149;obj_t BgL_arg1564z00_150;
BgL_arg1563z00_149 = 
(BgL_iz00_98+((long)2)); 
BgL_arg1564z00_150 = 
CDR(
((obj_t)BgL_osz00_99)); 
{ 
obj_t BgL_osz00_2499;long BgL_iz00_2498;
BgL_iz00_2498 = BgL_arg1563z00_149; 
BgL_osz00_2499 = BgL_arg1564z00_150; 
BgL_osz00_99 = BgL_osz00_2499; 
BgL_iz00_98 = BgL_iz00_2498; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } break;case ((unsigned char)'%') : 
case ((unsigned char)'n') : 

bgl_display_char(((unsigned char)10), BgL_pz00_95); 
{ 
long BgL_iz00_2501;
BgL_iz00_2501 = 
(BgL_iz00_98+((long)2)); 
BgL_iz00_98 = BgL_iz00_2501; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} break;case ((unsigned char)'r') : 

bgl_display_char(((unsigned char)13), BgL_pz00_95); 
{ 
long BgL_iz00_2504;
BgL_iz00_2504 = 
(BgL_iz00_98+((long)2)); 
BgL_iz00_98 = BgL_iz00_2504; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} break;case ((unsigned char)'~') : 

bgl_display_char(((unsigned char)'~'), BgL_pz00_95); 
{ 
long BgL_iz00_2507;
BgL_iz00_2507 = 
(BgL_iz00_98+((long)2)); 
BgL_iz00_98 = BgL_iz00_2507; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} break;
default: 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2154z00zz__sqlite_sqlitez00, 
BCHAR(BgL_fz00_115));} } }  else 
{ /* Llib/sqlite.scm 378 */
bgl_display_char(BgL_cz00_110, BgL_pz00_95); 
{ 
long BgL_iz00_2514;
BgL_iz00_2514 = 
(BgL_iz00_98+((long)1)); 
BgL_iz00_98 = BgL_iz00_2514; 
goto BgL_zc3z04anonymousza31331ze3z87_100;} } }  else 
{ /* Llib/sqlite.scm 376 */
return 
bgl_close_output_port(BgL_pz00_95);} } } } } 

}



/* display-sqlite~0 */
obj_t BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(obj_t BgL_objz00_166, obj_t BgL_pz00_167, long BgL_lz00_168)
{
{ /* Llib/sqlite.scm 302 */
{ 
obj_t BgL_objz00_194;obj_t BgL_pz00_195;obj_t BgL_objz00_210;obj_t BgL_pz00_211;obj_t BgL_objz00_221;obj_t BgL_pz00_222;
if(
STRINGP(BgL_objz00_166))
{ /* Llib/sqlite.scm 276 */
if(
(BgL_lz00_168==((long)0)))
{ /* Llib/sqlite.scm 277 */
bgl_display_char(((unsigned char)'\''), BgL_pz00_167); }  else 
{ /* Llib/sqlite.scm 277 */
bgl_display_string(BGl_string2162z00zz__sqlite_sqlitez00, BgL_pz00_167); } 
{ /* Llib/sqlite.scm 280 */
long BgL_lenz00_172;
BgL_lenz00_172 = 
STRING_LENGTH(BgL_objz00_166); 
{ 
long BgL_iz00_174;
BgL_iz00_174 = ((long)0); 
BgL_zc3z04anonymousza31630ze3z87_175:
if(
(BgL_iz00_174==BgL_lenz00_172))
{ /* Llib/sqlite.scm 281 */((bool_t)0); }  else 
{ /* Llib/sqlite.scm 281 */
{ /* Llib/sqlite.scm 283 */
unsigned char BgL_cz00_177;
BgL_cz00_177 = 
STRING_REF(
((obj_t)BgL_objz00_166), BgL_iz00_174); 
bgl_display_char(BgL_cz00_177, BgL_pz00_167); 
if(
(((unsigned char)'\'')==BgL_cz00_177))
{ /* Llib/sqlite.scm 285 */
bgl_display_char(((unsigned char)'\''), BgL_pz00_167); }  else 
{ /* Llib/sqlite.scm 285 */BFALSE; } } 
{ 
long BgL_iz00_2532;
BgL_iz00_2532 = 
(BgL_iz00_174+((long)1)); 
BgL_iz00_174 = BgL_iz00_2532; 
goto BgL_zc3z04anonymousza31630ze3z87_175;} } } } 
if(
(BgL_lz00_168==((long)0)))
{ /* Llib/sqlite.scm 286 */
return 
bgl_display_char(((unsigned char)'\''), BgL_pz00_167);}  else 
{ /* Llib/sqlite.scm 286 */
return 
bgl_display_string(BGl_string2162z00zz__sqlite_sqlitez00, BgL_pz00_167);} }  else 
{ /* Llib/sqlite.scm 276 */
if(
BGL_DATEP(BgL_objz00_166))
{ /* Llib/sqlite.scm 290 */
long BgL_arg1643z00_183;
BgL_arg1643z00_183 = 
bgl_date_to_seconds(BgL_objz00_166); 
return 
bgl_display_obj(
make_belong(BgL_arg1643z00_183), BgL_pz00_167);}  else 
{ /* Llib/sqlite.scm 291 */
bool_t BgL_test2384z00_2543;
if(
ELONGP(BgL_objz00_166))
{ /* Llib/sqlite.scm 291 */
BgL_test2384z00_2543 = ((bool_t)1)
; }  else 
{ /* Llib/sqlite.scm 291 */
BgL_test2384z00_2543 = 
LLONGP(BgL_objz00_166)
; } 
if(BgL_test2384z00_2543)
{ /* Llib/sqlite.scm 292 */
obj_t BgL_list1647z00_186;
BgL_list1647z00_186 = 
MAKE_YOUNG_PAIR(BgL_pz00_167, BNIL); 
return 
BGl_writez00zz__r4_output_6_10_3z00(BgL_objz00_166, BgL_list1647z00_186);}  else 
{ /* Llib/sqlite.scm 293 */
bool_t BgL_test2386z00_2549;
if(
(BgL_objz00_166==BUNSPEC))
{ /* Llib/sqlite.scm 293 */
BgL_test2386z00_2549 = ((bool_t)1)
; }  else 
{ /* Llib/sqlite.scm 293 */
BgL_test2386z00_2549 = 
(BgL_objz00_166==BFALSE)
; } 
if(BgL_test2386z00_2549)
{ /* Llib/sqlite.scm 293 */
return 
bgl_display_string(BGl_string2163z00zz__sqlite_sqlitez00, BgL_pz00_167);}  else 
{ /* Llib/sqlite.scm 293 */
if(
PAIRP(BgL_objz00_166))
{ /* Llib/sqlite.scm 295 */
BgL_objz00_194 = BgL_objz00_166; 
BgL_pz00_195 = BgL_pz00_167; 
bgl_display_string(BGl_string2160z00zz__sqlite_sqlitez00, BgL_pz00_195); 
{ 
obj_t BgL_objz00_198;
BgL_objz00_198 = BgL_objz00_194; 
BgL_zc3z04anonymousza31655ze3z87_199:
{ /* Llib/sqlite.scm 306 */
obj_t BgL_arg1656z00_200;
BgL_arg1656z00_200 = 
CAR(
((obj_t)BgL_objz00_198)); 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(BgL_arg1656z00_200, BgL_pz00_195, ((long)1)); } 
if(
NULLP(
CDR(
((obj_t)BgL_objz00_198))))
{ /* Llib/sqlite.scm 308 */
return 
bgl_display_string(BGl_string2159z00zz__sqlite_sqlitez00, BgL_pz00_195);}  else 
{ /* Llib/sqlite.scm 310 */
bool_t BgL_test2390z00_2565;
{ /* Llib/sqlite.scm 310 */
obj_t BgL_tmpz00_2566;
BgL_tmpz00_2566 = 
CDR(
((obj_t)BgL_objz00_198)); 
BgL_test2390z00_2565 = 
PAIRP(BgL_tmpz00_2566); } 
if(BgL_test2390z00_2565)
{ /* Llib/sqlite.scm 310 */
bgl_display_string(BGl_string2157z00zz__sqlite_sqlitez00, BgL_pz00_195); 
{ /* Llib/sqlite.scm 316 */
obj_t BgL_arg1674z00_205;
BgL_arg1674z00_205 = 
CDR(
((obj_t)BgL_objz00_198)); 
{ 
obj_t BgL_objz00_2573;
BgL_objz00_2573 = BgL_arg1674z00_205; 
BgL_objz00_198 = BgL_objz00_2573; 
goto BgL_zc3z04anonymousza31655ze3z87_199;} } }  else 
{ /* Llib/sqlite.scm 310 */
bgl_display_string(BGl_string2161z00zz__sqlite_sqlitez00, BgL_pz00_195); 
{ /* Llib/sqlite.scm 312 */
obj_t BgL_arg1677z00_206;
BgL_arg1677z00_206 = 
CDR(
((obj_t)BgL_objz00_198)); 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(BgL_arg1677z00_206, BgL_pz00_195, ((long)1)); } 
return 
bgl_display_string(BGl_string2159z00zz__sqlite_sqlitez00, BgL_pz00_195);} } } }  else 
{ /* Llib/sqlite.scm 295 */
if(
VECTORP(BgL_objz00_166))
{ /* Llib/sqlite.scm 297 */
BgL_objz00_210 = BgL_objz00_166; 
BgL_pz00_211 = BgL_pz00_167; 
bgl_display_string(BGl_string2158z00zz__sqlite_sqlitez00, BgL_pz00_211); 
{ 
long BgL_iz00_215;
BgL_iz00_215 = ((long)0); 
BgL_zc3z04anonymousza31683ze3z87_216:
if(
(BgL_iz00_215==
VECTOR_LENGTH(BgL_objz00_210)))
{ /* Llib/sqlite.scm 321 */
return 
bgl_display_string(BGl_string2159z00zz__sqlite_sqlitez00, BgL_pz00_211);}  else 
{ /* Llib/sqlite.scm 321 */
bgl_display_string(BGl_string2157z00zz__sqlite_sqlitez00, BgL_pz00_211); 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(
VECTOR_REF(BgL_objz00_210,BgL_iz00_215), BgL_pz00_211, ((long)1)); 
{ 
long BgL_iz00_2589;
BgL_iz00_2589 = 
(BgL_iz00_215+((long)1)); 
BgL_iz00_215 = BgL_iz00_2589; 
goto BgL_zc3z04anonymousza31683ze3z87_216;} } } }  else 
{ /* Llib/sqlite.scm 297 */
if(
STRUCTP(BgL_objz00_166))
{ /* Llib/sqlite.scm 299 */
BgL_objz00_221 = BgL_objz00_166; 
BgL_pz00_222 = BgL_pz00_167; 
bgl_display_string(BGl_string2155z00zz__sqlite_sqlitez00, BgL_pz00_222); 
bgl_display_obj(
STRUCT_KEY(BgL_objz00_221), BgL_pz00_222); 
{ /* Llib/sqlite.scm 330 */
int BgL_lenz00_225;
BgL_lenz00_225 = 
STRUCT_LENGTH(BgL_objz00_221); 
{ 
long BgL_iz00_227;
BgL_iz00_227 = ((long)0); 
BgL_zc3z04anonymousza31700ze3z87_228:
if(
(BgL_iz00_227==
(long)(BgL_lenz00_225)))
{ /* Llib/sqlite.scm 332 */
return 
bgl_display_string(BGl_string2156z00zz__sqlite_sqlitez00, BgL_pz00_222);}  else 
{ /* Llib/sqlite.scm 332 */
bgl_display_string(BGl_string2157z00zz__sqlite_sqlitez00, BgL_pz00_222); 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(
STRUCT_REF(BgL_objz00_221, 
(int)(BgL_iz00_227)), BgL_pz00_222, ((long)1)); 
{ 
long BgL_iz00_2605;
BgL_iz00_2605 = 
(BgL_iz00_227+((long)1)); 
BgL_iz00_227 = BgL_iz00_2605; 
goto BgL_zc3z04anonymousza31700ze3z87_228;} } } } }  else 
{ /* Llib/sqlite.scm 299 */
return 
bgl_display_obj(BgL_objz00_166, BgL_pz00_167);} } } } } } } } } 

}



/* display-sqlite-quote-list~0 */
obj_t BGl_displayzd2sqlitezd2quotezd2listze70z35zz__sqlite_sqlitez00(obj_t BgL_objz00_255, obj_t BgL_pz00_256)
{
{ /* Llib/sqlite.scm 375 */
if(
PAIRP(BgL_objz00_255))
{ /* Llib/sqlite.scm 359 */
if(
NULLP(
CDR(BgL_objz00_255)))
{ /* Llib/sqlite.scm 363 */
return 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(
CAR(BgL_objz00_255), BgL_pz00_256, ((long)0));}  else 
{ 
obj_t BgL_oz00_264;
BgL_oz00_264 = BgL_objz00_255; 
BgL_zc3z04anonymousza31742ze3z87_265:
{ /* Llib/sqlite.scm 368 */
bool_t BgL_test2397z00_2615;
{ /* Llib/sqlite.scm 368 */
obj_t BgL_tmpz00_2616;
BgL_tmpz00_2616 = 
CDR(
((obj_t)BgL_oz00_264)); 
BgL_test2397z00_2615 = 
PAIRP(BgL_tmpz00_2616); } 
if(BgL_test2397z00_2615)
{ /* Llib/sqlite.scm 368 */
{ /* Llib/sqlite.scm 369 */
obj_t BgL_arg1760z00_268;
BgL_arg1760z00_268 = 
CAR(
((obj_t)BgL_oz00_264)); 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(BgL_arg1760z00_268, BgL_pz00_256, ((long)0)); } 
bgl_display_string(BGl_string2148z00zz__sqlite_sqlitez00, BgL_pz00_256); 
{ /* Llib/sqlite.scm 371 */
obj_t BgL_arg1763z00_269;
BgL_arg1763z00_269 = 
CDR(
((obj_t)BgL_oz00_264)); 
{ 
obj_t BgL_oz00_2626;
BgL_oz00_2626 = BgL_arg1763z00_269; 
BgL_oz00_264 = BgL_oz00_2626; 
goto BgL_zc3z04anonymousza31742ze3z87_265;} } }  else 
{ /* Llib/sqlite.scm 368 */
if(
NULLP(
CDR(
((obj_t)BgL_oz00_264))))
{ /* Llib/sqlite.scm 373 */
obj_t BgL_arg1775z00_272;
BgL_arg1775z00_272 = 
CAR(
((obj_t)BgL_oz00_264)); 
return 
BGl_displayzd2sqliteze70z35zz__sqlite_sqlitez00(BgL_arg1775z00_272, BgL_pz00_256, ((long)0));}  else 
{ /* Llib/sqlite.scm 372 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2149z00zz__sqlite_sqlitez00, BgL_objz00_255);} } } } }  else 
{ /* Llib/sqlite.scm 359 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2149z00zz__sqlite_sqlitez00, BgL_objz00_255);} } 

}



/* &sqlite-format */
obj_t BGl_z62sqlitezd2formatzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1461, obj_t BgL_fmtz00_1462, obj_t BgL_objsz00_1463)
{
{ /* Llib/sqlite.scm 261 */
{ /* Llib/sqlite.scm 262 */
obj_t BgL_auxz00_2638;
if(
STRINGP(BgL_fmtz00_1462))
{ /* Llib/sqlite.scm 262 */
BgL_auxz00_2638 = BgL_fmtz00_1462
; }  else 
{ 
obj_t BgL_auxz00_2641;
BgL_auxz00_2641 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)11102)), BGl_string2164z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_fmtz00_1462); 
FAILURE(BgL_auxz00_2641,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_auxz00_2638, BgL_objsz00_1463);} } 

}



/* sqlite-last-insert-rowid */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2lastzd2insertzd2rowidzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_53)
{
{ /* Llib/sqlite.scm 439 */
return 
BGl_sqlitezd2execzd2zz__sqlite_sqlitez00(BgL_dbz00_53, BGl_string2165z00zz__sqlite_sqlitez00, BNIL);} 

}



/* &sqlite-last-insert-rowid */
obj_t BGl_z62sqlitezd2lastzd2insertzd2rowidzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1464, obj_t BgL_dbz00_1465)
{
{ /* Llib/sqlite.scm 439 */
{ /* Llib/sqlite.scm 440 */
BgL_z52sqlitez52_bglt BgL_auxz00_2647;
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1465, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 440 */
BgL_auxz00_2647 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1465)
; }  else 
{ 
obj_t BgL_auxz00_2651;
BgL_auxz00_2651 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)16207)), BGl_string2166z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1465); 
FAILURE(BgL_auxz00_2651,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2lastzd2insertzd2rowidzd2zz__sqlite_sqlitez00(BgL_auxz00_2647);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
{ /* Llib/sqlite.scm 34 */
obj_t BgL_arg1782z00_290;obj_t BgL_arg1783z00_291;
{ /* Llib/sqlite.scm 34 */
obj_t BgL_v1220z00_297;
BgL_v1220z00_297 = 
create_vector(((long)1)); 
{ /* Llib/sqlite.scm 34 */
obj_t BgL_arg1787z00_298;
BgL_arg1787z00_298 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)2)), BGl_proc2169z00zz__sqlite_sqlitez00, BGl_proc2168z00zz__sqlite_sqlitez00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2167z00zz__sqlite_sqlitez00, 
CNST_TABLE_REF(((long)3))); 
VECTOR_SET(BgL_v1220z00_297,((long)0),BgL_arg1787z00_298); } 
BgL_arg1782z00_290 = BgL_v1220z00_297; } 
{ /* Llib/sqlite.scm 34 */
obj_t BgL_v1221z00_311;
BgL_v1221z00_311 = 
create_vector(((long)0)); 
BgL_arg1783z00_291 = BgL_v1221z00_311; } 
BGl_z52sqlitez52zz__sqlite_sqlitez00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)4)), 
CNST_TABLE_REF(((long)5)), BGl_objectz00zz__objectz00, ((long)41441), BFALSE, BGl_proc2171z00zz__sqlite_sqlitez00, BFALSE, BGl_proc2170z00zz__sqlite_sqlitez00, BFALSE, BgL_arg1782z00_290, BgL_arg1783z00_291); } 
{ /* Llib/sqlite.scm 37 */
obj_t BgL_arg1797z00_317;obj_t BgL_arg1798z00_318;
{ /* Llib/sqlite.scm 37 */
obj_t BgL_v1222z00_332;
BgL_v1222z00_332 = 
create_vector(((long)2)); 
{ /* Llib/sqlite.scm 37 */
obj_t BgL_arg1805z00_333;
BgL_arg1805z00_333 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)6)), BGl_proc2174z00zz__sqlite_sqlitez00, BGl_proc2173z00zz__sqlite_sqlitez00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2172z00zz__sqlite_sqlitez00, 
CNST_TABLE_REF(((long)7))); 
VECTOR_SET(BgL_v1222z00_332,((long)0),BgL_arg1805z00_333); } 
{ /* Llib/sqlite.scm 37 */
obj_t BgL_arg1813z00_346;
BgL_arg1813z00_346 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc2177z00zz__sqlite_sqlitez00, BGl_proc2176z00zz__sqlite_sqlitez00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2175z00zz__sqlite_sqlitez00, BGl_z42sqltinyz42zz__sqlite_sqltinyz00); 
VECTOR_SET(BgL_v1222z00_332,((long)1),BgL_arg1813z00_346); } 
BgL_arg1797z00_317 = BgL_v1222z00_332; } 
{ /* Llib/sqlite.scm 37 */
obj_t BgL_v1223z00_359;
BgL_v1223z00_359 = 
create_vector(((long)0)); 
BgL_arg1798z00_318 = BgL_v1223z00_359; } 
BGl_sqltinyz00zz__sqlite_sqlitez00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)9)), 
CNST_TABLE_REF(((long)5)), BGl_z52sqlitez52zz__sqlite_sqlitez00, ((long)6234), BGl_proc2180z00zz__sqlite_sqlitez00, BGl_proc2179z00zz__sqlite_sqlitez00, BGl_z52setupzd2sqltinyz12zd2envz40zz__sqlite_sqlitez00, BGl_proc2178z00zz__sqlite_sqlitez00, BFALSE, BgL_arg1797z00_317, BgL_arg1798z00_318); } 
{ /* Llib/sqlite.scm 25 */
obj_t BgL_arg1823z00_366;obj_t BgL_arg1824z00_367;
{ /* Llib/sqlite.scm 25 */
obj_t BgL_v1224z00_380;
BgL_v1224z00_380 = 
create_vector(((long)1)); 
{ /* Llib/sqlite.scm 25 */
obj_t BgL_arg1831z00_381;
BgL_arg1831z00_381 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc2183z00zz__sqlite_sqlitez00, BGl_proc2182z00zz__sqlite_sqlitez00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2181z00zz__sqlite_sqlitez00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1224z00_380,((long)0),BgL_arg1831z00_381); } 
BgL_arg1823z00_366 = BgL_v1224z00_380; } 
{ /* Llib/sqlite.scm 25 */
obj_t BgL_v1225z00_394;
BgL_v1225z00_394 = 
create_vector(((long)0)); 
BgL_arg1824z00_367 = BgL_v1225z00_394; } 
return ( 
BGl_sqlitez00zz__sqlite_sqlitez00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)5)), BGl_z52sqlitez52zz__sqlite_sqlitez00, ((long)51526), BGl_proc2186z00zz__sqlite_sqlitez00, BGl_proc2185z00zz__sqlite_sqlitez00, BGl_z52setupzd2sqlitez12zd2envz40zz__sqlite_sqlitez00, BGl_proc2184z00zz__sqlite_sqlitez00, BFALSE, BgL_arg1823z00_366, BgL_arg1824z00_367), BUNSPEC) ;} } 

}



/* &<@anonymous:1830> */
obj_t BGl_z62zc3z04anonymousza31830ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1486, obj_t BgL_new1063z00_1487)
{
{ /* Llib/sqlite.scm 25 */
{ 
BgL_sqlitez00_bglt BgL_auxz00_2686;
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)
((BgL_sqlitez00_bglt)BgL_new1063z00_1487))))->BgL_pathz00)=((obj_t)BGl_string2187z00zz__sqlite_sqlitez00),BUNSPEC); 
((((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_new1063z00_1487)))->BgL_z42builtinz42)=((void *)
0L),BUNSPEC); 
BgL_auxz00_2686 = 
((BgL_sqlitez00_bglt)BgL_new1063z00_1487); 
return 
((obj_t)BgL_auxz00_2686);} } 

}



/* &lambda1828 */
BgL_sqlitez00_bglt BGl_z62lambda1828z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1488)
{
{ /* Llib/sqlite.scm 25 */
{ /* Llib/sqlite.scm 25 */
BgL_sqlitez00_bglt BgL_new1062z00_1958;
BgL_new1062z00_1958 = 
((BgL_sqlitez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sqlitez00_bgl) ))); 
{ /* Llib/sqlite.scm 25 */
long BgL_arg1829z00_1959;
BgL_arg1829z00_1959 = 
BGL_CLASS_INDEX(BGl_sqlitez00zz__sqlite_sqlitez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1062z00_1958), BgL_arg1829z00_1959); } 
return BgL_new1062z00_1958;} } 

}



/* &lambda1825 */
BgL_sqlitez00_bglt BGl_z62lambda1825z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1489, obj_t BgL_path1060z00_1490, obj_t BgL_z42builtin1061z42_1491)
{
{ /* Llib/sqlite.scm 25 */
{ /* Llib/sqlite.scm 25 */
void * BgL_z42builtin1061z42_1961;
BgL_z42builtin1061z42_1961 = 
FOREIGN_TO_COBJ(BgL_z42builtin1061z42_1491); 
{ /* Llib/sqlite.scm 25 */
BgL_sqlitez00_bglt BgL_new1216z00_1962;
{ /* Llib/sqlite.scm 25 */
BgL_sqlitez00_bglt BgL_new1215z00_1963;
BgL_new1215z00_1963 = 
((BgL_sqlitez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sqlitez00_bgl) ))); 
{ /* Llib/sqlite.scm 25 */
long BgL_arg1827z00_1964;
BgL_arg1827z00_1964 = 
BGL_CLASS_INDEX(BGl_sqlitez00zz__sqlite_sqlitez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_1963), BgL_arg1827z00_1964); } 
BgL_new1216z00_1962 = BgL_new1215z00_1963; } 
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_new1216z00_1962)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_path1060z00_1490)),BUNSPEC); 
((((BgL_sqlitez00_bglt)COBJECT(BgL_new1216z00_1962))->BgL_z42builtinz42)=((void *)BgL_z42builtin1061z42_1961),BUNSPEC); 
{ /* Llib/sqlite.scm 25 */
obj_t BgL_fun1826z00_1965;
BgL_fun1826z00_1965 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sqlitez00zz__sqlite_sqlitez00); 
PROCEDURE_ENTRY(BgL_fun1826z00_1965)(BgL_fun1826z00_1965, 
((obj_t)BgL_new1216z00_1962), BEOA); } 
return BgL_new1216z00_1962;} } } 

}



/* &<@anonymous:1837> */
obj_t BGl_z62zc3z04anonymousza31837ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1492)
{
{ /* Llib/sqlite.scm 25 */
return 
void_star_to_obj(
(0L));} 

}



/* &lambda1836 */
obj_t BGl_z62lambda1836z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1493, obj_t BgL_oz00_1494, obj_t BgL_vz00_1495)
{
{ /* Llib/sqlite.scm 25 */
{ /* Llib/sqlite.scm 25 */
void * BgL_vz00_1967;
BgL_vz00_1967 = 
FOREIGN_TO_COBJ(BgL_vz00_1495); 
return 
((((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1494)))->BgL_z42builtinz42)=((void *)BgL_vz00_1967),BUNSPEC);} } 

}



/* &lambda1835 */
obj_t BGl_z62lambda1835z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1496, obj_t BgL_oz00_1497)
{
{ /* Llib/sqlite.scm 25 */
return 
void_star_to_obj(
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1497)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1804> */
obj_t BGl_z62zc3z04anonymousza31804ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1498, obj_t BgL_new1058z00_1499)
{
{ /* Llib/sqlite.scm 37 */
{ 
BgL_sqltinyz00_bglt BgL_auxz00_2722;
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)
((BgL_sqltinyz00_bglt)BgL_new1058z00_1499))))->BgL_pathz00)=((obj_t)BGl_string2187z00zz__sqlite_sqlitez00),BUNSPEC); 
((((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_new1058z00_1499)))->BgL_syncz00)=((obj_t)
CNST_TABLE_REF(((long)12))),BUNSPEC); 
{ 
BgL_z42sqltinyz42_bglt BgL_auxz00_2729;
{ /* Llib/sqlite.scm 37 */
obj_t BgL_classz00_1970;
BgL_classz00_1970 = BGl_z42sqltinyz42zz__sqlite_sqltinyz00; 
{ /* Llib/sqlite.scm 37 */
obj_t BgL__ortest_1111z00_1971;
BgL__ortest_1111z00_1971 = 
BGL_CLASS_NIL(BgL_classz00_1970); 
if(
CBOOL(BgL__ortest_1111z00_1971))
{ /* Llib/sqlite.scm 37 */
BgL_auxz00_2729 = 
((BgL_z42sqltinyz42_bglt)BgL__ortest_1111z00_1971)
; }  else 
{ /* Llib/sqlite.scm 37 */
BgL_auxz00_2729 = 
((BgL_z42sqltinyz42_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1970))
; } } } 
((((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_new1058z00_1499)))->BgL_z42builtinz42)=((BgL_z42sqltinyz42_bglt)BgL_auxz00_2729),BUNSPEC); } 
BgL_auxz00_2722 = 
((BgL_sqltinyz00_bglt)BgL_new1058z00_1499); 
return 
((obj_t)BgL_auxz00_2722);} } 

}



/* &lambda1802 */
BgL_sqltinyz00_bglt BGl_z62lambda1802z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1500)
{
{ /* Llib/sqlite.scm 37 */
{ /* Llib/sqlite.scm 37 */
BgL_sqltinyz00_bglt BgL_new1057z00_1972;
BgL_new1057z00_1972 = 
((BgL_sqltinyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sqltinyz00_bgl) ))); 
{ /* Llib/sqlite.scm 37 */
long BgL_arg1803z00_1973;
BgL_arg1803z00_1973 = 
BGL_CLASS_INDEX(BGl_sqltinyz00zz__sqlite_sqlitez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1057z00_1972), BgL_arg1803z00_1973); } 
return BgL_new1057z00_1972;} } 

}



/* &lambda1799 */
BgL_sqltinyz00_bglt BGl_z62lambda1799z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1501, obj_t BgL_path1054z00_1502, obj_t BgL_sync1055z00_1503, obj_t BgL_z42builtin1056z42_1504)
{
{ /* Llib/sqlite.scm 37 */
{ /* Llib/sqlite.scm 37 */
BgL_sqltinyz00_bglt BgL_new1214z00_1977;
{ /* Llib/sqlite.scm 37 */
BgL_sqltinyz00_bglt BgL_new1213z00_1978;
BgL_new1213z00_1978 = 
((BgL_sqltinyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_sqltinyz00_bgl) ))); 
{ /* Llib/sqlite.scm 37 */
long BgL_arg1801z00_1979;
BgL_arg1801z00_1979 = 
BGL_CLASS_INDEX(BGl_sqltinyz00zz__sqlite_sqlitez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_1978), BgL_arg1801z00_1979); } 
BgL_new1214z00_1977 = BgL_new1213z00_1978; } 
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_new1214z00_1977)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_path1054z00_1502)),BUNSPEC); 
((((BgL_sqltinyz00_bglt)COBJECT(BgL_new1214z00_1977))->BgL_syncz00)=((obj_t)
((obj_t)BgL_sync1055z00_1503)),BUNSPEC); 
((((BgL_sqltinyz00_bglt)COBJECT(BgL_new1214z00_1977))->BgL_z42builtinz42)=((BgL_z42sqltinyz42_bglt)
((BgL_z42sqltinyz42_bglt)BgL_z42builtin1056z42_1504)),BUNSPEC); 
{ /* Llib/sqlite.scm 37 */
obj_t BgL_fun1800z00_1980;
BgL_fun1800z00_1980 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_sqltinyz00zz__sqlite_sqlitez00); 
PROCEDURE_ENTRY(BgL_fun1800z00_1980)(BgL_fun1800z00_1980, 
((obj_t)BgL_new1214z00_1977), BEOA); } 
return BgL_new1214z00_1977;} } 

}



/* &<@anonymous:1819> */
obj_t BGl_z62zc3z04anonymousza31819ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1505)
{
{ /* Llib/sqlite.scm 37 */
{ /* Llib/sqlite.scm 40 */
obj_t BgL_classz00_1981;
BgL_classz00_1981 = BGl_z42sqltinyz42zz__sqlite_sqltinyz00; 
{ /* Llib/sqlite.scm 40 */
obj_t BgL__ortest_1111z00_1982;
BgL__ortest_1111z00_1982 = 
BGL_CLASS_NIL(BgL_classz00_1981); 
if(
CBOOL(BgL__ortest_1111z00_1982))
{ /* Llib/sqlite.scm 40 */
return BgL__ortest_1111z00_1982;}  else 
{ /* Llib/sqlite.scm 40 */
return 
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1981);} } } } 

}



/* &lambda1818 */
obj_t BGl_z62lambda1818z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1506, obj_t BgL_oz00_1507, obj_t BgL_vz00_1508)
{
{ /* Llib/sqlite.scm 37 */
return 
((((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_oz00_1507)))->BgL_z42builtinz42)=((BgL_z42sqltinyz42_bglt)
((BgL_z42sqltinyz42_bglt)BgL_vz00_1508)),BUNSPEC);} 

}



/* &lambda1817 */
BgL_z42sqltinyz42_bglt BGl_z62lambda1817z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1509, obj_t BgL_oz00_1510)
{
{ /* Llib/sqlite.scm 37 */
return 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_oz00_1510)))->BgL_z42builtinz42);} 

}



/* &<@anonymous:1812> */
obj_t BGl_z62zc3z04anonymousza31812ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1511)
{
{ /* Llib/sqlite.scm 37 */
return 
CNST_TABLE_REF(((long)13));} 

}



/* &lambda1811 */
obj_t BGl_z62lambda1811z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1512, obj_t BgL_oz00_1513, obj_t BgL_vz00_1514)
{
{ /* Llib/sqlite.scm 37 */
return 
((((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_oz00_1513)))->BgL_syncz00)=((obj_t)
((obj_t)BgL_vz00_1514)),BUNSPEC);} 

}



/* &lambda1810 */
obj_t BGl_z62lambda1810z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1515, obj_t BgL_oz00_1516)
{
{ /* Llib/sqlite.scm 37 */
return 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)BgL_oz00_1516)))->BgL_syncz00);} 

}



/* &<@anonymous:1786> */
obj_t BGl_z62zc3z04anonymousza31786ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1517, obj_t BgL_new1052z00_1518)
{
{ /* Llib/sqlite.scm 34 */
{ 
BgL_z52sqlitez52_bglt BgL_auxz00_2776;
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_new1052z00_1518)))->BgL_pathz00)=((obj_t)BGl_string2187z00zz__sqlite_sqlitez00),BUNSPEC); 
BgL_auxz00_2776 = 
((BgL_z52sqlitez52_bglt)BgL_new1052z00_1518); 
return 
((obj_t)BgL_auxz00_2776);} } 

}



/* &lambda1784 */
BgL_z52sqlitez52_bglt BGl_z62lambda1784z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1519)
{
{ /* Llib/sqlite.scm 34 */
{ /* Llib/sqlite.scm 34 */
BgL_z52sqlitez52_bglt BgL_new1051z00_1990;
BgL_new1051z00_1990 = 
((BgL_z52sqlitez52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sqlitez52_bgl) ))); 
{ /* Llib/sqlite.scm 34 */
long BgL_arg1785z00_1991;
BgL_arg1785z00_1991 = 
BGL_CLASS_INDEX(BGl_z52sqlitez52zz__sqlite_sqlitez00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_1990), BgL_arg1785z00_1991); } 
return BgL_new1051z00_1990;} } 

}



/* &<@anonymous:1793> */
obj_t BGl_z62zc3z04anonymousza31793ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1520)
{
{ /* Llib/sqlite.scm 34 */
return BGl_string2188z00zz__sqlite_sqlitez00;} 

}



/* &lambda1792 */
obj_t BGl_z62lambda1792z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1521, obj_t BgL_oz00_1522, obj_t BgL_vz00_1523)
{
{ /* Llib/sqlite.scm 34 */
return 
((((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_1522)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_vz00_1523)),BUNSPEC);} 

}



/* &lambda1791 */
obj_t BGl_z62lambda1791z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1524, obj_t BgL_oz00_1525)
{
{ /* Llib/sqlite.scm 34 */
return 
(((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_1525)))->BgL_pathz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sqlitezd2closezd2envz00zz__sqlite_sqlitez00, BGl_proc2189z00zz__sqlite_sqlitez00, BGl_z52sqlitez52zz__sqlite_sqlitez00, BGl_string2190z00zz__sqlite_sqlitez00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sqlitezd2execzd2envz00zz__sqlite_sqlitez00, BGl_proc2191z00zz__sqlite_sqlitez00, BGl_z52sqlitez52zz__sqlite_sqlitez00, BGl_string2192z00zz__sqlite_sqlitez00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sqlitezd2evalzd2envz00zz__sqlite_sqlitez00, BGl_proc2193z00zz__sqlite_sqlitez00, BGl_z52sqlitez52zz__sqlite_sqlitez00, BGl_string2194z00zz__sqlite_sqlitez00); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sqlitezd2mapzd2envz00zz__sqlite_sqlitez00, BGl_proc2195z00zz__sqlite_sqlitez00, BGl_z52sqlitez52zz__sqlite_sqlitez00, BGl_string2196z00zz__sqlite_sqlitez00); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_sqlitezd2dumpzd2tablezd2envzd2zz__sqlite_sqlitez00, BGl_proc2197z00zz__sqlite_sqlitez00, BGl_z52sqlitez52zz__sqlite_sqlitez00, BGl_string2198z00zz__sqlite_sqlitez00);} 

}



/* &sqlite-dump-table1248 */
obj_t BGl_z62sqlitezd2dumpzd2table1248z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1531, obj_t BgL_dbz00_1532, obj_t BgL_tablez00_1533, obj_t BgL_outz00_1534)
{
{ /* Llib/sqlite.scm 248 */
{ /* Llib/sqlite.scm 250 */
BgL_z42sqltinyz42_bglt BgL_arg1866z00_1998;
BgL_arg1866z00_1998 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_dbz00_1532))))->BgL_z42builtinz42); 
BGl_z42sqltinyzd2dumpzd2tablez42zz__sqlite_sqltinyz00(
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_dbz00_1532)), BgL_arg1866z00_1998, 
((obj_t)BgL_tablez00_1533), 
((obj_t)BgL_outz00_1534)); } 
return BUNSPEC;} 

}



/* &sqlite-map1244 */
obj_t BGl_z62sqlitezd2map1244zb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1535, obj_t BgL_oz00_1536, obj_t BgL_pz00_1537, obj_t BgL_fmtz00_1538, obj_t BgL_argsz00_1539)
{
{ /* Llib/sqlite.scm 189 */
if(
NULLP(BgL_argsz00_1539))
{ /* Llib/sqlite.scm 192 */
BgL_z42sqltinyz42_bglt BgL_arg1858z00_2002;
BgL_arg1858z00_2002 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1536))))->BgL_z42builtinz42); 
return 
BGl_z42sqltinyzd2mapz90zz__sqlite_sqltinyz00(BgL_arg1858z00_2002, 
((obj_t)BgL_pz00_1537), 
((obj_t)BgL_fmtz00_1538), 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1536)));}  else 
{ /* Llib/sqlite.scm 193 */
BgL_z42sqltinyz42_bglt BgL_arg1859z00_2003;obj_t BgL_arg1861z00_2004;
BgL_arg1859z00_2003 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1536))))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 193 */
obj_t BgL_runner1864z00_2005;
{ /* Llib/sqlite.scm 193 */
obj_t BgL_list1862z00_2006;
BgL_list1862z00_2006 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1539, BNIL); 
BgL_runner1864z00_2005 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1538), BgL_list1862z00_2006); } 
{ /* Llib/sqlite.scm 193 */
obj_t BgL_aux1863z00_2007;
BgL_aux1863z00_2007 = 
CAR(BgL_runner1864z00_2005); 
BgL_runner1864z00_2005 = 
CDR(BgL_runner1864z00_2005); 
BgL_arg1861z00_2004 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1863z00_2007, BgL_runner1864z00_2005); } } 
return 
BGl_z42sqltinyzd2mapz90zz__sqlite_sqltinyz00(BgL_arg1859z00_2003, 
((obj_t)BgL_pz00_1537), BgL_arg1861z00_2004, 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1536)));} } 

}



/* &sqlite-eval1240 */
obj_t BGl_z62sqlitezd2eval1240zb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1540, obj_t BgL_oz00_1541, obj_t BgL_pz00_1542, obj_t BgL_fmtz00_1543, obj_t BgL_argsz00_1544)
{
{ /* Llib/sqlite.scm 168 */
if(
NULLP(BgL_argsz00_1544))
{ /* Llib/sqlite.scm 171 */
BgL_z42sqltinyz42_bglt BgL_arg1850z00_2011;
BgL_arg1850z00_2011 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1541))))->BgL_z42builtinz42); 
return 
BGl_z42sqltinyzd2evalz90zz__sqlite_sqltinyz00(BgL_arg1850z00_2011, 
((obj_t)BgL_pz00_1542), 
((obj_t)BgL_fmtz00_1543), 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1541)));}  else 
{ /* Llib/sqlite.scm 172 */
BgL_z42sqltinyz42_bglt BgL_arg1851z00_2012;obj_t BgL_arg1852z00_2013;
BgL_arg1851z00_2012 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1541))))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 172 */
obj_t BgL_runner1855z00_2014;
{ /* Llib/sqlite.scm 172 */
obj_t BgL_list1853z00_2015;
BgL_list1853z00_2015 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1544, BNIL); 
BgL_runner1855z00_2014 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1543), BgL_list1853z00_2015); } 
{ /* Llib/sqlite.scm 172 */
obj_t BgL_aux1854z00_2016;
BgL_aux1854z00_2016 = 
CAR(BgL_runner1855z00_2014); 
BgL_runner1855z00_2014 = 
CDR(BgL_runner1855z00_2014); 
BgL_arg1852z00_2013 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1854z00_2016, BgL_runner1855z00_2014); } } 
return 
BGl_z42sqltinyzd2evalz90zz__sqlite_sqltinyz00(BgL_arg1851z00_2012, 
((obj_t)BgL_pz00_1542), BgL_arg1852z00_2013, 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1541)));} } 

}



/* &sqlite-exec1236 */
obj_t BGl_z62sqlitezd2exec1236zb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1545, obj_t BgL_oz00_1546, obj_t BgL_fmtz00_1547, obj_t BgL_argsz00_1548)
{
{ /* Llib/sqlite.scm 130 */
if(
NULLP(BgL_argsz00_1548))
{ /* Llib/sqlite.scm 133 */
BgL_z42sqltinyz42_bglt BgL_arg1842z00_2019;
BgL_arg1842z00_2019 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1546))))->BgL_z42builtinz42); 
return 
BGl_z42sqltinyzd2execz90zz__sqlite_sqltinyz00(BgL_arg1842z00_2019, 
((obj_t)BgL_fmtz00_1547), 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1546)));}  else 
{ /* Llib/sqlite.scm 134 */
BgL_z42sqltinyz42_bglt BgL_arg1843z00_2020;obj_t BgL_arg1844z00_2021;
BgL_arg1843z00_2020 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1546))))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 134 */
obj_t BgL_runner1847z00_2022;
{ /* Llib/sqlite.scm 134 */
obj_t BgL_list1845z00_2023;
BgL_list1845z00_2023 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1548, BNIL); 
BgL_runner1847z00_2022 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1547), BgL_list1845z00_2023); } 
{ /* Llib/sqlite.scm 134 */
obj_t BgL_aux1846z00_2024;
BgL_aux1846z00_2024 = 
CAR(BgL_runner1847z00_2022); 
BgL_runner1847z00_2022 = 
CDR(BgL_runner1847z00_2022); 
BgL_arg1844z00_2021 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1846z00_2024, BgL_runner1847z00_2022); } } 
return 
BGl_z42sqltinyzd2execz90zz__sqlite_sqltinyz00(BgL_arg1843z00_2020, BgL_arg1844z00_2021, 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1546)));} } 

}



/* &sqlite-close1232 */
obj_t BGl_z62sqlitezd2close1232zb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1549, obj_t BgL_oz00_1550)
{
{ /* Llib/sqlite.scm 116 */
{ /* Llib/sqlite.scm 118 */
BgL_z42sqltinyz42_bglt BgL_arg1839z00_2026;
BgL_arg1839z00_2026 = 
(((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1550))))->BgL_z42builtinz42); 
BGl_z42sqltinyzd2closez90zz__sqlite_sqltinyz00(BgL_arg1839z00_2026, 
((obj_t)
((BgL_z52sqlitez52_bglt)BgL_oz00_1550))); } 
{ 
BgL_z42sqltinyz42_bglt BgL_auxz00_2876;
{ /* Llib/sqlite.scm 119 */
obj_t BgL_classz00_2027;
BgL_classz00_2027 = BGl_z42sqltinyz42zz__sqlite_sqltinyz00; 
{ /* Llib/sqlite.scm 119 */
obj_t BgL__ortest_1111z00_2028;
BgL__ortest_1111z00_2028 = 
BGL_CLASS_NIL(BgL_classz00_2027); 
if(
CBOOL(BgL__ortest_1111z00_2028))
{ /* Llib/sqlite.scm 119 */
BgL_auxz00_2876 = 
((BgL_z42sqltinyz42_bglt)BgL__ortest_1111z00_2028)
; }  else 
{ /* Llib/sqlite.scm 119 */
BgL_auxz00_2876 = 
((BgL_z42sqltinyz42_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2027))
; } } } 
return 
((((BgL_sqltinyz00_bglt)COBJECT(
((BgL_sqltinyz00_bglt)
((BgL_z52sqlitez52_bglt)BgL_oz00_1550))))->BgL_z42builtinz42)=((BgL_z42sqltinyz42_bglt)BgL_auxz00_2876),BUNSPEC);} } 

}



/* sqlite-close */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2closezd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_oz00_12)
{
{ /* Llib/sqlite.scm 116 */
{ /* Llib/sqlite.scm 116 */
obj_t BgL_method1233z00_456;
{ /* Llib/sqlite.scm 116 */
obj_t BgL_res2047z00_1271;
{ /* Llib/sqlite.scm 116 */
long BgL_objzd2classzd2numz00_1242;
BgL_objzd2classzd2numz00_1242 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_12)); 
{ /* Llib/sqlite.scm 116 */
obj_t BgL_arg1765z00_1243;
BgL_arg1765z00_1243 = 
PROCEDURE_REF(BGl_sqlitezd2closezd2envz00zz__sqlite_sqlitez00, 
(int)(((long)1))); 
{ /* Llib/sqlite.scm 116 */
int BgL_offsetz00_1246;
BgL_offsetz00_1246 = 
(int)(BgL_objzd2classzd2numz00_1242); 
{ /* Llib/sqlite.scm 116 */
long BgL_offsetz00_1247;
BgL_offsetz00_1247 = 
(
(long)(BgL_offsetz00_1246)-OBJECT_TYPE); 
{ /* Llib/sqlite.scm 116 */
long BgL_modz00_1248;
BgL_modz00_1248 = 
(BgL_offsetz00_1247 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/sqlite.scm 116 */
long BgL_restz00_1250;
BgL_restz00_1250 = 
(BgL_offsetz00_1247 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/sqlite.scm 116 */

{ /* Llib/sqlite.scm 116 */
obj_t BgL_bucketz00_1252;
BgL_bucketz00_1252 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1243),BgL_modz00_1248); 
BgL_res2047z00_1271 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1252),BgL_restz00_1250); } } } } } } } } 
BgL_method1233z00_456 = BgL_res2047z00_1271; } 
return 
PROCEDURE_ENTRY(BgL_method1233z00_456)(BgL_method1233z00_456, 
((obj_t)BgL_oz00_12), BEOA);} } 

}



/* &sqlite-close */
obj_t BGl_z62sqlitezd2closezb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1551, obj_t BgL_oz00_1552)
{
{ /* Llib/sqlite.scm 116 */
{ /* Llib/sqlite.scm 116 */
BgL_z52sqlitez52_bglt BgL_auxz00_2916;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1552, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 116 */
BgL_auxz00_2916 = 
((BgL_z52sqlitez52_bglt)BgL_oz00_1552)
; }  else 
{ 
obj_t BgL_auxz00_2920;
BgL_auxz00_2920 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)4987)), BGl_string2199z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_oz00_1552); 
FAILURE(BgL_auxz00_2920,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2closezd2zz__sqlite_sqlitez00(BgL_auxz00_2916);} } 

}



/* sqlite-exec */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2execzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_oz00_14, obj_t BgL_fmtz00_15, obj_t BgL_argsz00_16)
{
{ /* Llib/sqlite.scm 130 */
{ /* Llib/sqlite.scm 130 */
obj_t BgL_method1237z00_457;
{ /* Llib/sqlite.scm 130 */
obj_t BgL_res2052z00_1302;
{ /* Llib/sqlite.scm 130 */
long BgL_objzd2classzd2numz00_1273;
BgL_objzd2classzd2numz00_1273 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_14)); 
{ /* Llib/sqlite.scm 130 */
obj_t BgL_arg1765z00_1274;
BgL_arg1765z00_1274 = 
PROCEDURE_REF(BGl_sqlitezd2execzd2envz00zz__sqlite_sqlitez00, 
(int)(((long)1))); 
{ /* Llib/sqlite.scm 130 */
int BgL_offsetz00_1277;
BgL_offsetz00_1277 = 
(int)(BgL_objzd2classzd2numz00_1273); 
{ /* Llib/sqlite.scm 130 */
long BgL_offsetz00_1278;
BgL_offsetz00_1278 = 
(
(long)(BgL_offsetz00_1277)-OBJECT_TYPE); 
{ /* Llib/sqlite.scm 130 */
long BgL_modz00_1279;
BgL_modz00_1279 = 
(BgL_offsetz00_1278 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/sqlite.scm 130 */
long BgL_restz00_1281;
BgL_restz00_1281 = 
(BgL_offsetz00_1278 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/sqlite.scm 130 */

{ /* Llib/sqlite.scm 130 */
obj_t BgL_bucketz00_1283;
BgL_bucketz00_1283 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1274),BgL_modz00_1279); 
BgL_res2052z00_1302 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1283),BgL_restz00_1281); } } } } } } } } 
BgL_method1237z00_457 = BgL_res2052z00_1302; } 
{ /* Llib/sqlite.scm 130 */
obj_t BgL_auxz00_2950;
{ /* Llib/sqlite.scm 130 */
obj_t BgL_list1867z00_458;
{ /* Llib/sqlite.scm 130 */
obj_t BgL_arg1868z00_459;
BgL_arg1868z00_459 = 
MAKE_YOUNG_PAIR(BgL_argsz00_16, BNIL); 
BgL_list1867z00_458 = 
MAKE_YOUNG_PAIR(BgL_fmtz00_15, BgL_arg1868z00_459); } 
BgL_auxz00_2950 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_oz00_14), BgL_list1867z00_458); } 
return 
apply(BgL_method1237z00_457, BgL_auxz00_2950);} } } 

}



/* &sqlite-exec */
obj_t BGl_z62sqlitezd2execzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1553, obj_t BgL_oz00_1554, obj_t BgL_fmtz00_1555, obj_t BgL_argsz00_1556)
{
{ /* Llib/sqlite.scm 130 */
{ /* Llib/sqlite.scm 130 */
obj_t BgL_auxz00_2964;BgL_z52sqlitez52_bglt BgL_auxz00_2956;
if(
STRINGP(BgL_fmtz00_1555))
{ /* Llib/sqlite.scm 130 */
BgL_auxz00_2964 = BgL_fmtz00_1555
; }  else 
{ 
obj_t BgL_auxz00_2967;
BgL_auxz00_2967 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)5535)), BGl_string2200z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_fmtz00_1555); 
FAILURE(BgL_auxz00_2967,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1554, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 130 */
BgL_auxz00_2956 = 
((BgL_z52sqlitez52_bglt)BgL_oz00_1554)
; }  else 
{ 
obj_t BgL_auxz00_2960;
BgL_auxz00_2960 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)5535)), BGl_string2200z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_oz00_1554); 
FAILURE(BgL_auxz00_2960,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2execzd2zz__sqlite_sqlitez00(BgL_auxz00_2956, BgL_auxz00_2964, BgL_argsz00_1556);} } 

}



/* sqlite-eval */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2evalzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_oz00_20, obj_t BgL_pz00_21, obj_t BgL_fmtz00_22, obj_t BgL_argsz00_23)
{
{ /* Llib/sqlite.scm 168 */
{ /* Llib/sqlite.scm 168 */
obj_t BgL_method1241z00_460;
{ /* Llib/sqlite.scm 168 */
obj_t BgL_res2057z00_1333;
{ /* Llib/sqlite.scm 168 */
long BgL_objzd2classzd2numz00_1304;
BgL_objzd2classzd2numz00_1304 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_20)); 
{ /* Llib/sqlite.scm 168 */
obj_t BgL_arg1765z00_1305;
BgL_arg1765z00_1305 = 
PROCEDURE_REF(BGl_sqlitezd2evalzd2envz00zz__sqlite_sqlitez00, 
(int)(((long)1))); 
{ /* Llib/sqlite.scm 168 */
int BgL_offsetz00_1308;
BgL_offsetz00_1308 = 
(int)(BgL_objzd2classzd2numz00_1304); 
{ /* Llib/sqlite.scm 168 */
long BgL_offsetz00_1309;
BgL_offsetz00_1309 = 
(
(long)(BgL_offsetz00_1308)-OBJECT_TYPE); 
{ /* Llib/sqlite.scm 168 */
long BgL_modz00_1310;
BgL_modz00_1310 = 
(BgL_offsetz00_1309 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/sqlite.scm 168 */
long BgL_restz00_1312;
BgL_restz00_1312 = 
(BgL_offsetz00_1309 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/sqlite.scm 168 */

{ /* Llib/sqlite.scm 168 */
obj_t BgL_bucketz00_1314;
BgL_bucketz00_1314 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1305),BgL_modz00_1310); 
BgL_res2057z00_1333 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1314),BgL_restz00_1312); } } } } } } } } 
BgL_method1241z00_460 = BgL_res2057z00_1333; } 
{ /* Llib/sqlite.scm 168 */
obj_t BgL_auxz00_2997;
{ /* Llib/sqlite.scm 168 */
obj_t BgL_list1869z00_461;
{ /* Llib/sqlite.scm 168 */
obj_t BgL_arg1870z00_462;
{ /* Llib/sqlite.scm 168 */
obj_t BgL_arg1871z00_463;
BgL_arg1871z00_463 = 
MAKE_YOUNG_PAIR(BgL_argsz00_23, BNIL); 
BgL_arg1870z00_462 = 
MAKE_YOUNG_PAIR(BgL_fmtz00_22, BgL_arg1871z00_463); } 
BgL_list1869z00_461 = 
MAKE_YOUNG_PAIR(BgL_pz00_21, BgL_arg1870z00_462); } 
BgL_auxz00_2997 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_oz00_20), BgL_list1869z00_461); } 
return 
apply(BgL_method1241z00_460, BgL_auxz00_2997);} } } 

}



/* &sqlite-eval */
obj_t BGl_z62sqlitezd2evalzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1557, obj_t BgL_oz00_1558, obj_t BgL_pz00_1559, obj_t BgL_fmtz00_1560, obj_t BgL_argsz00_1561)
{
{ /* Llib/sqlite.scm 168 */
{ /* Llib/sqlite.scm 168 */
obj_t BgL_auxz00_3019;obj_t BgL_auxz00_3012;BgL_z52sqlitez52_bglt BgL_auxz00_3004;
if(
STRINGP(BgL_fmtz00_1560))
{ /* Llib/sqlite.scm 168 */
BgL_auxz00_3019 = BgL_fmtz00_1560
; }  else 
{ 
obj_t BgL_auxz00_3022;
BgL_auxz00_3022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7006)), BGl_string2201z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_fmtz00_1560); 
FAILURE(BgL_auxz00_3022,BFALSE,BFALSE);} 
if(
PROCEDUREP(BgL_pz00_1559))
{ /* Llib/sqlite.scm 168 */
BgL_auxz00_3012 = BgL_pz00_1559
; }  else 
{ 
obj_t BgL_auxz00_3015;
BgL_auxz00_3015 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7006)), BGl_string2201z00zz__sqlite_sqlitez00, BGl_string2202z00zz__sqlite_sqlitez00, BgL_pz00_1559); 
FAILURE(BgL_auxz00_3015,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1558, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 168 */
BgL_auxz00_3004 = 
((BgL_z52sqlitez52_bglt)BgL_oz00_1558)
; }  else 
{ 
obj_t BgL_auxz00_3008;
BgL_auxz00_3008 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7006)), BGl_string2201z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_oz00_1558); 
FAILURE(BgL_auxz00_3008,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2evalzd2zz__sqlite_sqlitez00(BgL_auxz00_3004, BgL_auxz00_3012, BgL_auxz00_3019, BgL_argsz00_1561);} } 

}



/* sqlite-map */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_oz00_28, obj_t BgL_pz00_29, obj_t BgL_fmtz00_30, obj_t BgL_argsz00_31)
{
{ /* Llib/sqlite.scm 189 */
{ /* Llib/sqlite.scm 189 */
obj_t BgL_method1245z00_464;
{ /* Llib/sqlite.scm 189 */
obj_t BgL_res2062z00_1364;
{ /* Llib/sqlite.scm 189 */
long BgL_objzd2classzd2numz00_1335;
BgL_objzd2classzd2numz00_1335 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_28)); 
{ /* Llib/sqlite.scm 189 */
obj_t BgL_arg1765z00_1336;
BgL_arg1765z00_1336 = 
PROCEDURE_REF(BGl_sqlitezd2mapzd2envz00zz__sqlite_sqlitez00, 
(int)(((long)1))); 
{ /* Llib/sqlite.scm 189 */
int BgL_offsetz00_1339;
BgL_offsetz00_1339 = 
(int)(BgL_objzd2classzd2numz00_1335); 
{ /* Llib/sqlite.scm 189 */
long BgL_offsetz00_1340;
BgL_offsetz00_1340 = 
(
(long)(BgL_offsetz00_1339)-OBJECT_TYPE); 
{ /* Llib/sqlite.scm 189 */
long BgL_modz00_1341;
BgL_modz00_1341 = 
(BgL_offsetz00_1340 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/sqlite.scm 189 */
long BgL_restz00_1343;
BgL_restz00_1343 = 
(BgL_offsetz00_1340 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/sqlite.scm 189 */

{ /* Llib/sqlite.scm 189 */
obj_t BgL_bucketz00_1345;
BgL_bucketz00_1345 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1336),BgL_modz00_1341); 
BgL_res2062z00_1364 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1345),BgL_restz00_1343); } } } } } } } } 
BgL_method1245z00_464 = BgL_res2062z00_1364; } 
{ /* Llib/sqlite.scm 189 */
obj_t BgL_auxz00_3052;
{ /* Llib/sqlite.scm 189 */
obj_t BgL_list1872z00_465;
{ /* Llib/sqlite.scm 189 */
obj_t BgL_arg1873z00_466;
{ /* Llib/sqlite.scm 189 */
obj_t BgL_arg1874z00_467;
BgL_arg1874z00_467 = 
MAKE_YOUNG_PAIR(BgL_argsz00_31, BNIL); 
BgL_arg1873z00_466 = 
MAKE_YOUNG_PAIR(BgL_fmtz00_30, BgL_arg1874z00_467); } 
BgL_list1872z00_465 = 
MAKE_YOUNG_PAIR(BgL_pz00_29, BgL_arg1873z00_466); } 
BgL_auxz00_3052 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_oz00_28), BgL_list1872z00_465); } 
return 
apply(BgL_method1245z00_464, BgL_auxz00_3052);} } } 

}



/* &sqlite-map */
obj_t BGl_z62sqlitezd2mapzb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1562, obj_t BgL_oz00_1563, obj_t BgL_pz00_1564, obj_t BgL_fmtz00_1565, obj_t BgL_argsz00_1566)
{
{ /* Llib/sqlite.scm 189 */
{ /* Llib/sqlite.scm 189 */
obj_t BgL_auxz00_3074;obj_t BgL_auxz00_3067;BgL_z52sqlitez52_bglt BgL_auxz00_3059;
if(
STRINGP(BgL_fmtz00_1565))
{ /* Llib/sqlite.scm 189 */
BgL_auxz00_3074 = BgL_fmtz00_1565
; }  else 
{ 
obj_t BgL_auxz00_3077;
BgL_auxz00_3077 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7865)), BGl_string2203z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_fmtz00_1565); 
FAILURE(BgL_auxz00_3077,BFALSE,BFALSE);} 
if(
PROCEDUREP(BgL_pz00_1564))
{ /* Llib/sqlite.scm 189 */
BgL_auxz00_3067 = BgL_pz00_1564
; }  else 
{ 
obj_t BgL_auxz00_3070;
BgL_auxz00_3070 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7865)), BGl_string2203z00zz__sqlite_sqlitez00, BGl_string2202z00zz__sqlite_sqlitez00, BgL_pz00_1564); 
FAILURE(BgL_auxz00_3070,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_1563, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 189 */
BgL_auxz00_3059 = 
((BgL_z52sqlitez52_bglt)BgL_oz00_1563)
; }  else 
{ 
obj_t BgL_auxz00_3063;
BgL_auxz00_3063 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)7865)), BGl_string2203z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_oz00_1563); 
FAILURE(BgL_auxz00_3063,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2mapzd2zz__sqlite_sqlitez00(BgL_auxz00_3059, BgL_auxz00_3067, BgL_auxz00_3074, BgL_argsz00_1566);} } 

}



/* sqlite-dump-table */
BGL_EXPORTED_DEF obj_t BGl_sqlitezd2dumpzd2tablez00zz__sqlite_sqlitez00(BgL_z52sqlitez52_bglt BgL_dbz00_45, obj_t BgL_tablez00_46, obj_t BgL_outz00_47)
{
{ /* Llib/sqlite.scm 248 */
{ /* Llib/sqlite.scm 248 */
obj_t BgL_method1249z00_468;
{ /* Llib/sqlite.scm 248 */
obj_t BgL_res2067z00_1395;
{ /* Llib/sqlite.scm 248 */
long BgL_objzd2classzd2numz00_1366;
BgL_objzd2classzd2numz00_1366 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_dbz00_45)); 
{ /* Llib/sqlite.scm 248 */
obj_t BgL_arg1765z00_1367;
BgL_arg1765z00_1367 = 
PROCEDURE_REF(BGl_sqlitezd2dumpzd2tablezd2envzd2zz__sqlite_sqlitez00, 
(int)(((long)1))); 
{ /* Llib/sqlite.scm 248 */
int BgL_offsetz00_1370;
BgL_offsetz00_1370 = 
(int)(BgL_objzd2classzd2numz00_1366); 
{ /* Llib/sqlite.scm 248 */
long BgL_offsetz00_1371;
BgL_offsetz00_1371 = 
(
(long)(BgL_offsetz00_1370)-OBJECT_TYPE); 
{ /* Llib/sqlite.scm 248 */
long BgL_modz00_1372;
BgL_modz00_1372 = 
(BgL_offsetz00_1371 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/sqlite.scm 248 */
long BgL_restz00_1374;
BgL_restz00_1374 = 
(BgL_offsetz00_1371 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/sqlite.scm 248 */

{ /* Llib/sqlite.scm 248 */
obj_t BgL_bucketz00_1376;
BgL_bucketz00_1376 = 
VECTOR_REF(
((obj_t)BgL_arg1765z00_1367),BgL_modz00_1372); 
BgL_res2067z00_1395 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1376),BgL_restz00_1374); } } } } } } } } 
BgL_method1249z00_468 = BgL_res2067z00_1395; } 
return 
PROCEDURE_ENTRY(BgL_method1249z00_468)(BgL_method1249z00_468, 
((obj_t)BgL_dbz00_45), BgL_tablez00_46, BgL_outz00_47, BEOA);} } 

}



/* &sqlite-dump-table */
obj_t BGl_z62sqlitezd2dumpzd2tablez62zz__sqlite_sqlitez00(obj_t BgL_envz00_1567, obj_t BgL_dbz00_1568, obj_t BgL_tablez00_1569, obj_t BgL_outz00_1570)
{
{ /* Llib/sqlite.scm 248 */
{ /* Llib/sqlite.scm 248 */
obj_t BgL_auxz00_3129;obj_t BgL_auxz00_3122;BgL_z52sqlitez52_bglt BgL_auxz00_3114;
if(
OUTPUT_PORTP(BgL_outz00_1570))
{ /* Llib/sqlite.scm 248 */
BgL_auxz00_3129 = BgL_outz00_1570
; }  else 
{ 
obj_t BgL_auxz00_3132;
BgL_auxz00_3132 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)10490)), BGl_string2204z00zz__sqlite_sqlitez00, BGl_string2147z00zz__sqlite_sqlitez00, BgL_outz00_1570); 
FAILURE(BgL_auxz00_3132,BFALSE,BFALSE);} 
if(
STRINGP(BgL_tablez00_1569))
{ /* Llib/sqlite.scm 248 */
BgL_auxz00_3122 = BgL_tablez00_1569
; }  else 
{ 
obj_t BgL_auxz00_3125;
BgL_auxz00_3125 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)10490)), BGl_string2204z00zz__sqlite_sqlitez00, BGl_string2136z00zz__sqlite_sqlitez00, BgL_tablez00_1569); 
FAILURE(BgL_auxz00_3125,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_dbz00_1568, BGl_z52sqlitez52zz__sqlite_sqlitez00))
{ /* Llib/sqlite.scm 248 */
BgL_auxz00_3114 = 
((BgL_z52sqlitez52_bglt)BgL_dbz00_1568)
; }  else 
{ 
obj_t BgL_auxz00_3118;
BgL_auxz00_3118 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2127z00zz__sqlite_sqlitez00, 
BINT(((long)10490)), BGl_string2204z00zz__sqlite_sqlitez00, BGl_string2135z00zz__sqlite_sqlitez00, BgL_dbz00_1568); 
FAILURE(BgL_auxz00_3118,BFALSE,BFALSE);} 
return 
BGl_sqlitezd2dumpzd2tablez00zz__sqlite_sqlitez00(BgL_auxz00_3114, BgL_auxz00_3122, BgL_auxz00_3129);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2205z00zz__sqlite_sqlitez00, BGl_string2206z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2207z00zz__sqlite_sqlitez00, BGl_string2208z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2209z00zz__sqlite_sqlitez00, BGl_string2210z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_sqlitezd2closezd2envz00zz__sqlite_sqlitez00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2211z00zz__sqlite_sqlitez00, BGl_string2212z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_sqlitezd2execzd2envz00zz__sqlite_sqlitez00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2213z00zz__sqlite_sqlitez00, BGl_string2214z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_sqlitezd2evalzd2envz00zz__sqlite_sqlitez00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2215z00zz__sqlite_sqlitez00, BGl_string2216z00zz__sqlite_sqlitez00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_sqlitezd2mapzd2envz00zz__sqlite_sqlitez00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2217z00zz__sqlite_sqlitez00, BGl_string2218z00zz__sqlite_sqlitez00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_sqlitezd2dumpzd2tablezd2envzd2zz__sqlite_sqlitez00, BGl_sqlitez00zz__sqlite_sqlitez00, BGl_proc2219z00zz__sqlite_sqlitez00, BGl_string2220z00zz__sqlite_sqlitez00);} 

}



/* &sqlite-dump-table-sq1251 */
obj_t BGl_z62sqlitezd2dumpzd2tablezd2sq1251zb0zz__sqlite_sqlitez00(obj_t BgL_envz00_1613, obj_t BgL_dbz00_1614, obj_t BgL_tablez00_1615, obj_t BgL_outz00_1616)
{
{ /* Llib/sqlite.scm 255 */
{ /* Llib/sqlite.scm 256 */
obj_t BgL_arg2038z00_2030;
{ /* Llib/sqlite.scm 256 */
obj_t BgL_arg2040z00_2031;
BgL_arg2040z00_2031 = 
string_append(BGl_string2221z00zz__sqlite_sqlitez00, BgL_tablez00_1615); 
BgL_arg2038z00_2030 = 
BGl_sqlitezd2execzd2zz__sqlite_sqlitez00(
((BgL_z52sqlitez52_bglt)
((BgL_sqlitez00_bglt)BgL_dbz00_1614)), BgL_arg2040z00_2031, BNIL); } 
{ /* Llib/sqlite.scm 256 */
obj_t BgL_list2039z00_2032;
BgL_list2039z00_2032 = 
MAKE_YOUNG_PAIR(BgL_outz00_1616, BNIL); 
return 
BGl_writez00zz__r4_output_6_10_3z00(BgL_arg2038z00_2030, BgL_list2039z00_2032);} } } 

}



/* &sqlite-map-sqlite1247 */
obj_t BGl_z62sqlitezd2mapzd2sqlite1247z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1617, obj_t BgL_oz00_1618, obj_t BgL_pz00_1619, obj_t BgL_fmtz00_1620, obj_t BgL_argsz00_1621)
{
{ /* Llib/sqlite.scm 197 */
{ /* Llib/sqlite.scm 198 */
obj_t BgL_excz00_2036;
BgL_excz00_2036 = 
MAKE_CELL(BFALSE); 
{ /* Llib/sqlite.scm 198 */
obj_t BgL_pz00_2037;
{ 

{ /* Llib/sqlite.scm 199 */
int BgL_aux1156z00_2040;
BgL_aux1156z00_2040 = 
PROCEDURE_ARITY(
((obj_t)BgL_pz00_1619)); 
switch( 
(long)(BgL_aux1156z00_2040)) { case ((long)1) : 

{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza31980ze3z87_2041;
BgL_zc3z04anonymousza31980ze3z87_2041 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31980ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_2041, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31980ze3z87_2041, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1619)); 
BgL_pz00_2037 = BgL_zc3z04anonymousza31980ze3z87_2041; } break;case ((long)2) : 

{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza31991ze3z87_2042;
BgL_zc3z04anonymousza31991ze3z87_2042 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31991ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)2)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_2042, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31991ze3z87_2042, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1619)); 
BgL_pz00_2037 = BgL_zc3z04anonymousza31991ze3z87_2042; } break;case ((long)3) : 

{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32002ze3z87_2043;
BgL_zc3z04anonymousza32002ze3z87_2043 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32002ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)3)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32002ze3z87_2043, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32002ze3z87_2043, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1619)); 
BgL_pz00_2037 = BgL_zc3z04anonymousza32002ze3z87_2043; } break;case ((long)4) : 

{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32013ze3z87_2044;
BgL_zc3z04anonymousza32013ze3z87_2044 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32013ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)4)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_2044, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32013ze3z87_2044, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1619)); 
BgL_pz00_2037 = BgL_zc3z04anonymousza32013ze3z87_2044; } break;
default: 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32024ze3z87_2039;
BgL_zc3z04anonymousza32024ze3z87_2039 = 
MAKE_VA_PROCEDURE(BGl_z62zc3z04anonymousza32024ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)-1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_2039, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32024ze3z87_2039, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1619)); 
BgL_pz00_2037 = BgL_zc3z04anonymousza32024ze3z87_2039; } } } } 
{ /* Llib/sqlite.scm 199 */

{ /* Llib/sqlite.scm 200 */
obj_t BgL_exitd1205z00_2045;
BgL_exitd1205z00_2045 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/sqlite.scm 205 */
obj_t BgL_zc3z04anonymousza31978ze3z87_2046;
BgL_zc3z04anonymousza31978ze3z87_2046 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31978ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31978ze3z87_2046, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2036)); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1205z00_2045, BgL_zc3z04anonymousza31978ze3z87_2046); 
{ /* Llib/sqlite.scm 201 */
obj_t BgL_tmp1207z00_2047;
if(
NULLP(BgL_argsz00_1621))
{ /* Llib/sqlite.scm 203 */
void * BgL_arg1972z00_2048;
BgL_arg1972z00_2048 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1618)))->BgL_z42builtinz42); 
BgL_tmp1207z00_2047 = 
bgl_sqlite_map(BgL_arg1972z00_2048, BgL_pz00_2037, 
BSTRING_TO_STRING(
((obj_t)BgL_fmtz00_1620)), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1618))); }  else 
{ /* Llib/sqlite.scm 204 */
void * BgL_arg1973z00_2049;obj_t BgL_arg1974z00_2050;
BgL_arg1973z00_2049 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1618)))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 204 */
obj_t BgL_runner1977z00_2051;
{ /* Llib/sqlite.scm 204 */
obj_t BgL_list1975z00_2052;
BgL_list1975z00_2052 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1621, BNIL); 
BgL_runner1977z00_2051 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1620), BgL_list1975z00_2052); } 
{ /* Llib/sqlite.scm 204 */
obj_t BgL_aux1976z00_2053;
BgL_aux1976z00_2053 = 
CAR(BgL_runner1977z00_2051); 
BgL_runner1977z00_2051 = 
CDR(BgL_runner1977z00_2051); 
BgL_arg1974z00_2050 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1976z00_2053, BgL_runner1977z00_2051); } } 
BgL_tmp1207z00_2047 = 
bgl_sqlite_map(BgL_arg1973z00_2049, BgL_pz00_2037, 
BSTRING_TO_STRING(BgL_arg1974z00_2050), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1618))); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1205z00_2045); 
if(
CBOOL(
CELL_REF(BgL_excz00_2036)))
{ /* Llib/sqlite.scm 205 */
BGl_raisez00zz__errorz00(
CELL_REF(BgL_excz00_2036)); }  else 
{ /* Llib/sqlite.scm 205 */BFALSE; } 
return BgL_tmp1207z00_2047;} } } } } } } 

}



/* &<@anonymous:1978> */
obj_t BGl_z62zc3z04anonymousza31978ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1624)
{
{ /* Llib/sqlite.scm 200 */
{ /* Llib/sqlite.scm 205 */
obj_t BgL_excz00_1625;
BgL_excz00_1625 = 
PROCEDURE_REF(BgL_envz00_1624, 
(int)(((long)0))); 
if(
CBOOL(
CELL_REF(BgL_excz00_1625)))
{ /* Llib/sqlite.scm 205 */
return 
BGl_raisez00zz__errorz00(
CELL_REF(BgL_excz00_1625));}  else 
{ /* Llib/sqlite.scm 205 */
return BFALSE;} } } 

}



/* &<@anonymous:2013> */
obj_t BGl_z62zc3z04anonymousza32013ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1626, obj_t BgL_xz00_1629, obj_t BgL_yz00_1630, obj_t BgL_za7za7_1631, obj_t BgL_tz00_1632)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_excz00_1627;obj_t BgL_pz00_1628;
BgL_excz00_1627 = 
PROCEDURE_REF(BgL_envz00_1626, 
(int)(((long)0))); 
BgL_pz00_1628 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1626, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1195z00_2054;
BgL_res1195z00_2054 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza32019ze3ze70z60zz__sqlite_sqlitez00(BgL_tz00_1632, BgL_za7za7_1631, BgL_yz00_1630, BgL_xz00_1629, BgL_pz00_1628, BgL_res1195z00_2054)))
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
int BgL_tmpz00_3246;
BgL_tmpz00_3246 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3246); } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ez00_2055;
BgL_ez00_2055 = 
CELL_REF(BgL_res1195z00_2054); 
return 
CELL_SET(BgL_excz00_1627, BgL_ez00_2055);} }  else 
{ /* Llib/sqlite.scm 199 */
return 
CELL_REF(BgL_res1195z00_2054);} } } } 

}



/* <@exit:2019>~0 */
obj_t BGl_zc3z04exitza32019ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_tz00_1868, obj_t BgL_za7za7_1867, obj_t BgL_yz00_1866, obj_t BgL_xz00_1865, obj_t BgL_pz00_1864, obj_t BgL_res1195z00_1863)
{
{ /* Llib/sqlite.scm 199 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1201z00_936;
if( SET_EXIT(BgL_an_exit1201z00_936 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1201z00_936 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 199 */

PUSH_EXIT(BgL_an_exit1201z00_936, ((long)1)); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_an_exitd1202z00_937;
BgL_an_exitd1202z00_937 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_res1204z00_940;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ohs1193z00_941;
BgL_ohs1193z00_941 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_exitd1198z00_942;
BgL_exitd1198z00_942 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32022ze3z87_1581;
BgL_zc3z04anonymousza32022ze3z87_1581 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32022ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32022ze3z87_1581, 
(int)(((long)0)), BgL_ohs1193z00_941); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1198z00_942, BgL_zc3z04anonymousza32022ze3z87_1581); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_tmp1200z00_944;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32021ze3z87_1582;
BgL_zc3z04anonymousza32021ze3z87_1582 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32021ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32021ze3z87_1582, 
(int)(((long)0)), 
((obj_t)BgL_res1195z00_1863)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32021ze3z87_1582, 
(int)(((long)1)), BgL_an_exitd1202z00_937); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza32021ze3z87_1582, BgL_ohs1193z00_941); BUNSPEC; } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_auxz00_1634;
BgL_auxz00_1634 = 
PROCEDURE_ENTRY(BgL_pz00_1864)(BgL_pz00_1864, BgL_xz00_1865, BgL_yz00_1866, BgL_za7za7_1867, BgL_tz00_1868, BEOA); 
CELL_SET(BgL_res1195z00_1863, BgL_auxz00_1634); } 
BgL_tmp1200z00_944 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1198z00_942); 
BGL_ERROR_HANDLER_SET(BgL_ohs1193z00_941); BUNSPEC; 
BgL_res1204z00_940 = BgL_tmp1200z00_944; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1204z00_940);} } } 
}} 

}



/* &<@anonymous:2021> */
obj_t BGl_z62zc3z04anonymousza32021ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1637, obj_t BgL_ez00_1640)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1195z00_1638;obj_t BgL_an_exitd1202z00_1639;
BgL_res1195z00_1638 = 
PROCEDURE_REF(BgL_envz00_1637, 
(int)(((long)0))); 
BgL_an_exitd1202z00_1639 = 
PROCEDURE_REF(BgL_envz00_1637, 
(int)(((long)1))); 
CELL_SET(BgL_res1195z00_1638, BgL_ez00_1640); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1202z00_1639, BTRUE);} } 

}



/* &<@anonymous:2022> */
obj_t BGl_z62zc3z04anonymousza32022ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1642)
{
{ /* Llib/sqlite.scm 199 */
{ 
obj_t BgL_ohs1193z00_1643;
BgL_ohs1193z00_1643 = 
PROCEDURE_REF(BgL_envz00_1642, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1193z00_1643); 
return BUNSPEC;} } 

}



/* &<@anonymous:2002> */
obj_t BGl_z62zc3z04anonymousza32002ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1644, obj_t BgL_xz00_1647, obj_t BgL_yz00_1648, obj_t BgL_za7za7_1649)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_excz00_1645;obj_t BgL_pz00_1646;
BgL_excz00_1645 = 
PROCEDURE_REF(BgL_envz00_1644, 
(int)(((long)0))); 
BgL_pz00_1646 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1644, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1183z00_2056;
BgL_res1183z00_2056 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza32008ze3ze70z60zz__sqlite_sqlitez00(BgL_za7za7_1649, BgL_yz00_1648, BgL_xz00_1647, BgL_pz00_1646, BgL_res1183z00_2056)))
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
int BgL_tmpz00_3295;
BgL_tmpz00_3295 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3295); } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ez00_2057;
BgL_ez00_2057 = 
CELL_REF(BgL_res1183z00_2056); 
return 
CELL_SET(BgL_excz00_1645, BgL_ez00_2057);} }  else 
{ /* Llib/sqlite.scm 199 */
return 
CELL_REF(BgL_res1183z00_2056);} } } } 

}



/* <@exit:2008>~0 */
obj_t BGl_zc3z04exitza32008ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_za7za7_1862, obj_t BgL_yz00_1861, obj_t BgL_xz00_1860, obj_t BgL_pz00_1859, obj_t BgL_res1183z00_1858)
{
{ /* Llib/sqlite.scm 199 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1189z00_893;
if( SET_EXIT(BgL_an_exit1189z00_893 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1189z00_893 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 199 */

PUSH_EXIT(BgL_an_exit1189z00_893, ((long)1)); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_an_exitd1190z00_894;
BgL_an_exitd1190z00_894 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_res1192z00_897;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ohs1181z00_898;
BgL_ohs1181z00_898 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_exitd1186z00_899;
BgL_exitd1186z00_899 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32011ze3z87_1578;
BgL_zc3z04anonymousza32011ze3z87_1578 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32011ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32011ze3z87_1578, 
(int)(((long)0)), BgL_ohs1181z00_898); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1186z00_899, BgL_zc3z04anonymousza32011ze3z87_1578); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_tmp1188z00_901;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32010ze3z87_1579;
BgL_zc3z04anonymousza32010ze3z87_1579 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32010ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_1579, 
(int)(((long)0)), 
((obj_t)BgL_res1183z00_1858)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32010ze3z87_1579, 
(int)(((long)1)), BgL_an_exitd1190z00_894); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza32010ze3z87_1579, BgL_ohs1181z00_898); BUNSPEC; } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_auxz00_1651;
BgL_auxz00_1651 = 
PROCEDURE_ENTRY(BgL_pz00_1859)(BgL_pz00_1859, BgL_xz00_1860, BgL_yz00_1861, BgL_za7za7_1862, BEOA); 
CELL_SET(BgL_res1183z00_1858, BgL_auxz00_1651); } 
BgL_tmp1188z00_901 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1186z00_899); 
BGL_ERROR_HANDLER_SET(BgL_ohs1181z00_898); BUNSPEC; 
BgL_res1192z00_897 = BgL_tmp1188z00_901; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1192z00_897);} } } 
}} 

}



/* &<@anonymous:2010> */
obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1654, obj_t BgL_ez00_1657)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1183z00_1655;obj_t BgL_an_exitd1190z00_1656;
BgL_res1183z00_1655 = 
PROCEDURE_REF(BgL_envz00_1654, 
(int)(((long)0))); 
BgL_an_exitd1190z00_1656 = 
PROCEDURE_REF(BgL_envz00_1654, 
(int)(((long)1))); 
CELL_SET(BgL_res1183z00_1655, BgL_ez00_1657); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1190z00_1656, BTRUE);} } 

}



/* &<@anonymous:2011> */
obj_t BGl_z62zc3z04anonymousza32011ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1659)
{
{ /* Llib/sqlite.scm 199 */
{ 
obj_t BgL_ohs1181z00_1660;
BgL_ohs1181z00_1660 = 
PROCEDURE_REF(BgL_envz00_1659, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1181z00_1660); 
return BUNSPEC;} } 

}



/* &<@anonymous:1991> */
obj_t BGl_z62zc3z04anonymousza31991ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1661, obj_t BgL_xz00_1664, obj_t BgL_yz00_1665)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_excz00_1662;obj_t BgL_pz00_1663;
BgL_excz00_1662 = 
PROCEDURE_REF(BgL_envz00_1661, 
(int)(((long)0))); 
BgL_pz00_1663 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1661, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1171z00_2058;
BgL_res1171z00_2058 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31997ze3ze70z60zz__sqlite_sqlitez00(BgL_yz00_1665, BgL_xz00_1664, BgL_pz00_1663, BgL_res1171z00_2058)))
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
int BgL_tmpz00_3343;
BgL_tmpz00_3343 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3343); } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ez00_2059;
BgL_ez00_2059 = 
CELL_REF(BgL_res1171z00_2058); 
return 
CELL_SET(BgL_excz00_1662, BgL_ez00_2059);} }  else 
{ /* Llib/sqlite.scm 199 */
return 
CELL_REF(BgL_res1171z00_2058);} } } } 

}



/* <@exit:1997>~0 */
obj_t BGl_zc3z04exitza31997ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_yz00_1857, obj_t BgL_xz00_1856, obj_t BgL_pz00_1855, obj_t BgL_res1171z00_1854)
{
{ /* Llib/sqlite.scm 199 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1177z00_851;
if( SET_EXIT(BgL_an_exit1177z00_851 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1177z00_851 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 199 */

PUSH_EXIT(BgL_an_exit1177z00_851, ((long)1)); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_an_exitd1178z00_852;
BgL_an_exitd1178z00_852 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_res1180z00_855;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ohs1169z00_856;
BgL_ohs1169z00_856 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_exitd1174z00_857;
BgL_exitd1174z00_857 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32000ze3z87_1575;
BgL_zc3z04anonymousza32000ze3z87_1575 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32000ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_1575, 
(int)(((long)0)), BgL_ohs1169z00_856); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1174z00_857, BgL_zc3z04anonymousza32000ze3z87_1575); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_tmp1176z00_859;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza31999ze3z87_1576;
BgL_zc3z04anonymousza31999ze3z87_1576 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31999ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31999ze3z87_1576, 
(int)(((long)0)), 
((obj_t)BgL_res1171z00_1854)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31999ze3z87_1576, 
(int)(((long)1)), BgL_an_exitd1178z00_852); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31999ze3z87_1576, BgL_ohs1169z00_856); BUNSPEC; } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_auxz00_1667;
BgL_auxz00_1667 = 
PROCEDURE_ENTRY(BgL_pz00_1855)(BgL_pz00_1855, BgL_xz00_1856, BgL_yz00_1857, BEOA); 
CELL_SET(BgL_res1171z00_1854, BgL_auxz00_1667); } 
BgL_tmp1176z00_859 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1174z00_857); 
BGL_ERROR_HANDLER_SET(BgL_ohs1169z00_856); BUNSPEC; 
BgL_res1180z00_855 = BgL_tmp1176z00_859; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1180z00_855);} } } 
}} 

}



/* &<@anonymous:1999> */
obj_t BGl_z62zc3z04anonymousza31999ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1670, obj_t BgL_ez00_1673)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1171z00_1671;obj_t BgL_an_exitd1178z00_1672;
BgL_res1171z00_1671 = 
PROCEDURE_REF(BgL_envz00_1670, 
(int)(((long)0))); 
BgL_an_exitd1178z00_1672 = 
PROCEDURE_REF(BgL_envz00_1670, 
(int)(((long)1))); 
CELL_SET(BgL_res1171z00_1671, BgL_ez00_1673); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1178z00_1672, BTRUE);} } 

}



/* &<@anonymous:2000> */
obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1675)
{
{ /* Llib/sqlite.scm 199 */
{ 
obj_t BgL_ohs1169z00_1676;
BgL_ohs1169z00_1676 = 
PROCEDURE_REF(BgL_envz00_1675, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1169z00_1676); 
return BUNSPEC;} } 

}



/* &<@anonymous:1980> */
obj_t BGl_z62zc3z04anonymousza31980ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1677, obj_t BgL_xz00_1680)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_excz00_1678;obj_t BgL_pz00_1679;
BgL_excz00_1678 = 
PROCEDURE_REF(BgL_envz00_1677, 
(int)(((long)0))); 
BgL_pz00_1679 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1677, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1159z00_2060;
BgL_res1159z00_2060 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31986ze3ze70z60zz__sqlite_sqlitez00(BgL_xz00_1680, BgL_pz00_1679, BgL_res1159z00_2060)))
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
int BgL_tmpz00_3390;
BgL_tmpz00_3390 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3390); } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ez00_2061;
BgL_ez00_2061 = 
CELL_REF(BgL_res1159z00_2060); 
return 
CELL_SET(BgL_excz00_1678, BgL_ez00_2061);} }  else 
{ /* Llib/sqlite.scm 199 */
return 
CELL_REF(BgL_res1159z00_2060);} } } } 

}



/* <@exit:1986>~0 */
obj_t BGl_zc3z04exitza31986ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_xz00_1853, obj_t BgL_pz00_1852, obj_t BgL_res1159z00_1851)
{
{ /* Llib/sqlite.scm 199 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1165z00_810;
if( SET_EXIT(BgL_an_exit1165z00_810 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1165z00_810 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 199 */

PUSH_EXIT(BgL_an_exit1165z00_810, ((long)1)); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_an_exitd1166z00_811;
BgL_an_exitd1166z00_811 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_res1168z00_814;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ohs1157z00_815;
BgL_ohs1157z00_815 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_exitd1162z00_816;
BgL_exitd1162z00_816 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31989ze3z87_1572;
BgL_zc3z04anonymousza31989ze3z87_1572 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31989ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31989ze3z87_1572, 
(int)(((long)0)), BgL_ohs1157z00_815); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1162z00_816, BgL_zc3z04anonymousza31989ze3z87_1572); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_tmp1164z00_818;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza31988ze3z87_1573;
BgL_zc3z04anonymousza31988ze3z87_1573 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31988ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31988ze3z87_1573, 
(int)(((long)0)), 
((obj_t)BgL_res1159z00_1851)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31988ze3z87_1573, 
(int)(((long)1)), BgL_an_exitd1166z00_811); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31988ze3z87_1573, BgL_ohs1157z00_815); BUNSPEC; } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_auxz00_1682;
BgL_auxz00_1682 = 
PROCEDURE_ENTRY(BgL_pz00_1852)(BgL_pz00_1852, BgL_xz00_1853, BEOA); 
CELL_SET(BgL_res1159z00_1851, BgL_auxz00_1682); } 
BgL_tmp1164z00_818 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1162z00_816); 
BGL_ERROR_HANDLER_SET(BgL_ohs1157z00_815); BUNSPEC; 
BgL_res1168z00_814 = BgL_tmp1164z00_818; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1168z00_814);} } } 
}} 

}



/* &<@anonymous:1988> */
obj_t BGl_z62zc3z04anonymousza31988ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1685, obj_t BgL_ez00_1688)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1159z00_1686;obj_t BgL_an_exitd1166z00_1687;
BgL_res1159z00_1686 = 
PROCEDURE_REF(BgL_envz00_1685, 
(int)(((long)0))); 
BgL_an_exitd1166z00_1687 = 
PROCEDURE_REF(BgL_envz00_1685, 
(int)(((long)1))); 
CELL_SET(BgL_res1159z00_1686, BgL_ez00_1688); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1166z00_1687, BTRUE);} } 

}



/* &<@anonymous:1989> */
obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1690)
{
{ /* Llib/sqlite.scm 199 */
{ 
obj_t BgL_ohs1157z00_1691;
BgL_ohs1157z00_1691 = 
PROCEDURE_REF(BgL_envz00_1690, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1157z00_1691); 
return BUNSPEC;} } 

}



/* &<@anonymous:2024> */
obj_t BGl_z62zc3z04anonymousza32024ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1692, obj_t BgL_lz00_1695)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_excz00_1693;obj_t BgL_pz00_1694;
BgL_excz00_1693 = 
PROCEDURE_REF(BgL_envz00_1692, 
(int)(((long)0))); 
BgL_pz00_1694 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1692, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1145z00_2062;
BgL_res1145z00_2062 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza32030ze3ze70z60zz__sqlite_sqlitez00(BgL_pz00_1694, BgL_lz00_1695, BgL_res1145z00_2062)))
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
int BgL_tmpz00_3436;
BgL_tmpz00_3436 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3436); } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ez00_2063;
BgL_ez00_2063 = 
CELL_REF(BgL_res1145z00_2062); 
return 
CELL_SET(BgL_excz00_1693, BgL_ez00_2063);} }  else 
{ /* Llib/sqlite.scm 199 */
return 
CELL_REF(BgL_res1145z00_2062);} } } } 

}



/* <@exit:2030>~0 */
obj_t BGl_zc3z04exitza32030ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_pz00_1850, obj_t BgL_lz00_1849, obj_t BgL_res1145z00_1848)
{
{ /* Llib/sqlite.scm 199 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1151z00_976;
if( SET_EXIT(BgL_an_exit1151z00_976 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1151z00_976 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 199 */

PUSH_EXIT(BgL_an_exit1151z00_976, ((long)1)); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_an_exitd1152z00_977;
BgL_an_exitd1152z00_977 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_res1154z00_980;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_ohs1143z00_981;
BgL_ohs1143z00_981 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_exitd1148z00_982;
BgL_exitd1148z00_982 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32033ze3z87_1585;
BgL_zc3z04anonymousza32033ze3z87_1585 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32033ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32033ze3z87_1585, 
(int)(((long)0)), BgL_ohs1143z00_981); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1148z00_982, BgL_zc3z04anonymousza32033ze3z87_1585); 
{ /* Llib/sqlite.scm 199 */
bool_t BgL_tmp1150z00_984;
{ /* Llib/sqlite.scm 199 */
obj_t BgL_zc3z04anonymousza32032ze3z87_1586;
BgL_zc3z04anonymousza32032ze3z87_1586 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32032ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32032ze3z87_1586, 
(int)(((long)0)), 
((obj_t)BgL_res1145z00_1848)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32032ze3z87_1586, 
(int)(((long)1)), BgL_an_exitd1152z00_977); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza32032ze3z87_1586, BgL_ohs1143z00_981); BUNSPEC; } 
{ /* Llib/sqlite.scm 199 */
obj_t BgL_auxz00_1697;
BgL_auxz00_1697 = 
apply(BgL_pz00_1850, BgL_lz00_1849); 
CELL_SET(BgL_res1145z00_1848, BgL_auxz00_1697); } 
BgL_tmp1150z00_984 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1148z00_982); 
BGL_ERROR_HANDLER_SET(BgL_ohs1143z00_981); BUNSPEC; 
BgL_res1154z00_980 = BgL_tmp1150z00_984; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1154z00_980);} } } 
}} 

}



/* &<@anonymous:2032> */
obj_t BGl_z62zc3z04anonymousza32032ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1700, obj_t BgL_ez00_1703)
{
{ /* Llib/sqlite.scm 199 */
{ /* Llib/sqlite.scm 199 */
obj_t BgL_res1145z00_1701;obj_t BgL_an_exitd1152z00_1702;
BgL_res1145z00_1701 = 
PROCEDURE_REF(BgL_envz00_1700, 
(int)(((long)0))); 
BgL_an_exitd1152z00_1702 = 
PROCEDURE_REF(BgL_envz00_1700, 
(int)(((long)1))); 
CELL_SET(BgL_res1145z00_1701, BgL_ez00_1703); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1152z00_1702, BTRUE);} } 

}



/* &<@anonymous:2033> */
obj_t BGl_z62zc3z04anonymousza32033ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1705)
{
{ /* Llib/sqlite.scm 199 */
{ 
obj_t BgL_ohs1143z00_1706;
BgL_ohs1143z00_1706 = 
PROCEDURE_REF(BgL_envz00_1705, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1143z00_1706); 
return BUNSPEC;} } 

}



/* &sqlite-eval-sqlite1243 */
obj_t BGl_z62sqlitezd2evalzd2sqlite1243z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1707, obj_t BgL_oz00_1708, obj_t BgL_pz00_1709, obj_t BgL_fmtz00_1710, obj_t BgL_argsz00_1711)
{
{ /* Llib/sqlite.scm 176 */
{ /* Llib/sqlite.scm 177 */
obj_t BgL_excz00_2067;
BgL_excz00_2067 = 
MAKE_CELL(BFALSE); 
{ /* Llib/sqlite.scm 177 */
obj_t BgL_pz00_2068;
{ 

{ /* Llib/sqlite.scm 178 */
int BgL_aux1089z00_2071;
BgL_aux1089z00_2071 = 
PROCEDURE_ARITY(
((obj_t)BgL_pz00_1709)); 
switch( 
(long)(BgL_aux1089z00_2071)) { case ((long)1) : 

{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31913ze3z87_2072;
BgL_zc3z04anonymousza31913ze3z87_2072 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31913ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31913ze3z87_2072, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31913ze3z87_2072, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1709)); 
BgL_pz00_2068 = BgL_zc3z04anonymousza31913ze3z87_2072; } break;case ((long)2) : 

{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31924ze3z87_2073;
BgL_zc3z04anonymousza31924ze3z87_2073 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31924ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)2)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_2073, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_2073, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1709)); 
BgL_pz00_2068 = BgL_zc3z04anonymousza31924ze3z87_2073; } break;case ((long)3) : 

{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31935ze3z87_2074;
BgL_zc3z04anonymousza31935ze3z87_2074 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31935ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)3)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31935ze3z87_2074, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31935ze3z87_2074, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1709)); 
BgL_pz00_2068 = BgL_zc3z04anonymousza31935ze3z87_2074; } break;case ((long)4) : 

{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31946ze3z87_2075;
BgL_zc3z04anonymousza31946ze3z87_2075 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31946ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)4)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31946ze3z87_2075, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31946ze3z87_2075, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1709)); 
BgL_pz00_2068 = BgL_zc3z04anonymousza31946ze3z87_2075; } break;
default: 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31957ze3z87_2070;
BgL_zc3z04anonymousza31957ze3z87_2070 = 
MAKE_VA_PROCEDURE(BGl_z62zc3z04anonymousza31957ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)-1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31957ze3z87_2070, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31957ze3z87_2070, 
(int)(((long)1)), 
((obj_t)BgL_pz00_1709)); 
BgL_pz00_2068 = BgL_zc3z04anonymousza31957ze3z87_2070; } } } } 
{ /* Llib/sqlite.scm 178 */

{ /* Llib/sqlite.scm 179 */
obj_t BgL_exitd1138z00_2076;
BgL_exitd1138z00_2076 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/sqlite.scm 184 */
obj_t BgL_zc3z04anonymousza31911ze3z87_2077;
BgL_zc3z04anonymousza31911ze3z87_2077 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31911ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31911ze3z87_2077, 
(int)(((long)0)), 
((obj_t)BgL_excz00_2067)); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1138z00_2076, BgL_zc3z04anonymousza31911ze3z87_2077); 
{ /* Llib/sqlite.scm 180 */
obj_t BgL_tmp1140z00_2078;
if(
NULLP(BgL_argsz00_1711))
{ /* Llib/sqlite.scm 182 */
void * BgL_arg1905z00_2079;
BgL_arg1905z00_2079 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1708)))->BgL_z42builtinz42); 
BgL_tmp1140z00_2078 = 
bgl_sqlite_eval(BgL_arg1905z00_2079, BgL_pz00_2068, 
BSTRING_TO_STRING(
((obj_t)BgL_fmtz00_1710)), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1708))); }  else 
{ /* Llib/sqlite.scm 183 */
void * BgL_arg1906z00_2080;obj_t BgL_arg1907z00_2081;
BgL_arg1906z00_2080 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1708)))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 183 */
obj_t BgL_runner1910z00_2082;
{ /* Llib/sqlite.scm 183 */
obj_t BgL_list1908z00_2083;
BgL_list1908z00_2083 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1711, BNIL); 
BgL_runner1910z00_2082 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1710), BgL_list1908z00_2083); } 
{ /* Llib/sqlite.scm 183 */
obj_t BgL_aux1909z00_2084;
BgL_aux1909z00_2084 = 
CAR(BgL_runner1910z00_2082); 
BgL_runner1910z00_2082 = 
CDR(BgL_runner1910z00_2082); 
BgL_arg1907z00_2081 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1909z00_2084, BgL_runner1910z00_2082); } } 
BgL_tmp1140z00_2078 = 
bgl_sqlite_eval(BgL_arg1906z00_2080, BgL_pz00_2068, 
BSTRING_TO_STRING(BgL_arg1907z00_2081), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1708))); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1138z00_2076); 
if(
CBOOL(
CELL_REF(BgL_excz00_2067)))
{ /* Llib/sqlite.scm 184 */
BGl_raisez00zz__errorz00(
CELL_REF(BgL_excz00_2067)); }  else 
{ /* Llib/sqlite.scm 184 */BFALSE; } 
return BgL_tmp1140z00_2078;} } } } } } } 

}



/* &<@anonymous:1911> */
obj_t BGl_z62zc3z04anonymousza31911ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1714)
{
{ /* Llib/sqlite.scm 179 */
{ /* Llib/sqlite.scm 184 */
obj_t BgL_excz00_1715;
BgL_excz00_1715 = 
PROCEDURE_REF(BgL_envz00_1714, 
(int)(((long)0))); 
if(
CBOOL(
CELL_REF(BgL_excz00_1715)))
{ /* Llib/sqlite.scm 184 */
return 
BGl_raisez00zz__errorz00(
CELL_REF(BgL_excz00_1715));}  else 
{ /* Llib/sqlite.scm 184 */
return BFALSE;} } } 

}



/* &<@anonymous:1946> */
obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1716, obj_t BgL_xz00_1719, obj_t BgL_yz00_1720, obj_t BgL_za7za7_1721, obj_t BgL_tz00_1722)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_excz00_1717;obj_t BgL_pz00_1718;
BgL_excz00_1717 = 
PROCEDURE_REF(BgL_envz00_1716, 
(int)(((long)0))); 
BgL_pz00_1718 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1716, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1128z00_2085;
BgL_res1128z00_2085 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31952ze3ze70z60zz__sqlite_sqlitez00(BgL_tz00_1722, BgL_za7za7_1721, BgL_yz00_1720, BgL_xz00_1719, BgL_pz00_1718, BgL_res1128z00_2085)))
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
int BgL_tmpz00_3567;
BgL_tmpz00_3567 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3567); } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ez00_2086;
BgL_ez00_2086 = 
CELL_REF(BgL_res1128z00_2085); 
return 
CELL_SET(BgL_excz00_1717, BgL_ez00_2086);} }  else 
{ /* Llib/sqlite.scm 178 */
return 
CELL_REF(BgL_res1128z00_2085);} } } } 

}



/* <@exit:1952>~0 */
obj_t BGl_zc3z04exitza31952ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_tz00_1847, obj_t BgL_za7za7_1846, obj_t BgL_yz00_1845, obj_t BgL_xz00_1844, obj_t BgL_pz00_1843, obj_t BgL_res1128z00_1842)
{
{ /* Llib/sqlite.scm 178 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1134z00_702;
if( SET_EXIT(BgL_an_exit1134z00_702 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1134z00_702 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 178 */

PUSH_EXIT(BgL_an_exit1134z00_702, ((long)1)); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_an_exitd1135z00_703;
BgL_an_exitd1135z00_703 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_res1137z00_706;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ohs1126z00_707;
BgL_ohs1126z00_707 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_exitd1131z00_708;
BgL_exitd1131z00_708 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31955ze3z87_1598;
BgL_zc3z04anonymousza31955ze3z87_1598 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31955ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31955ze3z87_1598, 
(int)(((long)0)), BgL_ohs1126z00_707); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_708, BgL_zc3z04anonymousza31955ze3z87_1598); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_tmp1133z00_710;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31954ze3z87_1599;
BgL_zc3z04anonymousza31954ze3z87_1599 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31954ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_1599, 
(int)(((long)0)), 
((obj_t)BgL_res1128z00_1842)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_1599, 
(int)(((long)1)), BgL_an_exitd1135z00_703); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31954ze3z87_1599, BgL_ohs1126z00_707); BUNSPEC; } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_auxz00_1724;
BgL_auxz00_1724 = 
PROCEDURE_ENTRY(BgL_pz00_1843)(BgL_pz00_1843, BgL_xz00_1844, BgL_yz00_1845, BgL_za7za7_1846, BgL_tz00_1847, BEOA); 
CELL_SET(BgL_res1128z00_1842, BgL_auxz00_1724); } 
BgL_tmp1133z00_710 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_708); 
BGL_ERROR_HANDLER_SET(BgL_ohs1126z00_707); BUNSPEC; 
BgL_res1137z00_706 = BgL_tmp1133z00_710; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1137z00_706);} } } 
}} 

}



/* &<@anonymous:1954> */
obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1727, obj_t BgL_ez00_1730)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1128z00_1728;obj_t BgL_an_exitd1135z00_1729;
BgL_res1128z00_1728 = 
PROCEDURE_REF(BgL_envz00_1727, 
(int)(((long)0))); 
BgL_an_exitd1135z00_1729 = 
PROCEDURE_REF(BgL_envz00_1727, 
(int)(((long)1))); 
CELL_SET(BgL_res1128z00_1728, BgL_ez00_1730); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1135z00_1729, BTRUE);} } 

}



/* &<@anonymous:1955> */
obj_t BGl_z62zc3z04anonymousza31955ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1732)
{
{ /* Llib/sqlite.scm 178 */
{ 
obj_t BgL_ohs1126z00_1733;
BgL_ohs1126z00_1733 = 
PROCEDURE_REF(BgL_envz00_1732, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1126z00_1733); 
return BUNSPEC;} } 

}



/* &<@anonymous:1935> */
obj_t BGl_z62zc3z04anonymousza31935ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1734, obj_t BgL_xz00_1737, obj_t BgL_yz00_1738, obj_t BgL_za7za7_1739)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_excz00_1735;obj_t BgL_pz00_1736;
BgL_excz00_1735 = 
PROCEDURE_REF(BgL_envz00_1734, 
(int)(((long)0))); 
BgL_pz00_1736 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1734, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1116z00_2087;
BgL_res1116z00_2087 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31941ze3ze70z60zz__sqlite_sqlitez00(BgL_za7za7_1739, BgL_yz00_1738, BgL_xz00_1737, BgL_pz00_1736, BgL_res1116z00_2087)))
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
int BgL_tmpz00_3616;
BgL_tmpz00_3616 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3616); } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ez00_2088;
BgL_ez00_2088 = 
CELL_REF(BgL_res1116z00_2087); 
return 
CELL_SET(BgL_excz00_1735, BgL_ez00_2088);} }  else 
{ /* Llib/sqlite.scm 178 */
return 
CELL_REF(BgL_res1116z00_2087);} } } } 

}



/* <@exit:1941>~0 */
obj_t BGl_zc3z04exitza31941ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_za7za7_1841, obj_t BgL_yz00_1840, obj_t BgL_xz00_1839, obj_t BgL_pz00_1838, obj_t BgL_res1116z00_1837)
{
{ /* Llib/sqlite.scm 178 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1122z00_659;
if( SET_EXIT(BgL_an_exit1122z00_659 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1122z00_659 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 178 */

PUSH_EXIT(BgL_an_exit1122z00_659, ((long)1)); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_an_exitd1123z00_660;
BgL_an_exitd1123z00_660 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_res1125z00_663;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ohs1114z00_664;
BgL_ohs1114z00_664 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_exitd1119z00_665;
BgL_exitd1119z00_665 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31944ze3z87_1595;
BgL_zc3z04anonymousza31944ze3z87_1595 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31944ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31944ze3z87_1595, 
(int)(((long)0)), BgL_ohs1114z00_664); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1119z00_665, BgL_zc3z04anonymousza31944ze3z87_1595); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_tmp1121z00_667;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31943ze3z87_1596;
BgL_zc3z04anonymousza31943ze3z87_1596 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31943ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31943ze3z87_1596, 
(int)(((long)0)), 
((obj_t)BgL_res1116z00_1837)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31943ze3z87_1596, 
(int)(((long)1)), BgL_an_exitd1123z00_660); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31943ze3z87_1596, BgL_ohs1114z00_664); BUNSPEC; } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_auxz00_1741;
BgL_auxz00_1741 = 
PROCEDURE_ENTRY(BgL_pz00_1838)(BgL_pz00_1838, BgL_xz00_1839, BgL_yz00_1840, BgL_za7za7_1841, BEOA); 
CELL_SET(BgL_res1116z00_1837, BgL_auxz00_1741); } 
BgL_tmp1121z00_667 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1119z00_665); 
BGL_ERROR_HANDLER_SET(BgL_ohs1114z00_664); BUNSPEC; 
BgL_res1125z00_663 = BgL_tmp1121z00_667; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1125z00_663);} } } 
}} 

}



/* &<@anonymous:1943> */
obj_t BGl_z62zc3z04anonymousza31943ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1744, obj_t BgL_ez00_1747)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1116z00_1745;obj_t BgL_an_exitd1123z00_1746;
BgL_res1116z00_1745 = 
PROCEDURE_REF(BgL_envz00_1744, 
(int)(((long)0))); 
BgL_an_exitd1123z00_1746 = 
PROCEDURE_REF(BgL_envz00_1744, 
(int)(((long)1))); 
CELL_SET(BgL_res1116z00_1745, BgL_ez00_1747); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1123z00_1746, BTRUE);} } 

}



/* &<@anonymous:1944> */
obj_t BGl_z62zc3z04anonymousza31944ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1749)
{
{ /* Llib/sqlite.scm 178 */
{ 
obj_t BgL_ohs1114z00_1750;
BgL_ohs1114z00_1750 = 
PROCEDURE_REF(BgL_envz00_1749, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1114z00_1750); 
return BUNSPEC;} } 

}



/* &<@anonymous:1924> */
obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1751, obj_t BgL_xz00_1754, obj_t BgL_yz00_1755)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_excz00_1752;obj_t BgL_pz00_1753;
BgL_excz00_1752 = 
PROCEDURE_REF(BgL_envz00_1751, 
(int)(((long)0))); 
BgL_pz00_1753 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1751, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1104z00_2089;
BgL_res1104z00_2089 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31930ze3ze70z60zz__sqlite_sqlitez00(BgL_yz00_1755, BgL_xz00_1754, BgL_pz00_1753, BgL_res1104z00_2089)))
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
int BgL_tmpz00_3664;
BgL_tmpz00_3664 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3664); } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ez00_2090;
BgL_ez00_2090 = 
CELL_REF(BgL_res1104z00_2089); 
return 
CELL_SET(BgL_excz00_1752, BgL_ez00_2090);} }  else 
{ /* Llib/sqlite.scm 178 */
return 
CELL_REF(BgL_res1104z00_2089);} } } } 

}



/* <@exit:1930>~0 */
obj_t BGl_zc3z04exitza31930ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_yz00_1836, obj_t BgL_xz00_1835, obj_t BgL_pz00_1834, obj_t BgL_res1104z00_1833)
{
{ /* Llib/sqlite.scm 178 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1110z00_617;
if( SET_EXIT(BgL_an_exit1110z00_617 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1110z00_617 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 178 */

PUSH_EXIT(BgL_an_exit1110z00_617, ((long)1)); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_an_exitd1111z00_618;
BgL_an_exitd1111z00_618 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_res1113z00_621;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ohs1102z00_622;
BgL_ohs1102z00_622 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_exitd1107z00_623;
BgL_exitd1107z00_623 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31933ze3z87_1592;
BgL_zc3z04anonymousza31933ze3z87_1592 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31933ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31933ze3z87_1592, 
(int)(((long)0)), BgL_ohs1102z00_622); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1107z00_623, BgL_zc3z04anonymousza31933ze3z87_1592); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_tmp1109z00_625;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31932ze3z87_1593;
BgL_zc3z04anonymousza31932ze3z87_1593 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31932ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_1593, 
(int)(((long)0)), 
((obj_t)BgL_res1104z00_1833)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31932ze3z87_1593, 
(int)(((long)1)), BgL_an_exitd1111z00_618); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31932ze3z87_1593, BgL_ohs1102z00_622); BUNSPEC; } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_auxz00_1757;
BgL_auxz00_1757 = 
PROCEDURE_ENTRY(BgL_pz00_1834)(BgL_pz00_1834, BgL_xz00_1835, BgL_yz00_1836, BEOA); 
CELL_SET(BgL_res1104z00_1833, BgL_auxz00_1757); } 
BgL_tmp1109z00_625 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1107z00_623); 
BGL_ERROR_HANDLER_SET(BgL_ohs1102z00_622); BUNSPEC; 
BgL_res1113z00_621 = BgL_tmp1109z00_625; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1113z00_621);} } } 
}} 

}



/* &<@anonymous:1932> */
obj_t BGl_z62zc3z04anonymousza31932ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1760, obj_t BgL_ez00_1763)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1104z00_1761;obj_t BgL_an_exitd1111z00_1762;
BgL_res1104z00_1761 = 
PROCEDURE_REF(BgL_envz00_1760, 
(int)(((long)0))); 
BgL_an_exitd1111z00_1762 = 
PROCEDURE_REF(BgL_envz00_1760, 
(int)(((long)1))); 
CELL_SET(BgL_res1104z00_1761, BgL_ez00_1763); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1111z00_1762, BTRUE);} } 

}



/* &<@anonymous:1933> */
obj_t BGl_z62zc3z04anonymousza31933ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1765)
{
{ /* Llib/sqlite.scm 178 */
{ 
obj_t BgL_ohs1102z00_1766;
BgL_ohs1102z00_1766 = 
PROCEDURE_REF(BgL_envz00_1765, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1102z00_1766); 
return BUNSPEC;} } 

}



/* &<@anonymous:1913> */
obj_t BGl_z62zc3z04anonymousza31913ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1767, obj_t BgL_xz00_1770)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_excz00_1768;obj_t BgL_pz00_1769;
BgL_excz00_1768 = 
PROCEDURE_REF(BgL_envz00_1767, 
(int)(((long)0))); 
BgL_pz00_1769 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1767, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1092z00_2091;
BgL_res1092z00_2091 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31919ze3ze70z60zz__sqlite_sqlitez00(BgL_xz00_1770, BgL_pz00_1769, BgL_res1092z00_2091)))
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
int BgL_tmpz00_3711;
BgL_tmpz00_3711 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3711); } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ez00_2092;
BgL_ez00_2092 = 
CELL_REF(BgL_res1092z00_2091); 
return 
CELL_SET(BgL_excz00_1768, BgL_ez00_2092);} }  else 
{ /* Llib/sqlite.scm 178 */
return 
CELL_REF(BgL_res1092z00_2091);} } } } 

}



/* <@exit:1919>~0 */
obj_t BGl_zc3z04exitza31919ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_xz00_1832, obj_t BgL_pz00_1831, obj_t BgL_res1092z00_1830)
{
{ /* Llib/sqlite.scm 178 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1098z00_576;
if( SET_EXIT(BgL_an_exit1098z00_576 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1098z00_576 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 178 */

PUSH_EXIT(BgL_an_exit1098z00_576, ((long)1)); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_an_exitd1099z00_577;
BgL_an_exitd1099z00_577 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_res1101z00_580;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ohs1090z00_581;
BgL_ohs1090z00_581 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_exitd1095z00_582;
BgL_exitd1095z00_582 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31922ze3z87_1589;
BgL_zc3z04anonymousza31922ze3z87_1589 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31922ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31922ze3z87_1589, 
(int)(((long)0)), BgL_ohs1090z00_581); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1095z00_582, BgL_zc3z04anonymousza31922ze3z87_1589); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_tmp1097z00_584;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31921ze3z87_1590;
BgL_zc3z04anonymousza31921ze3z87_1590 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31921ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31921ze3z87_1590, 
(int)(((long)0)), 
((obj_t)BgL_res1092z00_1830)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31921ze3z87_1590, 
(int)(((long)1)), BgL_an_exitd1099z00_577); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31921ze3z87_1590, BgL_ohs1090z00_581); BUNSPEC; } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_auxz00_1772;
BgL_auxz00_1772 = 
PROCEDURE_ENTRY(BgL_pz00_1831)(BgL_pz00_1831, BgL_xz00_1832, BEOA); 
CELL_SET(BgL_res1092z00_1830, BgL_auxz00_1772); } 
BgL_tmp1097z00_584 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1095z00_582); 
BGL_ERROR_HANDLER_SET(BgL_ohs1090z00_581); BUNSPEC; 
BgL_res1101z00_580 = BgL_tmp1097z00_584; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1101z00_580);} } } 
}} 

}



/* &<@anonymous:1921> */
obj_t BGl_z62zc3z04anonymousza31921ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1775, obj_t BgL_ez00_1778)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1092z00_1776;obj_t BgL_an_exitd1099z00_1777;
BgL_res1092z00_1776 = 
PROCEDURE_REF(BgL_envz00_1775, 
(int)(((long)0))); 
BgL_an_exitd1099z00_1777 = 
PROCEDURE_REF(BgL_envz00_1775, 
(int)(((long)1))); 
CELL_SET(BgL_res1092z00_1776, BgL_ez00_1778); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1099z00_1777, BTRUE);} } 

}



/* &<@anonymous:1922> */
obj_t BGl_z62zc3z04anonymousza31922ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1780)
{
{ /* Llib/sqlite.scm 178 */
{ 
obj_t BgL_ohs1090z00_1781;
BgL_ohs1090z00_1781 = 
PROCEDURE_REF(BgL_envz00_1780, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1090z00_1781); 
return BUNSPEC;} } 

}



/* &<@anonymous:1957> */
obj_t BGl_z62zc3z04anonymousza31957ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1782, obj_t BgL_lz00_1785)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_excz00_1783;obj_t BgL_pz00_1784;
BgL_excz00_1783 = 
PROCEDURE_REF(BgL_envz00_1782, 
(int)(((long)0))); 
BgL_pz00_1784 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1782, 
(int)(((long)1)))); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1078z00_2093;
BgL_res1078z00_2093 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza31963ze3ze70z60zz__sqlite_sqlitez00(BgL_pz00_1784, BgL_lz00_1785, BgL_res1078z00_2093)))
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
int BgL_tmpz00_3757;
BgL_tmpz00_3757 = 
(int)(((long)0)); 
BGL_SIGSETMASK(BgL_tmpz00_3757); } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ez00_2094;
BgL_ez00_2094 = 
CELL_REF(BgL_res1078z00_2093); 
return 
CELL_SET(BgL_excz00_1783, BgL_ez00_2094);} }  else 
{ /* Llib/sqlite.scm 178 */
return 
CELL_REF(BgL_res1078z00_2093);} } } } 

}



/* <@exit:1963>~0 */
obj_t BGl_zc3z04exitza31963ze3ze70z60zz__sqlite_sqlitez00(obj_t BgL_pz00_1829, obj_t BgL_lz00_1828, obj_t BgL_res1078z00_1827)
{
{ /* Llib/sqlite.scm 178 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1084z00_742;
if( SET_EXIT(BgL_an_exit1084z00_742 ) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

BgL_an_exit1084z00_742 = 
(void *)jmpbuf; 
{ /* Llib/sqlite.scm 178 */

PUSH_EXIT(BgL_an_exit1084z00_742, ((long)1)); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_an_exitd1085z00_743;
BgL_an_exitd1085z00_743 = 
((obj_t)(&exitd)); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_res1087z00_746;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_ohs1076z00_747;
BgL_ohs1076z00_747 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_exitd1081z00_748;
BgL_exitd1081z00_748 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza31966ze3z87_1602;
BgL_zc3z04anonymousza31966ze3z87_1602 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31966ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31966ze3z87_1602, 
(int)(((long)0)), BgL_ohs1076z00_747); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1081z00_748, BgL_zc3z04anonymousza31966ze3z87_1602); 
{ /* Llib/sqlite.scm 178 */
bool_t BgL_tmp1083z00_750;
{ /* Llib/sqlite.scm 178 */
obj_t BgL_zc3z04anonymousza31965ze3z87_1603;
BgL_zc3z04anonymousza31965ze3z87_1603 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31965ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31965ze3z87_1603, 
(int)(((long)0)), 
((obj_t)BgL_res1078z00_1827)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31965ze3z87_1603, 
(int)(((long)1)), BgL_an_exitd1085z00_743); 
BGL_ERROR_HANDLER_PUSH(BgL_zc3z04anonymousza31965ze3z87_1603, BgL_ohs1076z00_747); BUNSPEC; } 
{ /* Llib/sqlite.scm 178 */
obj_t BgL_auxz00_1787;
BgL_auxz00_1787 = 
apply(BgL_pz00_1829, BgL_lz00_1828); 
CELL_SET(BgL_res1078z00_1827, BgL_auxz00_1787); } 
BgL_tmp1083z00_750 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1081z00_748); 
BGL_ERROR_HANDLER_SET(BgL_ohs1076z00_747); BUNSPEC; 
BgL_res1087z00_746 = BgL_tmp1083z00_750; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1087z00_746);} } } 
}} 

}



/* &<@anonymous:1965> */
obj_t BGl_z62zc3z04anonymousza31965ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1790, obj_t BgL_ez00_1793)
{
{ /* Llib/sqlite.scm 178 */
{ /* Llib/sqlite.scm 178 */
obj_t BgL_res1078z00_1791;obj_t BgL_an_exitd1085z00_1792;
BgL_res1078z00_1791 = 
PROCEDURE_REF(BgL_envz00_1790, 
(int)(((long)0))); 
BgL_an_exitd1085z00_1792 = 
PROCEDURE_REF(BgL_envz00_1790, 
(int)(((long)1))); 
CELL_SET(BgL_res1078z00_1791, BgL_ez00_1793); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1085z00_1792, BTRUE);} } 

}



/* &<@anonymous:1966> */
obj_t BGl_z62zc3z04anonymousza31966ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1795)
{
{ /* Llib/sqlite.scm 178 */
{ 
obj_t BgL_ohs1076z00_1796;
BgL_ohs1076z00_1796 = 
PROCEDURE_REF(BgL_envz00_1795, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1076z00_1796); 
return BUNSPEC;} } 

}



/* &sqlite-exec-sqlite1239 */
obj_t BGl_z62sqlitezd2execzd2sqlite1239z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1797, obj_t BgL_oz00_1798, obj_t BgL_fmtz00_1799, obj_t BgL_argsz00_1800)
{
{ /* Llib/sqlite.scm 138 */
if(
NULLP(BgL_argsz00_1800))
{ /* Llib/sqlite.scm 141 */
void * BgL_arg1896z00_2097;
BgL_arg1896z00_2097 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1798)))->BgL_z42builtinz42); 
return 
bgl_sqlite_exec(BgL_arg1896z00_2097, 
BSTRING_TO_STRING(
((obj_t)BgL_fmtz00_1799)), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1798)));}  else 
{ /* Llib/sqlite.scm 142 */
void * BgL_arg1897z00_2098;obj_t BgL_arg1898z00_2099;
BgL_arg1897z00_2098 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1798)))->BgL_z42builtinz42); 
{ /* Llib/sqlite.scm 142 */
obj_t BgL_runner1901z00_2100;
{ /* Llib/sqlite.scm 142 */
obj_t BgL_list1899z00_2101;
BgL_list1899z00_2101 = 
MAKE_YOUNG_PAIR(BgL_argsz00_1800, BNIL); 
BgL_runner1901z00_2100 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(
((obj_t)BgL_fmtz00_1799), BgL_list1899z00_2101); } 
{ /* Llib/sqlite.scm 142 */
obj_t BgL_aux1900z00_2102;
BgL_aux1900z00_2102 = 
CAR(BgL_runner1901z00_2100); 
BgL_runner1901z00_2100 = 
CDR(BgL_runner1901z00_2100); 
BgL_arg1898z00_2099 = 
BGl_sqlitezd2formatzd2zz__sqlite_sqlitez00(BgL_aux1900z00_2102, BgL_runner1901z00_2100); } } 
return 
bgl_sqlite_exec(BgL_arg1897z00_2098, 
BSTRING_TO_STRING(BgL_arg1898z00_2099), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1798)));} } 

}



/* &sqlite-close-sqlite1235 */
obj_t BGl_z62sqlitezd2closezd2sqlite1235z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1801, obj_t BgL_oz00_1802)
{
{ /* Llib/sqlite.scm 123 */
{ /* Llib/sqlite.scm 125 */
void * BgL_arg1894z00_2104;
BgL_arg1894z00_2104 = 
(((BgL_sqlitez00_bglt)COBJECT(
((BgL_sqlitez00_bglt)BgL_oz00_1802)))->BgL_z42builtinz42); 
bgl_sqlite_close(BgL_arg1894z00_2104, 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1802))); 
return BUNSPEC;} } 

}



/* &object-print-sqlite1231 */
obj_t BGl_z62objectzd2printzd2sqlite1231z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1803, obj_t BgL_oz00_1804, obj_t BgL_portz00_1805, obj_t BgL_printzd2slotzd2_1806)
{
{ /* Llib/sqlite.scm 91 */
{ /* Llib/sqlite.scm 92 */
obj_t BgL_list1893z00_2106;
BgL_list1893z00_2106 = 
MAKE_YOUNG_PAIR(BgL_portz00_1805, BNIL); 
return 
BGl_objectzd2writezd2zz__objectz00(
((BgL_objectz00_bglt)
((BgL_sqlitez00_bglt)BgL_oz00_1804)), BgL_list1893z00_2106);} } 

}



/* &object-write-sqlite1229 */
obj_t BGl_z62objectzd2writezd2sqlite1229z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1807, obj_t BgL_oz00_1808, obj_t BgL_portz00_1809)
{
{ /* Llib/sqlite.scm 82 */
{ /* Llib/sqlite.scm 83 */
obj_t BgL_arg1884z00_2108;
if(
PAIRP(BgL_portz00_1809))
{ /* Llib/sqlite.scm 83 */
BgL_arg1884z00_2108 = 
CAR(BgL_portz00_1809); }  else 
{ /* Llib/sqlite.scm 83 */
obj_t BgL_tmpz00_3826;
BgL_tmpz00_3826 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1884z00_2108 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3826); } 
{ /* Llib/sqlite.scm 85 */
obj_t BgL_zc3z04anonymousza31887ze3z87_2109;
BgL_zc3z04anonymousza31887ze3z87_2109 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31887ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31887ze3z87_2109, 
(int)(((long)0)), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1808))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1884z00_2108, BgL_zc3z04anonymousza31887ze3z87_2109);} } } 

}



/* &<@anonymous:1887> */
obj_t BGl_z62zc3z04anonymousza31887ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1810)
{
{ /* Llib/sqlite.scm 84 */
{ /* Llib/sqlite.scm 85 */
BgL_sqlitez00_bglt BgL_oz00_1811;
BgL_oz00_1811 = 
((BgL_sqlitez00_bglt)
PROCEDURE_REF(BgL_envz00_1810, 
(int)(((long)0)))); 
{ /* Llib/sqlite.scm 86 */
obj_t BgL_arg1888z00_2110;
BgL_arg1888z00_2110 = 
(((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_1811)))->BgL_pathz00); 
{ /* Llib/sqlite.scm 86 */
obj_t BgL_list1889z00_2111;
{ /* Llib/sqlite.scm 86 */
obj_t BgL_arg1890z00_2112;
{ /* Llib/sqlite.scm 86 */
obj_t BgL_arg1891z00_2113;
BgL_arg1891z00_2113 = 
MAKE_YOUNG_PAIR(BGl_string2222z00zz__sqlite_sqlitez00, BNIL); 
BgL_arg1890z00_2112 = 
MAKE_YOUNG_PAIR(BgL_arg1888z00_2110, BgL_arg1891z00_2113); } 
BgL_list1889z00_2111 = 
MAKE_YOUNG_PAIR(BGl_string2223z00zz__sqlite_sqlitez00, BgL_arg1890z00_2112); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1889z00_2111);} } } } 

}



/* &object-display-sqlit1227 */
obj_t BGl_z62objectzd2displayzd2sqlit1227z62zz__sqlite_sqlitez00(obj_t BgL_envz00_1812, obj_t BgL_oz00_1813, obj_t BgL_portz00_1814)
{
{ /* Llib/sqlite.scm 73 */
{ /* Llib/sqlite.scm 74 */
obj_t BgL_arg1875z00_2115;
if(
PAIRP(BgL_portz00_1814))
{ /* Llib/sqlite.scm 74 */
BgL_arg1875z00_2115 = 
CAR(BgL_portz00_1814); }  else 
{ /* Llib/sqlite.scm 74 */
obj_t BgL_tmpz00_3849;
BgL_tmpz00_3849 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1875z00_2115 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3849); } 
{ /* Llib/sqlite.scm 76 */
obj_t BgL_zc3z04anonymousza31878ze3z87_2116;
BgL_zc3z04anonymousza31878ze3z87_2116 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31878ze3ze5zz__sqlite_sqlitez00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31878ze3z87_2116, 
(int)(((long)0)), 
((obj_t)
((BgL_sqlitez00_bglt)BgL_oz00_1813))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1875z00_2115, BgL_zc3z04anonymousza31878ze3z87_2116);} } } 

}



/* &<@anonymous:1878> */
obj_t BGl_z62zc3z04anonymousza31878ze3ze5zz__sqlite_sqlitez00(obj_t BgL_envz00_1815)
{
{ /* Llib/sqlite.scm 75 */
{ /* Llib/sqlite.scm 76 */
BgL_sqlitez00_bglt BgL_oz00_1816;
BgL_oz00_1816 = 
((BgL_sqlitez00_bglt)
PROCEDURE_REF(BgL_envz00_1815, 
(int)(((long)0)))); 
{ /* Llib/sqlite.scm 77 */
obj_t BgL_arg1879z00_2117;
BgL_arg1879z00_2117 = 
(((BgL_z52sqlitez52_bglt)COBJECT(
((BgL_z52sqlitez52_bglt)BgL_oz00_1816)))->BgL_pathz00); 
{ /* Llib/sqlite.scm 77 */
obj_t BgL_list1880z00_2118;
{ /* Llib/sqlite.scm 77 */
obj_t BgL_arg1881z00_2119;
{ /* Llib/sqlite.scm 77 */
obj_t BgL_arg1882z00_2120;
BgL_arg1882z00_2120 = 
MAKE_YOUNG_PAIR(BGl_string2222z00zz__sqlite_sqlitez00, BNIL); 
BgL_arg1881z00_2119 = 
MAKE_YOUNG_PAIR(BgL_arg1879z00_2117, BgL_arg1882z00_2120); } 
BgL_list1880z00_2118 = 
MAKE_YOUNG_PAIR(BGl_string2223z00zz__sqlite_sqlitez00, BgL_arg1881z00_2119); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1880z00_2118);} } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__sqlite_sqlitez00()
{
{ /* Llib/sqlite.scm 15 */
return 
BGl_modulezd2initializa7ationz75zz__sqlite_sqltinyz00(((long)266205491), 
BSTRING_TO_STRING(BGl_string2224z00zz__sqlite_sqlitez00));} 

}

#ifdef __cplusplus
}
#endif
