/*===========================================================================*/
/*   (bmem/bmem.scm)                                                         */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:58:31 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4b/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4b/lib/bigloo/4.4b -ld-relative -g -I bmem bmem/bmem.scm -o bmem/bmem.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z52htmlzd2elementz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
} *BgL_z52htmlzd2elementz80_bglt;

typedef struct BgL_z52htmlzd2documentz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_attrza2za2;
   obj_t BgL_dtdz00;
   obj_t BgL_bodyz00;
   obj_t BgL_cssz00;
} *BgL_z52htmlzd2documentz80_bglt;

typedef struct BgL_z52htmlzd2brz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
} *BgL_z52htmlzd2brz80_bglt;

typedef struct BgL_z52htmlzd2boxz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_kindz00;
   obj_t BgL_inlineza2za2;
   obj_t BgL_alignz00;
} *BgL_z52htmlzd2boxz80_bglt;

typedef struct BgL_z52htmlzd2headingz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   int BgL_levelz00;
   obj_t BgL_alignmentz00;
   obj_t BgL_inlineza2za2;
} *BgL_z52htmlzd2headingz80_bglt;

typedef struct BgL_z52htmlzd2tablez80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_captionz00;
   obj_t BgL_colgroupzf3zf3;
   obj_t BgL_tfootzf3zf3;
   obj_t BgL_theadzf3zf3;
   obj_t BgL_widthz00;
   obj_t BgL_borderz00;
   obj_t BgL_framez00;
   obj_t BgL_rulesz00;
   obj_t BgL_cellspacingz00;
   obj_t BgL_cellpaddingz00;
   obj_t BgL_tbodyzb2zb2;
} *BgL_z52htmlzd2tablez80_bglt;

typedef struct BgL_z52htmlzd2trz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_tcellzb2zb2;
} *BgL_z52htmlzd2trz80_bglt;

typedef struct BgL_z52htmlzd2colgroupz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_widthz00;
   obj_t BgL_spanz00;
   obj_t BgL_alignz00;
   obj_t BgL_valignz00;
   obj_t BgL_charz00;
   obj_t BgL_colza2za2;
} *BgL_z52htmlzd2colgroupz80_bglt;

typedef struct BgL_z52htmlzd2tcellz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_kindz00;
   int BgL_colspanz00;
   int BgL_rowspanz00;
   obj_t BgL_alignz00;
   obj_t BgL_valignz00;
   obj_t BgL_charz00;
   obj_t BgL_widthz00;
   obj_t BgL_flowza2za2;
} *BgL_z52htmlzd2tcellz80_bglt;

typedef struct BgL_z52htmlzd2az80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_typez00;
   obj_t BgL_hrefz00;
   obj_t BgL_namez00;
   obj_t BgL_inlineza2za2;
} *BgL_z52htmlzd2az80_bglt;

typedef struct BgL_z52cssz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_typez00;
} *BgL_z52cssz52_bglt;

typedef struct BgL_funinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_identz00;
   bool_t BgL_usez00;
   int BgL_numz00;
   BGL_LONGLONG_T BgL_dsiza7eza7;
   BGL_LONGLONG_T BgL_isiza7eza7;
   obj_t BgL_gcza2za2;
   obj_t BgL_dtypez00;
   obj_t BgL_itypez00;
} *BgL_funinfoz00_bglt;


BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
extern obj_t BGl_z52htmlzd2az80zzhtmlz00;
static obj_t BGl_pregexp1557z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1558z00zzbmemz00 = BUNSPEC;
extern obj_t BGl_z52htmlzd2tablez80zzhtmlz00;
static obj_t BGl_z62zc3z04anonymousza31637za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31796za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31832za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00(obj_t);
static obj_t BGl_pregexp1562z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1563z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1564z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1565z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1566z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1567z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1568z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1569z00zzbmemz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zzbmemz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31812za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t);
extern obj_t BGl_csszd2colorzd2zzbmem_toolsz00(int, int, int, int);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62functionzd2identzd2ppz62zzbmemz00(obj_t, obj_t);
extern obj_t BGl_addzd2functionz12zc0zzbmem_functionz00(obj_t);
extern obj_t BGl_za2uriza2z00zzbmem_paramz00;
BGL_IMPORT bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_findzd2monitorzd2zzbmemz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2siza7eofzd2wordza2z75zzbmem_paramz00;
extern obj_t BGl_z52htmlzd2documentz80zzhtmlz00;
static obj_t BGl_toplevelzd2initzd2zzbmemz00();
extern obj_t BGl_z52htmlzd2trz80zzhtmlz00;
extern obj_t BGl_funinfoz00zzbmem_functionz00;
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_getenvz00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zzbmemz00();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static BgL_z52htmlzd2documentz80_bglt BGl_bmemzd2allzd2zzbmemz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zzbmemz00();
BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31699za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bigloo_main(obj_t);
static obj_t BGl_z62zc3z04anonymousza31781za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_usagez00zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_pregexpz00zz__regexpz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31678za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2typeza2z00zzbmem_paramz00;
BGL_EXPORTED_DECL obj_t BGl_dynamiczd2csszd2zzbmemz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_functionzd2refzd2zzbmemz00(obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
extern obj_t BGl_htmlzd2pluginzd2versionz00zzhtmlz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2hostnameza2z00zzbmem_paramz00;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzbmemz00();
extern obj_t BGl_za2foutza2z00zzbmem_paramz00;
static obj_t BGl_z62zc3z04anonymousza31815za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
BGL_IMPORT obj_t BGl_errorzf2czd2locationz20zz__errorz00(obj_t, obj_t, obj_t, char *, long);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_z52cssz52_bglt BGl_listzd2ze3cssz31zzhtmlz00(obj_t);
extern obj_t BGl_htmlzd2legendzd2zzbmem_toolsz00(int, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52htmlzd2tcellz80zzhtmlz00;
extern obj_t BGl_bmemzd2typezd2zzbmem_typez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2bmemza2z00zzbmem_paramz00;
static obj_t BGl_z62zc3z04anonymousza32066za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2portza2z00zzbmem_paramz00;
BGL_IMPORT obj_t string_append(obj_t, obj_t);
extern obj_t BGl_za2functionza2z00zzbmem_paramz00;
static obj_t BGl_parsezd2cmdlinez12zc0zzbmemz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31628za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31714za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62dynamiczd2csszb0zzbmemz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_htmlzd2vboxzd2zzhtmlz00(obj_t, obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
extern obj_t BGl_z52htmlzd2brz80zzhtmlz00;
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
extern obj_t BGl_printzd2htmlzd2zzhtmlz00(BgL_z52htmlzd2documentz80_bglt);
extern obj_t BGl_z52htmlzd2boxz80zzhtmlz00;
BGL_IMPORT obj_t BGl_errorzd2notifyzd2zz__errorz00(obj_t);
extern obj_t BGl_za2csszd2pathza2zd2zzbmem_paramz00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzbmemz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_gcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_functionz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzhtmlz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__expander_argsz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__regexpz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_makezd2gczd2tablesz00zzbmem_gcz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
extern obj_t BGl_htmlzd2pluginzd2usagez00zzhtmlz00(obj_t, obj_t, obj_t, BgL_z52htmlzd2elementz80_bglt);
BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_za2bmemzd2versionza2zd2zzbmem_paramz00;
extern obj_t BGl_z52htmlzd2headingz80zzhtmlz00;
BGL_IMPORT obj_t BGl_bigloozd2initializa7edz12z67zz__paramz00();
BGL_IMPORT obj_t bgl_debug_set(int);
static obj_t BGl_z62typezd2refzb0zzbmemz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_functionzd2identzd2ppz00zzbmemz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_argszd2parsezd2usagez00zz__expander_argsz00(obj_t);
static obj_t BGl_cnstzd2initzd2zzbmemz00();
extern obj_t BGl_htmlzd2stringzd2zzhtmlz00(obj_t);
BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzbmemz00();
BGL_IMPORT long bgl_list_length(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zzbmemz00();
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_gczd2rootszd2initz00zzbmemz00();
extern obj_t BGl_za2fileza2z00zzbmem_paramz00;
static obj_t BGl_z62zc3z04anonymousza32044za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62functionzd2refzb0zzbmemz00(obj_t, obj_t);
static obj_t BGl_bmemzd2requestzd2zzbmemz00();
extern obj_t BGl_getzd2functionszd2zzbmem_functionz00();
static obj_t BGl_parsezd2uriz12zc0zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62mainz62zzbmemz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2typezd2tablesz00zzbmem_typez00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31653za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mainz00zzbmemz00(obj_t);
extern obj_t BGl_htmlzd2pluginzd2errorz00zzhtmlz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
extern obj_t BGl_makezd2functionzd2tablesz00zzbmem_functionz00(obj_t, obj_t, obj_t);
extern obj_t BGl_z52htmlzd2colgroupz80zzhtmlz00;
static bool_t BGl_httpzd2requestzf3z21zzbmemz00();
BGL_IMPORT obj_t BGl_pregexpzd2matchzd2zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31761za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2gczd2summaryz00zzbmem_gcz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31731za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_typezd2refzd2zzbmemz00(obj_t);
extern obj_t BGl_bmemzd2functionzd2zzbmem_functionz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2threadzd2tablez00zzbmem_threadz00(obj_t);
static obj_t __cnst[ 82 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_functionzd2identzd2ppzd2envzd2zzbmemz00, BgL_bgl_za762functionza7d2id2757z00, BGl_z62functionzd2identzd2ppz62zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2600z00zzbmemz00, BgL_bgl_string2600za700za7za7b2758za7, "bglmem", 6 );
DEFINE_STRING( BGl_string2601z00zzbmemz00, BgL_bgl_string2601za700za7za7b2759za7, "bglmem [options]", 16 );
DEFINE_STRING( BGl_string2602z00zzbmemz00, BgL_bgl_string2602za700za7za7b2760za7, "/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm", 56 );
DEFINE_STRING( BGl_string2603z00zzbmemz00, BgL_bgl_string2603za700za7za7b2761za7, "usage", 5 );
DEFINE_STRING( BGl_string2604z00zzbmemz00, BgL_bgl_string2604za700za7za7b2762za7, "%html-document", 14 );
DEFINE_STRING( BGl_string2605z00zzbmemz00, BgL_bgl_string2605za700za7za7b2763za7, "usage: bglmem [options] name.bmem", 33 );
DEFINE_STRING( BGl_string2606z00zzbmemz00, BgL_bgl_string2606za700za7za7b2764za7, "procedure", 9 );
DEFINE_STRING( BGl_string2607z00zzbmemz00, BgL_bgl_string2607za700za7za7b2765za7, "usage:Wrong number of arguments", 31 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_functionzd2refzd2envz00zzbmemz00, BgL_bgl_za762functionza7d2re2766z00, BGl_z62functionzd2refzb0zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2608z00zzbmemz00, BgL_bgl_string2608za700za7za7b2767za7, "<@anonymous:1628:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:60@>", 78 );
DEFINE_STRING( BGl_string2609z00zzbmemz00, BgL_bgl_string2609za700za7za7b2768za7, "<@anonymous:1628:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:60@>:Wrong number of arguments", 104 );
DEFINE_STRING( BGl_string2610z00zzbmemz00, BgL_bgl_string2610za700za7za7b2769za7, "QUERY_STRING", 12 );
DEFINE_STRING( BGl_string2611z00zzbmemz00, BgL_bgl_string2611za700za7za7b2770za7, "SERVER_NAME", 11 );
DEFINE_STRING( BGl_string2612z00zzbmemz00, BgL_bgl_string2612za700za7za7b2771za7, "SERVER_PORT", 11 );
DEFINE_STRING( BGl_string2700z00zzbmemz00, BgL_bgl_string2700za700za7za7b2772za7, "funinfo", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2613z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2773za7, BGl_z62zc3z04anonymousza31796za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2614z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2774za7, BGl_z62zc3z04anonymousza31637za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2702z00zzbmemz00, BgL_bgl_string2702za700za7za7b2775za7, "<@anonymous:2024:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:322@>", 79 );
DEFINE_STRING( BGl_string2621z00zzbmemz00, BgL_bgl_string2621za700za7za7b2776za7, "liip", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2615z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2777za7, BGl_z62zc3z04anonymousza31653za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2703z00zzbmemz00, BgL_bgl_string2703za700za7za7b2778za7, "function~a", 10 );
DEFINE_STRING( BGl_string2622z00zzbmemz00, BgL_bgl_string2622za700za7za7b2779za7, "pair", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2780za7, BGl_z62zc3z04anonymousza31678za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2704z00zzbmemz00, BgL_bgl_string2704za700za7za7b2781za7, "map", 3 );
DEFINE_STRING( BGl_string2623z00zzbmemz00, BgL_bgl_string2623za700za7za7b2782za7, "liip:Wrong number of arguments", 30 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2783za7, BGl_z62zc3z04anonymousza31699za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2705z00zzbmemz00, BgL_bgl_string2705za700za7za7b2784za7, "90%", 3 );
DEFINE_STRING( BGl_string2624z00zzbmemz00, BgL_bgl_string2624za700za7za7b2785za7, "Illegal argument list", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2618z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2786za7, BGl_z62zc3z04anonymousza31714za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2706z00zzbmemz00, BgL_bgl_string2706za700za7za7b2787za7, "function-legend", 15 );
DEFINE_STRING( BGl_string2625z00zzbmemz00, BgL_bgl_string2625za700za7za7b2788za7, "<@anonymous:1781:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2619z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2789za7, BGl_z62zc3z04anonymousza31731za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2626z00zzbmemz00, BgL_bgl_string2626za700za7za7b2790za7, "bstring", 7 );
DEFINE_STRING( BGl_string2708z00zzbmemz00, BgL_bgl_string2708za700za7za7b2791za7, "<@anonymous:2052:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:340@>", 79 );
DEFINE_STRING( BGl_string2627z00zzbmemz00, BgL_bgl_string2627za700za7za7b2792za7, "--help", 6 );
DEFINE_STRING( BGl_string2709z00zzbmemz00, BgL_bgl_string2709za700za7za7b2793za7, "type~a", 6 );
DEFINE_STRING( BGl_string2628z00zzbmemz00, BgL_bgl_string2628za700za7za7b2794za7, "<@anonymous:1761:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2629z00zzbmemz00, BgL_bgl_string2629za700za7za7b2795za7, "-v", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2701z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2796za7, BGl_z62zc3z04anonymousza32044za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2797za7, BGl_z62zc3z04anonymousza31761za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2710z00zzbmemz00, BgL_bgl_string2710za700za7za7b2798za7, "type-legend", 11 );
DEFINE_STRING( BGl_string2711z00zzbmemz00, BgL_bgl_string2711za700za7za7b2799za7, "<@anonymous:2072:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:350@>", 79 );
DEFINE_STRING( BGl_string2630z00zzbmemz00, BgL_bgl_string2630za700za7za7b2800za7, "--version", 9 );
DEFINE_STRING( BGl_string2712z00zzbmemz00, BgL_bgl_string2712za700za7za7b2801za7, "gc~a", 4 );
DEFINE_STRING( BGl_string2631z00zzbmemz00, BgL_bgl_string2631za700za7za7b2802za7, ": ", 2 );
DEFINE_STRING( BGl_string2713z00zzbmemz00, BgL_bgl_string2713za700za7za7b2803za7, "gc #~a", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2707z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2804za7, BGl_z62zc3z04anonymousza32066za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2632z00zzbmemz00, BgL_bgl_string2632za700za7za7b2805za7, "<@anonymous:1731:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2714z00zzbmemz00, BgL_bgl_string2714za700za7za7b2806za7, "Gcs", 3 );
DEFINE_STRING( BGl_string2633z00zzbmemz00, BgL_bgl_string2633za700za7za7b2807za7, "-o", 2 );
DEFINE_STRING( BGl_string2715z00zzbmemz00, BgL_bgl_string2715za700za7za7b2808za7, "gc-legend", 9 );
DEFINE_STRING( BGl_string2634z00zzbmemz00, BgL_bgl_string2634za700za7za7b2809za7, "--output", 8 );
DEFINE_STRING( BGl_string2716z00zzbmemz00, BgL_bgl_string2716za700za7za7b2810za7, "functions", 9 );
DEFINE_STRING( BGl_string2635z00zzbmemz00, BgL_bgl_string2635za700za7za7b2811za7, "missing argument", 16 );
DEFINE_STRING( BGl_string2717z00zzbmemz00, BgL_bgl_string2717za700za7za7b2812za7, "types", 5 );
DEFINE_STRING( BGl_string2636z00zzbmemz00, BgL_bgl_string2636za700za7za7b2813za7, "<@anonymous:1714:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2718z00zzbmemz00, BgL_bgl_string2718za700za7za7b2814za7, "threads", 7 );
DEFINE_STRING( BGl_string2637z00zzbmemz00, BgL_bgl_string2637za700za7za7b2815za7, "-f", 2 );
DEFINE_STRING( BGl_string2719z00zzbmemz00, BgL_bgl_string2719za700za7za7b2816za7, "gcs", 3 );
DEFINE_STRING( BGl_string2638z00zzbmemz00, BgL_bgl_string2638za700za7za7b2817za7, "--function", 10 );
DEFINE_STRING( BGl_string2639z00zzbmemz00, BgL_bgl_string2639za700za7za7b2818za7, "<@anonymous:1699:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2720z00zzbmemz00, BgL_bgl_string2720za700za7za7b2819za7, "main", 4 );
DEFINE_STRING( BGl_string2721z00zzbmemz00, BgL_bgl_string2721za700za7za7b2820za7, "hop", 3 );
DEFINE_STRING( BGl_string2640z00zzbmemz00, BgL_bgl_string2640za700za7za7b2821za7, "-t", 2 );
DEFINE_STRING( BGl_string2722z00zzbmemz00, BgL_bgl_string2722za700za7za7b2822za7, "bglmem: ", 8 );
DEFINE_STRING( BGl_string2641z00zzbmemz00, BgL_bgl_string2641za700za7za7b2823za7, "--type", 6 );
DEFINE_STRING( BGl_string2723z00zzbmemz00, BgL_bgl_string2723za700za7za7b2824za7, "class-field", 11 );
DEFINE_STRING( BGl_string2642z00zzbmemz00, BgL_bgl_string2642za700za7za7b2825za7, "<@anonymous:1678:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2724z00zzbmemz00, BgL_bgl_string2724za700za7za7b2826za7, "20%", 3 );
DEFINE_STRING( BGl_string2643z00zzbmemz00, BgL_bgl_string2643za700za7za7b2827za7, "-h", 2 );
DEFINE_STRING( BGl_string2725z00zzbmemz00, BgL_bgl_string2725za700za7za7b2828za7, "80%", 3 );
DEFINE_STRING( BGl_string2644z00zzbmemz00, BgL_bgl_string2644za700za7za7b2829za7, "--hostname", 10 );
DEFINE_STRING( BGl_string2726z00zzbmemz00, BgL_bgl_string2726za700za7za7b2830za7, "100%", 4 );
DEFINE_STRING( BGl_string2645z00zzbmemz00, BgL_bgl_string2645za700za7za7b2831za7, "<@anonymous:1653:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2727z00zzbmemz00, BgL_bgl_string2727za700za7za7b2832za7, "1px solid black", 15 );
DEFINE_STRING( BGl_string2646z00zzbmemz00, BgL_bgl_string2646za700za7za7b2833za7, "-p", 2 );
DEFINE_STRING( BGl_string2728z00zzbmemz00, BgL_bgl_string2728za700za7za7b2834za7, "left", 4 );
DEFINE_STRING( BGl_string2647z00zzbmemz00, BgL_bgl_string2647za700za7za7b2835za7, "--port", 6 );
DEFINE_STRING( BGl_string2729z00zzbmemz00, BgL_bgl_string2729za700za7za7b2836za7, "top", 3 );
DEFINE_STRING( BGl_string2648z00zzbmemz00, BgL_bgl_string2648za700za7za7b2837za7, "<@anonymous:1796:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2649z00zzbmemz00, BgL_bgl_string2649za700za7za7b2838za7, "Illegal option", 14 );
DEFINE_STRING( BGl_string2730z00zzbmemz00, BgL_bgl_string2730za700za7za7b2839za7, "hop-margin", 10 );
DEFINE_STRING( BGl_string2731z00zzbmemz00, BgL_bgl_string2731za700za7za7b2840za7, "hop-title", 9 );
DEFINE_STRING( BGl_string2650z00zzbmemz00, BgL_bgl_string2650za700za7za7b2841za7, "see -help", 9 );
DEFINE_STRING( BGl_string2732z00zzbmemz00, BgL_bgl_string2732za700za7za7b2842za7, "hop-page", 8 );
DEFINE_STRING( BGl_string2651z00zzbmemz00, BgL_bgl_string2651za700za7za7b2843za7, "parse-uri!", 10 );
DEFINE_STRING( BGl_string2733z00zzbmemz00, BgL_bgl_string2733za700za7za7b2844za7, "<@anonymous:2066:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:343@>", 79 );
DEFINE_STRING( BGl_string2734z00zzbmemz00, BgL_bgl_string2734za700za7za7b2845za7, "<@anonymous:2044:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:326@>", 79 );
DEFINE_STRING( BGl_string2653z00zzbmemz00, BgL_bgl_string2653za700za7za7b2846za7, "&main", 5 );
DEFINE_STRING( BGl_string2735z00zzbmemz00, BgL_bgl_string2735za700za7za7b2847za7, "gc-css", 6 );
DEFINE_STRING( BGl_string2736z00zzbmemz00, BgL_bgl_string2736za700za7za7b2848za7, "div.profile .gc~a", 17 );
DEFINE_STRING( BGl_string2655z00zzbmemz00, BgL_bgl_string2655za700za7za7b2849za7, "<@anonymous:1804:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:125@>", 79 );
DEFINE_STRING( BGl_string2737z00zzbmemz00, BgL_bgl_string2737za700za7za7b2850za7, "#ccc", 4 );
DEFINE_STRING( BGl_string2656z00zzbmemz00, BgL_bgl_string2656za700za7za7b2851za7, "/usr/lib64/bigloo/4.4b/bmem", 27 );
DEFINE_STRING( BGl_string2738z00zzbmemz00, BgL_bgl_string2738za700za7za7b2852za7, "#ddf", 4 );
DEFINE_STRING( BGl_string2657z00zzbmemz00, BgL_bgl_string2657za700za7za7b2853za7, "bmem.css", 8 );
DEFINE_STRING( BGl_string2739z00zzbmemz00, BgL_bgl_string2739za700za7za7b2854za7, "div.profile .function-1", 23 );
DEFINE_STRING( BGl_string2658z00zzbmemz00, BgL_bgl_string2658za700za7za7b2855za7, "bmem-request", 12 );
DEFINE_STRING( BGl_string2659z00zzbmemz00, BgL_bgl_string2659za700za7za7b2856za7, "Illegal monitor file (empty gc section)", 39 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mainzd2envzd2zzbmemz00, BgL_bgl_za762mainza762za7za7bmem2857z00, BGl_z62mainz62zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_typezd2refzd2envz00zzbmemz00, BgL_bgl_za762typeza7d2refza7b02858za7, BGl_z62typezd2refzb0zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2652z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2859za7, BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2740z00zzbmemz00, BgL_bgl_string2740za700za7za7b2860za7, "<@anonymous:2119:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:403@>", 79 );
DEFINE_STRING( BGl_string2741z00zzbmemz00, BgL_bgl_string2741za700za7za7b2861za7, "div.profile .function~a", 23 );
DEFINE_STRING( BGl_string2660z00zzbmemz00, BgL_bgl_string2660za700za7za7b2862za7, "pair-nil", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo2863za7, BGl_z62zc3z04anonymousza31815za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2742z00zzbmemz00, BgL_bgl_string2742za700za7za7b2864za7, "div.profile .type-1", 19 );
DEFINE_STRING( BGl_string2661z00zzbmemz00, BgL_bgl_string2661za700za7za7b2865za7, "bint", 4 );
DEFINE_STRING( BGl_string2743z00zzbmemz00, BgL_bgl_string2743za700za7za7b2866za7, "<@anonymous:2139:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:411@>", 79 );
DEFINE_STRING( BGl_string2662z00zzbmemz00, BgL_bgl_string2662za700za7za7b2867za7, "<@anonymous:1825:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:175@>", 79 );
DEFINE_STRING( BGl_string2744z00zzbmemz00, BgL_bgl_string2744za700za7za7b2868za7, "div.profile .type~a", 19 );
DEFINE_STRING( BGl_string2663z00zzbmemz00, BgL_bgl_string2663za700za7za7b2869za7, "for-each", 8 );
DEFINE_STRING( BGl_string2745z00zzbmemz00, BgL_bgl_string2745za700za7za7b2870za7, "byte", 4 );
DEFINE_STRING( BGl_string2664z00zzbmemz00, BgL_bgl_string2664za700za7za7b2871za7, "list", 4 );
DEFINE_STRING( BGl_string2746z00zzbmemz00, BgL_bgl_string2746za700za7za7b2872za7, "rgb( 60, 60, 60 )", 17 );
DEFINE_STRING( BGl_string2665z00zzbmemz00, BgL_bgl_string2665za700za7za7b2873za7, "Can't find function", 19 );
DEFINE_STRING( BGl_string2747z00zzbmemz00, BgL_bgl_string2747za700za7za7b2874za7, "dynamic-css", 11 );
DEFINE_STRING( BGl_string2666z00zzbmemz00, BgL_bgl_string2666za700za7za7b2875za7, "Can't find type", 15 );
DEFINE_STRING( BGl_string2748z00zzbmemz00, BgL_bgl_string2748za700za7za7b2876za7, "loop", 4 );
DEFINE_STRING( BGl_string2667z00zzbmemz00, BgL_bgl_string2667za700za7za7b2877za7, "<@anonymous:1832:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:194@>", 79 );
DEFINE_STRING( BGl_string2749z00zzbmemz00, BgL_bgl_string2749za700za7za7b2878za7, "bmem", 4 );
DEFINE_STRING( BGl_string2668z00zzbmemz00, BgL_bgl_string2668za700za7za7b2879za7, "function-ident-pp", 17 );
DEFINE_STRING( BGl_string2669z00zzbmemz00, BgL_bgl_string2669za700za7za7b2880za7, ")", 1 );
DEFINE_STRING( BGl_string2750z00zzbmemz00, BgL_bgl_string2750za700za7za7b2881za7, "%import@bmem method-init@bmem generic-init@bmem object-init@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 15280) find-monitor@bmem :background :cursor help (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 13848) dynamic-css@bmem td (\"Garbage collections\") (\"Threads information\") (\"Types\") (\"Functions\") (\"Statistics\") exec bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 10764) bmem-all@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 10203) type-ref@bmem span (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 9077) function-ref@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 8360) function-ident-pp@bmem sizeof-word bglmem (\".\") thread type function gc info (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 5677) bmem-request@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 5069) main@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem."
"scm\" 4460) parse-uri!@bmem (((\"-p\" \"--port\") ?p (help \"Port number of the request\")) (set! *port* p)) ?p (((\"-h\" \"--hostname\") ?h (help \"Hostname of the request\")) (set! *hostname* h)) ?h (((\"-t\" \"--type\") ?type (help \"Show the type information\")) (set! *type* type)) ?type (((\"-f\" \"--function\") ?function (help \"Show the function information\")) (set! *function* function)) ?function (((\"-o\" \"--output\") ?fout (help \"Output file\")) (set! *fout* fout)) ?fout (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 1902) plugin-exit@bmem args-parse end fail next (funcall fun1793 fun1793 a* v) ((\"--help\" . \"This help message\") (\"-v,--version\" . \"Version number\") (\"-o,--output FOUT\" . \"Output file\") (\"-f,--function FUNCTION\" . \"Show the function information\") (\"-t,--type TYPE\" . \"Show the type information\") (\"-h,--hostname H\" . \"Hostname of the request\") (\"-p,--port P\" . \"Port number of the request\")) (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/b"
"mem/bmem.scm\" 3070) parse-cmdline!@bmem _ (funcall proc proc #f) div (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 2455) usage@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 2168) http-request?@bmem pregexp1557@bmem pregexp1558@bmem pregexp1562@bmem pregexp1563@bmem pregexp1564@bmem pregexp1565@bmem pregexp1566@bmem pregexp1567@bmem pregexp1568@bmem pregexp1569@bmem %toplevel@bmem (at \"/builddir/build/BUILD/bigloo-4.4b/bde/bmem/bmem/bmem.scm\" 1037) gc-roots-init@bmem ", 2467 );
DEFINE_STRING( BGl_string2670z00zzbmemz00, BgL_bgl_string2670za700za7za7b2882za7, ":", 1 );
DEFINE_STRING( BGl_string2671z00zzbmemz00, BgL_bgl_string2671za700za7za7b2883za7, "&#955; (", 8 );
DEFINE_STRING( BGl_string2672z00zzbmemz00, BgL_bgl_string2672za700za7za7b2884za7, "&#923; (", 8 );
DEFINE_STRING( BGl_string2673z00zzbmemz00, BgL_bgl_string2673za700za7za7b2885za7, "function-ref", 12 );
DEFINE_STRING( BGl_string2674z00zzbmemz00, BgL_bgl_string2674za700za7za7b2886za7, "function-index", 14 );
DEFINE_STRING( BGl_string2593z00zzbmemz00, BgL_bgl_string2593za700za7za7b2887za7, "<exit:([^>]+)>", 14 );
DEFINE_STRING( BGl_string2675z00zzbmemz00, BgL_bgl_string2675za700za7za7b2888za7, "&#955;", 6 );
DEFINE_STRING( BGl_string2594z00zzbmemz00, BgL_bgl_string2594za700za7za7b2889za7, "<exit:[^:]+:([^:]+):([0-9]+)>", 29 );
DEFINE_STRING( BGl_string2676z00zzbmemz00, BgL_bgl_string2676za700za7za7b2890za7, "&#923;", 6 );
DEFINE_STRING( BGl_string2595z00zzbmemz00, BgL_bgl_string2595za700za7za7b2891za7, "<anonymous:([^>]+)>", 19 );
DEFINE_STRING( BGl_string2677z00zzbmemz00, BgL_bgl_string2677za700za7za7b2892za7, "function-ident", 14 );
DEFINE_STRING( BGl_string2596z00zzbmemz00, BgL_bgl_string2596za700za7za7b2893za7, "<anonymous:[^:]+:([^:]+):([0-9]+)>", 34 );
DEFINE_STRING( BGl_string2678z00zzbmemz00, BgL_bgl_string2678za700za7za7b2894za7, "http://~a:~a/~a?fun=~a", 22 );
DEFINE_STRING( BGl_string2597z00zzbmemz00, BgL_bgl_string2597za700za7za7b2895za7, "([^?]+)[?]type=(.+)", 19 );
DEFINE_STRING( BGl_string2679z00zzbmemz00, BgL_bgl_string2679za700za7za7b2896za7, "type-ref", 8 );
DEFINE_STRING( BGl_string2598z00zzbmemz00, BgL_bgl_string2598za700za7za7b2897za7, "([^?]+)[?]fun=(.+)", 18 );
DEFINE_STRING( BGl_string2599z00zzbmemz00, BgL_bgl_string2599za700za7za7b2898za7, "hop-usage", 9 );
DEFINE_STRING( BGl_string2680z00zzbmemz00, BgL_bgl_string2680za700za7za7b2899za7, "type-ident", 10 );
DEFINE_STRING( BGl_string2681z00zzbmemz00, BgL_bgl_string2681za700za7za7b2900za7, "http://~a:~a/~a?type=~a", 23 );
DEFINE_STRING( BGl_string2682z00zzbmemz00, BgL_bgl_string2682za700za7za7b2901za7, "bmem-all", 8 );
DEFINE_STRING( BGl_string2683z00zzbmemz00, BgL_bgl_string2683za700za7za7b2902za7, "Can't find gc monitor", 21 );
DEFINE_STRING( BGl_string2684z00zzbmemz00, BgL_bgl_string2684za700za7za7b2903za7, "Can't find function monitor", 27 );
DEFINE_STRING( BGl_string2685z00zzbmemz00, BgL_bgl_string2685za700za7za7b2904za7, "Can't find type monitor", 23 );
DEFINE_STRING( BGl_string2686z00zzbmemz00, BgL_bgl_string2686za700za7za7b2905za7, "", 0 );
DEFINE_STRING( BGl_string2687z00zzbmemz00, BgL_bgl_string2687za700za7za7b2906za7, "Bglmem", 6 );
DEFINE_STRING( BGl_string2688z00zzbmemz00, BgL_bgl_string2688za700za7za7b2907za7, "Contents", 8 );
DEFINE_STRING( BGl_string2689z00zzbmemz00, BgL_bgl_string2689za700za7za7b2908za7, "contents", 8 );
DEFINE_STRING( BGl_string2690z00zzbmemz00, BgL_bgl_string2690za700za7za7b2909za7, "#functions", 10 );
DEFINE_STRING( BGl_string2691z00zzbmemz00, BgL_bgl_string2691za700za7za7b2910za7, "Functions", 9 );
DEFINE_STRING( BGl_string2692z00zzbmemz00, BgL_bgl_string2692za700za7za7b2911za7, "#types", 6 );
DEFINE_STRING( BGl_string2693z00zzbmemz00, BgL_bgl_string2693za700za7za7b2912za7, "Types", 5 );
DEFINE_STRING( BGl_string2694z00zzbmemz00, BgL_bgl_string2694za700za7za7b2913za7, "#threads", 8 );
DEFINE_STRING( BGl_string2695z00zzbmemz00, BgL_bgl_string2695za700za7za7b2914za7, "Threads", 7 );
DEFINE_STRING( BGl_string2696z00zzbmemz00, BgL_bgl_string2696za700za7za7b2915za7, "#gcs", 4 );
DEFINE_STRING( BGl_string2697z00zzbmemz00, BgL_bgl_string2697za700za7za7b2916za7, "Garbage Collections", 19 );
DEFINE_STRING( BGl_string2698z00zzbmemz00, BgL_bgl_string2698za700za7za7b2917za7, "Legends", 7 );
DEFINE_STRING( BGl_string2699z00zzbmemz00, BgL_bgl_string2699za700za7za7b2918za7, "<@anonymous:2038:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:326@>", 79 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_dynamiczd2csszd2envz00zzbmemz00, BgL_bgl_za762dynamicza7d2css2919z00, BGl_z62dynamiczd2csszb0zzbmemz00, 0L, BUNSPEC, 3 );
BGL_IMPORT obj_t BGl_readzd2envzd2zz__readerz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_pregexp1557z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1558z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1562z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1563z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1564z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1565z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1566z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1567z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1568z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1569z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zzbmemz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}


/* Libraries setup */
static int bigloo_libinit( int argc, char *argv[], char *env[] ) {
return 0; }


long bigloo_abort(long n) { return n; }

int BIGLOO_MAIN(int argc, char *argv[], char *env[]) { 
return _bigloo_main(argc, argv, env, &bigloo_main, &bigloo_libinit, 0);}


/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzbmemz00(long BgL_checksumz00_2296, char * BgL_fromz00_2297)
{
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_2296, ((long)78678107)))), BgL_checksumz00_2296))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzbmemz00))
{ 
BGl_requirezd2initializa7ationz75zzbmemz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zzbmemz00(); 
BGl_libraryzd2moduleszd2initz00zzbmemz00(); 
BGl_cnstzd2initzd2zzbmemz00(); 
BGl_importedzd2moduleszd2initz00zzbmemz00(); 
BGl_objectzd2initzd2zzbmemz00(); 
BGl_genericzd2initzd2zzbmemz00(); 
BGl_methodzd2initzd2zzbmemz00(); 
return 
BGl_toplevelzd2initzd2zzbmemz00();}  else 
{ 
return BUNSPEC;} }  else 
{ 
char * BgL_sz00_2300;
BgL_sz00_2300 = 
"bmem"; 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(BgL_sz00_2300, BgL_fromz00_2297);} } 

}



/* bigloo_main */
BGL_EXPORTED_DEF obj_t bigloo_main(obj_t BgL_argvz00_2302)
{
{ 
BGl_modulezd2initializa7ationz75zzbmemz00(((long)0), "bmem"); 
BGl_bigloozd2initializa7edz12z67zz__paramz00(); 
{ 
obj_t BgL_tmpz00_2324;
BgL_tmpz00_2324 = 
BGl_mainz00zzbmemz00(BgL_argvz00_2302); 
return 
BIGLOO_EXIT(BgL_tmpz00_2324);} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__regexpz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__expander_argsz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "bmem"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_cportz00_2096;
{ /* bmem/bmem.scm 16 */
obj_t BgL_stringz00_2104;
BgL_stringz00_2104 = BGl_string2750z00zzbmemz00; 
{ /* bmem/bmem.scm 16 */
obj_t BgL_startz00_2105;
BgL_startz00_2105 = 
BINT(((long)0)); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_endz00_2106;
BgL_endz00_2106 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2104))); 
{ /* bmem/bmem.scm 16 */

BgL_cportz00_2096 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2104, BgL_startz00_2105, BgL_endz00_2106); } } } } 
{ 
long BgL_iz00_2097;
BgL_iz00_2097 = ((long)81); 
BgL_loopz00_2098:
if(
(BgL_iz00_2097==((long)-1)))
{ /* bmem/bmem.scm 16 */
return BUNSPEC;}  else 
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_arg2752z00_2100;
{ /* bmem/bmem.scm 16 */

{ /* bmem/bmem.scm 16 */
obj_t BgL_locationz00_2102;
BgL_locationz00_2102 = 
BBOOL(((bool_t)0)); 
{ /* bmem/bmem.scm 16 */

BgL_arg2752z00_2100 = 
BGl_readz00zz__readerz00(BgL_cportz00_2096, BgL_locationz00_2102); } } } 
{ /* bmem/bmem.scm 16 */
int BgL_tmpz00_2353;
BgL_tmpz00_2353 = 
(int)(BgL_iz00_2097); 
CNST_TABLE_SET(BgL_tmpz00_2353, BgL_arg2752z00_2100); } } 
{ /* bmem/bmem.scm 16 */
int BgL_auxz00_2103;
BgL_auxz00_2103 = 
(int)(
(BgL_iz00_2097-((long)1))); 
{ 
long BgL_iz00_2358;
BgL_iz00_2358 = 
(long)(BgL_auxz00_2103); 
BgL_iz00_2097 = BgL_iz00_2358; 
goto BgL_loopz00_2098;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2205z00_1041;obj_t BgL_loc2206z00_1042;obj_t BgL_env2207z00_1043;
BgL_name2205z00_1041 = 
CNST_TABLE_REF(((long)0)); 
BgL_loc2206z00_1042 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2207z00_1043 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2207z00_1043, BgL_name2205z00_1041, BgL_loc2206z00_1042); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2204z00_1044;
BgL_aux2204z00_1044 = 
bgl_gc_roots_register(); 
BGL_ENV_POP_TRACE(BgL_env2207z00_1043); 
return BgL_aux2204z00_1044;} } } } 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2209z00_1045;obj_t BgL_loc2210z00_1046;obj_t BgL_env2211z00_1047;
BgL_name2209z00_1045 = 
CNST_TABLE_REF(((long)2)); 
BgL_loc2210z00_1046 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2211z00_1047 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2211z00_1047, BgL_name2209z00_1045, BgL_loc2210z00_1046); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2208z00_1048;
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2165z00_1001;obj_t BgL_loc2166z00_1002;obj_t BgL_env2167z00_1003;
BgL_name2165z00_1001 = 
CNST_TABLE_REF(((long)3)); 
BgL_loc2166z00_1002 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2167z00_1003 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2167z00_1003, BgL_name2165z00_1001, BgL_loc2166z00_1002); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2164z00_1004;
BgL_aux2164z00_1004 = 
BGl_pregexpz00zz__regexpz00(BGl_string2593z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2167z00_1003); 
BGl_pregexp1569z00zzbmemz00 = BgL_aux2164z00_1004; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2169z00_1005;obj_t BgL_loc2170z00_1006;obj_t BgL_env2171z00_1007;
BgL_name2169z00_1005 = 
CNST_TABLE_REF(((long)4)); 
BgL_loc2170z00_1006 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2171z00_1007 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2171z00_1007, BgL_name2169z00_1005, BgL_loc2170z00_1006); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2168z00_1008;
BgL_aux2168z00_1008 = 
BGl_pregexpz00zz__regexpz00(BGl_string2594z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2171z00_1007); 
BGl_pregexp1568z00zzbmemz00 = BgL_aux2168z00_1008; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2173z00_1009;obj_t BgL_loc2174z00_1010;obj_t BgL_env2175z00_1011;
BgL_name2173z00_1009 = 
CNST_TABLE_REF(((long)5)); 
BgL_loc2174z00_1010 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2175z00_1011 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2175z00_1011, BgL_name2173z00_1009, BgL_loc2174z00_1010); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2172z00_1012;
BgL_aux2172z00_1012 = 
BGl_pregexpz00zz__regexpz00(BGl_string2595z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2175z00_1011); 
BGl_pregexp1567z00zzbmemz00 = BgL_aux2172z00_1012; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2177z00_1013;obj_t BgL_loc2178z00_1014;obj_t BgL_env2179z00_1015;
BgL_name2177z00_1013 = 
CNST_TABLE_REF(((long)6)); 
BgL_loc2178z00_1014 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2179z00_1015 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2179z00_1015, BgL_name2177z00_1013, BgL_loc2178z00_1014); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2176z00_1016;
BgL_aux2176z00_1016 = 
BGl_pregexpz00zz__regexpz00(BGl_string2596z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2179z00_1015); 
BGl_pregexp1566z00zzbmemz00 = BgL_aux2176z00_1016; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2181z00_1017;obj_t BgL_loc2182z00_1018;obj_t BgL_env2183z00_1019;
BgL_name2181z00_1017 = 
CNST_TABLE_REF(((long)7)); 
BgL_loc2182z00_1018 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2183z00_1019 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2183z00_1019, BgL_name2181z00_1017, BgL_loc2182z00_1018); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2180z00_1020;
BgL_aux2180z00_1020 = 
BGl_pregexpz00zz__regexpz00(BGl_string2593z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2183z00_1019); 
BGl_pregexp1565z00zzbmemz00 = BgL_aux2180z00_1020; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2185z00_1021;obj_t BgL_loc2186z00_1022;obj_t BgL_env2187z00_1023;
BgL_name2185z00_1021 = 
CNST_TABLE_REF(((long)8)); 
BgL_loc2186z00_1022 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2187z00_1023 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2187z00_1023, BgL_name2185z00_1021, BgL_loc2186z00_1022); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2184z00_1024;
BgL_aux2184z00_1024 = 
BGl_pregexpz00zz__regexpz00(BGl_string2594z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2187z00_1023); 
BGl_pregexp1564z00zzbmemz00 = BgL_aux2184z00_1024; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2189z00_1025;obj_t BgL_loc2190z00_1026;obj_t BgL_env2191z00_1027;
BgL_name2189z00_1025 = 
CNST_TABLE_REF(((long)9)); 
BgL_loc2190z00_1026 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2191z00_1027 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2191z00_1027, BgL_name2189z00_1025, BgL_loc2190z00_1026); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2188z00_1028;
BgL_aux2188z00_1028 = 
BGl_pregexpz00zz__regexpz00(BGl_string2595z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2191z00_1027); 
BGl_pregexp1563z00zzbmemz00 = BgL_aux2188z00_1028; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2193z00_1029;obj_t BgL_loc2194z00_1030;obj_t BgL_env2195z00_1031;
BgL_name2193z00_1029 = 
CNST_TABLE_REF(((long)10)); 
BgL_loc2194z00_1030 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2195z00_1031 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2195z00_1031, BgL_name2193z00_1029, BgL_loc2194z00_1030); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2192z00_1032;
BgL_aux2192z00_1032 = 
BGl_pregexpz00zz__regexpz00(BGl_string2596z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2195z00_1031); 
BGl_pregexp1562z00zzbmemz00 = BgL_aux2192z00_1032; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2197z00_1033;obj_t BgL_loc2198z00_1034;obj_t BgL_env2199z00_1035;
BgL_name2197z00_1033 = 
CNST_TABLE_REF(((long)11)); 
BgL_loc2198z00_1034 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2199z00_1035 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2199z00_1035, BgL_name2197z00_1033, BgL_loc2198z00_1034); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2196z00_1036;
BgL_aux2196z00_1036 = 
BGl_pregexpz00zz__regexpz00(BGl_string2597z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2199z00_1035); 
BGl_pregexp1558z00zzbmemz00 = BgL_aux2196z00_1036; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2201z00_1037;obj_t BgL_loc2202z00_1038;obj_t BgL_env2203z00_1039;
BgL_name2201z00_1037 = 
CNST_TABLE_REF(((long)12)); 
BgL_loc2202z00_1038 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2203z00_1039 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2203z00_1039, BgL_name2201z00_1037, BgL_loc2202z00_1038); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2200z00_1040;
BgL_aux2200z00_1040 = 
BGl_pregexpz00zz__regexpz00(BGl_string2598z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2203z00_1039); 
BGl_pregexp1557z00zzbmemz00 = BgL_aux2200z00_1040; } } } 
BgL_aux2208z00_1048 = 
bgl_debug_set(
(int)(((long)1))); 
BGL_ENV_POP_TRACE(BgL_env2211z00_1047); 
return BgL_aux2208z00_1048;} } } } 

}



/* http-request? */
bool_t BGl_httpzd2requestzf3z21zzbmemz00()
{
{ /* bmem/bmem.scm 46 */
{ /* bmem/bmem.scm 47 */
obj_t BgL_name2217z00_1053;obj_t BgL_loc2218z00_1054;obj_t BgL_env2219z00_1055;
BgL_name2217z00_1053 = 
CNST_TABLE_REF(((long)13)); 
BgL_loc2218z00_1054 = 
CNST_TABLE_REF(((long)14)); 
BgL_env2219z00_1055 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 47 */

BGL_ENV_PUSH_TRACE(BgL_env2219z00_1055, BgL_name2217z00_1053, BgL_loc2218z00_1054); 
{ /* bmem/bmem.scm 47 */
bool_t BgL_aux2216z00_1056;
if(
STRINGP(BGl_za2hostnameza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 47 */
BgL_aux2216z00_1056 = 
STRINGP(BGl_za2portza2z00zzbmem_paramz00); }  else 
{ /* bmem/bmem.scm 47 */
BgL_aux2216z00_1056 = ((bool_t)0); } 
BGL_ENV_POP_TRACE(BgL_env2219z00_1055); 
return BgL_aux2216z00_1056;} } } } 

}



/* usage */
obj_t BGl_usagez00zzbmemz00(obj_t BgL_procz00_4)
{
{ /* bmem/bmem.scm 52 */
{ /* bmem/bmem.scm 53 */
obj_t BgL_name2221z00_1057;obj_t BgL_loc2222z00_1058;obj_t BgL_env2223z00_1059;
BgL_name2221z00_1057 = 
CNST_TABLE_REF(((long)15)); 
BgL_loc2222z00_1058 = 
CNST_TABLE_REF(((long)16)); 
BgL_env2223z00_1059 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 53 */

BGL_ENV_PUSH_TRACE(BgL_env2223z00_1059, BgL_name2221z00_1057, BgL_loc2222z00_1058); 
{ /* bmem/bmem.scm 53 */
obj_t BgL_aux2220z00_1060;
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 58 */
obj_t BgL_arg1619z00_43;
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1624z00_44;
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_new1287z00_45;
{ /* bmem/bmem.scm 58 */
obj_t BgL_env1285z00_50;
BgL_env1285z00_50 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 58 */

{ 
long BgL_auxz00_2448;
{ /* bmem/bmem.scm 58 */
obj_t BgL_classz00_1119;
BgL_classz00_1119 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_2448 = 
BGL_CLASS_INDEX(BgL_classz00_1119); } 
bmem_set_allocation_type( BgL_auxz00_2448, 0 ); } 
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_new1284z00_52;
BgL_new1284z00_52 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 58 */
long BgL_arg1631z00_53;
BgL_arg1631z00_53 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1284z00_52), BgL_arg1631z00_53); } 
BgL_new1287z00_45 = BgL_new1284z00_52; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1287z00_45)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1287z00_45)))->BgL_classz00)=((obj_t)BGl_string2599z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1287z00_45)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1287z00_45)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1287z00_45))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_2465;
{ /* bmem/bmem.scm 62 */
obj_t BgL_arg1626z00_46;
{ /* bmem/bmem.scm 62 */
obj_t BgL_zc3z04anonymousza31628za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_1699;
BgL_zc3z04anonymousza31628za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_1699 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31628za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31628za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_1699, 
(int)(((long)0)), BgL_procz00_4); 
BgL_arg1626z00_46 = 
BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3z04anonymousza31628za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_1699); } 
BgL_auxz00_2465 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_arg1626z00_46); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1287z00_45))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_2465),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1287z00_45))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1624z00_44 = BgL_new1287z00_45; } 
BgL_arg1619z00_43 = 
BGl_htmlzd2pluginzd2usagez00zzhtmlz00(BFALSE, BGl_string2600z00zzbmemz00, BGl_string2601z00zzbmemz00, 
((BgL_z52htmlzd2elementz80_bglt)BgL_arg1624z00_44)); } 
{ /* bmem/bmem.scm 54 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_2477;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1619z00_43, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 62 */
BgL_auxz00_2477 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1619z00_43)
; }  else 
{ 
obj_t BgL_auxz00_2481;
BgL_auxz00_2481 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)2679)), BGl_string2603z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_arg1619z00_43); 
FAILURE(BgL_auxz00_2481,BFALSE,BFALSE);} 
BgL_aux2220z00_1060 = 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_2477); } }  else 
{ /* bmem/bmem.scm 53 */
{ /* bmem/bmem.scm 64 */
obj_t BgL_port1498z00_54;
{ /* bmem/bmem.scm 64 */
obj_t BgL_tmpz00_2486;
BgL_tmpz00_2486 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1498z00_54 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2486); } 
bgl_display_string(BGl_string2605z00zzbmemz00, BgL_port1498z00_54); 
bgl_display_char(((unsigned char)10), BgL_port1498z00_54); } 
{ /* bmem/bmem.scm 65 */
obj_t BgL_funz00_1785;
if(
PROCEDUREP(BgL_procz00_4))
{ /* bmem/bmem.scm 65 */
BgL_funz00_1785 = BgL_procz00_4; }  else 
{ 
obj_t BgL_auxz00_2493;
BgL_auxz00_2493 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)2746)), BGl_string2603z00zzbmemz00, BGl_string2606z00zzbmemz00, BgL_procz00_4); 
FAILURE(BgL_auxz00_2493,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1785, ((long)1)))
{ /* bmem/bmem.scm 65 */
BgL_aux2220z00_1060 = 
PROCEDURE_ENTRY(BgL_funz00_1785)(BgL_procz00_4, BFALSE, BEOA); }  else 
{ /* bmem/bmem.scm 65 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2607z00zzbmemz00, 
CNST_TABLE_REF(((long)18)), BgL_funz00_1785, BGl_string2602z00zzbmemz00, 
BINT(((long)2746))); 
{ 
obj_t BgL_auxz00_2510;obj_t BgL_auxz00_2508;obj_t BgL_auxz00_2506;
BgL_auxz00_2510 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2508 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2506 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_2506,BgL_auxz00_2508,BgL_auxz00_2510);} } } } 
BGL_ENV_POP_TRACE(BgL_env2223z00_1059); 
return BgL_aux2220z00_1060;} } } } 

}



/* &<@anonymous:1628:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:60@> */
obj_t BGl_z62zc3z04anonymousza31628za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00(obj_t BgL_envz00_1700)
{
{ /* bmem/bmem.scm 61 */
{ /* bmem/bmem.scm 62 */
obj_t BgL_procz00_1701;
BgL_procz00_1701 = 
PROCEDURE_REF(BgL_envz00_1700, 
(int)(((long)0))); 
{ /* bmem/bmem.scm 62 */
obj_t BgL_funz00_2108;
if(
PROCEDUREP(BgL_procz00_1701))
{ /* bmem/bmem.scm 62 */
BgL_funz00_2108 = BgL_procz00_1701; }  else 
{ 
obj_t BgL_auxz00_2518;
BgL_auxz00_2518 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)2666)), BGl_string2608z00zzbmemz00, BGl_string2606z00zzbmemz00, BgL_procz00_1701); 
FAILURE(BgL_auxz00_2518,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_2108, ((long)1)))
{ /* bmem/bmem.scm 62 */
return 
PROCEDURE_ENTRY(BgL_funz00_2108)(BgL_procz00_1701, BFALSE, BEOA);}  else 
{ /* bmem/bmem.scm 62 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2609z00zzbmemz00, 
CNST_TABLE_REF(((long)18)), BgL_funz00_2108, BGl_string2602z00zzbmemz00, 
BINT(((long)2666))); 
{ 
obj_t BgL_auxz00_2535;obj_t BgL_auxz00_2533;obj_t BgL_auxz00_2531;
BgL_auxz00_2535 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2533 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2531 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_2531,BgL_auxz00_2533,BgL_auxz00_2535);} } } } } 

}



/* parse-cmdline! */
obj_t BGl_parsezd2cmdlinez12zc0zzbmemz00(obj_t BgL_argvz00_5)
{
{ /* bmem/bmem.scm 70 */
{ /* bmem/bmem.scm 72 */
obj_t BgL_name2225z00_1061;obj_t BgL_loc2226z00_1062;obj_t BgL_env2227z00_1063;
BgL_name2225z00_1061 = 
CNST_TABLE_REF(((long)20)); 
BgL_loc2226z00_1062 = 
CNST_TABLE_REF(((long)21)); 
BgL_env2227z00_1063 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 72 */

BGL_ENV_PUSH_TRACE(BgL_env2227z00_1063, BgL_name2225z00_1061, BgL_loc2226z00_1062); 
{ /* bmem/bmem.scm 72 */
obj_t BgL_aux2224z00_1064;
BGl_za2uriza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2610z00zzbmemz00); 
BGl_za2hostnameza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2611z00zzbmemz00); 
BGl_za2portza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2612z00zzbmemz00); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_55;
BgL_argszd2parsezd2usagez00_55 = 
BGl_argszd2parsezd2usagez00zz__expander_argsz00(
CNST_TABLE_REF(((long)22))); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_pza2za2_56;
{ /* bmem/bmem.scm 76 */
obj_t BgL_list1795z00_277;
BgL_list1795z00_277 = 
MAKE_YOUNG_PAIR(BGl_proc2613z00zzbmemz00, BNIL); 
BgL_pza2za2_56 = BgL_list1795z00_277; } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_aza2za2_57;
BgL_aza2za2_57 = 
CDR(BgL_argvz00_5); 
{ /* bmem/bmem.scm 76 */

BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2614z00zzbmemz00, BgL_pza2za2_56); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_zc3z04anonymousza31644za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1709;
BgL_zc3z04anonymousza31644za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1709 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31644za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1709, 
(int)(((long)0)), BgL_argszd2parsezd2usagez00_55); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31644za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1709, BgL_pza2za2_56); } 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2615z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2616z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2617z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2618z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2619z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2620z00zzbmemz00, BgL_pza2za2_56); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1702;
BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1702 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31781za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1702, 
(int)(((long)0)), BgL_argszd2parsezd2usagez00_55); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_1702, BgL_pza2za2_56); } 
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_aza2za2_57))
{ 
obj_t BgL_aza2za2_259;obj_t BgL_vz00_260;
BgL_aza2za2_259 = BgL_aza2za2_57; 
BgL_vz00_260 = BFALSE; 
BgL_zc3z04anonymousza31787za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_261:
{ 
obj_t BgL_pza2za2_263;
BgL_pza2za2_263 = BgL_pza2za2_56; 
BgL_zc3z04anonymousza31788za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_264:
{ /* bmem/bmem.scm 76 */
obj_t BgL_actionz00_265;
{ /* bmem/bmem.scm 76 */
obj_t BgL_fun1793z00_273;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_1327;
if(
PAIRP(BgL_pza2za2_263))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_1327 = BgL_pza2za2_263; }  else 
{ 
obj_t BgL_auxz00_2572;
BgL_auxz00_2572 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2621z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_pza2za2_263); 
FAILURE(BgL_auxz00_2572,BFALSE,BFALSE);} 
BgL_fun1793z00_273 = 
CAR(BgL_pairz00_1327); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_funz00_1797;
if(
PROCEDUREP(BgL_fun1793z00_273))
{ /* bmem/bmem.scm 76 */
BgL_funz00_1797 = BgL_fun1793z00_273; }  else 
{ 
obj_t BgL_auxz00_2579;
BgL_auxz00_2579 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2621z00zzbmemz00, BGl_string2606z00zzbmemz00, BgL_fun1793z00_273); 
FAILURE(BgL_auxz00_2579,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1797, ((long)2)))
{ /* bmem/bmem.scm 76 */
BgL_actionz00_265 = 
PROCEDURE_ENTRY(BgL_funz00_1797)(BgL_fun1793z00_273, BgL_aza2za2_259, BgL_vz00_260, BEOA); }  else 
{ /* bmem/bmem.scm 76 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2623z00zzbmemz00, 
CNST_TABLE_REF(((long)23)), BgL_funz00_1797, BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); 
{ 
obj_t BgL_auxz00_2597;obj_t BgL_auxz00_2595;obj_t BgL_auxz00_2593;
BgL_auxz00_2597 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2595 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2593 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_2593,BgL_auxz00_2595,BgL_auxz00_2597);} } } } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_naza2za2_266;obj_t BgL_nvz00_267;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2600;
BgL_tmpz00_2600 = 
(int)(((long)1)); 
BgL_naza2za2_266 = 
BGL_MVALUES_VAL(BgL_tmpz00_2600); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2603;
BgL_tmpz00_2603 = 
(int)(((long)2)); 
BgL_nvz00_267 = 
BGL_MVALUES_VAL(BgL_tmpz00_2603); } 
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)24))))
{ 
obj_t BgL_vz00_2610;obj_t BgL_aza2za2_2609;
BgL_aza2za2_2609 = BgL_naza2za2_266; 
BgL_vz00_2610 = BgL_nvz00_267; 
BgL_vz00_260 = BgL_vz00_2610; 
BgL_aza2za2_259 = BgL_aza2za2_2609; 
goto BgL_zc3z04anonymousza31787za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_261;}  else 
{ /* bmem/bmem.scm 76 */
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)25))))
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1791z00_271;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_1330;
if(
PAIRP(BgL_pza2za2_263))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_1330 = BgL_pza2za2_263; }  else 
{ 
obj_t BgL_auxz00_2616;
BgL_auxz00_2616 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2621z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_pza2za2_263); 
FAILURE(BgL_auxz00_2616,BFALSE,BFALSE);} 
BgL_arg1791z00_271 = 
CDR(BgL_pairz00_1330); } 
{ 
obj_t BgL_pza2za2_2621;
BgL_pza2za2_2621 = BgL_arg1791z00_271; 
BgL_pza2za2_263 = BgL_pza2za2_2621; 
goto BgL_zc3z04anonymousza31788za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_264;} }  else 
{ /* bmem/bmem.scm 76 */
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)26))))
{ /* bmem/bmem.scm 76 */
BgL_aux2224z00_1064 = BgL_nvz00_267; }  else 
{ /* bmem/bmem.scm 76 */
BgL_aux2224z00_1064 = BUNSPEC; } } } } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_aux2224z00_1064 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string2624z00zzbmemz00, BgL_aza2za2_57, BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } } } } } 
BGL_ENV_POP_TRACE(BgL_env2227z00_1063); 
return BgL_aux2224z00_1064;} } } } 

}



/* &<@anonymous:1781:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31781za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1712, obj_t BgL_g1310z00_1714, obj_t BgL_g1311z00_1715)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_1713;
BgL_argszd2parsezd2usagez00_1713 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1712, 
(int)(((long)0)))); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2938z00_2632;
if(
PAIRP(BgL_g1310z00_1714))
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1785z00_2109;
BgL_arg1785z00_2109 = 
CAR(BgL_g1310z00_1714); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2110;
if(
STRINGP(BgL_arg1785z00_2109))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2110 = BgL_arg1785z00_2109; }  else 
{ 
obj_t BgL_auxz00_2638;
BgL_auxz00_2638 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2625z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1785z00_2109); 
FAILURE(BgL_auxz00_2638,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2110)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2112;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2647;char * BgL_tmpz00_2645;
BgL_auxz00_2647 = 
BSTRING_TO_STRING(BgL_string2z00_2110); 
BgL_tmpz00_2645 = 
BSTRING_TO_STRING(BGl_string2627z00zzbmemz00); 
BgL_arg1282z00_2112 = 
memcmp(BgL_tmpz00_2645, BgL_auxz00_2647, ((long)6)); } 
BgL_test2938z00_2632 = 
(
(long)(BgL_arg1282z00_2112)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2938z00_2632 = ((bool_t)0)
; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2938z00_2632 = ((bool_t)0)
; } 
if(BgL_test2938z00_2632)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2113;
BgL_thezd2remainingzd2argsz00_2113 = 
CDR(BgL_g1310z00_1714); 
{ /* bmem/bmem.scm 78 */
obj_t BgL_nvz00_2114;
BGl_usagez00zzbmemz00(BgL_argszd2parsezd2usagez00_1713); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2213z00_2115;obj_t BgL_loc2214z00_2116;obj_t BgL_env2215z00_2117;
BgL_name2213z00_2115 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2214z00_2116 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2215z00_2117 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2215z00_2117, BgL_name2213z00_2115, BgL_loc2214z00_2116); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2212z00_2118;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1617z00_2119;
BgL_list1617z00_2119 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2212z00_2118 = 
BGl_exitz00zz__errorz00(BgL_list1617z00_2119); } 
BGL_ENV_POP_TRACE(BgL_env2215z00_2117); 
BgL_nvz00_2114 = BgL_aux2212z00_2118; } } } 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1551z00_2120;
BgL_val0_1551z00_2120 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2663;
BgL_tmpz00_2663 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2663); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2666;
BgL_tmpz00_2666 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2666, BgL_thezd2remainingzd2argsz00_2113); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2669;
BgL_tmpz00_2669 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2669, BgL_nvz00_2114); } 
return BgL_val0_1551z00_2120;} } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1554z00_2121;
BgL_val0_1554z00_2121 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2673;
BgL_tmpz00_2673 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2673); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2676;
BgL_tmpz00_2676 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2676, BgL_g1310z00_1714); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2679;
BgL_tmpz00_2679 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2679, BgL_g1311z00_1715); } 
return BgL_val0_1554z00_2121;} } } } 

}



/* &<@anonymous:1761:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31761za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1716, obj_t BgL_g1307z00_1717, obj_t BgL_g1308z00_1718)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2942z00_2682;
if(
PAIRP(BgL_g1307z00_1717))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1309z00_2122;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1779z00_2123;
BgL_arg1779z00_2123 = 
CAR(BgL_g1307z00_1717); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2124;
if(
STRINGP(BgL_arg1779z00_2123))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2124 = BgL_arg1779z00_2123; }  else 
{ 
obj_t BgL_auxz00_2688;
BgL_auxz00_2688 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2628z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1779z00_2123); 
FAILURE(BgL_auxz00_2688,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2124)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2126;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2697;char * BgL_tmpz00_2695;
BgL_auxz00_2697 = 
BSTRING_TO_STRING(BgL_string2z00_2124); 
BgL_tmpz00_2695 = 
BSTRING_TO_STRING(BGl_string2629z00zzbmemz00); 
BgL_arg1282z00_2126 = 
memcmp(BgL_tmpz00_2695, BgL_auxz00_2697, ((long)2)); } 
BgL__ortest_1309z00_2122 = 
(
(long)(BgL_arg1282z00_2126)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1309z00_2122 = ((bool_t)0); } } } 
if(BgL__ortest_1309z00_2122)
{ /* bmem/bmem.scm 76 */
BgL_test2942z00_2682 = BgL__ortest_1309z00_2122
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1778z00_2127;
BgL_arg1778z00_2127 = 
CAR(BgL_g1307z00_1717); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2128;
if(
STRINGP(BgL_arg1778z00_2127))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2128 = BgL_arg1778z00_2127; }  else 
{ 
obj_t BgL_auxz00_2706;
BgL_auxz00_2706 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2628z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1778z00_2127); 
FAILURE(BgL_auxz00_2706,BFALSE,BFALSE);} 
if(
(((long)9)==
STRING_LENGTH(BgL_string2z00_2128)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2130;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2715;char * BgL_tmpz00_2713;
BgL_auxz00_2715 = 
BSTRING_TO_STRING(BgL_string2z00_2128); 
BgL_tmpz00_2713 = 
BSTRING_TO_STRING(BGl_string2630z00zzbmemz00); 
BgL_arg1282z00_2130 = 
memcmp(BgL_tmpz00_2713, BgL_auxz00_2715, ((long)9)); } 
BgL_test2942z00_2682 = 
(
(long)(BgL_arg1282z00_2130)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2942z00_2682 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2942z00_2682 = ((bool_t)0)
; } 
if(BgL_test2942z00_2682)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2131;
BgL_thezd2remainingzd2argsz00_2131 = 
CDR(BgL_g1307z00_1717); 
{ /* bmem/bmem.scm 83 */
obj_t BgL_nvz00_2132;
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 82 */
obj_t BgL_arg1777z00_2133;
{ /* bmem/bmem.scm 82 */
obj_t BgL_auxz00_2730;obj_t BgL_auxz00_2723;
{ /* bmem/bmem.scm 82 */
obj_t BgL_aux2327z00_2135;
BgL_aux2327z00_2135 = BGl_za2bmemzd2versionza2zd2zzbmem_paramz00; 
if(
STRINGP(BgL_aux2327z00_2135))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_2730 = BgL_aux2327z00_2135
; }  else 
{ 
obj_t BgL_auxz00_2733;
BgL_auxz00_2733 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3434)), BGl_string2628z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2327z00_2135); 
FAILURE(BgL_auxz00_2733,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 82 */
obj_t BgL_aux2325z00_2134;
BgL_aux2325z00_2134 = BGl_za2bmemza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2325z00_2134))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_2723 = BgL_aux2325z00_2134
; }  else 
{ 
obj_t BgL_auxz00_2726;
BgL_auxz00_2726 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3427)), BGl_string2628z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2325z00_2134); 
FAILURE(BgL_auxz00_2726,BFALSE,BFALSE);} } 
BgL_arg1777z00_2133 = 
BGl_htmlzd2pluginzd2versionz00zzhtmlz00(BFALSE, BgL_auxz00_2723, BgL_auxz00_2730); } 
{ /* bmem/bmem.scm 82 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_2738;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1777z00_2133, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_2738 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1777z00_2133)
; }  else 
{ 
obj_t BgL_auxz00_2742;
BgL_auxz00_2742 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3448)), BGl_string2628z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_arg1777z00_2133); 
FAILURE(BgL_auxz00_2742,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_2738); } }  else 
{ /* bmem/bmem.scm 83 */
obj_t BgL_port1544z00_2136;
{ /* bmem/bmem.scm 83 */
obj_t BgL_tmpz00_2747;
BgL_tmpz00_2747 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_port1544z00_2136 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_2747); } 
bgl_display_obj(BGl_za2bmemza2z00zzbmem_paramz00, BgL_port1544z00_2136); 
bgl_display_string(BGl_string2631z00zzbmemz00, BgL_port1544z00_2136); 
bgl_display_obj(BGl_za2bmemzd2versionza2zd2zzbmem_paramz00, BgL_port1544z00_2136); 
bgl_display_char(((unsigned char)10), BgL_port1544z00_2136); } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2213z00_2137;obj_t BgL_loc2214z00_2138;obj_t BgL_env2215z00_2139;
BgL_name2213z00_2137 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2214z00_2138 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2215z00_2139 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2215z00_2139, BgL_name2213z00_2137, BgL_loc2214z00_2138); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2212z00_2140;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1617z00_2141;
BgL_list1617z00_2141 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2212z00_2140 = 
BGl_exitz00zz__errorz00(BgL_list1617z00_2141); } 
BGL_ENV_POP_TRACE(BgL_env2215z00_2139); 
BgL_nvz00_2132 = BgL_aux2212z00_2140; } } } 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1545z00_2142;
BgL_val0_1545z00_2142 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2763;
BgL_tmpz00_2763 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2763); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2766;
BgL_tmpz00_2766 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2766, BgL_thezd2remainingzd2argsz00_2131); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2769;
BgL_tmpz00_2769 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2769, BgL_nvz00_2132); } 
return BgL_val0_1545z00_2142;} } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1548z00_2143;
BgL_val0_1548z00_2143 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2773;
BgL_tmpz00_2773 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2773); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2776;
BgL_tmpz00_2776 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2776, BgL_g1307z00_1717); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2779;
BgL_tmpz00_2779 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2779, BgL_g1308z00_1718); } 
return BgL_val0_1548z00_2143;} } } 

}



/* &<@anonymous:1731:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31731za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1719, obj_t BgL_g1304z00_1720, obj_t BgL_g1305z00_1721)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2953z00_2782;
if(
PAIRP(BgL_g1304z00_1720))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1306z00_2144;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1748z00_2145;
BgL_arg1748z00_2145 = 
CAR(BgL_g1304z00_1720); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2146;
if(
STRINGP(BgL_arg1748z00_2145))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2146 = BgL_arg1748z00_2145; }  else 
{ 
obj_t BgL_auxz00_2788;
BgL_auxz00_2788 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2632z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1748z00_2145); 
FAILURE(BgL_auxz00_2788,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2146)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2148;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2797;char * BgL_tmpz00_2795;
BgL_auxz00_2797 = 
BSTRING_TO_STRING(BgL_string2z00_2146); 
BgL_tmpz00_2795 = 
BSTRING_TO_STRING(BGl_string2633z00zzbmemz00); 
BgL_arg1282z00_2148 = 
memcmp(BgL_tmpz00_2795, BgL_auxz00_2797, ((long)2)); } 
BgL__ortest_1306z00_2144 = 
(
(long)(BgL_arg1282z00_2148)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1306z00_2144 = ((bool_t)0); } } } 
if(BgL__ortest_1306z00_2144)
{ /* bmem/bmem.scm 76 */
BgL_test2953z00_2782 = BgL__ortest_1306z00_2144
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1741z00_2149;
BgL_arg1741z00_2149 = 
CAR(BgL_g1304z00_1720); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2150;
if(
STRINGP(BgL_arg1741z00_2149))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2150 = BgL_arg1741z00_2149; }  else 
{ 
obj_t BgL_auxz00_2806;
BgL_auxz00_2806 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2632z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1741z00_2149); 
FAILURE(BgL_auxz00_2806,BFALSE,BFALSE);} 
if(
(((long)8)==
STRING_LENGTH(BgL_string2z00_2150)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2152;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2815;char * BgL_tmpz00_2813;
BgL_auxz00_2815 = 
BSTRING_TO_STRING(BgL_string2z00_2150); 
BgL_tmpz00_2813 = 
BSTRING_TO_STRING(BGl_string2634z00zzbmemz00); 
BgL_arg1282z00_2152 = 
memcmp(BgL_tmpz00_2813, BgL_auxz00_2815, ((long)8)); } 
BgL_test2953z00_2782 = 
(
(long)(BgL_arg1282z00_2152)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2953z00_2782 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2953z00_2782 = ((bool_t)0)
; } 
if(BgL_test2953z00_2782)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2153;
BgL_thezd2remainingzd2argsz00_2153 = 
CDR(BgL_g1304z00_1720); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_foutz00_2154;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2153))
{ /* bmem/bmem.scm 76 */
BgL_foutz00_2154 = 
CAR(BgL_thezd2remainingzd2argsz00_2153); }  else 
{ /* bmem/bmem.scm 76 */
BgL_foutz00_2154 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string2635z00zzbmemz00, 
CNST_TABLE_REF(((long)31)), BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2155;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2156;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2153))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2156 = BgL_thezd2remainingzd2argsz00_2153; }  else 
{ 
obj_t BgL_auxz00_2830;
BgL_auxz00_2830 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2632z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2153); 
FAILURE(BgL_auxz00_2830,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2155 = 
CDR(BgL_pairz00_2156); } 
{ /* bmem/bmem.scm 86 */
obj_t BgL_nvz00_2157;
BgL_nvz00_2157 = ( 
BGl_za2foutza2z00zzbmem_paramz00 = BgL_foutz00_2154, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1538z00_2158;
BgL_val0_1538z00_2158 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2836;
BgL_tmpz00_2836 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2836); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2839;
BgL_tmpz00_2839 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2839, BgL_thezd2remainingzd2argsz00_2155); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2842;
BgL_tmpz00_2842 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2842, BgL_nvz00_2157); } 
return BgL_val0_1538z00_2158;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1541z00_2159;
BgL_val0_1541z00_2159 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2846;
BgL_tmpz00_2846 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2846); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2849;
BgL_tmpz00_2849 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2849, BgL_g1304z00_1720); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2852;
BgL_tmpz00_2852 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2852, BgL_g1305z00_1721); } 
return BgL_val0_1541z00_2159;} } } 

}



/* &<@anonymous:1714:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31714za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1722, obj_t BgL_g1301z00_1723, obj_t BgL_g1302z00_1724)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2962z00_2855;
if(
PAIRP(BgL_g1301z00_1723))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1303z00_2160;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1727z00_2161;
BgL_arg1727z00_2161 = 
CAR(BgL_g1301z00_1723); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2162;
if(
STRINGP(BgL_arg1727z00_2161))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2162 = BgL_arg1727z00_2161; }  else 
{ 
obj_t BgL_auxz00_2861;
BgL_auxz00_2861 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2636z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1727z00_2161); 
FAILURE(BgL_auxz00_2861,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2162)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2164;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2870;char * BgL_tmpz00_2868;
BgL_auxz00_2870 = 
BSTRING_TO_STRING(BgL_string2z00_2162); 
BgL_tmpz00_2868 = 
BSTRING_TO_STRING(BGl_string2637z00zzbmemz00); 
BgL_arg1282z00_2164 = 
memcmp(BgL_tmpz00_2868, BgL_auxz00_2870, ((long)2)); } 
BgL__ortest_1303z00_2160 = 
(
(long)(BgL_arg1282z00_2164)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1303z00_2160 = ((bool_t)0); } } } 
if(BgL__ortest_1303z00_2160)
{ /* bmem/bmem.scm 76 */
BgL_test2962z00_2855 = BgL__ortest_1303z00_2160
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1726z00_2165;
BgL_arg1726z00_2165 = 
CAR(BgL_g1301z00_1723); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2166;
if(
STRINGP(BgL_arg1726z00_2165))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2166 = BgL_arg1726z00_2165; }  else 
{ 
obj_t BgL_auxz00_2879;
BgL_auxz00_2879 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2636z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1726z00_2165); 
FAILURE(BgL_auxz00_2879,BFALSE,BFALSE);} 
if(
(((long)10)==
STRING_LENGTH(BgL_string2z00_2166)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2168;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2888;char * BgL_tmpz00_2886;
BgL_auxz00_2888 = 
BSTRING_TO_STRING(BgL_string2z00_2166); 
BgL_tmpz00_2886 = 
BSTRING_TO_STRING(BGl_string2638z00zzbmemz00); 
BgL_arg1282z00_2168 = 
memcmp(BgL_tmpz00_2886, BgL_auxz00_2888, ((long)10)); } 
BgL_test2962z00_2855 = 
(
(long)(BgL_arg1282z00_2168)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2962z00_2855 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2962z00_2855 = ((bool_t)0)
; } 
if(BgL_test2962z00_2855)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2169;
BgL_thezd2remainingzd2argsz00_2169 = 
CDR(BgL_g1301z00_1723); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_functionz00_2170;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2169))
{ /* bmem/bmem.scm 76 */
BgL_functionz00_2170 = 
CAR(BgL_thezd2remainingzd2argsz00_2169); }  else 
{ /* bmem/bmem.scm 76 */
BgL_functionz00_2170 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string2635z00zzbmemz00, 
CNST_TABLE_REF(((long)33)), BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2171;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2172;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2169))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2172 = BgL_thezd2remainingzd2argsz00_2169; }  else 
{ 
obj_t BgL_auxz00_2903;
BgL_auxz00_2903 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2636z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2169); 
FAILURE(BgL_auxz00_2903,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2171 = 
CDR(BgL_pairz00_2172); } 
{ /* bmem/bmem.scm 88 */
obj_t BgL_nvz00_2173;
BgL_nvz00_2173 = ( 
BGl_za2functionza2z00zzbmem_paramz00 = BgL_functionz00_2170, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1532z00_2174;
BgL_val0_1532z00_2174 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2909;
BgL_tmpz00_2909 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2909); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2912;
BgL_tmpz00_2912 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2912, BgL_thezd2remainingzd2argsz00_2171); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2915;
BgL_tmpz00_2915 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2915, BgL_nvz00_2173); } 
return BgL_val0_1532z00_2174;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1535z00_2175;
BgL_val0_1535z00_2175 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2919;
BgL_tmpz00_2919 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2919); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2922;
BgL_tmpz00_2922 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2922, BgL_g1301z00_1723); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2925;
BgL_tmpz00_2925 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2925, BgL_g1302z00_1724); } 
return BgL_val0_1535z00_2175;} } } 

}



/* &<@anonymous:1699:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31699za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1725, obj_t BgL_g1298z00_1726, obj_t BgL_g1299z00_1727)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2971z00_2928;
if(
PAIRP(BgL_g1298z00_1726))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1300z00_2176;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1712z00_2177;
BgL_arg1712z00_2177 = 
CAR(BgL_g1298z00_1726); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2178;
if(
STRINGP(BgL_arg1712z00_2177))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2178 = BgL_arg1712z00_2177; }  else 
{ 
obj_t BgL_auxz00_2934;
BgL_auxz00_2934 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2639z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1712z00_2177); 
FAILURE(BgL_auxz00_2934,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2178)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2180;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2943;char * BgL_tmpz00_2941;
BgL_auxz00_2943 = 
BSTRING_TO_STRING(BgL_string2z00_2178); 
BgL_tmpz00_2941 = 
BSTRING_TO_STRING(BGl_string2640z00zzbmemz00); 
BgL_arg1282z00_2180 = 
memcmp(BgL_tmpz00_2941, BgL_auxz00_2943, ((long)2)); } 
BgL__ortest_1300z00_2176 = 
(
(long)(BgL_arg1282z00_2180)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1300z00_2176 = ((bool_t)0); } } } 
if(BgL__ortest_1300z00_2176)
{ /* bmem/bmem.scm 76 */
BgL_test2971z00_2928 = BgL__ortest_1300z00_2176
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1706z00_2181;
BgL_arg1706z00_2181 = 
CAR(BgL_g1298z00_1726); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2182;
if(
STRINGP(BgL_arg1706z00_2181))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2182 = BgL_arg1706z00_2181; }  else 
{ 
obj_t BgL_auxz00_2952;
BgL_auxz00_2952 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2639z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1706z00_2181); 
FAILURE(BgL_auxz00_2952,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2182)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2184;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_2961;char * BgL_tmpz00_2959;
BgL_auxz00_2961 = 
BSTRING_TO_STRING(BgL_string2z00_2182); 
BgL_tmpz00_2959 = 
BSTRING_TO_STRING(BGl_string2641z00zzbmemz00); 
BgL_arg1282z00_2184 = 
memcmp(BgL_tmpz00_2959, BgL_auxz00_2961, ((long)6)); } 
BgL_test2971z00_2928 = 
(
(long)(BgL_arg1282z00_2184)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2971z00_2928 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2971z00_2928 = ((bool_t)0)
; } 
if(BgL_test2971z00_2928)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2185;
BgL_thezd2remainingzd2argsz00_2185 = 
CDR(BgL_g1298z00_1726); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_typez00_2186;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2185))
{ /* bmem/bmem.scm 76 */
BgL_typez00_2186 = 
CAR(BgL_thezd2remainingzd2argsz00_2185); }  else 
{ /* bmem/bmem.scm 76 */
BgL_typez00_2186 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string2635z00zzbmemz00, 
CNST_TABLE_REF(((long)35)), BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2187;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2188;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2185))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2188 = BgL_thezd2remainingzd2argsz00_2185; }  else 
{ 
obj_t BgL_auxz00_2976;
BgL_auxz00_2976 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2639z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2185); 
FAILURE(BgL_auxz00_2976,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2187 = 
CDR(BgL_pairz00_2188); } 
{ /* bmem/bmem.scm 90 */
obj_t BgL_nvz00_2189;
BgL_nvz00_2189 = ( 
BGl_za2typeza2z00zzbmem_paramz00 = BgL_typez00_2186, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1526z00_2190;
BgL_val0_1526z00_2190 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2982;
BgL_tmpz00_2982 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2982); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2985;
BgL_tmpz00_2985 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2985, BgL_thezd2remainingzd2argsz00_2187); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2988;
BgL_tmpz00_2988 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2988, BgL_nvz00_2189); } 
return BgL_val0_1526z00_2190;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1529z00_2191;
BgL_val0_1529z00_2191 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2992;
BgL_tmpz00_2992 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2992); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2995;
BgL_tmpz00_2995 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2995, BgL_g1298z00_1726); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_2998;
BgL_tmpz00_2998 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2998, BgL_g1299z00_1727); } 
return BgL_val0_1529z00_2191;} } } 

}



/* &<@anonymous:1678:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31678za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1728, obj_t BgL_g1295z00_1729, obj_t BgL_g1296z00_1730)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2980z00_3001;
if(
PAIRP(BgL_g1295z00_1729))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1297z00_2192;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1697z00_2193;
BgL_arg1697z00_2193 = 
CAR(BgL_g1295z00_1729); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2194;
if(
STRINGP(BgL_arg1697z00_2193))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2194 = BgL_arg1697z00_2193; }  else 
{ 
obj_t BgL_auxz00_3007;
BgL_auxz00_3007 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2642z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1697z00_2193); 
FAILURE(BgL_auxz00_3007,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2194)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2196;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3016;char * BgL_tmpz00_3014;
BgL_auxz00_3016 = 
BSTRING_TO_STRING(BgL_string2z00_2194); 
BgL_tmpz00_3014 = 
BSTRING_TO_STRING(BGl_string2643z00zzbmemz00); 
BgL_arg1282z00_2196 = 
memcmp(BgL_tmpz00_3014, BgL_auxz00_3016, ((long)2)); } 
BgL__ortest_1297z00_2192 = 
(
(long)(BgL_arg1282z00_2196)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1297z00_2192 = ((bool_t)0); } } } 
if(BgL__ortest_1297z00_2192)
{ /* bmem/bmem.scm 76 */
BgL_test2980z00_3001 = BgL__ortest_1297z00_2192
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1696z00_2197;
BgL_arg1696z00_2197 = 
CAR(BgL_g1295z00_1729); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2198;
if(
STRINGP(BgL_arg1696z00_2197))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2198 = BgL_arg1696z00_2197; }  else 
{ 
obj_t BgL_auxz00_3025;
BgL_auxz00_3025 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2642z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1696z00_2197); 
FAILURE(BgL_auxz00_3025,BFALSE,BFALSE);} 
if(
(((long)10)==
STRING_LENGTH(BgL_string2z00_2198)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2200;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3034;char * BgL_tmpz00_3032;
BgL_auxz00_3034 = 
BSTRING_TO_STRING(BgL_string2z00_2198); 
BgL_tmpz00_3032 = 
BSTRING_TO_STRING(BGl_string2644z00zzbmemz00); 
BgL_arg1282z00_2200 = 
memcmp(BgL_tmpz00_3032, BgL_auxz00_3034, ((long)10)); } 
BgL_test2980z00_3001 = 
(
(long)(BgL_arg1282z00_2200)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2980z00_3001 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2980z00_3001 = ((bool_t)0)
; } 
if(BgL_test2980z00_3001)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2201;
BgL_thezd2remainingzd2argsz00_2201 = 
CDR(BgL_g1295z00_1729); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_hz00_2202;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2201))
{ /* bmem/bmem.scm 76 */
BgL_hz00_2202 = 
CAR(BgL_thezd2remainingzd2argsz00_2201); }  else 
{ /* bmem/bmem.scm 76 */
BgL_hz00_2202 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string2635z00zzbmemz00, 
CNST_TABLE_REF(((long)37)), BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2203;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2204;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2201))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2204 = BgL_thezd2remainingzd2argsz00_2201; }  else 
{ 
obj_t BgL_auxz00_3049;
BgL_auxz00_3049 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2642z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2201); 
FAILURE(BgL_auxz00_3049,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2203 = 
CDR(BgL_pairz00_2204); } 
{ /* bmem/bmem.scm 92 */
obj_t BgL_nvz00_2205;
BgL_nvz00_2205 = ( 
BGl_za2hostnameza2z00zzbmem_paramz00 = BgL_hz00_2202, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1520z00_2206;
BgL_val0_1520z00_2206 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3055;
BgL_tmpz00_3055 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3055); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3058;
BgL_tmpz00_3058 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3058, BgL_thezd2remainingzd2argsz00_2203); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3061;
BgL_tmpz00_3061 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3061, BgL_nvz00_2205); } 
return BgL_val0_1520z00_2206;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1523z00_2207;
BgL_val0_1523z00_2207 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3065;
BgL_tmpz00_3065 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3065); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3068;
BgL_tmpz00_3068 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3068, BgL_g1295z00_1729); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3071;
BgL_tmpz00_3071 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3071, BgL_g1296z00_1730); } 
return BgL_val0_1523z00_2207;} } } 

}



/* &<@anonymous:1653:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31653za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1731, obj_t BgL_g1292z00_1732, obj_t BgL_g1293z00_1733)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test2989z00_3074;
if(
PAIRP(BgL_g1292z00_1732))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1294z00_2208;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1674z00_2209;
BgL_arg1674z00_2209 = 
CAR(BgL_g1292z00_1732); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2210;
if(
STRINGP(BgL_arg1674z00_2209))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2210 = BgL_arg1674z00_2209; }  else 
{ 
obj_t BgL_auxz00_3080;
BgL_auxz00_3080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2645z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1674z00_2209); 
FAILURE(BgL_auxz00_3080,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2210)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2212;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3089;char * BgL_tmpz00_3087;
BgL_auxz00_3089 = 
BSTRING_TO_STRING(BgL_string2z00_2210); 
BgL_tmpz00_3087 = 
BSTRING_TO_STRING(BGl_string2646z00zzbmemz00); 
BgL_arg1282z00_2212 = 
memcmp(BgL_tmpz00_3087, BgL_auxz00_3089, ((long)2)); } 
BgL__ortest_1294z00_2208 = 
(
(long)(BgL_arg1282z00_2212)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL__ortest_1294z00_2208 = ((bool_t)0); } } } 
if(BgL__ortest_1294z00_2208)
{ /* bmem/bmem.scm 76 */
BgL_test2989z00_3074 = BgL__ortest_1294z00_2208
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1671z00_2213;
BgL_arg1671z00_2213 = 
CAR(BgL_g1292z00_1732); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2214;
if(
STRINGP(BgL_arg1671z00_2213))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2214 = BgL_arg1671z00_2213; }  else 
{ 
obj_t BgL_auxz00_3098;
BgL_auxz00_3098 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2645z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1671z00_2213); 
FAILURE(BgL_auxz00_3098,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2214)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1282z00_2216;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3107;char * BgL_tmpz00_3105;
BgL_auxz00_3107 = 
BSTRING_TO_STRING(BgL_string2z00_2214); 
BgL_tmpz00_3105 = 
BSTRING_TO_STRING(BGl_string2647z00zzbmemz00); 
BgL_arg1282z00_2216 = 
memcmp(BgL_tmpz00_3105, BgL_auxz00_3107, ((long)6)); } 
BgL_test2989z00_3074 = 
(
(long)(BgL_arg1282z00_2216)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2989z00_3074 = ((bool_t)0)
; } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test2989z00_3074 = ((bool_t)0)
; } 
if(BgL_test2989z00_3074)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2217;
BgL_thezd2remainingzd2argsz00_2217 = 
CDR(BgL_g1292z00_1732); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_pz00_2218;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2217))
{ /* bmem/bmem.scm 76 */
BgL_pz00_2218 = 
CAR(BgL_thezd2remainingzd2argsz00_2217); }  else 
{ /* bmem/bmem.scm 76 */
BgL_pz00_2218 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string2635z00zzbmemz00, 
CNST_TABLE_REF(((long)39)), BGl_string2602z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2219;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2220;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2217))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2220 = BgL_thezd2remainingzd2argsz00_2217; }  else 
{ 
obj_t BgL_auxz00_3122;
BgL_auxz00_3122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2645z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2217); 
FAILURE(BgL_auxz00_3122,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2219 = 
CDR(BgL_pairz00_2220); } 
{ /* bmem/bmem.scm 94 */
obj_t BgL_nvz00_2221;
BgL_nvz00_2221 = ( 
BGl_za2portza2z00zzbmem_paramz00 = BgL_pz00_2218, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1514z00_2222;
BgL_val0_1514z00_2222 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3128;
BgL_tmpz00_3128 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3128); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3131;
BgL_tmpz00_3131 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3131, BgL_thezd2remainingzd2argsz00_2219); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3134;
BgL_tmpz00_3134 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3134, BgL_nvz00_2221); } 
return BgL_val0_1514z00_2222;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1517z00_2223;
BgL_val0_1517z00_2223 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3138;
BgL_tmpz00_3138 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3138); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3141;
BgL_tmpz00_3141 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3141, BgL_g1292z00_1732); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3144;
BgL_tmpz00_3144 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3144, BgL_g1293z00_1733); } 
return BgL_val0_1517z00_2223;} } } 

}



/* &<@anonymous:1644:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1734, obj_t BgL_g1290z00_1736, obj_t BgL_g1291z00_1737)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_1735;
BgL_argszd2parsezd2usagez00_1735 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1734, 
(int)(((long)0)))); 
if(
NULLP(BgL_g1290z00_1736))
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1508z00_2224;obj_t BgL_val2_1510z00_2225;
BgL_val0_1508z00_2224 = 
CNST_TABLE_REF(((long)26)); 
{ /* bmem/bmem.scm 96 */
bool_t BgL_test2999z00_3153;
if(
STRINGP(BGl_za2uriza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 96 */
BgL_test2999z00_3153 = ((bool_t)0)
; }  else 
{ /* bmem/bmem.scm 96 */
if(
STRINGP(BGl_za2hostnameza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 97 */
BgL_test2999z00_3153 = 
STRINGP(BGl_za2portza2z00zzbmem_paramz00)
; }  else 
{ /* bmem/bmem.scm 97 */
BgL_test2999z00_3153 = ((bool_t)0)
; } } 
if(BgL_test2999z00_3153)
{ /* bmem/bmem.scm 96 */
BGl_usagez00zzbmemz00(BgL_argszd2parsezd2usagez00_1735); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2213z00_2226;obj_t BgL_loc2214z00_2227;obj_t BgL_env2215z00_2228;
BgL_name2213z00_2226 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2214z00_2227 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2215z00_2228 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2215z00_2228, BgL_name2213z00_2226, BgL_loc2214z00_2227); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2212z00_2229;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1617z00_2230;
BgL_list1617z00_2230 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2212z00_2229 = 
BGl_exitz00zz__errorz00(BgL_list1617z00_2230); } 
BGL_ENV_POP_TRACE(BgL_env2215z00_2228); 
BgL_val2_1510z00_2225 = BgL_aux2212z00_2229; } } } }  else 
{ /* bmem/bmem.scm 96 */
BgL_val2_1510z00_2225 = BFALSE; } } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3168;
BgL_tmpz00_3168 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3168); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3171;
BgL_tmpz00_3171 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3171, BgL_g1290z00_1736); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3174;
BgL_tmpz00_3174 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3174, BgL_val2_1510z00_2225); } 
return BgL_val0_1508z00_2224;}  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1511z00_2231;
BgL_val0_1511z00_2231 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3178;
BgL_tmpz00_3178 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3178); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3181;
BgL_tmpz00_3181 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3181, BgL_g1290z00_1736); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3184;
BgL_tmpz00_3184 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3184, BgL_g1291z00_1737); } 
return BgL_val0_1511z00_2231;} } } 

}



/* &<@anonymous:1637:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31637za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1738, obj_t BgL_g1288z00_1739, obj_t BgL_g1289z00_1740)
{
{ /* bmem/bmem.scm 76 */
if(
PAIRP(BgL_g1288z00_1739))
{ /* bmem/bmem.scm 76 */
obj_t BgL_elsez00_2232;
BgL_elsez00_2232 = 
CAR(BgL_g1288z00_1739); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1502z00_2233;obj_t BgL_val1_1503z00_2234;obj_t BgL_val2_1504z00_2235;
BgL_val0_1502z00_2233 = 
CNST_TABLE_REF(((long)24)); 
BgL_val1_1503z00_2234 = 
CDR(BgL_g1288z00_1739); 
BgL_val2_1504z00_2235 = ( 
BGl_za2uriza2z00zzbmem_paramz00 = BgL_elsez00_2232, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3192;
BgL_tmpz00_3192 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3192); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3195;
BgL_tmpz00_3195 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3195, BgL_val1_1503z00_2234); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3198;
BgL_tmpz00_3198 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3198, BgL_val2_1504z00_2235); } 
return BgL_val0_1502z00_2233;} }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1505z00_2236;
BgL_val0_1505z00_2236 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3202;
BgL_tmpz00_3202 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3202); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3205;
BgL_tmpz00_3205 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3205, BgL_g1288z00_1739); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3208;
BgL_tmpz00_3208 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3208, BgL_g1289z00_1740); } 
return BgL_val0_1505z00_2236;} } 

}



/* &<@anonymous:1796:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31796za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_1741, obj_t BgL_az00_1742, obj_t BgL_vz00_1743)
{
{ /* bmem/bmem.scm 76 */
if(
NULLP(BgL_az00_1742))
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1499z00_2237;
BgL_val0_1499z00_2237 = 
CNST_TABLE_REF(((long)26)); 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3214;
BgL_tmpz00_3214 = 
(int)(((long)3)); 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3214); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3217;
BgL_tmpz00_3217 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3217, BgL_az00_1742); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3220;
BgL_tmpz00_3220 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3220, BgL_vz00_1743); } 
return BgL_val0_1499z00_2237;}  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1798z00_2238;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2239;
if(
PAIRP(BgL_az00_1742))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2239 = BgL_az00_1742; }  else 
{ 
obj_t BgL_auxz00_3225;
BgL_auxz00_3225 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)3182)), BGl_string2648z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_az00_1742); 
FAILURE(BgL_auxz00_3225,BFALSE,BFALSE);} 
BgL_arg1798z00_2238 = 
CAR(BgL_pairz00_2239); } 
return 
BGl_errorzf2locationzf2zz__errorz00(BgL_arg1798z00_2238, BGl_string2649z00zzbmemz00, BGl_string2650z00zzbmemz00, BGl_string2602z00zzbmemz00, 
BINT(((long)3182)));} } 

}



/* parse-uri! */
obj_t BGl_parsezd2uriz12zc0zzbmemz00(obj_t BgL_uriz00_6)
{
{ /* bmem/bmem.scm 108 */
{ /* bmem/bmem.scm 109 */
obj_t BgL_name2229z00_1065;obj_t BgL_loc2230z00_1066;obj_t BgL_env2231z00_1067;
BgL_name2229z00_1065 = 
CNST_TABLE_REF(((long)40)); 
BgL_loc2230z00_1066 = 
CNST_TABLE_REF(((long)41)); 
BgL_env2231z00_1067 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 109 */

BGL_ENV_PUSH_TRACE(BgL_env2231z00_1067, BgL_name2229z00_1065, BgL_loc2230z00_1066); 
{ /* bmem/bmem.scm 109 */
obj_t BgL_aux2228z00_1068;
{ /* bmem/bmem.scm 109 */
obj_t BgL_pz00_287;
{ /* bmem/bmem.scm 109 */
obj_t BgL_patz00_295;
BgL_patz00_295 = BGl_pregexp1557z00zzbmemz00; 
{ /* bmem/bmem.scm 109 */
long BgL_endz00_298;
{ /* bmem/bmem.scm 109 */
obj_t BgL_stringz00_1332;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 109 */
BgL_stringz00_1332 = BgL_uriz00_6; }  else 
{ 
obj_t BgL_auxz00_3238;
BgL_auxz00_3238 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4469)), BGl_string2651z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3238,BFALSE,BFALSE);} 
BgL_endz00_298 = 
STRING_LENGTH(BgL_stringz00_1332); } 
{ /* bmem/bmem.scm 109 */

{ /* bmem/bmem.scm 109 */
obj_t BgL_auxz00_3243;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 109 */
BgL_auxz00_3243 = BgL_uriz00_6
; }  else 
{ 
obj_t BgL_auxz00_3246;
BgL_auxz00_3246 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4469)), BGl_string2651z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3246,BFALSE,BFALSE);} 
BgL_pz00_287 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_295, BgL_auxz00_3243, 
BINT(((long)0)), 
BINT(BgL_endz00_298)); } } } } 
if(
PAIRP(BgL_pz00_287))
{ /* bmem/bmem.scm 110 */
{ /* bmem/bmem.scm 112 */
obj_t BgL_pairz00_1336;
{ /* bmem/bmem.scm 112 */
obj_t BgL_aux2367z00_1852;
BgL_aux2367z00_1852 = 
CDR(BgL_pz00_287); 
if(
PAIRP(BgL_aux2367z00_1852))
{ /* bmem/bmem.scm 112 */
BgL_pairz00_1336 = BgL_aux2367z00_1852; }  else 
{ 
obj_t BgL_auxz00_3258;
BgL_auxz00_3258 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4562)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2367z00_1852); 
FAILURE(BgL_auxz00_3258,BFALSE,BFALSE);} } 
BGl_za2fileza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1336); } 
{ /* bmem/bmem.scm 113 */
obj_t BgL_pairz00_1342;
{ /* bmem/bmem.scm 113 */
obj_t BgL_pairz00_1341;
{ /* bmem/bmem.scm 113 */
obj_t BgL_aux2369z00_1854;
BgL_aux2369z00_1854 = 
CDR(BgL_pz00_287); 
if(
PAIRP(BgL_aux2369z00_1854))
{ /* bmem/bmem.scm 113 */
BgL_pairz00_1341 = BgL_aux2369z00_1854; }  else 
{ 
obj_t BgL_auxz00_3266;
BgL_auxz00_3266 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4595)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2369z00_1854); 
FAILURE(BgL_auxz00_3266,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 113 */
obj_t BgL_aux2371z00_1856;
BgL_aux2371z00_1856 = 
CDR(BgL_pairz00_1341); 
if(
PAIRP(BgL_aux2371z00_1856))
{ /* bmem/bmem.scm 113 */
BgL_pairz00_1342 = BgL_aux2371z00_1856; }  else 
{ 
obj_t BgL_auxz00_3273;
BgL_auxz00_3273 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4595)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2371z00_1856); 
FAILURE(BgL_auxz00_3273,BFALSE,BFALSE);} } } 
BgL_aux2228z00_1068 = ( 
BGl_za2functionza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1342), BUNSPEC) ; } }  else 
{ /* bmem/bmem.scm 114 */
obj_t BgL_pz00_289;
{ /* bmem/bmem.scm 114 */
obj_t BgL_patz00_291;
BgL_patz00_291 = BGl_pregexp1558z00zzbmemz00; 
{ /* bmem/bmem.scm 114 */
long BgL_endz00_294;
{ /* bmem/bmem.scm 114 */
obj_t BgL_stringz00_1343;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 114 */
BgL_stringz00_1343 = BgL_uriz00_6; }  else 
{ 
obj_t BgL_auxz00_3280;
BgL_auxz00_3280 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4619)), BGl_string2651z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3280,BFALSE,BFALSE);} 
BgL_endz00_294 = 
STRING_LENGTH(BgL_stringz00_1343); } 
{ /* bmem/bmem.scm 114 */

{ /* bmem/bmem.scm 114 */
obj_t BgL_auxz00_3285;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 114 */
BgL_auxz00_3285 = BgL_uriz00_6
; }  else 
{ 
obj_t BgL_auxz00_3288;
BgL_auxz00_3288 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4619)), BGl_string2651z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3288,BFALSE,BFALSE);} 
BgL_pz00_289 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_291, BgL_auxz00_3285, 
BINT(((long)0)), 
BINT(BgL_endz00_294)); } } } } 
if(
PAIRP(BgL_pz00_289))
{ /* bmem/bmem.scm 115 */
{ /* bmem/bmem.scm 117 */
obj_t BgL_pairz00_1347;
{ /* bmem/bmem.scm 117 */
obj_t BgL_aux2377z00_1862;
BgL_aux2377z00_1862 = 
CDR(BgL_pz00_289); 
if(
PAIRP(BgL_aux2377z00_1862))
{ /* bmem/bmem.scm 117 */
BgL_pairz00_1347 = BgL_aux2377z00_1862; }  else 
{ 
obj_t BgL_auxz00_3300;
BgL_auxz00_3300 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4712)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2377z00_1862); 
FAILURE(BgL_auxz00_3300,BFALSE,BFALSE);} } 
BGl_za2fileza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1347); } 
{ /* bmem/bmem.scm 118 */
obj_t BgL_pairz00_1353;
{ /* bmem/bmem.scm 118 */
obj_t BgL_pairz00_1352;
{ /* bmem/bmem.scm 118 */
obj_t BgL_aux2379z00_1864;
BgL_aux2379z00_1864 = 
CDR(BgL_pz00_289); 
if(
PAIRP(BgL_aux2379z00_1864))
{ /* bmem/bmem.scm 118 */
BgL_pairz00_1352 = BgL_aux2379z00_1864; }  else 
{ 
obj_t BgL_auxz00_3308;
BgL_auxz00_3308 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4741)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2379z00_1864); 
FAILURE(BgL_auxz00_3308,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 118 */
obj_t BgL_aux2381z00_1866;
BgL_aux2381z00_1866 = 
CDR(BgL_pairz00_1352); 
if(
PAIRP(BgL_aux2381z00_1866))
{ /* bmem/bmem.scm 118 */
BgL_pairz00_1353 = BgL_aux2381z00_1866; }  else 
{ 
obj_t BgL_auxz00_3315;
BgL_auxz00_3315 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)4741)), BGl_string2651z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2381z00_1866); 
FAILURE(BgL_auxz00_3315,BFALSE,BFALSE);} } } 
BgL_aux2228z00_1068 = ( 
BGl_za2typeza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1353), BUNSPEC) ; } }  else 
{ /* bmem/bmem.scm 115 */
BgL_aux2228z00_1068 = ( 
BGl_za2fileza2z00zzbmem_paramz00 = BgL_uriz00_6, BUNSPEC) ; } } } 
BGL_ENV_POP_TRACE(BgL_env2231z00_1067); 
return BgL_aux2228z00_1068;} } } } 

}



/* main */
BGL_EXPORTED_DEF obj_t BGl_mainz00zzbmemz00(obj_t BgL_argvz00_7)
{
{ /* bmem/bmem.scm 124 */
{ /* bmem/bmem.scm 127 */
obj_t BgL_name2233z00_1069;obj_t BgL_loc2234z00_1070;obj_t BgL_env2235z00_1071;
BgL_name2233z00_1069 = 
CNST_TABLE_REF(((long)42)); 
BgL_loc2234z00_1070 = 
CNST_TABLE_REF(((long)43)); 
BgL_env2235z00_1071 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 127 */

BGL_ENV_PUSH_TRACE(BgL_env2235z00_1071, BgL_name2233z00_1069, BgL_loc2234z00_1070); 
{ /* bmem/bmem.scm 127 */
obj_t BgL_aux2232z00_1072;
{ /* bmem/bmem.scm 127 */
obj_t BgL_zc3z04anonymousza31812za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_1745;
BgL_zc3z04anonymousza31812za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_1745 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31812za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31812za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_1745, 
(int)(((long)0)), BgL_argvz00_7); 
BgL_aux2232z00_1072 = 
BGl_withzd2exceptionzd2handlerz00zz__errorz00(BGl_proc2652z00zzbmemz00, BgL_zc3z04anonymousza31812za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_1745); } 
BGL_ENV_POP_TRACE(BgL_env2235z00_1071); 
return BgL_aux2232z00_1072;} } } } 

}



/* &main */
obj_t BGl_z62mainz62zzbmemz00(obj_t BgL_envz00_1747, obj_t BgL_argvz00_1748)
{
{ /* bmem/bmem.scm 124 */
{ /* bmem/bmem.scm 127 */
obj_t BgL_auxz00_3332;
if(
PAIRP(BgL_argvz00_1748))
{ /* bmem/bmem.scm 127 */
BgL_auxz00_3332 = BgL_argvz00_1748
; }  else 
{ 
obj_t BgL_auxz00_3335;
BgL_auxz00_3335 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)5069)), BGl_string2653z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_argvz00_1748); 
FAILURE(BgL_auxz00_3335,BFALSE,BFALSE);} 
return 
BGl_mainz00zzbmemz00(BgL_auxz00_3332);} } 

}



/* &<@anonymous:1812:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:125@> */
obj_t BGl_z62zc3z04anonymousza31812za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t BgL_envz00_1749)
{
{ /* bmem/bmem.scm 136 */
{ /* bmem/bmem.scm 137 */
obj_t BgL_argvz00_1750;
BgL_argvz00_1750 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1749, 
(int)(((long)0)))); 
BGl_parsezd2cmdlinez12zc0zzbmemz00(BgL_argvz00_1750); 
if(
STRINGP(BGl_za2uriza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 138 */BFALSE; }  else 
{ /* bmem/bmem.scm 138 */
BGl_usagez00zzbmemz00(BGl_proc2654z00zzbmemz00); } 
BGl_parsezd2uriz12zc0zzbmemz00(BGl_za2uriza2z00zzbmem_paramz00); 
return 
BGl_bmemzd2requestzd2zzbmemz00();} } 

}



/* &<@anonymous:1804:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:125@> */
obj_t BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t BgL_envz00_1751, obj_t BgL_ez00_1752)
{
{ /* bmem/bmem.scm 126 */
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_1752, BGl_z62errorz62zz__objectz00))
{ /* bmem/bmem.scm 127 */
BGl_errorzd2notifyzd2zz__errorz00(BgL_ez00_1752); 
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 132 */
obj_t BgL_arg1807z00_2240;
{ /* bmem/bmem.scm 132 */
obj_t BgL_arg1809z00_2241;obj_t BgL_arg1810z00_2242;obj_t BgL_arg1811z00_2243;
BgL_arg1809z00_2241 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_1752)))->BgL_objz00); 
BgL_arg1810z00_2242 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_1752)))->BgL_procz00); 
BgL_arg1811z00_2243 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_1752)))->BgL_msgz00); 
{ /* bmem/bmem.scm 132 */
obj_t BgL_auxz00_3360;
{ /* bmem/bmem.scm 132 */
obj_t BgL_aux2385z00_2244;
BgL_aux2385z00_2244 = BGl_za2bmemza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2385z00_2244))
{ /* bmem/bmem.scm 132 */
BgL_auxz00_3360 = BgL_aux2385z00_2244
; }  else 
{ 
obj_t BgL_auxz00_3363;
BgL_auxz00_3363 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)5221)), BGl_string2655z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2385z00_2244); 
FAILURE(BgL_auxz00_3363,BFALSE,BFALSE);} } 
BgL_arg1807z00_2240 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BgL_auxz00_3360, BgL_arg1809z00_2241, BgL_arg1810z00_2242, BgL_arg1811z00_2243); } } 
{ /* bmem/bmem.scm 131 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3368;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1807z00_2240, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 132 */
BgL_auxz00_3368 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1807z00_2240)
; }  else 
{ 
obj_t BgL_auxz00_3372;
BgL_auxz00_3372 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)5240)), BGl_string2655z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_arg1807z00_2240); 
FAILURE(BgL_auxz00_3372,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3368); } }  else 
{ /* bmem/bmem.scm 130 */BFALSE; } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2213z00_2245;obj_t BgL_loc2214z00_2246;obj_t BgL_env2215z00_2247;
BgL_name2213z00_2245 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2214z00_2246 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2215z00_2247 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2215z00_2247, BgL_name2213z00_2245, BgL_loc2214z00_2246); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2212z00_2248;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1617z00_2249;
BgL_list1617z00_2249 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2212z00_2248 = 
BGl_exitz00zz__errorz00(BgL_list1617z00_2249); } 
BGL_ENV_POP_TRACE(BgL_env2215z00_2247); BgL_aux2212z00_2248; } } } ((bool_t)0); }  else 
{ /* bmem/bmem.scm 127 */((bool_t)0); } 
return 
BGl_raisez00zz__errorz00(BgL_ez00_1752);} 

}



/* &<@anonymous:1815:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:139@> */
obj_t BGl_z62zc3z04anonymousza31815za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00(obj_t BgL_envz00_1753, obj_t BgL__z00_1754)
{
{ /* bmem/bmem.scm 139 */
{ /* bmem/bmem.scm 139 */
obj_t BgL_list1816z00_2250;
BgL_list1816z00_2250 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BNIL); 
return 
BGl_exitz00zz__errorz00(BgL_list1816z00_2250);} } 

}



/* bmem-request */
obj_t BGl_bmemzd2requestzd2zzbmemz00()
{
{ /* bmem/bmem.scm 146 */
{ /* bmem/bmem.scm 147 */
obj_t BgL_name2237z00_1073;obj_t BgL_loc2238z00_1074;obj_t BgL_env2239z00_1075;
BgL_name2237z00_1073 = 
CNST_TABLE_REF(((long)44)); 
BgL_loc2238z00_1074 = 
CNST_TABLE_REF(((long)45)); 
BgL_env2239z00_1075 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 147 */

BGL_ENV_PUSH_TRACE(BgL_env2239z00_1075, BgL_name2237z00_1073, BgL_loc2238z00_1074); 
{ /* bmem/bmem.scm 147 */
obj_t BgL_aux2236z00_1076;
{ /* bmem/bmem.scm 147 */
obj_t BgL_monz00_319;
if(
STRINGP(BGl_za2fileza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 147 */
BgL_monz00_319 = 
BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(BGl_za2fileza2z00zzbmem_paramz00, BGl_readzd2envzd2zz__readerz00); }  else 
{ /* bmem/bmem.scm 149 */
obj_t BgL_arg1839z00_360;
{ /* bmem/bmem.scm 149 */
obj_t BgL_tmpz00_3396;
BgL_tmpz00_3396 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1839z00_360 = 
BGL_ENV_CURRENT_INPUT_PORT(BgL_tmpz00_3396); } 
{ /* bmem/bmem.scm 149 */

{ /* bmem/bmem.scm 149 */

BgL_monz00_319 = 
BGl_readz00zz__readerz00(BgL_arg1839z00_360, BFALSE); } } } 
{ /* bmem/bmem.scm 147 */
obj_t BgL_infoz00_320;
BgL_infoz00_320 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)46))); 
{ /* bmem/bmem.scm 150 */
obj_t BgL_gcmonz00_321;
BgL_gcmonz00_321 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)47))); 
{ /* bmem/bmem.scm 151 */
obj_t BgL_funmonz00_322;
BgL_funmonz00_322 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)48))); 
{ /* bmem/bmem.scm 152 */
obj_t BgL_typesz00_323;
BgL_typesz00_323 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)49))); 
{ /* bmem/bmem.scm 153 */
obj_t BgL_threadz00_324;
BgL_threadz00_324 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)50))); 
{ /* bmem/bmem.scm 154 */
obj_t BgL_cssz00_325;
{ /* bmem/bmem.scm 155 */
obj_t BgL_pz00_352;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1834z00_355;
BgL_arg1834z00_355 = 
MAKE_YOUNG_PAIR(BGl_string2656z00zzbmemz00, BNIL); 
{ /* bmem/bmem.scm 155 */
obj_t BgL_list1835z00_356;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1836z00_357;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1837z00_358;
BgL_arg1837z00_358 = 
MAKE_YOUNG_PAIR(BgL_arg1834z00_355, BNIL); 
BgL_arg1836z00_357 = 
MAKE_YOUNG_PAIR(BGl_za2csszd2pathza2zd2zzbmem_paramz00, BgL_arg1837z00_358); } 
BgL_list1835z00_356 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)51)), BgL_arg1836z00_357); } 
BgL_pz00_352 = 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list1835z00_356); } } 
{ /* bmem/bmem.scm 156 */
obj_t BgL_fz00_353;
BgL_fz00_353 = 
BGl_findzd2filezf2pathz20zz__osz00(BGl_string2657z00zzbmemz00, BgL_pz00_352); 
if(
STRINGP(BgL_fz00_353))
{ /* bmem/bmem.scm 157 */
BgL_cssz00_325 = BgL_fz00_353; }  else 
{ /* bmem/bmem.scm 157 */
BgL_cssz00_325 = BFALSE; } } } 
{ /* bmem/bmem.scm 155 */

{ /* bmem/bmem.scm 161 */
bool_t BgL_test3025z00_3419;
if(
NULLP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 161 */
BgL_test3025z00_3419 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 161 */
obj_t BgL_tmpz00_3422;
{ /* bmem/bmem.scm 161 */
obj_t BgL_pairz00_1363;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 161 */
BgL_pairz00_1363 = BgL_gcmonz00_321; }  else 
{ 
obj_t BgL_auxz00_3425;
BgL_auxz00_3425 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6164)), BGl_string2658z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_3425,BFALSE,BFALSE);} 
BgL_tmpz00_3422 = 
CDR(BgL_pairz00_1363); } 
BgL_test3025z00_3419 = 
NULLP(BgL_tmpz00_3422); } 
if(BgL_test3025z00_3419)
{ /* bmem/bmem.scm 161 */
{ /* bmem/bmem.scm 164 */
obj_t BgL_arg1820z00_329;
BgL_arg1820z00_329 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2600z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string2659z00zzbmemz00, BNIL); 
{ /* bmem/bmem.scm 163 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3433;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1820z00_329, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 168 */
BgL_auxz00_3433 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1820z00_329)
; }  else 
{ 
obj_t BgL_auxz00_3437;
BgL_auxz00_3437 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6312)), BGl_string2658z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_arg1820z00_329); 
FAILURE(BgL_auxz00_3437,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3433); } } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2213z00_1364;obj_t BgL_loc2214z00_1365;obj_t BgL_env2215z00_1366;
BgL_name2213z00_1364 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2214z00_1365 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2215z00_1366 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2215z00_1366, BgL_name2213z00_1364, BgL_loc2214z00_1365); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2212z00_1367;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1617z00_1368;
BgL_list1617z00_1368 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2212z00_1367 = 
BGl_exitz00zz__errorz00(BgL_list1617z00_1368); } 
BGL_ENV_POP_TRACE(BgL_env2215z00_1366); BgL_aux2212z00_1367; } } } }  else 
{ /* bmem/bmem.scm 161 */((bool_t)0); } } 
{ /* bmem/bmem.scm 171 */
obj_t BgL_cz00_332;
{ /* bmem/bmem.scm 171 */
obj_t BgL_auxz00_3450;
{ /* bmem/bmem.scm 171 */
obj_t BgL_pairz00_1369;
if(
PAIRP(BgL_infoz00_320))
{ /* bmem/bmem.scm 171 */
BgL_pairz00_1369 = BgL_infoz00_320; }  else 
{ 
obj_t BgL_auxz00_3454;
BgL_auxz00_3454 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6409)), BGl_string2658z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_infoz00_320); 
FAILURE(BgL_auxz00_3454,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 171 */
obj_t BgL_aux2395z00_1884;
BgL_aux2395z00_1884 = 
CDR(BgL_pairz00_1369); 
{ /* bmem/bmem.scm 171 */
bool_t BgL_test3030z00_3459;
if(
PAIRP(BgL_aux2395z00_1884))
{ /* bmem/bmem.scm 171 */
BgL_test3030z00_3459 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 171 */
BgL_test3030z00_3459 = 
NULLP(BgL_aux2395z00_1884)
; } 
if(BgL_test3030z00_3459)
{ /* bmem/bmem.scm 171 */
BgL_auxz00_3450 = BgL_aux2395z00_1884
; }  else 
{ 
obj_t BgL_auxz00_3463;
BgL_auxz00_3463 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6404)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2395z00_1884); 
FAILURE(BgL_auxz00_3463,BFALSE,BFALSE);} } } } 
BgL_cz00_332 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)53)), BgL_auxz00_3450); } 
if(
PAIRP(BgL_cz00_332))
{ /* bmem/bmem.scm 173 */
obj_t BgL_arg1823z00_334;
{ /* bmem/bmem.scm 173 */
obj_t BgL_pairz00_1373;
{ /* bmem/bmem.scm 173 */
obj_t BgL_aux2397z00_1886;
BgL_aux2397z00_1886 = 
CDR(BgL_cz00_332); 
if(
PAIRP(BgL_aux2397z00_1886))
{ /* bmem/bmem.scm 173 */
BgL_pairz00_1373 = BgL_aux2397z00_1886; }  else 
{ 
obj_t BgL_auxz00_3473;
BgL_auxz00_3473 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6475)), BGl_string2658z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2397z00_1886); 
FAILURE(BgL_auxz00_3473,BFALSE,BFALSE);} } 
BgL_arg1823z00_334 = 
CAR(BgL_pairz00_1373); } 
{ /* bmem/bmem.scm 173 */
long BgL_xz00_1374;
{ /* bmem/bmem.scm 173 */
obj_t BgL_tmpz00_3478;
if(
INTEGERP(BgL_arg1823z00_334))
{ /* bmem/bmem.scm 173 */
BgL_tmpz00_3478 = BgL_arg1823z00_334
; }  else 
{ 
obj_t BgL_auxz00_3481;
BgL_auxz00_3481 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6482)), BGl_string2658z00zzbmemz00, BGl_string2661z00zzbmemz00, BgL_arg1823z00_334); 
FAILURE(BgL_auxz00_3481,BFALSE,BFALSE);} 
BgL_xz00_1374 = 
(long)CINT(BgL_tmpz00_3478); } 
BGl_za2siza7eofzd2wordza2z75zzbmem_paramz00 = 
make_bllong(
LONG_TO_LLONG(BgL_xz00_1374)); } }  else 
{ /* bmem/bmem.scm 172 */BFALSE; } } 
{ /* bmem/bmem.scm 175 */
obj_t BgL_g1561z00_336;
{ /* bmem/bmem.scm 175 */
obj_t BgL_pairz00_1375;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 175 */
BgL_pairz00_1375 = BgL_funmonz00_322; }  else 
{ 
obj_t BgL_auxz00_3490;
BgL_auxz00_3490 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6556)), BGl_string2658z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_3490,BFALSE,BFALSE);} 
BgL_g1561z00_336 = 
CDR(BgL_pairz00_1375); } 
{ 
obj_t BgL_l1559z00_338;
BgL_l1559z00_338 = BgL_g1561z00_336; 
BgL_zc3z04anonymousza31825za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3175z04ze3z51_339:
if(
PAIRP(BgL_l1559z00_338))
{ /* bmem/bmem.scm 175 */
{ /* bmem/bmem.scm 175 */
obj_t BgL_arg1827z00_341;
BgL_arg1827z00_341 = 
CAR(BgL_l1559z00_338); 
{ /* bmem/bmem.scm 175 */
obj_t BgL_auxz00_3498;
if(
PAIRP(BgL_arg1827z00_341))
{ /* bmem/bmem.scm 175 */
BgL_auxz00_3498 = BgL_arg1827z00_341
; }  else 
{ 
obj_t BgL_auxz00_3501;
BgL_auxz00_3501 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6551)), BGl_string2662z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_arg1827z00_341); 
FAILURE(BgL_auxz00_3501,BFALSE,BFALSE);} 
BGl_addzd2functionz12zc0zzbmem_functionz00(BgL_auxz00_3498); } } 
{ 
obj_t BgL_l1559z00_3506;
BgL_l1559z00_3506 = 
CDR(BgL_l1559z00_338); 
BgL_l1559z00_338 = BgL_l1559z00_3506; 
goto BgL_zc3z04anonymousza31825za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3175z04ze3z51_339;} }  else 
{ /* bmem/bmem.scm 175 */
if(
NULLP(BgL_l1559z00_338))
{ /* bmem/bmem.scm 175 */BTRUE; }  else 
{ /* bmem/bmem.scm 175 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2663z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1559z00_338, BGl_string2602z00zzbmemz00, 
BINT(((long)6527))); } } } } 
{ /* bmem/bmem.scm 176 */
obj_t BgL_docz00_345;
if(
CBOOL(BGl_za2functionza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 178 */
obj_t BgL__ortest_1313z00_350;
{ /* bmem/bmem.scm 178 */
obj_t BgL_auxz00_3539;obj_t BgL_auxz00_3530;obj_t BgL_auxz00_3521;obj_t BgL_auxz00_3514;
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3045z00_3540;
if(
PAIRP(BgL_typesz00_323))
{ /* bmem/bmem.scm 178 */
BgL_test3045z00_3540 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3045z00_3540 = 
NULLP(BgL_typesz00_323)
; } 
if(BgL_test3045z00_3540)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_3539 = BgL_typesz00_323
; }  else 
{ 
obj_t BgL_auxz00_3544;
BgL_auxz00_3544 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6665)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_typesz00_323); 
FAILURE(BgL_auxz00_3544,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3043z00_3531;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 178 */
BgL_test3043z00_3531 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3043z00_3531 = 
NULLP(BgL_funmonz00_322)
; } 
if(BgL_test3043z00_3531)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_3530 = BgL_funmonz00_322
; }  else 
{ 
obj_t BgL_auxz00_3535;
BgL_auxz00_3535 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6658)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_3535,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3041z00_3522;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 178 */
BgL_test3041z00_3522 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3041z00_3522 = 
NULLP(BgL_gcmonz00_321)
; } 
if(BgL_test3041z00_3522)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_3521 = BgL_gcmonz00_321
; }  else 
{ 
obj_t BgL_auxz00_3526;
BgL_auxz00_3526 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6652)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_3526,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
obj_t BgL_aux2405z00_1894;
BgL_aux2405z00_1894 = BGl_za2functionza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2405z00_1894))
{ /* bmem/bmem.scm 178 */
BgL_auxz00_3514 = BgL_aux2405z00_1894
; }  else 
{ 
obj_t BgL_auxz00_3517;
BgL_auxz00_3517 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6632)), BGl_string2658z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2405z00_1894); 
FAILURE(BgL_auxz00_3517,BFALSE,BFALSE);} } 
BgL__ortest_1313z00_350 = 
BGl_bmemzd2functionzd2zzbmem_functionz00(BgL_auxz00_3514, BgL_cssz00_325, BgL_infoz00_320, BgL_auxz00_3521, BgL_auxz00_3530, BgL_auxz00_3539); } 
if(
CBOOL(BgL__ortest_1313z00_350))
{ /* bmem/bmem.scm 178 */
BgL_docz00_345 = BgL__ortest_1313z00_350; }  else 
{ /* bmem/bmem.scm 178 */
BgL_docz00_345 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2600z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string2665z00zzbmemz00, BGl_za2functionza2z00zzbmem_paramz00); } }  else 
{ /* bmem/bmem.scm 177 */
if(
CBOOL(BGl_za2typeza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 185 */
obj_t BgL__ortest_1314z00_351;
{ /* bmem/bmem.scm 185 */
obj_t BgL_auxz00_3580;obj_t BgL_auxz00_3571;obj_t BgL_auxz00_3562;obj_t BgL_auxz00_3555;
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3054z00_3581;
if(
PAIRP(BgL_typesz00_323))
{ /* bmem/bmem.scm 185 */
BgL_test3054z00_3581 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3054z00_3581 = 
NULLP(BgL_typesz00_323)
; } 
if(BgL_test3054z00_3581)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_3580 = BgL_typesz00_323
; }  else 
{ 
obj_t BgL_auxz00_3585;
BgL_auxz00_3585 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6852)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_typesz00_323); 
FAILURE(BgL_auxz00_3585,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3052z00_3572;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 185 */
BgL_test3052z00_3572 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3052z00_3572 = 
NULLP(BgL_funmonz00_322)
; } 
if(BgL_test3052z00_3572)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_3571 = BgL_funmonz00_322
; }  else 
{ 
obj_t BgL_auxz00_3576;
BgL_auxz00_3576 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6845)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_3576,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3050z00_3563;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 185 */
BgL_test3050z00_3563 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3050z00_3563 = 
NULLP(BgL_gcmonz00_321)
; } 
if(BgL_test3050z00_3563)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_3562 = BgL_gcmonz00_321
; }  else 
{ 
obj_t BgL_auxz00_3567;
BgL_auxz00_3567 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6839)), BGl_string2658z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_3567,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
obj_t BgL_aux2413z00_1902;
BgL_aux2413z00_1902 = BGl_za2typeza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2413z00_1902))
{ /* bmem/bmem.scm 185 */
BgL_auxz00_3555 = BgL_aux2413z00_1902
; }  else 
{ 
obj_t BgL_auxz00_3558;
BgL_auxz00_3558 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)6823)), BGl_string2658z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2413z00_1902); 
FAILURE(BgL_auxz00_3558,BFALSE,BFALSE);} } 
BgL__ortest_1314z00_351 = 
BGl_bmemzd2typezd2zzbmem_typez00(BgL_auxz00_3555, BgL_cssz00_325, BgL_infoz00_320, BgL_auxz00_3562, BgL_auxz00_3571, BgL_auxz00_3580); } 
if(
CBOOL(BgL__ortest_1314z00_351))
{ /* bmem/bmem.scm 185 */
BgL_docz00_345 = BgL__ortest_1314z00_351; }  else 
{ /* bmem/bmem.scm 185 */
BgL_docz00_345 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2600z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string2666z00zzbmemz00, BGl_za2typeza2z00zzbmem_paramz00); } }  else 
{ /* bmem/bmem.scm 184 */
BgL_docz00_345 = 
((obj_t)
BGl_bmemzd2allzd2zzbmemz00(BgL_cssz00_325, BgL_infoz00_320, BgL_gcmonz00_321, BgL_funmonz00_322, BgL_typesz00_323, BgL_threadz00_324)); } } 
if(
STRINGP(BGl_za2foutza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 194 */
obj_t BgL_zc3z04anonymousza31832za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_1755;
BgL_zc3z04anonymousza31832za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_1755 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31832za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31832za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_1755, 
(int)(((long)0)), BgL_docz00_345); 
BgL_aux2236z00_1076 = 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BGl_za2foutza2z00zzbmem_paramz00, BgL_zc3z04anonymousza31832za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_1755); }  else 
{ /* bmem/bmem.scm 195 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3604;
if(
BGl_isazf3zf3zz__objectz00(BgL_docz00_345, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 195 */
BgL_auxz00_3604 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_docz00_345)
; }  else 
{ 
obj_t BgL_auxz00_3608;
BgL_auxz00_3608 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)7140)), BGl_string2658z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_docz00_345); 
FAILURE(BgL_auxz00_3608,BFALSE,BFALSE);} 
BgL_aux2236z00_1076 = 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3604); } } } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2239z00_1075); 
return BgL_aux2236z00_1076;} } } } 

}



/* &<@anonymous:1832:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:194@> */
obj_t BGl_z62zc3z04anonymousza31832za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00(obj_t BgL_envz00_1756)
{
{ /* bmem/bmem.scm 194 */
{ /* bmem/bmem.scm 194 */
obj_t BgL_docz00_1757;
BgL_docz00_1757 = 
PROCEDURE_REF(BgL_envz00_1756, 
(int)(((long)0))); 
{ /* bmem/bmem.scm 194 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3616;
if(
BGl_isazf3zf3zz__objectz00(BgL_docz00_1757, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 194 */
BgL_auxz00_3616 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_docz00_1757)
; }  else 
{ 
obj_t BgL_auxz00_3620;
BgL_auxz00_3620 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)7115)), BGl_string2667z00zzbmemz00, BGl_string2604z00zzbmemz00, BgL_docz00_1757); 
FAILURE(BgL_auxz00_3620,BFALSE,BFALSE);} 
return 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3616);} } } 

}



/* function-ident-pp */
BGL_EXPORTED_DEF obj_t BGl_functionzd2identzd2ppz00zzbmemz00(obj_t BgL_identz00_8)
{
{ /* bmem/bmem.scm 223 */
{ /* bmem/bmem.scm 224 */
obj_t BgL_name2241z00_1077;obj_t BgL_loc2242z00_1078;obj_t BgL_env2243z00_1079;
BgL_name2241z00_1077 = 
CNST_TABLE_REF(((long)54)); 
BgL_loc2242z00_1078 = 
CNST_TABLE_REF(((long)55)); 
BgL_env2243z00_1079 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 224 */

BGL_ENV_PUSH_TRACE(BgL_env2243z00_1079, BgL_name2241z00_1077, BgL_loc2242z00_1078); 
{ /* bmem/bmem.scm 224 */
obj_t BgL_aux2240z00_1080;
{ /* bmem/bmem.scm 224 */
obj_t BgL_iz00_363;
if(
SYMBOLP(BgL_identz00_8))
{ /* bmem/bmem.scm 224 */
obj_t BgL_arg1434z00_1380;
BgL_arg1434z00_1380 = 
SYMBOL_TO_STRING(BgL_identz00_8); 
BgL_iz00_363 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_1380); }  else 
{ /* bmem/bmem.scm 224 */
BgL_iz00_363 = BgL_identz00_8; } 
{ /* bmem/bmem.scm 224 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_pregexpzd2tmp1318zd2_365;
BgL_pregexpzd2tmp1318zd2_365 = BNIL; 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_367;
BgL_patz00_367 = BGl_pregexp1562z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_370;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1383;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1383 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_3635;
BgL_auxz00_3635 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3635,BFALSE,BFALSE);} 
BgL_endz00_370 = 
STRING_LENGTH(BgL_stringz00_1383); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3640;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3640 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_3643;
BgL_auxz00_3643 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3643,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1318zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_367, BgL_auxz00_3640, 
BINT(((long)0)), 
BINT(BgL_endz00_370)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1318zd2_365))
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1840z00_371;obj_t BgL_arg1841z00_372;
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1384;
BgL_arg1858z00_1384 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3653;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2429z00_1922;
BgL_aux2429z00_1922 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3064z00_3654;
if(
PAIRP(BgL_aux2429z00_1922))
{ /* bmem/bmem.scm 225 */
BgL_test3064z00_3654 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3064z00_3654 = 
NULLP(BgL_aux2429z00_1922)
; } 
if(BgL_test3064z00_3654)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3653 = BgL_aux2429z00_1922
; }  else 
{ 
obj_t BgL_auxz00_3658;
BgL_auxz00_3658 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2429z00_1922); 
FAILURE(BgL_auxz00_3658,BFALSE,BFALSE);} } } 
BgL_arg1840z00_371 = 
bgl_list_ref(BgL_auxz00_3653, BgL_arg1858z00_1384); } } 
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1385;
BgL_arg1858z00_1385 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3664;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2431z00_1924;
BgL_aux2431z00_1924 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3066z00_3665;
if(
PAIRP(BgL_aux2431z00_1924))
{ /* bmem/bmem.scm 225 */
BgL_test3066z00_3665 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3066z00_3665 = 
NULLP(BgL_aux2431z00_1924)
; } 
if(BgL_test3066z00_3665)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3664 = BgL_aux2431z00_1924
; }  else 
{ 
obj_t BgL_auxz00_3669;
BgL_auxz00_3669 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2431z00_1924); 
FAILURE(BgL_auxz00_3669,BFALSE,BFALSE);} } } 
BgL_arg1841z00_372 = 
bgl_list_ref(BgL_auxz00_3664, BgL_arg1858z00_1385); } } 
{ /* bmem/bmem.scm 228 */
obj_t BgL_list1842z00_373;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1843z00_374;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1844z00_375;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1845z00_376;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1846z00_377;
BgL_arg1846z00_377 = 
MAKE_YOUNG_PAIR(BGl_string2669z00zzbmemz00, BNIL); 
BgL_arg1845z00_376 = 
MAKE_YOUNG_PAIR(BgL_arg1841z00_372, BgL_arg1846z00_377); } 
BgL_arg1844z00_375 = 
MAKE_YOUNG_PAIR(BGl_string2670z00zzbmemz00, BgL_arg1845z00_376); } 
BgL_arg1843z00_374 = 
MAKE_YOUNG_PAIR(BgL_arg1840z00_371, BgL_arg1844z00_375); } 
BgL_list1842z00_373 = 
MAKE_YOUNG_PAIR(BGl_string2671z00zzbmemz00, BgL_arg1843z00_374); } 
BgL_aux2240z00_1080 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1842z00_373); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_378;
BgL_patz00_378 = BGl_pregexp1563z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_381;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1386;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1386 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_3682;
BgL_auxz00_3682 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3682,BFALSE,BFALSE);} 
BgL_endz00_381 = 
STRING_LENGTH(BgL_stringz00_1386); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3687;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3687 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_3690;
BgL_auxz00_3690 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3690,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1318zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_378, BgL_auxz00_3687, 
BINT(((long)0)), 
BINT(BgL_endz00_381)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1318zd2_365))
{ /* bmem/bmem.scm 230 */
obj_t BgL_arg1847z00_382;
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1387;
BgL_arg1858z00_1387 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3700;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2437z00_1930;
BgL_aux2437z00_1930 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3071z00_3701;
if(
PAIRP(BgL_aux2437z00_1930))
{ /* bmem/bmem.scm 225 */
BgL_test3071z00_3701 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3071z00_3701 = 
NULLP(BgL_aux2437z00_1930)
; } 
if(BgL_test3071z00_3701)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3700 = BgL_aux2437z00_1930
; }  else 
{ 
obj_t BgL_auxz00_3705;
BgL_auxz00_3705 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2437z00_1930); 
FAILURE(BgL_auxz00_3705,BFALSE,BFALSE);} } } 
BgL_arg1847z00_382 = 
bgl_list_ref(BgL_auxz00_3700, BgL_arg1858z00_1387); } } 
{ /* bmem/bmem.scm 230 */
obj_t BgL_tmpz00_3710;
if(
STRINGP(BgL_arg1847z00_382))
{ /* bmem/bmem.scm 230 */
BgL_tmpz00_3710 = BgL_arg1847z00_382
; }  else 
{ 
obj_t BgL_auxz00_3713;
BgL_auxz00_3713 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8590)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1847z00_382); 
FAILURE(BgL_auxz00_3713,BFALSE,BFALSE);} 
BgL_aux2240z00_1080 = 
string_append_3(BGl_string2671z00zzbmemz00, BgL_tmpz00_3710, BGl_string2669z00zzbmemz00); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_383;
BgL_patz00_383 = BGl_pregexp1564z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_386;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1388;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1388 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_3720;
BgL_auxz00_3720 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3720,BFALSE,BFALSE);} 
BgL_endz00_386 = 
STRING_LENGTH(BgL_stringz00_1388); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3725;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3725 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_3728;
BgL_auxz00_3728 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3728,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1318zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_383, BgL_auxz00_3725, 
BINT(((long)0)), 
BINT(BgL_endz00_386)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1318zd2_365))
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1848z00_387;obj_t BgL_arg1849z00_388;
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1389;
BgL_arg1858z00_1389 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3738;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2445z00_1938;
BgL_aux2445z00_1938 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3077z00_3739;
if(
PAIRP(BgL_aux2445z00_1938))
{ /* bmem/bmem.scm 225 */
BgL_test3077z00_3739 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3077z00_3739 = 
NULLP(BgL_aux2445z00_1938)
; } 
if(BgL_test3077z00_3739)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3738 = BgL_aux2445z00_1938
; }  else 
{ 
obj_t BgL_auxz00_3743;
BgL_auxz00_3743 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2445z00_1938); 
FAILURE(BgL_auxz00_3743,BFALSE,BFALSE);} } } 
BgL_arg1848z00_387 = 
bgl_list_ref(BgL_auxz00_3738, BgL_arg1858z00_1389); } } 
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1390;
BgL_arg1858z00_1390 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3749;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2447z00_1940;
BgL_aux2447z00_1940 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3079z00_3750;
if(
PAIRP(BgL_aux2447z00_1940))
{ /* bmem/bmem.scm 225 */
BgL_test3079z00_3750 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3079z00_3750 = 
NULLP(BgL_aux2447z00_1940)
; } 
if(BgL_test3079z00_3750)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3749 = BgL_aux2447z00_1940
; }  else 
{ 
obj_t BgL_auxz00_3754;
BgL_auxz00_3754 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2447z00_1940); 
FAILURE(BgL_auxz00_3754,BFALSE,BFALSE);} } } 
BgL_arg1849z00_388 = 
bgl_list_ref(BgL_auxz00_3749, BgL_arg1858z00_1390); } } 
{ /* bmem/bmem.scm 232 */
obj_t BgL_list1850z00_389;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1851z00_390;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1852z00_391;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1853z00_392;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1854z00_393;
BgL_arg1854z00_393 = 
MAKE_YOUNG_PAIR(BGl_string2669z00zzbmemz00, BNIL); 
BgL_arg1853z00_392 = 
MAKE_YOUNG_PAIR(BgL_arg1849z00_388, BgL_arg1854z00_393); } 
BgL_arg1852z00_391 = 
MAKE_YOUNG_PAIR(BGl_string2670z00zzbmemz00, BgL_arg1853z00_392); } 
BgL_arg1851z00_390 = 
MAKE_YOUNG_PAIR(BgL_arg1848z00_387, BgL_arg1852z00_391); } 
BgL_list1850z00_389 = 
MAKE_YOUNG_PAIR(BGl_string2672z00zzbmemz00, BgL_arg1851z00_390); } 
BgL_aux2240z00_1080 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1850z00_389); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_394;
BgL_patz00_394 = BGl_pregexp1565z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_397;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1391;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1391 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_3767;
BgL_auxz00_3767 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3767,BFALSE,BFALSE);} 
BgL_endz00_397 = 
STRING_LENGTH(BgL_stringz00_1391); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3772;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3772 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_3775;
BgL_auxz00_3775 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3775,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1318zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_394, BgL_auxz00_3772, 
BINT(((long)0)), 
BINT(BgL_endz00_397)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1318zd2_365))
{ /* bmem/bmem.scm 234 */
obj_t BgL_arg1855z00_398;
{ /* bmem/bmem.scm 225 */
long BgL_arg1858z00_1392;
BgL_arg1858z00_1392 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_3785;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2453z00_1946;
BgL_aux2453z00_1946 = BgL_pregexpzd2tmp1318zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3084z00_3786;
if(
PAIRP(BgL_aux2453z00_1946))
{ /* bmem/bmem.scm 225 */
BgL_test3084z00_3786 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3084z00_3786 = 
NULLP(BgL_aux2453z00_1946)
; } 
if(BgL_test3084z00_3786)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_3785 = BgL_aux2453z00_1946
; }  else 
{ 
obj_t BgL_auxz00_3790;
BgL_auxz00_3790 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8428)), BGl_string2668z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2453z00_1946); 
FAILURE(BgL_auxz00_3790,BFALSE,BFALSE);} } } 
BgL_arg1855z00_398 = 
bgl_list_ref(BgL_auxz00_3785, BgL_arg1858z00_1392); } } 
{ /* bmem/bmem.scm 234 */
obj_t BgL_tmpz00_3795;
if(
STRINGP(BgL_arg1855z00_398))
{ /* bmem/bmem.scm 234 */
BgL_tmpz00_3795 = BgL_arg1855z00_398
; }  else 
{ 
obj_t BgL_auxz00_3798;
BgL_auxz00_3798 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8749)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg1855z00_398); 
FAILURE(BgL_auxz00_3798,BFALSE,BFALSE);} 
BgL_aux2240z00_1080 = 
string_append_3(BGl_string2672z00zzbmemz00, BgL_tmpz00_3795, BGl_string2669z00zzbmemz00); } }  else 
{ /* bmem/bmem.scm 236 */
obj_t BgL_auxz00_3803;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 236 */
BgL_auxz00_3803 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_3806;
BgL_auxz00_3806 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)8815)), BGl_string2668z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_3806,BFALSE,BFALSE);} 
BgL_aux2240z00_1080 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_3803); } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2243z00_1079); 
return BgL_aux2240z00_1080;} } } } 

}



/* &function-ident-pp */
obj_t BGl_z62functionzd2identzd2ppz62zzbmemz00(obj_t BgL_envz00_1761, obj_t BgL_identz00_1762)
{
{ /* bmem/bmem.scm 223 */
return 
BGl_functionzd2identzd2ppz00zzbmemz00(BgL_identz00_1762);} 

}



/* function-ref */
BGL_EXPORTED_DEF obj_t BGl_functionzd2refzd2zzbmemz00(obj_t BgL_identz00_9)
{
{ /* bmem/bmem.scm 241 */
{ /* bmem/bmem.scm 242 */
obj_t BgL_name2245z00_1081;obj_t BgL_loc2246z00_1082;obj_t BgL_env2247z00_1083;
BgL_name2245z00_1081 = 
CNST_TABLE_REF(((long)56)); 
BgL_loc2246z00_1082 = 
CNST_TABLE_REF(((long)57)); 
BgL_env2247z00_1083 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 242 */

BGL_ENV_PUSH_TRACE(BgL_env2247z00_1083, BgL_name2245z00_1081, BgL_loc2246z00_1082); 
{ /* bmem/bmem.scm 242 */
BgL_z52htmlzd2elementz80_bglt BgL_aux2244z00_1084;
{ /* bmem/bmem.scm 242 */
obj_t BgL_iz00_404;
if(
SYMBOLP(BgL_identz00_9))
{ /* bmem/bmem.scm 242 */
obj_t BgL_arg1434z00_1394;
BgL_arg1434z00_1394 = 
SYMBOL_TO_STRING(BgL_identz00_9); 
BgL_iz00_404 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_1394); }  else 
{ /* bmem/bmem.scm 242 */
BgL_iz00_404 = BgL_identz00_9; } 
{ /* bmem/bmem.scm 242 */
obj_t BgL_idz00_405;
{ /* bmem/bmem.scm 243 */
obj_t BgL_pregexpzd2tmp1320zd2_424;
BgL_pregexpzd2tmp1320zd2_424 = BNIL; 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_426;
BgL_patz00_426 = BGl_pregexp1566z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_429;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1397;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1397 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_3823;
BgL_auxz00_3823 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3823,BFALSE,BFALSE);} 
BgL_endz00_429 = 
STRING_LENGTH(BgL_stringz00_1397); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3828;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3828 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_3831;
BgL_auxz00_3831 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3831,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1320zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_426, BgL_auxz00_3828, 
BINT(((long)0)), 
BINT(BgL_endz00_429)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1320zd2_424))
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1867z00_430;
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_new1324z00_433;
{ /* bmem/bmem.scm 247 */
obj_t BgL_env1322z00_439;
BgL_env1322z00_439 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 247 */

{ 
long BgL_auxz00_3841;
{ /* bmem/bmem.scm 247 */
obj_t BgL_classz00_1398;
BgL_classz00_1398 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_3841 = 
BGL_CLASS_INDEX(BgL_classz00_1398); } 
bmem_set_allocation_type( BgL_auxz00_3841, 0 ); } 
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_new1321z00_441;
BgL_new1321z00_441 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 247 */
long BgL_arg1875z00_442;
BgL_arg1875z00_442 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1321z00_441), BgL_arg1875z00_442); } 
BgL_new1324z00_433 = BgL_new1321z00_441; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1324z00_433)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1324z00_433)))->BgL_classz00)=((obj_t)BGl_string2674z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1324z00_433)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1324z00_433)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1324z00_433))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_3858;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1870z00_434;obj_t BgL_arg1871z00_435;
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1402;
BgL_arg1894z00_1402 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3860;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2463z00_1956;
BgL_aux2463z00_1956 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3092z00_3861;
if(
PAIRP(BgL_aux2463z00_1956))
{ /* bmem/bmem.scm 243 */
BgL_test3092z00_3861 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3092z00_3861 = 
NULLP(BgL_aux2463z00_1956)
; } 
if(BgL_test3092z00_3861)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3860 = BgL_aux2463z00_1956
; }  else 
{ 
obj_t BgL_auxz00_3865;
BgL_auxz00_3865 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2463z00_1956); 
FAILURE(BgL_auxz00_3865,BFALSE,BFALSE);} } } 
BgL_arg1870z00_434 = 
bgl_list_ref(BgL_auxz00_3860, BgL_arg1894z00_1402); } } 
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1403;
BgL_arg1894z00_1403 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3871;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2465z00_1958;
BgL_aux2465z00_1958 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3094z00_3872;
if(
PAIRP(BgL_aux2465z00_1958))
{ /* bmem/bmem.scm 243 */
BgL_test3094z00_3872 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3094z00_3872 = 
NULLP(BgL_aux2465z00_1958)
; } 
if(BgL_test3094z00_3872)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3871 = BgL_aux2465z00_1958
; }  else 
{ 
obj_t BgL_auxz00_3876;
BgL_auxz00_3876 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2465z00_1958); 
FAILURE(BgL_auxz00_3876,BFALSE,BFALSE);} } } 
BgL_arg1871z00_435 = 
bgl_list_ref(BgL_auxz00_3871, BgL_arg1894z00_1403); } } 
{ /* bmem/bmem.scm 248 */
obj_t BgL_list1872z00_436;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1873z00_437;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1874z00_438;
BgL_arg1874z00_438 = 
MAKE_YOUNG_PAIR(BgL_arg1871z00_435, BNIL); 
BgL_arg1873z00_437 = 
MAKE_YOUNG_PAIR(BGl_string2670z00zzbmemz00, BgL_arg1874z00_438); } 
BgL_list1872z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1870z00_434, BgL_arg1873z00_437); } 
BgL_auxz00_3858 = BgL_list1872z00_436; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1324z00_433))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_3858),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1324z00_433))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1867z00_430 = BgL_new1324z00_433; } 
{ /* bmem/bmem.scm 246 */
obj_t BgL_list1868z00_431;
{ /* bmem/bmem.scm 246 */
obj_t BgL_arg1869z00_432;
BgL_arg1869z00_432 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1867z00_430), BNIL); 
BgL_list1868z00_431 = 
MAKE_YOUNG_PAIR(BGl_string2675z00zzbmemz00, BgL_arg1869z00_432); } 
BgL_idz00_405 = BgL_list1868z00_431; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_443;
BgL_patz00_443 = BGl_pregexp1567z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_446;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1406;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1406 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_3891;
BgL_auxz00_3891 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3891,BFALSE,BFALSE);} 
BgL_endz00_446 = 
STRING_LENGTH(BgL_stringz00_1406); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3896;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3896 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_3899;
BgL_auxz00_3899 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3899,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1320zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_443, BgL_auxz00_3896, 
BINT(((long)0)), 
BINT(BgL_endz00_446)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1320zd2_424))
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1876z00_447;
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_new1328z00_450;
{ /* bmem/bmem.scm 251 */
obj_t BgL_env1326z00_451;
BgL_env1326z00_451 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 251 */

{ 
long BgL_auxz00_3909;
{ /* bmem/bmem.scm 251 */
obj_t BgL_classz00_1407;
BgL_classz00_1407 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_3909 = 
BGL_CLASS_INDEX(BgL_classz00_1407); } 
bmem_set_allocation_type( BgL_auxz00_3909, 0 ); } 
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_new1325z00_453;
BgL_new1325z00_453 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 251 */
long BgL_arg1879z00_454;
BgL_arg1879z00_454 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1325z00_453), BgL_arg1879z00_454); } 
BgL_new1328z00_450 = BgL_new1325z00_453; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1328z00_450)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1328z00_450)))->BgL_classz00)=((obj_t)BGl_string2674z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1328z00_450)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1328z00_450)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1328z00_450))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_3926;
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1411;
BgL_arg1894z00_1411 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3928;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2471z00_1964;
BgL_aux2471z00_1964 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3099z00_3929;
if(
PAIRP(BgL_aux2471z00_1964))
{ /* bmem/bmem.scm 243 */
BgL_test3099z00_3929 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3099z00_3929 = 
NULLP(BgL_aux2471z00_1964)
; } 
if(BgL_test3099z00_3929)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3928 = BgL_aux2471z00_1964
; }  else 
{ 
obj_t BgL_auxz00_3933;
BgL_auxz00_3933 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2471z00_1964); 
FAILURE(BgL_auxz00_3933,BFALSE,BFALSE);} } } 
BgL_auxz00_3926 = 
bgl_list_ref(BgL_auxz00_3928, BgL_arg1894z00_1411); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1328z00_450))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_3926),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1328z00_450))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1876z00_447 = BgL_new1328z00_450; } 
{ /* bmem/bmem.scm 250 */
obj_t BgL_list1877z00_448;
{ /* bmem/bmem.scm 250 */
obj_t BgL_arg1878z00_449;
BgL_arg1878z00_449 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1876z00_447), BNIL); 
BgL_list1877z00_448 = 
MAKE_YOUNG_PAIR(BGl_string2675z00zzbmemz00, BgL_arg1878z00_449); } 
BgL_idz00_405 = BgL_list1877z00_448; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_455;
BgL_patz00_455 = BGl_pregexp1568z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_458;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1413;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1413 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_3945;
BgL_auxz00_3945 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3945,BFALSE,BFALSE);} 
BgL_endz00_458 = 
STRING_LENGTH(BgL_stringz00_1413); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3950;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3950 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_3953;
BgL_auxz00_3953 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_3953,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1320zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_455, BgL_auxz00_3950, 
BINT(((long)0)), 
BINT(BgL_endz00_458)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1320zd2_424))
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1880z00_459;
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_new1332z00_462;
{ /* bmem/bmem.scm 254 */
obj_t BgL_env1330z00_468;
BgL_env1330z00_468 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 254 */

{ 
long BgL_auxz00_3963;
{ /* bmem/bmem.scm 254 */
obj_t BgL_classz00_1414;
BgL_classz00_1414 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_3963 = 
BGL_CLASS_INDEX(BgL_classz00_1414); } 
bmem_set_allocation_type( BgL_auxz00_3963, 0 ); } 
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_new1329z00_470;
BgL_new1329z00_470 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 254 */
long BgL_arg1888z00_471;
BgL_arg1888z00_471 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1329z00_470), BgL_arg1888z00_471); } 
BgL_new1332z00_462 = BgL_new1329z00_470; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1332z00_462)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1332z00_462)))->BgL_classz00)=((obj_t)BGl_string2674z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1332z00_462)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1332z00_462)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1332z00_462))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_3980;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1883z00_463;obj_t BgL_arg1884z00_464;
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1418;
BgL_arg1894z00_1418 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3982;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2477z00_1970;
BgL_aux2477z00_1970 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3104z00_3983;
if(
PAIRP(BgL_aux2477z00_1970))
{ /* bmem/bmem.scm 243 */
BgL_test3104z00_3983 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3104z00_3983 = 
NULLP(BgL_aux2477z00_1970)
; } 
if(BgL_test3104z00_3983)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3982 = BgL_aux2477z00_1970
; }  else 
{ 
obj_t BgL_auxz00_3987;
BgL_auxz00_3987 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2477z00_1970); 
FAILURE(BgL_auxz00_3987,BFALSE,BFALSE);} } } 
BgL_arg1883z00_463 = 
bgl_list_ref(BgL_auxz00_3982, BgL_arg1894z00_1418); } } 
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1419;
BgL_arg1894z00_1419 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_3993;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2479z00_1972;
BgL_aux2479z00_1972 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3106z00_3994;
if(
PAIRP(BgL_aux2479z00_1972))
{ /* bmem/bmem.scm 243 */
BgL_test3106z00_3994 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3106z00_3994 = 
NULLP(BgL_aux2479z00_1972)
; } 
if(BgL_test3106z00_3994)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_3993 = BgL_aux2479z00_1972
; }  else 
{ 
obj_t BgL_auxz00_3998;
BgL_auxz00_3998 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2479z00_1972); 
FAILURE(BgL_auxz00_3998,BFALSE,BFALSE);} } } 
BgL_arg1884z00_464 = 
bgl_list_ref(BgL_auxz00_3993, BgL_arg1894z00_1419); } } 
{ /* bmem/bmem.scm 255 */
obj_t BgL_list1885z00_465;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1886z00_466;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1887z00_467;
BgL_arg1887z00_467 = 
MAKE_YOUNG_PAIR(BgL_arg1884z00_464, BNIL); 
BgL_arg1886z00_466 = 
MAKE_YOUNG_PAIR(BGl_string2670z00zzbmemz00, BgL_arg1887z00_467); } 
BgL_list1885z00_465 = 
MAKE_YOUNG_PAIR(BgL_arg1883z00_463, BgL_arg1886z00_466); } 
BgL_auxz00_3980 = BgL_list1885z00_465; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1332z00_462))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_3980),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1332z00_462))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1880z00_459 = BgL_new1332z00_462; } 
{ /* bmem/bmem.scm 253 */
obj_t BgL_list1881z00_460;
{ /* bmem/bmem.scm 253 */
obj_t BgL_arg1882z00_461;
BgL_arg1882z00_461 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1880z00_459), BNIL); 
BgL_list1881z00_460 = 
MAKE_YOUNG_PAIR(BGl_string2676z00zzbmemz00, BgL_arg1882z00_461); } 
BgL_idz00_405 = BgL_list1881z00_460; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_472;
BgL_patz00_472 = BGl_pregexp1569z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_475;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1422;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1422 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_4013;
BgL_auxz00_4013 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4013,BFALSE,BFALSE);} 
BgL_endz00_475 = 
STRING_LENGTH(BgL_stringz00_1422); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4018;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4018 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4021;
BgL_auxz00_4021 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4021,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1320zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_472, BgL_auxz00_4018, 
BINT(((long)0)), 
BINT(BgL_endz00_475)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1320zd2_424))
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1889z00_476;
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_new1336z00_479;
{ /* bmem/bmem.scm 258 */
obj_t BgL_env1334z00_480;
BgL_env1334z00_480 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 258 */

{ 
long BgL_auxz00_4031;
{ /* bmem/bmem.scm 258 */
obj_t BgL_classz00_1423;
BgL_classz00_1423 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_4031 = 
BGL_CLASS_INDEX(BgL_classz00_1423); } 
bmem_set_allocation_type( BgL_auxz00_4031, 0 ); } 
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_new1333z00_482;
BgL_new1333z00_482 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 258 */
long BgL_arg1892z00_483;
BgL_arg1892z00_483 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1333z00_482), BgL_arg1892z00_483); } 
BgL_new1336z00_479 = BgL_new1333z00_482; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1336z00_479)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1336z00_479)))->BgL_classz00)=((obj_t)BGl_string2674z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1336z00_479)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1336z00_479)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1336z00_479))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4048;
{ /* bmem/bmem.scm 243 */
long BgL_arg1894z00_1427;
BgL_arg1894z00_1427 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4050;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2485z00_1978;
BgL_aux2485z00_1978 = BgL_pregexpzd2tmp1320zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3111z00_4051;
if(
PAIRP(BgL_aux2485z00_1978))
{ /* bmem/bmem.scm 243 */
BgL_test3111z00_4051 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3111z00_4051 = 
NULLP(BgL_aux2485z00_1978)
; } 
if(BgL_test3111z00_4051)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4050 = BgL_aux2485z00_1978
; }  else 
{ 
obj_t BgL_auxz00_4055;
BgL_auxz00_4055 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9145)), BGl_string2673z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2485z00_1978); 
FAILURE(BgL_auxz00_4055,BFALSE,BFALSE);} } } 
BgL_auxz00_4048 = 
bgl_list_ref(BgL_auxz00_4050, BgL_arg1894z00_1427); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1336z00_479))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4048),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1336z00_479))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1889z00_476 = BgL_new1336z00_479; } 
{ /* bmem/bmem.scm 257 */
obj_t BgL_list1890z00_477;
{ /* bmem/bmem.scm 257 */
obj_t BgL_arg1891z00_478;
BgL_arg1891z00_478 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1889z00_476), BNIL); 
BgL_list1890z00_477 = 
MAKE_YOUNG_PAIR(BGl_string2676z00zzbmemz00, BgL_arg1891z00_478); } 
BgL_idz00_405 = BgL_list1890z00_477; } }  else 
{ /* bmem/bmem.scm 260 */
obj_t BgL_auxz00_4065;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 260 */
BgL_auxz00_4065 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4068;
BgL_auxz00_4068 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)9702)), BGl_string2673z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4068,BFALSE,BFALSE);} 
BgL_idz00_405 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_4065); } } } } } } 
{ /* bmem/bmem.scm 243 */
BgL_z52htmlzd2boxz80_bglt BgL_hidz00_406;
{ /* bmem/bmem.scm 261 */
BgL_z52htmlzd2boxz80_bglt BgL_new1340z00_418;
{ /* bmem/bmem.scm 261 */
obj_t BgL_env1338z00_419;
BgL_env1338z00_419 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 261 */

{ 
long BgL_auxz00_4074;
{ /* bmem/bmem.scm 261 */
obj_t BgL_classz00_1429;
BgL_classz00_1429 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_4074 = 
BGL_CLASS_INDEX(BgL_classz00_1429); } 
bmem_set_allocation_type( BgL_auxz00_4074, 0 ); } 
{ /* bmem/bmem.scm 261 */
BgL_z52htmlzd2boxz80_bglt BgL_new1337z00_421;
BgL_new1337z00_421 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 261 */
long BgL_arg1866z00_422;
BgL_arg1866z00_422 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1337z00_421), BgL_arg1866z00_422); } 
BgL_new1340z00_418 = BgL_new1337z00_421; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1340z00_418)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1340z00_418)))->BgL_classz00)=((obj_t)BGl_string2677z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1340z00_418)))->BgL_titlez00)=((obj_t)BgL_iz00_404),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1340z00_418)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1340z00_418))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1340z00_418))->BgL_inlineza2za2)=((obj_t)BgL_idz00_405),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1340z00_418))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_hidz00_406 = BgL_new1340z00_418; } 
{ /* bmem/bmem.scm 261 */

if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 264 */
obj_t BgL_urlz00_408;
{ /* bmem/bmem.scm 264 */
obj_t BgL_list1862z00_414;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1863z00_415;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1864z00_416;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1865z00_417;
BgL_arg1865z00_417 = 
MAKE_YOUNG_PAIR(BgL_identz00_9, BNIL); 
BgL_arg1864z00_416 = 
MAKE_YOUNG_PAIR(BGl_za2fileza2z00zzbmem_paramz00, BgL_arg1865z00_417); } 
BgL_arg1863z00_415 = 
MAKE_YOUNG_PAIR(BGl_za2portza2z00zzbmem_paramz00, BgL_arg1864z00_416); } 
BgL_list1862z00_414 = 
MAKE_YOUNG_PAIR(BGl_za2hostnameza2z00zzbmem_paramz00, BgL_arg1863z00_415); } 
BgL_urlz00_408 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2678z00zzbmemz00, BgL_list1862z00_414); } 
{ /* bmem/bmem.scm 269 */
BgL_z52htmlzd2az80_bglt BgL_new1344z00_409;
{ /* bmem/bmem.scm 269 */
obj_t BgL_env1342z00_410;
BgL_env1342z00_410 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 269 */

{ 
long BgL_auxz00_4101;
{ /* bmem/bmem.scm 269 */
obj_t BgL_classz00_1433;
BgL_classz00_1433 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4101 = 
BGL_CLASS_INDEX(BgL_classz00_1433); } 
bmem_set_allocation_type( BgL_auxz00_4101, 0 ); } 
{ /* bmem/bmem.scm 269 */
BgL_z52htmlzd2az80_bglt BgL_new1341z00_412;
BgL_new1341z00_412 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 269 */
long BgL_arg1861z00_413;
BgL_arg1861z00_413 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1341z00_412), BgL_arg1861z00_413); } 
BgL_new1344z00_409 = BgL_new1341z00_412; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1344z00_409)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1344z00_409)))->BgL_classz00)=((obj_t)BGl_string2673z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1344z00_409)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1344z00_409)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1344z00_409))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1344z00_409))->BgL_hrefz00)=((obj_t)BgL_urlz00_408),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1344z00_409))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1344z00_409))->BgL_inlineza2za2)=((obj_t)
((obj_t)BgL_hidz00_406)),BUNSPEC); 
BgL_aux2244z00_1084 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_new1344z00_409); } }  else 
{ /* bmem/bmem.scm 262 */
BgL_aux2244z00_1084 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_hidz00_406); } } } } } 
BGL_ENV_POP_TRACE(BgL_env2247z00_1083); 
return 
((obj_t)BgL_aux2244z00_1084);} } } } 

}



/* &function-ref */
obj_t BGl_z62functionzd2refzb0zzbmemz00(obj_t BgL_envz00_1763, obj_t BgL_identz00_1764)
{
{ /* bmem/bmem.scm 241 */
return 
BGl_functionzd2refzd2zzbmemz00(BgL_identz00_1764);} 

}



/* type-ref */
BGL_EXPORTED_DEF obj_t BGl_typezd2refzd2zzbmemz00(obj_t BgL_identz00_10)
{
{ /* bmem/bmem.scm 274 */
{ /* bmem/bmem.scm 275 */
obj_t BgL_name2249z00_1085;obj_t BgL_loc2250z00_1086;obj_t BgL_env2251z00_1087;
BgL_name2249z00_1085 = 
CNST_TABLE_REF(((long)59)); 
BgL_loc2250z00_1086 = 
CNST_TABLE_REF(((long)60)); 
BgL_env2251z00_1087 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 275 */

BGL_ENV_PUSH_TRACE(BgL_env2251z00_1087, BgL_name2249z00_1085, BgL_loc2250z00_1086); 
{ /* bmem/bmem.scm 275 */
BgL_z52htmlzd2elementz80_bglt BgL_aux2248z00_1088;
{ /* bmem/bmem.scm 275 */
obj_t BgL_identz00_489;
{ /* bmem/bmem.scm 275 */
obj_t BgL_auxz00_4130;
if(
STRINGP(BgL_identz00_10))
{ /* bmem/bmem.scm 275 */
BgL_auxz00_4130 = BgL_identz00_10
; }  else 
{ 
obj_t BgL_auxz00_4133;
BgL_auxz00_4133 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)10230)), BGl_string2679z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_identz00_10); 
FAILURE(BgL_auxz00_4133,BFALSE,BFALSE);} 
BgL_identz00_489 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_4130); } 
{ /* bmem/bmem.scm 275 */
BgL_z52htmlzd2boxz80_bglt BgL_hidz00_490;
{ /* bmem/bmem.scm 276 */
BgL_z52htmlzd2boxz80_bglt BgL_new1348z00_502;
{ /* bmem/bmem.scm 276 */
obj_t BgL_env1346z00_503;
BgL_env1346z00_503 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 276 */

{ 
long BgL_auxz00_4139;
{ /* bmem/bmem.scm 276 */
obj_t BgL_classz00_1437;
BgL_classz00_1437 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_4139 = 
BGL_CLASS_INDEX(BgL_classz00_1437); } 
bmem_set_allocation_type( BgL_auxz00_4139, 0 ); } 
{ /* bmem/bmem.scm 276 */
BgL_z52htmlzd2boxz80_bglt BgL_new1345z00_505;
BgL_new1345z00_505 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 276 */
long BgL_arg1904z00_506;
BgL_arg1904z00_506 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1345z00_505), BgL_arg1904z00_506); } 
BgL_new1348z00_502 = BgL_new1345z00_505; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1348z00_502)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1348z00_502)))->BgL_classz00)=((obj_t)BGl_string2680z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1348z00_502)))->BgL_titlez00)=((obj_t)BgL_identz00_489),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1348z00_502)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1348z00_502))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1348z00_502))->BgL_inlineza2za2)=((obj_t)BgL_identz00_489),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1348z00_502))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_hidz00_490 = BgL_new1348z00_502; } 
{ /* bmem/bmem.scm 276 */

if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 279 */
obj_t BgL_urlz00_492;
{ /* bmem/bmem.scm 279 */
obj_t BgL_list1898z00_498;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1899z00_499;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1902z00_500;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1903z00_501;
BgL_arg1903z00_501 = 
MAKE_YOUNG_PAIR(BgL_identz00_489, BNIL); 
BgL_arg1902z00_500 = 
MAKE_YOUNG_PAIR(BGl_za2fileza2z00zzbmem_paramz00, BgL_arg1903z00_501); } 
BgL_arg1899z00_499 = 
MAKE_YOUNG_PAIR(BGl_za2portza2z00zzbmem_paramz00, BgL_arg1902z00_500); } 
BgL_list1898z00_498 = 
MAKE_YOUNG_PAIR(BGl_za2hostnameza2z00zzbmem_paramz00, BgL_arg1899z00_499); } 
BgL_urlz00_492 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2681z00zzbmemz00, BgL_list1898z00_498); } 
{ /* bmem/bmem.scm 284 */
BgL_z52htmlzd2az80_bglt BgL_new1352z00_493;
{ /* bmem/bmem.scm 284 */
obj_t BgL_env1350z00_494;
BgL_env1350z00_494 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 284 */

{ 
long BgL_auxz00_4166;
{ /* bmem/bmem.scm 284 */
obj_t BgL_classz00_1441;
BgL_classz00_1441 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4166 = 
BGL_CLASS_INDEX(BgL_classz00_1441); } 
bmem_set_allocation_type( BgL_auxz00_4166, 0 ); } 
{ /* bmem/bmem.scm 284 */
BgL_z52htmlzd2az80_bglt BgL_new1349z00_496;
BgL_new1349z00_496 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 284 */
long BgL_arg1897z00_497;
BgL_arg1897z00_497 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1349z00_496), BgL_arg1897z00_497); } 
BgL_new1352z00_493 = BgL_new1349z00_496; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1352z00_493)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1352z00_493)))->BgL_classz00)=((obj_t)BGl_string2679z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1352z00_493)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1352z00_493)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1352z00_493))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1352z00_493))->BgL_hrefz00)=((obj_t)BgL_urlz00_492),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1352z00_493))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1352z00_493))->BgL_inlineza2za2)=((obj_t)
((obj_t)BgL_hidz00_490)),BUNSPEC); 
BgL_aux2248z00_1088 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_new1352z00_493); } }  else 
{ /* bmem/bmem.scm 277 */
BgL_aux2248z00_1088 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_hidz00_490); } } } } 
BGL_ENV_POP_TRACE(BgL_env2251z00_1087); 
return 
((obj_t)BgL_aux2248z00_1088);} } } } 

}



/* &type-ref */
obj_t BGl_z62typezd2refzb0zzbmemz00(obj_t BgL_envz00_1765, obj_t BgL_identz00_1766)
{
{ /* bmem/bmem.scm 274 */
return 
BGl_typezd2refzd2zzbmemz00(BgL_identz00_1766);} 

}



/* bmem-all */
BgL_z52htmlzd2documentz80_bglt BGl_bmemzd2allzd2zzbmemz00(obj_t BgL_cssz00_11, obj_t BgL_infoz00_12, obj_t BgL_gcmonz00_13, obj_t BgL_funmonz00_14, obj_t BgL_typesz00_15, obj_t BgL_threadz00_16)
{
{ /* bmem/bmem.scm 290 */
{ /* bmem/bmem.scm 291 */
obj_t BgL_name2253z00_1089;obj_t BgL_loc2254z00_1090;obj_t BgL_env2255z00_1091;
BgL_name2253z00_1089 = 
CNST_TABLE_REF(((long)61)); 
BgL_loc2254z00_1090 = 
CNST_TABLE_REF(((long)62)); 
BgL_env2255z00_1091 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 291 */

BGL_ENV_PUSH_TRACE(BgL_env2255z00_1091, BgL_name2253z00_1089, BgL_loc2254z00_1090); 
{ /* bmem/bmem.scm 291 */
BgL_z52htmlzd2documentz80_bglt BgL_aux2252z00_1092;
{ /* bmem/bmem.scm 291 */
obj_t BgL_functionsz00_507;
BgL_functionsz00_507 = 
BGl_getzd2functionszd2zzbmem_functionz00(); 
{ /* bmem/bmem.scm 291 */
obj_t BgL_gctablez00_508;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 293 */
obj_t BgL_auxz00_4198;
{ /* bmem/bmem.scm 293 */
bool_t BgL_test3118z00_4199;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 293 */
BgL_test3118z00_4199 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 293 */
BgL_test3118z00_4199 = 
NULLP(BgL_typesz00_15)
; } 
if(BgL_test3118z00_4199)
{ /* bmem/bmem.scm 293 */
BgL_auxz00_4198 = BgL_typesz00_15
; }  else 
{ 
obj_t BgL_auxz00_4203;
BgL_auxz00_4203 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)10870)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_typesz00_15); 
FAILURE(BgL_auxz00_4203,BFALSE,BFALSE);} } 
BgL_gctablez00_508 = 
BGl_makezd2gczd2tablesz00zzbmem_gcz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_auxz00_4198); }  else 
{ /* bmem/bmem.scm 292 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string2683z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2602z00zzbmemz00), ((long)10886)); 
BgL_gctablez00_508 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2602z00zzbmemz00, 
BINT(((long)10886))); } 
{ /* bmem/bmem.scm 292 */
obj_t BgL_funtablez00_509;
if(
PAIRP(BgL_funmonz00_14))
{ /* bmem/bmem.scm 297 */
BgL_funtablez00_509 = 
BGl_makezd2functionzd2tablesz00zzbmem_functionz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_typesz00_15); }  else 
{ /* bmem/bmem.scm 297 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string2684z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2602z00zzbmemz00), ((long)11030)); 
BgL_funtablez00_509 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2602z00zzbmemz00, 
BINT(((long)11030))); } 
{ /* bmem/bmem.scm 297 */
obj_t BgL_typetablez00_510;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 303 */
obj_t BgL_auxz00_4223;
{ /* bmem/bmem.scm 303 */
bool_t BgL_test3122z00_4224;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 303 */
BgL_test3122z00_4224 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 303 */
BgL_test3122z00_4224 = 
NULLP(BgL_gcmonz00_13)
; } 
if(BgL_test3122z00_4224)
{ /* bmem/bmem.scm 303 */
BgL_auxz00_4223 = BgL_gcmonz00_13
; }  else 
{ 
obj_t BgL_auxz00_4228;
BgL_auxz00_4228 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11153)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_4228,BFALSE,BFALSE);} } 
BgL_typetablez00_510 = 
BGl_makezd2typezd2tablesz00zzbmem_typez00(BgL_auxz00_4223, BgL_functionsz00_507, BgL_typesz00_15); }  else 
{ /* bmem/bmem.scm 302 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string2685z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2602z00zzbmemz00), ((long)11180)); 
BgL_typetablez00_510 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2602z00zzbmemz00, 
BINT(((long)11180))); } 
{ /* bmem/bmem.scm 302 */
obj_t BgL_threadtablez00_511;
if(
PAIRP(BgL_threadz00_16))
{ /* bmem/bmem.scm 307 */
BgL_threadtablez00_511 = 
BGl_makezd2threadzd2tablez00zzbmem_threadz00(BgL_threadz00_16); }  else 
{ /* bmem/bmem.scm 307 */
BgL_threadtablez00_511 = BGl_string2686z00zzbmemz00; } 
{ /* bmem/bmem.scm 307 */
obj_t BgL_dcssz00_512;
BgL_dcssz00_512 = 
BGl_dynamiczd2csszd2zzbmemz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_typesz00_15); 
{ /* bmem/bmem.scm 310 */
obj_t BgL_marginz00_513;
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_arg1989z00_697;BgL_z52htmlzd2headingz80_bglt BgL_arg1990z00_698;BgL_z52htmlzd2boxz80_bglt BgL_arg1991z00_699;BgL_z52htmlzd2headingz80_bglt BgL_arg1992z00_700;obj_t BgL_arg1993z00_701;BgL_z52htmlzd2brz80_bglt BgL_arg1994z00_702;obj_t BgL_arg1995z00_703;BgL_z52htmlzd2brz80_bglt BgL_arg1996z00_704;obj_t BgL_arg1997z00_705;
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_new1356z00_715;
{ /* bmem/bmem.scm 311 */
obj_t BgL_env1354z00_716;
BgL_env1354z00_716 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 311 */

{ 
long BgL_auxz00_4243;
{ /* bmem/bmem.scm 311 */
obj_t BgL_classz00_1445;
BgL_classz00_1445 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4243 = 
BGL_CLASS_INDEX(BgL_classz00_1445); } 
bmem_set_allocation_type( BgL_auxz00_4243, 0 ); } 
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_new1353z00_718;
BgL_new1353z00_718 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 311 */
long BgL_arg2007z00_719;
BgL_arg2007z00_719 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1353z00_718), BgL_arg2007z00_719); } 
BgL_new1356z00_715 = BgL_new1353z00_718; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1356z00_715)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1356z00_715)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1356z00_715)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1356z00_715)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1356z00_715))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1356z00_715))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4261;
{ /* bmem/bmem.scm 311 */
obj_t BgL_tmpz00_4262;
{ /* bmem/bmem.scm 311 */
obj_t BgL_aux2495z00_1988;
BgL_aux2495z00_1988 = BGl_za2bmemzd2versionza2zd2zzbmem_paramz00; 
if(
STRINGP(BgL_aux2495z00_1988))
{ /* bmem/bmem.scm 311 */
BgL_tmpz00_4262 = BgL_aux2495z00_1988
; }  else 
{ 
obj_t BgL_auxz00_4265;
BgL_auxz00_4265 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11380)), BGl_string2682z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2495z00_1988); 
FAILURE(BgL_auxz00_4265,BFALSE,BFALSE);} } 
BgL_auxz00_4261 = 
string_append(BGl_string2687z00zzbmemz00, BgL_tmpz00_4262); } 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1356z00_715))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4261),BUNSPEC); } 
BgL_arg1989z00_697 = BgL_new1356z00_715; } 
{ /* bmem/bmem.scm 312 */
BgL_z52htmlzd2headingz80_bglt BgL_new1360z00_720;
{ /* bmem/bmem.scm 312 */
obj_t BgL_env1358z00_721;
BgL_env1358z00_721 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 312 */

{ 
long BgL_auxz00_4272;
{ /* bmem/bmem.scm 312 */
obj_t BgL_classz00_1449;
BgL_classz00_1449 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4272 = 
BGL_CLASS_INDEX(BgL_classz00_1449); } 
bmem_set_allocation_type( BgL_auxz00_4272, 0 ); } 
{ /* bmem/bmem.scm 312 */
BgL_z52htmlzd2headingz80_bglt BgL_new1357z00_723;
BgL_new1357z00_723 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 312 */
long BgL_arg2008z00_724;
BgL_arg2008z00_724 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1357z00_723), BgL_arg2008z00_724); } 
BgL_new1360z00_720 = BgL_new1357z00_723; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1360z00_720)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1360z00_720)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1360z00_720)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1360z00_720)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1360z00_720))->BgL_levelz00)=((int)
(int)(((long)2))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1360z00_720))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1360z00_720))->BgL_inlineza2za2)=((obj_t)BGl_string2688z00zzbmemz00),BUNSPEC); 
BgL_arg1990z00_698 = BgL_new1360z00_720; } 
{ /* bmem/bmem.scm 313 */
BgL_z52htmlzd2boxz80_bglt BgL_new1364z00_725;
{ /* bmem/bmem.scm 313 */
obj_t BgL_env1362z00_753;
BgL_env1362z00_753 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 313 */

{ 
long BgL_auxz00_4292;
{ /* bmem/bmem.scm 313 */
obj_t BgL_classz00_1453;
BgL_classz00_1453 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_4292 = 
BGL_CLASS_INDEX(BgL_classz00_1453); } 
bmem_set_allocation_type( BgL_auxz00_4292, 0 ); } 
{ /* bmem/bmem.scm 313 */
BgL_z52htmlzd2boxz80_bglt BgL_new1361z00_755;
BgL_new1361z00_755 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 313 */
long BgL_arg2020z00_756;
BgL_arg2020z00_756 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1361z00_755), BgL_arg2020z00_756); } 
BgL_new1364z00_725 = BgL_new1361z00_755; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1364z00_725)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1364z00_725)))->BgL_classz00)=((obj_t)BGl_string2689z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1364z00_725)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1364z00_725)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1364z00_725))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4309;
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_arg2009z00_726;BgL_z52htmlzd2az80_bglt BgL_arg2010z00_727;BgL_z52htmlzd2az80_bglt BgL_arg2011z00_728;BgL_z52htmlzd2az80_bglt BgL_arg2012z00_729;
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_new1368z00_733;
{ /* bmem/bmem.scm 315 */
obj_t BgL_env1366z00_734;
BgL_env1366z00_734 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 315 */

{ 
long BgL_auxz00_4311;
{ /* bmem/bmem.scm 315 */
obj_t BgL_classz00_1457;
BgL_classz00_1457 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4311 = 
BGL_CLASS_INDEX(BgL_classz00_1457); } 
bmem_set_allocation_type( BgL_auxz00_4311, 0 ); } 
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_new1365z00_736;
BgL_new1365z00_736 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 315 */
long BgL_arg2016z00_737;
{ /* bmem/bmem.scm 315 */
obj_t BgL_classz00_1458;
BgL_classz00_1458 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_arg2016z00_737 = 
BGL_CLASS_INDEX(BgL_classz00_1458); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1365z00_736), BgL_arg2016z00_737); } 
BgL_new1368z00_733 = BgL_new1365z00_736; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1368z00_733)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1368z00_733)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1368z00_733)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1368z00_733)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1368z00_733))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1368z00_733))->BgL_hrefz00)=((obj_t)BGl_string2690z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1368z00_733))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1368z00_733))->BgL_inlineza2za2)=((obj_t)BGl_string2691z00zzbmemz00),BUNSPEC); 
BgL_arg2009z00_726 = BgL_new1368z00_733; } 
{ /* bmem/bmem.scm 316 */
BgL_z52htmlzd2az80_bglt BgL_new1372z00_738;
{ /* bmem/bmem.scm 316 */
obj_t BgL_env1370z00_739;
BgL_env1370z00_739 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 316 */

{ 
long BgL_auxz00_4331;
{ /* bmem/bmem.scm 316 */
obj_t BgL_classz00_1461;
BgL_classz00_1461 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4331 = 
BGL_CLASS_INDEX(BgL_classz00_1461); } 
bmem_set_allocation_type( BgL_auxz00_4331, 0 ); } 
{ /* bmem/bmem.scm 316 */
BgL_z52htmlzd2az80_bglt BgL_new1369z00_741;
BgL_new1369z00_741 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 316 */
long BgL_arg2017z00_742;
{ /* bmem/bmem.scm 316 */
obj_t BgL_classz00_1462;
BgL_classz00_1462 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_arg2017z00_742 = 
BGL_CLASS_INDEX(BgL_classz00_1462); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1369z00_741), BgL_arg2017z00_742); } 
BgL_new1372z00_738 = BgL_new1369z00_741; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1372z00_738)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1372z00_738)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1372z00_738)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1372z00_738)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1372z00_738))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1372z00_738))->BgL_hrefz00)=((obj_t)BGl_string2692z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1372z00_738))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1372z00_738))->BgL_inlineza2za2)=((obj_t)BGl_string2693z00zzbmemz00),BUNSPEC); 
BgL_arg2010z00_727 = BgL_new1372z00_738; } 
{ /* bmem/bmem.scm 317 */
BgL_z52htmlzd2az80_bglt BgL_new1376z00_743;
{ /* bmem/bmem.scm 317 */
obj_t BgL_env1374z00_744;
BgL_env1374z00_744 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 317 */

{ 
long BgL_auxz00_4351;
{ /* bmem/bmem.scm 317 */
obj_t BgL_classz00_1465;
BgL_classz00_1465 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4351 = 
BGL_CLASS_INDEX(BgL_classz00_1465); } 
bmem_set_allocation_type( BgL_auxz00_4351, 0 ); } 
{ /* bmem/bmem.scm 317 */
BgL_z52htmlzd2az80_bglt BgL_new1373z00_746;
BgL_new1373z00_746 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 317 */
long BgL_arg2018z00_747;
{ /* bmem/bmem.scm 317 */
obj_t BgL_classz00_1466;
BgL_classz00_1466 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_arg2018z00_747 = 
BGL_CLASS_INDEX(BgL_classz00_1466); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1373z00_746), BgL_arg2018z00_747); } 
BgL_new1376z00_743 = BgL_new1373z00_746; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1376z00_743)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1376z00_743)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1376z00_743)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1376z00_743)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1376z00_743))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1376z00_743))->BgL_hrefz00)=((obj_t)BGl_string2694z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1376z00_743))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1376z00_743))->BgL_inlineza2za2)=((obj_t)BGl_string2695z00zzbmemz00),BUNSPEC); 
BgL_arg2011z00_728 = BgL_new1376z00_743; } 
{ /* bmem/bmem.scm 318 */
BgL_z52htmlzd2az80_bglt BgL_new1380z00_748;
{ /* bmem/bmem.scm 318 */
obj_t BgL_env1378z00_749;
BgL_env1378z00_749 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 318 */

{ 
long BgL_auxz00_4371;
{ /* bmem/bmem.scm 318 */
obj_t BgL_classz00_1469;
BgL_classz00_1469 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4371 = 
BGL_CLASS_INDEX(BgL_classz00_1469); } 
bmem_set_allocation_type( BgL_auxz00_4371, 0 ); } 
{ /* bmem/bmem.scm 318 */
BgL_z52htmlzd2az80_bglt BgL_new1377z00_751;
BgL_new1377z00_751 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 318 */
long BgL_arg2019z00_752;
{ /* bmem/bmem.scm 318 */
obj_t BgL_classz00_1470;
BgL_classz00_1470 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_arg2019z00_752 = 
BGL_CLASS_INDEX(BgL_classz00_1470); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1377z00_751), BgL_arg2019z00_752); } 
BgL_new1380z00_748 = BgL_new1377z00_751; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1380z00_748)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1380z00_748)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1380z00_748)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1380z00_748)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1380z00_748))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1380z00_748))->BgL_hrefz00)=((obj_t)BGl_string2696z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1380z00_748))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1380z00_748))->BgL_inlineza2za2)=((obj_t)BGl_string2697z00zzbmemz00),BUNSPEC); 
BgL_arg2012z00_729 = BgL_new1380z00_748; } 
{ /* bmem/bmem.scm 314 */
obj_t BgL_list2013z00_730;
{ /* bmem/bmem.scm 314 */
obj_t BgL_arg2014z00_731;
{ /* bmem/bmem.scm 314 */
obj_t BgL_arg2015z00_732;
BgL_arg2015z00_732 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2012z00_729), BNIL); 
BgL_arg2014z00_731 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2011z00_728), BgL_arg2015z00_732); } 
BgL_list2013z00_730 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2010z00_727), BgL_arg2014z00_731); } 
BgL_auxz00_4309 = 
BGl_htmlzd2vboxzd2zzhtmlz00(
((obj_t)BgL_arg2009z00_726), BgL_list2013z00_730); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1364z00_725))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4309),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1364z00_725))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1991z00_699 = BgL_new1364z00_725; } 
{ /* bmem/bmem.scm 319 */
BgL_z52htmlzd2headingz80_bglt BgL_new1384z00_757;
{ /* bmem/bmem.scm 319 */
obj_t BgL_env1382z00_758;
BgL_env1382z00_758 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 319 */

{ 
long BgL_auxz00_4401;
{ /* bmem/bmem.scm 319 */
obj_t BgL_classz00_1473;
BgL_classz00_1473 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4401 = 
BGL_CLASS_INDEX(BgL_classz00_1473); } 
bmem_set_allocation_type( BgL_auxz00_4401, 0 ); } 
{ /* bmem/bmem.scm 319 */
BgL_z52htmlzd2headingz80_bglt BgL_new1381z00_760;
BgL_new1381z00_760 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 319 */
long BgL_arg2021z00_761;
BgL_arg2021z00_761 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1381z00_760), BgL_arg2021z00_761); } 
BgL_new1384z00_757 = BgL_new1381z00_760; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1384z00_757)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1384z00_757)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1384z00_757)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1384z00_757)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1384z00_757))->BgL_levelz00)=((int)
(int)(((long)2))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1384z00_757))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1384z00_757))->BgL_inlineza2za2)=((obj_t)BGl_string2698z00zzbmemz00),BUNSPEC); 
BgL_arg1992z00_700 = BgL_new1384z00_757; } 
{ /* bmem/bmem.scm 322 */
obj_t BgL_arg2022z00_762;
{ /* bmem/bmem.scm 322 */
obj_t BgL_l1575z00_763;
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2036z00_785;
{ /* bmem/bmem.scm 326 */
obj_t BgL_hook1574z00_787;
BgL_hook1574z00_787 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ 
obj_t BgL_l1571z00_789;obj_t BgL_h1572z00_790;
BgL_l1571z00_789 = BgL_functionsz00_507; 
BgL_h1572z00_790 = BgL_hook1574z00_787; 
BgL_zc3z04anonymousza32038za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791:
if(
NULLP(BgL_l1571z00_789))
{ /* bmem/bmem.scm 326 */
BgL_arg2036z00_785 = 
CDR(BgL_hook1574z00_787); }  else 
{ /* bmem/bmem.scm 326 */
bool_t BgL_test3127z00_4424;
{ /* bmem/bmem.scm 327 */
BgL_funinfoz00_bglt BgL_i1386z00_801;
{ /* bmem/bmem.scm 327 */
obj_t BgL_pairz00_1478;
if(
PAIRP(BgL_l1571z00_789))
{ /* bmem/bmem.scm 327 */
BgL_pairz00_1478 = BgL_l1571z00_789; }  else 
{ 
obj_t BgL_auxz00_4427;
BgL_auxz00_4427 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11906)), BGl_string2699z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_l1571z00_789); 
FAILURE(BgL_auxz00_4427,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 327 */
obj_t BgL_aux2499z00_1992;
BgL_aux2499z00_1992 = 
CAR(BgL_pairz00_1478); 
if(
BGl_isazf3zf3zz__objectz00(BgL_aux2499z00_1992, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 327 */
BgL_i1386z00_801 = 
((BgL_funinfoz00_bglt)BgL_aux2499z00_1992); }  else 
{ 
obj_t BgL_auxz00_4435;
BgL_auxz00_4435 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11906)), BGl_string2699z00zzbmemz00, BGl_string2700z00zzbmemz00, BgL_aux2499z00_1992); 
FAILURE(BgL_auxz00_4435,BFALSE,BFALSE);} } } 
BgL_test3127z00_4424 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1386z00_801))->BgL_usez00); } 
if(BgL_test3127z00_4424)
{ /* bmem/bmem.scm 326 */
obj_t BgL_nh1573z00_796;
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2042z00_798;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1479;
if(
PAIRP(BgL_l1571z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1479 = BgL_l1571z00_789; }  else 
{ 
obj_t BgL_auxz00_4442;
BgL_auxz00_4442 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11874)), BGl_string2699z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_l1571z00_789); 
FAILURE(BgL_auxz00_4442,BFALSE,BFALSE);} 
BgL_arg2042z00_798 = 
CAR(BgL_pairz00_1479); } 
BgL_nh1573z00_796 = 
MAKE_YOUNG_PAIR(BgL_arg2042z00_798, BNIL); } 
SET_CDR(BgL_h1572z00_790, BgL_nh1573z00_796); 
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2041z00_797;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1481;
if(
PAIRP(BgL_l1571z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1481 = BgL_l1571z00_789; }  else 
{ 
obj_t BgL_auxz00_4451;
BgL_auxz00_4451 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11874)), BGl_string2699z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_l1571z00_789); 
FAILURE(BgL_auxz00_4451,BFALSE,BFALSE);} 
BgL_arg2041z00_797 = 
CDR(BgL_pairz00_1481); } 
{ 
obj_t BgL_h1572z00_4457;obj_t BgL_l1571z00_4456;
BgL_l1571z00_4456 = BgL_arg2041z00_797; 
BgL_h1572z00_4457 = BgL_nh1573z00_796; 
BgL_h1572z00_790 = BgL_h1572z00_4457; 
BgL_l1571z00_789 = BgL_l1571z00_4456; 
goto BgL_zc3z04anonymousza32038za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791;} } }  else 
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2043z00_799;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1482;
if(
PAIRP(BgL_l1571z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1482 = BgL_l1571z00_789; }  else 
{ 
obj_t BgL_auxz00_4460;
BgL_auxz00_4460 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11874)), BGl_string2699z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_l1571z00_789); 
FAILURE(BgL_auxz00_4460,BFALSE,BFALSE);} 
BgL_arg2043z00_799 = 
CDR(BgL_pairz00_1482); } 
{ 
obj_t BgL_l1571z00_4465;
BgL_l1571z00_4465 = BgL_arg2043z00_799; 
BgL_l1571z00_789 = BgL_l1571z00_4465; 
goto BgL_zc3z04anonymousza32038za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791;} } } } } 
BgL_l1575z00_763 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_arg2036z00_785, BGl_proc2701z00zzbmemz00); } 
if(
NULLP(BgL_l1575z00_763))
{ /* bmem/bmem.scm 322 */
BgL_arg2022z00_762 = BNIL; }  else 
{ /* bmem/bmem.scm 322 */
obj_t BgL_head1577z00_765;
BgL_head1577z00_765 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1575z00_767;obj_t BgL_tail1578z00_768;
BgL_l1575z00_767 = BgL_l1575z00_763; 
BgL_tail1578z00_768 = BgL_head1577z00_765; 
BgL_zc3z04anonymousza32024za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3322z04ze3z51_769:
if(
PAIRP(BgL_l1575z00_767))
{ /* bmem/bmem.scm 322 */
obj_t BgL_newtail1579z00_771;
{ /* bmem/bmem.scm 322 */
obj_t BgL_arg2027z00_773;
{ /* bmem/bmem.scm 322 */
obj_t BgL_fz00_774;
BgL_fz00_774 = 
CAR(BgL_l1575z00_767); 
{ /* bmem/bmem.scm 323 */
BgL_funinfoz00_bglt BgL_i1385z00_775;
if(
BGl_isazf3zf3zz__objectz00(BgL_fz00_774, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 324 */
BgL_i1385z00_775 = 
((BgL_funinfoz00_bglt)BgL_fz00_774); }  else 
{ 
obj_t BgL_auxz00_4476;
BgL_auxz00_4476 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)11796)), BGl_string2702z00zzbmemz00, BGl_string2700z00zzbmemz00, BgL_fz00_774); 
FAILURE(BgL_auxz00_4476,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 324 */
obj_t BgL_arg2028z00_776;obj_t BgL_arg2029z00_777;
{ /* bmem/bmem.scm 324 */
int BgL_arg2032z00_780;
BgL_arg2032z00_780 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1385z00_775))->BgL_numz00); 
{ /* bmem/bmem.scm 324 */
obj_t BgL_list2033z00_781;
BgL_list2033z00_781 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2032z00_780), BNIL); 
BgL_arg2028z00_776 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2703z00zzbmemz00, BgL_list2033z00_781); } } 
BgL_arg2029z00_777 = 
BGl_functionzd2refzd2zzbmemz00(
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1385z00_775))->BgL_identz00)); 
{ /* bmem/bmem.scm 324 */
obj_t BgL_list2030z00_778;
{ /* bmem/bmem.scm 324 */
obj_t BgL_arg2031z00_779;
BgL_arg2031z00_779 = 
MAKE_YOUNG_PAIR(BgL_arg2029z00_777, BNIL); 
BgL_list2030z00_778 = 
MAKE_YOUNG_PAIR(BgL_arg2028z00_776, BgL_arg2031z00_779); } 
BgL_arg2027z00_773 = BgL_list2030z00_778; } } } } 
BgL_newtail1579z00_771 = 
MAKE_YOUNG_PAIR(BgL_arg2027z00_773, BNIL); } 
SET_CDR(BgL_tail1578z00_768, BgL_newtail1579z00_771); 
{ 
obj_t BgL_tail1578z00_4492;obj_t BgL_l1575z00_4490;
BgL_l1575z00_4490 = 
CDR(BgL_l1575z00_767); 
BgL_tail1578z00_4492 = BgL_newtail1579z00_771; 
BgL_tail1578z00_768 = BgL_tail1578z00_4492; 
BgL_l1575z00_767 = BgL_l1575z00_4490; 
goto BgL_zc3z04anonymousza32024za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3322z04ze3z51_769;} }  else 
{ /* bmem/bmem.scm 322 */
if(
NULLP(BgL_l1575z00_767))
{ /* bmem/bmem.scm 322 */
BgL_arg2022z00_762 = 
CDR(BgL_head1577z00_765); }  else 
{ /* bmem/bmem.scm 322 */
BgL_arg2022z00_762 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2704z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1575z00_767, BGl_string2602z00zzbmemz00, 
BINT(((long)11730))); } } } } } 
{ /* bmem/bmem.scm 320 */
obj_t BgL_auxz00_4498;
{ /* bmem/bmem.scm 335 */
bool_t BgL_test3137z00_4500;
if(
PAIRP(BgL_arg2022z00_762))
{ /* bmem/bmem.scm 335 */
BgL_test3137z00_4500 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 335 */
BgL_test3137z00_4500 = 
NULLP(BgL_arg2022z00_762)
; } 
if(BgL_test3137z00_4500)
{ /* bmem/bmem.scm 335 */
BgL_auxz00_4498 = BgL_arg2022z00_762
; }  else 
{ 
obj_t BgL_auxz00_4504;
BgL_auxz00_4504 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12170)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_arg2022z00_762); 
FAILURE(BgL_auxz00_4504,BFALSE,BFALSE);} } 
BgL_arg1993z00_701 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string2705z00zzbmemz00, BgL_auxz00_4498, BGl_string2691z00zzbmemz00, BGl_string2706z00zzbmemz00); } } 
{ /* bmem/bmem.scm 337 */
BgL_z52htmlzd2brz80_bglt BgL_new1392z00_813;
{ /* bmem/bmem.scm 337 */
obj_t BgL_env1390z00_814;
BgL_env1390z00_814 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 337 */

{ 
long BgL_auxz00_4510;
{ /* bmem/bmem.scm 337 */
obj_t BgL_classz00_1500;
BgL_classz00_1500 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4510 = 
BGL_CLASS_INDEX(BgL_classz00_1500); } 
bmem_set_allocation_type( BgL_auxz00_4510, 0 ); } 
{ /* bmem/bmem.scm 337 */
BgL_z52htmlzd2brz80_bglt BgL_new1389z00_816;
BgL_new1389z00_816 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 337 */
long BgL_arg2049z00_817;
BgL_arg2049z00_817 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1389z00_816), BgL_arg2049z00_817); } 
BgL_new1392z00_813 = BgL_new1389z00_816; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1392z00_813)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1392z00_813)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1392z00_813)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1392z00_813)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1994z00_702 = BgL_new1392z00_813; } 
{ /* bmem/bmem.scm 340 */
obj_t BgL_arg2050z00_818;
{ /* bmem/bmem.scm 340 */
obj_t BgL_l1580z00_819;
{ /* bmem/bmem.scm 343 */
obj_t BgL_arg2064z00_840;
{ /* bmem/bmem.scm 343 */
obj_t BgL_pairz00_1504;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 343 */
BgL_pairz00_1504 = BgL_typesz00_15; }  else 
{ 
obj_t BgL_auxz00_4527;
BgL_auxz00_4527 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12359)), BGl_string2682z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_typesz00_15); 
FAILURE(BgL_auxz00_4527,BFALSE,BFALSE);} 
BgL_arg2064z00_840 = 
CDR(BgL_pairz00_1504); } 
BgL_l1580z00_819 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_arg2064z00_840, BGl_proc2707z00zzbmemz00); } 
if(
NULLP(BgL_l1580z00_819))
{ /* bmem/bmem.scm 340 */
BgL_arg2050z00_818 = BNIL; }  else 
{ /* bmem/bmem.scm 340 */
obj_t BgL_head1582z00_821;
BgL_head1582z00_821 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1580z00_823;obj_t BgL_tail1583z00_824;
BgL_l1580z00_823 = BgL_l1580z00_819; 
BgL_tail1583z00_824 = BgL_head1582z00_821; 
BgL_zc3z04anonymousza32052za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3340z04ze3z51_825:
if(
PAIRP(BgL_l1580z00_823))
{ /* bmem/bmem.scm 340 */
obj_t BgL_newtail1584z00_827;
{ /* bmem/bmem.scm 340 */
obj_t BgL_arg2055z00_829;
{ /* bmem/bmem.scm 340 */
obj_t BgL_tz00_830;
BgL_tz00_830 = 
CAR(BgL_l1580z00_823); 
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2056z00_831;obj_t BgL_arg2057z00_832;
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2060z00_835;
{ /* bmem/bmem.scm 341 */
obj_t BgL_pairz00_1518;
if(
PAIRP(BgL_tz00_830))
{ /* bmem/bmem.scm 341 */
BgL_pairz00_1518 = BgL_tz00_830; }  else 
{ 
obj_t BgL_auxz00_4541;
BgL_auxz00_4541 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12302)), BGl_string2708z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_830); 
FAILURE(BgL_auxz00_4541,BFALSE,BFALSE);} 
BgL_arg2060z00_835 = 
CAR(BgL_pairz00_1518); } 
{ /* bmem/bmem.scm 341 */
obj_t BgL_list2061z00_836;
BgL_list2061z00_836 = 
MAKE_YOUNG_PAIR(BgL_arg2060z00_835, BNIL); 
BgL_arg2056z00_831 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2709z00zzbmemz00, BgL_list2061z00_836); } } 
{ /* bmem/bmem.scm 342 */
obj_t BgL_arg2062z00_837;
{ /* bmem/bmem.scm 342 */
obj_t BgL_pairz00_1519;
if(
PAIRP(BgL_tz00_830))
{ /* bmem/bmem.scm 342 */
BgL_pairz00_1519 = BgL_tz00_830; }  else 
{ 
obj_t BgL_auxz00_4550;
BgL_auxz00_4550 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12333)), BGl_string2708z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_830); 
FAILURE(BgL_auxz00_4550,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 342 */
obj_t BgL_pairz00_1522;
{ /* bmem/bmem.scm 342 */
obj_t BgL_aux2517z00_2014;
BgL_aux2517z00_2014 = 
CDR(BgL_pairz00_1519); 
if(
PAIRP(BgL_aux2517z00_2014))
{ /* bmem/bmem.scm 342 */
BgL_pairz00_1522 = BgL_aux2517z00_2014; }  else 
{ 
obj_t BgL_auxz00_4557;
BgL_auxz00_4557 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12327)), BGl_string2708z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2517z00_2014); 
FAILURE(BgL_auxz00_4557,BFALSE,BFALSE);} } 
BgL_arg2062z00_837 = 
CAR(BgL_pairz00_1522); } } 
BgL_arg2057z00_832 = 
BGl_typezd2refzd2zzbmemz00(BgL_arg2062z00_837); } 
{ /* bmem/bmem.scm 341 */
obj_t BgL_list2058z00_833;
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2059z00_834;
BgL_arg2059z00_834 = 
MAKE_YOUNG_PAIR(BgL_arg2057z00_832, BNIL); 
BgL_list2058z00_833 = 
MAKE_YOUNG_PAIR(BgL_arg2056z00_831, BgL_arg2059z00_834); } 
BgL_arg2055z00_829 = BgL_list2058z00_833; } } } 
BgL_newtail1584z00_827 = 
MAKE_YOUNG_PAIR(BgL_arg2055z00_829, BNIL); } 
SET_CDR(BgL_tail1583z00_824, BgL_newtail1584z00_827); 
{ 
obj_t BgL_tail1583z00_4569;obj_t BgL_l1580z00_4567;
BgL_l1580z00_4567 = 
CDR(BgL_l1580z00_823); 
BgL_tail1583z00_4569 = BgL_newtail1584z00_827; 
BgL_tail1583z00_824 = BgL_tail1583z00_4569; 
BgL_l1580z00_823 = BgL_l1580z00_4567; 
goto BgL_zc3z04anonymousza32052za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3340z04ze3z51_825;} }  else 
{ /* bmem/bmem.scm 340 */
if(
NULLP(BgL_l1580z00_823))
{ /* bmem/bmem.scm 340 */
BgL_arg2050z00_818 = 
CDR(BgL_head1582z00_821); }  else 
{ /* bmem/bmem.scm 340 */
BgL_arg2050z00_818 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2704z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1580z00_823, BGl_string2602z00zzbmemz00, 
BINT(((long)12252))); } } } } } 
{ /* bmem/bmem.scm 338 */
obj_t BgL_auxz00_4575;
{ /* bmem/bmem.scm 345 */
bool_t BgL_test3146z00_4577;
if(
PAIRP(BgL_arg2050z00_818))
{ /* bmem/bmem.scm 345 */
BgL_test3146z00_4577 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 345 */
BgL_test3146z00_4577 = 
NULLP(BgL_arg2050z00_818)
; } 
if(BgL_test3146z00_4577)
{ /* bmem/bmem.scm 345 */
BgL_auxz00_4575 = BgL_arg2050z00_818
; }  else 
{ 
obj_t BgL_auxz00_4581;
BgL_auxz00_4581 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12433)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_arg2050z00_818); 
FAILURE(BgL_auxz00_4581,BFALSE,BFALSE);} } 
BgL_arg1995z00_703 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string2705z00zzbmemz00, BgL_auxz00_4575, BGl_string2693z00zzbmemz00, BGl_string2710z00zzbmemz00); } } 
{ /* bmem/bmem.scm 347 */
BgL_z52htmlzd2brz80_bglt BgL_new1396z00_848;
{ /* bmem/bmem.scm 347 */
obj_t BgL_env1394z00_849;
BgL_env1394z00_849 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 347 */

{ 
long BgL_auxz00_4587;
{ /* bmem/bmem.scm 347 */
obj_t BgL_classz00_1527;
BgL_classz00_1527 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4587 = 
BGL_CLASS_INDEX(BgL_classz00_1527); } 
bmem_set_allocation_type( BgL_auxz00_4587, 0 ); } 
{ /* bmem/bmem.scm 347 */
BgL_z52htmlzd2brz80_bglt BgL_new1393z00_851;
BgL_new1393z00_851 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 347 */
long BgL_arg2069z00_852;
BgL_arg2069z00_852 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1393z00_851), BgL_arg2069z00_852); } 
BgL_new1396z00_848 = BgL_new1393z00_851; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1396z00_848)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1396z00_848)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1396z00_848)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1396z00_848)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1996z00_704 = BgL_new1396z00_848; } 
{ /* bmem/bmem.scm 350 */
obj_t BgL_arg2070z00_853;
{ /* bmem/bmem.scm 350 */
obj_t BgL_l1585z00_854;
{ /* bmem/bmem.scm 353 */
obj_t BgL_pairz00_1531;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 353 */
BgL_pairz00_1531 = BgL_gcmonz00_13; }  else 
{ 
obj_t BgL_auxz00_4604;
BgL_auxz00_4604 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12628)), BGl_string2682z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_4604,BFALSE,BFALSE);} 
BgL_l1585z00_854 = 
CDR(BgL_pairz00_1531); } 
if(
NULLP(BgL_l1585z00_854))
{ /* bmem/bmem.scm 350 */
BgL_arg2070z00_853 = BNIL; }  else 
{ /* bmem/bmem.scm 350 */
obj_t BgL_head1587z00_856;
BgL_head1587z00_856 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1585z00_858;obj_t BgL_tail1588z00_859;
BgL_l1585z00_858 = BgL_l1585z00_854; 
BgL_tail1588z00_859 = BgL_head1587z00_856; 
BgL_zc3z04anonymousza32072za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3350z04ze3z51_860:
if(
PAIRP(BgL_l1585z00_858))
{ /* bmem/bmem.scm 350 */
obj_t BgL_newtail1589z00_862;
{ /* bmem/bmem.scm 350 */
obj_t BgL_arg2075z00_864;
{ /* bmem/bmem.scm 350 */
obj_t BgL_tz00_865;
BgL_tz00_865 = 
CAR(BgL_l1585z00_858); 
{ /* bmem/bmem.scm 351 */
obj_t BgL_arg2076z00_866;obj_t BgL_arg2077z00_867;
{ /* bmem/bmem.scm 351 */
long BgL_arg2080z00_870;
{ /* bmem/bmem.scm 351 */
long BgL_za72za7_1534;
{ /* bmem/bmem.scm 351 */
obj_t BgL_pairz00_1533;
if(
PAIRP(BgL_tz00_865))
{ /* bmem/bmem.scm 351 */
BgL_pairz00_1533 = BgL_tz00_865; }  else 
{ 
obj_t BgL_auxz00_4617;
BgL_auxz00_4617 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12562)), BGl_string2711z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_865); 
FAILURE(BgL_auxz00_4617,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 351 */
obj_t BgL_tmpz00_4621;
{ /* bmem/bmem.scm 351 */
obj_t BgL_aux2525z00_2022;
BgL_aux2525z00_2022 = 
CAR(BgL_pairz00_1533); 
if(
INTEGERP(BgL_aux2525z00_2022))
{ /* bmem/bmem.scm 351 */
BgL_tmpz00_4621 = BgL_aux2525z00_2022
; }  else 
{ 
obj_t BgL_auxz00_4625;
BgL_auxz00_4625 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12557)), BGl_string2711z00zzbmemz00, BGl_string2661z00zzbmemz00, BgL_aux2525z00_2022); 
FAILURE(BgL_auxz00_4625,BFALSE,BFALSE);} } 
BgL_za72za7_1534 = 
(long)CINT(BgL_tmpz00_4621); } } 
BgL_arg2080z00_870 = 
(((long)1)+BgL_za72za7_1534); } 
{ /* bmem/bmem.scm 351 */
obj_t BgL_list2081z00_871;
BgL_list2081z00_871 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2080z00_870), BNIL); 
BgL_arg2076z00_866 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2712z00zzbmemz00, BgL_list2081z00_871); } } 
{ /* bmem/bmem.scm 352 */
long BgL_arg2083z00_873;
{ /* bmem/bmem.scm 352 */
long BgL_za72za7_1536;
{ /* bmem/bmem.scm 352 */
obj_t BgL_pairz00_1535;
if(
PAIRP(BgL_tz00_865))
{ /* bmem/bmem.scm 352 */
BgL_pairz00_1535 = BgL_tz00_865; }  else 
{ 
obj_t BgL_auxz00_4636;
BgL_auxz00_4636 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12607)), BGl_string2711z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_865); 
FAILURE(BgL_auxz00_4636,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 352 */
obj_t BgL_tmpz00_4640;
{ /* bmem/bmem.scm 352 */
obj_t BgL_aux2529z00_2026;
BgL_aux2529z00_2026 = 
CAR(BgL_pairz00_1535); 
if(
INTEGERP(BgL_aux2529z00_2026))
{ /* bmem/bmem.scm 352 */
BgL_tmpz00_4640 = BgL_aux2529z00_2026
; }  else 
{ 
obj_t BgL_auxz00_4644;
BgL_auxz00_4644 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12602)), BGl_string2711z00zzbmemz00, BGl_string2661z00zzbmemz00, BgL_aux2529z00_2026); 
FAILURE(BgL_auxz00_4644,BFALSE,BFALSE);} } 
BgL_za72za7_1536 = 
(long)CINT(BgL_tmpz00_4640); } } 
BgL_arg2083z00_873 = 
(((long)1)+BgL_za72za7_1536); } 
{ /* bmem/bmem.scm 352 */
obj_t BgL_list2084z00_874;
BgL_list2084z00_874 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2083z00_873), BNIL); 
BgL_arg2077z00_867 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2713z00zzbmemz00, BgL_list2084z00_874); } } 
{ /* bmem/bmem.scm 351 */
obj_t BgL_list2078z00_868;
{ /* bmem/bmem.scm 351 */
obj_t BgL_arg2079z00_869;
BgL_arg2079z00_869 = 
MAKE_YOUNG_PAIR(BgL_arg2077z00_867, BNIL); 
BgL_list2078z00_868 = 
MAKE_YOUNG_PAIR(BgL_arg2076z00_866, BgL_arg2079z00_869); } 
BgL_arg2075z00_864 = BgL_list2078z00_868; } } } 
BgL_newtail1589z00_862 = 
MAKE_YOUNG_PAIR(BgL_arg2075z00_864, BNIL); } 
SET_CDR(BgL_tail1588z00_859, BgL_newtail1589z00_862); 
{ 
obj_t BgL_tail1588z00_4659;obj_t BgL_l1585z00_4657;
BgL_l1585z00_4657 = 
CDR(BgL_l1585z00_858); 
BgL_tail1588z00_4659 = BgL_newtail1589z00_862; 
BgL_tail1588z00_859 = BgL_tail1588z00_4659; 
BgL_l1585z00_858 = BgL_l1585z00_4657; 
goto BgL_zc3z04anonymousza32072za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3350z04ze3z51_860;} }  else 
{ /* bmem/bmem.scm 350 */
if(
NULLP(BgL_l1585z00_858))
{ /* bmem/bmem.scm 350 */
BgL_arg2070z00_853 = 
CDR(BgL_head1587z00_856); }  else 
{ /* bmem/bmem.scm 350 */
BgL_arg2070z00_853 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2704z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1585z00_858, BGl_string2602z00zzbmemz00, 
BINT(((long)12507))); } } } } } 
{ /* bmem/bmem.scm 348 */
obj_t BgL_auxz00_4665;
{ /* bmem/bmem.scm 353 */
bool_t BgL_test3156z00_4667;
if(
PAIRP(BgL_arg2070z00_853))
{ /* bmem/bmem.scm 353 */
BgL_test3156z00_4667 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 353 */
BgL_test3156z00_4667 = 
NULLP(BgL_arg2070z00_853)
; } 
if(BgL_test3156z00_4667)
{ /* bmem/bmem.scm 353 */
BgL_auxz00_4665 = BgL_arg2070z00_853
; }  else 
{ 
obj_t BgL_auxz00_4671;
BgL_auxz00_4671 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12634)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_arg2070z00_853); 
FAILURE(BgL_auxz00_4671,BFALSE,BFALSE);} } 
BgL_arg1997z00_705 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string2705z00zzbmemz00, BgL_auxz00_4665, BGl_string2714z00zzbmemz00, BGl_string2715z00zzbmemz00); } } 
{ /* bmem/bmem.scm 311 */
obj_t BgL_list1998z00_706;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1999z00_707;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2000z00_708;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2001z00_709;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2002z00_710;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2003z00_711;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2004z00_712;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2005z00_713;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg2006z00_714;
BgL_arg2006z00_714 = 
MAKE_YOUNG_PAIR(BgL_arg1997z00_705, BNIL); 
BgL_arg2005z00_713 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1996z00_704), BgL_arg2006z00_714); } 
BgL_arg2004z00_712 = 
MAKE_YOUNG_PAIR(BgL_arg1995z00_703, BgL_arg2005z00_713); } 
BgL_arg2003z00_711 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1994z00_702), BgL_arg2004z00_712); } 
BgL_arg2002z00_710 = 
MAKE_YOUNG_PAIR(BgL_arg1993z00_701, BgL_arg2003z00_711); } 
BgL_arg2001z00_709 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1992z00_700), BgL_arg2002z00_710); } 
BgL_arg2000z00_708 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1991z00_699), BgL_arg2001z00_709); } 
BgL_arg1999z00_707 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1990z00_698), BgL_arg2000z00_708); } 
BgL_list1998z00_706 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1989z00_697), BgL_arg1999z00_707); } 
BgL_marginz00_513 = BgL_list1998z00_706; } } 
{ /* bmem/bmem.scm 311 */
obj_t BgL_titlez00_514;
if(
PAIRP(BgL_infoz00_12))
{ /* bmem/bmem.scm 356 */
obj_t BgL_cz00_694;
{ /* bmem/bmem.scm 356 */
obj_t BgL_auxz00_4693;
{ /* bmem/bmem.scm 356 */
obj_t BgL_aux2533z00_2030;
BgL_aux2533z00_2030 = 
CDR(BgL_infoz00_12); 
{ /* bmem/bmem.scm 356 */
bool_t BgL_test3159z00_4696;
if(
PAIRP(BgL_aux2533z00_2030))
{ /* bmem/bmem.scm 356 */
BgL_test3159z00_4696 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 356 */
BgL_test3159z00_4696 = 
NULLP(BgL_aux2533z00_2030)
; } 
if(BgL_test3159z00_4696)
{ /* bmem/bmem.scm 356 */
BgL_auxz00_4693 = BgL_aux2533z00_2030
; }  else 
{ 
obj_t BgL_auxz00_4700;
BgL_auxz00_4700 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12716)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_aux2533z00_2030); 
FAILURE(BgL_auxz00_4700,BFALSE,BFALSE);} } } 
BgL_cz00_694 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)64)), BgL_auxz00_4693); } 
if(
PAIRP(BgL_cz00_694))
{ /* bmem/bmem.scm 358 */
obj_t BgL_pairz00_1546;
{ /* bmem/bmem.scm 358 */
obj_t BgL_aux2535z00_2032;
BgL_aux2535z00_2032 = 
CDR(BgL_cz00_694); 
if(
PAIRP(BgL_aux2535z00_2032))
{ /* bmem/bmem.scm 358 */
BgL_pairz00_1546 = BgL_aux2535z00_2032; }  else 
{ 
obj_t BgL_auxz00_4710;
BgL_auxz00_4710 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12754)), BGl_string2682z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2535z00_2032); 
FAILURE(BgL_auxz00_4710,BFALSE,BFALSE);} } 
BgL_titlez00_514 = 
CAR(BgL_pairz00_1546); }  else 
{ /* bmem/bmem.scm 357 */
BgL_titlez00_514 = BGl_string2600z00zzbmemz00; } }  else 
{ /* bmem/bmem.scm 355 */
BgL_titlez00_514 = BGl_string2600z00zzbmemz00; } 
{ /* bmem/bmem.scm 355 */
obj_t BgL_pagez00_515;
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_arg1941z00_596;obj_t BgL_arg1942z00_597;BgL_z52htmlzd2brz80_bglt BgL_arg1943z00_598;BgL_z52htmlzd2headingz80_bglt BgL_arg1944z00_599;BgL_z52htmlzd2az80_bglt BgL_arg1945z00_600;BgL_z52htmlzd2brz80_bglt BgL_arg1946z00_601;BgL_z52htmlzd2headingz80_bglt BgL_arg1947z00_602;BgL_z52htmlzd2az80_bglt BgL_arg1948z00_603;BgL_z52htmlzd2brz80_bglt BgL_arg1949z00_604;BgL_z52htmlzd2headingz80_bglt BgL_arg1950z00_605;BgL_z52htmlzd2az80_bglt BgL_arg1951z00_606;BgL_z52htmlzd2brz80_bglt BgL_arg1952z00_607;BgL_z52htmlzd2headingz80_bglt BgL_arg1953z00_608;BgL_z52htmlzd2az80_bglt BgL_arg1954z00_609;
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_new1400z00_628;
{ /* bmem/bmem.scm 361 */
obj_t BgL_env1398z00_629;
BgL_env1398z00_629 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 361 */

{ 
long BgL_auxz00_4716;
{ /* bmem/bmem.scm 361 */
obj_t BgL_classz00_1547;
BgL_classz00_1547 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4716 = 
BGL_CLASS_INDEX(BgL_classz00_1547); } 
bmem_set_allocation_type( BgL_auxz00_4716, 0 ); } 
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_new1397z00_631;
BgL_new1397z00_631 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 361 */
long BgL_arg1973z00_632;
BgL_arg1973z00_632 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1397z00_631), BgL_arg1973z00_632); } 
BgL_new1400z00_628 = BgL_new1397z00_631; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1400z00_628)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1400z00_628)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1400z00_628)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1400z00_628)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1400z00_628))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1400z00_628))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1400z00_628))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)65))),BUNSPEC); 
BgL_arg1941z00_596 = BgL_new1400z00_628; } 
{ /* bmem/bmem.scm 362 */
obj_t BgL_auxz00_4736;
{ /* bmem/bmem.scm 362 */
bool_t BgL_test3163z00_4737;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 362 */
BgL_test3163z00_4737 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 362 */
BgL_test3163z00_4737 = 
NULLP(BgL_gcmonz00_13)
; } 
if(BgL_test3163z00_4737)
{ /* bmem/bmem.scm 362 */
BgL_auxz00_4736 = BgL_gcmonz00_13
; }  else 
{ 
obj_t BgL_auxz00_4741;
BgL_auxz00_4741 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12862)), BGl_string2682z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_4741,BFALSE,BFALSE);} } 
BgL_arg1942z00_597 = 
BGl_makezd2gczd2summaryz00zzbmem_gcz00(BgL_auxz00_4736); } 
{ /* bmem/bmem.scm 363 */
BgL_z52htmlzd2brz80_bglt BgL_new1404z00_633;
{ /* bmem/bmem.scm 363 */
obj_t BgL_env1402z00_634;
BgL_env1402z00_634 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 363 */

{ 
long BgL_auxz00_4747;
{ /* bmem/bmem.scm 363 */
obj_t BgL_classz00_1551;
BgL_classz00_1551 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4747 = 
BGL_CLASS_INDEX(BgL_classz00_1551); } 
bmem_set_allocation_type( BgL_auxz00_4747, 0 ); } 
{ /* bmem/bmem.scm 363 */
BgL_z52htmlzd2brz80_bglt BgL_new1401z00_636;
BgL_new1401z00_636 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 363 */
long BgL_arg1974z00_637;
BgL_arg1974z00_637 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1401z00_636), BgL_arg1974z00_637); } 
BgL_new1404z00_633 = BgL_new1401z00_636; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1404z00_633)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1404z00_633)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1404z00_633)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1404z00_633)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1943z00_598 = BgL_new1404z00_633; } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2headingz80_bglt BgL_new1408z00_638;
{ /* bmem/bmem.scm 364 */
obj_t BgL_env1406z00_639;
BgL_env1406z00_639 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 364 */

{ 
long BgL_auxz00_4763;
{ /* bmem/bmem.scm 364 */
obj_t BgL_classz00_1555;
BgL_classz00_1555 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4763 = 
BGL_CLASS_INDEX(BgL_classz00_1555); } 
bmem_set_allocation_type( BgL_auxz00_4763, 0 ); } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2headingz80_bglt BgL_new1405z00_641;
BgL_new1405z00_641 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 364 */
long BgL_arg1975z00_642;
BgL_arg1975z00_642 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1405z00_641), BgL_arg1975z00_642); } 
BgL_new1408z00_638 = BgL_new1405z00_641; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1408z00_638)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1408z00_638)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1408z00_638)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1408z00_638)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1408z00_638))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1408z00_638))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1408z00_638))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)66))),BUNSPEC); 
BgL_arg1944z00_599 = BgL_new1408z00_638; } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2az80_bglt BgL_new1412z00_643;
{ /* bmem/bmem.scm 364 */
obj_t BgL_env1410z00_644;
BgL_env1410z00_644 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 364 */

{ 
long BgL_auxz00_4784;
{ /* bmem/bmem.scm 364 */
obj_t BgL_classz00_1559;
BgL_classz00_1559 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4784 = 
BGL_CLASS_INDEX(BgL_classz00_1559); } 
bmem_set_allocation_type( BgL_auxz00_4784, 0 ); } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2az80_bglt BgL_new1409z00_646;
BgL_new1409z00_646 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 364 */
long BgL_arg1976z00_647;
BgL_arg1976z00_647 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1409z00_646), BgL_arg1976z00_647); } 
BgL_new1412z00_643 = BgL_new1409z00_646; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1412z00_643)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1412z00_643)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1412z00_643)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1412z00_643)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1412z00_643))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1412z00_643))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1412z00_643))->BgL_namez00)=((obj_t)BGl_string2716z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1412z00_643))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1945z00_600 = BgL_new1412z00_643; } 
{ /* bmem/bmem.scm 365 */
BgL_z52htmlzd2brz80_bglt BgL_new1416z00_648;
{ /* bmem/bmem.scm 365 */
obj_t BgL_env1414z00_649;
BgL_env1414z00_649 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 365 */

{ 
long BgL_auxz00_4804;
{ /* bmem/bmem.scm 365 */
obj_t BgL_classz00_1563;
BgL_classz00_1563 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4804 = 
BGL_CLASS_INDEX(BgL_classz00_1563); } 
bmem_set_allocation_type( BgL_auxz00_4804, 0 ); } 
{ /* bmem/bmem.scm 365 */
BgL_z52htmlzd2brz80_bglt BgL_new1413z00_651;
BgL_new1413z00_651 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 365 */
long BgL_arg1977z00_652;
BgL_arg1977z00_652 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1413z00_651), BgL_arg1977z00_652); } 
BgL_new1416z00_648 = BgL_new1413z00_651; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1416z00_648)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1416z00_648)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1416z00_648)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1416z00_648)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1946z00_601 = BgL_new1416z00_648; } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2headingz80_bglt BgL_new1420z00_653;
{ /* bmem/bmem.scm 366 */
obj_t BgL_env1418z00_654;
BgL_env1418z00_654 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 366 */

{ 
long BgL_auxz00_4820;
{ /* bmem/bmem.scm 366 */
obj_t BgL_classz00_1567;
BgL_classz00_1567 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4820 = 
BGL_CLASS_INDEX(BgL_classz00_1567); } 
bmem_set_allocation_type( BgL_auxz00_4820, 0 ); } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2headingz80_bglt BgL_new1417z00_656;
BgL_new1417z00_656 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 366 */
long BgL_arg1978z00_657;
BgL_arg1978z00_657 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1417z00_656), BgL_arg1978z00_657); } 
BgL_new1420z00_653 = BgL_new1417z00_656; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1420z00_653)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1420z00_653)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1420z00_653)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1420z00_653)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1420z00_653))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1420z00_653))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1420z00_653))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)67))),BUNSPEC); 
BgL_arg1947z00_602 = BgL_new1420z00_653; } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2az80_bglt BgL_new1424z00_658;
{ /* bmem/bmem.scm 366 */
obj_t BgL_env1422z00_659;
BgL_env1422z00_659 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 366 */

{ 
long BgL_auxz00_4841;
{ /* bmem/bmem.scm 366 */
obj_t BgL_classz00_1571;
BgL_classz00_1571 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4841 = 
BGL_CLASS_INDEX(BgL_classz00_1571); } 
bmem_set_allocation_type( BgL_auxz00_4841, 0 ); } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2az80_bglt BgL_new1421z00_661;
BgL_new1421z00_661 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 366 */
long BgL_arg1979z00_662;
BgL_arg1979z00_662 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1421z00_661), BgL_arg1979z00_662); } 
BgL_new1424z00_658 = BgL_new1421z00_661; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1424z00_658)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1424z00_658)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1424z00_658)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1424z00_658)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1424z00_658))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1424z00_658))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1424z00_658))->BgL_namez00)=((obj_t)BGl_string2717z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1424z00_658))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1948z00_603 = BgL_new1424z00_658; } 
{ /* bmem/bmem.scm 367 */
BgL_z52htmlzd2brz80_bglt BgL_new1428z00_663;
{ /* bmem/bmem.scm 367 */
obj_t BgL_env1426z00_664;
BgL_env1426z00_664 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 367 */

{ 
long BgL_auxz00_4861;
{ /* bmem/bmem.scm 367 */
obj_t BgL_classz00_1575;
BgL_classz00_1575 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4861 = 
BGL_CLASS_INDEX(BgL_classz00_1575); } 
bmem_set_allocation_type( BgL_auxz00_4861, 0 ); } 
{ /* bmem/bmem.scm 367 */
BgL_z52htmlzd2brz80_bglt BgL_new1425z00_666;
BgL_new1425z00_666 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 367 */
long BgL_arg1980z00_667;
BgL_arg1980z00_667 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1425z00_666), BgL_arg1980z00_667); } 
BgL_new1428z00_663 = BgL_new1425z00_666; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1428z00_663)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1428z00_663)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1428z00_663)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1428z00_663)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1949z00_604 = BgL_new1428z00_663; } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2headingz80_bglt BgL_new1432z00_668;
{ /* bmem/bmem.scm 368 */
obj_t BgL_env1430z00_669;
BgL_env1430z00_669 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 368 */

{ 
long BgL_auxz00_4877;
{ /* bmem/bmem.scm 368 */
obj_t BgL_classz00_1579;
BgL_classz00_1579 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4877 = 
BGL_CLASS_INDEX(BgL_classz00_1579); } 
bmem_set_allocation_type( BgL_auxz00_4877, 0 ); } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2headingz80_bglt BgL_new1429z00_671;
BgL_new1429z00_671 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 368 */
long BgL_arg1981z00_672;
BgL_arg1981z00_672 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1429z00_671), BgL_arg1981z00_672); } 
BgL_new1432z00_668 = BgL_new1429z00_671; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1432z00_668)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1432z00_668)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1432z00_668)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1432z00_668)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1432z00_668))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1432z00_668))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1432z00_668))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)68))),BUNSPEC); 
BgL_arg1950z00_605 = BgL_new1432z00_668; } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2az80_bglt BgL_new1436z00_673;
{ /* bmem/bmem.scm 368 */
obj_t BgL_env1434z00_674;
BgL_env1434z00_674 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 368 */

{ 
long BgL_auxz00_4898;
{ /* bmem/bmem.scm 368 */
obj_t BgL_classz00_1583;
BgL_classz00_1583 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4898 = 
BGL_CLASS_INDEX(BgL_classz00_1583); } 
bmem_set_allocation_type( BgL_auxz00_4898, 0 ); } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2az80_bglt BgL_new1433z00_676;
BgL_new1433z00_676 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 368 */
long BgL_arg1982z00_677;
BgL_arg1982z00_677 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1433z00_676), BgL_arg1982z00_677); } 
BgL_new1436z00_673 = BgL_new1433z00_676; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1436z00_673)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1436z00_673)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1436z00_673)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1436z00_673)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1436z00_673))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1436z00_673))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1436z00_673))->BgL_namez00)=((obj_t)BGl_string2718z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1436z00_673))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1951z00_606 = BgL_new1436z00_673; } 
{ /* bmem/bmem.scm 369 */
BgL_z52htmlzd2brz80_bglt BgL_new1440z00_678;
{ /* bmem/bmem.scm 369 */
obj_t BgL_env1438z00_679;
BgL_env1438z00_679 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 369 */

{ 
long BgL_auxz00_4918;
{ /* bmem/bmem.scm 369 */
obj_t BgL_classz00_1587;
BgL_classz00_1587 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_auxz00_4918 = 
BGL_CLASS_INDEX(BgL_classz00_1587); } 
bmem_set_allocation_type( BgL_auxz00_4918, 0 ); } 
{ /* bmem/bmem.scm 369 */
BgL_z52htmlzd2brz80_bglt BgL_new1437z00_681;
BgL_new1437z00_681 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 369 */
long BgL_arg1983z00_682;
BgL_arg1983z00_682 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1437z00_681), BgL_arg1983z00_682); } 
BgL_new1440z00_678 = BgL_new1437z00_681; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1440z00_678)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1440z00_678)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1440z00_678)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1440z00_678)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1952z00_607 = BgL_new1440z00_678; } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2headingz80_bglt BgL_new1444z00_683;
{ /* bmem/bmem.scm 370 */
obj_t BgL_env1442z00_684;
BgL_env1442z00_684 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 370 */

{ 
long BgL_auxz00_4934;
{ /* bmem/bmem.scm 370 */
obj_t BgL_classz00_1591;
BgL_classz00_1591 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_auxz00_4934 = 
BGL_CLASS_INDEX(BgL_classz00_1591); } 
bmem_set_allocation_type( BgL_auxz00_4934, 0 ); } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2headingz80_bglt BgL_new1441z00_686;
BgL_new1441z00_686 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 370 */
long BgL_arg1984z00_687;
BgL_arg1984z00_687 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1441z00_686), BgL_arg1984z00_687); } 
BgL_new1444z00_683 = BgL_new1441z00_686; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1444z00_683)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1444z00_683)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1444z00_683)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1444z00_683)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1444z00_683))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1444z00_683))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1444z00_683))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)69))),BUNSPEC); 
BgL_arg1953z00_608 = BgL_new1444z00_683; } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2az80_bglt BgL_new1448z00_688;
{ /* bmem/bmem.scm 370 */
obj_t BgL_env1446z00_689;
BgL_env1446z00_689 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 370 */

{ 
long BgL_auxz00_4955;
{ /* bmem/bmem.scm 370 */
obj_t BgL_classz00_1595;
BgL_classz00_1595 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_auxz00_4955 = 
BGL_CLASS_INDEX(BgL_classz00_1595); } 
bmem_set_allocation_type( BgL_auxz00_4955, 0 ); } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2az80_bglt BgL_new1445z00_691;
BgL_new1445z00_691 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 370 */
long BgL_arg1985z00_692;
BgL_arg1985z00_692 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1445z00_691), BgL_arg1985z00_692); } 
BgL_new1448z00_688 = BgL_new1445z00_691; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1448z00_688)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1448z00_688)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1448z00_688)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1448z00_688)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1448z00_688))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1448z00_688))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1448z00_688))->BgL_namez00)=((obj_t)BGl_string2719z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1448z00_688))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1954z00_609 = BgL_new1448z00_688; } 
{ /* bmem/bmem.scm 361 */
obj_t BgL_list1955z00_610;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1956z00_611;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1957z00_612;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1958z00_613;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1959z00_614;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1960z00_615;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1961z00_616;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1962z00_617;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1963z00_618;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1964z00_619;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1965z00_620;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1966z00_621;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1967z00_622;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1968z00_623;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1969z00_624;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1970z00_625;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1971z00_626;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1972z00_627;
BgL_arg1972z00_627 = 
MAKE_YOUNG_PAIR(BgL_gctablez00_508, BNIL); 
BgL_arg1971z00_626 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1954z00_609), BgL_arg1972z00_627); } 
BgL_arg1970z00_625 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1953z00_608), BgL_arg1971z00_626); } 
BgL_arg1969z00_624 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1952z00_607), BgL_arg1970z00_625); } 
BgL_arg1968z00_623 = 
MAKE_YOUNG_PAIR(BgL_threadtablez00_511, BgL_arg1969z00_624); } 
BgL_arg1967z00_622 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1951z00_606), BgL_arg1968z00_623); } 
BgL_arg1966z00_621 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1950z00_605), BgL_arg1967z00_622); } 
BgL_arg1965z00_620 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1949z00_604), BgL_arg1966z00_621); } 
BgL_arg1964z00_619 = 
MAKE_YOUNG_PAIR(BgL_typetablez00_510, BgL_arg1965z00_620); } 
BgL_arg1963z00_618 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1948z00_603), BgL_arg1964z00_619); } 
BgL_arg1962z00_617 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1947z00_602), BgL_arg1963z00_618); } 
BgL_arg1961z00_616 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1946z00_601), BgL_arg1962z00_617); } 
BgL_arg1960z00_615 = 
MAKE_YOUNG_PAIR(BgL_funtablez00_509, BgL_arg1961z00_616); } 
BgL_arg1959z00_614 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1945z00_600), BgL_arg1960z00_615); } 
BgL_arg1958z00_613 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1944z00_599), BgL_arg1959z00_614); } 
BgL_arg1957z00_612 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1943z00_598), BgL_arg1958z00_613); } 
BgL_arg1956z00_611 = 
MAKE_YOUNG_PAIR(BgL_arg1942z00_597, BgL_arg1957z00_612); } 
BgL_list1955z00_610 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1941z00_596), BgL_arg1956z00_611); } 
BgL_pagez00_515 = BgL_list1955z00_610; } } 
{ /* bmem/bmem.scm 361 */

{ /* bmem/bmem.scm 372 */
BgL_z52htmlzd2documentz80_bglt BgL_new1452z00_516;
{ /* bmem/bmem.scm 372 */
obj_t BgL_env1450z00_592;
BgL_env1450z00_592 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 372 */

{ 
long BgL_auxz00_5006;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_1600;
BgL_classz00_1600 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_auxz00_5006 = 
BGL_CLASS_INDEX(BgL_classz00_1600); } 
bmem_set_allocation_type( BgL_auxz00_5006, 0 ); } 
{ /* bmem/bmem.scm 372 */
BgL_z52htmlzd2documentz80_bglt BgL_new1449z00_594;
BgL_new1449z00_594 = 
((BgL_z52htmlzd2documentz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2documentz80_bgl) ))); 
{ /* bmem/bmem.scm 372 */
long BgL_arg1940z00_595;
BgL_arg1940z00_595 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2documentz80zzhtmlz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1449z00_594), BgL_arg1940z00_595); } 
BgL_new1452z00_516 = BgL_new1449z00_594; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1452z00_516)))->BgL_idz00)=((obj_t)BGl_string2720z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1452z00_516)))->BgL_classz00)=((obj_t)BGl_string2721z00zzbmemz00),BUNSPEC); 
{ 
obj_t BgL_auxz00_5017;
{ /* bmem/bmem.scm 372 */
bool_t BgL_test3165z00_5019;
{ /* bmem/bmem.scm 372 */
obj_t BgL_string1z00_1604;
if(
STRINGP(BgL_titlez00_514))
{ /* bmem/bmem.scm 372 */
BgL_string1z00_1604 = BgL_titlez00_514; }  else 
{ 
obj_t BgL_auxz00_5022;
BgL_auxz00_5022 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)13250)), BGl_string2682z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_titlez00_514); 
FAILURE(BgL_auxz00_5022,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 372 */
long BgL_l1z00_1606;
BgL_l1z00_1606 = 
STRING_LENGTH(BgL_string1z00_1604); 
if(
(BgL_l1z00_1606==
STRING_LENGTH(BGl_string2600z00zzbmemz00)))
{ /* bmem/bmem.scm 372 */
int BgL_arg1282z00_1609;
{ /* bmem/bmem.scm 372 */
char * BgL_auxz00_5032;char * BgL_tmpz00_5030;
BgL_auxz00_5032 = 
BSTRING_TO_STRING(BGl_string2600z00zzbmemz00); 
BgL_tmpz00_5030 = 
BSTRING_TO_STRING(BgL_string1z00_1604); 
BgL_arg1282z00_1609 = 
memcmp(BgL_tmpz00_5030, BgL_auxz00_5032, BgL_l1z00_1606); } 
BgL_test3165z00_5019 = 
(
(long)(BgL_arg1282z00_1609)==((long)0)); }  else 
{ /* bmem/bmem.scm 372 */
BgL_test3165z00_5019 = ((bool_t)0)
; } } } 
if(BgL_test3165z00_5019)
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5017 = BGl_string2600z00zzbmemz00
; }  else 
{ /* bmem/bmem.scm 374 */
obj_t BgL_tmpz00_5037;
if(
STRINGP(BgL_titlez00_514))
{ /* bmem/bmem.scm 374 */
BgL_tmpz00_5037 = BgL_titlez00_514
; }  else 
{ 
obj_t BgL_auxz00_5040;
BgL_auxz00_5040 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)13283)), BGl_string2682z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_titlez00_514); 
FAILURE(BgL_auxz00_5040,BFALSE,BFALSE);} 
BgL_auxz00_5017 = 
string_append(BGl_string2722z00zzbmemz00, BgL_tmpz00_5037); } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1452z00_516)))->BgL_titlez00)=((obj_t)BgL_auxz00_5017),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5046;
{ /* bmem/bmem.scm 375 */
obj_t BgL_list1906z00_518;
{ /* bmem/bmem.scm 375 */
obj_t BgL_arg1907z00_519;
BgL_arg1907z00_519 = 
MAKE_YOUNG_PAIR(BgL_dcssz00_512, BNIL); 
BgL_list1906z00_518 = 
MAKE_YOUNG_PAIR(BgL_cssz00_11, BgL_arg1907z00_519); } 
BgL_auxz00_5046 = BgL_list1906z00_518; } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1452z00_516)))->BgL_stylez00)=((obj_t)BgL_auxz00_5046),BUNSPEC); } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1452z00_516))->BgL_attrza2za2)=((obj_t)BNIL),BUNSPEC); 
{ 
obj_t BgL_auxz00_5052;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1908z00_520;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1909z00_521;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_1616;
BgL_classz00_1616 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_arg1909z00_521 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1616); } 
BgL_arg1908z00_520 = 
VECTOR_REF(BgL_arg1909z00_521,((long)5)); } 
{ /* bmem/bmem.scm 372 */
obj_t BgL_auxz00_5055;
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_arg1908z00_520))
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5055 = BgL_arg1908z00_520
; }  else 
{ 
obj_t BgL_auxz00_5058;
BgL_auxz00_5058 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)13214)), BGl_string2682z00zzbmemz00, BGl_string2723z00zzbmemz00, BgL_arg1908z00_520); 
FAILURE(BgL_auxz00_5058,BFALSE,BFALSE);} 
BgL_auxz00_5052 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_auxz00_5055); } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1452z00_516))->BgL_dtdz00)=((obj_t)BgL_auxz00_5052),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5064;
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1910z00_522;
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_new1456z00_524;
{ /* bmem/bmem.scm 377 */
obj_t BgL_env1454z00_586;
BgL_env1454z00_586 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 377 */

{ 
long BgL_auxz00_5066;
{ /* bmem/bmem.scm 377 */
obj_t BgL_classz00_1618;
BgL_classz00_1618 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_5066 = 
BGL_CLASS_INDEX(BgL_classz00_1618); } 
bmem_set_allocation_type( BgL_auxz00_5066, 0 ); } 
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_new1453z00_588;
BgL_new1453z00_588 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 377 */
long BgL_arg1937z00_589;
{ /* bmem/bmem.scm 377 */
obj_t BgL_classz00_1619;
BgL_classz00_1619 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_arg1937z00_589 = 
BGL_CLASS_INDEX(BgL_classz00_1619); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1453z00_588), BgL_arg1937z00_589); } 
BgL_new1456z00_524 = BgL_new1453z00_588; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1456z00_524)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1456z00_524)))->BgL_classz00)=((obj_t)BGl_string2600z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1456z00_524)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1456z00_524)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1456z00_524))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5083;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_arg1912z00_525;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_new1460z00_527;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1458z00_582;
BgL_env1458z00_582 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5085;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1622;
BgL_classz00_1622 = BGl_z52htmlzd2tablez80zzhtmlz00; 
BgL_auxz00_5085 = 
BGL_CLASS_INDEX(BgL_classz00_1622); } 
bmem_set_allocation_type( BgL_auxz00_5085, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_new1457z00_584;
BgL_new1457z00_584 = 
((BgL_z52htmlzd2tablez80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tablez80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1936z00_585;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1623;
BgL_classz00_1623 = BGl_z52htmlzd2tablez80zzhtmlz00; 
BgL_arg1936z00_585 = 
BGL_CLASS_INDEX(BgL_classz00_1623); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1457z00_584), BgL_arg1936z00_585); } 
BgL_new1460z00_527 = BgL_new1457z00_584; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1460z00_527)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1460z00_527)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1460z00_527)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1460z00_527)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_captionz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5101;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_arg1914z00_528;BgL_z52htmlzd2colgroupz80_bglt BgL_arg1915z00_529;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1464z00_532;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1462z00_533;
BgL_env1462z00_533 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5103;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1626;
BgL_classz00_1626 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_auxz00_5103 = 
BGL_CLASS_INDEX(BgL_classz00_1626); } 
bmem_set_allocation_type( BgL_auxz00_5103, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1461z00_535;
BgL_new1461z00_535 = 
((BgL_z52htmlzd2colgroupz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2colgroupz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1918z00_536;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1627;
BgL_classz00_1627 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_arg1918z00_536 = 
BGL_CLASS_INDEX(BgL_classz00_1627); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1461z00_535), BgL_arg1918z00_536); } 
BgL_new1464z00_532 = BgL_new1461z00_535; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1464z00_532)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1464z00_532)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1464z00_532)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1464z00_532)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_widthz00)=((obj_t)BGl_string2724z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_spanz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_valignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1464z00_532))->BgL_colza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1914z00_528 = BgL_new1464z00_532; } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1468z00_537;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1466z00_538;
BgL_env1466z00_538 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5125;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1630;
BgL_classz00_1630 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_auxz00_5125 = 
BGL_CLASS_INDEX(BgL_classz00_1630); } 
bmem_set_allocation_type( BgL_auxz00_5125, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1465z00_540;
BgL_new1465z00_540 = 
((BgL_z52htmlzd2colgroupz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2colgroupz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1919z00_541;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1631;
BgL_classz00_1631 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_arg1919z00_541 = 
BGL_CLASS_INDEX(BgL_classz00_1631); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1465z00_540), BgL_arg1919z00_541); } 
BgL_new1468z00_537 = BgL_new1465z00_540; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1468z00_537)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1468z00_537)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1468z00_537)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1468z00_537)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_widthz00)=((obj_t)BGl_string2725z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_spanz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_valignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1468z00_537))->BgL_colza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1915z00_529 = BgL_new1468z00_537; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1916z00_530;
{ /* bmem/bmem.scm 378 */
obj_t BgL_arg1917z00_531;
BgL_arg1917z00_531 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1915z00_529), BNIL); 
BgL_list1916z00_530 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1914z00_528), BgL_arg1917z00_531); } 
BgL_auxz00_5101 = BgL_list1916z00_530; } } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_colgroupzf3zf3)=((obj_t)BgL_auxz00_5101),BUNSPEC); } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_tfootzf3zf3)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_theadzf3zf3)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_widthz00)=((obj_t)BGl_string2726z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_borderz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_framez00)=((obj_t)BGl_string2727z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_rulesz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_cellspacingz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_cellpaddingz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5159;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_arg1920z00_542;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_new1472z00_544;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1470z00_578;
BgL_env1470z00_578 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5161;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1635;
BgL_classz00_1635 = BGl_z52htmlzd2trz80zzhtmlz00; 
BgL_auxz00_5161 = 
BGL_CLASS_INDEX(BgL_classz00_1635); } 
bmem_set_allocation_type( BgL_auxz00_5161, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_new1469z00_580;
BgL_new1469z00_580 = 
((BgL_z52htmlzd2trz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2trz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1935z00_581;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1636;
BgL_classz00_1636 = BGl_z52htmlzd2trz80zzhtmlz00; 
BgL_arg1935z00_581 = 
BGL_CLASS_INDEX(BgL_classz00_1636); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1469z00_580), BgL_arg1935z00_581); } 
BgL_new1472z00_544 = BgL_new1469z00_580; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1472z00_544)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1472z00_544)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1472z00_544)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1472z00_544)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5176;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_arg1922z00_545;BgL_z52htmlzd2tcellz80_bglt BgL_arg1923z00_546;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1476z00_549;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1474z00_555;
BgL_env1474z00_555 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5178;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1639;
BgL_classz00_1639 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_auxz00_5178 = 
BGL_CLASS_INDEX(BgL_classz00_1639); } 
bmem_set_allocation_type( BgL_auxz00_5178, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1473z00_557;
BgL_new1473z00_557 = 
((BgL_z52htmlzd2tcellz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tcellz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1927z00_558;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1640;
BgL_classz00_1640 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_arg1927z00_558 = 
BGL_CLASS_INDEX(BgL_classz00_1640); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1473z00_557), BgL_arg1927z00_558); } 
BgL_new1476z00_549 = BgL_new1473z00_557; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1476z00_549)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1476z00_549)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1476z00_549)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1476z00_549)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)70))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_colspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_rowspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_alignz00)=((obj_t)BGl_string2728z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_valignz00)=((obj_t)BGl_string2729z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_widthz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5203;
{ /* bmem/html.sch 105 */
BgL_z52htmlzd2boxz80_bglt BgL_new1480z00_550;
{ /* bmem/html.sch 105 */
obj_t BgL_env1478z00_551;
BgL_env1478z00_551 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/html.sch 105 */

{ 
long BgL_auxz00_5205;
{ /* bmem/html.sch 105 */
obj_t BgL_classz00_1643;
BgL_classz00_1643 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_5205 = 
BGL_CLASS_INDEX(BgL_classz00_1643); } 
bmem_set_allocation_type( BgL_auxz00_5205, 0 ); } 
{ /* bmem/html.sch 105 */
BgL_z52htmlzd2boxz80_bglt BgL_new1477z00_553;
BgL_new1477z00_553 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 105 */
long BgL_arg1926z00_554;
{ /* bmem/html.sch 105 */
obj_t BgL_classz00_1644;
BgL_classz00_1644 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_arg1926z00_554 = 
BGL_CLASS_INDEX(BgL_classz00_1644); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1477z00_553), BgL_arg1926z00_554); } 
BgL_new1480z00_550 = BgL_new1477z00_553; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1480z00_550)))->BgL_idz00)=((obj_t)BGl_string2728z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1480z00_550)))->BgL_classz00)=((obj_t)BGl_string2730z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1480z00_550)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1480z00_550)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1480z00_550))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1480z00_550))->BgL_inlineza2za2)=((obj_t)BgL_marginz00_513),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1480z00_550))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_auxz00_5203 = 
((obj_t)BgL_new1480z00_550); } 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1476z00_549))->BgL_flowza2za2)=((obj_t)BgL_auxz00_5203),BUNSPEC); } 
BgL_arg1922z00_545 = BgL_new1476z00_549; } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1484z00_559;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1482z00_574;
BgL_env1482z00_574 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5227;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1647;
BgL_classz00_1647 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_auxz00_5227 = 
BGL_CLASS_INDEX(BgL_classz00_1647); } 
bmem_set_allocation_type( BgL_auxz00_5227, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1481z00_576;
BgL_new1481z00_576 = 
((BgL_z52htmlzd2tcellz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tcellz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1934z00_577;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1648;
BgL_classz00_1648 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_arg1934z00_577 = 
BGL_CLASS_INDEX(BgL_classz00_1648); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1481z00_576), BgL_arg1934z00_577); } 
BgL_new1484z00_559 = BgL_new1481z00_576; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1484z00_559)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1484z00_559)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1484z00_559)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1484z00_559)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)70))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_colspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_rowspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_alignz00)=((obj_t)BGl_string2728z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_valignz00)=((obj_t)BGl_string2729z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_widthz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5252;
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1928z00_560;BgL_z52htmlzd2boxz80_bglt BgL_arg1929z00_561;
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1488z00_564;
{ /* bmem/html.sch 133 */
obj_t BgL_env1486z00_565;
BgL_env1486z00_565 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/html.sch 133 */

{ 
long BgL_auxz00_5254;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1651;
BgL_classz00_1651 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_5254 = 
BGL_CLASS_INDEX(BgL_classz00_1651); } 
bmem_set_allocation_type( BgL_auxz00_5254, 0 ); } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1485z00_567;
BgL_new1485z00_567 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 133 */
long BgL_arg1932z00_568;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1652;
BgL_classz00_1652 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_arg1932z00_568 = 
BGL_CLASS_INDEX(BgL_classz00_1652); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1485z00_567), BgL_arg1932z00_568); } 
BgL_new1488z00_564 = BgL_new1485z00_567; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1488z00_564)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1488z00_564)))->BgL_classz00)=((obj_t)BGl_string2731z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1488z00_564)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1488z00_564)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1488z00_564))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1488z00_564))->BgL_inlineza2za2)=((obj_t)BgL_titlez00_514),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1488z00_564))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1928z00_560 = BgL_new1488z00_564; } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1492z00_569;
{ /* bmem/html.sch 133 */
obj_t BgL_env1490z00_570;
BgL_env1490z00_570 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/html.sch 133 */

{ 
long BgL_auxz00_5274;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1655;
BgL_classz00_1655 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_auxz00_5274 = 
BGL_CLASS_INDEX(BgL_classz00_1655); } 
bmem_set_allocation_type( BgL_auxz00_5274, 0 ); } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1489z00_572;
BgL_new1489z00_572 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 133 */
long BgL_arg1933z00_573;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1656;
BgL_classz00_1656 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_arg1933z00_573 = 
BGL_CLASS_INDEX(BgL_classz00_1656); } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1489z00_572), BgL_arg1933z00_573); } 
BgL_new1492z00_569 = BgL_new1489z00_572; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1492z00_569)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1492z00_569)))->BgL_classz00)=((obj_t)BGl_string2732z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1492z00_569)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1492z00_569)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1492z00_569))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1492z00_569))->BgL_inlineza2za2)=((obj_t)BgL_pagez00_515),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1492z00_569))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1929z00_561 = BgL_new1492z00_569; } 
{ /* bmem/html.sch 133 */
obj_t BgL_list1930z00_562;
{ /* bmem/html.sch 133 */
obj_t BgL_arg1931z00_563;
BgL_arg1931z00_563 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1929z00_561), BNIL); 
BgL_list1930z00_562 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1928z00_560), BgL_arg1931z00_563); } 
BgL_auxz00_5252 = BgL_list1930z00_562; } } 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1484z00_559))->BgL_flowza2za2)=((obj_t)BgL_auxz00_5252),BUNSPEC); } 
BgL_arg1923z00_546 = BgL_new1484z00_559; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1924z00_547;
{ /* bmem/bmem.scm 378 */
obj_t BgL_arg1925z00_548;
BgL_arg1925z00_548 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1923z00_546), BNIL); 
BgL_list1924z00_547 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1922z00_545), BgL_arg1925z00_548); } 
BgL_auxz00_5176 = BgL_list1924z00_547; } } 
((((BgL_z52htmlzd2trz80_bglt)COBJECT(BgL_new1472z00_544))->BgL_tcellzb2zb2)=((obj_t)BgL_auxz00_5176),BUNSPEC); } 
BgL_arg1920z00_542 = BgL_new1472z00_544; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1921z00_543;
BgL_list1921z00_543 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1920z00_542), BNIL); 
BgL_auxz00_5159 = BgL_list1921z00_543; } } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1460z00_527))->BgL_tbodyzb2zb2)=((obj_t)BgL_auxz00_5159),BUNSPEC); } 
BgL_arg1912z00_525 = BgL_new1460z00_527; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1913z00_526;
BgL_list1913z00_526 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1912z00_525), BNIL); 
BgL_auxz00_5083 = BgL_list1913z00_526; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1456z00_524))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_5083),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1456z00_524))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1910z00_522 = BgL_new1456z00_524; } 
{ /* bmem/bmem.scm 377 */
obj_t BgL_list1911z00_523;
BgL_list1911z00_523 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1910z00_522), BNIL); 
BgL_auxz00_5064 = BgL_list1911z00_523; } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1452z00_516))->BgL_bodyz00)=((obj_t)BgL_auxz00_5064),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5313;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1938z00_590;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1939z00_591;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_1664;
BgL_classz00_1664 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_arg1939z00_591 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1664); } 
BgL_arg1938z00_590 = 
VECTOR_REF(BgL_arg1939z00_591,((long)7)); } 
{ /* bmem/bmem.scm 372 */
obj_t BgL_auxz00_5316;
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_arg1938z00_590))
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5316 = BgL_arg1938z00_590
; }  else 
{ 
obj_t BgL_auxz00_5319;
BgL_auxz00_5319 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)13214)), BGl_string2682z00zzbmemz00, BGl_string2723z00zzbmemz00, BgL_arg1938z00_590); 
FAILURE(BgL_auxz00_5319,BFALSE,BFALSE);} 
BgL_auxz00_5313 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_auxz00_5316); } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1452z00_516))->BgL_cssz00)=((obj_t)BgL_auxz00_5313),BUNSPEC); } 
BgL_aux2252z00_1092 = BgL_new1452z00_516; } } } } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2255z00_1091); 
return BgL_aux2252z00_1092;} } } } 

}



/* &<@anonymous:2066:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:343@> */
obj_t BGl_z62zc3z04anonymousza32066za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00(obj_t BgL_envz00_1769, obj_t BgL_t1z00_1770, obj_t BgL_t2z00_1771)
{
{ /* bmem/bmem.scm 344 */
{ /* bmem/bmem.scm 345 */
bool_t BgL_tmpz00_5326;
{ /* bmem/bmem.scm 345 */
obj_t BgL_string1z00_2277;obj_t BgL_string2z00_2278;
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2279;
if(
PAIRP(BgL_t1z00_1770))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2279 = BgL_t1z00_1770; }  else 
{ 
obj_t BgL_auxz00_5329;
BgL_auxz00_5329 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12417)), BGl_string2733z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_t1z00_1770); 
FAILURE(BgL_auxz00_5329,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2280;
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2549z00_2281;
BgL_aux2549z00_2281 = 
CDR(BgL_pairz00_2279); 
if(
PAIRP(BgL_aux2549z00_2281))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2280 = BgL_aux2549z00_2281; }  else 
{ 
obj_t BgL_auxz00_5336;
BgL_auxz00_5336 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12411)), BGl_string2733z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2549z00_2281); 
FAILURE(BgL_auxz00_5336,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2551z00_2282;
BgL_aux2551z00_2282 = 
CAR(BgL_pairz00_2280); 
if(
STRINGP(BgL_aux2551z00_2282))
{ /* bmem/bmem.scm 345 */
BgL_string1z00_2277 = BgL_aux2551z00_2282; }  else 
{ 
obj_t BgL_auxz00_5343;
BgL_auxz00_5343 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12411)), BGl_string2733z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2551z00_2282); 
FAILURE(BgL_auxz00_5343,BFALSE,BFALSE);} } } } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2283;
if(
PAIRP(BgL_t2z00_1771))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2283 = BgL_t2z00_1771; }  else 
{ 
obj_t BgL_auxz00_5349;
BgL_auxz00_5349 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12427)), BGl_string2733z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_t2z00_1771); 
FAILURE(BgL_auxz00_5349,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2284;
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2555z00_2285;
BgL_aux2555z00_2285 = 
CDR(BgL_pairz00_2283); 
if(
PAIRP(BgL_aux2555z00_2285))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2284 = BgL_aux2555z00_2285; }  else 
{ 
obj_t BgL_auxz00_5356;
BgL_auxz00_5356 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12421)), BGl_string2733z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2555z00_2285); 
FAILURE(BgL_auxz00_5356,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2557z00_2286;
BgL_aux2557z00_2286 = 
CAR(BgL_pairz00_2284); 
if(
STRINGP(BgL_aux2557z00_2286))
{ /* bmem/bmem.scm 345 */
BgL_string2z00_2278 = BgL_aux2557z00_2286; }  else 
{ 
obj_t BgL_auxz00_5363;
BgL_auxz00_5363 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12421)), BGl_string2733z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_aux2557z00_2286); 
FAILURE(BgL_auxz00_5363,BFALSE,BFALSE);} } } } 
BgL_tmpz00_5326 = 
bigloo_string_lt(BgL_string1z00_2277, BgL_string2z00_2278); } 
return 
BBOOL(BgL_tmpz00_5326);} } 

}



/* &<@anonymous:2044:/builddir/build/BUILD/bigloo-4,4b/bde/bmem/bmem/bmem,scm:326@> */
obj_t BGl_z62zc3z04anonymousza32044za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00(obj_t BgL_envz00_1772, obj_t BgL_f1z00_1773, obj_t BgL_f2z00_1774)
{
{ /* bmem/bmem.scm 330 */
{ /* bmem/bmem.scm 331 */
bool_t BgL_tmpz00_5369;
{ /* bmem/bmem.scm 331 */
BgL_funinfoz00_bglt BgL_i1387z00_2287;
if(
BGl_isazf3zf3zz__objectz00(BgL_f1z00_1773, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 332 */
BgL_i1387z00_2287 = 
((BgL_funinfoz00_bglt)BgL_f1z00_1773); }  else 
{ 
obj_t BgL_auxz00_5373;
BgL_auxz00_5373 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12053)), BGl_string2734z00zzbmemz00, BGl_string2700z00zzbmemz00, BgL_f1z00_1773); 
FAILURE(BgL_auxz00_5373,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 332 */
BgL_funinfoz00_bglt BgL_i1388z00_2288;
if(
BGl_isazf3zf3zz__objectz00(BgL_f1z00_1773, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 333 */
BgL_i1388z00_2288 = 
((BgL_funinfoz00_bglt)BgL_f1z00_1773); }  else 
{ 
obj_t BgL_auxz00_5380;
BgL_auxz00_5380 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)12102)), BGl_string2734z00zzbmemz00, BGl_string2700z00zzbmemz00, BgL_f1z00_1773); 
FAILURE(BgL_auxz00_5380,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg2045z00_2289;obj_t BgL_arg2046z00_2290;
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg2047z00_2291;
BgL_arg2047z00_2291 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1387z00_2287))->BgL_identz00); 
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg1434z00_2292;
BgL_arg1434z00_2292 = 
SYMBOL_TO_STRING(BgL_arg2047z00_2291); 
BgL_arg2045z00_2289 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_2292); } } 
{ /* bmem/bmem.scm 335 */
obj_t BgL_arg2048z00_2293;
BgL_arg2048z00_2293 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1388z00_2288))->BgL_identz00); 
{ /* bmem/bmem.scm 335 */
obj_t BgL_arg1434z00_2294;
BgL_arg1434z00_2294 = 
SYMBOL_TO_STRING(BgL_arg2048z00_2293); 
BgL_arg2046z00_2290 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1434z00_2294); } } 
BgL_tmpz00_5369 = 
bigloo_string_lt(BgL_arg2045z00_2289, BgL_arg2046z00_2290); } } } 
return 
BBOOL(BgL_tmpz00_5369);} } 

}



/* dynamic-css */
BGL_EXPORTED_DEF obj_t BGl_dynamiczd2csszd2zzbmemz00(obj_t BgL_gcmonz00_17, obj_t BgL_functionz00_18, obj_t BgL_typesz00_19)
{
{ /* bmem/bmem.scm 388 */
{ /* bmem/bmem.scm 390 */
obj_t BgL_name2257z00_1093;obj_t BgL_loc2258z00_1094;obj_t BgL_env2259z00_1095;
BgL_name2257z00_1093 = 
CNST_TABLE_REF(((long)71)); 
BgL_loc2258z00_1094 = 
CNST_TABLE_REF(((long)72)); 
BgL_env2259z00_1095 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 390 */

BGL_ENV_PUSH_TRACE(BgL_env2259z00_1095, BgL_name2257z00_1093, BgL_loc2258z00_1094); 
{ /* bmem/bmem.scm 390 */
BgL_z52cssz52_bglt BgL_aux2256z00_1096;
{ 
obj_t BgL_typesz00_949;obj_t BgL_funz00_917;obj_t BgL_gcmonz00_894;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2091z00_885;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2092z00_886;obj_t BgL_arg2093z00_887;obj_t BgL_arg2094z00_888;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2098z00_892;
{ /* bmem/bmem.scm 420 */
obj_t BgL_pairz00_1692;
if(
PAIRP(BgL_gcmonz00_17))
{ /* bmem/bmem.scm 420 */
BgL_pairz00_1692 = BgL_gcmonz00_17; }  else 
{ 
obj_t BgL_auxz00_5398;
BgL_auxz00_5398 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14919)), BGl_string2747z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_gcmonz00_17); 
FAILURE(BgL_auxz00_5398,BFALSE,BFALSE);} 
BgL_arg2098z00_892 = 
CDR(BgL_pairz00_1692); } 
BgL_gcmonz00_894 = BgL_arg2098z00_892; 
{ /* bmem/bmem.scm 390 */
long BgL_g1493z00_896;
{ /* bmem/bmem.scm 390 */
obj_t BgL_auxz00_5403;
{ /* bmem/bmem.scm 390 */
bool_t BgL_test3180z00_5404;
if(
PAIRP(BgL_gcmonz00_894))
{ /* bmem/bmem.scm 390 */
BgL_test3180z00_5404 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 390 */
BgL_test3180z00_5404 = 
NULLP(BgL_gcmonz00_894)
; } 
if(BgL_test3180z00_5404)
{ /* bmem/bmem.scm 390 */
BgL_auxz00_5403 = BgL_gcmonz00_894
; }  else 
{ 
obj_t BgL_auxz00_5408;
BgL_auxz00_5408 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)13870)), BGl_string2735z00zzbmemz00, BGl_string2660z00zzbmemz00, BgL_gcmonz00_894); 
FAILURE(BgL_auxz00_5408,BFALSE,BFALSE);} } 
BgL_g1493z00_896 = 
bgl_list_length(BgL_auxz00_5403); } 
{ 
long BgL_iz00_899;obj_t BgL_resz00_900;
BgL_iz00_899 = BgL_g1493z00_896; 
BgL_resz00_900 = BNIL; 
BgL_zc3z04anonymousza32101za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3390z04ze3z51_901:
if(
(BgL_iz00_899>=((long)-1)))
{ /* bmem/bmem.scm 393 */
obj_t BgL_selectorz00_903;
{ /* bmem/bmem.scm 393 */
obj_t BgL_list2110z00_915;
BgL_list2110z00_915 = 
MAKE_YOUNG_PAIR(
BINT(BgL_iz00_899), BNIL); 
BgL_selectorz00_903 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2736z00zzbmemz00, BgL_list2110z00_915); } 
{ /* bmem/bmem.scm 393 */
obj_t BgL_colorz00_904;
switch( BgL_iz00_899) { case ((long)-1) : 

BgL_colorz00_904 = BGl_string2737z00zzbmemz00; break;case ((long)0) : 

BgL_colorz00_904 = BGl_string2738z00zzbmemz00; break;
default: 
BgL_colorz00_904 = 
BGl_csszd2colorzd2zzbmem_toolsz00(
(int)(BgL_iz00_899), 
(int)(((long)117)), 
(int)(((long)128)), 
(int)(((long)162))); } 
{ /* bmem/bmem.scm 394 */
obj_t BgL_entryz00_905;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2105z00_908;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2106z00_909;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2107z00_910;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2108z00_911;
BgL_arg2108z00_911 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2107z00_910 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2108z00_911); } 
BgL_arg2106z00_909 = 
MAKE_YOUNG_PAIR(BgL_colorz00_904, BgL_arg2107z00_910); } 
BgL_arg2105z00_908 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2106z00_909); } 
BgL_entryz00_905 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_903, BgL_arg2105z00_908); } 
{ /* bmem/bmem.scm 398 */

{ /* bmem/bmem.scm 399 */
long BgL_arg2103z00_906;obj_t BgL_arg2104z00_907;
BgL_arg2103z00_906 = 
(BgL_iz00_899-((long)1)); 
BgL_arg2104z00_907 = 
MAKE_YOUNG_PAIR(BgL_entryz00_905, BgL_resz00_900); 
{ 
obj_t BgL_resz00_5435;long BgL_iz00_5434;
BgL_iz00_5434 = BgL_arg2103z00_906; 
BgL_resz00_5435 = BgL_arg2104z00_907; 
BgL_resz00_900 = BgL_resz00_5435; 
BgL_iz00_899 = BgL_iz00_5434; 
goto BgL_zc3z04anonymousza32101za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3390z04ze3z51_901;} } } } } }  else 
{ /* bmem/bmem.scm 392 */
BgL_arg2092z00_886 = 
bgl_reverse_bang(BgL_resz00_900); } } } } 
BgL_funz00_917 = BgL_functionz00_18; 
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2112z00_919;obj_t BgL_arg2113z00_920;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2114z00_921;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2115z00_922;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2116z00_923;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2117z00_924;
BgL_arg2117z00_924 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2116z00_923 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2117z00_924); } 
BgL_arg2115z00_922 = 
MAKE_YOUNG_PAIR(BGl_string2737z00zzbmemz00, BgL_arg2116z00_923); } 
BgL_arg2114z00_921 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2115z00_922); } 
BgL_arg2112z00_919 = 
MAKE_YOUNG_PAIR(BGl_string2739z00zzbmemz00, BgL_arg2114z00_921); } 
if(
NULLP(BgL_funz00_917))
{ /* bmem/bmem.scm 403 */
BgL_arg2113z00_920 = BNIL; }  else 
{ /* bmem/bmem.scm 403 */
obj_t BgL_head1592z00_927;
BgL_head1592z00_927 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1590z00_929;obj_t BgL_tail1593z00_930;
BgL_l1590z00_929 = BgL_funz00_917; 
BgL_tail1593z00_930 = BgL_head1592z00_927; 
BgL_zc3z04anonymousza32119za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3403z04ze3z51_931:
if(
PAIRP(BgL_l1590z00_929))
{ /* bmem/bmem.scm 403 */
obj_t BgL_newtail1594z00_933;
{ /* bmem/bmem.scm 403 */
obj_t BgL_arg2122z00_935;
{ /* bmem/bmem.scm 403 */
obj_t BgL_fz00_936;
BgL_fz00_936 = 
CAR(BgL_l1590z00_929); 
{ /* bmem/bmem.scm 404 */
BgL_funinfoz00_bglt BgL_i1497z00_937;
if(
BGl_isazf3zf3zz__objectz00(BgL_fz00_936, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 405 */
BgL_i1497z00_937 = 
((BgL_funinfoz00_bglt)BgL_fz00_936); }  else 
{ 
obj_t BgL_auxz00_5454;
BgL_auxz00_5454 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14357)), BGl_string2740z00zzbmemz00, BGl_string2700z00zzbmemz00, BgL_fz00_936); 
FAILURE(BgL_auxz00_5454,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 405 */
obj_t BgL_selectorz00_938;
{ /* bmem/bmem.scm 405 */
int BgL_arg2128z00_945;
BgL_arg2128z00_945 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1497z00_937))->BgL_numz00); 
{ /* bmem/bmem.scm 405 */
obj_t BgL_list2129z00_946;
BgL_list2129z00_946 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2128z00_945), BNIL); 
BgL_selectorz00_938 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2741z00zzbmemz00, BgL_list2129z00_946); } } 
{ /* bmem/bmem.scm 405 */
obj_t BgL_colorz00_939;
BgL_colorz00_939 = 
BGl_csszd2colorzd2zzbmem_toolsz00(
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1497z00_937))->BgL_numz00), 
(int)(((long)143)), 
(int)(((long)255)), 
(int)(((long)128))); 
{ /* bmem/bmem.scm 406 */

{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2123z00_940;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2124z00_941;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2125z00_942;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2126z00_943;
BgL_arg2126z00_943 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2125z00_942 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2126z00_943); } 
BgL_arg2124z00_941 = 
MAKE_YOUNG_PAIR(BgL_colorz00_939, BgL_arg2125z00_942); } 
BgL_arg2123z00_940 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2124z00_941); } 
BgL_arg2122z00_935 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_938, BgL_arg2123z00_940); } } } } } } 
BgL_newtail1594z00_933 = 
MAKE_YOUNG_PAIR(BgL_arg2122z00_935, BNIL); } 
SET_CDR(BgL_tail1593z00_930, BgL_newtail1594z00_933); 
{ 
obj_t BgL_tail1593z00_5479;obj_t BgL_l1590z00_5477;
BgL_l1590z00_5477 = 
CDR(BgL_l1590z00_929); 
BgL_tail1593z00_5479 = BgL_newtail1594z00_933; 
BgL_tail1593z00_930 = BgL_tail1593z00_5479; 
BgL_l1590z00_929 = BgL_l1590z00_5477; 
goto BgL_zc3z04anonymousza32119za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3403z04ze3z51_931;} }  else 
{ /* bmem/bmem.scm 403 */
if(
NULLP(BgL_l1590z00_929))
{ /* bmem/bmem.scm 403 */
BgL_arg2113z00_920 = 
CDR(BgL_head1592z00_927); }  else 
{ /* bmem/bmem.scm 403 */
BgL_arg2113z00_920 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2704z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1590z00_929, BGl_string2602z00zzbmemz00, 
BINT(((long)14301))); } } } } 
BgL_arg2093z00_887 = 
MAKE_YOUNG_PAIR(BgL_arg2112z00_919, BgL_arg2113z00_920); } 
{ /* bmem/bmem.scm 422 */
obj_t BgL_arg2099z00_893;
{ /* bmem/bmem.scm 422 */
obj_t BgL_pairz00_1693;
if(
PAIRP(BgL_typesz00_19))
{ /* bmem/bmem.scm 422 */
BgL_pairz00_1693 = BgL_typesz00_19; }  else 
{ 
obj_t BgL_auxz00_5488;
BgL_auxz00_5488 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14976)), BGl_string2747z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_typesz00_19); 
FAILURE(BgL_auxz00_5488,BFALSE,BFALSE);} 
BgL_arg2099z00_893 = 
CDR(BgL_pairz00_1693); } 
BgL_typesz00_949 = BgL_arg2099z00_893; 
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2132z00_951;obj_t BgL_arg2133z00_952;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2134z00_953;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2135z00_954;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2136z00_955;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2137z00_956;
BgL_arg2137z00_956 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2136z00_955 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2137z00_956); } 
BgL_arg2135z00_954 = 
MAKE_YOUNG_PAIR(BGl_string2737z00zzbmemz00, BgL_arg2136z00_955); } 
BgL_arg2134z00_953 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2135z00_954); } 
BgL_arg2132z00_951 = 
MAKE_YOUNG_PAIR(BGl_string2742z00zzbmemz00, BgL_arg2134z00_953); } 
if(
NULLP(BgL_typesz00_949))
{ /* bmem/bmem.scm 411 */
BgL_arg2133z00_952 = BNIL; }  else 
{ /* bmem/bmem.scm 411 */
obj_t BgL_head1597z00_959;
BgL_head1597z00_959 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
{ 
obj_t BgL_l1595z00_961;obj_t BgL_tail1598z00_962;
BgL_l1595z00_961 = BgL_typesz00_949; 
BgL_tail1598z00_962 = BgL_head1597z00_959; 
BgL_zc3z04anonymousza32139za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3411z04ze3z51_963:
if(
PAIRP(BgL_l1595z00_961))
{ /* bmem/bmem.scm 411 */
obj_t BgL_newtail1599z00_965;
{ /* bmem/bmem.scm 411 */
obj_t BgL_arg2142z00_967;
{ /* bmem/bmem.scm 411 */
obj_t BgL_tz00_968;
BgL_tz00_968 = 
CAR(BgL_l1595z00_961); 
{ /* bmem/bmem.scm 412 */
obj_t BgL_iz00_969;
{ /* bmem/bmem.scm 412 */
obj_t BgL_pairz00_1673;
if(
PAIRP(BgL_tz00_968))
{ /* bmem/bmem.scm 412 */
BgL_pairz00_1673 = BgL_tz00_968; }  else 
{ 
obj_t BgL_auxz00_5509;
BgL_auxz00_5509 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14660)), BGl_string2743z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_968); 
FAILURE(BgL_auxz00_5509,BFALSE,BFALSE);} 
BgL_iz00_969 = 
CAR(BgL_pairz00_1673); } 
{ /* bmem/bmem.scm 412 */
obj_t BgL_selectorz00_970;
{ /* bmem/bmem.scm 413 */
obj_t BgL_list2150z00_979;
BgL_list2150z00_979 = 
MAKE_YOUNG_PAIR(BgL_iz00_969, BNIL); 
BgL_selectorz00_970 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string2744z00zzbmemz00, BgL_list2150z00_979); } 
{ /* bmem/bmem.scm 413 */
obj_t BgL_colorz00_971;
{ /* bmem/bmem.scm 414 */
bool_t BgL_test3191z00_5516;
{ /* bmem/bmem.scm 414 */
obj_t BgL_arg2149z00_978;
{ /* bmem/bmem.scm 414 */
obj_t BgL_pairz00_1674;
if(
PAIRP(BgL_tz00_968))
{ /* bmem/bmem.scm 414 */
BgL_pairz00_1674 = BgL_tz00_968; }  else 
{ 
obj_t BgL_auxz00_5519;
BgL_auxz00_5519 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14741)), BGl_string2743z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_tz00_968); 
FAILURE(BgL_auxz00_5519,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 414 */
obj_t BgL_pairz00_1677;
{ /* bmem/bmem.scm 414 */
obj_t BgL_aux2571z00_2074;
BgL_aux2571z00_2074 = 
CDR(BgL_pairz00_1674); 
if(
PAIRP(BgL_aux2571z00_2074))
{ /* bmem/bmem.scm 414 */
BgL_pairz00_1677 = BgL_aux2571z00_2074; }  else 
{ 
obj_t BgL_auxz00_5526;
BgL_auxz00_5526 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14735)), BGl_string2743z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2571z00_2074); 
FAILURE(BgL_auxz00_5526,BFALSE,BFALSE);} } 
BgL_arg2149z00_978 = 
CAR(BgL_pairz00_1677); } } 
{ /* bmem/bmem.scm 414 */
obj_t BgL_string1z00_1678;
if(
STRINGP(BgL_arg2149z00_978))
{ /* bmem/bmem.scm 414 */
BgL_string1z00_1678 = BgL_arg2149z00_978; }  else 
{ 
obj_t BgL_auxz00_5533;
BgL_auxz00_5533 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14742)), BGl_string2743z00zzbmemz00, BGl_string2626z00zzbmemz00, BgL_arg2149z00_978); 
FAILURE(BgL_auxz00_5533,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 414 */
long BgL_l1z00_1680;
BgL_l1z00_1680 = 
STRING_LENGTH(BgL_string1z00_1678); 
if(
(BgL_l1z00_1680==((long)4)))
{ /* bmem/bmem.scm 414 */
int BgL_arg1282z00_1683;
{ /* bmem/bmem.scm 414 */
char * BgL_auxz00_5542;char * BgL_tmpz00_5540;
BgL_auxz00_5542 = 
BSTRING_TO_STRING(BGl_string2745z00zzbmemz00); 
BgL_tmpz00_5540 = 
BSTRING_TO_STRING(BgL_string1z00_1678); 
BgL_arg1282z00_1683 = 
memcmp(BgL_tmpz00_5540, BgL_auxz00_5542, BgL_l1z00_1680); } 
BgL_test3191z00_5516 = 
(
(long)(BgL_arg1282z00_1683)==((long)0)); }  else 
{ /* bmem/bmem.scm 414 */
BgL_test3191z00_5516 = ((bool_t)0)
; } } } } 
if(BgL_test3191z00_5516)
{ /* bmem/bmem.scm 414 */
BgL_colorz00_971 = BGl_string2746z00zzbmemz00; }  else 
{ /* bmem/bmem.scm 416 */
int BgL_auxz00_5547;
{ /* bmem/bmem.scm 416 */
obj_t BgL_tmpz00_5548;
if(
INTEGERP(BgL_iz00_969))
{ /* bmem/bmem.scm 416 */
BgL_tmpz00_5548 = BgL_iz00_969
; }  else 
{ 
obj_t BgL_auxz00_5551;
BgL_auxz00_5551 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14797)), BGl_string2743z00zzbmemz00, BGl_string2661z00zzbmemz00, BgL_iz00_969); 
FAILURE(BgL_auxz00_5551,BFALSE,BFALSE);} 
BgL_auxz00_5547 = 
CINT(BgL_tmpz00_5548); } 
BgL_colorz00_971 = 
BGl_csszd2colorzd2zzbmem_toolsz00(BgL_auxz00_5547, 
(int)(((long)200)), 
(int)(((long)40)), 
(int)(((long)80))); } } 
{ /* bmem/bmem.scm 414 */

{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2143z00_972;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2144z00_973;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2145z00_974;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2146z00_975;
BgL_arg2146z00_975 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2145z00_974 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2146z00_975); } 
BgL_arg2144z00_973 = 
MAKE_YOUNG_PAIR(BgL_colorz00_971, BgL_arg2145z00_974); } 
BgL_arg2143z00_972 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2144z00_973); } 
BgL_arg2142z00_967 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_970, BgL_arg2143z00_972); } } } } } } 
BgL_newtail1599z00_965 = 
MAKE_YOUNG_PAIR(BgL_arg2142z00_967, BNIL); } 
SET_CDR(BgL_tail1598z00_962, BgL_newtail1599z00_965); 
{ 
obj_t BgL_tail1598z00_5572;obj_t BgL_l1595z00_5570;
BgL_l1595z00_5570 = 
CDR(BgL_l1595z00_961); 
BgL_tail1598z00_5572 = BgL_newtail1599z00_965; 
BgL_tail1598z00_962 = BgL_tail1598z00_5572; 
BgL_l1595z00_961 = BgL_l1595z00_5570; 
goto BgL_zc3z04anonymousza32139za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3411z04ze3z51_963;} }  else 
{ /* bmem/bmem.scm 411 */
if(
NULLP(BgL_l1595z00_961))
{ /* bmem/bmem.scm 411 */
BgL_arg2133z00_952 = 
CDR(BgL_head1597z00_959); }  else 
{ /* bmem/bmem.scm 411 */
BgL_arg2133z00_952 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2704z00zzbmemz00, BGl_string2664z00zzbmemz00, BgL_l1595z00_961, BGl_string2602z00zzbmemz00, 
BINT(((long)14625))); } } } } 
BgL_arg2094z00_888 = 
MAKE_YOUNG_PAIR(BgL_arg2132z00_951, BgL_arg2133z00_952); } } 
{ /* bmem/bmem.scm 420 */
obj_t BgL_list2095z00_889;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2096z00_890;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2097z00_891;
BgL_arg2097z00_891 = 
MAKE_YOUNG_PAIR(BgL_arg2094z00_888, BNIL); 
BgL_arg2096z00_890 = 
MAKE_YOUNG_PAIR(BgL_arg2093z00_887, BgL_arg2097z00_891); } 
BgL_list2095z00_889 = 
MAKE_YOUNG_PAIR(BgL_arg2092z00_886, BgL_arg2096z00_890); } 
BgL_arg2091z00_885 = 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2095z00_889); } } 
{ /* bmem/bmem.scm 419 */
obj_t BgL_auxz00_5583;
if(
PAIRP(BgL_arg2091z00_885))
{ /* bmem/bmem.scm 422 */
BgL_auxz00_5583 = BgL_arg2091z00_885
; }  else 
{ 
obj_t BgL_auxz00_5586;
BgL_auxz00_5586 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)14983)), BGl_string2747z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_arg2091z00_885); 
FAILURE(BgL_auxz00_5586,BFALSE,BFALSE);} 
BgL_aux2256z00_1096 = 
BGl_listzd2ze3cssz31zzhtmlz00(BgL_auxz00_5583); } } } 
BGL_ENV_POP_TRACE(BgL_env2259z00_1095); 
return 
((obj_t)BgL_aux2256z00_1096);} } } } 

}



/* &dynamic-css */
obj_t BGl_z62dynamiczd2csszb0zzbmemz00(obj_t BgL_envz00_1775, obj_t BgL_gcmonz00_1776, obj_t BgL_functionz00_1777, obj_t BgL_typesz00_1778)
{
{ /* bmem/bmem.scm 388 */
return 
BGl_dynamiczd2csszd2zzbmemz00(BgL_gcmonz00_1776, BgL_functionz00_1777, BgL_typesz00_1778);} 

}



/* find-monitor */
obj_t BGl_findzd2monitorzd2zzbmemz00(obj_t BgL_monz00_20, obj_t BgL_keyz00_21)
{
{ /* bmem/bmem.scm 427 */
{ /* bmem/bmem.scm 430 */
obj_t BgL_name2261z00_1097;obj_t BgL_loc2262z00_1098;obj_t BgL_env2263z00_1099;
BgL_name2261z00_1097 = 
CNST_TABLE_REF(((long)76)); 
BgL_loc2262z00_1098 = 
CNST_TABLE_REF(((long)77)); 
BgL_env2263z00_1099 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 430 */

BGL_ENV_PUSH_TRACE(BgL_env2263z00_1099, BgL_name2261z00_1097, BgL_loc2262z00_1098); 
{ /* bmem/bmem.scm 430 */
obj_t BgL_aux2260z00_1100;
{ 
obj_t BgL_monz00_986;
BgL_monz00_986 = BgL_monz00_20; 
BgL_zc3z04anonymousza32152za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3428z04ze3z51_987:
if(
NULLP(BgL_monz00_986))
{ /* bmem/bmem.scm 430 */
BgL_aux2260z00_1100 = BFALSE; }  else 
{ /* bmem/bmem.scm 432 */
bool_t BgL_test3200z00_5600;
{ /* bmem/bmem.scm 432 */
bool_t BgL_test3201z00_5601;
{ /* bmem/bmem.scm 432 */
obj_t BgL_tmpz00_5602;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_1694;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_1694 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_5605;
BgL_auxz00_5605 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)15320)), BGl_string2748z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_5605,BFALSE,BFALSE);} 
BgL_tmpz00_5602 = 
CAR(BgL_pairz00_1694); } 
BgL_test3201z00_5601 = 
PAIRP(BgL_tmpz00_5602); } 
if(BgL_test3201z00_5601)
{ /* bmem/bmem.scm 432 */
obj_t BgL_tmpz00_5611;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_1696;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_1695;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_1695 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_5614;
BgL_auxz00_5614 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)15341)), BGl_string2748z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_5614,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 432 */
obj_t BgL_aux2587z00_2090;
BgL_aux2587z00_2090 = 
CAR(BgL_pairz00_1695); 
if(
PAIRP(BgL_aux2587z00_2090))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_1696 = BgL_aux2587z00_2090; }  else 
{ 
obj_t BgL_auxz00_5621;
BgL_auxz00_5621 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)15336)), BGl_string2748z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_aux2587z00_2090); 
FAILURE(BgL_auxz00_5621,BFALSE,BFALSE);} } } 
BgL_tmpz00_5611 = 
CAR(BgL_pairz00_1696); } 
BgL_test3200z00_5600 = 
(BgL_tmpz00_5611==BgL_keyz00_21); }  else 
{ /* bmem/bmem.scm 432 */
BgL_test3200z00_5600 = ((bool_t)0)
; } } 
if(BgL_test3200z00_5600)
{ /* bmem/bmem.scm 433 */
obj_t BgL_pairz00_1697;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 433 */
BgL_pairz00_1697 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_5629;
BgL_auxz00_5629 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)15361)), BGl_string2748z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_5629,BFALSE,BFALSE);} 
BgL_aux2260z00_1100 = 
CAR(BgL_pairz00_1697); }  else 
{ 
obj_t BgL_monz00_5634;
{ /* bmem/bmem.scm 435 */
obj_t BgL_pairz00_1698;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 435 */
BgL_pairz00_1698 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_5637;
BgL_auxz00_5637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2602z00zzbmemz00, 
BINT(((long)15389)), BGl_string2748z00zzbmemz00, BGl_string2622z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_5637,BFALSE,BFALSE);} 
BgL_monz00_5634 = 
CDR(BgL_pairz00_1698); } 
BgL_monz00_986 = BgL_monz00_5634; 
goto BgL_zc3z04anonymousza32152za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24bzf2bdezf2bmemzf2bmemzf2bmemzc2scmza3428z04ze3z51_987;} } } 
BGL_ENV_POP_TRACE(BgL_env2263z00_1099); 
return BgL_aux2260z00_1100;} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2265z00_1101;obj_t BgL_loc2266z00_1102;obj_t BgL_env2267z00_1103;
BgL_name2265z00_1101 = 
CNST_TABLE_REF(((long)78)); 
BgL_loc2266z00_1102 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2267z00_1103 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2267z00_1103, BgL_name2265z00_1101, BgL_loc2266z00_1102); 
BGL_ENV_POP_TRACE(BgL_env2267z00_1103); 
return BUNSPEC;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2269z00_1105;obj_t BgL_loc2270z00_1106;obj_t BgL_env2271z00_1107;
BgL_name2269z00_1105 = 
CNST_TABLE_REF(((long)79)); 
BgL_loc2270z00_1106 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2271z00_1107 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2271z00_1107, BgL_name2269z00_1105, BgL_loc2270z00_1106); 
BGL_ENV_POP_TRACE(BgL_env2271z00_1107); 
return BUNSPEC;} } } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2273z00_1109;obj_t BgL_loc2274z00_1110;obj_t BgL_env2275z00_1111;
BgL_name2273z00_1109 = 
CNST_TABLE_REF(((long)80)); 
BgL_loc2274z00_1110 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2275z00_1111 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2275z00_1111, BgL_name2273z00_1109, BgL_loc2274z00_1110); 
BGL_ENV_POP_TRACE(BgL_env2275z00_1111); 
return BUNSPEC;} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2277z00_1113;obj_t BgL_loc2278z00_1114;obj_t BgL_env2279z00_1115;
BgL_name2277z00_1113 = 
CNST_TABLE_REF(((long)81)); 
BgL_loc2278z00_1114 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2279z00_1115 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2279z00_1115, BgL_name2277z00_1113, BgL_loc2278z00_1114); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2276z00_1116;
BGl_modulezd2initializa7ationz75zzhtmlz00(((long)75074024), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_paramz00(((long)145760956), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_toolsz00(((long)330722983), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_functionz00(((long)88630197), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_gcz00(((long)471623548), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_typez00(((long)176367264), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BgL_aux2276z00_1116 = 
BGl_modulezd2initializa7ationz75zzbmem_threadz00(((long)222586157), 
BSTRING_TO_STRING(BGl_string2749z00zzbmemz00)); 
BGL_ENV_POP_TRACE(BgL_env2279z00_1115); 
return BgL_aux2276z00_1116;} } } } 

}

#ifdef __cplusplus
}
#endif
