/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
		obj_t BgL_valzd2noescapezd2;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00(BgL_nodez00_bglt);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t,
		int);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00
		(BgL_globalz00_bglt, BgL_nodez00_bglt, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza31530ze3ze70z60zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza36924ze3ze5zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_liipze70ze7zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31534ze3ze5zzast_sexpz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31535ze3ze5zzast_sexpz00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_gczd2rootszd2initz00zzast_sexpz00();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	static obj_t BGl_loopze70ze7zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	static obj_t __cnst[49];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d7433za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e37434z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzf2srczd2ze3nodezd2envz11zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim7435z00,
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00, 0L, BUNSPEC,
		3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim7436z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string7400z00zzast_sexpz00,
		BgL_bgl_string7400za700za7za7a7437za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string7401z00zzast_sexpz00,
		BgL_bgl_string7401za700za7za7a7438za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string7402z00zzast_sexpz00,
		BgL_bgl_string7402za700za7za7a7439za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string7403z00zzast_sexpz00,
		BgL_bgl_string7403za700za7za7a7440za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string7404z00zzast_sexpz00,
		BgL_bgl_string7404za700za7za7a7441za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string7405z00zzast_sexpz00,
		BgL_bgl_string7405za700za7za7a7442za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string7406z00zzast_sexpz00,
		BgL_bgl_string7406za700za7za7a7443za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string7407z00zzast_sexpz00,
		BgL_bgl_string7407za700za7za7a7444za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string7408z00zzast_sexpz00,
		BgL_bgl_string7408za700za7za7a7445za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string7409z00zzast_sexpz00,
		BgL_bgl_string7409za700za7za7a7446za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string7410z00zzast_sexpz00,
		BgL_bgl_string7410za700za7za7a7447za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string7411z00zzast_sexpz00,
		BgL_bgl_string7411za700za7za7a7448za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string7412z00zzast_sexpz00,
		BgL_bgl_string7412za700za7za7a7449za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string7413z00zzast_sexpz00,
		BgL_bgl_string7413za700za7za7a7450za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string7414z00zzast_sexpz00,
		BgL_bgl_string7414za700za7za7a7451za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string7415z00zzast_sexpz00,
		BgL_bgl_string7415za700za7za7a7452za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string7416z00zzast_sexpz00,
		BgL_bgl_string7416za700za7za7a7453za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string7417z00zzast_sexpz00,
		BgL_bgl_string7417za700za7za7a7454za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string7418z00zzast_sexpz00,
		BgL_bgl_string7418za700za7za7a7455za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string7419z00zzast_sexpz00,
		BgL_bgl_string7419za700za7za7a7456za7, "Illegal lambda", 14);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza77457za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string7420z00zzast_sexpz00,
		BgL_bgl_string7420za700za7za7a7458za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string7421z00zzast_sexpz00,
		BgL_bgl_string7421za700za7za7a7459za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string7422z00zzast_sexpz00,
		BgL_bgl_string7422za700za7za7a7460za7, "($1)", 4);
	      DEFINE_STRING(BGl_string7423z00zzast_sexpz00,
		BgL_bgl_string7423za700za7za7a7461za7, "<@", 2);
	      DEFINE_STRING(BGl_string7424z00zzast_sexpz00,
		BgL_bgl_string7424za700za7za7a7462za7, ":", 1);
	      DEFINE_STRING(BGl_string7425z00zzast_sexpz00,
		BgL_bgl_string7425za700za7za7a7463za7, "./", 2);
	      DEFINE_STRING(BGl_string7426z00zzast_sexpz00,
		BgL_bgl_string7426za700za7za7a7464za7, "@>", 2);
	      DEFINE_STRING(BGl_string7427z00zzast_sexpz00,
		BgL_bgl_string7427za700za7za7a7465za7, ">", 1);
	      DEFINE_STRING(BGl_string7428z00zzast_sexpz00,
		BgL_bgl_string7428za700za7za7a7466za7, "-", 1);
	      DEFINE_STRING(BGl_string7429z00zzast_sexpz00,
		BgL_bgl_string7429za700za7za7a7467za7, "ast_sexp", 8);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string7430z00zzast_sexpz00,
		BgL_bgl_string7430za700za7za7a7468za7,
		"not mutex @> bdb anonymous location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) at (@ define-primop-ref/loc! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock apply synchronize jump-exit set-exit case failure free-pragma/effect static-pragma free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval bool test set! pragma else (quote ()) lambda value if (value apply app set! test) ",
		480);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za77469za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym7470z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza77471za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e7472za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string7396z00zzast_sexpz00,
		BgL_bgl_string7396za700za7za7a7473za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string7397z00zzast_sexpz00,
		BgL_bgl_string7397za700za7za7a7474za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string7398z00zzast_sexpz00,
		BgL_bgl_string7398za700za7za7a7475za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string7399z00zzast_sexpz00,
		BgL_bgl_string7399za700za7za7a7476za7, "Illegal `static-pragma' expression",
		34);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod7477za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl7478z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim7479z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2nameza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2resza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2sitesza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2ifza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2stackza2zd2zzast_sexpz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_13261, char *BgL_fromz00_13262)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_sexpz00();
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_13249;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_stringz00_13257;

					BgL_stringz00_13257 = BGl_string7430z00zzast_sexpz00;
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_startz00_13258;

						BgL_startz00_13258 = BINT(((long) 0));
						{	/* Ast/sexp.scm 14 */
							obj_t BgL_endz00_13259;

							BgL_endz00_13259 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_13257)));
							{	/* Ast/sexp.scm 14 */

								BgL_cportz00_13249 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_13257, BgL_startz00_13258, BgL_endz00_13259);
				}}}}
				{
					long BgL_iz00_13250;

					BgL_iz00_13250 = ((long) 48);
				BgL_loopz00_13251:
					if ((BgL_iz00_13250 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg7432z00_13253;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_13255;

										BgL_locationz00_13255 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg7432z00_13253 =
												BGl_readz00zz__readerz00(BgL_cportz00_13249,
												BgL_locationz00_13255);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_tmpz00_13300;

									BgL_tmpz00_13300 = (int) (BgL_iz00_13250);
									CNST_TABLE_SET(BgL_tmpz00_13300, BgL_arg7432z00_13253);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_13256;

								BgL_auxz00_13256 = (int) ((BgL_iz00_13250 - ((long) 1)));
								{
									long BgL_iz00_13305;

									BgL_iz00_13305 = (long) (BgL_auxz00_13256);
									BgL_iz00_13250 = BgL_iz00_13305;
									goto BgL_loopz00_13251;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}

	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		{	/* Ast/sexp.scm 66 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3z04exitza31530ze3ze70z60zzast_sexpz00(BgL_locz00_18,
					BgL_expz00_17));
		}

	}



/* <@exit:1530>~0 */
	obj_t BGl_zc3z04exitza31530ze3ze70z60zzast_sexpz00(obj_t BgL_locz00_13247,
		obj_t BgL_expz00_13246)
	{
		{	/* Ast/sexp.scm 67 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1108z00_1731;

			if (SET_EXIT(BgL_an_exit1108z00_1731))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
				 // MS: CARE 5 jan 2021: see runtime/Clib/csystem.c  // bgl_restore_signal_handlers();
#endif

					BgL_an_exit1108z00_1731 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 67 */

						PUSH_EXIT(BgL_an_exit1108z00_1731, ((long) 1));
						{	/* Ast/sexp.scm 67 */
							obj_t BgL_an_exitd1109z00_1732;

							BgL_an_exitd1109z00_1732 = ((obj_t) (&exitd));
							{	/* Ast/sexp.scm 67 */
								obj_t BgL_res1111z00_1735;

								{	/* Ast/sexp.scm 70 */
									obj_t BgL_zc3z04anonymousza31535ze3z87_13189;
									obj_t BgL_zc3z04anonymousza31534ze3z87_13190;

									BgL_zc3z04anonymousza31535ze3z87_13189 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31535ze3ze5zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3z04anonymousza31534ze3z87_13190 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31534ze3ze5zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31535ze3z87_13189,
										(int) (((long) 0)), BgL_expz00_13246);
									PROCEDURE_SET(BgL_zc3z04anonymousza31535ze3z87_13189,
										(int) (((long) 1)), BgL_locz00_13247);
									PROCEDURE_SET(BgL_zc3z04anonymousza31534ze3z87_13190,
										(int) (((long) 0)), BgL_an_exitd1109z00_1732);
									BgL_res1111z00_1735 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3z04anonymousza31534ze3z87_13190,
										BgL_zc3z04anonymousza31535ze3z87_13189);
								}
								POP_EXIT();
								return BgL_res1111z00_1735;
							}
						}
					}
				}
		}

	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13191, obj_t BgL_expz00_13192, obj_t BgL_locz00_13193)
	{
		{	/* Ast/sexp.scm 66 */
			return
				BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13192,
				BgL_locz00_13193);
		}

	}



/* &<@anonymous:1535> */
	obj_t BGl_z62zc3z04anonymousza31535ze3ze5zzast_sexpz00(obj_t BgL_envz00_13194)
	{
		{	/* Ast/sexp.scm 72 */
			{	/* Ast/sexp.scm 73 */
				obj_t BgL_expz00_13195;
				obj_t BgL_locz00_13196;

				BgL_expz00_13195 = PROCEDURE_REF(BgL_envz00_13194, (int) (((long) 0)));
				BgL_locz00_13196 = PROCEDURE_REF(BgL_envz00_13194, (int) (((long) 1)));
				return
					((obj_t)
					BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13195, BNIL,
						BgL_locz00_13196, CNST_TABLE_REF(((long) 2))));
		}}

	}



/* &<@anonymous:1534> */
	obj_t BGl_z62zc3z04anonymousza31534ze3ze5zzast_sexpz00(obj_t BgL_envz00_13197,
		obj_t BgL_ez00_13199)
	{
		{	/* Ast/sexp.scm 69 */
			{	/* Ast/sexp.scm 70 */
				obj_t BgL_an_exitd1109z00_13198;

				BgL_an_exitd1109z00_13198 =
					PROCEDURE_REF(BgL_envz00_13197, (int) (((long) 0)));
				BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_13199);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1109z00_13198,
					BUNSPEC);
			}
		}

	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}

	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_13200)
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_ifzd2symzd2zzast_sexpz00();
		}

	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		{	/* Ast/sexp.scm 100 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 101 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 101 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 101 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 101 */
									obj_t BgL_tmpz00_13351;

									BgL_tmpz00_13351 = CDR(BgL_ez00_20);
									return PAIRP(BgL_tmpz00_13351);
								}
							else
								{	/* Ast/sexp.scm 101 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 101 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		{	/* Ast/sexp.scm 114 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1757;
				obj_t BgL_lz00_1762;
				obj_t BgL_bodyz00_1766;
				obj_t BgL_lz00_1771;
				obj_t BgL_valz00_1772;
				obj_t BgL_bodyz00_1776;
				obj_t BgL_argsz00_1777;
				obj_t BgL_bindingsz00_1779;
				obj_t BgL_exprz00_1780;
				obj_t BgL_varz00_1784;
				obj_t BgL_bodyz00_1785;
				obj_t BgL_argz00_1786;
				obj_t BgL_varsz00_1788;
				obj_t BgL_bodyz00_1789;
				obj_t BgL_argsz00_1790;
				obj_t BgL_testz00_1792;
				obj_t BgL_proc1z00_1793;
				obj_t BgL_proc2z00_1794;
				obj_t BgL_argsz00_1795;
				obj_t BgL_testz00_1797;
				obj_t BgL_proc1z00_1798;
				obj_t BgL_proc2z00_1799;
				obj_t BgL_argsz00_1800;
				obj_t BgL_effectz00_1804;
				obj_t BgL_restz00_1805;
				obj_t BgL_effectz00_1809;
				obj_t BgL_restz00_1810;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 119 */
						{	/* Ast/sexp.scm 122 */
							BgL_nodez00_bglt BgL_res7358z00_9667;

							{	/* Ast/sexp.scm 726 */
								obj_t BgL_arg7138z00_9663;
								BgL_nodez00_bglt BgL_arg7139z00_9664;

								BgL_arg7138z00_9663 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg7139z00_9664 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 725 */
									obj_t BgL_list7140z00_9666;

									BgL_list7140z00_9666 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg7139z00_9664), BNIL);
									BgL_res7358z00_9667 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg7138z00_9663,
											BGl_string7412z00zzast_sexpz00, BgL_expz00_21,
											BgL_list7140z00_9666));
							}}
							return BgL_res7358z00_9667;
						}
					}
				else
					{	/* Ast/sexp.scm 119 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_13367;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 127 */
										obj_t BgL_l01345z00_8386;

										BgL_l01345z00_8386 =
											(((BgL_externz00_bglt) COBJECT(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1344z00_8388;

											BgL_l1344z00_8388 = BgL_l01345z00_8386;
										BgL_zc3z04anonymousza36643ze3z87_8389:
											if (NULLP(BgL_l1344z00_8388))
												{	/* Ast/sexp.scm 127 */
													BgL_l01345z00_8386;
												}
											else
												{	/* Ast/sexp.scm 127 */
													{	/* Ast/sexp.scm 127 */
														BgL_nodez00_bglt BgL_arg6645z00_8391;

														{	/* Ast/sexp.scm 127 */
															obj_t BgL_ez00_8392;

															BgL_ez00_8392 = CAR(((obj_t) BgL_l1344z00_8388));
															{	/* Ast/sexp.scm 127 */
																obj_t BgL_arg6646z00_8393;

																BgL_arg6646z00_8393 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg6645z00_8391 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8392, BgL_stackz00_22,
																	BgL_arg6646z00_8393,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 127 */
															obj_t BgL_auxz00_13383;
															obj_t BgL_tmpz00_13381;

															BgL_auxz00_13383 = ((obj_t) BgL_arg6645z00_8391);
															BgL_tmpz00_13381 = ((obj_t) BgL_l1344z00_8388);
															SET_CAR(BgL_tmpz00_13381, BgL_auxz00_13383);
													}}
													{	/* Ast/sexp.scm 127 */
														obj_t BgL_arg6647z00_8394;

														BgL_arg6647z00_8394 =
															CDR(((obj_t) BgL_l1344z00_8388));
														{
															obj_t BgL_l1344z00_13388;

															BgL_l1344z00_13388 = BgL_arg6647z00_8394;
															BgL_l1344z00_8388 = BgL_l1344z00_13388;
															goto BgL_zc3z04anonymousza36643ze3z87_8389;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 125 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 130 */
										obj_t BgL_l01348z00_8398;

										BgL_l01348z00_8398 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1347z00_8400;

											BgL_l1347z00_8400 = BgL_l01348z00_8398;
										BgL_zc3z04anonymousza36649ze3z87_8401:
											if (NULLP(BgL_l1347z00_8400))
												{	/* Ast/sexp.scm 130 */
													BgL_l01348z00_8398;
												}
											else
												{	/* Ast/sexp.scm 130 */
													{	/* Ast/sexp.scm 130 */
														BgL_nodez00_bglt BgL_arg6651z00_8403;

														{	/* Ast/sexp.scm 130 */
															obj_t BgL_ez00_8404;

															BgL_ez00_8404 = CAR(((obj_t) BgL_l1347z00_8400));
															{	/* Ast/sexp.scm 130 */
																obj_t BgL_arg6652z00_8405;

																BgL_arg6652z00_8405 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg6651z00_8403 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8404, BgL_stackz00_22,
																	BgL_arg6652z00_8405,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 130 */
															obj_t BgL_auxz00_13404;
															obj_t BgL_tmpz00_13402;

															BgL_auxz00_13404 = ((obj_t) BgL_arg6651z00_8403);
															BgL_tmpz00_13402 = ((obj_t) BgL_l1347z00_8400);
															SET_CAR(BgL_tmpz00_13402, BgL_auxz00_13404);
													}}
													{	/* Ast/sexp.scm 130 */
														obj_t BgL_arg6653z00_8406;

														BgL_arg6653z00_8406 =
															CDR(((obj_t) BgL_l1347z00_8400));
														{
															obj_t BgL_l1347z00_13409;

															BgL_l1347z00_13409 = BgL_arg6653z00_8406;
															BgL_l1347z00_8400 = BgL_l1347z00_13409;
															goto BgL_zc3z04anonymousza36649ze3z87_8401;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 128 */
										BFALSE;
									}
								BgL_auxz00_13367 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_13367);
							}
						else
							{	/* Ast/sexp.scm 119 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 119 */
										obj_t BgL_carzd2478zd2_1831;

										BgL_carzd2478zd2_1831 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2478zd2_1831))
											{	/* Ast/sexp.scm 119 */
												bool_t BgL_test7493z00_13416;

												{	/* Ast/sexp.scm 119 */
													obj_t BgL__ortest_1147z00_5111;

													BgL__ortest_1147z00_5111 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2478zd2_1831, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1147z00_5111))
														{	/* Ast/sexp.scm 119 */
															BgL_test7493z00_13416 =
																CBOOL(BgL__ortest_1147z00_5111);
														}
													else
														{	/* Ast/sexp.scm 119 */
															obj_t BgL_gz00_5112;

															BgL_gz00_5112 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2478zd2_1831, BNIL);
															if (CBOOL(BgL_gz00_5112))
																{	/* Ast/sexp.scm 119 */
																	if (
																		((((BgL_globalz00_bglt) COBJECT(
																						((BgL_globalz00_bglt)
																							BgL_gz00_5112)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* Ast/sexp.scm 119 */
																			BgL_test7493z00_13416 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 119 */
																			BgL_test7493z00_13416 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 119 */
																	BgL_test7493z00_13416 = ((bool_t) 0);
																}
														}
												}
												if (BgL_test7493z00_13416)
													{	/* Ast/sexp.scm 119 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 11))))
															{	/* Ast/sexp.scm 119 */
															BgL_tagzd2371zd2_1761:
																{	/* Ast/sexp.scm 174 */
																	obj_t BgL_locz00_8438;

																	BgL_locz00_8438 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_8439;
																		obj_t BgL_modulez00_8440;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 175 */
																				obj_t BgL_cdrzd262164zd2_8445;

																				BgL_cdrzd262164zd2_8445 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 11))))
																					{	/* Ast/sexp.scm 175 */
																						if (PAIRP(BgL_cdrzd262164zd2_8445))
																							{	/* Ast/sexp.scm 175 */
																								obj_t BgL_carzd262167zd2_8449;
																								obj_t BgL_cdrzd262168zd2_8450;

																								BgL_carzd262167zd2_8449 =
																									CAR(BgL_cdrzd262164zd2_8445);
																								BgL_cdrzd262168zd2_8450 =
																									CDR(BgL_cdrzd262164zd2_8445);
																								if (SYMBOLP
																									(BgL_carzd262167zd2_8449))
																									{	/* Ast/sexp.scm 175 */
																										if (PAIRP
																											(BgL_cdrzd262168zd2_8450))
																											{	/* Ast/sexp.scm 175 */
																												obj_t
																													BgL_carzd262173zd2_8453;
																												BgL_carzd262173zd2_8453
																													=
																													CAR
																													(BgL_cdrzd262168zd2_8450);
																												if (SYMBOLP
																													(BgL_carzd262173zd2_8453))
																													{	/* Ast/sexp.scm 175 */
																														if (NULLP(CDR
																																(BgL_cdrzd262168zd2_8450)))
																															{	/* Ast/sexp.scm 175 */
																																BgL_namez00_8439
																																	=
																																	BgL_carzd262167zd2_8449;
																																BgL_modulez00_8440
																																	=
																																	BgL_carzd262173zd2_8453;
																																{	/* Ast/sexp.scm 177 */
																																	obj_t
																																		BgL_globalz00_8459;
																																	obj_t
																																		BgL_locz00_8460;
																																	BgL_globalz00_8459
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_8439,
																																		BgL_modulez00_8440);
																																	BgL_locz00_8460
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_namez00_8439,
																																		BgL_locz00_8438);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_8459, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 180 */
																																			if (
																																				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_globalz00_8459)))->BgL_importz00) == CNST_TABLE_REF(((long) 10))))
																																				{	/* Ast/sexp.scm 183 */
																																					obj_t
																																						BgL_arg6686z00_8464;
																																					{	/* Ast/sexp.scm 183 */
																																						obj_t
																																							BgL_arg6687z00_8465;
																																						BgL_arg6687z00_8465
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg6686z00_8464
																																							=
																																							MAKE_YOUNG_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 10)), BgL_arg6687z00_8465);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_13469;
																																						obj_t
																																							BgL_expz00_13468;
																																						BgL_expz00_13468
																																							=
																																							BgL_arg6686z00_8464;
																																						BgL_locz00_13469
																																							=
																																							BgL_locz00_8460;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_13469;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_13468;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 182 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_8459,
																																						BgL_locz00_8460,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 181 */
																																			BgL_nodez00_bglt
																																				BgL_res7361z00_9697;
																																			{	/* Ast/sexp.scm 726 */
																																				obj_t
																																					BgL_arg7138z00_9693;
																																				BgL_nodez00_bglt
																																					BgL_arg7139z00_9694;
																																				BgL_arg7138z00_9693
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg7139z00_9694
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_8460, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 725 */
																																					obj_t
																																						BgL_list7140z00_9696;
																																					BgL_list7140z00_9696
																																						=
																																						MAKE_YOUNG_PAIR
																																						(((obj_t) BgL_arg7139z00_9694), BNIL);
																																					BgL_res7361z00_9697
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_8460,
																																							BgL_arg7138z00_9693,
																																							BGl_string7410z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list7140z00_9696));
																																			}}
																																			return
																																				BgL_res7361z00_9697;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 175 */
																															BgL_tagzd262157zd2_8442:
																																{	/* Ast/sexp.scm 187 */
																																	BgL_nodez00_bglt
																																		BgL_res7362z00_9703;
																																	{	/* Ast/sexp.scm 726 */
																																		obj_t
																																			BgL_arg7138z00_9699;
																																		BgL_nodez00_bglt
																																			BgL_arg7139z00_9700;
																																		BgL_arg7138z00_9699
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg7139z00_9700
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_8438,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 725 */
																																			obj_t
																																				BgL_list7140z00_9702;
																																			BgL_list7140z00_9702
																																				=
																																				MAKE_YOUNG_PAIR
																																				(((obj_t) BgL_arg7139z00_9700), BNIL);
																																			BgL_res7362z00_9703
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_8438,
																																					BgL_arg7138z00_9699,
																																					BGl_string7409z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list7140z00_9702));
																																	}}
																																	return
																																		BgL_res7362z00_9703;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 175 */
																														goto
																															BgL_tagzd262157zd2_8442;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 175 */
																												goto
																													BgL_tagzd262157zd2_8442;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 175 */
																										goto
																											BgL_tagzd262157zd2_8442;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 175 */
																								goto BgL_tagzd262157zd2_8442;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 175 */
																						goto BgL_tagzd262157zd2_8442;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 175 */
																				goto BgL_tagzd262157zd2_8442;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 14))))
																	{	/* Ast/sexp.scm 119 */
																		BgL_lz00_1762 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1763:
																		{	/* Ast/sexp.scm 190 */
																			bool_t BgL_test7508z00_13493;

																			if (PAIRP(BgL_lz00_1762))
																				{	/* Ast/sexp.scm 190 */
																					bool_t BgL_test7510z00_13496;

																					{	/* Ast/sexp.scm 190 */
																						obj_t BgL_tmpz00_13497;

																						BgL_tmpz00_13497 =
																							CDR(BgL_lz00_1762);
																						BgL_test7510z00_13496 =
																							PAIRP(BgL_tmpz00_13497);
																					}
																					if (BgL_test7510z00_13496)
																						{
																							obj_t BgL_l1349z00_8484;

																							BgL_l1349z00_8484 = BgL_lz00_1762;
																						BgL_zc3z04anonymousza36698ze3z87_8485:
																							if (NULLP
																								(BgL_l1349z00_8484))
																								{	/* Ast/sexp.scm 190 */
																									BgL_test7508z00_13493 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 190 */
																									bool_t BgL_test7512z00_13502;

																									{	/* Ast/sexp.scm 190 */
																										obj_t BgL_tmpz00_13503;

																										BgL_tmpz00_13503 =
																											CAR(
																											((obj_t)
																												BgL_l1349z00_8484));
																										BgL_test7512z00_13502 =
																											SYMBOLP(BgL_tmpz00_13503);
																									}
																									if (BgL_test7512z00_13502)
																										{
																											obj_t BgL_l1349z00_13507;

																											BgL_l1349z00_13507 =
																												CDR(
																												((obj_t)
																													BgL_l1349z00_8484));
																											BgL_l1349z00_8484 =
																												BgL_l1349z00_13507;
																											goto
																												BgL_zc3z04anonymousza36698ze3z87_8485;
																										}
																									else
																										{	/* Ast/sexp.scm 190 */
																											BgL_test7508z00_13493 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 190 */
																							BgL_test7508z00_13493 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 190 */
																					BgL_test7508z00_13493 = ((bool_t) 0);
																				}
																			if (BgL_test7508z00_13493)
																				{	/* Ast/sexp.scm 190 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1762, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 192 */
																					BgL_nodez00_bglt BgL_res7363z00_9718;

																					{	/* Ast/sexp.scm 726 */
																						obj_t BgL_arg7138z00_9714;
																						BgL_nodez00_bglt
																							BgL_arg7139z00_9715;
																						BgL_arg7138z00_9714 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7139z00_9715 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 725 */
																							obj_t BgL_list7140z00_9717;

																							BgL_list7140z00_9717 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7139z00_9715),
																								BNIL);
																							BgL_res7363z00_9718 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg7138z00_9714,
																									BGl_string7406z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7140z00_9717));
																					}}
																					return BgL_res7363z00_9718;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 119 */
																			BgL_tagzd2373zd2_1764:
																				{
																					obj_t BgL_valuez00_8493;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 119 */
																							obj_t BgL_cdrzd262184zd2_8498;

																							BgL_cdrzd262184zd2_8498 =
																								CDR(BgL_expz00_21);
																							if (PAIRP
																								(BgL_cdrzd262184zd2_8498))
																								{	/* Ast/sexp.scm 119 */
																									if (NULLP(CDR
																											(BgL_cdrzd262184zd2_8498)))
																										{	/* Ast/sexp.scm 119 */
																											BgL_valuez00_8493 =
																												CAR
																												(BgL_cdrzd262184zd2_8498);
																											{	/* Ast/sexp.scm 197 */
																												obj_t BgL_locz00_8504;

																												BgL_locz00_8504 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_8493))
																													{	/* Ast/sexp.scm 200 */
																														BgL_literalz00_bglt
																															BgL_new1123z00_8506;
																														{	/* Ast/sexp.scm 201 */
																															BgL_literalz00_bglt
																																BgL_new1122z00_8508;
																															BgL_new1122z00_8508
																																=
																																(
																																(BgL_literalz00_bglt)
																																BOBJECT
																																(GC_MALLOC
																																	(sizeof(struct
																																			BgL_literalz00_bgl))));
																															{	/* Ast/sexp.scm 201 */
																																long
																																	BgL_arg6710z00_8509;
																																BgL_arg6710z00_8509
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_literalz00zzast_nodez00);
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1122z00_8508), BgL_arg6710z00_8509);
																															}
																															{	/* Ast/sexp.scm 201 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_13540;
																																BgL_tmpz00_13540
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1122z00_8508);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_tmpz00_13540,
																																	BFALSE);
																															}
																															((BgL_objectz00_bglt) BgL_new1122z00_8508);
																															BgL_new1123z00_8506
																																=
																																BgL_new1122z00_8508;
																														}
																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1123z00_8506)))->BgL_locz00) = ((obj_t) BgL_locz00_8504), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_13546;
																															{	/* Ast/sexp.scm 202 */
																																BgL_typez00_bglt
																																	BgL_arg6709z00_8507;
																																BgL_arg6709z00_8507
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_8493);
																																BgL_auxz00_13546
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg6709z00_8507,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1123z00_8506)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_13546), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_new1123z00_8506)))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1123z00_8506);
																													}
																												else
																													{	/* Ast/sexp.scm 204 */
																														bool_t
																															BgL_test7518z00_13555;
																														if (PAIRP
																															(BgL_valuez00_8493))
																															{	/* Ast/sexp.scm 204 */
																																BgL_test7518z00_13555
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 204 */
																																if (VECTORP
																																	(BgL_valuez00_8493))
																																	{	/* Ast/sexp.scm 205 */
																																		BgL_test7518z00_13555
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 205 */
																																		if (BGL_HVECTORP(BgL_valuez00_8493))
																																			{	/* Ast/sexp.scm 206 */
																																				BgL_test7518z00_13555
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 206 */
																																				if (STRUCTP(BgL_valuez00_8493))
																																					{	/* Ast/sexp.scm 207 */
																																						BgL_test7518z00_13555
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 207 */
																																						if (SYMBOLP(BgL_valuez00_8493))
																																							{	/* Ast/sexp.scm 208 */
																																								BgL_test7518z00_13555
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 208 */
																																								BgL_test7518z00_13555
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_8493);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_test7518z00_13555)
																															{	/* Ast/sexp.scm 210 */
																																BgL_kwotez00_bglt
																																	BgL_new1125z00_8516;
																																{	/* Ast/sexp.scm 211 */
																																	BgL_kwotez00_bglt
																																		BgL_new1124z00_8518;
																																	BgL_new1124z00_8518
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 211 */
																																		long
																																			BgL_arg6718z00_8519;
																																		BgL_arg6718z00_8519
																																			=
																																			BGL_CLASS_INDEX
																																			(BGl_kwotez00zzast_nodez00);
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1124z00_8518), BgL_arg6718z00_8519);
																																	}
																																	{	/* Ast/sexp.scm 211 */
																																		BgL_objectz00_bglt
																																			BgL_tmpz00_13571;
																																		BgL_tmpz00_13571
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1124z00_8518);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_tmpz00_13571,
																																			BFALSE);
																																	}
																																	((BgL_objectz00_bglt) BgL_new1124z00_8518);
																																	BgL_new1125z00_8516
																																		=
																																		BgL_new1124z00_8518;
																																}
																																((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1125z00_8516)))->BgL_locz00) = ((obj_t) BgL_locz00_8504), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_13577;
																																	{	/* Ast/sexp.scm 212 */
																																		BgL_typez00_bglt
																																			BgL_arg6717z00_8517;
																																		BgL_arg6717z00_8517
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_8493);
																																		BgL_auxz00_13577
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg6717z00_8517,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1125z00_8516)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_13577), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) COBJECT(BgL_new1125z00_8516))->BgL_valuez00) = ((obj_t) BgL_valuez00_8493), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1125z00_8516);
																															}
																														else
																															{	/* Ast/sexp.scm 214 */
																																bool_t
																																	BgL_test7524z00_13585;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_8493))
																																	{	/* Ast/sexp.scm 214 */
																																		BgL_test7524z00_13585
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 214 */
																																		if (STRINGP
																																			(BgL_valuez00_8493))
																																			{	/* Ast/sexp.scm 215 */
																																				BgL_test7524z00_13585
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 215 */
																																				if (CNSTP(BgL_valuez00_8493))
																																					{	/* Ast/sexp.scm 216 */
																																						BgL_test7524z00_13585
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 216 */
																																						if (CHARP(BgL_valuez00_8493))
																																							{	/* Ast/sexp.scm 220 */
																																								BgL_test7524z00_13585
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 220 */
																																								BgL_test7524z00_13585
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_8493);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_test7524z00_13585)
																																	{
																																		obj_t
																																			BgL_locz00_13596;
																																		obj_t
																																			BgL_expz00_13595;
																																		BgL_expz00_13595
																																			=
																																			BgL_valuez00_8493;
																																		BgL_locz00_13596
																																			=
																																			BgL_locz00_8504;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_13596;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_13595;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 224 */
																																		BgL_nodez00_bglt
																																			BgL_res7364z00_9732;
																																		{	/* Ast/sexp.scm 726 */
																																			obj_t
																																				BgL_arg7138z00_9728;
																																			BgL_nodez00_bglt
																																				BgL_arg7139z00_9729;
																																			BgL_arg7138z00_9728
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg7139z00_9729
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_8504,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 725 */
																																				obj_t
																																					BgL_list7140z00_9731;
																																				BgL_list7140z00_9731
																																					=
																																					MAKE_YOUNG_PAIR
																																					(((obj_t) BgL_arg7139z00_9729), BNIL);
																																				BgL_res7364z00_9732
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_8504,
																																						BgL_arg7138z00_9728,
																																						BGl_string7408z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list7140z00_9731));
																																		}}
																																		return
																																			BgL_res7364z00_9732;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																										BgL_tagzd262179zd2_8495:
																											{	/* Ast/sexp.scm 226 */
																												BgL_nodez00_bglt
																													BgL_res7365z00_9738;
																												{	/* Ast/sexp.scm 726 */
																													obj_t
																														BgL_arg7138z00_9734;
																													BgL_nodez00_bglt
																														BgL_arg7139z00_9735;
																													BgL_arg7138z00_9734 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg7139z00_9735 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 725 */
																														obj_t
																															BgL_list7140z00_9737;
																														BgL_list7140z00_9737
																															=
																															MAKE_YOUNG_PAIR((
																																(obj_t)
																																BgL_arg7139z00_9735),
																															BNIL);
																														BgL_res7365z00_9738
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg7138z00_9734,
																																BGl_string7408z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list7140z00_9737));
																												}}
																												return
																													BgL_res7365z00_9738;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									goto BgL_tagzd262179zd2_8495;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							goto BgL_tagzd262179zd2_8495;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 15))))
																					{	/* Ast/sexp.scm 119 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 119 */
																							BgL_tagzd2374zd2_1765:
																								{
																									obj_t BgL_locz00_13624;
																									obj_t BgL_expz00_13623;

																									BgL_expz00_13623 = BUNSPEC;
																									BgL_locz00_13624 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_13624;
																									BgL_expz00_21 =
																										BgL_expz00_13623;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 119 */
																								obj_t BgL_arg1584z00_1853;

																								BgL_arg1584z00_1853 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_13627;
																									BgL_bodyz00_1766 =
																										BgL_arg1584z00_1853;
																								BgL_tagzd2375zd2_1767:
																									{	/* Ast/sexp.scm 231 */
																										obj_t BgL_locz00_8535;

																										BgL_locz00_8535 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 231 */
																											obj_t BgL_nodesz00_8536;

																											BgL_nodesz00_8536 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1766,
																												BgL_stackz00_22,
																												BgL_locz00_8535,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 232 */

																												{	/* Ast/sexp.scm 233 */
																													BgL_sequencez00_bglt
																														BgL_new1129z00_8537;
																													{	/* Ast/sexp.scm 234 */
																														BgL_sequencez00_bglt
																															BgL_new1128z00_8538;
																														BgL_new1128z00_8538
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BOBJECT(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 234 */
																															long
																																BgL_arg6725z00_8539;
																															BgL_arg6725z00_8539
																																=
																																BGL_CLASS_INDEX
																																(BGl_sequencez00zzast_nodez00);
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1128z00_8538), BgL_arg6725z00_8539);
																														}
																														{	/* Ast/sexp.scm 234 */
																															BgL_objectz00_bglt
																																BgL_tmpz00_13634;
																															BgL_tmpz00_13634 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1128z00_8538);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_tmpz00_13634,
																																BFALSE);
																														}
																														((BgL_objectz00_bglt) BgL_new1128z00_8538);
																														BgL_new1129z00_8537
																															=
																															BgL_new1128z00_8538;
																													}
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1129z00_8537)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_8535),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1129z00_8537)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8537)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8537)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1129z00_8537))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_8536), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1129z00_8537))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1129z00_8537))->BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																													BgL_auxz00_13627 =
																														BgL_new1129z00_8537;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_13627);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_carzd2610zd2_1855;
																						obj_t BgL_cdrzd2611zd2_1856;

																						BgL_carzd2610zd2_1855 =
																							CAR(BgL_expz00_21);
																						BgL_cdrzd2611zd2_1856 =
																							CDR(BgL_expz00_21);
																						{

																							if (
																								(BgL_carzd2610zd2_1855 ==
																									CNST_TABLE_REF(((long) 1))))
																								{
																									obj_t BgL_auxz00_13657;

																								BgL_kapzd2612zd2_1857:
																									if (PAIRP
																										(BgL_cdrzd2611zd2_1856))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd2615zd2_2604;
																											BgL_cdrzd2615zd2_2604 =
																												CDR
																												(BgL_cdrzd2611zd2_1856);
																											if (PAIRP
																												(BgL_cdrzd2615zd2_2604))
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd2618zd2_2606;
																													BgL_cdrzd2618zd2_2606
																														=
																														CDR
																														(BgL_cdrzd2615zd2_2604);
																													if ((CAR
																															(BgL_cdrzd2615zd2_2604)
																															== BTRUE))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd2618zd2_2606))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_cdrzd2618zd2_2606)
																																			==
																																			BFALSE))
																																		{	/* Ast/sexp.scm 119 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd2618zd2_2606)))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_sitez00_24
																																							==
																																							CNST_TABLE_REF
																																							(((long) 8))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2263z00_2616;
																																							BgL_arg2263z00_2616
																																								=
																																								CAR
																																								(BgL_cdrzd2611zd2_1856);
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg2263z00_2616,
																																									BgL_stackz00_22,
																																									BgL_locz00_23,
																																									BgL_sitez00_24));
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd2637zd2_2617;
																																							BgL_carzd2637zd2_2617
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd2637zd2_2617 == CNST_TABLE_REF(((long) 1))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_13686;
																																								BgL_tagzd2377zd2_1770:
																																									{
																																										obj_t
																																											BgL_siz00_8540;
																																										obj_t
																																											BgL_alorsz00_8541;
																																										obj_t
																																											BgL_sinonz00_8542;
																																										obj_t
																																											BgL_siz00_8544;
																																										obj_t
																																											BgL_alorsz00_8545;
																																										if (PAIRP(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd262200zd2_8550;
																																												BgL_cdrzd262200zd2_8550
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												if (PAIRP(BgL_cdrzd262200zd2_8550))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd262205zd2_8552;
																																														BgL_cdrzd262205zd2_8552
																																															=
																																															CDR
																																															(BgL_cdrzd262200zd2_8550);
																																														if (PAIRP(BgL_cdrzd262205zd2_8552))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262210zd2_8554;
																																																BgL_cdrzd262210zd2_8554
																																																	=
																																																	CDR
																																																	(BgL_cdrzd262205zd2_8552);
																																																if (PAIRP(BgL_cdrzd262210zd2_8554))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd262210zd2_8554)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				BgL_siz00_8540
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262200zd2_8550);
																																																				BgL_alorsz00_8541
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262205zd2_8552);
																																																				BgL_sinonz00_8542
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262210zd2_8554);
																																																				{	/* Ast/sexp.scm 244 */
																																																					obj_t
																																																						BgL_ntz00_8569;
																																																					BgL_ntz00_8569
																																																						=
																																																						BGl_notzd2testzd2zzast_sexpz00
																																																						(BgL_siz00_8540);
																																																					if (CBOOL(BgL_ntz00_8569))
																																																						{	/* Ast/sexp.scm 245 */
																																																							{	/* Ast/sexp.scm 247 */
																																																								obj_t
																																																									BgL_arg6741z00_8570;
																																																								BgL_arg6741z00_8570
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 247 */
																																																									obj_t
																																																										BgL_tmpz00_13706;
																																																									BgL_tmpz00_13706
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6741z00_8570);
																																																									SET_CAR
																																																										(BgL_tmpz00_13706,
																																																										BgL_ntz00_8569);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 248 */
																																																								obj_t
																																																									BgL_arg6742z00_8571;
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_pairz00_9751;
																																																									BgL_pairz00_9751
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_arg6742z00_8571
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9751);
																																																								}
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_tmpz00_13712;
																																																									BgL_tmpz00_13712
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6742z00_8571);
																																																									SET_CAR
																																																										(BgL_tmpz00_13712,
																																																										BgL_sinonz00_8542);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 249 */
																																																								obj_t
																																																									BgL_arg6743z00_8572;
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_pairz00_9758;
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_pairz00_9757;
																																																										BgL_pairz00_9757
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_pairz00_9758
																																																											=
																																																											CDR
																																																											(BgL_pairz00_9757);
																																																									}
																																																									BgL_arg6743z00_8572
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9758);
																																																								}
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_tmpz00_13719;
																																																									BgL_tmpz00_13719
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6743z00_8572);
																																																									SET_CAR
																																																										(BgL_tmpz00_13719,
																																																										BgL_alorsz00_8541);
																																																								}
																																																							}
																																																							BgL_auxz00_13686
																																																								=
																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																								(BgL_expz00_21,
																																																								BgL_stackz00_22,
																																																								BgL_locz00_23,
																																																								BgL_sitez00_24);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 251 */
																																																							obj_t
																																																								BgL_locz00_8573;
																																																							BgL_locz00_8573
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 251 */
																																																								obj_t
																																																									BgL_cdlocz00_8574;
																																																								{	/* Ast/sexp.scm 252 */
																																																									obj_t
																																																										BgL_arg6763z00_8608;
																																																									BgL_arg6763z00_8608
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8574
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6763z00_8608,
																																																										BgL_locz00_8573);
																																																								}
																																																								{	/* Ast/sexp.scm 252 */
																																																									obj_t
																																																										BgL_cddlocz00_8575;
																																																									{	/* Ast/sexp.scm 253 */
																																																										obj_t
																																																											BgL_arg6762z00_8607;
																																																										{	/* Ast/sexp.scm 253 */
																																																											obj_t
																																																												BgL_pairz00_9764;
																																																											BgL_pairz00_9764
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6762z00_8607
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9764);
																																																										}
																																																										BgL_cddlocz00_8575
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6762z00_8607,
																																																											BgL_locz00_8573);
																																																									}
																																																									{	/* Ast/sexp.scm 253 */
																																																										obj_t
																																																											BgL_cdddlocz00_8576;
																																																										{	/* Ast/sexp.scm 254 */
																																																											obj_t
																																																												BgL_arg6761z00_8606;
																																																											{	/* Ast/sexp.scm 254 */
																																																												obj_t
																																																													BgL_pairz00_9770;
																																																												{	/* Ast/sexp.scm 254 */
																																																													obj_t
																																																														BgL_pairz00_9769;
																																																													BgL_pairz00_9769
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_pairz00_9770
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9769);
																																																												}
																																																												BgL_arg6761z00_8606
																																																													=
																																																													CDR
																																																													(BgL_pairz00_9770);
																																																											}
																																																											BgL_cdddlocz00_8576
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6761z00_8606,
																																																												BgL_locz00_8573);
																																																										}
																																																										{	/* Ast/sexp.scm 254 */
																																																											obj_t
																																																												BgL_lzd2sizd2_8577;
																																																											BgL_lzd2sizd2_8577
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_8540,
																																																												BgL_cdlocz00_8574);
																																																											{	/* Ast/sexp.scm 255 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_8578;
																																																												BgL_lzd2alorszd2_8578
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_8541,
																																																													BgL_cddlocz00_8575);
																																																												{	/* Ast/sexp.scm 256 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_8579;
																																																													BgL_lzd2sinonzd2_8579
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_8542,
																																																														BgL_cdddlocz00_8576);
																																																													{	/* Ast/sexp.scm 257 */
																																																														BgL_nodez00_bglt
																																																															BgL_testz00_8580;
																																																														BgL_testz00_8580
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_8540,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_8573,
																																																															CNST_TABLE_REF
																																																															(((long) 8)));
																																																														{	/* Ast/sexp.scm 258 */

																																																															if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_testz00_8580), BGl_atomz00zzast_nodez00))
																																																																{	/* Ast/sexp.scm 260 */
																																																																	if (CBOOL((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_testz00_8580)))->BgL_valuez00)))
																																																																		{	/* Ast/sexp.scm 262 */
																																																																			BgL_auxz00_13686
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(BgL_alorsz00_8541,
																																																																				BgL_stackz00_22,
																																																																				BgL_lzd2alorszd2_8578,
																																																																				CNST_TABLE_REF
																																																																				(((long) 2)));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 262 */
																																																																			BgL_auxz00_13686
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(BgL_sinonz00_8542,
																																																																				BgL_stackz00_22,
																																																																				BgL_lzd2sinonzd2_8579,
																																																																				CNST_TABLE_REF
																																																																				(((long) 2)));
																																																																}}
																																																															else
																																																																{	/* Ast/sexp.scm 260 */
																																																																	if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_testz00_8580), BGl_kwotez00zzast_nodez00))
																																																																		{	/* Ast/sexp.scm 265 */
																																																																			BgL_auxz00_13686
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(BgL_alorsz00_8541,
																																																																				BgL_stackz00_22,
																																																																				BgL_lzd2alorszd2_8578,
																																																																				CNST_TABLE_REF
																																																																				(((long) 2)));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 265 */
																																																																			if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_testz00_8580), BGl_varz00zzast_nodez00))
																																																																				{	/* Ast/sexp.scm 268 */
																																																																					BgL_nodez00_bglt
																																																																						BgL_alorsz00_8586;
																																																																					BgL_nodez00_bglt
																																																																						BgL_sinonz00_8587;
																																																																					BgL_alorsz00_8586
																																																																						=
																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																						(BgL_alorsz00_8541,
																																																																						BgL_stackz00_22,
																																																																						BgL_lzd2alorszd2_8578,
																																																																						CNST_TABLE_REF
																																																																						(((long) 2)));
																																																																					BgL_sinonz00_8587
																																																																						=
																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																						(BgL_sinonz00_8542,
																																																																						BgL_stackz00_22,
																																																																						BgL_lzd2sinonzd2_8579,
																																																																						CNST_TABLE_REF
																																																																						(((long) 2)));
																																																																					{	/* Ast/sexp.scm 270 */
																																																																						BgL_conditionalz00_bglt
																																																																							BgL_new1133z00_8588;
																																																																						{	/* Ast/sexp.scm 271 */
																																																																							BgL_conditionalz00_bglt
																																																																								BgL_new1131z00_8589;
																																																																							BgL_new1131z00_8589
																																																																								=
																																																																								(
																																																																								(BgL_conditionalz00_bglt)
																																																																								BOBJECT
																																																																								(GC_MALLOC
																																																																									(sizeof
																																																																										(struct
																																																																											BgL_conditionalz00_bgl))));
																																																																							{	/* Ast/sexp.scm 271 */
																																																																								long
																																																																									BgL_arg6748z00_8590;
																																																																								BgL_arg6748z00_8590
																																																																									=
																																																																									BGL_CLASS_INDEX
																																																																									(BGl_conditionalz00zzast_nodez00);
																																																																								BGL_OBJECT_CLASS_NUM_SET
																																																																									(
																																																																									((BgL_objectz00_bglt) BgL_new1131z00_8589), BgL_arg6748z00_8590);
																																																																							}
																																																																							{	/* Ast/sexp.scm 271 */
																																																																								BgL_objectz00_bglt
																																																																									BgL_tmpz00_13768;
																																																																								BgL_tmpz00_13768
																																																																									=
																																																																									(
																																																																									(BgL_objectz00_bglt)
																																																																									BgL_new1131z00_8589);
																																																																								BGL_OBJECT_WIDENING_SET
																																																																									(BgL_tmpz00_13768,
																																																																									BFALSE);
																																																																							}
																																																																							((BgL_objectz00_bglt) BgL_new1131z00_8589);
																																																																							BgL_new1133z00_8588
																																																																								=
																																																																								BgL_new1131z00_8589;
																																																																						}
																																																																						((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8588)))->BgL_locz00) = ((obj_t) BgL_locz00_8573), BUNSPEC);
																																																																						((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1133z00_8588)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1133z00_8588)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1133z00_8588)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																						((((BgL_conditionalz00_bglt) COBJECT(BgL_new1133z00_8588))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8580), BUNSPEC);
																																																																						((((BgL_conditionalz00_bglt) COBJECT(BgL_new1133z00_8588))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_8586), BUNSPEC);
																																																																						((((BgL_conditionalz00_bglt) COBJECT(BgL_new1133z00_8588))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_8587), BUNSPEC);
																																																																						BgL_auxz00_13686
																																																																							=
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_new1133z00_8588);
																																																																				}}
																																																																			else
																																																																				{	/* Ast/sexp.scm 277 */
																																																																					obj_t
																																																																						BgL_vz00_8591;
																																																																					BgL_vz00_8591
																																																																						=
																																																																						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																																						(BGl_gensymz00zz__r4_symbols_6_4z00
																																																																						(CNST_TABLE_REF
																																																																							(((long) 8))));
																																																																					{	/* Ast/sexp.scm 277 */
																																																																						obj_t
																																																																							BgL_varz00_8592;
																																																																						BgL_varz00_8592
																																																																							=
																																																																							BGl_makezd2typedzd2identz00zzast_identz00
																																																																							(BgL_vz00_8591,
																																																																							CNST_TABLE_REF
																																																																							(((long) 9)));
																																																																						{	/* Ast/sexp.scm 278 */
																																																																							obj_t
																																																																								BgL_nexpz00_8593;
																																																																							{	/* Ast/sexp.scm 279 */
																																																																								obj_t
																																																																									BgL_arg6756z00_8601;
																																																																								{	/* Ast/sexp.scm 279 */
																																																																									obj_t
																																																																										BgL_arg6757z00_8602;
																																																																									{	/* Ast/sexp.scm 279 */
																																																																										obj_t
																																																																											BgL_arg6758z00_8603;
																																																																										{	/* Ast/sexp.scm 279 */
																																																																											obj_t
																																																																												BgL_arg6759z00_8604;
																																																																											BgL_arg6759z00_8604
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_sinonz00_8542,
																																																																												BNIL);
																																																																											BgL_arg6758z00_8603
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_alorsz00_8541,
																																																																												BgL_arg6759z00_8604);
																																																																										}
																																																																										BgL_arg6757z00_8602
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(BgL_vz00_8591,
																																																																											BgL_arg6758z00_8603);
																																																																									}
																																																																									BgL_arg6756z00_8601
																																																																										=
																																																																										MAKE_YOUNG_PAIR
																																																																										(CNST_TABLE_REF
																																																																										(((long) 1)), BgL_arg6757z00_8602);
																																																																								}
																																																																								BgL_nexpz00_8593
																																																																									=
																																																																									BGl_epairifyzd2reczd2zztools_miscz00
																																																																									(BgL_arg6756z00_8601,
																																																																									BgL_expz00_21);
																																																																							}
																																																																							{	/* Ast/sexp.scm 279 */

																																																																								{	/* Ast/sexp.scm 280 */
																																																																									obj_t
																																																																										BgL_arg6749z00_8594;
																																																																									{	/* Ast/sexp.scm 280 */
																																																																										obj_t
																																																																											BgL_arg6750z00_8595;
																																																																										obj_t
																																																																											BgL_arg6751z00_8596;
																																																																										BgL_arg6750z00_8595
																																																																											=
																																																																											BGl_letzd2symzd2zzast_letz00
																																																																											();
																																																																										{	/* Ast/sexp.scm 280 */
																																																																											obj_t
																																																																												BgL_arg6752z00_8597;
																																																																											obj_t
																																																																												BgL_arg6753z00_8598;
																																																																											{	/* Ast/sexp.scm 280 */
																																																																												obj_t
																																																																													BgL_arg6754z00_8599;
																																																																												{	/* Ast/sexp.scm 280 */
																																																																													obj_t
																																																																														BgL_arg6755z00_8600;
																																																																													BgL_arg6755z00_8600
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_siz00_8540,
																																																																														BNIL);
																																																																													BgL_arg6754z00_8599
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_varz00_8592,
																																																																														BgL_arg6755z00_8600);
																																																																												}
																																																																												BgL_arg6752z00_8597
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_arg6754z00_8599,
																																																																													BNIL);
																																																																											}
																																																																											BgL_arg6753z00_8598
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_nexpz00_8593,
																																																																												BNIL);
																																																																											BgL_arg6751z00_8596
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_arg6752z00_8597,
																																																																												BgL_arg6753z00_8598);
																																																																										}
																																																																										BgL_arg6749z00_8594
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(BgL_arg6750z00_8595,
																																																																											BgL_arg6751z00_8596);
																																																																									}
																																																																									BGl_replacez12z12zztools_miscz00
																																																																										(BgL_expz00_21,
																																																																										BgL_arg6749z00_8594);
																																																																								}
																																																																								BgL_auxz00_13686
																																																																									=
																																																																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																									BgL_stackz00_22,
																																																																									BgL_locz00_8573,
																																																																									BgL_sitez00_24);
																																																			}}}}}}}}}}}}}}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_tagzd262191zd2_8547:
																																																				{	/* Ast/sexp.scm 286 */
																																																					BgL_nodez00_bglt
																																																						BgL_res7367z00_9786;
																																																					{	/* Ast/sexp.scm 726 */
																																																						obj_t
																																																							BgL_arg7138z00_9782;
																																																						BgL_nodez00_bglt
																																																							BgL_arg7139z00_9783;
																																																						BgL_arg7138z00_9782
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg7139z00_9783
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 725 */
																																																							obj_t
																																																								BgL_list7140z00_9785;
																																																							BgL_list7140z00_9785
																																																								=
																																																								MAKE_YOUNG_PAIR
																																																								(
																																																								((obj_t) BgL_arg7139z00_9783), BNIL);
																																																							BgL_res7367z00_9786
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_locz00_23,
																																																									BgL_arg7138z00_9782,
																																																									BGl_string7407z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list7140z00_9785));
																																																					}}
																																																					BgL_auxz00_13686
																																																						=
																																																						BgL_res7367z00_9786;
																																																	}}}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262235zd2_8563;
																																																		BgL_cdrzd262235zd2_8563
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd262200zd2_8550));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd262235zd2_8563))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6738z00_8566;
																																																				obj_t
																																																					BgL_arg6739z00_8567;
																																																				BgL_arg6738z00_8566
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262200zd2_8550));
																																																				BgL_arg6739z00_8567
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262235zd2_8563));
																																																				BgL_siz00_8544
																																																					=
																																																					BgL_arg6738z00_8566;
																																																				BgL_alorsz00_8545
																																																					=
																																																					BgL_arg6739z00_8567;
																																																				{	/* Ast/sexp.scm 283 */
																																																					obj_t
																																																						BgL_arg6764z00_8609;
																																																					obj_t
																																																						BgL_arg6765z00_8610;
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_pairz00_9778;
																																																						BgL_pairz00_9778
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_arg6764z00_8609
																																																							=
																																																							CDR
																																																							(BgL_pairz00_9778);
																																																					}
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_list6766z00_8611;
																																																						BgL_list6766z00_8611
																																																							=
																																																							MAKE_YOUNG_PAIR
																																																							(BUNSPEC,
																																																							BNIL);
																																																						BgL_arg6765z00_8610
																																																							=
																																																							BgL_list6766z00_8611;
																																																					}
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_tmpz00_13832;
																																																						BgL_tmpz00_13832
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_arg6764z00_8609);
																																																						SET_CDR
																																																							(BgL_tmpz00_13832,
																																																							BgL_arg6765z00_8610);
																																																					}
																																																				}
																																																				BgL_auxz00_13686
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_stackz00_22,
																																																					BgL_locz00_23,
																																																					BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262191zd2_8547;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262191zd2_8547;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd262191zd2_8547;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd262191zd2_8547;
																																											}
																																									}
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_13686);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd2637zd2_2617 == BGl_za2ifza2z00zzast_sexpz00))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_13839;
																																											goto
																																												BgL_tagzd2377zd2_1770;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_13839);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_13846;
																																												BgL_tagzd2379zd2_1774:
																																													{
																																														obj_t
																																															BgL_varz00_8638;
																																														obj_t
																																															BgL_valz00_8639;
																																														if (PAIRP(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262265zd2_8644;
																																																BgL_cdrzd262265zd2_8644
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if (PAIRP(BgL_cdrzd262265zd2_8644))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262269zd2_8646;
																																																		BgL_cdrzd262269zd2_8646
																																																			=
																																																			CDR
																																																			(BgL_cdrzd262265zd2_8644);
																																																		if (PAIRP(BgL_cdrzd262269zd2_8646))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd262269zd2_8646)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						BgL_varz00_8638
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262265zd2_8644);
																																																						BgL_valz00_8639
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262269zd2_8646);
																																																						{	/* Ast/sexp.scm 295 */
																																																							obj_t
																																																								BgL_locz00_8653;
																																																							BgL_locz00_8653
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 295 */
																																																								obj_t
																																																									BgL_cdlocz00_8654;
																																																								{	/* Ast/sexp.scm 296 */
																																																									obj_t
																																																										BgL_arg6803z00_8681;
																																																									BgL_arg6803z00_8681
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8654
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6803z00_8681,
																																																										BgL_locz00_8653);
																																																								}
																																																								{	/* Ast/sexp.scm 296 */
																																																									obj_t
																																																										BgL_cddlocz00_8655;
																																																									{	/* Ast/sexp.scm 297 */
																																																										obj_t
																																																											BgL_arg6802z00_8680;
																																																										{	/* Ast/sexp.scm 297 */
																																																											obj_t
																																																												BgL_pairz00_9812;
																																																											BgL_pairz00_9812
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6802z00_8680
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9812);
																																																										}
																																																										BgL_cddlocz00_8655
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6802z00_8680,
																																																											BgL_locz00_8653);
																																																									}
																																																									{	/* Ast/sexp.scm 297 */
																																																										obj_t
																																																											BgL_valzd2loczd2_8656;
																																																										BgL_valzd2loczd2_8656
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_valz00_8639,
																																																											BgL_cddlocz00_8655);
																																																										{	/* Ast/sexp.scm 298 */
																																																											BgL_nodez00_bglt
																																																												BgL_valz00_8657;
																																																											{

																																																												if (PAIRP(BgL_valz00_8639))
																																																													{	/* Ast/sexp.scm 299 */
																																																														if ((CAR(BgL_valz00_8639) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 299 */
																																																																{	/* Ast/sexp.scm 302 */
																																																																	obj_t
																																																																		BgL_arg6801z00_8679;
																																																																	{	/* Ast/sexp.scm 302 */
																																																																		obj_t
																																																																			BgL_arg1447z00_9814;
																																																																		BgL_arg1447z00_9814
																																																																			=
																																																																			SYMBOL_TO_STRING
																																																																			(
																																																																			((obj_t) BgL_varz00_8638));
																																																																		BgL_arg6801z00_8679
																																																																			=
																																																																			BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																																			(BgL_arg1447z00_9814);
																																																																	}
																																																																	BgL_valz00_8657
																																																																		=
																																																																		BGl_lambdazd2ze3nodez31zzast_sexpz00
																																																																		(BgL_valz00_8639,
																																																																		BgL_stackz00_22,
																																																																		BgL_valzd2loczd2_8656,
																																																																		CNST_TABLE_REF
																																																																		(((long) 2)), BgL_arg6801z00_8679);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 299 */
																																																															BgL_tagzd262276zd2_8673:
																																																																BgL_valz00_8657 = BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_8639, BgL_stackz00_22, BgL_valzd2loczd2_8656, CNST_TABLE_REF(((long) 2)));
																																																													}}
																																																												else
																																																													{	/* Ast/sexp.scm 299 */
																																																														goto
																																																															BgL_tagzd262276zd2_8673;
																																																													}
																																																											}
																																																											{	/* Ast/sexp.scm 299 */

																																																												{	/* Ast/sexp.scm 305 */
																																																													BgL_nodez00_bglt
																																																														BgL_astz00_8658;
																																																													BgL_astz00_8658
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_varz00_8638,
																																																														BgL_stackz00_22,
																																																														BgL_cdlocz00_8654,
																																																														CNST_TABLE_REF
																																																														(((long) 7)));
																																																													if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_astz00_8658), BGl_varz00zzast_nodez00))
																																																														{	/* Ast/sexp.scm 308 */
																																																															bool_t
																																																																BgL_test7560z00_13885;
																																																															{	/* Ast/sexp.scm 308 */
																																																																bool_t
																																																																	BgL_test7561z00_13886;
																																																																{	/* Ast/sexp.scm 308 */
																																																																	BgL_variablez00_bglt
																																																																		BgL_arg6796z00_8671;
																																																																	BgL_arg6796z00_8671
																																																																		=
																																																																		(
																																																																		((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8658)))->BgL_variablez00);
																																																																	BgL_test7561z00_13886
																																																																		=
																																																																		BGl_isazf3zf3zz__objectz00
																																																																		(
																																																																		((obj_t) BgL_arg6796z00_8671), BGl_globalz00zzast_varz00);
																																																																}
																																																																if (BgL_test7561z00_13886)
																																																																	{	/* Ast/sexp.scm 309 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6795z00_8670;
																																																																		BgL_arg6795z00_8670
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8658)))->BgL_variablez00);
																																																																		BgL_test7560z00_13885
																																																																			=
																																																																			BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																																			(
																																																																			((BgL_globalz00_bglt) BgL_arg6795z00_8670));
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 308 */
																																																																		BgL_test7560z00_13885
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																															if (BgL_test7560z00_13885)
																																																																{	/* Ast/sexp.scm 310 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7369z00_9821;
																																																																	{	/* Ast/sexp.scm 726 */
																																																																		obj_t
																																																																			BgL_arg7138z00_9817;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7139z00_9818;
																																																																		BgL_arg7138z00_9817
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7139z00_9818
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_cdlocz00_8654, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 725 */
																																																																			obj_t
																																																																				BgL_list7140z00_9820;
																																																																			BgL_list7140z00_9820
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7139z00_9818), BNIL);
																																																																			BgL_res7369z00_9821
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_cdlocz00_8654,
																																																																					BgL_arg7138z00_9817,
																																																																					BGl_string7404z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7140z00_9820));
																																																																	}}
																																																																	BgL_auxz00_13846
																																																																		=
																																																																		BgL_res7369z00_9821;
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 312 */
																																																																	BgL_setqz00_bglt
																																																																		BgL_new1136z00_8666;
																																																																	{	/* Ast/sexp.scm 313 */
																																																																		BgL_setqz00_bglt
																																																																			BgL_new1135z00_8667;
																																																																		BgL_new1135z00_8667
																																																																			=
																																																																			(
																																																																			(BgL_setqz00_bglt)
																																																																			BOBJECT
																																																																			(GC_MALLOC
																																																																				(sizeof
																																																																					(struct
																																																																						BgL_setqz00_bgl))));
																																																																		{	/* Ast/sexp.scm 313 */
																																																																			long
																																																																				BgL_arg6794z00_8668;
																																																																			BgL_arg6794z00_8668
																																																																				=
																																																																				BGL_CLASS_INDEX
																																																																				(BGl_setqz00zzast_nodez00);
																																																																			BGL_OBJECT_CLASS_NUM_SET
																																																																				(
																																																																				((BgL_objectz00_bglt) BgL_new1135z00_8667), BgL_arg6794z00_8668);
																																																																		}
																																																																		{	/* Ast/sexp.scm 313 */
																																																																			BgL_objectz00_bglt
																																																																				BgL_tmpz00_13908;
																																																																			BgL_tmpz00_13908
																																																																				=
																																																																				(
																																																																				(BgL_objectz00_bglt)
																																																																				BgL_new1135z00_8667);
																																																																			BGL_OBJECT_WIDENING_SET
																																																																				(BgL_tmpz00_13908,
																																																																				BFALSE);
																																																																		}
																																																																		((BgL_objectz00_bglt) BgL_new1135z00_8667);
																																																																		BgL_new1136z00_8666
																																																																			=
																																																																			BgL_new1135z00_8667;
																																																																	}
																																																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1136z00_8666)))->BgL_locz00) = ((obj_t) BgL_locz00_8653), BUNSPEC);
																																																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1136z00_8666)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																	((((BgL_setqz00_bglt) COBJECT(BgL_new1136z00_8666))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8658)), BUNSPEC);
																																																																	((((BgL_setqz00_bglt) COBJECT(BgL_new1136z00_8666))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8657), BUNSPEC);
																																																																	BgL_auxz00_13846
																																																																		=
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_new1136z00_8666);
																																																														}}
																																																													else
																																																														{	/* Ast/sexp.scm 317 */
																																																															BgL_nodez00_bglt
																																																																BgL_res7370z00_9831;
																																																															{	/* Ast/sexp.scm 726 */
																																																																obj_t
																																																																	BgL_arg7138z00_9827;
																																																																BgL_nodez00_bglt
																																																																	BgL_arg7139z00_9828;
																																																																BgL_arg7138z00_9827
																																																																	=
																																																																	BGl_shapez00zztools_shapez00
																																																																	(BGl_currentzd2functionzd2zztools_errorz00
																																																																	());
																																																																BgL_arg7139z00_9828
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(CNST_TABLE_REF
																																																																	(((long) 4)), BNIL, BgL_locz00_8653, CNST_TABLE_REF(((long) 2)));
																																																																{	/* Ast/sexp.scm 725 */
																																																																	obj_t
																																																																		BgL_list7140z00_9830;
																																																																	BgL_list7140z00_9830
																																																																		=
																																																																		MAKE_YOUNG_PAIR
																																																																		(
																																																																		((obj_t) BgL_arg7139z00_9828), BNIL);
																																																																	BgL_res7370z00_9831
																																																																		=
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																		(BgL_locz00_8653,
																																																																			BgL_arg7138z00_9827,
																																																																			BGl_string7405z00zzast_sexpz00,
																																																																			BgL_expz00_21,
																																																																			BgL_list7140z00_9830));
																																																															}}
																																																															BgL_auxz00_13846
																																																																=
																																																																BgL_res7370z00_9831;
																																																					}}}}}}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																					BgL_tagzd262258zd2_8641:
																																																						{	/* Ast/sexp.scm 321 */
																																																							obj_t
																																																								BgL_arg6804z00_8682;
																																																							BgL_arg6804z00_8682
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 320 */
																																																								BgL_nodez00_bglt
																																																									BgL_res7371z00_9837;
																																																								{	/* Ast/sexp.scm 726 */
																																																									obj_t
																																																										BgL_arg7138z00_9833;
																																																									BgL_nodez00_bglt
																																																										BgL_arg7139z00_9834;
																																																									BgL_arg7138z00_9833
																																																										=
																																																										BGl_shapez00zztools_shapez00
																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																										());
																																																									BgL_arg7139z00_9834
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(CNST_TABLE_REF
																																																										(((long) 4)), BNIL, BgL_arg6804z00_8682, CNST_TABLE_REF(((long) 2)));
																																																									{	/* Ast/sexp.scm 725 */
																																																										obj_t
																																																											BgL_list7140z00_9836;
																																																										BgL_list7140z00_9836
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(
																																																											((obj_t) BgL_arg7139z00_9834), BNIL);
																																																										BgL_res7371z00_9837
																																																											=
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																											(BgL_arg6804z00_8682,
																																																												BgL_arg7138z00_9833,
																																																												BGl_string7403z00zzast_sexpz00,
																																																												BgL_expz00_21,
																																																												BgL_list7140z00_9836));
																																																								}}
																																																								BgL_auxz00_13846
																																																									=
																																																									BgL_res7371z00_9837;
																																																			}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262258zd2_8641;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262258zd2_8641;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262258zd2_8641;
																																															}
																																													}
																																													BgL_auxz00_13657
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_13846);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_13948;
																																														BgL_tagzd2380zd2_1775:
																																															{
																																																obj_t
																																																	BgL_varz00_8683;
																																																obj_t
																																																	BgL_valz00_8684;
																																																if (PAIRP(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262288zd2_8689;
																																																		BgL_cdrzd262288zd2_8689
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		if (PAIRP(BgL_cdrzd262288zd2_8689))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd262292zd2_8691;
																																																				BgL_cdrzd262292zd2_8691
																																																					=
																																																					CDR
																																																					(BgL_cdrzd262288zd2_8689);
																																																				if (PAIRP(BgL_cdrzd262292zd2_8691))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd262292zd2_8691)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								BgL_varz00_8683
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262288zd2_8689);
																																																								BgL_valz00_8684
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262292zd2_8691);
																																																								{	/* Ast/sexp.scm 328 */
																																																									obj_t
																																																										BgL_locz00_8698;
																																																									BgL_locz00_8698
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 328 */
																																																										obj_t
																																																											BgL_cdlocz00_8699;
																																																										{	/* Ast/sexp.scm 329 */
																																																											obj_t
																																																												BgL_arg6820z00_8714;
																																																											BgL_arg6820z00_8714
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdlocz00_8699
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6820z00_8714,
																																																												BgL_locz00_8698);
																																																										}
																																																										{	/* Ast/sexp.scm 329 */
																																																											obj_t
																																																												BgL_cddlocz00_8700;
																																																											{	/* Ast/sexp.scm 330 */
																																																												obj_t
																																																													BgL_arg6819z00_8713;
																																																												{	/* Ast/sexp.scm 330 */
																																																													obj_t
																																																														BgL_pairz00_9847;
																																																													BgL_pairz00_9847
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_arg6819z00_8713
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9847);
																																																												}
																																																												BgL_cddlocz00_8700
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_arg6819z00_8713,
																																																													BgL_locz00_8698);
																																																											}
																																																											{	/* Ast/sexp.scm 330 */
																																																												obj_t
																																																													BgL_valzd2loczd2_8701;
																																																												BgL_valzd2loczd2_8701
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_valz00_8684,
																																																													BgL_cddlocz00_8700);
																																																												{	/* Ast/sexp.scm 331 */
																																																													BgL_nodez00_bglt
																																																														BgL_valz00_8702;
																																																													BgL_valz00_8702
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_valz00_8684,
																																																														BgL_stackz00_22,
																																																														BgL_valzd2loczd2_8701,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 332 */

																																																														{	/* Ast/sexp.scm 333 */
																																																															BgL_nodez00_bglt
																																																																BgL_astz00_8703;
																																																															BgL_astz00_8703
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_varz00_8683,
																																																																BgL_stackz00_22,
																																																																BgL_cdlocz00_8699,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 334 */
																																																																bool_t
																																																																	BgL_test7567z00_13973;
																																																																if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_astz00_8703), BGl_varz00zzast_nodez00))
																																																																	{	/* Ast/sexp.scm 334 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6818z00_8712;
																																																																		BgL_arg6818z00_8712
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8703)))->BgL_variablez00);
																																																																		BgL_test7567z00_13973
																																																																			=
																																																																			BGl_isazf3zf3zz__objectz00
																																																																			(
																																																																			((obj_t) BgL_arg6818z00_8712), BGl_globalz00zzast_varz00);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 334 */
																																																																		BgL_test7567z00_13973
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																																if (BgL_test7567z00_13973)
																																																																	{	/* Ast/sexp.scm 334 */
																																																																		{	/* Ast/sexp.scm 336 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6816z00_8707;
																																																																			BgL_arg6816z00_8707
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8703)))->BgL_variablez00);
																																																																			((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_arg6816z00_8707)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_8702)), BUNSPEC);
																																																																		}
																																																																		{	/* Ast/sexp.scm 337 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1138z00_8708;
																																																																			{	/* Ast/sexp.scm 338 */
																																																																				BgL_setqz00_bglt
																																																																					BgL_new1137z00_8709;
																																																																				BgL_new1137z00_8709
																																																																					=
																																																																					(
																																																																					(BgL_setqz00_bglt)
																																																																					BOBJECT
																																																																					(GC_MALLOC
																																																																						(sizeof
																																																																							(struct
																																																																								BgL_setqz00_bgl))));
																																																																				{	/* Ast/sexp.scm 338 */
																																																																					long
																																																																						BgL_arg6817z00_8710;
																																																																					BgL_arg6817z00_8710
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_setqz00zzast_nodez00);
																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																						(
																																																																						((BgL_objectz00_bglt) BgL_new1137z00_8709), BgL_arg6817z00_8710);
																																																																				}
																																																																				{	/* Ast/sexp.scm 338 */
																																																																					BgL_objectz00_bglt
																																																																						BgL_tmpz00_13990;
																																																																					BgL_tmpz00_13990
																																																																						=
																																																																						(
																																																																						(BgL_objectz00_bglt)
																																																																						BgL_new1137z00_8709);
																																																																					BGL_OBJECT_WIDENING_SET
																																																																						(BgL_tmpz00_13990,
																																																																						BFALSE);
																																																																				}
																																																																				((BgL_objectz00_bglt) BgL_new1137z00_8709);
																																																																				BgL_new1138z00_8708
																																																																					=
																																																																					BgL_new1137z00_8709;
																																																																			}
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8708)))->BgL_locz00) = ((obj_t) BgL_locz00_8698), BUNSPEC);
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8708)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1138z00_8708))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8703)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1138z00_8708))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8702), BUNSPEC);
																																																																			BgL_auxz00_13948
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_new1138z00_8708);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 342 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7372z00_9860;
																																																																		{	/* Ast/sexp.scm 726 */
																																																																			obj_t
																																																																				BgL_arg7138z00_9856;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7139z00_9857;
																																																																			BgL_arg7138z00_9856
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7139z00_9857
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_locz00_8698, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 725 */
																																																																				obj_t
																																																																					BgL_list7140z00_9859;
																																																																				BgL_list7140z00_9859
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7139z00_9857), BNIL);
																																																																				BgL_res7372z00_9860
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_locz00_8698,
																																																																						BgL_arg7138z00_9856,
																																																																						BGl_string7402z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7140z00_9859));
																																																																		}}
																																																																		BgL_auxz00_13948
																																																																			=
																																																																			BgL_res7372z00_9860;
																																																							}}}}}}}}}}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																							BgL_tagzd262281zd2_8686:
																																																								{	/* Ast/sexp.scm 346 */
																																																									obj_t
																																																										BgL_arg6821z00_8715;
																																																									BgL_arg6821z00_8715
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 345 */
																																																										BgL_nodez00_bglt
																																																											BgL_res7373z00_9866;
																																																										{	/* Ast/sexp.scm 726 */
																																																											obj_t
																																																												BgL_arg7138z00_9862;
																																																											BgL_nodez00_bglt
																																																												BgL_arg7139z00_9863;
																																																											BgL_arg7138z00_9862
																																																												=
																																																												BGl_shapez00zztools_shapez00
																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																												());
																																																											BgL_arg7139z00_9863
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(CNST_TABLE_REF
																																																												(((long) 4)), BNIL, BgL_arg6821z00_8715, CNST_TABLE_REF(((long) 2)));
																																																											{	/* Ast/sexp.scm 725 */
																																																												obj_t
																																																													BgL_list7140z00_9865;
																																																												BgL_list7140z00_9865
																																																													=
																																																													MAKE_YOUNG_PAIR
																																																													(
																																																													((obj_t) BgL_arg7139z00_9863), BNIL);
																																																												BgL_res7373z00_9866
																																																													=
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																													(BgL_arg6821z00_8715,
																																																														BgL_arg7138z00_9862,
																																																														BGl_string7401z00zzast_sexpz00,
																																																														BgL_expz00_21,
																																																														BgL_list7140z00_9865));
																																																										}}
																																																										BgL_auxz00_13948
																																																											=
																																																											BgL_res7373z00_9866;
																																																					}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd262281zd2_8686;
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262281zd2_8686;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262281zd2_8686;
																																																	}
																																															}
																																															BgL_auxz00_13657
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_13948);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd2706zd2_2624;
																																															BgL_carzd2706zd2_2624
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if (PAIRP(BgL_carzd2706zd2_2624))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd2709zd2_2626;
																																																	obj_t
																																																		BgL_cdrzd2710zd2_2627;
																																																	BgL_carzd2709zd2_2626
																																																		=
																																																		CAR
																																																		(BgL_carzd2706zd2_2624);
																																																	BgL_cdrzd2710zd2_2627
																																																		=
																																																		CDR
																																																		(BgL_carzd2706zd2_2624);
																																																	{

																																																		if ((BgL_carzd2709zd2_2626 == CNST_TABLE_REF(((long) 17))))
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_kapzd2711zd2_2628:
																																																				if (PAIRP(BgL_cdrzd2710zd2_2627))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd2714zd2_2753;
																																																						BgL_cdrzd2714zd2_2753
																																																							=
																																																							CDR
																																																							(BgL_cdrzd2710zd2_2627);
																																																						if (PAIRP(BgL_cdrzd2714zd2_2753))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (NULLP(CDR(BgL_cdrzd2714zd2_2753)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2357z00_2757;
																																																										obj_t
																																																											BgL_arg2358z00_2758;
																																																										BgL_arg2357z00_2757
																																																											=
																																																											CAR
																																																											(BgL_cdrzd2714zd2_2753);
																																																										BgL_arg2358z00_2758
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_14045;
																																																											BgL_bodyz00_1776
																																																												=
																																																												BgL_arg2357z00_2757;
																																																											BgL_argsz00_1777
																																																												=
																																																												BgL_arg2358z00_2758;
																																																										BgL_tagzd2381zd2_1778:
																																																											{	/* Ast/sexp.scm 349 */
																																																												obj_t
																																																													BgL_letzd2partzd2_8716;
																																																												BgL_letzd2partzd2_8716
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 349 */
																																																													obj_t
																																																														BgL_nexpz00_8717;
																																																													{	/* Ast/sexp.scm 350 */
																																																														obj_t
																																																															BgL_arg6822z00_8718;
																																																														obj_t
																																																															BgL_arg6823z00_8719;
																																																														BgL_arg6822z00_8718
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_letzd2partzd2_8716));
																																																														{	/* Ast/sexp.scm 350 */
																																																															obj_t
																																																																BgL_arg6824z00_8720;
																																																															obj_t
																																																																BgL_arg6825z00_8721;
																																																															{	/* Ast/sexp.scm 350 */
																																																																obj_t
																																																																	BgL_pairz00_9877;
																																																																BgL_pairz00_9877
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_letzd2partzd2_8716));
																																																																BgL_arg6824z00_8720
																																																																	=
																																																																	CAR
																																																																	(BgL_pairz00_9877);
																																																															}
																																																															{	/* Ast/sexp.scm 350 */
																																																																obj_t
																																																																	BgL_arg6826z00_8722;
																																																																BgL_arg6826z00_8722
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_bodyz00_1776,
																																																																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																	(BgL_argsz00_1777,
																																																																		BNIL));
																																																																BgL_arg6825z00_8721
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_arg6826z00_8722,
																																																																	BNIL);
																																																															}
																																																															BgL_arg6823z00_8719
																																																																=
																																																																MAKE_YOUNG_PAIR
																																																																(BgL_arg6824z00_8720,
																																																																BgL_arg6825z00_8721);
																																																														}
																																																														BgL_nexpz00_8717
																																																															=
																																																															MAKE_YOUNG_PAIR
																																																															(BgL_arg6822z00_8718,
																																																															BgL_arg6823z00_8719);
																																																													}
																																																													{	/* Ast/sexp.scm 350 */

																																																														BgL_auxz00_14045
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_nexpz00_8717,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															BgL_sitez00_24);
																																																													}
																																																												}
																																																											}
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14045);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd2738zd2_2759;
																																																										BgL_cdrzd2738zd2_2759
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test7574z00_14062;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2433z00_2870;
																																																												BgL_arg2433z00_2870
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test7574z00_14062
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2433z00_2870));
																																																											}
																																																											if (BgL_test7574z00_14062)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2361z00_2762;
																																																													obj_t
																																																														BgL_arg2362z00_2763;
																																																													BgL_arg2361z00_2762
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2759));
																																																													BgL_arg2362z00_2763
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2759));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_14071;
																																																														BgL_bindingsz00_1779
																																																															=
																																																															BgL_arg2361z00_2762;
																																																														BgL_exprz00_1780
																																																															=
																																																															BgL_arg2362z00_2763;
																																																													BgL_tagzd2382zd2_1781:
																																																														{	/* Ast/sexp.scm 354 */
																																																															bool_t
																																																																BgL_test7575z00_14072;
																																																															if (PAIRP(BgL_bindingsz00_1779))
																																																																{	/* Ast/sexp.scm 354 */
																																																																	if (NULLP(CDR(BgL_bindingsz00_1779)))
																																																																		{	/* Ast/sexp.scm 354 */
																																																																			if (PAIRP(BgL_exprz00_1780))
																																																																				{	/* Ast/sexp.scm 355 */
																																																																					BgL_test7575z00_14072
																																																																						=
																																																																						NULLP
																																																																						(CDR
																																																																						(BgL_exprz00_1780));
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 355 */
																																																																					BgL_test7575z00_14072
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 354 */
																																																																			BgL_test7575z00_14072
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 354 */
																																																																	BgL_test7575z00_14072
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															if (BgL_test7575z00_14072)
																																																																{
																																																																	obj_t
																																																																		BgL_varz00_8731;
																																																																	obj_t
																																																																		BgL_exprz00_8732;
																																																																	obj_t
																																																																		BgL_idz00_8733;
																																																																	obj_t
																																																																		BgL_thenz00_8734;
																																																																	obj_t
																																																																		BgL_otherwisez00_8735;
																																																																	if (PAIRP(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 356 */
																																																																			obj_t
																																																																				BgL_cdrzd262311zd2_8739;
																																																																			BgL_cdrzd262311zd2_8739
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if (PAIRP(BgL_cdrzd262311zd2_8739))
																																																																				{	/* Ast/sexp.scm 356 */
																																																																					obj_t
																																																																						BgL_carzd262317zd2_8741;
																																																																					obj_t
																																																																						BgL_cdrzd262318zd2_8742;
																																																																					BgL_carzd262317zd2_8741
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd262311zd2_8739);
																																																																					BgL_cdrzd262318zd2_8742
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262311zd2_8739);
																																																																					if (PAIRP(BgL_carzd262317zd2_8741))
																																																																						{	/* Ast/sexp.scm 356 */
																																																																							obj_t
																																																																								BgL_carzd262321zd2_8744;
																																																																							BgL_carzd262321zd2_8744
																																																																								=
																																																																								CAR
																																																																								(BgL_carzd262317zd2_8741);
																																																																							if (PAIRP(BgL_carzd262321zd2_8744))
																																																																								{	/* Ast/sexp.scm 356 */
																																																																									obj_t
																																																																										BgL_cdrzd262326zd2_8746;
																																																																									BgL_cdrzd262326zd2_8746
																																																																										=
																																																																										CDR
																																																																										(BgL_carzd262321zd2_8744);
																																																																									if (PAIRP(BgL_cdrzd262326zd2_8746))
																																																																										{	/* Ast/sexp.scm 356 */
																																																																											if (NULLP(CDR(BgL_cdrzd262326zd2_8746)))
																																																																												{	/* Ast/sexp.scm 356 */
																																																																													if (NULLP(CDR(BgL_carzd262317zd2_8741)))
																																																																														{	/* Ast/sexp.scm 356 */
																																																																															if (PAIRP(BgL_cdrzd262318zd2_8742))
																																																																																{	/* Ast/sexp.scm 356 */
																																																																																	obj_t
																																																																																		BgL_carzd262335zd2_8753;
																																																																																	BgL_carzd262335zd2_8753
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd262318zd2_8742);
																																																																																	if (PAIRP(BgL_carzd262335zd2_8753))
																																																																																		{	/* Ast/sexp.scm 356 */
																																																																																			obj_t
																																																																																				BgL_cdrzd262341zd2_8755;
																																																																																			BgL_cdrzd262341zd2_8755
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_carzd262335zd2_8753);
																																																																																			if ((CAR(BgL_carzd262335zd2_8753) == CNST_TABLE_REF(((long) 1))))
																																																																																				{	/* Ast/sexp.scm 356 */
																																																																																					if (PAIRP(BgL_cdrzd262341zd2_8755))
																																																																																						{	/* Ast/sexp.scm 356 */
																																																																																							obj_t
																																																																																								BgL_carzd262345zd2_8759;
																																																																																							obj_t
																																																																																								BgL_cdrzd262346zd2_8760;
																																																																																							BgL_carzd262345zd2_8759
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_cdrzd262341zd2_8755);
																																																																																							BgL_cdrzd262346zd2_8760
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_cdrzd262341zd2_8755);
																																																																																							if (SYMBOLP(BgL_carzd262345zd2_8759))
																																																																																								{	/* Ast/sexp.scm 356 */
																																																																																									if (PAIRP(BgL_cdrzd262346zd2_8760))
																																																																																										{	/* Ast/sexp.scm 356 */
																																																																																											obj_t
																																																																																												BgL_cdrzd262353zd2_8763;
																																																																																											BgL_cdrzd262353zd2_8763
																																																																																												=
																																																																																												CDR
																																																																																												(BgL_cdrzd262346zd2_8760);
																																																																																											if (PAIRP(BgL_cdrzd262353zd2_8763))
																																																																																												{	/* Ast/sexp.scm 356 */
																																																																																													if (NULLP(CDR(BgL_cdrzd262353zd2_8763)))
																																																																																														{	/* Ast/sexp.scm 356 */
																																																																																															if (NULLP(CDR(BgL_cdrzd262318zd2_8742)))
																																																																																																{	/* Ast/sexp.scm 356 */
																																																																																																	BgL_varz00_8731
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_carzd262321zd2_8744);
																																																																																																	BgL_exprz00_8732
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262326zd2_8746);
																																																																																																	BgL_idz00_8733
																																																																																																		=
																																																																																																		BgL_carzd262345zd2_8759;
																																																																																																	BgL_thenz00_8734
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262346zd2_8760);
																																																																																																	BgL_otherwisez00_8735
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262353zd2_8763);
																																																																																																	{	/* Ast/sexp.scm 361 */
																																																																																																		obj_t
																																																																																																			BgL_ntz00_8778;
																																																																																																		BgL_ntz00_8778
																																																																																																			=
																																																																																																			BGl_notzd2testzd2zzast_sexpz00
																																																																																																			(BgL_exprz00_8732);
																																																																																																		{	/* Ast/sexp.scm 362 */
																																																																																																			bool_t
																																																																																																				BgL_test7595z00_14131;
																																																																																																			if (CBOOL(BgL_ntz00_8778))
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8733, BgL_otherwisez00_8735))
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							BgL_test7595z00_14131
																																																																																																								=
																																																																																																								(
																																																																																																								(bool_t)
																																																																																																								0);
																																																																																																						}
																																																																																																					else
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8733, BgL_thenz00_8734))
																																																																																																								{	/* Ast/sexp.scm 364 */
																																																																																																									BgL_test7595z00_14131
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										0);
																																																																																																								}
																																																																																																							else
																																																																																																								{	/* Ast/sexp.scm 364 */
																																																																																																									BgL_test7595z00_14131
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										1);
																																																																																																								}
																																																																																																						}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					BgL_test7595z00_14131
																																																																																																						=
																																																																																																						(
																																																																																																						(bool_t)
																																																																																																						0);
																																																																																																				}
																																																																																																			if (BgL_test7595z00_14131)
																																																																																																				{	/* Ast/sexp.scm 365 */
																																																																																																					obj_t
																																																																																																						BgL_bindingz00_8782;
																																																																																																					obj_t
																																																																																																						BgL_bodyz00_8783;
																																																																																																					BgL_bindingz00_8782
																																																																																																						=
																																																																																																						CAR
																																																																																																						(
																																																																																																						((obj_t) BgL_bindingsz00_1779));
																																																																																																					{	/* Ast/sexp.scm 366 */
																																																																																																						obj_t
																																																																																																							BgL_pairz00_9886;
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9885;
																																																																																																							BgL_pairz00_9885
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_expz00_21));
																																																																																																							BgL_pairz00_9886
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9885);
																																																																																																						}
																																																																																																						BgL_bodyz00_8783
																																																																																																							=
																																																																																																							CAR
																																																																																																							(BgL_pairz00_9886);
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 367 */
																																																																																																						obj_t
																																																																																																							BgL_arg6867z00_8784;
																																																																																																						BgL_arg6867z00_8784
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_bindingz00_8782));
																																																																																																						{	/* Ast/sexp.scm 367 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14146;
																																																																																																							BgL_tmpz00_14146
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6867z00_8784);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14146,
																																																																																																								BgL_ntz00_8778);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 368 */
																																																																																																						obj_t
																																																																																																							BgL_arg6868z00_8785;
																																																																																																						{	/* Ast/sexp.scm 368 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9892;
																																																																																																							BgL_pairz00_9892
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_bodyz00_8783));
																																																																																																							BgL_arg6868z00_8785
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9892);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 368 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14152;
																																																																																																							BgL_tmpz00_14152
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6868z00_8785);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14152,
																																																																																																								BgL_otherwisez00_8735);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 369 */
																																																																																																						obj_t
																																																																																																							BgL_arg6869z00_8786;
																																																																																																						{	/* Ast/sexp.scm 369 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9899;
																																																																																																							{	/* Ast/sexp.scm 369 */
																																																																																																								obj_t
																																																																																																									BgL_pairz00_9898;
																																																																																																								BgL_pairz00_9898
																																																																																																									=
																																																																																																									CDR
																																																																																																									(
																																																																																																									((obj_t) BgL_bodyz00_8783));
																																																																																																								BgL_pairz00_9899
																																																																																																									=
																																																																																																									CDR
																																																																																																									(BgL_pairz00_9898);
																																																																																																							}
																																																																																																							BgL_arg6869z00_8786
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9899);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 369 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14159;
																																																																																																							BgL_tmpz00_14159
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6869z00_8786);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14159,
																																																																																																								BgL_thenz00_8734);
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					BFALSE;
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 356 */
																																																																																																	BFALSE;
																																																																																																}
																																																																																														}
																																																																																													else
																																																																																														{	/* Ast/sexp.scm 356 */
																																																																																															BFALSE;
																																																																																														}
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 356 */
																																																																																													BFALSE;
																																																																																												}
																																																																																										}
																																																																																									else
																																																																																										{	/* Ast/sexp.scm 356 */
																																																																																											BFALSE;
																																																																																										}
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 356 */
																																																																																									BFALSE;
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 356 */
																																																																																							BFALSE;
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 356 */
																																																																																					BFALSE;
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 356 */
																																																																																			BFALSE;
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 356 */
																																																																																	BFALSE;
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 356 */
																																																																															BFALSE;
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 356 */
																																																																													BFALSE;
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 356 */
																																																																											BFALSE;
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 356 */
																																																																									BFALSE;
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 356 */
																																																																							BFALSE;
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 356 */
																																																																					BFALSE;
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 356 */
																																																																			BFALSE;
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 354 */
																																																																	BFALSE;
																																																																}
																																																														}
																																																														BgL_auxz00_14071
																																																															=
																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																															(BgL_expz00_21,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_14071);
																																																												}}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test7599z00_14169;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2431z00_2869;
																																																														BgL_arg2431z00_2869
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test7599z00_14169
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2431z00_2869));
																																																													}
																																																													if (BgL_test7599z00_14169)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_14174;
																																																														BgL_tagzd2384zd2_1783:
																																																															BgL_auxz00_14174 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14174);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd2805zd2_2766;
																																																															BgL_carzd2805zd2_2766
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd2810zd2_2767;
																																																																BgL_cdrzd2810zd2_2767
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd2805zd2_2766));
																																																																if ((CAR(((obj_t) BgL_carzd2805zd2_2766)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2367z00_2770;
																																																																		obj_t
																																																																			BgL_arg2368z00_2771;
																																																																		obj_t
																																																																			BgL_arg2369z00_2772;
																																																																		BgL_arg2367z00_2770
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2767));
																																																																		BgL_arg2368z00_2771
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2767));
																																																																		BgL_arg2369z00_2772
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_14193;
																																																																			BgL_varsz00_1788
																																																																				=
																																																																				BgL_arg2367z00_2770;
																																																																			BgL_bodyz00_1789
																																																																				=
																																																																				BgL_arg2368z00_2771;
																																																																			BgL_argsz00_1790
																																																																				=
																																																																				BgL_arg2369z00_2772;
																																																																		BgL_tagzd2386zd2_1791:
																																																																			{	/* Ast/sexp.scm 383 */
																																																																				obj_t
																																																																					BgL_locz00_8798;
																																																																				obj_t
																																																																					BgL_nexpz00_8799;
																																																																				BgL_locz00_8798
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 384 */
																																																																					obj_t
																																																																						BgL_arg6874z00_8800;
																																																																					obj_t
																																																																						BgL_arg6875z00_8801;
																																																																					BgL_arg6874z00_8800
																																																																						=
																																																																						BGl_letzd2symzd2zzast_letz00
																																																																						();
																																																																					{	/* Ast/sexp.scm 387 */
																																																																						obj_t
																																																																							BgL_arg6876z00_8802;
																																																																						obj_t
																																																																							BgL_arg6877z00_8803;
																																																																						BgL_arg6876z00_8802
																																																																							=
																																																																							BGl_loopze70ze7zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23,
																																																																							BgL_varsz00_1788,
																																																																							BgL_argsz00_1790);
																																																																						{	/* Ast/sexp.scm 426 */
																																																																							obj_t
																																																																								BgL_arg6919z00_8853;
																																																																							{	/* Ast/sexp.scm 426 */
																																																																								obj_t
																																																																									BgL_arg6920z00_8854;
																																																																								obj_t
																																																																									BgL_arg6921z00_8855;
																																																																								BgL_arg6920z00_8854
																																																																									=
																																																																									BGl_shapez00zztools_shapez00
																																																																									(BGl_currentzd2functionzd2zztools_errorz00
																																																																									());
																																																																								BgL_arg6921z00_8855
																																																																									=
																																																																									BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																									(BgL_bodyz00_1789);
																																																																								{	/* Ast/sexp.scm 430 */
																																																																									obj_t
																																																																										BgL_zc3z04anonymousza36924ze3z87_13201;
																																																																									BgL_zc3z04anonymousza36924ze3z87_13201
																																																																										=
																																																																										MAKE_FX_PROCEDURE
																																																																										(BGl_z62zc3z04anonymousza36924ze3ze5zzast_sexpz00,
																																																																										(int)
																																																																										(((long) 3)), (int) (((long) 1)));
																																																																									PROCEDURE_SET
																																																																										(BgL_zc3z04anonymousza36924ze3z87_13201,
																																																																										(int)
																																																																										(((long) 0)), BgL_locz00_23);
																																																																									BgL_arg6919z00_8853
																																																																										=
																																																																										BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																																										(BgL_arg6920z00_8854,
																																																																										BgL_varsz00_1788,
																																																																										BgL_arg6921z00_8855,
																																																																										BgL_zc3z04anonymousza36924ze3z87_13201);
																																																																							}}
																																																																							BgL_arg6877z00_8803
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6919z00_8853,
																																																																								BNIL);
																																																																						}
																																																																						BgL_arg6875z00_8801
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(BgL_arg6876z00_8802,
																																																																							BgL_arg6877z00_8803);
																																																																					}
																																																																					BgL_nexpz00_8799
																																																																						=
																																																																						MAKE_YOUNG_PAIR
																																																																						(BgL_arg6874z00_8800,
																																																																						BgL_arg6875z00_8801);
																																																																				}
																																																																				BgL_auxz00_14193
																																																																					=
																																																																					BGl_letzd2ze3nodez31zzast_letz00
																																																																					(BgL_nexpz00_8799,
																																																																					BgL_stackz00_22,
																																																																					BgL_locz00_8798,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_14193);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd2833zd2_2774;
																																																																		BgL_cdrzd2833zd2_2774
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd2839zd2_2775;
																																																																			BgL_cdrzd2839zd2_2775
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd2805zd2_2766));
																																																																			if ((CAR(((obj_t) BgL_carzd2805zd2_2766)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd2845zd2_2778;
																																																																					BgL_cdrzd2845zd2_2778
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd2839zd2_2775));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd2850zd2_2779;
																																																																						obj_t
																																																																							BgL_cdrzd2851zd2_2780;
																																																																						BgL_carzd2850zd2_2779
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2778));
																																																																						BgL_cdrzd2851zd2_2780
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2778));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2850zd2_2779))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd2851zd2_2780))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd2858zd2_2783;
																																																																										BgL_carzd2858zd2_2783
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd2851zd2_2780);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2858zd2_2783))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd2851zd2_2780)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test7606z00_14237;
																																																																														{
																																																																															obj_t
																																																																																BgL_l1368z00_2816;
																																																																															BgL_l1368z00_2816
																																																																																=
																																																																																BgL_cdrzd2833zd2_2774;
																																																																														BgL_zc3z04anonymousza32393ze3z87_2817:
																																																																															if (NULLP(BgL_l1368z00_2816))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test7606z00_14237
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test7608z00_14240;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test7609z00_14241;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_tmpz00_14242;
																																																																																			BgL_tmpz00_14242
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_l1368z00_2816));
																																																																																			BgL_test7609z00_14241
																																																																																				=
																																																																																				PAIRP
																																																																																				(BgL_tmpz00_14242);
																																																																																		}
																																																																																		if (BgL_test7609z00_14241)
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test7608z00_14240
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test7608z00_14240
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test7608z00_14240)
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_l1368z00_14246;
																																																																																			BgL_l1368z00_14246
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_l1368z00_2816));
																																																																																			BgL_l1368z00_2816
																																																																																				=
																																																																																				BgL_l1368z00_14246;
																																																																																			goto
																																																																																				BgL_zc3z04anonymousza32393ze3z87_2817;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test7606z00_14237
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																}
																																																																														}
																																																																														if (BgL_test7606z00_14237)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2382z00_2799;
																																																																																BgL_arg2382z00_2799
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd2839zd2_2775));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14251;
																																																																																	BgL_testz00_1792
																																																																																		=
																																																																																		BgL_arg2382z00_2799;
																																																																																	BgL_proc1z00_1793
																																																																																		=
																																																																																		BgL_carzd2850zd2_2779;
																																																																																	BgL_proc2z00_1794
																																																																																		=
																																																																																		BgL_carzd2858zd2_2783;
																																																																																	BgL_argsz00_1795
																																																																																		=
																																																																																		BgL_cdrzd2833zd2_2774;
																																																																																BgL_tagzd2387zd2_1796:
																																																																																	{	/* Ast/sexp.scm 437 */
																																																																																		obj_t
																																																																																			BgL_nexpz00_8864;
																																																																																		{	/* Ast/sexp.scm 437 */
																																																																																			obj_t
																																																																																				BgL_arg6927z00_8866;
																																																																																			{	/* Ast/sexp.scm 437 */
																																																																																				obj_t
																																																																																					BgL_arg6928z00_8867;
																																																																																				{	/* Ast/sexp.scm 437 */
																																																																																					obj_t
																																																																																						BgL_arg6929z00_8868;
																																																																																					obj_t
																																																																																						BgL_arg6930z00_8869;
																																																																																					BgL_arg6929z00_8868
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_proc1z00_1793,
																																																																																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																						(BgL_argsz00_1795,
																																																																																							BNIL));
																																																																																					{	/* Ast/sexp.scm 437 */
																																																																																						obj_t
																																																																																							BgL_arg6932z00_8871;
																																																																																						BgL_arg6932z00_8871
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_proc2z00_1794,
																																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																							(BgL_argsz00_1795,
																																																																																								BNIL));
																																																																																						BgL_arg6930z00_8869
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_arg6932z00_8871,
																																																																																							BNIL);
																																																																																					}
																																																																																					BgL_arg6928z00_8867
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_arg6929z00_8868,
																																																																																						BgL_arg6930z00_8869);
																																																																																				}
																																																																																				BgL_arg6927z00_8866
																																																																																					=
																																																																																					MAKE_YOUNG_PAIR
																																																																																					(BgL_testz00_1792,
																																																																																					BgL_arg6928z00_8867);
																																																																																			}
																																																																																			BgL_nexpz00_8864
																																																																																				=
																																																																																				MAKE_YOUNG_PAIR
																																																																																				(CNST_TABLE_REF
																																																																																				(((long) 1)), BgL_arg6927z00_8866);
																																																																																		}
																																																																																		BgL_auxz00_14251
																																																																																			=
																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																			(BgL_nexpz00_8864,
																																																																																			BgL_stackz00_22,
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_locz00_23),
																																																																																			BgL_sitez00_24);
																																																																																	}
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14251);
																																																																															}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd2882zd2_2800;
																																																																																BgL_cdrzd2882zd2_2800
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd2889zd2_2801;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10077;
																																																																																		BgL_pairz00_10077
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_expz00_21));
																																																																																		BgL_cdrzd2889zd2_2801
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_pairz00_10077);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd2896zd2_2802;
																																																																																		BgL_cdrzd2896zd2_2802
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd2889zd2_2801));
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd2902zd2_2803;
																																																																																			BgL_carzd2902zd2_2803
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd2896zd2_2802));
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2902zd2_2803))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_carzd2909zd2_2805;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_pairz00_10081;
																																																																																						BgL_pairz00_10081
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd2896zd2_2802));
																																																																																						BgL_carzd2909zd2_2805
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_pairz00_10081);
																																																																																					}
																																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2909zd2_2805))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2882zd2_2800))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_arg2387z00_2808;
																																																																																									BgL_arg2387z00_2808
																																																																																										=
																																																																																										CAR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd2889zd2_2801));
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14284;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_arg2387z00_2808;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_carzd2902zd2_2803;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_carzd2909zd2_2805;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_cdrzd2882zd2_2800;
																																																																																									BgL_tagzd2388zd2_1801:
																																																																																										{	/* Ast/sexp.scm 443 */
																																																																																											obj_t
																																																																																												BgL_tmpsz00_8873;
																																																																																											if (NULLP(BgL_argsz00_1800))
																																																																																												{	/* Ast/sexp.scm 443 */
																																																																																													BgL_tmpsz00_8873
																																																																																														=
																																																																																														BNIL;
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 443 */
																																																																																													obj_t
																																																																																														BgL_head1357z00_8917;
																																																																																													BgL_head1357z00_8917
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BNIL,
																																																																																														BNIL);
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_l1355z00_8919;
																																																																																														obj_t
																																																																																															BgL_tail1358z00_8920;
																																																																																														BgL_l1355z00_8919
																																																																																															=
																																																																																															BgL_argsz00_1800;
																																																																																														BgL_tail1358z00_8920
																																																																																															=
																																																																																															BgL_head1357z00_8917;
																																																																																													BgL_zc3z04anonymousza36963ze3z87_8921:
																																																																																														if (NULLP(BgL_l1355z00_8919))
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																BgL_tmpsz00_8873
																																																																																																	=
																																																																																																	CDR
																																																																																																	(BgL_head1357z00_8917);
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																obj_t
																																																																																																	BgL_newtail1359z00_8923;
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6966z00_8925;
																																																																																																	{	/* Ast/sexp.scm 443 */

																																																																																																		{	/* Ast/sexp.scm 443 */

																																																																																																			BgL_arg6966z00_8925
																																																																																																				=
																																																																																																				BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																																				(BFALSE);
																																																																																																		}
																																																																																																	}
																																																																																																	BgL_newtail1359z00_8923
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(BgL_arg6966z00_8925,
																																																																																																		BNIL);
																																																																																																}
																																																																																																SET_CDR
																																																																																																	(BgL_tail1358z00_8920,
																																																																																																	BgL_newtail1359z00_8923);
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6965z00_8924;
																																																																																																	BgL_arg6965z00_8924
																																																																																																		=
																																																																																																		CDR
																																																																																																		(
																																																																																																		((obj_t) BgL_l1355z00_8919));
																																																																																																	{
																																																																																																		obj_t
																																																																																																			BgL_tail1358z00_14297;
																																																																																																		obj_t
																																																																																																			BgL_l1355z00_14296;
																																																																																																		BgL_l1355z00_14296
																																																																																																			=
																																																																																																			BgL_arg6965z00_8924;
																																																																																																		BgL_tail1358z00_14297
																																																																																																			=
																																																																																																			BgL_newtail1359z00_8923;
																																																																																																		BgL_tail1358z00_8920
																																																																																																			=
																																																																																																			BgL_tail1358z00_14297;
																																																																																																		BgL_l1355z00_8919
																																																																																																			=
																																																																																																			BgL_l1355z00_14296;
																																																																																																		goto
																																																																																																			BgL_zc3z04anonymousza36963ze3z87_8921;
																																																																																																	}
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											{	/* Ast/sexp.scm 443 */
																																																																																												obj_t
																																																																																													BgL_locz00_8874;
																																																																																												BgL_locz00_8874
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_expz00_21,
																																																																																													BgL_locz00_23);
																																																																																												{	/* Ast/sexp.scm 444 */
																																																																																													obj_t
																																																																																														BgL_nexpz00_8875;
																																																																																													{	/* Ast/sexp.scm 445 */
																																																																																														obj_t
																																																																																															BgL_arg6935z00_8877;
																																																																																														obj_t
																																																																																															BgL_arg6936z00_8878;
																																																																																														BgL_arg6935z00_8877
																																																																																															=
																																																																																															BGl_letzd2symzd2zzast_letz00
																																																																																															();
																																																																																														{	/* Ast/sexp.scm 445 */
																																																																																															obj_t
																																																																																																BgL_arg6937z00_8879;
																																																																																															obj_t
																																																																																																BgL_arg6938z00_8880;
																																																																																															if (NULLP(BgL_tmpsz00_8873))
																																																																																																{	/* Ast/sexp.scm 445 */
																																																																																																	BgL_arg6937z00_8879
																																																																																																		=
																																																																																																		BNIL;
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 445 */
																																																																																																	obj_t
																																																																																																		BgL_head1362z00_8884;
																																																																																																	{	/* Ast/sexp.scm 445 */
																																																																																																		obj_t
																																																																																																			BgL_arg6949z00_8902;
																																																																																																		{	/* Ast/sexp.scm 445 */
																																																																																																			obj_t
																																																																																																				BgL_arg6950z00_8903;
																																																																																																			obj_t
																																																																																																				BgL_arg6951z00_8904;
																																																																																																			BgL_arg6950z00_8903
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_tmpsz00_8873));
																																																																																																			BgL_arg6951z00_8904
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_argsz00_1800));
																																																																																																			{	/* Ast/sexp.scm 445 */
																																																																																																				obj_t
																																																																																																					BgL_list6952z00_8905;
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					obj_t
																																																																																																						BgL_arg6953z00_8906;
																																																																																																					BgL_arg6953z00_8906
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6951z00_8904,
																																																																																																						BNIL);
																																																																																																					BgL_list6952z00_8905
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6950z00_8903,
																																																																																																						BgL_arg6953z00_8906);
																																																																																																				}
																																																																																																				BgL_arg6949z00_8902
																																																																																																					=
																																																																																																					BgL_list6952z00_8905;
																																																																																																			}
																																																																																																		}
																																																																																																		BgL_head1362z00_8884
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_arg6949z00_8902,
																																																																																																			BNIL);
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 445 */
																																																																																																		obj_t
																																																																																																			BgL_g1366z00_8885;
																																																																																																		obj_t
																																																																																																			BgL_g1367z00_8886;
																																																																																																		BgL_g1366z00_8885
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_tmpsz00_8873));
																																																																																																		BgL_g1367z00_8886
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_argsz00_1800));
																																																																																																		{
																																																																																																			obj_t
																																																																																																				BgL_ll1360z00_8888;
																																																																																																			obj_t
																																																																																																				BgL_ll1361z00_8889;
																																																																																																			obj_t
																																																																																																				BgL_tail1363z00_8890;
																																																																																																			BgL_ll1360z00_8888
																																																																																																				=
																																																																																																				BgL_g1366z00_8885;
																																																																																																			BgL_ll1361z00_8889
																																																																																																				=
																																																																																																				BgL_g1367z00_8886;
																																																																																																			BgL_tail1363z00_8890
																																																																																																				=
																																																																																																				BgL_head1362z00_8884;
																																																																																																		BgL_zc3z04anonymousza36940ze3z87_8891:
																																																																																																			if (NULLP(BgL_ll1360z00_8888))
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					BgL_arg6937z00_8879
																																																																																																						=
																																																																																																						BgL_head1362z00_8884;
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					obj_t
																																																																																																						BgL_newtail1364z00_8893;
																																																																																																					{	/* Ast/sexp.scm 445 */
																																																																																																						obj_t
																																																																																																							BgL_arg6944z00_8896;
																																																																																																						{	/* Ast/sexp.scm 445 */
																																																																																																							obj_t
																																																																																																								BgL_arg6945z00_8897;
																																																																																																							obj_t
																																																																																																								BgL_arg6946z00_8898;
																																																																																																							BgL_arg6945z00_8897
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1360z00_8888));
																																																																																																							BgL_arg6946z00_8898
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1361z00_8889));
																																																																																																							{	/* Ast/sexp.scm 445 */
																																																																																																								obj_t
																																																																																																									BgL_list6947z00_8899;
																																																																																																								{	/* Ast/sexp.scm 445 */
																																																																																																									obj_t
																																																																																																										BgL_arg6948z00_8900;
																																																																																																									BgL_arg6948z00_8900
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6946z00_8898,
																																																																																																										BNIL);
																																																																																																									BgL_list6947z00_8899
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6945z00_8897,
																																																																																																										BgL_arg6948z00_8900);
																																																																																																								}
																																																																																																								BgL_arg6944z00_8896
																																																																																																									=
																																																																																																									BgL_list6947z00_8899;
																																																																																																							}
																																																																																																						}
																																																																																																						BgL_newtail1364z00_8893
																																																																																																							=
																																																																																																							MAKE_YOUNG_PAIR
																																																																																																							(BgL_arg6944z00_8896,
																																																																																																							BNIL);
																																																																																																					}
																																																																																																					SET_CDR
																																																																																																						(BgL_tail1363z00_8890,
																																																																																																						BgL_newtail1364z00_8893);
																																																																																																					{	/* Ast/sexp.scm 445 */
																																																																																																						obj_t
																																																																																																							BgL_arg6942z00_8894;
																																																																																																						obj_t
																																																																																																							BgL_arg6943z00_8895;
																																																																																																						BgL_arg6942z00_8894
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1360z00_8888));
																																																																																																						BgL_arg6943z00_8895
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1361z00_8889));
																																																																																																						{
																																																																																																							obj_t
																																																																																																								BgL_tail1363z00_14329;
																																																																																																							obj_t
																																																																																																								BgL_ll1361z00_14328;
																																																																																																							obj_t
																																																																																																								BgL_ll1360z00_14327;
																																																																																																							BgL_ll1360z00_14327
																																																																																																								=
																																																																																																								BgL_arg6942z00_8894;
																																																																																																							BgL_ll1361z00_14328
																																																																																																								=
																																																																																																								BgL_arg6943z00_8895;
																																																																																																							BgL_tail1363z00_14329
																																																																																																								=
																																																																																																								BgL_newtail1364z00_8893;
																																																																																																							BgL_tail1363z00_8890
																																																																																																								=
																																																																																																								BgL_tail1363z00_14329;
																																																																																																							BgL_ll1361z00_8889
																																																																																																								=
																																																																																																								BgL_ll1361z00_14328;
																																																																																																							BgL_ll1360z00_8888
																																																																																																								=
																																																																																																								BgL_ll1360z00_14327;
																																																																																																							goto
																																																																																																								BgL_zc3z04anonymousza36940ze3z87_8891;
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															{	/* Ast/sexp.scm 446 */
																																																																																																obj_t
																																																																																																	BgL_arg6954z00_8907;
																																																																																																{	/* Ast/sexp.scm 446 */
																																																																																																	obj_t
																																																																																																		BgL_arg6955z00_8908;
																																																																																																	{	/* Ast/sexp.scm 446 */
																																																																																																		obj_t
																																																																																																			BgL_arg6956z00_8909;
																																																																																																		{	/* Ast/sexp.scm 446 */
																																																																																																			obj_t
																																																																																																				BgL_arg6957z00_8910;
																																																																																																			obj_t
																																																																																																				BgL_arg6958z00_8911;
																																																																																																			BgL_arg6957z00_8910
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_proc1z00_1798,
																																																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																				(BgL_tmpsz00_8873,
																																																																																																					BNIL));
																																																																																																			{	/* Ast/sexp.scm 446 */
																																																																																																				obj_t
																																																																																																					BgL_arg6960z00_8913;
																																																																																																				BgL_arg6960z00_8913
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_proc2z00_1799,
																																																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																					(BgL_tmpsz00_8873,
																																																																																																						BNIL));
																																																																																																				BgL_arg6958z00_8911
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_arg6960z00_8913,
																																																																																																					BNIL);
																																																																																																			}
																																																																																																			BgL_arg6956z00_8909
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6957z00_8910,
																																																																																																				BgL_arg6958z00_8911);
																																																																																																		}
																																																																																																		BgL_arg6955z00_8908
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_testz00_1797,
																																																																																																			BgL_arg6956z00_8909);
																																																																																																	}
																																																																																																	BgL_arg6954z00_8907
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(CNST_TABLE_REF
																																																																																																		(((long) 1)), BgL_arg6955z00_8908);
																																																																																																}
																																																																																																BgL_arg6938z00_8880
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BgL_arg6954z00_8907,
																																																																																																	BNIL);
																																																																																															}
																																																																																															BgL_arg6936z00_8878
																																																																																																=
																																																																																																MAKE_YOUNG_PAIR
																																																																																																(BgL_arg6937z00_8879,
																																																																																																BgL_arg6938z00_8880);
																																																																																														}
																																																																																														BgL_nexpz00_8875
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BgL_arg6935z00_8877,
																																																																																															BgL_arg6936z00_8878);
																																																																																													}
																																																																																													{	/* Ast/sexp.scm 445 */

																																																																																														BgL_auxz00_14284
																																																																																															=
																																																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																																																															(BgL_nexpz00_8875,
																																																																																															BgL_stackz00_22,
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_expz00_21,
																																																																																																BgL_locz00_8874),
																																																																																															BgL_sitez00_24);
																																																																																										}}}}
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14284);
																																																																																								}}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																										BgL_tagzd2403zd2_1825:
																																																																																											BgL_auxz00_13657 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																										}
																																																																																									else
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14348;
																																																																																										BgL_tagzd2404zd2_1826:
																																																																																											BgL_auxz00_14348 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																											BgL_auxz00_13657
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14348);
																																																																																										}
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1825;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14353;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1826;
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14353);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14357;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14357);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	}
																																																																																}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_14361;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_14361);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd21185zd2_2827;
																																																																												BgL_cdrzd21185zd2_2827
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd21191zd2_2828;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10085;
																																																																														BgL_pairz00_10085
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd21191zd2_2828
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10085);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd21197zd2_2829;
																																																																														BgL_cdrzd21197zd2_2829
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd21191zd2_2828));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21202zd2_2830;
																																																																															obj_t
																																																																																BgL_cdrzd21203zd2_2831;
																																																																															BgL_carzd21202zd2_2830
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2829));
																																																																															BgL_cdrzd21203zd2_2831
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2829));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21202zd2_2830))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd21208zd2_2833;
																																																																																	BgL_carzd21208zd2_2833
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd21203zd2_2831));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21208zd2_2833))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (NULLP(CDR(((obj_t) BgL_cdrzd21203zd2_2831))))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21185zd2_2827))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2403z00_2838;
																																																																																							BgL_arg2403z00_2838
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd21191zd2_2828));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14388;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_14392;
																																																																																									obj_t
																																																																																										BgL_proc2z00_14391;
																																																																																									obj_t
																																																																																										BgL_proc1z00_14390;
																																																																																									obj_t
																																																																																										BgL_testz00_14389;
																																																																																									BgL_testz00_14389
																																																																																										=
																																																																																										BgL_arg2403z00_2838;
																																																																																									BgL_proc1z00_14390
																																																																																										=
																																																																																										BgL_carzd21202zd2_2830;
																																																																																									BgL_proc2z00_14391
																																																																																										=
																																																																																										BgL_carzd21208zd2_2833;
																																																																																									BgL_argsz00_14392
																																																																																										=
																																																																																										BgL_cdrzd21185zd2_2827;
																																																																																									BgL_argsz00_1800
																																																																																										=
																																																																																										BgL_argsz00_14392;
																																																																																									BgL_proc2z00_1799
																																																																																										=
																																																																																										BgL_proc2z00_14391;
																																																																																									BgL_proc1z00_1798
																																																																																										=
																																																																																										BgL_proc1z00_14390;
																																																																																									BgL_testz00_1797
																																																																																										=
																																																																																										BgL_testz00_14389;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1801;
																																																																																								}
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14388);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1825;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14396;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1826;
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14396);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14400;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14400);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14404;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14404);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_14408;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_14408);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_14412;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_14412);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd21541zd2_2846;
																																																																								BgL_cdrzd21541zd2_2846
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd21548zd2_2847;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10094;
																																																																										BgL_pairz00_10094
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd21548zd2_2847
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10094);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd21555zd2_2848;
																																																																										BgL_cdrzd21555zd2_2848
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd21548zd2_2847));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd21561zd2_2849;
																																																																											obj_t
																																																																												BgL_cdrzd21562zd2_2850;
																																																																											BgL_carzd21561zd2_2849
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2848));
																																																																											BgL_cdrzd21562zd2_2850
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2848));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21561zd2_2849))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd21562zd2_2850))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21569zd2_2853;
																																																																															BgL_carzd21569zd2_2853
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd21562zd2_2850);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21569zd2_2853))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd21562zd2_2850)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21541zd2_2846))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2420z00_2858;
																																																																																					BgL_arg2420z00_2858
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd21548zd2_2847));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_14439;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_14443;
																																																																																							obj_t
																																																																																								BgL_proc2z00_14442;
																																																																																							obj_t
																																																																																								BgL_proc1z00_14441;
																																																																																							obj_t
																																																																																								BgL_testz00_14440;
																																																																																							BgL_testz00_14440
																																																																																								=
																																																																																								BgL_arg2420z00_2858;
																																																																																							BgL_proc1z00_14441
																																																																																								=
																																																																																								BgL_carzd21561zd2_2849;
																																																																																							BgL_proc2z00_14442
																																																																																								=
																																																																																								BgL_carzd21569zd2_2853;
																																																																																							BgL_argsz00_14443
																																																																																								=
																																																																																								BgL_cdrzd21541zd2_2846;
																																																																																							BgL_argsz00_1800
																																																																																								=
																																																																																								BgL_argsz00_14443;
																																																																																							BgL_proc2z00_1799
																																																																																								=
																																																																																								BgL_proc2z00_14442;
																																																																																							BgL_proc1z00_1798
																																																																																								=
																																																																																								BgL_proc1z00_14441;
																																																																																							BgL_testz00_1797
																																																																																								=
																																																																																								BgL_testz00_14440;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1801;
																																																																																						}
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_14439);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_14447;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_14447);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14451;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14451);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_14455;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_14455);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14459;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14459);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_14463;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_14463);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_14467;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_14467);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd21962zd2_2872;
																																																								BgL_cdrzd21962zd2_2872
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7641z00_14471;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2454z00_2889;
																																																										BgL_arg2454z00_2889
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7641z00_14471
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2454z00_2889));
																																																									}
																																																									if (BgL_test7641z00_14471)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2437z00_2875;
																																																											obj_t
																																																												BgL_arg2438z00_2876;
																																																											BgL_arg2437z00_2875
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2872));
																																																											BgL_arg2438z00_2876
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2872));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_14480;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_14482;
																																																													obj_t
																																																														BgL_bindingsz00_14481;
																																																													BgL_bindingsz00_14481
																																																														=
																																																														BgL_arg2437z00_2875;
																																																													BgL_exprz00_14482
																																																														=
																																																														BgL_arg2438z00_2876;
																																																													BgL_exprz00_1780
																																																														=
																																																														BgL_exprz00_14482;
																																																													BgL_bindingsz00_1779
																																																														=
																																																														BgL_bindingsz00_14481;
																																																													goto
																																																														BgL_tagzd2382zd2_1781;
																																																												}
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_14480);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test7642z00_14484;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2453z00_2888;
																																																												BgL_arg2453z00_2888
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test7642z00_14484
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2453z00_2888));
																																																											}
																																																											if (BgL_test7642z00_14484)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_14489;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_14489);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd22028zd2_2879;
																																																													BgL_carzd22028zd2_2879
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd22033zd2_2880;
																																																														BgL_cdrzd22033zd2_2880
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd22028zd2_2879));
																																																														if ((CAR(((obj_t) BgL_carzd22028zd2_2879)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2445z00_2883;
																																																																obj_t
																																																																	BgL_arg2446z00_2884;
																																																																obj_t
																																																																	BgL_arg2447z00_2885;
																																																																BgL_arg2445z00_2883
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2880));
																																																																BgL_arg2446z00_2884
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2880));
																																																																BgL_arg2447z00_2885
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_14506;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_14509;
																																																																		obj_t
																																																																			BgL_bodyz00_14508;
																																																																		obj_t
																																																																			BgL_varsz00_14507;
																																																																		BgL_varsz00_14507
																																																																			=
																																																																			BgL_arg2445z00_2883;
																																																																		BgL_bodyz00_14508
																																																																			=
																																																																			BgL_arg2446z00_2884;
																																																																		BgL_argsz00_14509
																																																																			=
																																																																			BgL_arg2447z00_2885;
																																																																		BgL_argsz00_1790
																																																																			=
																																																																			BgL_argsz00_14509;
																																																																		BgL_bodyz00_1789
																																																																			=
																																																																			BgL_bodyz00_14508;
																																																																		BgL_varsz00_1788
																																																																			=
																																																																			BgL_varsz00_14507;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1791;
																																																																	}
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_14506);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_14513;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_14513);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd22144zd2_2890;
																																																						BgL_cdrzd22144zd2_2890
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7645z00_14517;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2464z00_2899;
																																																								BgL_arg2464z00_2899
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7645z00_14517
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2464z00_2899));
																																																							}
																																																							if (BgL_test7645z00_14517)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2457z00_2893;
																																																									obj_t
																																																										BgL_arg2458z00_2894;
																																																									BgL_arg2457z00_2893
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2890));
																																																									BgL_arg2458z00_2894
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2890));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_14526;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_14528;
																																																											obj_t
																																																												BgL_bindingsz00_14527;
																																																											BgL_bindingsz00_14527
																																																												=
																																																												BgL_arg2457z00_2893;
																																																											BgL_exprz00_14528
																																																												=
																																																												BgL_arg2458z00_2894;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_14528;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_14527;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_14526);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7646z00_14530;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2463z00_2898;
																																																										BgL_arg2463z00_2898
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7646z00_14530
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2463z00_2898));
																																																									}
																																																									if (BgL_test7646z00_14530)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_14535;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14535);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_14539;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_14539);
																																																												}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2709zd2_2626)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd2711zd2_2628;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd2709zd2_2626 == CNST_TABLE_REF(((long) 18))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd2711zd2_2628;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if ((BgL_carzd2709zd2_2626 == CNST_TABLE_REF(((long) 19))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd2711zd2_2628;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2709zd2_2626)))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_kapzd2711zd2_2628;
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd22316zd2_2634;
																																																												BgL_cdrzd22316zd2_2634
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test7652z00_14555;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2352z00_2751;
																																																														BgL_arg2352z00_2751
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test7652z00_14555
																																																															=
																																																															CBOOL
																																																															(BGl_letzd2symzf3z21zzast_letz00
																																																															(BgL_arg2352z00_2751));
																																																													}
																																																													if (BgL_test7652z00_14555)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg2279z00_2637;
																																																															obj_t
																																																																BgL_arg2280z00_2638;
																																																															BgL_arg2279z00_2637
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2634));
																																																															BgL_arg2280z00_2638
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2634));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_14564;
																																																																{
																																																																	obj_t
																																																																		BgL_exprz00_14566;
																																																																	obj_t
																																																																		BgL_bindingsz00_14565;
																																																																	BgL_bindingsz00_14565
																																																																		=
																																																																		BgL_arg2279z00_2637;
																																																																	BgL_exprz00_14566
																																																																		=
																																																																		BgL_arg2280z00_2638;
																																																																	BgL_exprz00_1780
																																																																		=
																																																																		BgL_exprz00_14566;
																																																																	BgL_bindingsz00_1779
																																																																		=
																																																																		BgL_bindingsz00_14565;
																																																																	goto
																																																																		BgL_tagzd2382zd2_1781;
																																																																}
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_14564);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test7653z00_14568;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2351z00_2750;
																																																																BgL_arg2351z00_2750
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_test7653z00_14568
																																																																	=
																																																																	CBOOL
																																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																																	(BgL_arg2351z00_2750));
																																																															}
																																																															if (BgL_test7653z00_14568)
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_14573;
																																																																	goto
																																																																		BgL_tagzd2384zd2_1783;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_14573);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd22382zd2_2641;
																																																																	BgL_carzd22382zd2_2641
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd22387zd2_2642;
																																																																		BgL_cdrzd22387zd2_2642
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd22382zd2_2641));
																																																																		if ((CAR(((obj_t) BgL_carzd22382zd2_2641)) == CNST_TABLE_REF(((long) 3))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd22387zd2_2642))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg2287z00_2646;
																																																																						obj_t
																																																																							BgL_arg2288z00_2647;
																																																																						obj_t
																																																																							BgL_arg2289z00_2648;
																																																																						BgL_arg2287z00_2646
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd22387zd2_2642);
																																																																						BgL_arg2288z00_2647
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd22387zd2_2642);
																																																																						BgL_arg2289z00_2648
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_14590;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_14593;
																																																																								obj_t
																																																																									BgL_bodyz00_14592;
																																																																								obj_t
																																																																									BgL_varsz00_14591;
																																																																								BgL_varsz00_14591
																																																																									=
																																																																									BgL_arg2287z00_2646;
																																																																								BgL_bodyz00_14592
																																																																									=
																																																																									BgL_arg2288z00_2647;
																																																																								BgL_argsz00_14593
																																																																									=
																																																																									BgL_arg2289z00_2648;
																																																																								BgL_argsz00_1790
																																																																									=
																																																																									BgL_argsz00_14593;
																																																																								BgL_bodyz00_1789
																																																																									=
																																																																									BgL_bodyz00_14592;
																																																																								BgL_varsz00_1788
																																																																									=
																																																																									BgL_varsz00_14591;
																																																																								goto
																																																																									BgL_tagzd2386zd2_1791;
																																																																							}
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_14590);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_14597;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_14597);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd22494zd2_2651;
																																																																				BgL_cdrzd22494zd2_2651
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd22499zd2_2652;
																																																																					BgL_cdrzd22499zd2_2652
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_carzd22382zd2_2641));
																																																																					if ((CAR(((obj_t) BgL_carzd22382zd2_2641)) == CNST_TABLE_REF(((long) 1))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd22499zd2_2652))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd22504zd2_2656;
																																																																									BgL_cdrzd22504zd2_2656
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd22499zd2_2652);
																																																																									if (PAIRP(BgL_cdrzd22504zd2_2656))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd22508zd2_2658;
																																																																											obj_t
																																																																												BgL_cdrzd22509zd2_2659;
																																																																											BgL_carzd22508zd2_2658
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22504zd2_2656);
																																																																											BgL_cdrzd22509zd2_2659
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd22504zd2_2656);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22508zd2_2658))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd22509zd2_2659))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd22514zd2_2662;
																																																																															BgL_carzd22514zd2_2662
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd22509zd2_2659);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22514zd2_2662))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd22509zd2_2659)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test7664z00_14625;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1371z00_2695;
																																																																																				BgL_l1371z00_2695
																																																																																					=
																																																																																					BgL_cdrzd22494zd2_2651;
																																																																																			BgL_zc3z04anonymousza32315ze3z87_2696:
																																																																																				if (NULLP(BgL_l1371z00_2695))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test7664z00_14625
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							1);
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						bool_t
																																																																																							BgL_test7666z00_14628;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							bool_t
																																																																																								BgL_test7667z00_14629;
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_tmpz00_14630;
																																																																																								BgL_tmpz00_14630
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_l1371z00_2695));
																																																																																								BgL_test7667z00_14629
																																																																																									=
																																																																																									PAIRP
																																																																																									(BgL_tmpz00_14630);
																																																																																							}
																																																																																							if (BgL_test7667z00_14629)
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test7666z00_14628
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										0);
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test7666z00_14628
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										1);
																																																																																								}
																																																																																						}
																																																																																						if (BgL_test7666z00_14628)
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_l1371z00_14634;
																																																																																								BgL_l1371z00_14634
																																																																																									=
																																																																																									CDR
																																																																																									(
																																																																																									((obj_t) BgL_l1371z00_2695));
																																																																																								BgL_l1371z00_2695
																																																																																									=
																																																																																									BgL_l1371z00_14634;
																																																																																								goto
																																																																																									BgL_zc3z04anonymousza32315ze3z87_2696;
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								BgL_test7664z00_14625
																																																																																									=
																																																																																									(
																																																																																									(bool_t)
																																																																																									0);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																			if (BgL_test7664z00_14625)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2305z00_2678;
																																																																																					BgL_arg2305z00_2678
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_cdrzd22499zd2_2652);
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_14638;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_14642;
																																																																																							obj_t
																																																																																								BgL_proc2z00_14641;
																																																																																							obj_t
																																																																																								BgL_proc1z00_14640;
																																																																																							obj_t
																																																																																								BgL_testz00_14639;
																																																																																							BgL_testz00_14639
																																																																																								=
																																																																																								BgL_arg2305z00_2678;
																																																																																							BgL_proc1z00_14640
																																																																																								=
																																																																																								BgL_carzd22508zd2_2658;
																																																																																							BgL_proc2z00_14641
																																																																																								=
																																																																																								BgL_carzd22514zd2_2662;
																																																																																							BgL_argsz00_14642
																																																																																								=
																																																																																								BgL_cdrzd22494zd2_2651;
																																																																																							BgL_argsz00_1795
																																																																																								=
																																																																																								BgL_argsz00_14642;
																																																																																							BgL_proc2z00_1794
																																																																																								=
																																																																																								BgL_proc2z00_14641;
																																																																																							BgL_proc1z00_1793
																																																																																								=
																																																																																								BgL_proc1z00_14640;
																																																																																							BgL_testz00_1792
																																																																																								=
																																																																																								BgL_testz00_14639;
																																																																																							goto
																																																																																								BgL_tagzd2387zd2_1796;
																																																																																						}
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_14638);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd22539zd2_2679;
																																																																																					BgL_cdrzd22539zd2_2679
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_cdrzd22547zd2_2680;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10142;
																																																																																							BgL_pairz00_10142
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_expz00_21));
																																																																																							BgL_cdrzd22547zd2_2680
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_pairz00_10142);
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_cdrzd22555zd2_2681;
																																																																																							BgL_cdrzd22555zd2_2681
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd22547zd2_2680));
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd22562zd2_2682;
																																																																																								BgL_carzd22562zd2_2682
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd22555zd2_2681));
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22562zd2_2682))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_carzd22571zd2_2684;
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																											obj_t
																																																																																												BgL_pairz00_10146;
																																																																																											BgL_pairz00_10146
																																																																																												=
																																																																																												CDR
																																																																																												(
																																																																																												((obj_t) BgL_cdrzd22555zd2_2681));
																																																																																											BgL_carzd22571zd2_2684
																																																																																												=
																																																																																												CAR
																																																																																												(BgL_pairz00_10146);
																																																																																										}
																																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22571zd2_2684))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22539zd2_2679))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														obj_t
																																																																																															BgL_arg2309z00_2687;
																																																																																														BgL_arg2309z00_2687
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_cdrzd22547zd2_2680));
																																																																																														{
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_auxz00_14664;
																																																																																															{
																																																																																																obj_t
																																																																																																	BgL_argsz00_14668;
																																																																																																obj_t
																																																																																																	BgL_proc2z00_14667;
																																																																																																obj_t
																																																																																																	BgL_proc1z00_14666;
																																																																																																obj_t
																																																																																																	BgL_testz00_14665;
																																																																																																BgL_testz00_14665
																																																																																																	=
																																																																																																	BgL_arg2309z00_2687;
																																																																																																BgL_proc1z00_14666
																																																																																																	=
																																																																																																	BgL_carzd22562zd2_2682;
																																																																																																BgL_proc2z00_14667
																																																																																																	=
																																																																																																	BgL_carzd22571zd2_2684;
																																																																																																BgL_argsz00_14668
																																																																																																	=
																																																																																																	BgL_cdrzd22539zd2_2679;
																																																																																																BgL_argsz00_1800
																																																																																																	=
																																																																																																	BgL_argsz00_14668;
																																																																																																BgL_proc2z00_1799
																																																																																																	=
																																																																																																	BgL_proc2z00_14667;
																																																																																																BgL_proc1z00_1798
																																																																																																	=
																																																																																																	BgL_proc1z00_14666;
																																																																																																BgL_testz00_1797
																																																																																																	=
																																																																																																	BgL_testz00_14665;
																																																																																																goto
																																																																																																	BgL_tagzd2388zd2_1801;
																																																																																															}
																																																																																															BgL_auxz00_13657
																																																																																																=
																																																																																																(
																																																																																																(obj_t)
																																																																																																BgL_auxz00_14664);
																																																																																														}
																																																																																													}
																																																																																												else
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																															{	/* Ast/sexp.scm 119 */
																																																																																																goto
																																																																																																	BgL_tagzd2403zd2_1825;
																																																																																															}
																																																																																														else
																																																																																															{
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_auxz00_14672;
																																																																																																goto
																																																																																																	BgL_tagzd2404zd2_1826;
																																																																																																BgL_auxz00_13657
																																																																																																	=
																																																																																																	(
																																																																																																	(obj_t)
																																																																																																	BgL_auxz00_14672);
																																																																																															}
																																																																																													}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1825;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_14676;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1826;
																																																																																														BgL_auxz00_13657
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_14676);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_14680;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_14680);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_14684;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_14684);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd22849zd2_2706;
																																																																																	BgL_cdrzd22849zd2_2706
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd22856zd2_2707;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10150;
																																																																																			BgL_pairz00_10150
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd22856zd2_2707
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10150);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd22863zd2_2708;
																																																																																			BgL_cdrzd22863zd2_2708
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd22856zd2_2707));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd22869zd2_2709;
																																																																																				obj_t
																																																																																					BgL_cdrzd22870zd2_2710;
																																																																																				BgL_carzd22869zd2_2709
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2708));
																																																																																				BgL_cdrzd22870zd2_2710
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2708));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22869zd2_2709))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd22877zd2_2712;
																																																																																						BgL_carzd22877zd2_2712
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd22870zd2_2710));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22877zd2_2712))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd22870zd2_2710))))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22849zd2_2706))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2324z00_2717;
																																																																																												BgL_arg2324z00_2717
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd22856zd2_2707));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_14711;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_14715;
																																																																																														obj_t
																																																																																															BgL_proc2z00_14714;
																																																																																														obj_t
																																																																																															BgL_proc1z00_14713;
																																																																																														obj_t
																																																																																															BgL_testz00_14712;
																																																																																														BgL_testz00_14712
																																																																																															=
																																																																																															BgL_arg2324z00_2717;
																																																																																														BgL_proc1z00_14713
																																																																																															=
																																																																																															BgL_carzd22869zd2_2709;
																																																																																														BgL_proc2z00_14714
																																																																																															=
																																																																																															BgL_carzd22877zd2_2712;
																																																																																														BgL_argsz00_14715
																																																																																															=
																																																																																															BgL_cdrzd22849zd2_2706;
																																																																																														BgL_argsz00_1800
																																																																																															=
																																																																																															BgL_argsz00_14715;
																																																																																														BgL_proc2z00_1799
																																																																																															=
																																																																																															BgL_proc2z00_14714;
																																																																																														BgL_proc1z00_1798
																																																																																															=
																																																																																															BgL_proc1z00_14713;
																																																																																														BgL_testz00_1797
																																																																																															=
																																																																																															BgL_testz00_14712;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1801;
																																																																																													}
																																																																																													BgL_auxz00_13657
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_14711);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1825;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_14719;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1826;
																																																																																														BgL_auxz00_13657
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_14719);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_14723;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_14723);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14727;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14727);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14731;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14731);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14735;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14735);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd23210zd2_2725;
																																																																													BgL_cdrzd23210zd2_2725
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd23216zd2_2726;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10159;
																																																																															BgL_pairz00_10159
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd23216zd2_2726
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10159);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd23222zd2_2727;
																																																																															BgL_cdrzd23222zd2_2727
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd23216zd2_2726));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd23227zd2_2728;
																																																																																obj_t
																																																																																	BgL_cdrzd23228zd2_2729;
																																																																																BgL_carzd23227zd2_2728
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2727));
																																																																																BgL_cdrzd23228zd2_2729
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2727));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23227zd2_2728))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (PAIRP(BgL_cdrzd23228zd2_2729))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd23233zd2_2732;
																																																																																				BgL_carzd23233zd2_2732
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_cdrzd23228zd2_2729);
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23233zd2_2732))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(BgL_cdrzd23228zd2_2729)))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23210zd2_2725))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2338z00_2737;
																																																																																										BgL_arg2338z00_2737
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd23216zd2_2726));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14762;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_14766;
																																																																																												obj_t
																																																																																													BgL_proc2z00_14765;
																																																																																												obj_t
																																																																																													BgL_proc1z00_14764;
																																																																																												obj_t
																																																																																													BgL_testz00_14763;
																																																																																												BgL_testz00_14763
																																																																																													=
																																																																																													BgL_arg2338z00_2737;
																																																																																												BgL_proc1z00_14764
																																																																																													=
																																																																																													BgL_carzd23227zd2_2728;
																																																																																												BgL_proc2z00_14765
																																																																																													=
																																																																																													BgL_carzd23233zd2_2732;
																																																																																												BgL_argsz00_14766
																																																																																													=
																																																																																													BgL_cdrzd23210zd2_2725;
																																																																																												BgL_argsz00_1800
																																																																																													=
																																																																																													BgL_argsz00_14766;
																																																																																												BgL_proc2z00_1799
																																																																																													=
																																																																																													BgL_proc2z00_14765;
																																																																																												BgL_proc1z00_1798
																																																																																													=
																																																																																													BgL_proc1z00_14764;
																																																																																												BgL_testz00_1797
																																																																																													=
																																																																																													BgL_testz00_14763;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1801;
																																																																																											}
																																																																																											BgL_auxz00_13657
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14762);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_14770;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_14770);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14774;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14774);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_14778;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_14778);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_14782;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_14782);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_14786;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_14786);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_14790;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_14790);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_14794;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_14794);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_14798;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_14798);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd23771zd2_2901;
																																																	BgL_cdrzd23771zd2_2901
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd2706zd2_2624 == CNST_TABLE_REF(((long) 17))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2466z00_2903;
																																																			obj_t
																																																				BgL_arg2467z00_2904;
																																																			BgL_arg2466z00_2903
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2901));
																																																			BgL_arg2467z00_2904
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2901));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_14809;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_14811;
																																																					obj_t
																																																						BgL_bindingsz00_14810;
																																																					BgL_bindingsz00_14810
																																																						=
																																																						BgL_arg2466z00_2903;
																																																					BgL_exprz00_14811
																																																						=
																																																						BgL_arg2467z00_2904;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_14811;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_14810;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_14809);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2706zd2_2624)))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2470z00_2906;
																																																					obj_t
																																																						BgL_arg2471z00_2907;
																																																					BgL_arg2470z00_2906
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2901));
																																																					BgL_arg2471z00_2907
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2901));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_14820;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_14822;
																																																							obj_t
																																																								BgL_bindingsz00_14821;
																																																							BgL_bindingsz00_14821
																																																								=
																																																								BgL_arg2470z00_2906;
																																																							BgL_exprz00_14822
																																																								=
																																																								BgL_arg2471z00_2907;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_14822;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_14821;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_14820);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((BgL_carzd2706zd2_2624 == CNST_TABLE_REF(((long) 18))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2473z00_2909;
																																																							obj_t
																																																								BgL_arg2474z00_2910;
																																																							BgL_arg2473z00_2909
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2901));
																																																							BgL_arg2474z00_2910
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2901));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_14831;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_14833;
																																																									obj_t
																																																										BgL_bindingsz00_14832;
																																																									BgL_bindingsz00_14832
																																																										=
																																																										BgL_arg2473z00_2909;
																																																									BgL_exprz00_14833
																																																										=
																																																										BgL_arg2474z00_2910;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_14833;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_14832;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_14831);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_14840;
																																																								BgL_tagzd2383zd2_1782:
																																																									BgL_auxz00_14840 = BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_14840);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd23808zd2_2913;
																																																									BgL_carzd23808zd2_2913
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((BgL_carzd23808zd2_2913 == CNST_TABLE_REF(((long) 19))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_14849;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14849);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23808zd2_2913)))
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_14854;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_14854);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_14861;
																																																														BgL_tagzd2389zd2_1802:
																																																															BgL_auxz00_14861 = BGl_lambdazd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24, BGl_string7400z00zzast_sexpz00);
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14861);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_14869;
																																																																BgL_tagzd2390zd2_1803:
																																																																	BgL_auxz00_14869 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_14869);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd23888zd2_2920;
																																																																	BgL_cdrzd23888zd2_2920
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg2490z00_2923;
																																																																			obj_t
																																																																				BgL_arg2491z00_2924;
																																																																			BgL_arg2490z00_2923
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2920));
																																																																			BgL_arg2491z00_2924
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2920));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_14884;
																																																																				BgL_effectz00_1804
																																																																					=
																																																																					BgL_arg2490z00_2923;
																																																																				BgL_restz00_1805
																																																																					=
																																																																					BgL_arg2491z00_2924;
																																																																			BgL_tagzd2391zd2_1806:
																																																																				{	/* Ast/sexp.scm 458 */
																																																																					BgL_feffectz00_bglt
																																																																						BgL_arg6967z00_8929;
																																																																					obj_t
																																																																						BgL_arg6968z00_8930;
																																																																					BgL_arg6967z00_8929
																																																																						=
																																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																						(BgL_effectz00_1804);
																																																																					{	/* Ast/sexp.scm 459 */
																																																																						obj_t
																																																																							BgL_arg6969z00_8931;
																																																																						BgL_arg6969z00_8931
																																																																							=
																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																							(BgL_restz00_1805,
																																																																							BNIL);
																																																																						BgL_arg6968z00_8930
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(CNST_TABLE_REF
																																																																							(((long) 6)), BgL_arg6969z00_8931);
																																																																					}
																																																																					BgL_auxz00_14884
																																																																						=
																																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																						(
																																																																						((bool_t) 0), ((obj_t) BgL_arg6967z00_8929), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6968z00_8930, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																				}
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_14884);
																																																																		}}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_14898;
																																																																				BgL_tagzd2392zd2_1807:
																																																																					BgL_auxz00_14898 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_14898);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_14907;
																																																																						BgL_tagzd2393zd2_1808:
																																																																							{	/* Ast/sexp.scm 465 */
																																																																								bool_t
																																																																									BgL_test7708z00_14908;
																																																																								if (NULLP(BgL_stackz00_22))
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										BgL_test7708z00_14908
																																																																											=
																																																																											(BgL_sitez00_24
																																																																											==
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										BgL_test7708z00_14908
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								if (BgL_test7708z00_14908)
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										{	/* Ast/sexp.scm 469 */
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg6972z00_8934;
																																																																											BgL_arg6972z00_8934
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																											BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00
																																																																												(BgL_arg6972z00_8934);
																																																																										}
																																																																										BgL_auxz00_14907
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BUNSPEC,
																																																																											BgL_stackz00_22,
																																																																											BgL_locz00_23,
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 466 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_res7379z00_9957;
																																																																										{	/* Ast/sexp.scm 726 */
																																																																											obj_t
																																																																												BgL_arg7138z00_9953;
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg7139z00_9954;
																																																																											BgL_arg7138z00_9953
																																																																												=
																																																																												BGl_shapez00zztools_shapez00
																																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																																												());
																																																																											BgL_arg7139z00_9954
																																																																												=
																																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																												(CNST_TABLE_REF
																																																																												(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																																											{	/* Ast/sexp.scm 725 */
																																																																												obj_t
																																																																													BgL_list7140z00_9956;
																																																																												BgL_list7140z00_9956
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(
																																																																													((obj_t) BgL_arg7139z00_9954), BNIL);
																																																																												BgL_res7379z00_9957
																																																																													=
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																													(BgL_locz00_23,
																																																																														BgL_arg7138z00_9953,
																																																																														BGl_string7399z00zzast_sexpz00,
																																																																														BgL_expz00_21,
																																																																														BgL_list7140z00_9956));
																																																																										}}
																																																																										BgL_auxz00_14907
																																																																											=
																																																																											BgL_res7379z00_9957;
																																																																							}}
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_14907);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg2500z00_2932;
																																																																									obj_t
																																																																										BgL_arg2502z00_2933;
																																																																									BgL_arg2500z00_2932
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2920));
																																																																									BgL_arg2502z00_2933
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2920));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_14936;
																																																																										BgL_effectz00_1809
																																																																											=
																																																																											BgL_arg2500z00_2932;
																																																																										BgL_restz00_1810
																																																																											=
																																																																											BgL_arg2502z00_2933;
																																																																									BgL_tagzd2394zd2_1811:
																																																																										{	/* Ast/sexp.scm 474 */
																																																																											BgL_feffectz00_bglt
																																																																												BgL_arg6973z00_8936;
																																																																											obj_t
																																																																												BgL_arg6974z00_8937;
																																																																											BgL_arg6973z00_8936
																																																																												=
																																																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																												(BgL_effectz00_1809);
																																																																											{	/* Ast/sexp.scm 475 */
																																																																												obj_t
																																																																													BgL_arg6975z00_8938;
																																																																												BgL_arg6975z00_8938
																																																																													=
																																																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																													(BgL_restz00_1810,
																																																																													BNIL);
																																																																												BgL_arg6974z00_8937
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(CNST_TABLE_REF
																																																																													(((long) 6)), BgL_arg6975z00_8938);
																																																																											}
																																																																											BgL_auxz00_14936
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), ((obj_t) BgL_arg6973z00_8936), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6974z00_8937, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																										}
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_14936);
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_14950;
																																																																										BgL_tagzd2395zd2_1812:
																																																																											{
																																																																												obj_t
																																																																													BgL_procz00_8939;
																																																																												obj_t
																																																																													BgL_msgz00_8940;
																																																																												obj_t
																																																																													BgL_objz00_8941;
																																																																												if (PAIRP(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd262369zd2_8946;
																																																																														BgL_cdrzd262369zd2_8946
																																																																															=
																																																																															CDR
																																																																															(BgL_expz00_21);
																																																																														if (PAIRP(BgL_cdrzd262369zd2_8946))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262374zd2_8948;
																																																																																BgL_cdrzd262374zd2_8948
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd262369zd2_8946);
																																																																																if (PAIRP(BgL_cdrzd262374zd2_8948))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd262379zd2_8950;
																																																																																		BgL_cdrzd262379zd2_8950
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262374zd2_8948);
																																																																																		if (PAIRP(BgL_cdrzd262379zd2_8950))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd262379zd2_8950)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg6982z00_8954;
																																																																																						obj_t
																																																																																							BgL_arg6983z00_8955;
																																																																																						obj_t
																																																																																							BgL_arg6984z00_8956;
																																																																																						BgL_arg6982z00_8954
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262369zd2_8946);
																																																																																						BgL_arg6983z00_8955
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262374zd2_8948);
																																																																																						BgL_arg6984z00_8956
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262379zd2_8950);
																																																																																						{
																																																																																							BgL_failz00_bglt
																																																																																								BgL_auxz00_14968;
																																																																																							BgL_procz00_8939
																																																																																								=
																																																																																								BgL_arg6982z00_8954;
																																																																																							BgL_msgz00_8940
																																																																																								=
																																																																																								BgL_arg6983z00_8955;
																																																																																							BgL_objz00_8941
																																																																																								=
																																																																																								BgL_arg6984z00_8956;
																																																																																							{	/* Ast/sexp.scm 480 */
																																																																																								obj_t
																																																																																									BgL_locz00_8958;
																																																																																								BgL_locz00_8958
																																																																																									=
																																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																									(BgL_expz00_21,
																																																																																									BgL_locz00_23);
																																																																																								{	/* Ast/sexp.scm 480 */
																																																																																									obj_t
																																																																																										BgL_cdlocz00_8959;
																																																																																									{	/* Ast/sexp.scm 481 */
																																																																																										obj_t
																																																																																											BgL_arg6989z00_8973;
																																																																																										BgL_arg6989z00_8973
																																																																																											=
																																																																																											CDR
																																																																																											(
																																																																																											((obj_t) BgL_expz00_21));
																																																																																										BgL_cdlocz00_8959
																																																																																											=
																																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																											(BgL_arg6989z00_8973,
																																																																																											BgL_locz00_8958);
																																																																																									}
																																																																																									{	/* Ast/sexp.scm 481 */
																																																																																										obj_t
																																																																																											BgL_cddlocz00_8960;
																																																																																										{	/* Ast/sexp.scm 482 */
																																																																																											obj_t
																																																																																												BgL_arg6988z00_8972;
																																																																																											{	/* Ast/sexp.scm 482 */
																																																																																												obj_t
																																																																																													BgL_pairz00_9962;
																																																																																												BgL_pairz00_9962
																																																																																													=
																																																																																													CDR
																																																																																													(
																																																																																													((obj_t) BgL_expz00_21));
																																																																																												BgL_arg6988z00_8972
																																																																																													=
																																																																																													CDR
																																																																																													(BgL_pairz00_9962);
																																																																																											}
																																																																																											BgL_cddlocz00_8960
																																																																																												=
																																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																												(BgL_arg6988z00_8972,
																																																																																												BgL_locz00_8958);
																																																																																										}
																																																																																										{	/* Ast/sexp.scm 482 */
																																																																																											obj_t
																																																																																												BgL_cdddlocz00_8961;
																																																																																											{	/* Ast/sexp.scm 483 */
																																																																																												obj_t
																																																																																													BgL_arg6987z00_8971;
																																																																																												{	/* Ast/sexp.scm 483 */
																																																																																													obj_t
																																																																																														BgL_pairz00_9968;
																																																																																													{	/* Ast/sexp.scm 483 */
																																																																																														obj_t
																																																																																															BgL_pairz00_9967;
																																																																																														BgL_pairz00_9967
																																																																																															=
																																																																																															CDR
																																																																																															(
																																																																																															((obj_t) BgL_expz00_21));
																																																																																														BgL_pairz00_9968
																																																																																															=
																																																																																															CDR
																																																																																															(BgL_pairz00_9967);
																																																																																													}
																																																																																													BgL_arg6987z00_8971
																																																																																														=
																																																																																														CDR
																																																																																														(BgL_pairz00_9968);
																																																																																												}
																																																																																												BgL_cdddlocz00_8961
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_arg6987z00_8971,
																																																																																													BgL_locz00_8958);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 483 */
																																																																																												obj_t
																																																																																													BgL_loczd2proczd2_8962;
																																																																																												BgL_loczd2proczd2_8962
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_procz00_8939,
																																																																																													BgL_cdlocz00_8959);
																																																																																												{	/* Ast/sexp.scm 484 */
																																																																																													obj_t
																																																																																														BgL_loczd2msgzd2_8963;
																																																																																													BgL_loczd2msgzd2_8963
																																																																																														=
																																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																														(BgL_msgz00_8940,
																																																																																														BgL_cddlocz00_8960);
																																																																																													{	/* Ast/sexp.scm 485 */
																																																																																														obj_t
																																																																																															BgL_loczd2objzd2_8964;
																																																																																														BgL_loczd2objzd2_8964
																																																																																															=
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_objz00_8941,
																																																																																															BgL_cdddlocz00_8961);
																																																																																														{	/* Ast/sexp.scm 486 */
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_procz00_8965;
																																																																																															BgL_procz00_8965
																																																																																																=
																																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																(BgL_procz00_8939,
																																																																																																BgL_stackz00_22,
																																																																																																BgL_loczd2proczd2_8962,
																																																																																																CNST_TABLE_REF
																																																																																																(((long) 2)));
																																																																																															{	/* Ast/sexp.scm 487 */
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_msgz00_8966;
																																																																																																BgL_msgz00_8966
																																																																																																	=
																																																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																	(BgL_msgz00_8940,
																																																																																																	BgL_stackz00_22,
																																																																																																	BgL_loczd2msgzd2_8963,
																																																																																																	CNST_TABLE_REF
																																																																																																	(((long) 2)));
																																																																																																{	/* Ast/sexp.scm 488 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_objz00_8967;
																																																																																																	BgL_objz00_8967
																																																																																																		=
																																																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																		(BgL_objz00_8941,
																																																																																																		BgL_stackz00_22,
																																																																																																		BgL_loczd2objzd2_8964,
																																																																																																		CNST_TABLE_REF
																																																																																																		(((long) 2)));
																																																																																																	{	/* Ast/sexp.scm 489 */

																																																																																																		{	/* Ast/sexp.scm 490 */
																																																																																																			BgL_failz00_bglt
																																																																																																				BgL_new1143z00_8968;
																																																																																																			{	/* Ast/sexp.scm 491 */
																																																																																																				BgL_failz00_bglt
																																																																																																					BgL_new1142z00_8969;
																																																																																																				BgL_new1142z00_8969
																																																																																																					=
																																																																																																					(
																																																																																																					(BgL_failz00_bglt)
																																																																																																					BOBJECT
																																																																																																					(GC_MALLOC
																																																																																																						(sizeof
																																																																																																							(struct
																																																																																																								BgL_failz00_bgl))));
																																																																																																				{	/* Ast/sexp.scm 491 */
																																																																																																					long
																																																																																																						BgL_arg6986z00_8970;
																																																																																																					BgL_arg6986z00_8970
																																																																																																						=
																																																																																																						BGL_CLASS_INDEX
																																																																																																						(BGl_failz00zzast_nodez00);
																																																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																																																						(
																																																																																																						((BgL_objectz00_bglt) BgL_new1142z00_8969), BgL_arg6986z00_8970);
																																																																																																				}
																																																																																																				{	/* Ast/sexp.scm 491 */
																																																																																																					BgL_objectz00_bglt
																																																																																																						BgL_tmpz00_14995;
																																																																																																					BgL_tmpz00_14995
																																																																																																						=
																																																																																																						(
																																																																																																						(BgL_objectz00_bglt)
																																																																																																						BgL_new1142z00_8969);
																																																																																																					BGL_OBJECT_WIDENING_SET
																																																																																																						(BgL_tmpz00_14995,
																																																																																																						BFALSE);
																																																																																																				}
																																																																																																				((BgL_objectz00_bglt) BgL_new1142z00_8969);
																																																																																																				BgL_new1143z00_8968
																																																																																																					=
																																																																																																					BgL_new1142z00_8969;
																																																																																																			}
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8968)))->BgL_locz00) = ((obj_t) BgL_locz00_8958), BUNSPEC);
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8968)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1143z00_8968))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_8965), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1143z00_8968))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_8966), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1143z00_8968))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_8967), BUNSPEC);
																																																																																																			BgL_auxz00_14968
																																																																																																				=
																																																																																																				BgL_new1143z00_8968;
																																																																																							}}}}}}}}}}}}
																																																																																							BgL_auxz00_14950
																																																																																								=
																																																																																								(
																																																																																								(BgL_nodez00_bglt)
																																																																																								BgL_auxz00_14968);
																																																																																					}}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																					BgL_tagzd262360zd2_8943:
																																																																																						{	/* Ast/sexp.scm 498 */
																																																																																							obj_t
																																																																																								BgL_arg6990z00_8974;
																																																																																							BgL_arg6990z00_8974
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_expz00_21,
																																																																																								BgL_locz00_23);
																																																																																							{	/* Ast/sexp.scm 497 */
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_res7380z00_9978;
																																																																																								{	/* Ast/sexp.scm 726 */
																																																																																									obj_t
																																																																																										BgL_arg7138z00_9974;
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_arg7139z00_9975;
																																																																																									BgL_arg7138z00_9974
																																																																																										=
																																																																																										BGl_shapez00zztools_shapez00
																																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																																										());
																																																																																									BgL_arg7139z00_9975
																																																																																										=
																																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																										(CNST_TABLE_REF
																																																																																										(((long) 4)), BNIL, BgL_arg6990z00_8974, CNST_TABLE_REF(((long) 2)));
																																																																																									{	/* Ast/sexp.scm 725 */
																																																																																										obj_t
																																																																																											BgL_list7140z00_9977;
																																																																																										BgL_list7140z00_9977
																																																																																											=
																																																																																											MAKE_YOUNG_PAIR
																																																																																											(
																																																																																											((obj_t) BgL_arg7139z00_9975), BNIL);
																																																																																										BgL_res7380z00_9978
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																											(BgL_arg6990z00_8974,
																																																																																												BgL_arg7138z00_9974,
																																																																																												BGl_string7398z00zzast_sexpz00,
																																																																																												BgL_expz00_21,
																																																																																												BgL_list7140z00_9977));
																																																																																								}}
																																																																																								BgL_auxz00_14950
																																																																																									=
																																																																																									BgL_res7380z00_9978;
																																																																																			}}}}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd262360zd2_8943;
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd262360zd2_8943;
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262360zd2_8943;
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd262360zd2_8943;
																																																																													}
																																																																											}
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_14950);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15024;
																																																																												BgL_tagzd2396zd2_1813:
																																																																													{
																																																																														obj_t
																																																																															BgL_testz00_8975;
																																																																														obj_t
																																																																															BgL_clausesz00_8976;
																																																																														if (PAIRP(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262393zd2_8981;
																																																																																BgL_cdrzd262393zd2_8981
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_expz00_21);
																																																																																if (PAIRP(BgL_cdrzd262393zd2_8981))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_testz00_8975
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd262393zd2_8981);
																																																																																		BgL_clausesz00_8976
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262393zd2_8981);
																																																																																		{	/* Ast/sexp.scm 509 */
																																																																																			obj_t
																																																																																				BgL_locz00_8985;
																																																																																			BgL_locz00_8985
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 509 */
																																																																																				obj_t
																																																																																					BgL_cdlocz00_8986;
																																																																																				{	/* Ast/sexp.scm 510 */
																																																																																					obj_t
																																																																																						BgL_arg7020z00_9026;
																																																																																					BgL_arg7020z00_9026
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdlocz00_8986
																																																																																						=
																																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																						(BgL_arg7020z00_9026,
																																																																																						BgL_locz00_8985);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 510 */
																																																																																					obj_t
																																																																																						BgL_cddlocz00_8987;
																																																																																					{	/* Ast/sexp.scm 511 */
																																																																																						obj_t
																																																																																							BgL_arg7019z00_9025;
																																																																																						BgL_arg7019z00_9025
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_expz00_21));
																																																																																						BgL_cddlocz00_8987
																																																																																							=
																																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																							(BgL_arg7019z00_9025,
																																																																																							BgL_locz00_8985);
																																																																																					}
																																																																																					{	/* Ast/sexp.scm 511 */
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_testz00_8988;
																																																																																						{	/* Ast/sexp.scm 514 */
																																																																																							obj_t
																																																																																								BgL_arg7018z00_9024;
																																																																																							BgL_arg7018z00_9024
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_testz00_8975,
																																																																																								BgL_cdlocz00_8986);
																																																																																							BgL_testz00_8988
																																																																																								=
																																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																								(BgL_testz00_8975,
																																																																																								BgL_stackz00_22,
																																																																																								BgL_arg7018z00_9024,
																																																																																								CNST_TABLE_REF
																																																																																								(((long) 2)));
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 512 */

																																																																																							{
																																																																																								obj_t
																																																																																									BgL_clsz00_8991;
																																																																																								obj_t
																																																																																									BgL_nclausesz00_8992;
																																																																																								BgL_clsz00_8991
																																																																																									=
																																																																																									BgL_clausesz00_8976;
																																																																																								BgL_nclausesz00_8992
																																																																																									=
																																																																																									BNIL;
																																																																																							BgL_zc3z04anonymousza36995ze3z87_8993:
																																																																																								if (NULLP(BgL_clsz00_8991))
																																																																																									{	/* Ast/sexp.scm 519 */
																																																																																										BgL_switchz00_bglt
																																																																																											BgL_new1146z00_8995;
																																																																																										{	/* Ast/sexp.scm 520 */
																																																																																											BgL_switchz00_bglt
																																																																																												BgL_new1145z00_8999;
																																																																																											BgL_new1145z00_8999
																																																																																												=
																																																																																												(
																																																																																												(BgL_switchz00_bglt)
																																																																																												BOBJECT
																																																																																												(GC_MALLOC
																																																																																													(sizeof
																																																																																														(struct
																																																																																															BgL_switchz00_bgl))));
																																																																																											{	/* Ast/sexp.scm 520 */
																																																																																												long
																																																																																													BgL_arg7000z00_9000;
																																																																																												BgL_arg7000z00_9000
																																																																																													=
																																																																																													BGL_CLASS_INDEX
																																																																																													(BGl_switchz00zzast_nodez00);
																																																																																												BGL_OBJECT_CLASS_NUM_SET
																																																																																													(
																																																																																													((BgL_objectz00_bglt) BgL_new1145z00_8999), BgL_arg7000z00_9000);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 520 */
																																																																																												BgL_objectz00_bglt
																																																																																													BgL_tmpz00_15046;
																																																																																												BgL_tmpz00_15046
																																																																																													=
																																																																																													(
																																																																																													(BgL_objectz00_bglt)
																																																																																													BgL_new1145z00_8999);
																																																																																												BGL_OBJECT_WIDENING_SET
																																																																																													(BgL_tmpz00_15046,
																																																																																													BFALSE);
																																																																																											}
																																																																																											((BgL_objectz00_bglt) BgL_new1145z00_8999);
																																																																																											BgL_new1146z00_8995
																																																																																												=
																																																																																												BgL_new1145z00_8999;
																																																																																										}
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1146z00_8995)))->BgL_locz00) = ((obj_t) BgL_locz00_8985), BUNSPEC);
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1146z00_8995)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1146z00_8995)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1146z00_8995)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1146z00_8995))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8988), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1146z00_8995))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_8992)), BUNSPEC);
																																																																																										{
																																																																																											BgL_typez00_bglt
																																																																																												BgL_auxz00_15063;
																																																																																											{	/* Ast/sexp.scm 523 */
																																																																																												obj_t
																																																																																													BgL_arg6997z00_8996;
																																																																																												{	/* Ast/sexp.scm 523 */
																																																																																													obj_t
																																																																																														BgL_pairz00_9994;
																																																																																													{	/* Ast/sexp.scm 523 */
																																																																																														obj_t
																																																																																															BgL_pairz00_9993;
																																																																																														BgL_pairz00_9993
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_clausesz00_8976));
																																																																																														BgL_pairz00_9994
																																																																																															=
																																																																																															CAR
																																																																																															(BgL_pairz00_9993);
																																																																																													}
																																																																																													BgL_arg6997z00_8996
																																																																																														=
																																																																																														CAR
																																																																																														(BgL_pairz00_9994);
																																																																																												}
																																																																																												BgL_auxz00_15063
																																																																																													=
																																																																																													BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																																													(BgL_arg6997z00_8996);
																																																																																											}
																																																																																											((((BgL_switchz00_bglt) COBJECT(BgL_new1146z00_8995))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_15063), BUNSPEC);
																																																																																										}
																																																																																										BgL_auxz00_15024
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BgL_new1146z00_8995);
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 525 */
																																																																																										obj_t
																																																																																											BgL_clausez00_9001;
																																																																																										BgL_clausez00_9001
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_clsz00_8991));
																																																																																										{	/* Ast/sexp.scm 525 */
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_bodyz00_9002;
																																																																																											{	/* Ast/sexp.scm 526 */
																																																																																												obj_t
																																																																																													BgL_arg7015z00_9020;
																																																																																												obj_t
																																																																																													BgL_arg7016z00_9021;
																																																																																												{	/* Ast/sexp.scm 526 */
																																																																																													obj_t
																																																																																														BgL_arg7017z00_9022;
																																																																																													BgL_arg7017z00_9022
																																																																																														=
																																																																																														CDR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_9001));
																																																																																													BgL_arg7015z00_9020
																																																																																														=
																																																																																														BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																																														(BgL_arg7017z00_9022);
																																																																																												}
																																																																																												BgL_arg7016z00_9021
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_clausez00_9001,
																																																																																													BgL_cddlocz00_8987);
																																																																																												BgL_bodyz00_9002
																																																																																													=
																																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																													(BgL_arg7015z00_9020,
																																																																																													BgL_stackz00_22,
																																																																																													BgL_arg7016z00_9021,
																																																																																													CNST_TABLE_REF
																																																																																													(((long) 2)));
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 526 */
																																																																																												obj_t
																																																																																													BgL_nclausez00_9003;
																																																																																												{	/* Ast/sexp.scm 530 */
																																																																																													obj_t
																																																																																														BgL_arg7014z00_9019;
																																																																																													BgL_arg7014z00_9019
																																																																																														=
																																																																																														CAR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_9001));
																																																																																													BgL_nclausez00_9003
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BgL_arg7014z00_9019,
																																																																																														((obj_t) BgL_bodyz00_9002));
																																																																																												}
																																																																																												{	/* Ast/sexp.scm 530 */

																																																																																													{	/* Ast/sexp.scm 532 */
																																																																																														bool_t
																																																																																															BgL_test7721z00_15083;
																																																																																														if ((CAR(((obj_t) BgL_clausez00_9001)) == CNST_TABLE_REF(((long) 5))))
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																if (NULLP(CDR(((obj_t) BgL_clsz00_8991))))
																																																																																																	{	/* Ast/sexp.scm 533 */
																																																																																																		BgL_test7721z00_15083
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			0);
																																																																																																	}
																																																																																																else
																																																																																																	{	/* Ast/sexp.scm 533 */
																																																																																																		BgL_test7721z00_15083
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			1);
																																																																																																	}
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																BgL_test7721z00_15083
																																																																																																	=
																																																																																																	(
																																																																																																	(bool_t)
																																																																																																	0);
																																																																																															}
																																																																																														if (BgL_test7721z00_15083)
																																																																																															{	/* Ast/sexp.scm 535 */
																																																																																																obj_t
																																																																																																	BgL_arg7008z00_9011;
																																																																																																BgL_arg7008z00_9011
																																																																																																	=
																																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																																	(BgL_expz00_21,
																																																																																																	BgL_locz00_8985);
																																																																																																{	/* Ast/sexp.scm 534 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_res7381z00_10005;
																																																																																																	{	/* Ast/sexp.scm 726 */
																																																																																																		obj_t
																																																																																																			BgL_arg7138z00_10001;
																																																																																																		BgL_nodez00_bglt
																																																																																																			BgL_arg7139z00_10002;
																																																																																																		BgL_arg7138z00_10001
																																																																																																			=
																																																																																																			BGl_shapez00zztools_shapez00
																																																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																																																			());
																																																																																																		BgL_arg7139z00_10002
																																																																																																			=
																																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																			(CNST_TABLE_REF
																																																																																																			(((long) 4)), BNIL, BgL_arg7008z00_9011, CNST_TABLE_REF(((long) 2)));
																																																																																																		{	/* Ast/sexp.scm 725 */
																																																																																																			obj_t
																																																																																																				BgL_list7140z00_10004;
																																																																																																			BgL_list7140z00_10004
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(
																																																																																																				((obj_t) BgL_arg7139z00_10002), BNIL);
																																																																																																			BgL_res7381z00_10005
																																																																																																				=
																																																																																																				(
																																																																																																				(BgL_nodez00_bglt)
																																																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																																				(BgL_arg7008z00_9011,
																																																																																																					BgL_arg7138z00_10001,
																																																																																																					BGl_string7397z00zzast_sexpz00,
																																																																																																					BgL_expz00_21,
																																																																																																					BgL_list7140z00_10004));
																																																																																																	}}
																																																																																																	BgL_auxz00_15024
																																																																																																		=
																																																																																																		BgL_res7381z00_10005;
																																																																																															}}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 536 */
																																																																																																obj_t
																																																																																																	BgL_arg7009z00_9012;
																																																																																																obj_t
																																																																																																	BgL_arg7010z00_9013;
																																																																																																BgL_arg7009z00_9012
																																																																																																	=
																																																																																																	CDR
																																																																																																	(
																																																																																																	((obj_t) BgL_clsz00_8991));
																																																																																																BgL_arg7010z00_9013
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BGl_epairifyz00zztools_miscz00
																																																																																																	(BgL_nclausez00_9003,
																																																																																																		BgL_clausez00_9001),
																																																																																																	BgL_nclausesz00_8992);
																																																																																																{
																																																																																																	obj_t
																																																																																																		BgL_nclausesz00_15108;
																																																																																																	obj_t
																																																																																																		BgL_clsz00_15107;
																																																																																																	BgL_clsz00_15107
																																																																																																		=
																																																																																																		BgL_arg7009z00_9012;
																																																																																																	BgL_nclausesz00_15108
																																																																																																		=
																																																																																																		BgL_arg7010z00_9013;
																																																																																																	BgL_nclausesz00_8992
																																																																																																		=
																																																																																																		BgL_nclausesz00_15108;
																																																																																																	BgL_clsz00_8991
																																																																																																		=
																																																																																																		BgL_clsz00_15107;
																																																																																																	goto
																																																																																																		BgL_zc3z04anonymousza36995ze3z87_8993;
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											}
																																																																																										}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																	BgL_tagzd262386zd2_8978:
																																																																																		{	/* Ast/sexp.scm 541 */
																																																																																			obj_t
																																																																																				BgL_arg7021z00_9027;
																																																																																			BgL_arg7021z00_9027
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 540 */
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_res7382z00_10012;
																																																																																				{	/* Ast/sexp.scm 726 */
																																																																																					obj_t
																																																																																						BgL_arg7138z00_10008;
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_arg7139z00_10009;
																																																																																					BgL_arg7138z00_10008
																																																																																						=
																																																																																						BGl_shapez00zztools_shapez00
																																																																																						(BGl_currentzd2functionzd2zztools_errorz00
																																																																																						());
																																																																																					BgL_arg7139z00_10009
																																																																																						=
																																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																						(CNST_TABLE_REF
																																																																																						(((long) 4)), BNIL, BgL_arg7021z00_9027, CNST_TABLE_REF(((long) 2)));
																																																																																					{	/* Ast/sexp.scm 725 */
																																																																																						obj_t
																																																																																							BgL_list7140z00_10011;
																																																																																						BgL_list7140z00_10011
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(
																																																																																							((obj_t) BgL_arg7139z00_10009), BNIL);
																																																																																						BgL_res7382z00_10012
																																																																																							=
																																																																																							(
																																																																																							(BgL_nodez00_bglt)
																																																																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																							(BgL_arg7021z00_9027,
																																																																																								BgL_arg7138z00_10008,
																																																																																								BGl_string7397z00zzast_sexpz00,
																																																																																								BgL_expz00_21,
																																																																																								BgL_list7140z00_10011));
																																																																																				}}
																																																																																				BgL_auxz00_15024
																																																																																					=
																																																																																					BgL_res7382z00_10012;
																																																																															}}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262386zd2_8978;
																																																																															}
																																																																													}
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15024);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																														{
																																																																															BgL_letzd2funzd2_bglt
																																																																																BgL_auxz00_15127;
																																																																														BgL_tagzd2397zd2_1814:
																																																																															BgL_auxz00_15127 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15127);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																																{
																																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																																		BgL_auxz00_15135;
																																																																																BgL_tagzd2398zd2_1815:
																																																																																	BgL_auxz00_15135 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15135);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd23965zd2_2942;
																																																																																	BgL_cdrzd23965zd2_2942
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2517z00_2945;
																																																																																			obj_t
																																																																																				BgL_arg2521z00_2946;
																																																																																			BgL_arg2517z00_2945
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2942));
																																																																																			BgL_arg2521z00_2946
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2942));
																																																																																			{	/* Ast/sexp.scm 555 */
																																																																																				obj_t
																																																																																					BgL_arg7023z00_10196;
																																																																																				BgL_arg7023z00_10196
																																																																																					=
																																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																					(BgL_expz00_21,
																																																																																					BgL_locz00_23);
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																					(BgL_expz00_21,
																																																																																						BgL_arg2517z00_2945,
																																																																																						CNST_TABLE_REF
																																																																																						(((long) 4)), BgL_arg2521z00_2946, BgL_stackz00_22, BgL_arg7023z00_10196, BgL_sitez00_24));
																																																																																		}}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15155;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15155);
																																																																																				}
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd23990zd2_2963;
																																					BgL_carzd23990zd2_2963
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd23990zd2_2963
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15162;
																																							goto
																																								BgL_tagzd2377zd2_1770;
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15162);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd23990zd2_2963 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15166;
																																									goto
																																										BgL_tagzd2377zd2_1770;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15166);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15173;
																																											goto
																																												BgL_tagzd2379zd2_1774;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15173);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_15180;
																																													goto
																																														BgL_tagzd2380zd2_1775;
																																													BgL_auxz00_13657
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_15180);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd24059zd2_2970;
																																													BgL_carzd24059zd2_2970
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd24059zd2_2970))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd24062zd2_2972;
																																															obj_t
																																																BgL_cdrzd24063zd2_2973;
																																															BgL_carzd24062zd2_2972
																																																=
																																																CAR
																																																(BgL_carzd24059zd2_2970);
																																															BgL_cdrzd24063zd2_2973
																																																=
																																																CDR
																																																(BgL_carzd24059zd2_2970);
																																															{

																																																if ((BgL_carzd24062zd2_2972 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd24064zd2_2974:
																																																		if (PAIRP(BgL_cdrzd24063zd2_2973))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd24067zd2_3099;
																																																				BgL_cdrzd24067zd2_3099
																																																					=
																																																					CDR
																																																					(BgL_cdrzd24063zd2_2973);
																																																				if (PAIRP(BgL_cdrzd24067zd2_3099))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd24067zd2_3099)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2650z00_3103;
																																																								obj_t
																																																									BgL_arg2651z00_3104;
																																																								BgL_arg2650z00_3103
																																																									=
																																																									CAR
																																																									(BgL_cdrzd24067zd2_3099);
																																																								BgL_arg2651z00_3104
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15202;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_15204;
																																																										obj_t
																																																											BgL_bodyz00_15203;
																																																										BgL_bodyz00_15203
																																																											=
																																																											BgL_arg2650z00_3103;
																																																										BgL_argsz00_15204
																																																											=
																																																											BgL_arg2651z00_3104;
																																																										BgL_argsz00_1777
																																																											=
																																																											BgL_argsz00_15204;
																																																										BgL_bodyz00_1776
																																																											=
																																																											BgL_bodyz00_15203;
																																																										goto
																																																											BgL_tagzd2381zd2_1778;
																																																									}
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15202);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd24091zd2_3105;
																																																								BgL_cdrzd24091zd2_3105
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7737z00_15208;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2725z00_3216;
																																																										BgL_arg2725z00_3216
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7737z00_15208
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2725z00_3216));
																																																									}
																																																									if (BgL_test7737z00_15208)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2654z00_3108;
																																																											obj_t
																																																												BgL_arg2657z00_3109;
																																																											BgL_arg2654z00_3108
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3105));
																																																											BgL_arg2657z00_3109
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3105));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15217;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15219;
																																																													obj_t
																																																														BgL_bindingsz00_15218;
																																																													BgL_bindingsz00_15218
																																																														=
																																																														BgL_arg2654z00_3108;
																																																													BgL_exprz00_15219
																																																														=
																																																														BgL_arg2657z00_3109;
																																																													BgL_exprz00_1780
																																																														=
																																																														BgL_exprz00_15219;
																																																													BgL_bindingsz00_1779
																																																														=
																																																														BgL_bindingsz00_15218;
																																																													goto
																																																														BgL_tagzd2382zd2_1781;
																																																												}
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15217);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test7738z00_15221;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2724z00_3215;
																																																												BgL_arg2724z00_3215
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test7738z00_15221
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2724z00_3215));
																																																											}
																																																											if (BgL_test7738z00_15221)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15226;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15226);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd24158zd2_3112;
																																																													BgL_carzd24158zd2_3112
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd24163zd2_3113;
																																																														BgL_cdrzd24163zd2_3113
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd24158zd2_3112));
																																																														if ((CAR(((obj_t) BgL_carzd24158zd2_3112)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2663z00_3116;
																																																																obj_t
																																																																	BgL_arg2665z00_3117;
																																																																obj_t
																																																																	BgL_arg2666z00_3118;
																																																																BgL_arg2663z00_3116
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3113));
																																																																BgL_arg2665z00_3117
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3113));
																																																																BgL_arg2666z00_3118
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15243;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15246;
																																																																		obj_t
																																																																			BgL_bodyz00_15245;
																																																																		obj_t
																																																																			BgL_varsz00_15244;
																																																																		BgL_varsz00_15244
																																																																			=
																																																																			BgL_arg2663z00_3116;
																																																																		BgL_bodyz00_15245
																																																																			=
																																																																			BgL_arg2665z00_3117;
																																																																		BgL_argsz00_15246
																																																																			=
																																																																			BgL_arg2666z00_3118;
																																																																		BgL_argsz00_1790
																																																																			=
																																																																			BgL_argsz00_15246;
																																																																		BgL_bodyz00_1789
																																																																			=
																																																																			BgL_bodyz00_15245;
																																																																		BgL_varsz00_1788
																																																																			=
																																																																			BgL_varsz00_15244;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1791;
																																																																	}
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15243);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd24186zd2_3120;
																																																																BgL_cdrzd24186zd2_3120
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd24192zd2_3121;
																																																																	BgL_cdrzd24192zd2_3121
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd24158zd2_3112));
																																																																	if ((CAR(((obj_t) BgL_carzd24158zd2_3112)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd24198zd2_3124;
																																																																			BgL_cdrzd24198zd2_3124
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd24192zd2_3121));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd24203zd2_3125;
																																																																				obj_t
																																																																					BgL_cdrzd24204zd2_3126;
																																																																				BgL_carzd24203zd2_3125
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3124));
																																																																				BgL_cdrzd24204zd2_3126
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3124));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24203zd2_3125))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd24204zd2_3126))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd24211zd2_3129;
																																																																								BgL_carzd24211zd2_3129
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd24204zd2_3126);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24211zd2_3129))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd24204zd2_3126)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test7745z00_15273;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1374z00_3162;
																																																																													BgL_l1374z00_3162
																																																																														=
																																																																														BgL_cdrzd24186zd2_3120;
																																																																												BgL_zc3z04anonymousza32690ze3z87_3163:
																																																																													if (NULLP(BgL_l1374z00_3162))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test7745z00_15273
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test7747z00_15276;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test7748z00_15277;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_15278;
																																																																																	BgL_tmpz00_15278
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1374z00_3162));
																																																																																	BgL_test7748z00_15277
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_15278);
																																																																																}
																																																																																if (BgL_test7748z00_15277)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test7747z00_15276
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test7747z00_15276
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test7747z00_15276)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1374z00_15282;
																																																																																	BgL_l1374z00_15282
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1374z00_3162));
																																																																																	BgL_l1374z00_3162
																																																																																		=
																																																																																		BgL_l1374z00_15282;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza32690ze3z87_3163;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test7745z00_15273
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test7745z00_15273)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2680z00_3145;
																																																																														BgL_arg2680z00_3145
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd24192zd2_3121));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15287;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_15291;
																																																																																obj_t
																																																																																	BgL_proc2z00_15290;
																																																																																obj_t
																																																																																	BgL_proc1z00_15289;
																																																																																obj_t
																																																																																	BgL_testz00_15288;
																																																																																BgL_testz00_15288
																																																																																	=
																																																																																	BgL_arg2680z00_3145;
																																																																																BgL_proc1z00_15289
																																																																																	=
																																																																																	BgL_carzd24203zd2_3125;
																																																																																BgL_proc2z00_15290
																																																																																	=
																																																																																	BgL_carzd24211zd2_3129;
																																																																																BgL_argsz00_15291
																																																																																	=
																																																																																	BgL_cdrzd24186zd2_3120;
																																																																																BgL_argsz00_1795
																																																																																	=
																																																																																	BgL_argsz00_15291;
																																																																																BgL_proc2z00_1794
																																																																																	=
																																																																																	BgL_proc2z00_15290;
																																																																																BgL_proc1z00_1793
																																																																																	=
																																																																																	BgL_proc1z00_15289;
																																																																																BgL_testz00_1792
																																																																																	=
																																																																																	BgL_testz00_15288;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1796;
																																																																															}
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15287);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd24235zd2_3146;
																																																																														BgL_cdrzd24235zd2_3146
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd24242zd2_3147;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10232;
																																																																																BgL_pairz00_10232
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd24242zd2_3147
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10232);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd24249zd2_3148;
																																																																																BgL_cdrzd24249zd2_3148
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd24242zd2_3147));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd24255zd2_3149;
																																																																																	BgL_carzd24255zd2_3149
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd24249zd2_3148));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24255zd2_3149))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd24262zd2_3151;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_10236;
																																																																																				BgL_pairz00_10236
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd24249zd2_3148));
																																																																																				BgL_carzd24262zd2_3151
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_10236);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24262zd2_3151))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24235zd2_3146))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2684z00_3154;
																																																																																							BgL_arg2684z00_3154
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd24242zd2_3147));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15313;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15317;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15316;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15315;
																																																																																									obj_t
																																																																																										BgL_testz00_15314;
																																																																																									BgL_testz00_15314
																																																																																										=
																																																																																										BgL_arg2684z00_3154;
																																																																																									BgL_proc1z00_15315
																																																																																										=
																																																																																										BgL_carzd24255zd2_3149;
																																																																																									BgL_proc2z00_15316
																																																																																										=
																																																																																										BgL_carzd24262zd2_3151;
																																																																																									BgL_argsz00_15317
																																																																																										=
																																																																																										BgL_cdrzd24235zd2_3146;
																																																																																									BgL_argsz00_1800
																																																																																										=
																																																																																										BgL_argsz00_15317;
																																																																																									BgL_proc2z00_1799
																																																																																										=
																																																																																										BgL_proc2z00_15316;
																																																																																									BgL_proc1z00_1798
																																																																																										=
																																																																																										BgL_proc1z00_15315;
																																																																																									BgL_testz00_1797
																																																																																										=
																																																																																										BgL_testz00_15314;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1801;
																																																																																								}
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15313);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1825;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15321;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1826;
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15321);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15325;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15325);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15329;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15329);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_15333;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_15333);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd24538zd2_3173;
																																																																										BgL_cdrzd24538zd2_3173
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd24544zd2_3174;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10240;
																																																																												BgL_pairz00_10240
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd24544zd2_3174
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10240);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd24550zd2_3175;
																																																																												BgL_cdrzd24550zd2_3175
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd24544zd2_3174));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24555zd2_3176;
																																																																													obj_t
																																																																														BgL_cdrzd24556zd2_3177;
																																																																													BgL_carzd24555zd2_3176
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3175));
																																																																													BgL_cdrzd24556zd2_3177
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3175));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24555zd2_3176))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd24561zd2_3179;
																																																																															BgL_carzd24561zd2_3179
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd24556zd2_3177));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24561zd2_3179))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd24556zd2_3177))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24538zd2_3173))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2699z00_3184;
																																																																																					BgL_arg2699z00_3184
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd24544zd2_3174));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15360;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15364;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15363;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15362;
																																																																																							obj_t
																																																																																								BgL_testz00_15361;
																																																																																							BgL_testz00_15361
																																																																																								=
																																																																																								BgL_arg2699z00_3184;
																																																																																							BgL_proc1z00_15362
																																																																																								=
																																																																																								BgL_carzd24555zd2_3176;
																																																																																							BgL_proc2z00_15363
																																																																																								=
																																																																																								BgL_carzd24561zd2_3179;
																																																																																							BgL_argsz00_15364
																																																																																								=
																																																																																								BgL_cdrzd24538zd2_3173;
																																																																																							BgL_argsz00_1800
																																																																																								=
																																																																																								BgL_argsz00_15364;
																																																																																							BgL_proc2z00_1799
																																																																																								=
																																																																																								BgL_proc2z00_15363;
																																																																																							BgL_proc1z00_1798
																																																																																								=
																																																																																								BgL_proc1z00_15362;
																																																																																							BgL_testz00_1797
																																																																																								=
																																																																																								BgL_testz00_15361;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1801;
																																																																																						}
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15360);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15368;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15368);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15372;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15372);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15376;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15376);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15380;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15380);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15384;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15384);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd24894zd2_3192;
																																																																						BgL_cdrzd24894zd2_3192
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd24901zd2_3193;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10249;
																																																																								BgL_pairz00_10249
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd24901zd2_3193
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10249);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd24908zd2_3194;
																																																																								BgL_cdrzd24908zd2_3194
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd24901zd2_3193));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd24914zd2_3195;
																																																																									obj_t
																																																																										BgL_cdrzd24915zd2_3196;
																																																																									BgL_carzd24914zd2_3195
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3194));
																																																																									BgL_cdrzd24915zd2_3196
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3194));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24914zd2_3195))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd24915zd2_3196))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24922zd2_3199;
																																																																													BgL_carzd24922zd2_3199
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd24915zd2_3196);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24922zd2_3199))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd24915zd2_3196)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24894zd2_3192))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2713z00_3204;
																																																																																			BgL_arg2713z00_3204
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd24901zd2_3193));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15411;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_15415;
																																																																																					obj_t
																																																																																						BgL_proc2z00_15414;
																																																																																					obj_t
																																																																																						BgL_proc1z00_15413;
																																																																																					obj_t
																																																																																						BgL_testz00_15412;
																																																																																					BgL_testz00_15412
																																																																																						=
																																																																																						BgL_arg2713z00_3204;
																																																																																					BgL_proc1z00_15413
																																																																																						=
																																																																																						BgL_carzd24914zd2_3195;
																																																																																					BgL_proc2z00_15414
																																																																																						=
																																																																																						BgL_carzd24922zd2_3199;
																																																																																					BgL_argsz00_15415
																																																																																						=
																																																																																						BgL_cdrzd24894zd2_3192;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_15415;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_15414;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_15413;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_15412;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15411);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15419;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15419);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15423;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15423);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15427;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15427);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15431;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15431);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15435;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15435);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15439;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15439);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd25315zd2_3218;
																																																						BgL_cdrzd25315zd2_3218
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7776z00_15443;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2747z00_3235;
																																																								BgL_arg2747z00_3235
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7776z00_15443
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2747z00_3235));
																																																							}
																																																							if (BgL_test7776z00_15443)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2729z00_3221;
																																																									obj_t
																																																										BgL_arg2733z00_3222;
																																																									BgL_arg2729z00_3221
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3218));
																																																									BgL_arg2733z00_3222
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3218));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15452;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15454;
																																																											obj_t
																																																												BgL_bindingsz00_15453;
																																																											BgL_bindingsz00_15453
																																																												=
																																																												BgL_arg2729z00_3221;
																																																											BgL_exprz00_15454
																																																												=
																																																												BgL_arg2733z00_3222;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_15454;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_15453;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15452);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7777z00_15456;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2746z00_3234;
																																																										BgL_arg2746z00_3234
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7777z00_15456
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2746z00_3234));
																																																									}
																																																									if (BgL_test7777z00_15456)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15461;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15461);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd25381zd2_3225;
																																																											BgL_carzd25381zd2_3225
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd25386zd2_3226;
																																																												BgL_cdrzd25386zd2_3226
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd25381zd2_3225));
																																																												if ((CAR(((obj_t) BgL_carzd25381zd2_3225)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2740z00_3229;
																																																														obj_t
																																																															BgL_arg2741z00_3230;
																																																														obj_t
																																																															BgL_arg2742z00_3231;
																																																														BgL_arg2740z00_3229
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3226));
																																																														BgL_arg2741z00_3230
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3226));
																																																														BgL_arg2742z00_3231
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15478;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_15481;
																																																																obj_t
																																																																	BgL_bodyz00_15480;
																																																																obj_t
																																																																	BgL_varsz00_15479;
																																																																BgL_varsz00_15479
																																																																	=
																																																																	BgL_arg2740z00_3229;
																																																																BgL_bodyz00_15480
																																																																	=
																																																																	BgL_arg2741z00_3230;
																																																																BgL_argsz00_15481
																																																																	=
																																																																	BgL_arg2742z00_3231;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_15481;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_15480;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_15479;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15478);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15485;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15485);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd25497zd2_3236;
																																																				BgL_cdrzd25497zd2_3236
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test7780z00_15489;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2760z00_3245;
																																																						BgL_arg2760z00_3245
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test7780z00_15489
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg2760z00_3245));
																																																					}
																																																					if (BgL_test7780z00_15489)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2754z00_3239;
																																																							obj_t
																																																								BgL_arg2755z00_3240;
																																																							BgL_arg2754z00_3239
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3236));
																																																							BgL_arg2755z00_3240
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3236));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15498;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_15500;
																																																									obj_t
																																																										BgL_bindingsz00_15499;
																																																									BgL_bindingsz00_15499
																																																										=
																																																										BgL_arg2754z00_3239;
																																																									BgL_exprz00_15500
																																																										=
																																																										BgL_arg2755z00_3240;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_15500;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_15499;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15498);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7781z00_15502;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2759z00_3244;
																																																								BgL_arg2759z00_3244
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7781z00_15502
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg2759z00_3244));
																																																							}
																																																							if (BgL_test7781z00_15502)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_15507;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15507);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_15511;
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15511);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24062zd2_2972)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd24064zd2_2974;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd24062zd2_2972 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd24064zd2_2974;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd24062zd2_2972 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd24064zd2_2974;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24062zd2_2972)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd24064zd2_2974;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd25669zd2_2980;
																																																										BgL_cdrzd25669zd2_2980
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test7787z00_15527;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2645z00_3097;
																																																												BgL_arg2645z00_3097
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test7787z00_15527
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2645z00_3097));
																																																											}
																																																											if (BgL_test7787z00_15527)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2568z00_2983;
																																																													obj_t
																																																														BgL_arg2569z00_2984;
																																																													BgL_arg2568z00_2983
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2980));
																																																													BgL_arg2569z00_2984
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2980));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_15536;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_15538;
																																																															obj_t
																																																																BgL_bindingsz00_15537;
																																																															BgL_bindingsz00_15537
																																																																=
																																																																BgL_arg2568z00_2983;
																																																															BgL_exprz00_15538
																																																																=
																																																																BgL_arg2569z00_2984;
																																																															BgL_exprz00_1780
																																																																=
																																																																BgL_exprz00_15538;
																																																															BgL_bindingsz00_1779
																																																																=
																																																																BgL_bindingsz00_15537;
																																																															goto
																																																																BgL_tagzd2382zd2_1781;
																																																														}
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_15536);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test7788z00_15540;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2644z00_3096;
																																																														BgL_arg2644z00_3096
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test7788z00_15540
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2644z00_3096));
																																																													}
																																																													if (BgL_test7788z00_15540)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_15545;
																																																															goto
																																																																BgL_tagzd2384zd2_1783;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15545);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd25735zd2_2987;
																																																															BgL_carzd25735zd2_2987
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd25740zd2_2988;
																																																																BgL_cdrzd25740zd2_2988
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd25735zd2_2987));
																																																																if ((CAR(((obj_t) BgL_carzd25735zd2_2987)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd25740zd2_2988))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg2575z00_2992;
																																																																				obj_t
																																																																					BgL_arg2577z00_2993;
																																																																				obj_t
																																																																					BgL_arg2578z00_2994;
																																																																				BgL_arg2575z00_2992
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd25740zd2_2988);
																																																																				BgL_arg2577z00_2993
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd25740zd2_2988);
																																																																				BgL_arg2578z00_2994
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15562;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_15565;
																																																																						obj_t
																																																																							BgL_bodyz00_15564;
																																																																						obj_t
																																																																							BgL_varsz00_15563;
																																																																						BgL_varsz00_15563
																																																																							=
																																																																							BgL_arg2575z00_2992;
																																																																						BgL_bodyz00_15564
																																																																							=
																																																																							BgL_arg2577z00_2993;
																																																																						BgL_argsz00_15565
																																																																							=
																																																																							BgL_arg2578z00_2994;
																																																																						BgL_argsz00_1790
																																																																							=
																																																																							BgL_argsz00_15565;
																																																																						BgL_bodyz00_1789
																																																																							=
																																																																							BgL_bodyz00_15564;
																																																																						BgL_varsz00_1788
																																																																							=
																																																																							BgL_varsz00_15563;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1791;
																																																																					}
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15562);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_15569;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_15569);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd25847zd2_2997;
																																																																		BgL_cdrzd25847zd2_2997
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd25852zd2_2998;
																																																																			BgL_cdrzd25852zd2_2998
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd25735zd2_2987));
																																																																			if ((CAR(((obj_t) BgL_carzd25735zd2_2987)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd25852zd2_2998))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd25857zd2_3002;
																																																																							BgL_cdrzd25857zd2_3002
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd25852zd2_2998);
																																																																							if (PAIRP(BgL_cdrzd25857zd2_3002))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd25861zd2_3004;
																																																																									obj_t
																																																																										BgL_cdrzd25862zd2_3005;
																																																																									BgL_carzd25861zd2_3004
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd25857zd2_3002);
																																																																									BgL_cdrzd25862zd2_3005
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd25857zd2_3002);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25861zd2_3004))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd25862zd2_3005))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd25867zd2_3008;
																																																																													BgL_carzd25867zd2_3008
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd25862zd2_3005);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25867zd2_3008))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd25862zd2_3005)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test7799z00_15597;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1377z00_3041;
																																																																																		BgL_l1377z00_3041
																																																																																			=
																																																																																			BgL_cdrzd25847zd2_2997;
																																																																																	BgL_zc3z04anonymousza32605ze3z87_3042:
																																																																																		if (NULLP(BgL_l1377z00_3041))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test7799z00_15597
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test7801z00_15600;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test7802z00_15601;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_15602;
																																																																																						BgL_tmpz00_15602
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1377z00_3041));
																																																																																						BgL_test7802z00_15601
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_15602);
																																																																																					}
																																																																																					if (BgL_test7802z00_15601)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test7801z00_15600
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test7801z00_15600
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test7801z00_15600)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1377z00_15606;
																																																																																						BgL_l1377z00_15606
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1377z00_3041));
																																																																																						BgL_l1377z00_3041
																																																																																							=
																																																																																							BgL_l1377z00_15606;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza32605ze3z87_3042;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test7799z00_15597
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test7799z00_15597)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2594z00_3024;
																																																																																			BgL_arg2594z00_3024
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd25852zd2_2998);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15610;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_15614;
																																																																																					obj_t
																																																																																						BgL_proc2z00_15613;
																																																																																					obj_t
																																																																																						BgL_proc1z00_15612;
																																																																																					obj_t
																																																																																						BgL_testz00_15611;
																																																																																					BgL_testz00_15611
																																																																																						=
																																																																																						BgL_arg2594z00_3024;
																																																																																					BgL_proc1z00_15612
																																																																																						=
																																																																																						BgL_carzd25861zd2_3004;
																																																																																					BgL_proc2z00_15613
																																																																																						=
																																																																																						BgL_carzd25867zd2_3008;
																																																																																					BgL_argsz00_15614
																																																																																						=
																																																																																						BgL_cdrzd25847zd2_2997;
																																																																																					BgL_argsz00_1795
																																																																																						=
																																																																																						BgL_argsz00_15614;
																																																																																					BgL_proc2z00_1794
																																																																																						=
																																																																																						BgL_proc2z00_15613;
																																																																																					BgL_proc1z00_1793
																																																																																						=
																																																																																						BgL_proc1z00_15612;
																																																																																					BgL_testz00_1792
																																																																																						=
																																																																																						BgL_testz00_15611;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1796;
																																																																																				}
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15610);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd25892zd2_3025;
																																																																																			BgL_cdrzd25892zd2_3025
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd25900zd2_3026;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10297;
																																																																																					BgL_pairz00_10297
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd25900zd2_3026
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_10297);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd25908zd2_3027;
																																																																																					BgL_cdrzd25908zd2_3027
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd25900zd2_3026));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd25915zd2_3028;
																																																																																						BgL_carzd25915zd2_3028
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd25908zd2_3027));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25915zd2_3028))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd25924zd2_3030;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_10301;
																																																																																									BgL_pairz00_10301
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd25908zd2_3027));
																																																																																									BgL_carzd25924zd2_3030
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_10301);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25924zd2_3030))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25892zd2_3025))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2599z00_3033;
																																																																																												BgL_arg2599z00_3033
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd25900zd2_3026));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_15636;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_15640;
																																																																																														obj_t
																																																																																															BgL_proc2z00_15639;
																																																																																														obj_t
																																																																																															BgL_proc1z00_15638;
																																																																																														obj_t
																																																																																															BgL_testz00_15637;
																																																																																														BgL_testz00_15637
																																																																																															=
																																																																																															BgL_arg2599z00_3033;
																																																																																														BgL_proc1z00_15638
																																																																																															=
																																																																																															BgL_carzd25915zd2_3028;
																																																																																														BgL_proc2z00_15639
																																																																																															=
																																																																																															BgL_carzd25924zd2_3030;
																																																																																														BgL_argsz00_15640
																																																																																															=
																																																																																															BgL_cdrzd25892zd2_3025;
																																																																																														BgL_argsz00_1800
																																																																																															=
																																																																																															BgL_argsz00_15640;
																																																																																														BgL_proc2z00_1799
																																																																																															=
																																																																																															BgL_proc2z00_15639;
																																																																																														BgL_proc1z00_1798
																																																																																															=
																																																																																															BgL_proc1z00_15638;
																																																																																														BgL_testz00_1797
																																																																																															=
																																																																																															BgL_testz00_15637;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1801;
																																																																																													}
																																																																																													BgL_auxz00_13657
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_15636);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1825;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15644;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1826;
																																																																																														BgL_auxz00_13657
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15644);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15648;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15648);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15652;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15652);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15656;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15656);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd26202zd2_3052;
																																																																															BgL_cdrzd26202zd2_3052
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd26209zd2_3053;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10305;
																																																																																	BgL_pairz00_10305
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd26209zd2_3053
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10305);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd26216zd2_3054;
																																																																																	BgL_cdrzd26216zd2_3054
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd26209zd2_3053));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26222zd2_3055;
																																																																																		obj_t
																																																																																			BgL_cdrzd26223zd2_3056;
																																																																																		BgL_carzd26222zd2_3055
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3054));
																																																																																		BgL_cdrzd26223zd2_3056
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3054));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26222zd2_3055))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd26230zd2_3058;
																																																																																				BgL_carzd26230zd2_3058
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd26223zd2_3056));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26230zd2_3058))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd26223zd2_3056))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26202zd2_3052))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2616z00_3063;
																																																																																										BgL_arg2616z00_3063
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd26209zd2_3053));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_15683;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_15687;
																																																																																												obj_t
																																																																																													BgL_proc2z00_15686;
																																																																																												obj_t
																																																																																													BgL_proc1z00_15685;
																																																																																												obj_t
																																																																																													BgL_testz00_15684;
																																																																																												BgL_testz00_15684
																																																																																													=
																																																																																													BgL_arg2616z00_3063;
																																																																																												BgL_proc1z00_15685
																																																																																													=
																																																																																													BgL_carzd26222zd2_3055;
																																																																																												BgL_proc2z00_15686
																																																																																													=
																																																																																													BgL_carzd26230zd2_3058;
																																																																																												BgL_argsz00_15687
																																																																																													=
																																																																																													BgL_cdrzd26202zd2_3052;
																																																																																												BgL_argsz00_1800
																																																																																													=
																																																																																													BgL_argsz00_15687;
																																																																																												BgL_proc2z00_1799
																																																																																													=
																																																																																													BgL_proc2z00_15686;
																																																																																												BgL_proc1z00_1798
																																																																																													=
																																																																																													BgL_proc1z00_15685;
																																																																																												BgL_testz00_1797
																																																																																													=
																																																																																													BgL_testz00_15684;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1801;
																																																																																											}
																																																																																											BgL_auxz00_13657
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_15683);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15691;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15691);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15695;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15695);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15699;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15699);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15703;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15703);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15707;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15707);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd26563zd2_3071;
																																																																											BgL_cdrzd26563zd2_3071
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd26569zd2_3072;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10314;
																																																																													BgL_pairz00_10314
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd26569zd2_3072
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10314);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd26575zd2_3073;
																																																																													BgL_cdrzd26575zd2_3073
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd26569zd2_3072));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd26580zd2_3074;
																																																																														obj_t
																																																																															BgL_cdrzd26581zd2_3075;
																																																																														BgL_carzd26580zd2_3074
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3073));
																																																																														BgL_cdrzd26581zd2_3075
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3073));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26580zd2_3074))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd26581zd2_3075))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26586zd2_3078;
																																																																																		BgL_carzd26586zd2_3078
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd26581zd2_3075);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26586zd2_3078))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd26581zd2_3075)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26563zd2_3071))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2630z00_3083;
																																																																																								BgL_arg2630z00_3083
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd26569zd2_3072));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15734;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_15738;
																																																																																										obj_t
																																																																																											BgL_proc2z00_15737;
																																																																																										obj_t
																																																																																											BgL_proc1z00_15736;
																																																																																										obj_t
																																																																																											BgL_testz00_15735;
																																																																																										BgL_testz00_15735
																																																																																											=
																																																																																											BgL_arg2630z00_3083;
																																																																																										BgL_proc1z00_15736
																																																																																											=
																																																																																											BgL_carzd26580zd2_3074;
																																																																																										BgL_proc2z00_15737
																																																																																											=
																																																																																											BgL_carzd26586zd2_3078;
																																																																																										BgL_argsz00_15738
																																																																																											=
																																																																																											BgL_cdrzd26563zd2_3071;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_15738;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_15737;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_15736;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_15735;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15734);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15742;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15742);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15746;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15746);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15750;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15750);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15754;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15754);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_15758;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_15758);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15762;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15762);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15766;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15766);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15770;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15770);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd27124zd2_3247;
																																															BgL_cdrzd27124zd2_3247
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd24059zd2_2970 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2762z00_3249;
																																																	obj_t
																																																		BgL_arg2763z00_3250;
																																																	BgL_arg2762z00_3249
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3247));
																																																	BgL_arg2763z00_3250
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3247));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_15781;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_15783;
																																																			obj_t
																																																				BgL_bindingsz00_15782;
																																																			BgL_bindingsz00_15782
																																																				=
																																																				BgL_arg2762z00_3249;
																																																			BgL_exprz00_15783
																																																				=
																																																				BgL_arg2763z00_3250;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_15783;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_15782;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_15781);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24059zd2_2970)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2766z00_3252;
																																																			obj_t
																																																				BgL_arg2767z00_3253;
																																																			BgL_arg2766z00_3252
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3247));
																																																			BgL_arg2767z00_3253
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3247));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_15792;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_15794;
																																																					obj_t
																																																						BgL_bindingsz00_15793;
																																																					BgL_bindingsz00_15793
																																																						=
																																																						BgL_arg2766z00_3252;
																																																					BgL_exprz00_15794
																																																						=
																																																						BgL_arg2767z00_3253;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_15794;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_15793;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_15792);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd24059zd2_2970 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2769z00_3255;
																																																					obj_t
																																																						BgL_arg2776z00_3256;
																																																					BgL_arg2769z00_3255
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3247));
																																																					BgL_arg2776z00_3256
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3247));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_15803;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_15805;
																																																							obj_t
																																																								BgL_bindingsz00_15804;
																																																							BgL_bindingsz00_15804
																																																								=
																																																								BgL_arg2769z00_3255;
																																																							BgL_exprz00_15805
																																																								=
																																																								BgL_arg2776z00_3256;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_15805;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_15804;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_15803);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_15812;
																																																							goto
																																																								BgL_tagzd2383zd2_1782;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_15812);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd27161zd2_3259;
																																																							BgL_carzd27161zd2_3259
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd27161zd2_3259 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_15819;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15819);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27161zd2_3259)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15824;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15824);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_15831;
																																																													goto
																																																														BgL_tagzd2389zd2_1802;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15831);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15838;
																																																															goto
																																																																BgL_tagzd2390zd2_1803;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15838);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27241zd2_3266;
																																																															BgL_cdrzd27241zd2_3266
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg2793z00_3269;
																																																																	obj_t
																																																																		BgL_arg2794z00_3270;
																																																																	BgL_arg2793z00_3269
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3266));
																																																																	BgL_arg2794z00_3270
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3266));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_15851;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_15853;
																																																																			obj_t
																																																																				BgL_effectz00_15852;
																																																																			BgL_effectz00_15852
																																																																				=
																																																																				BgL_arg2793z00_3269;
																																																																			BgL_restz00_15853
																																																																				=
																																																																				BgL_arg2794z00_3270;
																																																																			BgL_restz00_1805
																																																																				=
																																																																				BgL_restz00_15853;
																																																																			BgL_effectz00_1804
																																																																				=
																																																																				BgL_effectz00_15852;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1806;
																																																																		}
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_15851);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_15860;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1807;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_15860);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15867;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1808;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15867);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg2803z00_3278;
																																																																							obj_t
																																																																								BgL_arg2804z00_3279;
																																																																							BgL_arg2803z00_3278
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3266));
																																																																							BgL_arg2804z00_3279
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3266));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_15878;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_15880;
																																																																									obj_t
																																																																										BgL_effectz00_15879;
																																																																									BgL_effectz00_15879
																																																																										=
																																																																										BgL_arg2803z00_3278;
																																																																									BgL_restz00_15880
																																																																										=
																																																																										BgL_arg2804z00_3279;
																																																																									BgL_restz00_1810
																																																																										=
																																																																										BgL_restz00_15880;
																																																																									BgL_effectz00_1809
																																																																										=
																																																																										BgL_effectz00_15879;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1811;
																																																																								}
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_15878);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15887;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1812;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15887);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15894;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1813;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15894);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_15901;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1814;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15901);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_15908;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1815;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15908);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd27318zd2_3288;
																																																																															BgL_cdrzd27318zd2_3288
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2824z00_3291;
																																																																																	obj_t
																																																																																		BgL_arg2827z00_3292;
																																																																																	BgL_arg2824z00_3291
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3288));
																																																																																	BgL_arg2827z00_3292
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3288));
																																																																																	{	/* Ast/sexp.scm 555 */
																																																																																		obj_t
																																																																																			BgL_arg7023z00_10351;
																																																																																		BgL_arg7023z00_10351
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg2824z00_3291,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg2827z00_3292, BgL_stackz00_22, BgL_arg7023z00_10351, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15927;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15927);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd27343zd2_3309;
																																			BgL_carzd27343zd2_3309
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd27343zd2_3309
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_15934;
																																					goto
																																						BgL_tagzd2377zd2_1770;
																																					BgL_auxz00_13657
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_15934);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd27343zd2_3309
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15938;
																																							goto
																																								BgL_tagzd2377zd2_1770;
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15938);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15945;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15945);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15952;
																																											goto
																																												BgL_tagzd2380zd2_1775;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15952);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd27412zd2_3316;
																																											BgL_carzd27412zd2_3316
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd27412zd2_3316))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd27415zd2_3318;
																																													obj_t
																																														BgL_cdrzd27416zd2_3319;
																																													BgL_carzd27415zd2_3318
																																														=
																																														CAR
																																														(BgL_carzd27412zd2_3316);
																																													BgL_cdrzd27416zd2_3319
																																														=
																																														CDR
																																														(BgL_carzd27412zd2_3316);
																																													{

																																														if ((BgL_carzd27415zd2_3318 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd27417zd2_3320:
																																																if (PAIRP(BgL_cdrzd27416zd2_3319))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd27420zd2_3445;
																																																		BgL_cdrzd27420zd2_3445
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27416zd2_3319);
																																																		if (PAIRP(BgL_cdrzd27420zd2_3445))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd27420zd2_3445)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2974z00_3449;
																																																						obj_t
																																																							BgL_arg2976z00_3450;
																																																						BgL_arg2974z00_3449
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27420zd2_3445);
																																																						BgL_arg2976z00_3450
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_15974;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_15976;
																																																								obj_t
																																																									BgL_bodyz00_15975;
																																																								BgL_bodyz00_15975
																																																									=
																																																									BgL_arg2974z00_3449;
																																																								BgL_argsz00_15976
																																																									=
																																																									BgL_arg2976z00_3450;
																																																								BgL_argsz00_1777
																																																									=
																																																									BgL_argsz00_15976;
																																																								BgL_bodyz00_1776
																																																									=
																																																									BgL_bodyz00_15975;
																																																								goto
																																																									BgL_tagzd2381zd2_1778;
																																																							}
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_15974);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd27444zd2_3451;
																																																						BgL_cdrzd27444zd2_3451
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7859z00_15980;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3067z00_3562;
																																																								BgL_arg3067z00_3562
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7859z00_15980
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3067z00_3562));
																																																							}
																																																							if (BgL_test7859z00_15980)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2979z00_3454;
																																																									obj_t
																																																										BgL_arg2980z00_3455;
																																																									BgL_arg2979z00_3454
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3451));
																																																									BgL_arg2980z00_3455
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3451));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15989;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15991;
																																																											obj_t
																																																												BgL_bindingsz00_15990;
																																																											BgL_bindingsz00_15990
																																																												=
																																																												BgL_arg2979z00_3454;
																																																											BgL_exprz00_15991
																																																												=
																																																												BgL_arg2980z00_3455;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_15991;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_15990;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15989);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7860z00_15993;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3066z00_3561;
																																																										BgL_arg3066z00_3561
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7860z00_15993
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3066z00_3561));
																																																									}
																																																									if (BgL_test7860z00_15993)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15998;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15998);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd27511zd2_3458;
																																																											BgL_carzd27511zd2_3458
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd27516zd2_3459;
																																																												BgL_cdrzd27516zd2_3459
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd27511zd2_3458));
																																																												if ((CAR(((obj_t) BgL_carzd27511zd2_3458)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2986z00_3462;
																																																														obj_t
																																																															BgL_arg2987z00_3463;
																																																														obj_t
																																																															BgL_arg2988z00_3464;
																																																														BgL_arg2986z00_3462
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3459));
																																																														BgL_arg2987z00_3463
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3459));
																																																														BgL_arg2988z00_3464
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16015;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16018;
																																																																obj_t
																																																																	BgL_bodyz00_16017;
																																																																obj_t
																																																																	BgL_varsz00_16016;
																																																																BgL_varsz00_16016
																																																																	=
																																																																	BgL_arg2986z00_3462;
																																																																BgL_bodyz00_16017
																																																																	=
																																																																	BgL_arg2987z00_3463;
																																																																BgL_argsz00_16018
																																																																	=
																																																																	BgL_arg2988z00_3464;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_16018;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_16017;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_16016;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16015);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd27539zd2_3466;
																																																														BgL_cdrzd27539zd2_3466
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27545zd2_3467;
																																																															BgL_cdrzd27545zd2_3467
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd27511zd2_3458));
																																																															if ((CAR(((obj_t) BgL_carzd27511zd2_3458)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd27551zd2_3470;
																																																																	BgL_cdrzd27551zd2_3470
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27545zd2_3467));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd27556zd2_3471;
																																																																		obj_t
																																																																			BgL_cdrzd27557zd2_3472;
																																																																		BgL_carzd27556zd2_3471
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3470));
																																																																		BgL_cdrzd27557zd2_3472
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3470));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27556zd2_3471))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd27557zd2_3472))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd27564zd2_3475;
																																																																						BgL_carzd27564zd2_3475
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd27557zd2_3472);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27564zd2_3475))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd27557zd2_3472)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test7867z00_16045;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1380z00_3508;
																																																																											BgL_l1380z00_3508
																																																																												=
																																																																												BgL_cdrzd27539zd2_3466;
																																																																										BgL_zc3z04anonymousza33021ze3z87_3509:
																																																																											if (NULLP(BgL_l1380z00_3508))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test7867z00_16045
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test7869z00_16048;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test7870z00_16049;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_16050;
																																																																															BgL_tmpz00_16050
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1380z00_3508));
																																																																															BgL_test7870z00_16049
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_16050);
																																																																														}
																																																																														if (BgL_test7870z00_16049)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test7869z00_16048
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test7869z00_16048
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test7869z00_16048)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1380z00_16054;
																																																																															BgL_l1380z00_16054
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1380z00_3508));
																																																																															BgL_l1380z00_3508
																																																																																=
																																																																																BgL_l1380z00_16054;
																																																																															goto
																																																																																BgL_zc3z04anonymousza33021ze3z87_3509;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test7867z00_16045
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test7867z00_16045)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg3002z00_3491;
																																																																												BgL_arg3002z00_3491
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd27545zd2_3467));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16059;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_16063;
																																																																														obj_t
																																																																															BgL_proc2z00_16062;
																																																																														obj_t
																																																																															BgL_proc1z00_16061;
																																																																														obj_t
																																																																															BgL_testz00_16060;
																																																																														BgL_testz00_16060
																																																																															=
																																																																															BgL_arg3002z00_3491;
																																																																														BgL_proc1z00_16061
																																																																															=
																																																																															BgL_carzd27556zd2_3471;
																																																																														BgL_proc2z00_16062
																																																																															=
																																																																															BgL_carzd27564zd2_3475;
																																																																														BgL_argsz00_16063
																																																																															=
																																																																															BgL_cdrzd27539zd2_3466;
																																																																														BgL_argsz00_1795
																																																																															=
																																																																															BgL_argsz00_16063;
																																																																														BgL_proc2z00_1794
																																																																															=
																																																																															BgL_proc2z00_16062;
																																																																														BgL_proc1z00_1793
																																																																															=
																																																																															BgL_proc1z00_16061;
																																																																														BgL_testz00_1792
																																																																															=
																																																																															BgL_testz00_16060;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1796;
																																																																													}
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16059);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd27588zd2_3492;
																																																																												BgL_cdrzd27588zd2_3492
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd27595zd2_3493;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10387;
																																																																														BgL_pairz00_10387
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd27595zd2_3493
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10387);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd27602zd2_3494;
																																																																														BgL_cdrzd27602zd2_3494
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd27595zd2_3493));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd27608zd2_3495;
																																																																															BgL_carzd27608zd2_3495
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd27602zd2_3494));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27608zd2_3495))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd27615zd2_3497;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10391;
																																																																																		BgL_pairz00_10391
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd27602zd2_3494));
																																																																																		BgL_carzd27615zd2_3497
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_10391);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27615zd2_3497))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27588zd2_3492))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg3009z00_3500;
																																																																																					BgL_arg3009z00_3500
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd27595zd2_3493));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16085;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16089;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16088;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16087;
																																																																																							obj_t
																																																																																								BgL_testz00_16086;
																																																																																							BgL_testz00_16086
																																																																																								=
																																																																																								BgL_arg3009z00_3500;
																																																																																							BgL_proc1z00_16087
																																																																																								=
																																																																																								BgL_carzd27608zd2_3495;
																																																																																							BgL_proc2z00_16088
																																																																																								=
																																																																																								BgL_carzd27615zd2_3497;
																																																																																							BgL_argsz00_16089
																																																																																								=
																																																																																								BgL_cdrzd27588zd2_3492;
																																																																																							BgL_argsz00_1800
																																																																																								=
																																																																																								BgL_argsz00_16089;
																																																																																							BgL_proc2z00_1799
																																																																																								=
																																																																																								BgL_proc2z00_16088;
																																																																																							BgL_proc1z00_1798
																																																																																								=
																																																																																								BgL_proc1z00_16087;
																																																																																							BgL_testz00_1797
																																																																																								=
																																																																																								BgL_testz00_16086;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1801;
																																																																																						}
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16085);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16093;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16093);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16097;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16097);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16101;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16101);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_16105;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_16105);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd27891zd2_3519;
																																																																								BgL_cdrzd27891zd2_3519
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd27897zd2_3520;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10395;
																																																																										BgL_pairz00_10395
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd27897zd2_3520
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10395);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd27903zd2_3521;
																																																																										BgL_cdrzd27903zd2_3521
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd27897zd2_3520));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd27908zd2_3522;
																																																																											obj_t
																																																																												BgL_cdrzd27909zd2_3523;
																																																																											BgL_carzd27908zd2_3522
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3521));
																																																																											BgL_cdrzd27909zd2_3523
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3521));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27908zd2_3522))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd27914zd2_3525;
																																																																													BgL_carzd27914zd2_3525
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd27909zd2_3523));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27914zd2_3525))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd27909zd2_3523))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27891zd2_3519))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3031z00_3530;
																																																																																			BgL_arg3031z00_3530
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd27897zd2_3520));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16132;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16136;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16135;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16134;
																																																																																					obj_t
																																																																																						BgL_testz00_16133;
																																																																																					BgL_testz00_16133
																																																																																						=
																																																																																						BgL_arg3031z00_3530;
																																																																																					BgL_proc1z00_16134
																																																																																						=
																																																																																						BgL_carzd27908zd2_3522;
																																																																																					BgL_proc2z00_16135
																																																																																						=
																																																																																						BgL_carzd27914zd2_3525;
																																																																																					BgL_argsz00_16136
																																																																																						=
																																																																																						BgL_cdrzd27891zd2_3519;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_16136;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_16135;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_16134;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_16133;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16132);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16140;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16140);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16144;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16144);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16148;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16148);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16152;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16152);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16156;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16156);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd28247zd2_3538;
																																																																				BgL_cdrzd28247zd2_3538
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd28254zd2_3539;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10404;
																																																																						BgL_pairz00_10404
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd28254zd2_3539
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10404);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd28261zd2_3540;
																																																																						BgL_cdrzd28261zd2_3540
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd28254zd2_3539));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd28267zd2_3541;
																																																																							obj_t
																																																																								BgL_cdrzd28268zd2_3542;
																																																																							BgL_carzd28267zd2_3541
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3540));
																																																																							BgL_cdrzd28268zd2_3542
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3540));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28267zd2_3541))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd28268zd2_3542))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd28275zd2_3545;
																																																																											BgL_carzd28275zd2_3545
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd28268zd2_3542);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28275zd2_3545))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd28268zd2_3542)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd28247zd2_3538))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3045z00_3550;
																																																																																	BgL_arg3045z00_3550
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd28254zd2_3539));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16183;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16187;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16186;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16185;
																																																																																			obj_t
																																																																																				BgL_testz00_16184;
																																																																																			BgL_testz00_16184
																																																																																				=
																																																																																				BgL_arg3045z00_3550;
																																																																																			BgL_proc1z00_16185
																																																																																				=
																																																																																				BgL_carzd28267zd2_3541;
																																																																																			BgL_proc2z00_16186
																																																																																				=
																																																																																				BgL_carzd28275zd2_3545;
																																																																																			BgL_argsz00_16187
																																																																																				=
																																																																																				BgL_cdrzd28247zd2_3538;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_16187;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_16186;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_16185;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_16184;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16183);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16191;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16191);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16195;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16195);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16199;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16199);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16203;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16203);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16207;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16207);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16211;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16211);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd28668zd2_3564;
																																																				BgL_cdrzd28668zd2_3564
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test7898z00_16215;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3087z00_3581;
																																																						BgL_arg3087z00_3581
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test7898z00_16215
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3087z00_3581));
																																																					}
																																																					if (BgL_test7898z00_16215)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3073z00_3567;
																																																							obj_t
																																																								BgL_arg3076z00_3568;
																																																							BgL_arg3073z00_3567
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3564));
																																																							BgL_arg3076z00_3568
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3564));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16224;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16226;
																																																									obj_t
																																																										BgL_bindingsz00_16225;
																																																									BgL_bindingsz00_16225
																																																										=
																																																										BgL_arg3073z00_3567;
																																																									BgL_exprz00_16226
																																																										=
																																																										BgL_arg3076z00_3568;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_16226;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_16225;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16224);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7899z00_16228;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3086z00_3580;
																																																								BgL_arg3086z00_3580
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7899z00_16228
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3086z00_3580));
																																																							}
																																																							if (BgL_test7899z00_16228)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16233;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16233);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd28734zd2_3571;
																																																									BgL_carzd28734zd2_3571
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd28739zd2_3572;
																																																										BgL_cdrzd28739zd2_3572
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd28734zd2_3571));
																																																										if ((CAR(((obj_t) BgL_carzd28734zd2_3571)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3081z00_3575;
																																																												obj_t
																																																													BgL_arg3082z00_3576;
																																																												obj_t
																																																													BgL_arg3083z00_3577;
																																																												BgL_arg3081z00_3575
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3572));
																																																												BgL_arg3082z00_3576
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3572));
																																																												BgL_arg3083z00_3577
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16250;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16253;
																																																														obj_t
																																																															BgL_bodyz00_16252;
																																																														obj_t
																																																															BgL_varsz00_16251;
																																																														BgL_varsz00_16251
																																																															=
																																																															BgL_arg3081z00_3575;
																																																														BgL_bodyz00_16252
																																																															=
																																																															BgL_arg3082z00_3576;
																																																														BgL_argsz00_16253
																																																															=
																																																															BgL_arg3083z00_3577;
																																																														BgL_argsz00_1790
																																																															=
																																																															BgL_argsz00_16253;
																																																														BgL_bodyz00_1789
																																																															=
																																																															BgL_bodyz00_16252;
																																																														BgL_varsz00_1788
																																																															=
																																																															BgL_varsz00_16251;
																																																														goto
																																																															BgL_tagzd2386zd2_1791;
																																																													}
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16250);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16257;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16257);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd28850zd2_3582;
																																																		BgL_cdrzd28850zd2_3582
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test7902z00_16261;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3108z00_3591;
																																																				BgL_arg3108z00_3591
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test7902z00_16261
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3108z00_3591));
																																																			}
																																																			if (BgL_test7902z00_16261)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3091z00_3585;
																																																					obj_t
																																																						BgL_arg3092z00_3586;
																																																					BgL_arg3091z00_3585
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3582));
																																																					BgL_arg3092z00_3586
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3582));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16270;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16272;
																																																							obj_t
																																																								BgL_bindingsz00_16271;
																																																							BgL_bindingsz00_16271
																																																								=
																																																								BgL_arg3091z00_3585;
																																																							BgL_exprz00_16272
																																																								=
																																																								BgL_arg3092z00_3586;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_16272;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_16271;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16270);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test7903z00_16274;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3100z00_3590;
																																																						BgL_arg3100z00_3590
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test7903z00_16274
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3100z00_3590));
																																																					}
																																																					if (BgL_test7903z00_16274)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16279;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16279);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_16283;
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16283);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27415zd2_3318)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd27417zd2_3320;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd27415zd2_3318 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd27417zd2_3320;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd27415zd2_3318 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd27417zd2_3320;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27415zd2_3318)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd27417zd2_3320;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd29022zd2_3326;
																																																								BgL_cdrzd29022zd2_3326
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test7909z00_16299;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2967z00_3443;
																																																										BgL_arg2967z00_3443
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test7909z00_16299
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2967z00_3443));
																																																									}
																																																									if (BgL_test7909z00_16299)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2868z00_3329;
																																																											obj_t
																																																												BgL_arg2869z00_3330;
																																																											BgL_arg2868z00_3329
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3326));
																																																											BgL_arg2869z00_3330
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3326));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_16308;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_16310;
																																																													obj_t
																																																														BgL_bindingsz00_16309;
																																																													BgL_bindingsz00_16309
																																																														=
																																																														BgL_arg2868z00_3329;
																																																													BgL_exprz00_16310
																																																														=
																																																														BgL_arg2869z00_3330;
																																																													BgL_exprz00_1780
																																																														=
																																																														BgL_exprz00_16310;
																																																													BgL_bindingsz00_1779
																																																														=
																																																														BgL_bindingsz00_16309;
																																																													goto
																																																														BgL_tagzd2382zd2_1781;
																																																												}
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_16308);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test7910z00_16312;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2966z00_3442;
																																																												BgL_arg2966z00_3442
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test7910z00_16312
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2966z00_3442));
																																																											}
																																																											if (BgL_test7910z00_16312)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_16317;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16317);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd29088zd2_3333;
																																																													BgL_carzd29088zd2_3333
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd29093zd2_3334;
																																																														BgL_cdrzd29093zd2_3334
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd29088zd2_3333));
																																																														if ((CAR(((obj_t) BgL_carzd29088zd2_3333)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd29093zd2_3334))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2876z00_3338;
																																																																		obj_t
																																																																			BgL_arg2877z00_3339;
																																																																		obj_t
																																																																			BgL_arg2878z00_3340;
																																																																		BgL_arg2876z00_3338
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd29093zd2_3334);
																																																																		BgL_arg2877z00_3339
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd29093zd2_3334);
																																																																		BgL_arg2878z00_3340
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16334;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_16337;
																																																																				obj_t
																																																																					BgL_bodyz00_16336;
																																																																				obj_t
																																																																					BgL_varsz00_16335;
																																																																				BgL_varsz00_16335
																																																																					=
																																																																					BgL_arg2876z00_3338;
																																																																				BgL_bodyz00_16336
																																																																					=
																																																																					BgL_arg2877z00_3339;
																																																																				BgL_argsz00_16337
																																																																					=
																																																																					BgL_arg2878z00_3340;
																																																																				BgL_argsz00_1790
																																																																					=
																																																																					BgL_argsz00_16337;
																																																																				BgL_bodyz00_1789
																																																																					=
																																																																					BgL_bodyz00_16336;
																																																																				BgL_varsz00_1788
																																																																					=
																																																																					BgL_varsz00_16335;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1791;
																																																																			}
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16334);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_16341;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_16341);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd29200zd2_3343;
																																																																BgL_cdrzd29200zd2_3343
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd29205zd2_3344;
																																																																	BgL_cdrzd29205zd2_3344
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd29088zd2_3333));
																																																																	if ((CAR(((obj_t) BgL_carzd29088zd2_3333)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd29205zd2_3344))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd29210zd2_3348;
																																																																					BgL_cdrzd29210zd2_3348
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd29205zd2_3344);
																																																																					if (PAIRP(BgL_cdrzd29210zd2_3348))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd29214zd2_3350;
																																																																							obj_t
																																																																								BgL_cdrzd29215zd2_3351;
																																																																							BgL_carzd29214zd2_3350
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd29210zd2_3348);
																																																																							BgL_cdrzd29215zd2_3351
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd29210zd2_3348);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29214zd2_3350))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd29215zd2_3351))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd29220zd2_3354;
																																																																											BgL_carzd29220zd2_3354
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd29215zd2_3351);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29220zd2_3354))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd29215zd2_3351)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test7921z00_16369;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1383z00_3387;
																																																																																BgL_l1383z00_3387
																																																																																	=
																																																																																	BgL_cdrzd29200zd2_3343;
																																																																															BgL_zc3z04anonymousza32922ze3z87_3388:
																																																																																if (NULLP(BgL_l1383z00_3387))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test7921z00_16369
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test7923z00_16372;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test7924z00_16373;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_16374;
																																																																																				BgL_tmpz00_16374
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1383z00_3387));
																																																																																				BgL_test7924z00_16373
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_16374);
																																																																																			}
																																																																																			if (BgL_test7924z00_16373)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test7923z00_16372
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test7923z00_16372
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test7923z00_16372)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1383z00_16378;
																																																																																				BgL_l1383z00_16378
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1383z00_3387));
																																																																																				BgL_l1383z00_3387
																																																																																					=
																																																																																					BgL_l1383z00_16378;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza32922ze3z87_3388;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test7921z00_16369
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test7921z00_16369)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2896z00_3370;
																																																																																	BgL_arg2896z00_3370
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd29205zd2_3344);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16382;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16386;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16385;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16384;
																																																																																			obj_t
																																																																																				BgL_testz00_16383;
																																																																																			BgL_testz00_16383
																																																																																				=
																																																																																				BgL_arg2896z00_3370;
																																																																																			BgL_proc1z00_16384
																																																																																				=
																																																																																				BgL_carzd29214zd2_3350;
																																																																																			BgL_proc2z00_16385
																																																																																				=
																																																																																				BgL_carzd29220zd2_3354;
																																																																																			BgL_argsz00_16386
																																																																																				=
																																																																																				BgL_cdrzd29200zd2_3343;
																																																																																			BgL_argsz00_1795
																																																																																				=
																																																																																				BgL_argsz00_16386;
																																																																																			BgL_proc2z00_1794
																																																																																				=
																																																																																				BgL_proc2z00_16385;
																																																																																			BgL_proc1z00_1793
																																																																																				=
																																																																																				BgL_proc1z00_16384;
																																																																																			BgL_testz00_1792
																																																																																				=
																																																																																				BgL_testz00_16383;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1796;
																																																																																		}
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16382);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd29245zd2_3371;
																																																																																	BgL_cdrzd29245zd2_3371
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd29253zd2_3372;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10452;
																																																																																			BgL_pairz00_10452
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd29253zd2_3372
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10452);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd29261zd2_3373;
																																																																																			BgL_cdrzd29261zd2_3373
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd29253zd2_3372));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd29268zd2_3374;
																																																																																				BgL_carzd29268zd2_3374
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd29261zd2_3373));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29268zd2_3374))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd29277zd2_3376;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10456;
																																																																																							BgL_pairz00_10456
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd29261zd2_3373));
																																																																																							BgL_carzd29277zd2_3376
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_10456);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29277zd2_3376))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29245zd2_3371))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2900z00_3379;
																																																																																										BgL_arg2900z00_3379
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd29253zd2_3372));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16408;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16412;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16411;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16410;
																																																																																												obj_t
																																																																																													BgL_testz00_16409;
																																																																																												BgL_testz00_16409
																																																																																													=
																																																																																													BgL_arg2900z00_3379;
																																																																																												BgL_proc1z00_16410
																																																																																													=
																																																																																													BgL_carzd29268zd2_3374;
																																																																																												BgL_proc2z00_16411
																																																																																													=
																																																																																													BgL_carzd29277zd2_3376;
																																																																																												BgL_argsz00_16412
																																																																																													=
																																																																																													BgL_cdrzd29245zd2_3371;
																																																																																												BgL_argsz00_1800
																																																																																													=
																																																																																													BgL_argsz00_16412;
																																																																																												BgL_proc2z00_1799
																																																																																													=
																																																																																													BgL_proc2z00_16411;
																																																																																												BgL_proc1z00_1798
																																																																																													=
																																																																																													BgL_proc1z00_16410;
																																																																																												BgL_testz00_1797
																																																																																													=
																																																																																													BgL_testz00_16409;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1801;
																																																																																											}
																																																																																											BgL_auxz00_13657
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16408);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16416;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_13657
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16416);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16420;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16420);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16424;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16424);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16428;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16428);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd29555zd2_3398;
																																																																													BgL_cdrzd29555zd2_3398
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd29562zd2_3399;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10460;
																																																																															BgL_pairz00_10460
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd29562zd2_3399
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10460);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd29569zd2_3400;
																																																																															BgL_cdrzd29569zd2_3400
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd29562zd2_3399));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29575zd2_3401;
																																																																																obj_t
																																																																																	BgL_cdrzd29576zd2_3402;
																																																																																BgL_carzd29575zd2_3401
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3400));
																																																																																BgL_cdrzd29576zd2_3402
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3400));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29575zd2_3401))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd29583zd2_3404;
																																																																																		BgL_carzd29583zd2_3404
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd29576zd2_3402));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29583zd2_3404))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd29576zd2_3402))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29555zd2_3398))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2932z00_3409;
																																																																																								BgL_arg2932z00_3409
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd29562zd2_3399));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16455;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16459;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16458;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16457;
																																																																																										obj_t
																																																																																											BgL_testz00_16456;
																																																																																										BgL_testz00_16456
																																																																																											=
																																																																																											BgL_arg2932z00_3409;
																																																																																										BgL_proc1z00_16457
																																																																																											=
																																																																																											BgL_carzd29575zd2_3401;
																																																																																										BgL_proc2z00_16458
																																																																																											=
																																																																																											BgL_carzd29583zd2_3404;
																																																																																										BgL_argsz00_16459
																																																																																											=
																																																																																											BgL_cdrzd29555zd2_3398;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_16459;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_16458;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_16457;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_16456;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16455);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16463;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16463);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16467;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16467);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16471;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16471);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16475;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16475);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16479;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16479);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd29916zd2_3417;
																																																																									BgL_cdrzd29916zd2_3417
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd29922zd2_3418;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10469;
																																																																											BgL_pairz00_10469
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd29922zd2_3418
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10469);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd29928zd2_3419;
																																																																											BgL_cdrzd29928zd2_3419
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd29922zd2_3418));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd29933zd2_3420;
																																																																												obj_t
																																																																													BgL_cdrzd29934zd2_3421;
																																																																												BgL_carzd29933zd2_3420
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3419));
																																																																												BgL_cdrzd29934zd2_3421
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3419));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29933zd2_3420))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd29934zd2_3421))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29939zd2_3424;
																																																																																BgL_carzd29939zd2_3424
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd29934zd2_3421);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29939zd2_3424))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd29934zd2_3421)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29916zd2_3417))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg2952z00_3429;
																																																																																						BgL_arg2952z00_3429
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd29922zd2_3418));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16506;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_16510;
																																																																																								obj_t
																																																																																									BgL_proc2z00_16509;
																																																																																								obj_t
																																																																																									BgL_proc1z00_16508;
																																																																																								obj_t
																																																																																									BgL_testz00_16507;
																																																																																								BgL_testz00_16507
																																																																																									=
																																																																																									BgL_arg2952z00_3429;
																																																																																								BgL_proc1z00_16508
																																																																																									=
																																																																																									BgL_carzd29933zd2_3420;
																																																																																								BgL_proc2z00_16509
																																																																																									=
																																																																																									BgL_carzd29939zd2_3424;
																																																																																								BgL_argsz00_16510
																																																																																									=
																																																																																									BgL_cdrzd29916zd2_3417;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_16510;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_16509;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_16508;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_16507;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16506);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16514;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16514);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16518;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16518);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16522;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16522);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16526;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16526);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_16530;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_16530);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16534;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16534);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16538;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16538);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16542;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16542);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd210477zd2_3593;
																																													BgL_cdrzd210477zd2_3593
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd27412zd2_3316 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3110z00_3595;
																																															obj_t
																																																BgL_arg3112z00_3596;
																																															BgL_arg3110z00_3595
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3593));
																																															BgL_arg3112z00_3596
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3593));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_16553;
																																																{
																																																	obj_t
																																																		BgL_exprz00_16555;
																																																	obj_t
																																																		BgL_bindingsz00_16554;
																																																	BgL_bindingsz00_16554
																																																		=
																																																		BgL_arg3110z00_3595;
																																																	BgL_exprz00_16555
																																																		=
																																																		BgL_arg3112z00_3596;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_16555;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_16554;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_13657
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_16553);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27412zd2_3316)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3115z00_3598;
																																																	obj_t
																																																		BgL_arg3116z00_3599;
																																																	BgL_arg3115z00_3598
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3593));
																																																	BgL_arg3116z00_3599
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3593));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_16564;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_16566;
																																																			obj_t
																																																				BgL_bindingsz00_16565;
																																																			BgL_bindingsz00_16565
																																																				=
																																																				BgL_arg3115z00_3598;
																																																			BgL_exprz00_16566
																																																				=
																																																				BgL_arg3116z00_3599;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_16566;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_16565;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_16564);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd27412zd2_3316 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3118z00_3601;
																																																			obj_t
																																																				BgL_arg3119z00_3602;
																																																			BgL_arg3118z00_3601
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3593));
																																																			BgL_arg3119z00_3602
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3593));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_16575;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_16577;
																																																					obj_t
																																																						BgL_bindingsz00_16576;
																																																					BgL_bindingsz00_16576
																																																						=
																																																						BgL_arg3118z00_3601;
																																																					BgL_exprz00_16577
																																																						=
																																																						BgL_arg3119z00_3602;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_16577;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_16576;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_16575);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_16584;
																																																					goto
																																																						BgL_tagzd2383zd2_1782;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_16584);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd210514zd2_3605;
																																																					BgL_carzd210514zd2_3605
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd210514zd2_3605 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16591;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16591);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210514zd2_3605)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16596;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16596);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_16603;
																																																											goto
																																																												BgL_tagzd2389zd2_1802;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16603);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16610;
																																																													goto
																																																														BgL_tagzd2390zd2_1803;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16610);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210594zd2_3612;
																																																													BgL_cdrzd210594zd2_3612
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3132z00_3615;
																																																															obj_t
																																																																BgL_arg3137z00_3616;
																																																															BgL_arg3132z00_3615
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3612));
																																																															BgL_arg3137z00_3616
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3612));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_16623;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_16625;
																																																																	obj_t
																																																																		BgL_effectz00_16624;
																																																																	BgL_effectz00_16624
																																																																		=
																																																																		BgL_arg3132z00_3615;
																																																																	BgL_restz00_16625
																																																																		=
																																																																		BgL_arg3137z00_3616;
																																																																	BgL_restz00_1805
																																																																		=
																																																																		BgL_restz00_16625;
																																																																	BgL_effectz00_1804
																																																																		=
																																																																		BgL_effectz00_16624;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1806;
																																																																}
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_16623);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_16632;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1807;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_16632);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16639;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1808;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16639);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3147z00_3624;
																																																																					obj_t
																																																																						BgL_arg3148z00_3625;
																																																																					BgL_arg3147z00_3624
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3612));
																																																																					BgL_arg3148z00_3625
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3612));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16650;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_16652;
																																																																							obj_t
																																																																								BgL_effectz00_16651;
																																																																							BgL_effectz00_16651
																																																																								=
																																																																								BgL_arg3147z00_3624;
																																																																							BgL_restz00_16652
																																																																								=
																																																																								BgL_arg3148z00_3625;
																																																																							BgL_restz00_1810
																																																																								=
																																																																								BgL_restz00_16652;
																																																																							BgL_effectz00_1809
																																																																								=
																																																																								BgL_effectz00_16651;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1811;
																																																																						}
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16650);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16659;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1812;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16659);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16666;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1813;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16666);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_16673;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1814;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16673);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_16680;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1815;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16680);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd210671zd2_3634;
																																																																													BgL_cdrzd210671zd2_3634
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3162z00_3637;
																																																																															obj_t
																																																																																BgL_arg3168z00_3638;
																																																																															BgL_arg3162z00_3637
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3634));
																																																																															BgL_arg3168z00_3638
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3634));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7023z00_10506;
																																																																																BgL_arg7023z00_10506
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3162z00_3637,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3168z00_3638, BgL_stackz00_22, BgL_arg7023z00_10506, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16699;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16699);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd210696zd2_3655;
																																	BgL_carzd210696zd2_3655
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd210696zd2_3655
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_16706;
																																			goto
																																				BgL_tagzd2377zd2_1770;
																																			BgL_auxz00_13657
																																				=
																																				((obj_t)
																																				BgL_auxz00_16706);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd210696zd2_3655
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_16710;
																																					goto
																																						BgL_tagzd2377zd2_1770;
																																					BgL_auxz00_13657
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_16710);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd210718zd2_3658;
																																					BgL_cdrzd210718zd2_3658
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd210721zd2_3661;
																																							obj_t
																																								BgL_cdrzd210722zd2_3662;
																																							BgL_carzd210721zd2_3661
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3658));
																																							BgL_cdrzd210722zd2_3662
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3658));
																																							if (PAIRP(BgL_carzd210721zd2_3661))
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_carzd210721zd2_3661) == CNST_TABLE_REF(((long) 14))))
																																										{	/* Ast/sexp.scm 119 */
																																											if (NULLP(CDR(((obj_t) BgL_cdrzd210722zd2_3662))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3203z00_3668;
																																													obj_t
																																														BgL_arg3204z00_3669;
																																													BgL_arg3203z00_3668
																																														=
																																														CDR
																																														(BgL_carzd210721zd2_3661);
																																													BgL_arg3204z00_3669
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210722zd2_3662));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_16736;
																																														BgL_lz00_1771
																																															=
																																															BgL_arg3203z00_3668;
																																														BgL_valz00_1772
																																															=
																																															BgL_arg3204z00_3669;
																																													BgL_tagzd2378zd2_1773:
																																														{	/* Ast/sexp.scm 289 */
																																															bool_t
																																																BgL_test7978z00_16737;
																																															if (PAIRP(BgL_lz00_1771))
																																																{	/* Ast/sexp.scm 289 */
																																																	bool_t
																																																		BgL_test7980z00_16740;
																																																	{	/* Ast/sexp.scm 289 */
																																																		obj_t
																																																			BgL_tmpz00_16741;
																																																		BgL_tmpz00_16741
																																																			=
																																																			CDR
																																																			(BgL_lz00_1771);
																																																		BgL_test7980z00_16740
																																																			=
																																																			PAIRP
																																																			(BgL_tmpz00_16741);
																																																	}
																																																	if (BgL_test7980z00_16740)
																																																		{
																																																			obj_t
																																																				BgL_l1352z00_8629;
																																																			BgL_l1352z00_8629
																																																				=
																																																				BgL_lz00_1771;
																																																		BgL_zc3z04anonymousza36776ze3z87_8630:
																																																			if (NULLP(BgL_l1352z00_8629))
																																																				{	/* Ast/sexp.scm 289 */
																																																					BgL_test7978z00_16737
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 289 */
																																																					bool_t
																																																						BgL_test7982z00_16746;
																																																					{	/* Ast/sexp.scm 289 */
																																																						obj_t
																																																							BgL_tmpz00_16747;
																																																						BgL_tmpz00_16747
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_l1352z00_8629));
																																																						BgL_test7982z00_16746
																																																							=
																																																							SYMBOLP
																																																							(BgL_tmpz00_16747);
																																																					}
																																																					if (BgL_test7982z00_16746)
																																																						{
																																																							obj_t
																																																								BgL_l1352z00_16751;
																																																							BgL_l1352z00_16751
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_l1352z00_8629));
																																																							BgL_l1352z00_8629
																																																								=
																																																								BgL_l1352z00_16751;
																																																							goto
																																																								BgL_zc3z04anonymousza36776ze3z87_8630;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 289 */
																																																							BgL_test7978z00_16737
																																																								=
																																																								(
																																																								(bool_t)
																																																								0);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 289 */
																																																			BgL_test7978z00_16737
																																																				=
																																																				(
																																																				(bool_t)
																																																				0);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 289 */
																																																	BgL_test7978z00_16737
																																																		=
																																																		(
																																																		(bool_t)
																																																		0);
																																																}
																																															if (BgL_test7978z00_16737)
																																																{	/* Ast/sexp.scm 289 */
																																																	BgL_auxz00_16736
																																																		=
																																																		BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																																		(BgL_lz00_1771,
																																																		BgL_valz00_1772,
																																																		BgL_expz00_21,
																																																		BgL_stackz00_22,
																																																		BgL_locz00_23,
																																																		BgL_sitez00_24);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 291 */
																																																	BgL_nodez00_bglt
																																																		BgL_res7368z00_9807;
																																																	{	/* Ast/sexp.scm 726 */
																																																		obj_t
																																																			BgL_arg7138z00_9803;
																																																		BgL_nodez00_bglt
																																																			BgL_arg7139z00_9804;
																																																		BgL_arg7138z00_9803
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg7139z00_9804
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 725 */
																																																			obj_t
																																																				BgL_list7140z00_9806;
																																																			BgL_list7140z00_9806
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_arg7139z00_9804), BNIL);
																																																			BgL_res7368z00_9807
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_23,
																																																					BgL_arg7138z00_9803,
																																																					BGl_string7406z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list7140z00_9806));
																																																	}}
																																																	BgL_auxz00_16736
																																																		=
																																																		BgL_res7368z00_9807;
																																														}}
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_16736);
																																												}}
																																											else
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_16765;
																																													goto
																																														BgL_tagzd2379zd2_1774;
																																													BgL_auxz00_13657
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_16765);
																																												}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_16767;
																																											goto
																																												BgL_tagzd2379zd2_1774;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_16767);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16769;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16769);
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16776;
																																									goto
																																										BgL_tagzd2380zd2_1775;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16776);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd210819zd2_3674;
																																									BgL_carzd210819zd2_3674
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd210819zd2_3674))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd210822zd2_3676;
																																											obj_t
																																												BgL_cdrzd210823zd2_3677;
																																											BgL_carzd210822zd2_3676
																																												=
																																												CAR
																																												(BgL_carzd210819zd2_3674);
																																											BgL_cdrzd210823zd2_3677
																																												=
																																												CDR
																																												(BgL_carzd210819zd2_3674);
																																											{

																																												if ((BgL_carzd210822zd2_3676 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd210824zd2_3678:
																																														if (PAIRP(BgL_cdrzd210823zd2_3677))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd210827zd2_3803;
																																																BgL_cdrzd210827zd2_3803
																																																	=
																																																	CDR
																																																	(BgL_cdrzd210823zd2_3677);
																																																if (PAIRP(BgL_cdrzd210827zd2_3803))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd210827zd2_3803)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3325z00_3807;
																																																				obj_t
																																																					BgL_arg3326z00_3808;
																																																				BgL_arg3325z00_3807
																																																					=
																																																					CAR
																																																					(BgL_cdrzd210827zd2_3803);
																																																				BgL_arg3326z00_3808
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_16798;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_16800;
																																																						obj_t
																																																							BgL_bodyz00_16799;
																																																						BgL_bodyz00_16799
																																																							=
																																																							BgL_arg3325z00_3807;
																																																						BgL_argsz00_16800
																																																							=
																																																							BgL_arg3326z00_3808;
																																																						BgL_argsz00_1777
																																																							=
																																																							BgL_argsz00_16800;
																																																						BgL_bodyz00_1776
																																																							=
																																																							BgL_bodyz00_16799;
																																																						goto
																																																							BgL_tagzd2381zd2_1778;
																																																					}
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_16798);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd210851zd2_3809;
																																																				BgL_cdrzd210851zd2_3809
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test7989z00_16804;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3421z00_3920;
																																																						BgL_arg3421z00_3920
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test7989z00_16804
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3421z00_3920));
																																																					}
																																																					if (BgL_test7989z00_16804)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3332z00_3812;
																																																							obj_t
																																																								BgL_arg3333z00_3813;
																																																							BgL_arg3332z00_3812
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3809));
																																																							BgL_arg3333z00_3813
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3809));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16813;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16815;
																																																									obj_t
																																																										BgL_bindingsz00_16814;
																																																									BgL_bindingsz00_16814
																																																										=
																																																										BgL_arg3332z00_3812;
																																																									BgL_exprz00_16815
																																																										=
																																																										BgL_arg3333z00_3813;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_16815;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_16814;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16813);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test7990z00_16817;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3420z00_3919;
																																																								BgL_arg3420z00_3919
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test7990z00_16817
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3420z00_3919));
																																																							}
																																																							if (BgL_test7990z00_16817)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16822;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16822);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd210918zd2_3816;
																																																									BgL_carzd210918zd2_3816
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd210923zd2_3817;
																																																										BgL_cdrzd210923zd2_3817
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd210918zd2_3816));
																																																										if ((CAR(((obj_t) BgL_carzd210918zd2_3816)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3340z00_3820;
																																																												obj_t
																																																													BgL_arg3341z00_3821;
																																																												obj_t
																																																													BgL_arg3344z00_3822;
																																																												BgL_arg3340z00_3820
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3817));
																																																												BgL_arg3341z00_3821
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3817));
																																																												BgL_arg3344z00_3822
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16839;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16842;
																																																														obj_t
																																																															BgL_bodyz00_16841;
																																																														obj_t
																																																															BgL_varsz00_16840;
																																																														BgL_varsz00_16840
																																																															=
																																																															BgL_arg3340z00_3820;
																																																														BgL_bodyz00_16841
																																																															=
																																																															BgL_arg3341z00_3821;
																																																														BgL_argsz00_16842
																																																															=
																																																															BgL_arg3344z00_3822;
																																																														BgL_argsz00_1790
																																																															=
																																																															BgL_argsz00_16842;
																																																														BgL_bodyz00_1789
																																																															=
																																																															BgL_bodyz00_16841;
																																																														BgL_varsz00_1788
																																																															=
																																																															BgL_varsz00_16840;
																																																														goto
																																																															BgL_tagzd2386zd2_1791;
																																																													}
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16839);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd210946zd2_3824;
																																																												BgL_cdrzd210946zd2_3824
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210952zd2_3825;
																																																													BgL_cdrzd210952zd2_3825
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd210918zd2_3816));
																																																													if ((CAR(((obj_t) BgL_carzd210918zd2_3816)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd210958zd2_3828;
																																																															BgL_cdrzd210958zd2_3828
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210952zd2_3825));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd210963zd2_3829;
																																																																obj_t
																																																																	BgL_cdrzd210964zd2_3830;
																																																																BgL_carzd210963zd2_3829
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3828));
																																																																BgL_cdrzd210964zd2_3830
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3828));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210963zd2_3829))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd210964zd2_3830))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd210971zd2_3833;
																																																																				BgL_carzd210971zd2_3833
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd210964zd2_3830);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210971zd2_3833))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd210964zd2_3830)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test7997z00_16869;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1386z00_3866;
																																																																									BgL_l1386z00_3866
																																																																										=
																																																																										BgL_cdrzd210946zd2_3824;
																																																																								BgL_zc3z04anonymousza33380ze3z87_3867:
																																																																									if (NULLP(BgL_l1386z00_3866))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test7997z00_16869
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test7999z00_16872;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8000z00_16873;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_16874;
																																																																													BgL_tmpz00_16874
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1386z00_3866));
																																																																													BgL_test8000z00_16873
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_16874);
																																																																												}
																																																																												if (BgL_test8000z00_16873)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test7999z00_16872
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test7999z00_16872
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test7999z00_16872)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1386z00_16878;
																																																																													BgL_l1386z00_16878
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1386z00_3866));
																																																																													BgL_l1386z00_3866
																																																																														=
																																																																														BgL_l1386z00_16878;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33380ze3z87_3867;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test7997z00_16869
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test7997z00_16869)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3357z00_3849;
																																																																										BgL_arg3357z00_3849
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd210952zd2_3825));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16883;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_16887;
																																																																												obj_t
																																																																													BgL_proc2z00_16886;
																																																																												obj_t
																																																																													BgL_proc1z00_16885;
																																																																												obj_t
																																																																													BgL_testz00_16884;
																																																																												BgL_testz00_16884
																																																																													=
																																																																													BgL_arg3357z00_3849;
																																																																												BgL_proc1z00_16885
																																																																													=
																																																																													BgL_carzd210963zd2_3829;
																																																																												BgL_proc2z00_16886
																																																																													=
																																																																													BgL_carzd210971zd2_3833;
																																																																												BgL_argsz00_16887
																																																																													=
																																																																													BgL_cdrzd210946zd2_3824;
																																																																												BgL_argsz00_1795
																																																																													=
																																																																													BgL_argsz00_16887;
																																																																												BgL_proc2z00_1794
																																																																													=
																																																																													BgL_proc2z00_16886;
																																																																												BgL_proc1z00_1793
																																																																													=
																																																																													BgL_proc1z00_16885;
																																																																												BgL_testz00_1792
																																																																													=
																																																																													BgL_testz00_16884;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1796;
																																																																											}
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16883);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd210995zd2_3850;
																																																																										BgL_cdrzd210995zd2_3850
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd211002zd2_3851;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10549;
																																																																												BgL_pairz00_10549
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd211002zd2_3851
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10549);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd211009zd2_3852;
																																																																												BgL_cdrzd211009zd2_3852
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd211002zd2_3851));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd211015zd2_3853;
																																																																													BgL_carzd211015zd2_3853
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd211009zd2_3852));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211015zd2_3853))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd211022zd2_3855;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10553;
																																																																																BgL_pairz00_10553
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd211009zd2_3852));
																																																																																BgL_carzd211022zd2_3855
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_10553);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211022zd2_3855))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd210995zd2_3850))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3361z00_3858;
																																																																																			BgL_arg3361z00_3858
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd211002zd2_3851));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16909;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16913;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16912;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16911;
																																																																																					obj_t
																																																																																						BgL_testz00_16910;
																																																																																					BgL_testz00_16910
																																																																																						=
																																																																																						BgL_arg3361z00_3858;
																																																																																					BgL_proc1z00_16911
																																																																																						=
																																																																																						BgL_carzd211015zd2_3853;
																																																																																					BgL_proc2z00_16912
																																																																																						=
																																																																																						BgL_carzd211022zd2_3855;
																																																																																					BgL_argsz00_16913
																																																																																						=
																																																																																						BgL_cdrzd210995zd2_3850;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_16913;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_16912;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_16911;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_16910;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16909);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16917;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16917);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16921;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16921);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16925;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16925);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_16929;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_16929);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd211298zd2_3877;
																																																																						BgL_cdrzd211298zd2_3877
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd211304zd2_3878;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10557;
																																																																								BgL_pairz00_10557
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd211304zd2_3878
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10557);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd211310zd2_3879;
																																																																								BgL_cdrzd211310zd2_3879
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd211304zd2_3878));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211315zd2_3880;
																																																																									obj_t
																																																																										BgL_cdrzd211316zd2_3881;
																																																																									BgL_carzd211315zd2_3880
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3879));
																																																																									BgL_cdrzd211316zd2_3881
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3879));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211315zd2_3880))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd211321zd2_3883;
																																																																											BgL_carzd211321zd2_3883
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd211316zd2_3881));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211321zd2_3883))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd211316zd2_3881))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211298zd2_3877))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3391z00_3888;
																																																																																	BgL_arg3391z00_3888
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd211304zd2_3878));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16956;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16960;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16959;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16958;
																																																																																			obj_t
																																																																																				BgL_testz00_16957;
																																																																																			BgL_testz00_16957
																																																																																				=
																																																																																				BgL_arg3391z00_3888;
																																																																																			BgL_proc1z00_16958
																																																																																				=
																																																																																				BgL_carzd211315zd2_3880;
																																																																																			BgL_proc2z00_16959
																																																																																				=
																																																																																				BgL_carzd211321zd2_3883;
																																																																																			BgL_argsz00_16960
																																																																																				=
																																																																																				BgL_cdrzd211298zd2_3877;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_16960;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_16959;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_16958;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_16957;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16956);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16964;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16964);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16968;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16968);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16972;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16972);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16976;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16976);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16980;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16980);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd211654zd2_3896;
																																																																		BgL_cdrzd211654zd2_3896
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd211661zd2_3897;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_10566;
																																																																				BgL_pairz00_10566
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd211661zd2_3897
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10566);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd211668zd2_3898;
																																																																				BgL_cdrzd211668zd2_3898
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd211661zd2_3897));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd211674zd2_3899;
																																																																					obj_t
																																																																						BgL_cdrzd211675zd2_3900;
																																																																					BgL_carzd211674zd2_3899
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3898));
																																																																					BgL_cdrzd211675zd2_3900
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3898));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211674zd2_3899))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd211675zd2_3900))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211682zd2_3903;
																																																																									BgL_carzd211682zd2_3903
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd211675zd2_3900);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211682zd2_3903))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd211675zd2_3900)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211654zd2_3896))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3406z00_3908;
																																																																															BgL_arg3406z00_3908
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd211661zd2_3897));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17007;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17011;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17010;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17009;
																																																																																	obj_t
																																																																																		BgL_testz00_17008;
																																																																																	BgL_testz00_17008
																																																																																		=
																																																																																		BgL_arg3406z00_3908;
																																																																																	BgL_proc1z00_17009
																																																																																		=
																																																																																		BgL_carzd211674zd2_3899;
																																																																																	BgL_proc2z00_17010
																																																																																		=
																																																																																		BgL_carzd211682zd2_3903;
																																																																																	BgL_argsz00_17011
																																																																																		=
																																																																																		BgL_cdrzd211654zd2_3896;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_17011;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_17010;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_17009;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_17008;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17007);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17015;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17015);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17019;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17019);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17023;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17023);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17027;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17027);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17031;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17031);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17035;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17035);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd212075zd2_3922;
																																																		BgL_cdrzd212075zd2_3922
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8028z00_17039;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3442z00_3939;
																																																				BgL_arg3442z00_3939
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8028z00_17039
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3442z00_3939));
																																																			}
																																																			if (BgL_test8028z00_17039)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3426z00_3925;
																																																					obj_t
																																																						BgL_arg3427z00_3926;
																																																					BgL_arg3426z00_3925
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3922));
																																																					BgL_arg3427z00_3926
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3922));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17048;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17050;
																																																							obj_t
																																																								BgL_bindingsz00_17049;
																																																							BgL_bindingsz00_17049
																																																								=
																																																								BgL_arg3426z00_3925;
																																																							BgL_exprz00_17050
																																																								=
																																																								BgL_arg3427z00_3926;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_17050;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_17049;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17048);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8029z00_17052;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3441z00_3938;
																																																						BgL_arg3441z00_3938
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8029z00_17052
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3441z00_3938));
																																																					}
																																																					if (BgL_test8029z00_17052)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17057;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17057);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd212141zd2_3929;
																																																							BgL_carzd212141zd2_3929
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd212146zd2_3930;
																																																								BgL_cdrzd212146zd2_3930
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd212141zd2_3929));
																																																								if ((CAR(((obj_t) BgL_carzd212141zd2_3929)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3435z00_3933;
																																																										obj_t
																																																											BgL_arg3436z00_3934;
																																																										obj_t
																																																											BgL_arg3437z00_3935;
																																																										BgL_arg3435z00_3933
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3930));
																																																										BgL_arg3436z00_3934
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3930));
																																																										BgL_arg3437z00_3935
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17074;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17077;
																																																												obj_t
																																																													BgL_bodyz00_17076;
																																																												obj_t
																																																													BgL_varsz00_17075;
																																																												BgL_varsz00_17075
																																																													=
																																																													BgL_arg3435z00_3933;
																																																												BgL_bodyz00_17076
																																																													=
																																																													BgL_arg3436z00_3934;
																																																												BgL_argsz00_17077
																																																													=
																																																													BgL_arg3437z00_3935;
																																																												BgL_argsz00_1790
																																																													=
																																																													BgL_argsz00_17077;
																																																												BgL_bodyz00_1789
																																																													=
																																																													BgL_bodyz00_17076;
																																																												BgL_varsz00_1788
																																																													=
																																																													BgL_varsz00_17075;
																																																												goto
																																																													BgL_tagzd2386zd2_1791;
																																																											}
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17074);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_17081;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_17081);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd212257zd2_3940;
																																																BgL_cdrzd212257zd2_3940
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8032z00_17085;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3452z00_3949;
																																																		BgL_arg3452z00_3949
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8032z00_17085
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3452z00_3949));
																																																	}
																																																	if (BgL_test8032z00_17085)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3445z00_3943;
																																																			obj_t
																																																				BgL_arg3447z00_3944;
																																																			BgL_arg3445z00_3943
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3940));
																																																			BgL_arg3447z00_3944
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3940));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17094;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17096;
																																																					obj_t
																																																						BgL_bindingsz00_17095;
																																																					BgL_bindingsz00_17095
																																																						=
																																																						BgL_arg3445z00_3943;
																																																					BgL_exprz00_17096
																																																						=
																																																						BgL_arg3447z00_3944;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_17096;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_17095;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17094);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8033z00_17098;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3451z00_3948;
																																																				BgL_arg3451z00_3948
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8033z00_17098
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3451z00_3948));
																																																			}
																																																			if (BgL_test8033z00_17098)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17103;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17103);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1825;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_17107;
																																																							goto
																																																								BgL_tagzd2404zd2_1826;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17107);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210822zd2_3676)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd210824zd2_3678;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd210822zd2_3676 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd210824zd2_3678;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd210822zd2_3676 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd210824zd2_3678;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210822zd2_3676)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd210824zd2_3678;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd212429zd2_3684;
																																																						BgL_cdrzd212429zd2_3684
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8039z00_17123;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3320z00_3801;
																																																								BgL_arg3320z00_3801
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8039z00_17123
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3320z00_3801));
																																																							}
																																																							if (BgL_test8039z00_17123)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg3218z00_3687;
																																																									obj_t
																																																										BgL_arg3219z00_3688;
																																																									BgL_arg3218z00_3687
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3684));
																																																									BgL_arg3219z00_3688
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3684));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17132;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_17134;
																																																											obj_t
																																																												BgL_bindingsz00_17133;
																																																											BgL_bindingsz00_17133
																																																												=
																																																												BgL_arg3218z00_3687;
																																																											BgL_exprz00_17134
																																																												=
																																																												BgL_arg3219z00_3688;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_17134;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_17133;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17132);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8040z00_17136;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3319z00_3800;
																																																										BgL_arg3319z00_3800
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8040z00_17136
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3319z00_3800));
																																																									}
																																																									if (BgL_test8040z00_17136)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_17141;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17141);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd212495zd2_3691;
																																																											BgL_carzd212495zd2_3691
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd212500zd2_3692;
																																																												BgL_cdrzd212500zd2_3692
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd212495zd2_3691));
																																																												if ((CAR(((obj_t) BgL_carzd212495zd2_3691)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd212500zd2_3692))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg3227z00_3696;
																																																																obj_t
																																																																	BgL_arg3229z00_3697;
																																																																obj_t
																																																																	BgL_arg3238z00_3698;
																																																																BgL_arg3227z00_3696
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd212500zd2_3692);
																																																																BgL_arg3229z00_3697
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd212500zd2_3692);
																																																																BgL_arg3238z00_3698
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17158;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_17161;
																																																																		obj_t
																																																																			BgL_bodyz00_17160;
																																																																		obj_t
																																																																			BgL_varsz00_17159;
																																																																		BgL_varsz00_17159
																																																																			=
																																																																			BgL_arg3227z00_3696;
																																																																		BgL_bodyz00_17160
																																																																			=
																																																																			BgL_arg3229z00_3697;
																																																																		BgL_argsz00_17161
																																																																			=
																																																																			BgL_arg3238z00_3698;
																																																																		BgL_argsz00_1790
																																																																			=
																																																																			BgL_argsz00_17161;
																																																																		BgL_bodyz00_1789
																																																																			=
																																																																			BgL_bodyz00_17160;
																																																																		BgL_varsz00_1788
																																																																			=
																																																																			BgL_varsz00_17159;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1791;
																																																																	}
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17158);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_17165;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_17165);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd212607zd2_3701;
																																																														BgL_cdrzd212607zd2_3701
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd212612zd2_3702;
																																																															BgL_cdrzd212612zd2_3702
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd212495zd2_3691));
																																																															if ((CAR(((obj_t) BgL_carzd212495zd2_3691)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd212612zd2_3702))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd212617zd2_3706;
																																																																			BgL_cdrzd212617zd2_3706
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd212612zd2_3702);
																																																																			if (PAIRP(BgL_cdrzd212617zd2_3706))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd212621zd2_3708;
																																																																					obj_t
																																																																						BgL_cdrzd212622zd2_3709;
																																																																					BgL_carzd212621zd2_3708
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd212617zd2_3706);
																																																																					BgL_cdrzd212622zd2_3709
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd212617zd2_3706);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212621zd2_3708))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd212622zd2_3709))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd212627zd2_3712;
																																																																									BgL_carzd212627zd2_3712
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd212622zd2_3709);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212627zd2_3712))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd212622zd2_3709)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8051z00_17193;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1389z00_3745;
																																																																														BgL_l1389z00_3745
																																																																															=
																																																																															BgL_cdrzd212607zd2_3701;
																																																																													BgL_zc3z04anonymousza33267ze3z87_3746:
																																																																														if (NULLP(BgL_l1389z00_3745))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8051z00_17193
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8053z00_17196;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8054z00_17197;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_17198;
																																																																																		BgL_tmpz00_17198
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1389z00_3745));
																																																																																		BgL_test8054z00_17197
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_17198);
																																																																																	}
																																																																																	if (BgL_test8054z00_17197)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8053z00_17196
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8053z00_17196
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test8053z00_17196)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1389z00_17202;
																																																																																		BgL_l1389z00_17202
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1389z00_3745));
																																																																																		BgL_l1389z00_3745
																																																																																			=
																																																																																			BgL_l1389z00_17202;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza33267ze3z87_3746;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8051z00_17193
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test8051z00_17193)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3257z00_3728;
																																																																															BgL_arg3257z00_3728
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd212612zd2_3702);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17206;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17210;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17209;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17208;
																																																																																	obj_t
																																																																																		BgL_testz00_17207;
																																																																																	BgL_testz00_17207
																																																																																		=
																																																																																		BgL_arg3257z00_3728;
																																																																																	BgL_proc1z00_17208
																																																																																		=
																																																																																		BgL_carzd212621zd2_3708;
																																																																																	BgL_proc2z00_17209
																																																																																		=
																																																																																		BgL_carzd212627zd2_3712;
																																																																																	BgL_argsz00_17210
																																																																																		=
																																																																																		BgL_cdrzd212607zd2_3701;
																																																																																	BgL_argsz00_1795
																																																																																		=
																																																																																		BgL_argsz00_17210;
																																																																																	BgL_proc2z00_1794
																																																																																		=
																																																																																		BgL_proc2z00_17209;
																																																																																	BgL_proc1z00_1793
																																																																																		=
																																																																																		BgL_proc1z00_17208;
																																																																																	BgL_testz00_1792
																																																																																		=
																																																																																		BgL_testz00_17207;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1796;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17206);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd212652zd2_3729;
																																																																															BgL_cdrzd212652zd2_3729
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd212660zd2_3730;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10614;
																																																																																	BgL_pairz00_10614
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd212660zd2_3730
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10614);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd212668zd2_3731;
																																																																																	BgL_cdrzd212668zd2_3731
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd212660zd2_3730));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd212675zd2_3732;
																																																																																		BgL_carzd212675zd2_3732
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd212668zd2_3731));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212675zd2_3732))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd212684zd2_3734;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10618;
																																																																																					BgL_pairz00_10618
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd212668zd2_3731));
																																																																																					BgL_carzd212684zd2_3734
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_10618);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212684zd2_3734))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212652zd2_3729))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg3261z00_3737;
																																																																																								BgL_arg3261z00_3737
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd212660zd2_3730));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17232;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17236;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17235;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17234;
																																																																																										obj_t
																																																																																											BgL_testz00_17233;
																																																																																										BgL_testz00_17233
																																																																																											=
																																																																																											BgL_arg3261z00_3737;
																																																																																										BgL_proc1z00_17234
																																																																																											=
																																																																																											BgL_carzd212675zd2_3732;
																																																																																										BgL_proc2z00_17235
																																																																																											=
																																																																																											BgL_carzd212684zd2_3734;
																																																																																										BgL_argsz00_17236
																																																																																											=
																																																																																											BgL_cdrzd212652zd2_3729;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_17236;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_17235;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_17234;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_17233;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_13657
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17232);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17240;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_13657
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17240);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17244;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17244);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17248;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17248);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17252;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17252);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd212962zd2_3756;
																																																																											BgL_cdrzd212962zd2_3756
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd212969zd2_3757;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10622;
																																																																													BgL_pairz00_10622
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd212969zd2_3757
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10622);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd212976zd2_3758;
																																																																													BgL_cdrzd212976zd2_3758
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd212969zd2_3757));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd212982zd2_3759;
																																																																														obj_t
																																																																															BgL_cdrzd212983zd2_3760;
																																																																														BgL_carzd212982zd2_3759
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3758));
																																																																														BgL_cdrzd212983zd2_3760
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3758));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212982zd2_3759))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd212990zd2_3762;
																																																																																BgL_carzd212990zd2_3762
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd212983zd2_3760));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212990zd2_3762))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212983zd2_3760))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212962zd2_3756))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3277z00_3767;
																																																																																						BgL_arg3277z00_3767
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd212969zd2_3757));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17279;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17283;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17282;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17281;
																																																																																								obj_t
																																																																																									BgL_testz00_17280;
																																																																																								BgL_testz00_17280
																																																																																									=
																																																																																									BgL_arg3277z00_3767;
																																																																																								BgL_proc1z00_17281
																																																																																									=
																																																																																									BgL_carzd212982zd2_3759;
																																																																																								BgL_proc2z00_17282
																																																																																									=
																																																																																									BgL_carzd212990zd2_3762;
																																																																																								BgL_argsz00_17283
																																																																																									=
																																																																																									BgL_cdrzd212962zd2_3756;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_17283;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_17282;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_17281;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_17280;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17279);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17287;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17287);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17291;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17291);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17295;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17295);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17299;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17299);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17303;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17303);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd213323zd2_3775;
																																																																							BgL_cdrzd213323zd2_3775
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd213329zd2_3776;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_10631;
																																																																									BgL_pairz00_10631
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd213329zd2_3776
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10631);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd213335zd2_3777;
																																																																									BgL_cdrzd213335zd2_3777
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd213329zd2_3776));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd213340zd2_3778;
																																																																										obj_t
																																																																											BgL_cdrzd213341zd2_3779;
																																																																										BgL_carzd213340zd2_3778
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3777));
																																																																										BgL_cdrzd213341zd2_3779
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3777));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213340zd2_3778))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd213341zd2_3779))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd213346zd2_3782;
																																																																														BgL_carzd213346zd2_3782
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd213341zd2_3779);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213346zd2_3782))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd213341zd2_3779)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd213323zd2_3775))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3305z00_3787;
																																																																																				BgL_arg3305z00_3787
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd213329zd2_3776));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17330;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_17334;
																																																																																						obj_t
																																																																																							BgL_proc2z00_17333;
																																																																																						obj_t
																																																																																							BgL_proc1z00_17332;
																																																																																						obj_t
																																																																																							BgL_testz00_17331;
																																																																																						BgL_testz00_17331
																																																																																							=
																																																																																							BgL_arg3305z00_3787;
																																																																																						BgL_proc1z00_17332
																																																																																							=
																																																																																							BgL_carzd213340zd2_3778;
																																																																																						BgL_proc2z00_17333
																																																																																							=
																																																																																							BgL_carzd213346zd2_3782;
																																																																																						BgL_argsz00_17334
																																																																																							=
																																																																																							BgL_cdrzd213323zd2_3775;
																																																																																						BgL_argsz00_1800
																																																																																							=
																																																																																							BgL_argsz00_17334;
																																																																																						BgL_proc2z00_1799
																																																																																							=
																																																																																							BgL_proc2z00_17333;
																																																																																						BgL_proc1z00_1798
																																																																																							=
																																																																																							BgL_proc1z00_17332;
																																																																																						BgL_testz00_1797
																																																																																							=
																																																																																							BgL_testz00_17331;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1801;
																																																																																					}
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17330);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17338;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17338);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17342;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17342);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17346;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17346);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17350;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17350);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17354;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17354);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17358;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17358);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17362;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17362);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17366;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17366);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd210819zd2_3674 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3454z00_3953;
																																													obj_t
																																														BgL_arg3456z00_3954;
																																													BgL_arg3454z00_3953
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3658));
																																													BgL_arg3456z00_3954
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3658));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17375;
																																														{
																																															obj_t
																																																BgL_exprz00_17377;
																																															obj_t
																																																BgL_bindingsz00_17376;
																																															BgL_bindingsz00_17376
																																																=
																																																BgL_arg3454z00_3953;
																																															BgL_exprz00_17377
																																																=
																																																BgL_arg3456z00_3954;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_17377;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_17376;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17375);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210819zd2_3674)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3458z00_3956;
																																															obj_t
																																																BgL_arg3460z00_3957;
																																															BgL_arg3458z00_3956
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3658));
																																															BgL_arg3460z00_3957
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3658));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17386;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17388;
																																																	obj_t
																																																		BgL_bindingsz00_17387;
																																																	BgL_bindingsz00_17387
																																																		=
																																																		BgL_arg3458z00_3956;
																																																	BgL_exprz00_17388
																																																		=
																																																		BgL_arg3460z00_3957;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_17388;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_17387;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_13657
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17386);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd210819zd2_3674 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3462z00_3959;
																																																	obj_t
																																																		BgL_arg3463z00_3960;
																																																	BgL_arg3462z00_3959
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3658));
																																																	BgL_arg3463z00_3960
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3658));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17397;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17399;
																																																			obj_t
																																																				BgL_bindingsz00_17398;
																																																			BgL_bindingsz00_17398
																																																				=
																																																				BgL_arg3462z00_3959;
																																																			BgL_exprz00_17399
																																																				=
																																																				BgL_arg3463z00_3960;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_17399;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_17398;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17397);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_17406;
																																																			goto
																																																				BgL_tagzd2383zd2_1782;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_17406);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd213921zd2_3963;
																																																			BgL_carzd213921zd2_3963
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd213921zd2_3963 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17413;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17413);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd213921zd2_3963)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17418;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17418);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_17425;
																																																									goto
																																																										BgL_tagzd2389zd2_1802;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17425);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17432;
																																																											goto
																																																												BgL_tagzd2390zd2_1803;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17432);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214001zd2_3970;
																																																											BgL_cdrzd214001zd2_3970
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg3475z00_3973;
																																																													obj_t
																																																														BgL_arg3477z00_3974;
																																																													BgL_arg3475z00_3973
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3970));
																																																													BgL_arg3477z00_3974
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3970));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_17445;
																																																														{
																																																															obj_t
																																																																BgL_restz00_17447;
																																																															obj_t
																																																																BgL_effectz00_17446;
																																																															BgL_effectz00_17446
																																																																=
																																																																BgL_arg3475z00_3973;
																																																															BgL_restz00_17447
																																																																=
																																																																BgL_arg3477z00_3974;
																																																															BgL_restz00_1805
																																																																=
																																																																BgL_restz00_17447;
																																																															BgL_effectz00_1804
																																																																=
																																																																BgL_effectz00_17446;
																																																															goto
																																																																BgL_tagzd2391zd2_1806;
																																																														}
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_17445);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_17454;
																																																															goto
																																																																BgL_tagzd2392zd2_1807;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_17454);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17461;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1808;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17461);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3485z00_3982;
																																																																			obj_t
																																																																				BgL_arg3486z00_3983;
																																																																			BgL_arg3485z00_3982
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3970));
																																																																			BgL_arg3486z00_3983
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3970));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_17472;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_17474;
																																																																					obj_t
																																																																						BgL_effectz00_17473;
																																																																					BgL_effectz00_17473
																																																																						=
																																																																						BgL_arg3485z00_3982;
																																																																					BgL_restz00_17474
																																																																						=
																																																																						BgL_arg3486z00_3983;
																																																																					BgL_restz00_1810
																																																																						=
																																																																						BgL_restz00_17474;
																																																																					BgL_effectz00_1809
																																																																						=
																																																																						BgL_effectz00_17473;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1811;
																																																																				}
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_17472);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17481;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1812;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17481);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17488;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1813;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17488);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_17495;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1814;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17495);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_17502;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1815;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17502);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8101z00_17509;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_17510;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10667;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10666;
																																																																																BgL_pairz00_10666
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_pairz00_10667
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10666);
																																																																															}
																																																																															BgL_tmpz00_17510
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10667);
																																																																														}
																																																																														BgL_test8101z00_17509
																																																																															=
																																																																															NULLP
																																																																															(BgL_tmpz00_17510);
																																																																													}
																																																																													if (BgL_test8101z00_17509)
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17516;
																																																																														BgL_tagzd2399zd2_1816:
																																																																															BgL_auxz00_17516 = BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17516);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17521;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17521);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd214094zd2_4002;
																																																																													BgL_cdrzd214094zd2_4002
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3512z00_4005;
																																																																															obj_t
																																																																																BgL_arg3514z00_4006;
																																																																															BgL_arg3512z00_4005
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_4002));
																																																																															BgL_arg3514z00_4006
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_4002));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7023z00_10672;
																																																																																BgL_arg7023z00_10672
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3512z00_4005,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3514z00_4006, BgL_stackz00_22, BgL_arg7023z00_10672, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17540;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17540);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd214119zd2_4023;
																															BgL_carzd214119zd2_4023
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd214119zd2_4023
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_17547;
																																	goto
																																		BgL_tagzd2377zd2_1770;
																																	BgL_auxz00_13657
																																		=
																																		((obj_t)
																																		BgL_auxz00_17547);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd214119zd2_4023
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_17551;
																																			goto
																																				BgL_tagzd2377zd2_1770;
																																			BgL_auxz00_13657
																																				=
																																				((obj_t)
																																				BgL_auxz00_17551);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd214141zd2_4026;
																																			BgL_cdrzd214141zd2_4026
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd214144zd2_4029;
																																					obj_t
																																						BgL_cdrzd214145zd2_4030;
																																					BgL_carzd214144zd2_4029
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd214141zd2_4026));
																																					BgL_cdrzd214145zd2_4030
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd214141zd2_4026));
																																					if (PAIRP(BgL_carzd214144zd2_4029))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd214144zd2_4029) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd214145zd2_4030))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3546z00_4036;
																																											obj_t
																																												BgL_arg3547z00_4037;
																																											BgL_arg3546z00_4036
																																												=
																																												CDR
																																												(BgL_carzd214144zd2_4029);
																																											BgL_arg3547z00_4037
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214145zd2_4030));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_17577;
																																												{
																																													obj_t
																																														BgL_valz00_17579;
																																													obj_t
																																														BgL_lz00_17578;
																																													BgL_lz00_17578
																																														=
																																														BgL_arg3546z00_4036;
																																													BgL_valz00_17579
																																														=
																																														BgL_arg3547z00_4037;
																																													BgL_valz00_1772
																																														=
																																														BgL_valz00_17579;
																																													BgL_lz00_1771
																																														=
																																														BgL_lz00_17578;
																																													goto
																																														BgL_tagzd2378zd2_1773;
																																												}
																																												BgL_auxz00_13657
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_17577);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_17581;
																																											goto
																																												BgL_tagzd2379zd2_1774;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_17581);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17583;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17583);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_17585;
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_17585);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_17592;
																																							goto
																																								BgL_tagzd2380zd2_1775;
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_17592);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd214242zd2_4042;
																																							BgL_carzd214242zd2_4042
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd214242zd2_4042))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd214245zd2_4044;
																																									obj_t
																																										BgL_cdrzd214246zd2_4045;
																																									BgL_carzd214245zd2_4044
																																										=
																																										CAR
																																										(BgL_carzd214242zd2_4042);
																																									BgL_cdrzd214246zd2_4045
																																										=
																																										CDR
																																										(BgL_carzd214242zd2_4042);
																																									{

																																										if ((BgL_carzd214245zd2_4044 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd214247zd2_4046:
																																												if (PAIRP(BgL_cdrzd214246zd2_4045))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd214250zd2_4171;
																																														BgL_cdrzd214250zd2_4171
																																															=
																																															CDR
																																															(BgL_cdrzd214246zd2_4045);
																																														if (PAIRP(BgL_cdrzd214250zd2_4171))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd214250zd2_4171)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3646z00_4175;
																																																		obj_t
																																																			BgL_arg3647z00_4176;
																																																		BgL_arg3646z00_4175
																																																			=
																																																			CAR
																																																			(BgL_cdrzd214250zd2_4171);
																																																		BgL_arg3647z00_4176
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_17614;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_17616;
																																																				obj_t
																																																					BgL_bodyz00_17615;
																																																				BgL_bodyz00_17615
																																																					=
																																																					BgL_arg3646z00_4175;
																																																				BgL_argsz00_17616
																																																					=
																																																					BgL_arg3647z00_4176;
																																																				BgL_argsz00_1777
																																																					=
																																																					BgL_argsz00_17616;
																																																				BgL_bodyz00_1776
																																																					=
																																																					BgL_bodyz00_17615;
																																																				goto
																																																					BgL_tagzd2381zd2_1778;
																																																			}
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_17614);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd214274zd2_4177;
																																																		BgL_cdrzd214274zd2_4177
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8117z00_17620;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3723z00_4288;
																																																				BgL_arg3723z00_4288
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8117z00_17620
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3723z00_4288));
																																																			}
																																																			if (BgL_test8117z00_17620)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3651z00_4180;
																																																					obj_t
																																																						BgL_arg3652z00_4181;
																																																					BgL_arg3651z00_4180
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4177));
																																																					BgL_arg3652z00_4181
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4177));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17629;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17631;
																																																							obj_t
																																																								BgL_bindingsz00_17630;
																																																							BgL_bindingsz00_17630
																																																								=
																																																								BgL_arg3651z00_4180;
																																																							BgL_exprz00_17631
																																																								=
																																																								BgL_arg3652z00_4181;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_17631;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_17630;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17629);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8118z00_17633;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3722z00_4287;
																																																						BgL_arg3722z00_4287
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8118z00_17633
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3722z00_4287));
																																																					}
																																																					if (BgL_test8118z00_17633)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17638;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17638);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd214341zd2_4184;
																																																							BgL_carzd214341zd2_4184
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd214346zd2_4185;
																																																								BgL_cdrzd214346zd2_4185
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd214341zd2_4184));
																																																								if ((CAR(((obj_t) BgL_carzd214341zd2_4184)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3657z00_4188;
																																																										obj_t
																																																											BgL_arg3659z00_4189;
																																																										obj_t
																																																											BgL_arg3661z00_4190;
																																																										BgL_arg3657z00_4188
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4185));
																																																										BgL_arg3659z00_4189
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4185));
																																																										BgL_arg3661z00_4190
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17655;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17658;
																																																												obj_t
																																																													BgL_bodyz00_17657;
																																																												obj_t
																																																													BgL_varsz00_17656;
																																																												BgL_varsz00_17656
																																																													=
																																																													BgL_arg3657z00_4188;
																																																												BgL_bodyz00_17657
																																																													=
																																																													BgL_arg3659z00_4189;
																																																												BgL_argsz00_17658
																																																													=
																																																													BgL_arg3661z00_4190;
																																																												BgL_argsz00_1790
																																																													=
																																																													BgL_argsz00_17658;
																																																												BgL_bodyz00_1789
																																																													=
																																																													BgL_bodyz00_17657;
																																																												BgL_varsz00_1788
																																																													=
																																																													BgL_varsz00_17656;
																																																												goto
																																																													BgL_tagzd2386zd2_1791;
																																																											}
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17655);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd214369zd2_4192;
																																																										BgL_cdrzd214369zd2_4192
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214375zd2_4193;
																																																											BgL_cdrzd214375zd2_4193
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd214341zd2_4184));
																																																											if ((CAR(((obj_t) BgL_carzd214341zd2_4184)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd214381zd2_4196;
																																																													BgL_cdrzd214381zd2_4196
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214375zd2_4193));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd214386zd2_4197;
																																																														obj_t
																																																															BgL_cdrzd214387zd2_4198;
																																																														BgL_carzd214386zd2_4197
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4196));
																																																														BgL_cdrzd214387zd2_4198
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4196));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214386zd2_4197))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd214387zd2_4198))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd214394zd2_4201;
																																																																		BgL_carzd214394zd2_4201
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd214387zd2_4198);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214394zd2_4201))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd214387zd2_4198)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test8125z00_17685;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1392z00_4234;
																																																																							BgL_l1392z00_4234
																																																																								=
																																																																								BgL_cdrzd214369zd2_4192;
																																																																						BgL_zc3z04anonymousza33686ze3z87_4235:
																																																																							if (NULLP(BgL_l1392z00_4234))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8125z00_17685
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test8127z00_17688;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8128z00_17689;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_17690;
																																																																											BgL_tmpz00_17690
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1392z00_4234));
																																																																											BgL_test8128z00_17689
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_17690);
																																																																										}
																																																																										if (BgL_test8128z00_17689)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8127z00_17688
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8127z00_17688
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test8127z00_17688)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1392z00_17694;
																																																																											BgL_l1392z00_17694
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1392z00_4234));
																																																																											BgL_l1392z00_4234
																																																																												=
																																																																												BgL_l1392z00_17694;
																																																																											goto
																																																																												BgL_zc3z04anonymousza33686ze3z87_4235;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8125z00_17685
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test8125z00_17685)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg3675z00_4217;
																																																																								BgL_arg3675z00_4217
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd214375zd2_4193));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17699;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_17703;
																																																																										obj_t
																																																																											BgL_proc2z00_17702;
																																																																										obj_t
																																																																											BgL_proc1z00_17701;
																																																																										obj_t
																																																																											BgL_testz00_17700;
																																																																										BgL_testz00_17700
																																																																											=
																																																																											BgL_arg3675z00_4217;
																																																																										BgL_proc1z00_17701
																																																																											=
																																																																											BgL_carzd214386zd2_4197;
																																																																										BgL_proc2z00_17702
																																																																											=
																																																																											BgL_carzd214394zd2_4201;
																																																																										BgL_argsz00_17703
																																																																											=
																																																																											BgL_cdrzd214369zd2_4192;
																																																																										BgL_argsz00_1795
																																																																											=
																																																																											BgL_argsz00_17703;
																																																																										BgL_proc2z00_1794
																																																																											=
																																																																											BgL_proc2z00_17702;
																																																																										BgL_proc1z00_1793
																																																																											=
																																																																											BgL_proc1z00_17701;
																																																																										BgL_testz00_1792
																																																																											=
																																																																											BgL_testz00_17700;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1796;
																																																																									}
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17699);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd214418zd2_4218;
																																																																								BgL_cdrzd214418zd2_4218
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd214425zd2_4219;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10715;
																																																																										BgL_pairz00_10715
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd214425zd2_4219
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10715);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd214432zd2_4220;
																																																																										BgL_cdrzd214432zd2_4220
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd214425zd2_4219));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd214438zd2_4221;
																																																																											BgL_carzd214438zd2_4221
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd214432zd2_4220));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214438zd2_4221))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd214445zd2_4223;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10719;
																																																																														BgL_pairz00_10719
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd214432zd2_4220));
																																																																														BgL_carzd214445zd2_4223
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_10719);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214445zd2_4223))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214418zd2_4218))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3680z00_4226;
																																																																																	BgL_arg3680z00_4226
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd214425zd2_4219));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17725;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17729;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17728;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17727;
																																																																																			obj_t
																																																																																				BgL_testz00_17726;
																																																																																			BgL_testz00_17726
																																																																																				=
																																																																																				BgL_arg3680z00_4226;
																																																																																			BgL_proc1z00_17727
																																																																																				=
																																																																																				BgL_carzd214438zd2_4221;
																																																																																			BgL_proc2z00_17728
																																																																																				=
																																																																																				BgL_carzd214445zd2_4223;
																																																																																			BgL_argsz00_17729
																																																																																				=
																																																																																				BgL_cdrzd214418zd2_4218;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_17729;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_17728;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_17727;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_17726;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17725);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17733;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17733);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17737;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17737);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17741;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17741);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_17745;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_17745);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd214721zd2_4245;
																																																																				BgL_cdrzd214721zd2_4245
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd214727zd2_4246;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10723;
																																																																						BgL_pairz00_10723
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd214727zd2_4246
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10723);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd214733zd2_4247;
																																																																						BgL_cdrzd214733zd2_4247
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd214727zd2_4246));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd214738zd2_4248;
																																																																							obj_t
																																																																								BgL_cdrzd214739zd2_4249;
																																																																							BgL_carzd214738zd2_4248
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4247));
																																																																							BgL_cdrzd214739zd2_4249
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4247));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214738zd2_4248))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd214744zd2_4251;
																																																																									BgL_carzd214744zd2_4251
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd214739zd2_4249));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214744zd2_4251))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd214739zd2_4249))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214721zd2_4245))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3695z00_4256;
																																																																															BgL_arg3695z00_4256
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214727zd2_4246));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17772;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17776;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17775;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17774;
																																																																																	obj_t
																																																																																		BgL_testz00_17773;
																																																																																	BgL_testz00_17773
																																																																																		=
																																																																																		BgL_arg3695z00_4256;
																																																																																	BgL_proc1z00_17774
																																																																																		=
																																																																																		BgL_carzd214738zd2_4248;
																																																																																	BgL_proc2z00_17775
																																																																																		=
																																																																																		BgL_carzd214744zd2_4251;
																																																																																	BgL_argsz00_17776
																																																																																		=
																																																																																		BgL_cdrzd214721zd2_4245;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_17776;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_17775;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_17774;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_17773;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17772);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17780;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17780);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17784;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17784);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17788;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17788);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17792;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17792);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_17796;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_17796);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd215077zd2_4264;
																																																																BgL_cdrzd215077zd2_4264
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd215084zd2_4265;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_10732;
																																																																		BgL_pairz00_10732
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd215084zd2_4265
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_10732);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd215091zd2_4266;
																																																																		BgL_cdrzd215091zd2_4266
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd215084zd2_4265));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd215097zd2_4267;
																																																																			obj_t
																																																																				BgL_cdrzd215098zd2_4268;
																																																																			BgL_carzd215097zd2_4267
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4266));
																																																																			BgL_cdrzd215098zd2_4268
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4266));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215097zd2_4267))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd215098zd2_4268))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd215105zd2_4271;
																																																																							BgL_carzd215105zd2_4271
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd215098zd2_4268);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215105zd2_4271))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd215098zd2_4268)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd215077zd2_4264))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3710z00_4276;
																																																																													BgL_arg3710z00_4276
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd215084zd2_4265));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17823;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_17827;
																																																																															obj_t
																																																																																BgL_proc2z00_17826;
																																																																															obj_t
																																																																																BgL_proc1z00_17825;
																																																																															obj_t
																																																																																BgL_testz00_17824;
																																																																															BgL_testz00_17824
																																																																																=
																																																																																BgL_arg3710z00_4276;
																																																																															BgL_proc1z00_17825
																																																																																=
																																																																																BgL_carzd215097zd2_4267;
																																																																															BgL_proc2z00_17826
																																																																																=
																																																																																BgL_carzd215105zd2_4271;
																																																																															BgL_argsz00_17827
																																																																																=
																																																																																BgL_cdrzd215077zd2_4264;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_17827;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_17826;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_17825;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_17824;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17823);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17831;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17831);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17835;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17835);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17839;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17839);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17843;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17843);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17847;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17847);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_17851;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_17851);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd215498zd2_4290;
																																																BgL_cdrzd215498zd2_4290
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8156z00_17855;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3739z00_4307;
																																																		BgL_arg3739z00_4307
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8156z00_17855
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3739z00_4307));
																																																	}
																																																	if (BgL_test8156z00_17855)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3727z00_4293;
																																																			obj_t
																																																				BgL_arg3728z00_4294;
																																																			BgL_arg3727z00_4293
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4290));
																																																			BgL_arg3728z00_4294
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4290));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17864;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17866;
																																																					obj_t
																																																						BgL_bindingsz00_17865;
																																																					BgL_bindingsz00_17865
																																																						=
																																																						BgL_arg3727z00_4293;
																																																					BgL_exprz00_17866
																																																						=
																																																						BgL_arg3728z00_4294;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_17866;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_17865;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17864);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8157z00_17868;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3738z00_4306;
																																																				BgL_arg3738z00_4306
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8157z00_17868
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3738z00_4306));
																																																			}
																																																			if (BgL_test8157z00_17868)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17873;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17873);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd215564zd2_4297;
																																																					BgL_carzd215564zd2_4297
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd215569zd2_4298;
																																																						BgL_cdrzd215569zd2_4298
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd215564zd2_4297));
																																																						if ((CAR(((obj_t) BgL_carzd215564zd2_4297)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3733z00_4301;
																																																								obj_t
																																																									BgL_arg3734z00_4302;
																																																								obj_t
																																																									BgL_arg3735z00_4303;
																																																								BgL_arg3733z00_4301
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4298));
																																																								BgL_arg3734z00_4302
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4298));
																																																								BgL_arg3735z00_4303
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_17890;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_17893;
																																																										obj_t
																																																											BgL_bodyz00_17892;
																																																										obj_t
																																																											BgL_varsz00_17891;
																																																										BgL_varsz00_17891
																																																											=
																																																											BgL_arg3733z00_4301;
																																																										BgL_bodyz00_17892
																																																											=
																																																											BgL_arg3734z00_4302;
																																																										BgL_argsz00_17893
																																																											=
																																																											BgL_arg3735z00_4303;
																																																										BgL_argsz00_1790
																																																											=
																																																											BgL_argsz00_17893;
																																																										BgL_bodyz00_1789
																																																											=
																																																											BgL_bodyz00_17892;
																																																										BgL_varsz00_1788
																																																											=
																																																											BgL_varsz00_17891;
																																																										goto
																																																											BgL_tagzd2386zd2_1791;
																																																									}
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17890);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17897;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17897);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd215680zd2_4308;
																																														BgL_cdrzd215680zd2_4308
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8160z00_17901;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3748z00_4317;
																																																BgL_arg3748z00_4317
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8160z00_17901
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3748z00_4317));
																																															}
																																															if (BgL_test8160z00_17901)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3742z00_4311;
																																																	obj_t
																																																		BgL_arg3743z00_4312;
																																																	BgL_arg3742z00_4311
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4308));
																																																	BgL_arg3743z00_4312
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4308));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17910;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17912;
																																																			obj_t
																																																				BgL_bindingsz00_17911;
																																																			BgL_bindingsz00_17911
																																																				=
																																																				BgL_arg3742z00_4311;
																																																			BgL_exprz00_17912
																																																				=
																																																				BgL_arg3743z00_4312;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_17912;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_17911;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17910);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8161z00_17914;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3747z00_4316;
																																																		BgL_arg3747z00_4316
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8161z00_17914
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3747z00_4316));
																																																	}
																																																	if (BgL_test8161z00_17914)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_17919;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_17919);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1825;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17923;
																																																					goto
																																																						BgL_tagzd2404zd2_1826;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17923);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214245zd2_4044)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd214247zd2_4046;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd214245zd2_4044 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd214247zd2_4046;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd214245zd2_4044 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd214247zd2_4046;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd214245zd2_4044)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd214247zd2_4046;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd215852zd2_4052;
																																																				BgL_cdrzd215852zd2_4052
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8167z00_17939;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3641z00_4169;
																																																						BgL_arg3641z00_4169
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8167z00_17939
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3641z00_4169));
																																																					}
																																																					if (BgL_test8167z00_17939)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3561z00_4055;
																																																							obj_t
																																																								BgL_arg3562z00_4056;
																																																							BgL_arg3561z00_4055
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4052));
																																																							BgL_arg3562z00_4056
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4052));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_17948;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_17950;
																																																									obj_t
																																																										BgL_bindingsz00_17949;
																																																									BgL_bindingsz00_17949
																																																										=
																																																										BgL_arg3561z00_4055;
																																																									BgL_exprz00_17950
																																																										=
																																																										BgL_arg3562z00_4056;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_17950;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_17949;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_17948);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8168z00_17952;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3639z00_4168;
																																																								BgL_arg3639z00_4168
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8168z00_17952
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3639z00_4168));
																																																							}
																																																							if (BgL_test8168z00_17952)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17957;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17957);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd215918zd2_4059;
																																																									BgL_carzd215918zd2_4059
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd215923zd2_4060;
																																																										BgL_cdrzd215923zd2_4060
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd215918zd2_4059));
																																																										if ((CAR(((obj_t) BgL_carzd215918zd2_4059)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd215923zd2_4060))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg3569z00_4064;
																																																														obj_t
																																																															BgL_arg3570z00_4065;
																																																														obj_t
																																																															BgL_arg3571z00_4066;
																																																														BgL_arg3569z00_4064
																																																															=
																																																															CAR
																																																															(BgL_cdrzd215923zd2_4060);
																																																														BgL_arg3570z00_4065
																																																															=
																																																															CDR
																																																															(BgL_cdrzd215923zd2_4060);
																																																														BgL_arg3571z00_4066
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_17974;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_17977;
																																																																obj_t
																																																																	BgL_bodyz00_17976;
																																																																obj_t
																																																																	BgL_varsz00_17975;
																																																																BgL_varsz00_17975
																																																																	=
																																																																	BgL_arg3569z00_4064;
																																																																BgL_bodyz00_17976
																																																																	=
																																																																	BgL_arg3570z00_4065;
																																																																BgL_argsz00_17977
																																																																	=
																																																																	BgL_arg3571z00_4066;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_17977;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_17976;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_17975;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_17974);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_17981;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_17981);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd216030zd2_4069;
																																																												BgL_cdrzd216030zd2_4069
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd216035zd2_4070;
																																																													BgL_cdrzd216035zd2_4070
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd215918zd2_4059));
																																																													if ((CAR(((obj_t) BgL_carzd215918zd2_4059)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd216035zd2_4070))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd216040zd2_4074;
																																																																	BgL_cdrzd216040zd2_4074
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd216035zd2_4070);
																																																																	if (PAIRP(BgL_cdrzd216040zd2_4074))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd216044zd2_4076;
																																																																			obj_t
																																																																				BgL_cdrzd216045zd2_4077;
																																																																			BgL_carzd216044zd2_4076
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd216040zd2_4074);
																																																																			BgL_cdrzd216045zd2_4077
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd216040zd2_4074);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216044zd2_4076))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd216045zd2_4077))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd216050zd2_4080;
																																																																							BgL_carzd216050zd2_4080
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd216045zd2_4077);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216050zd2_4080))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd216045zd2_4077)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8179z00_18009;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1395z00_4113;
																																																																												BgL_l1395z00_4113
																																																																													=
																																																																													BgL_cdrzd216030zd2_4069;
																																																																											BgL_zc3z04anonymousza33599ze3z87_4114:
																																																																												if (NULLP(BgL_l1395z00_4113))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8179z00_18009
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8181z00_18012;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8182z00_18013;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_18014;
																																																																																BgL_tmpz00_18014
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1395z00_4113));
																																																																																BgL_test8182z00_18013
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_18014);
																																																																															}
																																																																															if (BgL_test8182z00_18013)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8181z00_18012
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8181z00_18012
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test8181z00_18012)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1395z00_18018;
																																																																																BgL_l1395z00_18018
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1395z00_4113));
																																																																																BgL_l1395z00_4113
																																																																																	=
																																																																																	BgL_l1395z00_18018;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza33599ze3z87_4114;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8179z00_18009
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test8179z00_18009)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3588z00_4096;
																																																																													BgL_arg3588z00_4096
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd216035zd2_4070);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18022;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18026;
																																																																															obj_t
																																																																																BgL_proc2z00_18025;
																																																																															obj_t
																																																																																BgL_proc1z00_18024;
																																																																															obj_t
																																																																																BgL_testz00_18023;
																																																																															BgL_testz00_18023
																																																																																=
																																																																																BgL_arg3588z00_4096;
																																																																															BgL_proc1z00_18024
																																																																																=
																																																																																BgL_carzd216044zd2_4076;
																																																																															BgL_proc2z00_18025
																																																																																=
																																																																																BgL_carzd216050zd2_4080;
																																																																															BgL_argsz00_18026
																																																																																=
																																																																																BgL_cdrzd216030zd2_4069;
																																																																															BgL_argsz00_1795
																																																																																=
																																																																																BgL_argsz00_18026;
																																																																															BgL_proc2z00_1794
																																																																																=
																																																																																BgL_proc2z00_18025;
																																																																															BgL_proc1z00_1793
																																																																																=
																																																																																BgL_proc1z00_18024;
																																																																															BgL_testz00_1792
																																																																																=
																																																																																BgL_testz00_18023;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1796;
																																																																														}
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18022);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd216075zd2_4097;
																																																																													BgL_cdrzd216075zd2_4097
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd216083zd2_4098;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10780;
																																																																															BgL_pairz00_10780
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd216083zd2_4098
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10780);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd216091zd2_4099;
																																																																															BgL_cdrzd216091zd2_4099
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd216083zd2_4098));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd216098zd2_4100;
																																																																																BgL_carzd216098zd2_4100
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd216091zd2_4099));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216098zd2_4100))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd216107zd2_4102;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10784;
																																																																																			BgL_pairz00_10784
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd216091zd2_4099));
																																																																																			BgL_carzd216107zd2_4102
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_10784);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216107zd2_4102))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216075zd2_4097))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3592z00_4105;
																																																																																						BgL_arg3592z00_4105
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd216083zd2_4098));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_18048;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_18052;
																																																																																								obj_t
																																																																																									BgL_proc2z00_18051;
																																																																																								obj_t
																																																																																									BgL_proc1z00_18050;
																																																																																								obj_t
																																																																																									BgL_testz00_18049;
																																																																																								BgL_testz00_18049
																																																																																									=
																																																																																									BgL_arg3592z00_4105;
																																																																																								BgL_proc1z00_18050
																																																																																									=
																																																																																									BgL_carzd216098zd2_4100;
																																																																																								BgL_proc2z00_18051
																																																																																									=
																																																																																									BgL_carzd216107zd2_4102;
																																																																																								BgL_argsz00_18052
																																																																																									=
																																																																																									BgL_cdrzd216075zd2_4097;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_18052;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_18051;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_18050;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_18049;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_13657
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_18048);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_18056;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_13657
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_18056);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18060;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18060);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18064;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18064);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18068;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18068);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd216385zd2_4124;
																																																																									BgL_cdrzd216385zd2_4124
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd216392zd2_4125;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10788;
																																																																											BgL_pairz00_10788
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd216392zd2_4125
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10788);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd216399zd2_4126;
																																																																											BgL_cdrzd216399zd2_4126
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd216392zd2_4125));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216405zd2_4127;
																																																																												obj_t
																																																																													BgL_cdrzd216406zd2_4128;
																																																																												BgL_carzd216405zd2_4127
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4126));
																																																																												BgL_cdrzd216406zd2_4128
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4126));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216405zd2_4127))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd216413zd2_4130;
																																																																														BgL_carzd216413zd2_4130
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd216406zd2_4128));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216413zd2_4130))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd216406zd2_4128))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216385zd2_4124))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3609z00_4135;
																																																																																				BgL_arg3609z00_4135
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd216392zd2_4125));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_18095;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_18099;
																																																																																						obj_t
																																																																																							BgL_proc2z00_18098;
																																																																																						obj_t
																																																																																							BgL_proc1z00_18097;
																																																																																						obj_t
																																																																																							BgL_testz00_18096;
																																																																																						BgL_testz00_18096
																																																																																							=
																																																																																							BgL_arg3609z00_4135;
																																																																																						BgL_proc1z00_18097
																																																																																							=
																																																																																							BgL_carzd216405zd2_4127;
																																																																																						BgL_proc2z00_18098
																																																																																							=
																																																																																							BgL_carzd216413zd2_4130;
																																																																																						BgL_argsz00_18099
																																																																																							=
																																																																																							BgL_cdrzd216385zd2_4124;
																																																																																						BgL_argsz00_1800
																																																																																							=
																																																																																							BgL_argsz00_18099;
																																																																																						BgL_proc2z00_1799
																																																																																							=
																																																																																							BgL_proc2z00_18098;
																																																																																						BgL_proc1z00_1798
																																																																																							=
																																																																																							BgL_proc1z00_18097;
																																																																																						BgL_testz00_1797
																																																																																							=
																																																																																							BgL_testz00_18096;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1801;
																																																																																					}
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_18095);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18103;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_13657
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18103);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18107;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18107);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18111;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18111);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18115;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18115);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18119;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18119);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd216746zd2_4143;
																																																																					BgL_cdrzd216746zd2_4143
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd216752zd2_4144;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_10797;
																																																																							BgL_pairz00_10797
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd216752zd2_4144
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_10797);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd216758zd2_4145;
																																																																							BgL_cdrzd216758zd2_4145
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd216752zd2_4144));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd216763zd2_4146;
																																																																								obj_t
																																																																									BgL_cdrzd216764zd2_4147;
																																																																								BgL_carzd216763zd2_4146
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4145));
																																																																								BgL_cdrzd216764zd2_4147
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4145));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216763zd2_4146))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd216764zd2_4147))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216769zd2_4150;
																																																																												BgL_carzd216769zd2_4150
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd216764zd2_4147);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216769zd2_4150))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd216764zd2_4147)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216746zd2_4143))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3625z00_4155;
																																																																																		BgL_arg3625z00_4155
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd216752zd2_4144));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18146;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_18150;
																																																																																				obj_t
																																																																																					BgL_proc2z00_18149;
																																																																																				obj_t
																																																																																					BgL_proc1z00_18148;
																																																																																				obj_t
																																																																																					BgL_testz00_18147;
																																																																																				BgL_testz00_18147
																																																																																					=
																																																																																					BgL_arg3625z00_4155;
																																																																																				BgL_proc1z00_18148
																																																																																					=
																																																																																					BgL_carzd216763zd2_4146;
																																																																																				BgL_proc2z00_18149
																																																																																					=
																																																																																					BgL_carzd216769zd2_4150;
																																																																																				BgL_argsz00_18150
																																																																																					=
																																																																																					BgL_cdrzd216746zd2_4143;
																																																																																				BgL_argsz00_1800
																																																																																					=
																																																																																					BgL_argsz00_18150;
																																																																																				BgL_proc2z00_1799
																																																																																					=
																																																																																					BgL_proc2z00_18149;
																																																																																				BgL_proc1z00_1798
																																																																																					=
																																																																																					BgL_proc1z00_18148;
																																																																																				BgL_testz00_1797
																																																																																					=
																																																																																					BgL_testz00_18147;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1801;
																																																																																			}
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18146);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18154;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18154);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18158;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18158);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18162;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18162);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18166;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18166);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18170;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18170);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18174;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18174);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18178;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18178);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18182;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18182);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd214242zd2_4042 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3750z00_4321;
																																											obj_t
																																												BgL_arg3751z00_4322;
																																											BgL_arg3750z00_4321
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_4026));
																																											BgL_arg3751z00_4322
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_4026));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18191;
																																												{
																																													obj_t
																																														BgL_exprz00_18193;
																																													obj_t
																																														BgL_bindingsz00_18192;
																																													BgL_bindingsz00_18192
																																														=
																																														BgL_arg3750z00_4321;
																																													BgL_exprz00_18193
																																														=
																																														BgL_arg3751z00_4322;
																																													BgL_exprz00_1780
																																														=
																																														BgL_exprz00_18193;
																																													BgL_bindingsz00_1779
																																														=
																																														BgL_bindingsz00_18192;
																																													goto
																																														BgL_tagzd2382zd2_1781;
																																												}
																																												BgL_auxz00_13657
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18191);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214242zd2_4042)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3753z00_4324;
																																													obj_t
																																														BgL_arg3754z00_4325;
																																													BgL_arg3753z00_4324
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_4026));
																																													BgL_arg3754z00_4325
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_4026));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18202;
																																														{
																																															obj_t
																																																BgL_exprz00_18204;
																																															obj_t
																																																BgL_bindingsz00_18203;
																																															BgL_bindingsz00_18203
																																																=
																																																BgL_arg3753z00_4324;
																																															BgL_exprz00_18204
																																																=
																																																BgL_arg3754z00_4325;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_18204;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_18203;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18202);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd214242zd2_4042 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3756z00_4327;
																																															obj_t
																																																BgL_arg3757z00_4328;
																																															BgL_arg3756z00_4327
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_4026));
																																															BgL_arg3757z00_4328
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_4026));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18213;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18215;
																																																	obj_t
																																																		BgL_bindingsz00_18214;
																																																	BgL_bindingsz00_18214
																																																		=
																																																		BgL_arg3756z00_4327;
																																																	BgL_exprz00_18215
																																																		=
																																																		BgL_arg3757z00_4328;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_18215;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_18214;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_13657
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18213);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18222;
																																																	goto
																																																		BgL_tagzd2383zd2_1782;
																																																	BgL_auxz00_13657
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18222);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd217344zd2_4331;
																																																	BgL_carzd217344zd2_4331
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd217344zd2_4331 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18229;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18229);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217344zd2_4331)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18234;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18234);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18241;
																																																							goto
																																																								BgL_tagzd2389zd2_1802;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18241);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18248;
																																																									goto
																																																										BgL_tagzd2390zd2_1803;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18248);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217424zd2_4338;
																																																									BgL_cdrzd217424zd2_4338
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg3768z00_4341;
																																																											obj_t
																																																												BgL_arg3769z00_4342;
																																																											BgL_arg3768z00_4341
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4338));
																																																											BgL_arg3769z00_4342
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4338));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_18261;
																																																												{
																																																													obj_t
																																																														BgL_restz00_18263;
																																																													obj_t
																																																														BgL_effectz00_18262;
																																																													BgL_effectz00_18262
																																																														=
																																																														BgL_arg3768z00_4341;
																																																													BgL_restz00_18263
																																																														=
																																																														BgL_arg3769z00_4342;
																																																													BgL_restz00_1805
																																																														=
																																																														BgL_restz00_18263;
																																																													BgL_effectz00_1804
																																																														=
																																																														BgL_effectz00_18262;
																																																													goto
																																																														BgL_tagzd2391zd2_1806;
																																																												}
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_18261);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18270;
																																																													goto
																																																														BgL_tagzd2392zd2_1807;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18270);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18277;
																																																															goto
																																																																BgL_tagzd2393zd2_1808;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18277);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3776z00_4350;
																																																																	obj_t
																																																																		BgL_arg3777z00_4351;
																																																																	BgL_arg3776z00_4350
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4338));
																																																																	BgL_arg3777z00_4351
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4338));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18288;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_18290;
																																																																			obj_t
																																																																				BgL_effectz00_18289;
																																																																			BgL_effectz00_18289
																																																																				=
																																																																				BgL_arg3776z00_4350;
																																																																			BgL_restz00_18290
																																																																				=
																																																																				BgL_arg3777z00_4351;
																																																																			BgL_restz00_1810
																																																																				=
																																																																				BgL_restz00_18290;
																																																																			BgL_effectz00_1809
																																																																				=
																																																																				BgL_effectz00_18289;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1811;
																																																																		}
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18288);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18297;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1812;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18297);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18304;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1813;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18304);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_18311;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1814;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18311);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_18318;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1815;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18318);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8229z00_18325;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_18326;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10833;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10832;
																																																																														BgL_pairz00_10832
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_10833
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10832);
																																																																													}
																																																																													BgL_tmpz00_18326
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10833);
																																																																												}
																																																																												BgL_test8229z00_18325
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_18326);
																																																																											}
																																																																											if (BgL_test8229z00_18325)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18332;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1816;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18332);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18336;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18336);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd217512zd2_4370;
																																																																											BgL_cdrzd217512zd2_4370
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd217518zd2_4373;
																																																																													BgL_cdrzd217518zd2_4373
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd217512zd2_4370));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd217524zd2_4374;
																																																																														BgL_cdrzd217524zd2_4374
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd217518zd2_4373));
																																																																														if ((CAR(((obj_t) BgL_cdrzd217518zd2_4373)) == CNST_TABLE_REF(((long) 31))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd217524zd2_4374))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3801z00_4378;
																																																																																		obj_t
																																																																																			BgL_arg3802z00_4379;
																																																																																		obj_t
																																																																																			BgL_arg3803z00_4380;
																																																																																		BgL_arg3801z00_4378
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4370));
																																																																																		BgL_arg3802z00_4379
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd217524zd2_4374);
																																																																																		BgL_arg3803z00_4380
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd217524zd2_4374);
																																																																																		{	/* Ast/sexp.scm 553 */
																																																																																			obj_t
																																																																																				BgL_arg7022z00_10842;
																																																																																			BgL_arg7022z00_10842
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3801z00_4378,
																																																																																					BgL_arg3802z00_4379,
																																																																																					BgL_arg3803z00_4380,
																																																																																					BgL_stackz00_22,
																																																																																					BgL_arg7022z00_10842,
																																																																																					BgL_sitez00_24));
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3804z00_4382;
																																																																																		obj_t
																																																																																			BgL_arg3805z00_4383;
																																																																																		BgL_arg3804z00_4382
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4370));
																																																																																		BgL_arg3805z00_4383
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4370));
																																																																																		{	/* Ast/sexp.scm 555 */
																																																																																			obj_t
																																																																																				BgL_arg7023z00_10846;
																																																																																			BgL_arg7023z00_10846
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3804z00_4382,
																																																																																					CNST_TABLE_REF
																																																																																					(((long) 4)), BgL_arg3805z00_4383, BgL_stackz00_22, BgL_arg7023z00_10846, BgL_sitez00_24));
																																																																															}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg3806z00_4385;
																																																																																obj_t
																																																																																	BgL_arg3807z00_4386;
																																																																																BgL_arg3806z00_4385
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4370));
																																																																																BgL_arg3807z00_4386
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4370));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7023z00_10850;
																																																																																	BgL_arg7023z00_10850
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg3806z00_4385,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg3807z00_4386, BgL_stackz00_22, BgL_arg7023z00_10850, BgL_sitez00_24));
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18381;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18381);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd217575zd2_4405;
																													BgL_carzd217575zd2_4405
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd217575zd2_4405
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_18388;
																															goto
																																BgL_tagzd2377zd2_1770;
																															BgL_auxz00_13657 =
																																((obj_t)
																																BgL_auxz00_18388);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd217575zd2_4405
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18392;
																																	goto
																																		BgL_tagzd2377zd2_1770;
																																	BgL_auxz00_13657
																																		=
																																		((obj_t)
																																		BgL_auxz00_18392);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18399;
																																			goto
																																				BgL_tagzd2379zd2_1774;
																																			BgL_auxz00_13657
																																				=
																																				((obj_t)
																																				BgL_auxz00_18399);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_18406;
																																					goto
																																						BgL_tagzd2380zd2_1775;
																																					BgL_auxz00_13657
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_18406);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd217644zd2_4412;
																																					BgL_carzd217644zd2_4412
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd217644zd2_4412))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd217647zd2_4414;
																																							obj_t
																																								BgL_cdrzd217648zd2_4415;
																																							BgL_carzd217647zd2_4414
																																								=
																																								CAR
																																								(BgL_carzd217644zd2_4412);
																																							BgL_cdrzd217648zd2_4415
																																								=
																																								CDR
																																								(BgL_carzd217644zd2_4412);
																																							{

																																								if ((BgL_carzd217647zd2_4414 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd217649zd2_4416:
																																										if (PAIRP(BgL_cdrzd217648zd2_4415))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd217652zd2_4598;
																																												BgL_cdrzd217652zd2_4598
																																													=
																																													CDR
																																													(BgL_cdrzd217648zd2_4415);
																																												if (PAIRP(BgL_cdrzd217652zd2_4598))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd217652zd2_4598)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3961z00_4602;
																																																obj_t
																																																	BgL_arg3962z00_4603;
																																																BgL_arg3961z00_4602
																																																	=
																																																	CAR
																																																	(BgL_cdrzd217652zd2_4598);
																																																BgL_arg3962z00_4603
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18428;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_18430;
																																																		obj_t
																																																			BgL_bodyz00_18429;
																																																		BgL_bodyz00_18429
																																																			=
																																																			BgL_arg3961z00_4602;
																																																		BgL_argsz00_18430
																																																			=
																																																			BgL_arg3962z00_4603;
																																																		BgL_argsz00_1777
																																																			=
																																																			BgL_argsz00_18430;
																																																		BgL_bodyz00_1776
																																																			=
																																																			BgL_bodyz00_18429;
																																																		goto
																																																			BgL_tagzd2381zd2_1778;
																																																	}
																																																	BgL_auxz00_13657
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18428);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd217676zd2_4604;
																																																BgL_cdrzd217676zd2_4604
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8244z00_18434;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4031z00_4715;
																																																		BgL_arg4031z00_4715
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8244z00_18434
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg4031z00_4715));
																																																	}
																																																	if (BgL_test8244z00_18434)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3965z00_4607;
																																																			obj_t
																																																				BgL_arg3966z00_4608;
																																																			BgL_arg3965z00_4607
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4604));
																																																			BgL_arg3966z00_4608
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4604));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18443;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18445;
																																																					obj_t
																																																						BgL_bindingsz00_18444;
																																																					BgL_bindingsz00_18444
																																																						=
																																																						BgL_arg3965z00_4607;
																																																					BgL_exprz00_18445
																																																						=
																																																						BgL_arg3966z00_4608;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_18445;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_18444;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18443);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8245z00_18447;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg4030z00_4714;
																																																				BgL_arg4030z00_4714
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8245z00_18447
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg4030z00_4714));
																																																			}
																																																			if (BgL_test8245z00_18447)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18452;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18452);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd217743zd2_4611;
																																																					BgL_carzd217743zd2_4611
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd217748zd2_4612;
																																																						BgL_cdrzd217748zd2_4612
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd217743zd2_4611));
																																																						if ((CAR(((obj_t) BgL_carzd217743zd2_4611)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3971z00_4615;
																																																								obj_t
																																																									BgL_arg3972z00_4616;
																																																								obj_t
																																																									BgL_arg3973z00_4617;
																																																								BgL_arg3971z00_4615
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4612));
																																																								BgL_arg3972z00_4616
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4612));
																																																								BgL_arg3973z00_4617
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18469;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18472;
																																																										obj_t
																																																											BgL_bodyz00_18471;
																																																										obj_t
																																																											BgL_varsz00_18470;
																																																										BgL_varsz00_18470
																																																											=
																																																											BgL_arg3971z00_4615;
																																																										BgL_bodyz00_18471
																																																											=
																																																											BgL_arg3972z00_4616;
																																																										BgL_argsz00_18472
																																																											=
																																																											BgL_arg3973z00_4617;
																																																										BgL_argsz00_1790
																																																											=
																																																											BgL_argsz00_18472;
																																																										BgL_bodyz00_1789
																																																											=
																																																											BgL_bodyz00_18471;
																																																										BgL_varsz00_1788
																																																											=
																																																											BgL_varsz00_18470;
																																																										goto
																																																											BgL_tagzd2386zd2_1791;
																																																									}
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18469);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd217771zd2_4619;
																																																								BgL_cdrzd217771zd2_4619
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217777zd2_4620;
																																																									BgL_cdrzd217777zd2_4620
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd217743zd2_4611));
																																																									if ((CAR(((obj_t) BgL_carzd217743zd2_4611)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd217783zd2_4623;
																																																											BgL_cdrzd217783zd2_4623
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217777zd2_4620));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd217788zd2_4624;
																																																												obj_t
																																																													BgL_cdrzd217789zd2_4625;
																																																												BgL_carzd217788zd2_4624
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4623));
																																																												BgL_cdrzd217789zd2_4625
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4623));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217788zd2_4624))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd217789zd2_4625))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd217796zd2_4628;
																																																																BgL_carzd217796zd2_4628
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd217789zd2_4625);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217796zd2_4628))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd217789zd2_4625)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test8252z00_18499;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1398z00_4661;
																																																																					BgL_l1398z00_4661
																																																																						=
																																																																						BgL_cdrzd217771zd2_4619;
																																																																				BgL_zc3z04anonymousza33996ze3z87_4662:
																																																																					if (NULLP(BgL_l1398z00_4661))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8252z00_18499
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test8254z00_18502;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8255z00_18503;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_18504;
																																																																									BgL_tmpz00_18504
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1398z00_4661));
																																																																									BgL_test8255z00_18503
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_18504);
																																																																								}
																																																																								if (BgL_test8255z00_18503)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8254z00_18502
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8254z00_18502
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test8254z00_18502)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1398z00_18508;
																																																																									BgL_l1398z00_18508
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1398z00_4661));
																																																																									BgL_l1398z00_4661
																																																																										=
																																																																										BgL_l1398z00_18508;
																																																																									goto
																																																																										BgL_zc3z04anonymousza33996ze3z87_4662;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8252z00_18499
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test8252z00_18499)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg3986z00_4644;
																																																																						BgL_arg3986z00_4644
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd217777zd2_4620));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18513;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_18517;
																																																																								obj_t
																																																																									BgL_proc2z00_18516;
																																																																								obj_t
																																																																									BgL_proc1z00_18515;
																																																																								obj_t
																																																																									BgL_testz00_18514;
																																																																								BgL_testz00_18514
																																																																									=
																																																																									BgL_arg3986z00_4644;
																																																																								BgL_proc1z00_18515
																																																																									=
																																																																									BgL_carzd217788zd2_4624;
																																																																								BgL_proc2z00_18516
																																																																									=
																																																																									BgL_carzd217796zd2_4628;
																																																																								BgL_argsz00_18517
																																																																									=
																																																																									BgL_cdrzd217771zd2_4619;
																																																																								BgL_argsz00_1795
																																																																									=
																																																																									BgL_argsz00_18517;
																																																																								BgL_proc2z00_1794
																																																																									=
																																																																									BgL_proc2z00_18516;
																																																																								BgL_proc1z00_1793
																																																																									=
																																																																									BgL_proc1z00_18515;
																																																																								BgL_testz00_1792
																																																																									=
																																																																									BgL_testz00_18514;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1796;
																																																																							}
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18513);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd217820zd2_4645;
																																																																						BgL_cdrzd217820zd2_4645
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd217827zd2_4646;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10886;
																																																																								BgL_pairz00_10886
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd217827zd2_4646
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10886);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd217834zd2_4647;
																																																																								BgL_cdrzd217834zd2_4647
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd217827zd2_4646));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd217840zd2_4648;
																																																																									BgL_carzd217840zd2_4648
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd217834zd2_4647));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217840zd2_4648))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd217847zd2_4650;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10890;
																																																																												BgL_pairz00_10890
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd217834zd2_4647));
																																																																												BgL_carzd217847zd2_4650
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_10890);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217847zd2_4650))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd217820zd2_4645))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3990z00_4653;
																																																																															BgL_arg3990z00_4653
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd217827zd2_4646));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18539;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_18543;
																																																																																	obj_t
																																																																																		BgL_proc2z00_18542;
																																																																																	obj_t
																																																																																		BgL_proc1z00_18541;
																																																																																	obj_t
																																																																																		BgL_testz00_18540;
																																																																																	BgL_testz00_18540
																																																																																		=
																																																																																		BgL_arg3990z00_4653;
																																																																																	BgL_proc1z00_18541
																																																																																		=
																																																																																		BgL_carzd217840zd2_4648;
																																																																																	BgL_proc2z00_18542
																																																																																		=
																																																																																		BgL_carzd217847zd2_4650;
																																																																																	BgL_argsz00_18543
																																																																																		=
																																																																																		BgL_cdrzd217820zd2_4645;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_18543;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_18542;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_18541;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_18540;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18539);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18547;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18547);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18551;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18551);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18555;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18555);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_18559;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_18559);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd218123zd2_4672;
																																																																		BgL_cdrzd218123zd2_4672
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd218129zd2_4673;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_10894;
																																																																				BgL_pairz00_10894
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd218129zd2_4673
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10894);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd218135zd2_4674;
																																																																				BgL_cdrzd218135zd2_4674
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd218129zd2_4673));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218140zd2_4675;
																																																																					obj_t
																																																																						BgL_cdrzd218141zd2_4676;
																																																																					BgL_carzd218140zd2_4675
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4674));
																																																																					BgL_cdrzd218141zd2_4676
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4674));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218140zd2_4675))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd218146zd2_4678;
																																																																							BgL_carzd218146zd2_4678
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd218141zd2_4676));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218146zd2_4678))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd218141zd2_4676))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218123zd2_4672))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4005z00_4683;
																																																																													BgL_arg4005z00_4683
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd218129zd2_4673));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18586;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18590;
																																																																															obj_t
																																																																																BgL_proc2z00_18589;
																																																																															obj_t
																																																																																BgL_proc1z00_18588;
																																																																															obj_t
																																																																																BgL_testz00_18587;
																																																																															BgL_testz00_18587
																																																																																=
																																																																																BgL_arg4005z00_4683;
																																																																															BgL_proc1z00_18588
																																																																																=
																																																																																BgL_carzd218140zd2_4675;
																																																																															BgL_proc2z00_18589
																																																																																=
																																																																																BgL_carzd218146zd2_4678;
																																																																															BgL_argsz00_18590
																																																																																=
																																																																																BgL_cdrzd218123zd2_4672;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_18590;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_18589;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_18588;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_18587;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18586);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18594;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18594);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18598;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18598);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18602;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18602);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18606;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18606);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18610;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18610);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd218479zd2_4691;
																																																														BgL_cdrzd218479zd2_4691
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd218486zd2_4692;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_10903;
																																																																BgL_pairz00_10903
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd218486zd2_4692
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_10903);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd218493zd2_4693;
																																																																BgL_cdrzd218493zd2_4693
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd218486zd2_4692));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd218499zd2_4694;
																																																																	obj_t
																																																																		BgL_cdrzd218500zd2_4695;
																																																																	BgL_carzd218499zd2_4694
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4693));
																																																																	BgL_cdrzd218500zd2_4695
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4693));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218499zd2_4694))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd218500zd2_4695))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218507zd2_4698;
																																																																					BgL_carzd218507zd2_4698
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd218500zd2_4695);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218507zd2_4698))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd218500zd2_4695)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218479zd2_4691))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg4019z00_4703;
																																																																											BgL_arg4019z00_4703
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd218486zd2_4692));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18637;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_18641;
																																																																													obj_t
																																																																														BgL_proc2z00_18640;
																																																																													obj_t
																																																																														BgL_proc1z00_18639;
																																																																													obj_t
																																																																														BgL_testz00_18638;
																																																																													BgL_testz00_18638
																																																																														=
																																																																														BgL_arg4019z00_4703;
																																																																													BgL_proc1z00_18639
																																																																														=
																																																																														BgL_carzd218499zd2_4694;
																																																																													BgL_proc2z00_18640
																																																																														=
																																																																														BgL_carzd218507zd2_4698;
																																																																													BgL_argsz00_18641
																																																																														=
																																																																														BgL_cdrzd218479zd2_4691;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_18641;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_18640;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_18639;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_18638;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18637);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18645;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18645);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18649;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18649);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18653;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18653);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18657;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18657);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18661;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18661);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18665;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18665);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd218900zd2_4717;
																																														BgL_cdrzd218900zd2_4717
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8283z00_18669;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4048z00_4734;
																																																BgL_arg4048z00_4734
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8283z00_18669
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg4048z00_4734));
																																															}
																																															if (BgL_test8283z00_18669)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4036z00_4720;
																																																	obj_t
																																																		BgL_arg4037z00_4721;
																																																	BgL_arg4036z00_4720
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4717));
																																																	BgL_arg4037z00_4721
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4717));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18678;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18680;
																																																			obj_t
																																																				BgL_bindingsz00_18679;
																																																			BgL_bindingsz00_18679
																																																				=
																																																				BgL_arg4036z00_4720;
																																																			BgL_exprz00_18680
																																																				=
																																																				BgL_arg4037z00_4721;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_18680;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_18679;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18678);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8284z00_18682;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4047z00_4733;
																																																		BgL_arg4047z00_4733
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8284z00_18682
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg4047z00_4733));
																																																	}
																																																	if (BgL_test8284z00_18682)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18687;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18687);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd218966zd2_4724;
																																																			BgL_carzd218966zd2_4724
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd218971zd2_4725;
																																																				BgL_cdrzd218971zd2_4725
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd218966zd2_4724));
																																																				if ((CAR(((obj_t) BgL_carzd218966zd2_4724)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg4042z00_4728;
																																																						obj_t
																																																							BgL_arg4043z00_4729;
																																																						obj_t
																																																							BgL_arg4044z00_4730;
																																																						BgL_arg4042z00_4728
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4725));
																																																						BgL_arg4043z00_4729
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4725));
																																																						BgL_arg4044z00_4730
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18704;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_18707;
																																																								obj_t
																																																									BgL_bodyz00_18706;
																																																								obj_t
																																																									BgL_varsz00_18705;
																																																								BgL_varsz00_18705
																																																									=
																																																									BgL_arg4042z00_4728;
																																																								BgL_bodyz00_18706
																																																									=
																																																									BgL_arg4043z00_4729;
																																																								BgL_argsz00_18707
																																																									=
																																																									BgL_arg4044z00_4730;
																																																								BgL_argsz00_1790
																																																									=
																																																									BgL_argsz00_18707;
																																																								BgL_bodyz00_1789
																																																									=
																																																									BgL_bodyz00_18706;
																																																								BgL_varsz00_1788
																																																									=
																																																									BgL_varsz00_18705;
																																																								goto
																																																									BgL_tagzd2386zd2_1791;
																																																							}
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18704);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1825;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_18711;
																																																								goto
																																																									BgL_tagzd2404zd2_1826;
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_18711);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd219082zd2_4735;
																																												BgL_cdrzd219082zd2_4735
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test8287z00_18715;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4057z00_4744;
																																														BgL_arg4057z00_4744
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test8287z00_18715
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg4057z00_4744));
																																													}
																																													if (BgL_test8287z00_18715)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4051z00_4738;
																																															obj_t
																																																BgL_arg4052z00_4739;
																																															BgL_arg4051z00_4738
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4735));
																																															BgL_arg4052z00_4739
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4735));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18724;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18726;
																																																	obj_t
																																																		BgL_bindingsz00_18725;
																																																	BgL_bindingsz00_18725
																																																		=
																																																		BgL_arg4051z00_4738;
																																																	BgL_exprz00_18726
																																																		=
																																																		BgL_arg4052z00_4739;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_18726;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_18725;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_13657
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18724);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8288z00_18728;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4056z00_4743;
																																																BgL_arg4056z00_4743
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8288z00_18728
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg4056z00_4743));
																																															}
																																															if (BgL_test8288z00_18728)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_18733;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_13657
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18733);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1825;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18737;
																																																			goto
																																																				BgL_tagzd2404zd2_1826;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18737);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217647zd2_4414)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd217649zd2_4416;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd217647zd2_4414 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd217649zd2_4416;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd217647zd2_4414 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd217649zd2_4416;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217647zd2_4414)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd217649zd2_4416;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd219254zd2_4422;
																																																		BgL_cdrzd219254zd2_4422
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8294z00_18753;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3956z00_4596;
																																																				BgL_arg3956z00_4596
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8294z00_18753
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3956z00_4596));
																																																			}
																																																			if (BgL_test8294z00_18753)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3840z00_4425;
																																																					obj_t
																																																						BgL_arg3841z00_4426;
																																																					BgL_arg3840z00_4425
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4422));
																																																					BgL_arg3841z00_4426
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4422));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_18762;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_18764;
																																																							obj_t
																																																								BgL_bindingsz00_18763;
																																																							BgL_bindingsz00_18763
																																																								=
																																																								BgL_arg3840z00_4425;
																																																							BgL_exprz00_18764
																																																								=
																																																								BgL_arg3841z00_4426;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_18764;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_18763;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_13657
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_18762);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8295z00_18766;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3955z00_4595;
																																																						BgL_arg3955z00_4595
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8295z00_18766
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3955z00_4595));
																																																					}
																																																					if (BgL_test8295z00_18766)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18771;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18771);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd219307zd2_4429;
																																																							obj_t
																																																								BgL_cdrzd219308zd2_4430;
																																																							BgL_carzd219307zd2_4429
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							BgL_cdrzd219308zd2_4430
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd219312zd2_4431;
																																																								BgL_cdrzd219312zd2_4431
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd219307zd2_4429));
																																																								if ((CAR(((obj_t) BgL_carzd219307zd2_4429)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd219312zd2_4431))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd219315zd2_4435;
																																																												obj_t
																																																													BgL_cdrzd219316zd2_4436;
																																																												BgL_carzd219315zd2_4435
																																																													=
																																																													CAR
																																																													(BgL_cdrzd219312zd2_4431);
																																																												BgL_cdrzd219316zd2_4436
																																																													=
																																																													CDR
																																																													(BgL_cdrzd219312zd2_4431);
																																																												if (PAIRP(BgL_carzd219315zd2_4435))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (NULLP(CDR(BgL_carzd219315zd2_4435)))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd219316zd2_4436))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd219322zd2_4441;
																																																																		BgL_carzd219322zd2_4441
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd219316zd2_4436);
																																																																		if (PAIRP(BgL_carzd219322zd2_4441))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd219322zd2_4441))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219316zd2_4436)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd219329zd2_4446;
																																																																								BgL_carzd219329zd2_4446
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd219308zd2_4430));
																																																																								if (PAIRP(BgL_carzd219329zd2_4446))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219354zd2_4448;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10942;
																																																																											BgL_pairz00_10942
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd219354zd2_4448
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10942);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg3856z00_4449;
																																																																											obj_t
																																																																												BgL_arg3857z00_4450;
																																																																											obj_t
																																																																												BgL_arg3858z00_4451;
																																																																											BgL_arg3856z00_4449
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4448));
																																																																											BgL_arg3857z00_4450
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4448));
																																																																											BgL_arg3858z00_4451
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18816;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_18819;
																																																																													obj_t
																																																																														BgL_bodyz00_18818;
																																																																													obj_t
																																																																														BgL_varsz00_18817;
																																																																													BgL_varsz00_18817
																																																																														=
																																																																														BgL_arg3856z00_4449;
																																																																													BgL_bodyz00_18818
																																																																														=
																																																																														BgL_arg3857z00_4450;
																																																																													BgL_argsz00_18819
																																																																														=
																																																																														BgL_arg3858z00_4451;
																																																																													BgL_argsz00_1790
																																																																														=
																																																																														BgL_argsz00_18819;
																																																																													BgL_bodyz00_1789
																																																																														=
																																																																														BgL_bodyz00_18818;
																																																																													BgL_varsz00_1788
																																																																														=
																																																																														BgL_varsz00_18817;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1791;
																																																																												}
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18816);
																																																																											}
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd219308zd2_4430))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg3862z00_4455;
																																																																												BgL_arg3862z00_4455
																																																																													=
																																																																													CAR
																																																																													(BgL_carzd219315zd2_4435);
																																																																												{
																																																																													BgL_castz00_bglt
																																																																														BgL_auxz00_18826;
																																																																													BgL_varz00_1784
																																																																														=
																																																																														BgL_arg3862z00_4455;
																																																																													BgL_bodyz00_1785
																																																																														=
																																																																														BgL_carzd219322zd2_4441;
																																																																													BgL_argz00_1786
																																																																														=
																																																																														BgL_carzd219329zd2_4446;
																																																																												BgL_tagzd2385zd2_1787:
																																																																													{	/* Ast/sexp.scm 378 */
																																																																														BgL_castz00_bglt
																																																																															BgL_new1141z00_8794;
																																																																														{	/* Ast/sexp.scm 379 */
																																																																															BgL_castz00_bglt
																																																																																BgL_new1140z00_8796;
																																																																															BgL_new1140z00_8796
																																																																																=
																																																																																(
																																																																																(BgL_castz00_bglt)
																																																																																BOBJECT
																																																																																(GC_MALLOC
																																																																																	(sizeof
																																																																																		(struct
																																																																																			BgL_castz00_bgl))));
																																																																															{	/* Ast/sexp.scm 379 */
																																																																																long
																																																																																	BgL_arg6873z00_8797;
																																																																																BgL_arg6873z00_8797
																																																																																	=
																																																																																	BGL_CLASS_INDEX
																																																																																	(BGl_castz00zzast_nodez00);
																																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																																	(
																																																																																	((BgL_objectz00_bglt) BgL_new1140z00_8796), BgL_arg6873z00_8797);
																																																																															}
																																																																															{	/* Ast/sexp.scm 379 */
																																																																																BgL_objectz00_bglt
																																																																																	BgL_tmpz00_18831;
																																																																																BgL_tmpz00_18831
																																																																																	=
																																																																																	(
																																																																																	(BgL_objectz00_bglt)
																																																																																	BgL_new1140z00_8796);
																																																																																BGL_OBJECT_WIDENING_SET
																																																																																	(BgL_tmpz00_18831,
																																																																																	BFALSE);
																																																																															}
																																																																															((BgL_objectz00_bglt) BgL_new1140z00_8796);
																																																																															BgL_new1141z00_8794
																																																																																=
																																																																																BgL_new1140z00_8796;
																																																																														}
																																																																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1141z00_8794)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																														{
																																																																															BgL_typez00_bglt
																																																																																BgL_auxz00_18837;
																																																																															{	/* Ast/sexp.scm 380 */
																																																																																obj_t
																																																																																	BgL_arg6872z00_8795;
																																																																																BgL_arg6872z00_8795
																																																																																	=
																																																																																	BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																																	(BgL_bodyz00_1785);
																																																																																BgL_auxz00_18837
																																																																																	=
																																																																																	BGl_usezd2typez12zc0zztype_envz00
																																																																																	(BgL_arg6872z00_8795,
																																																																																	BgL_locz00_23);
																																																																															}
																																																																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1141z00_8794)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_18837), BUNSPEC);
																																																																														}
																																																																														((((BgL_castz00_bglt) COBJECT(BgL_new1141z00_8794))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1786, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																														BgL_auxz00_18826
																																																																															=
																																																																															BgL_new1141z00_8794;
																																																																													}
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18826);
																																																																											}}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219382zd2_4456;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10949;
																																																																													BgL_pairz00_10949
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd219382zd2_4456
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10949);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3863z00_4457;
																																																																													obj_t
																																																																														BgL_arg3864z00_4458;
																																																																													obj_t
																																																																														BgL_arg3865z00_4459;
																																																																													BgL_arg3863z00_4457
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4456));
																																																																													BgL_arg3864z00_4458
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4456));
																																																																													BgL_arg3865z00_4459
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18854;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18857;
																																																																															obj_t
																																																																																BgL_bodyz00_18856;
																																																																															obj_t
																																																																																BgL_varsz00_18855;
																																																																															BgL_varsz00_18855
																																																																																=
																																																																																BgL_arg3863z00_4457;
																																																																															BgL_bodyz00_18856
																																																																																=
																																																																																BgL_arg3864z00_4458;
																																																																															BgL_argsz00_18857
																																																																																=
																																																																																BgL_arg3865z00_4459;
																																																																															BgL_argsz00_1790
																																																																																=
																																																																																BgL_argsz00_18857;
																																																																															BgL_bodyz00_1789
																																																																																=
																																																																																BgL_bodyz00_18856;
																																																																															BgL_varsz00_1788
																																																																																=
																																																																																BgL_varsz00_18855;
																																																																															goto
																																																																																BgL_tagzd2386zd2_1791;
																																																																														}
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18854);
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd219408zd2_4462;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_10954;
																																																																									BgL_pairz00_10954
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd219408zd2_4462
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10954);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg3868z00_4463;
																																																																									obj_t
																																																																										BgL_arg3869z00_4464;
																																																																									obj_t
																																																																										BgL_arg3870z00_4465;
																																																																									BgL_arg3868z00_4463
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4462));
																																																																									BgL_arg3869z00_4464
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4462));
																																																																									BgL_arg3870z00_4465
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_18868;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_18871;
																																																																											obj_t
																																																																												BgL_bodyz00_18870;
																																																																											obj_t
																																																																												BgL_varsz00_18869;
																																																																											BgL_varsz00_18869
																																																																												=
																																																																												BgL_arg3868z00_4463;
																																																																											BgL_bodyz00_18870
																																																																												=
																																																																												BgL_arg3869z00_4464;
																																																																											BgL_argsz00_18871
																																																																												=
																																																																												BgL_arg3870z00_4465;
																																																																											BgL_argsz00_1790
																																																																												=
																																																																												BgL_argsz00_18871;
																																																																											BgL_bodyz00_1789
																																																																												=
																																																																												BgL_bodyz00_18870;
																																																																											BgL_varsz00_1788
																																																																												=
																																																																												BgL_varsz00_18869;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1791;
																																																																										}
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_18868);
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd219434zd2_4468;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_10959;
																																																																							BgL_pairz00_10959
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd219434zd2_4468
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_10959);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg3873z00_4469;
																																																																							obj_t
																																																																								BgL_arg3874z00_4470;
																																																																							obj_t
																																																																								BgL_arg3875z00_4471;
																																																																							BgL_arg3873z00_4469
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4468));
																																																																							BgL_arg3874z00_4470
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4468));
																																																																							BgL_arg3875z00_4471
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_18882;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_18885;
																																																																									obj_t
																																																																										BgL_bodyz00_18884;
																																																																									obj_t
																																																																										BgL_varsz00_18883;
																																																																									BgL_varsz00_18883
																																																																										=
																																																																										BgL_arg3873z00_4469;
																																																																									BgL_bodyz00_18884
																																																																										=
																																																																										BgL_arg3874z00_4470;
																																																																									BgL_argsz00_18885
																																																																										=
																																																																										BgL_arg3875z00_4471;
																																																																									BgL_argsz00_1790
																																																																										=
																																																																										BgL_argsz00_18885;
																																																																									BgL_bodyz00_1789
																																																																										=
																																																																										BgL_bodyz00_18884;
																																																																									BgL_varsz00_1788
																																																																										=
																																																																										BgL_varsz00_18883;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1791;
																																																																								}
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_18882);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd219460zd2_4473;
																																																																				BgL_cdrzd219460zd2_4473
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_carzd219307zd2_4429));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3877z00_4474;
																																																																					obj_t
																																																																						BgL_arg3878z00_4475;
																																																																					obj_t
																																																																						BgL_arg3879z00_4476;
																																																																					BgL_arg3877z00_4474
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4473));
																																																																					BgL_arg3878z00_4475
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4473));
																																																																					BgL_arg3879z00_4476
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_18895;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_18898;
																																																																							obj_t
																																																																								BgL_bodyz00_18897;
																																																																							obj_t
																																																																								BgL_varsz00_18896;
																																																																							BgL_varsz00_18896
																																																																								=
																																																																								BgL_arg3877z00_4474;
																																																																							BgL_bodyz00_18897
																																																																								=
																																																																								BgL_arg3878z00_4475;
																																																																							BgL_argsz00_18898
																																																																								=
																																																																								BgL_arg3879z00_4476;
																																																																							BgL_argsz00_1790
																																																																								=
																																																																								BgL_argsz00_18898;
																																																																							BgL_bodyz00_1789
																																																																								=
																																																																								BgL_bodyz00_18897;
																																																																							BgL_varsz00_1788
																																																																								=
																																																																								BgL_varsz00_18896;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1791;
																																																																						}
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_18895);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd219486zd2_4478;
																																																																		BgL_cdrzd219486zd2_4478
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd219307zd2_4429));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3881z00_4479;
																																																																			obj_t
																																																																				BgL_arg3882z00_4480;
																																																																			obj_t
																																																																				BgL_arg3883z00_4481;
																																																																			BgL_arg3881z00_4479
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4478));
																																																																			BgL_arg3882z00_4480
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4478));
																																																																			BgL_arg3883z00_4481
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18908;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_18911;
																																																																					obj_t
																																																																						BgL_bodyz00_18910;
																																																																					obj_t
																																																																						BgL_varsz00_18909;
																																																																					BgL_varsz00_18909
																																																																						=
																																																																						BgL_arg3881z00_4479;
																																																																					BgL_bodyz00_18910
																																																																						=
																																																																						BgL_arg3882z00_4480;
																																																																					BgL_argsz00_18911
																																																																						=
																																																																						BgL_arg3883z00_4481;
																																																																					BgL_argsz00_1790
																																																																						=
																																																																						BgL_argsz00_18911;
																																																																					BgL_bodyz00_1789
																																																																						=
																																																																						BgL_bodyz00_18910;
																																																																					BgL_varsz00_1788
																																																																						=
																																																																						BgL_varsz00_18909;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1791;
																																																																				}
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18908);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd219512zd2_4483;
																																																																BgL_cdrzd219512zd2_4483
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd219307zd2_4429));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3885z00_4484;
																																																																	obj_t
																																																																		BgL_arg3886z00_4485;
																																																																	obj_t
																																																																		BgL_arg3887z00_4486;
																																																																	BgL_arg3885z00_4484
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4483));
																																																																	BgL_arg3886z00_4485
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4483));
																																																																	BgL_arg3887z00_4486
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18921;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_18924;
																																																																			obj_t
																																																																				BgL_bodyz00_18923;
																																																																			obj_t
																																																																				BgL_varsz00_18922;
																																																																			BgL_varsz00_18922
																																																																				=
																																																																				BgL_arg3885z00_4484;
																																																																			BgL_bodyz00_18923
																																																																				=
																																																																				BgL_arg3886z00_4485;
																																																																			BgL_argsz00_18924
																																																																				=
																																																																				BgL_arg3887z00_4486;
																																																																			BgL_argsz00_1790
																																																																				=
																																																																				BgL_argsz00_18924;
																																																																			BgL_bodyz00_1789
																																																																				=
																																																																				BgL_bodyz00_18923;
																																																																			BgL_varsz00_1788
																																																																				=
																																																																				BgL_varsz00_18922;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1791;
																																																																		}
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18921);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219538zd2_4489;
																																																														BgL_cdrzd219538zd2_4489
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd219307zd2_4429));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3890z00_4490;
																																																															obj_t
																																																																BgL_arg3891z00_4491;
																																																															obj_t
																																																																BgL_arg3892z00_4492;
																																																															BgL_arg3890z00_4490
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4489));
																																																															BgL_arg3891z00_4491
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4489));
																																																															BgL_arg3892z00_4492
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_18934;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_18937;
																																																																	obj_t
																																																																		BgL_bodyz00_18936;
																																																																	obj_t
																																																																		BgL_varsz00_18935;
																																																																	BgL_varsz00_18935
																																																																		=
																																																																		BgL_arg3890z00_4490;
																																																																	BgL_bodyz00_18936
																																																																		=
																																																																		BgL_arg3891z00_4491;
																																																																	BgL_argsz00_18937
																																																																		=
																																																																		BgL_arg3892z00_4492;
																																																																	BgL_argsz00_1790
																																																																		=
																																																																		BgL_argsz00_18937;
																																																																	BgL_bodyz00_1789
																																																																		=
																																																																		BgL_bodyz00_18936;
																																																																	BgL_varsz00_1788
																																																																		=
																																																																		BgL_varsz00_18935;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1791;
																																																																}
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_18934);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_18941;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_18941);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd219676zd2_4497;
																																																										BgL_cdrzd219676zd2_4497
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd219307zd2_4429));
																																																										if ((CAR(((obj_t) BgL_carzd219307zd2_4429)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd219676zd2_4497))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219681zd2_4501;
																																																														BgL_cdrzd219681zd2_4501
																																																															=
																																																															CDR
																																																															(BgL_cdrzd219676zd2_4497);
																																																														if (PAIRP(BgL_cdrzd219681zd2_4501))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd219685zd2_4503;
																																																																obj_t
																																																																	BgL_cdrzd219686zd2_4504;
																																																																BgL_carzd219685zd2_4503
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd219681zd2_4501);
																																																																BgL_cdrzd219686zd2_4504
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd219681zd2_4501);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219685zd2_4503))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd219686zd2_4504))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd219691zd2_4507;
																																																																				BgL_carzd219691zd2_4507
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd219686zd2_4504);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219691zd2_4507))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219686zd2_4504)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8314z00_18967;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1401z00_4540;
																																																																									BgL_l1401z00_4540
																																																																										=
																																																																										BgL_cdrzd219308zd2_4430;
																																																																								BgL_zc3z04anonymousza33919ze3z87_4541:
																																																																									if (NULLP(BgL_l1401z00_4540))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8314z00_18967
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8316z00_18970;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8317z00_18971;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_18972;
																																																																													BgL_tmpz00_18972
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1401z00_4540));
																																																																													BgL_test8317z00_18971
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_18972);
																																																																												}
																																																																												if (BgL_test8317z00_18971)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8316z00_18970
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8316z00_18970
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8316z00_18970)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1401z00_18976;
																																																																													BgL_l1401z00_18976
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1401z00_4540));
																																																																													BgL_l1401z00_4540
																																																																														=
																																																																														BgL_l1401z00_18976;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33919ze3z87_4541;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8314z00_18967
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8314z00_18967)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3909z00_4523;
																																																																										BgL_arg3909z00_4523
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd219676zd2_4497);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18980;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_18984;
																																																																												obj_t
																																																																													BgL_proc2z00_18983;
																																																																												obj_t
																																																																													BgL_proc1z00_18982;
																																																																												obj_t
																																																																													BgL_testz00_18981;
																																																																												BgL_testz00_18981
																																																																													=
																																																																													BgL_arg3909z00_4523;
																																																																												BgL_proc1z00_18982
																																																																													=
																																																																													BgL_carzd219685zd2_4503;
																																																																												BgL_proc2z00_18983
																																																																													=
																																																																													BgL_carzd219691zd2_4507;
																																																																												BgL_argsz00_18984
																																																																													=
																																																																													BgL_cdrzd219308zd2_4430;
																																																																												BgL_argsz00_1795
																																																																													=
																																																																													BgL_argsz00_18984;
																																																																												BgL_proc2z00_1794
																																																																													=
																																																																													BgL_proc2z00_18983;
																																																																												BgL_proc1z00_1793
																																																																													=
																																																																													BgL_proc1z00_18982;
																																																																												BgL_testz00_1792
																																																																													=
																																																																													BgL_testz00_18981;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1796;
																																																																											}
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18980);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219716zd2_4524;
																																																																										BgL_cdrzd219716zd2_4524
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd219724zd2_4525;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10997;
																																																																												BgL_pairz00_10997
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd219724zd2_4525
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10997);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219732zd2_4526;
																																																																												BgL_cdrzd219732zd2_4526
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd219724zd2_4525));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd219739zd2_4527;
																																																																													BgL_carzd219739zd2_4527
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219732zd2_4526));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219739zd2_4527))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd219748zd2_4529;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11001;
																																																																																BgL_pairz00_11001
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd219732zd2_4526));
																																																																																BgL_carzd219748zd2_4529
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11001);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219748zd2_4529))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd219716zd2_4524))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3913z00_4532;
																																																																																			BgL_arg3913z00_4532
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd219724zd2_4525));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_19006;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_19010;
																																																																																					obj_t
																																																																																						BgL_proc2z00_19009;
																																																																																					obj_t
																																																																																						BgL_proc1z00_19008;
																																																																																					obj_t
																																																																																						BgL_testz00_19007;
																																																																																					BgL_testz00_19007
																																																																																						=
																																																																																						BgL_arg3913z00_4532;
																																																																																					BgL_proc1z00_19008
																																																																																						=
																																																																																						BgL_carzd219739zd2_4527;
																																																																																					BgL_proc2z00_19009
																																																																																						=
																																																																																						BgL_carzd219748zd2_4529;
																																																																																					BgL_argsz00_19010
																																																																																						=
																																																																																						BgL_cdrzd219716zd2_4524;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_19010;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_19009;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_19008;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_19007;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_13657
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_19006);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_19014;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_13657
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_19014);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19018;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19018);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19022;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19022);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19026;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19026);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd220026zd2_4551;
																																																																						BgL_cdrzd220026zd2_4551
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd220033zd2_4552;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11005;
																																																																								BgL_pairz00_11005
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd220033zd2_4552
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11005);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd220040zd2_4553;
																																																																								BgL_cdrzd220040zd2_4553
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd220033zd2_4552));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220046zd2_4554;
																																																																									obj_t
																																																																										BgL_cdrzd220047zd2_4555;
																																																																									BgL_carzd220046zd2_4554
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4553));
																																																																									BgL_cdrzd220047zd2_4555
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4553));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220046zd2_4554))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd220054zd2_4557;
																																																																											BgL_carzd220054zd2_4557
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd220047zd2_4555));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220054zd2_4557))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd220047zd2_4555))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220026zd2_4551))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3928z00_4562;
																																																																																	BgL_arg3928z00_4562
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd220033zd2_4552));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_19053;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_19057;
																																																																																			obj_t
																																																																																				BgL_proc2z00_19056;
																																																																																			obj_t
																																																																																				BgL_proc1z00_19055;
																																																																																			obj_t
																																																																																				BgL_testz00_19054;
																																																																																			BgL_testz00_19054
																																																																																				=
																																																																																				BgL_arg3928z00_4562;
																																																																																			BgL_proc1z00_19055
																																																																																				=
																																																																																				BgL_carzd220046zd2_4554;
																																																																																			BgL_proc2z00_19056
																																																																																				=
																																																																																				BgL_carzd220054zd2_4557;
																																																																																			BgL_argsz00_19057
																																																																																				=
																																																																																				BgL_cdrzd220026zd2_4551;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_19057;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_19056;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_19055;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_19054;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_13657
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_19053);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19061;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_13657
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19061);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19065;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19065);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19069;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19069);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19073;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19073);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19077;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19077);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd220387zd2_4570;
																																																																		BgL_cdrzd220387zd2_4570
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd220393zd2_4571;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11014;
																																																																				BgL_pairz00_11014
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd220393zd2_4571
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11014);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd220399zd2_4572;
																																																																				BgL_cdrzd220399zd2_4572
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd220393zd2_4571));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd220404zd2_4573;
																																																																					obj_t
																																																																						BgL_cdrzd220405zd2_4574;
																																																																					BgL_carzd220404zd2_4573
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4572));
																																																																					BgL_cdrzd220405zd2_4574
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4572));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220404zd2_4573))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd220405zd2_4574))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220410zd2_4577;
																																																																									BgL_carzd220410zd2_4577
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd220405zd2_4574);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220410zd2_4577))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd220405zd2_4574)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220387zd2_4570))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3942z00_4582;
																																																																															BgL_arg3942z00_4582
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd220393zd2_4571));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19104;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19108;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19107;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19106;
																																																																																	obj_t
																																																																																		BgL_testz00_19105;
																																																																																	BgL_testz00_19105
																																																																																		=
																																																																																		BgL_arg3942z00_4582;
																																																																																	BgL_proc1z00_19106
																																																																																		=
																																																																																		BgL_carzd220404zd2_4573;
																																																																																	BgL_proc2z00_19107
																																																																																		=
																																																																																		BgL_carzd220410zd2_4577;
																																																																																	BgL_argsz00_19108
																																																																																		=
																																																																																		BgL_cdrzd220387zd2_4570;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_19108;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_19107;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_19106;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_19105;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19104);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19112;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19112);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19116;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19116);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19120;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19120);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19124;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19124);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19128;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19128);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19132;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19132);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19136;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19136);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19140;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19140);
																																																													}
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_cdrzd220948zd2_4746;
																																							BgL_cdrzd220948zd2_4746
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd217644zd2_4412 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4059z00_4748;
																																									obj_t
																																										BgL_arg4060z00_4749;
																																									BgL_arg4059z00_4748
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4746));
																																									BgL_arg4060z00_4749
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4746));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_19151;
																																										{
																																											obj_t
																																												BgL_exprz00_19153;
																																											obj_t
																																												BgL_bindingsz00_19152;
																																											BgL_bindingsz00_19152
																																												=
																																												BgL_arg4059z00_4748;
																																											BgL_exprz00_19153
																																												=
																																												BgL_arg4060z00_4749;
																																											BgL_exprz00_1780
																																												=
																																												BgL_exprz00_19153;
																																											BgL_bindingsz00_1779
																																												=
																																												BgL_bindingsz00_19152;
																																											goto
																																												BgL_tagzd2382zd2_1781;
																																										}
																																										BgL_auxz00_13657
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_19151);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217644zd2_4412)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4062z00_4751;
																																											obj_t
																																												BgL_arg4063z00_4752;
																																											BgL_arg4062z00_4751
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4746));
																																											BgL_arg4063z00_4752
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4746));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_19162;
																																												{
																																													obj_t
																																														BgL_exprz00_19164;
																																													obj_t
																																														BgL_bindingsz00_19163;
																																													BgL_bindingsz00_19163
																																														=
																																														BgL_arg4062z00_4751;
																																													BgL_exprz00_19164
																																														=
																																														BgL_arg4063z00_4752;
																																													BgL_exprz00_1780
																																														=
																																														BgL_exprz00_19164;
																																													BgL_bindingsz00_1779
																																														=
																																														BgL_bindingsz00_19163;
																																													goto
																																														BgL_tagzd2382zd2_1781;
																																												}
																																												BgL_auxz00_13657
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19162);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd217644zd2_4412 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4065z00_4754;
																																													obj_t
																																														BgL_arg4066z00_4755;
																																													BgL_arg4065z00_4754
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4746));
																																													BgL_arg4066z00_4755
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4746));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19173;
																																														{
																																															obj_t
																																																BgL_exprz00_19175;
																																															obj_t
																																																BgL_bindingsz00_19174;
																																															BgL_bindingsz00_19174
																																																=
																																																BgL_arg4065z00_4754;
																																															BgL_exprz00_19175
																																																=
																																																BgL_arg4066z00_4755;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_19175;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_19174;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19173);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19182;
																																															goto
																																																BgL_tagzd2383zd2_1782;
																																															BgL_auxz00_13657
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19182);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd220985zd2_4758;
																																															BgL_carzd220985zd2_4758
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd220985zd2_4758 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19189;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_13657
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19189);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd220985zd2_4758)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19194;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19194);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19201;
																																																					goto
																																																						BgL_tagzd2389zd2_1802;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19201);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19208;
																																																							goto
																																																								BgL_tagzd2390zd2_1803;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19208);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd221065zd2_4765;
																																																							BgL_cdrzd221065zd2_4765
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4077z00_4768;
																																																									obj_t
																																																										BgL_arg4078z00_4769;
																																																									BgL_arg4077z00_4768
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4765));
																																																									BgL_arg4078z00_4769
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4765));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19221;
																																																										{
																																																											obj_t
																																																												BgL_restz00_19223;
																																																											obj_t
																																																												BgL_effectz00_19222;
																																																											BgL_effectz00_19222
																																																												=
																																																												BgL_arg4077z00_4768;
																																																											BgL_restz00_19223
																																																												=
																																																												BgL_arg4078z00_4769;
																																																											BgL_restz00_1805
																																																												=
																																																												BgL_restz00_19223;
																																																											BgL_effectz00_1804
																																																												=
																																																												BgL_effectz00_19222;
																																																											goto
																																																												BgL_tagzd2391zd2_1806;
																																																										}
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19221);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_19230;
																																																											goto
																																																												BgL_tagzd2392zd2_1807;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19230);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19237;
																																																													goto
																																																														BgL_tagzd2393zd2_1808;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19237);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg4085z00_4777;
																																																															obj_t
																																																																BgL_arg4086z00_4778;
																																																															BgL_arg4085z00_4777
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4765));
																																																															BgL_arg4086z00_4778
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4765));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19248;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_19250;
																																																																	obj_t
																																																																		BgL_effectz00_19249;
																																																																	BgL_effectz00_19249
																																																																		=
																																																																		BgL_arg4085z00_4777;
																																																																	BgL_restz00_19250
																																																																		=
																																																																		BgL_arg4086z00_4778;
																																																																	BgL_restz00_1810
																																																																		=
																																																																		BgL_restz00_19250;
																																																																	BgL_effectz00_1809
																																																																		=
																																																																		BgL_effectz00_19249;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1811;
																																																																}
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19248);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19257;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1812;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19257);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_19264;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1813;
																																																																			BgL_auxz00_13657
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_19264);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_19271;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1814;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19271);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_19278;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1815;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19278);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd221142zd2_4787;
																																																																							BgL_cdrzd221142zd2_4787
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4097z00_4790;
																																																																									obj_t
																																																																										BgL_arg4098z00_4791;
																																																																									BgL_arg4097z00_4790
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4787));
																																																																									BgL_arg4098z00_4791
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4787));
																																																																									{	/* Ast/sexp.scm 555 */
																																																																										obj_t
																																																																											BgL_arg7023z00_11051;
																																																																										BgL_arg7023z00_11051
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																												BgL_arg4097z00_4790,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4098z00_4791, BgL_stackz00_22, BgL_arg7023z00_11051, BgL_sitez00_24));
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19297;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19297);
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd221167zd2_4807;
																											BgL_carzd221167zd2_4807 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd221167zd2_4807
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_19304;
																													goto
																														BgL_tagzd2377zd2_1770;
																													BgL_auxz00_13657 =
																														((obj_t)
																														BgL_auxz00_19304);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd221167zd2_4807
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19308;
																															goto
																																BgL_tagzd2377zd2_1770;
																															BgL_auxz00_13657 =
																																((obj_t)
																																BgL_auxz00_19308);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19315;
																																	goto
																																		BgL_tagzd2379zd2_1774;
																																	BgL_auxz00_13657
																																		=
																																		((obj_t)
																																		BgL_auxz00_19315);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19322;
																																			goto
																																				BgL_tagzd2380zd2_1775;
																																			BgL_auxz00_13657
																																				=
																																				((obj_t)
																																				BgL_auxz00_19322);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd221236zd2_4814;
																																			BgL_carzd221236zd2_4814
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd221236zd2_4814))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd221239zd2_4816;
																																					obj_t
																																						BgL_cdrzd221240zd2_4817;
																																					BgL_carzd221239zd2_4816
																																						=
																																						CAR
																																						(BgL_carzd221236zd2_4814);
																																					BgL_cdrzd221240zd2_4817
																																						=
																																						CDR
																																						(BgL_carzd221236zd2_4814);
																																					{

																																						if (
																																							(BgL_carzd221239zd2_4816
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd221241zd2_4818:
																																								if (PAIRP(BgL_cdrzd221240zd2_4817))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd221244zd2_4937;
																																										BgL_cdrzd221244zd2_4937
																																											=
																																											CDR
																																											(BgL_cdrzd221240zd2_4817);
																																										if (PAIRP(BgL_cdrzd221244zd2_4937))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd221244zd2_4937)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4200z00_4941;
																																														obj_t
																																															BgL_arg4201z00_4942;
																																														BgL_arg4200z00_4941
																																															=
																																															CAR
																																															(BgL_cdrzd221244zd2_4937);
																																														BgL_arg4201z00_4942
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19344;
																																															{
																																																obj_t
																																																	BgL_argsz00_19346;
																																																obj_t
																																																	BgL_bodyz00_19345;
																																																BgL_bodyz00_19345
																																																	=
																																																	BgL_arg4200z00_4941;
																																																BgL_argsz00_19346
																																																	=
																																																	BgL_arg4201z00_4942;
																																																BgL_argsz00_1777
																																																	=
																																																	BgL_argsz00_19346;
																																																BgL_bodyz00_1776
																																																	=
																																																	BgL_bodyz00_19345;
																																																goto
																																																	BgL_tagzd2381zd2_1778;
																																															}
																																															BgL_auxz00_13657
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19344);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test8374z00_19348;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4265z00_5048;
																																															BgL_arg4265z00_5048
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8374z00_19348
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4265z00_5048));
																																														}
																																														if (BgL_test8374z00_19348)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_19353;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_13657
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19353);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd221322zd2_4945;
																																																BgL_carzd221322zd2_4945
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd221327zd2_4946;
																																																	BgL_cdrzd221327zd2_4946
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd221322zd2_4945));
																																																	if ((CAR(((obj_t) BgL_carzd221322zd2_4945)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4206z00_4949;
																																																			obj_t
																																																				BgL_arg4207z00_4950;
																																																			obj_t
																																																				BgL_arg4208z00_4951;
																																																			BgL_arg4206z00_4949
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4946));
																																																			BgL_arg4207z00_4950
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4946));
																																																			BgL_arg4208z00_4951
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19370;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_19373;
																																																					obj_t
																																																						BgL_bodyz00_19372;
																																																					obj_t
																																																						BgL_varsz00_19371;
																																																					BgL_varsz00_19371
																																																						=
																																																						BgL_arg4206z00_4949;
																																																					BgL_bodyz00_19372
																																																						=
																																																						BgL_arg4207z00_4950;
																																																					BgL_argsz00_19373
																																																						=
																																																						BgL_arg4208z00_4951;
																																																					BgL_argsz00_1790
																																																						=
																																																						BgL_argsz00_19373;
																																																					BgL_bodyz00_1789
																																																						=
																																																						BgL_bodyz00_19372;
																																																					BgL_varsz00_1788
																																																						=
																																																						BgL_varsz00_19371;
																																																					goto
																																																						BgL_tagzd2386zd2_1791;
																																																				}
																																																				BgL_auxz00_13657
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19370);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd221350zd2_4953;
																																																			BgL_cdrzd221350zd2_4953
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd221356zd2_4954;
																																																				BgL_cdrzd221356zd2_4954
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd221322zd2_4945));
																																																				if ((CAR(((obj_t) BgL_carzd221322zd2_4945)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd221362zd2_4957;
																																																						BgL_cdrzd221362zd2_4957
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd221356zd2_4954));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd221367zd2_4958;
																																																							obj_t
																																																								BgL_cdrzd221368zd2_4959;
																																																							BgL_carzd221367zd2_4958
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4957));
																																																							BgL_cdrzd221368zd2_4959
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4957));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221367zd2_4958))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd221368zd2_4959))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd221375zd2_4962;
																																																											BgL_carzd221375zd2_4962
																																																												=
																																																												CAR
																																																												(BgL_cdrzd221368zd2_4959);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221375zd2_4962))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd221368zd2_4959)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test8381z00_19400;
																																																															{
																																																																obj_t
																																																																	BgL_l1404z00_4995;
																																																																BgL_l1404z00_4995
																																																																	=
																																																																	BgL_cdrzd221350zd2_4953;
																																																															BgL_zc3z04anonymousza34231ze3z87_4996:
																																																																if (NULLP(BgL_l1404z00_4995))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test8381z00_19400
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test8383z00_19403;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test8384z00_19404;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_19405;
																																																																				BgL_tmpz00_19405
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1404z00_4995));
																																																																				BgL_test8384z00_19404
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_19405);
																																																																			}
																																																																			if (BgL_test8384z00_19404)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test8383z00_19403
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test8383z00_19403
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test8383z00_19403)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1404z00_19409;
																																																																				BgL_l1404z00_19409
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1404z00_4995));
																																																																				BgL_l1404z00_4995
																																																																					=
																																																																					BgL_l1404z00_19409;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34231ze3z87_4996;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test8381z00_19400
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test8381z00_19400)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4221z00_4978;
																																																																	BgL_arg4221z00_4978
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd221356zd2_4954));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19414;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19418;
																																																																			obj_t
																																																																				BgL_proc2z00_19417;
																																																																			obj_t
																																																																				BgL_proc1z00_19416;
																																																																			obj_t
																																																																				BgL_testz00_19415;
																																																																			BgL_testz00_19415
																																																																				=
																																																																				BgL_arg4221z00_4978;
																																																																			BgL_proc1z00_19416
																																																																				=
																																																																				BgL_carzd221367zd2_4958;
																																																																			BgL_proc2z00_19417
																																																																				=
																																																																				BgL_carzd221375zd2_4962;
																																																																			BgL_argsz00_19418
																																																																				=
																																																																				BgL_cdrzd221350zd2_4953;
																																																																			BgL_argsz00_1795
																																																																				=
																																																																				BgL_argsz00_19418;
																																																																			BgL_proc2z00_1794
																																																																				=
																																																																				BgL_proc2z00_19417;
																																																																			BgL_proc1z00_1793
																																																																				=
																																																																				BgL_proc1z00_19416;
																																																																			BgL_testz00_1792
																																																																				=
																																																																				BgL_testz00_19415;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1796;
																																																																		}
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19414);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd221399zd2_4979;
																																																																	BgL_cdrzd221399zd2_4979
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd221406zd2_4980;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11083;
																																																																			BgL_pairz00_11083
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd221406zd2_4980
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11083);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd221413zd2_4981;
																																																																			BgL_cdrzd221413zd2_4981
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd221406zd2_4980));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd221419zd2_4982;
																																																																				BgL_carzd221419zd2_4982
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd221413zd2_4981));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221419zd2_4982))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd221426zd2_4984;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11087;
																																																																							BgL_pairz00_11087
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd221413zd2_4981));
																																																																							BgL_carzd221426zd2_4984
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_11087);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221426zd2_4984))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221399zd2_4979))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4225z00_4987;
																																																																										BgL_arg4225z00_4987
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd221406zd2_4980));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19440;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19444;
																																																																												obj_t
																																																																													BgL_proc2z00_19443;
																																																																												obj_t
																																																																													BgL_proc1z00_19442;
																																																																												obj_t
																																																																													BgL_testz00_19441;
																																																																												BgL_testz00_19441
																																																																													=
																																																																													BgL_arg4225z00_4987;
																																																																												BgL_proc1z00_19442
																																																																													=
																																																																													BgL_carzd221419zd2_4982;
																																																																												BgL_proc2z00_19443
																																																																													=
																																																																													BgL_carzd221426zd2_4984;
																																																																												BgL_argsz00_19444
																																																																													=
																																																																													BgL_cdrzd221399zd2_4979;
																																																																												BgL_argsz00_1800
																																																																													=
																																																																													BgL_argsz00_19444;
																																																																												BgL_proc2z00_1799
																																																																													=
																																																																													BgL_proc2z00_19443;
																																																																												BgL_proc1z00_1798
																																																																													=
																																																																													BgL_proc1z00_19442;
																																																																												BgL_testz00_1797
																																																																													=
																																																																													BgL_testz00_19441;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1801;
																																																																											}
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19440);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19448;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19448);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19452;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19452);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19456;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19456);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19460;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19460);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd221702zd2_5006;
																																																													BgL_cdrzd221702zd2_5006
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd221708zd2_5007;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11091;
																																																															BgL_pairz00_11091
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd221708zd2_5007
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11091);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd221714zd2_5008;
																																																															BgL_cdrzd221714zd2_5008
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221708zd2_5007));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd221719zd2_5009;
																																																																obj_t
																																																																	BgL_cdrzd221720zd2_5010;
																																																																BgL_carzd221719zd2_5009
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_5008));
																																																																BgL_cdrzd221720zd2_5010
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_5008));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221719zd2_5009))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd221725zd2_5012;
																																																																		BgL_carzd221725zd2_5012
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd221720zd2_5010));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221725zd2_5012))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd221720zd2_5010))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221702zd2_5006))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4240z00_5017;
																																																																								BgL_arg4240z00_5017
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd221708zd2_5007));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19487;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_19491;
																																																																										obj_t
																																																																											BgL_proc2z00_19490;
																																																																										obj_t
																																																																											BgL_proc1z00_19489;
																																																																										obj_t
																																																																											BgL_testz00_19488;
																																																																										BgL_testz00_19488
																																																																											=
																																																																											BgL_arg4240z00_5017;
																																																																										BgL_proc1z00_19489
																																																																											=
																																																																											BgL_carzd221719zd2_5009;
																																																																										BgL_proc2z00_19490
																																																																											=
																																																																											BgL_carzd221725zd2_5012;
																																																																										BgL_argsz00_19491
																																																																											=
																																																																											BgL_cdrzd221702zd2_5006;
																																																																										BgL_argsz00_1800
																																																																											=
																																																																											BgL_argsz00_19491;
																																																																										BgL_proc2z00_1799
																																																																											=
																																																																											BgL_proc2z00_19490;
																																																																										BgL_proc1z00_1798
																																																																											=
																																																																											BgL_proc1z00_19489;
																																																																										BgL_testz00_1797
																																																																											=
																																																																											BgL_testz00_19488;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1801;
																																																																									}
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19487);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19495;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_13657
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19495);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19499;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19499);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19503;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19503);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19507;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19507);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19511;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_13657
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19511);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd222058zd2_5025;
																																																									BgL_cdrzd222058zd2_5025
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222065zd2_5026;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_11100;
																																																											BgL_pairz00_11100
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd222065zd2_5026
																																																												=
																																																												CDR
																																																												(BgL_pairz00_11100);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd222072zd2_5027;
																																																											BgL_cdrzd222072zd2_5027
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd222065zd2_5026));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222078zd2_5028;
																																																												obj_t
																																																													BgL_cdrzd222079zd2_5029;
																																																												BgL_carzd222078zd2_5028
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_5027));
																																																												BgL_cdrzd222079zd2_5029
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_5027));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222078zd2_5028))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222079zd2_5029))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222086zd2_5032;
																																																																BgL_carzd222086zd2_5032
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222079zd2_5029);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222086zd2_5032))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222079zd2_5029)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd222058zd2_5025))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4254z00_5037;
																																																																						BgL_arg4254z00_5037
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd222065zd2_5026));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19538;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19542;
																																																																								obj_t
																																																																									BgL_proc2z00_19541;
																																																																								obj_t
																																																																									BgL_proc1z00_19540;
																																																																								obj_t
																																																																									BgL_testz00_19539;
																																																																								BgL_testz00_19539
																																																																									=
																																																																									BgL_arg4254z00_5037;
																																																																								BgL_proc1z00_19540
																																																																									=
																																																																									BgL_carzd222078zd2_5028;
																																																																								BgL_proc2z00_19541
																																																																									=
																																																																									BgL_carzd222086zd2_5032;
																																																																								BgL_argsz00_19542
																																																																									=
																																																																									BgL_cdrzd222058zd2_5025;
																																																																								BgL_argsz00_1800
																																																																									=
																																																																									BgL_argsz00_19542;
																																																																								BgL_proc2z00_1799
																																																																									=
																																																																									BgL_proc2z00_19541;
																																																																								BgL_proc1z00_1798
																																																																									=
																																																																									BgL_proc1z00_19540;
																																																																								BgL_testz00_1797
																																																																									=
																																																																									BgL_testz00_19539;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1801;
																																																																							}
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19538);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19546;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_13657
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19546);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19550;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19550);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19554;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_13657
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19554);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19558;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19558);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19562;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_13657
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19562);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1825;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19566;
																																																								goto
																																																									BgL_tagzd2404zd2_1826;
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19566);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test8412z00_19568;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4276z00_5061;
																																													BgL_arg4276z00_5061
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test8412z00_19568
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4276z00_5061));
																																												}
																																												if (BgL_test8412z00_19568)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_19573;
																																														goto
																																															BgL_tagzd2384zd2_1783;
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19573);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd222532zd2_5052;
																																														BgL_carzd222532zd2_5052
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd222537zd2_5053;
																																															BgL_cdrzd222537zd2_5053
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd222532zd2_5052));
																																															if ((CAR(((obj_t) BgL_carzd222532zd2_5052)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4271z00_5056;
																																																	obj_t
																																																		BgL_arg4272z00_5057;
																																																	obj_t
																																																		BgL_arg4273z00_5058;
																																																	BgL_arg4271z00_5056
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5053));
																																																	BgL_arg4272z00_5057
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5053));
																																																	BgL_arg4273z00_5058
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_19590;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_19593;
																																																			obj_t
																																																				BgL_bodyz00_19592;
																																																			obj_t
																																																				BgL_varsz00_19591;
																																																			BgL_varsz00_19591
																																																				=
																																																				BgL_arg4271z00_5056;
																																																			BgL_bodyz00_19592
																																																				=
																																																				BgL_arg4272z00_5057;
																																																			BgL_argsz00_19593
																																																				=
																																																				BgL_arg4273z00_5058;
																																																			BgL_argsz00_1790
																																																				=
																																																				BgL_argsz00_19593;
																																																			BgL_bodyz00_1789
																																																				=
																																																				BgL_bodyz00_19592;
																																																			BgL_varsz00_1788
																																																				=
																																																				BgL_varsz00_19591;
																																																			goto
																																																				BgL_tagzd2386zd2_1791;
																																																		}
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19590);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1825;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19597;
																																																			goto
																																																				BgL_tagzd2404zd2_1826;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19597);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test8415z00_19599;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4280z00_5065;
																																											BgL_arg4280z00_5065
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test8415z00_19599
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4280z00_5065));
																																										}
																																										if (BgL_test8415z00_19599)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_19604;
																																												goto
																																													BgL_tagzd2384zd2_1783;
																																												BgL_auxz00_13657
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19604);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1825;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19608;
																																														goto
																																															BgL_tagzd2404zd2_1826;
																																														BgL_auxz00_13657
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19608);
																																													}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd221239zd2_4816)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd221241zd2_4818;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd221239zd2_4816 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd221241zd2_4818;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd221239zd2_4816 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd221241zd2_4818;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd221239zd2_4816)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd221241zd2_4818;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test8421z00_19622;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4195z00_4935;
																																																	BgL_arg4195z00_4935
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test8421z00_19622
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4195z00_4935));
																																																}
																																																if (BgL_test8421z00_19622)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_19627;
																																																		goto
																																																			BgL_tagzd2384zd2_1783;
																																																		BgL_auxz00_13657
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19627);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd222860zd2_4826;
																																																		BgL_carzd222860zd2_4826
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd222865zd2_4827;
																																																			BgL_cdrzd222865zd2_4827
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd222860zd2_4826));
																																																			if ((CAR(((obj_t) BgL_carzd222860zd2_4826)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd222865zd2_4827))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg4131z00_4831;
																																																							obj_t
																																																								BgL_arg4132z00_4832;
																																																							obj_t
																																																								BgL_arg4133z00_4833;
																																																							BgL_arg4131z00_4831
																																																								=
																																																								CAR
																																																								(BgL_cdrzd222865zd2_4827);
																																																							BgL_arg4132z00_4832
																																																								=
																																																								CDR
																																																								(BgL_cdrzd222865zd2_4827);
																																																							BgL_arg4133z00_4833
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19644;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_19647;
																																																									obj_t
																																																										BgL_bodyz00_19646;
																																																									obj_t
																																																										BgL_varsz00_19645;
																																																									BgL_varsz00_19645
																																																										=
																																																										BgL_arg4131z00_4831;
																																																									BgL_bodyz00_19646
																																																										=
																																																										BgL_arg4132z00_4832;
																																																									BgL_argsz00_19647
																																																										=
																																																										BgL_arg4133z00_4833;
																																																									BgL_argsz00_1790
																																																										=
																																																										BgL_argsz00_19647;
																																																									BgL_bodyz00_1789
																																																										=
																																																										BgL_bodyz00_19646;
																																																									BgL_varsz00_1788
																																																										=
																																																										BgL_varsz00_19645;
																																																									goto
																																																										BgL_tagzd2386zd2_1791;
																																																								}
																																																								BgL_auxz00_13657
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19644);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_19651;
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_19651);
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd222972zd2_4836;
																																																					BgL_cdrzd222972zd2_4836
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd222977zd2_4837;
																																																						BgL_cdrzd222977zd2_4837
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd222860zd2_4826));
																																																						if ((CAR(((obj_t) BgL_carzd222860zd2_4826)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd222977zd2_4837))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222982zd2_4841;
																																																										BgL_cdrzd222982zd2_4841
																																																											=
																																																											CDR
																																																											(BgL_cdrzd222977zd2_4837);
																																																										if (PAIRP(BgL_cdrzd222982zd2_4841))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222986zd2_4843;
																																																												obj_t
																																																													BgL_cdrzd222987zd2_4844;
																																																												BgL_carzd222986zd2_4843
																																																													=
																																																													CAR
																																																													(BgL_cdrzd222982zd2_4841);
																																																												BgL_cdrzd222987zd2_4844
																																																													=
																																																													CDR
																																																													(BgL_cdrzd222982zd2_4841);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222986zd2_4843))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222987zd2_4844))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222992zd2_4847;
																																																																BgL_carzd222992zd2_4847
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222987zd2_4844);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222992zd2_4847))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222987zd2_4844)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test8432z00_19679;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1407z00_4880;
																																																																					BgL_l1407z00_4880
																																																																						=
																																																																						BgL_cdrzd222972zd2_4836;
																																																																				BgL_zc3z04anonymousza34159ze3z87_4881:
																																																																					if (NULLP(BgL_l1407z00_4880))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8432z00_19679
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test8434z00_19682;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8435z00_19683;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_19684;
																																																																									BgL_tmpz00_19684
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1407z00_4880));
																																																																									BgL_test8435z00_19683
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_19684);
																																																																								}
																																																																								if (BgL_test8435z00_19683)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8434z00_19682
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8434z00_19682
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test8434z00_19682)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1407z00_19688;
																																																																									BgL_l1407z00_19688
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1407z00_4880));
																																																																									BgL_l1407z00_4880
																																																																										=
																																																																										BgL_l1407z00_19688;
																																																																									goto
																																																																										BgL_zc3z04anonymousza34159ze3z87_4881;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8432z00_19679
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test8432z00_19679)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4149z00_4863;
																																																																						BgL_arg4149z00_4863
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd222977zd2_4837);
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19692;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19696;
																																																																								obj_t
																																																																									BgL_proc2z00_19695;
																																																																								obj_t
																																																																									BgL_proc1z00_19694;
																																																																								obj_t
																																																																									BgL_testz00_19693;
																																																																								BgL_testz00_19693
																																																																									=
																																																																									BgL_arg4149z00_4863;
																																																																								BgL_proc1z00_19694
																																																																									=
																																																																									BgL_carzd222986zd2_4843;
																																																																								BgL_proc2z00_19695
																																																																									=
																																																																									BgL_carzd222992zd2_4847;
																																																																								BgL_argsz00_19696
																																																																									=
																																																																									BgL_cdrzd222972zd2_4836;
																																																																								BgL_argsz00_1795
																																																																									=
																																																																									BgL_argsz00_19696;
																																																																								BgL_proc2z00_1794
																																																																									=
																																																																									BgL_proc2z00_19695;
																																																																								BgL_proc1z00_1793
																																																																									=
																																																																									BgL_proc1z00_19694;
																																																																								BgL_testz00_1792
																																																																									=
																																																																									BgL_testz00_19693;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1796;
																																																																							}
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19692);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd223017zd2_4864;
																																																																						BgL_cdrzd223017zd2_4864
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd223025zd2_4865;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11136;
																																																																								BgL_pairz00_11136
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd223025zd2_4865
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11136);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd223033zd2_4866;
																																																																								BgL_cdrzd223033zd2_4866
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd223025zd2_4865));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd223040zd2_4867;
																																																																									BgL_carzd223040zd2_4867
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd223033zd2_4866));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223040zd2_4867))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd223049zd2_4869;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11140;
																																																																												BgL_pairz00_11140
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd223033zd2_4866));
																																																																												BgL_carzd223049zd2_4869
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11140);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223049zd2_4869))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223017zd2_4864))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4153z00_4872;
																																																																															BgL_arg4153z00_4872
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd223025zd2_4865));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19718;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19722;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19721;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19720;
																																																																																	obj_t
																																																																																		BgL_testz00_19719;
																																																																																	BgL_testz00_19719
																																																																																		=
																																																																																		BgL_arg4153z00_4872;
																																																																																	BgL_proc1z00_19720
																																																																																		=
																																																																																		BgL_carzd223040zd2_4867;
																																																																																	BgL_proc2z00_19721
																																																																																		=
																																																																																		BgL_carzd223049zd2_4869;
																																																																																	BgL_argsz00_19722
																																																																																		=
																																																																																		BgL_cdrzd223017zd2_4864;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_19722;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_19721;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_19720;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_19719;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_13657
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19718);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19726;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_13657
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19726);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19730;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19730);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19734;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19734);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19738;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_13657
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19738);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd223327zd2_4891;
																																																																		BgL_cdrzd223327zd2_4891
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd223334zd2_4892;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11144;
																																																																				BgL_pairz00_11144
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd223334zd2_4892
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11144);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd223341zd2_4893;
																																																																				BgL_cdrzd223341zd2_4893
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd223334zd2_4892));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223347zd2_4894;
																																																																					obj_t
																																																																						BgL_cdrzd223348zd2_4895;
																																																																					BgL_carzd223347zd2_4894
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4893));
																																																																					BgL_cdrzd223348zd2_4895
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4893));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223347zd2_4894))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd223355zd2_4897;
																																																																							BgL_carzd223355zd2_4897
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd223348zd2_4895));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223355zd2_4897))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd223348zd2_4895))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223327zd2_4891))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4168z00_4902;
																																																																													BgL_arg4168z00_4902
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd223334zd2_4892));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19765;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19769;
																																																																															obj_t
																																																																																BgL_proc2z00_19768;
																																																																															obj_t
																																																																																BgL_proc1z00_19767;
																																																																															obj_t
																																																																																BgL_testz00_19766;
																																																																															BgL_testz00_19766
																																																																																=
																																																																																BgL_arg4168z00_4902;
																																																																															BgL_proc1z00_19767
																																																																																=
																																																																																BgL_carzd223347zd2_4894;
																																																																															BgL_proc2z00_19768
																																																																																=
																																																																																BgL_carzd223355zd2_4897;
																																																																															BgL_argsz00_19769
																																																																																=
																																																																																BgL_cdrzd223327zd2_4891;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_19769;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_19768;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_19767;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_19766;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_13657
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19765);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19773;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_13657
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19773);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19777;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19777);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19781;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19781);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19785;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19785);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19789;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_13657
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19789);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd223688zd2_4910;
																																																														BgL_cdrzd223688zd2_4910
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd223694zd2_4911;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_11153;
																																																																BgL_pairz00_11153
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd223694zd2_4911
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11153);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd223700zd2_4912;
																																																																BgL_cdrzd223700zd2_4912
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd223694zd2_4911));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd223705zd2_4913;
																																																																	obj_t
																																																																		BgL_cdrzd223706zd2_4914;
																																																																	BgL_carzd223705zd2_4913
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4912));
																																																																	BgL_cdrzd223706zd2_4914
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4912));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223705zd2_4913))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd223706zd2_4914))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223711zd2_4917;
																																																																					BgL_carzd223711zd2_4917
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd223706zd2_4914);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223711zd2_4917))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd223706zd2_4914)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223688zd2_4910))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg4182z00_4922;
																																																																											BgL_arg4182z00_4922
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd223694zd2_4911));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19816;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19820;
																																																																													obj_t
																																																																														BgL_proc2z00_19819;
																																																																													obj_t
																																																																														BgL_proc1z00_19818;
																																																																													obj_t
																																																																														BgL_testz00_19817;
																																																																													BgL_testz00_19817
																																																																														=
																																																																														BgL_arg4182z00_4922;
																																																																													BgL_proc1z00_19818
																																																																														=
																																																																														BgL_carzd223705zd2_4913;
																																																																													BgL_proc2z00_19819
																																																																														=
																																																																														BgL_carzd223711zd2_4917;
																																																																													BgL_argsz00_19820
																																																																														=
																																																																														BgL_cdrzd223688zd2_4910;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_19820;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_19819;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_19818;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_19817;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																												BgL_auxz00_13657
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19816);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19824;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_13657
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19824);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19828;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_13657
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19828);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19832;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_13657
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19832);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19836;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_13657
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19836);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_19840;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_13657
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19840);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19844;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_13657
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19844);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_19848;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_13657
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_19848);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19852;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_13657
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19852);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd221236zd2_4814
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_19857;
																																							goto
																																								BgL_tagzd2383zd2_1782;
																																							BgL_auxz00_13657
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_19857);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd224273zd2_5068;
																																							BgL_carzd224273zd2_5068
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd224273zd2_5068 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_19864;
																																									goto
																																										BgL_tagzd2384zd2_1783;
																																									BgL_auxz00_13657
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_19864);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224273zd2_5068)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_19869;
																																											goto
																																												BgL_tagzd2384zd2_1783;
																																											BgL_auxz00_13657
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_19869);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_19876;
																																													goto
																																														BgL_tagzd2389zd2_1802;
																																													BgL_auxz00_13657
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_19876);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19883;
																																															goto
																																																BgL_tagzd2390zd2_1803;
																																															BgL_auxz00_13657
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19883);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_19890;
																																																	goto
																																																		BgL_tagzd2392zd2_1807;
																																																	BgL_auxz00_13657
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19890);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19897;
																																																			goto
																																																				BgL_tagzd2393zd2_1808;
																																																			BgL_auxz00_13657
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19897);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19904;
																																																					goto
																																																						BgL_tagzd2395zd2_1812;
																																																					BgL_auxz00_13657
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19904);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19911;
																																																							goto
																																																								BgL_tagzd2396zd2_1813;
																																																							BgL_auxz00_13657
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19911);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_19918;
																																																									goto
																																																										BgL_tagzd2397zd2_1814;
																																																									BgL_auxz00_13657
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_19918);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_19925;
																																																											goto
																																																												BgL_tagzd2398zd2_1815;
																																																											BgL_auxz00_13657
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19925);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_19935;
																																																														BgL_tagzd2402zd2_1824:
																																																															{	/* Ast/sexp.scm 559 */
																																																																obj_t
																																																																	BgL_arg7024z00_9030;
																																																																BgL_arg7024z00_9030
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 558 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7383z00_10023;
																																																																	{	/* Ast/sexp.scm 726 */
																																																																		obj_t
																																																																			BgL_arg7138z00_10019;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7139z00_10020;
																																																																		BgL_arg7138z00_10019
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7139z00_10020
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg7024z00_9030, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 725 */
																																																																			obj_t
																																																																				BgL_list7140z00_10022;
																																																																			BgL_list7140z00_10022
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7139z00_10020), BNIL);
																																																																			BgL_res7383z00_10023
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg7024z00_9030,
																																																																					BgL_arg7138z00_10019,
																																																																					BGl_string7396z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7140z00_10022));
																																																																	}}
																																																																	BgL_auxz00_19935
																																																																		=
																																																																		BgL_res7383z00_10023;
																																																															}}
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_19935);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19949;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_13657
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19949);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_19953;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_13657
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_19953);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_13657);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									if (
																										(BgL_carzd2610zd2_1855 ==
																											BGl_za2ifza2z00zzast_sexpz00))
																										{
																											obj_t BgL_auxz00_19958;

																											goto
																												BgL_kapzd2612zd2_1857;
																											return ((BgL_nodez00_bglt)
																												BgL_auxz00_19958);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											bool_t
																												BgL_test8481z00_19960;
																											{	/* Ast/sexp.scm 119 */
																												obj_t
																													BgL_arg2252z00_2602;
																												BgL_arg2252z00_2602 =
																													CAR(BgL_expz00_21);
																												BgL_test8481z00_19960 =
																													(BgL_arg2252z00_2602
																													==
																													BGl_za2ifza2z00zzast_sexpz00);
																											}
																											if (BgL_test8481z00_19960)
																												{	/* Ast/sexp.scm 119 */
																													goto
																														BgL_tagzd2377zd2_1770;
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd224445zd2_1862;
																													BgL_cdrzd224445zd2_1862
																														=
																														CDR(BgL_expz00_21);
																													if ((CAR
																															(BgL_expz00_21) ==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd224445zd2_1862))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224448zd2_1866;
																																	obj_t
																																		BgL_cdrzd224449zd2_1867;
																																	BgL_carzd224448zd2_1866
																																		=
																																		CAR
																																		(BgL_cdrzd224445zd2_1862);
																																	BgL_cdrzd224449zd2_1867
																																		=
																																		CDR
																																		(BgL_cdrzd224445zd2_1862);
																																	if (PAIRP
																																		(BgL_carzd224448zd2_1866))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR
																																					(BgL_carzd224448zd2_1866)
																																					==
																																					CNST_TABLE_REF
																																					(((long) 14))))
																																				{	/* Ast/sexp.scm 119 */
																																					if (PAIRP(BgL_cdrzd224449zd2_1867))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(BgL_cdrzd224449zd2_1867)))
																																								{
																																									obj_t
																																										BgL_valz00_19985;
																																									obj_t
																																										BgL_lz00_19983;
																																									BgL_lz00_19983
																																										=
																																										CDR
																																										(BgL_carzd224448zd2_1866);
																																									BgL_valz00_19985
																																										=
																																										CAR
																																										(BgL_cdrzd224449zd2_1867);
																																									BgL_valz00_1772
																																										=
																																										BgL_valz00_19985;
																																									BgL_lz00_1771
																																										=
																																										BgL_lz00_19983;
																																									goto
																																										BgL_tagzd2378zd2_1773;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1774;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1774;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1774;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_expz00_21)
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2380zd2_1775;
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224574zd2_1880;
																																	BgL_carzd224574zd2_1880
																																		=
																																		CAR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_carzd224574zd2_1880))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd224577zd2_1882;
																																			obj_t
																																				BgL_cdrzd224578zd2_1883;
																																			BgL_carzd224577zd2_1882
																																				=
																																				CAR
																																				(BgL_carzd224574zd2_1880);
																																			BgL_cdrzd224578zd2_1883
																																				=
																																				CDR
																																				(BgL_carzd224574zd2_1880);
																																			{

																																				if (
																																					(BgL_carzd224577zd2_1882
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{
																																						obj_t
																																							BgL_auxz00_19999;
																																					BgL_kapzd224579zd2_1884:
																																						if (PAIRP(BgL_cdrzd224578zd2_1883))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd224582zd2_2186;
																																								BgL_cdrzd224582zd2_2186
																																									=
																																									CDR
																																									(BgL_cdrzd224578zd2_1883);
																																								if (PAIRP(BgL_cdrzd224582zd2_2186))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd224582zd2_2186)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg1941z00_2190;
																																												obj_t
																																													BgL_arg1942z00_2191;
																																												BgL_arg1941z00_2190
																																													=
																																													CAR
																																													(BgL_cdrzd224582zd2_2186);
																																												BgL_arg1942z00_2191
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20011;
																																													{
																																														obj_t
																																															BgL_argsz00_20013;
																																														obj_t
																																															BgL_bodyz00_20012;
																																														BgL_bodyz00_20012
																																															=
																																															BgL_arg1941z00_2190;
																																														BgL_argsz00_20013
																																															=
																																															BgL_arg1942z00_2191;
																																														BgL_argsz00_1777
																																															=
																																															BgL_argsz00_20013;
																																														BgL_bodyz00_1776
																																															=
																																															BgL_bodyz00_20012;
																																														goto
																																															BgL_tagzd2381zd2_1778;
																																													}
																																													BgL_auxz00_19999
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20011);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd224605zd2_2192;
																																												BgL_cdrzd224605zd2_2192
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test8494z00_20017;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2011z00_2302;
																																															BgL_arg2011z00_2302
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8494z00_20017
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg2011z00_2302));
																																														}
																																														if (BgL_test8494z00_20017)
																																															{	/* Ast/sexp.scm 119 */
																																																if (PAIRP(BgL_cdrzd224605zd2_2192))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg2013z00_2304;
																																																		obj_t
																																																			BgL_arg2014z00_2305;
																																																		BgL_arg2013z00_2304
																																																			=
																																																			CAR
																																																			(BgL_cdrzd224605zd2_2192);
																																																		BgL_arg2014z00_2305
																																																			=
																																																			CDR
																																																			(BgL_cdrzd224605zd2_2192);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20026;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_20028;
																																																				obj_t
																																																					BgL_bindingsz00_20027;
																																																				BgL_bindingsz00_20027
																																																					=
																																																					BgL_arg2013z00_2304;
																																																				BgL_exprz00_20028
																																																					=
																																																					BgL_arg2014z00_2305;
																																																				BgL_exprz00_1780
																																																					=
																																																					BgL_exprz00_20028;
																																																				BgL_bindingsz00_1779
																																																					=
																																																					BgL_bindingsz00_20027;
																																																				goto
																																																					BgL_tagzd2382zd2_1781;
																																																			}
																																																			BgL_auxz00_19999
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20026);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test8496z00_20030;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2079z00_2411;
																																																			BgL_arg2079z00_2411
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test8496z00_20030
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg2079z00_2411));
																																																		}
																																																		if (BgL_test8496z00_20030)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20035;
																																																				goto
																																																					BgL_tagzd2384zd2_1783;
																																																				BgL_auxz00_19999
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20035);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd224669zd2_2308;
																																																				BgL_carzd224669zd2_2308
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd224674zd2_2309;
																																																					BgL_cdrzd224674zd2_2309
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd224669zd2_2308));
																																																					if ((CAR(((obj_t) BgL_carzd224669zd2_2308)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2019z00_2312;
																																																							obj_t
																																																								BgL_arg2020z00_2313;
																																																							obj_t
																																																								BgL_arg2021z00_2314;
																																																							BgL_arg2019z00_2312
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2309));
																																																							BgL_arg2020z00_2313
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2309));
																																																							BgL_arg2021z00_2314
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20052;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20055;
																																																									obj_t
																																																										BgL_bodyz00_20054;
																																																									obj_t
																																																										BgL_varsz00_20053;
																																																									BgL_varsz00_20053
																																																										=
																																																										BgL_arg2019z00_2312;
																																																									BgL_bodyz00_20054
																																																										=
																																																										BgL_arg2020z00_2313;
																																																									BgL_argsz00_20055
																																																										=
																																																										BgL_arg2021z00_2314;
																																																									BgL_argsz00_1790
																																																										=
																																																										BgL_argsz00_20055;
																																																									BgL_bodyz00_1789
																																																										=
																																																										BgL_bodyz00_20054;
																																																									BgL_varsz00_1788
																																																										=
																																																										BgL_varsz00_20053;
																																																									goto
																																																										BgL_tagzd2386zd2_1791;
																																																								}
																																																								BgL_auxz00_19999
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20052);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd224697zd2_2316;
																																																							BgL_cdrzd224697zd2_2316
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd224703zd2_2317;
																																																								BgL_cdrzd224703zd2_2317
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd224669zd2_2308));
																																																								if ((CAR(((obj_t) BgL_carzd224669zd2_2308)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd224709zd2_2320;
																																																										BgL_cdrzd224709zd2_2320
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd224703zd2_2317));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd224714zd2_2321;
																																																											obj_t
																																																												BgL_cdrzd224715zd2_2322;
																																																											BgL_carzd224714zd2_2321
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2320));
																																																											BgL_cdrzd224715zd2_2322
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2320));
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224714zd2_2321))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd224715zd2_2322))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd224722zd2_2325;
																																																															BgL_carzd224722zd2_2325
																																																																=
																																																																CAR
																																																																(BgL_cdrzd224715zd2_2322);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224722zd2_2325))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd224715zd2_2322)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test8503z00_20082;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1410z00_2358;
																																																																				BgL_l1410z00_2358
																																																																					=
																																																																					BgL_cdrzd224697zd2_2316;
																																																																			BgL_zc3z04anonymousza32044ze3z87_2359:
																																																																				if (NULLP(BgL_l1410z00_2358))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test8503z00_20082
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test8505z00_20085;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test8506z00_20086;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_20087;
																																																																								BgL_tmpz00_20087
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1410z00_2358));
																																																																								BgL_test8506z00_20086
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_20087);
																																																																							}
																																																																							if (BgL_test8506z00_20086)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8505z00_20085
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8505z00_20085
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test8505z00_20085)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1410z00_20091;
																																																																								BgL_l1410z00_20091
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1410z00_2358));
																																																																								BgL_l1410z00_2358
																																																																									=
																																																																									BgL_l1410z00_20091;
																																																																								goto
																																																																									BgL_zc3z04anonymousza32044ze3z87_2359;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test8503z00_20082
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test8503z00_20082)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg2034z00_2341;
																																																																					BgL_arg2034z00_2341
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd224703zd2_2317));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20096;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20100;
																																																																							obj_t
																																																																								BgL_proc2z00_20099;
																																																																							obj_t
																																																																								BgL_proc1z00_20098;
																																																																							obj_t
																																																																								BgL_testz00_20097;
																																																																							BgL_testz00_20097
																																																																								=
																																																																								BgL_arg2034z00_2341;
																																																																							BgL_proc1z00_20098
																																																																								=
																																																																								BgL_carzd224714zd2_2321;
																																																																							BgL_proc2z00_20099
																																																																								=
																																																																								BgL_carzd224722zd2_2325;
																																																																							BgL_argsz00_20100
																																																																								=
																																																																								BgL_cdrzd224697zd2_2316;
																																																																							BgL_argsz00_1795
																																																																								=
																																																																								BgL_argsz00_20100;
																																																																							BgL_proc2z00_1794
																																																																								=
																																																																								BgL_proc2z00_20099;
																																																																							BgL_proc1z00_1793
																																																																								=
																																																																								BgL_proc1z00_20098;
																																																																							BgL_testz00_1792
																																																																								=
																																																																								BgL_testz00_20097;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1796;
																																																																						}
																																																																						BgL_auxz00_19999
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20096);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd224746zd2_2342;
																																																																					BgL_cdrzd224746zd2_2342
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd224753zd2_2343;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11213;
																																																																							BgL_pairz00_11213
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd224753zd2_2343
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11213);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd224760zd2_2344;
																																																																							BgL_cdrzd224760zd2_2344
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd224753zd2_2343));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd224766zd2_2345;
																																																																								BgL_carzd224766zd2_2345
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd224760zd2_2344));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224766zd2_2345))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd224773zd2_2347;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11217;
																																																																											BgL_pairz00_11217
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd224760zd2_2344));
																																																																											BgL_carzd224773zd2_2347
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_11217);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224773zd2_2347))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd224746zd2_2342))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2038z00_2350;
																																																																														BgL_arg2038z00_2350
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd224753zd2_2343));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20122;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_20126;
																																																																																obj_t
																																																																																	BgL_proc2z00_20125;
																																																																																obj_t
																																																																																	BgL_proc1z00_20124;
																																																																																obj_t
																																																																																	BgL_testz00_20123;
																																																																																BgL_testz00_20123
																																																																																	=
																																																																																	BgL_arg2038z00_2350;
																																																																																BgL_proc1z00_20124
																																																																																	=
																																																																																	BgL_carzd224766zd2_2345;
																																																																																BgL_proc2z00_20125
																																																																																	=
																																																																																	BgL_carzd224773zd2_2347;
																																																																																BgL_argsz00_20126
																																																																																	=
																																																																																	BgL_cdrzd224746zd2_2342;
																																																																																BgL_argsz00_1800
																																																																																	=
																																																																																	BgL_argsz00_20126;
																																																																																BgL_proc2z00_1799
																																																																																	=
																																																																																	BgL_proc2z00_20125;
																																																																																BgL_proc1z00_1798
																																																																																	=
																																																																																	BgL_proc1z00_20124;
																																																																																BgL_testz00_1797
																																																																																	=
																																																																																	BgL_testz00_20123;
																																																																																goto
																																																																																	BgL_tagzd2388zd2_1801;
																																																																															}
																																																																															BgL_auxz00_19999
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20122);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20130;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_19999
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20130);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20134;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_19999
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20134);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20138;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_19999
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20138);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20142;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_19999
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20142);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd225049zd2_2369;
																																																																	BgL_cdrzd225049zd2_2369
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd225055zd2_2370;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11221;
																																																																			BgL_pairz00_11221
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd225055zd2_2370
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11221);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225061zd2_2371;
																																																																			BgL_cdrzd225061zd2_2371
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225055zd2_2370));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225066zd2_2372;
																																																																				obj_t
																																																																					BgL_cdrzd225067zd2_2373;
																																																																				BgL_carzd225066zd2_2372
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2371));
																																																																				BgL_cdrzd225067zd2_2373
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2371));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225066zd2_2372))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225072zd2_2375;
																																																																						BgL_carzd225072zd2_2375
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225067zd2_2373));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225072zd2_2375))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd225067zd2_2373))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225049zd2_2369))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2053z00_2380;
																																																																												BgL_arg2053z00_2380
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225055zd2_2370));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20169;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20173;
																																																																														obj_t
																																																																															BgL_proc2z00_20172;
																																																																														obj_t
																																																																															BgL_proc1z00_20171;
																																																																														obj_t
																																																																															BgL_testz00_20170;
																																																																														BgL_testz00_20170
																																																																															=
																																																																															BgL_arg2053z00_2380;
																																																																														BgL_proc1z00_20171
																																																																															=
																																																																															BgL_carzd225066zd2_2372;
																																																																														BgL_proc2z00_20172
																																																																															=
																																																																															BgL_carzd225072zd2_2375;
																																																																														BgL_argsz00_20173
																																																																															=
																																																																															BgL_cdrzd225049zd2_2369;
																																																																														BgL_argsz00_1800
																																																																															=
																																																																															BgL_argsz00_20173;
																																																																														BgL_proc2z00_1799
																																																																															=
																																																																															BgL_proc2z00_20172;
																																																																														BgL_proc1z00_1798
																																																																															=
																																																																															BgL_proc1z00_20171;
																																																																														BgL_testz00_1797
																																																																															=
																																																																															BgL_testz00_20170;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1801;
																																																																													}
																																																																													BgL_auxz00_19999
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20169);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20177;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_19999
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20177);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20181;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_19999
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20181);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20185;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_19999
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20185);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20189;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_19999
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20189);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20193;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_19999
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20193);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd225405zd2_2388;
																																																													BgL_cdrzd225405zd2_2388
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd225412zd2_2389;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11230;
																																																															BgL_pairz00_11230
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd225412zd2_2389
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11230);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd225419zd2_2390;
																																																															BgL_cdrzd225419zd2_2390
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd225412zd2_2389));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd225425zd2_2391;
																																																																obj_t
																																																																	BgL_cdrzd225426zd2_2392;
																																																																BgL_carzd225425zd2_2391
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2390));
																																																																BgL_cdrzd225426zd2_2392
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2390));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225425zd2_2391))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd225426zd2_2392))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225433zd2_2395;
																																																																				BgL_carzd225433zd2_2395
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd225426zd2_2392);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225433zd2_2395))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd225426zd2_2392)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225405zd2_2388))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg2067z00_2400;
																																																																										BgL_arg2067z00_2400
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd225412zd2_2389));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20220;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20224;
																																																																												obj_t
																																																																													BgL_proc2z00_20223;
																																																																												obj_t
																																																																													BgL_proc1z00_20222;
																																																																												obj_t
																																																																													BgL_testz00_20221;
																																																																												BgL_testz00_20221
																																																																													=
																																																																													BgL_arg2067z00_2400;
																																																																												BgL_proc1z00_20222
																																																																													=
																																																																													BgL_carzd225425zd2_2391;
																																																																												BgL_proc2z00_20223
																																																																													=
																																																																													BgL_carzd225433zd2_2395;
																																																																												BgL_argsz00_20224
																																																																													=
																																																																													BgL_cdrzd225405zd2_2388;
																																																																												BgL_argsz00_1800
																																																																													=
																																																																													BgL_argsz00_20224;
																																																																												BgL_proc2z00_1799
																																																																													=
																																																																													BgL_proc2z00_20223;
																																																																												BgL_proc1z00_1798
																																																																													=
																																																																													BgL_proc1z00_20222;
																																																																												BgL_testz00_1797
																																																																													=
																																																																													BgL_testz00_20221;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1801;
																																																																											}
																																																																											BgL_auxz00_19999
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20220);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20228;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_19999
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20228);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20232;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_19999
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20232);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20236;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_19999
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20236);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20240;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_19999
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20240);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20244;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_19999
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20244);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20248;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_19999
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20248);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test8534z00_20250;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2010z00_2301;
																																																	BgL_arg2010z00_2301
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test8534z00_20250
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2010z00_2301));
																																																}
																																																if (BgL_test8534z00_20250)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20255;
																																																		goto
																																																			BgL_tagzd2384zd2_1783;
																																																		BgL_auxz00_19999
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20255);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd225865zd2_2198;
																																																		BgL_carzd225865zd2_2198
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd225870zd2_2199;
																																																			BgL_cdrzd225870zd2_2199
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd225865zd2_2198));
																																																			if ((CAR(((obj_t) BgL_carzd225865zd2_2198)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1949z00_2202;
																																																					obj_t
																																																						BgL_arg1950z00_2203;
																																																					obj_t
																																																						BgL_arg1951z00_2204;
																																																					BgL_arg1949z00_2202
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2199));
																																																					BgL_arg1950z00_2203
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2199));
																																																					BgL_arg1951z00_2204
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20272;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20275;
																																																							obj_t
																																																								BgL_bodyz00_20274;
																																																							obj_t
																																																								BgL_varsz00_20273;
																																																							BgL_varsz00_20273
																																																								=
																																																								BgL_arg1949z00_2202;
																																																							BgL_bodyz00_20274
																																																								=
																																																								BgL_arg1950z00_2203;
																																																							BgL_argsz00_20275
																																																								=
																																																								BgL_arg1951z00_2204;
																																																							BgL_argsz00_1790
																																																								=
																																																								BgL_argsz00_20275;
																																																							BgL_bodyz00_1789
																																																								=
																																																								BgL_bodyz00_20274;
																																																							BgL_varsz00_1788
																																																								=
																																																								BgL_varsz00_20273;
																																																							goto
																																																								BgL_tagzd2386zd2_1791;
																																																						}
																																																						BgL_auxz00_19999
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20272);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd225893zd2_2206;
																																																					BgL_cdrzd225893zd2_2206
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd225899zd2_2207;
																																																						BgL_cdrzd225899zd2_2207
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd225865zd2_2198));
																																																						if ((CAR(((obj_t) BgL_carzd225865zd2_2198)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd225905zd2_2210;
																																																								BgL_cdrzd225905zd2_2210
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd225899zd2_2207));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd225910zd2_2211;
																																																									obj_t
																																																										BgL_cdrzd225911zd2_2212;
																																																									BgL_carzd225910zd2_2211
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2210));
																																																									BgL_cdrzd225911zd2_2212
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2210));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225910zd2_2211))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd225911zd2_2212))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd225918zd2_2215;
																																																													BgL_carzd225918zd2_2215
																																																														=
																																																														CAR
																																																														(BgL_cdrzd225911zd2_2212);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225918zd2_2215))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd225911zd2_2212)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test8541z00_20302;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1413z00_2248;
																																																																		BgL_l1413z00_2248
																																																																			=
																																																																			BgL_cdrzd225893zd2_2206;
																																																																	BgL_zc3z04anonymousza31975ze3z87_2249:
																																																																		if (NULLP(BgL_l1413z00_2248))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test8541z00_20302
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test8543z00_20305;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test8544z00_20306;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_20307;
																																																																						BgL_tmpz00_20307
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1413z00_2248));
																																																																						BgL_test8544z00_20306
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_20307);
																																																																					}
																																																																					if (BgL_test8544z00_20306)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8543z00_20305
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8543z00_20305
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test8543z00_20305)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1413z00_20311;
																																																																						BgL_l1413z00_20311
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1413z00_2248));
																																																																						BgL_l1413z00_2248
																																																																							=
																																																																							BgL_l1413z00_20311;
																																																																						goto
																																																																							BgL_zc3z04anonymousza31975ze3z87_2249;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test8541z00_20302
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test8541z00_20302)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg1965z00_2231;
																																																																			BgL_arg1965z00_2231
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225899zd2_2207));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20316;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20320;
																																																																					obj_t
																																																																						BgL_proc2z00_20319;
																																																																					obj_t
																																																																						BgL_proc1z00_20318;
																																																																					obj_t
																																																																						BgL_testz00_20317;
																																																																					BgL_testz00_20317
																																																																						=
																																																																						BgL_arg1965z00_2231;
																																																																					BgL_proc1z00_20318
																																																																						=
																																																																						BgL_carzd225910zd2_2211;
																																																																					BgL_proc2z00_20319
																																																																						=
																																																																						BgL_carzd225918zd2_2215;
																																																																					BgL_argsz00_20320
																																																																						=
																																																																						BgL_cdrzd225893zd2_2206;
																																																																					BgL_argsz00_1795
																																																																						=
																																																																						BgL_argsz00_20320;
																																																																					BgL_proc2z00_1794
																																																																						=
																																																																						BgL_proc2z00_20319;
																																																																					BgL_proc1z00_1793
																																																																						=
																																																																						BgL_proc1z00_20318;
																																																																					BgL_testz00_1792
																																																																						=
																																																																						BgL_testz00_20317;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1796;
																																																																				}
																																																																				BgL_auxz00_19999
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20316);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225942zd2_2232;
																																																																			BgL_cdrzd225942zd2_2232
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd225949zd2_2233;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_11259;
																																																																					BgL_pairz00_11259
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd225949zd2_2233
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_11259);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd225956zd2_2234;
																																																																					BgL_cdrzd225956zd2_2234
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd225949zd2_2233));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225962zd2_2235;
																																																																						BgL_carzd225962zd2_2235
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225956zd2_2234));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225962zd2_2235))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd225969zd2_2237;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11263;
																																																																									BgL_pairz00_11263
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd225956zd2_2234));
																																																																									BgL_carzd225969zd2_2237
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_11263);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225969zd2_2237))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225942zd2_2232))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1969z00_2240;
																																																																												BgL_arg1969z00_2240
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225949zd2_2233));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20342;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20346;
																																																																														obj_t
																																																																															BgL_proc2z00_20345;
																																																																														obj_t
																																																																															BgL_proc1z00_20344;
																																																																														obj_t
																																																																															BgL_testz00_20343;
																																																																														BgL_testz00_20343
																																																																															=
																																																																															BgL_arg1969z00_2240;
																																																																														BgL_proc1z00_20344
																																																																															=
																																																																															BgL_carzd225962zd2_2235;
																																																																														BgL_proc2z00_20345
																																																																															=
																																																																															BgL_carzd225969zd2_2237;
																																																																														BgL_argsz00_20346
																																																																															=
																																																																															BgL_cdrzd225942zd2_2232;
																																																																														BgL_argsz00_1800
																																																																															=
																																																																															BgL_argsz00_20346;
																																																																														BgL_proc2z00_1799
																																																																															=
																																																																															BgL_proc2z00_20345;
																																																																														BgL_proc1z00_1798
																																																																															=
																																																																															BgL_proc1z00_20344;
																																																																														BgL_testz00_1797
																																																																															=
																																																																															BgL_testz00_20343;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1801;
																																																																													}
																																																																													BgL_auxz00_19999
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20342);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20350;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_19999
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20350);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20354;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_19999
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20354);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20358;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_19999
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20358);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_20362;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_19999
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_20362);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd226245zd2_2259;
																																																															BgL_cdrzd226245zd2_2259
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd226251zd2_2260;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_11267;
																																																																	BgL_pairz00_11267
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd226251zd2_2260
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_11267);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd226257zd2_2261;
																																																																	BgL_cdrzd226257zd2_2261
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd226251zd2_2260));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226262zd2_2262;
																																																																		obj_t
																																																																			BgL_cdrzd226263zd2_2263;
																																																																		BgL_carzd226262zd2_2262
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2261));
																																																																		BgL_cdrzd226263zd2_2263
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2261));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226262zd2_2262))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd226268zd2_2265;
																																																																				BgL_carzd226268zd2_2265
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd226263zd2_2263));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226268zd2_2265))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd226263zd2_2263))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226245zd2_2259))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1984z00_2270;
																																																																										BgL_arg1984z00_2270
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd226251zd2_2260));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20389;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20393;
																																																																												obj_t
																																																																													BgL_proc2z00_20392;
																																																																												obj_t
																																																																													BgL_proc1z00_20391;
																																																																												obj_t
																																																																													BgL_testz00_20390;
																																																																												BgL_testz00_20390
																																																																													=
																																																																													BgL_arg1984z00_2270;
																																																																												BgL_proc1z00_20391
																																																																													=
																																																																													BgL_carzd226262zd2_2262;
																																																																												BgL_proc2z00_20392
																																																																													=
																																																																													BgL_carzd226268zd2_2265;
																																																																												BgL_argsz00_20393
																																																																													=
																																																																													BgL_cdrzd226245zd2_2259;
																																																																												BgL_argsz00_1800
																																																																													=
																																																																													BgL_argsz00_20393;
																																																																												BgL_proc2z00_1799
																																																																													=
																																																																													BgL_proc2z00_20392;
																																																																												BgL_proc1z00_1798
																																																																													=
																																																																													BgL_proc1z00_20391;
																																																																												BgL_testz00_1797
																																																																													=
																																																																													BgL_testz00_20390;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1801;
																																																																											}
																																																																											BgL_auxz00_19999
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20389);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20397;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_19999
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20397);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20401;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_19999
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20401);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20405;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_19999
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20405);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20409;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_19999
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20409);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20413;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_19999
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20413);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd226601zd2_2278;
																																																											BgL_cdrzd226601zd2_2278
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd226608zd2_2279;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_11276;
																																																													BgL_pairz00_11276
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd226608zd2_2279
																																																														=
																																																														CDR
																																																														(BgL_pairz00_11276);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd226615zd2_2280;
																																																													BgL_cdrzd226615zd2_2280
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd226608zd2_2279));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd226621zd2_2281;
																																																														obj_t
																																																															BgL_cdrzd226622zd2_2282;
																																																														BgL_carzd226621zd2_2281
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2280));
																																																														BgL_cdrzd226622zd2_2282
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2280));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226621zd2_2281))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd226622zd2_2282))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226629zd2_2285;
																																																																		BgL_carzd226629zd2_2285
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd226622zd2_2282);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226629zd2_2285))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd226622zd2_2282)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226601zd2_2278))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg1998z00_2290;
																																																																								BgL_arg1998z00_2290
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd226608zd2_2279));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20440;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20444;
																																																																										obj_t
																																																																											BgL_proc2z00_20443;
																																																																										obj_t
																																																																											BgL_proc1z00_20442;
																																																																										obj_t
																																																																											BgL_testz00_20441;
																																																																										BgL_testz00_20441
																																																																											=
																																																																											BgL_arg1998z00_2290;
																																																																										BgL_proc1z00_20442
																																																																											=
																																																																											BgL_carzd226621zd2_2281;
																																																																										BgL_proc2z00_20443
																																																																											=
																																																																											BgL_carzd226629zd2_2285;
																																																																										BgL_argsz00_20444
																																																																											=
																																																																											BgL_cdrzd226601zd2_2278;
																																																																										BgL_argsz00_1800
																																																																											=
																																																																											BgL_argsz00_20444;
																																																																										BgL_proc2z00_1799
																																																																											=
																																																																											BgL_proc2z00_20443;
																																																																										BgL_proc1z00_1798
																																																																											=
																																																																											BgL_proc1z00_20442;
																																																																										BgL_testz00_1797
																																																																											=
																																																																											BgL_testz00_20441;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1801;
																																																																									}
																																																																									BgL_auxz00_19999
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20440);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20448;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_19999
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20448);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20452;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_19999
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20452);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20456;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_19999
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20456);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20460;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_19999
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20460);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20464;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_19999
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20464);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20468;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_19999
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20468);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd227021zd2_2413;
																																										BgL_cdrzd227021zd2_2413
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test8572z00_20472;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2093z00_2429;
																																													BgL_arg2093z00_2429
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test8572z00_20472
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg2093z00_2429));
																																												}
																																												if (BgL_test8572z00_20472)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd227021zd2_2413))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg2095z00_2431;
																																																obj_t
																																																	BgL_arg2096z00_2432;
																																																BgL_arg2095z00_2431
																																																	=
																																																	CAR
																																																	(BgL_cdrzd227021zd2_2413);
																																																BgL_arg2096z00_2432
																																																	=
																																																	CDR
																																																	(BgL_cdrzd227021zd2_2413);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20481;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_20483;
																																																		obj_t
																																																			BgL_bindingsz00_20482;
																																																		BgL_bindingsz00_20482
																																																			=
																																																			BgL_arg2095z00_2431;
																																																		BgL_exprz00_20483
																																																			=
																																																			BgL_arg2096z00_2432;
																																																		BgL_exprz00_1780
																																																			=
																																																			BgL_exprz00_20483;
																																																		BgL_bindingsz00_1779
																																																			=
																																																			BgL_bindingsz00_20482;
																																																		goto
																																																			BgL_tagzd2382zd2_1781;
																																																	}
																																																	BgL_auxz00_19999
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20481);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test8574z00_20485;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2106z00_2444;
																																																	BgL_arg2106z00_2444
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test8574z00_20485
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2106z00_2444));
																																																}
																																																if (BgL_test8574z00_20485)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20490;
																																																		goto
																																																			BgL_tagzd2384zd2_1783;
																																																		BgL_auxz00_19999
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20490);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd227084zd2_2435;
																																																		BgL_carzd227084zd2_2435
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd227089zd2_2436;
																																																			BgL_cdrzd227089zd2_2436
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd227084zd2_2435));
																																																			if ((CAR(((obj_t) BgL_carzd227084zd2_2435)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2101z00_2439;
																																																					obj_t
																																																						BgL_arg2102z00_2440;
																																																					obj_t
																																																						BgL_arg2103z00_2441;
																																																					BgL_arg2101z00_2439
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2436));
																																																					BgL_arg2102z00_2440
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2436));
																																																					BgL_arg2103z00_2441
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20507;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20510;
																																																							obj_t
																																																								BgL_bodyz00_20509;
																																																							obj_t
																																																								BgL_varsz00_20508;
																																																							BgL_varsz00_20508
																																																								=
																																																								BgL_arg2101z00_2439;
																																																							BgL_bodyz00_20509
																																																								=
																																																								BgL_arg2102z00_2440;
																																																							BgL_argsz00_20510
																																																								=
																																																								BgL_arg2103z00_2441;
																																																							BgL_argsz00_1790
																																																								=
																																																								BgL_argsz00_20510;
																																																							BgL_bodyz00_1789
																																																								=
																																																								BgL_bodyz00_20509;
																																																							BgL_varsz00_1788
																																																								=
																																																								BgL_varsz00_20508;
																																																							goto
																																																								BgL_tagzd2386zd2_1791;
																																																						}
																																																						BgL_auxz00_19999
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20507);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1825;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_20514;
																																																							goto
																																																								BgL_tagzd2404zd2_1826;
																																																							BgL_auxz00_19999
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_20514);
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test8577z00_20516;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2092z00_2428;
																																															BgL_arg2092z00_2428
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8577z00_20516
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2092z00_2428));
																																														}
																																														if (BgL_test8577z00_20516)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_20521;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_19999
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_20521);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd227238zd2_2419;
																																																BgL_carzd227238zd2_2419
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd227243zd2_2420;
																																																	BgL_cdrzd227243zd2_2420
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd227238zd2_2419));
																																																	if ((CAR(((obj_t) BgL_carzd227238zd2_2419)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2087z00_2423;
																																																			obj_t
																																																				BgL_arg2088z00_2424;
																																																			obj_t
																																																				BgL_arg2089z00_2425;
																																																			BgL_arg2087z00_2423
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2420));
																																																			BgL_arg2088z00_2424
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2420));
																																																			BgL_arg2089z00_2425
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_20538;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_20541;
																																																					obj_t
																																																						BgL_bodyz00_20540;
																																																					obj_t
																																																						BgL_varsz00_20539;
																																																					BgL_varsz00_20539
																																																						=
																																																						BgL_arg2087z00_2423;
																																																					BgL_bodyz00_20540
																																																						=
																																																						BgL_arg2088z00_2424;
																																																					BgL_argsz00_20541
																																																						=
																																																						BgL_arg2089z00_2425;
																																																					BgL_argsz00_1790
																																																						=
																																																						BgL_argsz00_20541;
																																																					BgL_bodyz00_1789
																																																						=
																																																						BgL_bodyz00_20540;
																																																					BgL_varsz00_1788
																																																						=
																																																						BgL_varsz00_20539;
																																																					goto
																																																						BgL_tagzd2386zd2_1791;
																																																				}
																																																				BgL_auxz00_19999
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20538);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1825;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20545;
																																																					goto
																																																						BgL_tagzd2404zd2_1826;
																																																					BgL_auxz00_19999
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20545);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd227353zd2_2445;
																																								BgL_cdrzd227353zd2_2445
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test8580z00_20549;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg2113z00_2453;
																																											BgL_arg2113z00_2453
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test8580z00_20549
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg2113z00_2453));
																																										}
																																										if (BgL_test8580z00_20549)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd227353zd2_2445))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg2115z00_2455;
																																														obj_t
																																															BgL_arg2116z00_2456;
																																														BgL_arg2115z00_2455
																																															=
																																															CAR
																																															(BgL_cdrzd227353zd2_2445);
																																														BgL_arg2116z00_2456
																																															=
																																															CDR
																																															(BgL_cdrzd227353zd2_2445);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_20558;
																																															{
																																																obj_t
																																																	BgL_exprz00_20560;
																																																obj_t
																																																	BgL_bindingsz00_20559;
																																																BgL_bindingsz00_20559
																																																	=
																																																	BgL_arg2115z00_2455;
																																																BgL_exprz00_20560
																																																	=
																																																	BgL_arg2116z00_2456;
																																																BgL_exprz00_1780
																																																	=
																																																	BgL_exprz00_20560;
																																																BgL_bindingsz00_1779
																																																	=
																																																	BgL_bindingsz00_20559;
																																																goto
																																																	BgL_tagzd2382zd2_1781;
																																															}
																																															BgL_auxz00_19999
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_20558);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test8582z00_20562;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2120z00_2460;
																																															BgL_arg2120z00_2460
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test8582z00_20562
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2120z00_2460));
																																														}
																																														if (BgL_test8582z00_20562)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_20567;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_19999
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_20567);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd2403zd2_1825;
																																																	}
																																																else
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_20571;
																																																		goto
																																																			BgL_tagzd2404zd2_1826;
																																																		BgL_auxz00_19999
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20571);
																																																	}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test8584z00_20573;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2112z00_2452;
																																													BgL_arg2112z00_2452
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test8584z00_20573
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg2112z00_2452));
																																												}
																																												if (BgL_test8584z00_20573)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_20578;
																																														goto
																																															BgL_tagzd2384zd2_1783;
																																														BgL_auxz00_19999
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20578);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1825;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_20582;
																																																goto
																																																	BgL_tagzd2404zd2_1826;
																																																BgL_auxz00_19999
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_20582);
																																															}
																																													}
																																											}
																																									}
																																								}
																																							}
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_19999);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224577zd2_1882)))
																																							{
																																								obj_t
																																									BgL_auxz00_20588;
																																								goto
																																									BgL_kapzd224579zd2_1884;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_20588);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd224577zd2_1882 == CNST_TABLE_REF(((long) 18))))
																																									{
																																										obj_t
																																											BgL_auxz00_20593;
																																										goto
																																											BgL_kapzd224579zd2_1884;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_20593);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd224577zd2_1882 == CNST_TABLE_REF(((long) 19))))
																																											{
																																												obj_t
																																													BgL_auxz00_20598;
																																												goto
																																													BgL_kapzd224579zd2_1884;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_20598);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224577zd2_1882)))
																																													{
																																														obj_t
																																															BgL_auxz00_20603;
																																														goto
																																															BgL_kapzd224579zd2_1884;
																																														return
																																															(
																																															(BgL_nodez00_bglt)
																																															BgL_auxz00_20603);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd227662zd2_1890;
																																														BgL_cdrzd227662zd2_1890
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{

																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test8590z00_20606;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg1854z00_2069;
																																																	BgL_arg1854z00_2069
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test8590z00_20606
																																																		=
																																																		CBOOL
																																																		(BGl_letzd2symzf3z21zzast_letz00
																																																		(BgL_arg1854z00_2069));
																																																}
																																																if (BgL_test8590z00_20606)
																																																	{
																																																		obj_t
																																																			BgL_auxz00_20610;
																																																		if (PAIRP(BgL_cdrzd227662zd2_1890))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg1856z00_2071;
																																																				obj_t
																																																					BgL_arg1857z00_2072;
																																																				BgL_arg1856z00_2071
																																																					=
																																																					CAR
																																																					(BgL_cdrzd227662zd2_1890);
																																																				BgL_arg1857z00_2072
																																																					=
																																																					CDR
																																																					(BgL_cdrzd227662zd2_1890);
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20615;
																																																					{
																																																						obj_t
																																																							BgL_exprz00_20617;
																																																						obj_t
																																																							BgL_bindingsz00_20616;
																																																						BgL_bindingsz00_20616
																																																							=
																																																							BgL_arg1856z00_2071;
																																																						BgL_exprz00_20617
																																																							=
																																																							BgL_arg1857z00_2072;
																																																						BgL_exprz00_1780
																																																							=
																																																							BgL_exprz00_20617;
																																																						BgL_bindingsz00_1779
																																																							=
																																																							BgL_bindingsz00_20616;
																																																						goto
																																																							BgL_tagzd2382zd2_1781;
																																																					}
																																																					BgL_auxz00_20610
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20615);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				bool_t
																																																					BgL_test8592z00_20619;
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1936z00_2184;
																																																					BgL_arg1936z00_2184
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_test8592z00_20619
																																																						=
																																																						CBOOL
																																																						(BGl_labelszd2symzf3z21zzast_labelsz00
																																																						(BgL_arg1936z00_2184));
																																																				}
																																																				if (BgL_test8592z00_20619)
																																																					{
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_20624;
																																																						goto
																																																							BgL_tagzd2384zd2_1783;
																																																						BgL_auxz00_20610
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20624);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_carzd227725zd2_2075;
																																																						BgL_carzd227725zd2_2075
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd227730zd2_2076;
																																																							BgL_cdrzd227730zd2_2076
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd227725zd2_2075));
																																																							if ((CAR(((obj_t) BgL_carzd227725zd2_2075)) == CNST_TABLE_REF(((long) 3))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd227730zd2_2076))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg1863z00_2080;
																																																											obj_t
																																																												BgL_arg1864z00_2081;
																																																											obj_t
																																																												BgL_arg1867z00_2082;
																																																											BgL_arg1863z00_2080
																																																												=
																																																												CAR
																																																												(BgL_cdrzd227730zd2_2076);
																																																											BgL_arg1864z00_2081
																																																												=
																																																												CDR
																																																												(BgL_cdrzd227730zd2_2076);
																																																											BgL_arg1867z00_2082
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20641;
																																																												{
																																																													obj_t
																																																														BgL_argsz00_20644;
																																																													obj_t
																																																														BgL_bodyz00_20643;
																																																													obj_t
																																																														BgL_varsz00_20642;
																																																													BgL_varsz00_20642
																																																														=
																																																														BgL_arg1863z00_2080;
																																																													BgL_bodyz00_20643
																																																														=
																																																														BgL_arg1864z00_2081;
																																																													BgL_argsz00_20644
																																																														=
																																																														BgL_arg1867z00_2082;
																																																													BgL_argsz00_1790
																																																														=
																																																														BgL_argsz00_20644;
																																																													BgL_bodyz00_1789
																																																														=
																																																														BgL_bodyz00_20643;
																																																													BgL_varsz00_1788
																																																														=
																																																														BgL_varsz00_20642;
																																																													goto
																																																														BgL_tagzd2386zd2_1791;
																																																												}
																																																												BgL_auxz00_20610
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20641);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_20648;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_20610
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_20648);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd227837zd2_2085;
																																																									BgL_cdrzd227837zd2_2085
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd227842zd2_2086;
																																																										BgL_cdrzd227842zd2_2086
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd227725zd2_2075));
																																																										if ((CAR(((obj_t) BgL_carzd227725zd2_2075)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd227842zd2_2086))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd227847zd2_2090;
																																																														BgL_cdrzd227847zd2_2090
																																																															=
																																																															CDR
																																																															(BgL_cdrzd227842zd2_2086);
																																																														if (PAIRP(BgL_cdrzd227847zd2_2090))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd227851zd2_2092;
																																																																obj_t
																																																																	BgL_cdrzd227852zd2_2093;
																																																																BgL_carzd227851zd2_2092
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd227847zd2_2090);
																																																																BgL_cdrzd227852zd2_2093
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd227847zd2_2090);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227851zd2_2092))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd227852zd2_2093))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd227857zd2_2096;
																																																																				BgL_carzd227857zd2_2096
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd227852zd2_2093);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227857zd2_2096))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd227852zd2_2093)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8603z00_20676;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1416z00_2129;
																																																																									BgL_l1416z00_2129
																																																																										=
																																																																										BgL_cdrzd227837zd2_2085;
																																																																								BgL_zc3z04anonymousza31896ze3z87_2130:
																																																																									if (NULLP(BgL_l1416z00_2129))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8603z00_20676
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8605z00_20679;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8606z00_20680;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_20681;
																																																																													BgL_tmpz00_20681
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1416z00_2129));
																																																																													BgL_test8606z00_20680
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_20681);
																																																																												}
																																																																												if (BgL_test8606z00_20680)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8605z00_20679
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8605z00_20679
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8605z00_20679)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1416z00_20685;
																																																																													BgL_l1416z00_20685
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1416z00_2129));
																																																																													BgL_l1416z00_2129
																																																																														=
																																																																														BgL_l1416z00_20685;
																																																																													goto
																																																																														BgL_zc3z04anonymousza31896ze3z87_2130;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8603z00_20676
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8603z00_20676)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1886z00_2112;
																																																																										BgL_arg1886z00_2112
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd227842zd2_2086);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20689;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20693;
																																																																												obj_t
																																																																													BgL_proc2z00_20692;
																																																																												obj_t
																																																																													BgL_proc1z00_20691;
																																																																												obj_t
																																																																													BgL_testz00_20690;
																																																																												BgL_testz00_20690
																																																																													=
																																																																													BgL_arg1886z00_2112;
																																																																												BgL_proc1z00_20691
																																																																													=
																																																																													BgL_carzd227851zd2_2092;
																																																																												BgL_proc2z00_20692
																																																																													=
																																																																													BgL_carzd227857zd2_2096;
																																																																												BgL_argsz00_20693
																																																																													=
																																																																													BgL_cdrzd227837zd2_2085;
																																																																												BgL_argsz00_1795
																																																																													=
																																																																													BgL_argsz00_20693;
																																																																												BgL_proc2z00_1794
																																																																													=
																																																																													BgL_proc2z00_20692;
																																																																												BgL_proc1z00_1793
																																																																													=
																																																																													BgL_proc1z00_20691;
																																																																												BgL_testz00_1792
																																																																													=
																																																																													BgL_testz00_20690;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1796;
																																																																											}
																																																																											BgL_auxz00_20610
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20689);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd227882zd2_2113;
																																																																										BgL_cdrzd227882zd2_2113
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd227890zd2_2114;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11331;
																																																																												BgL_pairz00_11331
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd227890zd2_2114
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11331);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd227898zd2_2115;
																																																																												BgL_cdrzd227898zd2_2115
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd227890zd2_2114));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd227905zd2_2116;
																																																																													BgL_carzd227905zd2_2116
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd227898zd2_2115));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227905zd2_2116))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd227914zd2_2118;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11335;
																																																																																BgL_pairz00_11335
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd227898zd2_2115));
																																																																																BgL_carzd227914zd2_2118
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11335);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227914zd2_2118))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd227882zd2_2113))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg1890z00_2121;
																																																																																			BgL_arg1890z00_2121
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd227890zd2_2114));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_20715;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_20719;
																																																																																					obj_t
																																																																																						BgL_proc2z00_20718;
																																																																																					obj_t
																																																																																						BgL_proc1z00_20717;
																																																																																					obj_t
																																																																																						BgL_testz00_20716;
																																																																																					BgL_testz00_20716
																																																																																						=
																																																																																						BgL_arg1890z00_2121;
																																																																																					BgL_proc1z00_20717
																																																																																						=
																																																																																						BgL_carzd227905zd2_2116;
																																																																																					BgL_proc2z00_20718
																																																																																						=
																																																																																						BgL_carzd227914zd2_2118;
																																																																																					BgL_argsz00_20719
																																																																																						=
																																																																																						BgL_cdrzd227882zd2_2113;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_20719;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_20718;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_20717;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_20716;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_20610
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_20715);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_20723;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_20610
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_20723);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_20727;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_20610
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_20727);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20731;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_20610
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20731);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20735;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_20610
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20735);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd228192zd2_2140;
																																																																						BgL_cdrzd228192zd2_2140
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd228199zd2_2141;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11339;
																																																																								BgL_pairz00_11339
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd228199zd2_2141
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11339);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd228206zd2_2142;
																																																																								BgL_cdrzd228206zd2_2142
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd228199zd2_2141));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228212zd2_2143;
																																																																									obj_t
																																																																										BgL_cdrzd228213zd2_2144;
																																																																									BgL_carzd228212zd2_2143
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2142));
																																																																									BgL_cdrzd228213zd2_2144
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2142));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228212zd2_2143))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd228220zd2_2146;
																																																																											BgL_carzd228220zd2_2146
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd228213zd2_2144));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228220zd2_2146))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd228213zd2_2144))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228192zd2_2140))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg1907z00_2151;
																																																																																	BgL_arg1907z00_2151
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd228199zd2_2141));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_20762;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_20766;
																																																																																			obj_t
																																																																																				BgL_proc2z00_20765;
																																																																																			obj_t
																																																																																				BgL_proc1z00_20764;
																																																																																			obj_t
																																																																																				BgL_testz00_20763;
																																																																																			BgL_testz00_20763
																																																																																				=
																																																																																				BgL_arg1907z00_2151;
																																																																																			BgL_proc1z00_20764
																																																																																				=
																																																																																				BgL_carzd228212zd2_2143;
																																																																																			BgL_proc2z00_20765
																																																																																				=
																																																																																				BgL_carzd228220zd2_2146;
																																																																																			BgL_argsz00_20766
																																																																																				=
																																																																																				BgL_cdrzd228192zd2_2140;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_20766;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_20765;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_20764;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_20763;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_20610
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_20762);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_20770;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_20610
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_20770);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20774;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_20610
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20774);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20778;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_20610
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20778);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20782;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_20610
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20782);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20786;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_20610
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20786);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd228553zd2_2159;
																																																																		BgL_cdrzd228553zd2_2159
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd228559zd2_2160;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11348;
																																																																				BgL_pairz00_11348
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd228559zd2_2160
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11348);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd228565zd2_2161;
																																																																				BgL_cdrzd228565zd2_2161
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd228559zd2_2160));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd228570zd2_2162;
																																																																					obj_t
																																																																						BgL_cdrzd228571zd2_2163;
																																																																					BgL_carzd228570zd2_2162
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2161));
																																																																					BgL_cdrzd228571zd2_2163
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2161));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228570zd2_2162))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd228571zd2_2163))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228576zd2_2166;
																																																																									BgL_carzd228576zd2_2166
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd228571zd2_2163);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228576zd2_2166))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd228571zd2_2163)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228553zd2_2159))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg1921z00_2171;
																																																																															BgL_arg1921z00_2171
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd228559zd2_2160));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20813;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_20817;
																																																																																	obj_t
																																																																																		BgL_proc2z00_20816;
																																																																																	obj_t
																																																																																		BgL_proc1z00_20815;
																																																																																	obj_t
																																																																																		BgL_testz00_20814;
																																																																																	BgL_testz00_20814
																																																																																		=
																																																																																		BgL_arg1921z00_2171;
																																																																																	BgL_proc1z00_20815
																																																																																		=
																																																																																		BgL_carzd228570zd2_2162;
																																																																																	BgL_proc2z00_20816
																																																																																		=
																																																																																		BgL_carzd228576zd2_2166;
																																																																																	BgL_argsz00_20817
																																																																																		=
																																																																																		BgL_cdrzd228553zd2_2159;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_20817;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_20816;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_20815;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_20814;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_20610
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20813);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20821;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_20610
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20821);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20825;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_20610
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20825);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20829;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_20610
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20829);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20833;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_20610
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20833);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20837;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_20610
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20837);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20841;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_20610
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20841);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_20845;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_20610
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_20845);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_20849;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_20610
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_20849);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_20610);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test8636z00_20852;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg1851z00_2068;
																																																			BgL_arg1851z00_2068
																																																				=
																																																				CAR
																																																				(BgL_expz00_21);
																																																			BgL_test8636z00_20852
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg1851z00_2068));
																																																		}
																																																		if (BgL_test8636z00_20852)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20856;
																																																				goto
																																																					BgL_tagzd2384zd2_1783;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_20856);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd229139zd2_1896;
																																																				obj_t
																																																					BgL_cdrzd229140zd2_1897;
																																																				BgL_carzd229139zd2_1896
																																																					=
																																																					CAR
																																																					(BgL_expz00_21);
																																																				BgL_cdrzd229140zd2_1897
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd229144zd2_1898;
																																																					BgL_cdrzd229144zd2_1898
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd229139zd2_1896));
																																																					if ((CAR(((obj_t) BgL_carzd229139zd2_1896)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd229144zd2_1898))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd229147zd2_1902;
																																																									obj_t
																																																										BgL_cdrzd229148zd2_1903;
																																																									BgL_carzd229147zd2_1902
																																																										=
																																																										CAR
																																																										(BgL_cdrzd229144zd2_1898);
																																																									BgL_cdrzd229148zd2_1903
																																																										=
																																																										CDR
																																																										(BgL_cdrzd229144zd2_1898);
																																																									if (PAIRP(BgL_carzd229147zd2_1902))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_carzd229147zd2_1902)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd229148zd2_1903))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd229154zd2_1908;
																																																															BgL_carzd229154zd2_1908
																																																																=
																																																																CAR
																																																																(BgL_cdrzd229148zd2_1903);
																																																															if (PAIRP(BgL_carzd229154zd2_1908))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd229154zd2_1908))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229148zd2_1903)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd229140zd2_1897))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd229161zd2_1914;
																																																																							BgL_carzd229161zd2_1914
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229140zd2_1897);
																																																																							if (PAIRP(BgL_carzd229161zd2_1914))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229185zd2_1916;
																																																																									BgL_cdrzd229185zd2_1916
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1672z00_1917;
																																																																										obj_t
																																																																											BgL_arg1673z00_1918;
																																																																										obj_t
																																																																											BgL_arg1675z00_1919;
																																																																										BgL_arg1672z00_1917
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1916));
																																																																										BgL_arg1673z00_1918
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1916));
																																																																										BgL_arg1675z00_1919
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_20900;
																																																																											obj_t
																																																																												BgL_bodyz00_20899;
																																																																											obj_t
																																																																												BgL_varsz00_20898;
																																																																											BgL_varsz00_20898
																																																																												=
																																																																												BgL_arg1672z00_1917;
																																																																											BgL_bodyz00_20899
																																																																												=
																																																																												BgL_arg1673z00_1918;
																																																																											BgL_argsz00_20900
																																																																												=
																																																																												BgL_arg1675z00_1919;
																																																																											BgL_argsz00_1790
																																																																												=
																																																																												BgL_argsz00_20900;
																																																																											BgL_bodyz00_1789
																																																																												=
																																																																												BgL_bodyz00_20899;
																																																																											BgL_varsz00_1788
																																																																												=
																																																																												BgL_varsz00_20898;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1791;
																																																																										}
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd229140zd2_1897)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg1682z00_1923;
																																																																											BgL_arg1682z00_1923
																																																																												=
																																																																												CAR
																																																																												(BgL_carzd229147zd2_1902);
																																																																											{
																																																																												BgL_castz00_bglt
																																																																													BgL_auxz00_20905;
																																																																												{
																																																																													obj_t
																																																																														BgL_argz00_20908;
																																																																													obj_t
																																																																														BgL_bodyz00_20907;
																																																																													obj_t
																																																																														BgL_varz00_20906;
																																																																													BgL_varz00_20906
																																																																														=
																																																																														BgL_arg1682z00_1923;
																																																																													BgL_bodyz00_20907
																																																																														=
																																																																														BgL_carzd229154zd2_1908;
																																																																													BgL_argz00_20908
																																																																														=
																																																																														BgL_carzd229161zd2_1914;
																																																																													BgL_argz00_1786
																																																																														=
																																																																														BgL_argz00_20908;
																																																																													BgL_bodyz00_1785
																																																																														=
																																																																														BgL_bodyz00_20907;
																																																																													BgL_varz00_1784
																																																																														=
																																																																														BgL_varz00_20906;
																																																																													goto
																																																																														BgL_tagzd2385zd2_1787;
																																																																												}
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_20905);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd229212zd2_1924;
																																																																											BgL_cdrzd229212zd2_1924
																																																																												=
																																																																												CDR
																																																																												(CAR
																																																																												(BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1685z00_1925;
																																																																												obj_t
																																																																													BgL_arg1686z00_1926;
																																																																												obj_t
																																																																													BgL_arg1690z00_1927;
																																																																												BgL_arg1685z00_1925
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1924));
																																																																												BgL_arg1686z00_1926
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1924));
																																																																												BgL_arg1690z00_1927
																																																																													=
																																																																													CDR
																																																																													(BgL_expz00_21);
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_20919;
																																																																													obj_t
																																																																														BgL_bodyz00_20918;
																																																																													obj_t
																																																																														BgL_varsz00_20917;
																																																																													BgL_varsz00_20917
																																																																														=
																																																																														BgL_arg1685z00_1925;
																																																																													BgL_bodyz00_20918
																																																																														=
																																																																														BgL_arg1686z00_1926;
																																																																													BgL_argsz00_20919
																																																																														=
																																																																														BgL_arg1690z00_1927;
																																																																													BgL_argsz00_1790
																																																																														=
																																																																														BgL_argsz00_20919;
																																																																													BgL_bodyz00_1789
																																																																														=
																																																																														BgL_bodyz00_20918;
																																																																													BgL_varsz00_1788
																																																																														=
																																																																														BgL_varsz00_20917;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1791;
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229238zd2_1930;
																																																																							BgL_cdrzd229238zd2_1930
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg1696z00_1931;
																																																																								obj_t
																																																																									BgL_arg1697z00_1932;
																																																																								obj_t
																																																																									BgL_arg1699z00_1933;
																																																																								BgL_arg1696z00_1931
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1930));
																																																																								BgL_arg1697z00_1932
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1930));
																																																																								BgL_arg1699z00_1933
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_20929;
																																																																									obj_t
																																																																										BgL_bodyz00_20928;
																																																																									obj_t
																																																																										BgL_varsz00_20927;
																																																																									BgL_varsz00_20927
																																																																										=
																																																																										BgL_arg1696z00_1931;
																																																																									BgL_bodyz00_20928
																																																																										=
																																																																										BgL_arg1697z00_1932;
																																																																									BgL_argsz00_20929
																																																																										=
																																																																										BgL_arg1699z00_1933;
																																																																									BgL_argsz00_1790
																																																																										=
																																																																										BgL_argsz00_20929;
																																																																									BgL_bodyz00_1789
																																																																										=
																																																																										BgL_bodyz00_20928;
																																																																									BgL_varsz00_1788
																																																																										=
																																																																										BgL_varsz00_20927;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1791;
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229264zd2_1935;
																																																																					BgL_cdrzd229264zd2_1935
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg1704z00_1936;
																																																																						obj_t
																																																																							BgL_arg1710z00_1937;
																																																																						obj_t
																																																																							BgL_arg1717z00_1938;
																																																																						BgL_arg1704z00_1936
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1935));
																																																																						BgL_arg1710z00_1937
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1935));
																																																																						BgL_arg1717z00_1938
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20939;
																																																																							obj_t
																																																																								BgL_bodyz00_20938;
																																																																							obj_t
																																																																								BgL_varsz00_20937;
																																																																							BgL_varsz00_20937
																																																																								=
																																																																								BgL_arg1704z00_1936;
																																																																							BgL_bodyz00_20938
																																																																								=
																																																																								BgL_arg1710z00_1937;
																																																																							BgL_argsz00_20939
																																																																								=
																																																																								BgL_arg1717z00_1938;
																																																																							BgL_argsz00_1790
																																																																								=
																																																																								BgL_argsz00_20939;
																																																																							BgL_bodyz00_1789
																																																																								=
																																																																								BgL_bodyz00_20938;
																																																																							BgL_varsz00_1788
																																																																								=
																																																																								BgL_varsz00_20937;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1791;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229290zd2_1941;
																																																																			BgL_cdrzd229290zd2_1941
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg1720z00_1942;
																																																																				obj_t
																																																																					BgL_arg1721z00_1943;
																																																																				obj_t
																																																																					BgL_arg1722z00_1944;
																																																																				BgL_arg1720z00_1942
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1941));
																																																																				BgL_arg1721z00_1943
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1941));
																																																																				BgL_arg1722z00_1944
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20949;
																																																																					obj_t
																																																																						BgL_bodyz00_20948;
																																																																					obj_t
																																																																						BgL_varsz00_20947;
																																																																					BgL_varsz00_20947
																																																																						=
																																																																						BgL_arg1720z00_1942;
																																																																					BgL_bodyz00_20948
																																																																						=
																																																																						BgL_arg1721z00_1943;
																																																																					BgL_argsz00_20949
																																																																						=
																																																																						BgL_arg1722z00_1944;
																																																																					BgL_argsz00_1790
																																																																						=
																																																																						BgL_argsz00_20949;
																																																																					BgL_bodyz00_1789
																																																																						=
																																																																						BgL_bodyz00_20948;
																																																																					BgL_varsz00_1788
																																																																						=
																																																																						BgL_varsz00_20947;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1791;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd229316zd2_1946;
																																																																	BgL_cdrzd229316zd2_1946
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd229139zd2_1896));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg1725z00_1947;
																																																																		obj_t
																																																																			BgL_arg1732z00_1948;
																																																																		obj_t
																																																																			BgL_arg1733z00_1949;
																																																																		BgL_arg1725z00_1947
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1946));
																																																																		BgL_arg1732z00_1948
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1946));
																																																																		BgL_arg1733z00_1949
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_20959;
																																																																			obj_t
																																																																				BgL_bodyz00_20958;
																																																																			obj_t
																																																																				BgL_varsz00_20957;
																																																																			BgL_varsz00_20957
																																																																				=
																																																																				BgL_arg1725z00_1947;
																																																																			BgL_bodyz00_20958
																																																																				=
																																																																				BgL_arg1732z00_1948;
																																																																			BgL_argsz00_20959
																																																																				=
																																																																				BgL_arg1733z00_1949;
																																																																			BgL_argsz00_1790
																																																																				=
																																																																				BgL_argsz00_20959;
																																																																			BgL_bodyz00_1789
																																																																				=
																																																																				BgL_bodyz00_20958;
																																																																			BgL_varsz00_1788
																																																																				=
																																																																				BgL_varsz00_20957;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1791;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd229342zd2_1951;
																																																															BgL_cdrzd229342zd2_1951
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd229139zd2_1896));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg1735z00_1952;
																																																																obj_t
																																																																	BgL_arg1736z00_1953;
																																																																obj_t
																																																																	BgL_arg1737z00_1954;
																																																																BgL_arg1735z00_1952
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1951));
																																																																BgL_arg1736z00_1953
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1951));
																																																																BgL_arg1737z00_1954
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_20969;
																																																																	obj_t
																																																																		BgL_bodyz00_20968;
																																																																	obj_t
																																																																		BgL_varsz00_20967;
																																																																	BgL_varsz00_20967
																																																																		=
																																																																		BgL_arg1735z00_1952;
																																																																	BgL_bodyz00_20968
																																																																		=
																																																																		BgL_arg1736z00_1953;
																																																																	BgL_argsz00_20969
																																																																		=
																																																																		BgL_arg1737z00_1954;
																																																																	BgL_argsz00_1790
																																																																		=
																																																																		BgL_argsz00_20969;
																																																																	BgL_bodyz00_1789
																																																																		=
																																																																		BgL_bodyz00_20968;
																																																																	BgL_varsz00_1788
																																																																		=
																																																																		BgL_varsz00_20967;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1791;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd229368zd2_1956;
																																																													BgL_cdrzd229368zd2_1956
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd229139zd2_1896));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg1740z00_1957;
																																																														obj_t
																																																															BgL_arg1741z00_1958;
																																																														obj_t
																																																															BgL_arg1744z00_1959;
																																																														BgL_arg1740z00_1957
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1956));
																																																														BgL_arg1741z00_1958
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1956));
																																																														BgL_arg1744z00_1959
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_20979;
																																																															obj_t
																																																																BgL_bodyz00_20978;
																																																															obj_t
																																																																BgL_varsz00_20977;
																																																															BgL_varsz00_20977
																																																																=
																																																																BgL_arg1740z00_1957;
																																																															BgL_bodyz00_20978
																																																																=
																																																																BgL_arg1741z00_1958;
																																																															BgL_argsz00_20979
																																																																=
																																																																BgL_arg1744z00_1959;
																																																															BgL_argsz00_1790
																																																																=
																																																																BgL_argsz00_20979;
																																																															BgL_bodyz00_1789
																																																																=
																																																																BgL_bodyz00_20978;
																																																															BgL_varsz00_1788
																																																																=
																																																																BgL_varsz00_20977;
																																																															goto
																																																																BgL_tagzd2386zd2_1791;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229394zd2_1962;
																																																											BgL_cdrzd229394zd2_1962
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd229139zd2_1896));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg1751z00_1963;
																																																												obj_t
																																																													BgL_arg1753z00_1964;
																																																												obj_t
																																																													BgL_arg1755z00_1965;
																																																												BgL_arg1751z00_1963
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1962));
																																																												BgL_arg1753z00_1964
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1962));
																																																												BgL_arg1755z00_1965
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_20989;
																																																													obj_t
																																																														BgL_bodyz00_20988;
																																																													obj_t
																																																														BgL_varsz00_20987;
																																																													BgL_varsz00_20987
																																																														=
																																																														BgL_arg1751z00_1963;
																																																													BgL_bodyz00_20988
																																																														=
																																																														BgL_arg1753z00_1964;
																																																													BgL_argsz00_20989
																																																														=
																																																														BgL_arg1755z00_1965;
																																																													BgL_argsz00_1790
																																																														=
																																																														BgL_argsz00_20989;
																																																													BgL_bodyz00_1789
																																																														=
																																																														BgL_bodyz00_20988;
																																																													BgL_varsz00_1788
																																																														=
																																																														BgL_varsz00_20987;
																																																													goto
																																																														BgL_tagzd2386zd2_1791;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_20992;
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_20992);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd229532zd2_1970;
																																																							BgL_cdrzd229532zd2_1970
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd229139zd2_1896));
																																																							if ((CAR(((obj_t) BgL_carzd229139zd2_1896)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd229532zd2_1970))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229537zd2_1974;
																																																											BgL_cdrzd229537zd2_1974
																																																												=
																																																												CDR
																																																												(BgL_cdrzd229532zd2_1970);
																																																											if (PAIRP(BgL_cdrzd229537zd2_1974))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd229541zd2_1976;
																																																													obj_t
																																																														BgL_cdrzd229542zd2_1977;
																																																													BgL_carzd229541zd2_1976
																																																														=
																																																														CAR
																																																														(BgL_cdrzd229537zd2_1974);
																																																													BgL_cdrzd229542zd2_1977
																																																														=
																																																														CDR
																																																														(BgL_cdrzd229537zd2_1974);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229541zd2_1976))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd229542zd2_1977))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd229547zd2_1980;
																																																																	BgL_carzd229547zd2_1980
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd229542zd2_1977);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229547zd2_1980))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229542zd2_1977)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test8656z00_21018;
																																																																					{
																																																																						obj_t
																																																																							BgL_l1419z00_2013;
																																																																						BgL_l1419z00_2013
																																																																							=
																																																																							BgL_cdrzd229140zd2_1897;
																																																																					BgL_zc3z04anonymousza31811ze3z87_2014:
																																																																						if (NULLP(BgL_l1419z00_2013))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test8656z00_21018
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8658z00_21021;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test8659z00_21022;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_21023;
																																																																										BgL_tmpz00_21023
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_l1419z00_2013));
																																																																										BgL_test8659z00_21022
																																																																											=
																																																																											PAIRP
																																																																											(BgL_tmpz00_21023);
																																																																									}
																																																																									if (BgL_test8659z00_21022)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8658z00_21021
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8658z00_21021
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																								if (BgL_test8658z00_21021)
																																																																									{
																																																																										obj_t
																																																																											BgL_l1419z00_21027;
																																																																										BgL_l1419z00_21027
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_l1419z00_2013));
																																																																										BgL_l1419z00_2013
																																																																											=
																																																																											BgL_l1419z00_21027;
																																																																										goto
																																																																											BgL_zc3z04anonymousza31811ze3z87_2014;
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8656z00_21018
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																							}
																																																																					}
																																																																					if (BgL_test8656z00_21018)
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21034;
																																																																							obj_t
																																																																								BgL_proc2z00_21033;
																																																																							obj_t
																																																																								BgL_proc1z00_21032;
																																																																							obj_t
																																																																								BgL_testz00_21030;
																																																																							BgL_testz00_21030
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229532zd2_1970);
																																																																							BgL_proc1z00_21032
																																																																								=
																																																																								BgL_carzd229541zd2_1976;
																																																																							BgL_proc2z00_21033
																																																																								=
																																																																								BgL_carzd229547zd2_1980;
																																																																							BgL_argsz00_21034
																																																																								=
																																																																								BgL_cdrzd229140zd2_1897;
																																																																							BgL_argsz00_1795
																																																																								=
																																																																								BgL_argsz00_21034;
																																																																							BgL_proc2z00_1794
																																																																								=
																																																																								BgL_proc2z00_21033;
																																																																							BgL_proc1z00_1793
																																																																								=
																																																																								BgL_proc1z00_21032;
																																																																							BgL_testz00_1792
																																																																								=
																																																																								BgL_testz00_21030;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1796;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229572zd2_1997;
																																																																							BgL_cdrzd229572zd2_1997
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd229580zd2_1998;
																																																																								BgL_cdrzd229580zd2_1998
																																																																									=
																																																																									CDR
																																																																									(CAR
																																																																									(BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229588zd2_1999;
																																																																									BgL_cdrzd229588zd2_1999
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd229580zd2_1998));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd229595zd2_2000;
																																																																										BgL_carzd229595zd2_2000
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229588zd2_1999));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229595zd2_2000))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd229604zd2_2002;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11432;
																																																																													BgL_pairz00_11432
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd229588zd2_1999));
																																																																													BgL_carzd229604zd2_2002
																																																																														=
																																																																														CAR
																																																																														(BgL_pairz00_11432);
																																																																												}
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229604zd2_2002))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229572zd2_1997))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg1804z00_2005;
																																																																																BgL_arg1804z00_2005
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd229580zd2_1998));
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21056;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21055;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21054;
																																																																																	obj_t
																																																																																		BgL_testz00_21053;
																																																																																	BgL_testz00_21053
																																																																																		=
																																																																																		BgL_arg1804z00_2005;
																																																																																	BgL_proc1z00_21054
																																																																																		=
																																																																																		BgL_carzd229595zd2_2000;
																																																																																	BgL_proc2z00_21055
																																																																																		=
																																																																																		BgL_carzd229604zd2_2002;
																																																																																	BgL_argsz00_21056
																																																																																		=
																																																																																		BgL_cdrzd229572zd2_1997;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_21056;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_21055;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_21054;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_21053;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_auxz00_21059;
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																		return
																																																																																			(
																																																																																			(BgL_nodez00_bglt)
																																																																																			BgL_auxz00_21059);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21063;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21063);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21067;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21067);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_21071;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_21071);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229882zd2_2024;
																																																																			BgL_cdrzd229882zd2_2024
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd229889zd2_2025;
																																																																				BgL_cdrzd229889zd2_2025
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229896zd2_2026;
																																																																					BgL_cdrzd229896zd2_2026
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd229889zd2_2025));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd229902zd2_2027;
																																																																						obj_t
																																																																							BgL_cdrzd229903zd2_2028;
																																																																						BgL_carzd229902zd2_2027
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_2026));
																																																																						BgL_cdrzd229903zd2_2028
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_2026));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229902zd2_2027))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd229910zd2_2030;
																																																																								BgL_carzd229910zd2_2030
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229903zd2_2028));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229910zd2_2030))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd229903zd2_2028))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229882zd2_2024))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg1821z00_2035;
																																																																														BgL_arg1821z00_2035
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd229889zd2_2025));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_21099;
																																																																															obj_t
																																																																																BgL_proc2z00_21098;
																																																																															obj_t
																																																																																BgL_proc1z00_21097;
																																																																															obj_t
																																																																																BgL_testz00_21096;
																																																																															BgL_testz00_21096
																																																																																=
																																																																																BgL_arg1821z00_2035;
																																																																															BgL_proc1z00_21097
																																																																																=
																																																																																BgL_carzd229902zd2_2027;
																																																																															BgL_proc2z00_21098
																																																																																=
																																																																																BgL_carzd229910zd2_2030;
																																																																															BgL_argsz00_21099
																																																																																=
																																																																																BgL_cdrzd229882zd2_2024;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_21099;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_21098;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_21097;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_21096;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21102;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21102);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21106;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21106);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21110;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21110);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21114;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21114);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_21118;
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21118);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd230243zd2_2043;
																																																															BgL_cdrzd230243zd2_2043
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd230249zd2_2044;
																																																																BgL_cdrzd230249zd2_2044
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd230255zd2_2045;
																																																																	BgL_cdrzd230255zd2_2045
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd230249zd2_2044));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd230260zd2_2046;
																																																																		obj_t
																																																																			BgL_cdrzd230261zd2_2047;
																																																																		BgL_carzd230260zd2_2046
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_2045));
																																																																		BgL_cdrzd230261zd2_2047
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_2045));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230260zd2_2046))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd230261zd2_2047))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd230266zd2_2050;
																																																																						BgL_carzd230266zd2_2050
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd230261zd2_2047);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230266zd2_2050))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd230261zd2_2047)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd230243zd2_2043))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1835z00_2055;
																																																																												BgL_arg1835z00_2055
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd230249zd2_2044));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21146;
																																																																													obj_t
																																																																														BgL_proc2z00_21145;
																																																																													obj_t
																																																																														BgL_proc1z00_21144;
																																																																													obj_t
																																																																														BgL_testz00_21143;
																																																																													BgL_testz00_21143
																																																																														=
																																																																														BgL_arg1835z00_2055;
																																																																													BgL_proc1z00_21144
																																																																														=
																																																																														BgL_carzd230260zd2_2046;
																																																																													BgL_proc2z00_21145
																																																																														=
																																																																														BgL_carzd230266zd2_2050;
																																																																													BgL_argsz00_21146
																																																																														=
																																																																														BgL_cdrzd230243zd2_2043;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_21146;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_21145;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_21144;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_21143;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21149;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21149);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21153;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21153);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21157;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21157);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_21161;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_21161);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_21165;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_21165);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21169;
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21169);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_21173;
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_21173);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21177;
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21177);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{

																																			if (
																																				(BgL_carzd224574zd2_1880
																																					==
																																					CNST_TABLE_REF
																																					(((long) 17))))
																																				{
																																					obj_t
																																						BgL_auxz00_21182;
																																				BgL_kapzd230804zd2_2463:
																																					if (PAIRP(BgL_cdrzd224445zd2_1862))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2211z00_2560;
																																							obj_t
																																								BgL_arg2212z00_2561;
																																							BgL_arg2211z00_2560
																																								=
																																								CAR
																																								(BgL_cdrzd224445zd2_1862);
																																							BgL_arg2212z00_2561
																																								=
																																								CDR
																																								(BgL_cdrzd224445zd2_1862);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_21187;
																																								{
																																									obj_t
																																										BgL_exprz00_21189;
																																									obj_t
																																										BgL_bindingsz00_21188;
																																									BgL_bindingsz00_21188
																																										=
																																										BgL_arg2211z00_2560;
																																									BgL_exprz00_21189
																																										=
																																										BgL_arg2212z00_2561;
																																									BgL_exprz00_1780
																																										=
																																										BgL_exprz00_21189;
																																									BgL_bindingsz00_1779
																																										=
																																										BgL_bindingsz00_21188;
																																									goto
																																										BgL_tagzd2382zd2_1781;
																																								}
																																								BgL_auxz00_21182
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_21187);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21196;
																																									goto
																																										BgL_tagzd2383zd2_1782;
																																									BgL_auxz00_21182
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21196);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd230837zd2_2564;
																																									BgL_carzd230837zd2_2564
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if ((BgL_carzd230837zd2_2564 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_21203;
																																											goto
																																												BgL_tagzd2384zd2_1783;
																																											BgL_auxz00_21182
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21203);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230837zd2_2564)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21208;
																																													goto
																																														BgL_tagzd2384zd2_1783;
																																													BgL_auxz00_21182
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21208);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21215;
																																															goto
																																																BgL_tagzd2389zd2_1802;
																																															BgL_auxz00_21182
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21215);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21222;
																																																	goto
																																																		BgL_tagzd2390zd2_1803;
																																																	BgL_auxz00_21182
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21222);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_21229;
																																																			goto
																																																				BgL_tagzd2392zd2_1807;
																																																			BgL_auxz00_21182
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_21229);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21236;
																																																					goto
																																																						BgL_tagzd2393zd2_1808;
																																																					BgL_auxz00_21182
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21236);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21243;
																																																							goto
																																																								BgL_tagzd2395zd2_1812;
																																																							BgL_auxz00_21182
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21243);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21250;
																																																									goto
																																																										BgL_tagzd2396zd2_1813;
																																																									BgL_auxz00_21182
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21250);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21257;
																																																											goto
																																																												BgL_tagzd2397zd2_1814;
																																																											BgL_auxz00_21182
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21257);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																												{
																																																													BgL_jumpzd2exzd2itz00_bglt
																																																														BgL_auxz00_21264;
																																																													goto
																																																														BgL_tagzd2398zd2_1815;
																																																													BgL_auxz00_21182
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21264);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21274;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1824;
																																																																	BgL_auxz00_21182
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21274);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21278;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21182
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21278);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21282;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_21182
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21282);
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_21182);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224574zd2_1880)))
																																						{
																																							obj_t
																																								BgL_auxz00_21288;
																																							goto
																																								BgL_kapzd230804zd2_2463;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_21288);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd224574zd2_1880 == CNST_TABLE_REF(((long) 18))))
																																								{
																																									obj_t
																																										BgL_auxz00_21293;
																																									goto
																																										BgL_kapzd230804zd2_2463;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_21293);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																										{	/* Ast/sexp.scm 119 */
																																											goto
																																												BgL_tagzd2383zd2_1782;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd230998zd2_2469;
																																											BgL_carzd230998zd2_2469
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											if ((BgL_carzd230998zd2_2469 == CNST_TABLE_REF(((long) 19))))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21303;
																																													goto
																																														BgL_tagzd2384zd2_1783;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_21303);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230998zd2_2469)))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_21308;
																																															goto
																																																BgL_tagzd2384zd2_1783;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_21308);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2389zd2_1802;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2390zd2_1803;
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd231077zd2_2476;
																																																			BgL_cdrzd231077zd2_2476
																																																				=
																																																				CDR
																																																				(BgL_expz00_21);
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd231077zd2_2476))
																																																						{
																																																							obj_t
																																																								BgL_restz00_21327;
																																																							obj_t
																																																								BgL_effectz00_21325;
																																																							BgL_effectz00_21325
																																																								=
																																																								CAR
																																																								(BgL_cdrzd231077zd2_2476);
																																																							BgL_restz00_21327
																																																								=
																																																								CDR
																																																								(BgL_cdrzd231077zd2_2476);
																																																							BgL_restz00_1805
																																																								=
																																																								BgL_restz00_21327;
																																																							BgL_effectz00_1804
																																																								=
																																																								BgL_effectz00_21325;
																																																							goto
																																																								BgL_tagzd2391zd2_1806;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_21331;
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_21331);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2392zd2_1807;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2393zd2_1808;
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd231077zd2_2476))
																																																												{
																																																													obj_t
																																																														BgL_restz00_21349;
																																																													obj_t
																																																														BgL_effectz00_21347;
																																																													BgL_effectz00_21347
																																																														=
																																																														CAR
																																																														(BgL_cdrzd231077zd2_2476);
																																																													BgL_restz00_21349
																																																														=
																																																														CDR
																																																														(BgL_cdrzd231077zd2_2476);
																																																													BgL_restz00_1810
																																																														=
																																																														BgL_restz00_21349;
																																																													BgL_effectz00_1809
																																																														=
																																																														BgL_effectz00_21347;
																																																													goto
																																																														BgL_tagzd2394zd2_1811;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21353;
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21353);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2395zd2_1812;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2396zd2_1813;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_21367;
																																																																	goto
																																																																		BgL_tagzd2397zd2_1814;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_21367);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																		{
																																																																			BgL_jumpzd2exzd2itz00_bglt
																																																																				BgL_auxz00_21373;
																																																																			goto
																																																																				BgL_tagzd2398zd2_1815;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21373);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231204zd2_2502;
																																																																			BgL_cdrzd231204zd2_2502
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd231204zd2_2502))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd231206zd2_2506;
																																																																							BgL_cdrzd231206zd2_2506
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd231204zd2_2502);
																																																																							if (PAIRP(BgL_cdrzd231206zd2_2506))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd231206zd2_2506)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2399zd2_1816;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21390;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21390);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21394;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21394);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_21398;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_21398);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd231204zd2_2502))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd231251zd2_2518;
																																																																									BgL_cdrzd231251zd2_2518
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd231204zd2_2502);
																																																																									if (PAIRP(BgL_cdrzd231251zd2_2518))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231256zd2_2520;
																																																																											BgL_cdrzd231256zd2_2520
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd231251zd2_2518);
																																																																											if ((CAR(BgL_cdrzd231251zd2_2518) == CNST_TABLE_REF(((long) 31))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd231256zd2_2520))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg2177z00_2524;
																																																																															obj_t
																																																																																BgL_arg2178z00_2525;
																																																																															obj_t
																																																																																BgL_arg2179z00_2526;
																																																																															BgL_arg2177z00_2524
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231204zd2_2502);
																																																																															BgL_arg2178z00_2525
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231256zd2_2520);
																																																																															BgL_arg2179z00_2526
																																																																																=
																																																																																CDR
																																																																																(BgL_cdrzd231256zd2_2520);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2177z00_2524,
																																																																																BgL_arg2178z00_2525,
																																																																																BgL_arg2179z00_2526,
																																																																																BgL_stackz00_22,
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_locz00_23),
																																																																																BgL_sitez00_24);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231269zd2_2527;
																																																																															BgL_cdrzd231269zd2_2527
																																																																																=
																																																																																CDR
																																																																																(BgL_expz00_21);
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2180z00_2528;
																																																																																obj_t
																																																																																	BgL_arg2182z00_2529;
																																																																																BgL_arg2180z00_2528
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2527));
																																																																																BgL_arg2182z00_2529
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2527));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7023z00_11502;
																																																																																	BgL_arg7023z00_11502
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	return
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_arg2180z00_2528,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg2182z00_2529, BgL_stackz00_22, BgL_arg7023z00_11502, BgL_sitez00_24);
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd231284zd2_2530;
																																																																													BgL_cdrzd231284zd2_2530
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2183z00_2531;
																																																																														obj_t
																																																																															BgL_arg2184z00_2532;
																																																																														BgL_arg2183z00_2531
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2530));
																																																																														BgL_arg2184z00_2532
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2530));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7023z00_11506;
																																																																															BgL_arg7023z00_11506
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2183z00_2531,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg2184z00_2532, BgL_stackz00_22, BgL_arg7023z00_11506, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231299zd2_2534;
																																																																											BgL_cdrzd231299zd2_2534
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2186z00_2535;
																																																																												obj_t
																																																																													BgL_arg2187z00_2536;
																																																																												BgL_arg2186z00_2535
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2534));
																																																																												BgL_arg2187z00_2536
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2534));
																																																																												{	/* Ast/sexp.scm 555 */
																																																																													obj_t
																																																																														BgL_arg7023z00_11510;
																																																																													BgL_arg7023z00_11510
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg2186z00_2535,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg2187z00_2536, BgL_stackz00_22, BgL_arg7023z00_11510, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21447;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21447);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_expz00_21)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1824;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_21457;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_21457);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_21461;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_21461);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 119 */
												if (
													(BgL_carzd2478zd2_1831 ==
														CNST_TABLE_REF(((long) 11))))
													{	/* Ast/sexp.scm 119 */
														goto BgL_tagzd2371zd2_1761;
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 14))))
															{
																obj_t BgL_lz00_21470;

																BgL_lz00_21470 = CDR(BgL_expz00_21);
																BgL_lz00_1762 = BgL_lz00_21470;
																goto BgL_tagzd2372zd2_1763;
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 12))))
																	{	/* Ast/sexp.scm 119 */
																		goto BgL_tagzd2373zd2_1764;
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 15))))
																			{	/* Ast/sexp.scm 119 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 119 */
																						goto BgL_tagzd2374zd2_1765;
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_arg4337z00_5127;

																						BgL_arg4337z00_5127 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_21484;
																							{
																								obj_t BgL_bodyz00_21485;

																								BgL_bodyz00_21485 =
																									BgL_arg4337z00_5127;
																								BgL_bodyz00_1766 =
																									BgL_bodyz00_21485;
																								goto BgL_tagzd2375zd2_1767;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_21484);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				obj_t BgL_carzd231447zd2_5129;
																				obj_t BgL_cdrzd231448zd2_5130;

																				BgL_carzd231447zd2_5129 =
																					CAR(BgL_expz00_21);
																				BgL_cdrzd231448zd2_5130 =
																					CDR(BgL_expz00_21);
																				{

																					if (
																						(BgL_carzd231447zd2_5129 ==
																							CNST_TABLE_REF(((long) 1))))
																						{
																							obj_t BgL_auxz00_21492;

																						BgL_kapzd231449zd2_5131:
																							if (PAIRP
																								(BgL_cdrzd231448zd2_5130))
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_cdrzd231452zd2_5878;

																									BgL_cdrzd231452zd2_5878 =
																										CDR
																										(BgL_cdrzd231448zd2_5130);
																									if (PAIRP
																										(BgL_cdrzd231452zd2_5878))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd231455zd2_5880;
																											BgL_cdrzd231455zd2_5880 =
																												CDR
																												(BgL_cdrzd231452zd2_5878);
																											if ((CAR
																													(BgL_cdrzd231452zd2_5878)
																													== BTRUE))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd231455zd2_5880))
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_cdrzd231455zd2_5880)
																																	== BFALSE))
																																{	/* Ast/sexp.scm 119 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd231455zd2_5880)))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_sitez00_24
																																					==
																																					CNST_TABLE_REF
																																					(((long) 8))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4877z00_5890;
																																					BgL_arg4877z00_5890
																																						=
																																						CAR
																																						(BgL_cdrzd231448zd2_5130);
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg4877z00_5890,
																																							BgL_stackz00_22,
																																							BgL_locz00_23,
																																							BgL_sitez00_24));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd231474zd2_5891;
																																					BgL_carzd231474zd2_5891
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd231474zd2_5891
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_21521;
																																							goto
																																								BgL_tagzd2377zd2_1770;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_21521);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd231474zd2_5891 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21525;
																																									goto
																																										BgL_tagzd2377zd2_1770;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21525);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_21532;
																																											goto
																																												BgL_tagzd2379zd2_1774;
																																											BgL_auxz00_21492
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21532);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_21539;
																																													goto
																																														BgL_tagzd2380zd2_1775;
																																													BgL_auxz00_21492
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21539);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd231543zd2_5898;
																																													BgL_carzd231543zd2_5898
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd231543zd2_5898))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd231546zd2_5900;
																																															obj_t
																																																BgL_cdrzd231547zd2_5901;
																																															BgL_carzd231546zd2_5900
																																																=
																																																CAR
																																																(BgL_carzd231543zd2_5898);
																																															BgL_cdrzd231547zd2_5901
																																																=
																																																CDR
																																																(BgL_carzd231543zd2_5898);
																																															{

																																																if ((BgL_carzd231546zd2_5900 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd231548zd2_5902:
																																																		if (PAIRP(BgL_cdrzd231547zd2_5901))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd231551zd2_6027;
																																																				BgL_cdrzd231551zd2_6027
																																																					=
																																																					CDR
																																																					(BgL_cdrzd231547zd2_5901);
																																																				if (PAIRP(BgL_cdrzd231551zd2_6027))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd231551zd2_6027)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg4969z00_6031;
																																																								obj_t
																																																									BgL_arg4970z00_6032;
																																																								BgL_arg4969z00_6031
																																																									=
																																																									CAR
																																																									(BgL_cdrzd231551zd2_6027);
																																																								BgL_arg4970z00_6032
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21561;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_21563;
																																																										obj_t
																																																											BgL_bodyz00_21562;
																																																										BgL_bodyz00_21562
																																																											=
																																																											BgL_arg4969z00_6031;
																																																										BgL_argsz00_21563
																																																											=
																																																											BgL_arg4970z00_6032;
																																																										BgL_argsz00_1777
																																																											=
																																																											BgL_argsz00_21563;
																																																										BgL_bodyz00_1776
																																																											=
																																																											BgL_bodyz00_21562;
																																																										goto
																																																											BgL_tagzd2381zd2_1778;
																																																									}
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21561);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd231575zd2_6033;
																																																								BgL_cdrzd231575zd2_6033
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8764z00_21567;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5039z00_6144;
																																																										BgL_arg5039z00_6144
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8764z00_21567
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5039z00_6144));
																																																									}
																																																									if (BgL_test8764z00_21567)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg4973z00_6036;
																																																											obj_t
																																																												BgL_arg4974z00_6037;
																																																											BgL_arg4973z00_6036
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_6033));
																																																											BgL_arg4974z00_6037
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_6033));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_21576;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_21578;
																																																													obj_t
																																																														BgL_bindingsz00_21577;
																																																													BgL_bindingsz00_21577
																																																														=
																																																														BgL_arg4973z00_6036;
																																																													BgL_exprz00_21578
																																																														=
																																																														BgL_arg4974z00_6037;
																																																													BgL_exprz00_1780
																																																														=
																																																														BgL_exprz00_21578;
																																																													BgL_bindingsz00_1779
																																																														=
																																																														BgL_bindingsz00_21577;
																																																													goto
																																																														BgL_tagzd2382zd2_1781;
																																																												}
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_21576);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8765z00_21580;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5038z00_6143;
																																																												BgL_arg5038z00_6143
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8765z00_21580
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5038z00_6143));
																																																											}
																																																											if (BgL_test8765z00_21580)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_21585;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21585);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd231642zd2_6040;
																																																													BgL_carzd231642zd2_6040
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd231647zd2_6041;
																																																														BgL_cdrzd231647zd2_6041
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd231642zd2_6040));
																																																														if ((CAR(((obj_t) BgL_carzd231642zd2_6040)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4979z00_6044;
																																																																obj_t
																																																																	BgL_arg4980z00_6045;
																																																																obj_t
																																																																	BgL_arg4981z00_6046;
																																																																BgL_arg4979z00_6044
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_6041));
																																																																BgL_arg4980z00_6045
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_6041));
																																																																BgL_arg4981z00_6046
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21602;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_21605;
																																																																		obj_t
																																																																			BgL_bodyz00_21604;
																																																																		obj_t
																																																																			BgL_varsz00_21603;
																																																																		BgL_varsz00_21603
																																																																			=
																																																																			BgL_arg4979z00_6044;
																																																																		BgL_bodyz00_21604
																																																																			=
																																																																			BgL_arg4980z00_6045;
																																																																		BgL_argsz00_21605
																																																																			=
																																																																			BgL_arg4981z00_6046;
																																																																		BgL_argsz00_1790
																																																																			=
																																																																			BgL_argsz00_21605;
																																																																		BgL_bodyz00_1789
																																																																			=
																																																																			BgL_bodyz00_21604;
																																																																		BgL_varsz00_1788
																																																																			=
																																																																			BgL_varsz00_21603;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1791;
																																																																	}
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21602);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd231670zd2_6048;
																																																																BgL_cdrzd231670zd2_6048
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd231676zd2_6049;
																																																																	BgL_cdrzd231676zd2_6049
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd231642zd2_6040));
																																																																	if ((CAR(((obj_t) BgL_carzd231642zd2_6040)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231682zd2_6052;
																																																																			BgL_cdrzd231682zd2_6052
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd231676zd2_6049));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd231687zd2_6053;
																																																																				obj_t
																																																																					BgL_cdrzd231688zd2_6054;
																																																																				BgL_carzd231687zd2_6053
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6052));
																																																																				BgL_cdrzd231688zd2_6054
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6052));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231687zd2_6053))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd231688zd2_6054))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd231695zd2_6057;
																																																																								BgL_carzd231695zd2_6057
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd231688zd2_6054);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231695zd2_6057))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd231688zd2_6054)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8772z00_21632;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1422z00_6090;
																																																																													BgL_l1422z00_6090
																																																																														=
																																																																														BgL_cdrzd231670zd2_6048;
																																																																												BgL_zc3z04anonymousza35004ze3z87_6091:
																																																																													if (NULLP(BgL_l1422z00_6090))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8772z00_21632
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8774z00_21635;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8775z00_21636;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_21637;
																																																																																	BgL_tmpz00_21637
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1422z00_6090));
																																																																																	BgL_test8775z00_21636
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_21637);
																																																																																}
																																																																																if (BgL_test8775z00_21636)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8774z00_21635
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8774z00_21635
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test8774z00_21635)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1422z00_21641;
																																																																																	BgL_l1422z00_21641
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1422z00_6090));
																																																																																	BgL_l1422z00_6090
																																																																																		=
																																																																																		BgL_l1422z00_21641;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza35004ze3z87_6091;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8772z00_21632
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test8772z00_21632)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4994z00_6073;
																																																																														BgL_arg4994z00_6073
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231676zd2_6049));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21646;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_21650;
																																																																																obj_t
																																																																																	BgL_proc2z00_21649;
																																																																																obj_t
																																																																																	BgL_proc1z00_21648;
																																																																																obj_t
																																																																																	BgL_testz00_21647;
																																																																																BgL_testz00_21647
																																																																																	=
																																																																																	BgL_arg4994z00_6073;
																																																																																BgL_proc1z00_21648
																																																																																	=
																																																																																	BgL_carzd231687zd2_6053;
																																																																																BgL_proc2z00_21649
																																																																																	=
																																																																																	BgL_carzd231695zd2_6057;
																																																																																BgL_argsz00_21650
																																																																																	=
																																																																																	BgL_cdrzd231670zd2_6048;
																																																																																BgL_argsz00_1795
																																																																																	=
																																																																																	BgL_argsz00_21650;
																																																																																BgL_proc2z00_1794
																																																																																	=
																																																																																	BgL_proc2z00_21649;
																																																																																BgL_proc1z00_1793
																																																																																	=
																																																																																	BgL_proc1z00_21648;
																																																																																BgL_testz00_1792
																																																																																	=
																																																																																	BgL_testz00_21647;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1796;
																																																																															}
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21646);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd231719zd2_6074;
																																																																														BgL_cdrzd231719zd2_6074
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231726zd2_6075;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11563;
																																																																																BgL_pairz00_11563
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd231726zd2_6075
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_11563);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd231733zd2_6076;
																																																																																BgL_cdrzd231733zd2_6076
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231726zd2_6075));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd231739zd2_6077;
																																																																																	BgL_carzd231739zd2_6077
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd231733zd2_6076));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231739zd2_6077))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd231746zd2_6079;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_11567;
																																																																																				BgL_pairz00_11567
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd231733zd2_6076));
																																																																																				BgL_carzd231746zd2_6079
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_11567);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231746zd2_6079))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd231719zd2_6074))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg4998z00_6082;
																																																																																							BgL_arg4998z00_6082
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd231726zd2_6075));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_21672;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_21676;
																																																																																									obj_t
																																																																																										BgL_proc2z00_21675;
																																																																																									obj_t
																																																																																										BgL_proc1z00_21674;
																																																																																									obj_t
																																																																																										BgL_testz00_21673;
																																																																																									BgL_testz00_21673
																																																																																										=
																																																																																										BgL_arg4998z00_6082;
																																																																																									BgL_proc1z00_21674
																																																																																										=
																																																																																										BgL_carzd231739zd2_6077;
																																																																																									BgL_proc2z00_21675
																																																																																										=
																																																																																										BgL_carzd231746zd2_6079;
																																																																																									BgL_argsz00_21676
																																																																																										=
																																																																																										BgL_cdrzd231719zd2_6074;
																																																																																									BgL_argsz00_1800
																																																																																										=
																																																																																										BgL_argsz00_21676;
																																																																																									BgL_proc2z00_1799
																																																																																										=
																																																																																										BgL_proc2z00_21675;
																																																																																									BgL_proc1z00_1798
																																																																																										=
																																																																																										BgL_proc1z00_21674;
																																																																																									BgL_testz00_1797
																																																																																										=
																																																																																										BgL_testz00_21673;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1801;
																																																																																								}
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_21672);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1825;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_21680;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1826;
																																																																																									BgL_auxz00_21492
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_21680);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_21684;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_21684);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21688;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21688);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_21692;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_21692);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd232022zd2_6101;
																																																																										BgL_cdrzd232022zd2_6101
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd232028zd2_6102;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11571;
																																																																												BgL_pairz00_11571
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd232028zd2_6102
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11571);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd232034zd2_6103;
																																																																												BgL_cdrzd232034zd2_6103
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd232028zd2_6102));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232039zd2_6104;
																																																																													obj_t
																																																																														BgL_cdrzd232040zd2_6105;
																																																																													BgL_carzd232039zd2_6104
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6103));
																																																																													BgL_cdrzd232040zd2_6105
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6103));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232039zd2_6104))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd232045zd2_6107;
																																																																															BgL_carzd232045zd2_6107
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd232040zd2_6105));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232045zd2_6107))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd232040zd2_6105))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232022zd2_6101))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg5013z00_6112;
																																																																																					BgL_arg5013z00_6112
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd232028zd2_6102));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_21719;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_21723;
																																																																																							obj_t
																																																																																								BgL_proc2z00_21722;
																																																																																							obj_t
																																																																																								BgL_proc1z00_21721;
																																																																																							obj_t
																																																																																								BgL_testz00_21720;
																																																																																							BgL_testz00_21720
																																																																																								=
																																																																																								BgL_arg5013z00_6112;
																																																																																							BgL_proc1z00_21721
																																																																																								=
																																																																																								BgL_carzd232039zd2_6104;
																																																																																							BgL_proc2z00_21722
																																																																																								=
																																																																																								BgL_carzd232045zd2_6107;
																																																																																							BgL_argsz00_21723
																																																																																								=
																																																																																								BgL_cdrzd232022zd2_6101;
																																																																																							BgL_argsz00_1800
																																																																																								=
																																																																																								BgL_argsz00_21723;
																																																																																							BgL_proc2z00_1799
																																																																																								=
																																																																																								BgL_proc2z00_21722;
																																																																																							BgL_proc1z00_1798
																																																																																								=
																																																																																								BgL_proc1z00_21721;
																																																																																							BgL_testz00_1797
																																																																																								=
																																																																																								BgL_testz00_21720;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1801;
																																																																																						}
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_21719);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_21727;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_21727);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21731;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21731);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21735;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21735);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21739;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21739);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21743;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21743);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd232378zd2_6120;
																																																																						BgL_cdrzd232378zd2_6120
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd232385zd2_6121;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11580;
																																																																								BgL_pairz00_11580
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd232385zd2_6121
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11580);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd232392zd2_6122;
																																																																								BgL_cdrzd232392zd2_6122
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd232385zd2_6121));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd232398zd2_6123;
																																																																									obj_t
																																																																										BgL_cdrzd232399zd2_6124;
																																																																									BgL_carzd232398zd2_6123
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6122));
																																																																									BgL_cdrzd232399zd2_6124
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6122));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232398zd2_6123))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd232399zd2_6124))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232406zd2_6127;
																																																																													BgL_carzd232406zd2_6127
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd232399zd2_6124);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232406zd2_6127))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd232399zd2_6124)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232378zd2_6120))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5027z00_6132;
																																																																																			BgL_arg5027z00_6132
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd232385zd2_6121));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21770;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21774;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21773;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21772;
																																																																																					obj_t
																																																																																						BgL_testz00_21771;
																																																																																					BgL_testz00_21771
																																																																																						=
																																																																																						BgL_arg5027z00_6132;
																																																																																					BgL_proc1z00_21772
																																																																																						=
																																																																																						BgL_carzd232398zd2_6123;
																																																																																					BgL_proc2z00_21773
																																																																																						=
																																																																																						BgL_carzd232406zd2_6127;
																																																																																					BgL_argsz00_21774
																																																																																						=
																																																																																						BgL_cdrzd232378zd2_6120;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_21774;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_21773;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_21772;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_21771;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21770);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21778;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21778);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21782;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21782);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21786;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21786);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21790;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21790);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21794;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21794);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_21798;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_21798);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd232799zd2_6146;
																																																						BgL_cdrzd232799zd2_6146
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8803z00_21802;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5055z00_6163;
																																																								BgL_arg5055z00_6163
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8803z00_21802
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5055z00_6163));
																																																							}
																																																							if (BgL_test8803z00_21802)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5043z00_6149;
																																																									obj_t
																																																										BgL_arg5044z00_6150;
																																																									BgL_arg5043z00_6149
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6146));
																																																									BgL_arg5044z00_6150
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6146));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_21811;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_21813;
																																																											obj_t
																																																												BgL_bindingsz00_21812;
																																																											BgL_bindingsz00_21812
																																																												=
																																																												BgL_arg5043z00_6149;
																																																											BgL_exprz00_21813
																																																												=
																																																												BgL_arg5044z00_6150;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_21813;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_21812;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_21811);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8804z00_21815;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5054z00_6162;
																																																										BgL_arg5054z00_6162
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8804z00_21815
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5054z00_6162));
																																																									}
																																																									if (BgL_test8804z00_21815)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21820;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21820);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd232865zd2_6153;
																																																											BgL_carzd232865zd2_6153
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd232870zd2_6154;
																																																												BgL_cdrzd232870zd2_6154
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd232865zd2_6153));
																																																												if ((CAR(((obj_t) BgL_carzd232865zd2_6153)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5049z00_6157;
																																																														obj_t
																																																															BgL_arg5050z00_6158;
																																																														obj_t
																																																															BgL_arg5051z00_6159;
																																																														BgL_arg5049z00_6157
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6154));
																																																														BgL_arg5050z00_6158
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6154));
																																																														BgL_arg5051z00_6159
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_21837;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_21840;
																																																																obj_t
																																																																	BgL_bodyz00_21839;
																																																																obj_t
																																																																	BgL_varsz00_21838;
																																																																BgL_varsz00_21838
																																																																	=
																																																																	BgL_arg5049z00_6157;
																																																																BgL_bodyz00_21839
																																																																	=
																																																																	BgL_arg5050z00_6158;
																																																																BgL_argsz00_21840
																																																																	=
																																																																	BgL_arg5051z00_6159;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_21840;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_21839;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_21838;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_21837);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_21844;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_21844);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd232981zd2_6164;
																																																				BgL_cdrzd232981zd2_6164
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8807z00_21848;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5064z00_6173;
																																																						BgL_arg5064z00_6173
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8807z00_21848
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5064z00_6173));
																																																					}
																																																					if (BgL_test8807z00_21848)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5058z00_6167;
																																																							obj_t
																																																								BgL_arg5059z00_6168;
																																																							BgL_arg5058z00_6167
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6164));
																																																							BgL_arg5059z00_6168
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6164));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_21857;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_21859;
																																																									obj_t
																																																										BgL_bindingsz00_21858;
																																																									BgL_bindingsz00_21858
																																																										=
																																																										BgL_arg5058z00_6167;
																																																									BgL_exprz00_21859
																																																										=
																																																										BgL_arg5059z00_6168;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_21859;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_21858;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_21857);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8808z00_21861;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5063z00_6172;
																																																								BgL_arg5063z00_6172
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8808z00_21861
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5063z00_6172));
																																																							}
																																																							if (BgL_test8808z00_21861)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_21866;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21866);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_21870;
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21870);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231546zd2_5900)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd231548zd2_5902;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd231546zd2_5900 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd231548zd2_5902;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd231546zd2_5900 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd231548zd2_5902;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd231546zd2_5900)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd231548zd2_5902;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd233153zd2_5908;
																																																										BgL_cdrzd233153zd2_5908
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8814z00_21886;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4964z00_6025;
																																																												BgL_arg4964z00_6025
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8814z00_21886
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg4964z00_6025));
																																																											}
																																																											if (BgL_test8814z00_21886)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg4892z00_5911;
																																																													obj_t
																																																														BgL_arg4893z00_5912;
																																																													BgL_arg4892z00_5911
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5908));
																																																													BgL_arg4893z00_5912
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5908));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_21895;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_21897;
																																																															obj_t
																																																																BgL_bindingsz00_21896;
																																																															BgL_bindingsz00_21896
																																																																=
																																																																BgL_arg4892z00_5911;
																																																															BgL_exprz00_21897
																																																																=
																																																																BgL_arg4893z00_5912;
																																																															BgL_exprz00_1780
																																																																=
																																																																BgL_exprz00_21897;
																																																															BgL_bindingsz00_1779
																																																																=
																																																																BgL_bindingsz00_21896;
																																																															goto
																																																																BgL_tagzd2382zd2_1781;
																																																														}
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_21895);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8815z00_21899;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4963z00_6024;
																																																														BgL_arg4963z00_6024
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8815z00_21899
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg4963z00_6024));
																																																													}
																																																													if (BgL_test8815z00_21899)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_21904;
																																																															goto
																																																																BgL_tagzd2384zd2_1783;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_21904);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd233219zd2_5915;
																																																															BgL_carzd233219zd2_5915
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd233224zd2_5916;
																																																																BgL_cdrzd233224zd2_5916
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd233219zd2_5915));
																																																																if ((CAR(((obj_t) BgL_carzd233219zd2_5915)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd233224zd2_5916))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4899z00_5920;
																																																																				obj_t
																																																																					BgL_arg4900z00_5921;
																																																																				obj_t
																																																																					BgL_arg4901z00_5922;
																																																																				BgL_arg4899z00_5920
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd233224zd2_5916);
																																																																				BgL_arg4900z00_5921
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd233224zd2_5916);
																																																																				BgL_arg4901z00_5922
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_21921;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_21924;
																																																																						obj_t
																																																																							BgL_bodyz00_21923;
																																																																						obj_t
																																																																							BgL_varsz00_21922;
																																																																						BgL_varsz00_21922
																																																																							=
																																																																							BgL_arg4899z00_5920;
																																																																						BgL_bodyz00_21923
																																																																							=
																																																																							BgL_arg4900z00_5921;
																																																																						BgL_argsz00_21924
																																																																							=
																																																																							BgL_arg4901z00_5922;
																																																																						BgL_argsz00_1790
																																																																							=
																																																																							BgL_argsz00_21924;
																																																																						BgL_bodyz00_1789
																																																																							=
																																																																							BgL_bodyz00_21923;
																																																																						BgL_varsz00_1788
																																																																							=
																																																																							BgL_varsz00_21922;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1791;
																																																																					}
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_21921);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21928;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21928);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd233331zd2_5925;
																																																																		BgL_cdrzd233331zd2_5925
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd233336zd2_5926;
																																																																			BgL_cdrzd233336zd2_5926
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd233219zd2_5915));
																																																																			if ((CAR(((obj_t) BgL_carzd233219zd2_5915)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd233336zd2_5926))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd233341zd2_5930;
																																																																							BgL_cdrzd233341zd2_5930
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd233336zd2_5926);
																																																																							if (PAIRP(BgL_cdrzd233341zd2_5930))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd233345zd2_5932;
																																																																									obj_t
																																																																										BgL_cdrzd233346zd2_5933;
																																																																									BgL_carzd233345zd2_5932
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd233341zd2_5930);
																																																																									BgL_cdrzd233346zd2_5933
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd233341zd2_5930);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233345zd2_5932))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd233346zd2_5933))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd233351zd2_5936;
																																																																													BgL_carzd233351zd2_5936
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd233346zd2_5933);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233351zd2_5936))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd233346zd2_5933)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8826z00_21956;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1425z00_5969;
																																																																																		BgL_l1425z00_5969
																																																																																			=
																																																																																			BgL_cdrzd233331zd2_5925;
																																																																																	BgL_zc3z04anonymousza34927ze3z87_5970:
																																																																																		if (NULLP(BgL_l1425z00_5969))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8826z00_21956
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test8828z00_21959;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test8829z00_21960;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_21961;
																																																																																						BgL_tmpz00_21961
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1425z00_5969));
																																																																																						BgL_test8829z00_21960
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_21961);
																																																																																					}
																																																																																					if (BgL_test8829z00_21960)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8828z00_21959
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8828z00_21959
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test8828z00_21959)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1425z00_21965;
																																																																																						BgL_l1425z00_21965
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1425z00_5969));
																																																																																						BgL_l1425z00_5969
																																																																																							=
																																																																																							BgL_l1425z00_21965;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza34927ze3z87_5970;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test8826z00_21956
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8826z00_21956)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg4917z00_5952;
																																																																																			BgL_arg4917z00_5952
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd233336zd2_5926);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21969;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21973;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21972;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21971;
																																																																																					obj_t
																																																																																						BgL_testz00_21970;
																																																																																					BgL_testz00_21970
																																																																																						=
																																																																																						BgL_arg4917z00_5952;
																																																																																					BgL_proc1z00_21971
																																																																																						=
																																																																																						BgL_carzd233345zd2_5932;
																																																																																					BgL_proc2z00_21972
																																																																																						=
																																																																																						BgL_carzd233351zd2_5936;
																																																																																					BgL_argsz00_21973
																																																																																						=
																																																																																						BgL_cdrzd233331zd2_5925;
																																																																																					BgL_argsz00_1795
																																																																																						=
																																																																																						BgL_argsz00_21973;
																																																																																					BgL_proc2z00_1794
																																																																																						=
																																																																																						BgL_proc2z00_21972;
																																																																																					BgL_proc1z00_1793
																																																																																						=
																																																																																						BgL_proc1z00_21971;
																																																																																					BgL_testz00_1792
																																																																																						=
																																																																																						BgL_testz00_21970;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1796;
																																																																																				}
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21969);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd233376zd2_5953;
																																																																																			BgL_cdrzd233376zd2_5953
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd233384zd2_5954;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11628;
																																																																																					BgL_pairz00_11628
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd233384zd2_5954
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_11628);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd233392zd2_5955;
																																																																																					BgL_cdrzd233392zd2_5955
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd233384zd2_5954));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd233399zd2_5956;
																																																																																						BgL_carzd233399zd2_5956
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd233392zd2_5955));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233399zd2_5956))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd233408zd2_5958;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_11632;
																																																																																									BgL_pairz00_11632
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd233392zd2_5955));
																																																																																									BgL_carzd233408zd2_5958
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_11632);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233408zd2_5958))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233376zd2_5953))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg4921z00_5961;
																																																																																												BgL_arg4921z00_5961
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd233384zd2_5954));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_21995;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_21999;
																																																																																														obj_t
																																																																																															BgL_proc2z00_21998;
																																																																																														obj_t
																																																																																															BgL_proc1z00_21997;
																																																																																														obj_t
																																																																																															BgL_testz00_21996;
																																																																																														BgL_testz00_21996
																																																																																															=
																																																																																															BgL_arg4921z00_5961;
																																																																																														BgL_proc1z00_21997
																																																																																															=
																																																																																															BgL_carzd233399zd2_5956;
																																																																																														BgL_proc2z00_21998
																																																																																															=
																																																																																															BgL_carzd233408zd2_5958;
																																																																																														BgL_argsz00_21999
																																																																																															=
																																																																																															BgL_cdrzd233376zd2_5953;
																																																																																														BgL_argsz00_1800
																																																																																															=
																																																																																															BgL_argsz00_21999;
																																																																																														BgL_proc2z00_1799
																																																																																															=
																																																																																															BgL_proc2z00_21998;
																																																																																														BgL_proc1z00_1798
																																																																																															=
																																																																																															BgL_proc1z00_21997;
																																																																																														BgL_testz00_1797
																																																																																															=
																																																																																															BgL_testz00_21996;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1801;
																																																																																													}
																																																																																													BgL_auxz00_21492
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_21995);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1825;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_22003;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1826;
																																																																																														BgL_auxz00_21492
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_22003);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22007;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_21492
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22007);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22011;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22011);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22015;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22015);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd233686zd2_5980;
																																																																															BgL_cdrzd233686zd2_5980
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd233693zd2_5981;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11636;
																																																																																	BgL_pairz00_11636
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd233693zd2_5981
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11636);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd233700zd2_5982;
																																																																																	BgL_cdrzd233700zd2_5982
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd233693zd2_5981));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd233706zd2_5983;
																																																																																		obj_t
																																																																																			BgL_cdrzd233707zd2_5984;
																																																																																		BgL_carzd233706zd2_5983
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5982));
																																																																																		BgL_cdrzd233707zd2_5984
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5982));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233706zd2_5983))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd233714zd2_5986;
																																																																																				BgL_carzd233714zd2_5986
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd233707zd2_5984));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233714zd2_5986))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd233707zd2_5984))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233686zd2_5980))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg4936z00_5991;
																																																																																										BgL_arg4936z00_5991
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd233693zd2_5981));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22042;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22046;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22045;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22044;
																																																																																												obj_t
																																																																																													BgL_testz00_22043;
																																																																																												BgL_testz00_22043
																																																																																													=
																																																																																													BgL_arg4936z00_5991;
																																																																																												BgL_proc1z00_22044
																																																																																													=
																																																																																													BgL_carzd233706zd2_5983;
																																																																																												BgL_proc2z00_22045
																																																																																													=
																																																																																													BgL_carzd233714zd2_5986;
																																																																																												BgL_argsz00_22046
																																																																																													=
																																																																																													BgL_cdrzd233686zd2_5980;
																																																																																												BgL_argsz00_1800
																																																																																													=
																																																																																													BgL_argsz00_22046;
																																																																																												BgL_proc2z00_1799
																																																																																													=
																																																																																													BgL_proc2z00_22045;
																																																																																												BgL_proc1z00_1798
																																																																																													=
																																																																																													BgL_proc1z00_22044;
																																																																																												BgL_testz00_1797
																																																																																													=
																																																																																													BgL_testz00_22043;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1801;
																																																																																											}
																																																																																											BgL_auxz00_21492
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22042);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22050;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_21492
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22050);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22054;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22054);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22058;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22058);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22062;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22062);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22066;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22066);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd234047zd2_5999;
																																																																											BgL_cdrzd234047zd2_5999
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd234053zd2_6000;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11645;
																																																																													BgL_pairz00_11645
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd234053zd2_6000
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11645);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd234059zd2_6001;
																																																																													BgL_cdrzd234059zd2_6001
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd234053zd2_6000));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd234064zd2_6002;
																																																																														obj_t
																																																																															BgL_cdrzd234065zd2_6003;
																																																																														BgL_carzd234064zd2_6002
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_6001));
																																																																														BgL_cdrzd234065zd2_6003
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_6001));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234064zd2_6002))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd234065zd2_6003))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd234070zd2_6006;
																																																																																		BgL_carzd234070zd2_6006
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd234065zd2_6003);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234070zd2_6006))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd234065zd2_6003)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd234047zd2_5999))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg4950z00_6011;
																																																																																								BgL_arg4950z00_6011
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd234053zd2_6000));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22093;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22097;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22096;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22095;
																																																																																										obj_t
																																																																																											BgL_testz00_22094;
																																																																																										BgL_testz00_22094
																																																																																											=
																																																																																											BgL_arg4950z00_6011;
																																																																																										BgL_proc1z00_22095
																																																																																											=
																																																																																											BgL_carzd234064zd2_6002;
																																																																																										BgL_proc2z00_22096
																																																																																											=
																																																																																											BgL_carzd234070zd2_6006;
																																																																																										BgL_argsz00_22097
																																																																																											=
																																																																																											BgL_cdrzd234047zd2_5999;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_22097;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_22096;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_22095;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_22094;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_21492
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22093);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22101;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22101);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22105;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22105);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22109;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22109);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22113;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22113);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22117;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22117);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22121;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22121);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22125;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22125);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22129;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22129);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd234608zd2_6175;
																																															BgL_cdrzd234608zd2_6175
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd231543zd2_5898 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5066z00_6177;
																																																	obj_t
																																																		BgL_arg5067z00_6178;
																																																	BgL_arg5066z00_6177
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6175));
																																																	BgL_arg5067z00_6178
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6175));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22140;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22142;
																																																			obj_t
																																																				BgL_bindingsz00_22141;
																																																			BgL_bindingsz00_22141
																																																				=
																																																				BgL_arg5066z00_6177;
																																																			BgL_exprz00_22142
																																																				=
																																																				BgL_arg5067z00_6178;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_22142;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_22141;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22140);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231543zd2_5898)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5069z00_6180;
																																																			obj_t
																																																				BgL_arg5070z00_6181;
																																																			BgL_arg5069z00_6180
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6175));
																																																			BgL_arg5070z00_6181
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6175));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22151;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22153;
																																																					obj_t
																																																						BgL_bindingsz00_22152;
																																																					BgL_bindingsz00_22152
																																																						=
																																																						BgL_arg5069z00_6180;
																																																					BgL_exprz00_22153
																																																						=
																																																						BgL_arg5070z00_6181;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_22153;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_22152;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22151);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd231543zd2_5898 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5072z00_6183;
																																																					obj_t
																																																						BgL_arg5073z00_6184;
																																																					BgL_arg5072z00_6183
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6175));
																																																					BgL_arg5073z00_6184
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6175));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22162;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22164;
																																																							obj_t
																																																								BgL_bindingsz00_22163;
																																																							BgL_bindingsz00_22163
																																																								=
																																																								BgL_arg5072z00_6183;
																																																							BgL_exprz00_22164
																																																								=
																																																								BgL_arg5073z00_6184;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_22164;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_22163;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22162);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22171;
																																																							goto
																																																								BgL_tagzd2383zd2_1782;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22171);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd234645zd2_6187;
																																																							BgL_carzd234645zd2_6187
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd234645zd2_6187 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22178;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22178);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234645zd2_6187)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22183;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22183);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22190;
																																																													goto
																																																														BgL_tagzd2389zd2_1802;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22190);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22197;
																																																															goto
																																																																BgL_tagzd2390zd2_1803;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22197);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd234725zd2_6194;
																																																															BgL_cdrzd234725zd2_6194
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5084z00_6197;
																																																																	obj_t
																																																																		BgL_arg5085z00_6198;
																																																																	BgL_arg5084z00_6197
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6194));
																																																																	BgL_arg5085z00_6198
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6194));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_22210;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_22212;
																																																																			obj_t
																																																																				BgL_effectz00_22211;
																																																																			BgL_effectz00_22211
																																																																				=
																																																																				BgL_arg5084z00_6197;
																																																																			BgL_restz00_22212
																																																																				=
																																																																				BgL_arg5085z00_6198;
																																																																			BgL_restz00_1805
																																																																				=
																																																																				BgL_restz00_22212;
																																																																			BgL_effectz00_1804
																																																																				=
																																																																				BgL_effectz00_22211;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1806;
																																																																		}
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_22210);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22219;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1807;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22219);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22226;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1808;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22226);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg5092z00_6206;
																																																																							obj_t
																																																																								BgL_arg5093z00_6207;
																																																																							BgL_arg5092z00_6206
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6194));
																																																																							BgL_arg5093z00_6207
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6194));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22237;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_22239;
																																																																									obj_t
																																																																										BgL_effectz00_22238;
																																																																									BgL_effectz00_22238
																																																																										=
																																																																										BgL_arg5092z00_6206;
																																																																									BgL_restz00_22239
																																																																										=
																																																																										BgL_arg5093z00_6207;
																																																																									BgL_restz00_1810
																																																																										=
																																																																										BgL_restz00_22239;
																																																																									BgL_effectz00_1809
																																																																										=
																																																																										BgL_effectz00_22238;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1811;
																																																																								}
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22237);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22246;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1812;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22246);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22253;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1813;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22253);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_22260;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1814;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22260);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_22267;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1815;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22267);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd234802zd2_6216;
																																																																															BgL_cdrzd234802zd2_6216
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5104z00_6219;
																																																																																	obj_t
																																																																																		BgL_arg5105z00_6220;
																																																																																	BgL_arg5104z00_6219
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6216));
																																																																																	BgL_arg5105z00_6220
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6216));
																																																																																	{	/* Ast/sexp.scm 555 */
																																																																																		obj_t
																																																																																			BgL_arg7023z00_11682;
																																																																																		BgL_arg7023z00_11682
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg5104z00_6219,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg5105z00_6220, BgL_stackz00_22, BgL_arg7023z00_11682, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22286;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22286);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd234827zd2_6237;
																																			BgL_carzd234827zd2_6237
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd234827zd2_6237
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_22293;
																																					goto
																																						BgL_tagzd2377zd2_1770;
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_22293);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd234827zd2_6237
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22297;
																																							goto
																																								BgL_tagzd2377zd2_1770;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22297);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22304;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22304);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22311;
																																											goto
																																												BgL_tagzd2380zd2_1775;
																																											BgL_auxz00_21492
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22311);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd234896zd2_6244;
																																											BgL_carzd234896zd2_6244
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd234896zd2_6244))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd234899zd2_6246;
																																													obj_t
																																														BgL_cdrzd234900zd2_6247;
																																													BgL_carzd234899zd2_6246
																																														=
																																														CAR
																																														(BgL_carzd234896zd2_6244);
																																													BgL_cdrzd234900zd2_6247
																																														=
																																														CDR
																																														(BgL_carzd234896zd2_6244);
																																													{

																																														if ((BgL_carzd234899zd2_6246 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd234901zd2_6248:
																																																if (PAIRP(BgL_cdrzd234900zd2_6247))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd234904zd2_6373;
																																																		BgL_cdrzd234904zd2_6373
																																																			=
																																																			CDR
																																																			(BgL_cdrzd234900zd2_6247);
																																																		if (PAIRP(BgL_cdrzd234904zd2_6373))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd234904zd2_6373)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5212z00_6377;
																																																						obj_t
																																																							BgL_arg5213z00_6378;
																																																						BgL_arg5212z00_6377
																																																							=
																																																							CAR
																																																							(BgL_cdrzd234904zd2_6373);
																																																						BgL_arg5213z00_6378
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22333;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_22335;
																																																								obj_t
																																																									BgL_bodyz00_22334;
																																																								BgL_bodyz00_22334
																																																									=
																																																									BgL_arg5212z00_6377;
																																																								BgL_argsz00_22335
																																																									=
																																																									BgL_arg5213z00_6378;
																																																								BgL_argsz00_1777
																																																									=
																																																									BgL_argsz00_22335;
																																																								BgL_bodyz00_1776
																																																									=
																																																									BgL_bodyz00_22334;
																																																								goto
																																																									BgL_tagzd2381zd2_1778;
																																																							}
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22333);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd234928zd2_6379;
																																																						BgL_cdrzd234928zd2_6379
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8886z00_22339;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5282z00_6490;
																																																								BgL_arg5282z00_6490
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8886z00_22339
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5282z00_6490));
																																																							}
																																																							if (BgL_test8886z00_22339)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5216z00_6382;
																																																									obj_t
																																																										BgL_arg5217z00_6383;
																																																									BgL_arg5216z00_6382
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6379));
																																																									BgL_arg5217z00_6383
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6379));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22348;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22350;
																																																											obj_t
																																																												BgL_bindingsz00_22349;
																																																											BgL_bindingsz00_22349
																																																												=
																																																												BgL_arg5216z00_6382;
																																																											BgL_exprz00_22350
																																																												=
																																																												BgL_arg5217z00_6383;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_22350;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_22349;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22348);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8887z00_22352;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5281z00_6489;
																																																										BgL_arg5281z00_6489
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8887z00_22352
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5281z00_6489));
																																																									}
																																																									if (BgL_test8887z00_22352)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22357;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22357);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd234995zd2_6386;
																																																											BgL_carzd234995zd2_6386
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd235000zd2_6387;
																																																												BgL_cdrzd235000zd2_6387
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd234995zd2_6386));
																																																												if ((CAR(((obj_t) BgL_carzd234995zd2_6386)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5222z00_6390;
																																																														obj_t
																																																															BgL_arg5223z00_6391;
																																																														obj_t
																																																															BgL_arg5224z00_6392;
																																																														BgL_arg5222z00_6390
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6387));
																																																														BgL_arg5223z00_6391
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6387));
																																																														BgL_arg5224z00_6392
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22374;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22377;
																																																																obj_t
																																																																	BgL_bodyz00_22376;
																																																																obj_t
																																																																	BgL_varsz00_22375;
																																																																BgL_varsz00_22375
																																																																	=
																																																																	BgL_arg5222z00_6390;
																																																																BgL_bodyz00_22376
																																																																	=
																																																																	BgL_arg5223z00_6391;
																																																																BgL_argsz00_22377
																																																																	=
																																																																	BgL_arg5224z00_6392;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_22377;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_22376;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_22375;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22374);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd235023zd2_6394;
																																																														BgL_cdrzd235023zd2_6394
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd235029zd2_6395;
																																																															BgL_cdrzd235029zd2_6395
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd234995zd2_6386));
																																																															if ((CAR(((obj_t) BgL_carzd234995zd2_6386)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd235035zd2_6398;
																																																																	BgL_cdrzd235035zd2_6398
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd235029zd2_6395));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd235040zd2_6399;
																																																																		obj_t
																																																																			BgL_cdrzd235041zd2_6400;
																																																																		BgL_carzd235040zd2_6399
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6398));
																																																																		BgL_cdrzd235041zd2_6400
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6398));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235040zd2_6399))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd235041zd2_6400))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd235048zd2_6403;
																																																																						BgL_carzd235048zd2_6403
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd235041zd2_6400);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235048zd2_6403))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd235041zd2_6400)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8894z00_22404;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1428z00_6436;
																																																																											BgL_l1428z00_6436
																																																																												=
																																																																												BgL_cdrzd235023zd2_6394;
																																																																										BgL_zc3z04anonymousza35247ze3z87_6437:
																																																																											if (NULLP(BgL_l1428z00_6436))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8894z00_22404
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8896z00_22407;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8897z00_22408;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_22409;
																																																																															BgL_tmpz00_22409
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1428z00_6436));
																																																																															BgL_test8897z00_22408
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_22409);
																																																																														}
																																																																														if (BgL_test8897z00_22408)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8896z00_22407
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8896z00_22407
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test8896z00_22407)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1428z00_22413;
																																																																															BgL_l1428z00_22413
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1428z00_6436));
																																																																															BgL_l1428z00_6436
																																																																																=
																																																																																BgL_l1428z00_22413;
																																																																															goto
																																																																																BgL_zc3z04anonymousza35247ze3z87_6437;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8894z00_22404
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test8894z00_22404)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg5237z00_6419;
																																																																												BgL_arg5237z00_6419
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd235029zd2_6395));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22418;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_22422;
																																																																														obj_t
																																																																															BgL_proc2z00_22421;
																																																																														obj_t
																																																																															BgL_proc1z00_22420;
																																																																														obj_t
																																																																															BgL_testz00_22419;
																																																																														BgL_testz00_22419
																																																																															=
																																																																															BgL_arg5237z00_6419;
																																																																														BgL_proc1z00_22420
																																																																															=
																																																																															BgL_carzd235040zd2_6399;
																																																																														BgL_proc2z00_22421
																																																																															=
																																																																															BgL_carzd235048zd2_6403;
																																																																														BgL_argsz00_22422
																																																																															=
																																																																															BgL_cdrzd235023zd2_6394;
																																																																														BgL_argsz00_1795
																																																																															=
																																																																															BgL_argsz00_22422;
																																																																														BgL_proc2z00_1794
																																																																															=
																																																																															BgL_proc2z00_22421;
																																																																														BgL_proc1z00_1793
																																																																															=
																																																																															BgL_proc1z00_22420;
																																																																														BgL_testz00_1792
																																																																															=
																																																																															BgL_testz00_22419;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1796;
																																																																													}
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22418);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd235072zd2_6420;
																																																																												BgL_cdrzd235072zd2_6420
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd235079zd2_6421;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_11718;
																																																																														BgL_pairz00_11718
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd235079zd2_6421
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_11718);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd235086zd2_6422;
																																																																														BgL_cdrzd235086zd2_6422
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd235079zd2_6421));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd235092zd2_6423;
																																																																															BgL_carzd235092zd2_6423
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd235086zd2_6422));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235092zd2_6423))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd235099zd2_6425;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_11722;
																																																																																		BgL_pairz00_11722
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd235086zd2_6422));
																																																																																		BgL_carzd235099zd2_6425
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_11722);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235099zd2_6425))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235072zd2_6420))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg5241z00_6428;
																																																																																					BgL_arg5241z00_6428
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd235079zd2_6421));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22444;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22448;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22447;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22446;
																																																																																							obj_t
																																																																																								BgL_testz00_22445;
																																																																																							BgL_testz00_22445
																																																																																								=
																																																																																								BgL_arg5241z00_6428;
																																																																																							BgL_proc1z00_22446
																																																																																								=
																																																																																								BgL_carzd235092zd2_6423;
																																																																																							BgL_proc2z00_22447
																																																																																								=
																																																																																								BgL_carzd235099zd2_6425;
																																																																																							BgL_argsz00_22448
																																																																																								=
																																																																																								BgL_cdrzd235072zd2_6420;
																																																																																							BgL_argsz00_1800
																																																																																								=
																																																																																								BgL_argsz00_22448;
																																																																																							BgL_proc2z00_1799
																																																																																								=
																																																																																								BgL_proc2z00_22447;
																																																																																							BgL_proc1z00_1798
																																																																																								=
																																																																																								BgL_proc1z00_22446;
																																																																																							BgL_testz00_1797
																																																																																								=
																																																																																								BgL_testz00_22445;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1801;
																																																																																						}
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22444);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1825;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22452;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1826;
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22452);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22456;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22456);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22460;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22460);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_22464;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_22464);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd235375zd2_6447;
																																																																								BgL_cdrzd235375zd2_6447
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd235381zd2_6448;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_11726;
																																																																										BgL_pairz00_11726
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd235381zd2_6448
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_11726);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd235387zd2_6449;
																																																																										BgL_cdrzd235387zd2_6449
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd235381zd2_6448));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235392zd2_6450;
																																																																											obj_t
																																																																												BgL_cdrzd235393zd2_6451;
																																																																											BgL_carzd235392zd2_6450
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6449));
																																																																											BgL_cdrzd235393zd2_6451
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6449));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235392zd2_6450))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd235398zd2_6453;
																																																																													BgL_carzd235398zd2_6453
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd235393zd2_6451));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235398zd2_6453))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd235393zd2_6451))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235375zd2_6447))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5256z00_6458;
																																																																																			BgL_arg5256z00_6458
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd235381zd2_6448));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22491;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22495;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22494;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22493;
																																																																																					obj_t
																																																																																						BgL_testz00_22492;
																																																																																					BgL_testz00_22492
																																																																																						=
																																																																																						BgL_arg5256z00_6458;
																																																																																					BgL_proc1z00_22493
																																																																																						=
																																																																																						BgL_carzd235392zd2_6450;
																																																																																					BgL_proc2z00_22494
																																																																																						=
																																																																																						BgL_carzd235398zd2_6453;
																																																																																					BgL_argsz00_22495
																																																																																						=
																																																																																						BgL_cdrzd235375zd2_6447;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_22495;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_22494;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_22493;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_22492;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22491);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22499;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22499);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22503;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22503);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22507;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22507);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22511;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22511);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22515;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22515);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd235731zd2_6466;
																																																																				BgL_cdrzd235731zd2_6466
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd235738zd2_6467;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_11735;
																																																																						BgL_pairz00_11735
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd235738zd2_6467
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_11735);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd235745zd2_6468;
																																																																						BgL_cdrzd235745zd2_6468
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd235738zd2_6467));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd235751zd2_6469;
																																																																							obj_t
																																																																								BgL_cdrzd235752zd2_6470;
																																																																							BgL_carzd235751zd2_6469
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6468));
																																																																							BgL_cdrzd235752zd2_6470
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6468));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235751zd2_6469))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd235752zd2_6470))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235759zd2_6473;
																																																																											BgL_carzd235759zd2_6473
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd235752zd2_6470);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235759zd2_6473))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd235752zd2_6470)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235731zd2_6466))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5270z00_6478;
																																																																																	BgL_arg5270z00_6478
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd235738zd2_6467));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22542;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_22546;
																																																																																			obj_t
																																																																																				BgL_proc2z00_22545;
																																																																																			obj_t
																																																																																				BgL_proc1z00_22544;
																																																																																			obj_t
																																																																																				BgL_testz00_22543;
																																																																																			BgL_testz00_22543
																																																																																				=
																																																																																				BgL_arg5270z00_6478;
																																																																																			BgL_proc1z00_22544
																																																																																				=
																																																																																				BgL_carzd235751zd2_6469;
																																																																																			BgL_proc2z00_22545
																																																																																				=
																																																																																				BgL_carzd235759zd2_6473;
																																																																																			BgL_argsz00_22546
																																																																																				=
																																																																																				BgL_cdrzd235731zd2_6466;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_22546;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_22545;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_22544;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_22543;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22542);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22550;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22550);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22554;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22554);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22558;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22558);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22562;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22562);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22566;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22566);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22570;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22570);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd236152zd2_6492;
																																																				BgL_cdrzd236152zd2_6492
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8925z00_22574;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5298z00_6509;
																																																						BgL_arg5298z00_6509
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8925z00_22574
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5298z00_6509));
																																																					}
																																																					if (BgL_test8925z00_22574)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5286z00_6495;
																																																							obj_t
																																																								BgL_arg5287z00_6496;
																																																							BgL_arg5286z00_6495
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6492));
																																																							BgL_arg5287z00_6496
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6492));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_22583;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_22585;
																																																									obj_t
																																																										BgL_bindingsz00_22584;
																																																									BgL_bindingsz00_22584
																																																										=
																																																										BgL_arg5286z00_6495;
																																																									BgL_exprz00_22585
																																																										=
																																																										BgL_arg5287z00_6496;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_22585;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_22584;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_22583);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8926z00_22587;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5297z00_6508;
																																																								BgL_arg5297z00_6508
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8926z00_22587
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5297z00_6508));
																																																							}
																																																							if (BgL_test8926z00_22587)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22592;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22592);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd236218zd2_6499;
																																																									BgL_carzd236218zd2_6499
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd236223zd2_6500;
																																																										BgL_cdrzd236223zd2_6500
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd236218zd2_6499));
																																																										if ((CAR(((obj_t) BgL_carzd236218zd2_6499)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5292z00_6503;
																																																												obj_t
																																																													BgL_arg5293z00_6504;
																																																												obj_t
																																																													BgL_arg5294z00_6505;
																																																												BgL_arg5292z00_6503
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6500));
																																																												BgL_arg5293z00_6504
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6500));
																																																												BgL_arg5294z00_6505
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22609;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_22612;
																																																														obj_t
																																																															BgL_bodyz00_22611;
																																																														obj_t
																																																															BgL_varsz00_22610;
																																																														BgL_varsz00_22610
																																																															=
																																																															BgL_arg5292z00_6503;
																																																														BgL_bodyz00_22611
																																																															=
																																																															BgL_arg5293z00_6504;
																																																														BgL_argsz00_22612
																																																															=
																																																															BgL_arg5294z00_6505;
																																																														BgL_argsz00_1790
																																																															=
																																																															BgL_argsz00_22612;
																																																														BgL_bodyz00_1789
																																																															=
																																																															BgL_bodyz00_22611;
																																																														BgL_varsz00_1788
																																																															=
																																																															BgL_varsz00_22610;
																																																														goto
																																																															BgL_tagzd2386zd2_1791;
																																																													}
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22609);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_22616;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_22616);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd236334zd2_6510;
																																																		BgL_cdrzd236334zd2_6510
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8929z00_22620;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5307z00_6519;
																																																				BgL_arg5307z00_6519
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8929z00_22620
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5307z00_6519));
																																																			}
																																																			if (BgL_test8929z00_22620)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5301z00_6513;
																																																					obj_t
																																																						BgL_arg5302z00_6514;
																																																					BgL_arg5301z00_6513
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6510));
																																																					BgL_arg5302z00_6514
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6510));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22629;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22631;
																																																							obj_t
																																																								BgL_bindingsz00_22630;
																																																							BgL_bindingsz00_22630
																																																								=
																																																								BgL_arg5301z00_6513;
																																																							BgL_exprz00_22631
																																																								=
																																																								BgL_arg5302z00_6514;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_22631;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_22630;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22629);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8930z00_22633;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5306z00_6518;
																																																						BgL_arg5306z00_6518
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8930z00_22633
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5306z00_6518));
																																																					}
																																																					if (BgL_test8930z00_22633)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_22638;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22638);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_22642;
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22642);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234899zd2_6246)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd234901zd2_6248;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd234899zd2_6246 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd234901zd2_6248;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd234899zd2_6246 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd234901zd2_6248;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234899zd2_6246)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd234901zd2_6248;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd236506zd2_6254;
																																																								BgL_cdrzd236506zd2_6254
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8936z00_22658;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5207z00_6371;
																																																										BgL_arg5207z00_6371
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8936z00_22658
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5207z00_6371));
																																																									}
																																																									if (BgL_test8936z00_22658)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5135z00_6257;
																																																											obj_t
																																																												BgL_arg5136z00_6258;
																																																											BgL_arg5135z00_6257
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6254));
																																																											BgL_arg5136z00_6258
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6254));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_22667;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_22669;
																																																													obj_t
																																																														BgL_bindingsz00_22668;
																																																													BgL_bindingsz00_22668
																																																														=
																																																														BgL_arg5135z00_6257;
																																																													BgL_exprz00_22669
																																																														=
																																																														BgL_arg5136z00_6258;
																																																													BgL_exprz00_1780
																																																														=
																																																														BgL_exprz00_22669;
																																																													BgL_bindingsz00_1779
																																																														=
																																																														BgL_bindingsz00_22668;
																																																													goto
																																																														BgL_tagzd2382zd2_1781;
																																																												}
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_22667);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8937z00_22671;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5206z00_6370;
																																																												BgL_arg5206z00_6370
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8937z00_22671
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5206z00_6370));
																																																											}
																																																											if (BgL_test8937z00_22671)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_22676;
																																																													goto
																																																														BgL_tagzd2384zd2_1783;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22676);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd236572zd2_6261;
																																																													BgL_carzd236572zd2_6261
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd236577zd2_6262;
																																																														BgL_cdrzd236577zd2_6262
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd236572zd2_6261));
																																																														if ((CAR(((obj_t) BgL_carzd236572zd2_6261)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd236577zd2_6262))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg5142z00_6266;
																																																																		obj_t
																																																																			BgL_arg5143z00_6267;
																																																																		obj_t
																																																																			BgL_arg5144z00_6268;
																																																																		BgL_arg5142z00_6266
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd236577zd2_6262);
																																																																		BgL_arg5143z00_6267
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd236577zd2_6262);
																																																																		BgL_arg5144z00_6268
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22693;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_22696;
																																																																				obj_t
																																																																					BgL_bodyz00_22695;
																																																																				obj_t
																																																																					BgL_varsz00_22694;
																																																																				BgL_varsz00_22694
																																																																					=
																																																																					BgL_arg5142z00_6266;
																																																																				BgL_bodyz00_22695
																																																																					=
																																																																					BgL_arg5143z00_6267;
																																																																				BgL_argsz00_22696
																																																																					=
																																																																					BgL_arg5144z00_6268;
																																																																				BgL_argsz00_1790
																																																																					=
																																																																					BgL_argsz00_22696;
																																																																				BgL_bodyz00_1789
																																																																					=
																																																																					BgL_bodyz00_22695;
																																																																				BgL_varsz00_1788
																																																																					=
																																																																					BgL_varsz00_22694;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1791;
																																																																			}
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22693);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_22700;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_22700);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd236684zd2_6271;
																																																																BgL_cdrzd236684zd2_6271
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd236689zd2_6272;
																																																																	BgL_cdrzd236689zd2_6272
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd236572zd2_6261));
																																																																	if ((CAR(((obj_t) BgL_carzd236572zd2_6261)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd236689zd2_6272))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd236694zd2_6276;
																																																																					BgL_cdrzd236694zd2_6276
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd236689zd2_6272);
																																																																					if (PAIRP(BgL_cdrzd236694zd2_6276))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd236698zd2_6278;
																																																																							obj_t
																																																																								BgL_cdrzd236699zd2_6279;
																																																																							BgL_carzd236698zd2_6278
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd236694zd2_6276);
																																																																							BgL_cdrzd236699zd2_6279
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd236694zd2_6276);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236698zd2_6278))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd236699zd2_6279))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd236704zd2_6282;
																																																																											BgL_carzd236704zd2_6282
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd236699zd2_6279);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236704zd2_6282))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd236699zd2_6279)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8948z00_22728;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1431z00_6315;
																																																																																BgL_l1431z00_6315
																																																																																	=
																																																																																	BgL_cdrzd236684zd2_6271;
																																																																															BgL_zc3z04anonymousza35170ze3z87_6316:
																																																																																if (NULLP(BgL_l1431z00_6315))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8948z00_22728
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test8950z00_22731;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test8951z00_22732;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_22733;
																																																																																				BgL_tmpz00_22733
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1431z00_6315));
																																																																																				BgL_test8951z00_22732
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_22733);
																																																																																			}
																																																																																			if (BgL_test8951z00_22732)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8950z00_22731
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8950z00_22731
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test8950z00_22731)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1431z00_22737;
																																																																																				BgL_l1431z00_22737
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1431z00_6315));
																																																																																				BgL_l1431z00_6315
																																																																																					=
																																																																																					BgL_l1431z00_22737;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza35170ze3z87_6316;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8948z00_22728
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test8948z00_22728)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5160z00_6298;
																																																																																	BgL_arg5160z00_6298
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd236689zd2_6272);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22741;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_22745;
																																																																																			obj_t
																																																																																				BgL_proc2z00_22744;
																																																																																			obj_t
																																																																																				BgL_proc1z00_22743;
																																																																																			obj_t
																																																																																				BgL_testz00_22742;
																																																																																			BgL_testz00_22742
																																																																																				=
																																																																																				BgL_arg5160z00_6298;
																																																																																			BgL_proc1z00_22743
																																																																																				=
																																																																																				BgL_carzd236698zd2_6278;
																																																																																			BgL_proc2z00_22744
																																																																																				=
																																																																																				BgL_carzd236704zd2_6282;
																																																																																			BgL_argsz00_22745
																																																																																				=
																																																																																				BgL_cdrzd236684zd2_6271;
																																																																																			BgL_argsz00_1795
																																																																																				=
																																																																																				BgL_argsz00_22745;
																																																																																			BgL_proc2z00_1794
																																																																																				=
																																																																																				BgL_proc2z00_22744;
																																																																																			BgL_proc1z00_1793
																																																																																				=
																																																																																				BgL_proc1z00_22743;
																																																																																			BgL_testz00_1792
																																																																																				=
																																																																																				BgL_testz00_22742;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1796;
																																																																																		}
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22741);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd236729zd2_6299;
																																																																																	BgL_cdrzd236729zd2_6299
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd236737zd2_6300;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_11783;
																																																																																			BgL_pairz00_11783
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd236737zd2_6300
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_11783);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd236745zd2_6301;
																																																																																			BgL_cdrzd236745zd2_6301
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd236737zd2_6300));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd236752zd2_6302;
																																																																																				BgL_carzd236752zd2_6302
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd236745zd2_6301));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236752zd2_6302))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd236761zd2_6304;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_11787;
																																																																																							BgL_pairz00_11787
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd236745zd2_6301));
																																																																																							BgL_carzd236761zd2_6304
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_11787);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236761zd2_6304))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd236729zd2_6299))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg5164z00_6307;
																																																																																										BgL_arg5164z00_6307
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd236737zd2_6300));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22767;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22771;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22770;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22769;
																																																																																												obj_t
																																																																																													BgL_testz00_22768;
																																																																																												BgL_testz00_22768
																																																																																													=
																																																																																													BgL_arg5164z00_6307;
																																																																																												BgL_proc1z00_22769
																																																																																													=
																																																																																													BgL_carzd236752zd2_6302;
																																																																																												BgL_proc2z00_22770
																																																																																													=
																																																																																													BgL_carzd236761zd2_6304;
																																																																																												BgL_argsz00_22771
																																																																																													=
																																																																																													BgL_cdrzd236729zd2_6299;
																																																																																												BgL_argsz00_1800
																																																																																													=
																																																																																													BgL_argsz00_22771;
																																																																																												BgL_proc2z00_1799
																																																																																													=
																																																																																													BgL_proc2z00_22770;
																																																																																												BgL_proc1z00_1798
																																																																																													=
																																																																																													BgL_proc1z00_22769;
																																																																																												BgL_testz00_1797
																																																																																													=
																																																																																													BgL_testz00_22768;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1801;
																																																																																											}
																																																																																											BgL_auxz00_21492
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22767);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1825;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22775;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1826;
																																																																																												BgL_auxz00_21492
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22775);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22779;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22779);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22783;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22783);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22787;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22787);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd237039zd2_6326;
																																																																													BgL_cdrzd237039zd2_6326
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd237046zd2_6327;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_11791;
																																																																															BgL_pairz00_11791
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd237046zd2_6327
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_11791);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd237053zd2_6328;
																																																																															BgL_cdrzd237053zd2_6328
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd237046zd2_6327));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237059zd2_6329;
																																																																																obj_t
																																																																																	BgL_cdrzd237060zd2_6330;
																																																																																BgL_carzd237059zd2_6329
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6328));
																																																																																BgL_cdrzd237060zd2_6330
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6328));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237059zd2_6329))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd237067zd2_6332;
																																																																																		BgL_carzd237067zd2_6332
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd237060zd2_6330));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237067zd2_6332))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd237060zd2_6330))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237039zd2_6326))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5179z00_6337;
																																																																																								BgL_arg5179z00_6337
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd237046zd2_6327));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22814;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22818;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22817;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22816;
																																																																																										obj_t
																																																																																											BgL_testz00_22815;
																																																																																										BgL_testz00_22815
																																																																																											=
																																																																																											BgL_arg5179z00_6337;
																																																																																										BgL_proc1z00_22816
																																																																																											=
																																																																																											BgL_carzd237059zd2_6329;
																																																																																										BgL_proc2z00_22817
																																																																																											=
																																																																																											BgL_carzd237067zd2_6332;
																																																																																										BgL_argsz00_22818
																																																																																											=
																																																																																											BgL_cdrzd237039zd2_6326;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_22818;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_22817;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_22816;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_22815;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_21492
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22814);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22822;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22822);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22826;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22826);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22830;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22830);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22834;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22834);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22838;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22838);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd237400zd2_6345;
																																																																									BgL_cdrzd237400zd2_6345
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd237406zd2_6346;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11800;
																																																																											BgL_pairz00_11800
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd237406zd2_6346
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11800);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd237412zd2_6347;
																																																																											BgL_cdrzd237412zd2_6347
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd237406zd2_6346));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd237417zd2_6348;
																																																																												obj_t
																																																																													BgL_cdrzd237418zd2_6349;
																																																																												BgL_carzd237417zd2_6348
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6347));
																																																																												BgL_cdrzd237418zd2_6349
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6347));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237417zd2_6348))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd237418zd2_6349))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237423zd2_6352;
																																																																																BgL_carzd237423zd2_6352
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd237418zd2_6349);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237423zd2_6352))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd237418zd2_6349)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237400zd2_6345))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5193z00_6357;
																																																																																						BgL_arg5193z00_6357
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd237406zd2_6346));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22865;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_22869;
																																																																																								obj_t
																																																																																									BgL_proc2z00_22868;
																																																																																								obj_t
																																																																																									BgL_proc1z00_22867;
																																																																																								obj_t
																																																																																									BgL_testz00_22866;
																																																																																								BgL_testz00_22866
																																																																																									=
																																																																																									BgL_arg5193z00_6357;
																																																																																								BgL_proc1z00_22867
																																																																																									=
																																																																																									BgL_carzd237417zd2_6348;
																																																																																								BgL_proc2z00_22868
																																																																																									=
																																																																																									BgL_carzd237423zd2_6352;
																																																																																								BgL_argsz00_22869
																																																																																									=
																																																																																									BgL_cdrzd237400zd2_6345;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_22869;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_22868;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_22867;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_22866;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22865);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22873;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22873);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22877;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22877);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22881;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22881);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22885;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22885);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_22889;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_22889);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22893;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22893);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22897;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22897);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22901;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22901);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd237961zd2_6521;
																																													BgL_cdrzd237961zd2_6521
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd234896zd2_6244 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5309z00_6523;
																																															obj_t
																																																BgL_arg5310z00_6524;
																																															BgL_arg5309z00_6523
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6521));
																																															BgL_arg5310z00_6524
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6521));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_22912;
																																																{
																																																	obj_t
																																																		BgL_exprz00_22914;
																																																	obj_t
																																																		BgL_bindingsz00_22913;
																																																	BgL_bindingsz00_22913
																																																		=
																																																		BgL_arg5309z00_6523;
																																																	BgL_exprz00_22914
																																																		=
																																																		BgL_arg5310z00_6524;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_22914;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_22913;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_22912);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234896zd2_6244)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5312z00_6526;
																																																	obj_t
																																																		BgL_arg5313z00_6527;
																																																	BgL_arg5312z00_6526
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6521));
																																																	BgL_arg5313z00_6527
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6521));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22923;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22925;
																																																			obj_t
																																																				BgL_bindingsz00_22924;
																																																			BgL_bindingsz00_22924
																																																				=
																																																				BgL_arg5312z00_6526;
																																																			BgL_exprz00_22925
																																																				=
																																																				BgL_arg5313z00_6527;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_22925;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_22924;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22923);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd234896zd2_6244 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5315z00_6529;
																																																			obj_t
																																																				BgL_arg5316z00_6530;
																																																			BgL_arg5315z00_6529
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6521));
																																																			BgL_arg5316z00_6530
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6521));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22934;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22936;
																																																					obj_t
																																																						BgL_bindingsz00_22935;
																																																					BgL_bindingsz00_22935
																																																						=
																																																						BgL_arg5315z00_6529;
																																																					BgL_exprz00_22936
																																																						=
																																																						BgL_arg5316z00_6530;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_22936;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_22935;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22934);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_22943;
																																																					goto
																																																						BgL_tagzd2383zd2_1782;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_22943);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd237998zd2_6533;
																																																					BgL_carzd237998zd2_6533
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd237998zd2_6533 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_22950;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22950);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd237998zd2_6533)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22955;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22955);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_22962;
																																																											goto
																																																												BgL_tagzd2389zd2_1802;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22962);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22969;
																																																													goto
																																																														BgL_tagzd2390zd2_1803;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22969);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238078zd2_6540;
																																																													BgL_cdrzd238078zd2_6540
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg5327z00_6543;
																																																															obj_t
																																																																BgL_arg5328z00_6544;
																																																															BgL_arg5327z00_6543
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6540));
																																																															BgL_arg5328z00_6544
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6540));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_22982;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_22984;
																																																																	obj_t
																																																																		BgL_effectz00_22983;
																																																																	BgL_effectz00_22983
																																																																		=
																																																																		BgL_arg5327z00_6543;
																																																																	BgL_restz00_22984
																																																																		=
																																																																		BgL_arg5328z00_6544;
																																																																	BgL_restz00_1805
																																																																		=
																																																																		BgL_restz00_22984;
																																																																	BgL_effectz00_1804
																																																																		=
																																																																		BgL_effectz00_22983;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1806;
																																																																}
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_22982);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_22991;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1807;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_22991);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22998;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1808;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22998);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg5335z00_6552;
																																																																					obj_t
																																																																						BgL_arg5336z00_6553;
																																																																					BgL_arg5335z00_6552
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6540));
																																																																					BgL_arg5336z00_6553
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6540));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23009;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_23011;
																																																																							obj_t
																																																																								BgL_effectz00_23010;
																																																																							BgL_effectz00_23010
																																																																								=
																																																																								BgL_arg5335z00_6552;
																																																																							BgL_restz00_23011
																																																																								=
																																																																								BgL_arg5336z00_6553;
																																																																							BgL_restz00_1810
																																																																								=
																																																																								BgL_restz00_23011;
																																																																							BgL_effectz00_1809
																																																																								=
																																																																								BgL_effectz00_23010;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1811;
																																																																						}
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23009);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23018;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1812;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23018);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23025;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1813;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23025);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_23032;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1814;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23032);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_23039;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1815;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23039);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd238155zd2_6562;
																																																																													BgL_cdrzd238155zd2_6562
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5347z00_6565;
																																																																															obj_t
																																																																																BgL_arg5348z00_6566;
																																																																															BgL_arg5347z00_6565
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6562));
																																																																															BgL_arg5348z00_6566
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6562));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7023z00_11837;
																																																																																BgL_arg7023z00_11837
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg5347z00_6565,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg5348z00_6566, BgL_stackz00_22, BgL_arg7023z00_11837, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23058;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23058);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd238180zd2_6583;
																																	BgL_carzd238180zd2_6583
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd238180zd2_6583
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23065;
																																			goto
																																				BgL_tagzd2377zd2_1770;
																																			BgL_auxz00_21492
																																				=
																																				((obj_t)
																																				BgL_auxz00_23065);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd238180zd2_6583
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_23069;
																																					goto
																																						BgL_tagzd2377zd2_1770;
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_23069);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23076;
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23076);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23083;
																																									goto
																																										BgL_tagzd2380zd2_1775;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23083);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd238249zd2_6590;
																																									BgL_carzd238249zd2_6590
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd238249zd2_6590))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd238252zd2_6592;
																																											obj_t
																																												BgL_cdrzd238253zd2_6593;
																																											BgL_carzd238252zd2_6592
																																												=
																																												CAR
																																												(BgL_carzd238249zd2_6590);
																																											BgL_cdrzd238253zd2_6593
																																												=
																																												CDR
																																												(BgL_carzd238249zd2_6590);
																																											{

																																												if ((BgL_carzd238252zd2_6592 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd238254zd2_6594:
																																														if (PAIRP(BgL_cdrzd238253zd2_6593))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd238257zd2_6719;
																																																BgL_cdrzd238257zd2_6719
																																																	=
																																																	CDR
																																																	(BgL_cdrzd238253zd2_6593);
																																																if (PAIRP(BgL_cdrzd238257zd2_6719))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd238257zd2_6719)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5456z00_6723;
																																																				obj_t
																																																					BgL_arg5457z00_6724;
																																																				BgL_arg5456z00_6723
																																																					=
																																																					CAR
																																																					(BgL_cdrzd238257zd2_6719);
																																																				BgL_arg5457z00_6724
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23105;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_23107;
																																																						obj_t
																																																							BgL_bodyz00_23106;
																																																						BgL_bodyz00_23106
																																																							=
																																																							BgL_arg5456z00_6723;
																																																						BgL_argsz00_23107
																																																							=
																																																							BgL_arg5457z00_6724;
																																																						BgL_argsz00_1777
																																																							=
																																																							BgL_argsz00_23107;
																																																						BgL_bodyz00_1776
																																																							=
																																																							BgL_bodyz00_23106;
																																																						goto
																																																							BgL_tagzd2381zd2_1778;
																																																					}
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23105);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd238281zd2_6725;
																																																				BgL_cdrzd238281zd2_6725
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9008z00_23111;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5526z00_6836;
																																																						BgL_arg5526z00_6836
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9008z00_23111
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5526z00_6836));
																																																					}
																																																					if (BgL_test9008z00_23111)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5460z00_6728;
																																																							obj_t
																																																								BgL_arg5461z00_6729;
																																																							BgL_arg5460z00_6728
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6725));
																																																							BgL_arg5461z00_6729
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6725));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23120;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23122;
																																																									obj_t
																																																										BgL_bindingsz00_23121;
																																																									BgL_bindingsz00_23121
																																																										=
																																																										BgL_arg5460z00_6728;
																																																									BgL_exprz00_23122
																																																										=
																																																										BgL_arg5461z00_6729;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_23122;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_23121;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23120);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9009z00_23124;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5525z00_6835;
																																																								BgL_arg5525z00_6835
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9009z00_23124
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5525z00_6835));
																																																							}
																																																							if (BgL_test9009z00_23124)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23129;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23129);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd238348zd2_6732;
																																																									BgL_carzd238348zd2_6732
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd238353zd2_6733;
																																																										BgL_cdrzd238353zd2_6733
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd238348zd2_6732));
																																																										if ((CAR(((obj_t) BgL_carzd238348zd2_6732)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5466z00_6736;
																																																												obj_t
																																																													BgL_arg5467z00_6737;
																																																												obj_t
																																																													BgL_arg5468z00_6738;
																																																												BgL_arg5466z00_6736
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6733));
																																																												BgL_arg5467z00_6737
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6733));
																																																												BgL_arg5468z00_6738
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23146;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23149;
																																																														obj_t
																																																															BgL_bodyz00_23148;
																																																														obj_t
																																																															BgL_varsz00_23147;
																																																														BgL_varsz00_23147
																																																															=
																																																															BgL_arg5466z00_6736;
																																																														BgL_bodyz00_23148
																																																															=
																																																															BgL_arg5467z00_6737;
																																																														BgL_argsz00_23149
																																																															=
																																																															BgL_arg5468z00_6738;
																																																														BgL_argsz00_1790
																																																															=
																																																															BgL_argsz00_23149;
																																																														BgL_bodyz00_1789
																																																															=
																																																															BgL_bodyz00_23148;
																																																														BgL_varsz00_1788
																																																															=
																																																															BgL_varsz00_23147;
																																																														goto
																																																															BgL_tagzd2386zd2_1791;
																																																													}
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23146);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd238376zd2_6740;
																																																												BgL_cdrzd238376zd2_6740
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238382zd2_6741;
																																																													BgL_cdrzd238382zd2_6741
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd238348zd2_6732));
																																																													if ((CAR(((obj_t) BgL_carzd238348zd2_6732)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd238388zd2_6744;
																																																															BgL_cdrzd238388zd2_6744
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238382zd2_6741));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd238393zd2_6745;
																																																																obj_t
																																																																	BgL_cdrzd238394zd2_6746;
																																																																BgL_carzd238393zd2_6745
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6744));
																																																																BgL_cdrzd238394zd2_6746
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6744));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238393zd2_6745))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd238394zd2_6746))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd238401zd2_6749;
																																																																				BgL_carzd238401zd2_6749
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd238394zd2_6746);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238401zd2_6749))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd238394zd2_6746)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9016z00_23176;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1434z00_6782;
																																																																									BgL_l1434z00_6782
																																																																										=
																																																																										BgL_cdrzd238376zd2_6740;
																																																																								BgL_zc3z04anonymousza35491ze3z87_6783:
																																																																									if (NULLP(BgL_l1434z00_6782))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9016z00_23176
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9018z00_23179;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9019z00_23180;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_23181;
																																																																													BgL_tmpz00_23181
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1434z00_6782));
																																																																													BgL_test9019z00_23180
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_23181);
																																																																												}
																																																																												if (BgL_test9019z00_23180)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9018z00_23179
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9018z00_23179
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9018z00_23179)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1434z00_23185;
																																																																													BgL_l1434z00_23185
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1434z00_6782));
																																																																													BgL_l1434z00_6782
																																																																														=
																																																																														BgL_l1434z00_23185;
																																																																													goto
																																																																														BgL_zc3z04anonymousza35491ze3z87_6783;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9016z00_23176
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9016z00_23176)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg5481z00_6765;
																																																																										BgL_arg5481z00_6765
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd238382zd2_6741));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23190;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_23194;
																																																																												obj_t
																																																																													BgL_proc2z00_23193;
																																																																												obj_t
																																																																													BgL_proc1z00_23192;
																																																																												obj_t
																																																																													BgL_testz00_23191;
																																																																												BgL_testz00_23191
																																																																													=
																																																																													BgL_arg5481z00_6765;
																																																																												BgL_proc1z00_23192
																																																																													=
																																																																													BgL_carzd238393zd2_6745;
																																																																												BgL_proc2z00_23193
																																																																													=
																																																																													BgL_carzd238401zd2_6749;
																																																																												BgL_argsz00_23194
																																																																													=
																																																																													BgL_cdrzd238376zd2_6740;
																																																																												BgL_argsz00_1795
																																																																													=
																																																																													BgL_argsz00_23194;
																																																																												BgL_proc2z00_1794
																																																																													=
																																																																													BgL_proc2z00_23193;
																																																																												BgL_proc1z00_1793
																																																																													=
																																																																													BgL_proc1z00_23192;
																																																																												BgL_testz00_1792
																																																																													=
																																																																													BgL_testz00_23191;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1796;
																																																																											}
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23190);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd238425zd2_6766;
																																																																										BgL_cdrzd238425zd2_6766
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd238432zd2_6767;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11873;
																																																																												BgL_pairz00_11873
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd238432zd2_6767
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11873);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd238439zd2_6768;
																																																																												BgL_cdrzd238439zd2_6768
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd238432zd2_6767));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd238445zd2_6769;
																																																																													BgL_carzd238445zd2_6769
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd238439zd2_6768));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238445zd2_6769))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd238452zd2_6771;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11877;
																																																																																BgL_pairz00_11877
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd238439zd2_6768));
																																																																																BgL_carzd238452zd2_6771
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11877);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238452zd2_6771))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238425zd2_6766))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5485z00_6774;
																																																																																			BgL_arg5485z00_6774
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd238432zd2_6767));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23216;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23220;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23219;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23218;
																																																																																					obj_t
																																																																																						BgL_testz00_23217;
																																																																																					BgL_testz00_23217
																																																																																						=
																																																																																						BgL_arg5485z00_6774;
																																																																																					BgL_proc1z00_23218
																																																																																						=
																																																																																						BgL_carzd238445zd2_6769;
																																																																																					BgL_proc2z00_23219
																																																																																						=
																																																																																						BgL_carzd238452zd2_6771;
																																																																																					BgL_argsz00_23220
																																																																																						=
																																																																																						BgL_cdrzd238425zd2_6766;
																																																																																					BgL_argsz00_1800
																																																																																						=
																																																																																						BgL_argsz00_23220;
																																																																																					BgL_proc2z00_1799
																																																																																						=
																																																																																						BgL_proc2z00_23219;
																																																																																					BgL_proc1z00_1798
																																																																																						=
																																																																																						BgL_proc1z00_23218;
																																																																																					BgL_testz00_1797
																																																																																						=
																																																																																						BgL_testz00_23217;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1801;
																																																																																				}
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23216);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1825;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23224;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1826;
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23224);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23228;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23228);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23232;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23232);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_23236;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_23236);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd238728zd2_6793;
																																																																						BgL_cdrzd238728zd2_6793
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd238734zd2_6794;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11881;
																																																																								BgL_pairz00_11881
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd238734zd2_6794
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11881);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd238740zd2_6795;
																																																																								BgL_cdrzd238740zd2_6795
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd238734zd2_6794));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd238745zd2_6796;
																																																																									obj_t
																																																																										BgL_cdrzd238746zd2_6797;
																																																																									BgL_carzd238745zd2_6796
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6795));
																																																																									BgL_cdrzd238746zd2_6797
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6795));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238745zd2_6796))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd238751zd2_6799;
																																																																											BgL_carzd238751zd2_6799
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd238746zd2_6797));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238751zd2_6799))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd238746zd2_6797))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238728zd2_6793))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5500z00_6804;
																																																																																	BgL_arg5500z00_6804
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd238734zd2_6794));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23263;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23267;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23266;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23265;
																																																																																			obj_t
																																																																																				BgL_testz00_23264;
																																																																																			BgL_testz00_23264
																																																																																				=
																																																																																				BgL_arg5500z00_6804;
																																																																																			BgL_proc1z00_23265
																																																																																				=
																																																																																				BgL_carzd238745zd2_6796;
																																																																																			BgL_proc2z00_23266
																																																																																				=
																																																																																				BgL_carzd238751zd2_6799;
																																																																																			BgL_argsz00_23267
																																																																																				=
																																																																																				BgL_cdrzd238728zd2_6793;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_23267;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_23266;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_23265;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_23264;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23263);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23271;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23271);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23275;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23275);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23279;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23279);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23283;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23283);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23287;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23287);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd239084zd2_6812;
																																																																		BgL_cdrzd239084zd2_6812
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd239091zd2_6813;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11890;
																																																																				BgL_pairz00_11890
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd239091zd2_6813
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11890);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd239098zd2_6814;
																																																																				BgL_cdrzd239098zd2_6814
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd239091zd2_6813));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd239104zd2_6815;
																																																																					obj_t
																																																																						BgL_cdrzd239105zd2_6816;
																																																																					BgL_carzd239104zd2_6815
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6814));
																																																																					BgL_cdrzd239105zd2_6816
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6814));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239104zd2_6815))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd239105zd2_6816))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd239112zd2_6819;
																																																																									BgL_carzd239112zd2_6819
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd239105zd2_6816);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239112zd2_6819))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd239105zd2_6816)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd239084zd2_6812))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5514z00_6824;
																																																																															BgL_arg5514z00_6824
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd239091zd2_6813));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23314;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23318;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23317;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23316;
																																																																																	obj_t
																																																																																		BgL_testz00_23315;
																																																																																	BgL_testz00_23315
																																																																																		=
																																																																																		BgL_arg5514z00_6824;
																																																																																	BgL_proc1z00_23316
																																																																																		=
																																																																																		BgL_carzd239104zd2_6815;
																																																																																	BgL_proc2z00_23317
																																																																																		=
																																																																																		BgL_carzd239112zd2_6819;
																																																																																	BgL_argsz00_23318
																																																																																		=
																																																																																		BgL_cdrzd239084zd2_6812;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_23318;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_23317;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_23316;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_23315;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23314);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23322;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23322);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23326;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23326);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23330;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23330);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23334;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23334);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23338;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23338);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23342;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23342);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd239505zd2_6838;
																																																		BgL_cdrzd239505zd2_6838
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9047z00_23346;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5542z00_6855;
																																																				BgL_arg5542z00_6855
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9047z00_23346
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5542z00_6855));
																																																			}
																																																			if (BgL_test9047z00_23346)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5530z00_6841;
																																																					obj_t
																																																						BgL_arg5531z00_6842;
																																																					BgL_arg5530z00_6841
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6838));
																																																					BgL_arg5531z00_6842
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6838));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23355;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23357;
																																																							obj_t
																																																								BgL_bindingsz00_23356;
																																																							BgL_bindingsz00_23356
																																																								=
																																																								BgL_arg5530z00_6841;
																																																							BgL_exprz00_23357
																																																								=
																																																								BgL_arg5531z00_6842;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_23357;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_23356;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23355);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9048z00_23359;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5541z00_6854;
																																																						BgL_arg5541z00_6854
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9048z00_23359
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5541z00_6854));
																																																					}
																																																					if (BgL_test9048z00_23359)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23364;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23364);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd239571zd2_6845;
																																																							BgL_carzd239571zd2_6845
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd239576zd2_6846;
																																																								BgL_cdrzd239576zd2_6846
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd239571zd2_6845));
																																																								if ((CAR(((obj_t) BgL_carzd239571zd2_6845)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5536z00_6849;
																																																										obj_t
																																																											BgL_arg5537z00_6850;
																																																										obj_t
																																																											BgL_arg5538z00_6851;
																																																										BgL_arg5536z00_6849
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6846));
																																																										BgL_arg5537z00_6850
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6846));
																																																										BgL_arg5538z00_6851
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23381;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_23384;
																																																												obj_t
																																																													BgL_bodyz00_23383;
																																																												obj_t
																																																													BgL_varsz00_23382;
																																																												BgL_varsz00_23382
																																																													=
																																																													BgL_arg5536z00_6849;
																																																												BgL_bodyz00_23383
																																																													=
																																																													BgL_arg5537z00_6850;
																																																												BgL_argsz00_23384
																																																													=
																																																													BgL_arg5538z00_6851;
																																																												BgL_argsz00_1790
																																																													=
																																																													BgL_argsz00_23384;
																																																												BgL_bodyz00_1789
																																																													=
																																																													BgL_bodyz00_23383;
																																																												BgL_varsz00_1788
																																																													=
																																																													BgL_varsz00_23382;
																																																												goto
																																																													BgL_tagzd2386zd2_1791;
																																																											}
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23381);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23388;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23388);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd239687zd2_6856;
																																																BgL_cdrzd239687zd2_6856
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9051z00_23392;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5551z00_6865;
																																																		BgL_arg5551z00_6865
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9051z00_23392
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5551z00_6865));
																																																	}
																																																	if (BgL_test9051z00_23392)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5545z00_6859;
																																																			obj_t
																																																				BgL_arg5546z00_6860;
																																																			BgL_arg5545z00_6859
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6856));
																																																			BgL_arg5546z00_6860
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6856));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23401;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23403;
																																																					obj_t
																																																						BgL_bindingsz00_23402;
																																																					BgL_bindingsz00_23402
																																																						=
																																																						BgL_arg5545z00_6859;
																																																					BgL_exprz00_23403
																																																						=
																																																						BgL_arg5546z00_6860;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_23403;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_23402;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23401);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9052z00_23405;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5550z00_6864;
																																																				BgL_arg5550z00_6864
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9052z00_23405
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5550z00_6864));
																																																			}
																																																			if (BgL_test9052z00_23405)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_23410;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23410);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1825;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_23414;
																																																							goto
																																																								BgL_tagzd2404zd2_1826;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23414);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238252zd2_6592)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd238254zd2_6594;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd238252zd2_6592 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd238254zd2_6594;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd238252zd2_6592 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd238254zd2_6594;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd238252zd2_6592)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd238254zd2_6594;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd239859zd2_6600;
																																																						BgL_cdrzd239859zd2_6600
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9058z00_23430;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5451z00_6717;
																																																								BgL_arg5451z00_6717
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9058z00_23430
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5451z00_6717));
																																																							}
																																																							if (BgL_test9058z00_23430)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5379z00_6603;
																																																									obj_t
																																																										BgL_arg5380z00_6604;
																																																									BgL_arg5379z00_6603
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6600));
																																																									BgL_arg5380z00_6604
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6600));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_23439;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_23441;
																																																											obj_t
																																																												BgL_bindingsz00_23440;
																																																											BgL_bindingsz00_23440
																																																												=
																																																												BgL_arg5379z00_6603;
																																																											BgL_exprz00_23441
																																																												=
																																																												BgL_arg5380z00_6604;
																																																											BgL_exprz00_1780
																																																												=
																																																												BgL_exprz00_23441;
																																																											BgL_bindingsz00_1779
																																																												=
																																																												BgL_bindingsz00_23440;
																																																											goto
																																																												BgL_tagzd2382zd2_1781;
																																																										}
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_23439);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9059z00_23443;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5450z00_6716;
																																																										BgL_arg5450z00_6716
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9059z00_23443
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5450z00_6716));
																																																									}
																																																									if (BgL_test9059z00_23443)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_23448;
																																																											goto
																																																												BgL_tagzd2384zd2_1783;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23448);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd239925zd2_6607;
																																																											BgL_carzd239925zd2_6607
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd239930zd2_6608;
																																																												BgL_cdrzd239930zd2_6608
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd239925zd2_6607));
																																																												if ((CAR(((obj_t) BgL_carzd239925zd2_6607)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd239930zd2_6608))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg5386z00_6612;
																																																																obj_t
																																																																	BgL_arg5387z00_6613;
																																																																obj_t
																																																																	BgL_arg5388z00_6614;
																																																																BgL_arg5386z00_6612
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd239930zd2_6608);
																																																																BgL_arg5387z00_6613
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd239930zd2_6608);
																																																																BgL_arg5388z00_6614
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23465;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_23468;
																																																																		obj_t
																																																																			BgL_bodyz00_23467;
																																																																		obj_t
																																																																			BgL_varsz00_23466;
																																																																		BgL_varsz00_23466
																																																																			=
																																																																			BgL_arg5386z00_6612;
																																																																		BgL_bodyz00_23467
																																																																			=
																																																																			BgL_arg5387z00_6613;
																																																																		BgL_argsz00_23468
																																																																			=
																																																																			BgL_arg5388z00_6614;
																																																																		BgL_argsz00_1790
																																																																			=
																																																																			BgL_argsz00_23468;
																																																																		BgL_bodyz00_1789
																																																																			=
																																																																			BgL_bodyz00_23467;
																																																																		BgL_varsz00_1788
																																																																			=
																																																																			BgL_varsz00_23466;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1791;
																																																																	}
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23465);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_23472;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_23472);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd240037zd2_6617;
																																																														BgL_cdrzd240037zd2_6617
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd240042zd2_6618;
																																																															BgL_cdrzd240042zd2_6618
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd239925zd2_6607));
																																																															if ((CAR(((obj_t) BgL_carzd239925zd2_6607)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd240042zd2_6618))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd240047zd2_6622;
																																																																			BgL_cdrzd240047zd2_6622
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd240042zd2_6618);
																																																																			if (PAIRP(BgL_cdrzd240047zd2_6622))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd240051zd2_6624;
																																																																					obj_t
																																																																						BgL_cdrzd240052zd2_6625;
																																																																					BgL_carzd240051zd2_6624
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd240047zd2_6622);
																																																																					BgL_cdrzd240052zd2_6625
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd240047zd2_6622);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240051zd2_6624))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd240052zd2_6625))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd240057zd2_6628;
																																																																									BgL_carzd240057zd2_6628
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd240052zd2_6625);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240057zd2_6628))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd240052zd2_6625)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9070z00_23500;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1437z00_6661;
																																																																														BgL_l1437z00_6661
																																																																															=
																																																																															BgL_cdrzd240037zd2_6617;
																																																																													BgL_zc3z04anonymousza35414ze3z87_6662:
																																																																														if (NULLP(BgL_l1437z00_6661))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9070z00_23500
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test9072z00_23503;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test9073z00_23504;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_23505;
																																																																																		BgL_tmpz00_23505
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1437z00_6661));
																																																																																		BgL_test9073z00_23504
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_23505);
																																																																																	}
																																																																																	if (BgL_test9073z00_23504)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9072z00_23503
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9072z00_23503
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test9072z00_23503)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1437z00_23509;
																																																																																		BgL_l1437z00_23509
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1437z00_6661));
																																																																																		BgL_l1437z00_6661
																																																																																			=
																																																																																			BgL_l1437z00_23509;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza35414ze3z87_6662;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9070z00_23500
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test9070z00_23500)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5404z00_6644;
																																																																															BgL_arg5404z00_6644
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd240042zd2_6618);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23513;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23517;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23516;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23515;
																																																																																	obj_t
																																																																																		BgL_testz00_23514;
																																																																																	BgL_testz00_23514
																																																																																		=
																																																																																		BgL_arg5404z00_6644;
																																																																																	BgL_proc1z00_23515
																																																																																		=
																																																																																		BgL_carzd240051zd2_6624;
																																																																																	BgL_proc2z00_23516
																																																																																		=
																																																																																		BgL_carzd240057zd2_6628;
																																																																																	BgL_argsz00_23517
																																																																																		=
																																																																																		BgL_cdrzd240037zd2_6617;
																																																																																	BgL_argsz00_1795
																																																																																		=
																																																																																		BgL_argsz00_23517;
																																																																																	BgL_proc2z00_1794
																																																																																		=
																																																																																		BgL_proc2z00_23516;
																																																																																	BgL_proc1z00_1793
																																																																																		=
																																																																																		BgL_proc1z00_23515;
																																																																																	BgL_testz00_1792
																																																																																		=
																																																																																		BgL_testz00_23514;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1796;
																																																																																}
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23513);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd240082zd2_6645;
																																																																															BgL_cdrzd240082zd2_6645
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd240090zd2_6646;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11938;
																																																																																	BgL_pairz00_11938
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd240090zd2_6646
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11938);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd240098zd2_6647;
																																																																																	BgL_cdrzd240098zd2_6647
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd240090zd2_6646));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd240105zd2_6648;
																																																																																		BgL_carzd240105zd2_6648
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd240098zd2_6647));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240105zd2_6648))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd240114zd2_6650;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11942;
																																																																																					BgL_pairz00_11942
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd240098zd2_6647));
																																																																																					BgL_carzd240114zd2_6650
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_11942);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240114zd2_6650))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240082zd2_6645))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5408z00_6653;
																																																																																								BgL_arg5408z00_6653
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd240090zd2_6646));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_23539;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_23543;
																																																																																										obj_t
																																																																																											BgL_proc2z00_23542;
																																																																																										obj_t
																																																																																											BgL_proc1z00_23541;
																																																																																										obj_t
																																																																																											BgL_testz00_23540;
																																																																																										BgL_testz00_23540
																																																																																											=
																																																																																											BgL_arg5408z00_6653;
																																																																																										BgL_proc1z00_23541
																																																																																											=
																																																																																											BgL_carzd240105zd2_6648;
																																																																																										BgL_proc2z00_23542
																																																																																											=
																																																																																											BgL_carzd240114zd2_6650;
																																																																																										BgL_argsz00_23543
																																																																																											=
																																																																																											BgL_cdrzd240082zd2_6645;
																																																																																										BgL_argsz00_1800
																																																																																											=
																																																																																											BgL_argsz00_23543;
																																																																																										BgL_proc2z00_1799
																																																																																											=
																																																																																											BgL_proc2z00_23542;
																																																																																										BgL_proc1z00_1798
																																																																																											=
																																																																																											BgL_proc1z00_23541;
																																																																																										BgL_testz00_1797
																																																																																											=
																																																																																											BgL_testz00_23540;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1801;
																																																																																									}
																																																																																									BgL_auxz00_21492
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_23539);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1825;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23547;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1826;
																																																																																										BgL_auxz00_21492
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23547);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23551;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23551);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23555;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23555);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23559;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23559);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd240392zd2_6672;
																																																																											BgL_cdrzd240392zd2_6672
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd240399zd2_6673;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11946;
																																																																													BgL_pairz00_11946
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd240399zd2_6673
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11946);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd240406zd2_6674;
																																																																													BgL_cdrzd240406zd2_6674
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd240399zd2_6673));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240412zd2_6675;
																																																																														obj_t
																																																																															BgL_cdrzd240413zd2_6676;
																																																																														BgL_carzd240412zd2_6675
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6674));
																																																																														BgL_cdrzd240413zd2_6676
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6674));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240412zd2_6675))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd240420zd2_6678;
																																																																																BgL_carzd240420zd2_6678
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd240413zd2_6676));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240420zd2_6678))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd240413zd2_6676))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240392zd2_6672))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5423z00_6683;
																																																																																						BgL_arg5423z00_6683
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd240399zd2_6673));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23586;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_23590;
																																																																																								obj_t
																																																																																									BgL_proc2z00_23589;
																																																																																								obj_t
																																																																																									BgL_proc1z00_23588;
																																																																																								obj_t
																																																																																									BgL_testz00_23587;
																																																																																								BgL_testz00_23587
																																																																																									=
																																																																																									BgL_arg5423z00_6683;
																																																																																								BgL_proc1z00_23588
																																																																																									=
																																																																																									BgL_carzd240412zd2_6675;
																																																																																								BgL_proc2z00_23589
																																																																																									=
																																																																																									BgL_carzd240420zd2_6678;
																																																																																								BgL_argsz00_23590
																																																																																									=
																																																																																									BgL_cdrzd240392zd2_6672;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_23590;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_23589;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_23588;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_23587;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23586);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23594;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23594);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23598;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23598);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23602;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23602);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23606;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23606);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23610;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23610);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd240753zd2_6691;
																																																																							BgL_cdrzd240753zd2_6691
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd240759zd2_6692;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11955;
																																																																									BgL_pairz00_11955
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd240759zd2_6692
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_11955);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd240765zd2_6693;
																																																																									BgL_cdrzd240765zd2_6693
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd240759zd2_6692));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd240770zd2_6694;
																																																																										obj_t
																																																																											BgL_cdrzd240771zd2_6695;
																																																																										BgL_carzd240770zd2_6694
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6693));
																																																																										BgL_cdrzd240771zd2_6695
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6693));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240770zd2_6694))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd240771zd2_6695))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240776zd2_6698;
																																																																														BgL_carzd240776zd2_6698
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd240771zd2_6695);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240776zd2_6698))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd240771zd2_6695)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240753zd2_6691))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5437z00_6703;
																																																																																				BgL_arg5437z00_6703
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd240759zd2_6692));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23637;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_23641;
																																																																																						obj_t
																																																																																							BgL_proc2z00_23640;
																																																																																						obj_t
																																																																																							BgL_proc1z00_23639;
																																																																																						obj_t
																																																																																							BgL_testz00_23638;
																																																																																						BgL_testz00_23638
																																																																																							=
																																																																																							BgL_arg5437z00_6703;
																																																																																						BgL_proc1z00_23639
																																																																																							=
																																																																																							BgL_carzd240770zd2_6694;
																																																																																						BgL_proc2z00_23640
																																																																																							=
																																																																																							BgL_carzd240776zd2_6698;
																																																																																						BgL_argsz00_23641
																																																																																							=
																																																																																							BgL_cdrzd240753zd2_6691;
																																																																																						BgL_argsz00_1800
																																																																																							=
																																																																																							BgL_argsz00_23641;
																																																																																						BgL_proc2z00_1799
																																																																																							=
																																																																																							BgL_proc2z00_23640;
																																																																																						BgL_proc1z00_1798
																																																																																							=
																																																																																							BgL_proc1z00_23639;
																																																																																						BgL_testz00_1797
																																																																																							=
																																																																																							BgL_testz00_23638;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1801;
																																																																																					}
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23637);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23645;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23645);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23649;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23649);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23653;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23653);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23657;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23657);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_23661;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_23661);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23665;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23665);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23669;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23669);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23673;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23673);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_cdrzd241314zd2_6867;
																																											BgL_cdrzd241314zd2_6867
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if ((BgL_carzd238249zd2_6590 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5553z00_6869;
																																													obj_t
																																														BgL_arg5554z00_6870;
																																													BgL_arg5553z00_6869
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6867));
																																													BgL_arg5554z00_6870
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6867));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_23684;
																																														{
																																															obj_t
																																																BgL_exprz00_23686;
																																															obj_t
																																																BgL_bindingsz00_23685;
																																															BgL_bindingsz00_23685
																																																=
																																																BgL_arg5553z00_6869;
																																															BgL_exprz00_23686
																																																=
																																																BgL_arg5554z00_6870;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_23686;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_23685;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_21492
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_23684);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238249zd2_6590)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5556z00_6872;
																																															obj_t
																																																BgL_arg5557z00_6873;
																																															BgL_arg5556z00_6872
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6867));
																																															BgL_arg5557z00_6873
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6867));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_23695;
																																																{
																																																	obj_t
																																																		BgL_exprz00_23697;
																																																	obj_t
																																																		BgL_bindingsz00_23696;
																																																	BgL_bindingsz00_23696
																																																		=
																																																		BgL_arg5556z00_6872;
																																																	BgL_exprz00_23697
																																																		=
																																																		BgL_arg5557z00_6873;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_23697;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_23696;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_23695);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd238249zd2_6590 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5559z00_6875;
																																																	obj_t
																																																		BgL_arg5560z00_6876;
																																																	BgL_arg5559z00_6875
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6867));
																																																	BgL_arg5560z00_6876
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6867));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_23706;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_23708;
																																																			obj_t
																																																				BgL_bindingsz00_23707;
																																																			BgL_bindingsz00_23707
																																																				=
																																																				BgL_arg5559z00_6875;
																																																			BgL_exprz00_23708
																																																				=
																																																				BgL_arg5560z00_6876;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_23708;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_23707;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_23706);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_23715;
																																																			goto
																																																				BgL_tagzd2383zd2_1782;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_23715);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd241351zd2_6879;
																																																			BgL_carzd241351zd2_6879
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd241351zd2_6879 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_23722;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23722);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241351zd2_6879)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23727;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23727);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_23734;
																																																									goto
																																																										BgL_tagzd2389zd2_1802;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23734);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23741;
																																																											goto
																																																												BgL_tagzd2390zd2_1803;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23741);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241431zd2_6886;
																																																											BgL_cdrzd241431zd2_6886
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg5571z00_6889;
																																																													obj_t
																																																														BgL_arg5572z00_6890;
																																																													BgL_arg5571z00_6889
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6886));
																																																													BgL_arg5572z00_6890
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6886));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_23754;
																																																														{
																																																															obj_t
																																																																BgL_restz00_23756;
																																																															obj_t
																																																																BgL_effectz00_23755;
																																																															BgL_effectz00_23755
																																																																=
																																																																BgL_arg5571z00_6889;
																																																															BgL_restz00_23756
																																																																=
																																																																BgL_arg5572z00_6890;
																																																															BgL_restz00_1805
																																																																=
																																																																BgL_restz00_23756;
																																																															BgL_effectz00_1804
																																																																=
																																																																BgL_effectz00_23755;
																																																															goto
																																																																BgL_tagzd2391zd2_1806;
																																																														}
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_23754);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_23763;
																																																															goto
																																																																BgL_tagzd2392zd2_1807;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_23763);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23770;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1808;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23770);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg5579z00_6898;
																																																																			obj_t
																																																																				BgL_arg5580z00_6899;
																																																																			BgL_arg5579z00_6898
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6886));
																																																																			BgL_arg5580z00_6899
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6886));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_23781;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_23783;
																																																																					obj_t
																																																																						BgL_effectz00_23782;
																																																																					BgL_effectz00_23782
																																																																						=
																																																																						BgL_arg5579z00_6898;
																																																																					BgL_restz00_23783
																																																																						=
																																																																						BgL_arg5580z00_6899;
																																																																					BgL_restz00_1810
																																																																						=
																																																																						BgL_restz00_23783;
																																																																					BgL_effectz00_1809
																																																																						=
																																																																						BgL_effectz00_23782;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1811;
																																																																				}
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_23781);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23790;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1812;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23790);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23797;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1813;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23797);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_23804;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1814;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23804);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_23811;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1815;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23811);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd241508zd2_6908;
																																																																											BgL_cdrzd241508zd2_6908
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5591z00_6911;
																																																																													obj_t
																																																																														BgL_arg5592z00_6912;
																																																																													BgL_arg5591z00_6911
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6908));
																																																																													BgL_arg5592z00_6912
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6908));
																																																																													{	/* Ast/sexp.scm 555 */
																																																																														obj_t
																																																																															BgL_arg7023z00_11992;
																																																																														BgL_arg7023z00_11992
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5591z00_6911,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5592z00_6912, BgL_stackz00_22, BgL_arg7023z00_11992, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23830;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23830);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd241533zd2_6929;
																															BgL_carzd241533zd2_6929
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd241533zd2_6929
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_23837;
																																	goto
																																		BgL_tagzd2377zd2_1770;
																																	BgL_auxz00_21492
																																		=
																																		((obj_t)
																																		BgL_auxz00_23837);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd241533zd2_6929
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23841;
																																			goto
																																				BgL_tagzd2377zd2_1770;
																																			BgL_auxz00_21492
																																				=
																																				((obj_t)
																																				BgL_auxz00_23841);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd241555zd2_6932;
																																			BgL_cdrzd241555zd2_6932
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd241558zd2_6935;
																																					obj_t
																																						BgL_cdrzd241559zd2_6936;
																																					BgL_carzd241558zd2_6935
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd241555zd2_6932));
																																					BgL_cdrzd241559zd2_6936
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd241555zd2_6932));
																																					if (PAIRP(BgL_carzd241558zd2_6935))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd241558zd2_6935) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd241559zd2_6936))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5618z00_6942;
																																											obj_t
																																												BgL_arg5619z00_6943;
																																											BgL_arg5618z00_6942
																																												=
																																												CDR
																																												(BgL_carzd241558zd2_6935);
																																											BgL_arg5619z00_6943
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241559zd2_6936));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_23867;
																																												{
																																													obj_t
																																														BgL_valz00_23869;
																																													obj_t
																																														BgL_lz00_23868;
																																													BgL_lz00_23868
																																														=
																																														BgL_arg5618z00_6942;
																																													BgL_valz00_23869
																																														=
																																														BgL_arg5619z00_6943;
																																													BgL_valz00_1772
																																														=
																																														BgL_valz00_23869;
																																													BgL_lz00_1771
																																														=
																																														BgL_lz00_23868;
																																													goto
																																														BgL_tagzd2378zd2_1773;
																																												}
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_23867);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_23871;
																																											goto
																																												BgL_tagzd2379zd2_1774;
																																											BgL_auxz00_21492
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_23871);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23873;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23873);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23875;
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23875);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23882;
																																							goto
																																								BgL_tagzd2380zd2_1775;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23882);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd241656zd2_6948;
																																							BgL_carzd241656zd2_6948
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd241656zd2_6948))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd241659zd2_6950;
																																									obj_t
																																										BgL_cdrzd241660zd2_6951;
																																									BgL_carzd241659zd2_6950
																																										=
																																										CAR
																																										(BgL_carzd241656zd2_6948);
																																									BgL_cdrzd241660zd2_6951
																																										=
																																										CDR
																																										(BgL_carzd241656zd2_6948);
																																									{

																																										if ((BgL_carzd241659zd2_6950 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd241661zd2_6952:
																																												if (PAIRP(BgL_cdrzd241660zd2_6951))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd241664zd2_7077;
																																														BgL_cdrzd241664zd2_7077
																																															=
																																															CDR
																																															(BgL_cdrzd241660zd2_6951);
																																														if (PAIRP(BgL_cdrzd241664zd2_7077))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd241664zd2_7077)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5709z00_7081;
																																																		obj_t
																																																			BgL_arg5710z00_7082;
																																																		BgL_arg5709z00_7081
																																																			=
																																																			CAR
																																																			(BgL_cdrzd241664zd2_7077);
																																																		BgL_arg5710z00_7082
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_23904;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_23906;
																																																				obj_t
																																																					BgL_bodyz00_23905;
																																																				BgL_bodyz00_23905
																																																					=
																																																					BgL_arg5709z00_7081;
																																																				BgL_argsz00_23906
																																																					=
																																																					BgL_arg5710z00_7082;
																																																				BgL_argsz00_1777
																																																					=
																																																					BgL_argsz00_23906;
																																																				BgL_bodyz00_1776
																																																					=
																																																					BgL_bodyz00_23905;
																																																				goto
																																																					BgL_tagzd2381zd2_1778;
																																																			}
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_23904);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd241688zd2_7083;
																																																		BgL_cdrzd241688zd2_7083
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9133z00_23910;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5779z00_7194;
																																																				BgL_arg5779z00_7194
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9133z00_23910
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5779z00_7194));
																																																			}
																																																			if (BgL_test9133z00_23910)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5713z00_7086;
																																																					obj_t
																																																						BgL_arg5714z00_7087;
																																																					BgL_arg5713z00_7086
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7083));
																																																					BgL_arg5714z00_7087
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7083));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23919;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23921;
																																																							obj_t
																																																								BgL_bindingsz00_23920;
																																																							BgL_bindingsz00_23920
																																																								=
																																																								BgL_arg5713z00_7086;
																																																							BgL_exprz00_23921
																																																								=
																																																								BgL_arg5714z00_7087;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_23921;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_23920;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23919);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9134z00_23923;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5778z00_7193;
																																																						BgL_arg5778z00_7193
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9134z00_23923
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5778z00_7193));
																																																					}
																																																					if (BgL_test9134z00_23923)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23928;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23928);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd241755zd2_7090;
																																																							BgL_carzd241755zd2_7090
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd241760zd2_7091;
																																																								BgL_cdrzd241760zd2_7091
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd241755zd2_7090));
																																																								if ((CAR(((obj_t) BgL_carzd241755zd2_7090)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5719z00_7094;
																																																										obj_t
																																																											BgL_arg5720z00_7095;
																																																										obj_t
																																																											BgL_arg5721z00_7096;
																																																										BgL_arg5719z00_7094
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7091));
																																																										BgL_arg5720z00_7095
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7091));
																																																										BgL_arg5721z00_7096
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23945;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_23948;
																																																												obj_t
																																																													BgL_bodyz00_23947;
																																																												obj_t
																																																													BgL_varsz00_23946;
																																																												BgL_varsz00_23946
																																																													=
																																																													BgL_arg5719z00_7094;
																																																												BgL_bodyz00_23947
																																																													=
																																																													BgL_arg5720z00_7095;
																																																												BgL_argsz00_23948
																																																													=
																																																													BgL_arg5721z00_7096;
																																																												BgL_argsz00_1790
																																																													=
																																																													BgL_argsz00_23948;
																																																												BgL_bodyz00_1789
																																																													=
																																																													BgL_bodyz00_23947;
																																																												BgL_varsz00_1788
																																																													=
																																																													BgL_varsz00_23946;
																																																												goto
																																																													BgL_tagzd2386zd2_1791;
																																																											}
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23945);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd241783zd2_7098;
																																																										BgL_cdrzd241783zd2_7098
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241789zd2_7099;
																																																											BgL_cdrzd241789zd2_7099
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd241755zd2_7090));
																																																											if ((CAR(((obj_t) BgL_carzd241755zd2_7090)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd241795zd2_7102;
																																																													BgL_cdrzd241795zd2_7102
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241789zd2_7099));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd241800zd2_7103;
																																																														obj_t
																																																															BgL_cdrzd241801zd2_7104;
																																																														BgL_carzd241800zd2_7103
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7102));
																																																														BgL_cdrzd241801zd2_7104
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7102));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241800zd2_7103))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd241801zd2_7104))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd241808zd2_7107;
																																																																		BgL_carzd241808zd2_7107
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd241801zd2_7104);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241808zd2_7107))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd241801zd2_7104)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9141z00_23975;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1440z00_7140;
																																																																							BgL_l1440z00_7140
																																																																								=
																																																																								BgL_cdrzd241783zd2_7098;
																																																																						BgL_zc3z04anonymousza35744ze3z87_7141:
																																																																							if (NULLP(BgL_l1440z00_7140))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9141z00_23975
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9143z00_23978;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9144z00_23979;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_23980;
																																																																											BgL_tmpz00_23980
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1440z00_7140));
																																																																											BgL_test9144z00_23979
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_23980);
																																																																										}
																																																																										if (BgL_test9144z00_23979)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9143z00_23978
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9143z00_23978
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9143z00_23978)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1440z00_23984;
																																																																											BgL_l1440z00_23984
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1440z00_7140));
																																																																											BgL_l1440z00_7140
																																																																												=
																																																																												BgL_l1440z00_23984;
																																																																											goto
																																																																												BgL_zc3z04anonymousza35744ze3z87_7141;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9141z00_23975
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9141z00_23975)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg5734z00_7123;
																																																																								BgL_arg5734z00_7123
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd241789zd2_7099));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23989;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_23993;
																																																																										obj_t
																																																																											BgL_proc2z00_23992;
																																																																										obj_t
																																																																											BgL_proc1z00_23991;
																																																																										obj_t
																																																																											BgL_testz00_23990;
																																																																										BgL_testz00_23990
																																																																											=
																																																																											BgL_arg5734z00_7123;
																																																																										BgL_proc1z00_23991
																																																																											=
																																																																											BgL_carzd241800zd2_7103;
																																																																										BgL_proc2z00_23992
																																																																											=
																																																																											BgL_carzd241808zd2_7107;
																																																																										BgL_argsz00_23993
																																																																											=
																																																																											BgL_cdrzd241783zd2_7098;
																																																																										BgL_argsz00_1795
																																																																											=
																																																																											BgL_argsz00_23993;
																																																																										BgL_proc2z00_1794
																																																																											=
																																																																											BgL_proc2z00_23992;
																																																																										BgL_proc1z00_1793
																																																																											=
																																																																											BgL_proc1z00_23991;
																																																																										BgL_testz00_1792
																																																																											=
																																																																											BgL_testz00_23990;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1796;
																																																																									}
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23989);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd241832zd2_7124;
																																																																								BgL_cdrzd241832zd2_7124
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd241839zd2_7125;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12035;
																																																																										BgL_pairz00_12035
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd241839zd2_7125
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12035);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd241846zd2_7126;
																																																																										BgL_cdrzd241846zd2_7126
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd241839zd2_7125));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd241852zd2_7127;
																																																																											BgL_carzd241852zd2_7127
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd241846zd2_7126));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241852zd2_7127))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd241859zd2_7129;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12039;
																																																																														BgL_pairz00_12039
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd241846zd2_7126));
																																																																														BgL_carzd241859zd2_7129
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12039);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241859zd2_7129))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd241832zd2_7124))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5738z00_7132;
																																																																																	BgL_arg5738z00_7132
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd241839zd2_7125));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24015;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_24019;
																																																																																			obj_t
																																																																																				BgL_proc2z00_24018;
																																																																																			obj_t
																																																																																				BgL_proc1z00_24017;
																																																																																			obj_t
																																																																																				BgL_testz00_24016;
																																																																																			BgL_testz00_24016
																																																																																				=
																																																																																				BgL_arg5738z00_7132;
																																																																																			BgL_proc1z00_24017
																																																																																				=
																																																																																				BgL_carzd241852zd2_7127;
																																																																																			BgL_proc2z00_24018
																																																																																				=
																																																																																				BgL_carzd241859zd2_7129;
																																																																																			BgL_argsz00_24019
																																																																																				=
																																																																																				BgL_cdrzd241832zd2_7124;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_24019;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_24018;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_24017;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_24016;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24015);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24023;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24023);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24027;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24027);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24031;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24031);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_24035;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_24035);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd242135zd2_7151;
																																																																				BgL_cdrzd242135zd2_7151
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd242141zd2_7152;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12043;
																																																																						BgL_pairz00_12043
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd242141zd2_7152
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12043);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd242147zd2_7153;
																																																																						BgL_cdrzd242147zd2_7153
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd242141zd2_7152));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242152zd2_7154;
																																																																							obj_t
																																																																								BgL_cdrzd242153zd2_7155;
																																																																							BgL_carzd242152zd2_7154
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7153));
																																																																							BgL_cdrzd242153zd2_7155
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7153));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242152zd2_7154))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd242158zd2_7157;
																																																																									BgL_carzd242158zd2_7157
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd242153zd2_7155));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242158zd2_7157))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd242153zd2_7155))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242135zd2_7151))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5753z00_7162;
																																																																															BgL_arg5753z00_7162
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd242141zd2_7152));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24062;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24066;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24065;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24064;
																																																																																	obj_t
																																																																																		BgL_testz00_24063;
																																																																																	BgL_testz00_24063
																																																																																		=
																																																																																		BgL_arg5753z00_7162;
																																																																																	BgL_proc1z00_24064
																																																																																		=
																																																																																		BgL_carzd242152zd2_7154;
																																																																																	BgL_proc2z00_24065
																																																																																		=
																																																																																		BgL_carzd242158zd2_7157;
																																																																																	BgL_argsz00_24066
																																																																																		=
																																																																																		BgL_cdrzd242135zd2_7151;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_24066;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_24065;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_24064;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_24063;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24062);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24070;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24070);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24074;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24074);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24078;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24078);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24082;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24082);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24086;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24086);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd242491zd2_7170;
																																																																BgL_cdrzd242491zd2_7170
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd242498zd2_7171;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12052;
																																																																		BgL_pairz00_12052
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd242498zd2_7171
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12052);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd242505zd2_7172;
																																																																		BgL_cdrzd242505zd2_7172
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd242498zd2_7171));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd242511zd2_7173;
																																																																			obj_t
																																																																				BgL_cdrzd242512zd2_7174;
																																																																			BgL_carzd242511zd2_7173
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7172));
																																																																			BgL_cdrzd242512zd2_7174
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7172));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242511zd2_7173))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd242512zd2_7174))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242519zd2_7177;
																																																																							BgL_carzd242519zd2_7177
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd242512zd2_7174);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242519zd2_7177))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd242512zd2_7174)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242491zd2_7170))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5767z00_7182;
																																																																													BgL_arg5767z00_7182
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd242498zd2_7171));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24113;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24117;
																																																																															obj_t
																																																																																BgL_proc2z00_24116;
																																																																															obj_t
																																																																																BgL_proc1z00_24115;
																																																																															obj_t
																																																																																BgL_testz00_24114;
																																																																															BgL_testz00_24114
																																																																																=
																																																																																BgL_arg5767z00_7182;
																																																																															BgL_proc1z00_24115
																																																																																=
																																																																																BgL_carzd242511zd2_7173;
																																																																															BgL_proc2z00_24116
																																																																																=
																																																																																BgL_carzd242519zd2_7177;
																																																																															BgL_argsz00_24117
																																																																																=
																																																																																BgL_cdrzd242491zd2_7170;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_24117;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_24116;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_24115;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_24114;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24113);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24121;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24121);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24125;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24125);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24129;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24129);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24133;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24133);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24137;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24137);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24141;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24141);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd242912zd2_7196;
																																																BgL_cdrzd242912zd2_7196
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9172z00_24145;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5795z00_7213;
																																																		BgL_arg5795z00_7213
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9172z00_24145
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5795z00_7213));
																																																	}
																																																	if (BgL_test9172z00_24145)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5783z00_7199;
																																																			obj_t
																																																				BgL_arg5784z00_7200;
																																																			BgL_arg5783z00_7199
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7196));
																																																			BgL_arg5784z00_7200
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7196));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24154;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24156;
																																																					obj_t
																																																						BgL_bindingsz00_24155;
																																																					BgL_bindingsz00_24155
																																																						=
																																																						BgL_arg5783z00_7199;
																																																					BgL_exprz00_24156
																																																						=
																																																						BgL_arg5784z00_7200;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_24156;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_24155;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24154);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9173z00_24158;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5794z00_7212;
																																																				BgL_arg5794z00_7212
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9173z00_24158
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5794z00_7212));
																																																			}
																																																			if (BgL_test9173z00_24158)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24163;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24163);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd242978zd2_7203;
																																																					BgL_carzd242978zd2_7203
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd242983zd2_7204;
																																																						BgL_cdrzd242983zd2_7204
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd242978zd2_7203));
																																																						if ((CAR(((obj_t) BgL_carzd242978zd2_7203)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5789z00_7207;
																																																								obj_t
																																																									BgL_arg5790z00_7208;
																																																								obj_t
																																																									BgL_arg5791z00_7209;
																																																								BgL_arg5789z00_7207
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7204));
																																																								BgL_arg5790z00_7208
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7204));
																																																								BgL_arg5791z00_7209
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24180;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24183;
																																																										obj_t
																																																											BgL_bodyz00_24182;
																																																										obj_t
																																																											BgL_varsz00_24181;
																																																										BgL_varsz00_24181
																																																											=
																																																											BgL_arg5789z00_7207;
																																																										BgL_bodyz00_24182
																																																											=
																																																											BgL_arg5790z00_7208;
																																																										BgL_argsz00_24183
																																																											=
																																																											BgL_arg5791z00_7209;
																																																										BgL_argsz00_1790
																																																											=
																																																											BgL_argsz00_24183;
																																																										BgL_bodyz00_1789
																																																											=
																																																											BgL_bodyz00_24182;
																																																										BgL_varsz00_1788
																																																											=
																																																											BgL_varsz00_24181;
																																																										goto
																																																											BgL_tagzd2386zd2_1791;
																																																									}
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24180);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24187;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24187);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd243094zd2_7214;
																																														BgL_cdrzd243094zd2_7214
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9176z00_24191;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5804z00_7223;
																																																BgL_arg5804z00_7223
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9176z00_24191
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg5804z00_7223));
																																															}
																																															if (BgL_test9176z00_24191)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5798z00_7217;
																																																	obj_t
																																																		BgL_arg5799z00_7218;
																																																	BgL_arg5798z00_7217
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7214));
																																																	BgL_arg5799z00_7218
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7214));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24200;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24202;
																																																			obj_t
																																																				BgL_bindingsz00_24201;
																																																			BgL_bindingsz00_24201
																																																				=
																																																				BgL_arg5798z00_7217;
																																																			BgL_exprz00_24202
																																																				=
																																																				BgL_arg5799z00_7218;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_24202;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_24201;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24200);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9177z00_24204;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5803z00_7222;
																																																		BgL_arg5803z00_7222
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9177z00_24204
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg5803z00_7222));
																																																	}
																																																	if (BgL_test9177z00_24204)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24209;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24209);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1825;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_24213;
																																																					goto
																																																						BgL_tagzd2404zd2_1826;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24213);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241659zd2_6950)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd241661zd2_6952;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd241659zd2_6950 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd241661zd2_6952;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd241659zd2_6950 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd241661zd2_6952;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241659zd2_6950)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd241661zd2_6952;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd243266zd2_6958;
																																																				BgL_cdrzd243266zd2_6958
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9183z00_24229;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5704z00_7075;
																																																						BgL_arg5704z00_7075
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9183z00_24229
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5704z00_7075));
																																																					}
																																																					if (BgL_test9183z00_24229)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5632z00_6961;
																																																							obj_t
																																																								BgL_arg5633z00_6962;
																																																							BgL_arg5632z00_6961
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6958));
																																																							BgL_arg5633z00_6962
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6958));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_24238;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_24240;
																																																									obj_t
																																																										BgL_bindingsz00_24239;
																																																									BgL_bindingsz00_24239
																																																										=
																																																										BgL_arg5632z00_6961;
																																																									BgL_exprz00_24240
																																																										=
																																																										BgL_arg5633z00_6962;
																																																									BgL_exprz00_1780
																																																										=
																																																										BgL_exprz00_24240;
																																																									BgL_bindingsz00_1779
																																																										=
																																																										BgL_bindingsz00_24239;
																																																									goto
																																																										BgL_tagzd2382zd2_1781;
																																																								}
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_24238);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9184z00_24242;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5703z00_7074;
																																																								BgL_arg5703z00_7074
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9184z00_24242
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5703z00_7074));
																																																							}
																																																							if (BgL_test9184z00_24242)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_24247;
																																																									goto
																																																										BgL_tagzd2384zd2_1783;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24247);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd243332zd2_6965;
																																																									BgL_carzd243332zd2_6965
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd243337zd2_6966;
																																																										BgL_cdrzd243337zd2_6966
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd243332zd2_6965));
																																																										if ((CAR(((obj_t) BgL_carzd243332zd2_6965)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd243337zd2_6966))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5639z00_6970;
																																																														obj_t
																																																															BgL_arg5640z00_6971;
																																																														obj_t
																																																															BgL_arg5641z00_6972;
																																																														BgL_arg5639z00_6970
																																																															=
																																																															CAR
																																																															(BgL_cdrzd243337zd2_6966);
																																																														BgL_arg5640z00_6971
																																																															=
																																																															CDR
																																																															(BgL_cdrzd243337zd2_6966);
																																																														BgL_arg5641z00_6972
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24264;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_24267;
																																																																obj_t
																																																																	BgL_bodyz00_24266;
																																																																obj_t
																																																																	BgL_varsz00_24265;
																																																																BgL_varsz00_24265
																																																																	=
																																																																	BgL_arg5639z00_6970;
																																																																BgL_bodyz00_24266
																																																																	=
																																																																	BgL_arg5640z00_6971;
																																																																BgL_argsz00_24267
																																																																	=
																																																																	BgL_arg5641z00_6972;
																																																																BgL_argsz00_1790
																																																																	=
																																																																	BgL_argsz00_24267;
																																																																BgL_bodyz00_1789
																																																																	=
																																																																	BgL_bodyz00_24266;
																																																																BgL_varsz00_1788
																																																																	=
																																																																	BgL_varsz00_24265;
																																																																goto
																																																																	BgL_tagzd2386zd2_1791;
																																																															}
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24264);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_24271;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_24271);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd243444zd2_6975;
																																																												BgL_cdrzd243444zd2_6975
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd243449zd2_6976;
																																																													BgL_cdrzd243449zd2_6976
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd243332zd2_6965));
																																																													if ((CAR(((obj_t) BgL_carzd243332zd2_6965)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd243449zd2_6976))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd243454zd2_6980;
																																																																	BgL_cdrzd243454zd2_6980
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd243449zd2_6976);
																																																																	if (PAIRP(BgL_cdrzd243454zd2_6980))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd243458zd2_6982;
																																																																			obj_t
																																																																				BgL_cdrzd243459zd2_6983;
																																																																			BgL_carzd243458zd2_6982
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd243454zd2_6980);
																																																																			BgL_cdrzd243459zd2_6983
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd243454zd2_6980);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243458zd2_6982))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd243459zd2_6983))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd243464zd2_6986;
																																																																							BgL_carzd243464zd2_6986
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd243459zd2_6983);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243464zd2_6986))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd243459zd2_6983)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9195z00_24299;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1443z00_7019;
																																																																												BgL_l1443z00_7019
																																																																													=
																																																																													BgL_cdrzd243444zd2_6975;
																																																																											BgL_zc3z04anonymousza35667ze3z87_7020:
																																																																												if (NULLP(BgL_l1443z00_7019))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9195z00_24299
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test9197z00_24302;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9198z00_24303;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_24304;
																																																																																BgL_tmpz00_24304
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1443z00_7019));
																																																																																BgL_test9198z00_24303
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_24304);
																																																																															}
																																																																															if (BgL_test9198z00_24303)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9197z00_24302
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9197z00_24302
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test9197z00_24302)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1443z00_24308;
																																																																																BgL_l1443z00_24308
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1443z00_7019));
																																																																																BgL_l1443z00_7019
																																																																																	=
																																																																																	BgL_l1443z00_24308;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza35667ze3z87_7020;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9195z00_24299
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test9195z00_24299)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5657z00_7002;
																																																																													BgL_arg5657z00_7002
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd243449zd2_6976);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24312;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24316;
																																																																															obj_t
																																																																																BgL_proc2z00_24315;
																																																																															obj_t
																																																																																BgL_proc1z00_24314;
																																																																															obj_t
																																																																																BgL_testz00_24313;
																																																																															BgL_testz00_24313
																																																																																=
																																																																																BgL_arg5657z00_7002;
																																																																															BgL_proc1z00_24314
																																																																																=
																																																																																BgL_carzd243458zd2_6982;
																																																																															BgL_proc2z00_24315
																																																																																=
																																																																																BgL_carzd243464zd2_6986;
																																																																															BgL_argsz00_24316
																																																																																=
																																																																																BgL_cdrzd243444zd2_6975;
																																																																															BgL_argsz00_1795
																																																																																=
																																																																																BgL_argsz00_24316;
																																																																															BgL_proc2z00_1794
																																																																																=
																																																																																BgL_proc2z00_24315;
																																																																															BgL_proc1z00_1793
																																																																																=
																																																																																BgL_proc1z00_24314;
																																																																															BgL_testz00_1792
																																																																																=
																																																																																BgL_testz00_24313;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1796;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24312);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd243489zd2_7003;
																																																																													BgL_cdrzd243489zd2_7003
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd243497zd2_7004;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_12100;
																																																																															BgL_pairz00_12100
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd243497zd2_7004
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12100);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd243505zd2_7005;
																																																																															BgL_cdrzd243505zd2_7005
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd243497zd2_7004));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd243512zd2_7006;
																																																																																BgL_carzd243512zd2_7006
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd243505zd2_7005));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243512zd2_7006))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd243521zd2_7008;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12104;
																																																																																			BgL_pairz00_12104
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd243505zd2_7005));
																																																																																			BgL_carzd243521zd2_7008
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_12104);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243521zd2_7008))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243489zd2_7003))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5661z00_7011;
																																																																																						BgL_arg5661z00_7011
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd243497zd2_7004));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24338;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24342;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24341;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24340;
																																																																																								obj_t
																																																																																									BgL_testz00_24339;
																																																																																								BgL_testz00_24339
																																																																																									=
																																																																																									BgL_arg5661z00_7011;
																																																																																								BgL_proc1z00_24340
																																																																																									=
																																																																																									BgL_carzd243512zd2_7006;
																																																																																								BgL_proc2z00_24341
																																																																																									=
																																																																																									BgL_carzd243521zd2_7008;
																																																																																								BgL_argsz00_24342
																																																																																									=
																																																																																									BgL_cdrzd243489zd2_7003;
																																																																																								BgL_argsz00_1800
																																																																																									=
																																																																																									BgL_argsz00_24342;
																																																																																								BgL_proc2z00_1799
																																																																																									=
																																																																																									BgL_proc2z00_24341;
																																																																																								BgL_proc1z00_1798
																																																																																									=
																																																																																									BgL_proc1z00_24340;
																																																																																								BgL_testz00_1797
																																																																																									=
																																																																																									BgL_testz00_24339;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1801;
																																																																																							}
																																																																																							BgL_auxz00_21492
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24338);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1825;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24346;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1826;
																																																																																								BgL_auxz00_21492
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24346);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24350;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24350);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24354;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24354);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24358;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24358);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd243799zd2_7030;
																																																																									BgL_cdrzd243799zd2_7030
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd243806zd2_7031;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12108;
																																																																											BgL_pairz00_12108
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd243806zd2_7031
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12108);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd243813zd2_7032;
																																																																											BgL_cdrzd243813zd2_7032
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd243806zd2_7031));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd243819zd2_7033;
																																																																												obj_t
																																																																													BgL_cdrzd243820zd2_7034;
																																																																												BgL_carzd243819zd2_7033
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_7032));
																																																																												BgL_cdrzd243820zd2_7034
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_7032));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243819zd2_7033))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd243827zd2_7036;
																																																																														BgL_carzd243827zd2_7036
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd243820zd2_7034));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243827zd2_7036))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd243820zd2_7034))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243799zd2_7030))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5676z00_7041;
																																																																																				BgL_arg5676z00_7041
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd243806zd2_7031));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24385;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24389;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24388;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24387;
																																																																																						obj_t
																																																																																							BgL_testz00_24386;
																																																																																						BgL_testz00_24386
																																																																																							=
																																																																																							BgL_arg5676z00_7041;
																																																																																						BgL_proc1z00_24387
																																																																																							=
																																																																																							BgL_carzd243819zd2_7033;
																																																																																						BgL_proc2z00_24388
																																																																																							=
																																																																																							BgL_carzd243827zd2_7036;
																																																																																						BgL_argsz00_24389
																																																																																							=
																																																																																							BgL_cdrzd243799zd2_7030;
																																																																																						BgL_argsz00_1800
																																																																																							=
																																																																																							BgL_argsz00_24389;
																																																																																						BgL_proc2z00_1799
																																																																																							=
																																																																																							BgL_proc2z00_24388;
																																																																																						BgL_proc1z00_1798
																																																																																							=
																																																																																							BgL_proc1z00_24387;
																																																																																						BgL_testz00_1797
																																																																																							=
																																																																																							BgL_testz00_24386;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1801;
																																																																																					}
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24385);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24393;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24393);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24397;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24397);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24401;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24401);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24405;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24405);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24409;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24409);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd244160zd2_7049;
																																																																					BgL_cdrzd244160zd2_7049
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd244166zd2_7050;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12117;
																																																																							BgL_pairz00_12117
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd244166zd2_7050
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12117);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd244172zd2_7051;
																																																																							BgL_cdrzd244172zd2_7051
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd244166zd2_7050));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd244177zd2_7052;
																																																																								obj_t
																																																																									BgL_cdrzd244178zd2_7053;
																																																																								BgL_carzd244177zd2_7052
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7051));
																																																																								BgL_cdrzd244178zd2_7053
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7051));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244177zd2_7052))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd244178zd2_7053))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd244183zd2_7056;
																																																																												BgL_carzd244183zd2_7056
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd244178zd2_7053);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244183zd2_7056))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd244178zd2_7053)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd244160zd2_7049))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5690z00_7061;
																																																																																		BgL_arg5690z00_7061
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd244166zd2_7050));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24436;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_24440;
																																																																																				obj_t
																																																																																					BgL_proc2z00_24439;
																																																																																				obj_t
																																																																																					BgL_proc1z00_24438;
																																																																																				obj_t
																																																																																					BgL_testz00_24437;
																																																																																				BgL_testz00_24437
																																																																																					=
																																																																																					BgL_arg5690z00_7061;
																																																																																				BgL_proc1z00_24438
																																																																																					=
																																																																																					BgL_carzd244177zd2_7052;
																																																																																				BgL_proc2z00_24439
																																																																																					=
																																																																																					BgL_carzd244183zd2_7056;
																																																																																				BgL_argsz00_24440
																																																																																					=
																																																																																					BgL_cdrzd244160zd2_7049;
																																																																																				BgL_argsz00_1800
																																																																																					=
																																																																																					BgL_argsz00_24440;
																																																																																				BgL_proc2z00_1799
																																																																																					=
																																																																																					BgL_proc2z00_24439;
																																																																																				BgL_proc1z00_1798
																																																																																					=
																																																																																					BgL_proc1z00_24438;
																																																																																				BgL_testz00_1797
																																																																																					=
																																																																																					BgL_testz00_24437;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1801;
																																																																																			}
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24436);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24444;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24444);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24448;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24448);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24452;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24452);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24456;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24456);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_24460;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_24460);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24464;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24464);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24468;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24468);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24472;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24472);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd241656zd2_6948 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5806z00_7227;
																																											obj_t
																																												BgL_arg5807z00_7228;
																																											BgL_arg5806z00_7227
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6932));
																																											BgL_arg5807z00_7228
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6932));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24481;
																																												{
																																													obj_t
																																														BgL_exprz00_24483;
																																													obj_t
																																														BgL_bindingsz00_24482;
																																													BgL_bindingsz00_24482
																																														=
																																														BgL_arg5806z00_7227;
																																													BgL_exprz00_24483
																																														=
																																														BgL_arg5807z00_7228;
																																													BgL_exprz00_1780
																																														=
																																														BgL_exprz00_24483;
																																													BgL_bindingsz00_1779
																																														=
																																														BgL_bindingsz00_24482;
																																													goto
																																														BgL_tagzd2382zd2_1781;
																																												}
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24481);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241656zd2_6948)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5809z00_7230;
																																													obj_t
																																														BgL_arg5810z00_7231;
																																													BgL_arg5809z00_7230
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6932));
																																													BgL_arg5810z00_7231
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6932));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24492;
																																														{
																																															obj_t
																																																BgL_exprz00_24494;
																																															obj_t
																																																BgL_bindingsz00_24493;
																																															BgL_bindingsz00_24493
																																																=
																																																BgL_arg5809z00_7230;
																																															BgL_exprz00_24494
																																																=
																																																BgL_arg5810z00_7231;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_24494;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_24493;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_21492
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24492);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd241656zd2_6948 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5812z00_7233;
																																															obj_t
																																																BgL_arg5813z00_7234;
																																															BgL_arg5812z00_7233
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6932));
																																															BgL_arg5813z00_7234
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6932));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_24503;
																																																{
																																																	obj_t
																																																		BgL_exprz00_24505;
																																																	obj_t
																																																		BgL_bindingsz00_24504;
																																																	BgL_bindingsz00_24504
																																																		=
																																																		BgL_arg5812z00_7233;
																																																	BgL_exprz00_24505
																																																		=
																																																		BgL_arg5813z00_7234;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_24505;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_24504;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_24503);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_24512;
																																																	goto
																																																		BgL_tagzd2383zd2_1782;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_24512);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd244758zd2_7237;
																																																	BgL_carzd244758zd2_7237
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd244758zd2_7237 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24519;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24519);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd244758zd2_7237)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24524;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24524);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_24531;
																																																							goto
																																																								BgL_tagzd2389zd2_1802;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24531);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24538;
																																																									goto
																																																										BgL_tagzd2390zd2_1803;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24538);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd244838zd2_7244;
																																																									BgL_cdrzd244838zd2_7244
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5824z00_7247;
																																																											obj_t
																																																												BgL_arg5825z00_7248;
																																																											BgL_arg5824z00_7247
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7244));
																																																											BgL_arg5825z00_7248
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7244));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_24551;
																																																												{
																																																													obj_t
																																																														BgL_restz00_24553;
																																																													obj_t
																																																														BgL_effectz00_24552;
																																																													BgL_effectz00_24552
																																																														=
																																																														BgL_arg5824z00_7247;
																																																													BgL_restz00_24553
																																																														=
																																																														BgL_arg5825z00_7248;
																																																													BgL_restz00_1805
																																																														=
																																																														BgL_restz00_24553;
																																																													BgL_effectz00_1804
																																																														=
																																																														BgL_effectz00_24552;
																																																													goto
																																																														BgL_tagzd2391zd2_1806;
																																																												}
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_24551);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_24560;
																																																													goto
																																																														BgL_tagzd2392zd2_1807;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_24560);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24567;
																																																															goto
																																																																BgL_tagzd2393zd2_1808;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24567);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5832z00_7256;
																																																																	obj_t
																																																																		BgL_arg5833z00_7257;
																																																																	BgL_arg5832z00_7256
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7244));
																																																																	BgL_arg5833z00_7257
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7244));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_24578;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_24580;
																																																																			obj_t
																																																																				BgL_effectz00_24579;
																																																																			BgL_effectz00_24579
																																																																				=
																																																																				BgL_arg5832z00_7256;
																																																																			BgL_restz00_24580
																																																																				=
																																																																				BgL_arg5833z00_7257;
																																																																			BgL_restz00_1810
																																																																				=
																																																																				BgL_restz00_24580;
																																																																			BgL_effectz00_1809
																																																																				=
																																																																				BgL_effectz00_24579;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1811;
																																																																		}
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_24578);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24587;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1812;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24587);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24594;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1813;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24594);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_24601;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1814;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24601);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_24608;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1815;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24608);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9245z00_24615;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_24616;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12153;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12152;
																																																																														BgL_pairz00_12152
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_12153
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12152);
																																																																													}
																																																																													BgL_tmpz00_24616
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12153);
																																																																												}
																																																																												BgL_test9245z00_24615
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_24616);
																																																																											}
																																																																											if (BgL_test9245z00_24615)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24622;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1816;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24622);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24626;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24626);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd244931zd2_7276;
																																																																											BgL_cdrzd244931zd2_7276
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5854z00_7279;
																																																																													obj_t
																																																																														BgL_arg5855z00_7280;
																																																																													BgL_arg5854z00_7279
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7276));
																																																																													BgL_arg5855z00_7280
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7276));
																																																																													{	/* Ast/sexp.scm 555 */
																																																																														obj_t
																																																																															BgL_arg7023z00_12158;
																																																																														BgL_arg7023z00_12158
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5854z00_7279,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5855z00_7280, BgL_stackz00_22, BgL_arg7023z00_12158, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24645;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24645);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd244956zd2_7297;
																													BgL_carzd244956zd2_7297
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd244956zd2_7297
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_24652;
																															goto
																																BgL_tagzd2377zd2_1770;
																															BgL_auxz00_21492 =
																																((obj_t)
																																BgL_auxz00_24652);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd244956zd2_7297
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_24656;
																																	goto
																																		BgL_tagzd2377zd2_1770;
																																	BgL_auxz00_21492
																																		=
																																		((obj_t)
																																		BgL_auxz00_24656);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_cdrzd244978zd2_7300;
																																	BgL_cdrzd244978zd2_7300
																																		=
																																		CDR(((obj_t)
																																			BgL_expz00_21));
																																	if ((CAR((
																																					(obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd244981zd2_7303;
																																			obj_t
																																				BgL_cdrzd244982zd2_7304;
																																			BgL_carzd244981zd2_7303
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7300));
																																			BgL_cdrzd244982zd2_7304
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7300));
																																			if (PAIRP
																																				(BgL_carzd244981zd2_7303))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(BgL_carzd244981zd2_7303)
																																							==
																																							CNST_TABLE_REF
																																							(((long) 14))))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(((obj_t) BgL_cdrzd244982zd2_7304))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg5881z00_7310;
																																									obj_t
																																										BgL_arg5882z00_7311;
																																									BgL_arg5881z00_7310
																																										=
																																										CDR
																																										(BgL_carzd244981zd2_7303);
																																									BgL_arg5882z00_7311
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244982zd2_7304));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_24682;
																																										{
																																											obj_t
																																												BgL_valz00_24684;
																																											obj_t
																																												BgL_lz00_24683;
																																											BgL_lz00_24683
																																												=
																																												BgL_arg5881z00_7310;
																																											BgL_valz00_24684
																																												=
																																												BgL_arg5882z00_7311;
																																											BgL_valz00_1772
																																												=
																																												BgL_valz00_24684;
																																											BgL_lz00_1771
																																												=
																																												BgL_lz00_24683;
																																											goto
																																												BgL_tagzd2378zd2_1773;
																																										}
																																										BgL_auxz00_21492
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_24682);
																																									}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_24686;
																																									goto
																																										BgL_tagzd2379zd2_1774;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_24686);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24688;
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24688);
																																						}
																																				}
																																			else
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_24690;
																																					goto
																																						BgL_tagzd2379zd2_1774;
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_24690);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_24697;
																																					goto
																																						BgL_tagzd2380zd2_1775;
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_24697);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd245079zd2_7316;
																																					BgL_carzd245079zd2_7316
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd245079zd2_7316))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd245082zd2_7318;
																																							obj_t
																																								BgL_cdrzd245083zd2_7319;
																																							BgL_carzd245082zd2_7318
																																								=
																																								CAR
																																								(BgL_carzd245079zd2_7316);
																																							BgL_cdrzd245083zd2_7319
																																								=
																																								CDR
																																								(BgL_carzd245079zd2_7316);
																																							{

																																								if ((BgL_carzd245082zd2_7318 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd245084zd2_7320:
																																										if (PAIRP(BgL_cdrzd245083zd2_7319))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd245087zd2_7445;
																																												BgL_cdrzd245087zd2_7445
																																													=
																																													CDR
																																													(BgL_cdrzd245083zd2_7319);
																																												if (PAIRP(BgL_cdrzd245087zd2_7445))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd245087zd2_7445)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5972z00_7449;
																																																obj_t
																																																	BgL_arg5973z00_7450;
																																																BgL_arg5972z00_7449
																																																	=
																																																	CAR
																																																	(BgL_cdrzd245087zd2_7445);
																																																BgL_arg5973z00_7450
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_24719;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_24721;
																																																		obj_t
																																																			BgL_bodyz00_24720;
																																																		BgL_bodyz00_24720
																																																			=
																																																			BgL_arg5972z00_7449;
																																																		BgL_argsz00_24721
																																																			=
																																																			BgL_arg5973z00_7450;
																																																		BgL_argsz00_1777
																																																			=
																																																			BgL_argsz00_24721;
																																																		BgL_bodyz00_1776
																																																			=
																																																			BgL_bodyz00_24720;
																																																		goto
																																																			BgL_tagzd2381zd2_1778;
																																																	}
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_24719);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd245111zd2_7451;
																																																BgL_cdrzd245111zd2_7451
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9261z00_24725;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6042z00_7562;
																																																		BgL_arg6042z00_7562
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9261z00_24725
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6042z00_7562));
																																																	}
																																																	if (BgL_test9261z00_24725)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5976z00_7454;
																																																			obj_t
																																																				BgL_arg5977z00_7455;
																																																			BgL_arg5976z00_7454
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7451));
																																																			BgL_arg5977z00_7455
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7451));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24734;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24736;
																																																					obj_t
																																																						BgL_bindingsz00_24735;
																																																					BgL_bindingsz00_24735
																																																						=
																																																						BgL_arg5976z00_7454;
																																																					BgL_exprz00_24736
																																																						=
																																																						BgL_arg5977z00_7455;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_24736;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_24735;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24734);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9262z00_24738;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6041z00_7561;
																																																				BgL_arg6041z00_7561
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9262z00_24738
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6041z00_7561));
																																																			}
																																																			if (BgL_test9262z00_24738)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24743;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24743);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd245178zd2_7458;
																																																					BgL_carzd245178zd2_7458
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd245183zd2_7459;
																																																						BgL_cdrzd245183zd2_7459
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd245178zd2_7458));
																																																						if ((CAR(((obj_t) BgL_carzd245178zd2_7458)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5982z00_7462;
																																																								obj_t
																																																									BgL_arg5983z00_7463;
																																																								obj_t
																																																									BgL_arg5984z00_7464;
																																																								BgL_arg5982z00_7462
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7459));
																																																								BgL_arg5983z00_7463
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7459));
																																																								BgL_arg5984z00_7464
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24760;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24763;
																																																										obj_t
																																																											BgL_bodyz00_24762;
																																																										obj_t
																																																											BgL_varsz00_24761;
																																																										BgL_varsz00_24761
																																																											=
																																																											BgL_arg5982z00_7462;
																																																										BgL_bodyz00_24762
																																																											=
																																																											BgL_arg5983z00_7463;
																																																										BgL_argsz00_24763
																																																											=
																																																											BgL_arg5984z00_7464;
																																																										BgL_argsz00_1790
																																																											=
																																																											BgL_argsz00_24763;
																																																										BgL_bodyz00_1789
																																																											=
																																																											BgL_bodyz00_24762;
																																																										BgL_varsz00_1788
																																																											=
																																																											BgL_varsz00_24761;
																																																										goto
																																																											BgL_tagzd2386zd2_1791;
																																																									}
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24760);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd245206zd2_7466;
																																																								BgL_cdrzd245206zd2_7466
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd245212zd2_7467;
																																																									BgL_cdrzd245212zd2_7467
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd245178zd2_7458));
																																																									if ((CAR(((obj_t) BgL_carzd245178zd2_7458)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd245218zd2_7470;
																																																											BgL_cdrzd245218zd2_7470
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd245212zd2_7467));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd245223zd2_7471;
																																																												obj_t
																																																													BgL_cdrzd245224zd2_7472;
																																																												BgL_carzd245223zd2_7471
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7470));
																																																												BgL_cdrzd245224zd2_7472
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7470));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245223zd2_7471))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd245224zd2_7472))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd245231zd2_7475;
																																																																BgL_carzd245231zd2_7475
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd245224zd2_7472);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245231zd2_7475))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd245224zd2_7472)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9269z00_24790;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1446z00_7508;
																																																																					BgL_l1446z00_7508
																																																																						=
																																																																						BgL_cdrzd245206zd2_7466;
																																																																				BgL_zc3z04anonymousza36007ze3z87_7509:
																																																																					if (NULLP(BgL_l1446z00_7508))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9269z00_24790
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9271z00_24793;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9272z00_24794;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_24795;
																																																																									BgL_tmpz00_24795
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1446z00_7508));
																																																																									BgL_test9272z00_24794
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_24795);
																																																																								}
																																																																								if (BgL_test9272z00_24794)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9271z00_24793
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9271z00_24793
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9271z00_24793)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1446z00_24799;
																																																																									BgL_l1446z00_24799
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1446z00_7508));
																																																																									BgL_l1446z00_7508
																																																																										=
																																																																										BgL_l1446z00_24799;
																																																																									goto
																																																																										BgL_zc3z04anonymousza36007ze3z87_7509;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9269z00_24790
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9269z00_24790)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg5997z00_7491;
																																																																						BgL_arg5997z00_7491
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd245212zd2_7467));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24804;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_24808;
																																																																								obj_t
																																																																									BgL_proc2z00_24807;
																																																																								obj_t
																																																																									BgL_proc1z00_24806;
																																																																								obj_t
																																																																									BgL_testz00_24805;
																																																																								BgL_testz00_24805
																																																																									=
																																																																									BgL_arg5997z00_7491;
																																																																								BgL_proc1z00_24806
																																																																									=
																																																																									BgL_carzd245223zd2_7471;
																																																																								BgL_proc2z00_24807
																																																																									=
																																																																									BgL_carzd245231zd2_7475;
																																																																								BgL_argsz00_24808
																																																																									=
																																																																									BgL_cdrzd245206zd2_7466;
																																																																								BgL_argsz00_1795
																																																																									=
																																																																									BgL_argsz00_24808;
																																																																								BgL_proc2z00_1794
																																																																									=
																																																																									BgL_proc2z00_24807;
																																																																								BgL_proc1z00_1793
																																																																									=
																																																																									BgL_proc1z00_24806;
																																																																								BgL_testz00_1792
																																																																									=
																																																																									BgL_testz00_24805;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1796;
																																																																							}
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24804);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd245255zd2_7492;
																																																																						BgL_cdrzd245255zd2_7492
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd245262zd2_7493;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_12201;
																																																																								BgL_pairz00_12201
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd245262zd2_7493
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12201);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd245269zd2_7494;
																																																																								BgL_cdrzd245269zd2_7494
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd245262zd2_7493));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd245275zd2_7495;
																																																																									BgL_carzd245275zd2_7495
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd245269zd2_7494));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245275zd2_7495))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd245282zd2_7497;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12205;
																																																																												BgL_pairz00_12205
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd245269zd2_7494));
																																																																												BgL_carzd245282zd2_7497
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_12205);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245282zd2_7497))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245255zd2_7492))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg6001z00_7500;
																																																																															BgL_arg6001z00_7500
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd245262zd2_7493));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24830;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24834;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24833;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24832;
																																																																																	obj_t
																																																																																		BgL_testz00_24831;
																																																																																	BgL_testz00_24831
																																																																																		=
																																																																																		BgL_arg6001z00_7500;
																																																																																	BgL_proc1z00_24832
																																																																																		=
																																																																																		BgL_carzd245275zd2_7495;
																																																																																	BgL_proc2z00_24833
																																																																																		=
																																																																																		BgL_carzd245282zd2_7497;
																																																																																	BgL_argsz00_24834
																																																																																		=
																																																																																		BgL_cdrzd245255zd2_7492;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_24834;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_24833;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_24832;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_24831;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24830);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24838;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24838);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24842;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24842);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24846;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24846);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_24850;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_24850);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd245558zd2_7519;
																																																																		BgL_cdrzd245558zd2_7519
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd245564zd2_7520;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_12209;
																																																																				BgL_pairz00_12209
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd245564zd2_7520
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12209);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd245570zd2_7521;
																																																																				BgL_cdrzd245570zd2_7521
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd245564zd2_7520));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245575zd2_7522;
																																																																					obj_t
																																																																						BgL_cdrzd245576zd2_7523;
																																																																					BgL_carzd245575zd2_7522
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7521));
																																																																					BgL_cdrzd245576zd2_7523
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7521));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245575zd2_7522))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd245581zd2_7525;
																																																																							BgL_carzd245581zd2_7525
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd245576zd2_7523));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245581zd2_7525))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd245576zd2_7523))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245558zd2_7519))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6016z00_7530;
																																																																													BgL_arg6016z00_7530
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd245564zd2_7520));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24877;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24881;
																																																																															obj_t
																																																																																BgL_proc2z00_24880;
																																																																															obj_t
																																																																																BgL_proc1z00_24879;
																																																																															obj_t
																																																																																BgL_testz00_24878;
																																																																															BgL_testz00_24878
																																																																																=
																																																																																BgL_arg6016z00_7530;
																																																																															BgL_proc1z00_24879
																																																																																=
																																																																																BgL_carzd245575zd2_7522;
																																																																															BgL_proc2z00_24880
																																																																																=
																																																																																BgL_carzd245581zd2_7525;
																																																																															BgL_argsz00_24881
																																																																																=
																																																																																BgL_cdrzd245558zd2_7519;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_24881;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_24880;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_24879;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_24878;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24877);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24885;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24885);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24889;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24889);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24893;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24893);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24897;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24897);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_24901;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_24901);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd245914zd2_7538;
																																																														BgL_cdrzd245914zd2_7538
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd245921zd2_7539;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_12218;
																																																																BgL_pairz00_12218
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd245921zd2_7539
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_12218);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd245928zd2_7540;
																																																																BgL_cdrzd245928zd2_7540
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd245921zd2_7539));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd245934zd2_7541;
																																																																	obj_t
																																																																		BgL_cdrzd245935zd2_7542;
																																																																	BgL_carzd245934zd2_7541
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7540));
																																																																	BgL_cdrzd245935zd2_7542
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7540));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245934zd2_7541))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd245935zd2_7542))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245942zd2_7545;
																																																																					BgL_carzd245942zd2_7545
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd245935zd2_7542);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245942zd2_7545))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd245935zd2_7542)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245914zd2_7538))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6030z00_7550;
																																																																											BgL_arg6030z00_7550
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd245921zd2_7539));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_24928;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_24932;
																																																																													obj_t
																																																																														BgL_proc2z00_24931;
																																																																													obj_t
																																																																														BgL_proc1z00_24930;
																																																																													obj_t
																																																																														BgL_testz00_24929;
																																																																													BgL_testz00_24929
																																																																														=
																																																																														BgL_arg6030z00_7550;
																																																																													BgL_proc1z00_24930
																																																																														=
																																																																														BgL_carzd245934zd2_7541;
																																																																													BgL_proc2z00_24931
																																																																														=
																																																																														BgL_carzd245942zd2_7545;
																																																																													BgL_argsz00_24932
																																																																														=
																																																																														BgL_cdrzd245914zd2_7538;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_24932;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_24931;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_24930;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_24929;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_24928);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24936;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24936);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24940;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24940);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24944;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24944);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24948;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24948);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24952;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24952);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_24956;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_24956);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd246335zd2_7564;
																																														BgL_cdrzd246335zd2_7564
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9300z00_24960;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6058z00_7581;
																																																BgL_arg6058z00_7581
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9300z00_24960
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6058z00_7581));
																																															}
																																															if (BgL_test9300z00_24960)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6046z00_7567;
																																																	obj_t
																																																		BgL_arg6047z00_7568;
																																																	BgL_arg6046z00_7567
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7564));
																																																	BgL_arg6047z00_7568
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7564));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24969;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24971;
																																																			obj_t
																																																				BgL_bindingsz00_24970;
																																																			BgL_bindingsz00_24970
																																																				=
																																																				BgL_arg6046z00_7567;
																																																			BgL_exprz00_24971
																																																				=
																																																				BgL_arg6047z00_7568;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_24971;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_24970;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24969);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9301z00_24973;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6057z00_7580;
																																																		BgL_arg6057z00_7580
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9301z00_24973
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6057z00_7580));
																																																	}
																																																	if (BgL_test9301z00_24973)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24978;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24978);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd246401zd2_7571;
																																																			BgL_carzd246401zd2_7571
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd246406zd2_7572;
																																																				BgL_cdrzd246406zd2_7572
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd246401zd2_7571));
																																																				if ((CAR(((obj_t) BgL_carzd246401zd2_7571)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg6052z00_7575;
																																																						obj_t
																																																							BgL_arg6053z00_7576;
																																																						obj_t
																																																							BgL_arg6054z00_7577;
																																																						BgL_arg6052z00_7575
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7572));
																																																						BgL_arg6053z00_7576
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7572));
																																																						BgL_arg6054z00_7577
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_24995;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_24998;
																																																								obj_t
																																																									BgL_bodyz00_24997;
																																																								obj_t
																																																									BgL_varsz00_24996;
																																																								BgL_varsz00_24996
																																																									=
																																																									BgL_arg6052z00_7575;
																																																								BgL_bodyz00_24997
																																																									=
																																																									BgL_arg6053z00_7576;
																																																								BgL_argsz00_24998
																																																									=
																																																									BgL_arg6054z00_7577;
																																																								BgL_argsz00_1790
																																																									=
																																																									BgL_argsz00_24998;
																																																								BgL_bodyz00_1789
																																																									=
																																																									BgL_bodyz00_24997;
																																																								BgL_varsz00_1788
																																																									=
																																																									BgL_varsz00_24996;
																																																								goto
																																																									BgL_tagzd2386zd2_1791;
																																																							}
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24995);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1825;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_25002;
																																																								goto
																																																									BgL_tagzd2404zd2_1826;
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_25002);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd246517zd2_7582;
																																												BgL_cdrzd246517zd2_7582
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test9304z00_25006;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6067z00_7591;
																																														BgL_arg6067z00_7591
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9304z00_25006
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6067z00_7591));
																																													}
																																													if (BgL_test9304z00_25006)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6061z00_7585;
																																															obj_t
																																																BgL_arg6062z00_7586;
																																															BgL_arg6061z00_7585
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7582));
																																															BgL_arg6062z00_7586
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7582));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25015;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25017;
																																																	obj_t
																																																		BgL_bindingsz00_25016;
																																																	BgL_bindingsz00_25016
																																																		=
																																																		BgL_arg6061z00_7585;
																																																	BgL_exprz00_25017
																																																		=
																																																		BgL_arg6062z00_7586;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_25017;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_25016;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25015);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9305z00_25019;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6066z00_7590;
																																																BgL_arg6066z00_7590
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9305z00_25019
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6066z00_7590));
																																															}
																																															if (BgL_test9305z00_25019)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25024;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25024);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1825;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_25028;
																																																			goto
																																																				BgL_tagzd2404zd2_1826;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25028);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245082zd2_7318)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd245084zd2_7320;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd245082zd2_7318 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd245084zd2_7320;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd245082zd2_7318 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd245084zd2_7320;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd245082zd2_7318)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd245084zd2_7320;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd246689zd2_7326;
																																																		BgL_cdrzd246689zd2_7326
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9311z00_25044;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5967z00_7443;
																																																				BgL_arg5967z00_7443
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9311z00_25044
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5967z00_7443));
																																																			}
																																																			if (BgL_test9311z00_25044)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5895z00_7329;
																																																					obj_t
																																																						BgL_arg5896z00_7330;
																																																					BgL_arg5895z00_7329
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7326));
																																																					BgL_arg5896z00_7330
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7326));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25053;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_25055;
																																																							obj_t
																																																								BgL_bindingsz00_25054;
																																																							BgL_bindingsz00_25054
																																																								=
																																																								BgL_arg5895z00_7329;
																																																							BgL_exprz00_25055
																																																								=
																																																								BgL_arg5896z00_7330;
																																																							BgL_exprz00_1780
																																																								=
																																																								BgL_exprz00_25055;
																																																							BgL_bindingsz00_1779
																																																								=
																																																								BgL_bindingsz00_25054;
																																																							goto
																																																								BgL_tagzd2382zd2_1781;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25053);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9312z00_25057;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5966z00_7442;
																																																						BgL_arg5966z00_7442
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9312z00_25057
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5966z00_7442));
																																																					}
																																																					if (BgL_test9312z00_25057)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_25062;
																																																							goto
																																																								BgL_tagzd2384zd2_1783;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25062);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd246755zd2_7333;
																																																							BgL_carzd246755zd2_7333
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd246760zd2_7334;
																																																								BgL_cdrzd246760zd2_7334
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd246755zd2_7333));
																																																								if ((CAR(((obj_t) BgL_carzd246755zd2_7333)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd246760zd2_7334))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5902z00_7338;
																																																												obj_t
																																																													BgL_arg5903z00_7339;
																																																												obj_t
																																																													BgL_arg5904z00_7340;
																																																												BgL_arg5902z00_7338
																																																													=
																																																													CAR
																																																													(BgL_cdrzd246760zd2_7334);
																																																												BgL_arg5903z00_7339
																																																													=
																																																													CDR
																																																													(BgL_cdrzd246760zd2_7334);
																																																												BgL_arg5904z00_7340
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25079;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_25082;
																																																														obj_t
																																																															BgL_bodyz00_25081;
																																																														obj_t
																																																															BgL_varsz00_25080;
																																																														BgL_varsz00_25080
																																																															=
																																																															BgL_arg5902z00_7338;
																																																														BgL_bodyz00_25081
																																																															=
																																																															BgL_arg5903z00_7339;
																																																														BgL_argsz00_25082
																																																															=
																																																															BgL_arg5904z00_7340;
																																																														BgL_argsz00_1790
																																																															=
																																																															BgL_argsz00_25082;
																																																														BgL_bodyz00_1789
																																																															=
																																																															BgL_bodyz00_25081;
																																																														BgL_varsz00_1788
																																																															=
																																																															BgL_varsz00_25080;
																																																														goto
																																																															BgL_tagzd2386zd2_1791;
																																																													}
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25079);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_25086;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_25086);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd246867zd2_7343;
																																																										BgL_cdrzd246867zd2_7343
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd246872zd2_7344;
																																																											BgL_cdrzd246872zd2_7344
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd246755zd2_7333));
																																																											if ((CAR(((obj_t) BgL_carzd246755zd2_7333)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd246872zd2_7344))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd246877zd2_7348;
																																																															BgL_cdrzd246877zd2_7348
																																																																=
																																																																CDR
																																																																(BgL_cdrzd246872zd2_7344);
																																																															if (PAIRP(BgL_cdrzd246877zd2_7348))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd246881zd2_7350;
																																																																	obj_t
																																																																		BgL_cdrzd246882zd2_7351;
																																																																	BgL_carzd246881zd2_7350
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd246877zd2_7348);
																																																																	BgL_cdrzd246882zd2_7351
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd246877zd2_7348);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246881zd2_7350))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd246882zd2_7351))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd246887zd2_7354;
																																																																					BgL_carzd246887zd2_7354
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd246882zd2_7351);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246887zd2_7354))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd246882zd2_7351)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9323z00_25114;
																																																																									{
																																																																										obj_t
																																																																											BgL_l1449z00_7387;
																																																																										BgL_l1449z00_7387
																																																																											=
																																																																											BgL_cdrzd246867zd2_7343;
																																																																									BgL_zc3z04anonymousza35930ze3z87_7388:
																																																																										if (NULLP(BgL_l1449z00_7387))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9323z00_25114
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9325z00_25117;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9326z00_25118;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_25119;
																																																																														BgL_tmpz00_25119
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_l1449z00_7387));
																																																																														BgL_test9326z00_25118
																																																																															=
																																																																															PAIRP
																																																																															(BgL_tmpz00_25119);
																																																																													}
																																																																													if (BgL_test9326z00_25118)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9325z00_25117
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9325z00_25117
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																												if (BgL_test9325z00_25117)
																																																																													{
																																																																														obj_t
																																																																															BgL_l1449z00_25123;
																																																																														BgL_l1449z00_25123
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_l1449z00_7387));
																																																																														BgL_l1449z00_7387
																																																																															=
																																																																															BgL_l1449z00_25123;
																																																																														goto
																																																																															BgL_zc3z04anonymousza35930ze3z87_7388;
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9323z00_25114
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																											}
																																																																									}
																																																																									if (BgL_test9323z00_25114)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg5920z00_7370;
																																																																											BgL_arg5920z00_7370
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd246872zd2_7344);
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25127;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25131;
																																																																													obj_t
																																																																														BgL_proc2z00_25130;
																																																																													obj_t
																																																																														BgL_proc1z00_25129;
																																																																													obj_t
																																																																														BgL_testz00_25128;
																																																																													BgL_testz00_25128
																																																																														=
																																																																														BgL_arg5920z00_7370;
																																																																													BgL_proc1z00_25129
																																																																														=
																																																																														BgL_carzd246881zd2_7350;
																																																																													BgL_proc2z00_25130
																																																																														=
																																																																														BgL_carzd246887zd2_7354;
																																																																													BgL_argsz00_25131
																																																																														=
																																																																														BgL_cdrzd246867zd2_7343;
																																																																													BgL_argsz00_1795
																																																																														=
																																																																														BgL_argsz00_25131;
																																																																													BgL_proc2z00_1794
																																																																														=
																																																																														BgL_proc2z00_25130;
																																																																													BgL_proc1z00_1793
																																																																														=
																																																																														BgL_proc1z00_25129;
																																																																													BgL_testz00_1792
																																																																														=
																																																																														BgL_testz00_25128;
																																																																													goto
																																																																														BgL_tagzd2387zd2_1796;
																																																																												}
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25127);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd246912zd2_7371;
																																																																											BgL_cdrzd246912zd2_7371
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd246920zd2_7372;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12266;
																																																																													BgL_pairz00_12266
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd246920zd2_7372
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12266);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd246928zd2_7373;
																																																																													BgL_cdrzd246928zd2_7373
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd246920zd2_7372));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd246935zd2_7374;
																																																																														BgL_carzd246935zd2_7374
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd246928zd2_7373));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246935zd2_7374))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd246944zd2_7376;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12270;
																																																																																	BgL_pairz00_12270
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd246928zd2_7373));
																																																																																	BgL_carzd246944zd2_7376
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_pairz00_12270);
																																																																																}
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246944zd2_7376))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd246912zd2_7371))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5924z00_7379;
																																																																																				BgL_arg5924z00_7379
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd246920zd2_7372));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25153;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25157;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25156;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25155;
																																																																																						obj_t
																																																																																							BgL_testz00_25154;
																																																																																						BgL_testz00_25154
																																																																																							=
																																																																																							BgL_arg5924z00_7379;
																																																																																						BgL_proc1z00_25155
																																																																																							=
																																																																																							BgL_carzd246935zd2_7374;
																																																																																						BgL_proc2z00_25156
																																																																																							=
																																																																																							BgL_carzd246944zd2_7376;
																																																																																						BgL_argsz00_25157
																																																																																							=
																																																																																							BgL_cdrzd246912zd2_7371;
																																																																																						BgL_argsz00_1800
																																																																																							=
																																																																																							BgL_argsz00_25157;
																																																																																						BgL_proc2z00_1799
																																																																																							=
																																																																																							BgL_proc2z00_25156;
																																																																																						BgL_proc1z00_1798
																																																																																							=
																																																																																							BgL_proc1z00_25155;
																																																																																						BgL_testz00_1797
																																																																																							=
																																																																																							BgL_testz00_25154;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1801;
																																																																																					}
																																																																																					BgL_auxz00_21492
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25153);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1825;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25161;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1826;
																																																																																						BgL_auxz00_21492
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25161);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25165;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25165);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25169;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25169);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25173;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25173);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd247222zd2_7398;
																																																																							BgL_cdrzd247222zd2_7398
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd247229zd2_7399;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12274;
																																																																									BgL_pairz00_12274
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd247229zd2_7399
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12274);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd247236zd2_7400;
																																																																									BgL_cdrzd247236zd2_7400
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd247229zd2_7399));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247242zd2_7401;
																																																																										obj_t
																																																																											BgL_cdrzd247243zd2_7402;
																																																																										BgL_carzd247242zd2_7401
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7400));
																																																																										BgL_cdrzd247243zd2_7402
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7400));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247242zd2_7401))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd247250zd2_7404;
																																																																												BgL_carzd247250zd2_7404
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd247243zd2_7402));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247250zd2_7404))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(((obj_t) BgL_cdrzd247243zd2_7402))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247222zd2_7398))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5939z00_7409;
																																																																																		BgL_arg5939z00_7409
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd247229zd2_7399));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25200;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25204;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25203;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25202;
																																																																																				obj_t
																																																																																					BgL_testz00_25201;
																																																																																				BgL_testz00_25201
																																																																																					=
																																																																																					BgL_arg5939z00_7409;
																																																																																				BgL_proc1z00_25202
																																																																																					=
																																																																																					BgL_carzd247242zd2_7401;
																																																																																				BgL_proc2z00_25203
																																																																																					=
																																																																																					BgL_carzd247250zd2_7404;
																																																																																				BgL_argsz00_25204
																																																																																					=
																																																																																					BgL_cdrzd247222zd2_7398;
																																																																																				BgL_argsz00_1800
																																																																																					=
																																																																																					BgL_argsz00_25204;
																																																																																				BgL_proc2z00_1799
																																																																																					=
																																																																																					BgL_proc2z00_25203;
																																																																																				BgL_proc1z00_1798
																																																																																					=
																																																																																					BgL_proc1z00_25202;
																																																																																				BgL_testz00_1797
																																																																																					=
																																																																																					BgL_testz00_25201;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1801;
																																																																																			}
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25200);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1825;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25208;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1826;
																																																																																				BgL_auxz00_21492
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25208);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25212;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25212);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25216;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25216);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25220;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25220);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25224;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25224);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd247583zd2_7417;
																																																																			BgL_cdrzd247583zd2_7417
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd247589zd2_7418;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12283;
																																																																					BgL_pairz00_12283
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd247589zd2_7418
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12283);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd247595zd2_7419;
																																																																					BgL_cdrzd247595zd2_7419
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd247589zd2_7418));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd247600zd2_7420;
																																																																						obj_t
																																																																							BgL_cdrzd247601zd2_7421;
																																																																						BgL_carzd247600zd2_7420
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7419));
																																																																						BgL_cdrzd247601zd2_7421
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7419));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247600zd2_7420))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd247601zd2_7421))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247606zd2_7424;
																																																																										BgL_carzd247606zd2_7424
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd247601zd2_7421);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247606zd2_7424))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd247601zd2_7421)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247583zd2_7417))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg5953z00_7429;
																																																																																BgL_arg5953z00_7429
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd247589zd2_7418));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25251;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_argsz00_25255;
																																																																																		obj_t
																																																																																			BgL_proc2z00_25254;
																																																																																		obj_t
																																																																																			BgL_proc1z00_25253;
																																																																																		obj_t
																																																																																			BgL_testz00_25252;
																																																																																		BgL_testz00_25252
																																																																																			=
																																																																																			BgL_arg5953z00_7429;
																																																																																		BgL_proc1z00_25253
																																																																																			=
																																																																																			BgL_carzd247600zd2_7420;
																																																																																		BgL_proc2z00_25254
																																																																																			=
																																																																																			BgL_carzd247606zd2_7424;
																																																																																		BgL_argsz00_25255
																																																																																			=
																																																																																			BgL_cdrzd247583zd2_7417;
																																																																																		BgL_argsz00_1800
																																																																																			=
																																																																																			BgL_argsz00_25255;
																																																																																		BgL_proc2z00_1799
																																																																																			=
																																																																																			BgL_proc2z00_25254;
																																																																																		BgL_proc1z00_1798
																																																																																			=
																																																																																			BgL_proc1z00_25253;
																																																																																		BgL_testz00_1797
																																																																																			=
																																																																																			BgL_testz00_25252;
																																																																																		goto
																																																																																			BgL_tagzd2388zd2_1801;
																																																																																	}
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25251);
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1825;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25259;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1826;
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25259);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25263;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25263);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25267;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25267);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25271;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25271);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25275;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25275);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25279;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25279);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25283;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25283);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25287;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25287);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd245079zd2_7316 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6069z00_7595;
																																									obj_t
																																										BgL_arg6070z00_7596;
																																									BgL_arg6069z00_7595
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7300));
																																									BgL_arg6070z00_7596
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7300));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25296;
																																										{
																																											obj_t
																																												BgL_exprz00_25298;
																																											obj_t
																																												BgL_bindingsz00_25297;
																																											BgL_bindingsz00_25297
																																												=
																																												BgL_arg6069z00_7595;
																																											BgL_exprz00_25298
																																												=
																																												BgL_arg6070z00_7596;
																																											BgL_exprz00_1780
																																												=
																																												BgL_exprz00_25298;
																																											BgL_bindingsz00_1779
																																												=
																																												BgL_bindingsz00_25297;
																																											goto
																																												BgL_tagzd2382zd2_1781;
																																										}
																																										BgL_auxz00_21492
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25296);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245079zd2_7316)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6072z00_7598;
																																											obj_t
																																												BgL_arg6073z00_7599;
																																											BgL_arg6072z00_7598
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7300));
																																											BgL_arg6073z00_7599
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7300));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25307;
																																												{
																																													obj_t
																																														BgL_exprz00_25309;
																																													obj_t
																																														BgL_bindingsz00_25308;
																																													BgL_bindingsz00_25308
																																														=
																																														BgL_arg6072z00_7598;
																																													BgL_exprz00_25309
																																														=
																																														BgL_arg6073z00_7599;
																																													BgL_exprz00_1780
																																														=
																																														BgL_exprz00_25309;
																																													BgL_bindingsz00_1779
																																														=
																																														BgL_bindingsz00_25308;
																																													goto
																																														BgL_tagzd2382zd2_1781;
																																												}
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25307);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd245079zd2_7316 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6075z00_7601;
																																													obj_t
																																														BgL_arg6076z00_7602;
																																													BgL_arg6075z00_7601
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7300));
																																													BgL_arg6076z00_7602
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7300));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25318;
																																														{
																																															obj_t
																																																BgL_exprz00_25320;
																																															obj_t
																																																BgL_bindingsz00_25319;
																																															BgL_bindingsz00_25319
																																																=
																																																BgL_arg6075z00_7601;
																																															BgL_exprz00_25320
																																																=
																																																BgL_arg6076z00_7602;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_25320;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_25319;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_21492
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25318);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25327;
																																															goto
																																																BgL_tagzd2383zd2_1782;
																																															BgL_auxz00_21492
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25327);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd248181zd2_7605;
																																															BgL_carzd248181zd2_7605
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd248181zd2_7605 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25334;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25334);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248181zd2_7605)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25339;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25339);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25346;
																																																					goto
																																																						BgL_tagzd2389zd2_1802;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25346);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25353;
																																																							goto
																																																								BgL_tagzd2390zd2_1803;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25353);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248261zd2_7612;
																																																							BgL_cdrzd248261zd2_7612
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg6087z00_7615;
																																																									obj_t
																																																										BgL_arg6088z00_7616;
																																																									BgL_arg6087z00_7615
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7612));
																																																									BgL_arg6088z00_7616
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7612));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_25366;
																																																										{
																																																											obj_t
																																																												BgL_restz00_25368;
																																																											obj_t
																																																												BgL_effectz00_25367;
																																																											BgL_effectz00_25367
																																																												=
																																																												BgL_arg6087z00_7615;
																																																											BgL_restz00_25368
																																																												=
																																																												BgL_arg6088z00_7616;
																																																											BgL_restz00_1805
																																																												=
																																																												BgL_restz00_25368;
																																																											BgL_effectz00_1804
																																																												=
																																																												BgL_effectz00_25367;
																																																											goto
																																																												BgL_tagzd2391zd2_1806;
																																																										}
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_25366);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_25375;
																																																											goto
																																																												BgL_tagzd2392zd2_1807;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_25375);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25382;
																																																													goto
																																																														BgL_tagzd2393zd2_1808;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25382);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6095z00_7624;
																																																															obj_t
																																																																BgL_arg6096z00_7625;
																																																															BgL_arg6095z00_7624
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7612));
																																																															BgL_arg6096z00_7625
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7612));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_25393;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_25395;
																																																																	obj_t
																																																																		BgL_effectz00_25394;
																																																																	BgL_effectz00_25394
																																																																		=
																																																																		BgL_arg6095z00_7624;
																																																																	BgL_restz00_25395
																																																																		=
																																																																		BgL_arg6096z00_7625;
																																																																	BgL_restz00_1810
																																																																		=
																																																																		BgL_restz00_25395;
																																																																	BgL_effectz00_1809
																																																																		=
																																																																		BgL_effectz00_25394;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1811;
																																																																}
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_25393);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25402;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1812;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25402);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25409;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1813;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25409);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_25416;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1814;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25416);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_25423;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1815;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25423);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9373z00_25430;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_25431;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12319;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12318;
																																																																												BgL_pairz00_12318
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_pairz00_12319
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12318);
																																																																											}
																																																																											BgL_tmpz00_25431
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12319);
																																																																										}
																																																																										BgL_test9373z00_25430
																																																																											=
																																																																											NULLP
																																																																											(BgL_tmpz00_25431);
																																																																									}
																																																																									if (BgL_test9373z00_25430)
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25437;
																																																																											goto
																																																																												BgL_tagzd2399zd2_1816;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25437);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25441;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25441);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd248349zd2_7644;
																																																																									BgL_cdrzd248349zd2_7644
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd248355zd2_7647;
																																																																											BgL_cdrzd248355zd2_7647
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248349zd2_7644));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd248361zd2_7648;
																																																																												BgL_cdrzd248361zd2_7648
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd248355zd2_7647));
																																																																												if ((CAR(((obj_t) BgL_cdrzd248355zd2_7647)) == CNST_TABLE_REF(((long) 31))))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd248361zd2_7648))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6120z00_7652;
																																																																																obj_t
																																																																																	BgL_arg6121z00_7653;
																																																																																obj_t
																																																																																	BgL_arg6122z00_7654;
																																																																																BgL_arg6120z00_7652
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7644));
																																																																																BgL_arg6121z00_7653
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd248361zd2_7648);
																																																																																BgL_arg6122z00_7654
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd248361zd2_7648);
																																																																																{	/* Ast/sexp.scm 553 */
																																																																																	obj_t
																																																																																		BgL_arg7022z00_12328;
																																																																																	BgL_arg7022z00_12328
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6120z00_7652,
																																																																																			BgL_arg6121z00_7653,
																																																																																			BgL_arg6122z00_7654,
																																																																																			BgL_stackz00_22,
																																																																																			BgL_arg7022z00_12328,
																																																																																			BgL_sitez00_24));
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6123z00_7656;
																																																																																obj_t
																																																																																	BgL_arg6124z00_7657;
																																																																																BgL_arg6123z00_7656
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7644));
																																																																																BgL_arg6124z00_7657
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7644));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7023z00_12332;
																																																																																	BgL_arg7023z00_12332
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6123z00_7656,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg6124z00_7657, BgL_stackz00_22, BgL_arg7023z00_12332, BgL_sitez00_24));
																																																																													}}}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg6125z00_7659;
																																																																														obj_t
																																																																															BgL_arg6126z00_7660;
																																																																														BgL_arg6125z00_7659
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7644));
																																																																														BgL_arg6126z00_7660
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7644));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7023z00_12336;
																																																																															BgL_arg7023z00_12336
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_arg6125z00_7659,
																																																																																	CNST_TABLE_REF
																																																																																	(((long) 4)), BgL_arg6126z00_7660, BgL_stackz00_22, BgL_arg7023z00_12336, BgL_sitez00_24));
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25486;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25486);
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd248412zd2_7679;
																											BgL_carzd248412zd2_7679 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd248412zd2_7679
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_25493;
																													goto
																														BgL_tagzd2377zd2_1770;
																													BgL_auxz00_21492 =
																														((obj_t)
																														BgL_auxz00_25493);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd248412zd2_7679
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25497;
																															goto
																																BgL_tagzd2377zd2_1770;
																															BgL_auxz00_21492 =
																																((obj_t)
																																BgL_auxz00_25497);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_25504;
																																	goto
																																		BgL_tagzd2379zd2_1774;
																																	BgL_auxz00_21492
																																		=
																																		((obj_t)
																																		BgL_auxz00_25504);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_25511;
																																			goto
																																				BgL_tagzd2380zd2_1775;
																																			BgL_auxz00_21492
																																				=
																																				((obj_t)
																																				BgL_auxz00_25511);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd248481zd2_7686;
																																			BgL_carzd248481zd2_7686
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd248481zd2_7686))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd248484zd2_7688;
																																					obj_t
																																						BgL_cdrzd248485zd2_7689;
																																					BgL_carzd248484zd2_7688
																																						=
																																						CAR
																																						(BgL_carzd248481zd2_7686);
																																					BgL_cdrzd248485zd2_7689
																																						=
																																						CDR
																																						(BgL_carzd248481zd2_7686);
																																					{

																																						if (
																																							(BgL_carzd248484zd2_7688
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd248486zd2_7690:
																																								if (PAIRP(BgL_cdrzd248485zd2_7689))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd248489zd2_7872;
																																										BgL_cdrzd248489zd2_7872
																																											=
																																											CDR
																																											(BgL_cdrzd248485zd2_7689);
																																										if (PAIRP(BgL_cdrzd248489zd2_7872))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd248489zd2_7872)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6280z00_7876;
																																														obj_t
																																															BgL_arg6281z00_7877;
																																														BgL_arg6280z00_7876
																																															=
																																															CAR
																																															(BgL_cdrzd248489zd2_7872);
																																														BgL_arg6281z00_7877
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25533;
																																															{
																																																obj_t
																																																	BgL_argsz00_25535;
																																																obj_t
																																																	BgL_bodyz00_25534;
																																																BgL_bodyz00_25534
																																																	=
																																																	BgL_arg6280z00_7876;
																																																BgL_argsz00_25535
																																																	=
																																																	BgL_arg6281z00_7877;
																																																BgL_argsz00_1777
																																																	=
																																																	BgL_argsz00_25535;
																																																BgL_bodyz00_1776
																																																	=
																																																	BgL_bodyz00_25534;
																																																goto
																																																	BgL_tagzd2381zd2_1778;
																																															}
																																															BgL_auxz00_21492
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25533);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd248513zd2_7878;
																																														BgL_cdrzd248513zd2_7878
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9388z00_25539;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6350z00_7989;
																																																BgL_arg6350z00_7989
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9388z00_25539
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6350z00_7989));
																																															}
																																															if (BgL_test9388z00_25539)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6284z00_7881;
																																																	obj_t
																																																		BgL_arg6285z00_7882;
																																																	BgL_arg6284z00_7881
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7878));
																																																	BgL_arg6285z00_7882
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7878));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_25548;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_25550;
																																																			obj_t
																																																				BgL_bindingsz00_25549;
																																																			BgL_bindingsz00_25549
																																																				=
																																																				BgL_arg6284z00_7881;
																																																			BgL_exprz00_25550
																																																				=
																																																				BgL_arg6285z00_7882;
																																																			BgL_exprz00_1780
																																																				=
																																																				BgL_exprz00_25550;
																																																			BgL_bindingsz00_1779
																																																				=
																																																				BgL_bindingsz00_25549;
																																																			goto
																																																				BgL_tagzd2382zd2_1781;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_25548);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9389z00_25552;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6349z00_7988;
																																																		BgL_arg6349z00_7988
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9389z00_25552
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6349z00_7988));
																																																	}
																																																	if (BgL_test9389z00_25552)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25557;
																																																			goto
																																																				BgL_tagzd2384zd2_1783;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25557);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd248580zd2_7885;
																																																			BgL_carzd248580zd2_7885
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd248585zd2_7886;
																																																				BgL_cdrzd248585zd2_7886
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd248580zd2_7885));
																																																				if ((CAR(((obj_t) BgL_carzd248580zd2_7885)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg6290z00_7889;
																																																						obj_t
																																																							BgL_arg6291z00_7890;
																																																						obj_t
																																																							BgL_arg6292z00_7891;
																																																						BgL_arg6290z00_7889
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7886));
																																																						BgL_arg6291z00_7890
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7886));
																																																						BgL_arg6292z00_7891
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25574;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_25577;
																																																								obj_t
																																																									BgL_bodyz00_25576;
																																																								obj_t
																																																									BgL_varsz00_25575;
																																																								BgL_varsz00_25575
																																																									=
																																																									BgL_arg6290z00_7889;
																																																								BgL_bodyz00_25576
																																																									=
																																																									BgL_arg6291z00_7890;
																																																								BgL_argsz00_25577
																																																									=
																																																									BgL_arg6292z00_7891;
																																																								BgL_argsz00_1790
																																																									=
																																																									BgL_argsz00_25577;
																																																								BgL_bodyz00_1789
																																																									=
																																																									BgL_bodyz00_25576;
																																																								BgL_varsz00_1788
																																																									=
																																																									BgL_varsz00_25575;
																																																								goto
																																																									BgL_tagzd2386zd2_1791;
																																																							}
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25574);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd248608zd2_7893;
																																																						BgL_cdrzd248608zd2_7893
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248614zd2_7894;
																																																							BgL_cdrzd248614zd2_7894
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd248580zd2_7885));
																																																							if ((CAR(((obj_t) BgL_carzd248580zd2_7885)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd248620zd2_7897;
																																																									BgL_cdrzd248620zd2_7897
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248614zd2_7894));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd248625zd2_7898;
																																																										obj_t
																																																											BgL_cdrzd248626zd2_7899;
																																																										BgL_carzd248625zd2_7898
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7897));
																																																										BgL_cdrzd248626zd2_7899
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7897));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248625zd2_7898))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd248626zd2_7899))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd248633zd2_7902;
																																																														BgL_carzd248633zd2_7902
																																																															=
																																																															CAR
																																																															(BgL_cdrzd248626zd2_7899);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248633zd2_7902))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd248626zd2_7899)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test9396z00_25604;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1452z00_7935;
																																																																			BgL_l1452z00_7935
																																																																				=
																																																																				BgL_cdrzd248608zd2_7893;
																																																																		BgL_zc3z04anonymousza36315ze3z87_7936:
																																																																			if (NULLP(BgL_l1452z00_7935))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9396z00_25604
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9398z00_25607;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9399z00_25608;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_25609;
																																																																							BgL_tmpz00_25609
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1452z00_7935));
																																																																							BgL_test9399z00_25608
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_25609);
																																																																						}
																																																																						if (BgL_test9399z00_25608)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9398z00_25607
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9398z00_25607
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test9398z00_25607)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1452z00_25613;
																																																																							BgL_l1452z00_25613
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1452z00_7935));
																																																																							BgL_l1452z00_7935
																																																																								=
																																																																								BgL_l1452z00_25613;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36315ze3z87_7936;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9396z00_25604
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test9396z00_25604)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6305z00_7918;
																																																																				BgL_arg6305z00_7918
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd248614zd2_7894));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25618;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_25622;
																																																																						obj_t
																																																																							BgL_proc2z00_25621;
																																																																						obj_t
																																																																							BgL_proc1z00_25620;
																																																																						obj_t
																																																																							BgL_testz00_25619;
																																																																						BgL_testz00_25619
																																																																							=
																																																																							BgL_arg6305z00_7918;
																																																																						BgL_proc1z00_25620
																																																																							=
																																																																							BgL_carzd248625zd2_7898;
																																																																						BgL_proc2z00_25621
																																																																							=
																																																																							BgL_carzd248633zd2_7902;
																																																																						BgL_argsz00_25622
																																																																							=
																																																																							BgL_cdrzd248608zd2_7893;
																																																																						BgL_argsz00_1795
																																																																							=
																																																																							BgL_argsz00_25622;
																																																																						BgL_proc2z00_1794
																																																																							=
																																																																							BgL_proc2z00_25621;
																																																																						BgL_proc1z00_1793
																																																																							=
																																																																							BgL_proc1z00_25620;
																																																																						BgL_testz00_1792
																																																																							=
																																																																							BgL_testz00_25619;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1796;
																																																																					}
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25618);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd248657zd2_7919;
																																																																				BgL_cdrzd248657zd2_7919
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd248664zd2_7920;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12372;
																																																																						BgL_pairz00_12372
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd248664zd2_7920
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12372);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd248671zd2_7921;
																																																																						BgL_cdrzd248671zd2_7921
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd248664zd2_7920));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd248677zd2_7922;
																																																																							BgL_carzd248677zd2_7922
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd248671zd2_7921));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248677zd2_7922))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd248684zd2_7924;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12376;
																																																																										BgL_pairz00_12376
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd248671zd2_7921));
																																																																										BgL_carzd248684zd2_7924
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12376);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248684zd2_7924))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248657zd2_7919))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6309z00_7927;
																																																																													BgL_arg6309z00_7927
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd248664zd2_7920));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25644;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_25648;
																																																																															obj_t
																																																																																BgL_proc2z00_25647;
																																																																															obj_t
																																																																																BgL_proc1z00_25646;
																																																																															obj_t
																																																																																BgL_testz00_25645;
																																																																															BgL_testz00_25645
																																																																																=
																																																																																BgL_arg6309z00_7927;
																																																																															BgL_proc1z00_25646
																																																																																=
																																																																																BgL_carzd248677zd2_7922;
																																																																															BgL_proc2z00_25647
																																																																																=
																																																																																BgL_carzd248684zd2_7924;
																																																																															BgL_argsz00_25648
																																																																																=
																																																																																BgL_cdrzd248657zd2_7919;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_25648;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_25647;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_25646;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_25645;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25644);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25652;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25652);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25656;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25656);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25660;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25660);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_25664;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_25664);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd248960zd2_7946;
																																																																BgL_cdrzd248960zd2_7946
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd248966zd2_7947;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12380;
																																																																		BgL_pairz00_12380
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd248966zd2_7947
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12380);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd248972zd2_7948;
																																																																		BgL_cdrzd248972zd2_7948
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd248966zd2_7947));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd248977zd2_7949;
																																																																			obj_t
																																																																				BgL_cdrzd248978zd2_7950;
																																																																			BgL_carzd248977zd2_7949
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7948));
																																																																			BgL_cdrzd248978zd2_7950
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7948));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248977zd2_7949))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd248983zd2_7952;
																																																																					BgL_carzd248983zd2_7952
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd248978zd2_7950));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248983zd2_7952))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd248978zd2_7950))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248960zd2_7946))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6324z00_7957;
																																																																											BgL_arg6324z00_7957
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248966zd2_7947));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25691;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25695;
																																																																													obj_t
																																																																														BgL_proc2z00_25694;
																																																																													obj_t
																																																																														BgL_proc1z00_25693;
																																																																													obj_t
																																																																														BgL_testz00_25692;
																																																																													BgL_testz00_25692
																																																																														=
																																																																														BgL_arg6324z00_7957;
																																																																													BgL_proc1z00_25693
																																																																														=
																																																																														BgL_carzd248977zd2_7949;
																																																																													BgL_proc2z00_25694
																																																																														=
																																																																														BgL_carzd248983zd2_7952;
																																																																													BgL_argsz00_25695
																																																																														=
																																																																														BgL_cdrzd248960zd2_7946;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_25695;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_25694;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_25693;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_25692;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25691);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25699;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25699);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25703;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25703);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25707;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25707);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25711;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25711);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_25715;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_25715);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd249316zd2_7965;
																																																												BgL_cdrzd249316zd2_7965
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd249323zd2_7966;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_12389;
																																																														BgL_pairz00_12389
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd249323zd2_7966
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12389);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd249330zd2_7967;
																																																														BgL_cdrzd249330zd2_7967
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd249323zd2_7966));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd249336zd2_7968;
																																																															obj_t
																																																																BgL_cdrzd249337zd2_7969;
																																																															BgL_carzd249336zd2_7968
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7967));
																																																															BgL_cdrzd249337zd2_7969
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7967));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249336zd2_7968))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd249337zd2_7969))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd249344zd2_7972;
																																																																			BgL_carzd249344zd2_7972
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd249337zd2_7969);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249344zd2_7972))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd249337zd2_7969)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd249316zd2_7965))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6338z00_7977;
																																																																									BgL_arg6338z00_7977
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd249323zd2_7966));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25742;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_25746;
																																																																											obj_t
																																																																												BgL_proc2z00_25745;
																																																																											obj_t
																																																																												BgL_proc1z00_25744;
																																																																											obj_t
																																																																												BgL_testz00_25743;
																																																																											BgL_testz00_25743
																																																																												=
																																																																												BgL_arg6338z00_7977;
																																																																											BgL_proc1z00_25744
																																																																												=
																																																																												BgL_carzd249336zd2_7968;
																																																																											BgL_proc2z00_25745
																																																																												=
																																																																												BgL_carzd249344zd2_7972;
																																																																											BgL_argsz00_25746
																																																																												=
																																																																												BgL_cdrzd249316zd2_7965;
																																																																											BgL_argsz00_1800
																																																																												=
																																																																												BgL_argsz00_25746;
																																																																											BgL_proc2z00_1799
																																																																												=
																																																																												BgL_proc2z00_25745;
																																																																											BgL_proc1z00_1798
																																																																												=
																																																																												BgL_proc1z00_25744;
																																																																											BgL_testz00_1797
																																																																												=
																																																																												BgL_testz00_25743;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1801;
																																																																										}
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25742);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25750;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25750);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25754;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25754);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25758;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25758);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25762;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25762);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25766;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25766);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_25770;
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_25770);
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd249737zd2_7991;
																																												BgL_cdrzd249737zd2_7991
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test9427z00_25774;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6366z00_8008;
																																														BgL_arg6366z00_8008
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9427z00_25774
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6366z00_8008));
																																													}
																																													if (BgL_test9427z00_25774)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6354z00_7994;
																																															obj_t
																																																BgL_arg6355z00_7995;
																																															BgL_arg6354z00_7994
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7991));
																																															BgL_arg6355z00_7995
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7991));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25783;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25785;
																																																	obj_t
																																																		BgL_bindingsz00_25784;
																																																	BgL_bindingsz00_25784
																																																		=
																																																		BgL_arg6354z00_7994;
																																																	BgL_exprz00_25785
																																																		=
																																																		BgL_arg6355z00_7995;
																																																	BgL_exprz00_1780
																																																		=
																																																		BgL_exprz00_25785;
																																																	BgL_bindingsz00_1779
																																																		=
																																																		BgL_bindingsz00_25784;
																																																	goto
																																																		BgL_tagzd2382zd2_1781;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25783);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9428z00_25787;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6365z00_8007;
																																																BgL_arg6365z00_8007
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9428z00_25787
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6365z00_8007));
																																															}
																																															if (BgL_test9428z00_25787)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25792;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25792);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd249803zd2_7998;
																																																	BgL_carzd249803zd2_7998
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd249808zd2_7999;
																																																		BgL_cdrzd249808zd2_7999
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd249803zd2_7998));
																																																		if ((CAR(((obj_t) BgL_carzd249803zd2_7998)) == CNST_TABLE_REF(((long) 3))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6360z00_8002;
																																																				obj_t
																																																					BgL_arg6361z00_8003;
																																																				obj_t
																																																					BgL_arg6362z00_8004;
																																																				BgL_arg6360z00_8002
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7999));
																																																				BgL_arg6361z00_8003
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7999));
																																																				BgL_arg6362z00_8004
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25809;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_25812;
																																																						obj_t
																																																							BgL_bodyz00_25811;
																																																						obj_t
																																																							BgL_varsz00_25810;
																																																						BgL_varsz00_25810
																																																							=
																																																							BgL_arg6360z00_8002;
																																																						BgL_bodyz00_25811
																																																							=
																																																							BgL_arg6361z00_8003;
																																																						BgL_argsz00_25812
																																																							=
																																																							BgL_arg6362z00_8004;
																																																						BgL_argsz00_1790
																																																							=
																																																							BgL_argsz00_25812;
																																																						BgL_bodyz00_1789
																																																							=
																																																							BgL_bodyz00_25811;
																																																						BgL_varsz00_1788
																																																							=
																																																							BgL_varsz00_25810;
																																																						goto
																																																							BgL_tagzd2386zd2_1791;
																																																					}
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25809);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1825;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25816;
																																																						goto
																																																							BgL_tagzd2404zd2_1826;
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25816);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd249919zd2_8009;
																																										BgL_cdrzd249919zd2_8009
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{	/* Ast/sexp.scm 119 */
																																											bool_t
																																												BgL_test9431z00_25820;
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6375z00_8018;
																																												BgL_arg6375z00_8018
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												BgL_test9431z00_25820
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg6375z00_8018));
																																											}
																																											if (BgL_test9431z00_25820)
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6369z00_8012;
																																													obj_t
																																														BgL_arg6370z00_8013;
																																													BgL_arg6369z00_8012
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_8009));
																																													BgL_arg6370z00_8013
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_8009));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25829;
																																														{
																																															obj_t
																																																BgL_exprz00_25831;
																																															obj_t
																																																BgL_bindingsz00_25830;
																																															BgL_bindingsz00_25830
																																																=
																																																BgL_arg6369z00_8012;
																																															BgL_exprz00_25831
																																																=
																																																BgL_arg6370z00_8013;
																																															BgL_exprz00_1780
																																																=
																																																BgL_exprz00_25831;
																																															BgL_bindingsz00_1779
																																																=
																																																BgL_bindingsz00_25830;
																																															goto
																																																BgL_tagzd2382zd2_1781;
																																														}
																																														BgL_auxz00_21492
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25829);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test9432z00_25833;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6374z00_8017;
																																														BgL_arg6374z00_8017
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9432z00_25833
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg6374z00_8017));
																																													}
																																													if (BgL_test9432z00_25833)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_25838;
																																															goto
																																																BgL_tagzd2384zd2_1783;
																																															BgL_auxz00_21492
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25838);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1825;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25842;
																																																	goto
																																																		BgL_tagzd2404zd2_1826;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25842);
																																																}
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248484zd2_7688)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd248486zd2_7690;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd248484zd2_7688 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd248486zd2_7690;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd248484zd2_7688 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd248486zd2_7690;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248484zd2_7688)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd248486zd2_7690;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd250091zd2_7696;
																																																BgL_cdrzd250091zd2_7696
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9438z00_25858;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6275z00_7870;
																																																		BgL_arg6275z00_7870
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9438z00_25858
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6275z00_7870));
																																																	}
																																																	if (BgL_test9438z00_25858)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg6159z00_7699;
																																																			obj_t
																																																				BgL_arg6160z00_7700;
																																																			BgL_arg6159z00_7699
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7696));
																																																			BgL_arg6160z00_7700
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7696));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_25867;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_25869;
																																																					obj_t
																																																						BgL_bindingsz00_25868;
																																																					BgL_bindingsz00_25868
																																																						=
																																																						BgL_arg6159z00_7699;
																																																					BgL_exprz00_25869
																																																						=
																																																						BgL_arg6160z00_7700;
																																																					BgL_exprz00_1780
																																																						=
																																																						BgL_exprz00_25869;
																																																					BgL_bindingsz00_1779
																																																						=
																																																						BgL_bindingsz00_25868;
																																																					goto
																																																						BgL_tagzd2382zd2_1781;
																																																				}
																																																				BgL_auxz00_21492
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_25867);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9439z00_25871;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6274z00_7869;
																																																				BgL_arg6274z00_7869
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9439z00_25871
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6274z00_7869));
																																																			}
																																																			if (BgL_test9439z00_25871)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25876;
																																																					goto
																																																						BgL_tagzd2384zd2_1783;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25876);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd250144zd2_7703;
																																																					obj_t
																																																						BgL_cdrzd250145zd2_7704;
																																																					BgL_carzd250144zd2_7703
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_cdrzd250145zd2_7704
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd250149zd2_7705;
																																																						BgL_cdrzd250149zd2_7705
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd250144zd2_7703));
																																																						if ((CAR(((obj_t) BgL_carzd250144zd2_7703)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd250149zd2_7705))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd250152zd2_7709;
																																																										obj_t
																																																											BgL_cdrzd250153zd2_7710;
																																																										BgL_carzd250152zd2_7709
																																																											=
																																																											CAR
																																																											(BgL_cdrzd250149zd2_7705);
																																																										BgL_cdrzd250153zd2_7710
																																																											=
																																																											CDR
																																																											(BgL_cdrzd250149zd2_7705);
																																																										if (PAIRP(BgL_carzd250152zd2_7709))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (NULLP(CDR(BgL_carzd250152zd2_7709)))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd250153zd2_7710))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd250159zd2_7715;
																																																																BgL_carzd250159zd2_7715
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd250153zd2_7710);
																																																																if (PAIRP(BgL_carzd250159zd2_7715))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd250159zd2_7715))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250153zd2_7710)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd250166zd2_7720;
																																																																						BgL_carzd250166zd2_7720
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250145zd2_7704));
																																																																						if (PAIRP(BgL_carzd250166zd2_7720))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250191zd2_7722;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12428;
																																																																									BgL_pairz00_12428
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd250191zd2_7722
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12428);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6175z00_7723;
																																																																									obj_t
																																																																										BgL_arg6176z00_7724;
																																																																									obj_t
																																																																										BgL_arg6177z00_7725;
																																																																									BgL_arg6175z00_7723
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7722));
																																																																									BgL_arg6176z00_7724
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7722));
																																																																									BgL_arg6177z00_7725
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25921;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_25924;
																																																																											obj_t
																																																																												BgL_bodyz00_25923;
																																																																											obj_t
																																																																												BgL_varsz00_25922;
																																																																											BgL_varsz00_25922
																																																																												=
																																																																												BgL_arg6175z00_7723;
																																																																											BgL_bodyz00_25923
																																																																												=
																																																																												BgL_arg6176z00_7724;
																																																																											BgL_argsz00_25924
																																																																												=
																																																																												BgL_arg6177z00_7725;
																																																																											BgL_argsz00_1790
																																																																												=
																																																																												BgL_argsz00_25924;
																																																																											BgL_bodyz00_1789
																																																																												=
																																																																												BgL_bodyz00_25923;
																																																																											BgL_varsz00_1788
																																																																												=
																																																																												BgL_varsz00_25922;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1791;
																																																																										}
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25921);
																																																																									}
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd250145zd2_7704))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg6181z00_7729;
																																																																										BgL_arg6181z00_7729
																																																																											=
																																																																											CAR
																																																																											(BgL_carzd250152zd2_7709);
																																																																										{
																																																																											BgL_castz00_bglt
																																																																												BgL_auxz00_25931;
																																																																											{
																																																																												obj_t
																																																																													BgL_argz00_25934;
																																																																												obj_t
																																																																													BgL_bodyz00_25933;
																																																																												obj_t
																																																																													BgL_varz00_25932;
																																																																												BgL_varz00_25932
																																																																													=
																																																																													BgL_arg6181z00_7729;
																																																																												BgL_bodyz00_25933
																																																																													=
																																																																													BgL_carzd250159zd2_7715;
																																																																												BgL_argz00_25934
																																																																													=
																																																																													BgL_carzd250166zd2_7720;
																																																																												BgL_argz00_1786
																																																																													=
																																																																													BgL_argz00_25934;
																																																																												BgL_bodyz00_1785
																																																																													=
																																																																													BgL_bodyz00_25933;
																																																																												BgL_varz00_1784
																																																																													=
																																																																													BgL_varz00_25932;
																																																																												goto
																																																																													BgL_tagzd2385zd2_1787;
																																																																											}
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25931);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250219zd2_7730;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12435;
																																																																											BgL_pairz00_12435
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd250219zd2_7730
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12435);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6182z00_7731;
																																																																											obj_t
																																																																												BgL_arg6183z00_7732;
																																																																											obj_t
																																																																												BgL_arg6184z00_7733;
																																																																											BgL_arg6182z00_7731
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7730));
																																																																											BgL_arg6183z00_7732
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7730));
																																																																											BgL_arg6184z00_7733
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25945;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25948;
																																																																													obj_t
																																																																														BgL_bodyz00_25947;
																																																																													obj_t
																																																																														BgL_varsz00_25946;
																																																																													BgL_varsz00_25946
																																																																														=
																																																																														BgL_arg6182z00_7731;
																																																																													BgL_bodyz00_25947
																																																																														=
																																																																														BgL_arg6183z00_7732;
																																																																													BgL_argsz00_25948
																																																																														=
																																																																														BgL_arg6184z00_7733;
																																																																													BgL_argsz00_1790
																																																																														=
																																																																														BgL_argsz00_25948;
																																																																													BgL_bodyz00_1789
																																																																														=
																																																																														BgL_bodyz00_25947;
																																																																													BgL_varsz00_1788
																																																																														=
																																																																														BgL_varsz00_25946;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1791;
																																																																												}
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25945);
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250245zd2_7736;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12440;
																																																																							BgL_pairz00_12440
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd250245zd2_7736
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12440);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6187z00_7737;
																																																																							obj_t
																																																																								BgL_arg6188z00_7738;
																																																																							obj_t
																																																																								BgL_arg6189z00_7739;
																																																																							BgL_arg6187z00_7737
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7736));
																																																																							BgL_arg6188z00_7738
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7736));
																																																																							BgL_arg6189z00_7739
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_25959;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_25962;
																																																																									obj_t
																																																																										BgL_bodyz00_25961;
																																																																									obj_t
																																																																										BgL_varsz00_25960;
																																																																									BgL_varsz00_25960
																																																																										=
																																																																										BgL_arg6187z00_7737;
																																																																									BgL_bodyz00_25961
																																																																										=
																																																																										BgL_arg6188z00_7738;
																																																																									BgL_argsz00_25962
																																																																										=
																																																																										BgL_arg6189z00_7739;
																																																																									BgL_argsz00_1790
																																																																										=
																																																																										BgL_argsz00_25962;
																																																																									BgL_bodyz00_1789
																																																																										=
																																																																										BgL_bodyz00_25961;
																																																																									BgL_varsz00_1788
																																																																										=
																																																																										BgL_varsz00_25960;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1791;
																																																																								}
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_25959);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250271zd2_7742;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12445;
																																																																					BgL_pairz00_12445
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd250271zd2_7742
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12445);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg6192z00_7743;
																																																																					obj_t
																																																																						BgL_arg6193z00_7744;
																																																																					obj_t
																																																																						BgL_arg6194z00_7745;
																																																																					BgL_arg6192z00_7743
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7742));
																																																																					BgL_arg6193z00_7744
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7742));
																																																																					BgL_arg6194z00_7745
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_25973;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_25976;
																																																																							obj_t
																																																																								BgL_bodyz00_25975;
																																																																							obj_t
																																																																								BgL_varsz00_25974;
																																																																							BgL_varsz00_25974
																																																																								=
																																																																								BgL_arg6192z00_7743;
																																																																							BgL_bodyz00_25975
																																																																								=
																																																																								BgL_arg6193z00_7744;
																																																																							BgL_argsz00_25976
																																																																								=
																																																																								BgL_arg6194z00_7745;
																																																																							BgL_argsz00_1790
																																																																								=
																																																																								BgL_argsz00_25976;
																																																																							BgL_bodyz00_1789
																																																																								=
																																																																								BgL_bodyz00_25975;
																																																																							BgL_varsz00_1788
																																																																								=
																																																																								BgL_varsz00_25974;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1791;
																																																																						}
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_25973);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd250297zd2_7747;
																																																																		BgL_cdrzd250297zd2_7747
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd250144zd2_7703));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg6196z00_7748;
																																																																			obj_t
																																																																				BgL_arg6197z00_7749;
																																																																			obj_t
																																																																				BgL_arg6198z00_7750;
																																																																			BgL_arg6196z00_7748
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7747));
																																																																			BgL_arg6197z00_7749
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7747));
																																																																			BgL_arg6198z00_7750
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_25986;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_25989;
																																																																					obj_t
																																																																						BgL_bodyz00_25988;
																																																																					obj_t
																																																																						BgL_varsz00_25987;
																																																																					BgL_varsz00_25987
																																																																						=
																																																																						BgL_arg6196z00_7748;
																																																																					BgL_bodyz00_25988
																																																																						=
																																																																						BgL_arg6197z00_7749;
																																																																					BgL_argsz00_25989
																																																																						=
																																																																						BgL_arg6198z00_7750;
																																																																					BgL_argsz00_1790
																																																																						=
																																																																						BgL_argsz00_25989;
																																																																					BgL_bodyz00_1789
																																																																						=
																																																																						BgL_bodyz00_25988;
																																																																					BgL_varsz00_1788
																																																																						=
																																																																						BgL_varsz00_25987;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1791;
																																																																				}
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_25986);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd250323zd2_7752;
																																																																BgL_cdrzd250323zd2_7752
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd250144zd2_7703));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg6200z00_7753;
																																																																	obj_t
																																																																		BgL_arg6201z00_7754;
																																																																	obj_t
																																																																		BgL_arg6202z00_7755;
																																																																	BgL_arg6200z00_7753
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7752));
																																																																	BgL_arg6201z00_7754
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7752));
																																																																	BgL_arg6202z00_7755
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25999;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_26002;
																																																																			obj_t
																																																																				BgL_bodyz00_26001;
																																																																			obj_t
																																																																				BgL_varsz00_26000;
																																																																			BgL_varsz00_26000
																																																																				=
																																																																				BgL_arg6200z00_7753;
																																																																			BgL_bodyz00_26001
																																																																				=
																																																																				BgL_arg6201z00_7754;
																																																																			BgL_argsz00_26002
																																																																				=
																																																																				BgL_arg6202z00_7755;
																																																																			BgL_argsz00_1790
																																																																				=
																																																																				BgL_argsz00_26002;
																																																																			BgL_bodyz00_1789
																																																																				=
																																																																				BgL_bodyz00_26001;
																																																																			BgL_varsz00_1788
																																																																				=
																																																																				BgL_varsz00_26000;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1791;
																																																																		}
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25999);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd250349zd2_7757;
																																																														BgL_cdrzd250349zd2_7757
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd250144zd2_7703));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6204z00_7758;
																																																															obj_t
																																																																BgL_arg6205z00_7759;
																																																															obj_t
																																																																BgL_arg6206z00_7760;
																																																															BgL_arg6204z00_7758
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7757));
																																																															BgL_arg6205z00_7759
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7757));
																																																															BgL_arg6206z00_7760
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26012;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26015;
																																																																	obj_t
																																																																		BgL_bodyz00_26014;
																																																																	obj_t
																																																																		BgL_varsz00_26013;
																																																																	BgL_varsz00_26013
																																																																		=
																																																																		BgL_arg6204z00_7758;
																																																																	BgL_bodyz00_26014
																																																																		=
																																																																		BgL_arg6205z00_7759;
																																																																	BgL_argsz00_26015
																																																																		=
																																																																		BgL_arg6206z00_7760;
																																																																	BgL_argsz00_1790
																																																																		=
																																																																		BgL_argsz00_26015;
																																																																	BgL_bodyz00_1789
																																																																		=
																																																																		BgL_bodyz00_26014;
																																																																	BgL_varsz00_1788
																																																																		=
																																																																		BgL_varsz00_26013;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1791;
																																																																}
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26012);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250375zd2_7763;
																																																												BgL_cdrzd250375zd2_7763
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd250144zd2_7703));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6209z00_7764;
																																																													obj_t
																																																														BgL_arg6210z00_7765;
																																																													obj_t
																																																														BgL_arg6211z00_7766;
																																																													BgL_arg6209z00_7764
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7763));
																																																													BgL_arg6210z00_7765
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7763));
																																																													BgL_arg6211z00_7766
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26025;
																																																														{
																																																															obj_t
																																																																BgL_argsz00_26028;
																																																															obj_t
																																																																BgL_bodyz00_26027;
																																																															obj_t
																																																																BgL_varsz00_26026;
																																																															BgL_varsz00_26026
																																																																=
																																																																BgL_arg6209z00_7764;
																																																															BgL_bodyz00_26027
																																																																=
																																																																BgL_arg6210z00_7765;
																																																															BgL_argsz00_26028
																																																																=
																																																																BgL_arg6211z00_7766;
																																																															BgL_argsz00_1790
																																																																=
																																																																BgL_argsz00_26028;
																																																															BgL_bodyz00_1789
																																																																=
																																																																BgL_bodyz00_26027;
																																																															BgL_varsz00_1788
																																																																=
																																																																BgL_varsz00_26026;
																																																															goto
																																																																BgL_tagzd2386zd2_1791;
																																																														}
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26025);
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26032;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26032);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd250513zd2_7771;
																																																								BgL_cdrzd250513zd2_7771
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd250144zd2_7703));
																																																								if ((CAR(((obj_t) BgL_carzd250144zd2_7703)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd250513zd2_7771))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250518zd2_7775;
																																																												BgL_cdrzd250518zd2_7775
																																																													=
																																																													CDR
																																																													(BgL_cdrzd250513zd2_7771);
																																																												if (PAIRP(BgL_cdrzd250518zd2_7775))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd250522zd2_7777;
																																																														obj_t
																																																															BgL_cdrzd250523zd2_7778;
																																																														BgL_carzd250522zd2_7777
																																																															=
																																																															CAR
																																																															(BgL_cdrzd250518zd2_7775);
																																																														BgL_cdrzd250523zd2_7778
																																																															=
																																																															CDR
																																																															(BgL_cdrzd250518zd2_7775);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250522zd2_7777))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd250523zd2_7778))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd250528zd2_7781;
																																																																		BgL_carzd250528zd2_7781
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd250523zd2_7778);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250528zd2_7781))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250523zd2_7778)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9458z00_26058;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1455z00_7814;
																																																																							BgL_l1455z00_7814
																																																																								=
																																																																								BgL_cdrzd250145zd2_7704;
																																																																						BgL_zc3z04anonymousza36238ze3z87_7815:
																																																																							if (NULLP(BgL_l1455z00_7814))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9458z00_26058
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9460z00_26061;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9461z00_26062;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_26063;
																																																																											BgL_tmpz00_26063
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1455z00_7814));
																																																																											BgL_test9461z00_26062
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_26063);
																																																																										}
																																																																										if (BgL_test9461z00_26062)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9460z00_26061
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9460z00_26061
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9460z00_26061)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1455z00_26067;
																																																																											BgL_l1455z00_26067
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1455z00_7814));
																																																																											BgL_l1455z00_7814
																																																																												=
																																																																												BgL_l1455z00_26067;
																																																																											goto
																																																																												BgL_zc3z04anonymousza36238ze3z87_7815;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9458z00_26058
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9458z00_26058)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6228z00_7797;
																																																																								BgL_arg6228z00_7797
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd250513zd2_7771);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26071;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26075;
																																																																										obj_t
																																																																											BgL_proc2z00_26074;
																																																																										obj_t
																																																																											BgL_proc1z00_26073;
																																																																										obj_t
																																																																											BgL_testz00_26072;
																																																																										BgL_testz00_26072
																																																																											=
																																																																											BgL_arg6228z00_7797;
																																																																										BgL_proc1z00_26073
																																																																											=
																																																																											BgL_carzd250522zd2_7777;
																																																																										BgL_proc2z00_26074
																																																																											=
																																																																											BgL_carzd250528zd2_7781;
																																																																										BgL_argsz00_26075
																																																																											=
																																																																											BgL_cdrzd250145zd2_7704;
																																																																										BgL_argsz00_1795
																																																																											=
																																																																											BgL_argsz00_26075;
																																																																										BgL_proc2z00_1794
																																																																											=
																																																																											BgL_proc2z00_26074;
																																																																										BgL_proc1z00_1793
																																																																											=
																																																																											BgL_proc1z00_26073;
																																																																										BgL_testz00_1792
																																																																											=
																																																																											BgL_testz00_26072;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1796;
																																																																									}
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26071);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250553zd2_7798;
																																																																								BgL_cdrzd250553zd2_7798
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd250561zd2_7799;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12483;
																																																																										BgL_pairz00_12483
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd250561zd2_7799
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12483);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250569zd2_7800;
																																																																										BgL_cdrzd250569zd2_7800
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd250561zd2_7799));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd250576zd2_7801;
																																																																											BgL_carzd250576zd2_7801
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250569zd2_7800));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250576zd2_7801))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd250585zd2_7803;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12487;
																																																																														BgL_pairz00_12487
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd250569zd2_7800));
																																																																														BgL_carzd250585zd2_7803
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12487);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250585zd2_7803))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250553zd2_7798))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg6232z00_7806;
																																																																																	BgL_arg6232z00_7806
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd250561zd2_7799));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_26097;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_26101;
																																																																																			obj_t
																																																																																				BgL_proc2z00_26100;
																																																																																			obj_t
																																																																																				BgL_proc1z00_26099;
																																																																																			obj_t
																																																																																				BgL_testz00_26098;
																																																																																			BgL_testz00_26098
																																																																																				=
																																																																																				BgL_arg6232z00_7806;
																																																																																			BgL_proc1z00_26099
																																																																																				=
																																																																																				BgL_carzd250576zd2_7801;
																																																																																			BgL_proc2z00_26100
																																																																																				=
																																																																																				BgL_carzd250585zd2_7803;
																																																																																			BgL_argsz00_26101
																																																																																				=
																																																																																				BgL_cdrzd250553zd2_7798;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_26101;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_26100;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_26099;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_26098;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_21492
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_26097);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_26105;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_21492
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_26105);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26109;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26109);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26113;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26113);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26117;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26117);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250863zd2_7825;
																																																																				BgL_cdrzd250863zd2_7825
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd250870zd2_7826;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12491;
																																																																						BgL_pairz00_12491
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd250870zd2_7826
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12491);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250877zd2_7827;
																																																																						BgL_cdrzd250877zd2_7827
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250870zd2_7826));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd250883zd2_7828;
																																																																							obj_t
																																																																								BgL_cdrzd250884zd2_7829;
																																																																							BgL_carzd250883zd2_7828
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7827));
																																																																							BgL_cdrzd250884zd2_7829
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7827));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250883zd2_7828))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd250891zd2_7831;
																																																																									BgL_carzd250891zd2_7831
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250884zd2_7829));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250891zd2_7831))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd250884zd2_7829))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250863zd2_7825))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg6247z00_7836;
																																																																															BgL_arg6247z00_7836
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd250870zd2_7826));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_26144;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_26148;
																																																																																	obj_t
																																																																																		BgL_proc2z00_26147;
																																																																																	obj_t
																																																																																		BgL_proc1z00_26146;
																																																																																	obj_t
																																																																																		BgL_testz00_26145;
																																																																																	BgL_testz00_26145
																																																																																		=
																																																																																		BgL_arg6247z00_7836;
																																																																																	BgL_proc1z00_26146
																																																																																		=
																																																																																		BgL_carzd250883zd2_7828;
																																																																																	BgL_proc2z00_26147
																																																																																		=
																																																																																		BgL_carzd250891zd2_7831;
																																																																																	BgL_argsz00_26148
																																																																																		=
																																																																																		BgL_cdrzd250863zd2_7825;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_26148;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_26147;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_26146;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_26145;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_21492
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_26144);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26152;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_21492
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26152);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26156;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26156);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26160;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26160);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26164;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26164);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26168;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26168);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd251224zd2_7844;
																																																																BgL_cdrzd251224zd2_7844
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd251230zd2_7845;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12500;
																																																																		BgL_pairz00_12500
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd251230zd2_7845
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12500);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd251236zd2_7846;
																																																																		BgL_cdrzd251236zd2_7846
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd251230zd2_7845));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd251241zd2_7847;
																																																																			obj_t
																																																																				BgL_cdrzd251242zd2_7848;
																																																																			BgL_carzd251241zd2_7847
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7846));
																																																																			BgL_cdrzd251242zd2_7848
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7846));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251241zd2_7847))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd251242zd2_7848))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd251247zd2_7851;
																																																																							BgL_carzd251247zd2_7851
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd251242zd2_7848);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251247zd2_7851))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd251242zd2_7848)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd251224zd2_7844))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6261z00_7856;
																																																																													BgL_arg6261z00_7856
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd251230zd2_7845));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26195;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26199;
																																																																															obj_t
																																																																																BgL_proc2z00_26198;
																																																																															obj_t
																																																																																BgL_proc1z00_26197;
																																																																															obj_t
																																																																																BgL_testz00_26196;
																																																																															BgL_testz00_26196
																																																																																=
																																																																																BgL_arg6261z00_7856;
																																																																															BgL_proc1z00_26197
																																																																																=
																																																																																BgL_carzd251241zd2_7847;
																																																																															BgL_proc2z00_26198
																																																																																=
																																																																																BgL_carzd251247zd2_7851;
																																																																															BgL_argsz00_26199
																																																																																=
																																																																																BgL_cdrzd251224zd2_7844;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_26199;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_26198;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_26197;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_26196;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26195);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26203;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26203);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26207;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26207);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26211;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26211);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26215;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26215);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26219;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26219);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26223;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26223);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26227;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26227);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26231;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26231);
																																																											}
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd251785zd2_8020;
																																					BgL_cdrzd251785zd2_8020
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd248481zd2_7686
																																							==
																																							CNST_TABLE_REF
																																							(((long) 17))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg6377z00_8022;
																																							obj_t
																																								BgL_arg6378z00_8023;
																																							BgL_arg6377z00_8022
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_8020));
																																							BgL_arg6378z00_8023
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_8020));
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_26242;
																																								{
																																									obj_t
																																										BgL_exprz00_26244;
																																									obj_t
																																										BgL_bindingsz00_26243;
																																									BgL_bindingsz00_26243
																																										=
																																										BgL_arg6377z00_8022;
																																									BgL_exprz00_26244
																																										=
																																										BgL_arg6378z00_8023;
																																									BgL_exprz00_1780
																																										=
																																										BgL_exprz00_26244;
																																									BgL_bindingsz00_1779
																																										=
																																										BgL_bindingsz00_26243;
																																									goto
																																										BgL_tagzd2382zd2_1781;
																																								}
																																								BgL_auxz00_21492
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_26242);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248481zd2_7686)))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6380z00_8025;
																																									obj_t
																																										BgL_arg6381z00_8026;
																																									BgL_arg6380z00_8025
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_8020));
																																									BgL_arg6381z00_8026
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_8020));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_26253;
																																										{
																																											obj_t
																																												BgL_exprz00_26255;
																																											obj_t
																																												BgL_bindingsz00_26254;
																																											BgL_bindingsz00_26254
																																												=
																																												BgL_arg6380z00_8025;
																																											BgL_exprz00_26255
																																												=
																																												BgL_arg6381z00_8026;
																																											BgL_exprz00_1780
																																												=
																																												BgL_exprz00_26255;
																																											BgL_bindingsz00_1779
																																												=
																																												BgL_bindingsz00_26254;
																																											goto
																																												BgL_tagzd2382zd2_1781;
																																										}
																																										BgL_auxz00_21492
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26253);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd248481zd2_7686 == CNST_TABLE_REF(((long) 18))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6383z00_8028;
																																											obj_t
																																												BgL_arg6384z00_8029;
																																											BgL_arg6383z00_8028
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_8020));
																																											BgL_arg6384z00_8029
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_8020));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26264;
																																												{
																																													obj_t
																																														BgL_exprz00_26266;
																																													obj_t
																																														BgL_bindingsz00_26265;
																																													BgL_bindingsz00_26265
																																														=
																																														BgL_arg6383z00_8028;
																																													BgL_exprz00_26266
																																														=
																																														BgL_arg6384z00_8029;
																																													BgL_exprz00_1780
																																														=
																																														BgL_exprz00_26266;
																																													BgL_bindingsz00_1779
																																														=
																																														BgL_bindingsz00_26265;
																																													goto
																																														BgL_tagzd2382zd2_1781;
																																												}
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26264);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26273;
																																													goto
																																														BgL_tagzd2383zd2_1782;
																																													BgL_auxz00_21492
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26273);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd251822zd2_8032;
																																													BgL_carzd251822zd2_8032
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd251822zd2_8032 == CNST_TABLE_REF(((long) 19))))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26280;
																																															goto
																																																BgL_tagzd2384zd2_1783;
																																															BgL_auxz00_21492
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26280);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd251822zd2_8032)))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26285;
																																																	goto
																																																		BgL_tagzd2384zd2_1783;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26285);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26292;
																																																			goto
																																																				BgL_tagzd2389zd2_1802;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26292);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26299;
																																																					goto
																																																						BgL_tagzd2390zd2_1803;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26299);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd251902zd2_8039;
																																																					BgL_cdrzd251902zd2_8039
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg6395z00_8042;
																																																							obj_t
																																																								BgL_arg6396z00_8043;
																																																							BgL_arg6395z00_8042
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_8039));
																																																							BgL_arg6396z00_8043
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_8039));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26312;
																																																								{
																																																									obj_t
																																																										BgL_restz00_26314;
																																																									obj_t
																																																										BgL_effectz00_26313;
																																																									BgL_effectz00_26313
																																																										=
																																																										BgL_arg6395z00_8042;
																																																									BgL_restz00_26314
																																																										=
																																																										BgL_arg6396z00_8043;
																																																									BgL_restz00_1805
																																																										=
																																																										BgL_restz00_26314;
																																																									BgL_effectz00_1804
																																																										=
																																																										BgL_effectz00_26313;
																																																									goto
																																																										BgL_tagzd2391zd2_1806;
																																																								}
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26312);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_26321;
																																																									goto
																																																										BgL_tagzd2392zd2_1807;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_26321);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26328;
																																																											goto
																																																												BgL_tagzd2393zd2_1808;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26328);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6403z00_8051;
																																																													obj_t
																																																														BgL_arg6404z00_8052;
																																																													BgL_arg6403z00_8051
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_8039));
																																																													BgL_arg6404z00_8052
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_8039));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26339;
																																																														{
																																																															obj_t
																																																																BgL_restz00_26341;
																																																															obj_t
																																																																BgL_effectz00_26340;
																																																															BgL_effectz00_26340
																																																																=
																																																																BgL_arg6403z00_8051;
																																																															BgL_restz00_26341
																																																																=
																																																																BgL_arg6404z00_8052;
																																																															BgL_restz00_1810
																																																																=
																																																																BgL_restz00_26341;
																																																															BgL_effectz00_1809
																																																																=
																																																																BgL_effectz00_26340;
																																																															goto
																																																																BgL_tagzd2394zd2_1811;
																																																														}
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26339);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26348;
																																																															goto
																																																																BgL_tagzd2395zd2_1812;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26348);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26355;
																																																																	goto
																																																																		BgL_tagzd2396zd2_1813;
																																																																	BgL_auxz00_21492
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26355);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																		{
																																																																			BgL_letzd2funzd2_bglt
																																																																				BgL_auxz00_26362;
																																																																			goto
																																																																				BgL_tagzd2397zd2_1814;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26362);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																				{
																																																																					BgL_jumpzd2exzd2itz00_bglt
																																																																						BgL_auxz00_26369;
																																																																					goto
																																																																						BgL_tagzd2398zd2_1815;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26369);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd251979zd2_8061;
																																																																					BgL_cdrzd251979zd2_8061
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6415z00_8064;
																																																																							obj_t
																																																																								BgL_arg6416z00_8065;
																																																																							BgL_arg6415z00_8064
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8061));
																																																																							BgL_arg6416z00_8065
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8061));
																																																																							{	/* Ast/sexp.scm 555 */
																																																																								obj_t
																																																																									BgL_arg7023z00_12537;
																																																																								BgL_arg7023z00_12537
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																										BgL_arg6415z00_8064,
																																																																										CNST_TABLE_REF
																																																																										(((long) 4)), BgL_arg6416z00_8065, BgL_stackz00_22, BgL_arg7023z00_12537, BgL_sitez00_24));
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26388;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26388);
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_carzd252004zd2_8081;

																									BgL_carzd252004zd2_8081 =
																										CAR(
																										((obj_t) BgL_expz00_21));
																									if (
																										(BgL_carzd252004zd2_8081 ==
																											CNST_TABLE_REF(((long)
																													1))))
																										{
																											BgL_nodez00_bglt
																												BgL_auxz00_26395;
																											goto
																												BgL_tagzd2377zd2_1770;
																											BgL_auxz00_21492 =
																												((obj_t)
																												BgL_auxz00_26395);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											if (
																												(BgL_carzd252004zd2_8081
																													==
																													BGl_za2ifza2z00zzast_sexpz00))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26399;
																													goto
																														BgL_tagzd2377zd2_1770;
																													BgL_auxz00_21492 =
																														((obj_t)
																														BgL_auxz00_26399);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(
																																((obj_t)
																																	BgL_expz00_21))
																															==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26406;
																															goto
																																BgL_tagzd2379zd2_1774;
																															BgL_auxz00_21492 =
																																((obj_t)
																																BgL_auxz00_26406);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26413;
																																	goto
																																		BgL_tagzd2380zd2_1775;
																																	BgL_auxz00_21492
																																		=
																																		((obj_t)
																																		BgL_auxz00_26413);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd252073zd2_8088;
																																	BgL_carzd252073zd2_8088
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (PAIRP
																																		(BgL_carzd252073zd2_8088))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd252076zd2_8090;
																																			obj_t
																																				BgL_cdrzd252077zd2_8091;
																																			BgL_carzd252076zd2_8090
																																				=
																																				CAR
																																				(BgL_carzd252073zd2_8088);
																																			BgL_cdrzd252077zd2_8091
																																				=
																																				CDR
																																				(BgL_carzd252073zd2_8088);
																																			{

																																				if (
																																					(BgL_carzd252076zd2_8090
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{	/* Ast/sexp.scm 119 */
																																					BgL_kapzd252078zd2_8092:
																																						if (PAIRP(BgL_cdrzd252077zd2_8091))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd252081zd2_8211;
																																								BgL_cdrzd252081zd2_8211
																																									=
																																									CDR
																																									(BgL_cdrzd252077zd2_8091);
																																								if (PAIRP(BgL_cdrzd252081zd2_8211))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd252081zd2_8211)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6518z00_8215;
																																												obj_t
																																													BgL_arg6519z00_8216;
																																												BgL_arg6518z00_8215
																																													=
																																													CAR
																																													(BgL_cdrzd252081zd2_8211);
																																												BgL_arg6519z00_8216
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26435;
																																													{
																																														obj_t
																																															BgL_argsz00_26437;
																																														obj_t
																																															BgL_bodyz00_26436;
																																														BgL_bodyz00_26436
																																															=
																																															BgL_arg6518z00_8215;
																																														BgL_argsz00_26437
																																															=
																																															BgL_arg6519z00_8216;
																																														BgL_argsz00_1777
																																															=
																																															BgL_argsz00_26437;
																																														BgL_bodyz00_1776
																																															=
																																															BgL_bodyz00_26436;
																																														goto
																																															BgL_tagzd2381zd2_1778;
																																													}
																																													BgL_auxz00_21492
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26435);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9518z00_26439;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6583z00_8322;
																																													BgL_arg6583z00_8322
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9518z00_26439
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg6583z00_8322));
																																												}
																																												if (BgL_test9518z00_26439)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_26444;
																																														goto
																																															BgL_tagzd2384zd2_1783;
																																														BgL_auxz00_21492
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26444);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd252159zd2_8219;
																																														BgL_carzd252159zd2_8219
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd252164zd2_8220;
																																															BgL_cdrzd252164zd2_8220
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd252159zd2_8219));
																																															if ((CAR(((obj_t) BgL_carzd252159zd2_8219)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6524z00_8223;
																																																	obj_t
																																																		BgL_arg6525z00_8224;
																																																	obj_t
																																																		BgL_arg6526z00_8225;
																																																	BgL_arg6524z00_8223
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8220));
																																																	BgL_arg6525z00_8224
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8220));
																																																	BgL_arg6526z00_8225
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26461;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_26464;
																																																			obj_t
																																																				BgL_bodyz00_26463;
																																																			obj_t
																																																				BgL_varsz00_26462;
																																																			BgL_varsz00_26462
																																																				=
																																																				BgL_arg6524z00_8223;
																																																			BgL_bodyz00_26463
																																																				=
																																																				BgL_arg6525z00_8224;
																																																			BgL_argsz00_26464
																																																				=
																																																				BgL_arg6526z00_8225;
																																																			BgL_argsz00_1790
																																																				=
																																																				BgL_argsz00_26464;
																																																			BgL_bodyz00_1789
																																																				=
																																																				BgL_bodyz00_26463;
																																																			BgL_varsz00_1788
																																																				=
																																																				BgL_varsz00_26462;
																																																			goto
																																																				BgL_tagzd2386zd2_1791;
																																																		}
																																																		BgL_auxz00_21492
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26461);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd252187zd2_8227;
																																																	BgL_cdrzd252187zd2_8227
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd252193zd2_8228;
																																																		BgL_cdrzd252193zd2_8228
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd252159zd2_8219));
																																																		if ((CAR(((obj_t) BgL_carzd252159zd2_8219)) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd252199zd2_8231;
																																																				BgL_cdrzd252199zd2_8231
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd252193zd2_8228));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd252204zd2_8232;
																																																					obj_t
																																																						BgL_cdrzd252205zd2_8233;
																																																					BgL_carzd252204zd2_8232
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8231));
																																																					BgL_cdrzd252205zd2_8233
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8231));
																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252204zd2_8232))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd252205zd2_8233))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd252212zd2_8236;
																																																									BgL_carzd252212zd2_8236
																																																										=
																																																										CAR
																																																										(BgL_cdrzd252205zd2_8233);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252212zd2_8236))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_cdrzd252205zd2_8233)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test9525z00_26491;
																																																													{
																																																														obj_t
																																																															BgL_l1458z00_8269;
																																																														BgL_l1458z00_8269
																																																															=
																																																															BgL_cdrzd252187zd2_8227;
																																																													BgL_zc3z04anonymousza36549ze3z87_8270:
																																																														if (NULLP(BgL_l1458z00_8269))
																																																															{	/* Ast/sexp.scm 119 */
																																																																BgL_test9525z00_26491
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																bool_t
																																																																	BgL_test9527z00_26494;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test9528z00_26495;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_tmpz00_26496;
																																																																		BgL_tmpz00_26496
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_l1458z00_8269));
																																																																		BgL_test9528z00_26495
																																																																			=
																																																																			PAIRP
																																																																			(BgL_tmpz00_26496);
																																																																	}
																																																																	if (BgL_test9528z00_26495)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test9527z00_26494
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test9527z00_26494
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																}
																																																																if (BgL_test9527z00_26494)
																																																																	{
																																																																		obj_t
																																																																			BgL_l1458z00_26500;
																																																																		BgL_l1458z00_26500
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_l1458z00_8269));
																																																																		BgL_l1458z00_8269
																																																																			=
																																																																			BgL_l1458z00_26500;
																																																																		goto
																																																																			BgL_zc3z04anonymousza36549ze3z87_8270;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test9525z00_26491
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																													}
																																																													if (BgL_test9525z00_26491)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6539z00_8252;
																																																															BgL_arg6539z00_8252
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd252193zd2_8228));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26505;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26509;
																																																																	obj_t
																																																																		BgL_proc2z00_26508;
																																																																	obj_t
																																																																		BgL_proc1z00_26507;
																																																																	obj_t
																																																																		BgL_testz00_26506;
																																																																	BgL_testz00_26506
																																																																		=
																																																																		BgL_arg6539z00_8252;
																																																																	BgL_proc1z00_26507
																																																																		=
																																																																		BgL_carzd252204zd2_8232;
																																																																	BgL_proc2z00_26508
																																																																		=
																																																																		BgL_carzd252212zd2_8236;
																																																																	BgL_argsz00_26509
																																																																		=
																																																																		BgL_cdrzd252187zd2_8227;
																																																																	BgL_argsz00_1795
																																																																		=
																																																																		BgL_argsz00_26509;
																																																																	BgL_proc2z00_1794
																																																																		=
																																																																		BgL_proc2z00_26508;
																																																																	BgL_proc1z00_1793
																																																																		=
																																																																		BgL_proc1z00_26507;
																																																																	BgL_testz00_1792
																																																																		=
																																																																		BgL_testz00_26506;
																																																																	goto
																																																																		BgL_tagzd2387zd2_1796;
																																																																}
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26505);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd252236zd2_8253;
																																																															BgL_cdrzd252236zd2_8253
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd252243zd2_8254;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_12569;
																																																																	BgL_pairz00_12569
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd252243zd2_8254
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_12569);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd252250zd2_8255;
																																																																	BgL_cdrzd252250zd2_8255
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd252243zd2_8254));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd252256zd2_8256;
																																																																		BgL_carzd252256zd2_8256
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd252250zd2_8255));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252256zd2_8256))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd252263zd2_8258;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12573;
																																																																					BgL_pairz00_12573
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd252250zd2_8255));
																																																																					BgL_carzd252263zd2_8258
																																																																						=
																																																																						CAR
																																																																						(BgL_pairz00_12573);
																																																																				}
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252263zd2_8258))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252236zd2_8253))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6543z00_8261;
																																																																								BgL_arg6543z00_8261
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd252243zd2_8254));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26531;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26535;
																																																																										obj_t
																																																																											BgL_proc2z00_26534;
																																																																										obj_t
																																																																											BgL_proc1z00_26533;
																																																																										obj_t
																																																																											BgL_testz00_26532;
																																																																										BgL_testz00_26532
																																																																											=
																																																																											BgL_arg6543z00_8261;
																																																																										BgL_proc1z00_26533
																																																																											=
																																																																											BgL_carzd252256zd2_8256;
																																																																										BgL_proc2z00_26534
																																																																											=
																																																																											BgL_carzd252263zd2_8258;
																																																																										BgL_argsz00_26535
																																																																											=
																																																																											BgL_cdrzd252236zd2_8253;
																																																																										BgL_argsz00_1800
																																																																											=
																																																																											BgL_argsz00_26535;
																																																																										BgL_proc2z00_1799
																																																																											=
																																																																											BgL_proc2z00_26534;
																																																																										BgL_proc1z00_1798
																																																																											=
																																																																											BgL_proc1z00_26533;
																																																																										BgL_testz00_1797
																																																																											=
																																																																											BgL_testz00_26532;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1801;
																																																																									}
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26531);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26539;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26539);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26543;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26543);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26547;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26547);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26551;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26551);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd252539zd2_8280;
																																																											BgL_cdrzd252539zd2_8280
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd252545zd2_8281;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_12577;
																																																													BgL_pairz00_12577
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd252545zd2_8281
																																																														=
																																																														CDR
																																																														(BgL_pairz00_12577);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd252551zd2_8282;
																																																													BgL_cdrzd252551zd2_8282
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd252545zd2_8281));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252556zd2_8283;
																																																														obj_t
																																																															BgL_cdrzd252557zd2_8284;
																																																														BgL_carzd252556zd2_8283
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8282));
																																																														BgL_cdrzd252557zd2_8284
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8282));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252556zd2_8283))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd252562zd2_8286;
																																																																BgL_carzd252562zd2_8286
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd252557zd2_8284));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252562zd2_8286))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd252557zd2_8284))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252539zd2_8280))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg6558z00_8291;
																																																																						BgL_arg6558z00_8291
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd252545zd2_8281));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26578;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_26582;
																																																																								obj_t
																																																																									BgL_proc2z00_26581;
																																																																								obj_t
																																																																									BgL_proc1z00_26580;
																																																																								obj_t
																																																																									BgL_testz00_26579;
																																																																								BgL_testz00_26579
																																																																									=
																																																																									BgL_arg6558z00_8291;
																																																																								BgL_proc1z00_26580
																																																																									=
																																																																									BgL_carzd252556zd2_8283;
																																																																								BgL_proc2z00_26581
																																																																									=
																																																																									BgL_carzd252562zd2_8286;
																																																																								BgL_argsz00_26582
																																																																									=
																																																																									BgL_cdrzd252539zd2_8280;
																																																																								BgL_argsz00_1800
																																																																									=
																																																																									BgL_argsz00_26582;
																																																																								BgL_proc2z00_1799
																																																																									=
																																																																									BgL_proc2z00_26581;
																																																																								BgL_proc1z00_1798
																																																																									=
																																																																									BgL_proc1z00_26580;
																																																																								BgL_testz00_1797
																																																																									=
																																																																									BgL_testz00_26579;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1801;
																																																																							}
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26578);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26586;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_21492
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26586);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26590;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26590);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26594;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26594);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26598;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26598);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26602;
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																											BgL_auxz00_21492
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26602);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd252895zd2_8299;
																																																							BgL_cdrzd252895zd2_8299
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd252902zd2_8300;
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_pairz00_12586;
																																																									BgL_pairz00_12586
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdrzd252902zd2_8300
																																																										=
																																																										CDR
																																																										(BgL_pairz00_12586);
																																																								}
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd252909zd2_8301;
																																																									BgL_cdrzd252909zd2_8301
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd252902zd2_8300));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd252915zd2_8302;
																																																										obj_t
																																																											BgL_cdrzd252916zd2_8303;
																																																										BgL_carzd252915zd2_8302
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8301));
																																																										BgL_cdrzd252916zd2_8303
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8301));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252915zd2_8302))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd252916zd2_8303))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252923zd2_8306;
																																																														BgL_carzd252923zd2_8306
																																																															=
																																																															CAR
																																																															(BgL_cdrzd252916zd2_8303);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252923zd2_8306))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd252916zd2_8303)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252895zd2_8299))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6572z00_8311;
																																																																				BgL_arg6572z00_8311
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd252902zd2_8300));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26629;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26633;
																																																																						obj_t
																																																																							BgL_proc2z00_26632;
																																																																						obj_t
																																																																							BgL_proc1z00_26631;
																																																																						obj_t
																																																																							BgL_testz00_26630;
																																																																						BgL_testz00_26630
																																																																							=
																																																																							BgL_arg6572z00_8311;
																																																																						BgL_proc1z00_26631
																																																																							=
																																																																							BgL_carzd252915zd2_8302;
																																																																						BgL_proc2z00_26632
																																																																							=
																																																																							BgL_carzd252923zd2_8306;
																																																																						BgL_argsz00_26633
																																																																							=
																																																																							BgL_cdrzd252895zd2_8299;
																																																																						BgL_argsz00_1800
																																																																							=
																																																																							BgL_argsz00_26633;
																																																																						BgL_proc2z00_1799
																																																																							=
																																																																							BgL_proc2z00_26632;
																																																																						BgL_proc1z00_1798
																																																																							=
																																																																							BgL_proc1z00_26631;
																																																																						BgL_testz00_1797
																																																																							=
																																																																							BgL_testz00_26630;
																																																																						goto
																																																																							BgL_tagzd2388zd2_1801;
																																																																					}
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26629);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26637;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_21492
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26637);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26641;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26641);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26645;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_21492
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26645);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26649;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26649);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26653;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_21492
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26653);
																																																													}
																																																											}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1825;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26657;
																																																						goto
																																																							BgL_tagzd2404zd2_1826;
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26657);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9556z00_26659;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6594z00_8335;
																																											BgL_arg6594z00_8335
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9556z00_26659
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg6594z00_8335));
																																										}
																																										if (BgL_test9556z00_26659)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_26664;
																																												goto
																																													BgL_tagzd2384zd2_1783;
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26664);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_carzd253369zd2_8326;
																																												BgL_carzd253369zd2_8326
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd253374zd2_8327;
																																													BgL_cdrzd253374zd2_8327
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_carzd253369zd2_8326));
																																													if ((CAR(((obj_t) BgL_carzd253369zd2_8326)) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6589z00_8330;
																																															obj_t
																																																BgL_arg6590z00_8331;
																																															obj_t
																																																BgL_arg6591z00_8332;
																																															BgL_arg6589z00_8330
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8327));
																																															BgL_arg6590z00_8331
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8327));
																																															BgL_arg6591z00_8332
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_26681;
																																																{
																																																	obj_t
																																																		BgL_argsz00_26684;
																																																	obj_t
																																																		BgL_bodyz00_26683;
																																																	obj_t
																																																		BgL_varsz00_26682;
																																																	BgL_varsz00_26682
																																																		=
																																																		BgL_arg6589z00_8330;
																																																	BgL_bodyz00_26683
																																																		=
																																																		BgL_arg6590z00_8331;
																																																	BgL_argsz00_26684
																																																		=
																																																		BgL_arg6591z00_8332;
																																																	BgL_argsz00_1790
																																																		=
																																																		BgL_argsz00_26684;
																																																	BgL_bodyz00_1789
																																																		=
																																																		BgL_bodyz00_26683;
																																																	BgL_varsz00_1788
																																																		=
																																																		BgL_varsz00_26682;
																																																	goto
																																																		BgL_tagzd2386zd2_1791;
																																																}
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26681);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1825;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26688;
																																																	goto
																																																		BgL_tagzd2404zd2_1826;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26688);
																																																}
																																														}
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test9559z00_26690;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6598z00_8339;
																																									BgL_arg6598z00_8339
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test9559z00_26690
																																										=
																																										CBOOL
																																										(BGl_labelszd2symzf3z21zzast_labelsz00
																																										(BgL_arg6598z00_8339));
																																								}
																																								if (BgL_test9559z00_26690)
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_26695;
																																										goto
																																											BgL_tagzd2384zd2_1783;
																																										BgL_auxz00_21492
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26695);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd2403zd2_1825;
																																											}
																																										else
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26699;
																																												goto
																																													BgL_tagzd2404zd2_1826;
																																												BgL_auxz00_21492
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26699);
																																											}
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd252076zd2_8090)))
																																							{	/* Ast/sexp.scm 119 */
																																								goto
																																									BgL_kapzd252078zd2_8092;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd252076zd2_8090 == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd252078zd2_8092;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd252076zd2_8090 == CNST_TABLE_REF(((long) 19))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd252078zd2_8092;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd252076zd2_8090)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd252078zd2_8092;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9565z00_26713;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6513z00_8209;
																																															BgL_arg6513z00_8209
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9565z00_26713
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg6513z00_8209));
																																														}
																																														if (BgL_test9565z00_26713)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_26718;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_21492
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26718);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd253697zd2_8100;
																																																BgL_carzd253697zd2_8100
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd253702zd2_8101;
																																																	BgL_cdrzd253702zd2_8101
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd253697zd2_8100));
																																																	if ((CAR(((obj_t) BgL_carzd253697zd2_8100)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd253702zd2_8101))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg6449z00_8105;
																																																					obj_t
																																																						BgL_arg6450z00_8106;
																																																					obj_t
																																																						BgL_arg6451z00_8107;
																																																					BgL_arg6449z00_8105
																																																						=
																																																						CAR
																																																						(BgL_cdrzd253702zd2_8101);
																																																					BgL_arg6450z00_8106
																																																						=
																																																						CDR
																																																						(BgL_cdrzd253702zd2_8101);
																																																					BgL_arg6451z00_8107
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26735;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_26738;
																																																							obj_t
																																																								BgL_bodyz00_26737;
																																																							obj_t
																																																								BgL_varsz00_26736;
																																																							BgL_varsz00_26736
																																																								=
																																																								BgL_arg6449z00_8105;
																																																							BgL_bodyz00_26737
																																																								=
																																																								BgL_arg6450z00_8106;
																																																							BgL_argsz00_26738
																																																								=
																																																								BgL_arg6451z00_8107;
																																																							BgL_argsz00_1790
																																																								=
																																																								BgL_argsz00_26738;
																																																							BgL_bodyz00_1789
																																																								=
																																																								BgL_bodyz00_26737;
																																																							BgL_varsz00_1788
																																																								=
																																																								BgL_varsz00_26736;
																																																							goto
																																																								BgL_tagzd2386zd2_1791;
																																																						}
																																																						BgL_auxz00_21492
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26735);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1825;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_26742;
																																																							goto
																																																								BgL_tagzd2404zd2_1826;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_26742);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd253809zd2_8110;
																																																			BgL_cdrzd253809zd2_8110
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd253814zd2_8111;
																																																				BgL_cdrzd253814zd2_8111
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd253697zd2_8100));
																																																				if ((CAR(((obj_t) BgL_carzd253697zd2_8100)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (PAIRP(BgL_cdrzd253814zd2_8111))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd253819zd2_8115;
																																																								BgL_cdrzd253819zd2_8115
																																																									=
																																																									CDR
																																																									(BgL_cdrzd253814zd2_8111);
																																																								if (PAIRP(BgL_cdrzd253819zd2_8115))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd253823zd2_8117;
																																																										obj_t
																																																											BgL_cdrzd253824zd2_8118;
																																																										BgL_carzd253823zd2_8117
																																																											=
																																																											CAR
																																																											(BgL_cdrzd253819zd2_8115);
																																																										BgL_cdrzd253824zd2_8118
																																																											=
																																																											CDR
																																																											(BgL_cdrzd253819zd2_8115);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253823zd2_8117))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd253824zd2_8118))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd253829zd2_8121;
																																																														BgL_carzd253829zd2_8121
																																																															=
																																																															CAR
																																																															(BgL_cdrzd253824zd2_8118);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253829zd2_8121))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd253824zd2_8118)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test9576z00_26770;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1461z00_8154;
																																																																			BgL_l1461z00_8154
																																																																				=
																																																																				BgL_cdrzd253809zd2_8110;
																																																																		BgL_zc3z04anonymousza36477ze3z87_8155:
																																																																			if (NULLP(BgL_l1461z00_8154))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9576z00_26770
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9578z00_26773;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9579z00_26774;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_26775;
																																																																							BgL_tmpz00_26775
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1461z00_8154));
																																																																							BgL_test9579z00_26774
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_26775);
																																																																						}
																																																																						if (BgL_test9579z00_26774)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9578z00_26773
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9578z00_26773
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test9578z00_26773)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1461z00_26779;
																																																																							BgL_l1461z00_26779
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1461z00_8154));
																																																																							BgL_l1461z00_8154
																																																																								=
																																																																								BgL_l1461z00_26779;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36477ze3z87_8155;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9576z00_26770
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test9576z00_26770)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6467z00_8137;
																																																																				BgL_arg6467z00_8137
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd253814zd2_8111);
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26783;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26787;
																																																																						obj_t
																																																																							BgL_proc2z00_26786;
																																																																						obj_t
																																																																							BgL_proc1z00_26785;
																																																																						obj_t
																																																																							BgL_testz00_26784;
																																																																						BgL_testz00_26784
																																																																							=
																																																																							BgL_arg6467z00_8137;
																																																																						BgL_proc1z00_26785
																																																																							=
																																																																							BgL_carzd253823zd2_8117;
																																																																						BgL_proc2z00_26786
																																																																							=
																																																																							BgL_carzd253829zd2_8121;
																																																																						BgL_argsz00_26787
																																																																							=
																																																																							BgL_cdrzd253809zd2_8110;
																																																																						BgL_argsz00_1795
																																																																							=
																																																																							BgL_argsz00_26787;
																																																																						BgL_proc2z00_1794
																																																																							=
																																																																							BgL_proc2z00_26786;
																																																																						BgL_proc1z00_1793
																																																																							=
																																																																							BgL_proc1z00_26785;
																																																																						BgL_testz00_1792
																																																																							=
																																																																							BgL_testz00_26784;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1796;
																																																																					}
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26783);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd253854zd2_8138;
																																																																				BgL_cdrzd253854zd2_8138
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd253862zd2_8139;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12622;
																																																																						BgL_pairz00_12622
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd253862zd2_8139
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12622);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd253870zd2_8140;
																																																																						BgL_cdrzd253870zd2_8140
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd253862zd2_8139));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd253877zd2_8141;
																																																																							BgL_carzd253877zd2_8141
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd253870zd2_8140));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253877zd2_8141))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd253886zd2_8143;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12626;
																																																																										BgL_pairz00_12626
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd253870zd2_8140));
																																																																										BgL_carzd253886zd2_8143
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12626);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253886zd2_8143))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd253854zd2_8138))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6471z00_8146;
																																																																													BgL_arg6471z00_8146
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd253862zd2_8139));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26809;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26813;
																																																																															obj_t
																																																																																BgL_proc2z00_26812;
																																																																															obj_t
																																																																																BgL_proc1z00_26811;
																																																																															obj_t
																																																																																BgL_testz00_26810;
																																																																															BgL_testz00_26810
																																																																																=
																																																																																BgL_arg6471z00_8146;
																																																																															BgL_proc1z00_26811
																																																																																=
																																																																																BgL_carzd253877zd2_8141;
																																																																															BgL_proc2z00_26812
																																																																																=
																																																																																BgL_carzd253886zd2_8143;
																																																																															BgL_argsz00_26813
																																																																																=
																																																																																BgL_cdrzd253854zd2_8138;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_26813;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_26812;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_26811;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_26810;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_21492
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26809);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26817;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_21492
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26817);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26821;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26821);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26825;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26825);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26829;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_21492
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26829);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd254164zd2_8165;
																																																																BgL_cdrzd254164zd2_8165
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd254171zd2_8166;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12630;
																																																																		BgL_pairz00_12630
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd254171zd2_8166
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12630);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd254178zd2_8167;
																																																																		BgL_cdrzd254178zd2_8167
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd254171zd2_8166));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254184zd2_8168;
																																																																			obj_t
																																																																				BgL_cdrzd254185zd2_8169;
																																																																			BgL_carzd254184zd2_8168
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8167));
																																																																			BgL_cdrzd254185zd2_8169
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8167));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254184zd2_8168))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd254192zd2_8171;
																																																																					BgL_carzd254192zd2_8171
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd254185zd2_8169));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254192zd2_8171))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd254185zd2_8169))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254164zd2_8165))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6486z00_8176;
																																																																											BgL_arg6486z00_8176
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd254171zd2_8166));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26856;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26860;
																																																																													obj_t
																																																																														BgL_proc2z00_26859;
																																																																													obj_t
																																																																														BgL_proc1z00_26858;
																																																																													obj_t
																																																																														BgL_testz00_26857;
																																																																													BgL_testz00_26857
																																																																														=
																																																																														BgL_arg6486z00_8176;
																																																																													BgL_proc1z00_26858
																																																																														=
																																																																														BgL_carzd254184zd2_8168;
																																																																													BgL_proc2z00_26859
																																																																														=
																																																																														BgL_carzd254192zd2_8171;
																																																																													BgL_argsz00_26860
																																																																														=
																																																																														BgL_cdrzd254164zd2_8165;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_26860;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_26859;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_26858;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_26857;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																												BgL_auxz00_21492
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26856);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26864;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_21492
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26864);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26868;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26868);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26872;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26872);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26876;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26876);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26880;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_21492
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26880);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd254525zd2_8184;
																																																												BgL_cdrzd254525zd2_8184
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd254531zd2_8185;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_12639;
																																																														BgL_pairz00_12639
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd254531zd2_8185
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12639);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd254537zd2_8186;
																																																														BgL_cdrzd254537zd2_8186
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd254531zd2_8185));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd254542zd2_8187;
																																																															obj_t
																																																																BgL_cdrzd254543zd2_8188;
																																																															BgL_carzd254542zd2_8187
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8186));
																																																															BgL_cdrzd254543zd2_8188
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8186));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254542zd2_8187))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd254543zd2_8188))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254548zd2_8191;
																																																																			BgL_carzd254548zd2_8191
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd254543zd2_8188);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254548zd2_8191))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd254543zd2_8188)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254525zd2_8184))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6500z00_8196;
																																																																									BgL_arg6500z00_8196
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd254531zd2_8185));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26907;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26911;
																																																																											obj_t
																																																																												BgL_proc2z00_26910;
																																																																											obj_t
																																																																												BgL_proc1z00_26909;
																																																																											obj_t
																																																																												BgL_testz00_26908;
																																																																											BgL_testz00_26908
																																																																												=
																																																																												BgL_arg6500z00_8196;
																																																																											BgL_proc1z00_26909
																																																																												=
																																																																												BgL_carzd254542zd2_8187;
																																																																											BgL_proc2z00_26910
																																																																												=
																																																																												BgL_carzd254548zd2_8191;
																																																																											BgL_argsz00_26911
																																																																												=
																																																																												BgL_cdrzd254525zd2_8184;
																																																																											BgL_argsz00_1800
																																																																												=
																																																																												BgL_argsz00_26911;
																																																																											BgL_proc2z00_1799
																																																																												=
																																																																												BgL_proc2z00_26910;
																																																																											BgL_proc1z00_1798
																																																																												=
																																																																												BgL_proc1z00_26909;
																																																																											BgL_testz00_1797
																																																																												=
																																																																												BgL_testz00_26908;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1801;
																																																																										}
																																																																										BgL_auxz00_21492
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26907);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26915;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_21492
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26915);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26919;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_21492
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26919);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26923;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_21492
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26923);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26927;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																					BgL_auxz00_21492
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26927);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26931;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_21492
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26931);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26935;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_21492
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26935);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_26939;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_21492
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_26939);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1825;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26943;
																																																								goto
																																																									BgL_tagzd2404zd2_1826;
																																																								BgL_auxz00_21492
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26943);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd252073zd2_8088
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_26948;
																																					goto
																																						BgL_tagzd2383zd2_1782;
																																					BgL_auxz00_21492
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_26948);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd255110zd2_8342;
																																					BgL_carzd255110zd2_8342
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd255110zd2_8342
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_26955;
																																							goto
																																								BgL_tagzd2384zd2_1783;
																																							BgL_auxz00_21492
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_26955);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255110zd2_8342)))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_26960;
																																									goto
																																										BgL_tagzd2384zd2_1783;
																																									BgL_auxz00_21492
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_26960);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_26967;
																																											goto
																																												BgL_tagzd2389zd2_1802;
																																											BgL_auxz00_21492
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_26967);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26974;
																																													goto
																																														BgL_tagzd2390zd2_1803;
																																													BgL_auxz00_21492
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26974);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_26981;
																																															goto
																																																BgL_tagzd2392zd2_1807;
																																															BgL_auxz00_21492
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26981);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26988;
																																																	goto
																																																		BgL_tagzd2393zd2_1808;
																																																	BgL_auxz00_21492
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26988);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26995;
																																																			goto
																																																				BgL_tagzd2395zd2_1812;
																																																			BgL_auxz00_21492
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26995);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27002;
																																																					goto
																																																						BgL_tagzd2396zd2_1813;
																																																					BgL_auxz00_21492
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27002);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_27009;
																																																							goto
																																																								BgL_tagzd2397zd2_1814;
																																																							BgL_auxz00_21492
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27009);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																								{
																																																									BgL_jumpzd2exzd2itz00_bglt
																																																										BgL_auxz00_27016;
																																																									goto
																																																										BgL_tagzd2398zd2_1815;
																																																									BgL_auxz00_21492
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_27016);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27026;
																																																													goto
																																																														BgL_tagzd2402zd2_1824;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27026);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27030;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_21492
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27030);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27034;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_21492
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27034);
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_21492);
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							if (
																								(BgL_carzd231447zd2_5129 ==
																									BGl_za2ifza2z00zzast_sexpz00))
																								{
																									obj_t BgL_auxz00_27039;

																									goto BgL_kapzd231449zd2_5131;
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_27039);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									bool_t BgL_test9625z00_27041;

																									{	/* Ast/sexp.scm 119 */
																										obj_t BgL_arg4866z00_5876;

																										BgL_arg4866z00_5876 =
																											CAR(BgL_expz00_21);
																										BgL_test9625z00_27041 =
																											(BgL_arg4866z00_5876 ==
																											BGl_za2ifza2z00zzast_sexpz00);
																									}
																									if (BgL_test9625z00_27041)
																										{	/* Ast/sexp.scm 119 */
																											goto
																												BgL_tagzd2377zd2_1770;
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd255282zd2_5136;
																											BgL_cdrzd255282zd2_5136 =
																												CDR(BgL_expz00_21);
																											if ((CAR(BgL_expz00_21) ==
																													CNST_TABLE_REF(((long)
																															7))))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd255282zd2_5136))
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255285zd2_5140;
																															obj_t
																																BgL_cdrzd255286zd2_5141;
																															BgL_carzd255285zd2_5140
																																=
																																CAR
																																(BgL_cdrzd255282zd2_5136);
																															BgL_cdrzd255286zd2_5141
																																=
																																CDR
																																(BgL_cdrzd255282zd2_5136);
																															if (PAIRP
																																(BgL_carzd255285zd2_5140))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_carzd255285zd2_5140)
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					14))))
																																		{	/* Ast/sexp.scm 119 */
																																			if (PAIRP
																																				(BgL_cdrzd255286zd2_5141))
																																				{	/* Ast/sexp.scm 119 */
																																					if (NULLP(CDR(BgL_cdrzd255286zd2_5141)))
																																						{
																																							obj_t
																																								BgL_valz00_27066;
																																							obj_t
																																								BgL_lz00_27064;
																																							BgL_lz00_27064
																																								=
																																								CDR
																																								(BgL_carzd255285zd2_5140);
																																							BgL_valz00_27066
																																								=
																																								CAR
																																								(BgL_cdrzd255286zd2_5141);
																																							BgL_valz00_1772
																																								=
																																								BgL_valz00_27066;
																																							BgL_lz00_1771
																																								=
																																								BgL_lz00_27064;
																																							goto
																																								BgL_tagzd2378zd2_1773;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1774;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1774;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1774;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1774;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2379zd2_1774;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(BgL_expz00_21)
																															==
																															CNST_TABLE_REF((
																																	(long) 16))))
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2380zd2_1775;
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255411zd2_5154;
																															BgL_carzd255411zd2_5154
																																=
																																CAR
																																(BgL_expz00_21);
																															if (PAIRP
																																(BgL_carzd255411zd2_5154))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd255414zd2_5156;
																																	obj_t
																																		BgL_cdrzd255415zd2_5157;
																																	BgL_carzd255414zd2_5156
																																		=
																																		CAR
																																		(BgL_carzd255411zd2_5154);
																																	BgL_cdrzd255415zd2_5157
																																		=
																																		CDR
																																		(BgL_carzd255411zd2_5154);
																																	{

																																		if (
																																			(BgL_carzd255414zd2_5156
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{
																																				obj_t
																																					BgL_auxz00_27080;
																																			BgL_kapzd255416zd2_5158:
																																				if (PAIRP(BgL_cdrzd255415zd2_5157))
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd255419zd2_5460;
																																						BgL_cdrzd255419zd2_5460
																																							=
																																							CDR
																																							(BgL_cdrzd255415zd2_5157);
																																						if (PAIRP(BgL_cdrzd255419zd2_5460))
																																							{	/* Ast/sexp.scm 119 */
																																								if (NULLP(CDR(BgL_cdrzd255419zd2_5460)))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_arg4563z00_5464;
																																										obj_t
																																											BgL_arg4564z00_5465;
																																										BgL_arg4563z00_5464
																																											=
																																											CAR
																																											(BgL_cdrzd255419zd2_5460);
																																										BgL_arg4564z00_5465
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27092;
																																											{
																																												obj_t
																																													BgL_argsz00_27094;
																																												obj_t
																																													BgL_bodyz00_27093;
																																												BgL_bodyz00_27093
																																													=
																																													BgL_arg4563z00_5464;
																																												BgL_argsz00_27094
																																													=
																																													BgL_arg4564z00_5465;
																																												BgL_argsz00_1777
																																													=
																																													BgL_argsz00_27094;
																																												BgL_bodyz00_1776
																																													=
																																													BgL_bodyz00_27093;
																																												goto
																																													BgL_tagzd2381zd2_1778;
																																											}
																																											BgL_auxz00_27080
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27092);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd255442zd2_5466;
																																										BgL_cdrzd255442zd2_5466
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9638z00_27098;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4631z00_5576;
																																													BgL_arg4631z00_5576
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9638z00_27098
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg4631z00_5576));
																																												}
																																												if (BgL_test9638z00_27098)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd255442zd2_5466))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4633z00_5578;
																																																obj_t
																																																	BgL_arg4634z00_5579;
																																																BgL_arg4633z00_5578
																																																	=
																																																	CAR
																																																	(BgL_cdrzd255442zd2_5466);
																																																BgL_arg4634z00_5579
																																																	=
																																																	CDR
																																																	(BgL_cdrzd255442zd2_5466);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27107;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_27109;
																																																		obj_t
																																																			BgL_bindingsz00_27108;
																																																		BgL_bindingsz00_27108
																																																			=
																																																			BgL_arg4633z00_5578;
																																																		BgL_exprz00_27109
																																																			=
																																																			BgL_arg4634z00_5579;
																																																		BgL_exprz00_1780
																																																			=
																																																			BgL_exprz00_27109;
																																																		BgL_bindingsz00_1779
																																																			=
																																																			BgL_bindingsz00_27108;
																																																		goto
																																																			BgL_tagzd2382zd2_1781;
																																																	}
																																																	BgL_auxz00_27080
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27107);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9640z00_27111;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4698z00_5685;
																																																	BgL_arg4698z00_5685
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9640z00_27111
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4698z00_5685));
																																																}
																																																if (BgL_test9640z00_27111)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27116;
																																																		goto
																																																			BgL_tagzd2384zd2_1783;
																																																		BgL_auxz00_27080
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27116);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd255506zd2_5582;
																																																		BgL_carzd255506zd2_5582
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd255511zd2_5583;
																																																			BgL_cdrzd255511zd2_5583
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd255506zd2_5582));
																																																			if ((CAR(((obj_t) BgL_carzd255506zd2_5582)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg4639z00_5586;
																																																					obj_t
																																																						BgL_arg4640z00_5587;
																																																					obj_t
																																																						BgL_arg4641z00_5588;
																																																					BgL_arg4639z00_5586
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5583));
																																																					BgL_arg4640z00_5587
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5583));
																																																					BgL_arg4641z00_5588
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27133;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27136;
																																																							obj_t
																																																								BgL_bodyz00_27135;
																																																							obj_t
																																																								BgL_varsz00_27134;
																																																							BgL_varsz00_27134
																																																								=
																																																								BgL_arg4639z00_5586;
																																																							BgL_bodyz00_27135
																																																								=
																																																								BgL_arg4640z00_5587;
																																																							BgL_argsz00_27136
																																																								=
																																																								BgL_arg4641z00_5588;
																																																							BgL_argsz00_1790
																																																								=
																																																								BgL_argsz00_27136;
																																																							BgL_bodyz00_1789
																																																								=
																																																								BgL_bodyz00_27135;
																																																							BgL_varsz00_1788
																																																								=
																																																								BgL_varsz00_27134;
																																																							goto
																																																								BgL_tagzd2386zd2_1791;
																																																						}
																																																						BgL_auxz00_27080
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27133);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd255534zd2_5590;
																																																					BgL_cdrzd255534zd2_5590
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd255540zd2_5591;
																																																						BgL_cdrzd255540zd2_5591
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd255506zd2_5582));
																																																						if ((CAR(((obj_t) BgL_carzd255506zd2_5582)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd255546zd2_5594;
																																																								BgL_cdrzd255546zd2_5594
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd255540zd2_5591));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd255551zd2_5595;
																																																									obj_t
																																																										BgL_cdrzd255552zd2_5596;
																																																									BgL_carzd255551zd2_5595
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5594));
																																																									BgL_cdrzd255552zd2_5596
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5594));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255551zd2_5595))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd255552zd2_5596))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd255559zd2_5599;
																																																													BgL_carzd255559zd2_5599
																																																														=
																																																														CAR
																																																														(BgL_cdrzd255552zd2_5596);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255559zd2_5599))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd255552zd2_5596)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test9647z00_27163;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1464z00_5632;
																																																																		BgL_l1464z00_5632
																																																																			=
																																																																			BgL_cdrzd255534zd2_5590;
																																																																	BgL_zc3z04anonymousza34664ze3z87_5633:
																																																																		if (NULLP(BgL_l1464z00_5632))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test9647z00_27163
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9649z00_27166;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9650z00_27167;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_27168;
																																																																						BgL_tmpz00_27168
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1464z00_5632));
																																																																						BgL_test9650z00_27167
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_27168);
																																																																					}
																																																																					if (BgL_test9650z00_27167)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9649z00_27166
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9649z00_27166
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test9649z00_27166)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1464z00_27172;
																																																																						BgL_l1464z00_27172
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1464z00_5632));
																																																																						BgL_l1464z00_5632
																																																																							=
																																																																							BgL_l1464z00_27172;
																																																																						goto
																																																																							BgL_zc3z04anonymousza34664ze3z87_5633;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9647z00_27163
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test9647z00_27163)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg4654z00_5615;
																																																																			BgL_arg4654z00_5615
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd255540zd2_5591));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27177;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_27181;
																																																																					obj_t
																																																																						BgL_proc2z00_27180;
																																																																					obj_t
																																																																						BgL_proc1z00_27179;
																																																																					obj_t
																																																																						BgL_testz00_27178;
																																																																					BgL_testz00_27178
																																																																						=
																																																																						BgL_arg4654z00_5615;
																																																																					BgL_proc1z00_27179
																																																																						=
																																																																						BgL_carzd255551zd2_5595;
																																																																					BgL_proc2z00_27180
																																																																						=
																																																																						BgL_carzd255559zd2_5599;
																																																																					BgL_argsz00_27181
																																																																						=
																																																																						BgL_cdrzd255534zd2_5590;
																																																																					BgL_argsz00_1795
																																																																						=
																																																																						BgL_argsz00_27181;
																																																																					BgL_proc2z00_1794
																																																																						=
																																																																						BgL_proc2z00_27180;
																																																																					BgL_proc1z00_1793
																																																																						=
																																																																						BgL_proc1z00_27179;
																																																																					BgL_testz00_1792
																																																																						=
																																																																						BgL_testz00_27178;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1796;
																																																																				}
																																																																				BgL_auxz00_27080
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27177);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd255583zd2_5616;
																																																																			BgL_cdrzd255583zd2_5616
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd255590zd2_5617;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12699;
																																																																					BgL_pairz00_12699
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd255590zd2_5617
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12699);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd255597zd2_5618;
																																																																					BgL_cdrzd255597zd2_5618
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd255590zd2_5617));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd255603zd2_5619;
																																																																						BgL_carzd255603zd2_5619
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd255597zd2_5618));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255603zd2_5619))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd255610zd2_5621;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12703;
																																																																									BgL_pairz00_12703
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd255597zd2_5618));
																																																																									BgL_carzd255610zd2_5621
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_12703);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255610zd2_5621))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255583zd2_5616))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4658z00_5624;
																																																																												BgL_arg4658z00_5624
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd255590zd2_5617));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27203;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_27207;
																																																																														obj_t
																																																																															BgL_proc2z00_27206;
																																																																														obj_t
																																																																															BgL_proc1z00_27205;
																																																																														obj_t
																																																																															BgL_testz00_27204;
																																																																														BgL_testz00_27204
																																																																															=
																																																																															BgL_arg4658z00_5624;
																																																																														BgL_proc1z00_27205
																																																																															=
																																																																															BgL_carzd255603zd2_5619;
																																																																														BgL_proc2z00_27206
																																																																															=
																																																																															BgL_carzd255610zd2_5621;
																																																																														BgL_argsz00_27207
																																																																															=
																																																																															BgL_cdrzd255583zd2_5616;
																																																																														BgL_argsz00_1800
																																																																															=
																																																																															BgL_argsz00_27207;
																																																																														BgL_proc2z00_1799
																																																																															=
																																																																															BgL_proc2z00_27206;
																																																																														BgL_proc1z00_1798
																																																																															=
																																																																															BgL_proc1z00_27205;
																																																																														BgL_testz00_1797
																																																																															=
																																																																															BgL_testz00_27204;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1801;
																																																																													}
																																																																													BgL_auxz00_27080
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27203);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27211;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																														BgL_auxz00_27080
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27211);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27215;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_27080
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27215);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27219;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_27080
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27219);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1825;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27223;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1826;
																																																																			BgL_auxz00_27080
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27223);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd255886zd2_5643;
																																																															BgL_cdrzd255886zd2_5643
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd255892zd2_5644;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_12707;
																																																																	BgL_pairz00_12707
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd255892zd2_5644
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_12707);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd255898zd2_5645;
																																																																	BgL_cdrzd255898zd2_5645
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd255892zd2_5644));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd255903zd2_5646;
																																																																		obj_t
																																																																			BgL_cdrzd255904zd2_5647;
																																																																		BgL_carzd255903zd2_5646
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5645));
																																																																		BgL_cdrzd255904zd2_5647
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5645));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255903zd2_5646))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd255909zd2_5649;
																																																																				BgL_carzd255909zd2_5649
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd255904zd2_5647));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255909zd2_5649))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd255904zd2_5647))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255886zd2_5643))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4673z00_5654;
																																																																										BgL_arg4673z00_5654
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd255892zd2_5644));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27250;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27254;
																																																																												obj_t
																																																																													BgL_proc2z00_27253;
																																																																												obj_t
																																																																													BgL_proc1z00_27252;
																																																																												obj_t
																																																																													BgL_testz00_27251;
																																																																												BgL_testz00_27251
																																																																													=
																																																																													BgL_arg4673z00_5654;
																																																																												BgL_proc1z00_27252
																																																																													=
																																																																													BgL_carzd255903zd2_5646;
																																																																												BgL_proc2z00_27253
																																																																													=
																																																																													BgL_carzd255909zd2_5649;
																																																																												BgL_argsz00_27254
																																																																													=
																																																																													BgL_cdrzd255886zd2_5643;
																																																																												BgL_argsz00_1800
																																																																													=
																																																																													BgL_argsz00_27254;
																																																																												BgL_proc2z00_1799
																																																																													=
																																																																													BgL_proc2z00_27253;
																																																																												BgL_proc1z00_1798
																																																																													=
																																																																													BgL_proc1z00_27252;
																																																																												BgL_testz00_1797
																																																																													=
																																																																													BgL_testz00_27251;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1801;
																																																																											}
																																																																											BgL_auxz00_27080
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27250);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27258;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_27080
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27258);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27262;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_27080
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27262);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27266;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27080
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27266);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27270;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_27080
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27270);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27274;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_27080
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27274);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd256242zd2_5662;
																																																											BgL_cdrzd256242zd2_5662
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd256249zd2_5663;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_12716;
																																																													BgL_pairz00_12716
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd256249zd2_5663
																																																														=
																																																														CDR
																																																														(BgL_pairz00_12716);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd256256zd2_5664;
																																																													BgL_cdrzd256256zd2_5664
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd256249zd2_5663));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd256262zd2_5665;
																																																														obj_t
																																																															BgL_cdrzd256263zd2_5666;
																																																														BgL_carzd256262zd2_5665
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5664));
																																																														BgL_cdrzd256263zd2_5666
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5664));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256262zd2_5665))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd256263zd2_5666))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd256270zd2_5669;
																																																																		BgL_carzd256270zd2_5669
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd256263zd2_5666);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256270zd2_5669))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd256263zd2_5666)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256242zd2_5662))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4687z00_5674;
																																																																								BgL_arg4687z00_5674
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd256249zd2_5663));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27301;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27305;
																																																																										obj_t
																																																																											BgL_proc2z00_27304;
																																																																										obj_t
																																																																											BgL_proc1z00_27303;
																																																																										obj_t
																																																																											BgL_testz00_27302;
																																																																										BgL_testz00_27302
																																																																											=
																																																																											BgL_arg4687z00_5674;
																																																																										BgL_proc1z00_27303
																																																																											=
																																																																											BgL_carzd256262zd2_5665;
																																																																										BgL_proc2z00_27304
																																																																											=
																																																																											BgL_carzd256270zd2_5669;
																																																																										BgL_argsz00_27305
																																																																											=
																																																																											BgL_cdrzd256242zd2_5662;
																																																																										BgL_argsz00_1800
																																																																											=
																																																																											BgL_argsz00_27305;
																																																																										BgL_proc2z00_1799
																																																																											=
																																																																											BgL_proc2z00_27304;
																																																																										BgL_proc1z00_1798
																																																																											=
																																																																											BgL_proc1z00_27303;
																																																																										BgL_testz00_1797
																																																																											=
																																																																											BgL_testz00_27302;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1801;
																																																																									}
																																																																									BgL_auxz00_27080
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27301);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27309;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_27080
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27309);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27313;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27080
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27313);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27317;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_27080
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27317);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27321;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_27080
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27321);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27325;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_27080
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27325);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1825;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27329;
																																																										goto
																																																											BgL_tagzd2404zd2_1826;
																																																										BgL_auxz00_27080
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27329);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9678z00_27331;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4630z00_5575;
																																															BgL_arg4630z00_5575
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9678z00_27331
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4630z00_5575));
																																														}
																																														if (BgL_test9678z00_27331)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27336;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_27080
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27336);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd256702zd2_5472;
																																																BgL_carzd256702zd2_5472
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd256707zd2_5473;
																																																	BgL_cdrzd256707zd2_5473
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd256702zd2_5472));
																																																	if ((CAR(((obj_t) BgL_carzd256702zd2_5472)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4571z00_5476;
																																																			obj_t
																																																				BgL_arg4572z00_5477;
																																																			obj_t
																																																				BgL_arg4573z00_5478;
																																																			BgL_arg4571z00_5476
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5473));
																																																			BgL_arg4572z00_5477
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5473));
																																																			BgL_arg4573z00_5478
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27353;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27356;
																																																					obj_t
																																																						BgL_bodyz00_27355;
																																																					obj_t
																																																						BgL_varsz00_27354;
																																																					BgL_varsz00_27354
																																																						=
																																																						BgL_arg4571z00_5476;
																																																					BgL_bodyz00_27355
																																																						=
																																																						BgL_arg4572z00_5477;
																																																					BgL_argsz00_27356
																																																						=
																																																						BgL_arg4573z00_5478;
																																																					BgL_argsz00_1790
																																																						=
																																																						BgL_argsz00_27356;
																																																					BgL_bodyz00_1789
																																																						=
																																																						BgL_bodyz00_27355;
																																																					BgL_varsz00_1788
																																																						=
																																																						BgL_varsz00_27354;
																																																					goto
																																																						BgL_tagzd2386zd2_1791;
																																																				}
																																																				BgL_auxz00_27080
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27353);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd256730zd2_5480;
																																																			BgL_cdrzd256730zd2_5480
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd256736zd2_5481;
																																																				BgL_cdrzd256736zd2_5481
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd256702zd2_5472));
																																																				if ((CAR(((obj_t) BgL_carzd256702zd2_5472)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd256742zd2_5484;
																																																						BgL_cdrzd256742zd2_5484
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd256736zd2_5481));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd256747zd2_5485;
																																																							obj_t
																																																								BgL_cdrzd256748zd2_5486;
																																																							BgL_carzd256747zd2_5485
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5484));
																																																							BgL_cdrzd256748zd2_5486
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5484));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256747zd2_5485))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd256748zd2_5486))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd256755zd2_5489;
																																																											BgL_carzd256755zd2_5489
																																																												=
																																																												CAR
																																																												(BgL_cdrzd256748zd2_5486);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256755zd2_5489))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd256748zd2_5486)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test9685z00_27383;
																																																															{
																																																																obj_t
																																																																	BgL_l1467z00_5522;
																																																																BgL_l1467z00_5522
																																																																	=
																																																																	BgL_cdrzd256730zd2_5480;
																																																															BgL_zc3z04anonymousza34596ze3z87_5523:
																																																																if (NULLP(BgL_l1467z00_5522))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test9685z00_27383
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test9687z00_27386;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test9688z00_27387;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_27388;
																																																																				BgL_tmpz00_27388
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1467z00_5522));
																																																																				BgL_test9688z00_27387
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_27388);
																																																																			}
																																																																			if (BgL_test9688z00_27387)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9687z00_27386
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9687z00_27386
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test9687z00_27386)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1467z00_27392;
																																																																				BgL_l1467z00_27392
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1467z00_5522));
																																																																				BgL_l1467z00_5522
																																																																					=
																																																																					BgL_l1467z00_27392;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34596ze3z87_5523;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test9685z00_27383
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test9685z00_27383)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4586z00_5505;
																																																																	BgL_arg4586z00_5505
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd256736zd2_5481));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27397;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_27401;
																																																																			obj_t
																																																																				BgL_proc2z00_27400;
																																																																			obj_t
																																																																				BgL_proc1z00_27399;
																																																																			obj_t
																																																																				BgL_testz00_27398;
																																																																			BgL_testz00_27398
																																																																				=
																																																																				BgL_arg4586z00_5505;
																																																																			BgL_proc1z00_27399
																																																																				=
																																																																				BgL_carzd256747zd2_5485;
																																																																			BgL_proc2z00_27400
																																																																				=
																																																																				BgL_carzd256755zd2_5489;
																																																																			BgL_argsz00_27401
																																																																				=
																																																																				BgL_cdrzd256730zd2_5480;
																																																																			BgL_argsz00_1795
																																																																				=
																																																																				BgL_argsz00_27401;
																																																																			BgL_proc2z00_1794
																																																																				=
																																																																				BgL_proc2z00_27400;
																																																																			BgL_proc1z00_1793
																																																																				=
																																																																				BgL_proc1z00_27399;
																																																																			BgL_testz00_1792
																																																																				=
																																																																				BgL_testz00_27398;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1796;
																																																																		}
																																																																		BgL_auxz00_27080
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27397);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd256779zd2_5506;
																																																																	BgL_cdrzd256779zd2_5506
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd256786zd2_5507;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_12745;
																																																																			BgL_pairz00_12745
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd256786zd2_5507
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_12745);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd256793zd2_5508;
																																																																			BgL_cdrzd256793zd2_5508
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd256786zd2_5507));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd256799zd2_5509;
																																																																				BgL_carzd256799zd2_5509
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd256793zd2_5508));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256799zd2_5509))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd256806zd2_5511;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12749;
																																																																							BgL_pairz00_12749
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd256793zd2_5508));
																																																																							BgL_carzd256806zd2_5511
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_12749);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256806zd2_5511))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256779zd2_5506))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4590z00_5514;
																																																																										BgL_arg4590z00_5514
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd256786zd2_5507));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27423;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27427;
																																																																												obj_t
																																																																													BgL_proc2z00_27426;
																																																																												obj_t
																																																																													BgL_proc1z00_27425;
																																																																												obj_t
																																																																													BgL_testz00_27424;
																																																																												BgL_testz00_27424
																																																																													=
																																																																													BgL_arg4590z00_5514;
																																																																												BgL_proc1z00_27425
																																																																													=
																																																																													BgL_carzd256799zd2_5509;
																																																																												BgL_proc2z00_27426
																																																																													=
																																																																													BgL_carzd256806zd2_5511;
																																																																												BgL_argsz00_27427
																																																																													=
																																																																													BgL_cdrzd256779zd2_5506;
																																																																												BgL_argsz00_1800
																																																																													=
																																																																													BgL_argsz00_27427;
																																																																												BgL_proc2z00_1799
																																																																													=
																																																																													BgL_proc2z00_27426;
																																																																												BgL_proc1z00_1798
																																																																													=
																																																																													BgL_proc1z00_27425;
																																																																												BgL_testz00_1797
																																																																													=
																																																																													BgL_testz00_27424;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1801;
																																																																											}
																																																																											BgL_auxz00_27080
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27423);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27431;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																												BgL_auxz00_27080
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27431);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27435;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_27080
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27435);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27439;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27080
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27439);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_27443;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_27080
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_27443);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd257082zd2_5533;
																																																													BgL_cdrzd257082zd2_5533
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd257088zd2_5534;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_12753;
																																																															BgL_pairz00_12753
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd257088zd2_5534
																																																																=
																																																																CDR
																																																																(BgL_pairz00_12753);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd257094zd2_5535;
																																																															BgL_cdrzd257094zd2_5535
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd257088zd2_5534));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257099zd2_5536;
																																																																obj_t
																																																																	BgL_cdrzd257100zd2_5537;
																																																																BgL_carzd257099zd2_5536
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5535));
																																																																BgL_cdrzd257100zd2_5537
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5535));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257099zd2_5536))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd257105zd2_5539;
																																																																		BgL_carzd257105zd2_5539
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd257100zd2_5537));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257105zd2_5539))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd257100zd2_5537))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257082zd2_5533))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4605z00_5544;
																																																																								BgL_arg4605z00_5544
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd257088zd2_5534));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27470;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27474;
																																																																										obj_t
																																																																											BgL_proc2z00_27473;
																																																																										obj_t
																																																																											BgL_proc1z00_27472;
																																																																										obj_t
																																																																											BgL_testz00_27471;
																																																																										BgL_testz00_27471
																																																																											=
																																																																											BgL_arg4605z00_5544;
																																																																										BgL_proc1z00_27472
																																																																											=
																																																																											BgL_carzd257099zd2_5536;
																																																																										BgL_proc2z00_27473
																																																																											=
																																																																											BgL_carzd257105zd2_5539;
																																																																										BgL_argsz00_27474
																																																																											=
																																																																											BgL_cdrzd257082zd2_5533;
																																																																										BgL_argsz00_1800
																																																																											=
																																																																											BgL_argsz00_27474;
																																																																										BgL_proc2z00_1799
																																																																											=
																																																																											BgL_proc2z00_27473;
																																																																										BgL_proc1z00_1798
																																																																											=
																																																																											BgL_proc1z00_27472;
																																																																										BgL_testz00_1797
																																																																											=
																																																																											BgL_testz00_27471;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1801;
																																																																									}
																																																																									BgL_auxz00_27080
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27470);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27478;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																										BgL_auxz00_27080
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27478);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27482;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27080
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27482);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27486;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_27080
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27486);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27490;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_27080
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27490);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27494;
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																													BgL_auxz00_27080
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27494);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd257438zd2_5552;
																																																									BgL_cdrzd257438zd2_5552
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd257445zd2_5553;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_12762;
																																																											BgL_pairz00_12762
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd257445zd2_5553
																																																												=
																																																												CDR
																																																												(BgL_pairz00_12762);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd257452zd2_5554;
																																																											BgL_cdrzd257452zd2_5554
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd257445zd2_5553));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd257458zd2_5555;
																																																												obj_t
																																																													BgL_cdrzd257459zd2_5556;
																																																												BgL_carzd257458zd2_5555
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5554));
																																																												BgL_cdrzd257459zd2_5556
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5554));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257458zd2_5555))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd257459zd2_5556))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257466zd2_5559;
																																																																BgL_carzd257466zd2_5559
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd257459zd2_5556);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257466zd2_5559))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd257459zd2_5556)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257438zd2_5552))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4619z00_5564;
																																																																						BgL_arg4619z00_5564
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd257445zd2_5553));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27521;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_27525;
																																																																								obj_t
																																																																									BgL_proc2z00_27524;
																																																																								obj_t
																																																																									BgL_proc1z00_27523;
																																																																								obj_t
																																																																									BgL_testz00_27522;
																																																																								BgL_testz00_27522
																																																																									=
																																																																									BgL_arg4619z00_5564;
																																																																								BgL_proc1z00_27523
																																																																									=
																																																																									BgL_carzd257458zd2_5555;
																																																																								BgL_proc2z00_27524
																																																																									=
																																																																									BgL_carzd257466zd2_5559;
																																																																								BgL_argsz00_27525
																																																																									=
																																																																									BgL_cdrzd257438zd2_5552;
																																																																								BgL_argsz00_1800
																																																																									=
																																																																									BgL_argsz00_27525;
																																																																								BgL_proc2z00_1799
																																																																									=
																																																																									BgL_proc2z00_27524;
																																																																								BgL_proc1z00_1798
																																																																									=
																																																																									BgL_proc1z00_27523;
																																																																								BgL_testz00_1797
																																																																									=
																																																																									BgL_testz00_27522;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1801;
																																																																							}
																																																																							BgL_auxz00_27080
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27521);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27529;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27080
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27529);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27533;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																						BgL_auxz00_27080
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27533);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27537;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_27080
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27537);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1825;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27541;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1826;
																																																																		BgL_auxz00_27080
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27541);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27545;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_27080
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27545);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1825;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_27549;
																																																								goto
																																																									BgL_tagzd2404zd2_1826;
																																																								BgL_auxz00_27080
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_27549);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd257858zd2_5687;
																																								BgL_cdrzd257858zd2_5687
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9716z00_27553;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4712z00_5703;
																																											BgL_arg4712z00_5703
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9716z00_27553
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg4712z00_5703));
																																										}
																																										if (BgL_test9716z00_27553)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd257858zd2_5687))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4714z00_5705;
																																														obj_t
																																															BgL_arg4715z00_5706;
																																														BgL_arg4714z00_5705
																																															=
																																															CAR
																																															(BgL_cdrzd257858zd2_5687);
																																														BgL_arg4715z00_5706
																																															=
																																															CDR
																																															(BgL_cdrzd257858zd2_5687);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_27562;
																																															{
																																																obj_t
																																																	BgL_exprz00_27564;
																																																obj_t
																																																	BgL_bindingsz00_27563;
																																																BgL_bindingsz00_27563
																																																	=
																																																	BgL_arg4714z00_5705;
																																																BgL_exprz00_27564
																																																	=
																																																	BgL_arg4715z00_5706;
																																																BgL_exprz00_1780
																																																	=
																																																	BgL_exprz00_27564;
																																																BgL_bindingsz00_1779
																																																	=
																																																	BgL_bindingsz00_27563;
																																																goto
																																																	BgL_tagzd2382zd2_1781;
																																															}
																																															BgL_auxz00_27080
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_27562);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9718z00_27566;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4725z00_5718;
																																															BgL_arg4725z00_5718
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9718z00_27566
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4725z00_5718));
																																														}
																																														if (BgL_test9718z00_27566)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27571;
																																																goto
																																																	BgL_tagzd2384zd2_1783;
																																																BgL_auxz00_27080
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27571);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd257921zd2_5709;
																																																BgL_carzd257921zd2_5709
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd257926zd2_5710;
																																																	BgL_cdrzd257926zd2_5710
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd257921zd2_5709));
																																																	if ((CAR(((obj_t) BgL_carzd257921zd2_5709)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4720z00_5713;
																																																			obj_t
																																																				BgL_arg4721z00_5714;
																																																			obj_t
																																																				BgL_arg4722z00_5715;
																																																			BgL_arg4720z00_5713
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5710));
																																																			BgL_arg4721z00_5714
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5710));
																																																			BgL_arg4722z00_5715
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27588;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27591;
																																																					obj_t
																																																						BgL_bodyz00_27590;
																																																					obj_t
																																																						BgL_varsz00_27589;
																																																					BgL_varsz00_27589
																																																						=
																																																						BgL_arg4720z00_5713;
																																																					BgL_bodyz00_27590
																																																						=
																																																						BgL_arg4721z00_5714;
																																																					BgL_argsz00_27591
																																																						=
																																																						BgL_arg4722z00_5715;
																																																					BgL_argsz00_1790
																																																						=
																																																						BgL_argsz00_27591;
																																																					BgL_bodyz00_1789
																																																						=
																																																						BgL_bodyz00_27590;
																																																					BgL_varsz00_1788
																																																						=
																																																						BgL_varsz00_27589;
																																																					goto
																																																						BgL_tagzd2386zd2_1791;
																																																				}
																																																				BgL_auxz00_27080
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27588);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1825;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27595;
																																																					goto
																																																						BgL_tagzd2404zd2_1826;
																																																					BgL_auxz00_27080
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27595);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9721z00_27597;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4711z00_5702;
																																													BgL_arg4711z00_5702
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9721z00_27597
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4711z00_5702));
																																												}
																																												if (BgL_test9721z00_27597)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_27602;
																																														goto
																																															BgL_tagzd2384zd2_1783;
																																														BgL_auxz00_27080
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_27602);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd258075zd2_5693;
																																														BgL_carzd258075zd2_5693
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd258080zd2_5694;
																																															BgL_cdrzd258080zd2_5694
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd258075zd2_5693));
																																															if ((CAR(((obj_t) BgL_carzd258075zd2_5693)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4706z00_5697;
																																																	obj_t
																																																		BgL_arg4707z00_5698;
																																																	obj_t
																																																		BgL_arg4708z00_5699;
																																																	BgL_arg4706z00_5697
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5694));
																																																	BgL_arg4707z00_5698
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5694));
																																																	BgL_arg4708z00_5699
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_27619;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_27622;
																																																			obj_t
																																																				BgL_bodyz00_27621;
																																																			obj_t
																																																				BgL_varsz00_27620;
																																																			BgL_varsz00_27620
																																																				=
																																																				BgL_arg4706z00_5697;
																																																			BgL_bodyz00_27621
																																																				=
																																																				BgL_arg4707z00_5698;
																																																			BgL_argsz00_27622
																																																				=
																																																				BgL_arg4708z00_5699;
																																																			BgL_argsz00_1790
																																																				=
																																																				BgL_argsz00_27622;
																																																			BgL_bodyz00_1789
																																																				=
																																																				BgL_bodyz00_27621;
																																																			BgL_varsz00_1788
																																																				=
																																																				BgL_varsz00_27620;
																																																			goto
																																																				BgL_tagzd2386zd2_1791;
																																																		}
																																																		BgL_auxz00_27080
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27619);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1825;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27626;
																																																			goto
																																																				BgL_tagzd2404zd2_1826;
																																																			BgL_auxz00_27080
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27626);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd258190zd2_5719;
																																						BgL_cdrzd258190zd2_5719
																																							=
																																							CDR
																																							(((obj_t) BgL_expz00_21));
																																						{

																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test9724z00_27630;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4732z00_5727;
																																									BgL_arg4732z00_5727
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test9724z00_27630
																																										=
																																										CBOOL
																																										(BGl_letzd2symzf3z21zzast_letz00
																																										(BgL_arg4732z00_5727));
																																								}
																																								if (BgL_test9724z00_27630)
																																									{	/* Ast/sexp.scm 119 */
																																										if (PAIRP(BgL_cdrzd258190zd2_5719))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg4734z00_5729;
																																												obj_t
																																													BgL_arg4735z00_5730;
																																												BgL_arg4734z00_5729
																																													=
																																													CAR
																																													(BgL_cdrzd258190zd2_5719);
																																												BgL_arg4735z00_5730
																																													=
																																													CDR
																																													(BgL_cdrzd258190zd2_5719);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27639;
																																													{
																																														obj_t
																																															BgL_exprz00_27641;
																																														obj_t
																																															BgL_bindingsz00_27640;
																																														BgL_bindingsz00_27640
																																															=
																																															BgL_arg4734z00_5729;
																																														BgL_exprz00_27641
																																															=
																																															BgL_arg4735z00_5730;
																																														BgL_exprz00_1780
																																															=
																																															BgL_exprz00_27641;
																																														BgL_bindingsz00_1779
																																															=
																																															BgL_bindingsz00_27640;
																																														goto
																																															BgL_tagzd2382zd2_1781;
																																													}
																																													BgL_auxz00_27080
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27639);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9726z00_27643;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4739z00_5734;
																																													BgL_arg4739z00_5734
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9726z00_27643
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4739z00_5734));
																																												}
																																												if (BgL_test9726z00_27643)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_27648;
																																														goto
																																															BgL_tagzd2384zd2_1783;
																																														BgL_auxz00_27080
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_27648);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1825;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_27652;
																																																goto
																																																	BgL_tagzd2404zd2_1826;
																																																BgL_auxz00_27080
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27652);
																																															}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9728z00_27654;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4731z00_5726;
																																											BgL_arg4731z00_5726
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9728z00_27654
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4731z00_5726));
																																										}
																																										if (BgL_test9728z00_27654)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_27659;
																																												goto
																																													BgL_tagzd2384zd2_1783;
																																												BgL_auxz00_27080
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27659);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1825;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_27663;
																																														goto
																																															BgL_tagzd2404zd2_1826;
																																														BgL_auxz00_27080
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_27663);
																																													}
																																											}
																																									}
																																							}
																																						}
																																					}
																																				return
																																					(
																																					(BgL_nodez00_bglt)
																																					BgL_auxz00_27080);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 119 */
																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd255414zd2_5156)))
																																					{
																																						obj_t
																																							BgL_auxz00_27669;
																																						goto
																																							BgL_kapzd255416zd2_5158;
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_27669);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (
																																							(BgL_carzd255414zd2_5156
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{
																																								obj_t
																																									BgL_auxz00_27674;
																																								goto
																																									BgL_kapzd255416zd2_5158;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_27674);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd255414zd2_5156 == CNST_TABLE_REF(((long) 19))))
																																									{
																																										obj_t
																																											BgL_auxz00_27679;
																																										goto
																																											BgL_kapzd255416zd2_5158;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_27679);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255414zd2_5156)))
																																											{
																																												obj_t
																																													BgL_auxz00_27684;
																																												goto
																																													BgL_kapzd255416zd2_5158;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_27684);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd258499zd2_5164;
																																												BgL_cdrzd258499zd2_5164
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9734z00_27687;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4485z00_5343;
																																															BgL_arg4485z00_5343
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_test9734z00_27687
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg4485z00_5343));
																																														}
																																														if (BgL_test9734z00_27687)
																																															{
																																																obj_t
																																																	BgL_auxz00_27691;
																																																if (PAIRP(BgL_cdrzd258499zd2_5164))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4487z00_5345;
																																																		obj_t
																																																			BgL_arg4488z00_5346;
																																																		BgL_arg4487z00_5345
																																																			=
																																																			CAR
																																																			(BgL_cdrzd258499zd2_5164);
																																																		BgL_arg4488z00_5346
																																																			=
																																																			CDR
																																																			(BgL_cdrzd258499zd2_5164);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27696;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_27698;
																																																				obj_t
																																																					BgL_bindingsz00_27697;
																																																				BgL_bindingsz00_27697
																																																					=
																																																					BgL_arg4487z00_5345;
																																																				BgL_exprz00_27698
																																																					=
																																																					BgL_arg4488z00_5346;
																																																				BgL_exprz00_1780
																																																					=
																																																					BgL_exprz00_27698;
																																																				BgL_bindingsz00_1779
																																																					=
																																																					BgL_bindingsz00_27697;
																																																				goto
																																																					BgL_tagzd2382zd2_1781;
																																																			}
																																																			BgL_auxz00_27691
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27696);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test9736z00_27700;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4558z00_5458;
																																																			BgL_arg4558z00_5458
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test9736z00_27700
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg4558z00_5458));
																																																		}
																																																		if (BgL_test9736z00_27700)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_27705;
																																																				goto
																																																					BgL_tagzd2384zd2_1783;
																																																				BgL_auxz00_27691
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27705);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd258562zd2_5349;
																																																				BgL_carzd258562zd2_5349
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd258567zd2_5350;
																																																					BgL_cdrzd258567zd2_5350
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd258562zd2_5349));
																																																					if ((CAR(((obj_t) BgL_carzd258562zd2_5349)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd258567zd2_5350))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4494z00_5354;
																																																									obj_t
																																																										BgL_arg4495z00_5355;
																																																									obj_t
																																																										BgL_arg4496z00_5356;
																																																									BgL_arg4494z00_5354
																																																										=
																																																										CAR
																																																										(BgL_cdrzd258567zd2_5350);
																																																									BgL_arg4495z00_5355
																																																										=
																																																										CDR
																																																										(BgL_cdrzd258567zd2_5350);
																																																									BgL_arg4496z00_5356
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27722;
																																																										{
																																																											obj_t
																																																												BgL_argsz00_27725;
																																																											obj_t
																																																												BgL_bodyz00_27724;
																																																											obj_t
																																																												BgL_varsz00_27723;
																																																											BgL_varsz00_27723
																																																												=
																																																												BgL_arg4494z00_5354;
																																																											BgL_bodyz00_27724
																																																												=
																																																												BgL_arg4495z00_5355;
																																																											BgL_argsz00_27725
																																																												=
																																																												BgL_arg4496z00_5356;
																																																											BgL_argsz00_1790
																																																												=
																																																												BgL_argsz00_27725;
																																																											BgL_bodyz00_1789
																																																												=
																																																												BgL_bodyz00_27724;
																																																											BgL_varsz00_1788
																																																												=
																																																												BgL_varsz00_27723;
																																																											goto
																																																												BgL_tagzd2386zd2_1791;
																																																										}
																																																										BgL_auxz00_27691
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27722);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_27729;
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																											BgL_auxz00_27691
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_27729);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd258674zd2_5359;
																																																							BgL_cdrzd258674zd2_5359
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd258679zd2_5360;
																																																								BgL_cdrzd258679zd2_5360
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd258562zd2_5349));
																																																								if ((CAR(((obj_t) BgL_carzd258562zd2_5349)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd258679zd2_5360))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd258684zd2_5364;
																																																												BgL_cdrzd258684zd2_5364
																																																													=
																																																													CDR
																																																													(BgL_cdrzd258679zd2_5360);
																																																												if (PAIRP(BgL_cdrzd258684zd2_5364))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd258688zd2_5366;
																																																														obj_t
																																																															BgL_cdrzd258689zd2_5367;
																																																														BgL_carzd258688zd2_5366
																																																															=
																																																															CAR
																																																															(BgL_cdrzd258684zd2_5364);
																																																														BgL_cdrzd258689zd2_5367
																																																															=
																																																															CDR
																																																															(BgL_cdrzd258684zd2_5364);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258688zd2_5366))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd258689zd2_5367))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd258694zd2_5370;
																																																																		BgL_carzd258694zd2_5370
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd258689zd2_5367);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258694zd2_5370))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd258689zd2_5367)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9747z00_27757;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1470z00_5403;
																																																																							BgL_l1470z00_5403
																																																																								=
																																																																								BgL_cdrzd258674zd2_5359;
																																																																						BgL_zc3z04anonymousza34522ze3z87_5404:
																																																																							if (NULLP(BgL_l1470z00_5403))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9747z00_27757
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9749z00_27760;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9750z00_27761;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_27762;
																																																																											BgL_tmpz00_27762
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1470z00_5403));
																																																																											BgL_test9750z00_27761
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_27762);
																																																																										}
																																																																										if (BgL_test9750z00_27761)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9749z00_27760
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9749z00_27760
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9749z00_27760)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1470z00_27766;
																																																																											BgL_l1470z00_27766
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1470z00_5403));
																																																																											BgL_l1470z00_5403
																																																																												=
																																																																												BgL_l1470z00_27766;
																																																																											goto
																																																																												BgL_zc3z04anonymousza34522ze3z87_5404;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9747z00_27757
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9747z00_27757)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4512z00_5386;
																																																																								BgL_arg4512z00_5386
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd258679zd2_5360);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27770;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27774;
																																																																										obj_t
																																																																											BgL_proc2z00_27773;
																																																																										obj_t
																																																																											BgL_proc1z00_27772;
																																																																										obj_t
																																																																											BgL_testz00_27771;
																																																																										BgL_testz00_27771
																																																																											=
																																																																											BgL_arg4512z00_5386;
																																																																										BgL_proc1z00_27772
																																																																											=
																																																																											BgL_carzd258688zd2_5366;
																																																																										BgL_proc2z00_27773
																																																																											=
																																																																											BgL_carzd258694zd2_5370;
																																																																										BgL_argsz00_27774
																																																																											=
																																																																											BgL_cdrzd258674zd2_5359;
																																																																										BgL_argsz00_1795
																																																																											=
																																																																											BgL_argsz00_27774;
																																																																										BgL_proc2z00_1794
																																																																											=
																																																																											BgL_proc2z00_27773;
																																																																										BgL_proc1z00_1793
																																																																											=
																																																																											BgL_proc1z00_27772;
																																																																										BgL_testz00_1792
																																																																											=
																																																																											BgL_testz00_27771;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1796;
																																																																									}
																																																																									BgL_auxz00_27691
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27770);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd258719zd2_5387;
																																																																								BgL_cdrzd258719zd2_5387
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd258727zd2_5388;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12817;
																																																																										BgL_pairz00_12817
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd258727zd2_5388
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12817);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd258735zd2_5389;
																																																																										BgL_cdrzd258735zd2_5389
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd258727zd2_5388));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd258742zd2_5390;
																																																																											BgL_carzd258742zd2_5390
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd258735zd2_5389));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258742zd2_5390))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd258751zd2_5392;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12821;
																																																																														BgL_pairz00_12821
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd258735zd2_5389));
																																																																														BgL_carzd258751zd2_5392
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12821);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258751zd2_5392))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd258719zd2_5387))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg4516z00_5395;
																																																																																	BgL_arg4516z00_5395
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd258727zd2_5388));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_27796;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_27800;
																																																																																			obj_t
																																																																																				BgL_proc2z00_27799;
																																																																																			obj_t
																																																																																				BgL_proc1z00_27798;
																																																																																			obj_t
																																																																																				BgL_testz00_27797;
																																																																																			BgL_testz00_27797
																																																																																				=
																																																																																				BgL_arg4516z00_5395;
																																																																																			BgL_proc1z00_27798
																																																																																				=
																																																																																				BgL_carzd258742zd2_5390;
																																																																																			BgL_proc2z00_27799
																																																																																				=
																																																																																				BgL_carzd258751zd2_5392;
																																																																																			BgL_argsz00_27800
																																																																																				=
																																																																																				BgL_cdrzd258719zd2_5387;
																																																																																			BgL_argsz00_1800
																																																																																				=
																																																																																				BgL_argsz00_27800;
																																																																																			BgL_proc2z00_1799
																																																																																				=
																																																																																				BgL_proc2z00_27799;
																																																																																			BgL_proc1z00_1798
																																																																																				=
																																																																																				BgL_proc1z00_27798;
																																																																																			BgL_testz00_1797
																																																																																				=
																																																																																				BgL_testz00_27797;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1801;
																																																																																		}
																																																																																		BgL_auxz00_27691
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_27796);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1825;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_27804;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1826;
																																																																																			BgL_auxz00_27691
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_27804);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_27808;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_27691
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_27808);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27812;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_27691
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27812);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27816;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																								BgL_auxz00_27691
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27816);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd259029zd2_5414;
																																																																				BgL_cdrzd259029zd2_5414
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd259036zd2_5415;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12825;
																																																																						BgL_pairz00_12825
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd259036zd2_5415
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12825);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd259043zd2_5416;
																																																																						BgL_cdrzd259043zd2_5416
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd259036zd2_5415));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259049zd2_5417;
																																																																							obj_t
																																																																								BgL_cdrzd259050zd2_5418;
																																																																							BgL_carzd259049zd2_5417
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5416));
																																																																							BgL_cdrzd259050zd2_5418
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5416));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259049zd2_5417))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd259057zd2_5420;
																																																																									BgL_carzd259057zd2_5420
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd259050zd2_5418));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259057zd2_5420))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd259050zd2_5418))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259029zd2_5414))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4531z00_5425;
																																																																															BgL_arg4531z00_5425
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd259036zd2_5415));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_27843;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_27847;
																																																																																	obj_t
																																																																																		BgL_proc2z00_27846;
																																																																																	obj_t
																																																																																		BgL_proc1z00_27845;
																																																																																	obj_t
																																																																																		BgL_testz00_27844;
																																																																																	BgL_testz00_27844
																																																																																		=
																																																																																		BgL_arg4531z00_5425;
																																																																																	BgL_proc1z00_27845
																																																																																		=
																																																																																		BgL_carzd259049zd2_5417;
																																																																																	BgL_proc2z00_27846
																																																																																		=
																																																																																		BgL_carzd259057zd2_5420;
																																																																																	BgL_argsz00_27847
																																																																																		=
																																																																																		BgL_cdrzd259029zd2_5414;
																																																																																	BgL_argsz00_1800
																																																																																		=
																																																																																		BgL_argsz00_27847;
																																																																																	BgL_proc2z00_1799
																																																																																		=
																																																																																		BgL_proc2z00_27846;
																																																																																	BgL_proc1z00_1798
																																																																																		=
																																																																																		BgL_proc1z00_27845;
																																																																																	BgL_testz00_1797
																																																																																		=
																																																																																		BgL_testz00_27844;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1801;
																																																																																}
																																																																																BgL_auxz00_27691
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_27843);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1825;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_27851;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1826;
																																																																																	BgL_auxz00_27691
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_27851);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27855;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_27691
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27855);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27859;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_27691
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27859);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27863;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_27691
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27863);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27867;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																				BgL_auxz00_27691
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27867);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd259390zd2_5433;
																																																																BgL_cdrzd259390zd2_5433
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd259396zd2_5434;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12834;
																																																																		BgL_pairz00_12834
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd259396zd2_5434
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12834);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd259402zd2_5435;
																																																																		BgL_cdrzd259402zd2_5435
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd259396zd2_5434));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd259407zd2_5436;
																																																																			obj_t
																																																																				BgL_cdrzd259408zd2_5437;
																																																																			BgL_carzd259407zd2_5436
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5435));
																																																																			BgL_cdrzd259408zd2_5437
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5435));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259407zd2_5436))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd259408zd2_5437))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259413zd2_5440;
																																																																							BgL_carzd259413zd2_5440
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd259408zd2_5437);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259413zd2_5440))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd259408zd2_5437)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259390zd2_5433))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4545z00_5445;
																																																																													BgL_arg4545z00_5445
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd259396zd2_5434));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27894;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_27898;
																																																																															obj_t
																																																																																BgL_proc2z00_27897;
																																																																															obj_t
																																																																																BgL_proc1z00_27896;
																																																																															obj_t
																																																																																BgL_testz00_27895;
																																																																															BgL_testz00_27895
																																																																																=
																																																																																BgL_arg4545z00_5445;
																																																																															BgL_proc1z00_27896
																																																																																=
																																																																																BgL_carzd259407zd2_5436;
																																																																															BgL_proc2z00_27897
																																																																																=
																																																																																BgL_carzd259413zd2_5440;
																																																																															BgL_argsz00_27898
																																																																																=
																																																																																BgL_cdrzd259390zd2_5433;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_27898;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_27897;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_27896;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_27895;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																														BgL_auxz00_27691
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27894);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1825;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27902;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1826;
																																																																															BgL_auxz00_27691
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27902);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1825;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27906;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1826;
																																																																													BgL_auxz00_27691
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27906);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27910;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																											BgL_auxz00_27691
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27910);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27914;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																									BgL_auxz00_27691
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27914);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27918;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																							BgL_auxz00_27691
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27918);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1825;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27922;
																																																																goto
																																																																	BgL_tagzd2404zd2_1826;
																																																																BgL_auxz00_27691
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27922);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1825;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_27926;
																																																														goto
																																																															BgL_tagzd2404zd2_1826;
																																																														BgL_auxz00_27691
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_27926);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1825;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_27930;
																																																												goto
																																																													BgL_tagzd2404zd2_1826;
																																																												BgL_auxz00_27691
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_27930);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																return
																																																	(
																																																	(BgL_nodez00_bglt)
																																																	BgL_auxz00_27691);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9780z00_27933;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4484z00_5342;
																																																	BgL_arg4484z00_5342
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test9780z00_27933
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4484z00_5342));
																																																}
																																																if (BgL_test9780z00_27933)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27937;
																																																		goto
																																																			BgL_tagzd2384zd2_1783;
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_27937);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd259976zd2_5170;
																																																		obj_t
																																																			BgL_cdrzd259977zd2_5171;
																																																		BgL_carzd259976zd2_5170
																																																			=
																																																			CAR
																																																			(BgL_expz00_21);
																																																		BgL_cdrzd259977zd2_5171
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd259981zd2_5172;
																																																			BgL_cdrzd259981zd2_5172
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd259976zd2_5170));
																																																			if ((CAR(((obj_t) BgL_carzd259976zd2_5170)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd259981zd2_5172))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd259984zd2_5176;
																																																							obj_t
																																																								BgL_cdrzd259985zd2_5177;
																																																							BgL_carzd259984zd2_5176
																																																								=
																																																								CAR
																																																								(BgL_cdrzd259981zd2_5172);
																																																							BgL_cdrzd259985zd2_5177
																																																								=
																																																								CDR
																																																								(BgL_cdrzd259981zd2_5172);
																																																							if (PAIRP(BgL_carzd259984zd2_5176))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (NULLP(CDR(BgL_carzd259984zd2_5176)))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd259985zd2_5177))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd259991zd2_5182;
																																																													BgL_carzd259991zd2_5182
																																																														=
																																																														CAR
																																																														(BgL_cdrzd259985zd2_5177);
																																																													if (PAIRP(BgL_carzd259991zd2_5182))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd259991zd2_5182))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd259985zd2_5177)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd259977zd2_5171))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd259998zd2_5188;
																																																																					BgL_carzd259998zd2_5188
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd259977zd2_5171);
																																																																					if (PAIRP(BgL_carzd259998zd2_5188))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260022zd2_5190;
																																																																							BgL_cdrzd260022zd2_5190
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4381z00_5191;
																																																																								obj_t
																																																																									BgL_arg4382z00_5192;
																																																																								obj_t
																																																																									BgL_arg4383z00_5193;
																																																																								BgL_arg4381z00_5191
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5190));
																																																																								BgL_arg4382z00_5192
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5190));
																																																																								BgL_arg4383z00_5193
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_27981;
																																																																									obj_t
																																																																										BgL_bodyz00_27980;
																																																																									obj_t
																																																																										BgL_varsz00_27979;
																																																																									BgL_varsz00_27979
																																																																										=
																																																																										BgL_arg4381z00_5191;
																																																																									BgL_bodyz00_27980
																																																																										=
																																																																										BgL_arg4382z00_5192;
																																																																									BgL_argsz00_27981
																																																																										=
																																																																										BgL_arg4383z00_5193;
																																																																									BgL_argsz00_1790
																																																																										=
																																																																										BgL_argsz00_27981;
																																																																									BgL_bodyz00_1789
																																																																										=
																																																																										BgL_bodyz00_27980;
																																																																									BgL_varsz00_1788
																																																																										=
																																																																										BgL_varsz00_27979;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1791;
																																																																								}
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd259977zd2_5171)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4387z00_5197;
																																																																									BgL_arg4387z00_5197
																																																																										=
																																																																										CAR
																																																																										(BgL_carzd259984zd2_5176);
																																																																									{
																																																																										BgL_castz00_bglt
																																																																											BgL_auxz00_27986;
																																																																										{
																																																																											obj_t
																																																																												BgL_argz00_27989;
																																																																											obj_t
																																																																												BgL_bodyz00_27988;
																																																																											obj_t
																																																																												BgL_varz00_27987;
																																																																											BgL_varz00_27987
																																																																												=
																																																																												BgL_arg4387z00_5197;
																																																																											BgL_bodyz00_27988
																																																																												=
																																																																												BgL_carzd259991zd2_5182;
																																																																											BgL_argz00_27989
																																																																												=
																																																																												BgL_carzd259998zd2_5188;
																																																																											BgL_argz00_1786
																																																																												=
																																																																												BgL_argz00_27989;
																																																																											BgL_bodyz00_1785
																																																																												=
																																																																												BgL_bodyz00_27988;
																																																																											BgL_varz00_1784
																																																																												=
																																																																												BgL_varz00_27987;
																																																																											goto
																																																																												BgL_tagzd2385zd2_1787;
																																																																										}
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_27986);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd260049zd2_5198;
																																																																									BgL_cdrzd260049zd2_5198
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4388z00_5199;
																																																																										obj_t
																																																																											BgL_arg4389z00_5200;
																																																																										obj_t
																																																																											BgL_arg4390z00_5201;
																																																																										BgL_arg4388z00_5199
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5198));
																																																																										BgL_arg4389z00_5200
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5198));
																																																																										BgL_arg4390z00_5201
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28000;
																																																																											obj_t
																																																																												BgL_bodyz00_27999;
																																																																											obj_t
																																																																												BgL_varsz00_27998;
																																																																											BgL_varsz00_27998
																																																																												=
																																																																												BgL_arg4388z00_5199;
																																																																											BgL_bodyz00_27999
																																																																												=
																																																																												BgL_arg4389z00_5200;
																																																																											BgL_argsz00_28000
																																																																												=
																																																																												BgL_arg4390z00_5201;
																																																																											BgL_argsz00_1790
																																																																												=
																																																																												BgL_argsz00_28000;
																																																																											BgL_bodyz00_1789
																																																																												=
																																																																												BgL_bodyz00_27999;
																																																																											BgL_varsz00_1788
																																																																												=
																																																																												BgL_varsz00_27998;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1791;
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260075zd2_5204;
																																																																					BgL_cdrzd260075zd2_5204
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4393z00_5205;
																																																																						obj_t
																																																																							BgL_arg4394z00_5206;
																																																																						obj_t
																																																																							BgL_arg4395z00_5207;
																																																																						BgL_arg4393z00_5205
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5204));
																																																																						BgL_arg4394z00_5206
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5204));
																																																																						BgL_arg4395z00_5207
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_28010;
																																																																							obj_t
																																																																								BgL_bodyz00_28009;
																																																																							obj_t
																																																																								BgL_varsz00_28008;
																																																																							BgL_varsz00_28008
																																																																								=
																																																																								BgL_arg4393z00_5205;
																																																																							BgL_bodyz00_28009
																																																																								=
																																																																								BgL_arg4394z00_5206;
																																																																							BgL_argsz00_28010
																																																																								=
																																																																								BgL_arg4395z00_5207;
																																																																							BgL_argsz00_1790
																																																																								=
																																																																								BgL_argsz00_28010;
																																																																							BgL_bodyz00_1789
																																																																								=
																																																																								BgL_bodyz00_28009;
																																																																							BgL_varsz00_1788
																																																																								=
																																																																								BgL_varsz00_28008;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1791;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260101zd2_5209;
																																																																			BgL_cdrzd260101zd2_5209
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4397z00_5210;
																																																																				obj_t
																																																																					BgL_arg4398z00_5211;
																																																																				obj_t
																																																																					BgL_arg4399z00_5212;
																																																																				BgL_arg4397z00_5210
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5209));
																																																																				BgL_arg4398z00_5211
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5209));
																																																																				BgL_arg4399z00_5212
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28020;
																																																																					obj_t
																																																																						BgL_bodyz00_28019;
																																																																					obj_t
																																																																						BgL_varsz00_28018;
																																																																					BgL_varsz00_28018
																																																																						=
																																																																						BgL_arg4397z00_5210;
																																																																					BgL_bodyz00_28019
																																																																						=
																																																																						BgL_arg4398z00_5211;
																																																																					BgL_argsz00_28020
																																																																						=
																																																																						BgL_arg4399z00_5212;
																																																																					BgL_argsz00_1790
																																																																						=
																																																																						BgL_argsz00_28020;
																																																																					BgL_bodyz00_1789
																																																																						=
																																																																						BgL_bodyz00_28019;
																																																																					BgL_varsz00_1788
																																																																						=
																																																																						BgL_varsz00_28018;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1791;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260127zd2_5215;
																																																																	BgL_cdrzd260127zd2_5215
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg4402z00_5216;
																																																																		obj_t
																																																																			BgL_arg4403z00_5217;
																																																																		obj_t
																																																																			BgL_arg4404z00_5218;
																																																																		BgL_arg4402z00_5216
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5215));
																																																																		BgL_arg4403z00_5217
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5215));
																																																																		BgL_arg4404z00_5218
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28030;
																																																																			obj_t
																																																																				BgL_bodyz00_28029;
																																																																			obj_t
																																																																				BgL_varsz00_28028;
																																																																			BgL_varsz00_28028
																																																																				=
																																																																				BgL_arg4402z00_5216;
																																																																			BgL_bodyz00_28029
																																																																				=
																																																																				BgL_arg4403z00_5217;
																																																																			BgL_argsz00_28030
																																																																				=
																																																																				BgL_arg4404z00_5218;
																																																																			BgL_argsz00_1790
																																																																				=
																																																																				BgL_argsz00_28030;
																																																																			BgL_bodyz00_1789
																																																																				=
																																																																				BgL_bodyz00_28029;
																																																																			BgL_varsz00_1788
																																																																				=
																																																																				BgL_varsz00_28028;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1791;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd260153zd2_5220;
																																																															BgL_cdrzd260153zd2_5220
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd259976zd2_5170));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4406z00_5221;
																																																																obj_t
																																																																	BgL_arg4407z00_5222;
																																																																obj_t
																																																																	BgL_arg4408z00_5223;
																																																																BgL_arg4406z00_5221
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5220));
																																																																BgL_arg4407z00_5222
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5220));
																																																																BgL_arg4408z00_5223
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_28040;
																																																																	obj_t
																																																																		BgL_bodyz00_28039;
																																																																	obj_t
																																																																		BgL_varsz00_28038;
																																																																	BgL_varsz00_28038
																																																																		=
																																																																		BgL_arg4406z00_5221;
																																																																	BgL_bodyz00_28039
																																																																		=
																																																																		BgL_arg4407z00_5222;
																																																																	BgL_argsz00_28040
																																																																		=
																																																																		BgL_arg4408z00_5223;
																																																																	BgL_argsz00_1790
																																																																		=
																																																																		BgL_argsz00_28040;
																																																																	BgL_bodyz00_1789
																																																																		=
																																																																		BgL_bodyz00_28039;
																																																																	BgL_varsz00_1788
																																																																		=
																																																																		BgL_varsz00_28038;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1791;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd260179zd2_5225;
																																																													BgL_cdrzd260179zd2_5225
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd259976zd2_5170));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4410z00_5226;
																																																														obj_t
																																																															BgL_arg4411z00_5227;
																																																														obj_t
																																																															BgL_arg4412z00_5228;
																																																														BgL_arg4410z00_5226
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5225));
																																																														BgL_arg4411z00_5227
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5225));
																																																														BgL_arg4412z00_5228
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_28050;
																																																															obj_t
																																																																BgL_bodyz00_28049;
																																																															obj_t
																																																																BgL_varsz00_28048;
																																																															BgL_varsz00_28048
																																																																=
																																																																BgL_arg4410z00_5226;
																																																															BgL_bodyz00_28049
																																																																=
																																																																BgL_arg4411z00_5227;
																																																															BgL_argsz00_28050
																																																																=
																																																																BgL_arg4412z00_5228;
																																																															BgL_argsz00_1790
																																																																=
																																																																BgL_argsz00_28050;
																																																															BgL_bodyz00_1789
																																																																=
																																																																BgL_bodyz00_28049;
																																																															BgL_varsz00_1788
																																																																=
																																																																BgL_varsz00_28048;
																																																															goto
																																																																BgL_tagzd2386zd2_1791;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd260205zd2_5230;
																																																											BgL_cdrzd260205zd2_5230
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd259976zd2_5170));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4414z00_5231;
																																																												obj_t
																																																													BgL_arg4415z00_5232;
																																																												obj_t
																																																													BgL_arg4416z00_5233;
																																																												BgL_arg4414z00_5231
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5230));
																																																												BgL_arg4415z00_5232
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5230));
																																																												BgL_arg4416z00_5233
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_28060;
																																																													obj_t
																																																														BgL_bodyz00_28059;
																																																													obj_t
																																																														BgL_varsz00_28058;
																																																													BgL_varsz00_28058
																																																														=
																																																														BgL_arg4414z00_5231;
																																																													BgL_bodyz00_28059
																																																														=
																																																														BgL_arg4415z00_5232;
																																																													BgL_argsz00_28060
																																																														=
																																																														BgL_arg4416z00_5233;
																																																													BgL_argsz00_1790
																																																														=
																																																														BgL_argsz00_28060;
																																																													BgL_bodyz00_1789
																																																														=
																																																														BgL_bodyz00_28059;
																																																													BgL_varsz00_1788
																																																														=
																																																														BgL_varsz00_28058;
																																																													goto
																																																														BgL_tagzd2386zd2_1791;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260231zd2_5236;
																																																									BgL_cdrzd260231zd2_5236
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd259976zd2_5170));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg4419z00_5237;
																																																										obj_t
																																																											BgL_arg4420z00_5238;
																																																										obj_t
																																																											BgL_arg4421z00_5239;
																																																										BgL_arg4419z00_5237
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5236));
																																																										BgL_arg4420z00_5238
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5236));
																																																										BgL_arg4421z00_5239
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28070;
																																																											obj_t
																																																												BgL_bodyz00_28069;
																																																											obj_t
																																																												BgL_varsz00_28068;
																																																											BgL_varsz00_28068
																																																												=
																																																												BgL_arg4419z00_5237;
																																																											BgL_bodyz00_28069
																																																												=
																																																												BgL_arg4420z00_5238;
																																																											BgL_argsz00_28070
																																																												=
																																																												BgL_arg4421z00_5239;
																																																											BgL_argsz00_1790
																																																												=
																																																												BgL_argsz00_28070;
																																																											BgL_bodyz00_1789
																																																												=
																																																												BgL_bodyz00_28069;
																																																											BgL_varsz00_1788
																																																												=
																																																												BgL_varsz00_28068;
																																																											goto
																																																												BgL_tagzd2386zd2_1791;
																																																										}
																																																									}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28073;
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28073);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd260369zd2_5244;
																																																					BgL_cdrzd260369zd2_5244
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd259976zd2_5170));
																																																					if ((CAR(((obj_t) BgL_carzd259976zd2_5170)) == CNST_TABLE_REF(((long) 1))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd260369zd2_5244))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260374zd2_5248;
																																																									BgL_cdrzd260374zd2_5248
																																																										=
																																																										CDR
																																																										(BgL_cdrzd260369zd2_5244);
																																																									if (PAIRP(BgL_cdrzd260374zd2_5248))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd260378zd2_5250;
																																																											obj_t
																																																												BgL_cdrzd260379zd2_5251;
																																																											BgL_carzd260378zd2_5250
																																																												=
																																																												CAR
																																																												(BgL_cdrzd260374zd2_5248);
																																																											BgL_cdrzd260379zd2_5251
																																																												=
																																																												CDR
																																																												(BgL_cdrzd260374zd2_5248);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260378zd2_5250))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd260379zd2_5251))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd260384zd2_5254;
																																																															BgL_carzd260384zd2_5254
																																																																=
																																																																CAR
																																																																(BgL_cdrzd260379zd2_5251);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260384zd2_5254))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd260379zd2_5251)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test9800z00_28099;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1473z00_5287;
																																																																				BgL_l1473z00_5287
																																																																					=
																																																																					BgL_cdrzd259977zd2_5171;
																																																																			BgL_zc3z04anonymousza34448ze3z87_5288:
																																																																				if (NULLP(BgL_l1473z00_5287))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9800z00_28099
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9802z00_28102;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9803z00_28103;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_28104;
																																																																								BgL_tmpz00_28104
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1473z00_5287));
																																																																								BgL_test9803z00_28103
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_28104);
																																																																							}
																																																																							if (BgL_test9803z00_28103)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9802z00_28102
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9802z00_28102
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test9802z00_28102)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1473z00_28108;
																																																																								BgL_l1473z00_28108
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1473z00_5287));
																																																																								BgL_l1473z00_5287
																																																																									=
																																																																									BgL_l1473z00_28108;
																																																																								goto
																																																																									BgL_zc3z04anonymousza34448ze3z87_5288;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9800z00_28099
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test9800z00_28099)
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28115;
																																																																					obj_t
																																																																						BgL_proc2z00_28114;
																																																																					obj_t
																																																																						BgL_proc1z00_28113;
																																																																					obj_t
																																																																						BgL_testz00_28111;
																																																																					BgL_testz00_28111
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd260369zd2_5244);
																																																																					BgL_proc1z00_28113
																																																																						=
																																																																						BgL_carzd260378zd2_5250;
																																																																					BgL_proc2z00_28114
																																																																						=
																																																																						BgL_carzd260384zd2_5254;
																																																																					BgL_argsz00_28115
																																																																						=
																																																																						BgL_cdrzd259977zd2_5171;
																																																																					BgL_argsz00_1795
																																																																						=
																																																																						BgL_argsz00_28115;
																																																																					BgL_proc2z00_1794
																																																																						=
																																																																						BgL_proc2z00_28114;
																																																																					BgL_proc1z00_1793
																																																																						=
																																																																						BgL_proc1z00_28113;
																																																																					BgL_testz00_1792
																																																																						=
																																																																						BgL_testz00_28111;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1796;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260409zd2_5271;
																																																																					BgL_cdrzd260409zd2_5271
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd260417zd2_5272;
																																																																						BgL_cdrzd260417zd2_5272
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260425zd2_5273;
																																																																							BgL_cdrzd260425zd2_5273
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd260417zd2_5272));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd260432zd2_5274;
																																																																								BgL_carzd260432zd2_5274
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260425zd2_5273));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260432zd2_5274))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd260441zd2_5276;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12918;
																																																																											BgL_pairz00_12918
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd260425zd2_5273));
																																																																											BgL_carzd260441zd2_5276
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_12918);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260441zd2_5276))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260409zd2_5271))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4442z00_5279;
																																																																														BgL_arg4442z00_5279
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd260417zd2_5272));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28137;
																																																																															obj_t
																																																																																BgL_proc2z00_28136;
																																																																															obj_t
																																																																																BgL_proc1z00_28135;
																																																																															obj_t
																																																																																BgL_testz00_28134;
																																																																															BgL_testz00_28134
																																																																																=
																																																																																BgL_arg4442z00_5279;
																																																																															BgL_proc1z00_28135
																																																																																=
																																																																																BgL_carzd260432zd2_5274;
																																																																															BgL_proc2z00_28136
																																																																																=
																																																																																BgL_carzd260441zd2_5276;
																																																																															BgL_argsz00_28137
																																																																																=
																																																																																BgL_cdrzd260409zd2_5271;
																																																																															BgL_argsz00_1800
																																																																																=
																																																																																BgL_argsz00_28137;
																																																																															BgL_proc2z00_1799
																																																																																=
																																																																																BgL_proc2z00_28136;
																																																																															BgL_proc1z00_1798
																																																																																=
																																																																																BgL_proc1z00_28135;
																																																																															BgL_testz00_1797
																																																																																=
																																																																																BgL_testz00_28134;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1801;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_28140;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1825;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_28140);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1826;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28144;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28144);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28148;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28148);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_28152;
																																																																					goto
																																																																						BgL_tagzd2403zd2_1825;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_28152);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2404zd2_1826;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260719zd2_5298;
																																																																	BgL_cdrzd260719zd2_5298
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd260726zd2_5299;
																																																																		BgL_cdrzd260726zd2_5299
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260733zd2_5300;
																																																																			BgL_cdrzd260733zd2_5300
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd260726zd2_5299));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd260739zd2_5301;
																																																																				obj_t
																																																																					BgL_cdrzd260740zd2_5302;
																																																																				BgL_carzd260739zd2_5301
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5300));
																																																																				BgL_cdrzd260740zd2_5302
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5300));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260739zd2_5301))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd260747zd2_5304;
																																																																						BgL_carzd260747zd2_5304
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260740zd2_5302));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260747zd2_5304))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd260740zd2_5302))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260719zd2_5298))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4457z00_5309;
																																																																												BgL_arg4457z00_5309
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd260726zd2_5299));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_28180;
																																																																													obj_t
																																																																														BgL_proc2z00_28179;
																																																																													obj_t
																																																																														BgL_proc1z00_28178;
																																																																													obj_t
																																																																														BgL_testz00_28177;
																																																																													BgL_testz00_28177
																																																																														=
																																																																														BgL_arg4457z00_5309;
																																																																													BgL_proc1z00_28178
																																																																														=
																																																																														BgL_carzd260739zd2_5301;
																																																																													BgL_proc2z00_28179
																																																																														=
																																																																														BgL_carzd260747zd2_5304;
																																																																													BgL_argsz00_28180
																																																																														=
																																																																														BgL_cdrzd260719zd2_5298;
																																																																													BgL_argsz00_1800
																																																																														=
																																																																														BgL_argsz00_28180;
																																																																													BgL_proc2z00_1799
																																																																														=
																																																																														BgL_proc2z00_28179;
																																																																													BgL_proc1z00_1798
																																																																														=
																																																																														BgL_proc1z00_28178;
																																																																													BgL_testz00_1797
																																																																														=
																																																																														BgL_testz00_28177;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1801;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28183;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1825;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28183);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1826;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28187;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28187);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28191;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28191);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28195;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28195);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_28199;
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28199);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd261080zd2_5317;
																																																													BgL_cdrzd261080zd2_5317
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd261086zd2_5318;
																																																														BgL_cdrzd261086zd2_5318
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd261092zd2_5319;
																																																															BgL_cdrzd261092zd2_5319
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd261086zd2_5318));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd261097zd2_5320;
																																																																obj_t
																																																																	BgL_cdrzd261098zd2_5321;
																																																																BgL_carzd261097zd2_5320
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5319));
																																																																BgL_cdrzd261098zd2_5321
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5319));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261097zd2_5320))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd261098zd2_5321))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd261103zd2_5324;
																																																																				BgL_carzd261103zd2_5324
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd261098zd2_5321);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261103zd2_5324))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd261098zd2_5321)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd261080zd2_5317))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4471z00_5329;
																																																																										BgL_arg4471z00_5329
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd261086zd2_5318));
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28227;
																																																																											obj_t
																																																																												BgL_proc2z00_28226;
																																																																											obj_t
																																																																												BgL_proc1z00_28225;
																																																																											obj_t
																																																																												BgL_testz00_28224;
																																																																											BgL_testz00_28224
																																																																												=
																																																																												BgL_arg4471z00_5329;
																																																																											BgL_proc1z00_28225
																																																																												=
																																																																												BgL_carzd261097zd2_5320;
																																																																											BgL_proc2z00_28226
																																																																												=
																																																																												BgL_carzd261103zd2_5324;
																																																																											BgL_argsz00_28227
																																																																												=
																																																																												BgL_cdrzd261080zd2_5317;
																																																																											BgL_argsz00_1800
																																																																												=
																																																																												BgL_argsz00_28227;
																																																																											BgL_proc2z00_1799
																																																																												=
																																																																												BgL_proc2z00_28226;
																																																																											BgL_proc1z00_1798
																																																																												=
																																																																												BgL_proc1z00_28225;
																																																																											BgL_testz00_1797
																																																																												=
																																																																												BgL_testz00_28224;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1801;
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28230;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1825;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28230);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1826;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28234;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1825;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28234);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1826;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28238;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1825;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28238);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1826;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_28242;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1825;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_28242);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1826;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_28246;
																																																																				goto
																																																																					BgL_tagzd2403zd2_1825;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_28246);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2404zd2_1826;
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28250;
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28250);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_28254;
																																																											goto
																																																												BgL_tagzd2403zd2_1825;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_28254);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1826;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28258;
																																																									goto
																																																										BgL_tagzd2403zd2_1825;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28258);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1826;
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																																}
																															else
																																{

																																	if (
																																		(BgL_carzd255411zd2_5154
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					17))))
																																		{
																																			obj_t
																																				BgL_auxz00_28263;
																																		BgL_kapzd261641zd2_5737:
																																			if (PAIRP
																																				(BgL_cdrzd255282zd2_5136))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4825z00_5834;
																																					obj_t
																																						BgL_arg4826z00_5835;
																																					BgL_arg4825z00_5834
																																						=
																																						CAR
																																						(BgL_cdrzd255282zd2_5136);
																																					BgL_arg4826z00_5835
																																						=
																																						CDR
																																						(BgL_cdrzd255282zd2_5136);
																																					{
																																						BgL_nodez00_bglt
																																							BgL_auxz00_28268;
																																						{
																																							obj_t
																																								BgL_exprz00_28270;
																																							obj_t
																																								BgL_bindingsz00_28269;
																																							BgL_bindingsz00_28269
																																								=
																																								BgL_arg4825z00_5834;
																																							BgL_exprz00_28270
																																								=
																																								BgL_arg4826z00_5835;
																																							BgL_exprz00_1780
																																								=
																																								BgL_exprz00_28270;
																																							BgL_bindingsz00_1779
																																								=
																																								BgL_bindingsz00_28269;
																																							goto
																																								BgL_tagzd2382zd2_1781;
																																						}
																																						BgL_auxz00_28263
																																							=
																																							(
																																							(obj_t)
																																							BgL_auxz00_28268);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_28277;
																																							goto
																																								BgL_tagzd2383zd2_1782;
																																							BgL_auxz00_28263
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_28277);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd261674zd2_5838;
																																							BgL_carzd261674zd2_5838
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd261674zd2_5838 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_28284;
																																									goto
																																										BgL_tagzd2384zd2_1783;
																																									BgL_auxz00_28263
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_28284);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261674zd2_5838)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28289;
																																											goto
																																												BgL_tagzd2384zd2_1783;
																																											BgL_auxz00_28263
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_28289);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28296;
																																													goto
																																														BgL_tagzd2389zd2_1802;
																																													BgL_auxz00_28263
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28296);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28303;
																																															goto
																																																BgL_tagzd2390zd2_1803;
																																															BgL_auxz00_28263
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28303);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_28310;
																																																	goto
																																																		BgL_tagzd2392zd2_1807;
																																																	BgL_auxz00_28263
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_28310);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28317;
																																																			goto
																																																				BgL_tagzd2393zd2_1808;
																																																			BgL_auxz00_28263
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28317);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28324;
																																																					goto
																																																						BgL_tagzd2395zd2_1812;
																																																					BgL_auxz00_28263
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28324);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_28331;
																																																							goto
																																																								BgL_tagzd2396zd2_1813;
																																																							BgL_auxz00_28263
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_28331);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_28338;
																																																									goto
																																																										BgL_tagzd2397zd2_1814;
																																																									BgL_auxz00_28263
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_28338);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_28345;
																																																											goto
																																																												BgL_tagzd2398zd2_1815;
																																																											BgL_auxz00_28263
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28345);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28355;
																																																															goto
																																																																BgL_tagzd2402zd2_1824;
																																																															BgL_auxz00_28263
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28355);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1825;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28359;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1826;
																																																																	BgL_auxz00_28263
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28359);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1825;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28363;
																																																															goto
																																																																BgL_tagzd2404zd2_1826;
																																																															BgL_auxz00_28263
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28363);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_28263);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd255411zd2_5154)))
																																				{
																																					obj_t
																																						BgL_auxz00_28369;
																																					goto
																																						BgL_kapzd261641zd2_5737;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_28369);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd255411zd2_5154
																																							==
																																							CNST_TABLE_REF
																																							(((long) 18))))
																																						{
																																							obj_t
																																								BgL_auxz00_28374;
																																							goto
																																								BgL_kapzd261641zd2_5737;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_28374);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2383zd2_1782;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd261835zd2_5743;
																																									BgL_carzd261835zd2_5743
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									if ((BgL_carzd261835zd2_5743 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28384;
																																											goto
																																												BgL_tagzd2384zd2_1783;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_28384);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261835zd2_5743)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_28389;
																																													goto
																																														BgL_tagzd2384zd2_1783;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_28389);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															goto
																																																BgL_tagzd2389zd2_1802;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2390zd2_1803;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd261914zd2_5750;
																																																	BgL_cdrzd261914zd2_5750
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd261914zd2_5750))
																																																				{
																																																					obj_t
																																																						BgL_restz00_28408;
																																																					obj_t
																																																						BgL_effectz00_28406;
																																																					BgL_effectz00_28406
																																																						=
																																																						CAR
																																																						(BgL_cdrzd261914zd2_5750);
																																																					BgL_restz00_28408
																																																						=
																																																						CDR
																																																						(BgL_cdrzd261914zd2_5750);
																																																					BgL_restz00_1805
																																																						=
																																																						BgL_restz00_28408;
																																																					BgL_effectz00_1804
																																																						=
																																																						BgL_effectz00_28406;
																																																					goto
																																																						BgL_tagzd2391zd2_1806;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{
																																																							obj_t
																																																								BgL_auxz00_28412;
																																																							goto
																																																								BgL_tagzd2403zd2_1825;
																																																							return
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BgL_auxz00_28412);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2404zd2_1826;
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2392zd2_1807;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2393zd2_1808;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd261914zd2_5750))
																																																										{
																																																											obj_t
																																																												BgL_restz00_28430;
																																																											obj_t
																																																												BgL_effectz00_28428;
																																																											BgL_effectz00_28428
																																																												=
																																																												CAR
																																																												(BgL_cdrzd261914zd2_5750);
																																																											BgL_restz00_28430
																																																												=
																																																												CDR
																																																												(BgL_cdrzd261914zd2_5750);
																																																											BgL_restz00_1810
																																																												=
																																																												BgL_restz00_28430;
																																																											BgL_effectz00_1809
																																																												=
																																																												BgL_effectz00_28428;
																																																											goto
																																																												BgL_tagzd2394zd2_1811;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28434;
																																																													goto
																																																														BgL_tagzd2403zd2_1825;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28434);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1826;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2395zd2_1812;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2396zd2_1813;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_28448;
																																																															goto
																																																																BgL_tagzd2397zd2_1814;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_28448);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																{
																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																		BgL_auxz00_28454;
																																																																	goto
																																																																		BgL_tagzd2398zd2_1815;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28454);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd262041zd2_5776;
																																																																	BgL_cdrzd262041zd2_5776
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd262041zd2_5776))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd262043zd2_5780;
																																																																					BgL_cdrzd262043zd2_5780
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262041zd2_5776);
																																																																					if (PAIRP(BgL_cdrzd262043zd2_5780))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd262043zd2_5780)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2399zd2_1816;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_28471;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_28471);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_28475;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_28475);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_28479;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1825;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_28479);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1826;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd262041zd2_5776))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd262088zd2_5792;
																																																																							BgL_cdrzd262088zd2_5792
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd262041zd2_5776);
																																																																							if (PAIRP(BgL_cdrzd262088zd2_5792))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262093zd2_5794;
																																																																									BgL_cdrzd262093zd2_5794
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd262088zd2_5792);
																																																																									if ((CAR(BgL_cdrzd262088zd2_5792) == CNST_TABLE_REF(((long) 31))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd262093zd2_5794))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4792z00_5798;
																																																																													obj_t
																																																																														BgL_arg4793z00_5799;
																																																																													obj_t
																																																																														BgL_arg4794z00_5800;
																																																																													BgL_arg4792z00_5798
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262041zd2_5776);
																																																																													BgL_arg4793z00_5799
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262093zd2_5794);
																																																																													BgL_arg4794z00_5800
																																																																														=
																																																																														CDR
																																																																														(BgL_cdrzd262093zd2_5794);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4792z00_5798,
																																																																														BgL_arg4793z00_5799,
																																																																														BgL_arg4794z00_5800,
																																																																														BgL_stackz00_22,
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																															BgL_locz00_23),
																																																																														BgL_sitez00_24);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd262106zd2_5801;
																																																																													BgL_cdrzd262106zd2_5801
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4795z00_5802;
																																																																														obj_t
																																																																															BgL_arg4796z00_5803;
																																																																														BgL_arg4795z00_5802
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5801));
																																																																														BgL_arg4796z00_5803
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5801));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7023z00_12988;
																																																																															BgL_arg7023z00_12988
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg4795z00_5802,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg4796z00_5803, BgL_stackz00_22, BgL_arg7023z00_12988, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd262121zd2_5804;
																																																																											BgL_cdrzd262121zd2_5804
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4797z00_5805;
																																																																												obj_t
																																																																													BgL_arg4798z00_5806;
																																																																												BgL_arg4797z00_5805
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5804));
																																																																												BgL_arg4798z00_5806
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5804));
																																																																												{	/* Ast/sexp.scm 555 */
																																																																													obj_t
																																																																														BgL_arg7023z00_12992;
																																																																													BgL_arg7023z00_12992
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4797z00_5805,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg4798z00_5806, BgL_stackz00_22, BgL_arg7023z00_12992, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262136zd2_5808;
																																																																									BgL_cdrzd262136zd2_5808
																																																																										=
																																																																										CDR
																																																																										(BgL_expz00_21);
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4800z00_5809;
																																																																										obj_t
																																																																											BgL_arg4801z00_5810;
																																																																										BgL_arg4800z00_5809
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5808));
																																																																										BgL_arg4801z00_5810
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5808));
																																																																										{	/* Ast/sexp.scm 555 */
																																																																											obj_t
																																																																												BgL_arg7023z00_12996;
																																																																											BgL_arg7023z00_12996
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_expz00_21,
																																																																												BgL_locz00_23);
																																																																											return
																																																																												BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																												(BgL_expz00_21,
																																																																												BgL_arg4800z00_5809,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4801z00_5810, BgL_stackz00_22, BgL_arg7023z00_12996, BgL_sitez00_24);
																																																																						}}}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_28528;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_28528);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_expz00_21)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1824;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_28538;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1825;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_28538);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1826;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_28542;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1825;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_28542);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1826;
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 119 */
										BgL_atomz00_1757 = BgL_expz00_21;
										{	/* Ast/sexp.scm 135 */
											bool_t BgL_test9886z00_28544;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1757,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 135 */
													BgL_test9886z00_28544 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 135 */
													BgL_test9886z00_28544 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1757,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_test9886z00_28544)
												{	/* Ast/sexp.scm 135 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1757, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 137 */
													bool_t BgL_test9888z00_28549;

													if (STRUCTP(BgL_atomz00_1757))
														{	/* Ast/sexp.scm 137 */
															BgL_test9888z00_28549 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (VECTORP(BgL_atomz00_1757))
																{	/* Ast/sexp.scm 138 */
																	BgL_test9888z00_28549 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 138 */
																	if (BGL_HVECTORP(BgL_atomz00_1757))
																		{	/* Ast/sexp.scm 138 */
																			BgL_test9888z00_28549 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 138 */
																			if (BGL_OBJECTP(BgL_atomz00_1757))
																				{	/* Ast/sexp.scm 139 */
																					BgL_test9888z00_28549 = ((bool_t) 1);
																				}
																			else
																				{	/* Ast/sexp.scm 139 */
																					BgL_test9888z00_28549 =
																						PROCEDUREP(BgL_atomz00_1757);
																				}
																		}
																}
														}
													if (BgL_test9888z00_28549)
														{	/* Ast/sexp.scm 141 */
															BgL_nodez00_bglt BgL_res7359z00_9679;

															{	/* Ast/sexp.scm 726 */
																obj_t BgL_arg7138z00_9675;
																BgL_nodez00_bglt BgL_arg7139z00_9676;

																BgL_arg7138z00_9675 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg7139z00_9676 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 725 */
																	obj_t BgL_list7140z00_9678;

																	BgL_list7140z00_9678 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg7139z00_9676), BNIL);
																	BgL_res7359z00_9679 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg7138z00_9675,
																			BGl_string7411z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list7140z00_9678));
															}}
															return BgL_res7359z00_9679;
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (SYMBOLP(BgL_atomz00_1757))
																{	/* Ast/sexp.scm 147 */
																	obj_t BgL_g1120z00_8416;

																	BgL_g1120z00_8416 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1757, BgL_stackz00_22);
																	if (CBOOL(BgL_g1120z00_8416))
																		{	/* Ast/sexp.scm 147 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1120z00_8416, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 151 */
																			obj_t BgL_globalz00_8419;
																			obj_t BgL_locz00_8420;

																			BgL_globalz00_8419 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1757, BNIL);
																			BgL_locz00_8420 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_atomz00_1757, BgL_locz00_23);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_8419,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 154 */
																					if (
																						((((BgL_globalz00_bglt) COBJECT(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_8419)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 10))))
																						{	/* Ast/sexp.scm 157 */
																							obj_t BgL_arg6665z00_8424;

																							{	/* Ast/sexp.scm 157 */
																								obj_t BgL_arg6666z00_8425;

																								{	/* Ast/sexp.scm 157 */
																									obj_t BgL_arg6667z00_8426;

																									{	/* Ast/sexp.scm 157 */
																										obj_t BgL_arg6668z00_8427;

																										BgL_arg6668z00_8427 =
																											MAKE_YOUNG_PAIR
																											(BgL_atomz00_1757, BNIL);
																										BgL_arg6667z00_8426 =
																											MAKE_YOUNG_PAIR
																											(CNST_TABLE_REF(((long)
																													12)),
																											BgL_arg6668z00_8427);
																									}
																									BgL_arg6666z00_8425 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg6667z00_8426, BNIL);
																								}
																								BgL_arg6665z00_8424 =
																									MAKE_YOUNG_PAIR(CNST_TABLE_REF
																									(((long) 10)),
																									BgL_arg6666z00_8425);
																							}
																							{
																								obj_t BgL_locz00_28590;
																								obj_t BgL_expz00_28589;

																								BgL_expz00_28589 =
																									BgL_arg6665z00_8424;
																								BgL_locz00_28590 =
																									BgL_locz00_8420;
																								BgL_locz00_23 =
																									BgL_locz00_28590;
																								BgL_expz00_21 =
																									BgL_expz00_28589;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 156 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_8419,
																								BgL_locz00_8420,
																								BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 155 */
																					BgL_nodez00_bglt BgL_res7360z00_9686;

																					{	/* Ast/sexp.scm 726 */
																						obj_t BgL_arg7138z00_9682;
																						BgL_nodez00_bglt
																							BgL_arg7139z00_9683;
																						BgL_arg7138z00_9682 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7139z00_9683 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_8420,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 725 */
																							obj_t BgL_list7140z00_9685;

																							BgL_list7140z00_9685 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7139z00_9683),
																								BNIL);
																							BgL_res7360z00_9686 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_8420,
																									BgL_arg7138z00_9682,
																									BGl_string7410z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7140z00_9685));
																					}}
																					return BgL_res7360z00_9686;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 143 */
																	BgL_literalz00_bglt BgL_new1116z00_8430;

																	{	/* Ast/sexp.scm 144 */
																		BgL_literalz00_bglt BgL_new1114z00_8431;

																		BgL_new1114z00_8431 =
																			((BgL_literalz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_literalz00_bgl))));
																		{	/* Ast/sexp.scm 144 */
																			long BgL_arg6671z00_8432;

																			BgL_arg6671z00_8432 =
																				BGL_CLASS_INDEX
																				(BGl_literalz00zzast_nodez00);
																			BGL_OBJECT_CLASS_NUM_SET((
																					(BgL_objectz00_bglt)
																					BgL_new1114z00_8431),
																				BgL_arg6671z00_8432);
																		}
																		{	/* Ast/sexp.scm 144 */
																			BgL_objectz00_bglt BgL_tmpz00_28605;

																			BgL_tmpz00_28605 =
																				((BgL_objectz00_bglt)
																				BgL_new1114z00_8431);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_28605,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1114z00_8431);
																		BgL_new1116z00_8430 = BgL_new1114z00_8431;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1116z00_8430)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1116z00_8430)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1757)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				COBJECT(((BgL_atomz00_bglt)
																						BgL_new1116z00_8430)))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1757), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1116z00_8430);
																}
														}
												}
										}
									}
							}
					}
			}
		}

	}



/* liip~0 */
	obj_t BGl_liipze70ze7zzast_sexpz00(obj_t BgL_argsz00_8843)
	{
		{	/* Ast/sexp.scm 399 */
			if (NULLP(BgL_argsz00_8843))
				{	/* Ast/sexp.scm 400 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 402 */
					obj_t BgL_arg6914z00_8846;

					{	/* Ast/sexp.scm 402 */
						obj_t BgL_arg6915z00_8847;
						obj_t BgL_arg6916z00_8848;

						BgL_arg6915z00_8847 = CAR(((obj_t) BgL_argsz00_8843));
						{	/* Ast/sexp.scm 403 */
							obj_t BgL_arg6917z00_8849;

							{	/* Ast/sexp.scm 403 */
								obj_t BgL_arg6918z00_8850;

								BgL_arg6918z00_8850 = CDR(((obj_t) BgL_argsz00_8843));
								BgL_arg6917z00_8849 =
									BGl_liipze70ze7zzast_sexpz00(BgL_arg6918z00_8850);
							}
							BgL_arg6916z00_8848 = MAKE_YOUNG_PAIR(BgL_arg6917z00_8849, BNIL);
						}
						BgL_arg6914z00_8846 =
							MAKE_YOUNG_PAIR(BgL_arg6915z00_8847, BgL_arg6916z00_8848);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg6914z00_8846);
		}}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zzast_sexpz00(obj_t BgL_expz00_13245,
		obj_t BgL_locz00_13244, obj_t BgL_varsz00_8805, obj_t BgL_argsz00_8806)
	{
		{	/* Ast/sexp.scm 384 */
		BGl_loopze70ze7zzast_sexpz00:
			if (NULLP(BgL_varsz00_8805))
				{	/* Ast/sexp.scm 387 */
					if (NULLP(BgL_argsz00_8806))
						{	/* Ast/sexp.scm 388 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 388 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_13244,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string7413z00zzast_sexpz00, BgL_expz00_13245, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 387 */
					if (PAIRP(BgL_varsz00_8805))
						{	/* Ast/sexp.scm 395 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_8805)))
								{	/* Ast/sexp.scm 405 */
									obj_t BgL_argz00_8816;

									BgL_argz00_8816 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_8805));
									if (CBOOL(BgL_argz00_8816))
										{
											obj_t BgL_varsz00_28645;

											BgL_varsz00_28645 = BgL_argz00_8816;
											BgL_varsz00_8805 = BgL_varsz00_28645;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_28646;

											BgL_varsz00_28646 = BNIL;
											BgL_varsz00_8805 = BgL_varsz00_28646;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 410 */
									bool_t BgL_test9903z00_28647;

									{	/* Ast/sexp.scm 410 */
										obj_t BgL_tmpz00_28648;

										BgL_tmpz00_28648 = CAR(BgL_varsz00_8805);
										BgL_test9903z00_28647 = SYMBOLP(BgL_tmpz00_28648);
									}
									if (BgL_test9903z00_28647)
										{	/* Ast/sexp.scm 410 */
											if (NULLP(BgL_argsz00_8806))
												{	/* Ast/sexp.scm 416 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_13244,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string7413z00zzast_sexpz00, BgL_expz00_13245,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 423 */
													obj_t BgL_arg6894z00_8824;
													obj_t BgL_arg6895z00_8825;

													{	/* Ast/sexp.scm 423 */
														obj_t BgL_arg6896z00_8826;
														obj_t BgL_arg6897z00_8827;

														BgL_arg6896z00_8826 = CAR(BgL_varsz00_8805);
														BgL_arg6897z00_8827 =
															CAR(((obj_t) BgL_argsz00_8806));
														{	/* Ast/sexp.scm 423 */
															obj_t BgL_list6898z00_8828;

															{	/* Ast/sexp.scm 423 */
																obj_t BgL_arg6899z00_8829;

																BgL_arg6899z00_8829 =
																	MAKE_YOUNG_PAIR(BgL_arg6897z00_8827, BNIL);
																BgL_list6898z00_8828 =
																	MAKE_YOUNG_PAIR(BgL_arg6896z00_8826,
																	BgL_arg6899z00_8829);
															}
															BgL_arg6894z00_8824 = BgL_list6898z00_8828;
														}
													}
													{	/* Ast/sexp.scm 424 */
														obj_t BgL_arg6900z00_8830;
														obj_t BgL_arg6901z00_8831;

														BgL_arg6900z00_8830 = CDR(BgL_varsz00_8805);
														BgL_arg6901z00_8831 =
															CDR(((obj_t) BgL_argsz00_8806));
														BgL_arg6895z00_8825 =
															BGl_loopze70ze7zzast_sexpz00(BgL_expz00_13245,
															BgL_locz00_13244, BgL_arg6900z00_8830,
															BgL_arg6901z00_8831);
													}
													return
														MAKE_YOUNG_PAIR(BgL_arg6894z00_8824,
														BgL_arg6895z00_8825);
												}
										}
									else
										{	/* Ast/sexp.scm 410 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_13244,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string7414z00zzast_sexpz00, BgL_expz00_13245, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 400 */
							obj_t BgL_arg6907z00_8837;

							{	/* Ast/sexp.scm 400 */
								obj_t BgL_arg6909z00_8839;

								BgL_arg6909z00_8839 =
									BGl_liipze70ze7zzast_sexpz00(BgL_argsz00_8806);
								{	/* Ast/sexp.scm 397 */
									obj_t BgL_list6910z00_8840;

									{	/* Ast/sexp.scm 397 */
										obj_t BgL_arg6911z00_8841;

										BgL_arg6911z00_8841 =
											MAKE_YOUNG_PAIR(BgL_arg6909z00_8839, BNIL);
										BgL_list6910z00_8840 =
											MAKE_YOUNG_PAIR(BgL_varsz00_8805, BgL_arg6911z00_8841);
									}
									BgL_arg6907z00_8837 = BgL_list6910z00_8840;
								}
							}
							{	/* Ast/sexp.scm 396 */
								obj_t BgL_list6908z00_8838;

								BgL_list6908z00_8838 =
									MAKE_YOUNG_PAIR(BgL_arg6907z00_8837, BNIL);
								return BgL_list6908z00_8838;
							}
						}
				}
		}

	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_13202,
		obj_t BgL_expz00_13203, obj_t BgL_stackz00_13204, obj_t BgL_locz00_13205,
		obj_t BgL_sitez00_13206)
	{
		{	/* Ast/sexp.scm 114 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13203, BgL_stackz00_13204,
				BgL_locz00_13205, BgL_sitez00_13206);
		}

	}



/* &<@anonymous:6924> */
	obj_t BGl_z62zc3z04anonymousza36924ze3ze5zzast_sexpz00(obj_t BgL_envz00_13207,
		obj_t BgL_objz00_13209, obj_t BgL_procz00_13210, obj_t BgL_msgz00_13211)
	{
		{	/* Ast/sexp.scm 429 */
			return
				BGl_userzd2errorzf2locationz20zztools_errorz00(PROCEDURE_REF
				(BgL_envz00_13207, (int) (((long) 0))), BgL_objz00_13209,
				BgL_procz00_13210, BgL_msgz00_13211, BNIL);
		}

	}



/* lambda->node */
	BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_25,
		obj_t BgL_stackz00_26, obj_t BgL_locz00_27, obj_t BgL_sitez00_28,
		obj_t BgL_prefnamez00_29)
	{
		{	/* Ast/sexp.scm 574 */
			{
				obj_t BgL_argsz00_9031;
				obj_t BgL_bodyz00_9032;

				if (PAIRP(BgL_expz00_25))
					{	/* Ast/sexp.scm 575 */
						obj_t BgL_cdrzd262408zd2_9037;

						BgL_cdrzd262408zd2_9037 = CDR(BgL_expz00_25);
						if (PAIRP(BgL_cdrzd262408zd2_9037))
							{	/* Ast/sexp.scm 575 */
								BgL_argsz00_9031 = CAR(BgL_cdrzd262408zd2_9037);
								BgL_bodyz00_9032 = CDR(BgL_cdrzd262408zd2_9037);
								{	/* Ast/sexp.scm 577 */
									obj_t BgL_locz00_9041;
									obj_t BgL_funz00_9042;

									BgL_locz00_9041 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 578 */
										obj_t BgL_list7038z00_9052;

										BgL_list7038z00_9052 =
											MAKE_YOUNG_PAIR(BgL_prefnamez00_29, BNIL);
										BgL_funz00_9042 =
											BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_27,
											BgL_list7038z00_9052);
									}
									{	/* Ast/sexp.scm 579 */
										obj_t BgL_arg7029z00_9043;

										{	/* Ast/sexp.scm 579 */
											obj_t BgL_arg7030z00_9044;
											obj_t BgL_arg7031z00_9045;

											BgL_arg7030z00_9044 =
												BGl_labelszd2symzd2zzast_labelsz00();
											{	/* Ast/sexp.scm 579 */
												obj_t BgL_arg7032z00_9046;
												obj_t BgL_arg7033z00_9047;

												{	/* Ast/sexp.scm 579 */
													obj_t BgL_arg7034z00_9048;

													{	/* Ast/sexp.scm 579 */
														obj_t BgL_arg7035z00_9049;

														{	/* Ast/sexp.scm 579 */
															obj_t BgL_arg7036z00_9050;

															BgL_arg7036z00_9050 =
																MAKE_YOUNG_PAIR
																(BGl_normaliza7ezd2prognz75zztools_prognz00
																(BgL_bodyz00_9032), BNIL);
															BgL_arg7035z00_9049 =
																MAKE_YOUNG_PAIR(BgL_argsz00_9031,
																BgL_arg7036z00_9050);
														}
														BgL_arg7034z00_9048 =
															MAKE_YOUNG_PAIR(BgL_funz00_9042,
															BgL_arg7035z00_9049);
													}
													BgL_arg7032z00_9046 =
														MAKE_YOUNG_PAIR(BgL_arg7034z00_9048, BNIL);
												}
												BgL_arg7033z00_9047 =
													MAKE_YOUNG_PAIR(BgL_funz00_9042, BNIL);
												BgL_arg7031z00_9045 =
													MAKE_YOUNG_PAIR(BgL_arg7032z00_9046,
													BgL_arg7033z00_9047);
											}
											BgL_arg7029z00_9043 =
												MAKE_YOUNG_PAIR(BgL_arg7030z00_9044,
												BgL_arg7031z00_9045);
										}
										return
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7029z00_9043,
											BgL_stackz00_26, BgL_locz00_9041, BgL_sitez00_28);
									}
								}
							}
						else
							{	/* Ast/sexp.scm 575 */
							BgL_tagzd262401zd2_9034:
								{	/* Ast/sexp.scm 586 */
									obj_t BgL_arg7039z00_9053;

									BgL_arg7039z00_9053 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 584 */
										BgL_nodez00_bglt BgL_res7384z00_13004;

										{	/* Ast/sexp.scm 726 */
											obj_t BgL_arg7138z00_13000;
											BgL_nodez00_bglt BgL_arg7139z00_13001;

											BgL_arg7138z00_13000 =
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00());
											BgL_arg7139z00_13001 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
														(long) 4)), BNIL, BgL_arg7039z00_9053,
												CNST_TABLE_REF(((long) 2)));
											{	/* Ast/sexp.scm 725 */
												obj_t BgL_list7140z00_13003;

												BgL_list7140z00_13003 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg7139z00_13001), BNIL);
												BgL_res7384z00_13004 =
													((BgL_nodez00_bglt)
													BGl_userzd2errorzf2locationz20zztools_errorz00
													(BgL_arg7039z00_9053, BgL_arg7138z00_13000,
														BGl_string7415z00zzast_sexpz00, BgL_expz00_25,
														BgL_list7140z00_13003));
										}}
										return BgL_res7384z00_13004;
									}
								}
							}
					}
				else
					{	/* Ast/sexp.scm 575 */
						goto BgL_tagzd262401zd2_9034;
					}
			}
		}

	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_30,
		obj_t BgL_locz00_31, obj_t BgL_sitez00_32)
	{
		{	/* Ast/sexp.scm 591 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_30), BgL_locz00_31, BgL_sitez00_32);
			{	/* Ast/sexp.scm 593 */
				bool_t BgL_test9907z00_28709;

				if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 593 */
						BgL_test9907z00_28709 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 593 */
						BgL_valuez00_bglt BgL_arg7062z00_9085;

						BgL_arg7062z00_9085 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_valuez00);
						BgL_test9907z00_28709 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_arg7062z00_9085), BGl_funz00zzast_varz00);
					}
				if (BgL_test9907z00_28709)
					{	/* Ast/sexp.scm 594 */
						bool_t BgL_test9909z00_28717;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_30,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 595 */
								bool_t BgL_test9911z00_28720;

								{	/* Ast/sexp.scm 595 */
									BgL_valuez00_bglt BgL_arg7059z00_9079;

									BgL_arg7059z00_9079 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_30))))->BgL_valuez00);
									BgL_test9911z00_28720 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg7059z00_9079), BGl_cfunz00zzast_varz00);
								}
								if (BgL_test9911z00_28720)
									{	/* Ast/sexp.scm 596 */
										bool_t BgL_test9912z00_28726;

										{	/* Ast/sexp.scm 596 */
											obj_t BgL_arg7058z00_9078;

											BgL_arg7058z00_9078 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_test9912z00_28726 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg7058z00_9078)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_test9912z00_28726)
											{	/* Ast/sexp.scm 596 */
												BgL_test9909z00_28717 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 596 */
												if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 30))))
													{	/* Ast/sexp.scm 597 */
														BgL_test9909z00_28717 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 597 */
														BgL_test9909z00_28717 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 595 */
										BgL_test9909z00_28717 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 594 */
								BgL_test9909z00_28717 = ((bool_t) 0);
							}
						if (BgL_test9909z00_28717)
							{	/* Ast/sexp.scm 599 */
								obj_t BgL_arg7052z00_9066;

								{	/* Ast/sexp.scm 599 */
									obj_t BgL_arg7053z00_9067;

									{	/* Ast/sexp.scm 599 */
										obj_t BgL_arg7055z00_9069;

										BgL_arg7055z00_9069 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg7053z00_9067 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg7055z00_9069)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 599 */
										obj_t BgL_list7054z00_9068;

										BgL_list7054z00_9068 =
											MAKE_YOUNG_PAIR(BgL_arg7053z00_9067, BNIL);
										BgL_arg7052z00_9066 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string7416z00zzast_sexpz00, BgL_list7054z00_9068);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg7052z00_9066, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_31);
							}
						else
							{	/* Ast/sexp.scm 600 */
								BgL_closurez00_bglt BgL_new1149z00_9070;

								{	/* Ast/sexp.scm 601 */
									BgL_closurez00_bglt BgL_new1148z00_9072;

									BgL_new1148z00_9072 =
										((BgL_closurez00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 601 */
										long BgL_arg7057z00_9073;

										BgL_arg7057z00_9073 =
											BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1148z00_9072),
											BgL_arg7057z00_9073);
									}
									BgL_new1149z00_9070 = BgL_new1148z00_9072;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1149z00_9070)))->
										BgL_locz00) = ((obj_t) BgL_locz00_31), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_28745;

									{	/* Ast/sexp.scm 602 */
										BgL_typez00_bglt BgL_arg7056z00_9071;

										BgL_arg7056z00_9071 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
										BgL_auxz00_28745 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg7056z00_9071);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_new1149z00_9070)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_28745), BUNSPEC);
								}
								((((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_new1149z00_9070)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1149z00_9070);
							}
					}
				else
					{	/* Ast/sexp.scm 604 */
						BgL_varz00_bglt BgL_new1151z00_9080;

						{	/* Ast/sexp.scm 605 */
							BgL_varz00_bglt BgL_new1150z00_9082;

							BgL_new1150z00_9082 =
								((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 605 */
								long BgL_arg7061z00_9083;

								BgL_arg7061z00_9083 = BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1150z00_9082),
									BgL_arg7061z00_9083);
							}
							BgL_new1151z00_9080 = BgL_new1150z00_9082;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1151z00_9080)))->BgL_locz00) =
							((obj_t) BgL_locz00_31), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_28762;

							{	/* Ast/sexp.scm 606 */
								BgL_typez00_bglt BgL_arg7060z00_9081;

								BgL_arg7060z00_9081 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
								BgL_auxz00_28762 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg7060z00_9081);
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1151z00_9080)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_28762), BUNSPEC);
						}
						((((BgL_varz00_bglt) COBJECT(BgL_new1151z00_9080))->
								BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1151z00_9080);
					}
			}
		}

	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_33,
		obj_t BgL_stackz00_34, obj_t BgL_locz00_35, obj_t BgL_sitez00_36)
	{
		{	/* Ast/sexp.scm 612 */
			{	/* Ast/sexp.scm 613 */
				obj_t BgL_callerz00_9086;
				obj_t BgL_locz00_9087;

				BgL_callerz00_9086 = CAR(((obj_t) BgL_expz00_33));
				BgL_locz00_9087 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_33,
					BgL_locz00_35);
				if (SYMBOLP(BgL_callerz00_9086))
					{	/* Ast/sexp.scm 617 */
						obj_t BgL_pidz00_9089;

						BgL_pidz00_9089 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_9086,
							BgL_locz00_9087);
						{	/* Ast/sexp.scm 617 */
							obj_t BgL_idz00_9090;

							BgL_idz00_9090 = CAR(BgL_pidz00_9089);
							{	/* Ast/sexp.scm 618 */
								obj_t BgL_typez00_9091;

								BgL_typez00_9091 = CDR(BgL_pidz00_9089);
								{	/* Ast/sexp.scm 619 */

									if ((BgL_idz00_9090 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 620 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_9091),
												BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9087,
												BgL_sitez00_36);
										}
									else
										{	/* Ast/sexp.scm 620 */
											if ((BgL_idz00_9090 == CNST_TABLE_REF(((long) 21))))
												{	/* Ast/sexp.scm 624 */
													bool_t BgL_test9917z00_28788;

													{	/* Ast/sexp.scm 624 */
														obj_t BgL_tmpz00_28789;

														BgL_tmpz00_28789 = CDR(((obj_t) BgL_expz00_33));
														BgL_test9917z00_28788 = PAIRP(BgL_tmpz00_28789);
													}
													if (BgL_test9917z00_28788)
														{	/* Ast/sexp.scm 628 */
															BgL_feffectz00_bglt BgL_arg7068z00_9097;
															obj_t BgL_arg7069z00_9098;

															{	/* Ast/sexp.scm 628 */
																obj_t BgL_arg7070z00_9099;

																{	/* Ast/sexp.scm 628 */
																	obj_t BgL_pairz00_13031;

																	BgL_pairz00_13031 =
																		CDR(((obj_t) BgL_expz00_33));
																	BgL_arg7070z00_9099 = CAR(BgL_pairz00_13031);
																}
																BgL_arg7068z00_9097 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg7070z00_9099);
															}
															{	/* Ast/sexp.scm 629 */
																obj_t BgL_arg7071z00_9100;
																obj_t BgL_arg7072z00_9101;

																{	/* Ast/sexp.scm 629 */
																	obj_t BgL_arg7073z00_9102;

																	BgL_arg7073z00_9102 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg7071z00_9100 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg7073z00_9102);
																}
																{	/* Ast/sexp.scm 629 */
																	obj_t BgL_auxz00_28801;

																	{	/* Ast/sexp.scm 629 */
																		obj_t BgL_pairz00_13035;

																		BgL_pairz00_13035 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_auxz00_28801 = CDR(BgL_pairz00_13035);
																	}
																	BgL_arg7072z00_9101 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_28801, BNIL);
																}
																BgL_arg7069z00_9098 =
																	MAKE_YOUNG_PAIR(BgL_arg7071z00_9100,
																	BgL_arg7072z00_9101);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg7068z00_9097),
																((BgL_typez00_bglt) BgL_typez00_9091),
																BgL_arg7069z00_9098, BgL_stackz00_34,
																BgL_locz00_9087, BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 627 */
															obj_t BgL_arg7075z00_9104;

															BgL_arg7075z00_9104 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_33, BgL_locz00_9087);
															{	/* Ast/sexp.scm 625 */
																BgL_nodez00_bglt BgL_res7385z00_13041;

																{	/* Ast/sexp.scm 726 */
																	obj_t BgL_arg7138z00_13037;
																	BgL_nodez00_bglt BgL_arg7139z00_13038;

																	BgL_arg7138z00_13037 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg7139z00_13038 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg7075z00_9104,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 725 */
																		obj_t BgL_list7140z00_13040;

																		BgL_list7140z00_13040 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_arg7139z00_13038), BNIL);
																		BgL_res7385z00_13041 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg7075z00_9104,
																				BgL_arg7138z00_13037,
																				BGl_string7417z00zzast_sexpz00,
																				BgL_expz00_33, BgL_list7140z00_13040));
																}}
																return BgL_res7385z00_13041;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 620 */
													if ((BgL_idz00_9090 == CNST_TABLE_REF(((long) 22))))
														{	/* Ast/sexp.scm 620 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_9091),
																BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9087,
																BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 620 */
															if (
																(BgL_idz00_9090 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 634 */
																	bool_t BgL_test9920z00_28828;

																	{	/* Ast/sexp.scm 634 */
																		obj_t BgL_tmpz00_28829;

																		BgL_tmpz00_28829 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_test9920z00_28828 =
																			PAIRP(BgL_tmpz00_28829);
																	}
																	if (BgL_test9920z00_28828)
																		{	/* Ast/sexp.scm 638 */
																			BgL_feffectz00_bglt BgL_arg7081z00_9110;
																			obj_t BgL_arg7082z00_9111;

																			{	/* Ast/sexp.scm 638 */
																				obj_t BgL_arg7083z00_9112;

																				{	/* Ast/sexp.scm 638 */
																					obj_t BgL_pairz00_13048;

																					BgL_pairz00_13048 =
																						CDR(((obj_t) BgL_expz00_33));
																					BgL_arg7083z00_9112 =
																						CAR(BgL_pairz00_13048);
																				}
																				BgL_arg7081z00_9110 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg7083z00_9112);
																			}
																			{	/* Ast/sexp.scm 639 */
																				obj_t BgL_arg7084z00_9113;
																				obj_t BgL_arg7085z00_9114;

																				{	/* Ast/sexp.scm 639 */
																					obj_t BgL_arg7086z00_9115;

																					BgL_arg7086z00_9115 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 34)), BNIL);
																					BgL_arg7084z00_9113 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 35)),
																						BgL_arg7086z00_9115);
																				}
																				{	/* Ast/sexp.scm 639 */
																					obj_t BgL_auxz00_28841;

																					{	/* Ast/sexp.scm 639 */
																						obj_t BgL_pairz00_13052;

																						BgL_pairz00_13052 =
																							CDR(((obj_t) BgL_expz00_33));
																						BgL_auxz00_28841 =
																							CDR(BgL_pairz00_13052);
																					}
																					BgL_arg7085z00_9114 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_28841, BNIL);
																				}
																				BgL_arg7082z00_9111 =
																					MAKE_YOUNG_PAIR(BgL_arg7084z00_9113,
																					BgL_arg7085z00_9114);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg7081z00_9110),
																				((BgL_typez00_bglt) BgL_typez00_9091),
																				BgL_arg7082z00_9111, BgL_stackz00_34,
																				BgL_locz00_9087, BgL_sitez00_36);
																		}
																	else
																		{	/* Ast/sexp.scm 637 */
																			obj_t BgL_arg7088z00_9117;

																			BgL_arg7088z00_9117 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_33, BgL_locz00_9087);
																			{	/* Ast/sexp.scm 635 */
																				BgL_nodez00_bglt BgL_res7386z00_13058;

																				{	/* Ast/sexp.scm 726 */
																					obj_t BgL_arg7138z00_13054;
																					BgL_nodez00_bglt BgL_arg7139z00_13055;

																					BgL_arg7138z00_13054 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg7139z00_13055 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg7088z00_9117,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 725 */
																						obj_t BgL_list7140z00_13057;

																						BgL_list7140z00_13057 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_arg7139z00_13055),
																							BNIL);
																						BgL_res7386z00_13058 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg7088z00_9117,
																								BgL_arg7138z00_13054,
																								BGl_string7418z00zzast_sexpz00,
																								BgL_expz00_33,
																								BgL_list7140z00_13057));
																				}}
																				return BgL_res7386z00_13058;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 620 */
																	if (
																		(BgL_idz00_9090 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_9120;
																			obj_t BgL_bodyz00_9121;

																			if (PAIRP(BgL_expz00_33))
																				{	/* Ast/sexp.scm 642 */
																					obj_t BgL_cdrzd262423zd2_9126;

																					BgL_cdrzd262423zd2_9126 =
																						CDR(BgL_expz00_33);
																					if (PAIRP(BgL_cdrzd262423zd2_9126))
																						{	/* Ast/sexp.scm 642 */
																							BgL_argsz00_9120 =
																								CAR(BgL_cdrzd262423zd2_9126);
																							BgL_bodyz00_9121 =
																								CDR(BgL_cdrzd262423zd2_9126);
																							{	/* Ast/sexp.scm 644 */
																								obj_t BgL_locz00_9130;

																								BgL_locz00_9130 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_33,
																									BgL_locz00_9087);
																								{	/* Ast/sexp.scm 644 */
																									obj_t BgL_funz00_9131;

																									BgL_funz00_9131 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 645 */
																										obj_t BgL_tfunz00_9132;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_9091)))
																											{	/* Ast/sexp.scm 647 */
																												obj_t
																													BgL_arg7105z00_9143;
																												BgL_arg7105z00_9143 =
																													(((BgL_typez00_bglt)
																														COBJECT((
																																(BgL_typez00_bglt)
																																BgL_typez00_9091)))->
																													BgL_idz00);
																												BgL_tfunz00_9132 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_9131,
																													BgL_arg7105z00_9143);
																											}
																										else
																											{	/* Ast/sexp.scm 646 */
																												BgL_tfunz00_9132 =
																													BgL_funz00_9131;
																											}
																										{	/* Ast/sexp.scm 646 */

																											{	/* Ast/sexp.scm 650 */
																												obj_t
																													BgL_arg7095z00_9133;
																												{	/* Ast/sexp.scm 650 */
																													obj_t
																														BgL_arg7096z00_9134;
																													obj_t
																														BgL_arg7097z00_9135;
																													BgL_arg7096z00_9134 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 650 */
																														obj_t
																															BgL_arg7098z00_9136;
																														obj_t
																															BgL_arg7099z00_9137;
																														{	/* Ast/sexp.scm 650 */
																															obj_t
																																BgL_arg7100z00_9138;
																															{	/* Ast/sexp.scm 650 */
																																obj_t
																																	BgL_arg7101z00_9139;
																																{	/* Ast/sexp.scm 650 */
																																	obj_t
																																		BgL_arg7102z00_9140;
																																	BgL_arg7102z00_9140
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_9121),
																																		BNIL);
																																	BgL_arg7101z00_9139
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_argsz00_9120,
																																		BgL_arg7102z00_9140);
																																}
																																BgL_arg7100z00_9138
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_tfunz00_9132,
																																	BgL_arg7101z00_9139);
																															}
																															BgL_arg7098z00_9136
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg7100z00_9138,
																																BNIL);
																														}
																														BgL_arg7099z00_9137
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_funz00_9131,
																															BNIL);
																														BgL_arg7097z00_9135
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg7098z00_9136,
																															BgL_arg7099z00_9137);
																													}
																													BgL_arg7095z00_9133 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg7096z00_9134,
																														BgL_arg7097z00_9135);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg7095z00_9133,
																													BgL_stackz00_34,
																													BgL_locz00_9130,
																													BgL_sitez00_36);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 642 */
																						BgL_tagzd262416zd2_9123:
																							{	/* Ast/sexp.scm 656 */
																								BgL_nodez00_bglt
																									BgL_res7387z00_13066;
																								{	/* Ast/sexp.scm 726 */
																									obj_t BgL_arg7138z00_13062;
																									BgL_nodez00_bglt
																										BgL_arg7139z00_13063;
																									BgL_arg7138z00_13062 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg7139z00_13063 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_9087,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 725 */
																										obj_t BgL_list7140z00_13065;

																										BgL_list7140z00_13065 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_arg7139z00_13063),
																											BNIL);
																										BgL_res7387z00_13066 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_9087,
																												BgL_arg7138z00_13062,
																												BGl_string7419z00zzast_sexpz00,
																												BgL_expz00_33,
																												BgL_list7140z00_13065));
																								}}
																								return BgL_res7387z00_13066;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 642 */
																					goto BgL_tagzd262416zd2_9123;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 620 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_33, BgL_stackz00_34,
																				BgL_locz00_9087, BgL_sitez00_36);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 615 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_33,
							BgL_stackz00_34, BgL_locz00_9087, BgL_sitez00_36);
					}
			}
		}

	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_37, obj_t BgL_stackz00_38, obj_t BgL_locz00_39,
		obj_t BgL_sitez00_40)
	{
		{	/* Ast/sexp.scm 664 */
			{
				obj_t BgL_expsz00_9147;
				obj_t BgL_resz00_9148;
				obj_t BgL_locz00_9149;

				BgL_expsz00_9147 = BgL_expza2za2_37;
				BgL_resz00_9148 = BNIL;
				BgL_locz00_9149 = BgL_locz00_39;
			BgL_zc3z04anonymousza37107ze3z87_9150:
				if (NULLP(BgL_expsz00_9147))
					{	/* Ast/sexp.scm 670 */
						BgL_nodez00_bglt BgL_res7388z00_13075;

						{	/* Ast/sexp.scm 726 */
							obj_t BgL_arg7138z00_13071;
							BgL_nodez00_bglt BgL_arg7139z00_13072;

							BgL_arg7138z00_13071 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg7139z00_13072 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_9149, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 725 */
								obj_t BgL_list7140z00_13074;

								BgL_list7140z00_13074 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_arg7139z00_13072), BNIL);
								BgL_res7388z00_13075 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_9149, BgL_arg7138z00_13071,
										BGl_string7420z00zzast_sexpz00, BgL_expsz00_9147,
										BgL_list7140z00_13074));
						}}
						return ((obj_t) BgL_res7388z00_13075);
					}
				else
					{	/* Ast/sexp.scm 669 */
						if (NULLP(CDR(((obj_t) BgL_expsz00_9147))))
							{	/* Ast/sexp.scm 672 */
								obj_t BgL_locz00_9154;
								obj_t BgL_nsitez00_9155;

								{	/* Ast/sexp.scm 672 */
									obj_t BgL_arg7114z00_9159;
									obj_t BgL_arg7115z00_9160;

									BgL_arg7114z00_9159 = CAR(((obj_t) BgL_expsz00_9147));
									BgL_arg7115z00_9160 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9147, BgL_locz00_9149);
									BgL_locz00_9154 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7114z00_9159, BgL_arg7115z00_9160);
								}
								if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 674 */
										BgL_nsitez00_9155 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 674 */
										BgL_nsitez00_9155 = BgL_sitez00_40;
									}
								{	/* Ast/sexp.scm 675 */
									obj_t BgL_arg7111z00_9156;

									{	/* Ast/sexp.scm 675 */
										BgL_nodez00_bglt BgL_arg7112z00_9157;

										{	/* Ast/sexp.scm 675 */
											obj_t BgL_arg7113z00_9158;

											BgL_arg7113z00_9158 = CAR(((obj_t) BgL_expsz00_9147));
											BgL_arg7112z00_9157 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7113z00_9158,
												BgL_stackz00_38, BgL_locz00_9154, BgL_nsitez00_9155);
										}
										BgL_arg7111z00_9156 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7112z00_9157), BgL_resz00_9148);
									}
									return bgl_reverse_bang(BgL_arg7111z00_9156);
								}
							}
						else
							{	/* Ast/sexp.scm 677 */
								obj_t BgL_locz00_9162;

								{	/* Ast/sexp.scm 677 */
									obj_t BgL_arg7121z00_9167;
									obj_t BgL_arg7122z00_9168;

									BgL_arg7121z00_9167 = CAR(((obj_t) BgL_expsz00_9147));
									BgL_arg7122z00_9168 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9147, BgL_locz00_9149);
									BgL_locz00_9162 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7121z00_9167, BgL_arg7122z00_9168);
								}
								{	/* Ast/sexp.scm 679 */
									obj_t BgL_arg7117z00_9163;
									obj_t BgL_arg7118z00_9164;

									BgL_arg7117z00_9163 = CDR(((obj_t) BgL_expsz00_9147));
									{	/* Ast/sexp.scm 680 */
										BgL_nodez00_bglt BgL_arg7119z00_9165;

										{	/* Ast/sexp.scm 680 */
											obj_t BgL_arg7120z00_9166;

											BgL_arg7120z00_9166 = CAR(((obj_t) BgL_expsz00_9147));
											BgL_arg7119z00_9165 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7120z00_9166,
												BgL_stackz00_38, BgL_locz00_9162,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg7118z00_9164 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7119z00_9165), BgL_resz00_9148);
									}
									{
										obj_t BgL_locz00_28945;
										obj_t BgL_resz00_28944;
										obj_t BgL_expsz00_28943;

										BgL_expsz00_28943 = BgL_arg7117z00_9163;
										BgL_resz00_28944 = BgL_arg7118z00_9164;
										BgL_locz00_28945 = BgL_locz00_9162;
										BgL_locz00_9149 = BgL_locz00_28945;
										BgL_resz00_9148 = BgL_resz00_28944;
										BgL_expsz00_9147 = BgL_expsz00_28943;
										goto BgL_zc3z04anonymousza37107ze3z87_9150;
									}
								}
							}
					}
			}
		}

	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_13214,
		obj_t BgL_expza2za2_13215, obj_t BgL_stackz00_13216, obj_t BgL_locz00_13217,
		obj_t BgL_sitez00_13218)
	{
		{	/* Ast/sexp.scm 664 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_13215,
				BgL_stackz00_13216, BgL_locz00_13217, BgL_sitez00_13218);
		}

	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_41,
		obj_t BgL_stackz00_42)
	{
		{	/* Ast/sexp.scm 693 */
			{	/* Ast/sexp.scm 694 */
				bool_t BgL_test9928z00_28947;

				if ((BgL_namez00_41 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 694 */
						BgL_test9928z00_28947 =
							(BgL_stackz00_42 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 694 */
						BgL_test9928z00_28947 = ((bool_t) 0);
					}
				if (BgL_test9928z00_28947)
					{	/* Ast/sexp.scm 694 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 694 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_41;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_42;
						{
							obj_t BgL_stackz00_9174;

							BgL_stackz00_9174 = BgL_stackz00_42;
						BgL_zc3z04anonymousza37126ze3z87_9175:
							if (NULLP(BgL_stackz00_9174))
								{	/* Ast/sexp.scm 701 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 701 */
									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_stackz00_9174))))))->
												BgL_idz00) == BgL_namez00_41))
										{	/* Ast/sexp.scm 704 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(((obj_t) BgL_stackz00_9174));
											return CAR(((obj_t) BgL_stackz00_9174));
										}
									else
										{	/* Ast/sexp.scm 708 */
											obj_t BgL_arg7131z00_9180;

											BgL_arg7131z00_9180 = CDR(((obj_t) BgL_stackz00_9174));
											{
												obj_t BgL_stackz00_28966;

												BgL_stackz00_28966 = BgL_arg7131z00_9180;
												BgL_stackz00_9174 = BgL_stackz00_28966;
												goto BgL_zc3z04anonymousza37126ze3z87_9175;
											}
										}
								}
						}
					}
			}
		}

	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_13219,
		obj_t BgL_namez00_13220, obj_t BgL_stackz00_13221)
	{
		{	/* Ast/sexp.scm 693 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_13220, BgL_stackz00_13221);
		}

	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_43,
		obj_t BgL_locz00_44, obj_t BgL_sitez00_45)
	{
		{	/* Ast/sexp.scm 713 */
			if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 716 */
					obj_t BgL_vz00_13088;

					BgL_vz00_13088 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_accessz00) =
						((obj_t) BgL_vz00_13088), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 715 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 717 */
				BgL_valuez00_bglt BgL_valz00_9186;

				BgL_valz00_9186 =
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_valuez00);
				{	/* Ast/sexp.scm 718 */
					bool_t BgL_test9933z00_28974;

					if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 718 */
							BgL_test9933z00_28974 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_9186), BGl_funz00zzast_varz00);
						}
					else
						{	/* Ast/sexp.scm 718 */
							BgL_test9933z00_28974 = ((bool_t) 0);
						}
					if (BgL_test9933z00_28974)
						{	/* Ast/sexp.scm 719 */
							obj_t BgL_arg7137z00_9189;

							BgL_arg7137z00_9189 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_43));
							{	/* Ast/sexp.scm 719 */
								BgL_nodez00_bglt BgL_res7389z00_13095;

								{	/* Ast/sexp.scm 726 */
									obj_t BgL_arg7138z00_13091;
									BgL_nodez00_bglt BgL_arg7139z00_13092;

									BgL_arg7138z00_13091 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg7139z00_13092 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_44, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 725 */
										obj_t BgL_list7140z00_13094;

										BgL_list7140z00_13094 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7139z00_13092), BNIL);
										BgL_res7389z00_13095 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_44, BgL_arg7138z00_13091,
												BGl_string7421z00zzast_sexpz00, BgL_arg7137z00_9189,
												BgL_list7140z00_13094));
								}}
								return ((obj_t) BgL_res7389z00_13095);
							}
						}
					else
						{	/* Ast/sexp.scm 718 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_13222,
		obj_t BgL_varz00_13223, obj_t BgL_locz00_13224, obj_t BgL_sitez00_13225)
	{
		{	/* Ast/sexp.scm 713 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_13223), BgL_locz00_13224,
				BgL_sitez00_13225);
		}

	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_46,
		obj_t BgL_expz00_47, obj_t BgL_locz00_48)
	{
		{	/* Ast/sexp.scm 724 */
			{	/* Ast/sexp.scm 726 */
				obj_t BgL_arg7138z00_9191;
				BgL_nodez00_bglt BgL_arg7139z00_9192;

				BgL_arg7138z00_9191 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg7139z00_9192 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_48, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 725 */
					obj_t BgL_list7140z00_9193;

					BgL_list7140z00_9193 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_arg7139z00_9192), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_48,
							BgL_arg7138z00_9191, BgL_msgz00_46, BgL_expz00_47,
							BgL_list7140z00_9193));
				}
			}
		}

	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13226, obj_t BgL_msgz00_13227, obj_t BgL_expz00_13228,
		obj_t BgL_locz00_13229)
	{
		{	/* Ast/sexp.scm 724 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_13227,
				BgL_expz00_13228, BgL_locz00_13229);
		}

	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_49, BgL_nodez00_bglt BgL_refz00_50)
	{
		{	/* Ast/sexp.scm 734 */
			{	/* Ast/sexp.scm 735 */
				BgL_nodez00_bglt BgL_funz00_9195;

				BgL_funz00_9195 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_funz00_9195),
						BGl_varz00zzast_nodez00))
					{	/* Ast/sexp.scm 737 */
						BgL_appz00_bglt BgL_new1154z00_9197;

						{	/* Ast/sexp.scm 737 */
							BgL_appz00_bglt BgL_new1153z00_9204;

							BgL_new1153z00_9204 =
								((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_appz00_bgl))));
							{	/* Ast/sexp.scm 737 */
								long BgL_arg7149z00_9205;

								BgL_arg7149z00_9205 = BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1153z00_9204),
									BgL_arg7149z00_9205);
							}
							{	/* Ast/sexp.scm 737 */
								BgL_objectz00_bglt BgL_tmpz00_29014;

								BgL_tmpz00_29014 = ((BgL_objectz00_bglt) BgL_new1153z00_9204);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29014, BFALSE);
							}
							((BgL_objectz00_bglt) BgL_new1153z00_9204);
							BgL_new1154z00_9197 = BgL_new1153z00_9204;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1154z00_9197)))->BgL_locz00) =
							((obj_t) BFALSE), BUNSPEC);
						((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
											BgL_new1154z00_9197)))->BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1154z00_9197)))->BgL_sidezd2effectzd2) =
							((obj_t) BUNSPEC), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1154z00_9197)))->BgL_keyz00) =
							((obj_t) BINT(((long) -1))), BUNSPEC);
						((((BgL_appz00_bglt) COBJECT(BgL_new1154z00_9197))->BgL_funz00) =
							((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9195)), BUNSPEC);
						{
							obj_t BgL_auxz00_29030;

							{	/* Ast/sexp.scm 740 */
								BgL_nodez00_bglt BgL_arg7143z00_9198;

								{	/* Ast/sexp.scm 740 */
									obj_t BgL_arg7146z00_9201;

									{	/* Ast/sexp.scm 740 */
										obj_t BgL_arg7147z00_9202;

										{	/* Ast/sexp.scm 740 */
											obj_t BgL_arg7148z00_9203;

											BgL_arg7148z00_9203 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_globalz00_49)))->
												BgL_idz00);
											BgL_arg7147z00_9202 =
												MAKE_YOUNG_PAIR(BgL_arg7148z00_9203, BNIL);
										}
										BgL_arg7146z00_9201 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
											BgL_arg7147z00_9202);
									}
									BgL_arg7143z00_9198 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7146z00_9201,
										BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
								}
								{	/* Ast/sexp.scm 740 */
									obj_t BgL_list7144z00_9199;

									{	/* Ast/sexp.scm 740 */
										obj_t BgL_arg7145z00_9200;

										BgL_arg7145z00_9200 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_refz00_50), BNIL);
										BgL_list7144z00_9199 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7143z00_9198), BgL_arg7145z00_9200);
									}
									BgL_auxz00_29030 = BgL_list7144z00_9199;
							}}
							((((BgL_appz00_bglt) COBJECT(BgL_new1154z00_9197))->BgL_argsz00) =
								((obj_t) BgL_auxz00_29030), BUNSPEC);
						}
						((((BgL_appz00_bglt) COBJECT(BgL_new1154z00_9197))->
								BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1154z00_9197);
					}
				else
					{	/* Ast/sexp.scm 736 */
						return BgL_funz00_9195;
					}
			}
		}

	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13230, obj_t BgL_globalz00_13231, obj_t BgL_refz00_13232)
	{
		{	/* Ast/sexp.scm 734 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13231),
				((BgL_nodez00_bglt) BgL_refz00_13232));
		}

	}



/* define-primop-ref/src->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_51, BgL_nodez00_bglt BgL_refz00_52, obj_t BgL_srcz00_53)
	{
		{	/* Ast/sexp.scm 746 */
			if (EPAIRP(BgL_srcz00_53))
				{
					obj_t BgL_fnamez00_9207;
					obj_t BgL_locz00_9208;

					{	/* Ast/sexp.scm 749 */
						obj_t BgL_ezd262432zd2_9211;

						BgL_ezd262432zd2_9211 = CER(((obj_t) BgL_srcz00_53));
						if (PAIRP(BgL_ezd262432zd2_9211))
							{	/* Ast/sexp.scm 749 */
								obj_t BgL_cdrzd262438zd2_9213;

								BgL_cdrzd262438zd2_9213 = CDR(BgL_ezd262432zd2_9211);
								if ((CAR(BgL_ezd262432zd2_9211) == CNST_TABLE_REF(((long) 39))))
									{	/* Ast/sexp.scm 749 */
										if (PAIRP(BgL_cdrzd262438zd2_9213))
											{	/* Ast/sexp.scm 749 */
												obj_t BgL_cdrzd262442zd2_9217;

												BgL_cdrzd262442zd2_9217 = CDR(BgL_cdrzd262438zd2_9213);
												if (PAIRP(BgL_cdrzd262442zd2_9217))
													{	/* Ast/sexp.scm 749 */
														if (NULLP(CDR(BgL_cdrzd262442zd2_9217)))
															{	/* Ast/sexp.scm 749 */
																BgL_fnamez00_9207 =
																	CAR(BgL_cdrzd262438zd2_9213);
																BgL_locz00_9208 = CAR(BgL_cdrzd262442zd2_9217);
																{	/* Ast/sexp.scm 751 */
																	BgL_nodez00_bglt BgL_funz00_9225;

																	BgL_funz00_9225 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 38)), BNIL, BFALSE,
																		CNST_TABLE_REF(((long) 33)));
																	if (BGl_isazf3zf3zz__objectz00(((obj_t)
																				BgL_funz00_9225),
																			BGl_varz00zzast_nodez00))
																		{	/* Ast/sexp.scm 753 */
																			BgL_appz00_bglt BgL_new1157z00_9227;

																			{	/* Ast/sexp.scm 753 */
																				BgL_appz00_bglt BgL_new1156z00_9238;

																				BgL_new1156z00_9238 =
																					((BgL_appz00_bglt)
																					BOBJECT(GC_MALLOC(sizeof(struct
																								BgL_appz00_bgl))));
																				{	/* Ast/sexp.scm 753 */
																					long BgL_arg7173z00_9239;

																					BgL_arg7173z00_9239 =
																						BGL_CLASS_INDEX
																						(BGl_appz00zzast_nodez00);
																					BGL_OBJECT_CLASS_NUM_SET((
																							(BgL_objectz00_bglt)
																							BgL_new1156z00_9238),
																						BgL_arg7173z00_9239);
																				}
																				{	/* Ast/sexp.scm 753 */
																					BgL_objectz00_bglt BgL_tmpz00_29077;

																					BgL_tmpz00_29077 =
																						((BgL_objectz00_bglt)
																						BgL_new1156z00_9238);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_tmpz00_29077, BFALSE);
																				}
																				((BgL_objectz00_bglt)
																					BgL_new1156z00_9238);
																				BgL_new1157z00_9227 =
																					BgL_new1156z00_9238;
																			}
																			((((BgL_nodez00_bglt) COBJECT(
																							((BgL_nodez00_bglt)
																								BgL_new1157z00_9227)))->
																					BgL_locz00) =
																				((obj_t) BFALSE), BUNSPEC);
																			((((BgL_nodez00_bglt)
																						COBJECT(((BgL_nodez00_bglt)
																								BgL_new1157z00_9227)))->
																					BgL_typez00) =
																				((BgL_typez00_bglt) ((BgL_typez00_bglt)
																						BGl_za2_za2z00zztype_cachez00)),
																				BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1157z00_9227)))->
																					BgL_sidezd2effectzd2) =
																				((obj_t) BUNSPEC), BUNSPEC);
																			((((BgL_nodezf2effectzf2_bglt)
																						COBJECT(((BgL_nodezf2effectzf2_bglt)
																								BgL_new1157z00_9227)))->
																					BgL_keyz00) =
																				((obj_t) BINT(((long) -1))), BUNSPEC);
																			((((BgL_appz00_bglt)
																						COBJECT(BgL_new1157z00_9227))->
																					BgL_funz00) =
																				((BgL_varz00_bglt) ((BgL_varz00_bglt)
																						BgL_funz00_9225)), BUNSPEC);
																			{
																				obj_t BgL_auxz00_29093;

																				{	/* Ast/sexp.scm 757 */
																					BgL_nodez00_bglt BgL_arg7163z00_9228;
																					BgL_nodez00_bglt BgL_arg7164z00_9229;
																					BgL_nodez00_bglt BgL_arg7165z00_9230;

																					{	/* Ast/sexp.scm 757 */
																						obj_t BgL_arg7170z00_9235;

																						{	/* Ast/sexp.scm 757 */
																							obj_t BgL_arg7171z00_9236;

																							{	/* Ast/sexp.scm 757 */
																								obj_t BgL_arg7172z00_9237;

																								BgL_arg7172z00_9237 =
																									(((BgL_variablez00_bglt)
																										COBJECT((
																												(BgL_variablez00_bglt)
																												BgL_globalz00_51)))->
																									BgL_idz00);
																								BgL_arg7171z00_9236 =
																									MAKE_YOUNG_PAIR
																									(BgL_arg7172z00_9237, BNIL);
																							}
																							BgL_arg7170z00_9235 =
																								MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																										(long) 12)),
																								BgL_arg7171z00_9236);
																						}
																						BgL_arg7163z00_9228 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(BgL_arg7170z00_9235, BNIL,
																							BFALSE,
																							CNST_TABLE_REF(((long) 2)));
																					}
																					BgL_arg7164z00_9229 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(BgL_fnamez00_9207, BNIL, BFALSE,
																						CNST_TABLE_REF(((long) 2)));
																					BgL_arg7165z00_9230 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(BgL_locz00_9208, BNIL, BFALSE,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 756 */
																						obj_t BgL_list7166z00_9231;

																						{	/* Ast/sexp.scm 756 */
																							obj_t BgL_arg7167z00_9232;

																							{	/* Ast/sexp.scm 756 */
																								obj_t BgL_arg7168z00_9233;

																								{	/* Ast/sexp.scm 756 */
																									obj_t BgL_arg7169z00_9234;

																									BgL_arg7169z00_9234 =
																										MAKE_YOUNG_PAIR(
																										((obj_t)
																											BgL_arg7165z00_9230),
																										BNIL);
																									BgL_arg7168z00_9233 =
																										MAKE_YOUNG_PAIR(((obj_t)
																											BgL_arg7164z00_9229),
																										BgL_arg7169z00_9234);
																								}
																								BgL_arg7167z00_9232 =
																									MAKE_YOUNG_PAIR(
																									((obj_t) BgL_refz00_52),
																									BgL_arg7168z00_9233);
																							}
																							BgL_list7166z00_9231 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7163z00_9228),
																								BgL_arg7167z00_9232);
																						}
																						BgL_auxz00_29093 =
																							BgL_list7166z00_9231;
																				}}
																				((((BgL_appz00_bglt)
																							COBJECT(BgL_new1157z00_9227))->
																						BgL_argsz00) =
																					((obj_t) BgL_auxz00_29093), BUNSPEC);
																			}
																			((((BgL_appz00_bglt)
																						COBJECT(BgL_new1157z00_9227))->
																					BgL_stackablez00) =
																				((obj_t) BFALSE), BUNSPEC);
																			return ((BgL_nodez00_bglt)
																				BgL_new1157z00_9227);
																		}
																	else
																		{	/* Ast/sexp.scm 752 */
																			return BgL_funz00_9225;
																		}
																}
															}
														else
															{	/* Ast/sexp.scm 749 */
																return
																	BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
																	(BgL_globalz00_51, BgL_refz00_52);
															}
													}
												else
													{	/* Ast/sexp.scm 749 */
														return
															BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
															(BgL_globalz00_51, BgL_refz00_52);
													}
											}
										else
											{	/* Ast/sexp.scm 749 */
												return
													BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
													(BgL_globalz00_51, BgL_refz00_52);
											}
									}
								else
									{	/* Ast/sexp.scm 749 */
										return
											BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
											(BgL_globalz00_51, BgL_refz00_52);
									}
							}
						else
							{	/* Ast/sexp.scm 749 */
								return
									BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
									(BgL_globalz00_51, BgL_refz00_52);
							}
					}
				}
			else
				{	/* Ast/sexp.scm 747 */
					return
						BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
						(BgL_globalz00_51, BgL_refz00_52);
				}
		}

	}



/* &define-primop-ref/src->node */
	BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t
		BgL_envz00_13233, obj_t BgL_globalz00_13234, obj_t BgL_refz00_13235,
		obj_t BgL_srcz00_13236)
	{
		{	/* Ast/sexp.scm 746 */
			return
				BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13234),
				((BgL_nodez00_bglt) BgL_refz00_13235), BgL_srcz00_13236);
		}

	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_54)
	{
		{	/* Ast/sexp.scm 768 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_54), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 770 */
				BgL_nodez00_bglt BgL_funz00_9240;

				BgL_funz00_9240 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 40)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_funz00_9240),
						BGl_varz00zzast_nodez00))
					{	/* Ast/sexp.scm 772 */
						BgL_appz00_bglt BgL_new1159z00_9242;

						{	/* Ast/sexp.scm 772 */
							BgL_appz00_bglt BgL_new1158z00_9250;

							BgL_new1158z00_9250 =
								((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_appz00_bgl))));
							{	/* Ast/sexp.scm 772 */
								long BgL_arg7182z00_9251;

								BgL_arg7182z00_9251 = BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1158z00_9250),
									BgL_arg7182z00_9251);
							}
							{	/* Ast/sexp.scm 772 */
								BgL_objectz00_bglt BgL_tmpz00_29140;

								BgL_tmpz00_29140 = ((BgL_objectz00_bglt) BgL_new1158z00_9250);
								BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29140, BFALSE);
							}
							((BgL_objectz00_bglt) BgL_new1158z00_9250);
							BgL_new1159z00_9242 = BgL_new1158z00_9250;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1159z00_9242)))->BgL_locz00) =
							((obj_t) BFALSE), BUNSPEC);
						((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
											BgL_new1159z00_9242)))->BgL_typez00) =
							((BgL_typez00_bglt) ((BgL_typez00_bglt)
									BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1159z00_9242)))->BgL_sidezd2effectzd2) =
							((obj_t) BUNSPEC), BUNSPEC);
						((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt)
											BgL_new1159z00_9242)))->BgL_keyz00) =
							((obj_t) BINT(((long) -1))), BUNSPEC);
						((((BgL_appz00_bglt) COBJECT(BgL_new1159z00_9242))->BgL_funz00) =
							((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9240)), BUNSPEC);
						{
							obj_t BgL_auxz00_29156;

							{	/* Ast/sexp.scm 775 */
								BgL_nodez00_bglt BgL_arg7175z00_9243;
								BgL_nodez00_bglt BgL_arg7176z00_9244;

								{	/* Ast/sexp.scm 775 */
									obj_t BgL_arg7179z00_9247;

									{	/* Ast/sexp.scm 775 */
										obj_t BgL_arg7180z00_9248;

										{	/* Ast/sexp.scm 775 */
											obj_t BgL_arg7181z00_9249;

											BgL_arg7181z00_9249 =
												(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_globalz00_54)))->
												BgL_idz00);
											BgL_arg7180z00_9248 =
												MAKE_YOUNG_PAIR(BgL_arg7181z00_9249, BNIL);
										}
										BgL_arg7179z00_9247 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
											BgL_arg7180z00_9248);
									}
									BgL_arg7175z00_9243 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7179z00_9247,
										BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
								}
								BgL_arg7176z00_9244 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(
									((obj_t) BgL_globalz00_54), BNIL, BFALSE,
									CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 775 */
									obj_t BgL_list7177z00_9245;

									{	/* Ast/sexp.scm 775 */
										obj_t BgL_arg7178z00_9246;

										BgL_arg7178z00_9246 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7176z00_9244), BNIL);
										BgL_list7177z00_9245 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7175z00_9243), BgL_arg7178z00_9246);
									}
									BgL_auxz00_29156 = BgL_list7177z00_9245;
							}}
							((((BgL_appz00_bglt) COBJECT(BgL_new1159z00_9242))->BgL_argsz00) =
								((obj_t) BgL_auxz00_29156), BUNSPEC);
						}
						((((BgL_appz00_bglt) COBJECT(BgL_new1159z00_9242))->
								BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1159z00_9242);
					}
				else
					{	/* Ast/sexp.scm 771 */
						return BgL_funz00_9240;
					}
			}
		}

	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13237, obj_t BgL_globalz00_13238)
	{
		{	/* Ast/sexp.scm 768 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13238));
		}

	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_55)
	{
		{	/* Ast/sexp.scm 782 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_55), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 784 */
				BgL_nodez00_bglt BgL_funz00_9252;

				BgL_funz00_9252 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 41)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				if (BGl_isazf3zf3zz__objectz00(((obj_t) BgL_funz00_9252),
						BGl_varz00zzast_nodez00))
					{	/* Ast/sexp.scm 786 */
						obj_t BgL_exprz00_9254;

						{	/* Ast/sexp.scm 786 */
							bool_t BgL_test9945z00_29185;

							{	/* Ast/sexp.scm 786 */
								obj_t BgL_arg7191z00_9264;

								BgL_arg7191z00_9264 =
									BGl_thezd2backendzd2zzbackend_backendz00();
								BgL_test9945z00_29185 =
									(((BgL_backendz00_bglt) COBJECT(
											((BgL_backendz00_bglt) BgL_arg7191z00_9264)))->
									BgL_pragmazd2supportzd2);
							}
							if (BgL_test9945z00_29185)
								{	/* Ast/sexp.scm 787 */
									obj_t BgL_arg7189z00_9262;

									{	/* Ast/sexp.scm 787 */
										obj_t BgL_arg7190z00_9263;

										BgL_arg7190z00_9263 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_55), BNIL);
										BgL_arg7189z00_9262 =
											MAKE_YOUNG_PAIR(BGl_string7422z00zzast_sexpz00,
											BgL_arg7190z00_9263);
									}
									BgL_exprz00_9254 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 42)),
										BgL_arg7189z00_9262);
								}
							else
								{	/* Ast/sexp.scm 786 */
									BgL_exprz00_9254 = ((obj_t) BgL_globalz00_55);
								}
						}
						{	/* Ast/sexp.scm 789 */
							BgL_appz00_bglt BgL_new1161z00_9255;

							{	/* Ast/sexp.scm 789 */
								BgL_appz00_bglt BgL_new1160z00_9258;

								BgL_new1160z00_9258 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 789 */
									long BgL_arg7186z00_9259;

									BgL_arg7186z00_9259 =
										BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1160z00_9258),
										BgL_arg7186z00_9259);
								}
								{	/* Ast/sexp.scm 789 */
									BgL_objectz00_bglt BgL_tmpz00_29199;

									BgL_tmpz00_29199 = ((BgL_objectz00_bglt) BgL_new1160z00_9258);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29199, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1160z00_9258);
								BgL_new1161z00_9255 = BgL_new1160z00_9258;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1161z00_9255)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1161z00_9255)))->BgL_typez00) =
								((BgL_typez00_bglt)
									BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
											BGl_za2_za2z00zztype_cachez00),
										((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
								BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1161z00_9255)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1161z00_9255)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1161z00_9255))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9252)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29217;

								{	/* Ast/sexp.scm 792 */
									BgL_nodez00_bglt BgL_arg7184z00_9256;

									BgL_arg7184z00_9256 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_9254, BNIL,
										BFALSE, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 792 */
										obj_t BgL_list7185z00_9257;

										BgL_list7185z00_9257 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7184z00_9256), BNIL);
										BgL_auxz00_29217 = BgL_list7185z00_9257;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1161z00_9255))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29217), BUNSPEC);
							}
							((((BgL_appz00_bglt) COBJECT(BgL_new1161z00_9255))->
									BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
							return ((BgL_nodez00_bglt) BgL_new1161z00_9255);
						}
					}
				else
					{	/* Ast/sexp.scm 785 */
						return BgL_funz00_9252;
					}
			}
		}

	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13239, obj_t BgL_globalz00_13240)
	{
		{	/* Ast/sexp.scm 782 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13240));
		}

	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_56, obj_t BgL_prefz00_57)
	{
		{	/* Ast/sexp.scm 798 */
			{	/* Ast/sexp.scm 799 */
				obj_t BgL_prefz00_9265;

				{	/* Ast/sexp.scm 799 */
					bool_t BgL_test9946z00_29227;

					if (PAIRP(BgL_prefz00_57))
						{	/* Ast/sexp.scm 799 */
							obj_t BgL_tmpz00_29230;

							BgL_tmpz00_29230 = CAR(BgL_prefz00_57);
							BgL_test9946z00_29227 = STRINGP(BgL_tmpz00_29230);
						}
					else
						{	/* Ast/sexp.scm 799 */
							BgL_test9946z00_29227 = ((bool_t) 0);
						}
					if (BgL_test9946z00_29227)
						{	/* Ast/sexp.scm 799 */
							BgL_prefz00_9265 = CAR(BgL_prefz00_57);
						}
					else
						{	/* Ast/sexp.scm 799 */
							BgL_prefz00_9265 = BGl_string7400z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 802 */
					bool_t BgL_test9948z00_29234;

					if (STRUCTP(BgL_locz00_56))
						{	/* Ast/sexp.scm 802 */
							BgL_test9948z00_29234 =
								(STRUCT_KEY(BgL_locz00_56) == CNST_TABLE_REF(((long) 43)));
						}
					else
						{	/* Ast/sexp.scm 802 */
							BgL_test9948z00_29234 = ((bool_t) 0);
						}
					if (BgL_test9948z00_29234)
						{	/* Ast/sexp.scm 803 */
							obj_t BgL_filez00_9267;
							obj_t BgL_linez00_9268;
							obj_t BgL_basez00_9269;

							BgL_filez00_9267 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_56);
							BgL_linez00_9268 = STRUCT_REF(BgL_locz00_56, (int) (((long) 2)));
							{	/* Ast/sexp.scm 805 */
								obj_t BgL_arg7221z00_9310;

								BgL_arg7221z00_9310 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string7423z00zzast_sexpz00, BgL_prefz00_9265,
										BGl_string7424z00zzast_sexpz00));
								{	/* Ast/sexp.scm 805 */
									obj_t BgL_arg1447z00_13136;

									BgL_arg1447z00_13136 = SYMBOL_TO_STRING(BgL_arg7221z00_9310);
									BgL_basez00_9269 =
										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
										(BgL_arg1447z00_13136);
							}}
							{	/* Ast/sexp.scm 807 */
								bool_t BgL_test9950z00_29247;

								{	/* Ast/sexp.scm 807 */

									BgL_test9950z00_29247 =
										CBOOL(BGl_stringzd2containszd2zz__r4_strings_6_7z00
										(BgL_prefz00_9265, BGl_string7423z00zzast_sexpz00,
											(int) (((long) 0))));
								}
								if (BgL_test9950z00_29247)
									{	/* Ast/sexp.scm 808 */
										obj_t BgL_arg7194z00_9274;

										{	/* Ast/sexp.scm 808 */
											obj_t BgL_arg7195z00_9275;
											obj_t BgL_arg7196z00_9276;

											{	/* Ast/sexp.scm 808 */
												obj_t BgL_arg7197z00_9277;

												BgL_arg7197z00_9277 =
													bstring_to_symbol(((obj_t) BgL_prefz00_9265));
												{	/* Ast/sexp.scm 808 */
													obj_t BgL_arg1447z00_13139;

													BgL_arg1447z00_13139 =
														SYMBOL_TO_STRING(BgL_arg7197z00_9277);
													BgL_arg7195z00_9275 =
														BGl_stringzd2copyzd2zz__r4_strings_6_7z00
														(BgL_arg1447z00_13139);
												}
											}
											{	/* Ast/sexp.scm 808 */
												obj_t BgL_arg7198z00_9278;

												BgL_arg7198z00_9278 =
													BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 44)));
												{	/* Ast/sexp.scm 808 */
													obj_t BgL_arg1447z00_13141;

													BgL_arg1447z00_13141 =
														SYMBOL_TO_STRING(BgL_arg7198z00_9278);
													BgL_arg7196z00_9276 =
														BGl_stringzd2copyzd2zz__r4_strings_6_7z00
														(BgL_arg1447z00_13141);
											}}
											BgL_arg7194z00_9274 =
												string_append(BgL_arg7195z00_9275, BgL_arg7196z00_9276);
										}
										return bstring_to_symbol(BgL_arg7194z00_9274);
									}
								else
									{	/* Ast/sexp.scm 809 */
										bool_t BgL_test9951z00_29261;

										{	/* Ast/sexp.scm 809 */
											bool_t BgL_test9952z00_29262;

											if (
												((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00)
													>= ((long) 1)))
												{	/* Ast/sexp.scm 810 */
													obj_t BgL_arg7219z00_9305;

													{	/* Ast/sexp.scm 810 */
														obj_t BgL_arg7220z00_9306;

														BgL_arg7220z00_9306 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														BgL_arg7219z00_9305 =
															(((BgL_backendz00_bglt) COBJECT(
																	((BgL_backendz00_bglt)
																		BgL_arg7220z00_9306)))->
															BgL_debugzd2supportzd2);
													}
													BgL_test9952z00_29262 =
														CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 45)), BgL_arg7219z00_9305));
												}
											else
												{	/* Ast/sexp.scm 809 */
													BgL_test9952z00_29262 = ((bool_t) 0);
												}
											if (BgL_test9952z00_29262)
												{	/* Ast/sexp.scm 809 */
													BgL_test9951z00_29261 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 809 */
													BgL_test9951z00_29261 =
														(
														(long)
														CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
														>= ((long) 1));
										}}
										if (BgL_test9951z00_29261)
											{	/* Ast/sexp.scm 812 */
												obj_t BgL_filez00_9287;

												if (bigloo_strncmp(BgL_filez00_9267,
														BGl_string7425z00zzast_sexpz00, ((long) 2)))
													{	/* Ast/sexp.scm 812 */
														BgL_filez00_9287 =
															c_substring(BgL_filez00_9267, ((long) 2),
															STRING_LENGTH(BgL_filez00_9267));
													}
												else
													{	/* Ast/sexp.scm 812 */
														BgL_filez00_9287 = BgL_filez00_9267;
													}
												{	/* Ast/sexp.scm 817 */
													obj_t BgL_arg7206z00_9288;

													{	/* Ast/sexp.scm 817 */
														obj_t BgL_arg7207z00_9289;
														obj_t BgL_arg7208z00_9290;

														BgL_arg7207z00_9289 =
															BGl_stringzd2replacezd2zz__r4_strings_6_7z00
															(BgL_filez00_9287, (char) (((unsigned char) '.')),
															(char) (((unsigned char) ',')));
														{	/* Ast/sexp.scm 818 */

															BgL_arg7208z00_9290 =
																BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
																(BgL_linez00_9268, BINT(((long) 10)));
														}
														{	/* Ast/sexp.scm 816 */
															obj_t BgL_list7209z00_9291;

															{	/* Ast/sexp.scm 816 */
																obj_t BgL_arg7210z00_9292;

																{	/* Ast/sexp.scm 816 */
																	obj_t BgL_arg7211z00_9293;

																	{	/* Ast/sexp.scm 816 */
																		obj_t BgL_arg7212z00_9294;

																		{	/* Ast/sexp.scm 816 */
																			obj_t BgL_arg7213z00_9295;

																			{	/* Ast/sexp.scm 816 */
																				obj_t BgL_arg7214z00_9296;

																				BgL_arg7214z00_9296 =
																					MAKE_YOUNG_PAIR
																					(BGl_string7426z00zzast_sexpz00,
																					BNIL);
																				BgL_arg7213z00_9295 =
																					MAKE_YOUNG_PAIR(BgL_arg7208z00_9290,
																					BgL_arg7214z00_9296);
																			}
																			BgL_arg7212z00_9294 =
																				MAKE_YOUNG_PAIR
																				(BGl_string7424z00zzast_sexpz00,
																				BgL_arg7213z00_9295);
																		}
																		BgL_arg7211z00_9293 =
																			MAKE_YOUNG_PAIR(BgL_arg7207z00_9289,
																			BgL_arg7212z00_9294);
																	}
																	BgL_arg7210z00_9292 =
																		MAKE_YOUNG_PAIR
																		(BGl_string7424z00zzast_sexpz00,
																		BgL_arg7211z00_9293);
																}
																BgL_list7209z00_9291 =
																	MAKE_YOUNG_PAIR(BgL_basez00_9269,
																	BgL_arg7210z00_9292);
															}
															BgL_arg7206z00_9288 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list7209z00_9291);
													}}
													return bstring_to_symbol(BgL_arg7206z00_9288);
												}
											}
										else
											{	/* Ast/sexp.scm 821 */
												obj_t BgL_arg7217z00_9301;

												BgL_arg7217z00_9301 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(string_append(BgL_basez00_9269,
														BGl_string7427z00zzast_sexpz00),
													(char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												return bstring_to_symbol(((obj_t) BgL_arg7217z00_9301));
											}
									}
							}
						}
					else
						{	/* Ast/sexp.scm 822 */
							obj_t BgL_arg7223z00_9312;

							{	/* Ast/sexp.scm 822 */
								obj_t BgL_arg7224z00_9313;
								obj_t BgL_arg7225z00_9314;

								{	/* Ast/sexp.scm 822 */
									obj_t BgL_arg7226z00_9315;

									BgL_arg7226z00_9315 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string7423z00zzast_sexpz00, BgL_prefz00_9265,
											BGl_string7428z00zzast_sexpz00));
									{	/* Ast/sexp.scm 822 */
										obj_t BgL_arg1447z00_13155;

										BgL_arg1447z00_13155 =
											SYMBOL_TO_STRING(BgL_arg7226z00_9315);
										BgL_arg7224z00_9313 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1447z00_13155);
									}
								}
								{	/* Ast/sexp.scm 822 */
									obj_t BgL_symbolz00_13156;

									BgL_symbolz00_13156 = CNST_TABLE_REF(((long) 46));
									{	/* Ast/sexp.scm 822 */
										obj_t BgL_arg1447z00_13157;

										BgL_arg1447z00_13157 =
											SYMBOL_TO_STRING(BgL_symbolz00_13156);
										BgL_arg7225z00_9314 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1447z00_13157);
								}}
								BgL_arg7223z00_9312 =
									string_append(BgL_arg7224z00_9313, BgL_arg7225z00_9314);
							}
							return bstring_to_symbol(BgL_arg7223z00_9312);
						}
				}
			}
		}

	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_13241,
		obj_t BgL_locz00_13242, obj_t BgL_prefz00_13243)
	{
		{	/* Ast/sexp.scm 798 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_13242,
				BgL_prefz00_13243);
		}

	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_58, obj_t BgL_mutexz00_59, obj_t BgL_prelockz00_60,
		obj_t BgL_bodyz00_61, obj_t BgL_stackz00_62, obj_t BgL_locz00_63,
		obj_t BgL_sitez00_64)
	{
		{	/* Ast/sexp.scm 827 */
			if (SYMBOLP(BgL_mutexz00_59))
				{	/* Ast/sexp.scm 829 */
					BgL_syncz00_bglt BgL_new1163z00_9323;

					{	/* Ast/sexp.scm 830 */
						BgL_syncz00_bglt BgL_new1162z00_9325;

						BgL_new1162z00_9325 =
							((BgL_syncz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 830 */
							long BgL_arg7234z00_9326;

							BgL_arg7234z00_9326 = BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1162z00_9325),
								BgL_arg7234z00_9326);
						}
						{	/* Ast/sexp.scm 830 */
							BgL_objectz00_bglt BgL_tmpz00_29313;

							BgL_tmpz00_29313 = ((BgL_objectz00_bglt) BgL_new1162z00_9325);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29313, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_new1162z00_9325);
						BgL_new1163z00_9323 = BgL_new1162z00_9325;
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1163z00_9323)))->BgL_locz00) =
						((obj_t) BgL_locz00_63), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1163z00_9323)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1163z00_9323))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_59,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1163z00_9323))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_60,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_29328;

						{	/* Ast/sexp.scm 834 */
							obj_t BgL_arg7233z00_9324;

							BgL_arg7233z00_9324 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_61);
							BgL_auxz00_29328 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7233z00_9324,
								BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
						}
						((((BgL_syncz00_bglt) COBJECT(BgL_new1163z00_9323))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_29328), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1163z00_9323);
				}
			else
				{	/* Ast/sexp.scm 835 */
					obj_t BgL_vz00_9327;

					BgL_vz00_9327 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 47))));
					{	/* Ast/sexp.scm 835 */
						obj_t BgL_varz00_9328;

						BgL_varz00_9328 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_9327,
							CNST_TABLE_REF(((long) 47)));
						{	/* Ast/sexp.scm 836 */
							obj_t BgL_nexpz00_9329;

							{	/* Ast/sexp.scm 837 */
								obj_t BgL_arg7242z00_9337;

								{	/* Ast/sexp.scm 837 */
									obj_t BgL_arg7243z00_9338;

									BgL_arg7243z00_9338 =
										MAKE_YOUNG_PAIR(BgL_vz00_9327,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_61, BNIL));
									BgL_arg7242z00_9337 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 29)),
										BgL_arg7243z00_9338);
								}
								BgL_nexpz00_9329 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg7242z00_9337,
									BgL_expz00_58);
							}
							{	/* Ast/sexp.scm 837 */

								{	/* Ast/sexp.scm 838 */
									obj_t BgL_arg7235z00_9330;

									{	/* Ast/sexp.scm 838 */
										obj_t BgL_arg7236z00_9331;
										obj_t BgL_arg7237z00_9332;

										BgL_arg7236z00_9331 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 838 */
											obj_t BgL_arg7238z00_9333;
											obj_t BgL_arg7239z00_9334;

											{	/* Ast/sexp.scm 838 */
												obj_t BgL_arg7240z00_9335;

												{	/* Ast/sexp.scm 838 */
													obj_t BgL_arg7241z00_9336;

													BgL_arg7241z00_9336 =
														MAKE_YOUNG_PAIR(BgL_mutexz00_59, BNIL);
													BgL_arg7240z00_9335 =
														MAKE_YOUNG_PAIR(BgL_varz00_9328,
														BgL_arg7241z00_9336);
												}
												BgL_arg7238z00_9333 =
													MAKE_YOUNG_PAIR(BgL_arg7240z00_9335, BNIL);
											}
											BgL_arg7239z00_9334 =
												MAKE_YOUNG_PAIR(BgL_nexpz00_9329, BNIL);
											BgL_arg7237z00_9332 =
												MAKE_YOUNG_PAIR(BgL_arg7238z00_9333,
												BgL_arg7239z00_9334);
										}
										BgL_arg7235z00_9330 =
											MAKE_YOUNG_PAIR(BgL_arg7236z00_9331, BgL_arg7237z00_9332);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_58,
										BgL_arg7235z00_9330);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_58,
									BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
							}
						}
					}
				}
		}

	}



/* not-test */
	obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t BgL_testz00_65)
	{
		{	/* Ast/sexp.scm 847 */
			{
				obj_t BgL_bindingsz00_9345;
				obj_t BgL_exprz00_9346;

				if (PAIRP(BgL_testz00_65))
					{	/* Ast/sexp.scm 848 */
						obj_t BgL_cdrzd262458zd2_9351;

						BgL_cdrzd262458zd2_9351 = CDR(BgL_testz00_65);
						if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 1))))
							{	/* Ast/sexp.scm 848 */
								if (PAIRP(BgL_cdrzd262458zd2_9351))
									{	/* Ast/sexp.scm 848 */
										obj_t BgL_cdrzd262461zd2_9355;

										BgL_cdrzd262461zd2_9355 = CDR(BgL_cdrzd262458zd2_9351);
										if (PAIRP(BgL_cdrzd262461zd2_9355))
											{	/* Ast/sexp.scm 848 */
												obj_t BgL_cdrzd262464zd2_9357;

												BgL_cdrzd262464zd2_9357 = CDR(BgL_cdrzd262461zd2_9355);
												if ((CAR(BgL_cdrzd262461zd2_9355) == BFALSE))
													{	/* Ast/sexp.scm 848 */
														if (PAIRP(BgL_cdrzd262464zd2_9357))
															{	/* Ast/sexp.scm 848 */
																if ((CAR(BgL_cdrzd262464zd2_9357) == BTRUE))
																	{	/* Ast/sexp.scm 848 */
																		if (NULLP(CDR(BgL_cdrzd262464zd2_9357)))
																			{	/* Ast/sexp.scm 848 */
																				return CAR(BgL_cdrzd262458zd2_9351);
																			}
																		else
																			{	/* Ast/sexp.scm 848 */
																				return BFALSE;
																			}
																	}
																else
																	{	/* Ast/sexp.scm 848 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 848 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 848 */
										return BFALSE;
									}
							}
						else
							{	/* Ast/sexp.scm 848 */
								if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 48))))
									{	/* Ast/sexp.scm 848 */
										if (PAIRP(BgL_cdrzd262458zd2_9351))
											{	/* Ast/sexp.scm 848 */
												if (NULLP(CDR(BgL_cdrzd262458zd2_9351)))
													{	/* Ast/sexp.scm 848 */
														return CAR(BgL_cdrzd262458zd2_9351);
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 848 */
										obj_t BgL_cdrzd262538zd2_9377;

										BgL_cdrzd262538zd2_9377 = CDR(BgL_testz00_65);
										if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 17))))
											{	/* Ast/sexp.scm 848 */
												if (PAIRP(BgL_cdrzd262538zd2_9377))
													{	/* Ast/sexp.scm 848 */
														obj_t BgL_cdrzd262542zd2_9381;

														BgL_cdrzd262542zd2_9381 =
															CDR(BgL_cdrzd262538zd2_9377);
														if (PAIRP(BgL_cdrzd262542zd2_9381))
															{	/* Ast/sexp.scm 848 */
																if (NULLP(CDR(BgL_cdrzd262542zd2_9381)))
																	{	/* Ast/sexp.scm 848 */
																		BgL_bindingsz00_9345 =
																			CAR(BgL_cdrzd262538zd2_9377);
																		BgL_exprz00_9346 =
																			CAR(BgL_cdrzd262542zd2_9381);
																		{	/* Ast/sexp.scm 854 */
																			obj_t BgL_ntz00_9391;

																			BgL_ntz00_9391 =
																				BGl_notzd2testzd2zzast_sexpz00
																				(BgL_exprz00_9346);
																			if (CBOOL(BgL_ntz00_9391))
																				{	/* Ast/sexp.scm 856 */
																					obj_t BgL_arg7281z00_9392;

																					{	/* Ast/sexp.scm 856 */
																						obj_t BgL_arg7282z00_9393;

																						{	/* Ast/sexp.scm 856 */
																							obj_t BgL_arg7283z00_9394;

																							BgL_arg7283z00_9394 =
																								MAKE_YOUNG_PAIR(BgL_ntz00_9391,
																								BNIL);
																							BgL_arg7282z00_9393 =
																								MAKE_YOUNG_PAIR
																								(BgL_bindingsz00_9345,
																								BgL_arg7283z00_9394);
																						}
																						BgL_arg7281z00_9392 =
																							MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																									(long) 17)),
																							BgL_arg7282z00_9393);
																					}
																					return
																						BGl_epairifyzd2reczd2zztools_miscz00
																						(BgL_arg7281z00_9392,
																						BgL_testz00_65);
																				}
																			else
																				{	/* Ast/sexp.scm 855 */
																					return BFALSE;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 848 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 848 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
							}
					}
				else
					{	/* Ast/sexp.scm 848 */
						return BFALSE;
					}
			}
		}

	}



/* used-in? */
	bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t BgL_idz00_66,
		obj_t BgL_exprz00_67)
	{
		{	/* Ast/sexp.scm 865 */
			if ((BgL_idz00_66 == BgL_exprz00_67))
				{	/* Ast/sexp.scm 867 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 867 */
					if (PAIRP(BgL_exprz00_67))
						{	/* Ast/sexp.scm 868 */
							if ((CAR(BgL_exprz00_67) == CNST_TABLE_REF(((long) 12))))
								{	/* Ast/sexp.scm 869 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/sexp.scm 869 */
									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00
										(BgL_exprz00_67))
										{
											obj_t BgL_list1477z00_9411;

											{	/* Ast/sexp.scm 871 */
												obj_t BgL_tmpz00_29420;

												BgL_list1477z00_9411 = BgL_exprz00_67;
											BgL_zc3z04anonymousza37294ze3z87_9412:
												if (PAIRP(BgL_list1477z00_9411))
													{	/* Ast/sexp.scm 871 */
														if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_66,
																CAR(BgL_list1477z00_9411)))
															{	/* Ast/sexp.scm 871 */
																BgL_tmpz00_29420 = CAR(BgL_list1477z00_9411);
															}
														else
															{
																obj_t BgL_list1477z00_29427;

																BgL_list1477z00_29427 =
																	CDR(BgL_list1477z00_9411);
																BgL_list1477z00_9411 = BgL_list1477z00_29427;
																goto BgL_zc3z04anonymousza37294ze3z87_9412;
															}
													}
												else
													{	/* Ast/sexp.scm 871 */
														BgL_tmpz00_29420 = BFALSE;
													}
												return CBOOL(BgL_tmpz00_29420);
											}
										}
									else
										{	/* Ast/sexp.scm 870 */
											return ((bool_t) 0);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 868 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 301998274),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867955),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346491734),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502007119),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780265),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 311443803),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035925),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 156774043),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879154),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066125),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859288),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780830),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263837),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121776),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707717),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string7429z00zzast_sexpz00));
		}

	}

#ifdef __cplusplus
}
#endif
