/*===========================================================================*/
/*   (Ast/walk.scm)                                                          */
/*   Bigloo (4.4b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 22 Mar 2021 06:56:16 PM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4b -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/walk.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2noescapezd2;
		obj_t BgL_argszd2retescapezd2;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
		obj_t BgL_stackablez00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_retblockz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                  *BgL_retblockz00_bglt;

	typedef struct BgL_returnz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_retblockz00_bgl *BgL_blockz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                *BgL_returnz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
		obj_t BgL_stackablez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static obj_t BGl_z62walk2za2zd2retblock1961z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2setzd2exzd2it1907zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2cast1821za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2node1672z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32350ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2funcall1769z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_z62walk3za2zd2boxzd2ref2038zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2setq1833zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_returnz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk0z12z70zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2app1729za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2node1666zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zc0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2return1997za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2boxzd2ref2026z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_walkz00 = BUNSPEC;
	static obj_t BGl_z62walk2zd2letzd2fun2124z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2fun2136z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33492ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2boxzd2setz122050z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2appzd2ly1743zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2sync2084z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2funcall1757zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2boxzd2setz122056zd2zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2switch2116za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2funcall1779za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32261ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk31634z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2retblock1951zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62walk1zd2app1711zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza32477ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2conditional1869za2zzast_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk3z12zd2setq1851za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2sync2078zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2retblock1957z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2letzd2var2158zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2extern1795z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza33404ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2return1989z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2letzd2var2146z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza32567ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2setzd2exzd2it1903zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2setq1845za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2conditional1863z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32200ze3ze5zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_walkz00();
	static obj_t BGl_z62walk3za2zd2sequence1699z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2fail1887z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2extern1781zb0zzast_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_z62walk2za2zd2cast1817z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2switch2108z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2return1973zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk4z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2node1679za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk4za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33503ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2switch2098zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2conditional1873za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_genericzd2initzd2zzast_walkz00();
	static obj_t BGl_z62walk3zd2extern1787zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2node1660zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2sequence1689zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2conditional1867z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2cast1811zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2makezd2box2020z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0za2zd2funcall1765z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza33350ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk1zd2appzd2ly1735z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2conditional1853zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzast_walkz00();
	BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t BGl_z62walk1za2zd2boxzd2ref2034zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk41636z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0z121649z70zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2conditional1857zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2fail1881zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3zd2return1980zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2funcall1763zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_zc3z04anonymousza32254ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2sync2072zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2sync2090za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2sequence1707za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2letzd2fun2132zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2extern1799za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32220ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32212ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62walk1za2zd2sequence1695z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32204ze3ze5zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2funcall1775za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2fail1899za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2ref2044z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2jumpzd2exzd2it1943za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2makezd2box2014zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2jumpzd2exzd2it1947za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2makezd2box1999z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2letzd2var2154zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2setq1841z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2switch2100zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2app1721z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2return1993za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2makezd2box2016z70zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2letzd2fun2120z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza33244ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2fun2142z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za21638zc0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2setq1835zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2fail1893za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2boxzd2setz122068z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2cast1805zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2switch2112za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2cast1823za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2makezd2box2003z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2jumpzd2exzd2it1931zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33360ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2node1675z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2var2164z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33388ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2app1713zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_walkz00();
	static BgL_nodez00_bglt BGl_z62walk3z12zd2app1731za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2retblock1969za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2extern1791z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2return1984z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2jumpzd2exzd2it1927zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62walk0za2zd2node1668z12zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2sequence1703za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2appzd2ly1753z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2sequence1685zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2setzd2exzd2it1913z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2sync2086z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32232ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32224ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32216ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32208ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62walk1za2zd2makezd2box2010zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1z121651z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2extern1801za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2switch2104z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza32247ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2letzd2fun2128zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2boxzd2setz122062zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2setzd2exzd2it1909z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2boxzd2ref2028z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32551ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33254ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2letzd2fun2126z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2appzd2ly1745zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2boxzd2setz122064z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2setq1829zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2sync2080z12zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2setq1847za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2retblock1963z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2ref2040z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2funcall1759zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2funcall1771z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2fail1889z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2switch2118za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_z62walk3za2zd2cast1819z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2fun2138z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2retblock1965za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2jumpzd2exzd2it1935z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2boxzd2setz122052z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2setzd2exzd2it1921za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2app1725za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2jumpzd2exzd2it1939z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2node1662zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33515ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za21640zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2extern1783zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2retblock1953zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2letzd2var2148z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3zd2fail1883zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2setzd2exzd2it1917za2zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2return1976zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2node1681za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2boxzd2setz122058zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32228ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62walk0za2zd2cast1813z12zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2var2160z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
	static obj_t BGl_z62walk1zd2sync2074zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2retblock1959z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2switch2110z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2z121653z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2appzd2ly1737z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32535ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2sync2092za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk0z00zzast_walkz00(BgL_nodez00_bglt, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk1z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk3z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2setzd2exzd2it1905zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_walk4z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2app1723z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32544ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2appzd2ly1749z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pp_circlez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_z62walk0za2zd2conditional1861z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62walk3zd2app1715zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2setq1843z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2cast1807zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32174ze3ze5zzast_walkz00(obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62walk1za2zd2funcall1767z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32339ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2boxzd2ref2036zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2sequence1691zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2boxzd2setz122048z70zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2fail1877zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2fail1895za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2setq1837z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2switch2102zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2cast1825za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2makezd2box2022z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2conditional1871za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za21642zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2retblock1949zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2letzd2fun2134zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2conditional1865z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk2z12zd2return1995za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2boxzd2ref2024z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2funcall1777za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62zc3z04anonymousza32192ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32184ze3ze5zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2ref2046z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2letzd2fun2122z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk01627z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_walkz00();
	static obj_t BGl_z62walk0za2zd2appzd2ly1741zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2setzd2exzd2it1901zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2letzd2var2156zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk4z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_walkz00();
	static obj_t BGl_z62walk0za2zd2app1717z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2sequence1697z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2switch2114za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_walkz00();
	static obj_t BGl_z62walk1za2zd2node1670z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2conditional1855zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3z121655z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32447ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2conditional1875za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2conditional1859zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t);
	static obj_t BGl_z62walk2za2zd2extern1793z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk0za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t);
	static obj_t BGl_z62walk3zd2makezd2box2005z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33212ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2makezd2box2018z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2return1986z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_retblockz00zzast_nodez00;
	static obj_t BGl_z62walk0zd2letzd2var2144z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2appzd2ly1755z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32268ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2setq1831zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2var2166z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk1z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2app1727za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2sync2082z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2setq1849za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk1za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_writezd2circlezd2zz__pp_circlez00(obj_t, obj_t);
	static obj_t BGl_z62walk2zd2node1664zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2jumpzd2exzd2it1941za2zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32179ze3ze5zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2extern1803za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2jumpzd2exzd2it1945za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2switch2106z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2sequence1687zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2boxzd2setz122070z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk2z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk2za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2fail1891z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32196ze3ze5zzast_walkz00(obj_t);
	static obj_t BGl_z62walk0za2zd2boxzd2ref2032zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32188ze3ze5zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2sequence1705za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk3z12zd2retblock1971za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2sync2076zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za21644zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk3z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2app1709zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2appzd2ly1747zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2sequence1693z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk3za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2boxzd2ref2030z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2node1683za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2fail1885z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk11630z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32322ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk0zd2switch2096zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2cast1815z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2makezd2box2012zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2jumpzd2exzd2it1929zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2letzd2fun2130zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2extern1785zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk4z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2funcall1761zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2funcall1773za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2return1978zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk4za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2node1677za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2setzd2exzd2it1915z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2ref2042z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_switchz00zzast_nodez00;
	static obj_t BGl_z62walk0zd2appzd2ly1733z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33222ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3z04anonymousza32331ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk4z121657z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2extern1797za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2letzd2var2152zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2sync2094za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2boxzd2setz122054z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2boxzd2setz122066z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2cast1809zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2jumpzd2exzd2it1925zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2fun2140z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2letzd2var2150z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2appzd2ly1739z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2retblock1955zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2retblock1967za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2sync2088za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2return1991za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2fail1879zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2setzd2exzd2it1911z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2makezd2box2001z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2sequence1701za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2makezd2box2008zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2var2162z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza33482ze3ze70z60zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32458ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2setzd2exzd2it1923za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk2z12zd2fail1897za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2extern1789z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2setq1839z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2cast1827za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk21632z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0za2zd2jumpzd2exzd2it1933z12zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3z04anonymousza32467ze3ze70z60zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2jumpzd2exzd2it1937z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk4za21646zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2setzd2exzd2it1919za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2boxzd2setz122060zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2app1719z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0za2zd2return1982z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2appzd2ly1751z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string4009z00zzast_walkz00,
		BgL_bgl_string4009za700za7za7a4094za7, "ast_walk", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4000z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2letza7d4095za7,
		BGl_z62walk3zd2letzd2var2150z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4001z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2le4096za7,
		BGl_z62walk0za2zd2letzd2var2152zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4002z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2le4097za7,
		BGl_z62walk1za2zd2letzd2var2154zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4003z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2le4098za7,
		BGl_z62walk2za2zd2letzd2var2156zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4004z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2le4099za7,
		BGl_z62walk3za2zd2letzd2var2158zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4005z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2le4100za7,
		BGl_z62walk0z12zd2letzd2var2160z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4006z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2le4101za7,
		BGl_z62walk1z12zd2letzd2var2162z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4007z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2le4102za7,
		BGl_z62walk2z12zd2letzd2var2164z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4008z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2le4103za7,
		BGl_z62walk3z12zd2letzd2var2166z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk2za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7c0za7za74104za7, BGl_z62walk2za2zc0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk3za712za770za7za74105za7, BGl_z62walk3z12z70zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7c0za7za74106za7, BGl_z62walk3za2zc0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk4za712za770za7za74107za7, BGl_z62walk4z12z70zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk0za762za7za7ast4108z00, BGl_z62walk0z62zzast_walkz00, 0L,
		BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk4za7a2za7c0za7za74109za7, BGl_z62walk4za2zc0zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STRING(BGl_string3713z00zzast_walkz00,
		BgL_bgl_string3713za700za7za7a4110za7, "walk01627", 9);
	      DEFINE_STRING(BGl_string3715z00zzast_walkz00,
		BgL_bgl_string3715za700za7za7a4111za7, "walk11630", 9);
	      DEFINE_STRING(BGl_string3717z00zzast_walkz00,
		BgL_bgl_string3717za700za7za7a4112za7, "walk21632", 9);
	      DEFINE_STRING(BGl_string3719z00zzast_walkz00,
		BgL_bgl_string3719za700za7za7a4113za7, "walk31634", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3712z00zzast_walkz00,
		BgL_bgl_za762walk01627za762za74114za7, BGl_z62walk01627z62zzast_walkz00, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3714z00zzast_walkz00,
		BgL_bgl_za762walk11630za762za74115za7, BGl_z62walk11630z62zzast_walkz00, 0L,
		BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3721z00zzast_walkz00,
		BgL_bgl_string3721za700za7za7a4116za7, "walk41636", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3716z00zzast_walkz00,
		BgL_bgl_za762walk21632za762za74117za7, BGl_z62walk21632z62zzast_walkz00, 0L,
		BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3723z00zzast_walkz00,
		BgL_bgl_string3723za700za7za7a4118za7, "walk0*1638", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3718z00zzast_walkz00,
		BgL_bgl_za762walk31634za762za74119za7, BGl_z62walk31634z62zzast_walkz00, 0L,
		BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3725z00zzast_walkz00,
		BgL_bgl_string3725za700za7za7a4120za7, "walk1*1640", 10);
	      DEFINE_STRING(BGl_string3727z00zzast_walkz00,
		BgL_bgl_string3727za700za7za7a4121za7, "walk2*1642", 10);
	      DEFINE_STRING(BGl_string3729z00zzast_walkz00,
		BgL_bgl_string3729za700za7za7a4122za7, "walk3*1644", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3800z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ap4123za7,
		BGl_z62walk3za2zd2appzd2ly1747zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3801z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ap4124za7,
		BGl_z62walk0z12zd2appzd2ly1749z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3720z00zzast_walkz00,
		BgL_bgl_za762walk41636za762za74125za7, BGl_z62walk41636z62zzast_walkz00, 0L,
		BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3802z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ap4126za7,
		BGl_z62walk1z12zd2appzd2ly1751z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3803z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ap4127za7,
		BGl_z62walk2z12zd2appzd2ly1753z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3722z00zzast_walkz00,
		BgL_bgl_za762walk0za7a21638za74128za7, BGl_z62walk0za21638zc0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3804z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ap4129za7,
		BGl_z62walk3z12zd2appzd2ly1755z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3805z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2funca4130z00,
		BGl_z62walk0zd2funcall1757zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3724z00zzast_walkz00,
		BgL_bgl_za762walk1za7a21640za74131za7, BGl_z62walk1za21640zc0zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3806z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2funca4132z00,
		BGl_z62walk1zd2funcall1759zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3731z00zzast_walkz00,
		BgL_bgl_string3731za700za7za7a4133za7, "walk4*1646", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3807z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2funca4134z00,
		BGl_z62walk2zd2funcall1761zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3726z00zzast_walkz00,
		BgL_bgl_za762walk2za7a21642za74135za7, BGl_z62walk2za21642zc0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3808z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2funca4136z00,
		BGl_z62walk3zd2funcall1763zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3733z00zzast_walkz00,
		BgL_bgl_string3733za700za7za7a4137za7, "walk0!1649", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3809z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2fu4138za7,
		BGl_z62walk0za2zd2funcall1765z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3728z00zzast_walkz00,
		BgL_bgl_za762walk3za7a21644za74139za7, BGl_z62walk3za21644zc0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3735z00zzast_walkz00,
		BgL_bgl_string3735za700za7za7a4140za7, "walk1!1651", 10);
	      DEFINE_STRING(BGl_string3737z00zzast_walkz00,
		BgL_bgl_string3737za700za7za7a4141za7, "walk2!1653", 10);
	      DEFINE_STRING(BGl_string3739z00zzast_walkz00,
		BgL_bgl_string3739za700za7za7a4142za7, "walk3!1655", 10);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk1za762za7za7ast4143z00, BGl_z62walk1z62zzast_walkz00, 0L,
		BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3810z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2fu4144za7,
		BGl_z62walk1za2zd2funcall1767z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3811z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2fu4145za7,
		BGl_z62walk2za2zd2funcall1769z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3730z00zzast_walkz00,
		BgL_bgl_za762walk4za7a21646za74146za7, BGl_z62walk4za21646zc0zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3812z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2fu4147za7,
		BGl_z62walk3za2zd2funcall1771z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3813z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2fu4148za7,
		BGl_z62walk0z12zd2funcall1773za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3732z00zzast_walkz00,
		BgL_bgl_za762walk0za7121649za74149za7, BGl_z62walk0z121649z70zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3814z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2fu4150za7,
		BGl_z62walk1z12zd2funcall1775za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3815z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2fu4151za7,
		BGl_z62walk2z12zd2funcall1777za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3734z00zzast_walkz00,
		BgL_bgl_za762walk1za7121651za74152za7, BGl_z62walk1z121651z70zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3816z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2fu4153za7,
		BGl_z62walk3z12zd2funcall1779za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3741z00zzast_walkz00,
		BgL_bgl_string3741za700za7za7a4154za7, "walk4!1657", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3817z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2exter4155z00,
		BGl_z62walk0zd2extern1781zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3742z00zzast_walkz00,
		BgL_bgl_string3742za700za7za7a4156za7, "walk4!", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3736z00zzast_walkz00,
		BgL_bgl_za762walk2za7121653za74157za7, BGl_z62walk2z121653z70zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3818z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2exter4158z00,
		BGl_z62walk1zd2extern1783zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3743z00zzast_walkz00,
		BgL_bgl_string3743za700za7za7a4159za7, "Internal Error: forgot Node type",
		32);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3819z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2exter4160z00,
		BGl_z62walk2zd2extern1785zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3744z00zzast_walkz00,
		BgL_bgl_string3744za700za7za7a4161za7, "walk3!", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3738z00zzast_walkz00,
		BgL_bgl_za762walk3za7121655za74162za7, BGl_z62walk3z121655z70zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3745z00zzast_walkz00,
		BgL_bgl_string3745za700za7za7a4163za7, "walk2!", 6);
	      DEFINE_STRING(BGl_string3746z00zzast_walkz00,
		BgL_bgl_string3746za700za7za7a4164za7, "walk1!", 6);
	      DEFINE_STRING(BGl_string3747z00zzast_walkz00,
		BgL_bgl_string3747za700za7za7a4165za7, "walk0!", 6);
	      DEFINE_STRING(BGl_string3748z00zzast_walkz00,
		BgL_bgl_string3748za700za7za7a4166za7, "walk3*", 6);
	      DEFINE_STRING(BGl_string3749z00zzast_walkz00,
		BgL_bgl_string3749za700za7za7a4167za7, "walk2*", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3900z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ju4168za7,
		BGl_z62walk3z12zd2jumpzd2exzd2it1947za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3901z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2retbl4169z00,
		BGl_z62walk0zd2retblock1949zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3820z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2exter4170z00,
		BGl_z62walk3zd2extern1787zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3902z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2retbl4171z00,
		BGl_z62walk1zd2retblock1951zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3821z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ex4172za7,
		BGl_z62walk0za2zd2extern1789z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3740z00zzast_walkz00,
		BgL_bgl_za762walk4za7121657za74173za7, BGl_z62walk4z121657z70zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3903z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2retbl4174z00,
		BGl_z62walk2zd2retblock1953zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3822z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ex4175za7,
		BGl_z62walk1za2zd2extern1791z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3904z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2retbl4176z00,
		BGl_z62walk3zd2retblock1955zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3823z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ex4177za7,
		BGl_z62walk2za2zd2extern1793z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3905z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2re4178za7,
		BGl_z62walk0za2zd2retblock1957z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3824z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ex4179za7,
		BGl_z62walk3za2zd2extern1795z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3906z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2re4180za7,
		BGl_z62walk1za2zd2retblock1959z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3825z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ex4181za7,
		BGl_z62walk0z12zd2extern1797za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3750z00zzast_walkz00,
		BgL_bgl_string3750za700za7za7a4182za7, "walk1*", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3907z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2re4183za7,
		BGl_z62walk2za2zd2retblock1961z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3826z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ex4184za7,
		BGl_z62walk1z12zd2extern1799za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3751z00zzast_walkz00,
		BgL_bgl_string3751za700za7za7a4185za7, "walk0*", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3908z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2re4186za7,
		BGl_z62walk3za2zd2retblock1963z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3827z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ex4187za7,
		BGl_z62walk2z12zd2extern1801za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3752z00zzast_walkz00,
		BgL_bgl_string3752za700za7za7a4188za7, "walk4", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3909z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2re4189za7,
		BGl_z62walk0z12zd2retblock1965za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3828z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ex4190za7,
		BGl_z62walk3z12zd2extern1803za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3753z00zzast_walkz00,
		BgL_bgl_string3753za700za7za7a4191za7, "walk3", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3829z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2cast14192z00,
		BGl_z62walk0zd2cast1805zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3754z00zzast_walkz00,
		BgL_bgl_string3754za700za7za7a4193za7, "walk2", 5);
	      DEFINE_STRING(BGl_string3755z00zzast_walkz00,
		BgL_bgl_string3755za700za7za7a4194za7, "walk1", 5);
	      DEFINE_STRING(BGl_string3756z00zzast_walkz00,
		BgL_bgl_string3756za700za7za7a4195za7, "walk0", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3910z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2re4196za7,
		BGl_z62walk1z12zd2retblock1967za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3911z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2re4197za7,
		BGl_z62walk2z12zd2retblock1969za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3830z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2cast14198z00,
		BGl_z62walk1zd2cast1807zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3912z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2re4199za7,
		BGl_z62walk3z12zd2retblock1971za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3831z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2cast14200z00,
		BGl_z62walk2zd2cast1809zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3913z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2retur4201z00,
		BGl_z62walk0zd2return1973zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3832z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2cast14202z00,
		BGl_z62walk3zd2cast1811zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3914z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2retur4203z00,
		BGl_z62walk1zd2return1976zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3833z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ca4204za7,
		BGl_z62walk0za2zd2cast1813z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3915z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2retur4205z00,
		BGl_z62walk2zd2return1978zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3834z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ca4206za7,
		BGl_z62walk1za2zd2cast1815z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3916z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2retur4207z00,
		BGl_z62walk3zd2return1980zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3835z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ca4208za7,
		BGl_z62walk2za2zd2cast1817z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3917z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2re4209za7,
		BGl_z62walk0za2zd2return1982z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3836z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ca4210za7,
		BGl_z62walk3za2zd2cast1819z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3918z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2re4211za7,
		BGl_z62walk1za2zd2return1984z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3837z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ca4212za7,
		BGl_z62walk0z12zd2cast1821za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3919z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2re4213za7,
		BGl_z62walk2za2zd2return1986z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3838z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ca4214za7,
		BGl_z62walk1z12zd2cast1823za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3757z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2node14215z00,
		BGl_z62walk0zd2node1660zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3839z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ca4216za7,
		BGl_z62walk2z12zd2cast1825za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3758z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2node14217z00,
		BGl_z62walk1zd2node1662zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3759z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2node14218z00,
		BGl_z62walk2zd2node1664zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3920z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2re4219za7,
		BGl_z62walk3za2zd2return1989z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3921z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2re4220za7,
		BGl_z62walk0z12zd2return1991za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3840z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ca4221za7,
		BGl_z62walk3z12zd2cast1827za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3922z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2re4222za7,
		BGl_z62walk1z12zd2return1993za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3841z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2setq14223z00,
		BGl_z62walk0zd2setq1829zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3760z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2node14224z00,
		BGl_z62walk3zd2node1666zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3923z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2re4225za7,
		BGl_z62walk2z12zd2return1995za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3842z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2setq14226z00,
		BGl_z62walk1zd2setq1831zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3761z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2no4227za7,
		BGl_z62walk0za2zd2node1668z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3924z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2re4228za7,
		BGl_z62walk3z12zd2return1997za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3843z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2setq14229z00,
		BGl_z62walk2zd2setq1833zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3762z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2no4230za7,
		BGl_z62walk1za2zd2node1670z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3925z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2makeza74231za7,
		BGl_z62walk0zd2makezd2box1999z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3844z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2setq14232z00,
		BGl_z62walk3zd2setq1835zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3763z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2no4233za7,
		BGl_z62walk2za2zd2node1672z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3926z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2makeza74234za7,
		BGl_z62walk1zd2makezd2box2001z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3845z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se4235za7,
		BGl_z62walk0za2zd2setq1837z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3764z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2no4236za7,
		BGl_z62walk3za2zd2node1675z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3927z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2makeza74237za7,
		BGl_z62walk2zd2makezd2box2003z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3846z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se4238za7,
		BGl_z62walk1za2zd2setq1839z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3765z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2no4239za7,
		BGl_z62walk0z12zd2node1677za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3928z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2makeza74240za7,
		BGl_z62walk3zd2makezd2box2005z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3847z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se4241za7,
		BGl_z62walk2za2zd2setq1841z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3766z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2no4242za7,
		BGl_z62walk1z12zd2node1679za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3929z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ma4243za7,
		BGl_z62walk0za2zd2makezd2box2008zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3848z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se4244za7,
		BGl_z62walk3za2zd2setq1843z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3767z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2no4245za7,
		BGl_z62walk2z12zd2node1681za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3849z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se4246za7,
		BGl_z62walk0z12zd2setq1845za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3768z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2no4247za7,
		BGl_z62walk3z12zd2node1683za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3769z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2seque4248z00,
		BGl_z62walk0zd2sequence1685zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk2zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk2za762za7za7ast4249z00, BGl_z62walk2z62zzast_walkz00, 0L,
		BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3930z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ma4250za7,
		BGl_z62walk1za2zd2makezd2box2010zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3931z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ma4251za7,
		BGl_z62walk2za2zd2makezd2box2012zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3850z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se4252za7,
		BGl_z62walk1z12zd2setq1847za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3932z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ma4253za7,
		BGl_z62walk3za2zd2makezd2box2014zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3851z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se4254za7,
		BGl_z62walk2z12zd2setq1849za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3770z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2seque4255z00,
		BGl_z62walk1zd2sequence1687zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3933z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ma4256za7,
		BGl_z62walk0z12zd2makezd2box2016z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3852z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4257za7,
		BGl_z62walk3z12zd2setq1851za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3771z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2seque4258z00,
		BGl_z62walk2zd2sequence1689zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3934z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ma4259za7,
		BGl_z62walk1z12zd2makezd2box2018z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3853z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2condi4260z00,
		BGl_z62walk0zd2conditional1853zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3772z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2seque4261z00,
		BGl_z62walk3zd2sequence1691zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3935z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ma4262za7,
		BGl_z62walk2z12zd2makezd2box2020z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3854z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2condi4263z00,
		BGl_z62walk1zd2conditional1855zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3773z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se4264za7,
		BGl_z62walk0za2zd2sequence1693z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3936z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ma4265za7,
		BGl_z62walk3z12zd2makezd2box2022z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3855z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2condi4266z00,
		BGl_z62walk2zd2conditional1857zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3774z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se4267za7,
		BGl_z62walk1za2zd2sequence1695z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3937z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2boxza7d4268za7,
		BGl_z62walk0zd2boxzd2ref2024z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3856z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2condi4269z00,
		BGl_z62walk3zd2conditional1859zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3775z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se4270za7,
		BGl_z62walk2za2zd2sequence1697z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3938z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2boxza7d4271za7,
		BGl_z62walk1zd2boxzd2ref2026z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3857z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2co4272za7,
		BGl_z62walk0za2zd2conditional1861z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3776z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se4273za7,
		BGl_z62walk3za2zd2sequence1699z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3939z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2boxza7d4274za7,
		BGl_z62walk2zd2boxzd2ref2028z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3858z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2co4275za7,
		BGl_z62walk1za2zd2conditional1863z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3777z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se4276za7,
		BGl_z62walk0z12zd2sequence1701za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3859z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2co4277za7,
		BGl_z62walk2za2zd2conditional1865z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3778z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se4278za7,
		BGl_z62walk1z12zd2sequence1703za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3779z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se4279za7,
		BGl_z62walk2z12zd2sequence1705za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk0za712za770za7za74280za7, BGl_z62walk0z12z70zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3940z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2boxza7d4281za7,
		BGl_z62walk3zd2boxzd2ref2030z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3941z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2bo4282za7,
		BGl_z62walk0za2zd2boxzd2ref2032zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3860z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2co4283za7,
		BGl_z62walk3za2zd2conditional1867z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3942z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2bo4284za7,
		BGl_z62walk1za2zd2boxzd2ref2034zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3861z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2co4285za7,
		BGl_z62walk0z12zd2conditional1869za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3780z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4286za7,
		BGl_z62walk3z12zd2sequence1707za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3943z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2bo4287za7,
		BGl_z62walk2za2zd2boxzd2ref2036zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3862z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2co4288za7,
		BGl_z62walk1z12zd2conditional1871za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3781z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2app174289z00, BGl_z62walk0zd2app1709zb0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3944z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2bo4290za7,
		BGl_z62walk3za2zd2boxzd2ref2038zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3863z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2co4291za7,
		BGl_z62walk2z12zd2conditional1873za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3782z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2app174292z00, BGl_z62walk1zd2app1711zb0zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3945z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2bo4293za7,
		BGl_z62walk0z12zd2boxzd2ref2040z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3864z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2co4294za7,
		BGl_z62walk3z12zd2conditional1875za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3783z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2app174295z00, BGl_z62walk2zd2app1713zb0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3946z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2bo4296za7,
		BGl_z62walk1z12zd2boxzd2ref2042z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3865z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2fail14297z00,
		BGl_z62walk0zd2fail1877zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3784z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2app174298z00, BGl_z62walk3zd2app1715zb0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3947z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2bo4299za7,
		BGl_z62walk2z12zd2boxzd2ref2044z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3866z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2fail14300z00,
		BGl_z62walk1zd2fail1879zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3785z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ap4301za7,
		BGl_z62walk0za2zd2app1717z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3948z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2bo4302za7,
		BGl_z62walk3z12zd2boxzd2ref2046z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3867z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2fail14303z00,
		BGl_z62walk2zd2fail1881zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3786z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ap4304za7,
		BGl_z62walk1za2zd2app1719z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3949z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2boxza7d4305za7,
		BGl_z62walk0zd2boxzd2setz122048z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3868z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2fail14306z00,
		BGl_z62walk3zd2fail1883zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3787z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ap4307za7,
		BGl_z62walk2za2zd2app1721z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3869z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2fa4308za7,
		BGl_z62walk0za2zd2fail1885z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3788z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ap4309za7,
		BGl_z62walk3za2zd2app1723z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3789z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ap4310za7,
		BGl_z62walk0z12zd2app1725za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3950z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2boxza7d4311za7,
		BGl_z62walk1zd2boxzd2setz122050z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3951z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2boxza7d4312za7,
		BGl_z62walk2zd2boxzd2setz122052z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3870z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2fa4313za7,
		BGl_z62walk1za2zd2fail1887z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3952z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2boxza7d4314za7,
		BGl_z62walk3zd2boxzd2setz122054z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3871z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2fa4315za7,
		BGl_z62walk2za2zd2fail1889z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3790z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ap4316za7,
		BGl_z62walk1z12zd2app1727za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3953z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2bo4317za7,
		BGl_z62walk0za2zd2boxzd2setz122056zd2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3872z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2fa4318za7,
		BGl_z62walk3za2zd2fail1891z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3791z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ap4319za7,
		BGl_z62walk2z12zd2app1729za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3954z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2bo4320za7,
		BGl_z62walk1za2zd2boxzd2setz122058zd2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3873z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2fa4321za7,
		BGl_z62walk0z12zd2fail1893za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3792z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ap4322za7,
		BGl_z62walk3z12zd2app1731za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3955z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2bo4323za7,
		BGl_z62walk2za2zd2boxzd2setz122060zd2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3874z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2fa4324za7,
		BGl_z62walk1z12zd2fail1895za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3793z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2appza7d4325za7,
		BGl_z62walk0zd2appzd2ly1733z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3956z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2bo4326za7,
		BGl_z62walk3za2zd2boxzd2setz122062zd2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3875z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2fa4327za7,
		BGl_z62walk2z12zd2fail1897za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3794z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2appza7d4328za7,
		BGl_z62walk1zd2appzd2ly1735z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3957z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2bo4329za7,
		BGl_z62walk0z12zd2boxzd2setz122064z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3876z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2fa4330za7,
		BGl_z62walk3z12zd2fail1899za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3795z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2appza7d4331za7,
		BGl_z62walk2zd2appzd2ly1737z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3958z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2bo4332za7,
		BGl_z62walk1z12zd2boxzd2setz122066z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3877z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2setza7d4333za7,
		BGl_z62walk0zd2setzd2exzd2it1901zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3796z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2appza7d4334za7,
		BGl_z62walk3zd2appzd2ly1739z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3959z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2bo4335za7,
		BGl_z62walk2z12zd2boxzd2setz122068z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3878z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2setza7d4336za7,
		BGl_z62walk1zd2setzd2exzd2it1903zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3797z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ap4337za7,
		BGl_z62walk0za2zd2appzd2ly1741zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3879z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2setza7d4338za7,
		BGl_z62walk2zd2setzd2exzd2it1905zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3798z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ap4339za7,
		BGl_z62walk1za2zd2appzd2ly1743zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3799z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ap4340za7,
		BGl_z62walk2za2zd2appzd2ly1745zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3960z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2bo4341za7,
		BGl_z62walk3z12zd2boxzd2setz122070z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3961z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2sync24342z00,
		BGl_z62walk0zd2sync2072zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3880z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2setza7d4343za7,
		BGl_z62walk3zd2setzd2exzd2it1907zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3962z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2sync24344z00,
		BGl_z62walk1zd2sync2074zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3881z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se4345za7,
		BGl_z62walk0za2zd2setzd2exzd2it1909z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3963z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2sync24346z00,
		BGl_z62walk2zd2sync2076zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3882z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se4347za7,
		BGl_z62walk1za2zd2setzd2exzd2it1911z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3964z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2sync24348z00,
		BGl_z62walk3zd2sync2078zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3883z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se4349za7,
		BGl_z62walk2za2zd2setzd2exzd2it1913z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3965z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2sy4350za7,
		BGl_z62walk0za2zd2sync2080z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3884z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se4351za7,
		BGl_z62walk3za2zd2setzd2exzd2it1915z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3966z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2sy4352za7,
		BGl_z62walk1za2zd2sync2082z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3885z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se4353za7,
		BGl_z62walk0z12zd2setzd2exzd2it1917za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3967z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2sy4354za7,
		BGl_z62walk2za2zd2sync2084z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3886z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se4355za7,
		BGl_z62walk1z12zd2setzd2exzd2it1919za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3968z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2sy4356za7,
		BGl_z62walk3za2zd2sync2086z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3887z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se4357za7,
		BGl_z62walk2z12zd2setzd2exzd2it1921za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3969z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2sy4358za7,
		BGl_z62walk0z12zd2sync2088za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3888z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4359za7,
		BGl_z62walk3z12zd2setzd2exzd2it1923za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3889z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2jumpza74360za7,
		BGl_z62walk0zd2jumpzd2exzd2it1925zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk3za762za7za7ast4361z00, BGl_z62walk3z62zzast_walkz00, 0L,
		BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3970z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2sy4362za7,
		BGl_z62walk1z12zd2sync2090za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3971z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2sy4363za7,
		BGl_z62walk2z12zd2sync2092za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3890z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2jumpza74364za7,
		BGl_z62walk1zd2jumpzd2exzd2it1927zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3972z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2sy4365za7,
		BGl_z62walk3z12zd2sync2094za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3891z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2jumpza74366za7,
		BGl_z62walk2zd2jumpzd2exzd2it1929zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3973z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2switc4367z00,
		BGl_z62walk0zd2switch2096zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3892z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2jumpza74368za7,
		BGl_z62walk3zd2jumpzd2exzd2it1931zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3974z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2switc4369z00,
		BGl_z62walk1zd2switch2098zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3893z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ju4370za7,
		BGl_z62walk0za2zd2jumpzd2exzd2it1933z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3975z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2switc4371z00,
		BGl_z62walk2zd2switch2100zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3894z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ju4372za7,
		BGl_z62walk1za2zd2jumpzd2exzd2it1935z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3976z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2switc4373z00,
		BGl_z62walk3zd2switch2102zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3895z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ju4374za7,
		BGl_z62walk2za2zd2jumpzd2exzd2it1937z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3977z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2sw4375za7,
		BGl_z62walk0za2zd2switch2104z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3896z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ju4376za7,
		BGl_z62walk3za2zd2jumpzd2exzd2it1939z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3978z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2sw4377za7,
		BGl_z62walk1za2zd2switch2106z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3897z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ju4378za7,
		BGl_z62walk0z12zd2jumpzd2exzd2it1941za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3979z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2sw4379za7,
		BGl_z62walk2za2zd2switch2108z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3898z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ju4380za7,
		BGl_z62walk1z12zd2jumpzd2exzd2it1943za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3899z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ju4381za7,
		BGl_z62walk2z12zd2jumpzd2exzd2it1945za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7c0za7za74382za7, BGl_z62walk0za2zc0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3980z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2sw4383za7,
		BGl_z62walk3za2zd2switch2110z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3981z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2sw4384za7,
		BGl_z62walk0z12zd2switch2112za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3982z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2sw4385za7,
		BGl_z62walk1z12zd2switch2114za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3983z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2sw4386za7,
		BGl_z62walk2z12zd2switch2116za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3984z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2sw4387za7,
		BGl_z62walk3z12zd2switch2118za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3985z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2letza7d4388za7,
		BGl_z62walk0zd2letzd2fun2120z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3986z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2letza7d4389za7,
		BGl_z62walk1zd2letzd2fun2122z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3987z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2letza7d4390za7,
		BGl_z62walk2zd2letzd2fun2124z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3988z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2letza7d4391za7,
		BGl_z62walk3zd2letzd2fun2126z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3989z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2le4392za7,
		BGl_z62walk0za2zd2letzd2fun2128zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk1za712za770za7za74393za7, BGl_z62walk1z12z70zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3990z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2le4394za7,
		BGl_z62walk1za2zd2letzd2fun2130zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3991z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2le4395za7,
		BGl_z62walk2za2zd2letzd2fun2132zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3992z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2le4396za7,
		BGl_z62walk3za2zd2letzd2fun2134zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3993z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2le4397za7,
		BGl_z62walk0z12zd2letzd2fun2136z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3994z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2le4398za7,
		BGl_z62walk1z12zd2letzd2fun2138z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3995z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2le4399za7,
		BGl_z62walk2z12zd2letzd2fun2140z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3996z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2le4400za7,
		BGl_z62walk3z12zd2letzd2fun2142z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3997z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2letza7d4401za7,
		BGl_z62walk0zd2letzd2var2144z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3998z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2letza7d4402za7,
		BGl_z62walk1zd2letzd2var2146z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3999z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2letza7d4403za7,
		BGl_z62walk2zd2letzd2var2148z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk4za762za7za7ast4404z00, BGl_z62walk4z62zzast_walkz00, 0L,
		BUNSPEC, 6);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7c0za7za74405za7, BGl_z62walk1za2zc0zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk2z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk2za712za770za7za74406za7, BGl_z62walk2z12z70zzast_walkz00,
		0L, BUNSPEC, 4);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_walkz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long
		BgL_checksumz00_9894, char *BgL_fromz00_9895)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzast_walkz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_walkz00();
					BGl_libraryzd2moduleszd2initz00zzast_walkz00();
					BGl_importedzd2moduleszd2initz00zzast_walkz00();
					BGl_genericzd2initzd2zzast_walkz00();
					BGl_methodzd2initzd2zzast_walkz00();
					return BGl_toplevelzd2initzd2zzast_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__pp_circlez00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_walk");
			return BUNSPEC;
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzast_walkz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_2274;

				BgL_headz00_2274 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_2275;
					obj_t BgL_tailz00_2276;

					BgL_prevz00_2275 = BgL_headz00_2274;
					BgL_tailz00_2276 = BgL_l1z00_1;
				BgL_loopz00_2277:
					if (PAIRP(BgL_tailz00_2276))
						{
							obj_t BgL_newzd2prevzd2_2279;

							BgL_newzd2prevzd2_2279 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_2276), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_2275, BgL_newzd2prevzd2_2279);
							{
								obj_t BgL_tailz00_9922;
								obj_t BgL_prevz00_9921;

								BgL_prevz00_9921 = BgL_newzd2prevzd2_2279;
								BgL_tailz00_9922 = CDR(BgL_tailz00_2276);
								BgL_tailz00_2276 = BgL_tailz00_9922;
								BgL_prevz00_2275 = BgL_prevz00_9921;
								goto BgL_loopz00_2277;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_2274);
				}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk0zd2envzd2zzast_walkz00,
				BGl_proc3712z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3713z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk1zd2envzd2zzast_walkz00,
				BGl_proc3714z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3715z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk2zd2envzd2zzast_walkz00,
				BGl_proc3716z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3717z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk3zd2envzd2zzast_walkz00,
				BGl_proc3718z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3719z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk4zd2envzd2zzast_walkz00,
				BGl_proc3720z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3721z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_proc3722z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3723z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_proc3724z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3725z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_proc3726z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3727z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_proc3728z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3729z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk4za2zd2envz70zzast_walkz00, BGl_proc3730z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3731z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_proc3732z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3733z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_proc3734z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3735z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_proc3736z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3737z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_proc3738z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3739z00zzast_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk4z12zd2envzc0zzast_walkz00, BGl_proc3740z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3741z00zzast_walkz00);
		}

	}



/* &walk4!1657 */
	obj_t BGl_z62walk4z121657z70zzast_walkz00(obj_t BgL_envz00_7015,
		obj_t BgL_nz00_7016, obj_t BgL_pz00_7017, obj_t BgL_arg0z00_7018,
		obj_t BgL_arg1z00_7019, obj_t BgL_arg2z00_7020, obj_t BgL_arg3z00_7021)
	{
		{	/* Ast/walk.scm 160 */
			{	/* Ast/walk.scm 162 */
				obj_t BgL_arg2230z00_8653;

				{	/* Ast/walk.scm 162 */
					obj_t BgL_zc3z04anonymousza32232ze3z87_8654;

					BgL_zc3z04anonymousza32232ze3z87_8654 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32232ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32232ze3z87_8654,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7016)));
					BgL_arg2230z00_8653 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32232ze3z87_8654);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3742z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2230z00_8653);
			}
		}

	}



/* &<@anonymous:2232> */
	obj_t BGl_z62zc3z04anonymousza32232ze3ze5zzast_walkz00(obj_t BgL_envz00_7022)
	{
		{	/* Ast/walk.scm 162 */
			{	/* Ast/walk.scm 162 */
				BgL_nodez00_bglt BgL_nz00_7023;

				BgL_nz00_7023 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7022, (int) (((long) 0))));
				{	/* Ast/walk.scm 162 */
					obj_t BgL_portz00_8655;

					{	/* Ast/walk.scm 162 */
						obj_t BgL_tmpz00_9952;

						BgL_tmpz00_9952 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8655 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_9952);
					}
					{	/* Ast/walk.scm 162 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7023), BgL_portz00_8655);
					}
				}
			}
		}

	}



/* &walk3!1655 */
	obj_t BGl_z62walk3z121655z70zzast_walkz00(obj_t BgL_envz00_7024,
		obj_t BgL_nz00_7025, obj_t BgL_pz00_7026, obj_t BgL_arg0z00_7027,
		obj_t BgL_arg1z00_7028, obj_t BgL_arg2z00_7029)
	{
		{	/* Ast/walk.scm 157 */
			{	/* Ast/walk.scm 159 */
				obj_t BgL_arg2226z00_8658;

				{	/* Ast/walk.scm 159 */
					obj_t BgL_zc3z04anonymousza32228ze3z87_8659;

					BgL_zc3z04anonymousza32228ze3z87_8659 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32228ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32228ze3z87_8659,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7025)));
					BgL_arg2226z00_8658 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32228ze3z87_8659);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3744z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2226z00_8658);
			}
		}

	}



/* &<@anonymous:2228> */
	obj_t BGl_z62zc3z04anonymousza32228ze3ze5zzast_walkz00(obj_t BgL_envz00_7030)
	{
		{	/* Ast/walk.scm 159 */
			{	/* Ast/walk.scm 159 */
				BgL_nodez00_bglt BgL_nz00_7031;

				BgL_nz00_7031 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7030, (int) (((long) 0))));
				{	/* Ast/walk.scm 159 */
					obj_t BgL_portz00_8660;

					{	/* Ast/walk.scm 159 */
						obj_t BgL_tmpz00_9969;

						BgL_tmpz00_9969 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8660 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_9969);
					}
					{	/* Ast/walk.scm 159 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7031), BgL_portz00_8660);
					}
				}
			}
		}

	}



/* &walk2!1653 */
	obj_t BGl_z62walk2z121653z70zzast_walkz00(obj_t BgL_envz00_7032,
		obj_t BgL_nz00_7033, obj_t BgL_pz00_7034, obj_t BgL_arg0z00_7035,
		obj_t BgL_arg1z00_7036)
	{
		{	/* Ast/walk.scm 154 */
			{	/* Ast/walk.scm 156 */
				obj_t BgL_arg2222z00_8663;

				{	/* Ast/walk.scm 156 */
					obj_t BgL_zc3z04anonymousza32224ze3z87_8664;

					BgL_zc3z04anonymousza32224ze3z87_8664 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32224ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32224ze3z87_8664,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7033)));
					BgL_arg2222z00_8663 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32224ze3z87_8664);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3745z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2222z00_8663);
			}
		}

	}



/* &<@anonymous:2224> */
	obj_t BGl_z62zc3z04anonymousza32224ze3ze5zzast_walkz00(obj_t BgL_envz00_7037)
	{
		{	/* Ast/walk.scm 156 */
			{	/* Ast/walk.scm 156 */
				BgL_nodez00_bglt BgL_nz00_7038;

				BgL_nz00_7038 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7037, (int) (((long) 0))));
				{	/* Ast/walk.scm 156 */
					obj_t BgL_portz00_8665;

					{	/* Ast/walk.scm 156 */
						obj_t BgL_tmpz00_9986;

						BgL_tmpz00_9986 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8665 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_9986);
					}
					{	/* Ast/walk.scm 156 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7038), BgL_portz00_8665);
					}
				}
			}
		}

	}



/* &walk1!1651 */
	obj_t BGl_z62walk1z121651z70zzast_walkz00(obj_t BgL_envz00_7039,
		obj_t BgL_nz00_7040, obj_t BgL_pz00_7041, obj_t BgL_arg0z00_7042)
	{
		{	/* Ast/walk.scm 151 */
			{	/* Ast/walk.scm 153 */
				obj_t BgL_arg2218z00_8668;

				{	/* Ast/walk.scm 153 */
					obj_t BgL_zc3z04anonymousza32220ze3z87_8669;

					BgL_zc3z04anonymousza32220ze3z87_8669 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32220ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32220ze3z87_8669,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7040)));
					BgL_arg2218z00_8668 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32220ze3z87_8669);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3746z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2218z00_8668);
			}
		}

	}



/* &<@anonymous:2220> */
	obj_t BGl_z62zc3z04anonymousza32220ze3ze5zzast_walkz00(obj_t BgL_envz00_7043)
	{
		{	/* Ast/walk.scm 153 */
			{	/* Ast/walk.scm 153 */
				BgL_nodez00_bglt BgL_nz00_7044;

				BgL_nz00_7044 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7043, (int) (((long) 0))));
				{	/* Ast/walk.scm 153 */
					obj_t BgL_portz00_8670;

					{	/* Ast/walk.scm 153 */
						obj_t BgL_tmpz00_10003;

						BgL_tmpz00_10003 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8670 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10003);
					}
					{	/* Ast/walk.scm 153 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7044), BgL_portz00_8670);
					}
				}
			}
		}

	}



/* &walk0!1649 */
	obj_t BGl_z62walk0z121649z70zzast_walkz00(obj_t BgL_envz00_7045,
		obj_t BgL_nz00_7046, obj_t BgL_pz00_7047)
	{
		{	/* Ast/walk.scm 148 */
			{	/* Ast/walk.scm 150 */
				obj_t BgL_arg2214z00_8673;

				{	/* Ast/walk.scm 150 */
					obj_t BgL_zc3z04anonymousza32216ze3z87_8674;

					BgL_zc3z04anonymousza32216ze3z87_8674 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32216ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32216ze3z87_8674,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7046)));
					BgL_arg2214z00_8673 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32216ze3z87_8674);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3747z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2214z00_8673);
			}
		}

	}



/* &<@anonymous:2216> */
	obj_t BGl_z62zc3z04anonymousza32216ze3ze5zzast_walkz00(obj_t BgL_envz00_7048)
	{
		{	/* Ast/walk.scm 150 */
			{	/* Ast/walk.scm 150 */
				BgL_nodez00_bglt BgL_nz00_7049;

				BgL_nz00_7049 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7048, (int) (((long) 0))));
				{	/* Ast/walk.scm 150 */
					obj_t BgL_portz00_8675;

					{	/* Ast/walk.scm 150 */
						obj_t BgL_tmpz00_10020;

						BgL_tmpz00_10020 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8675 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10020);
					}
					{	/* Ast/walk.scm 150 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7049), BgL_portz00_8675);
					}
				}
			}
		}

	}



/* &walk4*1646 */
	obj_t BGl_z62walk4za21646zc0zzast_walkz00(obj_t BgL_envz00_7050,
		obj_t BgL_nz00_7051, obj_t BgL_pz00_7052, obj_t BgL_arg0z00_7053,
		obj_t BgL_arg1z00_7054, obj_t BgL_arg2z00_7055, obj_t BgL_arg3z00_7056)
	{
		{	/* Ast/walk.scm 144 */
			{	/* Ast/walk.scm 146 */
				obj_t BgL_arg2210z00_8678;

				{	/* Ast/walk.scm 146 */
					obj_t BgL_zc3z04anonymousza32212ze3z87_8679;

					BgL_zc3z04anonymousza32212ze3z87_8679 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32212ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32212ze3z87_8679,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7051)));
					BgL_arg2210z00_8678 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32212ze3z87_8679);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3742z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2210z00_8678);
			}
		}

	}



/* &<@anonymous:2212> */
	obj_t BGl_z62zc3z04anonymousza32212ze3ze5zzast_walkz00(obj_t BgL_envz00_7057)
	{
		{	/* Ast/walk.scm 146 */
			{	/* Ast/walk.scm 146 */
				BgL_nodez00_bglt BgL_nz00_7058;

				BgL_nz00_7058 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7057, (int) (((long) 0))));
				{	/* Ast/walk.scm 146 */
					obj_t BgL_portz00_8680;

					{	/* Ast/walk.scm 146 */
						obj_t BgL_tmpz00_10037;

						BgL_tmpz00_10037 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8680 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10037);
					}
					{	/* Ast/walk.scm 146 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7058), BgL_portz00_8680);
					}
				}
			}
		}

	}



/* &walk3*1644 */
	obj_t BGl_z62walk3za21644zc0zzast_walkz00(obj_t BgL_envz00_7059,
		obj_t BgL_nz00_7060, obj_t BgL_pz00_7061, obj_t BgL_arg0z00_7062,
		obj_t BgL_arg1z00_7063, obj_t BgL_arg2z00_7064)
	{
		{	/* Ast/walk.scm 141 */
			{	/* Ast/walk.scm 143 */
				obj_t BgL_arg2206z00_8683;

				{	/* Ast/walk.scm 143 */
					obj_t BgL_zc3z04anonymousza32208ze3z87_8684;

					BgL_zc3z04anonymousza32208ze3z87_8684 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32208ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32208ze3z87_8684,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7060)));
					BgL_arg2206z00_8683 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32208ze3z87_8684);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3748z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2206z00_8683);
			}
		}

	}



/* &<@anonymous:2208> */
	obj_t BGl_z62zc3z04anonymousza32208ze3ze5zzast_walkz00(obj_t BgL_envz00_7065)
	{
		{	/* Ast/walk.scm 143 */
			{	/* Ast/walk.scm 143 */
				BgL_nodez00_bglt BgL_nz00_7066;

				BgL_nz00_7066 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7065, (int) (((long) 0))));
				{	/* Ast/walk.scm 143 */
					obj_t BgL_portz00_8685;

					{	/* Ast/walk.scm 143 */
						obj_t BgL_tmpz00_10054;

						BgL_tmpz00_10054 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8685 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10054);
					}
					{	/* Ast/walk.scm 143 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7066), BgL_portz00_8685);
					}
				}
			}
		}

	}



/* &walk2*1642 */
	obj_t BGl_z62walk2za21642zc0zzast_walkz00(obj_t BgL_envz00_7067,
		obj_t BgL_nz00_7068, obj_t BgL_pz00_7069, obj_t BgL_arg0z00_7070,
		obj_t BgL_arg1z00_7071)
	{
		{	/* Ast/walk.scm 138 */
			{	/* Ast/walk.scm 140 */
				obj_t BgL_arg2202z00_8688;

				{	/* Ast/walk.scm 140 */
					obj_t BgL_zc3z04anonymousza32204ze3z87_8689;

					BgL_zc3z04anonymousza32204ze3z87_8689 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32204ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32204ze3z87_8689,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7068)));
					BgL_arg2202z00_8688 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32204ze3z87_8689);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3749z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2202z00_8688);
			}
		}

	}



/* &<@anonymous:2204> */
	obj_t BGl_z62zc3z04anonymousza32204ze3ze5zzast_walkz00(obj_t BgL_envz00_7072)
	{
		{	/* Ast/walk.scm 140 */
			{	/* Ast/walk.scm 140 */
				BgL_nodez00_bglt BgL_nz00_7073;

				BgL_nz00_7073 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7072, (int) (((long) 0))));
				{	/* Ast/walk.scm 140 */
					obj_t BgL_portz00_8690;

					{	/* Ast/walk.scm 140 */
						obj_t BgL_tmpz00_10071;

						BgL_tmpz00_10071 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8690 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10071);
					}
					{	/* Ast/walk.scm 140 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7073), BgL_portz00_8690);
					}
				}
			}
		}

	}



/* &walk1*1640 */
	obj_t BGl_z62walk1za21640zc0zzast_walkz00(obj_t BgL_envz00_7074,
		obj_t BgL_nz00_7075, obj_t BgL_pz00_7076, obj_t BgL_arg0z00_7077)
	{
		{	/* Ast/walk.scm 135 */
			{	/* Ast/walk.scm 137 */
				obj_t BgL_arg2198z00_8693;

				{	/* Ast/walk.scm 137 */
					obj_t BgL_zc3z04anonymousza32200ze3z87_8694;

					BgL_zc3z04anonymousza32200ze3z87_8694 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32200ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32200ze3z87_8694,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7075)));
					BgL_arg2198z00_8693 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32200ze3z87_8694);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3750z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2198z00_8693);
			}
		}

	}



/* &<@anonymous:2200> */
	obj_t BGl_z62zc3z04anonymousza32200ze3ze5zzast_walkz00(obj_t BgL_envz00_7078)
	{
		{	/* Ast/walk.scm 137 */
			{	/* Ast/walk.scm 137 */
				BgL_nodez00_bglt BgL_nz00_7079;

				BgL_nz00_7079 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7078, (int) (((long) 0))));
				{	/* Ast/walk.scm 137 */
					obj_t BgL_portz00_8695;

					{	/* Ast/walk.scm 137 */
						obj_t BgL_tmpz00_10088;

						BgL_tmpz00_10088 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8695 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10088);
					}
					{	/* Ast/walk.scm 137 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7079), BgL_portz00_8695);
					}
				}
			}
		}

	}



/* &walk0*1638 */
	obj_t BGl_z62walk0za21638zc0zzast_walkz00(obj_t BgL_envz00_7080,
		obj_t BgL_nz00_7081, obj_t BgL_pz00_7082)
	{
		{	/* Ast/walk.scm 132 */
			{	/* Ast/walk.scm 134 */
				obj_t BgL_arg2194z00_8698;

				{	/* Ast/walk.scm 134 */
					obj_t BgL_zc3z04anonymousza32196ze3z87_8699;

					BgL_zc3z04anonymousza32196ze3z87_8699 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32196ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32196ze3z87_8699,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7081)));
					BgL_arg2194z00_8698 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32196ze3z87_8699);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3751z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2194z00_8698);
			}
		}

	}



/* &<@anonymous:2196> */
	obj_t BGl_z62zc3z04anonymousza32196ze3ze5zzast_walkz00(obj_t BgL_envz00_7083)
	{
		{	/* Ast/walk.scm 134 */
			{	/* Ast/walk.scm 134 */
				BgL_nodez00_bglt BgL_nz00_7084;

				BgL_nz00_7084 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7083, (int) (((long) 0))));
				{	/* Ast/walk.scm 134 */
					obj_t BgL_portz00_8700;

					{	/* Ast/walk.scm 134 */
						obj_t BgL_tmpz00_10105;

						BgL_tmpz00_10105 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8700 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10105);
					}
					{	/* Ast/walk.scm 134 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7084), BgL_portz00_8700);
					}
				}
			}
		}

	}



/* &walk41636 */
	obj_t BGl_z62walk41636z62zzast_walkz00(obj_t BgL_envz00_7085,
		obj_t BgL_nz00_7086, obj_t BgL_pz00_7087, obj_t BgL_arg0z00_7088,
		obj_t BgL_arg1z00_7089, obj_t BgL_arg2z00_7090, obj_t BgL_arg3z00_7091)
	{
		{	/* Ast/walk.scm 128 */
			{	/* Ast/walk.scm 130 */
				obj_t BgL_arg2190z00_8703;

				{	/* Ast/walk.scm 130 */
					obj_t BgL_zc3z04anonymousza32192ze3z87_8704;

					BgL_zc3z04anonymousza32192ze3z87_8704 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32192ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32192ze3z87_8704,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7086)));
					BgL_arg2190z00_8703 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32192ze3z87_8704);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3752z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2190z00_8703);
			}
		}

	}



/* &<@anonymous:2192> */
	obj_t BGl_z62zc3z04anonymousza32192ze3ze5zzast_walkz00(obj_t BgL_envz00_7092)
	{
		{	/* Ast/walk.scm 130 */
			{	/* Ast/walk.scm 130 */
				BgL_nodez00_bglt BgL_nz00_7093;

				BgL_nz00_7093 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7092, (int) (((long) 0))));
				{	/* Ast/walk.scm 130 */
					obj_t BgL_portz00_8705;

					{	/* Ast/walk.scm 130 */
						obj_t BgL_tmpz00_10122;

						BgL_tmpz00_10122 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8705 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10122);
					}
					{	/* Ast/walk.scm 130 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7093), BgL_portz00_8705);
					}
				}
			}
		}

	}



/* &walk31634 */
	obj_t BGl_z62walk31634z62zzast_walkz00(obj_t BgL_envz00_7094,
		obj_t BgL_nz00_7095, obj_t BgL_pz00_7096, obj_t BgL_arg0z00_7097,
		obj_t BgL_arg1z00_7098, obj_t BgL_arg2z00_7099)
	{
		{	/* Ast/walk.scm 125 */
			{	/* Ast/walk.scm 127 */
				obj_t BgL_arg2186z00_8708;

				{	/* Ast/walk.scm 127 */
					obj_t BgL_zc3z04anonymousza32188ze3z87_8709;

					BgL_zc3z04anonymousza32188ze3z87_8709 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32188ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32188ze3z87_8709,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7095)));
					BgL_arg2186z00_8708 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32188ze3z87_8709);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3753z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2186z00_8708);
			}
		}

	}



/* &<@anonymous:2188> */
	obj_t BGl_z62zc3z04anonymousza32188ze3ze5zzast_walkz00(obj_t BgL_envz00_7100)
	{
		{	/* Ast/walk.scm 127 */
			{	/* Ast/walk.scm 127 */
				BgL_nodez00_bglt BgL_nz00_7101;

				BgL_nz00_7101 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7100, (int) (((long) 0))));
				{	/* Ast/walk.scm 127 */
					obj_t BgL_portz00_8710;

					{	/* Ast/walk.scm 127 */
						obj_t BgL_tmpz00_10139;

						BgL_tmpz00_10139 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8710 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10139);
					}
					{	/* Ast/walk.scm 127 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7101), BgL_portz00_8710);
					}
				}
			}
		}

	}



/* &walk21632 */
	obj_t BGl_z62walk21632z62zzast_walkz00(obj_t BgL_envz00_7102,
		obj_t BgL_nz00_7103, obj_t BgL_pz00_7104, obj_t BgL_arg0z00_7105,
		obj_t BgL_arg1z00_7106)
	{
		{	/* Ast/walk.scm 122 */
			{	/* Ast/walk.scm 124 */
				obj_t BgL_arg2182z00_8713;

				{	/* Ast/walk.scm 124 */
					obj_t BgL_zc3z04anonymousza32184ze3z87_8714;

					BgL_zc3z04anonymousza32184ze3z87_8714 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32184ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_8714,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7103)));
					BgL_arg2182z00_8713 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32184ze3z87_8714);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3754z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2182z00_8713);
			}
		}

	}



/* &<@anonymous:2184> */
	obj_t BGl_z62zc3z04anonymousza32184ze3ze5zzast_walkz00(obj_t BgL_envz00_7107)
	{
		{	/* Ast/walk.scm 124 */
			{	/* Ast/walk.scm 124 */
				BgL_nodez00_bglt BgL_nz00_7108;

				BgL_nz00_7108 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7107, (int) (((long) 0))));
				{	/* Ast/walk.scm 124 */
					obj_t BgL_portz00_8715;

					{	/* Ast/walk.scm 124 */
						obj_t BgL_tmpz00_10156;

						BgL_tmpz00_10156 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8715 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10156);
					}
					{	/* Ast/walk.scm 124 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7108), BgL_portz00_8715);
					}
				}
			}
		}

	}



/* &walk11630 */
	obj_t BGl_z62walk11630z62zzast_walkz00(obj_t BgL_envz00_7109,
		obj_t BgL_nz00_7110, obj_t BgL_pz00_7111, obj_t BgL_arg0z00_7112)
	{
		{	/* Ast/walk.scm 119 */
			{	/* Ast/walk.scm 121 */
				obj_t BgL_arg2177z00_8718;

				{	/* Ast/walk.scm 121 */
					obj_t BgL_zc3z04anonymousza32179ze3z87_8719;

					BgL_zc3z04anonymousza32179ze3z87_8719 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32179ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32179ze3z87_8719,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7110)));
					BgL_arg2177z00_8718 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32179ze3z87_8719);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3755z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2177z00_8718);
			}
		}

	}



/* &<@anonymous:2179> */
	obj_t BGl_z62zc3z04anonymousza32179ze3ze5zzast_walkz00(obj_t BgL_envz00_7113)
	{
		{	/* Ast/walk.scm 121 */
			{	/* Ast/walk.scm 121 */
				BgL_nodez00_bglt BgL_nz00_7114;

				BgL_nz00_7114 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7113, (int) (((long) 0))));
				{	/* Ast/walk.scm 121 */
					obj_t BgL_portz00_8720;

					{	/* Ast/walk.scm 121 */
						obj_t BgL_tmpz00_10173;

						BgL_tmpz00_10173 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8720 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10173);
					}
					{	/* Ast/walk.scm 121 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7114), BgL_portz00_8720);
					}
				}
			}
		}

	}



/* &walk01627 */
	obj_t BGl_z62walk01627z62zzast_walkz00(obj_t BgL_envz00_7115,
		obj_t BgL_nz00_7116, obj_t BgL_pz00_7117)
	{
		{	/* Ast/walk.scm 116 */
			{	/* Ast/walk.scm 118 */
				obj_t BgL_arg2172z00_8723;

				{	/* Ast/walk.scm 118 */
					obj_t BgL_zc3z04anonymousza32174ze3z87_8724;

					BgL_zc3z04anonymousza32174ze3z87_8724 =
						MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32174ze3ze5zzast_walkz00,
						(int) (((long) 0)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32174ze3z87_8724,
						(int) (((long) 0)), ((obj_t) ((BgL_nodez00_bglt) BgL_nz00_7116)));
					BgL_arg2172z00_8723 =
						BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
						(BgL_zc3z04anonymousza32174ze3z87_8724);
				}
				return
					BGl_errorz00zz__errorz00(BGl_string3756z00zzast_walkz00,
					BGl_string3743z00zzast_walkz00, BgL_arg2172z00_8723);
			}
		}

	}



/* &<@anonymous:2174> */
	obj_t BGl_z62zc3z04anonymousza32174ze3ze5zzast_walkz00(obj_t BgL_envz00_7118)
	{
		{	/* Ast/walk.scm 118 */
			{	/* Ast/walk.scm 118 */
				BgL_nodez00_bglt BgL_nz00_7119;

				BgL_nz00_7119 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_7118, (int) (((long) 0))));
				{	/* Ast/walk.scm 118 */
					obj_t BgL_portz00_8725;

					{	/* Ast/walk.scm 118 */
						obj_t BgL_tmpz00_10190;

						BgL_tmpz00_10190 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_portz00_8725 = BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_10190);
					}
					{	/* Ast/walk.scm 118 */

						return
							BGl_writezd2circlezd2zz__pp_circlez00(
							((obj_t) BgL_nz00_7119), BgL_portz00_8725);
					}
				}
			}
		}

	}



/* walk0 */
	BGL_EXPORTED_DEF obj_t BGl_walk0z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_3,
		obj_t BgL_pz00_4)
	{
		{	/* Ast/walk.scm 116 */
			{	/* Ast/walk.scm 116 */
				obj_t BgL_method1629z00_2477;

				{	/* Ast/walk.scm 116 */
					obj_t BgL_res3641z00_5998;

					{	/* Ast/walk.scm 116 */
						long BgL_objzd2classzd2numz00_5969;

						BgL_objzd2classzd2numz00_5969 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_3));
						{	/* Ast/walk.scm 116 */
							obj_t BgL_arg1791z00_5970;

							BgL_arg1791z00_5970 =
								PROCEDURE_REF(BGl_walk0zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 116 */
								int BgL_offsetz00_5973;

								BgL_offsetz00_5973 = (int) (BgL_objzd2classzd2numz00_5969);
								{	/* Ast/walk.scm 116 */
									long BgL_offsetz00_5974;

									BgL_offsetz00_5974 =
										((long) (BgL_offsetz00_5973) - OBJECT_TYPE);
									{	/* Ast/walk.scm 116 */
										long BgL_modz00_5975;

										BgL_modz00_5975 =
											(BgL_offsetz00_5974 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 116 */
											long BgL_restz00_5977;

											BgL_restz00_5977 =
												(BgL_offsetz00_5974 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 116 */

												{	/* Ast/walk.scm 116 */
													obj_t BgL_bucketz00_5979;

													BgL_bucketz00_5979 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_5970), BgL_modz00_5975);
													BgL_res3641z00_5998 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_5979), BgL_restz00_5977);
					}}}}}}}}
					BgL_method1629z00_2477 = BgL_res3641z00_5998;
				}
				return
					PROCEDURE_ENTRY(BgL_method1629z00_2477) (BgL_method1629z00_2477,
					((obj_t) BgL_nz00_3), BgL_pz00_4, BEOA);
			}
		}

	}



/* &walk0 */
	obj_t BGl_z62walk0z62zzast_walkz00(obj_t BgL_envz00_7120, obj_t BgL_nz00_7121,
		obj_t BgL_pz00_7122)
	{
		{	/* Ast/walk.scm 116 */
			return
				BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7121), BgL_pz00_7122);
		}

	}



/* walk1 */
	BGL_EXPORTED_DEF obj_t BGl_walk1z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_5,
		obj_t BgL_pz00_6, obj_t BgL_arg0z00_7)
	{
		{	/* Ast/walk.scm 119 */
			{	/* Ast/walk.scm 119 */
				obj_t BgL_method1631z00_2478;

				{	/* Ast/walk.scm 119 */
					obj_t BgL_res3646z00_6029;

					{	/* Ast/walk.scm 119 */
						long BgL_objzd2classzd2numz00_6000;

						BgL_objzd2classzd2numz00_6000 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_5));
						{	/* Ast/walk.scm 119 */
							obj_t BgL_arg1791z00_6001;

							BgL_arg1791z00_6001 =
								PROCEDURE_REF(BGl_walk1zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 119 */
								int BgL_offsetz00_6004;

								BgL_offsetz00_6004 = (int) (BgL_objzd2classzd2numz00_6000);
								{	/* Ast/walk.scm 119 */
									long BgL_offsetz00_6005;

									BgL_offsetz00_6005 =
										((long) (BgL_offsetz00_6004) - OBJECT_TYPE);
									{	/* Ast/walk.scm 119 */
										long BgL_modz00_6006;

										BgL_modz00_6006 =
											(BgL_offsetz00_6005 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 119 */
											long BgL_restz00_6008;

											BgL_restz00_6008 =
												(BgL_offsetz00_6005 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 119 */

												{	/* Ast/walk.scm 119 */
													obj_t BgL_bucketz00_6010;

													BgL_bucketz00_6010 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6001), BgL_modz00_6006);
													BgL_res3646z00_6029 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6010), BgL_restz00_6008);
					}}}}}}}}
					BgL_method1631z00_2478 = BgL_res3646z00_6029;
				}
				return
					PROCEDURE_ENTRY(BgL_method1631z00_2478) (BgL_method1631z00_2478,
					((obj_t) BgL_nz00_5), BgL_pz00_6, BgL_arg0z00_7, BEOA);
			}
		}

	}



/* &walk1 */
	obj_t BGl_z62walk1z62zzast_walkz00(obj_t BgL_envz00_7123, obj_t BgL_nz00_7124,
		obj_t BgL_pz00_7125, obj_t BgL_arg0z00_7126)
	{
		{	/* Ast/walk.scm 119 */
			return
				BGl_walk1z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7124), BgL_pz00_7125, BgL_arg0z00_7126);
		}

	}



/* walk2 */
	BGL_EXPORTED_DEF obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_8,
		obj_t BgL_pz00_9, obj_t BgL_arg0z00_10, obj_t BgL_arg1z00_11)
	{
		{	/* Ast/walk.scm 122 */
			{	/* Ast/walk.scm 122 */
				obj_t BgL_method1633z00_2479;

				{	/* Ast/walk.scm 122 */
					obj_t BgL_res3651z00_6060;

					{	/* Ast/walk.scm 122 */
						long BgL_objzd2classzd2numz00_6031;

						BgL_objzd2classzd2numz00_6031 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_8));
						{	/* Ast/walk.scm 122 */
							obj_t BgL_arg1791z00_6032;

							BgL_arg1791z00_6032 =
								PROCEDURE_REF(BGl_walk2zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 122 */
								int BgL_offsetz00_6035;

								BgL_offsetz00_6035 = (int) (BgL_objzd2classzd2numz00_6031);
								{	/* Ast/walk.scm 122 */
									long BgL_offsetz00_6036;

									BgL_offsetz00_6036 =
										((long) (BgL_offsetz00_6035) - OBJECT_TYPE);
									{	/* Ast/walk.scm 122 */
										long BgL_modz00_6037;

										BgL_modz00_6037 =
											(BgL_offsetz00_6036 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 122 */
											long BgL_restz00_6039;

											BgL_restz00_6039 =
												(BgL_offsetz00_6036 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 122 */

												{	/* Ast/walk.scm 122 */
													obj_t BgL_bucketz00_6041;

													BgL_bucketz00_6041 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6032), BgL_modz00_6037);
													BgL_res3651z00_6060 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6041), BgL_restz00_6039);
					}}}}}}}}
					BgL_method1633z00_2479 = BgL_res3651z00_6060;
				}
				return
					PROCEDURE_ENTRY(BgL_method1633z00_2479) (BgL_method1633z00_2479,
					((obj_t) BgL_nz00_8), BgL_pz00_9, BgL_arg0z00_10, BgL_arg1z00_11,
					BEOA);
			}
		}

	}



/* &walk2 */
	obj_t BGl_z62walk2z62zzast_walkz00(obj_t BgL_envz00_7127, obj_t BgL_nz00_7128,
		obj_t BgL_pz00_7129, obj_t BgL_arg0z00_7130, obj_t BgL_arg1z00_7131)
	{
		{	/* Ast/walk.scm 122 */
			return
				BGl_walk2z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7128), BgL_pz00_7129, BgL_arg0z00_7130,
				BgL_arg1z00_7131);
		}

	}



/* walk3 */
	BGL_EXPORTED_DEF obj_t BGl_walk3z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_12,
		obj_t BgL_pz00_13, obj_t BgL_arg0z00_14, obj_t BgL_arg1z00_15,
		obj_t BgL_arg2z00_16)
	{
		{	/* Ast/walk.scm 125 */
			{	/* Ast/walk.scm 125 */
				obj_t BgL_method1635z00_2480;

				{	/* Ast/walk.scm 125 */
					obj_t BgL_res3656z00_6091;

					{	/* Ast/walk.scm 125 */
						long BgL_objzd2classzd2numz00_6062;

						BgL_objzd2classzd2numz00_6062 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_12));
						{	/* Ast/walk.scm 125 */
							obj_t BgL_arg1791z00_6063;

							BgL_arg1791z00_6063 =
								PROCEDURE_REF(BGl_walk3zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 125 */
								int BgL_offsetz00_6066;

								BgL_offsetz00_6066 = (int) (BgL_objzd2classzd2numz00_6062);
								{	/* Ast/walk.scm 125 */
									long BgL_offsetz00_6067;

									BgL_offsetz00_6067 =
										((long) (BgL_offsetz00_6066) - OBJECT_TYPE);
									{	/* Ast/walk.scm 125 */
										long BgL_modz00_6068;

										BgL_modz00_6068 =
											(BgL_offsetz00_6067 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 125 */
											long BgL_restz00_6070;

											BgL_restz00_6070 =
												(BgL_offsetz00_6067 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 125 */

												{	/* Ast/walk.scm 125 */
													obj_t BgL_bucketz00_6072;

													BgL_bucketz00_6072 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6063), BgL_modz00_6068);
													BgL_res3656z00_6091 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6072), BgL_restz00_6070);
					}}}}}}}}
					BgL_method1635z00_2480 = BgL_res3656z00_6091;
				}
				return
					PROCEDURE_ENTRY(BgL_method1635z00_2480) (BgL_method1635z00_2480,
					((obj_t) BgL_nz00_12), BgL_pz00_13, BgL_arg0z00_14, BgL_arg1z00_15,
					BgL_arg2z00_16, BEOA);
			}
		}

	}



/* &walk3 */
	obj_t BGl_z62walk3z62zzast_walkz00(obj_t BgL_envz00_7132, obj_t BgL_nz00_7133,
		obj_t BgL_pz00_7134, obj_t BgL_arg0z00_7135, obj_t BgL_arg1z00_7136,
		obj_t BgL_arg2z00_7137)
	{
		{	/* Ast/walk.scm 125 */
			return
				BGl_walk3z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7133), BgL_pz00_7134, BgL_arg0z00_7135,
				BgL_arg1z00_7136, BgL_arg2z00_7137);
		}

	}



/* walk4 */
	BGL_EXPORTED_DEF obj_t BGl_walk4z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_17,
		obj_t BgL_pz00_18, obj_t BgL_arg0z00_19, obj_t BgL_arg1z00_20,
		obj_t BgL_arg2z00_21, obj_t BgL_arg3z00_22)
	{
		{	/* Ast/walk.scm 128 */
			{	/* Ast/walk.scm 128 */
				obj_t BgL_method1637z00_2481;

				{	/* Ast/walk.scm 128 */
					obj_t BgL_res3661z00_6122;

					{	/* Ast/walk.scm 128 */
						long BgL_objzd2classzd2numz00_6093;

						BgL_objzd2classzd2numz00_6093 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_17));
						{	/* Ast/walk.scm 128 */
							obj_t BgL_arg1791z00_6094;

							BgL_arg1791z00_6094 =
								PROCEDURE_REF(BGl_walk4zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 128 */
								int BgL_offsetz00_6097;

								BgL_offsetz00_6097 = (int) (BgL_objzd2classzd2numz00_6093);
								{	/* Ast/walk.scm 128 */
									long BgL_offsetz00_6098;

									BgL_offsetz00_6098 =
										((long) (BgL_offsetz00_6097) - OBJECT_TYPE);
									{	/* Ast/walk.scm 128 */
										long BgL_modz00_6099;

										BgL_modz00_6099 =
											(BgL_offsetz00_6098 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 128 */
											long BgL_restz00_6101;

											BgL_restz00_6101 =
												(BgL_offsetz00_6098 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 128 */

												{	/* Ast/walk.scm 128 */
													obj_t BgL_bucketz00_6103;

													BgL_bucketz00_6103 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6094), BgL_modz00_6099);
													BgL_res3661z00_6122 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6103), BgL_restz00_6101);
					}}}}}}}}
					BgL_method1637z00_2481 = BgL_res3661z00_6122;
				}
				return
					PROCEDURE_ENTRY(BgL_method1637z00_2481) (BgL_method1637z00_2481,
					((obj_t) BgL_nz00_17), BgL_pz00_18, BgL_arg0z00_19, BgL_arg1z00_20,
					BgL_arg2z00_21, BgL_arg3z00_22, BEOA);
			}
		}

	}



/* &walk4 */
	obj_t BGl_z62walk4z62zzast_walkz00(obj_t BgL_envz00_7138, obj_t BgL_nz00_7139,
		obj_t BgL_pz00_7140, obj_t BgL_arg0z00_7141, obj_t BgL_arg1z00_7142,
		obj_t BgL_arg2z00_7143, obj_t BgL_arg3z00_7144)
	{
		{	/* Ast/walk.scm 128 */
			return
				BGl_walk4z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7139), BgL_pz00_7140, BgL_arg0z00_7141,
				BgL_arg1z00_7142, BgL_arg2z00_7143, BgL_arg3z00_7144);
		}

	}



/* walk0* */
	BGL_EXPORTED_DEF obj_t BGl_walk0za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_23, obj_t BgL_pz00_24)
	{
		{	/* Ast/walk.scm 132 */
			{	/* Ast/walk.scm 132 */
				obj_t BgL_method1639z00_2482;

				{	/* Ast/walk.scm 132 */
					obj_t BgL_res3666z00_6153;

					{	/* Ast/walk.scm 132 */
						long BgL_objzd2classzd2numz00_6124;

						BgL_objzd2classzd2numz00_6124 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_23));
						{	/* Ast/walk.scm 132 */
							obj_t BgL_arg1791z00_6125;

							BgL_arg1791z00_6125 =
								PROCEDURE_REF(BGl_walk0za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 132 */
								int BgL_offsetz00_6128;

								BgL_offsetz00_6128 = (int) (BgL_objzd2classzd2numz00_6124);
								{	/* Ast/walk.scm 132 */
									long BgL_offsetz00_6129;

									BgL_offsetz00_6129 =
										((long) (BgL_offsetz00_6128) - OBJECT_TYPE);
									{	/* Ast/walk.scm 132 */
										long BgL_modz00_6130;

										BgL_modz00_6130 =
											(BgL_offsetz00_6129 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 132 */
											long BgL_restz00_6132;

											BgL_restz00_6132 =
												(BgL_offsetz00_6129 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 132 */

												{	/* Ast/walk.scm 132 */
													obj_t BgL_bucketz00_6134;

													BgL_bucketz00_6134 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6125), BgL_modz00_6130);
													BgL_res3666z00_6153 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6134), BgL_restz00_6132);
					}}}}}}}}
					BgL_method1639z00_2482 = BgL_res3666z00_6153;
				}
				return
					PROCEDURE_ENTRY(BgL_method1639z00_2482) (BgL_method1639z00_2482,
					((obj_t) BgL_nz00_23), BgL_pz00_24, BEOA);
			}
		}

	}



/* &walk0* */
	obj_t BGl_z62walk0za2zc0zzast_walkz00(obj_t BgL_envz00_7145,
		obj_t BgL_nz00_7146, obj_t BgL_pz00_7147)
	{
		{	/* Ast/walk.scm 132 */
			return
				BGl_walk0za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7146), BgL_pz00_7147);
		}

	}



/* walk1* */
	BGL_EXPORTED_DEF obj_t BGl_walk1za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_25, obj_t BgL_pz00_26, obj_t BgL_arg0z00_27)
	{
		{	/* Ast/walk.scm 135 */
			{	/* Ast/walk.scm 135 */
				obj_t BgL_method1641z00_2483;

				{	/* Ast/walk.scm 135 */
					obj_t BgL_res3671z00_6184;

					{	/* Ast/walk.scm 135 */
						long BgL_objzd2classzd2numz00_6155;

						BgL_objzd2classzd2numz00_6155 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_25));
						{	/* Ast/walk.scm 135 */
							obj_t BgL_arg1791z00_6156;

							BgL_arg1791z00_6156 =
								PROCEDURE_REF(BGl_walk1za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 135 */
								int BgL_offsetz00_6159;

								BgL_offsetz00_6159 = (int) (BgL_objzd2classzd2numz00_6155);
								{	/* Ast/walk.scm 135 */
									long BgL_offsetz00_6160;

									BgL_offsetz00_6160 =
										((long) (BgL_offsetz00_6159) - OBJECT_TYPE);
									{	/* Ast/walk.scm 135 */
										long BgL_modz00_6161;

										BgL_modz00_6161 =
											(BgL_offsetz00_6160 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 135 */
											long BgL_restz00_6163;

											BgL_restz00_6163 =
												(BgL_offsetz00_6160 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 135 */

												{	/* Ast/walk.scm 135 */
													obj_t BgL_bucketz00_6165;

													BgL_bucketz00_6165 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6156), BgL_modz00_6161);
													BgL_res3671z00_6184 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6165), BgL_restz00_6163);
					}}}}}}}}
					BgL_method1641z00_2483 = BgL_res3671z00_6184;
				}
				return
					PROCEDURE_ENTRY(BgL_method1641z00_2483) (BgL_method1641z00_2483,
					((obj_t) BgL_nz00_25), BgL_pz00_26, BgL_arg0z00_27, BEOA);
			}
		}

	}



/* &walk1* */
	obj_t BGl_z62walk1za2zc0zzast_walkz00(obj_t BgL_envz00_7148,
		obj_t BgL_nz00_7149, obj_t BgL_pz00_7150, obj_t BgL_arg0z00_7151)
	{
		{	/* Ast/walk.scm 135 */
			return
				BGl_walk1za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7149), BgL_pz00_7150, BgL_arg0z00_7151);
		}

	}



/* walk2* */
	BGL_EXPORTED_DEF obj_t BGl_walk2za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_28, obj_t BgL_pz00_29, obj_t BgL_arg0z00_30, obj_t BgL_arg1z00_31)
	{
		{	/* Ast/walk.scm 138 */
			{	/* Ast/walk.scm 138 */
				obj_t BgL_method1643z00_2484;

				{	/* Ast/walk.scm 138 */
					obj_t BgL_res3676z00_6215;

					{	/* Ast/walk.scm 138 */
						long BgL_objzd2classzd2numz00_6186;

						BgL_objzd2classzd2numz00_6186 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_28));
						{	/* Ast/walk.scm 138 */
							obj_t BgL_arg1791z00_6187;

							BgL_arg1791z00_6187 =
								PROCEDURE_REF(BGl_walk2za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 138 */
								int BgL_offsetz00_6190;

								BgL_offsetz00_6190 = (int) (BgL_objzd2classzd2numz00_6186);
								{	/* Ast/walk.scm 138 */
									long BgL_offsetz00_6191;

									BgL_offsetz00_6191 =
										((long) (BgL_offsetz00_6190) - OBJECT_TYPE);
									{	/* Ast/walk.scm 138 */
										long BgL_modz00_6192;

										BgL_modz00_6192 =
											(BgL_offsetz00_6191 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 138 */
											long BgL_restz00_6194;

											BgL_restz00_6194 =
												(BgL_offsetz00_6191 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 138 */

												{	/* Ast/walk.scm 138 */
													obj_t BgL_bucketz00_6196;

													BgL_bucketz00_6196 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6187), BgL_modz00_6192);
													BgL_res3676z00_6215 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6196), BgL_restz00_6194);
					}}}}}}}}
					BgL_method1643z00_2484 = BgL_res3676z00_6215;
				}
				return
					PROCEDURE_ENTRY(BgL_method1643z00_2484) (BgL_method1643z00_2484,
					((obj_t) BgL_nz00_28), BgL_pz00_29, BgL_arg0z00_30, BgL_arg1z00_31,
					BEOA);
			}
		}

	}



/* &walk2* */
	obj_t BGl_z62walk2za2zc0zzast_walkz00(obj_t BgL_envz00_7152,
		obj_t BgL_nz00_7153, obj_t BgL_pz00_7154, obj_t BgL_arg0z00_7155,
		obj_t BgL_arg1z00_7156)
	{
		{	/* Ast/walk.scm 138 */
			return
				BGl_walk2za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7153), BgL_pz00_7154, BgL_arg0z00_7155,
				BgL_arg1z00_7156);
		}

	}



/* walk3* */
	BGL_EXPORTED_DEF obj_t BGl_walk3za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_32, obj_t BgL_pz00_33, obj_t BgL_arg0z00_34, obj_t BgL_arg1z00_35,
		obj_t BgL_arg2z00_36)
	{
		{	/* Ast/walk.scm 141 */
			{	/* Ast/walk.scm 141 */
				obj_t BgL_method1645z00_2485;

				{	/* Ast/walk.scm 141 */
					obj_t BgL_res3681z00_6246;

					{	/* Ast/walk.scm 141 */
						long BgL_objzd2classzd2numz00_6217;

						BgL_objzd2classzd2numz00_6217 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_32));
						{	/* Ast/walk.scm 141 */
							obj_t BgL_arg1791z00_6218;

							BgL_arg1791z00_6218 =
								PROCEDURE_REF(BGl_walk3za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 141 */
								int BgL_offsetz00_6221;

								BgL_offsetz00_6221 = (int) (BgL_objzd2classzd2numz00_6217);
								{	/* Ast/walk.scm 141 */
									long BgL_offsetz00_6222;

									BgL_offsetz00_6222 =
										((long) (BgL_offsetz00_6221) - OBJECT_TYPE);
									{	/* Ast/walk.scm 141 */
										long BgL_modz00_6223;

										BgL_modz00_6223 =
											(BgL_offsetz00_6222 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 141 */
											long BgL_restz00_6225;

											BgL_restz00_6225 =
												(BgL_offsetz00_6222 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 141 */

												{	/* Ast/walk.scm 141 */
													obj_t BgL_bucketz00_6227;

													BgL_bucketz00_6227 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6218), BgL_modz00_6223);
													BgL_res3681z00_6246 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6227), BgL_restz00_6225);
					}}}}}}}}
					BgL_method1645z00_2485 = BgL_res3681z00_6246;
				}
				return
					PROCEDURE_ENTRY(BgL_method1645z00_2485) (BgL_method1645z00_2485,
					((obj_t) BgL_nz00_32), BgL_pz00_33, BgL_arg0z00_34, BgL_arg1z00_35,
					BgL_arg2z00_36, BEOA);
			}
		}

	}



/* &walk3* */
	obj_t BGl_z62walk3za2zc0zzast_walkz00(obj_t BgL_envz00_7157,
		obj_t BgL_nz00_7158, obj_t BgL_pz00_7159, obj_t BgL_arg0z00_7160,
		obj_t BgL_arg1z00_7161, obj_t BgL_arg2z00_7162)
	{
		{	/* Ast/walk.scm 141 */
			return
				BGl_walk3za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7158), BgL_pz00_7159, BgL_arg0z00_7160,
				BgL_arg1z00_7161, BgL_arg2z00_7162);
		}

	}



/* walk4* */
	BGL_EXPORTED_DEF obj_t BGl_walk4za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_37, obj_t BgL_pz00_38, obj_t BgL_arg0z00_39, obj_t BgL_arg1z00_40,
		obj_t BgL_arg2z00_41, obj_t BgL_arg3z00_42)
	{
		{	/* Ast/walk.scm 144 */
			{	/* Ast/walk.scm 144 */
				obj_t BgL_method1648z00_2486;

				{	/* Ast/walk.scm 144 */
					obj_t BgL_res3686z00_6277;

					{	/* Ast/walk.scm 144 */
						long BgL_objzd2classzd2numz00_6248;

						BgL_objzd2classzd2numz00_6248 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_37));
						{	/* Ast/walk.scm 144 */
							obj_t BgL_arg1791z00_6249;

							BgL_arg1791z00_6249 =
								PROCEDURE_REF(BGl_walk4za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 144 */
								int BgL_offsetz00_6252;

								BgL_offsetz00_6252 = (int) (BgL_objzd2classzd2numz00_6248);
								{	/* Ast/walk.scm 144 */
									long BgL_offsetz00_6253;

									BgL_offsetz00_6253 =
										((long) (BgL_offsetz00_6252) - OBJECT_TYPE);
									{	/* Ast/walk.scm 144 */
										long BgL_modz00_6254;

										BgL_modz00_6254 =
											(BgL_offsetz00_6253 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 144 */
											long BgL_restz00_6256;

											BgL_restz00_6256 =
												(BgL_offsetz00_6253 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 144 */

												{	/* Ast/walk.scm 144 */
													obj_t BgL_bucketz00_6258;

													BgL_bucketz00_6258 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6249), BgL_modz00_6254);
													BgL_res3686z00_6277 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6258), BgL_restz00_6256);
					}}}}}}}}
					BgL_method1648z00_2486 = BgL_res3686z00_6277;
				}
				return
					PROCEDURE_ENTRY(BgL_method1648z00_2486) (BgL_method1648z00_2486,
					((obj_t) BgL_nz00_37), BgL_pz00_38, BgL_arg0z00_39, BgL_arg1z00_40,
					BgL_arg2z00_41, BgL_arg3z00_42, BEOA);
			}
		}

	}



/* &walk4* */
	obj_t BGl_z62walk4za2zc0zzast_walkz00(obj_t BgL_envz00_7163,
		obj_t BgL_nz00_7164, obj_t BgL_pz00_7165, obj_t BgL_arg0z00_7166,
		obj_t BgL_arg1z00_7167, obj_t BgL_arg2z00_7168, obj_t BgL_arg3z00_7169)
	{
		{	/* Ast/walk.scm 144 */
			return
				BGl_walk4za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7164), BgL_pz00_7165, BgL_arg0z00_7166,
				BgL_arg1z00_7167, BgL_arg2z00_7168, BgL_arg3z00_7169);
		}

	}



/* walk0! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_43,
		obj_t BgL_pz00_44)
	{
		{	/* Ast/walk.scm 148 */
			{	/* Ast/walk.scm 148 */
				obj_t BgL_method1650z00_2487;

				{	/* Ast/walk.scm 148 */
					obj_t BgL_res3691z00_6308;

					{	/* Ast/walk.scm 148 */
						long BgL_objzd2classzd2numz00_6279;

						BgL_objzd2classzd2numz00_6279 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_43));
						{	/* Ast/walk.scm 148 */
							obj_t BgL_arg1791z00_6280;

							BgL_arg1791z00_6280 =
								PROCEDURE_REF(BGl_walk0z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 148 */
								int BgL_offsetz00_6283;

								BgL_offsetz00_6283 = (int) (BgL_objzd2classzd2numz00_6279);
								{	/* Ast/walk.scm 148 */
									long BgL_offsetz00_6284;

									BgL_offsetz00_6284 =
										((long) (BgL_offsetz00_6283) - OBJECT_TYPE);
									{	/* Ast/walk.scm 148 */
										long BgL_modz00_6285;

										BgL_modz00_6285 =
											(BgL_offsetz00_6284 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 148 */
											long BgL_restz00_6287;

											BgL_restz00_6287 =
												(BgL_offsetz00_6284 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 148 */

												{	/* Ast/walk.scm 148 */
													obj_t BgL_bucketz00_6289;

													BgL_bucketz00_6289 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6280), BgL_modz00_6285);
													BgL_res3691z00_6308 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6289), BgL_restz00_6287);
					}}}}}}}}
					BgL_method1650z00_2487 = BgL_res3691z00_6308;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1650z00_2487) (BgL_method1650z00_2487,
						((obj_t) BgL_nz00_43), BgL_pz00_44, BEOA));
			}
		}

	}



/* &walk0! */
	BgL_nodez00_bglt BGl_z62walk0z12z70zzast_walkz00(obj_t BgL_envz00_7170,
		obj_t BgL_nz00_7171, obj_t BgL_pz00_7172)
	{
		{	/* Ast/walk.scm 148 */
			return
				BGl_walk0z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7171), BgL_pz00_7172);
		}

	}



/* walk1! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk1z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_45,
		obj_t BgL_pz00_46, obj_t BgL_arg0z00_47)
	{
		{	/* Ast/walk.scm 151 */
			{	/* Ast/walk.scm 151 */
				obj_t BgL_method1652z00_2488;

				{	/* Ast/walk.scm 151 */
					obj_t BgL_res3696z00_6339;

					{	/* Ast/walk.scm 151 */
						long BgL_objzd2classzd2numz00_6310;

						BgL_objzd2classzd2numz00_6310 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_45));
						{	/* Ast/walk.scm 151 */
							obj_t BgL_arg1791z00_6311;

							BgL_arg1791z00_6311 =
								PROCEDURE_REF(BGl_walk1z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 151 */
								int BgL_offsetz00_6314;

								BgL_offsetz00_6314 = (int) (BgL_objzd2classzd2numz00_6310);
								{	/* Ast/walk.scm 151 */
									long BgL_offsetz00_6315;

									BgL_offsetz00_6315 =
										((long) (BgL_offsetz00_6314) - OBJECT_TYPE);
									{	/* Ast/walk.scm 151 */
										long BgL_modz00_6316;

										BgL_modz00_6316 =
											(BgL_offsetz00_6315 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 151 */
											long BgL_restz00_6318;

											BgL_restz00_6318 =
												(BgL_offsetz00_6315 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 151 */

												{	/* Ast/walk.scm 151 */
													obj_t BgL_bucketz00_6320;

													BgL_bucketz00_6320 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6311), BgL_modz00_6316);
													BgL_res3696z00_6339 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6320), BgL_restz00_6318);
					}}}}}}}}
					BgL_method1652z00_2488 = BgL_res3696z00_6339;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1652z00_2488) (BgL_method1652z00_2488,
						((obj_t) BgL_nz00_45), BgL_pz00_46, BgL_arg0z00_47, BEOA));
			}
		}

	}



/* &walk1! */
	BgL_nodez00_bglt BGl_z62walk1z12z70zzast_walkz00(obj_t BgL_envz00_7173,
		obj_t BgL_nz00_7174, obj_t BgL_pz00_7175, obj_t BgL_arg0z00_7176)
	{
		{	/* Ast/walk.scm 151 */
			return
				BGl_walk1z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7174), BgL_pz00_7175, BgL_arg0z00_7176);
		}

	}



/* walk2! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk2z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_48,
		obj_t BgL_pz00_49, obj_t BgL_arg0z00_50, obj_t BgL_arg1z00_51)
	{
		{	/* Ast/walk.scm 154 */
			{	/* Ast/walk.scm 154 */
				obj_t BgL_method1654z00_2489;

				{	/* Ast/walk.scm 154 */
					obj_t BgL_res3701z00_6370;

					{	/* Ast/walk.scm 154 */
						long BgL_objzd2classzd2numz00_6341;

						BgL_objzd2classzd2numz00_6341 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_48));
						{	/* Ast/walk.scm 154 */
							obj_t BgL_arg1791z00_6342;

							BgL_arg1791z00_6342 =
								PROCEDURE_REF(BGl_walk2z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 154 */
								int BgL_offsetz00_6345;

								BgL_offsetz00_6345 = (int) (BgL_objzd2classzd2numz00_6341);
								{	/* Ast/walk.scm 154 */
									long BgL_offsetz00_6346;

									BgL_offsetz00_6346 =
										((long) (BgL_offsetz00_6345) - OBJECT_TYPE);
									{	/* Ast/walk.scm 154 */
										long BgL_modz00_6347;

										BgL_modz00_6347 =
											(BgL_offsetz00_6346 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 154 */
											long BgL_restz00_6349;

											BgL_restz00_6349 =
												(BgL_offsetz00_6346 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 154 */

												{	/* Ast/walk.scm 154 */
													obj_t BgL_bucketz00_6351;

													BgL_bucketz00_6351 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6342), BgL_modz00_6347);
													BgL_res3701z00_6370 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6351), BgL_restz00_6349);
					}}}}}}}}
					BgL_method1654z00_2489 = BgL_res3701z00_6370;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1654z00_2489) (BgL_method1654z00_2489,
						((obj_t) BgL_nz00_48), BgL_pz00_49, BgL_arg0z00_50, BgL_arg1z00_51,
						BEOA));
			}
		}

	}



/* &walk2! */
	BgL_nodez00_bglt BGl_z62walk2z12z70zzast_walkz00(obj_t BgL_envz00_7177,
		obj_t BgL_nz00_7178, obj_t BgL_pz00_7179, obj_t BgL_arg0z00_7180,
		obj_t BgL_arg1z00_7181)
	{
		{	/* Ast/walk.scm 154 */
			return
				BGl_walk2z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7178), BgL_pz00_7179, BgL_arg0z00_7180,
				BgL_arg1z00_7181);
		}

	}



/* walk3! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk3z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_52,
		obj_t BgL_pz00_53, obj_t BgL_arg0z00_54, obj_t BgL_arg1z00_55,
		obj_t BgL_arg2z00_56)
	{
		{	/* Ast/walk.scm 157 */
			{	/* Ast/walk.scm 157 */
				obj_t BgL_method1656z00_2490;

				{	/* Ast/walk.scm 157 */
					obj_t BgL_res3706z00_6401;

					{	/* Ast/walk.scm 157 */
						long BgL_objzd2classzd2numz00_6372;

						BgL_objzd2classzd2numz00_6372 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_52));
						{	/* Ast/walk.scm 157 */
							obj_t BgL_arg1791z00_6373;

							BgL_arg1791z00_6373 =
								PROCEDURE_REF(BGl_walk3z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 157 */
								int BgL_offsetz00_6376;

								BgL_offsetz00_6376 = (int) (BgL_objzd2classzd2numz00_6372);
								{	/* Ast/walk.scm 157 */
									long BgL_offsetz00_6377;

									BgL_offsetz00_6377 =
										((long) (BgL_offsetz00_6376) - OBJECT_TYPE);
									{	/* Ast/walk.scm 157 */
										long BgL_modz00_6378;

										BgL_modz00_6378 =
											(BgL_offsetz00_6377 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 157 */
											long BgL_restz00_6380;

											BgL_restz00_6380 =
												(BgL_offsetz00_6377 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 157 */

												{	/* Ast/walk.scm 157 */
													obj_t BgL_bucketz00_6382;

													BgL_bucketz00_6382 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6373), BgL_modz00_6378);
													BgL_res3706z00_6401 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6382), BgL_restz00_6380);
					}}}}}}}}
					BgL_method1656z00_2490 = BgL_res3706z00_6401;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1656z00_2490) (BgL_method1656z00_2490,
						((obj_t) BgL_nz00_52), BgL_pz00_53, BgL_arg0z00_54, BgL_arg1z00_55,
						BgL_arg2z00_56, BEOA));
			}
		}

	}



/* &walk3! */
	BgL_nodez00_bglt BGl_z62walk3z12z70zzast_walkz00(obj_t BgL_envz00_7182,
		obj_t BgL_nz00_7183, obj_t BgL_pz00_7184, obj_t BgL_arg0z00_7185,
		obj_t BgL_arg1z00_7186, obj_t BgL_arg2z00_7187)
	{
		{	/* Ast/walk.scm 157 */
			return
				BGl_walk3z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7183), BgL_pz00_7184, BgL_arg0z00_7185,
				BgL_arg1z00_7186, BgL_arg2z00_7187);
		}

	}



/* walk4! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk4z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_57,
		obj_t BgL_pz00_58, obj_t BgL_arg0z00_59, obj_t BgL_arg1z00_60,
		obj_t BgL_arg2z00_61, obj_t BgL_arg3z00_62)
	{
		{	/* Ast/walk.scm 160 */
			{	/* Ast/walk.scm 160 */
				obj_t BgL_method1658z00_2491;

				{	/* Ast/walk.scm 160 */
					obj_t BgL_res3711z00_6432;

					{	/* Ast/walk.scm 160 */
						long BgL_objzd2classzd2numz00_6403;

						BgL_objzd2classzd2numz00_6403 =
							BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_57));
						{	/* Ast/walk.scm 160 */
							obj_t BgL_arg1791z00_6404;

							BgL_arg1791z00_6404 =
								PROCEDURE_REF(BGl_walk4z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 160 */
								int BgL_offsetz00_6407;

								BgL_offsetz00_6407 = (int) (BgL_objzd2classzd2numz00_6403);
								{	/* Ast/walk.scm 160 */
									long BgL_offsetz00_6408;

									BgL_offsetz00_6408 =
										((long) (BgL_offsetz00_6407) - OBJECT_TYPE);
									{	/* Ast/walk.scm 160 */
										long BgL_modz00_6409;

										BgL_modz00_6409 =
											(BgL_offsetz00_6408 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Ast/walk.scm 160 */
											long BgL_restz00_6411;

											BgL_restz00_6411 =
												(BgL_offsetz00_6408 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Ast/walk.scm 160 */

												{	/* Ast/walk.scm 160 */
													obj_t BgL_bucketz00_6413;

													BgL_bucketz00_6413 =
														VECTOR_REF(
														((obj_t) BgL_arg1791z00_6404), BgL_modz00_6409);
													BgL_res3711z00_6432 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_6413), BgL_restz00_6411);
					}}}}}}}}
					BgL_method1658z00_2491 = BgL_res3711z00_6432;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1658z00_2491) (BgL_method1658z00_2491,
						((obj_t) BgL_nz00_57), BgL_pz00_58, BgL_arg0z00_59, BgL_arg1z00_60,
						BgL_arg2z00_61, BgL_arg3z00_62, BEOA));
			}
		}

	}



/* &walk4! */
	BgL_nodez00_bglt BGl_z62walk4z12z70zzast_walkz00(obj_t BgL_envz00_7188,
		obj_t BgL_nz00_7189, obj_t BgL_pz00_7190, obj_t BgL_arg0z00_7191,
		obj_t BgL_arg1z00_7192, obj_t BgL_arg2z00_7193, obj_t BgL_arg3z00_7194)
	{
		{	/* Ast/walk.scm 160 */
			return
				BGl_walk4z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_7189), BgL_pz00_7190, BgL_arg0z00_7191,
				BgL_arg1z00_7192, BgL_arg2z00_7193, BgL_arg3z00_7194);
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3757z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3758z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3759z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3760z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3761z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3762z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3763z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3764z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3765z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3766z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3767z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3768z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3769z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3770z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3771z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3772z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3773z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3774z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3775z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3776z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3777z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3778z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3779z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3780z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3781z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3782z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3783z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3784z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3785z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3786z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3787z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3788z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3789z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3790z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3791z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3792z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3793z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3794z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3795z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3796z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3797z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3798z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3799z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3800z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3801z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3802z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3803z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3804z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3805z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3806z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3807z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3808z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3809z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3810z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3811z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3812z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3813z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3814z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3815z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3816z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3817z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3818z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3819z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3820z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3821z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3822z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3823z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3824z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3825z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3826z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3827z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3828z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3829z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3830z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3831z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3832z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3833z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3834z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3835z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3836z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3837z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3838z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3839z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3840z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3841z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3842z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3843z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3844z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3845z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3846z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3847z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3848z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3849z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3850z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3851z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3852z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3853z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3854z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3855z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3856z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3857z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3858z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3859z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3860z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3861z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3862z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3863z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3864z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3865z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3866z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3867z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3868z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3869z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3870z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3871z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3872z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3873z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3874z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3875z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3876z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3877z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3878z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3879z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3880z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3881z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3882z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3883z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3884z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3885z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3886z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3887z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3888z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3889z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3890z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3891z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3892z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3893z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3894z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3895z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3896z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3897z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3898z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3899z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3900z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3901z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3902z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3903z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3904z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3905z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3906z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3907z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3908z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3909z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3910z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3911z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_retblockz00zzast_nodez00,
				BGl_proc3912z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3913z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3914z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3915z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3916z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3917z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3918z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3919z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3920z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3921z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3922z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3923z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_returnz00zzast_nodez00,
				BGl_proc3924z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3925z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3926z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3927z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3928z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3929z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3930z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3931z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3932z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3933z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3934z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3935z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3936z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3937z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3938z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3939z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3940z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3941z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3942z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3943z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3944z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3945z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3946z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3947z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3948z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3949z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3950z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3951z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3952z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3953z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3954z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3955z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3956z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3957z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3958z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3959z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3960z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3961z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3962z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3963z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3964z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3965z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3966z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3967z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3968z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3969z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3970z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3971z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3972z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3973z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3974z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3975z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3976z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3977z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3978z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3979z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3980z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3981z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3982z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3983z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_switchz00zzast_nodez00,
				BGl_proc3984z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3985z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3986z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3987z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3988z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3989z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3990z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3991z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3992z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3993z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3994z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3995z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3996z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3997z00zzast_walkz00, BGl_string3756z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3998z00zzast_walkz00, BGl_string3755z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3999z00zzast_walkz00, BGl_string3754z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4000z00zzast_walkz00, BGl_string3753z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4001z00zzast_walkz00, BGl_string3751z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4002z00zzast_walkz00, BGl_string3750z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4003z00zzast_walkz00, BGl_string3749z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4004z00zzast_walkz00, BGl_string3748z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4005z00zzast_walkz00, BGl_string3747z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4006z00zzast_walkz00, BGl_string3746z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4007z00zzast_walkz00, BGl_string3745z00zzast_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc4008z00zzast_walkz00, BGl_string3744z00zzast_walkz00);
		}

	}



/* &walk3!-let-var2166 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2var2166z70zzast_walkz00(obj_t
		BgL_envz00_7447, obj_t BgL_nz00_7448, obj_t BgL_pz00_7449,
		obj_t BgL_arg0z00_7450, obj_t BgL_arg1z00_7451, obj_t BgL_arg2z00_7452)
	{
		{	/* Ast/walk.scm 320 */
			{
				obj_t BgL_fieldsz00_8728;

				BgL_fieldsz00_8728 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7448)))->BgL_bindingsz00);
			BgL_loopz00_8727:
				if (NULLP(BgL_fieldsz00_8728))
					{	/* Ast/walk.scm 320 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 320 */
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3559z00_8729;
							obj_t BgL_arg3561z00_8730;

							BgL_arg3559z00_8729 = CAR(((obj_t) BgL_fieldsz00_8728));
							{	/* Ast/walk.scm 320 */
								obj_t BgL_arg3562z00_8731;

								{	/* Ast/walk.scm 320 */
									obj_t BgL_pairz00_8732;

									BgL_pairz00_8732 = CAR(((obj_t) BgL_fieldsz00_8728));
									BgL_arg3562z00_8731 = CDR(BgL_pairz00_8732);
								}
								BgL_arg3561z00_8730 =
									PROCEDURE_ENTRY(BgL_pz00_7449) (BgL_pz00_7449,
									BgL_arg3562z00_8731, BgL_arg0z00_7450, BgL_arg1z00_7451,
									BgL_arg2z00_7452, BEOA);
							}
							{	/* Ast/walk.scm 320 */
								obj_t BgL_tmpz00_10991;

								BgL_tmpz00_10991 = ((obj_t) BgL_arg3559z00_8729);
								SET_CDR(BgL_tmpz00_10991, BgL_arg3561z00_8730);
							}
						}
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3565z00_8733;

							BgL_arg3565z00_8733 = CDR(((obj_t) BgL_fieldsz00_8728));
							{
								obj_t BgL_fieldsz00_10996;

								BgL_fieldsz00_10996 = BgL_arg3565z00_8733;
								BgL_fieldsz00_8728 = BgL_fieldsz00_10996;
								goto BgL_loopz00_8727;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_10999;

				{	/* Ast/walk.scm 320 */
					BgL_nodez00_bglt BgL_arg3566z00_8734;

					BgL_arg3566z00_8734 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7448)))->BgL_bodyz00);
					BgL_auxz00_10999 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7449) (BgL_pz00_7449,
							((obj_t) BgL_arg3566z00_8734), BgL_arg0z00_7450, BgL_arg1z00_7451,
							BgL_arg2z00_7452, BEOA));
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7448)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_10999), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nz00_7448));
		}

	}



/* &walk2!-let-var2164 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2var2164z70zzast_walkz00(obj_t
		BgL_envz00_7453, obj_t BgL_nz00_7454, obj_t BgL_pz00_7455,
		obj_t BgL_arg0z00_7456, obj_t BgL_arg1z00_7457)
	{
		{	/* Ast/walk.scm 320 */
			{
				obj_t BgL_fieldsz00_8737;

				BgL_fieldsz00_8737 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7454)))->BgL_bindingsz00);
			BgL_loopz00_8736:
				if (NULLP(BgL_fieldsz00_8737))
					{	/* Ast/walk.scm 320 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 320 */
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3548z00_8738;
							obj_t BgL_arg3549z00_8739;

							BgL_arg3548z00_8738 = CAR(((obj_t) BgL_fieldsz00_8737));
							{	/* Ast/walk.scm 320 */
								obj_t BgL_arg3550z00_8740;

								{	/* Ast/walk.scm 320 */
									obj_t BgL_pairz00_8741;

									BgL_pairz00_8741 = CAR(((obj_t) BgL_fieldsz00_8737));
									BgL_arg3550z00_8740 = CDR(BgL_pairz00_8741);
								}
								BgL_arg3549z00_8739 =
									PROCEDURE_ENTRY(BgL_pz00_7455) (BgL_pz00_7455,
									BgL_arg3550z00_8740, BgL_arg0z00_7456, BgL_arg1z00_7457,
									BEOA);
							}
							{	/* Ast/walk.scm 320 */
								obj_t BgL_tmpz00_11028;

								BgL_tmpz00_11028 = ((obj_t) BgL_arg3548z00_8738);
								SET_CDR(BgL_tmpz00_11028, BgL_arg3549z00_8739);
							}
						}
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3553z00_8742;

							BgL_arg3553z00_8742 = CDR(((obj_t) BgL_fieldsz00_8737));
							{
								obj_t BgL_fieldsz00_11033;

								BgL_fieldsz00_11033 = BgL_arg3553z00_8742;
								BgL_fieldsz00_8737 = BgL_fieldsz00_11033;
								goto BgL_loopz00_8736;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11036;

				{	/* Ast/walk.scm 320 */
					BgL_nodez00_bglt BgL_arg3554z00_8743;

					BgL_arg3554z00_8743 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7454)))->BgL_bodyz00);
					BgL_auxz00_11036 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7455) (BgL_pz00_7455,
							((obj_t) BgL_arg3554z00_8743), BgL_arg0z00_7456, BgL_arg1z00_7457,
							BEOA));
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7454)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11036), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nz00_7454));
		}

	}



/* &walk1!-let-var2162 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2var2162z70zzast_walkz00(obj_t
		BgL_envz00_7458, obj_t BgL_nz00_7459, obj_t BgL_pz00_7460,
		obj_t BgL_arg0z00_7461)
	{
		{	/* Ast/walk.scm 320 */
			{
				obj_t BgL_fieldsz00_8746;

				BgL_fieldsz00_8746 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7459)))->BgL_bindingsz00);
			BgL_loopz00_8745:
				if (NULLP(BgL_fieldsz00_8746))
					{	/* Ast/walk.scm 320 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 320 */
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3537z00_8747;
							obj_t BgL_arg3538z00_8748;

							BgL_arg3537z00_8747 = CAR(((obj_t) BgL_fieldsz00_8746));
							{	/* Ast/walk.scm 320 */
								obj_t BgL_arg3539z00_8749;

								{	/* Ast/walk.scm 320 */
									obj_t BgL_pairz00_8750;

									BgL_pairz00_8750 = CAR(((obj_t) BgL_fieldsz00_8746));
									BgL_arg3539z00_8749 = CDR(BgL_pairz00_8750);
								}
								BgL_arg3538z00_8748 =
									PROCEDURE_ENTRY(BgL_pz00_7460) (BgL_pz00_7460,
									BgL_arg3539z00_8749, BgL_arg0z00_7461, BEOA);
							}
							{	/* Ast/walk.scm 320 */
								obj_t BgL_tmpz00_11063;

								BgL_tmpz00_11063 = ((obj_t) BgL_arg3537z00_8747);
								SET_CDR(BgL_tmpz00_11063, BgL_arg3538z00_8748);
							}
						}
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3542z00_8751;

							BgL_arg3542z00_8751 = CDR(((obj_t) BgL_fieldsz00_8746));
							{
								obj_t BgL_fieldsz00_11068;

								BgL_fieldsz00_11068 = BgL_arg3542z00_8751;
								BgL_fieldsz00_8746 = BgL_fieldsz00_11068;
								goto BgL_loopz00_8745;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11071;

				{	/* Ast/walk.scm 320 */
					BgL_nodez00_bglt BgL_arg3544z00_8752;

					BgL_arg3544z00_8752 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7459)))->BgL_bodyz00);
					BgL_auxz00_11071 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7460) (BgL_pz00_7460,
							((obj_t) BgL_arg3544z00_8752), BgL_arg0z00_7461, BEOA));
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7459)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11071), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nz00_7459));
		}

	}



/* &walk0!-let-var2160 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2var2160z70zzast_walkz00(obj_t
		BgL_envz00_7462, obj_t BgL_nz00_7463, obj_t BgL_pz00_7464)
	{
		{	/* Ast/walk.scm 320 */
			{
				obj_t BgL_fieldsz00_8755;

				BgL_fieldsz00_8755 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7463)))->BgL_bindingsz00);
			BgL_loopz00_8754:
				if (NULLP(BgL_fieldsz00_8755))
					{	/* Ast/walk.scm 320 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 320 */
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3526z00_8756;
							obj_t BgL_arg3527z00_8757;

							BgL_arg3526z00_8756 = CAR(((obj_t) BgL_fieldsz00_8755));
							{	/* Ast/walk.scm 320 */
								obj_t BgL_arg3529z00_8758;

								{	/* Ast/walk.scm 320 */
									obj_t BgL_pairz00_8759;

									BgL_pairz00_8759 = CAR(((obj_t) BgL_fieldsz00_8755));
									BgL_arg3529z00_8758 = CDR(BgL_pairz00_8759);
								}
								BgL_arg3527z00_8757 =
									PROCEDURE_ENTRY(BgL_pz00_7464) (BgL_pz00_7464,
									BgL_arg3529z00_8758, BEOA);
							}
							{	/* Ast/walk.scm 320 */
								obj_t BgL_tmpz00_11096;

								BgL_tmpz00_11096 = ((obj_t) BgL_arg3526z00_8756);
								SET_CDR(BgL_tmpz00_11096, BgL_arg3527z00_8757);
							}
						}
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3532z00_8760;

							BgL_arg3532z00_8760 = CDR(((obj_t) BgL_fieldsz00_8755));
							{
								obj_t BgL_fieldsz00_11101;

								BgL_fieldsz00_11101 = BgL_arg3532z00_8760;
								BgL_fieldsz00_8755 = BgL_fieldsz00_11101;
								goto BgL_loopz00_8754;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11104;

				{	/* Ast/walk.scm 320 */
					BgL_nodez00_bglt BgL_arg3533z00_8761;

					BgL_arg3533z00_8761 =
						(((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7463)))->BgL_bodyz00);
					BgL_auxz00_11104 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7464) (BgL_pz00_7464,
							((obj_t) BgL_arg3533z00_8761), BEOA));
				}
				((((BgL_letzd2varzd2_bglt) COBJECT(
								((BgL_letzd2varzd2_bglt) BgL_nz00_7463)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11104), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2varzd2_bglt) BgL_nz00_7463));
		}

	}



/* &walk3*-let-var2158 */
	obj_t BGl_z62walk3za2zd2letzd2var2158zc0zzast_walkz00(obj_t BgL_envz00_7465,
		obj_t BgL_nz00_7466, obj_t BgL_pz00_7467, obj_t BgL_arg0z00_7468,
		obj_t BgL_arg1z00_7469, obj_t BgL_arg2z00_7470)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_res4010z00_8766;

				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3512z00_8763;
					obj_t BgL_arg3514z00_8764;

					BgL_arg3512z00_8763 =
						BGl_zc3z04anonymousza33515ze3ze70z60zzast_walkz00(BgL_arg2z00_7470,
						BgL_arg1z00_7469, BgL_arg0z00_7468, BgL_pz00_7467,
						(((BgL_letzd2varzd2_bglt) COBJECT(((BgL_letzd2varzd2_bglt)
										BgL_nz00_7466)))->BgL_bindingsz00));
					{	/* Ast/walk.scm 320 */
						BgL_nodez00_bglt BgL_arg3522z00_8765;

						BgL_arg3522z00_8765 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_7466)))->BgL_bodyz00);
						BgL_arg3514z00_8764 =
							PROCEDURE_ENTRY(BgL_pz00_7467) (BgL_pz00_7467,
							((obj_t) BgL_arg3522z00_8765), BgL_arg0z00_7468, BgL_arg1z00_7469,
							BgL_arg2z00_7470, BEOA);
					}
					BgL_res4010z00_8766 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3512z00_8763,
						BgL_arg3514z00_8764);
				}
				return BgL_res4010z00_8766;
			}
		}

	}



/* <@anonymous:3515>~0 */
	obj_t BGl_zc3z04anonymousza33515ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8650, obj_t BgL_arg1z00_8649, obj_t BgL_arg0z00_8648,
		obj_t BgL_pz00_8647, obj_t BgL_l1625z00_5653)
	{
		{	/* Ast/walk.scm 320 */
			if (NULLP(BgL_l1625z00_5653))
				{	/* Ast/walk.scm 320 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3517z00_5656;
					obj_t BgL_arg3518z00_5657;

					{	/* Ast/walk.scm 320 */
						obj_t BgL_fz00_5658;

						BgL_fz00_5658 = CAR(((obj_t) BgL_l1625z00_5653));
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3519z00_5659;

							BgL_arg3519z00_5659 = CDR(((obj_t) BgL_fz00_5658));
							BgL_arg3517z00_5656 =
								PROCEDURE_ENTRY(BgL_pz00_8647) (BgL_pz00_8647,
								BgL_arg3519z00_5659, BgL_arg0z00_8648, BgL_arg1z00_8649,
								BgL_arg2z00_8650, BEOA);
						}
					}
					{	/* Ast/walk.scm 320 */
						obj_t BgL_arg3521z00_5660;

						BgL_arg3521z00_5660 = CDR(((obj_t) BgL_l1625z00_5653));
						BgL_arg3518z00_5657 =
							BGl_zc3z04anonymousza33515ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8650, BgL_arg1z00_8649, BgL_arg0z00_8648,
							BgL_pz00_8647, BgL_arg3521z00_5660);
					}
					return bgl_append2(BgL_arg3517z00_5656, BgL_arg3518z00_5657);
				}
		}

	}



/* &walk2*-let-var2156 */
	obj_t BGl_z62walk2za2zd2letzd2var2156zc0zzast_walkz00(obj_t BgL_envz00_7471,
		obj_t BgL_nz00_7472, obj_t BgL_pz00_7473, obj_t BgL_arg0z00_7474,
		obj_t BgL_arg1z00_7475)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_res4011z00_8771;

				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3500z00_8768;
					obj_t BgL_arg3502z00_8769;

					BgL_arg3500z00_8768 =
						BGl_zc3z04anonymousza33503ze3ze70z60zzast_walkz00(BgL_arg1z00_7475,
						BgL_arg0z00_7474, BgL_pz00_7473,
						(((BgL_letzd2varzd2_bglt) COBJECT(((BgL_letzd2varzd2_bglt)
										BgL_nz00_7472)))->BgL_bindingsz00));
					{	/* Ast/walk.scm 320 */
						BgL_nodez00_bglt BgL_arg3511z00_8770;

						BgL_arg3511z00_8770 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_7472)))->BgL_bodyz00);
						BgL_arg3502z00_8769 =
							PROCEDURE_ENTRY(BgL_pz00_7473) (BgL_pz00_7473,
							((obj_t) BgL_arg3511z00_8770), BgL_arg0z00_7474, BgL_arg1z00_7475,
							BEOA);
					}
					BgL_res4011z00_8771 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3500z00_8768,
						BgL_arg3502z00_8769);
				}
				return BgL_res4011z00_8771;
			}
		}

	}



/* <@anonymous:3503>~0 */
	obj_t BGl_zc3z04anonymousza33503ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8646, obj_t BgL_arg0z00_8645, obj_t BgL_pz00_8644,
		obj_t BgL_l1622z00_5630)
	{
		{	/* Ast/walk.scm 320 */
			if (NULLP(BgL_l1622z00_5630))
				{	/* Ast/walk.scm 320 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3506z00_5633;
					obj_t BgL_arg3507z00_5634;

					{	/* Ast/walk.scm 320 */
						obj_t BgL_fz00_5635;

						BgL_fz00_5635 = CAR(((obj_t) BgL_l1622z00_5630));
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3509z00_5636;

							BgL_arg3509z00_5636 = CDR(((obj_t) BgL_fz00_5635));
							BgL_arg3506z00_5633 =
								PROCEDURE_ENTRY(BgL_pz00_8644) (BgL_pz00_8644,
								BgL_arg3509z00_5636, BgL_arg0z00_8645, BgL_arg1z00_8646, BEOA);
						}
					}
					{	/* Ast/walk.scm 320 */
						obj_t BgL_arg3510z00_5637;

						BgL_arg3510z00_5637 = CDR(((obj_t) BgL_l1622z00_5630));
						BgL_arg3507z00_5634 =
							BGl_zc3z04anonymousza33503ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8646, BgL_arg0z00_8645, BgL_pz00_8644,
							BgL_arg3510z00_5637);
					}
					return bgl_append2(BgL_arg3506z00_5633, BgL_arg3507z00_5634);
				}
		}

	}



/* &walk1*-let-var2154 */
	obj_t BGl_z62walk1za2zd2letzd2var2154zc0zzast_walkz00(obj_t BgL_envz00_7476,
		obj_t BgL_nz00_7477, obj_t BgL_pz00_7478, obj_t BgL_arg0z00_7479)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_res4012z00_8776;

				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3490z00_8773;
					obj_t BgL_arg3491z00_8774;

					BgL_arg3490z00_8773 =
						BGl_zc3z04anonymousza33492ze3ze70z60zzast_walkz00(BgL_arg0z00_7479,
						BgL_pz00_7478,
						(((BgL_letzd2varzd2_bglt) COBJECT(((BgL_letzd2varzd2_bglt)
										BgL_nz00_7477)))->BgL_bindingsz00));
					{	/* Ast/walk.scm 320 */
						BgL_nodez00_bglt BgL_arg3499z00_8775;

						BgL_arg3499z00_8775 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_7477)))->BgL_bodyz00);
						BgL_arg3491z00_8774 =
							PROCEDURE_ENTRY(BgL_pz00_7478) (BgL_pz00_7478,
							((obj_t) BgL_arg3499z00_8775), BgL_arg0z00_7479, BEOA);
					}
					BgL_res4012z00_8776 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3490z00_8773,
						BgL_arg3491z00_8774);
				}
				return BgL_res4012z00_8776;
			}
		}

	}



/* <@anonymous:3492>~0 */
	obj_t BGl_zc3z04anonymousza33492ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8643, obj_t BgL_pz00_8642, obj_t BgL_l1619z00_5608)
	{
		{	/* Ast/walk.scm 320 */
			if (NULLP(BgL_l1619z00_5608))
				{	/* Ast/walk.scm 320 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3494z00_5611;
					obj_t BgL_arg3495z00_5612;

					{	/* Ast/walk.scm 320 */
						obj_t BgL_fz00_5613;

						BgL_fz00_5613 = CAR(((obj_t) BgL_l1619z00_5608));
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3496z00_5614;

							BgL_arg3496z00_5614 = CDR(((obj_t) BgL_fz00_5613));
							BgL_arg3494z00_5611 =
								PROCEDURE_ENTRY(BgL_pz00_8642) (BgL_pz00_8642,
								BgL_arg3496z00_5614, BgL_arg0z00_8643, BEOA);
						}
					}
					{	/* Ast/walk.scm 320 */
						obj_t BgL_arg3497z00_5615;

						BgL_arg3497z00_5615 = CDR(((obj_t) BgL_l1619z00_5608));
						BgL_arg3495z00_5612 =
							BGl_zc3z04anonymousza33492ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8643, BgL_pz00_8642, BgL_arg3497z00_5615);
					}
					return bgl_append2(BgL_arg3494z00_5611, BgL_arg3495z00_5612);
				}
		}

	}



/* &walk0*-let-var2152 */
	obj_t BGl_z62walk0za2zd2letzd2var2152zc0zzast_walkz00(obj_t BgL_envz00_7480,
		obj_t BgL_nz00_7481, obj_t BgL_pz00_7482)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_res4013z00_8781;

				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3479z00_8778;
					obj_t BgL_arg3481z00_8779;

					BgL_arg3479z00_8778 =
						BGl_zc3z04anonymousza33482ze3ze70z60zzast_walkz00(BgL_pz00_7482,
						(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_7481)))->BgL_bindingsz00));
					{	/* Ast/walk.scm 320 */
						BgL_nodez00_bglt BgL_arg3489z00_8780;

						BgL_arg3489z00_8780 =
							(((BgL_letzd2varzd2_bglt) COBJECT(
									((BgL_letzd2varzd2_bglt) BgL_nz00_7481)))->BgL_bodyz00);
						BgL_arg3481z00_8779 =
							PROCEDURE_ENTRY(BgL_pz00_7482) (BgL_pz00_7482,
							((obj_t) BgL_arg3489z00_8780), BEOA);
					}
					BgL_res4013z00_8781 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3479z00_8778,
						BgL_arg3481z00_8779);
				}
				return BgL_res4013z00_8781;
			}
		}

	}



/* <@anonymous:3482>~0 */
	obj_t BGl_zc3z04anonymousza33482ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8641,
		obj_t BgL_l1616z00_5587)
	{
		{	/* Ast/walk.scm 320 */
			if (NULLP(BgL_l1616z00_5587))
				{	/* Ast/walk.scm 320 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 320 */
					obj_t BgL_arg3484z00_5590;
					obj_t BgL_arg3485z00_5591;

					{	/* Ast/walk.scm 320 */
						obj_t BgL_fz00_5592;

						BgL_fz00_5592 = CAR(((obj_t) BgL_l1616z00_5587));
						{	/* Ast/walk.scm 320 */
							obj_t BgL_arg3486z00_5593;

							BgL_arg3486z00_5593 = CDR(((obj_t) BgL_fz00_5592));
							BgL_arg3484z00_5590 =
								PROCEDURE_ENTRY(BgL_pz00_8641) (BgL_pz00_8641,
								BgL_arg3486z00_5593, BEOA);
						}
					}
					{	/* Ast/walk.scm 320 */
						obj_t BgL_arg3488z00_5594;

						BgL_arg3488z00_5594 = CDR(((obj_t) BgL_l1616z00_5587));
						BgL_arg3485z00_5591 =
							BGl_zc3z04anonymousza33482ze3ze70z60zzast_walkz00(BgL_pz00_8641,
							BgL_arg3488z00_5594);
					}
					return bgl_append2(BgL_arg3484z00_5590, BgL_arg3485z00_5591);
				}
		}

	}



/* &walk3-let-var2150 */
	obj_t BGl_z62walk3zd2letzd2var2150z62zzast_walkz00(obj_t BgL_envz00_7483,
		obj_t BgL_nz00_7484, obj_t BgL_pz00_7485, obj_t BgL_arg0z00_7486,
		obj_t BgL_arg1z00_7487, obj_t BgL_arg2z00_7488)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_g1614z00_8783;

				BgL_g1614z00_8783 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7484)))->BgL_bindingsz00);
				{
					obj_t BgL_l1612z00_8785;

					BgL_l1612z00_8785 = BgL_g1614z00_8783;
				BgL_zc3z04anonymousza33473ze3z87_8784:
					if (PAIRP(BgL_l1612z00_8785))
						{	/* Ast/walk.scm 320 */
							{	/* Ast/walk.scm 320 */
								obj_t BgL_fz00_8786;

								BgL_fz00_8786 = CAR(BgL_l1612z00_8785);
								{	/* Ast/walk.scm 320 */
									obj_t BgL_arg3475z00_8787;

									BgL_arg3475z00_8787 = CDR(((obj_t) BgL_fz00_8786));
									PROCEDURE_ENTRY(BgL_pz00_7485) (BgL_pz00_7485,
										BgL_arg3475z00_8787, BgL_arg0z00_7486, BgL_arg1z00_7487,
										BgL_arg2z00_7488, BEOA);
								}
							}
							{
								obj_t BgL_l1612z00_11243;

								BgL_l1612z00_11243 = CDR(BgL_l1612z00_8785);
								BgL_l1612z00_8785 = BgL_l1612z00_11243;
								goto BgL_zc3z04anonymousza33473ze3z87_8784;
							}
						}
					else
						{	/* Ast/walk.scm 320 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 320 */
				BgL_nodez00_bglt BgL_arg3478z00_8788;

				BgL_arg3478z00_8788 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7484)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7485) (BgL_pz00_7485,
					((obj_t) BgL_arg3478z00_8788), BgL_arg0z00_7486, BgL_arg1z00_7487,
					BgL_arg2z00_7488, BEOA);
			}
		}

	}



/* &walk2-let-var2148 */
	obj_t BGl_z62walk2zd2letzd2var2148z62zzast_walkz00(obj_t BgL_envz00_7489,
		obj_t BgL_nz00_7490, obj_t BgL_pz00_7491, obj_t BgL_arg0z00_7492,
		obj_t BgL_arg1z00_7493)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_g1611z00_8790;

				BgL_g1611z00_8790 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7490)))->BgL_bindingsz00);
				{
					obj_t BgL_l1609z00_8792;

					BgL_l1609z00_8792 = BgL_g1611z00_8790;
				BgL_zc3z04anonymousza33467ze3z87_8791:
					if (PAIRP(BgL_l1609z00_8792))
						{	/* Ast/walk.scm 320 */
							{	/* Ast/walk.scm 320 */
								obj_t BgL_fz00_8793;

								BgL_fz00_8793 = CAR(BgL_l1609z00_8792);
								{	/* Ast/walk.scm 320 */
									obj_t BgL_arg3469z00_8794;

									BgL_arg3469z00_8794 = CDR(((obj_t) BgL_fz00_8793));
									PROCEDURE_ENTRY(BgL_pz00_7491) (BgL_pz00_7491,
										BgL_arg3469z00_8794, BgL_arg0z00_7492, BgL_arg1z00_7493,
										BEOA);
								}
							}
							{
								obj_t BgL_l1609z00_11268;

								BgL_l1609z00_11268 = CDR(BgL_l1609z00_8792);
								BgL_l1609z00_8792 = BgL_l1609z00_11268;
								goto BgL_zc3z04anonymousza33467ze3z87_8791;
							}
						}
					else
						{	/* Ast/walk.scm 320 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 320 */
				BgL_nodez00_bglt BgL_arg3472z00_8795;

				BgL_arg3472z00_8795 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7490)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7491) (BgL_pz00_7491,
					((obj_t) BgL_arg3472z00_8795), BgL_arg0z00_7492, BgL_arg1z00_7493,
					BEOA);
			}
		}

	}



/* &walk1-let-var2146 */
	obj_t BGl_z62walk1zd2letzd2var2146z62zzast_walkz00(obj_t BgL_envz00_7494,
		obj_t BgL_nz00_7495, obj_t BgL_pz00_7496, obj_t BgL_arg0z00_7497)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_g1608z00_8797;

				BgL_g1608z00_8797 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7495)))->BgL_bindingsz00);
				{
					obj_t BgL_l1606z00_8799;

					BgL_l1606z00_8799 = BgL_g1608z00_8797;
				BgL_zc3z04anonymousza33461ze3z87_8798:
					if (PAIRP(BgL_l1606z00_8799))
						{	/* Ast/walk.scm 320 */
							{	/* Ast/walk.scm 320 */
								obj_t BgL_fz00_8800;

								BgL_fz00_8800 = CAR(BgL_l1606z00_8799);
								{	/* Ast/walk.scm 320 */
									obj_t BgL_arg3463z00_8801;

									BgL_arg3463z00_8801 = CDR(((obj_t) BgL_fz00_8800));
									PROCEDURE_ENTRY(BgL_pz00_7496) (BgL_pz00_7496,
										BgL_arg3463z00_8801, BgL_arg0z00_7497, BEOA);
								}
							}
							{
								obj_t BgL_l1606z00_11291;

								BgL_l1606z00_11291 = CDR(BgL_l1606z00_8799);
								BgL_l1606z00_8799 = BgL_l1606z00_11291;
								goto BgL_zc3z04anonymousza33461ze3z87_8798;
							}
						}
					else
						{	/* Ast/walk.scm 320 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 320 */
				BgL_nodez00_bglt BgL_arg3466z00_8802;

				BgL_arg3466z00_8802 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7495)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7496) (BgL_pz00_7496,
					((obj_t) BgL_arg3466z00_8802), BgL_arg0z00_7497, BEOA);
			}
		}

	}



/* &walk0-let-var2144 */
	obj_t BGl_z62walk0zd2letzd2var2144z62zzast_walkz00(obj_t BgL_envz00_7498,
		obj_t BgL_nz00_7499, obj_t BgL_pz00_7500)
	{
		{	/* Ast/walk.scm 320 */
			{	/* Ast/walk.scm 320 */
				obj_t BgL_g1604z00_8804;

				BgL_g1604z00_8804 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7499)))->BgL_bindingsz00);
				{
					obj_t BgL_l1602z00_8806;

					BgL_l1602z00_8806 = BgL_g1604z00_8804;
				BgL_zc3z04anonymousza33455ze3z87_8805:
					if (PAIRP(BgL_l1602z00_8806))
						{	/* Ast/walk.scm 320 */
							{	/* Ast/walk.scm 320 */
								obj_t BgL_fz00_8807;

								BgL_fz00_8807 = CAR(BgL_l1602z00_8806);
								{	/* Ast/walk.scm 320 */
									obj_t BgL_arg3457z00_8808;

									BgL_arg3457z00_8808 = CDR(((obj_t) BgL_fz00_8807));
									PROCEDURE_ENTRY(BgL_pz00_7500) (BgL_pz00_7500,
										BgL_arg3457z00_8808, BEOA);
								}
							}
							{
								obj_t BgL_l1602z00_11312;

								BgL_l1602z00_11312 = CDR(BgL_l1602z00_8806);
								BgL_l1602z00_8806 = BgL_l1602z00_11312;
								goto BgL_zc3z04anonymousza33455ze3z87_8805;
							}
						}
					else
						{	/* Ast/walk.scm 320 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 320 */
				BgL_nodez00_bglt BgL_arg3460z00_8809;

				BgL_arg3460z00_8809 =
					(((BgL_letzd2varzd2_bglt) COBJECT(
							((BgL_letzd2varzd2_bglt) BgL_nz00_7499)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7500) (BgL_pz00_7500,
					((obj_t) BgL_arg3460z00_8809), BEOA);
			}
		}

	}



/* &walk3!-let-fun2142 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2fun2142z70zzast_walkz00(obj_t
		BgL_envz00_7501, obj_t BgL_nz00_7502, obj_t BgL_pz00_7503,
		obj_t BgL_arg0z00_7504, obj_t BgL_arg1z00_7505, obj_t BgL_arg2z00_7506)
	{
		{	/* Ast/walk.scm 315 */
			{
				obj_t BgL_fieldsz00_8812;

				BgL_fieldsz00_8812 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7502)))->BgL_localsz00);
			BgL_loopz00_8811:
				if (NULLP(BgL_fieldsz00_8812))
					{	/* Ast/walk.scm 315 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 315 */
						{	/* Ast/walk.scm 315 */
							obj_t BgL_vz00_8813;
							obj_t BgL_bz00_8814;

							BgL_vz00_8813 = CAR(((obj_t) BgL_fieldsz00_8812));
							{	/* Ast/walk.scm 315 */
								obj_t BgL_arg3450z00_8815;

								BgL_arg3450z00_8815 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																CAR(
																	((obj_t) BgL_fieldsz00_8812)))))->
													BgL_valuez00))))->BgL_bodyz00);
								BgL_bz00_8814 =
									PROCEDURE_ENTRY(BgL_pz00_7503) (BgL_pz00_7503,
									BgL_arg3450z00_8815, BgL_arg0z00_7504, BgL_arg1z00_7505,
									BgL_arg2z00_7506, BEOA);
							}
							{	/* Ast/walk.scm 317 */
								BgL_valuez00_bglt BgL_arg3448z00_8816;

								BgL_arg3448z00_8816 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_8813)))->BgL_valuez00);
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_arg3448z00_8816)))->
										BgL_bodyz00) = ((obj_t) BgL_bz00_8814), BUNSPEC);
							}
						}
						{	/* Ast/walk.scm 315 */
							obj_t BgL_arg3452z00_8817;

							BgL_arg3452z00_8817 = CDR(((obj_t) BgL_fieldsz00_8812));
							{
								obj_t BgL_fieldsz00_11344;

								BgL_fieldsz00_11344 = BgL_arg3452z00_8817;
								BgL_fieldsz00_8812 = BgL_fieldsz00_11344;
								goto BgL_loopz00_8811;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11347;

				{	/* Ast/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg3454z00_8818;

					BgL_arg3454z00_8818 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7502)))->BgL_bodyz00);
					BgL_auxz00_11347 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7503) (BgL_pz00_7503,
							((obj_t) BgL_arg3454z00_8818), BgL_arg0z00_7504, BgL_arg1z00_7505,
							BgL_arg2z00_7506, BEOA));
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7502)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11347), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nz00_7502));
		}

	}



/* &walk2!-let-fun2140 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2fun2140z70zzast_walkz00(obj_t
		BgL_envz00_7507, obj_t BgL_nz00_7508, obj_t BgL_pz00_7509,
		obj_t BgL_arg0z00_7510, obj_t BgL_arg1z00_7511)
	{
		{	/* Ast/walk.scm 315 */
			{
				obj_t BgL_fieldsz00_8821;

				BgL_fieldsz00_8821 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7508)))->BgL_localsz00);
			BgL_loopz00_8820:
				if (NULLP(BgL_fieldsz00_8821))
					{	/* Ast/walk.scm 315 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 315 */
						{	/* Ast/walk.scm 315 */
							obj_t BgL_vz00_8822;
							obj_t BgL_bz00_8823;

							BgL_vz00_8822 = CAR(((obj_t) BgL_fieldsz00_8821));
							{	/* Ast/walk.scm 315 */
								obj_t BgL_arg3441z00_8824;

								BgL_arg3441z00_8824 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																CAR(
																	((obj_t) BgL_fieldsz00_8821)))))->
													BgL_valuez00))))->BgL_bodyz00);
								BgL_bz00_8823 =
									PROCEDURE_ENTRY(BgL_pz00_7509) (BgL_pz00_7509,
									BgL_arg3441z00_8824, BgL_arg0z00_7510, BgL_arg1z00_7511,
									BEOA);
							}
							{	/* Ast/walk.scm 317 */
								BgL_valuez00_bglt BgL_arg3439z00_8825;

								BgL_arg3439z00_8825 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_8822)))->BgL_valuez00);
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_arg3439z00_8825)))->
										BgL_bodyz00) = ((obj_t) BgL_bz00_8823), BUNSPEC);
							}
						}
						{	/* Ast/walk.scm 315 */
							obj_t BgL_arg3443z00_8826;

							BgL_arg3443z00_8826 = CDR(((obj_t) BgL_fieldsz00_8821));
							{
								obj_t BgL_fieldsz00_11385;

								BgL_fieldsz00_11385 = BgL_arg3443z00_8826;
								BgL_fieldsz00_8821 = BgL_fieldsz00_11385;
								goto BgL_loopz00_8820;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11388;

				{	/* Ast/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg3444z00_8827;

					BgL_arg3444z00_8827 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7508)))->BgL_bodyz00);
					BgL_auxz00_11388 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7509) (BgL_pz00_7509,
							((obj_t) BgL_arg3444z00_8827), BgL_arg0z00_7510, BgL_arg1z00_7511,
							BEOA));
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7508)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11388), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nz00_7508));
		}

	}



/* &walk1!-let-fun2138 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2fun2138z70zzast_walkz00(obj_t
		BgL_envz00_7512, obj_t BgL_nz00_7513, obj_t BgL_pz00_7514,
		obj_t BgL_arg0z00_7515)
	{
		{	/* Ast/walk.scm 315 */
			{
				obj_t BgL_fieldsz00_8830;

				BgL_fieldsz00_8830 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7513)))->BgL_localsz00);
			BgL_loopz00_8829:
				if (NULLP(BgL_fieldsz00_8830))
					{	/* Ast/walk.scm 315 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 315 */
						{	/* Ast/walk.scm 315 */
							obj_t BgL_vz00_8831;
							obj_t BgL_bz00_8832;

							BgL_vz00_8831 = CAR(((obj_t) BgL_fieldsz00_8830));
							{	/* Ast/walk.scm 315 */
								obj_t BgL_arg3430z00_8833;

								BgL_arg3430z00_8833 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																CAR(
																	((obj_t) BgL_fieldsz00_8830)))))->
													BgL_valuez00))))->BgL_bodyz00);
								BgL_bz00_8832 =
									PROCEDURE_ENTRY(BgL_pz00_7514) (BgL_pz00_7514,
									BgL_arg3430z00_8833, BgL_arg0z00_7515, BEOA);
							}
							{	/* Ast/walk.scm 317 */
								BgL_valuez00_bglt BgL_arg3429z00_8834;

								BgL_arg3429z00_8834 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_8831)))->BgL_valuez00);
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_arg3429z00_8834)))->
										BgL_bodyz00) = ((obj_t) BgL_bz00_8832), BUNSPEC);
							}
						}
						{	/* Ast/walk.scm 315 */
							obj_t BgL_arg3432z00_8835;

							BgL_arg3432z00_8835 = CDR(((obj_t) BgL_fieldsz00_8830));
							{
								obj_t BgL_fieldsz00_11424;

								BgL_fieldsz00_11424 = BgL_arg3432z00_8835;
								BgL_fieldsz00_8830 = BgL_fieldsz00_11424;
								goto BgL_loopz00_8829;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11427;

				{	/* Ast/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg3435z00_8836;

					BgL_arg3435z00_8836 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7513)))->BgL_bodyz00);
					BgL_auxz00_11427 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7514) (BgL_pz00_7514,
							((obj_t) BgL_arg3435z00_8836), BgL_arg0z00_7515, BEOA));
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7513)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11427), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nz00_7513));
		}

	}



/* &walk0!-let-fun2136 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2fun2136z70zzast_walkz00(obj_t
		BgL_envz00_7516, obj_t BgL_nz00_7517, obj_t BgL_pz00_7518)
	{
		{	/* Ast/walk.scm 315 */
			{
				obj_t BgL_fieldsz00_8839;

				BgL_fieldsz00_8839 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7517)))->BgL_localsz00);
			BgL_loopz00_8838:
				if (NULLP(BgL_fieldsz00_8839))
					{	/* Ast/walk.scm 315 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 315 */
						{	/* Ast/walk.scm 315 */
							obj_t BgL_vz00_8840;
							obj_t BgL_bz00_8841;

							BgL_vz00_8840 = CAR(((obj_t) BgL_fieldsz00_8839));
							{	/* Ast/walk.scm 315 */
								obj_t BgL_arg3420z00_8842;

								BgL_arg3420z00_8842 =
									(((BgL_sfunz00_bglt) COBJECT(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt)
																CAR(
																	((obj_t) BgL_fieldsz00_8839)))))->
													BgL_valuez00))))->BgL_bodyz00);
								BgL_bz00_8841 =
									PROCEDURE_ENTRY(BgL_pz00_7518) (BgL_pz00_7518,
									BgL_arg3420z00_8842, BEOA);
							}
							{	/* Ast/walk.scm 317 */
								BgL_valuez00_bglt BgL_arg3419z00_8843;

								BgL_arg3419z00_8843 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_8840)))->BgL_valuez00);
								((((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt) BgL_arg3419z00_8843)))->
										BgL_bodyz00) = ((obj_t) BgL_bz00_8841), BUNSPEC);
							}
						}
						{	/* Ast/walk.scm 315 */
							obj_t BgL_arg3422z00_8844;

							BgL_arg3422z00_8844 = CDR(((obj_t) BgL_fieldsz00_8839));
							{
								obj_t BgL_fieldsz00_11461;

								BgL_fieldsz00_11461 = BgL_arg3422z00_8844;
								BgL_fieldsz00_8839 = BgL_fieldsz00_11461;
								goto BgL_loopz00_8838;
							}
						}
					}
			}
			{
				BgL_nodez00_bglt BgL_auxz00_11464;

				{	/* Ast/walk.scm 315 */
					BgL_nodez00_bglt BgL_arg3424z00_8845;

					BgL_arg3424z00_8845 =
						(((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7517)))->BgL_bodyz00);
					BgL_auxz00_11464 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7518) (BgL_pz00_7518,
							((obj_t) BgL_arg3424z00_8845), BEOA));
				}
				((((BgL_letzd2funzd2_bglt) COBJECT(
								((BgL_letzd2funzd2_bglt) BgL_nz00_7517)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11464), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_letzd2funzd2_bglt) BgL_nz00_7517));
		}

	}



/* &walk3*-let-fun2134 */
	obj_t BGl_z62walk3za2zd2letzd2fun2134zc0zzast_walkz00(obj_t BgL_envz00_7519,
		obj_t BgL_nz00_7520, obj_t BgL_pz00_7521, obj_t BgL_arg0z00_7522,
		obj_t BgL_arg1z00_7523, obj_t BgL_arg2z00_7524)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_res4014z00_8850;

				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3401z00_8847;
					obj_t BgL_arg3403z00_8848;

					BgL_arg3401z00_8847 =
						BGl_zc3z04anonymousza33404ze3ze70z60zzast_walkz00(BgL_arg2z00_7524,
						BgL_arg1z00_7523, BgL_arg0z00_7522, BgL_pz00_7521,
						(((BgL_letzd2funzd2_bglt) COBJECT(((BgL_letzd2funzd2_bglt)
										BgL_nz00_7520)))->BgL_localsz00));
					{	/* Ast/walk.scm 315 */
						BgL_nodez00_bglt BgL_arg3412z00_8849;

						BgL_arg3412z00_8849 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nz00_7520)))->BgL_bodyz00);
						BgL_arg3403z00_8848 =
							PROCEDURE_ENTRY(BgL_pz00_7521) (BgL_pz00_7521,
							((obj_t) BgL_arg3412z00_8849), BgL_arg0z00_7522, BgL_arg1z00_7523,
							BgL_arg2z00_7524, BEOA);
					}
					BgL_res4014z00_8850 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3401z00_8847,
						BgL_arg3403z00_8848);
				}
				return BgL_res4014z00_8850;
			}
		}

	}



/* <@anonymous:3404>~0 */
	obj_t BGl_zc3z04anonymousza33404ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8640, obj_t BgL_arg1z00_8639, obj_t BgL_arg0z00_8638,
		obj_t BgL_pz00_8637, obj_t BgL_l1600z00_5409)
	{
		{	/* Ast/walk.scm 315 */
			if (NULLP(BgL_l1600z00_5409))
				{	/* Ast/walk.scm 315 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3406z00_5412;
					obj_t BgL_arg3407z00_5413;

					{	/* Ast/walk.scm 315 */
						obj_t BgL_fz00_5414;

						BgL_fz00_5414 = CAR(((obj_t) BgL_l1600z00_5409));
						{	/* Ast/walk.scm 316 */
							obj_t BgL_arg3409z00_5415;

							BgL_arg3409z00_5415 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_fz00_5414)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3406z00_5412 =
								PROCEDURE_ENTRY(BgL_pz00_8637) (BgL_pz00_8637,
								BgL_arg3409z00_5415, BgL_arg0z00_8638, BgL_arg1z00_8639,
								BgL_arg2z00_8640, BEOA);
						}
					}
					{	/* Ast/walk.scm 315 */
						obj_t BgL_arg3411z00_5418;

						BgL_arg3411z00_5418 = CDR(((obj_t) BgL_l1600z00_5409));
						BgL_arg3407z00_5413 =
							BGl_zc3z04anonymousza33404ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8640, BgL_arg1z00_8639, BgL_arg0z00_8638,
							BgL_pz00_8637, BgL_arg3411z00_5418);
					}
					return bgl_append2(BgL_arg3406z00_5412, BgL_arg3407z00_5413);
				}
		}

	}



/* &walk2*-let-fun2132 */
	obj_t BGl_z62walk2za2zd2letzd2fun2132zc0zzast_walkz00(obj_t BgL_envz00_7525,
		obj_t BgL_nz00_7526, obj_t BgL_pz00_7527, obj_t BgL_arg0z00_7528,
		obj_t BgL_arg1z00_7529)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_res4015z00_8855;

				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3385z00_8852;
					obj_t BgL_arg3387z00_8853;

					BgL_arg3385z00_8852 =
						BGl_zc3z04anonymousza33388ze3ze70z60zzast_walkz00(BgL_arg1z00_7529,
						BgL_arg0z00_7528, BgL_pz00_7527,
						(((BgL_letzd2funzd2_bglt) COBJECT(((BgL_letzd2funzd2_bglt)
										BgL_nz00_7526)))->BgL_localsz00));
					{	/* Ast/walk.scm 315 */
						BgL_nodez00_bglt BgL_arg3400z00_8854;

						BgL_arg3400z00_8854 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nz00_7526)))->BgL_bodyz00);
						BgL_arg3387z00_8853 =
							PROCEDURE_ENTRY(BgL_pz00_7527) (BgL_pz00_7527,
							((obj_t) BgL_arg3400z00_8854), BgL_arg0z00_7528, BgL_arg1z00_7529,
							BEOA);
					}
					BgL_res4015z00_8855 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3385z00_8852,
						BgL_arg3387z00_8853);
				}
				return BgL_res4015z00_8855;
			}
		}

	}



/* <@anonymous:3388>~0 */
	obj_t BGl_zc3z04anonymousza33388ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8636, obj_t BgL_arg0z00_8635, obj_t BgL_pz00_8634,
		obj_t BgL_l1597z00_5384)
	{
		{	/* Ast/walk.scm 315 */
			if (NULLP(BgL_l1597z00_5384))
				{	/* Ast/walk.scm 315 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3391z00_5387;
					obj_t BgL_arg3392z00_5388;

					{	/* Ast/walk.scm 315 */
						obj_t BgL_fz00_5389;

						BgL_fz00_5389 = CAR(((obj_t) BgL_l1597z00_5384));
						{	/* Ast/walk.scm 316 */
							obj_t BgL_arg3394z00_5390;

							BgL_arg3394z00_5390 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_fz00_5389)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3391z00_5387 =
								PROCEDURE_ENTRY(BgL_pz00_8634) (BgL_pz00_8634,
								BgL_arg3394z00_5390, BgL_arg0z00_8635, BgL_arg1z00_8636, BEOA);
						}
					}
					{	/* Ast/walk.scm 315 */
						obj_t BgL_arg3398z00_5393;

						BgL_arg3398z00_5393 = CDR(((obj_t) BgL_l1597z00_5384));
						BgL_arg3392z00_5388 =
							BGl_zc3z04anonymousza33388ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8636, BgL_arg0z00_8635, BgL_pz00_8634,
							BgL_arg3398z00_5393);
					}
					return bgl_append2(BgL_arg3391z00_5387, BgL_arg3392z00_5388);
				}
		}

	}



/* &walk1*-let-fun2130 */
	obj_t BGl_z62walk1za2zd2letzd2fun2130zc0zzast_walkz00(obj_t BgL_envz00_7530,
		obj_t BgL_nz00_7531, obj_t BgL_pz00_7532, obj_t BgL_arg0z00_7533)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_res4016z00_8860;

				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3358z00_8857;
					obj_t BgL_arg3359z00_8858;

					BgL_arg3358z00_8857 =
						BGl_zc3z04anonymousza33360ze3ze70z60zzast_walkz00(BgL_arg0z00_7533,
						BgL_pz00_7532,
						(((BgL_letzd2funzd2_bglt) COBJECT(((BgL_letzd2funzd2_bglt)
										BgL_nz00_7531)))->BgL_localsz00));
					{	/* Ast/walk.scm 315 */
						BgL_nodez00_bglt BgL_arg3384z00_8859;

						BgL_arg3384z00_8859 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nz00_7531)))->BgL_bodyz00);
						BgL_arg3359z00_8858 =
							PROCEDURE_ENTRY(BgL_pz00_7532) (BgL_pz00_7532,
							((obj_t) BgL_arg3384z00_8859), BgL_arg0z00_7533, BEOA);
					}
					BgL_res4016z00_8860 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3358z00_8857,
						BgL_arg3359z00_8858);
				}
				return BgL_res4016z00_8860;
			}
		}

	}



/* <@anonymous:3360>~0 */
	obj_t BGl_zc3z04anonymousza33360ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8633, obj_t BgL_pz00_8632, obj_t BgL_l1594z00_5360)
	{
		{	/* Ast/walk.scm 315 */
			if (NULLP(BgL_l1594z00_5360))
				{	/* Ast/walk.scm 315 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3374z00_5363;
					obj_t BgL_arg3379z00_5364;

					{	/* Ast/walk.scm 315 */
						obj_t BgL_fz00_5365;

						BgL_fz00_5365 = CAR(((obj_t) BgL_l1594z00_5360));
						{	/* Ast/walk.scm 316 */
							obj_t BgL_arg3380z00_5366;

							BgL_arg3380z00_5366 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_fz00_5365)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3374z00_5363 =
								PROCEDURE_ENTRY(BgL_pz00_8632) (BgL_pz00_8632,
								BgL_arg3380z00_5366, BgL_arg0z00_8633, BEOA);
						}
					}
					{	/* Ast/walk.scm 315 */
						obj_t BgL_arg3383z00_5369;

						BgL_arg3383z00_5369 = CDR(((obj_t) BgL_l1594z00_5360));
						BgL_arg3379z00_5364 =
							BGl_zc3z04anonymousza33360ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8633, BgL_pz00_8632, BgL_arg3383z00_5369);
					}
					return bgl_append2(BgL_arg3374z00_5363, BgL_arg3379z00_5364);
				}
		}

	}



/* &walk0*-let-fun2128 */
	obj_t BGl_z62walk0za2zd2letzd2fun2128zc0zzast_walkz00(obj_t BgL_envz00_7534,
		obj_t BgL_nz00_7535, obj_t BgL_pz00_7536)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_res4017z00_8865;

				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3348z00_8862;
					obj_t BgL_arg3349z00_8863;

					BgL_arg3348z00_8862 =
						BGl_zc3z04anonymousza33350ze3ze70z60zzast_walkz00(BgL_pz00_7536,
						(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nz00_7535)))->BgL_localsz00));
					{	/* Ast/walk.scm 315 */
						BgL_nodez00_bglt BgL_arg3357z00_8864;

						BgL_arg3357z00_8864 =
							(((BgL_letzd2funzd2_bglt) COBJECT(
									((BgL_letzd2funzd2_bglt) BgL_nz00_7535)))->BgL_bodyz00);
						BgL_arg3349z00_8863 =
							PROCEDURE_ENTRY(BgL_pz00_7536) (BgL_pz00_7536,
							((obj_t) BgL_arg3357z00_8864), BEOA);
					}
					BgL_res4017z00_8865 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3348z00_8862,
						BgL_arg3349z00_8863);
				}
				return BgL_res4017z00_8865;
			}
		}

	}



/* <@anonymous:3350>~0 */
	obj_t BGl_zc3z04anonymousza33350ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8631,
		obj_t BgL_l1591z00_5337)
	{
		{	/* Ast/walk.scm 315 */
			if (NULLP(BgL_l1591z00_5337))
				{	/* Ast/walk.scm 315 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 315 */
					obj_t BgL_arg3352z00_5340;
					obj_t BgL_arg3353z00_5341;

					{	/* Ast/walk.scm 315 */
						obj_t BgL_fz00_5342;

						BgL_fz00_5342 = CAR(((obj_t) BgL_l1591z00_5337));
						{	/* Ast/walk.scm 316 */
							obj_t BgL_arg3354z00_5343;

							BgL_arg3354z00_5343 =
								(((BgL_sfunz00_bglt) COBJECT(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt) BgL_fz00_5342)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3352z00_5340 =
								PROCEDURE_ENTRY(BgL_pz00_8631) (BgL_pz00_8631,
								BgL_arg3354z00_5343, BEOA);
						}
					}
					{	/* Ast/walk.scm 315 */
						obj_t BgL_arg3356z00_5346;

						BgL_arg3356z00_5346 = CDR(((obj_t) BgL_l1591z00_5337));
						BgL_arg3353z00_5341 =
							BGl_zc3z04anonymousza33350ze3ze70z60zzast_walkz00(BgL_pz00_8631,
							BgL_arg3356z00_5346);
					}
					return bgl_append2(BgL_arg3352z00_5340, BgL_arg3353z00_5341);
				}
		}

	}



/* &walk3-let-fun2126 */
	obj_t BGl_z62walk3zd2letzd2fun2126z62zzast_walkz00(obj_t BgL_envz00_7537,
		obj_t BgL_nz00_7538, obj_t BgL_pz00_7539, obj_t BgL_arg0z00_7540,
		obj_t BgL_arg1z00_7541, obj_t BgL_arg2z00_7542)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_g1589z00_8867;

				BgL_g1589z00_8867 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7538)))->BgL_localsz00);
				{
					obj_t BgL_l1587z00_8869;

					BgL_l1587z00_8869 = BgL_g1589z00_8867;
				BgL_zc3z04anonymousza33341ze3z87_8868:
					if (PAIRP(BgL_l1587z00_8869))
						{	/* Ast/walk.scm 315 */
							{	/* Ast/walk.scm 315 */
								obj_t BgL_fz00_8870;

								BgL_fz00_8870 = CAR(BgL_l1587z00_8869);
								{	/* Ast/walk.scm 316 */
									obj_t BgL_arg3344z00_8871;

									BgL_arg3344z00_8871 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_fz00_8870)))->
														BgL_valuez00))))->BgL_bodyz00);
									PROCEDURE_ENTRY(BgL_pz00_7539) (BgL_pz00_7539,
										BgL_arg3344z00_8871, BgL_arg0z00_7540, BgL_arg1z00_7541,
										BgL_arg2z00_7542, BEOA);
								}
							}
							{
								obj_t BgL_l1587z00_11613;

								BgL_l1587z00_11613 = CDR(BgL_l1587z00_8869);
								BgL_l1587z00_8869 = BgL_l1587z00_11613;
								goto BgL_zc3z04anonymousza33341ze3z87_8868;
							}
						}
					else
						{	/* Ast/walk.scm 315 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 315 */
				BgL_nodez00_bglt BgL_arg3347z00_8872;

				BgL_arg3347z00_8872 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7538)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7539) (BgL_pz00_7539,
					((obj_t) BgL_arg3347z00_8872), BgL_arg0z00_7540, BgL_arg1z00_7541,
					BgL_arg2z00_7542, BEOA);
			}
		}

	}



/* &walk2-let-fun2124 */
	obj_t BGl_z62walk2zd2letzd2fun2124z62zzast_walkz00(obj_t BgL_envz00_7543,
		obj_t BgL_nz00_7544, obj_t BgL_pz00_7545, obj_t BgL_arg0z00_7546,
		obj_t BgL_arg1z00_7547)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_g1586z00_8874;

				BgL_g1586z00_8874 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7544)))->BgL_localsz00);
				{
					obj_t BgL_l1584z00_8876;

					BgL_l1584z00_8876 = BgL_g1586z00_8874;
				BgL_zc3z04anonymousza33334ze3z87_8875:
					if (PAIRP(BgL_l1584z00_8876))
						{	/* Ast/walk.scm 315 */
							{	/* Ast/walk.scm 315 */
								obj_t BgL_fz00_8877;

								BgL_fz00_8877 = CAR(BgL_l1584z00_8876);
								{	/* Ast/walk.scm 316 */
									obj_t BgL_arg3336z00_8878;

									BgL_arg3336z00_8878 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_fz00_8877)))->
														BgL_valuez00))))->BgL_bodyz00);
									PROCEDURE_ENTRY(BgL_pz00_7545) (BgL_pz00_7545,
										BgL_arg3336z00_8878, BgL_arg0z00_7546, BgL_arg1z00_7547,
										BEOA);
								}
							}
							{
								obj_t BgL_l1584z00_11640;

								BgL_l1584z00_11640 = CDR(BgL_l1584z00_8876);
								BgL_l1584z00_8876 = BgL_l1584z00_11640;
								goto BgL_zc3z04anonymousza33334ze3z87_8875;
							}
						}
					else
						{	/* Ast/walk.scm 315 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 315 */
				BgL_nodez00_bglt BgL_arg3340z00_8879;

				BgL_arg3340z00_8879 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7544)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7545) (BgL_pz00_7545,
					((obj_t) BgL_arg3340z00_8879), BgL_arg0z00_7546, BgL_arg1z00_7547,
					BEOA);
			}
		}

	}



/* &walk1-let-fun2122 */
	obj_t BGl_z62walk1zd2letzd2fun2122z62zzast_walkz00(obj_t BgL_envz00_7548,
		obj_t BgL_nz00_7549, obj_t BgL_pz00_7550, obj_t BgL_arg0z00_7551)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_g1583z00_8881;

				BgL_g1583z00_8881 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7549)))->BgL_localsz00);
				{
					obj_t BgL_l1581z00_8883;

					BgL_l1581z00_8883 = BgL_g1583z00_8881;
				BgL_zc3z04anonymousza33326ze3z87_8882:
					if (PAIRP(BgL_l1581z00_8883))
						{	/* Ast/walk.scm 315 */
							{	/* Ast/walk.scm 315 */
								obj_t BgL_fz00_8884;

								BgL_fz00_8884 = CAR(BgL_l1581z00_8883);
								{	/* Ast/walk.scm 316 */
									obj_t BgL_arg3330z00_8885;

									BgL_arg3330z00_8885 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_fz00_8884)))->
														BgL_valuez00))))->BgL_bodyz00);
									PROCEDURE_ENTRY(BgL_pz00_7550) (BgL_pz00_7550,
										BgL_arg3330z00_8885, BgL_arg0z00_7551, BEOA);
								}
							}
							{
								obj_t BgL_l1581z00_11665;

								BgL_l1581z00_11665 = CDR(BgL_l1581z00_8883);
								BgL_l1581z00_8883 = BgL_l1581z00_11665;
								goto BgL_zc3z04anonymousza33326ze3z87_8882;
							}
						}
					else
						{	/* Ast/walk.scm 315 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 315 */
				BgL_nodez00_bglt BgL_arg3333z00_8886;

				BgL_arg3333z00_8886 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7549)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7550) (BgL_pz00_7550,
					((obj_t) BgL_arg3333z00_8886), BgL_arg0z00_7551, BEOA);
			}
		}

	}



/* &walk0-let-fun2120 */
	obj_t BGl_z62walk0zd2letzd2fun2120z62zzast_walkz00(obj_t BgL_envz00_7552,
		obj_t BgL_nz00_7553, obj_t BgL_pz00_7554)
	{
		{	/* Ast/walk.scm 315 */
			{	/* Ast/walk.scm 315 */
				obj_t BgL_g1580z00_8888;

				BgL_g1580z00_8888 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7553)))->BgL_localsz00);
				{
					obj_t BgL_l1578z00_8890;

					BgL_l1578z00_8890 = BgL_g1580z00_8888;
				BgL_zc3z04anonymousza33320ze3z87_8889:
					if (PAIRP(BgL_l1578z00_8890))
						{	/* Ast/walk.scm 315 */
							{	/* Ast/walk.scm 315 */
								obj_t BgL_fz00_8891;

								BgL_fz00_8891 = CAR(BgL_l1578z00_8890);
								{	/* Ast/walk.scm 316 */
									obj_t BgL_arg3322z00_8892;

									BgL_arg3322z00_8892 =
										(((BgL_sfunz00_bglt) COBJECT(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) COBJECT(
																((BgL_variablez00_bglt) BgL_fz00_8891)))->
														BgL_valuez00))))->BgL_bodyz00);
									PROCEDURE_ENTRY(BgL_pz00_7554) (BgL_pz00_7554,
										BgL_arg3322z00_8892, BEOA);
								}
							}
							{
								obj_t BgL_l1578z00_11688;

								BgL_l1578z00_11688 = CDR(BgL_l1578z00_8890);
								BgL_l1578z00_8890 = BgL_l1578z00_11688;
								goto BgL_zc3z04anonymousza33320ze3z87_8889;
							}
						}
					else
						{	/* Ast/walk.scm 315 */
							((bool_t) 1);
						}
				}
			}
			{	/* Ast/walk.scm 315 */
				BgL_nodez00_bglt BgL_arg3325z00_8893;

				BgL_arg3325z00_8893 =
					(((BgL_letzd2funzd2_bglt) COBJECT(
							((BgL_letzd2funzd2_bglt) BgL_nz00_7553)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7554) (BgL_pz00_7554,
					((obj_t) BgL_arg3325z00_8893), BEOA);
			}
		}

	}



/* &walk3!-switch2118 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2switch2118za2zzast_walkz00(obj_t
		BgL_envz00_7555, obj_t BgL_nz00_7556, obj_t BgL_pz00_7557,
		obj_t BgL_arg0z00_7558, obj_t BgL_arg1z00_7559, obj_t BgL_arg2z00_7560)
	{
		{	/* Ast/walk.scm 312 */
			{
				BgL_nodez00_bglt BgL_auxz00_11697;

				{	/* Ast/walk.scm 312 */
					BgL_nodez00_bglt BgL_arg3309z00_8895;

					BgL_arg3309z00_8895 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7556)))->BgL_testz00);
					BgL_auxz00_11697 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7557) (BgL_pz00_7557,
							((obj_t) BgL_arg3309z00_8895), BgL_arg0z00_7558, BgL_arg1z00_7559,
							BgL_arg2z00_7560, BEOA));
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7556)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11697), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_8897;

				BgL_fieldsz00_8897 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7556)))->BgL_clausesz00);
			BgL_loopz00_8896:
				if (NULLP(BgL_fieldsz00_8897))
					{	/* Ast/walk.scm 312 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 312 */
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3313z00_8898;
							obj_t BgL_arg3314z00_8899;

							BgL_arg3313z00_8898 = CAR(((obj_t) BgL_fieldsz00_8897));
							{	/* Ast/walk.scm 312 */
								obj_t BgL_arg3317z00_8900;

								{	/* Ast/walk.scm 312 */
									obj_t BgL_pairz00_8901;

									BgL_pairz00_8901 = CAR(((obj_t) BgL_fieldsz00_8897));
									BgL_arg3317z00_8900 = CDR(BgL_pairz00_8901);
								}
								BgL_arg3314z00_8899 =
									PROCEDURE_ENTRY(BgL_pz00_7557) (BgL_pz00_7557,
									BgL_arg3317z00_8900, BgL_arg0z00_7558, BgL_arg1z00_7559,
									BgL_arg2z00_7560, BEOA);
							}
							{	/* Ast/walk.scm 312 */
								obj_t BgL_tmpz00_11725;

								BgL_tmpz00_11725 = ((obj_t) BgL_arg3313z00_8898);
								SET_CDR(BgL_tmpz00_11725, BgL_arg3314z00_8899);
							}
						}
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3319z00_8902;

							BgL_arg3319z00_8902 = CDR(((obj_t) BgL_fieldsz00_8897));
							{
								obj_t BgL_fieldsz00_11730;

								BgL_fieldsz00_11730 = BgL_arg3319z00_8902;
								BgL_fieldsz00_8897 = BgL_fieldsz00_11730;
								goto BgL_loopz00_8896;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nz00_7556));
		}

	}



/* &walk2!-switch2116 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2switch2116za2zzast_walkz00(obj_t
		BgL_envz00_7561, obj_t BgL_nz00_7562, obj_t BgL_pz00_7563,
		obj_t BgL_arg0z00_7564, obj_t BgL_arg1z00_7565)
	{
		{	/* Ast/walk.scm 312 */
			{
				BgL_nodez00_bglt BgL_auxz00_11735;

				{	/* Ast/walk.scm 312 */
					BgL_nodez00_bglt BgL_arg3289z00_8904;

					BgL_arg3289z00_8904 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7562)))->BgL_testz00);
					BgL_auxz00_11735 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7563) (BgL_pz00_7563,
							((obj_t) BgL_arg3289z00_8904), BgL_arg0z00_7564, BgL_arg1z00_7565,
							BEOA));
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7562)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11735), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_8906;

				BgL_fieldsz00_8906 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7562)))->BgL_clausesz00);
			BgL_loopz00_8905:
				if (NULLP(BgL_fieldsz00_8906))
					{	/* Ast/walk.scm 312 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 312 */
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3301z00_8907;
							obj_t BgL_arg3305z00_8908;

							BgL_arg3301z00_8907 = CAR(((obj_t) BgL_fieldsz00_8906));
							{	/* Ast/walk.scm 312 */
								obj_t BgL_arg3306z00_8909;

								{	/* Ast/walk.scm 312 */
									obj_t BgL_pairz00_8910;

									BgL_pairz00_8910 = CAR(((obj_t) BgL_fieldsz00_8906));
									BgL_arg3306z00_8909 = CDR(BgL_pairz00_8910);
								}
								BgL_arg3305z00_8908 =
									PROCEDURE_ENTRY(BgL_pz00_7563) (BgL_pz00_7563,
									BgL_arg3306z00_8909, BgL_arg0z00_7564, BgL_arg1z00_7565,
									BEOA);
							}
							{	/* Ast/walk.scm 312 */
								obj_t BgL_tmpz00_11761;

								BgL_tmpz00_11761 = ((obj_t) BgL_arg3301z00_8907);
								SET_CDR(BgL_tmpz00_11761, BgL_arg3305z00_8908);
							}
						}
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3308z00_8911;

							BgL_arg3308z00_8911 = CDR(((obj_t) BgL_fieldsz00_8906));
							{
								obj_t BgL_fieldsz00_11766;

								BgL_fieldsz00_11766 = BgL_arg3308z00_8911;
								BgL_fieldsz00_8906 = BgL_fieldsz00_11766;
								goto BgL_loopz00_8905;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nz00_7562));
		}

	}



/* &walk1!-switch2114 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2switch2114za2zzast_walkz00(obj_t
		BgL_envz00_7566, obj_t BgL_nz00_7567, obj_t BgL_pz00_7568,
		obj_t BgL_arg0z00_7569)
	{
		{	/* Ast/walk.scm 312 */
			{
				BgL_nodez00_bglt BgL_auxz00_11771;

				{	/* Ast/walk.scm 312 */
					BgL_nodez00_bglt BgL_arg3270z00_8913;

					BgL_arg3270z00_8913 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7567)))->BgL_testz00);
					BgL_auxz00_11771 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7568) (BgL_pz00_7568,
							((obj_t) BgL_arg3270z00_8913), BgL_arg0z00_7569, BEOA));
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7567)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11771), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_8915;

				BgL_fieldsz00_8915 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7567)))->BgL_clausesz00);
			BgL_loopz00_8914:
				if (NULLP(BgL_fieldsz00_8915))
					{	/* Ast/walk.scm 312 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 312 */
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3274z00_8916;
							obj_t BgL_arg3275z00_8917;

							BgL_arg3274z00_8916 = CAR(((obj_t) BgL_fieldsz00_8915));
							{	/* Ast/walk.scm 312 */
								obj_t BgL_arg3276z00_8918;

								{	/* Ast/walk.scm 312 */
									obj_t BgL_pairz00_8919;

									BgL_pairz00_8919 = CAR(((obj_t) BgL_fieldsz00_8915));
									BgL_arg3276z00_8918 = CDR(BgL_pairz00_8919);
								}
								BgL_arg3275z00_8917 =
									PROCEDURE_ENTRY(BgL_pz00_7568) (BgL_pz00_7568,
									BgL_arg3276z00_8918, BgL_arg0z00_7569, BEOA);
							}
							{	/* Ast/walk.scm 312 */
								obj_t BgL_tmpz00_11795;

								BgL_tmpz00_11795 = ((obj_t) BgL_arg3274z00_8916);
								SET_CDR(BgL_tmpz00_11795, BgL_arg3275z00_8917);
							}
						}
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3280z00_8920;

							BgL_arg3280z00_8920 = CDR(((obj_t) BgL_fieldsz00_8915));
							{
								obj_t BgL_fieldsz00_11800;

								BgL_fieldsz00_11800 = BgL_arg3280z00_8920;
								BgL_fieldsz00_8915 = BgL_fieldsz00_11800;
								goto BgL_loopz00_8914;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nz00_7567));
		}

	}



/* &walk0!-switch2112 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2switch2112za2zzast_walkz00(obj_t
		BgL_envz00_7570, obj_t BgL_nz00_7571, obj_t BgL_pz00_7572)
	{
		{	/* Ast/walk.scm 312 */
			{
				BgL_nodez00_bglt BgL_auxz00_11805;

				{	/* Ast/walk.scm 312 */
					BgL_nodez00_bglt BgL_arg3261z00_8922;

					BgL_arg3261z00_8922 =
						(((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7571)))->BgL_testz00);
					BgL_auxz00_11805 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7572) (BgL_pz00_7572,
							((obj_t) BgL_arg3261z00_8922), BEOA));
				}
				((((BgL_switchz00_bglt) COBJECT(
								((BgL_switchz00_bglt) BgL_nz00_7571)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_11805), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_8924;

				BgL_fieldsz00_8924 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7571)))->BgL_clausesz00);
			BgL_loopz00_8923:
				if (NULLP(BgL_fieldsz00_8924))
					{	/* Ast/walk.scm 312 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 312 */
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3265z00_8925;
							obj_t BgL_arg3266z00_8926;

							BgL_arg3265z00_8925 = CAR(((obj_t) BgL_fieldsz00_8924));
							{	/* Ast/walk.scm 312 */
								obj_t BgL_arg3267z00_8927;

								{	/* Ast/walk.scm 312 */
									obj_t BgL_pairz00_8928;

									BgL_pairz00_8928 = CAR(((obj_t) BgL_fieldsz00_8924));
									BgL_arg3267z00_8927 = CDR(BgL_pairz00_8928);
								}
								BgL_arg3266z00_8926 =
									PROCEDURE_ENTRY(BgL_pz00_7572) (BgL_pz00_7572,
									BgL_arg3267z00_8927, BEOA);
							}
							{	/* Ast/walk.scm 312 */
								obj_t BgL_tmpz00_11827;

								BgL_tmpz00_11827 = ((obj_t) BgL_arg3265z00_8925);
								SET_CDR(BgL_tmpz00_11827, BgL_arg3266z00_8926);
							}
						}
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3269z00_8929;

							BgL_arg3269z00_8929 = CDR(((obj_t) BgL_fieldsz00_8924));
							{
								obj_t BgL_fieldsz00_11832;

								BgL_fieldsz00_11832 = BgL_arg3269z00_8929;
								BgL_fieldsz00_8924 = BgL_fieldsz00_11832;
								goto BgL_loopz00_8923;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_switchz00_bglt) BgL_nz00_7571));
		}

	}



/* &walk3*-switch2110 */
	obj_t BGl_z62walk3za2zd2switch2110z12zzast_walkz00(obj_t BgL_envz00_7573,
		obj_t BgL_nz00_7574, obj_t BgL_pz00_7575, obj_t BgL_arg0z00_7576,
		obj_t BgL_arg1z00_7577, obj_t BgL_arg2z00_7578)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				obj_t BgL_res4018z00_8934;

				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3251z00_8931;
					obj_t BgL_arg3252z00_8932;

					{	/* Ast/walk.scm 312 */
						BgL_nodez00_bglt BgL_arg3253z00_8933;

						BgL_arg3253z00_8933 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_7574)))->BgL_testz00);
						BgL_arg3251z00_8931 =
							PROCEDURE_ENTRY(BgL_pz00_7575) (BgL_pz00_7575,
							((obj_t) BgL_arg3253z00_8933), BgL_arg0z00_7576, BgL_arg1z00_7577,
							BgL_arg2z00_7578, BEOA);
					}
					BgL_arg3252z00_8932 =
						BGl_zc3z04anonymousza33254ze3ze70z60zzast_walkz00(BgL_arg2z00_7578,
						BgL_arg1z00_7577, BgL_arg0z00_7576, BgL_pz00_7575,
						(((BgL_switchz00_bglt) COBJECT(((BgL_switchz00_bglt)
										BgL_nz00_7574)))->BgL_clausesz00));
					BgL_res4018z00_8934 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3251z00_8931,
						BgL_arg3252z00_8932);
				}
				return BgL_res4018z00_8934;
			}
		}

	}



/* <@anonymous:3254>~0 */
	obj_t BGl_zc3z04anonymousza33254ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8630, obj_t BgL_arg1z00_8629, obj_t BgL_arg0z00_8628,
		obj_t BgL_pz00_8627, obj_t BgL_l1576z00_5162)
	{
		{	/* Ast/walk.scm 312 */
			if (NULLP(BgL_l1576z00_5162))
				{	/* Ast/walk.scm 312 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3256z00_5165;
					obj_t BgL_arg3257z00_5166;

					{	/* Ast/walk.scm 312 */
						obj_t BgL_fz00_5167;

						BgL_fz00_5167 = CAR(((obj_t) BgL_l1576z00_5162));
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3258z00_5168;

							BgL_arg3258z00_5168 = CDR(((obj_t) BgL_fz00_5167));
							BgL_arg3256z00_5165 =
								PROCEDURE_ENTRY(BgL_pz00_8627) (BgL_pz00_8627,
								BgL_arg3258z00_5168, BgL_arg0z00_8628, BgL_arg1z00_8629,
								BgL_arg2z00_8630, BEOA);
						}
					}
					{	/* Ast/walk.scm 312 */
						obj_t BgL_arg3260z00_5169;

						BgL_arg3260z00_5169 = CDR(((obj_t) BgL_l1576z00_5162));
						BgL_arg3257z00_5166 =
							BGl_zc3z04anonymousza33254ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8630, BgL_arg1z00_8629, BgL_arg0z00_8628,
							BgL_pz00_8627, BgL_arg3260z00_5169);
					}
					return bgl_append2(BgL_arg3256z00_5165, BgL_arg3257z00_5166);
				}
		}

	}



/* &walk2*-switch2108 */
	obj_t BGl_z62walk2za2zd2switch2108z12zzast_walkz00(obj_t BgL_envz00_7579,
		obj_t BgL_nz00_7580, obj_t BgL_pz00_7581, obj_t BgL_arg0z00_7582,
		obj_t BgL_arg1z00_7583)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				obj_t BgL_res4019z00_8939;

				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3238z00_8936;
					obj_t BgL_arg3239z00_8937;

					{	/* Ast/walk.scm 312 */
						BgL_nodez00_bglt BgL_arg3243z00_8938;

						BgL_arg3243z00_8938 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_7580)))->BgL_testz00);
						BgL_arg3238z00_8936 =
							PROCEDURE_ENTRY(BgL_pz00_7581) (BgL_pz00_7581,
							((obj_t) BgL_arg3243z00_8938), BgL_arg0z00_7582, BgL_arg1z00_7583,
							BEOA);
					}
					BgL_arg3239z00_8937 =
						BGl_zc3z04anonymousza33244ze3ze70z60zzast_walkz00(BgL_arg1z00_7583,
						BgL_arg0z00_7582, BgL_pz00_7581,
						(((BgL_switchz00_bglt) COBJECT(((BgL_switchz00_bglt)
										BgL_nz00_7580)))->BgL_clausesz00));
					BgL_res4019z00_8939 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3238z00_8936,
						BgL_arg3239z00_8937);
				}
				return BgL_res4019z00_8939;
			}
		}

	}



/* <@anonymous:3244>~0 */
	obj_t BGl_zc3z04anonymousza33244ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8626, obj_t BgL_arg0z00_8625, obj_t BgL_pz00_8624,
		obj_t BgL_l1573z00_5139)
	{
		{	/* Ast/walk.scm 312 */
			if (NULLP(BgL_l1573z00_5139))
				{	/* Ast/walk.scm 312 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3247z00_5142;
					obj_t BgL_arg3248z00_5143;

					{	/* Ast/walk.scm 312 */
						obj_t BgL_fz00_5144;

						BgL_fz00_5144 = CAR(((obj_t) BgL_l1573z00_5139));
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3249z00_5145;

							BgL_arg3249z00_5145 = CDR(((obj_t) BgL_fz00_5144));
							BgL_arg3247z00_5142 =
								PROCEDURE_ENTRY(BgL_pz00_8624) (BgL_pz00_8624,
								BgL_arg3249z00_5145, BgL_arg0z00_8625, BgL_arg1z00_8626, BEOA);
						}
					}
					{	/* Ast/walk.scm 312 */
						obj_t BgL_arg3250z00_5146;

						BgL_arg3250z00_5146 = CDR(((obj_t) BgL_l1573z00_5139));
						BgL_arg3248z00_5143 =
							BGl_zc3z04anonymousza33244ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8626, BgL_arg0z00_8625, BgL_pz00_8624,
							BgL_arg3250z00_5146);
					}
					return bgl_append2(BgL_arg3247z00_5142, BgL_arg3248z00_5143);
				}
		}

	}



/* &walk1*-switch2106 */
	obj_t BGl_z62walk1za2zd2switch2106z12zzast_walkz00(obj_t BgL_envz00_7584,
		obj_t BgL_nz00_7585, obj_t BgL_pz00_7586, obj_t BgL_arg0z00_7587)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				obj_t BgL_res4020z00_8944;

				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3219z00_8941;
					obj_t BgL_arg3220z00_8942;

					{	/* Ast/walk.scm 312 */
						BgL_nodez00_bglt BgL_arg3221z00_8943;

						BgL_arg3221z00_8943 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_7585)))->BgL_testz00);
						BgL_arg3219z00_8941 =
							PROCEDURE_ENTRY(BgL_pz00_7586) (BgL_pz00_7586,
							((obj_t) BgL_arg3221z00_8943), BgL_arg0z00_7587, BEOA);
					}
					BgL_arg3220z00_8942 =
						BGl_zc3z04anonymousza33222ze3ze70z60zzast_walkz00(BgL_arg0z00_7587,
						BgL_pz00_7586,
						(((BgL_switchz00_bglt) COBJECT(((BgL_switchz00_bglt)
										BgL_nz00_7585)))->BgL_clausesz00));
					BgL_res4020z00_8944 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3219z00_8941,
						BgL_arg3220z00_8942);
				}
				return BgL_res4020z00_8944;
			}
		}

	}



/* <@anonymous:3222>~0 */
	obj_t BGl_zc3z04anonymousza33222ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8623, obj_t BgL_pz00_8622, obj_t BgL_l1570z00_5117)
	{
		{	/* Ast/walk.scm 312 */
			if (NULLP(BgL_l1570z00_5117))
				{	/* Ast/walk.scm 312 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3224z00_5120;
					obj_t BgL_arg3225z00_5121;

					{	/* Ast/walk.scm 312 */
						obj_t BgL_fz00_5122;

						BgL_fz00_5122 = CAR(((obj_t) BgL_l1570z00_5117));
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3227z00_5123;

							BgL_arg3227z00_5123 = CDR(((obj_t) BgL_fz00_5122));
							BgL_arg3224z00_5120 =
								PROCEDURE_ENTRY(BgL_pz00_8622) (BgL_pz00_8622,
								BgL_arg3227z00_5123, BgL_arg0z00_8623, BEOA);
						}
					}
					{	/* Ast/walk.scm 312 */
						obj_t BgL_arg3229z00_5124;

						BgL_arg3229z00_5124 = CDR(((obj_t) BgL_l1570z00_5117));
						BgL_arg3225z00_5121 =
							BGl_zc3z04anonymousza33222ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8623, BgL_pz00_8622, BgL_arg3229z00_5124);
					}
					return bgl_append2(BgL_arg3224z00_5120, BgL_arg3225z00_5121);
				}
		}

	}



/* &walk0*-switch2104 */
	obj_t BGl_z62walk0za2zd2switch2104z12zzast_walkz00(obj_t BgL_envz00_7588,
		obj_t BgL_nz00_7589, obj_t BgL_pz00_7590)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				obj_t BgL_res4021z00_8949;

				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3208z00_8946;
					obj_t BgL_arg3209z00_8947;

					{	/* Ast/walk.scm 312 */
						BgL_nodez00_bglt BgL_arg3211z00_8948;

						BgL_arg3211z00_8948 =
							(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_7589)))->BgL_testz00);
						BgL_arg3208z00_8946 =
							PROCEDURE_ENTRY(BgL_pz00_7590) (BgL_pz00_7590,
							((obj_t) BgL_arg3211z00_8948), BEOA);
					}
					BgL_arg3209z00_8947 =
						BGl_zc3z04anonymousza33212ze3ze70z60zzast_walkz00(BgL_pz00_7590,
						(((BgL_switchz00_bglt) COBJECT(
									((BgL_switchz00_bglt) BgL_nz00_7589)))->BgL_clausesz00));
					BgL_res4021z00_8949 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3208z00_8946,
						BgL_arg3209z00_8947);
				}
				return BgL_res4021z00_8949;
			}
		}

	}



/* <@anonymous:3212>~0 */
	obj_t BGl_zc3z04anonymousza33212ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8621,
		obj_t BgL_l1567z00_5096)
	{
		{	/* Ast/walk.scm 312 */
			if (NULLP(BgL_l1567z00_5096))
				{	/* Ast/walk.scm 312 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 312 */
					obj_t BgL_arg3214z00_5099;
					obj_t BgL_arg3215z00_5100;

					{	/* Ast/walk.scm 312 */
						obj_t BgL_fz00_5101;

						BgL_fz00_5101 = CAR(((obj_t) BgL_l1567z00_5096));
						{	/* Ast/walk.scm 312 */
							obj_t BgL_arg3216z00_5102;

							BgL_arg3216z00_5102 = CDR(((obj_t) BgL_fz00_5101));
							BgL_arg3214z00_5099 =
								PROCEDURE_ENTRY(BgL_pz00_8621) (BgL_pz00_8621,
								BgL_arg3216z00_5102, BEOA);
						}
					}
					{	/* Ast/walk.scm 312 */
						obj_t BgL_arg3218z00_5103;

						BgL_arg3218z00_5103 = CDR(((obj_t) BgL_l1567z00_5096));
						BgL_arg3215z00_5100 =
							BGl_zc3z04anonymousza33212ze3ze70z60zzast_walkz00(BgL_pz00_8621,
							BgL_arg3218z00_5103);
					}
					return bgl_append2(BgL_arg3214z00_5099, BgL_arg3215z00_5100);
				}
		}

	}



/* &walk3-switch2102 */
	obj_t BGl_z62walk3zd2switch2102zb0zzast_walkz00(obj_t BgL_envz00_7591,
		obj_t BgL_nz00_7592, obj_t BgL_pz00_7593, obj_t BgL_arg0z00_7594,
		obj_t BgL_arg1z00_7595, obj_t BgL_arg2z00_7596)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				BgL_nodez00_bglt BgL_arg3203z00_8951;

				BgL_arg3203z00_8951 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7592)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_7593) (BgL_pz00_7593,
					((obj_t) BgL_arg3203z00_8951), BgL_arg0z00_7594, BgL_arg1z00_7595,
					BgL_arg2z00_7596, BEOA);
			}
			{	/* Ast/walk.scm 312 */
				obj_t BgL_g1565z00_8952;

				BgL_g1565z00_8952 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7592)))->BgL_clausesz00);
				{
					obj_t BgL_l1563z00_8954;

					{	/* Ast/walk.scm 312 */
						bool_t BgL_tmpz00_11961;

						BgL_l1563z00_8954 = BgL_g1565z00_8952;
					BgL_zc3z04anonymousza33204ze3z87_8953:
						if (PAIRP(BgL_l1563z00_8954))
							{	/* Ast/walk.scm 312 */
								{	/* Ast/walk.scm 312 */
									obj_t BgL_fz00_8955;

									BgL_fz00_8955 = CAR(BgL_l1563z00_8954);
									{	/* Ast/walk.scm 312 */
										obj_t BgL_arg3206z00_8956;

										BgL_arg3206z00_8956 = CDR(((obj_t) BgL_fz00_8955));
										PROCEDURE_ENTRY(BgL_pz00_7593) (BgL_pz00_7593,
											BgL_arg3206z00_8956, BgL_arg0z00_7594, BgL_arg1z00_7595,
											BgL_arg2z00_7596, BEOA);
									}
								}
								{
									obj_t BgL_l1563z00_11974;

									BgL_l1563z00_11974 = CDR(BgL_l1563z00_8954);
									BgL_l1563z00_8954 = BgL_l1563z00_11974;
									goto BgL_zc3z04anonymousza33204ze3z87_8953;
								}
							}
						else
							{	/* Ast/walk.scm 312 */
								BgL_tmpz00_11961 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_11961);
					}
				}
			}
		}

	}



/* &walk2-switch2100 */
	obj_t BGl_z62walk2zd2switch2100zb0zzast_walkz00(obj_t BgL_envz00_7597,
		obj_t BgL_nz00_7598, obj_t BgL_pz00_7599, obj_t BgL_arg0z00_7600,
		obj_t BgL_arg1z00_7601)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				BgL_nodez00_bglt BgL_arg3192z00_8958;

				BgL_arg3192z00_8958 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7598)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_7599) (BgL_pz00_7599,
					((obj_t) BgL_arg3192z00_8958), BgL_arg0z00_7600, BgL_arg1z00_7601,
					BEOA);
			}
			{	/* Ast/walk.scm 312 */
				obj_t BgL_g1562z00_8959;

				BgL_g1562z00_8959 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7598)))->BgL_clausesz00);
				{
					obj_t BgL_l1560z00_8961;

					{	/* Ast/walk.scm 312 */
						bool_t BgL_tmpz00_11988;

						BgL_l1560z00_8961 = BgL_g1562z00_8959;
					BgL_zc3z04anonymousza33193ze3z87_8960:
						if (PAIRP(BgL_l1560z00_8961))
							{	/* Ast/walk.scm 312 */
								{	/* Ast/walk.scm 312 */
									obj_t BgL_fz00_8962;

									BgL_fz00_8962 = CAR(BgL_l1560z00_8961);
									{	/* Ast/walk.scm 312 */
										obj_t BgL_arg3195z00_8963;

										BgL_arg3195z00_8963 = CDR(((obj_t) BgL_fz00_8962));
										PROCEDURE_ENTRY(BgL_pz00_7599) (BgL_pz00_7599,
											BgL_arg3195z00_8963, BgL_arg0z00_7600, BgL_arg1z00_7601,
											BEOA);
									}
								}
								{
									obj_t BgL_l1560z00_12000;

									BgL_l1560z00_12000 = CDR(BgL_l1560z00_8961);
									BgL_l1560z00_8961 = BgL_l1560z00_12000;
									goto BgL_zc3z04anonymousza33193ze3z87_8960;
								}
							}
						else
							{	/* Ast/walk.scm 312 */
								BgL_tmpz00_11988 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_11988);
					}
				}
			}
		}

	}



/* &walk1-switch2098 */
	obj_t BGl_z62walk1zd2switch2098zb0zzast_walkz00(obj_t BgL_envz00_7602,
		obj_t BgL_nz00_7603, obj_t BgL_pz00_7604, obj_t BgL_arg0z00_7605)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				BgL_nodez00_bglt BgL_arg3186z00_8965;

				BgL_arg3186z00_8965 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7603)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_7604) (BgL_pz00_7604,
					((obj_t) BgL_arg3186z00_8965), BgL_arg0z00_7605, BEOA);
			}
			{	/* Ast/walk.scm 312 */
				obj_t BgL_g1559z00_8966;

				BgL_g1559z00_8966 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7603)))->BgL_clausesz00);
				{
					obj_t BgL_l1557z00_8968;

					{	/* Ast/walk.scm 312 */
						bool_t BgL_tmpz00_12013;

						BgL_l1557z00_8968 = BgL_g1559z00_8966;
					BgL_zc3z04anonymousza33187ze3z87_8967:
						if (PAIRP(BgL_l1557z00_8968))
							{	/* Ast/walk.scm 312 */
								{	/* Ast/walk.scm 312 */
									obj_t BgL_fz00_8969;

									BgL_fz00_8969 = CAR(BgL_l1557z00_8968);
									{	/* Ast/walk.scm 312 */
										obj_t BgL_arg3189z00_8970;

										BgL_arg3189z00_8970 = CDR(((obj_t) BgL_fz00_8969));
										PROCEDURE_ENTRY(BgL_pz00_7604) (BgL_pz00_7604,
											BgL_arg3189z00_8970, BgL_arg0z00_7605, BEOA);
									}
								}
								{
									obj_t BgL_l1557z00_12024;

									BgL_l1557z00_12024 = CDR(BgL_l1557z00_8968);
									BgL_l1557z00_8968 = BgL_l1557z00_12024;
									goto BgL_zc3z04anonymousza33187ze3z87_8967;
								}
							}
						else
							{	/* Ast/walk.scm 312 */
								BgL_tmpz00_12013 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_12013);
					}
				}
			}
		}

	}



/* &walk0-switch2096 */
	obj_t BGl_z62walk0zd2switch2096zb0zzast_walkz00(obj_t BgL_envz00_7606,
		obj_t BgL_nz00_7607, obj_t BgL_pz00_7608)
	{
		{	/* Ast/walk.scm 312 */
			{	/* Ast/walk.scm 312 */
				BgL_nodez00_bglt BgL_arg3181z00_8972;

				BgL_arg3181z00_8972 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7607)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_7608) (BgL_pz00_7608,
					((obj_t) BgL_arg3181z00_8972), BEOA);
			}
			{	/* Ast/walk.scm 312 */
				obj_t BgL_g1556z00_8973;

				BgL_g1556z00_8973 =
					(((BgL_switchz00_bglt) COBJECT(
							((BgL_switchz00_bglt) BgL_nz00_7607)))->BgL_clausesz00);
				{
					obj_t BgL_l1554z00_8975;

					{	/* Ast/walk.scm 312 */
						bool_t BgL_tmpz00_12036;

						BgL_l1554z00_8975 = BgL_g1556z00_8973;
					BgL_zc3z04anonymousza33182ze3z87_8974:
						if (PAIRP(BgL_l1554z00_8975))
							{	/* Ast/walk.scm 312 */
								{	/* Ast/walk.scm 312 */
									obj_t BgL_fz00_8976;

									BgL_fz00_8976 = CAR(BgL_l1554z00_8975);
									{	/* Ast/walk.scm 312 */
										obj_t BgL_arg3184z00_8977;

										BgL_arg3184z00_8977 = CDR(((obj_t) BgL_fz00_8976));
										PROCEDURE_ENTRY(BgL_pz00_7608) (BgL_pz00_7608,
											BgL_arg3184z00_8977, BEOA);
									}
								}
								{
									obj_t BgL_l1554z00_12046;

									BgL_l1554z00_12046 = CDR(BgL_l1554z00_8975);
									BgL_l1554z00_8975 = BgL_l1554z00_12046;
									goto BgL_zc3z04anonymousza33182ze3z87_8974;
								}
							}
						else
							{	/* Ast/walk.scm 312 */
								BgL_tmpz00_12036 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_12036);
					}
				}
			}
		}

	}



/* &walk3!-sync2094 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2sync2094za2zzast_walkz00(obj_t
		BgL_envz00_7609, obj_t BgL_nz00_7610, obj_t BgL_pz00_7611,
		obj_t BgL_arg0z00_7612, obj_t BgL_arg1z00_7613, obj_t BgL_arg2z00_7614)
	{
		{	/* Ast/walk.scm 311 */
			{
				BgL_nodez00_bglt BgL_auxz00_12049;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3178z00_8979;

					BgL_arg3178z00_8979 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_mutexz00);
					BgL_auxz00_12049 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7611) (BgL_pz00_7611,
							((obj_t) BgL_arg3178z00_8979), BgL_arg0z00_7612, BgL_arg1z00_7613,
							BgL_arg2z00_7614, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12049), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12063;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3179z00_8980;

					BgL_arg3179z00_8980 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_prelockz00);
					BgL_auxz00_12063 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7611) (BgL_pz00_7611,
							((obj_t) BgL_arg3179z00_8980), BgL_arg0z00_7612, BgL_arg1z00_7613,
							BgL_arg2z00_7614, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12063), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12077;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3180z00_8981;

					BgL_arg3180z00_8981 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_bodyz00);
					BgL_auxz00_12077 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7611) (BgL_pz00_7611,
							((obj_t) BgL_arg3180z00_8981), BgL_arg0z00_7612, BgL_arg1z00_7613,
							BgL_arg2z00_7614, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7610)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12077), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nz00_7610));
		}

	}



/* &walk2!-sync2092 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2sync2092za2zzast_walkz00(obj_t
		BgL_envz00_7615, obj_t BgL_nz00_7616, obj_t BgL_pz00_7617,
		obj_t BgL_arg0z00_7618, obj_t BgL_arg1z00_7619)
	{
		{	/* Ast/walk.scm 311 */
			{
				BgL_nodez00_bglt BgL_auxz00_12093;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3175z00_8983;

					BgL_arg3175z00_8983 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_mutexz00);
					BgL_auxz00_12093 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7617) (BgL_pz00_7617,
							((obj_t) BgL_arg3175z00_8983), BgL_arg0z00_7618, BgL_arg1z00_7619,
							BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12093), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12106;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3176z00_8984;

					BgL_arg3176z00_8984 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_prelockz00);
					BgL_auxz00_12106 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7617) (BgL_pz00_7617,
							((obj_t) BgL_arg3176z00_8984), BgL_arg0z00_7618, BgL_arg1z00_7619,
							BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12106), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12119;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3177z00_8985;

					BgL_arg3177z00_8985 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_bodyz00);
					BgL_auxz00_12119 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7617) (BgL_pz00_7617,
							((obj_t) BgL_arg3177z00_8985), BgL_arg0z00_7618, BgL_arg1z00_7619,
							BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7616)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12119), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nz00_7616));
		}

	}



/* &walk1!-sync2090 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2sync2090za2zzast_walkz00(obj_t
		BgL_envz00_7620, obj_t BgL_nz00_7621, obj_t BgL_pz00_7622,
		obj_t BgL_arg0z00_7623)
	{
		{	/* Ast/walk.scm 311 */
			{
				BgL_nodez00_bglt BgL_auxz00_12134;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3171z00_8987;

					BgL_arg3171z00_8987 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_mutexz00);
					BgL_auxz00_12134 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7622) (BgL_pz00_7622,
							((obj_t) BgL_arg3171z00_8987), BgL_arg0z00_7623, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12134), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12146;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3172z00_8988;

					BgL_arg3172z00_8988 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_prelockz00);
					BgL_auxz00_12146 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7622) (BgL_pz00_7622,
							((obj_t) BgL_arg3172z00_8988), BgL_arg0z00_7623, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12146), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12158;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3174z00_8989;

					BgL_arg3174z00_8989 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_bodyz00);
					BgL_auxz00_12158 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7622) (BgL_pz00_7622,
							((obj_t) BgL_arg3174z00_8989), BgL_arg0z00_7623, BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7621)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12158), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nz00_7621));
		}

	}



/* &walk0!-sync2088 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2sync2088za2zzast_walkz00(obj_t
		BgL_envz00_7624, obj_t BgL_nz00_7625, obj_t BgL_pz00_7626)
	{
		{	/* Ast/walk.scm 311 */
			{
				BgL_nodez00_bglt BgL_auxz00_12172;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3159z00_8991;

					BgL_arg3159z00_8991 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_mutexz00);
					BgL_auxz00_12172 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7626) (BgL_pz00_7626,
							((obj_t) BgL_arg3159z00_8991), BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_mutexz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12172), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12183;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3162z00_8992;

					BgL_arg3162z00_8992 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_prelockz00);
					BgL_auxz00_12183 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7626) (BgL_pz00_7626,
							((obj_t) BgL_arg3162z00_8992), BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_prelockz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12183), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12194;

				{	/* Ast/walk.scm 311 */
					BgL_nodez00_bglt BgL_arg3168z00_8993;

					BgL_arg3168z00_8993 =
						(((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_bodyz00);
					BgL_auxz00_12194 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7626) (BgL_pz00_7626,
							((obj_t) BgL_arg3168z00_8993), BEOA));
				}
				((((BgL_syncz00_bglt) COBJECT(
								((BgL_syncz00_bglt) BgL_nz00_7625)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_12194), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_syncz00_bglt) BgL_nz00_7625));
		}

	}



/* &walk3*-sync2086 */
	obj_t BGl_z62walk3za2zd2sync2086z12zzast_walkz00(obj_t BgL_envz00_7627,
		obj_t BgL_nz00_7628, obj_t BgL_pz00_7629, obj_t BgL_arg0z00_7630,
		obj_t BgL_arg1z00_7631, obj_t BgL_arg2z00_7632)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				obj_t BgL_res4022z00_9004;

				{	/* Ast/walk.scm 311 */
					obj_t BgL_arg3148z00_8995;
					obj_t BgL_arg3150z00_8996;
					obj_t BgL_arg3151z00_8997;

					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3155z00_8998;

						BgL_arg3155z00_8998 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7628)))->BgL_mutexz00);
						BgL_arg3148z00_8995 =
							PROCEDURE_ENTRY(BgL_pz00_7629) (BgL_pz00_7629,
							((obj_t) BgL_arg3155z00_8998), BgL_arg0z00_7630, BgL_arg1z00_7631,
							BgL_arg2z00_7632, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3156z00_8999;

						BgL_arg3156z00_8999 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7628)))->BgL_prelockz00);
						BgL_arg3150z00_8996 =
							PROCEDURE_ENTRY(BgL_pz00_7629) (BgL_pz00_7629,
							((obj_t) BgL_arg3156z00_8999), BgL_arg0z00_7630, BgL_arg1z00_7631,
							BgL_arg2z00_7632, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3158z00_9000;

						BgL_arg3158z00_9000 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7628)))->BgL_bodyz00);
						BgL_arg3151z00_8997 =
							PROCEDURE_ENTRY(BgL_pz00_7629) (BgL_pz00_7629,
							((obj_t) BgL_arg3158z00_9000), BgL_arg0z00_7630, BgL_arg1z00_7631,
							BgL_arg2z00_7632, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						obj_t BgL_list3152z00_9001;

						{	/* Ast/walk.scm 311 */
							obj_t BgL_arg3153z00_9002;

							{	/* Ast/walk.scm 311 */
								obj_t BgL_arg3154z00_9003;

								BgL_arg3154z00_9003 =
									MAKE_YOUNG_PAIR(BgL_arg3151z00_8997, BNIL);
								BgL_arg3153z00_9002 =
									MAKE_YOUNG_PAIR(BgL_arg3150z00_8996, BgL_arg3154z00_9003);
							}
							BgL_list3152z00_9001 =
								MAKE_YOUNG_PAIR(BgL_arg3148z00_8995, BgL_arg3153z00_9002);
						}
						BgL_res4022z00_9004 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3152z00_9001);
					}
				}
				return BgL_res4022z00_9004;
			}
		}

	}



/* &walk2*-sync2084 */
	obj_t BGl_z62walk2za2zd2sync2084z12zzast_walkz00(obj_t BgL_envz00_7633,
		obj_t BgL_nz00_7634, obj_t BgL_pz00_7635, obj_t BgL_arg0z00_7636,
		obj_t BgL_arg1z00_7637)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				obj_t BgL_res4023z00_9015;

				{	/* Ast/walk.scm 311 */
					obj_t BgL_arg3137z00_9006;
					obj_t BgL_arg3140z00_9007;
					obj_t BgL_arg3141z00_9008;

					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3145z00_9009;

						BgL_arg3145z00_9009 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7634)))->BgL_mutexz00);
						BgL_arg3137z00_9006 =
							PROCEDURE_ENTRY(BgL_pz00_7635) (BgL_pz00_7635,
							((obj_t) BgL_arg3145z00_9009), BgL_arg0z00_7636, BgL_arg1z00_7637,
							BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3146z00_9010;

						BgL_arg3146z00_9010 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7634)))->BgL_prelockz00);
						BgL_arg3140z00_9007 =
							PROCEDURE_ENTRY(BgL_pz00_7635) (BgL_pz00_7635,
							((obj_t) BgL_arg3146z00_9010), BgL_arg0z00_7636, BgL_arg1z00_7637,
							BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3147z00_9011;

						BgL_arg3147z00_9011 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7634)))->BgL_bodyz00);
						BgL_arg3141z00_9008 =
							PROCEDURE_ENTRY(BgL_pz00_7635) (BgL_pz00_7635,
							((obj_t) BgL_arg3147z00_9011), BgL_arg0z00_7636, BgL_arg1z00_7637,
							BEOA);
					}
					{	/* Ast/walk.scm 311 */
						obj_t BgL_list3142z00_9012;

						{	/* Ast/walk.scm 311 */
							obj_t BgL_arg3143z00_9013;

							{	/* Ast/walk.scm 311 */
								obj_t BgL_arg3144z00_9014;

								BgL_arg3144z00_9014 =
									MAKE_YOUNG_PAIR(BgL_arg3141z00_9008, BNIL);
								BgL_arg3143z00_9013 =
									MAKE_YOUNG_PAIR(BgL_arg3140z00_9007, BgL_arg3144z00_9014);
							}
							BgL_list3142z00_9012 =
								MAKE_YOUNG_PAIR(BgL_arg3137z00_9006, BgL_arg3143z00_9013);
						}
						BgL_res4023z00_9015 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3142z00_9012);
					}
				}
				return BgL_res4023z00_9015;
			}
		}

	}



/* &walk1*-sync2082 */
	obj_t BGl_z62walk1za2zd2sync2082z12zzast_walkz00(obj_t BgL_envz00_7638,
		obj_t BgL_nz00_7639, obj_t BgL_pz00_7640, obj_t BgL_arg0z00_7641)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				obj_t BgL_res4024z00_9026;

				{	/* Ast/walk.scm 311 */
					obj_t BgL_arg3120z00_9017;
					obj_t BgL_arg3121z00_9018;
					obj_t BgL_arg3122z00_9019;

					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3127z00_9020;

						BgL_arg3127z00_9020 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7639)))->BgL_mutexz00);
						BgL_arg3120z00_9017 =
							PROCEDURE_ENTRY(BgL_pz00_7640) (BgL_pz00_7640,
							((obj_t) BgL_arg3127z00_9020), BgL_arg0z00_7641, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3129z00_9021;

						BgL_arg3129z00_9021 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7639)))->BgL_prelockz00);
						BgL_arg3121z00_9018 =
							PROCEDURE_ENTRY(BgL_pz00_7640) (BgL_pz00_7640,
							((obj_t) BgL_arg3129z00_9021), BgL_arg0z00_7641, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3132z00_9022;

						BgL_arg3132z00_9022 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7639)))->BgL_bodyz00);
						BgL_arg3122z00_9019 =
							PROCEDURE_ENTRY(BgL_pz00_7640) (BgL_pz00_7640,
							((obj_t) BgL_arg3132z00_9022), BgL_arg0z00_7641, BEOA);
					}
					{	/* Ast/walk.scm 311 */
						obj_t BgL_list3123z00_9023;

						{	/* Ast/walk.scm 311 */
							obj_t BgL_arg3124z00_9024;

							{	/* Ast/walk.scm 311 */
								obj_t BgL_arg3126z00_9025;

								BgL_arg3126z00_9025 =
									MAKE_YOUNG_PAIR(BgL_arg3122z00_9019, BNIL);
								BgL_arg3124z00_9024 =
									MAKE_YOUNG_PAIR(BgL_arg3121z00_9018, BgL_arg3126z00_9025);
							}
							BgL_list3123z00_9023 =
								MAKE_YOUNG_PAIR(BgL_arg3120z00_9017, BgL_arg3124z00_9024);
						}
						BgL_res4024z00_9026 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3123z00_9023);
					}
				}
				return BgL_res4024z00_9026;
			}
		}

	}



/* &walk0*-sync2080 */
	obj_t BGl_z62walk0za2zd2sync2080z12zzast_walkz00(obj_t BgL_envz00_7642,
		obj_t BgL_nz00_7643, obj_t BgL_pz00_7644)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				obj_t BgL_res4025z00_9037;

				{	/* Ast/walk.scm 311 */
					obj_t BgL_arg3109z00_9028;
					obj_t BgL_arg3110z00_9029;
					obj_t BgL_arg3112z00_9030;

					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3117z00_9031;

						BgL_arg3117z00_9031 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7643)))->BgL_mutexz00);
						BgL_arg3109z00_9028 =
							PROCEDURE_ENTRY(BgL_pz00_7644) (BgL_pz00_7644,
							((obj_t) BgL_arg3117z00_9031), BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3118z00_9032;

						BgL_arg3118z00_9032 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7643)))->BgL_prelockz00);
						BgL_arg3110z00_9029 =
							PROCEDURE_ENTRY(BgL_pz00_7644) (BgL_pz00_7644,
							((obj_t) BgL_arg3118z00_9032), BEOA);
					}
					{	/* Ast/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3119z00_9033;

						BgL_arg3119z00_9033 =
							(((BgL_syncz00_bglt) COBJECT(
									((BgL_syncz00_bglt) BgL_nz00_7643)))->BgL_bodyz00);
						BgL_arg3112z00_9030 =
							PROCEDURE_ENTRY(BgL_pz00_7644) (BgL_pz00_7644,
							((obj_t) BgL_arg3119z00_9033), BEOA);
					}
					{	/* Ast/walk.scm 311 */
						obj_t BgL_list3113z00_9034;

						{	/* Ast/walk.scm 311 */
							obj_t BgL_arg3115z00_9035;

							{	/* Ast/walk.scm 311 */
								obj_t BgL_arg3116z00_9036;

								BgL_arg3116z00_9036 =
									MAKE_YOUNG_PAIR(BgL_arg3112z00_9030, BNIL);
								BgL_arg3115z00_9035 =
									MAKE_YOUNG_PAIR(BgL_arg3110z00_9029, BgL_arg3116z00_9036);
							}
							BgL_list3113z00_9034 =
								MAKE_YOUNG_PAIR(BgL_arg3109z00_9028, BgL_arg3115z00_9035);
						}
						BgL_res4025z00_9037 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3113z00_9034);
					}
				}
				return BgL_res4025z00_9037;
			}
		}

	}



/* &walk3-sync2078 */
	obj_t BGl_z62walk3zd2sync2078zb0zzast_walkz00(obj_t BgL_envz00_7645,
		obj_t BgL_nz00_7646, obj_t BgL_pz00_7647, obj_t BgL_arg0z00_7648,
		obj_t BgL_arg1z00_7649, obj_t BgL_arg2z00_7650)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3096z00_9039;

				BgL_arg3096z00_9039 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7646)))->BgL_mutexz00);
				PROCEDURE_ENTRY(BgL_pz00_7647) (BgL_pz00_7647,
					((obj_t) BgL_arg3096z00_9039), BgL_arg0z00_7648, BgL_arg1z00_7649,
					BgL_arg2z00_7650, BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3100z00_9040;

				BgL_arg3100z00_9040 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7646)))->BgL_prelockz00);
				PROCEDURE_ENTRY(BgL_pz00_7647) (BgL_pz00_7647,
					((obj_t) BgL_arg3100z00_9040), BgL_arg0z00_7648, BgL_arg1z00_7649,
					BgL_arg2z00_7650, BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3108z00_9041;

				BgL_arg3108z00_9041 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7646)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7647) (BgL_pz00_7647,
					((obj_t) BgL_arg3108z00_9041), BgL_arg0z00_7648, BgL_arg1z00_7649,
					BgL_arg2z00_7650, BEOA);
			}
		}

	}



/* &walk2-sync2076 */
	obj_t BGl_z62walk2zd2sync2076zb0zzast_walkz00(obj_t BgL_envz00_7651,
		obj_t BgL_nz00_7652, obj_t BgL_pz00_7653, obj_t BgL_arg0z00_7654,
		obj_t BgL_arg1z00_7655)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3089z00_9043;

				BgL_arg3089z00_9043 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7652)))->BgL_mutexz00);
				PROCEDURE_ENTRY(BgL_pz00_7653) (BgL_pz00_7653,
					((obj_t) BgL_arg3089z00_9043), BgL_arg0z00_7654, BgL_arg1z00_7655,
					BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3091z00_9044;

				BgL_arg3091z00_9044 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7652)))->BgL_prelockz00);
				PROCEDURE_ENTRY(BgL_pz00_7653) (BgL_pz00_7653,
					((obj_t) BgL_arg3091z00_9044), BgL_arg0z00_7654, BgL_arg1z00_7655,
					BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3092z00_9045;

				BgL_arg3092z00_9045 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7652)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7653) (BgL_pz00_7653,
					((obj_t) BgL_arg3092z00_9045), BgL_arg0z00_7654, BgL_arg1z00_7655,
					BEOA);
			}
		}

	}



/* &walk1-sync2074 */
	obj_t BGl_z62walk1zd2sync2074zb0zzast_walkz00(obj_t BgL_envz00_7656,
		obj_t BgL_nz00_7657, obj_t BgL_pz00_7658, obj_t BgL_arg0z00_7659)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3086z00_9047;

				BgL_arg3086z00_9047 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7657)))->BgL_mutexz00);
				PROCEDURE_ENTRY(BgL_pz00_7658) (BgL_pz00_7658,
					((obj_t) BgL_arg3086z00_9047), BgL_arg0z00_7659, BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3087z00_9048;

				BgL_arg3087z00_9048 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7657)))->BgL_prelockz00);
				PROCEDURE_ENTRY(BgL_pz00_7658) (BgL_pz00_7658,
					((obj_t) BgL_arg3087z00_9048), BgL_arg0z00_7659, BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3088z00_9049;

				BgL_arg3088z00_9049 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7657)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7658) (BgL_pz00_7658,
					((obj_t) BgL_arg3088z00_9049), BgL_arg0z00_7659, BEOA);
			}
		}

	}



/* &walk0-sync2072 */
	obj_t BGl_z62walk0zd2sync2072zb0zzast_walkz00(obj_t BgL_envz00_7660,
		obj_t BgL_nz00_7661, obj_t BgL_pz00_7662)
	{
		{	/* Ast/walk.scm 311 */
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3083z00_9051;

				BgL_arg3083z00_9051 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7661)))->BgL_mutexz00);
				PROCEDURE_ENTRY(BgL_pz00_7662) (BgL_pz00_7662,
					((obj_t) BgL_arg3083z00_9051), BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3084z00_9052;

				BgL_arg3084z00_9052 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7661)))->BgL_prelockz00);
				PROCEDURE_ENTRY(BgL_pz00_7662) (BgL_pz00_7662,
					((obj_t) BgL_arg3084z00_9052), BEOA);
			}
			{	/* Ast/walk.scm 311 */
				BgL_nodez00_bglt BgL_arg3085z00_9053;

				BgL_arg3085z00_9053 =
					(((BgL_syncz00_bglt) COBJECT(
							((BgL_syncz00_bglt) BgL_nz00_7661)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7662) (BgL_pz00_7662,
					((obj_t) BgL_arg3085z00_9053), BEOA);
			}
		}

	}



/* &walk3!-box-set!2070 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2setz122070z62zzast_walkz00(obj_t
		BgL_envz00_7663, obj_t BgL_nz00_7664, obj_t BgL_pz00_7665,
		obj_t BgL_arg0z00_7666, obj_t BgL_arg1z00_7667, obj_t BgL_arg2z00_7668)
	{
		{	/* Ast/walk.scm 310 */
			{
				BgL_varz00_bglt BgL_auxz00_12427;

				{	/* Ast/walk.scm 310 */
					BgL_varz00_bglt BgL_arg3081z00_9055;

					BgL_arg3081z00_9055 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7664)))->BgL_varz00);
					BgL_auxz00_12427 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7665) (BgL_pz00_7665,
							((obj_t) BgL_arg3081z00_9055), BgL_arg0z00_7666, BgL_arg1z00_7667,
							BgL_arg2z00_7668, BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7664)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12427), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12441;

				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3082z00_9056;

					BgL_arg3082z00_9056 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7664)))->BgL_valuez00);
					BgL_auxz00_12441 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7665) (BgL_pz00_7665,
							((obj_t) BgL_arg3082z00_9056), BgL_arg0z00_7666, BgL_arg1z00_7667,
							BgL_arg2z00_7668, BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7664)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12441), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7664));
		}

	}



/* &walk2!-box-set!2068 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2setz122068z62zzast_walkz00(obj_t
		BgL_envz00_7669, obj_t BgL_nz00_7670, obj_t BgL_pz00_7671,
		obj_t BgL_arg0z00_7672, obj_t BgL_arg1z00_7673)
	{
		{	/* Ast/walk.scm 310 */
			{
				BgL_varz00_bglt BgL_auxz00_12457;

				{	/* Ast/walk.scm 310 */
					BgL_varz00_bglt BgL_arg3079z00_9058;

					BgL_arg3079z00_9058 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7670)))->BgL_varz00);
					BgL_auxz00_12457 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7671) (BgL_pz00_7671,
							((obj_t) BgL_arg3079z00_9058), BgL_arg0z00_7672, BgL_arg1z00_7673,
							BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7670)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12457), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12470;

				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3080z00_9059;

					BgL_arg3080z00_9059 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7670)))->BgL_valuez00);
					BgL_auxz00_12470 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7671) (BgL_pz00_7671,
							((obj_t) BgL_arg3080z00_9059), BgL_arg0z00_7672, BgL_arg1z00_7673,
							BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7670)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12470), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7670));
		}

	}



/* &walk1!-box-set!2066 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2setz122066z62zzast_walkz00(obj_t
		BgL_envz00_7674, obj_t BgL_nz00_7675, obj_t BgL_pz00_7676,
		obj_t BgL_arg0z00_7677)
	{
		{	/* Ast/walk.scm 310 */
			{
				BgL_varz00_bglt BgL_auxz00_12485;

				{	/* Ast/walk.scm 310 */
					BgL_varz00_bglt BgL_arg3077z00_9061;

					BgL_arg3077z00_9061 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7675)))->BgL_varz00);
					BgL_auxz00_12485 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7676) (BgL_pz00_7676,
							((obj_t) BgL_arg3077z00_9061), BgL_arg0z00_7677, BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7675)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12485), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12497;

				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3078z00_9062;

					BgL_arg3078z00_9062 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7675)))->BgL_valuez00);
					BgL_auxz00_12497 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7676) (BgL_pz00_7676,
							((obj_t) BgL_arg3078z00_9062), BgL_arg0z00_7677, BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7675)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12497), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7675));
		}

	}



/* &walk0!-box-set!2064 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2setz122064z62zzast_walkz00(obj_t
		BgL_envz00_7678, obj_t BgL_nz00_7679, obj_t BgL_pz00_7680)
	{
		{	/* Ast/walk.scm 310 */
			{
				BgL_varz00_bglt BgL_auxz00_12511;

				{	/* Ast/walk.scm 310 */
					BgL_varz00_bglt BgL_arg3073z00_9064;

					BgL_arg3073z00_9064 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7679)))->BgL_varz00);
					BgL_auxz00_12511 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7680) (BgL_pz00_7680,
							((obj_t) BgL_arg3073z00_9064), BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7679)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12511), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_12522;

				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3076z00_9065;

					BgL_arg3076z00_9065 =
						(((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7679)))->BgL_valuez00);
					BgL_auxz00_12522 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7680) (BgL_pz00_7680,
							((obj_t) BgL_arg3076z00_9065), BEOA));
				}
				((((BgL_boxzd2setz12zc0_bglt) COBJECT(
								((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7679)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12522), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7679));
		}

	}



/* &walk3*-box-set!2062 */
	obj_t BGl_z62walk3za2zd2boxzd2setz122062zd2zzast_walkz00(obj_t
		BgL_envz00_7681, obj_t BgL_nz00_7682, obj_t BgL_pz00_7683,
		obj_t BgL_arg0z00_7684, obj_t BgL_arg1z00_7685, obj_t BgL_arg2z00_7686)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				obj_t BgL_res4026z00_9071;

				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3067z00_9067;
					obj_t BgL_arg3070z00_9068;

					{	/* Ast/walk.scm 310 */
						BgL_varz00_bglt BgL_arg3071z00_9069;

						BgL_arg3071z00_9069 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7682)))->BgL_varz00);
						BgL_arg3067z00_9067 =
							PROCEDURE_ENTRY(BgL_pz00_7683) (BgL_pz00_7683,
							((obj_t) BgL_arg3071z00_9069), BgL_arg0z00_7684, BgL_arg1z00_7685,
							BgL_arg2z00_7686, BEOA);
					}
					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3072z00_9070;

						BgL_arg3072z00_9070 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7682)))->BgL_valuez00);
						BgL_arg3070z00_9068 =
							PROCEDURE_ENTRY(BgL_pz00_7683) (BgL_pz00_7683,
							((obj_t) BgL_arg3072z00_9070), BgL_arg0z00_7684, BgL_arg1z00_7685,
							BgL_arg2z00_7686, BEOA);
					}
					BgL_res4026z00_9071 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3067z00_9067,
						BgL_arg3070z00_9068);
				}
				return BgL_res4026z00_9071;
			}
		}

	}



/* &walk2*-box-set!2060 */
	obj_t BGl_z62walk2za2zd2boxzd2setz122060zd2zzast_walkz00(obj_t
		BgL_envz00_7687, obj_t BgL_nz00_7688, obj_t BgL_pz00_7689,
		obj_t BgL_arg0z00_7690, obj_t BgL_arg1z00_7691)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				obj_t BgL_res4027z00_9077;

				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3061z00_9073;
					obj_t BgL_arg3063z00_9074;

					{	/* Ast/walk.scm 310 */
						BgL_varz00_bglt BgL_arg3065z00_9075;

						BgL_arg3065z00_9075 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7688)))->BgL_varz00);
						BgL_arg3061z00_9073 =
							PROCEDURE_ENTRY(BgL_pz00_7689) (BgL_pz00_7689,
							((obj_t) BgL_arg3065z00_9075), BgL_arg0z00_7690, BgL_arg1z00_7691,
							BEOA);
					}
					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3066z00_9076;

						BgL_arg3066z00_9076 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7688)))->BgL_valuez00);
						BgL_arg3063z00_9074 =
							PROCEDURE_ENTRY(BgL_pz00_7689) (BgL_pz00_7689,
							((obj_t) BgL_arg3066z00_9076), BgL_arg0z00_7690, BgL_arg1z00_7691,
							BEOA);
					}
					BgL_res4027z00_9077 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3061z00_9073,
						BgL_arg3063z00_9074);
				}
				return BgL_res4027z00_9077;
			}
		}

	}



/* &walk1*-box-set!2058 */
	obj_t BGl_z62walk1za2zd2boxzd2setz122058zd2zzast_walkz00(obj_t
		BgL_envz00_7692, obj_t BgL_nz00_7693, obj_t BgL_pz00_7694,
		obj_t BgL_arg0z00_7695)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				obj_t BgL_res4028z00_9083;

				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3045z00_9079;
					obj_t BgL_arg3050z00_9080;

					{	/* Ast/walk.scm 310 */
						BgL_varz00_bglt BgL_arg3051z00_9081;

						BgL_arg3051z00_9081 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7693)))->BgL_varz00);
						BgL_arg3045z00_9079 =
							PROCEDURE_ENTRY(BgL_pz00_7694) (BgL_pz00_7694,
							((obj_t) BgL_arg3051z00_9081), BgL_arg0z00_7695, BEOA);
					}
					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3060z00_9082;

						BgL_arg3060z00_9082 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7693)))->BgL_valuez00);
						BgL_arg3050z00_9080 =
							PROCEDURE_ENTRY(BgL_pz00_7694) (BgL_pz00_7694,
							((obj_t) BgL_arg3060z00_9082), BgL_arg0z00_7695, BEOA);
					}
					BgL_res4028z00_9083 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3045z00_9079,
						BgL_arg3050z00_9080);
				}
				return BgL_res4028z00_9083;
			}
		}

	}



/* &walk0*-box-set!2056 */
	obj_t BGl_z62walk0za2zd2boxzd2setz122056zd2zzast_walkz00(obj_t
		BgL_envz00_7696, obj_t BgL_nz00_7697, obj_t BgL_pz00_7698)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				obj_t BgL_res4029z00_9089;

				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3041z00_9085;
					obj_t BgL_arg3042z00_9086;

					{	/* Ast/walk.scm 310 */
						BgL_varz00_bglt BgL_arg3043z00_9087;

						BgL_arg3043z00_9087 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7697)))->BgL_varz00);
						BgL_arg3041z00_9085 =
							PROCEDURE_ENTRY(BgL_pz00_7698) (BgL_pz00_7698,
							((obj_t) BgL_arg3043z00_9087), BEOA);
					}
					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3044z00_9088;

						BgL_arg3044z00_9088 =
							(((BgL_boxzd2setz12zc0_bglt) COBJECT(
									((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7697)))->BgL_valuez00);
						BgL_arg3042z00_9086 =
							PROCEDURE_ENTRY(BgL_pz00_7698) (BgL_pz00_7698,
							((obj_t) BgL_arg3044z00_9088), BEOA);
					}
					BgL_res4029z00_9089 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3041z00_9085,
						BgL_arg3042z00_9086);
				}
				return BgL_res4029z00_9089;
			}
		}

	}



/* &walk3-box-set!2054 */
	obj_t BGl_z62walk3zd2boxzd2setz122054z70zzast_walkz00(obj_t BgL_envz00_7699,
		obj_t BgL_nz00_7700, obj_t BgL_pz00_7701, obj_t BgL_arg0z00_7702,
		obj_t BgL_arg1z00_7703, obj_t BgL_arg2z00_7704)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				BgL_varz00_bglt BgL_arg3038z00_9091;

				BgL_arg3038z00_9091 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7700)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_7701) (BgL_pz00_7701,
					((obj_t) BgL_arg3038z00_9091), BgL_arg0z00_7702, BgL_arg1z00_7703,
					BgL_arg2z00_7704, BEOA);
			}
			{	/* Ast/walk.scm 310 */
				BgL_nodez00_bglt BgL_arg3040z00_9092;

				BgL_arg3040z00_9092 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7700)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7701) (BgL_pz00_7701,
					((obj_t) BgL_arg3040z00_9092), BgL_arg0z00_7702, BgL_arg1z00_7703,
					BgL_arg2z00_7704, BEOA);
			}
		}

	}



/* &walk2-box-set!2052 */
	obj_t BGl_z62walk2zd2boxzd2setz122052z70zzast_walkz00(obj_t BgL_envz00_7705,
		obj_t BgL_nz00_7706, obj_t BgL_pz00_7707, obj_t BgL_arg0z00_7708,
		obj_t BgL_arg1z00_7709)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				BgL_varz00_bglt BgL_arg3036z00_9094;

				BgL_arg3036z00_9094 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7706)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_7707) (BgL_pz00_7707,
					((obj_t) BgL_arg3036z00_9094), BgL_arg0z00_7708, BgL_arg1z00_7709,
					BEOA);
			}
			{	/* Ast/walk.scm 310 */
				BgL_nodez00_bglt BgL_arg3037z00_9095;

				BgL_arg3037z00_9095 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7706)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7707) (BgL_pz00_7707,
					((obj_t) BgL_arg3037z00_9095), BgL_arg0z00_7708, BgL_arg1z00_7709,
					BEOA);
			}
		}

	}



/* &walk1-box-set!2050 */
	obj_t BGl_z62walk1zd2boxzd2setz122050z70zzast_walkz00(obj_t BgL_envz00_7710,
		obj_t BgL_nz00_7711, obj_t BgL_pz00_7712, obj_t BgL_arg0z00_7713)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				BgL_varz00_bglt BgL_arg3034z00_9097;

				BgL_arg3034z00_9097 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7711)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_7712) (BgL_pz00_7712,
					((obj_t) BgL_arg3034z00_9097), BgL_arg0z00_7713, BEOA);
			}
			{	/* Ast/walk.scm 310 */
				BgL_nodez00_bglt BgL_arg3035z00_9098;

				BgL_arg3035z00_9098 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7711)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7712) (BgL_pz00_7712,
					((obj_t) BgL_arg3035z00_9098), BgL_arg0z00_7713, BEOA);
			}
		}

	}



/* &walk0-box-set!2048 */
	obj_t BGl_z62walk0zd2boxzd2setz122048z70zzast_walkz00(obj_t BgL_envz00_7714,
		obj_t BgL_nz00_7715, obj_t BgL_pz00_7716)
	{
		{	/* Ast/walk.scm 310 */
			{	/* Ast/walk.scm 310 */
				BgL_varz00_bglt BgL_arg3032z00_9100;

				BgL_arg3032z00_9100 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7715)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_7716) (BgL_pz00_7716,
					((obj_t) BgL_arg3032z00_9100), BEOA);
			}
			{	/* Ast/walk.scm 310 */
				BgL_nodez00_bglt BgL_arg3033z00_9101;

				BgL_arg3033z00_9101 =
					(((BgL_boxzd2setz12zc0_bglt) COBJECT(
							((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7715)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7716) (BgL_pz00_7716,
					((obj_t) BgL_arg3033z00_9101), BEOA);
			}
		}

	}



/* &walk3!-box-ref2046 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2ref2046z70zzast_walkz00(obj_t
		BgL_envz00_7717, obj_t BgL_nz00_7718, obj_t BgL_pz00_7719,
		obj_t BgL_arg0z00_7720, obj_t BgL_arg1z00_7721, obj_t BgL_arg2z00_7722)
	{
		{	/* Ast/walk.scm 309 */
			{
				BgL_varz00_bglt BgL_auxz00_12675;

				{	/* Ast/walk.scm 309 */
					BgL_varz00_bglt BgL_arg3031z00_9103;

					BgL_arg3031z00_9103 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7718)))->BgL_varz00);
					BgL_auxz00_12675 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7719) (BgL_pz00_7719,
							((obj_t) BgL_arg3031z00_9103), BgL_arg0z00_7720, BgL_arg1z00_7721,
							BgL_arg2z00_7722, BEOA));
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7718)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12675), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nz00_7718));
		}

	}



/* &walk2!-box-ref2044 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2ref2044z70zzast_walkz00(obj_t
		BgL_envz00_7723, obj_t BgL_nz00_7724, obj_t BgL_pz00_7725,
		obj_t BgL_arg0z00_7726, obj_t BgL_arg1z00_7727)
	{
		{	/* Ast/walk.scm 309 */
			{
				BgL_varz00_bglt BgL_auxz00_12691;

				{	/* Ast/walk.scm 309 */
					BgL_varz00_bglt BgL_arg3029z00_9105;

					BgL_arg3029z00_9105 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7724)))->BgL_varz00);
					BgL_auxz00_12691 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7725) (BgL_pz00_7725,
							((obj_t) BgL_arg3029z00_9105), BgL_arg0z00_7726, BgL_arg1z00_7727,
							BEOA));
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7724)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12691), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nz00_7724));
		}

	}



/* &walk1!-box-ref2042 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2ref2042z70zzast_walkz00(obj_t
		BgL_envz00_7728, obj_t BgL_nz00_7729, obj_t BgL_pz00_7730,
		obj_t BgL_arg0z00_7731)
	{
		{	/* Ast/walk.scm 309 */
			{
				BgL_varz00_bglt BgL_auxz00_12706;

				{	/* Ast/walk.scm 309 */
					BgL_varz00_bglt BgL_arg3028z00_9107;

					BgL_arg3028z00_9107 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7729)))->BgL_varz00);
					BgL_auxz00_12706 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7730) (BgL_pz00_7730,
							((obj_t) BgL_arg3028z00_9107), BgL_arg0z00_7731, BEOA));
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7729)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12706), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nz00_7729));
		}

	}



/* &walk0!-box-ref2040 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2ref2040z70zzast_walkz00(obj_t
		BgL_envz00_7732, obj_t BgL_nz00_7733, obj_t BgL_pz00_7734)
	{
		{	/* Ast/walk.scm 309 */
			{
				BgL_varz00_bglt BgL_auxz00_12720;

				{	/* Ast/walk.scm 309 */
					BgL_varz00_bglt BgL_arg3026z00_9109;

					BgL_arg3026z00_9109 =
						(((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7733)))->BgL_varz00);
					BgL_auxz00_12720 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7734) (BgL_pz00_7734,
							((obj_t) BgL_arg3026z00_9109), BEOA));
				}
				((((BgL_boxzd2refzd2_bglt) COBJECT(
								((BgL_boxzd2refzd2_bglt) BgL_nz00_7733)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_12720), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_boxzd2refzd2_bglt) BgL_nz00_7733));
		}

	}



/* &walk3*-box-ref2038 */
	obj_t BGl_z62walk3za2zd2boxzd2ref2038zc0zzast_walkz00(obj_t BgL_envz00_7735,
		obj_t BgL_nz00_7736, obj_t BgL_pz00_7737, obj_t BgL_arg0z00_7738,
		obj_t BgL_arg1z00_7739, obj_t BgL_arg2z00_7740)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				obj_t BgL_res4030z00_9114;

				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg3023z00_9111;

					{	/* Ast/walk.scm 309 */
						BgL_varz00_bglt BgL_arg3025z00_9112;

						BgL_arg3025z00_9112 =
							(((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nz00_7736)))->BgL_varz00);
						BgL_arg3023z00_9111 =
							PROCEDURE_ENTRY(BgL_pz00_7737) (BgL_pz00_7737,
							((obj_t) BgL_arg3025z00_9112), BgL_arg0z00_7738, BgL_arg1z00_7739,
							BgL_arg2z00_7740, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list3024z00_9113;

						BgL_list3024z00_9113 = MAKE_YOUNG_PAIR(BgL_arg3023z00_9111, BNIL);
						BgL_res4030z00_9114 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3024z00_9113);
					}
				}
				return BgL_res4030z00_9114;
			}
		}

	}



/* &walk2*-box-ref2036 */
	obj_t BGl_z62walk2za2zd2boxzd2ref2036zc0zzast_walkz00(obj_t BgL_envz00_7741,
		obj_t BgL_nz00_7742, obj_t BgL_pz00_7743, obj_t BgL_arg0z00_7744,
		obj_t BgL_arg1z00_7745)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				obj_t BgL_res4031z00_9119;

				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg3020z00_9116;

					{	/* Ast/walk.scm 309 */
						BgL_varz00_bglt BgL_arg3022z00_9117;

						BgL_arg3022z00_9117 =
							(((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nz00_7742)))->BgL_varz00);
						BgL_arg3020z00_9116 =
							PROCEDURE_ENTRY(BgL_pz00_7743) (BgL_pz00_7743,
							((obj_t) BgL_arg3022z00_9117), BgL_arg0z00_7744, BgL_arg1z00_7745,
							BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list3021z00_9118;

						BgL_list3021z00_9118 = MAKE_YOUNG_PAIR(BgL_arg3020z00_9116, BNIL);
						BgL_res4031z00_9119 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3021z00_9118);
					}
				}
				return BgL_res4031z00_9119;
			}
		}

	}



/* &walk1*-box-ref2034 */
	obj_t BGl_z62walk1za2zd2boxzd2ref2034zc0zzast_walkz00(obj_t BgL_envz00_7746,
		obj_t BgL_nz00_7747, obj_t BgL_pz00_7748, obj_t BgL_arg0z00_7749)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				obj_t BgL_res4032z00_9124;

				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg3010z00_9121;

					{	/* Ast/walk.scm 309 */
						BgL_varz00_bglt BgL_arg3015z00_9122;

						BgL_arg3015z00_9122 =
							(((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nz00_7747)))->BgL_varz00);
						BgL_arg3010z00_9121 =
							PROCEDURE_ENTRY(BgL_pz00_7748) (BgL_pz00_7748,
							((obj_t) BgL_arg3015z00_9122), BgL_arg0z00_7749, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list3011z00_9123;

						BgL_list3011z00_9123 = MAKE_YOUNG_PAIR(BgL_arg3010z00_9121, BNIL);
						BgL_res4032z00_9124 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3011z00_9123);
					}
				}
				return BgL_res4032z00_9124;
			}
		}

	}



/* &walk0*-box-ref2032 */
	obj_t BGl_z62walk0za2zd2boxzd2ref2032zc0zzast_walkz00(obj_t BgL_envz00_7750,
		obj_t BgL_nz00_7751, obj_t BgL_pz00_7752)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				obj_t BgL_res4033z00_9129;

				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg3002z00_9126;

					{	/* Ast/walk.scm 309 */
						BgL_varz00_bglt BgL_arg3009z00_9127;

						BgL_arg3009z00_9127 =
							(((BgL_boxzd2refzd2_bglt) COBJECT(
									((BgL_boxzd2refzd2_bglt) BgL_nz00_7751)))->BgL_varz00);
						BgL_arg3002z00_9126 =
							PROCEDURE_ENTRY(BgL_pz00_7752) (BgL_pz00_7752,
							((obj_t) BgL_arg3009z00_9127), BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list3003z00_9128;

						BgL_list3003z00_9128 = MAKE_YOUNG_PAIR(BgL_arg3002z00_9126, BNIL);
						BgL_res4033z00_9129 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list3003z00_9128);
					}
				}
				return BgL_res4033z00_9129;
			}
		}

	}



/* &walk3-box-ref2030 */
	obj_t BGl_z62walk3zd2boxzd2ref2030z62zzast_walkz00(obj_t BgL_envz00_7753,
		obj_t BgL_nz00_7754, obj_t BgL_pz00_7755, obj_t BgL_arg0z00_7756,
		obj_t BgL_arg1z00_7757, obj_t BgL_arg2z00_7758)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				BgL_varz00_bglt BgL_arg2999z00_9131;

				BgL_arg2999z00_9131 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nz00_7754)))->BgL_varz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7755) (BgL_pz00_7755,
					((obj_t) BgL_arg2999z00_9131), BgL_arg0z00_7756, BgL_arg1z00_7757,
					BgL_arg2z00_7758, BEOA);
			}
		}

	}



/* &walk2-box-ref2028 */
	obj_t BGl_z62walk2zd2boxzd2ref2028z62zzast_walkz00(obj_t BgL_envz00_7759,
		obj_t BgL_nz00_7760, obj_t BgL_pz00_7761, obj_t BgL_arg0z00_7762,
		obj_t BgL_arg1z00_7763)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				BgL_varz00_bglt BgL_arg2998z00_9133;

				BgL_arg2998z00_9133 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nz00_7760)))->BgL_varz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7761) (BgL_pz00_7761,
					((obj_t) BgL_arg2998z00_9133), BgL_arg0z00_7762, BgL_arg1z00_7763,
					BEOA);
			}
		}

	}



/* &walk1-box-ref2026 */
	obj_t BGl_z62walk1zd2boxzd2ref2026z62zzast_walkz00(obj_t BgL_envz00_7764,
		obj_t BgL_nz00_7765, obj_t BgL_pz00_7766, obj_t BgL_arg0z00_7767)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				BgL_varz00_bglt BgL_arg2997z00_9135;

				BgL_arg2997z00_9135 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nz00_7765)))->BgL_varz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7766) (BgL_pz00_7766,
					((obj_t) BgL_arg2997z00_9135), BgL_arg0z00_7767, BEOA);
			}
		}

	}



/* &walk0-box-ref2024 */
	obj_t BGl_z62walk0zd2boxzd2ref2024z62zzast_walkz00(obj_t BgL_envz00_7768,
		obj_t BgL_nz00_7769, obj_t BgL_pz00_7770)
	{
		{	/* Ast/walk.scm 309 */
			{	/* Ast/walk.scm 309 */
				BgL_varz00_bglt BgL_arg2995z00_9137;

				BgL_arg2995z00_9137 =
					(((BgL_boxzd2refzd2_bglt) COBJECT(
							((BgL_boxzd2refzd2_bglt) BgL_nz00_7769)))->BgL_varz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7770) (BgL_pz00_7770,
					((obj_t) BgL_arg2995z00_9137), BEOA);
			}
		}

	}



/* &walk3!-make-box2022 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2makezd2box2022z70zzast_walkz00(obj_t
		BgL_envz00_7771, obj_t BgL_nz00_7772, obj_t BgL_pz00_7773,
		obj_t BgL_arg0z00_7774, obj_t BgL_arg1z00_7775, obj_t BgL_arg2z00_7776)
	{
		{	/* Ast/walk.scm 308 */
			{
				BgL_nodez00_bglt BgL_auxz00_12809;

				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2994z00_9139;

					BgL_arg2994z00_9139 =
						(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7772)))->BgL_valuez00);
					BgL_auxz00_12809 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7773) (BgL_pz00_7773,
							((obj_t) BgL_arg2994z00_9139), BgL_arg0z00_7774, BgL_arg1z00_7775,
							BgL_arg2z00_7776, BEOA));
				}
				((((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7772)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12809), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nz00_7772));
		}

	}



/* &walk2!-make-box2020 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2makezd2box2020z70zzast_walkz00(obj_t
		BgL_envz00_7777, obj_t BgL_nz00_7778, obj_t BgL_pz00_7779,
		obj_t BgL_arg0z00_7780, obj_t BgL_arg1z00_7781)
	{
		{	/* Ast/walk.scm 308 */
			{
				BgL_nodez00_bglt BgL_auxz00_12825;

				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2993z00_9141;

					BgL_arg2993z00_9141 =
						(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7778)))->BgL_valuez00);
					BgL_auxz00_12825 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7779) (BgL_pz00_7779,
							((obj_t) BgL_arg2993z00_9141), BgL_arg0z00_7780, BgL_arg1z00_7781,
							BEOA));
				}
				((((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7778)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12825), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nz00_7778));
		}

	}



/* &walk1!-make-box2018 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2makezd2box2018z70zzast_walkz00(obj_t
		BgL_envz00_7782, obj_t BgL_nz00_7783, obj_t BgL_pz00_7784,
		obj_t BgL_arg0z00_7785)
	{
		{	/* Ast/walk.scm 308 */
			{
				BgL_nodez00_bglt BgL_auxz00_12840;

				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2992z00_9143;

					BgL_arg2992z00_9143 =
						(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7783)))->BgL_valuez00);
					BgL_auxz00_12840 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7784) (BgL_pz00_7784,
							((obj_t) BgL_arg2992z00_9143), BgL_arg0z00_7785, BEOA));
				}
				((((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7783)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12840), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nz00_7783));
		}

	}



/* &walk0!-make-box2016 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2makezd2box2016z70zzast_walkz00(obj_t
		BgL_envz00_7786, obj_t BgL_nz00_7787, obj_t BgL_pz00_7788)
	{
		{	/* Ast/walk.scm 308 */
			{
				BgL_nodez00_bglt BgL_auxz00_12854;

				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2991z00_9145;

					BgL_arg2991z00_9145 =
						(((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7787)))->BgL_valuez00);
					BgL_auxz00_12854 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7788) (BgL_pz00_7788,
							((obj_t) BgL_arg2991z00_9145), BEOA));
				}
				((((BgL_makezd2boxzd2_bglt) COBJECT(
								((BgL_makezd2boxzd2_bglt) BgL_nz00_7787)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12854), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_makezd2boxzd2_bglt) BgL_nz00_7787));
		}

	}



/* &walk3*-make-box2014 */
	obj_t BGl_z62walk3za2zd2makezd2box2014zc0zzast_walkz00(obj_t BgL_envz00_7789,
		obj_t BgL_nz00_7790, obj_t BgL_pz00_7791, obj_t BgL_arg0z00_7792,
		obj_t BgL_arg1z00_7793, obj_t BgL_arg2z00_7794)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				obj_t BgL_res4034z00_9150;

				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2988z00_9147;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2990z00_9148;

						BgL_arg2990z00_9148 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nz00_7790)))->BgL_valuez00);
						BgL_arg2988z00_9147 =
							PROCEDURE_ENTRY(BgL_pz00_7791) (BgL_pz00_7791,
							((obj_t) BgL_arg2990z00_9148), BgL_arg0z00_7792, BgL_arg1z00_7793,
							BgL_arg2z00_7794, BEOA);
					}
					{	/* Ast/walk.scm 308 */
						obj_t BgL_list2989z00_9149;

						BgL_list2989z00_9149 = MAKE_YOUNG_PAIR(BgL_arg2988z00_9147, BNIL);
						BgL_res4034z00_9150 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2989z00_9149);
					}
				}
				return BgL_res4034z00_9150;
			}
		}

	}



/* &walk2*-make-box2012 */
	obj_t BGl_z62walk2za2zd2makezd2box2012zc0zzast_walkz00(obj_t BgL_envz00_7795,
		obj_t BgL_nz00_7796, obj_t BgL_pz00_7797, obj_t BgL_arg0z00_7798,
		obj_t BgL_arg1z00_7799)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				obj_t BgL_res4035z00_9155;

				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2985z00_9152;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2987z00_9153;

						BgL_arg2987z00_9153 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nz00_7796)))->BgL_valuez00);
						BgL_arg2985z00_9152 =
							PROCEDURE_ENTRY(BgL_pz00_7797) (BgL_pz00_7797,
							((obj_t) BgL_arg2987z00_9153), BgL_arg0z00_7798, BgL_arg1z00_7799,
							BEOA);
					}
					{	/* Ast/walk.scm 308 */
						obj_t BgL_list2986z00_9154;

						BgL_list2986z00_9154 = MAKE_YOUNG_PAIR(BgL_arg2985z00_9152, BNIL);
						BgL_res4035z00_9155 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2986z00_9154);
					}
				}
				return BgL_res4035z00_9155;
			}
		}

	}



/* &walk1*-make-box2010 */
	obj_t BGl_z62walk1za2zd2makezd2box2010zc0zzast_walkz00(obj_t BgL_envz00_7800,
		obj_t BgL_nz00_7801, obj_t BgL_pz00_7802, obj_t BgL_arg0z00_7803)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				obj_t BgL_res4036z00_9160;

				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2980z00_9157;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2984z00_9158;

						BgL_arg2984z00_9158 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nz00_7801)))->BgL_valuez00);
						BgL_arg2980z00_9157 =
							PROCEDURE_ENTRY(BgL_pz00_7802) (BgL_pz00_7802,
							((obj_t) BgL_arg2984z00_9158), BgL_arg0z00_7803, BEOA);
					}
					{	/* Ast/walk.scm 308 */
						obj_t BgL_list2981z00_9159;

						BgL_list2981z00_9159 = MAKE_YOUNG_PAIR(BgL_arg2980z00_9157, BNIL);
						BgL_res4036z00_9160 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2981z00_9159);
					}
				}
				return BgL_res4036z00_9160;
			}
		}

	}



/* &walk0*-make-box2008 */
	obj_t BGl_z62walk0za2zd2makezd2box2008zc0zzast_walkz00(obj_t BgL_envz00_7804,
		obj_t BgL_nz00_7805, obj_t BgL_pz00_7806)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				obj_t BgL_res4037z00_9165;

				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2977z00_9162;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2979z00_9163;

						BgL_arg2979z00_9163 =
							(((BgL_makezd2boxzd2_bglt) COBJECT(
									((BgL_makezd2boxzd2_bglt) BgL_nz00_7805)))->BgL_valuez00);
						BgL_arg2977z00_9162 =
							PROCEDURE_ENTRY(BgL_pz00_7806) (BgL_pz00_7806,
							((obj_t) BgL_arg2979z00_9163), BEOA);
					}
					{	/* Ast/walk.scm 308 */
						obj_t BgL_list2978z00_9164;

						BgL_list2978z00_9164 = MAKE_YOUNG_PAIR(BgL_arg2977z00_9162, BNIL);
						BgL_res4037z00_9165 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2978z00_9164);
					}
				}
				return BgL_res4037z00_9165;
			}
		}

	}



/* &walk3-make-box2005 */
	obj_t BGl_z62walk3zd2makezd2box2005z62zzast_walkz00(obj_t BgL_envz00_7807,
		obj_t BgL_nz00_7808, obj_t BgL_pz00_7809, obj_t BgL_arg0z00_7810,
		obj_t BgL_arg1z00_7811, obj_t BgL_arg2z00_7812)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				BgL_nodez00_bglt BgL_arg2976z00_9167;

				BgL_arg2976z00_9167 =
					(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nz00_7808)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7809) (BgL_pz00_7809,
					((obj_t) BgL_arg2976z00_9167), BgL_arg0z00_7810, BgL_arg1z00_7811,
					BgL_arg2z00_7812, BEOA);
			}
		}

	}



/* &walk2-make-box2003 */
	obj_t BGl_z62walk2zd2makezd2box2003z62zzast_walkz00(obj_t BgL_envz00_7813,
		obj_t BgL_nz00_7814, obj_t BgL_pz00_7815, obj_t BgL_arg0z00_7816,
		obj_t BgL_arg1z00_7817)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				BgL_nodez00_bglt BgL_arg2974z00_9169;

				BgL_arg2974z00_9169 =
					(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nz00_7814)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7815) (BgL_pz00_7815,
					((obj_t) BgL_arg2974z00_9169), BgL_arg0z00_7816, BgL_arg1z00_7817,
					BEOA);
			}
		}

	}



/* &walk1-make-box2001 */
	obj_t BGl_z62walk1zd2makezd2box2001z62zzast_walkz00(obj_t BgL_envz00_7818,
		obj_t BgL_nz00_7819, obj_t BgL_pz00_7820, obj_t BgL_arg0z00_7821)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				BgL_nodez00_bglt BgL_arg2972z00_9171;

				BgL_arg2972z00_9171 =
					(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nz00_7819)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7820) (BgL_pz00_7820,
					((obj_t) BgL_arg2972z00_9171), BgL_arg0z00_7821, BEOA);
			}
		}

	}



/* &walk0-make-box1999 */
	obj_t BGl_z62walk0zd2makezd2box1999z62zzast_walkz00(obj_t BgL_envz00_7822,
		obj_t BgL_nz00_7823, obj_t BgL_pz00_7824)
	{
		{	/* Ast/walk.scm 308 */
			{	/* Ast/walk.scm 308 */
				BgL_nodez00_bglt BgL_arg2971z00_9173;

				BgL_arg2971z00_9173 =
					(((BgL_makezd2boxzd2_bglt) COBJECT(
							((BgL_makezd2boxzd2_bglt) BgL_nz00_7823)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7824) (BgL_pz00_7824,
					((obj_t) BgL_arg2971z00_9173), BEOA);
			}
		}

	}



/* &walk3!-return1997 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2return1997za2zzast_walkz00(obj_t
		BgL_envz00_7825, obj_t BgL_nz00_7826, obj_t BgL_pz00_7827,
		obj_t BgL_arg0z00_7828, obj_t BgL_arg1z00_7829, obj_t BgL_arg2z00_7830)
	{
		{	/* Ast/walk.scm 307 */
			{
				BgL_nodez00_bglt BgL_auxz00_12943;

				{	/* Ast/walk.scm 307 */
					BgL_nodez00_bglt BgL_arg2968z00_9175;

					BgL_arg2968z00_9175 =
						(((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7826)))->BgL_valuez00);
					BgL_auxz00_12943 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7827) (BgL_pz00_7827,
							((obj_t) BgL_arg2968z00_9175), BgL_arg0z00_7828, BgL_arg1z00_7829,
							BgL_arg2z00_7830, BEOA));
				}
				((((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7826)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12943), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_returnz00_bglt) BgL_nz00_7826));
		}

	}



/* &walk2!-return1995 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2return1995za2zzast_walkz00(obj_t
		BgL_envz00_7831, obj_t BgL_nz00_7832, obj_t BgL_pz00_7833,
		obj_t BgL_arg0z00_7834, obj_t BgL_arg1z00_7835)
	{
		{	/* Ast/walk.scm 307 */
			{
				BgL_nodez00_bglt BgL_auxz00_12959;

				{	/* Ast/walk.scm 307 */
					BgL_nodez00_bglt BgL_arg2967z00_9177;

					BgL_arg2967z00_9177 =
						(((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7832)))->BgL_valuez00);
					BgL_auxz00_12959 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7833) (BgL_pz00_7833,
							((obj_t) BgL_arg2967z00_9177), BgL_arg0z00_7834, BgL_arg1z00_7835,
							BEOA));
				}
				((((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7832)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12959), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_returnz00_bglt) BgL_nz00_7832));
		}

	}



/* &walk1!-return1993 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2return1993za2zzast_walkz00(obj_t
		BgL_envz00_7836, obj_t BgL_nz00_7837, obj_t BgL_pz00_7838,
		obj_t BgL_arg0z00_7839)
	{
		{	/* Ast/walk.scm 307 */
			{
				BgL_nodez00_bglt BgL_auxz00_12974;

				{	/* Ast/walk.scm 307 */
					BgL_nodez00_bglt BgL_arg2966z00_9179;

					BgL_arg2966z00_9179 =
						(((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7837)))->BgL_valuez00);
					BgL_auxz00_12974 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7838) (BgL_pz00_7838,
							((obj_t) BgL_arg2966z00_9179), BgL_arg0z00_7839, BEOA));
				}
				((((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7837)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12974), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_returnz00_bglt) BgL_nz00_7837));
		}

	}



/* &walk0!-return1991 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2return1991za2zzast_walkz00(obj_t
		BgL_envz00_7840, obj_t BgL_nz00_7841, obj_t BgL_pz00_7842)
	{
		{	/* Ast/walk.scm 307 */
			{
				BgL_nodez00_bglt BgL_auxz00_12988;

				{	/* Ast/walk.scm 307 */
					BgL_nodez00_bglt BgL_arg2965z00_9181;

					BgL_arg2965z00_9181 =
						(((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7841)))->BgL_valuez00);
					BgL_auxz00_12988 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7842) (BgL_pz00_7842,
							((obj_t) BgL_arg2965z00_9181), BEOA));
				}
				((((BgL_returnz00_bglt) COBJECT(
								((BgL_returnz00_bglt) BgL_nz00_7841)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_12988), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_returnz00_bglt) BgL_nz00_7841));
		}

	}



/* &walk3*-return1989 */
	obj_t BGl_z62walk3za2zd2return1989z12zzast_walkz00(obj_t BgL_envz00_7843,
		obj_t BgL_nz00_7844, obj_t BgL_pz00_7845, obj_t BgL_arg0z00_7846,
		obj_t BgL_arg1z00_7847, obj_t BgL_arg2z00_7848)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				obj_t BgL_res4038z00_9186;

				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2962z00_9183;

					{	/* Ast/walk.scm 307 */
						BgL_nodez00_bglt BgL_arg2964z00_9184;

						BgL_arg2964z00_9184 =
							(((BgL_returnz00_bglt) COBJECT(
									((BgL_returnz00_bglt) BgL_nz00_7844)))->BgL_valuez00);
						BgL_arg2962z00_9183 =
							PROCEDURE_ENTRY(BgL_pz00_7845) (BgL_pz00_7845,
							((obj_t) BgL_arg2964z00_9184), BgL_arg0z00_7846, BgL_arg1z00_7847,
							BgL_arg2z00_7848, BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2963z00_9185;

						BgL_list2963z00_9185 = MAKE_YOUNG_PAIR(BgL_arg2962z00_9183, BNIL);
						BgL_res4038z00_9186 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2963z00_9185);
					}
				}
				return BgL_res4038z00_9186;
			}
		}

	}



/* &walk2*-return1986 */
	obj_t BGl_z62walk2za2zd2return1986z12zzast_walkz00(obj_t BgL_envz00_7849,
		obj_t BgL_nz00_7850, obj_t BgL_pz00_7851, obj_t BgL_arg0z00_7852,
		obj_t BgL_arg1z00_7853)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				obj_t BgL_res4039z00_9191;

				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2959z00_9188;

					{	/* Ast/walk.scm 307 */
						BgL_nodez00_bglt BgL_arg2961z00_9189;

						BgL_arg2961z00_9189 =
							(((BgL_returnz00_bglt) COBJECT(
									((BgL_returnz00_bglt) BgL_nz00_7850)))->BgL_valuez00);
						BgL_arg2959z00_9188 =
							PROCEDURE_ENTRY(BgL_pz00_7851) (BgL_pz00_7851,
							((obj_t) BgL_arg2961z00_9189), BgL_arg0z00_7852, BgL_arg1z00_7853,
							BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2960z00_9190;

						BgL_list2960z00_9190 = MAKE_YOUNG_PAIR(BgL_arg2959z00_9188, BNIL);
						BgL_res4039z00_9191 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2960z00_9190);
					}
				}
				return BgL_res4039z00_9191;
			}
		}

	}



/* &walk1*-return1984 */
	obj_t BGl_z62walk1za2zd2return1984z12zzast_walkz00(obj_t BgL_envz00_7854,
		obj_t BgL_nz00_7855, obj_t BgL_pz00_7856, obj_t BgL_arg0z00_7857)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				obj_t BgL_res4040z00_9196;

				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2955z00_9193;

					{	/* Ast/walk.scm 307 */
						BgL_nodez00_bglt BgL_arg2957z00_9194;

						BgL_arg2957z00_9194 =
							(((BgL_returnz00_bglt) COBJECT(
									((BgL_returnz00_bglt) BgL_nz00_7855)))->BgL_valuez00);
						BgL_arg2955z00_9193 =
							PROCEDURE_ENTRY(BgL_pz00_7856) (BgL_pz00_7856,
							((obj_t) BgL_arg2957z00_9194), BgL_arg0z00_7857, BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2956z00_9195;

						BgL_list2956z00_9195 = MAKE_YOUNG_PAIR(BgL_arg2955z00_9193, BNIL);
						BgL_res4040z00_9196 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2956z00_9195);
					}
				}
				return BgL_res4040z00_9196;
			}
		}

	}



/* &walk0*-return1982 */
	obj_t BGl_z62walk0za2zd2return1982z12zzast_walkz00(obj_t BgL_envz00_7858,
		obj_t BgL_nz00_7859, obj_t BgL_pz00_7860)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				obj_t BgL_res4041z00_9201;

				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2952z00_9198;

					{	/* Ast/walk.scm 307 */
						BgL_nodez00_bglt BgL_arg2954z00_9199;

						BgL_arg2954z00_9199 =
							(((BgL_returnz00_bglt) COBJECT(
									((BgL_returnz00_bglt) BgL_nz00_7859)))->BgL_valuez00);
						BgL_arg2952z00_9198 =
							PROCEDURE_ENTRY(BgL_pz00_7860) (BgL_pz00_7860,
							((obj_t) BgL_arg2954z00_9199), BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2953z00_9200;

						BgL_list2953z00_9200 = MAKE_YOUNG_PAIR(BgL_arg2952z00_9198, BNIL);
						BgL_res4041z00_9201 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2953z00_9200);
					}
				}
				return BgL_res4041z00_9201;
			}
		}

	}



/* &walk3-return1980 */
	obj_t BGl_z62walk3zd2return1980zb0zzast_walkz00(obj_t BgL_envz00_7861,
		obj_t BgL_nz00_7862, obj_t BgL_pz00_7863, obj_t BgL_arg0z00_7864,
		obj_t BgL_arg1z00_7865, obj_t BgL_arg2z00_7866)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				BgL_nodez00_bglt BgL_arg2950z00_9203;

				BgL_arg2950z00_9203 =
					(((BgL_returnz00_bglt) COBJECT(
							((BgL_returnz00_bglt) BgL_nz00_7862)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7863) (BgL_pz00_7863,
					((obj_t) BgL_arg2950z00_9203), BgL_arg0z00_7864, BgL_arg1z00_7865,
					BgL_arg2z00_7866, BEOA);
			}
		}

	}



/* &walk2-return1978 */
	obj_t BGl_z62walk2zd2return1978zb0zzast_walkz00(obj_t BgL_envz00_7867,
		obj_t BgL_nz00_7868, obj_t BgL_pz00_7869, obj_t BgL_arg0z00_7870,
		obj_t BgL_arg1z00_7871)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				BgL_nodez00_bglt BgL_arg2949z00_9205;

				BgL_arg2949z00_9205 =
					(((BgL_returnz00_bglt) COBJECT(
							((BgL_returnz00_bglt) BgL_nz00_7868)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7869) (BgL_pz00_7869,
					((obj_t) BgL_arg2949z00_9205), BgL_arg0z00_7870, BgL_arg1z00_7871,
					BEOA);
			}
		}

	}



/* &walk1-return1976 */
	obj_t BGl_z62walk1zd2return1976zb0zzast_walkz00(obj_t BgL_envz00_7872,
		obj_t BgL_nz00_7873, obj_t BgL_pz00_7874, obj_t BgL_arg0z00_7875)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				BgL_nodez00_bglt BgL_arg2947z00_9207;

				BgL_arg2947z00_9207 =
					(((BgL_returnz00_bglt) COBJECT(
							((BgL_returnz00_bglt) BgL_nz00_7873)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7874) (BgL_pz00_7874,
					((obj_t) BgL_arg2947z00_9207), BgL_arg0z00_7875, BEOA);
			}
		}

	}



/* &walk0-return1973 */
	obj_t BGl_z62walk0zd2return1973zb0zzast_walkz00(obj_t BgL_envz00_7876,
		obj_t BgL_nz00_7877, obj_t BgL_pz00_7878)
	{
		{	/* Ast/walk.scm 307 */
			{	/* Ast/walk.scm 307 */
				BgL_nodez00_bglt BgL_arg2945z00_9209;

				BgL_arg2945z00_9209 =
					(((BgL_returnz00_bglt) COBJECT(
							((BgL_returnz00_bglt) BgL_nz00_7877)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7878) (BgL_pz00_7878,
					((obj_t) BgL_arg2945z00_9209), BEOA);
			}
		}

	}



/* &walk3!-retblock1971 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2retblock1971za2zzast_walkz00(obj_t
		BgL_envz00_7879, obj_t BgL_nz00_7880, obj_t BgL_pz00_7881,
		obj_t BgL_arg0z00_7882, obj_t BgL_arg1z00_7883, obj_t BgL_arg2z00_7884)
	{
		{	/* Ast/walk.scm 306 */
			{
				BgL_nodez00_bglt BgL_auxz00_13077;

				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2944z00_9211;

					BgL_arg2944z00_9211 =
						(((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7880)))->BgL_bodyz00);
					BgL_auxz00_13077 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7881) (BgL_pz00_7881,
							((obj_t) BgL_arg2944z00_9211), BgL_arg0z00_7882, BgL_arg1z00_7883,
							BgL_arg2z00_7884, BEOA));
				}
				((((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7880)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13077), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_retblockz00_bglt) BgL_nz00_7880));
		}

	}



/* &walk2!-retblock1969 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2retblock1969za2zzast_walkz00(obj_t
		BgL_envz00_7885, obj_t BgL_nz00_7886, obj_t BgL_pz00_7887,
		obj_t BgL_arg0z00_7888, obj_t BgL_arg1z00_7889)
	{
		{	/* Ast/walk.scm 306 */
			{
				BgL_nodez00_bglt BgL_auxz00_13093;

				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2943z00_9213;

					BgL_arg2943z00_9213 =
						(((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7886)))->BgL_bodyz00);
					BgL_auxz00_13093 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7887) (BgL_pz00_7887,
							((obj_t) BgL_arg2943z00_9213), BgL_arg0z00_7888, BgL_arg1z00_7889,
							BEOA));
				}
				((((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7886)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13093), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_retblockz00_bglt) BgL_nz00_7886));
		}

	}



/* &walk1!-retblock1967 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2retblock1967za2zzast_walkz00(obj_t
		BgL_envz00_7890, obj_t BgL_nz00_7891, obj_t BgL_pz00_7892,
		obj_t BgL_arg0z00_7893)
	{
		{	/* Ast/walk.scm 306 */
			{
				BgL_nodez00_bglt BgL_auxz00_13108;

				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2942z00_9215;

					BgL_arg2942z00_9215 =
						(((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7891)))->BgL_bodyz00);
					BgL_auxz00_13108 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7892) (BgL_pz00_7892,
							((obj_t) BgL_arg2942z00_9215), BgL_arg0z00_7893, BEOA));
				}
				((((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7891)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13108), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_retblockz00_bglt) BgL_nz00_7891));
		}

	}



/* &walk0!-retblock1965 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2retblock1965za2zzast_walkz00(obj_t
		BgL_envz00_7894, obj_t BgL_nz00_7895, obj_t BgL_pz00_7896)
	{
		{	/* Ast/walk.scm 306 */
			{
				BgL_nodez00_bglt BgL_auxz00_13122;

				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2941z00_9217;

					BgL_arg2941z00_9217 =
						(((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7895)))->BgL_bodyz00);
					BgL_auxz00_13122 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7896) (BgL_pz00_7896,
							((obj_t) BgL_arg2941z00_9217), BEOA));
				}
				((((BgL_retblockz00_bglt) COBJECT(
								((BgL_retblockz00_bglt) BgL_nz00_7895)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13122), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_retblockz00_bglt) BgL_nz00_7895));
		}

	}



/* &walk3*-retblock1963 */
	obj_t BGl_z62walk3za2zd2retblock1963z12zzast_walkz00(obj_t BgL_envz00_7897,
		obj_t BgL_nz00_7898, obj_t BgL_pz00_7899, obj_t BgL_arg0z00_7900,
		obj_t BgL_arg1z00_7901, obj_t BgL_arg2z00_7902)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				obj_t BgL_res4042z00_9222;

				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2932z00_9219;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2940z00_9220;

						BgL_arg2940z00_9220 =
							(((BgL_retblockz00_bglt) COBJECT(
									((BgL_retblockz00_bglt) BgL_nz00_7898)))->BgL_bodyz00);
						BgL_arg2932z00_9219 =
							PROCEDURE_ENTRY(BgL_pz00_7899) (BgL_pz00_7899,
							((obj_t) BgL_arg2940z00_9220), BgL_arg0z00_7900, BgL_arg1z00_7901,
							BgL_arg2z00_7902, BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2933z00_9221;

						BgL_list2933z00_9221 = MAKE_YOUNG_PAIR(BgL_arg2932z00_9219, BNIL);
						BgL_res4042z00_9222 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2933z00_9221);
					}
				}
				return BgL_res4042z00_9222;
			}
		}

	}



/* &walk2*-retblock1961 */
	obj_t BGl_z62walk2za2zd2retblock1961z12zzast_walkz00(obj_t BgL_envz00_7903,
		obj_t BgL_nz00_7904, obj_t BgL_pz00_7905, obj_t BgL_arg0z00_7906,
		obj_t BgL_arg1z00_7907)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				obj_t BgL_res4043z00_9227;

				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2929z00_9224;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2931z00_9225;

						BgL_arg2931z00_9225 =
							(((BgL_retblockz00_bglt) COBJECT(
									((BgL_retblockz00_bglt) BgL_nz00_7904)))->BgL_bodyz00);
						BgL_arg2929z00_9224 =
							PROCEDURE_ENTRY(BgL_pz00_7905) (BgL_pz00_7905,
							((obj_t) BgL_arg2931z00_9225), BgL_arg0z00_7906, BgL_arg1z00_7907,
							BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2930z00_9226;

						BgL_list2930z00_9226 = MAKE_YOUNG_PAIR(BgL_arg2929z00_9224, BNIL);
						BgL_res4043z00_9227 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2930z00_9226);
					}
				}
				return BgL_res4043z00_9227;
			}
		}

	}



/* &walk1*-retblock1959 */
	obj_t BGl_z62walk1za2zd2retblock1959z12zzast_walkz00(obj_t BgL_envz00_7908,
		obj_t BgL_nz00_7909, obj_t BgL_pz00_7910, obj_t BgL_arg0z00_7911)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				obj_t BgL_res4044z00_9232;

				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2926z00_9229;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2928z00_9230;

						BgL_arg2928z00_9230 =
							(((BgL_retblockz00_bglt) COBJECT(
									((BgL_retblockz00_bglt) BgL_nz00_7909)))->BgL_bodyz00);
						BgL_arg2926z00_9229 =
							PROCEDURE_ENTRY(BgL_pz00_7910) (BgL_pz00_7910,
							((obj_t) BgL_arg2928z00_9230), BgL_arg0z00_7911, BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2927z00_9231;

						BgL_list2927z00_9231 = MAKE_YOUNG_PAIR(BgL_arg2926z00_9229, BNIL);
						BgL_res4044z00_9232 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2927z00_9231);
					}
				}
				return BgL_res4044z00_9232;
			}
		}

	}



/* &walk0*-retblock1957 */
	obj_t BGl_z62walk0za2zd2retblock1957z12zzast_walkz00(obj_t BgL_envz00_7912,
		obj_t BgL_nz00_7913, obj_t BgL_pz00_7914)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				obj_t BgL_res4045z00_9237;

				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2922z00_9234;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2924z00_9235;

						BgL_arg2924z00_9235 =
							(((BgL_retblockz00_bglt) COBJECT(
									((BgL_retblockz00_bglt) BgL_nz00_7913)))->BgL_bodyz00);
						BgL_arg2922z00_9234 =
							PROCEDURE_ENTRY(BgL_pz00_7914) (BgL_pz00_7914,
							((obj_t) BgL_arg2924z00_9235), BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2923z00_9236;

						BgL_list2923z00_9236 = MAKE_YOUNG_PAIR(BgL_arg2922z00_9234, BNIL);
						BgL_res4045z00_9237 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2923z00_9236);
					}
				}
				return BgL_res4045z00_9237;
			}
		}

	}



/* &walk3-retblock1955 */
	obj_t BGl_z62walk3zd2retblock1955zb0zzast_walkz00(obj_t BgL_envz00_7915,
		obj_t BgL_nz00_7916, obj_t BgL_pz00_7917, obj_t BgL_arg0z00_7918,
		obj_t BgL_arg1z00_7919, obj_t BgL_arg2z00_7920)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				BgL_nodez00_bglt BgL_arg2921z00_9239;

				BgL_arg2921z00_9239 =
					(((BgL_retblockz00_bglt) COBJECT(
							((BgL_retblockz00_bglt) BgL_nz00_7916)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7917) (BgL_pz00_7917,
					((obj_t) BgL_arg2921z00_9239), BgL_arg0z00_7918, BgL_arg1z00_7919,
					BgL_arg2z00_7920, BEOA);
			}
		}

	}



/* &walk2-retblock1953 */
	obj_t BGl_z62walk2zd2retblock1953zb0zzast_walkz00(obj_t BgL_envz00_7921,
		obj_t BgL_nz00_7922, obj_t BgL_pz00_7923, obj_t BgL_arg0z00_7924,
		obj_t BgL_arg1z00_7925)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				BgL_nodez00_bglt BgL_arg2915z00_9241;

				BgL_arg2915z00_9241 =
					(((BgL_retblockz00_bglt) COBJECT(
							((BgL_retblockz00_bglt) BgL_nz00_7922)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7923) (BgL_pz00_7923,
					((obj_t) BgL_arg2915z00_9241), BgL_arg0z00_7924, BgL_arg1z00_7925,
					BEOA);
			}
		}

	}



/* &walk1-retblock1951 */
	obj_t BGl_z62walk1zd2retblock1951zb0zzast_walkz00(obj_t BgL_envz00_7926,
		obj_t BgL_nz00_7927, obj_t BgL_pz00_7928, obj_t BgL_arg0z00_7929)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				BgL_nodez00_bglt BgL_arg2914z00_9243;

				BgL_arg2914z00_9243 =
					(((BgL_retblockz00_bglt) COBJECT(
							((BgL_retblockz00_bglt) BgL_nz00_7927)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7928) (BgL_pz00_7928,
					((obj_t) BgL_arg2914z00_9243), BgL_arg0z00_7929, BEOA);
			}
		}

	}



/* &walk0-retblock1949 */
	obj_t BGl_z62walk0zd2retblock1949zb0zzast_walkz00(obj_t BgL_envz00_7930,
		obj_t BgL_nz00_7931, obj_t BgL_pz00_7932)
	{
		{	/* Ast/walk.scm 306 */
			{	/* Ast/walk.scm 306 */
				BgL_nodez00_bglt BgL_arg2902z00_9245;

				BgL_arg2902z00_9245 =
					(((BgL_retblockz00_bglt) COBJECT(
							((BgL_retblockz00_bglt) BgL_nz00_7931)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7932) (BgL_pz00_7932,
					((obj_t) BgL_arg2902z00_9245), BEOA);
			}
		}

	}



/* &walk3!-jump-ex-it1947 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2jumpzd2exzd2it1947za2zzast_walkz00(obj_t
		BgL_envz00_7933, obj_t BgL_nz00_7934, obj_t BgL_pz00_7935,
		obj_t BgL_arg0z00_7936, obj_t BgL_arg1z00_7937, obj_t BgL_arg2z00_7938)
	{
		{	/* Ast/walk.scm 305 */
			{
				BgL_nodez00_bglt BgL_auxz00_13211;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2900z00_9247;

					BgL_arg2900z00_9247 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7934)))->BgL_exitz00);
					BgL_auxz00_13211 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7935) (BgL_pz00_7935,
							((obj_t) BgL_arg2900z00_9247), BgL_arg0z00_7936, BgL_arg1z00_7937,
							BgL_arg2z00_7938, BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7934)))->BgL_exitz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13211), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13225;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2901z00_9248;

					BgL_arg2901z00_9248 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7934)))->BgL_valuez00);
					BgL_auxz00_13225 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7935) (BgL_pz00_7935,
							((obj_t) BgL_arg2901z00_9248), BgL_arg0z00_7936, BgL_arg1z00_7937,
							BgL_arg2z00_7938, BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7934)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13225), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7934));
		}

	}



/* &walk2!-jump-ex-it1945 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2jumpzd2exzd2it1945za2zzast_walkz00(obj_t
		BgL_envz00_7939, obj_t BgL_nz00_7940, obj_t BgL_pz00_7941,
		obj_t BgL_arg0z00_7942, obj_t BgL_arg1z00_7943)
	{
		{	/* Ast/walk.scm 305 */
			{
				BgL_nodez00_bglt BgL_auxz00_13241;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2898z00_9250;

					BgL_arg2898z00_9250 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7940)))->BgL_exitz00);
					BgL_auxz00_13241 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7941) (BgL_pz00_7941,
							((obj_t) BgL_arg2898z00_9250), BgL_arg0z00_7942, BgL_arg1z00_7943,
							BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7940)))->BgL_exitz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13241), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13254;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2899z00_9251;

					BgL_arg2899z00_9251 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7940)))->BgL_valuez00);
					BgL_auxz00_13254 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7941) (BgL_pz00_7941,
							((obj_t) BgL_arg2899z00_9251), BgL_arg0z00_7942, BgL_arg1z00_7943,
							BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7940)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13254), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7940));
		}

	}



/* &walk1!-jump-ex-it1943 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2jumpzd2exzd2it1943za2zzast_walkz00(obj_t
		BgL_envz00_7944, obj_t BgL_nz00_7945, obj_t BgL_pz00_7946,
		obj_t BgL_arg0z00_7947)
	{
		{	/* Ast/walk.scm 305 */
			{
				BgL_nodez00_bglt BgL_auxz00_13269;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2896z00_9253;

					BgL_arg2896z00_9253 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7945)))->BgL_exitz00);
					BgL_auxz00_13269 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7946) (BgL_pz00_7946,
							((obj_t) BgL_arg2896z00_9253), BgL_arg0z00_7947, BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7945)))->BgL_exitz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13269), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13281;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2897z00_9254;

					BgL_arg2897z00_9254 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7945)))->BgL_valuez00);
					BgL_auxz00_13281 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7946) (BgL_pz00_7946,
							((obj_t) BgL_arg2897z00_9254), BgL_arg0z00_7947, BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7945)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13281), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7945));
		}

	}



/* &walk0!-jump-ex-it1941 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2jumpzd2exzd2it1941za2zzast_walkz00(obj_t
		BgL_envz00_7948, obj_t BgL_nz00_7949, obj_t BgL_pz00_7950)
	{
		{	/* Ast/walk.scm 305 */
			{
				BgL_nodez00_bglt BgL_auxz00_13295;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2894z00_9256;

					BgL_arg2894z00_9256 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7949)))->BgL_exitz00);
					BgL_auxz00_13295 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7950) (BgL_pz00_7950,
							((obj_t) BgL_arg2894z00_9256), BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7949)))->BgL_exitz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13295), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13306;

				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2895z00_9257;

					BgL_arg2895z00_9257 =
						(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7949)))->BgL_valuez00);
					BgL_auxz00_13306 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7950) (BgL_pz00_7950,
							((obj_t) BgL_arg2895z00_9257), BEOA));
				}
				((((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
								((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7949)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13306), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7949));
		}

	}



/* &walk3*-jump-ex-it1939 */
	obj_t BGl_z62walk3za2zd2jumpzd2exzd2it1939z12zzast_walkz00(obj_t
		BgL_envz00_7951, obj_t BgL_nz00_7952, obj_t BgL_pz00_7953,
		obj_t BgL_arg0z00_7954, obj_t BgL_arg1z00_7955, obj_t BgL_arg2z00_7956)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				obj_t BgL_res4046z00_9263;

				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2890z00_9259;
					obj_t BgL_arg2891z00_9260;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2892z00_9261;

						BgL_arg2892z00_9261 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7952)))->BgL_exitz00);
						BgL_arg2890z00_9259 =
							PROCEDURE_ENTRY(BgL_pz00_7953) (BgL_pz00_7953,
							((obj_t) BgL_arg2892z00_9261), BgL_arg0z00_7954, BgL_arg1z00_7955,
							BgL_arg2z00_7956, BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2893z00_9262;

						BgL_arg2893z00_9262 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7952)))->BgL_valuez00);
						BgL_arg2891z00_9260 =
							PROCEDURE_ENTRY(BgL_pz00_7953) (BgL_pz00_7953,
							((obj_t) BgL_arg2893z00_9262), BgL_arg0z00_7954, BgL_arg1z00_7955,
							BgL_arg2z00_7956, BEOA);
					}
					BgL_res4046z00_9263 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2890z00_9259,
						BgL_arg2891z00_9260);
				}
				return BgL_res4046z00_9263;
			}
		}

	}



/* &walk2*-jump-ex-it1937 */
	obj_t BGl_z62walk2za2zd2jumpzd2exzd2it1937z12zzast_walkz00(obj_t
		BgL_envz00_7957, obj_t BgL_nz00_7958, obj_t BgL_pz00_7959,
		obj_t BgL_arg0z00_7960, obj_t BgL_arg1z00_7961)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				obj_t BgL_res4047z00_9269;

				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2883z00_9265;
					obj_t BgL_arg2884z00_9266;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2885z00_9267;

						BgL_arg2885z00_9267 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7958)))->BgL_exitz00);
						BgL_arg2883z00_9265 =
							PROCEDURE_ENTRY(BgL_pz00_7959) (BgL_pz00_7959,
							((obj_t) BgL_arg2885z00_9267), BgL_arg0z00_7960, BgL_arg1z00_7961,
							BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2889z00_9268;

						BgL_arg2889z00_9268 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7958)))->BgL_valuez00);
						BgL_arg2884z00_9266 =
							PROCEDURE_ENTRY(BgL_pz00_7959) (BgL_pz00_7959,
							((obj_t) BgL_arg2889z00_9268), BgL_arg0z00_7960, BgL_arg1z00_7961,
							BEOA);
					}
					BgL_res4047z00_9269 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2883z00_9265,
						BgL_arg2884z00_9266);
				}
				return BgL_res4047z00_9269;
			}
		}

	}



/* &walk1*-jump-ex-it1935 */
	obj_t BGl_z62walk1za2zd2jumpzd2exzd2it1935z12zzast_walkz00(obj_t
		BgL_envz00_7962, obj_t BgL_nz00_7963, obj_t BgL_pz00_7964,
		obj_t BgL_arg0z00_7965)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				obj_t BgL_res4048z00_9275;

				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2879z00_9271;
					obj_t BgL_arg2880z00_9272;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2881z00_9273;

						BgL_arg2881z00_9273 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7963)))->BgL_exitz00);
						BgL_arg2879z00_9271 =
							PROCEDURE_ENTRY(BgL_pz00_7964) (BgL_pz00_7964,
							((obj_t) BgL_arg2881z00_9273), BgL_arg0z00_7965, BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2882z00_9274;

						BgL_arg2882z00_9274 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7963)))->BgL_valuez00);
						BgL_arg2880z00_9272 =
							PROCEDURE_ENTRY(BgL_pz00_7964) (BgL_pz00_7964,
							((obj_t) BgL_arg2882z00_9274), BgL_arg0z00_7965, BEOA);
					}
					BgL_res4048z00_9275 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2879z00_9271,
						BgL_arg2880z00_9272);
				}
				return BgL_res4048z00_9275;
			}
		}

	}



/* &walk0*-jump-ex-it1933 */
	obj_t BGl_z62walk0za2zd2jumpzd2exzd2it1933z12zzast_walkz00(obj_t
		BgL_envz00_7966, obj_t BgL_nz00_7967, obj_t BgL_pz00_7968)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				obj_t BgL_res4049z00_9281;

				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2872z00_9277;
					obj_t BgL_arg2876z00_9278;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2877z00_9279;

						BgL_arg2877z00_9279 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7967)))->BgL_exitz00);
						BgL_arg2872z00_9277 =
							PROCEDURE_ENTRY(BgL_pz00_7968) (BgL_pz00_7968,
							((obj_t) BgL_arg2877z00_9279), BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2878z00_9280;

						BgL_arg2878z00_9280 =
							(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
									((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7967)))->BgL_valuez00);
						BgL_arg2876z00_9278 =
							PROCEDURE_ENTRY(BgL_pz00_7968) (BgL_pz00_7968,
							((obj_t) BgL_arg2878z00_9280), BEOA);
					}
					BgL_res4049z00_9281 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2872z00_9277,
						BgL_arg2876z00_9278);
				}
				return BgL_res4049z00_9281;
			}
		}

	}



/* &walk3-jump-ex-it1931 */
	obj_t BGl_z62walk3zd2jumpzd2exzd2it1931zb0zzast_walkz00(obj_t BgL_envz00_7969,
		obj_t BgL_nz00_7970, obj_t BgL_pz00_7971, obj_t BgL_arg0z00_7972,
		obj_t BgL_arg1z00_7973, obj_t BgL_arg2z00_7974)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2870z00_9283;

				BgL_arg2870z00_9283 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7970)))->BgL_exitz00);
				PROCEDURE_ENTRY(BgL_pz00_7971) (BgL_pz00_7971,
					((obj_t) BgL_arg2870z00_9283), BgL_arg0z00_7972, BgL_arg1z00_7973,
					BgL_arg2z00_7974, BEOA);
			}
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2871z00_9284;

				BgL_arg2871z00_9284 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7970)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7971) (BgL_pz00_7971,
					((obj_t) BgL_arg2871z00_9284), BgL_arg0z00_7972, BgL_arg1z00_7973,
					BgL_arg2z00_7974, BEOA);
			}
		}

	}



/* &walk2-jump-ex-it1929 */
	obj_t BGl_z62walk2zd2jumpzd2exzd2it1929zb0zzast_walkz00(obj_t BgL_envz00_7975,
		obj_t BgL_nz00_7976, obj_t BgL_pz00_7977, obj_t BgL_arg0z00_7978,
		obj_t BgL_arg1z00_7979)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2868z00_9286;

				BgL_arg2868z00_9286 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7976)))->BgL_exitz00);
				PROCEDURE_ENTRY(BgL_pz00_7977) (BgL_pz00_7977,
					((obj_t) BgL_arg2868z00_9286), BgL_arg0z00_7978, BgL_arg1z00_7979,
					BEOA);
			}
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2869z00_9287;

				BgL_arg2869z00_9287 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7976)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7977) (BgL_pz00_7977,
					((obj_t) BgL_arg2869z00_9287), BgL_arg0z00_7978, BgL_arg1z00_7979,
					BEOA);
			}
		}

	}



/* &walk1-jump-ex-it1927 */
	obj_t BGl_z62walk1zd2jumpzd2exzd2it1927zb0zzast_walkz00(obj_t BgL_envz00_7980,
		obj_t BgL_nz00_7981, obj_t BgL_pz00_7982, obj_t BgL_arg0z00_7983)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2866z00_9289;

				BgL_arg2866z00_9289 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7981)))->BgL_exitz00);
				PROCEDURE_ENTRY(BgL_pz00_7982) (BgL_pz00_7982,
					((obj_t) BgL_arg2866z00_9289), BgL_arg0z00_7983, BEOA);
			}
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2867z00_9290;

				BgL_arg2867z00_9290 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7981)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7982) (BgL_pz00_7982,
					((obj_t) BgL_arg2867z00_9290), BgL_arg0z00_7983, BEOA);
			}
		}

	}



/* &walk0-jump-ex-it1925 */
	obj_t BGl_z62walk0zd2jumpzd2exzd2it1925zb0zzast_walkz00(obj_t BgL_envz00_7984,
		obj_t BgL_nz00_7985, obj_t BgL_pz00_7986)
	{
		{	/* Ast/walk.scm 305 */
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2864z00_9292;

				BgL_arg2864z00_9292 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7985)))->BgL_exitz00);
				PROCEDURE_ENTRY(BgL_pz00_7986) (BgL_pz00_7986,
					((obj_t) BgL_arg2864z00_9292), BEOA);
			}
			{	/* Ast/walk.scm 305 */
				BgL_nodez00_bglt BgL_arg2865z00_9293;

				BgL_arg2865z00_9293 =
					(((BgL_jumpzd2exzd2itz00_bglt) COBJECT(
							((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7985)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_7986) (BgL_pz00_7986,
					((obj_t) BgL_arg2865z00_9293), BEOA);
			}
		}

	}



/* &walk3!-set-ex-it1923 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2setzd2exzd2it1923za2zzast_walkz00(obj_t
		BgL_envz00_7987, obj_t BgL_nz00_7988, obj_t BgL_pz00_7989,
		obj_t BgL_arg0z00_7990, obj_t BgL_arg1z00_7991, obj_t BgL_arg2z00_7992)
	{
		{	/* Ast/walk.scm 304 */
			{
				BgL_nodez00_bglt BgL_auxz00_13459;

				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2863z00_9295;

					BgL_arg2863z00_9295 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7988)))->BgL_bodyz00);
					BgL_auxz00_13459 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7989) (BgL_pz00_7989,
							((obj_t) BgL_arg2863z00_9295), BgL_arg0z00_7990, BgL_arg1z00_7991,
							BgL_arg2z00_7992, BEOA));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7988)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13459), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7988));
		}

	}



/* &walk2!-set-ex-it1921 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2setzd2exzd2it1921za2zzast_walkz00(obj_t
		BgL_envz00_7993, obj_t BgL_nz00_7994, obj_t BgL_pz00_7995,
		obj_t BgL_arg0z00_7996, obj_t BgL_arg1z00_7997)
	{
		{	/* Ast/walk.scm 304 */
			{
				BgL_nodez00_bglt BgL_auxz00_13475;

				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2859z00_9297;

					BgL_arg2859z00_9297 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7994)))->BgL_bodyz00);
					BgL_auxz00_13475 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_7995) (BgL_pz00_7995,
							((obj_t) BgL_arg2859z00_9297), BgL_arg0z00_7996, BgL_arg1z00_7997,
							BEOA));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7994)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13475), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7994));
		}

	}



/* &walk1!-set-ex-it1919 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2setzd2exzd2it1919za2zzast_walkz00(obj_t
		BgL_envz00_7998, obj_t BgL_nz00_7999, obj_t BgL_pz00_8000,
		obj_t BgL_arg0z00_8001)
	{
		{	/* Ast/walk.scm 304 */
			{
				BgL_nodez00_bglt BgL_auxz00_13490;

				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2858z00_9299;

					BgL_arg2858z00_9299 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7999)))->BgL_bodyz00);
					BgL_auxz00_13490 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8000) (BgL_pz00_8000,
							((obj_t) BgL_arg2858z00_9299), BgL_arg0z00_8001, BEOA));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7999)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13490), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7999));
		}

	}



/* &walk0!-set-ex-it1917 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2setzd2exzd2it1917za2zzast_walkz00(obj_t
		BgL_envz00_8002, obj_t BgL_nz00_8003, obj_t BgL_pz00_8004)
	{
		{	/* Ast/walk.scm 304 */
			{
				BgL_nodez00_bglt BgL_auxz00_13504;

				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2857z00_9301;

					BgL_arg2857z00_9301 =
						(((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8003)))->BgL_bodyz00);
					BgL_auxz00_13504 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8004) (BgL_pz00_8004,
							((obj_t) BgL_arg2857z00_9301), BEOA));
				}
				((((BgL_setzd2exzd2itz00_bglt) COBJECT(
								((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8003)))->BgL_bodyz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13504), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8003));
		}

	}



/* &walk3*-set-ex-it1915 */
	obj_t BGl_z62walk3za2zd2setzd2exzd2it1915z12zzast_walkz00(obj_t
		BgL_envz00_8005, obj_t BgL_nz00_8006, obj_t BgL_pz00_8007,
		obj_t BgL_arg0z00_8008, obj_t BgL_arg1z00_8009, obj_t BgL_arg2z00_8010)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				obj_t BgL_res4050z00_9306;

				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2854z00_9303;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2856z00_9304;

						BgL_arg2856z00_9304 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8006)))->BgL_bodyz00);
						BgL_arg2854z00_9303 =
							PROCEDURE_ENTRY(BgL_pz00_8007) (BgL_pz00_8007,
							((obj_t) BgL_arg2856z00_9304), BgL_arg0z00_8008, BgL_arg1z00_8009,
							BgL_arg2z00_8010, BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2855z00_9305;

						BgL_list2855z00_9305 = MAKE_YOUNG_PAIR(BgL_arg2854z00_9303, BNIL);
						BgL_res4050z00_9306 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2855z00_9305);
					}
				}
				return BgL_res4050z00_9306;
			}
		}

	}



/* &walk2*-set-ex-it1913 */
	obj_t BGl_z62walk2za2zd2setzd2exzd2it1913z12zzast_walkz00(obj_t
		BgL_envz00_8011, obj_t BgL_nz00_8012, obj_t BgL_pz00_8013,
		obj_t BgL_arg0z00_8014, obj_t BgL_arg1z00_8015)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				obj_t BgL_res4051z00_9311;

				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2851z00_9308;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2853z00_9309;

						BgL_arg2853z00_9309 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8012)))->BgL_bodyz00);
						BgL_arg2851z00_9308 =
							PROCEDURE_ENTRY(BgL_pz00_8013) (BgL_pz00_8013,
							((obj_t) BgL_arg2853z00_9309), BgL_arg0z00_8014, BgL_arg1z00_8015,
							BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2852z00_9310;

						BgL_list2852z00_9310 = MAKE_YOUNG_PAIR(BgL_arg2851z00_9308, BNIL);
						BgL_res4051z00_9311 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2852z00_9310);
					}
				}
				return BgL_res4051z00_9311;
			}
		}

	}



/* &walk1*-set-ex-it1911 */
	obj_t BGl_z62walk1za2zd2setzd2exzd2it1911z12zzast_walkz00(obj_t
		BgL_envz00_8016, obj_t BgL_nz00_8017, obj_t BgL_pz00_8018,
		obj_t BgL_arg0z00_8019)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				obj_t BgL_res4052z00_9316;

				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2846z00_9313;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2849z00_9314;

						BgL_arg2849z00_9314 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8017)))->BgL_bodyz00);
						BgL_arg2846z00_9313 =
							PROCEDURE_ENTRY(BgL_pz00_8018) (BgL_pz00_8018,
							((obj_t) BgL_arg2849z00_9314), BgL_arg0z00_8019, BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2847z00_9315;

						BgL_list2847z00_9315 = MAKE_YOUNG_PAIR(BgL_arg2846z00_9313, BNIL);
						BgL_res4052z00_9316 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2847z00_9315);
					}
				}
				return BgL_res4052z00_9316;
			}
		}

	}



/* &walk0*-set-ex-it1909 */
	obj_t BGl_z62walk0za2zd2setzd2exzd2it1909z12zzast_walkz00(obj_t
		BgL_envz00_8020, obj_t BgL_nz00_8021, obj_t BgL_pz00_8022)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				obj_t BgL_res4053z00_9321;

				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2843z00_9318;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2845z00_9319;

						BgL_arg2845z00_9319 =
							(((BgL_setzd2exzd2itz00_bglt) COBJECT(
									((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8021)))->BgL_bodyz00);
						BgL_arg2843z00_9318 =
							PROCEDURE_ENTRY(BgL_pz00_8022) (BgL_pz00_8022,
							((obj_t) BgL_arg2845z00_9319), BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2844z00_9320;

						BgL_list2844z00_9320 = MAKE_YOUNG_PAIR(BgL_arg2843z00_9318, BNIL);
						BgL_res4053z00_9321 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2844z00_9320);
					}
				}
				return BgL_res4053z00_9321;
			}
		}

	}



/* &walk3-set-ex-it1907 */
	obj_t BGl_z62walk3zd2setzd2exzd2it1907zb0zzast_walkz00(obj_t BgL_envz00_8023,
		obj_t BgL_nz00_8024, obj_t BgL_pz00_8025, obj_t BgL_arg0z00_8026,
		obj_t BgL_arg1z00_8027, obj_t BgL_arg2z00_8028)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				BgL_nodez00_bglt BgL_arg2842z00_9323;

				BgL_arg2842z00_9323 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8024)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8025) (BgL_pz00_8025,
					((obj_t) BgL_arg2842z00_9323), BgL_arg0z00_8026, BgL_arg1z00_8027,
					BgL_arg2z00_8028, BEOA);
			}
		}

	}



/* &walk2-set-ex-it1905 */
	obj_t BGl_z62walk2zd2setzd2exzd2it1905zb0zzast_walkz00(obj_t BgL_envz00_8029,
		obj_t BgL_nz00_8030, obj_t BgL_pz00_8031, obj_t BgL_arg0z00_8032,
		obj_t BgL_arg1z00_8033)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				BgL_nodez00_bglt BgL_arg2841z00_9325;

				BgL_arg2841z00_9325 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8030)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8031) (BgL_pz00_8031,
					((obj_t) BgL_arg2841z00_9325), BgL_arg0z00_8032, BgL_arg1z00_8033,
					BEOA);
			}
		}

	}



/* &walk1-set-ex-it1903 */
	obj_t BGl_z62walk1zd2setzd2exzd2it1903zb0zzast_walkz00(obj_t BgL_envz00_8034,
		obj_t BgL_nz00_8035, obj_t BgL_pz00_8036, obj_t BgL_arg0z00_8037)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				BgL_nodez00_bglt BgL_arg2835z00_9327;

				BgL_arg2835z00_9327 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8035)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8036) (BgL_pz00_8036,
					((obj_t) BgL_arg2835z00_9327), BgL_arg0z00_8037, BEOA);
			}
		}

	}



/* &walk0-set-ex-it1901 */
	obj_t BGl_z62walk0zd2setzd2exzd2it1901zb0zzast_walkz00(obj_t BgL_envz00_8038,
		obj_t BgL_nz00_8039, obj_t BgL_pz00_8040)
	{
		{	/* Ast/walk.scm 304 */
			{	/* Ast/walk.scm 304 */
				BgL_nodez00_bglt BgL_arg2834z00_9329;

				BgL_arg2834z00_9329 =
					(((BgL_setzd2exzd2itz00_bglt) COBJECT(
							((BgL_setzd2exzd2itz00_bglt) BgL_nz00_8039)))->BgL_bodyz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8040) (BgL_pz00_8040,
					((obj_t) BgL_arg2834z00_9329), BEOA);
			}
		}

	}



/* &walk3!-fail1899 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2fail1899za2zzast_walkz00(obj_t
		BgL_envz00_8041, obj_t BgL_nz00_8042, obj_t BgL_pz00_8043,
		obj_t BgL_arg0z00_8044, obj_t BgL_arg1z00_8045, obj_t BgL_arg2z00_8046)
	{
		{	/* Ast/walk.scm 303 */
			{
				BgL_nodez00_bglt BgL_auxz00_13593;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2829z00_9331;

					BgL_arg2829z00_9331 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_procz00);
					BgL_auxz00_13593 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8043) (BgL_pz00_8043,
							((obj_t) BgL_arg2829z00_9331), BgL_arg0z00_8044, BgL_arg1z00_8045,
							BgL_arg2z00_8046, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13593), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13607;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2832z00_9332;

					BgL_arg2832z00_9332 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_msgz00);
					BgL_auxz00_13607 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8043) (BgL_pz00_8043,
							((obj_t) BgL_arg2832z00_9332), BgL_arg0z00_8044, BgL_arg1z00_8045,
							BgL_arg2z00_8046, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13607), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13621;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2833z00_9333;

					BgL_arg2833z00_9333 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_objz00);
					BgL_auxz00_13621 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8043) (BgL_pz00_8043,
							((obj_t) BgL_arg2833z00_9333), BgL_arg0z00_8044, BgL_arg1z00_8045,
							BgL_arg2z00_8046, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8042)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13621), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nz00_8042));
		}

	}



/* &walk2!-fail1897 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2fail1897za2zzast_walkz00(obj_t
		BgL_envz00_8047, obj_t BgL_nz00_8048, obj_t BgL_pz00_8049,
		obj_t BgL_arg0z00_8050, obj_t BgL_arg1z00_8051)
	{
		{	/* Ast/walk.scm 303 */
			{
				BgL_nodez00_bglt BgL_auxz00_13637;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2823z00_9335;

					BgL_arg2823z00_9335 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_procz00);
					BgL_auxz00_13637 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8049) (BgL_pz00_8049,
							((obj_t) BgL_arg2823z00_9335), BgL_arg0z00_8050, BgL_arg1z00_8051,
							BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13637), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13650;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2824z00_9336;

					BgL_arg2824z00_9336 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_msgz00);
					BgL_auxz00_13650 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8049) (BgL_pz00_8049,
							((obj_t) BgL_arg2824z00_9336), BgL_arg0z00_8050, BgL_arg1z00_8051,
							BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13650), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13663;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2827z00_9337;

					BgL_arg2827z00_9337 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_objz00);
					BgL_auxz00_13663 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8049) (BgL_pz00_8049,
							((obj_t) BgL_arg2827z00_9337), BgL_arg0z00_8050, BgL_arg1z00_8051,
							BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8048)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13663), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nz00_8048));
		}

	}



/* &walk1!-fail1895 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2fail1895za2zzast_walkz00(obj_t
		BgL_envz00_8052, obj_t BgL_nz00_8053, obj_t BgL_pz00_8054,
		obj_t BgL_arg0z00_8055)
	{
		{	/* Ast/walk.scm 303 */
			{
				BgL_nodez00_bglt BgL_auxz00_13678;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2819z00_9339;

					BgL_arg2819z00_9339 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_procz00);
					BgL_auxz00_13678 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8054) (BgL_pz00_8054,
							((obj_t) BgL_arg2819z00_9339), BgL_arg0z00_8055, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13678), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13690;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2820z00_9340;

					BgL_arg2820z00_9340 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_msgz00);
					BgL_auxz00_13690 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8054) (BgL_pz00_8054,
							((obj_t) BgL_arg2820z00_9340), BgL_arg0z00_8055, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13690), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13702;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2822z00_9341;

					BgL_arg2822z00_9341 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_objz00);
					BgL_auxz00_13702 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8054) (BgL_pz00_8054,
							((obj_t) BgL_arg2822z00_9341), BgL_arg0z00_8055, BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8053)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13702), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nz00_8053));
		}

	}



/* &walk0!-fail1893 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2fail1893za2zzast_walkz00(obj_t
		BgL_envz00_8056, obj_t BgL_nz00_8057, obj_t BgL_pz00_8058)
	{
		{	/* Ast/walk.scm 303 */
			{
				BgL_nodez00_bglt BgL_auxz00_13716;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2810z00_9343;

					BgL_arg2810z00_9343 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_procz00);
					BgL_auxz00_13716 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8058) (BgL_pz00_8058,
							((obj_t) BgL_arg2810z00_9343), BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_procz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13716), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13727;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2813z00_9344;

					BgL_arg2813z00_9344 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_msgz00);
					BgL_auxz00_13727 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8058) (BgL_pz00_8058,
							((obj_t) BgL_arg2813z00_9344), BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_msgz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13727), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13738;

				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2814z00_9345;

					BgL_arg2814z00_9345 =
						(((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_objz00);
					BgL_auxz00_13738 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8058) (BgL_pz00_8058,
							((obj_t) BgL_arg2814z00_9345), BEOA));
				}
				((((BgL_failz00_bglt) COBJECT(
								((BgL_failz00_bglt) BgL_nz00_8057)))->BgL_objz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13738), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_failz00_bglt) BgL_nz00_8057));
		}

	}



/* &walk3*-fail1891 */
	obj_t BGl_z62walk3za2zd2fail1891z12zzast_walkz00(obj_t BgL_envz00_8059,
		obj_t BgL_nz00_8060, obj_t BgL_pz00_8061, obj_t BgL_arg0z00_8062,
		obj_t BgL_arg1z00_8063, obj_t BgL_arg2z00_8064)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				obj_t BgL_res4054z00_9356;

				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2796z00_9347;
					obj_t BgL_arg2798z00_9348;
					obj_t BgL_arg2799z00_9349;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2804z00_9350;

						BgL_arg2804z00_9350 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8060)))->BgL_procz00);
						BgL_arg2796z00_9347 =
							PROCEDURE_ENTRY(BgL_pz00_8061) (BgL_pz00_8061,
							((obj_t) BgL_arg2804z00_9350), BgL_arg0z00_8062, BgL_arg1z00_8063,
							BgL_arg2z00_8064, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2805z00_9351;

						BgL_arg2805z00_9351 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8060)))->BgL_msgz00);
						BgL_arg2798z00_9348 =
							PROCEDURE_ENTRY(BgL_pz00_8061) (BgL_pz00_8061,
							((obj_t) BgL_arg2805z00_9351), BgL_arg0z00_8062, BgL_arg1z00_8063,
							BgL_arg2z00_8064, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2806z00_9352;

						BgL_arg2806z00_9352 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8060)))->BgL_objz00);
						BgL_arg2799z00_9349 =
							PROCEDURE_ENTRY(BgL_pz00_8061) (BgL_pz00_8061,
							((obj_t) BgL_arg2806z00_9352), BgL_arg0z00_8062, BgL_arg1z00_8063,
							BgL_arg2z00_8064, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2800z00_9353;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2801z00_9354;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2803z00_9355;

								BgL_arg2803z00_9355 =
									MAKE_YOUNG_PAIR(BgL_arg2799z00_9349, BNIL);
								BgL_arg2801z00_9354 =
									MAKE_YOUNG_PAIR(BgL_arg2798z00_9348, BgL_arg2803z00_9355);
							}
							BgL_list2800z00_9353 =
								MAKE_YOUNG_PAIR(BgL_arg2796z00_9347, BgL_arg2801z00_9354);
						}
						BgL_res4054z00_9356 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2800z00_9353);
					}
				}
				return BgL_res4054z00_9356;
			}
		}

	}



/* &walk2*-fail1889 */
	obj_t BGl_z62walk2za2zd2fail1889z12zzast_walkz00(obj_t BgL_envz00_8065,
		obj_t BgL_nz00_8066, obj_t BgL_pz00_8067, obj_t BgL_arg0z00_8068,
		obj_t BgL_arg1z00_8069)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				obj_t BgL_res4055z00_9367;

				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2783z00_9358;
					obj_t BgL_arg2784z00_9359;
					obj_t BgL_arg2787z00_9360;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2793z00_9361;

						BgL_arg2793z00_9361 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8066)))->BgL_procz00);
						BgL_arg2783z00_9358 =
							PROCEDURE_ENTRY(BgL_pz00_8067) (BgL_pz00_8067,
							((obj_t) BgL_arg2793z00_9361), BgL_arg0z00_8068, BgL_arg1z00_8069,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2794z00_9362;

						BgL_arg2794z00_9362 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8066)))->BgL_msgz00);
						BgL_arg2784z00_9359 =
							PROCEDURE_ENTRY(BgL_pz00_8067) (BgL_pz00_8067,
							((obj_t) BgL_arg2794z00_9362), BgL_arg0z00_8068, BgL_arg1z00_8069,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2795z00_9363;

						BgL_arg2795z00_9363 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8066)))->BgL_objz00);
						BgL_arg2787z00_9360 =
							PROCEDURE_ENTRY(BgL_pz00_8067) (BgL_pz00_8067,
							((obj_t) BgL_arg2795z00_9363), BgL_arg0z00_8068, BgL_arg1z00_8069,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2788z00_9364;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2789z00_9365;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2790z00_9366;

								BgL_arg2790z00_9366 =
									MAKE_YOUNG_PAIR(BgL_arg2787z00_9360, BNIL);
								BgL_arg2789z00_9365 =
									MAKE_YOUNG_PAIR(BgL_arg2784z00_9359, BgL_arg2790z00_9366);
							}
							BgL_list2788z00_9364 =
								MAKE_YOUNG_PAIR(BgL_arg2783z00_9358, BgL_arg2789z00_9365);
						}
						BgL_res4055z00_9367 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2788z00_9364);
					}
				}
				return BgL_res4055z00_9367;
			}
		}

	}



/* &walk1*-fail1887 */
	obj_t BGl_z62walk1za2zd2fail1887z12zzast_walkz00(obj_t BgL_envz00_8070,
		obj_t BgL_nz00_8071, obj_t BgL_pz00_8072, obj_t BgL_arg0z00_8073)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				obj_t BgL_res4056z00_9378;

				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2763z00_9369;
					obj_t BgL_arg2764z00_9370;
					obj_t BgL_arg2766z00_9371;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2778z00_9372;

						BgL_arg2778z00_9372 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8071)))->BgL_procz00);
						BgL_arg2763z00_9369 =
							PROCEDURE_ENTRY(BgL_pz00_8072) (BgL_pz00_8072,
							((obj_t) BgL_arg2778z00_9372), BgL_arg0z00_8073, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2779z00_9373;

						BgL_arg2779z00_9373 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8071)))->BgL_msgz00);
						BgL_arg2764z00_9370 =
							PROCEDURE_ENTRY(BgL_pz00_8072) (BgL_pz00_8072,
							((obj_t) BgL_arg2779z00_9373), BgL_arg0z00_8073, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2780z00_9374;

						BgL_arg2780z00_9374 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8071)))->BgL_objz00);
						BgL_arg2766z00_9371 =
							PROCEDURE_ENTRY(BgL_pz00_8072) (BgL_pz00_8072,
							((obj_t) BgL_arg2780z00_9374), BgL_arg0z00_8073, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2767z00_9375;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2769z00_9376;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2776z00_9377;

								BgL_arg2776z00_9377 =
									MAKE_YOUNG_PAIR(BgL_arg2766z00_9371, BNIL);
								BgL_arg2769z00_9376 =
									MAKE_YOUNG_PAIR(BgL_arg2764z00_9370, BgL_arg2776z00_9377);
							}
							BgL_list2767z00_9375 =
								MAKE_YOUNG_PAIR(BgL_arg2763z00_9369, BgL_arg2769z00_9376);
						}
						BgL_res4056z00_9378 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2767z00_9375);
					}
				}
				return BgL_res4056z00_9378;
			}
		}

	}



/* &walk0*-fail1885 */
	obj_t BGl_z62walk0za2zd2fail1885z12zzast_walkz00(obj_t BgL_envz00_8074,
		obj_t BgL_nz00_8075, obj_t BgL_pz00_8076)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				obj_t BgL_res4057z00_9389;

				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2754z00_9380;
					obj_t BgL_arg2755z00_9381;
					obj_t BgL_arg2756z00_9382;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2760z00_9383;

						BgL_arg2760z00_9383 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8075)))->BgL_procz00);
						BgL_arg2754z00_9380 =
							PROCEDURE_ENTRY(BgL_pz00_8076) (BgL_pz00_8076,
							((obj_t) BgL_arg2760z00_9383), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2761z00_9384;

						BgL_arg2761z00_9384 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8075)))->BgL_msgz00);
						BgL_arg2755z00_9381 =
							PROCEDURE_ENTRY(BgL_pz00_8076) (BgL_pz00_8076,
							((obj_t) BgL_arg2761z00_9384), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2762z00_9385;

						BgL_arg2762z00_9385 =
							(((BgL_failz00_bglt) COBJECT(
									((BgL_failz00_bglt) BgL_nz00_8075)))->BgL_objz00);
						BgL_arg2756z00_9382 =
							PROCEDURE_ENTRY(BgL_pz00_8076) (BgL_pz00_8076,
							((obj_t) BgL_arg2762z00_9385), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2757z00_9386;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2758z00_9387;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2759z00_9388;

								BgL_arg2759z00_9388 =
									MAKE_YOUNG_PAIR(BgL_arg2756z00_9382, BNIL);
								BgL_arg2758z00_9387 =
									MAKE_YOUNG_PAIR(BgL_arg2755z00_9381, BgL_arg2759z00_9388);
							}
							BgL_list2757z00_9386 =
								MAKE_YOUNG_PAIR(BgL_arg2754z00_9380, BgL_arg2758z00_9387);
						}
						BgL_res4057z00_9389 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2757z00_9386);
					}
				}
				return BgL_res4057z00_9389;
			}
		}

	}



/* &walk3-fail1883 */
	obj_t BGl_z62walk3zd2fail1883zb0zzast_walkz00(obj_t BgL_envz00_8077,
		obj_t BgL_nz00_8078, obj_t BgL_pz00_8079, obj_t BgL_arg0z00_8080,
		obj_t BgL_arg1z00_8081, obj_t BgL_arg2z00_8082)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2747z00_9391;

				BgL_arg2747z00_9391 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8078)))->BgL_procz00);
				PROCEDURE_ENTRY(BgL_pz00_8079) (BgL_pz00_8079,
					((obj_t) BgL_arg2747z00_9391), BgL_arg0z00_8080, BgL_arg1z00_8081,
					BgL_arg2z00_8082, BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2749z00_9392;

				BgL_arg2749z00_9392 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8078)))->BgL_msgz00);
				PROCEDURE_ENTRY(BgL_pz00_8079) (BgL_pz00_8079,
					((obj_t) BgL_arg2749z00_9392), BgL_arg0z00_8080, BgL_arg1z00_8081,
					BgL_arg2z00_8082, BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2750z00_9393;

				BgL_arg2750z00_9393 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8078)))->BgL_objz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8079) (BgL_pz00_8079,
					((obj_t) BgL_arg2750z00_9393), BgL_arg0z00_8080, BgL_arg1z00_8081,
					BgL_arg2z00_8082, BEOA);
			}
		}

	}



/* &walk2-fail1881 */
	obj_t BGl_z62walk2zd2fail1881zb0zzast_walkz00(obj_t BgL_envz00_8083,
		obj_t BgL_nz00_8084, obj_t BgL_pz00_8085, obj_t BgL_arg0z00_8086,
		obj_t BgL_arg1z00_8087)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2743z00_9395;

				BgL_arg2743z00_9395 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8084)))->BgL_procz00);
				PROCEDURE_ENTRY(BgL_pz00_8085) (BgL_pz00_8085,
					((obj_t) BgL_arg2743z00_9395), BgL_arg0z00_8086, BgL_arg1z00_8087,
					BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2745z00_9396;

				BgL_arg2745z00_9396 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8084)))->BgL_msgz00);
				PROCEDURE_ENTRY(BgL_pz00_8085) (BgL_pz00_8085,
					((obj_t) BgL_arg2745z00_9396), BgL_arg0z00_8086, BgL_arg1z00_8087,
					BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2746z00_9397;

				BgL_arg2746z00_9397 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8084)))->BgL_objz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8085) (BgL_pz00_8085,
					((obj_t) BgL_arg2746z00_9397), BgL_arg0z00_8086, BgL_arg1z00_8087,
					BEOA);
			}
		}

	}



/* &walk1-fail1879 */
	obj_t BGl_z62walk1zd2fail1879zb0zzast_walkz00(obj_t BgL_envz00_8088,
		obj_t BgL_nz00_8089, obj_t BgL_pz00_8090, obj_t BgL_arg0z00_8091)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2740z00_9399;

				BgL_arg2740z00_9399 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8089)))->BgL_procz00);
				PROCEDURE_ENTRY(BgL_pz00_8090) (BgL_pz00_8090,
					((obj_t) BgL_arg2740z00_9399), BgL_arg0z00_8091, BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2741z00_9400;

				BgL_arg2741z00_9400 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8089)))->BgL_msgz00);
				PROCEDURE_ENTRY(BgL_pz00_8090) (BgL_pz00_8090,
					((obj_t) BgL_arg2741z00_9400), BgL_arg0z00_8091, BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2742z00_9401;

				BgL_arg2742z00_9401 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8089)))->BgL_objz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8090) (BgL_pz00_8090,
					((obj_t) BgL_arg2742z00_9401), BgL_arg0z00_8091, BEOA);
			}
		}

	}



/* &walk0-fail1877 */
	obj_t BGl_z62walk0zd2fail1877zb0zzast_walkz00(obj_t BgL_envz00_8092,
		obj_t BgL_nz00_8093, obj_t BgL_pz00_8094)
	{
		{	/* Ast/walk.scm 303 */
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2736z00_9403;

				BgL_arg2736z00_9403 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8093)))->BgL_procz00);
				PROCEDURE_ENTRY(BgL_pz00_8094) (BgL_pz00_8094,
					((obj_t) BgL_arg2736z00_9403), BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2737z00_9404;

				BgL_arg2737z00_9404 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8093)))->BgL_msgz00);
				PROCEDURE_ENTRY(BgL_pz00_8094) (BgL_pz00_8094,
					((obj_t) BgL_arg2737z00_9404), BEOA);
			}
			{	/* Ast/walk.scm 303 */
				BgL_nodez00_bglt BgL_arg2738z00_9405;

				BgL_arg2738z00_9405 =
					(((BgL_failz00_bglt) COBJECT(
							((BgL_failz00_bglt) BgL_nz00_8093)))->BgL_objz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8094) (BgL_pz00_8094,
					((obj_t) BgL_arg2738z00_9405), BEOA);
			}
		}

	}



/* &walk3!-conditional1875 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2conditional1875za2zzast_walkz00(obj_t
		BgL_envz00_8095, obj_t BgL_nz00_8096, obj_t BgL_pz00_8097,
		obj_t BgL_arg0z00_8098, obj_t BgL_arg1z00_8099, obj_t BgL_arg2z00_8100)
	{
		{	/* Ast/walk.scm 302 */
			{
				BgL_nodez00_bglt BgL_auxz00_13971;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2729z00_9407;

					BgL_arg2729z00_9407 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_testz00);
					BgL_auxz00_13971 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8097) (BgL_pz00_8097,
							((obj_t) BgL_arg2729z00_9407), BgL_arg0z00_8098, BgL_arg1z00_8099,
							BgL_arg2z00_8100, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_13971), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13985;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2733z00_9408;

					BgL_arg2733z00_9408 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_truez00);
					BgL_auxz00_13985 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8097) (BgL_pz00_8097,
							((obj_t) BgL_arg2733z00_9408), BgL_arg0z00_8098, BgL_arg1z00_8099,
							BgL_arg2z00_8100, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13985), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_13999;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2735z00_9409;

					BgL_arg2735z00_9409 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_falsez00);
					BgL_auxz00_13999 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8097) (BgL_pz00_8097,
							((obj_t) BgL_arg2735z00_9409), BgL_arg0z00_8098, BgL_arg1z00_8099,
							BgL_arg2z00_8100, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8096)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_13999), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nz00_8096));
		}

	}



/* &walk2!-conditional1873 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2conditional1873za2zzast_walkz00(obj_t
		BgL_envz00_8101, obj_t BgL_nz00_8102, obj_t BgL_pz00_8103,
		obj_t BgL_arg0z00_8104, obj_t BgL_arg1z00_8105)
	{
		{	/* Ast/walk.scm 302 */
			{
				BgL_nodez00_bglt BgL_auxz00_14015;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2725z00_9411;

					BgL_arg2725z00_9411 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_testz00);
					BgL_auxz00_14015 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8103) (BgL_pz00_8103,
							((obj_t) BgL_arg2725z00_9411), BgL_arg0z00_8104, BgL_arg1z00_8105,
							BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14015), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14028;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2726z00_9412;

					BgL_arg2726z00_9412 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_truez00);
					BgL_auxz00_14028 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8103) (BgL_pz00_8103,
							((obj_t) BgL_arg2726z00_9412), BgL_arg0z00_8104, BgL_arg1z00_8105,
							BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14028), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14041;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2727z00_9413;

					BgL_arg2727z00_9413 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_falsez00);
					BgL_auxz00_14041 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8103) (BgL_pz00_8103,
							((obj_t) BgL_arg2727z00_9413), BgL_arg0z00_8104, BgL_arg1z00_8105,
							BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8102)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14041), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nz00_8102));
		}

	}



/* &walk1!-conditional1871 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2conditional1871za2zzast_walkz00(obj_t
		BgL_envz00_8106, obj_t BgL_nz00_8107, obj_t BgL_pz00_8108,
		obj_t BgL_arg0z00_8109)
	{
		{	/* Ast/walk.scm 302 */
			{
				BgL_nodez00_bglt BgL_auxz00_14056;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2722z00_9415;

					BgL_arg2722z00_9415 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_testz00);
					BgL_auxz00_14056 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8108) (BgL_pz00_8108,
							((obj_t) BgL_arg2722z00_9415), BgL_arg0z00_8109, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14056), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14068;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2723z00_9416;

					BgL_arg2723z00_9416 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_truez00);
					BgL_auxz00_14068 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8108) (BgL_pz00_8108,
							((obj_t) BgL_arg2723z00_9416), BgL_arg0z00_8109, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14068), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14080;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2724z00_9417;

					BgL_arg2724z00_9417 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_falsez00);
					BgL_auxz00_14080 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8108) (BgL_pz00_8108,
							((obj_t) BgL_arg2724z00_9417), BgL_arg0z00_8109, BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8107)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14080), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nz00_8107));
		}

	}



/* &walk0!-conditional1869 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2conditional1869za2zzast_walkz00(obj_t
		BgL_envz00_8110, obj_t BgL_nz00_8111, obj_t BgL_pz00_8112)
	{
		{	/* Ast/walk.scm 302 */
			{
				BgL_nodez00_bglt BgL_auxz00_14094;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2718z00_9419;

					BgL_arg2718z00_9419 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_testz00);
					BgL_auxz00_14094 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8112) (BgL_pz00_8112,
							((obj_t) BgL_arg2718z00_9419), BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_testz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14094), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14105;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2719z00_9420;

					BgL_arg2719z00_9420 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_truez00);
					BgL_auxz00_14105 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8112) (BgL_pz00_8112,
							((obj_t) BgL_arg2719z00_9420), BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_truez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14105), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14116;

				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2720z00_9421;

					BgL_arg2720z00_9421 =
						(((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_falsez00);
					BgL_auxz00_14116 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8112) (BgL_pz00_8112,
							((obj_t) BgL_arg2720z00_9421), BEOA));
				}
				((((BgL_conditionalz00_bglt) COBJECT(
								((BgL_conditionalz00_bglt) BgL_nz00_8111)))->BgL_falsez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14116), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_conditionalz00_bglt) BgL_nz00_8111));
		}

	}



/* &walk3*-conditional1867 */
	obj_t BGl_z62walk3za2zd2conditional1867z12zzast_walkz00(obj_t BgL_envz00_8113,
		obj_t BgL_nz00_8114, obj_t BgL_pz00_8115, obj_t BgL_arg0z00_8116,
		obj_t BgL_arg1z00_8117, obj_t BgL_arg2z00_8118)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				obj_t BgL_res4058z00_9432;

				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2708z00_9423;
					obj_t BgL_arg2709z00_9424;
					obj_t BgL_arg2710z00_9425;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2714z00_9426;

						BgL_arg2714z00_9426 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8114)))->BgL_testz00);
						BgL_arg2708z00_9423 =
							PROCEDURE_ENTRY(BgL_pz00_8115) (BgL_pz00_8115,
							((obj_t) BgL_arg2714z00_9426), BgL_arg0z00_8116, BgL_arg1z00_8117,
							BgL_arg2z00_8118, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2716z00_9427;

						BgL_arg2716z00_9427 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8114)))->BgL_truez00);
						BgL_arg2709z00_9424 =
							PROCEDURE_ENTRY(BgL_pz00_8115) (BgL_pz00_8115,
							((obj_t) BgL_arg2716z00_9427), BgL_arg0z00_8116, BgL_arg1z00_8117,
							BgL_arg2z00_8118, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2717z00_9428;

						BgL_arg2717z00_9428 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8114)))->BgL_falsez00);
						BgL_arg2710z00_9425 =
							PROCEDURE_ENTRY(BgL_pz00_8115) (BgL_pz00_8115,
							((obj_t) BgL_arg2717z00_9428), BgL_arg0z00_8116, BgL_arg1z00_8117,
							BgL_arg2z00_8118, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2711z00_9429;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2712z00_9430;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2713z00_9431;

								BgL_arg2713z00_9431 =
									MAKE_YOUNG_PAIR(BgL_arg2710z00_9425, BNIL);
								BgL_arg2712z00_9430 =
									MAKE_YOUNG_PAIR(BgL_arg2709z00_9424, BgL_arg2713z00_9431);
							}
							BgL_list2711z00_9429 =
								MAKE_YOUNG_PAIR(BgL_arg2708z00_9423, BgL_arg2712z00_9430);
						}
						BgL_res4058z00_9432 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2711z00_9429);
					}
				}
				return BgL_res4058z00_9432;
			}
		}

	}



/* &walk2*-conditional1865 */
	obj_t BGl_z62walk2za2zd2conditional1865z12zzast_walkz00(obj_t BgL_envz00_8119,
		obj_t BgL_nz00_8120, obj_t BgL_pz00_8121, obj_t BgL_arg0z00_8122,
		obj_t BgL_arg1z00_8123)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				obj_t BgL_res4059z00_9443;

				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2697z00_9434;
					obj_t BgL_arg2698z00_9435;
					obj_t BgL_arg2699z00_9436;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2704z00_9437;

						BgL_arg2704z00_9437 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8120)))->BgL_testz00);
						BgL_arg2697z00_9434 =
							PROCEDURE_ENTRY(BgL_pz00_8121) (BgL_pz00_8121,
							((obj_t) BgL_arg2704z00_9437), BgL_arg0z00_8122, BgL_arg1z00_8123,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2705z00_9438;

						BgL_arg2705z00_9438 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8120)))->BgL_truez00);
						BgL_arg2698z00_9435 =
							PROCEDURE_ENTRY(BgL_pz00_8121) (BgL_pz00_8121,
							((obj_t) BgL_arg2705z00_9438), BgL_arg0z00_8122, BgL_arg1z00_8123,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2707z00_9439;

						BgL_arg2707z00_9439 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8120)))->BgL_falsez00);
						BgL_arg2699z00_9436 =
							PROCEDURE_ENTRY(BgL_pz00_8121) (BgL_pz00_8121,
							((obj_t) BgL_arg2707z00_9439), BgL_arg0z00_8122, BgL_arg1z00_8123,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2700z00_9440;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2701z00_9441;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2702z00_9442;

								BgL_arg2702z00_9442 =
									MAKE_YOUNG_PAIR(BgL_arg2699z00_9436, BNIL);
								BgL_arg2701z00_9441 =
									MAKE_YOUNG_PAIR(BgL_arg2698z00_9435, BgL_arg2702z00_9442);
							}
							BgL_list2700z00_9440 =
								MAKE_YOUNG_PAIR(BgL_arg2697z00_9434, BgL_arg2701z00_9441);
						}
						BgL_res4059z00_9443 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2700z00_9440);
					}
				}
				return BgL_res4059z00_9443;
			}
		}

	}



/* &walk1*-conditional1863 */
	obj_t BGl_z62walk1za2zd2conditional1863z12zzast_walkz00(obj_t BgL_envz00_8124,
		obj_t BgL_nz00_8125, obj_t BgL_pz00_8126, obj_t BgL_arg0z00_8127)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				obj_t BgL_res4060z00_9454;

				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2686z00_9445;
					obj_t BgL_arg2687z00_9446;
					obj_t BgL_arg2688z00_9447;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2693z00_9448;

						BgL_arg2693z00_9448 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8125)))->BgL_testz00);
						BgL_arg2686z00_9445 =
							PROCEDURE_ENTRY(BgL_pz00_8126) (BgL_pz00_8126,
							((obj_t) BgL_arg2693z00_9448), BgL_arg0z00_8127, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2695z00_9449;

						BgL_arg2695z00_9449 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8125)))->BgL_truez00);
						BgL_arg2687z00_9446 =
							PROCEDURE_ENTRY(BgL_pz00_8126) (BgL_pz00_8126,
							((obj_t) BgL_arg2695z00_9449), BgL_arg0z00_8127, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2696z00_9450;

						BgL_arg2696z00_9450 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8125)))->BgL_falsez00);
						BgL_arg2688z00_9447 =
							PROCEDURE_ENTRY(BgL_pz00_8126) (BgL_pz00_8126,
							((obj_t) BgL_arg2696z00_9450), BgL_arg0z00_8127, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2689z00_9451;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2691z00_9452;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2692z00_9453;

								BgL_arg2692z00_9453 =
									MAKE_YOUNG_PAIR(BgL_arg2688z00_9447, BNIL);
								BgL_arg2691z00_9452 =
									MAKE_YOUNG_PAIR(BgL_arg2687z00_9446, BgL_arg2692z00_9453);
							}
							BgL_list2689z00_9451 =
								MAKE_YOUNG_PAIR(BgL_arg2686z00_9445, BgL_arg2691z00_9452);
						}
						BgL_res4060z00_9454 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2689z00_9451);
					}
				}
				return BgL_res4060z00_9454;
			}
		}

	}



/* &walk0*-conditional1861 */
	obj_t BGl_z62walk0za2zd2conditional1861z12zzast_walkz00(obj_t BgL_envz00_8128,
		obj_t BgL_nz00_8129, obj_t BgL_pz00_8130)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				obj_t BgL_res4061z00_9465;

				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2677z00_9456;
					obj_t BgL_arg2678z00_9457;
					obj_t BgL_arg2679z00_9458;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2683z00_9459;

						BgL_arg2683z00_9459 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8129)))->BgL_testz00);
						BgL_arg2677z00_9456 =
							PROCEDURE_ENTRY(BgL_pz00_8130) (BgL_pz00_8130,
							((obj_t) BgL_arg2683z00_9459), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2684z00_9460;

						BgL_arg2684z00_9460 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8129)))->BgL_truez00);
						BgL_arg2678z00_9457 =
							PROCEDURE_ENTRY(BgL_pz00_8130) (BgL_pz00_8130,
							((obj_t) BgL_arg2684z00_9460), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2685z00_9461;

						BgL_arg2685z00_9461 =
							(((BgL_conditionalz00_bglt) COBJECT(
									((BgL_conditionalz00_bglt) BgL_nz00_8129)))->BgL_falsez00);
						BgL_arg2679z00_9458 =
							PROCEDURE_ENTRY(BgL_pz00_8130) (BgL_pz00_8130,
							((obj_t) BgL_arg2685z00_9461), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2680z00_9462;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2681z00_9463;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2682z00_9464;

								BgL_arg2682z00_9464 =
									MAKE_YOUNG_PAIR(BgL_arg2679z00_9458, BNIL);
								BgL_arg2681z00_9463 =
									MAKE_YOUNG_PAIR(BgL_arg2678z00_9457, BgL_arg2682z00_9464);
							}
							BgL_list2680z00_9462 =
								MAKE_YOUNG_PAIR(BgL_arg2677z00_9456, BgL_arg2681z00_9463);
						}
						BgL_res4061z00_9465 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2680z00_9462);
					}
				}
				return BgL_res4061z00_9465;
			}
		}

	}



/* &walk3-conditional1859 */
	obj_t BGl_z62walk3zd2conditional1859zb0zzast_walkz00(obj_t BgL_envz00_8131,
		obj_t BgL_nz00_8132, obj_t BgL_pz00_8133, obj_t BgL_arg0z00_8134,
		obj_t BgL_arg1z00_8135, obj_t BgL_arg2z00_8136)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2674z00_9467;

				BgL_arg2674z00_9467 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8132)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_8133) (BgL_pz00_8133,
					((obj_t) BgL_arg2674z00_9467), BgL_arg0z00_8134, BgL_arg1z00_8135,
					BgL_arg2z00_8136, BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2675z00_9468;

				BgL_arg2675z00_9468 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8132)))->BgL_truez00);
				PROCEDURE_ENTRY(BgL_pz00_8133) (BgL_pz00_8133,
					((obj_t) BgL_arg2675z00_9468), BgL_arg0z00_8134, BgL_arg1z00_8135,
					BgL_arg2z00_8136, BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2676z00_9469;

				BgL_arg2676z00_9469 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8132)))->BgL_falsez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8133) (BgL_pz00_8133,
					((obj_t) BgL_arg2676z00_9469), BgL_arg0z00_8134, BgL_arg1z00_8135,
					BgL_arg2z00_8136, BEOA);
			}
		}

	}



/* &walk2-conditional1857 */
	obj_t BGl_z62walk2zd2conditional1857zb0zzast_walkz00(obj_t BgL_envz00_8137,
		obj_t BgL_nz00_8138, obj_t BgL_pz00_8139, obj_t BgL_arg0z00_8140,
		obj_t BgL_arg1z00_8141)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2670z00_9471;

				BgL_arg2670z00_9471 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8138)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_8139) (BgL_pz00_8139,
					((obj_t) BgL_arg2670z00_9471), BgL_arg0z00_8140, BgL_arg1z00_8141,
					BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2671z00_9472;

				BgL_arg2671z00_9472 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8138)))->BgL_truez00);
				PROCEDURE_ENTRY(BgL_pz00_8139) (BgL_pz00_8139,
					((obj_t) BgL_arg2671z00_9472), BgL_arg0z00_8140, BgL_arg1z00_8141,
					BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2673z00_9473;

				BgL_arg2673z00_9473 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8138)))->BgL_falsez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8139) (BgL_pz00_8139,
					((obj_t) BgL_arg2673z00_9473), BgL_arg0z00_8140, BgL_arg1z00_8141,
					BEOA);
			}
		}

	}



/* &walk1-conditional1855 */
	obj_t BGl_z62walk1zd2conditional1855zb0zzast_walkz00(obj_t BgL_envz00_8142,
		obj_t BgL_nz00_8143, obj_t BgL_pz00_8144, obj_t BgL_arg0z00_8145)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2667z00_9475;

				BgL_arg2667z00_9475 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8143)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_8144) (BgL_pz00_8144,
					((obj_t) BgL_arg2667z00_9475), BgL_arg0z00_8145, BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2668z00_9476;

				BgL_arg2668z00_9476 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8143)))->BgL_truez00);
				PROCEDURE_ENTRY(BgL_pz00_8144) (BgL_pz00_8144,
					((obj_t) BgL_arg2668z00_9476), BgL_arg0z00_8145, BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2669z00_9477;

				BgL_arg2669z00_9477 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8143)))->BgL_falsez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8144) (BgL_pz00_8144,
					((obj_t) BgL_arg2669z00_9477), BgL_arg0z00_8145, BEOA);
			}
		}

	}



/* &walk0-conditional1853 */
	obj_t BGl_z62walk0zd2conditional1853zb0zzast_walkz00(obj_t BgL_envz00_8146,
		obj_t BgL_nz00_8147, obj_t BgL_pz00_8148)
	{
		{	/* Ast/walk.scm 302 */
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2663z00_9479;

				BgL_arg2663z00_9479 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8147)))->BgL_testz00);
				PROCEDURE_ENTRY(BgL_pz00_8148) (BgL_pz00_8148,
					((obj_t) BgL_arg2663z00_9479), BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2665z00_9480;

				BgL_arg2665z00_9480 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8147)))->BgL_truez00);
				PROCEDURE_ENTRY(BgL_pz00_8148) (BgL_pz00_8148,
					((obj_t) BgL_arg2665z00_9480), BEOA);
			}
			{	/* Ast/walk.scm 302 */
				BgL_nodez00_bglt BgL_arg2666z00_9481;

				BgL_arg2666z00_9481 =
					(((BgL_conditionalz00_bglt) COBJECT(
							((BgL_conditionalz00_bglt) BgL_nz00_8147)))->BgL_falsez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8148) (BgL_pz00_8148,
					((obj_t) BgL_arg2666z00_9481), BEOA);
			}
		}

	}



/* &walk3!-setq1851 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2setq1851za2zzast_walkz00(obj_t
		BgL_envz00_8149, obj_t BgL_nz00_8150, obj_t BgL_pz00_8151,
		obj_t BgL_arg0z00_8152, obj_t BgL_arg1z00_8153, obj_t BgL_arg2z00_8154)
	{
		{	/* Ast/walk.scm 301 */
			{
				BgL_varz00_bglt BgL_auxz00_14349;

				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2661z00_9483;

					BgL_arg2661z00_9483 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8150)))->BgL_varz00);
					BgL_auxz00_14349 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8151) (BgL_pz00_8151,
							((obj_t) BgL_arg2661z00_9483), BgL_arg0z00_8152, BgL_arg1z00_8153,
							BgL_arg2z00_8154, BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8150)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_14349), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14363;

				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2662z00_9484;

					BgL_arg2662z00_9484 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8150)))->BgL_valuez00);
					BgL_auxz00_14363 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8151) (BgL_pz00_8151,
							((obj_t) BgL_arg2662z00_9484), BgL_arg0z00_8152, BgL_arg1z00_8153,
							BgL_arg2z00_8154, BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8150)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14363), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nz00_8150));
		}

	}



/* &walk2!-setq1849 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2setq1849za2zzast_walkz00(obj_t
		BgL_envz00_8155, obj_t BgL_nz00_8156, obj_t BgL_pz00_8157,
		obj_t BgL_arg0z00_8158, obj_t BgL_arg1z00_8159)
	{
		{	/* Ast/walk.scm 301 */
			{
				BgL_varz00_bglt BgL_auxz00_14379;

				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2658z00_9486;

					BgL_arg2658z00_9486 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8156)))->BgL_varz00);
					BgL_auxz00_14379 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8157) (BgL_pz00_8157,
							((obj_t) BgL_arg2658z00_9486), BgL_arg0z00_8158, BgL_arg1z00_8159,
							BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8156)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_14379), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14392;

				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2659z00_9487;

					BgL_arg2659z00_9487 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8156)))->BgL_valuez00);
					BgL_auxz00_14392 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8157) (BgL_pz00_8157,
							((obj_t) BgL_arg2659z00_9487), BgL_arg0z00_8158, BgL_arg1z00_8159,
							BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8156)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14392), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nz00_8156));
		}

	}



/* &walk1!-setq1847 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2setq1847za2zzast_walkz00(obj_t
		BgL_envz00_8160, obj_t BgL_nz00_8161, obj_t BgL_pz00_8162,
		obj_t BgL_arg0z00_8163)
	{
		{	/* Ast/walk.scm 301 */
			{
				BgL_varz00_bglt BgL_auxz00_14407;

				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2654z00_9489;

					BgL_arg2654z00_9489 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8161)))->BgL_varz00);
					BgL_auxz00_14407 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8162) (BgL_pz00_8162,
							((obj_t) BgL_arg2654z00_9489), BgL_arg0z00_8163, BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8161)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_14407), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14419;

				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2657z00_9490;

					BgL_arg2657z00_9490 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8161)))->BgL_valuez00);
					BgL_auxz00_14419 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8162) (BgL_pz00_8162,
							((obj_t) BgL_arg2657z00_9490), BgL_arg0z00_8163, BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8161)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14419), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nz00_8161));
		}

	}



/* &walk0!-setq1845 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2setq1845za2zzast_walkz00(obj_t
		BgL_envz00_8164, obj_t BgL_nz00_8165, obj_t BgL_pz00_8166)
	{
		{	/* Ast/walk.scm 301 */
			{
				BgL_varz00_bglt BgL_auxz00_14433;

				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2652z00_9492;

					BgL_arg2652z00_9492 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8165)))->BgL_varz00);
					BgL_auxz00_14433 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8166) (BgL_pz00_8166,
							((obj_t) BgL_arg2652z00_9492), BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8165)))->BgL_varz00) =
					((BgL_varz00_bglt) BgL_auxz00_14433), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_14444;

				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2653z00_9493;

					BgL_arg2653z00_9493 =
						(((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8165)))->BgL_valuez00);
					BgL_auxz00_14444 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8166) (BgL_pz00_8166,
							((obj_t) BgL_arg2653z00_9493), BEOA));
				}
				((((BgL_setqz00_bglt) COBJECT(
								((BgL_setqz00_bglt) BgL_nz00_8165)))->BgL_valuez00) =
					((BgL_nodez00_bglt) BgL_auxz00_14444), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_setqz00_bglt) BgL_nz00_8165));
		}

	}



/* &walk3*-setq1843 */
	obj_t BGl_z62walk3za2zd2setq1843z12zzast_walkz00(obj_t BgL_envz00_8167,
		obj_t BgL_nz00_8168, obj_t BgL_pz00_8169, obj_t BgL_arg0z00_8170,
		obj_t BgL_arg1z00_8171, obj_t BgL_arg2z00_8172)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				obj_t BgL_res4062z00_9499;

				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2647z00_9495;
					obj_t BgL_arg2648z00_9496;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2650z00_9497;

						BgL_arg2650z00_9497 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8168)))->BgL_varz00);
						BgL_arg2647z00_9495 =
							PROCEDURE_ENTRY(BgL_pz00_8169) (BgL_pz00_8169,
							((obj_t) BgL_arg2650z00_9497), BgL_arg0z00_8170, BgL_arg1z00_8171,
							BgL_arg2z00_8172, BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2651z00_9498;

						BgL_arg2651z00_9498 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8168)))->BgL_valuez00);
						BgL_arg2648z00_9496 =
							PROCEDURE_ENTRY(BgL_pz00_8169) (BgL_pz00_8169,
							((obj_t) BgL_arg2651z00_9498), BgL_arg0z00_8170, BgL_arg1z00_8171,
							BgL_arg2z00_8172, BEOA);
					}
					BgL_res4062z00_9499 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2647z00_9495,
						BgL_arg2648z00_9496);
				}
				return BgL_res4062z00_9499;
			}
		}

	}



/* &walk2*-setq1841 */
	obj_t BGl_z62walk2za2zd2setq1841z12zzast_walkz00(obj_t BgL_envz00_8173,
		obj_t BgL_nz00_8174, obj_t BgL_pz00_8175, obj_t BgL_arg0z00_8176,
		obj_t BgL_arg1z00_8177)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				obj_t BgL_res4063z00_9505;

				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2642z00_9501;
					obj_t BgL_arg2643z00_9502;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2644z00_9503;

						BgL_arg2644z00_9503 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8174)))->BgL_varz00);
						BgL_arg2642z00_9501 =
							PROCEDURE_ENTRY(BgL_pz00_8175) (BgL_pz00_8175,
							((obj_t) BgL_arg2644z00_9503), BgL_arg0z00_8176, BgL_arg1z00_8177,
							BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2645z00_9504;

						BgL_arg2645z00_9504 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8174)))->BgL_valuez00);
						BgL_arg2643z00_9502 =
							PROCEDURE_ENTRY(BgL_pz00_8175) (BgL_pz00_8175,
							((obj_t) BgL_arg2645z00_9504), BgL_arg0z00_8176, BgL_arg1z00_8177,
							BEOA);
					}
					BgL_res4063z00_9505 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2642z00_9501,
						BgL_arg2643z00_9502);
				}
				return BgL_res4063z00_9505;
			}
		}

	}



/* &walk1*-setq1839 */
	obj_t BGl_z62walk1za2zd2setq1839z12zzast_walkz00(obj_t BgL_envz00_8178,
		obj_t BgL_nz00_8179, obj_t BgL_pz00_8180, obj_t BgL_arg0z00_8181)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				obj_t BgL_res4064z00_9511;

				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2636z00_9507;
					obj_t BgL_arg2638z00_9508;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2640z00_9509;

						BgL_arg2640z00_9509 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8179)))->BgL_varz00);
						BgL_arg2636z00_9507 =
							PROCEDURE_ENTRY(BgL_pz00_8180) (BgL_pz00_8180,
							((obj_t) BgL_arg2640z00_9509), BgL_arg0z00_8181, BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2641z00_9510;

						BgL_arg2641z00_9510 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8179)))->BgL_valuez00);
						BgL_arg2638z00_9508 =
							PROCEDURE_ENTRY(BgL_pz00_8180) (BgL_pz00_8180,
							((obj_t) BgL_arg2641z00_9510), BgL_arg0z00_8181, BEOA);
					}
					BgL_res4064z00_9511 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2636z00_9507,
						BgL_arg2638z00_9508);
				}
				return BgL_res4064z00_9511;
			}
		}

	}



/* &walk0*-setq1837 */
	obj_t BGl_z62walk0za2zd2setq1837z12zzast_walkz00(obj_t BgL_envz00_8182,
		obj_t BgL_nz00_8183, obj_t BgL_pz00_8184)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				obj_t BgL_res4065z00_9517;

				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2632z00_9513;
					obj_t BgL_arg2633z00_9514;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2634z00_9515;

						BgL_arg2634z00_9515 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8183)))->BgL_varz00);
						BgL_arg2632z00_9513 =
							PROCEDURE_ENTRY(BgL_pz00_8184) (BgL_pz00_8184,
							((obj_t) BgL_arg2634z00_9515), BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2635z00_9516;

						BgL_arg2635z00_9516 =
							(((BgL_setqz00_bglt) COBJECT(
									((BgL_setqz00_bglt) BgL_nz00_8183)))->BgL_valuez00);
						BgL_arg2633z00_9514 =
							PROCEDURE_ENTRY(BgL_pz00_8184) (BgL_pz00_8184,
							((obj_t) BgL_arg2635z00_9516), BEOA);
					}
					BgL_res4065z00_9517 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2632z00_9513,
						BgL_arg2633z00_9514);
				}
				return BgL_res4065z00_9517;
			}
		}

	}



/* &walk3-setq1835 */
	obj_t BGl_z62walk3zd2setq1835zb0zzast_walkz00(obj_t BgL_envz00_8185,
		obj_t BgL_nz00_8186, obj_t BgL_pz00_8187, obj_t BgL_arg0z00_8188,
		obj_t BgL_arg1z00_8189, obj_t BgL_arg2z00_8190)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				BgL_varz00_bglt BgL_arg2628z00_9519;

				BgL_arg2628z00_9519 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8186)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_8187) (BgL_pz00_8187,
					((obj_t) BgL_arg2628z00_9519), BgL_arg0z00_8188, BgL_arg1z00_8189,
					BgL_arg2z00_8190, BEOA);
			}
			{	/* Ast/walk.scm 301 */
				BgL_nodez00_bglt BgL_arg2630z00_9520;

				BgL_arg2630z00_9520 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8186)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8187) (BgL_pz00_8187,
					((obj_t) BgL_arg2630z00_9520), BgL_arg0z00_8188, BgL_arg1z00_8189,
					BgL_arg2z00_8190, BEOA);
			}
		}

	}



/* &walk2-setq1833 */
	obj_t BGl_z62walk2zd2setq1833zb0zzast_walkz00(obj_t BgL_envz00_8191,
		obj_t BgL_nz00_8192, obj_t BgL_pz00_8193, obj_t BgL_arg0z00_8194,
		obj_t BgL_arg1z00_8195)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				BgL_varz00_bglt BgL_arg2626z00_9522;

				BgL_arg2626z00_9522 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8192)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_8193) (BgL_pz00_8193,
					((obj_t) BgL_arg2626z00_9522), BgL_arg0z00_8194, BgL_arg1z00_8195,
					BEOA);
			}
			{	/* Ast/walk.scm 301 */
				BgL_nodez00_bglt BgL_arg2627z00_9523;

				BgL_arg2627z00_9523 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8192)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8193) (BgL_pz00_8193,
					((obj_t) BgL_arg2627z00_9523), BgL_arg0z00_8194, BgL_arg1z00_8195,
					BEOA);
			}
		}

	}



/* &walk1-setq1831 */
	obj_t BGl_z62walk1zd2setq1831zb0zzast_walkz00(obj_t BgL_envz00_8196,
		obj_t BgL_nz00_8197, obj_t BgL_pz00_8198, obj_t BgL_arg0z00_8199)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				BgL_varz00_bglt BgL_arg2623z00_9525;

				BgL_arg2623z00_9525 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8197)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_8198) (BgL_pz00_8198,
					((obj_t) BgL_arg2623z00_9525), BgL_arg0z00_8199, BEOA);
			}
			{	/* Ast/walk.scm 301 */
				BgL_nodez00_bglt BgL_arg2625z00_9526;

				BgL_arg2625z00_9526 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8197)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8198) (BgL_pz00_8198,
					((obj_t) BgL_arg2625z00_9526), BgL_arg0z00_8199, BEOA);
			}
		}

	}



/* &walk0-setq1829 */
	obj_t BGl_z62walk0zd2setq1829zb0zzast_walkz00(obj_t BgL_envz00_8200,
		obj_t BgL_nz00_8201, obj_t BgL_pz00_8202)
	{
		{	/* Ast/walk.scm 301 */
			{	/* Ast/walk.scm 301 */
				BgL_varz00_bglt BgL_arg2621z00_9528;

				BgL_arg2621z00_9528 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8201)))->BgL_varz00);
				PROCEDURE_ENTRY(BgL_pz00_8202) (BgL_pz00_8202,
					((obj_t) BgL_arg2621z00_9528), BEOA);
			}
			{	/* Ast/walk.scm 301 */
				BgL_nodez00_bglt BgL_arg2622z00_9529;

				BgL_arg2622z00_9529 =
					(((BgL_setqz00_bglt) COBJECT(
							((BgL_setqz00_bglt) BgL_nz00_8201)))->BgL_valuez00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8202) (BgL_pz00_8202,
					((obj_t) BgL_arg2622z00_9529), BEOA);
			}
		}

	}



/* &walk3!-cast1827 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2cast1827za2zzast_walkz00(obj_t
		BgL_envz00_8203, obj_t BgL_nz00_8204, obj_t BgL_pz00_8205,
		obj_t BgL_arg0z00_8206, obj_t BgL_arg1z00_8207, obj_t BgL_arg2z00_8208)
	{
		{	/* Ast/walk.scm 300 */
			{
				BgL_nodez00_bglt BgL_auxz00_14597;

				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2620z00_9531;

					BgL_arg2620z00_9531 =
						(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8204)))->BgL_argz00);
					BgL_auxz00_14597 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8205) (BgL_pz00_8205,
							((obj_t) BgL_arg2620z00_9531), BgL_arg0z00_8206, BgL_arg1z00_8207,
							BgL_arg2z00_8208, BEOA));
				}
				((((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8204)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14597), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nz00_8204));
		}

	}



/* &walk2!-cast1825 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2cast1825za2zzast_walkz00(obj_t
		BgL_envz00_8209, obj_t BgL_nz00_8210, obj_t BgL_pz00_8211,
		obj_t BgL_arg0z00_8212, obj_t BgL_arg1z00_8213)
	{
		{	/* Ast/walk.scm 300 */
			{
				BgL_nodez00_bglt BgL_auxz00_14613;

				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2619z00_9533;

					BgL_arg2619z00_9533 =
						(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8210)))->BgL_argz00);
					BgL_auxz00_14613 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8211) (BgL_pz00_8211,
							((obj_t) BgL_arg2619z00_9533), BgL_arg0z00_8212, BgL_arg1z00_8213,
							BEOA));
				}
				((((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8210)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14613), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nz00_8210));
		}

	}



/* &walk1!-cast1823 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2cast1823za2zzast_walkz00(obj_t
		BgL_envz00_8214, obj_t BgL_nz00_8215, obj_t BgL_pz00_8216,
		obj_t BgL_arg0z00_8217)
	{
		{	/* Ast/walk.scm 300 */
			{
				BgL_nodez00_bglt BgL_auxz00_14628;

				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2618z00_9535;

					BgL_arg2618z00_9535 =
						(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8215)))->BgL_argz00);
					BgL_auxz00_14628 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8216) (BgL_pz00_8216,
							((obj_t) BgL_arg2618z00_9535), BgL_arg0z00_8217, BEOA));
				}
				((((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8215)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14628), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nz00_8215));
		}

	}



/* &walk0!-cast1821 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2cast1821za2zzast_walkz00(obj_t
		BgL_envz00_8218, obj_t BgL_nz00_8219, obj_t BgL_pz00_8220)
	{
		{	/* Ast/walk.scm 300 */
			{
				BgL_nodez00_bglt BgL_auxz00_14642;

				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2617z00_9537;

					BgL_arg2617z00_9537 =
						(((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8219)))->BgL_argz00);
					BgL_auxz00_14642 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8220) (BgL_pz00_8220,
							((obj_t) BgL_arg2617z00_9537), BEOA));
				}
				((((BgL_castz00_bglt) COBJECT(
								((BgL_castz00_bglt) BgL_nz00_8219)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14642), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_castz00_bglt) BgL_nz00_8219));
		}

	}



/* &walk3*-cast1819 */
	obj_t BGl_z62walk3za2zd2cast1819z12zzast_walkz00(obj_t BgL_envz00_8221,
		obj_t BgL_nz00_8222, obj_t BgL_pz00_8223, obj_t BgL_arg0z00_8224,
		obj_t BgL_arg1z00_8225, obj_t BgL_arg2z00_8226)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				obj_t BgL_res4066z00_9542;

				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2614z00_9539;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2616z00_9540;

						BgL_arg2616z00_9540 =
							(((BgL_castz00_bglt) COBJECT(
									((BgL_castz00_bglt) BgL_nz00_8222)))->BgL_argz00);
						BgL_arg2614z00_9539 =
							PROCEDURE_ENTRY(BgL_pz00_8223) (BgL_pz00_8223,
							((obj_t) BgL_arg2616z00_9540), BgL_arg0z00_8224, BgL_arg1z00_8225,
							BgL_arg2z00_8226, BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2615z00_9541;

						BgL_list2615z00_9541 = MAKE_YOUNG_PAIR(BgL_arg2614z00_9539, BNIL);
						BgL_res4066z00_9542 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2615z00_9541);
					}
				}
				return BgL_res4066z00_9542;
			}
		}

	}



/* &walk2*-cast1817 */
	obj_t BGl_z62walk2za2zd2cast1817z12zzast_walkz00(obj_t BgL_envz00_8227,
		obj_t BgL_nz00_8228, obj_t BgL_pz00_8229, obj_t BgL_arg0z00_8230,
		obj_t BgL_arg1z00_8231)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				obj_t BgL_res4067z00_9547;

				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2611z00_9544;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2613z00_9545;

						BgL_arg2613z00_9545 =
							(((BgL_castz00_bglt) COBJECT(
									((BgL_castz00_bglt) BgL_nz00_8228)))->BgL_argz00);
						BgL_arg2611z00_9544 =
							PROCEDURE_ENTRY(BgL_pz00_8229) (BgL_pz00_8229,
							((obj_t) BgL_arg2613z00_9545), BgL_arg0z00_8230, BgL_arg1z00_8231,
							BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2612z00_9546;

						BgL_list2612z00_9546 = MAKE_YOUNG_PAIR(BgL_arg2611z00_9544, BNIL);
						BgL_res4067z00_9547 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2612z00_9546);
					}
				}
				return BgL_res4067z00_9547;
			}
		}

	}



/* &walk1*-cast1815 */
	obj_t BGl_z62walk1za2zd2cast1815z12zzast_walkz00(obj_t BgL_envz00_8232,
		obj_t BgL_nz00_8233, obj_t BgL_pz00_8234, obj_t BgL_arg0z00_8235)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				obj_t BgL_res4068z00_9552;

				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2608z00_9549;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2610z00_9550;

						BgL_arg2610z00_9550 =
							(((BgL_castz00_bglt) COBJECT(
									((BgL_castz00_bglt) BgL_nz00_8233)))->BgL_argz00);
						BgL_arg2608z00_9549 =
							PROCEDURE_ENTRY(BgL_pz00_8234) (BgL_pz00_8234,
							((obj_t) BgL_arg2610z00_9550), BgL_arg0z00_8235, BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2609z00_9551;

						BgL_list2609z00_9551 = MAKE_YOUNG_PAIR(BgL_arg2608z00_9549, BNIL);
						BgL_res4068z00_9552 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2609z00_9551);
					}
				}
				return BgL_res4068z00_9552;
			}
		}

	}



/* &walk0*-cast1813 */
	obj_t BGl_z62walk0za2zd2cast1813z12zzast_walkz00(obj_t BgL_envz00_8236,
		obj_t BgL_nz00_8237, obj_t BgL_pz00_8238)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				obj_t BgL_res4069z00_9557;

				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2605z00_9554;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2607z00_9555;

						BgL_arg2607z00_9555 =
							(((BgL_castz00_bglt) COBJECT(
									((BgL_castz00_bglt) BgL_nz00_8237)))->BgL_argz00);
						BgL_arg2605z00_9554 =
							PROCEDURE_ENTRY(BgL_pz00_8238) (BgL_pz00_8238,
							((obj_t) BgL_arg2607z00_9555), BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2606z00_9556;

						BgL_list2606z00_9556 = MAKE_YOUNG_PAIR(BgL_arg2605z00_9554, BNIL);
						BgL_res4069z00_9557 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2606z00_9556);
					}
				}
				return BgL_res4069z00_9557;
			}
		}

	}



/* &walk3-cast1811 */
	obj_t BGl_z62walk3zd2cast1811zb0zzast_walkz00(obj_t BgL_envz00_8239,
		obj_t BgL_nz00_8240, obj_t BgL_pz00_8241, obj_t BgL_arg0z00_8242,
		obj_t BgL_arg1z00_8243, obj_t BgL_arg2z00_8244)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				BgL_nodez00_bglt BgL_arg2604z00_9559;

				BgL_arg2604z00_9559 =
					(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nz00_8240)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8241) (BgL_pz00_8241,
					((obj_t) BgL_arg2604z00_9559), BgL_arg0z00_8242, BgL_arg1z00_8243,
					BgL_arg2z00_8244, BEOA);
			}
		}

	}



/* &walk2-cast1809 */
	obj_t BGl_z62walk2zd2cast1809zb0zzast_walkz00(obj_t BgL_envz00_8245,
		obj_t BgL_nz00_8246, obj_t BgL_pz00_8247, obj_t BgL_arg0z00_8248,
		obj_t BgL_arg1z00_8249)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				BgL_nodez00_bglt BgL_arg2603z00_9561;

				BgL_arg2603z00_9561 =
					(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nz00_8246)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8247) (BgL_pz00_8247,
					((obj_t) BgL_arg2603z00_9561), BgL_arg0z00_8248, BgL_arg1z00_8249,
					BEOA);
			}
		}

	}



/* &walk1-cast1807 */
	obj_t BGl_z62walk1zd2cast1807zb0zzast_walkz00(obj_t BgL_envz00_8250,
		obj_t BgL_nz00_8251, obj_t BgL_pz00_8252, obj_t BgL_arg0z00_8253)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				BgL_nodez00_bglt BgL_arg2602z00_9563;

				BgL_arg2602z00_9563 =
					(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nz00_8251)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8252) (BgL_pz00_8252,
					((obj_t) BgL_arg2602z00_9563), BgL_arg0z00_8253, BEOA);
			}
		}

	}



/* &walk0-cast1805 */
	obj_t BGl_z62walk0zd2cast1805zb0zzast_walkz00(obj_t BgL_envz00_8254,
		obj_t BgL_nz00_8255, obj_t BgL_pz00_8256)
	{
		{	/* Ast/walk.scm 300 */
			{	/* Ast/walk.scm 300 */
				BgL_nodez00_bglt BgL_arg2601z00_9565;

				BgL_arg2601z00_9565 =
					(((BgL_castz00_bglt) COBJECT(
							((BgL_castz00_bglt) BgL_nz00_8255)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8256) (BgL_pz00_8256,
					((obj_t) BgL_arg2601z00_9565), BEOA);
			}
		}

	}



/* &walk3!-extern1803 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2extern1803za2zzast_walkz00(obj_t
		BgL_envz00_8257, obj_t BgL_nz00_8258, obj_t BgL_pz00_8259,
		obj_t BgL_arg0z00_8260, obj_t BgL_arg1z00_8261, obj_t BgL_arg2z00_8262)
	{
		{	/* Ast/walk.scm 299 */
			{
				obj_t BgL_fieldsz00_9568;

				BgL_fieldsz00_9568 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8258)))->BgL_exprza2za2);
			BgL_loopz00_9567:
				if (NULLP(BgL_fieldsz00_9568))
					{	/* Ast/walk.scm 299 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 299 */
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2597z00_9569;

							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2599z00_9570;

								BgL_arg2599z00_9570 = CAR(((obj_t) BgL_fieldsz00_9568));
								BgL_arg2597z00_9569 =
									PROCEDURE_ENTRY(BgL_pz00_8259) (BgL_pz00_8259,
									BgL_arg2599z00_9570, BgL_arg0z00_8260, BgL_arg1z00_8261,
									BgL_arg2z00_8262, BEOA);
							}
							{	/* Ast/walk.scm 299 */
								obj_t BgL_tmpz00_14742;

								BgL_tmpz00_14742 = ((obj_t) BgL_fieldsz00_9568);
								SET_CAR(BgL_tmpz00_14742, BgL_arg2597z00_9569);
							}
						}
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2600z00_9571;

							BgL_arg2600z00_9571 = CDR(((obj_t) BgL_fieldsz00_9568));
							{
								obj_t BgL_fieldsz00_14747;

								BgL_fieldsz00_14747 = BgL_arg2600z00_9571;
								BgL_fieldsz00_9568 = BgL_fieldsz00_14747;
								goto BgL_loopz00_9567;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nz00_8258));
		}

	}



/* &walk2!-extern1801 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2extern1801za2zzast_walkz00(obj_t
		BgL_envz00_8263, obj_t BgL_nz00_8264, obj_t BgL_pz00_8265,
		obj_t BgL_arg0z00_8266, obj_t BgL_arg1z00_8267)
	{
		{	/* Ast/walk.scm 299 */
			{
				obj_t BgL_fieldsz00_9574;

				BgL_fieldsz00_9574 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8264)))->BgL_exprza2za2);
			BgL_loopz00_9573:
				if (NULLP(BgL_fieldsz00_9574))
					{	/* Ast/walk.scm 299 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 299 */
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2591z00_9575;

							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2592z00_9576;

								BgL_arg2592z00_9576 = CAR(((obj_t) BgL_fieldsz00_9574));
								BgL_arg2591z00_9575 =
									PROCEDURE_ENTRY(BgL_pz00_8265) (BgL_pz00_8265,
									BgL_arg2592z00_9576, BgL_arg0z00_8266, BgL_arg1z00_8267,
									BEOA);
							}
							{	/* Ast/walk.scm 299 */
								obj_t BgL_tmpz00_14762;

								BgL_tmpz00_14762 = ((obj_t) BgL_fieldsz00_9574);
								SET_CAR(BgL_tmpz00_14762, BgL_arg2591z00_9575);
							}
						}
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2593z00_9577;

							BgL_arg2593z00_9577 = CDR(((obj_t) BgL_fieldsz00_9574));
							{
								obj_t BgL_fieldsz00_14767;

								BgL_fieldsz00_14767 = BgL_arg2593z00_9577;
								BgL_fieldsz00_9574 = BgL_fieldsz00_14767;
								goto BgL_loopz00_9573;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nz00_8264));
		}

	}



/* &walk1!-extern1799 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2extern1799za2zzast_walkz00(obj_t
		BgL_envz00_8268, obj_t BgL_nz00_8269, obj_t BgL_pz00_8270,
		obj_t BgL_arg0z00_8271)
	{
		{	/* Ast/walk.scm 299 */
			{
				obj_t BgL_fieldsz00_9580;

				BgL_fieldsz00_9580 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8269)))->BgL_exprza2za2);
			BgL_loopz00_9579:
				if (NULLP(BgL_fieldsz00_9580))
					{	/* Ast/walk.scm 299 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 299 */
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2583z00_9581;

							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2584z00_9582;

								BgL_arg2584z00_9582 = CAR(((obj_t) BgL_fieldsz00_9580));
								BgL_arg2583z00_9581 =
									PROCEDURE_ENTRY(BgL_pz00_8270) (BgL_pz00_8270,
									BgL_arg2584z00_9582, BgL_arg0z00_8271, BEOA);
							}
							{	/* Ast/walk.scm 299 */
								obj_t BgL_tmpz00_14781;

								BgL_tmpz00_14781 = ((obj_t) BgL_fieldsz00_9580);
								SET_CAR(BgL_tmpz00_14781, BgL_arg2583z00_9581);
							}
						}
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2585z00_9583;

							BgL_arg2585z00_9583 = CDR(((obj_t) BgL_fieldsz00_9580));
							{
								obj_t BgL_fieldsz00_14786;

								BgL_fieldsz00_14786 = BgL_arg2585z00_9583;
								BgL_fieldsz00_9580 = BgL_fieldsz00_14786;
								goto BgL_loopz00_9579;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nz00_8269));
		}

	}



/* &walk0!-extern1797 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2extern1797za2zzast_walkz00(obj_t
		BgL_envz00_8272, obj_t BgL_nz00_8273, obj_t BgL_pz00_8274)
	{
		{	/* Ast/walk.scm 299 */
			{
				obj_t BgL_fieldsz00_9586;

				BgL_fieldsz00_9586 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8273)))->BgL_exprza2za2);
			BgL_loopz00_9585:
				if (NULLP(BgL_fieldsz00_9586))
					{	/* Ast/walk.scm 299 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 299 */
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2577z00_9587;

							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2578z00_9588;

								BgL_arg2578z00_9588 = CAR(((obj_t) BgL_fieldsz00_9586));
								BgL_arg2577z00_9587 =
									PROCEDURE_ENTRY(BgL_pz00_8274) (BgL_pz00_8274,
									BgL_arg2578z00_9588, BEOA);
							}
							{	/* Ast/walk.scm 299 */
								obj_t BgL_tmpz00_14799;

								BgL_tmpz00_14799 = ((obj_t) BgL_fieldsz00_9586);
								SET_CAR(BgL_tmpz00_14799, BgL_arg2577z00_9587);
							}
						}
						{	/* Ast/walk.scm 299 */
							obj_t BgL_arg2579z00_9589;

							BgL_arg2579z00_9589 = CDR(((obj_t) BgL_fieldsz00_9586));
							{
								obj_t BgL_fieldsz00_14804;

								BgL_fieldsz00_14804 = BgL_arg2579z00_9589;
								BgL_fieldsz00_9586 = BgL_fieldsz00_14804;
								goto BgL_loopz00_9585;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_externz00_bglt) BgL_nz00_8273));
		}

	}



/* &walk3*-extern1795 */
	obj_t BGl_z62walk3za2zd2extern1795z12zzast_walkz00(obj_t BgL_envz00_8275,
		obj_t BgL_nz00_8276, obj_t BgL_pz00_8277, obj_t BgL_arg0z00_8278,
		obj_t BgL_arg1z00_8279, obj_t BgL_arg2z00_8280)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_res4070z00_9593;

				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2565z00_9591;

					BgL_arg2565z00_9591 =
						BGl_zc3z04anonymousza32567ze3ze70z60zzast_walkz00(BgL_arg2z00_8280,
						BgL_arg1z00_8279, BgL_arg0z00_8278, BgL_pz00_8277,
						(((BgL_externz00_bglt) COBJECT(((BgL_externz00_bglt)
										BgL_nz00_8276)))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2566z00_9592;

						BgL_list2566z00_9592 = MAKE_YOUNG_PAIR(BgL_arg2565z00_9591, BNIL);
						BgL_res4070z00_9593 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2566z00_9592);
					}
				}
				return BgL_res4070z00_9593;
			}
		}

	}



/* <@anonymous:2567>~0 */
	obj_t BGl_zc3z04anonymousza32567ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8620, obj_t BgL_arg1z00_8619, obj_t BgL_arg0z00_8618,
		obj_t BgL_pz00_8617, obj_t BgL_l1552z00_3465)
	{
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1552z00_3465))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2569z00_3468;
					obj_t BgL_arg2570z00_3469;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3470;

						BgL_fz00_3470 = CAR(((obj_t) BgL_l1552z00_3465));
						BgL_arg2569z00_3468 =
							PROCEDURE_ENTRY(BgL_pz00_8617) (BgL_pz00_8617, BgL_fz00_3470,
							BgL_arg0z00_8618, BgL_arg1z00_8619, BgL_arg2z00_8620, BEOA);
					}
					{	/* Ast/walk.scm 299 */
						obj_t BgL_arg2572z00_3471;

						BgL_arg2572z00_3471 = CDR(((obj_t) BgL_l1552z00_3465));
						BgL_arg2570z00_3469 =
							BGl_zc3z04anonymousza32567ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8620, BgL_arg1z00_8619, BgL_arg0z00_8618,
							BgL_pz00_8617, BgL_arg2572z00_3471);
					}
					return bgl_append2(BgL_arg2569z00_3468, BgL_arg2570z00_3469);
				}
		}

	}



/* &walk2*-extern1793 */
	obj_t BGl_z62walk2za2zd2extern1793z12zzast_walkz00(obj_t BgL_envz00_8281,
		obj_t BgL_nz00_8282, obj_t BgL_pz00_8283, obj_t BgL_arg0z00_8284,
		obj_t BgL_arg1z00_8285)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_res4071z00_9597;

				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2549z00_9595;

					BgL_arg2549z00_9595 =
						BGl_zc3z04anonymousza32551ze3ze70z60zzast_walkz00(BgL_arg1z00_8285,
						BgL_arg0z00_8284, BgL_pz00_8283,
						(((BgL_externz00_bglt) COBJECT(((BgL_externz00_bglt)
										BgL_nz00_8282)))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2550z00_9596;

						BgL_list2550z00_9596 = MAKE_YOUNG_PAIR(BgL_arg2549z00_9595, BNIL);
						BgL_res4071z00_9597 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2550z00_9596);
					}
				}
				return BgL_res4071z00_9597;
			}
		}

	}



/* <@anonymous:2551>~0 */
	obj_t BGl_zc3z04anonymousza32551ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8616, obj_t BgL_arg0z00_8615, obj_t BgL_pz00_8614,
		obj_t BgL_l1549z00_3444)
	{
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1549z00_3444))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2553z00_3447;
					obj_t BgL_arg2554z00_3448;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3449;

						BgL_fz00_3449 = CAR(((obj_t) BgL_l1549z00_3444));
						BgL_arg2553z00_3447 =
							PROCEDURE_ENTRY(BgL_pz00_8614) (BgL_pz00_8614, BgL_fz00_3449,
							BgL_arg0z00_8615, BgL_arg1z00_8616, BEOA);
					}
					{	/* Ast/walk.scm 299 */
						obj_t BgL_arg2557z00_3450;

						BgL_arg2557z00_3450 = CDR(((obj_t) BgL_l1549z00_3444));
						BgL_arg2554z00_3448 =
							BGl_zc3z04anonymousza32551ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8616, BgL_arg0z00_8615, BgL_pz00_8614,
							BgL_arg2557z00_3450);
					}
					return bgl_append2(BgL_arg2553z00_3447, BgL_arg2554z00_3448);
				}
		}

	}



/* &walk1*-extern1791 */
	obj_t BGl_z62walk1za2zd2extern1791z12zzast_walkz00(obj_t BgL_envz00_8286,
		obj_t BgL_nz00_8287, obj_t BgL_pz00_8288, obj_t BgL_arg0z00_8289)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_res4072z00_9601;

				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2542z00_9599;

					BgL_arg2542z00_9599 =
						BGl_zc3z04anonymousza32544ze3ze70z60zzast_walkz00(BgL_arg0z00_8289,
						BgL_pz00_8288,
						(((BgL_externz00_bglt) COBJECT(((BgL_externz00_bglt)
										BgL_nz00_8287)))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2543z00_9600;

						BgL_list2543z00_9600 = MAKE_YOUNG_PAIR(BgL_arg2542z00_9599, BNIL);
						BgL_res4072z00_9601 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2543z00_9600);
					}
				}
				return BgL_res4072z00_9601;
			}
		}

	}



/* <@anonymous:2544>~0 */
	obj_t BGl_zc3z04anonymousza32544ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8613, obj_t BgL_pz00_8612, obj_t BgL_l1546z00_3424)
	{
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1546z00_3424))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2546z00_3427;
					obj_t BgL_arg2547z00_3428;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3429;

						BgL_fz00_3429 = CAR(((obj_t) BgL_l1546z00_3424));
						BgL_arg2546z00_3427 =
							PROCEDURE_ENTRY(BgL_pz00_8612) (BgL_pz00_8612, BgL_fz00_3429,
							BgL_arg0z00_8613, BEOA);
					}
					{	/* Ast/walk.scm 299 */
						obj_t BgL_arg2548z00_3430;

						BgL_arg2548z00_3430 = CDR(((obj_t) BgL_l1546z00_3424));
						BgL_arg2547z00_3428 =
							BGl_zc3z04anonymousza32544ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8613, BgL_pz00_8612, BgL_arg2548z00_3430);
					}
					return bgl_append2(BgL_arg2546z00_3427, BgL_arg2547z00_3428);
				}
		}

	}



/* &walk0*-extern1789 */
	obj_t BGl_z62walk0za2zd2extern1789z12zzast_walkz00(obj_t BgL_envz00_8290,
		obj_t BgL_nz00_8291, obj_t BgL_pz00_8292)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_res4073z00_9605;

				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2533z00_9603;

					BgL_arg2533z00_9603 =
						BGl_zc3z04anonymousza32535ze3ze70z60zzast_walkz00(BgL_pz00_8292,
						(((BgL_externz00_bglt) COBJECT(
									((BgL_externz00_bglt) BgL_nz00_8291)))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2534z00_9604;

						BgL_list2534z00_9604 = MAKE_YOUNG_PAIR(BgL_arg2533z00_9603, BNIL);
						BgL_res4073z00_9605 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2534z00_9604);
					}
				}
				return BgL_res4073z00_9605;
			}
		}

	}



/* <@anonymous:2535>~0 */
	obj_t BGl_zc3z04anonymousza32535ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8611,
		obj_t BgL_l1543z00_3405)
	{
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1543z00_3405))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2538z00_3408;
					obj_t BgL_arg2539z00_3409;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3410;

						BgL_fz00_3410 = CAR(((obj_t) BgL_l1543z00_3405));
						BgL_arg2538z00_3408 =
							PROCEDURE_ENTRY(BgL_pz00_8611) (BgL_pz00_8611, BgL_fz00_3410,
							BEOA);
					}
					{	/* Ast/walk.scm 299 */
						obj_t BgL_arg2541z00_3411;

						BgL_arg2541z00_3411 = CDR(((obj_t) BgL_l1543z00_3405));
						BgL_arg2539z00_3409 =
							BGl_zc3z04anonymousza32535ze3ze70z60zzast_walkz00(BgL_pz00_8611,
							BgL_arg2541z00_3411);
					}
					return bgl_append2(BgL_arg2538z00_3408, BgL_arg2539z00_3409);
				}
		}

	}



/* &walk3-extern1787 */
	obj_t BGl_z62walk3zd2extern1787zb0zzast_walkz00(obj_t BgL_envz00_8293,
		obj_t BgL_nz00_8294, obj_t BgL_pz00_8295, obj_t BgL_arg0z00_8296,
		obj_t BgL_arg1z00_8297, obj_t BgL_arg2z00_8298)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_g1541z00_9607;

				BgL_g1541z00_9607 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8294)))->BgL_exprza2za2);
				{
					obj_t BgL_l1539z00_9609;

					{	/* Ast/walk.scm 299 */
						bool_t BgL_tmpz00_14885;

						BgL_l1539z00_9609 = BgL_g1541z00_9607;
					BgL_zc3z04anonymousza32530ze3z87_9608:
						if (PAIRP(BgL_l1539z00_9609))
							{	/* Ast/walk.scm 299 */
								{	/* Ast/walk.scm 299 */
									obj_t BgL_fz00_9610;

									BgL_fz00_9610 = CAR(BgL_l1539z00_9609);
									PROCEDURE_ENTRY(BgL_pz00_8295) (BgL_pz00_8295, BgL_fz00_9610,
										BgL_arg0z00_8296, BgL_arg1z00_8297, BgL_arg2z00_8298, BEOA);
								}
								{
									obj_t BgL_l1539z00_14896;

									BgL_l1539z00_14896 = CDR(BgL_l1539z00_9609);
									BgL_l1539z00_9609 = BgL_l1539z00_14896;
									goto BgL_zc3z04anonymousza32530ze3z87_9608;
								}
							}
						else
							{	/* Ast/walk.scm 299 */
								BgL_tmpz00_14885 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_14885);
					}
				}
			}
		}

	}



/* &walk2-extern1785 */
	obj_t BGl_z62walk2zd2extern1785zb0zzast_walkz00(obj_t BgL_envz00_8299,
		obj_t BgL_nz00_8300, obj_t BgL_pz00_8301, obj_t BgL_arg0z00_8302,
		obj_t BgL_arg1z00_8303)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_g1538z00_9612;

				BgL_g1538z00_9612 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8300)))->BgL_exprza2za2);
				{
					obj_t BgL_l1536z00_9614;

					{	/* Ast/walk.scm 299 */
						bool_t BgL_tmpz00_14901;

						BgL_l1536z00_9614 = BgL_g1538z00_9612;
					BgL_zc3z04anonymousza32526ze3z87_9613:
						if (PAIRP(BgL_l1536z00_9614))
							{	/* Ast/walk.scm 299 */
								{	/* Ast/walk.scm 299 */
									obj_t BgL_fz00_9615;

									BgL_fz00_9615 = CAR(BgL_l1536z00_9614);
									PROCEDURE_ENTRY(BgL_pz00_8301) (BgL_pz00_8301, BgL_fz00_9615,
										BgL_arg0z00_8302, BgL_arg1z00_8303, BEOA);
								}
								{
									obj_t BgL_l1536z00_14911;

									BgL_l1536z00_14911 = CDR(BgL_l1536z00_9614);
									BgL_l1536z00_9614 = BgL_l1536z00_14911;
									goto BgL_zc3z04anonymousza32526ze3z87_9613;
								}
							}
						else
							{	/* Ast/walk.scm 299 */
								BgL_tmpz00_14901 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_14901);
					}
				}
			}
		}

	}



/* &walk1-extern1783 */
	obj_t BGl_z62walk1zd2extern1783zb0zzast_walkz00(obj_t BgL_envz00_8304,
		obj_t BgL_nz00_8305, obj_t BgL_pz00_8306, obj_t BgL_arg0z00_8307)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_g1535z00_9617;

				BgL_g1535z00_9617 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8305)))->BgL_exprza2za2);
				{
					obj_t BgL_l1533z00_9619;

					{	/* Ast/walk.scm 299 */
						bool_t BgL_tmpz00_14916;

						BgL_l1533z00_9619 = BgL_g1535z00_9617;
					BgL_zc3z04anonymousza32522ze3z87_9618:
						if (PAIRP(BgL_l1533z00_9619))
							{	/* Ast/walk.scm 299 */
								{	/* Ast/walk.scm 299 */
									obj_t BgL_fz00_9620;

									BgL_fz00_9620 = CAR(BgL_l1533z00_9619);
									PROCEDURE_ENTRY(BgL_pz00_8306) (BgL_pz00_8306, BgL_fz00_9620,
										BgL_arg0z00_8307, BEOA);
								}
								{
									obj_t BgL_l1533z00_14925;

									BgL_l1533z00_14925 = CDR(BgL_l1533z00_9619);
									BgL_l1533z00_9619 = BgL_l1533z00_14925;
									goto BgL_zc3z04anonymousza32522ze3z87_9618;
								}
							}
						else
							{	/* Ast/walk.scm 299 */
								BgL_tmpz00_14916 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_14916);
					}
				}
			}
		}

	}



/* &walk0-extern1781 */
	obj_t BGl_z62walk0zd2extern1781zb0zzast_walkz00(obj_t BgL_envz00_8308,
		obj_t BgL_nz00_8309, obj_t BgL_pz00_8310)
	{
		{	/* Ast/walk.scm 299 */
			{	/* Ast/walk.scm 299 */
				obj_t BgL_g1532z00_9622;

				BgL_g1532z00_9622 =
					(((BgL_externz00_bglt) COBJECT(
							((BgL_externz00_bglt) BgL_nz00_8309)))->BgL_exprza2za2);
				{
					obj_t BgL_l1530z00_9624;

					{	/* Ast/walk.scm 299 */
						bool_t BgL_tmpz00_14930;

						BgL_l1530z00_9624 = BgL_g1532z00_9622;
					BgL_zc3z04anonymousza32518ze3z87_9623:
						if (PAIRP(BgL_l1530z00_9624))
							{	/* Ast/walk.scm 299 */
								{	/* Ast/walk.scm 299 */
									obj_t BgL_fz00_9625;

									BgL_fz00_9625 = CAR(BgL_l1530z00_9624);
									PROCEDURE_ENTRY(BgL_pz00_8310) (BgL_pz00_8310, BgL_fz00_9625,
										BEOA);
								}
								{
									obj_t BgL_l1530z00_14938;

									BgL_l1530z00_14938 = CDR(BgL_l1530z00_9624);
									BgL_l1530z00_9624 = BgL_l1530z00_14938;
									goto BgL_zc3z04anonymousza32518ze3z87_9623;
								}
							}
						else
							{	/* Ast/walk.scm 299 */
								BgL_tmpz00_14930 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_14930);
					}
				}
			}
		}

	}



/* &walk3!-funcall1779 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2funcall1779za2zzast_walkz00(obj_t
		BgL_envz00_8311, obj_t BgL_nz00_8312, obj_t BgL_pz00_8313,
		obj_t BgL_arg0z00_8314, obj_t BgL_arg1z00_8315, obj_t BgL_arg2z00_8316)
	{
		{	/* Ast/walk.scm 298 */
			{
				BgL_nodez00_bglt BgL_auxz00_14941;

				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2511z00_9627;

					BgL_arg2511z00_9627 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8312)))->BgL_funz00);
					BgL_auxz00_14941 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8313) (BgL_pz00_8313,
							((obj_t) BgL_arg2511z00_9627), BgL_arg0z00_8314, BgL_arg1z00_8315,
							BgL_arg2z00_8316, BEOA));
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8312)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14941), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9629;

				BgL_fieldsz00_9629 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8312)))->BgL_argsz00);
			BgL_loopz00_9628:
				if (NULLP(BgL_fieldsz00_9629))
					{	/* Ast/walk.scm 298 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 298 */
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2515z00_9630;

							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2516z00_9631;

								BgL_arg2516z00_9631 = CAR(((obj_t) BgL_fieldsz00_9629));
								BgL_arg2515z00_9630 =
									PROCEDURE_ENTRY(BgL_pz00_8313) (BgL_pz00_8313,
									BgL_arg2516z00_9631, BgL_arg0z00_8314, BgL_arg1z00_8315,
									BgL_arg2z00_8316, BEOA);
							}
							{	/* Ast/walk.scm 298 */
								obj_t BgL_tmpz00_14966;

								BgL_tmpz00_14966 = ((obj_t) BgL_fieldsz00_9629);
								SET_CAR(BgL_tmpz00_14966, BgL_arg2515z00_9630);
							}
						}
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2517z00_9632;

							BgL_arg2517z00_9632 = CDR(((obj_t) BgL_fieldsz00_9629));
							{
								obj_t BgL_fieldsz00_14971;

								BgL_fieldsz00_14971 = BgL_arg2517z00_9632;
								BgL_fieldsz00_9629 = BgL_fieldsz00_14971;
								goto BgL_loopz00_9628;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nz00_8312));
		}

	}



/* &walk2!-funcall1777 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2funcall1777za2zzast_walkz00(obj_t
		BgL_envz00_8317, obj_t BgL_nz00_8318, obj_t BgL_pz00_8319,
		obj_t BgL_arg0z00_8320, obj_t BgL_arg1z00_8321)
	{
		{	/* Ast/walk.scm 298 */
			{
				BgL_nodez00_bglt BgL_auxz00_14976;

				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2503z00_9634;

					BgL_arg2503z00_9634 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8318)))->BgL_funz00);
					BgL_auxz00_14976 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8319) (BgL_pz00_8319,
							((obj_t) BgL_arg2503z00_9634), BgL_arg0z00_8320, BgL_arg1z00_8321,
							BEOA));
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8318)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_14976), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9636;

				BgL_fieldsz00_9636 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8318)))->BgL_argsz00);
			BgL_loopz00_9635:
				if (NULLP(BgL_fieldsz00_9636))
					{	/* Ast/walk.scm 298 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 298 */
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2507z00_9637;

							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2509z00_9638;

								BgL_arg2509z00_9638 = CAR(((obj_t) BgL_fieldsz00_9636));
								BgL_arg2507z00_9637 =
									PROCEDURE_ENTRY(BgL_pz00_8319) (BgL_pz00_8319,
									BgL_arg2509z00_9638, BgL_arg0z00_8320, BgL_arg1z00_8321,
									BEOA);
							}
							{	/* Ast/walk.scm 298 */
								obj_t BgL_tmpz00_14999;

								BgL_tmpz00_14999 = ((obj_t) BgL_fieldsz00_9636);
								SET_CAR(BgL_tmpz00_14999, BgL_arg2507z00_9637);
							}
						}
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2510z00_9639;

							BgL_arg2510z00_9639 = CDR(((obj_t) BgL_fieldsz00_9636));
							{
								obj_t BgL_fieldsz00_15004;

								BgL_fieldsz00_15004 = BgL_arg2510z00_9639;
								BgL_fieldsz00_9636 = BgL_fieldsz00_15004;
								goto BgL_loopz00_9635;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nz00_8318));
		}

	}



/* &walk1!-funcall1775 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2funcall1775za2zzast_walkz00(obj_t
		BgL_envz00_8322, obj_t BgL_nz00_8323, obj_t BgL_pz00_8324,
		obj_t BgL_arg0z00_8325)
	{
		{	/* Ast/walk.scm 298 */
			{
				BgL_nodez00_bglt BgL_auxz00_15009;

				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2493z00_9641;

					BgL_arg2493z00_9641 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8323)))->BgL_funz00);
					BgL_auxz00_15009 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8324) (BgL_pz00_8324,
							((obj_t) BgL_arg2493z00_9641), BgL_arg0z00_8325, BEOA));
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8323)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15009), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9643;

				BgL_fieldsz00_9643 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8323)))->BgL_argsz00);
			BgL_loopz00_9642:
				if (NULLP(BgL_fieldsz00_9643))
					{	/* Ast/walk.scm 298 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 298 */
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2498z00_9644;

							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2500z00_9645;

								BgL_arg2500z00_9645 = CAR(((obj_t) BgL_fieldsz00_9643));
								BgL_arg2498z00_9644 =
									PROCEDURE_ENTRY(BgL_pz00_8324) (BgL_pz00_8324,
									BgL_arg2500z00_9645, BgL_arg0z00_8325, BEOA);
							}
							{	/* Ast/walk.scm 298 */
								obj_t BgL_tmpz00_15030;

								BgL_tmpz00_15030 = ((obj_t) BgL_fieldsz00_9643);
								SET_CAR(BgL_tmpz00_15030, BgL_arg2498z00_9644);
							}
						}
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2502z00_9646;

							BgL_arg2502z00_9646 = CDR(((obj_t) BgL_fieldsz00_9643));
							{
								obj_t BgL_fieldsz00_15035;

								BgL_fieldsz00_15035 = BgL_arg2502z00_9646;
								BgL_fieldsz00_9643 = BgL_fieldsz00_15035;
								goto BgL_loopz00_9642;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nz00_8323));
		}

	}



/* &walk0!-funcall1773 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2funcall1773za2zzast_walkz00(obj_t
		BgL_envz00_8326, obj_t BgL_nz00_8327, obj_t BgL_pz00_8328)
	{
		{	/* Ast/walk.scm 298 */
			{
				BgL_nodez00_bglt BgL_auxz00_15040;

				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2486z00_9648;

					BgL_arg2486z00_9648 =
						(((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8327)))->BgL_funz00);
					BgL_auxz00_15040 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8328) (BgL_pz00_8328,
							((obj_t) BgL_arg2486z00_9648), BEOA));
				}
				((((BgL_funcallz00_bglt) COBJECT(
								((BgL_funcallz00_bglt) BgL_nz00_8327)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15040), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9650;

				BgL_fieldsz00_9650 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8327)))->BgL_argsz00);
			BgL_loopz00_9649:
				if (NULLP(BgL_fieldsz00_9650))
					{	/* Ast/walk.scm 298 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 298 */
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2490z00_9651;

							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2491z00_9652;

								BgL_arg2491z00_9652 = CAR(((obj_t) BgL_fieldsz00_9650));
								BgL_arg2490z00_9651 =
									PROCEDURE_ENTRY(BgL_pz00_8328) (BgL_pz00_8328,
									BgL_arg2491z00_9652, BEOA);
							}
							{	/* Ast/walk.scm 298 */
								obj_t BgL_tmpz00_15059;

								BgL_tmpz00_15059 = ((obj_t) BgL_fieldsz00_9650);
								SET_CAR(BgL_tmpz00_15059, BgL_arg2490z00_9651);
							}
						}
						{	/* Ast/walk.scm 298 */
							obj_t BgL_arg2492z00_9653;

							BgL_arg2492z00_9653 = CDR(((obj_t) BgL_fieldsz00_9650));
							{
								obj_t BgL_fieldsz00_15064;

								BgL_fieldsz00_15064 = BgL_arg2492z00_9653;
								BgL_fieldsz00_9650 = BgL_fieldsz00_15064;
								goto BgL_loopz00_9649;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_funcallz00_bglt) BgL_nz00_8327));
		}

	}



/* &walk3*-funcall1771 */
	obj_t BGl_z62walk3za2zd2funcall1771z12zzast_walkz00(obj_t BgL_envz00_8329,
		obj_t BgL_nz00_8330, obj_t BgL_pz00_8331, obj_t BgL_arg0z00_8332,
		obj_t BgL_arg1z00_8333, obj_t BgL_arg2z00_8334)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				obj_t BgL_res4074z00_9658;

				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2473z00_9655;
					obj_t BgL_arg2474z00_9656;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2476z00_9657;

						BgL_arg2476z00_9657 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nz00_8330)))->BgL_funz00);
						BgL_arg2473z00_9655 =
							PROCEDURE_ENTRY(BgL_pz00_8331) (BgL_pz00_8331,
							((obj_t) BgL_arg2476z00_9657), BgL_arg0z00_8332, BgL_arg1z00_8333,
							BgL_arg2z00_8334, BEOA);
					}
					BgL_arg2474z00_9656 =
						BGl_zc3z04anonymousza32477ze3ze70z60zzast_walkz00(BgL_arg2z00_8334,
						BgL_arg1z00_8333, BgL_arg0z00_8332, BgL_pz00_8331,
						(((BgL_funcallz00_bglt) COBJECT(((BgL_funcallz00_bglt)
										BgL_nz00_8330)))->BgL_argsz00));
					BgL_res4074z00_9658 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2473z00_9655,
						BgL_arg2474z00_9656);
				}
				return BgL_res4074z00_9658;
			}
		}

	}



/* <@anonymous:2477>~0 */
	obj_t BGl_zc3z04anonymousza32477ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8610, obj_t BgL_arg1z00_8609, obj_t BgL_arg0z00_8608,
		obj_t BgL_pz00_8607, obj_t BgL_l1528z00_3255)
	{
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1528z00_3255))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2479z00_3258;
					obj_t BgL_arg2481z00_3259;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3260;

						BgL_fz00_3260 = CAR(((obj_t) BgL_l1528z00_3255));
						BgL_arg2479z00_3258 =
							PROCEDURE_ENTRY(BgL_pz00_8607) (BgL_pz00_8607, BgL_fz00_3260,
							BgL_arg0z00_8608, BgL_arg1z00_8609, BgL_arg2z00_8610, BEOA);
					}
					{	/* Ast/walk.scm 298 */
						obj_t BgL_arg2482z00_3261;

						BgL_arg2482z00_3261 = CDR(((obj_t) BgL_l1528z00_3255));
						BgL_arg2481z00_3259 =
							BGl_zc3z04anonymousza32477ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8610, BgL_arg1z00_8609, BgL_arg0z00_8608,
							BgL_pz00_8607, BgL_arg2482z00_3261);
					}
					return bgl_append2(BgL_arg2479z00_3258, BgL_arg2481z00_3259);
				}
		}

	}



/* &walk2*-funcall1769 */
	obj_t BGl_z62walk2za2zd2funcall1769z12zzast_walkz00(obj_t BgL_envz00_8335,
		obj_t BgL_nz00_8336, obj_t BgL_pz00_8337, obj_t BgL_arg0z00_8338,
		obj_t BgL_arg1z00_8339)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				obj_t BgL_res4075z00_9663;

				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2464z00_9660;
					obj_t BgL_arg2465z00_9661;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2466z00_9662;

						BgL_arg2466z00_9662 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nz00_8336)))->BgL_funz00);
						BgL_arg2464z00_9660 =
							PROCEDURE_ENTRY(BgL_pz00_8337) (BgL_pz00_8337,
							((obj_t) BgL_arg2466z00_9662), BgL_arg0z00_8338, BgL_arg1z00_8339,
							BEOA);
					}
					BgL_arg2465z00_9661 =
						BGl_zc3z04anonymousza32467ze3ze70z60zzast_walkz00(BgL_arg1z00_8339,
						BgL_arg0z00_8338, BgL_pz00_8337,
						(((BgL_funcallz00_bglt) COBJECT(((BgL_funcallz00_bglt)
										BgL_nz00_8336)))->BgL_argsz00));
					BgL_res4075z00_9663 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2464z00_9660,
						BgL_arg2465z00_9661);
				}
				return BgL_res4075z00_9663;
			}
		}

	}



/* <@anonymous:2467>~0 */
	obj_t BGl_zc3z04anonymousza32467ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8606, obj_t BgL_arg0z00_8605, obj_t BgL_pz00_8604,
		obj_t BgL_l1525z00_3233)
	{
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1525z00_3233))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2470z00_3236;
					obj_t BgL_arg2471z00_3237;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3238;

						BgL_fz00_3238 = CAR(((obj_t) BgL_l1525z00_3233));
						BgL_arg2470z00_3236 =
							PROCEDURE_ENTRY(BgL_pz00_8604) (BgL_pz00_8604, BgL_fz00_3238,
							BgL_arg0z00_8605, BgL_arg1z00_8606, BEOA);
					}
					{	/* Ast/walk.scm 298 */
						obj_t BgL_arg2472z00_3239;

						BgL_arg2472z00_3239 = CDR(((obj_t) BgL_l1525z00_3233));
						BgL_arg2471z00_3237 =
							BGl_zc3z04anonymousza32467ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8606, BgL_arg0z00_8605, BgL_pz00_8604,
							BgL_arg2472z00_3239);
					}
					return bgl_append2(BgL_arg2470z00_3236, BgL_arg2471z00_3237);
				}
		}

	}



/* &walk1*-funcall1767 */
	obj_t BGl_z62walk1za2zd2funcall1767z12zzast_walkz00(obj_t BgL_envz00_8340,
		obj_t BgL_nz00_8341, obj_t BgL_pz00_8342, obj_t BgL_arg0z00_8343)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				obj_t BgL_res4076z00_9668;

				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2455z00_9665;
					obj_t BgL_arg2456z00_9666;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2457z00_9667;

						BgL_arg2457z00_9667 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nz00_8341)))->BgL_funz00);
						BgL_arg2455z00_9665 =
							PROCEDURE_ENTRY(BgL_pz00_8342) (BgL_pz00_8342,
							((obj_t) BgL_arg2457z00_9667), BgL_arg0z00_8343, BEOA);
					}
					BgL_arg2456z00_9666 =
						BGl_zc3z04anonymousza32458ze3ze70z60zzast_walkz00(BgL_arg0z00_8343,
						BgL_pz00_8342,
						(((BgL_funcallz00_bglt) COBJECT(((BgL_funcallz00_bglt)
										BgL_nz00_8341)))->BgL_argsz00));
					BgL_res4076z00_9668 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2455z00_9665,
						BgL_arg2456z00_9666);
				}
				return BgL_res4076z00_9668;
			}
		}

	}



/* <@anonymous:2458>~0 */
	obj_t BGl_zc3z04anonymousza32458ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8603, obj_t BgL_pz00_8602, obj_t BgL_l1522z00_3212)
	{
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1522z00_3212))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2460z00_3215;
					obj_t BgL_arg2461z00_3216;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3217;

						BgL_fz00_3217 = CAR(((obj_t) BgL_l1522z00_3212));
						BgL_arg2460z00_3215 =
							PROCEDURE_ENTRY(BgL_pz00_8602) (BgL_pz00_8602, BgL_fz00_3217,
							BgL_arg0z00_8603, BEOA);
					}
					{	/* Ast/walk.scm 298 */
						obj_t BgL_arg2463z00_3218;

						BgL_arg2463z00_3218 = CDR(((obj_t) BgL_l1522z00_3212));
						BgL_arg2461z00_3216 =
							BGl_zc3z04anonymousza32458ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8603, BgL_pz00_8602, BgL_arg2463z00_3218);
					}
					return bgl_append2(BgL_arg2460z00_3215, BgL_arg2461z00_3216);
				}
		}

	}



/* &walk0*-funcall1765 */
	obj_t BGl_z62walk0za2zd2funcall1765z12zzast_walkz00(obj_t BgL_envz00_8344,
		obj_t BgL_nz00_8345, obj_t BgL_pz00_8346)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				obj_t BgL_res4077z00_9673;

				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2444z00_9670;
					obj_t BgL_arg2445z00_9671;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2446z00_9672;

						BgL_arg2446z00_9672 =
							(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nz00_8345)))->BgL_funz00);
						BgL_arg2444z00_9670 =
							PROCEDURE_ENTRY(BgL_pz00_8346) (BgL_pz00_8346,
							((obj_t) BgL_arg2446z00_9672), BEOA);
					}
					BgL_arg2445z00_9671 =
						BGl_zc3z04anonymousza32447ze3ze70z60zzast_walkz00(BgL_pz00_8346,
						(((BgL_funcallz00_bglt) COBJECT(
									((BgL_funcallz00_bglt) BgL_nz00_8345)))->BgL_argsz00));
					BgL_res4077z00_9673 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2444z00_9670,
						BgL_arg2445z00_9671);
				}
				return BgL_res4077z00_9673;
			}
		}

	}



/* <@anonymous:2447>~0 */
	obj_t BGl_zc3z04anonymousza32447ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8601,
		obj_t BgL_l1519z00_3192)
	{
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1519z00_3192))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2450z00_3195;
					obj_t BgL_arg2453z00_3196;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3197;

						BgL_fz00_3197 = CAR(((obj_t) BgL_l1519z00_3192));
						BgL_arg2450z00_3195 =
							PROCEDURE_ENTRY(BgL_pz00_8601) (BgL_pz00_8601, BgL_fz00_3197,
							BEOA);
					}
					{	/* Ast/walk.scm 298 */
						obj_t BgL_arg2454z00_3198;

						BgL_arg2454z00_3198 = CDR(((obj_t) BgL_l1519z00_3192));
						BgL_arg2453z00_3196 =
							BGl_zc3z04anonymousza32447ze3ze70z60zzast_walkz00(BgL_pz00_8601,
							BgL_arg2454z00_3198);
					}
					return bgl_append2(BgL_arg2450z00_3195, BgL_arg2453z00_3196);
				}
		}

	}



/* &walk3-funcall1763 */
	obj_t BGl_z62walk3zd2funcall1763zb0zzast_walkz00(obj_t BgL_envz00_8347,
		obj_t BgL_nz00_8348, obj_t BgL_pz00_8349, obj_t BgL_arg0z00_8350,
		obj_t BgL_arg1z00_8351, obj_t BgL_arg2z00_8352)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				BgL_nodez00_bglt BgL_arg2438z00_9675;

				BgL_arg2438z00_9675 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8348)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8349) (BgL_pz00_8349,
					((obj_t) BgL_arg2438z00_9675), BgL_arg0z00_8350, BgL_arg1z00_8351,
					BgL_arg2z00_8352, BEOA);
			}
			{	/* Ast/walk.scm 298 */
				obj_t BgL_g1517z00_9676;

				BgL_g1517z00_9676 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8348)))->BgL_argsz00);
				{
					obj_t BgL_l1515z00_9678;

					{	/* Ast/walk.scm 298 */
						bool_t BgL_tmpz00_15185;

						BgL_l1515z00_9678 = BgL_g1517z00_9676;
					BgL_zc3z04anonymousza32439ze3z87_9677:
						if (PAIRP(BgL_l1515z00_9678))
							{	/* Ast/walk.scm 298 */
								{	/* Ast/walk.scm 298 */
									obj_t BgL_fz00_9679;

									BgL_fz00_9679 = CAR(BgL_l1515z00_9678);
									PROCEDURE_ENTRY(BgL_pz00_8349) (BgL_pz00_8349, BgL_fz00_9679,
										BgL_arg0z00_8350, BgL_arg1z00_8351, BgL_arg2z00_8352, BEOA);
								}
								{
									obj_t BgL_l1515z00_15196;

									BgL_l1515z00_15196 = CDR(BgL_l1515z00_9678);
									BgL_l1515z00_9678 = BgL_l1515z00_15196;
									goto BgL_zc3z04anonymousza32439ze3z87_9677;
								}
							}
						else
							{	/* Ast/walk.scm 298 */
								BgL_tmpz00_15185 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15185);
					}
				}
			}
		}

	}



/* &walk2-funcall1761 */
	obj_t BGl_z62walk2zd2funcall1761zb0zzast_walkz00(obj_t BgL_envz00_8353,
		obj_t BgL_nz00_8354, obj_t BgL_pz00_8355, obj_t BgL_arg0z00_8356,
		obj_t BgL_arg1z00_8357)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				BgL_nodez00_bglt BgL_arg2434z00_9681;

				BgL_arg2434z00_9681 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8354)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8355) (BgL_pz00_8355,
					((obj_t) BgL_arg2434z00_9681), BgL_arg0z00_8356, BgL_arg1z00_8357,
					BEOA);
			}
			{	/* Ast/walk.scm 298 */
				obj_t BgL_g1514z00_9682;

				BgL_g1514z00_9682 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8354)))->BgL_argsz00);
				{
					obj_t BgL_l1512z00_9684;

					{	/* Ast/walk.scm 298 */
						bool_t BgL_tmpz00_15210;

						BgL_l1512z00_9684 = BgL_g1514z00_9682;
					BgL_zc3z04anonymousza32435ze3z87_9683:
						if (PAIRP(BgL_l1512z00_9684))
							{	/* Ast/walk.scm 298 */
								{	/* Ast/walk.scm 298 */
									obj_t BgL_fz00_9685;

									BgL_fz00_9685 = CAR(BgL_l1512z00_9684);
									PROCEDURE_ENTRY(BgL_pz00_8355) (BgL_pz00_8355, BgL_fz00_9685,
										BgL_arg0z00_8356, BgL_arg1z00_8357, BEOA);
								}
								{
									obj_t BgL_l1512z00_15220;

									BgL_l1512z00_15220 = CDR(BgL_l1512z00_9684);
									BgL_l1512z00_9684 = BgL_l1512z00_15220;
									goto BgL_zc3z04anonymousza32435ze3z87_9683;
								}
							}
						else
							{	/* Ast/walk.scm 298 */
								BgL_tmpz00_15210 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15210);
					}
				}
			}
		}

	}



/* &walk1-funcall1759 */
	obj_t BGl_z62walk1zd2funcall1759zb0zzast_walkz00(obj_t BgL_envz00_8358,
		obj_t BgL_nz00_8359, obj_t BgL_pz00_8360, obj_t BgL_arg0z00_8361)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				BgL_nodez00_bglt BgL_arg2429z00_9687;

				BgL_arg2429z00_9687 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8359)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8360) (BgL_pz00_8360,
					((obj_t) BgL_arg2429z00_9687), BgL_arg0z00_8361, BEOA);
			}
			{	/* Ast/walk.scm 298 */
				obj_t BgL_g1511z00_9688;

				BgL_g1511z00_9688 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8359)))->BgL_argsz00);
				{
					obj_t BgL_l1509z00_9690;

					{	/* Ast/walk.scm 298 */
						bool_t BgL_tmpz00_15233;

						BgL_l1509z00_9690 = BgL_g1511z00_9688;
					BgL_zc3z04anonymousza32430ze3z87_9689:
						if (PAIRP(BgL_l1509z00_9690))
							{	/* Ast/walk.scm 298 */
								{	/* Ast/walk.scm 298 */
									obj_t BgL_fz00_9691;

									BgL_fz00_9691 = CAR(BgL_l1509z00_9690);
									PROCEDURE_ENTRY(BgL_pz00_8360) (BgL_pz00_8360, BgL_fz00_9691,
										BgL_arg0z00_8361, BEOA);
								}
								{
									obj_t BgL_l1509z00_15242;

									BgL_l1509z00_15242 = CDR(BgL_l1509z00_9690);
									BgL_l1509z00_9690 = BgL_l1509z00_15242;
									goto BgL_zc3z04anonymousza32430ze3z87_9689;
								}
							}
						else
							{	/* Ast/walk.scm 298 */
								BgL_tmpz00_15233 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15233);
					}
				}
			}
		}

	}



/* &walk0-funcall1757 */
	obj_t BGl_z62walk0zd2funcall1757zb0zzast_walkz00(obj_t BgL_envz00_8362,
		obj_t BgL_nz00_8363, obj_t BgL_pz00_8364)
	{
		{	/* Ast/walk.scm 298 */
			{	/* Ast/walk.scm 298 */
				BgL_nodez00_bglt BgL_arg2425z00_9693;

				BgL_arg2425z00_9693 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8363)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8364) (BgL_pz00_8364,
					((obj_t) BgL_arg2425z00_9693), BEOA);
			}
			{	/* Ast/walk.scm 298 */
				obj_t BgL_g1508z00_9694;

				BgL_g1508z00_9694 =
					(((BgL_funcallz00_bglt) COBJECT(
							((BgL_funcallz00_bglt) BgL_nz00_8363)))->BgL_argsz00);
				{
					obj_t BgL_l1506z00_9696;

					{	/* Ast/walk.scm 298 */
						bool_t BgL_tmpz00_15254;

						BgL_l1506z00_9696 = BgL_g1508z00_9694;
					BgL_zc3z04anonymousza32426ze3z87_9695:
						if (PAIRP(BgL_l1506z00_9696))
							{	/* Ast/walk.scm 298 */
								{	/* Ast/walk.scm 298 */
									obj_t BgL_fz00_9697;

									BgL_fz00_9697 = CAR(BgL_l1506z00_9696);
									PROCEDURE_ENTRY(BgL_pz00_8364) (BgL_pz00_8364, BgL_fz00_9697,
										BEOA);
								}
								{
									obj_t BgL_l1506z00_15262;

									BgL_l1506z00_15262 = CDR(BgL_l1506z00_9696);
									BgL_l1506z00_9696 = BgL_l1506z00_15262;
									goto BgL_zc3z04anonymousza32426ze3z87_9695;
								}
							}
						else
							{	/* Ast/walk.scm 298 */
								BgL_tmpz00_15254 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15254);
					}
				}
			}
		}

	}



/* &walk3!-app-ly1755 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2appzd2ly1755z70zzast_walkz00(obj_t
		BgL_envz00_8365, obj_t BgL_nz00_8366, obj_t BgL_pz00_8367,
		obj_t BgL_arg0z00_8368, obj_t BgL_arg1z00_8369, obj_t BgL_arg2z00_8370)
	{
		{	/* Ast/walk.scm 297 */
			{
				BgL_nodez00_bglt BgL_auxz00_15265;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2422z00_9699;

					BgL_arg2422z00_9699 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8366)))->BgL_funz00);
					BgL_auxz00_15265 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8367) (BgL_pz00_8367,
							((obj_t) BgL_arg2422z00_9699), BgL_arg0z00_8368, BgL_arg1z00_8369,
							BgL_arg2z00_8370, BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8366)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15265), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_15279;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2423z00_9700;

					BgL_arg2423z00_9700 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8366)))->BgL_argz00);
					BgL_auxz00_15279 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8367) (BgL_pz00_8367,
							((obj_t) BgL_arg2423z00_9700), BgL_arg0z00_8368, BgL_arg1z00_8369,
							BgL_arg2z00_8370, BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8366)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15279), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nz00_8366));
		}

	}



/* &walk2!-app-ly1753 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2appzd2ly1753z70zzast_walkz00(obj_t
		BgL_envz00_8371, obj_t BgL_nz00_8372, obj_t BgL_pz00_8373,
		obj_t BgL_arg0z00_8374, obj_t BgL_arg1z00_8375)
	{
		{	/* Ast/walk.scm 297 */
			{
				BgL_nodez00_bglt BgL_auxz00_15295;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2420z00_9702;

					BgL_arg2420z00_9702 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8372)))->BgL_funz00);
					BgL_auxz00_15295 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8373) (BgL_pz00_8373,
							((obj_t) BgL_arg2420z00_9702), BgL_arg0z00_8374, BgL_arg1z00_8375,
							BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8372)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15295), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_15308;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2421z00_9703;

					BgL_arg2421z00_9703 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8372)))->BgL_argz00);
					BgL_auxz00_15308 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8373) (BgL_pz00_8373,
							((obj_t) BgL_arg2421z00_9703), BgL_arg0z00_8374, BgL_arg1z00_8375,
							BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8372)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15308), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nz00_8372));
		}

	}



/* &walk1!-app-ly1751 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2appzd2ly1751z70zzast_walkz00(obj_t
		BgL_envz00_8376, obj_t BgL_nz00_8377, obj_t BgL_pz00_8378,
		obj_t BgL_arg0z00_8379)
	{
		{	/* Ast/walk.scm 297 */
			{
				BgL_nodez00_bglt BgL_auxz00_15323;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2417z00_9705;

					BgL_arg2417z00_9705 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8377)))->BgL_funz00);
					BgL_auxz00_15323 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8378) (BgL_pz00_8378,
							((obj_t) BgL_arg2417z00_9705), BgL_arg0z00_8379, BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8377)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15323), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_15335;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2418z00_9706;

					BgL_arg2418z00_9706 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8377)))->BgL_argz00);
					BgL_auxz00_15335 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8378) (BgL_pz00_8378,
							((obj_t) BgL_arg2418z00_9706), BgL_arg0z00_8379, BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8377)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15335), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nz00_8377));
		}

	}



/* &walk0!-app-ly1749 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2appzd2ly1749z70zzast_walkz00(obj_t
		BgL_envz00_8380, obj_t BgL_nz00_8381, obj_t BgL_pz00_8382)
	{
		{	/* Ast/walk.scm 297 */
			{
				BgL_nodez00_bglt BgL_auxz00_15349;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2414z00_9708;

					BgL_arg2414z00_9708 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8381)))->BgL_funz00);
					BgL_auxz00_15349 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8382) (BgL_pz00_8382,
							((obj_t) BgL_arg2414z00_9708), BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8381)))->BgL_funz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15349), BUNSPEC);
			}
			{
				BgL_nodez00_bglt BgL_auxz00_15360;

				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2416z00_9709;

					BgL_arg2416z00_9709 =
						(((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8381)))->BgL_argz00);
					BgL_auxz00_15360 =
						((BgL_nodez00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8382) (BgL_pz00_8382,
							((obj_t) BgL_arg2416z00_9709), BEOA));
				}
				((((BgL_appzd2lyzd2_bglt) COBJECT(
								((BgL_appzd2lyzd2_bglt) BgL_nz00_8381)))->BgL_argz00) =
					((BgL_nodez00_bglt) BgL_auxz00_15360), BUNSPEC);
			}
			return ((BgL_nodez00_bglt) ((BgL_appzd2lyzd2_bglt) BgL_nz00_8381));
		}

	}



/* &walk3*-app-ly1747 */
	obj_t BGl_z62walk3za2zd2appzd2ly1747zc0zzast_walkz00(obj_t BgL_envz00_8383,
		obj_t BgL_nz00_8384, obj_t BgL_pz00_8385, obj_t BgL_arg0z00_8386,
		obj_t BgL_arg1z00_8387, obj_t BgL_arg2z00_8388)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				obj_t BgL_res4078z00_9715;

				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2409z00_9711;
					obj_t BgL_arg2410z00_9712;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2411z00_9713;

						BgL_arg2411z00_9713 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8384)))->BgL_funz00);
						BgL_arg2409z00_9711 =
							PROCEDURE_ENTRY(BgL_pz00_8385) (BgL_pz00_8385,
							((obj_t) BgL_arg2411z00_9713), BgL_arg0z00_8386, BgL_arg1z00_8387,
							BgL_arg2z00_8388, BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2412z00_9714;

						BgL_arg2412z00_9714 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8384)))->BgL_argz00);
						BgL_arg2410z00_9712 =
							PROCEDURE_ENTRY(BgL_pz00_8385) (BgL_pz00_8385,
							((obj_t) BgL_arg2412z00_9714), BgL_arg0z00_8386, BgL_arg1z00_8387,
							BgL_arg2z00_8388, BEOA);
					}
					BgL_res4078z00_9715 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2409z00_9711,
						BgL_arg2410z00_9712);
				}
				return BgL_res4078z00_9715;
			}
		}

	}



/* &walk2*-app-ly1745 */
	obj_t BGl_z62walk2za2zd2appzd2ly1745zc0zzast_walkz00(obj_t BgL_envz00_8389,
		obj_t BgL_nz00_8390, obj_t BgL_pz00_8391, obj_t BgL_arg0z00_8392,
		obj_t BgL_arg1z00_8393)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				obj_t BgL_res4079z00_9721;

				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2403z00_9717;
					obj_t BgL_arg2404z00_9718;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2405z00_9719;

						BgL_arg2405z00_9719 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8390)))->BgL_funz00);
						BgL_arg2403z00_9717 =
							PROCEDURE_ENTRY(BgL_pz00_8391) (BgL_pz00_8391,
							((obj_t) BgL_arg2405z00_9719), BgL_arg0z00_8392, BgL_arg1z00_8393,
							BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2407z00_9720;

						BgL_arg2407z00_9720 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8390)))->BgL_argz00);
						BgL_arg2404z00_9718 =
							PROCEDURE_ENTRY(BgL_pz00_8391) (BgL_pz00_8391,
							((obj_t) BgL_arg2407z00_9720), BgL_arg0z00_8392, BgL_arg1z00_8393,
							BEOA);
					}
					BgL_res4079z00_9721 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2403z00_9717,
						BgL_arg2404z00_9718);
				}
				return BgL_res4079z00_9721;
			}
		}

	}



/* &walk1*-app-ly1743 */
	obj_t BGl_z62walk1za2zd2appzd2ly1743zc0zzast_walkz00(obj_t BgL_envz00_8394,
		obj_t BgL_nz00_8395, obj_t BgL_pz00_8396, obj_t BgL_arg0z00_8397)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				obj_t BgL_res4080z00_9727;

				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2398z00_9723;
					obj_t BgL_arg2400z00_9724;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2401z00_9725;

						BgL_arg2401z00_9725 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8395)))->BgL_funz00);
						BgL_arg2398z00_9723 =
							PROCEDURE_ENTRY(BgL_pz00_8396) (BgL_pz00_8396,
							((obj_t) BgL_arg2401z00_9725), BgL_arg0z00_8397, BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2402z00_9726;

						BgL_arg2402z00_9726 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8395)))->BgL_argz00);
						BgL_arg2400z00_9724 =
							PROCEDURE_ENTRY(BgL_pz00_8396) (BgL_pz00_8396,
							((obj_t) BgL_arg2402z00_9726), BgL_arg0z00_8397, BEOA);
					}
					BgL_res4080z00_9727 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2398z00_9723,
						BgL_arg2400z00_9724);
				}
				return BgL_res4080z00_9727;
			}
		}

	}



/* &walk0*-app-ly1741 */
	obj_t BGl_z62walk0za2zd2appzd2ly1741zc0zzast_walkz00(obj_t BgL_envz00_8398,
		obj_t BgL_nz00_8399, obj_t BgL_pz00_8400)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				obj_t BgL_res4081z00_9733;

				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2394z00_9729;
					obj_t BgL_arg2395z00_9730;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2396z00_9731;

						BgL_arg2396z00_9731 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8399)))->BgL_funz00);
						BgL_arg2394z00_9729 =
							PROCEDURE_ENTRY(BgL_pz00_8400) (BgL_pz00_8400,
							((obj_t) BgL_arg2396z00_9731), BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2397z00_9732;

						BgL_arg2397z00_9732 =
							(((BgL_appzd2lyzd2_bglt) COBJECT(
									((BgL_appzd2lyzd2_bglt) BgL_nz00_8399)))->BgL_argz00);
						BgL_arg2395z00_9730 =
							PROCEDURE_ENTRY(BgL_pz00_8400) (BgL_pz00_8400,
							((obj_t) BgL_arg2397z00_9732), BEOA);
					}
					BgL_res4081z00_9733 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2394z00_9729,
						BgL_arg2395z00_9730);
				}
				return BgL_res4081z00_9733;
			}
		}

	}



/* &walk3-app-ly1739 */
	obj_t BGl_z62walk3zd2appzd2ly1739z62zzast_walkz00(obj_t BgL_envz00_8401,
		obj_t BgL_nz00_8402, obj_t BgL_pz00_8403, obj_t BgL_arg0z00_8404,
		obj_t BgL_arg1z00_8405, obj_t BgL_arg2z00_8406)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2391z00_9735;

				BgL_arg2391z00_9735 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8402)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8403) (BgL_pz00_8403,
					((obj_t) BgL_arg2391z00_9735), BgL_arg0z00_8404, BgL_arg1z00_8405,
					BgL_arg2z00_8406, BEOA);
			}
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2392z00_9736;

				BgL_arg2392z00_9736 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8402)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8403) (BgL_pz00_8403,
					((obj_t) BgL_arg2392z00_9736), BgL_arg0z00_8404, BgL_arg1z00_8405,
					BgL_arg2z00_8406, BEOA);
			}
		}

	}



/* &walk2-app-ly1737 */
	obj_t BGl_z62walk2zd2appzd2ly1737z62zzast_walkz00(obj_t BgL_envz00_8407,
		obj_t BgL_nz00_8408, obj_t BgL_pz00_8409, obj_t BgL_arg0z00_8410,
		obj_t BgL_arg1z00_8411)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2389z00_9738;

				BgL_arg2389z00_9738 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8408)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8409) (BgL_pz00_8409,
					((obj_t) BgL_arg2389z00_9738), BgL_arg0z00_8410, BgL_arg1z00_8411,
					BEOA);
			}
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2390z00_9739;

				BgL_arg2390z00_9739 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8408)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8409) (BgL_pz00_8409,
					((obj_t) BgL_arg2390z00_9739), BgL_arg0z00_8410, BgL_arg1z00_8411,
					BEOA);
			}
		}

	}



/* &walk1-app-ly1735 */
	obj_t BGl_z62walk1zd2appzd2ly1735z62zzast_walkz00(obj_t BgL_envz00_8412,
		obj_t BgL_nz00_8413, obj_t BgL_pz00_8414, obj_t BgL_arg0z00_8415)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2385z00_9741;

				BgL_arg2385z00_9741 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8413)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8414) (BgL_pz00_8414,
					((obj_t) BgL_arg2385z00_9741), BgL_arg0z00_8415, BEOA);
			}
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2387z00_9742;

				BgL_arg2387z00_9742 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8413)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8414) (BgL_pz00_8414,
					((obj_t) BgL_arg2387z00_9742), BgL_arg0z00_8415, BEOA);
			}
		}

	}



/* &walk0-app-ly1733 */
	obj_t BGl_z62walk0zd2appzd2ly1733z62zzast_walkz00(obj_t BgL_envz00_8416,
		obj_t BgL_nz00_8417, obj_t BgL_pz00_8418)
	{
		{	/* Ast/walk.scm 297 */
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2383z00_9744;

				BgL_arg2383z00_9744 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8417)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8418) (BgL_pz00_8418,
					((obj_t) BgL_arg2383z00_9744), BEOA);
			}
			{	/* Ast/walk.scm 297 */
				BgL_nodez00_bglt BgL_arg2384z00_9745;

				BgL_arg2384z00_9745 =
					(((BgL_appzd2lyzd2_bglt) COBJECT(
							((BgL_appzd2lyzd2_bglt) BgL_nz00_8417)))->BgL_argz00);
				return
					PROCEDURE_ENTRY(BgL_pz00_8418) (BgL_pz00_8418,
					((obj_t) BgL_arg2384z00_9745), BEOA);
			}
		}

	}



/* &walk3!-app1731 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2app1731za2zzast_walkz00(obj_t
		BgL_envz00_8419, obj_t BgL_nz00_8420, obj_t BgL_pz00_8421,
		obj_t BgL_arg0z00_8422, obj_t BgL_arg1z00_8423, obj_t BgL_arg2z00_8424)
	{
		{	/* Ast/walk.scm 296 */
			{
				BgL_varz00_bglt BgL_auxz00_15513;

				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2376z00_9747;

					BgL_arg2376z00_9747 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8420)))->BgL_funz00);
					BgL_auxz00_15513 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8421) (BgL_pz00_8421,
							((obj_t) BgL_arg2376z00_9747), BgL_arg0z00_8422, BgL_arg1z00_8423,
							BgL_arg2z00_8424, BEOA));
				}
				((((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8420)))->BgL_funz00) =
					((BgL_varz00_bglt) BgL_auxz00_15513), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9749;

				BgL_fieldsz00_9749 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8420)))->BgL_argsz00);
			BgL_loopz00_9748:
				if (NULLP(BgL_fieldsz00_9749))
					{	/* Ast/walk.scm 296 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 296 */
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2380z00_9750;

							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2381z00_9751;

								BgL_arg2381z00_9751 = CAR(((obj_t) BgL_fieldsz00_9749));
								BgL_arg2380z00_9750 =
									PROCEDURE_ENTRY(BgL_pz00_8421) (BgL_pz00_8421,
									BgL_arg2381z00_9751, BgL_arg0z00_8422, BgL_arg1z00_8423,
									BgL_arg2z00_8424, BEOA);
							}
							{	/* Ast/walk.scm 296 */
								obj_t BgL_tmpz00_15538;

								BgL_tmpz00_15538 = ((obj_t) BgL_fieldsz00_9749);
								SET_CAR(BgL_tmpz00_15538, BgL_arg2380z00_9750);
							}
						}
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2382z00_9752;

							BgL_arg2382z00_9752 = CDR(((obj_t) BgL_fieldsz00_9749));
							{
								obj_t BgL_fieldsz00_15543;

								BgL_fieldsz00_15543 = BgL_arg2382z00_9752;
								BgL_fieldsz00_9749 = BgL_fieldsz00_15543;
								goto BgL_loopz00_9748;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nz00_8420));
		}

	}



/* &walk2!-app1729 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2app1729za2zzast_walkz00(obj_t
		BgL_envz00_8425, obj_t BgL_nz00_8426, obj_t BgL_pz00_8427,
		obj_t BgL_arg0z00_8428, obj_t BgL_arg1z00_8429)
	{
		{	/* Ast/walk.scm 296 */
			{
				BgL_varz00_bglt BgL_auxz00_15548;

				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2369z00_9754;

					BgL_arg2369z00_9754 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8426)))->BgL_funz00);
					BgL_auxz00_15548 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8427) (BgL_pz00_8427,
							((obj_t) BgL_arg2369z00_9754), BgL_arg0z00_8428, BgL_arg1z00_8429,
							BEOA));
				}
				((((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8426)))->BgL_funz00) =
					((BgL_varz00_bglt) BgL_auxz00_15548), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9756;

				BgL_fieldsz00_9756 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8426)))->BgL_argsz00);
			BgL_loopz00_9755:
				if (NULLP(BgL_fieldsz00_9756))
					{	/* Ast/walk.scm 296 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 296 */
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2373z00_9757;

							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2374z00_9758;

								BgL_arg2374z00_9758 = CAR(((obj_t) BgL_fieldsz00_9756));
								BgL_arg2373z00_9757 =
									PROCEDURE_ENTRY(BgL_pz00_8427) (BgL_pz00_8427,
									BgL_arg2374z00_9758, BgL_arg0z00_8428, BgL_arg1z00_8429,
									BEOA);
							}
							{	/* Ast/walk.scm 296 */
								obj_t BgL_tmpz00_15571;

								BgL_tmpz00_15571 = ((obj_t) BgL_fieldsz00_9756);
								SET_CAR(BgL_tmpz00_15571, BgL_arg2373z00_9757);
							}
						}
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2375z00_9759;

							BgL_arg2375z00_9759 = CDR(((obj_t) BgL_fieldsz00_9756));
							{
								obj_t BgL_fieldsz00_15576;

								BgL_fieldsz00_15576 = BgL_arg2375z00_9759;
								BgL_fieldsz00_9756 = BgL_fieldsz00_15576;
								goto BgL_loopz00_9755;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nz00_8426));
		}

	}



/* &walk1!-app1727 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2app1727za2zzast_walkz00(obj_t
		BgL_envz00_8430, obj_t BgL_nz00_8431, obj_t BgL_pz00_8432,
		obj_t BgL_arg0z00_8433)
	{
		{	/* Ast/walk.scm 296 */
			{
				BgL_varz00_bglt BgL_auxz00_15581;

				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2362z00_9761;

					BgL_arg2362z00_9761 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8431)))->BgL_funz00);
					BgL_auxz00_15581 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8432) (BgL_pz00_8432,
							((obj_t) BgL_arg2362z00_9761), BgL_arg0z00_8433, BEOA));
				}
				((((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8431)))->BgL_funz00) =
					((BgL_varz00_bglt) BgL_auxz00_15581), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9763;

				BgL_fieldsz00_9763 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8431)))->BgL_argsz00);
			BgL_loopz00_9762:
				if (NULLP(BgL_fieldsz00_9763))
					{	/* Ast/walk.scm 296 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 296 */
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2366z00_9764;

							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2367z00_9765;

								BgL_arg2367z00_9765 = CAR(((obj_t) BgL_fieldsz00_9763));
								BgL_arg2366z00_9764 =
									PROCEDURE_ENTRY(BgL_pz00_8432) (BgL_pz00_8432,
									BgL_arg2367z00_9765, BgL_arg0z00_8433, BEOA);
							}
							{	/* Ast/walk.scm 296 */
								obj_t BgL_tmpz00_15602;

								BgL_tmpz00_15602 = ((obj_t) BgL_fieldsz00_9763);
								SET_CAR(BgL_tmpz00_15602, BgL_arg2366z00_9764);
							}
						}
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2368z00_9766;

							BgL_arg2368z00_9766 = CDR(((obj_t) BgL_fieldsz00_9763));
							{
								obj_t BgL_fieldsz00_15607;

								BgL_fieldsz00_15607 = BgL_arg2368z00_9766;
								BgL_fieldsz00_9763 = BgL_fieldsz00_15607;
								goto BgL_loopz00_9762;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nz00_8431));
		}

	}



/* &walk0!-app1725 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2app1725za2zzast_walkz00(obj_t
		BgL_envz00_8434, obj_t BgL_nz00_8435, obj_t BgL_pz00_8436)
	{
		{	/* Ast/walk.scm 296 */
			{
				BgL_varz00_bglt BgL_auxz00_15612;

				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2355z00_9768;

					BgL_arg2355z00_9768 =
						(((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8435)))->BgL_funz00);
					BgL_auxz00_15612 =
						((BgL_varz00_bglt)
						PROCEDURE_ENTRY(BgL_pz00_8436) (BgL_pz00_8436,
							((obj_t) BgL_arg2355z00_9768), BEOA));
				}
				((((BgL_appz00_bglt) COBJECT(
								((BgL_appz00_bglt) BgL_nz00_8435)))->BgL_funz00) =
					((BgL_varz00_bglt) BgL_auxz00_15612), BUNSPEC);
			}
			{
				obj_t BgL_fieldsz00_9770;

				BgL_fieldsz00_9770 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8435)))->BgL_argsz00);
			BgL_loopz00_9769:
				if (NULLP(BgL_fieldsz00_9770))
					{	/* Ast/walk.scm 296 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 296 */
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2359z00_9771;

							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2360z00_9772;

								BgL_arg2360z00_9772 = CAR(((obj_t) BgL_fieldsz00_9770));
								BgL_arg2359z00_9771 =
									PROCEDURE_ENTRY(BgL_pz00_8436) (BgL_pz00_8436,
									BgL_arg2360z00_9772, BEOA);
							}
							{	/* Ast/walk.scm 296 */
								obj_t BgL_tmpz00_15631;

								BgL_tmpz00_15631 = ((obj_t) BgL_fieldsz00_9770);
								SET_CAR(BgL_tmpz00_15631, BgL_arg2359z00_9771);
							}
						}
						{	/* Ast/walk.scm 296 */
							obj_t BgL_arg2361z00_9773;

							BgL_arg2361z00_9773 = CDR(((obj_t) BgL_fieldsz00_9770));
							{
								obj_t BgL_fieldsz00_15636;

								BgL_fieldsz00_15636 = BgL_arg2361z00_9773;
								BgL_fieldsz00_9770 = BgL_fieldsz00_15636;
								goto BgL_loopz00_9769;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_appz00_bglt) BgL_nz00_8435));
		}

	}



/* &walk3*-app1723 */
	obj_t BGl_z62walk3za2zd2app1723z12zzast_walkz00(obj_t BgL_envz00_8437,
		obj_t BgL_nz00_8438, obj_t BgL_pz00_8439, obj_t BgL_arg0z00_8440,
		obj_t BgL_arg1z00_8441, obj_t BgL_arg2z00_8442)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				obj_t BgL_res4082z00_9778;

				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2345z00_9775;
					obj_t BgL_arg2348z00_9776;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2349z00_9777;

						BgL_arg2349z00_9777 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nz00_8438)))->BgL_funz00);
						BgL_arg2345z00_9775 =
							PROCEDURE_ENTRY(BgL_pz00_8439) (BgL_pz00_8439,
							((obj_t) BgL_arg2349z00_9777), BgL_arg0z00_8440, BgL_arg1z00_8441,
							BgL_arg2z00_8442, BEOA);
					}
					BgL_arg2348z00_9776 =
						BGl_zc3z04anonymousza32350ze3ze70z60zzast_walkz00(BgL_arg2z00_8442,
						BgL_arg1z00_8441, BgL_arg0z00_8440, BgL_pz00_8439,
						(((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt) BgL_nz00_8438)))->
							BgL_argsz00));
					BgL_res4082z00_9778 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2345z00_9775,
						BgL_arg2348z00_9776);
				}
				return BgL_res4082z00_9778;
			}
		}

	}



/* <@anonymous:2350>~0 */
	obj_t BGl_zc3z04anonymousza32350ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8600, obj_t BgL_arg1z00_8599, obj_t BgL_arg0z00_8598,
		obj_t BgL_pz00_8597, obj_t BgL_l1504z00_2915)
	{
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1504z00_2915))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2352z00_2918;
					obj_t BgL_arg2353z00_2919;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2920;

						BgL_fz00_2920 = CAR(((obj_t) BgL_l1504z00_2915));
						BgL_arg2352z00_2918 =
							PROCEDURE_ENTRY(BgL_pz00_8597) (BgL_pz00_8597, BgL_fz00_2920,
							BgL_arg0z00_8598, BgL_arg1z00_8599, BgL_arg2z00_8600, BEOA);
					}
					{	/* Ast/walk.scm 296 */
						obj_t BgL_arg2354z00_2921;

						BgL_arg2354z00_2921 = CDR(((obj_t) BgL_l1504z00_2915));
						BgL_arg2353z00_2919 =
							BGl_zc3z04anonymousza32350ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8600, BgL_arg1z00_8599, BgL_arg0z00_8598,
							BgL_pz00_8597, BgL_arg2354z00_2921);
					}
					return bgl_append2(BgL_arg2352z00_2918, BgL_arg2353z00_2919);
				}
		}

	}



/* &walk2*-app1721 */
	obj_t BGl_z62walk2za2zd2app1721z12zzast_walkz00(obj_t BgL_envz00_8443,
		obj_t BgL_nz00_8444, obj_t BgL_pz00_8445, obj_t BgL_arg0z00_8446,
		obj_t BgL_arg1z00_8447)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				obj_t BgL_res4083z00_9783;

				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2336z00_9780;
					obj_t BgL_arg2337z00_9781;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2338z00_9782;

						BgL_arg2338z00_9782 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nz00_8444)))->BgL_funz00);
						BgL_arg2336z00_9780 =
							PROCEDURE_ENTRY(BgL_pz00_8445) (BgL_pz00_8445,
							((obj_t) BgL_arg2338z00_9782), BgL_arg0z00_8446, BgL_arg1z00_8447,
							BEOA);
					}
					BgL_arg2337z00_9781 =
						BGl_zc3z04anonymousza32339ze3ze70z60zzast_walkz00(BgL_arg1z00_8447,
						BgL_arg0z00_8446, BgL_pz00_8445,
						(((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt) BgL_nz00_8444)))->
							BgL_argsz00));
					BgL_res4083z00_9783 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2336z00_9780,
						BgL_arg2337z00_9781);
				}
				return BgL_res4083z00_9783;
			}
		}

	}



/* <@anonymous:2339>~0 */
	obj_t BGl_zc3z04anonymousza32339ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8596, obj_t BgL_arg0z00_8595, obj_t BgL_pz00_8594,
		obj_t BgL_l1501z00_2893)
	{
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1501z00_2893))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2341z00_2896;
					obj_t BgL_arg2342z00_2897;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2898;

						BgL_fz00_2898 = CAR(((obj_t) BgL_l1501z00_2893));
						BgL_arg2341z00_2896 =
							PROCEDURE_ENTRY(BgL_pz00_8594) (BgL_pz00_8594, BgL_fz00_2898,
							BgL_arg0z00_8595, BgL_arg1z00_8596, BEOA);
					}
					{	/* Ast/walk.scm 296 */
						obj_t BgL_arg2344z00_2899;

						BgL_arg2344z00_2899 = CDR(((obj_t) BgL_l1501z00_2893));
						BgL_arg2342z00_2897 =
							BGl_zc3z04anonymousza32339ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8596, BgL_arg0z00_8595, BgL_pz00_8594,
							BgL_arg2344z00_2899);
					}
					return bgl_append2(BgL_arg2341z00_2896, BgL_arg2342z00_2897);
				}
		}

	}



/* &walk1*-app1719 */
	obj_t BGl_z62walk1za2zd2app1719z12zzast_walkz00(obj_t BgL_envz00_8448,
		obj_t BgL_nz00_8449, obj_t BgL_pz00_8450, obj_t BgL_arg0z00_8451)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				obj_t BgL_res4084z00_9788;

				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2327z00_9785;
					obj_t BgL_arg2329z00_9786;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2330z00_9787;

						BgL_arg2330z00_9787 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nz00_8449)))->BgL_funz00);
						BgL_arg2327z00_9785 =
							PROCEDURE_ENTRY(BgL_pz00_8450) (BgL_pz00_8450,
							((obj_t) BgL_arg2330z00_9787), BgL_arg0z00_8451, BEOA);
					}
					BgL_arg2329z00_9786 =
						BGl_zc3z04anonymousza32331ze3ze70z60zzast_walkz00(BgL_arg0z00_8451,
						BgL_pz00_8450,
						(((BgL_appz00_bglt) COBJECT(((BgL_appz00_bglt) BgL_nz00_8449)))->
							BgL_argsz00));
					BgL_res4084z00_9788 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2327z00_9785,
						BgL_arg2329z00_9786);
				}
				return BgL_res4084z00_9788;
			}
		}

	}



/* <@anonymous:2331>~0 */
	obj_t BGl_zc3z04anonymousza32331ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8593, obj_t BgL_pz00_8592, obj_t BgL_l1498z00_2872)
	{
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1498z00_2872))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2333z00_2875;
					obj_t BgL_arg2334z00_2876;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2877;

						BgL_fz00_2877 = CAR(((obj_t) BgL_l1498z00_2872));
						BgL_arg2333z00_2875 =
							PROCEDURE_ENTRY(BgL_pz00_8592) (BgL_pz00_8592, BgL_fz00_2877,
							BgL_arg0z00_8593, BEOA);
					}
					{	/* Ast/walk.scm 296 */
						obj_t BgL_arg2335z00_2878;

						BgL_arg2335z00_2878 = CDR(((obj_t) BgL_l1498z00_2872));
						BgL_arg2334z00_2876 =
							BGl_zc3z04anonymousza32331ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8593, BgL_pz00_8592, BgL_arg2335z00_2878);
					}
					return bgl_append2(BgL_arg2333z00_2875, BgL_arg2334z00_2876);
				}
		}

	}



/* &walk0*-app1717 */
	obj_t BGl_z62walk0za2zd2app1717z12zzast_walkz00(obj_t BgL_envz00_8452,
		obj_t BgL_nz00_8453, obj_t BgL_pz00_8454)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				obj_t BgL_res4085z00_9793;

				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2319z00_9790;
					obj_t BgL_arg2320z00_9791;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2321z00_9792;

						BgL_arg2321z00_9792 =
							(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nz00_8453)))->BgL_funz00);
						BgL_arg2319z00_9790 =
							PROCEDURE_ENTRY(BgL_pz00_8454) (BgL_pz00_8454,
							((obj_t) BgL_arg2321z00_9792), BEOA);
					}
					BgL_arg2320z00_9791 =
						BGl_zc3z04anonymousza32322ze3ze70z60zzast_walkz00(BgL_pz00_8454,
						(((BgL_appz00_bglt) COBJECT(
									((BgL_appz00_bglt) BgL_nz00_8453)))->BgL_argsz00));
					BgL_res4085z00_9793 =
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2319z00_9790,
						BgL_arg2320z00_9791);
				}
				return BgL_res4085z00_9793;
			}
		}

	}



/* <@anonymous:2322>~0 */
	obj_t BGl_zc3z04anonymousza32322ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8591,
		obj_t BgL_l1495z00_2852)
	{
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1495z00_2852))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2324z00_2855;
					obj_t BgL_arg2325z00_2856;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2857;

						BgL_fz00_2857 = CAR(((obj_t) BgL_l1495z00_2852));
						BgL_arg2324z00_2855 =
							PROCEDURE_ENTRY(BgL_pz00_8591) (BgL_pz00_8591, BgL_fz00_2857,
							BEOA);
					}
					{	/* Ast/walk.scm 296 */
						obj_t BgL_arg2326z00_2858;

						BgL_arg2326z00_2858 = CDR(((obj_t) BgL_l1495z00_2852));
						BgL_arg2325z00_2856 =
							BGl_zc3z04anonymousza32322ze3ze70z60zzast_walkz00(BgL_pz00_8591,
							BgL_arg2326z00_2858);
					}
					return bgl_append2(BgL_arg2324z00_2855, BgL_arg2325z00_2856);
				}
		}

	}



/* &walk3-app1715 */
	obj_t BGl_z62walk3zd2app1715zb0zzast_walkz00(obj_t BgL_envz00_8455,
		obj_t BgL_nz00_8456, obj_t BgL_pz00_8457, obj_t BgL_arg0z00_8458,
		obj_t BgL_arg1z00_8459, obj_t BgL_arg2z00_8460)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				BgL_varz00_bglt BgL_arg2314z00_9795;

				BgL_arg2314z00_9795 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8456)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8457) (BgL_pz00_8457,
					((obj_t) BgL_arg2314z00_9795), BgL_arg0z00_8458, BgL_arg1z00_8459,
					BgL_arg2z00_8460, BEOA);
			}
			{	/* Ast/walk.scm 296 */
				obj_t BgL_g1493z00_9796;

				BgL_g1493z00_9796 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8456)))->BgL_argsz00);
				{
					obj_t BgL_l1491z00_9798;

					{	/* Ast/walk.scm 296 */
						bool_t BgL_tmpz00_15757;

						BgL_l1491z00_9798 = BgL_g1493z00_9796;
					BgL_zc3z04anonymousza32315ze3z87_9797:
						if (PAIRP(BgL_l1491z00_9798))
							{	/* Ast/walk.scm 296 */
								{	/* Ast/walk.scm 296 */
									obj_t BgL_fz00_9799;

									BgL_fz00_9799 = CAR(BgL_l1491z00_9798);
									PROCEDURE_ENTRY(BgL_pz00_8457) (BgL_pz00_8457, BgL_fz00_9799,
										BgL_arg0z00_8458, BgL_arg1z00_8459, BgL_arg2z00_8460, BEOA);
								}
								{
									obj_t BgL_l1491z00_15768;

									BgL_l1491z00_15768 = CDR(BgL_l1491z00_9798);
									BgL_l1491z00_9798 = BgL_l1491z00_15768;
									goto BgL_zc3z04anonymousza32315ze3z87_9797;
								}
							}
						else
							{	/* Ast/walk.scm 296 */
								BgL_tmpz00_15757 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15757);
					}
				}
			}
		}

	}



/* &walk2-app1713 */
	obj_t BGl_z62walk2zd2app1713zb0zzast_walkz00(obj_t BgL_envz00_8461,
		obj_t BgL_nz00_8462, obj_t BgL_pz00_8463, obj_t BgL_arg0z00_8464,
		obj_t BgL_arg1z00_8465)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				BgL_varz00_bglt BgL_arg2308z00_9801;

				BgL_arg2308z00_9801 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8462)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8463) (BgL_pz00_8463,
					((obj_t) BgL_arg2308z00_9801), BgL_arg0z00_8464, BgL_arg1z00_8465,
					BEOA);
			}
			{	/* Ast/walk.scm 296 */
				obj_t BgL_g1490z00_9802;

				BgL_g1490z00_9802 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8462)))->BgL_argsz00);
				{
					obj_t BgL_l1488z00_9804;

					{	/* Ast/walk.scm 296 */
						bool_t BgL_tmpz00_15782;

						BgL_l1488z00_9804 = BgL_g1490z00_9802;
					BgL_zc3z04anonymousza32309ze3z87_9803:
						if (PAIRP(BgL_l1488z00_9804))
							{	/* Ast/walk.scm 296 */
								{	/* Ast/walk.scm 296 */
									obj_t BgL_fz00_9805;

									BgL_fz00_9805 = CAR(BgL_l1488z00_9804);
									PROCEDURE_ENTRY(BgL_pz00_8463) (BgL_pz00_8463, BgL_fz00_9805,
										BgL_arg0z00_8464, BgL_arg1z00_8465, BEOA);
								}
								{
									obj_t BgL_l1488z00_15792;

									BgL_l1488z00_15792 = CDR(BgL_l1488z00_9804);
									BgL_l1488z00_9804 = BgL_l1488z00_15792;
									goto BgL_zc3z04anonymousza32309ze3z87_9803;
								}
							}
						else
							{	/* Ast/walk.scm 296 */
								BgL_tmpz00_15782 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15782);
					}
				}
			}
		}

	}



/* &walk1-app1711 */
	obj_t BGl_z62walk1zd2app1711zb0zzast_walkz00(obj_t BgL_envz00_8466,
		obj_t BgL_nz00_8467, obj_t BgL_pz00_8468, obj_t BgL_arg0z00_8469)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				BgL_varz00_bglt BgL_arg2304z00_9807;

				BgL_arg2304z00_9807 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8467)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8468) (BgL_pz00_8468,
					((obj_t) BgL_arg2304z00_9807), BgL_arg0z00_8469, BEOA);
			}
			{	/* Ast/walk.scm 296 */
				obj_t BgL_g1487z00_9808;

				BgL_g1487z00_9808 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8467)))->BgL_argsz00);
				{
					obj_t BgL_l1485z00_9810;

					{	/* Ast/walk.scm 296 */
						bool_t BgL_tmpz00_15805;

						BgL_l1485z00_9810 = BgL_g1487z00_9808;
					BgL_zc3z04anonymousza32305ze3z87_9809:
						if (PAIRP(BgL_l1485z00_9810))
							{	/* Ast/walk.scm 296 */
								{	/* Ast/walk.scm 296 */
									obj_t BgL_fz00_9811;

									BgL_fz00_9811 = CAR(BgL_l1485z00_9810);
									PROCEDURE_ENTRY(BgL_pz00_8468) (BgL_pz00_8468, BgL_fz00_9811,
										BgL_arg0z00_8469, BEOA);
								}
								{
									obj_t BgL_l1485z00_15814;

									BgL_l1485z00_15814 = CDR(BgL_l1485z00_9810);
									BgL_l1485z00_9810 = BgL_l1485z00_15814;
									goto BgL_zc3z04anonymousza32305ze3z87_9809;
								}
							}
						else
							{	/* Ast/walk.scm 296 */
								BgL_tmpz00_15805 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15805);
					}
				}
			}
		}

	}



/* &walk0-app1709 */
	obj_t BGl_z62walk0zd2app1709zb0zzast_walkz00(obj_t BgL_envz00_8470,
		obj_t BgL_nz00_8471, obj_t BgL_pz00_8472)
	{
		{	/* Ast/walk.scm 296 */
			{	/* Ast/walk.scm 296 */
				BgL_varz00_bglt BgL_arg2300z00_9813;

				BgL_arg2300z00_9813 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8471)))->BgL_funz00);
				PROCEDURE_ENTRY(BgL_pz00_8472) (BgL_pz00_8472,
					((obj_t) BgL_arg2300z00_9813), BEOA);
			}
			{	/* Ast/walk.scm 296 */
				obj_t BgL_g1484z00_9814;

				BgL_g1484z00_9814 =
					(((BgL_appz00_bglt) COBJECT(
							((BgL_appz00_bglt) BgL_nz00_8471)))->BgL_argsz00);
				{
					obj_t BgL_l1482z00_9816;

					{	/* Ast/walk.scm 296 */
						bool_t BgL_tmpz00_15826;

						BgL_l1482z00_9816 = BgL_g1484z00_9814;
					BgL_zc3z04anonymousza32301ze3z87_9815:
						if (PAIRP(BgL_l1482z00_9816))
							{	/* Ast/walk.scm 296 */
								{	/* Ast/walk.scm 296 */
									obj_t BgL_fz00_9817;

									BgL_fz00_9817 = CAR(BgL_l1482z00_9816);
									PROCEDURE_ENTRY(BgL_pz00_8472) (BgL_pz00_8472, BgL_fz00_9817,
										BEOA);
								}
								{
									obj_t BgL_l1482z00_15834;

									BgL_l1482z00_15834 = CDR(BgL_l1482z00_9816);
									BgL_l1482z00_9816 = BgL_l1482z00_15834;
									goto BgL_zc3z04anonymousza32301ze3z87_9815;
								}
							}
						else
							{	/* Ast/walk.scm 296 */
								BgL_tmpz00_15826 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15826);
					}
				}
			}
		}

	}



/* &walk3!-sequence1707 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2sequence1707za2zzast_walkz00(obj_t
		BgL_envz00_8473, obj_t BgL_nz00_8474, obj_t BgL_pz00_8475,
		obj_t BgL_arg0z00_8476, obj_t BgL_arg1z00_8477, obj_t BgL_arg2z00_8478)
	{
		{	/* Ast/walk.scm 295 */
			{
				obj_t BgL_fieldsz00_9820;

				BgL_fieldsz00_9820 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8474)))->BgL_nodesz00);
			BgL_loopz00_9819:
				if (NULLP(BgL_fieldsz00_9820))
					{	/* Ast/walk.scm 295 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 295 */
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2297z00_9821;

							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2298z00_9822;

								BgL_arg2298z00_9822 = CAR(((obj_t) BgL_fieldsz00_9820));
								BgL_arg2297z00_9821 =
									PROCEDURE_ENTRY(BgL_pz00_8475) (BgL_pz00_8475,
									BgL_arg2298z00_9822, BgL_arg0z00_8476, BgL_arg1z00_8477,
									BgL_arg2z00_8478, BEOA);
							}
							{	/* Ast/walk.scm 295 */
								obj_t BgL_tmpz00_15848;

								BgL_tmpz00_15848 = ((obj_t) BgL_fieldsz00_9820);
								SET_CAR(BgL_tmpz00_15848, BgL_arg2297z00_9821);
							}
						}
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2299z00_9823;

							BgL_arg2299z00_9823 = CDR(((obj_t) BgL_fieldsz00_9820));
							{
								obj_t BgL_fieldsz00_15853;

								BgL_fieldsz00_15853 = BgL_arg2299z00_9823;
								BgL_fieldsz00_9820 = BgL_fieldsz00_15853;
								goto BgL_loopz00_9819;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nz00_8474));
		}

	}



/* &walk2!-sequence1705 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2sequence1705za2zzast_walkz00(obj_t
		BgL_envz00_8479, obj_t BgL_nz00_8480, obj_t BgL_pz00_8481,
		obj_t BgL_arg0z00_8482, obj_t BgL_arg1z00_8483)
	{
		{	/* Ast/walk.scm 295 */
			{
				obj_t BgL_fieldsz00_9826;

				BgL_fieldsz00_9826 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8480)))->BgL_nodesz00);
			BgL_loopz00_9825:
				if (NULLP(BgL_fieldsz00_9826))
					{	/* Ast/walk.scm 295 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 295 */
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2291z00_9827;

							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2292z00_9828;

								BgL_arg2292z00_9828 = CAR(((obj_t) BgL_fieldsz00_9826));
								BgL_arg2291z00_9827 =
									PROCEDURE_ENTRY(BgL_pz00_8481) (BgL_pz00_8481,
									BgL_arg2292z00_9828, BgL_arg0z00_8482, BgL_arg1z00_8483,
									BEOA);
							}
							{	/* Ast/walk.scm 295 */
								obj_t BgL_tmpz00_15868;

								BgL_tmpz00_15868 = ((obj_t) BgL_fieldsz00_9826);
								SET_CAR(BgL_tmpz00_15868, BgL_arg2291z00_9827);
							}
						}
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2293z00_9829;

							BgL_arg2293z00_9829 = CDR(((obj_t) BgL_fieldsz00_9826));
							{
								obj_t BgL_fieldsz00_15873;

								BgL_fieldsz00_15873 = BgL_arg2293z00_9829;
								BgL_fieldsz00_9826 = BgL_fieldsz00_15873;
								goto BgL_loopz00_9825;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nz00_8480));
		}

	}



/* &walk1!-sequence1703 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2sequence1703za2zzast_walkz00(obj_t
		BgL_envz00_8484, obj_t BgL_nz00_8485, obj_t BgL_pz00_8486,
		obj_t BgL_arg0z00_8487)
	{
		{	/* Ast/walk.scm 295 */
			{
				obj_t BgL_fieldsz00_9832;

				BgL_fieldsz00_9832 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8485)))->BgL_nodesz00);
			BgL_loopz00_9831:
				if (NULLP(BgL_fieldsz00_9832))
					{	/* Ast/walk.scm 295 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 295 */
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2284z00_9833;

							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2285z00_9834;

								BgL_arg2285z00_9834 = CAR(((obj_t) BgL_fieldsz00_9832));
								BgL_arg2284z00_9833 =
									PROCEDURE_ENTRY(BgL_pz00_8486) (BgL_pz00_8486,
									BgL_arg2285z00_9834, BgL_arg0z00_8487, BEOA);
							}
							{	/* Ast/walk.scm 295 */
								obj_t BgL_tmpz00_15887;

								BgL_tmpz00_15887 = ((obj_t) BgL_fieldsz00_9832);
								SET_CAR(BgL_tmpz00_15887, BgL_arg2284z00_9833);
							}
						}
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2287z00_9835;

							BgL_arg2287z00_9835 = CDR(((obj_t) BgL_fieldsz00_9832));
							{
								obj_t BgL_fieldsz00_15892;

								BgL_fieldsz00_15892 = BgL_arg2287z00_9835;
								BgL_fieldsz00_9832 = BgL_fieldsz00_15892;
								goto BgL_loopz00_9831;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nz00_8485));
		}

	}



/* &walk0!-sequence1701 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2sequence1701za2zzast_walkz00(obj_t
		BgL_envz00_8488, obj_t BgL_nz00_8489, obj_t BgL_pz00_8490)
	{
		{	/* Ast/walk.scm 295 */
			{
				obj_t BgL_fieldsz00_9838;

				BgL_fieldsz00_9838 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8489)))->BgL_nodesz00);
			BgL_loopz00_9837:
				if (NULLP(BgL_fieldsz00_9838))
					{	/* Ast/walk.scm 295 */
						((bool_t) 0);
					}
				else
					{	/* Ast/walk.scm 295 */
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2277z00_9839;

							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2278z00_9840;

								BgL_arg2278z00_9840 = CAR(((obj_t) BgL_fieldsz00_9838));
								BgL_arg2277z00_9839 =
									PROCEDURE_ENTRY(BgL_pz00_8490) (BgL_pz00_8490,
									BgL_arg2278z00_9840, BEOA);
							}
							{	/* Ast/walk.scm 295 */
								obj_t BgL_tmpz00_15905;

								BgL_tmpz00_15905 = ((obj_t) BgL_fieldsz00_9838);
								SET_CAR(BgL_tmpz00_15905, BgL_arg2277z00_9839);
							}
						}
						{	/* Ast/walk.scm 295 */
							obj_t BgL_arg2279z00_9841;

							BgL_arg2279z00_9841 = CDR(((obj_t) BgL_fieldsz00_9838));
							{
								obj_t BgL_fieldsz00_15910;

								BgL_fieldsz00_15910 = BgL_arg2279z00_9841;
								BgL_fieldsz00_9838 = BgL_fieldsz00_15910;
								goto BgL_loopz00_9837;
							}
						}
					}
			}
			return ((BgL_nodez00_bglt) ((BgL_sequencez00_bglt) BgL_nz00_8489));
		}

	}



/* &walk3*-sequence1699 */
	obj_t BGl_z62walk3za2zd2sequence1699z12zzast_walkz00(obj_t BgL_envz00_8491,
		obj_t BgL_nz00_8492, obj_t BgL_pz00_8493, obj_t BgL_arg0z00_8494,
		obj_t BgL_arg1z00_8495, obj_t BgL_arg2z00_8496)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_res4086z00_9845;

				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2266z00_9843;

					BgL_arg2266z00_9843 =
						BGl_zc3z04anonymousza32268ze3ze70z60zzast_walkz00(BgL_arg2z00_8496,
						BgL_arg1z00_8495, BgL_arg0z00_8494, BgL_pz00_8493,
						(((BgL_sequencez00_bglt) COBJECT(((BgL_sequencez00_bglt)
										BgL_nz00_8492)))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2267z00_9844;

						BgL_list2267z00_9844 = MAKE_YOUNG_PAIR(BgL_arg2266z00_9843, BNIL);
						BgL_res4086z00_9845 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2267z00_9844);
					}
				}
				return BgL_res4086z00_9845;
			}
		}

	}



/* <@anonymous:2268>~0 */
	obj_t BGl_zc3z04anonymousza32268ze3ze70z60zzast_walkz00(obj_t
		BgL_arg2z00_8590, obj_t BgL_arg1z00_8589, obj_t BgL_arg0z00_8588,
		obj_t BgL_pz00_8587, obj_t BgL_l1480z00_2701)
	{
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1480z00_2701))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2270z00_2704;
					obj_t BgL_arg2271z00_2705;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2706;

						BgL_fz00_2706 = CAR(((obj_t) BgL_l1480z00_2701));
						BgL_arg2270z00_2704 =
							PROCEDURE_ENTRY(BgL_pz00_8587) (BgL_pz00_8587, BgL_fz00_2706,
							BgL_arg0z00_8588, BgL_arg1z00_8589, BgL_arg2z00_8590, BEOA);
					}
					{	/* Ast/walk.scm 295 */
						obj_t BgL_arg2272z00_2707;

						BgL_arg2272z00_2707 = CDR(((obj_t) BgL_l1480z00_2701));
						BgL_arg2271z00_2705 =
							BGl_zc3z04anonymousza32268ze3ze70z60zzast_walkz00
							(BgL_arg2z00_8590, BgL_arg1z00_8589, BgL_arg0z00_8588,
							BgL_pz00_8587, BgL_arg2272z00_2707);
					}
					return bgl_append2(BgL_arg2270z00_2704, BgL_arg2271z00_2705);
				}
		}

	}



/* &walk2*-sequence1697 */
	obj_t BGl_z62walk2za2zd2sequence1697z12zzast_walkz00(obj_t BgL_envz00_8497,
		obj_t BgL_nz00_8498, obj_t BgL_pz00_8499, obj_t BgL_arg0z00_8500,
		obj_t BgL_arg1z00_8501)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_res4087z00_9849;

				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2259z00_9847;

					BgL_arg2259z00_9847 =
						BGl_zc3z04anonymousza32261ze3ze70z60zzast_walkz00(BgL_arg1z00_8501,
						BgL_arg0z00_8500, BgL_pz00_8499,
						(((BgL_sequencez00_bglt) COBJECT(((BgL_sequencez00_bglt)
										BgL_nz00_8498)))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2260z00_9848;

						BgL_list2260z00_9848 = MAKE_YOUNG_PAIR(BgL_arg2259z00_9847, BNIL);
						BgL_res4087z00_9849 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2260z00_9848);
					}
				}
				return BgL_res4087z00_9849;
			}
		}

	}



/* <@anonymous:2261>~0 */
	obj_t BGl_zc3z04anonymousza32261ze3ze70z60zzast_walkz00(obj_t
		BgL_arg1z00_8586, obj_t BgL_arg0z00_8585, obj_t BgL_pz00_8584,
		obj_t BgL_l1477z00_2680)
	{
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1477z00_2680))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2263z00_2683;
					obj_t BgL_arg2264z00_2684;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2685;

						BgL_fz00_2685 = CAR(((obj_t) BgL_l1477z00_2680));
						BgL_arg2263z00_2683 =
							PROCEDURE_ENTRY(BgL_pz00_8584) (BgL_pz00_8584, BgL_fz00_2685,
							BgL_arg0z00_8585, BgL_arg1z00_8586, BEOA);
					}
					{	/* Ast/walk.scm 295 */
						obj_t BgL_arg2265z00_2686;

						BgL_arg2265z00_2686 = CDR(((obj_t) BgL_l1477z00_2680));
						BgL_arg2264z00_2684 =
							BGl_zc3z04anonymousza32261ze3ze70z60zzast_walkz00
							(BgL_arg1z00_8586, BgL_arg0z00_8585, BgL_pz00_8584,
							BgL_arg2265z00_2686);
					}
					return bgl_append2(BgL_arg2263z00_2683, BgL_arg2264z00_2684);
				}
		}

	}



/* &walk1*-sequence1695 */
	obj_t BGl_z62walk1za2zd2sequence1695z12zzast_walkz00(obj_t BgL_envz00_8502,
		obj_t BgL_nz00_8503, obj_t BgL_pz00_8504, obj_t BgL_arg0z00_8505)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_res4088z00_9853;

				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2252z00_9851;

					BgL_arg2252z00_9851 =
						BGl_zc3z04anonymousza32254ze3ze70z60zzast_walkz00(BgL_arg0z00_8505,
						BgL_pz00_8504,
						(((BgL_sequencez00_bglt) COBJECT(((BgL_sequencez00_bglt)
										BgL_nz00_8503)))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2253z00_9852;

						BgL_list2253z00_9852 = MAKE_YOUNG_PAIR(BgL_arg2252z00_9851, BNIL);
						BgL_res4088z00_9853 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2253z00_9852);
					}
				}
				return BgL_res4088z00_9853;
			}
		}

	}



/* <@anonymous:2254>~0 */
	obj_t BGl_zc3z04anonymousza32254ze3ze70z60zzast_walkz00(obj_t
		BgL_arg0z00_8583, obj_t BgL_pz00_8582, obj_t BgL_l1474z00_2660)
	{
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1474z00_2660))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2256z00_2663;
					obj_t BgL_arg2257z00_2664;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2665;

						BgL_fz00_2665 = CAR(((obj_t) BgL_l1474z00_2660));
						BgL_arg2256z00_2663 =
							PROCEDURE_ENTRY(BgL_pz00_8582) (BgL_pz00_8582, BgL_fz00_2665,
							BgL_arg0z00_8583, BEOA);
					}
					{	/* Ast/walk.scm 295 */
						obj_t BgL_arg2258z00_2666;

						BgL_arg2258z00_2666 = CDR(((obj_t) BgL_l1474z00_2660));
						BgL_arg2257z00_2664 =
							BGl_zc3z04anonymousza32254ze3ze70z60zzast_walkz00
							(BgL_arg0z00_8583, BgL_pz00_8582, BgL_arg2258z00_2666);
					}
					return bgl_append2(BgL_arg2256z00_2663, BgL_arg2257z00_2664);
				}
		}

	}



/* &walk0*-sequence1693 */
	obj_t BGl_z62walk0za2zd2sequence1693z12zzast_walkz00(obj_t BgL_envz00_8506,
		obj_t BgL_nz00_8507, obj_t BgL_pz00_8508)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_res4089z00_9857;

				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2245z00_9855;

					BgL_arg2245z00_9855 =
						BGl_zc3z04anonymousza32247ze3ze70z60zzast_walkz00(BgL_pz00_8508,
						(((BgL_sequencez00_bglt) COBJECT(
									((BgL_sequencez00_bglt) BgL_nz00_8507)))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2246z00_9856;

						BgL_list2246z00_9856 = MAKE_YOUNG_PAIR(BgL_arg2245z00_9855, BNIL);
						BgL_res4089z00_9857 =
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2246z00_9856);
					}
				}
				return BgL_res4089z00_9857;
			}
		}

	}



/* <@anonymous:2247>~0 */
	obj_t BGl_zc3z04anonymousza32247ze3ze70z60zzast_walkz00(obj_t BgL_pz00_8581,
		obj_t BgL_l1471z00_2641)
	{
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1471z00_2641))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2249z00_2644;
					obj_t BgL_arg2250z00_2645;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2646;

						BgL_fz00_2646 = CAR(((obj_t) BgL_l1471z00_2641));
						BgL_arg2249z00_2644 =
							PROCEDURE_ENTRY(BgL_pz00_8581) (BgL_pz00_8581, BgL_fz00_2646,
							BEOA);
					}
					{	/* Ast/walk.scm 295 */
						obj_t BgL_arg2251z00_2647;

						BgL_arg2251z00_2647 = CDR(((obj_t) BgL_l1471z00_2641));
						BgL_arg2250z00_2645 =
							BGl_zc3z04anonymousza32247ze3ze70z60zzast_walkz00(BgL_pz00_8581,
							BgL_arg2251z00_2647);
					}
					return bgl_append2(BgL_arg2249z00_2644, BgL_arg2250z00_2645);
				}
		}

	}



/* &walk3-sequence1691 */
	obj_t BGl_z62walk3zd2sequence1691zb0zzast_walkz00(obj_t BgL_envz00_8509,
		obj_t BgL_nz00_8510, obj_t BgL_pz00_8511, obj_t BgL_arg0z00_8512,
		obj_t BgL_arg1z00_8513, obj_t BgL_arg2z00_8514)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_g1469z00_9859;

				BgL_g1469z00_9859 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8510)))->BgL_nodesz00);
				{
					obj_t BgL_l1467z00_9861;

					{	/* Ast/walk.scm 295 */
						bool_t BgL_tmpz00_15991;

						BgL_l1467z00_9861 = BgL_g1469z00_9859;
					BgL_zc3z04anonymousza32242ze3z87_9860:
						if (PAIRP(BgL_l1467z00_9861))
							{	/* Ast/walk.scm 295 */
								{	/* Ast/walk.scm 295 */
									obj_t BgL_fz00_9862;

									BgL_fz00_9862 = CAR(BgL_l1467z00_9861);
									PROCEDURE_ENTRY(BgL_pz00_8511) (BgL_pz00_8511, BgL_fz00_9862,
										BgL_arg0z00_8512, BgL_arg1z00_8513, BgL_arg2z00_8514, BEOA);
								}
								{
									obj_t BgL_l1467z00_16002;

									BgL_l1467z00_16002 = CDR(BgL_l1467z00_9861);
									BgL_l1467z00_9861 = BgL_l1467z00_16002;
									goto BgL_zc3z04anonymousza32242ze3z87_9860;
								}
							}
						else
							{	/* Ast/walk.scm 295 */
								BgL_tmpz00_15991 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_15991);
					}
				}
			}
		}

	}



/* &walk2-sequence1689 */
	obj_t BGl_z62walk2zd2sequence1689zb0zzast_walkz00(obj_t BgL_envz00_8515,
		obj_t BgL_nz00_8516, obj_t BgL_pz00_8517, obj_t BgL_arg0z00_8518,
		obj_t BgL_arg1z00_8519)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_g1466z00_9864;

				BgL_g1466z00_9864 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8516)))->BgL_nodesz00);
				{
					obj_t BgL_l1464z00_9866;

					{	/* Ast/walk.scm 295 */
						bool_t BgL_tmpz00_16007;

						BgL_l1464z00_9866 = BgL_g1466z00_9864;
					BgL_zc3z04anonymousza32239ze3z87_9865:
						if (PAIRP(BgL_l1464z00_9866))
							{	/* Ast/walk.scm 295 */
								{	/* Ast/walk.scm 295 */
									obj_t BgL_fz00_9867;

									BgL_fz00_9867 = CAR(BgL_l1464z00_9866);
									PROCEDURE_ENTRY(BgL_pz00_8517) (BgL_pz00_8517, BgL_fz00_9867,
										BgL_arg0z00_8518, BgL_arg1z00_8519, BEOA);
								}
								{
									obj_t BgL_l1464z00_16017;

									BgL_l1464z00_16017 = CDR(BgL_l1464z00_9866);
									BgL_l1464z00_9866 = BgL_l1464z00_16017;
									goto BgL_zc3z04anonymousza32239ze3z87_9865;
								}
							}
						else
							{	/* Ast/walk.scm 295 */
								BgL_tmpz00_16007 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_16007);
					}
				}
			}
		}

	}



/* &walk1-sequence1687 */
	obj_t BGl_z62walk1zd2sequence1687zb0zzast_walkz00(obj_t BgL_envz00_8520,
		obj_t BgL_nz00_8521, obj_t BgL_pz00_8522, obj_t BgL_arg0z00_8523)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_g1463z00_9869;

				BgL_g1463z00_9869 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8521)))->BgL_nodesz00);
				{
					obj_t BgL_l1461z00_9871;

					{	/* Ast/walk.scm 295 */
						bool_t BgL_tmpz00_16022;

						BgL_l1461z00_9871 = BgL_g1463z00_9869;
					BgL_zc3z04anonymousza32236ze3z87_9870:
						if (PAIRP(BgL_l1461z00_9871))
							{	/* Ast/walk.scm 295 */
								{	/* Ast/walk.scm 295 */
									obj_t BgL_fz00_9872;

									BgL_fz00_9872 = CAR(BgL_l1461z00_9871);
									PROCEDURE_ENTRY(BgL_pz00_8522) (BgL_pz00_8522, BgL_fz00_9872,
										BgL_arg0z00_8523, BEOA);
								}
								{
									obj_t BgL_l1461z00_16031;

									BgL_l1461z00_16031 = CDR(BgL_l1461z00_9871);
									BgL_l1461z00_9871 = BgL_l1461z00_16031;
									goto BgL_zc3z04anonymousza32236ze3z87_9870;
								}
							}
						else
							{	/* Ast/walk.scm 295 */
								BgL_tmpz00_16022 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_16022);
					}
				}
			}
		}

	}



/* &walk0-sequence1685 */
	obj_t BGl_z62walk0zd2sequence1685zb0zzast_walkz00(obj_t BgL_envz00_8524,
		obj_t BgL_nz00_8525, obj_t BgL_pz00_8526)
	{
		{	/* Ast/walk.scm 295 */
			{	/* Ast/walk.scm 295 */
				obj_t BgL_g1460z00_9874;

				BgL_g1460z00_9874 =
					(((BgL_sequencez00_bglt) COBJECT(
							((BgL_sequencez00_bglt) BgL_nz00_8525)))->BgL_nodesz00);
				{
					obj_t BgL_l1458z00_9876;

					{	/* Ast/walk.scm 295 */
						bool_t BgL_tmpz00_16036;

						BgL_l1458z00_9876 = BgL_g1460z00_9874;
					BgL_zc3z04anonymousza32233ze3z87_9875:
						if (PAIRP(BgL_l1458z00_9876))
							{	/* Ast/walk.scm 295 */
								{	/* Ast/walk.scm 295 */
									obj_t BgL_fz00_9877;

									BgL_fz00_9877 = CAR(BgL_l1458z00_9876);
									PROCEDURE_ENTRY(BgL_pz00_8526) (BgL_pz00_8526, BgL_fz00_9877,
										BEOA);
								}
								{
									obj_t BgL_l1458z00_16044;

									BgL_l1458z00_16044 = CDR(BgL_l1458z00_9876);
									BgL_l1458z00_9876 = BgL_l1458z00_16044;
									goto BgL_zc3z04anonymousza32233ze3z87_9875;
								}
							}
						else
							{	/* Ast/walk.scm 295 */
								BgL_tmpz00_16036 = ((bool_t) 1);
							}
						return BBOOL(BgL_tmpz00_16036);
					}
				}
			}
		}

	}



/* &walk3!-node1683 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2node1683za2zzast_walkz00(obj_t
		BgL_envz00_8527, obj_t BgL_nz00_8528, obj_t BgL_pz00_8529,
		obj_t BgL_arg0z00_8530, obj_t BgL_arg1z00_8531, obj_t BgL_arg2z00_8532)
	{
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8528);
		}

	}



/* &walk2!-node1681 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2node1681za2zzast_walkz00(obj_t
		BgL_envz00_8533, obj_t BgL_nz00_8534, obj_t BgL_pz00_8535,
		obj_t BgL_arg0z00_8536, obj_t BgL_arg1z00_8537)
	{
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8534);
		}

	}



/* &walk1!-node1679 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2node1679za2zzast_walkz00(obj_t
		BgL_envz00_8538, obj_t BgL_nz00_8539, obj_t BgL_pz00_8540,
		obj_t BgL_arg0z00_8541)
	{
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8539);
		}

	}



/* &walk0!-node1677 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2node1677za2zzast_walkz00(obj_t
		BgL_envz00_8542, obj_t BgL_nz00_8543, obj_t BgL_pz00_8544)
	{
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8543);
		}

	}



/* &walk3*-node1675 */
	obj_t BGl_z62walk3za2zd2node1675z12zzast_walkz00(obj_t BgL_envz00_8545,
		obj_t BgL_nz00_8546, obj_t BgL_pz00_8547, obj_t BgL_arg0z00_8548,
		obj_t BgL_arg1z00_8549, obj_t BgL_arg2z00_8550)
	{
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}

	}



/* &walk2*-node1672 */
	obj_t BGl_z62walk2za2zd2node1672z12zzast_walkz00(obj_t BgL_envz00_8551,
		obj_t BgL_nz00_8552, obj_t BgL_pz00_8553, obj_t BgL_arg0z00_8554,
		obj_t BgL_arg1z00_8555)
	{
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}

	}



/* &walk1*-node1670 */
	obj_t BGl_z62walk1za2zd2node1670z12zzast_walkz00(obj_t BgL_envz00_8556,
		obj_t BgL_nz00_8557, obj_t BgL_pz00_8558, obj_t BgL_arg0z00_8559)
	{
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}

	}



/* &walk0*-node1668 */
	obj_t BGl_z62walk0za2zd2node1668z12zzast_walkz00(obj_t BgL_envz00_8560,
		obj_t BgL_nz00_8561, obj_t BgL_pz00_8562)
	{
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}

	}



/* &walk3-node1666 */
	obj_t BGl_z62walk3zd2node1666zb0zzast_walkz00(obj_t BgL_envz00_8563,
		obj_t BgL_nz00_8564, obj_t BgL_pz00_8565, obj_t BgL_arg0z00_8566,
		obj_t BgL_arg1z00_8567, obj_t BgL_arg2z00_8568)
	{
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}

	}



/* &walk2-node1664 */
	obj_t BGl_z62walk2zd2node1664zb0zzast_walkz00(obj_t BgL_envz00_8569,
		obj_t BgL_nz00_8570, obj_t BgL_pz00_8571, obj_t BgL_arg0z00_8572,
		obj_t BgL_arg1z00_8573)
	{
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}

	}



/* &walk1-node1662 */
	obj_t BGl_z62walk1zd2node1662zb0zzast_walkz00(obj_t BgL_envz00_8574,
		obj_t BgL_nz00_8575, obj_t BgL_pz00_8576, obj_t BgL_arg0z00_8577)
	{
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}

	}



/* &walk0-node1660 */
	obj_t BGl_z62walk0zd2node1660zb0zzast_walkz00(obj_t BgL_envz00_8578,
		obj_t BgL_nz00_8579, obj_t BgL_pz00_8580)
	{
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_walkz00()
	{
		{	/* Ast/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string4009z00zzast_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string4009z00zzast_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732712),
				BSTRING_TO_STRING(BGl_string4009z00zzast_walkz00));
		}

	}

#ifdef __cplusplus
}
#endif
